"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var h1=["require","exports","vs/base/common/errors","vs/base/common/functional","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/arraysFind","vs/base/common/charCode","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/map","vs/base/common/platform","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/cache","vs/base/common/types","vs/base/common/objects","vs/base/common/uint","vs/base/common/strings","vs/base/common/worker/simpleWorker"],g1=function(_1){for(var e=[],A=0,t=_1.length;A<t;A++)e[A]=h1[_1[A]];return e};define(h1[6],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=A,e.$gb=t,e.$hb=G,e.$ib=m,e.$jb=V,e.$kb=W,e.$lb=L,e.$nb=k,e.$ob=j,e.$pb=X,e.$qb=u1,e.$rb=l1;function A(P,K){const S=t(P,K);if(S!==-1)return P[S]}function t(P,K,S=P.length-1){for(let g=S;g>=0;g--){const $=P[g];if(K($))return g}return-1}function G(P,K){const S=m(P,K);return S===-1?void 0:P[S]}function m(P,K,S=0,g=P.length){let $=S,O=g;for(;$<O;){const s=Math.floor(($+O)/2);K(P[s])?$=s+1:O=s}return $-1}function V(P,K){const S=W(P,K);return S===P.length?void 0:P[S]}function W(P,K,S=0,g=P.length){let $=S,O=g;for(;$<O;){const s=Math.floor(($+O)/2);K(P[s])?O=s:$=s+1}return $}function L(P,K,S=0,g=P.length){const $=W(P,K,S,g);return $===P.length?-1:$}class R{constructor(K){this.e=K,this.c=0}findLastMonotonous(K){if(R.assertInvariants){if(this.d){for(const g of this.e)if(this.d(g)&&!K(g))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=K}const S=m(this.e,K,this.c);return this.c=S+1,S===-1?void 0:this.e[S]}}e.$mb=R,R.assertInvariants=!1;function k(P,K){if(P.length===0)return;let S=P[0];for(let g=1;g<P.length;g++){const $=P[g];K($,S)>0&&(S=$)}return S}function j(P,K){if(P.length===0)return;let S=P[0];for(let g=1;g<P.length;g++){const $=P[g];K($,S)>=0&&(S=$)}return S}function X(P,K){return k(P,(S,g)=>-K(S,g))}function u1(P,K){if(P.length===0)return-1;let S=0;for(let g=1;g<P.length;g++){const $=P[g];K($,P[S])>0&&(S=g)}return S}function l1(P,K){for(const S of P){const g=K(S);if(g!==void 0)return g}}}),define(h1[7],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var A;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(A||(e.CharCode=A={}))}),define(h1[8],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E=A,e.$F=t,e.$G=G,e.$H=m;function A(V,W){const L=Object.create(null);for(const R of V){const k=W(R);let j=L[k];j||(j=L[k]=[]),j.push(R)}return L}function t(V,W){const L=[],R=[];for(const k of V)W.has(k)||L.push(k);for(const k of W)V.has(k)||R.push(k);return{removed:L,added:R}}function G(V,W){const L=[],R=[];for(const[k,j]of V)W.has(k)||L.push(j);for(const[k,j]of W)V.has(k)||R.push(j);return{removed:L,added:R}}function m(V,W){const L=new Set;for(const R of W)V.has(R)&&L.add(R);return L}}),define(h1[2],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=t,e.$Z=G,e.$1=m,e.$2=V,e.$3=W,e.$4=R,e.$6=j,e.$7=X,e.$8=u1,e.$0=P;class A{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?$.isErrorNoTelemetry(n)?new $(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(r=>{r(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$W=A,e.$X=new A;function t(s){e.$X.setUnexpectedErrorHandler(s)}function G(s){if(!s||typeof s!="object")return!1;const n=s;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function m(s){R(s)||e.$X.onUnexpectedError(s)}function V(s){R(s)||e.$X.onUnexpectedExternalError(s)}function W(s){if(s instanceof Error){const{name:n,message:r}=s,_=s.stacktrace||s.stack;return{$isError:!0,name:n,message:r,stack:_,noTelemetry:$.isErrorNoTelemetry(s)}}return s}const L="Canceled";function R(s){return s instanceof k?!0:s instanceof Error&&s.name===L&&s.message===L}class k extends Error{constructor(){super(L),this.name=this.message}}e.$5=k;function j(){const s=new Error(L);return s.name=s.message,s}function X(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function u1(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class l1 extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=l1;function P(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class K extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=K;class S extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=S;class g extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=g;class $ extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof $)return n;const r=new $;return r.message=n.message,r.stack=n.stack,r}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=$;class O extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,O.prototype)}}e.$cb=O}),define(h1[9],g1([0,1,2,6]),function(_1,e,A,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=G,e.$tb=m,e.$ub=V,e.$vb=W,e.$wb=L,e.$xb=R,e.$yb=k,e.$zb=j,e.$Ab=X,e.$Bb=u1,e.$Cb=l1,e.$Db=P,e.$Eb=K,e.top=S,e.$Gb=g,e.$Hb=O,e.$Ib=s,e.$Jb=n,e.$Kb=r,e.$Lb=_,e.$Mb=l,e.$Nb=T,e.$Ob=M,e.$Pb=x,e.$Qb=E1,e.$Rb=p,e.$Sb=o1,e.$Tb=v,e.$Ub=h,e.$Vb=D,e.$Wb=q,e.$Xb=I,e.$Yb=E,e.$Zb=F,e.$1b=Q,e.$2b=J,e.$3b=t1,e.$4b=n1,e.$5b=Y,e.$6b=v1,e.$7b=w1,e.$0b=k1;function G(c,o=0){return c[c.length-(1+o)]}function m(c){if(c.length===0)throw new Error("Invalid tail call");return[c.slice(0,c.length-1),c[c.length-1]]}function V(c,o,f=(d,U)=>d===U){if(c===o)return!0;if(!c||!o||c.length!==o.length)return!1;for(let d=0,U=c.length;d<U;d++)if(!f(c[d],o[d]))return!1;return!0}function W(c,o){const f=c.length-1;o<f&&(c[o]=c[f]),c.pop()}function L(c,o,f){return R(c.length,d=>f(c[d],o))}function R(c,o){let f=0,d=c-1;for(;f<=d;){const U=(f+d)/2|0,Z=o(U);if(Z<0)f=U+1;else if(Z>0)d=U-1;else return U}return-(f+1)}function k(c,o,f){if(c=c|0,c>=o.length)throw new TypeError("invalid index");const d=o[Math.floor(o.length*Math.random())],U=[],Z=[],r1=[];for(const d1 of o){const b1=f(d1,d);b1<0?U.push(d1):b1>0?Z.push(d1):r1.push(d1)}return c<U.length?k(c,U,f):c<U.length+r1.length?r1[0]:k(c-(U.length+r1.length),Z,f)}function j(c,o){const f=[];let d;for(const U of c.slice(0).sort(o))!d||o(d[0],U)!==0?(d=[U],f.push(d)):d.push(U);return f}function*X(c,o){let f,d;for(const U of c)d!==void 0&&o(d,U)?f.push(U):(f&&(yield f),f=[U]),d=U;f&&(yield f)}function u1(c,o){for(let f=0;f<=c.length;f++)o(f===0?void 0:c[f-1],f===c.length?void 0:c[f])}function l1(c,o){for(let f=0;f<c.length;f++)o(f===0?void 0:c[f-1],c[f],f+1===c.length?void 0:c[f+1])}function P(c,o,f){const d=[];function U(d1,b1,U1){if(b1===0&&U1.length===0)return;const N=d[d.length-1];N&&N.start+N.deleteCount===d1?(N.deleteCount+=b1,N.toInsert.push(...U1)):d.push({start:d1,deleteCount:b1,toInsert:U1})}let Z=0,r1=0;for(;;){if(Z===c.length){U(Z,0,o.slice(r1));break}if(r1===o.length){U(Z,c.length-Z,[]);break}const d1=c[Z],b1=o[r1],U1=f(d1,b1);U1===0?(Z+=1,r1+=1):U1<0?(U(Z,1,[]),Z+=1):U1>0&&(U(Z,0,[b1]),r1+=1)}return d}function K(c,o,f){const d=P(c,o,f),U=[],Z=[];for(const r1 of d)U.push(...c.slice(r1.start,r1.start+r1.deleteCount)),Z.push(...r1.toInsert);return{removed:U,added:Z}}function S(c,o,f){if(f===0)return[];const d=c.slice(0,f).sort(o);return $(c,o,d,f,c.length),d}function g(c,o,f,d,U){return f===0?Promise.resolve([]):new Promise((Z,r1)=>{(async()=>{const d1=c.length,b1=c.slice(0,f).sort(o);for(let U1=f,N=Math.min(f+d,d1);U1<d1;U1=N,N=Math.min(N+d,d1)){if(U1>f&&await new Promise(w=>setTimeout(w)),U&&U.isCancellationRequested)throw new A.$5;$(c,o,b1,U1,N)}return b1})().then(Z,r1)})}function $(c,o,f,d,U){for(const Z=f.length;d<U;d++){const r1=c[d];if(o(r1,f[Z-1])<0){f.pop();const d1=(0,t.$kb)(f,b1=>o(r1,b1)<0);f.splice(d1,0,r1)}}}function O(c){return c.filter(o=>!!o)}function s(c){let o=0;for(let f=0;f<c.length;f++)c[f]&&(c[o]=c[f],o+=1);c.length=o}function n(c,o,f){c.splice(f,0,c.splice(o,1)[0])}function r(c){return!Array.isArray(c)||c.length===0}function _(c){return Array.isArray(c)&&c.length>0}function l(c,o=f=>f){const f=new Set;return c.filter(d=>{const U=o(d);return f.has(U)?!1:(f.add(U),!0)})}function T(c){const o=new Set;return f=>{const d=c(f);return o.has(d)?!1:(o.add(d),!0)}}function M(c,o){return c.length>0?c[0]:o}function x(c,o){return c.length>0?c[c.length-1]:o}function E1(c,o,f=(d,U)=>d===U){let d=0;for(let U=0,Z=Math.min(c.length,o.length);U<Z&&f(c[U],o[U]);U++)d++;return d}function p(c,o){let f=typeof o=="number"?c:0;typeof o=="number"?f=c:(f=0,o=c);const d=[];if(f<=o)for(let U=f;U<o;U++)d.push(U);else for(let U=f;U>o;U--)d.push(U);return d}function o1(c,o,f){return c.reduce((d,U)=>(d[o(U)]=f?f(U):U,d),Object.create(null))}function v(c,o){return c.push(o),()=>h(c,o)}function h(c,o){const f=c.indexOf(o);if(f>-1)return c.splice(f,1),o}function D(c,o,f){const d=c.slice(0,o),U=c.slice(o);return d.concat(f,U)}function q(c,o){let f;if(typeof o=="number"){let d=o;f=()=>{const U=Math.sin(d++)*179426549;return U-Math.floor(U)}}else f=Math.random;for(let d=c.length-1;d>0;d-=1){const U=Math.floor(f()*(d+1)),Z=c[d];c[d]=c[U],c[U]=Z}}function I(c,o){const f=c.indexOf(o);f>-1&&(c.splice(f,1),c.unshift(o))}function E(c,o){const f=c.indexOf(o);f>-1&&(c.splice(f,1),c.push(o))}function F(c,o){for(const f of o)c.push(f)}function Q(c,o){return Array.isArray(c)?c.map(o):o(c)}function J(c){return Array.isArray(c)?c:[c]}function t1(c){return c[Math.floor(Math.random()*c.length)]}function n1(c,o,f){const d=C(c,o),U=c.length,Z=f.length;c.length=U+Z;for(let r1=U-1;r1>=d;r1--)c[r1+Z]=c[r1];for(let r1=0;r1<Z;r1++)c[r1+d]=f[r1]}function Y(c,o,f,d){const U=C(c,o);let Z=c.splice(U,f);return Z===void 0&&(Z=[]),n1(c,U,d),Z}function C(c,o){return o<0?Math.max(o+c.length,0):Math.min(o,c.length)}var c1;(function(c){function o(Z){return Z<0}c.isLessThan=o;function f(Z){return Z<=0}c.isLessThanOrEqual=f;function d(Z){return Z>0}c.isGreaterThan=d;function U(Z){return Z===0}c.isNeitherLessOrGreaterThan=U,c.greaterThan=1,c.lessThan=-1,c.neitherLessOrGreaterThan=0})(c1||(e.CompareResult=c1={}));function v1(c,o){return(f,d)=>o(c(f),c(d))}function w1(...c){return(o,f)=>{for(const d of c){const U=d(o,f);if(!c1.isNeitherLessOrGreaterThan(U))return U}return c1.neitherLessOrGreaterThan}}const L1=(c,o)=>c-o;e.$8b=L1;const S1=(c,o)=>(0,e.$8b)(c?1:0,o?1:0);e.$9b=S1;function k1(c){return(o,f)=>-c(o,f)}class B1{constructor(o){this.g=o,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(o){let f=this.c;for(;f<this.g.length&&o(this.g[f]);)f++;const d=f===this.c?null:this.g.slice(this.c,f);return this.c=f,d}takeFromEndWhile(o){let f=this.d;for(;f>=0&&o(this.g[f]);)f--;const d=f===this.d?null:this.g.slice(f+1,this.d+1);return this.d=f,d}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const o=this.g[this.c];return this.c++,o}removeLast(){const o=this.g[this.d];return this.d--,o}takeCount(o){const f=this.g.slice(this.c,this.c+o);return this.c+=o,f}}e.$$b=B1;class O1{constructor(o){this.iterate=o}forEach(o){this.iterate(f=>(o(f),!0))}toArray(){const o=[];return this.iterate(f=>(o.push(f),!0)),o}filter(o){return new O1(f=>this.iterate(d=>o(d)?f(d):!0))}map(o){return new O1(f=>this.iterate(d=>f(o(d))))}some(o){let f=!1;return this.iterate(d=>(f=o(d),!f)),f}findFirst(o){let f;return this.iterate(d=>o(d)?(f=d,!1):!0),f}findLast(o){let f;return this.iterate(d=>(o(d)&&(f=d),!0)),f}findLastMaxBy(o){let f,d=!0;return this.iterate(U=>((d||c1.isGreaterThan(o(U,f)))&&(d=!1,f=U),!0)),f}}e.$_b=O1,O1.empty=new O1(c=>{});class T1{constructor(o){this.c=o}static createSortPermutation(o,f){const d=Array.from(o.keys()).sort((U,Z)=>f(o[U],o[Z]));return new T1(d)}apply(o){return o.map((f,d)=>o[this.c[d]])}inverse(){const o=this.c.slice();for(let f=0;f<this.c.length;f++)o[this.c[f]]=f;return new T1(o)}}e.$ac=T1}),define(h1[3],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=A;function A(t,G){const m=this;let V=!1,W;return function(){if(V)return W;if(V=!0,G)try{W=t.apply(m,arguments)}finally{G()}else W=t.apply(m,arguments);return W}}}),define(h1[10],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var A;(function(t){function G(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=G;const m=Object.freeze([]);function V(){return m}t.empty=V;function*W(n){yield n}t.single=W;function L(n){return G(n)?n:W(n)}t.wrap=L;function R(n){return n||m}t.from=R;function*k(n){for(let r=n.length-1;r>=0;r--)yield n[r]}t.reverse=k;function j(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=j;function X(n){return n[Symbol.iterator]().next().value}t.first=X;function u1(n,r){for(const _ of n)if(r(_))return!0;return!1}t.some=u1;function l1(n,r){for(const _ of n)if(r(_))return _}t.find=l1;function*P(n,r){for(const _ of n)r(_)&&(yield _)}t.filter=P;function*K(n,r){let _=0;for(const l of n)yield r(l,_++)}t.map=K;function*S(...n){for(const r of n)yield*r}t.concat=S;function g(n,r,_){let l=_;for(const T of n)l=r(l,T);return l}t.reduce=g;function*$(n,r,_=n.length){for(r<0&&(r+=n.length),_<0?_+=n.length:_>n.length&&(_=n.length);r<_;r++)yield n[r]}t.slice=$;function O(n,r=Number.POSITIVE_INFINITY){const _=[];if(r===0)return[_,n];const l=n[Symbol.iterator]();for(let T=0;T<r;T++){const M=l.next();if(M.done)return[_,t.empty()];_.push(M.value)}return[_,{[Symbol.iterator](){return l}}]}t.consume=O;async function s(n){const r=[];for await(const _ of n)r.push(_);return Promise.resolve(r)}t.asyncToArray=s})(A||(e.Iterable=A={}))}),define(h1[11],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class A{constructor(G){this.d=G,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(G){this.c=G}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=A}),define(h1[12],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class A{constructor(m){this.element=m,this.next=A.Undefined,this.prev=A.Undefined}}A.Undefined=new A(void 0);class t{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let m=this.a;for(;m!==A.Undefined;){const V=m.next;m.prev=A.Undefined,m.next=A.Undefined,m=V}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(m){return this.d(m,!1)}push(m){return this.d(m,!0)}d(m,V){const W=new A(m);if(this.a===A.Undefined)this.a=W,this.b=W;else if(V){const R=this.b;this.b=W,W.prev=R,R.next=W}else{const R=this.a;this.a=W,W.next=R,R.prev=W}this.c+=1;let L=!1;return()=>{L||(L=!0,this.e(W))}}shift(){if(this.a!==A.Undefined){const m=this.a.element;return this.e(this.a),m}}pop(){if(this.b!==A.Undefined){const m=this.b.element;return this.e(this.b),m}}e(m){if(m.prev!==A.Undefined&&m.next!==A.Undefined){const V=m.prev;V.next=m.next,m.next.prev=V}else m.prev===A.Undefined&&m.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):m.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):m.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let m=this.a;for(;m!==A.Undefined;)yield m.element,m=m.next}}e.$5c=t}),define(h1[13],g1([0,1]),function(_1,e){"use strict";var A,t,G;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=m,e.$yc=V,e.$zc=W,e.$Ic=O;function m(s,n,r){let _=s.get(n);return _===void 0&&(_=r,s.set(n,_)),_}function V(s){const n=[];return s.forEach((r,_)=>{n.push(`${_} => ${r}`)}),`Map(${s.size}) {${n.join(", ")}}`}function W(s){const n=[];return s.forEach(r=>{n.push(r)}),`Set(${s.size}) {${n.join(", ")}}`}class L{constructor(n,r){this.uri=n,this.value=r}}function R(s){return Array.isArray(s)}class k{constructor(n,r){if(this[A]="ResourceMap",n instanceof k)this.d=new Map(n.d),this.e=r??k.c;else if(R(n)){this.d=new Map,this.e=r??k.c;for(const[_,l]of n)this.set(_,l)}else this.d=new Map,this.e=n??k.c}set(n,r){return this.d.set(this.e(n),new L(n,r)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,r){typeof r<"u"&&(n=n.bind(r));for(const[_,l]of this.d)n(l.value,l.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=k,k.c=s=>s.toString();class j{constructor(n,r){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new k(n):(this.c=new k(r),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,r){this.c.forEach((_,l)=>n.call(r,l,l,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=j;var X;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(X||(e.Touch=X={}));class u1{constructor(){this[G]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,r=X.None){const _=this.c.get(n);if(_)return r!==X.None&&this.m(_,r),_.value}set(n,r,_=X.None){let l=this.c.get(n);if(l)l.value=r,_!==X.None&&this.m(l,_);else{switch(l={key:n,value:r,next:void 0,previous:void 0},_){case X.None:this.k(l);break;case X.AsOld:this.j(l);break;case X.AsNew:this.k(l);break;default:this.k(l);break}this.c.set(n,l),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this.c.get(n);if(r)return this.c.delete(n),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,r){const _=this.g;let l=this.d;for(;l;){if(r?n.bind(r)(l.value,l.key,this):n(l.value,l.key,this),this.g!==_)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const n=this,r=this.g;let _=this.d;const l={[Symbol.iterator](){return l},next(){if(n.g!==r)throw new Error("LinkedMap got modified during iteration.");if(_){const T={value:_.key,done:!1};return _=_.next,T}else return{value:void 0,done:!0}}};return l}values(){const n=this,r=this.g;let _=this.d;const l={[Symbol.iterator](){return l},next(){if(n.g!==r)throw new Error("LinkedMap got modified during iteration.");if(_){const T={value:_.value,done:!1};return _=_.next,T}else return{value:void 0,done:!0}}};return l}entries(){const n=this,r=this.g;let _=this.d;const l={[Symbol.iterator](){return l},next(){if(n.g!==r)throw new Error("LinkedMap got modified during iteration.");if(_){const T={value:[_.key,_.value],done:!1};return _=_.next,T}else return{value:void 0,done:!0}}};return l}[(G=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this.d,_=this.size;for(;r&&_>n;)this.c.delete(r.key),r=r.next,_--;this.d=r,this.f=_,r&&(r.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this.e,_=this.size;for(;r&&_>n;)this.c.delete(r.key),r=r.previous,_--;this.e=r,this.f=_,r&&(r.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const r=n.next,_=n.previous;if(!r||!_)throw new Error("Invalid list");r.previous=_,_.next=r}n.next=void 0,n.previous=void 0,this.g++}m(n,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==X.AsOld&&r!==X.AsNew)){if(r===X.AsOld){if(n===this.d)return;const _=n.next,l=n.previous;n===this.e?(l.next=void 0,this.e=l):(_.previous=l,l.next=_),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(r===X.AsNew){if(n===this.e)return;const _=n.next,l=n.previous;n===this.d?(_.previous=void 0,this.d=_):(_.previous=l,l.next=_),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((r,_)=>{n.push([_,r])}),n}fromJSON(n){this.clear();for(const[r,_]of n)this.set(r,_)}}e.$Cc=u1;class l1 extends u1{constructor(n,r=1){super(),this.n=n,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,r=X.AsNew){return super.get(n,r)}peek(n){return super.get(n,X.None)}set(n,r){return super.set(n,r,X.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class P extends l1{constructor(n,r=1){super(n,r)}q(n){this.h(n)}set(n,r){return super.set(n,r),this.p(),this}}e.$Dc=P;class K extends l1{constructor(n,r=1){super(n,r)}q(n){this.i(n)}set(n,r){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,r),this}}e.$Ec=K;class S{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let r=this.c.get(n)||0;return r===0?!1:(r--,r===0?this.c.delete(n):this.c.set(n,r),!0)}has(n){return this.c.has(n)}}e.$Fc=S;class g{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[r,_]of n)this.set(r,_)}clear(){this.c.clear(),this.d.clear()}set(n,r){this.c.set(n,r),this.d.set(r,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const r=this.c.get(n);return r===void 0?!1:(this.c.delete(n),this.d.delete(r),!0)}forEach(n,r){this.c.forEach((_,l)=>{n.call(r,_,l,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=g;class ${constructor(){this.c=new Map}add(n,r){let _=this.c.get(n);_||(_=new Set,this.c.set(n,_)),_.add(r)}delete(n,r){const _=this.c.get(n);_&&(_.delete(r),_.size===0&&this.c.delete(n))}forEach(n,r){const _=this.c.get(n);_&&_.forEach(r)}get(n){const r=this.c.get(n);return r||new Set}}e.$Hc=$;function O(s,n){if(s===n)return!0;if(s.size!==n.size)return!1;for(const[r,_]of s)if(!n.has(r)||n.get(r)!==_)return!1;for(const[r]of n)if(!s.has(r))return!1;return!0}}),define(h1[4],g1([0,1,9,8,13,3,10]),function(_1,e,A,t,G,m,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=k,e.$Lc=j,e.$Mc=X,e.$Nc=P,e.$Oc=K,e.$Pc=S,e.$Qc=g,e.$Rc=$,e.$Sc=O,e.$3c=p;const W=!1;let L=null;class R{constructor(){this.b=new Map}c(h){let D=this.b.get(h);return D||(D={parent:null,source:null,isSingleton:!1,value:h,idx:R.a++},this.b.set(h,D)),D}trackDisposable(h){const D=this.c(h);D.source||(D.source=new Error().stack)}setParent(h,D){const q=this.c(h);q.parent=D}markAsDisposed(h){this.b.delete(h)}markAsSingleton(h){this.c(h).isSingleton=!0}f(h,D){const q=D.get(h);if(q)return q;const I=h.parent?this.f(this.c(h.parent),D):h;return D.set(h,I),I}getTrackedDisposables(){const h=new Map;return[...this.b.entries()].filter(([,q])=>q.source!==null&&!this.f(q,h).isSingleton).flatMap(([q])=>q)}computeLeakingDisposables(h=10,D){let q;if(D)q=D;else{const J=new Map,t1=[...this.b.values()].filter(Y=>Y.source!==null&&!this.f(Y,J).isSingleton);if(t1.length===0)return;const n1=new Set(t1.map(Y=>Y.value));if(q=t1.filter(Y=>!(Y.parent&&n1.has(Y.parent))),q.length===0)throw new Error("There are cyclic diposable chains!")}if(!q)return;function I(J){function t1(Y,C){for(;Y.length>0&&C.some(c1=>typeof c1=="string"?c1===Y[0]:Y[0].match(c1));)Y.shift()}const n1=J.source.split(`
`).map(Y=>Y.trim().replace("at ","")).filter(Y=>Y!=="");return t1(n1,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),n1.reverse()}const E=new G.$Hc;for(const J of q){const t1=I(J);for(let n1=0;n1<=t1.length;n1++)E.add(t1.slice(0,n1).join(`
`),J)}q.sort((0,A.$6b)(J=>J.idx,A.$8b));let F="",Q=0;for(const J of q.slice(0,h)){Q++;const t1=I(J),n1=[];for(let Y=0;Y<t1.length;Y++){let C=t1[Y];C=`(shared with ${E.get(t1.slice(0,Y+1).join(`
`)).size}/${q.length} leaks) at ${C}`;const v1=E.get(t1.slice(0,Y).join(`
`)),w1=(0,t.$E)([...v1].map(L1=>I(L1)[Y]),L1=>L1);delete w1[t1[Y]];for(const[L1,S1]of Object.entries(w1))n1.unshift(`    - stacktraces of ${S1.length} other leaks continue with ${L1}`);n1.unshift(C)}F+=`


==================== Leaking disposable ${Q}/${q.length}: ${J.value.constructor.name} ====================
${n1.join(`
`)}
============================================================

`}return q.length>h&&(F+=`


... and ${q.length-h} more leaking disposables

`),{leaks:q,details:F}}}e.$Jc=R,R.a=0;function k(v){L=v}if(W){const v="__is_disposable_tracked__";k(new class{trackDisposable(h){const D=new Error("Potentially leaked disposable").stack;setTimeout(()=>{h[v]||console.log(D)},3e3)}setParent(h,D){if(h&&h!==n.None)try{h[v]=!0}catch{}}markAsDisposed(h){if(h&&h!==n.None)try{h[v]=!0}catch{}}markAsSingleton(h){}})}function j(v){return L?.trackDisposable(v),v}function X(v){L?.markAsDisposed(v)}function u1(v,h){L?.setParent(v,h)}function l1(v,h){if(L)for(const D of v)L.setParent(D,h)}function P(v){return L?.markAsSingleton(v),v}function K(v){return typeof v=="object"&&v!==null&&typeof v.dispose=="function"&&v.dispose.length===0}function S(v){if(V.Iterable.is(v)){const h=[];for(const D of v)if(D)try{D.dispose()}catch(q){h.push(q)}if(h.length===1)throw h[0];if(h.length>1)throw new AggregateError(h,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}function g(v){for(const h of v)K(h)&&h.dispose();return[]}function $(...v){const h=O(()=>S(v));return l1(v,h),h}function O(v){const h=j({dispose:(0,m.$db)(()=>{X(h),v()})});return h}class s{constructor(){this.f=new Set,this.g=!1,j(this)}dispose(){this.g||(X(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{S(this.f)}finally{this.f.clear()}}add(h){if(!h)return h;if(h===this)throw new Error("Cannot register a disposable on itself!");return u1(h,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(h),h}delete(h){if(h){if(h===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(h),h.dispose()}}deleteAndLeak(h){h&&this.f.has(h)&&(this.f.delete(h),u1(h,null))}}e.$Tc=s,s.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this.q=new s,j(this),u1(this.q,this)}dispose(){X(this),this.q.dispose()}B(h){if(h===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(h)}}e.$Uc=n,n.None=Object.freeze({dispose(){}});class r{constructor(){this.b=!1,j(this)}get value(){return this.b?void 0:this.a}set value(h){this.b||h===this.a||(this.a?.dispose(),h&&u1(h,this),this.a=h)}clear(){this.value=void 0}dispose(){this.b=!0,X(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const h=this.a;return this.a=void 0,h&&u1(h,null),h}}e.$Vc=r;class _{constructor(h){this.a=new r,this.b=!1,this.a.value=h}get value(){return this.a.value}set value(h){this.b||h===this.a.value||(this.a.value=h)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=_;class l{constructor(h){this.b=h,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=l;class T{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,j(this)}set(h){let D=h;return this.unset=()=>D=void 0,this.isset=()=>D!==void 0,this.dispose=()=>{D&&(D(),D=void 0,X(this))},this}}e.$Yc=T;class M{constructor(){this.a=new Map}acquire(h,...D){let q=this.a.get(h);q||(q={counter:0,object:this.b(h,...D)},this.a.set(h,q));const{object:I}=q,E=(0,m.$db)(()=>{--q.counter===0&&(this.c(h,q.object),this.a.delete(h))});return q.counter++,{object:I,dispose:E}}}e.$Zc=M;class x{constructor(h){this.a=h}async acquire(h,...D){const q=this.a.acquire(h,...D);try{return{object:await q.object,dispose:()=>q.dispose()}}catch(I){throw q.dispose(),I}}}e.$1c=x;class E1{constructor(h){this.object=h}dispose(){}}e.$2c=E1;function p(v){const h=new s;try{v(h)}finally{h.dispose()}}class o1{constructor(){this.a=new Map,this.b=!1,j(this)}dispose(){X(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{S(this.a.values())}finally{this.a.clear()}}has(h){return this.a.has(h)}get size(){return this.a.size}get(h){return this.a.get(h)}set(h,D,q=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),q||this.a.get(h)?.dispose(),this.a.set(h,D)}deleteAndDispose(h){this.a.get(h)?.dispose(),this.a.delete(h)}deleteAndLeak(h){const D=this.a.get(h);return this.a.delete(h),D}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=o1}),define(h1[14],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=n,e.$x=x,e.$D=E1,e.$a="en";let A=!1,t=!1,G=!1,m=!1,V=!1,W=!1,L=!1,R=!1,k=!1,j=!1,X,u1=e.$a,l1=e.$a,P,K;const S=globalThis;let g;typeof S.vscode<"u"&&typeof S.vscode.process<"u"?g=S.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(g=process);const $=typeof g?.versions?.electron=="string",O=$&&g?.type==="renderer";if(typeof g=="object"){A=g.platform==="win32",t=g.platform==="darwin",G=g.platform==="linux",m=G&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,L=$,k=!!g.env.CI||!!g.env.BUILD_ARTIFACTSTAGINGDIRECTORY,X=e.$a,u1=e.$a;const p=g.env.VSCODE_NLS_CONFIG;if(p)try{const o1=JSON.parse(p),v=o1.availableLanguages["*"];X=o1.locale,l1=o1.osLocale,u1=v||e.$a,P=o1._translationsConfigFile}catch{}V=!0}else if(typeof navigator=="object"&&!O){K=navigator.userAgent,A=K.indexOf("Windows")>=0,t=K.indexOf("Macintosh")>=0,R=(K.indexOf("Macintosh")>=0||K.indexOf("iPad")>=0||K.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,G=K.indexOf("Linux")>=0,j=K?.indexOf("Mobi")>=0,W=!0,X=e.$a,u1=X,l1=navigator.language;const p=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),o1=p&&p.getAttribute("data-settings");if(o1)try{const v=JSON.parse(o1),h=v.availableLanguages["*"];X=v.locale,l1=v.osLocale,u1=h||e.$a,P=v._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var s;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(s||(e.Platform=s={}));function n(p){switch(p){case s.Web:return"Web";case s.Mac:return"Mac";case s.Linux:return"Linux";case s.Windows:return"Windows"}}let r=s.Web;t?r=s.Mac:A?r=s.Windows:G&&(r=s.Linux),e.$c=A,e.$d=t,e.$e=G,e.$f=m,e.$g=V,e.$h=L,e.$i=W,e.$j=W&&typeof S.importScripts=="function",e.$k=e.$j?S.origin:void 0,e.$l=R,e.$m=j,e.$n=k,e.$o=r,e.$p=K,e.$q=u1;var _;(function(p){function o1(){return e.$q}p.value=o1;function v(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}p.isDefaultVariant=v;function h(){return e.$q==="en"}p.isDefault=h})(_||(e.Language=_={})),e.$r=X,e.$s=l1,e.$t=P,e.$u=typeof S.postMessage=="function"&&!S.importScripts,e.$v=(()=>{if(e.$u){const p=[];S.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let h=0,D=p.length;h<D;h++){const q=p[h];if(q.id===v.data.vscodeScheduleAsyncWork){p.splice(h,1),q.callback();return}}});let o1=0;return v=>{const h=++o1;p.push({id:h,callback:v}),S.postMessage({vscodeScheduleAsyncWork:h},"*")}}return p=>setTimeout(p)})();var l;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(l||(e.OperatingSystem=l={})),e.OS=t||R?l.Macintosh:A?l.Windows:l.Linux;let T=!0,M=!1;function x(){if(!M){M=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,T=new Uint16Array(p.buffer)[0]===513}return T}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function E1(p){return parseFloat(p)>=20}}),define(h1[15],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const A=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(m){return new t(m)}constructor(m){this.c=A&&m===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=t}),define(h1[5],g1([0,1,2,3,4,12,15]),function(_1,e,A,t,G,m,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=u1;const W=!1,L=!1,R=!1;var k;(function(I){I.None=()=>G.$Uc.None;function E(N){if(R){const{onDidAddListener:w}=N,H=P.create();let y=0;N.onDidAddListener=()=>{++y===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),H.print()),w?.()}}}function F(N,w){return L1(N,()=>{},0,void 0,!0,void 0,w)}I.defer=F;function Q(N){return(w,H=null,y)=>{let z=!1,e1;return e1=N(f1=>{if(!z)return e1?e1.dispose():z=!0,w.call(H,f1)},null,y),z&&e1.dispose(),e1}}I.once=Q;function J(N,w,H){return v1((y,z=null,e1)=>N(f1=>y.call(z,w(f1)),null,e1),H)}I.map=J;function t1(N,w,H){return v1((y,z=null,e1)=>N(f1=>{w(f1),y.call(z,f1)},null,e1),H)}I.forEach=t1;function n1(N,w,H){return v1((y,z=null,e1)=>N(f1=>w(f1)&&y.call(z,f1),null,e1),H)}I.filter=n1;function Y(N){return N}I.signal=Y;function C(...N){return(w,H=null,y)=>{const z=(0,G.$Rc)(...N.map(e1=>e1(f1=>w.call(H,f1))));return w1(z,y)}}I.any=C;function c1(N,w,H,y){let z=H;return J(N,e1=>(z=w(z,e1),z),y)}I.reduce=c1;function v1(N,w){let H;const y={onWillAddFirstListener(){H=N(z.fire,z)},onDidRemoveLastListener(){H?.dispose()}};w||E(y);const z=new r(y);return w?.add(z),z.event}function w1(N,w){return w instanceof Array?w.push(N):w&&w.add(N),N}function L1(N,w,H=100,y=!1,z=!1,e1,f1){let $1,m1,N1,p1=0,F1;const i1={leakWarningThreshold:e1,onWillAddFirstListener(){$1=N(H1=>{p1++,m1=w(m1,H1),y&&!N1&&(R1.fire(m1),m1=void 0),F1=()=>{const j1=m1;m1=void 0,N1=void 0,(!y||p1>1)&&R1.fire(j1),p1=0},typeof H=="number"?(clearTimeout(N1),N1=setTimeout(F1,H)):N1===void 0&&(N1=0,queueMicrotask(F1))})},onWillRemoveListener(){z&&p1>0&&F1?.()},onDidRemoveLastListener(){F1=void 0,$1.dispose()}};f1||E(i1);const R1=new r(i1);return f1?.add(R1),R1.event}I.debounce=L1;function S1(N,w=0,H){return I.debounce(N,(y,z)=>y?(y.push(z),y):[z],w,void 0,!0,void 0,H)}I.accumulate=S1;function k1(N,w=(y,z)=>y===z,H){let y=!0,z;return n1(N,e1=>{const f1=y||!w(e1,z);return y=!1,z=e1,f1},H)}I.latch=k1;function B1(N,w,H){return[I.filter(N,w,H),I.filter(N,y=>!w(y),H)]}I.split=B1;function O1(N,w=!1,H=[],y){let z=H.slice(),e1=N(m1=>{z?z.push(m1):$1.fire(m1)});y&&y.add(e1);const f1=()=>{z?.forEach(m1=>$1.fire(m1)),z=null},$1=new r({onWillAddFirstListener(){e1||(e1=N(m1=>$1.fire(m1)),y&&y.add(e1))},onDidAddFirstListener(){z&&(w?setTimeout(f1):f1())},onDidRemoveLastListener(){e1&&e1.dispose(),e1=null}});return y&&y.add($1),$1.event}I.buffer=O1;function T1(N,w){return(y,z,e1)=>{const f1=w(new o);return N(function($1){const m1=f1.evaluate($1);m1!==c&&y.call(z,m1)},void 0,e1)}}I.chain=T1;const c=Symbol("HaltChainable");class o{constructor(){this.f=[]}map(w){return this.f.push(w),this}forEach(w){return this.f.push(H=>(w(H),H)),this}filter(w){return this.f.push(H=>w(H)?H:c),this}reduce(w,H){let y=H;return this.f.push(z=>(y=w(y,z),y)),this}latch(w=(H,y)=>H===y){let H=!0,y;return this.f.push(z=>{const e1=H||!w(z,y);return H=!1,y=z,e1?z:c}),this}evaluate(w){for(const H of this.f)if(w=H(w),w===c)break;return w}}function f(N,w,H=y=>y){const y=(...$1)=>f1.fire(H(...$1)),z=()=>N.on(w,y),e1=()=>N.removeListener(w,y),f1=new r({onWillAddFirstListener:z,onDidRemoveLastListener:e1});return f1.event}I.fromNodeEventEmitter=f;function d(N,w,H=y=>y){const y=(...$1)=>f1.fire(H(...$1)),z=()=>N.addEventListener(w,y),e1=()=>N.removeEventListener(w,y),f1=new r({onWillAddFirstListener:z,onDidRemoveLastListener:e1});return f1.event}I.fromDOMEventEmitter=d;function U(N){return new Promise(w=>Q(N)(w))}I.toPromise=U;function Z(N){const w=new r;return N.then(H=>{w.fire(H)},()=>{w.fire(void 0)}).finally(()=>{w.dispose()}),w.event}I.fromPromise=Z;function r1(N,w,H){return w(H),N(y=>w(y))}I.runAndSubscribe=r1;class d1{constructor(w,H){this._observable=w,this.f=0,this.g=!1;const y={onWillAddFirstListener:()=>{w.addObserver(this)},onDidRemoveLastListener:()=>{w.removeObserver(this)}};H||E(y),this.emitter=new r(y),H&&H.add(this.emitter)}beginUpdate(w){this.f++}handlePossibleChange(w){}handleChange(w,H){this.g=!0}endUpdate(w){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function b1(N,w){return new d1(N,w).emitter.event}I.fromObservable=b1;function U1(N){return(w,H,y)=>{let z=0,e1=!1;const f1={beginUpdate(){z++},endUpdate(){z--,z===0&&(N.reportChanges(),e1&&(e1=!1,w.call(H)))},handlePossibleChange(){},handleChange(){e1=!0}};N.addObserver(f1),N.reportChanges();const $1={dispose(){N.removeObserver(f1)}};return y instanceof G.$Tc?y.add($1):Array.isArray(y)&&y.push($1),$1}}I.fromObservableLight=U1})(k||(e.Event=k={}));class j{constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${j.f++}`,j.all.add(this)}start(E){this.g=new V.$be,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$de=j,j.all=new Set,j.f=0;let X=-1;function u1(I){const E=X;return X=I,{dispose(){X=E}}}class l1{constructor(E,F,Q=Math.random().toString(18).slice(2,5)){this.h=E,this.threshold=F,this.name=Q,this.g=0}dispose(){this.f?.clear()}check(E,F){const Q=this.threshold;if(Q<=0||F<Q)return;this.f||(this.f=new Map);const J=this.f.get(E.value)||0;if(this.f.set(E.value,J+1),this.g-=1,this.g<=0){this.g=Q*.5;const[t1,n1]=this.getMostFrequentStack(),Y=`[${this.name}] potential listener LEAK detected, having ${F} listeners already. MOST frequent listener (${n1}):`;console.warn(Y),console.warn(t1);const C=new K(Y,t1);this.h(C)}return()=>{const t1=this.f.get(E.value)||0;this.f.set(E.value,t1-1)}}getMostFrequentStack(){if(!this.f)return;let E,F=0;for(const[Q,J]of this.f)(!E||F<J)&&(E=[Q,J],F=J);return E}}class P{static create(){const E=new Error;return new P(E.stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class K extends Error{constructor(E,F){super(E),this.name="ListenerLeakError",this.stack=F}}e.$fe=K;class S extends Error{constructor(E,F){super(E),this.name="ListenerRefusalError",this.stack=F}}e.$ge=S;let g=0;class ${constructor(E){this.value=E,this.id=g++}}const O=2,s=(I,E)=>{if(I instanceof $)E(I);else for(let F=0;F<I.length;F++){const Q=I[F];Q&&E(Q)}},n=W?new FinalizationRegistry(I=>{typeof I=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(I))}):void 0;class r{constructor(E){this.w=0,this.f=E,this.g=X>0||this.f?.leakWarningThreshold?new l1(E?.onListenerError??A.$1,this.f?.leakWarningThreshold??X):void 0,this.j=this.f?._profName?new j(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(L){const E=this.t;queueMicrotask(()=>{s(E,F=>F.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(E,F,Q)=>{if(this.g&&this.w>this.g.threshold**2){const C=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(C);const c1=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],v1=new S(`${C}. HINT: Stack shows most frequent listener (${c1[1]}-times)`,c1[0]);return(this.f?.onListenerError||A.$1)(v1),G.$Uc.None}if(this.m)return G.$Uc.None;F&&(E=E.bind(F));const J=new $(E);let t1,n1;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(J.stack=P.create(),t1=this.g.check(J.stack,this.w+1)),L&&(J.stack=n1??P.create()),this.t?this.t instanceof $?(this.u??(this.u=new l),this.t=[this.t,J]):this.t.push(J):(this.f?.onWillAddFirstListener?.(this),this.t=J,this.f?.onDidAddFirstListener?.(this)),this.w++;const Y=(0,G.$Sc)(()=>{n?.unregister(Y),t1?.(),this.x(J)});if(Q instanceof G.$Tc?Q.add(Y):Array.isArray(Q)&&Q.push(Y),n){const C=new Error().stack.split(`
`).slice(2).join(`
`).trim();n.register(Y,C,Y)}return Y}),this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const F=this.t,Q=F.indexOf(E);if(Q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,F[Q]=void 0;const J=this.u.current===this;if(this.w*O<=F.length){let t1=0;for(let n1=0;n1<F.length;n1++)F[n1]?F[t1++]=F[n1]:J&&(this.u.end--,t1<this.u.i&&this.u.i--);F.length=t1}}y(E,F){if(!E)return;const Q=this.f?.onListenerError||A.$1;if(!Q){E.value(F);return}try{E.value(F)}catch(J){Q(J)}}z(E){const F=E.current.t;for(;E.i<E.end;)this.y(F[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,E);else{const F=this.u;F.enqueue(this,E,this.t.length),this.z(F)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=r;const _=()=>new l;e.$ie=_;class l{constructor(){this.i=-1,this.end=0}enqueue(E,F,Q){this.i=0,this.end=Q,this.current=E,this.value=F}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class T extends r{async fireAsync(E,F,Q){if(this.t)for(this.h||(this.h=new m.$5c),s(this.t,J=>this.h.push([J.value,E]));this.h.size>0&&!F.isCancellationRequested;){const[J,t1]=this.h.shift(),n1=[],Y={...t1,token:F,waitUntil:C=>{if(Object.isFrozen(n1))throw new Error("waitUntil can NOT be called asynchronous");Q&&(C=Q(C,J)),n1.push(C)}};try{J(Y)}catch(C){(0,A.$1)(C);continue}Object.freeze(n1),await Promise.allSettled(n1).then(C=>{for(const c1 of C)c1.status==="rejected"&&(0,A.$1)(c1.reason)})}}}e.$je=T;class M extends r{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new m.$5c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$ke=M;class x extends M{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$le=x;class E1 extends r{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(F=>super.fire(F)),this.h=[]}))}}e.$me=E1;class p{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const F={event:E,listener:null};this.h.push(F),this.g&&this.m(F);const Q=()=>{this.g&&this.o(F);const J=this.h.indexOf(F);this.h.splice(J,1)};return(0,G.$Sc)((0,t.$db)(Q))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(F=>this.f.fire(F))}o(E){E.listener?.dispose(),E.listener=null}dispose(){this.f.dispose();for(const E of this.h)E.listener?.dispose();this.h=[]}}e.$ne=p;class o1{constructor(E,F,Q,J){this.f=new G.$Tc;const t1=this.f.add(new p),n1=this.f.add(new G.$4c);function Y(C){n1.set(C,t1.add(J(C)))}for(const C of E)Y(C);this.f.add(F(C=>{Y(C)})),this.f.add(Q(C=>{n1.deleteAndDispose(C)})),this.event=t1.event}dispose(){this.f.dispose()}}e.$oe=o1;class v{constructor(){this.f=[]}wrapEvent(E,F,Q){return(J,t1,n1)=>E(Y=>{const C=this.f[this.f.length-1];if(!F){C?C.buffers.push(()=>J.call(t1,Y)):J.call(t1,Y);return}const c1=C;if(!c1){J.call(t1,F(Q,Y));return}c1.items??(c1.items=[]),c1.items.push(Y),c1.buffers.length===0&&C.buffers.push(()=>{c1.reducedResult??(c1.reducedResult=Q?c1.items.reduce(F,Q):c1.items.reduce(F)),J.call(t1,c1.reducedResult)})},void 0,n1)}bufferEvents(E){const F={buffers:new Array};this.f.push(F);const Q=E();return this.f.pop(),F.buffers.forEach(J=>J()),Q}}e.$pe=v;class h{constructor(){this.f=!1,this.g=k.None,this.h=G.$Uc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=h;class D{static const(E){return new q(E)}constructor(E){this.g=E,this.f=new r,this.onDidChange=this.f.event}get value(){return this.g}set value(E){E!==this.g&&(this.g=E,this.f.fire(void 0))}}e.$re=D;class q{constructor(E){this.value=E,this.onDidChange=k.None}}}),define(h1[16],g1([0,1,5]),function(_1,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=W;const t=Object.freeze(function(L,R){const k=setTimeout(L.bind(R),0);return{dispose(){clearTimeout(k)}}});var G;(function(L){function R(k){return k===L.None||k===L.Cancelled||k instanceof m?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}L.isCancellationToken=R,L.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),L.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(G||(e.CancellationToken=G={}));class m{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new A.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class V{constructor(R){this.f=void 0,this.g=void 0,this.g=R&&R.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new m),this.f}cancel(){this.f?this.f instanceof m&&this.f.cancel():this.f=G.Cancelled}dispose(R=!1){R&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof m&&this.f.dispose():this.f=G.None}}e.$se=V;function W(L){const R=new V;return L.add({dispose(){R.cancel()}}),R.token}}),define(h1[17],g1([0,1,16]),function(_1,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=G;class t{constructor(L){this.b=L,this.a=null}get(){if(this.a)return this.a;const L=new A.$se,R=this.b(L.token);return this.a={promise:R,dispose:()=>{this.a=null,L.cancel(),L.dispose()}},this.a}}e.$5e=t;function G(W){return W}class m{constructor(L,R){this.a=void 0,this.b=void 0,typeof L=="function"?(this.c=L,this.d=G):(this.c=R,this.d=L.getCacheKey)}get(L){const R=this.d(L);return this.b!==R&&(this.b=R,this.a=this.c(L)),this.a}}e.$7e=m;class V{get cachedValues(){return this.a}constructor(L,R){this.a=new Map,this.b=new Map,typeof L=="function"?(this.c=L,this.d=G):(this.c=R,this.d=L.getCacheKey)}get(L){const R=this.d(L);if(this.b.has(R))return this.b.get(R);const k=this.c(L);return this.a.set(L,k),this.b.set(R,k),k}}e.$8e=V}),define(h1[18],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=A,e.$bg=t,e.$cg=G,e.$dg=m,e.$eg=V,e.$fg=W,e.$gg=L,e.$hg=R,e.$ig=k,e.$jg=j,e.$kg=X,e.$lg=u1,e.$mg=l1,e.$ng=K,e.$og=S,e.$pg=g,e.$qg=$,e.$rg=O;function A(s){return typeof s=="string"}function t(s){return Array.isArray(s)&&s.every(n=>A(n))}function G(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function m(s){const n=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof n}function V(s){return typeof s=="number"&&!isNaN(s)}function W(s){return!!s&&typeof s[Symbol.iterator]=="function"}function L(s){return s===!0||s===!1}function R(s){return typeof s>"u"}function k(s){return!j(s)}function j(s){return R(s)||s===null}function X(s,n){if(!s)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function u1(s){if(j(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function l1(...s){const n=[];for(let r=0;r<s.length;r++){const _=s[r];if(j(_))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);n.push(_)}return n}const P=Object.prototype.hasOwnProperty;function K(s){if(!G(s))return!1;for(const n in s)if(P.call(s,n))return!1;return!0}function S(s){return typeof s=="function"}function g(...s){return s.length>0&&s.every(S)}function $(s,n){const r=Math.min(s.length,n.length);for(let _=0;_<r;_++)O(s[_],n[_])}function O(s,n){if(A(n)){if(typeof s!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(S(n)){try{if(s instanceof n)return}catch{}if(!j(s)&&s.constructor===n||n.length===1&&n.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(h1[19],g1([0,1,18]),function(_1,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=t,e.$$n=G,e.$_n=V,e.$ao=L,e.$bo=R,e.$co=k,e.$do=j,e.$eo=X,e.$fo=u1,e.$go=l1,e.$ho=P,e.$io=K,e.$jo=S;function t(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const $=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([O,s])=>{$[O]=s&&typeof s=="object"?t(s):s}),$}function G(g){if(!g||typeof g!="object")return g;const $=[g];for(;$.length>0;){const O=$.shift();Object.freeze(O);for(const s in O)if(m.call(O,s)){const n=O[s];typeof n=="object"&&!Object.isFrozen(n)&&!(0,A.$dg)(n)&&$.push(n)}}return g}const m=Object.prototype.hasOwnProperty;function V(g,$){return W(g,$,new Set)}function W(g,$,O){if((0,A.$jg)(g))return g;const s=$(g);if(typeof s<"u")return s;if(Array.isArray(g)){const n=[];for(const r of g)n.push(W(r,$,O));return n}if((0,A.$cg)(g)){if(O.has(g))throw new Error("Cannot clone recursive data-structure");O.add(g);const n={};for(const r in g)m.call(g,r)&&(n[r]=W(g[r],$,O));return O.delete(g),n}return g}function L(g,$,O=!0){return(0,A.$cg)(g)?((0,A.$cg)($)&&Object.keys($).forEach(s=>{s in g?O&&((0,A.$cg)(g[s])&&(0,A.$cg)($[s])?L(g[s],$[s],O):g[s]=$[s]):g[s]=$[s]}),g):$}function R(g,$){if(g===$)return!0;if(g==null||$===null||$===void 0||typeof g!=typeof $||typeof g!="object"||Array.isArray(g)!==Array.isArray($))return!1;let O,s;if(Array.isArray(g)){if(g.length!==$.length)return!1;for(O=0;O<g.length;O++)if(!R(g[O],$[O]))return!1}else{const n=[];for(s in g)n.push(s);n.sort();const r=[];for(s in $)r.push(s);if(r.sort(),!R(n,r))return!1;for(O=0;O<n.length;O++)if(!R(g[n[O]],$[n[O]]))return!1}return!0}function k(g){const $=new Set;return JSON.stringify(g,(O,s)=>{if((0,A.$cg)(s)||Array.isArray(s)){if($.has(s))return"[Circular]";$.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function j(g,$){const O=Object.create(null);return!g||!$||Object.keys($).forEach(n=>{const r=g[n],_=$[n];R(r,_)||(O[n]=_)}),O}function X(g,$){const O=$.toLowerCase(),s=Object.keys(g).find(n=>n.toLowerCase()===O);return s?g[s]:g[$]}function u1(g,$){const O=Object.create(null);for(const[s,n]of Object.entries(g))$(s,n)&&(O[s]=n);return O}function l1(g){let $=[];for(;Object.prototype!==g;)$=$.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return $}function P(g){const $=[];for(const O of l1(g))typeof g[O]=="function"&&$.push(O);return $}function K(g,$){const O=n=>function(){const r=Array.prototype.slice.call(arguments,0);return $(n,r)},s={};for(const n of g)s[n]=O(n);return s}function S(g,$){const O={};for(const[s,n]of Object.entries(g))O[s]=$(n,s);return O}}),define(h1[20],g1([0,1]),function(_1,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=t,e.$0e=G;var A;(function(m){m[m.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",m[m.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",m[m.MAX_UINT_8=255]="MAX_UINT_8",m[m.MAX_UINT_16=65535]="MAX_UINT_16",m[m.MAX_UINT_32=4294967295]="MAX_UINT_32",m[m.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(A||(e.Constants=A={}));function t(m){return m<0?0:m>A.MAX_UINT_8?A.MAX_UINT_8:m|0}function G(m){return m<0?0:m>A.MAX_UINT_32?A.MAX_UINT_32:m|0}}),define(h1[21],g1([0,1,17,7,11,20]),function(_1,e,A,t,G,m){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=W,e.$_e=R,e.$af=j,e.$bf=X,e.$cf=u1,e.$df=l1,e.$ef=P,e.$ff=K,e.$gf=S,e.$hf=g,e.$if=$,e.$jf=O,e.$kf=s,e.$lf=n,e.$mf=r,e.$nf=_,e.$of=l,e.$pf=T,e.$qf=M,e.$rf=x,e.$sf=E1,e.$tf=p,e.$uf=o1,e.$vf=v,e.$wf=h,e.$xf=D,e.$yf=q,e.$zf=I,e.$Af=E,e.$Bf=F,e.$Cf=Q,e.$Df=J,e.$Ef=t1,e.$Ff=n1,e.$Gf=Y,e.$Hf=C,e.$If=c1,e.$Lf=S1,e.$Mf=k1,e.$Nf=B1,e.$Of=O1,e.$Pf=o,e.$Qf=d,e.$Sf=U,e.$Tf=Z,e.$Uf=r1,e.$Vf=d1,e.$Wf=U1,e.$Xf=N,e.$Yf=H,e.$1f=y,e.$2f=z,e.$3f=e1,e.$4f=f1,e.$5f=$1,e.$6f=m1,e.$7f=N1,e.$8f=p1,e.$9f=j1;function W(i){return!i||typeof i!="string"?!0:i.trim().length===0}const L=/{(\d+)}/g;function R(i,...u){return u.length===0?i:i.replace(L,function(a,b){const B=parseInt(b,10);return isNaN(B)||B<0||B>=u.length?a:u[B]})}const k=/{([^}]+)}/g;function j(i,u){return Object.keys(u).length===0?i:i.replace(k,(a,b)=>u[b]??a)}function X(i){return i.replace(/[<>"'&]/g,u=>{switch(u){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return u})}function u1(i){return i.replace(/[<>&]/g,function(u){switch(u){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return u}})}function l1(i){return i.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function P(i,u){let a=0,b=i.indexOf(u);for(;b!==-1;)a++,b=i.indexOf(u,b+u.length);return a}function K(i,u,a="\u2026"){return i.length<=u?i:`${i.substr(0,u)}${a}`}function S(i,u,a="\u2026"){if(i.length<=u)return i;const b=Math.ceil(u/2)-a.length/2,B=Math.floor(u/2)-a.length/2;return`${i.substr(0,b)}${a}${i.substr(i.length-B)}`}function g(i,u=" "){const a=$(i,u);return O(a,u)}function $(i,u){if(!i||!u)return i;const a=u.length;if(a===0||i.length===0)return i;let b=0;for(;i.indexOf(u,b)===b;)b=b+a;return i.substring(b)}function O(i,u){if(!i||!u)return i;const a=u.length,b=i.length;if(a===0||b===0)return i;let B=b,s1=-1;for(;s1=i.lastIndexOf(u,B-1),!(s1===-1||s1+a!==B);){if(s1===0)return"";B=s1}return i.substring(0,B)}function s(i){return i.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function n(i){return i.replace(/\*/g,"")}function r(i,u,a={}){if(!i)throw new Error("Cannot create regex from empty string");u||(i=l1(i)),a.wholeWord&&(/\B/.test(i.charAt(0))||(i="\\b"+i),/\B/.test(i.charAt(i.length-1))||(i=i+"\\b"));let b="";return a.global&&(b+="g"),a.matchCase||(b+="i"),a.multiline&&(b+="m"),a.unicode&&(b+="u"),new RegExp(i,b)}function _(i){return i.source==="^"||i.source==="^$"||i.source==="$"||i.source==="^\\s*$"?!1:!!(i.exec("")&&i.lastIndex===0)}function l(i){return i.split(/\r\n|\r|\n/)}function T(i){const u=[],a=i.split(/(\r\n|\r|\n)/);for(let b=0;b<Math.ceil(a.length/2);b++)u.push(a[2*b]+(a[2*b+1]??""));return u}function M(i){for(let u=0,a=i.length;u<a;u++){const b=i.charCodeAt(u);if(b!==t.CharCode.Space&&b!==t.CharCode.Tab)return u}return-1}function x(i,u=0,a=i.length){for(let b=u;b<a;b++){const B=i.charCodeAt(b);if(B!==t.CharCode.Space&&B!==t.CharCode.Tab)return i.substring(u,b)}return i.substring(u,a)}function E1(i,u=i.length-1){for(let a=u;a>=0;a--){const b=i.charCodeAt(a);if(b!==t.CharCode.Space&&b!==t.CharCode.Tab)return a}return-1}function p(i,u,a){const b=[];let B=0;for(const s1 of i.matchAll(u)){if(b.push(i.slice(B,s1.index)),s1.index===void 0)throw new Error("match.index should be defined");B=s1.index+s1[0].length,b.push(a(s1[0],...s1.slice(1),s1.index,i,s1.groups))}return b.push(i.slice(B)),Promise.all(b).then(s1=>s1.join(""))}function o1(i,u){return i<u?-1:i>u?1:0}function v(i,u,a=0,b=i.length,B=0,s1=u.length){for(;a<b&&B<s1;a++,B++){const D1=i.charCodeAt(a),a1=u.charCodeAt(B);if(D1<a1)return-1;if(D1>a1)return 1}const A1=b-a,P1=s1-B;return A1<P1?-1:A1>P1?1:0}function h(i,u){return D(i,u,0,i.length,0,u.length)}function D(i,u,a=0,b=i.length,B=0,s1=u.length){for(;a<b&&B<s1;a++,B++){let D1=i.charCodeAt(a),a1=u.charCodeAt(B);if(D1===a1)continue;if(D1>=128||a1>=128)return v(i.toLowerCase(),u.toLowerCase(),a,b,B,s1);I(D1)&&(D1-=32),I(a1)&&(a1-=32);const I1=D1-a1;if(I1!==0)return I1}const A1=b-a,P1=s1-B;return A1<P1?-1:A1>P1?1:0}function q(i){return i>=t.CharCode.Digit0&&i<=t.CharCode.Digit9}function I(i){return i>=t.CharCode.a&&i<=t.CharCode.z}function E(i){return i>=t.CharCode.A&&i<=t.CharCode.Z}function F(i,u){return i.length===u.length&&D(i,u)===0}function Q(i,u){const a=u.length;return u.length>i.length?!1:D(i,u,0,a)===0}function J(i,u){const a=Math.min(i.length,u.length);let b;for(b=0;b<a;b++)if(i.charCodeAt(b)!==u.charCodeAt(b))return b;return a}function t1(i,u){const a=Math.min(i.length,u.length);let b;const B=i.length-1,s1=u.length-1;for(b=0;b<a;b++)if(i.charCodeAt(B-b)!==u.charCodeAt(s1-b))return b;return a}function n1(i){return 55296<=i&&i<=56319}function Y(i){return 56320<=i&&i<=57343}function C(i,u){return(i-55296<<10)+(u-56320)+65536}function c1(i,u,a){const b=i.charCodeAt(a);if(n1(b)&&a+1<u){const B=i.charCodeAt(a+1);if(Y(B))return C(b,B)}return b}function v1(i,u){const a=i.charCodeAt(u-1);if(Y(a)&&u>1){const b=i.charCodeAt(u-2);if(n1(b))return C(b,a)}return a}class w1{get offset(){return this.e}constructor(u,a=0){this.c=u,this.d=u.length,this.e=a}setOffset(u){this.e=u}prevCodePoint(){const u=v1(this.c,this.e);return this.e-=u>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,u}nextCodePoint(){const u=c1(this.c,this.d,this.e);return this.e+=u>=m.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,u}eol(){return this.e>=this.d}}e.$Jf=w1;class L1{get offset(){return this.c.offset}constructor(u,a=0){this.c=new w1(u,a)}nextGraphemeLength(){const u=R1.getInstance(),a=this.c,b=a.offset;let B=u.getGraphemeBreakType(a.nextCodePoint());for(;!a.eol();){const s1=a.offset,A1=u.getGraphemeBreakType(a.nextCodePoint());if(F1(B,A1)){a.setOffset(s1);break}B=A1}return a.offset-b}prevGraphemeLength(){const u=R1.getInstance(),a=this.c,b=a.offset;let B=u.getGraphemeBreakType(a.prevCodePoint());for(;a.offset>0;){const s1=a.offset,A1=u.getGraphemeBreakType(a.prevCodePoint());if(F1(A1,B)){a.setOffset(s1);break}B=A1}return b-a.offset}eol(){return this.c.eol()}}e.$Kf=L1;function S1(i,u){return new L1(i,u).nextGraphemeLength()}function k1(i,u){return new L1(i,u).prevGraphemeLength()}function B1(i,u){u>0&&Y(i.charCodeAt(u))&&u--;const a=u+S1(i,u);return[a-k1(i,a),a]}function O1(i){const u=new L1(i);let a=0;for(;!u.eol();)a++,u.nextGraphemeLength();return a}let T1;function c(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function o(i){return T1||(T1=c()),T1.test(i)}const f=/^[\t\n\r\x20-\x7E]*$/;function d(i){return f.test(i)}e.$Rf=/[\u2028\u2029]/;function U(i){return e.$Rf.test(i)}function Z(i){return i>=11904&&i<=55215||i>=63744&&i<=64255||i>=65281&&i<=65374}function r1(i){return i>=127462&&i<=127487||i===8986||i===8987||i===9200||i===9203||i>=9728&&i<=10175||i===11088||i===11093||i>=127744&&i<=128591||i>=128640&&i<=128764||i>=128992&&i<=129008||i>=129280&&i<=129535||i>=129648&&i<=129782}function d1(i,u,a=""){const b=i.trimStart();if(b.length<u)return b;const B=/\b/g;let s1=0;for(;B.test(b)&&!(b.length-B.lastIndex<u);)s1=B.lastIndex,B.lastIndex+=1;return s1===0?b:a+b.substring(s1).trimStart()}const b1=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*U1(i){let u=0;for(const a of i.matchAll(b1))u!==a.index&&(yield{isCode:!1,str:i.substring(u,a.index)}),yield{isCode:!0,str:a[0]},u=a.index+a[0].length;u!==i.length&&(yield{isCode:!1,str:i.substring(u)})}function N(i){return i&&(i=i.replace(b1,"")),i}const w=/\\\[.*?\\\]/g;function H(i){return N(i).replace(w,"")}e.$Zf=String.fromCharCode(t.CharCode.UTF8_BOM);function y(i){return!!(i&&i.length>0&&i.charCodeAt(0)===t.CharCode.UTF8_BOM)}function z(i){return y(i)?i.substr(1):i}function e1(i,u){if(!i||!u||i.length<u.length)return!1;const a=u.length,b=i.toLowerCase();let B=0,s1=-1;for(;B<a;){const A1=b.indexOf(u[B],s1+1);if(A1<0)return!1;s1=A1,B++}return!0}function f1(i,u=!1){return i?(u&&(i=i.replace(/\\./g,"")),i.toLowerCase()!==i):!1}function $1(i){return i.charAt(0).toUpperCase()+i.slice(1)}function m1(i,u=1){if(u===0)return"";let a=-1;do a=i.indexOf(`
`,a+1),u--;while(u>0&&a>=0);return a===-1?i:(i[a-1]==="\r"&&a--,i.substr(0,a))}function N1(i){const u=t.CharCode.Z-t.CharCode.A+1;return i=i%(2*u),i<u?String.fromCharCode(t.CharCode.a+i):String.fromCharCode(t.CharCode.A+i-u)}function p1(i){return R1.getInstance().getGraphemeBreakType(i)}function F1(i,u){return i===i1.Other?u!==i1.Extend&&u!==i1.SpacingMark:i===i1.CR&&u===i1.LF?!1:i===i1.Control||i===i1.CR||i===i1.LF||u===i1.Control||u===i1.CR||u===i1.LF?!0:!(i===i1.L&&(u===i1.L||u===i1.V||u===i1.LV||u===i1.LVT)||(i===i1.LV||i===i1.V)&&(u===i1.V||u===i1.T)||(i===i1.LVT||i===i1.T)&&u===i1.T||u===i1.Extend||u===i1.ZWJ||u===i1.SpacingMark||i===i1.Prepend||i===i1.ZWJ&&u===i1.Extended_Pictographic||i===i1.Regional_Indicator&&u===i1.Regional_Indicator)}var i1;(function(i){i[i.Other=0]="Other",i[i.Prepend=1]="Prepend",i[i.CR=2]="CR",i[i.LF=3]="LF",i[i.Control=4]="Control",i[i.Extend=5]="Extend",i[i.Regional_Indicator=6]="Regional_Indicator",i[i.SpacingMark=7]="SpacingMark",i[i.L=8]="L",i[i.V=9]="V",i[i.T=10]="T",i[i.LV=11]="LV",i[i.LVT=12]="LVT",i[i.ZWJ=13]="ZWJ",i[i.Extended_Pictographic=14]="Extended_Pictographic"})(i1||(e.GraphemeBreakType=i1={}));class R1{static getInstance(){return R1.c||(R1.c=new R1),R1.c}constructor(){this.d=H1()}getGraphemeBreakType(u){if(u<32)return u===t.CharCode.LineFeed?i1.LF:u===t.CharCode.CarriageReturn?i1.CR:i1.Control;if(u<127)return i1.Other;const a=this.d,b=a.length/3;let B=1;for(;B<=b;)if(u<a[3*B])B=2*B;else if(u>a[3*B+1])B=2*B+1;else return a[3*B+2];return i1.Other}}R1.c=null;function H1(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function j1(i,u){if(i===0)return 0;const a=V1(i,u);if(a!==void 0)return a;const b=new w1(u,i);return b.prevCodePoint(),b.offset}function V1(i,u){const a=new w1(u,i);let b=a.prevCodePoint();for(;z1(b)||b===W1.emojiVariantSelector||b===W1.enclosingKeyCap;){if(a.offset===0)return;b=a.prevCodePoint()}if(!r1(b))return;let B=a.offset;return B>0&&a.prevCodePoint()===W1.zwj&&(B=a.offset),B}function z1(i){return 127995<=i&&i<=127999}var W1;(function(i){i[i.zwj=8205]="zwj",i[i.emojiVariantSelector=65039]="emojiVariantSelector",i[i.enclosingKeyCap=8419]="enclosingKeyCap"})(W1||(W1={})),e.$0f="\xA0";class G1{static getInstance(u){return V.d.get(Array.from(u))}static getLocales(){return V.e.value}constructor(u){this.f=u}isAmbiguous(u){return this.f.has(u)}containsAmbiguousCharacter(u){for(let a=0;a<u.length;a++){const b=u.codePointAt(a);if(typeof b=="number"&&this.isAmbiguous(b))return!0}return!1}getPrimaryConfusable(u){return this.f.get(u)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=G1,V=G1,G1.c=new G.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),G1.d=new A.$7e({getCacheKey:JSON.stringify},i=>{function u(a1){const I1=new Map;for(let M1=0;M1<a1.length;M1+=2)I1.set(a1[M1],a1[M1+1]);return I1}function a(a1,I1){const M1=new Map(a1);for(const[q1,K1]of I1)M1.set(q1,K1);return M1}function b(a1,I1){if(!a1)return I1;const M1=new Map;for(const[q1,K1]of a1)I1.has(q1)&&M1.set(q1,K1);return M1}const B=V.c.value;let s1=i.filter(a1=>!a1.startsWith("_")&&a1 in B);s1.length===0&&(s1=["_default"]);let A1;for(const a1 of s1){const I1=u(B[a1]);A1=b(A1,I1)}const P1=u(B._common),D1=a(P1,A1);return new V(D1)}),G1.e=new G.$V(()=>Object.keys(V.c.value).filter(i=>!i.startsWith("_")));class y1{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(y1.c())),this.d}static isInvisibleCharacter(u){return y1.e().has(u)}static containsInvisibleCharacter(u){for(let a=0;a<u.length;a++){const b=u.codePointAt(a);if(typeof b=="number"&&y1.isInvisibleCharacter(b))return!0}return!1}static get codePoints(){return y1.e()}}e.$_f=y1,y1.d=void 0}),define(h1[22],g1([0,1,2,5,4,19,14,21]),function(_1,e,A,t,G,m,V,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SimpleWorkerServer=e.SimpleWorkerClient=void 0,e.logOnceWebWorkerWarning=k,e.create=r;const L="$initialize";let R=!1;function k(_){V.$i&&(R||(R=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(_.message))}var j;(function(_){_[_.Request=0]="Request",_[_.Reply=1]="Reply",_[_.SubscribeEvent=2]="SubscribeEvent",_[_.Event=3]="Event",_[_.UnsubscribeEvent=4]="UnsubscribeEvent"})(j||(j={}));class X{constructor(l,T,M,x){this.vsWorker=l,this.req=T,this.method=M,this.args=x,this.type=j.Request}}class u1{constructor(l,T,M,x){this.vsWorker=l,this.seq=T,this.res=M,this.err=x,this.type=j.Reply}}class l1{constructor(l,T,M,x){this.vsWorker=l,this.req=T,this.eventName=M,this.arg=x,this.type=j.SubscribeEvent}}class P{constructor(l,T,M){this.vsWorker=l,this.req=T,this.event=M,this.type=j.Event}}class K{constructor(l,T){this.vsWorker=l,this.req=T,this.type=j.UnsubscribeEvent}}class S{constructor(l){this.a=-1,this.g=l,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(l){this.a=l}sendMessage(l,T){const M=String(++this.b);return new Promise((x,E1)=>{this.c[M]={resolve:x,reject:E1},this.o(new X(this.a,M,l,T))})}listen(l,T){let M=null;const x=new t.$he({onWillAddFirstListener:()=>{M=String(++this.b),this.d.set(M,x),this.o(new l1(this.a,M,l,T))},onDidRemoveLastListener:()=>{this.d.delete(M),this.o(new K(this.a,M)),M=null}});return x.event}handleMessage(l){!l||!l.vsWorker||this.a!==-1&&l.vsWorker!==this.a||this.h(l)}h(l){switch(l.type){case j.Reply:return this.j(l);case j.Request:return this.k(l);case j.SubscribeEvent:return this.l(l);case j.Event:return this.m(l);case j.UnsubscribeEvent:return this.n(l)}}j(l){if(!this.c[l.seq]){console.warn("Got reply to unknown seq");return}const T=this.c[l.seq];if(delete this.c[l.seq],l.err){let M=l.err;l.err.$isError&&(M=new Error,M.name=l.err.name,M.message=l.err.message,M.stack=l.err.stack),T.reject(M);return}T.resolve(l.res)}k(l){const T=l.req;this.g.handleMessage(l.method,l.args).then(x=>{this.o(new u1(this.a,T,x,void 0))},x=>{x.detail instanceof Error&&(x.detail=(0,A.$3)(x.detail)),this.o(new u1(this.a,T,void 0,(0,A.$3)(x)))})}l(l){const T=l.req,M=this.g.handleEvent(l.eventName,l.arg)(x=>{this.o(new P(this.a,T,x))});this.f.set(T,M)}m(l){if(!this.d.has(l.req)){console.warn("Got event for unknown req");return}this.d.get(l.req).fire(l.event)}n(l){if(!this.f.has(l.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(l.req).dispose(),this.f.delete(l.req)}o(l){const T=[];if(l.type===j.Request)for(let M=0;M<l.args.length;M++)l.args[M]instanceof ArrayBuffer&&T.push(l.args[M]);else l.type===j.Reply&&l.res instanceof ArrayBuffer&&T.push(l.res);this.g.sendMessage(l,T)}}class g extends G.$Uc{constructor(l,T,M){super();let x=null;this.a=this.B(l.create("vs/base/common/worker/simpleWorker",D=>{this.c.handleMessage(D)},D=>{x?.(D)})),this.c=new S({sendMessage:(D,q)=>{this.a.postMessage(D,q)},handleMessage:(D,q)=>{if(typeof M[D]!="function")return Promise.reject(new Error("Missing method "+D+" on main thread host."));try{return Promise.resolve(M[D].apply(M,q))}catch(I){return Promise.reject(I)}},handleEvent:(D,q)=>{if(O(D)){const I=M[D].call(M,q);if(typeof I!="function")throw new Error(`Missing dynamic event ${D} on main thread host.`);return I}if($(D)){const I=M[D];if(typeof I!="function")throw new Error(`Missing event ${D} on main thread host.`);return I}throw new Error(`Malformed event name ${D}`)}}),this.c.setWorkerId(this.a.getId());let E1=null;const p=globalThis.require;typeof p<"u"&&typeof p.getConfig=="function"?E1=p.getConfig():typeof globalThis.requirejs<"u"&&(E1=globalThis.requirejs.s.contexts._.config);const o1=(0,m.$ho)(M);this.b=this.c.sendMessage(L,[this.a.getId(),JSON.parse(JSON.stringify(E1)),T,o1]);const v=(D,q)=>this.g(D,q),h=(D,q)=>this.c.listen(D,q);this.f=new Promise((D,q)=>{x=q,this.b.then(I=>{D(s(I,v,h))},I=>{q(I),this.h("Worker failed to load "+T,I)})})}getProxyObject(){return this.f}g(l,T){return new Promise((M,x)=>{this.b.then(()=>{this.c.sendMessage(l,T).then(M,x)},x)})}h(l,T){console.error(l),console.info(T)}}e.SimpleWorkerClient=g;function $(_){return _[0]==="o"&&_[1]==="n"&&W.$Af(_.charCodeAt(2))}function O(_){return/^onDynamic/.test(_)&&W.$Af(_.charCodeAt(9))}function s(_,l,T){const M=p=>function(){const o1=Array.prototype.slice.call(arguments,0);return l(p,o1)},x=p=>function(o1){return T(p,o1)},E1={};for(const p of _){if(O(p)){E1[p]=x(p);continue}if($(p)){E1[p]=T(p,void 0);continue}E1[p]=M(p)}return E1}class n{constructor(l,T){this.a=T,this.b=null,this.c=new S({sendMessage:(M,x)=>{l(M,x)},handleMessage:(M,x)=>this.d(M,x),handleEvent:(M,x)=>this.f(M,x)})}onmessage(l){this.c.handleMessage(l)}d(l,T){if(l===L)return this.g(T[0],T[1],T[2],T[3]);if(!this.b||typeof this.b[l]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+l));try{return Promise.resolve(this.b[l].apply(this.b,T))}catch(M){return Promise.reject(M)}}f(l,T){if(!this.b)throw new Error("Missing requestHandler");if(O(l)){const M=this.b[l].call(this.b,T);if(typeof M!="function")throw new Error(`Missing dynamic event ${l} on request handler.`);return M}if($(l)){const M=this.b[l];if(typeof M!="function")throw new Error(`Missing event ${l} on request handler.`);return M}throw new Error(`Malformed event name ${l}`)}g(l,T,M,x){this.c.setWorkerId(l);const o1=s(x,(v,h)=>this.c.sendMessage(v,h),(v,h)=>this.c.listen(v,h));return this.a?(this.b=this.a(o1),Promise.resolve((0,m.$ho)(this.b))):(T&&(typeof T.baseUrl<"u"&&delete T.baseUrl,typeof T.paths<"u"&&typeof T.paths.vs<"u"&&delete T.paths.vs,typeof T.trustedTypesPolicy<"u"&&delete T.trustedTypesPolicy,T.catchError=!0,globalThis.require.config(T)),new Promise((v,h)=>{(globalThis.require||_1)([M],q=>{if(this.b=q.create(o1),!this.b){h(new Error("No RequestHandler!"));return}v((0,m.$ho)(this.b))},h)}))}}e.SimpleWorkerServer=n;function r(_){return new n(_,null)}})}).call(this);

//# sourceMappingURL=simpleWorker.js.map
