"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/editor/common/core/range","vs/base/common/charCode","vs/base/common/errors","vs/editor/common/core/position","vs/editor/common/core/offsetRange","vs/base/common/arrays","vs/base/common/strings","vs/base/common/arraysFind","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/uint","vs/editor/common/core/lineRange","vs/base/common/map","vs/base/common/platform","vs/base/common/objects","vs/base/common/uri","vs/editor/common/diff/defaultLinesDiffComputer/utils","vs/editor/common/diff/rangeMapping","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/types","vs/base/common/codiconsUtil","vs/base/common/diff/diff","vs/editor/common/core/characterClassifier","vs/editor/common/core/textLength","vs/editor/common/core/wordHelper","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/myersDiffAlgorithm","vs/editor/common/diff/defaultLinesDiffComputer/linesSliceCharSequence","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/legacyLinesDiffComputer","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/path","vs/base/common/cache","vs/base/common/codiconsLibrary","vs/base/common/codicons","vs/base/common/hash","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/positionToOffset","vs/editor/common/core/textEdit","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/defaultLinesDiffComputer/heuristicSequenceOptimizations","vs/editor/common/diff/defaultLinesDiffComputer/lineSequence","vs/editor/common/diff/defaultLinesDiffComputer/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/defaultLinesDiffComputer/computeMovedLines","vs/editor/common/diff/defaultLinesDiffComputer/defaultLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/encodedTokenAttributes","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/findSectionHeaders","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/editor/common/services/editorSimpleWorker"],re=function(q){for(var i=[],t=0,n=q.length;t<n;t++)i[t]=ie[q[t]];return i};const Ze=this,Xe=typeof global=="object"?global:{};var Le;(function(q){q.global=Ze;class i{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=i._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof q.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}q.Environment=i})(Le||(Le={}));var Le;(function(q){class i{constructor(g,w,b){this.type=g,this.detail=w,this.timestamp=b}}q.LoaderEvent=i;class t{constructor(g){this._events=[new i(1,"",g)]}record(g,w){this._events.push(new i(g,w,q.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}q.LoaderEventRecorder=t;class n{record(g,w){}getEvents(){return[]}}n.INSTANCE=new n,q.NullLoaderEventRecorder=n})(Le||(Le={}));var Le;(function(q){class i{static fileUriToFilePath(n,p){if(p=decodeURI(p).replace(/%23/g,"#"),n){if(/^file:\/\/\//.test(p))return p.substr(8);if(/^file:\/\//.test(p))return p.substr(5)}else if(/^file:\/\//.test(p))return p.substr(7);return p}static startsWith(n,p){return n.length>=p.length&&n.substr(0,p.length)===p}static endsWith(n,p){return n.length>=p.length&&n.substr(n.length-p.length)===p}static containsQueryString(n){return/^[^\#]*\?/gi.test(n)}static isAbsolutePath(n){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(n)}static forEachProperty(n,p){if(n){let g;for(g in n)n.hasOwnProperty(g)&&p(g,n[g])}}static isEmpty(n){let p=!0;return i.forEachProperty(n,()=>{p=!1}),p}static recursiveClone(n){if(!n||typeof n!="object"||n instanceof RegExp||!Array.isArray(n)&&Object.getPrototypeOf(n)!==Object.prototype)return n;let p=Array.isArray(n)?[]:{};return i.forEachProperty(n,(g,w)=>{w&&typeof w=="object"?p[g]=i.recursiveClone(w):p[g]=w}),p}static generateAnonymousModule(){return"===anonymous"+i.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(n){return i.startsWith(n,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=q.global.performance&&typeof q.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?q.global.performance.now():Date.now()}}i.NEXT_ANONYMOUS_ID=1,i.PERFORMANCE_NOW_PROBED=!1,i.HAS_PERFORMANCE_NOW=!1,q.Utilities=i})(Le||(Le={}));var Le;(function(q){function i(p){if(p instanceof Error)return p;const g=new Error(p.message||String(p)||"Unknown Error");return p.stack&&(g.stack=p.stack),g}q.ensureError=i;class t{static validateConfigurationOptions(g){function w(b){if(b.phase==="loading"){console.error('Loading "'+b.moduleId+'" failed'),console.error(b),console.error("Here are the modules that depend on it:"),console.error(b.neededBy);return}if(b.phase==="factory"){console.error('The factory function of "'+b.moduleId+'" has thrown an exception'),console.error(b),console.error("Here are the modules that depend on it:"),console.error(b.neededBy);return}}if(g=g||{},typeof g.baseUrl!="string"&&(g.baseUrl=""),typeof g.isBuild!="boolean"&&(g.isBuild=!1),typeof g.paths!="object"&&(g.paths={}),typeof g.config!="object"&&(g.config={}),typeof g.catchError>"u"&&(g.catchError=!1),typeof g.recordStats>"u"&&(g.recordStats=!1),typeof g.urlArgs!="string"&&(g.urlArgs=""),typeof g.onError!="function"&&(g.onError=w),Array.isArray(g.ignoreDuplicateModules)||(g.ignoreDuplicateModules=[]),g.baseUrl.length>0&&(q.Utilities.endsWith(g.baseUrl,"/")||(g.baseUrl+="/")),typeof g.cspNonce!="string"&&(g.cspNonce=""),typeof g.preferScriptTags>"u"&&(g.preferScriptTags=!1),g.nodeCachedData&&typeof g.nodeCachedData=="object"&&(typeof g.nodeCachedData.seed!="string"&&(g.nodeCachedData.seed="seed"),(typeof g.nodeCachedData.writeDelay!="number"||g.nodeCachedData.writeDelay<0)&&(g.nodeCachedData.writeDelay=1e3*7),!g.nodeCachedData.path||typeof g.nodeCachedData.path!="string")){const b=i(new Error("INVALID cached data configuration, 'path' MUST be set"));b.phase="configuration",g.onError(b),g.nodeCachedData=void 0}return g}static mergeConfigurationOptions(g=null,w=null){let b=q.Utilities.recursiveClone(w||{});return q.Utilities.forEachProperty(g,(a,l)=>{a==="ignoreDuplicateModules"&&typeof b.ignoreDuplicateModules<"u"?b.ignoreDuplicateModules=b.ignoreDuplicateModules.concat(l):a==="paths"&&typeof b.paths<"u"?q.Utilities.forEachProperty(l,(f,$)=>b.paths[f]=$):a==="config"&&typeof b.config<"u"?q.Utilities.forEachProperty(l,(f,$)=>b.config[f]=$):b[a]=q.Utilities.recursiveClone(l)}),t.validateConfigurationOptions(b)}}q.ConfigurationOptionsUtil=t;class n{constructor(g,w){if(this._env=g,this.options=t.mergeConfigurationOptions(w),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let b=this.options.nodeRequire.main.filename,a=Math.max(b.lastIndexOf("/"),b.lastIndexOf("\\"));this.options.baseUrl=b.substring(0,a+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let g=0;g<this.options.ignoreDuplicateModules.length;g++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[g]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],q.Utilities.forEachProperty(this.options.paths,(g,w)=>{Array.isArray(w)?this.sortedPathsRules.push({from:g,to:w}):this.sortedPathsRules.push({from:g,to:[w]})}),this.sortedPathsRules.sort((g,w)=>w.from.length-g.from.length)}cloneAndMerge(g){return new n(this._env,t.mergeConfigurationOptions(g,this.options))}getOptionsLiteral(){return this.options}_applyPaths(g){let w;for(let b=0,a=this.sortedPathsRules.length;b<a;b++)if(w=this.sortedPathsRules[b],q.Utilities.startsWith(g,w.from)){let l=[];for(let f=0,$=w.to.length;f<$;f++)l.push(w.to[f]+g.substr(w.from.length));return l}return[g]}_addUrlArgsToUrl(g){return q.Utilities.containsQueryString(g)?g+"&"+this.options.urlArgs:g+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(g){return this.options.urlArgs?this._addUrlArgsToUrl(g):g}_addUrlArgsIfNecessaryToUrls(g){if(this.options.urlArgs)for(let w=0,b=g.length;w<b;w++)g[w]=this._addUrlArgsToUrl(g[w]);return g}moduleIdToPaths(g){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(g))return this.isBuild()?["empty:"]:["node|"+g];let w=g,b;if(!q.Utilities.endsWith(w,".js")&&!q.Utilities.isAbsolutePath(w)){b=this._applyPaths(w);for(let a=0,l=b.length;a<l;a++)this.isBuild()&&b[a]==="empty:"||(q.Utilities.isAbsolutePath(b[a])||(b[a]=this.options.baseUrl+b[a]),!q.Utilities.endsWith(b[a],".js")&&!q.Utilities.containsQueryString(b[a])&&(b[a]=b[a]+".js"))}else!q.Utilities.endsWith(w,".js")&&!q.Utilities.containsQueryString(w)&&(w=w+".js"),b=[w];return this._addUrlArgsIfNecessaryToUrls(b)}requireToUrl(g){let w=g;return q.Utilities.isAbsolutePath(w)||(w=this._applyPaths(w)[0],q.Utilities.isAbsolutePath(w)||(w=this.options.baseUrl+w)),this._addUrlArgsIfNecessaryToUrl(w)}isBuild(){return this.options.isBuild}shouldInvokeFactory(g){return!!(!this.options.isBuild||q.Utilities.isAnonymousModule(g)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[g])}isDuplicateMessageIgnoredFor(g){return this.ignoreDuplicateModulesMap.hasOwnProperty(g)}getConfigForModule(g){if(this.options.config)return this.options.config[g]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(g){this.options.onError(g)}}q.Configuration=n})(Le||(Le={}));var Le;(function(q){class i{constructor(l){this._env=l,this._scriptLoader=null,this._callbackMap={}}load(l,f,$,d){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new p;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=l.getConfig().getOptionsLiteral();e?this._scriptLoader=new t:this._scriptLoader=new g(this._env)}else this._env.isNode?this._scriptLoader=new g(this._env):this._scriptLoader=new t;let E={callback:$,errorback:d};if(this._callbackMap.hasOwnProperty(f)){this._callbackMap[f].push(E);return}this._callbackMap[f]=[E],this._scriptLoader.load(l,f,()=>this.triggerCallback(f),e=>this.triggerErrorback(f,e))}triggerCallback(l){let f=this._callbackMap[l];delete this._callbackMap[l];for(let $=0;$<f.length;$++)f[$].callback()}triggerErrorback(l,f){let $=this._callbackMap[l];delete this._callbackMap[l];for(let d=0;d<$.length;d++)$[d].errorback(f)}}class t{attachListeners(l,f,$){let d=()=>{l.removeEventListener("load",E),l.removeEventListener("error",e)},E=m=>{d(),f()},e=m=>{d(),$(m)};l.addEventListener("load",E),l.addEventListener("error",e)}load(l,f,$,d){if(/^node\|/.test(f)){let E=l.getConfig().getOptionsLiteral(),e=w(l.getRecorder(),E.nodeRequire||q.global.nodeRequire),m=f.split("|"),v=null;try{v=e(m[1])}catch(R){d(R);return}l.enqueueDefineAnonymousModule([],()=>v),$()}else{let E=document.createElement("script");E.setAttribute("async","async"),E.setAttribute("type","text/javascript"),this.attachListeners(E,$,d);const{trustedTypesPolicy:e}=l.getConfig().getOptionsLiteral();e&&(f=e.createScriptURL(f)),E.setAttribute("src",f);const{cspNonce:m}=l.getConfig().getOptionsLiteral();m&&E.setAttribute("nonce",m),document.getElementsByTagName("head")[0].appendChild(E)}}}function n(a){const{trustedTypesPolicy:l}=a.getConfig().getOptionsLiteral();try{return(l?self.eval(l.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class p{constructor(){this._cachedCanUseEval=null}_canUseEval(l){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=n(l)),this._cachedCanUseEval}load(l,f,$,d){if(/^node\|/.test(f)){const E=l.getConfig().getOptionsLiteral(),e=w(l.getRecorder(),E.nodeRequire||q.global.nodeRequire),m=f.split("|");let v=null;try{v=e(m[1])}catch(R){d(R);return}l.enqueueDefineAnonymousModule([],function(){return v}),$()}else{const{trustedTypesPolicy:E}=l.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(l)){fetch(f).then(m=>{if(m.status!==200)throw new Error(m.statusText);return m.text()}).then(m=>{m=`${m}
//# sourceURL=${f}`,(E?self.eval(E.createScript("",m)):new Function(m)).call(self),$()}).then(void 0,d);return}try{E&&(f=E.createScriptURL(f)),importScripts(f),$()}catch(m){d(m)}}}}class g{constructor(l){this._env=l,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(l){this._didInitialize||(this._didInitialize=!0,this._fs=l("fs"),this._vm=l("vm"),this._path=l("path"),this._crypto=l("crypto"))}_initNodeRequire(l,f){const{nodeCachedData:$}=f.getConfig().getOptionsLiteral();if(!$||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const d=this,E=l("module");function e(m){const v=m.constructor;let R=function(L){try{return m.require(L)}finally{}};return R.resolve=function(L,N){return v._resolveFilename(L,m,!1,N)},R.resolve.paths=function(L){return v._resolveLookupPaths(L,m)},R.main=process.mainModule,R.extensions=v._extensions,R.cache=v._cache,R}E.prototype._compile=function(m,v){const R=E.wrap(m.replace(/^#!.*/,"")),A=f.getRecorder(),L=d._getCachedDataPath($,v),N={filename:v};let c;try{const T=d._fs.readFileSync(L);c=T.slice(0,16),N.cachedData=T.slice(16),A.record(60,L)}catch{A.record(61,L)}const u=new d._vm.Script(R,N),s=u.runInThisContext(N),o=d._path.dirname(v),h=e(this),U=[this.exports,h,this,v,o,process,Xe,Buffer],_=s.apply(this.exports,U);return d._handleCachedData(u,R,L,!N.cachedData,f),d._verifyCachedData(u,R,L,c,f),_}}load(l,f,$,d){const E=l.getConfig().getOptionsLiteral(),e=w(l.getRecorder(),E.nodeRequire||q.global.nodeRequire),m=E.nodeInstrumenter||function(R){return R};this._init(e),this._initNodeRequire(e,l);let v=l.getRecorder();if(/^node\|/.test(f)){let R=f.split("|"),A=null;try{A=e(R[1])}catch(L){d(L);return}l.enqueueDefineAnonymousModule([],()=>A),$()}else{f=q.Utilities.fileUriToFilePath(this._env.isWindows,f);const R=this._path.normalize(f),A=this._getElectronRendererScriptPathOrUri(R),L=!!E.nodeCachedData,N=L?this._getCachedDataPath(E.nodeCachedData,f):void 0;this._readSourceAndCachedData(R,N,v,(c,u,s,o)=>{if(c){d(c);return}let h;u.charCodeAt(0)===g._BOM?h=g._PREFIX+u.substring(1)+g._SUFFIX:h=g._PREFIX+u+g._SUFFIX,h=m(h,R);const U={filename:A,cachedData:s},_=this._createAndEvalScript(l,h,U,$,d);this._handleCachedData(_,h,N,L&&!s,l),this._verifyCachedData(_,h,N,o,l)})}}_createAndEvalScript(l,f,$,d,E){const e=l.getRecorder();e.record(31,$.filename);const m=new this._vm.Script(f,$),v=m.runInThisContext($),R=l.getGlobalAMDDefineFunc();let A=!1;const L=function(){return A=!0,R.apply(null,arguments)};return L.amd=R.amd,v.call(q.global,l.getGlobalAMDRequireFunc(),L,$.filename,this._path.dirname($.filename)),e.record(32,$.filename),A?d():E(new Error(`Didn't receive define call in ${$.filename}!`)),m}_getElectronRendererScriptPathOrUri(l){if(!this._env.isElectronRenderer)return l;let f=l.match(/^([a-z])\:(.*)/i);return f?`file:///${(f[1].toUpperCase()+":"+f[2]).replace(/\\/g,"/")}`:`file://${l}`}_getCachedDataPath(l,f){const $=this._crypto.createHash("md5").update(f,"utf8").update(l.seed,"utf8").update(process.arch,"").digest("hex"),d=this._path.basename(f).replace(/\.js$/,"");return this._path.join(l.path,`${d}-${$}.code`)}_handleCachedData(l,f,$,d,E){l.cachedDataRejected?this._fs.unlink($,e=>{E.getRecorder().record(62,$),this._createAndWriteCachedData(l,f,$,E),e&&E.getConfig().onError(e)}):d&&this._createAndWriteCachedData(l,f,$,E)}_createAndWriteCachedData(l,f,$,d){let E=Math.ceil(d.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,m=0,v;const R=()=>{setTimeout(()=>{v||(v=this._crypto.createHash("md5").update(f,"utf8").digest());const A=l.createCachedData();if(!(A.length===0||A.length===e||m>=5)){if(A.length<e){R();return}e=A.length,this._fs.writeFile($,Buffer.concat([v,A]),L=>{L&&d.getConfig().onError(L),d.getRecorder().record(63,$),R()})}},E*Math.pow(4,m++))};R()}_readSourceAndCachedData(l,f,$,d){if(!f)this._fs.readFile(l,{encoding:"utf8"},d);else{let E,e,m,v=2;const R=A=>{A?d(A):--v===0&&d(void 0,E,e,m)};this._fs.readFile(l,{encoding:"utf8"},(A,L)=>{E=L,R(A)}),this._fs.readFile(f,(A,L)=>{!A&&L&&L.length>0?(m=L.slice(0,16),e=L.slice(16),$.record(60,f)):$.record(61,f),R()})}}_verifyCachedData(l,f,$,d,E){d&&(l.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(f,"utf8").digest();d.equals(e)||(E.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${$}' now, but a RESTART IS REQUIRED`)),this._fs.unlink($,m=>{m&&E.getConfig().onError(m)}))},Math.ceil(5e3*(1+Math.random()))))}}g._BOM=65279,g._PREFIX="(function (require, define, __filename, __dirname) { ",g._SUFFIX=`
});`;function w(a,l){if(l.__$__isRecorded)return l;const f=function(d){a.record(33,d);try{return l(d)}finally{a.record(34,d)}};return f.__$__isRecorded=!0,f}q.ensureRecordedNodeRequire=w;function b(a){return new i(a)}q.createScriptLoader=b})(Le||(Le={}));var Le;(function(q){class i{constructor(a){let l=a.lastIndexOf("/");l!==-1?this.fromModulePath=a.substr(0,l+1):this.fromModulePath=""}static _normalizeModuleId(a){let l=a,f;for(f=/\/\.\//;f.test(l);)l=l.replace(f,"/");for(l=l.replace(/^\.\//g,""),f=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;f.test(l);)l=l.replace(f,"/");return l=l.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),l}resolveModule(a){let l=a;return q.Utilities.isAbsolutePath(l)||(q.Utilities.startsWith(l,"./")||q.Utilities.startsWith(l,"../"))&&(l=i._normalizeModuleId(this.fromModulePath+l)),l}}i.ROOT=new i(""),q.ModuleIdResolver=i;class t{constructor(a,l,f,$,d,E){this.id=a,this.strId=l,this.dependencies=f,this._callback=$,this._errorback=d,this.moduleIdResolver=E,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(a,l){try{return{returnedValue:a.apply(q.global,l),producedError:null}}catch(f){return{returnedValue:null,producedError:f}}}static _invokeFactory(a,l,f,$){return a.shouldInvokeFactory(l)?a.shouldCatchError()?this._safeInvokeFunction(f,$):{returnedValue:f.apply(q.global,$),producedError:null}:{returnedValue:null,producedError:null}}complete(a,l,f,$){this._isComplete=!0;let d=null;if(this._callback)if(typeof this._callback=="function"){a.record(21,this.strId);let E=t._invokeFactory(l,this.strId,this._callback,f);d=E.producedError,a.record(22,this.strId),!d&&typeof E.returnedValue<"u"&&(!this.exportsPassedIn||q.Utilities.isEmpty(this.exports))&&(this.exports=E.returnedValue)}else this.exports=this._callback;if(d){let E=q.ensureError(d);E.phase="factory",E.moduleId=this.strId,E.neededBy=$(this.id),this.error=E,l.onError(E)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(a){return this._isComplete=!0,this.error=a,this._errorback?(this._errorback(a),!0):!1}isComplete(){return this._isComplete}}q.Module=t;class n{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(a){let l=this._strModuleIdToIntModuleId.get(a);return typeof l>"u"&&(l=this._nextId++,this._strModuleIdToIntModuleId.set(a,l),this._intModuleIdToStrModuleId[l]=a),l}getStrModuleId(a){return this._intModuleIdToStrModuleId[a]}}class p{constructor(a){this.id=a}}p.EXPORTS=new p(0),p.MODULE=new p(1),p.REQUIRE=new p(2),q.RegularDependency=p;class g{constructor(a,l,f){this.id=a,this.pluginId=l,this.pluginParam=f}}q.PluginDependency=g;class w{constructor(a,l,f,$,d=0){this._env=a,this._scriptLoader=l,this._loaderAvailableTimestamp=d,this._defineFunc=f,this._requireFunc=$,this._moduleIdProvider=new n,this._config=new q.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[],this._requireFunc.moduleManager=this}reset(){return new w(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(a,l){let f=E=>E.replace(/\\/g,"/"),$=f(a),d=l.split(/\n/);for(let E=0;E<d.length;E++){let e=d[E].match(/(.*):(\d+):(\d+)\)?$/);if(e){let m=e[1],v=e[2],R=e[3],A=Math.max(m.lastIndexOf(" ")+1,m.lastIndexOf("(")+1);if(m=m.substr(A),m=f(m),m===$){let L={line:parseInt(v,10),col:parseInt(R,10)};return L.line===1&&(L.col-=53),L}}}throw new Error("Could not correlate define call site for needle "+a)}getBuildInfo(){if(!this._config.isBuild())return null;let a=[],l=0;for(let f=0,$=this._modules2.length;f<$;f++){let d=this._modules2[f];if(!d)continue;let E=this._buildInfoPath[d.id]||null,e=this._buildInfoDefineStack[d.id]||null,m=this._buildInfoDependencies[d.id];a[l++]={id:d.strId,path:E,defineLocation:E&&e?w._findRelevantLocationInStack(E,e):null,dependencies:m,shim:null,exports:d.exports}}return a}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new q.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=q.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(a,l){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let f=null;this._config.isBuild()&&(f=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:f,dependencies:a,callback:l}}defineModule(a,l,f,$,d,E=new i(a)){let e=this._moduleIdProvider.getModuleId(a);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(a)||console.warn("Duplicate definition of module '"+a+"'");return}let m=new t(e,a,this._normalizeDependencies(l,E),f,$,E);this._modules2[e]=m,this._config.isBuild()&&(this._buildInfoDefineStack[e]=d,this._buildInfoDependencies[e]=(m.dependencies||[]).map(v=>this._moduleIdProvider.getStrModuleId(v.id))),this._resolve(m)}_normalizeDependency(a,l){if(a==="exports")return p.EXPORTS;if(a==="module")return p.MODULE;if(a==="require")return p.REQUIRE;let f=a.indexOf("!");if(f>=0){let $=l.resolveModule(a.substr(0,f)),d=l.resolveModule(a.substr(f+1)),E=this._moduleIdProvider.getModuleId($+"!"+d),e=this._moduleIdProvider.getModuleId($);return new g(E,e,d)}return new p(this._moduleIdProvider.getModuleId(l.resolveModule(a)))}_normalizeDependencies(a,l){let f=[],$=0;for(let d=0,E=a.length;d<E;d++)f[$++]=this._normalizeDependency(a[d],l);return f}_relativeRequire(a,l,f,$){if(typeof l=="string")return this.synchronousRequire(l,a);this.defineModule(q.Utilities.generateAnonymousModule(),l,f,$,null,a)}synchronousRequire(a,l=new i(a)){let f=this._normalizeDependency(a,l),$=this._modules2[f.id];if(!$)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This is the first mention of this module!");if(!$.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+a+"'. This module has not been resolved completely yet.");if($.error)throw $.error;return $.exports}configure(a,l){let f=this._config.shouldRecordStats();l?this._config=new q.Configuration(this._env,a):this._config=this._config.cloneAndMerge(a),this._config.shouldRecordStats()&&!f&&(this._recorder=null)}getConfig(){return this._config}_onLoad(a){if(this._currentAnonymousDefineCall!==null){let l=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(a),l.dependencies,l.callback,null,l.stack)}}_createLoadError(a,l){let f=this._moduleIdProvider.getStrModuleId(a),$=(this._inverseDependencies2[a]||[]).map(E=>this._moduleIdProvider.getStrModuleId(E));const d=q.ensureError(l);return d.phase="loading",d.moduleId=f,d.neededBy=$,d}_onLoadError(a,l){const f=this._createLoadError(a,l);this._modules2[a]||(this._modules2[a]=new t(a,this._moduleIdProvider.getStrModuleId(a),[],()=>{},null,null));let $=[];for(let e=0,m=this._moduleIdProvider.getMaxModuleId();e<m;e++)$[e]=!1;let d=!1,E=[];for(E.push(a),$[a]=!0;E.length>0;){let e=E.shift(),m=this._modules2[e];m&&(d=m.onDependencyError(f)||d);let v=this._inverseDependencies2[e];if(v)for(let R=0,A=v.length;R<A;R++){let L=v[R];$[L]||(E.push(L),$[L]=!0)}}d||this._config.onError(f)}_hasDependencyPath(a,l){let f=this._modules2[a];if(!f)return!1;let $=[];for(let E=0,e=this._moduleIdProvider.getMaxModuleId();E<e;E++)$[E]=!1;let d=[];for(d.push(f),$[a]=!0;d.length>0;){let e=d.shift().dependencies;if(e)for(let m=0,v=e.length;m<v;m++){let R=e[m];if(R.id===l)return!0;let A=this._modules2[R.id];A&&!$[R.id]&&($[R.id]=!0,d.push(A))}}return!1}_findCyclePath(a,l,f){if(a===l||f===50)return[a];let $=this._modules2[a];if(!$)return null;let d=$.dependencies;if(d)for(let E=0,e=d.length;E<e;E++){let m=this._findCyclePath(d[E].id,l,f+1);if(m!==null)return m.push(a),m}return null}_createRequire(a){let l=(f,$,d)=>this._relativeRequire(a,f,$,d);return l.toUrl=f=>this._config.requireToUrl(a.resolveModule(f)),l.getStats=()=>this.getLoaderEvents(),l.hasDependencyCycle=()=>this._hasDependencyCycle,l.config=(f,$=!1)=>{this.configure(f,$)},l.__$__nodeRequire=q.global.nodeRequire,l}_loadModule(a){if(this._modules2[a]||this._knownModules2[a])return;this._knownModules2[a]=!0;let l=this._moduleIdProvider.getStrModuleId(a),f=this._config.moduleIdToPaths(l),$=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(l.indexOf("/")===-1||$.test(l))&&f.push("node|"+l);let d=-1,E=e=>{if(d++,d>=f.length)this._onLoadError(a,e);else{let m=f[d],v=this.getRecorder();if(this._config.isBuild()&&m==="empty:"){this._buildInfoPath[a]=m,this.defineModule(this._moduleIdProvider.getStrModuleId(a),[],null,null,null),this._onLoad(a);return}v.record(10,m),this._scriptLoader.load(this,m,()=>{this._config.isBuild()&&(this._buildInfoPath[a]=m),v.record(11,m),this._onLoad(a)},R=>{v.record(12,m),E(R)})}};E(null)}_loadPluginDependency(a,l){if(this._modules2[l.id]||this._knownModules2[l.id])return;this._knownModules2[l.id]=!0;let f=$=>{this.defineModule(this._moduleIdProvider.getStrModuleId(l.id),[],$,null,null)};f.error=$=>{this._config.onError(this._createLoadError(l.id,$))},a.load(l.pluginParam,this._createRequire(i.ROOT),f,this._config.getOptionsLiteral())}_resolve(a){let l=a.dependencies;if(l)for(let f=0,$=l.length;f<$;f++){let d=l[f];if(d===p.EXPORTS){a.exportsPassedIn=!0,a.unresolvedDependenciesCount--;continue}if(d===p.MODULE){a.unresolvedDependenciesCount--;continue}if(d===p.REQUIRE){a.unresolvedDependenciesCount--;continue}let E=this._modules2[d.id];if(E&&E.isComplete()){if(E.error){a.onDependencyError(E.error);return}a.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(d.id,a.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(d.id)+"' and '"+this._moduleIdProvider.getStrModuleId(a.id)+"'. The cyclic path follows:");let e=this._findCyclePath(d.id,a.id,0)||[];e.reverse(),e.push(d.id),console.warn(e.map(m=>this._moduleIdProvider.getStrModuleId(m)).join(` => 
`)),a.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[d.id]=this._inverseDependencies2[d.id]||[],this._inverseDependencies2[d.id].push(a.id),d instanceof g){let e=this._modules2[d.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,d);continue}let m=this._inversePluginDependencies2.get(d.pluginId);m||(m=[],this._inversePluginDependencies2.set(d.pluginId,m)),m.push(d),this._loadModule(d.pluginId);continue}this._loadModule(d.id)}a.unresolvedDependenciesCount===0&&this._onModuleComplete(a)}_onModuleComplete(a){let l=this.getRecorder();if(a.isComplete())return;let f=a.dependencies,$=[];if(f)for(let m=0,v=f.length;m<v;m++){let R=f[m];if(R===p.EXPORTS){$[m]=a.exports;continue}if(R===p.MODULE){$[m]={id:a.strId,config:()=>this._config.getConfigForModule(a.strId)};continue}if(R===p.REQUIRE){$[m]=this._createRequire(a.moduleIdResolver);continue}let A=this._modules2[R.id];if(A){$[m]=A.exports;continue}$[m]=null}const d=m=>(this._inverseDependencies2[m]||[]).map(v=>this._moduleIdProvider.getStrModuleId(v));a.complete(l,this._config,$,d);let E=this._inverseDependencies2[a.id];if(this._inverseDependencies2[a.id]=null,E)for(let m=0,v=E.length;m<v;m++){let R=E[m],A=this._modules2[R];A.unresolvedDependenciesCount--,A.unresolvedDependenciesCount===0&&this._onModuleComplete(A)}let e=this._inversePluginDependencies2.get(a.id);if(e){this._inversePluginDependencies2.delete(a.id);for(let m=0,v=e.length;m<v;m++)this._loadPluginDependency(a.exports,e[m])}}}q.ModuleManager=w})(Le||(Le={}));var ne,Le;(function(q){const i=new q.Environment;let t=null;const n=function(b,a,l){typeof b!="string"&&(l=a,a=b,b=null),(typeof a!="object"||!Array.isArray(a))&&(l=a,a=null),a||(a=["require","exports","module"]),b?t.defineModule(b,a,l,null,null):t.enqueueDefineAnonymousModule(a,l)};n.amd={jQuery:!0};const p=function(b,a=!1){t.configure(b,a)},g=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){p(arguments[0]);return}if(typeof arguments[0]=="string")return t.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){t.defineModule(q.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};g.config=p,g.getConfig=function(){return t.getConfig().getOptionsLiteral()},g.reset=function(){t=t.reset()},g.getBuildInfo=function(){return t.getBuildInfo()},g.getStats=function(){return t.getLoaderEvents()},g.define=n;function w(){if(typeof q.global.require<"u"||typeof require<"u"){const b=q.global.require||require;if(typeof b=="function"&&typeof b.resolve=="function"){const a=q.ensureRecordedNodeRequire(t.getRecorder(),b);q.global.nodeRequire=a,g.nodeRequire=a,g.__$__nodeRequire=a}}i.isNode&&!i.isElectronRenderer&&!i.isElectronNodeIntegrationWebWorker?module.exports=g:(i.isElectronRenderer||(q.global.define=n),q.global.require=g)}q.init=w,(typeof q.global.define!="function"||!q.global.define.amd)&&(t=new q.ModuleManager(i,q.createScriptLoader(i),n,g,q.Utilities.getHighPerformanceTimestamp()),typeof q.global.require<"u"&&typeof q.global.require!="function"&&g.config(q.global.require),ne=function(){return n.apply(null,arguments)},ne.amd=n.amd,typeof doNotInitLoader>"u"&&w())})(Le||(Le={})),ne(ie[75],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.load=t;function t(b,a,l,f){if(f=f||{},(f["vs/css"]||{}).disabled){l({});return}const d=a.toUrl(b+".css");n(b,d,()=>{l({})},E=>{typeof l.error=="function"&&l.error("Could not find "+d+".")})}function n(b,a,l,f){if(p(b,a)){l();return}g(b,a,l,f)}function p(b,a){const l=window.document.getElementsByTagName("link");for(let f=0,$=l.length;f<$;f++){const d=l[f].getAttribute("data-name"),E=l[f].getAttribute("href");if(d===b||E===a)return!0}return!1}function g(b,a,l,f){const $=document.createElement("link");$.setAttribute("rel","stylesheet"),$.setAttribute("type","text/css"),$.setAttribute("data-name",b),w(b,$,l,f),$.setAttribute("href",a),(window.document.head||window.document.getElementsByTagName("head")[0]).appendChild($)}function w(b,a,l,f){const $=()=>{a.removeEventListener("load",d),a.removeEventListener("error",E)},d=e=>{$(),l()},E=e=>{$(),f(e)};a.addEventListener("load",d),a.addEventListener("error",E)}}),ne("vs/nls",["require","exports"],function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localize=f,i.localize2=$,i.getConfiguredDefaultLocale=d,i.setPseudoTranslation=E,i.create=e,i.load=m;let t=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const n="i-default";function p(v,R){let A;return R.length===0?A=v:A=v.replace(/\{(\d+)\}/g,(L,N)=>{const c=N[0],u=R[c];let s=L;return typeof u=="string"?s=u:(typeof u=="number"||typeof u=="boolean"||u===void 0||u===null)&&(s=String(u)),s}),t&&(A="\uFF3B"+A.replace(/[aouei]/g,"$&$&")+"\uFF3D"),A}function g(v,R){let A=v[R];return A||(A=v["*"],A)?A:null}function w(v){return v.charAt(v.length-1)==="/"?v:v+"/"}async function b(v,R,A){const L=w(v)+w(R)+"vscode/"+w(A),N=await fetch(L);if(N.ok)return await N.json();throw new Error(`${N.status} - ${N.statusText}`)}function a(v){return function(R,A){const L=Array.prototype.slice.call(arguments,2);return p(v[R],L)}}function l(v){return(R,A,...L)=>({value:p(v[R],L),original:p(A,L)})}function f(v,R,...A){return p(R,A)}function $(v,R,...A){const L=p(R,A);return{value:L,original:L}}function d(v){}function E(v){t=v}function e(v,R){return{localize:a(R[v]),localize2:l(R[v]),getConfiguredDefaultLocale:R.getConfiguredDefaultLocale??(A=>{})}}function m(v,R,A,L){const N=L["vs/nls"]??{};if(!v||v.length===0)return A({localize:f,localize2:$,getConfiguredDefaultLocale:()=>N.availableLanguages?.["*"]});const c=N.availableLanguages?g(N.availableLanguages,v):null,u=c===null||c===n;let s=".nls";u||(s=s+"."+c);const o=h=>{Array.isArray(h)?(h.localize=a(h),h.localize2=l(h)):(h.localize=a(h[v]),h.localize2=l(h[v])),h.getConfiguredDefaultLocale=()=>N.availableLanguages?.["*"],A(h)};typeof N.loadBundle=="function"?N.loadBundle(v,c,(h,U)=>{h?R([v+".nls"],o):o(U)}):N.translationServiceUrl&&!u?(async()=>{try{const h=await b(N.translationServiceUrl,c,v);return o(h)}catch(h){if(!c.includes("-"))return console.error(h),R([v+".nls"],o);try{const U=c.split("-")[0],_=await b(N.translationServiceUrl,U,v);return N.availableLanguages??(N.availableLanguages={}),N.availableLanguages["*"]=U,o(_)}catch(U){return console.error(U),R([v+".nls"],o)}}})():R([v+s],o,h=>{if(s===".nls"){console.error("Failed trying to load default language strings",h);return}console.error(`Failed to load message bundle for language ${c}. Falling back to the default language:`,h),R([v+".nls"],o)})}}),function(){const q=globalThis.MonacoEnvironment,i=q&&q.baseUrl?q.baseUrl:"../../../";function t(f,$){if(q?.createTrustedTypesPolicy)try{return q.createTrustedTypesPolicy(f,$)}catch(d){console.warn(d);return}try{return self.trustedTypes?.createPolicy(f,$)}catch(d){console.warn(d);return}}const n=t("amdLoader",{createScriptURL:f=>f,createScript:(f,...$)=>{const d=$.slice(0,-1).join(","),E=$.pop().toString();return`(function anonymous(${d}) { ${E}
})`}});function p(){try{return(n?globalThis.eval(n.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function g(){return new Promise((f,$)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return f();const d=i+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(d)&&d.substring(0,globalThis.origin.length)!==globalThis.origin)&&p()){fetch(d).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${d}`,(n?globalThis.eval(n.createScript("",e)):new Function(e)).call(globalThis),f()}).then(void 0,$);return}n?importScripts(n.createScriptURL(d)):importScripts(d),f()})}function w(){require.config({baseUrl:i,catchError:!0,trustedTypesPolicy:n,amdModulesPattern:/^vs\//})}function b(f){g().then(()=>{w(),require([f],function($){setTimeout(function(){const d=$.create((E,e)=>{globalThis.postMessage(E,e)},null);for(globalThis.onmessage=E=>d.onmessage(E.data,E.ports);l.length>0;){const E=l.shift();d.onmessage(E.data,E.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&w();let a=!0;const l=[];globalThis.onmessage=f=>{if(!a){l.push(f);return}a=!1,b(f.data)}}(),ne(ie[9],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$mb=void 0,i.$fb=t,i.$gb=n,i.$hb=p,i.$ib=g,i.$jb=w,i.$kb=b,i.$lb=a,i.$nb=f,i.$ob=$,i.$pb=d,i.$qb=E,i.$rb=e;function t(m,v){const R=n(m,v);if(R!==-1)return m[R]}function n(m,v,R=m.length-1){for(let A=R;A>=0;A--){const L=m[A];if(v(L))return A}return-1}function p(m,v){const R=g(m,v);return R===-1?void 0:m[R]}function g(m,v,R=0,A=m.length){let L=R,N=A;for(;L<N;){const c=Math.floor((L+N)/2);v(m[c])?L=c+1:N=c}return L-1}function w(m,v){const R=b(m,v);return R===m.length?void 0:m[R]}function b(m,v,R=0,A=m.length){let L=R,N=A;for(;L<N;){const c=Math.floor((L+N)/2);v(m[c])?N=c:L=c+1}return L}function a(m,v,R=0,A=m.length){const L=b(m,v,R,A);return L===m.length?-1:L}class l{constructor(v){this.e=v,this.c=0}findLastMonotonous(v){if(l.assertInvariants){if(this.d){for(const A of this.e)if(this.d(A)&&!v(A))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=v}const R=g(this.e,v,this.c);return this.c=R+1,R===-1?void 0:this.e[R]}}i.$mb=l,l.assertInvariants=!1;function f(m,v){if(m.length===0)return;let R=m[0];for(let A=1;A<m.length;A++){const L=m[A];v(L,R)>0&&(R=L)}return R}function $(m,v){if(m.length===0)return;let R=m[0];for(let A=1;A<m.length;A++){const L=m[A];v(L,R)>=0&&(R=L)}return R}function d(m,v){return f(m,(R,A)=>-v(R,A))}function E(m,v){if(m.length===0)return-1;let R=0;for(let A=1;A<m.length;A++){const L=m[A];v(L,m[R])>0&&(R=A)}return R}function e(m,v){for(const R of m){const A=v(R);if(A!==void 0)return A}}}),ne(ie[3],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.CharCode=void 0;var t;(function(n){n[n.Null=0]="Null",n[n.Backspace=8]="Backspace",n[n.Tab=9]="Tab",n[n.LineFeed=10]="LineFeed",n[n.CarriageReturn=13]="CarriageReturn",n[n.Space=32]="Space",n[n.ExclamationMark=33]="ExclamationMark",n[n.DoubleQuote=34]="DoubleQuote",n[n.Hash=35]="Hash",n[n.DollarSign=36]="DollarSign",n[n.PercentSign=37]="PercentSign",n[n.Ampersand=38]="Ampersand",n[n.SingleQuote=39]="SingleQuote",n[n.OpenParen=40]="OpenParen",n[n.CloseParen=41]="CloseParen",n[n.Asterisk=42]="Asterisk",n[n.Plus=43]="Plus",n[n.Comma=44]="Comma",n[n.Dash=45]="Dash",n[n.Period=46]="Period",n[n.Slash=47]="Slash",n[n.Digit0=48]="Digit0",n[n.Digit1=49]="Digit1",n[n.Digit2=50]="Digit2",n[n.Digit3=51]="Digit3",n[n.Digit4=52]="Digit4",n[n.Digit5=53]="Digit5",n[n.Digit6=54]="Digit6",n[n.Digit7=55]="Digit7",n[n.Digit8=56]="Digit8",n[n.Digit9=57]="Digit9",n[n.Colon=58]="Colon",n[n.Semicolon=59]="Semicolon",n[n.LessThan=60]="LessThan",n[n.Equals=61]="Equals",n[n.GreaterThan=62]="GreaterThan",n[n.QuestionMark=63]="QuestionMark",n[n.AtSign=64]="AtSign",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.OpenSquareBracket=91]="OpenSquareBracket",n[n.Backslash=92]="Backslash",n[n.CloseSquareBracket=93]="CloseSquareBracket",n[n.Caret=94]="Caret",n[n.Underline=95]="Underline",n[n.BackTick=96]="BackTick",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.OpenCurlyBrace=123]="OpenCurlyBrace",n[n.Pipe=124]="Pipe",n[n.CloseCurlyBrace=125]="CloseCurlyBrace",n[n.Tilde=126]="Tilde",n[n.NoBreakSpace=160]="NoBreakSpace",n[n.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",n[n.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",n[n.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",n[n.U_Combining_Tilde=771]="U_Combining_Tilde",n[n.U_Combining_Macron=772]="U_Combining_Macron",n[n.U_Combining_Overline=773]="U_Combining_Overline",n[n.U_Combining_Breve=774]="U_Combining_Breve",n[n.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",n[n.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",n[n.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",n[n.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",n[n.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",n[n.U_Combining_Caron=780]="U_Combining_Caron",n[n.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",n[n.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",n[n.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",n[n.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",n[n.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",n[n.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",n[n.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",n[n.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",n[n.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",n[n.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",n[n.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",n[n.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",n[n.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",n[n.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",n[n.U_Combining_Horn=795]="U_Combining_Horn",n[n.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",n[n.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",n[n.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",n[n.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",n[n.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",n[n.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",n[n.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",n[n.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",n[n.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",n[n.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",n[n.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",n[n.U_Combining_Cedilla=807]="U_Combining_Cedilla",n[n.U_Combining_Ogonek=808]="U_Combining_Ogonek",n[n.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",n[n.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",n[n.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",n[n.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",n[n.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",n[n.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",n[n.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",n[n.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",n[n.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",n[n.U_Combining_Low_Line=818]="U_Combining_Low_Line",n[n.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",n[n.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",n[n.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",n[n.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",n[n.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",n[n.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",n[n.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",n[n.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",n[n.U_Combining_Square_Below=827]="U_Combining_Square_Below",n[n.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",n[n.U_Combining_X_Above=829]="U_Combining_X_Above",n[n.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",n[n.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",n[n.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",n[n.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",n[n.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",n[n.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",n[n.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",n[n.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",n[n.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",n[n.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",n[n.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",n[n.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",n[n.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",n[n.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",n[n.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",n[n.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",n[n.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",n[n.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",n[n.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",n[n.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",n[n.U_Combining_Fermata=850]="U_Combining_Fermata",n[n.U_Combining_X_Below=851]="U_Combining_X_Below",n[n.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",n[n.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",n[n.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",n[n.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",n[n.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",n[n.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",n[n.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",n[n.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",n[n.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",n[n.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",n[n.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",n[n.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",n[n.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",n[n.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",n[n.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",n[n.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",n[n.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",n[n.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",n[n.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",n[n.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",n[n.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",n[n.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",n[n.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",n[n.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",n[n.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",n[n.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",n[n.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",n[n.LINE_SEPARATOR=8232]="LINE_SEPARATOR",n[n.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",n[n.NEXT_LINE=133]="NEXT_LINE",n[n.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",n[n.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",n[n.U_DIAERESIS=168]="U_DIAERESIS",n[n.U_MACRON=175]="U_MACRON",n[n.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",n[n.U_CEDILLA=184]="U_CEDILLA",n[n.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",n[n.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",n[n.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",n[n.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",n[n.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",n[n.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",n[n.U_BREVE=728]="U_BREVE",n[n.U_DOT_ABOVE=729]="U_DOT_ABOVE",n[n.U_RING_ABOVE=730]="U_RING_ABOVE",n[n.U_OGONEK=731]="U_OGONEK",n[n.U_SMALL_TILDE=732]="U_SMALL_TILDE",n[n.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",n[n.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",n[n.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",n[n.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",n[n.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",n[n.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",n[n.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",n[n.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",n[n.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",n[n.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",n[n.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",n[n.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",n[n.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",n[n.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",n[n.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",n[n.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",n[n.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",n[n.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",n[n.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",n[n.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",n[n.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",n[n.U_GREEK_TONOS=900]="U_GREEK_TONOS",n[n.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",n[n.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",n[n.U_GREEK_PSILI=8127]="U_GREEK_PSILI",n[n.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",n[n.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",n[n.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",n[n.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",n[n.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",n[n.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",n[n.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",n[n.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",n[n.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",n[n.U_GREEK_VARIA=8175]="U_GREEK_VARIA",n[n.U_GREEK_OXIA=8189]="U_GREEK_OXIA",n[n.U_GREEK_DASIA=8190]="U_GREEK_DASIA",n[n.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",n[n.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",n[n.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",n[n.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",n[n.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",n[n.U_OVERLINE=8254]="U_OVERLINE",n[n.UTF8_BOM=65279]="UTF8_BOM",n[n.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",n[n.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(t||(i.CharCode=t={}))}),ne(ie[37],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$E=t,i.$F=n,i.$G=p,i.$H=g;function t(w,b){const a=Object.create(null);for(const l of w){const f=b(l);let $=a[f];$||($=a[f]=[]),$.push(l)}return a}function n(w,b){const a=[],l=[];for(const f of w)b.has(f)||a.push(f);for(const f of b)w.has(f)||l.push(f);return{removed:a,added:l}}function p(w,b){const a=[],l=[];for(const[f,$]of w)b.has(f)||a.push($);for(const[f,$]of b)w.has(f)||l.push($);return{removed:a,added:l}}function g(w,b){const a=new Set;for(const l of b)w.has(l)&&a.add(l);return a}}),ne(ie[38],re([0,1,3]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$8s=i.$7s=i.$6s=i.$5s=void 0;function n(a,l){const f=Math.pow(10,l);return Math.round(a*f)/f}class p{constructor(l,f,$,d=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,l))|0,this.g=Math.min(255,Math.max(0,f))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=n(Math.max(Math.min(1,d),0),3)}static equals(l,f){return l.r===f.r&&l.g===f.g&&l.b===f.b&&l.a===f.a}}i.$5s=p;class g{constructor(l,f,$,d){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=n(Math.max(Math.min(1,f),0),3),this.l=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,d),0),3)}static equals(l,f){return l.h===f.h&&l.s===f.s&&l.l===f.l&&l.a===f.a}static fromRGBA(l){const f=l.r/255,$=l.g/255,d=l.b/255,E=l.a,e=Math.max(f,$,d),m=Math.min(f,$,d);let v=0,R=0;const A=(m+e)/2,L=e-m;if(L>0){switch(R=Math.min(A<=.5?L/(2*A):L/(2-2*A),1),e){case f:v=($-d)/L+($<d?6:0);break;case $:v=(d-f)/L+2;break;case d:v=(f-$)/L+4;break}v*=60,v=Math.round(v)}return new g(v,R,A,E)}static i(l,f,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?l+(f-l)*6*$:$<1/2?f:$<2/3?l+(f-l)*(2/3-$)*6:l}static toRGBA(l){const f=l.h/360,{s:$,l:d,a:E}=l;let e,m,v;if($===0)e=m=v=d;else{const R=d<.5?d*(1+$):d+$-d*$,A=2*d-R;e=g.i(A,R,f+1/3),m=g.i(A,R,f),v=g.i(A,R,f-1/3)}return new p(Math.round(e*255),Math.round(m*255),Math.round(v*255),E)}}i.$6s=g;class w{constructor(l,f,$,d){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,l),0)|0,this.s=n(Math.max(Math.min(1,f),0),3),this.v=n(Math.max(Math.min(1,$),0),3),this.a=n(Math.max(Math.min(1,d),0),3)}static equals(l,f){return l.h===f.h&&l.s===f.s&&l.v===f.v&&l.a===f.a}static fromRGBA(l){const f=l.r/255,$=l.g/255,d=l.b/255,E=Math.max(f,$,d),e=Math.min(f,$,d),m=E-e,v=E===0?0:m/E;let R;return m===0?R=0:E===f?R=(($-d)/m%6+6)%6:E===$?R=(d-f)/m+2:R=(f-$)/m+4,new w(Math.round(R*60),v,E,l.a)}static toRGBA(l){const{h:f,s:$,v:d,a:E}=l,e=d*$,m=e*(1-Math.abs(f/60%2-1)),v=d-e;let[R,A,L]=[0,0,0];return f<60?(R=e,A=m):f<120?(R=m,A=e):f<180?(A=e,L=m):f<240?(A=m,L=e):f<300?(R=m,L=e):f<=360&&(R=e,L=m),R=Math.round((R+v)*255),A=Math.round((A+v)*255),L=Math.round((L+v)*255),new p(R,A,L,E)}}i.$7s=w;class b{static fromHex(l){return b.Format.CSS.parseHex(l)||b.red}static equals(l,f){return!l&&!f?!0:!l||!f?!1:l.equals(f)}get hsla(){return this.i?this.i:g.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:w.fromRGBA(this.rgba)}constructor(l){if(l)if(l instanceof p)this.rgba=l;else if(l instanceof g)this.i=l,this.rgba=g.toRGBA(l);else if(l instanceof w)this.j=l,this.rgba=w.toRGBA(l);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(l){return!!l&&p.equals(this.rgba,l.rgba)&&g.equals(this.hsla,l.hsla)&&w.equals(this.hsva,l.hsva)}getRelativeLuminance(){const l=b.k(this.rgba.r),f=b.k(this.rgba.g),$=b.k(this.rgba.b),d=.2126*l+.7152*f+.0722*$;return n(d,4)}static k(l){const f=l/255;return f<=.03928?f/12.92:Math.pow((f+.055)/1.055,2.4)}getContrastRatio(l){const f=this.getRelativeLuminance(),$=l.getRelativeLuminance();return f>$?(f+.05)/($+.05):($+.05)/(f+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(l){const f=this.getRelativeLuminance(),$=l.getRelativeLuminance();return f>$}isDarkerThan(l){const f=this.getRelativeLuminance(),$=l.getRelativeLuminance();return f<$}lighten(l){return new b(new g(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*l,this.hsla.a))}darken(l){return new b(new g(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*l,this.hsla.a))}transparent(l){const{r:f,g:$,b:d,a:E}=this.rgba;return new b(new p(f,$,d,E*l))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new b(new p(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(l){const f=l.rgba,$=this.rgba.a,d=f.a,E=$+d*(1-$);if(E<1e-6)return b.transparent;const e=this.rgba.r*$/E+f.r*d*(1-$)/E,m=this.rgba.g*$/E+f.g*d*(1-$)/E,v=this.rgba.b*$/E+f.b*d*(1-$)/E;return new b(new p(e,m,v,E))}makeOpaque(l){if(this.isOpaque()||l.rgba.a!==1)return this;const{r:f,g:$,b:d,a:E}=this.rgba;return new b(new p(l.rgba.r-E*(l.rgba.r-f),l.rgba.g-E*(l.rgba.g-$),l.rgba.b-E*(l.rgba.b-d),1))}flatten(...l){const f=l.reduceRight(($,d)=>b.o(d,$));return b.o(this,f)}static o(l,f){const $=1-l.rgba.a;return new b(new p($*f.rgba.r+l.rgba.a*l.rgba.r,$*f.rgba.g+l.rgba.a*l.rgba.g,$*f.rgba.b+l.rgba.a*l.rgba.b))}toString(){return this.u||(this.u=b.Format.CSS.format(this)),this.u}static getLighterColor(l,f,$){if(l.isLighterThan(f))return l;$=$||.5;const d=l.getRelativeLuminance(),E=f.getRelativeLuminance();return $=$*(E-d)/E,l.lighten($)}static getDarkerColor(l,f,$){if(l.isDarkerThan(f))return l;$=$||.5;const d=l.getRelativeLuminance(),E=f.getRelativeLuminance();return $=$*(d-E)/d,l.darken($)}}i.$8s=b,b.white=new b(new p(255,255,255,1)),b.black=new b(new p(0,0,0,1)),b.red=new b(new p(255,0,0,1)),b.blue=new b(new p(0,0,255,1)),b.green=new b(new p(0,255,0,1)),b.cyan=new b(new p(0,255,255,1)),b.lightgrey=new b(new p(211,211,211,1)),b.transparent=new b(new p(0,0,0,0)),function(a){let l;(function(f){let $;(function(d){function E(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:a.Format.CSS.formatRGBA(s)}d.formatRGB=E;function e(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}d.formatRGBA=e;function m(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:a.Format.CSS.formatHSLA(s)}d.formatHSL=m;function v(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}d.formatHSLA=v;function R(s){const o=s.toString(16);return o.length!==2?"0"+o:o}function A(s){return`#${R(s.rgba.r)}${R(s.rgba.g)}${R(s.rgba.b)}`}d.formatHex=A;function L(s,o=!1){return o&&s.rgba.a===1?a.Format.CSS.formatHex(s):`#${R(s.rgba.r)}${R(s.rgba.g)}${R(s.rgba.b)}${R(Math.round(s.rgba.a*255))}`}d.formatHexA=L;function N(s){return s.isOpaque()?a.Format.CSS.formatHex(s):a.Format.CSS.formatRGBA(s)}d.format=N;function c(s){const o=s.length;if(o===0||s.charCodeAt(0)!==t.CharCode.Hash)return null;if(o===7){const h=16*u(s.charCodeAt(1))+u(s.charCodeAt(2)),U=16*u(s.charCodeAt(3))+u(s.charCodeAt(4)),_=16*u(s.charCodeAt(5))+u(s.charCodeAt(6));return new a(new p(h,U,_,1))}if(o===9){const h=16*u(s.charCodeAt(1))+u(s.charCodeAt(2)),U=16*u(s.charCodeAt(3))+u(s.charCodeAt(4)),_=16*u(s.charCodeAt(5))+u(s.charCodeAt(6)),T=16*u(s.charCodeAt(7))+u(s.charCodeAt(8));return new a(new p(h,U,_,T/255))}if(o===4){const h=u(s.charCodeAt(1)),U=u(s.charCodeAt(2)),_=u(s.charCodeAt(3));return new a(new p(16*h+h,16*U+U,16*_+_))}if(o===5){const h=u(s.charCodeAt(1)),U=u(s.charCodeAt(2)),_=u(s.charCodeAt(3)),T=u(s.charCodeAt(4));return new a(new p(16*h+h,16*U+U,16*_+_,(16*T+T)/255))}return null}d.parseHex=c;function u(s){switch(s){case t.CharCode.Digit0:return 0;case t.CharCode.Digit1:return 1;case t.CharCode.Digit2:return 2;case t.CharCode.Digit3:return 3;case t.CharCode.Digit4:return 4;case t.CharCode.Digit5:return 5;case t.CharCode.Digit6:return 6;case t.CharCode.Digit7:return 7;case t.CharCode.Digit8:return 8;case t.CharCode.Digit9:return 9;case t.CharCode.a:return 10;case t.CharCode.A:return 10;case t.CharCode.b:return 11;case t.CharCode.B:return 11;case t.CharCode.c:return 12;case t.CharCode.C:return 12;case t.CharCode.d:return 13;case t.CharCode.D:return 13;case t.CharCode.e:return 14;case t.CharCode.E:return 14;case t.CharCode.f:return 15;case t.CharCode.F:return 15}return 0}})($=f.CSS||(f.CSS={}))})(l=a.Format||(a.Format={}))}(b||(i.$8s=b={}))}),ne(ie[39],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Tv=void 0;class t{constructor(p,g,w,b){this.originalStart=p,this.originalLength=g,this.modifiedStart=w,this.modifiedLength=b}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}i.$Tv=t}),ne(ie[4],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$cb=i.$bb=i.$ab=i.$_=i.$$=i.$9=i.$5=i.$X=i.$W=void 0,i.setUnexpectedErrorHandler=n,i.$Z=p,i.$1=g,i.$2=w,i.$3=b,i.$4=l,i.$6=$,i.$7=d,i.$8=E,i.$0=m;class t{constructor(){this.b=[],this.a=function(u){setTimeout(()=>{throw u.stack?L.isErrorNoTelemetry(u)?new L(u.message+`

`+u.stack):new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.b.push(u),()=>{this.d(u)}}c(u){this.b.forEach(s=>{s(u)})}d(u){this.b.splice(this.b.indexOf(u),1)}setUnexpectedErrorHandler(u){this.a=u}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(u){this.a(u),this.c(u)}onUnexpectedExternalError(u){this.a(u)}}i.$W=t,i.$X=new t;function n(c){i.$X.setUnexpectedErrorHandler(c)}function p(c){if(!c||typeof c!="object")return!1;const u=c;return u.code==="EPIPE"&&u.syscall?.toUpperCase()==="WRITE"}function g(c){l(c)||i.$X.onUnexpectedError(c)}function w(c){l(c)||i.$X.onUnexpectedExternalError(c)}function b(c){if(c instanceof Error){const{name:u,message:s}=c,o=c.stacktrace||c.stack;return{$isError:!0,name:u,message:s,stack:o,noTelemetry:L.isErrorNoTelemetry(c)}}return c}const a="Canceled";function l(c){return c instanceof f?!0:c instanceof Error&&c.name===a&&c.message===a}class f extends Error{constructor(){super(a),this.name=this.message}}i.$5=f;function $(){const c=new Error(a);return c.name=c.message,c}function d(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}function E(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}class e extends TypeError{constructor(u){super(u?`${u} is read-only and cannot be changed`:"Cannot change read-only property")}}i.$9=e;function m(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}class v extends Error{constructor(u){super("NotImplemented"),u&&(this.message=u)}}i.$$=v;class R extends Error{constructor(u){super("NotSupported"),u&&(this.message=u)}}i.$_=R;class A extends Error{constructor(){super(...arguments),this.isExpected=!0}}i.$ab=A;class L extends Error{constructor(u){super(u),this.name="CodeExpectedError"}static fromError(u){if(u instanceof L)return u;const s=new L;return s.message=u.message,s.stack=u.stack,s}static isErrorNoTelemetry(u){return u.name==="CodeExpectedError"}}i.$bb=L;class N extends Error{constructor(u){super(u||"An unexpected bug occurred."),Object.setPrototypeOf(this,N.prototype)}}i.$cb=N}),ne(ie[7],re([0,1,4,9]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ac=i.$_b=i.$$b=i.$9b=i.$8b=i.CompareResult=void 0,i.$sb=p,i.$tb=g,i.$ub=w,i.$vb=b,i.$wb=a,i.$xb=l,i.$yb=f,i.$zb=$,i.$Ab=d,i.$Bb=E,i.$Cb=e,i.$Db=m,i.$Eb=v,i.top=R,i.$Gb=A,i.$Hb=N,i.$Ib=c,i.$Jb=u,i.$Kb=s,i.$Lb=o,i.$Mb=h,i.$Nb=U,i.$Ob=_,i.$Pb=T,i.$Qb=M,i.$Rb=j,i.$Sb=I,i.$Tb=S,i.$Ub=D,i.$Vb=B,i.$Wb=Z,i.$Xb=O,i.$Yb=P,i.$Zb=X,i.$1b=Y,i.$2b=H,i.$3b=K,i.$4b=C,i.$5b=F,i.$6b=fe,i.$7b=we,i.$0b=Me;function p(x,W=0){return x[x.length-(1+W)]}function g(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function w(x,W,V=(J,ee)=>J===ee){if(x===W)return!0;if(!x||!W||x.length!==W.length)return!1;for(let J=0,ee=x.length;J<ee;J++)if(!V(x[J],W[J]))return!1;return!0}function b(x,W){const V=x.length-1;W<V&&(x[W]=x[V]),x.pop()}function a(x,W,V){return l(x.length,J=>V(x[J],W))}function l(x,W){let V=0,J=x-1;for(;V<=J;){const ee=(V+J)/2|0,he=W(ee);if(he<0)V=ee+1;else if(he>0)J=ee-1;else return ee}return-(V+1)}function f(x,W,V){if(x=x|0,x>=W.length)throw new TypeError("invalid index");const J=W[Math.floor(W.length*Math.random())],ee=[],he=[],de=[];for(const Ne of W){const Ae=V(Ne,J);Ae<0?ee.push(Ne):Ae>0?he.push(Ne):de.push(Ne)}return x<ee.length?f(x,ee,V):x<ee.length+de.length?de[0]:f(x-(ee.length+de.length),he,V)}function $(x,W){const V=[];let J;for(const ee of x.slice(0).sort(W))!J||W(J[0],ee)!==0?(J=[ee],V.push(J)):J.push(ee);return V}function*d(x,W){let V,J;for(const ee of x)J!==void 0&&W(J,ee)?V.push(ee):(V&&(yield V),V=[ee]),J=ee;V&&(yield V)}function E(x,W){for(let V=0;V<=x.length;V++)W(V===0?void 0:x[V-1],V===x.length?void 0:x[V])}function e(x,W){for(let V=0;V<x.length;V++)W(V===0?void 0:x[V-1],x[V],V+1===x.length?void 0:x[V+1])}function m(x,W,V){const J=[];function ee(Ne,Ae,pe){if(Ae===0&&pe.length===0)return;const se=J[J.length-1];se&&se.start+se.deleteCount===Ne?(se.deleteCount+=Ae,se.toInsert.push(...pe)):J.push({start:Ne,deleteCount:Ae,toInsert:pe})}let he=0,de=0;for(;;){if(he===x.length){ee(he,0,W.slice(de));break}if(de===W.length){ee(he,x.length-he,[]);break}const Ne=x[he],Ae=W[de],pe=V(Ne,Ae);pe===0?(he+=1,de+=1):pe<0?(ee(he,1,[]),he+=1):pe>0&&(ee(he,0,[Ae]),de+=1)}return J}function v(x,W,V){const J=m(x,W,V),ee=[],he=[];for(const de of J)ee.push(...x.slice(de.start,de.start+de.deleteCount)),he.push(...de.toInsert);return{removed:ee,added:he}}function R(x,W,V){if(V===0)return[];const J=x.slice(0,V).sort(W);return L(x,W,J,V,x.length),J}function A(x,W,V,J,ee){return V===0?Promise.resolve([]):new Promise((he,de)=>{(async()=>{const Ne=x.length,Ae=x.slice(0,V).sort(W);for(let pe=V,se=Math.min(V+J,Ne);pe<Ne;pe=se,se=Math.min(se+J,Ne)){if(pe>V&&await new Promise(te=>setTimeout(te)),ee&&ee.isCancellationRequested)throw new t.$5;L(x,W,Ae,pe,se)}return Ae})().then(he,de)})}function L(x,W,V,J,ee){for(const he=V.length;J<ee;J++){const de=x[J];if(W(de,V[he-1])<0){V.pop();const Ne=(0,n.$kb)(V,Ae=>W(de,Ae)<0);V.splice(Ne,0,de)}}}function N(x){return x.filter(W=>!!W)}function c(x){let W=0;for(let V=0;V<x.length;V++)x[V]&&(x[W]=x[V],W+=1);x.length=W}function u(x,W,V){x.splice(V,0,x.splice(W,1)[0])}function s(x){return!Array.isArray(x)||x.length===0}function o(x){return Array.isArray(x)&&x.length>0}function h(x,W=V=>V){const V=new Set;return x.filter(J=>{const ee=W(J);return V.has(ee)?!1:(V.add(ee),!0)})}function U(x){const W=new Set;return V=>{const J=x(V);return W.has(J)?!1:(W.add(J),!0)}}function _(x,W){return x.length>0?x[0]:W}function T(x,W){return x.length>0?x[x.length-1]:W}function M(x,W,V=(J,ee)=>J===ee){let J=0;for(let ee=0,he=Math.min(x.length,W.length);ee<he&&V(x[ee],W[ee]);ee++)J++;return J}function j(x,W){let V=typeof W=="number"?x:0;typeof W=="number"?V=x:(V=0,W=x);const J=[];if(V<=W)for(let ee=V;ee<W;ee++)J.push(ee);else for(let ee=V;ee>W;ee--)J.push(ee);return J}function I(x,W,V){return x.reduce((J,ee)=>(J[W(ee)]=V?V(ee):ee,J),Object.create(null))}function S(x,W){return x.push(W),()=>D(x,W)}function D(x,W){const V=x.indexOf(W);if(V>-1)return x.splice(V,1),W}function B(x,W,V){const J=x.slice(0,W),ee=x.slice(W);return J.concat(V,ee)}function Z(x,W){let V;if(typeof W=="number"){let J=W;V=()=>{const ee=Math.sin(J++)*179426549;return ee-Math.floor(ee)}}else V=Math.random;for(let J=x.length-1;J>0;J-=1){const ee=Math.floor(V()*(J+1)),he=x[J];x[J]=x[ee],x[ee]=he}}function O(x,W){const V=x.indexOf(W);V>-1&&(x.splice(V,1),x.unshift(W))}function P(x,W){const V=x.indexOf(W);V>-1&&(x.splice(V,1),x.push(W))}function X(x,W){for(const V of W)x.push(V)}function Y(x,W){return Array.isArray(x)?x.map(W):W(x)}function H(x){return Array.isArray(x)?x:[x]}function K(x){return x[Math.floor(Math.random()*x.length)]}function C(x,W,V){const J=G(x,W),ee=x.length,he=V.length;x.length=ee+he;for(let de=ee-1;de>=J;de--)x[de+he]=x[de];for(let de=0;de<he;de++)x[de+J]=V[de]}function F(x,W,V,J){const ee=G(x,W);let he=x.splice(ee,V);return he===void 0&&(he=[]),C(x,ee,J),he}function G(x,W){return W<0?Math.max(W+x.length,0):Math.min(W,x.length)}var oe;(function(x){function W(he){return he<0}x.isLessThan=W;function V(he){return he<=0}x.isLessThanOrEqual=V;function J(he){return he>0}x.isGreaterThan=J;function ee(he){return he===0}x.isNeitherLessOrGreaterThan=ee,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(oe||(i.CompareResult=oe={}));function fe(x,W){return(V,J)=>W(x(V),x(J))}function we(...x){return(W,V)=>{for(const J of x){const ee=J(W,V);if(!oe.isNeitherLessOrGreaterThan(ee))return ee}return oe.neitherLessOrGreaterThan}}const r=(x,W)=>x-W;i.$8b=r;const Te=(x,W)=>(0,i.$8b)(x?1:0,W?1:0);i.$9b=Te;function Me(x){return(W,V)=>-x(W,V)}class xe{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let V=this.c;for(;V<this.g.length&&W(this.g[V]);)V++;const J=V===this.c?null:this.g.slice(this.c,V);return this.c=V,J}takeFromEndWhile(W){let V=this.d;for(;V>=0&&W(this.g[V]);)V--;const J=V===this.d?null:this.g.slice(V+1,this.d+1);return this.d=V,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const V=this.g.slice(this.c,this.c+W);return this.c+=W,V}}i.$$b=xe;class De{constructor(W){this.iterate=W}forEach(W){this.iterate(V=>(W(V),!0))}toArray(){const W=[];return this.iterate(V=>(W.push(V),!0)),W}filter(W){return new De(V=>this.iterate(J=>W(J)?V(J):!0))}map(W){return new De(V=>this.iterate(J=>V(W(J))))}some(W){let V=!1;return this.iterate(J=>(V=W(J),!V)),V}findFirst(W){let V;return this.iterate(J=>W(J)?(V=J,!1):!0),V}findLast(W){let V;return this.iterate(J=>(W(J)&&(V=J),!0)),V}findLastMaxBy(W){let V,J=!0;return this.iterate(ee=>((J||oe.isGreaterThan(W(ee,V)))&&(J=!1,V=ee),!0)),V}}i.$_b=De,De.empty=new De(x=>{});class Fe{constructor(W){this.c=W}static createSortPermutation(W,V){const J=Array.from(W.keys()).sort((ee,he)=>V(W[ee],W[he]));return new Fe(J)}apply(W){return W.map((V,J)=>W[this.c[J]])}inverse(){const W=this.c.slice();for(let V=0;V<this.c.length;V++)W[this.c[V]]=V;return new Fe(W)}}i.$ac=Fe}),ne(ie[11],re([0,1,4]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=n,i.$ed=p,i.$fd=g,i.$gd=w,i.$hd=b,i.$id=a;function n(l,f){if(!l)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function p(l,f="Unreachable"){throw new Error(f)}function g(l,f="unexpected state"){if(!l)throw new t.$cb(`Assertion Failed: ${f}`)}function w(l){l||(0,t.$1)(new t.$cb("Soft Assertion Failed"))}function b(l){if(!l()){debugger;l(),(0,t.$1)(new t.$cb("Assertion Failed"))}}function a(l,f){let $=0;for(;$<l.length-1;){const d=l[$],E=l[$+1];if(!f(d,E))return!1;$++}return!0}}),ne(ie[22],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$db=t;function t(n,p){const g=this;let w=!1,b;return function(){if(w)return b;if(w=!0,p)try{b=n.apply(g,arguments)}finally{p()}else b=n.apply(g,arguments);return b}}}),ne(ie[23],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Iterable=void 0;var t;(function(n){function p(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}n.is=p;const g=Object.freeze([]);function w(){return g}n.empty=w;function*b(u){yield u}n.single=b;function a(u){return p(u)?u:b(u)}n.wrap=a;function l(u){return u||g}n.from=l;function*f(u){for(let s=u.length-1;s>=0;s--)yield u[s]}n.reverse=f;function $(u){return!u||u[Symbol.iterator]().next().done===!0}n.isEmpty=$;function d(u){return u[Symbol.iterator]().next().value}n.first=d;function E(u,s){for(const o of u)if(s(o))return!0;return!1}n.some=E;function e(u,s){for(const o of u)if(s(o))return o}n.find=e;function*m(u,s){for(const o of u)s(o)&&(yield o)}n.filter=m;function*v(u,s){let o=0;for(const h of u)yield s(h,o++)}n.map=v;function*R(...u){for(const s of u)yield*s}n.concat=R;function A(u,s,o){let h=o;for(const U of u)h=s(h,U);return h}n.reduce=A;function*L(u,s,o=u.length){for(s<0&&(s+=u.length),o<0?o+=u.length:o>u.length&&(o=u.length);s<o;s++)yield u[s]}n.slice=L;function N(u,s=Number.POSITIVE_INFINITY){const o=[];if(s===0)return[o,u];const h=u[Symbol.iterator]();for(let U=0;U<s;U++){const _=h.next();if(_.done)return[o,n.empty()];o.push(_.value)}return[o,{[Symbol.iterator](){return h}}]}n.consume=N;async function c(u){const s=[];for await(const o of u)s.push(o);return Promise.resolve(s)}n.asyncToArray=c})(t||(i.Iterable=t={}))}),ne(ie[40],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.KeyMod=i.KeyCodeUtils=i.$Mr=i.$Lr=i.$Kr=i.$Jr=i.$Ir=i.ScanCode=i.KeyCode=void 0,i.$Nr=E;var t;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(t||(i.KeyCode=t={}));var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(n||(i.ScanCode=n={}));class p{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(m,v){this._keyCodeToStr[m]=v,this._strToKeyCode[v.toLowerCase()]=m}keyCodeToStr(m){return this._keyCodeToStr[m]}strToKeyCode(m){return this._strToKeyCode[m.toLowerCase()]||t.Unknown}}const g=new p,w=new p,b=new p;i.$Ir=new Array(230),i.$Jr={};const a=[],l=Object.create(null),f=Object.create(null);i.$Kr={lowerCaseToEnum:e=>f[e]||n.None,toEnum:e=>l[e]||n.None,toString:e=>a[e]||"None"},i.$Lr=[],i.$Mr=[];for(let e=0;e<=n.MAX_VALUE;e++)i.$Lr[e]=t.DependsOnKbLayout;for(let e=0;e<=t.MAX_VALUE;e++)i.$Mr[e]=n.DependsOnKbLayout;(function(){const e="",m=[[1,n.None,"None",t.Unknown,"unknown",0,"VK_UNKNOWN",e,e],[1,n.Hyper,"Hyper",t.Unknown,e,0,e,e,e],[1,n.Super,"Super",t.Unknown,e,0,e,e,e],[1,n.Fn,"Fn",t.Unknown,e,0,e,e,e],[1,n.FnLock,"FnLock",t.Unknown,e,0,e,e,e],[1,n.Suspend,"Suspend",t.Unknown,e,0,e,e,e],[1,n.Resume,"Resume",t.Unknown,e,0,e,e,e],[1,n.Turbo,"Turbo",t.Unknown,e,0,e,e,e],[1,n.Sleep,"Sleep",t.Unknown,e,0,"VK_SLEEP",e,e],[1,n.WakeUp,"WakeUp",t.Unknown,e,0,e,e,e],[0,n.KeyA,"KeyA",t.KeyA,"A",65,"VK_A",e,e],[0,n.KeyB,"KeyB",t.KeyB,"B",66,"VK_B",e,e],[0,n.KeyC,"KeyC",t.KeyC,"C",67,"VK_C",e,e],[0,n.KeyD,"KeyD",t.KeyD,"D",68,"VK_D",e,e],[0,n.KeyE,"KeyE",t.KeyE,"E",69,"VK_E",e,e],[0,n.KeyF,"KeyF",t.KeyF,"F",70,"VK_F",e,e],[0,n.KeyG,"KeyG",t.KeyG,"G",71,"VK_G",e,e],[0,n.KeyH,"KeyH",t.KeyH,"H",72,"VK_H",e,e],[0,n.KeyI,"KeyI",t.KeyI,"I",73,"VK_I",e,e],[0,n.KeyJ,"KeyJ",t.KeyJ,"J",74,"VK_J",e,e],[0,n.KeyK,"KeyK",t.KeyK,"K",75,"VK_K",e,e],[0,n.KeyL,"KeyL",t.KeyL,"L",76,"VK_L",e,e],[0,n.KeyM,"KeyM",t.KeyM,"M",77,"VK_M",e,e],[0,n.KeyN,"KeyN",t.KeyN,"N",78,"VK_N",e,e],[0,n.KeyO,"KeyO",t.KeyO,"O",79,"VK_O",e,e],[0,n.KeyP,"KeyP",t.KeyP,"P",80,"VK_P",e,e],[0,n.KeyQ,"KeyQ",t.KeyQ,"Q",81,"VK_Q",e,e],[0,n.KeyR,"KeyR",t.KeyR,"R",82,"VK_R",e,e],[0,n.KeyS,"KeyS",t.KeyS,"S",83,"VK_S",e,e],[0,n.KeyT,"KeyT",t.KeyT,"T",84,"VK_T",e,e],[0,n.KeyU,"KeyU",t.KeyU,"U",85,"VK_U",e,e],[0,n.KeyV,"KeyV",t.KeyV,"V",86,"VK_V",e,e],[0,n.KeyW,"KeyW",t.KeyW,"W",87,"VK_W",e,e],[0,n.KeyX,"KeyX",t.KeyX,"X",88,"VK_X",e,e],[0,n.KeyY,"KeyY",t.KeyY,"Y",89,"VK_Y",e,e],[0,n.KeyZ,"KeyZ",t.KeyZ,"Z",90,"VK_Z",e,e],[0,n.Digit1,"Digit1",t.Digit1,"1",49,"VK_1",e,e],[0,n.Digit2,"Digit2",t.Digit2,"2",50,"VK_2",e,e],[0,n.Digit3,"Digit3",t.Digit3,"3",51,"VK_3",e,e],[0,n.Digit4,"Digit4",t.Digit4,"4",52,"VK_4",e,e],[0,n.Digit5,"Digit5",t.Digit5,"5",53,"VK_5",e,e],[0,n.Digit6,"Digit6",t.Digit6,"6",54,"VK_6",e,e],[0,n.Digit7,"Digit7",t.Digit7,"7",55,"VK_7",e,e],[0,n.Digit8,"Digit8",t.Digit8,"8",56,"VK_8",e,e],[0,n.Digit9,"Digit9",t.Digit9,"9",57,"VK_9",e,e],[0,n.Digit0,"Digit0",t.Digit0,"0",48,"VK_0",e,e],[1,n.Enter,"Enter",t.Enter,"Enter",13,"VK_RETURN",e,e],[1,n.Escape,"Escape",t.Escape,"Escape",27,"VK_ESCAPE",e,e],[1,n.Backspace,"Backspace",t.Backspace,"Backspace",8,"VK_BACK",e,e],[1,n.Tab,"Tab",t.Tab,"Tab",9,"VK_TAB",e,e],[1,n.Space,"Space",t.Space,"Space",32,"VK_SPACE",e,e],[0,n.Minus,"Minus",t.Minus,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,n.Equal,"Equal",t.Equal,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,n.BracketLeft,"BracketLeft",t.BracketLeft,"[",219,"VK_OEM_4","[","OEM_4"],[0,n.BracketRight,"BracketRight",t.BracketRight,"]",221,"VK_OEM_6","]","OEM_6"],[0,n.Backslash,"Backslash",t.Backslash,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,n.IntlHash,"IntlHash",t.Unknown,e,0,e,e,e],[0,n.Semicolon,"Semicolon",t.Semicolon,";",186,"VK_OEM_1",";","OEM_1"],[0,n.Quote,"Quote",t.Quote,"'",222,"VK_OEM_7","'","OEM_7"],[0,n.Backquote,"Backquote",t.Backquote,"`",192,"VK_OEM_3","`","OEM_3"],[0,n.Comma,"Comma",t.Comma,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,n.Period,"Period",t.Period,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,n.Slash,"Slash",t.Slash,"/",191,"VK_OEM_2","/","OEM_2"],[1,n.CapsLock,"CapsLock",t.CapsLock,"CapsLock",20,"VK_CAPITAL",e,e],[1,n.F1,"F1",t.F1,"F1",112,"VK_F1",e,e],[1,n.F2,"F2",t.F2,"F2",113,"VK_F2",e,e],[1,n.F3,"F3",t.F3,"F3",114,"VK_F3",e,e],[1,n.F4,"F4",t.F4,"F4",115,"VK_F4",e,e],[1,n.F5,"F5",t.F5,"F5",116,"VK_F5",e,e],[1,n.F6,"F6",t.F6,"F6",117,"VK_F6",e,e],[1,n.F7,"F7",t.F7,"F7",118,"VK_F7",e,e],[1,n.F8,"F8",t.F8,"F8",119,"VK_F8",e,e],[1,n.F9,"F9",t.F9,"F9",120,"VK_F9",e,e],[1,n.F10,"F10",t.F10,"F10",121,"VK_F10",e,e],[1,n.F11,"F11",t.F11,"F11",122,"VK_F11",e,e],[1,n.F12,"F12",t.F12,"F12",123,"VK_F12",e,e],[1,n.PrintScreen,"PrintScreen",t.Unknown,e,0,e,e,e],[1,n.ScrollLock,"ScrollLock",t.ScrollLock,"ScrollLock",145,"VK_SCROLL",e,e],[1,n.Pause,"Pause",t.PauseBreak,"PauseBreak",19,"VK_PAUSE",e,e],[1,n.Insert,"Insert",t.Insert,"Insert",45,"VK_INSERT",e,e],[1,n.Home,"Home",t.Home,"Home",36,"VK_HOME",e,e],[1,n.PageUp,"PageUp",t.PageUp,"PageUp",33,"VK_PRIOR",e,e],[1,n.Delete,"Delete",t.Delete,"Delete",46,"VK_DELETE",e,e],[1,n.End,"End",t.End,"End",35,"VK_END",e,e],[1,n.PageDown,"PageDown",t.PageDown,"PageDown",34,"VK_NEXT",e,e],[1,n.ArrowRight,"ArrowRight",t.RightArrow,"RightArrow",39,"VK_RIGHT","Right",e],[1,n.ArrowLeft,"ArrowLeft",t.LeftArrow,"LeftArrow",37,"VK_LEFT","Left",e],[1,n.ArrowDown,"ArrowDown",t.DownArrow,"DownArrow",40,"VK_DOWN","Down",e],[1,n.ArrowUp,"ArrowUp",t.UpArrow,"UpArrow",38,"VK_UP","Up",e],[1,n.NumLock,"NumLock",t.NumLock,"NumLock",144,"VK_NUMLOCK",e,e],[1,n.NumpadDivide,"NumpadDivide",t.NumpadDivide,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,n.NumpadMultiply,"NumpadMultiply",t.NumpadMultiply,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,n.NumpadSubtract,"NumpadSubtract",t.NumpadSubtract,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,n.NumpadAdd,"NumpadAdd",t.NumpadAdd,"NumPad_Add",107,"VK_ADD",e,e],[1,n.NumpadEnter,"NumpadEnter",t.Enter,e,0,e,e,e],[1,n.Numpad1,"Numpad1",t.Numpad1,"NumPad1",97,"VK_NUMPAD1",e,e],[1,n.Numpad2,"Numpad2",t.Numpad2,"NumPad2",98,"VK_NUMPAD2",e,e],[1,n.Numpad3,"Numpad3",t.Numpad3,"NumPad3",99,"VK_NUMPAD3",e,e],[1,n.Numpad4,"Numpad4",t.Numpad4,"NumPad4",100,"VK_NUMPAD4",e,e],[1,n.Numpad5,"Numpad5",t.Numpad5,"NumPad5",101,"VK_NUMPAD5",e,e],[1,n.Numpad6,"Numpad6",t.Numpad6,"NumPad6",102,"VK_NUMPAD6",e,e],[1,n.Numpad7,"Numpad7",t.Numpad7,"NumPad7",103,"VK_NUMPAD7",e,e],[1,n.Numpad8,"Numpad8",t.Numpad8,"NumPad8",104,"VK_NUMPAD8",e,e],[1,n.Numpad9,"Numpad9",t.Numpad9,"NumPad9",105,"VK_NUMPAD9",e,e],[1,n.Numpad0,"Numpad0",t.Numpad0,"NumPad0",96,"VK_NUMPAD0",e,e],[1,n.NumpadDecimal,"NumpadDecimal",t.NumpadDecimal,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,n.IntlBackslash,"IntlBackslash",t.IntlBackslash,"OEM_102",226,"VK_OEM_102",e,e],[1,n.ContextMenu,"ContextMenu",t.ContextMenu,"ContextMenu",93,e,e,e],[1,n.Power,"Power",t.Unknown,e,0,e,e,e],[1,n.NumpadEqual,"NumpadEqual",t.Unknown,e,0,e,e,e],[1,n.F13,"F13",t.F13,"F13",124,"VK_F13",e,e],[1,n.F14,"F14",t.F14,"F14",125,"VK_F14",e,e],[1,n.F15,"F15",t.F15,"F15",126,"VK_F15",e,e],[1,n.F16,"F16",t.F16,"F16",127,"VK_F16",e,e],[1,n.F17,"F17",t.F17,"F17",128,"VK_F17",e,e],[1,n.F18,"F18",t.F18,"F18",129,"VK_F18",e,e],[1,n.F19,"F19",t.F19,"F19",130,"VK_F19",e,e],[1,n.F20,"F20",t.F20,"F20",131,"VK_F20",e,e],[1,n.F21,"F21",t.F21,"F21",132,"VK_F21",e,e],[1,n.F22,"F22",t.F22,"F22",133,"VK_F22",e,e],[1,n.F23,"F23",t.F23,"F23",134,"VK_F23",e,e],[1,n.F24,"F24",t.F24,"F24",135,"VK_F24",e,e],[1,n.Open,"Open",t.Unknown,e,0,e,e,e],[1,n.Help,"Help",t.Unknown,e,0,e,e,e],[1,n.Select,"Select",t.Unknown,e,0,e,e,e],[1,n.Again,"Again",t.Unknown,e,0,e,e,e],[1,n.Undo,"Undo",t.Unknown,e,0,e,e,e],[1,n.Cut,"Cut",t.Unknown,e,0,e,e,e],[1,n.Copy,"Copy",t.Unknown,e,0,e,e,e],[1,n.Paste,"Paste",t.Unknown,e,0,e,e,e],[1,n.Find,"Find",t.Unknown,e,0,e,e,e],[1,n.AudioVolumeMute,"AudioVolumeMute",t.AudioVolumeMute,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,n.AudioVolumeUp,"AudioVolumeUp",t.AudioVolumeUp,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,n.AudioVolumeDown,"AudioVolumeDown",t.AudioVolumeDown,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,n.NumpadComma,"NumpadComma",t.NUMPAD_SEPARATOR,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,n.IntlRo,"IntlRo",t.ABNT_C1,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,n.KanaMode,"KanaMode",t.Unknown,e,0,e,e,e],[0,n.IntlYen,"IntlYen",t.Unknown,e,0,e,e,e],[1,n.Convert,"Convert",t.Unknown,e,0,e,e,e],[1,n.NonConvert,"NonConvert",t.Unknown,e,0,e,e,e],[1,n.Lang1,"Lang1",t.Unknown,e,0,e,e,e],[1,n.Lang2,"Lang2",t.Unknown,e,0,e,e,e],[1,n.Lang3,"Lang3",t.Unknown,e,0,e,e,e],[1,n.Lang4,"Lang4",t.Unknown,e,0,e,e,e],[1,n.Lang5,"Lang5",t.Unknown,e,0,e,e,e],[1,n.Abort,"Abort",t.Unknown,e,0,e,e,e],[1,n.Props,"Props",t.Unknown,e,0,e,e,e],[1,n.NumpadParenLeft,"NumpadParenLeft",t.Unknown,e,0,e,e,e],[1,n.NumpadParenRight,"NumpadParenRight",t.Unknown,e,0,e,e,e],[1,n.NumpadBackspace,"NumpadBackspace",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryStore,"NumpadMemoryStore",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryRecall,"NumpadMemoryRecall",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryClear,"NumpadMemoryClear",t.Unknown,e,0,e,e,e],[1,n.NumpadMemoryAdd,"NumpadMemoryAdd",t.Unknown,e,0,e,e,e],[1,n.NumpadMemorySubtract,"NumpadMemorySubtract",t.Unknown,e,0,e,e,e],[1,n.NumpadClear,"NumpadClear",t.Clear,"Clear",12,"VK_CLEAR",e,e],[1,n.NumpadClearEntry,"NumpadClearEntry",t.Unknown,e,0,e,e,e],[1,n.None,e,t.Ctrl,"Ctrl",17,"VK_CONTROL",e,e],[1,n.None,e,t.Shift,"Shift",16,"VK_SHIFT",e,e],[1,n.None,e,t.Alt,"Alt",18,"VK_MENU",e,e],[1,n.None,e,t.Meta,"Meta",91,"VK_COMMAND",e,e],[1,n.ControlLeft,"ControlLeft",t.Ctrl,e,0,"VK_LCONTROL",e,e],[1,n.ShiftLeft,"ShiftLeft",t.Shift,e,0,"VK_LSHIFT",e,e],[1,n.AltLeft,"AltLeft",t.Alt,e,0,"VK_LMENU",e,e],[1,n.MetaLeft,"MetaLeft",t.Meta,e,0,"VK_LWIN",e,e],[1,n.ControlRight,"ControlRight",t.Ctrl,e,0,"VK_RCONTROL",e,e],[1,n.ShiftRight,"ShiftRight",t.Shift,e,0,"VK_RSHIFT",e,e],[1,n.AltRight,"AltRight",t.Alt,e,0,"VK_RMENU",e,e],[1,n.MetaRight,"MetaRight",t.Meta,e,0,"VK_RWIN",e,e],[1,n.BrightnessUp,"BrightnessUp",t.Unknown,e,0,e,e,e],[1,n.BrightnessDown,"BrightnessDown",t.Unknown,e,0,e,e,e],[1,n.MediaPlay,"MediaPlay",t.Unknown,e,0,e,e,e],[1,n.MediaRecord,"MediaRecord",t.Unknown,e,0,e,e,e],[1,n.MediaFastForward,"MediaFastForward",t.Unknown,e,0,e,e,e],[1,n.MediaRewind,"MediaRewind",t.Unknown,e,0,e,e,e],[1,n.MediaTrackNext,"MediaTrackNext",t.MediaTrackNext,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,n.MediaTrackPrevious,"MediaTrackPrevious",t.MediaTrackPrevious,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,n.MediaStop,"MediaStop",t.MediaStop,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,n.Eject,"Eject",t.Unknown,e,0,e,e,e],[1,n.MediaPlayPause,"MediaPlayPause",t.MediaPlayPause,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,n.MediaSelect,"MediaSelect",t.LaunchMediaPlayer,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,n.LaunchMail,"LaunchMail",t.LaunchMail,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,n.LaunchApp2,"LaunchApp2",t.LaunchApp2,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,n.LaunchApp1,"LaunchApp1",t.Unknown,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,n.SelectTask,"SelectTask",t.Unknown,e,0,e,e,e],[1,n.LaunchScreenSaver,"LaunchScreenSaver",t.Unknown,e,0,e,e,e],[1,n.BrowserSearch,"BrowserSearch",t.BrowserSearch,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,n.BrowserHome,"BrowserHome",t.BrowserHome,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,n.BrowserBack,"BrowserBack",t.BrowserBack,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,n.BrowserForward,"BrowserForward",t.BrowserForward,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,n.BrowserStop,"BrowserStop",t.Unknown,e,0,"VK_BROWSER_STOP",e,e],[1,n.BrowserRefresh,"BrowserRefresh",t.Unknown,e,0,"VK_BROWSER_REFRESH",e,e],[1,n.BrowserFavorites,"BrowserFavorites",t.Unknown,e,0,"VK_BROWSER_FAVORITES",e,e],[1,n.ZoomToggle,"ZoomToggle",t.Unknown,e,0,e,e,e],[1,n.MailReply,"MailReply",t.Unknown,e,0,e,e,e],[1,n.MailForward,"MailForward",t.Unknown,e,0,e,e,e],[1,n.MailSend,"MailSend",t.Unknown,e,0,e,e,e],[1,n.None,e,t.KEY_IN_COMPOSITION,"KeyInComposition",229,e,e,e],[1,n.None,e,t.ABNT_C2,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,n.None,e,t.OEM_8,"OEM_8",223,"VK_OEM_8",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANGUL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_JUNJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_FINAL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HANJA",e,e],[1,n.None,e,t.Unknown,e,0,"VK_KANJI",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONCONVERT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ACCEPT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_MODECHANGE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SELECT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PRINT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXECUTE",e,e],[1,n.None,e,t.Unknown,e,0,"VK_SNAPSHOT",e,e],[1,n.None,e,t.Unknown,e,0,"VK_HELP",e,e],[1,n.None,e,t.Unknown,e,0,"VK_APPS",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PROCESSKEY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PACKET",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_SBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_DBE_DBCSCHAR",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ATTN",e,e],[1,n.None,e,t.Unknown,e,0,"VK_CRSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EXSEL",e,e],[1,n.None,e,t.Unknown,e,0,"VK_EREOF",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PLAY",e,e],[1,n.None,e,t.Unknown,e,0,"VK_ZOOM",e,e],[1,n.None,e,t.Unknown,e,0,"VK_NONAME",e,e],[1,n.None,e,t.Unknown,e,0,"VK_PA1",e,e],[1,n.None,e,t.Unknown,e,0,"VK_OEM_CLEAR",e,e]],v=[],R=[];for(const A of m){const[L,N,c,u,s,o,h,U,_]=A;if(R[N]||(R[N]=!0,a[N]=c,l[c]=N,f[c.toLowerCase()]=N,L&&(i.$Lr[N]=u,u!==t.Unknown&&u!==t.Enter&&u!==t.Ctrl&&u!==t.Shift&&u!==t.Alt&&u!==t.Meta&&(i.$Mr[u]=N))),!v[u]){if(v[u]=!0,!s)throw new Error(`String representation missing for key code ${u} around scan code ${c}`);g.define(u,s),w.define(u,U||s),b.define(u,_||U||s)}o&&(i.$Ir[o]=u),h&&(i.$Jr[h]=u)}i.$Mr[t.Enter]=n.Enter})();var $;(function(e){function m(c){return g.keyCodeToStr(c)}e.toString=m;function v(c){return g.strToKeyCode(c)}e.fromString=v;function R(c){return w.keyCodeToStr(c)}e.toUserSettingsUS=R;function A(c){return b.keyCodeToStr(c)}e.toUserSettingsGeneral=A;function L(c){return w.strToKeyCode(c)||b.strToKeyCode(c)}e.fromUserSettings=L;function N(c){if(c>=t.Numpad0&&c<=t.NumpadDivide)return null;switch(c){case t.UpArrow:return"Up";case t.DownArrow:return"Down";case t.LeftArrow:return"Left";case t.RightArrow:return"Right"}return g.keyCodeToStr(c)}e.toElectronAccelerator=N})($||(i.KeyCodeUtils=$={}));var d;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(d||(i.KeyMod=d={}));function E(e,m){const v=(m&65535)<<16>>>0;return(e|v)>>>0}}),ne(ie[41],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$V=void 0;class t{constructor(p){this.d=p,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(p){this.c=p}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}i.$V=t}),ne(ie[24],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$5c=void 0;class t{constructor(g){this.element=g,this.next=t.Undefined,this.prev=t.Undefined}}t.Undefined=new t(void 0);class n{constructor(){this.a=t.Undefined,this.b=t.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===t.Undefined}clear(){let g=this.a;for(;g!==t.Undefined;){const w=g.next;g.prev=t.Undefined,g.next=t.Undefined,g=w}this.a=t.Undefined,this.b=t.Undefined,this.c=0}unshift(g){return this.d(g,!1)}push(g){return this.d(g,!0)}d(g,w){const b=new t(g);if(this.a===t.Undefined)this.a=b,this.b=b;else if(w){const l=this.b;this.b=b,b.prev=l,l.next=b}else{const l=this.a;this.a=b,b.next=l,l.prev=b}this.c+=1;let a=!1;return()=>{a||(a=!0,this.e(b))}}shift(){if(this.a!==t.Undefined){const g=this.a.element;return this.e(this.a),g}}pop(){if(this.b!==t.Undefined){const g=this.b.element;return this.e(this.b),g}}e(g){if(g.prev!==t.Undefined&&g.next!==t.Undefined){const w=g.prev;w.next=g.next,g.next.prev=w}else g.prev===t.Undefined&&g.next===t.Undefined?(this.a=t.Undefined,this.b=t.Undefined):g.next===t.Undefined?(this.b=this.b.prev,this.b.next=t.Undefined):g.prev===t.Undefined&&(this.a=this.a.next,this.a.prev=t.Undefined);this.c-=1}*[Symbol.iterator](){let g=this.a;for(;g!==t.Undefined;)yield g.element,g=g.next}}i.$5c=n}),ne(ie[16],re([0,1]),function(q,i){"use strict";var t,n,p;Object.defineProperty(i,"__esModule",{value:!0}),i.$Hc=i.$Gc=i.$Fc=i.$Ec=i.$Dc=i.$Cc=i.Touch=i.$Bc=i.$Ac=void 0,i.$xc=g,i.$yc=w,i.$zc=b,i.$Ic=N;function g(c,u,s){let o=c.get(u);return o===void 0&&(o=s,c.set(u,o)),o}function w(c){const u=[];return c.forEach((s,o)=>{u.push(`${o} => ${s}`)}),`Map(${c.size}) {${u.join(", ")}}`}function b(c){const u=[];return c.forEach(s=>{u.push(s)}),`Set(${c.size}) {${u.join(", ")}}`}class a{constructor(u,s){this.uri=u,this.value=s}}function l(c){return Array.isArray(c)}class f{constructor(u,s){if(this[t]="ResourceMap",u instanceof f)this.d=new Map(u.d),this.e=s??f.c;else if(l(u)){this.d=new Map,this.e=s??f.c;for(const[o,h]of u)this.set(o,h)}else this.d=new Map,this.e=u??f.c}set(u,s){return this.d.set(this.e(u),new a(u,s)),this}get(u){return this.d.get(this.e(u))?.value}has(u){return this.d.has(this.e(u))}get size(){return this.d.size}clear(){this.d.clear()}delete(u){return this.d.delete(this.e(u))}forEach(u,s){typeof s<"u"&&(u=u.bind(s));for(const[o,h]of this.d)u(h.value,h.uri,this)}*values(){for(const u of this.d.values())yield u.value}*keys(){for(const u of this.d.values())yield u.uri}*entries(){for(const u of this.d.values())yield[u.uri,u.value]}*[(t=Symbol.toStringTag,Symbol.iterator)](){for(const[,u]of this.d)yield[u.uri,u.value]}}i.$Ac=f,f.c=c=>c.toString();class ${constructor(u,s){this[n]="ResourceSet",!u||typeof u=="function"?this.c=new f(u):(this.c=new f(s),u.forEach(this.add,this))}get size(){return this.c.size}add(u){return this.c.set(u,u),this}clear(){this.c.clear()}delete(u){return this.c.delete(u)}forEach(u,s){this.c.forEach((o,h)=>u.call(s,h,h,this))}has(u){return this.c.has(u)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}i.$Bc=$;var d;(function(c){c[c.None=0]="None",c[c.AsOld=1]="AsOld",c[c.AsNew=2]="AsNew"})(d||(i.Touch=d={}));class E{constructor(){this[p]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(u){return this.c.has(u)}get(u,s=d.None){const o=this.c.get(u);if(o)return s!==d.None&&this.m(o,s),o.value}set(u,s,o=d.None){let h=this.c.get(u);if(h)h.value=s,o!==d.None&&this.m(h,o);else{switch(h={key:u,value:s,next:void 0,previous:void 0},o){case d.None:this.k(h);break;case d.AsOld:this.j(h);break;case d.AsNew:this.k(h);break;default:this.k(h);break}this.c.set(u,h),this.f++}return this}delete(u){return!!this.remove(u)}remove(u){const s=this.c.get(u);if(s)return this.c.delete(u),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const u=this.d;return this.c.delete(u.key),this.l(u),this.f--,u.value}forEach(u,s){const o=this.g;let h=this.d;for(;h;){if(s?u.bind(s)(h.value,h.key,this):u(h.value,h.key,this),this.g!==o)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const u=this,s=this.g;let o=this.d;const h={[Symbol.iterator](){return h},next(){if(u.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const U={value:o.key,done:!1};return o=o.next,U}else return{value:void 0,done:!0}}};return h}values(){const u=this,s=this.g;let o=this.d;const h={[Symbol.iterator](){return h},next(){if(u.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const U={value:o.value,done:!1};return o=o.next,U}else return{value:void 0,done:!0}}};return h}entries(){const u=this,s=this.g;let o=this.d;const h={[Symbol.iterator](){return h},next(){if(u.g!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const U={value:[o.key,o.value],done:!1};return o=o.next,U}else return{value:void 0,done:!0}}};return h}[(p=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(u){if(u>=this.size)return;if(u===0){this.clear();return}let s=this.d,o=this.size;for(;s&&o>u;)this.c.delete(s.key),s=s.next,o--;this.d=s,this.f=o,s&&(s.previous=void 0),this.g++}i(u){if(u>=this.size)return;if(u===0){this.clear();return}let s=this.e,o=this.size;for(;s&&o>u;)this.c.delete(s.key),s=s.previous,o--;this.e=s,this.f=o,s&&(s.next=void 0),this.g++}j(u){if(!this.d&&!this.e)this.e=u;else if(this.d)u.next=this.d,this.d.previous=u;else throw new Error("Invalid list");this.d=u,this.g++}k(u){if(!this.d&&!this.e)this.d=u;else if(this.e)u.previous=this.e,this.e.next=u;else throw new Error("Invalid list");this.e=u,this.g++}l(u){if(u===this.d&&u===this.e)this.d=void 0,this.e=void 0;else if(u===this.d){if(!u.next)throw new Error("Invalid list");u.next.previous=void 0,this.d=u.next}else if(u===this.e){if(!u.previous)throw new Error("Invalid list");u.previous.next=void 0,this.e=u.previous}else{const s=u.next,o=u.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}u.next=void 0,u.previous=void 0,this.g++}m(u,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==d.AsOld&&s!==d.AsNew)){if(s===d.AsOld){if(u===this.d)return;const o=u.next,h=u.previous;u===this.e?(h.next=void 0,this.e=h):(o.previous=h,h.next=o),u.previous=void 0,u.next=this.d,this.d.previous=u,this.d=u,this.g++}else if(s===d.AsNew){if(u===this.e)return;const o=u.next,h=u.previous;u===this.d?(o.previous=void 0,this.d=o):(o.previous=h,h.next=o),u.next=void 0,u.previous=this.e,this.e.next=u,this.e=u,this.g++}}}toJSON(){const u=[];return this.forEach((s,o)=>{u.push([o,s])}),u}fromJSON(u){this.clear();for(const[s,o]of u)this.set(s,o)}}i.$Cc=E;class e extends E{constructor(u,s=1){super(),this.n=u,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(u){this.n=u,this.p()}get ratio(){return this.o}set ratio(u){this.o=Math.min(Math.max(0,u),1),this.p()}get(u,s=d.AsNew){return super.get(u,s)}peek(u){return super.get(u,d.None)}set(u,s){return super.set(u,s,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class m extends e{constructor(u,s=1){super(u,s)}q(u){this.h(u)}set(u,s){return super.set(u,s),this.p(),this}}i.$Dc=m;class v extends e{constructor(u,s=1){super(u,s)}q(u){this.i(u)}set(u,s){return this.n<=this.size&&!this.has(u)&&this.q(Math.round(this.n*this.o)-1),super.set(u,s),this}}i.$Ec=v;class R{constructor(){this.c=new Map}add(u){return this.c.set(u,(this.c.get(u)||0)+1),this}delete(u){let s=this.c.get(u)||0;return s===0?!1:(s--,s===0?this.c.delete(u):this.c.set(u,s),!0)}has(u){return this.c.has(u)}}i.$Fc=R;class A{constructor(u){if(this.c=new Map,this.d=new Map,u)for(const[s,o]of u)this.set(s,o)}clear(){this.c.clear(),this.d.clear()}set(u,s){this.c.set(u,s),this.d.set(s,u)}get(u){return this.c.get(u)}getKey(u){return this.d.get(u)}delete(u){const s=this.c.get(u);return s===void 0?!1:(this.c.delete(u),this.d.delete(s),!0)}forEach(u,s){this.c.forEach((o,h)=>{u.call(s,o,h,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}i.$Gc=A;class L{constructor(){this.c=new Map}add(u,s){let o=this.c.get(u);o||(o=new Set,this.c.set(u,o)),o.add(s)}delete(u,s){const o=this.c.get(u);o&&(o.delete(s),o.size===0&&this.c.delete(u))}forEach(u,s){const o=this.c.get(u);o&&o.forEach(s)}get(u){const s=this.c.get(u);return s||new Set}}i.$Hc=L;function N(c,u){if(c===u)return!0;if(c.size!==u.size)return!1;for(const[s,o]of c)if(!u.has(s)||u.get(s)!==o)return!1;for(const[s]of u)if(!c.has(s))return!1;return!0}}),ne(ie[12],re([0,1,7,37,16,22,23]),function(q,i,t,n,p,g,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$4c=i.$2c=i.$1c=i.$Zc=i.$Yc=i.$Xc=i.$Wc=i.$Vc=i.$Uc=i.$Tc=i.$Jc=void 0,i.$Kc=f,i.$Lc=$,i.$Mc=d,i.$Nc=m,i.$Oc=v,i.$Pc=R,i.$Qc=A,i.$Rc=L,i.$Sc=N,i.$3c=j;const b=!1;let a=null;class l{constructor(){this.b=new Map}c(D){let B=this.b.get(D);return B||(B={parent:null,source:null,isSingleton:!1,value:D,idx:l.a++},this.b.set(D,B)),B}trackDisposable(D){const B=this.c(D);B.source||(B.source=new Error().stack)}setParent(D,B){const Z=this.c(D);Z.parent=B}markAsDisposed(D){this.b.delete(D)}markAsSingleton(D){this.c(D).isSingleton=!0}f(D,B){const Z=B.get(D);if(Z)return Z;const O=D.parent?this.f(this.c(D.parent),B):D;return B.set(D,O),O}getTrackedDisposables(){const D=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,D).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(D=10,B){let Z;if(B)Z=B;else{const H=new Map,K=[...this.b.values()].filter(F=>F.source!==null&&!this.f(F,H).isSingleton);if(K.length===0)return;const C=new Set(K.map(F=>F.value));if(Z=K.filter(F=>!(F.parent&&C.has(F.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function O(H){function K(F,G){for(;F.length>0&&G.some(oe=>typeof oe=="string"?oe===F[0]:F[0].match(oe));)F.shift()}const C=H.source.split(`
`).map(F=>F.trim().replace("at ","")).filter(F=>F!=="");return K(C,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),C.reverse()}const P=new p.$Hc;for(const H of Z){const K=O(H);for(let C=0;C<=K.length;C++)P.add(K.slice(0,C).join(`
`),H)}Z.sort((0,t.$6b)(H=>H.idx,t.$8b));let X="",Y=0;for(const H of Z.slice(0,D)){Y++;const K=O(H),C=[];for(let F=0;F<K.length;F++){let G=K[F];G=`(shared with ${P.get(K.slice(0,F+1).join(`
`)).size}/${Z.length} leaks) at ${G}`;const fe=P.get(K.slice(0,F).join(`
`)),we=(0,n.$E)([...fe].map(r=>O(r)[F]),r=>r);delete we[K[F]];for(const[r,Te]of Object.entries(we))C.unshift(`    - stacktraces of ${Te.length} other leaks continue with ${r}`);C.unshift(G)}X+=`


==================== Leaking disposable ${Y}/${Z.length}: ${H.value.constructor.name} ====================
${C.join(`
`)}
============================================================

`}return Z.length>D&&(X+=`


... and ${Z.length-D} more leaking disposables

`),{leaks:Z,details:X}}}i.$Jc=l,l.a=0;function f(S){a=S}if(b){const S="__is_disposable_tracked__";f(new class{trackDisposable(D){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{D[S]||console.log(B)},3e3)}setParent(D,B){if(D&&D!==u.None)try{D[S]=!0}catch{}}markAsDisposed(D){if(D&&D!==u.None)try{D[S]=!0}catch{}}markAsSingleton(D){}})}function $(S){return a?.trackDisposable(S),S}function d(S){a?.markAsDisposed(S)}function E(S,D){a?.setParent(S,D)}function e(S,D){if(a)for(const B of S)a.setParent(B,D)}function m(S){return a?.markAsSingleton(S),S}function v(S){return typeof S=="object"&&S!==null&&typeof S.dispose=="function"&&S.dispose.length===0}function R(S){if(w.Iterable.is(S)){const D=[];for(const B of S)if(B)try{B.dispose()}catch(Z){D.push(Z)}if(D.length===1)throw D[0];if(D.length>1)throw new AggregateError(D,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}function A(S){for(const D of S)v(D)&&D.dispose();return[]}function L(...S){const D=N(()=>R(S));return e(S,D),D}function N(S){const D=$({dispose:(0,g.$db)(()=>{d(D),S()})});return D}class c{constructor(){this.f=new Set,this.g=!1,$(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{R(this.f)}finally{this.f.clear()}}add(D){if(!D)return D;if(D===this)throw new Error("Cannot register a disposable on itself!");return E(D,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(D),D}delete(D){if(D){if(D===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(D),D.dispose()}}deleteAndLeak(D){D&&this.f.has(D)&&(this.f.delete(D),E(D,null))}}i.$Tc=c,c.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this.q=new c,$(this),E(this.q,this)}dispose(){d(this),this.q.dispose()}B(D){if(D===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(D)}}i.$Uc=u,u.None=Object.freeze({dispose(){}});class s{constructor(){this.b=!1,$(this)}get value(){return this.b?void 0:this.a}set value(D){this.b||D===this.a||(this.a?.dispose(),D&&E(D,this),this.a=D)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const D=this.a;return this.a=void 0,D&&E(D,null),D}}i.$Vc=s;class o{constructor(D){this.a=new s,this.b=!1,this.a.value=D}get value(){return this.a.value}set value(D){this.b||D===this.a.value||(this.a.value=D)}dispose(){this.b=!0,this.a.dispose()}}i.$Wc=o;class h{constructor(D){this.b=D,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}i.$Xc=h;class U{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,$(this)}set(D){let B=D;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,d(this))},this}}i.$Yc=U;class _{constructor(){this.a=new Map}acquire(D,...B){let Z=this.a.get(D);Z||(Z={counter:0,object:this.b(D,...B)},this.a.set(D,Z));const{object:O}=Z,P=(0,g.$db)(()=>{--Z.counter===0&&(this.c(D,Z.object),this.a.delete(D))});return Z.counter++,{object:O,dispose:P}}}i.$Zc=_;class T{constructor(D){this.a=D}async acquire(D,...B){const Z=this.a.acquire(D,...B);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(O){throw Z.dispose(),O}}}i.$1c=T;class M{constructor(D){this.object=D}dispose(){}}i.$2c=M;function j(S){const D=new c;try{S(D)}finally{D.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,$(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{R(this.a.values())}finally{this.a.clear()}}has(D){return this.a.has(D)}get size(){return this.a.size}get(D){return this.a.get(D)}set(D,B,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(D)?.dispose(),this.a.set(D,B)}deleteAndDispose(D){this.a.get(D)?.dispose(),this.a.delete(D)}deleteAndLeak(D){const B=this.a.get(D);return this.a.delete(D),B}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}i.$4c=I}),ne(ie[42],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.MarshalledId=void 0;var t;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadInstance=8]="CommentThreadInstance",n[n.CommentThreadReply=9]="CommentThreadReply",n[n.CommentNode=10]="CommentNode",n[n.CommentThreadNode=11]="CommentThreadNode",n[n.TimelineActionContext=12]="TimelineActionContext",n[n.NotebookCellActionContext=13]="NotebookCellActionContext",n[n.NotebookActionContext=14]="NotebookActionContext",n[n.TerminalContext=15]="TerminalContext",n[n.TestItemContext=16]="TestItemContext",n[n.Date=17]="Date",n[n.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(t||(i.MarshalledId=t={}))}),ne(ie[17],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$C=i.$B=i.$A=i.$z=i.$y=i.OS=i.OperatingSystem=i.$v=i.$u=i.$t=i.$s=i.$r=i.Language=i.$q=i.$p=i.$o=i.$n=i.$m=i.$l=i.$k=i.$j=i.$i=i.$h=i.$g=i.$f=i.$e=i.$d=i.$c=i.Platform=i.$a=void 0,i.$b=u,i.$x=T,i.$D=M,i.$a="en";let t=!1,n=!1,p=!1,g=!1,w=!1,b=!1,a=!1,l=!1,f=!1,$=!1,d,E=i.$a,e=i.$a,m,v;const R=globalThis;let A;typeof R.vscode<"u"&&typeof R.vscode.process<"u"?A=R.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(A=process);const L=typeof A?.versions?.electron=="string",N=L&&A?.type==="renderer";if(typeof A=="object"){t=A.platform==="win32",n=A.platform==="darwin",p=A.platform==="linux",g=p&&!!A.env.SNAP&&!!A.env.SNAP_REVISION,a=L,f=!!A.env.CI||!!A.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=i.$a,E=i.$a;const j=A.env.VSCODE_NLS_CONFIG;if(j)try{const I=JSON.parse(j),S=I.availableLanguages["*"];d=I.locale,e=I.osLocale,E=S||i.$a,m=I._translationsConfigFile}catch{}w=!0}else if(typeof navigator=="object"&&!N){v=navigator.userAgent,t=v.indexOf("Windows")>=0,n=v.indexOf("Macintosh")>=0,l=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,p=v.indexOf("Linux")>=0,$=v?.indexOf("Mobi")>=0,b=!0,d=i.$a,E=d,e=navigator.language;const j=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),I=j&&j.getAttribute("data-settings");if(I)try{const S=JSON.parse(I),D=S.availableLanguages["*"];d=S.locale,e=S.osLocale,E=D||i.$a,m=S._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var c;(function(j){j[j.Web=0]="Web",j[j.Mac=1]="Mac",j[j.Linux=2]="Linux",j[j.Windows=3]="Windows"})(c||(i.Platform=c={}));function u(j){switch(j){case c.Web:return"Web";case c.Mac:return"Mac";case c.Linux:return"Linux";case c.Windows:return"Windows"}}let s=c.Web;n?s=c.Mac:t?s=c.Windows:p&&(s=c.Linux),i.$c=t,i.$d=n,i.$e=p,i.$f=g,i.$g=w,i.$h=a,i.$i=b,i.$j=b&&typeof R.importScripts=="function",i.$k=i.$j?R.origin:void 0,i.$l=l,i.$m=$,i.$n=f,i.$o=s,i.$p=v,i.$q=E;var o;(function(j){function I(){return i.$q}j.value=I;function S(){return i.$q.length===2?i.$q==="en":i.$q.length>=3?i.$q[0]==="e"&&i.$q[1]==="n"&&i.$q[2]==="-":!1}j.isDefaultVariant=S;function D(){return i.$q==="en"}j.isDefault=D})(o||(i.Language=o={})),i.$r=d,i.$s=e,i.$t=m,i.$u=typeof R.postMessage=="function"&&!R.importScripts,i.$v=(()=>{if(i.$u){const j=[];R.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let D=0,B=j.length;D<B;D++){const Z=j[D];if(Z.id===S.data.vscodeScheduleAsyncWork){j.splice(D,1),Z.callback();return}}});let I=0;return S=>{const D=++I;j.push({id:D,callback:S}),R.postMessage({vscodeScheduleAsyncWork:D},"*")}}return j=>setTimeout(j)})();var h;(function(j){j[j.Windows=1]="Windows",j[j.Macintosh=2]="Macintosh",j[j.Linux=3]="Linux"})(h||(i.OperatingSystem=h={})),i.OS=n||l?h.Macintosh:t?h.Windows:h.Linux;let U=!0,_=!1;function T(){if(!_){_=!0;const j=new Uint8Array(2);j[0]=1,j[1]=2,U=new Uint16Array(j.buffer)[0]===513}return U}i.$y=!!(i.$p&&i.$p.indexOf("Chrome")>=0),i.$z=!!(i.$p&&i.$p.indexOf("Firefox")>=0),i.$A=!!(!i.$y&&i.$p&&i.$p.indexOf("Safari")>=0),i.$B=!!(i.$p&&i.$p.indexOf("Edg/")>=0),i.$C=!!(i.$p&&i.$p.indexOf("Android")>=0);function M(j){return parseFloat(j)>=20}}),ne(ie[43],re([0,1,17]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ec=i.$dc=i.env=i.cwd=void 0;let n;const p=globalThis.vscode;if(typeof p<"u"&&typeof p.process<"u"){const g=p.process;n={get platform(){return g.platform},get arch(){return g.arch},get env(){return g.env},cwd(){return g.cwd()}}}else typeof process<"u"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return t.$c?"win32":t.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};i.cwd=n.cwd,i.env=n.env,i.$dc=n.platform,i.$ec=n.arch}),ne(ie[44],re([0,1,43]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$tc=i.sep=i.$rc=i.$qc=i.$pc=i.$oc=i.$nc=i.$mc=i.$lc=i.$kc=i.$jc=i.$ic=i.$hc=i.$gc=i.$fc=void 0;const n=65,p=97,g=90,w=122,b=46,a=47,l=92,f=58,$=63;class d extends Error{constructor(s,o,h){let U;typeof o=="string"&&o.indexOf("not ")===0?(U="must not be",o=o.replace(/^not /,"")):U="must be";const _=s.indexOf(".")!==-1?"property":"argument";let T=`The "${s}" ${_} ${U} of type ${o}`;T+=`. Received type ${typeof h}`,super(T),this.code="ERR_INVALID_ARG_TYPE"}}function E(u,s){if(u===null||typeof u!="object")throw new d(s,"Object",u)}function e(u,s){if(typeof u!="string")throw new d(s,"string",u)}const m=t.$dc==="win32";function v(u){return u===a||u===l}function R(u){return u===a}function A(u){return u>=n&&u<=g||u>=p&&u<=w}function L(u,s,o,h){let U="",_=0,T=-1,M=0,j=0;for(let I=0;I<=u.length;++I){if(I<u.length)j=u.charCodeAt(I);else{if(h(j))break;j=a}if(h(j)){if(!(T===I-1||M===1))if(M===2){if(U.length<2||_!==2||U.charCodeAt(U.length-1)!==b||U.charCodeAt(U.length-2)!==b){if(U.length>2){const S=U.lastIndexOf(o);S===-1?(U="",_=0):(U=U.slice(0,S),_=U.length-1-U.lastIndexOf(o)),T=I,M=0;continue}else if(U.length!==0){U="",_=0,T=I,M=0;continue}}s&&(U+=U.length>0?`${o}..`:"..",_=2)}else U.length>0?U+=`${o}${u.slice(T+1,I)}`:U=u.slice(T+1,I),_=I-T-1;T=I,M=0}else j===b&&M!==-1?++M:M=-1}return U}function N(u,s){E(s,"pathObject");const o=s.dir||s.root,h=s.base||`${s.name||""}${s.ext||""}`;return o?o===s.root?`${o}${h}`:`${o}${u}${h}`:h}i.$fc={resolve(...u){let s="",o="",h=!1;for(let U=u.length-1;U>=-1;U--){let _;if(U>=0){if(_=u[U],e(_,"path"),_.length===0)continue}else s.length===0?_=t.cwd():(_=t.env[`=${s}`]||t.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==s.toLowerCase()&&_.charCodeAt(2)===l)&&(_=`${s}\\`));const T=_.length;let M=0,j="",I=!1;const S=_.charCodeAt(0);if(T===1)v(S)&&(M=1,I=!0);else if(v(S))if(I=!0,v(_.charCodeAt(1))){let D=2,B=D;for(;D<T&&!v(_.charCodeAt(D));)D++;if(D<T&&D!==B){const Z=_.slice(B,D);for(B=D;D<T&&v(_.charCodeAt(D));)D++;if(D<T&&D!==B){for(B=D;D<T&&!v(_.charCodeAt(D));)D++;(D===T||D!==B)&&(j=`\\\\${Z}\\${_.slice(B,D)}`,M=D)}}}else M=1;else A(S)&&_.charCodeAt(1)===f&&(j=_.slice(0,2),M=2,T>2&&v(_.charCodeAt(2))&&(I=!0,M=3));if(j.length>0)if(s.length>0){if(j.toLowerCase()!==s.toLowerCase())continue}else s=j;if(h){if(s.length>0)break}else if(o=`${_.slice(M)}\\${o}`,h=I,I&&s.length>0)break}return o=L(o,!h,"\\",v),h?`${s}\\${o}`:`${s}${o}`||"."},normalize(u){e(u,"path");const s=u.length;if(s===0)return".";let o=0,h,U=!1;const _=u.charCodeAt(0);if(s===1)return R(_)?"\\":u;if(v(_))if(U=!0,v(u.charCodeAt(1))){let M=2,j=M;for(;M<s&&!v(u.charCodeAt(M));)M++;if(M<s&&M!==j){const I=u.slice(j,M);for(j=M;M<s&&v(u.charCodeAt(M));)M++;if(M<s&&M!==j){for(j=M;M<s&&!v(u.charCodeAt(M));)M++;if(M===s)return`\\\\${I}\\${u.slice(j)}\\`;M!==j&&(h=`\\\\${I}\\${u.slice(j,M)}`,o=M)}}}else o=1;else A(_)&&u.charCodeAt(1)===f&&(h=u.slice(0,2),o=2,s>2&&v(u.charCodeAt(2))&&(U=!0,o=3));let T=o<s?L(u.slice(o),!U,"\\",v):"";return T.length===0&&!U&&(T="."),T.length>0&&v(u.charCodeAt(s-1))&&(T+="\\"),h===void 0?U?`\\${T}`:T:U?`${h}\\${T}`:`${h}${T}`},isAbsolute(u){e(u,"path");const s=u.length;if(s===0)return!1;const o=u.charCodeAt(0);return v(o)||s>2&&A(o)&&u.charCodeAt(1)===f&&v(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let s,o;for(let _=0;_<u.length;++_){const T=u[_];e(T,"path"),T.length>0&&(s===void 0?s=o=T:s+=`\\${T}`)}if(s===void 0)return".";let h=!0,U=0;if(typeof o=="string"&&v(o.charCodeAt(0))){++U;const _=o.length;_>1&&v(o.charCodeAt(1))&&(++U,_>2&&(v(o.charCodeAt(2))?++U:h=!1))}if(h){for(;U<s.length&&v(s.charCodeAt(U));)U++;U>=2&&(s=`\\${s.slice(U)}`)}return i.$fc.normalize(s)},relative(u,s){if(e(u,"from"),e(s,"to"),u===s)return"";const o=i.$fc.resolve(u),h=i.$fc.resolve(s);if(o===h||(u=o.toLowerCase(),s=h.toLowerCase(),u===s))return"";let U=0;for(;U<u.length&&u.charCodeAt(U)===l;)U++;let _=u.length;for(;_-1>U&&u.charCodeAt(_-1)===l;)_--;const T=_-U;let M=0;for(;M<s.length&&s.charCodeAt(M)===l;)M++;let j=s.length;for(;j-1>M&&s.charCodeAt(j-1)===l;)j--;const I=j-M,S=T<I?T:I;let D=-1,B=0;for(;B<S;B++){const O=u.charCodeAt(U+B);if(O!==s.charCodeAt(M+B))break;O===l&&(D=B)}if(B!==S){if(D===-1)return h}else{if(I>S){if(s.charCodeAt(M+B)===l)return h.slice(M+B+1);if(B===2)return h.slice(M+B)}T>S&&(u.charCodeAt(U+B)===l?D=B:B===2&&(D=3)),D===-1&&(D=0)}let Z="";for(B=U+D+1;B<=_;++B)(B===_||u.charCodeAt(B)===l)&&(Z+=Z.length===0?"..":"\\..");return M+=D,Z.length>0?`${Z}${h.slice(M,j)}`:(h.charCodeAt(M)===l&&++M,h.slice(M,j))},toNamespacedPath(u){if(typeof u!="string"||u.length===0)return u;const s=i.$fc.resolve(u);if(s.length<=2)return u;if(s.charCodeAt(0)===l){if(s.charCodeAt(1)===l){const o=s.charCodeAt(2);if(o!==$&&o!==b)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(A(s.charCodeAt(0))&&s.charCodeAt(1)===f&&s.charCodeAt(2)===l)return`\\\\?\\${s}`;return u},dirname(u){e(u,"path");const s=u.length;if(s===0)return".";let o=-1,h=0;const U=u.charCodeAt(0);if(s===1)return v(U)?u:".";if(v(U)){if(o=h=1,v(u.charCodeAt(1))){let M=2,j=M;for(;M<s&&!v(u.charCodeAt(M));)M++;if(M<s&&M!==j){for(j=M;M<s&&v(u.charCodeAt(M));)M++;if(M<s&&M!==j){for(j=M;M<s&&!v(u.charCodeAt(M));)M++;if(M===s)return u;M!==j&&(o=h=M+1)}}}}else A(U)&&u.charCodeAt(1)===f&&(o=s>2&&v(u.charCodeAt(2))?3:2,h=o);let _=-1,T=!0;for(let M=s-1;M>=h;--M)if(v(u.charCodeAt(M))){if(!T){_=M;break}}else T=!1;if(_===-1){if(o===-1)return".";_=o}return u.slice(0,_)},basename(u,s){s!==void 0&&e(s,"ext"),e(u,"path");let o=0,h=-1,U=!0,_;if(u.length>=2&&A(u.charCodeAt(0))&&u.charCodeAt(1)===f&&(o=2),s!==void 0&&s.length>0&&s.length<=u.length){if(s===u)return"";let T=s.length-1,M=-1;for(_=u.length-1;_>=o;--_){const j=u.charCodeAt(_);if(v(j)){if(!U){o=_+1;break}}else M===-1&&(U=!1,M=_+1),T>=0&&(j===s.charCodeAt(T)?--T===-1&&(h=_):(T=-1,h=M))}return o===h?h=M:h===-1&&(h=u.length),u.slice(o,h)}for(_=u.length-1;_>=o;--_)if(v(u.charCodeAt(_))){if(!U){o=_+1;break}}else h===-1&&(U=!1,h=_+1);return h===-1?"":u.slice(o,h)},extname(u){e(u,"path");let s=0,o=-1,h=0,U=-1,_=!0,T=0;u.length>=2&&u.charCodeAt(1)===f&&A(u.charCodeAt(0))&&(s=h=2);for(let M=u.length-1;M>=s;--M){const j=u.charCodeAt(M);if(v(j)){if(!_){h=M+1;break}continue}U===-1&&(_=!1,U=M+1),j===b?o===-1?o=M:T!==1&&(T=1):o!==-1&&(T=-1)}return o===-1||U===-1||T===0||T===1&&o===U-1&&o===h+1?"":u.slice(o,U)},format:N.bind(null,"\\"),parse(u){e(u,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return s;const o=u.length;let h=0,U=u.charCodeAt(0);if(o===1)return v(U)?(s.root=s.dir=u,s):(s.base=s.name=u,s);if(v(U)){if(h=1,v(u.charCodeAt(1))){let D=2,B=D;for(;D<o&&!v(u.charCodeAt(D));)D++;if(D<o&&D!==B){for(B=D;D<o&&v(u.charCodeAt(D));)D++;if(D<o&&D!==B){for(B=D;D<o&&!v(u.charCodeAt(D));)D++;D===o?h=D:D!==B&&(h=D+1)}}}}else if(A(U)&&u.charCodeAt(1)===f){if(o<=2)return s.root=s.dir=u,s;if(h=2,v(u.charCodeAt(2))){if(o===3)return s.root=s.dir=u,s;h=3}}h>0&&(s.root=u.slice(0,h));let _=-1,T=h,M=-1,j=!0,I=u.length-1,S=0;for(;I>=h;--I){if(U=u.charCodeAt(I),v(U)){if(!j){T=I+1;break}continue}M===-1&&(j=!1,M=I+1),U===b?_===-1?_=I:S!==1&&(S=1):_!==-1&&(S=-1)}return M!==-1&&(_===-1||S===0||S===1&&_===M-1&&_===T+1?s.base=s.name=u.slice(T,M):(s.name=u.slice(T,_),s.base=u.slice(T,M),s.ext=u.slice(_,M))),T>0&&T!==h?s.dir=u.slice(0,T-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(m){const u=/\\/g;return()=>{const s=t.cwd().replace(u,"/");return s.slice(s.indexOf("/"))}}return()=>t.cwd()})();i.$gc={resolve(...u){let s="",o=!1;for(let h=u.length-1;h>=-1&&!o;h--){const U=h>=0?u[h]:c();e(U,"path"),U.length!==0&&(s=`${U}/${s}`,o=U.charCodeAt(0)===a)}return s=L(s,!o,"/",R),o?`/${s}`:s.length>0?s:"."},normalize(u){if(e(u,"path"),u.length===0)return".";const s=u.charCodeAt(0)===a,o=u.charCodeAt(u.length-1)===a;return u=L(u,!s,"/",R),u.length===0?s?"/":o?"./":".":(o&&(u+="/"),s?`/${u}`:u)},isAbsolute(u){return e(u,"path"),u.length>0&&u.charCodeAt(0)===a},join(...u){if(u.length===0)return".";let s;for(let o=0;o<u.length;++o){const h=u[o];e(h,"path"),h.length>0&&(s===void 0?s=h:s+=`/${h}`)}return s===void 0?".":i.$gc.normalize(s)},relative(u,s){if(e(u,"from"),e(s,"to"),u===s||(u=i.$gc.resolve(u),s=i.$gc.resolve(s),u===s))return"";const o=1,h=u.length,U=h-o,_=1,T=s.length-_,M=U<T?U:T;let j=-1,I=0;for(;I<M;I++){const D=u.charCodeAt(o+I);if(D!==s.charCodeAt(_+I))break;D===a&&(j=I)}if(I===M)if(T>M){if(s.charCodeAt(_+I)===a)return s.slice(_+I+1);if(I===0)return s.slice(_+I)}else U>M&&(u.charCodeAt(o+I)===a?j=I:I===0&&(j=0));let S="";for(I=o+j+1;I<=h;++I)(I===h||u.charCodeAt(I)===a)&&(S+=S.length===0?"..":"/..");return`${S}${s.slice(_+j)}`},toNamespacedPath(u){return u},dirname(u){if(e(u,"path"),u.length===0)return".";const s=u.charCodeAt(0)===a;let o=-1,h=!0;for(let U=u.length-1;U>=1;--U)if(u.charCodeAt(U)===a){if(!h){o=U;break}}else h=!1;return o===-1?s?"/":".":s&&o===1?"//":u.slice(0,o)},basename(u,s){s!==void 0&&e(s,"ext"),e(u,"path");let o=0,h=-1,U=!0,_;if(s!==void 0&&s.length>0&&s.length<=u.length){if(s===u)return"";let T=s.length-1,M=-1;for(_=u.length-1;_>=0;--_){const j=u.charCodeAt(_);if(j===a){if(!U){o=_+1;break}}else M===-1&&(U=!1,M=_+1),T>=0&&(j===s.charCodeAt(T)?--T===-1&&(h=_):(T=-1,h=M))}return o===h?h=M:h===-1&&(h=u.length),u.slice(o,h)}for(_=u.length-1;_>=0;--_)if(u.charCodeAt(_)===a){if(!U){o=_+1;break}}else h===-1&&(U=!1,h=_+1);return h===-1?"":u.slice(o,h)},extname(u){e(u,"path");let s=-1,o=0,h=-1,U=!0,_=0;for(let T=u.length-1;T>=0;--T){const M=u.charCodeAt(T);if(M===a){if(!U){o=T+1;break}continue}h===-1&&(U=!1,h=T+1),M===b?s===-1?s=T:_!==1&&(_=1):s!==-1&&(_=-1)}return s===-1||h===-1||_===0||_===1&&s===h-1&&s===o+1?"":u.slice(s,h)},format:N.bind(null,"/"),parse(u){e(u,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return s;const o=u.charCodeAt(0)===a;let h;o?(s.root="/",h=1):h=0;let U=-1,_=0,T=-1,M=!0,j=u.length-1,I=0;for(;j>=h;--j){const S=u.charCodeAt(j);if(S===a){if(!M){_=j+1;break}continue}T===-1&&(M=!1,T=j+1),S===b?U===-1?U=j:I!==1&&(I=1):U!==-1&&(I=-1)}if(T!==-1){const S=_===0&&o?1:_;U===-1||I===0||I===1&&U===T-1&&U===_+1?s.base=s.name=u.slice(S,T):(s.name=u.slice(S,U),s.base=u.slice(S,T),s.ext=u.slice(U,T))}return _>0?s.dir=u.slice(0,_-1):o&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},i.$gc.win32=i.$fc.win32=i.$fc,i.$gc.posix=i.$fc.posix=i.$gc,i.$hc=m?i.$fc.normalize:i.$gc.normalize,i.$ic=m?i.$fc.isAbsolute:i.$gc.isAbsolute,i.$jc=m?i.$fc.join:i.$gc.join,i.$kc=m?i.$fc.resolve:i.$gc.resolve,i.$lc=m?i.$fc.relative:i.$gc.relative,i.$mc=m?i.$fc.dirname:i.$gc.dirname,i.$nc=m?i.$fc.basename:i.$gc.basename,i.$oc=m?i.$fc.extname:i.$gc.extname,i.$pc=m?i.$fc.format:i.$gc.format,i.$qc=m?i.$fc.parse:i.$gc.parse,i.$rc=m?i.$fc.toNamespacedPath:i.$gc.toNamespacedPath,i.sep=m?i.$fc.sep:i.$gc.sep,i.$tc=m?i.$fc.delimiter:i.$gc.delimiter}),ne(ie[25],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$be=void 0;const t=globalThis.performance&&typeof globalThis.performance.now=="function";class n{static create(g){return new n(g)}constructor(g){this.c=t&&g===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}i.$be=n}),ne(ie[13],re([0,1,4,22,12,24,25]),function(q,i,t,n,p,g,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$re=i.$qe=i.$pe=i.$oe=i.$ne=i.$me=i.$le=i.$ke=i.$je=i.$ie=i.$he=i.$ge=i.$fe=i.$de=i.Event=void 0,i.$ee=E;const b=!1,a=!1,l=!1;var f;(function(O){O.None=()=>p.$Uc.None;function P(se){if(l){const{onDidAddListener:te}=se,ae=m.create();let ue=0;se.onDidAddListener=()=>{++ue===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ae.print()),te?.()}}}function X(se,te){return r(se,()=>{},0,void 0,!0,void 0,te)}O.defer=X;function Y(se){return(te,ae=null,ue)=>{let ce=!1,ge;return ge=se($e=>{if(!ce)return ge?ge.dispose():ce=!0,te.call(ae,$e)},null,ue),ce&&ge.dispose(),ge}}O.once=Y;function H(se,te,ae){return fe((ue,ce=null,ge)=>se($e=>ue.call(ce,te($e)),null,ge),ae)}O.map=H;function K(se,te,ae){return fe((ue,ce=null,ge)=>se($e=>{te($e),ue.call(ce,$e)},null,ge),ae)}O.forEach=K;function C(se,te,ae){return fe((ue,ce=null,ge)=>se($e=>te($e)&&ue.call(ce,$e),null,ge),ae)}O.filter=C;function F(se){return se}O.signal=F;function G(...se){return(te,ae=null,ue)=>{const ce=(0,p.$Rc)(...se.map(ge=>ge($e=>te.call(ae,$e))));return we(ce,ue)}}O.any=G;function oe(se,te,ae,ue){let ce=ae;return H(se,ge=>(ce=te(ce,ge),ce),ue)}O.reduce=oe;function fe(se,te){let ae;const ue={onWillAddFirstListener(){ae=se(ce.fire,ce)},onDidRemoveLastListener(){ae?.dispose()}};te||P(ue);const ce=new s(ue);return te?.add(ce),ce.event}function we(se,te){return te instanceof Array?te.push(se):te&&te.add(se),se}function r(se,te,ae=100,ue=!1,ce=!1,ge,$e){let Ee,Re,Se,Be=0,Pe;const me={leakWarningThreshold:ge,onWillAddFirstListener(){Ee=se(He=>{Be++,Re=te(Re,He),ue&&!Se&&(Ue.fire(Re),Re=void 0),Pe=()=>{const Ge=Re;Re=void 0,Se=void 0,(!ue||Be>1)&&Ue.fire(Ge),Be=0},typeof ae=="number"?(clearTimeout(Se),Se=setTimeout(Pe,ae)):Se===void 0&&(Se=0,queueMicrotask(Pe))})},onWillRemoveListener(){ce&&Be>0&&Pe?.()},onDidRemoveLastListener(){Pe=void 0,Ee.dispose()}};$e||P(me);const Ue=new s(me);return $e?.add(Ue),Ue.event}O.debounce=r;function Te(se,te=0,ae){return O.debounce(se,(ue,ce)=>ue?(ue.push(ce),ue):[ce],te,void 0,!0,void 0,ae)}O.accumulate=Te;function Me(se,te=(ue,ce)=>ue===ce,ae){let ue=!0,ce;return C(se,ge=>{const $e=ue||!te(ge,ce);return ue=!1,ce=ge,$e},ae)}O.latch=Me;function xe(se,te,ae){return[O.filter(se,te,ae),O.filter(se,ue=>!te(ue),ae)]}O.split=xe;function De(se,te=!1,ae=[],ue){let ce=ae.slice(),ge=se(Re=>{ce?ce.push(Re):Ee.fire(Re)});ue&&ue.add(ge);const $e=()=>{ce?.forEach(Re=>Ee.fire(Re)),ce=null},Ee=new s({onWillAddFirstListener(){ge||(ge=se(Re=>Ee.fire(Re)),ue&&ue.add(ge))},onDidAddFirstListener(){ce&&(te?setTimeout($e):$e())},onDidRemoveLastListener(){ge&&ge.dispose(),ge=null}});return ue&&ue.add(Ee),Ee.event}O.buffer=De;function Fe(se,te){return(ue,ce,ge)=>{const $e=te(new W);return se(function(Ee){const Re=$e.evaluate(Ee);Re!==x&&ue.call(ce,Re)},void 0,ge)}}O.chain=Fe;const x=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(te){return this.f.push(te),this}forEach(te){return this.f.push(ae=>(te(ae),ae)),this}filter(te){return this.f.push(ae=>te(ae)?ae:x),this}reduce(te,ae){let ue=ae;return this.f.push(ce=>(ue=te(ue,ce),ue)),this}latch(te=(ae,ue)=>ae===ue){let ae=!0,ue;return this.f.push(ce=>{const ge=ae||!te(ce,ue);return ae=!1,ue=ce,ge?ce:x}),this}evaluate(te){for(const ae of this.f)if(te=ae(te),te===x)break;return te}}function V(se,te,ae=ue=>ue){const ue=(...Ee)=>$e.fire(ae(...Ee)),ce=()=>se.on(te,ue),ge=()=>se.removeListener(te,ue),$e=new s({onWillAddFirstListener:ce,onDidRemoveLastListener:ge});return $e.event}O.fromNodeEventEmitter=V;function J(se,te,ae=ue=>ue){const ue=(...Ee)=>$e.fire(ae(...Ee)),ce=()=>se.addEventListener(te,ue),ge=()=>se.removeEventListener(te,ue),$e=new s({onWillAddFirstListener:ce,onDidRemoveLastListener:ge});return $e.event}O.fromDOMEventEmitter=J;function ee(se){return new Promise(te=>Y(se)(te))}O.toPromise=ee;function he(se){const te=new s;return se.then(ae=>{te.fire(ae)},()=>{te.fire(void 0)}).finally(()=>{te.dispose()}),te.event}O.fromPromise=he;function de(se,te,ae){return te(ae),se(ue=>te(ue))}O.runAndSubscribe=de;class Ne{constructor(te,ae){this._observable=te,this.f=0,this.g=!1;const ue={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};ae||P(ue),this.emitter=new s(ue),ae&&ae.add(this.emitter)}beginUpdate(te){this.f++}handlePossibleChange(te){}handleChange(te,ae){this.g=!0}endUpdate(te){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ae(se,te){return new Ne(se,te).emitter.event}O.fromObservable=Ae;function pe(se){return(te,ae,ue)=>{let ce=0,ge=!1;const $e={beginUpdate(){ce++},endUpdate(){ce--,ce===0&&(se.reportChanges(),ge&&(ge=!1,te.call(ae)))},handlePossibleChange(){},handleChange(){ge=!0}};se.addObserver($e),se.reportChanges();const Ee={dispose(){se.removeObserver($e)}};return ue instanceof p.$Tc?ue.add(Ee):Array.isArray(ue)&&ue.push(Ee),Ee}}O.fromObservableLight=pe})(f||(i.Event=f={}));class ${constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${$.f++}`,$.all.add(this)}start(P){this.g=new w.$be,this.listenerCount=P}stop(){if(this.g){const P=this.g.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.g=void 0}}}i.$de=$,$.all=new Set,$.f=0;let d=-1;function E(O){const P=d;return d=O,{dispose(){d=P}}}class e{constructor(P,X,Y=Math.random().toString(18).slice(2,5)){this.h=P,this.threshold=X,this.name=Y,this.g=0}dispose(){this.f?.clear()}check(P,X){const Y=this.threshold;if(Y<=0||X<Y)return;this.f||(this.f=new Map);const H=this.f.get(P.value)||0;if(this.f.set(P.value,H+1),this.g-=1,this.g<=0){this.g=Y*.5;const[K,C]=this.getMostFrequentStack(),F=`[${this.name}] potential listener LEAK detected, having ${X} listeners already. MOST frequent listener (${C}):`;console.warn(F),console.warn(K);const G=new v(F,K);this.h(G)}return()=>{const K=this.f.get(P.value)||0;this.f.set(P.value,K-1)}}getMostFrequentStack(){if(!this.f)return;let P,X=0;for(const[Y,H]of this.f)(!P||X<H)&&(P=[Y,H],X=H);return P}}class m{static create(){const P=new Error;return new m(P.stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v extends Error{constructor(P,X){super(P),this.name="ListenerLeakError",this.stack=X}}i.$fe=v;class R extends Error{constructor(P,X){super(P),this.name="ListenerRefusalError",this.stack=X}}i.$ge=R;let A=0;class L{constructor(P){this.value=P,this.id=A++}}const N=2,c=(O,P)=>{if(O instanceof L)P(O);else for(let X=0;X<O.length;X++){const Y=O[X];Y&&P(Y)}},u=b?new FinalizationRegistry(O=>{typeof O=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(O))}):void 0;class s{constructor(P){this.w=0,this.f=P,this.g=d>0||this.f?.leakWarningThreshold?new e(P?.onListenerError??t.$1,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new $(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(a){const P=this.t;queueMicrotask(()=>{c(P,X=>X.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(P,X,Y)=>{if(this.g&&this.w>this.g.threshold**2){const G=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(G);const oe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],fe=new R(`${G}. HINT: Stack shows most frequent listener (${oe[1]}-times)`,oe[0]);return(this.f?.onListenerError||t.$1)(fe),p.$Uc.None}if(this.m)return p.$Uc.None;X&&(P=P.bind(X));const H=new L(P);let K,C;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(H.stack=m.create(),K=this.g.check(H.stack,this.w+1)),a&&(H.stack=C??m.create()),this.t?this.t instanceof L?(this.u??(this.u=new h),this.t=[this.t,H]):this.t.push(H):(this.f?.onWillAddFirstListener?.(this),this.t=H,this.f?.onDidAddFirstListener?.(this)),this.w++;const F=(0,p.$Sc)(()=>{u?.unregister(F),K?.(),this.x(H)});if(Y instanceof p.$Tc?Y.add(F):Array.isArray(Y)&&Y.push(F),u){const G=new Error().stack.split(`
`).slice(2).join(`
`).trim();u.register(F,G,F)}return F}),this.q}x(P){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const X=this.t,Y=X.indexOf(P);if(Y===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,X[Y]=void 0;const H=this.u.current===this;if(this.w*N<=X.length){let K=0;for(let C=0;C<X.length;C++)X[C]?X[K++]=X[C]:H&&(this.u.end--,K<this.u.i&&this.u.i--);X.length=K}}y(P,X){if(!P)return;const Y=this.f?.onListenerError||t.$1;if(!Y){P.value(X);return}try{P.value(X)}catch(H){Y(H)}}z(P){const X=P.current.t;for(;P.i<P.end;)this.y(X[P.i++],P.value);P.reset()}fire(P){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof L)this.y(this.t,P);else{const X=this.u;X.enqueue(this,P,this.t.length),this.z(X)}this.j?.stop()}hasListeners(){return this.w>0}}i.$he=s;const o=()=>new h;i.$ie=o;class h{constructor(){this.i=-1,this.end=0}enqueue(P,X,Y){this.i=0,this.end=Y,this.current=P,this.value=X}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class U extends s{async fireAsync(P,X,Y){if(this.t)for(this.h||(this.h=new g.$5c),c(this.t,H=>this.h.push([H.value,P]));this.h.size>0&&!X.isCancellationRequested;){const[H,K]=this.h.shift(),C=[],F={...K,token:X,waitUntil:G=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");Y&&(G=Y(G,H)),C.push(G)}};try{H(F)}catch(G){(0,t.$1)(G);continue}Object.freeze(C),await Promise.allSettled(C).then(G=>{for(const oe of G)oe.status==="rejected"&&(0,t.$1)(oe.reason)})}}}i.$je=U;class _ extends s{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new g.$5c,this.A=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.A(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.w&&(this.h!==0?this.s.push(P):super.fire(P))}}i.$ke=_;class T extends _{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}i.$le=T;class M extends s{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(X=>super.fire(X)),this.h=[]}))}}i.$me=M;class j{constructor(){this.g=!1,this.h=[],this.f=new s({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(P){const X={event:P,listener:null};this.h.push(X),this.g&&this.m(X);const Y=()=>{this.g&&this.o(X);const H=this.h.indexOf(X);this.h.splice(H,1)};return(0,p.$Sc)((0,n.$db)(Y))}j(){this.g=!0,this.h.forEach(P=>this.m(P))}k(){this.g=!1,this.h.forEach(P=>this.o(P))}m(P){P.listener=P.event(X=>this.f.fire(X))}o(P){P.listener?.dispose(),P.listener=null}dispose(){this.f.dispose();for(const P of this.h)P.listener?.dispose();this.h=[]}}i.$ne=j;class I{constructor(P,X,Y,H){this.f=new p.$Tc;const K=this.f.add(new j),C=this.f.add(new p.$4c);function F(G){C.set(G,K.add(H(G)))}for(const G of P)F(G);this.f.add(X(G=>{F(G)})),this.f.add(Y(G=>{C.deleteAndDispose(G)})),this.event=K.event}dispose(){this.f.dispose()}}i.$oe=I;class S{constructor(){this.f=[]}wrapEvent(P,X,Y){return(H,K,C)=>P(F=>{const G=this.f[this.f.length-1];if(!X){G?G.buffers.push(()=>H.call(K,F)):H.call(K,F);return}const oe=G;if(!oe){H.call(K,X(Y,F));return}oe.items??(oe.items=[]),oe.items.push(F),oe.buffers.length===0&&G.buffers.push(()=>{oe.reducedResult??(oe.reducedResult=Y?oe.items.reduce(X,Y):oe.items.reduce(X)),H.call(K,oe.reducedResult)})},void 0,C)}bufferEvents(P){const X={buffers:new Array};this.f.push(X);const Y=P();return this.f.pop(),X.buffers.forEach(H=>H()),Y}}i.$pe=S;class D{constructor(){this.f=!1,this.g=f.None,this.h=p.$Uc.None,this.j=new s({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(P){this.g=P,this.f&&(this.h.dispose(),this.h=P(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}i.$qe=D;class B{static const(P){return new Z(P)}constructor(P){this.g=P,this.f=new s,this.onDidChange=this.f.event}get value(){return this.g}set value(P){P!==this.g&&(this.g=P,this.f.fire(void 0))}}i.$re=B;class Z{constructor(P){this.value=P,this.onDidChange=f.None}}}),ne(ie[26],re([0,1,13]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$se=i.CancellationToken=void 0,i.$te=b;const n=Object.freeze(function(a,l){const f=setTimeout(a.bind(l),0);return{dispose(){clearTimeout(f)}}});var p;(function(a){function l(f){return f===a.None||f===a.Cancelled||f instanceof g?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}a.isCancellationToken=l,a.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:t.Event.None}),a.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(p||(i.CancellationToken=p={}));class g{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?n:(this.b||(this.b=new t.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new g),this.f}cancel(){this.f?this.f instanceof g&&this.f.cancel():this.f=p.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof g&&this.f.dispose():this.f=p.None}}i.$se=w;function b(a){const l=new w;return a.add({dispose(){l.cancel()}}),l.token}}),ne(ie[45],re([0,1,26]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$8e=i.$7e=i.$5e=void 0,i.$6e=p;class n{constructor(a){this.b=a,this.a=null}get(){if(this.a)return this.a;const a=new t.$se,l=this.b(a.token);return this.a={promise:l,dispose:()=>{this.a=null,a.cancel(),a.dispose()}},this.a}}i.$5e=n;function p(b){return b}class g{constructor(a,l){this.a=void 0,this.b=void 0,typeof a=="function"?(this.c=a,this.d=p):(this.c=l,this.d=a.getCacheKey)}get(a){const l=this.d(a);return this.b!==l&&(this.b=l,this.a=this.c(a)),this.a}}i.$7e=g;class w{get cachedValues(){return this.a}constructor(a,l){this.a=new Map,this.b=new Map,typeof a=="function"?(this.c=a,this.d=p):(this.c=l,this.d=a.getCacheKey)}get(a){const l=this.d(a);if(this.b.has(l))return this.b.get(l);const f=this.c(a);return this.a.set(a,f),this.b.set(l,f),f}}i.$8e=w}),ne(ie[27],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ag=t,i.$bg=n,i.$cg=p,i.$dg=g,i.$eg=w,i.$fg=b,i.$gg=a,i.$hg=l,i.$ig=f,i.$jg=$,i.$kg=d,i.$lg=E,i.$mg=e,i.$ng=v,i.$og=R,i.$pg=A,i.$qg=L,i.$rg=N;function t(c){return typeof c=="string"}function n(c){return Array.isArray(c)&&c.every(u=>t(u))}function p(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}function g(c){const u=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof u}function w(c){return typeof c=="number"&&!isNaN(c)}function b(c){return!!c&&typeof c[Symbol.iterator]=="function"}function a(c){return c===!0||c===!1}function l(c){return typeof c>"u"}function f(c){return!$(c)}function $(c){return l(c)||c===null}function d(c,u){if(!c)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}function E(c){if($(c))throw new Error("Assertion Failed: argument is undefined or null");return c}function e(...c){const u=[];for(let s=0;s<c.length;s++){const o=c[s];if($(o))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);u.push(o)}return u}const m=Object.prototype.hasOwnProperty;function v(c){if(!p(c))return!1;for(const u in c)if(m.call(c,u))return!1;return!0}function R(c){return typeof c=="function"}function A(...c){return c.length>0&&c.every(R)}function L(c,u){const s=Math.min(c.length,u.length);for(let o=0;o<s;o++)N(c[o],u[o])}function N(c,u){if(t(u)){if(typeof c!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(R(u)){try{if(c instanceof u)return}catch{}if(!$(c)&&c.constructor===u||u.length===1&&u.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),ne(ie[28],re([0,1,27]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Uj=p,i.$Vj=g;const n=Object.create(null);function p(w,b){if((0,t.$ag)(b)){const a=n[b];if(a===void 0)throw new Error(`${w} references an unknown codicon: ${b}`);b=a}return n[w]=b,{id:w}}function g(){return n}}),ne(ie[46],re([0,1,28]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Wj=void 0,i.$Wj={add:(0,t.$Uj)("add",6e4),plus:(0,t.$Uj)("plus",6e4),gistNew:(0,t.$Uj)("gist-new",6e4),repoCreate:(0,t.$Uj)("repo-create",6e4),lightbulb:(0,t.$Uj)("lightbulb",60001),lightBulb:(0,t.$Uj)("light-bulb",60001),repo:(0,t.$Uj)("repo",60002),repoDelete:(0,t.$Uj)("repo-delete",60002),gistFork:(0,t.$Uj)("gist-fork",60003),repoForked:(0,t.$Uj)("repo-forked",60003),gitPullRequest:(0,t.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,t.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,t.$Uj)("record-keys",60005),keyboard:(0,t.$Uj)("keyboard",60005),tag:(0,t.$Uj)("tag",60006),gitPullRequestLabel:(0,t.$Uj)("git-pull-request-label",60006),tagAdd:(0,t.$Uj)("tag-add",60006),tagRemove:(0,t.$Uj)("tag-remove",60006),person:(0,t.$Uj)("person",60007),personFollow:(0,t.$Uj)("person-follow",60007),personOutline:(0,t.$Uj)("person-outline",60007),personFilled:(0,t.$Uj)("person-filled",60007),gitBranch:(0,t.$Uj)("git-branch",60008),gitBranchCreate:(0,t.$Uj)("git-branch-create",60008),gitBranchDelete:(0,t.$Uj)("git-branch-delete",60008),sourceControl:(0,t.$Uj)("source-control",60008),mirror:(0,t.$Uj)("mirror",60009),mirrorPublic:(0,t.$Uj)("mirror-public",60009),star:(0,t.$Uj)("star",60010),starAdd:(0,t.$Uj)("star-add",60010),starDelete:(0,t.$Uj)("star-delete",60010),starEmpty:(0,t.$Uj)("star-empty",60010),comment:(0,t.$Uj)("comment",60011),commentAdd:(0,t.$Uj)("comment-add",60011),alert:(0,t.$Uj)("alert",60012),warning:(0,t.$Uj)("warning",60012),search:(0,t.$Uj)("search",60013),searchSave:(0,t.$Uj)("search-save",60013),logOut:(0,t.$Uj)("log-out",60014),signOut:(0,t.$Uj)("sign-out",60014),logIn:(0,t.$Uj)("log-in",60015),signIn:(0,t.$Uj)("sign-in",60015),eye:(0,t.$Uj)("eye",60016),eyeUnwatch:(0,t.$Uj)("eye-unwatch",60016),eyeWatch:(0,t.$Uj)("eye-watch",60016),circleFilled:(0,t.$Uj)("circle-filled",60017),primitiveDot:(0,t.$Uj)("primitive-dot",60017),closeDirty:(0,t.$Uj)("close-dirty",60017),debugBreakpoint:(0,t.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,t.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,t.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,t.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,t.$Uj)("primitive-square",60018),edit:(0,t.$Uj)("edit",60019),pencil:(0,t.$Uj)("pencil",60019),info:(0,t.$Uj)("info",60020),issueOpened:(0,t.$Uj)("issue-opened",60020),gistPrivate:(0,t.$Uj)("gist-private",60021),gitForkPrivate:(0,t.$Uj)("git-fork-private",60021),lock:(0,t.$Uj)("lock",60021),mirrorPrivate:(0,t.$Uj)("mirror-private",60021),close:(0,t.$Uj)("close",60022),removeClose:(0,t.$Uj)("remove-close",60022),x:(0,t.$Uj)("x",60022),repoSync:(0,t.$Uj)("repo-sync",60023),sync:(0,t.$Uj)("sync",60023),clone:(0,t.$Uj)("clone",60024),desktopDownload:(0,t.$Uj)("desktop-download",60024),beaker:(0,t.$Uj)("beaker",60025),microscope:(0,t.$Uj)("microscope",60025),vm:(0,t.$Uj)("vm",60026),deviceDesktop:(0,t.$Uj)("device-desktop",60026),file:(0,t.$Uj)("file",60027),fileText:(0,t.$Uj)("file-text",60027),more:(0,t.$Uj)("more",60028),ellipsis:(0,t.$Uj)("ellipsis",60028),kebabHorizontal:(0,t.$Uj)("kebab-horizontal",60028),mailReply:(0,t.$Uj)("mail-reply",60029),reply:(0,t.$Uj)("reply",60029),organization:(0,t.$Uj)("organization",60030),organizationFilled:(0,t.$Uj)("organization-filled",60030),organizationOutline:(0,t.$Uj)("organization-outline",60030),newFile:(0,t.$Uj)("new-file",60031),fileAdd:(0,t.$Uj)("file-add",60031),newFolder:(0,t.$Uj)("new-folder",60032),fileDirectoryCreate:(0,t.$Uj)("file-directory-create",60032),trash:(0,t.$Uj)("trash",60033),trashcan:(0,t.$Uj)("trashcan",60033),history:(0,t.$Uj)("history",60034),clock:(0,t.$Uj)("clock",60034),folder:(0,t.$Uj)("folder",60035),fileDirectory:(0,t.$Uj)("file-directory",60035),symbolFolder:(0,t.$Uj)("symbol-folder",60035),logoGithub:(0,t.$Uj)("logo-github",60036),markGithub:(0,t.$Uj)("mark-github",60036),github:(0,t.$Uj)("github",60036),terminal:(0,t.$Uj)("terminal",60037),console:(0,t.$Uj)("console",60037),repl:(0,t.$Uj)("repl",60037),zap:(0,t.$Uj)("zap",60038),symbolEvent:(0,t.$Uj)("symbol-event",60038),error:(0,t.$Uj)("error",60039),stop:(0,t.$Uj)("stop",60039),variable:(0,t.$Uj)("variable",60040),symbolVariable:(0,t.$Uj)("symbol-variable",60040),array:(0,t.$Uj)("array",60042),symbolArray:(0,t.$Uj)("symbol-array",60042),symbolModule:(0,t.$Uj)("symbol-module",60043),symbolPackage:(0,t.$Uj)("symbol-package",60043),symbolNamespace:(0,t.$Uj)("symbol-namespace",60043),symbolObject:(0,t.$Uj)("symbol-object",60043),symbolMethod:(0,t.$Uj)("symbol-method",60044),symbolFunction:(0,t.$Uj)("symbol-function",60044),symbolConstructor:(0,t.$Uj)("symbol-constructor",60044),symbolBoolean:(0,t.$Uj)("symbol-boolean",60047),symbolNull:(0,t.$Uj)("symbol-null",60047),symbolNumeric:(0,t.$Uj)("symbol-numeric",60048),symbolNumber:(0,t.$Uj)("symbol-number",60048),symbolStructure:(0,t.$Uj)("symbol-structure",60049),symbolStruct:(0,t.$Uj)("symbol-struct",60049),symbolParameter:(0,t.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,t.$Uj)("symbol-type-parameter",60050),symbolKey:(0,t.$Uj)("symbol-key",60051),symbolText:(0,t.$Uj)("symbol-text",60051),symbolReference:(0,t.$Uj)("symbol-reference",60052),goToFile:(0,t.$Uj)("go-to-file",60052),symbolEnum:(0,t.$Uj)("symbol-enum",60053),symbolValue:(0,t.$Uj)("symbol-value",60053),symbolRuler:(0,t.$Uj)("symbol-ruler",60054),symbolUnit:(0,t.$Uj)("symbol-unit",60054),activateBreakpoints:(0,t.$Uj)("activate-breakpoints",60055),archive:(0,t.$Uj)("archive",60056),arrowBoth:(0,t.$Uj)("arrow-both",60057),arrowDown:(0,t.$Uj)("arrow-down",60058),arrowLeft:(0,t.$Uj)("arrow-left",60059),arrowRight:(0,t.$Uj)("arrow-right",60060),arrowSmallDown:(0,t.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,t.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,t.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,t.$Uj)("arrow-small-up",60064),arrowUp:(0,t.$Uj)("arrow-up",60065),bell:(0,t.$Uj)("bell",60066),bold:(0,t.$Uj)("bold",60067),book:(0,t.$Uj)("book",60068),bookmark:(0,t.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,t.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,t.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,t.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,t.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,t.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,t.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,t.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,t.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,t.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,t.$Uj)("briefcase",60076),broadcast:(0,t.$Uj)("broadcast",60077),browser:(0,t.$Uj)("browser",60078),bug:(0,t.$Uj)("bug",60079),calendar:(0,t.$Uj)("calendar",60080),caseSensitive:(0,t.$Uj)("case-sensitive",60081),check:(0,t.$Uj)("check",60082),checklist:(0,t.$Uj)("checklist",60083),chevronDown:(0,t.$Uj)("chevron-down",60084),chevronLeft:(0,t.$Uj)("chevron-left",60085),chevronRight:(0,t.$Uj)("chevron-right",60086),chevronUp:(0,t.$Uj)("chevron-up",60087),chromeClose:(0,t.$Uj)("chrome-close",60088),chromeMaximize:(0,t.$Uj)("chrome-maximize",60089),chromeMinimize:(0,t.$Uj)("chrome-minimize",60090),chromeRestore:(0,t.$Uj)("chrome-restore",60091),circleOutline:(0,t.$Uj)("circle-outline",60092),circle:(0,t.$Uj)("circle",60092),debugBreakpointUnverified:(0,t.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,t.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,t.$Uj)("circle-slash",60093),circuitBoard:(0,t.$Uj)("circuit-board",60094),clearAll:(0,t.$Uj)("clear-all",60095),clippy:(0,t.$Uj)("clippy",60096),closeAll:(0,t.$Uj)("close-all",60097),cloudDownload:(0,t.$Uj)("cloud-download",60098),cloudUpload:(0,t.$Uj)("cloud-upload",60099),code:(0,t.$Uj)("code",60100),collapseAll:(0,t.$Uj)("collapse-all",60101),colorMode:(0,t.$Uj)("color-mode",60102),commentDiscussion:(0,t.$Uj)("comment-discussion",60103),creditCard:(0,t.$Uj)("credit-card",60105),dash:(0,t.$Uj)("dash",60108),dashboard:(0,t.$Uj)("dashboard",60109),database:(0,t.$Uj)("database",60110),debugContinue:(0,t.$Uj)("debug-continue",60111),debugDisconnect:(0,t.$Uj)("debug-disconnect",60112),debugPause:(0,t.$Uj)("debug-pause",60113),debugRestart:(0,t.$Uj)("debug-restart",60114),debugStart:(0,t.$Uj)("debug-start",60115),debugStepInto:(0,t.$Uj)("debug-step-into",60116),debugStepOut:(0,t.$Uj)("debug-step-out",60117),debugStepOver:(0,t.$Uj)("debug-step-over",60118),debugStop:(0,t.$Uj)("debug-stop",60119),debug:(0,t.$Uj)("debug",60120),deviceCameraVideo:(0,t.$Uj)("device-camera-video",60121),deviceCamera:(0,t.$Uj)("device-camera",60122),deviceMobile:(0,t.$Uj)("device-mobile",60123),diffAdded:(0,t.$Uj)("diff-added",60124),diffIgnored:(0,t.$Uj)("diff-ignored",60125),diffModified:(0,t.$Uj)("diff-modified",60126),diffRemoved:(0,t.$Uj)("diff-removed",60127),diffRenamed:(0,t.$Uj)("diff-renamed",60128),diff:(0,t.$Uj)("diff",60129),diffSidebyside:(0,t.$Uj)("diff-sidebyside",60129),discard:(0,t.$Uj)("discard",60130),editorLayout:(0,t.$Uj)("editor-layout",60131),emptyWindow:(0,t.$Uj)("empty-window",60132),exclude:(0,t.$Uj)("exclude",60133),extensions:(0,t.$Uj)("extensions",60134),eyeClosed:(0,t.$Uj)("eye-closed",60135),fileBinary:(0,t.$Uj)("file-binary",60136),fileCode:(0,t.$Uj)("file-code",60137),fileMedia:(0,t.$Uj)("file-media",60138),filePdf:(0,t.$Uj)("file-pdf",60139),fileSubmodule:(0,t.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,t.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,t.$Uj)("file-symlink-file",60142),fileZip:(0,t.$Uj)("file-zip",60143),files:(0,t.$Uj)("files",60144),filter:(0,t.$Uj)("filter",60145),flame:(0,t.$Uj)("flame",60146),foldDown:(0,t.$Uj)("fold-down",60147),foldUp:(0,t.$Uj)("fold-up",60148),fold:(0,t.$Uj)("fold",60149),folderActive:(0,t.$Uj)("folder-active",60150),folderOpened:(0,t.$Uj)("folder-opened",60151),gear:(0,t.$Uj)("gear",60152),gift:(0,t.$Uj)("gift",60153),gistSecret:(0,t.$Uj)("gist-secret",60154),gist:(0,t.$Uj)("gist",60155),gitCommit:(0,t.$Uj)("git-commit",60156),gitCompare:(0,t.$Uj)("git-compare",60157),compareChanges:(0,t.$Uj)("compare-changes",60157),gitMerge:(0,t.$Uj)("git-merge",60158),githubAction:(0,t.$Uj)("github-action",60159),githubAlt:(0,t.$Uj)("github-alt",60160),globe:(0,t.$Uj)("globe",60161),grabber:(0,t.$Uj)("grabber",60162),graph:(0,t.$Uj)("graph",60163),gripper:(0,t.$Uj)("gripper",60164),heart:(0,t.$Uj)("heart",60165),home:(0,t.$Uj)("home",60166),horizontalRule:(0,t.$Uj)("horizontal-rule",60167),hubot:(0,t.$Uj)("hubot",60168),inbox:(0,t.$Uj)("inbox",60169),issueReopened:(0,t.$Uj)("issue-reopened",60171),issues:(0,t.$Uj)("issues",60172),italic:(0,t.$Uj)("italic",60173),jersey:(0,t.$Uj)("jersey",60174),json:(0,t.$Uj)("json",60175),kebabVertical:(0,t.$Uj)("kebab-vertical",60176),key:(0,t.$Uj)("key",60177),law:(0,t.$Uj)("law",60178),lightbulbAutofix:(0,t.$Uj)("lightbulb-autofix",60179),linkExternal:(0,t.$Uj)("link-external",60180),link:(0,t.$Uj)("link",60181),listOrdered:(0,t.$Uj)("list-ordered",60182),listUnordered:(0,t.$Uj)("list-unordered",60183),liveShare:(0,t.$Uj)("live-share",60184),loading:(0,t.$Uj)("loading",60185),location:(0,t.$Uj)("location",60186),mailRead:(0,t.$Uj)("mail-read",60187),mail:(0,t.$Uj)("mail",60188),markdown:(0,t.$Uj)("markdown",60189),megaphone:(0,t.$Uj)("megaphone",60190),mention:(0,t.$Uj)("mention",60191),milestone:(0,t.$Uj)("milestone",60192),gitPullRequestMilestone:(0,t.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,t.$Uj)("mortar-board",60193),move:(0,t.$Uj)("move",60194),multipleWindows:(0,t.$Uj)("multiple-windows",60195),mute:(0,t.$Uj)("mute",60196),noNewline:(0,t.$Uj)("no-newline",60197),note:(0,t.$Uj)("note",60198),octoface:(0,t.$Uj)("octoface",60199),openPreview:(0,t.$Uj)("open-preview",60200),package:(0,t.$Uj)("package",60201),paintcan:(0,t.$Uj)("paintcan",60202),pin:(0,t.$Uj)("pin",60203),play:(0,t.$Uj)("play",60204),run:(0,t.$Uj)("run",60204),plug:(0,t.$Uj)("plug",60205),preserveCase:(0,t.$Uj)("preserve-case",60206),preview:(0,t.$Uj)("preview",60207),project:(0,t.$Uj)("project",60208),pulse:(0,t.$Uj)("pulse",60209),question:(0,t.$Uj)("question",60210),quote:(0,t.$Uj)("quote",60211),radioTower:(0,t.$Uj)("radio-tower",60212),reactions:(0,t.$Uj)("reactions",60213),references:(0,t.$Uj)("references",60214),refresh:(0,t.$Uj)("refresh",60215),regex:(0,t.$Uj)("regex",60216),remoteExplorer:(0,t.$Uj)("remote-explorer",60217),remote:(0,t.$Uj)("remote",60218),remove:(0,t.$Uj)("remove",60219),replaceAll:(0,t.$Uj)("replace-all",60220),replace:(0,t.$Uj)("replace",60221),repoClone:(0,t.$Uj)("repo-clone",60222),repoForcePush:(0,t.$Uj)("repo-force-push",60223),repoPull:(0,t.$Uj)("repo-pull",60224),repoPush:(0,t.$Uj)("repo-push",60225),report:(0,t.$Uj)("report",60226),requestChanges:(0,t.$Uj)("request-changes",60227),rocket:(0,t.$Uj)("rocket",60228),rootFolderOpened:(0,t.$Uj)("root-folder-opened",60229),rootFolder:(0,t.$Uj)("root-folder",60230),rss:(0,t.$Uj)("rss",60231),ruby:(0,t.$Uj)("ruby",60232),saveAll:(0,t.$Uj)("save-all",60233),saveAs:(0,t.$Uj)("save-as",60234),save:(0,t.$Uj)("save",60235),screenFull:(0,t.$Uj)("screen-full",60236),screenNormal:(0,t.$Uj)("screen-normal",60237),searchStop:(0,t.$Uj)("search-stop",60238),server:(0,t.$Uj)("server",60240),settingsGear:(0,t.$Uj)("settings-gear",60241),settings:(0,t.$Uj)("settings",60242),shield:(0,t.$Uj)("shield",60243),smiley:(0,t.$Uj)("smiley",60244),sortPrecedence:(0,t.$Uj)("sort-precedence",60245),splitHorizontal:(0,t.$Uj)("split-horizontal",60246),splitVertical:(0,t.$Uj)("split-vertical",60247),squirrel:(0,t.$Uj)("squirrel",60248),starFull:(0,t.$Uj)("star-full",60249),starHalf:(0,t.$Uj)("star-half",60250),symbolClass:(0,t.$Uj)("symbol-class",60251),symbolColor:(0,t.$Uj)("symbol-color",60252),symbolConstant:(0,t.$Uj)("symbol-constant",60253),symbolEnumMember:(0,t.$Uj)("symbol-enum-member",60254),symbolField:(0,t.$Uj)("symbol-field",60255),symbolFile:(0,t.$Uj)("symbol-file",60256),symbolInterface:(0,t.$Uj)("symbol-interface",60257),symbolKeyword:(0,t.$Uj)("symbol-keyword",60258),symbolMisc:(0,t.$Uj)("symbol-misc",60259),symbolOperator:(0,t.$Uj)("symbol-operator",60260),symbolProperty:(0,t.$Uj)("symbol-property",60261),wrench:(0,t.$Uj)("wrench",60261),wrenchSubaction:(0,t.$Uj)("wrench-subaction",60261),symbolSnippet:(0,t.$Uj)("symbol-snippet",60262),tasklist:(0,t.$Uj)("tasklist",60263),telescope:(0,t.$Uj)("telescope",60264),textSize:(0,t.$Uj)("text-size",60265),threeBars:(0,t.$Uj)("three-bars",60266),thumbsdown:(0,t.$Uj)("thumbsdown",60267),thumbsup:(0,t.$Uj)("thumbsup",60268),tools:(0,t.$Uj)("tools",60269),triangleDown:(0,t.$Uj)("triangle-down",60270),triangleLeft:(0,t.$Uj)("triangle-left",60271),triangleRight:(0,t.$Uj)("triangle-right",60272),triangleUp:(0,t.$Uj)("triangle-up",60273),twitter:(0,t.$Uj)("twitter",60274),unfold:(0,t.$Uj)("unfold",60275),unlock:(0,t.$Uj)("unlock",60276),unmute:(0,t.$Uj)("unmute",60277),unverified:(0,t.$Uj)("unverified",60278),verified:(0,t.$Uj)("verified",60279),versions:(0,t.$Uj)("versions",60280),vmActive:(0,t.$Uj)("vm-active",60281),vmOutline:(0,t.$Uj)("vm-outline",60282),vmRunning:(0,t.$Uj)("vm-running",60283),watch:(0,t.$Uj)("watch",60284),whitespace:(0,t.$Uj)("whitespace",60285),wholeWord:(0,t.$Uj)("whole-word",60286),window:(0,t.$Uj)("window",60287),wordWrap:(0,t.$Uj)("word-wrap",60288),zoomIn:(0,t.$Uj)("zoom-in",60289),zoomOut:(0,t.$Uj)("zoom-out",60290),listFilter:(0,t.$Uj)("list-filter",60291),listFlat:(0,t.$Uj)("list-flat",60292),listSelection:(0,t.$Uj)("list-selection",60293),selection:(0,t.$Uj)("selection",60293),listTree:(0,t.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,t.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,t.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,t.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,t.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,t.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,t.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,t.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,t.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,t.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,t.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,t.$Uj)("symbol-string",60301),debugReverseContinue:(0,t.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,t.$Uj)("debug-step-back",60303),debugRestartFrame:(0,t.$Uj)("debug-restart-frame",60304),debugAlt:(0,t.$Uj)("debug-alt",60305),callIncoming:(0,t.$Uj)("call-incoming",60306),callOutgoing:(0,t.$Uj)("call-outgoing",60307),menu:(0,t.$Uj)("menu",60308),expandAll:(0,t.$Uj)("expand-all",60309),feedback:(0,t.$Uj)("feedback",60310),gitPullRequestReviewer:(0,t.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,t.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,t.$Uj)("ungroup-by-ref-type",60312),account:(0,t.$Uj)("account",60313),gitPullRequestAssignee:(0,t.$Uj)("git-pull-request-assignee",60313),bellDot:(0,t.$Uj)("bell-dot",60314),debugConsole:(0,t.$Uj)("debug-console",60315),library:(0,t.$Uj)("library",60316),output:(0,t.$Uj)("output",60317),runAll:(0,t.$Uj)("run-all",60318),syncIgnored:(0,t.$Uj)("sync-ignored",60319),pinned:(0,t.$Uj)("pinned",60320),githubInverted:(0,t.$Uj)("github-inverted",60321),serverProcess:(0,t.$Uj)("server-process",60322),serverEnvironment:(0,t.$Uj)("server-environment",60323),pass:(0,t.$Uj)("pass",60324),issueClosed:(0,t.$Uj)("issue-closed",60324),stopCircle:(0,t.$Uj)("stop-circle",60325),playCircle:(0,t.$Uj)("play-circle",60326),record:(0,t.$Uj)("record",60327),debugAltSmall:(0,t.$Uj)("debug-alt-small",60328),vmConnect:(0,t.$Uj)("vm-connect",60329),cloud:(0,t.$Uj)("cloud",60330),merge:(0,t.$Uj)("merge",60331),export:(0,t.$Uj)("export",60332),graphLeft:(0,t.$Uj)("graph-left",60333),magnet:(0,t.$Uj)("magnet",60334),notebook:(0,t.$Uj)("notebook",60335),redo:(0,t.$Uj)("redo",60336),checkAll:(0,t.$Uj)("check-all",60337),pinnedDirty:(0,t.$Uj)("pinned-dirty",60338),passFilled:(0,t.$Uj)("pass-filled",60339),circleLargeFilled:(0,t.$Uj)("circle-large-filled",60340),circleLarge:(0,t.$Uj)("circle-large",60341),circleLargeOutline:(0,t.$Uj)("circle-large-outline",60341),combine:(0,t.$Uj)("combine",60342),gather:(0,t.$Uj)("gather",60342),table:(0,t.$Uj)("table",60343),variableGroup:(0,t.$Uj)("variable-group",60344),typeHierarchy:(0,t.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,t.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,t.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,t.$Uj)("git-pull-request-create",60348),runAbove:(0,t.$Uj)("run-above",60349),runBelow:(0,t.$Uj)("run-below",60350),notebookTemplate:(0,t.$Uj)("notebook-template",60351),debugRerun:(0,t.$Uj)("debug-rerun",60352),workspaceTrusted:(0,t.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,t.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,t.$Uj)("workspace-unknown",60355),terminalCmd:(0,t.$Uj)("terminal-cmd",60356),terminalDebian:(0,t.$Uj)("terminal-debian",60357),terminalLinux:(0,t.$Uj)("terminal-linux",60358),terminalPowershell:(0,t.$Uj)("terminal-powershell",60359),terminalTmux:(0,t.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,t.$Uj)("terminal-ubuntu",60361),terminalBash:(0,t.$Uj)("terminal-bash",60362),arrowSwap:(0,t.$Uj)("arrow-swap",60363),copy:(0,t.$Uj)("copy",60364),personAdd:(0,t.$Uj)("person-add",60365),filterFilled:(0,t.$Uj)("filter-filled",60366),wand:(0,t.$Uj)("wand",60367),debugLineByLine:(0,t.$Uj)("debug-line-by-line",60368),inspect:(0,t.$Uj)("inspect",60369),layers:(0,t.$Uj)("layers",60370),layersDot:(0,t.$Uj)("layers-dot",60371),layersActive:(0,t.$Uj)("layers-active",60372),compass:(0,t.$Uj)("compass",60373),compassDot:(0,t.$Uj)("compass-dot",60374),compassActive:(0,t.$Uj)("compass-active",60375),azure:(0,t.$Uj)("azure",60376),issueDraft:(0,t.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,t.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,t.$Uj)("git-pull-request-draft",60379),debugAll:(0,t.$Uj)("debug-all",60380),debugCoverage:(0,t.$Uj)("debug-coverage",60381),runErrors:(0,t.$Uj)("run-errors",60382),folderLibrary:(0,t.$Uj)("folder-library",60383),debugContinueSmall:(0,t.$Uj)("debug-continue-small",60384),beakerStop:(0,t.$Uj)("beaker-stop",60385),graphLine:(0,t.$Uj)("graph-line",60386),graphScatter:(0,t.$Uj)("graph-scatter",60387),pieChart:(0,t.$Uj)("pie-chart",60388),bracket:(0,t.$Uj)("bracket",60175),bracketDot:(0,t.$Uj)("bracket-dot",60389),bracketError:(0,t.$Uj)("bracket-error",60390),lockSmall:(0,t.$Uj)("lock-small",60391),azureDevops:(0,t.$Uj)("azure-devops",60392),verifiedFilled:(0,t.$Uj)("verified-filled",60393),newline:(0,t.$Uj)("newline",60394),layout:(0,t.$Uj)("layout",60395),layoutActivitybarLeft:(0,t.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,t.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,t.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,t.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,t.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,t.$Uj)("layout-panel-right",60401),layoutPanel:(0,t.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,t.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,t.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,t.$Uj)("layout-statusbar",60405),layoutMenubar:(0,t.$Uj)("layout-menubar",60406),layoutCentered:(0,t.$Uj)("layout-centered",60407),target:(0,t.$Uj)("target",60408),indent:(0,t.$Uj)("indent",60409),recordSmall:(0,t.$Uj)("record-small",60410),errorSmall:(0,t.$Uj)("error-small",60411),terminalDecorationError:(0,t.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,t.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,t.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,t.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,t.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,t.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,t.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,t.$Uj)("layout-sidebar-left-off",60418),blank:(0,t.$Uj)("blank",60419),heartFilled:(0,t.$Uj)("heart-filled",60420),map:(0,t.$Uj)("map",60421),mapHorizontal:(0,t.$Uj)("map-horizontal",60421),foldHorizontal:(0,t.$Uj)("fold-horizontal",60421),mapFilled:(0,t.$Uj)("map-filled",60422),mapHorizontalFilled:(0,t.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,t.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,t.$Uj)("circle-small",60423),bellSlash:(0,t.$Uj)("bell-slash",60424),bellSlashDot:(0,t.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,t.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,t.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,t.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,t.$Uj)("search-fuzzy",60429),commentDraft:(0,t.$Uj)("comment-draft",60430),send:(0,t.$Uj)("send",60431),sparkle:(0,t.$Uj)("sparkle",60432),insert:(0,t.$Uj)("insert",60433),mic:(0,t.$Uj)("mic",60434),thumbsdownFilled:(0,t.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,t.$Uj)("thumbsup-filled",60436),coffee:(0,t.$Uj)("coffee",60437),snake:(0,t.$Uj)("snake",60438),game:(0,t.$Uj)("game",60439),vr:(0,t.$Uj)("vr",60440),chip:(0,t.$Uj)("chip",60441),piano:(0,t.$Uj)("piano",60442),music:(0,t.$Uj)("music",60443),micFilled:(0,t.$Uj)("mic-filled",60444),repoFetch:(0,t.$Uj)("repo-fetch",60445),copilot:(0,t.$Uj)("copilot",60446),lightbulbSparkle:(0,t.$Uj)("lightbulb-sparkle",60447),robot:(0,t.$Uj)("robot",60448),sparkleFilled:(0,t.$Uj)("sparkle-filled",60449),diffSingle:(0,t.$Uj)("diff-single",60450),diffMultiple:(0,t.$Uj)("diff-multiple",60451),surroundWith:(0,t.$Uj)("surround-with",60452),share:(0,t.$Uj)("share",60453),gitStash:(0,t.$Uj)("git-stash",60454),gitStashApply:(0,t.$Uj)("git-stash-apply",60455),gitStashPop:(0,t.$Uj)("git-stash-pop",60456),vscode:(0,t.$Uj)("vscode",60457),vscodeInsiders:(0,t.$Uj)("vscode-insiders",60458),codeOss:(0,t.$Uj)("code-oss",60459),runCoverage:(0,t.$Uj)("run-coverage",60460),runAllCoverage:(0,t.$Uj)("run-all-coverage",60461),coverage:(0,t.$Uj)("coverage",60462),githubProject:(0,t.$Uj)("github-project",60463),mapVertical:(0,t.$Uj)("map-vertical",60464),foldVertical:(0,t.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,t.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,t.$Uj)("fold-vertical-filled",60465),goToSearch:(0,t.$Uj)("go-to-search",60466),percentage:(0,t.$Uj)("percentage",60467),sortPercentage:(0,t.$Uj)("sort-percentage",60467),attach:(0,t.$Uj)("attach",60468)}}),ne(ie[47],re([0,1,28,46]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Zj=i.$Yj=void 0,i.$Xj=p;function p(){return Object.values(i.$Zj)}i.$Yj={dialogError:(0,t.$Uj)("dialog-error","error"),dialogWarning:(0,t.$Uj)("dialog-warning","warning"),dialogInfo:(0,t.$Uj)("dialog-info","info"),dialogClose:(0,t.$Uj)("dialog-close","close"),treeItemExpanded:(0,t.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,t.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,t.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,t.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,t.$Uj)("tree-item-loading","loading"),menuSelection:(0,t.$Uj)("menu-selection","check"),menuSubmenu:(0,t.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,t.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,t.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,t.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,t.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,t.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,t.$Uj)("toolbar-more","more"),quickInputBack:(0,t.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,t.$Uj)("drop-down-button",60084),symbolCustomColor:(0,t.$Uj)("symbol-customcolor",60252),exportIcon:(0,t.$Uj)("export",60332),workspaceUnspecified:(0,t.$Uj)("workspace-unspecified",60355),newLine:(0,t.$Uj)("newline",60394),thumbsDownFilled:(0,t.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,t.$Uj)("thumbsup-filled",60436),gitFetch:(0,t.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,t.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,t.$Uj)("debug-breakpoint-pending",60377)},i.$Zj={...n.$Wj,...i.$Yj}}),ne(ie[18],re([0,1,27]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$0n=n,i.$$n=p,i.$_n=w,i.$ao=a,i.$bo=l,i.$co=f,i.$do=$,i.$eo=d,i.$fo=E,i.$go=e,i.$ho=m,i.$io=v,i.$jo=R;function n(A){if(!A||typeof A!="object"||A instanceof RegExp)return A;const L=Array.isArray(A)?[]:{};return Object.entries(A).forEach(([N,c])=>{L[N]=c&&typeof c=="object"?n(c):c}),L}function p(A){if(!A||typeof A!="object")return A;const L=[A];for(;L.length>0;){const N=L.shift();Object.freeze(N);for(const c in N)if(g.call(N,c)){const u=N[c];typeof u=="object"&&!Object.isFrozen(u)&&!(0,t.$dg)(u)&&L.push(u)}}return A}const g=Object.prototype.hasOwnProperty;function w(A,L){return b(A,L,new Set)}function b(A,L,N){if((0,t.$jg)(A))return A;const c=L(A);if(typeof c<"u")return c;if(Array.isArray(A)){const u=[];for(const s of A)u.push(b(s,L,N));return u}if((0,t.$cg)(A)){if(N.has(A))throw new Error("Cannot clone recursive data-structure");N.add(A);const u={};for(const s in A)g.call(A,s)&&(u[s]=b(A[s],L,N));return N.delete(A),u}return A}function a(A,L,N=!0){return(0,t.$cg)(A)?((0,t.$cg)(L)&&Object.keys(L).forEach(c=>{c in A?N&&((0,t.$cg)(A[c])&&(0,t.$cg)(L[c])?a(A[c],L[c],N):A[c]=L[c]):A[c]=L[c]}),A):L}function l(A,L){if(A===L)return!0;if(A==null||L===null||L===void 0||typeof A!=typeof L||typeof A!="object"||Array.isArray(A)!==Array.isArray(L))return!1;let N,c;if(Array.isArray(A)){if(A.length!==L.length)return!1;for(N=0;N<A.length;N++)if(!l(A[N],L[N]))return!1}else{const u=[];for(c in A)u.push(c);u.sort();const s=[];for(c in L)s.push(c);if(s.sort(),!l(u,s))return!1;for(N=0;N<u.length;N++)if(!l(A[u[N]],L[u[N]]))return!1}return!0}function f(A){const L=new Set;return JSON.stringify(A,(N,c)=>{if((0,t.$cg)(c)||Array.isArray(c)){if(L.has(c))return"[Circular]";L.add(c)}return typeof c=="bigint"?`[BigInt ${c.toString()}]`:c})}function $(A,L){const N=Object.create(null);return!A||!L||Object.keys(L).forEach(u=>{const s=A[u],o=L[u];l(s,o)||(N[u]=o)}),N}function d(A,L){const N=L.toLowerCase(),c=Object.keys(A).find(u=>u.toLowerCase()===N);return c?A[c]:A[L]}function E(A,L){const N=Object.create(null);for(const[c,u]of Object.entries(A))L(c,u)&&(N[c]=u);return N}function e(A){let L=[];for(;Object.prototype!==A;)L=L.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return L}function m(A){const L=[];for(const N of e(A))typeof A[N]=="function"&&L.push(N);return L}function v(A,L){const N=u=>function(){const s=Array.prototype.slice.call(arguments,0);return L(u,s)},c={};for(const u of A)c[u]=N(u);return c}function R(A,L){const N={};for(const[c,u]of Object.entries(A))N[c]=L(u,c);return N}}),ne(ie[14],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Constants=void 0,i.$9e=n,i.$0e=p;var t;(function(g){g[g.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",g[g.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",g[g.MAX_UINT_8=255]="MAX_UINT_8",g[g.MAX_UINT_16=65535]="MAX_UINT_16",g[g.MAX_UINT_32=4294967295]="MAX_UINT_32",g[g.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(t||(i.Constants=t={}));function n(g){return g<0?0:g>t.MAX_UINT_8?t.MAX_UINT_8:g|0}function p(g){return g<0?0:g>t.MAX_UINT_32?t.MAX_UINT_32:g|0}}),ne(ie[8],re([0,1,45,3,41,14]),function(q,i,t,n,p,g){"use strict";var w;Object.defineProperty(i,"__esModule",{value:!0}),i.$_f=i.$$f=i.$0f=i.GraphemeBreakType=i.$Zf=i.$Rf=i.$Kf=i.$Jf=void 0,i.$$e=b,i.$_e=l,i.$af=$,i.$bf=d,i.$cf=E,i.$df=e,i.$ef=m,i.$ff=v,i.$gf=R,i.$hf=A,i.$if=L,i.$jf=N,i.$kf=c,i.$lf=u,i.$mf=s,i.$nf=o,i.$of=h,i.$pf=U,i.$qf=_,i.$rf=T,i.$sf=M,i.$tf=j,i.$uf=I,i.$vf=S,i.$wf=D,i.$xf=B,i.$yf=Z,i.$zf=O,i.$Af=P,i.$Bf=X,i.$Cf=Y,i.$Df=H,i.$Ef=K,i.$Ff=C,i.$Gf=F,i.$Hf=G,i.$If=oe,i.$Lf=Te,i.$Mf=Me,i.$Nf=xe,i.$Of=De,i.$Pf=W,i.$Qf=J,i.$Sf=ee,i.$Tf=he,i.$Uf=de,i.$Vf=Ne,i.$Wf=pe,i.$Xf=se,i.$Yf=ae,i.$1f=ue,i.$2f=ce,i.$3f=ge,i.$4f=$e,i.$5f=Ee,i.$6f=Re,i.$7f=Se,i.$8f=Be,i.$9f=Ge;function b(k){return!k||typeof k!="string"?!0:k.trim().length===0}const a=/{(\d+)}/g;function l(k,...y){return y.length===0?k:k.replace(a,function(z,Q){const le=parseInt(Q,10);return isNaN(le)||le<0||le>=y.length?z:y[le]})}const f=/{([^}]+)}/g;function $(k,y){return Object.keys(y).length===0?k:k.replace(f,(z,Q)=>y[Q]??z)}function d(k){return k.replace(/[<>"'&]/g,y=>{switch(y){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return y})}function E(k){return k.replace(/[<>&]/g,function(y){switch(y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return y}})}function e(k){return k.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function m(k,y){let z=0,Q=k.indexOf(y);for(;Q!==-1;)z++,Q=k.indexOf(y,Q+y.length);return z}function v(k,y,z="\u2026"){return k.length<=y?k:`${k.substr(0,y)}${z}`}function R(k,y,z="\u2026"){if(k.length<=y)return k;const Q=Math.ceil(y/2)-z.length/2,le=Math.floor(y/2)-z.length/2;return`${k.substr(0,Q)}${z}${k.substr(k.length-le)}`}function A(k,y=" "){const z=L(k,y);return N(z,y)}function L(k,y){if(!k||!y)return k;const z=y.length;if(z===0||k.length===0)return k;let Q=0;for(;k.indexOf(y,Q)===Q;)Q=Q+z;return k.substring(Q)}function N(k,y){if(!k||!y)return k;const z=y.length,Q=k.length;if(z===0||Q===0)return k;let le=Q,be=-1;for(;be=k.lastIndexOf(y,le-1),!(be===-1||be+z!==le);){if(be===0)return"";le=be}return k.substring(0,le)}function c(k){return k.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function u(k){return k.replace(/\*/g,"")}function s(k,y,z={}){if(!k)throw new Error("Cannot create regex from empty string");y||(k=e(k)),z.wholeWord&&(/\B/.test(k.charAt(0))||(k="\\b"+k),/\B/.test(k.charAt(k.length-1))||(k=k+"\\b"));let Q="";return z.global&&(Q+="g"),z.matchCase||(Q+="i"),z.multiline&&(Q+="m"),z.unicode&&(Q+="u"),new RegExp(k,Q)}function o(k){return k.source==="^"||k.source==="^$"||k.source==="$"||k.source==="^\\s*$"?!1:!!(k.exec("")&&k.lastIndex===0)}function h(k){return k.split(/\r\n|\r|\n/)}function U(k){const y=[],z=k.split(/(\r\n|\r|\n)/);for(let Q=0;Q<Math.ceil(z.length/2);Q++)y.push(z[2*Q]+(z[2*Q+1]??""));return y}function _(k){for(let y=0,z=k.length;y<z;y++){const Q=k.charCodeAt(y);if(Q!==n.CharCode.Space&&Q!==n.CharCode.Tab)return y}return-1}function T(k,y=0,z=k.length){for(let Q=y;Q<z;Q++){const le=k.charCodeAt(Q);if(le!==n.CharCode.Space&&le!==n.CharCode.Tab)return k.substring(y,Q)}return k.substring(y,z)}function M(k,y=k.length-1){for(let z=y;z>=0;z--){const Q=k.charCodeAt(z);if(Q!==n.CharCode.Space&&Q!==n.CharCode.Tab)return z}return-1}function j(k,y,z){const Q=[];let le=0;for(const be of k.matchAll(y)){if(Q.push(k.slice(le,be.index)),be.index===void 0)throw new Error("match.index should be defined");le=be.index+be[0].length,Q.push(z(be[0],...be.slice(1),be.index,k,be.groups))}return Q.push(k.slice(le)),Promise.all(Q).then(be=>be.join(""))}function I(k,y){return k<y?-1:k>y?1:0}function S(k,y,z=0,Q=k.length,le=0,be=y.length){for(;z<Q&&le<be;z++,le++){const ke=k.charCodeAt(z),ve=y.charCodeAt(le);if(ke<ve)return-1;if(ke>ve)return 1}const _e=Q-z,Oe=be-le;return _e<Oe?-1:_e>Oe?1:0}function D(k,y){return B(k,y,0,k.length,0,y.length)}function B(k,y,z=0,Q=k.length,le=0,be=y.length){for(;z<Q&&le<be;z++,le++){let ke=k.charCodeAt(z),ve=y.charCodeAt(le);if(ke===ve)continue;if(ke>=128||ve>=128)return S(k.toLowerCase(),y.toLowerCase(),z,Q,le,be);O(ke)&&(ke-=32),O(ve)&&(ve-=32);const je=ke-ve;if(je!==0)return je}const _e=Q-z,Oe=be-le;return _e<Oe?-1:_e>Oe?1:0}function Z(k){return k>=n.CharCode.Digit0&&k<=n.CharCode.Digit9}function O(k){return k>=n.CharCode.a&&k<=n.CharCode.z}function P(k){return k>=n.CharCode.A&&k<=n.CharCode.Z}function X(k,y){return k.length===y.length&&B(k,y)===0}function Y(k,y){const z=y.length;return y.length>k.length?!1:B(k,y,0,z)===0}function H(k,y){const z=Math.min(k.length,y.length);let Q;for(Q=0;Q<z;Q++)if(k.charCodeAt(Q)!==y.charCodeAt(Q))return Q;return z}function K(k,y){const z=Math.min(k.length,y.length);let Q;const le=k.length-1,be=y.length-1;for(Q=0;Q<z;Q++)if(k.charCodeAt(le-Q)!==y.charCodeAt(be-Q))return Q;return z}function C(k){return 55296<=k&&k<=56319}function F(k){return 56320<=k&&k<=57343}function G(k,y){return(k-55296<<10)+(y-56320)+65536}function oe(k,y,z){const Q=k.charCodeAt(z);if(C(Q)&&z+1<y){const le=k.charCodeAt(z+1);if(F(le))return G(Q,le)}return Q}function fe(k,y){const z=k.charCodeAt(y-1);if(F(z)&&y>1){const Q=k.charCodeAt(y-2);if(C(Q))return G(Q,z)}return z}class we{get offset(){return this.e}constructor(y,z=0){this.c=y,this.d=y.length,this.e=z}setOffset(y){this.e=y}prevCodePoint(){const y=fe(this.c,this.e);return this.e-=y>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,y}nextCodePoint(){const y=oe(this.c,this.d,this.e);return this.e+=y>=g.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,y}eol(){return this.e>=this.d}}i.$Jf=we;class r{get offset(){return this.c.offset}constructor(y,z=0){this.c=new we(y,z)}nextGraphemeLength(){const y=Ue.getInstance(),z=this.c,Q=z.offset;let le=y.getGraphemeBreakType(z.nextCodePoint());for(;!z.eol();){const be=z.offset,_e=y.getGraphemeBreakType(z.nextCodePoint());if(Pe(le,_e)){z.setOffset(be);break}le=_e}return z.offset-Q}prevGraphemeLength(){const y=Ue.getInstance(),z=this.c,Q=z.offset;let le=y.getGraphemeBreakType(z.prevCodePoint());for(;z.offset>0;){const be=z.offset,_e=y.getGraphemeBreakType(z.prevCodePoint());if(Pe(_e,le)){z.setOffset(be);break}le=_e}return Q-z.offset}eol(){return this.c.eol()}}i.$Kf=r;function Te(k,y){return new r(k,y).nextGraphemeLength()}function Me(k,y){return new r(k,y).prevGraphemeLength()}function xe(k,y){y>0&&F(k.charCodeAt(y))&&y--;const z=y+Te(k,y);return[z-Me(k,z),z]}function De(k){const y=new r(k);let z=0;for(;!y.eol();)z++,y.nextGraphemeLength();return z}let Fe;function x(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(k){return Fe||(Fe=x()),Fe.test(k)}const V=/^[\t\n\r\x20-\x7E]*$/;function J(k){return V.test(k)}i.$Rf=/[\u2028\u2029]/;function ee(k){return i.$Rf.test(k)}function he(k){return k>=11904&&k<=55215||k>=63744&&k<=64255||k>=65281&&k<=65374}function de(k){return k>=127462&&k<=127487||k===8986||k===8987||k===9200||k===9203||k>=9728&&k<=10175||k===11088||k===11093||k>=127744&&k<=128591||k>=128640&&k<=128764||k>=128992&&k<=129008||k>=129280&&k<=129535||k>=129648&&k<=129782}function Ne(k,y,z=""){const Q=k.trimStart();if(Q.length<y)return Q;const le=/\b/g;let be=0;for(;le.test(Q)&&!(Q.length-le.lastIndex<y);)be=le.lastIndex,le.lastIndex+=1;return be===0?Q:z+Q.substring(be).trimStart()}const Ae=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*pe(k){let y=0;for(const z of k.matchAll(Ae))y!==z.index&&(yield{isCode:!1,str:k.substring(y,z.index)}),yield{isCode:!0,str:z[0]},y=z.index+z[0].length;y!==k.length&&(yield{isCode:!1,str:k.substring(y)})}function se(k){return k&&(k=k.replace(Ae,"")),k}const te=/\\\[.*?\\\]/g;function ae(k){return se(k).replace(te,"")}i.$Zf=String.fromCharCode(n.CharCode.UTF8_BOM);function ue(k){return!!(k&&k.length>0&&k.charCodeAt(0)===n.CharCode.UTF8_BOM)}function ce(k){return ue(k)?k.substr(1):k}function ge(k,y){if(!k||!y||k.length<y.length)return!1;const z=y.length,Q=k.toLowerCase();let le=0,be=-1;for(;le<z;){const _e=Q.indexOf(y[le],be+1);if(_e<0)return!1;be=_e,le++}return!0}function $e(k,y=!1){return k?(y&&(k=k.replace(/\\./g,"")),k.toLowerCase()!==k):!1}function Ee(k){return k.charAt(0).toUpperCase()+k.slice(1)}function Re(k,y=1){if(y===0)return"";let z=-1;do z=k.indexOf(`
`,z+1),y--;while(y>0&&z>=0);return z===-1?k:(k[z-1]==="\r"&&z--,k.substr(0,z))}function Se(k){const y=n.CharCode.Z-n.CharCode.A+1;return k=k%(2*y),k<y?String.fromCharCode(n.CharCode.a+k):String.fromCharCode(n.CharCode.A+k-y)}function Be(k){return Ue.getInstance().getGraphemeBreakType(k)}function Pe(k,y){return k===me.Other?y!==me.Extend&&y!==me.SpacingMark:k===me.CR&&y===me.LF?!1:k===me.Control||k===me.CR||k===me.LF||y===me.Control||y===me.CR||y===me.LF?!0:!(k===me.L&&(y===me.L||y===me.V||y===me.LV||y===me.LVT)||(k===me.LV||k===me.V)&&(y===me.V||y===me.T)||(k===me.LVT||k===me.T)&&y===me.T||y===me.Extend||y===me.ZWJ||y===me.SpacingMark||k===me.Prepend||k===me.ZWJ&&y===me.Extended_Pictographic||k===me.Regional_Indicator&&y===me.Regional_Indicator)}var me;(function(k){k[k.Other=0]="Other",k[k.Prepend=1]="Prepend",k[k.CR=2]="CR",k[k.LF=3]="LF",k[k.Control=4]="Control",k[k.Extend=5]="Extend",k[k.Regional_Indicator=6]="Regional_Indicator",k[k.SpacingMark=7]="SpacingMark",k[k.L=8]="L",k[k.V=9]="V",k[k.T=10]="T",k[k.LV=11]="LV",k[k.LVT=12]="LVT",k[k.ZWJ=13]="ZWJ",k[k.Extended_Pictographic=14]="Extended_Pictographic"})(me||(i.GraphemeBreakType=me={}));class Ue{static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=He()}getGraphemeBreakType(y){if(y<32)return y===n.CharCode.LineFeed?me.LF:y===n.CharCode.CarriageReturn?me.CR:me.Control;if(y<127)return me.Other;const z=this.d,Q=z.length/3;let le=1;for(;le<=Q;)if(y<z[3*le])le=2*le;else if(y>z[3*le+1])le=2*le+1;else return z[3*le+2];return me.Other}}Ue.c=null;function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(k,y){if(k===0)return 0;const z=Ye(k,y);if(z!==void 0)return z;const Q=new we(y,k);return Q.prevCodePoint(),Q.offset}function Ye(k,y){const z=new we(y,k);let Q=z.prevCodePoint();for(;Je(Q)||Q===qe.emojiVariantSelector||Q===qe.enclosingKeyCap;){if(z.offset===0)return;Q=z.prevCodePoint()}if(!de(Q))return;let le=z.offset;return le>0&&z.prevCodePoint()===qe.zwj&&(le=z.offset),le}function Je(k){return 127995<=k&&k<=127999}var qe;(function(k){k[k.zwj=8205]="zwj",k[k.emojiVariantSelector=65039]="emojiVariantSelector",k[k.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),i.$0f="\xA0";class Ve{static getInstance(y){return w.d.get(Array.from(y))}static getLocales(){return w.e.value}constructor(y){this.f=y}isAmbiguous(y){return this.f.has(y)}containsAmbiguousCharacter(y){for(let z=0;z<y.length;z++){const Q=y.codePointAt(z);if(typeof Q=="number"&&this.isAmbiguous(Q))return!0}return!1}getPrimaryConfusable(y){return this.f.get(y)}getConfusableCodePoints(){return new Set(this.f.keys())}}i.$$f=Ve,w=Ve,Ve.c=new p.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ve.d=new t.$7e({getCacheKey:JSON.stringify},k=>{function y(ve){const je=new Map;for(let Ie=0;Ie<ve.length;Ie+=2)je.set(ve[Ie],ve[Ie+1]);return je}function z(ve,je){const Ie=new Map(ve);for(const[We,ze]of je)Ie.set(We,ze);return Ie}function Q(ve,je){if(!ve)return je;const Ie=new Map;for(const[We,ze]of ve)je.has(We)&&Ie.set(We,ze);return Ie}const le=w.c.value;let be=k.filter(ve=>!ve.startsWith("_")&&ve in le);be.length===0&&(be=["_default"]);let _e;for(const ve of be){const je=y(le[ve]);_e=Q(_e,je)}const Oe=y(le._common),ke=z(Oe,_e);return new w(ke)}),Ve.e=new p.$V(()=>Object.keys(w.c.value).filter(k=>!k.startsWith("_")));class ye{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ye.c())),this.d}static isInvisibleCharacter(y){return ye.e().has(y)}static containsInvisibleCharacter(y){for(let z=0;z<y.length;z++){const Q=y.codePointAt(z);if(typeof Q=="number"&&ye.isInvisibleCharacter(Q))return!0}return!1}static get codePoints(){return ye.e()}}i.$_f=ye,ye.d=void 0}),ne(ie[48],re([0,1,8]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$uj=i.$sj=void 0,i.$oj=n,i.$pj=p,i.$qj=g,i.$rj=b,i.$tj=m;function n(R){return p(R,0)}function p(R,A){switch(typeof R){case"object":return R===null?g(349,A):Array.isArray(R)?a(R,A):l(R,A);case"string":return b(R,A);case"boolean":return w(R,A);case"number":return g(R,A);case"undefined":return g(937,A);default:return g(617,A)}}function g(R,A){return(A<<5)-A+R|0}function w(R,A){return g(R?433:863,A)}function b(R,A){A=g(149417,A);for(let L=0,N=R.length;L<N;L++)A=g(R.charCodeAt(L),A);return A}function a(R,A){return A=g(104579,A),R.reduce((L,N)=>p(N,L),A)}function l(R,A){return A=g(181387,A),Object.keys(R).sort().reduce((L,N)=>(L=b(N,L),p(R[N],L)),A)}class f{constructor(){this.g=0}get value(){return this.g}hash(A){return this.g=p(A,this.g),this.g}}i.$sj=f;var $;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})($||($={}));function d(R,A,L=32){const N=L-A,c=~((1<<N)-1);return(R<<A|(c&R)>>>N)>>>0}function E(R,A=0,L=R.byteLength,N=0){for(let c=0;c<L;c++)R[A+c]=N}function e(R,A,L="0"){for(;R.length<A;)R=L+R;return R}function m(R,A=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(L=>L.toString(16).padStart(2,"0")).join(""):e((R>>>0).toString(16),A/4)}class v{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array($.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(A){const L=A.length;if(L===0)return;const N=this.p;let c=this.r,u=this.u,s,o;for(u!==0?(s=u,o=-1,u=0):(s=A.charCodeAt(0),o=0);;){let h=s;if(t.$Ff(s))if(o+1<L){const U=A.charCodeAt(o+1);t.$Gf(U)?(o++,h=t.$Hf(s,U)):h=$.UNICODE_REPLACEMENT}else{u=s;break}else t.$Gf(s)&&(h=$.UNICODE_REPLACEMENT);if(c=this.w(N,c,h),o++,o<L)s=A.charCodeAt(o);else break}this.r=c,this.u=u}w(A,L,N){return N<128?A[L++]=N:N<2048?(A[L++]=192|(N&1984)>>>6,A[L++]=128|(N&63)>>>0):N<65536?(A[L++]=224|(N&61440)>>>12,A[L++]=128|(N&4032)>>>6,A[L++]=128|(N&63)>>>0):(A[L++]=240|(N&1835008)>>>18,A[L++]=128|(N&258048)>>>12,A[L++]=128|(N&4032)>>>6,A[L++]=128|(N&63)>>>0),L>=$.BLOCK_SIZE&&(this.y(),L-=$.BLOCK_SIZE,this.t+=$.BLOCK_SIZE,A[0]=A[$.BLOCK_SIZE+0],A[1]=A[$.BLOCK_SIZE+1],A[2]=A[$.BLOCK_SIZE+2]),L}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,$.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),m(this.h)+m(this.l)+m(this.m)+m(this.n)+m(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const A=8*this.t;this.q.setUint32(56,Math.floor(A/4294967296),!1),this.q.setUint32(60,A%4294967296,!1),this.y()}y(){const A=v.g,L=this.q;for(let T=0;T<64;T+=4)A.setUint32(T,L.getUint32(T,!1),!1);for(let T=64;T<320;T+=4)A.setUint32(T,d(A.getUint32(T-12,!1)^A.getUint32(T-32,!1)^A.getUint32(T-56,!1)^A.getUint32(T-64,!1),1),!1);let N=this.h,c=this.l,u=this.m,s=this.n,o=this.o,h,U,_;for(let T=0;T<80;T++)T<20?(h=c&u|~c&s,U=1518500249):T<40?(h=c^u^s,U=1859775393):T<60?(h=c&u|c&s|u&s,U=2400959708):(h=c^u^s,U=3395469782),_=d(N,5)+h+o+U+A.getUint32(T*4,!1)&4294967295,o=s,s=u,u=d(c,30),c=N,N=_;this.h=this.h+N&4294967295,this.l=this.l+c&4294967295,this.m=this.m+u&4294967295,this.n=this.n+s&4294967295,this.o=this.o+o&4294967295}}i.$uj=v,v.g=new DataView(new ArrayBuffer(320))}),ne(ie[29],re([0,1,39,48,14]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Wv=i.$Uv=void 0,i.$Vv=w;class g{constructor(E){this.a=E}getElements(){const E=this.a,e=new Int32Array(E.length);for(let m=0,v=E.length;m<v;m++)e[m]=E.charCodeAt(m);return e}}i.$Uv=g;function w(d,E,e){return new $(new g(d),new g(E)).ComputeDiff(e).changes}class b{static Assert(E,e){if(!E)throw new Error(e)}}class a{static Copy(E,e,m,v,R){for(let A=0;A<R;A++)m[v+A]=E[e+A]}static Copy2(E,e,m,v,R){for(let A=0;A<R;A++)m[v+A]=E[e+A]}}var l;(function(d){d[d.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(l||(l={}));class f{constructor(){this.a=[],this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new t.$Tv(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=p.Constants.MAX_SAFE_SMALL_INTEGER,this.c=p.Constants.MAX_SAFE_SMALL_INTEGER}AddOriginalElement(E,e){this.b=Math.min(this.b,E),this.c=Math.min(this.c,e),this.d++}AddModifiedElement(E,e){this.b=Math.min(this.b,E),this.c=Math.min(this.c,e),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class ${constructor(E,e,m=null){this.a=m,this.b=E,this.c=e;const[v,R,A]=$.o(E),[L,N,c]=$.o(e);this.d=A&&c,this.e=v,this.f=R,this.g=L,this.h=N,this.k=[],this.m=[]}static n(E){return E.length>0&&typeof E[0]=="string"}static o(E){const e=E.getElements();if($.n(e)){const m=new Int32Array(e.length);for(let v=0,R=e.length;v<R;v++)m[v]=(0,n.$rj)(e[v],0);return[e,m,!0]}return e instanceof Int32Array?[[],e,!1]:[[],new Int32Array(e),!1]}p(E,e){return this.f[E]!==this.h[e]?!1:this.d?this.e[E]===this.g[e]:!0}q(E,e){if(!this.p(E,e))return!1;const m=$.r(this.b,E),v=$.r(this.c,e);return m===v}static r(E,e){return typeof E.getStrictElement=="function"?E.getStrictElement(e):null}s(E,e){return this.f[E]!==this.f[e]?!1:this.d?this.e[E]===this.e[e]:!0}u(E,e){return this.h[E]!==this.h[e]?!1:this.d?this.g[E]===this.g[e]:!0}ComputeDiff(E){return this.v(0,this.f.length-1,0,this.h.length-1,E)}v(E,e,m,v,R){const A=[!1];let L=this.w(E,e,m,v,A);return R&&(L=this.z(L)),{quitEarly:A[0],changes:L}}w(E,e,m,v,R){for(R[0]=!1;E<=e&&m<=v&&this.p(E,m);)E++,m++;for(;e>=E&&v>=m&&this.p(e,v);)e--,v--;if(E>e||m>v){let s;return m<=v?(b.Assert(E===e+1,"originalStart should only be one more than originalEnd"),s=[new t.$Tv(E,0,m,v-m+1)]):E<=e?(b.Assert(m===v+1,"modifiedStart should only be one more than modifiedEnd"),s=[new t.$Tv(E,e-E+1,m,0)]):(b.Assert(E===e+1,"originalStart should only be one more than originalEnd"),b.Assert(m===v+1,"modifiedStart should only be one more than modifiedEnd"),s=[]),s}const A=[0],L=[0],N=this.y(E,e,m,v,A,L,R),c=A[0],u=L[0];if(N!==null)return N;if(!R[0]){const s=this.w(E,c,m,u,R);let o=[];return R[0]?o=[new t.$Tv(c+1,e-(c+1)+1,u+1,v-(u+1)+1)]:o=this.w(c+1,e,u+1,v,R),this.H(s,o)}return[new t.$Tv(E,e-E+1,m,v-m+1)]}x(E,e,m,v,R,A,L,N,c,u,s,o,h,U,_,T,M,j){let I=null,S=null,D=new f,B=e,Z=m,O=h[0]-T[0]-v,P=p.Constants.MIN_SAFE_SMALL_INTEGER,X=this.k.length-1;do{const Y=O+E;Y===B||Y<Z&&c[Y-1]<c[Y+1]?(s=c[Y+1],U=s-O-v,s<P&&D.MarkNextChange(),P=s,D.AddModifiedElement(s+1,U),O=Y+1-E):(s=c[Y-1]+1,U=s-O-v,s<P&&D.MarkNextChange(),P=s-1,D.AddOriginalElement(s,U+1),O=Y-1-E),X>=0&&(c=this.k[X],E=c[0],B=1,Z=c.length-1)}while(--X>=-1);if(I=D.getReverseChanges(),j[0]){let Y=h[0]+1,H=T[0]+1;if(I!==null&&I.length>0){const K=I[I.length-1];Y=Math.max(Y,K.getOriginalEnd()),H=Math.max(H,K.getModifiedEnd())}S=[new t.$Tv(Y,o-Y+1,H,_-H+1)]}else{D=new f,B=A,Z=L,O=h[0]-T[0]-N,P=p.Constants.MAX_SAFE_SMALL_INTEGER,X=M?this.m.length-1:this.m.length-2;do{const Y=O+R;Y===B||Y<Z&&u[Y-1]>=u[Y+1]?(s=u[Y+1]-1,U=s-O-N,s>P&&D.MarkNextChange(),P=s+1,D.AddOriginalElement(s+1,U+1),O=Y+1-R):(s=u[Y-1],U=s-O-N,s>P&&D.MarkNextChange(),P=s,D.AddModifiedElement(s+1,U+1),O=Y-1-R),X>=0&&(u=this.m[X],R=u[0],B=1,Z=u.length-1)}while(--X>=-1);S=D.getChanges()}return this.H(I,S)}y(E,e,m,v,R,A,L){let N=0,c=0,u=0,s=0,o=0,h=0;E--,m--,R[0]=0,A[0]=0,this.k=[],this.m=[];const U=e-E+(v-m),_=U+1,T=new Int32Array(_),M=new Int32Array(_),j=v-m,I=e-E,S=E-m,D=e-v,Z=(I-j)%2===0;T[j]=E,M[I]=e,L[0]=!1;for(let O=1;O<=U/2+1;O++){let P=0,X=0;u=this.J(j-O,O,j,_),s=this.J(j+O,O,j,_);for(let H=u;H<=s;H+=2){H===u||H<s&&T[H-1]<T[H+1]?N=T[H+1]:N=T[H-1]+1,c=N-(H-j)-S;const K=N;for(;N<e&&c<v&&this.p(N+1,c+1);)N++,c++;if(T[H]=N,N+c>P+X&&(P=N,X=c),!Z&&Math.abs(H-I)<=O-1&&N>=M[H])return R[0]=N,A[0]=c,K<=M[H]&&l.MaxDifferencesHistory>0&&O<=l.MaxDifferencesHistory+1?this.x(j,u,s,S,I,o,h,D,T,M,N,e,R,c,v,A,Z,L):null}const Y=(P-E+(X-m)-O)/2;if(this.a!==null&&!this.a(P,Y))return L[0]=!0,R[0]=P,A[0]=X,Y>0&&l.MaxDifferencesHistory>0&&O<=l.MaxDifferencesHistory+1?this.x(j,u,s,S,I,o,h,D,T,M,N,e,R,c,v,A,Z,L):(E++,m++,[new t.$Tv(E,e-E+1,m,v-m+1)]);o=this.J(I-O,O,I,_),h=this.J(I+O,O,I,_);for(let H=o;H<=h;H+=2){H===o||H<h&&M[H-1]>=M[H+1]?N=M[H+1]-1:N=M[H-1],c=N-(H-I)-D;const K=N;for(;N>E&&c>m&&this.p(N,c);)N--,c--;if(M[H]=N,Z&&Math.abs(H-j)<=O&&N<=T[H])return R[0]=N,A[0]=c,K>=T[H]&&l.MaxDifferencesHistory>0&&O<=l.MaxDifferencesHistory+1?this.x(j,u,s,S,I,o,h,D,T,M,N,e,R,c,v,A,Z,L):null}if(O<=l.MaxDifferencesHistory){let H=new Int32Array(s-u+2);H[0]=j-u+1,a.Copy2(T,u,H,1,s-u+1),this.k.push(H),H=new Int32Array(h-o+2),H[0]=I-o+1,a.Copy2(M,o,H,1,h-o+1),this.m.push(H)}}return this.x(j,u,s,S,I,o,h,D,T,M,N,e,R,c,v,A,Z,L)}z(E){for(let e=0;e<E.length;e++){const m=E[e],v=e<E.length-1?E[e+1].originalStart:this.f.length,R=e<E.length-1?E[e+1].modifiedStart:this.h.length,A=m.originalLength>0,L=m.modifiedLength>0;for(;m.originalStart+m.originalLength<v&&m.modifiedStart+m.modifiedLength<R&&(!A||this.s(m.originalStart,m.originalStart+m.originalLength))&&(!L||this.u(m.modifiedStart,m.modifiedStart+m.modifiedLength));){const c=this.q(m.originalStart,m.modifiedStart);if(this.q(m.originalStart+m.originalLength,m.modifiedStart+m.modifiedLength)&&!c)break;m.originalStart++,m.modifiedStart++}const N=[null];if(e<E.length-1&&this.I(E[e],E[e+1],N)){E[e]=N[0],E.splice(e+1,1),e--;continue}}for(let e=E.length-1;e>=0;e--){const m=E[e];let v=0,R=0;if(e>0){const s=E[e-1];v=s.originalStart+s.originalLength,R=s.modifiedStart+s.modifiedLength}const A=m.originalLength>0,L=m.modifiedLength>0;let N=0,c=this.G(m.originalStart,m.originalLength,m.modifiedStart,m.modifiedLength);for(let s=1;;s++){const o=m.originalStart-s,h=m.modifiedStart-s;if(o<v||h<R||A&&!this.s(o,o+m.originalLength)||L&&!this.u(h,h+m.modifiedLength))break;const _=(o===v&&h===R?5:0)+this.G(o,m.originalLength,h,m.modifiedLength);_>c&&(c=_,N=s)}m.originalStart-=N,m.modifiedStart-=N;const u=[null];if(e>0&&this.I(E[e-1],E[e],u)){E[e-1]=u[0],E.splice(e,1),e++;continue}}if(this.d)for(let e=1,m=E.length;e<m;e++){const v=E[e-1],R=E[e],A=R.originalStart-v.originalStart-v.originalLength,L=v.originalStart,N=R.originalStart+R.originalLength,c=N-L,u=v.modifiedStart,s=R.modifiedStart+R.modifiedLength,o=s-u;if(A<5&&c<20&&o<20){const h=this.A(L,c,u,o,A);if(h){const[U,_]=h;(U!==v.originalStart+v.originalLength||_!==v.modifiedStart+v.modifiedLength)&&(v.originalLength=U-v.originalStart,v.modifiedLength=_-v.modifiedStart,R.originalStart=U+A,R.modifiedStart=_+A,R.originalLength=N-R.originalStart,R.modifiedLength=s-R.modifiedStart)}}}return E}A(E,e,m,v,R){if(e<R||v<R)return null;const A=E+e-R+1,L=m+v-R+1;let N=0,c=0,u=0;for(let s=E;s<A;s++)for(let o=m;o<L;o++){const h=this.B(s,o,R);h>0&&h>N&&(N=h,c=s,u=o)}return N>0?[c,u]:null}B(E,e,m){let v=0;for(let R=0;R<m;R++){if(!this.p(E+R,e+R))return 0;v+=this.e[E+R].length}return v}C(E){return E<=0||E>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[E])}D(E,e){if(this.C(E)||this.C(E-1))return!0;if(e>0){const m=E+e;if(this.C(m-1)||this.C(m))return!0}return!1}E(E){return E<=0||E>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[E])}F(E,e){if(this.E(E)||this.E(E-1))return!0;if(e>0){const m=E+e;if(this.E(m-1)||this.E(m))return!0}return!1}G(E,e,m,v){const R=this.D(E,e)?1:0,A=this.F(m,v)?1:0;return R+A}H(E,e){const m=[];if(E.length===0||e.length===0)return e.length>0?e:E;if(this.I(E[E.length-1],e[0],m)){const v=new Array(E.length+e.length-1);return a.Copy(E,0,v,0,E.length-1),v[E.length-1]=m[0],a.Copy(e,1,v,E.length,e.length-1),v}else{const v=new Array(E.length+e.length);return a.Copy(E,0,v,0,E.length),a.Copy(e,0,v,E.length,e.length),v}}I(E,e,m){if(b.Assert(E.originalStart<=e.originalStart,"Left change is not less than or equal to right change"),b.Assert(E.modifiedStart<=e.modifiedStart,"Left change is not less than or equal to right change"),E.originalStart+E.originalLength>=e.originalStart||E.modifiedStart+E.modifiedLength>=e.modifiedStart){const v=E.originalStart;let R=E.originalLength;const A=E.modifiedStart;let L=E.modifiedLength;return E.originalStart+E.originalLength>=e.originalStart&&(R=e.originalStart+e.originalLength-E.originalStart),E.modifiedStart+E.modifiedLength>=e.modifiedStart&&(L=e.modifiedStart+e.modifiedLength-E.modifiedStart),m[0]=new t.$Tv(v,R,A,L),!0}else return m[0]=null,!1}J(E,e,m,v){if(E>=0&&E<v)return E;const R=m,A=v-m-1,L=e%2===0;if(E<0){const N=R%2===0;return L===N?0:1}else{const N=A%2===0;return L===N?v-1:v-2}}}i.$Wv=$}),ne(ie[19],re([0,1,3,42,44,17]),function(q,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.URI=void 0,i.$vc=v,i.$wc=u;const w=/^\w[\w\d+.-]*$/,b=/^\//,a=/^\/\//;function l(_,T){if(!_.scheme&&T)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${_.authority}", path: "${_.path}", query: "${_.query}", fragment: "${_.fragment}"}`);if(_.scheme&&!w.test(_.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(_.path){if(_.authority){if(!b.test(_.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(a.test(_.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(_,T){return!_&&!T?"file":_}function $(_,T){switch(_){case"https":case"http":case"file":T?T[0]!==E&&(T=E+T):T=E;break}return T}const d="",E="/",e=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(T){return T instanceof m?!0:T?typeof T.authority=="string"&&typeof T.fragment=="string"&&typeof T.path=="string"&&typeof T.query=="string"&&typeof T.scheme=="string"&&typeof T.fsPath=="string"&&typeof T.with=="function"&&typeof T.toString=="function":!1}constructor(T,M,j,I,S,D=!1){typeof T=="object"?(this.scheme=T.scheme||d,this.authority=T.authority||d,this.path=T.path||d,this.query=T.query||d,this.fragment=T.fragment||d):(this.scheme=f(T,D),this.authority=M||d,this.path=$(this.scheme,j||d),this.query=I||d,this.fragment=S||d,l(this,D))}get fsPath(){return u(this,!1)}with(T){if(!T)return this;let{scheme:M,authority:j,path:I,query:S,fragment:D}=T;return M===void 0?M=this.scheme:M===null&&(M=d),j===void 0?j=this.authority:j===null&&(j=d),I===void 0?I=this.path:I===null&&(I=d),S===void 0?S=this.query:S===null&&(S=d),D===void 0?D=this.fragment:D===null&&(D=d),M===this.scheme&&j===this.authority&&I===this.path&&S===this.query&&D===this.fragment?this:new A(M,j,I,S,D)}static parse(T,M=!1){const j=e.exec(T);return j?new A(j[2]||d,U(j[4]||d),U(j[5]||d),U(j[7]||d),U(j[9]||d),M):new A(d,d,d,d,d)}static file(T){let M=d;if(g.$c&&(T=T.replace(/\\/g,E)),T[0]===E&&T[1]===E){const j=T.indexOf(E,2);j===-1?(M=T.substring(2),T=E):(M=T.substring(2,j),T=T.substring(j)||E)}return new A("file",M,T,d,d)}static from(T,M){return new A(T.scheme,T.authority,T.path,T.query,T.fragment,M)}static joinPath(T,...M){if(!T.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let j;return g.$c&&T.scheme==="file"?j=m.file(p.$fc.join(u(T,!0),...M)).path:j=p.$gc.join(T.path,...M),T.with({path:j})}toString(T=!1){return s(this,T)}toJSON(){return this}static revive(T){if(T){if(T instanceof m)return T;{const M=new A(T);return M._formatted=T.external??null,M._fsPath=T._sep===R?T.fsPath??null:null,M}}else return T}}i.URI=m;function v(_){return!_||typeof _!="object"?!1:typeof _.scheme=="string"&&(typeof _.authority=="string"||typeof _.authority>"u")&&(typeof _.path=="string"||typeof _.path>"u")&&(typeof _.query=="string"||typeof _.query>"u")&&(typeof _.fragment=="string"||typeof _.fragment>"u")}const R=g.$c?1:void 0;class A extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(T=!1){return T?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const T={$mid:n.MarshalledId.Uri};return this._fsPath&&(T.fsPath=this._fsPath,T._sep=R),this._formatted&&(T.external=this._formatted),this.path&&(T.path=this.path),this.scheme&&(T.scheme=this.scheme),this.authority&&(T.authority=this.authority),this.query&&(T.query=this.query),this.fragment&&(T.fragment=this.fragment),T}}const L={[t.CharCode.Colon]:"%3A",[t.CharCode.Slash]:"%2F",[t.CharCode.QuestionMark]:"%3F",[t.CharCode.Hash]:"%23",[t.CharCode.OpenSquareBracket]:"%5B",[t.CharCode.CloseSquareBracket]:"%5D",[t.CharCode.AtSign]:"%40",[t.CharCode.ExclamationMark]:"%21",[t.CharCode.DollarSign]:"%24",[t.CharCode.Ampersand]:"%26",[t.CharCode.SingleQuote]:"%27",[t.CharCode.OpenParen]:"%28",[t.CharCode.CloseParen]:"%29",[t.CharCode.Asterisk]:"%2A",[t.CharCode.Plus]:"%2B",[t.CharCode.Comma]:"%2C",[t.CharCode.Semicolon]:"%3B",[t.CharCode.Equals]:"%3D",[t.CharCode.Space]:"%20"};function N(_,T,M){let j,I=-1;for(let S=0;S<_.length;S++){const D=_.charCodeAt(S);if(D>=t.CharCode.a&&D<=t.CharCode.z||D>=t.CharCode.A&&D<=t.CharCode.Z||D>=t.CharCode.Digit0&&D<=t.CharCode.Digit9||D===t.CharCode.Dash||D===t.CharCode.Period||D===t.CharCode.Underline||D===t.CharCode.Tilde||T&&D===t.CharCode.Slash||M&&D===t.CharCode.OpenSquareBracket||M&&D===t.CharCode.CloseSquareBracket||M&&D===t.CharCode.Colon)I!==-1&&(j+=encodeURIComponent(_.substring(I,S)),I=-1),j!==void 0&&(j+=_.charAt(S));else{j===void 0&&(j=_.substr(0,S));const B=L[D];B!==void 0?(I!==-1&&(j+=encodeURIComponent(_.substring(I,S)),I=-1),j+=B):I===-1&&(I=S)}}return I!==-1&&(j+=encodeURIComponent(_.substring(I))),j!==void 0?j:_}function c(_){let T;for(let M=0;M<_.length;M++){const j=_.charCodeAt(M);j===t.CharCode.Hash||j===t.CharCode.QuestionMark?(T===void 0&&(T=_.substr(0,M)),T+=L[j]):T!==void 0&&(T+=_[M])}return T!==void 0?T:_}function u(_,T){let M;return _.authority&&_.path.length>1&&_.scheme==="file"?M=`//${_.authority}${_.path}`:_.path.charCodeAt(0)===t.CharCode.Slash&&(_.path.charCodeAt(1)>=t.CharCode.A&&_.path.charCodeAt(1)<=t.CharCode.Z||_.path.charCodeAt(1)>=t.CharCode.a&&_.path.charCodeAt(1)<=t.CharCode.z)&&_.path.charCodeAt(2)===t.CharCode.Colon?T?M=_.path.substr(1):M=_.path[1].toLowerCase()+_.path.substr(2):M=_.path,g.$c&&(M=M.replace(/\//g,"\\")),M}function s(_,T){const M=T?c:N;let j="",{scheme:I,authority:S,path:D,query:B,fragment:Z}=_;if(I&&(j+=I,j+=":"),(S||I==="file")&&(j+=E,j+=E),S){let O=S.indexOf("@");if(O!==-1){const P=S.substr(0,O);S=S.substr(O+1),O=P.lastIndexOf(":"),O===-1?j+=M(P,!1,!1):(j+=M(P.substr(0,O),!1,!1),j+=":",j+=M(P.substr(O+1),!1,!0)),j+="@"}S=S.toLowerCase(),O=S.lastIndexOf(":"),O===-1?j+=M(S,!1,!0):(j+=M(S.substr(0,O),!1,!0),j+=S.substr(O))}if(D){if(D.length>=3&&D.charCodeAt(0)===t.CharCode.Slash&&D.charCodeAt(2)===t.CharCode.Colon){const O=D.charCodeAt(1);O>=t.CharCode.A&&O<=t.CharCode.Z&&(D=`/${String.fromCharCode(O+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===t.CharCode.Colon){const O=D.charCodeAt(0);O>=t.CharCode.A&&O<=t.CharCode.Z&&(D=`${String.fromCharCode(O+32)}:${D.substr(2)}`)}j+=M(D,!0,!1)}return B&&(j+="?",j+=M(B,!1,!1)),Z&&(j+="#",j+=T?Z:N(Z,!1,!1)),j}function o(_){try{return decodeURIComponent(_)}catch{return _.length>3?_.substr(0,3)+o(_.substr(3)):_}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function U(_){return _.match(h)?_.replace(h,T=>o(T)):_}}),ne(ie[76],re([0,1,4,13,12,18,17,8]),function(q,i,t,n,p,g,w,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SimpleWorkerServer=i.SimpleWorkerClient=void 0,i.logOnceWebWorkerWarning=f,i.create=s;const a="$initialize";let l=!1;function f(o){w.$i&&(l||(l=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(o.message))}var $;(function(o){o[o.Request=0]="Request",o[o.Reply=1]="Reply",o[o.SubscribeEvent=2]="SubscribeEvent",o[o.Event=3]="Event",o[o.UnsubscribeEvent=4]="UnsubscribeEvent"})($||($={}));class d{constructor(h,U,_,T){this.vsWorker=h,this.req=U,this.method=_,this.args=T,this.type=$.Request}}class E{constructor(h,U,_,T){this.vsWorker=h,this.seq=U,this.res=_,this.err=T,this.type=$.Reply}}class e{constructor(h,U,_,T){this.vsWorker=h,this.req=U,this.eventName=_,this.arg=T,this.type=$.SubscribeEvent}}class m{constructor(h,U,_){this.vsWorker=h,this.req=U,this.event=_,this.type=$.Event}}class v{constructor(h,U){this.vsWorker=h,this.req=U,this.type=$.UnsubscribeEvent}}class R{constructor(h){this.a=-1,this.g=h,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(h){this.a=h}sendMessage(h,U){const _=String(++this.b);return new Promise((T,M)=>{this.c[_]={resolve:T,reject:M},this.o(new d(this.a,_,h,U))})}listen(h,U){let _=null;const T=new n.$he({onWillAddFirstListener:()=>{_=String(++this.b),this.d.set(_,T),this.o(new e(this.a,_,h,U))},onDidRemoveLastListener:()=>{this.d.delete(_),this.o(new v(this.a,_)),_=null}});return T.event}handleMessage(h){!h||!h.vsWorker||this.a!==-1&&h.vsWorker!==this.a||this.h(h)}h(h){switch(h.type){case $.Reply:return this.j(h);case $.Request:return this.k(h);case $.SubscribeEvent:return this.l(h);case $.Event:return this.m(h);case $.UnsubscribeEvent:return this.n(h)}}j(h){if(!this.c[h.seq]){console.warn("Got reply to unknown seq");return}const U=this.c[h.seq];if(delete this.c[h.seq],h.err){let _=h.err;h.err.$isError&&(_=new Error,_.name=h.err.name,_.message=h.err.message,_.stack=h.err.stack),U.reject(_);return}U.resolve(h.res)}k(h){const U=h.req;this.g.handleMessage(h.method,h.args).then(T=>{this.o(new E(this.a,U,T,void 0))},T=>{T.detail instanceof Error&&(T.detail=(0,t.$3)(T.detail)),this.o(new E(this.a,U,void 0,(0,t.$3)(T)))})}l(h){const U=h.req,_=this.g.handleEvent(h.eventName,h.arg)(T=>{this.o(new m(this.a,U,T))});this.f.set(U,_)}m(h){if(!this.d.has(h.req)){console.warn("Got event for unknown req");return}this.d.get(h.req).fire(h.event)}n(h){if(!this.f.has(h.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(h.req).dispose(),this.f.delete(h.req)}o(h){const U=[];if(h.type===$.Request)for(let _=0;_<h.args.length;_++)h.args[_]instanceof ArrayBuffer&&U.push(h.args[_]);else h.type===$.Reply&&h.res instanceof ArrayBuffer&&U.push(h.res);this.g.sendMessage(h,U)}}class A extends p.$Uc{constructor(h,U,_){super();let T=null;this.a=this.B(h.create("vs/base/common/worker/simpleWorker",B=>{this.c.handleMessage(B)},B=>{T?.(B)})),this.c=new R({sendMessage:(B,Z)=>{this.a.postMessage(B,Z)},handleMessage:(B,Z)=>{if(typeof _[B]!="function")return Promise.reject(new Error("Missing method "+B+" on main thread host."));try{return Promise.resolve(_[B].apply(_,Z))}catch(O){return Promise.reject(O)}},handleEvent:(B,Z)=>{if(N(B)){const O=_[B].call(_,Z);if(typeof O!="function")throw new Error(`Missing dynamic event ${B} on main thread host.`);return O}if(L(B)){const O=_[B];if(typeof O!="function")throw new Error(`Missing event ${B} on main thread host.`);return O}throw new Error(`Malformed event name ${B}`)}}),this.c.setWorkerId(this.a.getId());let M=null;const j=globalThis.require;typeof j<"u"&&typeof j.getConfig=="function"?M=j.getConfig():typeof globalThis.requirejs<"u"&&(M=globalThis.requirejs.s.contexts._.config);const I=(0,g.$ho)(_);this.b=this.c.sendMessage(a,[this.a.getId(),JSON.parse(JSON.stringify(M)),U,I]);const S=(B,Z)=>this.g(B,Z),D=(B,Z)=>this.c.listen(B,Z);this.f=new Promise((B,Z)=>{T=Z,this.b.then(O=>{B(c(O,S,D))},O=>{Z(O),this.h("Worker failed to load "+U,O)})})}getProxyObject(){return this.f}g(h,U){return new Promise((_,T)=>{this.b.then(()=>{this.c.sendMessage(h,U).then(_,T)},T)})}h(h,U){console.error(h),console.info(U)}}i.SimpleWorkerClient=A;function L(o){return o[0]==="o"&&o[1]==="n"&&b.$Af(o.charCodeAt(2))}function N(o){return/^onDynamic/.test(o)&&b.$Af(o.charCodeAt(9))}function c(o,h,U){const _=j=>function(){const I=Array.prototype.slice.call(arguments,0);return h(j,I)},T=j=>function(I){return U(j,I)},M={};for(const j of o){if(N(j)){M[j]=T(j);continue}if(L(j)){M[j]=U(j,void 0);continue}M[j]=_(j)}return M}class u{constructor(h,U){this.a=U,this.b=null,this.c=new R({sendMessage:(_,T)=>{h(_,T)},handleMessage:(_,T)=>this.d(_,T),handleEvent:(_,T)=>this.f(_,T)})}onmessage(h){this.c.handleMessage(h)}d(h,U){if(h===a)return this.g(U[0],U[1],U[2],U[3]);if(!this.b||typeof this.b[h]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+h));try{return Promise.resolve(this.b[h].apply(this.b,U))}catch(_){return Promise.reject(_)}}f(h,U){if(!this.b)throw new Error("Missing requestHandler");if(N(h)){const _=this.b[h].call(this.b,U);if(typeof _!="function")throw new Error(`Missing dynamic event ${h} on request handler.`);return _}if(L(h)){const _=this.b[h];if(typeof _!="function")throw new Error(`Missing event ${h} on request handler.`);return _}throw new Error(`Malformed event name ${h}`)}g(h,U,_,T){this.c.setWorkerId(h);const I=c(T,(S,D)=>this.c.sendMessage(S,D),(S,D)=>this.c.listen(S,D));return this.a?(this.b=this.a(I),Promise.resolve((0,g.$ho)(this.b))):(U&&(typeof U.baseUrl<"u"&&delete U.baseUrl,typeof U.paths<"u"&&typeof U.paths.vs<"u"&&delete U.paths.vs,typeof U.trustedTypesPolicy<"u"&&delete U.trustedTypesPolicy,U.catchError=!0,globalThis.require.config(U)),new Promise((S,D)=>{(globalThis.require||q)([_],Z=>{if(this.b=Z.create(I),!this.b){D(new Error("No RequestHandler!"));return}S((0,g.$ho)(this.b))},D)}))}}i.SimpleWorkerServer=u;function s(o){return new u(o,null)}}),ne(ie[30],re([0,1,14]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$pt=i.$ot=void 0;class n{constructor(b){const a=(0,t.$9e)(b);this.c=a,this.a=n.d(a),this.b=new Map}static d(b){const a=new Uint8Array(256);return a.fill(b),a}set(b,a){const l=(0,t.$9e)(a);b>=0&&b<256?this.a[b]=l:this.b.set(b,l)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}i.$ot=n;var p;(function(w){w[w.False=0]="False",w[w.True=1]="True"})(p||(p={}));class g{constructor(){this.a=new n(p.False)}add(b){this.a.set(b,p.True)}has(b){return this.a.get(b)===p.True}clear(){return this.a.clear()}}i.$pt=g}),ne(ie[6],re([0,1,4]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Dv=i.$Cv=void 0;class n{static addRange(w,b){let a=0;for(;a<b.length&&b[a].endExclusive<w.start;)a++;let l=a;for(;l<b.length&&b[l].start<=w.endExclusive;)l++;if(a===l)b.splice(a,0,w);else{const f=Math.min(w.start,b[a].start),$=Math.max(w.endExclusive,b[l-1].endExclusive);b.splice(a,l-a,new n(f,$))}}static tryCreate(w,b){if(!(w>b))return new n(w,b)}static ofLength(w){return new n(0,w)}static ofStartAndLength(w,b){return new n(w,w+b)}constructor(w,b){if(this.start=w,this.endExclusive=b,w>b)throw new t.$cb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(w){return new n(this.start+w,this.endExclusive+w)}deltaStart(w){return new n(this.start+w,this.endExclusive)}deltaEnd(w){return new n(this.start,this.endExclusive+w)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(w){return this.start===w.start&&this.endExclusive===w.endExclusive}containsRange(w){return this.start<=w.start&&w.endExclusive<=this.endExclusive}contains(w){return this.start<=w&&w<this.endExclusive}join(w){return new n(Math.min(this.start,w.start),Math.max(this.endExclusive,w.endExclusive))}intersect(w){const b=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);if(b<=a)return new n(b,a)}intersects(w){const b=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);return b<a}intersectsOrTouches(w){const b=Math.max(this.start,w.start),a=Math.min(this.endExclusive,w.endExclusive);return b<=a}isBefore(w){return this.endExclusive<=w.start}isAfter(w){return this.start>=w.endExclusive}slice(w){return w.slice(this.start,this.endExclusive)}substring(w){return w.substring(this.start,this.endExclusive)}clip(w){if(this.isEmpty)throw new t.$cb(`Invalid clipping range: ${this.toString()}`);return Math.max(this.start,Math.min(this.endExclusive-1,w))}clipCyclic(w){if(this.isEmpty)throw new t.$cb(`Invalid clipping range: ${this.toString()}`);return w<this.start?this.endExclusive-(this.start-w)%this.length:w>=this.endExclusive?this.start+(w-this.start)%this.length:w}map(w){const b=[];for(let a=this.start;a<this.endExclusive;a++)b.push(w(a));return b}forEach(w){for(let b=this.start;b<this.endExclusive;b++)w(b)}}i.$Cv=n;class p{constructor(){this.a=[]}addRange(w){let b=0;for(;b<this.a.length&&this.a[b].endExclusive<w.start;)b++;let a=b;for(;a<this.a.length&&this.a[a].start<=w.endExclusive;)a++;if(b===a)this.a.splice(b,0,w);else{const l=Math.min(w.start,this.a[b].start),f=Math.max(w.endExclusive,this.a[a-1].endExclusive);this.a.splice(b,a-b,new n(l,f))}}toString(){return this.a.map(w=>w.toString()).join(", ")}intersectsStrict(w){let b=0;for(;b<this.a.length&&this.a[b].endExclusive<=w.start;)b++;return b<this.a.length&&this.a[b].start<w.endExclusive}intersectWithRange(w){const b=new p;for(const a of this.a){const l=a.intersect(w);l&&b.addRange(l)}return b}intersectWithRangeLength(w){return this.intersectWithRange(w).length}get length(){return this.a.reduce((w,b)=>w+b.length,0)}}i.$Dv=p}),ne(ie[5],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ct=void 0;class t{constructor(p,g){this.lineNumber=p,this.column=g}with(p=this.lineNumber,g=this.column){return p===this.lineNumber&&g===this.column?this:new t(p,g)}delta(p=0,g=0){return this.with(this.lineNumber+p,this.column+g)}equals(p){return t.equals(this,p)}static equals(p,g){return!p&&!g?!0:!!p&&!!g&&p.lineNumber===g.lineNumber&&p.column===g.column}isBefore(p){return t.isBefore(this,p)}static isBefore(p,g){return p.lineNumber<g.lineNumber?!0:g.lineNumber<p.lineNumber?!1:p.column<g.column}isBeforeOrEqual(p){return t.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,g){return p.lineNumber<g.lineNumber?!0:g.lineNumber<p.lineNumber?!1:p.column<=g.column}static compare(p,g){const w=p.lineNumber|0,b=g.lineNumber|0;if(w===b){const a=p.column|0,l=g.column|0;return a-l}return w-b}clone(){return new t(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new t(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}i.$ct=t}),ne(ie[2],re([0,1,5]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$dt=void 0;class n{constructor(g,w,b,a){g>b||g===b&&w>a?(this.startLineNumber=b,this.startColumn=a,this.endLineNumber=g,this.endColumn=w):(this.startLineNumber=g,this.startColumn=w,this.endLineNumber=b,this.endColumn=a)}isEmpty(){return n.isEmpty(this)}static isEmpty(g){return g.startLineNumber===g.endLineNumber&&g.startColumn===g.endColumn}containsPosition(g){return n.containsPosition(this,g)}static containsPosition(g,w){return!(w.lineNumber<g.startLineNumber||w.lineNumber>g.endLineNumber||w.lineNumber===g.startLineNumber&&w.column<g.startColumn||w.lineNumber===g.endLineNumber&&w.column>g.endColumn)}static strictContainsPosition(g,w){return!(w.lineNumber<g.startLineNumber||w.lineNumber>g.endLineNumber||w.lineNumber===g.startLineNumber&&w.column<=g.startColumn||w.lineNumber===g.endLineNumber&&w.column>=g.endColumn)}containsRange(g){return n.containsRange(this,g)}static containsRange(g,w){return!(w.startLineNumber<g.startLineNumber||w.endLineNumber<g.startLineNumber||w.startLineNumber>g.endLineNumber||w.endLineNumber>g.endLineNumber||w.startLineNumber===g.startLineNumber&&w.startColumn<g.startColumn||w.endLineNumber===g.endLineNumber&&w.endColumn>g.endColumn)}strictContainsRange(g){return n.strictContainsRange(this,g)}static strictContainsRange(g,w){return!(w.startLineNumber<g.startLineNumber||w.endLineNumber<g.startLineNumber||w.startLineNumber>g.endLineNumber||w.endLineNumber>g.endLineNumber||w.startLineNumber===g.startLineNumber&&w.startColumn<=g.startColumn||w.endLineNumber===g.endLineNumber&&w.endColumn>=g.endColumn)}plusRange(g){return n.plusRange(this,g)}static plusRange(g,w){let b,a,l,f;return w.startLineNumber<g.startLineNumber?(b=w.startLineNumber,a=w.startColumn):w.startLineNumber===g.startLineNumber?(b=w.startLineNumber,a=Math.min(w.startColumn,g.startColumn)):(b=g.startLineNumber,a=g.startColumn),w.endLineNumber>g.endLineNumber?(l=w.endLineNumber,f=w.endColumn):w.endLineNumber===g.endLineNumber?(l=w.endLineNumber,f=Math.max(w.endColumn,g.endColumn)):(l=g.endLineNumber,f=g.endColumn),new n(b,a,l,f)}intersectRanges(g){return n.intersectRanges(this,g)}static intersectRanges(g,w){let b=g.startLineNumber,a=g.startColumn,l=g.endLineNumber,f=g.endColumn;const $=w.startLineNumber,d=w.startColumn,E=w.endLineNumber,e=w.endColumn;return b<$?(b=$,a=d):b===$&&(a=Math.max(a,d)),l>E?(l=E,f=e):l===E&&(f=Math.min(f,e)),b>l||b===l&&a>f?null:new n(b,a,l,f)}equalsRange(g){return n.equalsRange(this,g)}static equalsRange(g,w){return!g&&!w?!0:!!g&&!!w&&g.startLineNumber===w.startLineNumber&&g.startColumn===w.startColumn&&g.endLineNumber===w.endLineNumber&&g.endColumn===w.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(g){return new t.$ct(g.endLineNumber,g.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(g){return new t.$ct(g.startLineNumber,g.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(g,w){return new n(this.startLineNumber,this.startColumn,g,w)}setStartPosition(g,w){return new n(g,w,this.endLineNumber,this.endColumn)}collapseToStart(){return n.collapseToStart(this)}static collapseToStart(g){return new n(g.startLineNumber,g.startColumn,g.startLineNumber,g.startColumn)}collapseToEnd(){return n.collapseToEnd(this)}static collapseToEnd(g){return new n(g.endLineNumber,g.endColumn,g.endLineNumber,g.endColumn)}delta(g){return new n(this.startLineNumber+g,this.startColumn,this.endLineNumber+g,this.endColumn)}static fromPositions(g,w=g){return new n(g.lineNumber,g.column,w.lineNumber,w.column)}static lift(g){return g?new n(g.startLineNumber,g.startColumn,g.endLineNumber,g.endColumn):null}static isIRange(g){return g&&typeof g.startLineNumber=="number"&&typeof g.startColumn=="number"&&typeof g.endLineNumber=="number"&&typeof g.endColumn=="number"}static areIntersectingOrTouching(g,w){return!(g.endLineNumber<w.startLineNumber||g.endLineNumber===w.startLineNumber&&g.endColumn<w.startColumn||w.endLineNumber<g.startLineNumber||w.endLineNumber===g.startLineNumber&&w.endColumn<g.startColumn)}static areIntersecting(g,w){return!(g.endLineNumber<w.startLineNumber||g.endLineNumber===w.startLineNumber&&g.endColumn<=w.startColumn||w.endLineNumber<g.startLineNumber||w.endLineNumber===g.startLineNumber&&w.endColumn<=g.startColumn)}static compareRangesUsingStarts(g,w){if(g&&w){const l=g.startLineNumber|0,f=w.startLineNumber|0;if(l===f){const $=g.startColumn|0,d=w.startColumn|0;if($===d){const E=g.endLineNumber|0,e=w.endLineNumber|0;if(E===e){const m=g.endColumn|0,v=w.endColumn|0;return m-v}return E-e}return $-d}return l-f}return(g?1:0)-(w?1:0)}static compareRangesUsingEnds(g,w){return g.endLineNumber===w.endLineNumber?g.endColumn===w.endColumn?g.startLineNumber===w.startLineNumber?g.startColumn-w.startColumn:g.startLineNumber-w.startLineNumber:g.endColumn-w.endColumn:g.endLineNumber-w.endLineNumber}static spansMultipleLines(g){return g.endLineNumber>g.startLineNumber}toJSON(){return this}}i.$dt=n}),ne(ie[49],re([0,1,2]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$et=void 0;class n{static insert(g,w){return{range:new t.$dt(g.lineNumber,g.column,g.lineNumber,g.column),text:w,forceMoveMarkers:!0}}static delete(g){return{range:g,text:null}}static replace(g,w){return{range:g,text:w}}static replaceMove(g,w){return{range:g,text:w,forceMoveMarkers:!0}}}i.$et=n}),ne(ie[15],re([0,1,4,6,2,9]),function(q,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Fv=i.$Ev=void 0;class w{static fromRange(l){return new w(l.startLineNumber,l.endLineNumber)}static fromRangeInclusive(l){return new w(l.startLineNumber,l.endLineNumber+1)}static subtract(l,f){return f?l.startLineNumber<f.startLineNumber&&f.endLineNumberExclusive<l.endLineNumberExclusive?[new w(l.startLineNumber,f.startLineNumber),new w(f.endLineNumberExclusive,l.endLineNumberExclusive)]:f.startLineNumber<=l.startLineNumber&&l.endLineNumberExclusive<=f.endLineNumberExclusive?[]:f.endLineNumberExclusive<l.endLineNumberExclusive?[new w(Math.max(f.endLineNumberExclusive,l.startLineNumber),l.endLineNumberExclusive)]:[new w(l.startLineNumber,Math.min(f.startLineNumber,l.endLineNumberExclusive))]:[l]}static joinMany(l){if(l.length===0)return[];let f=new b(l[0].slice());for(let $=1;$<l.length;$++)f=f.getUnion(new b(l[$].slice()));return f.ranges}static join(l){if(l.length===0)throw new t.$cb("lineRanges cannot be empty");let f=l[0].startLineNumber,$=l[0].endLineNumberExclusive;for(let d=1;d<l.length;d++)f=Math.min(f,l[d].startLineNumber),$=Math.max($,l[d].endLineNumberExclusive);return new w(f,$)}static ofLength(l,f){return new w(l,l+f)}static deserialize(l){return new w(l[0],l[1])}constructor(l,f){if(l>f)throw new t.$cb(`startLineNumber ${l} cannot be after endLineNumberExclusive ${f}`);this.startLineNumber=l,this.endLineNumberExclusive=f}contains(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(l){return new w(this.startLineNumber+l,this.endLineNumberExclusive+l)}deltaLength(l){return new w(this.startLineNumber,this.endLineNumberExclusive+l)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(l){return new w(Math.min(this.startLineNumber,l.startLineNumber),Math.max(this.endLineNumberExclusive,l.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(l){const f=Math.max(this.startLineNumber,l.startLineNumber),$=Math.min(this.endLineNumberExclusive,l.endLineNumberExclusive);if(f<=$)return new w(f,$)}intersectsStrict(l){return this.startLineNumber<l.endLineNumberExclusive&&l.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(l){return this.startLineNumber<=l.endLineNumberExclusive&&l.startLineNumber<=this.endLineNumberExclusive}equals(l){return this.startLineNumber===l.startLineNumber&&this.endLineNumberExclusive===l.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new p.$dt(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new p.$dt(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(l){const f=[];for(let $=this.startLineNumber;$<this.endLineNumberExclusive;$++)f.push(l($));return f}forEach(l){for(let f=this.startLineNumber;f<this.endLineNumberExclusive;f++)l(f)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(l){return this.startLineNumber<=l&&l<this.endLineNumberExclusive}toOffsetRange(){return new n.$Cv(this.startLineNumber-1,this.endLineNumberExclusive-1)}}i.$Ev=w;class b{constructor(l=[]){this.c=l}get ranges(){return this.c}addRange(l){if(l.length===0)return;const f=(0,g.$kb)(this.c,d=>d.endLineNumberExclusive>=l.startLineNumber),$=(0,g.$ib)(this.c,d=>d.startLineNumber<=l.endLineNumberExclusive)+1;if(f===$)this.c.splice(f,0,l);else if(f===$-1){const d=this.c[f];this.c[f]=d.join(l)}else{const d=this.c[f].join(this.c[$-1]).join(l);this.c.splice(f,$-f,d)}}contains(l){const f=(0,g.$hb)(this.c,$=>$.startLineNumber<=l);return!!f&&f.endLineNumberExclusive>l}intersects(l){const f=(0,g.$hb)(this.c,$=>$.startLineNumber<l.endLineNumberExclusive);return!!f&&f.endLineNumberExclusive>l.startLineNumber}getUnion(l){if(this.c.length===0)return l;if(l.c.length===0)return this;const f=[];let $=0,d=0,E=null;for(;$<this.c.length||d<l.c.length;){let e=null;if($<this.c.length&&d<l.c.length){const m=this.c[$],v=l.c[d];m.startLineNumber<v.startLineNumber?(e=m,$++):(e=v,d++)}else $<this.c.length?(e=this.c[$],$++):(e=l.c[d],d++);E===null?E=e:E.endLineNumberExclusive>=e.startLineNumber?E=new w(E.startLineNumber,Math.max(E.endLineNumberExclusive,e.endLineNumberExclusive)):(f.push(E),E=e)}return E!==null&&f.push(E),new b(f)}subtractFrom(l){const f=(0,g.$kb)(this.c,e=>e.endLineNumberExclusive>=l.startLineNumber),$=(0,g.$ib)(this.c,e=>e.startLineNumber<=l.endLineNumberExclusive)+1;if(f===$)return new b([l]);const d=[];let E=l.startLineNumber;for(let e=f;e<$;e++){const m=this.c[e];m.startLineNumber>E&&d.push(new w(E,m.startLineNumber)),E=m.endLineNumberExclusive}return E<l.endLineNumberExclusive&&d.push(new w(E,l.endLineNumberExclusive)),new b(d)}toString(){return this.c.map(l=>l.toString()).join(", ")}getIntersection(l){const f=[];let $=0,d=0;for(;$<this.c.length&&d<l.c.length;){const E=this.c[$],e=l.c[d],m=E.intersect(e);m&&!m.isEmpty&&f.push(m),E.endLineNumberExclusive<e.endLineNumberExclusive?$++:d++}return new b(f)}getWithDelta(l){return new b(this.c.map(f=>f.delta(l)))}}i.$Fv=b}),ne(ie[50],re([0,1,5,2]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$ft=i.SelectionDirection=void 0;var p;(function(w){w[w.LTR=0]="LTR",w[w.RTL=1]="RTL"})(p||(i.SelectionDirection=p={}));class g extends n.$dt{constructor(b,a,l,f){super(b,a,l,f),this.selectionStartLineNumber=b,this.selectionStartColumn=a,this.positionLineNumber=l,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return g.selectionsEqual(this,b)}static selectionsEqual(b,a){return b.selectionStartLineNumber===a.selectionStartLineNumber&&b.selectionStartColumn===a.selectionStartColumn&&b.positionLineNumber===a.positionLineNumber&&b.positionColumn===a.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?p.LTR:p.RTL}setEndPosition(b,a){return this.getDirection()===p.LTR?new g(this.startLineNumber,this.startColumn,b,a):new g(b,a,this.startLineNumber,this.startColumn)}getPosition(){return new t.$ct(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new t.$ct(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,a){return this.getDirection()===p.LTR?new g(b,a,this.endLineNumber,this.endColumn):new g(this.endLineNumber,this.endColumn,b,a)}static fromPositions(b,a=b){return new g(b.lineNumber,b.column,a.lineNumber,a.column)}static fromRange(b,a){return a===p.LTR?new g(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new g(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new g(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,a){if(b&&!a||!b&&a)return!1;if(!b&&!a)return!0;if(b.length!==a.length)return!1;for(let l=0,f=b.length;l<f;l++)if(!this.selectionsEqual(b[l],a[l]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,a,l,f,$){return $===p.LTR?new g(b,a,l,f):new g(l,f,b,a)}}i.$ft=g}),ne(ie[31],re([0,1,5,2]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Ot=void 0;class p{static lengthDiffNonNegative(w,b){return b.isLessThan(w)?p.zero:w.lineCount===b.lineCount?new p(0,b.columnCount-w.columnCount):new p(b.lineCount-w.lineCount,b.columnCount)}static betweenPositions(w,b){return w.lineNumber===b.lineNumber?new p(0,b.column-w.column):new p(b.lineNumber-w.lineNumber,b.column-1)}static ofRange(w){return p.betweenPositions(w.getStartPosition(),w.getEndPosition())}static ofText(w){let b=0,a=0;for(const l of w)l===`
`?(b++,a=0):a++;return new p(b,a)}constructor(w,b){this.lineCount=w,this.columnCount=b}isZero(){return this.lineCount===0&&this.columnCount===0}isLessThan(w){return this.lineCount!==w.lineCount?this.lineCount<w.lineCount:this.columnCount<w.columnCount}isGreaterThan(w){return this.lineCount!==w.lineCount?this.lineCount>w.lineCount:this.columnCount>w.columnCount}isGreaterThanOrEqualTo(w){return this.lineCount!==w.lineCount?this.lineCount>w.lineCount:this.columnCount>=w.columnCount}equals(w){return this.lineCount===w.lineCount&&this.columnCount===w.columnCount}compare(w){return this.lineCount!==w.lineCount?this.lineCount-w.lineCount:this.columnCount-w.columnCount}add(w){return w.lineCount===0?new p(this.lineCount,this.columnCount+w.columnCount):new p(this.lineCount+w.lineCount,w.columnCount)}createRange(w){return this.lineCount===0?new n.$dt(w.lineNumber,w.column,w.lineNumber,w.column+this.columnCount):new n.$dt(w.lineNumber,w.column,w.lineNumber+this.lineCount,this.columnCount+1)}toRange(){return new n.$dt(1,1,this.lineCount+1,this.columnCount+1)}addToPosition(w){return this.lineCount===0?new t.$ct(w.lineNumber,w.column+this.columnCount):new t.$ct(w.lineNumber+this.lineCount,this.columnCount+1)}toString(){return`${this.lineCount},${this.columnCount}`}}i.$Ot=p,p.zero=new p(0,0)}),ne(ie[51],re([0,1,9,6,5,2,31]),function(q,i,t,n,p,g,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$Xv=void 0;class b{constructor(l){this.text=l,this.a=[],this.a.push(0);for(let f=0;f<l.length;f++)l.charAt(f)===`
`&&this.a.push(f+1)}getOffset(l){return this.a[l.lineNumber-1]+l.column-1}getOffsetRange(l){return new n.$Cv(this.getOffset(l.getStartPosition()),this.getOffset(l.getEndPosition()))}getPosition(l){const f=(0,t.$ib)(this.a,E=>E<=l),$=f+1,d=l-this.a[f]+1;return new p.$ct($,d)}getRange(l){return g.$dt.fromPositions(this.getPosition(l.start),this.getPosition(l.endExclusive))}getTextLength(l){return w.$Ot.ofRange(this.getRange(l))}get textLength(){const l=this.a.length-1;return new w.$Ot(l,this.text.length-this.a[l])}}i.$Xv=b}),ne(ie[52],re([0,1,11,4,5,51,2,31]),function(q,i,t,n,p,g,w,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$3v=i.$2v=i.$1v=i.$Zv=i.$Yv=void 0;class a{static single(m,v){return new a([new l(m,v)])}constructor(m){this.edits=m,(0,t.$hd)(()=>(0,t.$id)(m,(v,R)=>v.range.getEndPosition().isBeforeOrEqual(R.range.getStartPosition())))}normalize(){const m=[];for(const v of this.edits)if(m.length>0&&m[m.length-1].range.getEndPosition().equals(v.range.getStartPosition())){const R=m[m.length-1];m[m.length-1]=new l(R.range.plusRange(v.range),R.text+v.text)}else v.isEmpty||m.push(v);return new a(m)}mapPosition(m){let v=0,R=0,A=0;for(const L of this.edits){const N=L.range.getStartPosition(),c=L.range.getEndPosition();if(m.isBeforeOrEqual(N))break;const u=b.$Ot.ofText(L.text);if(m.isBefore(c)){const s=new p.$ct(N.lineNumber+v,N.column+(N.lineNumber+v===R?A:0)),o=u.addToPosition(s);return f(s,o)}v+=u.lineCount-(L.range.endLineNumber-L.range.startLineNumber),u.lineCount===0?c.lineNumber!==N.lineNumber?A+=u.columnCount-(c.column-1):A+=u.columnCount-(c.column-N.column):A=u.columnCount,R=c.lineNumber+v}return new p.$ct(m.lineNumber+v,m.column+(m.lineNumber+v===R?A:0))}mapRange(m){function v(N){return N instanceof p.$ct?N:N.getStartPosition()}function R(N){return N instanceof p.$ct?N:N.getEndPosition()}const A=v(this.mapPosition(m.getStartPosition())),L=R(this.mapPosition(m.getEndPosition()));return f(A,L)}inverseMapPosition(m,v){return this.inverse(v).mapPosition(m)}inverseMapRange(m,v){return this.inverse(v).mapRange(m)}apply(m){let v="",R=new p.$ct(1,1);for(const L of this.edits){const N=L.range,c=N.getStartPosition(),u=N.getEndPosition(),s=f(R,c);s.isEmpty()||(v+=m.getValueOfRange(s)),v+=L.text,R=u}const A=f(R,m.endPositionExclusive);return A.isEmpty()||(v+=m.getValueOfRange(A)),v}applyToString(m){const v=new E(m);return this.apply(v)}inverse(m){const v=this.getNewRanges();return new a(this.edits.map((R,A)=>new l(v[A],m.getValueOfRange(R.range))))}getNewRanges(){const m=[];let v=0,R=0,A=0;for(const L of this.edits){const N=b.$Ot.ofText(L.text),c=p.$ct.lift({lineNumber:L.range.startLineNumber+R,column:L.range.startColumn+(L.range.startLineNumber===v?A:0)}),u=N.createRange(c);m.push(u),R=u.endLineNumber-L.range.endLineNumber,A=u.endColumn-L.range.endColumn,v=L.range.endLineNumber}return m}}i.$Yv=a;class l{constructor(m,v){this.range=m,this.text=v}get isEmpty(){return this.range.isEmpty()&&this.text.length===0}static equals(m,v){return m.range.equalsRange(v.range)&&m.text===v.text}toSingleEditOperation(){return{range:this.range,text:this.text}}}i.$Zv=l;function f(e,m){if(e.lineNumber===m.lineNumber&&e.column===Number.MAX_SAFE_INTEGER)return w.$dt.fromPositions(m,m);if(!e.isBeforeOrEqual(m))throw new n.$cb("start must be before end");return new w.$dt(e.lineNumber,e.column,m.lineNumber,m.column)}class ${get endPositionExclusive(){return this.length.addToPosition(new p.$ct(1,1))}getValue(){return this.getValueOfRange(this.length.toRange())}}i.$1v=$;class d extends ${constructor(m,v){(0,t.$fd)(v>=1),super(),this.c=m,this.d=v}getValueOfRange(m){if(m.startLineNumber===m.endLineNumber)return this.c(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);let v=this.c(m.startLineNumber).substring(m.startColumn-1);for(let R=m.startLineNumber+1;R<m.endLineNumber;R++)v+=`
`+this.c(R);return v+=`
`+this.c(m.endLineNumber).substring(0,m.endColumn-1),v}get length(){const m=this.c(this.d);return new b.$Ot(this.d-1,m.length)}}i.$2v=d;class E extends ${constructor(m){super(),this.value=m,this.c=new g.$Xv(this.value)}getValueOfRange(m){return this.c.getOffsetRange(m).substring(this.value)}get length(){return this.c.textLength}}i.$3v=E}),ne(ie[53],re([0,1,3,16,30]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$qt=i.WordCharacterClass=void 0,i.$rt=a;var g;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(g||(i.WordCharacterClass=g={}));class w extends p.$ot{constructor(f,$){super(g.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=$,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let d=0,E=f.length;d<E;d++)this.set(f.charCodeAt(d),g.WordSeparator);this.set(t.CharCode.Space,g.Whitespace),this.set(t.CharCode.Tab,g.Whitespace)}findPrevIntlWordBeforeOrAtOffset(f,$){let d=null;for(const E of this.h(f)){if(E.index>$)break;d=E}return d}findNextIntlWordAtOrAfterOffset(f,$){for(const d of this.h(f))if(!(d.index<$))return d;return null}h(f){return this.e?this.f===f?this.g:(this.f=f,this.g=this.j(this.e.segment(f)),this.g):[]}j(f){const $=[];for(const d of f)this.k(d)&&$.push(d);return $}k(f){return!!f.isWordLike}}i.$qt=w;const b=new n.$Dc(10);function a(l,f){const $=`${l}/${f.join(",")}`;let d=b.get($);return d||(d=new w(l,f),b.set($,d)),d}}),ne(ie[32],re([0,1,23,12,24]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$tt=i.$st=void 0,i.$ut=w,i.$vt=a,i.$wt=l,i.$st="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g($=""){let d="(-?\\d*\\.\\d\\w*)|([^";for(const E of i.$st)$.indexOf(E)>=0||(d+="\\"+E);return d+="\\s]+)",new RegExp(d,"g")}i.$tt=g();function w($){let d=i.$tt;if($&&$ instanceof RegExp)if($.global)d=$;else{let E="g";$.ignoreCase&&(E+="i"),$.multiline&&(E+="m"),$.unicode&&(E+="u"),d=new RegExp($.source,E)}return d.lastIndex=0,d}const b=new p.$5c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function a($){const d=b.unshift($);return(0,n.$Sc)(d)}function l($,d,E,e,m){if(d=w(d),m||(m=t.Iterable.first(b)),E.length>m.maxLen){let N=$-m.maxLen/2;return N<0?N=0:e+=N,E=E.substring(N,$+m.maxLen/2),l($,d,E,e,m)}const v=Date.now(),R=$-1-e;let A=-1,L=null;for(let N=1;!(Date.now()-v>=m.timeBudget);N++){const c=R-m.windowSize*N;d.lastIndex=Math.max(0,c);const u=f(d,E,R,A);if(!u&&L||(L=u,c<=0))break;A=c}if(L){const N={word:L[0],startColumn:e+1+L.index,endColumn:e+1+L.index+L[0].length};return d.lastIndex=0,N}return null}function f($,d,E,e){let m;for(;m=$.exec(d);){const v=m.index||0;if(v<=E&&$.lastIndex>=E)return m;if(e>0&&v>e)return null}return null}}),ne(ie[10],re([0,1,7,4,6]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$i3=i.$h3=i.$g3=i.$f3=i.$e3=void 0;class g{static trivial($,d){return new g([new w(p.$Cv.ofLength($.length),p.$Cv.ofLength(d.length))],!1)}static trivialTimedOut($,d){return new g([new w(p.$Cv.ofLength($.length),p.$Cv.ofLength(d.length))],!0)}constructor($,d){this.diffs=$,this.hitTimeout=d}}i.$e3=g;class w{static invert($,d){const E=[];return(0,t.$Bb)($,(e,m)=>{E.push(w.fromOffsetPairs(e?e.getEndExclusives():b.zero,m?m.getStarts():new b(d,(e?e.seq2Range.endExclusive-e.seq1Range.endExclusive:0)+d)))}),E}static fromOffsetPairs($,d){return new w(new p.$Cv($.offset1,d.offset1),new p.$Cv($.offset2,d.offset2))}constructor($,d){this.seq1Range=$,this.seq2Range=d}swap(){return new w(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join($){return new w(this.seq1Range.join($.seq1Range),this.seq2Range.join($.seq2Range))}delta($){return $===0?this:new w(this.seq1Range.delta($),this.seq2Range.delta($))}deltaStart($){return $===0?this:new w(this.seq1Range.deltaStart($),this.seq2Range.deltaStart($))}deltaEnd($){return $===0?this:new w(this.seq1Range.deltaEnd($),this.seq2Range.deltaEnd($))}intersectsOrTouches($){return this.seq1Range.intersectsOrTouches($.seq1Range)||this.seq2Range.intersectsOrTouches($.seq2Range)}intersect($){const d=this.seq1Range.intersect($.seq1Range),E=this.seq2Range.intersect($.seq2Range);if(!(!d||!E))return new w(d,E)}getStarts(){return new b(this.seq1Range.start,this.seq2Range.start)}getEndExclusives(){return new b(this.seq1Range.endExclusive,this.seq2Range.endExclusive)}}i.$f3=w;class b{constructor($,d){this.offset1=$,this.offset2=d}toString(){return`${this.offset1} <-> ${this.offset2}`}delta($){return $===0?this:new b(this.offset1+$,this.offset2+$)}equals($){return this.offset1===$.offset1&&this.offset2===$.offset2}}i.$g3=b,b.zero=new b(0,0),b.max=new b(Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER);class a{isValid(){return!0}}i.$h3=a,a.instance=new a;class l{constructor($){if(this.e=$,this.c=Date.now(),this.d=!0,$<=0)throw new n.$cb("timeout must be positive")}isValid(){if(!(Date.now()-this.c<this.e)&&this.d){this.d=!1;debugger}return this.d}disable(){this.e=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.d=!0}}i.$i3=l}),ne(ie[33],re([0,1,6,10]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$n3=void 0;class p{compute(l,f,$=n.$h3.instance){if(l.length===0||f.length===0)return n.$e3.trivial(l,f);const d=l,E=f;function e(s,o){for(;s<d.length&&o<E.length&&d.getElement(s)===E.getElement(o);)s++,o++;return s}let m=0;const v=new w;v.set(0,e(0,0));const R=new b;R.set(0,v.get(0)===0?null:new g(null,0,0,v.get(0)));let A=0;e:for(;;){if(m++,!$.isValid())return n.$e3.trivialTimedOut(d,E);const s=-Math.min(m,E.length+m%2),o=Math.min(m,d.length+m%2);for(A=s;A<=o;A+=2){let h=0;const U=A===o?-1:v.get(A+1),_=A===s?-1:v.get(A-1)+1;h++;const T=Math.min(Math.max(U,_),d.length),M=T-A;if(h++,T>d.length||M>E.length)continue;const j=e(T,M);v.set(A,j);const I=T===U?R.get(A+1):R.get(A-1);if(R.set(A,j!==T?new g(I,T,M,j-T):I),v.get(A)===d.length&&v.get(A)-A===E.length)break e}}let L=R.get(A);const N=[];let c=d.length,u=E.length;for(;;){const s=L?L.x+L.length:0,o=L?L.y+L.length:0;if((s!==c||o!==u)&&N.push(new n.$f3(new t.$Cv(s,c),new t.$Cv(o,u))),!L)break;c=L.x,u=L.y,L=L.prev}return N.reverse(),new n.$e3(N,!1)}}i.$n3=p;class g{constructor(l,f,$,d){this.prev=l,this.x=f,this.y=$,this.length=d}}class w{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,f){if(l<0){if(l=-l-1,l>=this.b.length){const $=this.b;this.b=new Int32Array($.length*2),this.b.set($)}this.b[l]=f}else{if(l>=this.a.length){const $=this.a;this.a=new Int32Array($.length*2),this.a.set($)}this.a[l]=f}}}class b{constructor(){this.a=[],this.b=[]}get(l){return l<0?(l=-l-1,this.b[l]):this.a[l]}set(l,f){l<0?(l=-l-1,this.b[l]=f):this.a[l]=f}}}),ne(ie[54],re([0,1,7,6,10]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$r3=g,i.$s3=l,i.$t3=f,i.$u3=d,i.$v3=E;function g(e,m,v){let R=v;return R=w(e,m,R),R=w(e,m,R),R=b(e,m,R),R}function w(e,m,v){if(v.length===0)return v;const R=[];R.push(v[0]);for(let L=1;L<v.length;L++){const N=R[R.length-1];let c=v[L];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const u=c.seq1Range.start-N.seq1Range.endExclusive;let s;for(s=1;s<=u&&!(e.getElement(c.seq1Range.start-s)!==e.getElement(c.seq1Range.endExclusive-s)||m.getElement(c.seq2Range.start-s)!==m.getElement(c.seq2Range.endExclusive-s));s++);if(s--,s===u){R[R.length-1]=new p.$f3(new n.$Cv(N.seq1Range.start,c.seq1Range.endExclusive-u),new n.$Cv(N.seq2Range.start,c.seq2Range.endExclusive-u));continue}c=c.delta(-s)}R.push(c)}const A=[];for(let L=0;L<R.length-1;L++){const N=R[L+1];let c=R[L];if(c.seq1Range.isEmpty||c.seq2Range.isEmpty){const u=N.seq1Range.start-c.seq1Range.endExclusive;let s;for(s=0;s<u&&!(!e.isStronglyEqual(c.seq1Range.start+s,c.seq1Range.endExclusive+s)||!m.isStronglyEqual(c.seq2Range.start+s,c.seq2Range.endExclusive+s));s++);if(s===u){R[L+1]=new p.$f3(new n.$Cv(c.seq1Range.start+u,N.seq1Range.endExclusive),new n.$Cv(c.seq2Range.start+u,N.seq2Range.endExclusive));continue}s>0&&(c=c.delta(s))}A.push(c)}return R.length>0&&A.push(R[R.length-1]),A}function b(e,m,v){if(!e.getBoundaryScore||!m.getBoundaryScore)return v;for(let R=0;R<v.length;R++){const A=R>0?v[R-1]:void 0,L=v[R],N=R+1<v.length?v[R+1]:void 0,c=new n.$Cv(A?A.seq1Range.endExclusive+1:0,N?N.seq1Range.start-1:e.length),u=new n.$Cv(A?A.seq2Range.endExclusive+1:0,N?N.seq2Range.start-1:m.length);L.seq1Range.isEmpty?v[R]=a(L,e,m,c,u):L.seq2Range.isEmpty&&(v[R]=a(L.swap(),m,e,u,c).swap())}return v}function a(e,m,v,R,A){let N=1;for(;e.seq1Range.start-N>=R.start&&e.seq2Range.start-N>=A.start&&v.isStronglyEqual(e.seq2Range.start-N,e.seq2Range.endExclusive-N)&&N<100;)N++;N--;let c=0;for(;e.seq1Range.start+c<R.endExclusive&&e.seq2Range.endExclusive+c<A.endExclusive&&v.isStronglyEqual(e.seq2Range.start+c,e.seq2Range.endExclusive+c)&&c<100;)c++;if(N===0&&c===0)return e;let u=0,s=-1;for(let o=-N;o<=c;o++){const h=e.seq2Range.start+o,U=e.seq2Range.endExclusive+o,_=e.seq1Range.start+o,T=m.getBoundaryScore(_)+v.getBoundaryScore(h)+v.getBoundaryScore(U);T>s&&(s=T,u=o)}return e.delta(u)}function l(e,m,v){const R=[];for(const A of v){const L=R[R.length-1];if(!L){R.push(A);continue}A.seq1Range.start-L.seq1Range.endExclusive<=2||A.seq2Range.start-L.seq2Range.endExclusive<=2?R[R.length-1]=new p.$f3(L.seq1Range.join(A.seq1Range),L.seq2Range.join(A.seq2Range)):R.push(A)}return R}function f(e,m,v){const R=p.$f3.invert(v,e.length),A=[];let L=new p.$g3(0,0);function N(u,s){if(u.offset1<L.offset1||u.offset2<L.offset2)return;const o=e.findWordContaining(u.offset1),h=m.findWordContaining(u.offset2);if(!o||!h)return;let U=new p.$f3(o,h);const _=U.intersect(s);let T=_.seq1Range.length,M=_.seq2Range.length;for(;R.length>0;){const j=R[0];if(!(j.seq1Range.intersects(U.seq1Range)||j.seq2Range.intersects(U.seq2Range)))break;const S=e.findWordContaining(j.seq1Range.start),D=m.findWordContaining(j.seq2Range.start),B=new p.$f3(S,D),Z=B.intersect(j);if(T+=Z.seq1Range.length,M+=Z.seq2Range.length,U=U.join(B),U.seq1Range.endExclusive>=j.seq1Range.endExclusive)R.shift();else break}T+M<(U.seq1Range.length+U.seq2Range.length)*2/3&&A.push(U),L=U.getEndExclusives()}for(;R.length>0;){const u=R.shift();u.seq1Range.isEmpty||(N(u.getStarts(),u),N(u.getEndExclusives().delta(-1),u))}return $(v,A)}function $(e,m){const v=[];for(;e.length>0||m.length>0;){const R=e[0],A=m[0];let L;R&&(!A||R.seq1Range.start<A.seq1Range.start)?L=e.shift():L=m.shift(),v.length>0&&v[v.length-1].seq1Range.endExclusive>=L.seq1Range.start?v[v.length-1]=v[v.length-1].join(L):v.push(L)}return v}function d(e,m,v){let R=v;if(R.length===0)return R;let A=0,L;do{L=!1;const N=[R[0]];for(let c=1;c<R.length;c++){let o=function(U,_){const T=new n.$Cv(s.seq1Range.endExclusive,u.seq1Range.start);return e.getText(T).replace(/\s/g,"").length<=4&&(U.seq1Range.length+U.seq2Range.length>5||_.seq1Range.length+_.seq2Range.length>5)};const u=R[c],s=N[N.length-1];o(s,u)?(L=!0,N[N.length-1]=N[N.length-1].join(u)):N.push(u)}R=N}while(A++<10&&L);return R}function E(e,m,v){let R=v;if(R.length===0)return R;let A=0,L;do{L=!1;const c=[R[0]];for(let u=1;u<R.length;u++){let h=function(_,T){const M=new n.$Cv(o.seq1Range.endExclusive,s.seq1Range.start);if(e.countLinesIn(M)>5||M.length>500)return!1;const I=e.getText(M).trim();if(I.length>20||I.split(/\r\n|\r|\n/).length>1)return!1;const S=e.countLinesIn(_.seq1Range),D=_.seq1Range.length,B=m.countLinesIn(_.seq2Range),Z=_.seq2Range.length,O=e.countLinesIn(T.seq1Range),P=T.seq1Range.length,X=m.countLinesIn(T.seq2Range),Y=T.seq2Range.length,H=2*40+50;function K(C){return Math.min(C,H)}return Math.pow(Math.pow(K(S*40+D),1.5)+Math.pow(K(B*40+Z),1.5),1.5)+Math.pow(Math.pow(K(O*40+P),1.5)+Math.pow(K(X*40+Y),1.5),1.5)>(H**1.5)**1.5*1.3};const s=R[u],o=c[c.length-1];h(o,s)?(L=!0,c[c.length-1]=c[c.length-1].join(s)):c.push(s)}R=c}while(A++<10&&L);const N=[];return(0,t.$Cb)(R,(c,u,s)=>{let o=u;function h(I){return I.length>0&&I.trim().length<=3&&u.seq1Range.length+u.seq2Range.length>100}const U=e.extendToFullLines(u.seq1Range),_=e.getText(new n.$Cv(U.start,u.seq1Range.start));h(_)&&(o=o.deltaStart(-_.length));const T=e.getText(new n.$Cv(u.seq1Range.endExclusive,U.endExclusive));h(T)&&(o=o.deltaEnd(T.length));const M=p.$f3.fromOffsetPairs(c?c.getEndExclusives():p.$g3.zero,s?s.getStarts():p.$g3.max),j=o.intersect(M);N.length>0&&j.getStarts().equals(N[N.length-1].getEndExclusives())?N[N.length-1]=N[N.length-1].join(j):N.push(j)}),N}}),ne(ie[55],re([0,1,3]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$q3=void 0;class n{constructor(w,b){this.a=w,this.b=b}getElement(w){return this.a[w]}get length(){return this.a.length}getBoundaryScore(w){const b=w===0?0:p(this.b[w-1]),a=w===this.b.length?0:p(this.b[w]);return 1e3-(b+a)}getText(w){return this.b.slice(w.start,w.endExclusive).join(`
`)}isStronglyEqual(w,b){return this.b[w]===this.b[b]}}i.$q3=n;function p(g){let w=0;for(;w<g.length&&(g.charCodeAt(w)===t.CharCode.Space||g.charCodeAt(w)===t.CharCode.Tab);)w++;return w}}),ne(ie[20],re([0,1,3]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$l3=i.$j3=void 0,i.$k3=p;class n{constructor(b,a){this.width=b,this.height=a,this.a=[],this.a=new Array(b*a)}get(b,a){return this.a[b+a*this.width]}set(b,a,l){this.a[b+a*this.width]=l}}i.$j3=n;function p(w){return w===t.CharCode.Space||w===t.CharCode.Tab}class g{static b(b){let a=this.a.get(b);return a===void 0&&(a=this.a.size,this.a.set(b,a)),a}constructor(b,a,l){this.range=b,this.lines=a,this.source=l,this.d=[];let f=0;for(let $=b.startLineNumber-1;$<b.endLineNumberExclusive-1;$++){const d=a[$];for(let e=0;e<d.length;e++){f++;const m=d[e],v=g.b(m);this.d[v]=(this.d[v]||0)+1}f++;const E=g.b(`
`);this.d[E]=(this.d[E]||0)+1}this.c=f}computeSimilarity(b){let a=0;const l=Math.max(this.d.length,b.d.length);for(let f=0;f<l;f++)a+=Math.abs((this.d[f]??0)-(b.d[f]??0));return 1-a/(this.c+b.c)}}i.$l3=g,g.a=new Map}),ne(ie[56],re([0,1,6,10,20]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$m3=void 0;class g{compute(b,a,l=n.$h3.instance,f){if(b.length===0||a.length===0)return n.$e3.trivial(b,a);const $=new p.$j3(b.length,a.length),d=new p.$j3(b.length,a.length),E=new p.$j3(b.length,a.length);for(let N=0;N<b.length;N++)for(let c=0;c<a.length;c++){if(!l.isValid())return n.$e3.trivialTimedOut(b,a);const u=N===0?0:$.get(N-1,c),s=c===0?0:$.get(N,c-1);let o;b.getElement(N)===a.getElement(c)?(N===0||c===0?o=0:o=$.get(N-1,c-1),N>0&&c>0&&d.get(N-1,c-1)===3&&(o+=E.get(N-1,c-1)),o+=f?f(N,c):1):o=-1;const h=Math.max(u,s,o);if(h===o){const U=N>0&&c>0?E.get(N-1,c-1):0;E.set(N,c,U+1),d.set(N,c,3)}else h===u?(E.set(N,c,0),d.set(N,c,1)):h===s&&(E.set(N,c,0),d.set(N,c,2));$.set(N,c,h)}const e=[];let m=b.length,v=a.length;function R(N,c){(N+1!==m||c+1!==v)&&e.push(new n.$f3(new t.$Cv(N+1,m),new t.$Cv(c+1,v))),m=N,v=c}let A=b.length-1,L=a.length-1;for(;A>=0&&L>=0;)d.get(A,L)===3?(R(A,L),A--,L--):d.get(A,L)===1?A--:L--;return R(-1,-1),e.reverse(),new n.$e3(e,!1)}}i.$m3=g}),ne(ie[34],re([0,1,9,3,6,5,2,20]),function(q,i,t,n,p,g,w,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$o3=void 0;class a{constructor(m,v,R){this.lines=m,this.considerWhitespaceChanges=R,this.b=[],this.c=[],this.d=[];let A=!1;v.start>0&&v.endExclusive>=m.length&&(v=new p.$Cv(v.start-1,v.endExclusive),A=!0),this.lineRange=v,this.c[0]=0;for(let L=this.lineRange.start;L<this.lineRange.endExclusive;L++){let N=m[L],c=0;if(A)c=N.length,N="",A=!1;else if(!R){const u=N.trimStart();c=N.length-u.length,N=u.trimEnd()}this.d.push(c);for(let u=0;u<N.length;u++)this.b.push(N.charCodeAt(u));L<m.length-1&&(this.b.push(10),this.c[L-this.lineRange.start+1]=this.b.length)}this.d.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new p.$Cv(0,this.length))}getText(m){return this.b.slice(m.start,m.endExclusive).map(v=>String.fromCharCode(v)).join("")}getElement(m){return this.b[m]}get length(){return this.b.length}getBoundaryScore(m){const v=E(m>0?this.b[m-1]:-1),R=E(m<this.b.length?this.b[m]:-1);if(v===f.LineBreakCR&&R===f.LineBreakLF)return 0;if(v===f.LineBreakLF)return 150;let A=0;return v!==R&&(A+=10,v===f.WordLower&&R===f.WordUpper&&(A+=1)),A+=d(v),A+=d(R),A}translateOffset(m){if(this.lineRange.isEmpty)return new g.$ct(this.lineRange.start+1,1);const v=(0,t.$ib)(this.c,R=>R<=m);return new g.$ct(this.lineRange.start+v+1,m-this.c[v]+this.d[v]+1)}translateRange(m){return w.$dt.fromPositions(this.translateOffset(m.start),this.translateOffset(m.endExclusive))}findWordContaining(m){if(m<0||m>=this.b.length||!l(this.b[m]))return;let v=m;for(;v>0&&l(this.b[v-1]);)v--;let R=m;for(;R<this.b.length&&l(this.b[R]);)R++;return new p.$Cv(v,R)}countLinesIn(m){return this.translateOffset(m.endExclusive).lineNumber-this.translateOffset(m.start).lineNumber}isStronglyEqual(m,v){return this.b[m]===this.b[v]}extendToFullLines(m){const v=(0,t.$hb)(this.c,A=>A<=m.start)??0,R=(0,t.$jb)(this.c,A=>m.endExclusive<=A)??this.b.length;return new p.$Cv(v,R)}}i.$o3=a;function l(e){return e>=n.CharCode.a&&e<=n.CharCode.z||e>=n.CharCode.A&&e<=n.CharCode.Z||e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9}var f;(function(e){e[e.WordLower=0]="WordLower",e[e.WordUpper=1]="WordUpper",e[e.WordNumber=2]="WordNumber",e[e.End=3]="End",e[e.Other=4]="Other",e[e.Separator=5]="Separator",e[e.Space=6]="Space",e[e.LineBreakCR=7]="LineBreakCR",e[e.LineBreakLF=8]="LineBreakLF"})(f||(f={}));const $={[f.WordLower]:0,[f.WordUpper]:0,[f.WordNumber]:0,[f.End]:10,[f.Other]:2,[f.Separator]:30,[f.Space]:3,[f.LineBreakCR]:10,[f.LineBreakLF]:10};function d(e){return $[e]}function E(e){return e===n.CharCode.LineFeed?f.LineBreakLF:e===n.CharCode.CarriageReturn?f.LineBreakCR:(0,b.$k3)(e)?f.Space:e>=n.CharCode.a&&e<=n.CharCode.z?f.WordLower:e>=n.CharCode.A&&e<=n.CharCode.Z?f.WordUpper:e>=n.CharCode.Digit0&&e<=n.CharCode.Digit9?f.WordNumber:e===-1?f.End:e===n.CharCode.Comma||e===n.CharCode.Semicolon?f.Separator:f.Other}}),ne(ie[35],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$8v=i.$7v=void 0;class t{constructor(g,w,b){this.changes=g,this.moves=w,this.hitTimeout=b}}i.$7v=t;class n{constructor(g,w){this.lineRangeMapping=g,this.changes=w}flip(){return new n(this.lineRangeMapping.flip(),this.changes.map(g=>g.flip()))}}i.$8v=n}),ne(ie[21],re([0,1,4,15,2,52]),function(q,i,t,n,p,g){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$6v=i.$5v=i.$4v=void 0;class w{static inverse(f,$,d){const E=[];let e=1,m=1;for(const R of f){const A=new w(new n.$Ev(e,R.original.startLineNumber),new n.$Ev(m,R.modified.startLineNumber));A.modified.isEmpty||E.push(A),e=R.original.endLineNumberExclusive,m=R.modified.endLineNumberExclusive}const v=new w(new n.$Ev(e,$+1),new n.$Ev(m,d+1));return v.modified.isEmpty||E.push(v),E}static clip(f,$,d){const E=[];for(const e of f){const m=e.original.intersect($),v=e.modified.intersect(d);m&&!m.isEmpty&&v&&!v.isEmpty&&E.push(new w(m,v))}return E}constructor(f,$){this.original=f,this.modified=$}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new w(this.modified,this.original)}join(f){return new w(this.original.join(f.original),this.modified.join(f.modified))}get changedLineCount(){return Math.max(this.original.length,this.modified.length)}toRangeMapping(){const f=this.original.toInclusiveRange(),$=this.modified.toInclusiveRange();if(f&&$)return new a(f,$);if(this.original.startLineNumber===1||this.modified.startLineNumber===1){if(!(this.modified.startLineNumber===1&&this.original.startLineNumber===1))throw new t.$cb("not a valid diff");return new a(new p.$dt(this.original.startLineNumber,1,this.original.endLineNumberExclusive,1),new p.$dt(this.modified.startLineNumber,1,this.modified.endLineNumberExclusive,1))}else return new a(new p.$dt(this.original.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.original.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER),new p.$dt(this.modified.startLineNumber-1,Number.MAX_SAFE_INTEGER,this.modified.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER))}}i.$4v=w;class b extends w{static fromRangeMappings(f){const $=n.$Ev.join(f.map(E=>n.$Ev.fromRangeInclusive(E.originalRange))),d=n.$Ev.join(f.map(E=>n.$Ev.fromRangeInclusive(E.modifiedRange)));return new b($,d,f)}constructor(f,$,d){super(f,$),this.innerChanges=d}flip(){return new b(this.modified,this.original,this.innerChanges?.map(f=>f.flip()))}withInnerChangesFromLineRanges(){return new b(this.original,this.modified,[this.toRangeMapping()])}}i.$5v=b;class a{constructor(f,$){this.originalRange=f,this.modifiedRange=$}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new a(this.modifiedRange,this.originalRange)}toTextEdit(f){const $=f.getValueOfRange(this.modifiedRange);return new g.$Zv(this.originalRange,$)}}i.$6v=a}),ne(ie[57],re([0,1,10,21,7,9,16,15,6,34,20,33]),function(q,i,t,n,p,g,w,b,a,l,f,$){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$p3=d;function d(L,N,c,u,s,o){let{moves:h,excludedChanges:U}=e(L,N,c,o);if(!o.isValid())return[];const _=L.filter(M=>!U.has(M)),T=m(_,u,s,N,c,o);return(0,p.$Zb)(h,T),h=R(h),h=h.filter(M=>{const j=M.original.toOffsetRange().slice(N).map(S=>S.trim());return j.join(`
`).length>=15&&E(j,S=>S.length>=2)>=2}),h=A(L,h),h}function E(L,N){let c=0;for(const u of L)N(u)&&c++;return c}function e(L,N,c,u){const s=[],o=L.filter(_=>_.modified.isEmpty&&_.original.length>=3).map(_=>new f.$l3(_.original,N,_)),h=new Set(L.filter(_=>_.original.isEmpty&&_.modified.length>=3).map(_=>new f.$l3(_.modified,c,_))),U=new Set;for(const _ of o){let T=-1,M;for(const j of h){const I=_.computeSimilarity(j);I>T&&(T=I,M=j)}if(T>.9&&M&&(h.delete(M),s.push(new n.$4v(_.range,M.range)),U.add(_.source),U.add(M.source)),!u.isValid())return{moves:s,excludedChanges:U}}return{moves:s,excludedChanges:U}}function m(L,N,c,u,s,o){const h=[],U=new w.$Hc;for(const I of L)for(let S=I.original.startLineNumber;S<I.original.endLineNumberExclusive-2;S++){const D=`${N[S-1]}:${N[S+1-1]}:${N[S+2-1]}`;U.add(D,{range:new b.$Ev(S,S+3)})}const _=[];L.sort((0,p.$6b)(I=>I.modified.startLineNumber,p.$8b));for(const I of L){let S=[];for(let D=I.modified.startLineNumber;D<I.modified.endLineNumberExclusive-2;D++){const B=`${c[D-1]}:${c[D+1-1]}:${c[D+2-1]}`,Z=new b.$Ev(D,D+3),O=[];U.forEach(B,({range:P})=>{for(const Y of S)if(Y.originalLineRange.endLineNumberExclusive+1===P.endLineNumberExclusive&&Y.modifiedLineRange.endLineNumberExclusive+1===Z.endLineNumberExclusive){Y.originalLineRange=new b.$Ev(Y.originalLineRange.startLineNumber,P.endLineNumberExclusive),Y.modifiedLineRange=new b.$Ev(Y.modifiedLineRange.startLineNumber,Z.endLineNumberExclusive),O.push(Y);return}const X={modifiedLineRange:Z,originalLineRange:P};_.push(X),O.push(X)}),S=O}if(!o.isValid())return[]}_.sort((0,p.$0b)((0,p.$6b)(I=>I.modifiedLineRange.length,p.$8b)));const T=new b.$Fv,M=new b.$Fv;for(const I of _){const S=I.modifiedLineRange.startLineNumber-I.originalLineRange.startLineNumber,D=T.subtractFrom(I.modifiedLineRange),B=M.subtractFrom(I.originalLineRange).getWithDelta(S),Z=D.getIntersection(B);for(const O of Z.ranges){if(O.length<3)continue;const P=O,X=O.delta(-S);h.push(new n.$4v(X,P)),T.addRange(P),M.addRange(X)}}h.sort((0,p.$6b)(I=>I.original.startLineNumber,p.$8b));const j=new g.$mb(L);for(let I=0;I<h.length;I++){const S=h[I],D=j.findLastMonotonous(K=>K.original.startLineNumber<=S.original.startLineNumber),B=(0,g.$hb)(L,K=>K.modified.startLineNumber<=S.modified.startLineNumber),Z=Math.max(S.original.startLineNumber-D.original.startLineNumber,S.modified.startLineNumber-B.modified.startLineNumber),O=j.findLastMonotonous(K=>K.original.startLineNumber<S.original.endLineNumberExclusive),P=(0,g.$hb)(L,K=>K.modified.startLineNumber<S.modified.endLineNumberExclusive),X=Math.max(O.original.endLineNumberExclusive-S.original.endLineNumberExclusive,P.modified.endLineNumberExclusive-S.modified.endLineNumberExclusive);let Y;for(Y=0;Y<Z;Y++){const K=S.original.startLineNumber-Y-1,C=S.modified.startLineNumber-Y-1;if(K>u.length||C>s.length||T.contains(C)||M.contains(K)||!v(u[K-1],s[C-1],o))break}Y>0&&(M.addRange(new b.$Ev(S.original.startLineNumber-Y,S.original.startLineNumber)),T.addRange(new b.$Ev(S.modified.startLineNumber-Y,S.modified.startLineNumber)));let H;for(H=0;H<X;H++){const K=S.original.endLineNumberExclusive+H,C=S.modified.endLineNumberExclusive+H;if(K>u.length||C>s.length||T.contains(C)||M.contains(K)||!v(u[K-1],s[C-1],o))break}H>0&&(M.addRange(new b.$Ev(S.original.endLineNumberExclusive,S.original.endLineNumberExclusive+H)),T.addRange(new b.$Ev(S.modified.endLineNumberExclusive,S.modified.endLineNumberExclusive+H))),(Y>0||H>0)&&(h[I]=new n.$4v(new b.$Ev(S.original.startLineNumber-Y,S.original.endLineNumberExclusive+H),new b.$Ev(S.modified.startLineNumber-Y,S.modified.endLineNumberExclusive+H)))}return h}function v(L,N,c){if(L.trim()===N.trim())return!0;if(L.length>300&&N.length>300)return!1;const s=new $.$n3().compute(new l.$o3([L],new a.$Cv(0,1),!1),new l.$o3([N],new a.$Cv(0,1),!1),c);let o=0;const h=t.$f3.invert(s.diffs,L.length);for(const M of h)M.seq1Range.forEach(j=>{(0,f.$k3)(L.charCodeAt(j))||o++});function U(M){let j=0;for(let I=0;I<L.length;I++)(0,f.$k3)(M.charCodeAt(I))||j++;return j}const _=U(L.length>N.length?L:N);return o/_>.6&&_>10}function R(L){if(L.length===0)return L;L.sort((0,p.$6b)(c=>c.original.startLineNumber,p.$8b));const N=[L[0]];for(let c=1;c<L.length;c++){const u=N[N.length-1],s=L[c],o=s.original.startLineNumber-u.original.endLineNumberExclusive,h=s.modified.startLineNumber-u.modified.endLineNumberExclusive;if(o>=0&&h>=0&&o+h<=2){N[N.length-1]=u.join(s);continue}N.push(s)}return N}function A(L,N){const c=new g.$mb(L);return N=N.filter(u=>{const s=c.findLastMonotonous(U=>U.original.startLineNumber<u.original.endLineNumberExclusive)||new n.$4v(new b.$Ev(1,1),new b.$Ev(1,1)),o=(0,g.$hb)(L,U=>U.modified.startLineNumber<u.modified.endLineNumberExclusive);return s!==o}),N}}),ne(ie[58],re([0,1,7,11,15,6,2,10,56,33,57,54,55,34,35,21]),function(q,i,t,n,p,g,w,b,a,l,f,$,d,E,e,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$w3=void 0,i.$x3=R,i.$y3=A;class v{constructor(){this.e=new a.$m3,this.f=new l.$n3}computeDiff(N,c,u){if(N.length<=1&&(0,t.$ub)(N,c,(H,K)=>H===K))return new e.$7v([],[],!1);if(N.length===1&&N[0].length===0||c.length===1&&c[0].length===0)return new e.$7v([new m.$5v(new p.$Ev(1,N.length+1),new p.$Ev(1,c.length+1),[new m.$6v(new w.$dt(1,1,N.length,N[N.length-1].length+1),new w.$dt(1,1,c.length,c[c.length-1].length+1))])],[],!1);const s=u.maxComputationTimeMs===0?b.$h3.instance:new b.$i3(u.maxComputationTimeMs),o=!u.ignoreTrimWhitespace,h=new Map;function U(H){let K=h.get(H);return K===void 0&&(K=h.size,h.set(H,K)),K}const _=N.map(H=>U(H.trim())),T=c.map(H=>U(H.trim())),M=new d.$q3(_,N),j=new d.$q3(T,c),I=M.length+j.length<1700?this.e.compute(M,j,s,(H,K)=>N[H]===c[K]?c[K].length===0?.1:1+Math.log(1+c[K].length):.99):this.f.compute(M,j,s);let S=I.diffs,D=I.hitTimeout;S=(0,$.$r3)(M,j,S),S=(0,$.$u3)(M,j,S);const B=[],Z=H=>{if(o)for(let K=0;K<H;K++){const C=O+K,F=P+K;if(N[C]!==c[F]){const G=this.j(N,c,new b.$f3(new g.$Cv(C,C+1),new g.$Cv(F,F+1)),s,o);for(const oe of G.mappings)B.push(oe);G.hitTimeout&&(D=!0)}}};let O=0,P=0;for(const H of S){(0,n.$hd)(()=>H.seq1Range.start-O===H.seq2Range.start-P);const K=H.seq1Range.start-O;Z(K),O=H.seq1Range.endExclusive,P=H.seq2Range.endExclusive;const C=this.j(N,c,H,s,o);C.hitTimeout&&(D=!0);for(const F of C.mappings)B.push(F)}Z(N.length-O);const X=R(B,N,c);let Y=[];return u.computeMoves&&(Y=this.h(X,N,c,_,T,s,o)),(0,n.$hd)(()=>{function H(C,F){if(C.lineNumber<1||C.lineNumber>F.length)return!1;const G=F[C.lineNumber-1];return!(C.column<1||C.column>G.length+1)}function K(C,F){return!(C.startLineNumber<1||C.startLineNumber>F.length+1||C.endLineNumberExclusive<1||C.endLineNumberExclusive>F.length+1)}for(const C of X){if(!C.innerChanges)return!1;for(const F of C.innerChanges)if(!(H(F.modifiedRange.getStartPosition(),c)&&H(F.modifiedRange.getEndPosition(),c)&&H(F.originalRange.getStartPosition(),N)&&H(F.originalRange.getEndPosition(),N)))return!1;if(!K(C.modified,c)||!K(C.original,N))return!1}return!0}),new e.$7v(X,Y,D)}h(N,c,u,s,o,h,U){return(0,f.$p3)(N,c,u,s,o,h).map(M=>{const j=this.j(c,u,new b.$f3(M.original.toOffsetRange(),M.modified.toOffsetRange()),h,U),I=R(j.mappings,c,u,!0);return new e.$8v(M,I)})}j(N,c,u,s,o){const h=new E.$o3(N,u.seq1Range,o),U=new E.$o3(c,u.seq2Range,o),_=h.length+U.length<500?this.e.compute(h,U,s):this.f.compute(h,U,s);let T=_.diffs;return T=(0,$.$r3)(h,U,T),T=(0,$.$t3)(h,U,T),T=(0,$.$s3)(h,U,T),T=(0,$.$v3)(h,U,T),{mappings:T.map(j=>new m.$6v(h.translateRange(j.seq1Range),U.translateRange(j.seq2Range))),hitTimeout:_.hitTimeout}}}i.$w3=v;function R(L,N,c,u=!1){const s=[];for(const o of(0,t.$Ab)(L.map(h=>A(h,N,c)),(h,U)=>h.original.overlapOrTouch(U.original)||h.modified.overlapOrTouch(U.modified))){const h=o[0],U=o[o.length-1];s.push(new m.$5v(h.original.join(U.original),h.modified.join(U.modified),o.map(_=>_.innerChanges[0])))}return(0,n.$hd)(()=>!u&&s.length>0&&(s[0].modified.startLineNumber!==s[0].original.startLineNumber||c.length-s[s.length-1].modified.endLineNumberExclusive!==N.length-s[s.length-1].original.endLineNumberExclusive)?!1:(0,n.$id)(s,(o,h)=>h.original.startLineNumber-o.original.endLineNumberExclusive===h.modified.startLineNumber-o.modified.endLineNumberExclusive&&o.original.endLineNumberExclusive<h.original.startLineNumber&&o.modified.endLineNumberExclusive<h.modified.startLineNumber)),s}function A(L,N,c){let u=0,s=0;L.modifiedRange.endColumn===1&&L.originalRange.endColumn===1&&L.originalRange.startLineNumber+u<=L.originalRange.endLineNumber&&L.modifiedRange.startLineNumber+u<=L.modifiedRange.endLineNumber&&(s=-1),L.modifiedRange.startColumn-1>=c[L.modifiedRange.startLineNumber-1].length&&L.originalRange.startColumn-1>=N[L.originalRange.startLineNumber-1].length&&L.originalRange.startLineNumber<=L.originalRange.endLineNumber+s&&L.modifiedRange.startLineNumber<=L.modifiedRange.endLineNumber+s&&(u=1);const o=new p.$Ev(L.originalRange.startLineNumber+u,L.originalRange.endLineNumber+1+s),h=new p.$Ev(L.modifiedRange.startLineNumber+u,L.modifiedRange.endLineNumber+1+s);return new m.$5v(o,h,[L])}}),ne(ie[36],re([0,1,3,29,35,21,8,2,11,15]),function(q,i,t,n,p,g,w,b,a,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$0v=i.$9v=void 0;const f=3;class ${computeDiff(s,o,h){const _=new A(s,o,{maxComputationTime:h.maxComputationTimeMs,shouldIgnoreTrimWhitespace:h.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),T=[];let M=null;for(const j of _.changes){let I;j.originalEndLineNumber===0?I=new l.$Ev(j.originalStartLineNumber+1,j.originalStartLineNumber+1):I=new l.$Ev(j.originalStartLineNumber,j.originalEndLineNumber+1);let S;j.modifiedEndLineNumber===0?S=new l.$Ev(j.modifiedStartLineNumber+1,j.modifiedStartLineNumber+1):S=new l.$Ev(j.modifiedStartLineNumber,j.modifiedEndLineNumber+1);let D=new g.$5v(I,S,j.charChanges?.map(B=>new g.$6v(new b.$dt(B.originalStartLineNumber,B.originalStartColumn,B.originalEndLineNumber,B.originalEndColumn),new b.$dt(B.modifiedStartLineNumber,B.modifiedStartColumn,B.modifiedEndLineNumber,B.modifiedEndColumn))));M&&(M.modified.endLineNumberExclusive===D.modified.startLineNumber||M.original.endLineNumberExclusive===D.original.startLineNumber)&&(D=new g.$5v(M.original.join(D.original),M.modified.join(D.modified),M.innerChanges&&D.innerChanges?M.innerChanges.concat(D.innerChanges):void 0),T.pop()),T.push(D),M=D}return(0,a.$hd)(()=>(0,a.$id)(T,(j,I)=>I.original.startLineNumber-j.original.endLineNumberExclusive===I.modified.startLineNumber-j.modified.endLineNumberExclusive&&j.original.endLineNumberExclusive<I.original.startLineNumber&&j.modified.endLineNumberExclusive<I.modified.startLineNumber)),new p.$7v(T,[],_.quitEarly)}}i.$9v=$;function d(u,s,o,h){return new n.$Wv(u,s,o).ComputeDiff(h)}class E{constructor(s){const o=[],h=[];for(let U=0,_=s.length;U<_;U++)o[U]=L(s[U],1),h[U]=N(s[U],1);this.lines=s,this.a=o,this.b=h}getElements(){const s=[];for(let o=0,h=this.lines.length;o<h;o++)s[o]=this.lines[o].substring(this.a[o]-1,this.b[o]-1);return s}getStrictElement(s){return this.lines[s]}getStartLineNumber(s){return s+1}getEndLineNumber(s){return s+1}createCharSequence(s,o,h){const U=[],_=[],T=[];let M=0;for(let j=o;j<=h;j++){const I=this.lines[j],S=s?this.a[j]:1,D=s?this.b[j]:I.length+1;for(let B=S;B<D;B++)U[M]=I.charCodeAt(B-1),_[M]=j+1,T[M]=B,M++;!s&&j<h&&(U[M]=t.CharCode.LineFeed,_[M]=j+1,T[M]=I.length+1,M++)}return new e(U,_,T)}}class e{constructor(s,o,h){this.a=s,this.b=o,this.d=h}toString(){return"["+this.a.map((s,o)=>(s===t.CharCode.LineFeed?"\\n":String.fromCharCode(s))+`-(${this.b[o]},${this.d[o]})`).join(", ")+"]"}e(s,o){if(s<0||s>=o.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(s){return s>0&&s===this.b.length?this.getEndLineNumber(s-1):(this.e(s,this.b),this.b[s])}getEndLineNumber(s){return s===-1?this.getStartLineNumber(s+1):(this.e(s,this.b),this.a[s]===t.CharCode.LineFeed?this.b[s]+1:this.b[s])}getStartColumn(s){return s>0&&s===this.d.length?this.getEndColumn(s-1):(this.e(s,this.d),this.d[s])}getEndColumn(s){return s===-1?this.getStartColumn(s+1):(this.e(s,this.d),this.a[s]===t.CharCode.LineFeed?1:this.d[s]+1)}}class m{constructor(s,o,h,U,_,T,M,j){this.originalStartLineNumber=s,this.originalStartColumn=o,this.originalEndLineNumber=h,this.originalEndColumn=U,this.modifiedStartLineNumber=_,this.modifiedStartColumn=T,this.modifiedEndLineNumber=M,this.modifiedEndColumn=j}static createFromDiffChange(s,o,h){const U=o.getStartLineNumber(s.originalStart),_=o.getStartColumn(s.originalStart),T=o.getEndLineNumber(s.originalStart+s.originalLength-1),M=o.getEndColumn(s.originalStart+s.originalLength-1),j=h.getStartLineNumber(s.modifiedStart),I=h.getStartColumn(s.modifiedStart),S=h.getEndLineNumber(s.modifiedStart+s.modifiedLength-1),D=h.getEndColumn(s.modifiedStart+s.modifiedLength-1);return new m(U,_,T,M,j,I,S,D)}}function v(u){if(u.length<=1)return u;const s=[u[0]];let o=s[0];for(let h=1,U=u.length;h<U;h++){const _=u[h],T=_.originalStart-(o.originalStart+o.originalLength),M=_.modifiedStart-(o.modifiedStart+o.modifiedLength);Math.min(T,M)<f?(o.originalLength=_.originalStart+_.originalLength-o.originalStart,o.modifiedLength=_.modifiedStart+_.modifiedLength-o.modifiedStart):(s.push(_),o=_)}return s}class R{constructor(s,o,h,U,_){this.originalStartLineNumber=s,this.originalEndLineNumber=o,this.modifiedStartLineNumber=h,this.modifiedEndLineNumber=U,this.charChanges=_}static createFromDiffResult(s,o,h,U,_,T,M){let j,I,S,D,B;if(o.originalLength===0?(j=h.getStartLineNumber(o.originalStart)-1,I=0):(j=h.getStartLineNumber(o.originalStart),I=h.getEndLineNumber(o.originalStart+o.originalLength-1)),o.modifiedLength===0?(S=U.getStartLineNumber(o.modifiedStart)-1,D=0):(S=U.getStartLineNumber(o.modifiedStart),D=U.getEndLineNumber(o.modifiedStart+o.modifiedLength-1)),T&&o.originalLength>0&&o.originalLength<20&&o.modifiedLength>0&&o.modifiedLength<20&&_()){const Z=h.createCharSequence(s,o.originalStart,o.originalStart+o.originalLength-1),O=U.createCharSequence(s,o.modifiedStart,o.modifiedStart+o.modifiedLength-1);if(Z.getElements().length>0&&O.getElements().length>0){let P=d(Z,O,_,!0).changes;M&&(P=v(P)),B=[];for(let X=0,Y=P.length;X<Y;X++)B.push(m.createFromDiffChange(P[X],Z,O))}}return new R(j,I,S,D,B)}}class A{constructor(s,o,h){this.a=h.shouldComputeCharChanges,this.b=h.shouldPostProcessCharChanges,this.d=h.shouldIgnoreTrimWhitespace,this.e=h.shouldMakePrettyDiff,this.f=s,this.g=o,this.h=new E(s),this.j=new E(o),this.k=c(h.maxComputationTime),this.l=c(h.maxComputationTime===0?0:Math.min(h.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const s=d(this.h,this.j,this.k,this.e),o=s.changes,h=s.quitEarly;if(this.d){const M=[];for(let j=0,I=o.length;j<I;j++)M.push(R.createFromDiffResult(this.d,o[j],this.h,this.j,this.l,this.a,this.b));return{quitEarly:h,changes:M}}const U=[];let _=0,T=0;for(let M=-1,j=o.length;M<j;M++){const I=M+1<j?o[M+1]:null,S=I?I.originalStart:this.f.length,D=I?I.modifiedStart:this.g.length;for(;_<S&&T<D;){const B=this.f[_],Z=this.g[T];if(B!==Z){{let O=L(B,1),P=L(Z,1);for(;O>1&&P>1;){const X=B.charCodeAt(O-2),Y=Z.charCodeAt(P-2);if(X!==Y)break;O--,P--}(O>1||P>1)&&this.m(U,_+1,1,O,T+1,1,P)}{let O=N(B,1),P=N(Z,1);const X=B.length+1,Y=Z.length+1;for(;O<X&&P<Y;){const H=B.charCodeAt(O-1),K=B.charCodeAt(P-1);if(H!==K)break;O++,P++}(O<X||P<Y)&&this.m(U,_+1,O,X,T+1,P,Y)}}_++,T++}I&&(U.push(R.createFromDiffResult(this.d,I,this.h,this.j,this.l,this.a,this.b)),_+=I.originalLength,T+=I.modifiedLength)}return{quitEarly:h,changes:U}}m(s,o,h,U,_,T,M){if(this.n(s,o,h,U,_,T,M))return;let j;this.a&&(j=[new m(o,h,o,U,_,T,_,M)]),s.push(new R(o,o,_,_,j))}n(s,o,h,U,_,T,M){const j=s.length;if(j===0)return!1;const I=s[j-1];return I.originalEndLineNumber===0||I.modifiedEndLineNumber===0?!1:I.originalEndLineNumber===o&&I.modifiedEndLineNumber===_?(this.a&&I.charChanges&&I.charChanges.push(new m(o,h,o,U,_,T,_,M)),!0):I.originalEndLineNumber+1===o&&I.modifiedEndLineNumber+1===_?(I.originalEndLineNumber=o,I.modifiedEndLineNumber=_,this.a&&I.charChanges&&I.charChanges.push(new m(o,h,o,U,_,T,_,M)),!0):!1}}i.$0v=A;function L(u,s){const o=w.$qf(u);return o===-1?s:o+1}function N(u,s){const o=w.$sf(u);return o===-1?s:o+2}function c(u){if(u===0)return()=>!0;const s=Date.now();return()=>Date.now()-s<u}}),ne(ie[59],re([0,1,36,58]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$z3=void 0,i.$z3={getLegacy:()=>new t.$9v,getDefault:()=>new n.$w3}}),ne(ie[60],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$gt=i.MetadataConsts=i.StandardTokenType=i.ColorId=i.FontStyle=i.LanguageId=void 0;var t;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(t||(i.LanguageId=t={}));var n;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline",a[a.Strikethrough=8]="Strikethrough"})(n||(i.FontStyle=n={}));var p;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(p||(i.ColorId=p={}));var g;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=3]="RegEx"})(g||(i.StandardTokenType=g={}));var w;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",a[a.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",a[a.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",a[a.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(w||(i.MetadataConsts=w={}));class b{static getLanguageId(l){return(l&w.LANGUAGEID_MASK)>>>w.LANGUAGEID_OFFSET}static getTokenType(l){return(l&w.TOKEN_TYPE_MASK)>>>w.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&w.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&w.FONT_STYLE_MASK)>>>w.FONT_STYLE_OFFSET}static getForeground(l){return(l&w.FOREGROUND_MASK)>>>w.FOREGROUND_OFFSET}static getBackground(l){return(l&w.BACKGROUND_MASK)>>>w.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let $="mtk"+this.getForeground(l);const d=this.getFontStyle(l);return d&n.Italic&&($+=" mtki"),d&n.Bold&&($+=" mtkb"),d&n.Underline&&($+=" mtku"),d&n.Strikethrough&&($+=" mtks"),$}static getInlineStyleFromMetadata(l,f){const $=this.getForeground(l),d=this.getFontStyle(l);let E=`color: ${f[$]};`;d&n.Italic&&(E+="font-style: italic;"),d&n.Bold&&(E+="font-weight: bold;");let e="";return d&n.Underline&&(e+=" underline"),d&n.Strikethrough&&(e+=" line-through"),e&&(E+=`text-decoration:${e};`),E}static getPresentationFromMetadata(l){const f=this.getForeground(l),$=this.getFontStyle(l);return{foreground:f,italic:!!($&n.Italic),bold:!!($&n.Bold),underline:!!($&n.Underline),strikethrough:!!($&n.Strikethrough)}}}i.$gt=b}),ne(ie[61],re([0,1,38]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$A3=$;function n(d){const E=[];for(const e of d){const m=Number(e);(m||m===0&&e.replace(/\s/g,"")!=="")&&E.push(m)}return E}function p(d,E,e,m){return{red:d/255,blue:e/255,green:E/255,alpha:m}}function g(d,E){const e=E.index,m=E[0].length;if(!e)return;const v=d.positionAt(e);return{startLineNumber:v.lineNumber,startColumn:v.column,endLineNumber:v.lineNumber,endColumn:v.column+m}}function w(d,E){if(!d)return;const e=t.$8s.Format.CSS.parseHex(E);if(e)return{range:d,color:p(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function b(d,E,e){if(!d||E.length!==1)return;const v=E[0].values(),R=n(v);return{range:d,color:p(R[0],R[1],R[2],e?R[3]:1)}}function a(d,E,e){if(!d||E.length!==1)return;const v=E[0].values(),R=n(v),A=new t.$8s(new t.$6s(R[0],R[1]/100,R[2]/100,e?R[3]:1));return{range:d,color:p(A.rgba.r,A.rgba.g,A.rgba.b,A.rgba.a)}}function l(d,E){return typeof d=="string"?[...d.matchAll(E)]:d.findMatches(E)}function f(d){const E=[],m=l(d,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(m.length>0)for(const v of m){const R=v.filter(c=>c!==void 0),A=R[1],L=R[2];if(!L)continue;let N;if(A==="rgb"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;N=b(g(d,v),l(L,c),!1)}else if(A==="rgba"){const c=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;N=b(g(d,v),l(L,c),!0)}else if(A==="hsl"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;N=a(g(d,v),l(L,c),!1)}else if(A==="hsla"){const c=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;N=a(g(d,v),l(L,c),!0)}else A==="#"&&(N=w(g(d,v),A+L));N&&E.push(N)}return E}function $(d){return!d||typeof d.getValue!="function"||typeof d.positionAt!="function"?[]:f(d)}}),ne(ie[62],re([0,1,3,30]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$_2=i.$$2=i.State=void 0,i.$a3=E;var p;(function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"})(p||(i.State=p={}));class g{constructor(m,v,R){const A=new Uint8Array(m*v);for(let L=0,N=m*v;L<N;L++)A[L]=R;this.a=A,this.rows=m,this.cols=v}get(m,v){return this.a[m*this.cols+v]}set(m,v,R){this.a[m*this.cols+v]=R}}class w{constructor(m){let v=0,R=p.Invalid;for(let L=0,N=m.length;L<N;L++){const[c,u,s]=m[L];u>v&&(v=u),c>R&&(R=c),s>R&&(R=s)}v++,R++;const A=new g(R,v,p.Invalid);for(let L=0,N=m.length;L<N;L++){const[c,u,s]=m[L];A.set(c,u,s)}this.a=A,this.b=v}nextState(m,v){return v<0||v>=this.b?p.Invalid:this.a.get(m,v)}}i.$$2=w;let b=null;function a(){return b===null&&(b=new w([[p.Start,t.CharCode.h,p.H],[p.Start,t.CharCode.H,p.H],[p.Start,t.CharCode.f,p.F],[p.Start,t.CharCode.F,p.F],[p.H,t.CharCode.t,p.HT],[p.H,t.CharCode.T,p.HT],[p.HT,t.CharCode.t,p.HTT],[p.HT,t.CharCode.T,p.HTT],[p.HTT,t.CharCode.p,p.HTTP],[p.HTT,t.CharCode.P,p.HTTP],[p.HTTP,t.CharCode.s,p.BeforeColon],[p.HTTP,t.CharCode.S,p.BeforeColon],[p.HTTP,t.CharCode.Colon,p.AfterColon],[p.F,t.CharCode.i,p.FI],[p.F,t.CharCode.I,p.FI],[p.FI,t.CharCode.l,p.FIL],[p.FI,t.CharCode.L,p.FIL],[p.FIL,t.CharCode.e,p.BeforeColon],[p.FIL,t.CharCode.E,p.BeforeColon],[p.BeforeColon,t.CharCode.Colon,p.AfterColon],[p.AfterColon,t.CharCode.Slash,p.AlmostThere],[p.AlmostThere,t.CharCode.Slash,p.End]])),b}var l;(function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let f=null;function $(){if(f===null){f=new n.$ot(l.None);const e=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<e.length;v++)f.set(e.charCodeAt(v),l.ForceTermination);const m=".,;:";for(let v=0;v<m.length;v++)f.set(m.charCodeAt(v),l.CannotEndIn)}return f}class d{static a(m,v,R,A,L){let N=L-1;do{const c=v.charCodeAt(N);if(m.get(c)!==l.CannotEndIn)break;N--}while(N>A);if(A>0){const c=v.charCodeAt(A-1),u=v.charCodeAt(N);(c===t.CharCode.OpenParen&&u===t.CharCode.CloseParen||c===t.CharCode.OpenSquareBracket&&u===t.CharCode.CloseSquareBracket||c===t.CharCode.OpenCurlyBrace&&u===t.CharCode.CloseCurlyBrace)&&N--}return{range:{startLineNumber:R,startColumn:A+1,endLineNumber:R,endColumn:N+2},url:v.substring(A,N+1)}}static computeLinks(m,v=a()){const R=$(),A=[];for(let L=1,N=m.getLineCount();L<=N;L++){const c=m.getLineContent(L),u=c.length;let s=0,o=0,h=0,U=p.Start,_=!1,T=!1,M=!1,j=!1;for(;s<u;){let I=!1;const S=c.charCodeAt(s);if(U===p.Accept){let D;switch(S){case t.CharCode.OpenParen:_=!0,D=l.None;break;case t.CharCode.CloseParen:D=_?l.None:l.ForceTermination;break;case t.CharCode.OpenSquareBracket:M=!0,T=!0,D=l.None;break;case t.CharCode.CloseSquareBracket:M=!1,D=T?l.None:l.ForceTermination;break;case t.CharCode.OpenCurlyBrace:j=!0,D=l.None;break;case t.CharCode.CloseCurlyBrace:D=j?l.None:l.ForceTermination;break;case t.CharCode.SingleQuote:case t.CharCode.DoubleQuote:case t.CharCode.BackTick:h===S?D=l.ForceTermination:h===t.CharCode.SingleQuote||h===t.CharCode.DoubleQuote||h===t.CharCode.BackTick?D=l.None:D=l.ForceTermination;break;case t.CharCode.Asterisk:D=h===t.CharCode.Asterisk?l.ForceTermination:l.None;break;case t.CharCode.Pipe:D=h===t.CharCode.Pipe?l.ForceTermination:l.None;break;case t.CharCode.Space:D=M?l.None:l.ForceTermination;break;default:D=R.get(S)}D===l.ForceTermination&&(A.push(d.a(R,c,L,o,s)),I=!0)}else if(U===p.End){let D;S===t.CharCode.OpenSquareBracket?(T=!0,D=l.None):D=R.get(S),D===l.ForceTermination?I=!0:U=p.Accept}else U=v.nextState(U,S),U===p.Invalid&&(I=!0);I&&(U=p.Start,_=!1,T=!1,j=!1,o=s+1,h=S),s++}U===p.Accept&&A.push(d.a(R,c,L,o,u))}return A}}i.$_2=d;function E(e){return!e||typeof e.getLineCount!="function"||typeof e.getLineContent!="function"?[]:d.computeLinks(e)}}),ne(ie[63],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$b3=void 0;class t{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}navigateValueSet(p,g,w,b,a){if(p&&g){const l=this.a(g,a);if(l)return{range:p,value:l}}if(w&&b){const l=this.a(b,a);if(l)return{range:w,value:l}}return null}a(p,g){const w=this.b(p,g);return w!==null?w:this.d(p,g)}b(p,g){const w=Math.pow(10,p.length-(p.lastIndexOf(".")+1));let b=Number(p);const a=parseFloat(p);return!isNaN(b)&&!isNaN(a)&&b===a?b===0&&!g?null:(b=Math.floor(b*w),b+=g?w:-w,String(b/w)):null}d(p,g){return this.e(this.c,p,g)}e(p,g,w){let b=null;for(let a=0,l=p.length;b===null&&a<l;a++)b=this.f(p[a],g,w);return b}f(p,g,w){let b=p.indexOf(g);return b>=0?(b+=w?1:-1,b<0?b=p.length-1:b%=p.length,p[b]):null}}i.$b3=t,t.INSTANCE=new t}),ne(ie[64],re([0,1,18]),function(q,i,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$wv=i.$vv=i.$uv=i.ModelConstants=i.PositionAffinity=i.TrackedRangeStickiness=i.$sv=i.$rv=i.EndOfLineSequence=i.DefaultEndOfLine=i.EndOfLinePreference=i.InjectedTextCursorStops=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.GlyphMarginLane=i.OverviewRulerLane=void 0,i.$tv=e,i.$xv=N;var n;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(n||(i.OverviewRulerLane=n={}));var p;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=3]="Right"})(p||(i.GlyphMarginLane=p={}));var g;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(g||(i.MinimapPosition=g={}));var w;(function(c){c[c.Normal=1]="Normal",c[c.Underlined=2]="Underlined"})(w||(i.MinimapSectionHeaderStyle=w={}));var b;(function(c){c[c.Both=0]="Both",c[c.Right=1]="Right",c[c.Left=2]="Left",c[c.None=3]="None"})(b||(i.InjectedTextCursorStops=b={}));var a;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(a||(i.EndOfLinePreference=a={}));var l;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(l||(i.DefaultEndOfLine=l={}));var f;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(f||(i.EndOfLineSequence=f={}));class ${get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(u){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,u.tabSize|0),u.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,u.indentSize|0),this.a=!1),this.insertSpaces=!!u.insertSpaces,this.defaultEOL=u.defaultEOL|0,this.trimAutoWhitespace=!!u.trimAutoWhitespace,this.bracketPairColorizationOptions=u.bracketPairColorizationOptions}equals(u){return this.tabSize===u.tabSize&&this.a===u.a&&this.indentSize===u.indentSize&&this.insertSpaces===u.insertSpaces&&this.defaultEOL===u.defaultEOL&&this.trimAutoWhitespace===u.trimAutoWhitespace&&(0,t.$bo)(this.bracketPairColorizationOptions,u.bracketPairColorizationOptions)}createChangeEvent(u){return{tabSize:this.tabSize!==u.tabSize,indentSize:this.indentSize!==u.indentSize,insertSpaces:this.insertSpaces!==u.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==u.trimAutoWhitespace}}}i.$rv=$;class d{constructor(u,s){this._findMatchBrand=void 0,this.range=u,this.matches=s}}i.$sv=d;var E;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(E||(i.TrackedRangeStickiness=E={}));function e(c){return c&&typeof c.read=="function"}var m;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right",c[c.None=2]="None",c[c.LeftOfInjectedText=3]="LeftOfInjectedText",c[c.RightOfInjectedText=4]="RightOfInjectedText"})(m||(i.PositionAffinity=m={}));var v;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(i.ModelConstants=v={}));class R{constructor(u,s,o,h,U,_){this.identifier=u,this.range=s,this.text=o,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=U,this._isTracked=_}}i.$uv=R;class A{constructor(u,s,o){this.regex=u,this.wordSeparators=s,this.simpleSearch=o}}i.$vv=A;class L{constructor(u,s,o){this.reverseEdits=u,this.changes=s,this.trimAutoWhitespaceLineNumbers=o}}i.$wv=L;function N(c){return!c.isTooLargeForSyncing()&&!c.isForSimpleWidget}}),ne(ie[65],re([0,1,7,14]),function(q,i,t,n){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$cw=i.$bw=i.$aw=void 0;class p{constructor(a){this.a=a,this.b=new Uint32Array(a.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(a,l){a=(0,n.$0e)(a);const f=this.a,$=this.b,d=l.length;return d===0?!1:(this.a=new Uint32Array(f.length+d),this.a.set(f.subarray(0,a),0),this.a.set(f.subarray(a),a+d),this.a.set(l,a),a-1<this.c[0]&&(this.c[0]=a-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}setValue(a,l){return a=(0,n.$0e)(a),l=(0,n.$0e)(l),this.a[a]===l?!1:(this.a[a]=l,a-1<this.c[0]&&(this.c[0]=a-1),!0)}removeValues(a,l){a=(0,n.$0e)(a),l=(0,n.$0e)(l);const f=this.a,$=this.b;if(a>=f.length)return!1;const d=f.length-a;return l>=d&&(l=d),l===0?!1:(this.a=new Uint32Array(f.length-l),this.a.set(f.subarray(0,a),0),this.a.set(f.subarray(a+l),a),this.b=new Uint32Array(this.a.length),a-1<this.c[0]&&(this.c[0]=a-1),this.c[0]>=0&&this.b.set($.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(a){return a<0?0:(a=(0,n.$0e)(a),this.d(a))}d(a){if(a<=this.c[0])return this.b[a];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),a>=this.a.length&&(a=this.a.length-1);for(let f=l;f<=a;f++)this.b[f]=this.b[f-1]+this.a[f];return this.c[0]=Math.max(this.c[0],a),this.b[a]}getIndexOf(a){a=Math.floor(a),this.getTotalSum();let l=0,f=this.a.length-1,$=0,d=0,E=0;for(;l<=f;)if($=l+(f-l)/2|0,d=this.b[$],E=d-this.a[$],a<E)f=$-1;else if(a>=d)l=$+1;else break;return new w($,a-E)}}i.$aw=p;class g{constructor(a){this.a=a,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(a){return this.g(),a===0?0:this.d[a-1]}getIndexOf(a){this.g();const l=this.e[a],f=l>0?this.d[l-1]:0;return new w(l,a-f)}removeValues(a,l){this.a.splice(a,l),this.f(a)}insertValues(a,l){this.a=(0,t.$Vb)(this.a,a,l),this.f(a)}f(a){this.b=!1,this.c=Math.min(this.c,a-1)}g(){if(!this.b){for(let a=this.c+1,l=this.a.length;a<l;a++){const f=this.a[a],$=a>0?this.d[a-1]:0;this.d[a]=$+f;for(let d=0;d<f;d++)this.e[$+d]=a}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(a,l){this.a[a]!==l&&(this.a[a]=l,this.f(a))}}i.$bw=g;class w{constructor(a,l){this.index=a,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=a,this.remainder=l}}i.$cw=w}),ne(ie[66],re([0,1,8,5,65]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$dw=void 0;class g{constructor(b,a,l,f){this.d=b,this.f=a,this.g=l,this.h=f,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const a=b.changes;for(const l of a)this.o(l.range),this.p(new n.$ct(l.range.startLineNumber,l.range.startColumn),l.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,a=this.f.length,l=new Uint32Array(a);for(let f=0;f<a;f++)l[f]=this.f[f].length+b;this.j=new p.$aw(l)}}n(b,a){this.f[b]=a,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,a){if(a.length===0)return;const l=(0,t.$of)(a);if(l.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+l[0]+this.f[b.lineNumber-1].substring(b.column-1));return}l[l.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+l[0]);const f=new Uint32Array(l.length-1);for(let $=1;$<l.length;$++)this.f.splice(b.lineNumber+$-1,0,l[$]),f[$-1]=l[$].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,f)}}i.$dw=g}),ne(ie[67],re([0,1,3,8,53,5,2,64]),function(q,i,t,n,p,g,w,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$7C=i.$5C=i.$2C=void 0,i.$3C=f,i.$4C=$,i.$6C=v;const a=999;class l{constructor(L,N,c,u){this.searchString=L,this.isRegex=N,this.matchCase=c,this.wordSeparators=u}parseSearchRequest(){if(this.searchString==="")return null;let L;this.isRegex?L=f(this.searchString):L=this.searchString.indexOf(`
`)>=0;let N=null;try{N=n.$mf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:L,global:!0,unicode:!0})}catch{return null}if(!N)return null;let c=!this.isRegex&&!L;return c&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(c=this.matchCase),new b.$vv(N,this.wordSeparators?(0,p.$rt)(this.wordSeparators,[]):null,c?this.searchString:null)}}i.$2C=l;function f(A){if(!A||A.length===0)return!1;for(let L=0,N=A.length;L<N;L++){const c=A.charCodeAt(L);if(c===t.CharCode.LineFeed)return!0;if(c===t.CharCode.Backslash){if(L++,L>=N)break;const u=A.charCodeAt(L);if(u===t.CharCode.n||u===t.CharCode.r||u===t.CharCode.W)return!0}}return!1}function $(A,L,N){if(!N)return new b.$sv(A,null);const c=[];for(let u=0,s=L.length;u<s;u++)c[u]=L[u];return new b.$sv(A,c)}class d{constructor(L){const N=[];let c=0;for(let u=0,s=L.length;u<s;u++)L.charCodeAt(u)===t.CharCode.LineFeed&&(N[c++]=u);this.a=N}findLineFeedCountBeforeOffset(L){const N=this.a;let c=0,u=N.length-1;if(u===-1||L<=N[0])return 0;for(;c<u;){const s=c+((u-c)/2>>0);N[s]>=L?u=s-1:N[s+1]>=L?(c=s,u=s):c=s+1}return c+1}}class E{static findMatches(L,N,c,u,s){const o=N.parseSearchRequest();return o?o.regex.multiline?this.b(L,c,new R(o.wordSeparators,o.regex),u,s):this.c(L,c,o,u,s):[]}static a(L,N,c,u,s,o){let h,U=0;u?(U=u.findLineFeedCountBeforeOffset(s),h=N+s+U):h=N+s;let _;if(u){const I=u.findLineFeedCountBeforeOffset(s+o.length)-U;_=h+o.length+I}else _=h+o.length;const T=L.getPositionAt(h),M=L.getPositionAt(_);return new w.$dt(T.lineNumber,T.column,M.lineNumber,M.column)}static b(L,N,c,u,s){const o=L.getOffsetAt(N.getStartPosition()),h=L.getValueInRange(N,b.EndOfLinePreference.LF),U=L.getEOL()===`\r
`?new d(h):null,_=[];let T=0,M;for(c.reset(0);M=c.next(h);)if(_[T++]=$(this.a(L,o,h,U,M.index,M[0]),M,u),T>=s)return _;return _}static c(L,N,c,u,s){const o=[];let h=0;if(N.startLineNumber===N.endLineNumber){const _=L.getLineContent(N.startLineNumber).substring(N.startColumn-1,N.endColumn-1);return h=this.d(c,_,N.startLineNumber,N.startColumn-1,h,o,u,s),o}const U=L.getLineContent(N.startLineNumber).substring(N.startColumn-1);h=this.d(c,U,N.startLineNumber,N.startColumn-1,h,o,u,s);for(let _=N.startLineNumber+1;_<N.endLineNumber&&h<s;_++)h=this.d(c,L.getLineContent(_),_,0,h,o,u,s);if(h<s){const _=L.getLineContent(N.endLineNumber).substring(0,N.endColumn-1);h=this.d(c,_,N.endLineNumber,0,h,o,u,s)}return o}static d(L,N,c,u,s,o,h,U){const _=L.wordSeparators;if(!h&&L.simpleSearch){const j=L.simpleSearch,I=j.length,S=N.length;let D=-I;for(;(D=N.indexOf(j,D+I))!==-1;)if((!_||v(_,N,S,D,I))&&(o[s++]=new b.$sv(new w.$dt(c,D+1+u,c,D+1+I+u),null),s>=U))return s;return s}const T=new R(L.wordSeparators,L.regex);let M;T.reset(0);do if(M=T.next(N),M&&(o[s++]=$(new w.$dt(c,M.index+1+u,c,M.index+1+M[0].length+u),M,h),s>=U))return s;while(M);return s}static findNextMatch(L,N,c,u){const s=N.parseSearchRequest();if(!s)return null;const o=new R(s.wordSeparators,s.regex);return s.regex.multiline?this.e(L,c,o,u):this.f(L,c,o,u)}static e(L,N,c,u){const s=new g.$ct(N.lineNumber,1),o=L.getOffsetAt(s),h=L.getLineCount(),U=L.getValueInRange(new w.$dt(s.lineNumber,s.column,h,L.getLineMaxColumn(h)),b.EndOfLinePreference.LF),_=L.getEOL()===`\r
`?new d(U):null;c.reset(N.column-1);const T=c.next(U);return T?$(this.a(L,o,U,_,T.index,T[0]),T,u):N.lineNumber!==1||N.column!==1?this.e(L,new g.$ct(1,1),c,u):null}static f(L,N,c,u){const s=L.getLineCount(),o=N.lineNumber,h=L.getLineContent(o),U=this.g(c,h,o,N.column,u);if(U)return U;for(let _=1;_<=s;_++){const T=(o+_-1)%s,M=L.getLineContent(T+1),j=this.g(c,M,T+1,1,u);if(j)return j}return null}static g(L,N,c,u,s){L.reset(u-1);const o=L.next(N);return o?$(new w.$dt(c,o.index+1,c,o.index+1+o[0].length),o,s):null}static findPreviousMatch(L,N,c,u){const s=N.parseSearchRequest();if(!s)return null;const o=new R(s.wordSeparators,s.regex);return s.regex.multiline?this.h(L,c,o,u):this.j(L,c,o,u)}static h(L,N,c,u){const s=this.b(L,new w.$dt(1,1,N.lineNumber,N.column),c,u,10*a);if(s.length>0)return s[s.length-1];const o=L.getLineCount();return N.lineNumber!==o||N.column!==L.getLineMaxColumn(o)?this.h(L,new g.$ct(o,L.getLineMaxColumn(o)),c,u):null}static j(L,N,c,u){const s=L.getLineCount(),o=N.lineNumber,h=L.getLineContent(o).substring(0,N.column-1),U=this.k(c,h,o,u);if(U)return U;for(let _=1;_<=s;_++){const T=(s+o-_-1)%s,M=L.getLineContent(T+1),j=this.k(c,M,T+1,u);if(j)return j}return null}static k(L,N,c,u){let s=null,o;for(L.reset(0);o=L.next(N);)s=$(new w.$dt(c,o.index+1,c,o.index+1+o[0].length),o,u);return s}}i.$5C=E;function e(A,L,N,c,u){if(c===0)return!0;const s=L.charCodeAt(c-1);if(A.get(s)!==p.WordCharacterClass.Regular||s===t.CharCode.CarriageReturn||s===t.CharCode.LineFeed)return!0;if(u>0){const o=L.charCodeAt(c);if(A.get(o)!==p.WordCharacterClass.Regular)return!0}return!1}function m(A,L,N,c,u){if(c+u===N)return!0;const s=L.charCodeAt(c+u);if(A.get(s)!==p.WordCharacterClass.Regular||s===t.CharCode.CarriageReturn||s===t.CharCode.LineFeed)return!0;if(u>0){const o=L.charCodeAt(c+u-1);if(A.get(o)!==p.WordCharacterClass.Regular)return!0}return!1}function v(A,L,N,c,u){return e(A,L,N,c,u)&&m(A,L,N,c,u)}class R{constructor(L,N){this._wordSeparators=L,this.a=N,this.b=-1,this.c=0}reset(L){this.a.lastIndex=L,this.b=-1,this.c=0}next(L){const N=L.length;let c;do{if(this.b+this.c===N||(c=this.a.exec(L),!c))return null;const u=c.index,s=c[0].length;if(u===this.b&&s===this.c){if(s===0){n.$If(L,N,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=u,this.c=s,!this._wordSeparators||v(this._wordSeparators,L,N,u,s))return c}while(c);return null}}i.$7C=R}),ne(ie[68],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$B3=p;const t=new RegExp("\\bMARK:\\s*(.*)$","d"),n=/^-+|-+$/g;function p(l,f){let $=[];if(f.findRegionSectionHeaders&&f.foldingRules?.markers){const d=g(l,f);$=$.concat(d)}if(f.findMarkSectionHeaders){const d=w(l);$=$.concat(d)}return $}function g(l,f){const $=[],d=l.getLineCount();for(let E=1;E<=d;E++){const e=l.getLineContent(E),m=e.match(f.foldingRules.markers.start);if(m){const v={startLineNumber:E,startColumn:m[0].length+1,endLineNumber:E,endColumn:e.length+1};if(v.endColumn>v.startColumn){const R={range:v,...a(e.substring(m[0].length)),shouldBeInComments:!1};(R.text||R.hasSeparatorLine)&&$.push(R)}}}return $}function w(l){const f=[],$=l.getLineCount();for(let d=1;d<=$;d++){const E=l.getLineContent(d);b(E,d,f)}return f}function b(l,f,$){t.lastIndex=0;const d=t.exec(l);if(d){const E=d.indices[1][0]+1,e=d.indices[1][1]+1,m={startLineNumber:f,startColumn:E,endLineNumber:f,endColumn:e};if(m.endColumn>m.startColumn){const v={range:m,...a(d[1]),shouldBeInComments:!0};(v.text||v.hasSeparatorLine)&&$.push(v)}}}function a(l){l=l.trim();const f=l.startsWith("-");return l=l.replace(n,""),{text:l,hasSeparatorLine:f}}}),ne(ie[69],re([0,1,2,67,8,11,32]),function(q,i,t,n,p,g,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UnicodeHighlighterReasonKind=i.$02=void 0;class b{static computeUnicodeHighlights(e,m,v){const R=v?v.startLineNumber:1,A=v?v.endLineNumber:e.getLineCount(),L=new f(m),N=L.getCandidateCodePoints();let c;N==="allNonBasicAscii"?c=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):c=new RegExp(`${a(Array.from(N))}`,"g");const u=new n.$7C(null,c),s=[];let o=!1,h,U=0,_=0,T=0;e:for(let M=R,j=A;M<=j;M++){const I=e.getLineContent(M),S=I.length;u.reset(0);do if(h=u.next(I),h){let D=h.index,B=h.index+h[0].length;if(D>0){const X=I.charCodeAt(D-1);p.$Ff(X)&&D--}if(B+1<S){const X=I.charCodeAt(B-1);p.$Ff(X)&&B++}const Z=I.substring(D,B);let O=(0,w.$wt)(D+1,w.$tt,I,0);O&&O.endColumn<=D+1&&(O=null);const P=L.shouldHighlightNonBasicASCII(Z,O?O.word:null);if(P!==d.None){if(P===d.Ambiguous?U++:P===d.Invisible?_++:P===d.NonBasicASCII?T++:(0,g.$ed)(P),s.length>=1e3){o=!0;break e}s.push(new t.$dt(M,D+1,M,B+1))}}while(h)}return{ranges:s,hasMore:o,ambiguousCharacterCount:U,invisibleCharacterCount:_,nonBasicAsciiCharacterCount:T}}static computeUnicodeHighlightReason(e,m){const v=new f(m);switch(v.shouldHighlightNonBasicASCII(e,null)){case d.None:return null;case d.Invisible:return{kind:l.Invisible};case d.Ambiguous:{const A=e.codePointAt(0),L=v.ambiguousCharacters.getPrimaryConfusable(A),N=p.$$f.getLocales().filter(c=>!p.$$f.getInstance(new Set([...m.allowedLocales,c])).isAmbiguous(A));return{kind:l.Ambiguous,confusableWith:String.fromCodePoint(L),notAmbiguousInLocales:N}}case d.NonBasicASCII:return{kind:l.NonBasicAscii}}}}i.$02=b;function a(E,e){return`[${p.$df(E.map(v=>String.fromCodePoint(v)).join(""))}]`}var l;(function(E){E[E.Ambiguous=0]="Ambiguous",E[E.Invisible=1]="Invisible",E[E.NonBasicAscii=2]="NonBasicAscii"})(l||(i.UnicodeHighlighterReasonKind=l={}));class f{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=p.$$f.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const m of p.$_f.codePoints)$(String.fromCodePoint(m))||e.add(m);if(this.b.ambiguousCharacters)for(const m of this.ambiguousCharacters.getConfusableCodePoints())e.add(m);for(const m of this.a)e.delete(m);return e}shouldHighlightNonBasicASCII(e,m){const v=e.codePointAt(0);if(this.a.has(v))return d.None;if(this.b.nonBasicASCII)return d.NonBasicASCII;let R=!1,A=!1;if(m)for(const L of m){const N=L.codePointAt(0),c=p.$Qf(L);R=R||c,!c&&!this.ambiguousCharacters.isAmbiguous(N)&&!p.$_f.isInvisibleCharacter(N)&&(A=!0)}return!R&&A?d.None:this.b.invisibleCharacters&&!$(e)&&p.$_f.isInvisibleCharacter(v)?d.Invisible:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(v)?d.Ambiguous:d.None}}function $(E){return E===" "||E===`
`||E==="	"}var d;(function(E){E[E.None=0]="None",E[E.NonBasicASCII=1]="NonBasicASCII",E[E.Invisible=2]="Invisible",E[E.Ambiguous=3]="Ambiguous"})(d||(d={}))}),ne(ie[70],re([0,1]),function(q,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.WrappingIndent=i.TrackedRangeStickiness=i.TextEditorCursorStyle=i.TextEditorCursorBlinkingStyle=i.SymbolTag=i.SymbolKind=i.SignatureHelpTriggerKind=i.ShowLightbulbIconMode=i.SelectionDirection=i.ScrollbarVisibility=i.ScrollType=i.RenderMinimap=i.RenderLineNumbersType=i.PositionAffinity=i.PartialAcceptTriggerKind=i.OverviewRulerLane=i.OverlayWidgetPositionPreference=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.MouseTargetType=i.MinimapSectionHeaderStyle=i.MinimapPosition=i.MarkerTag=i.MarkerSeverity=i.KeyCode=i.InlineEditTriggerKind=i.InlineCompletionTriggerKind=i.InlayHintKind=i.InjectedTextCursorStops=i.IndentAction=i.HoverVerbosityAction=i.GlyphMarginLane=i.EndOfLineSequence=i.EndOfLinePreference=i.EditorOption=i.EditorAutoIndentStrategy=i.DocumentHighlightKind=i.DefaultEndOfLine=i.CursorChangeReason=i.ContentWidgetPositionPreference=i.CompletionTriggerKind=i.CompletionItemTag=i.CompletionItemKind=i.CompletionItemInsertTextRule=i.CodeActionTriggerType=i.AccessibilitySupport=void 0;var t;(function(r){r[r.Unknown=0]="Unknown",r[r.Disabled=1]="Disabled",r[r.Enabled=2]="Enabled"})(t||(i.AccessibilitySupport=t={}));var n;(function(r){r[r.Invoke=1]="Invoke",r[r.Auto=2]="Auto"})(n||(i.CodeActionTriggerType=n={}));var p;(function(r){r[r.None=0]="None",r[r.KeepWhitespace=1]="KeepWhitespace",r[r.InsertAsSnippet=4]="InsertAsSnippet"})(p||(i.CompletionItemInsertTextRule=p={}));var g;(function(r){r[r.Method=0]="Method",r[r.Function=1]="Function",r[r.Constructor=2]="Constructor",r[r.Field=3]="Field",r[r.Variable=4]="Variable",r[r.Class=5]="Class",r[r.Struct=6]="Struct",r[r.Interface=7]="Interface",r[r.Module=8]="Module",r[r.Property=9]="Property",r[r.Event=10]="Event",r[r.Operator=11]="Operator",r[r.Unit=12]="Unit",r[r.Value=13]="Value",r[r.Constant=14]="Constant",r[r.Enum=15]="Enum",r[r.EnumMember=16]="EnumMember",r[r.Keyword=17]="Keyword",r[r.Text=18]="Text",r[r.Color=19]="Color",r[r.File=20]="File",r[r.Reference=21]="Reference",r[r.Customcolor=22]="Customcolor",r[r.Folder=23]="Folder",r[r.TypeParameter=24]="TypeParameter",r[r.User=25]="User",r[r.Issue=26]="Issue",r[r.Snippet=27]="Snippet"})(g||(i.CompletionItemKind=g={}));var w;(function(r){r[r.Deprecated=1]="Deprecated"})(w||(i.CompletionItemTag=w={}));var b;(function(r){r[r.Invoke=0]="Invoke",r[r.TriggerCharacter=1]="TriggerCharacter",r[r.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b||(i.CompletionTriggerKind=b={}));var a;(function(r){r[r.EXACT=0]="EXACT",r[r.ABOVE=1]="ABOVE",r[r.BELOW=2]="BELOW"})(a||(i.ContentWidgetPositionPreference=a={}));var l;(function(r){r[r.NotSet=0]="NotSet",r[r.ContentFlush=1]="ContentFlush",r[r.RecoverFromMarkers=2]="RecoverFromMarkers",r[r.Explicit=3]="Explicit",r[r.Paste=4]="Paste",r[r.Undo=5]="Undo",r[r.Redo=6]="Redo"})(l||(i.CursorChangeReason=l={}));var f;(function(r){r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(f||(i.DefaultEndOfLine=f={}));var $;(function(r){r[r.Text=0]="Text",r[r.Read=1]="Read",r[r.Write=2]="Write"})($||(i.DocumentHighlightKind=$={}));var d;(function(r){r[r.None=0]="None",r[r.Keep=1]="Keep",r[r.Brackets=2]="Brackets",r[r.Advanced=3]="Advanced",r[r.Full=4]="Full"})(d||(i.EditorAutoIndentStrategy=d={}));var E;(function(r){r[r.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",r[r.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",r[r.accessibilitySupport=2]="accessibilitySupport",r[r.accessibilityPageSize=3]="accessibilityPageSize",r[r.ariaLabel=4]="ariaLabel",r[r.ariaRequired=5]="ariaRequired",r[r.autoClosingBrackets=6]="autoClosingBrackets",r[r.autoClosingComments=7]="autoClosingComments",r[r.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",r[r.autoClosingDelete=9]="autoClosingDelete",r[r.autoClosingOvertype=10]="autoClosingOvertype",r[r.autoClosingQuotes=11]="autoClosingQuotes",r[r.autoIndent=12]="autoIndent",r[r.automaticLayout=13]="automaticLayout",r[r.autoSurround=14]="autoSurround",r[r.bracketPairColorization=15]="bracketPairColorization",r[r.guides=16]="guides",r[r.codeLens=17]="codeLens",r[r.codeLensFontFamily=18]="codeLensFontFamily",r[r.codeLensFontSize=19]="codeLensFontSize",r[r.colorDecorators=20]="colorDecorators",r[r.colorDecoratorsLimit=21]="colorDecoratorsLimit",r[r.columnSelection=22]="columnSelection",r[r.comments=23]="comments",r[r.contextmenu=24]="contextmenu",r[r.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",r[r.cursorBlinking=26]="cursorBlinking",r[r.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",r[r.cursorStyle=28]="cursorStyle",r[r.cursorSurroundingLines=29]="cursorSurroundingLines",r[r.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",r[r.cursorWidth=31]="cursorWidth",r[r.disableLayerHinting=32]="disableLayerHinting",r[r.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",r[r.domReadOnly=34]="domReadOnly",r[r.dragAndDrop=35]="dragAndDrop",r[r.dropIntoEditor=36]="dropIntoEditor",r[r.emptySelectionClipboard=37]="emptySelectionClipboard",r[r.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",r[r.extraEditorClassName=39]="extraEditorClassName",r[r.fastScrollSensitivity=40]="fastScrollSensitivity",r[r.find=41]="find",r[r.fixedOverflowWidgets=42]="fixedOverflowWidgets",r[r.folding=43]="folding",r[r.foldingStrategy=44]="foldingStrategy",r[r.foldingHighlight=45]="foldingHighlight",r[r.foldingImportsByDefault=46]="foldingImportsByDefault",r[r.foldingMaximumRegions=47]="foldingMaximumRegions",r[r.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",r[r.fontFamily=49]="fontFamily",r[r.fontInfo=50]="fontInfo",r[r.fontLigatures=51]="fontLigatures",r[r.fontSize=52]="fontSize",r[r.fontWeight=53]="fontWeight",r[r.fontVariations=54]="fontVariations",r[r.formatOnPaste=55]="formatOnPaste",r[r.formatOnType=56]="formatOnType",r[r.glyphMargin=57]="glyphMargin",r[r.gotoLocation=58]="gotoLocation",r[r.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",r[r.hover=60]="hover",r[r.inDiffEditor=61]="inDiffEditor",r[r.inlineSuggest=62]="inlineSuggest",r[r.inlineEdit=63]="inlineEdit",r[r.letterSpacing=64]="letterSpacing",r[r.lightbulb=65]="lightbulb",r[r.lineDecorationsWidth=66]="lineDecorationsWidth",r[r.lineHeight=67]="lineHeight",r[r.lineNumbers=68]="lineNumbers",r[r.lineNumbersMinChars=69]="lineNumbersMinChars",r[r.linkedEditing=70]="linkedEditing",r[r.links=71]="links",r[r.matchBrackets=72]="matchBrackets",r[r.minimap=73]="minimap",r[r.mouseStyle=74]="mouseStyle",r[r.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",r[r.mouseWheelZoom=76]="mouseWheelZoom",r[r.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",r[r.multiCursorModifier=78]="multiCursorModifier",r[r.multiCursorPaste=79]="multiCursorPaste",r[r.multiCursorLimit=80]="multiCursorLimit",r[r.occurrencesHighlight=81]="occurrencesHighlight",r[r.overviewRulerBorder=82]="overviewRulerBorder",r[r.overviewRulerLanes=83]="overviewRulerLanes",r[r.padding=84]="padding",r[r.pasteAs=85]="pasteAs",r[r.parameterHints=86]="parameterHints",r[r.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",r[r.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",r[r.quickSuggestions=89]="quickSuggestions",r[r.quickSuggestionsDelay=90]="quickSuggestionsDelay",r[r.readOnly=91]="readOnly",r[r.readOnlyMessage=92]="readOnlyMessage",r[r.renameOnType=93]="renameOnType",r[r.renderControlCharacters=94]="renderControlCharacters",r[r.renderFinalNewline=95]="renderFinalNewline",r[r.renderLineHighlight=96]="renderLineHighlight",r[r.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",r[r.renderValidationDecorations=98]="renderValidationDecorations",r[r.renderWhitespace=99]="renderWhitespace",r[r.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",r[r.roundedSelection=101]="roundedSelection",r[r.rulers=102]="rulers",r[r.scrollbar=103]="scrollbar",r[r.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",r[r.scrollBeyondLastLine=105]="scrollBeyondLastLine",r[r.scrollPredominantAxis=106]="scrollPredominantAxis",r[r.selectionClipboard=107]="selectionClipboard",r[r.selectionHighlight=108]="selectionHighlight",r[r.selectOnLineNumbers=109]="selectOnLineNumbers",r[r.showFoldingControls=110]="showFoldingControls",r[r.showUnused=111]="showUnused",r[r.snippetSuggestions=112]="snippetSuggestions",r[r.smartSelect=113]="smartSelect",r[r.smoothScrolling=114]="smoothScrolling",r[r.stickyScroll=115]="stickyScroll",r[r.stickyTabStops=116]="stickyTabStops",r[r.stopRenderingLineAfter=117]="stopRenderingLineAfter",r[r.suggest=118]="suggest",r[r.suggestFontSize=119]="suggestFontSize",r[r.suggestLineHeight=120]="suggestLineHeight",r[r.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",r[r.suggestSelection=122]="suggestSelection",r[r.tabCompletion=123]="tabCompletion",r[r.tabIndex=124]="tabIndex",r[r.unicodeHighlighting=125]="unicodeHighlighting",r[r.unusualLineTerminators=126]="unusualLineTerminators",r[r.useShadowDOM=127]="useShadowDOM",r[r.useTabStops=128]="useTabStops",r[r.wordBreak=129]="wordBreak",r[r.wordSegmenterLocales=130]="wordSegmenterLocales",r[r.wordSeparators=131]="wordSeparators",r[r.wordWrap=132]="wordWrap",r[r.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",r[r.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",r[r.wordWrapColumn=135]="wordWrapColumn",r[r.wordWrapOverride1=136]="wordWrapOverride1",r[r.wordWrapOverride2=137]="wordWrapOverride2",r[r.wrappingIndent=138]="wrappingIndent",r[r.wrappingStrategy=139]="wrappingStrategy",r[r.showDeprecated=140]="showDeprecated",r[r.inlayHints=141]="inlayHints",r[r.editorClassName=142]="editorClassName",r[r.pixelRatio=143]="pixelRatio",r[r.tabFocusMode=144]="tabFocusMode",r[r.layoutInfo=145]="layoutInfo",r[r.wrappingInfo=146]="wrappingInfo",r[r.defaultColorDecorators=147]="defaultColorDecorators",r[r.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",r[r.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(E||(i.EditorOption=E={}));var e;(function(r){r[r.TextDefined=0]="TextDefined",r[r.LF=1]="LF",r[r.CRLF=2]="CRLF"})(e||(i.EndOfLinePreference=e={}));var m;(function(r){r[r.LF=0]="LF",r[r.CRLF=1]="CRLF"})(m||(i.EndOfLineSequence=m={}));var v;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=3]="Right"})(v||(i.GlyphMarginLane=v={}));var R;(function(r){r[r.Increase=0]="Increase",r[r.Decrease=1]="Decrease"})(R||(i.HoverVerbosityAction=R={}));var A;(function(r){r[r.None=0]="None",r[r.Indent=1]="Indent",r[r.IndentOutdent=2]="IndentOutdent",r[r.Outdent=3]="Outdent"})(A||(i.IndentAction=A={}));var L;(function(r){r[r.Both=0]="Both",r[r.Right=1]="Right",r[r.Left=2]="Left",r[r.None=3]="None"})(L||(i.InjectedTextCursorStops=L={}));var N;(function(r){r[r.Type=1]="Type",r[r.Parameter=2]="Parameter"})(N||(i.InlayHintKind=N={}));var c;(function(r){r[r.Automatic=0]="Automatic",r[r.Explicit=1]="Explicit"})(c||(i.InlineCompletionTriggerKind=c={}));var u;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(u||(i.InlineEditTriggerKind=u={}));var s;(function(r){r[r.DependsOnKbLayout=-1]="DependsOnKbLayout",r[r.Unknown=0]="Unknown",r[r.Backspace=1]="Backspace",r[r.Tab=2]="Tab",r[r.Enter=3]="Enter",r[r.Shift=4]="Shift",r[r.Ctrl=5]="Ctrl",r[r.Alt=6]="Alt",r[r.PauseBreak=7]="PauseBreak",r[r.CapsLock=8]="CapsLock",r[r.Escape=9]="Escape",r[r.Space=10]="Space",r[r.PageUp=11]="PageUp",r[r.PageDown=12]="PageDown",r[r.End=13]="End",r[r.Home=14]="Home",r[r.LeftArrow=15]="LeftArrow",r[r.UpArrow=16]="UpArrow",r[r.RightArrow=17]="RightArrow",r[r.DownArrow=18]="DownArrow",r[r.Insert=19]="Insert",r[r.Delete=20]="Delete",r[r.Digit0=21]="Digit0",r[r.Digit1=22]="Digit1",r[r.Digit2=23]="Digit2",r[r.Digit3=24]="Digit3",r[r.Digit4=25]="Digit4",r[r.Digit5=26]="Digit5",r[r.Digit6=27]="Digit6",r[r.Digit7=28]="Digit7",r[r.Digit8=29]="Digit8",r[r.Digit9=30]="Digit9",r[r.KeyA=31]="KeyA",r[r.KeyB=32]="KeyB",r[r.KeyC=33]="KeyC",r[r.KeyD=34]="KeyD",r[r.KeyE=35]="KeyE",r[r.KeyF=36]="KeyF",r[r.KeyG=37]="KeyG",r[r.KeyH=38]="KeyH",r[r.KeyI=39]="KeyI",r[r.KeyJ=40]="KeyJ",r[r.KeyK=41]="KeyK",r[r.KeyL=42]="KeyL",r[r.KeyM=43]="KeyM",r[r.KeyN=44]="KeyN",r[r.KeyO=45]="KeyO",r[r.KeyP=46]="KeyP",r[r.KeyQ=47]="KeyQ",r[r.KeyR=48]="KeyR",r[r.KeyS=49]="KeyS",r[r.KeyT=50]="KeyT",r[r.KeyU=51]="KeyU",r[r.KeyV=52]="KeyV",r[r.KeyW=53]="KeyW",r[r.KeyX=54]="KeyX",r[r.KeyY=55]="KeyY",r[r.KeyZ=56]="KeyZ",r[r.Meta=57]="Meta",r[r.ContextMenu=58]="ContextMenu",r[r.F1=59]="F1",r[r.F2=60]="F2",r[r.F3=61]="F3",r[r.F4=62]="F4",r[r.F5=63]="F5",r[r.F6=64]="F6",r[r.F7=65]="F7",r[r.F8=66]="F8",r[r.F9=67]="F9",r[r.F10=68]="F10",r[r.F11=69]="F11",r[r.F12=70]="F12",r[r.F13=71]="F13",r[r.F14=72]="F14",r[r.F15=73]="F15",r[r.F16=74]="F16",r[r.F17=75]="F17",r[r.F18=76]="F18",r[r.F19=77]="F19",r[r.F20=78]="F20",r[r.F21=79]="F21",r[r.F22=80]="F22",r[r.F23=81]="F23",r[r.F24=82]="F24",r[r.NumLock=83]="NumLock",r[r.ScrollLock=84]="ScrollLock",r[r.Semicolon=85]="Semicolon",r[r.Equal=86]="Equal",r[r.Comma=87]="Comma",r[r.Minus=88]="Minus",r[r.Period=89]="Period",r[r.Slash=90]="Slash",r[r.Backquote=91]="Backquote",r[r.BracketLeft=92]="BracketLeft",r[r.Backslash=93]="Backslash",r[r.BracketRight=94]="BracketRight",r[r.Quote=95]="Quote",r[r.OEM_8=96]="OEM_8",r[r.IntlBackslash=97]="IntlBackslash",r[r.Numpad0=98]="Numpad0",r[r.Numpad1=99]="Numpad1",r[r.Numpad2=100]="Numpad2",r[r.Numpad3=101]="Numpad3",r[r.Numpad4=102]="Numpad4",r[r.Numpad5=103]="Numpad5",r[r.Numpad6=104]="Numpad6",r[r.Numpad7=105]="Numpad7",r[r.Numpad8=106]="Numpad8",r[r.Numpad9=107]="Numpad9",r[r.NumpadMultiply=108]="NumpadMultiply",r[r.NumpadAdd=109]="NumpadAdd",r[r.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",r[r.NumpadSubtract=111]="NumpadSubtract",r[r.NumpadDecimal=112]="NumpadDecimal",r[r.NumpadDivide=113]="NumpadDivide",r[r.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",r[r.ABNT_C1=115]="ABNT_C1",r[r.ABNT_C2=116]="ABNT_C2",r[r.AudioVolumeMute=117]="AudioVolumeMute",r[r.AudioVolumeUp=118]="AudioVolumeUp",r[r.AudioVolumeDown=119]="AudioVolumeDown",r[r.BrowserSearch=120]="BrowserSearch",r[r.BrowserHome=121]="BrowserHome",r[r.BrowserBack=122]="BrowserBack",r[r.BrowserForward=123]="BrowserForward",r[r.MediaTrackNext=124]="MediaTrackNext",r[r.MediaTrackPrevious=125]="MediaTrackPrevious",r[r.MediaStop=126]="MediaStop",r[r.MediaPlayPause=127]="MediaPlayPause",r[r.LaunchMediaPlayer=128]="LaunchMediaPlayer",r[r.LaunchMail=129]="LaunchMail",r[r.LaunchApp2=130]="LaunchApp2",r[r.Clear=131]="Clear",r[r.MAX_VALUE=132]="MAX_VALUE"})(s||(i.KeyCode=s={}));var o;(function(r){r[r.Hint=1]="Hint",r[r.Info=2]="Info",r[r.Warning=4]="Warning",r[r.Error=8]="Error"})(o||(i.MarkerSeverity=o={}));var h;(function(r){r[r.Unnecessary=1]="Unnecessary",r[r.Deprecated=2]="Deprecated"})(h||(i.MarkerTag=h={}));var U;(function(r){r[r.Inline=1]="Inline",r[r.Gutter=2]="Gutter"})(U||(i.MinimapPosition=U={}));var _;(function(r){r[r.Normal=1]="Normal",r[r.Underlined=2]="Underlined"})(_||(i.MinimapSectionHeaderStyle=_={}));var T;(function(r){r[r.UNKNOWN=0]="UNKNOWN",r[r.TEXTAREA=1]="TEXTAREA",r[r.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",r[r.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",r[r.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",r[r.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",r[r.CONTENT_TEXT=6]="CONTENT_TEXT",r[r.CONTENT_EMPTY=7]="CONTENT_EMPTY",r[r.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",r[r.CONTENT_WIDGET=9]="CONTENT_WIDGET",r[r.OVERVIEW_RULER=10]="OVERVIEW_RULER",r[r.SCROLLBAR=11]="SCROLLBAR",r[r.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",r[r.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(T||(i.MouseTargetType=T={}));var M;(function(r){r[r.AIGenerated=1]="AIGenerated"})(M||(i.NewSymbolNameTag=M={}));var j;(function(r){r[r.Invoke=0]="Invoke",r[r.Automatic=1]="Automatic"})(j||(i.NewSymbolNameTriggerKind=j={}));var I;(function(r){r[r.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",r[r.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",r[r.TOP_CENTER=2]="TOP_CENTER"})(I||(i.OverlayWidgetPositionPreference=I={}));var S;(function(r){r[r.Left=1]="Left",r[r.Center=2]="Center",r[r.Right=4]="Right",r[r.Full=7]="Full"})(S||(i.OverviewRulerLane=S={}));var D;(function(r){r[r.Word=0]="Word",r[r.Line=1]="Line",r[r.Suggest=2]="Suggest"})(D||(i.PartialAcceptTriggerKind=D={}));var B;(function(r){r[r.Left=0]="Left",r[r.Right=1]="Right",r[r.None=2]="None",r[r.LeftOfInjectedText=3]="LeftOfInjectedText",r[r.RightOfInjectedText=4]="RightOfInjectedText"})(B||(i.PositionAffinity=B={}));var Z;(function(r){r[r.Off=0]="Off",r[r.On=1]="On",r[r.Relative=2]="Relative",r[r.Interval=3]="Interval",r[r.Custom=4]="Custom"})(Z||(i.RenderLineNumbersType=Z={}));var O;(function(r){r[r.None=0]="None",r[r.Text=1]="Text",r[r.Blocks=2]="Blocks"})(O||(i.RenderMinimap=O={}));var P;(function(r){r[r.Smooth=0]="Smooth",r[r.Immediate=1]="Immediate"})(P||(i.ScrollType=P={}));var X;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(X||(i.ScrollbarVisibility=X={}));var Y;(function(r){r[r.LTR=0]="LTR",r[r.RTL=1]="RTL"})(Y||(i.SelectionDirection=Y={}));var H;(function(r){r.Off="off",r.OnCode="onCode",r.On="on"})(H||(i.ShowLightbulbIconMode=H={}));var K;(function(r){r[r.Invoke=1]="Invoke",r[r.TriggerCharacter=2]="TriggerCharacter",r[r.ContentChange=3]="ContentChange"})(K||(i.SignatureHelpTriggerKind=K={}));var C;(function(r){r[r.File=0]="File",r[r.Module=1]="Module",r[r.Namespace=2]="Namespace",r[r.Package=3]="Package",r[r.Class=4]="Class",r[r.Method=5]="Method",r[r.Property=6]="Property",r[r.Field=7]="Field",r[r.Constructor=8]="Constructor",r[r.Enum=9]="Enum",r[r.Interface=10]="Interface",r[r.Function=11]="Function",r[r.Variable=12]="Variable",r[r.Constant=13]="Constant",r[r.String=14]="String",r[r.Number=15]="Number",r[r.Boolean=16]="Boolean",r[r.Array=17]="Array",r[r.Object=18]="Object",r[r.Key=19]="Key",r[r.Null=20]="Null",r[r.EnumMember=21]="EnumMember",r[r.Struct=22]="Struct",r[r.Event=23]="Event",r[r.Operator=24]="Operator",r[r.TypeParameter=25]="TypeParameter"})(C||(i.SymbolKind=C={}));var F;(function(r){r[r.Deprecated=1]="Deprecated"})(F||(i.SymbolTag=F={}));var G;(function(r){r[r.Hidden=0]="Hidden",r[r.Blink=1]="Blink",r[r.Smooth=2]="Smooth",r[r.Phase=3]="Phase",r[r.Expand=4]="Expand",r[r.Solid=5]="Solid"})(G||(i.TextEditorCursorBlinkingStyle=G={}));var oe;(function(r){r[r.Line=1]="Line",r[r.Block=2]="Block",r[r.Underline=3]="Underline",r[r.LineThin=4]="LineThin",r[r.BlockOutline=5]="BlockOutline",r[r.UnderlineThin=6]="UnderlineThin"})(oe||(i.TextEditorCursorStyle=oe={}));var fe;(function(r){r[r.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",r[r.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",r[r.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",r[r.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(fe||(i.TrackedRangeStickiness=fe={}));var we;(function(r){r[r.None=0]="None",r[r.Same=1]="Same",r[r.Indent=2]="Indent",r[r.DeepIndent=3]="DeepIndent"})(we||(i.WrappingIndent=we={}))}),ne(ie[71],re([0,1,13,12,60]),function(q,i,t,n,p){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$yv=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new t.$he,this.onDidChange=this.c.event,this.d=null}handleChange(a){this.c.fire({changedLanguages:a,changedColorMap:!1})}register(a,l){return this.a.set(a,l),this.handleChange([a]),(0,n.$Sc)(()=>{this.a.get(a)===l&&(this.a.delete(a),this.handleChange([a]))})}get(a){return this.a.get(a)||null}registerFactory(a,l){this.b.get(a)?.dispose();const f=new w(this,a,l);return this.b.set(a,f),(0,n.$Sc)(()=>{const $=this.b.get(a);!$||$!==f||(this.b.delete(a),$.dispose())})}async getOrCreate(a){const l=this.get(a);if(l)return l;const f=this.b.get(a);return!f||f.isResolved?null:(await f.resolve(),this.get(a))}isResolved(a){if(this.get(a))return!0;const f=this.b.get(a);return!!(!f||f.isResolved)}setColorMap(a){this.d=a,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>p.ColorId.DefaultBackground?this.d[p.ColorId.DefaultBackground]:null}}i.$yv=g;class w extends n.$Uc{get isResolved(){return this.c}constructor(a,l,f){super(),this.f=a,this.g=l,this.h=f,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const a=await this.h.tokenizationSupport;this.c=!0,a&&!this.a&&this.B(this.f.register(this.g,a))}}}),ne(ie[72],re([77,78]),function(q,i){return q.create("vs/editor/common/languages",i)}),ne(ie[73],re([0,1,47,19,49,2,71,72]),function(q,i,t,n,p,g,w,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InlineEditTriggerKind=i.ExternalUriOpenerPriority=i.$Sv=i.$Rv=i.InlayHintKind=i.CommentState=i.CommentMode=i.CommentThreadApplicability=i.CommentThreadState=i.CommentThreadCollapsibleState=i.Command=i.NewSymbolNameTriggerKind=i.NewSymbolNameTag=i.$Qv=i.$Pv=i.SymbolKinds=i.SymbolTag=i.$Nv=i.SymbolKind=i.DocumentHighlightKind=i.SignatureHelpTriggerKind=i.DocumentPasteTriggerKind=i.CodeActionTriggerType=i.$Lv=i.InlineCompletionTriggerKind=i.CompletionTriggerKind=i.PartialAcceptTriggerKind=i.CompletionItemInsertTextRule=i.CompletionItemTag=i.CompletionItemKinds=i.CompletionItemKind=i.HoverVerbosityAction=i.$Kv=i.$Jv=i.$Iv=void 0,i.$Mv=o,i.$Ov=U;class a{constructor(G,oe,fe){this.offset=G,this.type=oe,this.language=fe,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}i.$Iv=a;class l{constructor(G,oe){this.tokens=G,this.endState=oe,this._tokenizationResultBrand=void 0}}i.$Jv=l;class f{constructor(G,oe){this.tokens=G,this.endState=oe,this._encodedTokenizationResultBrand=void 0}}i.$Kv=f;var $;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})($||(i.HoverVerbosityAction=$={}));var d;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(d||(i.CompletionItemKind=d={}));var E;(function(F){const G=new Map;G.set(d.Method,t.$Zj.symbolMethod),G.set(d.Function,t.$Zj.symbolFunction),G.set(d.Constructor,t.$Zj.symbolConstructor),G.set(d.Field,t.$Zj.symbolField),G.set(d.Variable,t.$Zj.symbolVariable),G.set(d.Class,t.$Zj.symbolClass),G.set(d.Struct,t.$Zj.symbolStruct),G.set(d.Interface,t.$Zj.symbolInterface),G.set(d.Module,t.$Zj.symbolModule),G.set(d.Property,t.$Zj.symbolProperty),G.set(d.Event,t.$Zj.symbolEvent),G.set(d.Operator,t.$Zj.symbolOperator),G.set(d.Unit,t.$Zj.symbolUnit),G.set(d.Value,t.$Zj.symbolValue),G.set(d.Enum,t.$Zj.symbolEnum),G.set(d.Constant,t.$Zj.symbolConstant),G.set(d.Enum,t.$Zj.symbolEnum),G.set(d.EnumMember,t.$Zj.symbolEnumMember),G.set(d.Keyword,t.$Zj.symbolKeyword),G.set(d.Snippet,t.$Zj.symbolSnippet),G.set(d.Text,t.$Zj.symbolText),G.set(d.Color,t.$Zj.symbolColor),G.set(d.File,t.$Zj.symbolFile),G.set(d.Reference,t.$Zj.symbolReference),G.set(d.Customcolor,t.$Zj.symbolCustomColor),G.set(d.Folder,t.$Zj.symbolFolder),G.set(d.TypeParameter,t.$Zj.symbolTypeParameter),G.set(d.User,t.$Zj.account),G.set(d.Issue,t.$Zj.issues);function oe(r){let Te=G.get(r);return Te||(console.info("No codicon found for CompletionItemKind "+r),Te=t.$Zj.symbolProperty),Te}F.toIcon=oe;const fe=new Map;fe.set("method",d.Method),fe.set("function",d.Function),fe.set("constructor",d.Constructor),fe.set("field",d.Field),fe.set("variable",d.Variable),fe.set("class",d.Class),fe.set("struct",d.Struct),fe.set("interface",d.Interface),fe.set("module",d.Module),fe.set("property",d.Property),fe.set("event",d.Event),fe.set("operator",d.Operator),fe.set("unit",d.Unit),fe.set("value",d.Value),fe.set("constant",d.Constant),fe.set("enum",d.Enum),fe.set("enum-member",d.EnumMember),fe.set("enumMember",d.EnumMember),fe.set("keyword",d.Keyword),fe.set("snippet",d.Snippet),fe.set("text",d.Text),fe.set("color",d.Color),fe.set("file",d.File),fe.set("reference",d.Reference),fe.set("customcolor",d.Customcolor),fe.set("folder",d.Folder),fe.set("type-parameter",d.TypeParameter),fe.set("typeParameter",d.TypeParameter),fe.set("account",d.User),fe.set("issue",d.Issue);function we(r,Te){let Me=fe.get(r);return typeof Me>"u"&&!Te&&(Me=d.Property),Me}F.fromString=we})(E||(i.CompletionItemKinds=E={}));var e;(function(F){F[F.Deprecated=1]="Deprecated"})(e||(i.CompletionItemTag=e={}));var m;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(m||(i.CompletionItemInsertTextRule=m={}));var v;(function(F){F[F.Word=0]="Word",F[F.Line=1]="Line",F[F.Suggest=2]="Suggest"})(v||(i.PartialAcceptTriggerKind=v={}));var R;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(R||(i.CompletionTriggerKind=R={}));var A;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(A||(i.InlineCompletionTriggerKind=A={}));class L{constructor(G,oe,fe,we){this.range=G,this.text=oe,this.completionKind=fe,this.isSnippetText=we}equals(G){return g.$dt.lift(this.range).equalsRange(G.range)&&this.text===G.text&&this.completionKind===G.completionKind&&this.isSnippetText===G.isSnippetText}}i.$Lv=L;var N;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(N||(i.CodeActionTriggerType=N={}));var c;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(c||(i.DocumentPasteTriggerKind=c={}));var u;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(u||(i.SignatureHelpTriggerKind=u={}));var s;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(s||(i.DocumentHighlightKind=s={}));function o(F){return F&&n.URI.isUri(F.uri)&&g.$dt.isIRange(F.range)&&(g.$dt.isIRange(F.originSelectionRange)||g.$dt.isIRange(F.targetSelectionRange))}var h;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(h||(i.SymbolKind=h={})),i.$Nv={[h.Array]:(0,b.localize)(0,null),[h.Boolean]:(0,b.localize)(1,null),[h.Class]:(0,b.localize)(2,null),[h.Constant]:(0,b.localize)(3,null),[h.Constructor]:(0,b.localize)(4,null),[h.Enum]:(0,b.localize)(5,null),[h.EnumMember]:(0,b.localize)(6,null),[h.Event]:(0,b.localize)(7,null),[h.Field]:(0,b.localize)(8,null),[h.File]:(0,b.localize)(9,null),[h.Function]:(0,b.localize)(10,null),[h.Interface]:(0,b.localize)(11,null),[h.Key]:(0,b.localize)(12,null),[h.Method]:(0,b.localize)(13,null),[h.Module]:(0,b.localize)(14,null),[h.Namespace]:(0,b.localize)(15,null),[h.Null]:(0,b.localize)(16,null),[h.Number]:(0,b.localize)(17,null),[h.Object]:(0,b.localize)(18,null),[h.Operator]:(0,b.localize)(19,null),[h.Package]:(0,b.localize)(20,null),[h.Property]:(0,b.localize)(21,null),[h.String]:(0,b.localize)(22,null),[h.Struct]:(0,b.localize)(23,null),[h.TypeParameter]:(0,b.localize)(24,null),[h.Variable]:(0,b.localize)(25,null)};function U(F,G){return(0,b.localize)(26,null,F,i.$Nv[G])}var _;(function(F){F[F.Deprecated=1]="Deprecated"})(_||(i.SymbolTag=_={}));var T;(function(F){const G=new Map;G.set(h.File,t.$Zj.symbolFile),G.set(h.Module,t.$Zj.symbolModule),G.set(h.Namespace,t.$Zj.symbolNamespace),G.set(h.Package,t.$Zj.symbolPackage),G.set(h.Class,t.$Zj.symbolClass),G.set(h.Method,t.$Zj.symbolMethod),G.set(h.Property,t.$Zj.symbolProperty),G.set(h.Field,t.$Zj.symbolField),G.set(h.Constructor,t.$Zj.symbolConstructor),G.set(h.Enum,t.$Zj.symbolEnum),G.set(h.Interface,t.$Zj.symbolInterface),G.set(h.Function,t.$Zj.symbolFunction),G.set(h.Variable,t.$Zj.symbolVariable),G.set(h.Constant,t.$Zj.symbolConstant),G.set(h.String,t.$Zj.symbolString),G.set(h.Number,t.$Zj.symbolNumber),G.set(h.Boolean,t.$Zj.symbolBoolean),G.set(h.Array,t.$Zj.symbolArray),G.set(h.Object,t.$Zj.symbolObject),G.set(h.Key,t.$Zj.symbolKey),G.set(h.Null,t.$Zj.symbolNull),G.set(h.EnumMember,t.$Zj.symbolEnumMember),G.set(h.Struct,t.$Zj.symbolStruct),G.set(h.Event,t.$Zj.symbolEvent),G.set(h.Operator,t.$Zj.symbolOperator),G.set(h.TypeParameter,t.$Zj.symbolTypeParameter);function oe(fe){let we=G.get(fe);return we||(console.info("No codicon found for SymbolKind "+fe),we=t.$Zj.symbolProperty),we}F.toIcon=oe})(T||(i.SymbolKinds=T={}));class M{static asEditOperation(G){return p.$et.replace(g.$dt.lift(G.range),G.text)}}i.$Pv=M;class j{static fromValue(G){switch(G){case"comment":return j.Comment;case"imports":return j.Imports;case"region":return j.Region}return new j(G)}constructor(G){this.value=G}}i.$Qv=j,j.Comment=new j("comment"),j.Imports=new j("imports"),j.Region=new j("region");var I;(function(F){F[F.AIGenerated=1]="AIGenerated"})(I||(i.NewSymbolNameTag=I={}));var S;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(S||(i.NewSymbolNameTriggerKind=S={}));var D;(function(F){function G(oe){return!oe||typeof oe!="object"?!1:typeof oe.id=="string"&&typeof oe.title=="string"}F.is=G})(D||(i.Command=D={}));var B;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(B||(i.CommentThreadCollapsibleState=B={}));var Z;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(Z||(i.CommentThreadState=Z={}));var O;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(O||(i.CommentThreadApplicability=O={}));var P;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(P||(i.CommentMode=P={}));var X;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(X||(i.CommentState=X={}));var Y;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(Y||(i.InlayHintKind=Y={}));class H{constructor(G){this.b=G,this.a=null}dispose(){this.a&&this.a.then(G=>{G&&G.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}i.$Rv=H,i.$Sv=new w.$yv;var K;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(K||(i.ExternalUriOpenerPriority=K={}));var C;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(C||(i.InlineEditTriggerKind=C={}))}),ne(ie[74],re([0,1,26,13,40,19,5,2,50,73,70]),function(q,i,t,n,p,g,w,b,a,l,f){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.$c3=void 0,i.$d3=d;class ${static chord(e,m){return(0,p.$Nr)(e,m)}}i.$c3=$,$.CtrlCmd=p.KeyMod.CtrlCmd,$.Shift=p.KeyMod.Shift,$.Alt=p.KeyMod.Alt,$.WinCtrl=p.KeyMod.WinCtrl;function d(){return{editor:void 0,languages:void 0,CancellationTokenSource:t.$se,Emitter:n.$he,KeyCode:f.KeyCode,KeyMod:$,Position:w.$ct,Range:b.$dt,Selection:a.$ft,SelectionDirection:f.SelectionDirection,MarkerSeverity:f.MarkerSeverity,MarkerTag:f.MarkerTag,Uri:g.URI,Token:l.$Iv}}}),ne(ie[79],re([0,1,29,19,5,2,66,32,62,63,74,25,69,36,59,18,4,61,68]),function(q,i,t,n,p,g,w,b,a,l,f,$,d,E,e,m,v,R,A){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.EditorSimpleWorker=void 0,i.create=c;class L extends w.$dw{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(s){const o=[];for(let h=0;h<this.f.length;h++){const U=this.f[h],_=this.offsetAt(new p.$ct(h+1,1)),T=U.matchAll(s);for(const M of T)(M.index||M.index===0)&&(M.index=M.index+_),o.push(M)}return o}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(s){return this.f[s-1]}getWordAtPosition(s,o){const h=(0,b.$wt)(s.column,(0,b.$ut)(o),this.f[s.lineNumber-1],0);return h?new g.$dt(s.lineNumber,h.startColumn,s.lineNumber,h.endColumn):null}getWordUntilPosition(s,o){const h=this.getWordAtPosition(s,o);return h?{word:this.f[s.lineNumber-1].substring(h.startColumn-1,s.column-1),startColumn:h.startColumn,endColumn:s.column}:{word:"",startColumn:s.column,endColumn:s.column}}words(s){const o=this.f,h=this.q.bind(this);let U=0,_="",T=0,M=[];return{*[Symbol.iterator](){for(;;)if(T<M.length){const j=_.substring(M[T].start,M[T].end);T+=1,yield j}else if(U<o.length)_=o[U],M=h(_,s),T=0,U+=1;else break}}}getLineWords(s,o){const h=this.f[s-1],U=this.q(h,o),_=[];for(const T of U)_.push({word:h.substring(T.start,T.end),startColumn:T.start+1,endColumn:T.end+1});return _}q(s,o){const h=[];let U;for(o.lastIndex=0;(U=o.exec(s))&&U[0].length!==0;)h.push({start:U.index,end:U.index+U[0].length});return h}getValueInRange(s){if(s=this.r(s),s.startLineNumber===s.endLineNumber)return this.f[s.startLineNumber-1].substring(s.startColumn-1,s.endColumn-1);const o=this.g,h=s.startLineNumber-1,U=s.endLineNumber-1,_=[];_.push(this.f[h].substring(s.startColumn-1));for(let T=h+1;T<U;T++)_.push(this.f[T]);return _.push(this.f[U].substring(0,s.endColumn-1)),_.join(o)}offsetAt(s){return s=this.s(s),this.l(),this.j.getPrefixSum(s.lineNumber-2)+(s.column-1)}positionAt(s){s=Math.floor(s),s=Math.max(0,s),this.l();const o=this.j.getIndexOf(s),h=this.f[o.index].length;return{lineNumber:1+o.index,column:1+Math.min(o.remainder,h)}}r(s){const o=this.s({lineNumber:s.startLineNumber,column:s.startColumn}),h=this.s({lineNumber:s.endLineNumber,column:s.endColumn});return o.lineNumber!==s.startLineNumber||o.column!==s.startColumn||h.lineNumber!==s.endLineNumber||h.column!==s.endColumn?{startLineNumber:o.lineNumber,startColumn:o.column,endLineNumber:h.lineNumber,endColumn:h.column}:s}s(s){if(!p.$ct.isIPosition(s))throw new Error("bad position");let{lineNumber:o,column:h}=s,U=!1;if(o<1)o=1,h=1,U=!0;else if(o>this.f.length)o=this.f.length,h=this.f[o-1].length+1,U=!0;else{const _=this.f[o-1].length+1;h<1?(h=1,U=!0):h>_&&(h=_,U=!0)}return U?{lineNumber:o,column:h}:s}}class N{constructor(s,o){this.d=s,this.f=Object.create(null),this.g=o,this.h=null}dispose(){this.f=Object.create(null)}j(s){return this.f[s]}k(){const s=[];return Object.keys(this.f).forEach(o=>s.push(this.f[o])),s}acceptNewModel(s){this.f[s.url]=new L(n.URI.parse(s.url),s.lines,s.EOL,s.versionId)}acceptModelChanged(s,o){if(!this.f[s])return;this.f[s].onEvents(o)}acceptRemovedModel(s){this.f[s]&&delete this.f[s]}async computeUnicodeHighlights(s,o,h){const U=this.j(s);return U?d.$02.computeUnicodeHighlights(U,o,h):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async findSectionHeaders(s,o){const h=this.j(s);return h?(0,A.$B3)(h,o):[]}async computeDiff(s,o,h,U){const _=this.j(s),T=this.j(o);return!_||!T?null:N.l(_,T,h,U)}static l(s,o,h,U){const _=U==="advanced"?e.$z3.getDefault():e.$z3.getLegacy(),T=s.getLinesContent(),M=o.getLinesContent(),j=_.computeDiff(T,M,h),I=j.changes.length>0?!1:this.n(s,o);function S(D){return D.map(B=>[B.original.startLineNumber,B.original.endLineNumberExclusive,B.modified.startLineNumber,B.modified.endLineNumberExclusive,B.innerChanges?.map(Z=>[Z.originalRange.startLineNumber,Z.originalRange.startColumn,Z.originalRange.endLineNumber,Z.originalRange.endColumn,Z.modifiedRange.startLineNumber,Z.modifiedRange.startColumn,Z.modifiedRange.endLineNumber,Z.modifiedRange.endColumn])])}return{identical:I,quitEarly:j.hitTimeout,changes:S(j.changes),moves:j.moves.map(D=>[D.lineRangeMapping.original.startLineNumber,D.lineRangeMapping.original.endLineNumberExclusive,D.lineRangeMapping.modified.startLineNumber,D.lineRangeMapping.modified.endLineNumberExclusive,S(D.changes)])}}static n(s,o){const h=s.getLineCount(),U=o.getLineCount();if(h!==U)return!1;for(let _=1;_<=h;_++){const T=s.getLineContent(_),M=o.getLineContent(_);if(T!==M)return!1}return!0}async computeDirtyDiff(s,o,h){const U=this.j(s),_=this.j(o);if(!U||!_)return null;const T=U.getLinesContent(),M=_.getLinesContent();return new E.$0v(T,M,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:h,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}async computeMoreMinimalEdits(s,o,h){const U=this.j(s);if(!U)return o;const _=[];let T;o=o.slice(0).sort((j,I)=>{if(j.range&&I.range)return g.$dt.compareRangesUsingStarts(j.range,I.range);const S=j.range?0:1,D=I.range?0:1;return S-D});let M=0;for(let j=1;j<o.length;j++)g.$dt.getEndPosition(o[M].range).equals(g.$dt.getStartPosition(o[j].range))?(o[M].range=g.$dt.fromPositions(g.$dt.getStartPosition(o[M].range),g.$dt.getEndPosition(o[j].range)),o[M].text+=o[j].text):(M++,o[M]=o[j]);o.length=M+1;for(let{range:j,text:I,eol:S}of o){if(typeof S=="number"&&(T=S),g.$dt.isEmpty(j)&&!I)continue;const D=U.getValueInRange(j);if(I=I.replace(/\r\n|\n|\r/g,U.eol),D===I)continue;if(Math.max(I.length,D.length)>N.o){_.push({range:j,text:I});continue}const B=(0,t.$Vv)(D,I,h),Z=U.offsetAt(g.$dt.lift(j).getStartPosition());for(const O of B){const P=U.positionAt(Z+O.originalStart),X=U.positionAt(Z+O.originalStart+O.originalLength),Y={text:I.substr(O.modifiedStart,O.modifiedLength),range:{startLineNumber:P.lineNumber,startColumn:P.column,endLineNumber:X.lineNumber,endColumn:X.column}};U.getValueInRange(Y.range)!==Y.text&&_.push(Y)}}return typeof T=="number"&&_.push({eol:T,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}computeHumanReadableDiff(s,o,h){const U=this.j(s);if(!U)return o;const _=[];let T;o=o.slice(0).sort((M,j)=>{if(M.range&&j.range)return g.$dt.compareRangesUsingStarts(M.range,j.range);const I=M.range?0:1,S=j.range?0:1;return I-S});for(let{range:M,text:j,eol:I}of o){let P=function(Y,H){return new p.$ct(Y.lineNumber+H.lineNumber-1,H.lineNumber===1?Y.column+H.column-1:H.column)},X=function(Y,H){const K=[];for(let C=H.startLineNumber;C<=H.endLineNumber;C++){const F=Y[C-1];C===H.startLineNumber&&C===H.endLineNumber?K.push(F.substring(H.startColumn-1,H.endColumn-1)):C===H.startLineNumber?K.push(F.substring(H.startColumn-1)):C===H.endLineNumber?K.push(F.substring(0,H.endColumn-1)):K.push(F)}return K};if(typeof I=="number"&&(T=I),g.$dt.isEmpty(M)&&!j)continue;const S=U.getValueInRange(M);if(j=j.replace(/\r\n|\n|\r/g,U.eol),S===j)continue;if(Math.max(j.length,S.length)>N.o){_.push({range:M,text:j});continue}const D=S.split(/\r\n|\n|\r/),B=j.split(/\r\n|\n|\r/),Z=e.$z3.getDefault().computeDiff(D,B,h),O=g.$dt.lift(M).getStartPosition();for(const Y of Z.changes)if(Y.innerChanges)for(const H of Y.innerChanges)_.push({range:g.$dt.fromPositions(P(O,H.originalRange.getStartPosition()),P(O,H.originalRange.getEndPosition())),text:X(B,H.modifiedRange).join(U.eol)});else throw new v.$cb("The experimental diff algorithm always produces inner changes")}return typeof T=="number"&&_.push({eol:T,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),_}async computeLinks(s){const o=this.j(s);return o?(0,a.$a3)(o):null}async computeDefaultDocumentColors(s){const o=this.j(s);return o?(0,R.$A3)(o):null}async textualSuggest(s,o,h,U){const _=new $.$be,T=new RegExp(h,U),M=new Set;e:for(const j of s){const I=this.j(j);if(I){for(const S of I.words(T))if(!(S===o||!isNaN(Number(S)))&&(M.add(S),M.size>N.p))break e}}return{words:Array.from(M),duration:_.elapsed()}}async computeWordRanges(s,o,h,U){const _=this.j(s);if(!_)return Object.create(null);const T=new RegExp(h,U),M=Object.create(null);for(let j=o.startLineNumber;j<o.endLineNumber;j++){const I=_.getLineWords(j,T);for(const S of I){if(!isNaN(Number(S.word)))continue;let D=M[S.word];D||(D=[],M[S.word]=D),D.push({startLineNumber:j,startColumn:S.startColumn,endLineNumber:j,endColumn:S.endColumn})}}return M}async navigateValueSet(s,o,h,U,_){const T=this.j(s);if(!T)return null;const M=new RegExp(U,_);o.startColumn===o.endColumn&&(o={startLineNumber:o.startLineNumber,startColumn:o.startColumn,endLineNumber:o.endLineNumber,endColumn:o.endColumn+1});const j=T.getValueInRange(o),I=T.getWordAtPosition({lineNumber:o.startLineNumber,column:o.startColumn},M);if(!I)return null;const S=T.getValueInRange(I);return l.$b3.INSTANCE.navigateValueSet(o,j,I,S,h)}loadForeignModule(s,o,h){const U=(M,j)=>this.d.fhr(M,j),T={host:(0,m.$io)(h,U),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(T,o),Promise.resolve((0,m.$ho)(this.h))):new Promise((M,j)=>{q([s],I=>{this.h=I.create(T,o),M((0,m.$ho)(this.h))},j)})}fmr(s,o){if(!this.h||typeof this.h[s]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+s));try{return Promise.resolve(this.h[s].apply(this.h,o))}catch(h){return Promise.reject(h)}}}i.EditorSimpleWorker=N,N.o=1e5,N.p=1e4;function c(u){return new N(u,null)}typeof importScripts=="function"&&(globalThis.monaco=(0,f.$d3)())})}).call(this);

//# sourceMappingURL=workerMain.js.map
