"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/lifecycle","vs/base/common/uri","vs/base/common/event","vs/base/common/strings","vs/base/common/async","vs/base/common/errors","vs/base/common/types","vs/base/common/charCode","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/extpath","vs/base/common/lazy","vs/base/common/buffer","fs","vs/platform/files/common/files","vs/platform/files/common/watcher","vs/base/common/map","vs/base/common/normalization","vs/base/common/resources","vs/base/common/glob","vs/base/node/pfs","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/marshallingIds","vs/base/common/process","vs/base/common/processes","vs/base/common/ternarySearchTree","vs/base/common/network","vs/base/node/extpath","vs/base/parts/sandbox/node/electronTypes","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/objects","vs/base/common/uint","vs/base/common/console","vs/base/common/marshalling","os","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/common/errorMessage","vs/nls","vs/nls!vs/platform/files/node/watcher/watcherMain","vs/base/common/errorMessage","vs/nls!vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcher","vs/platform/files/node/watcher/watcherStats","vs/platform/files/node/watcher/watcher","util","child_process","@parcel/watcher","vs/platform/files/node/watcher/watcherMain"],_e=function($e){for(var e=[],E=0,t=$e.length;E<t;E++)e[E]=Ee[$e[E]];return e};define(Ee[36],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=E,e.$gb=t,e.$hb=j,e.$ib=M,e.$jb=V,e.$kb=N,e.$lb=U,e.$nb=k,e.$ob=w,e.$pb=I,e.$qb=F,e.$rb=c;function E(r,d){const m=t(r,d);if(m!==-1)return r[m]}function t(r,d,m=r.length-1){for(let l=m;l>=0;l--){const _=r[l];if(d(_))return l}return-1}function j(r,d){const m=M(r,d);return m===-1?void 0:r[m]}function M(r,d,m=0,l=r.length){let _=m,y=l;for(;_<y;){const s=Math.floor((_+y)/2);d(r[s])?_=s+1:y=s}return _-1}function V(r,d){const m=N(r,d);return m===r.length?void 0:r[m]}function N(r,d,m=0,l=r.length){let _=m,y=l;for(;_<y;){const s=Math.floor((_+y)/2);d(r[s])?y=s:_=s+1}return _}function U(r,d,m=0,l=r.length){const _=N(r,d,m,l);return _===r.length?-1:_}class S{constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(S.assertInvariants){if(this.d){for(const l of this.e)if(this.d(l)&&!d(l))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const m=M(this.e,d,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}e.$mb=S,S.assertInvariants=!1;function k(r,d){if(r.length===0)return;let m=r[0];for(let l=1;l<r.length;l++){const _=r[l];d(_,m)>0&&(m=_)}return m}function w(r,d){if(r.length===0)return;let m=r[0];for(let l=1;l<r.length;l++){const _=r[l];d(_,m)>=0&&(m=_)}return m}function I(r,d){return k(r,(m,l)=>-d(m,l))}function F(r,d){if(r.length===0)return-1;let m=0;for(let l=1;l<r.length;l++){const _=r[l];d(_,r[m])>0&&(m=l)}return m}function c(r,d){for(const m of r){const l=d(m);if(l!==void 0)return l}}}),define(Ee[11],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var E;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(E||(e.CharCode=E={}))}),define(Ee[37],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E=E,e.$F=t,e.$G=j,e.$H=M;function E(V,N){const U=Object.create(null);for(const S of V){const k=N(S);let w=U[k];w||(w=U[k]=[]),w.push(S)}return U}function t(V,N){const U=[],S=[];for(const k of V)N.has(k)||U.push(k);for(const k of N)V.has(k)||S.push(k);return{removed:U,added:S}}function j(V,N){const U=[],S=[];for(const[k,w]of V)N.has(k)||U.push(w);for(const[k,w]of N)V.has(k)||S.push(w);return{removed:U,added:S}}function M(V,N){const U=new Set;for(const S of N)V.has(S)&&U.add(S);return U}}),define(Ee[38],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=t,e.$6h=j,e.$7h=M;function E(V){return(N,U,S)=>{let k=null,w=null;if(typeof S.value=="function"?(k="value",w=S.value):typeof S.get=="function"&&(k="get",w=S.get),!w)throw new Error("not supported");S[k]=V(w,U)}}function t(V,N,U){let S=null,k=null;if(typeof U.value=="function"?(S="value",k=U.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof U.get=="function"&&(S="get",k=U.get),!k)throw new Error("not supported");const w=`$memoize$${N}`;U[S]=function(...I){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,I)}),this[w]}}function j(V,N,U){return E((S,k)=>{const w=`$debounce$${k}`,I=`$debounce$result$${k}`;return function(...F){this[I]||(this[I]=U?U():void 0),clearTimeout(this[w]),N&&(this[I]=N(this[I],...F),F=[this[I]]),this[w]=setTimeout(()=>{S.apply(this,F),this[I]=U?U():void 0},V)}})}function M(V,N,U){return E((S,k)=>{const w=`$throttle$timer$${k}`,I=`$throttle$result$${k}`,F=`$throttle$lastRun$${k}`,c=`$throttle$pending$${k}`;return function(...r){if(this[I]||(this[I]=U?U():void 0),(this[F]===null||this[F]===void 0)&&(this[F]=-Number.MAX_VALUE),N&&(this[I]=N(this[I],...r)),this[c])return;const d=this[F]+V;d<=Date.now()?(this[F]=Date.now(),S.apply(this,[this[I]]),this[I]=U?U():void 0):(this[c]=!0,this[w]=setTimeout(()=>{this[c]=!1,this[F]=Date.now(),S.apply(this,[this[I]]),this[I]=U?U():void 0},d-Date.now()))}})}}),define(Ee[9],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=t,e.$Z=j,e.$1=M,e.$2=V,e.$3=N,e.$4=S,e.$6=w,e.$7=I,e.$8=F,e.$0=r;class E{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?_.isErrorNoTelemetry(n)?new _(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(i=>{i(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$W=E,e.$X=new E;function t(s){e.$X.setUnexpectedErrorHandler(s)}function j(s){if(!s||typeof s!="object")return!1;const n=s;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function M(s){S(s)||e.$X.onUnexpectedError(s)}function V(s){S(s)||e.$X.onUnexpectedExternalError(s)}function N(s){if(s instanceof Error){const{name:n,message:i}=s,f=s.stacktrace||s.stack;return{$isError:!0,name:n,message:i,stack:f,noTelemetry:_.isErrorNoTelemetry(s)}}return s}const U="Canceled";function S(s){return s instanceof k?!0:s instanceof Error&&s.name===U&&s.message===U}class k extends Error{constructor(){super(U),this.name=this.message}}e.$5=k;function w(){const s=new Error(U);return s.name=s.message,s}function I(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}function F(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}class c extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=c;function r(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}class d extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=d;class m extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=m;class l extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=l;class _ extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof _)return n;const i=new _;return i.message=n.message,i.stack=n.stack,i}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=_;class y extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,y.prototype)}}e.$cb=y}),define(Ee[12],_e([0,1,9,36]),function($e,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=j,e.$tb=M,e.$ub=V,e.$vb=N,e.$wb=U,e.$xb=S,e.$yb=k,e.$zb=w,e.$Ab=I,e.$Bb=F,e.$Cb=c,e.$Db=r,e.$Eb=d,e.top=m,e.$Gb=l,e.$Hb=y,e.$Ib=s,e.$Jb=n,e.$Kb=i,e.$Lb=f,e.$Mb=u,e.$Nb=P,e.$Ob=h,e.$Pb=A,e.$Qb=o,e.$Rb=D,e.$Sb=O,e.$Tb=$,e.$Ub=g,e.$Vb=K,e.$Wb=re,e.$Xb=ee,e.$Yb=X,e.$Zb=se,e.$1b=Y,e.$2b=te,e.$3b=ue,e.$4b=ce,e.$5b=L,e.$6b=q,e.$7b=Q,e.$0b=Z;function j(p,W=0){return p[p.length-(1+W)]}function M(p){if(p.length===0)throw new Error("Invalid tail call");return[p.slice(0,p.length-1),p[p.length-1]]}function V(p,W,G=(B,b)=>B===b){if(p===W)return!0;if(!p||!W||p.length!==W.length)return!1;for(let B=0,b=p.length;B<b;B++)if(!G(p[B],W[B]))return!1;return!0}function N(p,W){const G=p.length-1;W<G&&(p[W]=p[G]),p.pop()}function U(p,W,G){return S(p.length,B=>G(p[B],W))}function S(p,W){let G=0,B=p-1;for(;G<=B;){const b=(G+B)/2|0,H=W(b);if(H<0)G=b+1;else if(H>0)B=b-1;else return b}return-(G+1)}function k(p,W,G){if(p=p|0,p>=W.length)throw new TypeError("invalid index");const B=W[Math.floor(W.length*Math.random())],b=[],H=[],J=[];for(const ne of W){const ge=G(ne,B);ge<0?b.push(ne):ge>0?H.push(ne):J.push(ne)}return p<b.length?k(p,b,G):p<b.length+J.length?J[0]:k(p-(b.length+J.length),H,G)}function w(p,W){const G=[];let B;for(const b of p.slice(0).sort(W))!B||W(B[0],b)!==0?(B=[b],G.push(B)):B.push(b);return G}function*I(p,W){let G,B;for(const b of p)B!==void 0&&W(B,b)?G.push(b):(G&&(yield G),G=[b]),B=b;G&&(yield G)}function F(p,W){for(let G=0;G<=p.length;G++)W(G===0?void 0:p[G-1],G===p.length?void 0:p[G])}function c(p,W){for(let G=0;G<p.length;G++)W(G===0?void 0:p[G-1],p[G],G+1===p.length?void 0:p[G+1])}function r(p,W,G){const B=[];function b(ne,ge,De){if(ge===0&&De.length===0)return;const he=B[B.length-1];he&&he.start+he.deleteCount===ne?(he.deleteCount+=ge,he.toInsert.push(...De)):B.push({start:ne,deleteCount:ge,toInsert:De})}let H=0,J=0;for(;;){if(H===p.length){b(H,0,W.slice(J));break}if(J===W.length){b(H,p.length-H,[]);break}const ne=p[H],ge=W[J],De=G(ne,ge);De===0?(H+=1,J+=1):De<0?(b(H,1,[]),H+=1):De>0&&(b(H,0,[ge]),J+=1)}return B}function d(p,W,G){const B=r(p,W,G),b=[],H=[];for(const J of B)b.push(...p.slice(J.start,J.start+J.deleteCount)),H.push(...J.toInsert);return{removed:b,added:H}}function m(p,W,G){if(G===0)return[];const B=p.slice(0,G).sort(W);return _(p,W,B,G,p.length),B}function l(p,W,G,B,b){return G===0?Promise.resolve([]):new Promise((H,J)=>{(async()=>{const ne=p.length,ge=p.slice(0,G).sort(W);for(let De=G,he=Math.min(G+B,ne);De<ne;De=he,he=Math.min(he+B,ne)){if(De>G&&await new Promise(fe=>setTimeout(fe)),b&&b.isCancellationRequested)throw new E.$5;_(p,W,ge,De,he)}return ge})().then(H,J)})}function _(p,W,G,B,b){for(const H=G.length;B<b;B++){const J=p[B];if(W(J,G[H-1])<0){G.pop();const ne=(0,t.$kb)(G,ge=>W(J,ge)<0);G.splice(ne,0,J)}}}function y(p){return p.filter(W=>!!W)}function s(p){let W=0;for(let G=0;G<p.length;G++)p[G]&&(p[W]=p[G],W+=1);p.length=W}function n(p,W,G){p.splice(G,0,p.splice(W,1)[0])}function i(p){return!Array.isArray(p)||p.length===0}function f(p){return Array.isArray(p)&&p.length>0}function u(p,W=G=>G){const G=new Set;return p.filter(B=>{const b=W(B);return G.has(b)?!1:(G.add(b),!0)})}function P(p){const W=new Set;return G=>{const B=p(G);return W.has(B)?!1:(W.add(B),!0)}}function h(p,W){return p.length>0?p[0]:W}function A(p,W){return p.length>0?p[p.length-1]:W}function o(p,W,G=(B,b)=>B===b){let B=0;for(let b=0,H=Math.min(p.length,W.length);b<H&&G(p[b],W[b]);b++)B++;return B}function D(p,W){let G=typeof W=="number"?p:0;typeof W=="number"?G=p:(G=0,W=p);const B=[];if(G<=W)for(let b=G;b<W;b++)B.push(b);else for(let b=G;b>W;b--)B.push(b);return B}function O(p,W,G){return p.reduce((B,b)=>(B[W(b)]=G?G(b):b,B),Object.create(null))}function $(p,W){return p.push(W),()=>g(p,W)}function g(p,W){const G=p.indexOf(W);if(G>-1)return p.splice(G,1),W}function K(p,W,G){const B=p.slice(0,W),b=p.slice(W);return B.concat(G,b)}function re(p,W){let G;if(typeof W=="number"){let B=W;G=()=>{const b=Math.sin(B++)*179426549;return b-Math.floor(b)}}else G=Math.random;for(let B=p.length-1;B>0;B-=1){const b=Math.floor(G()*(B+1)),H=p[B];p[B]=p[b],p[b]=H}}function ee(p,W){const G=p.indexOf(W);G>-1&&(p.splice(G,1),p.unshift(W))}function X(p,W){const G=p.indexOf(W);G>-1&&(p.splice(G,1),p.push(W))}function se(p,W){for(const G of W)p.push(G)}function Y(p,W){return Array.isArray(p)?p.map(W):W(p)}function te(p){return Array.isArray(p)?p:[p]}function ue(p){return p[Math.floor(Math.random()*p.length)]}function ce(p,W,G){const B=a(p,W),b=p.length,H=G.length;p.length=b+H;for(let J=b-1;J>=B;J--)p[J+H]=p[J];for(let J=0;J<H;J++)p[J+B]=G[J]}function L(p,W,G,B){const b=a(p,W);let H=p.splice(b,G);return H===void 0&&(H=[]),ce(p,b,B),H}function a(p,W){return W<0?Math.max(W+p.length,0):Math.min(W,p.length)}var T;(function(p){function W(H){return H<0}p.isLessThan=W;function G(H){return H<=0}p.isLessThanOrEqual=G;function B(H){return H>0}p.isGreaterThan=B;function b(H){return H===0}p.isNeitherLessOrGreaterThan=b,p.greaterThan=1,p.lessThan=-1,p.neitherLessOrGreaterThan=0})(T||(e.CompareResult=T={}));function q(p,W){return(G,B)=>W(p(G),p(B))}function Q(...p){return(W,G)=>{for(const B of p){const b=B(W,G);if(!T.isNeitherLessOrGreaterThan(b))return b}return T.neitherLessOrGreaterThan}}const v=(p,W)=>p-W;e.$8b=v;const C=(p,W)=>(0,e.$8b)(p?1:0,W?1:0);e.$9b=C;function Z(p){return(W,G)=>-p(W,G)}class ie{constructor(W){this.g=W,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(W){let G=this.c;for(;G<this.g.length&&W(this.g[G]);)G++;const B=G===this.c?null:this.g.slice(this.c,G);return this.c=G,B}takeFromEndWhile(W){let G=this.d;for(;G>=0&&W(this.g[G]);)G--;const B=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const W=this.g[this.c];return this.c++,W}removeLast(){const W=this.g[this.d];return this.d--,W}takeCount(W){const G=this.g.slice(this.c,this.c+W);return this.c+=W,G}}e.$$b=ie;class le{constructor(W){this.iterate=W}forEach(W){this.iterate(G=>(W(G),!0))}toArray(){const W=[];return this.iterate(G=>(W.push(G),!0)),W}filter(W){return new le(G=>this.iterate(B=>W(B)?G(B):!0))}map(W){return new le(G=>this.iterate(B=>G(W(B))))}some(W){let G=!1;return this.iterate(B=>(G=W(B),!G)),G}findFirst(W){let G;return this.iterate(B=>W(B)?(G=B,!1):!0),G}findLast(W){let G;return this.iterate(B=>(W(B)&&(G=B),!0)),G}findLastMaxBy(W){let G,B=!0;return this.iterate(b=>((B||T.isGreaterThan(W(b,G)))&&(B=!1,G=b),!0)),G}}e.$_b=le,le.empty=new le(p=>{});class ae{constructor(W){this.c=W}static createSortPermutation(W,G){const B=Array.from(W.keys()).sort((b,H)=>G(W[b],W[H]));return new ae(B)}apply(W){return W.map((G,B)=>W[this.c[B]])}inverse(){const W=this.c.slice();for(let G=0;G<this.c.length;G++)W[this.c[G]]=G;return new ae(W)}}e.$ac=ae}),define(Ee[26],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=E;function E(t,j){const M=this;let V=!1,N;return function(){if(V)return N;if(V=!0,j)try{N=t.apply(M,arguments)}finally{j()}else N=t.apply(M,arguments);return N}}}),define(Ee[39],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(t){function j(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=j;const M=Object.freeze([]);function V(){return M}t.empty=V;function*N(n){yield n}t.single=N;function U(n){return j(n)?n:N(n)}t.wrap=U;function S(n){return n||M}t.from=S;function*k(n){for(let i=n.length-1;i>=0;i--)yield n[i]}t.reverse=k;function w(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=w;function I(n){return n[Symbol.iterator]().next().value}t.first=I;function F(n,i){for(const f of n)if(i(f))return!0;return!1}t.some=F;function c(n,i){for(const f of n)if(i(f))return f}t.find=c;function*r(n,i){for(const f of n)i(f)&&(yield f)}t.filter=r;function*d(n,i){let f=0;for(const u of n)yield i(u,f++)}t.map=d;function*m(...n){for(const i of n)yield*i}t.concat=m;function l(n,i,f){let u=f;for(const P of n)u=i(u,P);return u}t.reduce=l;function*_(n,i,f=n.length){for(i<0&&(i+=n.length),f<0?f+=n.length:f>n.length&&(f=n.length);i<f;i++)yield n[i]}t.slice=_;function y(n,i=Number.POSITIVE_INFINITY){const f=[];if(i===0)return[f,n];const u=n[Symbol.iterator]();for(let P=0;P<i;P++){const h=u.next();if(h.done)return[f,t.empty()];f.push(h.value)}return[f,{[Symbol.iterator](){return u}}]}t.consume=y;async function s(n){const i=[];for await(const f of n)i.push(f);return Promise.resolve(i)}t.asyncToArray=s})(E||(e.Iterable=E={}))}),define(Ee[15],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class E{constructor(j){this.d=j,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(j){this.c=j}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=E}),define(Ee[40],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class E{constructor(M){this.element=M,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let M=this.a;for(;M!==E.Undefined;){const V=M.next;M.prev=E.Undefined,M.next=E.Undefined,M=V}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,V){const N=new E(M);if(this.a===E.Undefined)this.a=N,this.b=N;else if(V){const S=this.b;this.b=N,N.prev=S,S.next=N}else{const S=this.a;this.a=N,N.next=S,S.prev=N}this.c+=1;let U=!1;return()=>{U||(U=!0,this.e(N))}}shift(){if(this.a!==E.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==E.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==E.Undefined&&M.next!==E.Undefined){const V=M.prev;V.next=M.next,M.next.prev=V}else M.prev===E.Undefined&&M.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):M.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):M.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==E.Undefined;)yield M.element,M=M.next}}e.$5c=t}),define(Ee[20],_e([0,1]),function($e,e){"use strict";var E,t,j;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=M,e.$yc=V,e.$zc=N,e.$Ic=y;function M(s,n,i){let f=s.get(n);return f===void 0&&(f=i,s.set(n,f)),f}function V(s){const n=[];return s.forEach((i,f)=>{n.push(`${f} => ${i}`)}),`Map(${s.size}) {${n.join(", ")}}`}function N(s){const n=[];return s.forEach(i=>{n.push(i)}),`Set(${s.size}) {${n.join(", ")}}`}class U{constructor(n,i){this.uri=n,this.value=i}}function S(s){return Array.isArray(s)}class k{constructor(n,i){if(this[E]="ResourceMap",n instanceof k)this.d=new Map(n.d),this.e=i??k.c;else if(S(n)){this.d=new Map,this.e=i??k.c;for(const[f,u]of n)this.set(f,u)}else this.d=new Map,this.e=n??k.c}set(n,i){return this.d.set(this.e(n),new U(n,i)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[f,u]of this.d)n(u.value,u.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=k,k.c=s=>s.toString();class w{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new k(n):(this.c=new k(i),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,i){this.c.forEach((f,u)=>n.call(i,u,u,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=w;var I;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(I||(e.Touch=I={}));class F{constructor(){this[j]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,i=I.None){const f=this.c.get(n);if(f)return i!==I.None&&this.m(f,i),f.value}set(n,i,f=I.None){let u=this.c.get(n);if(u)u.value=i,f!==I.None&&this.m(u,f);else{switch(u={key:n,value:i,next:void 0,previous:void 0},f){case I.None:this.k(u);break;case I.AsOld:this.j(u);break;case I.AsNew:this.k(u);break;default:this.k(u);break}this.c.set(n,u),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this.c.get(n);if(i)return this.c.delete(n),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,i){const f=this.g;let u=this.d;for(;u;){if(i?n.bind(i)(u.value,u.key,this):n(u.value,u.key,this),this.g!==f)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,i=this.g;let f=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(f){const P={value:f.key,done:!1};return f=f.next,P}else return{value:void 0,done:!0}}};return u}values(){const n=this,i=this.g;let f=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(f){const P={value:f.value,done:!1};return f=f.next,P}else return{value:void 0,done:!0}}};return u}entries(){const n=this,i=this.g;let f=this.d;const u={[Symbol.iterator](){return u},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(f){const P={value:[f.key,f.value],done:!1};return f=f.next,P}else return{value:void 0,done:!0}}};return u}[(j=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.d,f=this.size;for(;i&&f>n;)this.c.delete(i.key),i=i.next,f--;this.d=i,this.f=f,i&&(i.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.e,f=this.size;for(;i&&f>n;)this.c.delete(i.key),i=i.previous,f--;this.e=i,this.f=f,i&&(i.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const i=n.next,f=n.previous;if(!i||!f)throw new Error("Invalid list");i.previous=f,f.next=i}n.next=void 0,n.previous=void 0,this.g++}m(n,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==I.AsOld&&i!==I.AsNew)){if(i===I.AsOld){if(n===this.d)return;const f=n.next,u=n.previous;n===this.e?(u.next=void 0,this.e=u):(f.previous=u,u.next=f),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(i===I.AsNew){if(n===this.e)return;const f=n.next,u=n.previous;n===this.d?(f.previous=void 0,this.d=f):(f.previous=u,u.next=f),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((i,f)=>{n.push([f,i])}),n}fromJSON(n){this.clear();for(const[i,f]of n)this.set(i,f)}}e.$Cc=F;class c extends F{constructor(n,i=1){super(),this.n=n,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,i=I.AsNew){return super.get(n,i)}peek(n){return super.get(n,I.None)}set(n,i){return super.set(n,i,I.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class r extends c{constructor(n,i=1){super(n,i)}q(n){this.h(n)}set(n,i){return super.set(n,i),this.p(),this}}e.$Dc=r;class d extends c{constructor(n,i=1){super(n,i)}q(n){this.i(n)}set(n,i){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,i),this}}e.$Ec=d;class m{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let i=this.c.get(n)||0;return i===0?!1:(i--,i===0?this.c.delete(n):this.c.set(n,i),!0)}has(n){return this.c.has(n)}}e.$Fc=m;class l{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[i,f]of n)this.set(i,f)}clear(){this.c.clear(),this.d.clear()}set(n,i){this.c.set(n,i),this.d.set(i,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const i=this.c.get(n);return i===void 0?!1:(this.c.delete(n),this.d.delete(i),!0)}forEach(n,i){this.c.forEach((f,u)=>{n.call(i,f,u,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=l;class _{constructor(){this.c=new Map}add(n,i){let f=this.c.get(n);f||(f=new Set,this.c.set(n,f)),f.add(i)}delete(n,i){const f=this.c.get(n);f&&(f.delete(i),f.size===0&&this.c.delete(n))}forEach(n,i){const f=this.c.get(n);f&&f.forEach(i)}get(n){const i=this.c.get(n);return i||new Set}}e.$Hc=_;function y(s,n){if(s===n)return!0;if(s.size!==n.size)return!1;for(const[i,f]of s)if(!n.has(i)||n.get(i)!==f)return!1;for(const[i]of n)if(!s.has(i))return!1;return!0}}),define(Ee[4],_e([0,1,12,37,20,26,39]),function($e,e,E,t,j,M,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=k,e.$Lc=w,e.$Mc=I,e.$Nc=r,e.$Oc=d,e.$Pc=m,e.$Qc=l,e.$Rc=_,e.$Sc=y,e.$3c=D;const N=!1;let U=null;class S{constructor(){this.b=new Map}c(g){let K=this.b.get(g);return K||(K={parent:null,source:null,isSingleton:!1,value:g,idx:S.a++},this.b.set(g,K)),K}trackDisposable(g){const K=this.c(g);K.source||(K.source=new Error().stack)}setParent(g,K){const re=this.c(g);re.parent=K}markAsDisposed(g){this.b.delete(g)}markAsSingleton(g){this.c(g).isSingleton=!0}f(g,K){const re=K.get(g);if(re)return re;const ee=g.parent?this.f(this.c(g.parent),K):g;return K.set(g,ee),ee}getTrackedDisposables(){const g=new Map;return[...this.b.entries()].filter(([,re])=>re.source!==null&&!this.f(re,g).isSingleton).flatMap(([re])=>re)}computeLeakingDisposables(g=10,K){let re;if(K)re=K;else{const te=new Map,ue=[...this.b.values()].filter(L=>L.source!==null&&!this.f(L,te).isSingleton);if(ue.length===0)return;const ce=new Set(ue.map(L=>L.value));if(re=ue.filter(L=>!(L.parent&&ce.has(L.parent))),re.length===0)throw new Error("There are cyclic diposable chains!")}if(!re)return;function ee(te){function ue(L,a){for(;L.length>0&&a.some(T=>typeof T=="string"?T===L[0]:L[0].match(T));)L.shift()}const ce=te.source.split(`
`).map(L=>L.trim().replace("at ","")).filter(L=>L!=="");return ue(ce,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ce.reverse()}const X=new j.$Hc;for(const te of re){const ue=ee(te);for(let ce=0;ce<=ue.length;ce++)X.add(ue.slice(0,ce).join(`
`),te)}re.sort((0,E.$6b)(te=>te.idx,E.$8b));let se="",Y=0;for(const te of re.slice(0,g)){Y++;const ue=ee(te),ce=[];for(let L=0;L<ue.length;L++){let a=ue[L];a=`(shared with ${X.get(ue.slice(0,L+1).join(`
`)).size}/${re.length} leaks) at ${a}`;const q=X.get(ue.slice(0,L).join(`
`)),Q=(0,t.$E)([...q].map(v=>ee(v)[L]),v=>v);delete Q[ue[L]];for(const[v,C]of Object.entries(Q))ce.unshift(`    - stacktraces of ${C.length} other leaks continue with ${v}`);ce.unshift(a)}se+=`


==================== Leaking disposable ${Y}/${re.length}: ${te.value.constructor.name} ====================
${ce.join(`
`)}
============================================================

`}return re.length>g&&(se+=`


... and ${re.length-g} more leaking disposables

`),{leaks:re,details:se}}}e.$Jc=S,S.a=0;function k($){U=$}if(N){const $="__is_disposable_tracked__";k(new class{trackDisposable(g){const K=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[$]||console.log(K)},3e3)}setParent(g,K){if(g&&g!==n.None)try{g[$]=!0}catch{}}markAsDisposed(g){if(g&&g!==n.None)try{g[$]=!0}catch{}}markAsSingleton(g){}})}function w($){return U?.trackDisposable($),$}function I($){U?.markAsDisposed($)}function F($,g){U?.setParent($,g)}function c($,g){if(U)for(const K of $)U.setParent(K,g)}function r($){return U?.markAsSingleton($),$}function d($){return typeof $=="object"&&$!==null&&typeof $.dispose=="function"&&$.dispose.length===0}function m($){if(V.Iterable.is($)){const g=[];for(const K of $)if(K)try{K.dispose()}catch(re){g.push(re)}if(g.length===1)throw g[0];if(g.length>1)throw new AggregateError(g,"Encountered errors while disposing of store");return Array.isArray($)?[]:$}else if($)return $.dispose(),$}function l($){for(const g of $)d(g)&&g.dispose();return[]}function _(...$){const g=y(()=>m($));return c($,g),g}function y($){const g=w({dispose:(0,M.$db)(()=>{I(g),$()})});return g}class s{constructor(){this.f=new Set,this.g=!1,w(this)}dispose(){this.g||(I(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return F(g,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(g),g}delete(g){if(g){if(g===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(g),g.dispose()}}deleteAndLeak(g){g&&this.f.has(g)&&(this.f.delete(g),F(g,null))}}e.$Tc=s,s.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this.q=new s,w(this),F(this.q,this)}dispose(){I(this),this.q.dispose()}B(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(g)}}e.$Uc=n,n.None=Object.freeze({dispose(){}});class i{constructor(){this.b=!1,w(this)}get value(){return this.b?void 0:this.a}set value(g){this.b||g===this.a||(this.a?.dispose(),g&&F(g,this),this.a=g)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const g=this.a;return this.a=void 0,g&&F(g,null),g}}e.$Vc=i;class f{constructor(g){this.a=new i,this.b=!1,this.a.value=g}get value(){return this.a.value}set value(g){this.b||g===this.a.value||(this.a.value=g)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=f;class u{constructor(g){this.b=g,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=u;class P{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(g){let K=g;return this.unset=()=>K=void 0,this.isset=()=>K!==void 0,this.dispose=()=>{K&&(K(),K=void 0,I(this))},this}}e.$Yc=P;class h{constructor(){this.a=new Map}acquire(g,...K){let re=this.a.get(g);re||(re={counter:0,object:this.b(g,...K)},this.a.set(g,re));const{object:ee}=re,X=(0,M.$db)(()=>{--re.counter===0&&(this.c(g,re.object),this.a.delete(g))});return re.counter++,{object:ee,dispose:X}}}e.$Zc=h;class A{constructor(g){this.a=g}async acquire(g,...K){const re=this.a.acquire(g,...K);try{return{object:await re.object,dispose:()=>re.dispose()}}catch(ee){throw re.dispose(),ee}}}e.$1c=A;class o{constructor(g){this.object=g}dispose(){}}e.$2c=o;function D($){const g=new s;try{$(g)}finally{g.dispose()}}class O{constructor(){this.a=new Map,this.b=!1,w(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(g){return this.a.has(g)}get size(){return this.a.size}get(g){return this.a.get(g)}set(g,K,re=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),re||this.a.get(g)?.dispose(),this.a.set(g,K)}deleteAndDispose(g){this.a.get(g)?.dispose(),this.a.delete(g)}deleteAndLeak(g){const K=this.a.get(g);return this.a.delete(g),K}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=O}),define(Ee[27],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var E;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(E||(e.MarshalledId=E={}))}),define(Ee[21],_e([0,1,20]),function($e,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=void 0,e.$hm=j,e.$im=V;const t=new E.$Dc(1e4);function j(S){return U(S,"NFC",t)}const M=new E.$Dc(1e4);function V(S){return U(S,"NFD",M)}const N=/[^\u0000-\u0080]/;function U(S,k,w){if(!S)return S;const I=w.get(S);if(I)return I;let F;return N.test(S)?F=S.normalize(k):F=S,w.set(S,F),F}e.$jm=function(){const S=/[\u0300-\u036f]/g;return function(k){return V(k).replace(S,"")}}()}),define(Ee[2],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=n,e.$x=A,e.$D=o,e.$a="en";let E=!1,t=!1,j=!1,M=!1,V=!1,N=!1,U=!1,S=!1,k=!1,w=!1,I,F=e.$a,c=e.$a,r,d;const m=globalThis;let l;typeof m.vscode<"u"&&typeof m.vscode.process<"u"?l=m.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(l=process);const _=typeof l?.versions?.electron=="string",y=_&&l?.type==="renderer";if(typeof l=="object"){E=l.platform==="win32",t=l.platform==="darwin",j=l.platform==="linux",M=j&&!!l.env.SNAP&&!!l.env.SNAP_REVISION,U=_,k=!!l.env.CI||!!l.env.BUILD_ARTIFACTSTAGINGDIRECTORY,I=e.$a,F=e.$a;const D=l.env.VSCODE_NLS_CONFIG;if(D)try{const O=JSON.parse(D),$=O.availableLanguages["*"];I=O.locale,c=O.osLocale,F=$||e.$a,r=O._translationsConfigFile}catch{}V=!0}else if(typeof navigator=="object"&&!y){d=navigator.userAgent,E=d.indexOf("Windows")>=0,t=d.indexOf("Macintosh")>=0,S=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=d.indexOf("Linux")>=0,w=d?.indexOf("Mobi")>=0,N=!0,I=e.$a,F=I,c=navigator.language;const D=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),O=D&&D.getAttribute("data-settings");if(O)try{const $=JSON.parse(O),g=$.availableLanguages["*"];I=$.locale,c=$.osLocale,F=g||e.$a,r=$._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var s;(function(D){D[D.Web=0]="Web",D[D.Mac=1]="Mac",D[D.Linux=2]="Linux",D[D.Windows=3]="Windows"})(s||(e.Platform=s={}));function n(D){switch(D){case s.Web:return"Web";case s.Mac:return"Mac";case s.Linux:return"Linux";case s.Windows:return"Windows"}}let i=s.Web;t?i=s.Mac:E?i=s.Windows:j&&(i=s.Linux),e.$c=E,e.$d=t,e.$e=j,e.$f=M,e.$g=V,e.$h=U,e.$i=N,e.$j=N&&typeof m.importScripts=="function",e.$k=e.$j?m.origin:void 0,e.$l=S,e.$m=w,e.$n=k,e.$o=i,e.$p=d,e.$q=F;var f;(function(D){function O(){return e.$q}D.value=O;function $(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}D.isDefaultVariant=$;function g(){return e.$q==="en"}D.isDefault=g})(f||(e.Language=f={})),e.$r=I,e.$s=c,e.$t=r,e.$u=typeof m.postMessage=="function"&&!m.importScripts,e.$v=(()=>{if(e.$u){const D=[];m.addEventListener("message",$=>{if($.data&&$.data.vscodeScheduleAsyncWork)for(let g=0,K=D.length;g<K;g++){const re=D[g];if(re.id===$.data.vscodeScheduleAsyncWork){D.splice(g,1),re.callback();return}}});let O=0;return $=>{const g=++O;D.push({id:g,callback:$}),m.postMessage({vscodeScheduleAsyncWork:g},"*")}}return D=>setTimeout(D)})();var u;(function(D){D[D.Windows=1]="Windows",D[D.Macintosh=2]="Macintosh",D[D.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=t||S?u.Macintosh:E?u.Windows:u.Linux;let P=!0,h=!1;function A(){if(!h){h=!0;const D=new Uint8Array(2);D[0]=1,D[1]=2,P=new Uint16Array(D.buffer)[0]===513}return P}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function o(D){return parseFloat(D)>=20}}),define(Ee[28],_e([0,1,2]),function($e,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let t;const j=globalThis.vscode;if(typeof j<"u"&&typeof j.process<"u"){const M=j.process;t={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.$c?"win32":E.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$dc=t.platform,e.$ec=t.arch}),define(Ee[3],_e([0,1,28]),function($e,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const t=65,j=97,M=90,V=122,N=46,U=47,S=92,k=58,w=63;class I extends Error{constructor(i,f,u){let P;typeof f=="string"&&f.indexOf("not ")===0?(P="must not be",f=f.replace(/^not /,"")):P="must be";const h=i.indexOf(".")!==-1?"property":"argument";let A=`The "${i}" ${h} ${P} of type ${f}`;A+=`. Received type ${typeof u}`,super(A),this.code="ERR_INVALID_ARG_TYPE"}}function F(n,i){if(n===null||typeof n!="object")throw new I(i,"Object",n)}function c(n,i){if(typeof n!="string")throw new I(i,"string",n)}const r=E.$dc==="win32";function d(n){return n===U||n===S}function m(n){return n===U}function l(n){return n>=t&&n<=M||n>=j&&n<=V}function _(n,i,f,u){let P="",h=0,A=-1,o=0,D=0;for(let O=0;O<=n.length;++O){if(O<n.length)D=n.charCodeAt(O);else{if(u(D))break;D=U}if(u(D)){if(!(A===O-1||o===1))if(o===2){if(P.length<2||h!==2||P.charCodeAt(P.length-1)!==N||P.charCodeAt(P.length-2)!==N){if(P.length>2){const $=P.lastIndexOf(f);$===-1?(P="",h=0):(P=P.slice(0,$),h=P.length-1-P.lastIndexOf(f)),A=O,o=0;continue}else if(P.length!==0){P="",h=0,A=O,o=0;continue}}i&&(P+=P.length>0?`${f}..`:"..",h=2)}else P.length>0?P+=`${f}${n.slice(A+1,O)}`:P=n.slice(A+1,O),h=O-A-1;A=O,o=0}else D===N&&o!==-1?++o:o=-1}return P}function y(n,i){F(i,"pathObject");const f=i.dir||i.root,u=i.base||`${i.name||""}${i.ext||""}`;return f?f===i.root?`${f}${u}`:`${f}${n}${u}`:u}e.$fc={resolve(...n){let i="",f="",u=!1;for(let P=n.length-1;P>=-1;P--){let h;if(P>=0){if(h=n[P],c(h,"path"),h.length===0)continue}else i.length===0?h=E.cwd():(h=E.env[`=${i}`]||E.cwd(),(h===void 0||h.slice(0,2).toLowerCase()!==i.toLowerCase()&&h.charCodeAt(2)===S)&&(h=`${i}\\`));const A=h.length;let o=0,D="",O=!1;const $=h.charCodeAt(0);if(A===1)d($)&&(o=1,O=!0);else if(d($))if(O=!0,d(h.charCodeAt(1))){let g=2,K=g;for(;g<A&&!d(h.charCodeAt(g));)g++;if(g<A&&g!==K){const re=h.slice(K,g);for(K=g;g<A&&d(h.charCodeAt(g));)g++;if(g<A&&g!==K){for(K=g;g<A&&!d(h.charCodeAt(g));)g++;(g===A||g!==K)&&(D=`\\\\${re}\\${h.slice(K,g)}`,o=g)}}}else o=1;else l($)&&h.charCodeAt(1)===k&&(D=h.slice(0,2),o=2,A>2&&d(h.charCodeAt(2))&&(O=!0,o=3));if(D.length>0)if(i.length>0){if(D.toLowerCase()!==i.toLowerCase())continue}else i=D;if(u){if(i.length>0)break}else if(f=`${h.slice(o)}\\${f}`,u=O,O&&i.length>0)break}return f=_(f,!u,"\\",d),u?`${i}\\${f}`:`${i}${f}`||"."},normalize(n){c(n,"path");const i=n.length;if(i===0)return".";let f=0,u,P=!1;const h=n.charCodeAt(0);if(i===1)return m(h)?"\\":n;if(d(h))if(P=!0,d(n.charCodeAt(1))){let o=2,D=o;for(;o<i&&!d(n.charCodeAt(o));)o++;if(o<i&&o!==D){const O=n.slice(D,o);for(D=o;o<i&&d(n.charCodeAt(o));)o++;if(o<i&&o!==D){for(D=o;o<i&&!d(n.charCodeAt(o));)o++;if(o===i)return`\\\\${O}\\${n.slice(D)}\\`;o!==D&&(u=`\\\\${O}\\${n.slice(D,o)}`,f=o)}}}else f=1;else l(h)&&n.charCodeAt(1)===k&&(u=n.slice(0,2),f=2,i>2&&d(n.charCodeAt(2))&&(P=!0,f=3));let A=f<i?_(n.slice(f),!P,"\\",d):"";return A.length===0&&!P&&(A="."),A.length>0&&d(n.charCodeAt(i-1))&&(A+="\\"),u===void 0?P?`\\${A}`:A:P?`${u}\\${A}`:`${u}${A}`},isAbsolute(n){c(n,"path");const i=n.length;if(i===0)return!1;const f=n.charCodeAt(0);return d(f)||i>2&&l(f)&&n.charCodeAt(1)===k&&d(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,f;for(let h=0;h<n.length;++h){const A=n[h];c(A,"path"),A.length>0&&(i===void 0?i=f=A:i+=`\\${A}`)}if(i===void 0)return".";let u=!0,P=0;if(typeof f=="string"&&d(f.charCodeAt(0))){++P;const h=f.length;h>1&&d(f.charCodeAt(1))&&(++P,h>2&&(d(f.charCodeAt(2))?++P:u=!1))}if(u){for(;P<i.length&&d(i.charCodeAt(P));)P++;P>=2&&(i=`\\${i.slice(P)}`)}return e.$fc.normalize(i)},relative(n,i){if(c(n,"from"),c(i,"to"),n===i)return"";const f=e.$fc.resolve(n),u=e.$fc.resolve(i);if(f===u||(n=f.toLowerCase(),i=u.toLowerCase(),n===i))return"";let P=0;for(;P<n.length&&n.charCodeAt(P)===S;)P++;let h=n.length;for(;h-1>P&&n.charCodeAt(h-1)===S;)h--;const A=h-P;let o=0;for(;o<i.length&&i.charCodeAt(o)===S;)o++;let D=i.length;for(;D-1>o&&i.charCodeAt(D-1)===S;)D--;const O=D-o,$=A<O?A:O;let g=-1,K=0;for(;K<$;K++){const ee=n.charCodeAt(P+K);if(ee!==i.charCodeAt(o+K))break;ee===S&&(g=K)}if(K!==$){if(g===-1)return u}else{if(O>$){if(i.charCodeAt(o+K)===S)return u.slice(o+K+1);if(K===2)return u.slice(o+K)}A>$&&(n.charCodeAt(P+K)===S?g=K:K===2&&(g=3)),g===-1&&(g=0)}let re="";for(K=P+g+1;K<=h;++K)(K===h||n.charCodeAt(K)===S)&&(re+=re.length===0?"..":"\\..");return o+=g,re.length>0?`${re}${u.slice(o,D)}`:(u.charCodeAt(o)===S&&++o,u.slice(o,D))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$fc.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===S){if(i.charCodeAt(1)===S){const f=i.charCodeAt(2);if(f!==w&&f!==N)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(l(i.charCodeAt(0))&&i.charCodeAt(1)===k&&i.charCodeAt(2)===S)return`\\\\?\\${i}`;return n},dirname(n){c(n,"path");const i=n.length;if(i===0)return".";let f=-1,u=0;const P=n.charCodeAt(0);if(i===1)return d(P)?n:".";if(d(P)){if(f=u=1,d(n.charCodeAt(1))){let o=2,D=o;for(;o<i&&!d(n.charCodeAt(o));)o++;if(o<i&&o!==D){for(D=o;o<i&&d(n.charCodeAt(o));)o++;if(o<i&&o!==D){for(D=o;o<i&&!d(n.charCodeAt(o));)o++;if(o===i)return n;o!==D&&(f=u=o+1)}}}}else l(P)&&n.charCodeAt(1)===k&&(f=i>2&&d(n.charCodeAt(2))?3:2,u=f);let h=-1,A=!0;for(let o=i-1;o>=u;--o)if(d(n.charCodeAt(o))){if(!A){h=o;break}}else A=!1;if(h===-1){if(f===-1)return".";h=f}return n.slice(0,h)},basename(n,i){i!==void 0&&c(i,"ext"),c(n,"path");let f=0,u=-1,P=!0,h;if(n.length>=2&&l(n.charCodeAt(0))&&n.charCodeAt(1)===k&&(f=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let A=i.length-1,o=-1;for(h=n.length-1;h>=f;--h){const D=n.charCodeAt(h);if(d(D)){if(!P){f=h+1;break}}else o===-1&&(P=!1,o=h+1),A>=0&&(D===i.charCodeAt(A)?--A===-1&&(u=h):(A=-1,u=o))}return f===u?u=o:u===-1&&(u=n.length),n.slice(f,u)}for(h=n.length-1;h>=f;--h)if(d(n.charCodeAt(h))){if(!P){f=h+1;break}}else u===-1&&(P=!1,u=h+1);return u===-1?"":n.slice(f,u)},extname(n){c(n,"path");let i=0,f=-1,u=0,P=-1,h=!0,A=0;n.length>=2&&n.charCodeAt(1)===k&&l(n.charCodeAt(0))&&(i=u=2);for(let o=n.length-1;o>=i;--o){const D=n.charCodeAt(o);if(d(D)){if(!h){u=o+1;break}continue}P===-1&&(h=!1,P=o+1),D===N?f===-1?f=o:A!==1&&(A=1):f!==-1&&(A=-1)}return f===-1||P===-1||A===0||A===1&&f===P-1&&f===u+1?"":n.slice(f,P)},format:y.bind(null,"\\"),parse(n){c(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const f=n.length;let u=0,P=n.charCodeAt(0);if(f===1)return d(P)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(d(P)){if(u=1,d(n.charCodeAt(1))){let g=2,K=g;for(;g<f&&!d(n.charCodeAt(g));)g++;if(g<f&&g!==K){for(K=g;g<f&&d(n.charCodeAt(g));)g++;if(g<f&&g!==K){for(K=g;g<f&&!d(n.charCodeAt(g));)g++;g===f?u=g:g!==K&&(u=g+1)}}}}else if(l(P)&&n.charCodeAt(1)===k){if(f<=2)return i.root=i.dir=n,i;if(u=2,d(n.charCodeAt(2))){if(f===3)return i.root=i.dir=n,i;u=3}}u>0&&(i.root=n.slice(0,u));let h=-1,A=u,o=-1,D=!0,O=n.length-1,$=0;for(;O>=u;--O){if(P=n.charCodeAt(O),d(P)){if(!D){A=O+1;break}continue}o===-1&&(D=!1,o=O+1),P===N?h===-1?h=O:$!==1&&($=1):h!==-1&&($=-1)}return o!==-1&&(h===-1||$===0||$===1&&h===o-1&&h===A+1?i.base=i.name=n.slice(A,o):(i.name=n.slice(A,h),i.base=n.slice(A,o),i.ext=n.slice(h,o))),A>0&&A!==u?i.dir=n.slice(0,A-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const s=(()=>{if(r){const n=/\\/g;return()=>{const i=E.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>E.cwd()})();e.$gc={resolve(...n){let i="",f=!1;for(let u=n.length-1;u>=-1&&!f;u--){const P=u>=0?n[u]:s();c(P,"path"),P.length!==0&&(i=`${P}/${i}`,f=P.charCodeAt(0)===U)}return i=_(i,!f,"/",m),f?`/${i}`:i.length>0?i:"."},normalize(n){if(c(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===U,f=n.charCodeAt(n.length-1)===U;return n=_(n,!i,"/",m),n.length===0?i?"/":f?"./":".":(f&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return c(n,"path"),n.length>0&&n.charCodeAt(0)===U},join(...n){if(n.length===0)return".";let i;for(let f=0;f<n.length;++f){const u=n[f];c(u,"path"),u.length>0&&(i===void 0?i=u:i+=`/${u}`)}return i===void 0?".":e.$gc.normalize(i)},relative(n,i){if(c(n,"from"),c(i,"to"),n===i||(n=e.$gc.resolve(n),i=e.$gc.resolve(i),n===i))return"";const f=1,u=n.length,P=u-f,h=1,A=i.length-h,o=P<A?P:A;let D=-1,O=0;for(;O<o;O++){const g=n.charCodeAt(f+O);if(g!==i.charCodeAt(h+O))break;g===U&&(D=O)}if(O===o)if(A>o){if(i.charCodeAt(h+O)===U)return i.slice(h+O+1);if(O===0)return i.slice(h+O)}else P>o&&(n.charCodeAt(f+O)===U?D=O:O===0&&(D=0));let $="";for(O=f+D+1;O<=u;++O)(O===u||n.charCodeAt(O)===U)&&($+=$.length===0?"..":"/..");return`${$}${i.slice(h+D)}`},toNamespacedPath(n){return n},dirname(n){if(c(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===U;let f=-1,u=!0;for(let P=n.length-1;P>=1;--P)if(n.charCodeAt(P)===U){if(!u){f=P;break}}else u=!1;return f===-1?i?"/":".":i&&f===1?"//":n.slice(0,f)},basename(n,i){i!==void 0&&c(i,"ext"),c(n,"path");let f=0,u=-1,P=!0,h;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let A=i.length-1,o=-1;for(h=n.length-1;h>=0;--h){const D=n.charCodeAt(h);if(D===U){if(!P){f=h+1;break}}else o===-1&&(P=!1,o=h+1),A>=0&&(D===i.charCodeAt(A)?--A===-1&&(u=h):(A=-1,u=o))}return f===u?u=o:u===-1&&(u=n.length),n.slice(f,u)}for(h=n.length-1;h>=0;--h)if(n.charCodeAt(h)===U){if(!P){f=h+1;break}}else u===-1&&(P=!1,u=h+1);return u===-1?"":n.slice(f,u)},extname(n){c(n,"path");let i=-1,f=0,u=-1,P=!0,h=0;for(let A=n.length-1;A>=0;--A){const o=n.charCodeAt(A);if(o===U){if(!P){f=A+1;break}continue}u===-1&&(P=!1,u=A+1),o===N?i===-1?i=A:h!==1&&(h=1):i!==-1&&(h=-1)}return i===-1||u===-1||h===0||h===1&&i===u-1&&i===f+1?"":n.slice(i,u)},format:y.bind(null,"/"),parse(n){c(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const f=n.charCodeAt(0)===U;let u;f?(i.root="/",u=1):u=0;let P=-1,h=0,A=-1,o=!0,D=n.length-1,O=0;for(;D>=u;--D){const $=n.charCodeAt(D);if($===U){if(!o){h=D+1;break}continue}A===-1&&(o=!1,A=D+1),$===N?P===-1?P=D:O!==1&&(O=1):P!==-1&&(O=-1)}if(A!==-1){const $=h===0&&f?1:h;P===-1||O===0||O===1&&P===A-1&&P===h+1?i.base=i.name=n.slice($,A):(i.name=n.slice($,P),i.base=n.slice($,A),i.ext=n.slice(P,A))}return h>0?i.dir=n.slice(0,h-1):f&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=r?e.$fc.normalize:e.$gc.normalize,e.$ic=r?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=r?e.$fc.join:e.$gc.join,e.$kc=r?e.$fc.resolve:e.$gc.resolve,e.$lc=r?e.$fc.relative:e.$gc.relative,e.$mc=r?e.$fc.dirname:e.$gc.dirname,e.$nc=r?e.$fc.basename:e.$gc.basename,e.$oc=r?e.$fc.extname:e.$gc.extname,e.$pc=r?e.$fc.format:e.$gc.format,e.$qc=r?e.$fc.parse:e.$gc.parse,e.$rc=r?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=r?e.$fc.sep:e.$gc.sep,e.$tc=r?e.$fc.delimiter:e.$gc.delimiter}),define(Ee[29],_e([0,1,2]),function($e,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$sm=M,e.$tm=V;var t;(function(N){N[N.stdout=0]="stdout",N[N.stderr=1]="stderr"})(t||(e.Source=t={}));var j;(function(N){N[N.Success=0]="Success",N[N.Unknown=1]="Unknown",N[N.AccessDenied=2]="AccessDenied",N[N.ProcessNotFound=3]="ProcessNotFound"})(j||(e.TerminateResponseCode=j={}));function M(N,...U){const S=U.reduce((I,F)=>(I[F]=!0,I),{}),k=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(N).filter(I=>!S[I]).forEach(I=>{for(let F=0;F<k.length;F++)if(I.search(k[F])!==-1){delete N[I];break}})}function V(N){N&&(delete N.DEBUG,E.$d&&delete N.DYLD_LIBRARY_PATH,E.$e&&delete N.LD_PRELOAD)}}),define(Ee[41],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(M){return new t(M)}constructor(M){this.c=E&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=t}),define(Ee[6],_e([0,1,9,26,4,40,41]),function($e,e,E,t,j,M,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=F;const N=!1,U=!1,S=!1;var k;(function(ee){ee.None=()=>j.$Uc.None;function X(he){if(S){const{onDidAddListener:fe}=he,be=r.create();let de=0;he.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),fe?.()}}}function se(he,fe){return v(he,()=>{},0,void 0,!0,void 0,fe)}ee.defer=se;function Y(he){return(fe,be=null,de)=>{let we=!1,Ae;return Ae=he(Re=>{if(!we)return Ae?Ae.dispose():we=!0,fe.call(be,Re)},null,de),we&&Ae.dispose(),Ae}}ee.once=Y;function te(he,fe,be){return q((de,we=null,Ae)=>he(Re=>de.call(we,fe(Re)),null,Ae),be)}ee.map=te;function ue(he,fe,be){return q((de,we=null,Ae)=>he(Re=>{fe(Re),de.call(we,Re)},null,Ae),be)}ee.forEach=ue;function ce(he,fe,be){return q((de,we=null,Ae)=>he(Re=>fe(Re)&&de.call(we,Re),null,Ae),be)}ee.filter=ce;function L(he){return he}ee.signal=L;function a(...he){return(fe,be=null,de)=>{const we=(0,j.$Rc)(...he.map(Ae=>Ae(Re=>fe.call(be,Re))));return Q(we,de)}}ee.any=a;function T(he,fe,be,de){let we=be;return te(he,Ae=>(we=fe(we,Ae),we),de)}ee.reduce=T;function q(he,fe){let be;const de={onWillAddFirstListener(){be=he(we.fire,we)},onDidRemoveLastListener(){be?.dispose()}};fe||X(de);const we=new i(de);return fe?.add(we),we.event}function Q(he,fe){return fe instanceof Array?fe.push(he):fe&&fe.add(he),he}function v(he,fe,be=100,de=!1,we=!1,Ae,Re){let Ie,Ue,ke,Be=0,Fe;const ye={leakWarningThreshold:Ae,onWillAddFirstListener(){Ie=he(Ge=>{Be++,Ue=fe(Ue,Ge),de&&!ke&&(Oe.fire(Ue),Ue=void 0),Fe=()=>{const He=Ue;Ue=void 0,ke=void 0,(!de||Be>1)&&Oe.fire(He),Be=0},typeof be=="number"?(clearTimeout(ke),ke=setTimeout(Fe,be)):ke===void 0&&(ke=0,queueMicrotask(Fe))})},onWillRemoveListener(){we&&Be>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,Ie.dispose()}};Re||X(ye);const Oe=new i(ye);return Re?.add(Oe),Oe.event}ee.debounce=v;function C(he,fe=0,be){return ee.debounce(he,(de,we)=>de?(de.push(we),de):[we],fe,void 0,!0,void 0,be)}ee.accumulate=C;function Z(he,fe=(de,we)=>de===we,be){let de=!0,we;return ce(he,Ae=>{const Re=de||!fe(Ae,we);return de=!1,we=Ae,Re},be)}ee.latch=Z;function ie(he,fe,be){return[ee.filter(he,fe,be),ee.filter(he,de=>!fe(de),be)]}ee.split=ie;function le(he,fe=!1,be=[],de){let we=be.slice(),Ae=he(Ue=>{we?we.push(Ue):Ie.fire(Ue)});de&&de.add(Ae);const Re=()=>{we?.forEach(Ue=>Ie.fire(Ue)),we=null},Ie=new i({onWillAddFirstListener(){Ae||(Ae=he(Ue=>Ie.fire(Ue)),de&&de.add(Ae))},onDidAddFirstListener(){we&&(fe?setTimeout(Re):Re())},onDidRemoveLastListener(){Ae&&Ae.dispose(),Ae=null}});return de&&de.add(Ie),Ie.event}ee.buffer=le;function ae(he,fe){return(de,we,Ae)=>{const Re=fe(new W);return he(function(Ie){const Ue=Re.evaluate(Ie);Ue!==p&&de.call(we,Ue)},void 0,Ae)}}ee.chain=ae;const p=Symbol("HaltChainable");class W{constructor(){this.f=[]}map(fe){return this.f.push(fe),this}forEach(fe){return this.f.push(be=>(fe(be),be)),this}filter(fe){return this.f.push(be=>fe(be)?be:p),this}reduce(fe,be){let de=be;return this.f.push(we=>(de=fe(de,we),de)),this}latch(fe=(be,de)=>be===de){let be=!0,de;return this.f.push(we=>{const Ae=be||!fe(we,de);return be=!1,de=we,Ae?we:p}),this}evaluate(fe){for(const be of this.f)if(fe=be(fe),fe===p)break;return fe}}function G(he,fe,be=de=>de){const de=(...Ie)=>Re.fire(be(...Ie)),we=()=>he.on(fe,de),Ae=()=>he.removeListener(fe,de),Re=new i({onWillAddFirstListener:we,onDidRemoveLastListener:Ae});return Re.event}ee.fromNodeEventEmitter=G;function B(he,fe,be=de=>de){const de=(...Ie)=>Re.fire(be(...Ie)),we=()=>he.addEventListener(fe,de),Ae=()=>he.removeEventListener(fe,de),Re=new i({onWillAddFirstListener:we,onDidRemoveLastListener:Ae});return Re.event}ee.fromDOMEventEmitter=B;function b(he){return new Promise(fe=>Y(he)(fe))}ee.toPromise=b;function H(he){const fe=new i;return he.then(be=>{fe.fire(be)},()=>{fe.fire(void 0)}).finally(()=>{fe.dispose()}),fe.event}ee.fromPromise=H;function J(he,fe,be){return fe(be),he(de=>fe(de))}ee.runAndSubscribe=J;class ne{constructor(fe,be){this._observable=fe,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{fe.addObserver(this)},onDidRemoveLastListener:()=>{fe.removeObserver(this)}};be||X(de),this.emitter=new i(de),be&&be.add(this.emitter)}beginUpdate(fe){this.f++}handlePossibleChange(fe){}handleChange(fe,be){this.g=!0}endUpdate(fe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ge(he,fe){return new ne(he,fe).emitter.event}ee.fromObservable=ge;function De(he){return(fe,be,de)=>{let we=0,Ae=!1;const Re={beginUpdate(){we++},endUpdate(){we--,we===0&&(he.reportChanges(),Ae&&(Ae=!1,fe.call(be)))},handlePossibleChange(){},handleChange(){Ae=!0}};he.addObserver(Re),he.reportChanges();const Ie={dispose(){he.removeObserver(Re)}};return de instanceof j.$Tc?de.add(Ie):Array.isArray(de)&&de.push(Ie),Ie}}ee.fromObservableLight=De})(k||(e.Event=k={}));class w{constructor(X){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${X}_${w.f++}`,w.all.add(this)}start(X){this.g=new V.$be,this.listenerCount=X}stop(){if(this.g){const X=this.g.elapsed();this.durations.push(X),this.elapsedOverall+=X,this.invocationCount+=1,this.g=void 0}}}e.$de=w,w.all=new Set,w.f=0;let I=-1;function F(ee){const X=I;return I=ee,{dispose(){I=X}}}class c{constructor(X,se,Y=Math.random().toString(18).slice(2,5)){this.h=X,this.threshold=se,this.name=Y,this.g=0}dispose(){this.f?.clear()}check(X,se){const Y=this.threshold;if(Y<=0||se<Y)return;this.f||(this.f=new Map);const te=this.f.get(X.value)||0;if(this.f.set(X.value,te+1),this.g-=1,this.g<=0){this.g=Y*.5;const[ue,ce]=this.getMostFrequentStack(),L=`[${this.name}] potential listener LEAK detected, having ${se} listeners already. MOST frequent listener (${ce}):`;console.warn(L),console.warn(ue);const a=new d(L,ue);this.h(a)}return()=>{const ue=this.f.get(X.value)||0;this.f.set(X.value,ue-1)}}getMostFrequentStack(){if(!this.f)return;let X,se=0;for(const[Y,te]of this.f)(!X||se<te)&&(X=[Y,te],se=te);return X}}class r{static create(){const X=new Error;return new r(X.stack??"")}constructor(X){this.value=X}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(X,se){super(X),this.name="ListenerLeakError",this.stack=se}}e.$fe=d;class m extends Error{constructor(X,se){super(X),this.name="ListenerRefusalError",this.stack=se}}e.$ge=m;let l=0;class _{constructor(X){this.value=X,this.id=l++}}const y=2,s=(ee,X)=>{if(ee instanceof _)X(ee);else for(let se=0;se<ee.length;se++){const Y=ee[se];Y&&X(Y)}},n=N?new FinalizationRegistry(ee=>{typeof ee=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(ee))}):void 0;class i{constructor(X){this.w=0,this.f=X,this.g=I>0||this.f?.leakWarningThreshold?new c(X?.onListenerError??E.$1,this.f?.leakWarningThreshold??I):void 0,this.j=this.f?._profName?new w(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(U){const X=this.t;queueMicrotask(()=>{s(X,se=>se.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(X,se,Y)=>{if(this.g&&this.w>this.g.threshold**2){const a=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(a);const T=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],q=new m(`${a}. HINT: Stack shows most frequent listener (${T[1]}-times)`,T[0]);return(this.f?.onListenerError||E.$1)(q),j.$Uc.None}if(this.m)return j.$Uc.None;se&&(X=X.bind(se));const te=new _(X);let ue,ce;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(te.stack=r.create(),ue=this.g.check(te.stack,this.w+1)),U&&(te.stack=ce??r.create()),this.t?this.t instanceof _?(this.u??(this.u=new u),this.t=[this.t,te]):this.t.push(te):(this.f?.onWillAddFirstListener?.(this),this.t=te,this.f?.onDidAddFirstListener?.(this)),this.w++;const L=(0,j.$Sc)(()=>{n?.unregister(L),ue?.(),this.x(te)});if(Y instanceof j.$Tc?Y.add(L):Array.isArray(Y)&&Y.push(L),n){const a=new Error().stack.split(`
`).slice(2).join(`
`).trim();n.register(L,a,L)}return L}),this.q}x(X){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const se=this.t,Y=se.indexOf(X);if(Y===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,se[Y]=void 0;const te=this.u.current===this;if(this.w*y<=se.length){let ue=0;for(let ce=0;ce<se.length;ce++)se[ce]?se[ue++]=se[ce]:te&&(this.u.end--,ue<this.u.i&&this.u.i--);se.length=ue}}y(X,se){if(!X)return;const Y=this.f?.onListenerError||E.$1;if(!Y){X.value(se);return}try{X.value(se)}catch(te){Y(te)}}z(X){const se=X.current.t;for(;X.i<X.end;)this.y(se[X.i++],X.value);X.reset()}fire(X){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof _)this.y(this.t,X);else{const se=this.u;se.enqueue(this,X,this.t.length),this.z(se)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=i;const f=()=>new u;e.$ie=f;class u{constructor(){this.i=-1,this.end=0}enqueue(X,se,Y){this.i=0,this.end=Y,this.current=X,this.value=se}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class P extends i{async fireAsync(X,se,Y){if(this.t)for(this.h||(this.h=new M.$5c),s(this.t,te=>this.h.push([te.value,X]));this.h.size>0&&!se.isCancellationRequested;){const[te,ue]=this.h.shift(),ce=[],L={...ue,token:se,waitUntil:a=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");Y&&(a=Y(a,te)),ce.push(a)}};try{te(L)}catch(a){(0,E.$1)(a);continue}Object.freeze(ce),await Promise.allSettled(ce).then(a=>{for(const T of a)T.status==="rejected"&&(0,E.$1)(T.reason)})}}}e.$je=P;class h extends i{get isPaused(){return this.h!==0}constructor(X){super(X),this.h=0,this.s=new M.$5c,this.A=X?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const X=Array.from(this.s);this.s.clear(),super.fire(this.A(X))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(X){this.w&&(this.h!==0?this.s.push(X):super.fire(X))}}e.$ke=h;class A extends h{constructor(X){super(X),this.k=X.delay??100}fire(X){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(X)}}e.$le=A;class o extends i{constructor(X){super(X),this.h=[],this.k=X?.merge}fire(X){this.hasListeners()&&(this.h.push(X),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(se=>super.fire(se)),this.h=[]}))}}e.$me=o;class D{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(X){const se={event:X,listener:null};this.h.push(se),this.g&&this.m(se);const Y=()=>{this.g&&this.o(se);const te=this.h.indexOf(se);this.h.splice(te,1)};return(0,j.$Sc)((0,t.$db)(Y))}j(){this.g=!0,this.h.forEach(X=>this.m(X))}k(){this.g=!1,this.h.forEach(X=>this.o(X))}m(X){X.listener=X.event(se=>this.f.fire(se))}o(X){X.listener?.dispose(),X.listener=null}dispose(){this.f.dispose();for(const X of this.h)X.listener?.dispose();this.h=[]}}e.$ne=D;class O{constructor(X,se,Y,te){this.f=new j.$Tc;const ue=this.f.add(new D),ce=this.f.add(new j.$4c);function L(a){ce.set(a,ue.add(te(a)))}for(const a of X)L(a);this.f.add(se(a=>{L(a)})),this.f.add(Y(a=>{ce.deleteAndDispose(a)})),this.event=ue.event}dispose(){this.f.dispose()}}e.$oe=O;class ${constructor(){this.f=[]}wrapEvent(X,se,Y){return(te,ue,ce)=>X(L=>{const a=this.f[this.f.length-1];if(!se){a?a.buffers.push(()=>te.call(ue,L)):te.call(ue,L);return}const T=a;if(!T){te.call(ue,se(Y,L));return}T.items??(T.items=[]),T.items.push(L),T.buffers.length===0&&a.buffers.push(()=>{T.reducedResult??(T.reducedResult=Y?T.items.reduce(se,Y):T.items.reduce(se)),te.call(ue,T.reducedResult)})},void 0,ce)}bufferEvents(X){const se={buffers:new Array};this.f.push(se);const Y=X();return this.f.pop(),se.buffers.forEach(te=>te()),Y}}e.$pe=$;class g{constructor(){this.f=!1,this.g=k.None,this.h=j.$Uc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(X){this.g=X,this.f&&(this.h.dispose(),this.h=X(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=g;class K{static const(X){return new re(X)}constructor(X){this.g=X,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(X){X!==this.g&&(this.g=X,this.f.fire(void 0))}}e.$re=K;class re{constructor(X){this.value=X,this.onDidChange=k.None}}}),define(Ee[13],_e([0,1,6]),function($e,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=N;const t=Object.freeze(function(U,S){const k=setTimeout(U.bind(S),0);return{dispose(){clearTimeout(k)}}});var j;(function(U){function S(k){return k===U.None||k===U.Cancelled||k instanceof M?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}U.isCancellationToken=S,U.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),U.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(j||(e.CancellationToken=j={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new E.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class V{constructor(S){this.f=void 0,this.g=void 0,this.g=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=j.Cancelled}dispose(S=!1){S&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=j.None}}e.$se=V;function N(U){const S=new V;return U.add({dispose(){S.cancel()}}),S.token}}),define(Ee[42],_e([0,1,13]),function($e,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=j;class t{constructor(U){this.b=U,this.a=null}get(){if(this.a)return this.a;const U=new E.$se,S=this.b(U.token);return this.a={promise:S,dispose:()=>{this.a=null,U.cancel(),U.dispose()}},this.a}}e.$5e=t;function j(N){return N}class M{constructor(U,S){this.a=void 0,this.b=void 0,typeof U=="function"?(this.c=U,this.d=j):(this.c=S,this.d=U.getCacheKey)}get(U){const S=this.d(U);return this.b!==S&&(this.b=S,this.a=this.c(U)),this.a}}e.$7e=M;class V{get cachedValues(){return this.a}constructor(U,S){this.a=new Map,this.b=new Map,typeof U=="function"?(this.c=U,this.d=j):(this.c=S,this.d=U.getCacheKey)}get(U){const S=this.d(U);if(this.b.has(S))return this.b.get(S);const k=this.c(U);return this.a.set(U,k),this.b.set(S,k),k}}e.$8e=V}),define(Ee[43],_e([0,1,9,4]),function($e,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=j,e.$ve=M,e.$we=V,e.$xe=N,e.$ye=S,e.$ze=k,e.$Ae=w,e.$Be=I,e.$Ce=F,e.$De=c,e.$Ee=r,e.$Fe=d,e.$Ge=m,e.$He=l,e.$Ie=_;function j(y){const s=y;return s?typeof s.read=="function":!1}function M(y){const s=y;return s?[s.on,s.pause,s.resume,s.destroy].every(n=>typeof n=="function"):!1}function V(y){const s=y;return s?M(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}function N(y,s){return new U(y,s)}class U{constructor(s,n){this.e=s,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(s){if(!this.a.destroyed){if(this.a.flowing)this.g(s);else if(this.b.data.push(s),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(s){this.a.destroyed||(this.a.flowing?this.h(s):this.b.error.push(s))}end(s){this.a.destroyed||(typeof s<"u"&&this.write(s),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(s){this.c.data.slice(0).forEach(n=>n(s))}h(s){this.c.error.length===0?(0,E.$1)(s):this.c.error.slice(0).forEach(n=>n(s))}i(){this.c.end.slice(0).forEach(s=>s())}on(s,n){if(!this.a.destroyed)switch(s){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(s,n){if(this.a.destroyed)return;let i;switch(s){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const f=i.indexOf(n);f>=0&&i.splice(f,1)}}j(){if(this.b.data.length>0){const s=this.e(this.b.data);this.g(s),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const s of this.b.error)this.h(s);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function S(y,s){const n=[];let i;for(;(i=y.read())!==null;)n.push(i);return s(n)}function k(y,s,n){const i=[];let f;for(;(f=y.read())!==null&&i.length<n;)i.push(f);return f===null&&i.length>0?s(i):{read:()=>{if(i.length>0)return i.shift();if(typeof f<"u"){const u=f;return f=void 0,u}return y.read()}}}function w(y,s){return new Promise((n,i)=>{const f=[];I(y,{onData:u=>{s&&f.push(u)},onError:u=>{s?i(u):n(void 0)},onEnd:()=>{n(s?s(f):void 0)}})})}function I(y,s,n){y.on("error",i=>{n?.isCancellationRequested||s.onError(i)}),y.on("end",()=>{n?.isCancellationRequested||s.onEnd()}),y.on("data",i=>{n?.isCancellationRequested||s.onData(i)})}function F(y,s){return new Promise((n,i)=>{const f=new t.$Tc,u=[],P=o=>{if(u.push(o),u.length>s)return f.dispose(),y.pause(),n({stream:y,buffer:u,ended:!1})},h=o=>(f.dispose(),i(o)),A=()=>(f.dispose(),n({stream:y,buffer:u,ended:!0}));f.add((0,t.$Sc)(()=>y.removeListener("error",h))),y.on("error",h),f.add((0,t.$Sc)(()=>y.removeListener("end",A))),y.on("end",A),f.add((0,t.$Sc)(()=>y.removeListener("data",P))),y.on("data",P)})}function c(y,s){const n=N(s);return n.end(y),n}function r(){const y=N(()=>{throw new Error("not supported")});return y.end(),y}function d(y){let s=!1;return{read:()=>s?null:(s=!0,y)}}function m(y,s,n){const i=N(n);return I(y,{onData:f=>i.write(s.data(f)),onError:f=>i.error(s.error?s.error(f):f),onEnd:()=>i.end()}),i}function l(y,s,n){let i=!1;return{read:()=>{const f=s.read();return i?f:(i=!0,f!==null?n([y,f]):y)}}}function _(y,s,n){let i=!1;const f=N(n);return I(s,{onData:u=>i?f.write(u):(i=!0,f.write(n([y,u]))),onError:u=>f.error(u),onEnd:()=>{i||(i=!0,f.write(y)),f.end()}}),f}}),define(Ee[16],_e([0,1,15,43]),function($e,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=S,e.$Le=k,e.$Me=w,e.$Ne=I,e.$Oe=F,e.$Pe=c,e.$Qe=r,e.$Re=d,e.$Se=m,e.$Te=l,e.$Ue=_,e.$Ve=y,e.$We=s,e.$Xe=n,e.$Ye=i,e.$Ze=f,e.$1e=u,e.$2e=P,e.$3e=h,e.$4e=D;const j=typeof Buffer<"u",M=new E.$V(()=>new Uint8Array(256));let V,N;class U{static alloc($){return j?new U(Buffer.allocUnsafe($)):new U(new Uint8Array($))}static wrap($){return j&&!Buffer.isBuffer($)&&($=Buffer.from($.buffer,$.byteOffset,$.byteLength)),new U($)}static fromString($,g){return!(g?.dontUseNodeBuffer||!1)&&j?new U(Buffer.from($)):(V||(V=new TextEncoder),new U(V.encode($)))}static fromByteArray($){const g=U.alloc($.length);for(let K=0,re=$.length;K<re;K++)g.buffer[K]=$[K];return g}static concat($,g){if(typeof g>"u"){g=0;for(let ee=0,X=$.length;ee<X;ee++)g+=$[ee].byteLength}const K=U.alloc(g);let re=0;for(let ee=0,X=$.length;ee<X;ee++){const se=$[ee];K.set(se,re),re+=se.byteLength}return K}constructor($){this.buffer=$,this.byteLength=this.buffer.byteLength}clone(){const $=U.alloc(this.byteLength);return $.set(this),$}toString(){return j?this.buffer.toString():(N||(N=new TextDecoder),N.decode(this.buffer))}slice($,g){return new U(this.buffer.subarray($,g))}set($,g){if($ instanceof U)this.buffer.set($.buffer,g);else if($ instanceof Uint8Array)this.buffer.set($,g);else if($ instanceof ArrayBuffer)this.buffer.set(new Uint8Array($),g);else if(ArrayBuffer.isView($))this.buffer.set(new Uint8Array($.buffer,$.byteOffset,$.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE($){return I(this.buffer,$)}writeUInt32BE($,g){F(this.buffer,$,g)}readUInt32LE($){return c(this.buffer,$)}writeUInt32LE($,g){r(this.buffer,$,g)}readUInt8($){return d(this.buffer,$)}writeUInt8($,g){m(this.buffer,$,g)}indexOf($,g=0){return S(this.buffer,$ instanceof U?$.buffer:$,g)}}e.$Je=U;function S(O,$,g=0){const K=$.byteLength,re=O.byteLength;if(K===0)return 0;if(K===1)return O.indexOf($[0]);if(K>re-g)return-1;const ee=M.value;ee.fill($.length);for(let te=0;te<$.length;te++)ee[$[te]]=$.length-te-1;let X=g+$.length-1,se=X,Y=-1;for(;X<re;)if(O[X]===$[se]){if(se===0){Y=X;break}X--,se--}else X+=Math.max($.length-se,ee[O[X]]),se=$.length-1;return Y}function k(O,$){return O[$+0]<<0>>>0|O[$+1]<<8>>>0}function w(O,$,g){O[g+0]=$&255,$=$>>>8,O[g+1]=$&255}function I(O,$){return O[$]*2**24+O[$+1]*2**16+O[$+2]*2**8+O[$+3]}function F(O,$,g){O[g+3]=$,$=$>>>8,O[g+2]=$,$=$>>>8,O[g+1]=$,$=$>>>8,O[g]=$}function c(O,$){return O[$+0]<<0>>>0|O[$+1]<<8>>>0|O[$+2]<<16>>>0|O[$+3]<<24>>>0}function r(O,$,g){O[g+0]=$&255,$=$>>>8,O[g+1]=$&255,$=$>>>8,O[g+2]=$&255,$=$>>>8,O[g+3]=$&255}function d(O,$){return O[$]}function m(O,$,g){O[g]=$}function l(O){return t.$ye(O,$=>U.concat($))}function _(O){return t.$Fe(O)}function y(O){return t.$Ae(O,$=>U.concat($))}async function s(O){return O.ended?U.concat(O.buffer):U.concat([...O.buffer,await y(O.stream)])}function n(O){return t.$De(O,$=>U.concat($))}function i(O){return t.$Ge(O,{data:$=>typeof $=="string"?U.fromString($):U.wrap($)},$=>U.concat($))}function f(O){return t.$xe($=>U.concat($),O)}function u(O,$){return t.$He(O,$,g=>U.concat(g))}function P(O,$){return t.$Ie(O,$,g=>U.concat(g))}function h(O){let $=0,g=0,K=0;const re=new Uint8Array(Math.floor(O.length/4*3)),ee=se=>{switch(g){case 3:re[K++]=$|se,g=0;break;case 2:re[K++]=$|se>>>2,$=se<<6,g=3;break;case 1:re[K++]=$|se>>>4,$=se<<4,g=2;break;default:$=se<<2,g=1}};for(let se=0;se<O.length;se++){const Y=O.charCodeAt(se);if(Y>=65&&Y<=90)ee(Y-65);else if(Y>=97&&Y<=122)ee(Y-97+26);else if(Y>=48&&Y<=57)ee(Y-48+52);else if(Y===43||Y===45)ee(62);else if(Y===47||Y===95)ee(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${O[se]}`)}}const X=K;for(;g>0;)ee(0);return U.wrap(re).slice(0,X)}const A="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:O},$=!0,g=!1){const K=g?o:A;let re="";const ee=O.byteLength%3;let X=0;for(;X<O.byteLength-ee;X+=3){const se=O[X+0],Y=O[X+1],te=O[X+2];re+=K[se>>>2],re+=K[(se<<4|Y>>>4)&63],re+=K[(Y<<2|te>>>6)&63],re+=K[te&63]}if(ee===1){const se=O[X+0];re+=K[se>>>2],re+=K[se<<4&63],$&&(re+="==")}else if(ee===2){const se=O[X+0],Y=O[X+1];re+=K[se>>>2],re+=K[(se<<4|Y>>>4)&63],re+=K[Y<<2&63],$&&(re+="=")}return re}}),define(Ee[44],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(Ee[10],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=E,e.$bg=t,e.$cg=j,e.$dg=M,e.$eg=V,e.$fg=N,e.$gg=U,e.$hg=S,e.$ig=k,e.$jg=w,e.$kg=I,e.$lg=F,e.$mg=c,e.$ng=d,e.$og=m,e.$pg=l,e.$qg=_,e.$rg=y;function E(s){return typeof s=="string"}function t(s){return Array.isArray(s)&&s.every(n=>E(n))}function j(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}function M(s){const n=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof n}function V(s){return typeof s=="number"&&!isNaN(s)}function N(s){return!!s&&typeof s[Symbol.iterator]=="function"}function U(s){return s===!0||s===!1}function S(s){return typeof s>"u"}function k(s){return!w(s)}function w(s){return S(s)||s===null}function I(s,n){if(!s)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function F(s){if(w(s))throw new Error("Assertion Failed: argument is undefined or null");return s}function c(...s){const n=[];for(let i=0;i<s.length;i++){const f=s[i];if(w(f))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(f)}return n}const r=Object.prototype.hasOwnProperty;function d(s){if(!j(s))return!1;for(const n in s)if(r.call(s,n))return!1;return!0}function m(s){return typeof s=="function"}function l(...s){return s.length>0&&s.every(m)}function _(s,n){const i=Math.min(s.length,n.length);for(let f=0;f<i;f++)y(s[f],n[f])}function y(s,n){if(E(n)){if(typeof s!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(m(n)){try{if(s instanceof n)return}catch{}if(!w(s)&&s.constructor===n||n.length===1&&n.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[45],_e([0,1,10]),function($e,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=t,e.$$n=j,e.$_n=V,e.$ao=U,e.$bo=S,e.$co=k,e.$do=w,e.$eo=I,e.$fo=F,e.$go=c,e.$ho=r,e.$io=d,e.$jo=m;function t(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const _=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([y,s])=>{_[y]=s&&typeof s=="object"?t(s):s}),_}function j(l){if(!l||typeof l!="object")return l;const _=[l];for(;_.length>0;){const y=_.shift();Object.freeze(y);for(const s in y)if(M.call(y,s)){const n=y[s];typeof n=="object"&&!Object.isFrozen(n)&&!(0,E.$dg)(n)&&_.push(n)}}return l}const M=Object.prototype.hasOwnProperty;function V(l,_){return N(l,_,new Set)}function N(l,_,y){if((0,E.$jg)(l))return l;const s=_(l);if(typeof s<"u")return s;if(Array.isArray(l)){const n=[];for(const i of l)n.push(N(i,_,y));return n}if((0,E.$cg)(l)){if(y.has(l))throw new Error("Cannot clone recursive data-structure");y.add(l);const n={};for(const i in l)M.call(l,i)&&(n[i]=N(l[i],_,y));return y.delete(l),n}return l}function U(l,_,y=!0){return(0,E.$cg)(l)?((0,E.$cg)(_)&&Object.keys(_).forEach(s=>{s in l?y&&((0,E.$cg)(l[s])&&(0,E.$cg)(_[s])?U(l[s],_[s],y):l[s]=_[s]):l[s]=_[s]}),l):_}function S(l,_){if(l===_)return!0;if(l==null||_===null||_===void 0||typeof l!=typeof _||typeof l!="object"||Array.isArray(l)!==Array.isArray(_))return!1;let y,s;if(Array.isArray(l)){if(l.length!==_.length)return!1;for(y=0;y<l.length;y++)if(!S(l[y],_[y]))return!1}else{const n=[];for(s in l)n.push(s);n.sort();const i=[];for(s in _)i.push(s);if(i.sort(),!S(n,i))return!1;for(y=0;y<n.length;y++)if(!S(l[n[y]],_[n[y]]))return!1}return!0}function k(l){const _=new Set;return JSON.stringify(l,(y,s)=>{if((0,E.$cg)(s)||Array.isArray(s)){if(_.has(s))return"[Circular]";_.add(s)}return typeof s=="bigint"?`[BigInt ${s.toString()}]`:s})}function w(l,_){const y=Object.create(null);return!l||!_||Object.keys(_).forEach(n=>{const i=l[n],f=_[n];S(i,f)||(y[n]=f)}),y}function I(l,_){const y=_.toLowerCase(),s=Object.keys(l).find(n=>n.toLowerCase()===y);return s?l[s]:l[_]}function F(l,_){const y=Object.create(null);for(const[s,n]of Object.entries(l))_(s,n)&&(y[s]=n);return y}function c(l){let _=[];for(;Object.prototype!==l;)_=_.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return _}function r(l){const _=[];for(const y of c(l))typeof l[y]=="function"&&_.push(y);return _}function d(l,_){const y=n=>function(){const i=Array.prototype.slice.call(arguments,0);return _(n,i)},s={};for(const n of l)s[n]=y(n);return s}function m(l,_){const y={};for(const[s,n]of Object.entries(l))y[s]=_(n,s);return y}}),define(Ee[46],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=t,e.$0e=j;var E;(function(M){M[M.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",M[M.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",M[M.MAX_UINT_8=255]="MAX_UINT_8",M[M.MAX_UINT_16=65535]="MAX_UINT_16",M[M.MAX_UINT_32=4294967295]="MAX_UINT_32",M[M.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(E||(e.Constants=E={}));function t(M){return M<0?0:M>E.MAX_UINT_8?E.MAX_UINT_8:M|0}function j(M){return M<0?0:M>E.MAX_UINT_32?E.MAX_UINT_32:M|0}}),define(Ee[7],_e([0,1,42,11,15,46]),function($e,e,E,t,j,M){"use strict";var V;Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=N,e.$_e=S,e.$af=w,e.$bf=I,e.$cf=F,e.$df=c,e.$ef=r,e.$ff=d,e.$gf=m,e.$hf=l,e.$if=_,e.$jf=y,e.$kf=s,e.$lf=n,e.$mf=i,e.$nf=f,e.$of=u,e.$pf=P,e.$qf=h,e.$rf=A,e.$sf=o,e.$tf=D,e.$uf=O,e.$vf=$,e.$wf=g,e.$xf=K,e.$yf=re,e.$zf=ee,e.$Af=X,e.$Bf=se,e.$Cf=Y,e.$Df=te,e.$Ef=ue,e.$Ff=ce,e.$Gf=L,e.$Hf=a,e.$If=T,e.$Lf=C,e.$Mf=Z,e.$Nf=ie,e.$Of=le,e.$Pf=W,e.$Qf=B,e.$Sf=b,e.$Tf=H,e.$Uf=J,e.$Vf=ne,e.$Wf=De,e.$Xf=he,e.$Yf=be,e.$1f=de,e.$2f=we,e.$3f=Ae,e.$4f=Re,e.$5f=Ie,e.$6f=Ue,e.$7f=ke,e.$8f=Be,e.$9f=He;function N(R){return!R||typeof R!="string"?!0:R.trim().length===0}const U=/{(\d+)}/g;function S(R,...z){return z.length===0?R:R.replace(U,function(x,oe){const me=parseInt(oe,10);return isNaN(me)||me<0||me>=z.length?x:z[me]})}const k=/{([^}]+)}/g;function w(R,z){return Object.keys(z).length===0?R:R.replace(k,(x,oe)=>z[oe]??x)}function I(R){return R.replace(/[<>"'&]/g,z=>{switch(z){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return z})}function F(R){return R.replace(/[<>&]/g,function(z){switch(z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return z}})}function c(R){return R.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function r(R,z){let x=0,oe=R.indexOf(z);for(;oe!==-1;)x++,oe=R.indexOf(z,oe+z.length);return x}function d(R,z,x="\u2026"){return R.length<=z?R:`${R.substr(0,z)}${x}`}function m(R,z,x="\u2026"){if(R.length<=z)return R;const oe=Math.ceil(z/2)-x.length/2,me=Math.floor(z/2)-x.length/2;return`${R.substr(0,oe)}${x}${R.substr(R.length-me)}`}function l(R,z=" "){const x=_(R,z);return y(x,z)}function _(R,z){if(!R||!z)return R;const x=z.length;if(x===0||R.length===0)return R;let oe=0;for(;R.indexOf(z,oe)===oe;)oe=oe+x;return R.substring(oe)}function y(R,z){if(!R||!z)return R;const x=z.length,oe=R.length;if(x===0||oe===0)return R;let me=oe,ve=-1;for(;ve=R.lastIndexOf(z,me-1),!(ve===-1||ve+x!==me);){if(ve===0)return"";me=ve}return R.substring(0,me)}function s(R){return R.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function n(R){return R.replace(/\*/g,"")}function i(R,z,x={}){if(!R)throw new Error("Cannot create regex from empty string");z||(R=c(R)),x.wholeWord&&(/\B/.test(R.charAt(0))||(R="\\b"+R),/\B/.test(R.charAt(R.length-1))||(R=R+"\\b"));let oe="";return x.global&&(oe+="g"),x.matchCase||(oe+="i"),x.multiline&&(oe+="m"),x.unicode&&(oe+="u"),new RegExp(R,oe)}function f(R){return R.source==="^"||R.source==="^$"||R.source==="$"||R.source==="^\\s*$"?!1:!!(R.exec("")&&R.lastIndex===0)}function u(R){return R.split(/\r\n|\r|\n/)}function P(R){const z=[],x=R.split(/(\r\n|\r|\n)/);for(let oe=0;oe<Math.ceil(x.length/2);oe++)z.push(x[2*oe]+(x[2*oe+1]??""));return z}function h(R){for(let z=0,x=R.length;z<x;z++){const oe=R.charCodeAt(z);if(oe!==t.CharCode.Space&&oe!==t.CharCode.Tab)return z}return-1}function A(R,z=0,x=R.length){for(let oe=z;oe<x;oe++){const me=R.charCodeAt(oe);if(me!==t.CharCode.Space&&me!==t.CharCode.Tab)return R.substring(z,oe)}return R.substring(z,x)}function o(R,z=R.length-1){for(let x=z;x>=0;x--){const oe=R.charCodeAt(x);if(oe!==t.CharCode.Space&&oe!==t.CharCode.Tab)return x}return-1}function D(R,z,x){const oe=[];let me=0;for(const ve of R.matchAll(z)){if(oe.push(R.slice(me,ve.index)),ve.index===void 0)throw new Error("match.index should be defined");me=ve.index+ve[0].length,oe.push(x(ve[0],...ve.slice(1),ve.index,R,ve.groups))}return oe.push(R.slice(me)),Promise.all(oe).then(ve=>ve.join(""))}function O(R,z){return R<z?-1:R>z?1:0}function $(R,z,x=0,oe=R.length,me=0,ve=z.length){for(;x<oe&&me<ve;x++,me++){const Se=R.charCodeAt(x),Le=z.charCodeAt(me);if(Se<Le)return-1;if(Se>Le)return 1}const Te=oe-x,Me=ve-me;return Te<Me?-1:Te>Me?1:0}function g(R,z){return K(R,z,0,R.length,0,z.length)}function K(R,z,x=0,oe=R.length,me=0,ve=z.length){for(;x<oe&&me<ve;x++,me++){let Se=R.charCodeAt(x),Le=z.charCodeAt(me);if(Se===Le)continue;if(Se>=128||Le>=128)return $(R.toLowerCase(),z.toLowerCase(),x,oe,me,ve);ee(Se)&&(Se-=32),ee(Le)&&(Le-=32);const Pe=Se-Le;if(Pe!==0)return Pe}const Te=oe-x,Me=ve-me;return Te<Me?-1:Te>Me?1:0}function re(R){return R>=t.CharCode.Digit0&&R<=t.CharCode.Digit9}function ee(R){return R>=t.CharCode.a&&R<=t.CharCode.z}function X(R){return R>=t.CharCode.A&&R<=t.CharCode.Z}function se(R,z){return R.length===z.length&&K(R,z)===0}function Y(R,z){const x=z.length;return z.length>R.length?!1:K(R,z,0,x)===0}function te(R,z){const x=Math.min(R.length,z.length);let oe;for(oe=0;oe<x;oe++)if(R.charCodeAt(oe)!==z.charCodeAt(oe))return oe;return x}function ue(R,z){const x=Math.min(R.length,z.length);let oe;const me=R.length-1,ve=z.length-1;for(oe=0;oe<x;oe++)if(R.charCodeAt(me-oe)!==z.charCodeAt(ve-oe))return oe;return x}function ce(R){return 55296<=R&&R<=56319}function L(R){return 56320<=R&&R<=57343}function a(R,z){return(R-55296<<10)+(z-56320)+65536}function T(R,z,x){const oe=R.charCodeAt(x);if(ce(oe)&&x+1<z){const me=R.charCodeAt(x+1);if(L(me))return a(oe,me)}return oe}function q(R,z){const x=R.charCodeAt(z-1);if(L(x)&&z>1){const oe=R.charCodeAt(z-2);if(ce(oe))return a(oe,x)}return x}class Q{get offset(){return this.e}constructor(z,x=0){this.c=z,this.d=z.length,this.e=x}setOffset(z){this.e=z}prevCodePoint(){const z=q(this.c,this.e);return this.e-=z>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,z}nextCodePoint(){const z=T(this.c,this.d,this.e);return this.e+=z>=M.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,z}eol(){return this.e>=this.d}}e.$Jf=Q;class v{get offset(){return this.c.offset}constructor(z,x=0){this.c=new Q(z,x)}nextGraphemeLength(){const z=Oe.getInstance(),x=this.c,oe=x.offset;let me=z.getGraphemeBreakType(x.nextCodePoint());for(;!x.eol();){const ve=x.offset,Te=z.getGraphemeBreakType(x.nextCodePoint());if(Fe(me,Te)){x.setOffset(ve);break}me=Te}return x.offset-oe}prevGraphemeLength(){const z=Oe.getInstance(),x=this.c,oe=x.offset;let me=z.getGraphemeBreakType(x.prevCodePoint());for(;x.offset>0;){const ve=x.offset,Te=z.getGraphemeBreakType(x.prevCodePoint());if(Fe(Te,me)){x.setOffset(ve);break}me=Te}return oe-x.offset}eol(){return this.c.eol()}}e.$Kf=v;function C(R,z){return new v(R,z).nextGraphemeLength()}function Z(R,z){return new v(R,z).prevGraphemeLength()}function ie(R,z){z>0&&L(R.charCodeAt(z))&&z--;const x=z+C(R,z);return[x-Z(R,x),x]}function le(R){const z=new v(R);let x=0;for(;!z.eol();)x++,z.nextGraphemeLength();return x}let ae;function p(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function W(R){return ae||(ae=p()),ae.test(R)}const G=/^[\t\n\r\x20-\x7E]*$/;function B(R){return G.test(R)}e.$Rf=/[\u2028\u2029]/;function b(R){return e.$Rf.test(R)}function H(R){return R>=11904&&R<=55215||R>=63744&&R<=64255||R>=65281&&R<=65374}function J(R){return R>=127462&&R<=127487||R===8986||R===8987||R===9200||R===9203||R>=9728&&R<=10175||R===11088||R===11093||R>=127744&&R<=128591||R>=128640&&R<=128764||R>=128992&&R<=129008||R>=129280&&R<=129535||R>=129648&&R<=129782}function ne(R,z,x=""){const oe=R.trimStart();if(oe.length<z)return oe;const me=/\b/g;let ve=0;for(;me.test(oe)&&!(oe.length-me.lastIndex<z);)ve=me.lastIndex,me.lastIndex+=1;return ve===0?oe:x+oe.substring(ve).trimStart()}const ge=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*De(R){let z=0;for(const x of R.matchAll(ge))z!==x.index&&(yield{isCode:!1,str:R.substring(z,x.index)}),yield{isCode:!0,str:x[0]},z=x.index+x[0].length;z!==R.length&&(yield{isCode:!1,str:R.substring(z)})}function he(R){return R&&(R=R.replace(ge,"")),R}const fe=/\\\[.*?\\\]/g;function be(R){return he(R).replace(fe,"")}e.$Zf=String.fromCharCode(t.CharCode.UTF8_BOM);function de(R){return!!(R&&R.length>0&&R.charCodeAt(0)===t.CharCode.UTF8_BOM)}function we(R){return de(R)?R.substr(1):R}function Ae(R,z){if(!R||!z||R.length<z.length)return!1;const x=z.length,oe=R.toLowerCase();let me=0,ve=-1;for(;me<x;){const Te=oe.indexOf(z[me],ve+1);if(Te<0)return!1;ve=Te,me++}return!0}function Re(R,z=!1){return R?(z&&(R=R.replace(/\\./g,"")),R.toLowerCase()!==R):!1}function Ie(R){return R.charAt(0).toUpperCase()+R.slice(1)}function Ue(R,z=1){if(z===0)return"";let x=-1;do x=R.indexOf(`
`,x+1),z--;while(z>0&&x>=0);return x===-1?R:(R[x-1]==="\r"&&x--,R.substr(0,x))}function ke(R){const z=t.CharCode.Z-t.CharCode.A+1;return R=R%(2*z),R<z?String.fromCharCode(t.CharCode.a+R):String.fromCharCode(t.CharCode.A+R-z)}function Be(R){return Oe.getInstance().getGraphemeBreakType(R)}function Fe(R,z){return R===ye.Other?z!==ye.Extend&&z!==ye.SpacingMark:R===ye.CR&&z===ye.LF?!1:R===ye.Control||R===ye.CR||R===ye.LF||z===ye.Control||z===ye.CR||z===ye.LF?!0:!(R===ye.L&&(z===ye.L||z===ye.V||z===ye.LV||z===ye.LVT)||(R===ye.LV||R===ye.V)&&(z===ye.V||z===ye.T)||(R===ye.LVT||R===ye.T)&&z===ye.T||z===ye.Extend||z===ye.ZWJ||z===ye.SpacingMark||R===ye.Prepend||R===ye.ZWJ&&z===ye.Extended_Pictographic||R===ye.Regional_Indicator&&z===ye.Regional_Indicator)}var ye;(function(R){R[R.Other=0]="Other",R[R.Prepend=1]="Prepend",R[R.CR=2]="CR",R[R.LF=3]="LF",R[R.Control=4]="Control",R[R.Extend=5]="Extend",R[R.Regional_Indicator=6]="Regional_Indicator",R[R.SpacingMark=7]="SpacingMark",R[R.L=8]="L",R[R.V=9]="V",R[R.T=10]="T",R[R.LV=11]="LV",R[R.LVT=12]="LVT",R[R.ZWJ=13]="ZWJ",R[R.Extended_Pictographic=14]="Extended_Pictographic"})(ye||(e.GraphemeBreakType=ye={}));class Oe{static getInstance(){return Oe.c||(Oe.c=new Oe),Oe.c}constructor(){this.d=Ge()}getGraphemeBreakType(z){if(z<32)return z===t.CharCode.LineFeed?ye.LF:z===t.CharCode.CarriageReturn?ye.CR:ye.Control;if(z<127)return ye.Other;const x=this.d,oe=x.length/3;let me=1;for(;me<=oe;)if(z<x[3*me])me=2*me;else if(z>x[3*me+1])me=2*me+1;else return x[3*me+2];return ye.Other}}Oe.c=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(R,z){if(R===0)return 0;const x=Ve(R,z);if(x!==void 0)return x;const oe=new Q(z,R);return oe.prevCodePoint(),oe.offset}function Ve(R,z){const x=new Q(z,R);let oe=x.prevCodePoint();for(;Xe(oe)||oe===je.emojiVariantSelector||oe===je.enclosingKeyCap;){if(x.offset===0)return;oe=x.prevCodePoint()}if(!J(oe))return;let me=x.offset;return me>0&&x.prevCodePoint()===je.zwj&&(me=x.offset),me}function Xe(R){return 127995<=R&&R<=127999}var je;(function(R){R[R.zwj=8205]="zwj",R[R.emojiVariantSelector=65039]="emojiVariantSelector",R[R.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$0f="\xA0";class qe{static getInstance(z){return V.d.get(Array.from(z))}static getLocales(){return V.e.value}constructor(z){this.f=z}isAmbiguous(z){return this.f.has(z)}containsAmbiguousCharacter(z){for(let x=0;x<z.length;x++){const oe=z.codePointAt(x);if(typeof oe=="number"&&this.isAmbiguous(oe))return!0}return!1}getPrimaryConfusable(z){return this.f.get(z)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=qe,V=qe,qe.c=new j.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.d=new E.$7e({getCacheKey:JSON.stringify},R=>{function z(Le){const Pe=new Map;for(let Ne=0;Ne<Le.length;Ne+=2)Pe.set(Le[Ne],Le[Ne+1]);return Pe}function x(Le,Pe){const Ne=new Map(Le);for(const[We,ze]of Pe)Ne.set(We,ze);return Ne}function oe(Le,Pe){if(!Le)return Pe;const Ne=new Map;for(const[We,ze]of Le)Pe.has(We)&&Ne.set(We,ze);return Ne}const me=V.c.value;let ve=R.filter(Le=>!Le.startsWith("_")&&Le in me);ve.length===0&&(ve=["_default"]);let Te;for(const Le of ve){const Pe=z(me[Le]);Te=oe(Te,Pe)}const Me=z(me._common),Se=x(Me,Te);return new V(Se)}),qe.e=new j.$V(()=>Object.keys(V.c.value).filter(R=>!R.startsWith("_")));class pe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(pe.c())),this.d}static isInvisibleCharacter(z){return pe.e().has(z)}static containsInvisibleCharacter(z){for(let x=0;x<z.length;x++){const oe=z.codePointAt(x);if(typeof oe=="number"&&pe.isInvisibleCharacter(oe))return!0}return!1}static get codePoints(){return pe.e()}}e.$_f=pe,pe.d=void 0}),define(Ee[14],_e([0,1,11,3,2,7,10]),function($e,e,E,t,j,M,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=N,e.$tg=U,e.$ug=S,e.$vg=k,e.$wg=w,e.$xg=r,e.$yg=d,e.$zg=m,e.$Ag=l,e.$Bg=_,e.$Cg=y,e.$Dg=s,e.$Eg=n,e.$Fg=i,e.$Gg=f,e.$Hg=u,e.$Ig=A;function N(o){return o===E.CharCode.Slash||o===E.CharCode.Backslash}function U(o){return o.replace(/[\\/]/g,t.$gc.sep)}function S(o){return o.indexOf("/")===-1&&(o=U(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}function k(o,D=t.$gc.sep){if(!o)return"";const O=o.length,$=o.charCodeAt(0);if(N($)){if(N(o.charCodeAt(1))&&!N(o.charCodeAt(2))){let K=3;const re=K;for(;K<O&&!N(o.charCodeAt(K));K++);if(re!==K&&!N(o.charCodeAt(K+1))){for(K+=1;K<O;K++)if(N(o.charCodeAt(K)))return o.slice(0,K+1).replace(/[\\/]/g,D)}}return D}else if(l($)&&o.charCodeAt(1)===E.CharCode.Colon)return N(o.charCodeAt(2))?o.slice(0,2)+D:o.slice(0,2);let g=o.indexOf("://");if(g!==-1){for(g+=3;g<O;g++)if(N(o.charCodeAt(g)))return o.slice(0,g+1)}return""}function w(o){if(!j.$c||!o||o.length<5)return!1;let D=o.charCodeAt(0);if(D!==E.CharCode.Backslash||(D=o.charCodeAt(1),D!==E.CharCode.Backslash))return!1;let O=2;const $=O;for(;O<o.length&&(D=o.charCodeAt(O),D!==E.CharCode.Backslash);O++);return!($===O||(D=o.charCodeAt(O+1),isNaN(D)||D===E.CharCode.Backslash))}const I=/[\\/:\*\?"<>\|]/g,F=/[/]/g,c=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(o,D=j.$c){const O=D?I:F;return!(!o||o.length===0||/^\s+$/.test(o)||(O.lastIndex=0,O.test(o))||D&&c.test(o)||o==="."||o===".."||D&&o[o.length-1]==="."||D&&o.length!==o.trim().length||o.length>255)}function d(o,D,O){const $=o===D;return!O||$?$:!o||!D?!1:(0,M.$Bf)(o,D)}function m(o,D,O,$=t.sep){if(o===D)return!0;if(!o||!D||D.length>o.length)return!1;if(O){if(!(0,M.$Cf)(o,D))return!1;if(D.length===o.length)return!0;let K=D.length;return D.charAt(D.length-1)===$&&K--,o.charAt(K)===$}return D.charAt(D.length-1)!==$&&(D+=$),o.indexOf(D)===0}function l(o){return o>=E.CharCode.A&&o<=E.CharCode.Z||o>=E.CharCode.a&&o<=E.CharCode.z}function _(o,D){return j.$c&&o.endsWith(":")&&(o+=t.sep),(0,t.$ic)(o)||(o=(0,t.$jc)(D,o)),o=(0,t.$hc)(o),y(o)}function y(o){return j.$c?(o=(0,M.$jf)(o,t.sep),o.endsWith(":")&&(o+=t.sep)):(o=(0,M.$jf)(o,t.sep),o||(o=t.sep)),o}function s(o){const D=(0,t.$hc)(o);return j.$c?o.length>3?!1:n(D)&&(o.length===2||D.charCodeAt(2)===E.CharCode.Backslash):D===t.$gc.sep}function n(o,D=j.$c){return D?l(o.charCodeAt(0))&&o.charCodeAt(1)===E.CharCode.Colon:!1}function i(o,D=j.$c){return n(o,D)?o[0]:void 0}function f(o,D,O){return D.length>o.length?-1:o===D?0:(O&&(o=o.toLowerCase(),D=D.toLowerCase()),o.indexOf(D))}function u(o){const D=o.split(":");let O,$,g;for(const K of D){const re=Number(K);(0,V.$eg)(re)?$===void 0?$=re:g===void 0&&(g=re):O=O?[O,K].join(":"):K}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:$!==void 0?$:void 0,column:g!==void 0?g:$!==void 0?1:void 0}}const P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",h="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function A(o,D,O=8){let $="";for(let K=0;K<O;K++){let re;K===0&&j.$c&&!D&&(O===3||O===4)?re=h:re=P,$+=re.charAt(Math.floor(Math.random()*re.length))}let g;return D?g=`${D}-${$}`:g=$,o?(0,t.$jc)(o,g):g}}),define(Ee[30],_e([0,1,12,11,7]),function($e,e,E,t,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class M{constructor(){this.b="",this.c=0}reset(c){return this.b=c,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(c){const r=c.charCodeAt(0),d=this.b.charCodeAt(this.c);return r-d}value(){return this.b[this.c]}}e.$Ci=M;class V{constructor(c=!0){this.e=c}reset(c){return this.b=c,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let c=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(c)this.c++;else break;else c=!1;return this}cmp(c){return this.e?(0,j.$vf)(c,this.b,0,c.length,this.c,this.d):(0,j.$xf)(c,this.b,0,c.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=V;class N{constructor(c=!0,r=!0){this.f=c,this.g=r}reset(c){this.d=0,this.e=0,this.b=c,this.c=c.length;for(let r=c.length-1;r>=0;r--,this.c--){const d=this.b.charCodeAt(r);if(!(d===t.CharCode.Slash||this.f&&d===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let c=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===t.CharCode.Slash||this.f&&r===t.CharCode.Backslash)if(c)this.d++;else break;else c=!1}return this}cmp(c){return this.g?(0,j.$vf)(c,this.b,0,c.length,this.d,this.e):(0,j.$xf)(c,this.b,0,c.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=N;var U;(function(F){F[F.Scheme=1]="Scheme",F[F.Authority=2]="Authority",F[F.Path=3]="Path",F[F.Query=4]="Query",F[F.Fragment=5]="Fragment"})(U||(U={}));class S{constructor(c,r){this.f=c,this.g=r,this.d=[],this.e=0}reset(c){return this.c=c,this.d=[],this.c.scheme&&this.d.push(U.Scheme),this.c.authority&&this.d.push(U.Authority),this.c.path&&(this.b=new N(!1,!this.f(c)),this.b.reset(c.path),this.b.value()&&this.d.push(U.Path)),this.g(c)||(this.c.query&&this.d.push(U.Query),this.c.fragment&&this.d.push(U.Fragment)),this.e=0,this}next(){return this.d[this.e]===U.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===U.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(c){if(this.d[this.e]===U.Scheme)return(0,j.$wf)(c,this.c.scheme);if(this.d[this.e]===U.Authority)return(0,j.$wf)(c,this.c.authority);if(this.d[this.e]===U.Path)return this.b.cmp(c);if(this.d[this.e]===U.Query)return(0,j.$uf)(c,this.c.query);if(this.d[this.e]===U.Fragment)return(0,j.$uf)(c,this.c.fragment);throw new Error}value(){if(this.d[this.e]===U.Scheme)return this.c.scheme;if(this.d[this.e]===U.Authority)return this.c.authority;if(this.d[this.e]===U.Path)return this.b.value();if(this.d[this.e]===U.Query)return this.c.query;if(this.d[this.e]===U.Fragment)return this.c.fragment;throw new Error}}e.$Fi=S;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const c=this.right;return this.right=c.left,c.left=this,this.updateHeight(),c.updateHeight(),c}rotateRight(){const c=this.left;return this.left=c.right,c.right=this,this.updateHeight(),c.updateHeight(),c}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(F){F[F.Left=-1]="Left",F[F.Mid=0]="Mid",F[F.Right=1]="Right"})(w||(w={}));class I{static forUris(c=()=>!1,r=()=>!1){return new I(new S(c,r))}static forPaths(c=!1){return new I(new N(void 0,!c))}static forStrings(){return new I(new M)}static forConfigKeys(){return new I(new V)}constructor(c){this.b=c}clear(){this.c=void 0}fill(c,r){if(r){const d=r.slice(0);(0,E.$Wb)(d);for(const m of d)this.set(m,c)}else{const d=c.slice(0);(0,E.$Wb)(d);for(const m of d)this.set(m[0],m[1])}}set(c,r){const d=this.b.reset(c);let m;this.c||(this.c=new k,this.c.segment=d.value());const l=[];for(m=this.c;;){const y=d.cmp(m.segment);if(y>0)m.left||(m.left=new k,m.left.segment=d.value()),l.push([w.Left,m]),m=m.left;else if(y<0)m.right||(m.right=new k,m.right.segment=d.value()),l.push([w.Right,m]),m=m.right;else if(d.hasNext())d.next(),m.mid||(m.mid=new k,m.mid.segment=d.value()),l.push([w.Mid,m]),m=m.mid;else break}const _=m.value;m.value=r,m.key=c;for(let y=l.length-1;y>=0;y--){const s=l[y][1];s.updateHeight();const n=s.balanceFactor();if(n<-1||n>1){const i=l[y][0],f=l[y+1][0];if(i===w.Right&&f===w.Right)l[y][1]=s.rotateLeft();else if(i===w.Left&&f===w.Left)l[y][1]=s.rotateRight();else if(i===w.Right&&f===w.Left)s.right=l[y+1][1]=l[y+1][1].rotateRight(),l[y][1]=s.rotateLeft();else if(i===w.Left&&f===w.Right)s.left=l[y+1][1]=l[y+1][1].rotateLeft(),l[y][1]=s.rotateRight();else throw new Error;if(y>0)switch(l[y-1][0]){case w.Left:l[y-1][1].left=l[y][1];break;case w.Right:l[y-1][1].right=l[y][1];break;case w.Mid:l[y-1][1].mid=l[y][1];break}else this.c=l[0][1]}}return _}get(c){return this.d(c)?.value}d(c){const r=this.b.reset(c);let d=this.c;for(;d;){const m=r.cmp(d.segment);if(m>0)d=d.left;else if(m<0)d=d.right;else if(r.hasNext())r.next(),d=d.mid;else break}return d}has(c){const r=this.d(c);return!(r?.value===void 0&&r?.mid===void 0)}delete(c){return this.e(c,!1)}deleteSuperstr(c){return this.e(c,!0)}e(c,r){const d=this.b.reset(c),m=[];let l=this.c;for(;l;){const _=d.cmp(l.segment);if(_>0)m.push([w.Left,l]),l=l.left;else if(_<0)m.push([w.Right,l]),l=l.right;else if(d.hasNext())d.next(),m.push([w.Mid,l]),l=l.mid;else break}if(l){if(r?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const _=this.f(l.right);if(_.key){const{key:y,value:s,segment:n}=_;this.e(_.key,!1),l.key=y,l.value=s,l.segment=n}}else{const _=l.left??l.right;if(m.length>0){const[y,s]=m[m.length-1];switch(y){case w.Left:s.left=_;break;case w.Mid:s.mid=_;break;case w.Right:s.right=_;break}}else this.c=_}for(let _=m.length-1;_>=0;_--){const y=m[_][1];y.updateHeight();const s=y.balanceFactor();if(s>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),m[_][1]=y.rotateLeft()):s<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),m[_][1]=y.rotateRight()),_>0)switch(m[_-1][0]){case w.Left:m[_-1][1].left=m[_][1];break;case w.Right:m[_-1][1].right=m[_][1];break;case w.Mid:m[_-1][1].mid=m[_][1];break}else this.c=m[0][1]}}}f(c){for(;c.left;)c=c.left;return c}findSubstr(c){const r=this.b.reset(c);let d=this.c,m;for(;d;){const l=r.cmp(d.segment);if(l>0)d=d.left;else if(l<0)d=d.right;else if(r.hasNext())r.next(),m=d.value||m,d=d.mid;else break}return d&&d.value||m}findSuperstr(c){return this.g(c,!1)}g(c,r){const d=this.b.reset(c);let m=this.c;for(;m;){const l=d.cmp(m.segment);if(l>0)m=m.left;else if(l<0)m=m.right;else if(d.hasNext())d.next(),m=m.mid;else return m.mid?this.h(m.mid):r?m.value:void 0}}hasElementOrSubtree(c){return this.g(c,!0)!==void 0}forEach(c){for(const[r,d]of this)c(d,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(c){const r=[];return this.j(c,r),r[Symbol.iterator]()}j(c,r){c&&(c.left&&this.j(c.left,r),c.value&&r.push([c.key,c.value]),c.mid&&this.j(c.mid,r),c.right&&this.j(c.right,r))}_isBalanced(){const c=r=>{if(!r)return!0;const d=r.balanceFactor();return d<-1||d>1?!1:c(r.left)&&c(r.right)};return c(this.c)}}e.$Gi=I}),define(Ee[5],_e([0,1,11,27,3,2]),function($e,e,E,t,j,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=d,e.$wc=n;const V=/^\w[\w\d+.-]*$/,N=/^\//,U=/^\/\//;function S(h,A){if(!h.scheme&&A)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${h.authority}", path: "${h.path}", query: "${h.query}", fragment: "${h.fragment}"}`);if(h.scheme&&!V.test(h.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(h.path){if(h.authority){if(!N.test(h.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test(h.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(h,A){return!h&&!A?"file":h}function w(h,A){switch(h){case"https":case"http":case"file":A?A[0]!==F&&(A=F+A):A=F;break}return A}const I="",F="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{static isUri(A){return A instanceof r?!0:A?typeof A.authority=="string"&&typeof A.fragment=="string"&&typeof A.path=="string"&&typeof A.query=="string"&&typeof A.scheme=="string"&&typeof A.fsPath=="string"&&typeof A.with=="function"&&typeof A.toString=="function":!1}constructor(A,o,D,O,$,g=!1){typeof A=="object"?(this.scheme=A.scheme||I,this.authority=A.authority||I,this.path=A.path||I,this.query=A.query||I,this.fragment=A.fragment||I):(this.scheme=k(A,g),this.authority=o||I,this.path=w(this.scheme,D||I),this.query=O||I,this.fragment=$||I,S(this,g))}get fsPath(){return n(this,!1)}with(A){if(!A)return this;let{scheme:o,authority:D,path:O,query:$,fragment:g}=A;return o===void 0?o=this.scheme:o===null&&(o=I),D===void 0?D=this.authority:D===null&&(D=I),O===void 0?O=this.path:O===null&&(O=I),$===void 0?$=this.query:$===null&&($=I),g===void 0?g=this.fragment:g===null&&(g=I),o===this.scheme&&D===this.authority&&O===this.path&&$===this.query&&g===this.fragment?this:new l(o,D,O,$,g)}static parse(A,o=!1){const D=c.exec(A);return D?new l(D[2]||I,P(D[4]||I),P(D[5]||I),P(D[7]||I),P(D[9]||I),o):new l(I,I,I,I,I)}static file(A){let o=I;if(M.$c&&(A=A.replace(/\\/g,F)),A[0]===F&&A[1]===F){const D=A.indexOf(F,2);D===-1?(o=A.substring(2),A=F):(o=A.substring(2,D),A=A.substring(D)||F)}return new l("file",o,A,I,I)}static from(A,o){return new l(A.scheme,A.authority,A.path,A.query,A.fragment,o)}static joinPath(A,...o){if(!A.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return M.$c&&A.scheme==="file"?D=r.file(j.$fc.join(n(A,!0),...o)).path:D=j.$gc.join(A.path,...o),A.with({path:D})}toString(A=!1){return i(this,A)}toJSON(){return this}static revive(A){if(A){if(A instanceof r)return A;{const o=new l(A);return o._formatted=A.external??null,o._fsPath=A._sep===m?A.fsPath??null:null,o}}else return A}}e.URI=r;function d(h){return!h||typeof h!="object"?!1:typeof h.scheme=="string"&&(typeof h.authority=="string"||typeof h.authority>"u")&&(typeof h.path=="string"||typeof h.path>"u")&&(typeof h.query=="string"||typeof h.query>"u")&&(typeof h.fragment=="string"||typeof h.fragment>"u")}const m=M.$c?1:void 0;class l extends r{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(A=!1){return A?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const A={$mid:t.MarshalledId.Uri};return this._fsPath&&(A.fsPath=this._fsPath,A._sep=m),this._formatted&&(A.external=this._formatted),this.path&&(A.path=this.path),this.scheme&&(A.scheme=this.scheme),this.authority&&(A.authority=this.authority),this.query&&(A.query=this.query),this.fragment&&(A.fragment=this.fragment),A}}const _={[E.CharCode.Colon]:"%3A",[E.CharCode.Slash]:"%2F",[E.CharCode.QuestionMark]:"%3F",[E.CharCode.Hash]:"%23",[E.CharCode.OpenSquareBracket]:"%5B",[E.CharCode.CloseSquareBracket]:"%5D",[E.CharCode.AtSign]:"%40",[E.CharCode.ExclamationMark]:"%21",[E.CharCode.DollarSign]:"%24",[E.CharCode.Ampersand]:"%26",[E.CharCode.SingleQuote]:"%27",[E.CharCode.OpenParen]:"%28",[E.CharCode.CloseParen]:"%29",[E.CharCode.Asterisk]:"%2A",[E.CharCode.Plus]:"%2B",[E.CharCode.Comma]:"%2C",[E.CharCode.Semicolon]:"%3B",[E.CharCode.Equals]:"%3D",[E.CharCode.Space]:"%20"};function y(h,A,o){let D,O=-1;for(let $=0;$<h.length;$++){const g=h.charCodeAt($);if(g>=E.CharCode.a&&g<=E.CharCode.z||g>=E.CharCode.A&&g<=E.CharCode.Z||g>=E.CharCode.Digit0&&g<=E.CharCode.Digit9||g===E.CharCode.Dash||g===E.CharCode.Period||g===E.CharCode.Underline||g===E.CharCode.Tilde||A&&g===E.CharCode.Slash||o&&g===E.CharCode.OpenSquareBracket||o&&g===E.CharCode.CloseSquareBracket||o&&g===E.CharCode.Colon)O!==-1&&(D+=encodeURIComponent(h.substring(O,$)),O=-1),D!==void 0&&(D+=h.charAt($));else{D===void 0&&(D=h.substr(0,$));const K=_[g];K!==void 0?(O!==-1&&(D+=encodeURIComponent(h.substring(O,$)),O=-1),D+=K):O===-1&&(O=$)}}return O!==-1&&(D+=encodeURIComponent(h.substring(O))),D!==void 0?D:h}function s(h){let A;for(let o=0;o<h.length;o++){const D=h.charCodeAt(o);D===E.CharCode.Hash||D===E.CharCode.QuestionMark?(A===void 0&&(A=h.substr(0,o)),A+=_[D]):A!==void 0&&(A+=h[o])}return A!==void 0?A:h}function n(h,A){let o;return h.authority&&h.path.length>1&&h.scheme==="file"?o=`//${h.authority}${h.path}`:h.path.charCodeAt(0)===E.CharCode.Slash&&(h.path.charCodeAt(1)>=E.CharCode.A&&h.path.charCodeAt(1)<=E.CharCode.Z||h.path.charCodeAt(1)>=E.CharCode.a&&h.path.charCodeAt(1)<=E.CharCode.z)&&h.path.charCodeAt(2)===E.CharCode.Colon?A?o=h.path.substr(1):o=h.path[1].toLowerCase()+h.path.substr(2):o=h.path,M.$c&&(o=o.replace(/\//g,"\\")),o}function i(h,A){const o=A?s:y;let D="",{scheme:O,authority:$,path:g,query:K,fragment:re}=h;if(O&&(D+=O,D+=":"),($||O==="file")&&(D+=F,D+=F),$){let ee=$.indexOf("@");if(ee!==-1){const X=$.substr(0,ee);$=$.substr(ee+1),ee=X.lastIndexOf(":"),ee===-1?D+=o(X,!1,!1):(D+=o(X.substr(0,ee),!1,!1),D+=":",D+=o(X.substr(ee+1),!1,!0)),D+="@"}$=$.toLowerCase(),ee=$.lastIndexOf(":"),ee===-1?D+=o($,!1,!0):(D+=o($.substr(0,ee),!1,!0),D+=$.substr(ee))}if(g){if(g.length>=3&&g.charCodeAt(0)===E.CharCode.Slash&&g.charCodeAt(2)===E.CharCode.Colon){const ee=g.charCodeAt(1);ee>=E.CharCode.A&&ee<=E.CharCode.Z&&(g=`/${String.fromCharCode(ee+32)}:${g.substr(3)}`)}else if(g.length>=2&&g.charCodeAt(1)===E.CharCode.Colon){const ee=g.charCodeAt(0);ee>=E.CharCode.A&&ee<=E.CharCode.Z&&(g=`${String.fromCharCode(ee+32)}:${g.substr(2)}`)}D+=o(g,!0,!1)}return K&&(D+="?",D+=o(K,!1,!1)),re&&(D+="#",D+=A?re:y(re,!1,!1)),D}function f(h){try{return decodeURIComponent(h)}catch{return h.length>3?h.substr(0,3)+f(h.substr(3)):h}}const u=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function P(h){return h.match(u)?h.replace(u,A=>f(A)):h}}),define(Ee[47],_e([0,1,5]),function($e,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=t,e.$6q=j,e.$7q=M,e.log=N;function t(S){const k=S;return k&&typeof k.type=="string"&&typeof k.severity=="string"}function j(S){const k=[];let w;try{const I=JSON.parse(S.arguments),F=I[I.length-1];F&&F.__$stack&&(I.pop(),w=F.__$stack),k.push(...I)}catch{k.push("Unable to log remote console arguments",S.arguments)}return{args:k,stack:w}}function M(S){if(typeof S!="string")return M(j(S).stack);const k=S;if(k){const w=V(k),I=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(I&&I.length===4)return{uri:E.URI.file(I[1]),line:Number(I[2]),column:Number(I[3])}}}function V(S){if(!S)return S;const k=S.indexOf(`
`);return k===-1?S:S.substring(0,k)}function N(S,k){const{args:w,stack:I}=j(S),F=typeof w[0]=="string"&&w.length===1;let c=V(I);c&&(c=`(${c.trim()})`);let r=[];if(typeof w[0]=="string"?c&&F?r=[`%c[${k}] %c${w[0]} %c${c}`,U("blue"),U(""),U("grey")]:r=[`%c[${k}] %c${w[0]}`,U("blue"),U(""),...w.slice(1)]:r=[`%c[${k}]%`,U("blue"),...w],c&&!F&&r.push(c),typeof console[S.severity]!="function")throw new Error("Unknown console method");console[S.severity].apply(console,r)}function U(S){return`color: ${S}`}}),define(Ee[48],_e([0,1,16,5,27]),function($e,e,E,t,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=M,e.$9h=V,e.$0h=U;function M(S){return JSON.stringify(S,N)}function V(S){let k=JSON.parse(S);return k=U(k),k}function N(S,k){return k instanceof RegExp?{$mid:j.MarshalledId.Regexp,source:k.source,flags:k.flags}:k}function U(S,k=0){if(!S||k>200)return S;if(typeof S=="object"){switch(S.$mid){case j.MarshalledId.Uri:return t.URI.revive(S);case j.MarshalledId.Regexp:return new RegExp(S.source,S.flags);case j.MarshalledId.Date:return new Date(S.source)}if(S instanceof E.$Je||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let w=0;w<S.length;++w)S[w]=U(S[w],k+1);else for(const w in S)Object.hasOwnProperty.call(S,w)&&(S[w]=U(S[w],k+1))}return S}}),define(Ee[31],_e([0,1,9,2,7,5,3]),function($e,e,E,t,j,M,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=U,e.$Kg=S,e.$Og=w;var N;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(N||(e.Schemas=N={}));function U(c,r){return M.URI.isUri(c)?(0,j.$Bf)(c.scheme,r):(0,j.$Cf)(c,r+":")}function S(c,...r){return r.some(d=>U(c,d))}e.$Lg="vscode-tkn",e.$Mg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,d){this.f=w(r,d)}getServerRootPath(){return this.f}get g(){return V.$gc.join(this.f,N.vscodeRemoteResource)}set(r,d,m){this.a[r]=d,this.b[r]=m}setConnectionToken(r,d){this.c[r]=d}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(s){return E.$1(s),r}const d=r.authority;let m=this.a[d];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const l=this.b[d],_=this.c[d];let y=`path=${encodeURIComponent(r.path)}`;return typeof _=="string"&&(y+=`&${e.$Mg}=${encodeURIComponent(_)}`),M.URI.from({scheme:t.$i?this.d:N.vscodeRemoteResource,authority:`${m}:${l}`,path:t.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:y})}}e.$Ng=new k;function w(c,r){return V.$gc.join(r??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class I{asBrowserUri(r){const d=this.b(r,$e);return this.uriToBrowserUri(d)}uriToBrowserUri(r){return r.scheme===N.vscodeRemote?e.$Ng.rewrite(r):r.scheme===N.file&&(t.$g||t.$k===`${N.vscodeFileResource}://${I.a}`)?r.with({scheme:N.vscodeFileResource,authority:r.authority||I.a,query:null,fragment:null}):r}asFileUri(r){const d=this.b(r,$e);return this.uriToFileUri(d)}uriToFileUri(r){return r.scheme===N.vscodeFileResource?r.with({scheme:N.file,authority:r.authority!==I.a?r.authority:null,query:null,fragment:null}):r}b(r,d){return M.URI.isUri(r)?r:M.URI.parse(d.toUrl(r))}}I.a=e.$Tg,e.$Ug=new I;var F;(function(c){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(r.get("3"));const d="vscode-coi";function m(_){let y;typeof _=="string"?y=new URL(_).searchParams:_ instanceof URL?y=_.searchParams:M.URI.isUri(_)&&(y=new URL(_.toString(!0)).searchParams);const s=y?.get(d);if(s)return r.get(s)}c.getHeadersFromQuery=m;function l(_,y,s){if(!globalThis.crossOriginIsolated)return;const n=y&&s?"3":s?"2":"1";_ instanceof URLSearchParams?_.set(d,n):_[d]=n}c.addSearchParam=l})(F||(e.COI=F={}))}),define(Ee[22],_e([0,1,11,14,31,3,2,7,5]),function($e,e,E,t,j,M,V,N,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=S,e.$kh=w,e.$lh=F;function S(c){return(0,U.$wc)(c,!0)}class k{constructor(r){this.a=r}compare(r,d,m=!1){return r===d?0:(0,N.$uf)(this.getComparisonKey(r,m),this.getComparisonKey(d,m))}isEqual(r,d,m=!1){return r===d?!0:!r||!d?!1:this.getComparisonKey(r,m)===this.getComparisonKey(d,m)}getComparisonKey(r,d=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,d,m=!1){if(r.scheme===d.scheme){if(r.scheme===j.Schemas.file)return t.$zg(S(r),S(d),this.a(r))&&r.query===d.query&&(m||r.fragment===d.fragment);if((0,e.$gh)(r.authority,d.authority))return t.$zg(r.path,d.path,this.a(r),"/")&&r.query===d.query&&(m||r.fragment===d.fragment)}return!1}joinPath(r,...d){return U.URI.joinPath(r,...d)}basenameOrAuthority(r){return(0,e.$$g)(r)||r.authority}basename(r){return M.$gc.basename(r.path)}extname(r){return M.$gc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let d;return r.scheme===j.Schemas.file?d=U.URI.file(M.$mc(S(r))).path:(d=M.$gc.dirname(r.path),r.authority&&d.length&&d.charCodeAt(0)!==E.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),d="/")),r.with({path:d})}normalizePath(r){if(!r.path.length)return r;let d;return r.scheme===j.Schemas.file?d=U.URI.file(M.$hc(S(r))).path:d=M.$gc.normalize(r.path),r.with({path:d})}relativePath(r,d){if(r.scheme!==d.scheme||!(0,e.$gh)(r.authority,d.authority))return;if(r.scheme===j.Schemas.file){const _=M.$lc(S(r),S(d));return V.$c?t.$tg(_):_}let m=r.path||"/";const l=d.path||"/";if(this.a(r)){let _=0;for(const y=Math.min(m.length,l.length);_<y&&!(m.charCodeAt(_)!==l.charCodeAt(_)&&m.charAt(_).toLowerCase()!==l.charAt(_).toLowerCase());_++);m=l.substr(0,_)+m.substr(_)}return M.$gc.relative(m,l)}resolvePath(r,d){if(r.scheme===j.Schemas.file){const m=U.URI.file(M.$kc(S(r),d));return r.with({authority:m.authority,path:m.path})}return d=t.$ug(d),r.with({path:M.$gc.resolve(r.path,d)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,d){return r===d||r!==void 0&&d!==void 0&&(0,N.$Bf)(r,d)}hasTrailingPathSeparator(r,d=M.sep){if(r.scheme===j.Schemas.file){const m=S(r);return m.length>t.$vg(m).length&&m[m.length-1]===d}else{const m=r.path;return m.length>1&&m.charCodeAt(m.length-1)===E.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,d=M.sep){return(0,e.$hh)(r,d)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,d=M.sep){let m=!1;if(r.scheme===j.Schemas.file){const l=S(r);m=l!==void 0&&l.length===t.$vg(l).length&&l[l.length-1]===d}else{d="/";const l=r.path;m=l.length===1&&l.charCodeAt(l.length-1)===E.CharCode.Slash}return!m&&!(0,e.$hh)(r,d)?r.with({path:r.path+"/"}):r}}e.$3g=k,e.$4g=new k(()=>!1),e.$5g=new k(c=>c.scheme===j.Schemas.file?!V.$e:!0),e.$6g=new k(c=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function w(c,r){const d=[];for(let m=0;m<c.length;m++){const l=r(c[m]);c.some((_,y)=>y===m?!1:(0,e.$8g)(l,r(_)))||d.push(c[m])}return d}var I;(function(c){c.META_DATA_LABEL="label",c.META_DATA_DESCRIPTION="description",c.META_DATA_SIZE="size",c.META_DATA_MIME="mime";function r(d){const m=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(y=>{const[s,n]=y.split(":");s&&n&&m.set(s,n)});const _=d.path.substring(0,d.path.indexOf(";"));return _&&m.set(c.META_DATA_MIME,_),m}c.parseMetaData=r})(I||(e.DataUri=I={}));function F(c,r,d){if(r){let m=c.path;return m&&m[0]!==M.$gc.sep&&(m=M.$gc.sep+m),c.with({scheme:d,authority:r,path:m})}return c.with({scheme:d})}}),define(Ee[8],_e([0,1,13,9,6,4,22,2,44,15]),function($e,e,E,t,j,M,V,N,U,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=k,e.$nh=w,e.$oh=I,e.$ph=F,e.$qh=c,e.$rh=r,e.$sh=d,e.$th=m,e.$Bh=h,e.$Ch=A,e.$Dh=o,e.$Eh=D,e.$Fh=O,e.$Uh=a,e.$3h=W;function k(B){return!!B&&typeof B.then=="function"}function w(B){const b=new E.$se,H=B(b.token),J=new Promise((ne,ge)=>{const De=b.token.onCancellationRequested(()=>{De.dispose(),ge(new t.$5)});Promise.resolve(H).then(he=>{De.dispose(),b.dispose(),ne(he)},he=>{De.dispose(),b.dispose(),ge(he)})});return new class{cancel(){b.cancel(),b.dispose()}then(ne,ge){return J.then(ne,ge)}catch(ne){return this.then(void 0,ne)}finally(ne){return J.finally(ne)}}}function I(B,b,H){return new Promise((J,ne)=>{const ge=b.onCancellationRequested(()=>{ge.dispose(),J(H)});B.then(J,ne).finally(()=>ge.dispose())})}function F(B,b){return new Promise((H,J)=>{const ne=b.onCancellationRequested(()=>{ne.dispose(),J(new t.$5)});B.then(H,J).finally(()=>ne.dispose())})}async function c(B){let b=-1;const H=B.map((J,ne)=>J.then(ge=>(b=ne,ge)));try{return await Promise.race(H)}finally{B.forEach((J,ne)=>{ne!==b&&J.cancel()})}}function r(B,b,H){let J;const ne=setTimeout(()=>{J?.(void 0),H?.()},b);return Promise.race([B.finally(()=>clearTimeout(ne)),new Promise(ge=>J=ge)])}function d(B){return new Promise((b,H)=>{const J=B();k(J)?J.then(b,H):b(J)})}function m(){let B,b;return{promise:new Promise((J,ne)=>{B=J,b=ne}),resolve:B,reject:b}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(b){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=b,!this.b){const H=()=>{if(this.b=null,this.f)return;const J=this.queue(this.d);return this.d=null,J};this.b=new Promise(J=>{this.a.then(H,H).then(J)})}return new Promise((H,J)=>{this.b.then(H,J)})}return this.a=b(),new Promise((H,J)=>{this.a.then(ne=>{this.a=null,H(ne)},ne=>{this.a=null,J(ne)})})}dispose(){this.f=!0}}e.$uh=l;class _{constructor(){this.a=Promise.resolve(null)}queue(b){return this.a=this.a.then(()=>b(),()=>b())}}e.$vh=_;class y{constructor(){this.a=new Map}queue(b,H){const ne=(this.a.get(b)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.a.get(b)===ne&&this.a.delete(b)});return this.a.set(b,ne),ne}}e.$wh=y;const s=(B,b)=>{let H=!0;const J=setTimeout(()=>{H=!1,b()},B);return{isTriggered:()=>H,dispose:()=>{clearTimeout(J),H=!1}}},n=B=>{let b=!0;return queueMicrotask(()=>{b&&(b=!1,B())}),{isTriggered:()=>b,dispose:()=>{b=!1}}};class i{constructor(b){this.defaultDelay=b,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(b,H=this.defaultDelay){this.g=b,this.h(),this.b||(this.b=new Promise((ne,ge)=>{this.d=ne,this.f=ge}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const J=()=>{this.a=null,this.d?.(null)};return this.a=H===U.$ce?n(J):s(H,J),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=i;class f{constructor(b){this.a=new i(b),this.b=new l}trigger(b,H){return this.a.trigger(()=>this.b.queue(b),H)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=f;class u{constructor(){this.a=!1,this.b=new Promise((b,H)=>{this.d=b})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=u;class P extends u{constructor(b){super(),this.f=setTimeout(()=>this.open(),b)}open(){clearTimeout(this.f),super.open()}}e.$Ah=P;function h(B,b){return b?new Promise((H,J)=>{const ne=setTimeout(()=>{ge.dispose(),H()},B),ge=b.onCancellationRequested(()=>{clearTimeout(ne),ge.dispose(),J(new t.$5)})}):w(H=>h(B,H))}function A(B,b=0,H){const J=setTimeout(()=>{B(),H&&ne.dispose()},b),ne=(0,M.$Sc)(()=>{clearTimeout(J),H?.deleteAndLeak(ne)});return H?.add(ne),ne}function o(B){const b=[];let H=0;const J=B.length;function ne(){return H<J?B[H++]():null}function ge(De){De!=null&&b.push(De);const he=ne();return he?he.then(ge):Promise.resolve(b)}return Promise.resolve(null).then(ge)}function D(B,b=J=>!!J,H=null){let J=0;const ne=B.length,ge=()=>{if(J>=ne)return Promise.resolve(H);const De=B[J++];return Promise.resolve(De()).then(fe=>b(fe)?Promise.resolve(fe):ge())};return ge()}function O(B,b=J=>!!J,H=null){if(B.length===0)return Promise.resolve(H);let J=B.length;const ne=()=>{J=-1;for(const ge of B)ge.cancel?.()};return new Promise((ge,De)=>{for(const he of B)he.then(fe=>{--J>=0&&b(fe)?(ne(),ge(fe)):J===0&&ge(H)}).catch(fe=>{--J>=0&&(ne(),De(fe))})})}class ${constructor(b){this.a=0,this.b=!1,this.f=b,this.g=[],this.d=0,this.h=new j.$he}whenIdle(){return this.size>0?j.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(b){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((H,J)=>{this.g.push({factory:b,c:H,e:J}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const b=this.g.shift();this.d++;const H=b.factory();H.then(b.c,b.e),H.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=$;class g extends ${constructor(){super(1)}}e.$Hh=g;class K{constructor(){this.a=new T,this.b=0}queue(b){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,b())):this.a.run(this.b++,b())}}e.$Ih=K;class re{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const b=new v;return this.b.add(b),b.p}g(){for(const[,b]of this.a)if(b.size>0)return!1;return!0}queueSize(b,H=V.$4g){const J=H.getComparisonKey(b);return this.a.get(J)?.size??0}queueFor(b,H,J=V.$4g){const ne=J.getComparisonKey(b);let ge=this.a.get(ne);if(!ge){ge=new g;const De=this.f++,he=j.Event.once(ge.onDrained)(()=>{ge?.dispose(),this.a.delete(ne),this.h(),this.d?.deleteAndDispose(De),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$4c),this.d.set(De,he),this.a.set(ne,ge)}return ge.queue(H)}h(){this.g()&&this.j()}j(){for(const b of this.b)b.complete();this.b.clear()}dispose(){for(const[,b]of this.a)b.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=re;class ee{constructor(b,H){this.b=!1,this.a=-1,typeof b=="function"&&typeof H=="number"&&this.setIfNotSet(b,H)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(b,H){if(this.b)throw new t.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,b()},H)}setIfNotSet(b,H){if(this.b)throw new t.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,b()},H))}}e.$Kh=ee;class X{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(b,H,J=globalThis){if(this.f)throw new t.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ne=J.setInterval(()=>{b()},H);this.d=(0,M.$Sc)(()=>{J.clearInterval(ne),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=X;class se{constructor(b,H){this.b=-1,this.a=b,this.d=H,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(b=this.d){this.cancel(),this.b=setTimeout(this.f,b)}get delay(){return this.d}set delay(b){this.d=b}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=se;class Y{constructor(b,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.a=b,this.b=H,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(b=this.b){b%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${b}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(b/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=Y;class te extends se{constructor(b,H){super(b,H),this.j=[]}work(b){this.j.push(b),this.isScheduled()||this.schedule()}h(){const b=this.j;this.j=[],this.a?.(b)}dispose(){this.j=[],super.dispose()}}e.$Oh=te;class ue extends M.$Uc{constructor(b,H){super(),this.g=b,this.h=H,this.a=[],this.b=this.B(new M.$Vc),this.f=!1}get pending(){return this.a.length}work(b){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+b.length>this.g.maxBufferedWork)return!1}else if(this.pending+b.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const H of b)this.a.push(H);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=ue,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(B,b)=>{(0,N.$v)(()=>{if(H)return;const J=Date.now()+15;b(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,J-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$Rh=(B,b,H)=>{const J=B.requestIdleCallback(b,typeof H=="number"?{timeout:H}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,B.cancelIdleCallback(J))}}},e.$Qh=B=>(0,e.$Rh)(globalThis,B)}();class ce{constructor(b,H){this.g=!1,this.d=()=>{try{this.j=H()}catch(J){this.l=J}finally{this.g=!0}},this.f=(0,e.$Rh)(b,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=ce;class L extends ce{constructor(b){super(globalThis,b)}}e.$Th=L;async function a(B,b,H){let J;for(let ne=0;ne<H;ne++)try{return await B()}catch(ge){J=ge,await h(b)}throw J}class T{isRunning(b){return typeof b=="number"?this.a?.taskId===b:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(b,H,J){return this.a={taskId:b,cancel:()=>J?.(),promise:H},H.then(()=>this.d(b),()=>this.d(b)),H}d(b){this.a&&b===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const b=this.b;this.b=void 0,b.run().then(b.promiseResolve,b.promiseReject)}}queue(b){if(this.b)this.b.run=b;else{const{promise:H,resolve:J,reject:ne}=m();this.b={run:b,promise:H,promiseResolve:J,promiseReject:ne}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=T;class q{constructor(b,H=()=>Date.now()){this.d=b,this.f=H,this.a=0,this.b=0}increment(){const b=this.f();return b-this.a>this.d&&(this.a=b,this.b=0),this.b++,this.b}}e.$Wh=q;var Q;(function(B){B[B.Resolved=0]="Resolved",B[B.Rejected=1]="Rejected"})(Q||(Q={}));class v{get isRejected(){return this.d?.outcome===Q.Rejected}get isResolved(){return this.d?.outcome===Q.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===Q.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((b,H)=>{this.a=b,this.b=H})}complete(b){return new Promise(H=>{this.a(b),this.d={outcome:Q.Resolved,value:b},H()})}error(b){return new Promise(H=>{this.b(b),this.d={outcome:Q.Rejected,value:b},H()})}cancel(){return this.error(new t.$5)}}e.$Xh=v;var C;(function(B){async function b(J){let ne;const ge=await Promise.all(J.map(De=>De.then(he=>he,he=>{ne||(ne=he)})));if(typeof ne<"u")throw ne;return ge}B.settled=b;function H(J){return new Promise(async(ne,ge)=>{try{await J(ne,ge)}catch(De){ge(De)}})}B.withAsyncBody=H})(C||(e.Promises=C={}));class Z{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(b){this.a=void 0,this.b=void 0,this.d=!1,this.promise=b.then(H=>(this.a=H,this.d=!0,H),H=>{throw this.b=H,this.d=!0,H})}requireValue(){if(!this.d)throw new t.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=Z;class ie{constructor(b){this.b=b,this.a=new S.$V(()=>new Z(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=ie;var le;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(le||(le={}));class ae{static fromArray(b){return new ae(H=>{H.emitMany(b)})}static fromPromise(b){return new ae(async H=>{H.emitMany(await b)})}static fromPromises(b){return new ae(async H=>{await Promise.all(b.map(async J=>H.emitOne(await J)))})}static merge(b){return new ae(async H=>{await Promise.all(b.map(async J=>{for await(const ne of J)H.emitOne(ne)}))})}constructor(b,H){this.a=le.Initial,this.b=[],this.d=null,this.f=H,this.g=new j.$he,queueMicrotask(async()=>{const J={emitOne:ne=>this.h(ne),emitMany:ne=>this.j(ne),reject:ne=>this.l(ne)};try{await Promise.resolve(b(J)),this.k()}catch(ne){this.l(ne)}finally{J.emitOne=void 0,J.emitMany=void 0,J.reject=void 0}})}[Symbol.asyncIterator](){let b=0;return{next:async()=>{do{if(this.a===le.DoneError)throw this.d;if(b<this.b.length)return{done:!1,value:this.b[b++]};if(this.a===le.DoneOK)return{done:!0,value:void 0};await j.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(b,H){return new ae(async J=>{for await(const ne of b)J.emitOne(H(ne))})}map(b){return ae.map(this,b)}static filter(b,H){return new ae(async J=>{for await(const ne of b)H(ne)&&J.emitOne(ne)})}filter(b){return ae.filter(this,b)}static coalesce(b){return ae.filter(b,H=>!!H)}coalesce(){return ae.coalesce(this)}static async toPromise(b){const H=[];for await(const J of b)H.push(J);return H}toPromise(){return ae.toPromise(this)}h(b){this.a===le.Initial&&(this.b.push(b),this.g.fire())}j(b){this.a===le.Initial&&(this.b=this.b.concat(b),this.g.fire())}k(){this.a===le.Initial&&(this.a=le.DoneOK,this.g.fire())}l(b){this.a===le.Initial&&(this.a=le.DoneError,this.d=b,this.g.fire())}}e.$1h=ae,ae.EMPTY=ae.fromArray([]);class p extends ae{constructor(b,H){super(H),this.m=b}cancel(){this.m.cancel()}}e.$2h=p;function W(B){const b=new E.$se,H=B(b.token);return new p(b,async J=>{const ne=b.token.onCancellationRequested(()=>{ne.dispose(),b.dispose(),J.reject(new t.$5)});try{for await(const ge of H){if(b.token.isCancellationRequested)return;J.emitOne(ge)}ne.dispose(),b.dispose()}catch(ge){ne.dispose(),b.dispose(),J.reject(ge)}})}class G{constructor(b){this.a=new v,this.b=new ae(ne=>{if(H){ne.reject(H);return}return J&&ne.emitMany(J),this.d=ge=>ne.reject(ge),this.f=ge=>ne.emitOne(ge),this.a.p},b);let H,J;this.f=ne=>{J||(J=[]),J.push(ne)},this.d=ne=>{H||(H=ne)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(b){this.d(b),this.a.complete()}emitOne(b){this.f(b)}}e.$4h=G}),define(Ee[23],_e([0,1,12,8,11,14,20,3,2,7]),function($e,e,E,t,j,M,V,N,U,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=k,e.$sk=r,e.$tk=K,e.$uk=re,e.$vk=ee,e.$wk=X,e.$xk=se,e.$yk=ce;function k(){return Object.create(null)}e.$qk="**",e.$rk="/";const w="[/\\\\]",I="[^/\\\\]",F=/\//g;function c(L,a){switch(L){case 0:return"";case 1:return`${I}*?`;default:return`(?:${w}|${I}+${w}${a?`|${w}${I}+`:""})*?`}}function r(L,a){if(!L)return[];const T=[];let q=!1,Q=!1,v="";for(const C of L){switch(C){case a:if(!q&&!Q){T.push(v),v="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":Q=!0;break;case"]":Q=!1;break}v+=C}return v&&T.push(v),T}function d(L){if(!L)return"";let a="";const T=r(L,e.$rk);if(T.every(q=>q===e.$qk))a=".*";else{let q=!1;T.forEach((Q,v)=>{if(Q===e.$qk){if(q)return;a+=c(2,v===T.length-1)}else{let C=!1,Z="",ie=!1,le="";for(const ae of Q){if(ae!=="}"&&C){Z+=ae;continue}if(ie&&(ae!=="]"||!le)){let p;ae==="-"?p=ae:(ae==="^"||ae==="!")&&!le?p="^":ae===e.$rk?p="":p=(0,S.$df)(ae),le+=p;continue}switch(ae){case"{":C=!0;continue;case"[":ie=!0;continue;case"}":{const W=`(?:${r(Z,",").map(G=>d(G)).join("|")})`;a+=W,C=!1,Z="";break}case"]":{a+="["+le+"]",ie=!1,le="";break}case"?":a+=I;continue;case"*":a+=c(1);continue;default:a+=(0,S.$df)(ae)}}v<T.length-1&&(T[v+1]!==e.$qk||v+2<T.length)&&(a+=w)}q=Q===e.$qk})}return a}const m=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,n=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new V.$Dc(1e4),f=function(){return!1},u=function(){return null};function P(L,a){if(!L)return u;let T;typeof L!="string"?T=L.pattern:T=L,T=T.trim();const q=`${T}_${!!a.trimForExclusions}`;let Q=i.get(q);if(Q)return h(Q,L);let v;return m.test(T)?Q=o(T.substr(4),T):(v=l.exec(A(T,a)))?Q=D(v[1],T):(a.trimForExclusions?y:_).test(T)?Q=O(T,a):(v=s.exec(A(T,a)))?Q=$(v[1].substr(1),T,!0):(v=n.exec(A(T,a)))?Q=$(v[1],T,!1):Q=g(T),i.set(q,Q),h(Q,L)}function h(L,a){if(typeof a=="string")return L;const T=function(q,Q){return(0,M.$zg)(q,a.base,!U.$e)?L((0,S.$if)(q.substr(a.base.length),N.sep),Q):null};return T.allBasenames=L.allBasenames,T.allPaths=L.allPaths,T.basenames=L.basenames,T.patterns=L.patterns,T}function A(L,a){return a.trimForExclusions&&L.endsWith("/**")?L.substr(0,L.length-2):L}function o(L,a){return function(T,q){return typeof T=="string"&&T.endsWith(L)?a:null}}function D(L,a){const T=`/${L}`,q=`\\${L}`,Q=function(C,Z){return typeof C!="string"?null:Z?Z===L?a:null:C===L||C.endsWith(T)||C.endsWith(q)?a:null},v=[L];return Q.basenames=v,Q.patterns=[a],Q.allBasenames=v,Q}function O(L,a){const T=ue(L.slice(1,-1).split(",").map(Z=>P(Z,a)).filter(Z=>Z!==u),L),q=T.length;if(!q)return u;if(q===1)return T[0];const Q=function(Z,ie){for(let le=0,ae=T.length;le<ae;le++)if(T[le](Z,ie))return L;return null},v=T.find(Z=>!!Z.allBasenames);v&&(Q.allBasenames=v.allBasenames);const C=T.reduce((Z,ie)=>ie.allPaths?Z.concat(ie.allPaths):Z,[]);return C.length&&(Q.allPaths=C),Q}function $(L,a,T){const q=N.sep===N.$gc.sep,Q=q?L:L.replace(F,N.sep),v=N.sep+Q,C=N.$gc.sep+L;let Z;return T?Z=function(ie,le){return typeof ie=="string"&&(ie===Q||ie.endsWith(v)||!q&&(ie===L||ie.endsWith(C)))?a:null}:Z=function(ie,le){return typeof ie=="string"&&(ie===Q||!q&&ie===L)?a:null},Z.allPaths=[(T?"*/":"./")+L],Z}function g(L){try{const a=new RegExp(`^${d(L)}$`);return function(T){return a.lastIndex=0,typeof T=="string"&&a.test(T)?L:null}}catch{return u}}function K(L,a,T){return!L||typeof a!="string"?!1:re(L)(a,void 0,T)}function re(L,a={}){if(!L)return f;if(typeof L=="string"||ee(L)){const T=P(L,a);if(T===u)return f;const q=function(Q,v){return!!T(Q,v)};return T.allBasenames&&(q.allBasenames=T.allBasenames),T.allPaths&&(q.allPaths=T.allPaths),q}return Y(L,a)}function ee(L){const a=L;return a?typeof a.base=="string"&&typeof a.pattern=="string":!1}function X(L){return L.allBasenames||[]}function se(L){return L.allPaths||[]}function Y(L,a){const T=ue(Object.getOwnPropertyNames(L).map(Z=>te(Z,L[Z],a)).filter(Z=>Z!==u)),q=T.length;if(!q)return u;if(!T.some(Z=>!!Z.requiresSiblings)){if(q===1)return T[0];const Z=function(ae,p){let W;for(let G=0,B=T.length;G<B;G++){const b=T[G](ae,p);if(typeof b=="string")return b;(0,t.$mh)(b)&&(W||(W=[]),W.push(b))}return W?(async()=>{for(const G of W){const B=await G;if(typeof B=="string")return B}return null})():null},ie=T.find(ae=>!!ae.allBasenames);ie&&(Z.allBasenames=ie.allBasenames);const le=T.reduce((ae,p)=>p.allPaths?ae.concat(p.allPaths):ae,[]);return le.length&&(Z.allPaths=le),Z}const Q=function(Z,ie,le){let ae,p;for(let W=0,G=T.length;W<G;W++){const B=T[W];B.requiresSiblings&&le&&(ie||(ie=(0,N.$nc)(Z)),ae||(ae=ie.substr(0,ie.length-(0,N.$oc)(Z).length)));const b=B(Z,ie,ae,le);if(typeof b=="string")return b;(0,t.$mh)(b)&&(p||(p=[]),p.push(b))}return p?(async()=>{for(const W of p){const G=await W;if(typeof G=="string")return G}return null})():null},v=T.find(Z=>!!Z.allBasenames);v&&(Q.allBasenames=v.allBasenames);const C=T.reduce((Z,ie)=>ie.allPaths?Z.concat(ie.allPaths):Z,[]);return C.length&&(Q.allPaths=C),Q}function te(L,a,T){if(a===!1)return u;const q=P(L,T);if(q===u)return u;if(typeof a=="boolean")return q;if(a){const Q=a.when;if(typeof Q=="string"){const v=(C,Z,ie,le)=>{if(!le||!q(C,Z))return null;const ae=Q.replace("$(basename)",()=>ie),p=le(ae);return(0,t.$mh)(p)?p.then(W=>W?L:null):p?L:null};return v.requiresSiblings=!0,v}}return q}function ue(L,a){const T=L.filter(Z=>!!Z.basenames);if(T.length<2)return L;const q=T.reduce((Z,ie)=>{const le=ie.basenames;return le?Z.concat(le):Z},[]);let Q;if(a){Q=[];for(let Z=0,ie=q.length;Z<ie;Z++)Q.push(a)}else Q=T.reduce((Z,ie)=>{const le=ie.patterns;return le?Z.concat(le):Z},[]);const v=function(Z,ie){if(typeof Z!="string")return null;if(!ie){let ae;for(ae=Z.length;ae>0;ae--){const p=Z.charCodeAt(ae-1);if(p===j.CharCode.Slash||p===j.CharCode.Backslash)break}ie=Z.substr(ae)}const le=q.indexOf(ie);return le!==-1?Q[le]:null};v.basenames=q,v.patterns=Q,v.allBasenames=q;const C=L.filter(Z=>!Z.basenames);return C.push(v),C}function ce(L,a){return(0,E.$ub)(L,a,(T,q)=>typeof T=="string"&&typeof q=="string"?T===q:typeof T!="string"&&typeof q!="string"?T.base===q.base&&T.pattern===q.pattern:!1)}}),define(Ee[24],_e([0,1,17,49,63,8,14,21,3,2,22,5]),function($e,e,E,t,j,M,V,N,U,S,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=_,e.whenDeleted=n,e.configureFlushOnWrite=h,e.writeFileSync=o;var I;(function(Y){Y[Y.UNLINK=0]="UNLINK",Y[Y.MOVE=1]="MOVE"})(I||(e.RimRafMode=I={}));async function F(Y,te=I.UNLINK,ue){if((0,V.$Dg)(Y))throw new Error("rimraf - will refuse to recursively delete root");return te===I.UNLINK?r(Y):c(Y,ue)}async function c(Y,te=(0,V.$Ig)((0,t.tmpdir)())){try{try{await E.promises.rename(Y,te)}catch(ue){return ue.code==="ENOENT"?void 0:r(Y)}r(te).catch(ue=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function r(Y){return(0,j.promisify)(E.rm)(Y,{recursive:!0,force:!0,maxRetries:3})}function d(Y){if((0,V.$Dg)(Y))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(Y,{recursive:!0,force:!0,maxRetries:3})}async function m(Y,te){return y(await(te?l(Y):(0,j.promisify)(E.readdir)(Y)))}async function l(Y){try{return await(0,j.promisify)(E.readdir)(Y,{withFileTypes:!0})}catch(ce){console.warn("[node.js fs] readdir with filetypes failed with error: ",ce)}const te=[],ue=await m(Y);for(const ce of ue){let L=!1,a=!1,T=!1;try{const q=await e.Promises.lstat((0,U.$jc)(Y,ce));L=q.isFile(),a=q.isDirectory(),T=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}te.push({name:ce,isFile:()=>L,isDirectory:()=>a,isSymbolicLink:()=>T})}return te}function _(Y){return y(E.readdirSync(Y))}function y(Y){return Y.map(te=>typeof te=="string"?S.$d?(0,N.$hm)(te):te:(te.name=S.$d?(0,N.$hm)(te.name):te.name,te))}async function s(Y){const te=await m(Y),ue=[];for(const ce of te)await i.existsDirectory((0,U.$jc)(Y,ce))&&ue.push(ce);return ue}function n(Y,te=1e3){return new Promise(ue=>{let ce=!1;const L=setInterval(()=>{ce||(ce=!0,E.access(Y,a=>{ce=!1,a&&(clearInterval(L),ue(void 0))}))},te)})}var i;(function(Y){async function te(L){let a;try{if(a=await e.Promises.lstat(L),!a.isSymbolicLink())return{stat:a}}catch{}try{return{stat:await e.Promises.stat(L),symbolicLink:a?.isSymbolicLink()?{dangling:!1}:void 0}}catch(T){if(T.code==="ENOENT"&&a)return{stat:a,symbolicLink:{dangling:!0}};if(S.$c&&T.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(L)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&a)return{stat:a,symbolicLink:{dangling:!0}};throw q}throw T}}Y.stat=te;async function ue(L){try{const{stat:a,symbolicLink:T}=await Y.stat(L);return a.isFile()&&T?.dangling!==!0}catch{}return!1}Y.existsFile=ue;async function ce(L){try{const{stat:a,symbolicLink:T}=await Y.stat(L);return a.isDirectory()&&T?.dangling!==!0}catch{}return!1}Y.existsDirectory=ce})(i||(e.SymlinkSupport=i={}));const f=new M.$Jh;function u(Y,te,ue){return f.queueFor(w.URI.file(Y),()=>{const ce=D(ue);return new Promise((L,a)=>A(Y,te,ce,T=>T?a(T):L()))},k.$5g)}let P=!0;function h(Y){P=Y}function A(Y,te,ue,ce){if(!P)return E.writeFile(Y,te,{mode:ue.mode,flag:ue.flag},ce);E.open(Y,ue.flag,ue.mode,(L,a)=>{if(L)return ce(L);E.writeFile(a,te,T=>{if(T)return E.close(a,()=>ce(T));E.fdatasync(a,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),h(!1)),E.close(a,Q=>ce(Q))))})})}function o(Y,te,ue){const ce=D(ue);if(!P)return E.writeFileSync(Y,te,{mode:ce.mode,flag:ce.flag});const L=E.openSync(Y,ce.flag,ce.mode);try{E.writeFileSync(L,te);try{E.fdatasyncSync(L)}catch(a){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",a),h(!1)}}finally{E.closeSync(L)}}function D(Y){return Y?{mode:typeof Y.mode=="number"?Y.mode:438,flag:typeof Y.flag=="string"?Y.flag:"w"}:{mode:438,flag:"w"}}async function O(Y,te,ue=6e4){if(Y!==te)try{S.$c&&typeof ue=="number"?await $(Y,te,Date.now(),ue):await(0,j.promisify)(E.rename)(Y,te)}catch(ce){if(Y.toLowerCase()!==te.toLowerCase()&&ce.code==="EXDEV"||Y.endsWith("."))await g(Y,te,{preserveSymlinks:!1}),await F(Y,I.MOVE);else throw ce}}async function $(Y,te,ue,ce,L=0){try{return await(0,j.promisify)(E.rename)(Y,te)}catch(a){if(a.code!=="EACCES"&&a.code!=="EPERM"&&a.code!=="EBUSY")throw a;if(Date.now()-ue>=ce)throw console.error(`[node.js fs] rename failed after ${L} retries with error: ${a}`),a;if(L===0){let T=!1;try{const{stat:q}=await i.stat(te);q.isFile()||(T=!0)}catch{}if(T)throw a}return await(0,M.$Bh)(Math.min(100,L*10)),$(Y,te,ue,ce,L+1)}}async function g(Y,te,ue){return re(Y,te,{root:{source:Y,target:te},options:ue,handledSourcePaths:new Set})}const K=511;async function re(Y,te,ue){if(ue.handledSourcePaths.has(Y))return;ue.handledSourcePaths.add(Y);const{stat:ce,symbolicLink:L}=await i.stat(Y);if(L){if(ue.options.preserveSymlinks)try{return await se(Y,te,ue)}catch{}if(L.dangling)return}return ce.isDirectory()?ee(Y,te,ce.mode&K,ue):X(Y,te,ce.mode&K)}async function ee(Y,te,ue,ce){await e.Promises.mkdir(te,{recursive:!0,mode:ue});const L=await m(Y);for(const a of L)await re((0,U.$jc)(Y,a),(0,U.$jc)(te,a),ce)}async function X(Y,te,ue){await e.Promises.copyFile(Y,te),await e.Promises.chmod(te,ue)}async function se(Y,te,ue){let ce=await e.Promises.readlink(Y);(0,V.$zg)(ce,ue.root.source,!S.$e)&&(ce=(0,U.$jc)(ue.root.target,ce.substr(ue.root.source.length+1))),await e.Promises.symlink(ce,te)}e.Promises=new class{get access(){return(0,j.promisify)(E.access)}get stat(){return(0,j.promisify)(E.stat)}get lstat(){return(0,j.promisify)(E.lstat)}get utimes(){return(0,j.promisify)(E.utimes)}get read(){return(Y,te,ue,ce,L)=>new Promise((a,T)=>{E.read(Y,te,ue,ce,L,(q,Q,v)=>q?T(q):a({bytesRead:Q,buffer:v}))})}get readFile(){return(0,j.promisify)(E.readFile)}get write(){return(Y,te,ue,ce,L)=>new Promise((a,T)=>{E.write(Y,te,ue,ce,L,(q,Q,v)=>q?T(q):a({bytesWritten:Q,buffer:v}))})}get appendFile(){return(0,j.promisify)(E.appendFile)}get fdatasync(){return(0,j.promisify)(E.fdatasync)}get truncate(){return(0,j.promisify)(E.truncate)}get copyFile(){return(0,j.promisify)(E.copyFile)}get open(){return(0,j.promisify)(E.open)}get close(){return(0,j.promisify)(E.close)}get symlink(){return(0,j.promisify)(E.symlink)}get readlink(){return(0,j.promisify)(E.readlink)}get chmod(){return(0,j.promisify)(E.chmod)}get mkdir(){return(0,j.promisify)(E.mkdir)}get unlink(){return(0,j.promisify)(E.unlink)}get rmdir(){return(0,j.promisify)(E.rmdir)}get realpath(){return(0,j.promisify)(E.realpath)}async exists(Y){try{return await e.Promises.access(Y),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return s}get writeFile(){return u}get rm(){return F}get rename(){return O}get copy(){return g}}}),define(Ee[32],_e([0,1,17,3,2,7,24]),function($e,e,E,t,j,M,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=N,e.$br=U,e.$cr=S,e.$dr=k;function N(I){if(j.$e)return I;const F=(0,t.$mc)(I);if(I===F)return I;const c=((0,t.$nc)(I)||I).toLowerCase();try{const d=(0,V.readdirSync)(F).filter(m=>m.toLowerCase()===c);if(d.length===1){const m=N(F);if(m)return(0,t.$jc)(m,d[0])}else if(d.length>1){const m=d.indexOf(c);if(m>=0){const l=N(F);if(l)return(0,t.$jc)(l,d[m])}}}catch{}return null}async function U(I,F){if(j.$e)return I;const c=(0,t.$mc)(I);if(I===c)return I;const r=((0,t.$nc)(I)||I).toLowerCase();try{if(F?.isCancellationRequested)return null;const m=(await V.Promises.readdir(c)).filter(l=>l.toLowerCase()===r);if(m.length===1){const l=await U(c,F);if(l)return(0,t.$jc)(l,m[0])}else if(m.length>1){const l=m.indexOf(r);if(l>=0){const _=await U(c,F);if(_)return(0,t.$jc)(_,m[l])}}}catch{}return null}async function S(I){try{return await V.Promises.realpath(I)}catch{const c=w(I);return await V.Promises.access(c,E.constants.R_OK),c}}function k(I){try{return E.realpathSync(I)}catch{const c=w(I);return E.accessSync(c,E.constants.R_OK),c}}function w(I){return(0,M.$jf)((0,t.$hc)(I),t.sep)}}),define(Ee[50],_e([0,1,3,2,28,29,10,24]),function($e,e,E,t,j,M,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$um=U,e.$vm=S,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function U(w=j.env){return w.comspec||"cmd.exe"}function S(w){let I=[],F=!1;const c=function(r){if(F){I.push(r);return}(!w.send(r,m=>{if(m&&console.error(m),F=!1,I.length>0){const l=I.slice(0);I=[],l.forEach(_=>c(_))}})||t.$c)&&(F=!0)};return{send:c}}var k;(function(w){async function I(F,c,r){if(E.$ic(F))return F;if(c===void 0&&(c=j.cwd()),E.$mc(F)!=="."||(r===void 0&&V.$ag(j.env.PATH)&&(r=j.env.PATH.split(E.$tc)),r===void 0||r.length===0))return E.$jc(c,F);async function m(l){if(await N.Promises.exists(l)){let _;try{_=await N.Promises.stat(l)}catch(y){y.message.startsWith("EACCES")&&(_=await N.Promises.lstat(l))}return _?!_.isDirectory():!1}return!1}for(const l of r){let _;if(E.$ic(l)?_=E.$jc(l,F):_=E.$jc(c,l,F),await m(_))return _;let y=_+".com";if(await m(y)||(y=_+".exe",await m(y)))return y}return E.$jc(c,F)}w.findExecutable=I})(k||(e.win32=k={}))});var Ke=this&&this.__decorate||function($e,e,E,t){var j=arguments.length,M=j<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,E):t,V;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate($e,e,E,t);else for(var N=$e.length-1;N>=0;N--)(V=$e[N])&&(M=(j<3?V(M):j>3?V(e,E,M):V(e,E))||M);return j>3&&M&&Object.defineProperty(e,E,M),M};define(Ee[25],_e([0,1,12,8,16,13,38,9,6,4,48,7,10]),function($e,e,E,t,j,M,V,N,U,S,k,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=h,e.$bi=A,e.$gi=K,e.$hi=re;var F;(function(L){L[L.Promise=100]="Promise",L[L.PromiseCancel=101]="PromiseCancel",L[L.EventListen=102]="EventListen",L[L.EventDispose=103]="EventDispose"})(F||(F={}));function c(L){switch(L){case F.Promise:return"req";case F.PromiseCancel:return"cancel";case F.EventListen:return"subscribe";case F.EventDispose:return"unsubscribe"}}var r;(function(L){L[L.Initialize=200]="Initialize",L[L.PromiseSuccess=201]="PromiseSuccess",L[L.PromiseError=202]="PromiseError",L[L.PromiseErrorObj=203]="PromiseErrorObj",L[L.EventFire=204]="EventFire"})(r||(r={}));function d(L){switch(L){case r.Initialize:return"init";case r.PromiseSuccess:return"reply:";case r.PromiseError:case r.PromiseErrorObj:return"replyErr:";case r.EventFire:return"event:"}}var m;(function(L){L[L.Uninitialized=0]="Uninitialized",L[L.Idle=1]="Idle"})(m||(m={}));function l(L){let a=0;for(let T=0;;T+=7){const q=L.read(1);if(a|=(q.buffer[0]&127)<<T,!(q.buffer[0]&128))return a}}const _=f(0);function y(L,a){if(a===0){L.write(_);return}let T=0;for(let Q=a;Q!==0;Q=Q>>>7)T++;const q=j.$Je.alloc(T);for(let Q=0;a!==0;Q++)q.buffer[Q]=a&127,a=a>>>7,a>0&&(q.buffer[Q]|=128);L.write(q)}class s{constructor(a){this.b=a,this.a=0}read(a){const T=this.b.slice(this.a,this.a+a);return this.a+=T.byteLength,T}}e.$$h=s;class n{constructor(){this.a=[]}get buffer(){return j.$Je.concat(this.a)}write(a){this.a.push(a)}}e.$_h=n;var i;(function(L){L[L.Undefined=0]="Undefined",L[L.String=1]="String",L[L.Buffer=2]="Buffer",L[L.VSBuffer=3]="VSBuffer",L[L.Array=4]="Array",L[L.Object=5]="Object",L[L.Int=6]="Int"})(i||(i={}));function f(L){const a=j.$Je.alloc(1);return a.writeUInt8(L,0),a}const u={Undefined:f(i.Undefined),String:f(i.String),Buffer:f(i.Buffer),VSBuffer:f(i.VSBuffer),Array:f(i.Array),Object:f(i.Object),Uint:f(i.Int)},P=typeof Buffer<"u";function h(L,a){if(typeof a>"u")L.write(u.Undefined);else if(typeof a=="string"){const T=j.$Je.fromString(a);L.write(u.String),y(L,T.byteLength),L.write(T)}else if(P&&Buffer.isBuffer(a)){const T=j.$Je.wrap(a);L.write(u.Buffer),y(L,T.byteLength),L.write(T)}else if(a instanceof j.$Je)L.write(u.VSBuffer),y(L,a.byteLength),L.write(a);else if(Array.isArray(a)){L.write(u.Array),y(L,a.length);for(const T of a)h(L,T)}else if(typeof a=="number"&&(a|0)===a)L.write(u.Uint),y(L,a);else{const T=j.$Je.fromString(JSON.stringify(a));L.write(u.Object),y(L,T.byteLength),L.write(T)}}function A(L){switch(L.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return L.read(l(L)).toString();case i.Buffer:return L.read(l(L)).buffer;case i.VSBuffer:return L.read(l(L));case i.Array:{const T=l(L),q=[];for(let Q=0;Q<T;Q++)q.push(A(L));return q}case i.Object:return JSON.parse(L.read(l(L)).toString());case i.Int:return l(L)}}class o{constructor(a,T,q=null,Q=1e3){this.h=a,this.j=T,this.k=q,this.l=Q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(v=>this.q(v)),this.m({type:r.Initialize})}registerChannel(a,T){this.b.set(a,T),setTimeout(()=>this.w(a),0)}m(a){switch(a.type){case r.Initialize:{const T=this.o([a.type]);this.k?.logOutgoing(T,0,D.OtherSide,d(a.type));return}case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:{const T=this.o([a.type,a.id],a.data);this.k?.logOutgoing(T,a.id,D.OtherSide,d(a.type),a.data);return}}}o(a,T=void 0){const q=new n;return h(q,a),h(q,T),this.p(q.buffer)}p(a){try{return this.h.send(a),a.byteLength}catch{return 0}}q(a){const T=new s(a),q=A(T),Q=A(T),v=q[0];switch(v){case F.Promise:return this.k?.logIncoming(a.byteLength,q[1],D.OtherSide,`${c(v)}: ${q[2]}.${q[3]}`,Q),this.s({type:v,id:q[1],channelName:q[2],name:q[3],arg:Q});case F.EventListen:return this.k?.logIncoming(a.byteLength,q[1],D.OtherSide,`${c(v)}: ${q[2]}.${q[3]}`,Q),this.t({type:v,id:q[1],channelName:q[2],name:q[3],arg:Q});case F.PromiseCancel:return this.k?.logIncoming(a.byteLength,q[1],D.OtherSide,`${c(v)}`),this.u({type:v,id:q[1]});case F.EventDispose:return this.k?.logIncoming(a.byteLength,q[1],D.OtherSide,`${c(v)}`),this.u({type:v,id:q[1]})}}s(a){const T=this.b.get(a.channelName);if(!T){this.v(a);return}const q=new M.$se;let Q;try{Q=T.call(this.j,a.name,a.arg,q.token)}catch(Z){Q=Promise.reject(Z)}const v=a.id;Q.then(Z=>{this.m({id:v,data:Z,type:r.PromiseSuccess})},Z=>{Z instanceof Error?this.m({id:v,data:{message:Z.message,name:Z.name,stack:Z.stack?Z.stack.split?Z.stack.split(`
`):Z.stack:void 0},type:r.PromiseError}):this.m({id:v,data:Z,type:r.PromiseErrorObj})}).finally(()=>{C.dispose(),this.d.delete(a.id)});const C=(0,S.$Sc)(()=>q.cancel());this.d.set(a.id,C)}t(a){const T=this.b.get(a.channelName);if(!T){this.v(a);return}const q=a.id,v=T.listen(this.j,a.name,a.arg)(C=>this.m({id:q,data:C,type:r.EventFire}));this.d.set(a.id,v)}u(a){const T=this.d.get(a.id);T&&(T.dispose(),this.d.delete(a.id))}v(a){let T=this.g.get(a.channelName);T||(T=[],this.g.set(a.channelName,T));const q=setTimeout(()=>{console.error(`Unknown channel: ${a.channelName}`),a.type===F.Promise&&this.m({id:a.id,data:{name:"Unknown channel",message:`Channel name '${a.channelName}' timed out after ${this.l}ms`,stack:void 0},type:r.PromiseError})},this.l);T.push({request:a,timeoutTimer:q})}w(a){const T=this.g.get(a);if(T){for(const q of T)switch(clearTimeout(q.timeoutTimer),q.request.type){case F.Promise:this.s(q.request);break;case F.EventListen:this.t(q.request);break}this.g.delete(a)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$ci=o;var D;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class O{constructor(a,T=null){this.l=a,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new U.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(q=>this.s(q)),this.j=T}getChannel(a){const T=this;return{call(q,Q,v){return T.a?Promise.reject(new N.$5):T.m(a,q,Q,v)},listen(q,Q){return T.a?U.Event.None:T.o(a,q,Q)}}}m(a,T,q,Q=M.CancellationToken.None){const v=this.g++,C=F.Promise,Z={id:v,type:C,channelName:a,name:T,arg:q};if(Q.isCancellationRequested)return Promise.reject(new N.$5);let ie;return new Promise((ae,p)=>{if(Q.isCancellationRequested)return p(new N.$5);const W=()=>{const H=J=>{switch(J.type){case r.PromiseSuccess:this.f.delete(v),ae(J.data);break;case r.PromiseError:{this.f.delete(v);const ne=new Error(J.data.message);ne.stack=Array.isArray(J.data.stack)?J.data.stack.join(`
`):J.data.stack,ne.name=J.data.name,p(ne);break}case r.PromiseErrorObj:this.f.delete(v),p(J.data);break}};this.f.set(v,H),this.p(Z)};let G=null;this.b===m.Idle?W():(G=(0,t.$nh)(H=>this.u()),G.then(()=>{G=null,W()}));const B=()=>{G?(G.cancel(),G=null):this.p({id:v,type:F.PromiseCancel}),p(new N.$5)},b=Q.onCancellationRequested(B);ie=(0,S.$Rc)((0,S.$Sc)(B),b),this.d.add(ie)}).finally(()=>{ie.dispose(),this.d.delete(ie)})}o(a,T,q){const Q=this.g++,v=F.EventListen,C={id:Q,type:v,channelName:a,name:T,arg:q};let Z=null;const ie=new U.$he({onWillAddFirstListener:()=>{Z=(0,t.$nh)(ae=>this.u()),Z.then(()=>{Z=null,this.d.add(ie),this.p(C)})},onDidRemoveLastListener:()=>{Z?(Z.cancel(),Z=null):(this.d.delete(ie),this.p({id:Q,type:F.EventDispose}))}}),le=ae=>ie.fire(ae.data);return this.f.set(Q,le),ie.event}p(a){switch(a.type){case F.Promise:case F.EventListen:{const T=this.q([a.type,a.id,a.channelName,a.name],a.arg);this.j?.logOutgoing(T,a.id,D.LocalSide,`${c(a.type)}: ${a.channelName}.${a.name}`,a.arg);return}case F.PromiseCancel:case F.EventDispose:{const T=this.q([a.type,a.id]);this.j?.logOutgoing(T,a.id,D.LocalSide,c(a.type));return}}}q(a,T=void 0){const q=new n;return h(q,a),h(q,T),this.r(q.buffer)}r(a){try{return this.l.send(a),a.byteLength}catch{return 0}}s(a){const T=new s(a),q=A(T),Q=A(T),v=q[0];switch(v){case r.Initialize:return this.j?.logIncoming(a.byteLength,0,D.LocalSide,d(v)),this.t({type:q[0]});case r.PromiseSuccess:case r.PromiseError:case r.EventFire:case r.PromiseErrorObj:return this.j?.logIncoming(a.byteLength,q[1],D.LocalSide,d(v),Q),this.t({type:q[0],id:q[1],data:Q})}}t(a){if(a.type===r.Initialize){this.b=m.Idle,this.k.fire();return}this.f.get(a.id)?.(a)}get onDidInitializePromise(){return U.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,S.$Pc)(this.d.values()),this.d.clear()}}e.$di=O,Ke([V.$5h],O.prototype,"onDidInitializePromise",null);class ${get connections(){const a=[];return this.f.forEach(T=>a.push(T)),a}constructor(a,T,q){this.a=new Map,this.f=new Set,this.g=new U.$he,this.onDidAddConnection=this.g.event,this.h=new U.$he,this.onDidRemoveConnection=this.h.event,this.j=new S.$Tc,this.j.add(a(({protocol:Q,onDidClientDisconnect:v})=>{const C=U.Event.once(Q.onMessage);this.j.add(C(Z=>{const ie=new s(Z),le=A(ie),ae=new o(Q,le,T,q),p=new O(Q,T);this.a.forEach((G,B)=>ae.registerChannel(B,G));const W={channelServer:ae,channelClient:p,ctx:le};this.f.add(W),this.g.fire(W),this.j.add(v(()=>{ae.dispose(),p.dispose(),this.f.delete(W),this.h.fire(W)}))}))}))}getChannel(a,T){const q=this;return{call(Q,v,C){let Z;if((0,I.$og)(T)){const le=(0,E.$3b)(q.connections.filter(T));Z=le?Promise.resolve(le):U.Event.toPromise(U.Event.filter(q.onDidAddConnection,T))}else Z=T.routeCall(q,Q,v);const ie=Z.then(le=>le.channelClient.getChannel(a));return K(ie).call(Q,v,C)},listen(Q,v){if((0,I.$og)(T))return q.k(a,T,Q,v);const C=T.routeEvent(q,Q,v).then(Z=>Z.channelClient.getChannel(a));return K(C).listen(Q,v)}}}k(a,T,q,Q){const v=this;let C;const Z=new U.$he({onWillAddFirstListener:()=>{C=new S.$Tc;const ie=new U.$ne,le=new Map,ae=W=>{const B=W.channelClient.getChannel(a).listen(q,Q),b=ie.add(B);le.set(W,b)},p=W=>{const G=le.get(W);G&&(G.dispose(),le.delete(W))};v.connections.filter(T).forEach(ae),U.Event.filter(v.onDidAddConnection,T)(ae,void 0,C),v.onDidRemoveConnection(p,void 0,C),ie.event(Z.fire,Z,C),C.add(ie)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return Z.event}registerChannel(a,T){this.a.set(a,T);for(const q of this.f)q.channelServer.registerChannel(a,T)}dispose(){this.j.dispose();for(const a of this.f)a.channelClient.dispose(),a.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=$;class g{constructor(a,T,q=null){const Q=new n;h(Q,T),a.send(Q.buffer),this.a=new O(a,q),this.d=new o(a,T,q)}getChannel(a){return this.a.getChannel(a)}registerChannel(a,T){this.d.registerChannel(a,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=g;function K(L){return{call(a,T,q){return L.then(Q=>Q.call(a,T,q))},listen(a,T){const q=new U.$qe;return L.then(Q=>q.input=Q.listen(a,T)),q.event}}}function re(L){let a=!1;return{call(T,q,Q){return a?L.call(T,q,Q):(0,t.$Bh)(0).then(()=>a=!0).then(()=>L.call(T,q,Q))},listen(T,q){if(a)return L.listen(T,q);const Q=new U.$qe;return(0,t.$Bh)(0).then(()=>a=!0).then(()=>Q.input=L.listen(T,q)),Q.event}}}class ee{constructor(a){this.a=a}routeCall(a){return this.b(a)}routeEvent(a){return this.b(a)}async b(a){for(const T of a.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await U.Event.toPromise(a.onDidAddConnection),await this.b(a)}}e.$ii=ee;var X;(function(L){function a(v,C,Z){const ie=v,le=Z&&Z.disableMarshalling,ae=new Map;for(const p in ie)q(p)&&ae.set(p,U.Event.buffer(ie[p],!0,void 0,C));return new class{listen(p,W,G){const B=ae.get(W);if(B)return B;const b=ie[W];if(typeof b=="function"){if(Q(W))return b.call(ie,G);if(q(W))return ae.set(W,U.Event.buffer(ie[W],!0,void 0,C)),ae.get(W)}throw new N.$bb(`Event not found: ${W}`)}call(p,W,G){const B=ie[W];if(typeof B=="function"){if(!le&&Array.isArray(G))for(let H=0;H<G.length;H++)G[H]=(0,k.$0h)(G[H]);let b=B.apply(ie,G);return b instanceof Promise||(b=Promise.resolve(b)),b}throw new N.$bb(`Method not found: ${W}`)}}}L.fromService=a;function T(v,C){const Z=C&&C.disableMarshalling;return new Proxy({},{get(ie,le){if(typeof le=="string")return C?.properties?.has(le)?C.properties.get(le):Q(le)?function(ae){return v.listen(le,ae)}:q(le)?v.listen(le):async function(...ae){let p;C&&!(0,I.$jg)(C.context)?p=[C.context,...ae]:p=ae;const W=await v.call(le,p);return Z?W:(0,k.$0h)(W)};throw new N.$bb(`Property not found: ${String(le)}`)}})}L.toService=T;function q(v){return v[0]==="o"&&v[1]==="n"&&w.$Af(v.charCodeAt(2))}function Q(v){return/^onDynamic/.test(v)&&w.$Af(v.charCodeAt(9))}})(X||(e.ProxyChannel=X={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Y(L){if(Array.isArray(L))return L;if(L&&typeof L=="object"&&typeof L.toString=="function"){const a=L.toString();if(a!=="[object Object]")return a}return L}function te(L){return Array.isArray(L)?L.map(Y):Y(L)}function ue(L,a,T,q,Q,v,C){C=te(C);const Z=se[Q],ie=Z[q%Z.length];let le=[`%c[${L}]%c[${String(a).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${v}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(v)?(le=le.concat(C),le.push(")")):le.push(C),console.log.apply(console,le)}class ce{constructor(a,T){this.d=a,this.f=T,this.a=0,this.b=0}logOutgoing(a,T,q,Q,v){this.b+=a,ue(this.d,this.b,a,T,q,Q,v)}logIncoming(a,T,q,Q,v){this.a+=a,ue(this.f,this.a,a,T,q,Q,v)}}e.$ji=ce}),define(Ee[51],_e([0,1,64,8,16,13,47,9,6,4,45,50,29,25]),function($e,e,E,t,j,M,V,N,U,S,k,w,I,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=void 0;class c extends F.$ci{constructor(m){super({send:l=>{try{process.send?.(l.buffer.toString("base64"))}catch{}},onMessage:U.Event.fromNodeEventEmitter(process,"message",l=>j.$Je.wrap(Buffer.from(l,"base64")))},m),process.once("disconnect",()=>this.dispose())}}e.$9q=c;class r{constructor(m,l){this.i=m,this.j=l,this.c=new Set,this.g=new Map,this.h=new U.$he,this.onDidProcessExit=this.h.event;const _=l&&l.timeout?l.timeout:6e4;this.b=new t.$xh(_),this.d=null,this.f=null}getChannel(m){const l=this;return{call(_,y,s){return l.k(m,_,y,s)},listen(_,y){return l.l(m,_,y)}}}k(m,l,_,y=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(N.$6());this.b.cancel();const s=this.n(m),n=(0,t.$nh)(u=>s.call(l,_,u)),i=y.onCancellationRequested(()=>n.cancel()),f=(0,S.$Sc)(()=>n.cancel());return this.c.add(f),n.finally(()=>{i.dispose(),this.c.delete(f),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(m,l,_){if(!this.b)return U.Event.None;this.b.cancel();let y;const s=new U.$he({onWillAddFirstListener:()=>{y=this.n(m).listen(l,_)(s.fire,s),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return s.event}get m(){if(!this.f){const m=this.j&&this.j.args?this.j.args:[],l=Object.create(null);l.env={...(0,k.$0n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(l.env={...l.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(l.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(l.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(l.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),l.execArgv===void 0&&(l.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h)).filter(h=>!h.startsWith("--vscode-"))),(0,I.$tm)(l.env),this.d=(0,E.fork)(this.i,m,l);const _=new U.$he,s=U.Event.fromNodeEventEmitter(this.d,"message",h=>h)(h=>{if((0,V.$5q)(h)){(0,V.log)(h,`IPC Library: ${this.j.serverName}`);return}_.fire(j.$Je.wrap(Buffer.from(h,"base64")))}),n=this.j.useQueue?(0,w.$vm)(this.d):this.d,i=h=>this.d&&this.d.connected&&n.send(h.buffer.toString("base64")),f=_.event,u={send:i,onMessage:f};this.f=new F.$di(u);const P=()=>this.o();process.once("exit",P),this.d.on("error",h=>console.warn('IPC "'+this.j.serverName+'" errored with '+h)),this.d.on("exit",(h,A)=>{process.removeListener("exit",P),s.dispose(),this.c.forEach(o=>(0,S.$Pc)(o)),this.c.clear(),h!==0&&A!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+h+" and signal "+A),this.b?.cancel(),this.o(),this.h.fire({code:h,signal:A})})}return this.f}n(m){let l=this.g.get(m);return l||(l=this.m.getChannel(m),this.g.set(m,l)),l}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$0q=r}),define(Ee[33],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SW=E;function E(t){return!!t.parentPort}}),define(Ee[52],_e([0,1,33,16,25,6,10,12]),function($e,e,E,t,j,M,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TW=void 0,e.$UW=k;class U{constructor(I){this.a=I,this.onMessage=M.Event.fromNodeEventEmitter(this.a,"message",F=>F.data?t.$Je.wrap(F.data):t.$Je.alloc(0)),I.start()}send(I){this.a.postMessage(I.buffer)}disconnect(){this.a.close()}}class S extends j.$ei{static b(I){(0,V.$kg)((0,E.$SW)(process),"Electron Utility Process");const F=new M.$he;return process.parentPort.on("message",c=>{if(I?.handledClientConnection(c))return;const r=(0,N.$Ob)(c.ports);r&&F.fire(r)}),M.Event.map(F.event,c=>({protocol:new U(c),onDidClientDisconnect:M.Event.fromNodeEventEmitter(c,"close")}))}constructor(I){super(S.b(I))}}e.$TW=S;function k(w,I,F){const c=r=>{r.data===I&&(w.removeListener("message",c),F())};w.on("message",c)}}),define(Ee[53],_e([54,55]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(Ee[56],_e([0,1,12,10,53]),function($e,e,E,t,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=U,e.$mj=S,e.$nj=k;function M(w,I){return I&&(w.stack||w.stacktrace)?j.localize(0,null,N(w),V(w.stack)||V(w.stacktrace)):N(w)}function V(w){return Array.isArray(w)?w.join(`
`):w}function N(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?j.localize(1,null,w.message):w.message||j.localize(2,null)}function U(w=null,I=!1){if(!w)return j.localize(3,null);if(Array.isArray(w)){const F=E.$Hb(w),c=U(F[0],I);return F.length>1?j.localize(4,null,c,F.length):c}if(t.$ag(w))return w;if(w.detail){const F=w.detail;if(F.error)return M(F.error,I);if(F.exception)return M(F.exception,I)}return w.stack?M(w,I):w.message?w.message:j.localize(5,null)}function S(w){const I=w;return I instanceof Error&&Array.isArray(I.actions)}function k(w,I){let F;return typeof w=="string"?F=new Error(w):F=w,F.actions=I,F}}),define(Ee[57],_e([54,55]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(Ee[58],_e([0,1]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=j,e.$Bi=M;var E;(function(V){V.serviceIds=new Map,V.DI_TARGET="$di$target",V.DI_DEPENDENCIES="$di$dependencies";function N(U){return U[V.DI_DEPENDENCIES]||[]}V.getServiceDependencies=N})(E||(e._util=E={})),e.$zi=j("instantiationService");function t(V,N,U){N[E.DI_TARGET]===N?N[E.DI_DEPENDENCIES].push({id:V,index:U}):(N[E.DI_DEPENDENCIES]=[{id:V,index:U}],N[E.DI_TARGET]=N)}function j(V){if(E.serviceIds.has(V))return E.serviceIds.get(V);const N=function(U,S,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(N,U,k)};return N.toString=()=>V,E.serviceIds.set(V,N),N}function M(V){return V}}),define(Ee[18],_e([0,1,30,3,7,10,5,57,58,2,31,15]),function($e,e,E,t,j,M,V,N,U,S,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=I,e.$9k=d,e.$0k=l,e.$$k=_,e.$_k=y,e.$al=s,e.$bl=n,e.$cl=i,e.$dl=f,e.$el=u,e.$fl=P,e.$hl=o,e.$il=D,e.$jl=O,e.$kl=$,e.$ll=g,e.$ol=se,e.$Al=a,e.$Bl=T,e.$Dl=Q,e.$7k=(0,U.$Ai)("fileService");function I(v){return v.create===!0}var F;(function(v){v[v.Unknown=0]="Unknown",v[v.File=1]="File",v[v.Directory=2]="Directory",v[v.SymbolicLink=64]="SymbolicLink"})(F||(e.FileType=F={}));var c;(function(v){v[v.Readonly=1]="Readonly",v[v.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var r;(function(v){v[v.UPDATED=2]="UPDATED",v[v.ADDED=4]="ADDED",v[v.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function d(v){const C=v;return!!C&&typeof C.onDidChange=="function"}var m;(function(v){v[v.None=0]="None",v[v.FileReadWrite=2]="FileReadWrite",v[v.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",v[v.FileReadStream=16]="FileReadStream",v[v.FileFolderCopy=8]="FileFolderCopy",v[v.PathCaseSensitive=1024]="PathCaseSensitive",v[v.Readonly=2048]="Readonly",v[v.Trash=4096]="Trash",v[v.FileWriteUnlock=8192]="FileWriteUnlock",v[v.FileAtomicRead=16384]="FileAtomicRead",v[v.FileAtomicWrite=32768]="FileAtomicWrite",v[v.FileAtomicDelete=65536]="FileAtomicDelete",v[v.FileClone=131072]="FileClone"})(m||(e.FileSystemProviderCapabilities=m={}));function l(v){return!!(v.capabilities&m.FileReadWrite)}function _(v){return!!(v.capabilities&m.FileFolderCopy)}function y(v){return!!(v.capabilities&m.FileClone)}function s(v){return!!(v.capabilities&m.FileOpenReadWriteClose)}function n(v){return!!(v.capabilities&m.FileReadStream)}function i(v){return l(v)?!!(v.capabilities&m.FileAtomicRead):!1}function f(v){return l(v)?!!(v.capabilities&m.FileAtomicWrite):!1}function u(v){return!!(v.capabilities&m.FileAtomicDelete)}function P(v){return!!(v.capabilities&m.Readonly)}var h;(function(v){v.FileExists="EntryExists",v.FileNotFound="EntryNotFound",v.FileNotADirectory="EntryNotADirectory",v.FileIsADirectory="EntryIsADirectory",v.FileExceedsStorageQuota="EntryExceedsStorageQuota",v.FileTooLarge="EntryTooLarge",v.FileWriteLocked="EntryWriteLocked",v.NoPermissions="NoPermissions",v.Unavailable="Unavailable",v.Unknown="Unknown"})(h||(e.FileSystemProviderErrorCode=h={}));class A extends Error{static create(C,Z){const ie=new A(C.toString(),Z);return O(ie,Z),ie}constructor(C,Z){super(C),this.code=Z}}e.$gl=A;function o(v,C){return A.create(v,C)}function D(v){return v||o((0,N.localize)(0,null),h.Unknown)}function O(v,C){return v.name=C?`${C} (FileSystemError)`:"FileSystemError",v}function $(v){if(!v)return h.Unknown;if(v instanceof A)return v.code;const C=/^(.+) \(FileSystemError\)$/.exec(v.name);if(!C)return h.Unknown;switch(C[1]){case h.FileExists:return h.FileExists;case h.FileIsADirectory:return h.FileIsADirectory;case h.FileNotADirectory:return h.FileNotADirectory;case h.FileNotFound:return h.FileNotFound;case h.FileTooLarge:return h.FileTooLarge;case h.FileWriteLocked:return h.FileWriteLocked;case h.NoPermissions:return h.NoPermissions;case h.Unavailable:return h.Unavailable}return h.Unknown}function g(v){if(v instanceof Y)return v.fileOperationResult;switch($(v)){case h.FileNotFound:return ce.FILE_NOT_FOUND;case h.FileIsADirectory:return ce.FILE_IS_DIRECTORY;case h.FileNotADirectory:return ce.FILE_NOT_DIRECTORY;case h.FileWriteLocked:return ce.FILE_WRITE_LOCKED;case h.NoPermissions:return ce.FILE_PERMISSION_DENIED;case h.FileExists:return ce.FILE_MOVE_CONFLICT;case h.FileTooLarge:return ce.FILE_TOO_LARGE;default:return ce.FILE_OTHER_ERROR}}var K;(function(v){v[v.CREATE=0]="CREATE",v[v.DELETE=1]="DELETE",v[v.MOVE=2]="MOVE",v[v.COPY=3]="COPY",v[v.WRITE=4]="WRITE"})(K||(e.FileOperation=K={}));class re{constructor(C,Z,ie){this.resource=C,this.operation=Z,this.target=ie}isOperation(C){return this.operation===C}}e.$ml=re;var ee;(function(v){v[v.UPDATED=0]="UPDATED",v[v.ADDED=1]="ADDED",v[v.DELETED=2]="DELETED"})(ee||(e.FileChangeType=ee={}));class X{constructor(C,Z){this.c=Z,this.b=void 0,this.d=new w.$V(()=>{const ie=E.$Gi.forUris(()=>this.c);return ie.fill(this.rawAdded.map(le=>[le,!0])),ie}),this.f=new w.$V(()=>{const ie=E.$Gi.forUris(()=>this.c);return ie.fill(this.rawUpdated.map(le=>[le,!0])),ie}),this.g=new w.$V(()=>{const ie=E.$Gi.forUris(()=>this.c);return ie.fill(this.rawDeleted.map(le=>[le,!0])),ie}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ie of C){switch(ie.type){case ee.ADDED:this.rawAdded.push(ie.resource);break;case ee.UPDATED:this.rawUpdated.push(ie.resource);break;case ee.DELETED:this.rawDeleted.push(ie.resource);break}this.b!==X.a&&(typeof ie.cId=="number"?this.b===void 0?this.b=ie.cId:this.b!==ie.cId&&(this.b=X.a):this.b!==void 0&&(this.b=X.a))}}contains(C,...Z){return this.h(C,{includeChildren:!1},...Z)}affects(C,...Z){return this.h(C,{includeChildren:!0},...Z)}h(C,Z,...ie){if(!C)return!1;const le=ie.length>0;return!!((!le||ie.includes(ee.ADDED))&&(this.d.value.get(C)||Z.includeChildren&&this.d.value.findSuperstr(C))||(!le||ie.includes(ee.UPDATED))&&(this.f.value.get(C)||Z.includeChildren&&this.f.value.findSuperstr(C))||(!le||ie.includes(ee.DELETED))&&(this.g.value.findSubstr(C)||Z.includeChildren&&this.g.value.findSuperstr(C)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(C){return this.b===C}hasCorrelation(){return typeof this.b=="number"}}e.$nl=X,X.a=null;function se(v,C,Z){return!v||!C||v===C||C.length>v.length?!1:(C.charAt(C.length-1)!==t.sep&&(C+=t.sep),Z?(0,j.$Cf)(v,C):v.indexOf(C)===0)}class Y extends Error{constructor(C,Z,ie){super(C),this.fileOperationResult=Z,this.options=ie}}e.$pl=Y;class te extends Y{constructor(C,Z,ie,le){super(C,Z,le),this.fileOperationResult=Z,this.size=ie}}e.$ql=te;class ue extends Y{constructor(C,Z,ie){super(C,ce.FILE_NOT_MODIFIED_SINCE,ie),this.stat=Z}}e.$rl=ue;var ce;(function(v){v[v.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",v[v.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",v[v.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",v[v.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",v[v.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",v[v.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",v[v.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",v[v.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",v[v.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",v[v.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",v[v.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var L;(function(v){v[v.FILE=0]="FILE",v[v.FOLDER=1]="FOLDER",v[v.ROOT_FOLDER=2]="ROOT_FOLDER"})(L||(e.FileKind=L={})),e.$zl="";function a(v){if(!(typeof v.size!="number"||typeof v.mtime!="number"))return v.mtime.toString(29)+v.size.toString(31)}async function T(v,C){if(!C.hasProvider(V.URI.from({scheme:v.scheme})))return new Promise(Z=>{const ie=C.onDidChangeFileSystemProviderRegistrations(le=>{le.scheme===v.scheme&&le.added&&(ie.dispose(),Z())})})}class q{static formatSize(C){return(0,M.$eg)(C)||(C=0),C<q.KB?(0,N.localize)(1,null,C.toFixed(0)):C<q.MB?(0,N.localize)(2,null,(C/q.KB).toFixed(2)):C<q.GB?(0,N.localize)(3,null,(C/q.MB).toFixed(2)):C<q.TB?(0,N.localize)(4,null,(C/q.GB).toFixed(2)):(0,N.localize)(5,null,(C/q.TB).toFixed(2))}}e.$Cl=q,q.KB=1024,q.MB=q.KB*q.KB,q.GB=q.MB*q.KB,q.TB=q.GB*q.KB;function Q(v){const C=typeof v=="string"||v?.scheme===k.Schemas.vscodeRemote;return typeof v!="string"&&v?.scheme===k.Schemas.file?1024*q.MB:C?10*q.MB:S.$i?50*q.MB:1024*q.MB}}),define(Ee[19],_e([0,1,23,4,3,2,5,18]),function($e,e,E,t,j,M,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=void 0,e.$Sq=U,e.$Tq=S,e.$Xq=F,e.$Yq=c,e.$Zq=r,e.$1q=d,e.$2q=l,e.$3q=_;function U(y){return typeof y.correlationId=="number"}function S(y){return y.recursive===!0}class k extends t.$Uc{constructor(s,n,i,f){super(),this.m=s,this.n=n,this.r=i,this.s=f,this.f=this.B(new t.$Vc),this.g=void 0,this.h=new Map,this.j=0}u(){const s=new t.$Tc;this.f.value=s,this.c=this.t(s),this.c.setVerboseLogging(this.r),s.add(this.c.onDidChangeFile(n=>this.m(n))),s.add(this.c.onDidLogMessage(n=>this.n(n))),s.add(this.c.onDidError(n=>this.w(n.error,n.request)))}w(s,n){if(this.s.restartOnError&&this.g?.length)if(n){const i=this.h.get(n.path)??0;i<k.a?(this.z(`restarting watcher from error in watch request (retrying request): ${s} (${JSON.stringify(n)})`),this.h.set(n.path,i+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${s} (${JSON.stringify(n)})`),this.y(this.g.filter(f=>f.path!==n.path)))}else this.j<k.b?(this.z(`restarting watcher after unknown global error: ${s}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${s}`);else this.z(s)}y(s){this.u(),this.watch(s)}async watch(s){this.g=s,await this.c?.watch(s)}async setVerboseLogging(s){this.r=s,await this.c?.setVerboseLogging(s)}z(s){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${s}`})}C(s){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${s}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Uq=k,k.a=3,k.b=10;class w extends k{constructor(s,n,i){super(s,n,i,{type:"node.js",restartOnError:!1})}}e.$Vq=w;class I extends k{constructor(s,n,i){super(s,n,i,{type:"universal",restartOnError:!0})}}e.$Wq=I;function F(y){return y.map(s=>({type:s.type,resource:V.URI.revive(s.resource),cId:s.cId}))}function c(y){const s=new m;for(const n of y)s.processEvent(n);return s.coalesce()}function r(y,s){return typeof s=="string"&&!s.startsWith(E.$qk)&&!(0,j.$ic)(s)?{base:y,pattern:s}:s}function d(y,s){const n=[];for(const i of s)n.push((0,E.$uk)(r(y,i)));return n}class m{constructor(){this.a=new Set,this.b=new Map}c(s){return M.$e?s.resource.fsPath:s.resource.fsPath.toLowerCase()}processEvent(s){const n=this.b.get(this.c(s));let i=!1;if(n){const f=n.type,u=s.type;n.resource.fsPath!==s.resource.fsPath&&(s.type===N.FileChangeType.DELETED||s.type===N.FileChangeType.ADDED)?i=!0:f===N.FileChangeType.ADDED&&u===N.FileChangeType.DELETED?(this.b.delete(this.c(s)),this.a.delete(n)):f===N.FileChangeType.DELETED&&u===N.FileChangeType.ADDED?n.type=N.FileChangeType.UPDATED:f===N.FileChangeType.ADDED&&u===N.FileChangeType.UPDATED||(n.type=u)}else i=!0;i&&(this.a.add(s),this.b.set(this.c(s),s))}coalesce(){const s=[],n=[];return Array.from(this.a).filter(i=>i.type!==N.FileChangeType.DELETED?(s.push(i),!1):!0).sort((i,f)=>i.resource.fsPath.length-f.resource.fsPath.length).filter(i=>n.some(f=>(0,N.$ol)(i.resource.fsPath,f,!M.$e))?!1:(n.push(i.resource.fsPath),!0)).concat(s)}}function l(y,s){if(typeof s=="number")switch(y.type){case N.FileChangeType.ADDED:return(s&N.FileChangeFilter.ADDED)===0;case N.FileChangeType.DELETED:return(s&N.FileChangeFilter.DELETED)===0;case N.FileChangeType.UPDATED:return(s&N.FileChangeFilter.UPDATED)===0}return!1}function _(y){if(typeof y=="number"){const s=[];return y&N.FileChangeFilter.ADDED&&s.push("Added"),y&N.FileChangeFilter.DELETED&&s.push("Deleted"),y&N.FileChangeFilter.UPDATED&&s.push("Updated"),s.length===0?"<all>":`[${s.join(", ")}]`}return"<none>"}}),define(Ee[34],_e([0,1,17,4,19,6,18,5,8]),function($e,e,E,t,j,M,V,N,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class S extends t.$Uc{constructor(){super(),this.a=this.B(new M.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new M.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new t.$4c),this.m=new Set,this.n=5007,this.r=new U.$Xh,this.P=!1,this.B(this.f(w=>this.s(w)))}s(w){this.t(w)&&this.w(w)}t(w){return(0,j.$Sq)(w)}async watch(w){this.r.isSettled||this.r.complete(),this.r=new U.$Xh;try{this.h.clear(),this.g.clear();for(const I of w)this.t(I)?this.h.set(I.correlationId,I):this.g.add(I);for(const[I]of this.j)this.h.has(I)||(this.j.deleteAndDispose(I),this.m.delete(I));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(w=>!this.j.has(w.correlationId))])}isSuspended(w){return typeof w.correlationId!="number"?!1:this.m.has(w.correlationId)?"polling":this.j.has(w.correlationId)}async w(w){if(this.j.has(w.correlationId))return;const I=new t.$Tc;this.j.set(w.correlationId,I),await this.r.p,!I.isDisposed&&(this.z(w,I),this.u())}y(w){this.j.deleteAndDispose(w.correlationId),this.m.delete(w.correlationId),this.u()}z(w,I){this.C(w,I)?(this.N(`reusing an existing recursive watcher to monitor ${w.path}`),this.m.delete(w.correlationId)):(this.D(w,I),this.m.add(w.correlationId))}C(w,I){const F=this.M?.subscribe(w.path,(c,r)=>{I.isDisposed||(c?this.z(w,I):r?.type===V.FileChangeType.ADDED&&this.F(w))});return F?(I.add(F),!0):!1}D(w,I){let F=!1;const c=(r,d)=>{if(I.isDisposed)return;const m=this.G(r),l=this.G(d),_=F;F=m,!m&&(l||_)&&this.F(w)};this.N(`starting fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,E.watchFile)(w.path,{persistent:!1,interval:this.n},c)}catch(r){this.O(`fs.watchFile() failed with error ${r} on path ${w.path} (correlationId: ${w.correlationId})`)}I.add((0,t.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${w.path} (correlationId: ${w.correlationId})`);try{(0,E.unwatchFile)(w.path,c)}catch(r){this.O(`fs.unwatchFile() failed with error ${r} on path ${w.path} (correlationId: ${w.correlationId})`)}}))}F(w){this.N(`detected ${w.path} exists again, resuming watcher (correlationId: ${w.correlationId})`);const I={resource:N.URI.file(w.path),type:V.FileChangeType.ADDED,cId:w.correlationId};this.a.fire([I]),this.H(I,w),this.y(w)}G(w){return w.ctimeMs===0&&w.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(w,I){if(this.P){const F=` >> normalized ${w.type===V.FileChangeType.ADDED?"[ADDED]":w.type===V.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${w.resource.fsPath}`;this.I(F,I)}}I(w,I){this.P&&this.N(`${w}${typeof I.correlationId=="number"?` <${I.correlationId}> `:""}`)}J(w){return`${w.path} (excludes: ${w.excludes.length>0?w.excludes:"<none>"}, includes: ${w.includes&&w.includes.length>0?JSON.stringify(w.includes):"<all>"}, filter: ${(0,j.$3q)(w.filter)}, correlationId: ${typeof w.correlationId=="number"?w.correlationId:"<none>"})`}async setVerboseLogging(w){this.P=w}}e.$_q=S}),define(Ee[35],_e([0,1,17,8,13,14,4,21,3,2,22,5,32,24,18,19]),function($e,e,E,t,j,M,V,N,U,S,k,w,I,F,c,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0,e.$fr=m;class d extends V.$Uc{get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(_,y,s,n,i,f){super(),this.s=_,this.t=y,this.u=s,this.w=n,this.y=i,this.z=f,this.c=this.B(new t.$Ph({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},u=>this.u(u))),this.f=this.B(new t.$Oh(u=>this.M(u),d.b)),this.g=(0,r.$1q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,r.$1q)(this.s.path,this.s.includes):void 0,this.j=(0,r.$Sq)(this.s)?this.s.filter:void 0,this.m=new j.$se,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const _=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const y=await F.Promises.stat(_);if(this.m.token.isCancellationRequested)return;this.B(await this.G(_,y.isDirectory()))}catch(_){_.code!=="ENOENT"?this.O(_):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${_})`),this.D()}}D(){this.r=!0,this.w?.()}async F(_){let y=_.path;try{y=await F.Promises.realpath(_.path),_.path===y&&(y=await(0,I.$br)(_.path,this.m.token)??_.path),_.path!==y&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${_.path}, real: ${y})`)}catch{}return y}async G(_,y){const s=new V.$Tc;return this.H(_,y,s)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(_,y,s)),s}H(_,y,s){if(y)return!1;const n=w.URI.file(this.s.path),i=this.t?.subscribe(this.s.path,async(f,u)=>{if(!s.isDisposed)if(f){const P=await this.G(_,y);s.isDisposed?P.dispose():s.add(P)}else u&&(typeof u.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:n,type:u.type,cId:this.s.correlationId},!0)});return i?(s.add(i),!0):!1}async I(_,y,s){if(S.$d&&(0,M.$zg)(_,"/Volumes/",!0)){this.O(`Refusing to watch ${_} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const n=new j.$se(this.m.token);s.add((0,V.$Sc)(()=>n.dispose(!0)));const i=new V.$Tc;s.add(i);try{const f=w.URI.file(this.s.path),u=(0,U.$nc)(_),P=(0,E.watch)(_);i.add((0,V.$Sc)(()=>{P.removeAllListeners(),P.close()})),this.Q(`Started watching: '${_}'`);const h=new Set;if(y)try{for(const o of await F.Promises.readdir(_))h.add(o)}catch(o){this.O(o)}if(n.token.isCancellationRequested)return;const A=new Map;i.add((0,V.$Sc)(()=>{for(const[,o]of A)o.dispose();A.clear()})),P.on("error",(o,D)=>{n.token.isCancellationRequested||(this.O(`Failed to watch ${_} for changes using fs.watch() (${o}, ${D})`),this.D())}),P.on("change",(o,D)=>{if(n.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${o}"] ${D}`);let O="";if(D&&(O=D.toString(),S.$d&&(O=(0,N.$hm)(O))),!(!O||o!=="change"&&o!=="rename"))if(y)if(o==="rename"){A.get(O)?.dispose();const $=setTimeout(async()=>{if(A.delete(O),O===u&&!await F.Promises.exists(_)){this.J(f);return}if(n.token.isCancellationRequested)return;const g=await this.N((0,U.$jc)(_,O));if(n.token.isCancellationRequested)return;let K;g?h.has(O)?K=c.FileChangeType.UPDATED:(K=c.FileChangeType.ADDED,h.add(O)):(h.delete(O),K=c.FileChangeType.DELETED),this.L({resource:(0,k.$bh)(f,O),type:K,cId:this.s.correlationId})},d.a);A.set(O,(0,V.$Sc)(()=>clearTimeout($)))}else{let $;h.has(O)?$=c.FileChangeType.UPDATED:($=c.FileChangeType.ADDED,h.add(O)),this.L({resource:(0,k.$bh)(f,O),type:$,cId:this.s.correlationId})}else if(o==="rename"||O!==u){const $=setTimeout(async()=>{const g=await F.Promises.exists(_);n.token.isCancellationRequested||(g?(this.L({resource:f,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0),i.add(await this.G(_,!1))):this.J(f))},d.a);i.clear(),i.add((0,V.$Sc)(()=>clearTimeout($)))}else this.L({resource:f,type:c.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(f){n.token.isCancellationRequested||this.O(`Failed to watch ${_} for changes using fs.watch() (${f.toString()})`),this.D()}}J(_){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:_,type:c.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(_,y=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${_.type===c.FileChangeType.ADDED?"[ADDED]":_.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${_.resource.fsPath}`),!y&&this.g.some(s=>s(_.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${_.resource.fsPath}`):!y&&this.h&&this.h.length>0&&!this.h.some(s=>s(_.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${_.resource.fsPath}`):this.f.work(_))}M(_){const y=(0,r.$Yq)(_),s=[];for(const i of y){if((0,r.$2q)(i,this.j)){this.z&&this.R(` >> ignored (filtered) ${i.resource.fsPath}`);continue}s.push(i)}if(s.length===0)return;if(this.z)for(const i of s)this.R(` >> normalized ${i.type===c.FileChangeType.ADDED?"[ADDED]":i.type===c.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`);this.c.work(s)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(_){if(S.$e)return F.Promises.exists(_);try{const y=(0,U.$nc)(_);return(await F.Promises.readdir((0,U.$mc)(_))).some(n=>n===y)}catch(y){return this.Q(y),!1}}setVerboseLogging(_){this.z=_}O(_){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${_}`})}P(_){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${_}`})}Q(_){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${_}`})}R(_){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${_}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$er=d,d.a=100,d.b=75;async function m(l,_,y,s,n=512){const i=await F.Promises.open(l,"r"),f=Buffer.allocUnsafe(n),u=new j.$se(s);let P,h=!1;const A={path:l,excludes:[],recursive:!1},o=new d(A,void 0,D=>{(async()=>{for(const{type:O}of D)if(O===c.FileChangeType.UPDATED){if(h)return;h=!0;try{for(;!u.token.isCancellationRequested;){const{bytesRead:$}=await F.Promises.read(i,f,0,n,null);if(!$||u.token.isCancellationRequested)break;_(f.slice(0,$))}}catch($){P=new Error($),u.dispose(!0)}finally{h=!1}}})()});return await o.ready,y(),new Promise((D,O)=>{u.token.onCancellationRequested(async()=>{o.dispose();try{await F.Promises.close(i)}catch($){P=new Error($)}P?O(P):D()})})}}),define(Ee[59],_e([0,1,6,23,34,2,35,14]),function($e,e,E,t,j,M,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class U extends j.$_q{constructor(k){super(),this.M=k,this.onDidError=E.Event.None,this.watchers=new Set}async L(k){k=this.X(k);const w=[],I=new Set(Array.from(this.watchers));for(const F of k){const c=this.S(F);c&&(0,t.$yk)(c.request.excludes,F.excludes)&&(0,t.$yk)(c.request.includes,F.includes)?I.delete(c):w.push(F)}w.length&&this.N(`Request to start watching: ${w.map(F=>this.J(F)).join(",")}`),I.size&&this.N(`Request to stop watching: ${Array.from(I).map(F=>this.J(F.request)).join(",")}`);for(const F of I)this.W(F);for(const F of w)this.U(F)}S(k){for(const w of this.watchers)if(typeof k.correlationId=="number"||typeof w.request.correlationId=="number"){if(w.request.correlationId===k.correlationId)return w}else if((0,N.$yg)(w.request.path,k.path,!M.$e))return w}U(k){const w=new V.$er(k,this.M,F=>this.a.fire(F),()=>this.c.fire(k),F=>this.b.fire(F),this.P),I={request:k,instance:w};this.watchers.add(I)}async stop(){await super.stop();for(const k of this.watchers)this.W(k)}W(k){this.N("stopping file watcher",k),this.watchers.delete(k),k.instance.dispose()}X(k){const w=new Map;for(const I of k){const F=M.$e?I.path:I.path.toLowerCase();let c=w.get(I.correlationId);c||(c=new Map,w.set(I.correlationId,c)),c.has(F)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(I)}`),c.set(F,I)}return Array.from(w.values()).map(I=>Array.from(I.values())).flat()}async setVerboseLogging(k){super.setVerboseLogging(k);for(const w of this.watchers)w.instance.setVerboseLogging(k)}N(k,w){this.P&&this.b.fire({type:"trace",message:this.$(k,w)})}O(k){this.b.fire({type:"warn",message:this.$(k)})}$(k,w){return w?`[File Watcher (node.js)] ${k} (${this.J(w.request)})`:`[File Watcher (node.js)] ${k}`}}e.$gr=U}),define(Ee[60],_e([0,1,65,17,49,5,8,13,56,6,14,23,34,30,21,3,2,32,35,18,19,4]),function($e,e,E,t,j,M,V,N,U,S,k,w,I,F,c,r,d,m,l,_,y,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zjc=e.$Yjc=void 0;class n extends s.$Uc{get failed(){return this.c}get stopped(){return this.f}constructor(u,P,h,A,o,D){super(),this.ready=u,this.request=P,this.restarts=h,this.token=A,this.worker=o,this.m=D,this.a=this.B(new S.$he),this.onDidStop=this.a.event,this.b=this.B(new S.$he),this.onDidFail=this.b.event,this.c=!1,this.f=!1,this.g=this.request.includes?(0,y.$1q)(this.request.path,this.request.includes):void 0,this.h=this.request.excludes?(0,y.$1q)(this.request.path,this.request.excludes):void 0,this.j=new Map,this.B((0,s.$Sc)(()=>this.j.clear()))}subscribe(u,P){u=M.URI.file(u).fsPath;let h=this.j.get(u);return h||(h=new Set,this.j.set(u,h)),h.add(P),(0,s.$Sc)(()=>{const A=this.j.get(u);A&&(A.delete(P),A.size===0&&this.j.delete(u))})}get subscriptionsCount(){return this.j.size}notifyFileChange(u,P){const h=this.j.get(u);if(h)for(const A of h)A(P)}notifyWatchFailed(){this.c=!0,this.b.fire()}include(u){return!this.g||this.g.length===0?!0:this.g.some(P=>P(u))}exclude(u){return!!this.h?.some(P=>P(u))}async stop(u){this.f=!0;try{await this.m()}finally{this.a.fire({joinRestart:u}),this.dispose()}}}e.$Yjc=n;class i extends I.$_q{constructor(){super(),this.S=this.B(new S.$he),this.onDidError=this.S.event,this.watchers=new Set,this.W=this.B(new V.$Ph({maxWorkChunkSize:500,throttleDelay:200,maxBufferedWork:3e4},u=>this.a.fire(u))),this.X=!1,this.Y()}Y(){process.on("uncaughtException",u=>this.lb(u)),process.on("unhandledRejection",u=>this.lb(u))}async L(u){u=this.ob(u);const P=[],h=new Set(Array.from(this.watchers));for(const A of u){const o=this.$(A);o&&(0,w.$yk)(o.request.excludes,A.excludes)&&(0,w.$yk)(o.request.includes,A.includes)&&o.request.pollingInterval===A.pollingInterval?h.delete(o):P.push(A)}P.length&&this.N(`Request to start watching: ${P.map(A=>this.J(A)).join(",")}`),h.size&&this.N(`Request to stop watching: ${Array.from(h).map(A=>this.J(A.request)).join(",")}`);for(const A of h)await this.nb(A);for(const A of P)A.pollingInterval?this.ab(A,A.pollingInterval):this.bb(A)}$(u){for(const P of this.watchers)if(this.t(u)||this.t(P.request)){if(P.request.correlationId===u.correlationId)return P}else if((0,k.$yg)(P.request.path,u.path,!d.$e))return P}ab(u,P,h=0){const A=new N.$se,o=new V.$Xh,D=(0,k.$Ig)((0,j.tmpdir)(),"vscode-watcher-snapshot"),O=new n(o.p,u,h,A.token,new V.$Oh(X=>this.eb(X,O),i.U),async()=>{A.dispose(!0),O.worker.flush(),O.worker.dispose(),ee.dispose(),(0,t.unlinkSync)(D)});this.watchers.add(O);const{realPath:$,realPathDiffers:g,realPathLength:K}=this.gb(u);this.N(`Started watching: '${$}' with polling interval '${P}'`);let re=0;const ee=new V.$Mh(async()=>{if(re++,!A.token.isCancellationRequested){if(re>1){const X=await E.getEventsSince($,D,{ignore:u.excludes,backend:i.R});if(A.token.isCancellationRequested)return;this.cb(X,O,g,K)}await E.writeSnapshot($,D,{ignore:u.excludes,backend:i.R}),re===1&&o.complete(),!A.token.isCancellationRequested&&ee.schedule()}},P);ee.schedule(0)}bb(u,P=0){const h=new N.$se,A=new V.$Xh,o=new n(A.p,u,P,h.token,new V.$Oh(g=>this.eb(g,o),i.U),async()=>{h.dispose(!0),o.worker.flush(),o.worker.dispose(),await(await A.p)?.unsubscribe()});this.watchers.add(o);const{realPath:D,realPathDiffers:O,realPathLength:$}=this.gb(u);E.subscribe(D,(g,K)=>{o.token.isCancellationRequested||(g&&this.lb(g,u),this.cb(K,o,O,$))},{backend:i.R,ignore:o.request.excludes}).then(g=>{this.N(`Started watching: '${D}' with backend '${i.R}'`),A.complete(g)}).catch(g=>{this.lb(g,u),A.complete(void 0),o.notifyWatchFailed(),this.c.fire(u)})}cb(u,P,h,A){if(u.length===0)return;this.hb(u,P.request,h,A);const o=this.db(P,u);for(const D of o)P.worker.work(D)}db(u,P){const h=[];for(const{path:A,type:o}of P){const D=i.Q.get(o);this.P&&this.I(`${D===_.FileChangeType.ADDED?"[ADDED]":D===_.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${A}`,u.request),u.include(A)?h.push({type:D,resource:M.URI.file(A),cId:u.request.correlationId}):this.P&&this.I(` >> ignored (not included) ${A}`,u.request)}return h}eb(u,P){const h=(0,y.$Yq)(u),{events:A,rootDeleted:o}=this.ib(h,P);this.fb(A,P),o&&this.jb(P)}fb(u,P){if(u.length===0)return;this.W.work(u)?this.W.pending>0&&this.N(`started throttling events due to large amount of file change events at once (pending: ${this.W.pending}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`,P):this.O(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}gb(u){let P=u.path,h=!1,A=u.path.length;try{P=(0,m.$dr)(u.path),u.path===P&&(P=(0,m.$ar)(u.path)??u.path),u.path!==P&&(A=P.length,h=!0,this.N(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${P})`))}catch{}return{realPath:P,realPathDiffers:h,realPathLength:A}}hb(u,P,h,A){for(const o of u)d.$d&&(o.path=(0,c.$hm)(o.path)),d.$c&&P.path.length<=3&&(o.path=(0,r.$hc)(o.path)),h&&(o.path=P.path+o.path.substr(A))}ib(u,P){const h=[];let A=!1;const o=this.t(P.request)?P.request.filter:void 0;for(const D of u){if(P.subscriptionsCount>0&&P.notifyFileChange(D.resource.fsPath,D),A=D.type===_.FileChangeType.DELETED&&(0,k.$yg)(D.resource.fsPath,P.request.path,!d.$e),(0,y.$2q)(D,o)||A&&!this.t(P.request)){this.P&&this.I(` >> ignored (filtered) ${D.resource.fsPath}`,P.request);continue}this.H(D,P.request),h.push(D)}return{events:h,rootDeleted:A}}jb(u){this.O("Watcher shutdown because watched path got deleted",u);let P=!1;this.t(u.request)||(P=this.kb(u)),P||(u.notifyWatchFailed(),this.c.fire(u.request))}kb(u){const P=(0,r.$mc)(u.request.path);if((0,t.existsSync)(P)){this.N("Trying to watch on the parent path to restart the watcher...",u);const h=new l.$er({path:P,excludes:[],recursive:!1,correlationId:u.request.correlationId},void 0,A=>{if(!u.token.isCancellationRequested){for(const{resource:o,type:D}of A)if((0,k.$yg)(o.fsPath,u.request.path,!d.$e)&&(D===_.FileChangeType.ADDED||D===_.FileChangeType.UPDATED)&&this.pb(u.request.path)){this.O("Watcher restarts because watched path got created again",u),h.dispose(),this.mb(u);break}}},void 0,A=>this.b.fire(A),this.P);return u.token.onCancellationRequested(()=>h.dispose()),!0}return!1}lb(u,P){const h=(0,U.$lj)(u);h.indexOf("No space left on device")!==-1?this.X||(this.sb("Inotify limit reached (ENOSPC)",P),this.X=!0):(this.sb(`Unexpected error: ${h} (EUNKNOWN)`,P),this.S.fire({request:P,error:h}))}async stop(){await super.stop();for(const u of this.watchers)await this.nb(u)}mb(u,P=800){const h=new V.$Mh(async()=>{if(u.token.isCancellationRequested)return;const A=new V.$Xh;try{await this.nb(u,A.p),u.request.pollingInterval?this.ab(u.request,u.request.pollingInterval,u.restarts+1):this.bb(u.request,u.restarts+1)}finally{A.complete()}},P);h.schedule(),u.token.onCancellationRequested(()=>h.dispose())}async nb(u,P){this.N("stopping file watcher",u),this.watchers.delete(u);try{await u.stop(P)}catch(h){this.sb(`Unexpected error stopping watcher: ${(0,U.$lj)(h)}`,u.request)}}ob(u,P=!0){u.sort((o,D)=>o.path.length-D.path.length);const h=new Map;for(const o of u){if(o.excludes.includes(w.$qk))continue;const D=d.$e?o.path:o.path.toLowerCase();let O=h.get(o.correlationId);O||(O=new Map,h.set(o.correlationId,O)),O.has(D)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(o)}`),O.set(D,o)}const A=[];for(const o of h.values()){const D=F.$Gi.forPaths(!d.$e);for(const O of o.values()){if(D.findSubstr(O.path))try{if((0,m.$dr)(O.path)===O.path){this.N(`ignoring a request for watching who's parent is already watched: ${this.J(O)}`);continue}}catch($){this.N(`ignoring a request for watching who's realpath failed to resolve: ${this.J(O)} (error: ${$})`),this.c.fire(O);continue}if(P&&!this.pb(O.path)){this.c.fire(O);continue}D.set(O.path,O)}A.push(...Array.from(D).map(([,O])=>O))}return A}pb(u){try{if(!(0,t.statSync)(u).isDirectory())return this.N(`ignoring a path for watching that is a file and not a folder: ${u}`),!1}catch(P){return this.N(`ignoring a path for watching who's stat info failed to resolve: ${u} (error: ${P})`),!1}return!0}subscribe(u,P){for(const h of this.watchers){if(h.failed||!(0,k.$zg)(u,h.request.path,!d.$e)||h.exclude(u)||!h.include(u))continue;const A=new s.$Tc;return A.add(S.Event.once(h.onDidStop)(async o=>{await o.joinRestart,!A.isDisposed&&P(!0)})),A.add(S.Event.once(h.onDidFail)(()=>P(!0))),A.add(h.subscribe(u,o=>P(null,o))),A}}N(u,P){this.P&&this.b.fire({type:"trace",message:this.tb(u,P?.request)})}O(u,P){this.b.fire({type:"warn",message:this.tb(u,P?.request)})}sb(u,P){this.b.fire({type:"error",message:this.tb(u,P)})}tb(u,P){return P?`[File Watcher (parcel)] ${u} (path: ${P.path})`:`[File Watcher (parcel)] ${u}`}get M(){return this}}e.$Zjc=i,i.Q=new Map([["create",_.FileChangeType.ADDED],["update",_.FileChangeType.UPDATED],["delete",_.FileChangeType.DELETED]]),i.R=d.$c?"windows":d.$e?"inotify":"fs-events",i.U=75}),define(Ee[61],_e([0,1,19]),function($e,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1jc=t;function t(c,r,d){const m=[],l=U(c.filter(K=>K.recursive)),_=l.filter(K=>r.isSuspended(K)===!1),y=l.filter(K=>r.isSuspended(K)==="polling"),s=l.filter(K=>r.isSuspended(K)===!0),n=M(l,r),i=V(r),f=U(c.filter(K=>!K.recursive)),u=f.filter(K=>d.isSuspended(K)===!1),P=f.filter(K=>d.isSuspended(K)==="polling"),h=f.filter(K=>d.isSuspended(K)===!0),A=M(f,d),o=N(d);m.push("[Summary]"),m.push(`- Recursive Requests:     total: ${l.length}, suspended: ${n.suspended}, polling: ${n.polling}`),m.push(`- Non-Recursive Requests: total: ${f.length}, suspended: ${A.suspended}, polling: ${A.polling}`),m.push(`- Recursive Watchers:     total: ${r.watchers.size}, active: ${i.active}, failed: ${i.failed}, stopped: ${i.stopped}`),m.push(`- Non-Recursive Watchers: total: ${d.watchers.size}, active: ${o.active}, failed: ${o.failed}, reusing: ${o.reusing}`),m.push(`- I/O Handles Impact:     total: ${n.polling+A.polling+i.active+o.active}`),m.push(`
[Recursive Requests (${l.length}, suspended: ${n.suspended}, polling: ${n.polling})]:`);const D=[];for(const K of[_,y,s].flat())k(D,K,r);m.push(...j(D));const O=[];I(O,r),m.push(...j(O)),m.push(`
[Non-Recursive Requests (${f.length}, suspended: ${A.suspended}, polling: ${A.polling})]:`);const $=[];for(const K of[u,P,h].flat())k($,K,d);m.push(...j($));const g=[];return F(g,d),m.push(...j(g)),`

[File Watcher] request stats:

${m.join(`
`)}

`}function j(c){let r=0;for(const d of c)r=Math.max(r,d.split("	")[0].length);for(let d=0;d<c.length;d++){const l=c[d].split("	");if(l.length===2){const _=" ".repeat(r-l[0].length);c[d]=`${l[0]}${_}	${l[1]}`}}return c}function M(c,r){let d=0,m=0;for(const l of c){const _=r.isSuspended(l);_!==!1&&(m++,_==="polling"&&d++)}return{suspended:m,polling:d}}function V(c){let r=0,d=0,m=0;for(const l of c.watchers.values())!l.failed&&!l.stopped&&r++,l.failed&&d++,l.stopped&&m++;return{active:r,failed:d,stopped:m}}function N(c){let r=0,d=0,m=0;for(const l of c.watchers)!l.instance.failed&&!l.instance.isReusingRecursiveWatcher&&r++,l.instance.failed&&d++,l.instance.isReusingRecursiveWatcher&&m++;return{active:r,failed:d,reusing:m}}function U(c){return c.sort((r,d)=>{const m=S(r)?r.path:r.request.path,l=S(d)?d.path:d.request.path,_=Math.min(m.length,l.length);for(let y=0;y<_;y++)if(m[y]!==l[y])return m[y]<l[y]?-1:1;return m.length-l.length}),c}function S(c){return typeof c?.path=="string"}function k(c,r,d){const m=[],l=d.isSuspended(r);l!==!1&&(l==="polling"?m.push("[SUSPENDED <polling>]"):m.push("[SUSPENDED <non-polling>]")),c.push(` ${r.path}	${m.length>0?m.join(" ")+" ":""}(${w(r)})`)}function w(c){return`excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,E.$3q)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"}`}function I(c,r){const d=U(Array.from(r.watchers.values())),{active:m,failed:l,stopped:_}=V(r);c.push(`
[Recursive Watchers (${d.length}, active: ${m}, failed: ${l}, stopped: ${_})]:`);for(const y of d){const s=[];y.failed&&s.push("[FAILED]"),y.stopped&&s.push("[STOPPED]"),y.subscriptionsCount>0&&s.push(`[SUBSCRIBED:${y.subscriptionsCount}]`),y.restarts>0&&s.push(`[RESTARTED:${y.restarts}]`),c.push(` ${y.request.path}	${s.length>0?s.join(" ")+" ":""}(${w(y.request)})`)}}function F(c,r){const d=U(Array.from(r.watchers.values())),m=d.filter(i=>!i.instance.failed&&!i.instance.isReusingRecursiveWatcher),l=d.filter(i=>i.instance.failed),_=d.filter(i=>i.instance.isReusingRecursiveWatcher),{active:y,failed:s,reusing:n}=N(r);c.push(`
[Non-Recursive Watchers (${d.length}, active: ${y}, failed: ${s}, reusing: ${n})]:`);for(const i of[m,l,_].flat()){const f=[];i.instance.failed&&f.push("[FAILED]"),i.instance.isReusingRecursiveWatcher&&f.push("[REUSING]"),c.push(` ${i.request.path}	${f.length>0?f.join(" ")+" ":""}(${w(i.request)})`)}}}),define(Ee[62],_e([0,1,4,6,60,59,8,61]),function($e,e,E,t,j,M,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2jc=void 0;class U extends E.$Uc{constructor(){super(...arguments),this.a=this.B(new j.$Zjc),this.b=this.B(new M.$gr(this.a)),this.onDidChangeFile=t.Event.any(this.a.onDidChangeFile,this.b.onDidChangeFile),this.onDidError=t.Event.any(this.a.onDidError,this.b.onDidError),this.c=this.B(new t.$he),this.onDidLogMessage=t.Event.any(this.c.event,this.a.onDidLogMessage,this.b.onDidLogMessage),this.f=[]}async watch(k){this.f=k;let w;try{await this.a.watch(k.filter(I=>I.recursive))}catch(I){w=I}try{await this.b.watch(k.filter(I=>!I.recursive))}catch(I){w||(w=I)}if(w)throw w}async setVerboseLogging(k){k&&this.f.length>0&&this.c.fire({type:"trace",message:(0,N.$1jc)(this.f,this.a,this.b)}),await V.Promises.settled([this.a.setVerboseLogging(k),this.b.setVerboseLogging(k)])}async stop(){await V.Promises.settled([this.a.stop(),this.b.stop()])}}e.$2jc=U}),define(Ee[66],_e([0,1,4,25,51,52,33,62]),function($e,e,E,t,j,M,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;(0,V.$SW)(process)?U=new M.$TW:U=new j.$9q("watcher");const S=new N.$2jc;U.registerChannel("watcher",t.ProxyChannel.fromService(S,new E.$Tc))})}).call(this);

//# sourceMappingURL=watcherMain.js.map
