"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $e=["require","exports","vs/base/common/platform","vs/base/common/path","vs/base/common/charCode","vs/base/common/errors","vs/base/common/extpath","vs/base/common/strings","vs/base/common/uri","vs/base/common/async","vs/base/common/functional","vs/base/common/lazy","vs/base/common/map","vs/base/common/lifecycle","vs/base/common/process","vs/base/common/event","vs/base/common/cancellation","vs/base/common/resources","fs","os","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/arrays","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/symbols","vs/base/common/types","vs/base/common/uint","vs/base/common/network","vs/base/node/pfs","vs/base/node/terminalEncoding","child_process","vs/nls!vs/platform/environment/node/argv","vs/platform/environment/node/argv","vs/platform/environment/node/stdin","vs/platform/environment/node/wait","util","vs/nls","vs/nls!vs/server/node/server.cli","minimist","vs/server/node/server.cli","url","http"],Ee=function(ae){for(var e=[],h=0,t=ae.length;h<t;h++)e[h]=$e[ae[h]];return e};define($e[20],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=h,e.$gb=t,e.$hb=A,e.$ib=p,e.$jb=ee,e.$kb=z,e.$lb=F,e.$nb=X,e.$ob=te,e.$pb=j,e.$qb=ie,e.$rb=S;function h(c,g){const y=t(c,g);if(y!==-1)return c[y]}function t(c,g,y=c.length-1){for(let M=y;M>=0;M--){const q=c[M];if(g(q))return M}return-1}function A(c,g){const y=p(c,g);return y===-1?void 0:c[y]}function p(c,g,y=0,M=c.length){let q=y,ne=M;for(;q<ne;){const _=Math.floor((q+ne)/2);g(c[_])?q=_+1:ne=_}return q-1}function ee(c,g){const y=z(c,g);return y===c.length?void 0:c[y]}function z(c,g,y=0,M=c.length){let q=y,ne=M;for(;q<ne;){const _=Math.floor((q+ne)/2);g(c[_])?ne=_:q=_+1}return q}function F(c,g,y=0,M=c.length){const q=z(c,g,y,M);return q===c.length?-1:q}class P{constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(P.assertInvariants){if(this.d){for(const M of this.e)if(this.d(M)&&!g(M))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const y=p(this.e,g,this.c);return this.c=y+1,y===-1?void 0:this.e[y]}}e.$mb=P,P.assertInvariants=!1;function X(c,g){if(c.length===0)return;let y=c[0];for(let M=1;M<c.length;M++){const q=c[M];g(q,y)>0&&(y=q)}return y}function te(c,g){if(c.length===0)return;let y=c[0];for(let M=1;M<c.length;M++){const q=c[M];g(q,y)>=0&&(y=q)}return y}function j(c,g){return X(c,(y,M)=>-g(y,M))}function ie(c,g){if(c.length===0)return-1;let y=0;for(let M=1;M<c.length;M++){const q=c[M];g(q,c[y])>0&&(y=M)}return y}function S(c,g){for(const y of c){const M=g(y);if(M!==void 0)return M}}}),define($e[4],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var h;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(h||(e.CharCode=h={}))}),define($e[21],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E=h,e.$F=t,e.$G=A,e.$H=p;function h(ee,z){const F=Object.create(null);for(const P of ee){const X=z(P);let te=F[X];te||(te=F[X]=[]),te.push(P)}return F}function t(ee,z){const F=[],P=[];for(const X of ee)z.has(X)||F.push(X);for(const X of z)ee.has(X)||P.push(X);return{removed:F,added:P}}function A(ee,z){const F=[],P=[];for(const[X,te]of ee)z.has(X)||F.push(te);for(const[X,te]of z)ee.has(X)||P.push(te);return{removed:F,added:P}}function p(ee,z){const F=new Set;for(const P of z)ee.has(P)&&F.add(P);return F}}),define($e[5],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=t,e.$Z=A,e.$1=p,e.$2=ee,e.$3=z,e.$4=P,e.$6=te,e.$7=j,e.$8=ie,e.$0=c;class h{constructor(){this.b=[],this.a=function(n){setTimeout(()=>{throw n.stack?q.isErrorNoTelemetry(n)?new q(n.message+`

`+n.stack):new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.b.push(n),()=>{this.d(n)}}c(n){this.b.forEach(i=>{i(n)})}d(n){this.b.splice(this.b.indexOf(n),1)}setUnexpectedErrorHandler(n){this.a=n}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(n){this.a(n),this.c(n)}onUnexpectedExternalError(n){this.a(n)}}e.$W=h,e.$X=new h;function t(_){e.$X.setUnexpectedErrorHandler(_)}function A(_){if(!_||typeof _!="object")return!1;const n=_;return n.code==="EPIPE"&&n.syscall?.toUpperCase()==="WRITE"}function p(_){P(_)||e.$X.onUnexpectedError(_)}function ee(_){P(_)||e.$X.onUnexpectedExternalError(_)}function z(_){if(_ instanceof Error){const{name:n,message:i}=_,l=_.stacktrace||_.stack;return{$isError:!0,name:n,message:i,stack:l,noTelemetry:q.isErrorNoTelemetry(_)}}return _}const F="Canceled";function P(_){return _ instanceof X?!0:_ instanceof Error&&_.name===F&&_.message===F}class X extends Error{constructor(){super(F),this.name=this.message}}e.$5=X;function te(){const _=new Error(F);return _.name=_.message,_}function j(_){return _?new Error(`Illegal argument: ${_}`):new Error("Illegal argument")}function ie(_){return _?new Error(`Illegal state: ${_}`):new Error("Illegal state")}class S extends TypeError{constructor(n){super(n?`${n} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function c(_){return _?_.message?_.message:_.stack?_.stack.split(`
`)[0]:String(_):"Error"}class g extends Error{constructor(n){super("NotImplemented"),n&&(this.message=n)}}e.$$=g;class y extends Error{constructor(n){super("NotSupported"),n&&(this.message=n)}}e.$_=y;class M extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=M;class q extends Error{constructor(n){super(n),this.name="CodeExpectedError"}static fromError(n){if(n instanceof q)return n;const i=new q;return i.message=n.message,i.stack=n.stack,i}static isErrorNoTelemetry(n){return n.name==="CodeExpectedError"}}e.$bb=q;class ne extends Error{constructor(n){super(n||"An unexpected bug occurred."),Object.setPrototypeOf(this,ne.prototype)}}e.$cb=ne}),define($e[22],Ee([0,1,5,20]),function(ae,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=A,e.$tb=p,e.$ub=ee,e.$vb=z,e.$wb=F,e.$xb=P,e.$yb=X,e.$zb=te,e.$Ab=j,e.$Bb=ie,e.$Cb=S,e.$Db=c,e.$Eb=g,e.top=y,e.$Gb=M,e.$Hb=ne,e.$Ib=_,e.$Jb=n,e.$Kb=i,e.$Lb=l,e.$Mb=m,e.$Nb=L,e.$Ob=f,e.$Pb=d,e.$Qb=s,e.$Rb=a,e.$Sb=D,e.$Tb=I,e.$Ub=u,e.$Vb=B,e.$Wb=G,e.$Xb=V,e.$Yb=T,e.$Zb=Q,e.$1b=O,e.$2b=v,e.$3b=H,e.$4b=K,e.$5b=Z,e.$6b=be,e.$7b=ve,e.$0b=ue;function A($,R=0){return $[$.length-(1+R)]}function p($){if($.length===0)throw new Error("Invalid tail call");return[$.slice(0,$.length-1),$[$.length-1]]}function ee($,R,U=(b,r)=>b===r){if($===R)return!0;if(!$||!R||$.length!==R.length)return!1;for(let b=0,r=$.length;b<r;b++)if(!U($[b],R[b]))return!1;return!0}function z($,R){const U=$.length-1;R<U&&($[R]=$[U]),$.pop()}function F($,R,U){return P($.length,b=>U($[b],R))}function P($,R){let U=0,b=$-1;for(;U<=b;){const r=(U+b)/2|0,w=R(r);if(w<0)U=r+1;else if(w>0)b=r-1;else return r}return-(U+1)}function X($,R,U){if($=$|0,$>=R.length)throw new TypeError("invalid index");const b=R[Math.floor(R.length*Math.random())],r=[],w=[],N=[];for(const W of R){const oe=U(W,b);oe<0?r.push(W):oe>0?w.push(W):N.push(W)}return $<r.length?X($,r,U):$<r.length+N.length?N[0]:X($-(r.length+N.length),w,U)}function te($,R){const U=[];let b;for(const r of $.slice(0).sort(R))!b||R(b[0],r)!==0?(b=[r],U.push(b)):b.push(r);return U}function*j($,R){let U,b;for(const r of $)b!==void 0&&R(b,r)?U.push(r):(U&&(yield U),U=[r]),b=r;U&&(yield U)}function ie($,R){for(let U=0;U<=$.length;U++)R(U===0?void 0:$[U-1],U===$.length?void 0:$[U])}function S($,R){for(let U=0;U<$.length;U++)R(U===0?void 0:$[U-1],$[U],U+1===$.length?void 0:$[U+1])}function c($,R,U){const b=[];function r(W,oe,we){if(oe===0&&we.length===0)return;const x=b[b.length-1];x&&x.start+x.deleteCount===W?(x.deleteCount+=oe,x.toInsert.push(...we)):b.push({start:W,deleteCount:oe,toInsert:we})}let w=0,N=0;for(;;){if(w===$.length){r(w,0,R.slice(N));break}if(N===R.length){r(w,$.length-w,[]);break}const W=$[w],oe=R[N],we=U(W,oe);we===0?(w+=1,N+=1):we<0?(r(w,1,[]),w+=1):we>0&&(r(w,0,[oe]),N+=1)}return b}function g($,R,U){const b=c($,R,U),r=[],w=[];for(const N of b)r.push(...$.slice(N.start,N.start+N.deleteCount)),w.push(...N.toInsert);return{removed:r,added:w}}function y($,R,U){if(U===0)return[];const b=$.slice(0,U).sort(R);return q($,R,b,U,$.length),b}function M($,R,U,b,r){return U===0?Promise.resolve([]):new Promise((w,N)=>{(async()=>{const W=$.length,oe=$.slice(0,U).sort(R);for(let we=U,x=Math.min(U+b,W);we<W;we=x,x=Math.min(x+b,W)){if(we>U&&await new Promise(C=>setTimeout(C)),r&&r.isCancellationRequested)throw new h.$5;q($,R,oe,we,x)}return oe})().then(w,N)})}function q($,R,U,b,r){for(const w=U.length;b<r;b++){const N=$[b];if(R(N,U[w-1])<0){U.pop();const W=(0,t.$kb)(U,oe=>R(N,oe)<0);U.splice(W,0,N)}}}function ne($){return $.filter(R=>!!R)}function _($){let R=0;for(let U=0;U<$.length;U++)$[U]&&($[R]=$[U],R+=1);$.length=R}function n($,R,U){$.splice(U,0,$.splice(R,1)[0])}function i($){return!Array.isArray($)||$.length===0}function l($){return Array.isArray($)&&$.length>0}function m($,R=U=>U){const U=new Set;return $.filter(b=>{const r=R(b);return U.has(r)?!1:(U.add(r),!0)})}function L($){const R=new Set;return U=>{const b=$(U);return R.has(b)?!1:(R.add(b),!0)}}function f($,R){return $.length>0?$[0]:R}function d($,R){return $.length>0?$[$.length-1]:R}function s($,R,U=(b,r)=>b===r){let b=0;for(let r=0,w=Math.min($.length,R.length);r<w&&U($[r],R[r]);r++)b++;return b}function a($,R){let U=typeof R=="number"?$:0;typeof R=="number"?U=$:(U=0,R=$);const b=[];if(U<=R)for(let r=U;r<R;r++)b.push(r);else for(let r=U;r>R;r--)b.push(r);return b}function D($,R,U){return $.reduce((b,r)=>(b[R(r)]=U?U(r):r,b),Object.create(null))}function I($,R){return $.push(R),()=>u($,R)}function u($,R){const U=$.indexOf(R);if(U>-1)return $.splice(U,1),R}function B($,R,U){const b=$.slice(0,R),r=$.slice(R);return b.concat(U,r)}function G($,R){let U;if(typeof R=="number"){let b=R;U=()=>{const r=Math.sin(b++)*179426549;return r-Math.floor(r)}}else U=Math.random;for(let b=$.length-1;b>0;b-=1){const r=Math.floor(U()*(b+1)),w=$[b];$[b]=$[r],$[r]=w}}function V($,R){const U=$.indexOf(R);U>-1&&($.splice(U,1),$.unshift(R))}function T($,R){const U=$.indexOf(R);U>-1&&($.splice(U,1),$.push(R))}function Q($,R){for(const U of R)$.push(U)}function O($,R){return Array.isArray($)?$.map(R):R($)}function v($){return Array.isArray($)?$:[$]}function H($){return $[Math.floor(Math.random()*$.length)]}function K($,R,U){const b=J($,R),r=$.length,w=U.length;$.length=r+w;for(let N=r-1;N>=b;N--)$[N+w]=$[N];for(let N=0;N<w;N++)$[N+b]=U[N]}function Z($,R,U,b){const r=J($,R);let w=$.splice(r,U);return w===void 0&&(w=[]),K($,r,b),w}function J($,R){return R<0?Math.max(R+$.length,0):Math.min(R,$.length)}var se;(function($){function R(w){return w<0}$.isLessThan=R;function U(w){return w<=0}$.isLessThanOrEqual=U;function b(w){return w>0}$.isGreaterThan=b;function r(w){return w===0}$.isNeitherLessOrGreaterThan=r,$.greaterThan=1,$.lessThan=-1,$.neitherLessOrGreaterThan=0})(se||(e.CompareResult=se={}));function be($,R){return(U,b)=>R($(U),$(b))}function ve(...$){return(R,U)=>{for(const b of $){const r=b(R,U);if(!se.isNeitherLessOrGreaterThan(r))return r}return se.neitherLessOrGreaterThan}}const Re=($,R)=>$-R;e.$8b=Re;const Te=($,R)=>(0,e.$8b)($?1:0,R?1:0);e.$9b=Te;function ue($){return(R,U)=>-$(R,U)}class ye{constructor(R){this.g=R,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(R){let U=this.c;for(;U<this.g.length&&R(this.g[U]);)U++;const b=U===this.c?null:this.g.slice(this.c,U);return this.c=U,b}takeFromEndWhile(R){let U=this.d;for(;U>=0&&R(this.g[U]);)U--;const b=U===this.d?null:this.g.slice(U+1,this.d+1);return this.d=U,b}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const R=this.g[this.c];return this.c++,R}removeLast(){const R=this.g[this.d];return this.d--,R}takeCount(R){const U=this.g.slice(this.c,this.c+R);return this.c+=R,U}}e.$$b=ye;class de{constructor(R){this.iterate=R}forEach(R){this.iterate(U=>(R(U),!0))}toArray(){const R=[];return this.iterate(U=>(R.push(U),!0)),R}filter(R){return new de(U=>this.iterate(b=>R(b)?U(b):!0))}map(R){return new de(U=>this.iterate(b=>U(R(b))))}some(R){let U=!1;return this.iterate(b=>(U=R(b),!U)),U}findFirst(R){let U;return this.iterate(b=>R(b)?(U=b,!1):!0),U}findLast(R){let U;return this.iterate(b=>(R(b)&&(U=b),!0)),U}findLastMaxBy(R){let U,b=!0;return this.iterate(r=>((b||se.isGreaterThan(R(r,U)))&&(b=!1,U=r),!0)),U}}e.$_b=de,de.empty=new de($=>{});class ge{constructor(R){this.c=R}static createSortPermutation(R,U){const b=Array.from(R.keys()).sort((r,w)=>U(R[r],R[w]));return new ge(b)}apply(R){return R.map((U,b)=>R[this.c[b]])}inverse(){const R=this.c.slice();for(let U=0;U<this.c.length;U++)R[this.c[U]]=U;return new ge(R)}}e.$ac=ge}),define($e[10],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=h;function h(t,A){const p=this;let ee=!1,z;return function(){if(ee)return z;if(ee=!0,A)try{z=t.apply(p,arguments)}finally{A()}else z=t.apply(p,arguments);return z}}}),define($e[23],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var h;(function(t){function A(n){return n&&typeof n=="object"&&typeof n[Symbol.iterator]=="function"}t.is=A;const p=Object.freeze([]);function ee(){return p}t.empty=ee;function*z(n){yield n}t.single=z;function F(n){return A(n)?n:z(n)}t.wrap=F;function P(n){return n||p}t.from=P;function*X(n){for(let i=n.length-1;i>=0;i--)yield n[i]}t.reverse=X;function te(n){return!n||n[Symbol.iterator]().next().done===!0}t.isEmpty=te;function j(n){return n[Symbol.iterator]().next().value}t.first=j;function ie(n,i){for(const l of n)if(i(l))return!0;return!1}t.some=ie;function S(n,i){for(const l of n)if(i(l))return l}t.find=S;function*c(n,i){for(const l of n)i(l)&&(yield l)}t.filter=c;function*g(n,i){let l=0;for(const m of n)yield i(m,l++)}t.map=g;function*y(...n){for(const i of n)yield*i}t.concat=y;function M(n,i,l){let m=l;for(const L of n)m=i(m,L);return m}t.reduce=M;function*q(n,i,l=n.length){for(i<0&&(i+=n.length),l<0?l+=n.length:l>n.length&&(l=n.length);i<l;i++)yield n[i]}t.slice=q;function ne(n,i=Number.POSITIVE_INFINITY){const l=[];if(i===0)return[l,n];const m=n[Symbol.iterator]();for(let L=0;L<i;L++){const f=m.next();if(f.done)return[l,t.empty()];l.push(f.value)}return[l,{[Symbol.iterator](){return m}}]}t.consume=ne;async function _(n){const i=[];for await(const l of n)i.push(l);return Promise.resolve(i)}t.asyncToArray=_})(h||(e.Iterable=h={}))}),define($e[11],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class h{constructor(A){this.d=A,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(A){this.c=A}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=h}),define($e[24],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class h{constructor(p){this.element=p,this.next=h.Undefined,this.prev=h.Undefined}}h.Undefined=new h(void 0);class t{constructor(){this.a=h.Undefined,this.b=h.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===h.Undefined}clear(){let p=this.a;for(;p!==h.Undefined;){const ee=p.next;p.prev=h.Undefined,p.next=h.Undefined,p=ee}this.a=h.Undefined,this.b=h.Undefined,this.c=0}unshift(p){return this.d(p,!1)}push(p){return this.d(p,!0)}d(p,ee){const z=new h(p);if(this.a===h.Undefined)this.a=z,this.b=z;else if(ee){const P=this.b;this.b=z,z.prev=P,P.next=z}else{const P=this.a;this.a=z,z.next=P,P.prev=z}this.c+=1;let F=!1;return()=>{F||(F=!0,this.e(z))}}shift(){if(this.a!==h.Undefined){const p=this.a.element;return this.e(this.a),p}}pop(){if(this.b!==h.Undefined){const p=this.b.element;return this.e(this.b),p}}e(p){if(p.prev!==h.Undefined&&p.next!==h.Undefined){const ee=p.prev;ee.next=p.next,p.next.prev=ee}else p.prev===h.Undefined&&p.next===h.Undefined?(this.a=h.Undefined,this.b=h.Undefined):p.next===h.Undefined?(this.b=this.b.prev,this.b.next=h.Undefined):p.prev===h.Undefined&&(this.a=this.a.next,this.a.prev=h.Undefined);this.c-=1}*[Symbol.iterator](){let p=this.a;for(;p!==h.Undefined;)yield p.element,p=p.next}}e.$5c=t}),define($e[12],Ee([0,1]),function(ae,e){"use strict";var h,t,A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=p,e.$yc=ee,e.$zc=z,e.$Ic=ne;function p(_,n,i){let l=_.get(n);return l===void 0&&(l=i,_.set(n,l)),l}function ee(_){const n=[];return _.forEach((i,l)=>{n.push(`${l} => ${i}`)}),`Map(${_.size}) {${n.join(", ")}}`}function z(_){const n=[];return _.forEach(i=>{n.push(i)}),`Set(${_.size}) {${n.join(", ")}}`}class F{constructor(n,i){this.uri=n,this.value=i}}function P(_){return Array.isArray(_)}class X{constructor(n,i){if(this[h]="ResourceMap",n instanceof X)this.d=new Map(n.d),this.e=i??X.c;else if(P(n)){this.d=new Map,this.e=i??X.c;for(const[l,m]of n)this.set(l,m)}else this.d=new Map,this.e=n??X.c}set(n,i){return this.d.set(this.e(n),new F(n,i)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,i){typeof i<"u"&&(n=n.bind(i));for(const[l,m]of this.d)n(m.value,m.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(h=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=X,X.c=_=>_.toString();class te{constructor(n,i){this[t]="ResourceSet",!n||typeof n=="function"?this.c=new X(n):(this.c=new X(i),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,i){this.c.forEach((l,m)=>n.call(i,m,m,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=te;var j;(function(_){_[_.None=0]="None",_[_.AsOld=1]="AsOld",_[_.AsNew=2]="AsNew"})(j||(e.Touch=j={}));class ie{constructor(){this[A]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,i=j.None){const l=this.c.get(n);if(l)return i!==j.None&&this.m(l,i),l.value}set(n,i,l=j.None){let m=this.c.get(n);if(m)m.value=i,l!==j.None&&this.m(m,l);else{switch(m={key:n,value:i,next:void 0,previous:void 0},l){case j.None:this.k(m);break;case j.AsOld:this.j(m);break;case j.AsNew:this.k(m);break;default:this.k(m);break}this.c.set(n,m),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const i=this.c.get(n);if(i)return this.c.delete(n),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.l(n),this.f--,n.value}forEach(n,i){const l=this.g;let m=this.d;for(;m;){if(i?n.bind(i)(m.value,m.key,this):n(m.value,m.key,this),this.g!==l)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const n=this,i=this.g;let l=this.d;const m={[Symbol.iterator](){return m},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const L={value:l.key,done:!1};return l=l.next,L}else return{value:void 0,done:!0}}};return m}values(){const n=this,i=this.g;let l=this.d;const m={[Symbol.iterator](){return m},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const L={value:l.value,done:!1};return l=l.next,L}else return{value:void 0,done:!0}}};return m}entries(){const n=this,i=this.g;let l=this.d;const m={[Symbol.iterator](){return m},next(){if(n.g!==i)throw new Error("LinkedMap got modified during iteration.");if(l){const L={value:[l.key,l.value],done:!1};return l=l.next,L}else return{value:void 0,done:!0}}};return m}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.d,l=this.size;for(;i&&l>n;)this.c.delete(i.key),i=i.next,l--;this.d=i,this.f=l,i&&(i.previous=void 0),this.g++}i(n){if(n>=this.size)return;if(n===0){this.clear();return}let i=this.e,l=this.size;for(;i&&l>n;)this.c.delete(i.key),i=i.previous,l--;this.e=i,this.f=l,i&&(i.next=void 0),this.g++}j(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}k(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}l(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const i=n.next,l=n.previous;if(!i||!l)throw new Error("Invalid list");i.previous=l,l.next=i}n.next=void 0,n.previous=void 0,this.g++}m(n,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==j.AsOld&&i!==j.AsNew)){if(i===j.AsOld){if(n===this.d)return;const l=n.next,m=n.previous;n===this.e?(m.next=void 0,this.e=m):(l.previous=m,m.next=l),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(i===j.AsNew){if(n===this.e)return;const l=n.next,m=n.previous;n===this.d?(l.previous=void 0,this.d=l):(l.previous=m,m.next=l),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((i,l)=>{n.push([l,i])}),n}fromJSON(n){this.clear();for(const[i,l]of n)this.set(i,l)}}e.$Cc=ie;class S extends ie{constructor(n,i=1){super(),this.n=n,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(n){this.n=n,this.p()}get ratio(){return this.o}set ratio(n){this.o=Math.min(Math.max(0,n),1),this.p()}get(n,i=j.AsNew){return super.get(n,i)}peek(n){return super.get(n,j.None)}set(n,i){return super.set(n,i,j.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class c extends S{constructor(n,i=1){super(n,i)}q(n){this.h(n)}set(n,i){return super.set(n,i),this.p(),this}}e.$Dc=c;class g extends S{constructor(n,i=1){super(n,i)}q(n){this.i(n)}set(n,i){return this.n<=this.size&&!this.has(n)&&this.q(Math.round(this.n*this.o)-1),super.set(n,i),this}}e.$Ec=g;class y{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let i=this.c.get(n)||0;return i===0?!1:(i--,i===0?this.c.delete(n):this.c.set(n,i),!0)}has(n){return this.c.has(n)}}e.$Fc=y;class M{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[i,l]of n)this.set(i,l)}clear(){this.c.clear(),this.d.clear()}set(n,i){this.c.set(n,i),this.d.set(i,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const i=this.c.get(n);return i===void 0?!1:(this.c.delete(n),this.d.delete(i),!0)}forEach(n,i){this.c.forEach((l,m)=>{n.call(i,l,m,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=M;class q{constructor(){this.c=new Map}add(n,i){let l=this.c.get(n);l||(l=new Set,this.c.set(n,l)),l.add(i)}delete(n,i){const l=this.c.get(n);l&&(l.delete(i),l.size===0&&this.c.delete(n))}forEach(n,i){const l=this.c.get(n);l&&l.forEach(i)}get(n){const i=this.c.get(n);return i||new Set}}e.$Hc=q;function ne(_,n){if(_===n)return!0;if(_.size!==n.size)return!1;for(const[i,l]of _)if(!n.has(i)||n.get(i)!==l)return!1;for(const[i]of n)if(!_.has(i))return!1;return!0}}),define($e[13],Ee([0,1,22,21,12,10,23]),function(ae,e,h,t,A,p,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=X,e.$Lc=te,e.$Mc=j,e.$Nc=c,e.$Oc=g,e.$Pc=y,e.$Qc=M,e.$Rc=q,e.$Sc=ne,e.$3c=a;const z=!1;let F=null;class P{constructor(){this.b=new Map}c(u){let B=this.b.get(u);return B||(B={parent:null,source:null,isSingleton:!1,value:u,idx:P.a++},this.b.set(u,B)),B}trackDisposable(u){const B=this.c(u);B.source||(B.source=new Error().stack)}setParent(u,B){const G=this.c(u);G.parent=B}markAsDisposed(u){this.b.delete(u)}markAsSingleton(u){this.c(u).isSingleton=!0}f(u,B){const G=B.get(u);if(G)return G;const V=u.parent?this.f(this.c(u.parent),B):u;return B.set(u,V),V}getTrackedDisposables(){const u=new Map;return[...this.b.entries()].filter(([,G])=>G.source!==null&&!this.f(G,u).isSingleton).flatMap(([G])=>G)}computeLeakingDisposables(u=10,B){let G;if(B)G=B;else{const v=new Map,H=[...this.b.values()].filter(Z=>Z.source!==null&&!this.f(Z,v).isSingleton);if(H.length===0)return;const K=new Set(H.map(Z=>Z.value));if(G=H.filter(Z=>!(Z.parent&&K.has(Z.parent))),G.length===0)throw new Error("There are cyclic diposable chains!")}if(!G)return;function V(v){function H(Z,J){for(;Z.length>0&&J.some(se=>typeof se=="string"?se===Z[0]:Z[0].match(se));)Z.shift()}const K=v.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return H(K,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),K.reverse()}const T=new A.$Hc;for(const v of G){const H=V(v);for(let K=0;K<=H.length;K++)T.add(H.slice(0,K).join(`
`),v)}G.sort((0,h.$6b)(v=>v.idx,h.$8b));let Q="",O=0;for(const v of G.slice(0,u)){O++;const H=V(v),K=[];for(let Z=0;Z<H.length;Z++){let J=H[Z];J=`(shared with ${T.get(H.slice(0,Z+1).join(`
`)).size}/${G.length} leaks) at ${J}`;const be=T.get(H.slice(0,Z).join(`
`)),ve=(0,t.$E)([...be].map(Re=>V(Re)[Z]),Re=>Re);delete ve[H[Z]];for(const[Re,Te]of Object.entries(ve))K.unshift(`    - stacktraces of ${Te.length} other leaks continue with ${Re}`);K.unshift(J)}Q+=`


==================== Leaking disposable ${O}/${G.length}: ${v.value.constructor.name} ====================
${K.join(`
`)}
============================================================

`}return G.length>u&&(Q+=`


... and ${G.length-u} more leaking disposables

`),{leaks:G,details:Q}}}e.$Jc=P,P.a=0;function X(I){F=I}if(z){const I="__is_disposable_tracked__";X(new class{trackDisposable(u){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[I]||console.log(B)},3e3)}setParent(u,B){if(u&&u!==n.None)try{u[I]=!0}catch{}}markAsDisposed(u){if(u&&u!==n.None)try{u[I]=!0}catch{}}markAsSingleton(u){}})}function te(I){return F?.trackDisposable(I),I}function j(I){F?.markAsDisposed(I)}function ie(I,u){F?.setParent(I,u)}function S(I,u){if(F)for(const B of I)F.setParent(B,u)}function c(I){return F?.markAsSingleton(I),I}function g(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function y(I){if(ee.Iterable.is(I)){const u=[];for(const B of I)if(B)try{B.dispose()}catch(G){u.push(G)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function M(I){for(const u of I)g(u)&&u.dispose();return[]}function q(...I){const u=ne(()=>y(I));return S(I,u),u}function ne(I){const u=te({dispose:(0,p.$db)(()=>{j(u),I()})});return u}class _{constructor(){this.f=new Set,this.g=!1,te(this)}dispose(){this.g||(j(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{y(this.f)}finally{this.f.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return ie(u,this),this.g?_.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(u),u}delete(u){if(u){if(u===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(u),u.dispose()}}deleteAndLeak(u){u&&this.f.has(u)&&(this.f.delete(u),ie(u,null))}}e.$Tc=_,_.DISABLE_DISPOSED_WARNING=!1;class n{constructor(){this.q=new _,te(this),ie(this.q,this)}dispose(){j(this),this.q.dispose()}B(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(u)}}e.$Uc=n,n.None=Object.freeze({dispose(){}});class i{constructor(){this.b=!1,te(this)}get value(){return this.b?void 0:this.a}set value(u){this.b||u===this.a||(this.a?.dispose(),u&&ie(u,this),this.a=u)}clear(){this.value=void 0}dispose(){this.b=!0,j(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const u=this.a;return this.a=void 0,u&&ie(u,null),u}}e.$Vc=i;class l{constructor(u){this.a=new i,this.b=!1,this.a.value=u}get value(){return this.a.value}set value(u){this.b||u===this.a.value||(this.a.value=u)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=l;class m{constructor(u){this.b=u,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=m;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,te(this)}set(u){let B=u;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,j(this))},this}}e.$Yc=L;class f{constructor(){this.a=new Map}acquire(u,...B){let G=this.a.get(u);G||(G={counter:0,object:this.b(u,...B)},this.a.set(u,G));const{object:V}=G,T=(0,p.$db)(()=>{--G.counter===0&&(this.c(u,G.object),this.a.delete(u))});return G.counter++,{object:V,dispose:T}}}e.$Zc=f;class d{constructor(u){this.a=u}async acquire(u,...B){const G=this.a.acquire(u,...B);try{return{object:await G.object,dispose:()=>G.dispose()}}catch(V){throw G.dispose(),V}}}e.$1c=d;class s{constructor(u){this.object=u}dispose(){}}e.$2c=s;function a(I){const u=new _;try{I(u)}finally{u.dispose()}}class D{constructor(){this.a=new Map,this.b=!1,te(this)}dispose(){j(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{y(this.a.values())}finally{this.a.clear()}}has(u){return this.a.has(u)}get size(){return this.a.size}get(u){return this.a.get(u)}set(u,B,G=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),G||this.a.get(u)?.dispose(),this.a.set(u,B)}deleteAndDispose(u){this.a.get(u)?.dispose(),this.a.delete(u)}deleteAndLeak(u){const B=this.a.get(u);return this.a.delete(u),B}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=D}),define($e[25],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var h;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(h||(e.MarshalledId=h={}))}),define($e[26],Ee([0,1,12]),function(ae,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=void 0,e.$hm=A,e.$im=ee;const t=new h.$Dc(1e4);function A(P){return F(P,"NFC",t)}const p=new h.$Dc(1e4);function ee(P){return F(P,"NFD",p)}const z=/[^\u0000-\u0080]/;function F(P,X,te){if(!P)return P;const j=te.get(P);if(j)return j;let ie;return z.test(P)?ie=P.normalize(X):ie=P,te.set(P,ie),ie}e.$jm=function(){const P=/[\u0300-\u036f]/g;return function(X){return ee(X).replace(P,"")}}()}),define($e[2],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=n,e.$x=d,e.$D=s,e.$a="en";let h=!1,t=!1,A=!1,p=!1,ee=!1,z=!1,F=!1,P=!1,X=!1,te=!1,j,ie=e.$a,S=e.$a,c,g;const y=globalThis;let M;typeof y.vscode<"u"&&typeof y.vscode.process<"u"?M=y.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(M=process);const q=typeof M?.versions?.electron=="string",ne=q&&M?.type==="renderer";if(typeof M=="object"){h=M.platform==="win32",t=M.platform==="darwin",A=M.platform==="linux",p=A&&!!M.env.SNAP&&!!M.env.SNAP_REVISION,F=q,X=!!M.env.CI||!!M.env.BUILD_ARTIFACTSTAGINGDIRECTORY,j=e.$a,ie=e.$a;const a=M.env.VSCODE_NLS_CONFIG;if(a)try{const D=JSON.parse(a),I=D.availableLanguages["*"];j=D.locale,S=D.osLocale,ie=I||e.$a,c=D._translationsConfigFile}catch{}ee=!0}else if(typeof navigator=="object"&&!ne){g=navigator.userAgent,h=g.indexOf("Windows")>=0,t=g.indexOf("Macintosh")>=0,P=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,te=g?.indexOf("Mobi")>=0,z=!0,j=e.$a,ie=j,S=navigator.language;const a=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),D=a&&a.getAttribute("data-settings");if(D)try{const I=JSON.parse(D),u=I.availableLanguages["*"];j=I.locale,S=I.osLocale,ie=u||e.$a,c=I._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var _;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(_||(e.Platform=_={}));function n(a){switch(a){case _.Web:return"Web";case _.Mac:return"Mac";case _.Linux:return"Linux";case _.Windows:return"Windows"}}let i=_.Web;t?i=_.Mac:h?i=_.Windows:A&&(i=_.Linux),e.$c=h,e.$d=t,e.$e=A,e.$f=p,e.$g=ee,e.$h=F,e.$i=z,e.$j=z&&typeof y.importScripts=="function",e.$k=e.$j?y.origin:void 0,e.$l=P,e.$m=te,e.$n=X,e.$o=i,e.$p=g,e.$q=ie;var l;(function(a){function D(){return e.$q}a.value=D;function I(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}a.isDefaultVariant=I;function u(){return e.$q==="en"}a.isDefault=u})(l||(e.Language=l={})),e.$r=j,e.$s=S,e.$t=c,e.$u=typeof y.postMessage=="function"&&!y.importScripts,e.$v=(()=>{if(e.$u){const a=[];y.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let u=0,B=a.length;u<B;u++){const G=a[u];if(G.id===I.data.vscodeScheduleAsyncWork){a.splice(u,1),G.callback();return}}});let D=0;return I=>{const u=++D;a.push({id:u,callback:I}),y.postMessage({vscodeScheduleAsyncWork:u},"*")}}return a=>setTimeout(a)})();var m;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(m||(e.OperatingSystem=m={})),e.OS=t||P?m.Macintosh:h?m.Windows:m.Linux;let L=!0,f=!1;function d(){if(!f){f=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,L=new Uint16Array(a.buffer)[0]===513}return L}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function s(a){return parseFloat(a)>=20}}),define($e[14],Ee([0,1,2]),function(ae,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let t;const A=globalThis.vscode;if(typeof A<"u"&&typeof A.process<"u"){const p=A.process;t={get platform(){return p.platform},get arch(){return p.arch},get env(){return p.env},cwd(){return p.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return h.$c?"win32":h.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$dc=t.platform,e.$ec=t.arch}),define($e[3],Ee([0,1,14]),function(ae,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const t=65,A=97,p=90,ee=122,z=46,F=47,P=92,X=58,te=63;class j extends Error{constructor(i,l,m){let L;typeof l=="string"&&l.indexOf("not ")===0?(L="must not be",l=l.replace(/^not /,"")):L="must be";const f=i.indexOf(".")!==-1?"property":"argument";let d=`The "${i}" ${f} ${L} of type ${l}`;d+=`. Received type ${typeof m}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function ie(n,i){if(n===null||typeof n!="object")throw new j(i,"Object",n)}function S(n,i){if(typeof n!="string")throw new j(i,"string",n)}const c=h.$dc==="win32";function g(n){return n===F||n===P}function y(n){return n===F}function M(n){return n>=t&&n<=p||n>=A&&n<=ee}function q(n,i,l,m){let L="",f=0,d=-1,s=0,a=0;for(let D=0;D<=n.length;++D){if(D<n.length)a=n.charCodeAt(D);else{if(m(a))break;a=F}if(m(a)){if(!(d===D-1||s===1))if(s===2){if(L.length<2||f!==2||L.charCodeAt(L.length-1)!==z||L.charCodeAt(L.length-2)!==z){if(L.length>2){const I=L.lastIndexOf(l);I===-1?(L="",f=0):(L=L.slice(0,I),f=L.length-1-L.lastIndexOf(l)),d=D,s=0;continue}else if(L.length!==0){L="",f=0,d=D,s=0;continue}}i&&(L+=L.length>0?`${l}..`:"..",f=2)}else L.length>0?L+=`${l}${n.slice(d+1,D)}`:L=n.slice(d+1,D),f=D-d-1;d=D,s=0}else a===z&&s!==-1?++s:s=-1}return L}function ne(n,i){ie(i,"pathObject");const l=i.dir||i.root,m=i.base||`${i.name||""}${i.ext||""}`;return l?l===i.root?`${l}${m}`:`${l}${n}${m}`:m}e.$fc={resolve(...n){let i="",l="",m=!1;for(let L=n.length-1;L>=-1;L--){let f;if(L>=0){if(f=n[L],S(f,"path"),f.length===0)continue}else i.length===0?f=h.cwd():(f=h.env[`=${i}`]||h.cwd(),(f===void 0||f.slice(0,2).toLowerCase()!==i.toLowerCase()&&f.charCodeAt(2)===P)&&(f=`${i}\\`));const d=f.length;let s=0,a="",D=!1;const I=f.charCodeAt(0);if(d===1)g(I)&&(s=1,D=!0);else if(g(I))if(D=!0,g(f.charCodeAt(1))){let u=2,B=u;for(;u<d&&!g(f.charCodeAt(u));)u++;if(u<d&&u!==B){const G=f.slice(B,u);for(B=u;u<d&&g(f.charCodeAt(u));)u++;if(u<d&&u!==B){for(B=u;u<d&&!g(f.charCodeAt(u));)u++;(u===d||u!==B)&&(a=`\\\\${G}\\${f.slice(B,u)}`,s=u)}}}else s=1;else M(I)&&f.charCodeAt(1)===X&&(a=f.slice(0,2),s=2,d>2&&g(f.charCodeAt(2))&&(D=!0,s=3));if(a.length>0)if(i.length>0){if(a.toLowerCase()!==i.toLowerCase())continue}else i=a;if(m){if(i.length>0)break}else if(l=`${f.slice(s)}\\${l}`,m=D,D&&i.length>0)break}return l=q(l,!m,"\\",g),m?`${i}\\${l}`:`${i}${l}`||"."},normalize(n){S(n,"path");const i=n.length;if(i===0)return".";let l=0,m,L=!1;const f=n.charCodeAt(0);if(i===1)return y(f)?"\\":n;if(g(f))if(L=!0,g(n.charCodeAt(1))){let s=2,a=s;for(;s<i&&!g(n.charCodeAt(s));)s++;if(s<i&&s!==a){const D=n.slice(a,s);for(a=s;s<i&&g(n.charCodeAt(s));)s++;if(s<i&&s!==a){for(a=s;s<i&&!g(n.charCodeAt(s));)s++;if(s===i)return`\\\\${D}\\${n.slice(a)}\\`;s!==a&&(m=`\\\\${D}\\${n.slice(a,s)}`,l=s)}}}else l=1;else M(f)&&n.charCodeAt(1)===X&&(m=n.slice(0,2),l=2,i>2&&g(n.charCodeAt(2))&&(L=!0,l=3));let d=l<i?q(n.slice(l),!L,"\\",g):"";return d.length===0&&!L&&(d="."),d.length>0&&g(n.charCodeAt(i-1))&&(d+="\\"),m===void 0?L?`\\${d}`:d:L?`${m}\\${d}`:`${m}${d}`},isAbsolute(n){S(n,"path");const i=n.length;if(i===0)return!1;const l=n.charCodeAt(0);return g(l)||i>2&&M(l)&&n.charCodeAt(1)===X&&g(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let i,l;for(let f=0;f<n.length;++f){const d=n[f];S(d,"path"),d.length>0&&(i===void 0?i=l=d:i+=`\\${d}`)}if(i===void 0)return".";let m=!0,L=0;if(typeof l=="string"&&g(l.charCodeAt(0))){++L;const f=l.length;f>1&&g(l.charCodeAt(1))&&(++L,f>2&&(g(l.charCodeAt(2))?++L:m=!1))}if(m){for(;L<i.length&&g(i.charCodeAt(L));)L++;L>=2&&(i=`\\${i.slice(L)}`)}return e.$fc.normalize(i)},relative(n,i){if(S(n,"from"),S(i,"to"),n===i)return"";const l=e.$fc.resolve(n),m=e.$fc.resolve(i);if(l===m||(n=l.toLowerCase(),i=m.toLowerCase(),n===i))return"";let L=0;for(;L<n.length&&n.charCodeAt(L)===P;)L++;let f=n.length;for(;f-1>L&&n.charCodeAt(f-1)===P;)f--;const d=f-L;let s=0;for(;s<i.length&&i.charCodeAt(s)===P;)s++;let a=i.length;for(;a-1>s&&i.charCodeAt(a-1)===P;)a--;const D=a-s,I=d<D?d:D;let u=-1,B=0;for(;B<I;B++){const V=n.charCodeAt(L+B);if(V!==i.charCodeAt(s+B))break;V===P&&(u=B)}if(B!==I){if(u===-1)return m}else{if(D>I){if(i.charCodeAt(s+B)===P)return m.slice(s+B+1);if(B===2)return m.slice(s+B)}d>I&&(n.charCodeAt(L+B)===P?u=B:B===2&&(u=3)),u===-1&&(u=0)}let G="";for(B=L+u+1;B<=f;++B)(B===f||n.charCodeAt(B)===P)&&(G+=G.length===0?"..":"\\..");return s+=u,G.length>0?`${G}${m.slice(s,a)}`:(m.charCodeAt(s)===P&&++s,m.slice(s,a))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const i=e.$fc.resolve(n);if(i.length<=2)return n;if(i.charCodeAt(0)===P){if(i.charCodeAt(1)===P){const l=i.charCodeAt(2);if(l!==te&&l!==z)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(M(i.charCodeAt(0))&&i.charCodeAt(1)===X&&i.charCodeAt(2)===P)return`\\\\?\\${i}`;return n},dirname(n){S(n,"path");const i=n.length;if(i===0)return".";let l=-1,m=0;const L=n.charCodeAt(0);if(i===1)return g(L)?n:".";if(g(L)){if(l=m=1,g(n.charCodeAt(1))){let s=2,a=s;for(;s<i&&!g(n.charCodeAt(s));)s++;if(s<i&&s!==a){for(a=s;s<i&&g(n.charCodeAt(s));)s++;if(s<i&&s!==a){for(a=s;s<i&&!g(n.charCodeAt(s));)s++;if(s===i)return n;s!==a&&(l=m=s+1)}}}}else M(L)&&n.charCodeAt(1)===X&&(l=i>2&&g(n.charCodeAt(2))?3:2,m=l);let f=-1,d=!0;for(let s=i-1;s>=m;--s)if(g(n.charCodeAt(s))){if(!d){f=s;break}}else d=!1;if(f===-1){if(l===-1)return".";f=l}return n.slice(0,f)},basename(n,i){i!==void 0&&S(i,"ext"),S(n,"path");let l=0,m=-1,L=!0,f;if(n.length>=2&&M(n.charCodeAt(0))&&n.charCodeAt(1)===X&&(l=2),i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let d=i.length-1,s=-1;for(f=n.length-1;f>=l;--f){const a=n.charCodeAt(f);if(g(a)){if(!L){l=f+1;break}}else s===-1&&(L=!1,s=f+1),d>=0&&(a===i.charCodeAt(d)?--d===-1&&(m=f):(d=-1,m=s))}return l===m?m=s:m===-1&&(m=n.length),n.slice(l,m)}for(f=n.length-1;f>=l;--f)if(g(n.charCodeAt(f))){if(!L){l=f+1;break}}else m===-1&&(L=!1,m=f+1);return m===-1?"":n.slice(l,m)},extname(n){S(n,"path");let i=0,l=-1,m=0,L=-1,f=!0,d=0;n.length>=2&&n.charCodeAt(1)===X&&M(n.charCodeAt(0))&&(i=m=2);for(let s=n.length-1;s>=i;--s){const a=n.charCodeAt(s);if(g(a)){if(!f){m=s+1;break}continue}L===-1&&(f=!1,L=s+1),a===z?l===-1?l=s:d!==1&&(d=1):l!==-1&&(d=-1)}return l===-1||L===-1||d===0||d===1&&l===L-1&&l===m+1?"":n.slice(l,L)},format:ne.bind(null,"\\"),parse(n){S(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const l=n.length;let m=0,L=n.charCodeAt(0);if(l===1)return g(L)?(i.root=i.dir=n,i):(i.base=i.name=n,i);if(g(L)){if(m=1,g(n.charCodeAt(1))){let u=2,B=u;for(;u<l&&!g(n.charCodeAt(u));)u++;if(u<l&&u!==B){for(B=u;u<l&&g(n.charCodeAt(u));)u++;if(u<l&&u!==B){for(B=u;u<l&&!g(n.charCodeAt(u));)u++;u===l?m=u:u!==B&&(m=u+1)}}}}else if(M(L)&&n.charCodeAt(1)===X){if(l<=2)return i.root=i.dir=n,i;if(m=2,g(n.charCodeAt(2))){if(l===3)return i.root=i.dir=n,i;m=3}}m>0&&(i.root=n.slice(0,m));let f=-1,d=m,s=-1,a=!0,D=n.length-1,I=0;for(;D>=m;--D){if(L=n.charCodeAt(D),g(L)){if(!a){d=D+1;break}continue}s===-1&&(a=!1,s=D+1),L===z?f===-1?f=D:I!==1&&(I=1):f!==-1&&(I=-1)}return s!==-1&&(f===-1||I===0||I===1&&f===s-1&&f===d+1?i.base=i.name=n.slice(d,s):(i.name=n.slice(d,f),i.base=n.slice(d,s),i.ext=n.slice(f,s))),d>0&&d!==m?i.dir=n.slice(0,d-1):i.dir=i.root,i},sep:"\\",delimiter:";",win32:null,posix:null};const _=(()=>{if(c){const n=/\\/g;return()=>{const i=h.cwd().replace(n,"/");return i.slice(i.indexOf("/"))}}return()=>h.cwd()})();e.$gc={resolve(...n){let i="",l=!1;for(let m=n.length-1;m>=-1&&!l;m--){const L=m>=0?n[m]:_();S(L,"path"),L.length!==0&&(i=`${L}/${i}`,l=L.charCodeAt(0)===F)}return i=q(i,!l,"/",y),l?`/${i}`:i.length>0?i:"."},normalize(n){if(S(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===F,l=n.charCodeAt(n.length-1)===F;return n=q(n,!i,"/",y),n.length===0?i?"/":l?"./":".":(l&&(n+="/"),i?`/${n}`:n)},isAbsolute(n){return S(n,"path"),n.length>0&&n.charCodeAt(0)===F},join(...n){if(n.length===0)return".";let i;for(let l=0;l<n.length;++l){const m=n[l];S(m,"path"),m.length>0&&(i===void 0?i=m:i+=`/${m}`)}return i===void 0?".":e.$gc.normalize(i)},relative(n,i){if(S(n,"from"),S(i,"to"),n===i||(n=e.$gc.resolve(n),i=e.$gc.resolve(i),n===i))return"";const l=1,m=n.length,L=m-l,f=1,d=i.length-f,s=L<d?L:d;let a=-1,D=0;for(;D<s;D++){const u=n.charCodeAt(l+D);if(u!==i.charCodeAt(f+D))break;u===F&&(a=D)}if(D===s)if(d>s){if(i.charCodeAt(f+D)===F)return i.slice(f+D+1);if(D===0)return i.slice(f+D)}else L>s&&(n.charCodeAt(l+D)===F?a=D:D===0&&(a=0));let I="";for(D=l+a+1;D<=m;++D)(D===m||n.charCodeAt(D)===F)&&(I+=I.length===0?"..":"/..");return`${I}${i.slice(f+a)}`},toNamespacedPath(n){return n},dirname(n){if(S(n,"path"),n.length===0)return".";const i=n.charCodeAt(0)===F;let l=-1,m=!0;for(let L=n.length-1;L>=1;--L)if(n.charCodeAt(L)===F){if(!m){l=L;break}}else m=!1;return l===-1?i?"/":".":i&&l===1?"//":n.slice(0,l)},basename(n,i){i!==void 0&&S(i,"ext"),S(n,"path");let l=0,m=-1,L=!0,f;if(i!==void 0&&i.length>0&&i.length<=n.length){if(i===n)return"";let d=i.length-1,s=-1;for(f=n.length-1;f>=0;--f){const a=n.charCodeAt(f);if(a===F){if(!L){l=f+1;break}}else s===-1&&(L=!1,s=f+1),d>=0&&(a===i.charCodeAt(d)?--d===-1&&(m=f):(d=-1,m=s))}return l===m?m=s:m===-1&&(m=n.length),n.slice(l,m)}for(f=n.length-1;f>=0;--f)if(n.charCodeAt(f)===F){if(!L){l=f+1;break}}else m===-1&&(L=!1,m=f+1);return m===-1?"":n.slice(l,m)},extname(n){S(n,"path");let i=-1,l=0,m=-1,L=!0,f=0;for(let d=n.length-1;d>=0;--d){const s=n.charCodeAt(d);if(s===F){if(!L){l=d+1;break}continue}m===-1&&(L=!1,m=d+1),s===z?i===-1?i=d:f!==1&&(f=1):i!==-1&&(f=-1)}return i===-1||m===-1||f===0||f===1&&i===m-1&&i===l+1?"":n.slice(i,m)},format:ne.bind(null,"/"),parse(n){S(n,"path");const i={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return i;const l=n.charCodeAt(0)===F;let m;l?(i.root="/",m=1):m=0;let L=-1,f=0,d=-1,s=!0,a=n.length-1,D=0;for(;a>=m;--a){const I=n.charCodeAt(a);if(I===F){if(!s){f=a+1;break}continue}d===-1&&(s=!1,d=a+1),I===z?L===-1?L=a:D!==1&&(D=1):L!==-1&&(D=-1)}if(d!==-1){const I=f===0&&l?1:f;L===-1||D===0||D===1&&L===d-1&&L===f+1?i.base=i.name=n.slice(I,d):(i.name=n.slice(I,L),i.base=n.slice(I,d),i.ext=n.slice(L,d))}return f>0?i.dir=n.slice(0,f-1):l&&(i.dir="/"),i},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define($e[27],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const h=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(p){return new t(p)}constructor(p){this.c=h&&p===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=t}),define($e[15],Ee([0,1,5,10,13,24,27]),function(ae,e,h,t,A,p,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=ie;const z=!1,F=!1,P=!1;var X;(function(V){V.None=()=>A.$Uc.None;function T(x){if(P){const{onDidAddListener:C}=x,le=c.create();let re=0;x.onDidAddListener=()=>{++re===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),C?.()}}}function Q(x,C){return Re(x,()=>{},0,void 0,!0,void 0,C)}V.defer=Q;function O(x){return(C,le=null,re)=>{let fe=!1,he;return he=x(Ae=>{if(!fe)return he?he.dispose():fe=!0,C.call(le,Ae)},null,re),fe&&he.dispose(),he}}V.once=O;function v(x,C,le){return be((re,fe=null,he)=>x(Ae=>re.call(fe,C(Ae)),null,he),le)}V.map=v;function H(x,C,le){return be((re,fe=null,he)=>x(Ae=>{C(Ae),re.call(fe,Ae)},null,he),le)}V.forEach=H;function K(x,C,le){return be((re,fe=null,he)=>x(Ae=>C(Ae)&&re.call(fe,Ae),null,he),le)}V.filter=K;function Z(x){return x}V.signal=Z;function J(...x){return(C,le=null,re)=>{const fe=(0,A.$Rc)(...x.map(he=>he(Ae=>C.call(le,Ae))));return ve(fe,re)}}V.any=J;function se(x,C,le,re){let fe=le;return v(x,he=>(fe=C(fe,he),fe),re)}V.reduce=se;function be(x,C){let le;const re={onWillAddFirstListener(){le=x(fe.fire,fe)},onDidRemoveLastListener(){le?.dispose()}};C||T(re);const fe=new i(re);return C?.add(fe),fe.event}function ve(x,C){return C instanceof Array?C.push(x):C&&C.add(x),x}function Re(x,C,le=100,re=!1,fe=!1,he,Ae){let Le,Ie,Ne,Be=0,Me;const _e={leakWarningThreshold:he,onWillAddFirstListener(){Le=x(We=>{Be++,Ie=C(Ie,We),re&&!Ne&&(Oe.fire(Ie),Ie=void 0),Me=()=>{const Ge=Ie;Ie=void 0,Ne=void 0,(!re||Be>1)&&Oe.fire(Ge),Be=0},typeof le=="number"?(clearTimeout(Ne),Ne=setTimeout(Me,le)):Ne===void 0&&(Ne=0,queueMicrotask(Me))})},onWillRemoveListener(){fe&&Be>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,Le.dispose()}};Ae||T(_e);const Oe=new i(_e);return Ae?.add(Oe),Oe.event}V.debounce=Re;function Te(x,C=0,le){return V.debounce(x,(re,fe)=>re?(re.push(fe),re):[fe],C,void 0,!0,void 0,le)}V.accumulate=Te;function ue(x,C=(re,fe)=>re===fe,le){let re=!0,fe;return K(x,he=>{const Ae=re||!C(he,fe);return re=!1,fe=he,Ae},le)}V.latch=ue;function ye(x,C,le){return[V.filter(x,C,le),V.filter(x,re=>!C(re),le)]}V.split=ye;function de(x,C=!1,le=[],re){let fe=le.slice(),he=x(Ie=>{fe?fe.push(Ie):Le.fire(Ie)});re&&re.add(he);const Ae=()=>{fe?.forEach(Ie=>Le.fire(Ie)),fe=null},Le=new i({onWillAddFirstListener(){he||(he=x(Ie=>Le.fire(Ie)),re&&re.add(he))},onDidAddFirstListener(){fe&&(C?setTimeout(Ae):Ae())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return re&&re.add(Le),Le.event}V.buffer=de;function ge(x,C){return(re,fe,he)=>{const Ae=C(new R);return x(function(Le){const Ie=Ae.evaluate(Le);Ie!==$&&re.call(fe,Ie)},void 0,he)}}V.chain=ge;const $=Symbol("HaltChainable");class R{constructor(){this.f=[]}map(C){return this.f.push(C),this}forEach(C){return this.f.push(le=>(C(le),le)),this}filter(C){return this.f.push(le=>C(le)?le:$),this}reduce(C,le){let re=le;return this.f.push(fe=>(re=C(re,fe),re)),this}latch(C=(le,re)=>le===re){let le=!0,re;return this.f.push(fe=>{const he=le||!C(fe,re);return le=!1,re=fe,he?fe:$}),this}evaluate(C){for(const le of this.f)if(C=le(C),C===$)break;return C}}function U(x,C,le=re=>re){const re=(...Le)=>Ae.fire(le(...Le)),fe=()=>x.on(C,re),he=()=>x.removeListener(C,re),Ae=new i({onWillAddFirstListener:fe,onDidRemoveLastListener:he});return Ae.event}V.fromNodeEventEmitter=U;function b(x,C,le=re=>re){const re=(...Le)=>Ae.fire(le(...Le)),fe=()=>x.addEventListener(C,re),he=()=>x.removeEventListener(C,re),Ae=new i({onWillAddFirstListener:fe,onDidRemoveLastListener:he});return Ae.event}V.fromDOMEventEmitter=b;function r(x){return new Promise(C=>O(x)(C))}V.toPromise=r;function w(x){const C=new i;return x.then(le=>{C.fire(le)},()=>{C.fire(void 0)}).finally(()=>{C.dispose()}),C.event}V.fromPromise=w;function N(x,C,le){return C(le),x(re=>C(re))}V.runAndSubscribe=N;class W{constructor(C,le){this._observable=C,this.f=0,this.g=!1;const re={onWillAddFirstListener:()=>{C.addObserver(this)},onDidRemoveLastListener:()=>{C.removeObserver(this)}};le||T(re),this.emitter=new i(re),le&&le.add(this.emitter)}beginUpdate(C){this.f++}handlePossibleChange(C){}handleChange(C,le){this.g=!0}endUpdate(C){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function oe(x,C){return new W(x,C).emitter.event}V.fromObservable=oe;function we(x){return(C,le,re)=>{let fe=0,he=!1;const Ae={beginUpdate(){fe++},endUpdate(){fe--,fe===0&&(x.reportChanges(),he&&(he=!1,C.call(le)))},handlePossibleChange(){},handleChange(){he=!0}};x.addObserver(Ae),x.reportChanges();const Le={dispose(){x.removeObserver(Ae)}};return re instanceof A.$Tc?re.add(Le):Array.isArray(re)&&re.push(Le),Le}}V.fromObservableLight=we})(X||(e.Event=X={}));class te{constructor(T){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${T}_${te.f++}`,te.all.add(this)}start(T){this.g=new ee.$be,this.listenerCount=T}stop(){if(this.g){const T=this.g.elapsed();this.durations.push(T),this.elapsedOverall+=T,this.invocationCount+=1,this.g=void 0}}}e.$de=te,te.all=new Set,te.f=0;let j=-1;function ie(V){const T=j;return j=V,{dispose(){j=T}}}class S{constructor(T,Q,O=Math.random().toString(18).slice(2,5)){this.h=T,this.threshold=Q,this.name=O,this.g=0}dispose(){this.f?.clear()}check(T,Q){const O=this.threshold;if(O<=0||Q<O)return;this.f||(this.f=new Map);const v=this.f.get(T.value)||0;if(this.f.set(T.value,v+1),this.g-=1,this.g<=0){this.g=O*.5;const[H,K]=this.getMostFrequentStack(),Z=`[${this.name}] potential listener LEAK detected, having ${Q} listeners already. MOST frequent listener (${K}):`;console.warn(Z),console.warn(H);const J=new g(Z,H);this.h(J)}return()=>{const H=this.f.get(T.value)||0;this.f.set(T.value,H-1)}}getMostFrequentStack(){if(!this.f)return;let T,Q=0;for(const[O,v]of this.f)(!T||Q<v)&&(T=[O,v],Q=v);return T}}class c{static create(){const T=new Error;return new c(T.stack??"")}constructor(T){this.value=T}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class g extends Error{constructor(T,Q){super(T),this.name="ListenerLeakError",this.stack=Q}}e.$fe=g;class y extends Error{constructor(T,Q){super(T),this.name="ListenerRefusalError",this.stack=Q}}e.$ge=y;let M=0;class q{constructor(T){this.value=T,this.id=M++}}const ne=2,_=(V,T)=>{if(V instanceof q)T(V);else for(let Q=0;Q<V.length;Q++){const O=V[Q];O&&T(O)}},n=z?new FinalizationRegistry(V=>{typeof V=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(V))}):void 0;class i{constructor(T){this.w=0,this.f=T,this.g=j>0||this.f?.leakWarningThreshold?new S(T?.onListenerError??h.$1,this.f?.leakWarningThreshold??j):void 0,this.j=this.f?._profName?new te(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(F){const T=this.t;queueMicrotask(()=>{_(T,Q=>Q.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(T,Q,O)=>{if(this.g&&this.w>this.g.threshold**2){const J=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(J);const se=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],be=new y(`${J}. HINT: Stack shows most frequent listener (${se[1]}-times)`,se[0]);return(this.f?.onListenerError||h.$1)(be),A.$Uc.None}if(this.m)return A.$Uc.None;Q&&(T=T.bind(Q));const v=new q(T);let H,K;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(v.stack=c.create(),H=this.g.check(v.stack,this.w+1)),F&&(v.stack=K??c.create()),this.t?this.t instanceof q?(this.u??(this.u=new m),this.t=[this.t,v]):this.t.push(v):(this.f?.onWillAddFirstListener?.(this),this.t=v,this.f?.onDidAddFirstListener?.(this)),this.w++;const Z=(0,A.$Sc)(()=>{n?.unregister(Z),H?.(),this.x(v)});if(O instanceof A.$Tc?O.add(Z):Array.isArray(O)&&O.push(Z),n){const J=new Error().stack.split(`
`).slice(2).join(`
`).trim();n.register(Z,J,Z)}return Z}),this.q}x(T){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const Q=this.t,O=Q.indexOf(T);if(O===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,Q[O]=void 0;const v=this.u.current===this;if(this.w*ne<=Q.length){let H=0;for(let K=0;K<Q.length;K++)Q[K]?Q[H++]=Q[K]:v&&(this.u.end--,H<this.u.i&&this.u.i--);Q.length=H}}y(T,Q){if(!T)return;const O=this.f?.onListenerError||h.$1;if(!O){T.value(Q);return}try{T.value(Q)}catch(v){O(v)}}z(T){const Q=T.current.t;for(;T.i<T.end;)this.y(Q[T.i++],T.value);T.reset()}fire(T){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof q)this.y(this.t,T);else{const Q=this.u;Q.enqueue(this,T,this.t.length),this.z(Q)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=i;const l=()=>new m;e.$ie=l;class m{constructor(){this.i=-1,this.end=0}enqueue(T,Q,O){this.i=0,this.end=O,this.current=T,this.value=Q}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class L extends i{async fireAsync(T,Q,O){if(this.t)for(this.h||(this.h=new p.$5c),_(this.t,v=>this.h.push([v.value,T]));this.h.size>0&&!Q.isCancellationRequested;){const[v,H]=this.h.shift(),K=[],Z={...H,token:Q,waitUntil:J=>{if(Object.isFrozen(K))throw new Error("waitUntil can NOT be called asynchronous");O&&(J=O(J,v)),K.push(J)}};try{v(Z)}catch(J){(0,h.$1)(J);continue}Object.freeze(K),await Promise.allSettled(K).then(J=>{for(const se of J)se.status==="rejected"&&(0,h.$1)(se.reason)})}}}e.$je=L;class f extends i{get isPaused(){return this.h!==0}constructor(T){super(T),this.h=0,this.s=new p.$5c,this.A=T?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const T=Array.from(this.s);this.s.clear(),super.fire(this.A(T))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(T){this.w&&(this.h!==0?this.s.push(T):super.fire(T))}}e.$ke=f;class d extends f{constructor(T){super(T),this.k=T.delay??100}fire(T){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(T)}}e.$le=d;class s extends i{constructor(T){super(T),this.h=[],this.k=T?.merge}fire(T){this.hasListeners()&&(this.h.push(T),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Q=>super.fire(Q)),this.h=[]}))}}e.$me=s;class a{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(T){const Q={event:T,listener:null};this.h.push(Q),this.g&&this.m(Q);const O=()=>{this.g&&this.o(Q);const v=this.h.indexOf(Q);this.h.splice(v,1)};return(0,A.$Sc)((0,t.$db)(O))}j(){this.g=!0,this.h.forEach(T=>this.m(T))}k(){this.g=!1,this.h.forEach(T=>this.o(T))}m(T){T.listener=T.event(Q=>this.f.fire(Q))}o(T){T.listener?.dispose(),T.listener=null}dispose(){this.f.dispose();for(const T of this.h)T.listener?.dispose();this.h=[]}}e.$ne=a;class D{constructor(T,Q,O,v){this.f=new A.$Tc;const H=this.f.add(new a),K=this.f.add(new A.$4c);function Z(J){K.set(J,H.add(v(J)))}for(const J of T)Z(J);this.f.add(Q(J=>{Z(J)})),this.f.add(O(J=>{K.deleteAndDispose(J)})),this.event=H.event}dispose(){this.f.dispose()}}e.$oe=D;class I{constructor(){this.f=[]}wrapEvent(T,Q,O){return(v,H,K)=>T(Z=>{const J=this.f[this.f.length-1];if(!Q){J?J.buffers.push(()=>v.call(H,Z)):v.call(H,Z);return}const se=J;if(!se){v.call(H,Q(O,Z));return}se.items??(se.items=[]),se.items.push(Z),se.buffers.length===0&&J.buffers.push(()=>{se.reducedResult??(se.reducedResult=O?se.items.reduce(Q,O):se.items.reduce(Q)),v.call(H,se.reducedResult)})},void 0,K)}bufferEvents(T){const Q={buffers:new Array};this.f.push(Q);const O=T();return this.f.pop(),Q.buffers.forEach(v=>v()),O}}e.$pe=I;class u{constructor(){this.f=!1,this.g=X.None,this.h=A.$Uc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(T){this.g=T,this.f&&(this.h.dispose(),this.h=T(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=u;class B{static const(T){return new G(T)}constructor(T){this.g=T,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(T){T!==this.g&&(this.g=T,this.f.fire(void 0))}}e.$re=B;class G{constructor(T){this.value=T,this.onDidChange=X.None}}}),define($e[16],Ee([0,1,15]),function(ae,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=z;const t=Object.freeze(function(F,P){const X=setTimeout(F.bind(P),0);return{dispose(){clearTimeout(X)}}});var A;(function(F){function P(X){return X===F.None||X===F.Cancelled||X instanceof p?!0:!X||typeof X!="object"?!1:typeof X.isCancellationRequested=="boolean"&&typeof X.onCancellationRequested=="function"}F.isCancellationToken=P,F.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:h.Event.None}),F.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(A||(e.CancellationToken=A={}));class p{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new h.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class ee{constructor(P){this.f=void 0,this.g=void 0,this.g=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new p),this.f}cancel(){this.f?this.f instanceof p&&this.f.cancel():this.f=A.Cancelled}dispose(P=!1){P&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof p&&this.f.dispose():this.f=A.None}}e.$se=ee;function z(F){const P=new ee;return F.add({dispose(){P.cancel()}}),P.token}}),define($e[28],Ee([0,1,16]),function(ae,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=A;class t{constructor(F){this.b=F,this.a=null}get(){if(this.a)return this.a;const F=new h.$se,P=this.b(F.token);return this.a={promise:P,dispose:()=>{this.a=null,F.cancel(),F.dispose()}},this.a}}e.$5e=t;function A(z){return z}class p{constructor(F,P){this.a=void 0,this.b=void 0,typeof F=="function"?(this.c=F,this.d=A):(this.c=P,this.d=F.getCacheKey)}get(F){const P=this.d(F);return this.b!==P&&(this.b=P,this.a=this.c(F)),this.a}}e.$7e=p;class ee{get cachedValues(){return this.a}constructor(F,P){this.a=new Map,this.b=new Map,typeof F=="function"?(this.c=F,this.d=A):(this.c=P,this.d=F.getCacheKey)}get(F){const P=this.d(F);if(this.b.has(P))return this.b.get(P);const X=this.c(F);return this.a.set(F,X),this.b.set(P,X),X}}e.$8e=ee}),define($e[29],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define($e[30],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=h,e.$bg=t,e.$cg=A,e.$dg=p,e.$eg=ee,e.$fg=z,e.$gg=F,e.$hg=P,e.$ig=X,e.$jg=te,e.$kg=j,e.$lg=ie,e.$mg=S,e.$ng=g,e.$og=y,e.$pg=M,e.$qg=q,e.$rg=ne;function h(_){return typeof _=="string"}function t(_){return Array.isArray(_)&&_.every(n=>h(n))}function A(_){return typeof _=="object"&&_!==null&&!Array.isArray(_)&&!(_ instanceof RegExp)&&!(_ instanceof Date)}function p(_){const n=Object.getPrototypeOf(Uint8Array);return typeof _=="object"&&_ instanceof n}function ee(_){return typeof _=="number"&&!isNaN(_)}function z(_){return!!_&&typeof _[Symbol.iterator]=="function"}function F(_){return _===!0||_===!1}function P(_){return typeof _>"u"}function X(_){return!te(_)}function te(_){return P(_)||_===null}function j(_,n){if(!_)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}function ie(_){if(te(_))throw new Error("Assertion Failed: argument is undefined or null");return _}function S(..._){const n=[];for(let i=0;i<_.length;i++){const l=_[i];if(te(l))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);n.push(l)}return n}const c=Object.prototype.hasOwnProperty;function g(_){if(!A(_))return!1;for(const n in _)if(c.call(_,n))return!1;return!0}function y(_){return typeof _=="function"}function M(..._){return _.length>0&&_.every(y)}function q(_,n){const i=Math.min(_.length,n.length);for(let l=0;l<i;l++)ne(_[l],n[l])}function ne(_,n){if(h(n)){if(typeof _!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(y(n)){try{if(_ instanceof n)return}catch{}if(!te(_)&&_.constructor===n||n.length===1&&n.call(void 0,_)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define($e[31],Ee([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=t,e.$0e=A;var h;(function(p){p[p.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",p[p.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",p[p.MAX_UINT_8=255]="MAX_UINT_8",p[p.MAX_UINT_16=65535]="MAX_UINT_16",p[p.MAX_UINT_32=4294967295]="MAX_UINT_32",p[p.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(h||(e.Constants=h={}));function t(p){return p<0?0:p>h.MAX_UINT_8?h.MAX_UINT_8:p|0}function A(p){return p<0?0:p>h.MAX_UINT_32?h.MAX_UINT_32:p|0}}),define($e[7],Ee([0,1,28,4,11,31]),function(ae,e,h,t,A,p){"use strict";var ee;Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=z,e.$_e=P,e.$af=te,e.$bf=j,e.$cf=ie,e.$df=S,e.$ef=c,e.$ff=g,e.$gf=y,e.$hf=M,e.$if=q,e.$jf=ne,e.$kf=_,e.$lf=n,e.$mf=i,e.$nf=l,e.$of=m,e.$pf=L,e.$qf=f,e.$rf=d,e.$sf=s,e.$tf=a,e.$uf=D,e.$vf=I,e.$wf=u,e.$xf=B,e.$yf=G,e.$zf=V,e.$Af=T,e.$Bf=Q,e.$Cf=O,e.$Df=v,e.$Ef=H,e.$Ff=K,e.$Gf=Z,e.$Hf=J,e.$If=se,e.$Lf=Te,e.$Mf=ue,e.$Nf=ye,e.$Of=de,e.$Pf=R,e.$Qf=b,e.$Sf=r,e.$Tf=w,e.$Uf=N,e.$Vf=W,e.$Wf=we,e.$Xf=x,e.$Yf=le,e.$1f=re,e.$2f=fe,e.$3f=he,e.$4f=Ae,e.$5f=Le,e.$6f=Ie,e.$7f=Ne,e.$8f=Be,e.$9f=Ge;function z(o){return!o||typeof o!="string"?!0:o.trim().length===0}const F=/{(\d+)}/g;function P(o,...E){return E.length===0?o:o.replace(F,function(k,Y){const ce=parseInt(Y,10);return isNaN(ce)||ce<0||ce>=E.length?k:E[ce]})}const X=/{([^}]+)}/g;function te(o,E){return Object.keys(E).length===0?o:o.replace(X,(k,Y)=>E[Y]??k)}function j(o){return o.replace(/[<>"'&]/g,E=>{switch(E){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return E})}function ie(o){return o.replace(/[<>&]/g,function(E){switch(E){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return E}})}function S(o){return o.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(o,E){let k=0,Y=o.indexOf(E);for(;Y!==-1;)k++,Y=o.indexOf(E,Y+E.length);return k}function g(o,E,k="\u2026"){return o.length<=E?o:`${o.substr(0,E)}${k}`}function y(o,E,k="\u2026"){if(o.length<=E)return o;const Y=Math.ceil(E/2)-k.length/2,ce=Math.floor(E/2)-k.length/2;return`${o.substr(0,Y)}${k}${o.substr(o.length-ce)}`}function M(o,E=" "){const k=q(o,E);return ne(k,E)}function q(o,E){if(!o||!E)return o;const k=E.length;if(k===0||o.length===0)return o;let Y=0;for(;o.indexOf(E,Y)===Y;)Y=Y+k;return o.substring(Y)}function ne(o,E){if(!o||!E)return o;const k=E.length,Y=o.length;if(k===0||Y===0)return o;let ce=Y,me=-1;for(;me=o.lastIndexOf(E,ce-1),!(me===-1||me+k!==ce);){if(me===0)return"";ce=me}return o.substring(0,ce)}function _(o){return o.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function n(o){return o.replace(/\*/g,"")}function i(o,E,k={}){if(!o)throw new Error("Cannot create regex from empty string");E||(o=S(o)),k.wholeWord&&(/\B/.test(o.charAt(0))||(o="\\b"+o),/\B/.test(o.charAt(o.length-1))||(o=o+"\\b"));let Y="";return k.global&&(Y+="g"),k.matchCase||(Y+="i"),k.multiline&&(Y+="m"),k.unicode&&(Y+="u"),new RegExp(o,Y)}function l(o){return o.source==="^"||o.source==="^$"||o.source==="$"||o.source==="^\\s*$"?!1:!!(o.exec("")&&o.lastIndex===0)}function m(o){return o.split(/\r\n|\r|\n/)}function L(o){const E=[],k=o.split(/(\r\n|\r|\n)/);for(let Y=0;Y<Math.ceil(k.length/2);Y++)E.push(k[2*Y]+(k[2*Y+1]??""));return E}function f(o){for(let E=0,k=o.length;E<k;E++){const Y=o.charCodeAt(E);if(Y!==t.CharCode.Space&&Y!==t.CharCode.Tab)return E}return-1}function d(o,E=0,k=o.length){for(let Y=E;Y<k;Y++){const ce=o.charCodeAt(Y);if(ce!==t.CharCode.Space&&ce!==t.CharCode.Tab)return o.substring(E,Y)}return o.substring(E,k)}function s(o,E=o.length-1){for(let k=E;k>=0;k--){const Y=o.charCodeAt(k);if(Y!==t.CharCode.Space&&Y!==t.CharCode.Tab)return k}return-1}function a(o,E,k){const Y=[];let ce=0;for(const me of o.matchAll(E)){if(Y.push(o.slice(ce,me.index)),me.index===void 0)throw new Error("match.index should be defined");ce=me.index+me[0].length,Y.push(k(me[0],...me.slice(1),me.index,o,me.groups))}return Y.push(o.slice(ce)),Promise.all(Y).then(me=>me.join(""))}function D(o,E){return o<E?-1:o>E?1:0}function I(o,E,k=0,Y=o.length,ce=0,me=E.length){for(;k<Y&&ce<me;k++,ce++){const Se=o.charCodeAt(k),Ue=E.charCodeAt(ce);if(Se<Ue)return-1;if(Se>Ue)return 1}const pe=Y-k,Fe=me-ce;return pe<Fe?-1:pe>Fe?1:0}function u(o,E){return B(o,E,0,o.length,0,E.length)}function B(o,E,k=0,Y=o.length,ce=0,me=E.length){for(;k<Y&&ce<me;k++,ce++){let Se=o.charCodeAt(k),Ue=E.charCodeAt(ce);if(Se===Ue)continue;if(Se>=128||Ue>=128)return I(o.toLowerCase(),E.toLowerCase(),k,Y,ce,me);V(Se)&&(Se-=32),V(Ue)&&(Ue-=32);const De=Se-Ue;if(De!==0)return De}const pe=Y-k,Fe=me-ce;return pe<Fe?-1:pe>Fe?1:0}function G(o){return o>=t.CharCode.Digit0&&o<=t.CharCode.Digit9}function V(o){return o>=t.CharCode.a&&o<=t.CharCode.z}function T(o){return o>=t.CharCode.A&&o<=t.CharCode.Z}function Q(o,E){return o.length===E.length&&B(o,E)===0}function O(o,E){const k=E.length;return E.length>o.length?!1:B(o,E,0,k)===0}function v(o,E){const k=Math.min(o.length,E.length);let Y;for(Y=0;Y<k;Y++)if(o.charCodeAt(Y)!==E.charCodeAt(Y))return Y;return k}function H(o,E){const k=Math.min(o.length,E.length);let Y;const ce=o.length-1,me=E.length-1;for(Y=0;Y<k;Y++)if(o.charCodeAt(ce-Y)!==E.charCodeAt(me-Y))return Y;return k}function K(o){return 55296<=o&&o<=56319}function Z(o){return 56320<=o&&o<=57343}function J(o,E){return(o-55296<<10)+(E-56320)+65536}function se(o,E,k){const Y=o.charCodeAt(k);if(K(Y)&&k+1<E){const ce=o.charCodeAt(k+1);if(Z(ce))return J(Y,ce)}return Y}function be(o,E){const k=o.charCodeAt(E-1);if(Z(k)&&E>1){const Y=o.charCodeAt(E-2);if(K(Y))return J(Y,k)}return k}class ve{get offset(){return this.e}constructor(E,k=0){this.c=E,this.d=E.length,this.e=k}setOffset(E){this.e=E}prevCodePoint(){const E=be(this.c,this.e);return this.e-=E>=p.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,E}nextCodePoint(){const E=se(this.c,this.d,this.e);return this.e+=E>=p.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,E}eol(){return this.e>=this.d}}e.$Jf=ve;class Re{get offset(){return this.c.offset}constructor(E,k=0){this.c=new ve(E,k)}nextGraphemeLength(){const E=Oe.getInstance(),k=this.c,Y=k.offset;let ce=E.getGraphemeBreakType(k.nextCodePoint());for(;!k.eol();){const me=k.offset,pe=E.getGraphemeBreakType(k.nextCodePoint());if(Me(ce,pe)){k.setOffset(me);break}ce=pe}return k.offset-Y}prevGraphemeLength(){const E=Oe.getInstance(),k=this.c,Y=k.offset;let ce=E.getGraphemeBreakType(k.prevCodePoint());for(;k.offset>0;){const me=k.offset,pe=E.getGraphemeBreakType(k.prevCodePoint());if(Me(pe,ce)){k.setOffset(me);break}ce=pe}return Y-k.offset}eol(){return this.c.eol()}}e.$Kf=Re;function Te(o,E){return new Re(o,E).nextGraphemeLength()}function ue(o,E){return new Re(o,E).prevGraphemeLength()}function ye(o,E){E>0&&Z(o.charCodeAt(E))&&E--;const k=E+Te(o,E);return[k-ue(o,k),k]}function de(o){const E=new Re(o);let k=0;for(;!E.eol();)k++,E.nextGraphemeLength();return k}let ge;function $(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function R(o){return ge||(ge=$()),ge.test(o)}const U=/^[\t\n\r\x20-\x7E]*$/;function b(o){return U.test(o)}e.$Rf=/[\u2028\u2029]/;function r(o){return e.$Rf.test(o)}function w(o){return o>=11904&&o<=55215||o>=63744&&o<=64255||o>=65281&&o<=65374}function N(o){return o>=127462&&o<=127487||o===8986||o===8987||o===9200||o===9203||o>=9728&&o<=10175||o===11088||o===11093||o>=127744&&o<=128591||o>=128640&&o<=128764||o>=128992&&o<=129008||o>=129280&&o<=129535||o>=129648&&o<=129782}function W(o,E,k=""){const Y=o.trimStart();if(Y.length<E)return Y;const ce=/\b/g;let me=0;for(;ce.test(Y)&&!(Y.length-ce.lastIndex<E);)me=ce.lastIndex,ce.lastIndex+=1;return me===0?Y:k+Y.substring(me).trimStart()}const oe=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*we(o){let E=0;for(const k of o.matchAll(oe))E!==k.index&&(yield{isCode:!1,str:o.substring(E,k.index)}),yield{isCode:!0,str:k[0]},E=k.index+k[0].length;E!==o.length&&(yield{isCode:!1,str:o.substring(E)})}function x(o){return o&&(o=o.replace(oe,"")),o}const C=/\\\[.*?\\\]/g;function le(o){return x(o).replace(C,"")}e.$Zf=String.fromCharCode(t.CharCode.UTF8_BOM);function re(o){return!!(o&&o.length>0&&o.charCodeAt(0)===t.CharCode.UTF8_BOM)}function fe(o){return re(o)?o.substr(1):o}function he(o,E){if(!o||!E||o.length<E.length)return!1;const k=E.length,Y=o.toLowerCase();let ce=0,me=-1;for(;ce<k;){const pe=Y.indexOf(E[ce],me+1);if(pe<0)return!1;me=pe,ce++}return!0}function Ae(o,E=!1){return o?(E&&(o=o.replace(/\\./g,"")),o.toLowerCase()!==o):!1}function Le(o){return o.charAt(0).toUpperCase()+o.slice(1)}function Ie(o,E=1){if(E===0)return"";let k=-1;do k=o.indexOf(`
`,k+1),E--;while(E>0&&k>=0);return k===-1?o:(o[k-1]==="\r"&&k--,o.substr(0,k))}function Ne(o){const E=t.CharCode.Z-t.CharCode.A+1;return o=o%(2*E),o<E?String.fromCharCode(t.CharCode.a+o):String.fromCharCode(t.CharCode.A+o-E)}function Be(o){return Oe.getInstance().getGraphemeBreakType(o)}function Me(o,E){return o===_e.Other?E!==_e.Extend&&E!==_e.SpacingMark:o===_e.CR&&E===_e.LF?!1:o===_e.Control||o===_e.CR||o===_e.LF||E===_e.Control||E===_e.CR||E===_e.LF?!0:!(o===_e.L&&(E===_e.L||E===_e.V||E===_e.LV||E===_e.LVT)||(o===_e.LV||o===_e.V)&&(E===_e.V||E===_e.T)||(o===_e.LVT||o===_e.T)&&E===_e.T||E===_e.Extend||E===_e.ZWJ||E===_e.SpacingMark||o===_e.Prepend||o===_e.ZWJ&&E===_e.Extended_Pictographic||o===_e.Regional_Indicator&&E===_e.Regional_Indicator)}var _e;(function(o){o[o.Other=0]="Other",o[o.Prepend=1]="Prepend",o[o.CR=2]="CR",o[o.LF=3]="LF",o[o.Control=4]="Control",o[o.Extend=5]="Extend",o[o.Regional_Indicator=6]="Regional_Indicator",o[o.SpacingMark=7]="SpacingMark",o[o.L=8]="L",o[o.V=9]="V",o[o.T=10]="T",o[o.LV=11]="LV",o[o.LVT=12]="LVT",o[o.ZWJ=13]="ZWJ",o[o.Extended_Pictographic=14]="Extended_Pictographic"})(_e||(e.GraphemeBreakType=_e={}));class Oe{static getInstance(){return Oe.c||(Oe.c=new Oe),Oe.c}constructor(){this.d=We()}getGraphemeBreakType(E){if(E<32)return E===t.CharCode.LineFeed?_e.LF:E===t.CharCode.CarriageReturn?_e.CR:_e.Control;if(E<127)return _e.Other;const k=this.d,Y=k.length/3;let ce=1;for(;ce<=Y;)if(E<k[3*ce])ce=2*ce;else if(E>k[3*ce+1])ce=2*ce+1;else return k[3*ce+2];return _e.Other}}Oe.c=null;function We(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(o,E){if(o===0)return 0;const k=Ve(o,E);if(k!==void 0)return k;const Y=new ve(E,o);return Y.prevCodePoint(),Y.offset}function Ve(o,E){const k=new ve(E,o);let Y=k.prevCodePoint();for(;Ke(Y)||Y===je.emojiVariantSelector||Y===je.enclosingKeyCap;){if(k.offset===0)return;Y=k.prevCodePoint()}if(!N(Y))return;let ce=k.offset;return ce>0&&k.prevCodePoint()===je.zwj&&(ce=k.offset),ce}function Ke(o){return 127995<=o&&o<=127999}var je;(function(o){o[o.zwj=8205]="zwj",o[o.emojiVariantSelector=65039]="emojiVariantSelector",o[o.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.$0f="\xA0";class qe{static getInstance(E){return ee.d.get(Array.from(E))}static getLocales(){return ee.e.value}constructor(E){this.f=E}isAmbiguous(E){return this.f.has(E)}containsAmbiguousCharacter(E){for(let k=0;k<E.length;k++){const Y=E.codePointAt(k);if(typeof Y=="number"&&this.isAmbiguous(Y))return!0}return!1}getPrimaryConfusable(E){return this.f.get(E)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=qe,ee=qe,qe.c=new A.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.d=new h.$7e({getCacheKey:JSON.stringify},o=>{function E(Ue){const De=new Map;for(let Pe=0;Pe<Ue.length;Pe+=2)De.set(Ue[Pe],Ue[Pe+1]);return De}function k(Ue,De){const Pe=new Map(Ue);for(const[ze,He]of De)Pe.set(ze,He);return Pe}function Y(Ue,De){if(!Ue)return De;const Pe=new Map;for(const[ze,He]of Ue)De.has(ze)&&Pe.set(ze,He);return Pe}const ce=ee.c.value;let me=o.filter(Ue=>!Ue.startsWith("_")&&Ue in ce);me.length===0&&(me=["_default"]);let pe;for(const Ue of me){const De=E(ce[Ue]);pe=Y(pe,De)}const Fe=E(ce._common),Se=k(Fe,pe);return new ee(Se)}),qe.e=new A.$V(()=>Object.keys(ee.c.value).filter(o=>!o.startsWith("_")));class ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ke.c())),this.d}static isInvisibleCharacter(E){return ke.e().has(E)}static containsInvisibleCharacter(E){for(let k=0;k<E.length;k++){const Y=E.codePointAt(k);if(typeof Y=="number"&&ke.isInvisibleCharacter(Y))return!0}return!1}static get codePoints(){return ke.e()}}e.$_f=ke,ke.d=void 0}),define($e[6],Ee([0,1,4,3,2,7,30]),function(ae,e,h,t,A,p,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=z,e.$tg=F,e.$ug=P,e.$vg=X,e.$wg=te,e.$xg=c,e.$yg=g,e.$zg=y,e.$Ag=M,e.$Bg=q,e.$Cg=ne,e.$Dg=_,e.$Eg=n,e.$Fg=i,e.$Gg=l,e.$Hg=m,e.$Ig=d;function z(s){return s===h.CharCode.Slash||s===h.CharCode.Backslash}function F(s){return s.replace(/[\\/]/g,t.$gc.sep)}function P(s){return s.indexOf("/")===-1&&(s=F(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}function X(s,a=t.$gc.sep){if(!s)return"";const D=s.length,I=s.charCodeAt(0);if(z(I)){if(z(s.charCodeAt(1))&&!z(s.charCodeAt(2))){let B=3;const G=B;for(;B<D&&!z(s.charCodeAt(B));B++);if(G!==B&&!z(s.charCodeAt(B+1))){for(B+=1;B<D;B++)if(z(s.charCodeAt(B)))return s.slice(0,B+1).replace(/[\\/]/g,a)}}return a}else if(M(I)&&s.charCodeAt(1)===h.CharCode.Colon)return z(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let u=s.indexOf("://");if(u!==-1){for(u+=3;u<D;u++)if(z(s.charCodeAt(u)))return s.slice(0,u+1)}return""}function te(s){if(!A.$c||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==h.CharCode.Backslash||(a=s.charCodeAt(1),a!==h.CharCode.Backslash))return!1;let D=2;const I=D;for(;D<s.length&&(a=s.charCodeAt(D),a!==h.CharCode.Backslash);D++);return!(I===D||(a=s.charCodeAt(D+1),isNaN(a)||a===h.CharCode.Backslash))}const j=/[\\/:\*\?"<>\|]/g,ie=/[/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,a=A.$c){const D=a?j:ie;return!(!s||s.length===0||/^\s+$/.test(s)||(D.lastIndex=0,D.test(s))||a&&S.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}function g(s,a,D){const I=s===a;return!D||I?I:!s||!a?!1:(0,p.$Bf)(s,a)}function y(s,a,D,I=t.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(D){if(!(0,p.$Cf)(s,a))return!1;if(a.length===s.length)return!0;let B=a.length;return a.charAt(a.length-1)===I&&B--,s.charAt(B)===I}return a.charAt(a.length-1)!==I&&(a+=I),s.indexOf(a)===0}function M(s){return s>=h.CharCode.A&&s<=h.CharCode.Z||s>=h.CharCode.a&&s<=h.CharCode.z}function q(s,a){return A.$c&&s.endsWith(":")&&(s+=t.sep),(0,t.$ic)(s)||(s=(0,t.$jc)(a,s)),s=(0,t.$hc)(s),ne(s)}function ne(s){return A.$c?(s=(0,p.$jf)(s,t.sep),s.endsWith(":")&&(s+=t.sep)):(s=(0,p.$jf)(s,t.sep),s||(s=t.sep)),s}function _(s){const a=(0,t.$hc)(s);return A.$c?s.length>3?!1:n(a)&&(s.length===2||a.charCodeAt(2)===h.CharCode.Backslash):a===t.$gc.sep}function n(s,a=A.$c){return a?M(s.charCodeAt(0))&&s.charCodeAt(1)===h.CharCode.Colon:!1}function i(s,a=A.$c){return n(s,a)?s[0]:void 0}function l(s,a,D){return a.length>s.length?-1:s===a?0:(D&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}function m(s){const a=s.split(":");let D,I,u;for(const B of a){const G=Number(B);(0,ee.$eg)(G)?I===void 0?I=G:u===void 0&&(u=G):D=D?[D,B].join(":"):B}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:I!==void 0?I:void 0,column:u!==void 0?u:I!==void 0?1:void 0}}const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",f="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function d(s,a,D=8){let I="";for(let B=0;B<D;B++){let G;B===0&&A.$c&&!a&&(D===3||D===4)?G=f:G=L,I+=G.charAt(Math.floor(Math.random()*G.length))}let u;return a?u=`${a}-${I}`:u=I,s?(0,t.$jc)(s,u):u}}),define($e[8],Ee([0,1,4,25,3,2]),function(ae,e,h,t,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=g,e.$wc=n;const ee=/^\w[\w\d+.-]*$/,z=/^\//,F=/^\/\//;function P(f,d){if(!f.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${f.authority}", path: "${f.path}", query: "${f.query}", fragment: "${f.fragment}"}`);if(f.scheme&&!ee.test(f.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(f.path){if(f.authority){if(!z.test(f.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(F.test(f.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function X(f,d){return!f&&!d?"file":f}function te(f,d){switch(f){case"https":case"http":case"file":d?d[0]!==ie&&(d=ie+d):d=ie;break}return d}const j="",ie="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class c{static isUri(d){return d instanceof c?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}constructor(d,s,a,D,I,u=!1){typeof d=="object"?(this.scheme=d.scheme||j,this.authority=d.authority||j,this.path=d.path||j,this.query=d.query||j,this.fragment=d.fragment||j):(this.scheme=X(d,u),this.authority=s||j,this.path=te(this.scheme,a||j),this.query=D||j,this.fragment=I||j,P(this,u))}get fsPath(){return n(this,!1)}with(d){if(!d)return this;let{scheme:s,authority:a,path:D,query:I,fragment:u}=d;return s===void 0?s=this.scheme:s===null&&(s=j),a===void 0?a=this.authority:a===null&&(a=j),D===void 0?D=this.path:D===null&&(D=j),I===void 0?I=this.query:I===null&&(I=j),u===void 0?u=this.fragment:u===null&&(u=j),s===this.scheme&&a===this.authority&&D===this.path&&I===this.query&&u===this.fragment?this:new M(s,a,D,I,u)}static parse(d,s=!1){const a=S.exec(d);return a?new M(a[2]||j,L(a[4]||j),L(a[5]||j),L(a[7]||j),L(a[9]||j),s):new M(j,j,j,j,j)}static file(d){let s=j;if(p.$c&&(d=d.replace(/\\/g,ie)),d[0]===ie&&d[1]===ie){const a=d.indexOf(ie,2);a===-1?(s=d.substring(2),d=ie):(s=d.substring(2,a),d=d.substring(a)||ie)}return new M("file",s,d,j,j)}static from(d,s){return new M(d.scheme,d.authority,d.path,d.query,d.fragment,s)}static joinPath(d,...s){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return p.$c&&d.scheme==="file"?a=c.file(A.$fc.join(n(d,!0),...s)).path:a=A.$gc.join(d.path,...s),d.with({path:a})}toString(d=!1){return i(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof c)return d;{const s=new M(d);return s._formatted=d.external??null,s._fsPath=d._sep===y?d.fsPath??null:null,s}}else return d}}e.URI=c;function g(f){return!f||typeof f!="object"?!1:typeof f.scheme=="string"&&(typeof f.authority=="string"||typeof f.authority>"u")&&(typeof f.path=="string"||typeof f.path>"u")&&(typeof f.query=="string"||typeof f.query>"u")&&(typeof f.fragment=="string"||typeof f.fragment>"u")}const y=p.$c?1:void 0;class M extends c{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(d=!1){return d?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const d={$mid:t.MarshalledId.Uri};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=y),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const q={[h.CharCode.Colon]:"%3A",[h.CharCode.Slash]:"%2F",[h.CharCode.QuestionMark]:"%3F",[h.CharCode.Hash]:"%23",[h.CharCode.OpenSquareBracket]:"%5B",[h.CharCode.CloseSquareBracket]:"%5D",[h.CharCode.AtSign]:"%40",[h.CharCode.ExclamationMark]:"%21",[h.CharCode.DollarSign]:"%24",[h.CharCode.Ampersand]:"%26",[h.CharCode.SingleQuote]:"%27",[h.CharCode.OpenParen]:"%28",[h.CharCode.CloseParen]:"%29",[h.CharCode.Asterisk]:"%2A",[h.CharCode.Plus]:"%2B",[h.CharCode.Comma]:"%2C",[h.CharCode.Semicolon]:"%3B",[h.CharCode.Equals]:"%3D",[h.CharCode.Space]:"%20"};function ne(f,d,s){let a,D=-1;for(let I=0;I<f.length;I++){const u=f.charCodeAt(I);if(u>=h.CharCode.a&&u<=h.CharCode.z||u>=h.CharCode.A&&u<=h.CharCode.Z||u>=h.CharCode.Digit0&&u<=h.CharCode.Digit9||u===h.CharCode.Dash||u===h.CharCode.Period||u===h.CharCode.Underline||u===h.CharCode.Tilde||d&&u===h.CharCode.Slash||s&&u===h.CharCode.OpenSquareBracket||s&&u===h.CharCode.CloseSquareBracket||s&&u===h.CharCode.Colon)D!==-1&&(a+=encodeURIComponent(f.substring(D,I)),D=-1),a!==void 0&&(a+=f.charAt(I));else{a===void 0&&(a=f.substr(0,I));const B=q[u];B!==void 0?(D!==-1&&(a+=encodeURIComponent(f.substring(D,I)),D=-1),a+=B):D===-1&&(D=I)}}return D!==-1&&(a+=encodeURIComponent(f.substring(D))),a!==void 0?a:f}function _(f){let d;for(let s=0;s<f.length;s++){const a=f.charCodeAt(s);a===h.CharCode.Hash||a===h.CharCode.QuestionMark?(d===void 0&&(d=f.substr(0,s)),d+=q[a]):d!==void 0&&(d+=f[s])}return d!==void 0?d:f}function n(f,d){let s;return f.authority&&f.path.length>1&&f.scheme==="file"?s=`//${f.authority}${f.path}`:f.path.charCodeAt(0)===h.CharCode.Slash&&(f.path.charCodeAt(1)>=h.CharCode.A&&f.path.charCodeAt(1)<=h.CharCode.Z||f.path.charCodeAt(1)>=h.CharCode.a&&f.path.charCodeAt(1)<=h.CharCode.z)&&f.path.charCodeAt(2)===h.CharCode.Colon?d?s=f.path.substr(1):s=f.path[1].toLowerCase()+f.path.substr(2):s=f.path,p.$c&&(s=s.replace(/\//g,"\\")),s}function i(f,d){const s=d?_:ne;let a="",{scheme:D,authority:I,path:u,query:B,fragment:G}=f;if(D&&(a+=D,a+=":"),(I||D==="file")&&(a+=ie,a+=ie),I){let V=I.indexOf("@");if(V!==-1){const T=I.substr(0,V);I=I.substr(V+1),V=T.lastIndexOf(":"),V===-1?a+=s(T,!1,!1):(a+=s(T.substr(0,V),!1,!1),a+=":",a+=s(T.substr(V+1),!1,!0)),a+="@"}I=I.toLowerCase(),V=I.lastIndexOf(":"),V===-1?a+=s(I,!1,!0):(a+=s(I.substr(0,V),!1,!0),a+=I.substr(V))}if(u){if(u.length>=3&&u.charCodeAt(0)===h.CharCode.Slash&&u.charCodeAt(2)===h.CharCode.Colon){const V=u.charCodeAt(1);V>=h.CharCode.A&&V<=h.CharCode.Z&&(u=`/${String.fromCharCode(V+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===h.CharCode.Colon){const V=u.charCodeAt(0);V>=h.CharCode.A&&V<=h.CharCode.Z&&(u=`${String.fromCharCode(V+32)}:${u.substr(2)}`)}a+=s(u,!0,!1)}return B&&(a+="?",a+=s(B,!1,!1)),G&&(a+="#",a+=d?G:ne(G,!1,!1)),a}function l(f){try{return decodeURIComponent(f)}catch{return f.length>3?f.substr(0,3)+l(f.substr(3)):f}}const m=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(f){return f.match(m)?f.replace(m,d=>l(d)):f}}),define($e[32],Ee([0,1,5,2,7,8,3]),function(ae,e,h,t,A,p,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=F,e.$Kg=P,e.$Og=te;var z;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.vscodeManagedRemoteResource="vscode-managed-remote-resource",S.vscodeUserData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeInteractiveInput="vscode-interactive-input",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.vscodeChatCodeBlock="vscode-chat-code-block",S.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",S.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",S.vscodeChatSesssion="vscode-chat-editor",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp",S.vsls="vsls",S.vscodeSourceControl="vscode-scm",S.commentsInput="comment",S.codeSetting="code-setting"})(z||(e.Schemas=z={}));function F(S,c){return p.URI.isUri(S)?(0,A.$Bf)(S.scheme,c):(0,A.$Cf)(S,c+":")}function P(S,...c){return c.some(g=>F(S,g))}e.$Lg="vscode-tkn",e.$Mg="tkn";class X{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c,g){this.f=te(c,g)}getServerRootPath(){return this.f}get g(){return ee.$gc.join(this.f,z.vscodeRemoteResource)}set(c,g,y){this.a[c]=g,this.b[c]=y}setConnectionToken(c,g){this.c[c]=g}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(_){return h.$1(_),c}const g=c.authority;let y=this.a[g];y&&y.indexOf(":")!==-1&&y.indexOf("[")===-1&&(y=`[${y}]`);const M=this.b[g],q=this.c[g];let ne=`path=${encodeURIComponent(c.path)}`;return typeof q=="string"&&(ne+=`&${e.$Mg}=${encodeURIComponent(q)}`),p.URI.from({scheme:t.$i?this.d:z.vscodeRemoteResource,authority:`${y}:${M}`,path:t.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:ne})}}e.$Ng=new X;function te(S,c){return ee.$gc.join(c??"/",`${S.quality??"oss"}-${S.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class j{asBrowserUri(c){const g=this.b(c,ae);return this.uriToBrowserUri(g)}uriToBrowserUri(c){return c.scheme===z.vscodeRemote?e.$Ng.rewrite(c):c.scheme===z.file&&(t.$g||t.$k===`${z.vscodeFileResource}://${j.a}`)?c.with({scheme:z.vscodeFileResource,authority:c.authority||j.a,query:null,fragment:null}):c}asFileUri(c){const g=this.b(c,ae);return this.uriToFileUri(g)}uriToFileUri(c){return c.scheme===z.vscodeFileResource?c.with({scheme:z.file,authority:c.authority!==j.a?c.authority:null,query:null,fragment:null}):c}b(c,g){return p.URI.isUri(c)?c:p.URI.parse(g.toUrl(c))}}j.a=e.$Tg,e.$Ug=new j;var ie;(function(S){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);S.CoopAndCoep=Object.freeze(c.get("3"));const g="vscode-coi";function y(q){let ne;typeof q=="string"?ne=new URL(q).searchParams:q instanceof URL?ne=q.searchParams:p.URI.isUri(q)&&(ne=new URL(q.toString(!0)).searchParams);const _=ne?.get(g);if(_)return c.get(_)}S.getHeadersFromQuery=y;function M(q,ne,_){if(!globalThis.crossOriginIsolated)return;const n=ne&&_?"3":_?"2":"1";q instanceof URLSearchParams?q.set(g,n):q[g]=n}S.addSearchParam=M})(ie||(e.COI=ie={}))}),define($e[17],Ee([0,1,4,6,32,3,2,7,8]),function(ae,e,h,t,A,p,ee,z,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=P,e.$kh=te,e.$lh=ie;function P(S){return(0,F.$wc)(S,!0)}class X{constructor(c){this.a=c}compare(c,g,y=!1){return c===g?0:(0,z.$uf)(this.getComparisonKey(c,y),this.getComparisonKey(g,y))}isEqual(c,g,y=!1){return c===g?!0:!c||!g?!1:this.getComparisonKey(c,y)===this.getComparisonKey(g,y)}getComparisonKey(c,g=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,g,y=!1){if(c.scheme===g.scheme){if(c.scheme===A.Schemas.file)return t.$zg(P(c),P(g),this.a(c))&&c.query===g.query&&(y||c.fragment===g.fragment);if((0,e.$gh)(c.authority,g.authority))return t.$zg(c.path,g.path,this.a(c),"/")&&c.query===g.query&&(y||c.fragment===g.fragment)}return!1}joinPath(c,...g){return F.URI.joinPath(c,...g)}basenameOrAuthority(c){return(0,e.$$g)(c)||c.authority}basename(c){return p.$gc.basename(c.path)}extname(c){return p.$gc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let g;return c.scheme===A.Schemas.file?g=F.URI.file(p.$mc(P(c))).path:(g=p.$gc.dirname(c.path),c.authority&&g.length&&g.charCodeAt(0)!==h.CharCode.Slash&&(console.error(`dirname("${c.toString})) resulted in a relative path`),g="/")),c.with({path:g})}normalizePath(c){if(!c.path.length)return c;let g;return c.scheme===A.Schemas.file?g=F.URI.file(p.$hc(P(c))).path:g=p.$gc.normalize(c.path),c.with({path:g})}relativePath(c,g){if(c.scheme!==g.scheme||!(0,e.$gh)(c.authority,g.authority))return;if(c.scheme===A.Schemas.file){const q=p.$lc(P(c),P(g));return ee.$c?t.$tg(q):q}let y=c.path||"/";const M=g.path||"/";if(this.a(c)){let q=0;for(const ne=Math.min(y.length,M.length);q<ne&&!(y.charCodeAt(q)!==M.charCodeAt(q)&&y.charAt(q).toLowerCase()!==M.charAt(q).toLowerCase());q++);y=M.substr(0,q)+y.substr(q)}return p.$gc.relative(y,M)}resolvePath(c,g){if(c.scheme===A.Schemas.file){const y=F.URI.file(p.$kc(P(c),g));return c.with({authority:y.authority,path:y.path})}return g=t.$ug(g),c.with({path:p.$gc.resolve(c.path,g)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,g){return c===g||c!==void 0&&g!==void 0&&(0,z.$Bf)(c,g)}hasTrailingPathSeparator(c,g=p.sep){if(c.scheme===A.Schemas.file){const y=P(c);return y.length>t.$vg(y).length&&y[y.length-1]===g}else{const y=c.path;return y.length>1&&y.charCodeAt(y.length-1)===h.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,g=p.sep){return(0,e.$hh)(c,g)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,g=p.sep){let y=!1;if(c.scheme===A.Schemas.file){const M=P(c);y=M!==void 0&&M.length===t.$vg(M).length&&M[M.length-1]===g}else{g="/";const M=c.path;y=M.length===1&&M.charCodeAt(M.length-1)===h.CharCode.Slash}return!y&&!(0,e.$hh)(c,g)?c.with({path:c.path+"/"}):c}}e.$3g=X,e.$4g=new X(()=>!1),e.$5g=new X(S=>S.scheme===A.Schemas.file?!ee.$e:!0),e.$6g=new X(S=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function te(S,c){const g=[];for(let y=0;y<S.length;y++){const M=c(S[y]);S.some((q,ne)=>ne===y?!1:(0,e.$8g)(M,c(q)))||g.push(S[y])}return g}var j;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function c(g){const y=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(ne=>{const[_,n]=ne.split(":");_&&n&&y.set(_,n)});const q=g.path.substring(0,g.path.indexOf(";"));return q&&y.set(S.META_DATA_MIME,q),y}S.parseMetaData=c})(j||(e.DataUri=j={}));function ie(S,c,g){if(c){let y=S.path;return y&&y[0]!==p.$gc.sep&&(y=p.$gc.sep+y),S.with({scheme:g,authority:c,path:y})}return S.with({scheme:g})}}),define($e[9],Ee([0,1,16,5,15,13,17,2,29,11]),function(ae,e,h,t,A,p,ee,z,F,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=X,e.$nh=te,e.$oh=j,e.$ph=ie,e.$qh=S,e.$rh=c,e.$sh=g,e.$th=y,e.$Bh=f,e.$Ch=d,e.$Dh=s,e.$Eh=a,e.$Fh=D,e.$Uh=J,e.$3h=R;function X(b){return!!b&&typeof b.then=="function"}function te(b){const r=new h.$se,w=b(r.token),N=new Promise((W,oe)=>{const we=r.token.onCancellationRequested(()=>{we.dispose(),oe(new t.$5)});Promise.resolve(w).then(x=>{we.dispose(),r.dispose(),W(x)},x=>{we.dispose(),r.dispose(),oe(x)})});return new class{cancel(){r.cancel(),r.dispose()}then(W,oe){return N.then(W,oe)}catch(W){return this.then(void 0,W)}finally(W){return N.finally(W)}}}function j(b,r,w){return new Promise((N,W)=>{const oe=r.onCancellationRequested(()=>{oe.dispose(),N(w)});b.then(N,W).finally(()=>oe.dispose())})}function ie(b,r){return new Promise((w,N)=>{const W=r.onCancellationRequested(()=>{W.dispose(),N(new t.$5)});b.then(w,N).finally(()=>W.dispose())})}async function S(b){let r=-1;const w=b.map((N,W)=>N.then(oe=>(r=W,oe)));try{return await Promise.race(w)}finally{b.forEach((N,W)=>{W!==r&&N.cancel()})}}function c(b,r,w){let N;const W=setTimeout(()=>{N?.(void 0),w?.()},r);return Promise.race([b.finally(()=>clearTimeout(W)),new Promise(oe=>N=oe)])}function g(b){return new Promise((r,w)=>{const N=b();X(N)?N.then(r,w):r(N)})}function y(){let b,r;return{promise:new Promise((N,W)=>{b=N,r=W}),resolve:b,reject:r}}class M{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(r){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=r,!this.b){const w=()=>{if(this.b=null,this.f)return;const N=this.queue(this.d);return this.d=null,N};this.b=new Promise(N=>{this.a.then(w,w).then(N)})}return new Promise((w,N)=>{this.b.then(w,N)})}return this.a=r(),new Promise((w,N)=>{this.a.then(W=>{this.a=null,w(W)},W=>{this.a=null,N(W)})})}dispose(){this.f=!0}}e.$uh=M;class q{constructor(){this.a=Promise.resolve(null)}queue(r){return this.a=this.a.then(()=>r(),()=>r())}}e.$vh=q;class ne{constructor(){this.a=new Map}queue(r,w){const W=(this.a.get(r)??Promise.resolve()).catch(()=>{}).then(w).finally(()=>{this.a.get(r)===W&&this.a.delete(r)});return this.a.set(r,W),W}}e.$wh=ne;const _=(b,r)=>{let w=!0;const N=setTimeout(()=>{w=!1,r()},b);return{isTriggered:()=>w,dispose:()=>{clearTimeout(N),w=!1}}},n=b=>{let r=!0;return queueMicrotask(()=>{r&&(r=!1,b())}),{isTriggered:()=>r,dispose:()=>{r=!1}}};class i{constructor(r){this.defaultDelay=r,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(r,w=this.defaultDelay){this.g=r,this.h(),this.b||(this.b=new Promise((W,oe)=>{this.d=W,this.f=oe}).then(()=>{if(this.b=null,this.d=null,this.g){const W=this.g;return this.g=null,W()}}));const N=()=>{this.a=null,this.d?.(null)};return this.a=w===F.$ce?n(N):_(w,N),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=i;class l{constructor(r){this.a=new i(r),this.b=new M}trigger(r,w){return this.a.trigger(()=>this.b.queue(r),w)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=l;class m{constructor(){this.a=!1,this.b=new Promise((r,w)=>{this.d=r})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=m;class L extends m{constructor(r){super(),this.f=setTimeout(()=>this.open(),r)}open(){clearTimeout(this.f),super.open()}}e.$Ah=L;function f(b,r){return r?new Promise((w,N)=>{const W=setTimeout(()=>{oe.dispose(),w()},b),oe=r.onCancellationRequested(()=>{clearTimeout(W),oe.dispose(),N(new t.$5)})}):te(w=>f(b,w))}function d(b,r=0,w){const N=setTimeout(()=>{b(),w&&W.dispose()},r),W=(0,p.$Sc)(()=>{clearTimeout(N),w?.deleteAndLeak(W)});return w?.add(W),W}function s(b){const r=[];let w=0;const N=b.length;function W(){return w<N?b[w++]():null}function oe(we){we!=null&&r.push(we);const x=W();return x?x.then(oe):Promise.resolve(r)}return Promise.resolve(null).then(oe)}function a(b,r=N=>!!N,w=null){let N=0;const W=b.length,oe=()=>{if(N>=W)return Promise.resolve(w);const we=b[N++];return Promise.resolve(we()).then(C=>r(C)?Promise.resolve(C):oe())};return oe()}function D(b,r=N=>!!N,w=null){if(b.length===0)return Promise.resolve(w);let N=b.length;const W=()=>{N=-1;for(const oe of b)oe.cancel?.()};return new Promise((oe,we)=>{for(const x of b)x.then(C=>{--N>=0&&r(C)?(W(),oe(C)):N===0&&oe(w)}).catch(C=>{--N>=0&&(W(),we(C))})})}class I{constructor(r){this.a=0,this.b=!1,this.f=r,this.g=[],this.d=0,this.h=new A.$he}whenIdle(){return this.size>0?A.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(r){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((w,N)=>{this.g.push({factory:r,c:w,e:N}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const r=this.g.shift();this.d++;const w=r.factory();w.then(r.c,r.e),w.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=I;class u extends I{constructor(){super(1)}}e.$Hh=u;class B{constructor(){this.a=new se,this.b=0}queue(r){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,r())):this.a.run(this.b++,r())}}e.$Ih=B;class G{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const r=new Re;return this.b.add(r),r.p}g(){for(const[,r]of this.a)if(r.size>0)return!1;return!0}queueSize(r,w=ee.$4g){const N=w.getComparisonKey(r);return this.a.get(N)?.size??0}queueFor(r,w,N=ee.$4g){const W=N.getComparisonKey(r);let oe=this.a.get(W);if(!oe){oe=new u;const we=this.f++,x=A.Event.once(oe.onDrained)(()=>{oe?.dispose(),this.a.delete(W),this.h(),this.d?.deleteAndDispose(we),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new p.$4c),this.d.set(we,x),this.a.set(W,oe)}return oe.queue(w)}h(){this.g()&&this.j()}j(){for(const r of this.b)r.complete();this.b.clear()}dispose(){for(const[,r]of this.a)r.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=G;class V{constructor(r,w){this.b=!1,this.a=-1,typeof r=="function"&&typeof w=="number"&&this.setIfNotSet(r,w)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(r,w){if(this.b)throw new t.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,r()},w)}setIfNotSet(r,w){if(this.b)throw new t.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,r()},w))}}e.$Kh=V;class T{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(r,w,N=globalThis){if(this.f)throw new t.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const W=N.setInterval(()=>{r()},w);this.d=(0,p.$Sc)(()=>{N.clearInterval(W),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=T;class Q{constructor(r,w){this.b=-1,this.a=r,this.d=w,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(r=this.d){this.cancel(),this.b=setTimeout(this.f,r)}get delay(){return this.d}set delay(r){this.d=r}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=Q;class O{constructor(r,w){w%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${w}ms is not a multiple of 1000ms.`),this.a=r,this.b=w,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(r=this.b){r%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${r}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(r/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=O;class v extends Q{constructor(r,w){super(r,w),this.j=[]}work(r){this.j.push(r),this.isScheduled()||this.schedule()}h(){const r=this.j;this.j=[],this.a?.(r)}dispose(){this.j=[],super.dispose()}}e.$Oh=v;class H extends p.$Uc{constructor(r,w){super(),this.g=r,this.h=w,this.a=[],this.b=this.B(new p.$Vc),this.f=!1}get pending(){return this.a.length}work(r){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+r.length>this.g.maxBufferedWork)return!1}else if(this.pending+r.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const w of r)this.a.push(w);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=H,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(b,r)=>{(0,z.$v)(()=>{if(w)return;const N=Date.now()+15;r(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,N-Date.now())}}))});let w=!1;return{dispose(){w||(w=!0)}}}:e.$Rh=(b,r,w)=>{const N=b.requestIdleCallback(r,typeof w=="number"?{timeout:w}:void 0);let W=!1;return{dispose(){W||(W=!0,b.cancelIdleCallback(N))}}},e.$Qh=b=>(0,e.$Rh)(globalThis,b)}();class K{constructor(r,w){this.g=!1,this.d=()=>{try{this.j=w()}catch(N){this.l=N}finally{this.g=!0}},this.f=(0,e.$Rh)(r,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=K;class Z extends K{constructor(r){super(globalThis,r)}}e.$Th=Z;async function J(b,r,w){let N;for(let W=0;W<w;W++)try{return await b()}catch(oe){N=oe,await f(r)}throw N}class se{isRunning(r){return typeof r=="number"?this.a?.taskId===r:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(r,w,N){return this.a={taskId:r,cancel:()=>N?.(),promise:w},w.then(()=>this.d(r),()=>this.d(r)),w}d(r){this.a&&r===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const r=this.b;this.b=void 0,r.run().then(r.promiseResolve,r.promiseReject)}}queue(r){if(this.b)this.b.run=r;else{const{promise:w,resolve:N,reject:W}=y();this.b={run:r,promise:w,promiseResolve:N,promiseReject:W}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=se;class be{constructor(r,w=()=>Date.now()){this.d=r,this.f=w,this.a=0,this.b=0}increment(){const r=this.f();return r-this.a>this.d&&(this.a=r,this.b=0),this.b++,this.b}}e.$Wh=be;var ve;(function(b){b[b.Resolved=0]="Resolved",b[b.Rejected=1]="Rejected"})(ve||(ve={}));class Re{get isRejected(){return this.d?.outcome===ve.Rejected}get isResolved(){return this.d?.outcome===ve.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===ve.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((r,w)=>{this.a=r,this.b=w})}complete(r){return new Promise(w=>{this.a(r),this.d={outcome:ve.Resolved,value:r},w()})}error(r){return new Promise(w=>{this.b(r),this.d={outcome:ve.Rejected,value:r},w()})}cancel(){return this.error(new t.$5)}}e.$Xh=Re;var Te;(function(b){async function r(N){let W;const oe=await Promise.all(N.map(we=>we.then(x=>x,x=>{W||(W=x)})));if(typeof W<"u")throw W;return oe}b.settled=r;function w(N){return new Promise(async(W,oe)=>{try{await N(W,oe)}catch(we){oe(we)}})}b.withAsyncBody=w})(Te||(e.Promises=Te={}));class ue{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(r){this.a=void 0,this.b=void 0,this.d=!1,this.promise=r.then(w=>(this.a=w,this.d=!0,w),w=>{throw this.b=w,this.d=!0,w})}requireValue(){if(!this.d)throw new t.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=ue;class ye{constructor(r){this.b=r,this.a=new P.$V(()=>new ue(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=ye;var de;(function(b){b[b.Initial=0]="Initial",b[b.DoneOK=1]="DoneOK",b[b.DoneError=2]="DoneError"})(de||(de={}));class ge{static fromArray(r){return new ge(w=>{w.emitMany(r)})}static fromPromise(r){return new ge(async w=>{w.emitMany(await r)})}static fromPromises(r){return new ge(async w=>{await Promise.all(r.map(async N=>w.emitOne(await N)))})}static merge(r){return new ge(async w=>{await Promise.all(r.map(async N=>{for await(const W of N)w.emitOne(W)}))})}constructor(r,w){this.a=de.Initial,this.b=[],this.d=null,this.f=w,this.g=new A.$he,queueMicrotask(async()=>{const N={emitOne:W=>this.h(W),emitMany:W=>this.j(W),reject:W=>this.l(W)};try{await Promise.resolve(r(N)),this.k()}catch(W){this.l(W)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let r=0;return{next:async()=>{do{if(this.a===de.DoneError)throw this.d;if(r<this.b.length)return{done:!1,value:this.b[r++]};if(this.a===de.DoneOK)return{done:!0,value:void 0};await A.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(r,w){return new ge(async N=>{for await(const W of r)N.emitOne(w(W))})}map(r){return ge.map(this,r)}static filter(r,w){return new ge(async N=>{for await(const W of r)w(W)&&N.emitOne(W)})}filter(r){return ge.filter(this,r)}static coalesce(r){return ge.filter(r,w=>!!w)}coalesce(){return ge.coalesce(this)}static async toPromise(r){const w=[];for await(const N of r)w.push(N);return w}toPromise(){return ge.toPromise(this)}h(r){this.a===de.Initial&&(this.b.push(r),this.g.fire())}j(r){this.a===de.Initial&&(this.b=this.b.concat(r),this.g.fire())}k(){this.a===de.Initial&&(this.a=de.DoneOK,this.g.fire())}l(r){this.a===de.Initial&&(this.a=de.DoneError,this.d=r,this.g.fire())}}e.$1h=ge,ge.EMPTY=ge.fromArray([]);class $ extends ge{constructor(r,w){super(w),this.m=r}cancel(){this.m.cancel()}}e.$2h=$;function R(b){const r=new h.$se,w=b(r.token);return new $(r,async N=>{const W=r.token.onCancellationRequested(()=>{W.dispose(),r.dispose(),N.reject(new t.$5)});try{for await(const oe of w){if(r.token.isCancellationRequested)return;N.emitOne(oe)}W.dispose(),r.dispose()}catch(oe){W.dispose(),r.dispose(),N.reject(oe)}})}class U{constructor(r){this.a=new Re,this.b=new ge(W=>{if(w){W.reject(w);return}return N&&W.emitMany(N),this.d=oe=>W.reject(oe),this.f=oe=>W.emitOne(oe),this.a.p},r);let w,N;this.f=W=>{N||(N=[]),N.push(W)},this.d=W=>{w||(w=W)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(r){this.d(r),this.a.complete()}emitOne(r){this.f(r)}}e.$4h=U}),define($e[33],Ee([0,1,18,19,40,9,6,26,3,2,17,8]),function(ae,e,h,t,A,p,ee,z,F,P,X,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=g,e.readdirSync=q,e.whenDeleted=n,e.configureFlushOnWrite=f,e.writeFileSync=s;var j;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(j||(e.RimRafMode=j={}));async function ie(O,v=j.UNLINK,H){if((0,ee.$Dg)(O))throw new Error("rimraf - will refuse to recursively delete root");return v===j.UNLINK?c(O):S(O,H)}async function S(O,v=(0,ee.$Ig)((0,t.tmpdir)())){try{try{await h.promises.rename(O,v)}catch(H){return H.code==="ENOENT"?void 0:c(O)}c(v).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function c(O){return(0,A.promisify)(h.rm)(O,{recursive:!0,force:!0,maxRetries:3})}function g(O){if((0,ee.$Dg)(O))throw new Error("rimraf - will refuse to recursively delete root");h.rmSync(O,{recursive:!0,force:!0,maxRetries:3})}async function y(O,v){return ne(await(v?M(O):(0,A.promisify)(h.readdir)(O)))}async function M(O){try{return await(0,A.promisify)(h.readdir)(O,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const v=[],H=await y(O);for(const K of H){let Z=!1,J=!1,se=!1;try{const be=await e.Promises.lstat((0,F.$jc)(O,K));Z=be.isFile(),J=be.isDirectory(),se=be.isSymbolicLink()}catch(be){console.warn("[node.js fs] unexpected error from lstat after readdir: ",be)}v.push({name:K,isFile:()=>Z,isDirectory:()=>J,isSymbolicLink:()=>se})}return v}function q(O){return ne(h.readdirSync(O))}function ne(O){return O.map(v=>typeof v=="string"?P.$d?(0,z.$hm)(v):v:(v.name=P.$d?(0,z.$hm)(v.name):v.name,v))}async function _(O){const v=await y(O),H=[];for(const K of v)await i.existsDirectory((0,F.$jc)(O,K))&&H.push(K);return H}function n(O,v=1e3){return new Promise(H=>{let K=!1;const Z=setInterval(()=>{K||(K=!0,h.access(O,J=>{K=!1,J&&(clearInterval(Z),H(void 0))}))},v)})}var i;(function(O){async function v(Z){let J;try{if(J=await e.Promises.lstat(Z),!J.isSymbolicLink())return{stat:J}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:J?.isSymbolicLink()?{dangling:!1}:void 0}}catch(se){if(se.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};if(P.$c&&se.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(be){if(be.code==="ENOENT"&&J)return{stat:J,symbolicLink:{dangling:!0}};throw be}throw se}}O.stat=v;async function H(Z){try{const{stat:J,symbolicLink:se}=await O.stat(Z);return J.isFile()&&se?.dangling!==!0}catch{}return!1}O.existsFile=H;async function K(Z){try{const{stat:J,symbolicLink:se}=await O.stat(Z);return J.isDirectory()&&se?.dangling!==!0}catch{}return!1}O.existsDirectory=K})(i||(e.SymlinkSupport=i={}));const l=new p.$Jh;function m(O,v,H){return l.queueFor(te.URI.file(O),()=>{const K=a(H);return new Promise((Z,J)=>d(O,v,K,se=>se?J(se):Z()))},X.$5g)}let L=!0;function f(O){L=O}function d(O,v,H,K){if(!L)return h.writeFile(O,v,{mode:H.mode,flag:H.flag},K);h.open(O,H.flag,H.mode,(Z,J)=>{if(Z)return K(Z);h.writeFile(J,v,se=>{if(se)return h.close(J,()=>K(se));h.fdatasync(J,be=>(be&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",be),f(!1)),h.close(J,ve=>K(ve))))})})}function s(O,v,H){const K=a(H);if(!L)return h.writeFileSync(O,v,{mode:K.mode,flag:K.flag});const Z=h.openSync(O,K.flag,K.mode);try{h.writeFileSync(Z,v);try{h.fdatasyncSync(Z)}catch(J){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",J),f(!1)}}finally{h.closeSync(Z)}}function a(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function D(O,v,H=6e4){if(O!==v)try{P.$c&&typeof H=="number"?await I(O,v,Date.now(),H):await(0,A.promisify)(h.rename)(O,v)}catch(K){if(O.toLowerCase()!==v.toLowerCase()&&K.code==="EXDEV"||O.endsWith("."))await u(O,v,{preserveSymlinks:!1}),await ie(O,j.MOVE);else throw K}}async function I(O,v,H,K,Z=0){try{return await(0,A.promisify)(h.rename)(O,v)}catch(J){if(J.code!=="EACCES"&&J.code!=="EPERM"&&J.code!=="EBUSY")throw J;if(Date.now()-H>=K)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${J}`),J;if(Z===0){let se=!1;try{const{stat:be}=await i.stat(v);be.isFile()||(se=!0)}catch{}if(se)throw J}return await(0,p.$Bh)(Math.min(100,Z*10)),I(O,v,H,K,Z+1)}}async function u(O,v,H){return G(O,v,{root:{source:O,target:v},options:H,handledSourcePaths:new Set})}const B=511;async function G(O,v,H){if(H.handledSourcePaths.has(O))return;H.handledSourcePaths.add(O);const{stat:K,symbolicLink:Z}=await i.stat(O);if(Z){if(H.options.preserveSymlinks)try{return await Q(O,v,H)}catch{}if(Z.dangling)return}return K.isDirectory()?V(O,v,K.mode&B,H):T(O,v,K.mode&B)}async function V(O,v,H,K){await e.Promises.mkdir(v,{recursive:!0,mode:H});const Z=await y(O);for(const J of Z)await G((0,F.$jc)(O,J),(0,F.$jc)(v,J),K)}async function T(O,v,H){await e.Promises.copyFile(O,v),await e.Promises.chmod(v,H)}async function Q(O,v,H){let K=await e.Promises.readlink(O);(0,ee.$zg)(K,H.root.source,!P.$e)&&(K=(0,F.$jc)(H.root.target,K.substr(H.root.source.length+1))),await e.Promises.symlink(K,v)}e.Promises=new class{get access(){return(0,A.promisify)(h.access)}get stat(){return(0,A.promisify)(h.stat)}get lstat(){return(0,A.promisify)(h.lstat)}get utimes(){return(0,A.promisify)(h.utimes)}get read(){return(O,v,H,K,Z)=>new Promise((J,se)=>{h.read(O,v,H,K,Z,(be,ve,Re)=>be?se(be):J({bytesRead:ve,buffer:Re}))})}get readFile(){return(0,A.promisify)(h.readFile)}get write(){return(O,v,H,K,Z)=>new Promise((J,se)=>{h.write(O,v,H,K,Z,(be,ve,Re)=>be?se(be):J({bytesWritten:ve,buffer:Re}))})}get appendFile(){return(0,A.promisify)(h.appendFile)}get fdatasync(){return(0,A.promisify)(h.fdatasync)}get truncate(){return(0,A.promisify)(h.truncate)}get copyFile(){return(0,A.promisify)(h.copyFile)}get open(){return(0,A.promisify)(h.open)}get close(){return(0,A.promisify)(h.close)}get symlink(){return(0,A.promisify)(h.symlink)}get readlink(){return(0,A.promisify)(h.readlink)}get chmod(){return(0,A.promisify)(h.chmod)}get mkdir(){return(0,A.promisify)(h.mkdir)}get unlink(){return(0,A.promisify)(h.unlink)}get rmdir(){return(0,A.promisify)(h.rmdir)}get realpath(){return(0,A.promisify)(h.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return _}get writeFile(){return m}get rm(){return ie}get rename(){return D}get copy(){return u}}}),define($e[34],Ee([0,1,35,2]),function(ae,e,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DW=F;const A={437:"cp437",850:"cp850",852:"cp852",855:"cp855",857:"cp857",860:"cp860",861:"cp861",863:"cp863",865:"cp865",866:"cp866",869:"cp869",936:"cp936",1252:"cp1252"};function p(P){const X=P.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return ee[X]||X}const ee={ibm866:"cp866",big5:"cp950"},z="utf8";async function F(P){let X;const te=process.env.VSCODE_CLI_ENCODING;te?(P&&console.log(`Found VSCODE_CLI_ENCODING variable: ${te}`),X=Promise.resolve(te)):t.$c?X=new Promise(ie=>{P&&console.log('Running "chcp" to detect terminal encoding...'),(0,h.exec)("chcp",(S,c,g)=>{if(c){P&&console.log(`Output from "chcp" command is: ${c}`);const y=Object.keys(A);for(const M of y)if(c.indexOf(M)>=0)return ie(A[M])}return ie(void 0)})}):X=new Promise(ie=>{P&&console.log('Running "locale charmap" to detect terminal encoding...'),(0,h.exec)("locale charmap",(S,c,g)=>ie(c))});const j=await X;return P&&console.log(`Detected raw terminal encoding: ${j}`),!j||j.toLowerCase()==="utf-8"||j.toLowerCase()===z?z:p(j)}}),define($e[36],Ee([41,42]),function(ae,e){return ae.create("vs/platform/environment/node/argv",e)}),define($e[37],Ee([0,1,43,2,36]),function(ae,e,h,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=void 0,e.$zm=z,e.$Am=P,e.$Bm=ie,e.$Cm=S;const p={o:(0,A.localize)(0,null),e:(0,A.localize)(1,null),t:(0,A.localize)(2,null)};e.$xm=["tunnel","serve-web"],e.$ym={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,A.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,A.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,A.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,A.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,A.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,A.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,A.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,A.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,A.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,A.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,A.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,A.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,A.localize)(15,null)},"stdin-to-clipboard":{type:"boolean",cat:"o",alias:"c",description:(0,A.localize)(16,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,A.localize)(17,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,A.localize)(18,null)},"show-versions":{type:"boolean",cat:"e",description:(0,A.localize)(19,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,A.localize)(20,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,A.localize)(21,null)},"pre-release":{type:"boolean",cat:"e",description:(0,A.localize)(22,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,A.localize)(23,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,A.localize)(24,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,A.localize)(25,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,A.localize)(26,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,A.localize)(27,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,A.localize)(28,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,A.localize)(29,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,A.localize)(30,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,A.localize)(31,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,A.localize)(32,null)},sync:{type:"string",cat:"t",description:(0,A.localize)(33,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,A.localize)(34,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,A.localize)(35,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,A.localize)(36,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,A.localize)(37,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,A.localize)(38,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,A.localize)(39,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},"use-gl":{type:"string"},"use-angle":{type:"string"},_:{type:"string[]"}};const ee={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function z(c,g,y=ee){const M=c.find(f=>f.length>0&&f[0]!=="-"),q={},ne=["_"],_=[],n={};let i;for(const f in g){const d=g[f];d.type==="subcommand"?f===M&&(i=d):(d.alias&&(q[f]=d.alias),d.type==="string"||d.type==="string[]"?(ne.push(f),d.deprecates&&ne.push(...d.deprecates)):d.type==="boolean"&&(_.push(f),d.deprecates&&_.push(...d.deprecates)),d.global&&(n[f]=d))}if(i&&M){const f=n;for(const D in i.options)f[D]=i.options[D];const d=c.filter(D=>D!==M),s=y.getSubcommandReporter?y.getSubcommandReporter(M):void 0,a=z(d,f,s);return{[M]:a,_:[]}}const l=h(c,{string:ne,boolean:_,alias:q}),m={},L=l;m._=l._.map(f=>String(f)).filter(f=>f.length>0),delete L._;for(const f in g){const d=g[f];if(d.type==="subcommand")continue;d.alias&&delete L[d.alias];let s=L[f];if(d.deprecates)for(const a of d.deprecates)L.hasOwnProperty(a)&&(s||(s=L[a],s&&y.onDeprecatedOption(a,d.deprecationMessage||(0,A.localize)(40,null,f))),delete L[a]);if(typeof s<"u"){if(d.type==="string[]"){if(Array.isArray(s)||(s=[s]),!d.allowEmptyValue){const a=s.filter(D=>D.length>0);a.length!==s.length&&(y.onEmptyValue(f),s=a.length>0?a:void 0)}}else d.type==="string"&&(Array.isArray(s)?(s=s.pop(),y.onMultipleValues(f,s)):!s&&!d.allowEmptyValue&&(y.onEmptyValue(f),s=void 0));m[f]=s,d.deprecationMessage&&y.onDeprecatedOption(f,d.deprecationMessage)}delete L[f]}for(const f in L)y.onUnknownOption(f);return m}function F(c,g){let y="";return g.args&&(Array.isArray(g.args)?y=` <${g.args.join("> <")}>`:y=` <${g.args}>`),g.alias?`-${g.alias} --${c}${y}`:`--${c}${y}`}function P(c,g){const y=[];for(const M in c){const q=c[M],ne=F(M,q);y.push([ne,q.description])}return X(y,g)}function X(c,g){const M=c.reduce((_,n)=>Math.max(_,n[0].length),12)+2+1;if(g-M<25)return c.reduce((_,n)=>_.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const q=g-M-1,ne=[];for(const _ of c){const n=_[0],i=j(_[1],q),l=te(M-n.length-2);ne.push("  "+n+l+i[0]);for(let m=1;m<i.length;m++)ne.push(te(M)+i[m])}return ne}function te(c){return" ".repeat(c)}function j(c,g){const y=[];for(;c.length;){const M=c.length<g?c.length:c.lastIndexOf(" ",g),q=c.slice(0,M).trim();c=c.slice(M),y.push(q)}return y}function ie(c,g,y,M,q){const ne=process.stdout.isTTY&&process.stdout.columns||80,_=q?.noInputFiles!==!0?`[${(0,A.localize)(41,null)}...]`:"",n=[`${c} ${y}`];n.push(""),n.push(`${(0,A.localize)(42,null)}: ${g} [${(0,A.localize)(43,null)}]${_}`),n.push(""),q?.noPipe!==!0&&(t.$c?n.push((0,A.localize)(44,null,g)):n.push((0,A.localize)(45,null,g)),n.push(""));const i={},l=[];for(const m in M){const L=M[m];if(L.type==="subcommand")L.description&&l.push({command:m,description:L.description});else if(L.description&&L.cat){let f=i[L.cat];f||(i[L.cat]=f={}),f[m]=L}}for(const m in i){const L=m,f=i[L];f&&(n.push(p[L]),n.push(...P(f,ne)),n.push(""))}return l.length&&(n.push((0,A.localize)(46,null)),n.push(...X(l.map(m=>[m.command,m.description]),ne)),n.push("")),n.join(`
`)}function S(c,g){return`${c||(0,A.localize)(47,null)}
${g||(0,A.localize)(48,null)}
${process.arch}`}}),define($e[38],Ee([0,1,19,9,6,33,34]),function(ae,e,h,t,A,p,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dfc=z,e.$Efc=F,e.$Ffc=P,e.$Gfc=X;function z(){try{return!process.stdin.isTTY}catch{}return!1}function F(te){return new Promise(j=>{const ie=()=>j(!0);setTimeout(()=>{process.stdin.removeListener("data",ie),j(!1)},te),process.stdin.once("data",ie)})}function P(){return(0,A.$Ig)((0,h.tmpdir)(),"code-stdin",3)}async function X(te,j,ie){let[S,c]=await Promise.all([(0,ee.$DW)(j),new Promise((M,q)=>{ae(["@vscode/iconv-lite-umd"],M,q)}),p.Promises.appendFile(te,"")]);c.encodingExists(S)||(console.log(`Unsupported terminal encoding: ${S}, falling back to UTF-8.`),S="utf8");const g=new t.$Hh,y=c.getDecoder(S);process.stdin.on("data",M=>{const q=y.write(M);g.queue(()=>p.Promises.appendFile(te,q))}),process.stdin.on("end",()=>{const M=y.end();g.queue(async()=>{try{typeof M=="string"&&await p.Promises.appendFile(te,M)}finally{ie?.()}})})}}),define($e[39],Ee([0,1,18,19,6]),function(ae,e,h,t,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=p;function p(ee){const z=(0,A.$Ig)((0,t.tmpdir)());try{return(0,h.writeFileSync)(z,""),ee&&console.log(`Marker file for --wait created: ${z}`),z}catch(F){ee&&console.error(`Failed to create marker file for --wait: ${F}`);return}}}),define($e[44],Ee([0,1,18,45,35,46,14,3,37,39,38,9]),function(ae,e,h,t,A,p,ee,z,F,P,X,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=q;const j=G=>{switch(G){case"user-data-dir":case"extensions-dir":case"export-default-configuration":case"install-source":case"enable-smoke-test-driver":case"extensions-download-dir":case"builtin-extensions-dir":case"telemetry":return!1;default:return!0}},ie=G=>{switch(G){case"version":case"help":case"folder-uri":case"file-uri":case"add":case"diff":case"merge":case"wait":case"goto":case"reuse-window":case"new-window":case"status":case"install-extension":case"uninstall-extension":case"update-extensions":case"list-extensions":case"force":case"show-versions":case"category":case"verbose":case"remote":case"locate-shell-integration-path":case"stdin-to-clipboard":return!0;default:return!1}},S=process.env.VSCODE_IPC_HOOK_CLI,c=process.env.VSCODE_CLIENT_COMMAND,g=process.env.VSCODE_CLIENT_COMMAND_CWD,y=process.env.VSCODE_CLI_AUTHORITY,M=process.env.VSCODE_STDIN_FILE_PATH;async function q(G,V){if(!S&&!c){console.log("Command is only available in WSL or inside a Visual Studio Code terminal.");return}const T={...F.$ym,gitCredential:{type:"string"},openExternal:{type:"boolean"}},Q=c?j:ie;for(const ue in F.$ym){const ye=ue;Q(ye)||delete T[ye]}S&&(T.openExternal={type:"boolean"});const O={onMultipleValues:(ue,ye)=>{console.error(`Option '${ue}' can only be defined once. Using value ${ye}.`)},onEmptyValue:ue=>{console.error(`Ignoring option '${ue}': Value must not be empty.`)},onUnknownOption:ue=>{console.error(`Ignoring option '${ue}': not supported for ${G.executableName}.`)},onDeprecatedOption:(ue,ye)=>{console.warn(`Option '${ue}' is deprecated: ${ye}`)}},v=(0,F.$zm)(V,T,O),H=y?s:ue=>ue,K=!!v.verbose;if(v.help){console.log((0,F.$Bm)(G.productName,G.executableName,G.version,T));return}if(v.version){console.log((0,F.$Cm)(G.version,G.commit));return}if(v["locate-shell-integration-path"]){let ue;switch(v["locate-shell-integration-path"]){case"bash":ue="shellIntegration-bash.sh";break;case"pwsh":ue="shellIntegration.ps1";break;case"zsh":ue="shellIntegration-rc.zsh";break;case"fish":ue="fish_xdg_data/fish/vendor_conf.d/shellIntegration.fish";break;default:throw new Error("Error using --locate-shell-integration-path: Invalid shell type")}console.log((0,z.$kc)(__dirname,"../..","workbench","contrib","terminal","browser","media",ue));return}if(S&&v.openExternal){n(v._,K);return}let Z=v.remote;(Z==="local"||Z==="false"||Z==="")&&(Z=null);const J=(v["folder-uri"]||[]).map(H);v["folder-uri"]=J;const se=(v["file-uri"]||[]).map(H);v["file-uri"]=se;const be=v._;let ve=!1;for(const ue of be)ue==="-"?ve=!0:d(ue,H,J,se);v._=[];let Re;if(ve&&(0,X.$Dfc)())try{let ue=M;if(!ue){ue=(0,X.$Ffc)();const ye=new te.$Xh;await(0,X.$Gfc)(ue,K,()=>ye.complete()),v.wait||(Re=ye.p)}d(ue,H,J,se),v["skip-add-to-recently-opened"]=!0,console.log(`Reading from stdin via: ${ue}`)}catch(ue){console.log(`Failed to create file to read via stdin: ${ue.toString()}`)}v.extensionDevelopmentPath&&(v.extensionDevelopmentPath=v.extensionDevelopmentPath.map(ue=>H(f(ue).href))),v.extensionTestsPath&&(v.extensionTestsPath=H(f(v.extensionTestsPath).href));const Te=v["crash-reporter-directory"];if(Te!==void 0&&!Te.match(/^([a-zA-Z]:[\\\/])/)){console.log(`The crash reporter directory '${Te}' must be an absolute Windows path (e.g. c:/crashes)`);return}if(c){if(v["install-extension"]!==void 0||v["uninstall-extension"]!==void 0||v["list-extensions"]||v["update-extensions"]){const de=[];v["install-extension"]?.forEach($=>de.push("--install-extension",$)),v["uninstall-extension"]?.forEach($=>de.push("--uninstall-extension",$)),["list-extensions","force","show-versions","category"].forEach($=>{const R=v[$];R!==void 0&&de.push(`--${$}=${R}`)}),v["update-extensions"]&&de.push("--update-extensions"),A.fork((0,z.$jc)(__dirname,"../../../server-main.js"),de,{stdio:"inherit"}).on("error",$=>console.log($));return}const ue=[];for(const de in v){const ge=v[de];if(typeof ge=="boolean")ge&&ue.push("--"+de);else if(Array.isArray(ge))for(const $ of ge)ue.push(`--${de}=${$.toString()}`);else ge&&ue.push(`--${de}=${ge.toString()}`)}Z!==null&&ue.push(`--remote=${Z||y}`);const ye=(0,z.$oc)(c);if(ye===".bat"||ye===".cmd"){const de=g||(0,ee.cwd)();K&&console.log(`Invoking: cmd.exe /C ${c} ${ue.join(" ")} in ${de}`),A.spawn("cmd.exe",["/C",c,...ue],{stdio:"inherit",cwd:de})}else{const de=(0,z.$mc)(c),ge={...process.env,ELECTRON_RUN_AS_NODE:"1"};if(ue.unshift("resources/app/out/cli.js"),K&&console.log(`Invoking: cd "${de}" && ELECTRON_RUN_AS_NODE=1 "${c}" "${ue.join('" "')}"`),ne()){K&&console.log("Using pipes for output.");const $=A.spawn(c,ue,{cwd:de,env:ge,stdio:["inherit","pipe","pipe"]});$.stdout.on("data",R=>process.stdout.write(R)),$.stderr.on("data",R=>process.stderr.write(R))}else A.spawn(c,ue,{cwd:de,env:ge,stdio:"inherit"})}}else{if(v["stdin-to-clipboard"]){if(!(0,X.$Dfc)()){console.error("stdin has a tty.");return}const ge=ae("fs").readFileSync(0).toString();i({type:"clipboard",content:ge},K).catch($=>{console.error("Error when requesting status:",$)});return}if(v.status){i({type:"status"},K).then(ye=>{console.log(ye)}).catch(ye=>{console.error("Error when requesting status:",ye)});return}if(v["install-extension"]!==void 0||v["uninstall-extension"]!==void 0||v["list-extensions"]||v["update-extensions"]){i({type:"extensionManagement",list:v["list-extensions"]?{showVersions:v["show-versions"],category:v.category}:void 0,install:l(v["install-extension"]),uninstall:l(v["uninstall-extension"]),force:v.force},K).then(ye=>{console.log(ye)}).catch(ye=>{console.error("Error when invoking the extension management command:",ye)});return}let ue;if(v.wait){if(!se.length){console.log("At least one file must be provided to wait for.");return}ue=(0,P.$ifc)(K)}i({type:"open",fileURIs:se,folderURIs:J,diffMode:v.diff,mergeMode:v.merge,addMode:v.add,gotoLineMode:v.goto,forceReuseWindow:v["reuse-window"],forceNewWindow:v["new-window"],waitMarkerFilePath:ue,remoteAuthority:Z},K).catch(ye=>{console.error("Error when invoking the open command:",ye)}),ue&&_(ue),Re&&await Re}}function ne(){if(process.env.WSL_DISTRO_NAME)try{return A.execSync("uname -r",{encoding:"utf8"}).includes("-microsoft-")}catch{}return!1}async function _(G){for(;h.existsSync(G);)await new Promise(V=>setTimeout(V,1e3))}function n(G,V){const T=[];for(const Q of G)try{/^(http|https|file):\/\//.test(Q)?T.push(t.parse(Q).href):T.push(f(Q).href)}catch{console.log(`Invalid url: ${Q}`)}T.length&&i({type:"openExternal",uris:T},V).catch(Q=>{console.error("Error when invoking the open external command:",Q)})}function i(G,V){return V&&console.log(JSON.stringify(G,null,"  ")),new Promise((T,Q)=>{const O=JSON.stringify(G);if(!S){console.log("Message "+O),T("");return}const v={socketPath:S,path:"/",method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},H=p.request(v,K=>{if(K.headers["content-type"]!=="application/json"){Q("Error in response: Invalid content type: Expected 'application/json', is: "+K.headers["content-type"]);return}const Z=[];K.setEncoding("utf8"),K.on("data",J=>{Z.push(J)}),K.on("error",J=>m("Error in response.",J)),K.on("end",()=>{const J=Z.join("");try{const se=JSON.parse(J);K.statusCode===200?T(se):Q(se)}catch{Q("Error in response: Unable to parse response as JSON: "+J)}})});H.on("error",K=>m("Error in request.",K)),H.write(O),H.end()})}function l(G){return G?.map(V=>/\.vsix$/i.test(V)?f(V).href:V)}function m(G,V){console.error("Unable to connect to VS Code server: "+G),console.error(V),process.exit(1)}const L=process.env.PWD||(0,ee.cwd)();function f(G){return G=G.trim(),G=(0,z.$kc)(L,G),t.pathToFileURL(G)}function d(G,V,T,Q){const O=f(G),v=V(O.href);try{const H=h.lstatSync(h.realpathSync(G));H.isFile()?Q.push(v):H.isDirectory()?T.push(v):G==="/dev/null"&&Q.push(v)}catch(H){H.code==="ENOENT"?Q.push(v):console.log(`Problem accessing file ${G}. Ignoring file`,H)}}function s(G){return G.replace(/^file:\/\//,"vscode-remote://"+y)}const[,,a,D,I,u,...B]=process.argv;q({productName:a,version:D,commit:I,executableName:u},B).then(null,G=>{console.error(G.message||G.stack||G)})})}).call(this);

//# sourceMappingURL=server.cli.js.map
