"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/path","vs/base/common/errors","vs/base/common/types","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","fs","os","vs/base/common/process","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/charCode","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/iterator","vs/platform/telemetry/common/telemetryUtils","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/base/common/json","vs/base/common/performance","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/marshalling","vs/base/parts/ipc/common/ipc","vs/editor/common/core/range","vs/platform/files/common/watcher","vs/platform/terminal/common/terminal","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stopwatch","vs/base/common/stream","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uriIpc","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/mime","vs/base/common/processes","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/marshallingIds","vs/base/common/themables","vs/base/common/glob","path","net","vs/editor/common/core/position","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/storage/common/storage","vs/server/node/remoteLanguagePacks","vs/server/node/serverConnectionToken","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/assert","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/uint","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/encodedTokenAttributes","vs/platform/environment/node/environmentService","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/terminal/common/remote/terminal","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/collections","vs/base/common/equals","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/ports","vs/base/parts/storage/common/storage","vs/editor/common/core/editOperation","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/config/editorOptions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","cookie","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/chat/common/languageModels","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","vs/server/node/server.main"],De=function(he){for(var e=[],n=0,r=he.length;n<r;n++)e[n]=Se[he[n]];return e};define(Se[105],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.LoaderEventType=e.$T=void 0,e.$T=!1;var n;(function(S){S[S.LoaderAvailable=1]="LoaderAvailable",S[S.BeginLoadingScript=10]="BeginLoadingScript",S[S.EndLoadingScriptOK=11]="EndLoadingScriptOK",S[S.EndLoadingScriptError=12]="EndLoadingScriptError",S[S.BeginInvokeFactory=21]="BeginInvokeFactory",S[S.EndInvokeFactory=22]="EndInvokeFactory",S[S.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",S[S.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",S[S.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",S[S.NodeEndNativeRequire=34]="NodeEndNativeRequire",S[S.CachedDataFound=60]="CachedDataFound",S[S.CachedDataMissed=61]="CachedDataMissed",S[S.CachedDataRejected=62]="CachedDataRejected",S[S.CachedDataCreated=63]="CachedDataCreated"})(n||(e.LoaderEventType=n={}));class r{static get(){const k=new Map,R=new Map,A=new Map,v=new Map;function s(a,f){a.has(f.detail)||a.set(f.detail,-f.timestamp)}function E(a,f){const c=a.get(f.detail);c&&(c>=0||a.set(f.detail,c+f.timestamp))}let y=[];typeof he=="function"&&typeof he.getStats=="function"&&(y=he.getStats().slice(0).sort((a,f)=>a.timestamp-f.timestamp));for(const a of y)switch(a.type){case n.BeginLoadingScript:s(k,a);break;case n.EndLoadingScriptOK:case n.EndLoadingScriptError:E(k,a);break;case n.BeginInvokeFactory:s(R,a);break;case n.EndInvokeFactory:E(R,a);break;case n.NodeBeginNativeRequire:s(A,a);break;case n.NodeEndNativeRequire:E(A,a);break;case n.NodeBeginEvaluatingScript:s(v,a);break;case n.NodeEndEvaluatingScript:E(v,a);break}let $=0;A.forEach(a=>$+=a);function w(a){const f=[];return a.forEach((c,g)=>f.push([g,c])),f}return{amdLoad:w(k),amdInvoke:w(R),nodeRequire:w(A),nodeEval:w(v),nodeRequireTotal:$}}static toMarkdownTable(k,R){let A="";const v=[];return k.forEach((s,E)=>{v[E]=s.length}),R.forEach(s=>{s.forEach((E,y)=>{typeof E>"u"&&(E=s[y]="-");const $=E.toString().length;v[y]=Math.max($,v[y])})}),k.forEach((s,E)=>{A+=`| ${s+" ".repeat(v[E]-s.toString().length)} `}),A+=`|
`,k.forEach((s,E)=>{A+=`| ${"-".repeat(v[E])} `}),A+=`|
`,R.forEach(s=>{s.forEach((E,y)=>{typeof E<"u"&&(A+=`| ${E+" ".repeat(v[y]-E.toString().length)} `)}),A+=`|
`}),A}}e.$U=r}),define(Se[106],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=r,e.$hb=S,e.$ib=k,e.$jb=R,e.$kb=A,e.$lb=v,e.$nb=E,e.$ob=y,e.$pb=$,e.$qb=w,e.$rb=a;function n(f,c){const g=r(f,c);if(g!==-1)return f[g]}function r(f,c,g=f.length-1){for(let p=g;p>=0;p--){const m=f[p];if(c(m))return p}return-1}function S(f,c){const g=k(f,c);return g===-1?void 0:f[g]}function k(f,c,g=0,p=f.length){let m=g,b=p;for(;m<b;){const l=Math.floor((m+b)/2);c(f[l])?m=l+1:b=l}return m-1}function R(f,c){const g=A(f,c);return g===f.length?void 0:f[g]}function A(f,c,g=0,p=f.length){let m=g,b=p;for(;m<b;){const l=Math.floor((m+b)/2);c(f[l])?b=l:m=l+1}return m}function v(f,c,g=0,p=f.length){const m=A(f,c,g,p);return m===f.length?-1:m}class s{constructor(c){this.e=c,this.c=0}findLastMonotonous(c){if(s.assertInvariants){if(this.d){for(const p of this.e)if(this.d(p)&&!c(p))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=c}const g=k(this.e,c,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$mb=s,s.assertInvariants=!1;function E(f,c){if(f.length===0)return;let g=f[0];for(let p=1;p<f.length;p++){const m=f[p];c(m,g)>0&&(g=m)}return g}function y(f,c){if(f.length===0)return;let g=f[0];for(let p=1;p<f.length;p++){const m=f[p];c(m,g)>=0&&(g=m)}return g}function $(f,c){return E(f,(g,p)=>-c(g,p))}function w(f,c){if(f.length===0)return-1;let g=0;for(let p=1;p<f.length;p++){const m=f[p];c(m,f[g])>0&&(g=p)}return g}function a(f,c){for(const g of f){const p=c(g);if(p!==void 0)return p}}}),define(Se[35],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var n;(function(r){r[r.Null=0]="Null",r[r.Backspace=8]="Backspace",r[r.Tab=9]="Tab",r[r.LineFeed=10]="LineFeed",r[r.CarriageReturn=13]="CarriageReturn",r[r.Space=32]="Space",r[r.ExclamationMark=33]="ExclamationMark",r[r.DoubleQuote=34]="DoubleQuote",r[r.Hash=35]="Hash",r[r.DollarSign=36]="DollarSign",r[r.PercentSign=37]="PercentSign",r[r.Ampersand=38]="Ampersand",r[r.SingleQuote=39]="SingleQuote",r[r.OpenParen=40]="OpenParen",r[r.CloseParen=41]="CloseParen",r[r.Asterisk=42]="Asterisk",r[r.Plus=43]="Plus",r[r.Comma=44]="Comma",r[r.Dash=45]="Dash",r[r.Period=46]="Period",r[r.Slash=47]="Slash",r[r.Digit0=48]="Digit0",r[r.Digit1=49]="Digit1",r[r.Digit2=50]="Digit2",r[r.Digit3=51]="Digit3",r[r.Digit4=52]="Digit4",r[r.Digit5=53]="Digit5",r[r.Digit6=54]="Digit6",r[r.Digit7=55]="Digit7",r[r.Digit8=56]="Digit8",r[r.Digit9=57]="Digit9",r[r.Colon=58]="Colon",r[r.Semicolon=59]="Semicolon",r[r.LessThan=60]="LessThan",r[r.Equals=61]="Equals",r[r.GreaterThan=62]="GreaterThan",r[r.QuestionMark=63]="QuestionMark",r[r.AtSign=64]="AtSign",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.OpenSquareBracket=91]="OpenSquareBracket",r[r.Backslash=92]="Backslash",r[r.CloseSquareBracket=93]="CloseSquareBracket",r[r.Caret=94]="Caret",r[r.Underline=95]="Underline",r[r.BackTick=96]="BackTick",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.OpenCurlyBrace=123]="OpenCurlyBrace",r[r.Pipe=124]="Pipe",r[r.CloseCurlyBrace=125]="CloseCurlyBrace",r[r.Tilde=126]="Tilde",r[r.NoBreakSpace=160]="NoBreakSpace",r[r.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",r[r.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",r[r.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",r[r.U_Combining_Tilde=771]="U_Combining_Tilde",r[r.U_Combining_Macron=772]="U_Combining_Macron",r[r.U_Combining_Overline=773]="U_Combining_Overline",r[r.U_Combining_Breve=774]="U_Combining_Breve",r[r.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",r[r.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",r[r.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",r[r.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",r[r.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",r[r.U_Combining_Caron=780]="U_Combining_Caron",r[r.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",r[r.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",r[r.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",r[r.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",r[r.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",r[r.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",r[r.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",r[r.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",r[r.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",r[r.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",r[r.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",r[r.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",r[r.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",r[r.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",r[r.U_Combining_Horn=795]="U_Combining_Horn",r[r.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",r[r.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",r[r.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",r[r.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",r[r.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",r[r.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",r[r.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",r[r.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",r[r.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",r[r.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",r[r.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",r[r.U_Combining_Cedilla=807]="U_Combining_Cedilla",r[r.U_Combining_Ogonek=808]="U_Combining_Ogonek",r[r.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",r[r.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",r[r.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",r[r.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",r[r.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",r[r.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",r[r.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",r[r.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",r[r.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",r[r.U_Combining_Low_Line=818]="U_Combining_Low_Line",r[r.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",r[r.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",r[r.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",r[r.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",r[r.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",r[r.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",r[r.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",r[r.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",r[r.U_Combining_Square_Below=827]="U_Combining_Square_Below",r[r.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",r[r.U_Combining_X_Above=829]="U_Combining_X_Above",r[r.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",r[r.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",r[r.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",r[r.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",r[r.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",r[r.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",r[r.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",r[r.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",r[r.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",r[r.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",r[r.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",r[r.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",r[r.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",r[r.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",r[r.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",r[r.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",r[r.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",r[r.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",r[r.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",r[r.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",r[r.U_Combining_Fermata=850]="U_Combining_Fermata",r[r.U_Combining_X_Below=851]="U_Combining_X_Below",r[r.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",r[r.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",r[r.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",r[r.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",r[r.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",r[r.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",r[r.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",r[r.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",r[r.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",r[r.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",r[r.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",r[r.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",r[r.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",r[r.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",r[r.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",r[r.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",r[r.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",r[r.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",r[r.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",r[r.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",r[r.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",r[r.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",r[r.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",r[r.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",r[r.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",r[r.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",r[r.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",r[r.LINE_SEPARATOR=8232]="LINE_SEPARATOR",r[r.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",r[r.NEXT_LINE=133]="NEXT_LINE",r[r.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",r[r.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",r[r.U_DIAERESIS=168]="U_DIAERESIS",r[r.U_MACRON=175]="U_MACRON",r[r.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",r[r.U_CEDILLA=184]="U_CEDILLA",r[r.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",r[r.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",r[r.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",r[r.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",r[r.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",r[r.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",r[r.U_BREVE=728]="U_BREVE",r[r.U_DOT_ABOVE=729]="U_DOT_ABOVE",r[r.U_RING_ABOVE=730]="U_RING_ABOVE",r[r.U_OGONEK=731]="U_OGONEK",r[r.U_SMALL_TILDE=732]="U_SMALL_TILDE",r[r.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",r[r.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",r[r.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",r[r.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",r[r.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",r[r.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",r[r.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",r[r.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",r[r.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",r[r.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",r[r.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",r[r.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",r[r.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",r[r.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",r[r.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",r[r.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",r[r.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",r[r.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",r[r.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",r[r.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",r[r.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",r[r.U_GREEK_TONOS=900]="U_GREEK_TONOS",r[r.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",r[r.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",r[r.U_GREEK_PSILI=8127]="U_GREEK_PSILI",r[r.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",r[r.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",r[r.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",r[r.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",r[r.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",r[r.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",r[r.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",r[r.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",r[r.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",r[r.U_GREEK_VARIA=8175]="U_GREEK_VARIA",r[r.U_GREEK_OXIA=8189]="U_GREEK_OXIA",r[r.U_GREEK_DASIA=8190]="U_GREEK_DASIA",r[r.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",r[r.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",r[r.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",r[r.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",r[r.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",r[r.U_OVERLINE=8254]="U_OVERLINE",r[r.UTF8_BOM=65279]="UTF8_BOM",r[r.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",r[r.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(n||(e.CharCode=n={}))}),define(Se[156],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E=n,e.$F=r,e.$G=S,e.$H=k;function n(R,A){const v=Object.create(null);for(const s of R){const E=A(s);let y=v[E];y||(y=v[E]=[]),y.push(s)}return v}function r(R,A){const v=[],s=[];for(const E of R)A.has(E)||v.push(E);for(const E of A)R.has(E)||s.push(E);return{removed:v,added:s}}function S(R,A){const v=[],s=[];for(const[E,y]of R)A.has(E)||v.push(y);for(const[E,y]of A)R.has(E)||s.push(y);return{removed:v,added:s}}function k(R,A){const v=new Set;for(const s of A)R.has(s)&&v.add(s);return v}}),define(Se[77],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=r,e.$6h=S,e.$7h=k;function n(R){return(A,v,s)=>{let E=null,y=null;if(typeof s.value=="function"?(E="value",y=s.value):typeof s.get=="function"&&(E="get",y=s.get),!y)throw new Error("not supported");s[E]=R(y,v)}}function r(R,A,v){let s=null,E=null;if(typeof v.value=="function"?(s="value",E=v.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof v.get=="function"&&(s="get",E=v.get),!E)throw new Error("not supported");const y=`$memoize$${A}`;v[s]=function(...$){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,$)}),this[y]}}function S(R,A,v){return n((s,E)=>{const y=`$debounce$${E}`,$=`$debounce$result$${E}`;return function(...w){this[$]||(this[$]=v?v():void 0),clearTimeout(this[y]),A&&(this[$]=A(this[$],...w),w=[this[$]]),this[y]=setTimeout(()=>{s.apply(this,w),this[$]=v?v():void 0},R)}})}function k(R,A,v){return n((s,E)=>{const y=`$throttle$timer$${E}`,$=`$throttle$result$${E}`,w=`$throttle$lastRun$${E}`,a=`$throttle$pending$${E}`;return function(...f){if(this[$]||(this[$]=v?v():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),A&&(this[$]=A(this[$],...f)),this[a])return;const c=this[w]+R;c<=Date.now()?(this[w]=Date.now(),s.apply(this,[this[$]]),this[$]=v?v():void 0):(this[a]=!0,this[y]=setTimeout(()=>{this[a]=!1,this[w]=Date.now(),s.apply(this,[this[$]]),this[$]=v?v():void 0},c-Date.now()))}})}}),define(Se[10],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=r,e.$Z=S,e.$1=k,e.$2=R,e.$3=A,e.$4=s,e.$6=y,e.$7=$,e.$8=w,e.$0=f;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?m.isErrorNoTelemetry(t)?new m(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function r(l){e.$X.setUnexpectedErrorHandler(l)}function S(l){if(!l||typeof l!="object")return!1;const t=l;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function k(l){s(l)||e.$X.onUnexpectedError(l)}function R(l){s(l)||e.$X.onUnexpectedExternalError(l)}function A(l){if(l instanceof Error){const{name:t,message:o}=l,d=l.stacktrace||l.stack;return{$isError:!0,name:t,message:o,stack:d,noTelemetry:m.isErrorNoTelemetry(l)}}return l}const v="Canceled";function s(l){return l instanceof E?!0:l instanceof Error&&l.name===v&&l.message===v}class E extends Error{constructor(){super(v),this.name=this.message}}e.$5=E;function y(){const l=new Error(v);return l.name=l.message,l}function $(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}function w(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}class a extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=a;function f(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}class c extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=c;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=g;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=p;class m extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof m)return t;const o=new m;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=m;class b extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}e.$cb=b}),define(Se[18],De([1,0,10,106]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=S,e.$tb=k,e.$ub=R,e.$vb=A,e.$wb=v,e.$xb=s,e.$yb=E,e.$zb=y,e.$Ab=$,e.$Bb=w,e.$Cb=a,e.$Db=f,e.$Eb=c,e.top=g,e.$Gb=p,e.$Hb=b,e.$Ib=l,e.$Jb=t,e.$Kb=o,e.$Lb=d,e.$Mb=i,e.$Nb=h,e.$Ob=u,e.$Pb=D,e.$Qb=I,e.$Rb=T,e.$Sb=O,e.$Tb=C,e.$Ub=P,e.$Vb=Q,e.$Wb=X,e.$Xb=ie,e.$Yb=ne,e.$Zb=x,e.$1b=re,e.$2b=q,e.$3b=te,e.$4b=le,e.$5b=M,e.$6b=ce,e.$7b=pe,e.$0b=ee;function S(B,U=0){return B[B.length-(1+U)]}function k(B){if(B.length===0)throw new Error("Invalid tail call");return[B.slice(0,B.length-1),B[B.length-1]]}function R(B,U,K=(Z,j)=>Z===j){if(B===U)return!0;if(!B||!U||B.length!==U.length)return!1;for(let Z=0,j=B.length;Z<j;Z++)if(!K(B[Z],U[Z]))return!1;return!0}function A(B,U){const K=B.length-1;U<K&&(B[U]=B[K]),B.pop()}function v(B,U,K){return s(B.length,Z=>K(B[Z],U))}function s(B,U){let K=0,Z=B-1;for(;K<=Z;){const j=(K+Z)/2|0,G=U(j);if(G<0)K=j+1;else if(G>0)Z=j-1;else return j}return-(K+1)}function E(B,U,K){if(B=B|0,B>=U.length)throw new TypeError("invalid index");const Z=U[Math.floor(U.length*Math.random())],j=[],G=[],se=[];for(const fe of U){const Ee=K(fe,Z);Ee<0?j.push(fe):Ee>0?G.push(fe):se.push(fe)}return B<j.length?E(B,j,K):B<j.length+se.length?se[0]:E(B-(j.length+se.length),G,K)}function y(B,U){const K=[];let Z;for(const j of B.slice(0).sort(U))!Z||U(Z[0],j)!==0?(Z=[j],K.push(Z)):Z.push(j);return K}function*$(B,U){let K,Z;for(const j of B)Z!==void 0&&U(Z,j)?K.push(j):(K&&(yield K),K=[j]),Z=j;K&&(yield K)}function w(B,U){for(let K=0;K<=B.length;K++)U(K===0?void 0:B[K-1],K===B.length?void 0:B[K])}function a(B,U){for(let K=0;K<B.length;K++)U(K===0?void 0:B[K-1],B[K],K+1===B.length?void 0:B[K+1])}function f(B,U,K){const Z=[];function j(fe,Ee,Le){if(Ee===0&&Le.length===0)return;const de=Z[Z.length-1];de&&de.start+de.deleteCount===fe?(de.deleteCount+=Ee,de.toInsert.push(...Le)):Z.push({start:fe,deleteCount:Ee,toInsert:Le})}let G=0,se=0;for(;;){if(G===B.length){j(G,0,U.slice(se));break}if(se===U.length){j(G,B.length-G,[]);break}const fe=B[G],Ee=U[se],Le=K(fe,Ee);Le===0?(G+=1,se+=1):Le<0?(j(G,1,[]),G+=1):Le>0&&(j(G,0,[Ee]),se+=1)}return Z}function c(B,U,K){const Z=f(B,U,K),j=[],G=[];for(const se of Z)j.push(...B.slice(se.start,se.start+se.deleteCount)),G.push(...se.toInsert);return{removed:j,added:G}}function g(B,U,K){if(K===0)return[];const Z=B.slice(0,K).sort(U);return m(B,U,Z,K,B.length),Z}function p(B,U,K,Z,j){return K===0?Promise.resolve([]):new Promise((G,se)=>{(async()=>{const fe=B.length,Ee=B.slice(0,K).sort(U);for(let Le=K,de=Math.min(K+Z,fe);Le<fe;Le=de,de=Math.min(de+Z,fe)){if(Le>K&&await new Promise(we=>setTimeout(we)),j&&j.isCancellationRequested)throw new n.$5;m(B,U,Ee,Le,de)}return Ee})().then(G,se)})}function m(B,U,K,Z,j){for(const G=K.length;Z<j;Z++){const se=B[Z];if(U(se,K[G-1])<0){K.pop();const fe=(0,r.$kb)(K,Ee=>U(se,Ee)<0);K.splice(fe,0,se)}}}function b(B){return B.filter(U=>!!U)}function l(B){let U=0;for(let K=0;K<B.length;K++)B[K]&&(B[U]=B[K],U+=1);B.length=U}function t(B,U,K){B.splice(K,0,B.splice(U,1)[0])}function o(B){return!Array.isArray(B)||B.length===0}function d(B){return Array.isArray(B)&&B.length>0}function i(B,U=K=>K){const K=new Set;return B.filter(Z=>{const j=U(Z);return K.has(j)?!1:(K.add(j),!0)})}function h(B){const U=new Set;return K=>{const Z=B(K);return U.has(Z)?!1:(U.add(Z),!0)}}function u(B,U){return B.length>0?B[0]:U}function D(B,U){return B.length>0?B[B.length-1]:U}function I(B,U,K=(Z,j)=>Z===j){let Z=0;for(let j=0,G=Math.min(B.length,U.length);j<G&&K(B[j],U[j]);j++)Z++;return Z}function T(B,U){let K=typeof U=="number"?B:0;typeof U=="number"?K=B:(K=0,U=B);const Z=[];if(K<=U)for(let j=K;j<U;j++)Z.push(j);else for(let j=K;j>U;j--)Z.push(j);return Z}function O(B,U,K){return B.reduce((Z,j)=>(Z[U(j)]=K?K(j):j,Z),Object.create(null))}function C(B,U){return B.push(U),()=>P(B,U)}function P(B,U){const K=B.indexOf(U);if(K>-1)return B.splice(K,1),U}function Q(B,U,K){const Z=B.slice(0,U),j=B.slice(U);return Z.concat(K,j)}function X(B,U){let K;if(typeof U=="number"){let Z=U;K=()=>{const j=Math.sin(Z++)*179426549;return j-Math.floor(j)}}else K=Math.random;for(let Z=B.length-1;Z>0;Z-=1){const j=Math.floor(K()*(Z+1)),G=B[Z];B[Z]=B[j],B[j]=G}}function ie(B,U){const K=B.indexOf(U);K>-1&&(B.splice(K,1),B.unshift(U))}function ne(B,U){const K=B.indexOf(U);K>-1&&(B.splice(K,1),B.push(U))}function x(B,U){for(const K of U)B.push(K)}function re(B,U){return Array.isArray(B)?B.map(U):U(B)}function q(B){return Array.isArray(B)?B:[B]}function te(B){return B[Math.floor(Math.random()*B.length)]}function le(B,U,K){const Z=z(B,U),j=B.length,G=K.length;B.length=j+G;for(let se=j-1;se>=Z;se--)B[se+G]=B[se];for(let se=0;se<G;se++)B[se+Z]=K[se]}function M(B,U,K,Z){const j=z(B,U);let G=B.splice(j,K);return G===void 0&&(G=[]),le(B,j,Z),G}function z(B,U){return U<0?Math.max(U+B.length,0):Math.min(U,B.length)}var oe;(function(B){function U(G){return G<0}B.isLessThan=U;function K(G){return G<=0}B.isLessThanOrEqual=K;function Z(G){return G>0}B.isGreaterThan=Z;function j(G){return G===0}B.isNeitherLessOrGreaterThan=j,B.greaterThan=1,B.lessThan=-1,B.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function ce(B,U){return(K,Z)=>U(B(K),B(Z))}function pe(...B){return(U,K)=>{for(const Z of B){const j=Z(U,K);if(!oe.isNeitherLessOrGreaterThan(j))return j}return oe.neitherLessOrGreaterThan}}const W=(B,U)=>B-U;e.$8b=W;const ae=(B,U)=>(0,e.$8b)(B?1:0,U?1:0);e.$9b=ae;function ee(B){return(U,K)=>-B(U,K)}class H{constructor(U){this.g=U,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(U){let K=this.c;for(;K<this.g.length&&U(this.g[K]);)K++;const Z=K===this.c?null:this.g.slice(this.c,K);return this.c=K,Z}takeFromEndWhile(U){let K=this.d;for(;K>=0&&U(this.g[K]);)K--;const Z=K===this.d?null:this.g.slice(K+1,this.d+1);return this.d=K,Z}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const U=this.g[this.c];return this.c++,U}removeLast(){const U=this.g[this.d];return this.d--,U}takeCount(U){const K=this.g.slice(this.c,this.c+U);return this.c+=U,K}}e.$$b=H;class L{constructor(U){this.iterate=U}forEach(U){this.iterate(K=>(U(K),!0))}toArray(){const U=[];return this.iterate(K=>(U.push(K),!0)),U}filter(U){return new L(K=>this.iterate(Z=>U(Z)?K(Z):!0))}map(U){return new L(K=>this.iterate(Z=>K(U(Z))))}some(U){let K=!1;return this.iterate(Z=>(K=U(Z),!K)),K}findFirst(U){let K;return this.iterate(Z=>U(Z)?(K=Z,!1):!0),K}findLast(U){let K;return this.iterate(Z=>(U(Z)&&(K=Z),!0)),K}findLastMaxBy(U){let K,Z=!0;return this.iterate(j=>((Z||oe.isGreaterThan(U(j,K)))&&(Z=!1,K=j),!0)),K}}e.$_b=L,L.empty=new L(B=>{});class V{constructor(U){this.c=U}static createSortPermutation(U,K){const Z=Array.from(U.keys()).sort((j,G)=>K(U[j],U[G]));return new V(Z)}apply(U){return U.map((K,Z)=>U[this.c[Z]])}inverse(){const U=this.c.slice();for(let K=0;K<this.c.length;K++)U[this.c[K]]=K;return new V(U)}}e.$ac=V}),define(Se[107],De([1,0,10]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=r,e.$ed=S,e.$fd=k,e.$gd=R,e.$hd=A,e.$id=v;function r(s,E){if(!s)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function S(s,E="Unreachable"){throw new Error(E)}function k(s,E="unexpected state"){if(!s)throw new n.$cb(`Assertion Failed: ${E}`)}function R(s){s||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function A(s){if(!s()){debugger;s(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function v(s,E){let y=0;for(;y<s.length-1;){const $=s[y],w=s[y+1];if(!E($,w))return!1;y++}return!0}}),define(Se[157],De([1,0,18]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=S,e.$8c=k,e.$9c=R,e.$0c=A,e.$$c=v,e.$_c=s;const r=(w,a)=>w===a;e.$6c=r;function S(w=e.$6c){return(a,f)=>n.$ub(a,f,w)}function k(){return(w,a)=>JSON.stringify(w)===JSON.stringify(a)}function R(){return(w,a)=>w.equals(a)}function A(w,a,f){return!w||!a?w===a:f(w,a)}function v(w,a){if(w===a)return!0;if(Array.isArray(w)&&Array.isArray(a)){if(w.length!==a.length)return!1;for(let f=0;f<w.length;f++)if(!v(w[f],a[f]))return!1;return!0}if(w&&typeof w=="object"&&a&&typeof a=="object"&&Object.getPrototypeOf(w)===Object.prototype&&Object.getPrototypeOf(a)===Object.prototype){const f=w,c=a,g=Object.keys(f),p=Object.keys(c),m=new Set(p);if(g.length!==p.length)return!1;for(const b of g)if(!m.has(b)||!v(f[b],c[b]))return!1;return!0}return!1}function s(w){return JSON.stringify($(w))}let E=0;const y=new WeakMap;function $(w){if(Array.isArray(w))return w.map($);if(w&&typeof w=="object")if(Object.getPrototypeOf(w)===Object.prototype){const a=w,f=Object.create(null);for(const c of Object.keys(a).sort())f[c]=$(a[c]);return f}else{let a=y.get(w);return a===void 0&&(a=E++,y.set(w,a)),a+"----2b76a038c20c4bcc"}return w}}),define(Se[78],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(r,S){const k=this;let R=!1,A;return function(){if(R)return A;if(R=!0,S)try{A=r.apply(k,arguments)}finally{S()}else A=r.apply(k,arguments);return A}}}),define(Se[40],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(r){function S(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}r.is=S;const k=Object.freeze([]);function R(){return k}r.empty=R;function*A(t){yield t}r.single=A;function v(t){return S(t)?t:A(t)}r.wrap=v;function s(t){return t||k}r.from=s;function*E(t){for(let o=t.length-1;o>=0;o--)yield t[o]}r.reverse=E;function y(t){return!t||t[Symbol.iterator]().next().done===!0}r.isEmpty=y;function $(t){return t[Symbol.iterator]().next().value}r.first=$;function w(t,o){for(const d of t)if(o(d))return!0;return!1}r.some=w;function a(t,o){for(const d of t)if(o(d))return d}r.find=a;function*f(t,o){for(const d of t)o(d)&&(yield d)}r.filter=f;function*c(t,o){let d=0;for(const i of t)yield o(i,d++)}r.map=c;function*g(...t){for(const o of t)yield*o}r.concat=g;function p(t,o,d){let i=d;for(const h of t)i=o(i,h);return i}r.reduce=p;function*m(t,o,d=t.length){for(o<0&&(o+=t.length),d<0?d+=t.length:d>t.length&&(d=t.length);o<d;o++)yield t[o]}r.slice=m;function b(t,o=Number.POSITIVE_INFINITY){const d=[];if(o===0)return[d,t];const i=t[Symbol.iterator]();for(let h=0;h<o;h++){const u=i.next();if(u.done)return[d,r.empty()];d.push(u.value)}return[d,{[Symbol.iterator](){return i}}]}r.consume=b;async function l(t){const o=[];for await(const d of t)o.push(d);return Promise.resolve(o)}r.asyncToArray=l})(n||(e.Iterable=n={}))}),define(Se[44],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$On=R,e.$Pn=y,e.$Qn=$,e.$Rn=w,e.$Sn=a,e.$Tn=f,e.$Un=c,e.$Vn=g,e.$Wn=p,e.$Xn=m,e.$Yn=b,e.$Zn=l;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var r;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(r||(e.SyntaxKind=r={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var k;(function(t){t.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function R(t,o=!1){let d=0;const i=t.length;let h="",u=0,D=r.Unknown,I=n.None;function T(ne){let x=0,re=0;for(;x<ne;){const q=t.charCodeAt(d);if(q>=E._0&&q<=E._9)re=re*16+q-E._0;else if(q>=E.A&&q<=E.F)re=re*16+q-E.A+10;else if(q>=E.a&&q<=E.f)re=re*16+q-E.a+10;else break;d++,x++}return x<ne&&(re=-1),re}function O(ne){d=ne,h="",u=0,D=r.Unknown,I=n.None}function C(){const ne=d;if(t.charCodeAt(d)===E._0)d++;else for(d++;d<t.length&&s(t.charCodeAt(d));)d++;if(d<t.length&&t.charCodeAt(d)===E.dot)if(d++,d<t.length&&s(t.charCodeAt(d)))for(d++;d<t.length&&s(t.charCodeAt(d));)d++;else return I=n.UnexpectedEndOfNumber,t.substring(ne,d);let x=d;if(d<t.length&&(t.charCodeAt(d)===E.E||t.charCodeAt(d)===E.e))if(d++,(d<t.length&&t.charCodeAt(d)===E.plus||t.charCodeAt(d)===E.minus)&&d++,d<t.length&&s(t.charCodeAt(d))){for(d++;d<t.length&&s(t.charCodeAt(d));)d++;x=d}else I=n.UnexpectedEndOfNumber;return t.substring(ne,x)}function P(){let ne="",x=d;for(;;){if(d>=i){ne+=t.substring(x,d),I=n.UnexpectedEndOfString;break}const re=t.charCodeAt(d);if(re===E.doubleQuote){ne+=t.substring(x,d),d++;break}if(re===E.backslash){if(ne+=t.substring(x,d),d++,d>=i){I=n.UnexpectedEndOfString;break}switch(t.charCodeAt(d++)){case E.doubleQuote:ne+='"';break;case E.backslash:ne+="\\";break;case E.slash:ne+="/";break;case E.b:ne+="\b";break;case E.f:ne+="\f";break;case E.n:ne+=`
`;break;case E.r:ne+="\r";break;case E.t:ne+="	";break;case E.u:{const te=T(4);te>=0?ne+=String.fromCharCode(te):I=n.InvalidUnicode;break}default:I=n.InvalidEscapeCharacter}x=d;continue}if(re>=0&&re<=31)if(v(re)){ne+=t.substring(x,d),I=n.UnexpectedEndOfString;break}else I=n.InvalidCharacter;d++}return ne}function Q(){if(h="",I=n.None,u=d,d>=i)return u=i,D=r.EOF;let ne=t.charCodeAt(d);if(A(ne)){do d++,h+=String.fromCharCode(ne),ne=t.charCodeAt(d);while(A(ne));return D=r.Trivia}if(v(ne))return d++,h+=String.fromCharCode(ne),ne===E.carriageReturn&&t.charCodeAt(d)===E.lineFeed&&(d++,h+=`
`),D=r.LineBreakTrivia;switch(ne){case E.openBrace:return d++,D=r.OpenBraceToken;case E.closeBrace:return d++,D=r.CloseBraceToken;case E.openBracket:return d++,D=r.OpenBracketToken;case E.closeBracket:return d++,D=r.CloseBracketToken;case E.colon:return d++,D=r.ColonToken;case E.comma:return d++,D=r.CommaToken;case E.doubleQuote:return d++,h=P(),D=r.StringLiteral;case E.slash:{const x=d-1;if(t.charCodeAt(d+1)===E.slash){for(d+=2;d<i&&!v(t.charCodeAt(d));)d++;return h=t.substring(x,d),D=r.LineCommentTrivia}if(t.charCodeAt(d+1)===E.asterisk){d+=2;const re=i-1;let q=!1;for(;d<re;){if(t.charCodeAt(d)===E.asterisk&&t.charCodeAt(d+1)===E.slash){d+=2,q=!0;break}d++}return q||(d++,I=n.UnexpectedEndOfComment),h=t.substring(x,d),D=r.BlockCommentTrivia}return h+=String.fromCharCode(ne),d++,D=r.Unknown}case E.minus:if(h+=String.fromCharCode(ne),d++,d===i||!s(t.charCodeAt(d)))return D=r.Unknown;case E._0:case E._1:case E._2:case E._3:case E._4:case E._5:case E._6:case E._7:case E._8:case E._9:return h+=C(),D=r.NumericLiteral;default:for(;d<i&&X(ne);)d++,ne=t.charCodeAt(d);if(u!==d){switch(h=t.substring(u,d),h){case"true":return D=r.TrueKeyword;case"false":return D=r.FalseKeyword;case"null":return D=r.NullKeyword}return D=r.Unknown}return h+=String.fromCharCode(ne),d++,D=r.Unknown}}function X(ne){if(A(ne)||v(ne))return!1;switch(ne){case E.closeBrace:case E.closeBracket:case E.openBrace:case E.openBracket:case E.doubleQuote:case E.colon:case E.comma:case E.slash:return!1}return!0}function ie(){let ne;do ne=Q();while(ne>=r.LineCommentTrivia&&ne<=r.Trivia);return ne}return{setPosition:O,getPosition:()=>d,scan:o?ie:Q,getToken:()=>D,getTokenValue:()=>h,getTokenOffset:()=>u,getTokenLength:()=>d-u,getTokenError:()=>I}}function A(t){return t===E.space||t===E.tab||t===E.verticalTab||t===E.formFeed||t===E.nonBreakingSpace||t===E.ogham||t>=E.enQuad&&t<=E.zeroWidthSpace||t===E.narrowNoBreakSpace||t===E.mathematicalSpace||t===E.ideographicSpace||t===E.byteOrderMark}function v(t){return t===E.lineFeed||t===E.carriageReturn||t===E.lineSeparator||t===E.paragraphSeparator}function s(t){return t>=E._0&&t<=E._9}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function y(t,o){const d=[],i=new Object;let h;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let D=!1;function I(T,O,C,P){u.value=T,u.offset=O,u.length=C,u.type=P,u.colonOffset=void 0,h=u}try{m(t,{onObjectBegin:(T,O)=>{if(o<=T)throw i;h=void 0,D=o>T,d.push("")},onObjectProperty:(T,O,C)=>{if(o<O||(I(T,O,C,"property"),d[d.length-1]=T,o<=O+C))throw i},onObjectEnd:(T,O)=>{if(o<=T)throw i;h=void 0,d.pop()},onArrayBegin:(T,O)=>{if(o<=T)throw i;h=void 0,d.push(0)},onArrayEnd:(T,O)=>{if(o<=T)throw i;h=void 0,d.pop()},onLiteralValue:(T,O,C)=>{if(o<O||(I(T,O,C,l(T)),o<=O+C))throw i},onSeparator:(T,O,C)=>{if(o<=O)throw i;if(T===":"&&h&&h.type==="property")h.colonOffset=O,D=!1,h=void 0;else if(T===","){const P=d[d.length-1];typeof P=="number"?d[d.length-1]=P+1:(D=!0,d[d.length-1]=""),h=void 0}}})}catch(T){if(T!==i)throw T}return{path:d,previousNode:h,isAtPropertyKey:D,matches:T=>{let O=0;for(let C=0;O<T.length&&C<d.length;C++)if(T[O]===d[C]||T[O]==="*")O++;else if(T[O]!=="**")return!1;return O===T.length}}}function $(t,o=[],d=k.DEFAULT){let i=null,h=[];const u=[];function D(T){Array.isArray(h)?h.push(T):i!==null&&(h[i]=T)}return m(t,{onObjectBegin:()=>{const T={};D(T),u.push(h),h=T,i=null},onObjectProperty:T=>{i=T},onObjectEnd:()=>{h=u.pop()},onArrayBegin:()=>{const T=[];D(T),u.push(h),h=T,i=null},onArrayEnd:()=>{h=u.pop()},onLiteralValue:D,onError:(T,O,C)=>{o.push({error:T,offset:O,length:C})}},d),h[0]}function w(t,o=[],d=k.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(T){i.type==="property"&&(i.length=T-i.offset,i=i.parent)}function u(T){return i.children.push(T),T}m(t,{onObjectBegin:T=>{i=u({type:"object",offset:T,length:-1,parent:i,children:[]})},onObjectProperty:(T,O,C)=>{i=u({type:"property",offset:O,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:T,offset:O,length:C,parent:i})},onObjectEnd:(T,O)=>{i.length=T+O-i.offset,i=i.parent,h(T+O)},onArrayBegin:(T,O)=>{i=u({type:"array",offset:T,length:-1,parent:i,children:[]})},onArrayEnd:(T,O)=>{i.length=T+O-i.offset,i=i.parent,h(T+O)},onLiteralValue:(T,O,C)=>{u({type:l(T),offset:O,length:C,parent:i,value:T}),h(O+C)},onSeparator:(T,O,C)=>{i.type==="property"&&(T===":"?i.colonOffset=O:T===","&&h(O))},onError:(T,O,C)=>{o.push({error:T,offset:O,length:C})}},d);const I=i.children[0];return I&&delete I.parent,I}function a(t,o){if(!t)return;let d=t;for(const i of o)if(typeof i=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let h=!1;for(const u of d.children)if(Array.isArray(u.children)&&u.children[0].value===i){d=u.children[1],h=!0;break}if(!h)return}else{const h=i;if(d.type!=="array"||h<0||!Array.isArray(d.children)||h>=d.children.length)return;d=d.children[h]}return d}function f(t){if(!t.parent||!t.parent.children)return[];const o=f(t.parent);if(t.parent.type==="property"){const d=t.parent.children[0].value;o.push(d)}else if(t.parent.type==="array"){const d=t.parent.children.indexOf(t);d!==-1&&o.push(d)}return o}function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const o=Object.create(null);for(const d of t.children){const i=d.children[1];i&&(o[d.children[0].value]=c(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function g(t,o,d=!1){return o>=t.offset&&o<t.offset+t.length||d&&o===t.offset+t.length}function p(t,o,d=!1){if(g(t,o,d)){const i=t.children;if(Array.isArray(i))for(let h=0;h<i.length&&i[h].offset<=o;h++){const u=p(i[h],o,d);if(u)return u}return t}}function m(t,o,d=k.DEFAULT){const i=R(t,!1);function h(pe){return pe?()=>pe(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(pe){return pe?W=>pe(W,i.getTokenOffset(),i.getTokenLength()):()=>!0}const D=h(o.onObjectBegin),I=u(o.onObjectProperty),T=h(o.onObjectEnd),O=h(o.onArrayBegin),C=h(o.onArrayEnd),P=u(o.onLiteralValue),Q=u(o.onSeparator),X=h(o.onComment),ie=u(o.onError),ne=d&&d.disallowComments,x=d&&d.allowTrailingComma;function re(){for(;;){const pe=i.scan();switch(i.getTokenError()){case n.InvalidUnicode:q(S.InvalidUnicode);break;case n.InvalidEscapeCharacter:q(S.InvalidEscapeCharacter);break;case n.UnexpectedEndOfNumber:q(S.UnexpectedEndOfNumber);break;case n.UnexpectedEndOfComment:ne||q(S.UnexpectedEndOfComment);break;case n.UnexpectedEndOfString:q(S.UnexpectedEndOfString);break;case n.InvalidCharacter:q(S.InvalidCharacter);break}switch(pe){case r.LineCommentTrivia:case r.BlockCommentTrivia:ne?q(S.InvalidCommentToken):X();break;case r.Unknown:q(S.InvalidSymbol);break;case r.Trivia:case r.LineBreakTrivia:break;default:return pe}}}function q(pe,W=[],ae=[]){if(ie(pe),W.length+ae.length>0){let ee=i.getToken();for(;ee!==r.EOF;){if(W.indexOf(ee)!==-1){re();break}else if(ae.indexOf(ee)!==-1)break;ee=re()}}}function te(pe){const W=i.getTokenValue();return pe?P(W):I(W),re(),!0}function le(){switch(i.getToken()){case r.NumericLiteral:{let pe=0;try{pe=JSON.parse(i.getTokenValue()),typeof pe!="number"&&(q(S.InvalidNumberFormat),pe=0)}catch{q(S.InvalidNumberFormat)}P(pe);break}case r.NullKeyword:P(null);break;case r.TrueKeyword:P(!0);break;case r.FalseKeyword:P(!1);break;default:return!1}return re(),!0}function M(){return i.getToken()!==r.StringLiteral?(q(S.PropertyNameExpected,[],[r.CloseBraceToken,r.CommaToken]),!1):(te(!1),i.getToken()===r.ColonToken?(Q(":"),re(),ce()||q(S.ValueExpected,[],[r.CloseBraceToken,r.CommaToken])):q(S.ColonExpected,[],[r.CloseBraceToken,r.CommaToken]),!0)}function z(){D(),re();let pe=!1;for(;i.getToken()!==r.CloseBraceToken&&i.getToken()!==r.EOF;){if(i.getToken()===r.CommaToken){if(pe||q(S.ValueExpected,[],[]),Q(","),re(),i.getToken()===r.CloseBraceToken&&x)break}else pe&&q(S.CommaExpected,[],[]);M()||q(S.ValueExpected,[],[r.CloseBraceToken,r.CommaToken]),pe=!0}return T(),i.getToken()!==r.CloseBraceToken?q(S.CloseBraceExpected,[r.CloseBraceToken],[]):re(),!0}function oe(){O(),re();let pe=!1;for(;i.getToken()!==r.CloseBracketToken&&i.getToken()!==r.EOF;){if(i.getToken()===r.CommaToken){if(pe||q(S.ValueExpected,[],[]),Q(","),re(),i.getToken()===r.CloseBracketToken&&x)break}else pe&&q(S.CommaExpected,[],[]);ce()||q(S.ValueExpected,[],[r.CloseBracketToken,r.CommaToken]),pe=!0}return C(),i.getToken()!==r.CloseBracketToken?q(S.CloseBracketExpected,[r.CloseBracketToken],[]):re(),!0}function ce(){switch(i.getToken()){case r.OpenBracketToken:return oe();case r.OpenBraceToken:return z();case r.StringLiteral:return te(!0);default:return le()}}return re(),i.getToken()===r.EOF?d.allowEmptyContent?!0:(q(S.ValueExpected,[],[]),!1):ce()?(i.getToken()!==r.EOF&&q(S.EndOfFileExpected,[],[]),!0):(q(S.ValueExpected,[],[]),!1)}function b(t,o){const d=R(t),i=[];let h,u=0,D;do switch(D=d.getPosition(),h=d.scan(),h){case r.LineCommentTrivia:case r.BlockCommentTrivia:case r.EOF:u!==D&&i.push(t.substring(u,D)),o!==void 0&&i.push(d.getTokenValue().replace(/[^\r\n]/g,o)),u=d.getPosition();break}while(h!==r.EOF);return i.join("")}function l(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Se[158],De([1,0,44]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1n=r,e.$2n=S,e.$3n=A,e.$4n=v;function r(s,E,y){let $,w,a,f,c;if(E){for(f=E.offset,c=f+E.length,a=f;a>0&&!v(s,a-1);)a--;let D=c;for(;D<s.length&&!v(s,D);)D++;w=s.substring(a,D),$=R(w,y)}else w=s,$=0,a=0,f=0,c=s.length;const g=A(y,s);let p=!1,m=0,b;y.insertSpaces?b=k(" ",y.tabSize||4):b="	";const l=(0,n.$On)(w,!1);let t=!1;function o(){return g+k(b,$+m)}function d(){let D=l.scan();for(p=!1;D===n.SyntaxKind.Trivia||D===n.SyntaxKind.LineBreakTrivia;)p=p||D===n.SyntaxKind.LineBreakTrivia,D=l.scan();return t=D===n.SyntaxKind.Unknown||l.getTokenError()!==n.ScanError.None,D}const i=[];function h(D,I,T){!t&&I<c&&T>f&&s.substring(I,T)!==D&&i.push({offset:I,length:T-I,content:D})}let u=d();if(u!==n.SyntaxKind.EOF){const D=l.getTokenOffset()+a,I=k(b,$);h(I,a,D)}for(;u!==n.SyntaxKind.EOF;){let D=l.getTokenOffset()+l.getTokenLength()+a,I=d(),T="";for(;!p&&(I===n.SyntaxKind.LineCommentTrivia||I===n.SyntaxKind.BlockCommentTrivia);){const C=l.getTokenOffset()+a;h(" ",D,C),D=l.getTokenOffset()+l.getTokenLength()+a,T=I===n.SyntaxKind.LineCommentTrivia?o():"",I=d()}if(I===n.SyntaxKind.CloseBraceToken)u!==n.SyntaxKind.OpenBraceToken&&(m--,T=o());else if(I===n.SyntaxKind.CloseBracketToken)u!==n.SyntaxKind.OpenBracketToken&&(m--,T=o());else{switch(u){case n.SyntaxKind.OpenBracketToken:case n.SyntaxKind.OpenBraceToken:m++,T=o();break;case n.SyntaxKind.CommaToken:case n.SyntaxKind.LineCommentTrivia:T=o();break;case n.SyntaxKind.BlockCommentTrivia:p?T=o():T=" ";break;case n.SyntaxKind.ColonToken:T=" ";break;case n.SyntaxKind.StringLiteral:if(I===n.SyntaxKind.ColonToken){T="";break}case n.SyntaxKind.NullKeyword:case n.SyntaxKind.TrueKeyword:case n.SyntaxKind.FalseKeyword:case n.SyntaxKind.NumericLiteral:case n.SyntaxKind.CloseBraceToken:case n.SyntaxKind.CloseBracketToken:I===n.SyntaxKind.LineCommentTrivia||I===n.SyntaxKind.BlockCommentTrivia?T=" ":I!==n.SyntaxKind.CommaToken&&I!==n.SyntaxKind.EOF&&(t=!0);break;case n.SyntaxKind.Unknown:t=!0;break}p&&(I===n.SyntaxKind.LineCommentTrivia||I===n.SyntaxKind.BlockCommentTrivia)&&(T=o())}const O=l.getTokenOffset()+a;h(T,D,O),u=I}return i}function S(s,E){const y=JSON.stringify(s,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?y.replace(/\r\n|\r|\n/g,E.eol):y}function k(s,E){let y="";for(let $=0;$<E;$++)y+=s;return y}function R(s,E){let y=0,$=0;const w=E.tabSize||4;for(;y<s.length;){const a=s.charAt(y);if(a===" ")$++;else if(a==="	")$+=w;else break;y++}return Math.floor($/w)}function A(s,E){for(let y=0;y<E.length;y++){const $=E.charAt(y);if($==="\r")return y+1<E.length&&E.charAt(y+1)===`
`?`\r
`:"\r";if($===`
`)return`
`}return s&&s.eol||`
`}function v(s,E){return`\r
`.indexOf(s.charAt(E))!==-1}}),define(Se[159],De([1,0,44,158]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=S,e.$6n=k,e.$7n=R,e.$8n=A,e.$9n=v;function S(s,E,y){return k(s,E,void 0,y)}function k(s,E,y,$,w){const a=E.slice(),f=[],c=(0,n.$Rn)(s,f);let g,p;for(;a.length>0&&(p=a.pop(),g=(0,n.$Sn)(c,a),g===void 0&&y!==void 0);)typeof p=="string"?y={[p]:y}:y=[y];if(g)if(g.type==="object"&&typeof p=="string"&&Array.isArray(g.children)){const m=(0,n.$Sn)(g,[p]);if(m!==void 0)if(y===void 0){if(!m.parent)throw new Error("Malformed AST");const b=g.children.indexOf(m.parent);let l,t=m.parent.offset+m.parent.length;if(b>0){const o=g.children[b-1];l=o.offset+o.length}else l=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return R(s,{offset:l,length:t-l,content:""},$)}else return R(s,{offset:m.offset,length:m.length,content:JSON.stringify(y)},$);else{if(y===void 0)return[];const b=`${JSON.stringify(p)}: ${JSON.stringify(y)}`,l=w?w(g.children.map(o=>o.children[0].value)):g.children.length;let t;if(l>0){const o=g.children[l-1];t={offset:o.offset+o.length,length:0,content:","+b}}else g.children.length===0?t={offset:g.offset+1,length:0,content:b}:t={offset:g.offset+1,length:0,content:b+","};return R(s,t,$)}}else if(g.type==="array"&&typeof p=="number"&&Array.isArray(g.children))if(y!==void 0){const m=`${JSON.stringify(y)}`;let b;if(g.children.length===0||p===0)b={offset:g.offset+1,length:0,content:g.children.length===0?m:m+","};else{const l=p===-1||p>g.children.length?g.children.length:p,t=g.children[l-1];b={offset:t.offset+t.length,length:0,content:","+m}}return R(s,b,$)}else{const m=p,b=g.children[m];let l;if(g.children.length===1)l={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===m){const t=g.children[m-1],o=t.offset+t.length,d=g.offset+g.length;l={offset:o,length:d-2-o,content:""}}else l={offset:b.offset,length:g.children[m+1].offset-b.offset,content:""};return R(s,l,$)}else throw new Error(`Can not add ${typeof p!="number"?"index":"property"} to parent of type ${g.type}`);else return y===void 0?[]:R(s,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(y)},$)}function R(s,E,y){let $=A(s,E),w=E.offset,a=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;w>0&&!(0,r.$4n)($,w-1);)w--;for(;a<$.length&&!(0,r.$4n)($,a);)a++}const f=(0,r.$1n)($,{offset:w,length:a-w},y);for(let g=f.length-1;g>=0;g--){const p=f[g];$=A($,p),w=Math.min(w,p.offset),a=Math.max(a,p.offset+p.length),a+=p.content.length-p.length}const c=s.length-($.length-a)-w;return[{offset:w,length:c,content:$.substring(w,a)}]}function A(s,E){return s.substring(0,E.offset)+E.content+s.substring(E.offset+E.length)}function v(s,E){const y=E.slice(0).sort((w,a)=>{const f=w.offset-a.offset;return f===0?w.length-a.length:f});let $=s.length;for(let w=y.length-1;w>=0;w--){const a=y[w];if(a.offset+a.length<=$)s=A(s,a);else throw new Error("Overlapping edit");$=a.offset}return s}}),define(Se[65],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(Se[79],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class n{constructor(k){this.element=k,this.next=n.Undefined,this.prev=n.Undefined}}n.Undefined=new n(void 0);class r{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let k=this.a;for(;k!==n.Undefined;){const R=k.next;k.prev=n.Undefined,k.next=n.Undefined,k=R}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(k){return this.d(k,!1)}push(k){return this.d(k,!0)}d(k,R){const A=new n(k);if(this.a===n.Undefined)this.a=A,this.b=A;else if(R){const s=this.b;this.b=A,A.prev=s,s.next=A}else{const s=this.a;this.a=A,A.next=s,s.prev=A}this.c+=1;let v=!1;return()=>{v||(v=!0,this.e(A))}}shift(){if(this.a!==n.Undefined){const k=this.a.element;return this.e(this.a),k}}pop(){if(this.b!==n.Undefined){const k=this.b.element;return this.e(this.b),k}}e(k){if(k.prev!==n.Undefined&&k.next!==n.Undefined){const R=k.prev;R.next=k.next,k.next.prev=R}else k.prev===n.Undefined&&k.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):k.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):k.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let k=this.a;for(;k!==n.Undefined;)yield k.element,k=k.next}}e.$5c=r}),define(Se[26],De([1,0]),function(he,e){"use strict";var n,r,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=k,e.$yc=R,e.$zc=A,e.$Ic=b;function k(l,t,o){let d=l.get(t);return d===void 0&&(d=o,l.set(t,d)),d}function R(l){const t=[];return l.forEach((o,d)=>{t.push(`${d} => ${o}`)}),`Map(${l.size}) {${t.join(", ")}}`}function A(l){const t=[];return l.forEach(o=>{t.push(o)}),`Set(${l.size}) {${t.join(", ")}}`}class v{constructor(t,o){this.uri=t,this.value=o}}function s(l){return Array.isArray(l)}class E{constructor(t,o){if(this[n]="ResourceMap",t instanceof E)this.d=new Map(t.d),this.e=o??E.c;else if(s(t)){this.d=new Map,this.e=o??E.c;for(const[d,i]of t)this.set(d,i)}else this.d=new Map,this.e=t??E.c}set(t,o){return this.d.set(this.e(t),new v(t,o)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[d,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=E,E.c=l=>l.toString();class y{constructor(t,o){this[r]="ResourceSet",!t||typeof t=="function"?this.c=new E(t):(this.c=new E(o),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,o){this.c.forEach((d,i)=>t.call(o,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=y;var $;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})($||(e.Touch=$={}));class w{constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,o=$.None){const d=this.c.get(t);if(d)return o!==$.None&&this.m(d,o),d.value}set(t,o,d=$.None){let i=this.c.get(t);if(i)i.value=o,d!==$.None&&this.m(i,d);else{switch(i={key:t,value:o,next:void 0,previous:void 0},d){case $.None:this.k(i);break;case $.AsOld:this.j(i);break;case $.AsNew:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this.c.get(t);if(o)return this.c.delete(t),this.l(o),this.f--,o.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,o){const d=this.g;let i=this.d;for(;i;){if(o?t.bind(o)(i.value,i.key,this):t(i.value,i.key,this),this.g!==d)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,o=this.g;let d=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.key,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return i}values(){const t=this,o=this.g;let d=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:d.value,done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return i}entries(){const t=this,o=this.g;let d=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const h={value:[d.key,d.value],done:!1};return d=d.next,h}else return{value:void 0,done:!0}}};return i}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.d,d=this.size;for(;o&&d>t;)this.c.delete(o.key),o=o.next,d--;this.d=o,this.f=d,o&&(o.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.e,d=this.size;for(;o&&d>t;)this.c.delete(o.key),o=o.previous,d--;this.e=o,this.f=d,o&&(o.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const o=t.next,d=t.previous;if(!o||!d)throw new Error("Invalid list");o.previous=d,d.next=o}t.next=void 0,t.previous=void 0,this.g++}m(t,o){if(!this.d||!this.e)throw new Error("Invalid list");if(!(o!==$.AsOld&&o!==$.AsNew)){if(o===$.AsOld){if(t===this.d)return;const d=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(d.previous=i,i.next=d),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(o===$.AsNew){if(t===this.e)return;const d=t.next,i=t.previous;t===this.d?(d.previous=void 0,this.d=d):(d.previous=i,i.next=d),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((o,d)=>{t.push([d,o])}),t}fromJSON(t){this.clear();for(const[o,d]of t)this.set(o,d)}}e.$Cc=w;class a extends w{constructor(t,o=1){super(),this.n=t,this.o=Math.min(Math.max(0,o),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,o=$.AsNew){return super.get(t,o)}peek(t){return super.get(t,$.None)}set(t,o){return super.set(t,o,$.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class f extends a{constructor(t,o=1){super(t,o)}q(t){this.h(t)}set(t,o){return super.set(t,o),this.p(),this}}e.$Dc=f;class c extends a{constructor(t,o=1){super(t,o)}q(t){this.i(t)}set(t,o){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,o),this}}e.$Ec=c;class g{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let o=this.c.get(t)||0;return o===0?!1:(o--,o===0?this.c.delete(t):this.c.set(t,o),!0)}has(t){return this.c.has(t)}}e.$Fc=g;class p{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[o,d]of t)this.set(o,d)}clear(){this.c.clear(),this.d.clear()}set(t,o){this.c.set(t,o),this.d.set(o,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const o=this.c.get(t);return o===void 0?!1:(this.c.delete(t),this.d.delete(o),!0)}forEach(t,o){this.c.forEach((d,i)=>{t.call(o,d,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=p;class m{constructor(){this.c=new Map}add(t,o){let d=this.c.get(t);d||(d=new Set,this.c.set(t,d)),d.add(o)}delete(t,o){const d=this.c.get(t);d&&(d.delete(o),d.size===0&&this.c.delete(t))}forEach(t,o){const d=this.c.get(t);d&&d.forEach(o)}get(t){const o=this.c.get(t);return o||new Set}}e.$Hc=m;function b(l,t){if(l===t)return!0;if(l.size!==t.size)return!1;for(const[o,d]of l)if(!t.has(o)||t.get(o)!==d)return!1;for(const[o]of t)if(!l.has(o))return!1;return!0}}),define(Se[2],De([1,0,18,156,26,78,40]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=E,e.$Lc=y,e.$Mc=$,e.$Nc=f,e.$Oc=c,e.$Pc=g,e.$Qc=p,e.$Rc=m,e.$Sc=b,e.$3c=T;const A=!1;let v=null;class s{constructor(){this.b=new Map}c(P){let Q=this.b.get(P);return Q||(Q={parent:null,source:null,isSingleton:!1,value:P,idx:s.a++},this.b.set(P,Q)),Q}trackDisposable(P){const Q=this.c(P);Q.source||(Q.source=new Error().stack)}setParent(P,Q){const X=this.c(P);X.parent=Q}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,Q){const X=Q.get(P);if(X)return X;const ie=P.parent?this.f(this.c(P.parent),Q):P;return Q.set(P,ie),ie}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,X])=>X.source!==null&&!this.f(X,P).isSingleton).flatMap(([X])=>X)}computeLeakingDisposables(P=10,Q){let X;if(Q)X=Q;else{const q=new Map,te=[...this.b.values()].filter(M=>M.source!==null&&!this.f(M,q).isSingleton);if(te.length===0)return;const le=new Set(te.map(M=>M.value));if(X=te.filter(M=>!(M.parent&&le.has(M.parent))),X.length===0)throw new Error("There are cyclic diposable chains!")}if(!X)return;function ie(q){function te(M,z){for(;M.length>0&&z.some(oe=>typeof oe=="string"?oe===M[0]:M[0].match(oe));)M.shift()}const le=q.source.split(`
`).map(M=>M.trim().replace("at ","")).filter(M=>M!=="");return te(le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),le.reverse()}const ne=new S.$Hc;for(const q of X){const te=ie(q);for(let le=0;le<=te.length;le++)ne.add(te.slice(0,le).join(`
`),q)}X.sort((0,n.$6b)(q=>q.idx,n.$8b));let x="",re=0;for(const q of X.slice(0,P)){re++;const te=ie(q),le=[];for(let M=0;M<te.length;M++){let z=te[M];z=`(shared with ${ne.get(te.slice(0,M+1).join(`
`)).size}/${X.length} leaks) at ${z}`;const ce=ne.get(te.slice(0,M).join(`
`)),pe=(0,r.$E)([...ce].map(W=>ie(W)[M]),W=>W);delete pe[te[M]];for(const[W,ae]of Object.entries(pe))le.unshift(`    - stacktraces of ${ae.length} other leaks continue with ${W}`);le.unshift(z)}x+=`


==================== Leaking disposable ${re}/${X.length}: ${q.value.constructor.name} ====================
${le.join(`
`)}
============================================================

`}return X.length>P&&(x+=`


... and ${X.length-P} more leaking disposables

`),{leaks:X,details:x}}}e.$Jc=s,s.a=0;function E(C){v=C}if(A){const C="__is_disposable_tracked__";E(new class{trackDisposable(P){const Q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[C]||console.log(Q)},3e3)}setParent(P,Q){if(P&&P!==t.None)try{P[C]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[C]=!0}catch{}}markAsSingleton(P){}})}function y(C){return v?.trackDisposable(C),C}function $(C){v?.markAsDisposed(C)}function w(C,P){v?.setParent(C,P)}function a(C,P){if(v)for(const Q of C)v.setParent(Q,P)}function f(C){return v?.markAsSingleton(C),C}function c(C){return typeof C=="object"&&C!==null&&typeof C.dispose=="function"&&C.dispose.length===0}function g(C){if(R.Iterable.is(C)){const P=[];for(const Q of C)if(Q)try{Q.dispose()}catch(X){P.push(X)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(C)?[]:C}else if(C)return C.dispose(),C}function p(C){for(const P of C)c(P)&&P.dispose();return[]}function m(...C){const P=b(()=>g(C));return a(C,P),P}function b(C){const P=y({dispose:(0,k.$db)(()=>{$(P),C()})});return P}class l{constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||($(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return w(P,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),w(P,null))}}e.$Tc=l,l.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new l,y(this),w(this.q,this)}dispose(){$(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Uc=t,t.None=Object.freeze({dispose(){}});class o{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&w(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,$(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&w(P,null),P}}e.$Vc=o;class d{constructor(P){this.a=new o,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=d;class i{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=i;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(P){let Q=P;return this.unset=()=>Q=void 0,this.isset=()=>Q!==void 0,this.dispose=()=>{Q&&(Q(),Q=void 0,$(this))},this}}e.$Yc=h;class u{constructor(){this.a=new Map}acquire(P,...Q){let X=this.a.get(P);X||(X={counter:0,object:this.b(P,...Q)},this.a.set(P,X));const{object:ie}=X,ne=(0,k.$db)(()=>{--X.counter===0&&(this.c(P,X.object),this.a.delete(P))});return X.counter++,{object:ie,dispose:ne}}}e.$Zc=u;class D{constructor(P){this.a=P}async acquire(P,...Q){const X=this.a.acquire(P,...Q);try{return{object:await X.object,dispose:()=>X.dispose()}}catch(ie){throw X.dispose(),ie}}}e.$1c=D;class I{constructor(P){this.object=P}dispose(){}}e.$2c=I;function T(C){const P=new l;try{C(P)}finally{P.dispose()}}class O{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){$(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,Q,X=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),X||this.a.get(P)?.dispose(),this.a.set(P,Q)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}deleteAndLeak(P){const Q=this.a.get(P);return this.a.delete(P),Q}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=O}),function(he,e){typeof define=="function"&&define.amd?define(Se[160],De([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(U,K){for(var Z=0;Z<K.length;Z++){var j=K[Z];j.enumerable=j.enumerable||!1,j.configurable=!0,"value"in j&&(j.writable=!0),Object.defineProperty(U,j.key,j)}}function n(U,K,Z){return K&&e(U.prototype,K),Z&&e(U,Z),Object.defineProperty(U,"prototype",{writable:!1}),U}function r(U,K){if(U){if(typeof U=="string")return S(U,K);var Z=Object.prototype.toString.call(U).slice(8,-1);if(Z==="Object"&&U.constructor&&(Z=U.constructor.name),Z==="Map"||Z==="Set")return Array.from(U);if(Z==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Z))return S(U,K)}}function S(U,K){(K==null||K>U.length)&&(K=U.length);for(var Z=0,j=new Array(K);Z<K;Z++)j[Z]=U[Z];return j}function k(U,K){var Z=typeof Symbol<"u"&&U[Symbol.iterator]||U["@@iterator"];if(Z)return(Z=Z.call(U)).next.bind(Z);if(Array.isArray(U)||(Z=r(U))||K&&U&&typeof U.length=="number"){Z&&(U=Z);var j=0;return function(){return j>=U.length?{done:!0}:{done:!1,value:U[j++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=R();function A(U){he.defaults=U}var v=/[&<>"']/,s=/[&<>"']/g,E=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(K){return $[K]};function a(U,K){if(K){if(v.test(U))return U.replace(s,w)}else if(E.test(U))return U.replace(y,w);return U}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(U){return U.replace(f,function(K,Z){return Z=Z.toLowerCase(),Z==="colon"?":":Z.charAt(0)==="#"?Z.charAt(1)==="x"?String.fromCharCode(parseInt(Z.substring(2),16)):String.fromCharCode(+Z.substring(1)):""})}var g=/(^|[^\[])\^/g;function p(U,K){U=typeof U=="string"?U:U.source,K=K||"";var Z={replace:function(G,se){return se=se.source||se,se=se.replace(g,"$1"),U=U.replace(G,se),Z},getRegex:function(){return new RegExp(U,K)}};return Z}var m=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(U,K,Z){if(U){var j;try{j=decodeURIComponent(c(Z)).replace(m,"").toLowerCase()}catch{return null}if(j.indexOf("javascript:")===0||j.indexOf("vbscript:")===0||j.indexOf("data:")===0)return null}K&&!b.test(Z)&&(Z=h(K,Z));try{Z=encodeURI(Z).replace(/%25/g,"%")}catch{return null}return Z}var t={},o=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(U,K){t[" "+U]||(o.test(U)?t[" "+U]=U+"/":t[" "+U]=T(U,"/",!0)),U=t[" "+U];var Z=U.indexOf(":")===-1;return K.substring(0,2)==="//"?Z?K:U.replace(d,"$1")+K:K.charAt(0)==="/"?Z?K:U.replace(i,"$1")+K:U+K}var u={exec:function(){}};function D(U){for(var K=1,Z,j;K<arguments.length;K++){Z=arguments[K];for(j in Z)Object.prototype.hasOwnProperty.call(Z,j)&&(U[j]=Z[j])}return U}function I(U,K){var Z=U.replace(/\|/g,function(se,fe,Ee){for(var Le=!1,de=fe;--de>=0&&Ee[de]==="\\";)Le=!Le;return Le?"|":" |"}),j=Z.split(/ \|/),G=0;if(j[0].trim()||j.shift(),j.length>0&&!j[j.length-1].trim()&&j.pop(),j.length>K)j.splice(K);else for(;j.length<K;)j.push("");for(;G<j.length;G++)j[G]=j[G].trim().replace(/\\\|/g,"|");return j}function T(U,K,Z){var j=U.length;if(j===0)return"";for(var G=0;G<j;){var se=U.charAt(j-G-1);if(se===K&&!Z)G++;else if(se!==K&&Z)G++;else break}return U.slice(0,j-G)}function O(U,K){if(U.indexOf(K[1])===-1)return-1;for(var Z=U.length,j=0,G=0;G<Z;G++)if(U[G]==="\\")G++;else if(U[G]===K[0])j++;else if(U[G]===K[1]&&(j--,j<0))return G;return-1}function C(U){U&&U.sanitize&&!U.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(U,K){if(K<1)return"";for(var Z="";K>1;)K&1&&(Z+=U),K>>=1,U+=U;return Z+U}function Q(U,K,Z,j){var G=K.href,se=K.title?a(K.title):null,fe=U[1].replace(/\\([\[\]])/g,"$1");if(U[0].charAt(0)!=="!"){j.state.inLink=!0;var Ee={type:"link",raw:Z,href:G,title:se,text:fe,tokens:j.inlineTokens(fe)};return j.state.inLink=!1,Ee}return{type:"image",raw:Z,href:G,title:se,text:a(fe)}}function X(U,K){var Z=U.match(/^(\s+)(?:```)/);if(Z===null)return K;var j=Z[1];return K.split(`
`).map(function(G){var se=G.match(/^\s+/);if(se===null)return G;var fe=se[0];return fe.length>=j.length?G.slice(j.length):G}).join(`
`)}var ie=function(){function U(Z){this.options=Z||he.defaults}var K=U.prototype;return K.space=function(j){var G=this.rules.block.newline.exec(j);if(G&&G[0].length>0)return{type:"space",raw:G[0]}},K.code=function(j){var G=this.rules.block.code.exec(j);if(G){var se=G[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:G[0],codeBlockStyle:"indented",text:this.options.pedantic?se:T(se,`
`)}}},K.fences=function(j){var G=this.rules.block.fences.exec(j);if(G){var se=G[0],fe=X(se,G[3]||"");return{type:"code",raw:se,lang:G[2]?G[2].trim():G[2],text:fe}}},K.heading=function(j){var G=this.rules.block.heading.exec(j);if(G){var se=G[2].trim();if(/#$/.test(se)){var fe=T(se,"#");(this.options.pedantic||!fe||/ $/.test(fe))&&(se=fe.trim())}return{type:"heading",raw:G[0],depth:G[1].length,text:se,tokens:this.lexer.inline(se)}}},K.hr=function(j){var G=this.rules.block.hr.exec(j);if(G)return{type:"hr",raw:G[0]}},K.blockquote=function(j){var G=this.rules.block.blockquote.exec(j);if(G){var se=G[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:G[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},K.list=function(j){var G=this.rules.block.list.exec(j);if(G){var se,fe,Ee,Le,de,we,Re,Oe,me,Ie,Ae,je,Be=G[1].trim(),Je=Be.length>1,We={type:"list",raw:"",ordered:Je,start:Je?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Je?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Je?Be:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");j&&(je=!1,!(!(G=Qe.exec(j))||this.rules.block.hr.test(j)));){if(se=G[0],j=j.substring(se.length),Oe=G[2].split(`
`,1)[0],me=j.split(`
`,1)[0],this.options.pedantic?(Le=2,Ae=Oe.trimLeft()):(Le=G[2].search(/[^ ]/),Le=Le>4?1:Le,Ae=Oe.slice(Le),Le+=G[1].length),we=!1,!Oe&&/^ *$/.test(me)&&(se+=me+`
`,j=j.substring(me.length+1),je=!0),!je)for(var He=new RegExp("^ {0,"+Math.min(3,Le-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,Le-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,Le-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,Le-1)+"}#");j&&(Ie=j.split(`
`,1)[0],Oe=Ie,this.options.pedantic&&(Oe=Oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(Oe)||rt.test(Oe)||He.test(Oe)||nt.test(j)));){if(Oe.search(/[^ ]/)>=Le||!Oe.trim())Ae+=`
`+Oe.slice(Le);else if(!we)Ae+=`
`+Oe;else break;!we&&!Oe.trim()&&(we=!0),se+=Ie+`
`,j=j.substring(Ie.length+1)}We.loose||(Re?We.loose=!0:/\n *\n *$/.test(se)&&(Re=!0)),this.options.gfm&&(fe=/^\[[ xX]\] /.exec(Ae),fe&&(Ee=fe[0]!=="[ ] ",Ae=Ae.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:se,task:!!fe,checked:Ee,loose:!1,text:Ae}),We.raw+=se}We.items[We.items.length-1].raw=se.trimRight(),We.items[We.items.length-1].text=Ae.trimRight(),We.raw=We.raw.trimRight();var lt=We.items.length;for(de=0;de<lt;de++){this.lexer.state.top=!1,We.items[de].tokens=this.lexer.blockTokens(We.items[de].text,[]);var tt=We.items[de].tokens.filter(function(Ge){return Ge.type==="space"}),Xe=tt.every(function(Ge){for(var xe=Ge.raw.split(""),ve=0,ge=k(xe),be;!(be=ge()).done;){var Y=be.value;if(Y===`
`&&(ve+=1),ve>1)return!0}return!1});!We.loose&&tt.length&&Xe&&(We.loose=!0,We.items[de].loose=!0)}return We}},K.html=function(j){var G=this.rules.block.html.exec(j);if(G){var se={type:"html",raw:G[0],pre:!this.options.sanitizer&&(G[1]==="pre"||G[1]==="script"||G[1]==="style"),text:G[0]};if(this.options.sanitize){var fe=this.options.sanitizer?this.options.sanitizer(G[0]):a(G[0]);se.type="paragraph",se.text=fe,se.tokens=this.lexer.inline(fe)}return se}},K.def=function(j){var G=this.rules.block.def.exec(j);if(G){G[3]&&(G[3]=G[3].substring(1,G[3].length-1));var se=G[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:G[0],href:G[2],title:G[3]}}},K.table=function(j){var G=this.rules.block.table.exec(j);if(G){var se={type:"table",header:I(G[1]).map(function(Re){return{text:Re}}),align:G[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:G[3]&&G[3].trim()?G[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=G[0];var fe=se.align.length,Ee,Le,de,we;for(Ee=0;Ee<fe;Ee++)/^ *-+: *$/.test(se.align[Ee])?se.align[Ee]="right":/^ *:-+: *$/.test(se.align[Ee])?se.align[Ee]="center":/^ *:-+ *$/.test(se.align[Ee])?se.align[Ee]="left":se.align[Ee]=null;for(fe=se.rows.length,Ee=0;Ee<fe;Ee++)se.rows[Ee]=I(se.rows[Ee],se.header.length).map(function(Re){return{text:Re}});for(fe=se.header.length,Le=0;Le<fe;Le++)se.header[Le].tokens=this.lexer.inline(se.header[Le].text);for(fe=se.rows.length,Le=0;Le<fe;Le++)for(we=se.rows[Le],de=0;de<we.length;de++)we[de].tokens=this.lexer.inline(we[de].text);return se}}},K.lheading=function(j){var G=this.rules.block.lheading.exec(j);if(G)return{type:"heading",raw:G[0],depth:G[2].charAt(0)==="="?1:2,text:G[1],tokens:this.lexer.inline(G[1])}},K.paragraph=function(j){var G=this.rules.block.paragraph.exec(j);if(G){var se=G[1].charAt(G[1].length-1)===`
`?G[1].slice(0,-1):G[1];return{type:"paragraph",raw:G[0],text:se,tokens:this.lexer.inline(se)}}},K.text=function(j){var G=this.rules.block.text.exec(j);if(G)return{type:"text",raw:G[0],text:G[0],tokens:this.lexer.inline(G[0])}},K.escape=function(j){var G=this.rules.inline.escape.exec(j);if(G)return{type:"escape",raw:G[0],text:a(G[1])}},K.tag=function(j){var G=this.rules.inline.tag.exec(j);if(G)return!this.lexer.state.inLink&&/^<a /i.test(G[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(G[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(G[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(G[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:G[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(G[0]):a(G[0]):G[0]}},K.link=function(j){var G=this.rules.inline.link.exec(j);if(G){var se=G[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var fe=T(se.slice(0,-1),"\\");if((se.length-fe.length)%2===0)return}else{var Ee=O(G[2],"()");if(Ee>-1){var Le=G[0].indexOf("!")===0?5:4,de=Le+G[1].length+Ee;G[2]=G[2].substring(0,Ee),G[0]=G[0].substring(0,de).trim(),G[3]=""}}var we=G[2],Re="";if(this.options.pedantic){var Oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(we);Oe&&(we=Oe[1],Re=Oe[3])}else Re=G[3]?G[3].slice(1,-1):"";return we=we.trim(),/^</.test(we)&&(this.options.pedantic&&!/>$/.test(se)?we=we.slice(1):we=we.slice(1,-1)),Q(G,{href:we&&we.replace(this.rules.inline._escapes,"$1"),title:Re&&Re.replace(this.rules.inline._escapes,"$1")},G[0],this.lexer)}},K.reflink=function(j,G){var se;if((se=this.rules.inline.reflink.exec(j))||(se=this.rules.inline.nolink.exec(j))){var fe=(se[2]||se[1]).replace(/\s+/g," ");if(fe=G[fe.toLowerCase()],!fe||!fe.href){var Ee=se[0].charAt(0);return{type:"text",raw:Ee,text:Ee}}return Q(se,fe,se[0],this.lexer)}},K.emStrong=function(j,G,se){se===void 0&&(se="");var fe=this.rules.inline.emStrong.lDelim.exec(j);if(fe&&!(fe[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ee=fe[1]||fe[2]||"";if(!Ee||Ee&&(se===""||this.rules.inline.punctuation.exec(se))){var Le=fe[0].length-1,de,we,Re=Le,Oe=0,me=fe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,G=G.slice(-1*j.length+Le);(fe=me.exec(G))!=null;)if(de=fe[1]||fe[2]||fe[3]||fe[4]||fe[5]||fe[6],!!de){if(we=de.length,fe[3]||fe[4]){Re+=we;continue}else if((fe[5]||fe[6])&&Le%3&&!((Le+we)%3)){Oe+=we;continue}if(Re-=we,!(Re>0)){if(we=Math.min(we,we+Re+Oe),Math.min(Le,we)%2){var Ie=j.slice(1,Le+fe.index+we);return{type:"em",raw:j.slice(0,Le+fe.index+we+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}var Ae=j.slice(2,Le+fe.index+we-1);return{type:"strong",raw:j.slice(0,Le+fe.index+we+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}}}}},K.codespan=function(j){var G=this.rules.inline.code.exec(j);if(G){var se=G[2].replace(/\n/g," "),fe=/[^ ]/.test(se),Ee=/^ /.test(se)&&/ $/.test(se);return fe&&Ee&&(se=se.substring(1,se.length-1)),se=a(se,!0),{type:"codespan",raw:G[0],text:se}}},K.br=function(j){var G=this.rules.inline.br.exec(j);if(G)return{type:"br",raw:G[0]}},K.del=function(j){var G=this.rules.inline.del.exec(j);if(G)return{type:"del",raw:G[0],text:G[2],tokens:this.lexer.inlineTokens(G[2])}},K.autolink=function(j,G){var se=this.rules.inline.autolink.exec(j);if(se){var fe,Ee;return se[2]==="@"?(fe=a(this.options.mangle?G(se[1]):se[1]),Ee="mailto:"+fe):(fe=a(se[1]),Ee=fe),{type:"link",raw:se[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},K.url=function(j,G){var se;if(se=this.rules.inline.url.exec(j)){var fe,Ee;if(se[2]==="@")fe=a(this.options.mangle?G(se[0]):se[0]),Ee="mailto:"+fe;else{var Le;do Le=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(Le!==se[0]);fe=a(se[0]),se[1]==="www."?Ee="http://"+fe:Ee=fe}return{type:"link",raw:se[0],text:fe,href:Ee,tokens:[{type:"text",raw:fe,text:fe}]}}},K.inlineText=function(j,G){var se=this.rules.inline.text.exec(j);if(se){var fe;return this.lexer.state.inRawBlock?fe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):a(se[0]):se[0]:fe=a(this.options.smartypants?G(se[0]):se[0]),{type:"text",raw:se[0],text:fe}}},U}(),ne={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ne._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ne._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ne.def=p(ne.def).replace("label",ne._label).replace("title",ne._title).getRegex(),ne.bullet=/(?:[*+-]|\d{1,9}[.)])/,ne.listItemStart=p(/^( *)(bull) */).replace("bull",ne.bullet).getRegex(),ne.list=p(ne.list).replace(/bull/g,ne.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ne.def.source+")").getRegex(),ne._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ne._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ne.html=p(ne.html,"i").replace("comment",ne._comment).replace("tag",ne._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ne.paragraph=p(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.blockquote=p(ne.blockquote).replace("paragraph",ne.paragraph).getRegex(),ne.normal=D({},ne),ne.gfm=D({},ne.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ne.gfm.table=p(ne.gfm.table).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.gfm.paragraph=p(ne._paragraph).replace("hr",ne.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ne.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ne._tag).getRegex(),ne.pedantic=D({},ne.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ne._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:p(ne.normal._paragraph).replace("hr",ne.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ne.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var x={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};x._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",x.punctuation=p(x.punctuation).replace(/punctuation/g,x._punctuation).getRegex(),x.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,x.escapedEmSt=/\\\*|\\_/g,x._comment=p(ne._comment).replace("(?:-->|$)","-->").getRegex(),x.emStrong.lDelim=p(x.emStrong.lDelim).replace(/punct/g,x._punctuation).getRegex(),x.emStrong.rDelimAst=p(x.emStrong.rDelimAst,"g").replace(/punct/g,x._punctuation).getRegex(),x.emStrong.rDelimUnd=p(x.emStrong.rDelimUnd,"g").replace(/punct/g,x._punctuation).getRegex(),x._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,x._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,x._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,x.autolink=p(x.autolink).replace("scheme",x._scheme).replace("email",x._email).getRegex(),x._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,x.tag=p(x.tag).replace("comment",x._comment).replace("attribute",x._attribute).getRegex(),x._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,x._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,x._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,x.link=p(x.link).replace("label",x._label).replace("href",x._href).replace("title",x._title).getRegex(),x.reflink=p(x.reflink).replace("label",x._label).replace("ref",ne._label).getRegex(),x.nolink=p(x.nolink).replace("ref",ne._label).getRegex(),x.reflinkSearch=p(x.reflinkSearch,"g").replace("reflink",x.reflink).replace("nolink",x.nolink).getRegex(),x.normal=D({},x),x.pedantic=D({},x.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",x._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",x._label).getRegex()}),x.gfm=D({},x.normal,{escape:p(x.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),x.gfm.url=p(x.gfm.url,"i").replace("email",x.gfm._extended_email).getRegex(),x.breaks=D({},x.gfm,{br:p(x.br).replace("{2,}","*").getRegex(),text:p(x.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function re(U){return U.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function q(U){var K="",Z,j,G=U.length;for(Z=0;Z<G;Z++)j=U.charCodeAt(Z),Math.random()>.5&&(j="x"+j.toString(16)),K+="&#"+j+";";return K}var te=function(){function U(Z){this.tokens=[],this.tokens.links=Object.create(null),this.options=Z||he.defaults,this.options.tokenizer=this.options.tokenizer||new ie,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var j={block:ne.normal,inline:x.normal};this.options.pedantic?(j.block=ne.pedantic,j.inline=x.pedantic):this.options.gfm&&(j.block=ne.gfm,this.options.breaks?j.inline=x.breaks:j.inline=x.gfm),this.tokenizer.rules=j}U.lex=function(j,G){var se=new U(G);return se.lex(j)},U.lexInline=function(j,G){var se=new U(G);return se.inlineTokens(j)};var K=U.prototype;return K.lex=function(j){j=j.replace(/\r\n|\r/g,`
`),this.blockTokens(j,this.tokens);for(var G;G=this.inlineQueue.shift();)this.inlineTokens(G.src,G.tokens);return this.tokens},K.blockTokens=function(j,G){var se=this;G===void 0&&(G=[]),this.options.pedantic?j=j.replace(/\t/g,"    ").replace(/^ +$/gm,""):j=j.replace(/^( *)(\t+)/gm,function(Re,Oe,me){return Oe+"    ".repeat(me.length)});for(var fe,Ee,Le,de;j;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Re){return(fe=Re.call({lexer:se},j,G))?(j=j.substring(fe.raw.length),G.push(fe),!0):!1}))){if(fe=this.tokenizer.space(j)){j=j.substring(fe.raw.length),fe.raw.length===1&&G.length>0?G[G.length-1].raw+=`
`:G.push(fe);continue}if(fe=this.tokenizer.code(j)){j=j.substring(fe.raw.length),Ee=G[G.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+fe.raw,Ee.text+=`
`+fe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):G.push(fe);continue}if(fe=this.tokenizer.fences(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.heading(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.hr(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.blockquote(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.list(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.html(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.def(j)){j=j.substring(fe.raw.length),Ee=G[G.length-1],Ee&&(Ee.type==="paragraph"||Ee.type==="text")?(Ee.raw+=`
`+fe.raw,Ee.text+=`
`+fe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):this.tokens.links[fe.tag]||(this.tokens.links[fe.tag]={href:fe.href,title:fe.title});continue}if(fe=this.tokenizer.table(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.lheading(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(Le=j,this.options.extensions&&this.options.extensions.startBlock&&function(){var Re=1/0,Oe=j.slice(1),me=void 0;se.options.extensions.startBlock.forEach(function(Ie){me=Ie.call({lexer:this},Oe),typeof me=="number"&&me>=0&&(Re=Math.min(Re,me))}),Re<1/0&&Re>=0&&(Le=j.substring(0,Re+1))}(),this.state.top&&(fe=this.tokenizer.paragraph(Le))){Ee=G[G.length-1],de&&Ee.type==="paragraph"?(Ee.raw+=`
`+fe.raw,Ee.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):G.push(fe),de=Le.length!==j.length,j=j.substring(fe.raw.length);continue}if(fe=this.tokenizer.text(j)){j=j.substring(fe.raw.length),Ee=G[G.length-1],Ee&&Ee.type==="text"?(Ee.raw+=`
`+fe.raw,Ee.text+=`
`+fe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ee.text):G.push(fe);continue}if(j){var we="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return this.state.top=!0,G},K.inline=function(j,G){return G===void 0&&(G=[]),this.inlineQueue.push({src:j,tokens:G}),G},K.inlineTokens=function(j,G){var se=this;G===void 0&&(G=[]);var fe,Ee,Le,de=j,we,Re,Oe;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(we=this.tokenizer.rules.inline.reflinkSearch.exec(de))!=null;)me.includes(we[0].slice(we[0].lastIndexOf("[")+1,-1))&&(de=de.slice(0,we.index)+"["+P("a",we[0].length-2)+"]"+de.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(we=this.tokenizer.rules.inline.blockSkip.exec(de))!=null;)de=de.slice(0,we.index)+"["+P("a",we[0].length-2)+"]"+de.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(we=this.tokenizer.rules.inline.escapedEmSt.exec(de))!=null;)de=de.slice(0,we.index)+"++"+de.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;j;)if(Re||(Oe=""),Re=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ae){return(fe=Ae.call({lexer:se},j,G))?(j=j.substring(fe.raw.length),G.push(fe),!0):!1}))){if(fe=this.tokenizer.escape(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.tag(j)){j=j.substring(fe.raw.length),Ee=G[G.length-1],Ee&&fe.type==="text"&&Ee.type==="text"?(Ee.raw+=fe.raw,Ee.text+=fe.text):G.push(fe);continue}if(fe=this.tokenizer.link(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.reflink(j,this.tokens.links)){j=j.substring(fe.raw.length),Ee=G[G.length-1],Ee&&fe.type==="text"&&Ee.type==="text"?(Ee.raw+=fe.raw,Ee.text+=fe.text):G.push(fe);continue}if(fe=this.tokenizer.emStrong(j,de,Oe)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.codespan(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.br(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.del(j)){j=j.substring(fe.raw.length),G.push(fe);continue}if(fe=this.tokenizer.autolink(j,q)){j=j.substring(fe.raw.length),G.push(fe);continue}if(!this.state.inLink&&(fe=this.tokenizer.url(j,q))){j=j.substring(fe.raw.length),G.push(fe);continue}if(Le=j,this.options.extensions&&this.options.extensions.startInline&&function(){var Ae=1/0,je=j.slice(1),Be=void 0;se.options.extensions.startInline.forEach(function(Je){Be=Je.call({lexer:this},je),typeof Be=="number"&&Be>=0&&(Ae=Math.min(Ae,Be))}),Ae<1/0&&Ae>=0&&(Le=j.substring(0,Ae+1))}(),fe=this.tokenizer.inlineText(Le,re)){j=j.substring(fe.raw.length),fe.raw.slice(-1)!=="_"&&(Oe=fe.raw.slice(-1)),Re=!0,Ee=G[G.length-1],Ee&&Ee.type==="text"?(Ee.raw+=fe.raw,Ee.text+=fe.text):G.push(fe);continue}if(j){var Ie="Infinite loop on byte: "+j.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return G},n(U,null,[{key:"rules",get:function(){return{block:ne,inline:x}}}]),U}(),le=function(){function U(Z){this.options=Z||he.defaults}var K=U.prototype;return K.code=function(j,G,se){var fe=(G||"").match(/\S*/)[0];if(this.options.highlight){var Ee=this.options.highlight(j,fe);Ee!=null&&Ee!==j&&(se=!0,j=Ee)}return j=j.replace(/\n$/,"")+`
`,fe?'<pre><code class="'+this.options.langPrefix+a(fe,!0)+'">'+(se?j:a(j,!0))+`</code></pre>
`:"<pre><code>"+(se?j:a(j,!0))+`</code></pre>
`},K.blockquote=function(j){return`<blockquote>
`+j+`</blockquote>
`},K.html=function(j){return j},K.heading=function(j,G,se,fe){if(this.options.headerIds){var Ee=this.options.headerPrefix+fe.slug(se);return"<h"+G+' id="'+Ee+'">'+j+"</h"+G+`>
`}return"<h"+G+">"+j+"</h"+G+`>
`},K.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},K.list=function(j,G,se){var fe=G?"ol":"ul",Ee=G&&se!==1?' start="'+se+'"':"";return"<"+fe+Ee+`>
`+j+"</"+fe+`>
`},K.listitem=function(j){return"<li>"+j+`</li>
`},K.checkbox=function(j){return"<input "+(j?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},K.paragraph=function(j){return"<p>"+j+`</p>
`},K.table=function(j,G){return G&&(G="<tbody>"+G+"</tbody>"),`<table>
<thead>
`+j+`</thead>
`+G+`</table>
`},K.tablerow=function(j){return`<tr>
`+j+`</tr>
`},K.tablecell=function(j,G){var se=G.header?"th":"td",fe=G.align?"<"+se+' align="'+G.align+'">':"<"+se+">";return fe+j+("</"+se+`>
`)},K.strong=function(j){return"<strong>"+j+"</strong>"},K.em=function(j){return"<em>"+j+"</em>"},K.codespan=function(j){return"<code>"+j+"</code>"},K.br=function(){return this.options.xhtml?"<br/>":"<br>"},K.del=function(j){return"<del>"+j+"</del>"},K.link=function(j,G,se){if(j=l(this.options.sanitize,this.options.baseUrl,j),j===null)return se;var fe='<a href="'+a(j)+'"';return G&&(fe+=' title="'+G+'"'),fe+=">"+se+"</a>",fe},K.image=function(j,G,se){if(j=l(this.options.sanitize,this.options.baseUrl,j),j===null)return se;var fe='<img src="'+j+'" alt="'+se+'"';return G&&(fe+=' title="'+G+'"'),fe+=this.options.xhtml?"/>":">",fe},K.text=function(j){return j},U}(),M=function(){function U(){}var K=U.prototype;return K.strong=function(j){return j},K.em=function(j){return j},K.codespan=function(j){return j},K.del=function(j){return j},K.html=function(j){return j},K.text=function(j){return j},K.link=function(j,G,se){return""+se},K.image=function(j,G,se){return""+se},K.br=function(){return""},U}(),z=function(){function U(){this.seen={}}var K=U.prototype;return K.serialize=function(j){return j.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},K.getNextSafeSlug=function(j,G){var se=j,fe=0;if(this.seen.hasOwnProperty(se)){fe=this.seen[j];do fe++,se=j+"-"+fe;while(this.seen.hasOwnProperty(se))}return G||(this.seen[j]=fe,this.seen[se]=0),se},K.slug=function(j,G){G===void 0&&(G={});var se=this.serialize(j);return this.getNextSafeSlug(se,G.dryrun)},U}(),oe=function(){function U(Z){this.options=Z||he.defaults,this.options.renderer=this.options.renderer||new le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new M,this.slugger=new z}U.parse=function(j,G){var se=new U(G);return se.parse(j)},U.parseInline=function(j,G){var se=new U(G);return se.parseInline(j)};var K=U.prototype;return K.parse=function(j,G){G===void 0&&(G=!0);var se="",fe,Ee,Le,de,we,Re,Oe,me,Ie,Ae,je,Be,Je,We,Qe,He,nt,et,rt,lt=j.length;for(fe=0;fe<lt;fe++){if(Ae=j[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(rt=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ae.type))){se+=rt||"";continue}switch(Ae.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(Ae.tokens),Ae.depth,c(this.parseInline(Ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(Ae.text,Ae.lang,Ae.escaped);continue}case"table":{for(me="",Oe="",de=Ae.header.length,Ee=0;Ee<de;Ee++)Oe+=this.renderer.tablecell(this.parseInline(Ae.header[Ee].tokens),{header:!0,align:Ae.align[Ee]});for(me+=this.renderer.tablerow(Oe),Ie="",de=Ae.rows.length,Ee=0;Ee<de;Ee++){for(Re=Ae.rows[Ee],Oe="",we=Re.length,Le=0;Le<we;Le++)Oe+=this.renderer.tablecell(this.parseInline(Re[Le].tokens),{header:!1,align:Ae.align[Le]});Ie+=this.renderer.tablerow(Oe)}se+=this.renderer.table(me,Ie);continue}case"blockquote":{Ie=this.parse(Ae.tokens),se+=this.renderer.blockquote(Ie);continue}case"list":{for(je=Ae.ordered,Be=Ae.start,Je=Ae.loose,de=Ae.items.length,Ie="",Ee=0;Ee<de;Ee++)Qe=Ae.items[Ee],He=Qe.checked,nt=Qe.task,We="",Qe.task&&(et=this.renderer.checkbox(He),Je?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=et+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=et+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:et}):We+=et),We+=this.parse(Qe.tokens,Je),Ie+=this.renderer.listitem(We,nt,He);se+=this.renderer.list(Ie,je,Be);continue}case"html":{se+=this.renderer.html(Ae.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(Ae.tokens));continue}case"text":{for(Ie=Ae.tokens?this.parseInline(Ae.tokens):Ae.text;fe+1<lt&&j[fe+1].type==="text";)Ae=j[++fe],Ie+=`
`+(Ae.tokens?this.parseInline(Ae.tokens):Ae.text);se+=G?this.renderer.paragraph(Ie):Ie;continue}default:{var tt='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(tt);return}else throw new Error(tt)}}}return se},K.parseInline=function(j,G){G=G||this.renderer;var se="",fe,Ee,Le,de=j.length;for(fe=0;fe<de;fe++){if(Ee=j[fe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ee.type]&&(Le=this.options.extensions.renderers[Ee.type].call({parser:this},Ee),Le!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ee.type))){se+=Le||"";continue}switch(Ee.type){case"escape":{se+=G.text(Ee.text);break}case"html":{se+=G.html(Ee.text);break}case"link":{se+=G.link(Ee.href,Ee.title,this.parseInline(Ee.tokens,G));break}case"image":{se+=G.image(Ee.href,Ee.title,Ee.text);break}case"strong":{se+=G.strong(this.parseInline(Ee.tokens,G));break}case"em":{se+=G.em(this.parseInline(Ee.tokens,G));break}case"codespan":{se+=G.codespan(Ee.text);break}case"br":{se+=G.br();break}case"del":{se+=G.del(this.parseInline(Ee.tokens,G));break}case"text":{se+=G.text(Ee.text);break}default:{var we='Token with "'+Ee.type+'" type was not found.';if(this.options.silent){console.error(we);return}else throw new Error(we)}}}return se},U}();function ce(U,K,Z){if(typeof U>"u"||U===null)throw new Error("marked(): input parameter is undefined or null");if(typeof U!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(U)+", string expected");if(typeof K=="function"&&(Z=K,K=null),K=D({},ce.defaults,K||{}),C(K),Z){var j=K.highlight,G;try{G=te.lex(U,K)}catch(de){return Z(de)}var se=function(we){var Re;if(!we)try{K.walkTokens&&ce.walkTokens(G,K.walkTokens),Re=oe.parse(G,K)}catch(Oe){we=Oe}return K.highlight=j,we?Z(we):Z(null,Re)};if(!j||j.length<3||(delete K.highlight,!G.length))return se();var fe=0;ce.walkTokens(G,function(de){de.type==="code"&&(fe++,setTimeout(function(){j(de.text,de.lang,function(we,Re){if(we)return se(we);Re!=null&&Re!==de.text&&(de.text=Re,de.escaped=!0),fe--,fe===0&&se()})},0))}),fe===0&&se();return}function Ee(de){if(de.message+=`
Please report this to https://github.com/markedjs/marked.`,K.silent)return"<p>An error occurred:</p><pre>"+a(de.message+"",!0)+"</pre>";throw de}try{var Le=te.lex(U,K);if(K.walkTokens){if(K.async)return Promise.all(ce.walkTokens(Le,K.walkTokens)).then(function(){return oe.parse(Le,K)}).catch(Ee);ce.walkTokens(Le,K.walkTokens)}return oe.parse(Le,K)}catch(de){Ee(de)}}ce.options=ce.setOptions=function(U){return D(ce.defaults,U),A(ce.defaults),ce},ce.getDefaults=R,ce.defaults=he.defaults,ce.use=function(){for(var U=arguments.length,K=new Array(U),Z=0;Z<U;Z++)K[Z]=arguments[Z];var j=D.apply(void 0,[{}].concat(K)),G=ce.defaults.extensions||{renderers:{},childTokens:{}},se;K.forEach(function(fe){if(fe.extensions&&(se=!0,fe.extensions.forEach(function(Le){if(!Le.name)throw new Error("extension name required");if(Le.renderer){var de=G.renderers?G.renderers[Le.name]:null;de?G.renderers[Le.name]=function(){for(var we=arguments.length,Re=new Array(we),Oe=0;Oe<we;Oe++)Re[Oe]=arguments[Oe];var me=Le.renderer.apply(this,Re);return me===!1&&(me=de.apply(this,Re)),me}:G.renderers[Le.name]=Le.renderer}if(Le.tokenizer){if(!Le.level||Le.level!=="block"&&Le.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");G[Le.level]?G[Le.level].unshift(Le.tokenizer):G[Le.level]=[Le.tokenizer],Le.start&&(Le.level==="block"?G.startBlock?G.startBlock.push(Le.start):G.startBlock=[Le.start]:Le.level==="inline"&&(G.startInline?G.startInline.push(Le.start):G.startInline=[Le.start]))}Le.childTokens&&(G.childTokens[Le.name]=Le.childTokens)})),fe.renderer&&function(){var Le=ce.defaults.renderer||new le,de=function(Oe){var me=Le[Oe];Le[Oe]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),je=0;je<Ie;je++)Ae[je]=arguments[je];var Be=fe.renderer[Oe].apply(Le,Ae);return Be===!1&&(Be=me.apply(Le,Ae)),Be}};for(var we in fe.renderer)de(we);j.renderer=Le}(),fe.tokenizer&&function(){var Le=ce.defaults.tokenizer||new ie,de=function(Oe){var me=Le[Oe];Le[Oe]=function(){for(var Ie=arguments.length,Ae=new Array(Ie),je=0;je<Ie;je++)Ae[je]=arguments[je];var Be=fe.tokenizer[Oe].apply(Le,Ae);return Be===!1&&(Be=me.apply(Le,Ae)),Be}};for(var we in fe.tokenizer)de(we);j.tokenizer=Le}(),fe.walkTokens){var Ee=ce.defaults.walkTokens;j.walkTokens=function(Le){var de=[];return de.push(fe.walkTokens.call(this,Le)),Ee&&(de=de.concat(Ee.call(this,Le))),de}}se&&(j.extensions=G),ce.setOptions(j)})},ce.walkTokens=function(U,K){for(var Z=[],j=function(){var Ee=se.value;switch(Z=Z.concat(K.call(ce,Ee)),Ee.type){case"table":{for(var Le=k(Ee.header),de;!(de=Le()).done;){var we=de.value;Z=Z.concat(ce.walkTokens(we.tokens,K))}for(var Re=k(Ee.rows),Oe;!(Oe=Re()).done;)for(var me=Oe.value,Ie=k(me),Ae;!(Ae=Ie()).done;){var je=Ae.value;Z=Z.concat(ce.walkTokens(je.tokens,K))}break}case"list":{Z=Z.concat(ce.walkTokens(Ee.items,K));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Ee.type]?ce.defaults.extensions.childTokens[Ee.type].forEach(function(Be){Z=Z.concat(ce.walkTokens(Ee[Be],K))}):Ee.tokens&&(Z=Z.concat(ce.walkTokens(Ee.tokens,K)))}},G=k(U),se;!(se=G()).done;)j();return Z},ce.parseInline=function(U,K){if(typeof U>"u"||U===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof U!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(U)+", string expected");K=D({},ce.defaults,K||{}),C(K);try{var Z=te.lexInline(U,K);return K.walkTokens&&ce.walkTokens(Z,K.walkTokens),oe.parseInline(Z,K)}catch(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,K.silent)return"<p>An error occurred:</p><pre>"+a(j.message+"",!0)+"</pre>";throw j}},ce.Parser=oe,ce.parser=oe.parse,ce.Renderer=le,ce.TextRenderer=M,ce.Lexer=te,ce.lexer=te.lex,ce.Tokenizer=ie,ce.Slugger=z,ce.parse=ce;var pe=ce.options,W=ce.setOptions,ae=ce.use,ee=ce.walkTokens,H=ce.parseInline,L=ce,V=oe.parse,B=te.lex;he.Lexer=te,he.Parser=oe,he.Renderer=le,he.Slugger=z,he.TextRenderer=M,he.Tokenizer=ie,he.getDefaults=R,he.lexer=B,he.marked=ce,he.options=pe,he.parse=L,he.parseInline=H,he.parser=V,he.setOptions=W,he.use=ae,he.walkTokens=ee,Object.defineProperty(he,"__esModule",{value:!0})}),define(Se[80],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var n;(function(r){r[r.Uri=1]="Uri",r[r.Regexp=2]="Regexp",r[r.ScmResource=3]="ScmResource",r[r.ScmResourceGroup=4]="ScmResourceGroup",r[r.ScmProvider=5]="ScmProvider",r[r.CommentController=6]="CommentController",r[r.CommentThread=7]="CommentThread",r[r.CommentThreadInstance=8]="CommentThreadInstance",r[r.CommentThreadReply=9]="CommentThreadReply",r[r.CommentNode=10]="CommentNode",r[r.CommentThreadNode=11]="CommentThreadNode",r[r.TimelineActionContext=12]="TimelineActionContext",r[r.NotebookCellActionContext=13]="NotebookCellActionContext",r[r.NotebookActionContext=14]="NotebookActionContext",r[r.TerminalContext=15]="TerminalContext",r[r.TestItemContext=16]="TestItemContext",r[r.Date=17]="Date",r[r.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(n||(e.MarshalledId=n={}))}),define(Se[161],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=n;function n(f){const c=k(f);if(c&&c.length>0)return new Uint32Array(c)}let r=0;const S=new Uint32Array(10);function k(f){if(r=0,R(f,y,v.InitialConsonant),r>0||(R(f,$,v.Vowel),r>0)||(R(f,w,v.FinalConsonant),r>0)||(R(f,a,v.CompatibilityJamo),r))return S.subarray(0,r);if(f>=44032&&f<=55203){const c=f-44032,g=c%588,p=Math.floor(c/588),m=Math.floor(g/28),b=g%28-1;if(p<y.length?R(p,y,0):v.InitialConsonant+p-v.CompatibilityJamo<a.length&&R(v.InitialConsonant+p,a,v.CompatibilityJamo),m<$.length?R(m,$,0):v.Vowel+m-v.CompatibilityJamo<a.length&&R(v.Vowel+m-v.CompatibilityJamo,a,v.CompatibilityJamo),b>=0&&(b<w.length?R(b,w,0):v.FinalConsonant+b-v.CompatibilityJamo<a.length&&R(v.FinalConsonant+b-v.CompatibilityJamo,a,v.CompatibilityJamo)),r>0)return S.subarray(0,r)}}function R(f,c,g){f>=g&&f<g+c.length&&A(c[f-g])}function A(f){f!==s.NUL&&(S[r++]=f&255,f>>8&&(S[r++]=f>>8&255),f>>16&&(S[r++]=f>>16&255))}var v;(function(f){f[f.InitialConsonant=4352]="InitialConsonant",f[f.Vowel=4449]="Vowel",f[f.FinalConsonant=4520]="FinalConsonant",f[f.CompatibilityJamo=12593]="CompatibilityJamo"})(v||(v={}));var s;(function(f){f[f.NUL=0]="NUL",f[f.A=65]="A",f[f.B=66]="B",f[f.C=67]="C",f[f.D=68]="D",f[f.E=69]="E",f[f.F=70]="F",f[f.G=71]="G",f[f.H=72]="H",f[f.I=73]="I",f[f.J=74]="J",f[f.K=75]="K",f[f.L=76]="L",f[f.M=77]="M",f[f.N=78]="N",f[f.O=79]="O",f[f.P=80]="P",f[f.Q=81]="Q",f[f.R=82]="R",f[f.S=83]="S",f[f.T=84]="T",f[f.U=85]="U",f[f.V=86]="V",f[f.W=87]="W",f[f.X=88]="X",f[f.Y=89]="Y",f[f.Z=90]="Z",f[f.a=97]="a",f[f.b=98]="b",f[f.c=99]="c",f[f.d=100]="d",f[f.e=101]="e",f[f.f=102]="f",f[f.g=103]="g",f[f.h=104]="h",f[f.i=105]="i",f[f.j=106]="j",f[f.k=107]="k",f[f.l=108]="l",f[f.m=109]="m",f[f.n=110]="n",f[f.o=111]="o",f[f.p=112]="p",f[f.q=113]="q",f[f.r=114]="r",f[f.s=115]="s",f[f.t=116]="t",f[f.u=117]="u",f[f.v=118]="v",f[f.w=119]="w",f[f.x=120]="x",f[f.y=121]="y",f[f.z=122]="z"})(s||(s={}));var E;(function(f){f[f.fa=24934]="fa",f[f.fg=26470]="fg",f[f.fq=29030]="fq",f[f.fr=29286]="fr",f[f.ft=29798]="ft",f[f.fv=30310]="fv",f[f.fx=30822]="fx",f[f.hk=27496]="hk",f[f.hl=27752]="hl",f[f.ho=28520]="ho",f[f.ml=27757]="ml",f[f.nj=27246]="nj",f[f.nl=27758]="nl",f[f.np=28782]="np",f[f.qt=29809]="qt",f[f.rt=29810]="rt",f[f.sg=26483]="sg",f[f.sw=30579]="sw"})(E||(E={}));const y=new Uint8Array([s.r,s.R,s.s,s.e,s.E,s.f,s.a,s.q,s.Q,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g]),$=new Uint16Array([s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,E.hk,E.ho,E.hl,s.y,s.n,E.nj,E.np,E.nl,s.b,s.m,E.ml,s.l]),w=new Uint16Array([s.r,s.R,E.rt,s.s,E.sw,E.sg,s.e,s.f,E.fr,E.fa,E.fq,E.ft,E.fx,E.fv,E.fg,s.a,s.q,E.qt,s.t,s.T,s.d,s.w,s.c,s.z,s.x,s.v,s.g]),a=new Uint16Array([s.r,s.R,E.rt,s.s,E.sw,E.sg,s.e,s.E,s.f,E.fr,E.fa,E.fq,E.ft,E.fx,E.fv,E.fg,s.a,s.q,s.Q,E.qt,s.t,s.T,s.d,s.w,s.W,s.c,s.z,s.x,s.v,s.g,s.k,s.o,s.i,s.O,s.j,s.p,s.u,s.P,s.h,E.hk,E.ho,E.hl,s.y,s.n,E.nj,E.np,E.nl,s.b,s.m,E.ml,s.l])}),define(Se[108],De([1,0,26]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=void 0,e.$hm=S,e.$im=R;const r=new n.$Dc(1e4);function S(s){return v(s,"NFC",r)}const k=new n.$Dc(1e4);function R(s){return v(s,"NFD",k)}const A=/[^\u0000-\u0080]/;function v(s,E,y){if(!s)return s;const $=y.get(s);if($)return $;let w;return A.test(s)?w=s.normalize(E):w=s,y.set(s,w),w}e.$jm=function(){const s=/[\u0300-\u036f]/g;return function(E){return R(E).replace(s,"")}}()}),define(Se[162],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=n,e.rot=r;function n(A,v,s){return Math.min(Math.max(A,v),s)}function r(A,v){return(v+A%v)%v}class S{constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=S;class k{constructor(){this.a=1,this.b=0}update(v){return this.b=this.b+(v-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=k;class R{constructor(v){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(v),this.c.fill(0,0,v)}update(v){const s=this.c[this.d];return this.c[this.d]=v,this.d=(this.d+1)%this.c.length,this.e-=s,this.e+=v,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=R}),define(Se[163],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=k,e.$cd=$;class n{constructor(a,f,c){this.owner=a,this.debugNameSource=f,this.referenceFn=c}getDebugName(a){return k(a,this)}}e.$ad=n;const r=new Map,S=new WeakMap;function k(w,a){const f=S.get(w);if(f)return f;const c=R(w,a);if(c){let g=r.get(c)??0;g++,r.set(c,g);const p=g===1?c:`${c}#${g}`;return S.set(w,p),p}}function R(w,a){const f=S.get(w);if(f)return f;const c=a.owner?E(a.owner)+".":"";let g;const p=a.debugNameSource;if(p!==void 0)if(typeof p=="function"){if(g=p(),g!==void 0)return c+g}else return c+p;const m=a.referenceFn;if(m!==void 0&&(g=$(m),g!==void 0))return c+g;if(a.owner!==void 0){const b=A(a.owner,w);if(b!==void 0)return c+b}}function A(w,a){for(const f in w)if(w[f]===a)return f}const v=new Map,s=new WeakMap;function E(w){const a=s.get(w);if(a)return a;const f=y(w);let c=v.get(f)??0;c++,v.set(f,c);const g=c===1?f:`${f}#${c}`;return s.set(w,g),g}function y(w){const a=w.constructor;return a?a.name:"Object"}function $(w){const a=w.toString(),c=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(a);return(c?c[1]:void 0)?.trim()}}),define(Se[164],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=r,e.$Id=S;let n;function r(f){n=f}function S(){return n}class k{constructor(){this.a=0,this.d=new WeakMap}b(c){return R([A(w("|  ",this.a)),c])}c(c){return c.hadValue?c.didChange?[A(" "),s(E(c.oldValue,70),{color:"red",strikeThrough:!0}),A(" "),s(E(c.newValue,60),{color:"green"})]:[A(" (unchanged)")]:[A(" "),s(E(c.newValue,60),{color:"green"}),A(" (initial)")]}handleObservableChanged(c,g){console.log(...this.b([v("observable value changed"),s(c.debugName,{color:"BlueViolet"}),...this.c(g)]))}formatChanges(c){if(c.size!==0)return s(" (changed deps: "+[...c].map(g=>g.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(c){const g=c.handleChange;this.d.set(c,new Set),c.handleChange=(p,m)=>(this.d.get(c).add(p),g.apply(c,[p,m]))}handleDerivedRecomputed(c,g){const p=this.d.get(c);console.log(...this.b([v("derived recomputed"),s(c.debugName,{color:"BlueViolet"}),...this.c(g),this.formatChanges(p),{data:[{fn:c._computeFn}]}])),p.clear()}handleFromEventObservableTriggered(c,g){console.log(...this.b([v("observable from event triggered"),s(c.debugName,{color:"BlueViolet"}),...this.c(g),{data:[{fn:c._getValue}]}]))}handleAutorunCreated(c){const g=c.handleChange;this.d.set(c,new Set),c.handleChange=(p,m)=>(this.d.get(c).add(p),g.apply(c,[p,m]))}handleAutorunTriggered(c){const g=this.d.get(c);console.log(...this.b([v("autorun"),s(c.debugName,{color:"BlueViolet"}),this.formatChanges(g),{data:[{fn:c._runFn}]}])),g.clear(),this.a++}handleAutorunFinished(c){this.a--}handleBeginTransaction(c){let g=c.getDebugName();g===void 0&&(g=""),console.log(...this.b([v("transaction"),s(g,{color:"BlueViolet"}),{data:[{fn:c._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=k;function R(f){const c=new Array,g=[];let p="";function m(l){if("length"in l)for(const t of l)t&&m(t);else"text"in l?(p+=`%c${l.text}`,c.push(l.style),l.data&&g.push(...l.data)):"data"in l&&g.push(...l.data)}m(f);const b=[p,...c];return b.push(...g),b}function A(f){return s(f,{color:"black"})}function v(f){return s(a(`${f}: `,10),{color:"black",bold:!0})}function s(f,c={color:"black"}){function g(m){return Object.entries(m).reduce((b,[l,t])=>`${b}${l}:${t};`,"")}const p={color:c.color};return c.strikeThrough&&(p["text-decoration"]="line-through"),c.bold&&(p["font-weight"]="bold"),{text:f,style:g(p)}}function E(f,c){switch(typeof f){case"number":return""+f;case"string":return f.length+2<=c?`"${f}"`:`"${f.substr(0,c-7)}"+...`;case"boolean":return f?"true":"false";case"undefined":return"undefined";case"object":return f===null?"null":Array.isArray(f)?y(f,c):$(f,c);case"symbol":return f.toString();case"function":return`[[Function${f.name?" "+f.name:""}]]`;default:return""+f}}function y(f,c){let g="[ ",p=!0;for(const m of f){if(p||(g+=", "),g.length-5>c){g+="...";break}p=!1,g+=`${E(m,c-g.length)}`}return g+=" ]",g}function $(f,c){let g="{ ",p=!0;for(const[m,b]of Object.entries(f)){if(p||(g+=", "),g.length-5>c){g+="...";break}p=!1,g+=`${m}: ${E(b,c-g.length)}`}return g+=" }",g}function w(f,c){let g="";for(let p=1;p<=c;p++)g+=f;return g}function a(f,c){for(;f.length<c;)f+=" ";return f}}),define(Se[165],De([1,0,157,163,164]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=R,e.$Td=v,e.$Ud=E,e.$Xd=w,e.$Yd=f,e.$Zd=c,e.$1d=g,e.$3d=m,e.$4d=b,e.$6d=t;let k;function R(d){k=d}let A;function v(d){A=d}let s;function E(d){s=d}class y{get TChange(){return null}reportChanges(){this.get()}read(i){return i?i.readObservable(this):this.get()}map(i,h){const u=h===void 0?void 0:i,D=h===void 0?i:h;return s({owner:u,debugName:()=>{const I=(0,r.$cd)(D);if(I!==void 0)return I;const O=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(D.toString());if(O)return`${this.debugName}.${O[2]}`;if(!u)return`${this.debugName} (mapped)`},debugReferenceFn:D},I=>D(this.read(I),I))}recomputeInitiallyAndOnChange(i,h){return i.add(k(this,h)),this}keepObserved(i){return i.add(A(this)),this}get a(){return this.get()}}e.$Vd=y;class $ extends y{constructor(){super(...arguments),this.b=new Set}addObserver(i){const h=this.b.size;this.b.add(i),h===0&&this.c()}removeObserver(i){this.b.delete(i)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=$;function w(d,i){const h=new p(d,i);try{d(h)}finally{h.finish()}}let a;function f(d){if(a)d(a);else{const i=new p(d,void 0);a=i;try{d(i)}finally{i.finish(),a=void 0}}}async function c(d,i){const h=new p(d,i);try{await d(h)}finally{h.finish()}}function g(d,i,h){d?i(d):w(i,h)}class p{constructor(i,h){this._fn=i,this.b=h,this.a=[],(0,S.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,r.$cd)(this._fn)}updateObserver(i,h){this.a.push({observer:i,observable:h}),i.beginUpdate(h)}finish(){const i=this.a;for(let h=0;h<i.length;h++){const{observer:u,observable:D}=i[h];u.endUpdate(D)}this.a=null,(0,S.$Id)()?.handleEndTransaction()}}e.$2d=p;function m(d,i){let h;return typeof d=="string"?h=new r.$ad(void 0,d,void 0):h=new r.$ad(d,void 0,void 0),new l(h,i,n.$6c)}function b(d,i){return new l(new r.$ad(d.owner,d.debugName,void 0),i,d.equalsFn??n.$6c)}class l extends ${get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(i,h,u){super(),this.e=i,this.g=u,this.d=h}get(){return this.d}set(i,h,u){if(u===void 0&&this.g(this.d,i))return;let D;h||(h=D=new p(()=>{},()=>`Setting ${this.debugName}`));try{const I=this.d;this.h(i),(0,S.$Id)()?.handleObservableChanged(this,{oldValue:I,newValue:i,change:u,didChange:!0,hadValue:!0});for(const T of this.b)h.updateObserver(T,this),T.handleChange(this,u)}finally{D&&D.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(i){this.d=i}}e.$5d=l;function t(d,i){let h;return typeof d=="string"?h=new r.$ad(void 0,d,void 0):h=new r.$ad(d,void 0,void 0),new o(h,i,n.$6c)}class o extends l{h(i){this.d!==i&&(this.d&&this.d.dispose(),this.d=i)}dispose(){this.d?.dispose()}}e.$7d=o}),function(){function he(S){const k=[];typeof S=="number"&&k.push("code/timeOrigin",S);function R(v){k.push(v,Date.now())}function A(){const v=[];for(let s=0;s<k.length;s+=2)v.push({name:k[s],startTime:k[s+1]});return v}return{mark:R,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const R of performance.getEntriesByType("mark"))k.push({name:R.name,startTime:Math.round(S+R.startTime)});return k}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function n(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var r;typeof global=="object"?r=global:typeof self=="object"?r=self:r={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(r)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(r):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),r.perf=n(r))}(),define(Se[3],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=t,e.$x=D,e.$D=I,e.$a="en";let n=!1,r=!1,S=!1,k=!1,R=!1,A=!1,v=!1,s=!1,E=!1,y=!1,$,w=e.$a,a=e.$a,f,c;const g=globalThis;let p;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?p=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(p=process);const m=typeof p?.versions?.electron=="string",b=m&&p?.type==="renderer";if(typeof p=="object"){n=p.platform==="win32",r=p.platform==="darwin",S=p.platform==="linux",k=S&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,v=m,E=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,$=e.$a,w=e.$a;const T=p.env.VSCODE_NLS_CONFIG;if(T)try{const O=JSON.parse(T),C=O.availableLanguages["*"];$=O.locale,a=O.osLocale,w=C||e.$a,f=O._translationsConfigFile}catch{}R=!0}else if(typeof navigator=="object"&&!b){c=navigator.userAgent,n=c.indexOf("Windows")>=0,r=c.indexOf("Macintosh")>=0,s=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=c.indexOf("Linux")>=0,y=c?.indexOf("Mobi")>=0,A=!0,$=e.$a,w=$,a=navigator.language;const T=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),O=T&&T.getAttribute("data-settings");if(O)try{const C=JSON.parse(O),P=C.availableLanguages["*"];$=C.locale,a=C.osLocale,w=P||e.$a,f=C._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var l;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(l||(e.Platform=l={}));function t(T){switch(T){case l.Web:return"Web";case l.Mac:return"Mac";case l.Linux:return"Linux";case l.Windows:return"Windows"}}let o=l.Web;r?o=l.Mac:n?o=l.Windows:S&&(o=l.Linux),e.$c=n,e.$d=r,e.$e=S,e.$f=k,e.$g=R,e.$h=v,e.$i=A,e.$j=A&&typeof g.importScripts=="function",e.$k=e.$j?g.origin:void 0,e.$l=s,e.$m=y,e.$n=E,e.$o=o,e.$p=c,e.$q=w;var d;(function(T){function O(){return e.$q}T.value=O;function C(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}T.isDefaultVariant=C;function P(){return e.$q==="en"}T.isDefault=P})(d||(e.Language=d={})),e.$r=$,e.$s=a,e.$t=f,e.$u=typeof g.postMessage=="function"&&!g.importScripts,e.$v=(()=>{if(e.$u){const T=[];g.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let P=0,Q=T.length;P<Q;P++){const X=T[P];if(X.id===C.data.vscodeScheduleAsyncWork){T.splice(P,1),X.callback();return}}});let O=0;return C=>{const P=++O;T.push({id:P,callback:C}),g.postMessage({vscodeScheduleAsyncWork:P},"*")}}return T=>setTimeout(T)})();var i;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=r||s?i.Macintosh:n?i.Windows:i.Linux;let h=!0,u=!1;function D(){if(!u){u=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,h=new Uint16Array(T.buffer)[0]===513}return h}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function I(T){return parseFloat(T)>=20}}),define(Se[166],De([1,0,40]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OO=void 0;const r=Symbol("unset");class S{constructor(){this.a=new R,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||n.Iterable.empty()}insert(v,s,E){this.d(v,y=>y._value=s,E)}mutate(v,s){this.d(v,E=>E._value=s(E._value===r?void 0:E._value))}mutatePath(v,s){this.d(v,()=>{},E=>s(E))}delete(v){const s=this.c(v);if(!s)return;let E=s.length-1;const y=s[E].node._value;if(y!==r){for(this.b--,s[E].node._value=r;E>0;E--){const{node:$,part:w}=s[E];if($.children?.size||$._value!==r)break;s[E-1].node.children.delete(w)}return y}}*deleteRecursive(v){const s=this.c(v);if(!s)return;const E=s[s.length-1].node;for(let y=s.length-1;y>0;y--){const $=s[y-1];if($.node.children.delete(s[y].part),$.node.children.size>0||$.node._value!==r)break}for(const y of k(E))y._value!==r&&(this.b--,yield y._value)}find(v){let s=this.a;for(const E of v){const y=s.children?.get(E);if(!y)return;s=y}return s._value===r?void 0:s._value}hasKeyOrParent(v){let s=this.a;for(const E of v){const y=s.children?.get(E);if(!y)return!1;if(y._value!==r)return!0;s=y}return!1}hasKeyOrChildren(v){let s=this.a;for(const E of v){const y=s.children?.get(E);if(!y)return!1;s=y}return!0}hasKey(v){let s=this.a;for(const E of v){const y=s.children?.get(E);if(!y)return!1;s=y}return s._value!==r}c(v){const s=[{part:"",node:this.a}];let E=0;for(const y of v){const $=s[E].node.children?.get(y);if(!$)return;s.push({part:y,node:$}),E++}return s}d(v,s,E){let y=this.a;for(const a of v){if(y.children)if(y.children.has(a))y=y.children.get(a);else{const f=new R;y.children.set(a,f),y=f}else{const f=new R;y.children=new Map([[a,f]]),y=f}E?.(y)}const $=y._value===r?0:1;s(y);const w=y._value===r?0:1;this.b+=w-$}*values(){for(const{_value:v}of k(this.a))v!==r&&(yield v)}}e.$OO=S;function*k(A){const v=[A];for(;v.length>0;){const s=v.pop();if(yield s,s.children)for(const E of s.children.values())v.push(E)}}class R{constructor(){this._value=r}get value(){return this._value===r?void 0:this._value}set value(v){this._value=v===void 0?r:v}}}),define(Se[33],De([1,0,3]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let r;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const k=S.process;r={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process<"u"?r={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:r={get platform(){return n.$c?"win32":n.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=r.cwd,e.env=r.env,e.$dc=r.platform,e.$ec=r.arch}),define(Se[9],De([1,0,33]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const r=65,S=97,k=90,R=122,A=46,v=47,s=92,E=58,y=63;class $ extends Error{constructor(o,d,i){let h;typeof d=="string"&&d.indexOf("not ")===0?(h="must not be",d=d.replace(/^not /,"")):h="must be";const u=o.indexOf(".")!==-1?"property":"argument";let D=`The "${o}" ${u} ${h} of type ${d}`;D+=`. Received type ${typeof i}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function w(t,o){if(t===null||typeof t!="object")throw new $(o,"Object",t)}function a(t,o){if(typeof t!="string")throw new $(o,"string",t)}const f=n.$dc==="win32";function c(t){return t===v||t===s}function g(t){return t===v}function p(t){return t>=r&&t<=k||t>=S&&t<=R}function m(t,o,d,i){let h="",u=0,D=-1,I=0,T=0;for(let O=0;O<=t.length;++O){if(O<t.length)T=t.charCodeAt(O);else{if(i(T))break;T=v}if(i(T)){if(!(D===O-1||I===1))if(I===2){if(h.length<2||u!==2||h.charCodeAt(h.length-1)!==A||h.charCodeAt(h.length-2)!==A){if(h.length>2){const C=h.lastIndexOf(d);C===-1?(h="",u=0):(h=h.slice(0,C),u=h.length-1-h.lastIndexOf(d)),D=O,I=0;continue}else if(h.length!==0){h="",u=0,D=O,I=0;continue}}o&&(h+=h.length>0?`${d}..`:"..",u=2)}else h.length>0?h+=`${d}${t.slice(D+1,O)}`:h=t.slice(D+1,O),u=O-D-1;D=O,I=0}else T===A&&I!==-1?++I:I=-1}return h}function b(t,o){w(o,"pathObject");const d=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return d?d===o.root?`${d}${i}`:`${d}${t}${i}`:i}e.$fc={resolve(...t){let o="",d="",i=!1;for(let h=t.length-1;h>=-1;h--){let u;if(h>=0){if(u=t[h],a(u,"path"),u.length===0)continue}else o.length===0?u=n.cwd():(u=n.env[`=${o}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==o.toLowerCase()&&u.charCodeAt(2)===s)&&(u=`${o}\\`));const D=u.length;let I=0,T="",O=!1;const C=u.charCodeAt(0);if(D===1)c(C)&&(I=1,O=!0);else if(c(C))if(O=!0,c(u.charCodeAt(1))){let P=2,Q=P;for(;P<D&&!c(u.charCodeAt(P));)P++;if(P<D&&P!==Q){const X=u.slice(Q,P);for(Q=P;P<D&&c(u.charCodeAt(P));)P++;if(P<D&&P!==Q){for(Q=P;P<D&&!c(u.charCodeAt(P));)P++;(P===D||P!==Q)&&(T=`\\\\${X}\\${u.slice(Q,P)}`,I=P)}}}else I=1;else p(C)&&u.charCodeAt(1)===E&&(T=u.slice(0,2),I=2,D>2&&c(u.charCodeAt(2))&&(O=!0,I=3));if(T.length>0)if(o.length>0){if(T.toLowerCase()!==o.toLowerCase())continue}else o=T;if(i){if(o.length>0)break}else if(d=`${u.slice(I)}\\${d}`,i=O,O&&o.length>0)break}return d=m(d,!i,"\\",c),i?`${o}\\${d}`:`${o}${d}`||"."},normalize(t){a(t,"path");const o=t.length;if(o===0)return".";let d=0,i,h=!1;const u=t.charCodeAt(0);if(o===1)return g(u)?"\\":t;if(c(u))if(h=!0,c(t.charCodeAt(1))){let I=2,T=I;for(;I<o&&!c(t.charCodeAt(I));)I++;if(I<o&&I!==T){const O=t.slice(T,I);for(T=I;I<o&&c(t.charCodeAt(I));)I++;if(I<o&&I!==T){for(T=I;I<o&&!c(t.charCodeAt(I));)I++;if(I===o)return`\\\\${O}\\${t.slice(T)}\\`;I!==T&&(i=`\\\\${O}\\${t.slice(T,I)}`,d=I)}}}else d=1;else p(u)&&t.charCodeAt(1)===E&&(i=t.slice(0,2),d=2,o>2&&c(t.charCodeAt(2))&&(h=!0,d=3));let D=d<o?m(t.slice(d),!h,"\\",c):"";return D.length===0&&!h&&(D="."),D.length>0&&c(t.charCodeAt(o-1))&&(D+="\\"),i===void 0?h?`\\${D}`:D:h?`${i}\\${D}`:`${i}${D}`},isAbsolute(t){a(t,"path");const o=t.length;if(o===0)return!1;const d=t.charCodeAt(0);return c(d)||o>2&&p(d)&&t.charCodeAt(1)===E&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,d;for(let u=0;u<t.length;++u){const D=t[u];a(D,"path"),D.length>0&&(o===void 0?o=d=D:o+=`\\${D}`)}if(o===void 0)return".";let i=!0,h=0;if(typeof d=="string"&&c(d.charCodeAt(0))){++h;const u=d.length;u>1&&c(d.charCodeAt(1))&&(++h,u>2&&(c(d.charCodeAt(2))?++h:i=!1))}if(i){for(;h<o.length&&c(o.charCodeAt(h));)h++;h>=2&&(o=`\\${o.slice(h)}`)}return e.$fc.normalize(o)},relative(t,o){if(a(t,"from"),a(o,"to"),t===o)return"";const d=e.$fc.resolve(t),i=e.$fc.resolve(o);if(d===i||(t=d.toLowerCase(),o=i.toLowerCase(),t===o))return"";let h=0;for(;h<t.length&&t.charCodeAt(h)===s;)h++;let u=t.length;for(;u-1>h&&t.charCodeAt(u-1)===s;)u--;const D=u-h;let I=0;for(;I<o.length&&o.charCodeAt(I)===s;)I++;let T=o.length;for(;T-1>I&&o.charCodeAt(T-1)===s;)T--;const O=T-I,C=D<O?D:O;let P=-1,Q=0;for(;Q<C;Q++){const ie=t.charCodeAt(h+Q);if(ie!==o.charCodeAt(I+Q))break;ie===s&&(P=Q)}if(Q!==C){if(P===-1)return i}else{if(O>C){if(o.charCodeAt(I+Q)===s)return i.slice(I+Q+1);if(Q===2)return i.slice(I+Q)}D>C&&(t.charCodeAt(h+Q)===s?P=Q:Q===2&&(P=3)),P===-1&&(P=0)}let X="";for(Q=h+P+1;Q<=u;++Q)(Q===u||t.charCodeAt(Q)===s)&&(X+=X.length===0?"..":"\\..");return I+=P,X.length>0?`${X}${i.slice(I,T)}`:(i.charCodeAt(I)===s&&++I,i.slice(I,T))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===s){if(o.charCodeAt(1)===s){const d=o.charCodeAt(2);if(d!==y&&d!==A)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(p(o.charCodeAt(0))&&o.charCodeAt(1)===E&&o.charCodeAt(2)===s)return`\\\\?\\${o}`;return t},dirname(t){a(t,"path");const o=t.length;if(o===0)return".";let d=-1,i=0;const h=t.charCodeAt(0);if(o===1)return c(h)?t:".";if(c(h)){if(d=i=1,c(t.charCodeAt(1))){let I=2,T=I;for(;I<o&&!c(t.charCodeAt(I));)I++;if(I<o&&I!==T){for(T=I;I<o&&c(t.charCodeAt(I));)I++;if(I<o&&I!==T){for(T=I;I<o&&!c(t.charCodeAt(I));)I++;if(I===o)return t;I!==T&&(d=i=I+1)}}}}else p(h)&&t.charCodeAt(1)===E&&(d=o>2&&c(t.charCodeAt(2))?3:2,i=d);let u=-1,D=!0;for(let I=o-1;I>=i;--I)if(c(t.charCodeAt(I))){if(!D){u=I;break}}else D=!1;if(u===-1){if(d===-1)return".";u=d}return t.slice(0,u)},basename(t,o){o!==void 0&&a(o,"ext"),a(t,"path");let d=0,i=-1,h=!0,u;if(t.length>=2&&p(t.charCodeAt(0))&&t.charCodeAt(1)===E&&(d=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let D=o.length-1,I=-1;for(u=t.length-1;u>=d;--u){const T=t.charCodeAt(u);if(c(T)){if(!h){d=u+1;break}}else I===-1&&(h=!1,I=u+1),D>=0&&(T===o.charCodeAt(D)?--D===-1&&(i=u):(D=-1,i=I))}return d===i?i=I:i===-1&&(i=t.length),t.slice(d,i)}for(u=t.length-1;u>=d;--u)if(c(t.charCodeAt(u))){if(!h){d=u+1;break}}else i===-1&&(h=!1,i=u+1);return i===-1?"":t.slice(d,i)},extname(t){a(t,"path");let o=0,d=-1,i=0,h=-1,u=!0,D=0;t.length>=2&&t.charCodeAt(1)===E&&p(t.charCodeAt(0))&&(o=i=2);for(let I=t.length-1;I>=o;--I){const T=t.charCodeAt(I);if(c(T)){if(!u){i=I+1;break}continue}h===-1&&(u=!1,h=I+1),T===A?d===-1?d=I:D!==1&&(D=1):d!==-1&&(D=-1)}return d===-1||h===-1||D===0||D===1&&d===h-1&&d===i+1?"":t.slice(d,h)},format:b.bind(null,"\\"),parse(t){a(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const d=t.length;let i=0,h=t.charCodeAt(0);if(d===1)return c(h)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(c(h)){if(i=1,c(t.charCodeAt(1))){let P=2,Q=P;for(;P<d&&!c(t.charCodeAt(P));)P++;if(P<d&&P!==Q){for(Q=P;P<d&&c(t.charCodeAt(P));)P++;if(P<d&&P!==Q){for(Q=P;P<d&&!c(t.charCodeAt(P));)P++;P===d?i=P:P!==Q&&(i=P+1)}}}}else if(p(h)&&t.charCodeAt(1)===E){if(d<=2)return o.root=o.dir=t,o;if(i=2,c(t.charCodeAt(2))){if(d===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let u=-1,D=i,I=-1,T=!0,O=t.length-1,C=0;for(;O>=i;--O){if(h=t.charCodeAt(O),c(h)){if(!T){D=O+1;break}continue}I===-1&&(T=!1,I=O+1),h===A?u===-1?u=O:C!==1&&(C=1):u!==-1&&(C=-1)}return I!==-1&&(u===-1||C===0||C===1&&u===I-1&&u===D+1?o.base=o.name=t.slice(D,I):(o.name=t.slice(D,u),o.base=t.slice(D,I),o.ext=t.slice(u,I))),D>0&&D!==i?o.dir=t.slice(0,D-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const l=(()=>{if(f){const t=/\\/g;return()=>{const o=n.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>n.cwd()})();e.$gc={resolve(...t){let o="",d=!1;for(let i=t.length-1;i>=-1&&!d;i--){const h=i>=0?t[i]:l();a(h,"path"),h.length!==0&&(o=`${h}/${o}`,d=h.charCodeAt(0)===v)}return o=m(o,!d,"/",g),d?`/${o}`:o.length>0?o:"."},normalize(t){if(a(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===v,d=t.charCodeAt(t.length-1)===v;return t=m(t,!o,"/",g),t.length===0?o?"/":d?"./":".":(d&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return a(t,"path"),t.length>0&&t.charCodeAt(0)===v},join(...t){if(t.length===0)return".";let o;for(let d=0;d<t.length;++d){const i=t[d];a(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(a(t,"from"),a(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const d=1,i=t.length,h=i-d,u=1,D=o.length-u,I=h<D?h:D;let T=-1,O=0;for(;O<I;O++){const P=t.charCodeAt(d+O);if(P!==o.charCodeAt(u+O))break;P===v&&(T=O)}if(O===I)if(D>I){if(o.charCodeAt(u+O)===v)return o.slice(u+O+1);if(O===0)return o.slice(u+O)}else h>I&&(t.charCodeAt(d+O)===v?T=O:O===0&&(T=0));let C="";for(O=d+T+1;O<=i;++O)(O===i||t.charCodeAt(O)===v)&&(C+=C.length===0?"..":"/..");return`${C}${o.slice(u+T)}`},toNamespacedPath(t){return t},dirname(t){if(a(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===v;let d=-1,i=!0;for(let h=t.length-1;h>=1;--h)if(t.charCodeAt(h)===v){if(!i){d=h;break}}else i=!1;return d===-1?o?"/":".":o&&d===1?"//":t.slice(0,d)},basename(t,o){o!==void 0&&a(o,"ext"),a(t,"path");let d=0,i=-1,h=!0,u;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let D=o.length-1,I=-1;for(u=t.length-1;u>=0;--u){const T=t.charCodeAt(u);if(T===v){if(!h){d=u+1;break}}else I===-1&&(h=!1,I=u+1),D>=0&&(T===o.charCodeAt(D)?--D===-1&&(i=u):(D=-1,i=I))}return d===i?i=I:i===-1&&(i=t.length),t.slice(d,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===v){if(!h){d=u+1;break}}else i===-1&&(h=!1,i=u+1);return i===-1?"":t.slice(d,i)},extname(t){a(t,"path");let o=-1,d=0,i=-1,h=!0,u=0;for(let D=t.length-1;D>=0;--D){const I=t.charCodeAt(D);if(I===v){if(!h){d=D+1;break}continue}i===-1&&(h=!1,i=D+1),I===A?o===-1?o=D:u!==1&&(u=1):o!==-1&&(u=-1)}return o===-1||i===-1||u===0||u===1&&o===i-1&&o===d+1?"":t.slice(o,i)},format:b.bind(null,"/"),parse(t){a(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const d=t.charCodeAt(0)===v;let i;d?(o.root="/",i=1):i=0;let h=-1,u=0,D=-1,I=!0,T=t.length-1,O=0;for(;T>=i;--T){const C=t.charCodeAt(T);if(C===v){if(!I){u=T+1;break}continue}D===-1&&(I=!1,D=T+1),C===A?h===-1?h=T:O!==1&&(O=1):h!==-1&&(O=-1)}if(D!==-1){const C=u===0&&d?1:u;h===-1||O===0||O===1&&h===D-1&&h===u+1?o.base=o.name=t.slice(C,D):(o.name=t.slice(C,h),o.base=t.slice(C,D),o.ext=t.slice(h,D))}return u>0?o.dir=t.slice(0,u-1):d&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=f?e.$fc.normalize:e.$gc.normalize,e.$ic=f?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=f?e.$fc.join:e.$gc.join,e.$kc=f?e.$fc.resolve:e.$gc.resolve,e.$lc=f?e.$fc.relative:e.$gc.relative,e.$mc=f?e.$fc.dirname:e.$gc.dirname,e.$nc=f?e.$fc.basename:e.$gc.basename,e.$oc=f?e.$fc.extname:e.$gc.extname,e.$pc=f?e.$fc.format:e.$gc.format,e.$qc=f?e.$fc.parse:e.$gc.parse,e.$rc=f?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=f?e.$fc.sep:e.$gc.sep,e.$tc=f?e.$fc.delimiter:e.$gc.delimiter}),define(Se[66],De([1,0,9]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0,e.$1s=k,e.$2s=R,e.$3s=A,e.$4s=s,e.$Zs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const r={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function k(E){const y=(0,n.$oc)(E),$=r[y.toLowerCase()];return $!==void 0?$:R(E)}function R(E){const y=(0,n.$oc)(E);return S[y.toLowerCase()]}function A(E){for(const y in S)if(S[y]===E)return y}const v=/^(.+)\/(.+?)(;.+)?$/;function s(E,y){const $=v.exec(E);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:y?void 0:E}}),define(Se[67],De([1,0,3]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$sm=k,e.$tm=R;var r;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(r||(e.Source=r={}));var S;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function k(A,...v){const s=v.reduce(($,w)=>($[w]=!0,$),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(A).filter($=>!s[$]).forEach($=>{for(let w=0;w<E.length;w++)if($.search(E[w])!==-1){delete A[$];break}})}function R(A){A&&(delete A.DEBUG,n.$d&&delete A.DYLD_LIBRARY_PATH,n.$e&&delete A.LD_PRELOAD)}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var r in n)(typeof exports=="object"?exports:he)[r]=n[r]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function n(r){if(e[r])return e[r].exports;var S=e[r]={i:r,l:!1,exports:{}};return he[r].call(S.exports,S,S.exports,n),S.l=!0,S.exports}return n.m=he,n.c=e,n.d=function(r,S,k){n.o(r,S)||Object.defineProperty(r,S,{enumerable:!0,get:k})},n.r=function(r){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(r,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(r,"__esModule",{value:!0})},n.t=function(r,S){if(1&S&&(r=n(r)),8&S||4&S&&typeof r=="object"&&r&&r.__esModule)return r;var k=Object.create(null);if(n.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:r}),2&S&&typeof r!="string")for(var R in r)n.d(k,R,function(A){return r[A]}.bind(null,R));return k},n.n=function(r){var S=r&&r.__esModule?function(){return r.default}:function(){return r};return n.d(S,"a",S),S},n.o=function(r,S){return Object.prototype.hasOwnProperty.call(r,S)},n.p="",n(n.s=0)}([function(he,e,n){(function(r){var S;e=he.exports=ae,S=typeof r=="object"&&r.env&&r.env.NODE_DEBUG&&/\bsemver\b/i.test(r.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],v=e.src=[],s=0,E=s++;v[E]="0|[1-9]\\d*";var y=s++;v[y]="[0-9]+";var $=s++;v[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=s++;v[w]="("+v[E]+")\\.("+v[E]+")\\.("+v[E]+")";var a=s++;v[a]="("+v[y]+")\\.("+v[y]+")\\.("+v[y]+")";var f=s++;v[f]="(?:"+v[E]+"|"+v[$]+")";var c=s++;v[c]="(?:"+v[y]+"|"+v[$]+")";var g=s++;v[g]="(?:-("+v[f]+"(?:\\."+v[f]+")*))";var p=s++;v[p]="(?:-?("+v[c]+"(?:\\."+v[c]+")*))";var m=s++;v[m]="[0-9A-Za-z-]+";var b=s++;v[b]="(?:\\+("+v[m]+"(?:\\."+v[m]+")*))";var l=s++,t="v?"+v[w]+v[g]+"?"+v[b]+"?";v[l]="^"+t+"$";var o="[v=\\s]*"+v[a]+v[p]+"?"+v[b]+"?",d=s++;v[d]="^"+o+"$";var i=s++;v[i]="((?:<|>)?=?)";var h=s++;v[h]=v[y]+"|x|X|\\*";var u=s++;v[u]=v[E]+"|x|X|\\*";var D=s++;v[D]="[v=\\s]*("+v[u]+")(?:\\.("+v[u]+")(?:\\.("+v[u]+")(?:"+v[g]+")?"+v[b]+"?)?)?";var I=s++;v[I]="[v=\\s]*("+v[h]+")(?:\\.("+v[h]+")(?:\\.("+v[h]+")(?:"+v[p]+")?"+v[b]+"?)?)?";var T=s++;v[T]="^"+v[i]+"\\s*"+v[D]+"$";var O=s++;v[O]="^"+v[i]+"\\s*"+v[I]+"$";var C=s++;v[C]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=s++;v[P]="(?:~>?)";var Q=s++;v[Q]="(\\s*)"+v[P]+"\\s+",A[Q]=new RegExp(v[Q],"g");var X=s++;v[X]="^"+v[P]+v[D]+"$";var ie=s++;v[ie]="^"+v[P]+v[I]+"$";var ne=s++;v[ne]="(?:\\^)";var x=s++;v[x]="(\\s*)"+v[ne]+"\\s+",A[x]=new RegExp(v[x],"g");var re=s++;v[re]="^"+v[ne]+v[D]+"$";var q=s++;v[q]="^"+v[ne]+v[I]+"$";var te=s++;v[te]="^"+v[i]+"\\s*("+o+")$|^$";var le=s++;v[le]="^"+v[i]+"\\s*("+t+")$|^$";var M=s++;v[M]="(\\s*)"+v[i]+"\\s*("+o+"|"+v[D]+")",A[M]=new RegExp(v[M],"g");var z=s++;v[z]="^\\s*("+v[D]+")\\s+-\\s+("+v[D]+")\\s*$";var oe=s++;v[oe]="^\\s*("+v[I]+")\\s+-\\s+("+v[I]+")\\s*$";var ce=s++;v[ce]="(<|>)?=?\\s*\\*";for(var pe=0;pe<35;pe++)S(pe,v[pe]),A[pe]||(A[pe]=new RegExp(v[pe]));function W(me,Ie){if(me instanceof ae)return me;if(typeof me!="string"||me.length>k||!(Ie?A[d]:A[l]).test(me))return null;try{return new ae(me,Ie)}catch{return null}}function ae(me,Ie){if(me instanceof ae){if(me.loose===Ie)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof ae))return new ae(me,Ie);S("SemVer",me,Ie),this.loose=Ie;var Ae=me.trim().match(Ie?A[d]:A[l]);if(!Ae)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+Ae[1],this.minor=+Ae[2],this.patch=+Ae[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");Ae[4]?this.prerelease=Ae[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Be=+je;if(Be>=0&&Be<R)return Be}return je}):this.prerelease=[],this.build=Ae[5]?Ae[5].split("."):[],this.format()}e.parse=W,e.valid=function(me,Ie){var Ae=W(me,Ie);return Ae?Ae.version:null},e.clean=function(me,Ie){var Ae=W(me.trim().replace(/^[=v]+/,""),Ie);return Ae?Ae.version:null},e.SemVer=ae,ae.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ae.prototype.toString=function(){return this.version},ae.prototype.compare=function(me){return S("SemVer.compare",this.version,this.loose,me),me instanceof ae||(me=new ae(me,this.loose)),this.compareMain(me)||this.comparePre(me)},ae.prototype.compareMain=function(me){return me instanceof ae||(me=new ae(me,this.loose)),H(this.major,me.major)||H(this.minor,me.minor)||H(this.patch,me.patch)},ae.prototype.comparePre=function(me){if(me instanceof ae||(me=new ae(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var Ie=0;do{var Ae=this.prerelease[Ie],je=me.prerelease[Ie];if(S("prerelease compare",Ie,Ae,je),Ae===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(Ae===void 0)return-1;if(Ae!==je)return H(Ae,je)}while(++Ie)},ae.prototype.inc=function(me,Ie){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ie);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ie);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ie),this.inc("pre",Ie);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ie),this.inc("pre",Ie);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ae=this.prerelease.length;--Ae>=0;)typeof this.prerelease[Ae]=="number"&&(this.prerelease[Ae]++,Ae=-2);Ae===-1&&this.prerelease.push(0)}Ie&&(this.prerelease[0]===Ie?isNaN(this.prerelease[1])&&(this.prerelease=[Ie,0]):this.prerelease=[Ie,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,Ie,Ae,je){typeof Ae=="string"&&(je=Ae,Ae=void 0);try{return new ae(me,Ae).inc(Ie,je).version}catch{return null}},e.diff=function(me,Ie){if(U(me,Ie))return null;var Ae=W(me),je=W(Ie);if(Ae.prerelease.length||je.prerelease.length){for(var Be in Ae)if((Be==="major"||Be==="minor"||Be==="patch")&&Ae[Be]!==je[Be])return"pre"+Be;return"prerelease"}for(var Be in Ae)if((Be==="major"||Be==="minor"||Be==="patch")&&Ae[Be]!==je[Be])return Be},e.compareIdentifiers=H;var ee=/^[0-9]+$/;function H(me,Ie){var Ae=ee.test(me),je=ee.test(Ie);return Ae&&je&&(me=+me,Ie=+Ie),Ae&&!je?-1:je&&!Ae?1:me<Ie?-1:me>Ie?1:0}function L(me,Ie,Ae){return new ae(me,Ae).compare(new ae(Ie,Ae))}function V(me,Ie,Ae){return L(me,Ie,Ae)>0}function B(me,Ie,Ae){return L(me,Ie,Ae)<0}function U(me,Ie,Ae){return L(me,Ie,Ae)===0}function K(me,Ie,Ae){return L(me,Ie,Ae)!==0}function Z(me,Ie,Ae){return L(me,Ie,Ae)>=0}function j(me,Ie,Ae){return L(me,Ie,Ae)<=0}function G(me,Ie,Ae,je){var Be;switch(Ie){case"===":typeof me=="object"&&(me=me.version),typeof Ae=="object"&&(Ae=Ae.version),Be=me===Ae;break;case"!==":typeof me=="object"&&(me=me.version),typeof Ae=="object"&&(Ae=Ae.version),Be=me!==Ae;break;case"":case"=":case"==":Be=U(me,Ae,je);break;case"!=":Be=K(me,Ae,je);break;case">":Be=V(me,Ae,je);break;case">=":Be=Z(me,Ae,je);break;case"<":Be=B(me,Ae,je);break;case"<=":Be=j(me,Ae,je);break;default:throw new TypeError("Invalid operator: "+Ie)}return Be}function se(me,Ie){if(me instanceof se){if(me.loose===Ie)return me;me=me.value}if(!(this instanceof se))return new se(me,Ie);S("comparator",me,Ie),this.loose=Ie,this.parse(me),this.semver===fe?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(me,Ie){return H(Ie,me)},e.major=function(me,Ie){return new ae(me,Ie).major},e.minor=function(me,Ie){return new ae(me,Ie).minor},e.patch=function(me,Ie){return new ae(me,Ie).patch},e.compare=L,e.compareLoose=function(me,Ie){return L(me,Ie,!0)},e.rcompare=function(me,Ie,Ae){return L(Ie,me,Ae)},e.sort=function(me,Ie){return me.sort(function(Ae,je){return e.compare(Ae,je,Ie)})},e.rsort=function(me,Ie){return me.sort(function(Ae,je){return e.rcompare(Ae,je,Ie)})},e.gt=V,e.lt=B,e.eq=U,e.neq=K,e.gte=Z,e.lte=j,e.cmp=G,e.Comparator=se;var fe={};function Ee(me,Ie){if(me instanceof Ee)return me.loose===Ie?me:new Ee(me.raw,Ie);if(me instanceof se)return new Ee(me.value,Ie);if(!(this instanceof Ee))return new Ee(me,Ie);if(this.loose=Ie,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(Ae){return this.parseRange(Ae.trim())},this).filter(function(Ae){return Ae.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function Le(me){return!me||me.toLowerCase()==="x"||me==="*"}function de(me,Ie,Ae,je,Be,Je,We,Qe,He,nt,et,rt,lt){return((Ie=Le(Ae)?"":Le(je)?">="+Ae+".0.0":Le(Be)?">="+Ae+"."+je+".0":">="+Ie)+" "+(Qe=Le(He)?"":Le(nt)?"<"+(+He+1)+".0.0":Le(et)?"<"+He+"."+(+nt+1)+".0":rt?"<="+He+"."+nt+"."+et+"-"+rt:"<="+Qe)).trim()}function we(me,Ie){for(var Ae=0;Ae<me.length;Ae++)if(!me[Ae].test(Ie))return!1;if(Ie.prerelease.length){for(Ae=0;Ae<me.length;Ae++)if(S(me[Ae].semver),me[Ae].semver!==fe&&me[Ae].semver.prerelease.length>0){var je=me[Ae].semver;if(je.major===Ie.major&&je.minor===Ie.minor&&je.patch===Ie.patch)return!0}return!1}return!0}function Re(me,Ie,Ae){try{Ie=new Ee(Ie,Ae)}catch{return!1}return Ie.test(me)}function Oe(me,Ie,Ae,je){var Be,Je,We,Qe,He;switch(me=new ae(me,je),Ie=new Ee(Ie,je),Ae){case">":Be=V,Je=j,We=B,Qe=">",He=">=";break;case"<":Be=B,Je=Z,We=V,Qe="<",He="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re(me,Ie,je))return!1;for(var nt=0;nt<Ie.set.length;++nt){var et=Ie.set[nt],rt=null,lt=null;if(et.forEach(function(tt){tt.semver===fe&&(tt=new se(">=0.0.0")),rt=rt||tt,lt=lt||tt,Be(tt.semver,rt.semver,je)?rt=tt:We(tt.semver,lt.semver,je)&&(lt=tt)}),rt.operator===Qe||rt.operator===He||(!lt.operator||lt.operator===Qe)&&Je(me,lt.semver)||lt.operator===He&&We(me,lt.semver))return!1}return!0}se.prototype.parse=function(me){var Ie=this.loose?A[te]:A[le],Ae=me.match(Ie);if(!Ae)throw new TypeError("Invalid comparator: "+me);this.operator=Ae[1],this.operator==="="&&(this.operator=""),Ae[2]?this.semver=new ae(Ae[2],this.loose):this.semver=fe},se.prototype.toString=function(){return this.value},se.prototype.test=function(me){return S("Comparator.test",me,this.loose),this.semver===fe||(typeof me=="string"&&(me=new ae(me,this.loose)),G(me,this.operator,this.semver,this.loose))},se.prototype.intersects=function(me,Ie){if(!(me instanceof se))throw new TypeError("a Comparator is required");var Ae;if(this.operator==="")return Ae=new Ee(me.value,Ie),Re(this.value,Ae,Ie);if(me.operator==="")return Ae=new Ee(this.value,Ie),Re(me.semver,Ae,Ie);var je=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),Je=this.semver.version===me.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Qe=G(this.semver,"<",me.semver,Ie)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),He=G(this.semver,">",me.semver,Ie)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return je||Be||Je&&We||Qe||He},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(me){var Ie=this.loose;me=me.trim(),S("range",me,Ie);var Ae=Ie?A[oe]:A[z];me=me.replace(Ae,de),S("hyphen replace",me),me=me.replace(A[M],"$1$2$3"),S("comparator trim",me,A[M]),me=(me=(me=me.replace(A[Q],"$1~")).replace(A[x],"$1^")).split(/\s+/).join(" ");var je=Ie?A[te]:A[le],Be=me.split(" ").map(function(Je){return function(We,Qe){return S("comp",We),We=function(He,nt){return He.trim().split(/\s+/).map(function(et){return function(rt,lt){S("caret",rt,lt);var tt=lt?A[q]:A[re];return rt.replace(tt,function(Xe,Ge,xe,ve,ge){var be;return S("caret",rt,Xe,Ge,xe,ve,ge),Le(Ge)?be="":Le(xe)?be=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":Le(ve)?be=Ge==="0"?">="+Ge+"."+xe+".0 <"+Ge+"."+(+xe+1)+".0":">="+Ge+"."+xe+".0 <"+(+Ge+1)+".0.0":ge?(S("replaceCaret pr",ge),ge.charAt(0)!=="-"&&(ge="-"+ge),be=Ge==="0"?xe==="0"?">="+Ge+"."+xe+"."+ve+ge+" <"+Ge+"."+xe+"."+(+ve+1):">="+Ge+"."+xe+"."+ve+ge+" <"+Ge+"."+(+xe+1)+".0":">="+Ge+"."+xe+"."+ve+ge+" <"+(+Ge+1)+".0.0"):(S("no pr"),be=Ge==="0"?xe==="0"?">="+Ge+"."+xe+"."+ve+" <"+Ge+"."+xe+"."+(+ve+1):">="+Ge+"."+xe+"."+ve+" <"+Ge+"."+(+xe+1)+".0":">="+Ge+"."+xe+"."+ve+" <"+(+Ge+1)+".0.0"),S("caret return",be),be})}(et,nt)}).join(" ")}(We,Qe),S("caret",We),We=function(He,nt){return He.trim().split(/\s+/).map(function(et){return function(rt,lt){var tt=lt?A[ie]:A[X];return rt.replace(tt,function(Xe,Ge,xe,ve,ge){var be;return S("tilde",rt,Xe,Ge,xe,ve,ge),Le(Ge)?be="":Le(xe)?be=">="+Ge+".0.0 <"+(+Ge+1)+".0.0":Le(ve)?be=">="+Ge+"."+xe+".0 <"+Ge+"."+(+xe+1)+".0":ge?(S("replaceTilde pr",ge),ge.charAt(0)!=="-"&&(ge="-"+ge),be=">="+Ge+"."+xe+"."+ve+ge+" <"+Ge+"."+(+xe+1)+".0"):be=">="+Ge+"."+xe+"."+ve+" <"+Ge+"."+(+xe+1)+".0",S("tilde return",be),be})}(et,nt)}).join(" ")}(We,Qe),S("tildes",We),We=function(He,nt){return S("replaceXRanges",He,nt),He.split(/\s+/).map(function(et){return function(rt,lt){rt=rt.trim();var tt=lt?A[O]:A[T];return rt.replace(tt,function(Xe,Ge,xe,ve,ge,be){S("xRange",rt,Xe,Ge,xe,ve,ge,be);var Y=Le(xe),_=Y||Le(ve),ye=_||Le(ge);return Ge==="="&&ye&&(Ge=""),Y?Xe=Ge===">"||Ge==="<"?"<0.0.0":"*":Ge&&ye?(_&&(ve=0),ye&&(ge=0),Ge===">"?(Ge=">=",_?(xe=+xe+1,ve=0,ge=0):ye&&(ve=+ve+1,ge=0)):Ge==="<="&&(Ge="<",_?xe=+xe+1:ve=+ve+1),Xe=Ge+xe+"."+ve+"."+ge):_?Xe=">="+xe+".0.0 <"+(+xe+1)+".0.0":ye&&(Xe=">="+xe+"."+ve+".0 <"+xe+"."+(+ve+1)+".0"),S("xRange return",Xe),Xe})}(et,nt)}).join(" ")}(We,Qe),S("xrange",We),We=function(He,nt){return S("replaceStars",He,nt),He.trim().replace(A[ce],"")}(We,Qe),S("stars",We),We}(Je,Ie)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Je){return!!Je.match(je)})),Be=Be.map(function(Je){return new se(Je,Ie)})},Ee.prototype.intersects=function(me,Ie){if(!(me instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(Ae){return Ae.every(function(je){return me.set.some(function(Be){return Be.every(function(Je){return je.intersects(Je,Ie)})})})})},e.toComparators=function(me,Ie){return new Ee(me,Ie).set.map(function(Ae){return Ae.map(function(je){return je.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new ae(me,this.loose));for(var Ie=0;Ie<this.set.length;Ie++)if(we(this.set[Ie],me))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function(me,Ie,Ae){var je=null,Be=null;try{var Je=new Ee(Ie,Ae)}catch{return null}return me.forEach(function(We){Je.test(We)&&(je&&Be.compare(We)!==-1||(Be=new ae(je=We,Ae)))}),je},e.minSatisfying=function(me,Ie,Ae){var je=null,Be=null;try{var Je=new Ee(Ie,Ae)}catch{return null}return me.forEach(function(We){Je.test(We)&&(je&&Be.compare(We)!==1||(Be=new ae(je=We,Ae)))}),je},e.validRange=function(me,Ie){try{return new Ee(me,Ie).range||"*"}catch{return null}},e.ltr=function(me,Ie,Ae){return Oe(me,Ie,"<",Ae)},e.gtr=function(me,Ie,Ae){return Oe(me,Ie,">",Ae)},e.outside=Oe,e.prerelease=function(me,Ie){var Ae=W(me,Ie);return Ae&&Ae.prerelease.length?Ae.prerelease:null},e.intersects=function(me,Ie,Ae){return me=new Ee(me,Ae),Ie=new Ee(Ie,Ae),me.intersects(Ie)},e.coerce=function(me){if(me instanceof ae)return me;if(typeof me!="string")return null;var Ie=me.match(A[C]);return Ie==null?null:W((Ie[1]||"0")+"."+(Ie[2]||"0")+"."+(Ie[3]||"0"))}}).call(this,n(1))},function(he,e){var n,r,S=he.exports={};function k(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function A(c){if(n===setTimeout)return setTimeout(c,0);if((n===k||!n)&&setTimeout)return n=setTimeout,setTimeout(c,0);try{return n(c,0)}catch{try{return n.call(null,c,0)}catch{return n.call(this,c,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:k}catch{n=k}try{r=typeof clearTimeout=="function"?clearTimeout:R}catch{r=R}})();var v,s=[],E=!1,y=-1;function $(){E&&v&&(E=!1,v.length?s=v.concat(s):y=-1,s.length&&w())}function w(){if(!E){var c=A($);E=!0;for(var g=s.length;g;){for(v=s,s=[];++y<g;)v&&v[y].run();y=-1,g=s.length}v=null,E=!1,function(p){if(r===clearTimeout)return clearTimeout(p);if((r===R||!r)&&clearTimeout)return r=clearTimeout,clearTimeout(p);try{r(p)}catch{try{return r.call(null,p)}catch{return r.call(this,p)}}}(c)}}function a(c,g){this.fun=c,this.array=g}function f(){}S.nextTick=function(c){var g=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)g[p-1]=arguments[p];s.push(new a(c,g)),s.length!==1||E||A(w)},a.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=f,S.addListener=f,S.once=f,S.off=f,S.removeListener=f,S.removeAllListeners=f,S.emit=f,S.prependListener=f,S.prependOnceListener=f,S.listeners=function(c){return[]},S.binding=function(c){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(c){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(Se[167],De([1,0]),function(he,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;class r{constructor(A,v,s){this.level=A,this.key=v,this.value=s,this.forward=[]}}const S=void 0;class k{constructor(A,v=2**16){this.comparator=A,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(v)|0),this.e=new r(this.c,S,S)}get size(){return this.f}clear(){this.e=new r(this.c,S,S),this.f=0}has(A){return!!k.g(this,A,this.comparator)}get(A){return k.g(this,A,this.comparator)?.value}set(A,v){return k.h(this,A,v,this.comparator)&&(this.f+=1),this}delete(A){const v=k.k(this,A,this.comparator);return v&&(this.f-=1),v}forEach(A,v){let s=this.e.forward[0];for(;s;)A.call(v,s.value,s.key,this),s=s.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let A=this.e.forward[0];for(;A;)yield[A.key,A.value],A=A.forward[0]}*keys(){let A=this.e.forward[0];for(;A;)yield A.key,A=A.forward[0]}*values(){let A=this.e.forward[0];for(;A;)yield A.value,A=A.forward[0]}toString(){let A="[SkipList]:",v=this.e.forward[0];for(;v;)A+=`node(${v.key}, ${v.value}, lvl:${v.level})`,v=v.forward[0];return A}static g(A,v,s){let E=A.e;for(let y=A.d-1;y>=0;y--)for(;E.forward[y]&&s(E.forward[y].key,v)<0;)E=E.forward[y];if(E=E.forward[0],E&&s(E.key,v)===0)return E}static h(A,v,s,E){const y=[];let $=A.e;for(let w=A.d-1;w>=0;w--){for(;$.forward[w]&&E($.forward[w].key,v)<0;)$=$.forward[w];y[w]=$}if($=$.forward[0],$&&E($.key,v)===0)return $.value=s,!1;{const w=k.j(A);if(w>A.d){for(let a=A.d;a<w;a++)y[a]=A.e;A.d=w}$=new r(w,v,s);for(let a=0;a<w;a++)$.forward[a]=y[a].forward[a],y[a].forward[a]=$;return!0}}static j(A,v=.5){let s=1;for(;Math.random()<v&&s<A.c;)s+=1;return s}static k(A,v,s){const E=[];let y=A.e;for(let $=A.d-1;$>=0;$--){for(;y.forward[$]&&s(y.forward[$].key,v)<0;)y=y.forward[$];E[$]=y}if(y=y.forward[0],!y||s(y.key,v)!==0)return!1;for(let $=0;$<A.d&&E[$].forward[$]===y;$++)E[$].forward[$]=y.forward[$];for(;A.d>0&&A.e.forward[A.d-1]===S;)A.d-=1;return!0}}e.$Is=k}),define(Se[55],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class r{static create(k){return new r(k)}constructor(k){this.c=n&&k===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=r}),define(Se[6],De([1,0,10,78,2,79,55]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=w;const A=!1,v=!1,s=!1;var E;(function(ie){ie.None=()=>S.$Uc.None;function ne(de){if(s){const{onDidAddListener:we}=de,Re=f.create();let Oe=0;de.onDidAddListener=()=>{++Oe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Re.print()),we?.()}}}function x(de,we){return W(de,()=>{},0,void 0,!0,void 0,we)}ie.defer=x;function re(de){return(we,Re=null,Oe)=>{let me=!1,Ie;return Ie=de(Ae=>{if(!me)return Ie?Ie.dispose():me=!0,we.call(Re,Ae)},null,Oe),me&&Ie.dispose(),Ie}}ie.once=re;function q(de,we,Re){return ce((Oe,me=null,Ie)=>de(Ae=>Oe.call(me,we(Ae)),null,Ie),Re)}ie.map=q;function te(de,we,Re){return ce((Oe,me=null,Ie)=>de(Ae=>{we(Ae),Oe.call(me,Ae)},null,Ie),Re)}ie.forEach=te;function le(de,we,Re){return ce((Oe,me=null,Ie)=>de(Ae=>we(Ae)&&Oe.call(me,Ae),null,Ie),Re)}ie.filter=le;function M(de){return de}ie.signal=M;function z(...de){return(we,Re=null,Oe)=>{const me=(0,S.$Rc)(...de.map(Ie=>Ie(Ae=>we.call(Re,Ae))));return pe(me,Oe)}}ie.any=z;function oe(de,we,Re,Oe){let me=Re;return q(de,Ie=>(me=we(me,Ie),me),Oe)}ie.reduce=oe;function ce(de,we){let Re;const Oe={onWillAddFirstListener(){Re=de(me.fire,me)},onDidRemoveLastListener(){Re?.dispose()}};we||ne(Oe);const me=new o(Oe);return we?.add(me),me.event}function pe(de,we){return we instanceof Array?we.push(de):we&&we.add(de),de}function W(de,we,Re=100,Oe=!1,me=!1,Ie,Ae){let je,Be,Je,We=0,Qe;const He={leakWarningThreshold:Ie,onWillAddFirstListener(){je=de(et=>{We++,Be=we(Be,et),Oe&&!Je&&(nt.fire(Be),Be=void 0),Qe=()=>{const rt=Be;Be=void 0,Je=void 0,(!Oe||We>1)&&nt.fire(rt),We=0},typeof Re=="number"?(clearTimeout(Je),Je=setTimeout(Qe,Re)):Je===void 0&&(Je=0,queueMicrotask(Qe))})},onWillRemoveListener(){me&&We>0&&Qe?.()},onDidRemoveLastListener(){Qe=void 0,je.dispose()}};Ae||ne(He);const nt=new o(He);return Ae?.add(nt),nt.event}ie.debounce=W;function ae(de,we=0,Re){return ie.debounce(de,(Oe,me)=>Oe?(Oe.push(me),Oe):[me],we,void 0,!0,void 0,Re)}ie.accumulate=ae;function ee(de,we=(Oe,me)=>Oe===me,Re){let Oe=!0,me;return le(de,Ie=>{const Ae=Oe||!we(Ie,me);return Oe=!1,me=Ie,Ae},Re)}ie.latch=ee;function H(de,we,Re){return[ie.filter(de,we,Re),ie.filter(de,Oe=>!we(Oe),Re)]}ie.split=H;function L(de,we=!1,Re=[],Oe){let me=Re.slice(),Ie=de(Be=>{me?me.push(Be):je.fire(Be)});Oe&&Oe.add(Ie);const Ae=()=>{me?.forEach(Be=>je.fire(Be)),me=null},je=new o({onWillAddFirstListener(){Ie||(Ie=de(Be=>je.fire(Be)),Oe&&Oe.add(Ie))},onDidAddFirstListener(){me&&(we?setTimeout(Ae):Ae())},onDidRemoveLastListener(){Ie&&Ie.dispose(),Ie=null}});return Oe&&Oe.add(je),je.event}ie.buffer=L;function V(de,we){return(Oe,me,Ie)=>{const Ae=we(new U);return de(function(je){const Be=Ae.evaluate(je);Be!==B&&Oe.call(me,Be)},void 0,Ie)}}ie.chain=V;const B=Symbol("HaltChainable");class U{constructor(){this.f=[]}map(we){return this.f.push(we),this}forEach(we){return this.f.push(Re=>(we(Re),Re)),this}filter(we){return this.f.push(Re=>we(Re)?Re:B),this}reduce(we,Re){let Oe=Re;return this.f.push(me=>(Oe=we(Oe,me),Oe)),this}latch(we=(Re,Oe)=>Re===Oe){let Re=!0,Oe;return this.f.push(me=>{const Ie=Re||!we(me,Oe);return Re=!1,Oe=me,Ie?me:B}),this}evaluate(we){for(const Re of this.f)if(we=Re(we),we===B)break;return we}}function K(de,we,Re=Oe=>Oe){const Oe=(...je)=>Ae.fire(Re(...je)),me=()=>de.on(we,Oe),Ie=()=>de.removeListener(we,Oe),Ae=new o({onWillAddFirstListener:me,onDidRemoveLastListener:Ie});return Ae.event}ie.fromNodeEventEmitter=K;function Z(de,we,Re=Oe=>Oe){const Oe=(...je)=>Ae.fire(Re(...je)),me=()=>de.addEventListener(we,Oe),Ie=()=>de.removeEventListener(we,Oe),Ae=new o({onWillAddFirstListener:me,onDidRemoveLastListener:Ie});return Ae.event}ie.fromDOMEventEmitter=Z;function j(de){return new Promise(we=>re(de)(we))}ie.toPromise=j;function G(de){const we=new o;return de.then(Re=>{we.fire(Re)},()=>{we.fire(void 0)}).finally(()=>{we.dispose()}),we.event}ie.fromPromise=G;function se(de,we,Re){return we(Re),de(Oe=>we(Oe))}ie.runAndSubscribe=se;class fe{constructor(we,Re){this._observable=we,this.f=0,this.g=!1;const Oe={onWillAddFirstListener:()=>{we.addObserver(this)},onDidRemoveLastListener:()=>{we.removeObserver(this)}};Re||ne(Oe),this.emitter=new o(Oe),Re&&Re.add(this.emitter)}beginUpdate(we){this.f++}handlePossibleChange(we){}handleChange(we,Re){this.g=!0}endUpdate(we){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Ee(de,we){return new fe(de,we).emitter.event}ie.fromObservable=Ee;function Le(de){return(we,Re,Oe)=>{let me=0,Ie=!1;const Ae={beginUpdate(){me++},endUpdate(){me--,me===0&&(de.reportChanges(),Ie&&(Ie=!1,we.call(Re)))},handlePossibleChange(){},handleChange(){Ie=!0}};de.addObserver(Ae),de.reportChanges();const je={dispose(){de.removeObserver(Ae)}};return Oe instanceof S.$Tc?Oe.add(je):Array.isArray(Oe)&&Oe.push(je),je}}ie.fromObservableLight=Le})(E||(e.Event=E={}));class y{constructor(ne){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${ne}_${y.f++}`,y.all.add(this)}start(ne){this.g=new R.$be,this.listenerCount=ne}stop(){if(this.g){const ne=this.g.elapsed();this.durations.push(ne),this.elapsedOverall+=ne,this.invocationCount+=1,this.g=void 0}}}e.$de=y,y.all=new Set,y.f=0;let $=-1;function w(ie){const ne=$;return $=ie,{dispose(){$=ne}}}class a{constructor(ne,x,re=Math.random().toString(18).slice(2,5)){this.h=ne,this.threshold=x,this.name=re,this.g=0}dispose(){this.f?.clear()}check(ne,x){const re=this.threshold;if(re<=0||x<re)return;this.f||(this.f=new Map);const q=this.f.get(ne.value)||0;if(this.f.set(ne.value,q+1),this.g-=1,this.g<=0){this.g=re*.5;const[te,le]=this.getMostFrequentStack(),M=`[${this.name}] potential listener LEAK detected, having ${x} listeners already. MOST frequent listener (${le}):`;console.warn(M),console.warn(te);const z=new c(M,te);this.h(z)}return()=>{const te=this.f.get(ne.value)||0;this.f.set(ne.value,te-1)}}getMostFrequentStack(){if(!this.f)return;let ne,x=0;for(const[re,q]of this.f)(!ne||x<q)&&(ne=[re,q],x=q);return ne}}class f{static create(){const ne=new Error;return new f(ne.stack??"")}constructor(ne){this.value=ne}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class c extends Error{constructor(ne,x){super(ne),this.name="ListenerLeakError",this.stack=x}}e.$fe=c;class g extends Error{constructor(ne,x){super(ne),this.name="ListenerRefusalError",this.stack=x}}e.$ge=g;let p=0;class m{constructor(ne){this.value=ne,this.id=p++}}const b=2,l=(ie,ne)=>{if(ie instanceof m)ne(ie);else for(let x=0;x<ie.length;x++){const re=ie[x];re&&ne(re)}},t=A?new FinalizationRegistry(ie=>{typeof ie=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(ie))}):void 0;class o{constructor(ne){this.w=0,this.f=ne,this.g=$>0||this.f?.leakWarningThreshold?new a(ne?.onListenerError??n.$1,this.f?.leakWarningThreshold??$):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(v){const ne=this.t;queueMicrotask(()=>{l(ne,x=>x.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(ne,x,re)=>{if(this.g&&this.w>this.g.threshold**2){const z=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(z);const oe=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ce=new g(`${z}. HINT: Stack shows most frequent listener (${oe[1]}-times)`,oe[0]);return(this.f?.onListenerError||n.$1)(ce),S.$Uc.None}if(this.m)return S.$Uc.None;x&&(ne=ne.bind(x));const q=new m(ne);let te,le;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(q.stack=f.create(),te=this.g.check(q.stack,this.w+1)),v&&(q.stack=le??f.create()),this.t?this.t instanceof m?(this.u??(this.u=new i),this.t=[this.t,q]):this.t.push(q):(this.f?.onWillAddFirstListener?.(this),this.t=q,this.f?.onDidAddFirstListener?.(this)),this.w++;const M=(0,S.$Sc)(()=>{t?.unregister(M),te?.(),this.x(q)});if(re instanceof S.$Tc?re.add(M):Array.isArray(re)&&re.push(M),t){const z=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(M,z,M)}return M}),this.q}x(ne){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const x=this.t,re=x.indexOf(ne);if(re===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,x[re]=void 0;const q=this.u.current===this;if(this.w*b<=x.length){let te=0;for(let le=0;le<x.length;le++)x[le]?x[te++]=x[le]:q&&(this.u.end--,te<this.u.i&&this.u.i--);x.length=te}}y(ne,x){if(!ne)return;const re=this.f?.onListenerError||n.$1;if(!re){ne.value(x);return}try{ne.value(x)}catch(q){re(q)}}z(ne){const x=ne.current.t;for(;ne.i<ne.end;)this.y(x[ne.i++],ne.value);ne.reset()}fire(ne){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof m)this.y(this.t,ne);else{const x=this.u;x.enqueue(this,ne,this.t.length),this.z(x)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=o;const d=()=>new i;e.$ie=d;class i{constructor(){this.i=-1,this.end=0}enqueue(ne,x,re){this.i=0,this.end=re,this.current=ne,this.value=x}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class h extends o{async fireAsync(ne,x,re){if(this.t)for(this.h||(this.h=new k.$5c),l(this.t,q=>this.h.push([q.value,ne]));this.h.size>0&&!x.isCancellationRequested;){const[q,te]=this.h.shift(),le=[],M={...te,token:x,waitUntil:z=>{if(Object.isFrozen(le))throw new Error("waitUntil can NOT be called asynchronous");re&&(z=re(z,q)),le.push(z)}};try{q(M)}catch(z){(0,n.$1)(z);continue}Object.freeze(le),await Promise.allSettled(le).then(z=>{for(const oe of z)oe.status==="rejected"&&(0,n.$1)(oe.reason)})}}}e.$je=h;class u extends o{get isPaused(){return this.h!==0}constructor(ne){super(ne),this.h=0,this.s=new k.$5c,this.A=ne?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const ne=Array.from(this.s);this.s.clear(),super.fire(this.A(ne))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(ne){this.w&&(this.h!==0?this.s.push(ne):super.fire(ne))}}e.$ke=u;class D extends u{constructor(ne){super(ne),this.k=ne.delay??100}fire(ne){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(ne)}}e.$le=D;class I extends o{constructor(ne){super(ne),this.h=[],this.k=ne?.merge}fire(ne){this.hasListeners()&&(this.h.push(ne),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(x=>super.fire(x)),this.h=[]}))}}e.$me=I;class T{constructor(){this.g=!1,this.h=[],this.f=new o({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(ne){const x={event:ne,listener:null};this.h.push(x),this.g&&this.m(x);const re=()=>{this.g&&this.o(x);const q=this.h.indexOf(x);this.h.splice(q,1)};return(0,S.$Sc)((0,r.$db)(re))}j(){this.g=!0,this.h.forEach(ne=>this.m(ne))}k(){this.g=!1,this.h.forEach(ne=>this.o(ne))}m(ne){ne.listener=ne.event(x=>this.f.fire(x))}o(ne){ne.listener?.dispose(),ne.listener=null}dispose(){this.f.dispose();for(const ne of this.h)ne.listener?.dispose();this.h=[]}}e.$ne=T;class O{constructor(ne,x,re,q){this.f=new S.$Tc;const te=this.f.add(new T),le=this.f.add(new S.$4c);function M(z){le.set(z,te.add(q(z)))}for(const z of ne)M(z);this.f.add(x(z=>{M(z)})),this.f.add(re(z=>{le.deleteAndDispose(z)})),this.event=te.event}dispose(){this.f.dispose()}}e.$oe=O;class C{constructor(){this.f=[]}wrapEvent(ne,x,re){return(q,te,le)=>ne(M=>{const z=this.f[this.f.length-1];if(!x){z?z.buffers.push(()=>q.call(te,M)):q.call(te,M);return}const oe=z;if(!oe){q.call(te,x(re,M));return}oe.items??(oe.items=[]),oe.items.push(M),oe.buffers.length===0&&z.buffers.push(()=>{oe.reducedResult??(oe.reducedResult=re?oe.items.reduce(x,re):oe.items.reduce(x)),q.call(te,oe.reducedResult)})},void 0,le)}bufferEvents(ne){const x={buffers:new Array};this.f.push(x);const re=ne();return this.f.pop(),x.buffers.forEach(q=>q()),re}}e.$pe=C;class P{constructor(){this.f=!1,this.g=E.None,this.h=S.$Uc.None,this.j=new o({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(ne){this.g=ne,this.f&&(this.h.dispose(),this.h=ne(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=P;class Q{static const(ne){return new X(ne)}constructor(ne){this.g=ne,this.f=new o,this.onDidChange=this.f.event}get value(){return this.g}set value(ne){ne!==this.g&&(this.g=ne,this.f.fire(void 0))}}e.$re=Q;class X{constructor(ne){this.value=ne,this.onDidChange=E.None}}}),define(Se[19],De([1,0,6]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=A;const r=Object.freeze(function(v,s){const E=setTimeout(v.bind(s),0);return{dispose(){clearTimeout(E)}}});var S;(function(v){function s(E){return E===v.None||E===v.Cancelled||E instanceof k?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}v.isCancellationToken=s,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:r})})(S||(e.CancellationToken=S={}));class k{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?r:(this.b||(this.b=new n.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(s){this.f=void 0,this.g=void 0,this.g=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new k),this.f}cancel(){this.f?this.f instanceof k&&this.f.cancel():this.f=S.Cancelled}dispose(s=!1){s&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof k&&this.f.dispose():this.f=S.None}}e.$se=R;function A(v){const s=new R;return v.add({dispose(){s.cancel()}}),s.token}}),define(Se[168],De([1,0,19]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=S;class r{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new n.$se,s=this.b(v.token);return this.a={promise:s,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}e.$5e=r;function S(A){return A}class k{constructor(v,s){this.a=void 0,this.b=void 0,typeof v=="function"?(this.c=v,this.d=S):(this.c=s,this.d=v.getCacheKey)}get(v){const s=this.d(v);return this.b!==s&&(this.b=s,this.a=this.c(v)),this.a}}e.$7e=k;class R{get cachedValues(){return this.a}constructor(v,s){this.a=new Map,this.b=new Map,typeof v=="function"?(this.c=v,this.d=S):(this.c=s,this.d=v.getCacheKey)}get(v){const s=this.d(v);if(this.b.has(s))return this.b.get(s);const E=this.c(v);return this.a.set(v,E),this.b.set(s,E),E}}e.$8e=R}),define(Se[169],De([1,0,6,2]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=e.$iu=e.$hu=e.$gu=e.ScrollbarVisibility=void 0;var S;(function(w){w[w.Auto=1]="Auto",w[w.Hidden=2]="Hidden",w[w.Visible=3]="Visible"})(S||(e.ScrollbarVisibility=S={}));class k{constructor(a,f,c,g,p,m,b){this.c=a,this._scrollStateBrand=void 0,this.c&&(f=f|0,c=c|0,g=g|0,p=p|0,m=m|0,b=b|0),this.rawScrollLeft=g,this.rawScrollTop=b,f<0&&(f=0),g+f>c&&(g=c-f),g<0&&(g=0),p<0&&(p=0),b+p>m&&(b=m-p),b<0&&(b=0),this.width=f,this.scrollWidth=c,this.scrollLeft=g,this.height=p,this.scrollHeight=m,this.scrollTop=b}equals(a){return this.rawScrollLeft===a.rawScrollLeft&&this.rawScrollTop===a.rawScrollTop&&this.width===a.width&&this.scrollWidth===a.scrollWidth&&this.scrollLeft===a.scrollLeft&&this.height===a.height&&this.scrollHeight===a.scrollHeight&&this.scrollTop===a.scrollTop}withScrollDimensions(a,f){return new k(this.c,typeof a.width<"u"?a.width:this.width,typeof a.scrollWidth<"u"?a.scrollWidth:this.scrollWidth,f?this.rawScrollLeft:this.scrollLeft,typeof a.height<"u"?a.height:this.height,typeof a.scrollHeight<"u"?a.scrollHeight:this.scrollHeight,f?this.rawScrollTop:this.scrollTop)}withScrollPosition(a){return new k(this.c,this.width,this.scrollWidth,typeof a.scrollLeft<"u"?a.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof a.scrollTop<"u"?a.scrollTop:this.rawScrollTop)}createScrollEvent(a,f){const c=this.width!==a.width,g=this.scrollWidth!==a.scrollWidth,p=this.scrollLeft!==a.scrollLeft,m=this.height!==a.height,b=this.scrollHeight!==a.scrollHeight,l=this.scrollTop!==a.scrollTop;return{inSmoothScrolling:f,oldWidth:a.width,oldScrollWidth:a.scrollWidth,oldScrollLeft:a.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:a.height,oldScrollHeight:a.scrollHeight,oldScrollTop:a.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:c,scrollWidthChanged:g,scrollLeftChanged:p,heightChanged:m,scrollHeightChanged:b,scrollTopChanged:l}}}e.$gu=k;class R extends r.$Uc{constructor(a){super(),this._scrollableBrand=void 0,this.j=this.B(new n.$he),this.onScroll=this.j.event,this.c=a.smoothScrollDuration,this.f=a.scheduleAtNextAnimationFrame,this.g=new k(a.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(a){this.c=a}validateScrollPosition(a){return this.g.withScrollPosition(a)}getScrollDimensions(){return this.g}setScrollDimensions(a,f){const c=this.g.withScrollDimensions(a,f);this.n(c,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(a){const f=this.g.withScrollPosition(a);this.h&&(this.h.dispose(),this.h=null),this.n(f,!1)}setScrollPositionSmooth(a,f){if(this.c===0)return this.setScrollPositionNow(a);if(this.h){a={scrollLeft:typeof a.scrollLeft>"u"?this.h.to.scrollLeft:a.scrollLeft,scrollTop:typeof a.scrollTop>"u"?this.h.to.scrollTop:a.scrollTop};const c=this.g.withScrollPosition(a);if(this.h.to.scrollLeft===c.scrollLeft&&this.h.to.scrollTop===c.scrollTop)return;let g;f?g=new E(this.h.from,c,this.h.startTime,this.h.duration):g=this.h.combine(this.g,c,this.c),this.h.dispose(),this.h=g}else{const c=this.g.withScrollPosition(a);this.h=E.start(this.g,c,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const a=this.h.tick(),f=this.g.withScrollPosition(a);if(this.n(f,!0),!!this.h){if(a.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(a,f){const c=this.g;c.equals(a)||(this.g=a,this.j.fire(this.g.createScrollEvent(c,f)))}}e.$hu=R;class A{constructor(a,f,c){this.scrollLeft=a,this.scrollTop=f,this.isDone=c}}e.$iu=A;function v(w,a){const f=a-w;return function(c){return w+f*$(c)}}function s(w,a,f){return function(c){return c<f?w(c/f):a((c-f)/(1-f))}}class E{constructor(a,f,c,g){this.from=a,this.to=f,this.duration=g,this.startTime=c,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(a,f,c){if(Math.abs(a-f)>2.5*c){let p,m;return a<f?(p=a+.75*c,m=f-.75*c):(p=a-.75*c,m=f+.75*c),s(v(a,p),v(m,f),.33)}return v(a,f)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(a){this.to=a.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(a){const f=(a-this.startTime)/this.duration;if(f<1){const c=this.c(f),g=this.d(f);return new A(c,g,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(a,f,c){return E.start(a,f,c)}static start(a,f,c){c=c+10;const g=Date.now()-10;return new E(a,f,g,c)}}e.$ju=E;function y(w){return Math.pow(w,3)}function $(w){return 1-y(1-w)}}),define(Se[56],De([1,0,10,2]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=S,e.$ve=k,e.$we=R,e.$xe=A,e.$ye=s,e.$ze=E,e.$Ae=y,e.$Be=$,e.$Ce=w,e.$De=a,e.$Ee=f,e.$Fe=c,e.$Ge=g,e.$He=p,e.$Ie=m;function S(b){const l=b;return l?typeof l.read=="function":!1}function k(b){const l=b;return l?[l.on,l.pause,l.resume,l.destroy].every(t=>typeof t=="function"):!1}function R(b){const l=b;return l?k(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}function A(b,l){return new v(b,l)}class v{constructor(l,t){this.e=l,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(l){if(!this.a.destroyed){if(this.a.flowing)this.g(l);else if(this.b.data.push(l),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(l){this.a.destroyed||(this.a.flowing?this.h(l):this.b.error.push(l))}end(l){this.a.destroyed||(typeof l<"u"&&this.write(l),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(l){this.c.data.slice(0).forEach(t=>t(l))}h(l){this.c.error.length===0?(0,n.$1)(l):this.c.error.slice(0).forEach(t=>t(l))}i(){this.c.end.slice(0).forEach(l=>l())}on(l,t){if(!this.a.destroyed)switch(l){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(l,t){if(this.a.destroyed)return;let o;switch(l){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const d=o.indexOf(t);d>=0&&o.splice(d,1)}}j(){if(this.b.data.length>0){const l=this.e(this.b.data);this.g(l),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const l of this.b.error)this.h(l);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(b,l){const t=[];let o;for(;(o=b.read())!==null;)t.push(o);return l(t)}function E(b,l,t){const o=[];let d;for(;(d=b.read())!==null&&o.length<t;)o.push(d);return d===null&&o.length>0?l(o):{read:()=>{if(o.length>0)return o.shift();if(typeof d<"u"){const i=d;return d=void 0,i}return b.read()}}}function y(b,l){return new Promise((t,o)=>{const d=[];$(b,{onData:i=>{l&&d.push(i)},onError:i=>{l?o(i):t(void 0)},onEnd:()=>{t(l?l(d):void 0)}})})}function $(b,l,t){b.on("error",o=>{t?.isCancellationRequested||l.onError(o)}),b.on("end",()=>{t?.isCancellationRequested||l.onEnd()}),b.on("data",o=>{t?.isCancellationRequested||l.onData(o)})}function w(b,l){return new Promise((t,o)=>{const d=new r.$Tc,i=[],h=I=>{if(i.push(I),i.length>l)return d.dispose(),b.pause(),t({stream:b,buffer:i,ended:!1})},u=I=>(d.dispose(),o(I)),D=()=>(d.dispose(),t({stream:b,buffer:i,ended:!0}));d.add((0,r.$Sc)(()=>b.removeListener("error",u))),b.on("error",u),d.add((0,r.$Sc)(()=>b.removeListener("end",D))),b.on("end",D),d.add((0,r.$Sc)(()=>b.removeListener("data",h))),b.on("data",h)})}function a(b,l){const t=A(l);return t.end(b),t}function f(){const b=A(()=>{throw new Error("not supported")});return b.end(),b}function c(b){let l=!1;return{read:()=>l?null:(l=!0,b)}}function g(b,l,t){const o=A(t);return $(b,{onData:d=>o.write(l.data(d)),onError:d=>o.error(l.error?l.error(d):d),onEnd:()=>o.end()}),o}function p(b,l,t){let o=!1;return{read:()=>{const d=l.read();return o?d:(o=!0,d!==null?t([b,d]):b)}}}function m(b,l,t){let o=!1;const d=A(t);return $(l,{onData:i=>o?d.write(i):(o=!0,d.write(t([b,i]))),onError:i=>d.error(i),onEnd:()=>{o||(o=!0,d.write(b)),d.end()}}),d}}),define(Se[15],De([1,0,65,56]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=s,e.$Le=E,e.$Me=y,e.$Ne=$,e.$Oe=w,e.$Pe=a,e.$Qe=f,e.$Re=c,e.$Se=g,e.$Te=p,e.$Ue=m,e.$Ve=b,e.$We=l,e.$Xe=t,e.$Ye=o,e.$Ze=d,e.$1e=i,e.$2e=h,e.$3e=u,e.$4e=T;const S=typeof Buffer<"u",k=new n.$V(()=>new Uint8Array(256));let R,A;class v{static alloc(C){return S?new v(Buffer.allocUnsafe(C)):new v(new Uint8Array(C))}static wrap(C){return S&&!Buffer.isBuffer(C)&&(C=Buffer.from(C.buffer,C.byteOffset,C.byteLength)),new v(C)}static fromString(C,P){return!(P?.dontUseNodeBuffer||!1)&&S?new v(Buffer.from(C)):(R||(R=new TextEncoder),new v(R.encode(C)))}static fromByteArray(C){const P=v.alloc(C.length);for(let Q=0,X=C.length;Q<X;Q++)P.buffer[Q]=C[Q];return P}static concat(C,P){if(typeof P>"u"){P=0;for(let ie=0,ne=C.length;ie<ne;ie++)P+=C[ie].byteLength}const Q=v.alloc(P);let X=0;for(let ie=0,ne=C.length;ie<ne;ie++){const x=C[ie];Q.set(x,X),X+=x.byteLength}return Q}constructor(C){this.buffer=C,this.byteLength=this.buffer.byteLength}clone(){const C=v.alloc(this.byteLength);return C.set(this),C}toString(){return S?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(C,P){return new v(this.buffer.subarray(C,P))}set(C,P){if(C instanceof v)this.buffer.set(C.buffer,P);else if(C instanceof Uint8Array)this.buffer.set(C,P);else if(C instanceof ArrayBuffer)this.buffer.set(new Uint8Array(C),P);else if(ArrayBuffer.isView(C))this.buffer.set(new Uint8Array(C.buffer,C.byteOffset,C.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(C){return $(this.buffer,C)}writeUInt32BE(C,P){w(this.buffer,C,P)}readUInt32LE(C){return a(this.buffer,C)}writeUInt32LE(C,P){f(this.buffer,C,P)}readUInt8(C){return c(this.buffer,C)}writeUInt8(C,P){g(this.buffer,C,P)}indexOf(C,P=0){return s(this.buffer,C instanceof v?C.buffer:C,P)}}e.$Je=v;function s(O,C,P=0){const Q=C.byteLength,X=O.byteLength;if(Q===0)return 0;if(Q===1)return O.indexOf(C[0]);if(Q>X-P)return-1;const ie=k.value;ie.fill(C.length);for(let q=0;q<C.length;q++)ie[C[q]]=C.length-q-1;let ne=P+C.length-1,x=ne,re=-1;for(;ne<X;)if(O[ne]===C[x]){if(x===0){re=ne;break}ne--,x--}else ne+=Math.max(C.length-x,ie[O[ne]]),x=C.length-1;return re}function E(O,C){return O[C+0]<<0>>>0|O[C+1]<<8>>>0}function y(O,C,P){O[P+0]=C&255,C=C>>>8,O[P+1]=C&255}function $(O,C){return O[C]*2**24+O[C+1]*2**16+O[C+2]*2**8+O[C+3]}function w(O,C,P){O[P+3]=C,C=C>>>8,O[P+2]=C,C=C>>>8,O[P+1]=C,C=C>>>8,O[P]=C}function a(O,C){return O[C+0]<<0>>>0|O[C+1]<<8>>>0|O[C+2]<<16>>>0|O[C+3]<<24>>>0}function f(O,C,P){O[P+0]=C&255,C=C>>>8,O[P+1]=C&255,C=C>>>8,O[P+2]=C&255,C=C>>>8,O[P+3]=C&255}function c(O,C){return O[C]}function g(O,C,P){O[P]=C}function p(O){return r.$ye(O,C=>v.concat(C))}function m(O){return r.$Fe(O)}function b(O){return r.$Ae(O,C=>v.concat(C))}async function l(O){return O.ended?v.concat(O.buffer):v.concat([...O.buffer,await b(O.stream)])}function t(O){return r.$De(O,C=>v.concat(C))}function o(O){return r.$Ge(O,{data:C=>typeof C=="string"?v.fromString(C):v.wrap(C)},C=>v.concat(C))}function d(O){return r.$xe(C=>v.concat(C),O)}function i(O,C){return r.$He(O,C,P=>v.concat(P))}function h(O,C){return r.$Ie(O,C,P=>v.concat(P))}function u(O){let C=0,P=0,Q=0;const X=new Uint8Array(Math.floor(O.length/4*3)),ie=x=>{switch(P){case 3:X[Q++]=C|x,P=0;break;case 2:X[Q++]=C|x>>>2,C=x<<6,P=3;break;case 1:X[Q++]=C|x>>>4,C=x<<4,P=2;break;default:C=x<<2,P=1}};for(let x=0;x<O.length;x++){const re=O.charCodeAt(x);if(re>=65&&re<=90)ie(re-65);else if(re>=97&&re<=122)ie(re-97+26);else if(re>=48&&re<=57)ie(re-48+52);else if(re===43||re===45)ie(62);else if(re===47||re===95)ie(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${O[x]}`)}}const ne=Q;for(;P>0;)ie(0);return v.wrap(X).slice(0,ne)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function T({buffer:O},C=!0,P=!1){const Q=P?I:D;let X="";const ie=O.byteLength%3;let ne=0;for(;ne<O.byteLength-ie;ne+=3){const x=O[ne+0],re=O[ne+1],q=O[ne+2];X+=Q[x>>>2],X+=Q[(x<<4|re>>>4)&63],X+=Q[(re<<2|q>>>6)&63],X+=Q[q&63]}if(ie===1){const x=O[ne+0];X+=Q[x>>>2],X+=Q[x<<4&63],C&&(X+="==")}else if(ie===2){const x=O[ne+0],re=O[ne+1];X+=Q[x>>>2],X+=Q[(x<<4|re>>>4)&63],X+=Q[re<<2&63],C&&(X+="=")}return X}}),define(Se[170],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(Se[11],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=n,e.$bg=r,e.$cg=S,e.$dg=k,e.$eg=R,e.$fg=A,e.$gg=v,e.$hg=s,e.$ig=E,e.$jg=y,e.$kg=$,e.$lg=w,e.$mg=a,e.$ng=c,e.$og=g,e.$pg=p,e.$qg=m,e.$rg=b;function n(l){return typeof l=="string"}function r(l){return Array.isArray(l)&&l.every(t=>n(t))}function S(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}function k(l){const t=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof t}function R(l){return typeof l=="number"&&!isNaN(l)}function A(l){return!!l&&typeof l[Symbol.iterator]=="function"}function v(l){return l===!0||l===!1}function s(l){return typeof l>"u"}function E(l){return!y(l)}function y(l){return s(l)||l===null}function $(l,t){if(!l)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function w(l){if(y(l))throw new Error("Assertion Failed: argument is undefined or null");return l}function a(...l){const t=[];for(let o=0;o<l.length;o++){const d=l[o];if(y(d))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(d)}return t}const f=Object.prototype.hasOwnProperty;function c(l){if(!S(l))return!1;for(const t in l)if(f.call(l,t))return!1;return!0}function g(l){return typeof l=="function"}function p(...l){return l.length>0&&l.every(g)}function m(l,t){const o=Math.min(l.length,t.length);for(let d=0;d<o;d++)b(l[d],t[d])}function b(l,t){if(n(t)){if(typeof l!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(l instanceof t)return}catch{}if(!y(l)&&l.constructor===t||t.length===1&&t.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Se[109],De([1,0,11]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=S,e.$Vj=k;const r=Object.create(null);function S(R,A){if((0,n.$ag)(A)){const v=r[A];if(v===void 0)throw new Error(`${R} references an unknown codicon: ${A}`);A=v}return r[R]=A,{id:R}}function k(){return r}}),define(Se[171],De([1,0,109]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=void 0,e.$Wj={add:(0,n.$Uj)("add",6e4),plus:(0,n.$Uj)("plus",6e4),gistNew:(0,n.$Uj)("gist-new",6e4),repoCreate:(0,n.$Uj)("repo-create",6e4),lightbulb:(0,n.$Uj)("lightbulb",60001),lightBulb:(0,n.$Uj)("light-bulb",60001),repo:(0,n.$Uj)("repo",60002),repoDelete:(0,n.$Uj)("repo-delete",60002),gistFork:(0,n.$Uj)("gist-fork",60003),repoForked:(0,n.$Uj)("repo-forked",60003),gitPullRequest:(0,n.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Uj)("record-keys",60005),keyboard:(0,n.$Uj)("keyboard",60005),tag:(0,n.$Uj)("tag",60006),gitPullRequestLabel:(0,n.$Uj)("git-pull-request-label",60006),tagAdd:(0,n.$Uj)("tag-add",60006),tagRemove:(0,n.$Uj)("tag-remove",60006),person:(0,n.$Uj)("person",60007),personFollow:(0,n.$Uj)("person-follow",60007),personOutline:(0,n.$Uj)("person-outline",60007),personFilled:(0,n.$Uj)("person-filled",60007),gitBranch:(0,n.$Uj)("git-branch",60008),gitBranchCreate:(0,n.$Uj)("git-branch-create",60008),gitBranchDelete:(0,n.$Uj)("git-branch-delete",60008),sourceControl:(0,n.$Uj)("source-control",60008),mirror:(0,n.$Uj)("mirror",60009),mirrorPublic:(0,n.$Uj)("mirror-public",60009),star:(0,n.$Uj)("star",60010),starAdd:(0,n.$Uj)("star-add",60010),starDelete:(0,n.$Uj)("star-delete",60010),starEmpty:(0,n.$Uj)("star-empty",60010),comment:(0,n.$Uj)("comment",60011),commentAdd:(0,n.$Uj)("comment-add",60011),alert:(0,n.$Uj)("alert",60012),warning:(0,n.$Uj)("warning",60012),search:(0,n.$Uj)("search",60013),searchSave:(0,n.$Uj)("search-save",60013),logOut:(0,n.$Uj)("log-out",60014),signOut:(0,n.$Uj)("sign-out",60014),logIn:(0,n.$Uj)("log-in",60015),signIn:(0,n.$Uj)("sign-in",60015),eye:(0,n.$Uj)("eye",60016),eyeUnwatch:(0,n.$Uj)("eye-unwatch",60016),eyeWatch:(0,n.$Uj)("eye-watch",60016),circleFilled:(0,n.$Uj)("circle-filled",60017),primitiveDot:(0,n.$Uj)("primitive-dot",60017),closeDirty:(0,n.$Uj)("close-dirty",60017),debugBreakpoint:(0,n.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Uj)("primitive-square",60018),edit:(0,n.$Uj)("edit",60019),pencil:(0,n.$Uj)("pencil",60019),info:(0,n.$Uj)("info",60020),issueOpened:(0,n.$Uj)("issue-opened",60020),gistPrivate:(0,n.$Uj)("gist-private",60021),gitForkPrivate:(0,n.$Uj)("git-fork-private",60021),lock:(0,n.$Uj)("lock",60021),mirrorPrivate:(0,n.$Uj)("mirror-private",60021),close:(0,n.$Uj)("close",60022),removeClose:(0,n.$Uj)("remove-close",60022),x:(0,n.$Uj)("x",60022),repoSync:(0,n.$Uj)("repo-sync",60023),sync:(0,n.$Uj)("sync",60023),clone:(0,n.$Uj)("clone",60024),desktopDownload:(0,n.$Uj)("desktop-download",60024),beaker:(0,n.$Uj)("beaker",60025),microscope:(0,n.$Uj)("microscope",60025),vm:(0,n.$Uj)("vm",60026),deviceDesktop:(0,n.$Uj)("device-desktop",60026),file:(0,n.$Uj)("file",60027),fileText:(0,n.$Uj)("file-text",60027),more:(0,n.$Uj)("more",60028),ellipsis:(0,n.$Uj)("ellipsis",60028),kebabHorizontal:(0,n.$Uj)("kebab-horizontal",60028),mailReply:(0,n.$Uj)("mail-reply",60029),reply:(0,n.$Uj)("reply",60029),organization:(0,n.$Uj)("organization",60030),organizationFilled:(0,n.$Uj)("organization-filled",60030),organizationOutline:(0,n.$Uj)("organization-outline",60030),newFile:(0,n.$Uj)("new-file",60031),fileAdd:(0,n.$Uj)("file-add",60031),newFolder:(0,n.$Uj)("new-folder",60032),fileDirectoryCreate:(0,n.$Uj)("file-directory-create",60032),trash:(0,n.$Uj)("trash",60033),trashcan:(0,n.$Uj)("trashcan",60033),history:(0,n.$Uj)("history",60034),clock:(0,n.$Uj)("clock",60034),folder:(0,n.$Uj)("folder",60035),fileDirectory:(0,n.$Uj)("file-directory",60035),symbolFolder:(0,n.$Uj)("symbol-folder",60035),logoGithub:(0,n.$Uj)("logo-github",60036),markGithub:(0,n.$Uj)("mark-github",60036),github:(0,n.$Uj)("github",60036),terminal:(0,n.$Uj)("terminal",60037),console:(0,n.$Uj)("console",60037),repl:(0,n.$Uj)("repl",60037),zap:(0,n.$Uj)("zap",60038),symbolEvent:(0,n.$Uj)("symbol-event",60038),error:(0,n.$Uj)("error",60039),stop:(0,n.$Uj)("stop",60039),variable:(0,n.$Uj)("variable",60040),symbolVariable:(0,n.$Uj)("symbol-variable",60040),array:(0,n.$Uj)("array",60042),symbolArray:(0,n.$Uj)("symbol-array",60042),symbolModule:(0,n.$Uj)("symbol-module",60043),symbolPackage:(0,n.$Uj)("symbol-package",60043),symbolNamespace:(0,n.$Uj)("symbol-namespace",60043),symbolObject:(0,n.$Uj)("symbol-object",60043),symbolMethod:(0,n.$Uj)("symbol-method",60044),symbolFunction:(0,n.$Uj)("symbol-function",60044),symbolConstructor:(0,n.$Uj)("symbol-constructor",60044),symbolBoolean:(0,n.$Uj)("symbol-boolean",60047),symbolNull:(0,n.$Uj)("symbol-null",60047),symbolNumeric:(0,n.$Uj)("symbol-numeric",60048),symbolNumber:(0,n.$Uj)("symbol-number",60048),symbolStructure:(0,n.$Uj)("symbol-structure",60049),symbolStruct:(0,n.$Uj)("symbol-struct",60049),symbolParameter:(0,n.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Uj)("symbol-type-parameter",60050),symbolKey:(0,n.$Uj)("symbol-key",60051),symbolText:(0,n.$Uj)("symbol-text",60051),symbolReference:(0,n.$Uj)("symbol-reference",60052),goToFile:(0,n.$Uj)("go-to-file",60052),symbolEnum:(0,n.$Uj)("symbol-enum",60053),symbolValue:(0,n.$Uj)("symbol-value",60053),symbolRuler:(0,n.$Uj)("symbol-ruler",60054),symbolUnit:(0,n.$Uj)("symbol-unit",60054),activateBreakpoints:(0,n.$Uj)("activate-breakpoints",60055),archive:(0,n.$Uj)("archive",60056),arrowBoth:(0,n.$Uj)("arrow-both",60057),arrowDown:(0,n.$Uj)("arrow-down",60058),arrowLeft:(0,n.$Uj)("arrow-left",60059),arrowRight:(0,n.$Uj)("arrow-right",60060),arrowSmallDown:(0,n.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Uj)("arrow-small-up",60064),arrowUp:(0,n.$Uj)("arrow-up",60065),bell:(0,n.$Uj)("bell",60066),bold:(0,n.$Uj)("bold",60067),book:(0,n.$Uj)("book",60068),bookmark:(0,n.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Uj)("briefcase",60076),broadcast:(0,n.$Uj)("broadcast",60077),browser:(0,n.$Uj)("browser",60078),bug:(0,n.$Uj)("bug",60079),calendar:(0,n.$Uj)("calendar",60080),caseSensitive:(0,n.$Uj)("case-sensitive",60081),check:(0,n.$Uj)("check",60082),checklist:(0,n.$Uj)("checklist",60083),chevronDown:(0,n.$Uj)("chevron-down",60084),chevronLeft:(0,n.$Uj)("chevron-left",60085),chevronRight:(0,n.$Uj)("chevron-right",60086),chevronUp:(0,n.$Uj)("chevron-up",60087),chromeClose:(0,n.$Uj)("chrome-close",60088),chromeMaximize:(0,n.$Uj)("chrome-maximize",60089),chromeMinimize:(0,n.$Uj)("chrome-minimize",60090),chromeRestore:(0,n.$Uj)("chrome-restore",60091),circleOutline:(0,n.$Uj)("circle-outline",60092),circle:(0,n.$Uj)("circle",60092),debugBreakpointUnverified:(0,n.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Uj)("circle-slash",60093),circuitBoard:(0,n.$Uj)("circuit-board",60094),clearAll:(0,n.$Uj)("clear-all",60095),clippy:(0,n.$Uj)("clippy",60096),closeAll:(0,n.$Uj)("close-all",60097),cloudDownload:(0,n.$Uj)("cloud-download",60098),cloudUpload:(0,n.$Uj)("cloud-upload",60099),code:(0,n.$Uj)("code",60100),collapseAll:(0,n.$Uj)("collapse-all",60101),colorMode:(0,n.$Uj)("color-mode",60102),commentDiscussion:(0,n.$Uj)("comment-discussion",60103),creditCard:(0,n.$Uj)("credit-card",60105),dash:(0,n.$Uj)("dash",60108),dashboard:(0,n.$Uj)("dashboard",60109),database:(0,n.$Uj)("database",60110),debugContinue:(0,n.$Uj)("debug-continue",60111),debugDisconnect:(0,n.$Uj)("debug-disconnect",60112),debugPause:(0,n.$Uj)("debug-pause",60113),debugRestart:(0,n.$Uj)("debug-restart",60114),debugStart:(0,n.$Uj)("debug-start",60115),debugStepInto:(0,n.$Uj)("debug-step-into",60116),debugStepOut:(0,n.$Uj)("debug-step-out",60117),debugStepOver:(0,n.$Uj)("debug-step-over",60118),debugStop:(0,n.$Uj)("debug-stop",60119),debug:(0,n.$Uj)("debug",60120),deviceCameraVideo:(0,n.$Uj)("device-camera-video",60121),deviceCamera:(0,n.$Uj)("device-camera",60122),deviceMobile:(0,n.$Uj)("device-mobile",60123),diffAdded:(0,n.$Uj)("diff-added",60124),diffIgnored:(0,n.$Uj)("diff-ignored",60125),diffModified:(0,n.$Uj)("diff-modified",60126),diffRemoved:(0,n.$Uj)("diff-removed",60127),diffRenamed:(0,n.$Uj)("diff-renamed",60128),diff:(0,n.$Uj)("diff",60129),diffSidebyside:(0,n.$Uj)("diff-sidebyside",60129),discard:(0,n.$Uj)("discard",60130),editorLayout:(0,n.$Uj)("editor-layout",60131),emptyWindow:(0,n.$Uj)("empty-window",60132),exclude:(0,n.$Uj)("exclude",60133),extensions:(0,n.$Uj)("extensions",60134),eyeClosed:(0,n.$Uj)("eye-closed",60135),fileBinary:(0,n.$Uj)("file-binary",60136),fileCode:(0,n.$Uj)("file-code",60137),fileMedia:(0,n.$Uj)("file-media",60138),filePdf:(0,n.$Uj)("file-pdf",60139),fileSubmodule:(0,n.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Uj)("file-symlink-file",60142),fileZip:(0,n.$Uj)("file-zip",60143),files:(0,n.$Uj)("files",60144),filter:(0,n.$Uj)("filter",60145),flame:(0,n.$Uj)("flame",60146),foldDown:(0,n.$Uj)("fold-down",60147),foldUp:(0,n.$Uj)("fold-up",60148),fold:(0,n.$Uj)("fold",60149),folderActive:(0,n.$Uj)("folder-active",60150),folderOpened:(0,n.$Uj)("folder-opened",60151),gear:(0,n.$Uj)("gear",60152),gift:(0,n.$Uj)("gift",60153),gistSecret:(0,n.$Uj)("gist-secret",60154),gist:(0,n.$Uj)("gist",60155),gitCommit:(0,n.$Uj)("git-commit",60156),gitCompare:(0,n.$Uj)("git-compare",60157),compareChanges:(0,n.$Uj)("compare-changes",60157),gitMerge:(0,n.$Uj)("git-merge",60158),githubAction:(0,n.$Uj)("github-action",60159),githubAlt:(0,n.$Uj)("github-alt",60160),globe:(0,n.$Uj)("globe",60161),grabber:(0,n.$Uj)("grabber",60162),graph:(0,n.$Uj)("graph",60163),gripper:(0,n.$Uj)("gripper",60164),heart:(0,n.$Uj)("heart",60165),home:(0,n.$Uj)("home",60166),horizontalRule:(0,n.$Uj)("horizontal-rule",60167),hubot:(0,n.$Uj)("hubot",60168),inbox:(0,n.$Uj)("inbox",60169),issueReopened:(0,n.$Uj)("issue-reopened",60171),issues:(0,n.$Uj)("issues",60172),italic:(0,n.$Uj)("italic",60173),jersey:(0,n.$Uj)("jersey",60174),json:(0,n.$Uj)("json",60175),kebabVertical:(0,n.$Uj)("kebab-vertical",60176),key:(0,n.$Uj)("key",60177),law:(0,n.$Uj)("law",60178),lightbulbAutofix:(0,n.$Uj)("lightbulb-autofix",60179),linkExternal:(0,n.$Uj)("link-external",60180),link:(0,n.$Uj)("link",60181),listOrdered:(0,n.$Uj)("list-ordered",60182),listUnordered:(0,n.$Uj)("list-unordered",60183),liveShare:(0,n.$Uj)("live-share",60184),loading:(0,n.$Uj)("loading",60185),location:(0,n.$Uj)("location",60186),mailRead:(0,n.$Uj)("mail-read",60187),mail:(0,n.$Uj)("mail",60188),markdown:(0,n.$Uj)("markdown",60189),megaphone:(0,n.$Uj)("megaphone",60190),mention:(0,n.$Uj)("mention",60191),milestone:(0,n.$Uj)("milestone",60192),gitPullRequestMilestone:(0,n.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Uj)("mortar-board",60193),move:(0,n.$Uj)("move",60194),multipleWindows:(0,n.$Uj)("multiple-windows",60195),mute:(0,n.$Uj)("mute",60196),noNewline:(0,n.$Uj)("no-newline",60197),note:(0,n.$Uj)("note",60198),octoface:(0,n.$Uj)("octoface",60199),openPreview:(0,n.$Uj)("open-preview",60200),package:(0,n.$Uj)("package",60201),paintcan:(0,n.$Uj)("paintcan",60202),pin:(0,n.$Uj)("pin",60203),play:(0,n.$Uj)("play",60204),run:(0,n.$Uj)("run",60204),plug:(0,n.$Uj)("plug",60205),preserveCase:(0,n.$Uj)("preserve-case",60206),preview:(0,n.$Uj)("preview",60207),project:(0,n.$Uj)("project",60208),pulse:(0,n.$Uj)("pulse",60209),question:(0,n.$Uj)("question",60210),quote:(0,n.$Uj)("quote",60211),radioTower:(0,n.$Uj)("radio-tower",60212),reactions:(0,n.$Uj)("reactions",60213),references:(0,n.$Uj)("references",60214),refresh:(0,n.$Uj)("refresh",60215),regex:(0,n.$Uj)("regex",60216),remoteExplorer:(0,n.$Uj)("remote-explorer",60217),remote:(0,n.$Uj)("remote",60218),remove:(0,n.$Uj)("remove",60219),replaceAll:(0,n.$Uj)("replace-all",60220),replace:(0,n.$Uj)("replace",60221),repoClone:(0,n.$Uj)("repo-clone",60222),repoForcePush:(0,n.$Uj)("repo-force-push",60223),repoPull:(0,n.$Uj)("repo-pull",60224),repoPush:(0,n.$Uj)("repo-push",60225),report:(0,n.$Uj)("report",60226),requestChanges:(0,n.$Uj)("request-changes",60227),rocket:(0,n.$Uj)("rocket",60228),rootFolderOpened:(0,n.$Uj)("root-folder-opened",60229),rootFolder:(0,n.$Uj)("root-folder",60230),rss:(0,n.$Uj)("rss",60231),ruby:(0,n.$Uj)("ruby",60232),saveAll:(0,n.$Uj)("save-all",60233),saveAs:(0,n.$Uj)("save-as",60234),save:(0,n.$Uj)("save",60235),screenFull:(0,n.$Uj)("screen-full",60236),screenNormal:(0,n.$Uj)("screen-normal",60237),searchStop:(0,n.$Uj)("search-stop",60238),server:(0,n.$Uj)("server",60240),settingsGear:(0,n.$Uj)("settings-gear",60241),settings:(0,n.$Uj)("settings",60242),shield:(0,n.$Uj)("shield",60243),smiley:(0,n.$Uj)("smiley",60244),sortPrecedence:(0,n.$Uj)("sort-precedence",60245),splitHorizontal:(0,n.$Uj)("split-horizontal",60246),splitVertical:(0,n.$Uj)("split-vertical",60247),squirrel:(0,n.$Uj)("squirrel",60248),starFull:(0,n.$Uj)("star-full",60249),starHalf:(0,n.$Uj)("star-half",60250),symbolClass:(0,n.$Uj)("symbol-class",60251),symbolColor:(0,n.$Uj)("symbol-color",60252),symbolConstant:(0,n.$Uj)("symbol-constant",60253),symbolEnumMember:(0,n.$Uj)("symbol-enum-member",60254),symbolField:(0,n.$Uj)("symbol-field",60255),symbolFile:(0,n.$Uj)("symbol-file",60256),symbolInterface:(0,n.$Uj)("symbol-interface",60257),symbolKeyword:(0,n.$Uj)("symbol-keyword",60258),symbolMisc:(0,n.$Uj)("symbol-misc",60259),symbolOperator:(0,n.$Uj)("symbol-operator",60260),symbolProperty:(0,n.$Uj)("symbol-property",60261),wrench:(0,n.$Uj)("wrench",60261),wrenchSubaction:(0,n.$Uj)("wrench-subaction",60261),symbolSnippet:(0,n.$Uj)("symbol-snippet",60262),tasklist:(0,n.$Uj)("tasklist",60263),telescope:(0,n.$Uj)("telescope",60264),textSize:(0,n.$Uj)("text-size",60265),threeBars:(0,n.$Uj)("three-bars",60266),thumbsdown:(0,n.$Uj)("thumbsdown",60267),thumbsup:(0,n.$Uj)("thumbsup",60268),tools:(0,n.$Uj)("tools",60269),triangleDown:(0,n.$Uj)("triangle-down",60270),triangleLeft:(0,n.$Uj)("triangle-left",60271),triangleRight:(0,n.$Uj)("triangle-right",60272),triangleUp:(0,n.$Uj)("triangle-up",60273),twitter:(0,n.$Uj)("twitter",60274),unfold:(0,n.$Uj)("unfold",60275),unlock:(0,n.$Uj)("unlock",60276),unmute:(0,n.$Uj)("unmute",60277),unverified:(0,n.$Uj)("unverified",60278),verified:(0,n.$Uj)("verified",60279),versions:(0,n.$Uj)("versions",60280),vmActive:(0,n.$Uj)("vm-active",60281),vmOutline:(0,n.$Uj)("vm-outline",60282),vmRunning:(0,n.$Uj)("vm-running",60283),watch:(0,n.$Uj)("watch",60284),whitespace:(0,n.$Uj)("whitespace",60285),wholeWord:(0,n.$Uj)("whole-word",60286),window:(0,n.$Uj)("window",60287),wordWrap:(0,n.$Uj)("word-wrap",60288),zoomIn:(0,n.$Uj)("zoom-in",60289),zoomOut:(0,n.$Uj)("zoom-out",60290),listFilter:(0,n.$Uj)("list-filter",60291),listFlat:(0,n.$Uj)("list-flat",60292),listSelection:(0,n.$Uj)("list-selection",60293),selection:(0,n.$Uj)("selection",60293),listTree:(0,n.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Uj)("symbol-string",60301),debugReverseContinue:(0,n.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Uj)("debug-step-back",60303),debugRestartFrame:(0,n.$Uj)("debug-restart-frame",60304),debugAlt:(0,n.$Uj)("debug-alt",60305),callIncoming:(0,n.$Uj)("call-incoming",60306),callOutgoing:(0,n.$Uj)("call-outgoing",60307),menu:(0,n.$Uj)("menu",60308),expandAll:(0,n.$Uj)("expand-all",60309),feedback:(0,n.$Uj)("feedback",60310),gitPullRequestReviewer:(0,n.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Uj)("ungroup-by-ref-type",60312),account:(0,n.$Uj)("account",60313),gitPullRequestAssignee:(0,n.$Uj)("git-pull-request-assignee",60313),bellDot:(0,n.$Uj)("bell-dot",60314),debugConsole:(0,n.$Uj)("debug-console",60315),library:(0,n.$Uj)("library",60316),output:(0,n.$Uj)("output",60317),runAll:(0,n.$Uj)("run-all",60318),syncIgnored:(0,n.$Uj)("sync-ignored",60319),pinned:(0,n.$Uj)("pinned",60320),githubInverted:(0,n.$Uj)("github-inverted",60321),serverProcess:(0,n.$Uj)("server-process",60322),serverEnvironment:(0,n.$Uj)("server-environment",60323),pass:(0,n.$Uj)("pass",60324),issueClosed:(0,n.$Uj)("issue-closed",60324),stopCircle:(0,n.$Uj)("stop-circle",60325),playCircle:(0,n.$Uj)("play-circle",60326),record:(0,n.$Uj)("record",60327),debugAltSmall:(0,n.$Uj)("debug-alt-small",60328),vmConnect:(0,n.$Uj)("vm-connect",60329),cloud:(0,n.$Uj)("cloud",60330),merge:(0,n.$Uj)("merge",60331),export:(0,n.$Uj)("export",60332),graphLeft:(0,n.$Uj)("graph-left",60333),magnet:(0,n.$Uj)("magnet",60334),notebook:(0,n.$Uj)("notebook",60335),redo:(0,n.$Uj)("redo",60336),checkAll:(0,n.$Uj)("check-all",60337),pinnedDirty:(0,n.$Uj)("pinned-dirty",60338),passFilled:(0,n.$Uj)("pass-filled",60339),circleLargeFilled:(0,n.$Uj)("circle-large-filled",60340),circleLarge:(0,n.$Uj)("circle-large",60341),circleLargeOutline:(0,n.$Uj)("circle-large-outline",60341),combine:(0,n.$Uj)("combine",60342),gather:(0,n.$Uj)("gather",60342),table:(0,n.$Uj)("table",60343),variableGroup:(0,n.$Uj)("variable-group",60344),typeHierarchy:(0,n.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Uj)("git-pull-request-create",60348),runAbove:(0,n.$Uj)("run-above",60349),runBelow:(0,n.$Uj)("run-below",60350),notebookTemplate:(0,n.$Uj)("notebook-template",60351),debugRerun:(0,n.$Uj)("debug-rerun",60352),workspaceTrusted:(0,n.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Uj)("workspace-unknown",60355),terminalCmd:(0,n.$Uj)("terminal-cmd",60356),terminalDebian:(0,n.$Uj)("terminal-debian",60357),terminalLinux:(0,n.$Uj)("terminal-linux",60358),terminalPowershell:(0,n.$Uj)("terminal-powershell",60359),terminalTmux:(0,n.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Uj)("terminal-ubuntu",60361),terminalBash:(0,n.$Uj)("terminal-bash",60362),arrowSwap:(0,n.$Uj)("arrow-swap",60363),copy:(0,n.$Uj)("copy",60364),personAdd:(0,n.$Uj)("person-add",60365),filterFilled:(0,n.$Uj)("filter-filled",60366),wand:(0,n.$Uj)("wand",60367),debugLineByLine:(0,n.$Uj)("debug-line-by-line",60368),inspect:(0,n.$Uj)("inspect",60369),layers:(0,n.$Uj)("layers",60370),layersDot:(0,n.$Uj)("layers-dot",60371),layersActive:(0,n.$Uj)("layers-active",60372),compass:(0,n.$Uj)("compass",60373),compassDot:(0,n.$Uj)("compass-dot",60374),compassActive:(0,n.$Uj)("compass-active",60375),azure:(0,n.$Uj)("azure",60376),issueDraft:(0,n.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Uj)("git-pull-request-draft",60379),debugAll:(0,n.$Uj)("debug-all",60380),debugCoverage:(0,n.$Uj)("debug-coverage",60381),runErrors:(0,n.$Uj)("run-errors",60382),folderLibrary:(0,n.$Uj)("folder-library",60383),debugContinueSmall:(0,n.$Uj)("debug-continue-small",60384),beakerStop:(0,n.$Uj)("beaker-stop",60385),graphLine:(0,n.$Uj)("graph-line",60386),graphScatter:(0,n.$Uj)("graph-scatter",60387),pieChart:(0,n.$Uj)("pie-chart",60388),bracket:(0,n.$Uj)("bracket",60175),bracketDot:(0,n.$Uj)("bracket-dot",60389),bracketError:(0,n.$Uj)("bracket-error",60390),lockSmall:(0,n.$Uj)("lock-small",60391),azureDevops:(0,n.$Uj)("azure-devops",60392),verifiedFilled:(0,n.$Uj)("verified-filled",60393),newline:(0,n.$Uj)("newline",60394),layout:(0,n.$Uj)("layout",60395),layoutActivitybarLeft:(0,n.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Uj)("layout-panel-right",60401),layoutPanel:(0,n.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Uj)("layout-statusbar",60405),layoutMenubar:(0,n.$Uj)("layout-menubar",60406),layoutCentered:(0,n.$Uj)("layout-centered",60407),target:(0,n.$Uj)("target",60408),indent:(0,n.$Uj)("indent",60409),recordSmall:(0,n.$Uj)("record-small",60410),errorSmall:(0,n.$Uj)("error-small",60411),terminalDecorationError:(0,n.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Uj)("layout-sidebar-left-off",60418),blank:(0,n.$Uj)("blank",60419),heartFilled:(0,n.$Uj)("heart-filled",60420),map:(0,n.$Uj)("map",60421),mapHorizontal:(0,n.$Uj)("map-horizontal",60421),foldHorizontal:(0,n.$Uj)("fold-horizontal",60421),mapFilled:(0,n.$Uj)("map-filled",60422),mapHorizontalFilled:(0,n.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Uj)("circle-small",60423),bellSlash:(0,n.$Uj)("bell-slash",60424),bellSlashDot:(0,n.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Uj)("search-fuzzy",60429),commentDraft:(0,n.$Uj)("comment-draft",60430),send:(0,n.$Uj)("send",60431),sparkle:(0,n.$Uj)("sparkle",60432),insert:(0,n.$Uj)("insert",60433),mic:(0,n.$Uj)("mic",60434),thumbsdownFilled:(0,n.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Uj)("thumbsup-filled",60436),coffee:(0,n.$Uj)("coffee",60437),snake:(0,n.$Uj)("snake",60438),game:(0,n.$Uj)("game",60439),vr:(0,n.$Uj)("vr",60440),chip:(0,n.$Uj)("chip",60441),piano:(0,n.$Uj)("piano",60442),music:(0,n.$Uj)("music",60443),micFilled:(0,n.$Uj)("mic-filled",60444),repoFetch:(0,n.$Uj)("repo-fetch",60445),copilot:(0,n.$Uj)("copilot",60446),lightbulbSparkle:(0,n.$Uj)("lightbulb-sparkle",60447),robot:(0,n.$Uj)("robot",60448),sparkleFilled:(0,n.$Uj)("sparkle-filled",60449),diffSingle:(0,n.$Uj)("diff-single",60450),diffMultiple:(0,n.$Uj)("diff-multiple",60451),surroundWith:(0,n.$Uj)("surround-with",60452),share:(0,n.$Uj)("share",60453),gitStash:(0,n.$Uj)("git-stash",60454),gitStashApply:(0,n.$Uj)("git-stash-apply",60455),gitStashPop:(0,n.$Uj)("git-stash-pop",60456),vscode:(0,n.$Uj)("vscode",60457),vscodeInsiders:(0,n.$Uj)("vscode-insiders",60458),codeOss:(0,n.$Uj)("code-oss",60459),runCoverage:(0,n.$Uj)("run-coverage",60460),runAllCoverage:(0,n.$Uj)("run-all-coverage",60461),coverage:(0,n.$Uj)("coverage",60462),githubProject:(0,n.$Uj)("github-project",60463),mapVertical:(0,n.$Uj)("map-vertical",60464),foldVertical:(0,n.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Uj)("fold-vertical-filled",60465),goToSearch:(0,n.$Uj)("go-to-search",60466),percentage:(0,n.$Uj)("percentage",60467),sortPercentage:(0,n.$Uj)("sort-percentage",60467),attach:(0,n.$Uj)("attach",60468)}}),define(Se[57],De([1,0,109,171]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=void 0,e.$Xj=S;function S(){return Object.values(e.$Zj)}e.$Yj={dialogError:(0,n.$Uj)("dialog-error","error"),dialogWarning:(0,n.$Uj)("dialog-warning","warning"),dialogInfo:(0,n.$Uj)("dialog-info","info"),dialogClose:(0,n.$Uj)("dialog-close","close"),treeItemExpanded:(0,n.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Uj)("tree-item-loading","loading"),menuSelection:(0,n.$Uj)("menu-selection","check"),menuSubmenu:(0,n.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Uj)("toolbar-more","more"),quickInputBack:(0,n.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Uj)("drop-down-button",60084),symbolCustomColor:(0,n.$Uj)("symbol-customcolor",60252),exportIcon:(0,n.$Uj)("export",60332),workspaceUnspecified:(0,n.$Uj)("workspace-unspecified",60355),newLine:(0,n.$Uj)("newline",60394),thumbsDownFilled:(0,n.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Uj)("thumbsup-filled",60436),gitFetch:(0,n.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Uj)("debug-breakpoint-pending",60377)},e.$Zj={...r.$Wj,...e.$Yj}}),define(Se[21],De([1,0,11]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=r,e.$$n=S,e.$_n=R,e.$ao=v,e.$bo=s,e.$co=E,e.$do=y,e.$eo=$,e.$fo=w,e.$go=a,e.$ho=f,e.$io=c,e.$jo=g;function r(p){if(!p||typeof p!="object"||p instanceof RegExp)return p;const m=Array.isArray(p)?[]:{};return Object.entries(p).forEach(([b,l])=>{m[b]=l&&typeof l=="object"?r(l):l}),m}function S(p){if(!p||typeof p!="object")return p;const m=[p];for(;m.length>0;){const b=m.shift();Object.freeze(b);for(const l in b)if(k.call(b,l)){const t=b[l];typeof t=="object"&&!Object.isFrozen(t)&&!(0,n.$dg)(t)&&m.push(t)}}return p}const k=Object.prototype.hasOwnProperty;function R(p,m){return A(p,m,new Set)}function A(p,m,b){if((0,n.$jg)(p))return p;const l=m(p);if(typeof l<"u")return l;if(Array.isArray(p)){const t=[];for(const o of p)t.push(A(o,m,b));return t}if((0,n.$cg)(p)){if(b.has(p))throw new Error("Cannot clone recursive data-structure");b.add(p);const t={};for(const o in p)k.call(p,o)&&(t[o]=A(p[o],m,b));return b.delete(p),t}return p}function v(p,m,b=!0){return(0,n.$cg)(p)?((0,n.$cg)(m)&&Object.keys(m).forEach(l=>{l in p?b&&((0,n.$cg)(p[l])&&(0,n.$cg)(m[l])?v(p[l],m[l],b):p[l]=m[l]):p[l]=m[l]}),p):m}function s(p,m){if(p===m)return!0;if(p==null||m===null||m===void 0||typeof p!=typeof m||typeof p!="object"||Array.isArray(p)!==Array.isArray(m))return!1;let b,l;if(Array.isArray(p)){if(p.length!==m.length)return!1;for(b=0;b<p.length;b++)if(!s(p[b],m[b]))return!1}else{const t=[];for(l in p)t.push(l);t.sort();const o=[];for(l in m)o.push(l);if(o.sort(),!s(t,o))return!1;for(b=0;b<t.length;b++)if(!s(p[t[b]],m[t[b]]))return!1}return!0}function E(p){const m=new Set;return JSON.stringify(p,(b,l)=>{if((0,n.$cg)(l)||Array.isArray(l)){if(m.has(l))return"[Circular]";m.add(l)}return typeof l=="bigint"?`[BigInt ${l.toString()}]`:l})}function y(p,m){const b=Object.create(null);return!p||!m||Object.keys(m).forEach(t=>{const o=p[t],d=m[t];s(o,d)||(b[t]=d)}),b}function $(p,m){const b=m.toLowerCase(),l=Object.keys(p).find(t=>t.toLowerCase()===b);return l?p[l]:p[m]}function w(p,m){const b=Object.create(null);for(const[l,t]of Object.entries(p))m(l,t)&&(b[l]=t);return b}function a(p){let m=[];for(;Object.prototype!==p;)m=m.concat(Object.getOwnPropertyNames(p)),p=Object.getPrototypeOf(p);return m}function f(p){const m=[];for(const b of a(p))typeof p[b]=="function"&&m.push(b);return m}function c(p,m){const b=t=>function(){const o=Array.prototype.slice.call(arguments,0);return m(t,o)},l={};for(const t of p)l[t]=b(t);return l}function g(p,m){const b={};for(const[l,t]of Object.entries(p))b[l]=m(t,l);return b}}),define(Se[81],De([1,0,57]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=S;var r;(function(R){function A(v){return v&&typeof v=="object"&&typeof v.id=="string"}R.isThemeColor=A})(r||(e.ThemeColor=r={}));function S(R){return{id:R}}var k;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function v(p){const m=A.exec(p.id);if(!m)return v(n.$Zj.error);const[,b,l]=m,t=["codicon","codicon-"+b];return l&&t.push("codicon-modifier-"+l.substring(1)),t}R.asClassNameArray=v;function s(p){return v(p).join(" ")}R.asClassName=s;function E(p){return"."+v(p).join(".")}R.asCSSSelector=E;function y(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||r.isThemeColor(p.color))}R.isThemeIcon=y;const $=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function w(p){const m=$.exec(p);if(!m)return;const[,b]=m;return{id:b}}R.fromString=w;function a(p){return{id:p}}R.fromId=a;function f(p,m){let b=p.id;const l=b.lastIndexOf("~");return l!==-1&&(b=b.substring(0,l)),m&&(b=`${b}~${m}`),{id:b}}R.modify=f;function c(p){const m=p.id.lastIndexOf("~");if(m!==-1)return p.id.substring(m+1)}R.getModifier=c;function g(p,m){return p.id===m.id&&p.color?.id===m.color?.id}R.isEqual=g})(k||(e.ThemeIcon=k={}))}),define(Se[110],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=r,e.$0e=S;var n;(function(k){k[k.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",k[k.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",k[k.MAX_UINT_8=255]="MAX_UINT_8",k[k.MAX_UINT_16=65535]="MAX_UINT_16",k[k.MAX_UINT_32=4294967295]="MAX_UINT_32",k[k.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(n||(e.Constants=n={}));function r(k){return k<0?0:k>n.MAX_UINT_8?n.MAX_UINT_8:k|0}function S(k){return k<0?0:k>n.MAX_UINT_32?n.MAX_UINT_32:k|0}}),define(Se[17],De([1,0,168,35,65,110]),function(he,e,n,r,S,k){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=A,e.$_e=s,e.$af=y,e.$bf=$,e.$cf=w,e.$df=a,e.$ef=f,e.$ff=c,e.$gf=g,e.$hf=p,e.$if=m,e.$jf=b,e.$kf=l,e.$lf=t,e.$mf=o,e.$nf=d,e.$of=i,e.$pf=h,e.$qf=u,e.$rf=D,e.$sf=I,e.$tf=T,e.$uf=O,e.$vf=C,e.$wf=P,e.$xf=Q,e.$yf=X,e.$zf=ie,e.$Af=ne,e.$Bf=x,e.$Cf=re,e.$Df=q,e.$Ef=te,e.$Ff=le,e.$Gf=M,e.$Hf=z,e.$If=oe,e.$Lf=ae,e.$Mf=ee,e.$Nf=H,e.$Of=L,e.$Pf=U,e.$Qf=Z,e.$Sf=j,e.$Tf=G,e.$Uf=se,e.$Vf=fe,e.$Wf=Le,e.$Xf=de,e.$Yf=Re,e.$1f=Oe,e.$2f=me,e.$3f=Ie,e.$4f=Ae,e.$5f=je,e.$6f=Be,e.$7f=Je,e.$8f=We,e.$9f=rt;function A(ve){return!ve||typeof ve!="string"?!0:ve.trim().length===0}const v=/{(\d+)}/g;function s(ve,...ge){return ge.length===0?ve:ve.replace(v,function(be,Y){const _=parseInt(Y,10);return isNaN(_)||_<0||_>=ge.length?be:ge[_]})}const E=/{([^}]+)}/g;function y(ve,ge){return Object.keys(ge).length===0?ve:ve.replace(E,(be,Y)=>ge[Y]??be)}function $(ve){return ve.replace(/[<>"'&]/g,ge=>{switch(ge){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ge})}function w(ve){return ve.replace(/[<>&]/g,function(ge){switch(ge){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ge}})}function a(ve){return ve.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function f(ve,ge){let be=0,Y=ve.indexOf(ge);for(;Y!==-1;)be++,Y=ve.indexOf(ge,Y+ge.length);return be}function c(ve,ge,be="\u2026"){return ve.length<=ge?ve:`${ve.substr(0,ge)}${be}`}function g(ve,ge,be="\u2026"){if(ve.length<=ge)return ve;const Y=Math.ceil(ge/2)-be.length/2,_=Math.floor(ge/2)-be.length/2;return`${ve.substr(0,Y)}${be}${ve.substr(ve.length-_)}`}function p(ve,ge=" "){const be=m(ve,ge);return b(be,ge)}function m(ve,ge){if(!ve||!ge)return ve;const be=ge.length;if(be===0||ve.length===0)return ve;let Y=0;for(;ve.indexOf(ge,Y)===Y;)Y=Y+be;return ve.substring(Y)}function b(ve,ge){if(!ve||!ge)return ve;const be=ge.length,Y=ve.length;if(be===0||Y===0)return ve;let _=Y,ye=-1;for(;ye=ve.lastIndexOf(ge,_-1),!(ye===-1||ye+be!==_);){if(ye===0)return"";_=ye}return ve.substring(0,_)}function l(ve){return ve.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(ve){return ve.replace(/\*/g,"")}function o(ve,ge,be={}){if(!ve)throw new Error("Cannot create regex from empty string");ge||(ve=a(ve)),be.wholeWord&&(/\B/.test(ve.charAt(0))||(ve="\\b"+ve),/\B/.test(ve.charAt(ve.length-1))||(ve=ve+"\\b"));let Y="";return be.global&&(Y+="g"),be.matchCase||(Y+="i"),be.multiline&&(Y+="m"),be.unicode&&(Y+="u"),new RegExp(ve,Y)}function d(ve){return ve.source==="^"||ve.source==="^$"||ve.source==="$"||ve.source==="^\\s*$"?!1:!!(ve.exec("")&&ve.lastIndex===0)}function i(ve){return ve.split(/\r\n|\r|\n/)}function h(ve){const ge=[],be=ve.split(/(\r\n|\r|\n)/);for(let Y=0;Y<Math.ceil(be.length/2);Y++)ge.push(be[2*Y]+(be[2*Y+1]??""));return ge}function u(ve){for(let ge=0,be=ve.length;ge<be;ge++){const Y=ve.charCodeAt(ge);if(Y!==r.CharCode.Space&&Y!==r.CharCode.Tab)return ge}return-1}function D(ve,ge=0,be=ve.length){for(let Y=ge;Y<be;Y++){const _=ve.charCodeAt(Y);if(_!==r.CharCode.Space&&_!==r.CharCode.Tab)return ve.substring(ge,Y)}return ve.substring(ge,be)}function I(ve,ge=ve.length-1){for(let be=ge;be>=0;be--){const Y=ve.charCodeAt(be);if(Y!==r.CharCode.Space&&Y!==r.CharCode.Tab)return be}return-1}function T(ve,ge,be){const Y=[];let _=0;for(const ye of ve.matchAll(ge)){if(Y.push(ve.slice(_,ye.index)),ye.index===void 0)throw new Error("match.index should be defined");_=ye.index+ye[0].length,Y.push(be(ye[0],...ye.slice(1),ye.index,ve,ye.groups))}return Y.push(ve.slice(_)),Promise.all(Y).then(ye=>ye.join(""))}function O(ve,ge){return ve<ge?-1:ve>ge?1:0}function C(ve,ge,be=0,Y=ve.length,_=0,ye=ge.length){for(;be<Y&&_<ye;be++,_++){const Ye=ve.charCodeAt(be),_e=ge.charCodeAt(_);if(Ye<_e)return-1;if(Ye>_e)return 1}const Me=Y-be,Ve=ye-_;return Me<Ve?-1:Me>Ve?1:0}function P(ve,ge){return Q(ve,ge,0,ve.length,0,ge.length)}function Q(ve,ge,be=0,Y=ve.length,_=0,ye=ge.length){for(;be<Y&&_<ye;be++,_++){let Ye=ve.charCodeAt(be),_e=ge.charCodeAt(_);if(Ye===_e)continue;if(Ye>=128||_e>=128)return C(ve.toLowerCase(),ge.toLowerCase(),be,Y,_,ye);ie(Ye)&&(Ye-=32),ie(_e)&&(_e-=32);const ot=Ye-_e;if(ot!==0)return ot}const Me=Y-be,Ve=ye-_;return Me<Ve?-1:Me>Ve?1:0}function X(ve){return ve>=r.CharCode.Digit0&&ve<=r.CharCode.Digit9}function ie(ve){return ve>=r.CharCode.a&&ve<=r.CharCode.z}function ne(ve){return ve>=r.CharCode.A&&ve<=r.CharCode.Z}function x(ve,ge){return ve.length===ge.length&&Q(ve,ge)===0}function re(ve,ge){const be=ge.length;return ge.length>ve.length?!1:Q(ve,ge,0,be)===0}function q(ve,ge){const be=Math.min(ve.length,ge.length);let Y;for(Y=0;Y<be;Y++)if(ve.charCodeAt(Y)!==ge.charCodeAt(Y))return Y;return be}function te(ve,ge){const be=Math.min(ve.length,ge.length);let Y;const _=ve.length-1,ye=ge.length-1;for(Y=0;Y<be;Y++)if(ve.charCodeAt(_-Y)!==ge.charCodeAt(ye-Y))return Y;return be}function le(ve){return 55296<=ve&&ve<=56319}function M(ve){return 56320<=ve&&ve<=57343}function z(ve,ge){return(ve-55296<<10)+(ge-56320)+65536}function oe(ve,ge,be){const Y=ve.charCodeAt(be);if(le(Y)&&be+1<ge){const _=ve.charCodeAt(be+1);if(M(_))return z(Y,_)}return Y}function ce(ve,ge){const be=ve.charCodeAt(ge-1);if(M(be)&&ge>1){const Y=ve.charCodeAt(ge-2);if(le(Y))return z(Y,be)}return be}class pe{get offset(){return this.e}constructor(ge,be=0){this.c=ge,this.d=ge.length,this.e=be}setOffset(ge){this.e=ge}prevCodePoint(){const ge=ce(this.c,this.e);return this.e-=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}nextCodePoint(){const ge=oe(this.c,this.d,this.e);return this.e+=ge>=k.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,ge}eol(){return this.e>=this.d}}e.$Jf=pe;class W{get offset(){return this.c.offset}constructor(ge,be=0){this.c=new pe(ge,be)}nextGraphemeLength(){const ge=nt.getInstance(),be=this.c,Y=be.offset;let _=ge.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const ye=be.offset,Me=ge.getGraphemeBreakType(be.nextCodePoint());if(Qe(_,Me)){be.setOffset(ye);break}_=Me}return be.offset-Y}prevGraphemeLength(){const ge=nt.getInstance(),be=this.c,Y=be.offset;let _=ge.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const ye=be.offset,Me=ge.getGraphemeBreakType(be.prevCodePoint());if(Qe(Me,_)){be.setOffset(ye);break}_=Me}return Y-be.offset}eol(){return this.c.eol()}}e.$Kf=W;function ae(ve,ge){return new W(ve,ge).nextGraphemeLength()}function ee(ve,ge){return new W(ve,ge).prevGraphemeLength()}function H(ve,ge){ge>0&&M(ve.charCodeAt(ge))&&ge--;const be=ge+ae(ve,ge);return[be-ee(ve,be),be]}function L(ve){const ge=new W(ve);let be=0;for(;!ge.eol();)be++,ge.nextGraphemeLength();return be}let V;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(ve){return V||(V=B()),V.test(ve)}const K=/^[\t\n\r\x20-\x7E]*$/;function Z(ve){return K.test(ve)}e.$Rf=/[\u2028\u2029]/;function j(ve){return e.$Rf.test(ve)}function G(ve){return ve>=11904&&ve<=55215||ve>=63744&&ve<=64255||ve>=65281&&ve<=65374}function se(ve){return ve>=127462&&ve<=127487||ve===8986||ve===8987||ve===9200||ve===9203||ve>=9728&&ve<=10175||ve===11088||ve===11093||ve>=127744&&ve<=128591||ve>=128640&&ve<=128764||ve>=128992&&ve<=129008||ve>=129280&&ve<=129535||ve>=129648&&ve<=129782}function fe(ve,ge,be=""){const Y=ve.trimStart();if(Y.length<ge)return Y;const _=/\b/g;let ye=0;for(;_.test(Y)&&!(Y.length-_.lastIndex<ge);)ye=_.lastIndex,_.lastIndex+=1;return ye===0?Y:be+Y.substring(ye).trimStart()}const Ee=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*Le(ve){let ge=0;for(const be of ve.matchAll(Ee))ge!==be.index&&(yield{isCode:!1,str:ve.substring(ge,be.index)}),yield{isCode:!0,str:be[0]},ge=be.index+be[0].length;ge!==ve.length&&(yield{isCode:!1,str:ve.substring(ge)})}function de(ve){return ve&&(ve=ve.replace(Ee,"")),ve}const we=/\\\[.*?\\\]/g;function Re(ve){return de(ve).replace(we,"")}e.$Zf=String.fromCharCode(r.CharCode.UTF8_BOM);function Oe(ve){return!!(ve&&ve.length>0&&ve.charCodeAt(0)===r.CharCode.UTF8_BOM)}function me(ve){return Oe(ve)?ve.substr(1):ve}function Ie(ve,ge){if(!ve||!ge||ve.length<ge.length)return!1;const be=ge.length,Y=ve.toLowerCase();let _=0,ye=-1;for(;_<be;){const Me=Y.indexOf(ge[_],ye+1);if(Me<0)return!1;ye=Me,_++}return!0}function Ae(ve,ge=!1){return ve?(ge&&(ve=ve.replace(/\\./g,"")),ve.toLowerCase()!==ve):!1}function je(ve){return ve.charAt(0).toUpperCase()+ve.slice(1)}function Be(ve,ge=1){if(ge===0)return"";let be=-1;do be=ve.indexOf(`
`,be+1),ge--;while(ge>0&&be>=0);return be===-1?ve:(ve[be-1]==="\r"&&be--,ve.substr(0,be))}function Je(ve){const ge=r.CharCode.Z-r.CharCode.A+1;return ve=ve%(2*ge),ve<ge?String.fromCharCode(r.CharCode.a+ve):String.fromCharCode(r.CharCode.A+ve-ge)}function We(ve){return nt.getInstance().getGraphemeBreakType(ve)}function Qe(ve,ge){return ve===He.Other?ge!==He.Extend&&ge!==He.SpacingMark:ve===He.CR&&ge===He.LF?!1:ve===He.Control||ve===He.CR||ve===He.LF||ge===He.Control||ge===He.CR||ge===He.LF?!0:!(ve===He.L&&(ge===He.L||ge===He.V||ge===He.LV||ge===He.LVT)||(ve===He.LV||ve===He.V)&&(ge===He.V||ge===He.T)||(ve===He.LVT||ve===He.T)&&ge===He.T||ge===He.Extend||ge===He.ZWJ||ge===He.SpacingMark||ve===He.Prepend||ve===He.ZWJ&&ge===He.Extended_Pictographic||ve===He.Regional_Indicator&&ge===He.Regional_Indicator)}var He;(function(ve){ve[ve.Other=0]="Other",ve[ve.Prepend=1]="Prepend",ve[ve.CR=2]="CR",ve[ve.LF=3]="LF",ve[ve.Control=4]="Control",ve[ve.Extend=5]="Extend",ve[ve.Regional_Indicator=6]="Regional_Indicator",ve[ve.SpacingMark=7]="SpacingMark",ve[ve.L=8]="L",ve[ve.V=9]="V",ve[ve.T=10]="T",ve[ve.LV=11]="LV",ve[ve.LVT=12]="LVT",ve[ve.ZWJ=13]="ZWJ",ve[ve.Extended_Pictographic=14]="Extended_Pictographic"})(He||(e.GraphemeBreakType=He={}));class nt{static getInstance(){return nt.c||(nt.c=new nt),nt.c}constructor(){this.d=et()}getGraphemeBreakType(ge){if(ge<32)return ge===r.CharCode.LineFeed?He.LF:ge===r.CharCode.CarriageReturn?He.CR:He.Control;if(ge<127)return He.Other;const be=this.d,Y=be.length/3;let _=1;for(;_<=Y;)if(ge<be[3*_])_=2*_;else if(ge>be[3*_+1])_=2*_+1;else return be[3*_+2];return He.Other}}nt.c=null;function et(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function rt(ve,ge){if(ve===0)return 0;const be=lt(ve,ge);if(be!==void 0)return be;const Y=new pe(ge,ve);return Y.prevCodePoint(),Y.offset}function lt(ve,ge){const be=new pe(ge,ve);let Y=be.prevCodePoint();for(;tt(Y)||Y===Xe.emojiVariantSelector||Y===Xe.enclosingKeyCap;){if(be.offset===0)return;Y=be.prevCodePoint()}if(!se(Y))return;let _=be.offset;return _>0&&be.prevCodePoint()===Xe.zwj&&(_=be.offset),_}function tt(ve){return 127995<=ve&&ve<=127999}var Xe;(function(ve){ve[ve.zwj=8205]="zwj",ve[ve.emojiVariantSelector=65039]="emojiVariantSelector",ve[ve.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.$0f="\xA0";class Ge{static getInstance(ge){return R.d.get(Array.from(ge))}static getLocales(){return R.e.value}constructor(ge){this.f=ge}isAmbiguous(ge){return this.f.has(ge)}containsAmbiguousCharacter(ge){for(let be=0;be<ge.length;be++){const Y=ge.codePointAt(be);if(typeof Y=="number"&&this.isAmbiguous(Y))return!0}return!1}getPrimaryConfusable(ge){return this.f.get(ge)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=Ge,R=Ge,Ge.c=new S.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Ge.d=new n.$7e({getCacheKey:JSON.stringify},ve=>{function ge(_e){const ot=new Map;for(let ht=0;ht<_e.length;ht+=2)ot.set(_e[ht],_e[ht+1]);return ot}function be(_e,ot){const ht=new Map(_e);for(const[gt,Ct]of ot)ht.set(gt,Ct);return ht}function Y(_e,ot){if(!_e)return ot;const ht=new Map;for(const[gt,Ct]of _e)ot.has(gt)&&ht.set(gt,Ct);return ht}const _=R.c.value;let ye=ve.filter(_e=>!_e.startsWith("_")&&_e in _);ye.length===0&&(ye=["_default"]);let Me;for(const _e of ye){const ot=ge(_[_e]);Me=Y(Me,ot)}const Ve=ge(_._common),Ye=be(Ve,Me);return new R(Ye)}),Ge.e=new S.$V(()=>Object.keys(R.c.value).filter(ve=>!ve.startsWith("_")));class xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(xe.c())),this.d}static isInvisibleCharacter(ge){return xe.e().has(ge)}static containsInvisibleCharacter(ge){for(let be=0;be<ge.length;be++){const Y=ge.codePointAt(be);if(typeof Y=="number"&&xe.isInvisibleCharacter(Y))return!0}return!1}static get codePoints(){return xe.e()}}e.$_f=xe,xe.d=void 0}),define(Se[37],De([1,0,35,9,3,17,11]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=A,e.$tg=v,e.$ug=s,e.$vg=E,e.$wg=y,e.$xg=f,e.$yg=c,e.$zg=g,e.$Ag=p,e.$Bg=m,e.$Cg=b,e.$Dg=l,e.$Eg=t,e.$Fg=o,e.$Gg=d,e.$Hg=i,e.$Ig=D;function A(I){return I===n.CharCode.Slash||I===n.CharCode.Backslash}function v(I){return I.replace(/[\\/]/g,r.$gc.sep)}function s(I){return I.indexOf("/")===-1&&(I=v(I)),/^[a-zA-Z]:(\/|$)/.test(I)&&(I="/"+I),I}function E(I,T=r.$gc.sep){if(!I)return"";const O=I.length,C=I.charCodeAt(0);if(A(C)){if(A(I.charCodeAt(1))&&!A(I.charCodeAt(2))){let Q=3;const X=Q;for(;Q<O&&!A(I.charCodeAt(Q));Q++);if(X!==Q&&!A(I.charCodeAt(Q+1))){for(Q+=1;Q<O;Q++)if(A(I.charCodeAt(Q)))return I.slice(0,Q+1).replace(/[\\/]/g,T)}}return T}else if(p(C)&&I.charCodeAt(1)===n.CharCode.Colon)return A(I.charCodeAt(2))?I.slice(0,2)+T:I.slice(0,2);let P=I.indexOf("://");if(P!==-1){for(P+=3;P<O;P++)if(A(I.charCodeAt(P)))return I.slice(0,P+1)}return""}function y(I){if(!S.$c||!I||I.length<5)return!1;let T=I.charCodeAt(0);if(T!==n.CharCode.Backslash||(T=I.charCodeAt(1),T!==n.CharCode.Backslash))return!1;let O=2;const C=O;for(;O<I.length&&(T=I.charCodeAt(O),T!==n.CharCode.Backslash);O++);return!(C===O||(T=I.charCodeAt(O+1),isNaN(T)||T===n.CharCode.Backslash))}const $=/[\\/:\*\?"<>\|]/g,w=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(I,T=S.$c){const O=T?$:w;return!(!I||I.length===0||/^\s+$/.test(I)||(O.lastIndex=0,O.test(I))||T&&a.test(I)||I==="."||I===".."||T&&I[I.length-1]==="."||T&&I.length!==I.trim().length||I.length>255)}function c(I,T,O){const C=I===T;return!O||C?C:!I||!T?!1:(0,k.$Bf)(I,T)}function g(I,T,O,C=r.sep){if(I===T)return!0;if(!I||!T||T.length>I.length)return!1;if(O){if(!(0,k.$Cf)(I,T))return!1;if(T.length===I.length)return!0;let Q=T.length;return T.charAt(T.length-1)===C&&Q--,I.charAt(Q)===C}return T.charAt(T.length-1)!==C&&(T+=C),I.indexOf(T)===0}function p(I){return I>=n.CharCode.A&&I<=n.CharCode.Z||I>=n.CharCode.a&&I<=n.CharCode.z}function m(I,T){return S.$c&&I.endsWith(":")&&(I+=r.sep),(0,r.$ic)(I)||(I=(0,r.$jc)(T,I)),I=(0,r.$hc)(I),b(I)}function b(I){return S.$c?(I=(0,k.$jf)(I,r.sep),I.endsWith(":")&&(I+=r.sep)):(I=(0,k.$jf)(I,r.sep),I||(I=r.sep)),I}function l(I){const T=(0,r.$hc)(I);return S.$c?I.length>3?!1:t(T)&&(I.length===2||T.charCodeAt(2)===n.CharCode.Backslash):T===r.$gc.sep}function t(I,T=S.$c){return T?p(I.charCodeAt(0))&&I.charCodeAt(1)===n.CharCode.Colon:!1}function o(I,T=S.$c){return t(I,T)?I[0]:void 0}function d(I,T,O){return T.length>I.length?-1:I===T?0:(O&&(I=I.toLowerCase(),T=T.toLowerCase()),I.indexOf(T))}function i(I){const T=I.split(":");let O,C,P;for(const Q of T){const X=Number(Q);(0,R.$eg)(X)?C===void 0?C=X:P===void 0&&(P=X):O=O?[O,Q].join(":"):Q}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:C!==void 0?C:void 0,column:P!==void 0?P:C!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(I,T,O=8){let C="";for(let Q=0;Q<O;Q++){let X;Q===0&&S.$c&&!T&&(O===3||O===4)?X=u:X=h,C+=X.charAt(Math.floor(Math.random()*X.length))}let P;return T?P=`${T}-${C}`:P=C,I?(0,r.$jc)(I,P):P}}),define(Se[172],De([1,0,35,26,161,17]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.FuzzyScore=e.$Ck=e.$Bk=void 0,e.or=R,e.$Dk=v,e.$Ek=s,e.$Fk=$,e.$Gk=D,e.$Hk=I,e.$Ik=X,e.$Jk=ie,e.$Kk=ne,e.$Lk=x,e.$Mk=V,e.$Ok=Z,e.$Pk=se,e.$Qk=fe;function R(...de){return function(we,Re){for(let Oe=0,me=de.length;Oe<me;Oe++){const Ie=de[Oe](we,Re);if(Ie)return Ie}return null}}e.$Bk=A.bind(void 0,!1),e.$Ck=A.bind(void 0,!0);function A(de,we,Re){if(!Re||Re.length<we.length)return null;let Oe;return de?Oe=k.$Cf(Re,we):Oe=Re.indexOf(we)===0,Oe?we.length>0?[{start:0,end:we.length}]:[]:null}function v(de,we){const Re=we.toLowerCase().indexOf(de.toLowerCase());return Re===-1?null:[{start:Re,end:Re+de.length}]}function s(de,we){return E(de.toLowerCase(),we.toLowerCase(),0,0)}function E(de,we,Re,Oe){if(Re===de.length)return[];if(Oe===we.length)return null;if(de[Re]===we[Oe]){let me=null;return(me=E(de,we,Re+1,Oe+1))?l({start:Oe,end:Oe+1},me):null}return E(de,we,Re,Oe+1)}function y(de){return n.CharCode.a<=de&&de<=n.CharCode.z}function $(de){return n.CharCode.A<=de&&de<=n.CharCode.Z}function w(de){return n.CharCode.Digit0<=de&&de<=n.CharCode.Digit9}function a(de){return de===n.CharCode.Space||de===n.CharCode.Tab||de===n.CharCode.LineFeed||de===n.CharCode.CarriageReturn}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(de=>f.add(de.charCodeAt(0)));function c(de){return a(de)||f.has(de)}function g(de,we){return de===we||c(de)&&c(we)}const p=new Map;function m(de){if(p.has(de))return p.get(de);let we;const Re=(0,S.$zk)(de);return Re&&(we=Re),p.set(de,we),we}function b(de){return y(de)||$(de)||w(de)}function l(de,we){return we.length===0?we=[de]:de.end===we[0].start?we[0].start=de.start:we.unshift(de),we}function t(de,we){for(let Re=we;Re<de.length;Re++){const Oe=de.charCodeAt(Re);if($(Oe)||w(Oe)||Re>0&&!b(de.charCodeAt(Re-1)))return Re}return de.length}function o(de,we,Re,Oe){if(Re===de.length)return[];if(Oe===we.length)return null;if(de[Re]!==we[Oe].toLowerCase())return null;{let me=null,Ie=Oe+1;for(me=o(de,we,Re+1,Oe+1);!me&&(Ie=t(we,Ie))<we.length;)me=o(de,we,Re+1,Ie),Ie++;return me===null?null:l({start:Oe,end:Oe+1},me)}}function d(de){let we=0,Re=0,Oe=0,me=0,Ie=0;for(let We=0;We<de.length;We++)Ie=de.charCodeAt(We),$(Ie)&&we++,y(Ie)&&Re++,b(Ie)&&Oe++,w(Ie)&&me++;const Ae=we/de.length,je=Re/de.length,Be=Oe/de.length,Je=me/de.length;return{upperPercent:Ae,lowerPercent:je,alphaPercent:Be,numericPercent:Je}}function i(de){const{upperPercent:we,lowerPercent:Re}=de;return Re===0&&we>.6}function h(de){const{upperPercent:we,lowerPercent:Re,alphaPercent:Oe,numericPercent:me}=de;return Re>.2&&we<.8&&Oe>.6&&me<.2}function u(de){let we=0,Re=0,Oe=0,me=0;for(let Ie=0;Ie<de.length;Ie++)Oe=de.charCodeAt(Ie),$(Oe)&&we++,y(Oe)&&Re++,a(Oe)&&me++;return(we===0||Re===0)&&me===0?de.length<=30:we<=5}function D(de,we){if(!we||(we=we.trim(),we.length===0)||!u(de))return null;we.length>60&&(we=we.substring(0,60));const Re=d(we);if(!h(Re)){if(!i(Re))return null;we=we.toLowerCase()}let Oe=null,me=0;for(de=de.toLowerCase();me<we.length&&(Oe=o(de,we,0,me))===null;)me=t(we,me+1);return Oe}function I(de,we,Re=!1){if(!we||we.length===0)return null;let Oe=null,me=0;for(de=de.toLowerCase(),we=we.toLowerCase();me<we.length&&(Oe=T(de,we,0,me,Re),Oe===null);)me=O(we,me+1);return Oe}function T(de,we,Re,Oe,me){let Ie=0;if(Re===de.length)return[];if(Oe===we.length)return null;if(!g(de.charCodeAt(Re),we.charCodeAt(Oe))){const Be=m(de.charCodeAt(Re));if(!Be)return null;for(let Je=0;Je<Be.length;Je++)if(!g(Be[Je],we.charCodeAt(Oe+Je)))return null;Ie+=Be.length-1}let Ae=null,je=Oe+Ie+1;if(Ae=T(de,we,Re+1,je,me),!me)for(;!Ae&&(je=O(we,je))<we.length;)Ae=T(de,we,Re+1,je,me),je++;if(!Ae)return null;if(de.charCodeAt(Re)!==we.charCodeAt(Oe)){const Be=m(de.charCodeAt(Re));if(!Be)return Ae;for(let Je=0;Je<Be.length;Je++)if(Be[Je]!==we.charCodeAt(Oe+Je))return Ae}return l({start:Oe,end:Oe+Ie+1},Ae)}function O(de,we){for(let Re=we;Re<de.length;Re++)if(c(de.charCodeAt(Re))||Re>0&&c(de.charCodeAt(Re-1)))return Re;return de.length}const C=R(e.$Ck,D,v),P=R(e.$Ck,D,s),Q=new r.$Dc(1e4);function X(de,we,Re=!1){if(typeof de!="string"||typeof we!="string")return null;let Oe=Q.get(de);Oe||(Oe=new RegExp(k.$kf(de),"i"),Q.set(de,Oe));const me=Oe.exec(we);return me?[{start:me.index,end:me.index+me[0].length}]:Re?P(de,we):C(de,we)}function ie(de,we){const Re=Z(de,de.toLowerCase(),0,we,we.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?x(Re):null}function ne(de,we,Re,Oe,me,Ie){const Ae=Math.min(13,de.length);for(;Re<Ae;Re++){const je=Z(de,we,Re,Oe,me,Ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(je)return je}return[0,Ie]}function x(de){if(typeof de>"u")return[];const we=[],Re=de[1];for(let Oe=de.length-1;Oe>1;Oe--){const me=de[Oe]+Re,Ie=we[we.length-1];Ie&&Ie.end===me?Ie.end=me+1:we.push({start:me,end:me+1})}return we}const re=128;function q(){const de=[],we=[];for(let Re=0;Re<=re;Re++)we[Re]=0;for(let Re=0;Re<=re;Re++)de.push(we.slice(0));return de}function te(de){const we=[];for(let Re=0;Re<=de;Re++)we[Re]=0;return we}const le=te(2*re),M=te(2*re),z=q(),oe=q(),ce=q(),pe=!1;function W(de,we,Re,Oe,me){function Ie(je,Be,Je=" "){for(;je.length<Be;)je=Je+je;return je}let Ae=` |   |${Oe.split("").map(je=>Ie(je,3)).join("|")}
`;for(let je=0;je<=Re;je++)je===0?Ae+=" |":Ae+=`${we[je-1]}|`,Ae+=de[je].slice(0,me+1).map(Be=>Ie(Be.toString(),3)).join("|")+`
`;return Ae}function ae(de,we,Re,Oe){de=de.substr(we),Re=Re.substr(Oe),console.log(W(oe,de,de.length,Re,Re.length)),console.log(W(ce,de,de.length,Re,Re.length)),console.log(W(z,de,de.length,Re,Re.length))}function ee(de,we){if(we<0||we>=de.length)return!1;const Re=de.codePointAt(we);switch(Re){case n.CharCode.Underline:case n.CharCode.Dash:case n.CharCode.Period:case n.CharCode.Space:case n.CharCode.Slash:case n.CharCode.Backslash:case n.CharCode.SingleQuote:case n.CharCode.DoubleQuote:case n.CharCode.Colon:case n.CharCode.DollarSign:case n.CharCode.LessThan:case n.CharCode.GreaterThan:case n.CharCode.OpenParen:case n.CharCode.CloseParen:case n.CharCode.OpenSquareBracket:case n.CharCode.CloseSquareBracket:case n.CharCode.OpenCurlyBrace:case n.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!k.$Uf(Re)}}function H(de,we){if(we<0||we>=de.length)return!1;switch(de.charCodeAt(we)){case n.CharCode.Space:case n.CharCode.Tab:return!0;default:return!1}}function L(de,we,Re){return we[de]!==Re[de]}function V(de,we,Re,Oe,me,Ie,Ae=!1){for(;we<Re&&me<Ie;)de[we]===Oe[me]&&(Ae&&(le[we]=me),we+=1),me+=1;return we===Re}var B;(function(de){de[de.Diag=1]="Diag",de[de.Left=2]="Left",de[de.LeftLeft=3]="LeftLeft"})(B||(B={}));var U;(function(de){de.Default=[-100,0];function we(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}de.isDefault=we})(U||(e.FuzzyScore=U={}));class K{constructor(we,Re){this.firstMatchCanBeWeak=we,this.boostFullMatch=Re}}e.$Nk=K,K.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function Z(de,we,Re,Oe,me,Ie,Ae=K.default){const je=de.length>re?re:de.length,Be=Oe.length>re?re:Oe.length;if(Re>=je||Ie>=Be||je-Re>Be-Ie||!V(we,Re,je,me,Ie,Be,!0))return;j(je,Be,Re,Ie,we,me);let Je=1,We=1,Qe=Re,He=Ie;const nt=[!1];for(Je=1,Qe=Re;Qe<je;Je++,Qe++){const Xe=le[Qe],Ge=M[Qe],xe=Qe+1<je?M[Qe+1]:Be;for(We=Xe-Ie+1,He=Xe;He<xe;We++,He++){let ve=Number.MIN_SAFE_INTEGER,ge=!1;He<=Ge&&(ve=G(de,we,Qe,Re,Oe,me,He,Be,Ie,z[Je-1][We-1]===0,nt));let be=0;ve!==Number.MAX_SAFE_INTEGER&&(ge=!0,be=ve+oe[Je-1][We-1]);const Y=He>Xe,_=Y?oe[Je][We-1]+(z[Je][We-1]>0?-5:0):0,ye=He>Xe+1&&z[Je][We-1]>0,Me=ye?oe[Je][We-2]+(z[Je][We-2]>0?-5:0):0;if(ye&&(!Y||Me>=_)&&(!ge||Me>=be))oe[Je][We]=Me,ce[Je][We]=B.LeftLeft,z[Je][We]=0;else if(Y&&(!ge||_>=be))oe[Je][We]=_,ce[Je][We]=B.Left,z[Je][We]=0;else if(ge)oe[Je][We]=be,ce[Je][We]=B.Diag,z[Je][We]=z[Je-1][We-1]+1;else throw new Error("not possible")}}if(pe&&ae(de,Re,Oe,Ie),!nt[0]&&!Ae.firstMatchCanBeWeak)return;Je--,We--;const et=[oe[Je][We],Ie];let rt=0,lt=0;for(;Je>=1;){let Xe=We;do{const Ge=ce[Je][Xe];if(Ge===B.LeftLeft)Xe=Xe-2;else if(Ge===B.Left)Xe=Xe-1;else break}while(Xe>=1);rt>1&&we[Re+Je-1]===me[Ie+We-1]&&!L(Xe+Ie-1,Oe,me)&&rt+1>z[Je][Xe]&&(Xe=We),Xe===We?rt++:rt=1,lt||(lt=Xe),Je--,We=Xe-1,et.push(We)}Be-Ie===je&&Ae.boostFullMatch&&(et[0]+=2);const tt=lt-je;return et[0]-=tt,et}function j(de,we,Re,Oe,me,Ie){let Ae=de-1,je=we-1;for(;Ae>=Re&&je>=Oe;)me[Ae]===Ie[je]&&(M[Ae]=je,Ae--),je--}function G(de,we,Re,Oe,me,Ie,Ae,je,Be,Je,We){if(we[Re]!==Ie[Ae])return Number.MIN_SAFE_INTEGER;let Qe=1,He=!1;return Ae===Re-Oe?Qe=de[Re]===me[Ae]?7:5:L(Ae,me,Ie)&&(Ae===0||!L(Ae-1,me,Ie))?(Qe=de[Re]===me[Ae]?7:5,He=!0):ee(Ie,Ae)&&(Ae===0||!ee(Ie,Ae-1))?Qe=5:(ee(Ie,Ae-1)||H(Ie,Ae-1))&&(Qe=5,He=!0),Qe>1&&Re===Oe&&(We[0]=!0),He||(He=L(Ae,me,Ie)||ee(Ie,Ae-1)||H(Ie,Ae-1)),Re===Oe?Ae>Be&&(Qe-=He?3:5):Je?Qe+=He?2:0:Qe+=He?0:1,Ae+1===je&&(Qe-=He?3:5),Qe}function se(de,we,Re,Oe,me,Ie,Ae){return Ee(de,we,Re,Oe,me,Ie,!0,Ae)}function fe(de,we,Re,Oe,me,Ie,Ae){return Ee(de,we,Re,Oe,me,Ie,!1,Ae)}function Ee(de,we,Re,Oe,me,Ie,Ae,je){let Be=Z(de,we,Re,Oe,me,Ie,je);if(Be&&!Ae)return Be;if(de.length>=3){const Je=Math.min(7,de.length-1);for(let We=Re+1;We<Je;We++){const Qe=Le(de,We);if(Qe){const He=Z(Qe,Qe.toLowerCase(),Re,Oe,me,Ie,je);He&&(He[0]-=3,(!Be||He[0]>Be[0])&&(Be=He))}}}return Be}function Le(de,we){if(we+1>=de.length)return;const Re=de[we],Oe=de[we+1];if(Re!==Oe)return de.slice(0,we)+Oe+Re+de.slice(we+2)}}),define(Se[68],De([1,0,17]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=r,e.$pj=S,e.$qj=k,e.$rj=A,e.$tj=f;function r(g){return S(g,0)}function S(g,p){switch(typeof g){case"object":return g===null?k(349,p):Array.isArray(g)?v(g,p):s(g,p);case"string":return A(g,p);case"boolean":return R(g,p);case"number":return k(g,p);case"undefined":return k(937,p);default:return k(617,p)}}function k(g,p){return(p<<5)-p+g|0}function R(g,p){return k(g?433:863,p)}function A(g,p){p=k(149417,p);for(let m=0,b=g.length;m<b;m++)p=k(g.charCodeAt(m),p);return p}function v(g,p){return p=k(104579,p),g.reduce((m,b)=>S(b,m),p)}function s(g,p){return p=k(181387,p),Object.keys(g).sort().reduce((m,b)=>(m=A(b,m),S(g[b],m)),p)}class E{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=S(p,this.g),this.g}}e.$sj=E;var y;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function $(g,p,m=32){const b=m-p,l=~((1<<b)-1);return(g<<p|(l&g)>>>b)>>>0}function w(g,p=0,m=g.byteLength,b=0){for(let l=0;l<m;l++)g[p+l]=b}function a(g,p,m="0"){for(;g.length<p;)g=m+g;return g}function f(g,p=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(m=>m.toString(16).padStart(2,"0")).join(""):a((g>>>0).toString(16),p/4)}class c{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(y.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const m=p.length;if(m===0)return;const b=this.p;let l=this.r,t=this.u,o,d;for(t!==0?(o=t,d=-1,t=0):(o=p.charCodeAt(0),d=0);;){let i=o;if(n.$Ff(o))if(d+1<m){const h=p.charCodeAt(d+1);n.$Gf(h)?(d++,i=n.$Hf(o,h)):i=y.UNICODE_REPLACEMENT}else{t=o;break}else n.$Gf(o)&&(i=y.UNICODE_REPLACEMENT);if(l=this.w(b,l,i),d++,d<m)o=p.charCodeAt(d);else break}this.r=l,this.u=t}w(p,m,b){return b<128?p[m++]=b:b<2048?(p[m++]=192|(b&1984)>>>6,p[m++]=128|(b&63)>>>0):b<65536?(p[m++]=224|(b&61440)>>>12,p[m++]=128|(b&4032)>>>6,p[m++]=128|(b&63)>>>0):(p[m++]=240|(b&1835008)>>>18,p[m++]=128|(b&258048)>>>12,p[m++]=128|(b&4032)>>>6,p[m++]=128|(b&63)>>>0),m>=y.BLOCK_SIZE&&(this.y(),m-=y.BLOCK_SIZE,this.t+=y.BLOCK_SIZE,p[0]=p[y.BLOCK_SIZE+0],p[1]=p[y.BLOCK_SIZE+1],p[2]=p[y.BLOCK_SIZE+2]),m}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,y.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,w(this.p,this.r),this.r>56&&(this.y(),w(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=c.g,m=this.q;for(let D=0;D<64;D+=4)p.setUint32(D,m.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)p.setUint32(D,$(p.getUint32(D-12,!1)^p.getUint32(D-32,!1)^p.getUint32(D-56,!1)^p.getUint32(D-64,!1),1),!1);let b=this.h,l=this.l,t=this.m,o=this.n,d=this.o,i,h,u;for(let D=0;D<80;D++)D<20?(i=l&t|~l&o,h=1518500249):D<40?(i=l^t^o,h=1859775393):D<60?(i=l&t|l&o|t&o,h=2400959708):(i=l^t^o,h=3395469782),u=$(b,5)+i+d+h+p.getUint32(D*4,!1)&4294967295,d=o,o=t,t=$(l,30),l=b,b=u;this.h=this.h+b&4294967295,this.l=this.l+l&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+d&4294967295}}e.$uj=c,c.g=new DataView(new ArrayBuffer(320))}),define(Se[173],De([1,0,172,17,81]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=v,e.$Sk=E,e.$Tk=$,e.$Uk=w,e.$Vk=f,e.$Wk=c;const k="$(",R=new RegExp(`\\$\\(${S.ThemeIcon.iconNameExpression}(?:${S.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${R.source}`,"g");function v(g){return g.replace(A,(p,m)=>m?p:`\\${p}`)}const s=new RegExp(`\\\\${R.source}`,"g");function E(g){return g.replace(s,p=>`\\${p}`)}const y=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function $(g){return g.indexOf(k)===-1?g:g.replace(y,(p,m,b,l)=>b?p:m||l||"")}function w(g){return g?g.replace(/\$\((.*?)\)/g,(p,m)=>` ${m} `).trim():""}const a=new RegExp(`\\$\\(${S.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(g){a.lastIndex=0;let p="";const m=[];let b=0;for(;;){const l=a.lastIndex,t=a.exec(g),o=g.substring(l,t?.index);if(o.length>0){p+=o;for(let d=0;d<o.length;d++)m.push(b)}if(!t)break;b+=t[0].length}return{text:p,iconOffsets:m}}function c(g,p,m=!1){const{text:b,iconOffsets:l}=p;if(!l||l.length===0)return(0,n.$Ik)(g,b,m);const t=(0,r.$if)(b," "),o=b.length-t.length,d=(0,n.$Ik)(g,t,m);if(d)for(const i of d){const h=l[i.start+o]+o;i.start+=h,i.end+=h}return d}}),define(Se[58],De([1,0,17]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var r;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(r||(r={})),function(S){const k="error",R="warning",A="warn",v="info",s="ignore";function E($){return $?n.$Bf(k,$)?S.Error:n.$Bf(R,$)||n.$Bf(A,$)?S.Warning:n.$Bf(v,$)?S.Info:S.Ignore:S.Ignore}S.fromValue=E;function y($){switch($){case S.Error:return k;case S.Warning:return R;case S.Info:return v;default:return s}}S.toString=y}(r||(r={})),e.default=r}),define(Se[69],De([1,0,18,35,17]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class k{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const f=a.charCodeAt(0),c=this.b.charCodeAt(this.c);return f-c}value(){return this.b[this.c]}}e.$Ci=k;class R{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===r.CharCode.Period)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,S.$vf)(a,this.b,0,a.length,this.c,this.d):(0,S.$xf)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=R;class A{constructor(a=!0,f=!0){this.f=a,this.g=f}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let f=a.length-1;f>=0;f--,this.c--){const c=this.b.charCodeAt(f);if(!(c===r.CharCode.Slash||this.f&&c===r.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===r.CharCode.Slash||this.f&&f===r.CharCode.Backslash)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,S.$vf)(a,this.b,0,a.length,this.d,this.e):(0,S.$xf)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=A;var v;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(v||(v={}));class s{constructor(a,f){this.f=a,this.g=f,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(v.Scheme),this.c.authority&&this.d.push(v.Authority),this.c.path&&(this.b=new A(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(v.Path)),this.g(a)||(this.c.query&&this.d.push(v.Query),this.c.fragment&&this.d.push(v.Fragment)),this.e=0,this}next(){return this.d[this.e]===v.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===v.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===v.Scheme)return(0,S.$wf)(a,this.c.scheme);if(this.d[this.e]===v.Authority)return(0,S.$wf)(a,this.c.authority);if(this.d[this.e]===v.Path)return this.b.cmp(a);if(this.d[this.e]===v.Query)return(0,S.$uf)(a,this.c.query);if(this.d[this.e]===v.Fragment)return(0,S.$uf)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===v.Scheme)return this.c.scheme;if(this.d[this.e]===v.Authority)return this.c.authority;if(this.d[this.e]===v.Path)return this.b.value();if(this.d[this.e]===v.Query)return this.c.query;if(this.d[this.e]===v.Fragment)return this.c.fragment;throw new Error}}e.$Fi=s;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(y||(y={}));class ${static forUris(a=()=>!1,f=()=>!1){return new $(new s(a,f))}static forPaths(a=!1){return new $(new A(void 0,!a))}static forStrings(){return new $(new k)}static forConfigKeys(){return new $(new R)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,f){if(f){const c=f.slice(0);(0,n.$Wb)(c);for(const g of c)this.set(g,a)}else{const c=a.slice(0);(0,n.$Wb)(c);for(const g of c)this.set(g[0],g[1])}}set(a,f){const c=this.b.reset(a);let g;this.c||(this.c=new E,this.c.segment=c.value());const p=[];for(g=this.c;;){const b=c.cmp(g.segment);if(b>0)g.left||(g.left=new E,g.left.segment=c.value()),p.push([y.Left,g]),g=g.left;else if(b<0)g.right||(g.right=new E,g.right.segment=c.value()),p.push([y.Right,g]),g=g.right;else if(c.hasNext())c.next(),g.mid||(g.mid=new E,g.mid.segment=c.value()),p.push([y.Mid,g]),g=g.mid;else break}const m=g.value;g.value=f,g.key=a;for(let b=p.length-1;b>=0;b--){const l=p[b][1];l.updateHeight();const t=l.balanceFactor();if(t<-1||t>1){const o=p[b][0],d=p[b+1][0];if(o===y.Right&&d===y.Right)p[b][1]=l.rotateLeft();else if(o===y.Left&&d===y.Left)p[b][1]=l.rotateRight();else if(o===y.Right&&d===y.Left)l.right=p[b+1][1]=p[b+1][1].rotateRight(),p[b][1]=l.rotateLeft();else if(o===y.Left&&d===y.Right)l.left=p[b+1][1]=p[b+1][1].rotateLeft(),p[b][1]=l.rotateRight();else throw new Error;if(b>0)switch(p[b-1][0]){case y.Left:p[b-1][1].left=p[b][1];break;case y.Right:p[b-1][1].right=p[b][1];break;case y.Mid:p[b-1][1].mid=p[b][1];break}else this.c=p[0][1]}}return m}get(a){return this.d(a)?.value}d(a){const f=this.b.reset(a);let c=this.c;for(;c;){const g=f.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(f.hasNext())f.next(),c=c.mid;else break}return c}has(a){const f=this.d(a);return!(f?.value===void 0&&f?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,f){const c=this.b.reset(a),g=[];let p=this.c;for(;p;){const m=c.cmp(p.segment);if(m>0)g.push([y.Left,p]),p=p.left;else if(m<0)g.push([y.Right,p]),p=p.right;else if(c.hasNext())c.next(),g.push([y.Mid,p]),p=p.mid;else break}if(p){if(f?(p.left=void 0,p.mid=void 0,p.right=void 0,p.height=1):(p.key=void 0,p.value=void 0),!p.mid&&!p.value)if(p.left&&p.right){const m=this.f(p.right);if(m.key){const{key:b,value:l,segment:t}=m;this.e(m.key,!1),p.key=b,p.value=l,p.segment=t}}else{const m=p.left??p.right;if(g.length>0){const[b,l]=g[g.length-1];switch(b){case y.Left:l.left=m;break;case y.Mid:l.mid=m;break;case y.Right:l.right=m;break}}else this.c=m}for(let m=g.length-1;m>=0;m--){const b=g[m][1];b.updateHeight();const l=b.balanceFactor();if(l>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),g[m][1]=b.rotateLeft()):l<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),g[m][1]=b.rotateRight()),m>0)switch(g[m-1][0]){case y.Left:g[m-1][1].left=g[m][1];break;case y.Right:g[m-1][1].right=g[m][1];break;case y.Mid:g[m-1][1].mid=g[m][1];break}else this.c=g[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const f=this.b.reset(a);let c=this.c,g;for(;c;){const p=f.cmp(c.segment);if(p>0)c=c.left;else if(p<0)c=c.right;else if(f.hasNext())f.next(),g=c.value||g,c=c.mid;else break}return c&&c.value||g}findSuperstr(a){return this.g(a,!1)}g(a,f){const c=this.b.reset(a);let g=this.c;for(;g;){const p=c.cmp(g.segment);if(p>0)g=g.left;else if(p<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else return g.mid?this.h(g.mid):f?g.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[f,c]of this)a(c,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const f=[];return this.j(a,f),f[Symbol.iterator]()}j(a,f){a&&(a.left&&this.j(a.left,f),a.value&&f.push([a.key,a.value]),a.mid&&this.j(a.mid,f),a.right&&this.j(a.right,f))}_isBalanced(){const a=f=>{if(!f)return!0;const c=f.balanceFactor();return c<-1||c>1?!1:a(f.left)&&a(f.right)};return a(this.c)}}e.$Gi=$}),define(Se[4],De([1,0,35,80,9,3]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=c,e.$wc=t;const R=/^\w[\w\d+.-]*$/,A=/^\//,v=/^\/\//;function s(u,D){if(!u.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!R.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!A.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(u,D){return!u&&!D?"file":u}function y(u,D){switch(u){case"https":case"http":case"file":D?D[0]!==w&&(D=w+D):D=w;break}return D}const $="",w="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(D){return D instanceof f?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,I,T,O,C,P=!1){typeof D=="object"?(this.scheme=D.scheme||$,this.authority=D.authority||$,this.path=D.path||$,this.query=D.query||$,this.fragment=D.fragment||$):(this.scheme=E(D,P),this.authority=I||$,this.path=y(this.scheme,T||$),this.query=O||$,this.fragment=C||$,s(this,P))}get fsPath(){return t(this,!1)}with(D){if(!D)return this;let{scheme:I,authority:T,path:O,query:C,fragment:P}=D;return I===void 0?I=this.scheme:I===null&&(I=$),T===void 0?T=this.authority:T===null&&(T=$),O===void 0?O=this.path:O===null&&(O=$),C===void 0?C=this.query:C===null&&(C=$),P===void 0?P=this.fragment:P===null&&(P=$),I===this.scheme&&T===this.authority&&O===this.path&&C===this.query&&P===this.fragment?this:new p(I,T,O,C,P)}static parse(D,I=!1){const T=a.exec(D);return T?new p(T[2]||$,h(T[4]||$),h(T[5]||$),h(T[7]||$),h(T[9]||$),I):new p($,$,$,$,$)}static file(D){let I=$;if(k.$c&&(D=D.replace(/\\/g,w)),D[0]===w&&D[1]===w){const T=D.indexOf(w,2);T===-1?(I=D.substring(2),D=w):(I=D.substring(2,T),D=D.substring(T)||w)}return new p("file",I,D,$,$)}static from(D,I){return new p(D.scheme,D.authority,D.path,D.query,D.fragment,I)}static joinPath(D,...I){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let T;return k.$c&&D.scheme==="file"?T=f.file(S.$fc.join(t(D,!0),...I)).path:T=S.$gc.join(D.path,...I),D.with({path:T})}toString(D=!1){return o(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof f)return D;{const I=new p(D);return I._formatted=D.external??null,I._fsPath=D._sep===g?D.fsPath??null:null,I}}else return D}}e.URI=f;function c(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}const g=k.$c?1:void 0;class p extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(D=!1){return D?o(this,!0):(this._formatted||(this._formatted=o(this,!1)),this._formatted)}toJSON(){const D={$mid:r.MarshalledId.Uri};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=g),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const m={[n.CharCode.Colon]:"%3A",[n.CharCode.Slash]:"%2F",[n.CharCode.QuestionMark]:"%3F",[n.CharCode.Hash]:"%23",[n.CharCode.OpenSquareBracket]:"%5B",[n.CharCode.CloseSquareBracket]:"%5D",[n.CharCode.AtSign]:"%40",[n.CharCode.ExclamationMark]:"%21",[n.CharCode.DollarSign]:"%24",[n.CharCode.Ampersand]:"%26",[n.CharCode.SingleQuote]:"%27",[n.CharCode.OpenParen]:"%28",[n.CharCode.CloseParen]:"%29",[n.CharCode.Asterisk]:"%2A",[n.CharCode.Plus]:"%2B",[n.CharCode.Comma]:"%2C",[n.CharCode.Semicolon]:"%3B",[n.CharCode.Equals]:"%3D",[n.CharCode.Space]:"%20"};function b(u,D,I){let T,O=-1;for(let C=0;C<u.length;C++){const P=u.charCodeAt(C);if(P>=n.CharCode.a&&P<=n.CharCode.z||P>=n.CharCode.A&&P<=n.CharCode.Z||P>=n.CharCode.Digit0&&P<=n.CharCode.Digit9||P===n.CharCode.Dash||P===n.CharCode.Period||P===n.CharCode.Underline||P===n.CharCode.Tilde||D&&P===n.CharCode.Slash||I&&P===n.CharCode.OpenSquareBracket||I&&P===n.CharCode.CloseSquareBracket||I&&P===n.CharCode.Colon)O!==-1&&(T+=encodeURIComponent(u.substring(O,C)),O=-1),T!==void 0&&(T+=u.charAt(C));else{T===void 0&&(T=u.substr(0,C));const Q=m[P];Q!==void 0?(O!==-1&&(T+=encodeURIComponent(u.substring(O,C)),O=-1),T+=Q):O===-1&&(O=C)}}return O!==-1&&(T+=encodeURIComponent(u.substring(O))),T!==void 0?T:u}function l(u){let D;for(let I=0;I<u.length;I++){const T=u.charCodeAt(I);T===n.CharCode.Hash||T===n.CharCode.QuestionMark?(D===void 0&&(D=u.substr(0,I)),D+=m[T]):D!==void 0&&(D+=u[I])}return D!==void 0?D:u}function t(u,D){let I;return u.authority&&u.path.length>1&&u.scheme==="file"?I=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===n.CharCode.Slash&&(u.path.charCodeAt(1)>=n.CharCode.A&&u.path.charCodeAt(1)<=n.CharCode.Z||u.path.charCodeAt(1)>=n.CharCode.a&&u.path.charCodeAt(1)<=n.CharCode.z)&&u.path.charCodeAt(2)===n.CharCode.Colon?D?I=u.path.substr(1):I=u.path[1].toLowerCase()+u.path.substr(2):I=u.path,k.$c&&(I=I.replace(/\//g,"\\")),I}function o(u,D){const I=D?l:b;let T="",{scheme:O,authority:C,path:P,query:Q,fragment:X}=u;if(O&&(T+=O,T+=":"),(C||O==="file")&&(T+=w,T+=w),C){let ie=C.indexOf("@");if(ie!==-1){const ne=C.substr(0,ie);C=C.substr(ie+1),ie=ne.lastIndexOf(":"),ie===-1?T+=I(ne,!1,!1):(T+=I(ne.substr(0,ie),!1,!1),T+=":",T+=I(ne.substr(ie+1),!1,!0)),T+="@"}C=C.toLowerCase(),ie=C.lastIndexOf(":"),ie===-1?T+=I(C,!1,!0):(T+=I(C.substr(0,ie),!1,!0),T+=C.substr(ie))}if(P){if(P.length>=3&&P.charCodeAt(0)===n.CharCode.Slash&&P.charCodeAt(2)===n.CharCode.Colon){const ie=P.charCodeAt(1);ie>=n.CharCode.A&&ie<=n.CharCode.Z&&(P=`/${String.fromCharCode(ie+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===n.CharCode.Colon){const ie=P.charCodeAt(0);ie>=n.CharCode.A&&ie<=n.CharCode.Z&&(P=`${String.fromCharCode(ie+32)}:${P.substr(2)}`)}T+=I(P,!0,!1)}return Q&&(T+="?",T+=I(Q,!1,!1)),X&&(T+="#",T+=D?X:b(X,!1,!1)),T}function d(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+d(u.substr(3)):u}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(u){return u.match(i)?u.replace(i,D=>d(D)):u}}),define(Se[174],De([1,0,4]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=r,e.$6q=S,e.$7q=k,e.log=A;function r(s){const E=s;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function S(s){const E=[];let y;try{const $=JSON.parse(s.arguments),w=$[$.length-1];w&&w.__$stack&&($.pop(),y=w.__$stack),E.push(...$)}catch{E.push("Unable to log remote console arguments",s.arguments)}return{args:E,stack:y}}function k(s){if(typeof s!="string")return k(S(s).stack);const E=s;if(E){const y=R(E),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if($&&$.length===4)return{uri:n.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}function R(s){if(!s)return s;const E=s.indexOf(`
`);return E===-1?s:s.substring(0,E)}function A(s,E){const{args:y,stack:$}=S(s),w=typeof y[0]=="string"&&y.length===1;let a=R($);a&&(a=`(${a.trim()})`);let f=[];if(typeof y[0]=="string"?a&&w?f=[`%c[${E}] %c${y[0]} %c${a}`,v("blue"),v(""),v("grey")]:f=[`%c[${E}] %c${y[0]}`,v("blue"),v(""),...y.slice(1)]:f=[`%c[${E}]%`,v("blue"),...y],a&&!w&&f.push(a),typeof console[s.severity]!="function")throw new Error("Unknown console method");console[s.severity].apply(console,f)}function v(s){return`color: ${s}`}}),define(Se[48],De([1,0,15,4,80]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=k,e.$9h=R,e.$0h=v;function k(s){return JSON.stringify(s,A)}function R(s){let E=JSON.parse(s);return E=v(E),E}function A(s,E){return E instanceof RegExp?{$mid:S.MarshalledId.Regexp,source:E.source,flags:E.flags}:E}function v(s,E=0){if(!s||E>200)return s;if(typeof s=="object"){switch(s.$mid){case S.MarshalledId.Uri:return r.URI.revive(s);case S.MarshalledId.Regexp:return new RegExp(s.source,s.flags);case S.MarshalledId.Date:return new Date(s.source)}if(s instanceof n.$Je||s instanceof Uint8Array)return s;if(Array.isArray(s))for(let y=0;y<s.length;++y)s[y]=v(s[y],E+1);else for(const y in s)Object.hasOwnProperty.call(s,y)&&(s[y]=v(s[y],E+1))}return s}}),define(Se[13],De([1,0,10,3,17,4,9]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=v,e.$Kg=s,e.$Og=y;var A;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",a.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(A||(e.Schemas=A={}));function v(a,f){return k.URI.isUri(a)?(0,S.$Bf)(a.scheme,f):(0,S.$Cf)(a,f+":")}function s(a,...f){return f.some(c=>v(a,c))}e.$Lg="vscode-tkn",e.$Mg="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f,c){this.f=y(f,c)}getServerRootPath(){return this.f}get g(){return R.$gc.join(this.f,A.vscodeRemoteResource)}set(f,c,g){this.a[f]=c,this.b[f]=g}setConnectionToken(f,c){this.c[f]=c}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(l){return n.$1(l),f}const c=f.authority;let g=this.a[c];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const p=this.b[c],m=this.c[c];let b=`path=${encodeURIComponent(f.path)}`;return typeof m=="string"&&(b+=`&${e.$Mg}=${encodeURIComponent(m)}`),k.URI.from({scheme:r.$i?this.d:A.vscodeRemoteResource,authority:`${g}:${p}`,path:r.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:b})}}e.$Ng=new E;function y(a,f){return R.$gc.join(f??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class ${asBrowserUri(f){const c=this.b(f,he);return this.uriToBrowserUri(c)}uriToBrowserUri(f){return f.scheme===A.vscodeRemote?e.$Ng.rewrite(f):f.scheme===A.file&&(r.$g||r.$k===`${A.vscodeFileResource}://${$.a}`)?f.with({scheme:A.vscodeFileResource,authority:f.authority||$.a,query:null,fragment:null}):f}asFileUri(f){const c=this.b(f,he);return this.uriToFileUri(c)}uriToFileUri(f){return f.scheme===A.vscodeFileResource?f.with({scheme:A.file,authority:f.authority!==$.a?f.authority:null,query:null,fragment:null}):f}b(f,c){return k.URI.isUri(f)?f:k.URI.parse(c.toUrl(f))}}$.a=e.$Tg,e.$Ug=new $;var w;(function(a){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(f.get("3"));const c="vscode-coi";function g(m){let b;typeof m=="string"?b=new URL(m).searchParams:m instanceof URL?b=m.searchParams:k.URI.isUri(m)&&(b=new URL(m.toString(!0)).searchParams);const l=b?.get(c);if(l)return f.get(l)}a.getHeadersFromQuery=g;function p(m,b,l){if(!globalThis.crossOriginIsolated)return;const t=b&&l?"3":l?"2":"1";m instanceof URLSearchParams?m.set(c,t):m[c]=t}a.addSearchParam=p})(w||(e.COI=w={}))}),define(Se[175],De([1,0,105,13,3,4]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hE=E;class R{constructor($,w,a){this.id=$,this.dependencies=w,this.callback=a}}class A{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,w,a)=>{typeof $!="string"&&(a=w,w=$,$=null),(typeof w!="object"||!Array.isArray(w))&&(a=w,w=null),this.c.push(new R($,w,a))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const w=await(this.a?this.i($):this.b?this.h($):this.j($));if(!w)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(w.dependencies)&&w.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${w.dependencies.join(", ")}`);return typeof w.callback=="function"?w.callback([]):w.callback}h($){return new Promise((w,a)=>{const f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript");const c=()=>{f.removeEventListener("load",g),f.removeEventListener("error",p)},g=m=>{c(),w(this.c.pop())},p=m=>{c(),a(m)};f.addEventListener("load",g),f.addEventListener("error",p),this.f&&($=this.f.createScriptURL($)),f.setAttribute("src",$),window.document.getElementsByTagName("head")[0].appendChild(f)})}i($){return new Promise((w,a)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),w(this.c.pop())}catch(f){a(f)}})}async j($){try{const w=globalThis._VSCODE_NODE_MODULES.fs,a=globalThis._VSCODE_NODE_MODULES.vm,f=globalThis._VSCODE_NODE_MODULES.module,c=k.URI.parse($).fsPath,g=w.readFileSync(c).toString(),p=f.wrap(g.replace(/^#!.*/,""));return new a.Script(p).runInThisContext().apply(),this.c.pop()}catch(w){throw w}}}A.INSTANCE=new A;const v=new Map;let s={};typeof globalThis.require=="object"&&(s=globalThis.require.paths??{});async function E(y,$,w){if(n.$T){w===void 0&&(w=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),s[y]&&(y=s[y]);const a=`${y}/${$}`;if(v.has(a))return v.get(a);let f;if(/^\w[\w\d+.-]*:\/\//.test(a))f=a;else{const m=`${w&&!S.$i?r.$Rg:r.$Qg}/${a}`;f=r.$Ug.asBrowserUri(m).toString(!0)}const c=A.INSTANCE.load(f);return v.set(a,c),c}else return await new Promise((a,f)=>{he([y],a,f)})}}),define(Se[20],De([1,0,35,37,13,9,3,17,4]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=s,e.$kh=y,e.$lh=w;function s(a){return(0,v.$wc)(a,!0)}class E{constructor(f){this.a=f}compare(f,c,g=!1){return f===c?0:(0,A.$uf)(this.getComparisonKey(f,g),this.getComparisonKey(c,g))}isEqual(f,c,g=!1){return f===c?!0:!f||!c?!1:this.getComparisonKey(f,g)===this.getComparisonKey(c,g)}getComparisonKey(f,c=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,c,g=!1){if(f.scheme===c.scheme){if(f.scheme===S.Schemas.file)return r.$zg(s(f),s(c),this.a(f))&&f.query===c.query&&(g||f.fragment===c.fragment);if((0,e.$gh)(f.authority,c.authority))return r.$zg(f.path,c.path,this.a(f),"/")&&f.query===c.query&&(g||f.fragment===c.fragment)}return!1}joinPath(f,...c){return v.URI.joinPath(f,...c)}basenameOrAuthority(f){return(0,e.$$g)(f)||f.authority}basename(f){return k.$gc.basename(f.path)}extname(f){return k.$gc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let c;return f.scheme===S.Schemas.file?c=v.URI.file(k.$mc(s(f))).path:(c=k.$gc.dirname(f.path),f.authority&&c.length&&c.charCodeAt(0)!==n.CharCode.Slash&&(console.error(`dirname("${f.toString})) resulted in a relative path`),c="/")),f.with({path:c})}normalizePath(f){if(!f.path.length)return f;let c;return f.scheme===S.Schemas.file?c=v.URI.file(k.$hc(s(f))).path:c=k.$gc.normalize(f.path),f.with({path:c})}relativePath(f,c){if(f.scheme!==c.scheme||!(0,e.$gh)(f.authority,c.authority))return;if(f.scheme===S.Schemas.file){const m=k.$lc(s(f),s(c));return R.$c?r.$tg(m):m}let g=f.path||"/";const p=c.path||"/";if(this.a(f)){let m=0;for(const b=Math.min(g.length,p.length);m<b&&!(g.charCodeAt(m)!==p.charCodeAt(m)&&g.charAt(m).toLowerCase()!==p.charAt(m).toLowerCase());m++);g=p.substr(0,m)+g.substr(m)}return k.$gc.relative(g,p)}resolvePath(f,c){if(f.scheme===S.Schemas.file){const g=v.URI.file(k.$kc(s(f),c));return f.with({authority:g.authority,path:g.path})}return c=r.$ug(c),f.with({path:k.$gc.resolve(f.path,c)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,c){return f===c||f!==void 0&&c!==void 0&&(0,A.$Bf)(f,c)}hasTrailingPathSeparator(f,c=k.sep){if(f.scheme===S.Schemas.file){const g=s(f);return g.length>r.$vg(g).length&&g[g.length-1]===c}else{const g=f.path;return g.length>1&&g.charCodeAt(g.length-1)===n.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,c=k.sep){return(0,e.$hh)(f,c)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,c=k.sep){let g=!1;if(f.scheme===S.Schemas.file){const p=s(f);g=p!==void 0&&p.length===r.$vg(p).length&&p[p.length-1]===c}else{c="/";const p=f.path;g=p.length===1&&p.charCodeAt(p.length-1)===n.CharCode.Slash}return!g&&!(0,e.$hh)(f,c)?f.with({path:f.path+"/"}):f}}e.$3g=E,e.$4g=new E(()=>!1),e.$5g=new E(a=>a.scheme===S.Schemas.file?!R.$e:!0),e.$6g=new E(a=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function y(a,f){const c=[];for(let g=0;g<a.length;g++){const p=f(a[g]);a.some((m,b)=>b===g?!1:(0,e.$8g)(p,f(m)))||c.push(a[g])}return c}var $;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function f(c){const g=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(b=>{const[l,t]=b.split(":");l&&t&&g.set(l,t)});const m=c.path.substring(0,c.path.indexOf(";"));return m&&g.set(a.META_DATA_MIME,m),g}a.parseMetaData=f})($||(e.DataUri=$={}));function w(a,f,c){if(f){let g=a.path;return g&&g[0]!==k.$gc.sep&&(g=k.$gc.sep+g),a.with({scheme:c,authority:f,path:g})}return a.with({scheme:c})}}),define(Se[14],De([1,0,19,10,6,2,20,3,170,65]),function(he,e,n,r,S,k,R,A,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=E,e.$nh=y,e.$oh=$,e.$ph=w,e.$qh=a,e.$rh=f,e.$sh=c,e.$th=g,e.$Bh=u,e.$Ch=D,e.$Dh=I,e.$Eh=T,e.$Fh=O,e.$Uh=z,e.$3h=U;function E(Z){return!!Z&&typeof Z.then=="function"}function y(Z){const j=new n.$se,G=Z(j.token),se=new Promise((fe,Ee)=>{const Le=j.token.onCancellationRequested(()=>{Le.dispose(),Ee(new r.$5)});Promise.resolve(G).then(de=>{Le.dispose(),j.dispose(),fe(de)},de=>{Le.dispose(),j.dispose(),Ee(de)})});return new class{cancel(){j.cancel(),j.dispose()}then(fe,Ee){return se.then(fe,Ee)}catch(fe){return this.then(void 0,fe)}finally(fe){return se.finally(fe)}}}function $(Z,j,G){return new Promise((se,fe)=>{const Ee=j.onCancellationRequested(()=>{Ee.dispose(),se(G)});Z.then(se,fe).finally(()=>Ee.dispose())})}function w(Z,j){return new Promise((G,se)=>{const fe=j.onCancellationRequested(()=>{fe.dispose(),se(new r.$5)});Z.then(G,se).finally(()=>fe.dispose())})}async function a(Z){let j=-1;const G=Z.map((se,fe)=>se.then(Ee=>(j=fe,Ee)));try{return await Promise.race(G)}finally{Z.forEach((se,fe)=>{fe!==j&&se.cancel()})}}function f(Z,j,G){let se;const fe=setTimeout(()=>{se?.(void 0),G?.()},j);return Promise.race([Z.finally(()=>clearTimeout(fe)),new Promise(Ee=>se=Ee)])}function c(Z){return new Promise((j,G)=>{const se=Z();E(se)?se.then(j,G):j(se)})}function g(){let Z,j;return{promise:new Promise((se,fe)=>{Z=se,j=fe}),resolve:Z,reject:j}}class p{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(j){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=j,!this.b){const G=()=>{if(this.b=null,this.f)return;const se=this.queue(this.d);return this.d=null,se};this.b=new Promise(se=>{this.a.then(G,G).then(se)})}return new Promise((G,se)=>{this.b.then(G,se)})}return this.a=j(),new Promise((G,se)=>{this.a.then(fe=>{this.a=null,G(fe)},fe=>{this.a=null,se(fe)})})}dispose(){this.f=!0}}e.$uh=p;class m{constructor(){this.a=Promise.resolve(null)}queue(j){return this.a=this.a.then(()=>j(),()=>j())}}e.$vh=m;class b{constructor(){this.a=new Map}queue(j,G){const fe=(this.a.get(j)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(j)===fe&&this.a.delete(j)});return this.a.set(j,fe),fe}}e.$wh=b;const l=(Z,j)=>{let G=!0;const se=setTimeout(()=>{G=!1,j()},Z);return{isTriggered:()=>G,dispose:()=>{clearTimeout(se),G=!1}}},t=Z=>{let j=!0;return queueMicrotask(()=>{j&&(j=!1,Z())}),{isTriggered:()=>j,dispose:()=>{j=!1}}};class o{constructor(j){this.defaultDelay=j,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(j,G=this.defaultDelay){this.g=j,this.h(),this.b||(this.b=new Promise((fe,Ee)=>{this.d=fe,this.f=Ee}).then(()=>{if(this.b=null,this.d=null,this.g){const fe=this.g;return this.g=null,fe()}}));const se=()=>{this.a=null,this.d?.(null)};return this.a=G===v.$ce?t(se):l(G,se),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new r.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=o;class d{constructor(j){this.a=new o(j),this.b=new p}trigger(j,G){return this.a.trigger(()=>this.b.queue(j),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=d;class i{constructor(){this.a=!1,this.b=new Promise((j,G)=>{this.d=j})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=i;class h extends i{constructor(j){super(),this.f=setTimeout(()=>this.open(),j)}open(){clearTimeout(this.f),super.open()}}e.$Ah=h;function u(Z,j){return j?new Promise((G,se)=>{const fe=setTimeout(()=>{Ee.dispose(),G()},Z),Ee=j.onCancellationRequested(()=>{clearTimeout(fe),Ee.dispose(),se(new r.$5)})}):y(G=>u(Z,G))}function D(Z,j=0,G){const se=setTimeout(()=>{Z(),G&&fe.dispose()},j),fe=(0,k.$Sc)(()=>{clearTimeout(se),G?.deleteAndLeak(fe)});return G?.add(fe),fe}function I(Z){const j=[];let G=0;const se=Z.length;function fe(){return G<se?Z[G++]():null}function Ee(Le){Le!=null&&j.push(Le);const de=fe();return de?de.then(Ee):Promise.resolve(j)}return Promise.resolve(null).then(Ee)}function T(Z,j=se=>!!se,G=null){let se=0;const fe=Z.length,Ee=()=>{if(se>=fe)return Promise.resolve(G);const Le=Z[se++];return Promise.resolve(Le()).then(we=>j(we)?Promise.resolve(we):Ee())};return Ee()}function O(Z,j=se=>!!se,G=null){if(Z.length===0)return Promise.resolve(G);let se=Z.length;const fe=()=>{se=-1;for(const Ee of Z)Ee.cancel?.()};return new Promise((Ee,Le)=>{for(const de of Z)de.then(we=>{--se>=0&&j(we)?(fe(),Ee(we)):se===0&&Ee(G)}).catch(we=>{--se>=0&&(fe(),Le(we))})})}class C{constructor(j){this.a=0,this.b=!1,this.f=j,this.g=[],this.d=0,this.h=new S.$he}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(j){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((G,se)=>{this.g.push({factory:j,c:G,e:se}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const j=this.g.shift();this.d++;const G=j.factory();G.then(j.c,j.e),G.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=C;class P extends C{constructor(){super(1)}}e.$Hh=P;class Q{constructor(){this.a=new oe,this.b=0}queue(j){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,j())):this.a.run(this.b++,j())}}e.$Ih=Q;class X{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const j=new W;return this.b.add(j),j.p}g(){for(const[,j]of this.a)if(j.size>0)return!1;return!0}queueSize(j,G=R.$4g){const se=G.getComparisonKey(j);return this.a.get(se)?.size??0}queueFor(j,G,se=R.$4g){const fe=se.getComparisonKey(j);let Ee=this.a.get(fe);if(!Ee){Ee=new P;const Le=this.f++,de=S.Event.once(Ee.onDrained)(()=>{Ee?.dispose(),this.a.delete(fe),this.h(),this.d?.deleteAndDispose(Le),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new k.$4c),this.d.set(Le,de),this.a.set(fe,Ee)}return Ee.queue(G)}h(){this.g()&&this.j()}j(){for(const j of this.b)j.complete();this.b.clear()}dispose(){for(const[,j]of this.a)j.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=X;class ie{constructor(j,G){this.b=!1,this.a=-1,typeof j=="function"&&typeof G=="number"&&this.setIfNotSet(j,G)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(j,G){if(this.b)throw new r.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,j()},G)}setIfNotSet(j,G){if(this.b)throw new r.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,j()},G))}}e.$Kh=ie;class ne{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(j,G,se=globalThis){if(this.f)throw new r.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const fe=se.setInterval(()=>{j()},G);this.d=(0,k.$Sc)(()=>{se.clearInterval(fe),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=ne;class x{constructor(j,G){this.b=-1,this.a=j,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(j=this.d){this.cancel(),this.b=setTimeout(this.f,j)}get delay(){return this.d}set delay(j){this.d=j}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=x;class re{constructor(j,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=j,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(j=this.b){j%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${j}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(j/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=re;class q extends x{constructor(j,G){super(j,G),this.j=[]}work(j){this.j.push(j),this.isScheduled()||this.schedule()}h(){const j=this.j;this.j=[],this.a?.(j)}dispose(){this.j=[],super.dispose()}}e.$Oh=q;class te extends k.$Uc{constructor(j,G){super(),this.g=j,this.h=G,this.a=[],this.b=this.B(new k.$Vc),this.f=!1}get pending(){return this.a.length}work(j){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+j.length>this.g.maxBufferedWork)return!1}else if(this.pending+j.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of j)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new x(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=te,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(Z,j)=>{(0,A.$v)(()=>{if(G)return;const se=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,se-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$Rh=(Z,j,G)=>{const se=Z.requestIdleCallback(j,typeof G=="number"?{timeout:G}:void 0);let fe=!1;return{dispose(){fe||(fe=!0,Z.cancelIdleCallback(se))}}},e.$Qh=Z=>(0,e.$Rh)(globalThis,Z)}();class le{constructor(j,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(se){this.l=se}finally{this.g=!0}},this.f=(0,e.$Rh)(j,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=le;class M extends le{constructor(j){super(globalThis,j)}}e.$Th=M;async function z(Z,j,G){let se;for(let fe=0;fe<G;fe++)try{return await Z()}catch(Ee){se=Ee,await u(j)}throw se}class oe{isRunning(j){return typeof j=="number"?this.a?.taskId===j:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(j,G,se){return this.a={taskId:j,cancel:()=>se?.(),promise:G},G.then(()=>this.d(j),()=>this.d(j)),G}d(j){this.a&&j===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const j=this.b;this.b=void 0,j.run().then(j.promiseResolve,j.promiseReject)}}queue(j){if(this.b)this.b.run=j;else{const{promise:G,resolve:se,reject:fe}=g();this.b={run:j,promise:G,promiseResolve:se,promiseReject:fe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=oe;class ce{constructor(j,G=()=>Date.now()){this.d=j,this.f=G,this.a=0,this.b=0}increment(){const j=this.f();return j-this.a>this.d&&(this.a=j,this.b=0),this.b++,this.b}}e.$Wh=ce;var pe;(function(Z){Z[Z.Resolved=0]="Resolved",Z[Z.Rejected=1]="Rejected"})(pe||(pe={}));class W{get isRejected(){return this.d?.outcome===pe.Rejected}get isResolved(){return this.d?.outcome===pe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===pe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((j,G)=>{this.a=j,this.b=G})}complete(j){return new Promise(G=>{this.a(j),this.d={outcome:pe.Resolved,value:j},G()})}error(j){return new Promise(G=>{this.b(j),this.d={outcome:pe.Rejected,value:j},G()})}cancel(){return this.error(new r.$5)}}e.$Xh=W;var ae;(function(Z){async function j(se){let fe;const Ee=await Promise.all(se.map(Le=>Le.then(de=>de,de=>{fe||(fe=de)})));if(typeof fe<"u")throw fe;return Ee}Z.settled=j;function G(se){return new Promise(async(fe,Ee)=>{try{await se(fe,Ee)}catch(Le){Ee(Le)}})}Z.withAsyncBody=G})(ae||(e.Promises=ae={}));class ee{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(j){this.a=void 0,this.b=void 0,this.d=!1,this.promise=j.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new r.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=ee;class H{constructor(j){this.b=j,this.a=new s.$V(()=>new ee(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=H;var L;(function(Z){Z[Z.Initial=0]="Initial",Z[Z.DoneOK=1]="DoneOK",Z[Z.DoneError=2]="DoneError"})(L||(L={}));class V{static fromArray(j){return new V(G=>{G.emitMany(j)})}static fromPromise(j){return new V(async G=>{G.emitMany(await j)})}static fromPromises(j){return new V(async G=>{await Promise.all(j.map(async se=>G.emitOne(await se)))})}static merge(j){return new V(async G=>{await Promise.all(j.map(async se=>{for await(const fe of se)G.emitOne(fe)}))})}constructor(j,G){this.a=L.Initial,this.b=[],this.d=null,this.f=G,this.g=new S.$he,queueMicrotask(async()=>{const se={emitOne:fe=>this.h(fe),emitMany:fe=>this.j(fe),reject:fe=>this.l(fe)};try{await Promise.resolve(j(se)),this.k()}catch(fe){this.l(fe)}finally{se.emitOne=void 0,se.emitMany=void 0,se.reject=void 0}})}[Symbol.asyncIterator](){let j=0;return{next:async()=>{do{if(this.a===L.DoneError)throw this.d;if(j<this.b.length)return{done:!1,value:this.b[j++]};if(this.a===L.DoneOK)return{done:!0,value:void 0};await S.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(j,G){return new V(async se=>{for await(const fe of j)se.emitOne(G(fe))})}map(j){return V.map(this,j)}static filter(j,G){return new V(async se=>{for await(const fe of j)G(fe)&&se.emitOne(fe)})}filter(j){return V.filter(this,j)}static coalesce(j){return V.filter(j,G=>!!G)}coalesce(){return V.coalesce(this)}static async toPromise(j){const G=[];for await(const se of j)G.push(se);return G}toPromise(){return V.toPromise(this)}h(j){this.a===L.Initial&&(this.b.push(j),this.g.fire())}j(j){this.a===L.Initial&&(this.b=this.b.concat(j),this.g.fire())}k(){this.a===L.Initial&&(this.a=L.DoneOK,this.g.fire())}l(j){this.a===L.Initial&&(this.a=L.DoneError,this.d=j,this.g.fire())}}e.$1h=V,V.EMPTY=V.fromArray([]);class B extends V{constructor(j,G){super(G),this.m=j}cancel(){this.m.cancel()}}e.$2h=B;function U(Z){const j=new n.$se,G=Z(j.token);return new B(j,async se=>{const fe=j.token.onCancellationRequested(()=>{fe.dispose(),j.dispose(),se.reject(new r.$5)});try{for await(const Ee of G){if(j.token.isCancellationRequested)return;se.emitOne(Ee)}fe.dispose(),j.dispose()}catch(Ee){fe.dispose(),j.dispose(),se.reject(Ee)}})}class K{constructor(j){this.a=new W,this.b=new V(fe=>{if(G){fe.reject(G);return}return se&&fe.emitMany(se),this.d=Ee=>fe.reject(Ee),this.f=Ee=>fe.emitOne(Ee),this.a.p},j);let G,se;this.f=fe=>{se||(se=[]),se.push(fe)},this.d=fe=>{G||(G=fe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(j){this.d(j),this.a.complete()}emitOne(j){this.f(j)}}e.$4h=K}),define(Se[82],De([1,0,18,14,35,37,26,9,3,17]),function(he,e,n,r,S,k,R,A,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=E,e.$sk=f,e.$tk=Q,e.$uk=X,e.$vk=ie,e.$wk=ne,e.$xk=x,e.$yk=le;function E(){return Object.create(null)}e.$qk="**",e.$rk="/";const y="[/\\\\]",$="[^/\\\\]",w=/\//g;function a(M,z){switch(M){case 0:return"";case 1:return`${$}*?`;default:return`(?:${y}|${$}+${y}${z?`|${y}${$}+`:""})*?`}}function f(M,z){if(!M)return[];const oe=[];let ce=!1,pe=!1,W="";for(const ae of M){switch(ae){case z:if(!ce&&!pe){oe.push(W),W="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":pe=!0;break;case"]":pe=!1;break}W+=ae}return W&&oe.push(W),oe}function c(M){if(!M)return"";let z="";const oe=f(M,e.$rk);if(oe.every(ce=>ce===e.$qk))z=".*";else{let ce=!1;oe.forEach((pe,W)=>{if(pe===e.$qk){if(ce)return;z+=a(2,W===oe.length-1)}else{let ae=!1,ee="",H=!1,L="";for(const V of pe){if(V!=="}"&&ae){ee+=V;continue}if(H&&(V!=="]"||!L)){let B;V==="-"?B=V:(V==="^"||V==="!")&&!L?B="^":V===e.$rk?B="":B=(0,s.$df)(V),L+=B;continue}switch(V){case"{":ae=!0;continue;case"[":H=!0;continue;case"}":{const U=`(?:${f(ee,",").map(K=>c(K)).join("|")})`;z+=U,ae=!1,ee="";break}case"]":{z+="["+L+"]",H=!1,L="";break}case"?":z+=$;continue;case"*":z+=a(1);continue;default:z+=(0,s.$df)(V)}}W<oe.length-1&&(oe[W+1]!==e.$qk||W+2<oe.length)&&(z+=y)}ce=pe===e.$qk})}return z}const g=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,m=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,o=new R.$Dc(1e4),d=function(){return!1},i=function(){return null};function h(M,z){if(!M)return i;let oe;typeof M!="string"?oe=M.pattern:oe=M,oe=oe.trim();const ce=`${oe}_${!!z.trimForExclusions}`;let pe=o.get(ce);if(pe)return u(pe,M);let W;return g.test(oe)?pe=I(oe.substr(4),oe):(W=p.exec(D(oe,z)))?pe=T(W[1],oe):(z.trimForExclusions?b:m).test(oe)?pe=O(oe,z):(W=l.exec(D(oe,z)))?pe=C(W[1].substr(1),oe,!0):(W=t.exec(D(oe,z)))?pe=C(W[1],oe,!1):pe=P(oe),o.set(ce,pe),u(pe,M)}function u(M,z){if(typeof z=="string")return M;const oe=function(ce,pe){return(0,k.$zg)(ce,z.base,!v.$e)?M((0,s.$if)(ce.substr(z.base.length),A.sep),pe):null};return oe.allBasenames=M.allBasenames,oe.allPaths=M.allPaths,oe.basenames=M.basenames,oe.patterns=M.patterns,oe}function D(M,z){return z.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function I(M,z){return function(oe,ce){return typeof oe=="string"&&oe.endsWith(M)?z:null}}function T(M,z){const oe=`/${M}`,ce=`\\${M}`,pe=function(ae,ee){return typeof ae!="string"?null:ee?ee===M?z:null:ae===M||ae.endsWith(oe)||ae.endsWith(ce)?z:null},W=[M];return pe.basenames=W,pe.patterns=[z],pe.allBasenames=W,pe}function O(M,z){const oe=te(M.slice(1,-1).split(",").map(ee=>h(ee,z)).filter(ee=>ee!==i),M),ce=oe.length;if(!ce)return i;if(ce===1)return oe[0];const pe=function(ee,H){for(let L=0,V=oe.length;L<V;L++)if(oe[L](ee,H))return M;return null},W=oe.find(ee=>!!ee.allBasenames);W&&(pe.allBasenames=W.allBasenames);const ae=oe.reduce((ee,H)=>H.allPaths?ee.concat(H.allPaths):ee,[]);return ae.length&&(pe.allPaths=ae),pe}function C(M,z,oe){const ce=A.sep===A.$gc.sep,pe=ce?M:M.replace(w,A.sep),W=A.sep+pe,ae=A.$gc.sep+M;let ee;return oe?ee=function(H,L){return typeof H=="string"&&(H===pe||H.endsWith(W)||!ce&&(H===M||H.endsWith(ae)))?z:null}:ee=function(H,L){return typeof H=="string"&&(H===pe||!ce&&H===M)?z:null},ee.allPaths=[(oe?"*/":"./")+M],ee}function P(M){try{const z=new RegExp(`^${c(M)}$`);return function(oe){return z.lastIndex=0,typeof oe=="string"&&z.test(oe)?M:null}}catch{return i}}function Q(M,z,oe){return!M||typeof z!="string"?!1:X(M)(z,void 0,oe)}function X(M,z={}){if(!M)return d;if(typeof M=="string"||ie(M)){const oe=h(M,z);if(oe===i)return d;const ce=function(pe,W){return!!oe(pe,W)};return oe.allBasenames&&(ce.allBasenames=oe.allBasenames),oe.allPaths&&(ce.allPaths=oe.allPaths),ce}return re(M,z)}function ie(M){const z=M;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}function ne(M){return M.allBasenames||[]}function x(M){return M.allPaths||[]}function re(M,z){const oe=te(Object.getOwnPropertyNames(M).map(ee=>q(ee,M[ee],z)).filter(ee=>ee!==i)),ce=oe.length;if(!ce)return i;if(!oe.some(ee=>!!ee.requiresSiblings)){if(ce===1)return oe[0];const ee=function(V,B){let U;for(let K=0,Z=oe.length;K<Z;K++){const j=oe[K](V,B);if(typeof j=="string")return j;(0,r.$mh)(j)&&(U||(U=[]),U.push(j))}return U?(async()=>{for(const K of U){const Z=await K;if(typeof Z=="string")return Z}return null})():null},H=oe.find(V=>!!V.allBasenames);H&&(ee.allBasenames=H.allBasenames);const L=oe.reduce((V,B)=>B.allPaths?V.concat(B.allPaths):V,[]);return L.length&&(ee.allPaths=L),ee}const pe=function(ee,H,L){let V,B;for(let U=0,K=oe.length;U<K;U++){const Z=oe[U];Z.requiresSiblings&&L&&(H||(H=(0,A.$nc)(ee)),V||(V=H.substr(0,H.length-(0,A.$oc)(ee).length)));const j=Z(ee,H,V,L);if(typeof j=="string")return j;(0,r.$mh)(j)&&(B||(B=[]),B.push(j))}return B?(async()=>{for(const U of B){const K=await U;if(typeof K=="string")return K}return null})():null},W=oe.find(ee=>!!ee.allBasenames);W&&(pe.allBasenames=W.allBasenames);const ae=oe.reduce((ee,H)=>H.allPaths?ee.concat(H.allPaths):ee,[]);return ae.length&&(pe.allPaths=ae),pe}function q(M,z,oe){if(z===!1)return i;const ce=h(M,oe);if(ce===i)return i;if(typeof z=="boolean")return ce;if(z){const pe=z.when;if(typeof pe=="string"){const W=(ae,ee,H,L)=>{if(!L||!ce(ae,ee))return null;const V=pe.replace("$(basename)",()=>H),B=L(V);return(0,r.$mh)(B)?B.then(U=>U?M:null):B?M:null};return W.requiresSiblings=!0,W}}return ce}function te(M,z){const oe=M.filter(ee=>!!ee.basenames);if(oe.length<2)return M;const ce=oe.reduce((ee,H)=>{const L=H.basenames;return L?ee.concat(L):ee},[]);let pe;if(z){pe=[];for(let ee=0,H=ce.length;ee<H;ee++)pe.push(z)}else pe=oe.reduce((ee,H)=>{const L=H.patterns;return L?ee.concat(L):ee},[]);const W=function(ee,H){if(typeof ee!="string")return null;if(!H){let V;for(V=ee.length;V>0;V--){const B=ee.charCodeAt(V-1);if(B===S.CharCode.Slash||B===S.CharCode.Backslash)break}H=ee.substr(V)}const L=ce.indexOf(H);return L!==-1?pe[L]:null};W.basenames=ce,W.patterns=pe,W.allBasenames=ce;const ae=M.filter(ee=>!ee.basenames);return ae.push(W),ae}function le(M,z){return(0,n.$ub)(M,z,(oe,ce)=>typeof oe=="string"&&typeof ce=="string"?oe===ce:typeof oe!="string"&&typeof ce!="string"?oe.base===ce.base&&oe.pattern===ce.pattern:!1)}}),define(Se[111],De([1,0,10,173,20,17,4]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.MarkdownStringTextNewlineStyle=void 0,e.$Yk=s,e.$Zk=E,e.$1k=y,e.$2k=$,e.$3k=w,e.$4k=a,e.$5k=f,e.$6k=c;var A;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class v{constructor(p="",m=!1){if(this.value=p,typeof this.value!="string")throw(0,n.$7)("value");typeof m=="boolean"?(this.isTrusted=m,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=m.isTrusted??void 0,this.supportThemeIcons=m.supportThemeIcons??!1,this.supportHtml=m.supportHtml??!1)}appendText(p,m=A.Paragraph){return this.value+=$(this.supportThemeIcons?(0,r.$Rk)(p):p).replace(/([ \t]+)/g,(b,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,m===A.Break?`\\
`:`

`),this}appendMarkdown(p){return this.value+=p,this}appendCodeblock(p,m){return this.value+=`
${w(m,p)}
`,this}appendLink(p,m,b){return this.value+="[",this.value+=this.c(m,"]"),this.value+="](",this.value+=this.c(String(p),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(p,m){const b=new RegExp((0,k.$df)(m),"g");return p.replace(b,(l,t)=>p.charAt(t-1)!=="\\"?`\\${l}`:l)}}e.$Xk=v;function s(g){return E(g)?!g.value:Array.isArray(g)?g.every(s):!0}function E(g){return g instanceof v?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||typeof g.isTrusted=="object"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}function y(g,p){return g===p?!0:!g||!p?!1:g.value===p.value&&g.isTrusted===p.isTrusted&&g.supportThemeIcons===p.supportThemeIcons&&g.supportHtml===p.supportHtml&&(g.baseUri===p.baseUri||!!g.baseUri&&!!p.baseUri&&(0,S.$7g)(R.URI.from(g.baseUri),R.URI.from(p.baseUri)))}function $(g){return g.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(g,p){const m=g.match(/^`+/gm)?.reduce((l,t)=>l.length>t.length?l:t).length??0,b=m>=3?m+1:3;return[`${"`".repeat(b)}${p}`,g,`${"`".repeat(b)}`].join(`
`)}function a(g){return g.replace(/"/g,"&quot;")}function f(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function c(g){const p=[],m=g.split("|").map(l=>l.trim());g=m[0];const b=m[1];if(b){const l=/height=(\d+)/.exec(b),t=/width=(\d+)/.exec(b),o=l?l[1]:"",d=t?t[1]:"",i=isFinite(parseInt(d)),h=isFinite(parseInt(o));i&&p.push(`width="${d}"`),h&&p.push(`height="${o}"`)}return{href:g,dimensions:p}}}),define(Se[176],De([1,0,18,37,9,3,20,17]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=v,e.$Ow=E,e.$Pw=$,e.$Qw=w,e.$Rw=g,e.$Sw=m,e.$Tw=b,e.$Uw=l,e.$Vw=t,e.$Ww=o;function v(i,h){const{os:u,tildify:D,relative:I}=h;if(I){const C=s(i,I,u);if(typeof C=="string")return C}let T=i.fsPath;if(u===k.OperatingSystem.Windows&&!k.$c?T=T.replace(/\//g,"\\"):u!==k.OperatingSystem.Windows&&k.$c&&(T=T.replace(/\\/g,"/")),u!==k.OperatingSystem.Windows&&D?.userHome){const C=D.userHome.fsPath;let P;i.scheme!==D.userHome.scheme&&i.path[0]===S.$gc.sep&&i.path[1]!==S.$gc.sep?P=D.userHome.with({path:i.path}).fsPath:P=T,T=$(P,C,u)}return(u===k.OperatingSystem.Windows?S.$fc:S.$gc).normalize(E(T,u===k.OperatingSystem.Windows))}function s(i,h,u){const D=u===k.OperatingSystem.Windows?S.$fc:S.$gc,I=u===k.OperatingSystem.Linux?R.$4g:R.$6g,T=h.getWorkspace(),O=(0,n.$Ob)(T.folders);if(!O)return;i.scheme!==O.uri.scheme&&i.path[0]===S.$gc.sep&&i.path[1]!==S.$gc.sep&&(i=O.uri.with({path:i.path}));const C=h.getWorkspaceFolder(i);if(!C)return;let P;if(I.isEqual(C.uri,i)?P="":P=I.relativePath(C.uri,i)??"",P&&(P=D.normalize(P)),T.folders.length>1&&!h.noPrefix){const Q=C.name?C.name:I.basenameOrAuthority(C.uri);P=P?`${Q} \u2022 ${P}`:Q}return P}function E(i,h=k.$c){return(0,r.$Eg)(i,h)?i.charAt(0).toUpperCase()+i.slice(1):i}let y=Object.create(null);function $(i,h,u=k.OS){if(u===k.OperatingSystem.Windows||!i||!h)return i;let D=y.original===h?y.normalized:void 0;D||(D=h,k.$c&&(D=(0,r.$tg)(D)),D=`${(0,A.$jf)(D,S.$gc.sep)}${S.$gc.sep}`,y={original:h,normalized:D});let I=i;return k.$c&&(I=(0,r.$tg)(I)),(u===k.OperatingSystem.Linux?I.startsWith(D):(0,A.$Cf)(I,D))?`~/${I.substr(D.length)}`:i}function w(i,h){return i.replace(/^~($|\/|\\)/,`${h}$1`)}const a="\u2026",f="\\\\",c="~";function g(i,h=S.sep){const u=new Array(i.length);let D=!1;for(let I=0;I<i.length;I++){const T=i[I];if(T===""){u[I]=`.${h}`;continue}if(!T){u[I]=T;continue}D=!0;let O="",C=T;C.indexOf(f)===0?(O=C.substr(0,C.indexOf(f)+f.length),C=C.substr(C.indexOf(f)+f.length)):C.indexOf(h)===0?(O=C.substr(0,C.indexOf(h)+h.length),C=C.substr(C.indexOf(h)+h.length)):C.indexOf(c)===0&&(O=C.substr(0,C.indexOf(c)+c.length),C=C.substr(C.indexOf(c)+c.length));const P=C.split(h);for(let Q=1;D&&Q<=P.length;Q++)for(let X=P.length-Q;D&&X>=0;X--){D=!1;let ie=P.slice(X,X+Q).join(h);for(let ne=0;!D&&ne<i.length;ne++)if(ne!==I&&i[ne]&&i[ne].indexOf(ie)>-1){const x=X+Q===P.length,re=X>0&&i[ne].indexOf(h)>-1?h+ie:ie,q=i[ne].endsWith(re);D=!x||q}if(!D){let ne="";(P[0].endsWith(":")||O!=="")&&(X===1&&(X=0,Q++,ie=P[0]+h+ie),X>0&&(ne=P[0]+h),ne=O+ne),X>0&&(ne=ne+a+h),ne=ne+ie,X+Q<P.length&&(ne=ne+h+a),u[I]=ne}}D&&(u[I]=T)}return u}var p;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function m(i,h=Object.create(null)){const u=[];let D=!1,I="";for(const T of i)if(T==="$"||D&&T==="{")I&&u.push({value:I,type:p.TEXT}),I="",D=!0;else if(T==="}"&&D){const O=h[I];if(typeof O=="string")O.length&&u.push({value:O,type:p.VARIABLE});else if(O){const C=u[u.length-1];(!C||C.type!==p.SEPARATOR)&&u.push({value:O.label,type:p.SEPARATOR})}I="",D=!1}else I+=T;return I&&!D&&u.push({value:I,type:p.TEXT}),u.filter((T,O)=>{if(T.type===p.SEPARATOR){const C=u[O-1],P=u[O+1];return[C,P].every(Q=>Q&&(Q.type===p.VARIABLE||Q.type===p.TEXT)&&Q.value.length>0)}return!0}).map(T=>T.value).join("")}function b(i,h){return k.$d||h?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.$d?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function l(i,h){return k.$d||h?i.replace(/\(&&\w\)|&&/g,""):k.$c?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function o(i){if(i.endsWith("]")){const h=i.lastIndexOf(" [",i.length-2);if(h!==-1){const u=d(i.substring(0,h)),D=i.substring(h);return{name:u.name+D,parentPath:u.parentPath}}}return d(i)}function d(i){const h=i.indexOf("/")!==-1?S.$gc:S.$fc,u=h.basename(i),D=h.dirname(i);return u.length?{name:u,parentPath:D}:{name:D,parentPath:""}}}),define(Se[59],De([1,0,15,80,4]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=void 0,e.$Gn=v,e.$Hn=E,e.$In=y;function k($){return $.toJSON()}class R{constructor(w){this.a=w}transformIncoming(w){const a=this.a.transformIncoming(w);return a===w?w:k(S.URI.from(a))}transformOutgoing(w){const a=this.a.transformOutgoing(w);return a===w?w:k(S.URI.from(a))}transformOutgoingURI(w){const a=this.a.transformOutgoing(w);return a===w?w:S.URI.from(a)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$En=R,e.$Fn=new class{transformIncoming($){return $}transformOutgoing($){return $}transformOutgoingURI($){return $}transformOutgoingScheme($){return $}};function A($,w,a){if(!$||a>200)return null;if(typeof $=="object"){if($ instanceof S.URI)return w.transformOutgoing($);for(const f in $)if(Object.hasOwnProperty.call($,f)){const c=A($[f],w,a+1);c!==null&&($[f]=c)}}return null}function v($,w){const a=A($,w,0);return a===null?$:a}function s($,w,a,f){if(!$||f>200)return null;if(typeof $=="object"){if($.$mid===r.MarshalledId.Uri)return a?S.URI.revive(w.transformIncoming($)):w.transformIncoming($);if($ instanceof n.$Je)return null;for(const c in $)if(Object.hasOwnProperty.call($,c)){const g=s($[c],w,a,f+1);g!==null&&($[c]=g)}}return null}function E($,w){const a=s($,w,!1,0);return a===null?$:a}function y($,w){const a=s($,w,!0,0);return a===null?$:a}}),define(Se[22],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=r;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function r(S){return n.test(S)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(A){for(let v=0;v<A.length;v++)A[v]=Math.floor(Math.random()*256);return A};const k=new Uint8Array(16),R=[];for(let A=0;A<256;A++)R.push(A.toString(16).padStart(2,"0"));return function(){S(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let v=0,s="";return s+=R[k[v++]],s+=R[k[v++]],s+=R[k[v++]],s+=R[k[v++]],s+="-",s+=R[k[v++]],s+=R[k[v++]],s+="-",s+=R[k[v++]],s+=R[k[v++]],s+="-",s+=R[k[v++]],s+=R[k[v++]],s+="-",s+=R[k[v++]],s+=R[k[v++]],s+=R[k[v++]],s+=R[k[v++]],s+=R[k[v++]],s+=R[k[v++]],s}}()}),define(Se[177],De([1,0,18,40,22]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$$s=void 0,e.$9s=k,e.$0s=R,e.$_s=s;function k(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function R(y,$,w){const a={id:(0,S.$Wg)(),name:y,uri:$,data:w};return{asString:async()=>"",asFile:()=>a,value:void 0}}class A{constructor(){this.a=new Map}get size(){let $=0;for(const w of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const w=[...this.a.keys()];return r.Iterable.some(this,([a,f])=>f.asFile())&&w.push("files"),E(v($),w)}get($){return this.a.get(this.b($))?.[0]}append($,w){const a=this.a.get($);a?a.push(w):this.a.set(this.b($),[w])}replace($,w){this.a.set(this.b($),[w])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,w]of this.a)for(const a of w)yield[$,a]}b($){return v($)}}e.$$s=A;function v(y){return y.toLowerCase()}function s(y,$){return E(v(y),$.map(v))}function E(y,$){if(y==="*/*")return $.length>0;if($.includes(y))return!0;const w=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[a,f,c]=w;return c==="*"?$.some(g=>g.startsWith(f+"/")):!1}e.$at=Object.freeze({create:y=>(0,n.$Mb)(y.map($=>$.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$at.split(y).filter($=>!$.startsWith("#"))})}),function(){"use strict";function he(e,n,r){function S(w){return new Promise(a=>n.exists(w,a))}function k(w){return new Promise((a,f)=>{const c=new Date;n.utimes(w,c,c,g=>g?f(g):a())})}function R(w){return new Promise((a,f)=>n.mkdir(w,{recursive:!0},c=>c&&c.code!=="EEXIST"?f(c):a(w)))}function A(w){return new Promise((a,f)=>n.rm(w,{recursive:!0,force:!0,maxRetries:3},c=>c?f(c):a()))}function v(w){return new Promise((a,f)=>n.readFile(w,"utf8",(c,g)=>c?f(c):a(g)))}function s(w,a){return new Promise((f,c)=>n.writeFile(w,a,"utf8",g=>g?c(g):f()))}async function E(w){const a=e.join(w,"languagepacks.json");try{return JSON.parse(await v(a))}catch{}}function y(w,a){try{for(;a;){if(w[a])return a;{const f=a.lastIndexOf("-");if(f>0)a=a.substring(0,f);else return}}}catch(f){console.error("Resolving language pack configuration failed.",f)}}function $(w,a,f,c,g){const p=function(b){return r.mark("code/didGenerateNls"),Promise.resolve({locale:b,osLocale:g,availableLanguages:{}})};if(r.mark("code/willGenerateNls"),c==="pseudo")return Promise.resolve({locale:c,osLocale:g,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:c,osLocale:g,availableLanguages:{}});if(c&&(c==="en"||c==="en-us"))return Promise.resolve({locale:c,osLocale:g,availableLanguages:{}});const m=c;try{return w?E(a).then(b=>{if(!b)return p(m);const l=y(b,c);if(!l)return p(m);c=l;const t=b[c];let o;return!t||typeof t.hash!="string"||!t.translations||typeof(o=t.translations.vscode)!="string"?p(m):S(o).then(d=>{if(!d)return p(m);const i=t.hash+"."+c,h=e.join(a,"clp",i),u=e.join(h,w),D=e.join(h,"tcf.json"),I=e.join(h,"corrupted.info"),T={locale:m,osLocale:g,availableLanguages:{"*":c},_languagePackId:i,_translationsConfigFile:D,_cacheRoot:h,_resolvedLanguagePackCoreLocation:u,_corruptedFile:I};return S(I).then(O=>{let C;return O?C=A(h):C=Promise.resolve(void 0),C.then(()=>S(u).then(P=>P?(k(u).catch(()=>{}),r.mark("code/didGenerateNls"),T):R(u).then(()=>Promise.all([v(f),v(o)])).then(Q=>{const X=JSON.parse(Q[0]),ie=JSON.parse(Q[1]).contents,ne=Object.keys(X.bundles),x=[];for(const re of ne){const q=X.bundles[re],te=Object.create(null);for(const le of q){const M=X.keys[le],z=X.messages[le],oe=ie[le];let ce;if(oe){ce=[];for(let pe=0;pe<M.length;pe++){const W=M[pe],ae=typeof W=="string"?W:W.key;let ee=oe[ae];ee===void 0&&(ee=z[pe]),ce.push(ee)}}else ce=z;te[le]=ce}x.push(s(e.join(u,re.replace(/\//g,"!")+".nls.json"),JSON.stringify(te)))}return x.push(s(D,JSON.stringify(t.translations))),Promise.all(x)}).then(()=>(r.mark("code/didGenerateNls"),T)).catch(Q=>(console.error("Generating translation files failed.",Q),p(c)))))})})}):p(m)}catch(b){return console.error("Generating translation files failed.",b),p(c)}}return{getNLSConfiguration:$}}if(typeof define=="function")define(Se[178],De([83,31,45]),function(e,n,r){return he(e,n,r)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("fs"),r=require("../common/performance");module.exports=he(e,n,r)}else throw new Error("Unknown context")}(),define(Se[179],De([1,0,32]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jn=k;const r=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(R){const A=R.replace(/\-/g,":").toLowerCase();return!r.has(A)}function k(){const R=(0,n.networkInterfaces)();for(const A in R){const v=R[A];if(v){for(const{mac:s}of v)if(S(s))return s}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(Se[112],De([1,0,32,69,22,179,3]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0,e.$Ln=v,e.$Mn=y,e.$Nn=$,e.$Kn=new class{c(w){return this.a||(this.a=r.$Gi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,a=0;const f=(0,n.networkInterfaces)();for(const c in f){const g=f[c];if(g)for(const{mac:p,internal:m}of g)m||(a+=1,this.c(p.toUpperCase())&&(w+=1))}this.b=a>0?w/a:0}return this.b}};let A;async function v(w){return A||(A=(async()=>await s(w)||S.$Wg())()),A}async function s(w){try{const a=await new Promise((c,g)=>{he(["crypto"],c,g)}),f=(0,k.$Jn)();return a.createHash("sha256").update(f,"utf8").digest("hex")}catch(a){w(a);return}}const E="Software\\Microsoft\\SQMClient";async function y(w){if(R.$c){const a=await new Promise((f,c)=>{he(["@vscode/windows-registry"],f,c)});try{return a.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(f){return w(f),""}}return""}async function $(w){try{return await(await new Promise((c,g)=>{he(["@vscode/deviceid"],c,g)})).getDeviceId()}catch(a){return w(a),""}}}),define(Se[180],De([1,0,31,333,334,3]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xg=R;async function R(A){if(k.$d||k.$c)return;let v;for(const s of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{v=await(0,r.open)(s,n.constants.R_OK);break}catch{}if(!v){A("Unable to retrieve release information from known identifier paths.");return}try{const s=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const y of(0,S.createInterface)({input:v.createReadStream(),crlfDelay:1/0})){if(!y.includes("="))continue;const $=y.split("=")[0].toUpperCase().trim();if(s.has($)){const w=y.split("=")[1].replace(/"/g,"").toLowerCase().trim();$==="ID"||$==="DISTRIB_ID"?E.id=w:$==="ID_LIKE"?E.id_like=w:($==="VERSION_ID"||$==="DISTRIB_RELEASE")&&(E.version_id=w)}}return E}catch(s){A(s)}}}),define(Se[25],De([1,0,31,32,335,14,37,108,9,3,20,4]),function(he,e,n,r,S,k,R,A,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=c,e.readdirSync=m,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=I;var $;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function w(re,q=$.UNLINK,te){if((0,R.$Dg)(re))throw new Error("rimraf - will refuse to recursively delete root");return q===$.UNLINK?f(re):a(re,te)}async function a(re,q=(0,R.$Ig)((0,r.tmpdir)())){try{try{await n.promises.rename(re,q)}catch(te){return te.code==="ENOENT"?void 0:f(re)}f(q).catch(te=>{})}catch(te){if(te.code!=="ENOENT")throw te}}async function f(re){return(0,S.promisify)(n.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function c(re){if((0,R.$Dg)(re))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}async function g(re,q){return b(await(q?p(re):(0,S.promisify)(n.readdir)(re)))}async function p(re){try{return await(0,S.promisify)(n.readdir)(re,{withFileTypes:!0})}catch(le){console.warn("[node.js fs] readdir with filetypes failed with error: ",le)}const q=[],te=await g(re);for(const le of te){let M=!1,z=!1,oe=!1;try{const ce=await e.Promises.lstat((0,v.$jc)(re,le));M=ce.isFile(),z=ce.isDirectory(),oe=ce.isSymbolicLink()}catch(ce){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ce)}q.push({name:le,isFile:()=>M,isDirectory:()=>z,isSymbolicLink:()=>oe})}return q}function m(re){return b(n.readdirSync(re))}function b(re){return re.map(q=>typeof q=="string"?s.$d?(0,A.$hm)(q):q:(q.name=s.$d?(0,A.$hm)(q.name):q.name,q))}async function l(re){const q=await g(re),te=[];for(const le of q)await o.existsDirectory((0,v.$jc)(re,le))&&te.push(le);return te}function t(re,q=1e3){return new Promise(te=>{let le=!1;const M=setInterval(()=>{le||(le=!0,n.access(re,z=>{le=!1,z&&(clearInterval(M),te(void 0))}))},q)})}var o;(function(re){async function q(M){let z;try{if(z=await e.Promises.lstat(M),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat(M),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(oe){if(oe.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(s.$c&&oe.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(ce){if(ce.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw ce}throw oe}}re.stat=q;async function te(M){try{const{stat:z,symbolicLink:oe}=await re.stat(M);return z.isFile()&&oe?.dangling!==!0}catch{}return!1}re.existsFile=te;async function le(M){try{const{stat:z,symbolicLink:oe}=await re.stat(M);return z.isDirectory()&&oe?.dangling!==!0}catch{}return!1}re.existsDirectory=le})(o||(e.SymlinkSupport=o={}));const d=new k.$Jh;function i(re,q,te){return d.queueFor(y.URI.file(re),()=>{const le=T(te);return new Promise((M,z)=>D(re,q,le,oe=>oe?z(oe):M()))},E.$5g)}let h=!0;function u(re){h=re}function D(re,q,te,le){if(!h)return n.writeFile(re,q,{mode:te.mode,flag:te.flag},le);n.open(re,te.flag,te.mode,(M,z)=>{if(M)return le(M);n.writeFile(z,q,oe=>{if(oe)return n.close(z,()=>le(oe));n.fdatasync(z,ce=>(ce&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ce),u(!1)),n.close(z,pe=>le(pe))))})})}function I(re,q,te){const le=T(te);if(!h)return n.writeFileSync(re,q,{mode:le.mode,flag:le.flag});const M=n.openSync(re,le.flag,le.mode);try{n.writeFileSync(M,q);try{n.fdatasyncSync(M)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),u(!1)}}finally{n.closeSync(M)}}function T(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function O(re,q,te=6e4){if(re!==q)try{s.$c&&typeof te=="number"?await C(re,q,Date.now(),te):await(0,S.promisify)(n.rename)(re,q)}catch(le){if(re.toLowerCase()!==q.toLowerCase()&&le.code==="EXDEV"||re.endsWith("."))await P(re,q,{preserveSymlinks:!1}),await w(re,$.MOVE);else throw le}}async function C(re,q,te,le,M=0){try{return await(0,S.promisify)(n.rename)(re,q)}catch(z){if(z.code!=="EACCES"&&z.code!=="EPERM"&&z.code!=="EBUSY")throw z;if(Date.now()-te>=le)throw console.error(`[node.js fs] rename failed after ${M} retries with error: ${z}`),z;if(M===0){let oe=!1;try{const{stat:ce}=await o.stat(q);ce.isFile()||(oe=!0)}catch{}if(oe)throw z}return await(0,k.$Bh)(Math.min(100,M*10)),C(re,q,te,le,M+1)}}async function P(re,q,te){return X(re,q,{root:{source:re,target:q},options:te,handledSourcePaths:new Set})}const Q=511;async function X(re,q,te){if(te.handledSourcePaths.has(re))return;te.handledSourcePaths.add(re);const{stat:le,symbolicLink:M}=await o.stat(re);if(M){if(te.options.preserveSymlinks)try{return await x(re,q,te)}catch{}if(M.dangling)return}return le.isDirectory()?ie(re,q,le.mode&Q,te):ne(re,q,le.mode&Q)}async function ie(re,q,te,le){await e.Promises.mkdir(q,{recursive:!0,mode:te});const M=await g(re);for(const z of M)await X((0,v.$jc)(re,z),(0,v.$jc)(q,z),le)}async function ne(re,q,te){await e.Promises.copyFile(re,q),await e.Promises.chmod(q,te)}async function x(re,q,te){let le=await e.Promises.readlink(re);(0,R.$zg)(le,te.root.source,!s.$e)&&(le=(0,v.$jc)(te.root.target,le.substr(te.root.source.length+1))),await e.Promises.symlink(le,q)}e.Promises=new class{get access(){return(0,S.promisify)(n.access)}get stat(){return(0,S.promisify)(n.stat)}get lstat(){return(0,S.promisify)(n.lstat)}get utimes(){return(0,S.promisify)(n.utimes)}get read(){return(re,q,te,le,M)=>new Promise((z,oe)=>{n.read(re,q,te,le,M,(ce,pe,W)=>ce?oe(ce):z({bytesRead:pe,buffer:W}))})}get readFile(){return(0,S.promisify)(n.readFile)}get write(){return(re,q,te,le,M)=>new Promise((z,oe)=>{n.write(re,q,te,le,M,(ce,pe,W)=>ce?oe(ce):z({bytesWritten:pe,buffer:W}))})}get appendFile(){return(0,S.promisify)(n.appendFile)}get fdatasync(){return(0,S.promisify)(n.fdatasync)}get truncate(){return(0,S.promisify)(n.truncate)}get copyFile(){return(0,S.promisify)(n.copyFile)}get open(){return(0,S.promisify)(n.open)}get close(){return(0,S.promisify)(n.close)}get symlink(){return(0,S.promisify)(n.symlink)}get readlink(){return(0,S.promisify)(n.readlink)}get chmod(){return(0,S.promisify)(n.chmod)}get mkdir(){return(0,S.promisify)(n.mkdir)}get unlink(){return(0,S.promisify)(n.unlink)}get rmdir(){return(0,S.promisify)(n.rmdir)}get realpath(){return(0,S.promisify)(n.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return l}get writeFile(){return i}get rm(){return w}get rename(){return O}get copy(){return P}}}),define(Se[181],De([1,0,31,9,3,17,25]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=A,e.$br=v,e.$cr=s,e.$dr=E;function A($){if(S.$e)return $;const w=(0,r.$mc)($);if($===w)return $;const a=((0,r.$nc)($)||$).toLowerCase();try{const c=(0,R.readdirSync)(w).filter(g=>g.toLowerCase()===a);if(c.length===1){const g=A(w);if(g)return(0,r.$jc)(g,c[0])}else if(c.length>1){const g=c.indexOf(a);if(g>=0){const p=A(w);if(p)return(0,r.$jc)(p,c[g])}}}catch{}return null}async function v($,w){if(S.$e)return $;const a=(0,r.$mc)($);if($===a)return $;const f=((0,r.$nc)($)||$).toLowerCase();try{if(w?.isCancellationRequested)return null;const g=(await R.Promises.readdir(a)).filter(p=>p.toLowerCase()===f);if(g.length===1){const p=await v(a,w);if(p)return(0,r.$jc)(p,g[0])}else if(g.length>1){const p=g.indexOf(f);if(p>=0){const m=await v(a,w);if(m)return(0,r.$jc)(m,g[p])}}}catch{}return null}async function s($){try{return await R.Promises.realpath($)}catch{const a=y($);return await R.Promises.access(a,n.constants.R_OK),a}}function E($){try{return n.realpathSync($)}catch{const a=y($);return n.accessSync(a,n.constants.R_OK),a}}function y($){return(0,k.$jf)((0,r.$hc)($),r.sep)}}),define(Se[182],De([1,0,84]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=r,e.$1g=k;function r(A,v,s,E=1){let y=!1;return new Promise($=>{const w=setTimeout(()=>{if(!y)return y=!0,$(0)},s);S(A,v,E,a=>{if(!y)return y=!0,clearTimeout(w),$(a)})})}function S(A,v,s,E){if(v===0)return E(0);const y=new n.Socket;y.once("connect",()=>(R(y),S(A+s,v-1,s,E))),y.once("data",()=>{}),y.once("error",$=>(R(y),$.code!=="ECONNREFUSED"?S(A+s,v-1,s,E):E(A))),y.connect(A,"127.0.0.1")}e.$Zg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function k(A,v,s,E="127.0.0.1"){let y=!1,$,w=1;const a=n.createServer({pauseOnConnect:!0});function f(c,g){y||(y=!0,a.removeAllListeners(),a.close(),$&&clearTimeout($),g(c))}return new Promise(c=>{$=setTimeout(()=>{f(0,c)},s),a.on("listening",()=>{f(A,c)}),a.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&w<v?(A++,w++,a.listen(A,E)):f(0,c)}),a.on("close",()=>{f(0,c)}),a.listen(A,E)})}function R(A){try{A.removeAllListeners("connect"),A.removeAllListeners("error"),A.end(),A.destroy(),A.unref()}catch(v){console.error(v)}}}),define(Se[113],De([1,0,32,9,25]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=p,e.$rm=m;const k=/^\d+$/,R=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var v;(function(b){b[b.x64=0]="x64",b[b.x86=1]="x86",b[b.ARM=2]="ARM"})(v||(v={}));let s;switch(process.arch){case"ia32":s=v.x86;break;case"arm":case"arm64":s=v.ARM;break;default:s=v.x64;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?v.ARM:v.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=v.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=v.x86:E=v.x64;class y{constructor(l,t,o){this.exePath=l,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function $({useAlternateBitness:b=!1}={}){return b?s===v.x64?process.env["ProgramFiles(x86)"]||null:E===v.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:b=!1,findPreview:l=!1}={}){const t=$({useAlternateBitness:b});if(!t)return null;const o=r.$jc(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(o))return null;let d=-1,i=null;for(const D of await S.Promises.readdir(o)){let I=-1;if(l){const O=D.indexOf("-");if(O<0)continue;const C=D.substring(0,O);if(!k.test(C)||D.substring(O+1)!=="preview")continue;I=parseInt(C,10)}else{if(!k.test(D))continue;I=parseInt(D,10)}if(I<=d)continue;const T=r.$jc(o,D,"pwsh.exe");await S.SymlinkSupport.existsFile(T)&&(i=T,d=I)}if(!i)return null;const h=t.includes("x86")?" (x86)":"",u=l?" Preview":"";return new y(i,`PowerShell${u}${h}`,!0)}async function a({findPreview:b}={}){if(!process.env.LOCALAPPDATA)return null;const l=r.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=b?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const d of await S.Promises.readdir(l))if(t.test(d)){const i=r.$jc(l,d,"pwsh.exe");return new y(i,o)}return null}function f(){const b=r.$jc(n.homedir(),".dotnet","tools","pwsh.exe");return new y(b,".NET Core PowerShell Global Tool")}function c(){const b=r.$jc(process.env.windir,s===v.x86&&E!==v.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new y(b,"Windows PowerShell",!0)}async function*g(){let b=await w();b&&(yield b),b=await w({useAlternateBitness:!0}),b&&(yield b),b=await a(),b&&(yield b),b=f(),b&&(yield b),b=await w({findPreview:!0}),b&&(yield b),b=await a({findPreview:!0}),b&&(yield b),b=await w({useAlternateBitness:!0,findPreview:!0}),b&&(yield b),b=c(),b&&(yield b)}async function*p(){for await(const b of g())await b.exists()&&(yield b)}async function m(){for await(const b of p())return b;return null}}),define(Se[114],De([1,0,9,3,33,67,11,25]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$um=v,e.$vm=s,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return k.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return k.TerminateResponseCode}});function v(y=S.env){return y.comspec||"cmd.exe"}function s(y){let $=[],w=!1;const a=function(f){if(w){$.push(f);return}(!y.send(f,g=>{if(g&&console.error(g),w=!1,$.length>0){const p=$.slice(0);$=[],p.forEach(m=>a(m))}})||r.$c)&&(w=!0)};return{send:a}}var E;(function(y){async function $(w,a,f){if(n.$ic(w))return w;if(a===void 0&&(a=S.cwd()),n.$mc(w)!=="."||(f===void 0&&R.$ag(S.env.PATH)&&(f=S.env.PATH.split(n.$tc)),f===void 0||f.length===0))return n.$jc(a,w);async function g(p){if(await A.Promises.exists(p)){let m;try{m=await A.Promises.stat(p)}catch(b){b.message.startsWith("EACCES")&&(m=await A.Promises.lstat(p))}return m?!m.isDirectory():!1}return!1}for(const p of f){let m;if(n.$ic(p)?m=n.$jc(p,w):m=n.$jc(a,p,w),await g(m))return m;let b=m+".com";if(await g(b)||(b=m+".exe",await g(b)))return b}return n.$jc(a,w)}y.findExecutable=$})(E||(e.win32=E={}))}),define(Se[115],De([1,0,60,13]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ms=S;function S(R){return new Promise((A,v)=>{let s;const E=new Map;function y(w,a,f,c,g){const p=E.get(a);if(w===R||p){const m={name:$(f),cmd:f,pid:w,ppid:a,load:c,mem:g};E.set(w,m),w===R&&(s=m),p&&(p.children||(p.children=[]),p.children.push(m),p.children.length>1&&(p.children=p.children.sort((b,l)=>b.pid-l.pid)))}}function $(w){const a=/--utility-sub-type=network/i,f=/--crashes-directory/i,c=/\\pipe\\winpty-control/i,g=/conhost\.exe.+--headless/i,p=/--type=([a-zA-Z-]+)/;if(f.exec(w))return"electron-crash-reporter";if(c.exec(w))return"winpty-agent";if(g.exec(w))return"conpty-agent";let m=p.exec(w);if(m&&m.length===2)return m[1]==="renderer"?"window":m[1]==="utility"?a.exec(w)?"utility-network-service":"utility-process":m[1]==="extensionHost"?"extension-host":m[1];const b=/[a-zA-Z-]+\.js/g;let l="";do m=b.exec(w),m&&(l+=m+" ");while(m);return l&&w.indexOf("node ")<0&&w.indexOf("node.exe")<0?`electron-nodejs (${l})`:w}if(process.platform==="win32"){const w=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,f)=>{he(["@vscode/windows-process-tree"],a,f)}).then(a=>{a.getProcessList(R,f=>{if(!f){v(new Error(`Root process ${R} not found`));return}a.getProcessCpuUsage(f,c=>{const g=new Map;c.forEach(p=>{const m=w(p.commandLine||"");g.set(p.pid,{name:$(m),cmd:m,pid:p.pid,ppid:p.ppid,load:p.cpu||0,mem:p.memory||0})}),s=g.get(R),s?(g.forEach(p=>{const m=g.get(p.ppid);m&&(m.children||(m.children=[]),m.children.push(p))}),g.forEach(p=>{p.children&&(p.children=p.children.sort((m,b)=>m.pid-b.pid))}),A(s)):v(new Error(`Root process ${R} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let w=function(){let a=[s];const f=[];for(;a.length;){const g=a.shift();g&&(f.push(g.pid),g.children&&(a=a.concat(g.children)))}let c=JSON.stringify(r.$Ug.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+f.join(" "),(0,n.exec)(c,{},(g,p,m)=>{if(g||m)v(g||new Error(m.toString()));else{const b=p.toString().split(`
`);for(let l=0;l<f.length;l++){const t=E.get(f[l]);t.load=parseFloat(b[l])}if(!s){v(new Error(`Root process ${R} not found`));return}A(s)}})};(0,n.exec)("which ps",{},(a,f,c)=>{if(a||c)if(process.platform!=="linux")v(a||new Error(c.toString()));else{const g=JSON.stringify(r.$Ug.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(g,{},(p,m,b)=>{p||b?v(p||new Error(b.toString())):(k(m,y),w())})}else{const g=f.toString().trim();(0,n.exec)(`${g} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(m,b,l)=>{m||l&&!l.includes("screen size is bogus")?v(m||new Error(l.toString())):(k(b,y),process.platform==="linux"?w():s?A(s):v(new Error(`Root process ${R} not found`)))})}})}})}function k(R,A){const v=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,s=R.toString().split(`
`);for(const E of s){const y=v.exec(E.trim());y&&y.length===6&&A(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}}),define(Se[116],De([1,0,32,3,113,114]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=R;async function R(y,$){return y===r.OperatingSystem.Windows?r.$c?E():k.$um($):v(y,$)}let A=null;function v(y,$){if(r.$e&&y===r.OperatingSystem.Macintosh||r.$d&&y===r.OperatingSystem.Linux)return"/bin/bash";if(!A){let w;if(r.$c)w="/bin/bash";else{if(w=$.SHELL,!w)try{w=(0,n.userInfo)().shell}catch{}w||(w="sh"),w==="/bin/false"&&(w="/bin/bash")}A=w}return A}let s=null;async function E(){return s||(s=(await(0,S.$rm)()).exePath),s}}),function(){function he(){function e(){return process.uncHostAllowlist}function n(v){const s=new Set;if(Array.isArray(v))for(const E of v)typeof E=="string"&&s.add(E);return Array.from(s)}function r(){const v=e();return v?Array.from(v):[]}function S(v){if(process.platform!=="win32")return;const s=e();if(s)if(typeof v=="string")s.add(v.toLowerCase());else for(const E of n(v))S(E)}function k(v){if(typeof v!="string")return;const s=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let E;for(const y of s){if(v.indexOf(y)!==0)continue;const w=v.indexOf("\\",y.length);if(w===-1)continue;const a=v.substring(y.length,w);if(a){E=a;break}}return E}function R(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function A(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:r,addUNCHostToAllowlist:S,getUNCHost:k,disableUNCAccessRestrictions:R,isUNCAccessRestrictionsDisabled:A}}typeof define=="function"?define("vs/base/node/unc",[],function(){return he()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=he():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}();var Ue=this&&this.__decorate||function(he,e,n,r){var S=arguments.length,k=S<3?e:r===null?r=Object.getOwnPropertyDescriptor(e,n):r,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(he,e,n,r);else for(var A=he.length-1;A>=0;A--)(R=he[A])&&(k=(S<3?R(k):S>3?R(e,n,k):R(e,n))||k);return S>3&&k&&Object.defineProperty(e,n,k),k};define(Se[49],De([1,0,18,14,15,19,77,10,6,2,48,17,11]),function(he,e,n,r,S,k,R,A,v,s,E,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=u,e.$bi=D,e.$gi=Q,e.$hi=X;var w;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(w||(w={}));function a(M){switch(M){case w.Promise:return"req";case w.PromiseCancel:return"cancel";case w.EventListen:return"subscribe";case w.EventDispose:return"unsubscribe"}}var f;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(f||(f={}));function c(M){switch(M){case f.Initialize:return"init";case f.PromiseSuccess:return"reply:";case f.PromiseError:case f.PromiseErrorObj:return"replyErr:";case f.EventFire:return"event:"}}var g;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(g||(g={}));function p(M){let z=0;for(let oe=0;;oe+=7){const ce=M.read(1);if(z|=(ce.buffer[0]&127)<<oe,!(ce.buffer[0]&128))return z}}const m=d(0);function b(M,z){if(z===0){M.write(m);return}let oe=0;for(let pe=z;pe!==0;pe=pe>>>7)oe++;const ce=S.$Je.alloc(oe);for(let pe=0;z!==0;pe++)ce.buffer[pe]=z&127,z=z>>>7,z>0&&(ce.buffer[pe]|=128);M.write(ce)}class l{constructor(z){this.b=z,this.a=0}read(z){const oe=this.b.slice(this.a,this.a+z);return this.a+=oe.byteLength,oe}}e.$$h=l;class t{constructor(){this.a=[]}get buffer(){return S.$Je.concat(this.a)}write(z){this.a.push(z)}}e.$_h=t;var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(o||(o={}));function d(M){const z=S.$Je.alloc(1);return z.writeUInt8(M,0),z}const i={Undefined:d(o.Undefined),String:d(o.String),Buffer:d(o.Buffer),VSBuffer:d(o.VSBuffer),Array:d(o.Array),Object:d(o.Object),Uint:d(o.Int)},h=typeof Buffer<"u";function u(M,z){if(typeof z>"u")M.write(i.Undefined);else if(typeof z=="string"){const oe=S.$Je.fromString(z);M.write(i.String),b(M,oe.byteLength),M.write(oe)}else if(h&&Buffer.isBuffer(z)){const oe=S.$Je.wrap(z);M.write(i.Buffer),b(M,oe.byteLength),M.write(oe)}else if(z instanceof S.$Je)M.write(i.VSBuffer),b(M,z.byteLength),M.write(z);else if(Array.isArray(z)){M.write(i.Array),b(M,z.length);for(const oe of z)u(M,oe)}else if(typeof z=="number"&&(z|0)===z)M.write(i.Uint),b(M,z);else{const oe=S.$Je.fromString(JSON.stringify(z));M.write(i.Object),b(M,oe.byteLength),M.write(oe)}}function D(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(p(M)).toString();case o.Buffer:return M.read(p(M)).buffer;case o.VSBuffer:return M.read(p(M));case o.Array:{const oe=p(M),ce=[];for(let pe=0;pe<oe;pe++)ce.push(D(M));return ce}case o.Object:return JSON.parse(M.read(p(M)).toString());case o.Int:return p(M)}}class I{constructor(z,oe,ce=null,pe=1e3){this.h=z,this.j=oe,this.k=ce,this.l=pe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(W=>this.q(W)),this.m({type:f.Initialize})}registerChannel(z,oe){this.b.set(z,oe),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case f.Initialize:{const oe=this.o([z.type]);this.k?.logOutgoing(oe,0,T.OtherSide,c(z.type));return}case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:{const oe=this.o([z.type,z.id],z.data);this.k?.logOutgoing(oe,z.id,T.OtherSide,c(z.type),z.data);return}}}o(z,oe=void 0){const ce=new t;return u(ce,z),u(ce,oe),this.p(ce.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const oe=new l(z),ce=D(oe),pe=D(oe),W=ce[0];switch(W){case w.Promise:return this.k?.logIncoming(z.byteLength,ce[1],T.OtherSide,`${a(W)}: ${ce[2]}.${ce[3]}`,pe),this.s({type:W,id:ce[1],channelName:ce[2],name:ce[3],arg:pe});case w.EventListen:return this.k?.logIncoming(z.byteLength,ce[1],T.OtherSide,`${a(W)}: ${ce[2]}.${ce[3]}`,pe),this.t({type:W,id:ce[1],channelName:ce[2],name:ce[3],arg:pe});case w.PromiseCancel:return this.k?.logIncoming(z.byteLength,ce[1],T.OtherSide,`${a(W)}`),this.u({type:W,id:ce[1]});case w.EventDispose:return this.k?.logIncoming(z.byteLength,ce[1],T.OtherSide,`${a(W)}`),this.u({type:W,id:ce[1]})}}s(z){const oe=this.b.get(z.channelName);if(!oe){this.v(z);return}const ce=new k.$se;let pe;try{pe=oe.call(this.j,z.name,z.arg,ce.token)}catch(ee){pe=Promise.reject(ee)}const W=z.id;pe.then(ee=>{this.m({id:W,data:ee,type:f.PromiseSuccess})},ee=>{ee instanceof Error?this.m({id:W,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:f.PromiseError}):this.m({id:W,data:ee,type:f.PromiseErrorObj})}).finally(()=>{ae.dispose(),this.d.delete(z.id)});const ae=(0,s.$Sc)(()=>ce.cancel());this.d.set(z.id,ae)}t(z){const oe=this.b.get(z.channelName);if(!oe){this.v(z);return}const ce=z.id,W=oe.listen(this.j,z.name,z.arg)(ae=>this.m({id:ce,data:ae,type:f.EventFire}));this.d.set(z.id,W)}u(z){const oe=this.d.get(z.id);oe&&(oe.dispose(),this.d.delete(z.id))}v(z){let oe=this.g.get(z.channelName);oe||(oe=[],this.g.set(z.channelName,oe));const ce=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===w.Promise&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:f.PromiseError})},this.l);oe.push({request:z,timeoutTimer:ce})}w(z){const oe=this.g.get(z);if(oe){for(const ce of oe)switch(clearTimeout(ce.timeoutTimer),ce.request.type){case w.Promise:this.s(ce.request);break;case w.EventListen:this.t(ce.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,s.$Pc)(this.d.values()),this.d.clear()}}e.$ci=I;var T;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(T||(e.RequestInitiator=T={}));class O{constructor(z,oe=null){this.l=z,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new v.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ce=>this.s(ce)),this.j=oe}getChannel(z){const oe=this;return{call(ce,pe,W){return oe.a?Promise.reject(new A.$5):oe.m(z,ce,pe,W)},listen(ce,pe){return oe.a?v.Event.None:oe.o(z,ce,pe)}}}m(z,oe,ce,pe=k.CancellationToken.None){const W=this.g++,ae=w.Promise,ee={id:W,type:ae,channelName:z,name:oe,arg:ce};if(pe.isCancellationRequested)return Promise.reject(new A.$5);let H;return new Promise((V,B)=>{if(pe.isCancellationRequested)return B(new A.$5);const U=()=>{const G=se=>{switch(se.type){case f.PromiseSuccess:this.f.delete(W),V(se.data);break;case f.PromiseError:{this.f.delete(W);const fe=new Error(se.data.message);fe.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,fe.name=se.data.name,B(fe);break}case f.PromiseErrorObj:this.f.delete(W),B(se.data);break}};this.f.set(W,G),this.p(ee)};let K=null;this.b===g.Idle?U():(K=(0,r.$nh)(G=>this.u()),K.then(()=>{K=null,U()}));const Z=()=>{K?(K.cancel(),K=null):this.p({id:W,type:w.PromiseCancel}),B(new A.$5)},j=pe.onCancellationRequested(Z);H=(0,s.$Rc)((0,s.$Sc)(Z),j),this.d.add(H)}).finally(()=>{H.dispose(),this.d.delete(H)})}o(z,oe,ce){const pe=this.g++,W=w.EventListen,ae={id:pe,type:W,channelName:z,name:oe,arg:ce};let ee=null;const H=new v.$he({onWillAddFirstListener:()=>{ee=(0,r.$nh)(V=>this.u()),ee.then(()=>{ee=null,this.d.add(H),this.p(ae)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(H),this.p({id:pe,type:w.EventDispose}))}}),L=V=>H.fire(V.data);return this.f.set(pe,L),H.event}p(z){switch(z.type){case w.Promise:case w.EventListen:{const oe=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(oe,z.id,T.LocalSide,`${a(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case w.PromiseCancel:case w.EventDispose:{const oe=this.q([z.type,z.id]);this.j?.logOutgoing(oe,z.id,T.LocalSide,a(z.type));return}}}q(z,oe=void 0){const ce=new t;return u(ce,z),u(ce,oe),this.r(ce.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const oe=new l(z),ce=D(oe),pe=D(oe),W=ce[0];switch(W){case f.Initialize:return this.j?.logIncoming(z.byteLength,0,T.LocalSide,c(W)),this.t({type:ce[0]});case f.PromiseSuccess:case f.PromiseError:case f.EventFire:case f.PromiseErrorObj:return this.j?.logIncoming(z.byteLength,ce[1],T.LocalSide,c(W),pe),this.t({type:ce[0],id:ce[1],data:pe})}}t(z){if(z.type===f.Initialize){this.b=g.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,s.$Pc)(this.d.values()),this.d.clear()}}e.$di=O,Ue([R.$5h],O.prototype,"onDidInitializePromise",null);class C{get connections(){const z=[];return this.f.forEach(oe=>z.push(oe)),z}constructor(z,oe,ce){this.a=new Map,this.f=new Set,this.g=new v.$he,this.onDidAddConnection=this.g.event,this.h=new v.$he,this.onDidRemoveConnection=this.h.event,this.j=new s.$Tc,this.j.add(z(({protocol:pe,onDidClientDisconnect:W})=>{const ae=v.Event.once(pe.onMessage);this.j.add(ae(ee=>{const H=new l(ee),L=D(H),V=new I(pe,L,oe,ce),B=new O(pe,oe);this.a.forEach((K,Z)=>V.registerChannel(Z,K));const U={channelServer:V,channelClient:B,ctx:L};this.f.add(U),this.g.fire(U),this.j.add(W(()=>{V.dispose(),B.dispose(),this.f.delete(U),this.h.fire(U)}))}))}))}getChannel(z,oe){const ce=this;return{call(pe,W,ae){let ee;if((0,$.$og)(oe)){const L=(0,n.$3b)(ce.connections.filter(oe));ee=L?Promise.resolve(L):v.Event.toPromise(v.Event.filter(ce.onDidAddConnection,oe))}else ee=oe.routeCall(ce,pe,W);const H=ee.then(L=>L.channelClient.getChannel(z));return Q(H).call(pe,W,ae)},listen(pe,W){if((0,$.$og)(oe))return ce.k(z,oe,pe,W);const ae=oe.routeEvent(ce,pe,W).then(ee=>ee.channelClient.getChannel(z));return Q(ae).listen(pe,W)}}}k(z,oe,ce,pe){const W=this;let ae;const ee=new v.$he({onWillAddFirstListener:()=>{ae=new s.$Tc;const H=new v.$ne,L=new Map,V=U=>{const Z=U.channelClient.getChannel(z).listen(ce,pe),j=H.add(Z);L.set(U,j)},B=U=>{const K=L.get(U);K&&(K.dispose(),L.delete(U))};W.connections.filter(oe).forEach(V),v.Event.filter(W.onDidAddConnection,oe)(V,void 0,ae),W.onDidRemoveConnection(B,void 0,ae),H.event(ee.fire,ee,ae),ae.add(H)},onDidRemoveLastListener:()=>{ae?.dispose(),ae=void 0}});return ee.event}registerChannel(z,oe){this.a.set(z,oe);for(const ce of this.f)ce.channelServer.registerChannel(z,oe)}dispose(){this.j.dispose();for(const z of this.f)z.channelClient.dispose(),z.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=C;class P{constructor(z,oe,ce=null){const pe=new t;u(pe,oe),z.send(pe.buffer),this.a=new O(z,ce),this.d=new I(z,oe,ce)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,oe){this.d.registerChannel(z,oe)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=P;function Q(M){return{call(z,oe,ce){return M.then(pe=>pe.call(z,oe,ce))},listen(z,oe){const ce=new v.$qe;return M.then(pe=>ce.input=pe.listen(z,oe)),ce.event}}}function X(M){let z=!1;return{call(oe,ce,pe){return z?M.call(oe,ce,pe):(0,r.$Bh)(0).then(()=>z=!0).then(()=>M.call(oe,ce,pe))},listen(oe,ce){if(z)return M.listen(oe,ce);const pe=new v.$qe;return(0,r.$Bh)(0).then(()=>z=!0).then(()=>pe.input=M.listen(oe,ce)),pe.event}}}class ie{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const oe of z.connections)if(await Promise.resolve(this.a(oe.ctx)))return Promise.resolve(oe);return await v.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.$ii=ie;var ne;(function(M){function z(W,ae,ee){const H=W,L=ee&&ee.disableMarshalling,V=new Map;for(const B in H)ce(B)&&V.set(B,v.Event.buffer(H[B],!0,void 0,ae));return new class{listen(B,U,K){const Z=V.get(U);if(Z)return Z;const j=H[U];if(typeof j=="function"){if(pe(U))return j.call(H,K);if(ce(U))return V.set(U,v.Event.buffer(H[U],!0,void 0,ae)),V.get(U)}throw new A.$bb(`Event not found: ${U}`)}call(B,U,K){const Z=H[U];if(typeof Z=="function"){if(!L&&Array.isArray(K))for(let G=0;G<K.length;G++)K[G]=(0,E.$0h)(K[G]);let j=Z.apply(H,K);return j instanceof Promise||(j=Promise.resolve(j)),j}throw new A.$bb(`Method not found: ${U}`)}}}M.fromService=z;function oe(W,ae){const ee=ae&&ae.disableMarshalling;return new Proxy({},{get(H,L){if(typeof L=="string")return ae?.properties?.has(L)?ae.properties.get(L):pe(L)?function(V){return W.listen(L,V)}:ce(L)?W.listen(L):async function(...V){let B;ae&&!(0,$.$jg)(ae.context)?B=[ae.context,...V]:B=V;const U=await W.call(L,B);return ee?U:(0,E.$0h)(U)};throw new A.$bb(`Property not found: ${String(L)}`)}})}M.toService=oe;function ce(W){return W[0]==="o"&&W[1]==="n"&&y.$Af(W.charCodeAt(2))}function pe(W){return/^onDynamic/.test(W)&&y.$Af(W.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const x=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const z=M.toString();if(z!=="[object Object]")return z}return M}function q(M){return Array.isArray(M)?M.map(re):re(M)}function te(M,z,oe,ce,pe,W,ae){ae=q(ae);const ee=x[pe],H=ee[ce%ee.length];let L=[`%c[${M}]%c[${String(z).padStart(7," ")}]%c[len: ${String(oe).padStart(5," ")}]%c${String(ce).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${H}`];/\($/.test(W)?(L=L.concat(ae),L.push(")")):L.push(ae),console.log.apply(console,L)}class le{constructor(z,oe){this.d=z,this.f=oe,this.a=0,this.b=0}logOutgoing(z,oe,ce,pe,W){this.b+=z,te(this.d,this.b,z,oe,ce,pe,W)}logIncoming(z,oe,ce,pe,W){this.a+=z,te(this.f,this.a,z,oe,ce,pe,W)}}e.$ji=le}),define(Se[61],De([1,0,15,6,2,49]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.ProtocolConstants=e.$ki=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var A;(function(i){i.enableDiagnostics=!1,i.records=[];const h=new WeakMap;let u=0;function D(T,O){if(!h.has(T)){const C=String(++u);h.set(T,C)}return h.get(T)}function I(T,O,C,P){if(!i.enableDiagnostics)return;const Q=D(T,O);if(P instanceof n.$Je||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const X=n.$Je.alloc(P.byteLength);X.set(P),i.records.push({timestamp:Date.now(),id:Q,label:O,type:C,buff:X})}else i.records.push({timestamp:Date.now(),id:Q,label:O,type:C,data:P})}i.traceSocketEvent=I})(A||(e.SocketDiagnostics=A={}));var v;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let s=null;function E(){return s||(s=n.$Je.alloc(0)),s}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(h){this.a.push(h),this.b+=h.byteLength}read(h){return this.c(h,!0)}peek(h){return this.c(h,!1)}c(h,u){if(h===0)return E();if(h>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===h){const O=this.a[0];return u&&(this.a.shift(),this.b-=h),O}if(this.a[0].byteLength>h){const O=this.a[0].slice(0,h);return u&&(this.a[0]=this.a[0].slice(h),this.b-=h),O}const D=n.$Je.alloc(h);let I=0,T=0;for(;h>0;){const O=this.a[T];if(O.byteLength>h){const C=O.slice(0,h);D.set(C,I),I+=h,u&&(this.a[T]=O.slice(h),this.b-=h),h-=h}else D.set(O,I),I+=O.byteLength,u?(this.a.shift(),this.b-=O.byteLength):T++,h-=O.byteLength}return D}}e.$ki=y;var $;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})($||($={}));function w(i){switch(i){case $.None:return"None";case $.Regular:return"Regular";case $.Control:return"Control";case $.Ack:return"Ack";case $.Disconnect:return"Disconnect";case $.ReplayRequest:return"ReplayRequest";case $.Pause:return"PauseWriting";case $.Resume:return"ResumeWriting";case $.KeepAlive:return"KeepAlive"}}var a;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(a||(e.ProtocolConstants=a={}));class f{constructor(h,u,D,I){this.type=h,this.id=u,this.ack=D,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends S.$Uc{constructor(h){super(),this.f=this.B(new r.$he),this.onMessage=this.f.event,this.g={readHead:!0,readLen:a.HeaderLength,messageType:$.None,id:0,ack:0},this.a=h,this.b=!1,this.c=new y,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(h){if(!(!h||h.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(h);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent(R.ProtocolHeaderRead,{messageType:w(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const D=this.g.messageType,I=this.g.id,T=this.g.ack;if(this.g.readHead=!0,this.g.readLen=a.HeaderLength,this.g.messageType=$.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(R.ProtocolMessageRead,u),this.f.fire(new f(D,I,T,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(h){this.k=null,this.a=!1,this.b=!1,this.c=h,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(h){if(this.a)return;h.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.$Je.alloc(a.HeaderLength);u.writeUInt8(h.type,0),u.writeUInt32BE(h.id,1),u.writeUInt32BE(h.ack,5),u.writeUInt32BE(h.data.byteLength,9),this.c.traceSocketEvent(R.ProtocolHeaderWrite,{messageType:w(h.type),id:h.id,ack:h.ack,messageSize:h.data.byteLength}),this.c.traceSocketEvent(R.ProtocolMessageWrite,h.data),this.j(u,h.data)}g(h,u){const D=this.f===0;return this.d.push(h,u),this.f+=h.byteLength+u.byteLength,D}h(){const h=n.$Je.concat(this.d,this.f);return this.d.length=0,this.f=0,h}j(h,u){this.g(h,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const h=this.h();this.c.traceSocketEvent(R.ProtocolWrite,{byteLength:h.byteLength}),this.c.write(h)}}class p extends S.$Uc{constructor(h){super(),this.f=new r.$he,this.onMessage=this.f.event,this.g=new r.$he,this.onDidDispose=this.g.event,this.a=h,this.b=this.B(new g(this.a)),this.c=this.B(new c(this.a)),this.B(this.c.onMessage(u=>{u.type===$.Regular&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(h){this.b.write(new f($.Regular,0,0,h))}}e.$li=p;class m extends k.$fi{static fromSocket(h,u){return new m(new p(h),u)}get onDidDispose(){return this.b.onDidDispose}constructor(h,u,D=null){super(h,u,D),this.b=h}dispose(){super.dispose();const h=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),h.end()}}e.$mi=m;class b{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new r.$he({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(h){this.b?this.d.length>0?this.d.push(h):this.a.fire(h):this.d.push(h)}flushBuffer(){this.d=[]}}e.$ni=b;class l{constructor(h){this.data=h,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let h=0,u=this.a;for(;u;)u=u.next,h++;return h}peek(){return this.a?this.a.data:null}toArray(){const h=[];let u=0,D=this.a;for(;D;)h[u++]=D.data,D=D.next;return h}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(h){const u=new l(h);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class o{static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const h=Date.now();for(let u=0;u<o.a;u++)this.c[u]=h-1e3*u;setInterval(()=>{for(let u=o.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const h=Date.now(),u=(1+o.a)*1e3;let D=0;for(let I=0;I<o.a;I++)h-this.c[I]<=u&&D++;return 1-D/o.a}hasHighLoad(){return this.d()>=.5}}o.a=10,o.b=null;class d{get unacknowledgedCount(){return this.c-this.d}constructor(h){this.u=new b,this.onControlMessage=this.u.event,this.v=new b,this.onMessage=this.v.event,this.w=new b,this.onDidDispose=this.w.event,this.x=new b,this.onSocketClose=this.x.event,this.y=new b,this.onSocketTimeout=this.y.event,this.s=h.loadEstimator??o.getInstance(),this.t=h.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Tc,this.o=h.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),h.initialChunk&&this.q.acceptChunk(h.initialChunk),this.t?this.l=setInterval(()=>{this.D()},a.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const h=new f($.Disconnect,0,0,E());this.p.write(h),this.p.flush()}sendPause(){const h=new f($.Pause,0,0,E());this.p.write(h)}sendResume(){const h=new f($.Resume,0,0,E());this.p.write(h)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(h,u){this.a=!0,this.r.dispose(),this.r=new S.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=h,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(D=>this.z(D))),this.r.add(this.o.onClose(D=>this.x.fire(D))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const h=new f($.Ack,0,this.h,E());this.p.write(h);const u=this.b.toArray();for(let D=0,I=u.length;D<I;D++)this.p.write(u[D]);this.B()}acceptDisconnect(){this.w.fire()}z(h){if(h.ack>this.d){this.d=h.ack;do{const u=this.b.peek();if(u&&u.id<=h.ack)this.b.pop();else break}while(!0)}switch(h.type){case $.None:break;case $.Regular:{if(h.id>this.g)if(h.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new f($.ReplayRequest,0,0,E())))}else this.g=h.id,this.j=Date.now(),this.A(),this.v.fire(h.data);break}case $.Control:{this.u.fire(h.data);break}case $.Ack:break;case $.Disconnect:{this.w.fire();break}case $.ReplayRequest:{const u=this.b.toArray();for(let D=0,I=u.length;D<I;D++)this.p.write(u[D]);this.B();break}case $.Pause:{this.p.pause();break}case $.Resume:{this.p.resume();break}case $.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(h){const u=++this.c;this.h=this.g;const D=new f($.Regular,u,this.h,h);this.b.push(D),this.a||(this.p.write(D),this.B())}sendControl(h){const u=new f($.Control,0,0,h);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const h=Date.now()-this.j;if(h>=a.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},a.AcknowledgeTime-h+5)}B(){if(this.c<=this.d||this.f||this.a)return;const h=this.b.peek(),u=Date.now()-h.writtenTime,D=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(u>=a.TimeoutTime&&D>=a.TimeoutTime&&I>=a.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:D});return}const T=Math.max(a.TimeoutTime-u,a.TimeoutTime-D,a.TimeoutTime-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},T)}C(){if(this.g<=this.h)return;this.h=this.g;const h=new f($.Ack,0,this.h,E());this.p.write(h)}D(){this.h=this.g;const h=new f($.KeepAlive,0,this.h,E());this.p.write(h)}}e.$oi=d}),define(Se[117],De([1,0,60,14,15,19,174,10,6,2,21,114,67,49]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=void 0;class a extends w.$ci{constructor(g){super({send:p=>{try{process.send?.(p.buffer.toString("base64"))}catch{}},onMessage:v.Event.fromNodeEventEmitter(process,"message",p=>S.$Je.wrap(Buffer.from(p,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$9q=a;class f{constructor(g,p){this.i=g,this.j=p,this.c=new Set,this.g=new Map,this.h=new v.$he,this.onDidProcessExit=this.h.event;const m=p&&p.timeout?p.timeout:6e4;this.b=new r.$xh(m),this.d=null,this.f=null}getChannel(g){const p=this;return{call(m,b,l){return p.k(g,m,b,l)},listen(m,b){return p.l(g,m,b)}}}k(g,p,m,b=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(b.isCancellationRequested)return Promise.reject(A.$6());this.b.cancel();const l=this.n(g),t=(0,r.$nh)(i=>l.call(p,m,i)),o=b.onCancellationRequested(()=>t.cancel()),d=(0,s.$Sc)(()=>t.cancel());return this.c.add(d),t.finally(()=>{o.dispose(),this.c.delete(d),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,p,m){if(!this.b)return v.Event.None;this.b.cancel();let b;const l=new v.$he({onWillAddFirstListener:()=>{b=this.n(g).listen(p,m)(l.fire,l),this.c.add(b)},onDidRemoveLastListener:()=>{this.c.delete(b),b.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return l.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],p=Object.create(null);p.env={...(0,E.$0n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(p.env={...p.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(p.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(p.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(p.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),p.execArgv===void 0&&(p.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,$.$tm)(p.env),this.d=(0,n.fork)(this.i,g,p);const m=new v.$he,l=v.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,R.$5q)(u)){(0,R.log)(u,`IPC Library: ${this.j.serverName}`);return}m.fire(S.$Je.wrap(Buffer.from(u,"base64")))}),t=this.j.useQueue?(0,y.$vm)(this.d):this.d,o=u=>this.d&&this.d.connected&&t.send(u.buffer.toString("base64")),d=m.event,i={send:o,onMessage:d};this.f=new w.$di(i);const h=()=>this.o();process.once("exit",h),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,D)=>{process.removeListener("exit",h),l.dispose(),this.c.forEach(I=>(0,s.$Pc)(I)),this.c.clear(),u!==0&&D!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+D),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:D})})}return this.f}n(g){let p=this.g.get(g);return p||(p=this.m.getChannel(g),this.g.set(g,p)),p}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$0q=f}),define(Se[183],De([1,0,14,6,2,48,11]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=e.StorageState=e.StorageHint=void 0,e.$5p=v;var A;(function($){$[$.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",$[$.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(A||(e.StorageHint=A={}));function v($){const w=$;return w?.changed instanceof Map||w?.deleted instanceof Set}var s;(function($){$[$.None=0]="None",$[$.Initialized=1]="Initialized",$[$.Closed=2]="Closed"})(s||(e.StorageState=s={}));class E extends S.$Uc{constructor(w,a=Object.create(null)){super(),this.r=w,this.s=a,this.b=this.B(new r.$ke),this.onDidChangeStorage=this.b.event,this.c=s.None,this.f=new Map,this.g=this.B(new n.$yh(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((a,f)=>this.w(f,a)),w.deleted?.forEach(a=>this.w(a,void 0))}finally{this.b.resume()}}w(w,a){if(this.c===s.Closed)return;let f=!1;(0,R.$jg)(a)?f=this.f.delete(w):this.f.get(w)!==a&&(this.f.set(w,a),f=!0),f&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===s.None&&(this.c=s.Initialized,this.s.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,a){const f=this.f.get(w);return(0,R.$jg)(f)?a:f}getBoolean(w,a){const f=this.get(w);return(0,R.$jg)(f)?a:f==="true"}getNumber(w,a){const f=this.get(w);return(0,R.$jg)(f)?a:parseInt(f,10)}getObject(w,a){const f=this.get(w);return(0,R.$jg)(f)?a:(0,k.$9h)(f)}async set(w,a,f=!1){if(this.c===s.Closed)return;if((0,R.$jg)(a))return this.delete(w,f);const c=(0,R.$cg)(a)||Array.isArray(a)?(0,k.$8h)(a):String(a);if(this.f.get(w)!==c)return this.f.set(w,c),this.j.set(w,c),this.h.delete(w),this.b.fire({key:w,external:f}),this.D()}async delete(w,a=!1){if(!(this.c===s.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:a}),this.D()}async optimize(){if(this.c!==s.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=s.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===s.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===A.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===A.STORAGE_IN_MEMORY}}e.$6p=E,E.a=100;class y{constructor(){this.onDidChangeItemsExternal=r.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((a,f)=>this.a.set(f,a)),w.delete?.forEach(a=>this.a.delete(a))}async optimize(){}async close(){}}e.$7p=y}),define(Se[85],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class n{constructor(S,k){this.lineNumber=S,this.column=k}with(S=this.lineNumber,k=this.column){return S===this.lineNumber&&k===this.column?this:new n(S,k)}delta(S=0,k=0){return this.with(this.lineNumber+S,this.column+k)}equals(S){return n.equals(this,S)}static equals(S,k){return!S&&!k?!0:!!S&&!!k&&S.lineNumber===k.lineNumber&&S.column===k.column}isBefore(S){return n.isBefore(this,S)}static isBefore(S,k){return S.lineNumber<k.lineNumber?!0:k.lineNumber<S.lineNumber?!1:S.column<k.column}isBeforeOrEqual(S){return n.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,k){return S.lineNumber<k.lineNumber?!0:k.lineNumber<S.lineNumber?!1:S.column<=k.column}static compare(S,k){const R=S.lineNumber|0,A=k.lineNumber|0;if(R===A){const v=S.column|0,s=k.column|0;return v-s}return R-A}clone(){return new n(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new n(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$ct=n}),define(Se[50],De([1,0,85]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class r{constructor(k,R,A,v){k>A||k===A&&R>v?(this.startLineNumber=A,this.startColumn=v,this.endLineNumber=k,this.endColumn=R):(this.startLineNumber=k,this.startColumn=R,this.endLineNumber=A,this.endColumn=v)}isEmpty(){return r.isEmpty(this)}static isEmpty(k){return k.startLineNumber===k.endLineNumber&&k.startColumn===k.endColumn}containsPosition(k){return r.containsPosition(this,k)}static containsPosition(k,R){return!(R.lineNumber<k.startLineNumber||R.lineNumber>k.endLineNumber||R.lineNumber===k.startLineNumber&&R.column<k.startColumn||R.lineNumber===k.endLineNumber&&R.column>k.endColumn)}static strictContainsPosition(k,R){return!(R.lineNumber<k.startLineNumber||R.lineNumber>k.endLineNumber||R.lineNumber===k.startLineNumber&&R.column<=k.startColumn||R.lineNumber===k.endLineNumber&&R.column>=k.endColumn)}containsRange(k){return r.containsRange(this,k)}static containsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>k.endColumn)}strictContainsRange(k){return r.strictContainsRange(this,k)}static strictContainsRange(k,R){return!(R.startLineNumber<k.startLineNumber||R.endLineNumber<k.startLineNumber||R.startLineNumber>k.endLineNumber||R.endLineNumber>k.endLineNumber||R.startLineNumber===k.startLineNumber&&R.startColumn<=k.startColumn||R.endLineNumber===k.endLineNumber&&R.endColumn>=k.endColumn)}plusRange(k){return r.plusRange(this,k)}static plusRange(k,R){let A,v,s,E;return R.startLineNumber<k.startLineNumber?(A=R.startLineNumber,v=R.startColumn):R.startLineNumber===k.startLineNumber?(A=R.startLineNumber,v=Math.min(R.startColumn,k.startColumn)):(A=k.startLineNumber,v=k.startColumn),R.endLineNumber>k.endLineNumber?(s=R.endLineNumber,E=R.endColumn):R.endLineNumber===k.endLineNumber?(s=R.endLineNumber,E=Math.max(R.endColumn,k.endColumn)):(s=k.endLineNumber,E=k.endColumn),new r(A,v,s,E)}intersectRanges(k){return r.intersectRanges(this,k)}static intersectRanges(k,R){let A=k.startLineNumber,v=k.startColumn,s=k.endLineNumber,E=k.endColumn;const y=R.startLineNumber,$=R.startColumn,w=R.endLineNumber,a=R.endColumn;return A<y?(A=y,v=$):A===y&&(v=Math.max(v,$)),s>w?(s=w,E=a):s===w&&(E=Math.min(E,a)),A>s||A===s&&v>E?null:new r(A,v,s,E)}equalsRange(k){return r.equalsRange(this,k)}static equalsRange(k,R){return!k&&!R?!0:!!k&&!!R&&k.startLineNumber===R.startLineNumber&&k.startColumn===R.startColumn&&k.endLineNumber===R.endLineNumber&&k.endColumn===R.endColumn}getEndPosition(){return r.getEndPosition(this)}static getEndPosition(k){return new n.$ct(k.endLineNumber,k.endColumn)}getStartPosition(){return r.getStartPosition(this)}static getStartPosition(k){return new n.$ct(k.startLineNumber,k.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(k,R){return new r(this.startLineNumber,this.startColumn,k,R)}setStartPosition(k,R){return new r(k,R,this.endLineNumber,this.endColumn)}collapseToStart(){return r.collapseToStart(this)}static collapseToStart(k){return new r(k.startLineNumber,k.startColumn,k.startLineNumber,k.startColumn)}collapseToEnd(){return r.collapseToEnd(this)}static collapseToEnd(k){return new r(k.endLineNumber,k.endColumn,k.endLineNumber,k.endColumn)}delta(k){return new r(this.startLineNumber+k,this.startColumn,this.endLineNumber+k,this.endColumn)}static fromPositions(k,R=k){return new r(k.lineNumber,k.column,R.lineNumber,R.column)}static lift(k){return k?new r(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn):null}static isIRange(k){return k&&typeof k.startLineNumber=="number"&&typeof k.startColumn=="number"&&typeof k.endLineNumber=="number"&&typeof k.endColumn=="number"}static areIntersectingOrTouching(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<k.startColumn)}static areIntersecting(k,R){return!(k.endLineNumber<R.startLineNumber||k.endLineNumber===R.startLineNumber&&k.endColumn<=R.startColumn||R.endLineNumber<k.startLineNumber||R.endLineNumber===k.startLineNumber&&R.endColumn<=k.startColumn)}static compareRangesUsingStarts(k,R){if(k&&R){const s=k.startLineNumber|0,E=R.startLineNumber|0;if(s===E){const y=k.startColumn|0,$=R.startColumn|0;if(y===$){const w=k.endLineNumber|0,a=R.endLineNumber|0;if(w===a){const f=k.endColumn|0,c=R.endColumn|0;return f-c}return w-a}return y-$}return s-E}return(k?1:0)-(R?1:0)}static compareRangesUsingEnds(k,R){return k.endLineNumber===R.endLineNumber?k.endColumn===R.endColumn?k.startLineNumber===R.startLineNumber?k.startColumn-R.startColumn:k.startLineNumber-R.startLineNumber:k.endColumn-R.endColumn:k.endLineNumber-R.endLineNumber}static spansMultipleLines(k){return k.endLineNumber>k.startLineNumber}toJSON(){return this}}e.$dt=r}),define(Se[184],De([1,0,50]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0;class r{static insert(k,R){return{range:new n.$dt(k.lineNumber,k.column,k.lineNumber,k.column),text:R,forceMoveMarkers:!0}}static delete(k){return{range:k,text:null}}static replace(k,R){return{range:k,text:R}}static replaceMove(k,R){return{range:k,text:R,forceMoveMarkers:!0}}}e.$et=r}),define(Se[185],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=void 0,e.$ou={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[186],De([1,0,40,2,79]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=void 0,e.$ut=R,e.$vt=v,e.$wt=s,e.$st="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function k(y=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const w of e.$st)y.indexOf(w)>=0||($+="\\"+w);return $+="\\s]+)",new RegExp($,"g")}e.$tt=k();function R(y){let $=e.$tt;if(y&&y instanceof RegExp)if(y.global)$=y;else{let w="g";y.ignoreCase&&(w+="i"),y.multiline&&(w+="m"),y.unicode&&(w+="u"),$=new RegExp(y.source,w)}return $.lastIndex=0,$}const A=new S.$5c;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function v(y){const $=A.unshift(y);return(0,r.$Sc)($)}function s(y,$,w,a,f){if($=R($),f||(f=n.Iterable.first(A)),w.length>f.maxLen){let b=y-f.maxLen/2;return b<0?b=0:a+=b,w=w.substring(b,y+f.maxLen/2),s(y,$,w,a,f)}const c=Date.now(),g=y-1-a;let p=-1,m=null;for(let b=1;!(Date.now()-c>=f.timeBudget);b++){const l=g-f.windowSize*b;$.lastIndex=Math.max(0,l);const t=E($,w,g,p);if(!t&&m||(m=t,l<=0))break;p=l}if(m){const b={word:m[0],startColumn:a+1+m.index,endColumn:a+1+m.index+m[0].length};return $.lastIndex=0,b}return null}function E(y,$,w,a){let f;for(;f=y.exec($);){const c=f.index||0;if(c<=w&&y.lastIndex>=w)return f;if(a>0&&c>a)return null}return null}}),define(Se[118],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var n;(function(v){v[v.Null=0]="Null",v[v.PlainText=1]="PlainText"})(n||(e.LanguageId=n={}));var r;(function(v){v[v.NotSet=-1]="NotSet",v[v.None=0]="None",v[v.Italic=1]="Italic",v[v.Bold=2]="Bold",v[v.Underline=4]="Underline",v[v.Strikethrough=8]="Strikethrough"})(r||(e.FontStyle=r={}));var S;(function(v){v[v.None=0]="None",v[v.DefaultForeground=1]="DefaultForeground",v[v.DefaultBackground=2]="DefaultBackground"})(S||(e.ColorId=S={}));var k;(function(v){v[v.Other=0]="Other",v[v.Comment=1]="Comment",v[v.String=2]="String",v[v.RegEx=3]="RegEx"})(k||(e.StandardTokenType=k={}));var R;(function(v){v[v.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",v[v.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",v[v.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",v[v.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",v[v.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",v[v.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",v[v.ITALIC_MASK=2048]="ITALIC_MASK",v[v.BOLD_MASK=4096]="BOLD_MASK",v[v.UNDERLINE_MASK=8192]="UNDERLINE_MASK",v[v.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",v[v.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",v[v.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",v[v.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",v[v.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",v[v.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",v[v.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",v[v.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",v[v.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",v[v.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",v[v.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",v[v.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",v[v.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(R||(e.MetadataConsts=R={}));class A{static getLanguageId(s){return(s&R.LANGUAGEID_MASK)>>>R.LANGUAGEID_OFFSET}static getTokenType(s){return(s&R.TOKEN_TYPE_MASK)>>>R.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(s){return(s&R.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(s){return(s&R.FONT_STYLE_MASK)>>>R.FONT_STYLE_OFFSET}static getForeground(s){return(s&R.FOREGROUND_MASK)>>>R.FOREGROUND_OFFSET}static getBackground(s){return(s&R.BACKGROUND_MASK)>>>R.BACKGROUND_OFFSET}static getClassNameFromMetadata(s){let y="mtk"+this.getForeground(s);const $=this.getFontStyle(s);return $&r.Italic&&(y+=" mtki"),$&r.Bold&&(y+=" mtkb"),$&r.Underline&&(y+=" mtku"),$&r.Strikethrough&&(y+=" mtks"),y}static getInlineStyleFromMetadata(s,E){const y=this.getForeground(s),$=this.getFontStyle(s);let w=`color: ${E[y]};`;$&r.Italic&&(w+="font-style: italic;"),$&r.Bold&&(w+="font-weight: bold;");let a="";return $&r.Underline&&(a+=" underline"),$&r.Strikethrough&&(a+=" line-through"),a&&(w+=`text-decoration:${a};`),w}static getPresentationFromMetadata(s){const E=this.getForeground(s),y=this.getFontStyle(s);return{foreground:E,italic:!!(y&r.Italic),bold:!!(y&r.Bold),underline:!!(y&r.Underline),strikethrough:!!(y&r.Strikethrough)}}}e.$gt=A}),define(Se[187],De([1,0,21]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$sv=e.$rv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$tv=a,e.$xv=b;var r;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(r||(e.OverviewRulerLane=r={}));var S;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=3]="Right"})(S||(e.GlyphMarginLane=S={}));var k;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(k||(e.MinimapPosition=k={}));var R;(function(l){l[l.Normal=1]="Normal",l[l.Underlined=2]="Underlined"})(R||(e.MinimapSectionHeaderStyle=R={}));var A;(function(l){l[l.Both=0]="Both",l[l.Right=1]="Right",l[l.Left=2]="Left",l[l.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var v;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var s;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(s||(e.DefaultEndOfLine=s={}));var E;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(E||(e.EndOfLineSequence=E={}));class y{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,n.$bo)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$rv=y;class ${constructor(t,o){this._findMatchBrand=void 0,this.range=t,this.matches=o}}e.$sv=$;var w;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function a(l){return l&&typeof l.read=="function"}var f;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None",l[l.LeftOfInjectedText=3]="LeftOfInjectedText",l[l.RightOfInjectedText=4]="RightOfInjectedText"})(f||(e.PositionAffinity=f={}));var c;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c||(e.ModelConstants=c={}));class g{constructor(t,o,d,i,h,u){this.identifier=t,this.range=o,this.text=d,this.forceMoveMarkers=i,this.isAutoWhitespaceEdit=h,this._isTracked=u}}e.$uv=g;class p{constructor(t,o,d){this.regex=t,this.wordSeparators=o,this.simpleSearch=d}}e.$vv=p;class m{constructor(t,o,d){this.reverseEdits=t,this.changes=o,this.trimAutoWhitespaceLineNumbers=d}}e.$wv=m;function b(l){return!l.isTooLargeForSyncing()&&!l.isForSimpleWidget}}),define(Se[188],De([1,0,6,2,118]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yv=void 0;class k{constructor(){this.a=new Map,this.b=new Map,this.c=new n.$he,this.onDidChange=this.c.event,this.d=null}handleChange(v){this.c.fire({changedLanguages:v,changedColorMap:!1})}register(v,s){return this.a.set(v,s),this.handleChange([v]),(0,r.$Sc)(()=>{this.a.get(v)===s&&(this.a.delete(v),this.handleChange([v]))})}get(v){return this.a.get(v)||null}registerFactory(v,s){this.b.get(v)?.dispose();const E=new R(this,v,s);return this.b.set(v,E),(0,r.$Sc)(()=>{const y=this.b.get(v);!y||y!==E||(this.b.delete(v),y.dispose())})}async getOrCreate(v){const s=this.get(v);if(s)return s;const E=this.b.get(v);return!E||E.isResolved?null:(await E.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const E=this.b.get(v);return!!(!E||E.isResolved)}setColorMap(v){this.d=v,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>S.ColorId.DefaultBackground?this.d[S.ColorId.DefaultBackground]:null}}e.$yv=k;class R extends r.$Uc{get isResolved(){return this.c}constructor(v,s,E){super(),this.f=v,this.g=s,this.h=E,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const v=await this.h.tokenizationSupport;this.c=!0,v&&!this.a&&this.B(this.f.register(this.g,v))}}}),define(Se[189],De([7,8]),function(he,e){return he.create("vs/base/common/actions",e)}),define(Se[190],De([1,0,6,2,189]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=void 0,e.$kj=E;class k extends r.$Uc{constructor($,w="",a="",f=!0,c){super(),this.j=this.B(new n.$he),this.onDidChange=this.j.event,this.z=!0,this.m=$,this.n=w,this.w=a,this.z=f,this.D=c}get id(){return this.m}get label(){return this.n}set label($){this.F($)}F($){this.n!==$&&(this.n=$,this.j.fire({label:$}))}get tooltip(){return this.u||""}set tooltip($){this.G($)}G($){this.u!==$&&(this.u=$,this.j.fire({tooltip:$}))}get class(){return this.w}set class($){this.H($)}H($){this.w!==$&&(this.w=$,this.j.fire({class:$}))}get enabled(){return this.z}set enabled($){this.I($)}I($){this.z!==$&&(this.z=$,this.j.fire({enabled:$}))}get checked(){return this.C}set checked($){this.J($)}J($){this.C!==$&&(this.C=$,this.j.fire({checked:$}))}async run($,w){this.D&&await this.D($)}}e.$fj=k;class R extends r.$Uc{constructor(){super(...arguments),this.f=this.B(new n.$he),this.onWillRun=this.f.event,this.m=this.B(new n.$he),this.onDidRun=this.m.event}async run($,w){if(!$.enabled)return;this.f.fire({action:$});let a;try{await this.u($,w)}catch(f){a=f}this.m.fire({action:$,error:a})}async u($,w){await $.run(w)}}e.$gj=R;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let w=[];for(const a of $)a.length&&(w.length?w=[...w,new A,...a]:w=a);return w}async run(){}}e.$hj=A,A.ID="vs.actions.separator";class v{get actions(){return this.a}constructor($,w,a,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=w,this.class=f,this.a=a}async run(){}}e.$ij=v;class s extends k{constructor(){super(s.ID,S.localize(0,null),void 0,!1)}}e.$jj=s,s.ID="vs.actions.empty";function E(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...$)=>y.run(...$)}}}),define(Se[191],De([7,8]),function(he,e){return he.create("vs/base/common/date",e)}),define(Se[192],De([1,0,191]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=s,e.$9m=E,e.$0m=y;const r=60,S=r*60,k=S*24,R=k*7,A=k*30,v=k*365;function s($,w,a,f){typeof $!="number"&&($=$.getTime());const c=Math.round((new Date().getTime()-$)/1e3);if(c<-30)return(0,n.localize)(0,null,s(new Date().getTime()+c*1e3,!1));if(!f&&c<30)return(0,n.localize)(1,null);let g;return c<r?(g=c,w?g===1?a?(0,n.localize)(2,null,g):(0,n.localize)(3,null,g):a?(0,n.localize)(4,null,g):(0,n.localize)(5,null,g):g===1?a?(0,n.localize)(6,null,g):(0,n.localize)(7,null,g):a?(0,n.localize)(8,null,g):(0,n.localize)(9,null,g)):c<S?(g=Math.floor(c/r),w?g===1?a?(0,n.localize)(10,null,g):(0,n.localize)(11,null,g):a?(0,n.localize)(12,null,g):(0,n.localize)(13,null,g):g===1?a?(0,n.localize)(14,null,g):(0,n.localize)(15,null,g):a?(0,n.localize)(16,null,g):(0,n.localize)(17,null,g)):c<k?(g=Math.floor(c/S),w?g===1?a?(0,n.localize)(18,null,g):(0,n.localize)(19,null,g):a?(0,n.localize)(20,null,g):(0,n.localize)(21,null,g):g===1?a?(0,n.localize)(22,null,g):(0,n.localize)(23,null,g):a?(0,n.localize)(24,null,g):(0,n.localize)(25,null,g)):c<R?(g=Math.floor(c/k),w?g===1?(0,n.localize)(26,null,g):(0,n.localize)(27,null,g):g===1?(0,n.localize)(28,null,g):(0,n.localize)(29,null,g)):c<A?(g=Math.floor(c/R),w?g===1?a?(0,n.localize)(30,null,g):(0,n.localize)(31,null,g):a?(0,n.localize)(32,null,g):(0,n.localize)(33,null,g):g===1?a?(0,n.localize)(34,null,g):(0,n.localize)(35,null,g):a?(0,n.localize)(36,null,g):(0,n.localize)(37,null,g)):c<v?(g=Math.floor(c/A),w?g===1?a?(0,n.localize)(38,null,g):(0,n.localize)(39,null,g):a?(0,n.localize)(40,null,g):(0,n.localize)(41,null,g):g===1?a?(0,n.localize)(42,null,g):(0,n.localize)(43,null,g):a?(0,n.localize)(44,null,g):(0,n.localize)(45,null,g)):(g=Math.floor(c/v),w?g===1?a?(0,n.localize)(46,null,g):(0,n.localize)(47,null,g):a?(0,n.localize)(48,null,g):(0,n.localize)(49,null,g):g===1?a?(0,n.localize)(50,null,g):(0,n.localize)(51,null,g):a?(0,n.localize)(52,null,g):(0,n.localize)(53,null,g))}function E($,w){const a=Math.abs($/1e3);return a<1?w?(0,n.localize)(54,null,$):(0,n.localize)(55,null,$):a<r?w?(0,n.localize)(56,null,Math.round($)/1e3):(0,n.localize)(57,null,Math.round($)/1e3):a<S?w?(0,n.localize)(58,null,Math.round($/(1e3*r))):(0,n.localize)(59,null,Math.round($/(1e3*r))):a<k?w?(0,n.localize)(60,null,Math.round($/(1e3*S))):(0,n.localize)(61,null,Math.round($/(1e3*S))):(0,n.localize)(62,null,Math.round($/(1e3*k)))}function y($){return $.getFullYear()+"-"+String($.getMonth()+1).padStart(2,"0")+"-"+String($.getDate()).padStart(2,"0")+"T"+String($.getHours()).padStart(2,"0")+":"+String($.getMinutes()).padStart(2,"0")+":"+String($.getSeconds()).padStart(2,"0")+"."+($.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[193],De([7,8]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(Se[42],De([1,0,18,11,193]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=v,e.$mj=s,e.$nj=E;function k(y,$){return $&&(y.stack||y.stacktrace)?S.localize(0,null,A(y),R(y.stack)||R(y.stacktrace)):A(y)}function R(y){return Array.isArray(y)?y.join(`
`):y}function A(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?S.localize(1,null,y.message):y.message||S.localize(2,null)}function v(y=null,$=!1){if(!y)return S.localize(3,null);if(Array.isArray(y)){const w=n.$Hb(y),a=v(w[0],$);return w.length>1?S.localize(4,null,a,w.length):a}if(r.$ag(y))return y;if(y.detail){const w=y.detail;if(w.error)return k(w.error,$);if(w.exception)return k(w.exception,$)}return y.stack?k(y,$):y.message?y.message:S.localize(5,null)}function s(y){const $=y;return $ instanceof Error&&Array.isArray($.actions)}function E(y,$){let w;return typeof y=="string"?w=new Error(y):w=y,w.actions=$,w}}),define(Se[194],De([7,8]),function(he,e){return he.create("vs/base/common/jsonErrorMessages",e)}),define(Se[195],De([1,0,194,44]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=S;function S(k){switch(k){case r.ParseErrorCode.InvalidSymbol:return(0,n.localize)(0,null);case r.ParseErrorCode.InvalidNumberFormat:return(0,n.localize)(1,null);case r.ParseErrorCode.PropertyNameExpected:return(0,n.localize)(2,null);case r.ParseErrorCode.ValueExpected:return(0,n.localize)(3,null);case r.ParseErrorCode.ColonExpected:return(0,n.localize)(4,null);case r.ParseErrorCode.CommaExpected:return(0,n.localize)(5,null);case r.ParseErrorCode.CloseBraceExpected:return(0,n.localize)(6,null);case r.ParseErrorCode.CloseBracketExpected:return(0,n.localize)(7,null);case r.ParseErrorCode.EndOfFileExpected:return(0,n.localize)(8,null);default:return""}}}),define(Se[196],De([7,8]),function(he,e){return he.create("vs/base/node/zip",e)}),define(Se[86],De([1,0,31,14,9,11,25,196]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=void 0,e.zip=c,e.$sq=g,e.$tq=m,e.$pq="end of central directory record signature not found";const v=new RegExp(e.$pq);class s extends Error{constructor(l,t){let o=t.message;switch(l){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=l,this.cause=t}}e.$qq=s;function E(b){const l=b.externalFileAttributes>>16||33188;return[448,56,7].map(t=>l&t).reduce((t,o)=>t+o,l&61440)}function y(b){if(b instanceof s)return b;let l;return v.test(b.message)&&(l="CorruptZip"),new s(l,b)}function $(b,l,t,o,d,i){const h=S.$mc(l),u=S.$jc(o,h);if(!u.startsWith(o))return Promise.reject(new Error(A.localize(0,null,l)));const D=S.$jc(o,l);let I;return i.onCancellationRequested(()=>{I?.destroy()}),Promise.resolve(R.Promises.mkdir(u,{recursive:!0})).then(()=>new Promise((T,O)=>{if(!i.isCancellationRequested)try{I=(0,n.createWriteStream)(D,{mode:t}),I.once("close",()=>T()),I.once("error",O),b.once("error",O),b.pipe(I)}catch(C){O(C)}}))}function w(b,l,t,o){let d=(0,r.$nh)(()=>Promise.resolve()),i=0;const h=o.onCancellationRequested(()=>{d.cancel(),b.close()});return new Promise((u,D)=>{const I=new r.$vh,T=O=>{O.isCancellationRequested||(i++,b.readEntry())};b.once("error",D),b.once("close",()=>d.then(()=>{o.isCancellationRequested||b.entryCount===i?u():D(new s("Incomplete",new Error(A.localize(1,null,i,b.entryCount))))},D)),b.readEntry(),b.on("entry",O=>{if(o.isCancellationRequested)return;if(!t.sourcePathRegex.test(O.fileName)){T(o);return}const C=O.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(C)){const X=S.$jc(l,C);d=(0,r.$nh)(ie=>R.Promises.mkdir(X,{recursive:!0}).then(()=>T(ie)).then(void 0,D));return}const P=f(b,O),Q=E(O);d=(0,r.$nh)(X=>I.queue(()=>P.then(ie=>$(ie,C,Q,l,t,X).then(()=>T(X)))).then(null,D))})}).finally(()=>h.dispose())}async function a(b,l=!1){const{open:t}=await new Promise((o,d)=>{he(["yauzl"],o,d)});return new Promise((o,d)=>{t(b,l?{lazyEntries:!0}:void 0,(i,h)=>{i?d(y(i)):o((0,k.$lg)(h))})})}function f(b,l){return new Promise((t,o)=>{b.openReadStream(l,(d,i)=>{d?o(y(d)):t((0,k.$lg)(i))})})}async function c(b,l){const{ZipFile:t}=await new Promise((o,d)=>{he(["yazl"],o,d)});return new Promise((o,d)=>{const i=new t;l.forEach(u=>{u.contents?i.addBuffer(typeof u.contents=="string"?Buffer.from(u.contents,"utf8"):u.contents,u.path):u.localPath&&i.addFile(u.localPath,u.path)}),i.end();const h=(0,n.createWriteStream)(b);i.outputStream.pipe(h),i.outputStream.once("error",d),h.once("error",d),h.once("finish",()=>o(b))})}function g(b,l,t={},o){const d=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let i=a(b,!0);return t.overwrite&&(i=i.then(h=>R.Promises.rm(l).then(()=>h))),i.then(h=>w(h,l,{sourcePathRegex:d},o))}function p(b,l){return a(b).then(t=>new Promise((o,d)=>{t.on("entry",i=>{i.fileName===l&&f(t,i).then(h=>o(h),h=>d(h))}),t.once("close",()=>d(new Error(A.localize(2,null,l))))}))}function m(b,l){return p(b,l).then(t=>new Promise((o,d)=>{const i=[];t.once("error",d),t.on("data",h=>i.push(h)),t.on("end",()=>o(Buffer.concat(i)))}))}}),define(Se[197],De([7,8]),function(he,e){return he.create("vs/editor/common/config/editorOptions",e)}),define(Se[198],De([7,8]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(Se[199],De([1,0,57,4,184,50,188,198]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Sv=e.$Rv=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Qv=e.$Pv=e.SymbolKinds=e.SymbolTag=e.$Nv=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Lv=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Kv=e.$Jv=e.$Iv=void 0,e.$Mv=d,e.$Ov=h;class v{constructor(z,oe,ce){this.offset=z,this.type=oe,this.language=ce,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Iv=v;class s{constructor(z,oe){this.tokens=z,this.endState=oe,this._tokenizationResultBrand=void 0}}e.$Jv=s;class E{constructor(z,oe){this.tokens=z,this.endState=oe,this._encodedTokenizationResultBrand=void 0}}e.$Kv=E;var y;(function(M){M[M.Increase=0]="Increase",M[M.Decrease=1]="Decrease"})(y||(e.HoverVerbosityAction=y={}));var $;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})($||(e.CompletionItemKind=$={}));var w;(function(M){const z=new Map;z.set($.Method,n.$Zj.symbolMethod),z.set($.Function,n.$Zj.symbolFunction),z.set($.Constructor,n.$Zj.symbolConstructor),z.set($.Field,n.$Zj.symbolField),z.set($.Variable,n.$Zj.symbolVariable),z.set($.Class,n.$Zj.symbolClass),z.set($.Struct,n.$Zj.symbolStruct),z.set($.Interface,n.$Zj.symbolInterface),z.set($.Module,n.$Zj.symbolModule),z.set($.Property,n.$Zj.symbolProperty),z.set($.Event,n.$Zj.symbolEvent),z.set($.Operator,n.$Zj.symbolOperator),z.set($.Unit,n.$Zj.symbolUnit),z.set($.Value,n.$Zj.symbolValue),z.set($.Enum,n.$Zj.symbolEnum),z.set($.Constant,n.$Zj.symbolConstant),z.set($.Enum,n.$Zj.symbolEnum),z.set($.EnumMember,n.$Zj.symbolEnumMember),z.set($.Keyword,n.$Zj.symbolKeyword),z.set($.Snippet,n.$Zj.symbolSnippet),z.set($.Text,n.$Zj.symbolText),z.set($.Color,n.$Zj.symbolColor),z.set($.File,n.$Zj.symbolFile),z.set($.Reference,n.$Zj.symbolReference),z.set($.Customcolor,n.$Zj.symbolCustomColor),z.set($.Folder,n.$Zj.symbolFolder),z.set($.TypeParameter,n.$Zj.symbolTypeParameter),z.set($.User,n.$Zj.account),z.set($.Issue,n.$Zj.issues);function oe(W){let ae=z.get(W);return ae||(console.info("No codicon found for CompletionItemKind "+W),ae=n.$Zj.symbolProperty),ae}M.toIcon=oe;const ce=new Map;ce.set("method",$.Method),ce.set("function",$.Function),ce.set("constructor",$.Constructor),ce.set("field",$.Field),ce.set("variable",$.Variable),ce.set("class",$.Class),ce.set("struct",$.Struct),ce.set("interface",$.Interface),ce.set("module",$.Module),ce.set("property",$.Property),ce.set("event",$.Event),ce.set("operator",$.Operator),ce.set("unit",$.Unit),ce.set("value",$.Value),ce.set("constant",$.Constant),ce.set("enum",$.Enum),ce.set("enum-member",$.EnumMember),ce.set("enumMember",$.EnumMember),ce.set("keyword",$.Keyword),ce.set("snippet",$.Snippet),ce.set("text",$.Text),ce.set("color",$.Color),ce.set("file",$.File),ce.set("reference",$.Reference),ce.set("customcolor",$.Customcolor),ce.set("folder",$.Folder),ce.set("type-parameter",$.TypeParameter),ce.set("typeParameter",$.TypeParameter),ce.set("account",$.User),ce.set("issue",$.Issue);function pe(W,ae){let ee=ce.get(W);return typeof ee>"u"&&!ae&&(ee=$.Property),ee}M.fromString=pe})(w||(e.CompletionItemKinds=w={}));var a;(function(M){M[M.Deprecated=1]="Deprecated"})(a||(e.CompletionItemTag=a={}));var f;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(f||(e.CompletionItemInsertTextRule=f={}));var c;(function(M){M[M.Word=0]="Word",M[M.Line=1]="Line",M[M.Suggest=2]="Suggest"})(c||(e.PartialAcceptTriggerKind=c={}));var g;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(e.CompletionTriggerKind=g={}));var p;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(p||(e.InlineCompletionTriggerKind=p={}));class m{constructor(z,oe,ce,pe){this.range=z,this.text=oe,this.completionKind=ce,this.isSnippetText=pe}equals(z){return k.$dt.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}e.$Lv=m;var b;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(b||(e.CodeActionTriggerType=b={}));var l;(function(M){M[M.Automatic=0]="Automatic",M[M.PasteAs=1]="PasteAs"})(l||(e.DocumentPasteTriggerKind=l={}));var t;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var o;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function d(M){return M&&r.URI.isUri(M.uri)&&k.$dt.isIRange(M.range)&&(k.$dt.isIRange(M.originSelectionRange)||k.$dt.isIRange(M.targetSelectionRange))}var i;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(i||(e.SymbolKind=i={})),e.$Nv={[i.Array]:(0,A.localize)(0,null),[i.Boolean]:(0,A.localize)(1,null),[i.Class]:(0,A.localize)(2,null),[i.Constant]:(0,A.localize)(3,null),[i.Constructor]:(0,A.localize)(4,null),[i.Enum]:(0,A.localize)(5,null),[i.EnumMember]:(0,A.localize)(6,null),[i.Event]:(0,A.localize)(7,null),[i.Field]:(0,A.localize)(8,null),[i.File]:(0,A.localize)(9,null),[i.Function]:(0,A.localize)(10,null),[i.Interface]:(0,A.localize)(11,null),[i.Key]:(0,A.localize)(12,null),[i.Method]:(0,A.localize)(13,null),[i.Module]:(0,A.localize)(14,null),[i.Namespace]:(0,A.localize)(15,null),[i.Null]:(0,A.localize)(16,null),[i.Number]:(0,A.localize)(17,null),[i.Object]:(0,A.localize)(18,null),[i.Operator]:(0,A.localize)(19,null),[i.Package]:(0,A.localize)(20,null),[i.Property]:(0,A.localize)(21,null),[i.String]:(0,A.localize)(22,null),[i.Struct]:(0,A.localize)(23,null),[i.TypeParameter]:(0,A.localize)(24,null),[i.Variable]:(0,A.localize)(25,null)};function h(M,z){return(0,A.localize)(26,null,M,e.$Nv[z])}var u;(function(M){M[M.Deprecated=1]="Deprecated"})(u||(e.SymbolTag=u={}));var D;(function(M){const z=new Map;z.set(i.File,n.$Zj.symbolFile),z.set(i.Module,n.$Zj.symbolModule),z.set(i.Namespace,n.$Zj.symbolNamespace),z.set(i.Package,n.$Zj.symbolPackage),z.set(i.Class,n.$Zj.symbolClass),z.set(i.Method,n.$Zj.symbolMethod),z.set(i.Property,n.$Zj.symbolProperty),z.set(i.Field,n.$Zj.symbolField),z.set(i.Constructor,n.$Zj.symbolConstructor),z.set(i.Enum,n.$Zj.symbolEnum),z.set(i.Interface,n.$Zj.symbolInterface),z.set(i.Function,n.$Zj.symbolFunction),z.set(i.Variable,n.$Zj.symbolVariable),z.set(i.Constant,n.$Zj.symbolConstant),z.set(i.String,n.$Zj.symbolString),z.set(i.Number,n.$Zj.symbolNumber),z.set(i.Boolean,n.$Zj.symbolBoolean),z.set(i.Array,n.$Zj.symbolArray),z.set(i.Object,n.$Zj.symbolObject),z.set(i.Key,n.$Zj.symbolKey),z.set(i.Null,n.$Zj.symbolNull),z.set(i.EnumMember,n.$Zj.symbolEnumMember),z.set(i.Struct,n.$Zj.symbolStruct),z.set(i.Event,n.$Zj.symbolEvent),z.set(i.Operator,n.$Zj.symbolOperator),z.set(i.TypeParameter,n.$Zj.symbolTypeParameter);function oe(ce){let pe=z.get(ce);return pe||(console.info("No codicon found for SymbolKind "+ce),pe=n.$Zj.symbolProperty),pe}M.toIcon=oe})(D||(e.SymbolKinds=D={}));class I{static asEditOperation(z){return S.$et.replace(k.$dt.lift(z.range),z.text)}}e.$Pv=I;class T{static fromValue(z){switch(z){case"comment":return T.Comment;case"imports":return T.Imports;case"region":return T.Region}return new T(z)}constructor(z){this.value=z}}e.$Qv=T,T.Comment=new T("comment"),T.Imports=new T("imports"),T.Region=new T("region");var O;(function(M){M[M.AIGenerated=1]="AIGenerated"})(O||(e.NewSymbolNameTag=O={}));var C;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(C||(e.NewSymbolNameTriggerKind=C={}));var P;(function(M){function z(oe){return!oe||typeof oe!="object"?!1:typeof oe.id=="string"&&typeof oe.title=="string"}M.is=z})(P||(e.Command=P={}));var Q;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(Q||(e.CommentThreadCollapsibleState=Q={}));var X;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(X||(e.CommentThreadState=X={}));var ie;(function(M){M[M.Current=0]="Current",M[M.Outdated=1]="Outdated"})(ie||(e.CommentThreadApplicability=ie={}));var ne;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(ne||(e.CommentMode=ne={}));var x;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(x||(e.CommentState=x={}));var re;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(re||(e.InlayHintKind=re={}));class q{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Rv=q,e.$Sv=new R.$yv;var te;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(te||(e.ExternalUriOpenerPriority=te={}));var le;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(le||(e.InlineEditTriggerKind=le={}))}),define(Se[200],De([7,8]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[201],De([7,8]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[202],De([7,8]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(Se[203],De([7,8]),function(he,e){return he.create("vs/platform/environment/node/argv",e)}),define(Se[204],De([7,8]),function(he,e){return he.create("vs/platform/environment/node/argvHelper",e)}),define(Se[205],De([7,8]),function(he,e){return he.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(Se[206],De([7,8]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[207],De([7,8]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(Se[208],De([7,8]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(Se[209],De([7,8]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(Se[210],De([7,8]),function(he,e){return he.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Se[211],De([7,8]),function(he,e){return he.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Se[212],De([7,8]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[213],De([7,8]),function(he,e){return he.create("vs/platform/files/common/fileService",e)}),define(Se[214],De([7,8]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(Se[215],De([7,8]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(Se[216],De([7,8]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Se[217],De([7,8]),function(he,e){return he.create("vs/platform/languagePacks/common/languagePacks",e)}),define(Se[218],De([7,8]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(Se[219],De([7,8]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(Se[220],De([7,8]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(Se[221],De([7,8]),function(he,e){return he.create("vs/platform/shell/node/shellEnv",e)}),define(Se[222],De([7,8]),function(he,e){return he.create("vs/platform/telemetry/common/telemetryService",e)}),define(Se[223],De([7,8]),function(he,e){return he.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Se[224],De([7,8]),function(he,e){return he.create("vs/platform/terminal/common/terminalProfiles",e)}),define(Se[225],De([7,8]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[226],De([7,8]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(Se[227],De([7,8]),function(he,e){return he.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(Se[228],De([7,8]),function(he,e){return he.create("vs/server/node/serverEnvironmentService",e)}),define(Se[229],De([7,8]),function(he,e){return he.create("vs/server/node/serverServices",e)}),define(Se[230],De([7,8]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[231],De([7,8]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(Se[232],De([7,8]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[233],De([7,8]),function(he,e){return he.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Se[234],De([7,8]),function(he,e){return he.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[235],De([7,8]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[236],De([7,8]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[237],De([7,8]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(Se[238],De([1,0,35,10,202]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var k;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(k||(e.TokenType=k={}));function R(...E){switch(E.length){case 1:return(0,S.localize)(0,null,E[0]);case 2:return(0,S.localize)(1,null,E[0],E[1]);case 3:return(0,S.localize)(2,null,E[0],E[1],E[2]);default:return}}const A=(0,S.localize)(3,null),v=(0,S.localize)(4,null);class s{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return y.isTripleEq?"===":"==";case k.NotEq:return y.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return y.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return y.lexeme;case k.QuotedStr:return y.lexeme;case k.Error:return y.lexeme;case k.EOF:return"EOF";default:throw(0,r.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case n.CharCode.OpenParen:this.k(k.LParen);break;case n.CharCode.CloseParen:this.k(k.RParen);break;case n.CharCode.ExclamationMark:if(this.h(n.CharCode.Equals)){const $=this.h(n.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:$})}else this.k(k.Neg);break;case n.CharCode.SingleQuote:this.o();break;case n.CharCode.Slash:this.q();break;case n.CharCode.Equals:if(this.h(n.CharCode.Equals)){const $=this.h(n.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:$})}else this.h(n.CharCode.Tilde)?this.k(k.RegexOp):this.l(R("==","=~"));break;case n.CharCode.LessThan:this.k(this.h(n.CharCode.Equals)?k.LtEq:k.Lt);break;case n.CharCode.GreaterThan:this.k(this.h(n.CharCode.Equals)?k.GtEq:k.Gt);break;case n.CharCode.Ampersand:this.h(n.CharCode.Ampersand)?this.k(k.And):this.l(R("&&"));break;case n.CharCode.Pipe:this.h(n.CharCode.Pipe)?this.k(k.Or):this.l(R("||"));break;case n.CharCode.Space:case n.CharCode.CarriageReturn:case n.CharCode.Tab:case n.CharCode.LineFeed:case n.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?n.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const $=this.d,w=this.c.substring(this.d,this.e),a={type:k.Error,offset:this.d,lexeme:w};this.g.push({offset:$,lexeme:w,additionalInfo:y}),this.f.push(a)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const $=this.c.substring(this.d,this.e),w=s.b.get($);w?this.k(w):this.f.push({type:k.Str,lexeme:$,offset:this.d})}}o(){for(;this.j()!==n.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,$=!1,w=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(v);return}const f=this.c.charCodeAt(y);if($)$=!1;else if(f===n.CharCode.Slash&&!w){y++;break}else f===n.CharCode.OpenSquareBracket?w=!0:f===n.CharCode.Backslash?$=!0:f===n.CharCode.CloseSquareBracket&&(w=!1);y++}for(;y<this.c.length&&s.a.has(this.c.charCodeAt(y));)y++;this.e=y;const a=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:a,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=s,s.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0))),s.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}),define(Se[239],De([1,0,6,2]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ro=e.$Qo=void 0;class S{constructor(){this.a=new n.$he,this.b=new n.$he,this.c=new n.$he,this.d=new n.$he}call(A,v,s){switch(v){case"close":return Promise.resolve(this.a.fire({sessionId:s[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:s[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:s[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:s[0],port:s[1],subId:s[2]}))}throw new Error("Method not implemented.")}listen(A,v,s){switch(v){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Qo=S,S.ChannelName="extensionhostdebugservice";class k extends r.$Uc{constructor(A){super(),this.b=A}reload(A){this.b.call("reload",[A])}get onReload(){return this.b.listen("reload")}close(A){this.b.call("close",[A])}get onClose(){return this.b.listen("close")}attachSession(A,v,s){this.b.call("attach",[A,v,s])}get onAttachSession(){return this.b.listen("attach")}terminateSession(A,v){this.b.call("terminate",[A,v])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(A,v){return this.b.call("openExtensionDevelopmentHostWindow",[A,v])}}e.$Ro=k}),define(Se[240],De([1,0,4]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=void 0;class r{constructor(R){this.a=R}listen(R,A,v){throw new Error("Invalid listen")}call(R,A,v){switch(A){case"download":return this.a.download(n.URI.revive(v[0]),n.URI.revive(v[1]))}throw new Error("Invalid call")}}e.$To=r;class S{constructor(R,A){this.a=R,this.b=A}async download(R,A){const v=this.b();v&&(R=v.transformOutgoingURI(R),A=v.transformOutgoingURI(A)),await this.a.call("download",[R,A])}}e.$Uo=S}),define(Se[241],De([1,0,192,77,13,9,33,20,4]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=void 0,e.$an=E,e.$bn=y,e.$$m=/^([^.]+\..+)[:=](.+)$/;class s{get appRoot(){return(0,k.$mc)(S.$Ug.asFileUri("").fsPath)}get userHome(){return v.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return v.URI.file((0,k.$jc)(this.userDataPath,"User"))}get tmpDir(){return v.URI.file(this.b.tmpDir)}get cacheHome(){return v.URI.file(this.userDataPath)}get stateResource(){return(0,A.$bh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,A.$bh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const w=(0,n.$0m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$jc)(this.userDataPath,"logs",w)}return v.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.$bh)(v.URI.file((0,k.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.$bh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.$bh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.$bh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const w=R.env.VSCODE_PORTABLE;return w?v.URI.file((0,k.$jc)(w,"argv.json")):(0,A.$bh)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return v.URI.file((0,k.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const w=this.args["builtin-extensions-dir"];return w?(0,k.$kc)(w):(0,k.$hc)((0,k.$jc)(S.$Ug.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const w=this.args["extensions-download-dir"];return w?v.URI.file((0,k.$kc)(w)):v.URI.file((0,k.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const w=this.args["extensions-dir"];if(w)return(0,k.$kc)(w);const a=R.env.VSCODE_EXTENSIONS;if(a)return a;const f=R.env.VSCODE_PORTABLE;return f?(0,k.$jc)(f,"extensions"):(0,A.$bh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const w=this.args.extensionDevelopmentPath;if(Array.isArray(w))return w.map(a=>/^[^:/?#]+?:\/\//.test(a)?v.URI.parse(a):v.URI.file((0,k.$hc)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const w=this.args.extensionTestsPath;if(w)return/^[^:/?#]+?:\/\//.test(w)?v.URI.parse(w):v.URI.file((0,k.$hc)(w))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const w=this.args["disable-extension"];if(w){if(typeof w=="string")return[w];if(Array.isArray(w)&&w.length>0)return w}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(w=>!e.$$m.test(w))}get extensionLogLevel(){const w=[];for(const a of this.args.log||[]){const f=e.$$m.exec(a);f&&f[1]&&f[2]&&w.push([f[1],f[2]])}return w.length?w:void 0}get serviceMachineIdResource(){return(0,A.$bh)(v.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const w=R.env.VSCODE_PORTABLE;return w?v.URI.file((0,k.$jc)(w,"policy.json")):(0,A.$bh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(w){this.args.continueOn=w}get args(){return this.a}constructor(w,a,f){this.a=w,this.b=a,this.c=f,this.editSessionId=this.args.editSessionId}}e.$_m=s,Ue([r.$5h],s.prototype,"appRoot",null),Ue([r.$5h],s.prototype,"userHome",null),Ue([r.$5h],s.prototype,"userDataPath",null),Ue([r.$5h],s.prototype,"appSettingsHome",null),Ue([r.$5h],s.prototype,"tmpDir",null),Ue([r.$5h],s.prototype,"cacheHome",null),Ue([r.$5h],s.prototype,"stateResource",null),Ue([r.$5h],s.prototype,"userRoamingDataHome",null),Ue([r.$5h],s.prototype,"userDataSyncHome",null),Ue([r.$5h],s.prototype,"sync",null),Ue([r.$5h],s.prototype,"machineSettingsResource",null),Ue([r.$5h],s.prototype,"workspaceStorageHome",null),Ue([r.$5h],s.prototype,"localHistoryHome",null),Ue([r.$5h],s.prototype,"keyboardLayoutResource",null),Ue([r.$5h],s.prototype,"argvResource",null),Ue([r.$5h],s.prototype,"isExtensionDevelopment",null),Ue([r.$5h],s.prototype,"untitledWorkspacesHome",null),Ue([r.$5h],s.prototype,"builtinExtensionsPath",null),Ue([r.$5h],s.prototype,"extensionsPath",null),Ue([r.$5h],s.prototype,"extensionDevelopmentLocationURI",null),Ue([r.$5h],s.prototype,"extensionDevelopmentKind",null),Ue([r.$5h],s.prototype,"extensionTestsLocationURI",null),Ue([r.$5h],s.prototype,"debugExtensionHost",null),Ue([r.$5h],s.prototype,"logLevel",null),Ue([r.$5h],s.prototype,"extensionLogLevel",null),Ue([r.$5h],s.prototype,"serviceMachineIdResource",null),Ue([r.$5h],s.prototype,"disableTelemetry",null),Ue([r.$5h],s.prototype,"disableWorkspaceTrust",null),Ue([r.$5h],s.prototype,"useInMemorySecretStorage",null),Ue([r.$5h],s.prototype,"policyFile",null);function E($,w){return y($["inspect-extensions"],$["inspect-brk-extensions"],5870,w,$.debugId,$.extensionEnvironment)}function y($,w,a,f,c,g){const m=Number(w||$)||(f?null:a),b=m?!!w:!1;let l;if(g)try{l=JSON.parse(g)}catch{}return{port:m,break:b,debugId:c,env:l}}}),define(Se[70],De([1,0,336,3,203]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ym=e.$xm=void 0,e.$zm=A,e.$Am=s,e.$Bm=w,e.$Cm=a;const k={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$xm=["tunnel","serve-web"],e.$ym={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"stdin-to-clipboard":{type:"boolean",cat:"o",alias:"c",description:(0,S.localize)(16,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(17,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(19,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(20,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(21,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(22,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(23,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(24,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(25,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(26,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(27,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(28,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(29,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(30,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(31,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(32,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(33,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(35,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(38,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(39,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},"use-gl":{type:"string"},"use-angle":{type:"string"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function A(f,c,g=R){const p=f.find(u=>u.length>0&&u[0]!=="-"),m={},b=["_"],l=[],t={};let o;for(const u in c){const D=c[u];D.type==="subcommand"?u===p&&(o=D):(D.alias&&(m[u]=D.alias),D.type==="string"||D.type==="string[]"?(b.push(u),D.deprecates&&b.push(...D.deprecates)):D.type==="boolean"&&(l.push(u),D.deprecates&&l.push(...D.deprecates)),D.global&&(t[u]=D))}if(o&&p){const u=t;for(const O in o.options)u[O]=o.options[O];const D=f.filter(O=>O!==p),I=g.getSubcommandReporter?g.getSubcommandReporter(p):void 0,T=A(D,u,I);return{[p]:T,_:[]}}const d=n(f,{string:b,boolean:l,alias:m}),i={},h=d;i._=d._.map(u=>String(u)).filter(u=>u.length>0),delete h._;for(const u in c){const D=c[u];if(D.type==="subcommand")continue;D.alias&&delete h[D.alias];let I=h[u];if(D.deprecates)for(const T of D.deprecates)h.hasOwnProperty(T)&&(I||(I=h[T],I&&g.onDeprecatedOption(T,D.deprecationMessage||(0,S.localize)(40,null,u))),delete h[T]);if(typeof I<"u"){if(D.type==="string[]"){if(Array.isArray(I)||(I=[I]),!D.allowEmptyValue){const T=I.filter(O=>O.length>0);T.length!==I.length&&(g.onEmptyValue(u),I=T.length>0?T:void 0)}}else D.type==="string"&&(Array.isArray(I)?(I=I.pop(),g.onMultipleValues(u,I)):!I&&!D.allowEmptyValue&&(g.onEmptyValue(u),I=void 0));i[u]=I,D.deprecationMessage&&g.onDeprecatedOption(u,D.deprecationMessage)}delete h[u]}for(const u in h)g.onUnknownOption(u);return i}function v(f,c){let g="";return c.args&&(Array.isArray(c.args)?g=` <${c.args.join("> <")}>`:g=` <${c.args}>`),c.alias?`-${c.alias} --${f}${g}`:`--${f}${g}`}function s(f,c){const g=[];for(const p in f){const m=f[p],b=v(p,m);g.push([b,m.description])}return E(g,c)}function E(f,c){const p=f.reduce((l,t)=>Math.max(l,t[0].length),12)+2+1;if(c-p<25)return f.reduce((l,t)=>l.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const m=c-p-1,b=[];for(const l of f){const t=l[0],o=$(l[1],m),d=y(p-t.length-2);b.push("  "+t+d+o[0]);for(let i=1;i<o.length;i++)b.push(y(p)+o[i])}return b}function y(f){return" ".repeat(f)}function $(f,c){const g=[];for(;f.length;){const p=f.length<c?f.length:f.lastIndexOf(" ",c),m=f.slice(0,p).trim();f=f.slice(p),g.push(m)}return g}function w(f,c,g,p,m){const b=process.stdout.isTTY&&process.stdout.columns||80,l=m?.noInputFiles!==!0?`[${(0,S.localize)(41,null)}...]`:"",t=[`${f} ${g}`];t.push(""),t.push(`${(0,S.localize)(42,null)}: ${c} [${(0,S.localize)(43,null)}]${l}`),t.push(""),m?.noPipe!==!0&&(r.$c?t.push((0,S.localize)(44,null,c)):t.push((0,S.localize)(45,null,c)),t.push(""));const o={},d=[];for(const i in p){const h=p[i];if(h.type==="subcommand")h.description&&d.push({command:i,description:h.description});else if(h.description&&h.cat){let u=o[h.cat];u||(o[h.cat]=u={}),u[i]=h}}for(const i in o){const h=i,u=o[h];u&&(t.push(k[h]),t.push(...s(u,b)),t.push(""))}return d.length&&(t.push((0,S.localize)(46,null)),t.push(...E(d.map(i=>[i.command,i.description]),b)),t.push("")),t.join(`
`)}function a(f,c){return`${f||(0,S.localize)(47,null)}
${c||(0,S.localize)(48,null)}
${process.arch}`}}),define(Se[242],De([1,0,337,204,70]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=A,e.$Em=v,e.$Fm=s,e.$Gm=E;function k(y,$){const w=(m,b)=>{console.warn((0,r.localize)(0,null,m,b))},a=m=>{console.warn((0,r.localize)(1,null,m))},f=(m,b)=>{console.warn((0,r.localize)(2,null,m,b))},c=m=>({onUnknownOption:b=>{S.$xm.includes(m)||console.warn((0,r.localize)(3,null,b,m))},onMultipleValues:w,onEmptyValue:a,onDeprecatedOption:f,getSubcommandReporter:S.$xm.includes(m)?c:void 0}),g={onUnknownOption:m=>{console.warn((0,r.localize)(4,null,m))},onMultipleValues:w,onEmptyValue:a,onDeprecatedOption:f,getSubcommandReporter:c},p=(0,S.$zm)(y,S.$ym,$?g:void 0);return p.goto&&p._.forEach(m=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(m),(0,r.localize)(5,null))),p}function R(y){const $=y.findIndex(w=>!/^-/.test(w));if($>-1)return[...y.slice(0,$),...y.slice($+1)]}function A(y){let[,...$]=y;process.env.VSCODE_DEV&&($=R($)||[]);const w=!E(process.env);return k($,w)}function v(y){let[,,...$]=y;return process.env.VSCODE_DEV&&($=R($)||[]),k($,!0)}function s(y,...$){const w=y.indexOf("--");return w===-1?y.push(...$):y.splice(w,0,...$),y}function E(y){return y.VSCODE_CLI==="1"}}),function(){"use strict";function he(e,n,r){function S(R,A){const v=k(R,A),s=[v];return e.isAbsolute(v)||s.unshift(r),e.resolve(...s)}function k(R,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const v=process.env.VSCODE_PORTABLE;if(v)return e.join(v,"user-data");let s=process.env.VSCODE_APPDATA;if(s)return e.join(s,A);const E=R["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(s=process.env.APPDATA,!s){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");s=e.join(y,"AppData","Roaming")}break;case"darwin":s=e.join(n.homedir(),"Library","Application Support");break;case"linux":s=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(s,A)}return{getUserDataPath:S}}if(typeof define=="function")define(Se[243],De([83,32,33]),function(e,n,r){return he(e,n,r.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=he(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Se[119],De([1,0,32,241,243]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cn=void 0,e.$dn=R,e.$en=A;class k extends r.$_m{constructor(s,E){super(s,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,S.getUserDataPath)(s,E.nameShort)},E)}}e.$cn=k;function R(v,s){return(0,r.$bn)(v["inspect-ptyhost"],v["inspect-brk-ptyhost"],5877,s,v.extensionEnvironment)}function A(v,s){return(0,r.$bn)(v["inspect-sharedprocess"],v["inspect-brk-sharedprocess"],5879,s,v.extensionEnvironment)}}),define(Se[244],De([1,0,11,208]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=S;function S(R,A,v,s){try{k(R,A,v,s)}catch(E){R.error(E?.message??E)}return A}function k(R,A,v,s){const E=(y,$,w)=>{const a=y[$];if((0,n.$ag)(a)){const f=a,c=f.length;if(c>1&&f[0]==="%"&&f[c-1]==="%"){const g=f.substr(1,c-2);let p=v[g];p===void 0&&s&&(p=s[g]);const m=typeof p=="string"?p:p?.message,b=s?.[g],l=typeof b=="string"?b:b?.message;if(!m){l||R.warn(`[${A.name}]: ${(0,r.localize)(0,null,g)}`);return}if(w&&($==="title"||$==="category")&&l&&l!==m){const t={value:m,original:l};y[$]=t}else y[$]=m}}else if((0,n.$cg)(a))for(const f in a)a.hasOwnProperty(f)&&(f==="commands"?E(a,f,!0):E(a,f,w));else if(Array.isArray(a))for(let f=0;f<a.length;f++)E(a,f,w)};for(const y in A)A.hasOwnProperty(y)&&E(A,y)}}),define(Se[87],De([1,0,20,58,212,62]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=v,e.$Qp=s,e.$Rp=E,e.$Sp=y,e.$Tp=$,e.$Up=w,e.$Vp=a;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function v(g){return g=g.trim(),g==="*"||R.test(g)}function s(g){if(!v(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=g.match(R);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}function E(g){if(!g)return null;const p=g.majorBase,m=g.majorMustEqual,b=g.minorBase;let l=g.minorMustEqual;const t=g.patchBase;let o=g.patchMustEqual;g.hasCaret&&(p===0||(l=!1),o=!1);let d=0;if(g.preRelease){const i=A.exec(g.preRelease);if(i){const[,h,u,D]=i;d=Date.UTC(Number(h),Number(u)-1,Number(D))}}return{majorBase:p,majorMustEqual:m,minorBase:b,minorMustEqual:l,patchBase:t,patchMustEqual:o,isMinimum:g.hasGreaterEquals,notBefore:d}}function y(g,p,m){let b;typeof g=="string"?b=E(s(g)):b=g;let l;p instanceof Date?l=p.getTime():typeof p=="string"&&(l=new Date(p).getTime());let t;if(typeof m=="string"?t=E(s(m)):t=m,!b||!t)return!1;const o=b.majorBase,d=b.minorBase,i=b.patchBase;let h=t.majorBase,u=t.minorBase,D=t.patchBase;const I=t.notBefore;let T=t.majorMustEqual,O=t.minorMustEqual,C=t.patchMustEqual;return t.isMinimum?o>h?!0:o<h?!1:d>u?!0:d<u||l&&l<I?!1:i>=D:(o===1&&h===0&&(!T||!O||!C)&&(h=1,u=0,D=0,T=!0,O=!1,C=!1),o<h?!1:o>h?!T:d<u?!1:d>u?!O:i<D?!1:i>D?!C:!(l&&l<I))}function $(g,p,m,b,l){const t=[];if(typeof b.publisher<"u"&&typeof b.publisher!="string")return t.push([r.default.Error,S.localize(0,null)]),t;if(typeof b.name!="string")return t.push([r.default.Error,S.localize(1,null,"name")]),t;if(typeof b.version!="string")return t.push([r.default.Error,S.localize(2,null,"version")]),t;if(!b.engines)return t.push([r.default.Error,S.localize(3,null,"engines")]),t;if(typeof b.engines.vscode!="string")return t.push([r.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof b.extensionDependencies<"u"&&!c(b.extensionDependencies))return t.push([r.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof b.activationEvents<"u"){if(!c(b.activationEvents))return t.push([r.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof b.main>"u"&&typeof b.browser>"u")return t.push([r.default.Error,S.localize(7,null,"activationEvents","main","browser")]),t}if(typeof b.extensionKind<"u"&&typeof b.main>"u"&&t.push([r.default.Warning,S.localize(8,null,"extensionKind")]),typeof b.main<"u"){if(typeof b.main!="string")return t.push([r.default.Error,S.localize(9,null,"main")]),t;{const i=(0,n.$bh)(m,b.main);(0,n.$8g)(i,m)||t.push([r.default.Warning,S.localize(10,null,i.path,m.path)])}}if(typeof b.browser<"u"){if(typeof b.browser!="string")return t.push([r.default.Error,S.localize(11,null,"browser")]),t;{const i=(0,n.$bh)(m,b.browser);(0,n.$8g)(i,m)||t.push([r.default.Warning,S.localize(12,null,i.path,m.path)])}}if(!k.valid(b.version))return t.push([r.default.Error,S.localize(13,null)]),t;const o=[];if(!w(g,p,b,l,o))for(const i of o)t.push([r.default.Error,i]);return t}function w(g,p,m,b,l){return b||typeof m.main>"u"&&typeof m.browser>"u"?!0:f(g,p,m.engines.vscode,l)}function a(g,p,m){return g==="*"||f(p,m,g)}function f(g,p,m,b=[]){const l=E(s(m));if(!l)return b.push(S.localize(14,null,m)),!1;if(l.majorBase===0){if(!l.majorMustEqual||!l.minorMustEqual)return b.push(S.localize(15,null,m)),!1}else if(!l.majorMustEqual)return b.push(S.localize(16,null,m)),!1;return y(g,p,l)?!0:(b.push(S.localize(17,null,g,m)),!1)}function c(g){if(!Array.isArray(g))return!1;for(let p=0,m=g.length;p<m;p++)if(typeof g[p]!="string")return!1;return!0}}),define(Se[71],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class n{constructor(S,k=[],R=!1){this.ctor=S,this.staticArguments=k,this.supportsDelayedInstantiation=R}}e.$xi=n}),define(Se[120],De([1,0,71]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Gs=k,e.$Hs=R;const r=[];var S;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function k(A,v,s){v instanceof n.$xi||(v=new n.$xi(v,[],!!s)),r.push([A,v])}function R(){return r}}),define(Se[245],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=void 0;class n{constructor(k,R){this.key=k,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$jr=n;class r{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const R of this.a.values())R.outgoing.size===0&&k.push(R);return k}insertEdge(k,R){const A=this.lookupOrInsertNode(k),v=this.lookupOrInsertNode(R);A.outgoing.set(v.key,v),v.incoming.set(A.key,A)}removeNode(k){const R=this.b(k);this.a.delete(R);for(const A of this.a.values())A.outgoing.delete(R),A.incoming.delete(R)}lookupOrInsertNode(k){const R=this.b(k);let A=this.a.get(R);return A||(A=new n(R,k),this.a.set(R,A)),A}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[R,A]of this.a)k.push(`${R}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,R]of this.a){const A=new Set([k]),v=this.c(R,A);if(v)return v}}c(k,R){for(const[A,v]of k.outgoing){if(R.has(A))return[...R,A].join(" -> ");R.add(A);const s=this.c(v,R);if(s)return s;R.delete(A)}}}e.$kr=r}),define(Se[5],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=S,e.$Bi=k;var n;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function A(v){return v[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=A})(n||(e._util=n={})),e.$zi=S("instantiationService");function r(R,A,v){A[n.DI_TARGET]===A?A[n.DI_DEPENDENCIES].push({id:R,index:v}):(A[n.DI_DEPENDENCIES]=[{id:R,index:v}],A[n.DI_TARGET]=A)}function S(R){if(n.serviceIds.has(R))return n.serviceIds.get(R);const A=function(v,s,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");r(A,v,E)};return A.toString=()=>R,n.serviceIds.set(R,A),A}function k(R){return R}}),define(Se[27],De([1,0,11,4,5]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=k,e.$9i=R,e.$0i=v,e.$$i=s,e.$_i=E,e.$aj=y,e.$bj=$,e.$cj=a,e.$dj=f,e.$ej=c,e.$7i=(0,S.$Ai)("configurationService");function k(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof r.URI)}function R(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof r.URI)}var A;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function v(g){switch(g){case A.APPLICATION:return"APPLICATION";case A.USER:return"USER";case A.USER_LOCAL:return"USER_LOCAL";case A.USER_REMOTE:return"USER_REMOTE";case A.WORKSPACE:return"WORKSPACE";case A.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case A.DEFAULT:return"DEFAULT";case A.MEMORY:return"MEMORY"}}function s(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}function E(g,p){const m=Object.create(null);for(const b in g)y(m,b,g[b],p);return m}function y(g,p,m,b){const l=p.split("."),t=l.pop();let o=g;for(let d=0;d<l.length;d++){const i=l[d];let h=o[i];switch(typeof h){case"undefined":h=o[i]=Object.create(null);break;case"object":if(h===null){b(`Ignoring ${p} as ${l.slice(0,d+1).join(".")} is null`);return}break;default:b(`Ignoring ${p} as ${l.slice(0,d+1).join(".")} is ${JSON.stringify(h)}`);return}o=h}if(typeof o=="object"&&o!==null)try{o[t]=m}catch{b(`Ignoring ${p} as ${l.join(".")} is ${JSON.stringify(o)}`)}else b(`Ignoring ${p} as ${l.join(".")} is ${JSON.stringify(o)}`)}function $(g,p){const m=p.split(".");w(g,m)}function w(g,p){const m=p.shift();if(p.length===0){delete g[m];return}if(Object.keys(g).indexOf(m)!==-1){const b=g[m];typeof b=="object"&&!Array.isArray(b)&&(w(b,p),Object.keys(b).length===0&&delete g[m])}}function a(g,p,m){function b(o,d){let i=o;for(const h of d){if(typeof i!="object"||i===null)return;i=i[h]}return i}const l=p.split("."),t=b(g,l);return typeof t>"u"?m:t}function f(g,p,m){Object.keys(p).forEach(b=>{b!=="__proto__"&&(b in g?n.$cg(g[b])&&n.$cg(p[b])?f(g[b],p[b],m):m&&(g[b]=p[b]):g[b]=p[b])})}function c(g){return g.replace(/[\[\]]/g,"")}}),define(Se[43],De([1,0,35,3,17,238,5,201,10]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=E,e.$zj=d,e.$Aj=i,e.$Tj=W;const s=new Map;s.set("false",!1),s.set("true",!0),s.set("isMac",r.$d),s.set("isLinux",r.$e),s.set("isWindows",r.$c),s.set("isWeb",r.$i),s.set("isMacNative",r.$d&&!r.$i),s.set("isEdge",r.$B),s.set("isFirefox",r.$z),s.set("isChrome",r.$y),s.set("isSafari",r.$A);function E(H,L){if(s.get(H)!==void 0)throw(0,v.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");s.set(H,L)}const y=Object.prototype.hasOwnProperty;var $;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})($||(e.ContextKeyExprType=$={}));const w={regexParsingWithErrorRecovery:!0},a=(0,A.localize)(0,null),f=(0,A.localize)(1,null),c=(0,A.localize)(2,null),g=(0,A.localize)(3,null),p=(0,A.localize)(4,null),m=(0,A.localize)(5,null),b=(0,A.localize)(6,null),l=(0,A.localize)(7,null);class t{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=w){this.k=L,this.d=new k.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:a,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const V=this.l();if(!this.E()){const B=this.D(),U=B.type===k.TokenType.Str?m:void 0;throw this.h.push({message:p,offset:B.offset,lexeme:k.$vj.getLexeme(B),additionalInfo:U}),t.c}return V}catch(V){if(V!==t.c)throw V;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(k.TokenType.Or);){const V=this.o();L.push(V)}return L.length===1?L[0]:o.or(...L)}o(){const L=[this.s()];for(;this.y(k.TokenType.And);){const V=this.s();L.push(V)}return L.length===1?L[0]:o.and(...L)}s(){if(this.y(k.TokenType.Neg)){const L=this.D();switch(L.type){case k.TokenType.True:return this.z(),u.INSTANCE;case k.TokenType.False:return this.z(),D.INSTANCE;case k.TokenType.LParen:{this.z();const V=this.l();return this.A(k.TokenType.RParen,g),V?.negate()}case k.TokenType.Str:return this.z(),Q.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case k.TokenType.True:return this.z(),o.true();case k.TokenType.False:return this.z(),o.false();case k.TokenType.LParen:{this.z();const V=this.l();return this.A(k.TokenType.RParen,g),V}case k.TokenType.Str:{const V=L.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==k.TokenType.RegexStr)throw this.B("REGEX",U);const K=U.lexeme,Z=K.lastIndexOf("/"),j=Z===K.length-1?void 0:this.w(K.substring(Z+1));let G;try{G=new RegExp(K.substring(1,Z),j)}catch{throw this.B("REGEX",U)}return q.create(V,G)}switch(U.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const K=[U.lexeme];this.z();let Z=this.D(),j=0;for(let Le=0;Le<U.lexeme.length;Le++)U.lexeme.charCodeAt(Le)===n.CharCode.OpenParen?j++:U.lexeme.charCodeAt(Le)===n.CharCode.CloseParen&&j--;for(;!this.E()&&Z.type!==k.TokenType.And&&Z.type!==k.TokenType.Or;){switch(Z.type){case k.TokenType.LParen:j++;break;case k.TokenType.RParen:j--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let Le=0;Le<Z.lexeme.length;Le++)Z.lexeme.charCodeAt(Le)===n.CharCode.OpenParen?j++:U.lexeme.charCodeAt(Le)===n.CharCode.CloseParen&&j--}if(j<0)break;K.push(k.$vj.getLexeme(Z)),this.z(),Z=this.D()}const G=K.join(""),se=G.lastIndexOf("/"),fe=se===G.length-1?void 0:this.w(G.substring(se+1));let Ee;try{Ee=new RegExp(G.substring(1,se),fe)}catch{throw this.B("REGEX",U)}return o.regex(V,Ee)}case k.TokenType.QuotedStr:{const K=U.lexeme;this.z();let Z=null;if(!(0,S.$$e)(K)){const j=K.indexOf("/"),G=K.lastIndexOf("/");if(j!==G&&j>=0){const se=K.slice(j+1,G),fe=K[G+1]==="i"?"i":"";try{Z=new RegExp(se,fe)}catch{throw this.B("REGEX",U)}}}if(Z===null)throw this.B("REGEX",U);return q.create(V,Z)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,c);const U=this.u();return o.notIn(V,U)}switch(this.D().type){case k.TokenType.Eq:{this.z();const U=this.u();if(this.x().type===k.TokenType.QuotedStr)return o.equals(V,U);switch(U){case"true":return o.has(V);case"false":return o.not(V);default:return o.equals(V,U)}}case k.TokenType.NotEq:{this.z();const U=this.u();if(this.x().type===k.TokenType.QuotedStr)return o.notEquals(V,U);switch(U){case"true":return o.not(V);case"false":return o.has(V);default:return o.notEquals(V,U)}}case k.TokenType.Lt:return this.z(),x.create(V,this.u());case k.TokenType.LtEq:return this.z(),re.create(V,this.u());case k.TokenType.Gt:return this.z(),ie.create(V,this.u());case k.TokenType.GtEq:return this.z(),ne.create(V,this.u());case k.TokenType.In:return this.z(),o.in(V,this.u());default:return o.has(V)}}case k.TokenType.EOF:throw this.h.push({message:b,offset:L.offset,lexeme:"",additionalInfo:l}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),L.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,V){if(this.C(L))return this.z();throw this.B(V,this.D())}B(L,V,B){const U=(0,A.localize)(8,null,L,k.$vj.getLexeme(V)),K=V.offset,Z=k.$vj.getLexeme(V);return this.h.push({message:U,offset:K,lexeme:Z,additionalInfo:B}),t.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$xj=t,t.c=new Error;class o{static false(){return u.INSTANCE}static true(){return D.INSTANCE}static has(L){return I.create(L)}static equals(L,V){return T.create(L,V)}static notEquals(L,V){return P.create(L,V)}static regex(L,V){return q.create(L,V)}static in(L,V){return O.create(L,V)}static notIn(L,V){return C.create(L,V)}static not(L){return Q.create(L)}static and(...L){return M.create(L,null,!0)}static or(...L){return z.create(L,null,!0)}static greater(L,V){return ie.create(L,V)}static greaterEquals(L,V){return ne.create(L,V)}static smaller(L,V){return x.create(L,V)}static smallerEquals(L,V){return re.create(L,V)}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$yj=o,o.c=new t({regexParsingWithErrorRecovery:!1});function d(H){const L=new t({regexParsingWithErrorRecovery:!1});return H.map(V=>(L.parse(V),L.lexingErrors.length>0?L.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,A.localize)(9,null,B.additionalInfo):(0,A.localize)(10,null),offset:B.offset,length:B.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}function i(H,L){const V=H?H.substituteConstants():void 0,B=L?L.substituteConstants():void 0;return!V&&!B?!0:!V||!B?!1:V.equals(B)}function h(H,L){return H.cmp(L)}class u{constructor(){this.type=$.False}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return D.INSTANCE}}e.$Bj=u,u.INSTANCE=new u;class D{constructor(){this.type=$.True}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return u.INSTANCE}}e.$Cj=D,D.INSTANCE=new D;class I{static create(L,V=null){const B=s.get(L);return typeof B=="boolean"?B?D.INSTANCE:u.INSTANCE:new I(L,V)}constructor(L,V){this.key=L,this.c=V,this.type=$.Defined}cmp(L){return L.type!==this.type?this.type-L.type:ce(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=s.get(this.key);return typeof L=="boolean"?L?D.INSTANCE:u.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=Q.create(this.key,this)),this.c}}e.$Dj=I;class T{static create(L,V,B=null){if(typeof V=="boolean")return V?I.create(L,B):Q.create(L,B);const U=s.get(L);return typeof U=="boolean"?V===(U?"true":"false")?D.INSTANCE:u.INSTANCE:new T(L,V,B)}constructor(L,V,B){this.c=L,this.d=V,this.f=B,this.type=$.Equals}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=s.get(this.c);if(typeof L=="boolean"){const V=L?"true":"false";return this.d===V?D.INSTANCE:u.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Ej=T;class O{static create(L,V){return new O(L,V)}constructor(L,V){this.d=L,this.f=V,this.type=$.In,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const V=L.getValue(this.f),B=L.getValue(this.d);return Array.isArray(V)?V.includes(B):typeof B=="string"&&typeof V=="object"&&V!==null?y.call(V,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=C.create(this.d,this.f)),this.c}}e.$Fj=O;class C{static create(L,V){return new C(L,V)}constructor(L,V){this.d=L,this.f=V,this.type=$.NotIn,this.c=O.create(L,V)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=C;class P{static create(L,V,B=null){if(typeof V=="boolean")return V?Q.create(L,B):I.create(L,B);const U=s.get(L);return typeof U=="boolean"?V===(U?"true":"false")?u.INSTANCE:D.INSTANCE:new P(L,V,B)}constructor(L,V,B){this.c=L,this.d=V,this.f=B,this.type=$.NotEquals}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=s.get(this.c);if(typeof L=="boolean"){const V=L?"true":"false";return this.d===V?u.INSTANCE:D.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Hj=P;class Q{static create(L,V=null){const B=s.get(L);return typeof B=="boolean"?B?u.INSTANCE:D.INSTANCE:new Q(L,V)}constructor(L,V){this.c=L,this.d=V,this.type=$.Not}cmp(L){return L.type!==this.type?this.type-L.type:ce(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=s.get(this.c);return typeof L=="boolean"?L?u.INSTANCE:D.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=I.create(this.c,this)),this.d}}e.$Ij=Q;function X(H,L){if(typeof H=="string"){const V=parseFloat(H);isNaN(V)||(H=V)}return typeof H=="string"||typeof H=="number"?L(H):u.INSTANCE}class ie{static create(L,V,B=null){return X(V,U=>new ie(L,U,B))}constructor(L,V,B){this.c=L,this.d=V,this.f=B,this.type=$.Greater}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Jj=ie;class ne{static create(L,V,B=null){return X(V,U=>new ne(L,U,B))}constructor(L,V,B){this.c=L,this.d=V,this.f=B,this.type=$.GreaterEquals}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=x.create(this.c,this.d,this)),this.f}}e.$Kj=ne;class x{static create(L,V,B=null){return X(V,U=>new x(L,U,B))}constructor(L,V,B){this.c=L,this.d=V,this.f=B,this.type=$.Smaller}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Lj=x;class re{static create(L,V,B=null){return X(V,U=>new re(L,U,B))}constructor(L,V,B){this.c=L,this.d=V,this.f=B,this.type=$.SmallerEquals}cmp(L){return L.type!==this.type?this.type-L.type:pe(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Mj=re;class q{static create(L,V){return new q(L,V)}constructor(L,V){this.d=L,this.f=V,this.type=$.Regex,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const V=this.f?this.f.source:"",B=L.f?L.f.source:"";return V<B?-1:V>B?1:0}equals(L){if(L.type===this.type){const V=this.f?this.f.source:"",B=L.f?L.f.source:"";return this.d===L.d&&V===B}return!1}substituteConstants(){return this}evaluate(L){const V=L.getValue(this.d);return this.f?this.f.test(V):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=te.create(this)),this.c}}e.$Nj=q;class te{static create(L){return new te(L)}constructor(L){this.c=L,this.type=$.NotRegex}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new te(this.c.map(L))}negate(){return this.c}}e.$Oj=te;function le(H){let L=null;for(let V=0,B=H.length;V<B;V++){const U=H[V].substituteConstants();if(H[V]!==U&&L===null){L=[];for(let K=0;K<V;K++)L[K]=H[K]}L!==null&&(L[V]=U)}return L===null?H:L}class M{static create(L,V,B){return M.d(L,V,B)}constructor(L,V){this.expr=L,this.c=V,this.type=$.And}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let V=0,B=this.expr.length;V<B;V++){const U=h(this.expr[V],L.expr[V]);if(U!==0)return U}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let V=0,B=this.expr.length;V<B;V++)if(!this.expr[V].equals(L.expr[V]))return!1;return!0}return!1}substituteConstants(){const L=le(this.expr);return L===this.expr?this:M.create(L,this.c,!1)}evaluate(L){for(let V=0,B=this.expr.length;V<B;V++)if(!this.expr[V].evaluate(L))return!1;return!0}static d(L,V,B){const U=[];let K=!1;for(const Z of L)if(Z){if(Z.type===$.True){K=!0;continue}if(Z.type===$.False)return u.INSTANCE;if(Z.type===$.And){U.push(...Z.expr);continue}U.push(Z)}if(U.length===0&&K)return D.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(h);for(let Z=1;Z<U.length;Z++)U[Z-1].equals(U[Z])&&(U.splice(Z,1),Z--);if(U.length===1)return U[0];for(;U.length>1;){const Z=U[U.length-1];if(Z.type!==$.Or)break;U.pop();const j=U.pop(),G=U.length===0,se=z.create(Z.expr.map(fe=>M.create([fe,j],null,B)),null,G);se&&(U.push(se),U.sort(h))}if(U.length===1)return U[0];if(B){for(let Z=0;Z<U.length;Z++)for(let j=Z+1;j<U.length;j++)if(U[Z].negate().equals(U[j]))return u.INSTANCE;if(U.length===1)return U[0]}return new M(U,V)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const V of this.expr)L.push(...V.keys());return L}map(L){return new M(this.expr.map(V=>V.map(L)),null)}negate(){if(!this.c){const L=[];for(const V of this.expr)L.push(V.negate());this.c=z.create(L,this,!0)}return this.c}}e.$Pj=M;class z{static create(L,V,B){return z.d(L,V,B)}constructor(L,V){this.expr=L,this.c=V,this.type=$.Or}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let V=0,B=this.expr.length;V<B;V++){const U=h(this.expr[V],L.expr[V]);if(U!==0)return U}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let V=0,B=this.expr.length;V<B;V++)if(!this.expr[V].equals(L.expr[V]))return!1;return!0}return!1}substituteConstants(){const L=le(this.expr);return L===this.expr?this:z.create(L,this.c,!1)}evaluate(L){for(let V=0,B=this.expr.length;V<B;V++)if(this.expr[V].evaluate(L))return!0;return!1}static d(L,V,B){let U=[],K=!1;if(L){for(let Z=0,j=L.length;Z<j;Z++){const G=L[Z];if(G){if(G.type===$.False){K=!0;continue}if(G.type===$.True)return D.INSTANCE;if(G.type===$.Or){U=U.concat(G.expr);continue}U.push(G)}}if(U.length===0&&K)return u.INSTANCE;U.sort(h)}if(U.length!==0){if(U.length===1)return U[0];for(let Z=1;Z<U.length;Z++)U[Z-1].equals(U[Z])&&(U.splice(Z,1),Z--);if(U.length===1)return U[0];if(B){for(let Z=0;Z<U.length;Z++)for(let j=Z+1;j<U.length;j++)if(U[Z].negate().equals(U[j]))return D.INSTANCE;if(U.length===1)return U[0]}return new z(U,V)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const V of this.expr)L.push(...V.keys());return L}map(L){return new z(this.expr.map(V=>V.map(L)),null)}negate(){if(!this.c){const L=[];for(const V of this.expr)L.push(V.negate());for(;L.length>1;){const V=L.shift(),B=L.shift(),U=[];for(const K of ee(V))for(const Z of ee(B))U.push(M.create([K,Z],null,!1));L.unshift(z.create(U,null,!1))}this.c=z.create(L,this,!0)}return this.c}}e.$Qj=z;class oe extends I{static all(){return oe.d.values()}constructor(L,V,B){super(L,null),this.f=V,typeof B=="object"?oe.d.push({...B,key:L}):B!==!0&&oe.d.push({key:L,description:B,type:V!=null?typeof V:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return T.create(this.key,L)}notEqualsTo(L){return P.create(this.key,L)}}e.$Rj=oe,oe.d=[],e.$Sj=(0,R.$Ai)("contextKeyService");function ce(H,L){return H<L?-1:H>L?1:0}function pe(H,L,V,B){return H<V?-1:H>V?1:L<B?-1:L>B?1:0}function W(H,L){if(H.type===$.False||L.type===$.True)return!0;if(H.type===$.Or)return L.type===$.Or?ae(H.expr,L.expr):!1;if(L.type===$.Or){for(const V of L.expr)if(W(H,V))return!0;return!1}if(H.type===$.And){if(L.type===$.And)return ae(L.expr,H.expr);for(const V of H.expr)if(W(V,L))return!0;return!1}return H.equals(L)}function ae(H,L){let V=0,B=0;for(;V<H.length&&B<L.length;){const U=H[V].cmp(L[B]);if(U<0)return!1;U===0&&V++,B++}return V===H.length}function ee(H){return H.type===$.Or?H.expr:[H]}}),define(Se[246],De([1,0,43,5]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=e.$qu=e.AccessibilitySupport=e.$pu=void 0,e.$ru=k,e.$pu=(0,r.$Ai)("accessibilityService");var S;(function(R){R[R.Unknown=0]="Unknown",R[R.Disabled=1]="Disabled",R[R.Enabled=2]="Enabled"})(S||(e.AccessibilitySupport=S={})),e.$qu=new n.$Rj("accessibilityModeEnabled",!1);function k(R){return R&&typeof R=="object"&&typeof R.label=="string"&&(typeof R.role>"u"||typeof R.role=="string")}e.$su="ACCESSIBLE_VIEW_SHOWN_"}),define(Se[247],De([1,0,18,21,3,169,110,185,186,197,246]),function(he,e,n,r,S,k,R,A,v,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=m,e.clampedInt=l,e.clampedFloat=o,e.stringSet=h,e.cursorStyleToString=X,e.filterValidationDecorations=de;var y;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class ${constructor(_){this.c=_}hasChanged(_){return this.c[_]}}e.ConfigurationChangedEvent=$;class w{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=w;class a{constructor(_,ye,Me,Ve){this.id=_,this.name=ye,this.defaultValue=Me,this.schema=Ve}applyUpdate(_,ye){return c(_,ye)}compute(_,ye,Me){return Me}}class f{constructor(_,ye){this.newValue=_,this.didChange=ye}}e.ApplyUpdateResult=f;function c(Y,_){if(typeof Y!="object"||typeof _!="object"||!Y||!_)return new f(_,Y!==_);if(Array.isArray(Y)||Array.isArray(_)){const Me=Array.isArray(Y)&&Array.isArray(_)&&n.$ub(Y,_);return new f(_,!Me)}let ye=!1;for(const Me in _)if(_.hasOwnProperty(Me)){const Ve=c(Y[Me],_[Me]);Ve.didChange&&(Y[Me]=Ve.newValue,ye=!0)}return new f(Y,ye)}class g{constructor(_){this.schema=void 0,this.id=_,this.name="_never_",this.defaultValue=void 0}applyUpdate(_,ye){return c(_,ye)}validate(_){return this.defaultValue}}class p{constructor(_,ye,Me,Ve){this.id=_,this.name=ye,this.defaultValue=Me,this.schema=Ve}applyUpdate(_,ye){return c(_,ye)}validate(_){return typeof _>"u"?this.defaultValue:_}compute(_,ye,Me){return Me}}function m(Y,_){return typeof Y>"u"?_:Y==="false"?!1:!!Y}class b extends p{constructor(_,ye,Me,Ve=void 0){typeof Ve<"u"&&(Ve.type="boolean",Ve.default=Me),super(_,ye,Me,Ve)}validate(_){return m(_,this.defaultValue)}}function l(Y,_,ye,Me){if(typeof Y>"u")return _;let Ve=parseInt(Y,10);return isNaN(Ve)?_:(Ve=Math.max(ye,Ve),Ve=Math.min(Me,Ve),Ve|0)}class t extends p{static clampedInt(_,ye,Me,Ve){return l(_,ye,Me,Ve)}constructor(_,ye,Me,Ve,Ye,_e=void 0){typeof _e<"u"&&(_e.type="integer",_e.default=Me,_e.minimum=Ve,_e.maximum=Ye),super(_,ye,Me,_e),this.minimum=Ve,this.maximum=Ye}validate(_){return t.clampedInt(_,this.defaultValue,this.minimum,this.maximum)}}function o(Y,_,ye,Me){if(typeof Y>"u")return _;const Ve=d.float(Y,_);return d.clamp(Ve,ye,Me)}class d extends p{static clamp(_,ye,Me){return _<ye?ye:_>Me?Me:_}static float(_,ye){if(typeof _=="number")return _;if(typeof _>"u")return ye;const Me=parseFloat(_);return isNaN(Me)?ye:Me}constructor(_,ye,Me,Ve,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=Me),super(_,ye,Me,Ye),this.validationFn=Ve}validate(_){return this.validationFn(d.float(_,this.defaultValue))}}class i extends p{static string(_,ye){return typeof _!="string"?ye:_}constructor(_,ye,Me,Ve=void 0){typeof Ve<"u"&&(Ve.type="string",Ve.default=Me),super(_,ye,Me,Ve)}validate(_){return i.string(_,this.defaultValue)}}function h(Y,_,ye,Me){return typeof Y!="string"?_:Me&&Y in Me?Me[Y]:ye.indexOf(Y)===-1?_:Y}class u extends p{constructor(_,ye,Me,Ve,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=Ve,Ye.default=Me),super(_,ye,Me,Ye),this.c=Ve}validate(_){return h(_,this.defaultValue,this.c)}}class D extends a{constructor(_,ye,Me,Ve,Ye,_e,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=Ye,ot.default=Ve),super(_,ye,Me,ot),this.c=Ye,this.d=_e}validate(_){return typeof _!="string"?this.defaultValue:this.c.indexOf(_)===-1?this.defaultValue:this.d(_)}}function I(Y){switch(Y){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class T extends a{constructor(){super(be.accessibilitySupport,"accessibilitySupport",E.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[s.localize(0,null),s.localize(1,null),s.localize(2,null)],default:"auto",tags:["accessibility"],description:s.localize(3,null)})}validate(_){switch(_){case"auto":return E.AccessibilitySupport.Unknown;case"off":return E.AccessibilitySupport.Disabled;case"on":return E.AccessibilitySupport.Enabled}return this.defaultValue}compute(_,ye,Me){return Me===E.AccessibilitySupport.Unknown?_.accessibilitySupport:Me}}class O extends a{constructor(){const _={insertSpace:!0,ignoreEmptyLines:!0};super(be.comments,"comments",_,{"editor.comments.insertSpace":{type:"boolean",default:_.insertSpace,description:s.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:_.ignoreEmptyLines,description:s.localize(5,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{insertSpace:m(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:m(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var C;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(C||(e.TextEditorCursorBlinkingStyle=C={}));function P(Y){switch(Y){case"blink":return C.Blink;case"smooth":return C.Smooth;case"phase":return C.Phase;case"expand":return C.Expand;case"solid":return C.Solid}}var Q;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(Q||(e.TextEditorCursorStyle=Q={}));function X(Y){switch(Y){case Q.Line:return"line";case Q.Block:return"block";case Q.Underline:return"underline";case Q.LineThin:return"line-thin";case Q.BlockOutline:return"block-outline";case Q.UnderlineThin:return"underline-thin"}}function ie(Y){switch(Y){case"line":return Q.Line;case"block":return Q.Block;case"underline":return Q.Underline;case"line-thin":return Q.LineThin;case"block-outline":return Q.BlockOutline;case"underline-thin":return Q.UnderlineThin}}class ne extends g{constructor(){super(be.editorClassName)}compute(_,ye,Me){const Ve=["monaco-editor"];return ye.get(be.extraEditorClassName)&&Ve.push(ye.get(be.extraEditorClassName)),_.extraEditorClassName&&Ve.push(_.extraEditorClassName),ye.get(be.mouseStyle)==="default"?Ve.push("mouse-default"):ye.get(be.mouseStyle)==="copy"&&Ve.push("mouse-copy"),ye.get(be.showUnused)&&Ve.push("showUnused"),ye.get(be.showDeprecated)&&Ve.push("showDeprecated"),Ve.join(" ")}}class x extends b{constructor(){super(be.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:s.localize(6,null)})}compute(_,ye,Me){return Me&&_.emptySelectionClipboard}}class re extends a{constructor(){const _={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(be.find,"find",_,{"editor.find.cursorMoveOnType":{type:"boolean",default:_.cursorMoveOnType,description:s.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:_.seedSearchStringFromSelection,enumDescriptions:[s.localize(8,null),s.localize(9,null),s.localize(10,null)],description:s.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:_.autoFindInSelection,enumDescriptions:[s.localize(12,null),s.localize(13,null),s.localize(14,null)],description:s.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:_.globalFindClipboard,description:s.localize(16,null),included:S.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:_.addExtraSpaceOnTop,description:s.localize(17,null)},"editor.find.loop":{type:"boolean",default:_.loop,description:s.localize(18,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{cursorMoveOnType:m(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof _.seedSearchStringFromSelection=="boolean"?_.seedSearchStringFromSelection?"always":"never":h(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof _.autoFindInSelection=="boolean"?_.autoFindInSelection?"always":"never":h(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:m(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:m(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:m(ye.loop,this.defaultValue.loop)}}}class q extends a{constructor(){super(be.fontLigatures,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:s.localize(19,null)},{type:"string",description:s.localize(20,null)}],description:s.localize(21,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"||_.length===0?q.OFF:_==="true"?q.ON:_:_?q.ON:q.OFF}}e.EditorFontLigatures=q,q.OFF='"liga" off, "calt" off',q.ON='"liga" on, "calt" on';class te extends a{constructor(){super(be.fontVariations,"fontVariations",te.OFF,{anyOf:[{type:"boolean",description:s.localize(22,null)},{type:"string",description:s.localize(23,null)}],description:s.localize(24,null),default:!1})}validate(_){return typeof _>"u"?this.defaultValue:typeof _=="string"?_==="false"?te.OFF:_==="true"?te.TRANSLATE:_:_?te.TRANSLATE:te.OFF}compute(_,ye,Me){return _.fontInfo.fontVariationSettings}}e.EditorFontVariations=te,te.OFF="normal",te.TRANSLATE="translate";class le extends g{constructor(){super(be.fontInfo)}compute(_,ye,Me){return _.fontInfo}}class M extends p{constructor(){super(be.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:s.localize(25,null)})}validate(_){const ye=d.float(_,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ye,6,100)}compute(_,ye,Me){return _.fontInfo.fontSize}}class z extends a{constructor(){super(be.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.d,maximum:z.e,errorMessage:s.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:s.localize(27,null)})}validate(_){return _==="normal"||_==="bold"?_:String(t.clampedInt(_,e.EDITOR_FONT_DEFAULTS.fontWeight,z.d,z.e))}}z.c=["normal","bold","100","200","300","400","500","600","700","800","900"],z.d=1,z.e=1e3;class oe extends a{constructor(){const _={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:_.multiple,enumDescriptions:[s.localize(28,null),s.localize(29,null),s.localize(30,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(be.gotoLocation,"gotoLocation",_,{"editor.gotoLocation.multiple":{deprecationMessage:s.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:s.localize(32,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:s.localize(33,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:s.localize(34,null),...ye},"editor.gotoLocation.multipleImplementations":{description:s.localize(35,null),...ye},"editor.gotoLocation.multipleReferences":{description:s.localize(36,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:_.alternativeDefinitionCommand,enum:Me,description:s.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:_.alternativeTypeDefinitionCommand,enum:Me,description:s.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:_.alternativeDeclarationCommand,enum:Me,description:s.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:_.alternativeImplementationCommand,enum:Me,description:s.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:_.alternativeReferenceCommand,enum:Me,description:s.localize(41,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{multiple:h(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??h(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??h(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??h(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??h(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??h(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ce extends a{constructor(){const _={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(be.hover,"hover",_,{"editor.hover.enabled":{type:"boolean",default:_.enabled,description:s.localize(42,null)},"editor.hover.delay":{type:"number",default:_.delay,minimum:0,maximum:1e4,description:s.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:_.sticky,description:s.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:_.hidingDelay,description:s.localize(45,null)},"editor.hover.above":{type:"boolean",default:_.above,description:s.localize(46,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{enabled:m(ye.enabled,this.defaultValue.enabled),delay:t.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:m(ye.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(ye.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:m(ye.above,this.defaultValue.above)}}}var pe;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(pe||(e.RenderMinimap=pe={}));class W extends g{constructor(){super(be.layoutInfo)}compute(_,ye,Me){return W.computeLayout(ye,{memory:_.memory,outerWidth:_.outerWidth,outerHeight:_.outerHeight,isDominatedByLongLines:_.isDominatedByLongLines,lineHeight:_.fontInfo.lineHeight,viewLineCount:_.viewLineCount,lineNumbersDigitCount:_.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:_.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:_.fontInfo.maxDigitWidth,pixelRatio:_.pixelRatio,glyphMarginDecorationLaneCount:_.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(_){const ye=_.height/_.lineHeight,Me=Math.floor(_.paddingTop/_.lineHeight);let Ve=Math.floor(_.paddingBottom/_.lineHeight);_.scrollBeyondLastLine&&(Ve=Math.max(Ve,ye-1));const Ye=(Me+_.viewLineCount+Ve)/(_.pixelRatio*_.height),_e=Math.floor(_.viewLineCount/Ye);return{typicalViewportLineCount:ye,extraLinesBeforeFirstLine:Me,extraLinesBeyondLastLine:Ve,desiredRatio:Ye,minimapLineCount:_e}}static c(_,ye){const Me=_.outerWidth,Ve=_.outerHeight,Ye=_.pixelRatio;if(!_.minimap.enabled)return{renderMinimap:pe.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const _e=ye.stableMinimapLayoutInput,ot=_e&&_.outerHeight===_e.outerHeight&&_.lineHeight===_e.lineHeight&&_.typicalHalfwidthCharacterWidth===_e.typicalHalfwidthCharacterWidth&&_.pixelRatio===_e.pixelRatio&&_.scrollBeyondLastLine===_e.scrollBeyondLastLine&&_.paddingTop===_e.paddingTop&&_.paddingBottom===_e.paddingBottom&&_.minimap.enabled===_e.minimap.enabled&&_.minimap.side===_e.minimap.side&&_.minimap.size===_e.minimap.size&&_.minimap.showSlider===_e.minimap.showSlider&&_.minimap.renderCharacters===_e.minimap.renderCharacters&&_.minimap.maxColumn===_e.minimap.maxColumn&&_.minimap.scale===_e.minimap.scale&&_.verticalScrollbarWidth===_e.verticalScrollbarWidth&&_.isViewportWrapping===_e.isViewportWrapping,ht=_.lineHeight,gt=_.typicalHalfwidthCharacterWidth,Ct=_.scrollBeyondLastLine,Ot=_.minimap.renderCharacters;let mt=Ye>=2?Math.round(_.minimap.scale*2):_.minimap.scale;const yt=_.minimap.maxColumn,pt=_.minimap.size,kt=_.minimap.side,Ht=_.verticalScrollbarWidth,It=_.viewLineCount,bt=_.remainingWidth,qt=_.isViewportWrapping,Pt=Ot?2:3;let at=Math.floor(Ye*Ve);const ft=at/Ye;let $t=!1,Wt=!1,Rt=Pt*mt,Lt=mt/Ye,Vt=1;if(pt==="fill"||pt==="fit"){const{typicalViewportLineCount:Zt,extraLinesBeforeFirstLine:Xt,extraLinesBeyondLastLine:Tt,desiredRatio:Yt,minimapLineCount:St}=W.computeContainedMinimapLineCount({viewLineCount:It,scrollBeyondLastLine:Ct,paddingTop:_.paddingTop,paddingBottom:_.paddingBottom,height:Ve,lineHeight:ht,pixelRatio:Ye});if(It/St>1)$t=!0,Wt=!0,mt=1,Rt=1,Lt=mt/Ye;else{let wt=!1,zt=mt+1;if(pt==="fit"){const Gt=Math.ceil((Xt+It+Tt)*Rt);qt&&ot&&bt<=ye.stableFitRemainingWidth?(wt=!0,zt=ye.stableFitMaxMinimapScale):wt=Gt>at}if(pt==="fill"||wt){$t=!0;const Gt=mt;Rt=Math.min(ht*Ye,Math.max(1,Math.floor(1/Yt))),qt&&ot&&bt<=ye.stableFitRemainingWidth&&(zt=ye.stableFitMaxMinimapScale),mt=Math.min(zt,Math.max(1,Math.floor(Rt/Pt))),mt>Gt&&(Vt=Math.min(2,mt/Gt)),Lt=mt/Ye/Vt,at=Math.ceil(Math.max(Zt,Xt+It+Tt)*Rt),qt?(ye.stableMinimapLayoutInput=_,ye.stableFitRemainingWidth=bt,ye.stableFitMaxMinimapScale=mt):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const Kt=Math.floor(yt*Lt),Et=Math.min(Kt,Math.max(0,Math.floor((bt-Ht-2)*Lt/(gt+Lt)))+e.MINIMAP_GUTTER_WIDTH);let At=Math.floor(Ye*Et);const Ut=At/Ye;At=Math.floor(At*Vt);const Nt=Ot?pe.Text:pe.Blocks,Qt=kt==="left"?0:Me-Et-Ht;return{renderMinimap:Nt,minimapLeft:Qt,minimapWidth:Et,minimapHeightIsEditorHeight:$t,minimapIsSampling:Wt,minimapScale:mt,minimapLineHeight:Rt,minimapCanvasInnerWidth:At,minimapCanvasInnerHeight:at,minimapCanvasOuterWidth:Ut,minimapCanvasOuterHeight:ft}}static computeLayout(_,ye){const Me=ye.outerWidth|0,Ve=ye.outerHeight|0,Ye=ye.lineHeight|0,_e=ye.lineNumbersDigitCount|0,ot=ye.typicalHalfwidthCharacterWidth,ht=ye.maxDigitWidth,gt=ye.pixelRatio,Ct=ye.viewLineCount,Ot=_.get(be.wordWrapOverride2),mt=Ot==="inherit"?_.get(be.wordWrapOverride1):Ot,yt=mt==="inherit"?_.get(be.wordWrap):mt,pt=_.get(be.wordWrapColumn),kt=ye.isDominatedByLongLines,Ht=_.get(be.glyphMargin),It=_.get(be.lineNumbers).renderType!==Ee.Off,bt=_.get(be.lineNumbersMinChars),qt=_.get(be.scrollBeyondLastLine),Pt=_.get(be.padding),at=_.get(be.minimap),ft=_.get(be.scrollbar),$t=ft.verticalScrollbarSize,Wt=ft.verticalHasArrows,Rt=ft.arrowSize,Lt=ft.horizontalScrollbarSize,Vt=_.get(be.folding),Kt=_.get(be.showFoldingControls)!=="never";let Et=_.get(be.lineDecorationsWidth);Vt&&Kt&&(Et+=16);let At=0;if(It){const sn=Math.max(_e,bt);At=Math.round(sn*ht)}let Ut=0;Ht&&(Ut=Ye*ye.glyphMarginDecorationLaneCount);let Nt=0,Qt=Nt+Ut,Zt=Qt+At,Xt=Zt+Et;const Tt=Me-Ut-At-Et;let Yt=!1,St=!1,Ft=-1;mt==="inherit"&&kt?(Yt=!0,St=!0):yt==="on"||yt==="bounded"?St=!0:yt==="wordWrapColumn"&&(Ft=pt);const wt=W.c({outerWidth:Me,outerHeight:Ve,lineHeight:Ye,typicalHalfwidthCharacterWidth:ot,pixelRatio:gt,scrollBeyondLastLine:qt,paddingTop:Pt.top,paddingBottom:Pt.bottom,minimap:at,verticalScrollbarWidth:$t,viewLineCount:Ct,remainingWidth:Tt,isViewportWrapping:St},ye.memory||new w);wt.renderMinimap!==pe.None&&wt.minimapLeft===0&&(Nt+=wt.minimapWidth,Qt+=wt.minimapWidth,Zt+=wt.minimapWidth,Xt+=wt.minimapWidth);const zt=Tt-wt.minimapWidth,Gt=Math.max(1,Math.floor((zt-$t-2)/ot)),Mt=Wt?Rt:0;return St&&(Ft=Math.max(1,Gt),yt==="bounded"&&(Ft=Math.min(Ft,pt))),{width:Me,height:Ve,glyphMarginLeft:Nt,glyphMarginWidth:Ut,glyphMarginDecorationLaneCount:ye.glyphMarginDecorationLaneCount,lineNumbersLeft:Qt,lineNumbersWidth:At,decorationsLeft:Zt,decorationsWidth:Et,contentLeft:Xt,contentWidth:zt,minimap:wt,viewportColumn:Gt,isWordWrapMinified:Yt,isViewportWrapping:St,wrappingColumn:Ft,verticalScrollbarWidth:$t,horizontalScrollbarHeight:Lt,overviewRuler:{top:Mt,width:$t,height:Ve-2*Mt,right:0}}}}e.EditorLayoutInfoComputer=W;class ae extends a{constructor(){super(be.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[s.localize(47,null),s.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:s.localize(49,null)}})}validate(_){return h(_,"simple",["simple","advanced"])}compute(_,ye,Me){return ye.get(be.accessibilitySupport)===E.AccessibilitySupport.Enabled?"advanced":Me}}var ee;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(ee||(e.ShowLightbulbIconMode=ee={}));class H extends a{constructor(){const _={enabled:ee.On};super(be.lightbulb,"lightbulb",_,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[ee.Off,ee.OnCode,ee.On],default:_.enabled,enumDescriptions:[s.localize(50,null),s.localize(51,null),s.localize(52,null)],description:s.localize(53,null)}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{enabled:h(_.enabled,this.defaultValue.enabled,[ee.Off,ee.OnCode,ee.On])}}}class L extends a{constructor(){const _={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(be.stickyScroll,"stickyScroll",_,{"editor.stickyScroll.enabled":{type:"boolean",default:_.enabled,description:s.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:_.maxLineCount,minimum:1,maximum:20,description:s.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:_.defaultModel,description:s.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:_.scrollWithEditor,description:s.localize(57,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{enabled:m(ye.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(ye.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(ye.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:m(ye.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class V extends a{constructor(){const _={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(be.inlayHints,"inlayHints",_,{"editor.inlayHints.enabled":{type:"string",default:_.enabled,description:s.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[s.localize(59,null),s.localize(60,null,S.$d?"Ctrl+Option":"Ctrl+Alt"),s.localize(61,null,S.$d?"Ctrl+Option":"Ctrl+Alt"),s.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:_.fontSize,markdownDescription:s.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:_.fontFamily,markdownDescription:s.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:_.padding,description:s.localize(65,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:h(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(ye.fontFamily,this.defaultValue.fontFamily),padding:m(ye.padding,this.defaultValue.padding)}}}class B extends a{constructor(){super(be.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(_){return typeof _=="string"&&/^\d+(\.\d+)?ch$/.test(_)?-parseFloat(_.substring(0,_.length-2)):t.clampedInt(_,this.defaultValue,0,1e3)}compute(_,ye,Me){return Me<0?t.clampedInt(-Me*_.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Me}}class U extends d{constructor(){super(be.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,_=>d.clamp(_,0,150),{markdownDescription:s.localize(66,null)})}compute(_,ye,Me){return _.fontInfo.lineHeight}}class K extends a{constructor(){const _={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(be.minimap,"minimap",_,{"editor.minimap.enabled":{type:"boolean",default:_.enabled,description:s.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:_.autohide,description:s.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[s.localize(69,null),s.localize(70,null),s.localize(71,null)],default:_.size,description:s.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:_.side,description:s.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:_.showSlider,description:s.localize(74,null)},"editor.minimap.scale":{type:"number",default:_.scale,minimum:1,maximum:3,enum:[1,2,3],description:s.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:_.renderCharacters,description:s.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:_.maxColumn,description:s.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:_.showRegionSectionHeaders,description:s.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:_.showMarkSectionHeaders,description:s.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:_.sectionHeaderFontSize,description:s.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:_.sectionHeaderLetterSpacing,description:s.localize(81,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{enabled:m(ye.enabled,this.defaultValue.enabled),autohide:m(ye.autohide,this.defaultValue.autohide),size:h(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(ye.side,this.defaultValue.side,["right","left"]),showSlider:h(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:m(ye.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(ye.scale,1,1,3),maxColumn:t.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:m(ye.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:m(ye.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(ye.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(ye.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function Z(Y){return Y==="ctrlCmd"?S.$d?"metaKey":"ctrlKey":"altKey"}class j extends a{constructor(){super(be.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:s.localize(83,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{top:t.clampedInt(ye.top,0,0,1e3),bottom:t.clampedInt(ye.bottom,0,0,1e3)}}}class G extends a{constructor(){const _={enabled:!0,cycle:!0};super(be.parameterHints,"parameterHints",_,{"editor.parameterHints.enabled":{type:"boolean",default:_.enabled,description:s.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:_.cycle,description:s.localize(85,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{enabled:m(ye.enabled,this.defaultValue.enabled),cycle:m(ye.cycle,this.defaultValue.cycle)}}}class se extends g{constructor(){super(be.pixelRatio)}compute(_,ye,Me){return _.pixelRatio}}class fe extends a{constructor(){const _={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[s.localize(86,null),s.localize(87,null),s.localize(88,null)]}];super(be.quickSuggestions,"quickSuggestions",_,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:_.strings,description:s.localize(89,null)},comments:{anyOf:ye,default:_.comments,description:s.localize(90,null)},other:{anyOf:ye,default:_.other,description:s.localize(91,null)}},default:_,markdownDescription:s.localize(92,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=_}validate(_){if(typeof _=="boolean"){const gt=_?"on":"off";return{comments:gt,strings:gt,other:gt}}if(!_||typeof _!="object")return this.defaultValue;const{other:ye,comments:Me,strings:Ve}=_,Ye=["on","inline","off"];let _e,ot,ht;return typeof ye=="boolean"?_e=ye?"on":"off":_e=h(ye,this.defaultValue.other,Ye),typeof Me=="boolean"?ot=Me?"on":"off":ot=h(Me,this.defaultValue.comments,Ye),typeof Ve=="boolean"?ht=Ve?"on":"off":ht=h(Ve,this.defaultValue.strings,Ye),{other:_e,comments:ot,strings:ht}}}var Ee;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(Ee||(e.RenderLineNumbersType=Ee={}));class Le extends a{constructor(){super(be.lineNumbers,"lineNumbers",{renderType:Ee.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[s.localize(93,null),s.localize(94,null),s.localize(95,null),s.localize(96,null)],default:"on",description:s.localize(97,null)})}validate(_){let ye=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof _<"u"&&(typeof _=="function"?(ye=Ee.Custom,Me=_):_==="interval"?ye=Ee.Interval:_==="relative"?ye=Ee.Relative:_==="on"?ye=Ee.On:ye=Ee.Off),{renderType:ye,renderFn:Me}}}function de(Y){const _=Y.get(be.renderValidationDecorations);return _==="editable"?Y.get(be.readOnly):_!=="on"}class we extends a{constructor(){const _=[],ye={type:"number",description:s.localize(98,null)};super(be.rulers,"rulers",_,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:s.localize(99,null),format:"color-hex"}}}]},default:_,description:s.localize(100,null)})}validate(_){if(Array.isArray(_)){const ye=[];for(const Me of _)if(typeof Me=="number")ye.push({column:t.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const Ve=Me;ye.push({column:t.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return ye.sort((Me,Ve)=>Me.column-Ve.column),ye}return this.defaultValue}}class Re extends a{constructor(){super(be.readOnlyMessage,"readOnlyMessage",void 0)}validate(_){return!_||typeof _!="object"?this.defaultValue:_}}function Oe(Y,_){if(typeof Y!="string")return _;switch(Y){case"hidden":return k.ScrollbarVisibility.Hidden;case"visible":return k.ScrollbarVisibility.Visible;default:return k.ScrollbarVisibility.Auto}}class me extends a{constructor(){const _={vertical:k.ScrollbarVisibility.Auto,horizontal:k.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(be.scrollbar,"scrollbar",_,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(101,null),s.localize(102,null),s.localize(103,null)],default:"auto",description:s.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[s.localize(105,null),s.localize(106,null),s.localize(107,null)],default:"auto",description:s.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:_.verticalScrollbarSize,description:s.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:_.horizontalScrollbarSize,description:s.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:_.scrollByPage,description:s.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:_.ignoreHorizontalScrollbarInContentHeight,description:s.localize(112,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_,Me=t.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=t.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Oe(ye.vertical,this.defaultValue.vertical),horizontal:Oe(ye.horizontal,this.defaultValue.horizontal),useShadows:m(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:m(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:m(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:m(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:m(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:t.clampedInt(ye.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:t.clampedInt(ye.verticalSliderSize,Ve,0,1e3),scrollByPage:m(ye.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:m(ye.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Ie extends a{constructor(){const _={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(be.unicodeHighlighting,"unicodeHighlight",_,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.nonBasicASCII,description:s.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:_.invisibleCharacters,description:s.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:_.ambiguousCharacters,description:s.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeComments,description:s.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:_.includeStrings,description:s.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:_.allowedCharacters,description:s.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:_.allowedLocales,description:s.localize(119,null)}})}applyUpdate(_,ye){let Me=!1;ye.allowedCharacters&&_&&(r.$bo(_.allowedCharacters,ye.allowedCharacters)||(_={..._,allowedCharacters:ye.allowedCharacters},Me=!0)),ye.allowedLocales&&_&&(r.$bo(_.allowedLocales,ye.allowedLocales)||(_={..._,allowedLocales:ye.allowedLocales},Me=!0));const Ve=super.applyUpdate(_,ye);return Me?new f(Ve.newValue,!0):Ve}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{nonBasicASCII:We(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:m(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:m(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:We(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:We(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(_.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(_.allowedLocales,this.defaultValue.allowedLocales)}}c(_,ye){if(typeof _!="object"||!_)return ye;const Me={};for(const[Ve,Ye]of Object.entries(_))Ye===!0&&(Me[Ve]=!0);return Me}}class Ae extends a{constructor(){const _={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(be.inlineSuggest,"inlineSuggest",_,{"editor.inlineSuggest.enabled":{type:"boolean",default:_.enabled,description:s.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(121,null),s.localize(122,null),s.localize(123,null)],description:s.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:_.suppressSuggestions,description:s.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:_.fontFamily,description:s.localize(126,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{enabled:m(ye.enabled,this.defaultValue.enabled),mode:h(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:m(ye.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:m(ye.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string(ye.fontFamily,this.defaultValue.fontFamily)}}}class je extends a{constructor(){const _={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(be.inlineEdit,"experimentalInlineEdit",_,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:_.enabled,description:s.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:_.showToolbar,enum:["always","onHover","never"],enumDescriptions:[s.localize(128,null),s.localize(129,null),s.localize(130,null)],description:s.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:_.fontFamily,description:s.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:_.backgroundColoring,description:s.localize(133,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{enabled:m(ye.enabled,this.defaultValue.enabled),showToolbar:h(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string(ye.fontFamily,this.defaultValue.fontFamily),keepOnBlur:m(ye.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:m(ye.backgroundColoring,this.defaultValue.backgroundColoring)}}}class Be extends a{constructor(){const _={enabled:A.$ou.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.$ou.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(be.bracketPairColorization,"bracketPairColorization",_,{"editor.bracketPairColorization.enabled":{type:"boolean",default:_.enabled,markdownDescription:s.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:_.independentColorPoolPerBracketType,description:s.localize(135,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{enabled:m(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:m(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Je extends a{constructor(){const _={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(be.guides,"guides",_,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(136,null),s.localize(137,null),s.localize(138,null)],default:_.bracketPairs,description:s.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[s.localize(140,null),s.localize(141,null),s.localize(142,null)],default:_.bracketPairsHorizontal,description:s.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:_.highlightActiveBracketPair,description:s.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:_.indentation,description:s.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[s.localize(146,null),s.localize(147,null),s.localize(148,null)],default:_.highlightActiveIndentation,description:s.localize(149,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{bracketPairs:We(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:We(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:m(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:m(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:We(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function We(Y,_,ye){const Me=ye.indexOf(Y);return Me===-1?_:ye[Me]}class Qe extends a{constructor(){const _={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(be.suggest,"suggest",_,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[s.localize(150,null),s.localize(151,null)],default:_.insertMode,description:s.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:_.filterGraceful,description:s.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:_.localityBonus,description:s.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:_.shareSuggestSelections,markdownDescription:s.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[s.localize(156,null),s.localize(157,null),s.localize(158,null),s.localize(159,null)],default:_.selectionMode,markdownDescription:s.localize(160,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:_.snippetsPreventQuickSuggestions,description:s.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:_.showIcons,description:s.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:_.showStatusBar,description:s.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:_.preview,description:s.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:_.showInlineDetails,description:s.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:s.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:s.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:s.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:s.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:s.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:s.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:s.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:s.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:s.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:s.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:s.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:s.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:s.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:s.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:s.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:s.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:s.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:s.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:s.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:s.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:s.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:s.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:s.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:s.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:s.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:s.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:s.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:s.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:s.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:s.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:s.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:s.localize(197,null)}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{insertMode:h(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:m(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:m(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:m(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:m(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(ye.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:m(ye.showIcons,this.defaultValue.showIcons),showStatusBar:m(ye.showStatusBar,this.defaultValue.showStatusBar),preview:m(ye.preview,this.defaultValue.preview),previewMode:h(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:m(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:m(ye.showMethods,this.defaultValue.showMethods),showFunctions:m(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:m(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:m(ye.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:m(ye.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:m(ye.showFields,this.defaultValue.showFields),showVariables:m(ye.showVariables,this.defaultValue.showVariables),showClasses:m(ye.showClasses,this.defaultValue.showClasses),showStructs:m(ye.showStructs,this.defaultValue.showStructs),showInterfaces:m(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:m(ye.showModules,this.defaultValue.showModules),showProperties:m(ye.showProperties,this.defaultValue.showProperties),showEvents:m(ye.showEvents,this.defaultValue.showEvents),showOperators:m(ye.showOperators,this.defaultValue.showOperators),showUnits:m(ye.showUnits,this.defaultValue.showUnits),showValues:m(ye.showValues,this.defaultValue.showValues),showConstants:m(ye.showConstants,this.defaultValue.showConstants),showEnums:m(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:m(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:m(ye.showKeywords,this.defaultValue.showKeywords),showWords:m(ye.showWords,this.defaultValue.showWords),showColors:m(ye.showColors,this.defaultValue.showColors),showFiles:m(ye.showFiles,this.defaultValue.showFiles),showReferences:m(ye.showReferences,this.defaultValue.showReferences),showFolders:m(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:m(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:m(ye.showSnippets,this.defaultValue.showSnippets),showUsers:m(ye.showUsers,this.defaultValue.showUsers),showIssues:m(ye.showIssues,this.defaultValue.showIssues)}}}class He extends a{constructor(){super(be.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:s.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:s.localize(199,null),default:!0,type:"boolean"}})}validate(_){return!_||typeof _!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:m(_.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:m(_.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends a{constructor(){const _=[];super(be.wordSegmenterLocales,"wordSegmenterLocales",_,{anyOf:[{description:s.localize(200,null),type:"string"},{description:s.localize(201,null),type:"array",items:{type:"string"}}]})}validate(_){if(typeof _=="string"&&(_=[_]),Array.isArray(_)){const ye=[];for(const Me of _)if(typeof Me=="string")try{Intl.Segmenter.supportedLocalesOf(Me).length>0&&ye.push(Me)}catch{}return ye}return this.defaultValue}}var et;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends a{constructor(){super(be.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[s.localize(202,null),s.localize(203,null),s.localize(204,null),s.localize(205,null)],description:s.localize(206,null),default:"same"}})}validate(_){switch(_){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(_,ye,Me){return ye.get(be.accessibilitySupport)===E.AccessibilitySupport.Enabled?et.None:Me}}class lt extends g{constructor(){super(be.wrappingInfo)}compute(_,ye,Me){const Ve=ye.get(be.layoutInfo);return{isDominatedByLongLines:_.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}class tt extends a{constructor(){const _={enabled:!0,showDropSelector:"afterDrop"};super(be.dropIntoEditor,"dropIntoEditor",_,{"editor.dropIntoEditor.enabled":{type:"boolean",default:_.enabled,markdownDescription:s.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:s.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[s.localize(209,null),s.localize(210,null)],default:"afterDrop"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{enabled:m(ye.enabled,this.defaultValue.enabled),showDropSelector:h(ye.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Xe extends a{constructor(){const _={enabled:!0,showPasteSelector:"afterPaste"};super(be.pasteAs,"pasteAs",_,{"editor.pasteAs.enabled":{type:"boolean",default:_.enabled,markdownDescription:s.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:s.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[s.localize(213,null),s.localize(214,null)],default:"afterPaste"}})}validate(_){if(!_||typeof _!="object")return this.defaultValue;const ye=_;return{enabled:m(ye.enabled,this.defaultValue.enabled),showPasteSelector:h(ye.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Ge="Consolas, 'Courier New', monospace",xe="Menlo, Monaco, 'Courier New', monospace",ve="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:S.$d?xe:S.$e?ve:Ge,fontWeight:"normal",fontSize:S.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ge(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var be;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.inlineEdit=63]="inlineEdit",Y[Y.letterSpacing=64]="letterSpacing",Y[Y.lightbulb=65]="lightbulb",Y[Y.lineDecorationsWidth=66]="lineDecorationsWidth",Y[Y.lineHeight=67]="lineHeight",Y[Y.lineNumbers=68]="lineNumbers",Y[Y.lineNumbersMinChars=69]="lineNumbersMinChars",Y[Y.linkedEditing=70]="linkedEditing",Y[Y.links=71]="links",Y[Y.matchBrackets=72]="matchBrackets",Y[Y.minimap=73]="minimap",Y[Y.mouseStyle=74]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=76]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=78]="multiCursorModifier",Y[Y.multiCursorPaste=79]="multiCursorPaste",Y[Y.multiCursorLimit=80]="multiCursorLimit",Y[Y.occurrencesHighlight=81]="occurrencesHighlight",Y[Y.overviewRulerBorder=82]="overviewRulerBorder",Y[Y.overviewRulerLanes=83]="overviewRulerLanes",Y[Y.padding=84]="padding",Y[Y.pasteAs=85]="pasteAs",Y[Y.parameterHints=86]="parameterHints",Y[Y.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=89]="quickSuggestions",Y[Y.quickSuggestionsDelay=90]="quickSuggestionsDelay",Y[Y.readOnly=91]="readOnly",Y[Y.readOnlyMessage=92]="readOnlyMessage",Y[Y.renameOnType=93]="renameOnType",Y[Y.renderControlCharacters=94]="renderControlCharacters",Y[Y.renderFinalNewline=95]="renderFinalNewline",Y[Y.renderLineHighlight=96]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=98]="renderValidationDecorations",Y[Y.renderWhitespace=99]="renderWhitespace",Y[Y.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Y[Y.roundedSelection=101]="roundedSelection",Y[Y.rulers=102]="rulers",Y[Y.scrollbar=103]="scrollbar",Y[Y.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=105]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=106]="scrollPredominantAxis",Y[Y.selectionClipboard=107]="selectionClipboard",Y[Y.selectionHighlight=108]="selectionHighlight",Y[Y.selectOnLineNumbers=109]="selectOnLineNumbers",Y[Y.showFoldingControls=110]="showFoldingControls",Y[Y.showUnused=111]="showUnused",Y[Y.snippetSuggestions=112]="snippetSuggestions",Y[Y.smartSelect=113]="smartSelect",Y[Y.smoothScrolling=114]="smoothScrolling",Y[Y.stickyScroll=115]="stickyScroll",Y[Y.stickyTabStops=116]="stickyTabStops",Y[Y.stopRenderingLineAfter=117]="stopRenderingLineAfter",Y[Y.suggest=118]="suggest",Y[Y.suggestFontSize=119]="suggestFontSize",Y[Y.suggestLineHeight=120]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Y[Y.suggestSelection=122]="suggestSelection",Y[Y.tabCompletion=123]="tabCompletion",Y[Y.tabIndex=124]="tabIndex",Y[Y.unicodeHighlighting=125]="unicodeHighlighting",Y[Y.unusualLineTerminators=126]="unusualLineTerminators",Y[Y.useShadowDOM=127]="useShadowDOM",Y[Y.useTabStops=128]="useTabStops",Y[Y.wordBreak=129]="wordBreak",Y[Y.wordSegmenterLocales=130]="wordSegmenterLocales",Y[Y.wordSeparators=131]="wordSeparators",Y[Y.wordWrap=132]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=135]="wordWrapColumn",Y[Y.wordWrapOverride1=136]="wordWrapOverride1",Y[Y.wordWrapOverride2=137]="wordWrapOverride2",Y[Y.wrappingIndent=138]="wrappingIndent",Y[Y.wrappingStrategy=139]="wrappingStrategy",Y[Y.showDeprecated=140]="showDeprecated",Y[Y.inlayHints=141]="inlayHints",Y[Y.editorClassName=142]="editorClassName",Y[Y.pixelRatio=143]="pixelRatio",Y[Y.tabFocusMode=144]="tabFocusMode",Y[Y.layoutInfo=145]="layoutInfo",Y[Y.wrappingInfo=146]="wrappingInfo",Y[Y.defaultColorDecorators=147]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(be||(e.EditorOption=be={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ge(new b(be.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:s.localize(215,null)})),acceptSuggestionOnEnter:ge(new u(be.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",s.localize(216,null),""],markdownDescription:s.localize(217,null)})),accessibilitySupport:ge(new T),accessibilityPageSize:ge(new t(be.accessibilityPageSize,"accessibilityPageSize",10,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(218,null),tags:["accessibility"]})),ariaLabel:ge(new i(be.ariaLabel,"ariaLabel",s.localize(219,null))),ariaRequired:ge(new b(be.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ge(new b(be.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:s.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:ge(new u(be.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(221,null),s.localize(222,null),""],description:s.localize(223,null)})),autoClosingComments:ge(new u(be.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(224,null),s.localize(225,null),""],description:s.localize(226,null)})),autoClosingDelete:ge(new u(be.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",s.localize(227,null),""],description:s.localize(228,null)})),autoClosingOvertype:ge(new u(be.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",s.localize(229,null),""],description:s.localize(230,null)})),autoClosingQuotes:ge(new u(be.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",s.localize(231,null),s.localize(232,null),""],description:s.localize(233,null)})),autoIndent:ge(new D(be.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],I,{enumDescriptions:[s.localize(234,null),s.localize(235,null),s.localize(236,null),s.localize(237,null),s.localize(238,null)],description:s.localize(239,null)})),automaticLayout:ge(new b(be.automaticLayout,"automaticLayout",!1)),autoSurround:ge(new u(be.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[s.localize(240,null),s.localize(241,null),s.localize(242,null),""],description:s.localize(243,null)})),bracketPairColorization:ge(new Be),bracketPairGuides:ge(new Je),stickyTabStops:ge(new b(be.stickyTabStops,"stickyTabStops",!1,{description:s.localize(244,null)})),codeLens:ge(new b(be.codeLens,"codeLens",!0,{description:s.localize(245,null)})),codeLensFontFamily:ge(new i(be.codeLensFontFamily,"codeLensFontFamily","",{description:s.localize(246,null)})),codeLensFontSize:ge(new t(be.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:s.localize(247,null)})),colorDecorators:ge(new b(be.colorDecorators,"colorDecorators",!0,{description:s.localize(248,null)})),colorDecoratorActivatedOn:ge(new u(be.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[s.localize(249,null),s.localize(250,null),s.localize(251,null)],description:s.localize(252,null)})),colorDecoratorsLimit:ge(new t(be.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:s.localize(253,null)})),columnSelection:ge(new b(be.columnSelection,"columnSelection",!1,{description:s.localize(254,null)})),comments:ge(new O),contextmenu:ge(new b(be.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:ge(new b(be.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:s.localize(255,null)})),cursorBlinking:ge(new D(be.cursorBlinking,"cursorBlinking",C.Blink,"blink",["blink","smooth","phase","expand","solid"],P,{description:s.localize(256,null)})),cursorSmoothCaretAnimation:ge(new u(be.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[s.localize(257,null),s.localize(258,null),s.localize(259,null)],description:s.localize(260,null)})),cursorStyle:ge(new D(be.cursorStyle,"cursorStyle",Q.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],ie,{description:s.localize(261,null)})),cursorSurroundingLines:ge(new t(be.cursorSurroundingLines,"cursorSurroundingLines",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(262,null)})),cursorSurroundingLinesStyle:ge(new u(be.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[s.localize(263,null),s.localize(264,null)],markdownDescription:s.localize(265,null)})),cursorWidth:ge(new t(be.cursorWidth,"cursorWidth",0,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(266,null)})),disableLayerHinting:ge(new b(be.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:ge(new b(be.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:ge(new b(be.domReadOnly,"domReadOnly",!1)),dragAndDrop:ge(new b(be.dragAndDrop,"dragAndDrop",!0,{description:s.localize(267,null)})),emptySelectionClipboard:ge(new x),dropIntoEditor:ge(new tt),stickyScroll:ge(new L),experimentalWhitespaceRendering:ge(new u(be.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[s.localize(268,null),s.localize(269,null),s.localize(270,null)],description:s.localize(271,null)})),extraEditorClassName:ge(new i(be.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:ge(new d(be.fastScrollSensitivity,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:s.localize(272,null)})),find:ge(new re),fixedOverflowWidgets:ge(new b(be.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:ge(new b(be.folding,"folding",!0,{description:s.localize(273,null)})),foldingStrategy:ge(new u(be.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[s.localize(274,null),s.localize(275,null)],description:s.localize(276,null)})),foldingHighlight:ge(new b(be.foldingHighlight,"foldingHighlight",!0,{description:s.localize(277,null)})),foldingImportsByDefault:ge(new b(be.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:s.localize(278,null)})),foldingMaximumRegions:ge(new t(be.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:s.localize(279,null)})),unfoldOnClickAfterEndOfLine:ge(new b(be.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:s.localize(280,null)})),fontFamily:ge(new i(be.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:s.localize(281,null)})),fontInfo:ge(new le),fontLigatures2:ge(new q),fontSize:ge(new M),fontWeight:ge(new z),fontVariations:ge(new te),formatOnPaste:ge(new b(be.formatOnPaste,"formatOnPaste",!1,{description:s.localize(282,null)})),formatOnType:ge(new b(be.formatOnType,"formatOnType",!1,{description:s.localize(283,null)})),glyphMargin:ge(new b(be.glyphMargin,"glyphMargin",!0,{description:s.localize(284,null)})),gotoLocation:ge(new oe),hideCursorInOverviewRuler:ge(new b(be.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:s.localize(285,null)})),hover:ge(new ce),inDiffEditor:ge(new b(be.inDiffEditor,"inDiffEditor",!1)),letterSpacing:ge(new d(be.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>d.clamp(Y,-5,20),{description:s.localize(286,null)})),lightbulb:ge(new H),lineDecorationsWidth:ge(new B),lineHeight:ge(new U),lineNumbers:ge(new Le),lineNumbersMinChars:ge(new t(be.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:ge(new b(be.linkedEditing,"linkedEditing",!1,{description:s.localize(287,null)})),links:ge(new b(be.links,"links",!0,{description:s.localize(288,null)})),matchBrackets:ge(new u(be.matchBrackets,"matchBrackets","always",["always","near","never"],{description:s.localize(289,null)})),minimap:ge(new K),mouseStyle:ge(new u(be.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ge(new d(be.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:s.localize(290,null)})),mouseWheelZoom:ge(new b(be.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:S.$d?s.localize(291,null):s.localize(292,null)})),multiCursorMergeOverlapping:ge(new b(be.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:s.localize(293,null)})),multiCursorModifier:ge(new D(be.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Z,{markdownEnumDescriptions:[s.localize(294,null),s.localize(295,null)],markdownDescription:s.localize(296,null)})),multiCursorPaste:ge(new u(be.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[s.localize(297,null),s.localize(298,null)],markdownDescription:s.localize(299,null)})),multiCursorLimit:ge(new t(be.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:s.localize(300,null)})),occurrencesHighlight:ge(new u(be.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[s.localize(301,null),s.localize(302,null),s.localize(303,null)],markdownDescription:s.localize(304,null)})),overviewRulerBorder:ge(new b(be.overviewRulerBorder,"overviewRulerBorder",!0,{description:s.localize(305,null)})),overviewRulerLanes:ge(new t(be.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:ge(new j),pasteAs:ge(new Xe),parameterHints:ge(new G),peekWidgetDefaultFocus:ge(new u(be.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[s.localize(306,null),s.localize(307,null)],description:s.localize(308,null)})),definitionLinkOpensInPeek:ge(new b(be.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:s.localize(309,null)})),quickSuggestions:ge(new fe),quickSuggestionsDelay:ge(new t(be.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(310,null)})),readOnly:ge(new b(be.readOnly,"readOnly",!1)),readOnlyMessage:ge(new Re),renameOnType:ge(new b(be.renameOnType,"renameOnType",!1,{description:s.localize(311,null),markdownDeprecationMessage:s.localize(312,null)})),renderControlCharacters:ge(new b(be.renderControlCharacters,"renderControlCharacters",!0,{description:s.localize(313,null),restricted:!0})),renderFinalNewline:ge(new u(be.renderFinalNewline,"renderFinalNewline",S.$e?"dimmed":"on",["off","on","dimmed"],{description:s.localize(314,null)})),renderLineHighlight:ge(new u(be.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",s.localize(315,null)],description:s.localize(316,null)})),renderLineHighlightOnlyWhenFocus:ge(new b(be.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:s.localize(317,null)})),renderValidationDecorations:ge(new u(be.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ge(new u(be.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",s.localize(318,null),s.localize(319,null),s.localize(320,null),""],description:s.localize(321,null)})),revealHorizontalRightPadding:ge(new t(be.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ge(new b(be.roundedSelection,"roundedSelection",!0,{description:s.localize(322,null)})),rulers:ge(new we),scrollbar:ge(new me),scrollBeyondLastColumn:ge(new t(be.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,R.Constants.MAX_SAFE_SMALL_INTEGER,{description:s.localize(323,null)})),scrollBeyondLastLine:ge(new b(be.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:s.localize(324,null)})),scrollPredominantAxis:ge(new b(be.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:s.localize(325,null)})),selectionClipboard:ge(new b(be.selectionClipboard,"selectionClipboard",!0,{description:s.localize(326,null),included:S.$e})),selectionHighlight:ge(new b(be.selectionHighlight,"selectionHighlight",!0,{description:s.localize(327,null)})),selectOnLineNumbers:ge(new b(be.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:ge(new u(be.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[s.localize(328,null),s.localize(329,null),s.localize(330,null)],description:s.localize(331,null)})),showUnused:ge(new b(be.showUnused,"showUnused",!0,{description:s.localize(332,null)})),showDeprecated:ge(new b(be.showDeprecated,"showDeprecated",!0,{description:s.localize(333,null)})),inlayHints:ge(new V),snippetSuggestions:ge(new u(be.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[s.localize(334,null),s.localize(335,null),s.localize(336,null),s.localize(337,null)],description:s.localize(338,null)})),smartSelect:ge(new He),smoothScrolling:ge(new b(be.smoothScrolling,"smoothScrolling",!1,{description:s.localize(339,null)})),stopRenderingLineAfter:ge(new t(be.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:ge(new Qe),inlineSuggest:ge(new Ae),inlineEdit:ge(new je),inlineCompletionsAccessibilityVerbose:ge(new b(be.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:s.localize(340,null)})),suggestFontSize:ge(new t(be.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:s.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ge(new t(be.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:s.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ge(new b(be.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:s.localize(343,null)})),suggestSelection:ge(new u(be.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[s.localize(344,null),s.localize(345,null),s.localize(346,null)],description:s.localize(347,null)})),tabCompletion:ge(new u(be.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[s.localize(348,null),s.localize(349,null),s.localize(350,null)],description:s.localize(351,null)})),tabIndex:ge(new t(be.tabIndex,"tabIndex",0,-1,R.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:ge(new Ie),unusualLineTerminators:ge(new u(be.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[s.localize(352,null),s.localize(353,null),s.localize(354,null)],description:s.localize(355,null)})),useShadowDOM:ge(new b(be.useShadowDOM,"useShadowDOM",!0)),useTabStops:ge(new b(be.useTabStops,"useTabStops",!0,{description:s.localize(356,null)})),wordBreak:ge(new u(be.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[s.localize(357,null),s.localize(358,null)],description:s.localize(359,null)})),wordSegmenterLocales:ge(new nt),wordSeparators:ge(new i(be.wordSeparators,"wordSeparators",v.$st,{description:s.localize(360,null)})),wordWrap:ge(new u(be.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[s.localize(361,null),s.localize(362,null),s.localize(363,null),s.localize(364,null)],description:s.localize(365,null)})),wordWrapBreakAfterCharacters:ge(new i(be.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ge(new i(be.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ge(new t(be.wordWrapColumn,"wordWrapColumn",80,1,R.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:s.localize(366,null)})),wordWrapOverride1:ge(new u(be.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ge(new u(be.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ge(new ne),defaultColorDecorators:ge(new b(be.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:s.localize(367,null)})),pixelRatio:ge(new se),tabFocusMode:ge(new b(be.tabFocusMode,"tabFocusMode",!1,{markdownDescription:s.localize(368,null)})),layoutInfo:ge(new W),wrappingInfo:ge(new lt),wrappingIndent:ge(new rt),wrappingStrategy:ge(new ae)}}),define(Se[248],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$jn=e.ID=void 0,e.$kn=r,e.ID="diagnosticsService",e.$jn=(0,n.$Ai)(e.ID);function r(k){return!!k.hostName&&!!k.errorMessage}class S{async getPerformanceInfo(R,A){return{}}async getSystemInfo(R,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,A){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.$ln=S}),define(Se[88],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=void 0,e.$So=(0,n.$Ai)("downloadService")}),define(Se[28],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,n.$Ai)("environmentService"),e.$Ii=(0,n.$Bi)(e.$Hi)}),define(Se[16],De([1,0,69,9,17,11,4,214,5,3,13,65]),function(he,e,n,r,S,k,R,A,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=$,e.$9k=c,e.$0k=p,e.$$k=m,e.$_k=b,e.$al=l,e.$bl=t,e.$cl=o,e.$dl=d,e.$el=i,e.$fl=h,e.$hl=I,e.$il=T,e.$jl=O,e.$kl=C,e.$ll=P,e.$ol=x,e.$Al=z,e.$Bl=oe,e.$Dl=pe,e.$7k=(0,v.$Ai)("fileService");function $(W){return W.create===!0}var w;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var a;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var f;(function(W){W[W.UPDATED=2]="UPDATED",W[W.ADDED=4]="ADDED",W[W.DELETED=8]="DELETED"})(f||(e.FileChangeFilter=f={}));function c(W){const ae=W;return!!ae&&typeof ae.onDidChange=="function"}var g;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function p(W){return!!(W.capabilities&g.FileReadWrite)}function m(W){return!!(W.capabilities&g.FileFolderCopy)}function b(W){return!!(W.capabilities&g.FileClone)}function l(W){return!!(W.capabilities&g.FileOpenReadWriteClose)}function t(W){return!!(W.capabilities&g.FileReadStream)}function o(W){return p(W)?!!(W.capabilities&g.FileAtomicRead):!1}function d(W){return p(W)?!!(W.capabilities&g.FileAtomicWrite):!1}function i(W){return!!(W.capabilities&g.FileAtomicDelete)}function h(W){return!!(W.capabilities&g.Readonly)}var u;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class D extends Error{static create(ae,ee){const H=new D(ae.toString(),ee);return O(H,ee),H}constructor(ae,ee){super(ae),this.code=ee}}e.$gl=D;function I(W,ae){return D.create(W,ae)}function T(W){return W||I((0,A.localize)(0,null),u.Unknown)}function O(W,ae){return W.name=ae?`${ae} (FileSystemError)`:"FileSystemError",W}function C(W){if(!W)return u.Unknown;if(W instanceof D)return W.code;const ae=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ae)return u.Unknown;switch(ae[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function P(W){if(W instanceof re)return W.fileOperationResult;switch(C(W)){case u.FileNotFound:return le.FILE_NOT_FOUND;case u.FileIsADirectory:return le.FILE_IS_DIRECTORY;case u.FileNotADirectory:return le.FILE_NOT_DIRECTORY;case u.FileWriteLocked:return le.FILE_WRITE_LOCKED;case u.NoPermissions:return le.FILE_PERMISSION_DENIED;case u.FileExists:return le.FILE_MOVE_CONFLICT;case u.FileTooLarge:return le.FILE_TOO_LARGE;default:return le.FILE_OTHER_ERROR}}var Q;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(Q||(e.FileOperation=Q={}));class X{constructor(ae,ee,H){this.resource=ae,this.operation=ee,this.target=H}isOperation(ae){return this.operation===ae}}e.$ml=X;var ie;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(ie||(e.FileChangeType=ie={}));class ne{constructor(ae,ee){this.c=ee,this.b=void 0,this.d=new y.$V(()=>{const H=n.$Gi.forUris(()=>this.c);return H.fill(this.rawAdded.map(L=>[L,!0])),H}),this.f=new y.$V(()=>{const H=n.$Gi.forUris(()=>this.c);return H.fill(this.rawUpdated.map(L=>[L,!0])),H}),this.g=new y.$V(()=>{const H=n.$Gi.forUris(()=>this.c);return H.fill(this.rawDeleted.map(L=>[L,!0])),H}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const H of ae){switch(H.type){case ie.ADDED:this.rawAdded.push(H.resource);break;case ie.UPDATED:this.rawUpdated.push(H.resource);break;case ie.DELETED:this.rawDeleted.push(H.resource);break}this.b!==ne.a&&(typeof H.cId=="number"?this.b===void 0?this.b=H.cId:this.b!==H.cId&&(this.b=ne.a):this.b!==void 0&&(this.b=ne.a))}}contains(ae,...ee){return this.h(ae,{includeChildren:!1},...ee)}affects(ae,...ee){return this.h(ae,{includeChildren:!0},...ee)}h(ae,ee,...H){if(!ae)return!1;const L=H.length>0;return!!((!L||H.includes(ie.ADDED))&&(this.d.value.get(ae)||ee.includeChildren&&this.d.value.findSuperstr(ae))||(!L||H.includes(ie.UPDATED))&&(this.f.value.get(ae)||ee.includeChildren&&this.f.value.findSuperstr(ae))||(!L||H.includes(ie.DELETED))&&(this.g.value.findSubstr(ae)||ee.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$nl=ne,ne.a=null;function x(W,ae,ee){return!W||!ae||W===ae||ae.length>W.length?!1:(ae.charAt(ae.length-1)!==r.sep&&(ae+=r.sep),ee?(0,S.$Cf)(W,ae):W.indexOf(ae)===0)}class re extends Error{constructor(ae,ee,H){super(ae),this.fileOperationResult=ee,this.options=H}}e.$pl=re;class q extends re{constructor(ae,ee,H,L){super(ae,ee,L),this.fileOperationResult=ee,this.size=H}}e.$ql=q;class te extends re{constructor(ae,ee,H){super(ae,le.FILE_NOT_MODIFIED_SINCE,H),this.stat=ee}}e.$rl=te;var le;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(le||(e.FileOperationResult=le={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var M;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(M||(e.FileKind=M={})),e.$zl="";function z(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}async function oe(W,ae){if(!ae.hasProvider(R.URI.from({scheme:W.scheme})))return new Promise(ee=>{const H=ae.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===W.scheme&&L.added&&(H.dispose(),ee())})})}class ce{static formatSize(ae){return(0,k.$eg)(ae)||(ae=0),ae<ce.KB?(0,A.localize)(1,null,ae.toFixed(0)):ae<ce.MB?(0,A.localize)(2,null,(ae/ce.KB).toFixed(2)):ae<ce.GB?(0,A.localize)(3,null,(ae/ce.MB).toFixed(2)):ae<ce.TB?(0,A.localize)(4,null,(ae/ce.GB).toFixed(2)):(0,A.localize)(5,null,(ae/ce.TB).toFixed(2))}}e.$Cl=ce,ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB;function pe(W){const ae=typeof W=="string"||W?.scheme===E.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===E.Schemas.file?1024*ce.MB:ae?10*ce.MB:s.$i?50*ce.MB:1024*ce.MB}}),define(Se[121],De([1,0,15,10,215,16]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=R;async function R(E,y,$,w,a,f){let c;try{await A(E,y,$,w,a,f)}catch(g){c=g}finally{c&&a.errorTransformer&&(c=a.errorTransformer(c)),typeof c<"u"&&$.error(c),$.end()}}async function A(E,y,$,w,a,f){v(f);const c=await E.open(y,{create:!1});try{v(f);let g=0,p=0,m=a&&typeof a.length=="number"?a.length:void 0,b=n.$Je.alloc(Math.min(a.bufferSize,typeof m=="number"?m:a.bufferSize)),l=a&&typeof a.position=="number"?a.position:0,t=0;do p=await E.read(c,l,b.buffer,t,b.byteLength-t),l+=p,t+=p,g+=p,typeof m=="number"&&(m-=p),t===b.byteLength&&(await $.write(w(b)),b=n.$Je.alloc(Math.min(a.bufferSize,typeof m=="number"?m:a.bufferSize)),t=0);while(p>0&&(typeof m!="number"||m>0)&&v(f)&&s(g,a));if(t>0){let o=t;typeof m=="number"&&(o=Math.min(t,m)),$.write(w(b.slice(0,o)))}}catch(g){throw(0,k.$il)(g)}finally{await E.close(c)}}function v(E){if(E.isCancellationRequested)throw(0,r.$6)();return!0}function s(E,y){if(typeof y?.limits?.size=="number"&&E>y.limits.size)throw(0,k.$hl)((0,S.localize)(0,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Se[51],De([1,0,82,2,9,3,4,16]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=void 0,e.$Sq=v,e.$Tq=s,e.$Xq=w,e.$Yq=a,e.$Zq=f,e.$1q=c,e.$2q=p,e.$3q=m;function v(b){return typeof b.correlationId=="number"}function s(b){return b.recursive===!0}class E extends r.$Uc{constructor(l,t,o,d){super(),this.m=l,this.n=t,this.r=o,this.s=d,this.f=this.B(new r.$Vc),this.g=void 0,this.h=new Map,this.j=0}u(){const l=new r.$Tc;this.f.value=l,this.c=this.t(l),this.c.setVerboseLogging(this.r),l.add(this.c.onDidChangeFile(t=>this.m(t))),l.add(this.c.onDidLogMessage(t=>this.n(t))),l.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(l,t){if(this.s.restartOnError&&this.g?.length)if(t){const o=this.h.get(t.path)??0;o<E.a?(this.z(`restarting watcher from error in watch request (retrying request): ${l} (${JSON.stringify(t)})`),this.h.set(t.path,o+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${l} (${JSON.stringify(t)})`),this.y(this.g.filter(d=>d.path!==t.path)))}else this.j<E.b?(this.z(`restarting watcher after unknown global error: ${l}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${l}`);else this.z(l)}y(l){this.u(),this.watch(l)}async watch(l){this.g=l,await this.c?.watch(l)}async setVerboseLogging(l){this.r=l,await this.c?.setVerboseLogging(l)}z(l){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${l}`})}C(l){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${l}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Uq=E,E.a=3,E.b=10;class y extends E{constructor(l,t,o){super(l,t,o,{type:"node.js",restartOnError:!1})}}e.$Vq=y;class $ extends E{constructor(l,t,o){super(l,t,o,{type:"universal",restartOnError:!0})}}e.$Wq=$;function w(b){return b.map(l=>({type:l.type,resource:R.URI.revive(l.resource),cId:l.cId}))}function a(b){const l=new g;for(const t of b)l.processEvent(t);return l.coalesce()}function f(b,l){return typeof l=="string"&&!l.startsWith(n.$qk)&&!(0,S.$ic)(l)?{base:b,pattern:l}:l}function c(b,l){const t=[];for(const o of l)t.push((0,n.$uk)(f(b,o)));return t}class g{constructor(){this.a=new Set,this.b=new Map}c(l){return k.$e?l.resource.fsPath:l.resource.fsPath.toLowerCase()}processEvent(l){const t=this.b.get(this.c(l));let o=!1;if(t){const d=t.type,i=l.type;t.resource.fsPath!==l.resource.fsPath&&(l.type===A.FileChangeType.DELETED||l.type===A.FileChangeType.ADDED)?o=!0:d===A.FileChangeType.ADDED&&i===A.FileChangeType.DELETED?(this.b.delete(this.c(l)),this.a.delete(t)):d===A.FileChangeType.DELETED&&i===A.FileChangeType.ADDED?t.type=A.FileChangeType.UPDATED:d===A.FileChangeType.ADDED&&i===A.FileChangeType.UPDATED||(t.type=i)}else o=!0;o&&(this.a.add(l),this.b.set(this.c(l),l))}coalesce(){const l=[],t=[];return Array.from(this.a).filter(o=>o.type!==A.FileChangeType.DELETED?(l.push(o),!1):!0).sort((o,d)=>o.resource.fsPath.length-d.resource.fsPath.length).filter(o=>t.some(d=>(0,A.$ol)(o.resource.fsPath,d,!k.$e))?!1:(t.push(o.resource.fsPath),!0)).concat(l)}}function p(b,l){if(typeof l=="number")switch(b.type){case A.FileChangeType.ADDED:return(l&A.FileChangeFilter.ADDED)===0;case A.FileChangeType.DELETED:return(l&A.FileChangeFilter.DELETED)===0;case A.FileChangeType.UPDATED:return(l&A.FileChangeFilter.UPDATED)===0}return!1}function m(b){if(typeof b=="number"){const l=[];return b&A.FileChangeFilter.ADDED&&l.push("Added"),b&A.FileChangeFilter.DELETED&&l.push("Deleted"),b&A.FileChangeFilter.UPDATED&&l.push("Updated"),l.length===0?"<all>":`[${l.join(", ")}]`}return"<none>"}}),define(Se[249],De([1,0,15,42,10,6,2,56,22,16,51]),function(he,e,n,r,S,k,R,A,v,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=e.$8P=void 0,e.$8P="localFilesystem";class y extends R.$Uc{constructor(w,a){super(),this.a=w,this.b=a,this.onDidChangeCapabilities=k.Event.None,this.f=this.B(new k.$he),this.onDidChangeFile=this.f.event,this.g=this.B(new k.$he),this.onDidWatchError=this.g.event,this.h=(0,v.$Wg)(),this.j()}get capabilities(){return this.c||(this.c=s.FileSystemProviderCapabilities.FileReadWrite|s.FileSystemProviderCapabilities.FileOpenReadWriteClose|s.FileSystemProviderCapabilities.FileReadStream|s.FileSystemProviderCapabilities.FileFolderCopy|s.FileSystemProviderCapabilities.FileWriteUnlock|s.FileSystemProviderCapabilities.FileAtomicRead|s.FileSystemProviderCapabilities.FileAtomicWrite|s.FileSystemProviderCapabilities.FileAtomicDelete|s.FileSystemProviderCapabilities.FileClone,this.b.pathCaseSensitive&&(this.c|=s.FileSystemProviderCapabilities.PathCaseSensitive),this.b.trash&&(this.c|=s.FileSystemProviderCapabilities.Trash)),this.c}stat(w){return this.a.call("stat",[w])}readdir(w){return this.a.call("readdir",[w])}async readFile(w,a){const{buffer:f}=await this.a.call("readFile",[w,a]);return f}readFileStream(w,a,f){const c=(0,A.$xe)(p=>n.$Je.concat(p.map(m=>n.$Je.wrap(m))).buffer),g=new R.$Tc;return g.add(this.a.listen("readFileStream",[w,a])(p=>{if(p instanceof n.$Je)c.write(p.buffer);else{if(p==="end")c.end();else{let m;if(p instanceof Error)m=p;else{const b=p;m=(0,s.$hl)(b.message??(0,r.$lj)(b),b.code??s.FileSystemProviderErrorCode.Unknown)}c.error(m),c.end()}g.dispose()}})),g.add(f.onCancellationRequested(()=>{c.error((0,S.$6)()),c.end(),g.dispose()})),c}writeFile(w,a,f){return this.a.call("writeFile",[w,n.$Je.wrap(a),f])}open(w,a){return this.a.call("open",[w,a])}close(w){return this.a.call("close",[w])}async read(w,a,f,c,g){const[p,m]=await this.a.call("read",[w,a,g]);return f.set(p.buffer.slice(0,m),c),m}write(w,a,f,c,g){return this.a.call("write",[w,a,n.$Je.wrap(f),c,g])}mkdir(w){return this.a.call("mkdir",[w])}delete(w,a){return this.a.call("delete",[w,a])}rename(w,a,f){return this.a.call("rename",[w,a,f])}copy(w,a,f){return this.a.call("copy",[w,a,f])}cloneFile(w,a){return this.a.call("cloneFile",[w,a])}j(){this.B(this.a.listen("fileChange",[this.h])(w=>{if(Array.isArray(w)){const a=w;this.f.fire((0,E.$Xq)(a))}else{const a=w;this.g.fire(a)}}))}watch(w,a){const f=(0,v.$Wg)();return this.a.call("watch",[this.h,f,w,a]),(0,R.$Sc)(()=>this.a.call("unwatch",[this.h,f]))}}e.$9P=y}),define(Se[250],De([1,0,31,2,51,6,16,4,14]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class s extends r.$Uc{constructor(){super(),this.a=this.B(new k.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new r.$4c),this.m=new Set,this.n=5007,this.r=new v.$Xh,this.P=!1,this.B(this.f(y=>this.s(y)))}s(y){this.t(y)&&this.w(y)}t(y){return(0,S.$Sq)(y)}async watch(y){this.r.isSettled||this.r.complete(),this.r=new v.$Xh;try{this.h.clear(),this.g.clear();for(const $ of y)this.t($)?this.h.set($.correlationId,$):this.g.add($);for(const[$]of this.j)this.h.has($)||(this.j.deleteAndDispose($),this.m.delete($));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(y=>!this.j.has(y.correlationId))])}isSuspended(y){return typeof y.correlationId!="number"?!1:this.m.has(y.correlationId)?"polling":this.j.has(y.correlationId)}async w(y){if(this.j.has(y.correlationId))return;const $=new r.$Tc;this.j.set(y.correlationId,$),await this.r.p,!$.isDisposed&&(this.z(y,$),this.u())}y(y){this.j.deleteAndDispose(y.correlationId),this.m.delete(y.correlationId),this.u()}z(y,$){this.C(y,$)?(this.N(`reusing an existing recursive watcher to monitor ${y.path}`),this.m.delete(y.correlationId)):(this.D(y,$),this.m.add(y.correlationId))}C(y,$){const w=this.M?.subscribe(y.path,(a,f)=>{$.isDisposed||(a?this.z(y,$):f?.type===R.FileChangeType.ADDED&&this.F(y))});return w?($.add(w),!0):!1}D(y,$){let w=!1;const a=(f,c)=>{if($.isDisposed)return;const g=this.G(f),p=this.G(c),m=w;w=g,!g&&(p||m)&&this.F(y)};this.N(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,n.watchFile)(y.path,{persistent:!1,interval:this.n},a)}catch(f){this.O(`fs.watchFile() failed with error ${f} on path ${y.path} (correlationId: ${y.correlationId})`)}$.add((0,r.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,n.unwatchFile)(y.path,a)}catch(f){this.O(`fs.unwatchFile() failed with error ${f} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}F(y){this.N(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const $={resource:A.URI.file(y.path),type:R.FileChangeType.ADDED,cId:y.correlationId};this.a.fire([$]),this.H($,y),this.y(y)}G(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(y,$){if(this.P){const w=` >> normalized ${y.type===R.FileChangeType.ADDED?"[ADDED]":y.type===R.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.I(w,$)}}I(y,$){this.P&&this.N(`${y}${typeof $.correlationId=="number"?` <${$.correlationId}> `:""}`)}J(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,S.$3q)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.P=y}}e.$_q=s}),define(Se[251],De([1,0,31,14,19,37,2,108,9,3,20,4,181,25,16,51]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0,e.$fr=g;class c extends R.$Uc{get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(m,b,l,t,o,d){super(),this.s=m,this.t=b,this.u=l,this.w=t,this.y=o,this.z=d,this.c=this.B(new r.$Ph({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.u(i))),this.f=this.B(new r.$Oh(i=>this.M(i),c.b)),this.g=(0,f.$1q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,f.$1q)(this.s.path,this.s.includes):void 0,this.j=(0,f.$Sq)(this.s)?this.s.filter:void 0,this.m=new S.$se,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const m=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const b=await w.Promises.stat(m);if(this.m.token.isCancellationRequested)return;this.B(await this.G(m,b.isDirectory()))}catch(m){m.code!=="ENOENT"?this.O(m):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${m})`),this.D()}}D(){this.r=!0,this.w?.()}async F(m){let b=m.path;try{b=await w.Promises.realpath(m.path),m.path===b&&(b=await(0,$.$br)(m.path,this.m.token)??m.path),m.path!==b&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${b})`)}catch{}return b}async G(m,b){const l=new R.$Tc;return this.H(m,b,l)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(m,b,l)),l}H(m,b,l){if(b)return!1;const t=y.URI.file(this.s.path),o=this.t?.subscribe(this.s.path,async(d,i)=>{if(!l.isDisposed)if(d){const h=await this.G(m,b);l.isDisposed?h.dispose():l.add(h)}else i&&(typeof i.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:i.type,cId:this.s.correlationId},!0)});return o?(l.add(o),!0):!1}async I(m,b,l){if(s.$d&&(0,k.$zg)(m,"/Volumes/",!0)){this.O(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new S.$se(this.m.token);l.add((0,R.$Sc)(()=>t.dispose(!0)));const o=new R.$Tc;l.add(o);try{const d=y.URI.file(this.s.path),i=(0,v.$nc)(m),h=(0,n.watch)(m);o.add((0,R.$Sc)(()=>{h.removeAllListeners(),h.close()})),this.Q(`Started watching: '${m}'`);const u=new Set;if(b)try{for(const I of await w.Promises.readdir(m))u.add(I)}catch(I){this.O(I)}if(t.token.isCancellationRequested)return;const D=new Map;o.add((0,R.$Sc)(()=>{for(const[,I]of D)I.dispose();D.clear()})),h.on("error",(I,T)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${m} for changes using fs.watch() (${I}, ${T})`),this.D())}),h.on("change",(I,T)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${I}"] ${T}`);let O="";if(T&&(O=T.toString(),s.$d&&(O=(0,A.$hm)(O))),!(!O||I!=="change"&&I!=="rename"))if(b)if(I==="rename"){D.get(O)?.dispose();const C=setTimeout(async()=>{if(D.delete(O),O===i&&!await w.Promises.exists(m)){this.J(d);return}if(t.token.isCancellationRequested)return;const P=await this.N((0,v.$jc)(m,O));if(t.token.isCancellationRequested)return;let Q;P?u.has(O)?Q=a.FileChangeType.UPDATED:(Q=a.FileChangeType.ADDED,u.add(O)):(u.delete(O),Q=a.FileChangeType.DELETED),this.L({resource:(0,E.$bh)(d,O),type:Q,cId:this.s.correlationId})},c.a);D.set(O,(0,R.$Sc)(()=>clearTimeout(C)))}else{let C;u.has(O)?C=a.FileChangeType.UPDATED:(C=a.FileChangeType.ADDED,u.add(O)),this.L({resource:(0,E.$bh)(d,O),type:C,cId:this.s.correlationId})}else if(I==="rename"||O!==i){const C=setTimeout(async()=>{const P=await w.Promises.exists(m);t.token.isCancellationRequested||(P?(this.L({resource:d,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0),o.add(await this.G(m,!1))):this.J(d))},c.a);o.clear(),o.add((0,R.$Sc)(()=>clearTimeout(C)))}else this.L({resource:d,type:a.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(d){t.token.isCancellationRequested||this.O(`Failed to watch ${m} for changes using fs.watch() (${d.toString()})`),this.D()}}J(m){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:m,type:a.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(m,b=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${m.type===a.FileChangeType.ADDED?"[ADDED]":m.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${m.resource.fsPath}`),!b&&this.g.some(l=>l(m.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${m.resource.fsPath}`):!b&&this.h&&this.h.length>0&&!this.h.some(l=>l(m.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${m.resource.fsPath}`):this.f.work(m))}M(m){const b=(0,f.$Yq)(m),l=[];for(const o of b){if((0,f.$2q)(o,this.j)){this.z&&this.R(` >> ignored (filtered) ${o.resource.fsPath}`);continue}l.push(o)}if(l.length===0)return;if(this.z)for(const o of l)this.R(` >> normalized ${o.type===a.FileChangeType.ADDED?"[ADDED]":o.type===a.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${o.resource.fsPath}`);this.c.work(l)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(m){if(s.$e)return w.Promises.exists(m);try{const b=(0,v.$nc)(m);return(await w.Promises.readdir((0,v.$mc)(m))).some(t=>t===b)}catch(b){return this.Q(b),!1}}setVerboseLogging(m){this.z=m}O(m){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}P(m){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}Q(m){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}R(m){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${m}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$er=c,c.a=100,c.b=75;async function g(p,m,b,l,t=512){const o=await w.Promises.open(p,"r"),d=Buffer.allocUnsafe(t),i=new S.$se(l);let h,u=!1;const D={path:p,excludes:[],recursive:!1},I=new c(D,void 0,T=>{(async()=>{for(const{type:O}of T)if(O===a.FileChangeType.UPDATED){if(u)return;u=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:C}=await w.Promises.read(o,d,0,t,null);if(!C||i.token.isCancellationRequested)break;m(d.slice(0,C))}}catch(C){h=new Error(C),i.dispose(!0)}finally{u=!1}}})()});return await I.ready,b(),new Promise((T,O)=>{i.token.onCancellationRequested(async()=>{I.dispose();try{await w.Promises.close(o)}catch(C){h=new Error(C)}h?O(h):T()})})}}),define(Se[252],De([1,0,6,82,250,3,251,37]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class v extends S.$_q{constructor(E){super(),this.M=E,this.onDidError=n.Event.None,this.watchers=new Set}async L(E){E=this.X(E);const y=[],$=new Set(Array.from(this.watchers));for(const w of E){const a=this.S(w);a&&(0,r.$yk)(a.request.excludes,w.excludes)&&(0,r.$yk)(a.request.includes,w.includes)?$.delete(a):y.push(w)}y.length&&this.N(`Request to start watching: ${y.map(w=>this.J(w)).join(",")}`),$.size&&this.N(`Request to stop watching: ${Array.from($).map(w=>this.J(w.request)).join(",")}`);for(const w of $)this.W(w);for(const w of y)this.U(w)}S(E){for(const y of this.watchers)if(typeof E.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===E.correlationId)return y}else if((0,A.$yg)(y.request.path,E.path,!k.$e))return y}U(E){const y=new R.$er(E,this.M,w=>this.a.fire(w),()=>this.c.fire(E),w=>this.b.fire(w),this.P),$={request:E,instance:y};this.watchers.add($)}async stop(){await super.stop();for(const E of this.watchers)this.W(E)}W(E){this.N("stopping file watcher",E),this.watchers.delete(E),E.instance.dispose()}X(E){const y=new Map;for(const $ of E){const w=k.$e?$.path:$.path.toLowerCase();let a=y.get($.correlationId);a||(a=new Map,y.set($.correlationId,a)),a.has(w)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J($)}`),a.set(w,$)}return Array.from(y.values()).map($=>Array.from($.values())).flat()}async setVerboseLogging(E){super.setVerboseLogging(E);for(const y of this.watchers)y.instance.setVerboseLogging(E)}N(E,y){this.P&&this.b.fire({type:"trace",message:this.$(E,y)})}O(E){this.b.fire({type:"warn",message:this.$(E)})}$(E,y){return y?`[File Watcher (node.js)] ${E} (${this.J(y.request)})`:`[File Watcher (node.js)] ${E}`}}e.$gr=v}),define(Se[253],De([1,0,51,252]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class S extends n.$Vq{constructor(R,A,v){super(R,A,v),this.u()}t(R){return R.add(new r.$gr(void 0))}}e.$hr=S}),define(Se[254],De([1,0,13,49,117,51]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class R extends k.$Wq{constructor(v,s,E){super(v,s,E),this.u()}t(v){const s=v.add(new S.$0q(n.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return v.add(s.onDidProcessExit(({code:E,signal:y})=>this.w(`terminated by itself with code ${E}, signal: ${y} (ETERM)`))),r.ProxyChannel.toService((0,r.$hi)(s.getChannel("watcher")))}}e.$$q=R}),define(Se[89],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class n{constructor(...S){this.a=new Map;for(const[k,R]of S)this.set(k,R)}set(S,k){const R=this.a.get(S);return this.a.set(S,k),R}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$yi=n}),define(Se[122],De([1,0,14,10,2,71,245,5,89,79]),function(he,e,n,r,S,k,R,A,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=void 0;const E=!1;class y extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class ${constructor(c=new v.$yi,g=!1,p,m=E){this.i=c,this.j=g,this.k=p,this.l=m,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(A.$zi,this),this._globalGraph=m?p?._globalGraph??new R.$kr(b=>b):void 0}dispose(){if(!this.f){this.f=!0,(0,S.$Pc)(this.h),this.h.clear();for(const c of this.g)(0,S.$Oc)(c)&&c.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(c,g){this.m();const p=this,m=new class extends ${dispose(){p.h.delete(m),super.dispose()}}(c,this.j,this,this.l);return this.h.add(m),g?.add(m),m}invokeFunction(c,...g){this.m();const p=a.traceInvocation(this.l,c);let m=!1;try{return c({get:l=>{if(m)throw(0,r.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(l,p);if(!t)throw new Error(`[invokeFunction] unknown service '${l}'`);return t}},...g)}finally{m=!0,p.stop()}}createInstance(c,...g){this.m();let p,m;return c instanceof k.$xi?(p=a.traceCreation(this.l,c.ctor),m=this.o(c.ctor,c.staticArguments.concat(g),p)):(p=a.traceCreation(this.l,c),m=this.o(c,g,p)),p.stop(),m}o(c,g=[],p){const m=A._util.getServiceDependencies(c).sort((t,o)=>t.index-o.index),b=[];for(const t of m){const o=this.s(t.id,p);o||this.y(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),b.push(o)}const l=m.length>0?m[0].index:g.length;if(g.length!==l){console.trace(`[createInstance] First service dependency of ${c.name} at position ${l+1} conflicts with ${g.length} static arguments`);const t=l-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,l)}return Reflect.construct(c,g.concat(b))}q(c,g){if(this.i.get(c)instanceof k.$xi)this.i.set(c,g);else if(this.k)this.k.q(c,g);else throw new Error("illegalState - setting UNKNOWN service instance")}r(c){const g=this.i.get(c);return!g&&this.k?this.k.r(c):g}s(c,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const p=this.r(c);return p instanceof k.$xi?this.u(c,p,g.branch(c,!0)):(g.branch(c,!1),p)}u(c,g,p){if(this.t.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.t.add(c);try{return this.v(c,g,p)}finally{this.t.delete(c)}}v(c,g,p){const m=new R.$kr(t=>t.id.toString());let b=0;const l=[{id:c,desc:g,_trace:p}];for(;l.length;){const t=l.pop();if(m.lookupOrInsertNode(t),b++>1e3)throw new y(m);for(const o of A._util.getServiceDependencies(t.desc.ctor)){const d=this.r(o.id);if(d||this.y(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),d instanceof k.$xi){const i={id:o.id,desc:d,_trace:t._trace.branch(o.id,!0)};m.insertEdge(t,i),l.push(i)}}}for(;;){const t=m.roots();if(t.length===0){if(!m.isEmpty())throw new y(m);break}for(const{data:o}of t){if(this.r(o.id)instanceof k.$xi){const i=this.w(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.q(o.id,i)}m.removeNode(o)}}return this.r(c)}w(c,g,p=[],m,b){if(this.i.get(c)instanceof k.$xi)return this.x(c,g,p,m,b,this.g);if(this.k)return this.k.w(c,g,p,m,b);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}x(c,g,p=[],m,b,l){if(m){const t=new $(void 0,this.j,this,this.l);t.c=String(c);const o=new Map,d=new n.$Th(()=>{const i=t.o(g,p,b);for(const[h,u]of o){const D=i[h];if(typeof D=="function")for(const I of u)I.disposable=D.apply(i,I.listener)}return o.clear(),l.add(i),i});return new Proxy(Object.create(null),{get(i,h){if(!d.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let I=o.get(h);return I||(I=new s.$5c,o.set(h,I)),(O,C,P)=>{if(d.isInitialized)return d.value[h](O,C,P);{const Q={listener:[O,C,P],disposable:void 0},X=I.push(Q);return(0,S.$Sc)(()=>{X(),Q.disposable?.dispose()})}}}if(h in i)return i[h];const u=d.value;let D=u[h];return typeof D!="function"||(D=D.bind(u),i[h]=D),D},set(i,h,u){return d.value[h]=u,!0},getPrototypeOf(i){return g.prototype}})}else{const t=this.o(g,p,b);return l.add(t),t}}y(c,g){if(g&&console.warn(c),this.j)throw new Error(c)}}e.$lr=$;var w;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(w||(w={}));class a{static traceInvocation(c,g){return c?new a(w.Invocation,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):a.c}static traceCreation(c,g){return c?new a(w.Creation,g.name):a.c}constructor(c,g){this.type=c,this.name=g,this.g=Date.now(),this.h=[]}branch(c,g){const p=new a(w.Branch,c.toString());return this.h.push([c,g,p]),p}stop(){const c=Date.now()-this.g;a.f+=c;let g=!1;function p(b,l){const t=[],o=new Array(b+1).join("	");for(const[d,i,h]of l.h)if(i&&h){g=!0,t.push(`${o}CREATES -> ${d}`);const u=p(b+1,h);u&&t.push(u)}else t.push(`${o}uses -> ${d}`);return t.join(`
`)}const m=[`${this.type===w.Creation?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${a.f.toFixed(2)}ms)`];(c>2||g)&&a.all.add(m.join(`
`))}}e.$mr=a,a.all=new Set,a.c=new class extends a{constructor(){super(w.None,null)}stop(){}branch(){return this}},a.f=0}),define(Se[255],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$gw=void 0,e.$gw=(0,n.$Ai)("labelService");var r;(function(S){S[S.SHORT=0]="SHORT",S[S.MEDIUM=1]="MEDIUM",S[S.LONG=2]="LONG"})(r||(e.Verbosity=r={}))}),define(Se[12],De([1,0,218,42,6,68,2,26,3,20,11,4,43,5]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=f,e.log=g,e.$ik=D,e.$jk=I,e.$kk=T,e.$lk=O,e.$7j=(0,w.$Ai)("logService"),e.$8j=(0,w.$Ai)("loggerService");function a(){return new Date().toISOString()}function f(C){return(0,E.$eg)(C)}var c;(function(C){C[C.Off=0]="Off",C[C.Trace=1]="Trace",C[C.Debug=2]="Debug",C[C.Info=3]="Info",C[C.Warning=4]="Warning",C[C.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$0j=c.Info;function g(C,P,Q){switch(P){case c.Trace:C.trace(Q);break;case c.Debug:C.debug(Q);break;case c.Info:C.info(Q);break;case c.Warning:C.warn(Q);break;case c.Error:C.error(Q);break;case c.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function p(C,P=!1){let Q="";for(let X=0;X<C.length;X++){let ie=C[X];if(ie instanceof Error&&(ie=(0,r.$lj)(ie,P)),typeof ie=="object")try{ie=JSON.stringify(ie)}catch{}Q+=(X>0?" ":"")+ie}return Q}class m extends R.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new S.$he),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==c.Off&&this.b<=P}}e.$_j=m;class b extends m{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...Q){this.f(c.Trace)&&this.g(c.Trace,p([P,...Q],!0))}debug(P,...Q){this.f(c.Debug)&&this.g(c.Debug,p([P,...Q]))}info(P,...Q){this.f(c.Info)&&this.g(c.Info,p([P,...Q]))}warn(P,...Q){this.f(c.Warning)&&this.g(c.Warning,p([P,...Q]))}error(P,...Q){if(this.f(c.Error))if(P instanceof Error){const X=Array.prototype.slice.call(arguments);X[0]=P.stack,this.g(c.Error,p(X))}else this.g(c.Error,p([P,...Q]))}flush(){}}e.$ak=b;class l extends m{constructor(P=e.$0j){super(),this.setLevel(P),this.g=!v.$c}trace(P,...Q){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...Q):console.log(`[main ${a()}]`,P,...Q))}debug(P,...Q){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...Q):console.log(`[main ${a()}]`,P,...Q))}info(P,...Q){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,P,...Q):console.log(`[main ${a()}]`,P,...Q))}warn(P,...Q){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,P,...Q):console.warn(`[main ${a()}]`,P,...Q))}error(P,...Q){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,P,...Q):console.error(`[main ${a()}]`,P,...Q))}flush(){}}e.$bk=l;class t extends m{constructor(P=e.$0j,Q=!0){super(),this.g=Q,this.setLevel(P)}trace(P,...Q){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...Q):console.log(P,...Q))}debug(P,...Q){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...Q):console.log(P,...Q))}info(P,...Q){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...Q):console.log(P,...Q))}warn(P,...Q){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...Q):console.log(P,...Q))}error(P,...Q){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...Q):console.error(P,...Q))}flush(){}}e.$ck=t;class o extends m{constructor(P,Q=e.$0j){super(),this.g=P,this.setLevel(Q)}trace(P,...Q){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(P),...Q])}debug(P,...Q){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(P),...Q])}info(P,...Q){this.f(c.Info)&&this.g.log(c.Info,[this.h(P),...Q])}warn(P,...Q){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(P),...Q])}error(P,...Q){this.f(c.Error)&&this.g.log(c.Error,[this.h(P),...Q])}h(P){return typeof P=="string"?P:(0,r.$lj)(P,this.f(c.Trace))}flush(){}}e.$dk=o;class d extends m{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const Q of this.g)Q.setLevel(P);super.setLevel(P)}trace(P,...Q){for(const X of this.g)X.trace(P,...Q)}debug(P,...Q){for(const X of this.g)X.debug(P,...Q)}info(P,...Q){for(const X of this.g)X.info(P,...Q)}warn(P,...Q){for(const X of this.g)X.warn(P,...Q)}error(P,...Q){for(const X of this.g)X.error(P,...Q)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$ek=d;class i extends R.$Uc{constructor(P,Q,X){if(super(),this.h=P,this.j=Q,this.b=new A.$Ac,this.c=this.B(new S.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$he),this.onDidChangeVisibility=this.g.event,X)for(const ie of X)this.b.set(ie.resource,{logger:void 0,info:ie})}m(P){return(0,E.$ag)(P)?[...this.b.values()].find(Q=>Q.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,Q){const X=this.n(P),ie=(0,E.$ag)(P)?P:Q?.id??(0,k.$oj)(X.toString()).toString(16);let ne=this.b.get(X)?.logger;const x=Q?.logLevel==="always"?c.Trace:Q?.logLevel;ne||(ne=this.s(X,x??this.getLogLevel(X)??this.h,{...Q,id:ie}));const re={logger:ne,info:{resource:X,id:ie,logLevel:x,name:Q?.name,hidden:Q?.hidden,extensionId:Q?.extensionId,when:Q?.when}};return this.registerLogger(re.info),this.b.set(X,re),ne}n(P){return(0,E.$ag)(P)?(0,s.$bh)(this.j,`${P}.log`):P}setLogLevel(P,Q){if(y.URI.isUri(P)){const X=P,ie=Q,ne=this.b.get(X);ne&&ie!==ne.info.logLevel&&(ne.info.logLevel=ie===this.h?void 0:ie,ne.logger?.setLevel(ie),this.b.set(ne.info.resource,ne),this.f.fire([X,ie]))}else{this.h=P;for(const[X,ie]of this.b.entries())this.b.get(X)?.info.logLevel===void 0&&ie.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,Q){const X=this.m(P);X&&Q!==!X.info.hidden&&(X.info.hidden=!Q,this.b.set(X.info.resource,X),this.g.fire([X.info.resource,Q]))}getLogLevel(P){let Q;return P&&(Q=this.b.get(P)?.info.logLevel),Q??this.h}registerLogger(P){const Q=this.b.get(P.resource);Q?Q.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const Q=this.b.get(P);Q&&(Q.logger&&Q.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[Q.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=i;class h{constructor(){this.onDidChangeLogLevel=new S.$he().event}setLevel(P){}getLevel(){return c.Info}trace(P,...Q){}debug(P,...Q){}info(P,...Q){}warn(P,...Q){}error(P,...Q){}critical(P,...Q){}dispose(){}flush(){}}e.$gk=h;class u extends h{}e.$hk=u;function D(C){if(C.verbose)return c.Trace;if(typeof C.logLevel=="string"){const P=O(C.logLevel.toLowerCase());if(P!==void 0)return P}return e.$0j}function I(C){switch(C){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}function T(C){switch(C){case c.Trace:return{original:"Trace",value:n.localize(0,null)};case c.Debug:return{original:"Debug",value:n.localize(1,null)};case c.Info:return{original:"Info",value:n.localize(2,null)};case c.Warning:return{original:"Warning",value:n.localize(3,null)};case c.Error:return{original:"Error",value:n.localize(4,null)};case c.Off:return{original:"Off",value:n.localize(5,null)}}}function O(C){switch(C){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$mk=new $.$Rj("logLevel",I(c.Info))}),define(Se[256],De([1,0,18,14,10,6,37,2,9,51,12]),function(he,e,n,r,S,k,R,A,v,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;class y extends A.$Uc{constructor(w,a){super(),this.a=w,this.b=a,this.c=this.B(new k.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new r.$yh(0)),this.w=[],this.y=this.B(new r.$yh(0))}watch(w,a){return a.recursive||this.b?.watcher?.forceUniversal?this.n(w,a):this.z(w,a)}n(w,a){const f={path:this.J(w),excludes:a.excludes,includes:a.includes,recursive:a.recursive,filter:a.filter,correlationId:a.correlationId},c=(0,n.$Tb)(this.j,f);return this.r(),(0,A.$Sc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,S.$1)(w))}s(){this.h||(this.h=this.B(this.t(a=>this.c.fire((0,s.$Xq)(a)),a=>this.G(a),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const a of this.j)(0,s.$Tq)(a)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const a of this.j)(0,s.$Tq)(a)&&w.includes(a.path)&&(a.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,a){const f={path:this.J(w),excludes:a.excludes,includes:a.includes,recursive:!1,filter:a.filter,correlationId:a.correlationId},c=(0,n.$Tb)(this.w,f);return this.C(),(0,A.$Sc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,S.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,s.$Xq)(w)),w=>this.G(w),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.H(w)}H(w){this.a[w.type](w.message)}I(w){return(0,v.$hc)(w.fsPath)}J(w){const a=this.I(w);return(0,R.$Cg)(a)}}e.$4q=y});var Ne=this&&this.__param||function(he,e){return function(n,r){e(n,r,he)}};define(Se[123],De([1,0,18,14,15,19,6,68,40,2,69,13,45,20,56,213,16,121,12,10]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=void 0;let l=b=class extends s.$Uc{constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new R.$he),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.$he),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.$he),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new R.$he),this.onDidRunOperation=this.r.event,this.X=this.B(new R.$he),this.Y=this.B(new R.$he),this.onDidFilesChange=this.Y.event,this.Z=this.B(new R.$he),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new r.$Jh)}registerProvider(o,d){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,$.mark)(`code/registerFilesystem/${o}`);const i=new s.$Tc;return this.h.set(o,d),this.c.fire({added:!0,scheme:o,provider:d}),i.add(d.onDidChangeFile(h=>{const u=new c.$nl(h,!this.S(d));this.X.fire(u),u.hasCorrelation()||this.Y.fire(u)})),typeof d.onDidWatchError=="function"&&i.add(d.onDidWatchError(h=>this.Z.fire(new Error(h)))),i.add(d.onDidChangeCapabilities(()=>this.g.fire({provider:d,scheme:o}))),(0,s.$Sc)(()=>{this.c.fire({added:!1,scheme:o,provider:d}),this.h.delete(o),(0,s.$Pc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const d=[];this.f.fire({scheme:o,join(i){d.push(i)}}),!this.h.has(o)&&await r.Promises.settled(d)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,d){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&d)}listCapabilities(){return v.Iterable.map(this.h,([o,d])=>({scheme:o,capabilities:d.capabilities}))}async j(o){if(!(0,w.$fh)(o))throw new c.$pl((0,f.localize)(0,null,this.sb(o)),c.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(o.scheme);const d=this.h.get(o.scheme);if(!d){const i=new m.$bb;throw i.message=(0,f.localize)(1,null,o.toString()),i}return d}async m(o){const d=await this.j(o);if((0,c.$al)(d)||(0,c.$0k)(d)||(0,c.$bl)(d))return d;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const d=await this.j(o);if((0,c.$al)(d)||(0,c.$0k)(d))return d;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,d){try{return await this.s(o,d)}catch(i){throw(0,c.$kl)(i)===c.FileSystemProviderErrorCode.FileNotFound?new c.$pl((0,f.localize)(2,null,this.sb(o)),c.FileOperationResult.FILE_NOT_FOUND):(0,c.$il)(i)}}async s(o,d){const i=await this.j(o),h=this.S(i),u=d?.resolveTo,D=d?.resolveSingleChildDescendants,I=d?.resolveMetadata,T=await i.stat(o);let O;return this.t(i,o,T,void 0,!!I,(C,P)=>(O||(O=E.$Gi.forUris(()=>!h),O.set(o,!0),u&&O.fill(!0,u)),O.get(C.resource)||O.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&D?P===1:!1))}async t(o,d,i,h,u,D){const{providerExtUri:I}=this.R(o),T={resource:d,name:I.basename(d),isFile:(i.type&c.FileType.File)!==0,isDirectory:(i.type&c.FileType.Directory)!==0,isSymbolicLink:(i.type&c.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&c.FilePermission.Readonly)||!!(o.capabilities&c.FileSystemProviderCapabilities.Readonly),locked:!!((i.permissions??0)&c.FilePermission.Locked),etag:(0,c.$Al)({mtime:i.mtime,size:i.size}),children:void 0};if(T.isDirectory&&D(T,h)){try{const O=await o.readdir(d),C=await r.Promises.settled(O.map(async([P,Q])=>{try{const X=I.joinPath(d,P),ie=u?await o.stat(X):{type:Q};return await this.t(o,X,ie,O.length,u,D)}catch(X){return this.b.trace(X),null}}));T.children=(0,n.$Hb)(C)}catch(O){this.b.trace(O),T.children=[]}return T}return T}async resolveAll(o){return r.Promises.settled(o.map(async d=>{try{return{stat:await this.s(d.resource,d.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const d=await this.j(o),i=await d.stat(o);return this.t(d,o,i,void 0,!0,()=>!1)}async exists(o){const d=await this.j(o);try{return!!await d.stat(o)}catch{return!1}}async canCreateFile(o,d){try{await this.u(o,d)}catch(i){return i}return!0}async u(o,d){if(!d?.overwrite&&await this.exists(o))throw new c.$pl((0,f.localize)(3,null,this.sb(o)),c.FileOperationResult.FILE_MODIFIED_SINCE,d)}async createFile(o,d=S.$Je.fromString(""),i){await this.u(o,i);const h=await this.writeFile(o,d);return this.r.fire(new c.$ml(o,c.FileOperation.CREATE,h)),h}async writeFile(o,d,i){const h=this.qb(await this.n(o),o),{providerExtUri:u}=this.R(h);let D=i;if((0,c.$dl)(h)&&!D?.atomic){const I=h.enforceAtomicWriteFile?.(o);I&&(D={...i,atomic:I})}try{await this.w(h,o,D)||await this.U(h,u.dirname(o));let T;if((0,c.$0k)(h)&&!(d instanceof S.$Je))if((0,a.$ve)(d)){const O=await(0,a.$Ce)(d,3);O.ended?T=S.$Je.concat(O.buffer):T=O}else T=(0,a.$ze)(d,O=>S.$Je.concat(O),3);else T=d;!(0,c.$al)(h)||(0,c.$0k)(h)&&T instanceof S.$Je||(0,c.$0k)(h)&&(0,c.$dl)(h)&&D?.atomic?await this.hb(h,o,D,T):await this.db(h,o,D,T instanceof S.$Je?(0,S.$Ue)(T):T),this.r.fire(new c.$ml(o,c.FileOperation.WRITE))}catch(I){throw new c.$pl((0,f.localize)(4,null,this.sb(o),(0,c.$il)(I).toString()),(0,c.$ll)(I),D)}return this.resolve(o,{resolveMetadata:!0})}async w(o,d,i){const h=!!i?.unlock;if(h&&!(o.capabilities&c.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,f.localize)(5,null,this.sb(d)));if(!!i?.atomic){if(!(o.capabilities&c.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,f.localize)(6,null,this.sb(d)));if(!(o.capabilities&c.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,f.localize)(7,null,this.sb(d)));if(h)throw new Error((0,f.localize)(8,null,this.sb(d)))}let D;try{D=await o.stat(d)}catch{return}if(D.type&c.FileType.Directory)throw new c.$pl((0,f.localize)(9,null,this.sb(d)),c.FileOperationResult.FILE_IS_DIRECTORY,i);if(this.rb(d,D),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==c.$zl&&typeof D.mtime=="number"&&typeof D.size=="number"&&i.mtime<D.mtime&&i.etag!==(0,c.$Al)({mtime:i.mtime,size:D.size}))throw new c.$pl((0,f.localize)(10,null),c.FileOperationResult.FILE_MODIFIED_SINCE,i);return D}async readFile(o,d,i){const h=await this.m(o);return d?.atomic?this.z(h,o,d,i):this.C(h,o,d,i)}async z(o,d,i,h){return new Promise((u,D)=>{this.cb.queueFor(d,async()=>{try{const I=await this.C(o,d,i,h);u(I)}catch(I){D(I)}},this.R(o).providerExtUri)})}async C(o,d,i,h){const u=await this.D(o,d,{...i,preferUnbuffered:!0},h);return{...u,value:await(0,S.$Ve)(u.value)}}async readFileStream(o,d,i){const h=await this.m(o);return this.D(h,o,d,i)}async D(o,d,i,h){const u=new k.$se(h);let D=i;(0,c.$cl)(o)&&o.enforceAtomicReadFile?.(d)&&(D={...i,atomic:!0});const I=this.J(d,D).then(O=>O,O=>{throw u.dispose(!0),O});let T;try{return typeof D?.etag=="string"&&D.etag!==c.$zl&&await I,D?.atomic&&(0,c.$cl)(o)||!((0,c.$al)(o)||(0,c.$bl)(o))||(0,c.$0k)(o)&&D?.preferUnbuffered?T=this.I(o,d,D):(0,c.$bl)(o)?T=this.G(o,d,u.token,D):T=this.H(o,d,u.token,D),T.on("end",()=>u.dispose()),T.on("error",()=>u.dispose()),{...await I,value:T}}catch(O){throw T&&await(0,a.$Ae)(T),this.F(O,d,D)}}F(o,d,i){const h=(0,f.localize)(11,null,this.sb(d),(0,c.$il)(o).toString());return o instanceof c.$rl?new c.$rl(h,o.stat,i):o instanceof c.$ql?new c.$ql(h,o.fileOperationResult,o.size,o.options):new c.$pl(h,(0,c.$ll)(o),i)}G(o,d,i,h=Object.create(null)){const u=o.readFileStream(d,h,i);return(0,a.$Ge)(u,{data:D=>D instanceof S.$Je?D:S.$Je.wrap(D),error:D=>this.F(D,d,h)},D=>S.$Je.concat(D))}H(o,d,i,h=Object.create(null)){const u=(0,S.$Ze)();return(0,g.$Qq)(o,d,u,D=>D,{...h,bufferSize:this.a,errorTransformer:D=>this.F(D,d,h)},i),u}I(o,d,i){const h=(0,a.$xe)(u=>S.$Je.concat(u));return(async()=>{try{let u;i?.atomic&&(0,c.$cl)(o)?u=await o.readFile(d,{atomic:!0}):u=await o.readFile(d),typeof i?.position=="number"&&(u=u.slice(i.position)),typeof i?.length=="number"&&(u=u.slice(0,i.length)),this.L(d,u.byteLength,i),h.end(S.$Je.wrap(u))}catch(u){h.error(u),h.end()}})(),h}async J(o,d){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new c.$pl((0,f.localize)(12,null,this.sb(o)),c.FileOperationResult.FILE_IS_DIRECTORY,d);if(typeof d?.etag=="string"&&d.etag!==c.$zl&&d.etag===i.etag)throw new c.$rl((0,f.localize)(13,null),i,d);return this.L(o,i.size,d),i}L(o,d,i){if(typeof i?.limits?.size=="number"&&d>i.limits.size)throw new c.$ql((0,f.localize)(14,null,this.sb(o)),c.FileOperationResult.FILE_TOO_LARGE,d,i)}async canMove(o,d,i){return this.M(o,d,"move",i)}async canCopy(o,d,i){return this.M(o,d,"copy",i)}async M(o,d,i,h){if(o.toString()!==d.toString())try{const u=i==="move"?this.qb(await this.n(o),o):await this.m(o),D=this.qb(await this.n(d),d);await this.Q(u,o,D,d,i,h)}catch(u){return u}return!0}async move(o,d,i){const h=this.qb(await this.n(o),o),u=this.qb(await this.n(d),d),D=await this.N(h,o,u,d,"move",!!i),I=await this.resolve(d,{resolveMetadata:!0});return this.r.fire(new c.$ml(o,D==="move"?c.FileOperation.MOVE:c.FileOperation.COPY,I)),I}async copy(o,d,i){const h=await this.m(o),u=this.qb(await this.n(d),d),D=await this.N(h,o,u,d,"copy",!!i),I=await this.resolve(d,{resolveMetadata:!0});return this.r.fire(new c.$ml(o,D==="copy"?c.FileOperation.COPY:c.FileOperation.MOVE,I)),I}async N(o,d,i,h,u,D){if(d.toString()===h.toString())return u;const{exists:I,isSameResourceWithDifferentPathCase:T}=await this.Q(o,d,i,h,u,D);if(I&&!T&&D&&await this.del(h,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(h)),u==="copy"){if(o===i&&(0,c.$$k)(o))await o.copy(d,h,{overwrite:D});else{const O=await this.resolve(d);O.isDirectory?await this.P(o,O,i,h):await this.O(o,d,i,h)}return u}else return o===i?(await o.rename(d,h,{overwrite:D}),u):(await this.N(o,d,i,h,"copy",D),await this.del(d,{recursive:!0}),"copy")}async O(o,d,i,h){if((0,c.$al)(o)&&(0,c.$al)(i))return this.jb(o,d,i,h);if((0,c.$al)(o)&&(0,c.$0k)(i))return this.pb(o,d,i,h);if((0,c.$0k)(o)&&(0,c.$al)(i))return this.nb(o,d,i,h);if((0,c.$0k)(o)&&(0,c.$0k)(i))return this.lb(o,d,i,h)}async P(o,d,i,h){await i.mkdir(h),Array.isArray(d.children)&&await r.Promises.settled(d.children.map(async u=>{const D=this.R(i).providerExtUri.joinPath(h,u.name);return u.isDirectory?this.P(o,await this.resolve(u.resource),i,D):this.O(o,u.resource,i,D)}))}async Q(o,d,i,h,u,D){let I=!1;if(o===i){const{providerExtUri:O,isPathCaseSensitive:C}=this.R(o);if(C||(I=O.isEqual(d,h)),I&&u==="copy")throw new Error((0,f.localize)(15,null,this.sb(d),this.sb(h)));if(!I&&O.isEqualOrParent(h,d))throw new Error((0,f.localize)(16,null,this.sb(d),this.sb(h)))}const T=await this.exists(h);if(T&&!I){if(!D)throw new c.$pl((0,f.localize)(17,null,this.sb(d),this.sb(h)),c.FileOperationResult.FILE_MOVE_CONFLICT);if(o===i){const{providerExtUri:O}=this.R(o);if(O.isEqualOrParent(d,h))throw new Error((0,f.localize)(18,null,this.sb(d),this.sb(h)))}}return{exists:T,isSameResourceWithDifferentPathCase:I}}R(o){const d=this.S(o);return{providerExtUri:d?w.$4g:w.$6g,isPathCaseSensitive:d}}S(o){return!!(o.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(o){const d=this.qb(await this.j(o),o);await this.U(d,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new c.$ml(o,c.FileOperation.CREATE,i)),i}async U(o,d){const i=[],{providerExtUri:h}=this.R(o);for(;!h.isEqual(d,h.dirname(d));)try{if(!((await o.stat(d)).type&c.FileType.Directory))throw new Error((0,f.localize)(19,null,this.sb(d)));break}catch(u){if((0,c.$kl)(u)!==c.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(h.basename(d)),d=h.dirname(d)}for(let u=i.length-1;u>=0;u--){d=h.joinPath(d,i[u]);try{await o.mkdir(d)}catch(D){if((0,c.$kl)(D)!==c.FileSystemProviderErrorCode.FileExists)throw D}}}async canDelete(o,d){try{await this.W(o,d)}catch(i){return i}return!0}async W(o,d){const i=this.qb(await this.j(o),o),h=!!d?.useTrash;if(h&&!(i.capabilities&c.FileSystemProviderCapabilities.Trash))throw new Error((0,f.localize)(20,null,this.sb(o)));const u=d?.atomic;if(u&&!(i.capabilities&c.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,f.localize)(21,null,this.sb(o)));if(h&&u)throw new Error((0,f.localize)(22,null,this.sb(o)));let D;try{D=await i.stat(o)}catch{}if(D)this.rb(o,D);else throw new c.$pl((0,f.localize)(23,null,this.sb(o)),c.FileOperationResult.FILE_NOT_FOUND);if(!!!d?.recursive){const T=await this.resolve(o);if(T.isDirectory&&Array.isArray(T.children)&&T.children.length>0)throw new Error((0,f.localize)(24,null,this.sb(o)))}return i}async del(o,d){const i=await this.W(o,d);let h=d;if((0,c.$el)(i)&&!h?.atomic){const T=i.enforceAtomicDelete?.(o);T&&(h={...d,atomic:T})}const u=!!h?.useTrash,D=!!h?.recursive,I=h?.atomic??!1;await i.delete(o,{recursive:D,useTrash:u,atomic:I}),this.r.fire(new c.$ml(o,c.FileOperation.DELETE))}async cloneFile(o,d){const i=await this.j(o),h=this.qb(await this.n(d),d);if(!(i===h&&this.R(i).providerExtUri.isEqual(o,d)))return i===h&&(0,c.$_k)(i)?i.cloneFile(o,d):(await this.U(h,this.R(h).providerExtUri.dirname(d)),i===h&&(0,c.$$k)(i)?this.cb.queueFor(o,()=>i.copy(o,d,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,h,d),this.R(i).providerExtUri))}createWatcher(o,d){return this.watch(o,{...d,correlationId:b.ab++})}watch(o,d={recursive:!1,excludes:[]}){const i=new s.$Tc;let h=!1,u=()=>{h=!0};i.add((0,s.$Sc)(()=>u())),(async()=>{try{const I=await this.bb(o,d);h?(0,s.$Pc)(I):u=()=>(0,s.$Pc)(I)}catch(I){this.b.error(I)}})();const D=d.correlationId;if(typeof D=="number"){const I=i.add(new R.$he);return i.add(this.X.event(O=>{O.correlates(D)&&I.fire(O)})),{onDidChange:I.event,dispose:()=>i.dispose()}}return i}async bb(o,d){const i=await this.j(o),h=(0,A.$oj)([this.R(i).providerExtUri.getComparisonKey(o),d]);let u=this.$.get(h);return u||(u={count:0,disposable:i.watch(o,d)},this.$.set(h,u)),u.count+=1,(0,s.$Sc)(()=>{u&&(u.count--,u.count===0&&((0,s.$Pc)(u.disposable),this.$.delete(h)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,s.$Pc)(o.disposable);this.$.clear()}async db(o,d,i,h){return this.cb.queueFor(d,async()=>{const u=await o.open(d,{create:!0,unlock:i?.unlock??!1});try{(0,a.$ve)(h)||(0,a.$we)(h)?await this.eb(o,u,h):await this.fb(o,u,h)}catch(D){throw(0,c.$il)(D)}finally{await o.close(u)}},this.R(o).providerExtUri)}async eb(o,d,i){let h=0,u;if((0,a.$we)(i)){if(i.buffer.length>0){const D=S.$Je.concat(i.buffer);await this.gb(o,d,D,D.byteLength,h,0),h+=D.byteLength}if(i.ended)return;u=i.stream}else u=i;return new Promise((D,I)=>{(0,a.$Be)(u,{onData:async T=>{u.pause();try{await this.gb(o,d,T,T.byteLength,h,0)}catch(O){return I(O)}h+=T.byteLength,setTimeout(()=>u.resume())},onError:T=>I(T),onEnd:()=>D()})})}async fb(o,d,i){let h=0,u;for(;(u=i.read())!==null;)await this.gb(o,d,u,u.byteLength,h,0),h+=u.byteLength}async gb(o,d,i,h,u,D){let I=0;for(;I<h;){const T=await o.write(d,u+I,i.buffer,D+I,h-I);I+=T}}async hb(o,d,i,h){return this.cb.queueFor(d,()=>this.ib(o,d,i,h),this.R(o).providerExtUri)}async ib(o,d,i,h){let u;h instanceof S.$Je?u=h:(0,a.$ve)(h)?u=await(0,S.$Ve)(h):(0,a.$we)(h)?u=await(0,S.$We)(h):u=(0,S.$Te)(h),await o.writeFile(d,u.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,d,i,h){return this.cb.queueFor(h,()=>this.kb(o,d,i,h),this.R(i).providerExtUri)}async kb(o,d,i,h){let u,D;try{u=await o.open(d,{create:!1}),D=await i.open(h,{create:!0,unlock:!1});const I=S.$Je.alloc(this.a);let T=0,O=0,C=0;do C=await o.read(u,T,I.buffer,O,I.byteLength-O),await this.gb(i,D,I,C,T,O),T+=C,O+=C,O===I.byteLength&&(O=0);while(C>0)}catch(I){throw(0,c.$il)(I)}finally{await r.Promises.settled([typeof u=="number"?o.close(u):Promise.resolve(),typeof D=="number"?i.close(D):Promise.resolve()])}}async lb(o,d,i,h){return this.cb.queueFor(h,()=>this.mb(o,d,i,h),this.R(i).providerExtUri)}async mb(o,d,i,h){return i.writeFile(h,await o.readFile(d),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,d,i,h){return this.cb.queueFor(h,()=>this.ob(o,d,i,h),this.R(i).providerExtUri)}async ob(o,d,i,h){const u=await i.open(h,{create:!0,unlock:!1});try{const D=await o.readFile(d);await this.gb(i,u,S.$Je.wrap(D),D.byteLength,0,0)}catch(D){throw(0,c.$il)(D)}finally{await i.close(u)}}async pb(o,d,i,h){const u=await(0,S.$Ve)(this.H(o,d,k.CancellationToken.None));await this.hb(i,h,void 0,u)}qb(o,d){if(o.capabilities&c.FileSystemProviderCapabilities.Readonly)throw new c.$pl((0,f.localize)(25,null,this.sb(d)),c.FileOperationResult.FILE_PERMISSION_DENIED);return o}rb(o,d){if((d.permissions??0)&c.FilePermission.Readonly)throw new c.$pl((0,f.localize)(26,null,this.sb(o)),c.FileOperationResult.FILE_PERMISSION_DENIED)}sb(o){return o.scheme===y.Schemas.file?o.fsPath:o.toString(!0)}};e.$Rq=l,l.ab=0,e.$Rq=l=b=Ue([Ne(0,p.$7j)],l)}),define(Se[72],De([1,0,31,338,14,26,15,6,37,2,9,3,20,56,25,216,16,121,256,42,254,253]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m,b,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0,(()=>{try{(0,r.gracefulify)(n)}catch(o){console.error(`Error enabling graceful-fs: ${(0,m.$lj)(o)}`)}})();class t extends p.$4q{constructor(d,i){super(d,i),this.onDidChangeCapabilities=A.Event.None,this.P=new k.$Ac(h=>$.$5g.getComparisonKey(h)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=c.FileSystemProviderCapabilities.FileReadWrite|c.FileSystemProviderCapabilities.FileOpenReadWriteClose|c.FileSystemProviderCapabilities.FileReadStream|c.FileSystemProviderCapabilities.FileFolderCopy|c.FileSystemProviderCapabilities.FileWriteUnlock|c.FileSystemProviderCapabilities.FileAtomicRead|c.FileSystemProviderCapabilities.FileAtomicWrite|c.FileSystemProviderCapabilities.FileAtomicDelete|c.FileSystemProviderCapabilities.FileClone,y.$e&&(this.M|=c.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(d){try{const{stat:i,symbolicLink:h}=await a.SymlinkSupport.stat(this.I(d));return{type:this.O(i,h),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:c.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(d){try{return await this.stat(d)}catch{return}}async readdir(d){try{const i=await a.Promises.readdir(this.I(d),{withFileTypes:!0}),h=[];return await Promise.all(i.map(async u=>{try{let D;u.isSymbolicLink()?D=(await this.stat((0,$.$bh)(d,u.name))).type:D=this.O(u),h.push([u.name,D])}catch(D){this.a.trace(D)}})),h}catch(i){throw this.hb(i)}}O(d,i){let h;return i?.dangling?h=c.FileType.Unknown:d.isFile()?h=c.FileType.File:d.isDirectory()?h=c.FileType.Directory:h=c.FileType.Unknown,i&&(h|=c.FileType.SymbolicLink),h}async Q(d){const i=this.I(d);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let h;for(;h=this.P.get(d);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await h.wait();const u=new S.$zh;return this.P.set(d,u),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,s.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(d)===u&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(d)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(d,i){let h;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(d)})`),h=await this.Q(d));const u=this.I(d);return await a.Promises.readFile(u)}catch(u){throw this.hb(u)}finally{h?.dispose()}}R(d){t.L&&this.a.trace(d)}readFileStream(d,i,h){const u=(0,w.$xe)(D=>R.$Je.concat(D.map(I=>R.$Je.wrap(I))).buffer);return(0,g.$Qq)(this,d,u,D=>D.buffer,{...i,bufferSize:256*1024},h),u}async writeFile(d,i,h){return h?.atomic!==!1&&h?.atomic?.postfix&&await this.S(d)?this.U(d,(0,$.$bh)((0,$.$ah)(d),`${(0,$.$$g)(d)}${h.atomic.postfix}`),i,h):this.W(d,i,h)}async S(d){try{const i=this.I(d),{symbolicLink:h}=await a.SymlinkSupport.stat(i);if(h)return!1}catch{}return!0}async U(d,i,h,u){const D=new s.$Tc;try{D.add(await this.Q(d)),D.add(await this.Q(i)),await this.W(i,h,u,!0);try{await this.rename(i,d,{overwrite:!0})}catch(I){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{D.dispose()}}async W(d,i,h,u){let D;try{const I=this.I(d);if(!h.create||!h.overwrite){if(await a.Promises.exists(I)){if(!h.overwrite)throw(0,c.$hl)((0,f.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!h.create)throw(0,c.$hl)((0,f.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}D=await this.open(d,{create:!0,unlock:h.unlock},u),await this.write(D,0,i,0,i.byteLength)}catch(I){throw await this.ib(d,I)}finally{typeof D=="number"&&await this.close(D)}}static configureFlushOnWrite(d){t.$=d}async open(d,i,h){const u=this.I(d);let D;(0,c.$8k)(i)&&!h&&(D=await this.Q(d));let I;try{if((0,c.$8k)(i)&&i.unlock)try{const{stat:O}=await a.SymlinkSupport.stat(u);O.mode&128||await a.Promises.chmod(u,O.mode|128)}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}let T;if((0,c.$8k)(i)){if(y.$c)try{await a.Promises.truncate(u,0),T="r+"}catch(O){O.code!=="ENOENT"&&this.a.trace(O)}T||(T="w")}else T="r";I=await a.Promises.open(u,T)}catch(T){throw D?.dispose(),(0,c.$8k)(i)?await this.ib(d,T):this.hb(T)}if(this.X.set(I,0),(0,c.$8k)(i)&&this.Z.set(I,d),D){const T=this.Y.get(I);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${u})`),this.Y.set(I,D),T&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${u})`),T.dispose())}return I}async close(d){const i=this.Y.get(d);try{if(this.X.delete(d),this.Z.delete(d)&&t.$)try{await a.Promises.fdatasync(d)}catch(h){t.configureFlushOnWrite(!1),this.a.error(h)}return await a.Promises.close(d)}catch(h){throw this.hb(h)}finally{i&&(this.Y.get(d)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${d}`),this.Y.delete(d)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${d}`),i.dispose())}}async read(d,i,h,u,D){const I=this.ab(d,i);let T=null;try{T=(await a.Promises.read(d,h,u,D,I)).bytesRead}catch(O){throw this.hb(O)}finally{this.bb(d,I,T)}return T}ab(d,i){return i===this.X.get(d)?null:i}bb(d,i,h){const u=this.X.get(d);typeof u=="number"&&(typeof i=="number"||(typeof h=="number"?this.X.set(d,u+h):this.X.delete(d)))}async write(d,i,h,u,D){return(0,S.$Uh)(()=>this.cb(d,i,h,u,D),100,3)}async cb(d,i,h,u,D){const I=this.ab(d,i);let T=null;try{T=(await a.Promises.write(d,h,u,D,I)).bytesWritten}catch(O){throw await this.ib(this.Z.get(d),O)}finally{this.bb(d,I,T)}return T}async mkdir(d){try{await a.Promises.mkdir(this.I(d))}catch(i){throw this.hb(i)}}async delete(d,i){try{const h=this.I(d);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,E.$jc)((0,E.$mc)(h),`${(0,E.$nc)(h)}${i.atomic.postfix}`)),await a.Promises.rm(h,a.RimRafMode.MOVE,u)}else try{await a.Promises.unlink(h)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let D=!1;try{const{stat:I,symbolicLink:T}=await a.SymlinkSupport.stat(h);D=I.isDirectory()&&!T}catch{}if(D)await a.Promises.rmdir(h);else throw u}else throw u}}catch(h){throw this.hb(h)}}async rename(d,i,h){const u=this.I(d),D=this.I(i);if(u!==D)try{await this.db(d,i,"move",h.overwrite),await a.Promises.rename(u,D)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,f.localize)(2,null,(0,E.$nc)(u),(0,E.$nc)((0,E.$mc)(D)),I.toString()))),this.hb(I)}}async copy(d,i,h){const u=this.I(d),D=this.I(i);if(u!==D)try{await this.db(d,i,"copy",h.overwrite),await a.Promises.copy(u,D,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,f.localize)(3,null,(0,E.$nc)(u),(0,E.$nc)((0,E.$mc)(D)),I.toString()))),this.hb(I)}}async db(d,i,h,u){const D=this.I(d),I=this.I(i);let T=!1;if(!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive)||(T=(0,v.$yg)(D,I,!0)),T){if(h==="copy")throw(0,c.$hl)((0,f.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(h==="move")return}const C=await this.N(d);if(!C)throw(0,c.$hl)((0,f.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const P=await this.N(i);if(P){if(!u)throw(0,c.$hl)((0,f.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);C.type&c.FileType.File&&P.type&c.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(d,i){return this.eb(d,i,!1)}async eb(d,i,h){const u=this.I(d),D=this.I(i),I=!!(this.capabilities&c.FileSystemProviderCapabilities.PathCaseSensitive);if((0,v.$yg)(u,D,!I))return;const T=new s.$Tc;try{T.add(await this.Q(d)),T.add(await this.Q(i)),h&&await a.Promises.mkdir((0,E.$mc)(D),{recursive:!0}),await a.Promises.copyFile(u,D)}catch(O){if(O.code==="ENOENT"&&!h)return this.eb(d,i,!0);throw this.hb(O)}finally{T.dispose()}}t(d,i,h){return new b.$$q(u=>d(u),u=>i(u),h)}F(d,i,h){return new l.$hr(u=>d(u),u=>i(u),h)}hb(d){if(d instanceof c.$gl)return d;let i=d,h;switch(d.code){case"ENOENT":h=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":h=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":h=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":h=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":h=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,h=c.FileSystemProviderErrorCode.Unknown;break;default:h=c.FileSystemProviderErrorCode.Unknown}return(0,c.$hl)(i,h)}async ib(d,i){let h=this.hb(i);if(d&&h.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await a.SymlinkSupport.stat(this.I(d));u.mode&128||(h=(0,c.$hl)(i,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return h}}e.$ir=t,t.L=!1,t.$=!0}),define(Se[257],De([1,0,6,72,2,15,56,19]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=e.$Ss=void 0;class v extends S.$Uc{constructor(y,$){super(),this.a=y,this.b=$,this.F=new Map,this.G=new Map}call(y,$,w){const a=this.c(y);switch($){case"stat":return this.g(a,w[0]);case"readdir":return this.h(a,w[0]);case"open":return this.r(a,w[0],w[1]);case"close":return this.s(w[0]);case"read":return this.t(w[0],w[1],w[2]);case"readFile":return this.j(a,w[0],w[1]);case"write":return this.u(w[0],w[1],w[2],w[3],w[4]);case"writeFile":return this.n(a,w[0],w[1],w[2]);case"rename":return this.z(a,w[0],w[1],w[2]);case"copy":return this.C(a,w[0],w[1],w[2]);case"cloneFile":return this.D(a,w[0],w[1]);case"mkdir":return this.w(a,w[0]);case"delete":return this.y(a,w[0],w[1]);case"watch":return this.I(a,w[0],w[1],w[2],w[3]);case"unwatch":return this.J(w[0],w[1])}throw new Error(`IPC Command ${$} not found`)}listen(y,$,w){const a=this.c(y);switch($){case"fileChange":return this.H(a,w[0]);case"readFileStream":return this.m(a,w[0],w[1])}throw new Error(`Unknown event ${$}`)}g(y,$){const w=this.f(y,$,!0);return this.a.stat(w)}h(y,$){const w=this.f(y,$);return this.a.readdir(w)}async j(y,$,w){const a=this.f(y,$,!0);this.b.trace(`File action: readFile ${a.path}`);const f=await this.a.readFile(a,w);return k.$Je.wrap(f)}m(y,$,w){const a=this.f(y,$,!0),f=new A.$se,c=new n.$he({onDidRemoveLastListener:()=>{f.cancel()}});this.b.trace(`File action: readFileStream ${a.path}`);const g=this.a.readFileStream(a,w,f.token);return(0,R.$Be)(g,{onData:p=>c.fire(k.$Je.wrap(p)),onError:p=>c.fire(p),onEnd:()=>{c.fire("end"),c.dispose(),f.dispose()}}),c.event}n(y,$,w,a){const f=this.f(y,$);return this.b.trace(`File action: writeFile ${f.path}`),this.a.writeFile(f,w.buffer,a)}r(y,$,w){const a=this.f(y,$,!0);return this.a.open(a,w)}s(y){return this.a.close(y)}async t(y,$,w){const a=k.$Je.alloc(w),c=await this.a.read(y,$,a.buffer,0,w);return[a,c]}u(y,$,w,a,f){return this.a.write(y,$,w.buffer,a,f)}w(y,$){const w=this.f(y,$);return this.a.mkdir(w)}y(y,$,w){const a=this.f(y,$);return this.a.delete(a,w)}z(y,$,w,a){const f=this.f(y,$),c=this.f(y,w);return this.a.rename(f,c,a)}C(y,$,w,a){const f=this.f(y,$),c=this.f(y,w);return this.a.copy(f,c,a)}D(y,$,w){const a=this.f(y,$),f=this.f(y,w);return this.a.cloneFile(a,f)}H(y,$){const w=new n.$he({onWillAddFirstListener:()=>{this.F.set($,this.L(y,w))},onDidRemoveLastListener:()=>{(0,S.$Pc)(this.F.get($)),this.F.delete($)}});return w.event}async I(y,$,w,a,f){const c=this.F.get($);if(c){const g=this.f(y,a),p=c.watch(w,g,f);this.G.set($+w,p)}}async J(y,$){const w=y+$,a=this.G.get(w);a&&((0,S.$Pc)(a),this.G.delete(w))}dispose(){super.dispose();for(const[,y]of this.G)y.dispose();this.G.clear();for(const[,y]of this.F)y.dispose();this.F.clear()}}e.$Ss=v;class s extends S.$Uc{constructor(y,$,w,a){super(),this.c=y,this.f=w,this.g=a,this.a=new Map,this.b=this.B(new r.$ir(this.f,{watcher:{recursive:this.j(this.g)}})),this.h($)}h(y){const $=this.B(new n.$he);this.B($.event(w=>{y.fire(w.map(a=>({resource:this.c.transformOutgoingURI(a.resource),type:a.type,cId:a.cId})))})),this.B(this.b.onDidChangeFile(w=>$.fire(w))),this.B(this.b.onDidWatchError(w=>y.fire(w)))}j(y){}m(y){}watch(y,$,w){const a=this.m(this.g);return Array.isArray(a)&&(w.excludes=[...w.excludes,...a]),this.a.set(y,this.b.watch($,w)),(0,S.$Sc)(()=>{(0,S.$Pc)(this.a.get(y)),this.a.delete(y)})}dispose(){for(const[,y]of this.a)y.dispose();this.a.clear(),super.dispose()}}e.$Ts=s}),define(Se[124],De([1,0,4,6,12,2]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=e.$js=e.$is=void 0;class R extends S.$fk{constructor(y,$,w,a,f){super($,w,a),this.r=y,this.t=f,this.B(f.listen("onDidChangeLogLevel",y)(c=>{(0,S.$9j)(c)?super.setLogLevel(c):super.setLogLevel(n.URI.revive(c[0]),c[1])})),this.B(f.listen("onDidChangeVisibility",y)(([c,g])=>super.setVisibility(n.URI.revive(c),g))),this.B(f.listen("onDidChangeLoggers",y)(({added:c,removed:g})=>{for(const p of c)super.registerLogger({...p,resource:n.URI.revive(p.resource)});for(const p of g)super.deregisterLogger(p.resource)}))}createConsoleMainLogger(){return new S.$dk({log:(y,$)=>{this.t.call("consoleLog",[y,$])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,$){super.setLogLevel(y,$),this.t.call("setLogLevel",[y,$])}setVisibility(y,$){super.setVisibility(y,$),this.t.call("setVisibility",[this.n(y),$])}s(y,$,w){return new A(this.t,y,$,w,this.r)}static setLogLevel(y,$,w){return y.call("setLogLevel",[$,w])}}e.$is=R;class A extends S.$ak{constructor(y,$,w,a,f){super(a?.logLevel==="always"),this.r=y,this.s=$,this.m=!1,this.n=[],this.setLevel(w),this.r.call("createLogger",[$,a,f]).then(()=>{this.u(this.n),this.m=!0})}g(y,$){const w=[[y,$]];this.m?this.u(w):this.n.push(...w)}u(y){this.r.call("log",[this.s,y])}}class v{constructor(y,$){this.a=y,this.b=$}listen(y,$){const w=this.b(y);switch($){case"onDidChangeLoggers":return r.Event.map(this.a.onDidChangeLoggers,a=>({added:[...a.added].map(f=>this.c(f,w)),removed:[...a.removed].map(f=>this.c(f,w))}));case"onDidChangeVisibility":return r.Event.map(this.a.onDidChangeVisibility,a=>[w.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return r.Event.map(this.a.onDidChangeLogLevel,a=>(0,S.$9j)(a)?a:[w.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${$}`)}async call(y,$,w){const a=this.b(y);switch($){case"setLogLevel":return(0,S.$9j)(w[0])?this.a.setLogLevel(w[0]):this.a.setLogLevel(n.URI.revive(a.transformIncoming(w[0][0])),w[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(f=>this.c(f,a)))}throw new Error(`Call not found: ${$}`)}c(y,$){return{...y,resource:$.transformOutgoingURI(y.resource)}}}e.$js=v;class s extends k.$Uc{constructor(y,$){super(),$.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(w=>$.call("setLogLevel",[w]))),$.call("getRegisteredLoggers").then(w=>{for(const a of w)y.registerLogger({...a,resource:n.URI.revive(a.resource)})}),this.B($.listen("onDidChangeVisibility")(([w,a])=>y.setVisibility(n.URI.revive(w),a))),this.B($.listen("onDidChangeLoggers")(({added:w,removed:a})=>{for(const f of w)y.registerLogger({...f,resource:n.URI.revive(f.resource)});for(const f of a)y.deregisterLogger(f.resource)}))}}e.$ks=s}),define(Se[125],De([1,0,2,12]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=void 0;class S extends n.$Uc{constructor(R,A=[]){super(),this.a=new r.$ek([R,...A]),this.B(R.onDidChangeLogLevel(v=>this.setLevel(v)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...A){this.a.trace(R,...A)}debug(R,...A){this.a.debug(R,...A)}info(R,...A){this.a.info(R,...A)}warn(R,...A){this.a.warn(R,...A)}error(R,...A){this.a.error(R,...A)}flush(){this.a.flush()}}e.$oQ=S}),define(Se[258],De([1,0,16,12]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=void 0;var S;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(S||(S={}));async function k(s,E,y,$,w){try{const a=await new Promise((c,g)=>{he(["@vscode/spdlog"],c,g)});a.setFlushOn(S.Trace);const f=await a.createAsyncRotatingLogger(s,E,y,$);return w?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(a){console.error(a)}return null}function R(s,E,y){switch(E){case r.LogLevel.Trace:s.trace(y);break;case r.LogLevel.Debug:s.debug(y);break;case r.LogLevel.Info:s.info(y);break;case r.LogLevel.Warning:s.warn(y);break;case r.LogLevel.Error:s.error(y);break;case r.LogLevel.Off:break;default:throw new Error(`Invalid log level ${E}`)}}function A(s,E){switch(E){case r.LogLevel.Trace:s.setLevel(S.Trace);break;case r.LogLevel.Debug:s.setLevel(S.Debug);break;case r.LogLevel.Info:s.setLevel(S.Info);break;case r.LogLevel.Warning:s.setLevel(S.Warning);break;case r.LogLevel.Error:s.setLevel(S.Error);break;case r.LogLevel.Off:s.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${E}`)}}class v extends r.$ak{constructor(E,y,$,w,a){super(),this.m=[],this.setLevel(a),this.n=this.s(E,y,$,w),this.B(this.onDidChangeLogLevel(f=>{this.r&&A(this.r,f)}))}async s(E,y,$,w){const a=$?6:1,f=30/a*n.$Cl.MB,c=await k(E,y,f,a,w);if(c){this.r=c,A(this.r,this.getLevel());for(const{level:g,message:p}of this.m)R(this.r,g,p);this.m=[]}}g(E,y){this.r?R(this.r,E,y):this.getLevel()<=E&&this.m.push({level:E,message:y})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$dQ=v}),define(Se[126],De([1,0,22,12,258]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eQ=void 0;class k extends r.$fk{s(A,v,s){return new S.$dQ((0,n.$Wg)(),A.fsPath,!s?.donotRotate,!!s?.donotUseFormatters,v)}}e.$eQ=k}),define(Se[259],De([1,0,58,219,5]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var k;(function(v){v[v.Unnecessary=1]="Unnecessary",v[v.Deprecated=2]="Deprecated"})(k||(e.MarkerTag=k={}));var R;(function(v){v[v.Hint=1]="Hint",v[v.Info=2]="Info",v[v.Warning=4]="Warning",v[v.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(v){function s(a,f){return f-a}v.compare=s;const E=Object.create(null);E[v.Error]=(0,r.localize)(0,null),E[v.Warning]=(0,r.localize)(1,null),E[v.Info]=(0,r.localize)(2,null);function y(a){return E[a]||""}v.toString=y;function $(a){switch(a){case n.default.Error:return v.Error;case n.default.Warning:return v.Warning;case n.default.Info:return v.Info;case n.default.Ignore:return v.Hint}}v.fromSeverity=$;function w(a){switch(a){case v.Error:return n.default.Error;case v.Warning:return n.default.Warning;case v.Info:return n.default.Info;case v.Hint:return n.default.Ignore}}v.toSeverity=w}(R||(e.MarkerSeverity=R={}));var A;(function(v){const s="";function E($){return y($,!0)}v.makeKey=E;function y($,w){const a=[s];return $.source?a.push($.source.replace("\xA6","\\\xA6")):a.push(s),$.code?typeof $.code=="string"?a.push($.code.replace("\xA6","\\\xA6")):a.push($.code.value.replace("\xA6","\\\xA6")):a.push(s),$.severity!==void 0&&$.severity!==null?a.push(R.toString($.severity)):a.push(s),$.message&&w?a.push($.message.replace("\xA6","\\\xA6")):a.push(s),$.startLineNumber!==void 0&&$.startLineNumber!==null?a.push($.startLineNumber.toString()):a.push(s),$.startColumn!==void 0&&$.startColumn!==null?a.push($.startColumn.toString()):a.push(s),$.endLineNumber!==void 0&&$.endLineNumber!==null?a.push($.endLineNumber.toString()):a.push(s),$.endColumn!==void 0&&$.endColumn!==null?a.push($.endColumn.toString()):a.push(s),a.push(s),a.join("\xA6")}v.makeKeyOptionalMessage=y})(A||(e.IMarkerData=A={})),e.$Hv=(0,S.$Ai)("markerService")}),define(Se[73],De([1,0,6,40,2,5]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=void 0,e.$mo=(0,k.$Ai)("policy");class R extends S.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$he),this.onDidChange=this.h.event}async updatePolicyDefinitions(s){const E=Object.keys(this.f).length;return this.f={...s,...this.f},E!==Object.keys(this.f).length&&await this.j(s),r.Iterable.reduce(this.g.entries(),(y,[$,w])=>({...y,[$]:w}),{})}getPolicyValue(s){return this.g.get(s)}serialize(){return r.Iterable.reduce(Object.entries(this.f),(s,[E,y])=>({...s,[E]:{definition:y,value:this.g.get(E)}}),{})}}e.$no=R;class A{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$oo=A}),define(Se[63],De([1,0,33]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const k=S.context.configuration();if(k)r=k.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const k=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:k.version})}Object.assign(r,{extensionsGallery:n.env.EXTENSIONS_GALLERY?JSON.parse(n.env.EXTENSIONS_GALLERY):r.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""},telemetryEndpoint:n.env.CS_TELEMETRY_URL||r.telemetryEndpoint||"https://v1.telemetry.coder.com/track"})}else r={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.90.0",sha256:"1317dd7d1ac50641c1534a3e957ecbc94349f4fbd897acb916da11eea3208a66",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.90.2",commit:"c26ac35b25b09e9d58e6716f2aae41d8d1dfbb6c",date:"2024-06-20T22:15:21.422Z"},Object.keys(r).length===0&&Object.assign(r,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(Se[29],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,n.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"}),define(Se[260],De([1,0,14,19,2,5]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rw=e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.ProgressLocation=e.$lw=void 0,e.$lw=(0,k.$Ai)("progressService");var R;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$mw=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor($){this.b=$}report($){this.a=$,this.b(this.a)}}e.$nw=A,A.None=Object.freeze({report(){}});class v{get value(){return this.a}constructor($){this.e=$}report($){this.b?this.b.push($):this.b=[$],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const $=this.b.shift();this.a=$,await this.e(this.a)}}finally{this.c=!1;const $=this.d;this.d=void 0,$?.()}}drain(){return this.c?new Promise($=>{const w=this.d;this.d=()=>{w?.(),$()}}):Promise.resolve()}}e.$ow=v;let s=class extends S.$Uc{constructor($,w){super(),this.a=new n.$Xh,w.withProgress($,a=>(this.b=a,this.c&&a.report(this.c),this.a.p)),this.B((0,S.$Sc)(()=>this.a.complete()))}report($){this.b?this.b.report($):this.c=$}};e.$pw=s,e.$pw=s=Ue([Ne(1,e.$lw)],s);class E extends S.$Uc{constructor($){super(),this.g=$,this.a=0,this.b=this.B(new S.$Tc)}start($){this.stop();const w=++this.a,a=new r.$se;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},$),this.b.add((0,S.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,S.$Sc)(()=>a.cancel())),this.b.add((0,S.$Sc)(()=>this.c?this.c.done():void 0)),{id:w,token:a.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h($){this.a===$&&this.b.clear()}}e.$qw=E,e.$rw=(0,k.$Ai)("editorProgressService")}),define(Se[38],De([1,0,107,11]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=void 0;class S{constructor(){this.a=new Map}add(R,A){n.ok(r.$ag(R)),n.ok(r.$cg(A)),n.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,A)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$ko=new S}),define(Se[127],De([1,0,6,38]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=void 0,e.$lo={JSONContribution:"base.contributions.json"};function S(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class k{constructor(){this.b=new n.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(v,s){this.a[S(v)]=s,this.b.fire(v)}notifySchemaChanged(v){this.b.fire(v)}getSchemaContributions(){return{schemas:this.a}}}const R=new k;r.$ko.add(e.$lo.JSONContribution,R)}),define(Se[46],De([1,0,18,6,11,200,27,127,38]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.ConfigurationScope=e.$po=e.EditPresentationTypes=void 0,e.$Ao=f,e.$Bo=c,e.$Co=g,e.$Do=m,e.$Eo=b;var s;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(s||(e.EditPresentationTypes=s={})),e.$po={Configuration:"base.contributions.configuration"};var E;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo="vscode://schemas/settings/resourceLanguage",e.$xo="vscode://schemas/settings/configurationDefaults";const y=v.$ko.as(A.$lo.JSONContribution);class ${constructor(){this.h=new Set,this.i=new r.$he,this.onDidSchemaChange=this.i.event,this.j=new r.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:k.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$wo,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const d=new Set;this.n(t,o,d),y.registerSchema(e.$wo,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(t){const o=new Set;this.o(t,o),y.registerSchema(e.$wo,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const d=new Set;this.o(o,d),this.n(t,!1,d),y.registerSchema(e.$wo,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const d=[];for(const{overrides:i,source:h}of t)for(const u in i)if(o.add(u),e.$zo.test(u)){const D=this.a.get(u),I=D?.valuesSources??new Map;if(h)for(const P of Object.keys(i[u]))I.set(P,h);const T={...D?.value||{},...i[u]};this.a.set(u,{source:h,value:T,valuesSources:I});const O=(0,R.$ej)(u),C={type:"object",default:T,description:k.localize(1,null,O),$ref:e.$wo,defaultDefaultValue:T,source:S.$ag(h)?void 0:h,defaultValueSource:h};d.push(...f(u)),this.d[u]=C,this.b.properties[u]=C}else{this.a.set(u,{value:i[u],source:h});const D=this.d[u];D&&(this.w(u,D),this.r(u,D))}this.m(d)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:d,source:i}of t)for(const h in d){const u=this.a.get(h),D=S.$ag(i)?i:i?.id,I=S.$ag(u?.source)?u?.source:u?.source?.id;if(D===I)if(o.add(h),this.a.delete(h),e.$zo.test(h))delete this.d[h],delete this.b.properties[h];else{const T=this.d[h];T&&(this.w(h,T),this.r(h,T))}}this.u()}deltaConfiguration(t){let o=!1;const d=new Set;t.removedDefaults&&(this.l(t.removedDefaults,d),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,d),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,d),t.addedConfigurations&&this.n(t.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,d){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,d),this.c.push(i),this.q(i)})}o(t,o){const d=i=>{if(i.properties)for(const h in i.properties){o.add(h);const u=this.d[h];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[h],this.s(h,i.properties[h])}i.allOf?.forEach(h=>d(h))};for(const i of t){d(i);const h=this.c.indexOf(i);h!==-1&&this.c.splice(h,1)}}p(t,o=!0,d,i,h=E.WINDOW,u){h=S.$jg(t.scope)?h:t.scope;const D=t.properties;if(D)for(const T in D){const O=D[T];if(o&&m(T,O)){delete D[T];continue}if(O.source=d,O.defaultDefaultValue=D[T].default,this.w(T,O),e.$zo.test(T)?O.scope=void 0:(O.scope=S.$jg(O.scope)?h:O.scope,O.restricted=S.$jg(O.restricted)?!!i?.includes(T):O.restricted),D[T].hasOwnProperty("included")&&!D[T].included){this.f[T]=D[T],delete D[T];continue}else this.d[T]=D[T],D[T].policy?.name&&this.e.set(D[T].policy.name,T);!D[T].deprecationMessage&&D[T].markdownDeprecationMessage&&(D[T].deprecationMessage=D[T].markdownDeprecationMessage),u.add(T)}const I=t.allOf;if(I)for(const T of I)this.p(T,o,d,i,h,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=d=>{const i=d.properties;if(i)for(const u in i)this.r(u,i[u]);d.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$qo.properties[t]=o,o.scope){case E.APPLICATION:e.$ro.properties[t]=o;break;case E.MACHINE:e.$so.properties[t]=o;break;case E.MACHINE_OVERRIDABLE:e.$to.properties[t]=o;break;case E.WINDOW:e.$uo.properties[t]=o;break;case E.RESOURCE:e.$vo.properties[t]=o;break;case E.LANGUAGE_OVERRIDABLE:e.$vo.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$qo.properties[t],o.scope){case E.APPLICATION:delete e.$ro.properties[t];break;case E.MACHINE:delete e.$so.properties[t];break;case E.MACHINE_OVERRIDABLE:delete e.$to.properties[t];break;case E.WINDOW:delete e.$uo.properties[t];break;case E.RESOURCE:case E.LANGUAGE_OVERRIDABLE:delete e.$vo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,d={type:"object",description:k.localize(2,null),errorMessage:k.localize(3,null),$ref:e.$wo};this.w(o,d),e.$qo.properties[o]=d,e.$ro.properties[o]=d,e.$so.properties[o]=d,e.$to.properties[o]=d,e.$uo.properties[o]=d,e.$vo.properties[o]=d}}v(){const t={type:"object",description:k.localize(4,null),errorMessage:k.localize(5,null),$ref:e.$wo};e.$qo.patternProperties[e.$yo]=t,e.$ro.patternProperties[e.$yo]=t,e.$so.patternProperties[e.$yo]=t,e.$to.patternProperties[e.$yo]=t,e.$uo.patternProperties[e.$yo]=t,e.$vo.patternProperties[e.$yo]=t,this.i.fire()}w(t,o){const d=this.a.get(t);let i=d?.value,h=d?.source;S.$hg(i)&&(i=o.defaultDefaultValue,h=void 0),S.$hg(i)&&(i=g(o.type)),o.default=i,o.defaultValueSource=h}}const w="\\[([^\\]]+)\\]",a=new RegExp(w,"g");e.$yo=`^(${w})+$`,e.$zo=new RegExp(e.$yo);function f(l){const t=[];if(e.$zo.test(l)){let o=a.exec(l);for(;o?.length;){const d=o[1].trim();d&&t.push(d),o=a.exec(l)}}return(0,n.$Mb)(t)}function c(l){return l.reduce((t,o)=>`${t}[${o}]`,"")}function g(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const p=new $;v.$ko.add(e.$po.Configuration,p);function m(l,t){return l.trim()?e.$zo.test(l)?k.localize(7,null,l):p.getConfigurationProperties()[l]!==void 0?k.localize(8,null,l):t.policy?.name&&p.getPolicyConfigurations().get(t.policy?.name)!==void 0?k.localize(9,null,l,t.policy?.name,p.getPolicyConfigurations().get(t.policy?.name)):null:k.localize(6,null)}function b(){const l=[],t=p.getConfigurationProperties();for(const o of Object.keys(t))l.push([o,t[o].scope]);return l.push(["launch",E.RESOURCE]),l.push(["task",E.RESOURCE]),l}}),define(Se[128],De([1,0,18,6,44,2,26,21,11,4,27,46,16,38]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Jo=b;function a(d){return Object.isFrozen(d)?d:A.$$n(d)}class f{static createEmptyModel(i){return new f({},[],[],void 0,i)}constructor(i,h,u,D,I){this.b=i,this.c=h,this.d=u,this.raw=D,this.f=I,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(h=>{if(h instanceof f)return h;const u=new c("",this.f);return u.parseRaw(h),u.configurationModel});this.g=i.reduce((h,u)=>u===h?u:h.merge(u),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,E.$cj)(this.contents,i):this.contents}inspect(i,h){const u=this;return{get value(){return a(u.rawConfiguration.getValue(i))},get override(){return h?a(u.rawConfiguration.getOverrideValue(i,h)):void 0},get merged(){return a(h?u.rawConfiguration.override(h).getValue(i):u.rawConfiguration.getValue(i))},get overrides(){const D=[];for(const{contents:I,identifiers:T,keys:O}of u.rawConfiguration.overrides){const C=new f(I,O,[],void 0,u.f).getValue(i);C!==void 0&&D.push({identifiers:T,value:C})}return D.length?a(D):void 0}}}getOverrideValue(i,h){const u=this.j(h);return u?i?(0,E.$cj)(u,i):u:void 0}getKeysForOverrideIdentifier(i){const h=[];for(const u of this.overrides)u.identifiers.includes(i)&&h.push(...u.keys);return n.$Mb(h)}getAllOverrideIdentifiers(){const i=[];for(const h of this.overrides)i.push(...h.identifiers);return n.$Mb(i)}override(i){let h=this.a.get(i);return h||(h=this.h(i),this.a.set(i,h)),h}merge(...i){const h=A.$0n(this.contents),u=A.$0n(this.overrides),D=[...this.keys],I=this.raw?.length?[...this.raw]:[this];for(const T of i)if(I.push(...T.raw?.length?T.raw:[T]),!T.isEmpty()){this.i(h,T.contents);for(const O of T.overrides){const[C]=u.filter(P=>n.$ub(P.identifiers,O.identifiers));C?(this.i(C.contents,O.contents),C.keys.push(...O.keys),C.keys=n.$Mb(C.keys)):u.push(A.$0n(O))}for(const O of T.keys)D.indexOf(O)===-1&&D.push(O)}return new f(h,D,u,I.every(T=>T instanceof f)?void 0:I,this.f)}h(i){const h=this.j(i);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const u={};for(const D of n.$Mb([...Object.keys(this.contents),...Object.keys(h)])){let I=this.contents[D];const T=h[D];T&&(typeof I=="object"&&typeof T=="object"?(I=A.$0n(I),this.i(I,T)):I=T),u[D]=I}return new f(u,this.keys,this.overrides,void 0,this.f)}i(i,h){for(const u of Object.keys(h)){if(u in i&&v.$cg(i[u])&&v.$cg(h[u])){this.i(i[u],h[u]);continue}i[u]=A.$0n(h[u])}}j(i){let h=null,u=null;const D=I=>{I&&(u?this.i(u,I):u=A.$0n(I))};for(const I of this.overrides)I.identifiers.length===1&&I.identifiers[0]===i?h=I.contents:I.identifiers.includes(i)&&D(I.contents);return D(h),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,h){this.k(i,h,!0)}setValue(i,h){this.k(i,h,!1)}removeValue(i){const h=this.keys.indexOf(i);h!==-1&&(this.keys.splice(h,1),(0,E.$bj)(this.contents,i),y.$zo.test(i)&&this.overrides.splice(this.overrides.findIndex(u=>n.$ub(u.identifiers,(0,y.$Ao)(i))),1))}k(i,h,u){(0,E.$aj)(this.contents,i,h,D=>this.f.error(D)),u=u||this.keys.indexOf(i)===-1,u&&this.keys.push(i),y.$zo.test(i)&&this.overrides.push({identifiers:(0,y.$Ao)(i),keys:Object.keys(this.contents[i]),contents:(0,E.$_i)(this.contents[i],D=>this.f.error(D))})}}e.$Fo=f;class c{constructor(i,h){this.f=i,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,h){if(!v.$jg(i)){const u=this.h(i);this.parseRaw(u,h)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,h){this.a=i;const{contents:u,keys:D,overrides:I,restricted:T,hasExcludedProperties:O}=this.i(i,h);this.b=new f(u,D,I,O?[i]:void 0,this.g),this.c=T||[]}h(i){let h={},u=null,D=[];const I=[],T=[];function O(P){Array.isArray(D)?D.push(P):u!==null&&(D[u]=P)}const C={onObjectBegin:()=>{const P={};O(P),I.push(D),D=P,u=null},onObjectProperty:P=>{u=P},onObjectEnd:()=>{D=I.pop()},onArrayBegin:()=>{const P=[];O(P),I.push(D),D=P,u=null},onArrayEnd:()=>{D=I.pop()},onLiteralValue:O,onError:(P,Q,X)=>{T.push({error:P,offset:Q,length:X})}};if(i)try{S.$Xn(i,C),h=D[0]||{}}catch(P){this.g.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return h}i(i,h){const u=w.$ko.as(y.$po.Configuration).getConfigurationProperties(),D=this.j(i,u,!0,h);i=D.raw;const I=(0,E.$_i)(i,C=>this.g.error(`Conflict in settings file ${this.f}: ${C}`)),T=Object.keys(i),O=this.l(i,C=>this.g.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:I,keys:T,overrides:O,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(i,h,u,D){let I=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:I};const T={},O=[];for(const C in i)if(y.$zo.test(C)&&u){const P=this.j(i[C],h,!1,D);T[C]=P.raw,I=I||P.hasExcludedProperties,O.push(...P.restricted)}else{const P=h[C],Q=P?typeof P.scope<"u"?P.scope:y.ConfigurationScope.WINDOW:void 0;P?.restricted&&O.push(C),!D.exclude?.includes(C)&&(D.include?.includes(C)||(Q===void 0||D.scopes===void 0||D.scopes.includes(Q))&&!(D.skipRestricted&&P?.restricted))?T[C]=i[C]:I=!0}return{raw:T,restricted:O,hasExcludedProperties:I}}l(i,h){const u=[];for(const D of Object.keys(i))if(y.$zo.test(D)){const I={};for(const T in i[D])I[T]=i[D][T];u.push({identifiers:(0,y.$Ao)(D),keys:Object.keys(I),contents:(0,E.$_i)(I,h)})}return u}}e.$Go=c;class g extends k.$Uc{constructor(i,h,u,D,I){super(),this.c=i,this.f=h,this.g=D,this.h=I,this.b=this.B(new r.$he),this.onDidChange=this.b.event,this.a=new c(this.c.toString(),I),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(r.Event.any(r.Event.filter(this.g.onDidFilesChange,T=>T.contains(this.c)),r.Event.filter(this.g.onDidRunOperation,T=>(T.isOperation($.FileOperation.CREATE)||T.isOperation($.FileOperation.COPY)||T.isOperation($.FileOperation.DELETE)||T.isOperation($.FileOperation.WRITE))&&u.isEqual(T.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ho=g;class p{constructor(i,h,u,D,I,T,O,C,P,Q,X,ie,ne){this.a=i,this.b=h,this.c=u,this.overrideIdentifiers=D,this.d=I,this.f=T,this.g=O,this.h=C,this.i=P,this.j=Q,this.k=X,this.l=ie,this.m=ne}get value(){return a(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class m{constructor(i,h,u,D,I,T,O,C,P,Q){this.j=i,this.l=h,this.m=u,this.n=D,this.p=I,this.q=T,this.r=O,this.s=C,this.t=P,this.u=Q,this.h=null,this.i=new R.$Ac,this.v=null}getValue(i,h,u){return this.w(i,h,u).getValue(i)}updateValue(i,h,u={}){let D;u.resource?(D=this.t.get(u.resource),D||(D=f.createEmptyModel(this.u),this.t.set(u.resource,D))):D=this.s,h===void 0?D.removeValue(i):D.setValue(i,h),u.resource||(this.h=null)}inspect(i,h,u){const D=this.w(i,h,u),I=this.A(h.resource,u),T=h.resource?this.t.get(h.resource)||this.s:this.s,O=new Set;for(const C of D.overrides)for(const P of C.identifiers)D.getOverrideValue(i,P)!==void 0&&O.add(P);return new p(i,h,D.getValue(i),O.size?[...O]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.q:void 0,I||void 0,T)}keys(i){const h=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,h){this.r.set(i,h),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,h){const u=[];if(!h){const{added:D,updated:I,removed:T}=t(this.j,i);h=[...D,...I,...T]}for(const D of h)for(const I of(0,y.$Ao)(D)){const T=this.j.getKeysForOverrideIdentifier(I),O=i.getKeysForOverrideIdentifier(I),C=[...O.filter(P=>T.indexOf(P)===-1),...T.filter(P=>O.indexOf(P)===-1),...T.filter(P=>!A.$bo(this.j.override(I).getValue(P),i.override(I).getValue(P)))];u.push([I,C])}return this.updateDefaultConfiguration(i),{keys:h,overrides:u}}compareAndUpdatePolicyConfiguration(i){const{added:h,updated:u,removed:D}=t(this.l,i),I=[...h,...u,...D];return I.length&&this.updatePolicyConfiguration(i),{keys:I,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:h,updated:u,removed:D,overrides:I}=t(this.applicationConfiguration,i),T=[...h,...u,...D];return T.length&&this.updateApplicationConfiguration(i),{keys:T,overrides:I}}compareAndUpdateLocalUserConfiguration(i){const{added:h,updated:u,removed:D,overrides:I}=t(this.localUserConfiguration,i),T=[...h,...u,...D];return T.length&&this.updateLocalUserConfiguration(i),{keys:T,overrides:I}}compareAndUpdateRemoteUserConfiguration(i){const{added:h,updated:u,removed:D,overrides:I}=t(this.remoteUserConfiguration,i),T=[...h,...u,...D];return T.length&&this.updateRemoteUserConfiguration(i),{keys:T,overrides:I}}compareAndUpdateWorkspaceConfiguration(i){const{added:h,updated:u,removed:D,overrides:I}=t(this.workspaceConfiguration,i),T=[...h,...u,...D];return T.length&&this.updateWorkspaceConfiguration(i),{keys:T,overrides:I}}compareAndUpdateFolderConfiguration(i,h){const u=this.folderConfigurations.get(i),{added:D,updated:I,removed:T,overrides:O}=t(u,h),C=[...D,...I,...T];return(C.length||!u)&&this.updateFolderConfiguration(i,h),{keys:C,overrides:O}}compareAndDeleteFolderConfiguration(i){const h=this.folderConfigurations.get(i);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:u,updated:D,removed:I,overrides:T}=t(h,void 0);return{keys:[...u,...D,...I],overrides:T}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,h,u){let D=this.x(h,u);return h.overrideIdentifier&&(D=D.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(D=D.merge(this.l)),D}x({resource:i},h){let u=this.y();if(h&&i){const D=h.getFolder(i);D&&(u=this.z(D.uri)||u);const I=this.t.get(i);I&&(u=u.merge(I))}return u}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let h=this.i.get(i);if(!h){const u=this.y(),D=this.r.get(i);D?(h=u.merge(D),this.i.set(i,h)):h=u}return h}A(i,h){if(h&&i){const u=h.getFolder(i);if(u)return this.r.get(u.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,h)=>{const{contents:u,overrides:D,keys:I}=this.r.get(h);return i.push([h,{contents:u,overrides:D,keys:I}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(h=>i.add(h)),this.userConfiguration.keys.forEach(h=>i.add(h)),this.q.keys.forEach(h=>i.add(h)),this.r.forEach(h=>h.keys.forEach(u=>i.add(u))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>i.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>i.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>i.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(u=>i.add(u))),[...i.values()]}D(i){const h=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(u=>h.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>h.add(u)),this.q.getKeysForOverrideIdentifier(i).forEach(u=>h.add(u)),this.r.forEach(u=>u.getKeysForOverrideIdentifier(i).forEach(D=>h.add(D))),[...h.values()]}static parse(i,h){const u=this.E(i.defaults,h),D=this.E(i.policy,h),I=this.E(i.application,h),T=this.E(i.user,h),O=this.E(i.workspace,h),C=i.folders.reduce((P,Q)=>(P.set(s.URI.revive(Q[0]),this.E(Q[1],h)),P),new R.$Ac);return new m(u,D,I,T,f.createEmptyModel(h),O,C,f.createEmptyModel(h),new R.$Ac,h)}static E(i,h){return new f(i.contents,i.keys,i.overrides,void 0,h)}}e.$Io=m;function b(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const i=new Set,h=new Map;for(const D of d)D.keys.forEach(I=>i.add(I)),D.overrides.forEach(([I,T])=>{const O=(0,R.$xc)(h,I,new Set);T.forEach(C=>O.add(C))});const u=[];return h.forEach((D,I)=>u.push([I,[...D.values()]])),{keys:[...i.values()],overrides:u}}class l{constructor(i,h,u,D,I){this.change=i,this.f=h,this.g=u,this.h=D,this.i=I,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const T of i.keys)this.affectedKeys.add(T);for(const[,T]of i.overrides)for(const O of T)this.affectedKeys.add(O);this.d=this.a;for(const T of this.affectedKeys)this.d+=T+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=m.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,h){const u=this.a+i,D=this.d.indexOf(u);if(D<0)return!1;const I=D+u.length;if(I>=this.d.length)return!1;const T=this.d.charCodeAt(I);if(T!==this.b&&T!==this.c)return!1;if(h){const O=this.previousConfiguration?this.previousConfiguration.getValue(i,h,this.f?.workspace):void 0,C=this.g.getValue(i,h,this.h);return!A.$bo(O,C)}return!0}}e.$Ko=l;function t(d,i){const{added:h,removed:u,updated:D}=o(i?.rawConfiguration,d?.rawConfiguration),I=[],T=d?.getAllOverrideIdentifiers()||[],O=i?.getAllOverrideIdentifiers()||[];if(i){const C=O.filter(P=>!T.includes(P));for(const P of C)I.push([P,i.getKeysForOverrideIdentifier(P)])}if(d){const C=T.filter(P=>!O.includes(P));for(const P of C)I.push([P,d.getKeysForOverrideIdentifier(P)])}if(i&&d){for(const C of T)if(O.includes(C)){const P=o({contents:d.getOverrideValue(void 0,C)||{},keys:d.getKeysForOverrideIdentifier(C)},{contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)});I.push([C,[...P.added,...P.removed,...P.updated]])}}return{added:h,removed:u,updated:D,overrides:I}}function o(d,i){const h=d?i?d.keys.filter(I=>i.keys.indexOf(I)===-1):[...d.keys]:[],u=i?d?i.keys.filter(I=>d.keys.indexOf(I)===-1):[...i.keys]:[],D=[];if(d&&i){for(const I of i.keys)if(d.keys.indexOf(I)!==-1){const T=(0,E.$cj)(i.contents,I),O=(0,E.$cj)(d.contents,I);A.$bo(T,O)||D.push(I)}}return{added:h,removed:u,updated:D}}}),define(Se[261],De([1,0,18,6,2,21,11,128,46,12,73,38]),function(he,e,n,r,S,k,R,A,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=void 0;class $ extends S.$Uc{get configurationModel(){return this.b}constructor(c){super(),this.c=c,this.a=this.B(new r.$he),this.onDidChangeConfiguration=this.a.event,this.b=A.$Fo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(y.$ko.as(v.$po.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:g})=>this.f(Array.from(c),g))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(c,g){this.j(c,y.$ko.as(v.$po.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}g(){return{}}h(){this.b=A.$Fo.createEmptyModel(this.c);const c=y.$ko.as(v.$po.Configuration).getConfigurationProperties();this.j(Object.keys(c),c)}j(c,g){const p=this.g();for(const m of c){const b=p[m],l=g[m];b!==void 0?this.b.addValue(m,b):l?this.b.addValue(m,l.default):this.b.removeValue(m)}}}e.$Lo=$;class w{constructor(){this.onDidChangeConfiguration=r.Event.None,this.configurationModel=A.$Fo.createEmptyModel(new s.$hk)}async initialize(){return this.configurationModel}}e.$Mo=w;let a=class extends S.$Uc{get configurationModel(){return this.b}constructor(c,g,p){super(),this.c=c,this.f=g,this.g=p,this.a=this.B(new r.$he),this.onDidChangeConfiguration=this.a.event,this.b=A.$Fo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.j(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.m(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const g={},p=[],m=y.$ko.as(v.$po.Configuration).getConfigurationProperties();for(const b of c){const l=m[b];if(!l){p.push(b);continue}if(l.policy){if(l.type!=="string"&&l.type!=="number"){this.g.warn(`Policy ${l.policy.name} has unsupported type ${l.type}`);continue}p.push(b),g[l.policy.name]={type:l.type}}}return(0,R.$ng)(g)||await this.f.updatePolicyDefinitions(g),p}j(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const g=y.$ko.as(v.$po.Configuration).getPolicyConfigurations(),p=(0,n.$Hb)(c.map(m=>g.get(m)));this.m(p,!0)}m(c,g){this.g.trace("PolicyConfiguration#update",c);const p=y.$ko.as(v.$po.Configuration).getConfigurationProperties(),m=[],b=this.b.isEmpty();for(const l of c){const t=p[l]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(b?o!==void 0:!(0,k.$bo)(this.b.getValue(l),o))&&m.push([l,o])}else this.b.getValue(l)!==void 0&&m.push([l,void 0])}if(m.length){this.g.trace("PolicyConfiguration#changed",m);const l=this.b;this.b=A.$Fo.createEmptyModel(this.g);for(const t of l.keys)this.b.setValue(t,l.getValue(t));for(const[t,o]of m)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);g&&this.a.fire(this.b)}}};e.$No=a,e.$No=a=Ue([Ne(1,E.$mo),Ne(2,s.$7j)],a)}),define(Se[129],De([1,0,18,14,15,6,44,159,2,26,21,3,20,27,128,46,261,16,73]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=void 0;class m extends v.$Uc{constructor(t,o,d,i){super(),this.m=t,this.n=i,this.h=this.B(new k.$he),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new c.$Lo(i)),this.c=d instanceof p.$oo?new c.$Mo:this.B(new c.$No(this.b,d,i)),this.f=this.B(new a.$Ho(this.m,{},$.$5g,o,i)),this.a=new a.$Io(this.b.configurationModel,this.c.configurationModel,a.$Fo.createEmptyModel(i),a.$Fo.createEmptyModel(i),a.$Fo.createEmptyModel(i),a.$Fo.createEmptyModel(i),new s.$Ac,a.$Fo.createEmptyModel(i),new s.$Ac,i),this.j=new b(t,o,this),this.g=this.B(new r.$Mh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:h,properties:u})=>this.s(h,u))),this.B(this.c.onDidChangeConfiguration(h=>this.t(h))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[t,o,d]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new a.$Io(t,o,a.$Fo.createEmptyModel(this.n),d,a.$Fo.createEmptyModel(this.n),a.$Fo.createEmptyModel(this.n),new s.$Ac,a.$Fo.createEmptyModel(this.n),new s.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(t,o){const d=typeof t=="string"?t:void 0,i=(0,w.$8i)(t)?t:(0,w.$8i)(o)?o:{};return this.a.getValue(d,i,void 0)}async updateValue(t,o,d,i,h){const u=(0,w.$9i)(d)?d:(0,w.$8i)(d)?{resource:d.resource,overrideIdentifiers:d.overrideIdentifier?[d.overrideIdentifier]:void 0}:void 0,D=u?i:d;if(D!==void 0&&D!==w.ConfigurationTarget.USER_LOCAL&&D!==w.ConfigurationTarget.USER)throw new Error(`Unable to write ${t} to target ${D}.`);u?.overrideIdentifiers&&(u.overrideIdentifiers=(0,n.$Mb)(u.overrideIdentifiers),u.overrideIdentifiers=u.overrideIdentifiers.length?u.overrideIdentifiers:void 0);const I=this.inspect(t,{resource:u?.resource,overrideIdentifier:u?.overrideIdentifiers?u.overrideIdentifiers[0]:void 0});if(I.policyValue!==void 0)throw new Error(`Unable to write ${t} because it is configured in system policy.`);if((0,E.$bo)(o,I.defaultValue)&&(o=void 0),u?.overrideIdentifiers?.length&&u.overrideIdentifiers.length>1){const O=u.overrideIdentifiers.sort(),C=this.a.localUserConfiguration.overrides.find(P=>(0,n.$ub)([...P.identifiers].sort(),O));C&&(u.overrideIdentifiers=C.identifiers)}const T=u?.overrideIdentifiers?.length?[(0,f.$Bo)(u.overrideIdentifiers),t]:[t];await this.j.write(T,o),await this.reloadConfiguration()}inspect(t,o={}){return this.a.inspect(t,o,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const t=await this.f.loadConfiguration();this.r(t)}r(t){const o=this.a.toData(),d=this.a.compareAndUpdateLocalUserConfiguration(t);this.u(d,o,w.ConfigurationTarget.USER)}s(t,o){const d=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(t,o);this.u(i,d,w.ConfigurationTarget.DEFAULT)}t(t){const o=this.a.toData(),d=this.a.compareAndUpdatePolicyConfiguration(t);this.u(d,o,w.ConfigurationTarget.DEFAULT)}u(t,o,d){const i=new a.$Ko(t,{data:o},this.a,void 0,this.n);i.source=d,this.h.fire(i)}}e.$Oo=m;class b{constructor(t,o,d){this.b=t,this.c=o,this.d=d,this.a=new r.$Hh}write(t,o){return this.a.queue(()=>this.e(t,o))}async e(t,o){let d;try{d=(await this.c.readFile(this.b)).value.toString()}catch(u){if(u.fileOperationResult===g.FileOperationResult.FILE_NOT_FOUND)d="{}";else throw u}const i=[];if((0,R.$Qn)(d,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const h=this.f(d,t,o);d=(0,A.$9n)(d,h),await this.c.writeFile(this.b,S.$Je.fromString(d))}f(t,o,d){const{tabSize:i,insertSpaces:h,eol:u}=this.h;if(!o.length){const D=JSON.stringify(d,null,h?" ".repeat(i):"	");return[{content:D,length:D.length,offset:0}]}return(0,A.$6n)(t,o,d,{tabSize:i,insertSpaces:h,eol:u})}get h(){if(!this.g){let t=y.OS===y.OperatingSystem.Linux||y.OS===y.OperatingSystem.Macintosh?`
`:`\r
`;const o=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});o&&typeof o=="string"&&o!=="auto"&&(t=o),this.g={eol:t,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(Se[90],De([1,0,10,5]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=s,e.$Ll=(0,r.$Ai)("remoteAuthorityResolverService");var S;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class k{constructor(y){this.id=y,this.type=S.Managed}toString(){return`Managed(${this.id})`}}e.$Ml=k;class R{constructor(y,$){this.host=y,this.port=$,this.type=S.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=R;var A;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(A||(e.RemoteAuthorityResolverErrorCode=A={}));class v extends n.$bb{static isNotAvailable(y){return y instanceof v&&y._code===A.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof v&&y._code===A.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof v&&y._code===A.NoResolverFound}static isInvalidAuthority(y){return y instanceof v&&y._code===A.InvalidAuthority}static isHandled(y){return y instanceof v&&y.isHandled}constructor(y,$=A.Unknown,w){super(y),this._message=y,this._code=$,this._detail=w,this.isHandled=$===A.NotAvailable&&w===!0,Object.setPrototypeOf(this,v.prototype)}}e.$Ol=v;function s(E){const y=E.indexOf("+");return y===-1?E:E.substring(0,y)}}),define(Se[262],De([1,0,14,15,19,10,6,2,13,45,55,22,61,90]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ul=I,e.$Vl=T,e.$Wl=C;const a=30*1e3;var f;(function(ee){ee[ee.Management=1]="Management",ee[ee.ExtensionHost=2]="ExtensionHost",ee[ee.Tunnel=3]="Tunnel"})(f||(e.ConnectionType=f={}));function c(ee){switch(ee){case f.Management:return"Management";case f.ExtensionHost:return"ExtensionHost";case f.Tunnel:return"Tunnel"}}function g(ee){const H=new S.$se;return setTimeout(()=>H.cancel(),ee),H.token}function p(ee,H){if(ee.isCancellationRequested||H.isCancellationRequested)return S.CancellationToken.Cancelled;const L=new S.$se;return ee.onCancellationRequested(()=>L.cancel()),H.onCancellationRequested(()=>L.cancel()),L.token}class m{get didTimeout(){return this.c==="timedout"}constructor(H){this.c="pending",this.d=new A.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$th)(),H.isCancellationRequested?this.h():this.d.add(H.onCancellationRequested(()=>this.h()))}registerDisposable(H){this.c==="pending"?this.d.add(H):H.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const H=new Error("Time limit reached");return H.code="ETIMEDOUT",H.syscall="connect",H}resolve(H){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(H))}reject(H){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(H))}}function b(ee,H){const L=new m(H);return L.registerDisposable(ee.onControlMessage(V=>{const B=JSON.parse(V.toString()),U=z(B);U?L.reject(U):L.resolve(B)})),L.promise}function l(ee,H,L,V,B,U,K,Z){const j=new m(Z),G=E.$be.create(!1);return ee.info(`Creating a socket (${K})...`),s.mark(`code/willCreateSocket/${U}`),H.connect(L,V,B,K).then(se=>{j.didTimeout?(s.mark(`code/didCreateSocketError/${U}`),ee.info(`Creating a socket (${K}) finished after ${G.elapsed()} ms, but this is too late and has timed out already.`),se?.dispose()):(s.mark(`code/didCreateSocketOK/${U}`),ee.info(`Creating a socket (${K}) was successful after ${G.elapsed()} ms.`),j.resolve(se))},se=>{s.mark(`code/didCreateSocketError/${U}`),ee.info(`Creating a socket (${K}) returned an error after ${G.elapsed()} ms.`),ee.error(se),j.reject(se)}),j.promise}function t(ee,H){const L=new m(H);return ee.then(V=>{L.didTimeout||L.resolve(V)},V=>{L.didTimeout||L.reject(V)}),L.promise}async function o(ee,H,L,V){const B=W(ee,H);ee.logService.trace(`${B} 1/6. invoking socketFactory.connect().`);let U;try{U=await l(ee.logService,ee.remoteSocketFactoryService,ee.connectTo,v.$Ng.getServerRootPath(),`reconnectionToken=${ee.reconnectionToken}&reconnection=${ee.reconnectionProtocol?"true":"false"}`,c(H),`renderer-${c(H)}-${ee.reconnectionToken}`,V)}catch(se){throw ee.logService.error(`${B} socketFactory.connect() failed or timed out. Error:`),ee.logService.error(se),se}ee.logService.trace(`${B} 2/6. socketFactory.connect() was successful.`);let K,Z;ee.reconnectionProtocol?(ee.reconnectionProtocol.beginAcceptReconnection(U,null),K=ee.reconnectionProtocol,Z=!1):(K=new $.$oi({socket:U}),Z=!0),ee.logService.trace(`${B} 3/6. sending AuthRequest control message.`);const j=await t(ee.signService.createNewMessage((0,y.$Wg)()),V),G={type:"auth",auth:ee.connectionToken||"00000000000000000000",data:j.data};K.sendControl(r.$Je.fromString(JSON.stringify(G)));try{const se=await b(K,p(V,g(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const de=new Error("Unexpected handshake message");throw de.code="VSCODE_CONNECTION_ERROR",de}if(ee.logService.trace(`${B} 4/6. received SignRequest control message.`),!await t(ee.signService.validate(j,se.signedData),V)){const de=new Error("Refused to connect to unsupported server");throw de.code="VSCODE_CONNECTION_ERROR",de}const Ee=await t(ee.signService.sign(se.data),V),Le={type:"connectionType",commit:ee.commit,signedData:Ee,desiredConnectionType:H};return L&&(Le.args=L),ee.logService.trace(`${B} 5/6. sending ConnectionTypeRequest control message.`),K.sendControl(r.$Je.fromString(JSON.stringify(Le))),{protocol:K,ownsProtocol:Z}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(ee.logService.error(`${B} the handshake timed out. Error:`),ee.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(ee.logService.error(`${B} received error control message when negotiating connection. Error:`),ee.logService.error(se)),Z&&M(K),se}}async function d(ee,H,L,V){const B=Date.now(),U=W(ee,H),{protocol:K,ownsProtocol:Z}=await o(ee,H,L,V),j=new m(V);return j.registerDisposable(K.onControlMessage(G=>{const se=JSON.parse(G.toString()),fe=z(se);fe?(ee.logService.error(`${U} received error control message when negotiating connection. Error:`),ee.logService.error(fe),Z&&M(K),j.reject(fe)):(ee.reconnectionProtocol?.endAcceptReconnection(),ee.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${ae(B)}!`),j.resolve({protocol:K,firstMessage:se}))})),j.promise}async function i(ee,H){const{protocol:L}=await d(ee,f.Management,void 0,H);return{protocol:L}}async function h(ee,H,L){const{protocol:V,firstMessage:B}=await d(ee,f.ExtensionHost,H,L),U=B&&B.debugPort;return{protocol:V,debugPort:U}}async function u(ee,H,L){const V=Date.now(),B=W(ee,f.Tunnel),{protocol:U}=await o(ee,f.Tunnel,H,L);return ee.logService.trace(`${B} 6/6. handshake finished, connection is up and running after ${ae(V)}!`),U}async function D(ee,H,L){const{connectTo:V,connectionToken:B}=await ee.addressProvider.getAddress();return{commit:ee.commit,quality:ee.quality,connectTo:V,connectionToken:B,reconnectionToken:H,reconnectionProtocol:L,remoteSocketFactoryService:ee.remoteSocketFactoryService,signService:ee.signService,logService:ee.logService}}async function I(ee,H,L){return O(ee,async V=>{const{protocol:B}=await i(V,S.CancellationToken.None);return new te(ee,H,L,V.reconnectionToken,B)})}async function T(ee,H){return O(ee,async L=>{const{protocol:V,debugPort:B}=await h(L,H,S.CancellationToken.None);return new le(ee,H,L.reconnectionToken,V,B)})}async function O(ee,H){for(let V=1;;V++)try{const B=(0,y.$Wg)(),U=await D(ee,B,null);return await H(U)}catch(B){if(V<5)ee.logService.error(`[remote-connection][attempt ${V}] An error occurred in initial connection! Will retry... Error:`),ee.logService.error(B);else throw ee.logService.error(`[remote-connection][attempt ${V}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),ee.logService.error(B),q.triggerPermanentFailure(0,0,w.$Ol.isHandled(B)),B}}async function C(ee,H,L){const V=await D(ee,(0,y.$Wg)(),null);return await u(V,{host:H,port:L},S.CancellationToken.None)}function P(ee){return(0,n.$nh)(H=>new Promise((L,V)=>{const B=setTimeout(L,ee*1e3);H.onCancellationRequested(()=>{clearTimeout(B),L()})}))}var Q;(function(ee){ee[ee.ConnectionLost=0]="ConnectionLost",ee[ee.ReconnectionWait=1]="ReconnectionWait",ee[ee.ReconnectionRunning=2]="ReconnectionRunning",ee[ee.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",ee[ee.ConnectionGain=4]="ConnectionGain"})(Q||(e.PersistentConnectionEventType=Q={}));class X{constructor(H,L){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.type=Q.ConnectionLost}}e.$Xl=X;class ie{constructor(H,L,V,B){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.durationSeconds=V,this.c=B,this.type=Q.ReconnectionWait}skipWait(){this.c.cancel()}}e.$Yl=ie;class ne{constructor(H,L,V){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=V,this.type=Q.ReconnectionRunning}}e.$Zl=ne;class x{constructor(H,L,V){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=V,this.type=Q.ConnectionGain}}e.$1l=x;class re{constructor(H,L,V,B){this.reconnectionToken=H,this.millisSinceLastIncomingData=L,this.attempt=V,this.handled=B,this.type=Q.ReconnectionPermanentFailure}}e.$2l=re;class q extends A.$Uc{static triggerPermanentFailure(H,L,V){this._permanentFailure=!0,this.f=H,this.g=L,this.h=V,this.j.forEach(B=>B.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(H=>H.y())}static debugPauseSocketWriting(){this.j.forEach(H=>H.F())}get n(){return this.c||q._permanentFailure}constructor(H,L,V,B,U){super(),this.t=H,this.u=L,this.reconnectionToken=V,this.protocol=B,this.w=U,this.m=this.B(new R.$he),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new x(this.reconnectionToken,0,0)),this.B(B.onSocketClose(K=>{const Z=pe(this.t,this.reconnectionToken,!0);K?K.type===$.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${Z} received socket close event (hadError: ${K.hadError}).`),K.error&&this.u.logService.error(K.error)):(this.u.logService.info(`${Z} received socket close event (wasClean: ${K.wasClean}, code: ${K.code}, reason: ${K.reason}).`),K.event&&this.u.logService.error(K.event)):this.u.logService.info(`${Z} received socket close event.`),this.y()})),this.B(B.onSocketTimeout(K=>{const Z=pe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${Z} received socket timeout event (unacknowledgedMsgCount: ${K.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${K.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${K.timeSinceLastReceivedSomeData}).`),this.y()})),q.j.push(this),this.B((0,A.$Sc)(()=>{const K=q.j.indexOf(this);K>=0&&q.j.splice(K,1)})),this.n&&this.D(q.f,q.g,q.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const H=pe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${H} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new X(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const L=[0,5,5,10,10,10,10,10,30];let V=-1;do{V++;const B=V<L.length?L[V]:L[L.length-1];try{if(B>0){const K=P(B);this.m.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B,K)),this.u.logService.info(`${H} waiting for ${B} seconds before reconnecting...`);try{await K}catch{}}if(this.n){this.u.logService.error(`${H} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1)),this.u.logService.info(`${H} resolving connection...`);const U=await D(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${H} connecting to ${U.connectTo}...`),await this.G(U,g(a)),this.u.logService.info(`${H} reconnected!`),this.m.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${H} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(V>360){this.u.logService.error(`${H} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}if(w.$Ol.isTemporarilyNotAvailable(U)){this.u.logService.info(`${H} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this.u.logService.info(`${H} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(U);continue}if((0,k.$4)(U)){this.u.logService.info(`${H} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(U);continue}if(U instanceof w.$Ol){this.u.logService.error(`${H} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,w.$Ol.isHandled(U));break}this.u.logService.error(`${H} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(U),this.C(this.protocol.getMillisSinceLastIncomingData(),V+1,!1);break}}while(!this.n&&!this.s)}C(H,L,V){this.w?q.triggerPermanentFailure(H,L,V):this.D(H,L,V)}D(H,L,V){this.m.fire(new re(this.reconnectionToken,H,L,V)),M(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$3l=q,q._permanentFailure=!1,q.f=0,q.g=0,q.h=!1,q.j=[];class te extends q{constructor(H,L,V,B,U){super(f.Management,H,B,U,!0),this.client=this.B(new $.$mi(U,{remoteAuthority:L,clientId:V},H.ipcLogger))}async G(H,L){await i(H,L)}}e.$4l=te;class le extends q{constructor(H,L,V,B,U){super(f.ExtensionHost,H,V,B,!1),this.H=L,this.debugPort=U}async G(H,L){await h(H,this.H,L)}}e.$5l=le;function M(ee){try{ee.acceptDisconnect();const H=ee.getSocket();ee.dispose(),H.dispose()}catch(H){(0,k.$1)(H)}}function z(ee){if(ee&&ee.type==="error"){const H=new Error(`Connection error: ${ee.reason}`);return H.code="VSCODE_CONNECTION_ERROR",H}return null}function oe(ee,H){for(;ee.length<H;)ee+=" ";return ee}function ce(ee,H){return`[remote-connection][${oe(c(ee),13)}][${H.substr(0,5)}\u2026]`}function pe(ee,H,L){return`${ce(ee,H)}[${L?"reconnect":"initial"}]`}function W(ee,H){return`${pe(H,ee.reconnectionToken,!!ee.reconnectionProtocol)}[${ee.connectTo}]`}function ae(ee){return`${Date.now()-ee} ms`}}),define(Se[263],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rQ=e.$qQ=void 0,e.$qQ=(0,n.$Ai)("IRemoteExtensionsScannerService"),e.$rQ="remoteExtensionsScanner"}),define(Se[91],De([1,0,13]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=r,e.$Om=S,e.$Pm=k,e.$Qm=R;function r(v){return v.scheme===n.Schemas.vscodeRemote?v.authority:void 0}function S(v){if(!v)return;const s=v.indexOf("+");return s<0?v:v.substr(0,s)}function k(v){const{host:s,port:E}=A(v);if(typeof E>"u")throw new Error(`Invalid remote authority: ${v}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:s,port:E}}function R(v,s){let{host:E,port:y}=A(v);return typeof y>"u"&&(y=s),{host:E,port:y}}function A(v){const s=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(s)return{host:s[1],port:parseInt(s[2],10)};const E=v.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=v.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:v,port:void 0}}}),define(Se[23],De([1,0,17,5,91]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$Zm=e.$Ym=e.$Xm=e.TargetPlatform=e.ExtensionType=e.$Wm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0,e.$Vm=k,e.$1m=y,e.$2m=$,e.$3m=w,e.$4m=a,e.$Rm="extensions.user.cache",e.$Sm="extensions.builtin.cache",e.$Tm="undefined_publisher",e.$Um=["ui","workspace","web"];function k(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$Wm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R||(e.ExtensionType=R={}));var A;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class v{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,g){if(typeof c>"u"||c===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof c=="string"||typeof g=="string"){const p=typeof c=="string"?c:c.value,m=typeof g=="string"?g:g.value;return n.$Bf(p,m)}return c._lower===g._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$Xm=v;class s{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const g of c)this.add(g)}add(c){this.c.add(v.toKey(c))}delete(c){return this.c.delete(v.toKey(c))}has(c){return this.c.has(v.toKey(c))}}e.$Ym=s;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(v.toKey(c))}get(c){return this.c.get(v.toKey(c))}has(c){return this.c.has(v.toKey(c))}set(c,g){this.c.set(v.toKey(c),g)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Zm=E;function y(f){return $(f)}function $(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}function w(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}function a(f,c){if(c){const g=`onResolveRemoteAuthority:${(0,S.$Om)(c)}`;return!!f.activationEvents?.includes(g)}return!1}e.$5m=(0,r.$Ai)("IBuiltinExtensionsScannerService")}),define(Se[30],De([1,0,3,206,23,5]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.ExtensionManagementErrorCode=e.$dp=e.ExtensionGalleryErrorCode=e.$cp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0,e.$9o=A,e.$0o=v,e.$$o=s,e.$_o=E,e.$ap=y,e.$bp=$,e.$2o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3o=new RegExp(e.$2o),e.$4o="__web_extension",e.$5o="skipWalkthrough",e.$6o="extensionInstallSource",e.$7o="dependecyOrPackExtensionInstall",e.$8o="clientTargetPlatform";var R;(function(l){l.COMMAND="command",l.SETTINGS_SYNC="settingsSync"})(R||(e.ExtensionInstallSource=R={}));function A(l){switch(l){case S.TargetPlatform.WIN32_X64:return"Windows 64 bit";case S.TargetPlatform.WIN32_ARM64:return"Windows ARM";case S.TargetPlatform.LINUX_X64:return"Linux 64 bit";case S.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case S.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case S.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case S.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case S.TargetPlatform.DARWIN_X64:return"Mac";case S.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case S.TargetPlatform.WEB:return"Web";case S.TargetPlatform.UNIVERSAL:return S.TargetPlatform.UNIVERSAL;case S.TargetPlatform.UNKNOWN:return S.TargetPlatform.UNKNOWN;case S.TargetPlatform.UNDEFINED:return S.TargetPlatform.UNDEFINED}}function v(l){switch(l){case S.TargetPlatform.WIN32_X64:return S.TargetPlatform.WIN32_X64;case S.TargetPlatform.WIN32_ARM64:return S.TargetPlatform.WIN32_ARM64;case S.TargetPlatform.LINUX_X64:return S.TargetPlatform.LINUX_X64;case S.TargetPlatform.LINUX_ARM64:return S.TargetPlatform.LINUX_ARM64;case S.TargetPlatform.LINUX_ARMHF:return S.TargetPlatform.LINUX_ARMHF;case S.TargetPlatform.ALPINE_X64:return S.TargetPlatform.ALPINE_X64;case S.TargetPlatform.ALPINE_ARM64:return S.TargetPlatform.ALPINE_ARM64;case S.TargetPlatform.DARWIN_X64:return S.TargetPlatform.DARWIN_X64;case S.TargetPlatform.DARWIN_ARM64:return S.TargetPlatform.DARWIN_ARM64;case S.TargetPlatform.WEB:return S.TargetPlatform.WEB;case S.TargetPlatform.UNIVERSAL:return S.TargetPlatform.UNIVERSAL;default:return S.TargetPlatform.UNKNOWN}}function s(l,t){switch(l){case n.Platform.Windows:return t==="x64"?S.TargetPlatform.WIN32_X64:t==="arm64"?S.TargetPlatform.WIN32_ARM64:S.TargetPlatform.UNKNOWN;case n.Platform.Linux:return t==="x64"?S.TargetPlatform.LINUX_X64:t==="arm64"?S.TargetPlatform.LINUX_ARM64:t==="arm"?S.TargetPlatform.LINUX_ARMHF:S.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?S.TargetPlatform.ALPINE_X64:t==="arm64"?S.TargetPlatform.ALPINE_ARM64:S.TargetPlatform.UNKNOWN;case n.Platform.Mac:return t==="x64"?S.TargetPlatform.DARWIN_X64:t==="arm64"?S.TargetPlatform.DARWIN_ARM64:S.TargetPlatform.UNKNOWN;case n.Platform.Web:return S.TargetPlatform.WEB}}function E(l,t){return t===S.TargetPlatform.WEB&&!l.includes(S.TargetPlatform.WEB)}function y(l,t,o){return E(t,o)?!1:l===S.TargetPlatform.UNDEFINED||l===S.TargetPlatform.UNIVERSAL?!0:l===S.TargetPlatform.UNKNOWN?!1:l===o}function $(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}var w;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var a;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(a||(e.SortOrder=a={}));var f;(function(l){l.Install="install",l.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var c;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$cp=(0,k.$Ai)("extensionGalleryService");var g;(function(l){l.Timeout="Timeout",l.Cancelled="Cancelled",l.Failed="Failed",l.DownloadFailedWriting="DownloadFailedWriting"})(g||(e.ExtensionGalleryErrorCode=g={}));class p extends Error{constructor(t,o){super(t),this.code=o,this.name=o}}e.$dp=p;var m;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.DownloadSignature="DownloadSignature",l.DownloadFailedWriting="DownloadFailedWriting",l.UpdateMetadata="UpdateMetadata",l.Extract="Extract",l.Scanning="Scanning",l.ScanningExtension="ScanningExtension",l.ReadUninstalled="ReadUninstalled",l.UnsetUninstalled="UnsetUninstalled",l.Delete="Delete",l.Rename="Rename",l.IntializeDefaultProfile="IntializeDefaultProfile",l.AddToProfile="AddToProfile",l.InstalledExtensionNotFound="InstalledExtensionNotFound",l.PostInstall="PostInstall",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Signature="Signature",l.NotAllowed="NotAllowed",l.Gallery="Gallery",l.Cancelled="Cancelled",l.Unknown="Unknown",l.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));class b extends Error{constructor(t,o){super(t),this.code=o,this.name=o}}e.$ep=b,e.$fp=(0,k.$Ai)("extensionManagementService"),e.$gp="extensionsIdentifiers/disabled",e.$hp="extensionsIdentifiers/enabled",e.$ip=(0,k.$Ai)("IGlobalExtensionEnablementService"),e.$jp=(0,k.$Ai)("IExtensionTipsService"),e.$kp=(0,r.localize2)(0,"Extensions"),e.$lp=(0,r.localize2)(1,"Preferences")}),define(Se[264],De([1,0,6,2,21,4,59,30]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=e.$mq=void 0;function v(c,g){return c?k.URI.revive(g?g.transformIncoming(c):c):void 0}function s(c,g){return g?g.transformOutgoingURI(c):c}function E(c,g){g=g||R.$Fn;const p=c.manifest;return{...(0,R.$In)({...c,manifest:void 0},g),manifest:p}}function y(c,g){return c?.profileLocation?(0,R.$In)(c,g??R.$Fn):c}function $(c,g){return g?(0,S.$_n)(c,p=>p instanceof k.URI?g.transformOutgoingURI(p):void 0):c}class w{constructor(g,p){this.a=g,this.b=p,this.onInstallExtension=n.Event.buffer(g.onInstallExtension,!0),this.onDidInstallExtensions=n.Event.buffer(g.onDidInstallExtensions,!0),this.onUninstallExtension=n.Event.buffer(g.onUninstallExtension,!0),this.onDidUninstallExtension=n.Event.buffer(g.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=n.Event.buffer(g.onDidUpdateExtensionMetadata,!0)}listen(g,p){const m=this.b(g);switch(p){case"onInstallExtension":return n.Event.map(this.onInstallExtension,b=>({...b,profileLocation:b.profileLocation?s(b.profileLocation,m):b.profileLocation}));case"onDidInstallExtensions":return n.Event.map(this.onDidInstallExtensions,b=>b.map(l=>({...l,local:l.local?$(l.local,m):l.local,profileLocation:l.profileLocation?s(l.profileLocation,m):l.profileLocation})));case"onUninstallExtension":return n.Event.map(this.onUninstallExtension,b=>({...b,profileLocation:b.profileLocation?s(b.profileLocation,m):b.profileLocation}));case"onDidUninstallExtension":return n.Event.map(this.onDidUninstallExtension,b=>({...b,profileLocation:b.profileLocation?s(b.profileLocation,m):b.profileLocation}));case"onDidUpdateExtensionMetadata":return n.Event.map(this.onDidUpdateExtensionMetadata,b=>$(b,m))}throw new Error("Invalid listen")}async call(g,p,m){const b=this.b(g);switch(p){case"zip":{const l=E(m[0],b),t=await this.a.zip(l);return s(t,b)}case"unzip":return this.a.unzip(v(m[0],b));case"install":return this.a.install(v(m[0],b),y(m[1],b));case"installFromLocation":return this.a.installFromLocation(v(m[0],b),v(m[1],b));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(m[0],v(m[1],b),v(m[2],b));case"getManifest":return this.a.getManifest(v(m[0],b));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(m[0]);case"installFromGallery":return this.a.installFromGallery(m[0],y(m[1],b));case"installGalleryExtensions":{const l=m[0];return this.a.installGalleryExtensions(l.map(({extension:t,options:o})=>({extension:t,options:y(o,b)??{}})))}case"uninstall":return this.a.uninstall(E(m[0],b),y(m[1],b));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(m[0],b));case"getInstalled":return(await this.a.getInstalled(m[0],v(m[1],b),m[2])).map(t=>$(t,b));case"toggleAppliationScope":{const l=await this.a.toggleAppliationScope(E(m[0],b),v(m[1],b));return $(l,b)}case"copyExtensions":return this.a.copyExtensions(v(m[0],b),v(m[1],b));case"updateMetadata":{const l=await this.a.updateMetadata(E(m[0],b),m[1],v(m[2],b));return $(l,b)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(m[0],m[1],m[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$mq=w;class a extends r.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(g){super(),this.m=g,this.c=this.B(new n.$he),this.f=this.B(new n.$he),this.g=this.B(new n.$he),this.h=this.B(new n.$he),this.j=this.B(new n.$he),this.B(this.m.listen("onInstallExtension")(p=>this.n(this.c,{...p,source:this.r(p.source)?k.URI.revive(p.source):p.source,profileLocation:k.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(p=>this.n(this.f,p.map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?k.URI.revive(m.source):m.source,profileLocation:k.URI.revive(m.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(p=>this.n(this.g,{...p,profileLocation:k.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(p=>this.n(this.h,{...p,profileLocation:k.URI.revive(p.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(p=>this.j.fire(E(p,null))))}n(g,p){g.fire(p)}r(g){return g?typeof g.path=="string"&&typeof g.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(g){const p=await this.getTargetPlatform();return g.allTargetPlatforms.some(m=>(0,A.$ap)(m,g.allTargetPlatforms,p))}zip(g){return Promise.resolve(this.m.call("zip",[g]).then(p=>k.URI.revive(p)))}unzip(g){return Promise.resolve(this.m.call("unzip",[g]))}install(g,p){return Promise.resolve(this.m.call("install",[g,p])).then(m=>E(m,null))}installFromLocation(g,p){return Promise.resolve(this.m.call("installFromLocation",[g,p])).then(m=>E(m,null))}async installExtensionsFromProfile(g,p,m){return(await this.m.call("installExtensionsFromProfile",[g,p,m])).map(l=>E(l,null))}getManifest(g){return Promise.resolve(this.m.call("getManifest",[g]))}installFromGallery(g,p){return Promise.resolve(this.m.call("installFromGallery",[g,p])).then(m=>E(m,null))}async installGalleryExtensions(g){return(await this.m.call("installGalleryExtensions",[g])).map(m=>({...m,local:m.local?E(m.local,null):m.local,source:this.r(m.source)?k.URI.revive(m.source):m.source,profileLocation:k.URI.revive(m.profileLocation)}))}uninstall(g,p){if(g.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[g,p]))}reinstallFromGallery(g){return Promise.resolve(this.m.call("reinstallFromGallery",[g])).then(p=>E(p,null))}getInstalled(g=null,p,m){return Promise.resolve(this.m.call("getInstalled",[g,p,m])).then(b=>b.map(l=>E(l,null)))}updateMetadata(g,p,m){return Promise.resolve(this.m.call("updateMetadata",[g,p,m])).then(b=>E(b,null))}toggleAppliationScope(g,p){return this.m.call("toggleAppliationScope",[g,p]).then(m=>E(m,null))}copyExtensions(g,p){return this.m.call("copyExtensions",[g,p])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(g,p,m){const b=await this.m.call("download",[g,p,m]);return k.URI.revive(b)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$nq=a;class f{constructor(g){this.a=g}listen(g,p){throw new Error("Invalid listen")}call(g,p,m){switch(p){case"getConfigBasedTips":return this.a.getConfigBasedTips(k.URI.revive(m[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$oq=f}),define(Se[130],De([1,0,10,23]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AG=e.$zG=void 0;class S{constructor(){this.a=new Map,this.b=new WeakMap}register(R,A){this.a.set(R,A)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const A=Object.create(null);for(const v of R){const s=this.readActivationEvents(v);s.length>0&&(A[r.$Xm.toKey(v.identifier)]=s)}return A}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const A=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let v=0;v<A.length;v++)A[v]==="onUri"&&(A[v]=`onUri:${r.$Xm.toKey(R.identifier)}`);if(!R.contributes)return A;for(const v in R.contributes){const s=this.a.get(v);if(!s)continue;const E=R.contributes[v],y=Array.isArray(E)?E:[E];try{s(y,A)}catch($){(0,n.$1)($)}}return A}}e.$zG=S,e.$AG=new S}),define(Se[265],De([1,0,2,23,16]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=void 0;class k extends n.$Uc{constructor(A,v,s,E,y){super(),this.a=A,this.b=v,this.c=s,this.f=y,this.B(E.onDidInstallExtensions($=>this.g($))),this.B(E.onDidUninstallExtension($=>this.h($)))}g(A){for(const v of A)v.local&&this.invalidate(v.profileLocation)}h(A){A.error||this.invalidate(A.profileLocation)}async invalidate(A){if(A)for(const v of this.a.profiles)this.c.extUri.isEqual(v.extensionsResource,A)&&await this.j(v);else await this.j(this.a.defaultProfile)}async j(A){try{await this.b.del(this.c.extUri.joinPath(A.cacheHome,r.$Rm))}catch(v){(0,S.$ll)(v)!==S.FileOperationResult.FILE_NOT_FOUND&&this.f.error(v)}}}e.$Lq=k}),define(Se[92],De([1,0,19,2,3,217,30,5]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=void 0,e.$Zr=v;function v(E){return E.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$1r=(0,A.$Ai)("languagePackService");let s=class extends r.$Uc{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new n.$se;setTimeout(()=>y.cancel(),1e3);let $;try{$=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const a=$.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(c=>c.startsWith("lp-"))).map(f=>{const c=f.properties.localizedLanguages?.[0],g=v(f);return{...this.f(g,c,f),extensionId:f.identifier.id,galleryExtension:f}});return a.push(this.f("en","English")),a}f(y,$,w){const a=$??y;let f;if(a!==y&&(f=`(${y})`),y.toLowerCase()===S.$q.toLowerCase()&&(f??(f=""),f+=(0,k.localize)(0,null)),w?.installCount){f??(f="");const c=w.installCount;let g;c>1e6?g=`${Math.floor(c/1e5)/10}M`:c>1e3?g=`${Math.floor(c/1e3)}K`:g=String(c),f+=` $(cloud-download) ${g}`}return{id:y,label:a,description:f}}};e.$2r=s,e.$2r=s=Ue([Ne(0,R.$cp)],s)}),define(Se[47],De([1,0,15,10,2,220,46,5,12,38]),function(he,e,n,r,S,k,R,A,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0,e.$Yp=$,e.$Zp=w,e.$1p=a,e.$2p=f,e.$3p=c,e.$4p=g,e.$Wp=(0,A.$Ai)("requestService");class E{constructor(l){this.b=l}toJSON(){if(!this.a){const l=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?l[t]="*****":l[t]=this.b[t];this.a=l}return this.a}}class y extends S.$Uc{constructor(l){super(),this.b=0,this.a=l.createLogger("network",{name:(0,k.localize)(0,null),when:v.$mk.isEqualTo((0,v.$jk)(v.LogLevel.Trace)).serialize()})}async c(l,t,o){const d=`${l} #${++this.b}: ${t.url}`;this.a.trace(`${d} - begin`,t.type,new E(t.headers??{}));try{const i=await o();return this.a.trace(`${d} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${d} - error`,t.type,(0,r.$0)(i)),i}}}e.$Xp=y;function $(b){return b.res.statusCode&&b.res.statusCode>=200&&b.res.statusCode<300||b.res.statusCode===1223}function w(b){return b.res.statusCode===204}async function a(b){return w(b)?null:(await(0,n.$Ve)(b.stream)).toString()}async function f(b){if(!$(b))throw new Error("Server returned "+b.res.statusCode);return a(b)}async function c(b){if(!$(b))throw new Error("Server returned "+b.res.statusCode);if(w(b))return null;const t=(await(0,n.$Ve)(b.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}function g(b){m(b)}let p;function m(b){const l=s.$ko.as(R.$po.Configuration),t=p;p={id:"http",order:15,title:(0,k.localize)(1,null),type:"object",scope:b,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(6,null),(0,k.localize)(7,null),(0,k.localize)(8,null),(0,k.localize)(9,null)],default:"override",description:(0,k.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(12,null),restricted:!0}}},l.updateConfigurations({add:[p],remove:t?[t]:[]})}m(R.ConfigurationScope.APPLICATION)}),define(Se[266],De([1,0,19,13,16,47]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=void 0;let R=class{constructor(v,s){this.a=v,this.b=s}async download(v,s,E=n.CancellationToken.None){if(v.scheme===r.Schemas.file||v.scheme===r.Schemas.vscodeRemote){await this.b.copy(v,s);return}const y={type:"GET",url:v.toString(!0)},$=await this.a.request(y,E);if($.res.statusCode===200)await this.b.writeFile(s,$.stream);else{const w=await(0,k.$2p)($);throw new Error(`Expected 200, got back ${$.res.statusCode} instead.

${w}`)}}};e.$HQ=R,e.$HQ=R=Ue([Ne(0,k.$Wp),Ne(1,S.$7k)],R)}),define(Se[267],De([1,0,15,19]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=void 0;class S{constructor(A){this.a=A}listen(A,v){throw new Error("Invalid listen")}call(A,v,s,E=r.CancellationToken.None){switch(v){case"request":return this.a.request(s[0],E).then(async({res:y,stream:$})=>{const w=await(0,n.$Ve)($);return[{statusCode:y.statusCode,headers:y.headers},w]});case"resolveProxy":return this.a.resolveProxy(s[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$4r=S;class k{constructor(A){this.a=A}async request(A,v){const[s,E]=await this.a.call("request",[A],v);return{res:s,stream:(0,n.$Xe)(E)}}async resolveProxy(A){return this.a.call("resolveProxy",[A])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$5r=k}),define(Se[268],De([1,0,93,11]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=k;function S(R,A){return R.protocol==="http:"?A.HTTP_PROXY||A.http_proxy||null:R.protocol==="https:"&&(A.HTTPS_PROXY||A.https_proxy||A.HTTP_PROXY||A.http_proxy)||null}async function k(R,A,v={}){const s=(0,n.parse)(R),E=v.proxyUrl||S(s,A);if(!E)return null;const y=(0,n.parse)(E);if(!/^https?:$/.test(y.protocol||""))return null;const $={host:y.hostname||"",port:(y.port?+y.port:0)||(y.protocol==="https"?443:80),auth:y.auth,rejectUnauthorized:(0,r.$gg)(v.strictSSL)?v.strictSSL:!0,keepAlive:!0};return s.protocol==="http:"?new(await new Promise((w,a)=>{he(["http-proxy-agent"],w,a)})).HttpProxyAgent(E,$):new(await new Promise((w,a)=>{he(["https-proxy-agent"],w,a)})).HttpsProxyAgent(E,$)}}),define(Se[94],De([1,0,60,9,221,19,42,10,3,22,116,242,14,162]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=f;let a;async function f(g,p,m,b){return m["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):v.$c?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,y.$Gm)(b)&&!m["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,y.$Gm)(b)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),a||(a=$.Promises.withAsyncBody(async(l,t)=>{const o=new k.$se;let d=1e4;const i=g.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(d=(0,w.$Hm)(i,1,120)*1e3);const h=setTimeout(()=>{o.dispose(!0),t(new Error((0,S.localize)(0,null)))},d);try{l(await c(p,o.token))}catch(u){!(0,A.$4)(u)&&!o.token.isCancellationRequested?t(new Error((0,S.localize)(1,null,(0,R.$lj)(u)))):l({})}finally{clearTimeout(h),o.dispose()}})),a)}async function c(g,p){const m=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",m);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",b);const l=(0,s.$Wg)().replace(/-/g,"").substr(0,12),t=new RegExp(l+"({.*})"+l),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",o);const d=await(0,E.$wm)(v.OS,o);return g.trace("getUnixShellEnvironment#shell",d),new Promise((i,h)=>{if(p.isCancellationRequested)return h(new A.$5);const u=(0,r.$nc)(d);let D,I;const T="";/^pwsh(-preview)?$/.test(u)?(D=`& '${process.execPath}' ${T} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,I=["-Login","-Command"]):u==="nu"?(D=`^'${process.execPath}' ${T} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,I=["-i","-l","-c"]):u==="xonsh"?(D=`import os, json; print("${l}", json.dumps(dict(os.environ)), "${l}")`,I=["-i","-l","-c"]):(D=`'${process.execPath}' ${T} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,u==="tcsh"||u==="csh"?I=["-ic"]:I=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),D);const O=(0,n.spawn)(d,[...I,D],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});p.onCancellationRequested(()=>(O.kill(),h(new A.$5))),O.on("error",Q=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,R.$lj)(Q)),h(Q)});const C=[];O.stdout.on("data",Q=>C.push(Q));const P=[];O.stderr.on("data",Q=>P.push(Q)),O.on("close",(Q,X)=>{const ie=Buffer.concat(C).toString("utf8");g.trace("getUnixShellEnvironment#raw",ie);const ne=Buffer.concat(P).toString("utf8");if(ne.trim()&&g.trace("getUnixShellEnvironment#stderr",ne),Q||X)return h(new Error((0,S.localize)(2,null,Q,X)));const x=t.exec(ie),re=x?x[1]:"{}";try{const q=JSON.parse(re);m?q.ELECTRON_RUN_AS_NODE=m:delete q.ELECTRON_RUN_AS_NODE,b?q.ELECTRON_NO_ATTACH_CONSOLE=b:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.VSCODE_RESOLVING_ENVIRONMENT,delete q.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",q),i(q)}catch(q){g.error("getUnixShellEnvironment#errorCaught",(0,R.$lj)(q)),h(q)}})})}}),define(Se[269],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gQ=e.$fQ=void 0,e.$fQ=(0,n.$Ai)("stateReadService"),e.$gQ=(0,n.$Ai)("stateService")}),define(Se[270],De([1,0,14,15,2,11,28,16,12]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=e.$iQ=e.$hQ=e.SaveStrategy=void 0;var s;(function(w){w[w.IMMEDIATE=0]="IMMEDIATE",w[w.DELAYED=1]="DELAYED"})(s||(e.SaveStrategy=s={}));class E extends S.$Uc{constructor(a,f,c,g){super(),this.h=a,this.j=f,this.m=c,this.n=g,this.a=Object.create(null),this.b="",this.c=this.B(new n.$yh(this.j===s.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(a){a.fileOperationResult!==A.FileOperationResult.FILE_NOT_FOUND&&this.m.error(a)}}getItem(a,f){const c=this.a[a];return(0,k.$jg)(c)?f:c}setItem(a,f){this.setItems([{key:a,data:f}])}setItems(a){let f=!1;for(const{key:c,data:g}of a)this.a[c]!==g&&((0,k.$jg)(g)?(0,k.$hg)(this.a[c])||(this.a[c]=void 0,f=!0):(this.a[c]=g,f=!0));f&&this.s()}removeItem(a){(0,k.$hg)(this.a[a])||(this.a[a]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const a=JSON.stringify(this.a,null,4);if(a!==this.b)try{await this.n.writeFile(this.h,r.$Je.fromString(a),{atomic:{postfix:".vsctmp"}}),this.b=a}catch(f){this.m.error(f)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$hQ=E;let y=class extends S.$Uc{constructor(a,f,c,g){super(),this.a=this.B(new E(f.stateResource,a,c,g))}async init(){await this.a.init()}getItem(a,f){return this.a.getItem(a,f)}};e.$iQ=y,e.$iQ=y=Ue([Ne(1,R.$Hi),Ne(2,v.$7j),Ne(3,A.$7k)],y);class $ extends y{setItem(a,f){this.a.setItem(a,f)}setItems(a){this.a.setItems(a)}removeItem(a){this.a.removeItem(a)}close(){return this.a.close()}}e.$jQ=$}),define(Se[131],De([1,0,3,33,22]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=R,e.$np=A;function k(v){if(n.$o===n.Platform.Linux&&/^penguin(\.|$)/i.test(v))return"chromebook"}function R(v,s,E,y,$,w,a,f,c,g){const p=Object.create(null);p["common.machineId"]=w,p["common.sqmId"]=a,p["common.devDeviceId"]=f,p.sessionID=(0,S.$Wg)()+Date.now(),p.commitHash=y,p.version=$,p["common.platformVersion"]=(v||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,n.$b)(n.$o),p["common.nodePlatform"]=r.$dc,p["common.nodeArch"]=E,p["common.product"]=g||"desktop",c&&(p["common.msftInternal"]=c);let m=0;const b=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-b,enumerable:!0},"common.sequence":{get:()=>m++,enumerable:!0}}),n.$f&&(p["common.snap"]="true");const l=k(s);return l&&(p["common.platformDetail"]=l),p}function A(v){const s=r.env.USERDNSDOMAIN;if(!s)return!1;const E=s.toLowerCase();return v.some(y=>E===y)}}),define(Se[271],De([1,0,18,10,2,21,16]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var A;(function(s){function E(y,$){return y.callstack<$.callstack?-1:y.callstack>$.callstack?1:0}s.compare=E})(A||(e.ErrorEvent=A={}));class v{constructor(E,y=v.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new S.$Tc,this.c=E,this.d=y;const $=r.$X.addListener(w=>this.j(w));this.h.add((0,S.$Sc)($)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(E){if(!E||E.code||(E.detail&&E.detail.stack&&(E=E.detail),r.$bb.isErrorNoTelemetry(E)||E instanceof R.$pl||typeof E?.message=="string"&&E.message.includes("Unable to read file")))return;const y=Array.isArray(E.stack)?E.stack.join(`
`):E.stack,$=E.message?E.message:(0,k.$co)(E);y&&this.k({msg:$,callstack:y})}k(E){const y=(0,n.$wb)(this.g,E,A.compare);y<0?(E.count=1,this.g.splice(~y,0,E)):(this.g[y].count||(this.g[y].count=0),this.g[y].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const E of this.g)this.c.publicLogError2("UnhandledError",E);this.g.length=0}}v.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=v}),define(Se[24],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,n.$Ai)("telemetryService"),e.$7l=(0,n.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry.devDeviceId",e.$bm="telemetry",e.$cm="telemetry.telemetryLevel",e.$dm="telemetry.enableCrashReporter",e.$em="telemetry.enableTelemetry";var r;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(r||(e.TelemetryLevel=r={}));var S;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(Se[272],De([1,0,32,14,44,13,9,3,4,112,25,115,248,16,29,24]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Ns=g,e.$Os=m,e.$Ps=b;const c=new Map;async function g(t,o){const d=`${t}::${o.join(":")}`,i=c.get(d);if(i)return i;const h=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,D=new Map,I=2e4;function T(C,P,Q,X){const ie=P.substring(C.length+1);return r.Promises.withAsyncBody(async ne=>{let x;try{x=await E.Promises.readdir(P,{withFileTypes:!0})}catch{ne();return}if(X.count>=I){X.count+=x.length,X.maxReached=!0,ne();return}let re=x.length;if(re===0){ne();return}let q=x;X.count+x.length>I&&(X.maxReached=!0,re=I-X.count,q=x.slice(0,re)),X.count+=x.length;for(const te of q)if(te.isDirectory()){if(Q.includes(te.name)||await T(C,(0,R.$jc)(P,te.name),Q,X),--re===0){ne();return}}else{const le=te.name.lastIndexOf(".");if(le>=0){const M=te.name.substring(le+1);M&&u.set(M,(u.get(M)??0)+1)}for(const M of h)M.relativePathPattern?.test(ie)!==!1&&M.filePattern.test(te.name)&&D.set(M.tag,(D.get(M.tag)??0)+1);if(--re===0){ne();return}}})}const O=r.Promises.withAsyncBody(async C=>{const P={count:0,maxReached:!1};await T(t,t,o,P);const Q=await b(t);C({configFiles:p(D),fileTypes:p(u),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:Q})});return c.set(d,O),O}function p(t){return Array.from(t.entries(),([o,d])=>({name:o,count:d})).sort((o,d)=>d.count-o.count)}function m(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/w.$Cl.GB).toFixed(2)}GB (${(n.freemem()/w.$Cl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(s.$Kn.value()*100)}%`},o=n.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}async function b(t){try{const o=new Map,d=(0,R.$jc)(t,".vscode","launch.json"),i=await E.Promises.readFile(d),h=[],u=(0,S.$Qn)(i.toString(),h);if(h.length)return console.log(`Unable to parse ${d}`),[];if((0,S.$Zn)(u)==="object"&&u.configurations)for(const D of u.configurations){const I=D.type;I&&(o.has(I)?o.set(I,o.get(I)+1):o.set(I,1))}return p(o)}catch{return[]}}let l=class{constructor(o,d){this.c=o,this.d=d}f(o){const d=[];return d.push(`OS Version:       ${o.os}`),d.push(`CPUs:             ${o.cpus}`),d.push(`Memory (System):  ${o.memory}`),d.push(`VM:               ${o.vmHint}`),d.join(`
`)}g(o){const d=[];d.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),d.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&d.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),d.push(`Memory (System):  ${(n.totalmem()/w.$Cl.GB).toFixed(2)}GB (${(n.freemem()/w.$Cl.GB).toFixed(2)}GB free)`),A.$c||d.push(`Load (avg):       ${n.loadavg().map(h=>Math.round(h)).join(", ")}`),d.push(`VM:               ${Math.round(s.$Kn.value()*100)}%`),d.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),d.push(`Process Argv:     ${o.mainArguments.join(" ")}`),d.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),d.join(`
`)}async getPerformanceInfo(o,d){return Promise.all([(0,y.$Ms)(o.mainPID),this.k(o)]).then(async i=>{let[h,u]=i,D=this.m(o,h);return d.forEach(I=>{if((0,$.$kn)(I))D+=`
${I.errorMessage}`,u+=`
${I.errorMessage}`;else if(D+=`

Remote: ${I.hostName}`,I.processes&&(D+=`
${this.m(o,I.processes)}`),I.workspaceMetadata){u+=`
|  Remote: ${I.hostName}`;for(const T of Object.keys(I.workspaceMetadata)){const O=I.workspaceMetadata[T];let C=`${O.fileCount} files`;O.maxFilesReached&&(C=`more than ${C}`),u+=`|    Folder (${T}): ${C}`,u+=this.h(O)}}}),{processInfo:D,workspaceInfo:u}})}async getSystemInfo(o,d){const{memory:i,vmHint:h,os:u,cpus:D}=m(),I={os:u,memory:i,cpus:D,vmHint:h,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:d};return A.$c||(I.load=`${n.loadavg().map(T=>Math.round(T)).join(", ")}`),A.$e&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(o,d){const i=[];return(0,y.$Ms)(o.mainPID).then(async h=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,h)),o.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),d.forEach(u=>{if((0,$.$kn)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.f(u.machineInfo)),u.processes&&i.push(this.m(o,u.processes)),u.workspaceMetadata)for(const D of Object.keys(u.workspaceMetadata)){const I=u.workspaceMetadata[D];let T=`${I.fileCount} files`;I.maxFilesReached&&(T=`more than ${T}`),i.push(`Folder (${D}): ${T}`),i.push(this.h(I))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const d=[];let h=0;const u=(O,C)=>{const P=` ${O}(${C})`;h+P.length>60?(d.push(D),D="|                 ",h=D.length):h+=P.length,D+=P};let D="|      File types:";const I=10,T=o.fileTypes.length>I?I:o.fileTypes.length;for(let O=0;O<T;O++){const C=o.fileTypes[O];u(C.name,C.count)}if(d.push(D),o.configFiles.length>=0&&(D="|      Conf files:",h=0,o.configFiles.forEach(O=>{u(O.name,O.count)}),d.push(D)),o.launchConfigFiles.length>0){let O="|      Launch Configs:";o.launchConfigFiles.forEach(C=>{const P=C.count>1?` ${C.name}(${C.count})`:` ${C.name}`;O+=P}),d.push(O)}return d.join(`
`)}j(o){const d=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(d-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const d=[],i=[];return o.windows.forEach(h=>{h.folderURIs.length===0||h.remoteAuthority||(d.push(`|  Window (${h.title})`),h.folderURIs.forEach(u=>{const D=v.URI.revive(u);if(D.scheme===k.Schemas.file){const I=D.fsPath;i.push(g(I,["node_modules",".git"]).then(T=>{let O=`${T.fileCount} files`;T.maxFilesReached&&(O=`more than ${O}`),d.push(`|    Folder (${(0,R.$nc)(I)}): ${O}`),d.push(this.h(T))}).catch(T=>{d.push(`|      Error: Unable to collect workspace stats for folder ${I} (${T.toString()})`)}))}else d.push(`|    Folder (${D.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(h=>d.join(`
`)).catch(h=>`Unable to collect workspace stats: ${h}`)}m(o,d){const i=new Map;o.windows.forEach(u=>i.set(u.pid,`window [${u.id}] (${u.title})`)),o.pidToNames.forEach(({pid:u,name:D})=>i.set(u,D));const h=[];return h.push("CPU %	Mem MB	   PID	Process"),d&&this.n(o.mainPID,i,h,d,0),h.join(`
`)}n(o,d,i,h,u){const D=u===0;let I;D?I=h.pid===o?`${this.d.applicationName} main`:"remote agent":d.has(h.pid)?I=d.get(h.pid):I=`${"  ".repeat(u)} ${h.name}`;const T=process.platform==="win32"?h.mem:n.totalmem()*(h.mem/100);i.push(`${h.load.toFixed(0).padStart(5," ")}	${(T/w.$Cl.MB).toFixed(0).padStart(6," ")}	${h.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(h.children)&&h.children.forEach(O=>this.n(o,d,i,O,u+1))}async getWorkspaceFileExtensions(o){const d=new Set;for(const{uri:i}of o.folders){const h=v.URI.revive(i);if(h.scheme!==k.Schemas.file)continue;const u=h.fsPath;try{(await g(u,["node_modules",".git"])).fileTypes.forEach(I=>d.add(I.name))}catch{}}return{extensions:[...d]}}async reportWorkspaceStats(o){for(const{uri:d}of o.folders){const i=v.URI.revive(d);if(i.scheme!==k.Schemas.file)continue;const h=i.fsPath;try{const u=await g(h,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),u.fileTypes.forEach(D=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:D.name,count:D.count})}),u.launchConfigFiles.forEach(D=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:D.name,count:D.count})}),u.configFiles.forEach(D=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:D.name,count:D.count})})}catch{}}}};e.$Qs=l,e.$Qs=l=Ue([Ne(0,f.$6l),Ne(1,a.$nk)],l)}),define(Se[95],De([1,0,10,5,12,24]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.ExtensionSignatureVerificationCode=e.$iq=void 0,e.$iq=(0,r.$Ai)("IExtensionSignatureVerificationService");var R;(function(s){s.None="None",s.RequiredArgumentMissing="RequiredArgumentMissing",s.InvalidArgument="InvalidArgument",s.PackageIsUnreadable="PackageIsUnreadable",s.UnhandledException="UnhandledException",s.SignatureManifestIsMissing="SignatureManifestIsMissing",s.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",s.SignatureIsMissing="SignatureIsMissing",s.SignatureIsUnreadable="SignatureIsUnreadable",s.CertificateIsUnreadable="CertificateIsUnreadable",s.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",s.FileAlreadyExists="FileAlreadyExists",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",s.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",s.Success="Success",s.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",s.SignatureIsInvalid="SignatureIsInvalid",s.SignatureManifestIsInvalid="SignatureManifestIsInvalid",s.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",s.EntryIsMissing="EntryIsMissing",s.EntryIsTampered="EntryIsTampered",s.Untrusted="Untrusted",s.CertificateRevoked="CertificateRevoked",s.SignatureIsNotValid="SignatureIsNotValid",s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(R||(e.ExtensionSignatureVerificationCode=R={}));class A extends Error{constructor(E){super(E),this.code=E}}e.$jq=A;let v=class{constructor(E,y){this.b=E,this.c=y}d(){return this.a||(this.a=new Promise((E,y)=>he(["@vscode/vsce-sign"],async $=>E($),y))),this.a}async verify(E,y,$,w){let a;const f=E.identifier.id;try{a=await this.d()}catch(m){return this.b.error("Could not load vsce-sign module",(0,n.$0)(m)),this.b.info(`Extension signature verification is not done: ${f}`),!1}const c=new Date().getTime();let g;try{this.b.trace(`Verifying extension signature for ${f}...`),g=await a.verify(y,$,this.b.getLevel()===S.LogLevel.Trace)}catch(m){g={code:R.UnknownError,didExecute:!1,output:(0,n.$0)(m)}}const p=new Date().getTime()-c;if(this.b.info(`Extension signature verification result for ${f}: ${g.code}. Executed: ${g.didExecute}. Duration: ${p}ms.`),this.b.trace(`Extension signature verification output for ${f}:
${g.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:f,extensionVersion:E.version,code:g.code,internalCode:g.internalCode,duration:p,didExecute:g.didExecute,clientTargetPlatform:w}),g.code===R.Success)return!0;throw new A(g.code)}};e.$kq=v,e.$kq=v=Ue([Ne(0,S.$7j),Ne(1,k.$6l)],v)}),define(Se[273],De([1,0,2,24]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ys=void 0;class S extends n.$Uc{constructor(R,A){super(),this.a=R,this.b=A}async call(R,A,v){switch(A){case"updateTelemetryLevel":{const{telemetryLevel:s}=v;return this.a.updateInjectedTelemetryLevel(s)}case"logTelemetry":{const{eventName:s,data:E}=v;return this.b?this.b.log(s,E):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${A} not found`)}listen(R,A,v){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(r.TelemetryLevel.NONE),super.dispose()}}e.$Ys=S}),define(Se[41],De([1,0,21,11,91,131,24]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=void 0,e.$vp=E,e.$wp=y,e.$xp=$,e.$yp=w,e.$zp=f,e.$Ap=g,e.$Bp=p,e.$Cp=l;class A{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$op=A;class v{constructor(){this.telemetryLevel=R.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$pp=v,e.$qp=new v;class s{async publicLog(o,d,i){}async publicLogError(o,d,i){}}e.$rp=s,e.$sp="telemetry",e.$tp="extensionTelemetryLog",e.$up={log:()=>null,flush:()=>Promise.resolve(null)};function E(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}function y(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function $(t){const o=t.getValue(R.$cm),d=t.getValue(R.$dm);if(t.getValue(R.$em)===!1||d===!1)return R.TelemetryLevel.NONE;switch(o??R.TelemetryConfiguration.ON){case R.TelemetryConfiguration.ON:return R.TelemetryLevel.USAGE;case R.TelemetryConfiguration.ERROR:return R.TelemetryLevel.ERROR;case R.TelemetryConfiguration.CRASH:return R.TelemetryLevel.CRASH;case R.TelemetryConfiguration.OFF:return R.TelemetryLevel.NONE}}function w(t){const o={},d={},i={};c(t,i);for(let h in i){h=h.length>150?h.substr(h.length-149):h;const u=i[h];typeof u=="number"?d[h]=u:typeof u=="boolean"?d[h]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${u.length}`),o[h]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(o[h]=u)}return{properties:o,measurements:d}}const a=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(t){if(!t)return"none";const o=(0,S.$Om)(t);return a.has(o)?o:"other"}function c(t,o,d=0,i){if(t)for(const h of Object.getOwnPropertyNames(t)){const u=t[h],D=i?i+h:h;Array.isArray(u)?o[D]=(0,n.$co)(u):u instanceof Date?o[D]=u.toISOString():(0,r.$cg)(u)?d<2?c(u,o,d+1,D+"."):o[D]=(0,n.$co)(u):o[D]=u}}function g(t,o){const d=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,k.$np)(d)||i}function p(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function m(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let d=t;const i=[];for(const I of o)for(;;){const T=I.exec(t);if(!T)break;i.push([T.index,I.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(d="";;){const I=u.exec(t);if(!I)break;const T=i.some(([O,C])=>I.index<C&&O<u.lastIndex);!h.test(I[0])&&!T&&(d+=t.substring(D,I.index)+"<REDACTED: user-file-path>",D=u.lastIndex)}return D<t.length&&(d+=t.substr(D)),d}function b(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of o)if(d.regex.test(t))return`<REDACTED: ${d.label}>`;return t}function l(t,o){return(0,n.$_n)(t,d=>{if(d instanceof A||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let i=d.replaceAll("%20"," ");i=m(i,o);for(const h of o)i=i.replace(h,"");return i=b(i),i}})}}),define(Se[39],De([1,0,17,30,23,3,4,10,33,41]),function(he,e,n,r,S,k,R,A,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Ep=void 0,e.$Dp=E,e.$Fp=a,e.$Gp=f,e.$Hp=c,e.$Ip=g,e.$Jp=p,e.$Kp=m,e.$Lp=b,e.$Np=l,e.$Op=o;function E(d,i){return d.uuid&&i.uuid?d.uuid===i.uuid:d.id===i.id?!0:(0,n.$wf)(d.id,i.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(i){const h=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new $(i.identifier,h,u)}static parse(i){const h=y.exec(i);return h&&h[1]&&h[2]?new $({id:h[1]},h[2],h[4]||void 0):null}constructor(i,h,u=S.TargetPlatform.UNDEFINED){this.identifier=i,this.version=h,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==S.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof $?E(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$Ep=$;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function a(d){const i=w.exec(d);return i&&i[1]?[c(i[1]),i[2]]:[c(d),void 0]}function f(d,i){return`${d}.${i}`}function c(d){return d.toLowerCase()}function g(d,i){return c(f(d??S.$Tm,i))}function p(d,i){const h=[],u=D=>{for(const I of h)if(I.some(T=>E(i(T),i(D))))return I;return null};for(const D of d){const I=u(D);I?I.push(D):h.push([D])}return h}function m(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function b(d){return{id:new s.$op(d.identifier.id),name:new s.$op(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Mp=new S.$Xm("pprice.better-merge");function l(d,i){const h=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const D=u.shift();if(D&&h.every(I=>!E(I.identifier,{id:D}))){const I=d.filter(T=>E(T.identifier,{id:D}));I.length===1&&(h.push(I[0]),u.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function t(d,i){if(!k.$e)return!1;let h;try{h=(await d.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await d.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){i.debug("Error while getting the os-release file.",(0,A.$0)(D))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(d,i){const h=await t(d,i),u=(0,r.$$o)(h?"alpine":k.$o,v.$ec);return i.debug("ComputeTargetPlatform:",u),u}}),define(Se[132],De([1,0,19,10,13,20,62,4,207,30,39,23]),function(he,e,n,r,S,k,R,A,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;const $=f=>(0,v.localize)(0,null,f),w=(0,v.localize)(1,null,"ms-dotnettools.csharp");let a=class{constructor(c,g,p){this.a=c,this.b=g,this.d=p}get f(){}async listExtensions(c,g,p){let m=await this.b.getInstalled(y.ExtensionType.User,p);const b=y.$Wm.map(t=>t.toLowerCase());if(g&&g!==""){if(b.indexOf(g.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}m=m.filter(t=>t.manifest.categories?t.manifest.categories.map(d=>d.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){this.a.info("Possible Categories: "),b.forEach(t=>{this.a.info(t)});return}this.f&&this.a.info((0,v.localize)(2,null,this.f)),m=m.sort((t,o)=>t.identifier.id.localeCompare(o.identifier.id));let l;for(const t of m)l!==t.identifier.id&&(l=t.identifier.id,this.a.info(c?`${l}@${t.manifest.version}`:l))}async installExtensions(c,g,p,m){const b=[];try{c.length&&this.a.info(this.f?(0,v.localize)(3,null,this.f):(0,v.localize)(4,null));const l=[],t=[],o=(i,h,u)=>{t.push({id:i,version:h!=="prerelease"?h:void 0,installOptions:{...p,isBuiltin:u,installPreReleaseVersion:h==="prerelease"||p.installPreReleaseVersion}})};for(const i of c)if(i instanceof A.URI)l.push({vsix:i,installOptions:p});else{const[h,u]=(0,E.$Fp)(i);o(h,u,!1)}for(const i of g)if(i instanceof A.URI)l.push({vsix:i,installOptions:{...p,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[h,u]=(0,E.$Fp)(i);o(h,u,!0)}const d=await this.b.getInstalled(void 0,p.profileLocation);if(l.length&&await Promise.all(l.map(async({vsix:i,installOptions:h})=>{try{await this.h(i,h,m,d)}catch(u){this.a.error(u),b.push(i.toString())}})),t.length){const i=await this.g(t,d,m);b.push(...i)}}catch(l){throw this.a.error((0,v.localize)(5,null,(0,r.$0)(l))),l}if(b.length)throw new Error((0,v.localize)(6,null,b.join(", ")))}async updateExtensions(c){const g=await this.b.getInstalled(y.ExtensionType.User,c),p=[];for(const t of g)t.identifier.uuid&&p.push({...t.identifier,preRelease:t.preRelease});this.a.trace((0,v.localize)(7,null,p.length));const m=await this.d.getExtensions(p,{compatible:!0},n.CancellationToken.None),b=[];for(const t of m)for(const o of g)(0,E.$Dp)(o.identifier,t.identifier)&&(0,R.gt)(t.version,o.manifest.version)&&b.push({extension:t,options:{operation:s.InstallOperation.Update,installPreReleaseVersion:o.preRelease,profileLocation:c}});if(!b.length){this.a.info((0,v.localize)(8,null));return}this.a.info((0,v.localize)(9,null,b.map(t=>t.extension.identifier.id).join(", ")));const l=await this.b.installGalleryExtensions(b);for(const t of l)t.error?this.a.error((0,v.localize)(10,null,t.identifier.id,(0,r.$0)(t.error))):this.a.info((0,v.localize)(11,null,t.identifier.id,t.local?.manifest.version))}async g(c,g,p){if(c=c.filter(({id:t,version:o})=>{const d=g.find(i=>(0,E.$Dp)(i.identifier,{id:t}));if(d){if(!p&&(!o||o==="prerelease"&&d.preRelease))return this.a.info((0,v.localize)(12,null,t,d.manifest.version,t)),!1;if(o&&d.manifest.version===o)return this.a.info((0,v.localize)(13,null,`${t}@${o}`)),!1}return!0}),!c.length)return[];const m=[],b=[],l=await this.j(c);if(await Promise.all(c.map(async({id:t,version:o,installOptions:d})=>{const i=l.get(t.toLowerCase());if(!i){this.a.error(`${$(o?`${t}@${o}`:t)}
${w}`),m.push(t);return}try{const u=await this.d.getManifest(i,n.CancellationToken.None);if(u&&!this.k(u))return}catch(u){this.a.error(u.message||u.stack||u),m.push(t);return}const h=g.find(u=>(0,E.$Dp)(u.identifier,i.identifier));if(h){if(i.version===h.manifest.version){this.a.info((0,v.localize)(14,null,o?`${t}@${o}`:t));return}this.a.info((0,v.localize)(15,null,t,i.version))}d.isBuiltin?this.a.info(o?(0,v.localize)(16,null,t,o):(0,v.localize)(17,null,t)):this.a.info(o?(0,v.localize)(18,null,t,o):(0,v.localize)(19,null,t)),b.push({extension:i,options:{...d,installGivenVersion:!!o}})})),b.length){const t=await this.b.installGalleryExtensions(b);for(const o of t)o.error?(this.a.error((0,v.localize)(20,null,o.identifier.id,(0,r.$0)(o.error))),m.push(o.identifier.id)):this.a.info((0,v.localize)(21,null,o.identifier.id,o.local?.manifest.version))}return m}async h(c,g,p,m){const b=await this.b.getManifest(c);if(!b)throw new Error("Invalid vsix");if(await this.l(b,p,g.profileLocation,m))try{await this.b.install(c,g),this.a.info((0,v.localize)(22,null,(0,k.$$g)(c)))}catch(t){if((0,r.$4)(t))this.a.info((0,v.localize)(23,null,(0,k.$$g)(c)));else throw t}}async j(c){const g=new Map,p=c.some(l=>l.installOptions.installPreReleaseVersion),m=await this.b.getTargetPlatform(),b=[];for(const l of c)s.$3o.test(l.id)&&b.push({...l,preRelease:p});if(b.length){const l=await this.d.getExtensions(b,{targetPlatform:m},n.CancellationToken.None);for(const t of l)g.set(t.identifier.id.toLowerCase(),t)}return g}k(c){return!0}async l(c,g,p,m){if(!g){const b={id:(0,E.$Ip)(c.publisher,c.name)},l=m.find(t=>(0,E.$Dp)(b,t.identifier)&&(0,R.gt)(t.manifest.version,c.version));if(l)return this.a.info((0,v.localize)(24,null,l.identifier.id,l.manifest.version,c.version)),!1}return this.k(c)}async uninstallExtensions(c,g,p){const m=async l=>{if(l instanceof A.URI){const t=await this.b.getManifest(l);return(0,E.$Gp)(t.publisher,t.name)}return l},b=[];for(const l of c){const t=await m(l),d=(await this.b.getInstalled(void 0,p)).filter(i=>(0,E.$Dp)(i.identifier,{id:t}));if(!d.length)throw new Error(`${this.m(t)}
${w}`);if(d.some(i=>i.type===y.ExtensionType.System)){this.a.info((0,v.localize)(25,null,t));return}if(!g&&d.some(i=>i.isBuiltin)){this.a.info((0,v.localize)(26,null,t));return}this.a.info((0,v.localize)(27,null,t));for(const i of d)await this.b.uninstall(i,{profileLocation:p}),b.push(i);this.f?this.a.info((0,v.localize)(28,null,t,this.f)):this.a.info((0,v.localize)(29,null,t))}}async locateExtension(c){const g=await this.b.getInstalled();c.forEach(p=>{g.forEach(m=>{if(m.identifier.id===p&&m.location.scheme===S.Schemas.file){this.a.info(m.location.fsPath);return}})})}m(c){return this.f?(0,v.localize)(30,null,c,this.f):(0,v.localize)(31,null,c)}};e.$lq=a,e.$lq=a=Ue([Ne(1,s.$fp),Ne(2,s.$cp)],a)}),define(Se[274],De([1,0,6,2,26,39,23,16]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;class v extends r.$Uc{constructor(E,y,$,w,a,f,c){super(),this.f=E,this.g=y,this.h=$,this.j=w,this.m=a,this.n=f,this.r=c,this.a=this.B(new n.$he),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new r.$4c),this.s().then(null,g=>c.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(E=>this.u(E.added))),this.B(this.j.onAddExtensions(E=>this.w(E))),this.B(this.j.onDidAddExtensions(E=>this.y(E))),this.B(this.j.onRemoveExtensions(E=>this.z(E))),this.B(this.j.onDidRemoveExtensions(E=>this.C(E))),this.B(this.n.onDidFilesChange(E=>this.D(E)))}async u(E){try{E.length&&await Promise.all(E.map(y=>(this.c.set(y.id,(0,r.$Rc)(this.n.watch(this.m.extUri.dirname(y.extensionsResource)),this.n.watch(y.extensionsResource))),this.G(y.extensionsResource))))}catch(y){throw this.r.error(y),y}}async w(E){for(const y of E.extensions)this.I(this.L(y.identifier,y.version),E.profileLocation)}async y(E){for(const y of E.extensions){const $=this.L(y.identifier,y.version);E.error?this.J($,E.profileLocation):this.I($,E.profileLocation)}}async z(E){for(const y of E.extensions)this.J(this.L(y.identifier,y.version),E.profileLocation)}async C(E){const y=[],$=[];for(const w of E.extensions){const a=this.L(w.identifier,w.version);E.error?this.I(a,E.profileLocation):(this.J(a,E.profileLocation),this.b.has(a)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),$.push(this.f.scanInstalledExtensionAtLocation(w.location).then(f=>{f?y.push(f):this.r.info("Extension not found at the location",w.location.toString())},f=>this.r.error(f)))))}try{await Promise.all($),y.length&&await this.H(y)}catch(w){this.r.error(w)}}D(E){for(const y of this.h.profiles)E.contains(y.extensionsResource,A.FileChangeType.UPDATED,A.FileChangeType.ADDED)&&this.F(y.extensionsResource)}async F(E){const y=[],$=[],w=await this.j.scanProfileExtensions(E),a=new Set,f=new Set;for(const[c,g]of this.b)g.has(E)&&f.add(c);for(const c of w){const g=this.L(c.identifier,c.version);a.add(g),f.has(g)||(y.push(c.identifier),this.I(g,E))}for(const c of f)if(!a.has(c)){const g=this.M(c);g&&($.push(g.identifier),this.J(c,E))}(y.length||$.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:E}:void 0,removed:$.length?{extensions:$,profileLocation:E}:void 0})}async G(E){const y=await this.j.scanProfileExtensions(E);for(const $ of y)this.I(this.L($.identifier,$.version),E)}async H(E){E||(E=(await this.f.scanAllUserInstalledExtensions()).filter($=>!this.b.has(this.L($.identifier,$.manifest.version)))),E.length&&await this.f.markAsUninstalled(...E)}I(E,y){let $=this.b.get(E);$||this.b.set(E,$=new S.$Bc(w=>this.m.extUri.getComparisonKey(w))),$.add(y)}J(E,y){const $=this.b.get(E);$&&$.delete(y),$?.size||this.b.delete(E)}L(E,y){return`${R.$Xm.toKey(E.id)}@${y}`}M(E){const[y,$]=(0,k.$Fp)(E);return $?{identifier:{id:y},version:$}:void 0}}e.$Mq=v}),define(Se[133],De([1,0,96,18,14,2,13,9,25,28,30,39,12,92,4]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;let f=class extends w.$2r{constructor(m,b,l,t){super(l),this.h=m,this.j=t,this.g=this.B(new c(b,t)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(m,b){const t=(await this.g.getLanguagePacks())[b];if(!t){this.j.warn(`No language pack found for ${b}`);return}const o=t.translations[m];return o?a.URI.file(o):void 0}async getInstalledLanguages(){const m=await this.g.getLanguagePacks(),b=Object.keys(m).map(l=>{const t=m[l];return{...this.f(l,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return b.push(this.f("en","English")),b.sort((l,t)=>l.label.localeCompare(t.label)),b}async m(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",m.identifier.id),await this.update())}async n(m){const b=await this.g.getLanguagePacks();Object.keys(b).some(l=>b[l]&&b[l].extensions.some(t=>(0,y.$Dp)(t.extensionIdentifier,m.identifier)))&&(this.j.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,b]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(b);return!(0,r.$ub)(Object.keys(m),Object.keys(l))}};e.$3r=f,e.$3r=f=Ue([Ne(0,E.$fp),Ne(1,s.$Ii),Ne(2,E.$cp),Ne(3,$.$7j)],f);let c=class extends k.$Uc{constructor(m,b){super(),this.j=b,this.c={},this.f=(0,A.$jc)(m.userDataPath,"languagepacks.json"),this.g=new S.$Hh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(m){return this.s(b=>{Object.keys(b).forEach(l=>delete b[l]),this.m(b,...m)}).then(()=>this.c)}m(m,...b){for(const l of b)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(m,l);Object.keys(m).forEach(l=>this.r(m[l]))}n(m,b){const l=b.identifier,t=b.manifest.contributes&&b.manifest.contributes.localizations?b.manifest.contributes.localizations:[];for(const o of t)if(b.location.scheme===R.Schemas.file&&g(o)){let d=m[o.languageId];d||(d={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},m[o.languageId]=d);const i=d.extensions.filter(h=>(0,y.$Dp)(h.extensionIdentifier,l))[0];i?i.version=b.manifest.version:d.extensions.push({extensionIdentifier:l,version:b.manifest.version});for(const h of o.translations)d.translations[h.id]=(0,A.$jc)(b.location.fsPath,h.path)}}r(m){if(m){const b=(0,n.createHash)("md5");for(const l of m.extensions)b.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);m.hash=b.digest("hex")}}s(m=()=>null){return this.g.queue(()=>{let b=null;return v.Promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(b=m(l),l)).then(l=>{for(const o of Object.keys(l))l[o]||delete l[o];this.c=l,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),v.Promises.writeFile(this.f,t)}).then(()=>b,l=>this.j.error(l))})}};c=Ue([Ne(0,s.$Ii),Ne(1,$.$7j)],c);function g(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const m of p.translations)if(typeof m.id!="string"||typeof m.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(Se[275],De([1,0,175,10,21,41]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;const R="https://mobile.events.data.microsoft.com/OneCollector/1.0",A="https://mobile.events.data.microsoft.com/ping";async function v(E,y,$){const w=await(0,n.$hE)("@microsoft/1ds-core-js","dist/ms.core.js"),a=await(0,n.$hE)("@microsoft/1ds-post-js","dist/ms.post.js"),f=new w.AppInsightsCore,c=new a.PostChannel,g={instrumentationKey:E,endpointUrl:R,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[c]]};if($){g.extensionConfig={};const p={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:$};g.extensionConfig[c.identifier]=p}return f.initialize(g,[]),f.addTelemetryInitializer(p=>{p.ext=p.ext??{},p.ext.web=p.ext.web??{},p.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',y&&(p.ext.utc=p.ext.utc??{},p.ext.utc.flags=8462029)}),f}class s{constructor(y,$,w,a,f){this.e=y,this.f=$,this.g=w,this.h=f,this.c=R,this.d=A,this.g||(this.g={}),typeof a=="function"?this.a=a():this.a=a,this.b=null}i(y){if(this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=v(this.a,this.e,this.h)),this.b.then($=>{y($)},$=>{(0,r.$1)($),console.error($)})}}log(y,$){if(!this.a)return;$=(0,S.$ao)($,this.g),$=(0,k.$yp)($);const w=this.f+"/"+y;try{this.i(a=>{a.pluginVersionString=$?.properties.version??"Unknown",a.track({name:w,baseData:{name:w,properties:$?.properties,measurements:$?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i($=>{$.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.$bQ=s}),define(Se[276],De([1,0,2,21,3,17,222,27,46,63,29,38,24,41]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=void 0;let a=class{constructor(g,p,m){this.k=p,this.l=m,this.d={},this.i=new n.$Tc,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=$.TelemetryLevel.USAGE,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const b of this.f)this.j.push(new RegExp((0,k.$df)(b),"gi")),b.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$df)(b.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(b=>{(b.affectsConfiguration($.$cm)||b.affectsConfiguration($.$em)||b.affectsConfiguration($.$dm))&&this.m()}))}setExperimentProperty(g,p){this.d[g]=p}m(){let g=(0,w.$xp)(this.k);const p=this.l.enabledTelemetryLevels;if(p){this.h=this.sendErrorTelemetry?p.error:!1;const m=p.usage?$.TelemetryLevel.USAGE:p.error?$.TelemetryLevel.ERROR:$.TelemetryLevel.NONE;g=Math.min(g,m)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,p,m){this.g<p||(m=(0,r.$ao)(m,this.d),m=(0,w.$Cp)(m,this.j),m=(0,r.$ao)(m,this.c),this.b.forEach(b=>b.log(g,m)))}publicLog(g,p){this.n(g,$.TelemetryLevel.USAGE,p)}publicLog2(g,p){this.publicLog(g,p)}publicLogError(g,p){this.h&&this.n(g,$.TelemetryLevel.ERROR,p)}publicLogError2(g,p){this.publicLogError(g,p)}};e.$9r=a,a.IDLE_START_EVENT_NAME="UserIdleStart",a.IDLE_STOP_EVENT_NAME="UserIdleStop",e.$9r=a=Ue([Ne(1,A.$7i),Ne(2,E.$nk)],a);function f(){const c=(0,R.localize)(0,null,s.default.nameLong),g=s.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",s.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),p=S.$i?"":(0,R.localize)(3,null),m=(0,R.localize)(4,null),b=(0,R.localize)(5,null),l=(0,R.localize)(6,null),t=(0,R.localize)(7,null),o=`
|       | ${m} | ${b} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,d=(0,R.localize)(8,null);return`
${c} ${g} ${p}

&nbsp;

${t}
${o}

&nbsp;

${d}
`}y.$ko.as(v.$po.Configuration).registerConfiguration({id:$.$bm,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[$.$cm]:{type:"string",enum:[$.TelemetryConfiguration.ON,$.TelemetryConfiguration.ERROR,$.TelemetryConfiguration.CRASH,$.TelemetryConfiguration.OFF],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:f(),default:$.TelemetryConfiguration.ON,restricted:!0,scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),y.$ko.as(v.$po.Configuration).registerConfiguration({id:$.$bm,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[$.$em]:{type:"boolean",markdownDescription:s.default.privacyStatementUrl?(0,R.localize)(16,null,s.default.nameLong,s.default.privacyStatementUrl):(0,R.localize)(15,null,s.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${$.$cm}#\``),scope:v.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(Se[277],De([1,0,27,5,29,24,276,41]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.$Vs=void 0;let v=class extends R.$9r{constructor(E,y,$,w){super(E,$,w),this.o=y}publicLog(E,y){if(!(this.o<k.TelemetryLevel.USAGE))return super.publicLog(E,y)}publicLog2(E,y){return this.publicLog(E,y)}publicLogError(E,y){return this.o<k.TelemetryLevel.ERROR?Promise.resolve(void 0):super.publicLogError(E,y)}publicLogError2(E,y){return this.publicLogError(E,y)}async updateInjectedTelemetryLevel(E){if(E===void 0)throw this.o=k.TelemetryLevel.NONE,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,E):E,this.o===k.TelemetryLevel.NONE&&this.dispose()}};e.$Vs=v,e.$Vs=v=Ue([Ne(2,n.$7i),Ne(3,S.$nk)],v),e.$Ws=new class extends A.$pp{async updateInjectedTelemetryLevel(){}},e.$Xs=(0,r.$Bi)(k.$6l)}),define(Se[278],De([1,0,15,19,279,275]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cQ=void 0;async function R(E,y){const $=await y.request(E,r.CancellationToken.None),w=(await(0,n.$Ve)($.stream)).toString(),a=$.res.statusCode??200;return{headers:$.res.headers,statusCode:a,responseData:w}}async function A(E){const y={method:E.type,headers:E.headers};return new Promise((w,a)=>{const f=S.request(E.url??"",y,c=>{c.on("data",function(g){w({headers:c.headers,statusCode:c.statusCode??200,responseData:g.toString()})}),c.on("error",function(g){a(g)})});f.write(E.data,c=>{c&&a(c)}),f.end()})}async function v(E,y,$){const w=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),a={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:w};try{const f=E?await R(a,E):await A(a);$(f.statusCode,f.headers,f.responseData)}catch{$(0,{})}}class s extends k.$bQ{constructor(y,$,w,a,f){const c={sendPOST:(g,p)=>{v(y,g,p)}};super($,w,a,f,c)}}e.$cQ=s}),define(Se[280],De([1,0,10,271]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class S extends r.default{i(){(0,n.setUnexpectedErrorHandler)(A=>console.error(A));const R=[];process.on("unhandledRejection",(A,v)=>{R.push(v),setTimeout(()=>{const s=R.indexOf(v);s>=0&&v.catch(E=>{R.splice(s,1),(0,n.$4)(E)||(console.warn(`rejected promise not handled within 1 second: ${E}`),E.stack&&console.warn(`stack trace: ${E.stack}`),A&&(0,n.$1)(A))})},1e3)}),process.on("rejectionHandled",A=>{const v=R.indexOf(A);v>=0&&R.splice(v,1)}),process.on("uncaughtException",A=>{(0,n.$Z)(A)||(0,n.$1)(A)})}}e.default=S}),define(Se[134],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(r){r[r.Replace=1]="Replace",r[r.Append=2]="Append",r[r.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(Se[135],De([1,0,3,134]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;const S=new Map([[r.EnvironmentVariableMutatorType.Append,"APPEND"],[r.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[r.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class k{constructor(E){this.collections=E,this.a=new Map,this.b=new Map,E.forEach((y,$)=>{this.d(y,$);const w=y.map.entries();let a=w.next();for(;!a.done;){const f=a.value[1],c=a.value[0];let g=this.a.get(c);if(g||(g=[],this.a.set(c,g)),g.length>0&&g[0].type===r.EnvironmentVariableMutatorType.Replace){a=w.next();continue}const p={extensionIdentifier:$,value:f.value,type:f.type,scope:f.scope,variable:f.variable,options:f.options};p.scope||delete p.scope,g.unshift(p),a=w.next()}})}async applyToProcessEnvironment(E,y,$){let w;n.$c&&(w={},Object.keys(E).forEach(a=>w[a.toLowerCase()]=a));for(const[a,f]of this.getVariableMap(y)){const c=n.$c&&w[a.toLowerCase()]||a;for(const g of f){const p=$?await $(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case r.EnvironmentVariableMutatorType.Append:E[c]=(E[c]||"")+p;break;case r.EnvironmentVariableMutatorType.Prepend:E[c]=p+(E[c]||"");break;case r.EnvironmentVariableMutatorType.Replace:E[c]=p;break}if(g.options?.applyAtShellIntegration??!1){const m=`VSCODE_ENV_${S.get(g.type)}`;E[m]=(E[m]?E[m]+":":"")+a+"="+this.c(p)}}}}c(E){return E.replaceAll(":","\\x3a")}diff(E,y){const $=new Map,w=new Map,a=new Map;if(E.getVariableMap(y).forEach((f,c)=>{const g=this.getVariableMap(y).get(c),p=A(f,g);p&&$.set(c,p)}),this.getVariableMap(y).forEach((f,c)=>{const g=E.getVariableMap(y).get(c),p=A(f,g);p&&a.set(c,p)}),this.getVariableMap(y).forEach((f,c)=>{const g=E.getVariableMap(y).get(c),p=v(f,g);p&&w.set(c,p)}),!($.size===0&&w.size===0&&a.size===0))return{added:$,changed:w,removed:a}}getVariableMap(E){const y=new Map;for(const $ of this.a.values()){const w=$.filter(a=>R(a,E));w.length>0&&y.set(w[0].variable,w)}return y}getDescriptionMap(E){const y=new Map;for(const $ of this.b.values()){const w=$.filter(a=>R(a,E,!0));for(const a of w)y.set(a.extensionIdentifier,a.description)}return y}d(E,y){if(!E.descriptionMap)return;const $=E.descriptionMap.entries();let w=$.next();for(;!w.done;){const a=w.value[1],f=w.value[0];let c=this.b.get(f);c||(c=[],this.b.set(f,c));const g={extensionIdentifier:y,scope:a.scope,description:a.description};g.scope||delete g.scope,c.push(g),w=$.next()}}}e.$As=k;function R(s,E,y=!1){return s.scope?!!(s.scope.workspaceFolder&&E?.workspaceFolder&&s.scope.workspaceFolder.index===E.workspaceFolder.index):y?E===s.scope:!0}function A(s,E){if(!E)return s;const y=new Set;E.forEach(w=>y.add(w.extensionIdentifier));const $=[];return s.forEach(w=>{y.has(w.extensionIdentifier)||$.push(w)}),$.length===0?void 0:$}function v(s,E){if(!E)return;const y=new Map;E.forEach(w=>y.set(w.extensionIdentifier,w));const $=[];return s.forEach(w=>{const a=y.get(w.extensionIdentifier);a&&(w.type!==a.type||w.value!==a.value||w.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&$.push(a)}),$.length===0?void 0:$}}),define(Se[97],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=n,e.$vs=r,e.$ws=S,e.$xs=k,e.$ys=R,e.$zs=A;function n(v){return[...v.entries()]}function r(v){return v?[...v.entries()]:[]}function S(v){return new Map(v)}function k(v){return new Map(v??[])}function R(v){return Array.from(v.entries()).map(s=>[s[0],n(s[1].map),r(s[1].descriptionMap)])}function A(v){return new Map(v.map(s=>[s[0],{map:S(s[1]),descriptionMap:k(s[2])}]))}}),define(Se[281],De([1,0,14,19,6,2,12]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=void 0;let A=class extends k.$Uc{constructor(s,E){super(),this.h=E,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$he),this.onCreateRequest=this.g.event,this.b=s===void 0?15e3:s,this.B((0,k.$Sc)(()=>{for(const y of this.f.values())(0,k.$Pc)(y)}))}createRequest(s){return new Promise((E,y)=>{const $=++this.a;this.c.set($,E),this.g.fire({requestId:$,...s});const w=new r.$se;(0,n.$Bh)(this.b,w.token).then(()=>y(`Request ${$} timed out (${this.b}ms)`)),this.f.set($,[(0,k.$Sc)(()=>w.cancel())])})}acceptReply(s,E){const y=this.c.get(s);y?(this.c.delete(s),(0,k.$Pc)(this.f.get(s)||[]),this.f.delete(s),y(E)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${s}`)}};e.$ls=A,e.$ls=A=Ue([Ne(1,R.$7j)],A)}),define(Se[52],De([1,0,5,43,38]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$es=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ds=void 0,e.$ds=new r.$Rj("terminalTabFocusMode",!1,!0);var k;(function(l){l.AutomationProfile="terminal.integrated.automationProfile.",l.DefaultProfile="terminal.integrated.defaultProfile.",l.Profiles="terminal.integrated.profiles."})(k||(e.TerminalSettingPrefix=k={}));var R;(function(l){l.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",l.AutomationProfileLinux="terminal.integrated.automationProfile.linux",l.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",l.AutomationProfileWindows="terminal.integrated.automationProfile.windows",l.ProfilesWindows="terminal.integrated.profiles.windows",l.ProfilesMacOs="terminal.integrated.profiles.osx",l.ProfilesLinux="terminal.integrated.profiles.linux",l.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",l.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",l.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",l.UseWslProfiles="terminal.integrated.useWslProfiles",l.TabsDefaultColor="terminal.integrated.tabs.defaultColor",l.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",l.TabsEnabled="terminal.integrated.tabs.enabled",l.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",l.TabsHideCondition="terminal.integrated.tabs.hideCondition",l.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",l.TabsShowActions="terminal.integrated.tabs.showActions",l.TabsLocation="terminal.integrated.tabs.location",l.TabsFocusMode="terminal.integrated.tabs.focusMode",l.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",l.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",l.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",l.CopyOnSelection="terminal.integrated.copyOnSelection",l.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",l.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",l.FontFamily="terminal.integrated.fontFamily",l.FontSize="terminal.integrated.fontSize",l.LetterSpacing="terminal.integrated.letterSpacing",l.LineHeight="terminal.integrated.lineHeight",l.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",l.TabStopWidth="terminal.integrated.tabStopWidth",l.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",l.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",l.BellDuration="terminal.integrated.bellDuration",l.FontWeight="terminal.integrated.fontWeight",l.FontWeightBold="terminal.integrated.fontWeightBold",l.CursorBlinking="terminal.integrated.cursorBlinking",l.CursorStyle="terminal.integrated.cursorStyle",l.CursorStyleInactive="terminal.integrated.cursorStyleInactive",l.CursorWidth="terminal.integrated.cursorWidth",l.Scrollback="terminal.integrated.scrollback",l.DetectLocale="terminal.integrated.detectLocale",l.DefaultLocation="terminal.integrated.defaultLocation",l.GpuAcceleration="terminal.integrated.gpuAcceleration",l.TerminalTitleSeparator="terminal.integrated.tabs.separator",l.TerminalTitle="terminal.integrated.tabs.title",l.TerminalDescription="terminal.integrated.tabs.description",l.RightClickBehavior="terminal.integrated.rightClickBehavior",l.MiddleClickBehavior="terminal.integrated.middleClickBehavior",l.Cwd="terminal.integrated.cwd",l.ConfirmOnExit="terminal.integrated.confirmOnExit",l.ConfirmOnKill="terminal.integrated.confirmOnKill",l.EnableBell="terminal.integrated.enableBell",l.EnableVisualBell="terminal.integrated.enableVisualBell",l.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",l.AllowChords="terminal.integrated.allowChords",l.AllowMnemonics="terminal.integrated.allowMnemonics",l.TabFocusMode="terminal.integrated.tabFocusMode",l.EnvMacOs="terminal.integrated.env.osx",l.EnvLinux="terminal.integrated.env.linux",l.EnvWindows="terminal.integrated.env.windows",l.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",l.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",l.ShowExitAlert="terminal.integrated.showExitAlert",l.SplitCwd="terminal.integrated.splitCwd",l.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",l.WordSeparators="terminal.integrated.wordSeparators",l.EnableFileLinks="terminal.integrated.enableFileLinks",l.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",l.UnicodeVersion="terminal.integrated.unicodeVersion",l.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",l.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",l.HideOnStartup="terminal.integrated.hideOnStartup",l.CustomGlyphs="terminal.integrated.customGlyphs",l.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",l.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",l.InheritEnv="terminal.integrated.inheritEnv",l.ShowLinkHover="terminal.integrated.showLinkHover",l.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",l.AutoReplies="terminal.integrated.autoReplies",l.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",l.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",l.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",l.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",l.EnableImages="terminal.integrated.enableImages",l.SmoothScrolling="terminal.integrated.smoothScrolling",l.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",l.FocusAfterRun="terminal.integrated.focusAfterRun",l.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",l.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",l.DevMode="terminal.integrated.developer.devMode"})(R||(e.TerminalSettingId=R={}));var A;(function(l){l.PowerShell="pwsh",l.Bash="bash",l.Fish="fish",l.Sh="sh",l.Csh="csh",l.Ksh="ksh",l.Zsh="zsh",l.Python="python"})(A||(e.PosixShellType=A={}));var v;(function(l){l.CommandPrompt="cmd",l.PowerShell="pwsh",l.Wsl="wsl",l.GitBash="gitbash",l.Python="python"})(v||(e.WindowsShellType=v={}));var s;(function(l){l[l.Api=0]="Api",l[l.Process=1]="Process",l[l.Sequence=2]="Sequence",l[l.Config=3]="Config"})(s||(e.TitleEventSource=s={}));var E;(function(l){l.LocalPty="localPty",l.PtyHost="ptyHost",l.PtyHostWindow="ptyHostWindow",l.Logger="logger",l.Heartbeat="heartbeat"})(E||(e.TerminalIpcChannels=E={}));var y;(function(l){l.Cwd="cwd",l.InitialCwd="initialCwd",l.FixedDimensions="fixedDimensions",l.Title="title",l.ShellType="shellType",l.HasChildProcesses="hasChildProcesses",l.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",l.OverrideDimensions="overrideDimensions",l.FailedShellIntegrationActivation="failedShellIntegrationActivation",l.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$es=(0,n.$Ai)("ptyService");var $;(function(l){l[l.BeatInterval=5e3]="BeatInterval",l[l.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",l[l.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",l[l.SecondWaitMultiplier=1]="SecondWaitMultiplier",l[l.CreateProcessTimeout=5e3]="CreateProcessTimeout"})($||(e.HeartbeatConstants=$={}));var w;(function(l){l[l.Panel=1]="Panel",l[l.Editor=2]="Editor"})(w||(e.TerminalLocation=w={}));var a;(function(l){l.TerminalView="view",l.Editor="editor"})(a||(e.TerminalLocationString=a={}));var f;(function(l){l[l.GraceTime=6e4]="GraceTime",l[l.ShortGraceTime=6e3]="ShortGraceTime"})(f||(e.LocalReconnectConstants=f={}));var c;(function(l){l[l.HighWatermarkChars=1e5]="HighWatermarkChars",l[l.LowWatermarkChars=5e3]="LowWatermarkChars",l[l.CharCountAckSize=5e3]="CharCountAckSize"})(c||(e.FlowControlConstants=c={}));var g;(function(l){l.GitBash="Git Bash",l.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var p;(function(l){l[l.Off=0]="Off",l[l.FinalTerm=1]="FinalTerm",l[l.VSCode=2]="VSCode"})(p||(e.ShellIntegrationStatus=p={}));var m;(function(l){l[l.Unknown=0]="Unknown",l[l.Shutdown=1]="Shutdown",l[l.Process=2]="Process",l[l.User=3]="User",l[l.Extension=4]="Extension"})(m||(e.TerminalExitReason=m={})),e.$fs={Backend:"workbench.contributions.terminal.processBackend"};class b{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}S.$ko.add(e.$fs.Backend,new b),e.$gs=(0,n.$Ai)("localPtyService"),e.$hs=(0,n.$Ai)("terminalLogService")}),define(Se[136],De([1,0,3]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PP=r,e.$QP=S,e.$RP=k,e.$SP=R;function r(A){let v=A;v.includes("\\")&&(v=v.replace(/\\/g,"\\\\"));const s=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return v=v.replace(s,""),`'${v}'`}function S(A,v,s){if(!A)return"";if(!v)return A;v.match(/[\/\\]$/)&&(v=v.slice(0,v.length-1));const E=A.replace(/\\/g,"/").toLowerCase(),y=v.replace(/\\/g,"/").toLowerCase();return E.includes(y)?`~${s}${A.slice(v.length+1)}`:A}function k(A){return A.match(/^['"].*['"]$/)&&(A=A.substring(1,A.length-1)),n.OS===n.OperatingSystem.Windows&&A&&A[1]===":"?A[0].toUpperCase()+A.substring(1):A}function R(A){return!A.strictEnv}}),define(Se[282],De([1,0,57,4,224,81]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=R,e.$ns=s,e.$os=E,e.$ps=y;function R($,w){const a=[{name:null,description:(0,S.localize)(0,null)}];return a.push(...$.map(f=>({name:f.profileName,description:A(f)}))),w&&a.push(...w.map(f=>({name:f.title,description:v(f)}))),{values:a.map(f=>f.name),markdownDescriptions:a.map(f=>f.description)}}function A($){let w=`$(${k.ThemeIcon.isThemeIcon($.icon)?$.icon.id:$.icon?$.icon:n.$Zj.terminal.id}) ${$.profileName}
- path: ${$.path}`;return $.args&&(typeof $.args=="string"?w+=`
- args: "${$.args}"`:w+=`
- args: [${$.args.length===0?"":`'${$.args.join("','")}'`}]`),$.overrideName!==void 0&&(w+=`
- overrideName: ${$.overrideName}`),$.color&&(w+=`
- color: ${$.color}`),$.env&&(w+=`
- env: ${JSON.stringify($.env)}`),w}function v($){return`$(${k.ThemeIcon.isThemeIcon($.icon)?$.icon.id:$.icon?$.icon:n.$Zj.terminal.id}) ${$.title}
- extensionIdentifier: ${$.extensionIdentifier}`}function s($,w){if(!$&&!w)return!0;if(typeof $=="string"&&typeof w=="string")return $===w;if(Array.isArray($)&&Array.isArray(w)){if($.length!==w.length)return!1;for(let a=0;a<$.length;a++)if($[a]!==w[a])return!1;return!0}return!1}function E($,w){if(!$&&!w)return!0;if(!$||!w)return!1;if(k.ThemeIcon.isThemeIcon($)&&k.ThemeIcon.isThemeIcon(w))return $.id===w.id&&$.color===w.color;if(typeof $=="object"&&"light"in $&&"dark"in $&&typeof w=="object"&&"light"in w&&"dark"in w){const a=$,f=w;if((r.URI.isUri(a.light)||y(a.light))&&(r.URI.isUri(a.dark)||y(a.dark))&&(r.URI.isUri(f.light)||y(f.light))&&(r.URI.isUri(f.dark)||y(f.dark)))return a.light.path===f.light.path&&a.dark.path===f.dark.path}if(r.URI.isUri($)&&r.URI.isUri(w)||y($)||y(w)){const a=$,f=w;return a.path===f.path&&a.scheme===f.scheme}return!1}function y($){return $?typeof $.path=="string"&&typeof $.scheme=="string":!1}}),define(Se[283],De([1,0,57,3,223,46,38,52,282]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=void 0,e.$ss=a,e.$ts=c,e.$qs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$rs={type:"string",enum:Array.from((0,n.$Xj)(),g=>g.id),markdownEnumDescriptions:Array.from((0,n.$Xj)(),g=>`$(${g.id})`)};const s={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$rs},color:{description:(0,S.localize)(3,null),...e.$qs},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},E={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...s}},y={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...s}};function $(g){const p=g===r.Platform.Linux?"linux":g===r.Platform.Mac?"osx":"windows";return(0,S.localize)(7,null,(0,r.$b)(g),'```json\n"terminal.integrated.profile.'+p+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{[A.TerminalSettingId.AutomationProfileLinux]:{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.AutomationProfileMacOs]:{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.AutomationProfileWindows]:{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},[A.TerminalSettingId.ProfilesWindows]:{restricted:!0,markdownDescription:$(r.Platform.Windows),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...s}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...s}},{type:"null"},E]}},[A.TerminalSettingId.ProfilesMacOs]:{restricted:!0,markdownDescription:$(r.Platform.Mac),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...s}},{type:"null"},E]}},[A.TerminalSettingId.ProfilesLinux]:{restricted:!0,markdownDescription:$(r.Platform.Linux),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...s}},{type:"null"},E]}},[A.TerminalSettingId.UseWslProfiles]:{description:(0,S.localize)(22,null),type:"boolean",default:!0},[A.TerminalSettingId.InheritEnv]:{scope:k.ConfigurationScope.APPLICATION,description:(0,S.localize)(23,null),type:"boolean",default:!0},[A.TerminalSettingId.PersistentSessionScrollback]:{scope:k.ConfigurationScope.APPLICATION,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},[A.TerminalSettingId.ShowLinkHover]:{scope:k.ConfigurationScope.APPLICATION,description:(0,S.localize)(25,null),type:"boolean",default:!0},[A.TerminalSettingId.IgnoreProcessNames]:{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function a(){R.$ko.as(k.$po.Configuration).registerConfiguration(w),c()}let f;function c(g,p){const m=R.$ko.as(k.$po.Configuration);let b;g&&(b=(0,v.$ms)(g?.profiles,p));const l=f;f={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{[A.TerminalSettingId.DefaultProfileLinux]:{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:g?.os===r.OperatingSystem.Linux?b?.values:void 0,markdownEnumDescriptions:g?.os===r.OperatingSystem.Linux?b?.markdownDescriptions:void 0},[A.TerminalSettingId.DefaultProfileMacOs]:{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:g?.os===r.OperatingSystem.Macintosh?b?.values:void 0,markdownEnumDescriptions:g?.os===r.OperatingSystem.Macintosh?b?.markdownDescriptions:void 0},[A.TerminalSettingId.DefaultProfileWindows]:{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:g?.os===r.OperatingSystem.Windows?b?.values:void 0,markdownEnumDescriptions:g?.os===r.OperatingSystem.Windows?b?.markdownDescriptions:void 0}}},m.updateConfigurations({add:[f],remove:l?[l]:[]})}}),define(Se[284],De([1,0,2,13,117,28,119]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wQ=void 0;let A=class extends n.$Uc{constructor(s,E){super(),this.a=s,this.b=E}start(){const s={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:r.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},E=(0,R.$dn)(this.b.args,this.b.isBuilt);E&&(E.break&&E.port?s.debugBrk=E.port:!E.break&&E.port&&(s.debug=E.port));const y=new S.$0q(r.$Ug.asFileUri("bootstrap-fork").fsPath,s),$=new n.$Tc;return $.add(y),{client:y,store:$,onDidProcessExit:y.onDidProcessExit}}};e.$wQ=A,e.$wQ=A=Ue([Ne(1,k.$Hi)],A)}),define(Se[285],De([1,0,32,13,21,9,3,33,17,11,25,134,97,135]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=a,e.$Cs=f,e.$Ds=c;function a(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let D=0;return u&&u.length===4&&(D=parseInt(u[3])),D}async function f(u,D,I,T=A.env,O=E.Promises.exists){if(k.$ic(u))return await O(u)?u:void 0;if(D===void 0&&(D=A.cwd()),k.$mc(u)!=="."){const X=k.$jc(D,u);return await O(X)?X:void 0}const P=(0,S.$eo)(T,"PATH");if(I===void 0&&(0,s.$ag)(P)&&(I=P.split(k.$tc)),I===void 0||I.length===0){const X=k.$jc(D,u);return await O(X)?X:void 0}for(const X of I){let ie;if(k.$ic(X)?ie=k.$jc(X,u):ie=k.$jc(D,X,u),await O(ie))return ie;if(R.$c){let ne=ie+".com";if(await O(ne)||(ne=ie+".exe",await O(ne)))return ne}}const Q=k.$jc(D,u);return await O(Q)?Q:void 0}function c(u,D,I,T,O){const C=R.$c&&(!D.windowsEnableConpty||a()<18309);if(!D.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||C)return;const P=u.args,Q=A.$dc==="win32"?k.$nc(u.executable).toLowerCase():k.$nc(u.executable),X=k.$mc(r.$Ug.asFileUri("").fsPath);let ie;const ne={VSCODE_INJECTION:"1"};if(D.shellIntegration.nonce&&(ne.VSCODE_NONCE=D.shellIntegration.nonce),R.$c){if(Q==="pwsh.exe"||Q==="powershell.exe")return!P||i(P)?ie=m.get(p.WindowsPwsh):d(P)&&(ie=m.get(p.WindowsPwshLogin)),ie?(ie=[...ie],ie[ie.length-1]=(0,v.$_e)(ie[ie.length-1],X,""),D.shellIntegration.suggestEnabled&&(ne.VSCODE_SUGGEST="1"),{newArgs:ie,envMixin:ne}):void 0;if(Q==="bash.exe")return!P||P.length===0?ie=m.get(p.Bash):h(P)&&(ne.VSCODE_SHELL_LOGIN="1",g(D,ne),ie=m.get(p.Bash)),ie?(ie=[...ie],ie[ie.length-1]=(0,v.$_e)(ie[ie.length-1],X),{newArgs:ie,envMixin:ne}):void 0;T.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(Q){case"bash":return!P||P.length===0?ie=m.get(p.Bash):h(P)&&(ne.VSCODE_SHELL_LOGIN="1",g(D,ne),ie=m.get(p.Bash)),ie?(ie=[...ie],ie[ie.length-1]=(0,v.$_e)(ie[ie.length-1],X),{newArgs:ie,envMixin:ne}):void 0;case"fish":{const x=I?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",re=k.$jc(X,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return ne.XDG_DATA_DIRS=`${x}:${re}`,g(D,ne),{newArgs:void 0,envMixin:ne}}case"pwsh":return!P||i(P)?ie=m.get(p.Pwsh):d(P)&&(ie=m.get(p.PwshLogin)),ie?(D.shellIntegration.suggestEnabled&&(ne.VSCODE_SUGGEST="1"),ie=[...ie],ie[ie.length-1]=(0,v.$_e)(ie[ie.length-1],X,""),{newArgs:ie,envMixin:ne}):void 0;case"zsh":{if(!P||P.length===0?ie=m.get(p.Zsh):h(P)?(ie=m.get(p.ZshLogin),g(D,ne)):(P===m.get(p.Zsh)||P===m.get(p.ZshLogin))&&(ie=P),!ie)return;ie=[...ie],ie[ie.length-1]=(0,v.$_e)(ie[ie.length-1],X);let x;try{x=n.userInfo().username}catch{x="unknown"}const re=k.$jc(n.tmpdir(),`${x}-${O.applicationName}-zsh`);ne.ZDOTDIR=re;const q=I?.ZDOTDIR??n.homedir()??"~";ne.USER_ZDOTDIR=q;const te=[];return te.push({source:k.$jc(X,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:k.$jc(re,".zshrc")}),te.push({source:k.$jc(X,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:k.$jc(re,".zprofile")}),te.push({source:k.$jc(X,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:k.$jc(re,".zshenv")}),te.push({source:k.$jc(X,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:k.$jc(re,".zlogin")}),{newArgs:ie,envMixin:ne,filesToCopy:te}}}T.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function g(u,D){if(R.$d&&u.environmentVariableCollections){const I=(0,$.$zs)(u.environmentVariableCollections),O=new w.$As(I).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),C=[];if(O)for(const P of O)P.type===y.EnvironmentVariableMutatorType.Prepend&&C.push(P.value);C.length>0&&(D.VSCODE_PATH_PREFIX=C.join(""))}}var p;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(p||(p={}));const m=new Map;m.set(p.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(p.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),m.set(p.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),m.set(p.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),m.set(p.Zsh,["-i"]),m.set(p.ZshLogin,["-il"]),m.set(p.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const b=["-login","-l"],l=["--login","-l"],t=["-i","--interactive"],o=["-nol","-nologo"];function d(u){return typeof u=="string"?b.includes(u.toLowerCase()):u.length===1&&b.includes(u[0].toLowerCase())||u.length===2&&(b.includes(u[0].toLowerCase())||b.includes(u[1].toLowerCase()))&&(o.includes(u[0].toLowerCase())||o.includes(u[1].toLowerCase()))}function i(u){return typeof u=="string"?o.includes(u.toLowerCase()):u.length===0||u?.length===1&&o.includes(u[0].toLowerCase())}function h(u){return typeof u!="string"&&(u=u.filter(D=>!t.includes(D.toLowerCase()))),u==="string"&&l.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&l.includes(u[0].toLowerCase())}}),define(Se[286],De([1,0,60,57,9,3,11,25,113,52,285,83]),function(he,e,n,r,S,k,R,A,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=f;var $;(function(D){D.UnixShellsPath="/etc/shells"})($||($={}));let w,a=!0;function f(D,I,T,O,C=process.env,P,Q,X,ie){return P=P||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},k.$c?c(T,P,C,Q,O.getValue(s.TerminalSettingId.UseWslProfiles)!==!1,D&&typeof D=="object"?{...D}:O.getValue(s.TerminalSettingId.ProfilesWindows),typeof I=="string"?I:O.getValue(s.TerminalSettingId.DefaultProfileWindows),ie,X):i(P,Q,T,D&&typeof D=="object"?{...D}:O.getValue(k.$e?s.TerminalSettingId.ProfilesLinux:s.TerminalSettingId.ProfilesMacOs),typeof I=="string"?I:O.getValue(k.$e?s.TerminalSettingId.DefaultProfileLinux:s.TerminalSettingId.DefaultProfileMacOs),ie,X,C)}async function c(D,I,T,O,C,P,Q,X,ie){const ne=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),x=`${process.env.windir}\\${ne?"Sysnative":"System32"}`;let re=!1;(0,E.$Bs)()>=16299&&(re=!0),await b(X);const q=new Map;if(D){q.set("PowerShell",{source:s.ProfileSource.Pwsh,icon:r.$Zj.terminalPowershell,isAutoDetected:!0}),q.set("Windows PowerShell",{path:`${x}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:r.$Zj.terminalPowershell,isAutoDetected:!0}),q.set("Git Bash",{source:s.ProfileSource.GitBash,isAutoDetected:!0}),q.set("Command Prompt",{path:`${x}\\cmd.exe`,icon:r.$Zj.terminalCmd,isAutoDetected:!0}),q.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),q.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:r.$Zj.terminalBash,isAutoDetected:!0});const le=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;q.set("Cmder",{path:`${x}\\cmd.exe`,args:["/K",le],requiresPath:process.env.CMDER_ROOT?le:{path:le,isUnsafe:!0},isAutoDetected:!0})}h(P,q);const te=await g(q.entries(),Q,I,T,O,ie);if(D&&C)try{const le=await o(`${x}\\${re?"wsl":"bash"}.exe`,Q);for(const M of le)(!P||!(M.profileName in P))&&te.push(M)}catch{a&&(O?.trace("WSL is not installed, so could not detect WSL profiles"),a=!1)}return te}async function g(D,I,T,O=process.env,C,P){const Q=[];for(const[X,ie]of D)Q.push(p(X,ie,I,T,O,C,P));return(await Promise.all(Q)).filter(X=>!!X)}async function p(D,I,T,O,C=process.env,P,Q){if(I===null)return;let X,ie,ne;if("source"in I&&!("path"in I)){const te=w?.get(I.source);if(!te)return;X=te.paths,ie=I.args||te.args,I.icon?ne=m(I.icon):te.icon&&(ne=te.icon)}else X=Array.isArray(I.path)?I.path:[I.path],ie=k.$c||Array.isArray(I.args)?I.args:void 0,ne=m(I.icon);let x;if(Q){const te=X.map(M=>typeof M=="string"?M:M.path),le=await Q(te);x=new Array(X.length);for(let M=0;M<X.length;M++)typeof X[M]=="string"?x[M]=le[M]:x[M]={path:le[M],isUnsafe:!0}}else x=X.slice();let re;if(I.requiresPath){let te;if((0,R.$ag)(I.requiresPath)?te=I.requiresPath:(te=I.requiresPath.path,I.requiresPath.isUnsafe&&(re=te)),!await O.existsFile(te))return}const q=await u(D,T,x,O,C,ie,I.env,I.overrideName,I.isAutoDetected,re);if(!q){P?.debug("Terminal profile not validated",D,X);return}return q.isAutoDetected=I.isAutoDetected,q.icon=ne,q.color=I.color,q}function m(D){return typeof D=="string"?{id:D}:D}async function b(D){if(w&&!D)return;const[I,T]=await Promise.all([l(),D||t()]);w=new Map,w.set(s.ProfileSource.GitBash,{profileName:"Git Bash",paths:I,args:["--login","-i"]}),w.set(s.ProfileSource.Pwsh,{profileName:"PowerShell",paths:T,icon:r.$Zj.terminalPowershell})}async function l(){const D=new Set,I=await(0,E.$Cs)("git.exe");if(I){const C=(0,y.dirname)(I);D.add((0,y.resolve)(C,"../.."))}function T(C,P){P&&C.add(P)}T(D,process.env.ProgramW6432),T(D,process.env.ProgramFiles),T(D,process.env["ProgramFiles(X86)"]),T(D,`${process.env.LocalAppData}\\Program`);const O=[];for(const C of D)O.push(`${C}\\Git\\bin\\bash.exe`,`${C}\\Git\\usr\\bin\\bash.exe`,`${C}\\usr\\bin\\bash.exe`);return O.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),O.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),O}async function t(){const D=[];for await(const I of(0,v.$qm)())D.push(I.exePath);return D}async function o(D,I){const T=[],O=await new Promise((Q,X)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(ie,ne)=>{if(ie)return X("Problem occurred when getting wsl distros");Q(ne)})});if(!O)return[];const C=new RegExp(/[\r?\n]/),P=O.split(C).filter(Q=>Q.trim().length>0&&Q!=="");for(const Q of P){if(Q===""||Q.startsWith("docker-desktop"))continue;const X=`${Q} (WSL)`,ie={profileName:X,path:D,args:["-d",`${Q}`],isDefault:X===I,icon:d(Q),isAutoDetected:!1};T.push(ie)}return T}function d(D){return D.includes("Ubuntu")?r.$Zj.terminalUbuntu:D.includes("Debian")?r.$Zj.terminalDebian:r.$Zj.terminalLinux}async function i(D,I,T,O,C,P,Q,X){const ie=new Map;if(T&&await D.existsFile($.UnixShellsPath)){const ne=(await D.readFile($.UnixShellsPath)).toString(),x=(P||ne.split(`
`)).map(q=>{const te=q.indexOf("#");return te===-1?q:q.substring(0,te)}).filter(q=>q.trim().length>0),re=new Map;for(const q of x){let te=(0,S.$nc)(q),le=re.get(te)||0;le++,le>1&&(te=`${te} (${le})`),re.set(te,le),ie.set(te,{path:q,isAutoDetected:!0})}}return h(O,ie),await g(ie.entries(),C,D,X,I,Q)}function h(D,I){if(D)for(const[T,O]of Object.entries(D))O===null||typeof O!="object"||!("path"in O)&&!("source"in O)?I.delete(T):(O.icon=O.icon||I.get(T)?.icon,I.set(T,O))}async function u(D,I,T,O,C,P,Q,X,ie,ne){if(T.length===0)return Promise.resolve(void 0);const x=T.shift();if(x==="")return u(D,I,T,O,C,P,Q,X,ie);const re=typeof x!="string"&&x.isUnsafe,q=typeof x=="string"?x:x.path,te={profileName:D,path:q,args:P,env:Q,overrideName:X,isAutoDetected:ie,isDefault:D===I,isUnsafePath:re,requiresUnsafePath:ne};if((0,S.$nc)(q)===q){const M=C.PATH?C.PATH.split(S.$tc):void 0,z=await(0,E.$Cs)(q,void 0,M,void 0,O.existsFile);return z?(te.path=z,te.isFromPath=!0,te):u(D,I,T,O,C,P)}return await O.existsFile((0,S.$hc)(q))?te:u(D,I,T,O,C,P,Q,X,ie)}}),define(Se[287],De([1,0,6,2,3,49,27,12,124,94,281,52,283,286,116,55]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=void 0;var c;(function(p){p[p.MaxRestarts=5]="MaxRestarts"})(c||(c={}));let g=class extends r.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(m,b,l,t){super(),this.M=m,this.N=b,this.O=l,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$he),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$he),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$he),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$he),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$he),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$he),this.onProcessData=this.D.event,this.F=this.B(new n.$he),this.onProcessReady=this.F.event,this.G=this.B(new n.$he),this.onProcessReplay=this.G.event,this.H=this.B(new n.$he),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$he),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$he),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$he),this.onProcessExit=this.L.event,(0,$.$ss)(),this.B(this.M),this.B((0,r.$Sc)(()=>this.W())),this.j=this.B(new E.$ls(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue(y.TerminalSettingId.IgnoreProcessNames)}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$c)return process.env;try{return await(0,s.$Mm)(this.N,this.O,{_:[]},process.env)}catch(m){return this.O.error("ptyHost was unable to resolve shell environment",m),{}}}U(){const m=this.M.start(),b=m.client;this.O.getLevel()===A.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),k.ProxyChannel.toService(b.getChannel(y.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(m.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=c.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=k.ProxyChannel.toService(b.getChannel(y.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new v.$ks(this.P,b.getChannel(y.TerminalIpcChannels.Logger))),this.a=m,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration(y.TerminalSettingId.IgnoreProcessNames)&&await this.R()})),this.R(),[m,t]}async createProcess(m,b,l,t,o,d,i,h,u,D,I){const T=setTimeout(()=>this.$(),y.HeartbeatConstants.CreateProcessTimeout),O=await this.f.createProcess(m,b,l,t,o,d,i,h,u,D,I);return clearTimeout(T),O}updateTitle(m,b,l){return this.f.updateTitle(m,b,l)}updateIcon(m,b,l,t){return this.f.updateIcon(m,b,l,t)}attachToProcess(m){return this.f.attachToProcess(m)}detachFromProcess(m,b){return this.f.detachFromProcess(m,b)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(m){return this.f.start(m)}shutdown(m,b){return this.f.shutdown(m,b)}input(m,b){return this.f.input(m,b)}processBinary(m,b){return this.f.processBinary(m,b)}resize(m,b,l){return this.f.resize(m,b,l)}clearBuffer(m){return this.f.clearBuffer(m)}acknowledgeDataEvent(m,b){return this.f.acknowledgeDataEvent(m,b)}setUnicodeVersion(m,b){return this.f.setUnicodeVersion(m,b)}getInitialCwd(m){return this.f.getInitialCwd(m)}getCwd(m){return this.f.getCwd(m)}async getLatency(){const m=new f.$be,b=await this.f.getLatency();return m.stop(),[{label:"ptyhostservice<->ptyhost",latency:m.elapsed()},...b]}orphanQuestionReply(m){return this.f.orphanQuestionReply(m)}installAutoReply(m,b){return this.f.installAutoReply(m,b)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(m){return this.f.uninstallAutoReply(m)}getDefaultSystemShell(m){return this.g?.getDefaultSystemShell(m)??(0,a.$wm)(m??S.OS,process.env)}async getProfiles(m,b,l,t=!1){const o=await this.S();return(0,w.$Es)(b,l,t,this.N,o,void 0,this.O,this.bb.bind(this,m))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(m,b){return this.f.getWslPath(m,b)}getRevivedPtyNewId(m,b){return this.f.getRevivedPtyNewId(m,b)}setTerminalLayoutInfo(m){return this.f.setTerminalLayoutInfo(m)}async getTerminalLayoutInfo(m){return this.g?.getTerminalLayoutInfo(m)}async requestDetachInstance(m,b){return this.f.requestDetachInstance(m,b)}async acceptDetachInstanceReply(m,b){return this.f.acceptDetachInstanceReply(m,b)}async freePortKillProcess(m){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(m)}async serializeTerminalState(m){return this.f.serializeTerminalState(m)}async reviveTerminalProcesses(m,b,l){return this.f.reviveTerminalProcesses(m,b,l)}async refreshProperty(m,b){return this.f.refreshProperty(m,b)}async updateProperty(m,b,l){return this.f.updateProperty(m,b,l)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(m){this.ab(),this.s=setTimeout(()=>this.Y(),m?y.HeartbeatConstants.ConnectingBeatInterval:y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier+y.HeartbeatConstants.BeatInterval*y.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${y.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(m,b){return this.j.createRequest({workspaceId:m,originalText:b})}async acceptPtyHostResolvedVariables(m,b){this.j.acceptReply(m,b)}};e.$Fs=g,e.$Fs=g=Ue([Ne(1,R.$7i),Ne(2,A.$7j),Ne(3,A.$8j)],g)}),define(Se[36],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,n.$Ai)("IUriIdentityService")}),define(Se[137],De([1,0,36,120,16,20,167,6,2]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=void 0;class s{constructor($){this.uri=$,this.time=s._clock++}touch(){return this.time=s._clock++,this}}s._clock=0;let E=class{constructor($){this.g=$,this.c=new v.$Tc,this.f=2**16;const w=new Map,a=f=>{let c=w.get(f.scheme);return c===void 0&&(c=$.hasProvider(f)&&!this.g.hasCapability(f,S.FileSystemProviderCapabilities.PathCaseSensitive),w.set(f.scheme,c)),c};this.c.add(A.Event.any($.onDidChangeFileSystemProviderRegistrations,$.onDidChangeFileSystemProviderCapabilities)(f=>{w.delete(f.scheme)})),this.extUri=new k.$3g(a),this.d=new R.$Is((f,c)=>this.extUri.compare(f,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri($){this.g.hasProvider($)&&($=(0,k.$ch)($));const w=this.d.get($);return w?w.touch().uri.with({fragment:$.fragment}):(this.d.set($,new s($)),this.h(),$)}h(){if(this.d.size<this.f)return;const $=[...this.d.entries()].sort((a,f)=>a[1].time<f[1].time?1:a[1].time>f[1].time?-1:0);s._clock=0,this.d.clear();const w=this.f*.5;for(let a=0;a<w;a++)this.d.set($[a][0],$[a][1].touch())}};e.$Js=E,e.$Js=E=Ue([Ne(0,S.$7k)],E),(0,r.$Gs)(n.$El,E,r.InstantiationType.Delayed)}),define(Se[98],De([1,0,226,9,69,20,4,5,13]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=s,e.$Li=E,e.$Oi=y,e.$Pi=$,e.$Qi=w,e.$Ri=f,e.$Si=c,e.$Vi=m,e.$1i=b,e.$2i=l,e.$4i=t,e.$5i=o,e.$6i=d,e.$Ji=(0,A.$Ai)("contextService");function s(i){const h=i;return typeof h?.id=="string"&&R.URI.isUri(h.uri)}function E(i){return typeof i?.id=="string"&&!s(i)&&!$(i)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function y(i,h){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,r.$nc)(i)}:h?e.$Mi:e.$Ni;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function $(i){const h=i;return typeof h?.id=="string"&&R.URI.isUri(h.configPath)}function w(i){const h=i;if(h?.uri)return{id:h.id,uri:R.URI.revive(h.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:R.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}var a;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(a||(e.WorkbenchState=a={}));function f(i){const h=i;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function c(i){const h=i;return!!(h&&typeof h=="object"&&R.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class g{constructor(h,u,D,I,T){this.h=h,this.j=D,this.k=I,this.l=T,this.c=S.$Gi.forUris(this.l,()=>!0),this.folders=u}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=S.$Gi.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=g;class p{constructor(h,u){this.raw=u,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,k.$bh)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=p;function m(i){return new p({uri:i,index:0,name:(0,k.$0g)(i)},{uri:i.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,n.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function b(i,h){return k.$5g.isEqualOrParent(i,h.untitledWorkspacesHome)}function l(i){let h;return R.URI.isUri(i)?h=i:h=i.configuration,h?.scheme===v.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$3i}function o(i,h){return!b(i,h)&&!l(i)}function d(i){return(typeof i=="string"?(0,r.$oc)(i):(0,k.$_g)(i))===e.$Xi}}),define(Se[34],De([1,0,68,6,2,20,4,225,28,16,5,12,98,26,36,14,22,17,11]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=b,e.$Hl=l,e.$Il=t;var m;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(m||(e.ProfileResourceType=m={}));function b(i){const h=i;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&R.URI.isUri(h.location)&&R.URI.isUri(h.globalStorageHome)&&R.URI.isUri(h.settingsResource)&&R.URI.isUri(h.keybindingsResource)&&R.URI.isUri(h.tasksResource)&&R.URI.isUri(h.snippetsHome)&&R.URI.isUri(h.extensionsResource))}e.$Gl=(0,E.$Ai)("IUserDataProfilesService");function l(i,h){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:R.URI.revive(i.location).with({scheme:h}),globalStorageHome:R.URI.revive(i.globalStorageHome).with({scheme:h}),settingsResource:R.URI.revive(i.settingsResource).with({scheme:h}),keybindingsResource:R.URI.revive(i.keybindingsResource).with({scheme:h}),tasksResource:R.URI.revive(i.tasksResource).with({scheme:h}),snippetsHome:R.URI.revive(i.snippetsHome).with({scheme:h}),extensionsResource:R.URI.revive(i.extensionsResource).with({scheme:h}),cacheHome:R.URI.revive(i.cacheHome).with({scheme:h}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,h,u,D,I,T){return{id:i,name:h,location:u,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:T&&I?.useDefaultFlags?.globalState?T.globalStorageHome:(0,k.$bh)(u,"globalStorage"),settingsResource:T&&I?.useDefaultFlags?.settings?T.settingsResource:(0,k.$bh)(u,"settings.json"),keybindingsResource:T&&I?.useDefaultFlags?.keybindings?T.keybindingsResource:(0,k.$bh)(u,"keybindings.json"),tasksResource:T&&I?.useDefaultFlags?.tasks?T.tasksResource:(0,k.$bh)(u,"tasks.json"),snippetsHome:T&&I?.useDefaultFlags?.snippets?T.snippetsHome:(0,k.$bh)(u,"snippets"),extensionsResource:T&&I?.useDefaultFlags?.extensions?T.extensionsResource:(0,k.$bh)(u,"extensions.json"),cacheHome:(0,k.$bh)(D,i),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}let o=class extends S.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,u,D,I){super(),this.t=h,this.u=u,this.w=D,this.y=I,this.f=!0,this.h=this.B(new r.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new r.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new r.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new r.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,k.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),u=[h];if(this.f)try{for(const T of this.O()){if(!T.name||!(0,p.$ag)(T.name)||!T.location){this.y.warn("Skipping the invalid stored profile",T.location||T.name);continue}u.push(t((0,k.$$g)(T.location),T.name,T.location,this.g,{shortName:T.shortName,icon:T.icon,useDefaultFlags:T.useDefaultFlags},h))}}catch(T){this.y.error(T)}const D=new w.$Ac,I=new Map;if(u.length)try{const T=this.Q();if(T.workspaces)for(const[O,C]of Object.entries(T.workspaces)){const P=R.URI.parse(O),Q=u.find(X=>X.id===C);Q&&D.set(P,Q)}if(T.emptyWindows)for(const[O,C]of Object.entries(T.emptyWindows)){const P=u.find(Q=>Q.id===C);P&&I.set(O,P)}}catch(T){this.y.error(T)}this.z={profiles:u,workspaces:D,emptyWindows:I}}return this.z}D(){const h=t("__default__profile__",(0,A.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const u="Temp",D=new RegExp(`${(0,g.$df)(u)}\\s(\\d+)`);let I=0;for(const O of this.profiles){const C=D.exec(O.name),P=C?parseInt(C[1]):0;I=P>I?P:I}const T=`${u} ${I+1}`;return this.createProfile((0,n.$oj)((0,c.$Wg)()).toString(16),T,{transient:!0},h)}async createNamedProfile(h,u,D){return this.createProfile((0,n.$oj)((0,c.$Wg)()).toString(16),h,u,D)}async createProfile(h,u,D,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const T=await this.F(h,u,D);return I&&await this.setProfileForWorkspace(I,T),T}async F(h,u,D){if(!(0,p.$ag)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(u);return I||(I=(async()=>{try{if(this.profiles.find(P=>P.name===u||P.id===h))throw new Error(`Profile with ${u} name already exists`);const O=t(h,u,(0,k.$bh)(this.profilesHome,h),this.g,D,this.defaultProfile);await this.u.createFolder(O.location);const C=[];return this.j.fire({profile:O,join(P){C.push(P)}}),await f.Promises.settled(C),this.I([O],[],[]),O}finally{this.r.delete(u)}})(),this.r.set(u,I)),I}async updateProfile(h,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(I=>I.id===h.id);if(!D)throw new Error(`Profile '${h.name}' does not exist`);return D=t(D.id,u.name??D.name,D.location,this.g,{shortName:u.shortName??D.shortName,icon:u.icon===null?void 0:u.icon??D.icon,transient:u.transient??D.isTransient,useDefaultFlags:u.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(I=>I.id===h.id);if(!u)throw new Error(`Profile '${h.name}' does not exist`);const D=[];this.m.fire({profile:u,join(I){D.push(I)}});try{await Promise.allSettled(D)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(I){(0,s.$ll)(I)!==s.FileOperationResult.FILE_NOT_FOUND&&this.y.error(I)}}async setProfileForWorkspace(h,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(I=>I.id===u.id);if(!D)throw new Error(`Profile '${u.name}' does not exist`);this.L(h,D)}unsetWorkspace(h,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(u=>u.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(h.map(u=>this.removeProfile(u)))}getProfileForWorkspace(h){const u=this.G(h);return R.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(h){return(0,$.$Ki)(h)?h.uri:(0,$.$Pi)(h)?h.configPath:h.id}H(h){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,h.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,h.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,h.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,h.location)))}I(h,u,D){const I=[...this.profiles,...h],T=[];this.s.profiles=[];for(let O of I)O.isDefault||u.some(C=>O.id===C.id)||(O=D.find(C=>O.id===C.id)??O,O.isTransient?this.s.profiles.push(O):T.push({location:O.location,name:O.name,shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags}));this.P(T),this.z=void 0,this.J(h,u,D)}J(h,u,D){this.h.fire({added:h,removed:u,updated:D,all:this.profiles})}L(h,u,D){D=u?.isTransient?!0:D,D||this.L(h,void 0,!0);const I=this.G(h),T=D?this.s:this.C;R.URI.isUri(I)?(T.workspaces.delete(I),u&&T.workspaces.set(I,u)):(T.emptyWindows.delete(I),u&&T.emptyWindows.set(I,u)),D||this.M()}M(){const h={};for(const[D,I]of this.C.workspaces.entries())h[D.toString()]=I.id;const u={};for(const[D,I]of this.C.emptyWindows.entries())u[D.toString()]=I.id;this.R({workspaces:h,emptyWindows:u}),this.z=void 0}N(h){const u={},D=this.D();if(h.workspaces)for(const[T,O]of Object.entries(h.workspaces)){const C=R.URI.parse(O);u[T]=this.w.extUri.isEqual(C,D.location)?D.id:this.w.extUri.basename(C)}const I={};if(h.emptyWindows)for(const[T,O]of Object.entries(h.emptyWindows)){const C=R.URI.parse(O);I[T]=this.w.extUri.isEqual(C,D.location)?D.id:this.w.extUri.basename(C)}return{workspaces:u,emptyWindows:I}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$Jl=o,o.b="userDataProfiles",o.c="profileAssociations",e.$Jl=o=Ue([Ne(0,v.$Hi),Ne(1,s.$7k),Ne(2,a.$El),Ne(3,y.$7j)],o);class d extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$Kl=d}),define(Se[99],De([1,0,18,14,19,10,6,2,3,11,4,205,30,39,23,12,29,24,36,34]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$uq=void 0,e.$vq=l;let b=class extends A.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,h,u,D,I,T){super(),this.z=i,this.C=h,this.D=u,this.F=D,this.G=I,this.H=T,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new R.$he),this.s=this.B(new R.$he),this.t=this.B(new R.$he),this.u=this.B(new R.$he),this.w=this.B(new R.$he),this.y=[],this.B((0,A.$Sc)(()=>{this.j.forEach(({task:O})=>O.cancel()),this.m.forEach(O=>O.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const h=await this.getTargetPlatform();return i.allTargetPlatforms.some(u=>(0,$.$ap)(u,i.allTargetPlatforms,h))}async installFromGallery(i,h={}){try{const D=(await this.installGalleryExtensions([{extension:i,options:h}])).find(({identifier:I})=>(0,w.$Dp)(I,i.identifier));if(D?.local)return D?.local;throw D?.error?D.error:new $.$ep(`Unknown error while installing extension ${i.identifier.id}`,$.ExtensionManagementErrorCode.Unknown)}catch(u){throw l(u)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new $.$ep(y.localize(0,null),$.ExtensionManagementErrorCode.NotAllowed);const h=[],u=[];return await Promise.allSettled(i.map(async({extension:D,options:I})=>{try{const T=await this.N(D,!!I?.installGivenVersion,!!I?.installPreReleaseVersion,I.productVersion??{version:this.G.version,date:this.G.date});u.push({...T,options:I})}catch(T){h.push({identifier:D.identifier,operation:$.InstallOperation.Install,source:D,error:T})}})),u.length&&h.push(...await this.I(u)),h}async uninstall(i,h={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,h)}async toggleAppliationScope(i,h){if((0,a.$1m)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let u=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(h,this.H.defaultProfile.extensionsResource)||(u=await this.$(i,this.H.defaultProfile.extensionsResource,h));for(const D of this.H.profiles){const I=(await this.getInstalled(a.ExtensionType.User,D.extensionsResource)).find(T=>(0,w.$Dp)(T.identifier,i.identifier));I?this.w.fire(I):this.u.fire({identifier:i.identifier,profileLocation:D.extensionsResource})}return u}else{const u=this.D.extUri.isEqual(h,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,h,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:u.identifier,operation:$.InstallOperation.Install,local:u,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),u}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const h=new Map,u=new Map,D=[],I=(O,C)=>`${w.$Ep.create(O).toString()}-${C.toString()}`,T=(O,C,P,Q)=>{const X=this.Y(O,C,P),ie=`${(0,w.$Ip)(O.publisher,O.name)}-${P.profileLocation.toString()}`;u.set(ie,{task:X,root:Q}),this.n.fire({identifier:X.identifier,source:C,profileLocation:P.profileLocation}),this.F.info("Installing extension:",X.identifier.id,P.profileLocation.toString()),E.URI.isUri(C)||this.j.set(I(C,P.profileLocation),{task:X,waitingTasks:[]})};try{for(const{manifest:O,extension:C,options:P}of i){const Q=P.isApplicationScoped||P.isBuiltin||(0,a.$1m)(O),X={...P,installOnlyNewlyAddedFromExtensionPack:P.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(C),isApplicationScoped:Q,profileLocation:Q?this.H.defaultProfile.extensionsResource:P.profileLocation??this.X(),productVersion:P.productVersion??{version:this.G.version,date:this.G.date}},ie=E.URI.isUri(C)?void 0:this.j.get(I(C,X.profileLocation));ie?(this.F.info("Extension is already requested to install",ie.task.identifier.id,X.profileLocation.toString()),D.push(ie.task.waitUntilTaskIsFinished())):T(O,C,X,void 0)}return await Promise.all([...u.values()].map(async({task:O})=>{if(O.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",O.identifier.id);else try{const C=await this.M(O.identifier,O.manifest,!!O.options.installOnlyNewlyAddedFromExtensionPack,!!O.options.installPreReleaseVersion,O.options.profileLocation,O.options.productVersion),P=await this.getInstalled(void 0,O.options.profileLocation,O.options.productVersion),Q={...O.options,context:{...O.options.context,[$.$7o]:!0}};for(const{gallery:X,manifest:ie}of(0,n.$Mb)(C,({gallery:ne})=>ne.identifier.id)){if(u.has(`${X.identifier.id.toLowerCase()}-${Q.profileLocation.toString()}`))continue;const ne=this.j.get(I(X,Q.profileLocation));if(ne){if(this.J(O,ne.task)){const x=ne.task.identifier;this.F.info("Waiting for already requested installing extension",x.id,O.identifier.id,Q.profileLocation.toString()),ne.waitingTasks.push(O),D.push(R.Event.toPromise(R.Event.filter(this.onDidInstallExtensions,re=>re.some(q=>(0,w.$Dp)(q.identifier,x)))).then(re=>{if(this.F.info("Finished waiting for already requested installing extension",x.id,O.identifier.id,Q.profileLocation.toString()),!re.find(te=>(0,w.$Dp)(te.identifier,x))?.local)throw new Error(`Extension ${x.id} is not installed`)}))}}else P.some(({identifier:x})=>(0,w.$Dp)(x,X.identifier))||T(ie,X,Q,O)}}catch(C){if(E.URI.isUri(O.source))(0,n.$Lb)(O.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",O.identifier.id,C.message),(0,n.$Lb)(O.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",O.identifier.id,C.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",O.identifier.id),C}})),await this.L([...u.entries()].map(async([O,{task:C}])=>{const P=new Date().getTime();let Q;try{Q=await C.run(),await this.L(this.y.map(X=>X.postInstall(Q,C.source,C.options,S.CancellationToken.None)),$.ExtensionManagementErrorCode.PostInstall)}catch(X){const ie=l(X);throw E.URI.isUri(C.source)||t(this.C,C.operation===$.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Lp)(C.source),error:ie,source:C.options.context?.[$.$6o]}),h.set(O,{error:ie,identifier:C.identifier,operation:C.operation,source:C.source,context:C.options.context,profileLocation:C.options.profileLocation,applicationScoped:C.options.isApplicationScoped}),this.F.error("Error while installing the extension",C.identifier.id,(0,k.$0)(ie),C.options.profileLocation.toString()),ie}if(!E.URI.isUri(C.source)){const X=C.operation===$.InstallOperation.Update,ie=X?void 0:(new Date().getTime()-C.source.lastUpdated)/1e3;if(t(this.C,X?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,w.$Lp)(C.source),verificationStatus:C.verificationStatus,duration:new Date().getTime()-P,durationSinceUpdate:ie,source:C.options.context?.[$.$6o]}),v.$i&&C.operation!==$.InstallOperation.Update)try{await this.z.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,$.StatisticType.Install)}catch{}}h.set(O,{local:Q,identifier:C.identifier,operation:C.operation,source:C.source,context:C.options.context,profileLocation:C.options.profileLocation,applicationScoped:Q.isApplicationScoped})})),D.length&&await this.L(D),[...h.values()]}catch(O){const C=(X,ie,ne)=>{const x=[];X.manifest.extensionDependencies?.length&&x.push(...X.manifest.extensionDependencies),X.manifest.extensionPack?.length&&x.push(...X.manifest.extensionPack);for(const re of x){if(ne.includes(re.toLowerCase()))continue;ne.push(re.toLowerCase());const q=h.get(`${re.toLowerCase()}-${ie.toString()}`);q?.local&&(ne=C(q.local,ie,ne))}return ne},P=X=>({identifier:X.identifier,operation:$.InstallOperation.Install,source:X.source,context:X.options.context,profileLocation:X.options.profileLocation,error:O}),Q=[];for(const[X,{task:ie,root:ne}]of u){const x=h.get(X);x?x.local&&ne&&!h.get(`${ne.identifier.id.toLowerCase()}-${ie.options.profileLocation.toString()}`)?.local&&(Q.push(this.Z(x.local,{versionOnly:!0,profileLocation:ie.options.profileLocation})),h.set(X,P(ie))):(ie.cancel(),h.set(X,P(ie)))}for(const[X,{task:ie}]of u){const ne=h.get(X);if(!ne?.local||ie.options.donotIncludePackAndDependencies)continue;C(ne.local,ie.options.profileLocation,[ne.local.identifier.id.toLowerCase()]).slice(1).some(re=>u.has(`${re.toLowerCase()}-${ie.options.profileLocation.toString()}`)&&!h.get(`${re.toLowerCase()}-${ie.options.profileLocation.toString()}`)?.local)&&(Q.push(this.Z(ne.local,{versionOnly:!0,profileLocation:ie.options.profileLocation})),h.set(X,P(ie)))}throw Q.length&&await Promise.allSettled(Q.map(async X=>{try{await X.run(),this.F.info("Rollback: Uninstalled extension",X.extension.identifier.id)}catch(ie){this.F.warn("Rollback: Error while uninstalling extension",X.extension.identifier.id,(0,k.$0)(ie))}})),O}finally{for(const{task:O}of u.values())O.source&&!E.URI.isUri(O.source)&&this.j.delete(I(O.source,O.options.profileLocation));if(h.size){const O=[...h.values()];for(const C of O)C.local&&this.F.info("Extension installed successfully:",C.identifier.id,C.profileLocation.toString());this.s.fire(O)}}}J(i,h){for(const[,{task:u,waitingTasks:D}]of this.j.entries())if(u===i&&(D.includes(h)||D.some(I=>this.J(I,h)))||u===h&&D[0]&&!this.J(i,D[0]))return!1;return!0}async L(i,h){const u=[],D=[],I=await Promise.allSettled(i);for(const O of I)O.status==="fulfilled"?u.push(O.value):D.push(l(O.reason,h));if(!D.length)return u;if(D.length===1)throw D[0];let T=new $.$ep("",$.ExtensionManagementErrorCode.Unknown);for(const O of D)T=new $.$ep(T.message?`${T.message}, ${O.message}`:O.message,O.code!==$.ExtensionManagementErrorCode.Unknown&&O.code!==$.ExtensionManagementErrorCode.Internal?O.code:T.code);throw T}async M(i,h,u,D,I,T){if(!this.z.isEnabled())return[];const O=await this.getInstalled(void 0,I,T),C=[],P=[],Q=async(X,ie)=>{C.push(X);const ne=ie.extensionDependencies||[],x=[...ne];if(ie.extensionPack){const re=u?O.find(q=>(0,w.$Dp)(q.identifier,X)):void 0;for(const q of ie.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(te=>(0,w.$Dp)({id:te},{id:q}))||x.every(te=>!(0,w.$Dp)({id:te},{id:q}))&&x.push(q)}if(x.length){const re=x.filter(q=>C.every(te=>!(0,w.$Dp)(te,{id:q})));if(re.length){const q=await this.z.getExtensions(re.map(te=>({id:te,preRelease:D})),S.CancellationToken.None);for(const te of q){if(C.find(z=>(0,w.$Dp)(z,te.identifier)))continue;const le=ne.some(z=>(0,w.$Dp)({id:z},te.identifier));let M;try{M=await this.N(te,!1,D,T)}catch(z){if(le)throw z;this.F.info("Skipping the packed extension as it cannot be installed",te.identifier.id,(0,k.$0)(z));continue}P.push({gallery:M.extension,manifest:M.manifest}),await Q(M.extension.identifier,M.manifest)}}}};return await Q(i,h),P}async N(i,h,u,D){let I;const T=await this.getExtensionsControlManifest();if(T.malicious.some(P=>(0,w.$Dp)(i.identifier,P)))throw new $.$ep(y.localize(1,null,i.identifier.id),$.ExtensionManagementErrorCode.Malicious);const O=T.deprecated[i.identifier.id.toLowerCase()];if(O?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${O.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:O.extension.id,preRelease:O.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:D},S.CancellationToken.None))[0],!I)throw new $.$ep(y.localize(2,null,i.identifier.id,O.extension.id),$.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const P=await this.getTargetPlatform();throw new $.$ep(y.localize(3,null,i.identifier.id,this.G.nameLong,(0,$.$9o)(P)),$.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.O(i,h,u,D),!I)throw!u&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],S.CancellationToken.None))[0]?new $.$ep(y.localize(4,null,i.displayName??i.identifier.id),$.ExtensionManagementErrorCode.ReleaseVersionNotFound):new $.$ep(y.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),$.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const C=await this.z.getManifest(I,S.CancellationToken.None);if(C===null)throw new $.$ep(`Missing manifest for extension ${I.identifier.id}`,$.ExtensionManagementErrorCode.Invalid);if(C.version!==I.version)throw new $.$ep(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,$.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:C}}async O(i,h,u,D){const I=await this.getTargetPlatform();let T=null;return!h&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==u&&(T=(await this.z.getExtensions([{...i.identifier,preRelease:u}],{targetPlatform:I,compatible:!0,productVersion:D},S.CancellationToken.None))[0]||null),!T&&await this.z.isExtensionCompatible(i,u,I,D)&&(T=i),T||(h?T=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:I,compatible:!0,productVersion:D},S.CancellationToken.None))[0]||null:T=await this.z.getCompatibleExtension(i,u,I,D)),T}async P(i,h){const u={...h,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:h.profileLocation??this.X()},D=Q=>`${Q.id.toLowerCase()}${u.versionOnly?`-${i.manifest.version}`:""}${u.profileLocation?`@${u.profileLocation.toString()}`:""}`,I=this.m.get(D(i.identifier));if(I)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),I.waitUntilTaskIsFinished();const T=Q=>{const X=this.Z(Q,u);return this.m.set(D(X.extension.identifier),X),u.profileLocation?this.F.info("Uninstalling extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,u.profileLocation.toString()):this.F.info("Uninstalling extension:",`${Q.identifier.id}@${Q.manifest.version}`),this.t.fire({identifier:Q.identifier,profileLocation:u.profileLocation,applicationScoped:Q.isApplicationScoped}),X},O=(Q,X)=>{X?u.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${Q.identifier.id}@${Q.manifest.version}`,u.profileLocation.toString(),X.message):this.F.error("Failed to uninstall extension:",`${Q.identifier.id}@${Q.manifest.version}`,X.message):u.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${Q.identifier.id}@${Q.manifest.version}`,u.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${Q.identifier.id}@${Q.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,w.$Kp)(Q),error:X}),this.u.fire({identifier:Q.identifier,error:X?.code,profileLocation:u.profileLocation,applicationScoped:Q.isApplicationScoped})},C=[],P=[];try{C.push(T(i));const Q=await this.getInstalled(a.ExtensionType.User,u.profileLocation);if(u.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const X=this.S(i,Q);for(const ie of X)this.m.has(D(ie.identifier))?this.F.info("Extensions is already requested to uninstall",ie.identifier.id):C.push(T(ie))}u.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(C.map(X=>X.extension),Q,i),await this.L(C.map(async X=>{try{if(await X.run(),await this.L(this.y.map(ie=>ie.postUninstall(X.extension,u,S.CancellationToken.None))),X.extension.identifier.uuid)try{await this.z.reportStatistic(X.extension.manifest.publisher,X.extension.manifest.name,X.extension.manifest.version,$.StatisticType.Uninstall)}catch{}O(X.extension)}catch(ie){const ne=l(ie);throw O(X.extension,ne),ne}finally{P.push(X)}}))}catch(Q){const X=l(Q);for(const ie of C){try{ie.cancel()}catch{}P.includes(ie)||O(ie.extension,X)}throw X}finally{for(const Q of C)this.m.delete(D(Q.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",Q.extension.identifier.id)}}Q(i,h,u){for(const D of i){const I=this.U(D,h);if(I.length){const T=I.filter(O=>!i.some(C=>(0,w.$Dp)(C.identifier,O.identifier)));if(T.length)throw new Error(this.R(D,T,u))}}}R(i,h,u){return u===i?h.length===1?y.localize(6,null,u.manifest.displayName||u.manifest.name,h[0].manifest.displayName||h[0].manifest.name):h.length===2?y.localize(7,null,u.manifest.displayName||u.manifest.name,h[0].manifest.displayName||h[0].manifest.name,h[1].manifest.displayName||h[1].manifest.name):y.localize(8,null,u.manifest.displayName||u.manifest.name,h[0].manifest.displayName||h[0].manifest.name,h[1].manifest.displayName||h[1].manifest.name):h.length===1?y.localize(9,null,u.manifest.displayName||u.manifest.name,i.manifest.displayName||i.manifest.name,h[0].manifest.displayName||h[0].manifest.name):h.length===2?y.localize(10,null,u.manifest.displayName||u.manifest.name,i.manifest.displayName||i.manifest.name,h[0].manifest.displayName||h[0].manifest.name,h[1].manifest.displayName||h[1].manifest.name):y.localize(11,null,u.manifest.displayName||u.manifest.name,i.manifest.displayName||i.manifest.name,h[0].manifest.displayName||h[0].manifest.name,h[1].manifest.displayName||h[1].manifest.name)}S(i,h,u=[]){if(u.indexOf(i)!==-1)return[];u.push(i);const D=i.manifest.extensionPack?i.manifest.extensionPack:[];if(D.length){const I=h.filter(O=>!O.isBuiltin&&D.some(C=>(0,w.$Dp)({id:C},O.identifier))),T=[];for(const O of I)T.push(...this.S(O,h,u));return[...I,...T]}return[]}U(i,h){return h.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(D=>(0,w.$Dp)({id:D},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$uq=b,e.$uq=b=Ue([Ne(0,$.$cp),Ne(1,g.$6l),Ne(2,p.$El),Ne(3,f.$7j),Ne(4,c.$nk),Ne(5,m.$Gl)],b);function l(d,i){if(d instanceof $.$ep)return d;let h;return d instanceof $.$dp?h=new $.$ep(d.message,d.code===$.ExtensionGalleryErrorCode.DownloadFailedWriting?$.ExtensionManagementErrorCode.DownloadFailedWriting:$.ExtensionManagementErrorCode.Gallery):h=new $.$ep(d.message,(0,k.$4)(d)?$.ExtensionManagementErrorCode.Cancelled:i??$.ExtensionManagementErrorCode.Internal),h.stack=d.stack,h}function t(d,i,{extensionData:h,verificationStatus:u,duration:D,error:I,source:T,durationSinceUpdate:O}){let C,P;(0,s.$ig)(u)&&(u===!0?u="Verified":(u===!1||(C=$.ExtensionManagementErrorCode.Signature,P=u),u="Unverified")),I&&(C=I.code,I.code===$.ExtensionManagementErrorCode.Signature&&(P=I.message)),d.publicLog(i,{...h,verificationStatus:u,success:!I,duration:D,errorcode:C,errorcodeDetail:P,durationSinceUpdate:O,source:T})}class o{constructor(){this.d=new r.$zh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,r.$nh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,r.$nh)(i=>new Promise((h,u)=>{const D=i.onCancellationRequested(()=>{D.dispose(),u(new k.$5)})})),this.d.open()),this.g.cancel()}}e.$wq=o}),define(Se[53],De([1,0,14,15,2,6,26,4,30,39,16,5,12,34,36,11,10,24]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=e.$xq=e.ExtensionsProfileScanningErrorCode=void 0;var p;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(p||(e.ExtensionsProfileScanningErrorCode=p={}));class m extends Error{constructor(d,i){super(d),this.code=i}}e.$xq=m,e.$yq=(0,y.$Ai)("IExtensionsProfileScannerService");let b=class extends S.$Uc{constructor(d,i,h,u,D,I){super(),this.j=d,this.m=i,this.n=h,this.r=u,this.s=D,this.t=I,this.b=this.B(new k.$he),this.onAddExtensions=this.b.event,this.c=this.B(new k.$he),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$he),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$he),this.onDidRemoveExtensions=this.g.event,this.h=new R.$Ac}scanProfileExtensions(d,i){return this.u(d,void 0,i)}async addExtensionsToProfile(d,i,h){const u=[],D=[];try{return await this.u(i,I=>{const T=[];if(h)T.push(...I);else for(const O of I)d.some(([C])=>(0,s.$Dp)(C.identifier,O.identifier)&&C.manifest.version!==O.version)?u.push(O):T.push(O);for(const[O,C]of d){const P=T.findIndex(X=>(0,s.$Dp)(X.identifier,O.identifier)&&X.version===O.manifest.version),Q={identifier:O.identifier,version:O.manifest.version,location:O.location,metadata:C};P===-1?(D.push(Q),T.push(Q)):T.splice(P,1,Q)}return D.length&&this.b.fire({extensions:D,profileLocation:i}),u.length&&this.f.fire({extensions:u,profileLocation:i}),T}),D.length&&this.c.fire({extensions:D,profileLocation:i}),u.length&&this.g.fire({extensions:u,profileLocation:i}),D}catch(I){throw D.length&&this.c.fire({extensions:D,error:I,profileLocation:i}),u.length&&this.g.fire({extensions:u,error:I,profileLocation:i}),I}}async updateMetadata(d,i){const h=[];return await this.u(i,u=>{const D=[];for(const I of u){const T=d.find(([O])=>(0,s.$Dp)(O.identifier,I.identifier)&&O.manifest.version===I.version);T&&(I.metadata={...I.metadata,...T[1]},h.push(I)),D.push(I)}return D}),h}async removeExtensionFromProfile(d,i){const h=[];try{await this.u(i,u=>{const D=[];for(const I of u)(0,s.$Dp)(I.identifier,d.identifier)?h.push(I):D.push(I);return h.length&&this.f.fire({extensions:h,profileLocation:i}),D}),h.length&&this.g.fire({extensions:h,profileLocation:i})}catch(u){throw h.length&&this.g.fire({extensions:h,error:u,profileLocation:i}),u}}async u(d,i,h){return this.F(d).queue(async()=>{let u=[],D;try{const I=await this.m.readFile(d);D=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,E.$ll)(I)!==E.FileOperationResult.FILE_NOT_FOUND)throw I;if(this.r.extUri.isEqual(d,this.n.defaultProfile.extensionsResource)&&(D=await this.D()),!D&&h?.bailOutWhenFileNotFound)throw new m((0,c.$0)(I),p.ERROR_PROFILE_NOT_FOUND)}if(D){Array.isArray(D)||this.w(d);let I=!1;for(const T of D){l(T)||this.w(d);let O;if((0,f.$ag)(T.relativeLocation)&&T.relativeLocation)O=this.z(T.relativeLocation);else if((0,f.$ag)(T.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${T.location}`);continue}else{O=A.URI.revive(T.location);const C=this.y(O);C&&(I=!0,T.relativeLocation=C)}(0,f.$hg)(T.metadata?.hasPreReleaseVersion)&&T.metadata?.preRelease&&(I=!0,T.metadata.hasPreReleaseVersion=!0),u.push({identifier:T.identifier,location:O,version:T.version,metadata:T.metadata})}I&&await this.m.writeFile(d,r.$Je.fromString(JSON.stringify(D)))}if(i){u=i(u);const I=u.map(T=>({identifier:T.identifier,version:T.version,location:T.location.toJSON(),relativeLocation:this.y(T.location),metadata:T.metadata}));await this.m.writeFile(d,r.$Je.fromString(JSON.stringify(I)))}return u})}w(d){const i=new m(`Invalid extensions content in ${d.toString()}`,p.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(d){return this.r.extUri.isEqual(this.r.extUri.dirname(d),this.j)?this.r.extUri.basename(d):void 0}z(d){return this.r.extUri.joinPath(this.j,d)}async D(){return this.C||(this.C=(async()=>{const d=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let h;try{h=(await this.m.readFile(d)).value.toString()}catch(D){if((0,E.$ll)(D)===E.FileOperationResult.FILE_NOT_FOUND)return;throw D}this.t.info("Migrating extensions from old default profile location",d.toString());let u;try{const D=JSON.parse(h);Array.isArray(D)&&D.every(I=>l(I))?u=D:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",D)}catch(D){this.t.error(D)}if(u)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,r.$Je.fromString(JSON.stringify(u)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",d.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(D){if((0,E.$ll)(D)===E.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",d.toString(),this.n.defaultProfile.extensionsResource.toString());else throw D}try{await this.m.del(d)}catch(D){(0,E.$ll)(D)!==E.FileOperationResult.FILE_NOT_FOUND&&this.t.error(D)}try{await this.m.del(i)}catch(D){(0,E.$ll)(D)!==E.FileOperationResult.FILE_NOT_FOUND&&this.t.error(D)}return u})()),this.C}F(d){let i=this.h.get(d);return i||(i=new n.$Hh,this.h.set(d,i)),i}};e.$zq=b,e.$zq=b=Ue([Ne(1,E.$7k),Ne(2,w.$Gl),Ne(3,a.$El),Ne(4,g.$6l),Ne(5,$.$7j)],b);function l(o){return(0,f.$cg)(o)&&(0,v.$bp)(o.identifier)&&(t(o.location)||(0,f.$ag)(o.location)&&o.location)&&((0,f.$hg)(o.relativeLocation)||(0,f.$ag)(o.relativeLocation))&&o.version&&(0,f.$ag)(o.version)}function t(o){return o?(0,f.$ag)(o.path)&&(0,f.$ag)(o.scheme):!1}}),define(Se[64],De([1,0,18,14,21,15,10,44,195,2,13,9,3,20,62,58,11,4,209,28,39,23,87,16,5,12,29,6,48,53,34,36,244]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m,b,l,t,o,d,i,h,u,D,I,T,O,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Eq=e.$Dq=e.$Cq=e.Translations=void 0,e.$Fq=x;var P;(function(q){function te(le,M){if(le===M)return!0;const z=Object.keys(le),oe=new Set;for(const ce of Object.keys(M))oe.add(ce);if(z.length!==oe.size)return!1;for(const ce of z){if(le[ce]!==M[ce])return!1;oe.delete(ce)}return oe.size===0}q.equals=te})(P||(e.Translations=P={})),e.$Cq=(0,d.$Ai)("IExtensionsScannerService");let Q=class extends s.$Uc{constructor(te,le,M,z,oe,ce,pe,W,ae,ee,H,L){super(),this.systemExtensionsLocation=te,this.userExtensionsLocation=le,this.r=M,this.s=z,this.t=oe,this.u=ce,this.w=pe,this.y=W,this.z=ae,this.C=ee,this.D=H,this.F=L,this.g=this.B(new u.$he),this.onDidChangeCache=this.g.event,this.h=(0,w.$bh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ne,this.s,this.h)),this.m=this.B(this.F.createInstance(ne,this.s,this.h)),this.n=this.B(this.F.createInstance(ie,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(l.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(l.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,b.$Op)(this.w,this.y)),this.G}async scanAllExtensions(te,le,M){const[z,oe]=await Promise.all([this.scanSystemExtensions(te),this.scanUserExtensions(le)]),ce=M?await this.scanExtensionsUnderDevelopment(te,[...z,...oe]):[];return this.L(z,oe,ce,await this.getTargetPlatform(),!0)}async scanSystemExtensions(te){const le=[];le.push(this.M(!!te.useCache,te.language)),le.push(this.N(te.language,!!te.checkControlFile));const[M,z]=await Promise.all(le);return this.J([...M,...z],l.ExtensionType.System,te,!1)}async scanUserExtensions(te){const le=te.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",le);const M=this.D.extUri.isEqual(te.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.P(le,!!te.profileLocation,l.ExtensionType.User,!te.includeUninstalled,te.language,!0,M,te.productVersion??this.R()),oe=te.useCache&&!z.devMode&&z.excludeObsolete?this.m:this.n;let ce;try{ce=await oe.scanExtensions(z)}catch(pe){if(pe instanceof I.$xq&&pe.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),ce=await oe.scanExtensions(z);else throw pe}return ce=await this.J(ce,l.ExtensionType.User,te,!0),this.y.trace("Scanned user extensions:",ce.length),ce}async scanExtensionsUnderDevelopment(te,le){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(z=>z.scheme===E.Schemas.file).map(async z=>{const oe=await this.P(z,!1,l.ExtensionType.User,!0,te.language,!1,void 0,te.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(oe)).map(pe=>(pe.type=le.find(W=>(0,b.$Dp)(W.identifier,pe.identifier))?.type??pe.type,this.n.validate(pe,oe)))}))).flat();return this.J(M,"development",te,!0)}return[]}async scanExistingExtension(te,le,M){const z=await this.P(te,!1,le,!0,M.language,!0,void 0,M.productVersion??this.R()),oe=await this.n.scanExtension(z);return!oe||!M.includeInvalid&&!oe.isValid?null:oe}async scanOneOrMultipleExtensions(te,le,M){const z=await this.P(te,!1,le,!0,M.language,!0,void 0,M.productVersion??this.R()),oe=await this.n.scanOneOrMultipleExtensions(z);return this.J(oe,le,M,!0)}async scanMultipleExtensions(te,le,M){const z=[];return await Promise.all(te.map(async oe=>{const ce=await this.scanOneOrMultipleExtensions(oe,le,M);z.push(...ce)})),this.J(z,le,M,!0)}async scanMetadata(te){const le=(0,w.$bh)(te,"package.json"),M=(await this.w.readFile(le)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(te,le){const M=(0,w.$bh)(te,"package.json"),z=(await this.w.readFile(M)).value.toString(),oe=JSON.parse(z);le.isMachineScoped===!1&&delete le.isMachineScoped,le.isBuiltin===!1&&delete le.isBuiltin,oe.__metadata={...oe.__metadata,...le},await this.w.writeFile((0,w.$bh)(te,"package.json"),k.$Je.fromString(JSON.stringify(oe,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(te){if(te instanceof I.$xq&&te.code===I.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw te}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const te=await this.scanUserExtensions({includeInvalid:!0});if(te.length)await this.u.addExtensionsToProfile(te.map(le=>[le,le.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Je.fromString(JSON.stringify([])))}catch(le){(0,o.$ll)(le)!==o.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.$0)(le))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(te){this.y.error(te)}finally{this.H=void 0}})()),this.H}async J(te,le,M,z){return M.includeAllVersions||(te=this.L(le===l.ExtensionType.System?te:void 0,le===l.ExtensionType.User?te:void 0,le==="development"?te:void 0,await this.getTargetPlatform(),z)),M.includeInvalid||(te=te.filter(oe=>oe.isValid)),te.sort((oe,ce)=>{const pe=y.$nc(oe.location.fsPath),W=y.$nc(ce.location.fsPath);return pe<W?-1:pe>W?1:0})}L(te,le,M,z,oe){const ce=(W,ae,ee)=>{if(W.isValid&&!ae.isValid)return!1;if(W.isValid===ae.isValid){if(oe&&a.gt(W.manifest.version,ae.manifest.version))return this.y.debug(`Skipping extension ${ae.location.path} with lower version ${ae.manifest.version} in favour of ${W.location.path} with version ${W.manifest.version}`),!1;if(a.eq(W.manifest.version,ae.manifest.version)){if(W.type===l.ExtensionType.System)return this.y.debug(`Skipping extension ${ae.location.path} in favour of system extension ${W.location.path} with same version`),!1;if(W.targetPlatform===z)return this.y.debug(`Skipping extension ${ae.location.path} from different target platform ${ae.targetPlatform}`),!1}}return ee?this.y.warn(`Overwriting user extension ${W.location.path} with ${ae.location.path}.`):this.y.debug(`Overwriting user extension ${W.location.path} with ${ae.location.path}.`),!0},pe=new l.$Zm;return te?.forEach(W=>{const ae=pe.get(W.identifier.id);(!ae||ce(ae,W,!1))&&pe.set(W.identifier.id,W)}),le?.forEach(W=>{const ae=pe.get(W.identifier.id);if(!ae&&te&&W.type===l.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${W.location.path}.`);return}(!ae||ce(ae,W,!1))&&pe.set(W.identifier.id,W)}),M?.forEach(W=>{const ae=pe.get(W.identifier.id);(!ae||ce(ae,W,!0))&&pe.set(W.identifier.id,W),pe.set(W.identifier.id,W)}),[...pe.values()]}async M(te,le){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,l.ExtensionType.System,!0,le,!0,void 0,this.R()),oe=await(te&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",oe.length),oe}async N(te,le){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const z=le?await this.O():{},oe=[],ce=g.URI.file(y.$hc(y.$jc(E.$Ug.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const W of M){const ae=z[W.name]||"marketplace";switch(ae){case"disabled":break;case"marketplace":oe.push((0,w.$bh)(ce,W.name));break;default:oe.push(g.URI.file(ae));break}}const pe=await Promise.all(oe.map(async W=>this.n.scanExtension(await this.P(W,!1,l.ExtensionType.System,!0,te,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",pe.length),(0,n.$Hb)(pe)}async O(){try{const te=await this.w.readFile(this.r);return JSON.parse(te.value.toString())}catch{return{}}}async P(te,le,M,z,oe,ce,pe,W){const ae=await this.f(oe??$.$q),ee=await this.Q(te),H=le&&!this.D.extUri.isEqual(te,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,L=H?await this.Q(H):void 0;return new X(te,ee,H,L,le,pe,M,z,ce,W.version,W.date,this.C.commit,!this.z.isBuilt,oe,ae)}async Q(te){try{const le=await this.w.stat(te);if(typeof le.mtime=="number")return le.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Dq=Q,e.$Dq=Q=Ue([Ne(4,T.$Gl),Ne(5,I.$yq),Ne(6,o.$7k),Ne(7,i.$7j),Ne(8,m.$Hi),Ne(9,h.$nk),Ne(10,O.$El),Ne(11,d.$zi)],Q);class X{constructor(te,le,M,z,oe,ce,pe,W,ae,ee,H,L,V,B,U){this.location=te,this.mtime=le,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=z,this.profile=oe,this.profileScanOptions=ce,this.type=pe,this.excludeObsolete=W,this.validate=ae,this.productVersion=ee,this.productDate=H,this.productCommit=L,this.devMode=V,this.language=B,this.translations=U}static createNlsConfiguration(te){return{language:te.language,pseudo:te.language==="pseudo",devMode:te.devMode,translations:te.translations}}static equals(te,le){return(0,w.$7g)(te.location,le.location)&&te.mtime===le.mtime&&(0,w.$7g)(te.applicationExtensionslocation,le.applicationExtensionslocation)&&te.applicationExtensionslocationMtime===le.applicationExtensionslocationMtime&&te.profile===le.profile&&S.$bo(te.profileScanOptions,le.profileScanOptions)&&te.type===le.type&&te.excludeObsolete===le.excludeObsolete&&te.validate===le.validate&&te.productVersion===le.productVersion&&te.productDate===le.productDate&&te.productCommit===le.productCommit&&te.devMode===le.devMode&&te.language===le.language&&P.equals(te.translations,le.translations)}}e.$Eq=X;let ie=class extends s.$Uc{constructor(te,le,M,z,oe){super(),this.f=te,this.g=le,this.h=M,this.j=z,this.m=oe}async scanExtensions(te){const le=te.profile?await this.r(te):await this.n(te);let M={};if(te.excludeObsolete&&te.type===l.ExtensionType.User)try{const z=(await this.j.readFile(this.f)).value.toString();M=JSON.parse(z)}catch{}return(0,c.$ng)(M)?le:le.filter(z=>!M[b.$Ep.create(z).toString()])}async n(te){const le=await this.j.resolve(te.location);if(!le.children?.length)return[];const M=await Promise.all(le.children.map(async z=>{if(!z.isDirectory||te.type===l.ExtensionType.User&&(0,w.$$g)(z.resource).indexOf(".")===0)return null;const oe=new X(z.resource,te.mtime,te.applicationExtensionslocation,te.applicationExtensionslocationMtime,te.profile,te.profileScanOptions,te.type,te.excludeObsolete,te.validate,te.productVersion,te.productDate,te.productCommit,te.devMode,te.language,te.translations);return this.scanExtension(oe)}));return(0,n.$Hb)(M).sort((z,oe)=>z.location.path<oe.location.path?-1:1)}async r(te){let le=await this.s(te.location,()=>!0,te);if(te.applicationExtensionslocation&&!this.h.extUri.isEqual(te.location,te.applicationExtensionslocation)){le=le.filter(z=>!z.metadata?.isApplicationScoped);const M=await this.s(te.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,te);le.push(...M)}return le}async s(te,le,M){const z=await this.g.scanProfileExtensions(te,M.profileScanOptions);if(!z.length)return[];const oe=await Promise.all(z.map(async ce=>{if(le(ce)){const pe=new X(ce.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(pe,ce.metadata)}return null}));return(0,n.$Hb)(oe)}async scanOneOrMultipleExtensions(te){try{if(await this.j.exists((0,w.$bh)(te.location,"package.json"))){const le=await this.scanExtension(te);return le?[le]:[]}else return await this.scanExtensions(te)}catch(le){return this.m.error(`Error scanning extensions at ${te.location.path}:`,(0,R.$0)(le)),[]}}async scanExtension(te,le){try{let M=await this.scanExtensionManifest(te.location);if(M){M.publisher||(M.publisher=l.$Tm),le=le??M.__metadata,delete M.__metadata;const z=(0,b.$Ip)(M.publisher,M.name),oe=le?.id?{id:z,uuid:le.id}:{id:z},ce=le?.isSystem?l.ExtensionType.System:te.type,pe=ce===l.ExtensionType.System||!!le?.isBuiltin;M=await this.t(te.location,M,X.createNlsConfiguration(te));const W={type:ce,identifier:oe,manifest:M,location:te.location,isBuiltin:pe,targetPlatform:le?.targetPlatform??l.TargetPlatform.UNDEFINED,publisherDisplayName:le?.publisherDisplayName,metadata:le,isValid:!0,validations:[]};return te.validate?this.validate(W,te):W}}catch(M){te.type!==l.ExtensionType.System&&this.m.error(M)}return null}validate(te,le){let M=!0;const z=(0,t.$Tp)(le.productVersion,le.productDate,le.location,te.manifest,te.isBuiltin);for(const[oe,ce]of z)oe===f.default.Error&&(M=!1,this.m.error(this.z(le.location,ce)));return te.isValid=M,te.validations=z,te}async scanExtensionManifest(te){const le=(0,w.$bh)(te,"package.json");let M;try{M=(await this.j.readFile(le)).value.toString()}catch(oe){return(0,o.$ll)(oe)!==o.FileOperationResult.FILE_NOT_FOUND&&this.m.error(this.z(te,(0,p.localize)(0,null,le.path,oe.message))),null}let z;try{z=JSON.parse(M)}catch{const ce=[];(0,A.$Qn)(M,ce);for(const pe of ce)this.m.error(this.z(te,(0,p.localize)(1,null,le.path,pe.offset,pe.length,(0,v.$Aq)(pe.error))));return null}return(0,A.$Zn)(z)!=="object"?(this.m.error(this.z(te,(0,p.localize)(2,null,le.path))),null):z}async t(te,le,M){const z=await this.u(te,le,M);if(z)try{const oe=[],ce=await this.w(z.default,oe);if(oe.length>0)return oe.forEach(W=>{this.m.error(this.z(te,(0,p.localize)(3,null,z.default?.path,(0,v.$Aq)(W.error))))}),le;if((0,A.$Zn)(z)!=="object")return this.m.error(this.z(te,(0,p.localize)(4,null,z.default?.path))),le;const pe=z.values||Object.create(null);return(0,C.$Bq)(this.m,le,pe,ce)}catch{}return le}async u(te,le,M){const z=(0,w.$bh)(te,"package.nls.json"),oe=(ae,ee)=>{ee.forEach(H=>{this.m.error(this.z(te,(0,p.localize)(5,null,ae?.path,(0,v.$Aq)(H.error))))})},ce=ae=>{this.m.error(this.z(te,(0,p.localize)(6,null,ae?.path)))},pe=`${le.publisher}.${le.name}`,W=M.translations[pe];if(W)try{const ae=g.URI.file(W),ee=(await this.j.readFile(ae)).value.toString(),H=[],L=(0,A.$Qn)(ee,H);return H.length>0?(oe(ae,H),{values:void 0,default:z}):(0,A.$Zn)(L)!=="object"?(ce(ae),{values:void 0,default:z}):{values:L.contents?L.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.j.exists(z))return;let ee;try{ee=await this.y(te,M)}catch{return}if(!ee.localized)return{values:void 0,default:ee.original};try{const H=(await this.j.readFile(ee.localized)).value.toString(),L=[],V=(0,A.$Qn)(H,L);return L.length>0?(oe(ee.localized,L),{values:void 0,default:ee.original}):(0,A.$Zn)(V)!=="object"?(ce(ee.localized),{values:void 0,default:ee.original}):{values:V,default:ee.original}}catch{return{values:void 0,default:ee.original}}}}async w(te,le){if(te)try{const M=(await this.j.readFile(te)).value.toString();return(0,A.$Qn)(M,le)}catch{}}y(te,le){return new Promise((M,z)=>{const oe=ce=>{const pe=(0,w.$bh)(te,`package.nls.${ce}.json`);this.j.exists(pe).then(W=>{W&&M({localized:pe,original:(0,w.$bh)(te,"package.nls.json")});const ae=ce.lastIndexOf("-");ae===-1?M({localized:(0,w.$bh)(te,"package.nls.json"),original:null}):(ce=ce.substring(0,ae),oe(ce))})};if(le.devMode||le.pseudo||!le.language)return M({localized:(0,w.$bh)(te,"package.nls.json"),original:null});oe(le.language)})}z(te,le){return`[${te.path}]: ${le}`}};ie=Ue([Ne(1,I.$yq),Ne(2,O.$El),Ne(3,o.$7k),Ne(4,i.$7j)],ie);let ne=class extends ie{constructor(te,le,M,z,oe,ce,pe){super(le,z,oe,ce,pe),this.G=te,this.H=M,this.D=this.B(new r.$yh(3e3)),this.F=this.B(new u.$he),this.onDidChangeCache=this.F.event}async scanExtensions(te){const le=this.M(te),M=await this.I(le);if(this.C=te,M&&M.input&&X.equals(M.input,this.C))return this.m.debug("Using cached extensions scan result",te.location.toString()),this.D.trigger(()=>this.L()),M.result.map(oe=>(oe.location=g.URI.revive(oe.location),oe));const z=await super.scanExtensions(te);return await this.J(le,{input:te,result:z}),z}async I(te){try{const le=await this.j.readFile(te),M=JSON.parse(le.value.toString());return{result:M.result,input:(0,D.$0h)(M.input)}}catch(le){this.m.debug("Error while reading the extension cache file:",te.path,(0,R.$0)(le))}return null}async J(te,le){try{await this.j.writeFile(te,k.$Je.fromString(JSON.stringify(le)))}catch(M){this.m.debug("Error while writing the extension cache file:",te.path,(0,R.$0)(M))}}async L(){if(!this.C)return;const te=this.M(this.C),le=await this.I(te);if(!le)return;const M=le.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$bo(z,M))try{this.m.info("Invalidating Cache",M,z),await this.j.del(te),this.F.fire()}catch(oe){this.m.error(oe)}}M(te){const le=this.N(te);return this.h.extUri.joinPath(le.cacheHome,te.type===l.ExtensionType.System?l.$Sm:l.$Rm)}N(te){return te.type===l.ExtensionType.System?this.H.defaultProfile:te.profile?this.h.extUri.isEqual(te.location,this.G.extensionsResource)?this.G:this.H.profiles.find(le=>this.h.extUri.isEqual(te.location,le.extensionsResource))??this.G:this.H.defaultProfile}};ne=Ue([Ne(2,T.$Gl),Ne(3,I.$yq),Ne(4,O.$El),Ne(5,o.$7k),Ne(6,i.$7j)],ne);function x(q,te){const le=(0,b.$Gp)(q.manifest.publisher,q.manifest.name);return{id:le,identifier:new l.$Xm(le),isBuiltin:q.type===l.ExtensionType.System,isUserBuiltin:q.type===l.ExtensionType.User&&q.isBuiltin,isUnderDevelopment:te,extensionLocation:q.location,uuid:q.identifier.uuid,targetPlatform:q.targetPlatform,publisherDisplayName:q.publisherDisplayName,...q.manifest}}class re extends Q{constructor(te,le,M,z,oe,ce,pe,W,ae,ee,H,L){super(te,le,(0,w.$bh)(M,".vscode-oss-dev","extensions","control.json"),z,oe,ce,pe,W,ae,ee,H,L),this.S=(async()=>{if($.$t)try{const V=await this.w.readFile(g.URI.file($.$t));return JSON.parse(V.value.toString())}catch{}return Object.create(null)})()}f(te){return this.S}}e.$Gq=re}),define(Se[288],De([1,0,60,14,42,6,2,13,9,25,12,34]),function(he,e,n,r,S,k,R,A,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=void 0;let $=class extends R.$Uc{constructor(a,f){super(),this.b=a,this.f=f,this.a=new r.$Gh(5)}async postUninstall(a){const f=this.g(a,"uninstall");f&&(this.f.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(f.script,"uninstall",f.args,!0,a),this.f.info("Finished running post uninstall script",a.identifier.id,a.manifest.version)}catch(c){this.f.error("Failed to run post uninstall script",a.identifier.id,a.manifest.version),this.f.error(c)}}));try{await s.Promises.rm(this.m(a))}catch(c){this.f.error("Error while removing extension storage path",a.identifier.id),this.f.error(c)}}g(a,f){const c=`vscode:${f}`;if(a.location.scheme===A.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[c]=="string"){const g=a.manifest.scripts[c].split(" ");return g.length<2||g[0]!=="node"||!g[1]?(this.f.warn(a.identifier.id,a.manifest.version,`${c} should be a node script`),null):{script:(0,v.$jc)(a.location.fsPath,g[1]),args:g.slice(2)||[]}}return null}h(a,f,c,g,p){return new Promise((m,b)=>{const l=this.j(a,f,c,p);let t;const o=d=>{t&&(clearTimeout(t),t=null),d?b(d):m(void 0)};l.on("error",d=>{o((0,S.$lj)(d)||"Unknown")}),l.on("exit",(d,i)=>{o(d?`post-${f} process exited with code ${d}`:void 0)}),g&&(t=setTimeout(()=>{t=null,l.kill(),b("timed out")},5e3))})}j(a,f,c,g){const p={silent:!0,execArgv:void 0},m=(0,n.fork)(a,[`--type=extension-post-${f}`,...c],p);m.stdout.setEncoding("utf8"),m.stderr.setEncoding("utf8");const b=k.Event.fromNodeEventEmitter(m.stdout,"data"),l=k.Event.fromNodeEventEmitter(m.stderr,"data");this.B(b(d=>this.f.info(g.identifier.id,g.manifest.version,`post-${f}`,d))),this.B(l(d=>this.f.error(g.identifier.id,g.manifest.version,`post-${f}`,d)));const t=k.Event.any(k.Event.map(b,d=>({data:`%c${d}`,format:[""]}),this.q),k.Event.map(l,d=>({data:`%c${d}`,format:["color: red"]}),this.q));return k.Event.debounce(t,(d,i)=>d?{data:d.data+i.data,format:[...d.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(d=>{console.group(g.identifier.id),console.log(d.data,...d.format),console.groupEnd()}),m}m(a){return(0,v.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};e.$Kq=$,e.$Kq=$=Ue([Ne(0,y.$Gl),Ne(1,E.$7j)],$)}),define(Se[138],De([1,0,86,211,99,30]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=R,e.$Iq=A;function R(v){let s=k.ExtensionManagementErrorCode.Extract;return v instanceof n.$qq&&(v.type==="CorruptZip"?s=k.ExtensionManagementErrorCode.CorruptZip:v.type==="Incomplete"&&(s=k.ExtensionManagementErrorCode.IncompleteZip)),(0,S.$vq)(v,s)}async function A(v){let s;try{s=await(0,n.$tq)(v,"extension/package.json")}catch(E){throw R(E)}try{return JSON.parse(s.toString("utf8"))}catch{throw new k.$ep((0,r.localize)(0,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(Se[289],De([1,0,14,10,2,13,20,62,11,22,25,86,27,28,99,30,39,138,95,16,12,24]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m,b,l){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=void 0;let o=t=class extends S.$Uc{constructor(i,h,u,D,I,T,O){super(),this.h=h,this.j=u,this.m=D,this.n=I,this.r=T,this.t=O,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(i,h,u,D){await this.g;const I=await this.w(i,h);let T=!1;if(u&&this.u(i)){let O;try{O=await this.y(i)}catch(C){try{await this.delete(I)}catch(P){this.t.error(P)}throw C}try{T=await this.n.verify(i,I.fsPath,O.fsPath,D)}catch(C){if(T=C.code,T===p.ExtensionSignatureVerificationCode.PackageIsInvalidZip||T===p.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete(I)}catch(P){this.t.error(P)}throw new f.$ep(y.$pq,f.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(O)}catch(C){this.t.error(C)}}}return{location:I,verificationStatus:T}}u(i){return i.isSigned||this.t.info(`Extension is not signed: ${i.identifier.id}`),!1}async w(i,h){try{const u=(0,R.$bh)(this.extensionsDownloadDir,this.G(i)),D=await this.C(i,"vsix",async()=>{await this.z(i,u,I=>this.j.download(i,I,h));try{await this.D(u.fsPath,"extension/package.json")}catch(I){try{await this.h.del(u)}catch(T){this.t.warn(`Error while deleting: ${u.path}`,(0,r.$0)(T))}throw I}},2);return D>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:i.identifier.id,attempts:D}),u}catch(u){throw(0,a.$vq)(u,f.ExtensionManagementErrorCode.Download)}}async y(i){try{const h=(0,R.$bh)(this.extensionsDownloadDir,`.${(0,s.$Wg)()}`),u=await this.C(i,"sigzip",async()=>{await this.j.downloadSignatureArchive(i,h);try{await this.D(h.fsPath,".signature.p7s")}catch(D){try{await this.h.del(h)}catch(I){this.t.warn(`Error while deleting: ${h.path}`,(0,r.$0)(I))}throw D}},2);return u>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:i.identifier.id,attempts:u}),h}catch(h){throw(0,a.$vq)(h,f.ExtensionManagementErrorCode.DownloadSignature)}}async z(i,h,u){if(await this.h.exists(h))return;if(h.scheme!==k.Schemas.file){await u(h);return}const D=(0,R.$bh)(this.extensionsDownloadDir,`.${(0,s.$Wg)()}`);try{await u(D)}catch(I){try{await this.h.del(D)}catch{}throw I}try{await E.Promises.rename(D.fsPath,h.fsPath,2*60*1e3)}catch(I){try{await this.h.del(D)}catch{}let T=!1;try{T=await this.h.exists(h)}catch{}if(T)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,h.path);else throw this.t.info(`Rename failed because of ${(0,r.$0)(I)}. Deleted the file from downloaded location`,D.path),I}}async C(i,h,u,D){let I=1;for(;;)try{return await u(),I}catch(T){if(I++>D)throw T;this.t.warn(`Failed downloading ${h}. ${(0,r.$0)(T)}. Retry again...`,i.identifier.id)}}async D(i,h){try{await(0,y.$tq)(i,h)}catch(u){throw(0,g.$Hq)(u)}}async delete(i){await this.g,await this.h.del(i)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const h=[],u=[],D=[];for(const O of i.children)if(O.name.endsWith(t.c))D.push(O.resource);else{const C=c.$Ep.parse(O.name);C&&u.push([C,O])}const I=(0,c.$Jp)(u,([O])=>O),T=[];for(const O of I)O.sort((C,P)=>A.rcompare(C[0].version,P[0].version)),h.push(...O.slice(1).map(C=>C[1].resource)),T.push(O[0][1]);T.sort((O,C)=>O.mtime-C.mtime),h.push(...T.slice(0,Math.max(0,T.length-this.f)).map(O=>O.resource)),h.push(...D),await n.Promises.settled(h.map(O=>(this.t.trace("Deleting from cache",O.path),this.h.del(O))))}}catch(i){this.t.error(i)}}G(i){return this.f?c.$Ep.create(i).toString().toLowerCase():(0,s.$Wg)()}};e.$Jq=o,o.c=".sigzip",e.$Jq=o=t=Ue([Ne(0,w.$Ii),Ne(1,m.$7k),Ne(2,f.$cp),Ne(3,$.$7i),Ne(4,p.$iq),Ne(5,l.$6l),Ne(6,b.$7j)],o)}),define(Se[139],De([1,0,14,15,19,42,10,6,68,2,26,13,9,20,62,11,4,22,25,86,210,88,28,99,30,39,53,64,289,288,138,265,274,23,87,16,5,12,29,24,36,34]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m,b,l,t,o,d,i,h,u,D,I,T,O,C,P,Q,X,ie,ne,x,re,q,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pq=e.$Oq=e.$Nq=void 0,e.$Nq=(0,ie.$Bi)(d.$fp);const le=".vsctmp";let M=class extends o.$uq{constructor(W,ae,ee,H,L,V,B,U,K,Z,j,G){super(W,ae,j,ee,Z,G),this.eb=L,this.fb=V,this.gb=B,this.hb=U,this.ib=K,this.db=new Map,this.tb=new E.$Bc;const se=this.B(U.createInstance(I.$Kq));this.ab=this.B(U.createInstance(z,Ee=>se.postUninstall(Ee))),this.bb=this.B(new O.$Lq(G,K,j,this,this.F)),this.cb=this.B(U.createInstance(D.$Jq));const fe=this.B(new C.$Mq(this,this.eb,G,V,j,K,ee));this.B(fe.onDidChangeExtensionsByAnotherSource(Ee=>this.sb(Ee))),this.ub()}getTargetPlatform(){return this.jb||(this.jb=(0,i.$Op)(this.ib,this.F)),this.jb}async zip(W){this.F.trace("ExtensionManagementService#zip",W.identifier.id);const ae=await this.rb(W),ee=await(0,m.zip)((0,w.$bh)(this.cb.extensionsDownloadDir,(0,g.$Wg)()).fsPath,ae);return c.URI.file(ee)}async unzip(W){return this.F.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const{location:ae,cleanup:ee}=await this.lb(W),H=$.$kc(ae.fsPath);try{return await(0,T.$Iq)(H)}finally{await ee()}}getInstalled(W,ae=this.H.defaultProfile.extensionsResource,ee={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(W??null,ae,ee)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(W){return this.ab.scanUserExtensionAtLocation(W)}async install(W,ae={}){this.F.trace("ExtensionManagementService#install",W.toString());const{location:ee,cleanup:H}=await this.lb(W);try{const L=await(0,T.$Iq)($.$kc(ee.fsPath)),V=(0,i.$Ip)(L.publisher,L.name);if(L.engines&&L.engines.vscode&&!(0,Q.$Vp)(L.engines.vscode,this.G.version,this.G.date))throw new Error(b.localize(0,null,V,this.G.version));const U=(await this.I([{manifest:L,extension:ee,options:ae}])).find(({identifier:K})=>(0,i.$Dp)(K,{id:V}));if(U?.local)return U.local;throw U?.error?U.error:(0,o.$vq)(new Error(`Unknown error while installing extension ${V}`))}finally{await H()}}async installFromLocation(W,ae){this.F.trace("ExtensionManagementService#installFromLocation",W.toString());const ee=await this.ab.scanUserExtensionAtLocation(W);if(!ee||!ee.manifest.name||!ee.manifest.version)throw new Error(`Cannot find a valid extension from the location ${W.toString()}`);return await this.wb([[ee,{source:"resource"}]],ae),this.F.info("Successfully installed extension",ee.identifier.id,ae.toString()),ee}async installExtensionsFromProfile(W,ae,ee){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",W,ae.toString(),ee.toString());const H=(await this.getInstalled(P.ExtensionType.User,ae)).filter(L=>W.some(V=>(0,i.$Dp)(V,L.identifier)));if(H.length){const L=await Promise.all(H.map(V=>this.ab.scanMetadata(V,ae)));await this.wb(H.map((V,B)=>[V,L[B]]),ee),this.F.info("Successfully installed extensions",H.map(V=>V.identifier.id),ee.toString())}return H}async updateMetadata(W,ae,ee=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",W.identifier.id),ae.isPreReleaseVersion&&(ae.preRelease=!0,ae.hasPreReleaseVersion=!0),ae.isMachineScoped===!1&&(ae.isMachineScoped=void 0),ae.isBuiltin===!1&&(ae.isBuiltin=void 0),ae.pinned===!1&&(ae.pinned=void 0),W=await this.ab.updateMetadata(W,ae,ee),this.bb.invalidate(ee),this.w.fire(W),W}async reinstallFromGallery(W){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",W.identifier.id),!this.z.isEnabled())throw new Error(b.localize(1,null));const ae=await this.getTargetPlatform(),[ee]=await this.z.getExtensions([{...W.identifier,preRelease:W.preRelease}],{targetPlatform:ae,compatible:!0},S.CancellationToken.None);if(!ee)throw new Error(b.localize(2,null));await this.ab.setUninstalled(W);try{await this.ab.removeUninstalledExtension(W)}catch(H){throw new Error(b.localize(3,null,(0,k.$lj)(H)))}return this.installFromGallery(ee)}$(W,ae,ee,H){return this.ab.copyExtension(W,ae,ee,H)}copyExtensions(W,ae){return this.ab.copyExtensions(W,ae,{version:this.G.version,date:this.G.date})}markAsUninstalled(...W){return this.ab.setUninstalled(...W)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(W){this.F.error(W)}}async download(W,ae,ee){const{location:H}=await this.cb.download(W,ae,!ee);return H}async lb(W){if(W.scheme===y.Schemas.file)return{location:W,async cleanup(){}};this.F.trace("Downloading extension from",W.toString());const ae=(0,w.$bh)(this.cb.extensionsDownloadDir,(0,g.$Wg)());return await this.gb.download(W,ae),this.F.info("Downloaded extension to",ae.toString()),{location:ae,cleanup:async()=>{try{await this.ib.del(ae)}catch(H){this.F.error(H)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(W,ae,ee){const H=ae instanceof c.URI?new i.$Ep({id:(0,i.$Ip)(W.publisher,W.name)},W.version):i.$Ep.create(ae);return this.hb.createInstance(oe,H,W,ae,ee,(L,V)=>{if(ae instanceof c.URI)return this.qb(H,ae,ee,V);let B=this.db.get(H.toString());return B||(this.db.set(H.toString(),B=this.pb(H,ae,L,ee,V)),B.finally(()=>this.db.delete(H.toString()))),B},this.ab)}Z(W,ae){return new ce(W,ae.profileLocation,this.fb)}async pb(W,ae,ee,H,L){const{verificationStatus:V,location:B}=await this.cb.download(ae,ee,!H.donotVerifySignature,H.context?.[d.$8o]);try{if(L.isCancellationRequested)throw new R.$5;return await(0,T.$Iq)(B.fsPath),{local:await this.ab.extractUserExtension(W,B.fsPath,{id:ae.identifier.uuid,publisherId:ae.publisherId,publisherDisplayName:ae.publisherDisplayName,targetPlatform:ae.properties.targetPlatform,isApplicationScoped:H.isApplicationScoped,isMachineScoped:H.isMachineScoped,isBuiltin:H.isBuiltin,isPreReleaseVersion:ae.properties.isPreReleaseVersion,hasPreReleaseVersion:ae.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:H.installGivenVersion?!0:!!H.pinned,preRelease:(0,f.$gg)(H.preRelease)?H.preRelease:H.installPreReleaseVersion||ae.properties.isPreReleaseVersion,source:"gallery"},!1,L),verificationStatus:V}}catch(U){try{await this.cb.delete(B)}catch(K){this.F.warn("Error while deleting the downloaded file",B.toString(),(0,R.$0)(K))}throw(0,o.$vq)(U)}}async qb(W,ae,ee,H){return{local:await this.ab.extractUserExtension(W,$.$kc(ae.fsPath),{isApplicationScoped:ee.isApplicationScoped,isMachineScoped:ee.isMachineScoped,isBuiltin:ee.isBuiltin,installedTimestamp:Date.now(),pinned:ee.installGivenVersion?!0:!!ee.pinned,source:"vsix"},!0,H)}}async rb(W){const ae=async H=>{let L=await p.Promises.readdir(H);L=L.map(U=>$.$jc(H,U));const V=await Promise.all(L.map(U=>p.Promises.stat(U)));let B=Promise.resolve([]);return V.forEach((U,K)=>{const Z=L[K];U.isFile()&&(B=B.then(j=>[...j,Z])),U.isDirectory()&&(B=B.then(j=>ae(Z).then(G=>[...j,...G])))}),B};return(await ae(W.location.fsPath)).map(H=>({path:`extension/${$.$lc(W.location.fsPath,H)}`,localPath:H}))}async sb({added:W,removed:ae}){if(ae){const ee=W&&this.D.extUri.isEqual(ae.profileLocation,W.profileLocation)?ae.extensions.filter(H=>W.extensions.every(L=>!(0,i.$Dp)(L,H))):ae.extensions;for(const H of ee)this.F.info("Extensions removed from another source",H.id,ae.profileLocation.toString()),this.u.fire({identifier:H,profileLocation:ae.profileLocation})}if(W){const H=(await this.getInstalled(P.ExtensionType.User,W.profileLocation)).filter(L=>W.extensions.some(V=>(0,i.$Dp)(V,L.identifier)));this.s.fire(H.map(L=>(this.F.info("Extensions added from another source",L.identifier.id,W.profileLocation.toString()),{identifier:L.identifier,local:L,profileLocation:W.profileLocation,operation:d.InstallOperation.None})))}}async ub(){this.B(this.ab.onExtract(ae=>this.tb.add(ae)));const W=await this.ib.resolve(this.eb.userExtensionsLocation);for(const ae of W.children??[])ae.isDirectory&&this.tb.add(ae.resource);this.B(this.ib.watch(this.eb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(ae=>this.vb(ae)))}async vb(W){if(!W.affects(this.eb.userExtensionsLocation,X.FileChangeType.ADDED))return;const ae=[];for(const ee of W.rawAdded){if(this.tb.has(ee)||!this.D.extUri.isEqual(this.D.extUri.dirname(ee),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(ee,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(ee).startsWith(".")||!(await this.ib.stat(ee)).isDirectory)continue;const H=await this.ab.scanUserExtensionAtLocation(ee);H&&H.installedTimestamp===void 0&&(this.tb.add(ee),ae.push(H))}ae.length&&(await this.wb(ae.map(ee=>[ee,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",ae.map(ee=>ee.identifier.id)))}async wb(W,ae){const ee=W.map(H=>H[0]);await this.xb(ee),await this.fb.addExtensionsToProfile(W,ae),this.s.fire(ee.map(H=>({local:H,identifier:H.identifier,operation:d.InstallOperation.None,profileLocation:ae})))}async xb(W){const ae=await this.ab.getUninstalledExtensions();for(const ee of W){const H=i.$Ep.create(ee);ae[H.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",H.id),await this.ab.setInstalled(H),this.F.info("Removed the extension from uninstalled list:",H.id))}}};e.$Oq=M,e.$Oq=M=Ue([Ne(0,d.$cp),Ne(1,re.$6l),Ne(2,ne.$7j),Ne(3,t.$Ii),Ne(4,u.$Cq),Ne(5,h.$yq),Ne(6,l.$So),Ne(7,ie.$zi),Ne(8,X.$7k),Ne(9,x.$nk),Ne(10,q.$El),Ne(11,te.$Gl)],M);let z=class extends s.$Uc{constructor(W,ae,ee,H,L,V){super(),this.j=W,this.m=ae,this.n=ee,this.s=H,this.t=L,this.u=V,this.h=this.B(new A.$he),this.onExtract=this.h.event,this.c=(0,w.$bh)(this.n.userExtensionsLocation,".obsolete"),this.g=new n.$Hh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(W,ae,ee){try{const H={includeInvalid:!0,profileLocation:ae,productVersion:ee};let L=[];return W===null||W===P.ExtensionType.System?L.push(...await this.n.scanAllExtensions({includeInvalid:!0},H,!1)):W===P.ExtensionType.User&&L.push(...await this.n.scanUserExtensions(H)),L=W!==null?L.filter(V=>V.type===W):L,await Promise.all(L.map(V=>this.F(V)))}catch(H){throw(0,o.$vq)(H,d.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(W){try{const ae=await this.n.scanUserExtensions({includeAllVersions:!W,includeInvalid:!0});return await Promise.all(ae.map(ee=>this.F(ee)))}catch(ae){throw(0,o.$vq)(ae,d.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(W){try{const ae=await this.n.scanExistingExtension(W,P.ExtensionType.User,{includeInvalid:!0});if(ae)return await this.F(ae)}catch(ae){this.u.error(ae)}return null}async extractUserExtension(W,ae,ee,H,L){const V=W.toString(),B=c.URI.file($.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,g.$Wg)()}`)),U=c.URI.file($.$jc(this.n.userExtensionsLocation.fsPath,V));let K=await this.m.exists(U);if(K&&H){try{await this.y(W.id,U,"removeExisting")}catch{throw new d.$ep(b.localize(4,null,U.fsPath,W.id),d.ExtensionManagementErrorCode.Delete)}K=!1}if(K)try{await this.n.updateMetadata(U,ee)}catch(Z){throw(0,o.$vq)(Z,d.ExtensionManagementErrorCode.UpdateMetadata)}else try{if(L.isCancellationRequested)throw new R.$5;try{this.u.trace(`Started extracting the extension from ${ae} to ${U.fsPath}`),await(0,m.$sq)(ae,B.fsPath,{sourcePath:"extension",overwrite:!0},L),this.u.info(`Extracted extension to ${U}:`,W.id)}catch(Z){throw(0,T.$Hq)(Z)}try{await this.n.updateMetadata(B,ee)}catch(Z){throw(0,o.$vq)(Z,d.ExtensionManagementErrorCode.UpdateMetadata)}if(L.isCancellationRequested)throw new R.$5;try{this.u.trace(`Started renaming the extension from ${B.fsPath} to ${U.fsPath}`),await this.C(B.fsPath,U.fsPath),this.u.info("Renamed to",U.fsPath)}catch(Z){if(Z.code==="ENOTEMPTY"){this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",W.id);try{await this.m.del(B,{recursive:!0})}catch{}}else throw this.u.info(`Rename failed because of ${(0,R.$0)(Z)}. Deleted from extracted location`,B),Z}this.h.fire(U)}catch(Z){try{await this.m.del(B,{recursive:!0})}catch{}throw Z}return this.D(U,P.ExtensionType.User)}async scanMetadata(W,ae){return ae?(await this.w(W,ae))?.metadata:this.n.scanMetadata(W.location)}async w(W,ae){return(await this.s.scanProfileExtensions(ae)).find(H=>(0,i.$Dp)(H.identifier,W.identifier))}async updateMetadata(W,ae,ee){try{ee?await this.s.updateMetadata([[W,ae]],ee):await this.n.updateMetadata(W.location,ae)}catch(H){throw(0,o.$vq)(H,d.ExtensionManagementErrorCode.UpdateMetadata)}return this.D(W.location,W.type,ee)}async getUninstalledExtensions(){try{return await this.z()}catch(W){throw(0,o.$vq)(W,d.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...W){const ae=W.map(ee=>i.$Ep.create(ee));await this.z(ee=>ae.forEach(H=>{ee[H.toString()]=!0,this.u.info("Marked extension as uninstalled",H.toString())}))}async setInstalled(W){try{await this.z(ae=>delete ae[W.toString()])}catch(ae){throw(0,o.$vq)(ae,d.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(W,ae){if(this.t.extUri.isEqualOrParent(W.location,this.n.userExtensionsLocation))return this.y(W.identifier.id,W.location,ae)}async removeUninstalledExtension(W){await this.removeExtension(W,"uninstalled"),await this.z(ae=>delete ae[i.$Ep.create(W).toString()])}async copyExtension(W,ae,ee,H){const L=await this.w(W,ae),V=await this.w(W,ee);if(H={...L?.metadata,...H},V)if(this.t.extUri.isEqual(V.location,W.location))await this.s.updateMetadata([[W,{...V.metadata,...H}]],ee);else{const B=await this.D(V.location,W.type,ee);await this.s.removeExtensionFromProfile(B,ee),await this.s.addExtensionsToProfile([[W,{...V.metadata,...H}]],ee)}else await this.s.addExtensionsToProfile([[W,H]],ee);return this.D(W.location,W.type,ee)}async copyExtensions(W,ae,ee){const H=await this.scanExtensions(P.ExtensionType.User,W,ee),L=await Promise.all(H.filter(V=>!V.isApplicationScoped).map(async V=>[V,await this.scanMetadata(V,W)]));await this.s.addExtensionsToProfile(L,ae)}async y(W,ae,ee){this.u.trace(`Deleting ${ee} extension from disk`,W,ae.fsPath);const H=this.t.extUri.joinPath(this.t.extUri.dirname(ae),`${this.t.extUri.basename(ae)}.${(0,v.$oj)((0,g.$Wg)()).toString(16)}${le}`);await this.C(ae.fsPath,H.fsPath),await this.m.del(H,{recursive:!0}),this.u.info(`Deleted ${ee} extension from disk`,W,ae.fsPath)}z(W){return this.g.queue(async()=>{let ae;try{ae=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(H){if((0,X.$ll)(H)!==X.FileOperationResult.FILE_NOT_FOUND)throw H}let ee={};if(ae)try{ee=JSON.parse(ae)}catch{}return W&&(W(ee),Object.keys(ee).length?await this.m.writeFile(this.c,r.$Je.fromString(JSON.stringify(ee))):await this.m.del(this.c)),ee})}async C(W,ae){try{await p.Promises.rename(W,ae,2*60*1e3)}catch(ee){throw(0,o.$vq)(ee,d.ExtensionManagementErrorCode.Rename)}}async D(W,ae,ee){try{if(ee){const L=(await this.n.scanUserExtensions({profileLocation:ee})).find(V=>this.t.extUri.isEqual(V.location,W));if(L)return await this.F(L)}else{const H=await this.n.scanExistingExtension(W,ae,{includeInvalid:!0});if(H)return await this.F(H)}throw new d.$ep(b.localize(5,null,W.path),d.ExtensionManagementErrorCode.ScanningExtension)}catch(H){throw(0,o.$vq)(H,d.ExtensionManagementErrorCode.ScanningExtension)}}async F(W){const ae=await this.m.resolve(W.location);let ee,H;return ae.children&&(ee=ae.children.find(({name:L})=>/^readme(\.txt|\.md|)$/i.test(L))?.resource,H=ae.children.find(({name:L})=>/^changelog(\.txt|\.md|)$/i.test(L))?.resource),{identifier:W.identifier,type:W.type,isBuiltin:W.isBuiltin||!!W.metadata?.isBuiltin,location:W.location,manifest:W.manifest,targetPlatform:W.targetPlatform,validations:W.validations,isValid:W.isValid,readmeUrl:ee,changelogUrl:H,publisherDisplayName:W.metadata?.publisherDisplayName,publisherId:W.metadata?.publisherId||null,isApplicationScoped:!!W.metadata?.isApplicationScoped,isMachineScoped:!!W.metadata?.isMachineScoped,isPreReleaseVersion:!!W.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!W.metadata?.hasPreReleaseVersion,preRelease:!!W.metadata?.preRelease,installedTimestamp:W.metadata?.installedTimestamp,updated:!!W.metadata?.updated,pinned:!!W.metadata?.pinned,isWorkspaceScoped:!1,source:W.metadata?.source??(W.identifier.uuid?"gallery":"vsix")}}async G(){const W=await this.getUninstalledExtensions();if(Object.keys(W).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(W));const ae=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),ee=new Set;for(const L of ae)W[i.$Ep.create(L).toString()]||ee.add(L.identifier.id.toLowerCase());try{const L=(0,i.$Jp)(ae,V=>V.identifier);await n.Promises.settled(L.map(async V=>{const B=V.sort((U,K)=>a.rcompare(U.manifest.version,K.manifest.version))[0];ee.has(B.identifier.id.toLowerCase())||await this.j(await this.F(B))}))}catch(L){this.u.error(L)}const H=ae.filter(L=>L.metadata&&W[i.$Ep.create(L).toString()]);await Promise.allSettled(H.map(L=>this.removeUninstalledExtension(L)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let W;try{W=await this.m.resolve(this.n.userExtensionsLocation)}catch(ae){(0,X.$ll)(ae)!==X.FileOperationResult.FILE_NOT_FOUND&&this.u.error(ae);return}if(W?.children)try{await Promise.allSettled(W.children.map(async ae=>{if(!(!ae.isDirectory||!ae.name.endsWith(le))){this.u.trace("Deleting the temporarily deleted folder",ae.resource.toString());try{await this.m.del(ae.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",ae.resource.toString())}catch(ee){(0,X.$ll)(ee)!==X.FileOperationResult.FILE_NOT_FOUND&&this.u.error(ee)}}}))}catch{}}};e.$Pq=z,e.$Pq=z=Ue([Ne(1,X.$7k),Ne(2,u.$Cq),Ne(3,h.$yq),Ne(4,q.$El),Ne(5,ne.$7j)],z);let oe=class extends o.$wq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(W,ae,ee,H,L,V,B,U,K,Z,j,G){super(),this.l=W,this.manifest=ae,this.source=ee,this.options=H,this.m=L,this.n=V,this.o=B,this.p=U,this.q=K,this.s=Z,this.t=j,this.u=G,this.j=d.InstallOperation.Install,this.identifier=this.l.identifier}async v(){return(await this.n.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(ae=>(0,i.$Dp)(ae.identifier,this.identifier))}async h(W){const ae=await this.v();ae&&(this.j=d.InstallOperation.Update);const ee={isApplicationScoped:this.options.isApplicationScoped||ae?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||ae?.isMachineScoped,isBuiltin:this.options.isBuiltin||ae?.isBuiltin,isSystem:ae?.type===P.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??ae?.pinned,source:this.source instanceof c.URI?"vsix":"gallery"};let H;if(this.source instanceof c.URI)if(ae){if(this.l.equals(new i.$Ep(ae.identifier,ae.manifest.version)))try{await this.n.removeExtension(ae,"existing")}catch{throw new Error(b.localize(6,null,this.manifest.displayName||this.manifest.name))}}else{const V=await this.x(this.l);if(V)try{await this.n.removeExtension(V,"existing")}catch{throw new Error(b.localize(7,null,this.manifest.displayName||this.manifest.name))}}else ee.id=this.source.identifier.uuid,ee.publisherId=this.source.publisherId,ee.publisherDisplayName=this.source.publisherDisplayName,ee.targetPlatform=this.source.properties.targetPlatform,ee.updated=!!ae,ee.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,ee.hasPreReleaseVersion=ae?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,ee.preRelease=(0,f.$gg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||ae?.preRelease,ae&&ae.type!==P.ExtensionType.System&&ae.manifest.version===this.source.version?H=await this.n.updateMetadata(ae,ee):H=await this.x(this.l);if(W.isCancellationRequested)throw(0,o.$vq)(new R.$5);if(!H){const V=await this.m(this.operation,W);H=V.local,this.k=V.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(V){throw(0,o.$vq)(V,d.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(W.isCancellationRequested)throw(0,o.$vq)(new R.$5);try{await this.t.addExtensionsToProfile([[H,ee]],this.options.profileLocation,!H.isValid)}catch(V){throw(0,o.$vq)(V,d.ExtensionManagementErrorCode.AddToProfile)}const L=await this.v();if(!L)throw new d.$ep("Cannot find the installed extension",d.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof c.URI&&this.y(H,W),L}async x(W){return(await this.n.getUninstalledExtensions())[W.toString()]?(this.u.trace("Removing the extension from uninstalled list:",W.id),await this.n.setInstalled(W),this.u.info("Removed the extension from uninstalled list:",W.id),(await this.n.scanAllUserExtensions(!0)).find(H=>i.$Ep.create(H).equals(W))):void 0}async y(W,ae){try{let[ee]=await this.p.getExtensions([{id:W.identifier.id,version:W.manifest.version}],ae);if(ee||([ee]=await this.p.getExtensions([{id:W.identifier.id}],ae)),ee){const H={id:ee.identifier.uuid,publisherDisplayName:ee.publisherDisplayName,publisherId:ee.publisherId,isPreReleaseVersion:ee.properties.isPreReleaseVersion,hasPreReleaseVersion:W.hasPreReleaseVersion||ee.properties.isPreReleaseVersion,preRelease:ee.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(W,H,this.options.profileLocation)}}catch{}}};oe=Ue([Ne(6,q.$El),Ne(7,d.$cp),Ne(8,te.$Gl),Ne(9,u.$Cq),Ne(10,h.$yq),Ne(11,ne.$7j)],oe);class ce extends o.$wq{constructor(W,ae,ee){super(),this.extension=W,this.j=ae,this.k=ee}async h(W){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(Se[140],De([1,0,12,34,36,24,53,16,28,4]),function(he,e,n,r,S,k,R,A,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=void 0;let E=class extends R.$zq{constructor($,w,a,f,c,g){super(s.URI.file($.extensionsPath),w,a,f,c,g)}};e.$nQ=E,e.$nQ=E=Ue([Ne(0,v.$Ii),Ne(1,A.$7k),Ne(2,r.$Gl),Ne(3,S.$El),Ne(4,k.$6l),Ne(5,n.$7j)],E)}),define(Se[100],De([1,0,14,6,2,45,11,183,5,34]),function(he,e,n,r,S,k,R,A,v,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$_p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$0p=e.$9p=e.$8p=void 0,e.$$p=w,e.$aq=f,e.$cq=g,e.$8p="__$__isNewStorageMarker",e.$9p="__$__targetStorageMarker",e.$0p=(0,v.$Ai)("storageService");var E;(function(p){p[p.NONE=0]="NONE",p[p.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var y;(function(p){p[p.APPLICATION=-1]="APPLICATION",p[p.PROFILE=0]="PROFILE",p[p.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var $;(function(p){p[p.USER=0]="USER",p[p.MACHINE=1]="MACHINE"})($||(e.StorageTarget=$={}));function w(p){const m=p.get(e.$9p);if(m)try{return JSON.parse(m)}catch{}return Object.create(null)}class a extends S.$Uc{constructor(m={flushInterval:a.a}){super(),this.m=m,this.b=this.B(new r.$ke),this.c=this.B(new r.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new r.$he),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(m,b,l){return r.Event.filter(this.b.event,t=>t.scope===m&&(b===void 0||t.key===b),l)}n(){this.j.value=(0,n.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(m,b){const{key:l,external:t}=b;if(l===e.$9p){switch(m){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:m})}else this.b.fire({scope:m,key:l,target:this.J(m)[l],external:t})}w(m){this.f.fire({reason:m})}get(m,b,l){return this.P(b)?.get(m,l)}getBoolean(m,b,l){return this.P(b)?.getBoolean(m,l)}getNumber(m,b,l){return this.P(b)?.getNumber(m,l)}getObject(m,b,l){return this.P(b)?.getObject(m,l)}storeAll(m,b){this.y(()=>{for(const l of m)this.store(l.key,l.value,l.scope,l.target,b)})}store(m,b,l,t,o=!1){if((0,R.$jg)(b)){this.remove(m,l,o);return}this.y(()=>{this.z(m,l,t),this.P(l)?.set(m,b,o)})}remove(m,b,l=!1){this.y(()=>{this.z(m,b,void 0),this.P(b)?.delete(m,l)})}y(m){this.b.pause(),this.c.pause();try{m()}finally{this.b.resume(),this.c.resume()}}keys(m,b){const l=[],t=this.J(m);for(const o of Object.keys(t))t[o]===b&&l.push(o);return l}z(m,b,l,t=!1){const o=this.J(b);typeof l=="number"?o[m]!==l&&(o[m]=l,this.P(b)?.set(e.$9p,JSON.stringify(o),t)):typeof o[m]=="number"&&(delete o[m],this.P(b)?.set(e.$9p,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(m){switch(m){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(m){const b=this.P(m);return b?w(b):Object.create(null)}isNew(m){return this.getBoolean(e.$8p,m)===!0}async flush(m=E.NONE){this.f.fire({reason:m});const b=this.P(y.APPLICATION),l=this.P(y.PROFILE),t=this.P(y.WORKSPACE);switch(m){case E.NONE:await n.Promises.settled([b?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await n.Promises.settled([b?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const m=this.P(y.APPLICATION)?.items??new Map,b=this.P(y.PROFILE)?.items??new Map,l=this.P(y.WORKSPACE)?.items??new Map;return g(m,b,l,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(m){return await this.flush(),this.P(m)?.optimize()}async switch(m,b){return this.w(E.NONE),(0,s.$Fl)(m)?this.R(m,b):this.S(m,b)}M(m,b){return!(m.id===b.id||f(b)&&f(m))}N(m,b,l){this.y(()=>{const t=new Set;for(const[o,d]of m)t.add(o),b.get(o)!==d&&this.u(l,{key:o,external:!0});for(const[o]of b.items)t.has(o)||this.u(l,{key:o,external:!0})})}}e.$_p=a,a.a=60*1e3;function f(p){return p.isDefault||!!p.useDefaultFlags?.globalState}class c extends a{constructor(){super(),this.U=this.B(new A.$6p(new A.$7p,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new A.$6p(new A.$7p,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new A.$6p(new A.$7p,{hint:A.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(m=>this.u(y.WORKSPACE,m))),this.B(this.W.onDidChangeStorage(m=>this.u(y.PROFILE,m))),this.B(this.U.onDidChangeStorage(m=>this.u(y.APPLICATION,m)))}P(m){switch(m){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(m){switch(m){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(m){return!1}}e.$bq=c;async function g(p,m,b,l,t,o){const d=P=>{try{return JSON.parse(P)}catch{return P}},i=new Map,h=new Map;p.forEach((P,Q)=>{i.set(Q,P),h.set(Q,d(P))});const u=new Map,D=new Map;m.forEach((P,Q)=>{u.set(Q,P),D.set(Q,d(P))});const I=new Map,T=new Map;b.forEach((P,Q)=>{I.set(Q,P),T.set(Q,d(P))}),console.group(l!==t?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const O=[];if(i.forEach((P,Q)=>{O.push({key:Q,value:P})}),console.table(O),console.groupEnd(),console.log(h),l!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];u.forEach((Q,X)=>{P.push({key:X,value:Q})}),console.table(P),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${o})`);const C=[];I.forEach((P,Q)=>{C.push({key:Q,value:P})}),console.table(C),console.groupEnd(),console.log(T)}}),define(Se[290],De([1,0,15,22,100]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dq=k;async function k(R,A,v){let s=v&&v.get("storage.serviceMachineId",S.StorageScope.APPLICATION)||null;if(s)return s;try{const y=(await A.readFile(R.serviceMachineIdResource)).value.toString();s=(0,r.$Vg)(y)?y:null}catch{s=null}if(!s){s=(0,r.$Wg)();try{await A.writeFile(R.serviceMachineIdResource,n.$Je.fromString(s))}catch{}}return v?.store("storage.serviceMachineId",s,S.StorageScope.APPLICATION,S.StorageTarget.MACHINE),s}}),define(Se[291],De([1,0,290,24,41]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=k;async function k(R,A,v,s,E,y,$){const w={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${A.nameShort})`};if((0,S.$vp)(A,v)&&(0,S.$xp)(s)===r.TelemetryLevel.USAGE){const a=await(0,n.$dq)(v,E,y);w["X-Market-User-Id"]=a,w["VSCode-SessionId"]=$.machineId||a}return w}}),define(Se[141],De([1,0,18,19,10,3,33,11,4,27,28,30,39,23,87,16,12,29,47,291,100,24,55]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m,b,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0,e.$fq=pe;const o=k.$i?w.TargetPlatform.WEB:(0,y.$$o)(k.$o,R.$ec),d="X-Market-Search-Activity-Id";var i;(function(V){V[V.None=0]="None",V[V.IncludeVersions=1]="IncludeVersions",V[V.IncludeFiles=2]="IncludeFiles",V[V.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",V[V.IncludeSharedAccounts=8]="IncludeSharedAccounts",V[V.IncludeVersionProperties=16]="IncludeVersionProperties",V[V.ExcludeNonValidated=32]="ExcludeNonValidated",V[V.IncludeInstallationTargets=64]="IncludeInstallationTargets",V[V.IncludeAssetUri=128]="IncludeAssetUri",V[V.IncludeStatistics=256]="IncludeStatistics",V[V.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",V[V.Unpublished=4096]="Unpublished",V[V.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function h(...V){return String(V.reduce((B,U)=>B|U,0))}var u;(function(V){V[V.Tag=1]="Tag",V[V.ExtensionId=4]="ExtensionId",V[V.Category=5]="Category",V[V.ExtensionName=7]="ExtensionName",V[V.Target=8]="Target",V[V.Featured=9]="Featured",V[V.SearchText=10]="SearchText",V[V.ExcludeWithFlags=12]="ExcludeWithFlags"})(u||(u={}));const D={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},I={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},O={pageNumber:1,pageSize:10,sortBy:y.SortBy.NoneOrRelevance,sortOrder:y.SortOrder.Default,flags:i.None,criteria:[],assetTypes:[]};class C{constructor(B=O){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,U=this.d.pageSize){return new C({...this.d,pageNumber:B,pageSize:U})}withFilter(B,...U){const K=[...this.d.criteria,...U.length?U.map(Z=>({filterType:B,value:Z})):[{filterType:B}]];return new C({...this.d,criteria:K})}withSortBy(B){return new C({...this.d,sortBy:B})}withSortOrder(B){return new C({...this.d,sortOrder:B})}withFlags(...B){return new C({...this.d,flags:B.reduce((U,K)=>U|K,0)})}withAssetTypes(...B){return new C({...this.d,assetTypes:B})}withSource(B){return new C({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:U,pageSize:K,sortBy:Z,sortOrder:j,flags:G,assetTypes:se}=this.d;return{filters:[{criteria:B,pageNumber:U,pageSize:K,sortBy:Z,sortOrder:j}],assetTypes:se,flags:G}}get searchText(){const B=this.d.criteria.filter(U=>U.filterType===u.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function P(V,B){const U=(V||[]).filter(K=>K.statisticName===B)[0];return U?U.value:0}function Q(V){const B="Microsoft.VisualStudio.Code.Translation.";return V.files.filter(K=>K.assetType.indexOf(B)===0).reduce((K,Z)=>{const j=ne(V,Z.assetType);return j&&K.push([Z.assetType.substring(B.length),j]),K},[])}function X(V){if(V.properties){const B=V.properties.filter(Z=>Z.key===D.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),K=B.filter(Z=>U.test(Z.value))[0];return K?{uri:K.value,fallbackUri:K.value}:null}return ne(V,D.Repository)}function ie(V){return{uri:`${V.fallbackAssetUri}/${D.VSIX}?redirect=true${V.targetPlatform?`&targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${D.VSIX}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}}function ne(V,B){return V.files.filter(K=>K.assetType===B)[0]?{uri:`${V.assetUri}/${B}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`,fallbackUri:`${V.fallbackAssetUri}/${B}${V.targetPlatform?`?targetPlatform=${V.targetPlatform}`:""}`}:null}function x(V,B){const U=V.properties?V.properties.filter(Z=>Z.key===B):[],K=U.length>0&&U[0].value;return K?K.split(",").map(Z=>(0,$.$Hp)(Z)):[]}function re(V){const B=V.properties?V.properties.filter(U=>U.key===I.Engine):[];return B.length>0&&B[0].value||""}function q(V){const B=V.properties?V.properties.filter(U=>U.key===I.PreRelease):[];return B.length>0&&B[0].value==="true"}function te(V){const B=V.properties?V.properties.filter(K=>K.key===I.LocalizedLanguages):[],U=B.length>0&&B[0].value||"";return U?U.split(","):[]}function le(V){return V.properties?.find(B=>B.key===I.SponsorLink)?.value}function M(V){return V.properties?.find(B=>B.key===I.SupportLink)?.value}function z(V){return V.indexOf("preview")!==-1}function oe(V){return V.targetPlatform?(0,y.$0o)(V.targetPlatform):w.TargetPlatform.UNDEFINED}function ce(V){const B=(0,n.$Mb)(V.versions.map(oe)),U=!!V.tags?.includes(y.$4o),K=B.indexOf(w.TargetPlatform.WEB);return U?K===-1&&B.push(w.TargetPlatform.WEB):K!==-1&&B.splice(K,1),B}function pe(V,B){for(let U=0;U<V.length;U++){const K=V[U];if(K.version===V[U-1]?.version){let Z=U;if(oe(K)===B)for(;Z>0&&V[Z-1].version===K.version;)Z--;Z!==U&&(V.splice(U,1),V.splice(Z,0,K))}}return V}function W(V,B,U){V.telemetryData={index:B,querySource:U,queryActivityId:V.queryContext?.[d]}}function ae(V,B,U,K){const Z=V.versions[0],j={manifest:ne(B,D.Manifest),readme:ne(B,D.Details),changelog:ne(B,D.Changelog),license:ne(B,D.License),repository:X(B),download:ie(B),icon:ne(B,D.Icon),signature:ne(B,D.Signature),coreTranslations:Q(B)};return{type:"gallery",identifier:{id:(0,$.$Ip)(V.publisher.publisherName,V.extensionName),uuid:V.extensionId},name:V.extensionName,version:B.version,displayName:V.displayName,publisherId:V.publisher.publisherId,publisher:V.publisher.publisherName,publisherDisplayName:V.publisher.displayName,publisherDomain:V.publisher.domain?{link:V.publisher.domain,verified:!!V.publisher.isDomainVerified}:void 0,publisherSponsorLink:le(Z),description:V.shortDescription??"",installCount:P(V.statistics,"install"),rating:P(V.statistics,"averagerating"),ratingCount:P(V.statistics,"ratingcount"),categories:V.categories||[],tags:V.tags||[],releaseDate:Date.parse(V.releaseDate),lastUpdated:Date.parse(V.lastUpdated),allTargetPlatforms:U,assets:j,properties:{dependencies:x(B,I.Dependency),extensionPack:x(B,I.ExtensionPack),engine:re(B),localizedLanguages:te(B),targetPlatform:oe(B),isPreReleaseVersion:q(B)},hasPreReleaseVersion:q(Z),hasReleaseVersion:!0,preview:z(V.flags),isSigned:!!j.signature,queryContext:K,supportLink:M(Z)}}let ee=class{constructor(B,U,K,Z,j,G,se,fe){this.k=U,this.l=K,this.n=Z,this.o=j,this.q=G,this.u=se,this.w=fe;const Ee=se.extensionsGallery,Le=Ee?.servicePPEUrl&&fe.getValue("_extensionsGallery.enablePPE");this.d=Le?Ee.servicePPEUrl:Ee?.serviceUrl,this.g=Le?void 0:Ee?.searchUrl,this.h=Ee?.controlUrl,this.j=(0,m.$eq)(se.version,se,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,U,K){const Z=r.CancellationToken.isCancellationToken(U)?{}:U,j=r.CancellationToken.isCancellationToken(U)?U:K,G=[],se=[],fe=[],Ee=[];let Le=!0;for(const Re of B){Re.uuid?se.push(Re.uuid):G.push(Re.id);const Oe=!!(Re.version||Re.preRelease);fe.push({id:Re.id,uuid:Re.uuid,includePreRelease:Oe}),Re.version&&Ee.push({id:Re.id,uuid:Re.uuid,version:Re.version}),Le=Le&&!!Re.hasPreRelease&&!Oe}if(!se.length&&!G.length)return[];let de=new C().withPage(1,B.length);se.length&&(de=de.withFilter(u.ExtensionId,...se)),G.length&&(de=de.withFilter(u.ExtensionName,...G)),(Z.queryAllVersions||Le)&&(de=de.withFlags(de.flags,i.IncludeVersions)),Z.source&&(de=de.withSource(Z.source));const{extensions:we}=await this.z(de,{targetPlatform:Z.targetPlatform??o,includePreRelease:fe,versions:Ee,compatible:!!Z.compatible,productVersion:Z.productVersion??{version:this.u.version,date:this.u.date}},j);return Z.source&&we.forEach((Re,Oe)=>W(Re,Oe,Z.source)),we}async getCompatibleExtension(B,U,K,Z={version:this.u.version,date:this.u.date}){if((0,y.$_o)(B.allTargetPlatforms,K))return null;if(await this.isExtensionCompatible(B,U,K))return B;const j=new C().withFlags(i.IncludeVersions).withPage(1,1).withFilter(u.ExtensionId,B.identifier.uuid),{extensions:G}=await this.z(j,{targetPlatform:K,compatible:!0,includePreRelease:U,productVersion:Z},r.CancellationToken.None);return G[0]||null}async isExtensionCompatible(B,U,K,Z={version:this.u.version,date:this.u.date}){if(!(0,y.$ap)(B.properties.targetPlatform,B.allTargetPlatforms,K)||!U&&B.properties.isPreReleaseVersion)return!1;let j=B.properties.engine;if(!j){const G=await this.getManifest(B,r.CancellationToken.None);if(!G)throw new Error("Manifest was not found");j=G.engines.vscode}return(0,a.$Vp)(j,Z.version,Z.date)}async y(B,U,K,Z,j,G,se={version:this.u.version,date:this.u.date}){if(!(0,y.$ap)(oe(U),j,G)||K!=="any"&&q(U)!==(K==="prerelease"))return!1;if(Z)try{const fe=await this.E(B,U);if(!(0,a.$Vp)(fe,se.version,se.date))return!1}catch(fe){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,S.$0)(fe)),!1}return!0}async query(B,U){let K=B.text||"";const Z=B.pageSize??50;let j=new C().withPage(1,Z);K?(K=K.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Le,de,we)=>(j=j.withFilter(u.Category,we||de),"")),K=K.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Le,de,we)=>(j=j.withFilter(u.Tag,we||de),"")),K=K.replace(/\bfeatured(\s+|\b|$)/g,()=>(j=j.withFilter(u.Featured),"")),K=K.trim(),K&&(K=K.length<200?K:K.substring(0,200),j=j.withFilter(u.SearchText,K)),j=j.withSortBy(y.SortBy.NoneOrRelevance)):B.ids?j=j.withFilter(u.ExtensionId,...B.ids):B.names?j=j.withFilter(u.ExtensionName,...B.names):j=j.withSortBy(y.SortBy.InstallCount),typeof B.sortBy=="number"&&(j=j.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(j=j.withSortOrder(B.sortOrder)),B.source&&(j=j.withSource(B.source));const G=async(Le,de)=>{const{extensions:we,total:Re}=await this.z(Le,{targetPlatform:o,compatible:!1,includePreRelease:!!B.includePreRelease,productVersion:B.productVersion??{version:this.u.version,date:this.u.date}},de);return we.forEach((Oe,me)=>W(Oe,(Le.pageNumber-1)*Le.pageSize+me,B.source)),{extensions:we,total:Re}},{extensions:se,total:fe}=await G(j,U),Ee=async(Le,de)=>{if(de.isCancellationRequested)throw new S.$5;const{extensions:we}=await G(j.withPage(Le+1),de);return we};return{firstPage:se,total:fe,pageSize:j.pageSize,getPage:Ee}}async z(B,U,K){const Z=B.flags;B.flags&i.IncludeLatestVersionOnly&&B.flags&i.IncludeVersions&&(B=B.withFlags(B.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(B.flags&i.IncludeLatestVersionOnly)&&!(B.flags&i.IncludeVersions)&&(B=B.withFlags(B.flags,i.IncludeLatestVersionOnly)),U.versions?.length&&(B=B.withFlags(B.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),B=B.withFlags(B.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:j,total:G,context:se}=await this.B(B,K);if(!(B.flags&i.IncludeLatestVersionOnly)){const de=[];for(const we of j){const Re=await this.A(we,U,se);Re&&de.push(Re)}return{extensions:de,total:G}}const Ee=[],Le=new Map;for(let de=0;de<j.length;de++){const we=j[de],Re={id:(0,$.$Ip)(we.publisher.publisherName,we.extensionName),uuid:we.extensionId},Oe=(0,A.$gg)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Ie=>(0,$.$Dp)(Ie,Re))?.includePreRelease;if(U.compatible&&(0,y.$_o)(ce(we),U.targetPlatform))continue;const me=await this.A(we,U,se);!me||me.properties.isPreReleaseVersion&&(!Oe||!me.hasReleaseVersion)||!me.properties.isPreReleaseVersion&&me.properties.targetPlatform!==U.targetPlatform&&me.hasPreReleaseVersion?Le.set(we.extensionId,de):Ee.push([de,me])}if(Le.size){const de=new t.$be,we=new C().withFlags(Z&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,Le.size).withFilter(u.ExtensionId,...Le.keys()),{extensions:Re}=await this.z(we,U,K);this.o.publicLog2("galleryService:additionalQuery",{duration:de.elapsed(),count:Le.size});for(const Oe of Re){const me=Le.get(Oe.identifier.uuid);Ee.push([me,Oe])}}return{extensions:Ee.sort((de,we)=>de[0]-we[0]).map(([,de])=>de),total:G}}async A(B,U,K){const Z={id:(0,$.$Ip)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},j=U.versions?.find(Ee=>(0,$.$Dp)(Ee,Z))?.version,G=(0,A.$gg)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Ee=>(0,$.$Dp)(Ee,Z))?.includePreRelease,se=ce(B),fe=pe(B.versions,U.targetPlatform);if(U.compatible&&(0,y.$_o)(se,U.targetPlatform))return null;for(let Ee=0;Ee<fe.length;Ee++){const Le=fe[Ee];if(!(j&&Le.version!==j)){if(await this.y((0,$.$Ip)(B.publisher.publisherName,B.extensionName),Le,G?"any":"release",U.compatible,se,U.targetPlatform,U.productVersion))return ae(B,Le,se,K);if(j&&Le.version===j)return null}}return j||U.compatible?null:ae(B,B.versions[0],se)}async B(B,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,i.ExcludeNonValidated).withFilter(u.Target,"Microsoft.VisualStudio.Code").withFilter(u.ExcludeWithFlags,h(i.Unpublished));const K=await this.j,Z=JSON.stringify(B.raw),j={...K,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},G=new t.$be;let se,fe,Ee=0;try{if(se=await this.k.request({type:"POST",url:this.g&&B.criteria.some(de=>de.filterType===u.SearchText)?this.g:this.x("/extensionquery"),data:Z,headers:j},U),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:Ee};const Le=await(0,p.$3p)(se);if(Le){const de=Le.results[0],we=de.extensions,Re=de.resultMetadata&&de.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return Ee=Re&&Re.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:Ee,context:{[d]:se.res.headers.activityid}}}return{galleryExtensions:[],total:Ee}}catch(Le){if((0,S.$4)(Le))throw fe=y.ExtensionGalleryErrorCode.Cancelled,Le;{const de=(0,S.$0)(Le);throw fe=de.startsWith("XHR timeout")?y.ExtensionGalleryErrorCode.Timeout:y.ExtensionGalleryErrorCode.Failed,new y.$dp(de,fe)}}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(Z.length),duration:G.elapsed(),success:!!se&&(0,p.$Yp)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:fe,count:String(Ee)})}}async reportStatistic(B,U,K,Z){if(!this.isEnabled())return;const j=k.$i?this.x(`/itemName/${B}.${U}/version/${K}/statType/${Z===y.StatisticType.Install?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${U}/${K}/stats?statType=${Z}`),G=k.$i?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",fe={...await this.j,Accept:G};try{await this.k.request({type:"POST",url:j,headers:fe},r.CancellationToken.None)}catch{}}async download(B,U,K){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const Z=(0,$.$Lp)(B),j=new Date().getTime(),G=K===y.InstallOperation.Install?"install":K===y.InstallOperation.Update?"update":"",se=G?{uri:`${B.assets.download.uri}${v.URI.parse(B.assets.download.uri).query?"&":"?"}${G}=true`,fallbackUri:`${B.assets.download.fallbackUri}${v.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${G}=true`}:B.assets.download,fe=B.queryContext?.[d]?{[d]:B.queryContext[d]}:void 0,Ee=await this.D(B.identifier.id,se,D.VSIX,fe?{headers:fe}:void 0);try{await this.q.writeFile(U,Ee.stream)}catch(Le){try{await this.q.del(U)}catch(de){this.l.warn(`Error while deleting the file ${U.toString()}`,(0,S.$0)(de))}throw new y.$dp((0,S.$0)(Le),y.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.o.publicLog("galleryService:downloadVSIX",{...Z,duration:new Date().getTime()-j})}async downloadSignatureArchive(B,U){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const K=await this.D(B.identifier.id,B.assets.signature,D.Signature);try{await this.q.writeFile(U,K.stream)}catch(Z){try{await this.q.del(U)}catch(j){this.l.warn(`Error while deleting the file ${U.toString()}`,(0,S.$0)(j))}throw new y.$dp((0,S.$0)(Z),y.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(B,U){if(B.assets.readme){const K=await this.D(B.identifier.id,B.assets.readme,D.Details,{},U);return await(0,p.$2p)(K)||""}return""}async getManifest(B,U){if(B.assets.manifest){const K=await this.D(B.identifier.id,B.assets.manifest,D.Manifest,{},U),Z=await(0,p.$2p)(K);return Z?JSON.parse(Z):null}return null}async C(B,U,K){const Z=ne(U,D.Manifest);if(!Z)throw new Error("Manifest was not found");const j={"Accept-Encoding":"gzip"},G=await this.D(B,Z,D.Manifest,{headers:j});return await(0,p.$3p)(G)}async getCoreTranslation(B,U){const K=B.assets.coreTranslations.filter(Z=>Z[0]===U.toUpperCase())[0];if(K){const Z=await this.D(B.identifier.id,K[1],K[0]),j=await(0,p.$2p)(Z);return j?JSON.parse(j):null}return null}async getChangelog(B,U){if(B.assets.changelog){const K=await this.D(B.identifier.id,B.assets.changelog,D.Changelog,{},U);return await(0,p.$2p)(K)||""}return""}async getAllCompatibleVersions(B,U,K){let Z=new C().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?Z=Z.withFilter(u.ExtensionId,B.identifier.uuid):Z=Z.withFilter(u.ExtensionName,B.identifier.id);const{galleryExtensions:j}=await this.B(Z,r.CancellationToken.None);if(!j.length)return[];const G=ce(j[0]);if((0,y.$_o)(G,K))return[];const se=[];await Promise.all(j[0].versions.map(async Le=>{try{await this.y(B.identifier.id,Le,U?"any":"release",!0,G,K)&&se.push(Le)}catch{}}));const fe=[],Ee=new Set;for(const Le of pe(se,K))Ee.has(Le.version)||(Ee.add(Le.version),fe.push({version:Le.version,date:Le.lastUpdated,isPreReleaseVersion:q(Le)}));return fe}async D(B,U,K,Z={},j=r.CancellationToken.None){const G=await this.j,se={type:"GET"},fe={...G,...Z.headers||{}};Z={...Z,...se,headers:fe};const Ee=U.uri,Le=U.fallbackUri,de={...Z,url:Ee};try{const we=await this.k.request(de,j);if(we.res.statusCode===200)return we;const Re=await(0,p.$2p)(we);throw new Error(`Expected 200, got back ${we.res.statusCode} instead.

${Re}`)}catch(we){if((0,S.$4)(we))throw we;const Re=(0,S.$0)(we);this.o.publicLog2("galleryService:cdnFallback",{extension:B,assetType:K,message:Re});const Oe={...Z,url:Le};return this.k.request(Oe,j)}}async E(B,U){let K=re(U);if(!K){this.o.publicLog2("galleryService:engineFallback",{extension:B,version:U.version});const Z=await this.C(B,U,r.CancellationToken.None);if(!Z)throw new Error("Manifest was not found");K=Z.engines.vscode}return K}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const B=await this.k.request({type:"GET",url:this.h},r.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,p.$3p)(B),K=[],Z={},j=[];if(U){for(const G of U.malicious)K.push({id:G});if(U.migrateToPreRelease)for(const[G,se]of Object.entries(U.migrateToPreRelease))(!se.engine||(0,a.$Vp)(se.engine,this.u.version,this.u.date))&&(Z[G.toLowerCase()]={disallowInstall:!0,extension:{id:se.id,displayName:se.displayName,autoMigrate:{storage:!!se.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[G,se]of Object.entries(U.deprecated))se&&(Z[G.toLowerCase()]=(0,A.$gg)(se)?{}:se);if(U.search)for(const G of U.search)j.push(G)}return{malicious:K,deprecated:Z,search:j}}};ee=Ue([Ne(1,p.$Wp),Ne(2,c.$7j),Ne(3,E.$Hi),Ne(4,l.$6l),Ne(5,f.$7k),Ne(6,g.$nk),Ne(7,s.$7i)],ee);let H=class extends ee{constructor(B,U,K,Z,j,G,se,fe){super(B,U,K,Z,j,G,se,fe)}};e.$gq=H,e.$gq=H=Ue([Ne(0,b.$0p),Ne(1,p.$Wp),Ne(2,c.$7j),Ne(3,E.$Hi),Ne(4,l.$6l),Ne(5,f.$7k),Ne(6,g.$nk),Ne(7,s.$7i)],H);let L=class extends ee{constructor(B,U,K,Z,j,G,se){super(void 0,B,U,K,Z,j,G,se)}};e.$hq=L,e.$hq=L=Ue([Ne(0,p.$Wp),Ne(1,c.$7j),Ne(2,E.$Hi),Ne(3,l.$6l),Ne(4,f.$7k),Ne(5,g.$nk),Ne(6,s.$7i)],L)}),define(Se[292],De([1,0,6,2,34,59]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vQ=e.$uQ=void 0;class R{constructor(s,E){this.a=s,this.b=E}listen(s,E){const y=this.b(s);switch(E){case"onDidChangeProfiles":return n.Event.map(this.a.onDidChangeProfiles,$=>({all:$.all.map(w=>(0,k.$Gn)({...w},y)),added:$.added.map(w=>(0,k.$Gn)({...w},y)),removed:$.removed.map(w=>(0,k.$Gn)({...w},y)),updated:$.updated.map(w=>(0,k.$Gn)({...w},y))}))}throw new Error(`Invalid listen ${E}`)}async call(s,E,y){const $=this.b(s);switch(E){case"createProfile":{const w=await this.a.createProfile(y[0],y[1],y[2]);return(0,k.$Gn)({...w},$)}case"updateProfile":{let w=(0,S.$Hl)((0,k.$Hn)(y[0],$),this.a.profilesHome.scheme);return w=await this.a.updateProfile(w,y[1]),(0,k.$Gn)({...w},$)}case"removeProfile":{const w=(0,S.$Hl)((0,k.$Hn)(y[0],$),this.a.profilesHome.scheme);return this.a.removeProfile(w)}}throw new Error(`Invalid call ${E}`)}}e.$uQ=R;class A extends r.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(s,E,y){super(),this.profilesHome=E,this.f=y,this.a=[],this.b=this.B(new n.$he),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=s.map($=>(0,S.$Hl)($,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")($=>{const w=$.added.map(c=>(0,S.$Hl)(c,this.profilesHome.scheme)),a=$.removed.map(c=>(0,S.$Hl)(c,this.profilesHome.scheme)),f=$.updated.map(c=>(0,S.$Hl)(c,this.profilesHome.scheme));this.a=$.all.map(c=>(0,S.$Hl)(c,this.profilesHome.scheme)),this.b.fire({added:w,removed:a,updated:f,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(s){this.c=s}isEnabled(){return this.c}async createNamedProfile(s,E,y){const $=await this.f.call("createNamedProfile",[s,E,y]);return(0,S.$Hl)($,this.profilesHome.scheme)}async createProfile(s,E,y,$){const w=await this.f.call("createProfile",[s,E,y,$]);return(0,S.$Hl)(w,this.profilesHome.scheme)}async createTransientProfile(s){const E=await this.f.call("createTransientProfile",[s]);return(0,S.$Hl)(E,this.profilesHome.scheme)}async setProfileForWorkspace(s,E){await this.f.call("setProfileForWorkspace",[s,E])}removeProfile(s){return this.f.call("removeProfile",[s])}async updateProfile(s,E){const y=await this.f.call("updateProfile",[s,E]);return(0,S.$Hl)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$vQ=A}),define(Se[142],De([1,0,4,28,16,12,269,36,34,11,270]),function(he,e,n,r,S,k,R,A,v,s,E){"use strict";var y,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$mQ=e.$lQ=e.$kQ=void 0;let w=y=class extends v.$Jl{constructor(g,p,m,b,l){super(m,b,p,l),this.U=g,this.W=m}O(){return this.U.getItem(y.b,[]).map(p=>({...p,location:(0,s.$ag)(p.location)?this.w.extUri.joinPath(this.profilesHome,p.location):n.URI.revive(p.location)}))}Q(){const g=this.U.getItem(y.c,{});return this.U.getItem(y.a,!1)?g:this.N(g)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$kQ=w,w.a="profileAssociationsMigration",e.$kQ=w=y=Ue([Ne(0,R.$fQ),Ne(1,A.$El),Ne(2,r.$Ii),Ne(3,S.$7k),Ne(4,k.$7j)],w);let a=$=class extends w{constructor(g,p,m,b,l){super(g,p,m,b,l),this.$=g}P(g){g.length?this.$.setItem($.b,g.map(p=>({...p,location:this.w.extUri.basename(p.location)}))):this.$.removeItem($.b)}O(){const g=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(g),this.$.setItem("userDataProfilesMigration",!0)),g}R(g){g.emptyWindows||g.workspaces?this.$.setItem($.c,g):this.$.removeItem($.c)}Q(){const g="workspaceAndProfileInfo",p=this.$.getItem(g,void 0);if(p){this.$.removeItem(g);const b=p.reduce((l,{workspace:t,profile:o})=>(l[n.URI.revive(t).toString()]=n.URI.revive(o).toString(),l),{});this.$.setItem($.c,{workspaces:b})}const m=super.Q();return this.$.getItem($.a,!1)||(this.R(m),this.$.setItem($.a,!0)),m}};e.$lQ=a,e.$lQ=a=$=Ue([Ne(0,R.$gQ),Ne(1,A.$El),Ne(2,r.$Ii),Ne(3,S.$7k),Ne(4,k.$7j)],a);let f=class extends a{constructor(g,p,m,b){super(new E.$jQ(E.SaveStrategy.IMMEDIATE,p,b,m),g,p,m,b)}async init(){return await this.$.init(),super.init()}};e.$mQ=f,e.$mQ=f=Ue([Ne(0,A.$El),Ne(1,r.$Ii),Ne(2,S.$7k),Ne(3,k.$7j)],f)}),define(Se[143],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=void 0,e.$on=(0,n.$Ai)("extensionHostStatusService");class r{constructor(){this.a=new Map}setExitInfo(k,R){this.a.set(k,R)}getExitInfo(k){return this.a.get(k)||null}}e.$pn=r}),define(Se[293],De([1,0,61,6,14]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xn=void 0;function k(A){let v=0,s=0,E=0;A>=1e3&&(E=Math.floor(A/1e3),A-=E*1e3),E>=60&&(s=Math.floor(E/60),E-=s*60),s>=60&&(v=Math.floor(s/60),s-=v*60);const y=v?`${v}h`:"",$=s?`${s}m`:"",w=E?`${E}s`:"",a=A?`${A}ms`:"";return`${y}${$}${w}${a}`}class R{constructor(v,s,E,y){this.i=v,this.j=s,this.a=new r.$he,this.onClose=this.a.event,this.b=n.ProtocolConstants.ReconnectionGraceTime,this.c=n.ProtocolConstants.ReconnectionShortGraceTime,this.d=E,this.protocol=y,this.e=!1,this.f=new S.$Nh(()=>{this.k(`The reconnection grace time of ${k(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new S.$Nh(()=>{this.k(`The reconnection short grace time of ${k(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${k(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(v){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${v}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${k(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const v=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),v.end(),this.a.fire(void 0)}acceptReconnection(v,s,E){this.d=v,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(s,E),this.protocol.endAcceptReconnection()}}e.$xn=R}),define(Se[101],De([1,0,31,13,9,178,63]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gm=e.InternalNLSConfiguration=void 0,e.$fm=E;const A=S.$jc(r.$Ug.asFileUri("").fsPath,"nls.metadata.json"),v=new Map;function s(a){return new Promise(f=>n.exists(a,f))}function E(a,f){return s(A).then(c=>{if(!c||!R.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const g=`${a}||${f}`;let p=v.get(g);return p||(p=k.getNLSConfiguration(R.default.commit,f,A,a,a).then(m=>(y.is(m)&&(m._languagePackSupport=!0),m.locale!=="en"&&m.locale!=="en-us"&&Object.keys(m.availableLanguages).length===0&&v.delete(g),m)),v.set(g,p)),p})}var y;(function(a){function f(c){const g=c;return g&&typeof g._languagePackId=="string"}a.is=f})(y||(e.InternalNLSConfiguration=y={}));const $=async a=>{try{const f=w(await n.promises.readFile(a,"utf8"));return JSON.parse(f).locale}catch(f){return f.code!=="ENOENT"&&console.warn(f),"en"}};e.$gm=$;const w=a=>{const f=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return a.replace(f,(c,g,p,m,b)=>{if(m)return"";if(b){const l=b.length;return l>2&&b[l-1]===`
`?b[l-2]==="\r"?`\r
`:`
`:""}else return c})}}),define(Se[144],De([1,0,20,4,28,53,64,16,5,12,29,36,34,101]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=void 0;let a=class extends R.$Dq{constructor(c,g,p,m,b,l,t,o){super(r.URI.file(b.builtinExtensionsPath),r.URI.file(b.extensionsPath),(0,n.$bh)(b.userHome,".vscode-oss-dev","extensions","control.json"),c.defaultProfile,c,g,p,m,b,l,t,o),this.S=b}async f(c){const g=await(0,w.$fm)(c,this.S.userDataPath);if(w.InternalNLSConfiguration.is(g))try{const p=await this.w.readFile(r.URI.file(g._translationsConfigFile));return JSON.parse(p.value.toString())}catch{}return Object.create(null)}};e.$_P=a,e.$_P=a=Ue([Ne(0,$.$Gl),Ne(1,k.$yq),Ne(2,A.$7k),Ne(3,s.$7j),Ne(4,S.$Ii),Ne(5,E.$nk),Ne(6,y.$El),Ne(7,v.$zi)],a)}),define(Se[102],De([1,0,294,31,9,22,13,25]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$An=e.$zn=e.$yn=e.ServerConnectionTokenType=void 0,e.$Bn=w,e.$Cn=a,e.$Dn=f;const v=/^[0-9A-Za-z_-]+$/;var s;(function(c){c[c.None=0]="None",c[c.Optional=1]="Optional",c[c.Mandatory=2]="Mandatory"})(s||(e.ServerConnectionTokenType=s={}));class E{constructor(){this.type=s.None}validate(g){return!0}}e.$yn=E;class y{constructor(g){this.value=g,this.type=s.Mandatory}validate(g){return g===this.value}}e.$zn=y;class ${constructor(g){this.message=g}}e.$An=$;async function w(c,g){const p=c["without-connection-token"],m=c["connection-token"],b=c["connection-token-file"];if(p)return typeof m<"u"||typeof b<"u"?new $("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new E;if(typeof b<"u"){if(typeof m<"u")return new $("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let l;try{l=r.readFileSync(b).toString().replace(/\r?\n$/,"")}catch{return new $(`Unable to read the connection token file at '${b}'.`)}return v.test(l)?new y(l):new $(`The connection token defined in '${b} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof m<"u"?v.test(m)?new y(m):new $(`The connection token '${m} does not adhere to the characters 0-9, a-z, A-Z or -.`):new y(await g())}async function a(c){return w(c,async()=>{if(!c["user-data-dir"])return(0,k.$Wg)();const p=S.$jc(c["user-data-dir"],"token");try{const l=(await A.Promises.readFile(p)).toString().replace(/\r?\n$/,"");if(v.test(l))return l}catch{}const m=(0,k.$Wg)();try{await A.Promises.writeFile(p,m,{mode:384})}catch{}return m})}function f(c,g,p){if(c.validate(p.query[R.$Mg]))return!0;const m=n.parse(g.headers.cookie||"");return c.validate(m[R.$Lg])}}),define(Se[54],De([1,0,228,119,70,5,28,77]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$gn=e.$fn=void 0,e.$fn={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},"disable-file-uploads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:n.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:n.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:n.localize(2,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:n.localize(3,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:n.localize(4,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:n.localize(5,null)},"without-connection-token":{type:"boolean",cat:"o",description:n.localize(6,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:n.localize(7,null)},"server-data-dir":{type:"string",cat:"o",description:n.localize(8,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:n.localize(9,null)},"user-data-dir":S.$ym["user-data-dir"],"enable-smoke-test-driver":S.$ym["enable-smoke-test-driver"],"disable-telemetry":S.$ym["disable-telemetry"],"disable-workspace-trust":S.$ym["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:S.$ym.log,logsPath:S.$ym.logsPath,"force-disable-user-env":S.$ym["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:n.localize(10,null)},"default-workspace":{type:"string",description:n.localize(11,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":S.$ym["extensions-dir"],"extensions-download-dir":S.$ym["extensions-download-dir"],"builtin-extensions-dir":S.$ym["builtin-extensions-dir"],"install-extension":S.$ym["install-extension"],"install-builtin-extension":S.$ym["install-builtin-extension"],"update-extensions":S.$ym["update-extensions"],"uninstall-extension":S.$ym["uninstall-extension"],"list-extensions":S.$ym["list-extensions"],"locate-extension":S.$ym["locate-extension"],"show-versions":S.$ym["show-versions"],category:S.$ym.category,force:S.$ym.force,"do-not-sync":S.$ym["do-not-sync"],"pre-release":S.$ym["pre-release"],"start-server":{type:"boolean",cat:"e",description:n.localize(12,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:S.$ym.help,version:S.$ym.version,"locate-shell-integration-path":S.$ym["locate-shell-integration-path"],compatibility:{type:"string"},_:S.$ym._},e.$gn=(0,k.$Bi)(R.$Hi);class v extends r.$cn{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$hn=v,Ue([A.$5h],v.prototype,"userRoamingDataHome",null)}),define(Se[295],De([1,0,339,279,296,32]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0;class R extends n.AppInsightsCore{constructor(v,s,E){super(),this.b=v,this.a={measurements:{},properties:{}};try{const y=k.cpus();this.a.measurements.cores=y.length,this.a.properties["common.cpuModel"]=y[0].model}catch{}try{this.a.properties["common.shell"]=k.userInfo().shell,this.a.properties["common.release"]=k.release(),this.a.properties["common.arch"]=k.arch()}catch{}this.a.properties["common.remoteMachineId"]=s,this.a.properties["common.isContainer"]=E}track(v){const s=v.baseData||{};s.measurements={...s.measurements||{},...this.a.measurements},s.properties={...s.properties||{},...this.a.properties};try{s.measurements.memoryFree=k.freemem(),s.measurements.memoryTotal=k.totalmem()}catch{}try{const E=(/^http:/.test(this.b)?S:r).request(this.b,{method:"POST",headers:{"Content-Type":"application/json"}});E.on("error",()=>{}),E.write(JSON.stringify(s)),E.end()}catch{}}}e.$aQ=R}),define(Se[297],De([1,0,31,25,83,93,294,96,37,66,3,12,54,9,13,22,29,102,47,19,4,15,11,101,35]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m,b,l,t,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FQ=e.$EQ=e.$DQ=e.$CQ=e.$BQ=e.CacheControl=void 0,e.$zQ=h,e.$AQ=D;const i={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function h(X,ie,ne,x){ie.writeHead(ne,{"Content-Type":"text/plain"}),ie.end(x)}var u;(function(X){X[X.NO_CACHING=0]="NO_CACHING",X[X.ETAG=1]="ETAG",X[X.NO_EXPIRY=2]="NO_EXPIRY"})(u||(e.CacheControl=u={}));async function D(X,ie,ne,x,re,q){try{const te=await r.Promises.stat(X);if(ie===u.ETAG){const le=`W/"${[te.ino,te.size,te.mtime.getTime()].join("-")}"`;if(x.headers["if-none-match"]===le)return re.writeHead(304),void re.end();q.Etag=le}else ie===u.NO_EXPIRY?q["Cache-Control"]="public, max-age=31536000":ie===u.NO_CACHING&&(q["Cache-Control"]="no-store");q["Content-Type"]=i[(0,w.$oc)(X)]||(0,s.$2s)(X)||"text/plain",re.writeHead(200,q),(0,n.createReadStream)(X).pipe(re)}catch(te){return te.code!=="ENOENT"?(ne.error(te),console.error(te.toString())):console.error(`File not found: ${X}`),re.writeHead(404,{"Content-Type":"text/plain"}),void re.end("Not found")}}const I=(0,w.$mc)(a.$Ug.asFileUri("").fsPath);let T=class{constructor(ie,ne,x,re,q,te,le){this.f=ie,this.g=ne,this.serverRootPath=x,this.h=re,this.i=q,this.j=te,this.k=le,this.a=this.k.extensionsGallery?.resourceUrlTemplate?b.URI.parse(this.k.extensionsGallery.resourceUrlTemplate):void 0,this.b=`${x}/static`,this.c=`${x}/callback`,this.d="/web-extension-resource"}async handle(ie,ne,x){try{const re=x.pathname;return re.startsWith(this.b)&&re.charCodeAt(this.b.length)===d.CharCode.Slash?this.l(ie,ne,x):re===this.g?this.o(ie,ne,x):re===this.c?this.q(ne):re.startsWith(this.d)&&re.charCodeAt(this.d.length)===d.CharCode.Slash?this.n(ie,ne,x):h(ie,ne,404,"Not found.")}catch(re){return this.i.error(re),console.error(re.toString()),h(ie,ne,500,"Internal Server Error.")}}async l(ie,ne,x){const re=Object.create(null),te=decodeURIComponent(x.pathname).substring(this.b.length+1),le=(0,w.$jc)(I,te);return(0,v.$zg)(le,I,!E.$e)?D(le,this.h.isBuilt?u.NO_EXPIRY:u.ETAG,this.i,ie,ne,re):h(ie,ne,400,"Bad request.")}m(ie){const ne=ie.authority.indexOf(".");return ne!==-1?ie.authority.substring(ne+1):void 0}async n(ie,ne,x){if(!this.a)return h(ie,ne,500,"No extension gallery service configured.");const re=decodeURIComponent(x.pathname),q=(0,w.$hc)(re.substring(this.d.length+1)),te=b.URI.parse(q).with({scheme:this.a.scheme,authority:q.substring(0,q.indexOf("/")),path:q.substring(q.indexOf("/")+1)});if(this.m(this.a)!==this.m(te))return h(ie,ne,403,"Request Forbidden");const le={},M=ae=>{const ee=ie.headers[ae];ee&&((0,t.$ag)(ee)||ee[0])?le[ae]=(0,t.$ag)(ee)?ee:ee[0]:ae!==ae.toLowerCase()&&M(ae.toLowerCase())};M("X-Client-Name"),M("X-Client-Version"),M("X-Machine-Id"),M("X-Client-Commit");const z=await this.j.request({type:"GET",url:te.toString(!0),headers:le},m.CancellationToken.None),oe=z.res.statusCode||500;if(oe!==200){let ae=null;try{ae=await(0,p.$2p)(z)}catch{}return h(ie,ne,oe,ae||`Request failed with status ${oe}`)}const ce=Object.create(null),pe=ae=>{const ee=z.res.headers[ae];ee?ce[ae]=ee:ae!==ae.toLowerCase()&&pe(ae.toLowerCase())};pe("Cache-Control"),pe("Content-Type"),ne.writeHead(200,ce);const W=await(0,l.$Ve)(z.stream);return void ne.end(W.buffer)}async o(ie,ne,x){const re=x.query[a.$Mg];if(typeof re=="string"){const G=Object.create(null);G["Set-Cookie"]=R.serialize(a.$Lg,re,{sameSite:"lax",maxAge:60*60*24*7});const se=Object.create(null);for(const Ee in x.query)Ee!==a.$Mg&&(se[Ee]=x.query[Ee]);const fe=k.format({pathname:x.pathname,query:se});return G.Location=fe,ne.writeHead(302,G),void ne.end()}const q=!this.h.isBuilt&&this.h.args["use-test-resolver"],te=q?"test+test":"remote";if(!te)return h(ie,ne,400,"Bad request.");function le(G){return JSON.stringify(G).replace(/"/g,"&quot;")}let M;this.h.args["enable-smoke-test-driver"]&&(M=!1);const z=G=>G&&b.URI.file(S.resolve(G)).with({scheme:a.Schemas.vscodeRemote,authority:te}),oe=a.$Ug.asFileUri(this.h.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,ce=!this.h.isBuilt&&this.h.args["github-auth"]?{id:(0,f.$Wg)(),providerId:"github",accessToken:this.h.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,pe=(0,e.$DQ)((0,e.$FQ)(ie)),W=(0,e.$EQ)((0,e.$FQ)(ie)),ae={codeServerVersion:this.k.codeServerVersion,rootEndpoint:pe,updateEndpoint:this.h.args["disable-update-check"]?void 0:pe+"/update/check",logoutEndpoint:this.h.args.auth&&this.h.args.auth!=="none"?pe+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??pe+"/proxy/{{port}}/",serviceWorker:{scope:W+"/",path:pe+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.k.enableTelemetry,telemetryEndpoint:this.k.telemetryEndpoint,embedderIdentifier:"server-distro",extensionsGallery:this.k.extensionsGallery};if(!this.h.isBuilt)try{const G=JSON.parse((await r.Promises.readFile((0,w.$jc)(I,"product.overrides.json"))).toString());Object.assign(ae,G)}catch{}const ee={remoteAuthority:te,serverBasePath:this.g,webviewEndpoint:W+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.h.userDataPath,isEnabledFileDownloads:!this.h.args["disable-file-downloads"],isEnabledFileUploads:!this.h.args["disable-file-uploads"],isEnabledCoderGettingStarted:!this.h.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:M,developmentOptions:{enableSmokeTestDriver:this.h.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.i.getLevel()},settingsSyncOptions:!this.h.isBuilt&&this.h.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.h.args["disable-workspace-trust"],folderUri:z(this.h.args["default-folder"]),workspaceUri:z(this.h.args["default-workspace"]),productConfiguration:ae,callbackRoute:this.c},H=this.h.args.locale||await(0,o.$gm)(this.h.argvResource.fsPath),L=await(0,o.$fm)(H,this.h.userDataPath),V=this.k.extensionsGallery?.nlsBaseUrl,B={WORKBENCH_WEB_CONFIGURATION:le(ee),WORKBENCH_AUTH_SESSION:ce?le(ce):"",WORKBENCH_WEB_BASE_URL:W+this.b,WORKBENCH_NLS_BASE_URL:W+(V?`${V}${V.endsWith("/")?"":"/"}${this.k.commit}/${this.k.version}/`:""),BASE:pe,VS_BASE:W,NLS_CONFIGURATION:le(L)};if(q){const G=[];for(const se of["vscode-test-resolver","github-authentication"]){const fe=JSON.parse((await r.Promises.readFile(a.$Ug.asFileUri(`${a.$Pg}/${se}/package.json`).fsPath)).toString());G.push({extensionPath:se,packageJSON:fe})}B.WORKBENCH_BUILTIN_EXTENSIONS=le(G)}let U;try{U=(await r.Promises.readFile(oe)).toString().replace(/\{\{([^}]+)\}\}/g,(se,fe)=>B[fe]??"undefined")}catch{return ne.writeHead(404,{"Content-Type":"text/plain"}),void ne.end("Not found")}const j={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.p(U).join(" ")} 'sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=' ;`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==g.ServerConnectionTokenType.None&&(j["Set-Cookie"]=R.serialize(a.$Lg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),ne.writeHead(200,j),void ne.end(U)}p(ie){const ne=/<script>([\s\S]+?)<\/script>/img,x=[];let re;for(;re=ne.exec(ie);){const q=A.createHash("sha256"),te=re[1].replace(/\r\n/g,`
`),le=q.update(Buffer.from(te)).digest().toString("base64");x.push(`'sha256-${le}'`)}return x}async q(ie){const ne=a.$Ug.asFileUri("vs/code/browser/workbench/callback.html").fsPath,x=(await r.Promises.readFile(ne)).toString(),re=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.p(x).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return ie.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":re}),void ie.end(x)}};e.$BQ=T,e.$BQ=T=Ue([Ne(3,$.$gn),Ne(4,y.$7j),Ne(5,p.$Wp),Ne(6,c.$nk)],T);const O=(X,ie=!1)=>X.replace(/\/\/+/g,"/").replace(/\/+$/,ie?"/":"");e.$CQ=O;const C=X=>{const ie=(X.split("?",1)[0].match(/\//g)||[]).length;return(0,e.$CQ)("./"+(ie>1?"../".repeat(ie-1):""))};e.$DQ=C;const P=X=>{const ie=X.split("?",1)[0].split("/");return(0,e.$CQ)("./"+ie[ie.length-1])};e.$EQ=P;const Q=X=>X.originalUrl||X.url;e.$FQ=Q}),define(Se[298],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=void 0,e.$dP=(0,n.$Ai)("IExtHostInitDataService")}),define(Se[299],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=void 0,e.$ZO=(0,n.$Ai)("IExtHostRpcService");class r{constructor(k){this.getProxy=k.getProxy.bind(k),this.set=k.set.bind(k),this.dispose=k.dispose.bind(k),this.assertRegistered=k.assertRegistered.bind(k),this.drain=k.drain.bind(k)}}e.$1O=r}),define(Se[74],De([1,0,59]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=S;function r(k){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:k,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function S(k){return new n.$En(r(k))}}),define(Se[300],De([1,0,3,45,4,74,59,115,272,9,102,20]),function(he,e,n,r,S,k,R,A,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rs=void 0;class ${constructor(a,f,c,g){this.b=a,this.c=f,this.d=c,this.e=g}async call(a,f,c){switch(f){case"getEnvironmentData":{const g=c,p=(0,k.$Ks)(g.remoteAuthority);let m=await this.f(g.profile);return m=(0,R.$Gn)(m,p),m}case"getExtensionHostExitInfo":{const g=c;return this.e.getExitInfo(g.reconnectionToken)}case"getDiagnosticInfo":{const g=c,p={machineInfo:(0,v.$Os)()},m=g.includeProcesses?(0,A.$Ms)(process.pid):Promise.resolve();let b=[];const l={};if(g.folders){const t=(0,k.$Ks)("");b=g.folders.map(d=>S.URI.revive(t.transformIncoming(d))).filter(d=>d.scheme==="file").map(d=>(0,v.$Ns)(d.fsPath,["node_modules",".git"]).then(i=>{l[(0,s.$nc)(d.fsPath)]=i}))}return Promise.all([m,...b]).then(([t,o])=>(p.processes=t||void 0,p.workspaceMetadata=g.folders?l:void 0,p))}}throw new Error(`IPC Command ${f} not found`)}listen(a,f,c){throw new Error("Not supported")}async f(a){a&&!this.d.profiles.some(c=>c.id===a)&&await this.d.createProfile(a,a);let f=!1;if(process.platform==="linux"){const c=process.glibcVersion;f=(c?parseInt(c.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==E.ServerConnectionTokenType.None?this.b.value:"",appRoot:S.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,y.$bh)(this.c.logsHome,`exthost${$.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:n.OS,arch:process.arch,marks:r.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(c=>({...c}))},isUnsupportedGlibc:f}}}e.$Rs=$,$.a=1}),define(Se[301],De([1,0,4,74,72,9,257]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class A extends R.$Ss{constructor(E,y){super(new S.$ir(E),E),this.N=y,this.M=new Map,this.B(this.a)}c(E){let y=this.M.get(E.remoteAuthority);return y||(y=(0,r.$Ks)(E.remoteAuthority),this.M.set(E.remoteAuthority,y)),y}f(E,y,$=!1){if($&&y.path==="/vscode-resource"&&y.query){const w=JSON.parse(y.query).requestResourcePath;return n.URI.from({scheme:"file",path:w})}return n.URI.revive(E.transformIncoming(y))}L(E,y){return new v(E,y,this.b,this.N)}}e.$Us=A;class v extends R.$Ts{constructor(E,y,$,w){super(E,y,$,w)}j(E){const y=E.args["file-watcher-polling"];if(y){const $=y.split(k.$tc),w=Number($[0]);if(w>0)return{usePolling:$.length>1?$.slice(1):!0,pollingInterval:w}}}m(E){if(E.extensionsPath)return[k.$gc.join(E.extensionsPath,"**")]}}}),define(Se[103],De([1,0,231,11,4,2,5,38,16,13,42,190,58]),function(he,e,n,r,S,k,R,A,v,s,E,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$5F=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$UF=e.EditorInputCapabilities=e.$TF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$KF=f,e.$LF=c,e.$MF=g,e.$NF=p,e.$OF=m,e.$PF=b,e.$QF=l,e.$RF=t,e.$SF=o,e.$VF=I,e.$WF=O,e.$XF=C,e.$YF=P,e.$ZF=Q,e.$1F=X,e.$2F=ie,e.$3F=ne,e.$4F=M,e.$6F=ce,e.$7F=W,e.$8F=ae,e.$9F=ee,e.$FF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$GF={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.$HF="workbench.editor.sidebysideEditor",e.$IF="workbench.editors.textDiffEditor",e.$JF="workbench.editors.binaryResourceDiffEditor";var w;(function(H){H[H.PROGRAMMATIC=1]="PROGRAMMATIC",H[H.USER=2]="USER",H[H.EDIT=3]="EDIT",H[H.NAVIGATION=4]="NAVIGATION",H[H.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var a;(function(H){H[H.IDENTICAL=1]="IDENTICAL",H[H.SIMILAR=2]="SIMILAR",H[H.DIFFERENT=3]="DIFFERENT"})(a||(e.EditorPaneSelectionCompareResult=a={}));function f(H){const L=H;return!!L&&typeof L.getSelection=="function"&&!!L.onDidChangeSelection}function c(H){const L=H;return!!L&&typeof L.getScrollPosition=="function"&&typeof L.setScrollPosition=="function"&&!!L.onDidChangeScroll}function g(H,L,V){for(const B of V.visibleEditorPanes)if(B.group.id===L&&H.matches(B.input))return B.getViewState()}function p(H){if(I(H))return!1;const L=H;return S.URI.isUri(L?.resource)}function m(H){if(I(H))return!1;const L=H;return L?.original!==void 0&&L.modified!==void 0}function b(H){if(I(H))return!1;const L=H;return!L||L.resources&&!Array.isArray(L.resources)?!1:!!L.resources||!!L.multiDiffSource}function l(H){if(I(H)||m(H))return!1;const L=H;return L?.primary!==void 0&&L.secondary!==void 0}function t(H){if(I(H))return!1;const L=H;return L?L.resource===void 0||L.resource.scheme===s.Schemas.untitled||L.forceUntitled===!0:!1}function o(H){if(I(H))return!1;const L=H;return S.URI.isUri(L?.base?.resource)&&S.URI.isUri(L?.input1?.resource)&&S.URI.isUri(L?.input2?.resource)&&S.URI.isUri(L?.result?.resource)}var d;(function(H){H[H.SHORT=0]="SHORT",H[H.MEDIUM=1]="MEDIUM",H[H.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var i;(function(H){H[H.EXPLICIT=1]="EXPLICIT",H[H.AUTO=2]="AUTO",H[H.FOCUS_CHANGE=3]="FOCUS_CHANGE",H[H.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class h{constructor(){this.a=new Map}registerSource(L,V){let B=this.a.get(L);return B||(B={source:L,label:V},this.a.set(L,B)),B.source}getSourceLabel(L){return this.a.get(L)?.label??L}}e.$TF=new h;var u;(function(H){H[H.None=0]="None",H[H.Readonly=2]="Readonly",H[H.Untitled=4]="Untitled",H[H.Singleton=8]="Singleton",H[H.RequiresTrust=16]="RequiresTrust",H[H.CanSplitInGroup=32]="CanSplitInGroup",H[H.ForceDescription=64]="ForceDescription",H[H.CanDropIntoEditor=128]="CanDropIntoEditor",H[H.MultipleEditors=256]="MultipleEditors",H[H.Scratchpad=512]="Scratchpad"})(u||(e.EditorInputCapabilities=u={}));class D extends k.$Uc{}e.$UF=D;function I(H){return H instanceof D}function T(H){const L=H;return S.URI.isUri(L?.preferredResource)}function O(H){const L=H;return I(L?.primary)&&I(L?.secondary)}function C(H){const L=H;return I(L?.modified)&&I(L?.original)}function P(H,L,V,B,U){return ee(B,[(0,y.$kj)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const K={...V,limits:{size:Number.MAX_VALUE}};H.openEditor(L,K)}}),(0,y.$kj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>U.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}function Q(H){return I(H?.editor)}function X(H){const L=H;return Q(H)&&L?.group!==void 0}function ie(H){const L=H;return typeof L?.groupId=="number"&&I(L.editor)}function ne(H){return typeof H?.groupId=="number"}var x;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.REPLACE=1]="REPLACE",H[H.MOVE=2]="MOVE",H[H.UNPIN=3]="UNPIN"})(x||(e.EditorCloseContext=x={}));var re;(function(H){H[H.GROUP_ACTIVE=0]="GROUP_ACTIVE",H[H.GROUP_INDEX=1]="GROUP_INDEX",H[H.GROUP_LABEL=2]="GROUP_LABEL",H[H.GROUP_LOCKED=3]="GROUP_LOCKED",H[H.EDITORS_SELECTION=4]="EDITORS_SELECTION",H[H.EDITOR_OPEN=5]="EDITOR_OPEN",H[H.EDITOR_CLOSE=6]="EDITOR_CLOSE",H[H.EDITOR_MOVE=7]="EDITOR_MOVE",H[H.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",H[H.EDITOR_LABEL=9]="EDITOR_LABEL",H[H.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",H[H.EDITOR_PIN=11]="EDITOR_PIN",H[H.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",H[H.EDITOR_STICKY=13]="EDITOR_STICKY",H[H.EDITOR_DIRTY=14]="EDITOR_DIRTY",H[H.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(re||(e.GroupModelChangeKind=re={}));var q;(function(H){H[H.PRIMARY=1]="PRIMARY",H[H.SECONDARY=2]="SECONDARY",H[H.BOTH=3]="BOTH",H[H.ANY=4]="ANY"})(q||(e.SideBySideEditor=q={}));class te{getOriginalUri(L,V){if(!L)return;if(o(L))return e.$5F.getOriginalUri(L.result,V);if(V?.supportSideBySide){const{primary:U,secondary:K}=this.a(L);if(U&&K){if(V?.supportSideBySide===q.BOTH)return{primary:this.getOriginalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(K,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===q.ANY)return this.getOriginalUri(U,{filterByScheme:V.filterByScheme})??this.getOriginalUri(K,{filterByScheme:V.filterByScheme});L=V.supportSideBySide===q.PRIMARY?U:K}}if(m(L)||b(L)||l(L)||o(L))return;const B=T(L)?L.preferredResource:L.resource;return!B||!V||!V.filterByScheme?B:this.b(B,V.filterByScheme)}a(L){return O(L)||l(L)?{primary:L.primary,secondary:L.secondary}:C(L)||m(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,V){if(!L)return;if(o(L))return e.$5F.getCanonicalUri(L.result,V);if(V?.supportSideBySide){const{primary:U,secondary:K}=this.a(L);if(U&&K){if(V?.supportSideBySide===q.BOTH)return{primary:this.getCanonicalUri(U,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(K,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===q.ANY)return this.getCanonicalUri(U,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(K,{filterByScheme:V.filterByScheme});L=V.supportSideBySide===q.PRIMARY?U:K}}if(m(L)||b(L)||l(L)||o(L))return;const B=L.resource;return!B||!V||!V.filterByScheme?B:this.b(B,V.filterByScheme)}b(L,V){if(Array.isArray(V)){if(V.some(B=>L.scheme===B))return L}else if(V===L.scheme)return L}}var le;(function(H){H[H.UNKNOWN=0]="UNKNOWN",H[H.KEYBOARD=1]="KEYBOARD",H[H.MOUSE=2]="MOUSE"})(le||(e.EditorCloseMethod=le={}));function M(H,L,V,B){if(!H.isSticky(L))return!1;switch(B.preventPinnedEditorClose){case"keyboardAndMouse":return V===le.MOUSE||V===le.KEYBOARD;case"mouse":return V===le.MOUSE;case"keyboard":return V===le.KEYBOARD}return!1}e.$5F=new te;var z;(function(H){H[H.LEFT=0]="LEFT",H[H.RIGHT=1]="RIGHT"})(z||(e.CloseDirection=z={}));class oe{constructor(){this.c=new Map,this.d=new Map}start(L){const V=this.a=L.get(R.$zi);for(const[B,U]of this.c)this.e(B,U,V);this.c.clear()}e(L,V,B){const U=B.createInstance(V);this.d.set(L,U)}registerFileEditorFactory(L){if(this.b)throw new Error("Can only register one file editor factory.");this.b=L}getFileEditorFactory(){return(0,r.$lg)(this.b)}registerEditorSerializer(L,V){if(this.c.has(L)||this.d.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.a?this.e(L,V,this.a):this.c.set(L,V),(0,k.$Sc)(()=>{this.c.delete(L),this.d.delete(L)})}getEditorSerializer(L){return this.d.get(typeof L=="string"?L:L.typeId)}}A.$ko.add(e.$FF.EditorFactory,new oe);async function ce(H,L,V){return!H||!H.length?[]:await Promise.all(H.map(async B=>{const U=S.URI.revive(B.fileUri);if(!U){V.info("Cannot resolve the path because it is not valid.",B);return}if(!await L.canHandleResource(U)){V.info("Cannot resolve the path because it cannot be handled",B);return}let Z=B.exists,j=B.type;if(typeof Z!="boolean"||typeof j!="number")try{j=(await L.stat(U)).isDirectory?v.FileType.Directory:v.FileType.Unknown,Z=!0}catch(se){V.error(se),Z=!1}if(!Z&&B.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",B);return}if(j===v.FileType.Directory){V.info("Cannot resolve the path because it is a directory",B);return}const G={...B.options,pinned:!0};return Z?{resource:U,options:G}:{resource:U,options:G,forceUntitled:!0}}))}var pe;(function(H){H[H.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",H[H.SEQUENTIAL=1]="SEQUENTIAL"})(pe||(e.EditorsOrder=pe={}));function W(H){const L=H;if(!L)return!1;const V=L;if(V.modified)return W(V.modified);const B=L;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}function ae(H){return(0,E.$mj)(H)}function ee(H,L,V){const B=(0,E.$nj)(H,L);return B.forceMessage=V?.forceMessage,B.forceSeverity=V?.forceSeverity,B.allowDialog=V?.allowDialog,B}}),define(Se[302],De([1,0,232,43]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=void 0,e.$iG=new r.$Rj("chatSessionResponseVote","",{type:"string",description:(0,n.localize)(0,null)}),e.$jG=new r.$Rj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,n.localize)(1,null)}),e.$kG=new r.$Rj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,n.localize)(2,null)}),e.$lG=new r.$Rj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,n.localize)(3,null)}),e.$mG=new r.$Rj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,n.localize)(4,null)}),e.$nG=new r.$Rj("chatResponse",!1,{type:"boolean",description:(0,n.localize)(5,null)}),e.$oG=new r.$Rj("chatRequest",!1,{type:"boolean",description:(0,n.localize)(6,null)}),e.$pG=new r.$Rj("chatEditApplied",!1,{type:"boolean",description:(0,n.localize)(7,null)}),e.$qG=new r.$Rj("chatInputHasText",!1,{type:"boolean",description:(0,n.localize)(8,null)}),e.$rG=new r.$Rj("chatInputHasFocus",!1,{type:"boolean",description:(0,n.localize)(9,null)}),e.$sG=new r.$Rj("inChatInput",!1,{type:"boolean",description:(0,n.localize)(10,null)}),e.$tG=new r.$Rj("inChat",!1,{type:"boolean",description:(0,n.localize)(11,null)}),e.$uG=new r.$Rj("chatIsEnabled",!1,{type:"boolean",description:(0,n.localize)(12,null)}),e.$vG=new r.$Rj("chatCursorAtTop",!1),e.$wG=new r.$Rj("chatInputHasAgent",!1),e.$xG=new r.$Rj("chatLocation",void 0),e.$yG=new r.$Rj("quickChatHasFocus",!1,{type:"boolean",description:(0,n.localize)(13,null)})}),define(Se[303],De([1,0,106,14,19,6,40,2,48,165,17,43,23,5,12,29,47,100,302]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.ChatAgentLocation=void 0,e.$DH=d,e.$EH=i;var b;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(b||(e.ChatAgentLocation=b={})),function(h){function u(D){switch(D){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=u}(b||(e.ChatAgentLocation=b={})),e.$yH=(0,w.$Ai)("chatAgentService");let l=class{constructor(u){this.f=u,this.b=new Map,this.d=new k.$he,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=p.$uG.bindTo(this.f)}registerAgent(u,D){if(this.getAgent(u))throw new Error(`Agent already registered: ${JSON.stringify(u)}`);const T=this,O=D.slashCommands;D={...D,get slashCommands(){return O.filter(P=>!P.when||T.f.contextMatchesRules(y.$yj.deserialize(P.when)))}};const C={data:D};return this.b.set(u,C),(0,A.$Sc)(()=>{this.b.delete(u),this.d.fire(void 0)})}registerAgentImplementation(u,D){const I=this.b.get(u);if(!I)throw new Error(`Unknown agent: ${JSON.stringify(u)}`);if(I.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(u)}`);return I.data.isDefault&&this.e.set(!0),I.impl=D,this.d.fire(new t(I.data,D)),(0,A.$Sc)(()=>{I.impl=void 0,this.d.fire(void 0),I.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(u,D){u.isDynamic=!0;const I={data:u,impl:D};return this.b.set(u.id,I),this.d.fire(new t(u,D)),(0,A.$Sc)(()=>{this.b.delete(u.id),this.d.fire(void 0)})}registerAgentCompletionProvider(u,D){return this.g.set(u,D),{dispose:()=>{this.g.delete(u)}}}async getAgentCompletionItems(u,D,I){return await this.g.get(u)?.(D,I)??[]}updateAgent(u,D){const I=this.b.get(u);if(!I?.impl)throw new Error(`No activated agent with id ${JSON.stringify(u)} registered`);I.data.metadata={...I.data.metadata,...D},this.d.fire(new t(I.data,I.impl))}getDefaultAgent(u){return(0,n.$fb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(u))}getContributedDefaultAgent(u){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(u))}getSecondaryAgent(){return R.Iterable.find(this.b.values(),u=>!!u.data.metadata.isSecondary)?.data}getAgent(u){if(this.h(u))return this.b.get(u)?.data}h(u){const D=this.b.get(u);return!D?.data.when||this.f.contextMatchesRules(y.$yj.deserialize(D.data.when))}getAgentByFullyQualifiedId(u){const D=R.Iterable.find(this.b.values(),I=>d(I.data)===u)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(u=>u.data).filter(u=>this.h(u.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(u=>!!u.impl).filter(u=>this.h(u.data.id)).map(u=>new t(u.data,u.impl))}getAgentsByName(u){return this.getAgents().filter(D=>D.name===u)}async invokeAgent(u,D,I,T,O){const C=this.b.get(u);if(!C?.impl)throw new Error(`No activated agent with id "${u}"`);return await C.impl.invoke(D,I,T,O)}async getFollowups(u,D,I,T,O){const C=this.b.get(u);if(!C?.impl)throw new Error(`No activated agent with id "${u}"`);return C.impl?.provideFollowups?C.impl.provideFollowups(D,I,T,O):[]}};e.$zH=l,l.AGENT_LEADER="@",e.$zH=l=Ue([Ne(0,y.$Sj)],l);class t{constructor(u,D){this.b=u,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(u,D,I,T){return this.d.invoke(u,D,I,T)}async provideFollowups(u,D,I,T){return this.d.provideFollowups?this.d.provideFollowups(u,D,I,T):[]}provideWelcomeMessage(u,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(u,D)}provideSampleQuestions(u,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(u,D)}}e.$AH=t,e.$BH=(0,w.$Ai)("chatAgentNameService");let o=m=class{constructor(u,D,I,T){if(this.g=D,this.h=I,this.i=T,this.e=(0,s.$3d)(this,Object.create(null)),this.f=!1,!u.chatParticipantRegistry)return;this.d=u.chatParticipantRegistry;const O=T.get(m.b,g.StorageScope.APPLICATION);try{this.e.set(JSON.parse(O??"{}"),void 0)}catch{T.remove(m.b,g.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(u=>this.h.warn("Failed to fetch chat participant registry",u)).then(()=>(0,r.$Bh)(5*60*1e3)).then(()=>this.j())}async k(){const u=await this.g.request({type:"GET",url:this.d},S.CancellationToken.None);if(u.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,c.$3p)(u);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const I=D.restrictedChatParticipants;this.e.set(I,void 0),this.i.store(m.b,JSON.stringify(I),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE)}getAgentNameRestriction(u){const D=this.l(u.name,u).get(),I=!u.fullName||this.l(u.fullName.replace(/\s/g,""),u).get();return D&&I}l(u,D){return this.e.map(T=>T[u.toLowerCase()]).map(T=>T?T.some(O=>(0,E.$Bf)(O,O.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$CH=o,o.b="chat.participantNameRegistry",e.$CH=o=m=Ue([Ne(0,f.$nk),Ne(1,c.$Wp),Ne(2,a.$7j),Ne(3,g.$0p)],o);function d(h){return`${h.extensionId.value}.${h.id}`}function i(h){const u="name"in h?h:{...h,name:h.id};return"extensionPublisherId"in u||(u.extensionPublisherId=u.extensionPublisher??""),"extensionDisplayName"in u||(u.extensionDisplayName=""),"extensionId"in u||(u.extensionId=new $.$Xm("")),(0,v.$0h)(u)}}),define(Se[304],De([1,0,4,234,43,5]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$UJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$SJ=e.MemoryRangeType=e.State=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=void 0,e.$RJ=v,e.$TJ=E,e.$FI="workbench.view.debug",e.$GI="workbench.debug.variablesView",e.$HI="workbench.debug.watchExpressionsView",e.$II="workbench.debug.callStackView",e.$JI="workbench.debug.loadedScriptsView",e.$KI="workbench.debug.breakPointsView",e.$LI="workbench.debug.disassemblyView",e.$MI="workbench.panel.repl",e.$NI="workbench.panel.repl.view",e.$OI=new S.$Rj("debugType",void 0,{type:"string",description:r.localize(0,null)}),e.$PI=new S.$Rj("debugConfigurationType",void 0,{type:"string",description:r.localize(1,null)}),e.$QI=new S.$Rj("debugState","inactive",{type:"string",description:r.localize(2,null)}),e.$RI="debugUx",e.$SI=new S.$Rj(e.$RI,"default",{type:"string",description:r.localize(3,null)}),e.$TI=new S.$Rj("hasDebugged",!1,{type:"boolean",description:r.localize(4,null)}),e.$UI=new S.$Rj("inDebugMode",!1,{type:"boolean",description:r.localize(5,null)}),e.$VI=new S.$Rj("inDebugRepl",!1,{type:"boolean",description:r.localize(6,null)}),e.$WI=new S.$Rj("breakpointWidgetVisible",!1,{type:"boolean",description:r.localize(7,null)}),e.$XI=new S.$Rj("inBreakpointWidget",!1,{type:"boolean",description:r.localize(8,null)}),e.$YI=new S.$Rj("breakpointsFocused",!0,{type:"boolean",description:r.localize(9,null)}),e.$ZI=new S.$Rj("watchExpressionsFocused",!0,{type:"boolean",description:r.localize(10,null)}),e.$1I=new S.$Rj("watchExpressionsExist",!1,{type:"boolean",description:r.localize(11,null)}),e.$2I=new S.$Rj("variablesFocused",!0,{type:"boolean",description:r.localize(12,null)}),e.$3I=new S.$Rj("expressionSelected",!1,{type:"boolean",description:r.localize(13,null)}),e.$4I=new S.$Rj("breakpointInputFocused",!1,{type:"boolean",description:r.localize(14,null)}),e.$5I=new S.$Rj("callStackItemType",void 0,{type:"string",description:r.localize(15,null)}),e.$6I=new S.$Rj("callStackSessionIsAttach",!1,{type:"boolean",description:r.localize(16,null)}),e.$7I=new S.$Rj("callStackItemStopped",!1,{type:"boolean",description:r.localize(17,null)}),e.$8I=new S.$Rj("callStackSessionHasOneThread",!1,{type:"boolean",description:r.localize(18,null)}),e.$9I=new S.$Rj("watchItemType",void 0,{type:"string",description:r.localize(19,null)}),e.$0I=new S.$Rj("canViewMemory",void 0,{type:"boolean",description:r.localize(20,null)}),e.$$I=new S.$Rj("breakpointItemType",void 0,{type:"string",description:r.localize(21,null)}),e.$_I=new S.$Rj("breakpointItemBytes",void 0,{type:"boolean",description:r.localize(22,null)}),e.$aJ=new S.$Rj("breakpointHasModes",!1,{type:"boolean",description:r.localize(23,null)}),e.$bJ=new S.$Rj("breakpointSupportsCondition",!1,{type:"boolean",description:r.localize(24,null)}),e.$cJ=new S.$Rj("loadedScriptsSupported",!1,{type:"boolean",description:r.localize(25,null)}),e.$dJ=new S.$Rj("loadedScriptsItemType",void 0,{type:"string",description:r.localize(26,null)}),e.$eJ=new S.$Rj("focusedSessionIsAttach",!1,{type:"boolean",description:r.localize(27,null)}),e.$fJ=new S.$Rj("focusedSessionIsNoDebug",!1,{type:"boolean",description:r.localize(28,null)}),e.$gJ=new S.$Rj("stepBackSupported",!1,{type:"boolean",description:r.localize(29,null)}),e.$hJ=new S.$Rj("restartFrameSupported",!1,{type:"boolean",description:r.localize(30,null)}),e.$iJ=new S.$Rj("stackFrameSupportsRestart",!1,{type:"boolean",description:r.localize(31,null)}),e.$jJ=new S.$Rj("jumpToCursorSupported",!1,{type:"boolean",description:r.localize(32,null)}),e.$kJ=new S.$Rj("stepIntoTargetsSupported",!1,{type:"boolean",description:r.localize(33,null)}),e.$lJ=new S.$Rj("breakpointsExist",!1,{type:"boolean",description:r.localize(34,null)}),e.$mJ=new S.$Rj("debuggersAvailable",!1,{type:"boolean",description:r.localize(35,null)}),e.$nJ=new S.$Rj("debugExtensionAvailable",!0,{type:"boolean",description:r.localize(36,null)}),e.$oJ=new S.$Rj("debugProtocolVariableMenuContext",void 0,{type:"string",description:r.localize(37,null)}),e.$pJ=new S.$Rj("debugSetVariableSupported",!1,{type:"boolean",description:r.localize(38,null)}),e.$qJ=new S.$Rj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:r.localize(39,null)}),e.$rJ=new S.$Rj("debugSetExpressionSupported",!1,{type:"boolean",description:r.localize(40,null)}),e.$sJ=new S.$Rj("breakWhenValueChangesSupported",!1,{type:"boolean",description:r.localize(41,null)}),e.$tJ=new S.$Rj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:r.localize(42,null)}),e.$uJ=new S.$Rj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:r.localize(43,null)}),e.$vJ=new S.$Rj("terminateDebuggeeSupported",!1,{type:"boolean",description:r.localize(44,null)}),e.$wJ=new S.$Rj("suspendDebuggeeSupported",!1,{type:"boolean",description:r.localize(45,null)}),e.$xJ=new S.$Rj("variableEvaluateNamePresent",!1,{type:"boolean",description:r.localize(46,null)}),e.$yJ=new S.$Rj("variableIsReadonly",!1,{type:"boolean",description:r.localize(47,null)}),e.$zJ=new S.$Rj("variableValue",!1,{type:"string",description:r.localize(48,null)}),e.$AJ=new S.$Rj("variableType",!1,{type:"string",description:r.localize(49,null)}),e.$BJ=new S.$Rj("variableInterfaces",!1,{type:"array",description:r.localize(50,null)}),e.$CJ=new S.$Rj("variableName",!1,{type:"string",description:r.localize(51,null)}),e.$DJ=new S.$Rj("variableLanguage",!1,{type:"string",description:r.localize(52,null)}),e.$EJ=new S.$Rj("variableExtensionId",!1,{type:"string",description:r.localize(53,null)}),e.$FJ=new S.$Rj("exceptionWidgetVisible",!1,{type:"boolean",description:r.localize(54,null)}),e.$GJ=new S.$Rj("multiSessionRepl",!1,{type:"boolean",description:r.localize(55,null)}),e.$HJ=new S.$Rj("multiSessionDebug",!1,{type:"boolean",description:r.localize(56,null)}),e.$IJ=new S.$Rj("disassembleRequestSupported",!1,{type:"boolean",description:r.localize(57,null)}),e.$JJ=new S.$Rj("disassemblyViewFocus",!1,{type:"boolean",description:r.localize(58,null)}),e.$KJ=new S.$Rj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:r.localize(59,null)}),e.$LJ=new S.$Rj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:r.localize(60,null)});const R=m=>r.localize(61,null,m);e.$MJ=R,e.$NJ="editor.contrib.debug",e.$OJ="editor.contrib.breakpoint",e.$PJ="debug",e.$QJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:r.localize(62,null)};var A;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(A||(e.State=A={}));function v(m){switch(m){case A.Initializing:return"initializing";case A.Stopped:return"stopped";case A.Running:return"running";default:return"inactive"}}var s;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(s||(e.MemoryRangeType=s={})),e.$SJ="vscode-debug-memory";function E(m){return m.source.presentationHint==="deemphasize"||m.presentationHint==="deemphasize"||m.presentationHint==="subtle"}var y;(function(m){m[m.Variable=0]="Variable",m[m.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var $;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var w;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$UJ=(0,k.$Ai)("debugService");var a;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE",m[m.TRIGGER_POINT=3]="TRIGGER_POINT"})(a||(e.BreakpointWidgetContext=a={}));var f;(function(m){m[m.Command=0]="Command",m[m.Tree=1]="Tree"})(f||(e.DebugVisualizationType=f={}));var c;(function(m){m[m.None=0]="None",m[m.Collapsed=1]="Collapsed",m[m.Expanded=2]="Expanded"})(c||(e.DebugTreeItemCollapsibleState=c={}));var g;(function(m){m.deserialize=b=>b,m.serialize=b=>b})(g||(e.IDebugVisualizationTreeItem=g={}));var p;(function(m){m.deserialize=b=>({id:b.id,name:b.name,iconPath:b.iconPath&&{light:n.URI.revive(b.iconPath.light),dark:n.URI.revive(b.iconPath.dark)},iconClass:b.iconClass,visualization:b.visualization}),m.serialize=b=>b})(p||(e.IDebugVisualization=p={}))}),define(Se[305],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=void 0,e.$qP=(0,n.$Ai)("environmentVariableService")}),define(Se[145],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelRequest=e.RemoteTerminalChannelEvent=e.$MP=void 0,e.$MP="remoteterminal";var n;(function(S){S.OnPtyHostExitEvent="$onPtyHostExitEvent",S.OnPtyHostStartEvent="$onPtyHostStartEvent",S.OnPtyHostUnresponsiveEvent="$onPtyHostUnresponsiveEvent",S.OnPtyHostResponsiveEvent="$onPtyHostResponsiveEvent",S.OnPtyHostRequestResolveVariablesEvent="$onPtyHostRequestResolveVariablesEvent",S.OnProcessDataEvent="$onProcessDataEvent",S.OnProcessReadyEvent="$onProcessReadyEvent",S.OnProcessExitEvent="$onProcessExitEvent",S.OnProcessReplayEvent="$onProcessReplayEvent",S.OnProcessOrphanQuestion="$onProcessOrphanQuestion",S.OnExecuteCommand="$onExecuteCommand",S.OnDidRequestDetach="$onDidRequestDetach",S.OnDidChangeProperty="$onDidChangeProperty"})(n||(e.RemoteTerminalChannelEvent=n={}));var r;(function(S){S.RestartPtyHost="$restartPtyHost",S.CreateProcess="$createProcess",S.AttachToProcess="$attachToProcess",S.DetachFromProcess="$detachFromProcess",S.ListProcesses="$listProcesses",S.GetLatency="$getLatency",S.GetPerformanceMarks="$getPerformanceMarks",S.OrphanQuestionReply="$orphanQuestionReply",S.AcceptPtyHostResolvedVariables="$acceptPtyHostResolvedVariables",S.Start="$start",S.Input="$input",S.AcknowledgeDataEvent="$acknowledgeDataEvent",S.Shutdown="$shutdown",S.Resize="$resize",S.ClearBuffer="$clearBuffer",S.GetInitialCwd="$getInitialCwd",S.GetCwd="$getCwd",S.ProcessBinary="$processBinary",S.SendCommandResult="$sendCommandResult",S.InstallAutoReply="$installAutoReply",S.UninstallAllAutoReplies="$uninstallAllAutoReplies",S.GetDefaultSystemShell="$getDefaultSystemShell",S.GetProfiles="$getProfiles",S.GetEnvironment="$getEnvironment",S.GetWslPath="$getWslPath",S.GetTerminalLayoutInfo="$getTerminalLayoutInfo",S.SetTerminalLayoutInfo="$setTerminalLayoutInfo",S.SerializeTerminalState="$serializeTerminalState",S.ReviveTerminalProcesses="$reviveTerminalProcesses",S.GetRevivedPtyNewId="$getRevivedPtyNewId",S.SetUnicodeVersion="$setUnicodeVersion",S.ReduceConnectionGraceTime="$reduceConnectionGraceTime",S.UpdateIcon="$updateIcon",S.UpdateTitle="$updateTitle",S.UpdateProperty="$updateProperty",S.RefreshProperty="$refreshProperty",S.RequestDetachInstance="$requestDetachInstance",S.AcceptDetachInstanceReply="$acceptDetachInstanceReply",S.AcceptDetachedInstance="$acceptDetachedInstance",S.FreePortKillProcess="$freePortKillProcess"})(r||(e.RemoteTerminalChannelRequest=r={}))}),define(Se[306],De([1,0,9,4,67,52,3,136,11]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UP=s,e.$VP=y,e.$WP=a,e.$XP=f,e.$YP=c,e.$ZP=p,e.$1P=m,e.$2P=b,e.$3P=l;function s(t,o){if(o)if(R.$c)for(const d in o){let i=d;for(const u in t)if(d.toLowerCase()===u.toLowerCase()){i=u;break}const h=o[d];h!==void 0&&E(t,i,h)}else Object.keys(o).forEach(d=>{const i=o[d];i!==void 0&&E(t,d,i)})}function E(t,o,d){typeof d=="string"?t[o]=d:delete t[o]}function y(t,o,d,i){t.TERM_PROGRAM="vscode",o&&(t.TERM_PROGRAM_VERSION=o),a(t,i)&&(t.LANG=f(d)),t.COLORTERM="truecolor"}function $(t,o){if(o)for(const d of Object.keys(o)){const i=o[d];i!=null&&(t[d]=i)}}async function w(t,o){return await Promise.all(Object.entries(o).map(async([d,i])=>{if(typeof i=="string")try{o[d]=await t(i)}catch{o[d]=i}})),o}function a(t,o){if(o==="on")return!0;if(o==="auto"){const d=t.LANG;return!d||d.search(/\.UTF\-8$/)===-1&&d.search(/\.utf8$/)===-1&&d.search(/\.euc.+/)===-1}return!1}function f(t){const o=t?t.split("-"):[],d=o.length;if(d===0)return"en_US.UTF-8";if(d===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};o[0]in i&&o.push(i[o[0]])}else o[1]=o[1].toUpperCase();return o.join("_")+".UTF-8"}async function c(t,o,d,i,h,u){if(t.cwd){const I=typeof t.cwd=="object"?t.cwd.fsPath:t.cwd,T=await g(I,d);return(0,A.$RP)(T||I)}let D;return!t.ignoreConfigurationCwd&&h&&(d&&(h=await g(h,d,u)),h&&(n.$ic(h)?D=h:i&&(D=n.$jc(i.fsPath,h)))),D||(D=i?i.fsPath:o||""),(0,A.$RP)(D)}async function g(t,o,d){if(o)try{return await o(t)}catch(i){d?.error("Could not resolve terminal cwd",i);return}return t}function p(t,o,d){if(d)return i=>d.resolveWithEnvironment(o,t,i)}async function m(t,o,d,i,h,u){const D={};if(t.strictEnv)$(D,t.env);else{$(D,u);const I={...o};d&&(I&&await w(d,I),t.env&&await w(d,t.env)),R.$d&&(D.VSCODE_NODE_OPTIONS&&(D.NODE_OPTIONS=D.VSCODE_NODE_OPTIONS,delete D.VSCODE_NODE_OPTIONS),D.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(D.NODE_REPL_EXTERNAL_MODULE=D.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete D.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,S.$sm)(D,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),s(D,I),s(D,t.env),y(D,i,R.$q,h)}return D}async function b(t,o,d,i,h,u,D=R.$c){let I;if((0,v.$ag)(t)?I=t:(I=t.fsPath,D&&u!==R.OperatingSystem.Windows?I=I.replace(/\\/g,"/"):!D&&u===R.OperatingSystem.Windows&&(I=I.replace(/\//g,"\\"))),!o)return I;const T=I.includes(" "),O=I.includes("(")||I.includes(")"),C=n.$nc(o,".exe"),P=C==="pwsh"||d==="pwsh"||C==="powershell"||d==="powershell";if(P&&(T||I.includes("'")))return`& '${I.replace(/'/g,"''")}'`;if(O&&P)return`& '${I}'`;if(u===R.OperatingSystem.Windows){if(i!==void 0)return i===k.WindowsShellType.GitBash?(0,A.$PP)(I.replace(/\\/g,"/")):i===k.WindowsShellType.Wsl?h?.getWslPath(I,"win-to-unix")||I:T?`"${I}"`:I;const Q=o.toLowerCase();return Q.includes("wsl")||Q.includes("bash.exe")&&!Q.toLowerCase().includes("git")?h?.getWslPath(I,"win-to-unix")||I:T?`"${I}"`:I}return(0,A.$PP)(I)}function l(t,o,d){const i=typeof t=="string"?r.URI.parse(t):t;let h=i?o.getWorkspaceFolder(i)??void 0:void 0;if(!h){const u=d.getLastActiveWorkspaceRoot();h=u?o.getWorkspaceFolder(u)??void 0:void 0}return h}}),define(Se[75],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(k){k.Delimiter="\0"})(n||(e.TestIdPathParts=n={}));var r;(function(k){k[k.IsSame=0]="IsSame",k[k.Disconnected=1]="Disconnected",k[k.IsChild=2]="IsChild",k[k.IsParent=3]="IsParent"})(r||(e.TestPosition=r={}));class S{static fromExtHostTestItem(R,A,v=R.parent){if(R._isRoot)return new S([A]);const s=[R.id];for(let E=v;E&&E.id!==A;E=E.parent)s.push(E.id);return s.push(A),new S(s.reverse())}static isRoot(R){return!R.includes(n.Delimiter)}static root(R){const A=R.indexOf(n.Delimiter);return A===-1?R:R.slice(0,A)}static fromString(R){return new S(R.split(n.Delimiter))}static join(R,A){return new S([...R.path,A])}static joinToString(R,A){return R.toString()+n.Delimiter+A}static parentId(R){const A=R.lastIndexOf(n.Delimiter);return A===-1?void 0:R.slice(0,A)}static localId(R){const A=R.lastIndexOf(n.Delimiter);return A===-1?R:R.slice(A+n.Delimiter.length)}static isChild(R,A){return A.startsWith(R)&&A[R.length]===n.Delimiter}static compare(R,A){return R===A?r.IsSame:S.isChild(R,A)?r.IsChild:S.isChild(A,R)?r.IsParent:r.Disconnected}static getLengthOfCommonPrefix(R,A){if(R===0)return 0;let v=0;for(;v<R-1;){for(let s=1;s<R;s++){const E=A(s-1),y=A(s);if(E.path[v]!==y.path[v])return v}v++}return v}constructor(R,A=R.length){if(this.path=R,this.d=A,R.length===0||A<1)throw new Error("cannot create test with empty path")}get rootId(){return new S(this.path,1)}get parentId(){return this.d>1?new S(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new S(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new S(this.path,R)}compare(R){if(typeof R=="string")return S.compare(this.toString(),R);for(let A=0;A<R.d&&A<this.d;A++)if(R.path[A]!==this.path[A])return r.Disconnected;return R.d>this.d?r.IsChild:R.d<this.d?r.IsParent:r.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+=n.Delimiter,this.c+=this.path[R]}return this.c}}e.$hL=S}),define(Se[104],De([1,0,4,85,50,75]),function(he,e,n,r,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$pL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$oL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$nL=e.$mL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$lL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$kL=e.$jL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$iL=e.TestResultState=void 0;var R;(function(x){x[x.Unset=0]="Unset",x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(R||(e.TestResultState=R={})),e.$iL={[R.Unset]:"unset",[R.Queued]:"queued",[R.Running]:"running",[R.Passed]:"passed",[R.Failed]:"failed",[R.Skipped]:"skipped",[R.Errored]:"errored"};var A;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var v;(function(x){x[x.Run=2]="Run",x[x.Debug=4]="Debug",x[x.Coverage=8]="Coverage",x[x.HasNonDefaultProfile=16]="HasNonDefaultProfile",x[x.HasConfigurable=32]="HasConfigurable",x[x.SupportsContinuousRun=64]="SupportsContinuousRun"})(v||(e.TestRunProfileBitset=v={})),e.$jL=[v.Run,v.Debug,v.Coverage,v.HasNonDefaultProfile,v.HasConfigurable,v.SupportsContinuousRun];const s=x=>"runId"in x;e.$kL=s;var E;(function(x){x.serialize=re=>({range:re.range.toJSON(),uri:re.uri.toJSON()}),x.deserialize=(re,q)=>({range:S.$dt.lift(q.range),uri:re.asCanonicalUri(n.URI.revive(q.uri))})})(E||(e.IRichLocation=E={}));var y;(function(x){x[x.Error=0]="Error",x[x.Output=1]="Output"})(y||(e.TestMessageType=y={}));var $;(function(x){x.serialize=re=>({message:re.message,type:y.Error,expected:re.expected,actual:re.actual,contextValue:re.contextValue,location:re.location&&E.serialize(re.location)}),x.deserialize=(re,q)=>({message:q.message,type:y.Error,expected:q.expected,actual:q.actual,contextValue:q.contextValue,location:q.location&&E.deserialize(re,q.location)})})($||(e.ITestErrorMessage=$={}));const w=(x,re)=>`${re?"s":"e"}${x}`;e.$lL=w;var a;(function(x){x.serialize=re=>({message:re.message,type:y.Output,offset:re.offset,length:re.length,location:re.location&&E.serialize(re.location)}),x.deserialize=(re,q)=>({message:q.message,type:y.Output,offset:q.offset,length:q.length,location:q.location&&E.deserialize(re,q.location)})})(a||(e.ITestOutputMessage=a={}));var f;(function(x){x.serialize=re=>re.type===y.Error?$.serialize(re):a.serialize(re),x.deserialize=(re,q)=>q.type===y.Error?$.deserialize(re,q):a.deserialize(re,q)})(f||(e.ITestMessage=f={}));var c;(function(x){x.serializeWithoutMessages=re=>({state:re.state,duration:re.duration,messages:[]}),x.serialize=re=>({state:re.state,duration:re.duration,messages:re.messages.map(f.serialize)}),x.deserialize=(re,q)=>({state:q.state,duration:q.duration,messages:q.messages.map(te=>f.deserialize(re,te))})})(c||(e.ITestTaskState=c={}));const g="\0",p=(x,re)=>x+g+re;e.$mL=p;const m=x=>{const re=x.indexOf(g);return{ctrlId:x.slice(0,re),tagId:x.slice(re+1)}};e.$nL=m;var b;(function(x){x.serialize=re=>({extId:re.extId,label:re.label,tags:re.tags,busy:re.busy,children:void 0,uri:re.uri?.toJSON(),range:re.range?.toJSON()||null,description:re.description,error:re.error,sortText:re.sortText}),x.deserialize=(re,q)=>({extId:q.extId,label:q.label,tags:q.tags,busy:q.busy,children:void 0,uri:q.uri?re.asCanonicalUri(n.URI.revive(q.uri)):void 0,range:q.range?S.$dt.lift(q.range):null,description:q.description,error:q.error,sortText:q.sortText})})(b||(e.ITestItem=b={}));var l;(function(x){x[x.NotExpandable=0]="NotExpandable",x[x.Expandable=1]="Expandable",x[x.BusyExpanding=2]="BusyExpanding",x[x.Expanded=3]="Expanded"})(l||(e.TestItemExpandState=l={}));var t;(function(x){x.serialize=re=>({expand:re.expand,item:b.serialize(re.item)}),x.deserialize=(re,q)=>({controllerId:k.$hL.root(q.item.extId),expand:q.expand,item:b.deserialize(re,q.item)})})(t||(e.InternalTestItem=t={}));var o;(function(x){x.serialize=re=>{let q;return re.item&&(q={},re.item.label!==void 0&&(q.label=re.item.label),re.item.tags!==void 0&&(q.tags=re.item.tags),re.item.busy!==void 0&&(q.busy=re.item.busy),re.item.uri!==void 0&&(q.uri=re.item.uri?.toJSON()),re.item.range!==void 0&&(q.range=re.item.range?.toJSON()),re.item.description!==void 0&&(q.description=re.item.description),re.item.error!==void 0&&(q.error=re.item.error),re.item.sortText!==void 0&&(q.sortText=re.item.sortText)),{extId:re.extId,expand:re.expand,item:q}},x.deserialize=re=>{let q;return re.item&&(q={},re.item.label!==void 0&&(q.label=re.item.label),re.item.tags!==void 0&&(q.tags=re.item.tags),re.item.busy!==void 0&&(q.busy=re.item.busy),re.item.range!==void 0&&(q.range=re.item.range?S.$dt.lift(re.item.range):null),re.item.description!==void 0&&(q.description=re.item.description),re.item.error!==void 0&&(q.error=re.item.error),re.item.sortText!==void 0&&(q.sortText=re.item.sortText)),{extId:re.extId,expand:re.expand,item:q}}})(o||(e.ITestItemUpdate=o={}));const d=(x,re)=>{re.expand!==void 0&&(x.expand=re.expand),re.item!==void 0&&(x.item=x.item?Object.assign(x.item,re.item):re.item)};e.$oL=d;var i;(function(x){x.serializeWithoutMessages=re=>({...t.serialize(re),ownComputedState:re.ownComputedState,computedState:re.computedState,tasks:re.tasks.map(c.serializeWithoutMessages)}),x.serialize=re=>({...t.serialize(re),ownComputedState:re.ownComputedState,computedState:re.computedState,tasks:re.tasks.map(c.serialize)}),x.deserialize=(re,q)=>({...t.deserialize(re,q),ownComputedState:q.ownComputedState,computedState:q.computedState,tasks:q.tasks.map(te=>c.deserialize(re,te)),retired:!0})})(i||(e.TestResultItem=i={}));var h;(function(x){x.empty=()=>({covered:0,total:0}),x.sum=(re,q)=>{re.covered+=q.covered,re.total+=q.total}})(h||(e.ICoverageCount=h={}));var u;(function(x){x.serialize=re=>({id:re.id,statement:re.statement,branch:re.branch,declaration:re.declaration,testId:re.testId?.toString(),uri:re.uri.toJSON()}),x.deserialize=(re,q)=>({id:q.id,statement:q.statement,branch:q.branch,declaration:q.declaration,testId:q.testId?k.$hL.fromString(q.testId):void 0,uri:re.asCanonicalUri(n.URI.revive(q.uri))}),x.empty=(re,q)=>({id:re,uri:q,testId:void 0,statement:h.empty()})})(u||(e.IFileCoverage=u={}));function D(x){return{...x,location:x.location?.toJSON()}}function I(x){return x.location=x.location?r.$ct.isIPosition(x.location)?r.$ct.lift(x.location):S.$dt.lift(x.location):void 0,x}e.$pL=3;var T;(function(x){x[x.Declaration=0]="Declaration",x[x.Statement=1]="Statement",x[x.Branch=2]="Branch"})(T||(e.DetailType=T={}));var O;(function(x){x.serialize=re=>re.type===T.Declaration?P.serialize(re):Q.serialize(re),x.deserialize=re=>re.type===T.Declaration?P.deserialize(re):Q.deserialize(re)})(O||(e.CoverageDetails=O={}));var C;(function(x){x.serialize=D,x.deserialize=I})(C||(e.IBranchCoverage=C={}));var P;(function(x){x.serialize=D,x.deserialize=I})(P||(e.IDeclarationCoverage=P={}));var Q;(function(x){x.serialize=re=>({...D(re),branches:re.branches?.map(C.serialize)}),x.deserialize=re=>({...I(re),branches:re.branches?.map(C.deserialize)})})(Q||(e.IStatementCoverage=Q={}));var X;(function(x){x[x.Add=0]="Add",x[x.Update=1]="Update",x[x.DocumentSynced=2]="DocumentSynced",x[x.Remove=3]="Remove",x[x.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",x[x.Retire=5]="Retire",x[x.AddTag=6]="AddTag",x[x.RemoveTag=7]="RemoveTag"})(X||(e.TestDiffOpType=X={}));var ie;(function(x){x.deserialize=(re,q)=>q.op===X.Add?{op:q.op,item:t.deserialize(re,q.item)}:q.op===X.Update?{op:q.op,item:o.deserialize(q.item)}:q.op===X.DocumentSynced?{op:q.op,uri:re.asCanonicalUri(n.URI.revive(q.uri)),docv:q.docv}:q,x.serialize=re=>re.op===X.Add?{op:re.op,item:t.serialize(re.item)}:re.op===X.Update?{op:re.op,item:o.serialize(re.item)}:re})(ie||(e.TestsDiffOp=ie={}));class ne{constructor(re){this.k=re,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(re){const q=this.w();for(const te of re)switch(te.op){case X.Add:this.l(t.deserialize(this.k,te.item),q);break;case X.Update:this.p(o.deserialize(te.item),q);break;case X.Remove:this.q(te.itemId,q);break;case X.Retire:this.v(te.itemId);break;case X.IncrementPendingExtHosts:this.updatePendingRoots(te.amount);break;case X.AddTag:this.c.set(te.tag.id,te.tag);break;case X.RemoveTag:this.c.delete(te.id);break}q.complete?.()}l(re,q){const te=k.$hL.parentId(re.item.extId)?.toString();let le;if(!te)le=this.x(re),this.g.add(le),this.f.set(re.item.extId,le);else if(this.f.has(te)){const M=this.f.get(te);M.children.add(re.item.extId),le=this.x(re,M),this.f.set(re.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(re)}`);return}return q.add?.(le),re.expand===l.BusyExpanding&&this.h++,le}p(re,q){const te=this.f.get(re.extId);if(te)return re.expand!==void 0&&(te.expand===l.BusyExpanding&&this.h--,re.expand===l.BusyExpanding&&this.h++),(0,e.$oL)(te,re),q.update?.(te),te}q(re,q){const te=this.f.get(re);if(!te)return;const le=k.$hL.parentId(te.item.extId)?.toString();le?this.f.get(le).children.delete(te.item.extId):this.g.delete(te);const M=[[re]];for(;M.length;)for(const z of M.pop()){const oe=this.f.get(z);oe&&(M.push(oe.children),this.f.delete(z),q.remove?.(oe,oe!==te),oe.expand===l.BusyExpanding&&this.h--)}}v(re){}updatePendingRoots(re){this.j+=re}w(){return{}}}e.$qL=ne}),define(Se[146],De([1,0,14,6,2,107,104,75]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.TestItemEventOp=void 0;var v;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(v||(e.TestItemEventOp=v={}));const s=(p,m)=>p===m,y=Object.entries({range:(p,m)=>p===m?!0:!p||!m?!1:p.equalsRange(m),busy:s,label:s,description:s,error:s,sortText:s,tags:(p,m)=>!(p.length!==m.length||p.some(b=>!m.includes(b)))}),$=(p,m)=>{let b;for(const[l,t]of y)t(p[l],m[l])||(b?b[l]=m[l]:b={[l]:m[l]});return b};class w extends S.$Uc{get root(){return this.s.root}constructor(m){super(),this.s=m,this.f=this.B(new n.$Mh(()=>this.flushDiff(),200)),this.g=this.B(new r.$he),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(m){this.h=m;for(const b of this.tree.values())this.J(b)}get resolveHandler(){return this.h}collectDiff(){const m=this.m;return this.m=[],m}pushDiff(m){switch(m.op){case R.TestDiffOpType.DocumentSynced:{for(const b of this.m)if(b.op===R.TestDiffOpType.DocumentSynced&&b.uri===m.uri){b.docv=m.docv;return}break}case R.TestDiffOpType.Update:{const b=this.m[this.m.length-1];if(b){if(b.op===R.TestDiffOpType.Update&&b.item.extId===m.item.extId){(0,R.$oL)(b.item,m.item);return}if(b.op===R.TestDiffOpType.Add&&b.item.item.extId===m.item.extId){(0,R.$oL)(b.item,m.item);return}}break}}this.m.push(m),this.f.isScheduled()||this.f.schedule()}expand(m,b){const l=this.tree.get(m);if(l){if((l.expandLevels===void 0||b>l.expandLevels)&&(l.expandLevels=b),l.expand===R.TestItemExpandState.Expandable){const t=this.M(l);return t.isOpen()?this.L(l,b-1):t.wait().then(()=>this.L(l,b-1))}else if(l.expand===R.TestItemExpandState.Expanded)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.L(l,b-1)):this.L(l,b-1)}}dispose(){for(const m of this.tree.values())this.s.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(m,b){switch(b.op){case v.RemoveChild:this.O(A.$hL.joinToString(m.fullId,b.id));break;case v.Upsert:this.z(b.item,m);break;case v.Bulk:for(const l of b.ops)this.w(m,l);break;case v.SetTags:this.C(b.new,b.old,m.fullId.toString());break;case v.UpdateCanResolveChildren:this.J(m);break;case v.SetProp:this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:m.fullId.toString(),item:b.update}});break;case v.DocumentSynced:this.y(m.actual.uri);break;default:(0,k.$ed)(b)}}y(m){m&&this.pushDiff({op:R.TestDiffOpType.DocumentSynced,uri:m,docv:this.s.getDocumentVersion(m)})}z(m,b){const l=A.$hL.fromExtHostTestItem(m,this.root.id,b?.actual),t=this.s.getApiFor(m);t.parent&&t.parent!==b?.actual&&this.s.getChildren(t.parent).delete(m.id);let o=this.tree.get(l.toString());if(!o){o={fullId:l,actual:m,expandLevels:b?.expandLevels?b.expandLevels-1:void 0,expand:R.TestItemExpandState.NotExpandable},m.tags.forEach(this.D,this),this.tree.set(o.fullId.toString(),o),this.G(m,b),this.pushDiff({op:R.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:o.expand,item:this.s.toITestItem(m)}}),this.I(m,o,b);return}if(o.actual===m){this.H(m,o,b);return}if(o.actual.uri?.toString()!==m.uri?.toString())return this.O(l.toString()),this.z(m,b);const d=this.s.getChildren(o.actual),i=o.actual,h=$(this.s.toITestItem(i),this.s.toITestItem(m));this.s.getApiFor(i).listener=void 0,o.actual=m,o.resolveBarrier=void 0,o.expand=R.TestItemExpandState.NotExpandable,h&&(h.hasOwnProperty("tags")&&(this.C(m.tags,i.tags,l.toString()),delete h.tags),this.w(o,{op:v.SetProp,update:h})),this.I(m,o,b);for(const[D,I]of d)this.s.getChildren(m).get(I.id)||this.O(A.$hL.joinToString(l,I.id));const u=o.expandLevels;u!==void 0&&queueMicrotask(()=>{o.expand===R.TestItemExpandState.Expandable&&(o.expandLevels=void 0,this.expand(l.toString(),u))}),this.y(o.actual.uri)}C(m,b,l){const t=new Set(b.map(o=>o.id));for(const o of m)t.delete(o.id)||this.D(o);this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:l,item:{tags:m.map(o=>(0,R.$mL)(this.s.controllerId,o.id))}}}),t.forEach(this.F,this)}D(m){const b=this.j.get(m.id);b?b.refCount++:(this.j.set(m.id,{refCount:1}),this.pushDiff({op:R.TestDiffOpType.AddTag,tag:{id:(0,R.$mL)(this.s.controllerId,m.id)}}))}F(m){const b=this.j.get(m);b&&!--b.refCount&&(this.j.delete(m),this.pushDiff({op:R.TestDiffOpType.RemoveTag,id:(0,R.$mL)(this.s.controllerId,m)}))}G(m,b){this.s.getApiFor(m).parent=b&&b.actual!==this.root?b.actual:void 0}H(m,b,l){this.G(m,l);const t=this.s.getApiFor(m);t.parent=l?.actual,t.listener=o=>this.w(b,o),this.J(b)}I(m,b,l){this.H(m,b,l);for(const[t,o]of this.s.getChildren(m))this.z(o,b)}J(m){let b;this.h?m.resolveBarrier?b=m.resolveBarrier.isOpen()?R.TestItemExpandState.Expanded:R.TestItemExpandState.BusyExpanding:b=m.actual.canResolveChildren?R.TestItemExpandState.Expandable:R.TestItemExpandState.NotExpandable:b=R.TestItemExpandState.NotExpandable,b!==m.expand&&(m.expand=b,this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:m.fullId.toString(),expand:b}}),b===R.TestItemExpandState.Expandable&&m.expandLevels!==void 0&&this.M(m))}L(m,b){if(b<0)return;const l=[];for(const[t,o]of this.s.getChildren(m.actual)){const d=this.expand(A.$hL.joinToString(m.fullId,o.id),b);(0,n.$mh)(d)&&l.push(d)}if(l.length)return Promise.all(l).then(()=>{})}M(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this.h){const o=new n.$zh;return o.open(),o}m.expand=R.TestItemExpandState.BusyExpanding,this.N(m);const b=m.resolveBarrier=new n.$zh,l=o=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,o)};let t;try{t=this.h(m.actual===this.root?void 0:m.actual)}catch(o){l(o)}return(0,n.$mh)(t)?t.catch(l).then(()=>{b.open(),this.J(m)}):(b.open(),this.J(m)),m.resolveBarrier}N(m){this.pushDiff({op:R.TestDiffOpType.Update,item:{extId:m.fullId.toString(),expand:m.expand}})}O(m){const b=this.tree.get(m);if(!b)throw new Error("attempting to remove non-existent child");this.pushDiff({op:R.TestDiffOpType.Remove,itemId:m});const l=[b];for(;l.length;){const t=l.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const o of t.actual.tags)this.F(o.id);this.tree.delete(t.fullId.toString());for(const[o,d]of this.s.getChildren(t.actual))l.push(this.tree.get(A.$hL.joinToString(t.fullId,d.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.g.fire(m)}}e.$PO=w;class a extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.$QO=a;class f extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$RO=f;class c extends Error{constructor(m,b,l){super(`TestItem with ID "${m}" is from controller "${b}" and cannot be added as a child of an item from controller "${l}".`)}}e.$SO=c;const g=(p,m,b)=>{let l=new Map;return{get size(){return l.size},forEach(t,o){for(const d of l.values())t.call(o,d,this)},[Symbol.iterator](){return l.entries()},replace(t){const o=new Map,d=new Set(l.keys()),i={op:v.Bulk,ops:[]};for(const h of t){if(!(h instanceof b))throw new f(h.id);const u=m(h).controllerId;if(u!==p.controllerId)throw new c(h.id,u,p.controllerId);if(o.has(h.id))throw new a(h.id);o.set(h.id,h),d.delete(h.id),i.ops.push({op:v.Upsert,item:h})}for(const h of d.keys())i.ops.push({op:v.RemoveChild,id:h});p.listener?.(i),l=o},add(t){if(!(t instanceof b))throw new f(t.id);l.set(t.id,t),p.listener?.({op:v.Upsert,item:t})},delete(t){l.delete(t)&&p.listener?.({op:v.RemoveChild,id:t})},get(t){return l.get(t)},toJSON(){return Array.from(l.values())}}};e.$TO=g}),define(Se[147],De([1,0,146]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=void 0;const r=new WeakMap,S=(R,A)=>{const v={controllerId:A};return r.set(R,v),v};e.$UO=S;const k=R=>{const A=r.get(R);if(!A)throw new n.$RO(R?.id||"<unknown>");return A};e.$VO=k}),define(Se[307],De([1,0,46,27,5]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=e.$iF=e.$hF=e.$gF=e.$fF=e.$eF=e.$dF=e.$cF=e.$bF=e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=void 0,e.$2E=".vscode",e.$3E="settings",e.$4E=`${e.$2E}/${e.$3E}.json`,e.$5E="vscode://schemas/settings/default",e.$6E="vscode://schemas/settings/user",e.$7E="vscode://schemas/settings/profile",e.$8E="vscode://schemas/settings/machine",e.$9E="vscode://schemas/settings/workspace",e.$0E="vscode://schemas/settings/folder",e.$$E="vscode://schemas/launch",e.$_E="vscode://schemas/tasks",e.$aF=[n.ConfigurationScope.APPLICATION],e.$bF=[n.ConfigurationScope.MACHINE,n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$cF=[n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE],e.$dF=[n.ConfigurationScope.APPLICATION,...e.$cF],e.$eF=[n.ConfigurationScope.MACHINE,n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$fF=[n.ConfigurationScope.WINDOW,n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$gF=[n.ConfigurationScope.RESOURCE,n.ConfigurationScope.LANGUAGE_OVERRIDABLE,n.ConfigurationScope.MACHINE_OVERRIDABLE],e.$hF="tasks",e.$iF="launch",e.$jF=Object.create(null),e.$jF[e.$hF]=`${e.$2E}/${e.$hF}.json`,e.$jF[e.$iF]=`${e.$2E}/${e.$iF}.json`,e.$kF=Object.create(null),e.$kF[e.$hF]=`${e.$hF}.json`,e.$lF=(0,S.$Bi)(r.$7i),e.$mF=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$nF="workbench.settings.applyToAllProfiles"}),define(Se[148],De([1,0,5]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=e.VariableKind=e.$NP=void 0,e.$NP=(0,n.$Ai)("configurationResolverService");var r;(function(k){k.Unknown="unknown",k.Env="env",k.Config="config",k.Command="command",k.Input="input",k.ExtensionInstallFolder="extensionInstallFolder",k.WorkspaceFolder="workspaceFolder",k.Cwd="cwd",k.WorkspaceFolderBasename="workspaceFolderBasename",k.UserHome="userHome",k.LineNumber="lineNumber",k.SelectedText="selectedText",k.File="file",k.FileWorkspaceFolder="fileWorkspaceFolder",k.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",k.RelativeFile="relativeFile",k.RelativeFileDirname="relativeFileDirname",k.FileDirname="fileDirname",k.FileExtname="fileExtname",k.FileBasename="fileBasename",k.FileBasenameNoExtension="fileBasenameNoExtension",k.FileDirnameBasename="fileDirnameBasename",k.ExecPath="execPath",k.ExecInstallFolder="execInstallFolder",k.PathSeparator="pathSeparator",k.PathSeparatorAlias="/"})(r||(e.VariableKind=r={}));class S extends Error{constructor(R,A){super(A),this.variable=R}}e.$OP=S}),define(Se[308],De([1,0,9,33,11,21,3,176,235,148,17]),function(he,e,n,r,S,k,R,A,v,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;class y{constructor(w,a,f,c){this.h=new Map,this.a=w,this.b=a,this.g=f,c&&(this.c=c.then(g=>this.i(g)))}i(w){if(R.$c){const a=Object.create(null);return Object.keys(w).forEach(f=>{a[f.toLowerCase()]=w[f]}),a}return w}resolveWithEnvironment(w,a,f){return this.l({env:this.i(w),userHome:void 0},a?a.uri:void 0,f)}async resolveAsync(w,a){const f={env:await this.c,userHome:await this.g};return this.l(f,w?w.uri:void 0,a)}async j(w,a,f,c){const g=k.$0n(a);R.$c&&g.windows?Object.keys(g.windows).forEach(m=>g[m]=g.windows[m]):R.$d&&g.osx?Object.keys(g.osx).forEach(m=>g[m]=g.osx[m]):R.$e&&g.linux&&Object.keys(g.linux).forEach(m=>g[m]=g.linux[m]),delete g.windows,delete g.osx,delete g.linux;const p={env:await this.c,userHome:await this.g};return this.l(p,w?w.uri:void 0,g,f,c)}async resolveAnyAsync(w,a,f){return this.j(w,a,f)}async resolveAnyMap(w,a,f){const c=new Map;return{newConfig:await this.j(w,a,f,c),resolvedVariables:c}}resolveWithInteractionReplace(w,a,f,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,a,f,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,a){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,a)}async l(w,a,f,c,g){if(S.$ag(f))return this.m(w,a,f,c,g);if(Array.isArray(f))return Promise.all(f.map(p=>this.l(w,a,p,c,g)));if(S.$cg(f)){const p=Object.create(null),m=await Promise.all(Object.keys(f).map(async b=>[await this.m(w,a,b,c,g),await this.l(w,a,f[b],c,g)]));for(const[b,l]of m)p[b]=l;return p}return f}m(w,a,f,c,g){return(0,E.$tf)(f,y.VARIABLE_REGEXP,async(p,m)=>{if(m.includes(y.VARIABLE_LHS))return p;let b=await this.o(w,p,m,a,c);return g?.set(m,b),b!==p&&S.$ag(b)&&b.match(y.VARIABLE_REGEXP)&&(b=await this.m(w,a,b,c,g)),b})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,a,f,c,g){let p;const m=f.split(":");m.length>1&&(f=m[0],p=m[1]);const b=o=>{const d=this.a.getFilePath();if(d)return(0,A.$Ow)(d);throw new s.$OP(o,(0,v.localize)(0,null,a))},l=o=>{const d=b(o);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,A.$Ow)(i)}throw new s.$OP(o,(0,v.localize)(1,null,a,n.$nc(d)))},t=o=>{if(p){const d=this.a.getFolderUri(p);if(d)return d;throw new s.$OP(o,(0,v.localize)(2,null,a,p))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new s.$OP(o,(0,v.localize)(3,null,a)):new s.$OP(o,(0,v.localize)(4,null,a))};switch(f){case"env":if(p){if(w.env){const o=w.env[R.$c?p.toLowerCase():p];if(S.$ag(o))return o}return""}throw new s.$OP(s.VariableKind.Env,(0,v.localize)(5,null,a));case"config":if(p){const o=this.a.getConfigurationValue(c,p);if(S.$jg(o))throw new s.$OP(s.VariableKind.Config,(0,v.localize)(6,null,a,p));if(S.$cg(o))throw new s.$OP(s.VariableKind.Config,(0,v.localize)(7,null,a,p));return o}throw new s.$OP(s.VariableKind.Config,(0,v.localize)(8,null,a));case"command":return this.p(s.VariableKind.Command,a,p,g,"command");case"input":return this.p(s.VariableKind.Input,a,p,g,"input");case"extensionInstallFolder":if(p){const o=await this.a.getExtension(p);if(!o)throw new s.$OP(s.VariableKind.ExtensionInstallFolder,(0,v.localize)(9,null,a,p));return this.n(o.extensionLocation)}throw new s.$OP(s.VariableKind.ExtensionInstallFolder,(0,v.localize)(10,null,a));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,A.$Ow)(this.n(t(s.VariableKind.WorkspaceFolder)));case"cwd":return c||p?(0,A.$Ow)(this.n(t(s.VariableKind.Cwd))):r.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.$Ow)(n.$nc(this.n(t(s.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new s.$OP(s.VariableKind.UserHome,(0,v.localize)(11,null,a))}case"lineNumber":{const o=this.a.getLineNumber();if(o)return o;throw new s.$OP(s.VariableKind.LineNumber,(0,v.localize)(12,null,a))}case"selectedText":{const o=this.a.getSelectedText();if(o)return o;throw new s.$OP(s.VariableKind.SelectedText,(0,v.localize)(13,null,a))}case"file":return b(s.VariableKind.File);case"fileWorkspaceFolder":return l(s.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return n.$nc(l(s.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return c||p?n.$lc(this.n(t(s.VariableKind.RelativeFile)),b(s.VariableKind.RelativeFile)):b(s.VariableKind.RelativeFile);case"relativeFileDirname":{const o=n.$mc(b(s.VariableKind.RelativeFileDirname));if(c||p){const d=n.$lc(this.n(t(s.VariableKind.RelativeFileDirname)),o);return d.length===0?".":d}return o}case"fileDirname":return n.$mc(b(s.VariableKind.FileDirname));case"fileExtname":return n.$oc(b(s.VariableKind.FileExtname));case"fileBasename":return n.$nc(b(s.VariableKind.FileBasename));case"fileBasenameNoExtension":{const o=n.$nc(b(s.VariableKind.FileBasenameNoExtension));return o.slice(0,o.length-n.$oc(o).length)}case"fileDirnameBasename":return n.$nc(n.$mc(b(s.VariableKind.FileDirnameBasename)));case"execPath":{const o=this.a.getExecPath();return o||a}case"execInstallFolder":{const o=this.a.getAppRoot();return o||a}case"pathSeparator":case"/":return n.sep;default:try{const o=p?`${f}:${p}`:f;return this.p(s.VariableKind.Unknown,a,o,g,void 0)}catch{return a}}}}p(w,a,f,c,g){if(f&&c){const p=g===void 0?c[f]:c[g+":"+f];if(typeof p=="string")return p;throw new s.$OP(w,(0,v.localize)(14,null,a))}return a}}e.$4P=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Se[309],De([1,0,5,103]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$$D=void 0,e.$_D=s,e.$aE=$,e.$bE=w,e.$$D=(0,n.$Ai)("editorGroupsService");var S;(function(a){a[a.UP=0]="UP",a[a.DOWN=1]="DOWN",a[a.LEFT=2]="LEFT",a[a.RIGHT=3]="RIGHT"})(S||(e.GroupDirection=S={}));var k;(function(a){a[a.HORIZONTAL=0]="HORIZONTAL",a[a.VERTICAL=1]="VERTICAL"})(k||(e.GroupOrientation=k={}));var R;(function(a){a[a.FIRST=0]="FIRST",a[a.LAST=1]="LAST",a[a.NEXT=2]="NEXT",a[a.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var A;(function(a){a[a.MAXIMIZE=0]="MAXIMIZE",a[a.EXPAND=1]="EXPAND",a[a.EVEN=2]="EVEN"})(A||(e.GroupsArrangement=A={}));var v;(function(a){a[a.COPY_EDITORS=0]="COPY_EDITORS",a[a.MOVE_EDITORS=1]="MOVE_EDITORS"})(v||(e.MergeGroupMode=v={}));function s(a){const f=a;return(0,r.$VF)(f?.editor)&&(0,r.$VF)(f?.replacement)}var E;(function(a){a[a.CREATION_TIME=0]="CREATION_TIME",a[a.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",a[a.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(E||(e.GroupsOrder=E={}));var y;(function(a){a[a.NEW_EDITOR=1]="NEW_EDITOR",a[a.MOVE_EDITOR=2]="MOVE_EDITOR",a[a.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function $(a){const f=a;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}function w(a){return a.getValue("workbench.editor.openSideBySideDirection")==="down"?S.DOWN:S.RIGHT}}),define(Se[149],De([1,0,5,309]),function(he,e,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fE=e.$eE=e.$dE=e.$cE=void 0,e.$gE=S,e.$cE=(0,n.$Ai)("editorService"),e.$dE=-1,e.$eE=-2,e.$fE=-3;function S(k){const R=k;return typeof k=="number"||(0,r.$aE)(R)}}),define(Se[310],De([1,0,307,90,98,97,148,103,149,13,255,305,52,145]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7P=e.$6P=void 0,e.$6P="remoteterminal";let a=class{get onPtyHostExit(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostExitEvent)}get onPtyHostStart(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostStartEvent)}get onPtyHostUnresponsive(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent)}get onPtyHostResponsive(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent)}get onPtyHostRequestResolveVariables(){return this.b.listen(w.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent)}get onProcessData(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessDataEvent)}get onProcessExit(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessExitEvent)}get onProcessReady(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessReadyEvent)}get onProcessReplay(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessReplayEvent)}get onProcessOrphanQuestion(){return this.b.listen(w.RemoteTerminalChannelEvent.OnProcessOrphanQuestion)}get onExecuteCommand(){return this.b.listen(w.RemoteTerminalChannelEvent.OnExecuteCommand)}get onDidRequestDetach(){return this.b.listen(w.RemoteTerminalChannelEvent.OnDidRequestDetach)}get onDidChangeProperty(){return this.b.listen(w.RemoteTerminalChannelEvent.OnDidChangeProperty)}constructor(c,g,p,m,b,l,t,o,d,i){this.a=c,this.b=g,this.c=p,this.d=m,this.e=b,this.f=l,this.g=t,this.h=o,this.i=d,this.j=i}restartPtyHost(){return this.b.call(w.RemoteTerminalChannelRequest.RestartPtyHost,[])}async createProcess(c,g,p,m,b,l,t,o){await this.c.whenRemoteConfigurationLoaded();const d=Object.create(null),i=p?this.d.getWorkspaceFolder(p)??void 0:void 0;let h;try{h=(await this.e.resolveAnyMap(i,{shellLaunchConfig:c,configuration:g})).resolvedVariables}catch(X){this.h.error(X)}if(h)for(const[X,ie]of h.entries())(/^config:/.test(X)||X==="selectedText"||X==="lineNumber")&&(d[X]=ie);const u=[];for(const[X,ie]of this.f.collections.entries())u.push([X,(0,k.$us)(ie.map),(0,k.$vs)(ie.descriptionMap)]);const D=await this.g.resolveAuthority(this.a),I=D.options&&D.options.extensionHostEnv,T=this.d.getWorkspace(),O=T.folders,C=p?this.d.getWorkspaceFolder(p):null,P=A.$5F.getOriginalUri(this.i.activeEditor,{supportSideBySide:A.SideBySideEditor.PRIMARY,filterByScheme:[s.Schemas.file,s.Schemas.vscodeUserData,s.Schemas.vscodeRemote]}),Q={configuration:g,resolvedVariables:d,envVariableCollections:u,shellLaunchConfig:c,workspaceId:T.id,workspaceName:this.j.getWorkspaceLabel(T),workspaceFolders:O,activeWorkspaceFolder:C,activeFileResource:P,shouldPersistTerminal:b,options:m,cols:l,rows:t,unicodeVersion:o,resolverEnv:I};return await this.b.call(w.RemoteTerminalChannelRequest.CreateProcess,Q)}requestDetachInstance(c,g){return this.b.call(w.RemoteTerminalChannelRequest.RequestDetachInstance,[c,g])}acceptDetachInstanceReply(c,g){return this.b.call(w.RemoteTerminalChannelRequest.AcceptDetachInstanceReply,[c,g])}attachToProcess(c){return this.b.call(w.RemoteTerminalChannelRequest.AttachToProcess,[c])}detachFromProcess(c,g){return this.b.call(w.RemoteTerminalChannelRequest.DetachFromProcess,[c,g])}listProcesses(){return this.b.call(w.RemoteTerminalChannelRequest.ListProcesses)}getLatency(){return this.b.call(w.RemoteTerminalChannelRequest.GetLatency)}getPerformanceMarks(){return this.b.call(w.RemoteTerminalChannelRequest.GetPerformanceMarks)}reduceConnectionGraceTime(){return this.b.call(w.RemoteTerminalChannelRequest.ReduceConnectionGraceTime)}processBinary(c,g){return this.b.call(w.RemoteTerminalChannelRequest.ProcessBinary,[c,g])}start(c){return this.b.call(w.RemoteTerminalChannelRequest.Start,[c])}input(c,g){return this.b.call(w.RemoteTerminalChannelRequest.Input,[c,g])}acknowledgeDataEvent(c,g){return this.b.call(w.RemoteTerminalChannelRequest.AcknowledgeDataEvent,[c,g])}setUnicodeVersion(c,g){return this.b.call(w.RemoteTerminalChannelRequest.SetUnicodeVersion,[c,g])}shutdown(c,g){return this.b.call(w.RemoteTerminalChannelRequest.Shutdown,[c,g])}resize(c,g,p){return this.b.call(w.RemoteTerminalChannelRequest.Resize,[c,g,p])}clearBuffer(c){return this.b.call(w.RemoteTerminalChannelRequest.ClearBuffer,[c])}getInitialCwd(c){return this.b.call(w.RemoteTerminalChannelRequest.GetInitialCwd,[c])}getCwd(c){return this.b.call(w.RemoteTerminalChannelRequest.GetCwd,[c])}orphanQuestionReply(c){return this.b.call(w.RemoteTerminalChannelRequest.OrphanQuestionReply,[c])}sendCommandResult(c,g,p){return this.b.call(w.RemoteTerminalChannelRequest.SendCommandResult,[c,g,p])}freePortKillProcess(c){return this.b.call(w.RemoteTerminalChannelRequest.FreePortKillProcess,[c])}installAutoReply(c,g){return this.b.call(w.RemoteTerminalChannelRequest.InstallAutoReply,[c,g])}uninstallAllAutoReplies(){return this.b.call(w.RemoteTerminalChannelRequest.UninstallAllAutoReplies,[])}getDefaultSystemShell(c){return this.b.call(w.RemoteTerminalChannelRequest.GetDefaultSystemShell,[c])}getProfiles(c,g,p){return this.b.call(w.RemoteTerminalChannelRequest.GetProfiles,[this.d.getWorkspace().id,c,g,p])}acceptPtyHostResolvedVariables(c,g){return this.b.call(w.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables,[c,g])}getEnvironment(){return this.b.call(w.RemoteTerminalChannelRequest.GetEnvironment)}getWslPath(c,g){return this.b.call(w.RemoteTerminalChannelRequest.GetWslPath,[c,g])}setTerminalLayoutInfo(c){const p={workspaceId:this.d.getWorkspace().id,tabs:c?c.tabs:[]};return this.b.call(w.RemoteTerminalChannelRequest.SetTerminalLayoutInfo,p)}updateTitle(c,g,p){return this.b.call(w.RemoteTerminalChannelRequest.UpdateTitle,[c,g,p])}updateIcon(c,g,p,m){return this.b.call(w.RemoteTerminalChannelRequest.UpdateIcon,[c,g,p,m])}refreshProperty(c,g){return this.b.call(w.RemoteTerminalChannelRequest.RefreshProperty,[c,g])}updateProperty(c,g,p){return this.b.call(w.RemoteTerminalChannelRequest.UpdateProperty,[c,g,p])}getTerminalLayoutInfo(){const g={workspaceId:this.d.getWorkspace().id};return this.b.call(w.RemoteTerminalChannelRequest.GetTerminalLayoutInfo,g)}reviveTerminalProcesses(c,g,p){return this.b.call(w.RemoteTerminalChannelRequest.ReviveTerminalProcesses,[c,g,p])}getRevivedPtyNewId(c){return this.b.call(w.RemoteTerminalChannelRequest.GetRevivedPtyNewId,[c])}serializeTerminalState(c){return this.b.call(w.RemoteTerminalChannelRequest.SerializeTerminalState,[c])}};e.$7P=a,e.$7P=a=Ue([Ne(2,n.$lF),Ne(3,S.$Ji),Ne(4,R.$NP),Ne(5,y.$qP),Ne(6,r.$Ll),Ne(7,$.$hs),Ne(8,v.$cE),Ne(9,E.$gw)],a)}),define(Se[311],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.ExtHostConnectionType=void 0,e.$tn=A,e.$un=v;var n;(function(E){E[E.IPC=1]="IPC",E[E.Socket=2]="Socket",E[E.MessagePort=3]="MessagePort"})(n||(e.ExtHostConnectionType=n={}));class r{constructor(y){this.pipeName=y,this.type=n.IPC}serialize(y){y[r.ENV_KEY]=this.pipeName}}e.$qn=r,r.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class S{constructor(){this.type=n.Socket}serialize(y){y[S.ENV_KEY]="1"}}e.$rn=S,S.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class k{constructor(){this.type=n.MessagePort}serialize(y){y[k.ENV_KEY]="1"}}e.$sn=k,k.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function R(E){delete E[r.ENV_KEY],delete E[S.ENV_KEY],delete E[k.ENV_KEY]}function A(E,y){R(y),E.serialize(y)}function v(E){if(E[r.ENV_KEY])return s(E,new r(E[r.ENV_KEY]));if(E[S.ENV_KEY])return s(E,new S);if(E[k.ENV_KEY])return s(E,new k);throw new Error("No connection information defined in environment!")}function s(E,y){return R(E),y}}),define(Se[312],De([1,0,15]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$6m=R,e.$7m=A;var r;(function(s){s[s.Desktop=1]="Desktop",s[s.Web=2]="Web"})(r||(e.UIKind=r={}));var S;(function(s){s[s.VersionMismatch=55]="VersionMismatch",s[s.UnexpectedError=81]="UnexpectedError"})(S||(e.ExtensionHostExitCode=S={}));var k;(function(s){s[s.Initialized=0]="Initialized",s[s.Ready=1]="Ready",s[s.Terminate=2]="Terminate"})(k||(e.MessageType=k={}));function R(s){const E=n.$Je.alloc(1);switch(s){case k.Initialized:E.writeUInt8(1,0);break;case k.Ready:E.writeUInt8(2,0);break;case k.Terminate:E.writeUInt8(3,0);break}return E}function A(s,E){if(s.byteLength!==1)return!1;switch(s.readUInt8(0)){case 1:return E===k.Initialized;case 2:return E===k.Ready;case 3:return E===k.Terminate;default:return!1}}var v;(function(s){s.Start="START_NATIVE_LOG",s.End="END_NATIVE_LOG"})(v||(e.NativeLogMarkers=v={}))}),define(Se[313],De([1,0,5,6,24,12,298,312,91,41,21,4,2,230]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hP=e.$fP=e.$eP=void 0,e.$gP=c;let a=class extends $.$Uc{constructor(p,m){super(),this.s=p,this.t=m,this.a=this.B(new r.$he),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new r.$he),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=S.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=m.createLogger(this.m,{id:s.$tp,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(m.onDidChangeLogLevel(b=>{(0,k.$9j)(b)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===k.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===S.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=S.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=S.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=S.TelemetryLevel.USAGE:!1}}instantiateLogger(p,m,b){const l=this.getTelemetryDetails(),t=new f(m,b,p,this.n,this.j,this.getBuiltInCommonProperties(p),{isUsageEnabled:l.isUsageEnabled,isErrorsEnabled:l.isErrorsEnabled}),o=this.r.get(p.identifier.value)??[];return this.r.set(p.identifier.value,[...o,t]),t.apiTelemetryLogger}$initializeTelemetryLevel(p,m,b){this.f=p,this.g=m,this.c=b??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(p){const m=Object.create(null);switch(m["common.extname"]=`${p.publisher}.${p.name}`,m["common.extversion"]=p.version,m["common.vscodemachineid"]=this.s.telemetryInfo.machineId,m["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,m["common.sqmid"]=this.s.telemetryInfo.sqmId,m["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,m["common.vscodeversion"]=this.s.version,m["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),m["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:m["common.uikind"]="web";break;case A.UIKind.Desktop:m["common.uikind"]="desktop";break;default:m["common.uikind"]="unknown"}return m["common.remotename"]=(0,v.$Om)((0,s.$zp)(this.s.remote.authority)),m}$onDidChangeTelemetryLevel(p){this.h=this.getTelemetryConfiguration(),this.f=p;const m=this.getTelemetryDetails();this.r.forEach((b,l)=>{const t=b.filter(o=>!o.isDisposed);t.length===0?this.r.delete(l):this.r.set(l,t)}),this.r.forEach(b=>{for(const l of b)l.updateTelemetryEnablements(m.isUsageEnabled,m.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(p,m){const l=this.r.get(p.value)?.filter(o=>!o.isDisposed);if(!l)return this.r.delete(p.value),!1;let t=!1;for(const o of l)o.ignoreUnhandledExtHostErrors||(o.logError(m),t=!0);return t}};e.$eP=a,e.$eP=a=Ue([Ne(0,R.$dP),Ne(1,k.$8j)],a);class f{static validateSender(p){if(typeof p!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof p.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof p.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof p.flush<"u"&&typeof p.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(p,m,b,l,t,o,d){this.g=b,this.h=l,this.i=t,this.j=o,this.a=new r.$he,this.ignoreUnhandledExtHostErrors=m?.ignoreUnhandledErrors??!1,this.b=m?.ignoreBuiltInCommonProperties??!1,this.c=m?.additionalCommonProperties,this.f=p,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(p,m){this.e&&(this.d={isUsageEnabled:p,isErrorsEnabled:m},this.a.fire(this.e))}mixInCommonPropsAndCleanData(p){let m="properties"in p?p.properties??{}:p;return m=(0,s.$Cp)(m,[]),this.c&&(m=(0,E.$ao)(m,this.c)),this.b||(m=(0,E.$ao)(m,this.j)),"properties"in p?p.properties=m:p=m,p}k(p,m){this.f&&(this.g.publisher==="vscode"?p=this.g.name+"/"+p:p=this.g.identifier.value+"/"+p,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f?.sendEventData(p,m),this.h.trace(p,m))}logUsage(p,m){this.d.isUsageEnabled&&this.k(p,m)}logError(p,m){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof p=="string")this.k(p,m);else{const b={name:p.name,message:p.message,stack:p.stack,cause:p.cause},l=(0,s.$Cp)(b,[]),t=new Error(l.message,{cause:l.cause});t.stack=l.stack,t.name=l.name,m=this.mixInCommonPropsAndCleanData(m||{}),this.i||this.f.sendErrorData(t,m),this.h.trace("exception",m)}}get apiTelemetryLogger(){if(!this.e){const p=this,m={logUsage:p.logUsage.bind(p),get isUsageEnabled(){return p.d.isUsageEnabled},get isErrorsEnabled(){return p.d.isErrorsEnabled},logError:p.logError.bind(p),dispose:p.dispose.bind(p),onDidChangeEnableStates:p.a.event.bind(p)};this.e=Object.freeze(m)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let p=this.f;this.f=void 0,Promise.resolve(p.flush()).then(p=void 0),this.e=void 0}else this.f=void 0}}e.$fP=f;function c(g){const p=Date.now()-new Date(g).getTime();return isNaN(p)?!1:p<1e3*60*60*24}e.$hP=(0,n.$Ai)("IExtHostTelemetry")}),define(Se[314],De([1,0,6,4,39,130,23,5]),function(he,e,n,r,S,k,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1G=e.ActivationKind=e.$XG=e.$WG=e.$TG=e.ExtensionHostStartup=e.$SG=e.$RG=e.$QG=e.$PG=void 0,e.$UG=$,e.$VG=w,e.$YG=g,e.$ZG=p,e.$PG=Object.freeze({identifier:new R.$Xm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:r.URI.parse("void:location"),isBuiltin:!1,targetPlatform:R.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$QG="extensions.webWorker",e.$RG=(0,A.$Ai)("extensionService");class v{constructor(l){this.dependency=l}}e.$SG=v;var s;(function(b){b[b.EagerAutoStart=1]="EagerAutoStart",b[b.EagerManualStart=2]="EagerManualStart",b[b.Lazy=3]="Lazy"})(s||(e.ExtensionHostStartup=s={}));class E{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(l,t,o){this.c=l,this.d=t.slice(0),this.e=o.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:k.$AG.createActivationEventsMap(this.d)}}set(l,t,o){if(this.c>l)throw new Error(`ExtensionHostExtensions: invalid versionId ${l} (current: ${this.c})`);const d=[],i=[],h=[],u=[],D=y(this.d),I=y(t),T=(X,ie)=>X.extensionLocation.toString()===ie.extensionLocation.toString()||X.isBuiltin===ie.isBuiltin||X.isUserBuiltin===ie.isUserBuiltin||X.isUnderDevelopment===ie.isUnderDevelopment;for(const X of this.d){const ie=I.get(X.identifier);if(!ie){d.push(X.identifier),D.delete(X.identifier);continue}if(!T(X,ie)){d.push(X.identifier),D.delete(X.identifier);continue}}for(const X of t){const ie=D.get(X.identifier);if(!ie){i.push(X);continue}if(!T(ie,X)){d.push(ie.identifier),D.delete(ie.identifier);continue}}const O=new R.$Ym(this.e),C=new R.$Ym(o);for(const X of this.e)C.has(X)||h.push(X);for(const X of o)O.has(X)||u.push(X);const P=k.$AG.createActivationEventsMap(i),Q={versionId:l,toRemove:d,toAdd:i,addActivationEvents:P,myToRemove:h,myToAdd:u};return this.delta(Q),Q}delta(l){if(this.c>=l.versionId)return null;const{toRemove:t,toAdd:o,myToRemove:d,myToAdd:i}=l,h=new R.$Ym(t),u=new R.$Ym(d);for(let D=0;D<this.d.length;D++)h.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)u.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of o)this.d.push(D);for(const D of i)this.e.push(D);return this.f=null,l}containsExtension(l){for(const t of this.e)if(R.$Xm.equals(t,l))return!0;return!1}containsActivationEvent(l){return this.f||(this.f=this.g()),this.f.has(l)}g(){const l=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const o=k.$AG.readActivationEvents(t);for(const d of o)l.add(d)}return l}}e.$TG=E;function y(b){const l=new R.$Zm;for(const t of b)l.set(t.identifier,t);return l}function $(b,l){return!0}function w(b,l){if(!$(b,l))throw new Error(`Extension '${b.identifier.value}' CANNOT use API proposal: ${l}.
Its package.json#enabledApiProposals-property declares: ${b.enabledApiProposals?.join(", ")??"[]"} but NOT ${l}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${b.identifier.value}`)}class a{constructor(l,t,o,d){this.codeLoadingTime=l,this.activateCallTime=t,this.activateResolvedTime=o,this.activationReason=d}}e.$WG=a;class f{constructor(l,t){this.description=l,this.value=t}}e.$XG=f;var c;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(c||(e.ActivationKind=c={}));function g(b){return{type:b.isBuiltin?R.ExtensionType.System:R.ExtensionType.User,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,S.$Ip)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation,targetPlatform:b.targetPlatform,validations:[],isValid:!0}}function p(b,l){return{identifier:new R.$Xm((0,S.$Gp)(b.manifest.publisher,b.manifest.name)),isBuiltin:b.type===R.ExtensionType.System,isUserBuiltin:b.type===R.ExtensionType.User&&b.isBuiltin,isUnderDevelopment:!!l,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid,targetPlatform:b.targetPlatform,publisherDisplayName:b.publisherDisplayName}}class m{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.onWillStop=n.Event.None,this.extensions=[]}activateByEvent(l){return Promise.resolve(void 0)}activateById(l,t){return Promise.resolve(void 0)}activationEventIsDone(l){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(l){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(l,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(l){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$1G=m}),define(Se[315],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[316],De([1,0,236,10,58,30,127,38,23,315,29,130]),function(he,e,n,r,S,k,R,A,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=void 0;const $=A.$ko.as(R.$lo.JSONContribution);class w{constructor(l,t,o){this.a=l,this.b=t,this.c=o}d(l,t){this.a({type:l,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(l){this.d(S.default.Error,l)}warn(l){this.d(S.default.Warning,l)}info(l){this.d(S.default.Info,l)}}e.$JG=w;class a{static a(l){const t=new v.$Ym;for(let o=0,d=l.length;o<d;o++)t.add(l[o].description.identifier);return t}static compute(l,t){if(!l||!l.length)return new a(t,[]);if(!t||!t.length)return new a([],l);const o=this.a(l),d=this.a(t),i=t.filter(u=>!o.has(u.description.identifier)),h=l.filter(u=>!d.has(u.description.identifier));return new a(i,h)}constructor(l,t){this.added=l,this.removed=t}}e.$KG=a;class f{constructor(l,t){this.name=l,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(l){if(this.a!==null)throw new Error("Handler already set!");return this.a=l,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(l){this.c=a.compute(this.b,l),this.b=l,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(l){(0,r.$1)(l)}}}e.$LG=f;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},g="vscode://schemas/vscode-extensions";e.$MG={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:v.$Wm},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(s.allApiProposals),markdownEnumDescriptions:Object.values(s.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:n.localize(42,null)},{label:"*",description:n.localize(43,null),body:"*"}]}},badges:{type:"array",description:n.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(45,null)},href:{type:"string",description:n.localize(46,null)},description:{type:"string",description:n.localize(47,null)}}}},markdown:{type:"string",description:n.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:k.$2o}},extensionPack:{description:n.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:k.$2o}},extensionKind:{description:n.localize(52,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(53,null)},{body:["workspace"],description:n.localize(54,null)},{body:["ui","workspace"],description:n.localize(55,null)},{body:["workspace","ui"],description:n.localize(56,null)},{body:[],description:n.localize(57,null)}]},capabilities:{description:n.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(61,null),n.localize(62,null),n.localize(63,null)]},description:{type:"string",markdownDescription:n.localize(64,null)}}},untrustedWorkspaces:{description:n.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(67,null),n.localize(68,null),n.localize(69,null)]},restrictedConfigurations:{description:n.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(71,null)}}}}},sponsor:{description:n.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(74,null),type:"string"},"vscode:uninstall":{description:n.localize(75,null),type:"string"}}},icon:{type:"string",description:n.localize(76,null)},l10n:{type:"string",description:n.localize(77,null)},pricing:{type:"string",markdownDescription:n.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class p{constructor(){this.a=new Map}registerExtensionPoint(l){if(this.a.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const t=new f(l.extensionPoint,l.defaultExtensionKind);return this.a.set(l.extensionPoint,t),l.activationEventsGenerator&&y.$AG.register(l.extensionPoint,l.activationEventsGenerator),e.$MG.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,$.registerSchema(g,e.$MG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$NG=p;const m={ExtensionsRegistry:"ExtensionsRegistry"};A.$ko.add(m.ExtensionsRegistry,new p),e.$OG=A.$ko.as(m.ExtensionsRegistry),$.registerSchema(g,e.$MG),$.registerSchema(E.$ok,{properties:{extensionEnabledApiProposals:{description:n.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(s.allApiProposals),markdownEnumDescriptions:Object.values(s.allApiProposals)}}]}}}})}),define(Se[317],De([1,0,6,40,2,17,233,23,5,12,314,316]),function(he,e,n,r,S,k,R,A,v,s,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4G=e.$3G=e.$2G=e.ChatMessageRole=void 0;var $;(function(f){f[f.System=0]="System",f[f.User=1]="User",f[f.Assistant=2]="Assistant"})($||(e.ChatMessageRole=$={})),e.$2G=(0,v.$Ai)("ILanguageModelsService");const w={type:"object",properties:{vendor:{type:"string",description:(0,R.localize)(0,null)}}};e.$3G=y.$OG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,R.localize)(1,null),oneOf:[w,{type:"array",items:w}]},activationEventsGenerator:(f,c)=>{for(const g of f)c.push(`onLanguageModelChat:${g.vendor}`)}});let a=class{constructor(c,g){this.e=c,this.f=g,this.a=new S.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new n.$he),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$3G.setHandler(p=>{this.c.clear();for(const b of p){if(!(0,E.$UG)(b.description,"chatProvider")){b.collector.error((0,R.localize)(2,null));continue}for(const l of r.Iterable.wrap(b.value)){if(this.c.has(l.vendor)){b.collector.error((0,R.localize)(3,null,l.vendor));continue}if((0,k.$$e)(l.vendor)){b.collector.error((0,R.localize)(4,null));continue}if(l.vendor.trim()!==l.vendor){b.collector.error((0,R.localize)(5,null));continue}this.c.add(l.vendor)}}const m=[];for(const[b,l]of this.b)this.c.has(l.metadata.vendor)||(this.b.delete(b),m.push(b));m.length>0&&this.d.fire({removed:m})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(c){return this.b.get(c)?.metadata}async selectLanguageModels(c){if(c.vendor)await this.e.activateByEvent(`onLanguageModelChat:${c.vendor}}`);else{const p=Array.from(this.c).map(m=>this.e.activateByEvent(`onLanguageModelChat:${m}`));await Promise.all(p)}const g=[];for(const[p,m]of this.b)(c.vendor===void 0||m.metadata.vendor===c.vendor)&&(c.family===void 0||m.metadata.family===c.family)&&(c.version===void 0||m.metadata.version===c.version)&&(c.identifier===void 0||m.metadata.id===c.identifier)&&(!m.metadata.targetExtensions||m.metadata.targetExtensions.some(b=>A.$Xm.equals(b,c.extension)))&&g.push(p);return this.f.trace("[LM] selected language models",c,g),g}registerLanguageModelChat(c,g){if(this.f.trace("[LM] registering language model chat",c,g.metadata),!this.c.has(g.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${g.metadata.vendor}.`);if(this.b.has(c))throw new Error(`Chat response provider with identifier ${c} is already registered.`);return this.b.set(c,g),this.d.fire({added:[{identifier:c,metadata:g.metadata}]}),(0,S.$Sc)(()=>{this.b.delete(c)&&(this.d.fire({removed:[c]}),this.f.trace("[LM] UNregistered language model chat",c,g.metadata))})}makeLanguageModelChatRequest(c,g,p,m,b,l){const t=this.b.get(c);if(!t)throw new Error(`Chat response provider with identifier ${c} is not registered.`);return t.provideChatResponse(p,g,m,b,l)}computeTokenLength(c,g,p){const m=this.b.get(c);if(!m)throw new Error(`Chat response provider with identifier ${c} is not registered.`);return m.provideTokenCount(g,p)}};e.$4G=a,e.$4G=a=Ue([Ne(0,E.$RG),Ne(1,s.$7j)],a)}),define(Se[318],De([1,0,23,237,62]),function(he,e,n,r,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=k;function k(R,A,v,s,E){const y=new n.$Zm;return R.forEach($=>{const w=y.get($.identifier);w&&E.warn((0,r.localize)(0,null,w.extensionLocation.fsPath,$.extensionLocation.fsPath)),y.set($.identifier,$)}),A.forEach($=>{const w=y.get($.identifier);if(w)if(w.isBuiltin){if(S.gte(w.version,$.version)){E.warn(`Skipping extension ${$.extensionLocation.path} in favour of the builtin extension ${w.extensionLocation.path}.`);return}$.isBuiltin=!0}else E.warn((0,r.localize)(1,null,w.extensionLocation.fsPath,$.extensionLocation.fsPath));else if($.isBuiltin){E.warn(`Skipping obsolete builtin extension ${$.extensionLocation.path}`);return}y.set($.identifier,$)}),v.forEach($=>{const w=y.get($.identifier);w&&E.warn((0,r.localize)(2,null,w.extensionLocation.fsPath,$.extensionLocation.fsPath)),y.set($.identifier,$)}),s.forEach($=>{E.info((0,r.localize)(3,null,$.extensionLocation.fsPath));const w=y.get($.identifier);w&&w.isBuiltin&&($.isBuiltin=!0),y.set($.identifier,$)}),Array.from(y.values())}}),define(Se[319],De([1,0,9,3,33,4,45,59,43,64,23,318,13]),function(he,e,n,r,S,k,R,A,v,s,E,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tQ=e.$sQ=void 0;class w{constructor(c,g,p,m,b,l,t){this.c=c,this.d=p,this.f=m,this.g=b,this.h=l,this.i=t,this.a=Promise.resolve(),this.b=Promise.resolve();const o=g.args["install-builtin-extension"];if(o){b.trace("Installing builtin extensions passed via args...");const i={isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"]};R.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=c.installExtensions([],this.j(o),i,!!g.args.force).then(()=>{R.mark("code/server/didInstallBuiltinExtensions"),b.trace("Finished installing builtin extensions")},h=>{b.error(h)})}const d=g.args["install-extension"];d&&(b.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>c.installExtensions(this.j(d),[],{isMachineScoped:!!g.args["do-not-sync"],installPreReleaseVersion:!!g.args["pre-release"],isApplicationScoped:!0},!!g.args.force)).then(()=>{b.trace("Finished installing extensions")},i=>{b.error(i)}))}j(c){return c.map(g=>/\.vsix$/i.test(g)?k.URI.file((0,n.$ic)(g)?g:(0,n.$jc)((0,S.cwd)(),g)):g)}whenExtensionsReady(){return this.b}async scanExtensions(c,g,p,m,b){R.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${c}`),await this.a;const l=m?m.filter(o=>o.scheme===$.Schemas.file).map(o=>o.fsPath):void 0;g=g??this.d.defaultProfile.extensionsResource;const t=await this.k(g,c??r.$q,p,l,b);return this.g.trace("Scanned Extensions",t),this.s(t),R.mark("code/server/didScanExtensions"),t}async scanSingleExtension(c,g,p){await this.a;const m=c.scheme===$.Schemas.file?c.fsPath:null;if(!m)return null;const b=await this.q(m,g,p??r.$q);return b?(this.s([b]),b):null}async k(c,g,p,m,b){await this.r(g,b);const[l,t,o,d]=await Promise.all([this.n(g),this.o(c,g),this.m(g,p),this.l(g,m)]);return(0,y.$pQ)(l,t,o,d,this.g)}async l(c,g){return g?(await Promise.all(g.map(p=>this.f.scanOneOrMultipleExtensions(k.URI.file((0,n.$kc)(p)),E.ExtensionType.User,{language:c})))).flat().map(p=>(0,s.$Fq)(p,!0)):[]}async m(c,g){const p=[];if(g?.length){const m=await Promise.all(g.map(b=>this.f.scanExistingExtension(b,E.ExtensionType.User,{language:c})));for(const b of m)b&&p.push((0,s.$Fq)(b,!1))}return p}async n(c){return(await this.f.scanSystemExtensions({language:c,useCache:!0})).map(p=>(0,s.$Fq)(p,!1))}async o(c,g){return(await this.f.scanUserExtensions({profileLocation:c,language:g,useCache:!0})).map(m=>(0,s.$Fq)(m,!1))}async q(c,g,p){const m=k.URI.file((0,n.$kc)(c)),b=g?E.ExtensionType.System:E.ExtensionType.User,l=await this.f.scanExistingExtension(m,b,{language:p});return l?(0,s.$Fq)(l,!1):null}async r(c,g){if(!(c===r.$a||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(m=>m.id===c)){this.g.trace(`Language Pack ${c} is already installed. Skipping language pack installation.`);return}}catch(p){this.g.error(p)}if(!g){this.g.trace(`No language pack id provided for language ${c}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${g} for language ${c} is not installed. It will be installed now.`);try{await this.c.installExtensions([g],[],{isMachineScoped:!0},!0)}catch(p){this.g.error(p)}}}s(c){const g=(o,d)=>o.replace(/file/g,"vscode-remote"),p=o=>{let d="";return d+=o.global?"g":"",d+=o.ignoreCase?"i":"",d+=o.multiline?"m":"",new RegExp(g(o.source,!0),d)},m=new class{mapDefined(o){return v.$Dj.create(o)}mapNot(o){return v.$Ij.create(o)}mapEquals(o,d){return o==="resourceScheme"&&typeof d=="string"?v.$Ej.create(o,g(d,!1)):v.$Ej.create(o,d)}mapNotEquals(o,d){return o==="resourceScheme"&&typeof d=="string"?v.$Hj.create(o,g(d,!1)):v.$Hj.create(o,d)}mapGreater(o,d){return v.$Jj.create(o,d)}mapGreaterEquals(o,d){return v.$Kj.create(o,d)}mapSmaller(o,d){return v.$Lj.create(o,d)}mapSmallerEquals(o,d){return v.$Mj.create(o,d)}mapRegex(o,d){return o==="resourceScheme"&&d?v.$Nj.create(o,p(d)):v.$Nj.create(o,d)}mapIn(o,d){return v.$Fj.create(o,d)}mapNotIn(o,d){return v.$Gj.create(o,d)}},b=o=>{if(!o||!o.when||!/resourceScheme/.test(o.when))return;const d=v.$yj.deserialize(o.when);if(!d)return;const i=d.map(m);o.when=i.serialize()},l=o=>{if(Array.isArray(o))for(const d of o)b(d);else b(o)},t=o=>{for(const d in o)l(o[d])};c.forEach(o=>{o.contributes&&(o.contributes.menus&&t(o.contributes.menus),o.contributes.keybindings&&l(o.contributes.keybindings),o.contributes.views&&t(o.contributes.views))})}}e.$sQ=w;class a{constructor(c,g){this.a=c,this.b=g}listen(c,g){throw new Error("Invalid listen")}async call(c,g,p){const m=this.b(c);switch(g){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const b=p[0],l=p[1]?k.URI.revive(m.transformIncoming(p[1])):void 0,t=Array.isArray(p[2])?p[2].map(h=>k.URI.revive(m.transformIncoming(h))):void 0,o=Array.isArray(p[3])?p[3].map(h=>k.URI.revive(m.transformIncoming(h))):void 0,d=p[4];return(await this.a.scanExtensions(b,l,t,o,d)).map(h=>(0,A.$Gn)(h,m))}case"scanSingleExtension":{const b=await this.a.scanSingleExtension(k.URI.revive(m.transformIncoming(p[0])),p[1],p[2]);return b?(0,A.$Gn)(b,m):null}}throw new Error("Invalid call")}}e.$tQ=a}),define(Se[150],De([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lw=e.$Iw=void 0,e.$Jw=S,e.$Kw=k;class n{constructor(v){this._proxyIdentifierBrand=void 0,this.sid=v,this.nid=++n.count}}e.$Iw=n,n.count=0;const r=[];function S(A){const v=new n(A);return r[v.nid]=v,v}function k(A){return r[A].sid}class R{constructor(v){this.value=v}}e.$Lw=R}),define(Se[320],De([1,0,150]),function(he,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$uM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var r;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(r||(e.TextEditorRevealType=r={}));var S;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput",f[f.ChatEditorInput=10]="ChatEditorInput",f[f.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(S||(e.TabInputKind=S={}));var k;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(k||(e.TabModelOperationKind=k={}));var R;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var A;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var v;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(v||(e.CellOutputKind=v={}));var s;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(s||(e.NotebookEditorRevealType=s={}));var E;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output",f[f.Hybrid=3]="Hybrid"})(E||(e.CandidatePortSource=E={}));class y{static mixin(c){return c._id=y.a++,c}}e.$uM=y,y.a=0;var $;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var w;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var a;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(a||(e.ExtHostTestingResource=a={})),e.$vM={MainThreadAuthentication:(0,n.$Jw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.$Jw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,n.$Jw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,n.$Jw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,n.$Jw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,n.$Jw)("MainThreadChatVariables"),MainThreadClipboard:(0,n.$Jw)("MainThreadClipboard"),MainThreadCommands:(0,n.$Jw)("MainThreadCommands"),MainThreadComments:(0,n.$Jw)("MainThreadComments"),MainThreadConfiguration:(0,n.$Jw)("MainThreadConfiguration"),MainThreadConsole:(0,n.$Jw)("MainThreadConsole"),MainThreadDebugService:(0,n.$Jw)("MainThreadDebugService"),MainThreadDecorations:(0,n.$Jw)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.$Jw)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.$Jw)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.$Jw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.$Jw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.$Jw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.$Jw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.$Jw)("MainThreadEditorTabs"),MainThreadErrors:(0,n.$Jw)("MainThreadErrors"),MainThreadTreeViews:(0,n.$Jw)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.$Jw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,n.$Jw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.$Jw)("MainThreadLanguages"),MainThreadLogger:(0,n.$Jw)("MainThreadLogger"),MainThreadMessageService:(0,n.$Jw)("MainThreadMessageService"),MainThreadOutputService:(0,n.$Jw)("MainThreadOutputService"),MainThreadProgress:(0,n.$Jw)("MainThreadProgress"),MainThreadQuickDiff:(0,n.$Jw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.$Jw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.$Jw)("MainThreadStatusBar"),MainThreadSecretState:(0,n.$Jw)("MainThreadSecretState"),MainThreadStorage:(0,n.$Jw)("MainThreadStorage"),MainThreadSpeech:(0,n.$Jw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,n.$Jw)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.$Jw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,n.$Jw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,n.$Jw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.$Jw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.$Jw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.$Jw)("MainThreadCustomEditors"),MainThreadUrls:(0,n.$Jw)("MainThreadUrls"),MainThreadUriOpeners:(0,n.$Jw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.$Jw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.$Jw)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.$Jw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,n.$Jw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,n.$Jw)("MainThreadExtensionService"),MainThreadSCM:(0,n.$Jw)("MainThreadSCM"),MainThreadSearch:(0,n.$Jw)("MainThreadSearch"),MainThreadShare:(0,n.$Jw)("MainThreadShare"),MainThreadTask:(0,n.$Jw)("MainThreadTask"),MainThreadWindow:(0,n.$Jw)("MainThreadWindow"),MainThreadLabelService:(0,n.$Jw)("MainThreadLabelService"),MainThreadNotebook:(0,n.$Jw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.$Jw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.$Jw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.$Jw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.$Jw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.$Jw)("MainThreadInteractive"),MainThreadTheming:(0,n.$Jw)("MainThreadTheming"),MainThreadTunnelService:(0,n.$Jw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,n.$Jw)("MainThreadManagedSockets"),MainThreadTimeline:(0,n.$Jw)("MainThreadTimeline"),MainThreadTesting:(0,n.$Jw)("MainThreadTesting"),MainThreadLocalization:(0,n.$Jw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,n.$Jw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,n.$Jw)("MainThreadAiEmbeddingVector")},e.$wM={ExtHostCommands:(0,n.$Jw)("ExtHostCommands"),ExtHostConfiguration:(0,n.$Jw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.$Jw)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.$Jw)("ExtHostDebugService"),ExtHostDecorations:(0,n.$Jw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.$Jw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.$Jw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.$Jw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.$Jw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.$Jw)("ExtHostEditors"),ExtHostTreeViews:(0,n.$Jw)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.$Jw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.$Jw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.$Jw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.$Jw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.$Jw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.$Jw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.$Jw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,n.$Jw)("ExtHostStatusBar"),ExtHostShare:(0,n.$Jw)("ExtHostShare"),ExtHostExtensionService:(0,n.$Jw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.$Jw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.$Jw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,n.$Jw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,n.$Jw)("ExtHostSCM"),ExtHostSearch:(0,n.$Jw)("ExtHostSearch"),ExtHostTask:(0,n.$Jw)("ExtHostTask"),ExtHostWorkspace:(0,n.$Jw)("ExtHostWorkspace"),ExtHostWindow:(0,n.$Jw)("ExtHostWindow"),ExtHostWebviews:(0,n.$Jw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.$Jw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.$Jw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.$Jw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.$Jw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.$Jw)("ExtHostEditorTabs"),ExtHostProgress:(0,n.$Jw)("ExtHostProgress"),ExtHostComments:(0,n.$Jw)("ExtHostComments"),ExtHostSecretState:(0,n.$Jw)("ExtHostSecretState"),ExtHostStorage:(0,n.$Jw)("ExtHostStorage"),ExtHostUrls:(0,n.$Jw)("ExtHostUrls"),ExtHostUriOpeners:(0,n.$Jw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.$Jw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.$Jw)("ExtHostOutputService"),ExtHostLabelService:(0,n.$Jw)("ExtHostLabelService"),ExtHostNotebook:(0,n.$Jw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.$Jw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.$Jw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.$Jw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.$Jw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,n.$Jw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,n.$Jw)("ExtHostInteractive"),ExtHostChatAgents2:(0,n.$Jw)("ExtHostChatAgents"),ExtHostChatVariables:(0,n.$Jw)("ExtHostChatVariables"),ExtHostChatProvider:(0,n.$Jw)("ExtHostChatProvider"),ExtHostSpeech:(0,n.$Jw)("ExtHostSpeech"),ExtHostEmbeddings:(0,n.$Jw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,n.$Jw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,n.$Jw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,n.$Jw)("ExtHostTheming"),ExtHostTunnelService:(0,n.$Jw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,n.$Jw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,n.$Jw)("ExtHostAuthentication"),ExtHostTimeline:(0,n.$Jw)("ExtHostTimeline"),ExtHostTesting:(0,n.$Jw)("ExtHostTesting"),ExtHostTelemetry:(0,n.$Jw)("ExtHostTelemetry"),ExtHostLocalization:(0,n.$Jw)("ExtHostLocalization")}}),define(Se[321],De([1,0,15,26,13,120,5]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=e.$9J=void 0,e.$0J=E,e.$$J=y,e.$9J=(0,R.$Ai)("notebookDocumentService");const A=["W","X","Y","Z","a","b","c","d","e","f"],v=new RegExp(`^[${A.join("")}]+`),s=7;function E(w){if(w.scheme!==S.Schemas.vscodeNotebookCell)return;const a=w.fragment.indexOf("s");if(a<0)return;const f=parseInt(w.fragment.substring(0,a).replace(v,""),s),c=(0,n.$3e)(w.fragment.substring(a+1)).toString();if(!isNaN(f))return{handle:f,notebook:w.with({scheme:c,fragment:null})}}function y(w,a){const f=a.toString(s),g=`${f.length<A.length?A[f.length-1]:"z"}${f}s${(0,n.$4e)(n.$Je.fromString(w.scheme),!0,!0)}`;return w.with({scheme:S.Schemas.vscodeNotebookCell,fragment:g})}class ${constructor(){this.a=new r.$Ac}getNotebook(a){if(a.scheme===S.Schemas.vscodeNotebookCell){const f=E(a);if(f){const c=this.a.get(f.notebook);if(c)return c}}return this.a.get(a)}addNotebookDocument(a){this.a.set(a.uri,a)}removeNotebookDocument(a){this.a.delete(a.uri)}}e.$_J=$,(0,k.$Gs)(e.$9J,$,k.InstantiationType.Delayed)}),define(Se[151],De([1,0,15,82,40,66,13,9,3,43,321]),function(he,e,n,r,S,k,R,A,v,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$qK=e.CellStatusbarAlignment=e.$pK=e.NotebookEditorPriority=e.$mK=e.$lK=e.$jK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$iK=e.$hK=e.$gK=e.$fK=e.CellKind=e.$eK=e.$dK=e.$cK=void 0,e.$kK=o,e.$nK=i,e.$oK=h,e.$rK=I,e.$sK=O,e.$cK="workbench.editor.notebook",e.$dK="workbench.editor.notebookTextDiffEditor",e.$eK="workbench.editor.interactive";var y;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(y||(e.CellKind=y={})),e.$fK=["application/json","application/javascript","text/html","image/svg+xml",k.$Zs.latex,k.$Zs.markdown,"image/png","image/jpeg",k.$Zs.text],e.$gK=[k.$Zs.latex,k.$Zs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",k.$Zs.text],e.$hK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$iK="_notAvailable";var $;(function(q){q[q.Running=1]="Running",q[q.Idle=2]="Idle"})($||(e.NotebookRunState=$={}));var w;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var a;(function(q){q[q.Unconfirmed=1]="Unconfirmed",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(a||(e.NotebookExecutionState=a={}));var f;(function(q){q[q.WithHardKernelDependency=0]="WithHardKernelDependency",q[q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",q[q.Pure=2]="Pure",q[q.Never=3]="Never"})(f||(e.NotebookRendererMatch=f={}));var c;(function(q){q.Always="always",q.Never="never",q.Optional="optional"})(c||(e.RendererMessagingSpec=c={}));var g;(function(q){q[q.ModelChange=1]="ModelChange",q[q.Move=2]="Move",q[q.ChangeCellLanguage=5]="ChangeCellLanguage",q[q.Initialize=6]="Initialize",q[q.ChangeCellMetadata=7]="ChangeCellMetadata",q[q.Output=8]="Output",q[q.OutputItem=9]="OutputItem",q[q.ChangeCellContent=10]="ChangeCellContent",q[q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",q[q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",q[q.ChangeCellMime=13]="ChangeCellMime",q[q.Unknown=100]="Unknown"})(g||(e.NotebookCellsChangeType=g={}));var p;(function(q){q[q.Handle=0]="Handle",q[q.Index=1]="Index"})(p||(e.SelectionStateType=p={}));var m;(function(q){q[q.Replace=1]="Replace",q[q.Output=2]="Output",q[q.Metadata=3]="Metadata",q[q.CellLanguage=4]="CellLanguage",q[q.DocumentMetadata=5]="DocumentMetadata",q[q.Move=6]="Move",q[q.OutputItems=7]="OutputItems",q[q.PartialMetadata=8]="PartialMetadata",q[q.PartialInternalMetadata=9]="PartialInternalMetadata"})(m||(e.CellEditType=m={}));var b;(function(q){q.scheme=R.Schemas.vscodeNotebookCell;function te(pe,W){return(0,E.$$J)(pe,W)}q.generate=te;function le(pe){return(0,E.$0J)(pe)}q.parse=le;function M(pe,W){return pe.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${W??""},${pe.scheme!==R.Schemas.file?pe.scheme:""}`})}q.generateCellOutputUri=M;function z(pe){if(pe.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const W=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(pe.fragment);if(!W)return;const ae=W[1]&&W[1]!==""?W[1]:void 0,ee=W[2];return{outputId:ae,notebook:pe.with({scheme:ee||R.Schemas.file,fragment:null})}}q.parseCellOutputUri=z;function oe(pe,W,ae){return q.generate(pe,W).with({scheme:ae})}q.generateCellPropertyUri=oe;function ce(pe,W){if(pe.scheme===W)return q.parse(pe.with({scheme:q.scheme}))}q.parseCellPropertyUri=ce})(b||(e.CellUri=b={}));const l=q=>v.$c?q.replace(/\//g,"\\"):q;class t{constructor(te=[],le=e.$fK){this.e=le,this.d=[...new Set(te)].map(M=>({pattern:M,matches:r.$uk(l(M))}))}sort(te){const le=new Map(S.Iterable.map(te,z=>[z,l(z)]));let M=[];for(const{matches:z}of this.d)for(const[oe,ce]of le)if(z(ce)){M.push(oe),le.delete(oe);break}return le.size&&(M=M.concat([...le.keys()].sort((z,oe)=>this.e.indexOf(z)-this.e.indexOf(oe)))),M}prioritize(te,le){const M=this.f(te);if(M===-1){this.d.unshift({pattern:te,matches:r.$uk(l(te))});return}const z=new Set(le.map(ce=>this.f(ce,M)));z.delete(-1);const oe=Array.from(z).sort();this.d.splice(M+1,0,...oe.map(ce=>this.d[ce]));for(let ce=oe.length-1;ce>=0;ce--)this.d.splice(oe[ce],1)}toArray(){return this.d.map(te=>te.pattern)}f(te,le=this.d.length){const M=l(te);for(let z=0;z<le;z++)if(this.d[z].matches(M))return z;return-1}}e.$jK=t;function o(q,te,le,M=(z,oe)=>z===oe){const z=[];function oe(W,ae,ee){if(ae===0&&ee.length===0)return;const H=z[z.length-1];H&&H.start+H.deleteCount===W?(H.deleteCount+=ae,H.toInsert.push(...ee)):z.push({start:W,deleteCount:ae,toInsert:ee})}let ce=0,pe=0;for(;;){if(ce===q.length){oe(ce,0,te.slice(pe));break}if(pe===te.length){oe(ce,q.length-ce,[]);break}const W=q[ce],ae=te[pe];if(M(W,ae)){ce+=1,pe+=1;continue}le(ae)?(oe(ce,1,[]),ce+=1):(oe(ce,0,[ae]),pe+=1)}return z}e.$lK=new s.$Rj("notebookEditorCursorAtBoundary","none"),e.$mK=new s.$Rj("notebookEditorCursorAtLineBoundary","none");var d;(function(q){q.default="default",q.option="option"})(d||(e.NotebookEditorPriority=d={}));function i(q){const te=q;return!!((typeof te.include=="string"||r.$vk(te.include))&&(typeof te.exclude=="string"||r.$vk(te.exclude)))}function h(q,te,le){if(Array.isArray(q.viewType)&&q.viewType.indexOf(te)>=0||q.viewType===te)return!0;if(q.filenamePattern){const M=i(q.filenamePattern)?q.filenamePattern.include:q.filenamePattern,z=i(q.filenamePattern)?q.filenamePattern.exclude:void 0;if(r.$tk(M,(0,A.$nc)(le.fsPath).toLowerCase()))return!(z&&r.$tk(z,(0,A.$nc)(le.fsPath).toLowerCase()))}return!1}e.$pK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var u;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(u||(e.CellStatusbarAlignment=u={}));class D{static create(te){return`${D.d}${te}`}static parse(te){if(te.startsWith(D.d))return te.substring(D.d.length)}}e.$qK=D,D.d="notebook/";function I(q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(q)}const T=new TextDecoder;function O(q){const te=[];let le=!1;for(const ce of q)(te.length===0||le)&&(te.push(ce),le=!0);let M=Q(te);const z=n.$Je.concat(te.map(ce=>n.$Je.wrap(ce))),oe=re(z);return M=M||oe.byteLength!==z.byteLength,{data:oe,didCompression:M}}e.$tK="\x1B[A";const C=e.$tK.split("").map(q=>q.charCodeAt(0)),P=10;function Q(q){let te=!1;return q.forEach((le,M)=>{if(M===0||le.length<e.$tK.length)return;const z=q[M-1],oe=le.subarray(0,e.$tK.length);if(oe[0]===C[0]&&oe[1]===C[1]&&oe[2]===C[2]){const ce=z.lastIndexOf(P);if(ce===-1)return;te=!0,q[M-1]=z.subarray(0,ce),q[M]=le.subarray(e.$tK.length)}}),te}function X(q){let te=q;do q=te,te=q.replace(/[^\n]\x08/gm,"");while(te.length<q.length);return q}function ie(q){for(q=q.replace(/\r+\n/gm,`
`);q.search(/\r[^$]/g)>-1;){const te=q.match(/^(.*)\r+/m)[1];let le=q.match(/\r+(.*)$/m)[1];le=le+te.slice(le.length,te.length),q=q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,le)}return q}const ne=8,x=13;function re(q){return!q.buffer.includes(ne)&&!q.buffer.includes(x)?q:n.$Je.fromString(ie(X(T.decode(q.buffer))))}});var rn=this&&this.__classPrivateFieldSet||function(he,e,n,r,S){if(r==="m")throw new TypeError("Private method is not writable");if(r==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?he!==e||!S:!e.has(he))throw new TypeError("Cannot write private member to an object whose class did not declare it");return r==="a"?S.call(he,n):S?S.value=n:e.set(he,n),n},ut=this&&this.__classPrivateFieldGet||function(he,e,n,r){if(n==="a"&&!r)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?he!==e||!r:!e.has(he))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?r:n==="a"?r.call(he):r?r.value:e.get(he)};define(Se[152],De([1,0,18,10,111,26,66,17,11,4,22,23,16,90,151]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a){"use strict";var f,c,g,p,m,b,l,t,o,d,i,h,u,D,I,T,O,C,P,Q,X,ie,ne,x,re;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$NO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$tO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$gO=e.$fO=e.$eO=e.$dO=e.$bO=e.$aO=e.$_N=e.$$N=e.TestRunProfileKind=e.TestResultState=e.$0N=e.$9N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$8N=e.NotebookVariablesRequestKind=e.$7N=e.$6N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$5N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.ColorThemeKind=e.$YN=e.$XN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$WN=e.$VN=e.DebugConsoleMode=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$PN=e.$ON=e.FileChangeType=e.$NN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$MN=e.$LN=e.$KN=e.$JN=e.InlineCompletionTriggerKind=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$wN=e.ConfigurationTarget=e.$vN=e.$uN=e.$tN=e.$sN=e.DocumentPasteTriggerKind=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$lN=e.ViewBadge=e.ProgressLocation=e.$kN=e.$jN=e.TaskScope=e.ShellQuoting=e.$iN=e.$hN=e.$gN=e.TaskPanelKind=e.TaskRevealKind=e.$fN=e.TerminalLocation=e.$eN=e.$dN=e.$cN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$bN=e.$aN=e.$_M=e.$$M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$9M=e.$8M=e.$7M=e.$6M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$5M=e.$4M=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.LanguageStatusSeverity=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.CodeActionTriggerKind=e.$RM=e.$QM=e.SymbolTag=e.SymbolKind=e.$PM=e.$OM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.DiagnosticSeverity=e.DiagnosticTag=e.$IM=e.$HM=e.FileEditType=e.$GM=e.$FM=e.$EM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$0M=yt,e.$xN=Ke,e.$cO=pi;function q(F){return Object.assign(F,{apply:function(...ue){if(ue.length===0)return Reflect.construct(F,[]);{const Pe=ue.length===1?[]:ue[1];return Reflect.construct(F,Pe,ue[0].constructor)}},call:function(...ue){if(ue.length===0)return Reflect.construct(F,[]);{const[Pe,...qe]=ue;return Reflect.construct(F,qe,Pe.constructor)}}})}var te;(function(F){F[F.Top=0]="Top",F[F.Bottom=1]="Bottom"})(te||(e.TerminalOutputAnchor=te={}));var le;(function(F){F[F.TerminalCommand=0]="TerminalCommand",F[F.Opener=1]="Opener",F[F.Command=3]="Command"})(le||(e.TerminalQuickFixType=le={}));let M=o=class{static from(...N){let ue=N;return new o(function(){if(ue){for(const Pe of ue)Pe&&typeof Pe.dispose=="function"&&Pe.dispose();ue=void 0}})}constructor(N){f.set(this,void 0),rn(this,f,N,"f")}dispose(){typeof ut(this,f,"f")=="function"&&(ut(this,f,"f").call(this),rn(this,f,void 0,"f"))}};e.$xM=M,f=new WeakMap,e.$xM=M=o=Ue([q],M);let z=d=class{static Min(...N){if(N.length===0)throw new TypeError;let ue=N[0];for(let Pe=1;Pe<N.length;Pe++){const qe=N[Pe];qe.isBefore(ue)&&(ue=qe)}return ue}static Max(...N){if(N.length===0)throw new TypeError;let ue=N[0];for(let Pe=1;Pe<N.length;Pe++){const qe=N[Pe];qe.isAfter(ue)&&(ue=qe)}return ue}static isPosition(N){if(!N)return!1;if(N instanceof d)return!0;const{line:ue,character:Pe}=N;return typeof ue=="number"&&typeof Pe=="number"}static of(N){if(N instanceof d)return N;if(this.isPosition(N))return new d(N.line,N.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(N,ue){if(N<0)throw(0,r.$7)("line must be non-negative");if(ue<0)throw(0,r.$7)("character must be non-negative");this.c=N,this.e=ue}isBefore(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<N.e}isBeforeOrEqual(N){return this.c<N.c?!0:N.c<this.c?!1:this.e<=N.e}isAfter(N){return!this.isBeforeOrEqual(N)}isAfterOrEqual(N){return!this.isBefore(N)}isEqual(N){return this.c===N.c&&this.e===N.e}compareTo(N){return this.c<N.c?-1:this.c>N.line?1:this.e<N.e?-1:this.e>N.e?1:0}translate(N,ue=0){if(N===null||ue===null)throw(0,r.$7)();let Pe;return typeof N>"u"?Pe=0:typeof N=="number"?Pe=N:(Pe=typeof N.lineDelta=="number"?N.lineDelta:0,ue=typeof N.characterDelta=="number"?N.characterDelta:0),Pe===0&&ue===0?this:new d(this.line+Pe,this.character+ue)}with(N,ue=this.character){if(N===null||ue===null)throw(0,r.$7)();let Pe;return typeof N>"u"?Pe=this.line:typeof N=="number"?Pe=N:(Pe=typeof N.line=="number"?N.line:this.line,ue=typeof N.character=="number"?N.character:this.character),Pe===this.line&&ue===this.character?this:new d(Pe,ue)}toJSON(){return{line:this.line,character:this.character}}};e.$yM=z,e.$yM=z=d=Ue([q],z);let oe=i=class{static isRange(N){return N instanceof i?!0:N?z.isPosition(N.start)&&z.isPosition(N.end):!1}static of(N){if(N instanceof i)return N;if(this.isRange(N))return new i(N.start,N.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(N,ue,Pe,qe){let Ze,st;if(typeof N=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof qe=="number"?(Ze=new z(N,ue),st=new z(Pe,qe)):z.isPosition(N)&&z.isPosition(ue)&&(Ze=z.of(N),st=z.of(ue)),!Ze||!st)throw new Error("Invalid arguments");Ze.isBefore(st)?(this.c=Ze,this.e=st):(this.c=st,this.e=Ze)}contains(N){return i.isRange(N)?this.contains(N.start)&&this.contains(N.end):z.isPosition(N)?!(z.of(N).isBefore(this.c)||this.e.isBefore(N)):!1}isEqual(N){return this.c.isEqual(N.c)&&this.e.isEqual(N.e)}intersection(N){const ue=z.Max(N.start,this.c),Pe=z.Min(N.end,this.e);if(!ue.isAfter(Pe))return new i(ue,Pe)}union(N){if(this.contains(N))return this;if(N.contains(this))return N;const ue=z.Min(N.start,this.c),Pe=z.Max(N.end,this.end);return new i(ue,Pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(N,ue=this.end){if(N===null||ue===null)throw(0,r.$7)();let Pe;return N?z.isPosition(N)?Pe=N:(Pe=N.start||this.start,ue=N.end||this.end):Pe=this.start,Pe.isEqual(this.c)&&ue.isEqual(this.end)?this:new i(Pe,ue)}toJSON(){return[this.start,this.end]}};e.$zM=oe,e.$zM=oe=i=Ue([q],oe);let ce=h=class extends oe{static isSelection(N){return N instanceof h?!0:N?oe.isRange(N)&&z.isPosition(N.anchor)&&z.isPosition(N.active)&&typeof N.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(N,ue,Pe,qe){let Ze,st;if(typeof N=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof qe=="number"?(Ze=new z(N,ue),st=new z(Pe,qe)):z.isPosition(N)&&z.isPosition(ue)&&(Ze=z.of(N),st=z.of(ue)),!Ze||!st)throw new Error("Invalid arguments");super(Ze,st),this.f=Ze,this.g=st}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$AM=ce,e.$AM=ce=h=Ue([q],ce);const pe=F=>{if(typeof F!="string"||F.length===0||!/^[0-9A-Za-z_\-]+$/.test(F))throw(0,r.$7)("connectionToken")};class W{static isResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.host=="string"&&typeof N.port=="number"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ue,Pe){if(typeof N!="string"||N.length===0)throw(0,r.$7)("host");if(typeof ue!="number"||ue===0||Math.round(ue)!==ue)throw(0,r.$7)("port");typeof Pe<"u"&&pe(Pe),this.host=N,this.port=Math.round(ue),this.connectionToken=Pe}}e.$BM=W;class ae{static isManagedResolvedAuthority(N){return N&&typeof N=="object"&&typeof N.makeConnection=="function"&&(N.connectionToken===void 0||typeof N.connectionToken=="string")}constructor(N,ue){this.makeConnection=N,this.connectionToken=ue,typeof ue<"u"&&pe(ue)}}e.$CM=ae;class ee extends Error{static NotAvailable(N,ue){return new ee(N,w.RemoteAuthorityResolverErrorCode.NotAvailable,ue)}static TemporarilyNotAvailable(N){return new ee(N,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(N,ue=w.RemoteAuthorityResolverErrorCode.Unknown,Pe){super(N),this._message=N,this._code=ue,this._detail=Pe,Object.setPrototypeOf(this,ee.prototype)}}e.$DM=ee;var H;(function(F){F[F.LF=1]="LF",F[F.CRLF=2]="CRLF"})(H||(e.EndOfLine=H={}));var L;(function(F){F[F.Replace=1]="Replace",F[F.Append=2]="Append",F[F.Prepend=3]="Prepend"})(L||(e.EnvironmentVariableMutatorType=L={}));let V=u=class{static isTextEdit(N){return N instanceof u?!0:N?oe.isRange(N)&&typeof N.newText=="string":!1}static replace(N,ue){return new u(N,ue)}static insert(N,ue){return u.replace(new oe(N,N),ue)}static delete(N){return u.replace(N,"")}static setEndOfLine(N){const ue=new u(new oe(new z(0,0),new z(0,0)),"");return ue.newEol=N,ue}get range(){return this.c}set range(N){if(N&&!oe.isRange(N))throw(0,r.$7)("range");this.c=N}get newText(){return this.e||""}set newText(N){if(N&&typeof N!="string")throw(0,r.$7)("newText");this.e=N}get newEol(){return this.f}set newEol(N){if(N&&typeof N!="number")throw(0,r.$7)("newEol");this.f=N}constructor(N,ue){this.c=N,this.e=ue}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$EM=V,e.$EM=V=u=Ue([q],V);let B=D=class{static isNotebookCellEdit(N){return N instanceof D?!0:N?cn.isNotebookRange(N)&&Array.isArray(N.newCells):!1}static replaceCells(N,ue){return new D(N,ue)}static insertCells(N,ue){return new D(new cn(N,N),ue)}static deleteCells(N){return new D(N,[])}static updateCellMetadata(N,ue){const Pe=new D(new cn(N,N),[]);return Pe.newCellMetadata=ue,Pe}static updateNotebookMetadata(N){const ue=new D(new cn(0,0),[]);return ue.newNotebookMetadata=N,ue}constructor(N,ue){this.range=N,this.newCells=ue}};e.$FM=B,e.$FM=B=D=Ue([q],B);class U{static isSnippetTextEdit(N){return N instanceof U?!0:N?oe.isRange(N.range)&&j.isSnippetString(N.snippet):!1}static replace(N,ue){return new U(N,ue)}static insert(N,ue){return U.replace(new oe(N,N),ue)}constructor(N,ue){this.range=N,this.snippet=ue}}e.$GM=U;var K;(function(F){F[F.File=1]="File",F[F.Text=2]="Text",F[F.Cell=3]="Cell",F[F.CellReplace=5]="CellReplace",F[F.Snippet=6]="Snippet"})(K||(e.FileEditType=K={}));let Z=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(N,ue,Pe,qe){this.c.push({_type:K.File,from:N,to:ue,options:Pe,metadata:qe})}createFile(N,ue,Pe){this.c.push({_type:K.File,from:void 0,to:N,options:ue,metadata:Pe})}deleteFile(N,ue,Pe){this.c.push({_type:K.File,from:N,to:void 0,options:ue,metadata:Pe})}e(N,ue,Pe){this.c.push({_type:K.Cell,metadata:Pe,uri:N,edit:{editType:a.CellEditType.DocumentMetadata,metadata:ue},notebookMetadata:ue})}f(N,ue,Pe,qe){const Ze=ue.start,st=ue.end;(Ze!==st||Pe.length>0)&&this.c.push({_type:K.CellReplace,uri:N,index:Ze,count:st-Ze,cells:Pe,metadata:qe})}g(N,ue,Pe,qe){this.c.push({_type:K.Cell,metadata:qe,uri:N,edit:{editType:a.CellEditType.Metadata,index:ue,metadata:Pe}})}replace(N,ue,Pe,qe){this.c.push({_type:K.Text,uri:N,edit:new V(ue,Pe),metadata:qe})}insert(N,ue,Pe,qe){this.replace(N,new oe(ue,ue),Pe,qe)}delete(N,ue,Pe){this.replace(N,ue,"",Pe)}has(N){return this.c.some(ue=>ue._type===K.Text&&ue.uri.toString()===N.toString())}set(N,ue){if(ue)for(const Pe of ue){if(!Pe)continue;let qe,Ze;Array.isArray(Pe)?(qe=Pe[0],Ze=Pe[1]):qe=Pe,B.isNotebookCellEdit(qe)?qe.newCellMetadata?this.g(N,qe.range.start,qe.newCellMetadata,Ze):qe.newNotebookMetadata?this.e(N,qe.newNotebookMetadata,Ze):this.f(N,qe.range,qe.newCells,Ze):U.isSnippetTextEdit(qe)?this.c.push({_type:K.Snippet,uri:N,range:qe.range,edit:qe.snippet,metadata:Ze}):this.c.push({_type:K.Text,uri:N,edit:qe,metadata:Ze})}else{for(let Pe=0;Pe<this.c.length;Pe++){const qe=this.c[Pe];switch(qe._type){case K.Text:case K.Snippet:case K.Cell:case K.CellReplace:qe.uri.toString()===N.toString()&&(this.c[Pe]=void 0);break}}(0,n.$Ib)(this.c)}}get(N){const ue=[];for(const Pe of this.c)Pe._type===K.Text&&Pe.uri.toString()===N.toString()&&ue.push(Pe.edit);return ue}entries(){const N=new k.$Ac;for(const ue of this.c)if(ue._type===K.Text){let Pe=N.get(ue.uri);Pe||(Pe=[ue.uri,[]],N.set(ue.uri,Pe)),Pe[1].push(ue.edit)}return[...N.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$HM=Z,e.$HM=Z=Ue([q],Z);let j=I=class{static isSnippetString(N){return N instanceof I?!0:N?typeof N.value=="string":!1}static c(N){return N.replace(/\$|}|\\/g,"\\$&")}constructor(N){this.e=1,this.value=N||""}appendText(N){return this.value+=I.c(N),this}appendTabstop(N=this.e++){return this.value+="$",this.value+=N,this}appendPlaceholder(N,ue=this.e++){if(typeof N=="function"){const Pe=new I;Pe.e=this.e,N(Pe),this.e=Pe.e,N=Pe.value}else N=I.c(N);return this.value+="${",this.value+=ue,this.value+=":",this.value+=N,this.value+="}",this}appendChoice(N,ue=this.e++){const Pe=N.map(qe=>qe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ue,this.value+="|",this.value+=Pe,this.value+="|}",this}appendVariable(N,ue){if(typeof ue=="function"){const Pe=new I;Pe.e=this.e,ue(Pe),this.e=Pe.e,ue=Pe.value}else typeof ue=="string"&&(ue=ue.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=N,ue&&(this.value+=":",this.value+=ue),this.value+="}",this}};e.$IM=j,e.$IM=j=I=Ue([q],j);var G;(function(F){F[F.Unnecessary=1]="Unnecessary",F[F.Deprecated=2]="Deprecated"})(G||(e.DiagnosticTag=G={}));var se;(function(F){F[F.Hint=3]="Hint",F[F.Information=2]="Information",F[F.Warning=1]="Warning",F[F.Error=0]="Error"})(se||(e.DiagnosticSeverity=se={}));let fe=T=class{static isLocation(N){return N instanceof T?!0:N?oe.isRange(N.range)&&s.URI.isUri(N.uri):!1}constructor(N,ue){if(this.uri=N,ue)if(oe.isRange(ue))this.range=oe.of(ue);else if(z.isPosition(ue))this.range=new oe(ue,ue);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$JM=fe,e.$JM=fe=T=Ue([q],fe);let Ee=class{static is(N){return N?typeof N.message=="string"&&N.location&&oe.isRange(N.location.range)&&s.URI.isUri(N.location.uri):!1}constructor(N,ue){this.location=N,this.message=ue}static isEqual(N,ue){return N===ue?!0:!N||!ue?!1:N.message===ue.message&&N.location.range.isEqual(ue.location.range)&&N.location.uri.toString()===ue.location.uri.toString()}};e.$KM=Ee,e.$KM=Ee=Ue([q],Ee);let Le=class{constructor(N,ue,Pe=se.Error){if(!oe.isRange(N))throw new TypeError("range must be set");if(!ue)throw new TypeError("message must be set");this.range=N,this.message=ue,this.severity=Pe}toJSON(){return{severity:se[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(N,ue){return N===ue?!0:!N||!ue?!1:N.message===ue.message&&N.severity===ue.severity&&N.code===ue.code&&N.severity===ue.severity&&N.source===ue.source&&N.range.isEqual(ue.range)&&(0,n.$ub)(N.tags,ue.tags)&&(0,n.$ub)(N.relatedInformation,ue.relatedInformation,Ee.isEqual)}};e.$LM=Le,e.$LM=Le=Ue([q],Le);let de=class{constructor(N,ue){if(!N)throw new Error("Illegal argument, contents must be defined");Array.isArray(N)?this.contents=N:this.contents=[N],this.range=ue}};e.$MM=de,e.$MM=de=Ue([q],de);let we=class extends de{constructor(N,ue,Pe,qe){super(N,ue),this.canIncreaseHover=Pe,this.canDecreaseHover=qe}};e.$NM=we,e.$NM=we=Ue([q],we);var Re;(function(F){F[F.Increase=0]="Increase",F[F.Decrease=1]="Decrease"})(Re||(e.HoverVerbosityAction=Re={}));var Oe;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(Oe||(e.DocumentHighlightKind=Oe={}));let me=class{constructor(N,ue=Oe.Text){this.range=N,this.kind=ue}toJSON(){return{range:this.range,kind:Oe[this.kind]}}};e.$OM=me,e.$OM=me=Ue([q],me);let Ie=class{constructor(N,ue){this.uri=N,this.highlights=ue}toJSON(){return{uri:this.uri,highlights:this.highlights.map(N=>N.toJSON())}}};e.$PM=Ie,e.$PM=Ie=Ue([q],Ie);var Ae;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(Ae||(e.SymbolKind=Ae={}));var je;(function(F){F[F.Deprecated=1]="Deprecated"})(je||(e.SymbolTag=je={}));let Be=O=class{static validate(N){if(!N.name)throw new Error("name must not be falsy")}constructor(N,ue,Pe,qe,Ze){this.name=N,this.kind=ue,this.containerName=Ze,typeof Pe=="string"&&(this.containerName=Pe),qe instanceof fe?this.location=qe:Pe instanceof oe&&(this.location=new fe(qe,Pe)),O.validate(this)}toJSON(){return{name:this.name,kind:Ae[this.kind],location:this.location,containerName:this.containerName}}};e.$QM=Be,e.$QM=Be=O=Ue([q],Be);let Je=C=class{static validate(N){if(!N.name)throw new Error("name must not be falsy");if(!N.range.contains(N.selectionRange))throw new Error("selectionRange must be contained in fullRange");N.children?.forEach(C.validate)}constructor(N,ue,Pe,qe,Ze){this.name=N,this.detail=ue,this.kind=Pe,this.range=qe,this.selectionRange=Ze,this.children=[],C.validate(this)}};e.$RM=Je,e.$RM=Je=C=Ue([q],Je);var We;(function(F){F[F.Invoke=1]="Invoke",F[F.Automatic=2]="Automatic"})(We||(e.CodeActionTriggerKind=We={}));let Qe=class{constructor(N,ue){this.title=N,this.kind=ue}};e.$SM=Qe,e.$SM=Qe=Ue([q],Qe);let He=P=class{constructor(N){this.value=N}append(N){return new P(this.value?this.value+P.c+N:N)}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+P.c)}};e.$TM=He,He.c=".",e.$TM=He=P=Ue([q],He),He.Empty=new He(""),He.QuickFix=He.Empty.append("quickfix"),He.Refactor=He.Empty.append("refactor"),He.RefactorExtract=He.Refactor.append("extract"),He.RefactorInline=He.Refactor.append("inline"),He.RefactorMove=He.Refactor.append("move"),He.RefactorRewrite=He.Refactor.append("rewrite"),He.Source=He.Empty.append("source"),He.SourceOrganizeImports=He.Source.append("organizeImports"),He.SourceFixAll=He.Source.append("fixAll"),He.Notebook=He.Empty.append("notebook");let nt=class{constructor(N,ue){if(this.range=N,this.parent=ue,ue&&!ue.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$UM=nt,e.$UM=nt=Ue([q],nt);class et{constructor(N,ue,Pe,qe,Ze,st){this.kind=N,this.name=ue,this.detail=Pe,this.uri=qe,this.range=Ze,this.selectionRange=st}}e.$VM=et;class rt{constructor(N,ue){this.fromRanges=ue,this.from=N}}e.$WM=rt;class lt{constructor(N,ue){this.fromRanges=ue,this.to=N}}e.$XM=lt;var tt;(function(F){F[F.Information=0]="Information",F[F.Warning=1]="Warning",F[F.Error=2]="Error"})(tt||(e.LanguageStatusSeverity=tt={}));let Xe=class{constructor(N,ue){this.range=N,this.command=ue}get isResolved(){return!!this.command}};e.$YM=Xe,e.$YM=Xe=Ue([q],Xe);let Ge=Q=class{static isMarkdownString(N){return N instanceof Q?!0:N&&N.appendCodeblock&&N.appendMarkdown&&N.appendText&&N.value!==void 0}constructor(N,ue=!1){c.set(this,void 0),rn(this,c,new S.$Xk(N,{supportThemeIcons:ue}),"f")}get value(){return ut(this,c,"f").value}set value(N){ut(this,c,"f").value=N}get isTrusted(){return ut(this,c,"f").isTrusted}set isTrusted(N){ut(this,c,"f").isTrusted=N}get supportThemeIcons(){return ut(this,c,"f").supportThemeIcons}set supportThemeIcons(N){ut(this,c,"f").supportThemeIcons=N}get supportHtml(){return ut(this,c,"f").supportHtml}set supportHtml(N){ut(this,c,"f").supportHtml=N}get baseUri(){return ut(this,c,"f").baseUri}set baseUri(N){ut(this,c,"f").baseUri=N}appendText(N){return ut(this,c,"f").appendText(N),this}appendMarkdown(N){return ut(this,c,"f").appendMarkdown(N),this}appendCodeblock(N,ue){return ut(this,c,"f").appendCodeblock(ue??"",N),this}};e.$ZM=Ge,c=new WeakMap,e.$ZM=Ge=Q=Ue([q],Ge);let xe=class{constructor(N,ue){this.label=N,this.documentation=ue}};e.$1M=xe,e.$1M=xe=Ue([q],xe);let ve=class{constructor(N,ue){this.label=N,this.documentation=ue,this.parameters=[]}};e.$2M=ve,e.$2M=ve=Ue([q],ve);let ge=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$3M=ge,e.$3M=ge=Ue([q],ge);var be;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(be||(e.SignatureHelpTriggerKind=be={}));var Y;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(Y||(e.InlayHintKind=Y={}));let _=class{constructor(N){this.value=N}};e.$4M=_,e.$4M=_=Ue([q],_);let ye=class{constructor(N,ue,Pe){this.position=N,this.label=ue,this.kind=Pe}};e.$5M=ye,e.$5M=ye=Ue([q],ye);var Me;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Me||(e.CompletionTriggerKind=Me={}));var Ve;(function(F){F[F.Text=0]="Text",F[F.Method=1]="Method",F[F.Function=2]="Function",F[F.Constructor=3]="Constructor",F[F.Field=4]="Field",F[F.Variable=5]="Variable",F[F.Class=6]="Class",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Unit=10]="Unit",F[F.Value=11]="Value",F[F.Enum=12]="Enum",F[F.Keyword=13]="Keyword",F[F.Snippet=14]="Snippet",F[F.Color=15]="Color",F[F.File=16]="File",F[F.Reference=17]="Reference",F[F.Folder=18]="Folder",F[F.EnumMember=19]="EnumMember",F[F.Constant=20]="Constant",F[F.Struct=21]="Struct",F[F.Event=22]="Event",F[F.Operator=23]="Operator",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue"})(Ve||(e.CompletionItemKind=Ve={}));var Ye;(function(F){F[F.Deprecated=1]="Deprecated"})(Ye||(e.CompletionItemTag=Ye={}));let _e=class{constructor(N,ue){this.label=N,this.kind=ue}toJSON(){return{label:this.label,kind:this.kind&&Ve[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$6M=_e,e.$6M=_e=Ue([q],_e);let ot=class{constructor(N=[],ue=!1){this.items=N,this.isIncomplete=ue}};e.$7M=ot,e.$7M=ot=Ue([q],ot);let ht=class{constructor(N,ue,Pe){this.insertText=N,this.range=ue,this.command=Pe}};e.$8M=ht,e.$8M=ht=Ue([q],ht);let gt=class{constructor(N){this.commands=void 0,this.suppressSuggestions=void 0,this.items=N}};e.$9M=gt,e.$9M=gt=Ue([q],gt);var Ct;(function(F){F[F.Unknown=0]="Unknown",F[F.Word=1]="Word",F[F.Line=2]="Line",F[F.Suggest=3]="Suggest"})(Ct||(e.PartialAcceptTriggerKind=Ct={}));var Ot;(function(F){F[F.Active=-1]="Active",F[F.Beside=-2]="Beside",F[F.One=1]="One",F[F.Two=2]="Two",F[F.Three=3]="Three",F[F.Four=4]="Four",F[F.Five=5]="Five",F[F.Six=6]="Six",F[F.Seven=7]="Seven",F[F.Eight=8]="Eight",F[F.Nine=9]="Nine"})(Ot||(e.ViewColumn=Ot={}));var mt;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(mt||(e.StatusBarAlignment=mt={}));function yt(F,N){return`${y.$Xm.toKey(F)}.${N}`}var pt;(function(F){F[F.Off=0]="Off",F[F.On=1]="On",F[F.Relative=2]="Relative",F[F.Interval=3]="Interval"})(pt||(e.TextEditorLineNumbersStyle=pt={}));var kt;(function(F){F[F.Manual=1]="Manual",F[F.AfterDelay=2]="AfterDelay",F[F.FocusOut=3]="FocusOut"})(kt||(e.TextDocumentSaveReason=kt={}));var Ht;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(Ht||(e.TextEditorRevealType=Ht={}));var It;(function(F){F[F.Keyboard=1]="Keyboard",F[F.Mouse=2]="Mouse",F[F.Command=3]="Command"})(It||(e.TextEditorSelectionChangeKind=It={}));var bt;(function(F){F[F.Undo=1]="Undo",F[F.Redo=2]="Redo"})(bt||(e.TextDocumentChangeReason=bt={}));var qt;(function(F){F[F.OpenOpen=0]="OpenOpen",F[F.ClosedClosed=1]="ClosedClosed",F[F.OpenClosed=2]="OpenClosed",F[F.ClosedOpen=3]="ClosedOpen"})(qt||(e.DecorationRangeBehavior=qt={})),function(F){function N(ue){switch(ue){case"keyboard":return F.Keyboard;case"mouse":return F.Mouse;case"api":return F.Command}}F.fromValue=N}(It||(e.TextEditorSelectionChangeKind=It={}));var Pt;(function(F){F[F.Other=0]="Other",F[F.Comment=1]="Comment",F[F.String=2]="String",F[F.RegEx=3]="RegEx"})(Pt||(e.SyntaxTokenType=Pt={})),function(F){function N(ue){switch(ue){case F.Other:return"other";case F.Comment:return"comment";case F.String:return"string";case F.RegEx:return"regex"}return"other"}F.toString=N}(Pt||(e.SyntaxTokenType=Pt={}));let at=class{constructor(N,ue){if(ue&&!s.URI.isUri(ue))throw(0,r.$7)("target");if(!oe.isRange(N)||N.isEmpty)throw(0,r.$7)("range");this.range=N,this.target=ue}};e.$$M=at,e.$$M=at=Ue([q],at);let ft=class{constructor(N,ue,Pe,qe){this.red=N,this.green=ue,this.blue=Pe,this.alpha=qe}};e.$_M=ft,e.$_M=ft=Ue([q],ft);let $t=class{constructor(N,ue){if(ue&&!(ue instanceof ft))throw(0,r.$7)("color");if(!oe.isRange(N)||N.isEmpty)throw(0,r.$7)("range");this.range=N,this.color=ue}};e.$aN=$t,e.$aN=$t=Ue([q],$t);let Wt=class{constructor(N){if(!N||typeof N!="string")throw(0,r.$7)("label");this.label=N}};e.$bN=Wt,e.$bN=Wt=Ue([q],Wt);var Rt;(function(F){F[F.RGB=0]="RGB",F[F.HEX=1]="HEX",F[F.HSL=2]="HSL"})(Rt||(e.ColorFormat=Rt={}));var Lt;(function(F){F[F.Error=0]="Error",F[F.Warning=1]="Warning",F[F.Information=2]="Information"})(Lt||(e.SourceControlInputBoxValidationType=Lt={}));var Vt;(function(F){F[F.Unknown=0]="Unknown",F[F.Shutdown=1]="Shutdown",F[F.Process=2]="Process",F[F.User=3]="User",F[F.Extension=4]="Extension"})(Vt||(e.TerminalExitReason=Vt={}));var Kt;(function(F){F[F.Low=0]="Low",F[F.Medium=1]="Medium",F[F.High=2]="High"})(Kt||(e.TerminalShellExecutionCommandLineConfidence=Kt={}));class Et{constructor(N,ue,Pe){if(this.startIndex=N,this.length=ue,this.tooltip=Pe,typeof N!="number"||N<0)throw(0,r.$7)("startIndex");if(typeof ue!="number"||ue<1)throw(0,r.$7)("length");if(Pe!==void 0&&typeof Pe!="string")throw(0,r.$7)("tooltip")}}e.$cN=Et;class At{constructor(N){this.uri=N}}e.$dN=At;class Ut{constructor(N){this.terminalCommand=N}}e.$eN=Ut;var Nt;(function(F){F[F.Panel=1]="Panel",F[F.Editor=2]="Editor"})(Nt||(e.TerminalLocation=Nt={}));class Qt{constructor(N){if(this.options=N,typeof N!="object")throw(0,r.$7)("options")}}e.$fN=Qt;var Zt;(function(F){F[F.Always=1]="Always",F[F.Silent=2]="Silent",F[F.Never=3]="Never"})(Zt||(e.TaskRevealKind=Zt={}));var Xt;(function(F){F[F.Shared=1]="Shared",F[F.Dedicated=2]="Dedicated",F[F.New=3]="New"})(Xt||(e.TaskPanelKind=Xt={}));let Tt=X=class{static from(N){switch(N){case"clean":return X.Clean;case"build":return X.Build;case"rebuild":return X.Rebuild;case"test":return X.Test;default:return}}constructor(N,ue){if(this.label=ue,typeof N!="string"||typeof ue!="string")throw(0,r.$7)("name");this.c=N}get id(){return this.c}};e.$gN=Tt,Tt.Clean=new X("clean","Clean"),Tt.Build=new X("build","Build"),Tt.Rebuild=new X("rebuild","Rebuild"),Tt.Test=new X("test","Test"),e.$gN=Tt=X=Ue([q],Tt);function Yt(F){let N="";for(let ue=0;ue<F.length;ue++)N+=F[ue].replace(/,/g,",,")+",";return N}let St=class{constructor(N,ue,Pe){if(typeof N!="string")throw(0,r.$7)("process");this.e=[],this.c=N,ue!==void 0&&(Array.isArray(ue)?(this.e=ue,this.f=Pe):this.f=ue)}get process(){return this.c}set process(N){if(typeof N!="string")throw(0,r.$7)("process");this.c=N}get args(){return this.e}set args(N){Array.isArray(N)||(N=[]),this.e=N}get options(){return this.f}set options(N){this.f=N}computeId(){const N=[];if(N.push("process"),this.c!==void 0&&N.push(this.c),this.e&&this.e.length>0)for(const ue of this.e)N.push(ue);return Yt(N)}};e.$hN=St,e.$hN=St=Ue([q],St);let Ft=class{constructor(N,ue,Pe){if(this.f=[],Array.isArray(ue)){if(!N)throw(0,r.$7)("command can't be undefined or null");if(typeof N!="string"&&typeof N.value!="string")throw(0,r.$7)("command");this.e=N,this.f=ue,this.g=Pe}else{if(typeof N!="string")throw(0,r.$7)("commandLine");this.c=N,this.g=ue}}get commandLine(){return this.c}set commandLine(N){if(typeof N!="string")throw(0,r.$7)("commandLine");this.c=N}get command(){return this.e?this.e:""}set command(N){if(typeof N!="string"&&typeof N.value!="string")throw(0,r.$7)("command");this.e=N}get args(){return this.f}set args(N){this.f=N||[]}get options(){return this.g}set options(N){this.g=N}computeId(){const N=[];if(N.push("shell"),this.c!==void 0&&N.push(this.c),this.e!==void 0&&N.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ue of this.f)N.push(typeof ue=="string"?ue:ue.value);return Yt(N)}};e.$iN=Ft,e.$iN=Ft=Ue([q],Ft);var wt;(function(F){F[F.Escape=1]="Escape",F[F.Strong=2]="Strong",F[F.Weak=3]="Weak"})(wt||(e.ShellQuoting=wt={}));var zt;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace"})(zt||(e.TaskScope=zt={}));class Gt{constructor(N){this.c=N}computeId(){return"customExecution"+(0,E.$Wg)()}set callback(N){this.c=N}get callback(){return this.c}}e.$jN=Gt;let Mt=ie=class{constructor(N,ue,Pe,qe,Ze,st){this.k=!1,this.l=this.definition=N;let ct;typeof ue=="string"?(this.o=this.name=ue,this.w=this.source=Pe,this.execution=qe,ct=Ze,this.k=!0):ue===zt.Global||ue===zt.Workspace?(this.target=ue,this.o=this.name=Pe,this.w=this.source=qe,this.execution=Ze,ct=st):(this.target=ue,this.o=this.name=Pe,this.w=this.source=qe,this.execution=Ze,ct=st),typeof ct=="string"?(this.r=[ct],this.t=!0):Array.isArray(ct)?(this.r=ct,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(N){this.j=N}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof St?this.l={type:ie.e,id:this.q.computeId()}:this.q instanceof Ft?this.l={type:ie.f,id:this.q.computeId()}:this.q instanceof Gt?this.l={type:ie.c,id:this.q.computeId()}:this.l={type:ie.g,id:(0,E.$Wg)()}}get definition(){return this.l}set definition(N){if(N==null)throw(0,r.$7)("Kind can't be undefined or null");this.B(),this.l=N}get scope(){return this.m}set target(N){this.B(),this.m=N}get name(){return this.o}set name(N){if(typeof N!="string")throw(0,r.$7)("name");this.B(),this.o=N}get execution(){return this.q}set execution(N){N===null&&(N=void 0),this.B(),this.q=N;const ue=this.l.type;(ie.g===ue||ie.e===ue||ie.f===ue||ie.c===ue)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(N){if(Array.isArray(N))this.B(),this.r=N,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(N){N!==!0&&N!==!1&&(N=!1),this.B(),this.u=N}get source(){return this.w}set source(N){if(typeof N!="string"||N.length===0)throw(0,r.$7)("source must be a string of length > 0");this.B(),this.w=N}get group(){return this.x}set group(N){N===null&&(N=void 0),this.B(),this.x=N}get detail(){return this.A}set detail(N){N===null&&(N=void 0),this.A=N}get presentationOptions(){return this.y}set presentationOptions(N){N==null&&(N=Object.create(null)),this.B(),this.y=N}get runOptions(){return this.z}set runOptions(N){N==null&&(N=Object.create(null)),this.B(),this.z=N}};e.$kN=Mt,Mt.c="customExecution",Mt.e="process",Mt.f="shell",Mt.g="$empty",e.$kN=Mt=ie=Ue([q],Mt);var sn;(function(F){F[F.SourceControl=1]="SourceControl",F[F.Window=10]="Window",F[F.Notification=15]="Notification"})(sn||(e.ProgressLocation=sn={}));var hn;(function(F){function N(ue){const Pe=ue;return(0,v.$eg)(Pe.value)?Pe.tooltip&&!(0,v.$ag)(Pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Pe.value),!1)}F.isViewBadge=N})(hn||(e.ViewBadge=hn={}));let fn=ne=class{static isTreeItem(N,ue){const Pe=N;if(Pe.checkboxState!==void 0){const qe=(0,v.$eg)(Pe.checkboxState)?Pe.checkboxState:(0,v.$cg)(Pe.checkboxState)&&(0,v.$eg)(Pe.checkboxState.state)?Pe.checkboxState.state:void 0,Ze=!(0,v.$eg)(Pe.checkboxState)&&(0,v.$cg)(Pe.checkboxState)?Pe.checkboxState.tooltip:void 0;if(qe===void 0||qe!==an.Checked&&qe!==an.Unchecked||Ze!==void 0&&!(0,v.$ag)(Ze))return console.log("INVALID tree item, invalid checkboxState",Pe.checkboxState),!1}if(N instanceof ne)return!0;if(Pe.label!==void 0&&!(0,v.$ag)(Pe.label)&&!Pe.label?.label)return console.log("INVALID tree item, invalid label",Pe.label),!1;if(Pe.id!==void 0&&!(0,v.$ag)(Pe.id))return console.log("INVALID tree item, invalid id",Pe.id),!1;if(Pe.iconPath!==void 0&&!(0,v.$ag)(Pe.iconPath)&&!s.URI.isUri(Pe.iconPath)&&(!Pe.iconPath||!(0,v.$ag)(Pe.iconPath.id))){const qe=Pe.iconPath;if(!qe||!(0,v.$ag)(qe.light)&&!s.URI.isUri(qe.light)&&!(0,v.$ag)(qe.dark)&&!s.URI.isUri(qe.dark))return console.log("INVALID tree item, invalid iconPath",Pe.iconPath),!1}return Pe.description!==void 0&&!(0,v.$ag)(Pe.description)&&typeof Pe.description!="boolean"?(console.log("INVALID tree item, invalid description",Pe.description),!1):Pe.resourceUri!==void 0&&!s.URI.isUri(Pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Pe.resourceUri),!1):Pe.tooltip!==void 0&&!(0,v.$ag)(Pe.tooltip)&&!(Pe.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",Pe.tooltip),!1):Pe.command!==void 0&&!Pe.command.command?(console.log("INVALID tree item, invalid command",Pe.command),!1):Pe.collapsibleState!==void 0&&Pe.collapsibleState<on.None&&Pe.collapsibleState>on.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Pe.collapsibleState),!1):Pe.contextValue!==void 0&&!(0,v.$ag)(Pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Pe.contextValue),!1):Pe.accessibilityInformation!==void 0&&!Pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Pe.accessibilityInformation),!1):!0}constructor(N,ue=on.None){this.collapsibleState=ue,s.URI.isUri(N)?this.resourceUri=N:this.label=N}};e.$lN=fn,e.$lN=fn=ne=Ue([q],fn);var on;(function(F){F[F.None=0]="None",F[F.Collapsed=1]="Collapsed",F[F.Expanded=2]="Expanded"})(on||(e.TreeItemCollapsibleState=on={}));var an;(function(F){F[F.Unchecked=0]="Unchecked",F[F.Checked=1]="Checked"})(an||(e.TreeItemCheckboxState=an={}));let ln=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(N){this.value=N}};e.$mN=ln,e.$mN=ln=Ue([q],ln);class $n extends ln{}e.$nN=$n;class pn extends $n{constructor(N){super(""),g.set(this,void 0),rn(this,g,N,"f")}asFile(){return ut(this,g,"f")}}e.$oN=pn,g=new WeakMap;class vn{constructor(N,ue,Pe,qe){this.name=N,this.uri=ue,this._itemId=Pe,this.c=qe}data(){return this.c()}}e.$pN=vn;let dn=class{constructor(N){p.add(this),m.set(this,new Map);for(const[ue,Pe]of N??[]){const qe=ut(this,m,"f").get(ut(this,p,"m",b).call(this,ue));qe?qe.push(Pe):ut(this,m,"f").set(ut(this,p,"m",b).call(this,ue),[Pe])}}get(N){return ut(this,m,"f").get(ut(this,p,"m",b).call(this,N))?.[0]}set(N,ue){ut(this,m,"f").set(ut(this,p,"m",b).call(this,N),[ue])}forEach(N,ue){for(const[Pe,qe]of ut(this,m,"f"))for(const Ze of qe)N.call(ue,Ze,Pe,this)}*[(m=new WeakMap,p=new WeakSet,Symbol.iterator)](){for(const[N,ue]of ut(this,m,"f"))for(const Pe of ue)yield[N,Pe]}};e.$qN=dn,b=function(N){return N.toLowerCase()},e.$qN=dn=Ue([q],dn);let mn=class{constructor(N,ue,Pe){this.insertText=N,this.title=ue,this.kind=Pe}};e.$rN=mn,e.$rN=mn=Ue([q],mn);var gn;(function(F){F[F.Automatic=0]="Automatic",F[F.PasteAs=1]="PasteAs"})(gn||(e.DocumentPasteTriggerKind=gn={}));class _t{constructor(N){this.value=N}append(...N){return new _t((this.value?[this.value,...N]:N).join(_t.c))}intersects(N){return this.contains(N)||N.contains(this)}contains(N){return this.value===N.value||N.value.startsWith(this.value+_t.c)}}e.$sN=_t,_t.c=".",_t.Empty=new _t("");class ke{constructor(N,ue,Pe){this.title=ue,this.insertText=N,this.kind=Pe}}e.$tN=ke;let Ce=class{constructor(N,ue){this.id=N,this.color=ue}static isThemeIcon(N){return typeof N.id!="string"?(console.log("INVALID ThemeIcon, invalid id",N.id),!1):!0}};e.$uN=Ce,e.$uN=Ce=Ue([q],Ce),Ce.File=new Ce("file"),Ce.Folder=new Ce("folder");let $e=class{constructor(N){this.id=N}};e.$vN=$e,e.$vN=$e=Ue([q],$e);var J;(function(F){F[F.Global=1]="Global",F[F.Workspace=2]="Workspace",F[F.WorkspaceFolder=3]="WorkspaceFolder"})(J||(e.ConfigurationTarget=J={}));let Te=class{get base(){return this.c}set base(N){this.c=N,this.e=s.URI.file(N)}get baseUri(){return this.e}set baseUri(N){this.e=N,this.c=N.fsPath}constructor(N,ue){if(typeof N!="string"&&(!N||!s.URI.isUri(N)&&!s.URI.isUri(N.uri)))throw(0,r.$7)("base");if(typeof ue!="string")throw(0,r.$7)("pattern");typeof N=="string"?this.baseUri=s.URI.file(N):s.URI.isUri(N)?this.baseUri=N:this.baseUri=N.uri,this.pattern=ue}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wN=Te,e.$wN=Te=Ue([q],Te);const Fe=new WeakMap;function Ke(F,N){Fe.set(F,N)}let ze=class{constructor(N,ue,Pe,qe,Ze){this.enabled=typeof N=="boolean"?N:!0,typeof ue=="string"&&(this.condition=ue),typeof Pe=="string"&&(this.hitCondition=Pe),typeof qe=="string"&&(this.logMessage=qe),typeof Ze=="string"&&(this.mode=Ze)}get id(){return this.c||(this.c=Fe.get(this)??(0,E.$Wg)()),this.c}};e.$yN=ze,e.$yN=ze=Ue([q],ze);let it=class extends ze{constructor(N,ue,Pe,qe,Ze,st){if(super(ue,Pe,qe,Ze,st),N===null)throw(0,r.$7)("location");this.location=N}};e.$zN=it,e.$zN=it=Ue([q],it);let dt=class extends ze{constructor(N,ue,Pe,qe,Ze,st){super(ue,Pe,qe,Ze,st),this.functionName=N}};e.$AN=dt,e.$AN=dt=Ue([q],dt);let jt=class extends ze{constructor(N,ue,Pe,qe,Ze,st,ct,Dt){if(super(qe,Ze,st,ct,Dt),!ue)throw(0,r.$7)("dataId");this.label=N,this.dataId=ue,this.canPersist=Pe}};e.$BN=jt,e.$BN=jt=Ue([q],jt);let Jt=class{constructor(N,ue,Pe){this.command=N,this.args=ue||[],this.options=Pe}};e.$CN=Jt,e.$CN=Jt=Ue([q],Jt);let vt=class{constructor(N,ue){this.port=N,this.host=ue}};e.$DN=vt,e.$DN=vt=Ue([q],vt);let Bt=class{constructor(N){this.path=N}};e.$EN=Bt,e.$EN=Bt=Ue([q],Bt);let Pn=class{constructor(N){this.implementation=N}};e.$FN=Pn,e.$FN=Pn=Ue([q],Pn);class Li{constructor(N,ue,Pe){this.session=N,this.threadId=ue,this.frameId=Pe}}e.$GN=Li;class Ni{constructor(N,ue){this.session=N,this.threadId=ue}}e.$HN=Ni;let Rn=class{constructor(N,ue){this.range=N,this.expression=ue}};e.$IN=Rn,e.$IN=Rn=Ue([q],Rn);var Wn;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Wn||(e.InlineCompletionTriggerKind=Wn={}));let An=class{constructor(N,ue){this.range=N,this.text=ue}};e.$JN=An,e.$JN=An=Ue([q],An);let Tn=class{constructor(N,ue,Pe=!0){this.range=N,this.variableName=ue,this.caseSensitiveLookup=Pe}};e.$KN=Tn,e.$KN=Tn=Ue([q],Tn);let Cn=class{constructor(N,ue){this.range=N,this.expression=ue}};e.$LN=Cn,e.$LN=Cn=Ue([q],Cn);let On=class{constructor(N,ue){this.frameId=N,this.stoppedLocation=ue}};e.$MN=On,e.$MN=On=Ue([q],On);var Vn;(function(F){F[F.AIGenerated=1]="AIGenerated"})(Vn||(e.NewSymbolNameTag=Vn={}));var Gn;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Gn||(e.NewSymbolNameTriggerKind=Gn={}));class Fi{constructor(N,ue){this.newSymbolName=N,this.tags=ue}}e.$NN=Fi;var Jn;(function(F){F[F.Changed=1]="Changed",F[F.Created=2]="Created",F[F.Deleted=3]="Deleted"})(Jn||(e.FileChangeType=Jn={}));let Ln=x=class extends Error{static FileExists(N){return new x(N,$.FileSystemProviderErrorCode.FileExists,x.FileExists)}static FileNotFound(N){return new x(N,$.FileSystemProviderErrorCode.FileNotFound,x.FileNotFound)}static FileNotADirectory(N){return new x(N,$.FileSystemProviderErrorCode.FileNotADirectory,x.FileNotADirectory)}static FileIsADirectory(N){return new x(N,$.FileSystemProviderErrorCode.FileIsADirectory,x.FileIsADirectory)}static NoPermissions(N){return new x(N,$.FileSystemProviderErrorCode.NoPermissions,x.NoPermissions)}static Unavailable(N){return new x(N,$.FileSystemProviderErrorCode.Unavailable,x.Unavailable)}constructor(N,ue=$.FileSystemProviderErrorCode.Unknown,Pe){super(s.URI.isUri(N)?N.toString(!0):N),this.code=Pe?.name??"Unknown",(0,$.$jl)(this,ue),Object.setPrototypeOf(this,x.prototype),typeof Error.captureStackTrace=="function"&&typeof Pe=="function"&&Error.captureStackTrace(this,Pe)}};e.$ON=Ln,e.$ON=Ln=x=Ue([q],Ln);let Nn=class{constructor(N,ue,Pe){this.start=N,this.end=ue,this.kind=Pe}};e.$PN=Nn,e.$PN=Nn=Ue([q],Nn);var Kn;(function(F){F[F.Comment=1]="Comment",F[F.Imports=2]="Imports",F[F.Region=3]="Region"})(Kn||(e.FoldingRangeKind=Kn={}));var Qn;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(Qn||(e.CommentThreadCollapsibleState=Qn={}));var Zn;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(Zn||(e.CommentMode=Zn={}));var Xn;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(Xn||(e.CommentState=Xn={}));var Yn;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(Yn||(e.CommentThreadState=Yn={}));var xn;(function(F){F[F.Current=0]="Current",F[F.Outdated=1]="Outdated"})(xn||(e.CommentThreadApplicability=xn={}));class Mi{constructor(N,ue=[]){this.tokenTypes=N,this.tokenModifiers=ue}}e.$QN=Mi;function ji(F){return typeof F>"u"||(0,v.$bg)(F)}class Fn{constructor(N){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,N){this.m=!0;for(let ue=0,Pe=N.tokenTypes.length;ue<Pe;ue++)this.k.set(N.tokenTypes[ue],ue);for(let ue=0,Pe=N.tokenModifiers.length;ue<Pe;ue++)this.l.set(N.tokenModifiers[ue],ue)}}push(N,ue,Pe,qe,Ze){if(typeof N=="number"&&typeof ue=="number"&&typeof Pe=="number"&&typeof qe=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.q(N,ue,Pe,qe,Ze);if(oe.isRange(N)&&typeof ue=="string"&&ji(Pe))return this.o(N,ue,Pe);throw(0,r.$7)()}o(N,ue,Pe){if(!this.m)throw new Error("Legend must be provided in constructor");if(N.start.line!==N.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ue))throw new Error("`tokenType` is not in the provided legend");const qe=N.start.line,Ze=N.start.character,st=N.end.character-N.start.character,ct=this.k.get(ue);let Dt=0;if(Pe)for(const xt of Pe){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const en=this.l.get(xt);Dt|=1<<en>>>0}this.q(qe,Ze,st,ct,Dt)}q(N,ue,Pe,qe,Ze){if(this.f&&(N<this.c||N===this.c&&ue<this.e)){this.f=!1;const Dt=this.g.length/5|0;let xt=0,en=0;for(let tn=0;tn<Dt;tn++){let nn=this.g[5*tn],bn=this.g[5*tn+1];nn===0?(nn=xt,bn+=en):nn+=xt,this.g[5*tn]=nn,this.g[5*tn+1]=bn,xt=nn,en=bn}}let st=N,ct=ue;this.f&&this.j>0&&(st-=this.c,st===0&&(ct-=this.e)),this.g[this.j++]=st,this.g[this.j++]=ct,this.g[this.j++]=Pe,this.g[this.j++]=qe,this.g[this.j++]=Ze,this.c=N,this.e=ue}static r(N){const ue=[],Pe=N.length/5|0;for(let ct=0;ct<Pe;ct++)ue[ct]=ct;ue.sort((ct,Dt)=>{const xt=N[5*ct],en=N[5*Dt];if(xt===en){const tn=N[5*ct+1],nn=N[5*Dt+1];return tn-nn}return xt-en});const qe=new Uint32Array(N.length);let Ze=0,st=0;for(let ct=0;ct<Pe;ct++){const Dt=5*ue[ct],xt=N[Dt+0],en=N[Dt+1],tn=N[Dt+2],nn=N[Dt+3],bn=N[Dt+4],Oi=xt-Ze,Rr=Oi===0?en-st:en,wn=5*ct;qe[wn+0]=Oi,qe[wn+1]=Rr,qe[wn+2]=tn,qe[wn+3]=nn,qe[wn+4]=bn,Ze=xt,st=en}return qe}build(N){return this.f?new Mn(new Uint32Array(this.g),N):new Mn(Fn.r(this.g),N)}}e.$RN=Fn;class Mn{constructor(N,ue){this.resultId=ue,this.data=N}}e.$SN=Mn;class Ui{constructor(N,ue,Pe){this.start=N,this.deleteCount=ue,this.data=Pe}}e.$TN=Ui;class zi{constructor(N,ue){this.resultId=ue,this.edits=N}}e.$UN=zi;var _n;(function(F){F[F.Separate=0]="Separate",F[F.MergeWithParent=1]="MergeWithParent"})(_n||(e.DebugConsoleMode=_n={}));class Bi{constructor(N){this.name=N}}e.$VN=Bi;let yn=class{constructor(){}};e.$WN=yn,yn.Back={iconPath:new Ce("arrow-left")},e.$WN=yn=Ue([q],yn);var ei;(function(F){F[F.Separator=-1]="Separator",F[F.Default=0]="Default"})(ei||(e.QuickPickItemKind=ei={}));var ti;(function(F){F[F.Info=1]="Info",F[F.Warning=2]="Warning",F[F.Error=3]="Error"})(ti||(e.InputBoxValidationSeverity=ti={}));var ni;(function(F){F[F.UI=1]="UI",F[F.Workspace=2]="Workspace"})(ni||(e.ExtensionKind=ni={}));class Hi{static validate(N){if(typeof N.badge=="string"){let ue=(0,A.$Lf)(N.badge,0);if(ue<N.badge.length&&(ue+=(0,A.$Lf)(N.badge,ue)),N.badge.length>ue)throw new Error("The 'badge'-property must be undefined or a short character")}else if(N.badge&&!Ce.isThemeIcon(N.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!N.color&&!N.badge&&!N.tooltip)throw new Error("The decoration is empty");return!0}constructor(N,ue,Pe){this.badge=N,this.tooltip=ue,this.color=Pe}}e.$XN=Hi;let jn=class{constructor(N){this.kind=N}};e.$YN=jn,e.$YN=jn=Ue([q],jn);var ii;(function(F){F[F.Light=1]="Light",F[F.Dark=2]="Dark",F[F.HighContrast=3]="HighContrast",F[F.HighContrastLight=4]="HighContrastLight"})(ii||(e.ColorThemeKind=ii={}));class cn{static isNotebookRange(N){return N instanceof cn?!0:N?typeof N.start=="number"&&typeof N.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(N,ue){if(N<0)throw(0,r.$7)("start must be positive");if(ue<0)throw(0,r.$7)("end must be positive");N<=ue?(this.c=N,this.e=ue):(this.c=ue,this.e=N)}with(N){let ue=this.c,Pe=this.e;return N.start!==void 0&&(ue=N.start),N.end!==void 0&&(Pe=N.end),ue===this.c&&Pe===this.e?this:new cn(ue,Pe)}}e.$ZN=cn;class En{static validate(N){if(typeof N.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof N.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof N.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(N){return Array.isArray(N)&&N.every(ue=>En.isNotebookCellData(ue))}static isNotebookCellData(N){return!0}constructor(N,ue,Pe,qe,Ze,st,ct){this.kind=N,this.value=ue,this.languageId=Pe,this.mime=qe,this.outputs=Ze??[],this.metadata=st,this.executionSummary=ct,En.validate(this)}}e.$1N=En;class qi{constructor(N){this.cells=N}}e.$2N=qi;class ri{static isNotebookCellOutputItem(N){return N instanceof l?!0:N?typeof N.mime=="string"&&N.data instanceof Uint8Array:!1}static error(N){const ue={name:N.name,message:N.message,stack:N.stack};return l.json(ue,"application/vnd.code.notebook.error")}static stdout(N){return l.text(N,"application/vnd.code.notebook.stdout")}static stderr(N){return l.text(N,"application/vnd.code.notebook.stderr")}static bytes(N,ue="application/octet-stream"){return new l(N,ue)}static text(N,ue=R.$Zs.text){const Pe=ut(l,l,"f",t).encode(String(N));return new l(Pe,ue)}static json(N,ue="text/x-json"){const Pe=JSON.stringify(N,void 0,"	");return l.text(Pe,ue)}constructor(N,ue){this.data=N,this.mime=ue;const Pe=(0,R.$4s)(ue,!0);if(!Pe)throw new Error(`INVALID mime type: ${ue}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Pe}}e.$3N=ri,l=ri,t={value:new TextEncoder};class Sn{static isNotebookCellOutput(N){return N instanceof Sn?!0:!N||typeof N!="object"?!1:typeof N.id=="string"&&Array.isArray(N.items)}static ensureUniqueMimeTypes(N,ue=!1){const Pe=new Set,qe=new Set;for(let Ze=0;Ze<N.length;Ze++){const st=N[Ze],ct=(0,R.$4s)(st.mime);if(!Pe.has(ct)||(0,a.$rK)(ct)){Pe.add(ct);continue}qe.add(Ze),ue&&console.warn(`DUPLICATED mime type '${st.mime}' will be dropped`)}return qe.size===0?N:N.filter((Ze,st)=>!qe.has(st))}constructor(N,ue,Pe){this.items=Sn.ensureUniqueMimeTypes(N,!0),typeof ue=="string"?(this.id=ue,this.metadata=Pe):(this.id=(0,E.$Wg)(),this.metadata=ue??Pe)}}e.$4N=Sn;var si;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(si||(e.NotebookCellKind=si={}));var oi;(function(F){F[F.Idle=1]="Idle",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(oi||(e.NotebookCellExecutionState=oi={}));var ai;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(ai||(e.NotebookCellStatusBarAlignment=ai={}));var li;(function(F){F[F.Default=0]="Default",F[F.InCenter=1]="InCenter",F[F.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",F[F.AtTop=3]="AtTop"})(li||(e.NotebookEditorRevealType=li={}));class Wi{constructor(N,ue){this.text=N,this.alignment=ue}}e.$5N=Wi;var ci;(function(F){F[F.Default=1]="Default",F[F.Preferred=2]="Preferred"})(ci||(e.NotebookControllerAffinity=ci={}));var ui;(function(F){F[F.Default=1]="Default",F[F.Preferred=2]="Preferred",F[F.Hidden=-1]="Hidden"})(ui||(e.NotebookControllerAffinity2=ui={}));class Vi{constructor(N,ue=[]){this.uri=N,this.provides=(0,n.$2b)(ue)}}e.$6N=Vi;class Gi{constructor(N){this.label=N}}e.$7N=Gi;var hi;(function(F){F[F.Named=1]="Named",F[F.Indexed=2]="Indexed"})(hi||(e.NotebookVariablesRequestKind=hi={}));let Un=class{constructor(N,ue){this.label=N,this.timestamp=ue}};e.$8N=Un,e.$8N=Un=Ue([q],Un);var fi;(function(F){F[F.Production=1]="Production",F[F.Development=2]="Development",F[F.Test=3]="Test"})(fi||(e.ExtensionMode=fi={}));var di;(function(F){F[F.Node=1]="Node",F[F.Webworker=2]="Webworker"})(di||(e.ExtensionRuntime=di={}));var mi;(function(F){F[F.Other=0]="Other",F[F.Comment=1]="Comment",F[F.String=2]="String",F[F.RegEx=3]="RegEx"})(mi||(e.StandardTokenType=mi={}));class Ji{constructor(N,ue){this.ranges=N,this.wordPattern=ue}}e.$9N=Ji;class Ki{constructor(N){this.c=N}get autoForwardAction(){return this.c}}e.$0N=Ki;var gi;(function(F){F[F.Queued=1]="Queued",F[F.Running=2]="Running",F[F.Passed=3]="Passed",F[F.Failed=4]="Failed",F[F.Skipped=5]="Skipped",F[F.Errored=6]="Errored"})(gi||(e.TestResultState=gi={}));var $i;(function(F){F[F.Run=1]="Run",F[F.Debug=2]="Debug",F[F.Coverage=3]="Coverage"})($i||(e.TestRunProfileKind=$i={}));let zn=class{constructor(N=void 0,ue=void 0,Pe=void 0,qe=!1,Ze=!0){this.include=N,this.exclude=ue,this.profile=Pe,this.continuous=qe,this.preserveFocus=Ze}};e.$$N=zn,e.$$N=zn=Ue([q],zn);let Bn=re=class{static diff(N,ue,Pe){const qe=new re(N);return qe.expectedOutput=ue,qe.actualOutput=Pe,qe}constructor(N){this.message=N}};e.$_N=Bn,e.$_N=Bn=re=Ue([q],Bn);let Hn=class{constructor(N){this.id=N}};e.$aO=Hn,e.$aO=Hn=Ue([q],Hn);class Dn{constructor(N,ue){this.covered=N,this.total=ue,pi(this)}}e.$bO=Dn;function pi(F){if(F){if(F.covered>F.total)throw new Error(`The total number of covered items (${F.covered}) cannot be greater than the total (${F.total})`);if(F.total<0)throw new Error(`The number of covered items (${F.total}) cannot be negative`)}}class qn{static fromDetails(N,ue){const Pe=new Dn(0,0),qe=new Dn(0,0),Ze=new Dn(0,0);for(const ct of ue)if("branches"in ct){Pe.total+=1,Pe.covered+=ct.executed?1:0;for(const Dt of ct.branches)qe.total+=1,qe.covered+=Dt.executed?1:0}else Ze.total+=1,Ze.covered+=ct.executed?1:0;const st=new qn(N,Pe,qe.total>0?qe:void 0,Ze.total>0?Ze:void 0);return st.detailedCoverage=ue,st}constructor(N,ue,Pe,qe,Ze){this.uri=N,this.statementCoverage=ue,this.branchCoverage=Pe,this.declarationCoverage=qe,this.testItem=Ze}}e.$dO=qn;class Qi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ue,Pe=[]){this.executed=N,this.location=ue,this.branches=Pe}}e.$eO=Qi;class Zi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ue,Pe){this.executed=N,this.location=ue,this.label=Pe}}e.$fO=Zi;class Xi{get executionCount(){return+this.executed}set executionCount(N){this.executed=N}constructor(N,ue,Pe){this.name=N,this.executed=ue,this.location=Pe}}e.$gO=Xi;var bi;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(bi||(e.ExternalUriOpenerPriority=bi={}));var wi;(function(F){F[F.Untrusted=0]="Untrusted",F[F.Trusted=1]="Trusted",F[F.Unspecified=2]="Unspecified"})(wi||(e.WorkspaceTrustState=wi={}));var vi;(function(F){F[F.Notify=1]="Notify",F[F.OpenBrowser=2]="OpenBrowser",F[F.OpenPreview=3]="OpenPreview",F[F.Silent=4]="Silent",F[F.Ignore=5]="Ignore",F[F.OpenBrowserOnce=6]="OpenBrowserOnce"})(vi||(e.PortAutoForwardAction=vi={}));class Yi{constructor(N,ue,Pe,qe,Ze,st){this.kind=N,this.name=ue,this.detail=Pe,this.uri=qe,this.range=Ze,this.selectionRange=st}}e.$hO=Yi;class xi{constructor(N){this.uri=N}}e.$iO=xi;class _i{constructor(N,ue){this.original=N,this.modified=ue}}e.$jO=_i;class er{constructor(N,ue,Pe,qe){this.base=N,this.input1=ue,this.input2=Pe,this.result=qe}}e.$kO=er;class tr{constructor(N,ue){this.uri=N,this.viewType=ue}}e.$lO=tr;class nr{constructor(N){this.viewType=N}}e.$mO=nr;class ir{constructor(N,ue){this.uri=N,this.notebookType=ue}}e.$nO=ir;class rr{constructor(N,ue,Pe){this.original=N,this.modified=ue,this.notebookType=Pe}}e.$oO=rr;class sr{constructor(){}}e.$pO=sr;class or{constructor(N,ue){this.uri=N,this.inputBoxUri=ue}}e.$qO=or;class ar{constructor(){}}e.$rO=ar;class lr{constructor(N){this.textDiffs=N}}e.$sO=lr;var yi;(function(F){F[F.Down=0]="Down",F[F.Up=1]="Up"})(yi||(e.InteractiveSessionVoteDirection=yi={}));var Ei;(function(F){F[F.Action=1]="Action",F[F.Toolbar=2]="Toolbar"})(Ei||(e.ChatCopyKind=Ei={}));var Si;(function(F){F[F.Short=1]="Short",F[F.Medium=2]="Medium",F[F.Full=3]="Full"})(Si||(e.ChatVariableLevel=Si={}));class cr{constructor(N,ue,Pe){this.id=N,this.label=ue,this.values=Pe}}e.$tO=cr;var Di;(function(F){F[F.Unhelpful=0]="Unhelpful",F[F.Helpful=1]="Helpful",F[F.Undone=2]="Undone",F[F.Accepted=3]="Accepted",F[F.Bug=4]="Bug"})(Di||(e.InteractiveEditorResponseFeedbackKind=Di={}));var ki;(function(F){F[F.Unhelpful=0]="Unhelpful",F[F.Helpful=1]="Helpful"})(ki||(e.ChatResultFeedbackKind=ki={}));class ur{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new Ge(N):N}}e.$uO=ur;class hr{constructor(N,ue){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new Ge(N):N,this.vulnerabilities=ue}}e.$vO=hr;class fr{constructor(N,ue){this.participant=N,this.command=ue}}e.$wO=fr;class dr{constructor(N,ue,Pe){this.title=N,this.message=ue,this.data=Pe}}e.$xO=dr;class mr{constructor(N,ue){this.value=N,this.baseUri=ue}}e.$yO=mr;class gr{constructor(N,ue){this.value=N,this.title=ue}}e.$zO=gr;class $r{constructor(N){this.value=N}}e.$AO=$r;class pr{constructor(N,ue){this.value=N,this.task=ue}}e.$BO=pr;class br{constructor(N){if(typeof N!="string"&&N.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof N=="string"?new Ge(N):N}}e.$CO=br;class wr{constructor(N){this.value=N}}e.$DO=wr;class vr{constructor(N,ue){this.value=N,this.iconPath=ue}}e.$EO=vr;class yr{constructor(N,ue){this.uri=N,this.edits=Array.isArray(ue)?ue:[ue]}}e.$FO=yr;class Er{constructor(N,ue,Pe,qe){this.prompt=N,this.command=ue,this.references=Pe,this.participant=qe}}e.$GO=Er;class Sr{constructor(N,ue,Pe,qe){this.response=N,this.result=ue,this.participant=Pe,this.command=qe}}e.$HO=Sr;var Ii;(function(F){F[F.Panel=1]="Panel",F[F.Terminal=2]="Terminal",F[F.Notebook=3]="Notebook",F[F.Editor=4]="Editor"})(Ii||(e.ChatLocation=Ii={}));var kn;(function(F){F[F.User=1]="User",F[F.Assistant=2]="Assistant",F[F.System=3]="System"})(kn||(e.LanguageModelChatMessageRole=kn={}));class In{static User(N,ue){return new In(kn.User,N,ue)}static Assistant(N,ue){return new In(kn.Assistant,N,ue)}constructor(N,ue,Pe){this.role=N,this.content=ue,this.name=Pe}}e.$IO=In;class Dr{constructor(N){this.content=N}}e.$JO=Dr;class kr{constructor(N,ue){this.content=N,this.name=ue}}e.$KO=kr;class Ir{constructor(N,ue){this.content=N,this.name=ue}}e.$LO=Ir;class un extends Error{static NotFound(N){return new un(N,un.NotFound.name)}static NoPermissions(N){return new un(N,un.NoPermissions.name)}static Blocked(N){return new un(N,un.Blocked.name)}constructor(N,ue,Pe){super(N,{cause:Pe}),this.name="LanguageModelError",this.code=ue??""}}e.$MO=un;var Pi;(function(F){F[F.SymbolInformation=1]="SymbolInformation",F[F.CommandInformation=2]="CommandInformation",F[F.SearchInformation=3]="SearchInformation",F[F.SettingInformation=4]="SettingInformation"})(Pi||(e.RelatedInformationType=Pi={}));var Ri;(function(F){F[F.Started=1]="Started",F[F.Recognizing=2]="Recognizing",F[F.Recognized=3]="Recognized",F[F.Stopped=4]="Stopped",F[F.Error=5]="Error"})(Ri||(e.SpeechToTextStatus=Ri={}));var Ai;(function(F){F[F.Started=1]="Started",F[F.Stopped=2]="Stopped",F[F.Error=3]="Error"})(Ai||(e.TextToSpeechStatus=Ai={}));var Ti;(function(F){F[F.Recognized=1]="Recognized",F[F.Stopped=2]="Stopped"})(Ti||(e.KeywordRecognitionStatus=Ti={}));class Pr{constructor(N,ue){this.text=N,this.range=ue}}e.$NO=Pr;var Ci;(function(F){F[F.Invoke=0]="Invoke",F[F.Automatic=1]="Automatic"})(Ci||(e.InlineEditTriggerKind=Ci={}))}),define(Se[153],De([1,0,18,15,177,78,111,26,160,48,66,21,166,20,81,11,4,247,50,118,199,187,259,260,147,103,303,317,304,151,75,104,149,152]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m,b,l,t,o,d,i,h,u,D,I,T,O,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$WO=ce,e.$XO=W,e.$YO=ae;var Q;(function(ke){function Ce(J){const{selectionStartLineNumber:Te,selectionStartColumn:Fe,positionLineNumber:Ke,positionColumn:ze}=J,it=new P.$yM(Te-1,Fe-1),dt=new P.$yM(Ke-1,ze-1);return new P.$AM(it,dt)}ke.to=Ce;function $e(J){const{anchor:Te,active:Fe}=J;return{selectionStartLineNumber:Te.line+1,selectionStartColumn:Te.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}ke.from=$e})(Q||(e.Selection=Q={}));var X;(function(ke){function Ce(J){if(!J)return;const{start:Te,end:Fe}=J;return{startLineNumber:Te.line+1,startColumn:Te.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}ke.from=Ce;function $e(J){if(!J)return;const{startLineNumber:Te,startColumn:Fe,endLineNumber:Ke,endColumn:ze}=J;return new P.$zM(Te-1,Fe-1,Ke-1,ze-1)}ke.to=$e})(X||(e.Range=X={}));var ie;(function(ke){function Ce(J){return{uri:J.uri,range:X.from(J.range)}}ke.from=Ce;function $e(J){return new P.$JM(c.URI.revive(J.uri),X.to(J.range))}ke.to=$e})(ie||(e.Location=ie={}));var ne;(function(ke){function Ce($e){switch($e){case m.StandardTokenType.Comment:return P.StandardTokenType.Comment;case m.StandardTokenType.Other:return P.StandardTokenType.Other;case m.StandardTokenType.RegEx:return P.StandardTokenType.RegEx;case m.StandardTokenType.String:return P.StandardTokenType.String}}ke.to=Ce})(ne||(e.TokenType=ne={}));var x;(function(ke){function Ce(J){return new P.$yM(J.lineNumber-1,J.column-1)}ke.to=Ce;function $e(J){return{lineNumber:J.line+1,column:J.character+1}}ke.from=$e})(x||(e.Position=x={}));var re;(function(ke){function Ce(Te,Fe,Ke){return(0,n.$Hb)((0,n.$2b)(Te).map(ze=>$e(ze,Fe,Ke)))}ke.from=Ce;function $e(Te,Fe,Ke){if(typeof Te=="string")return{$serialized:!0,language:Te,isBuiltin:Ke?.isBuiltin};if(Te)return{$serialized:!0,language:Te.language,scheme:J(Te.scheme,Fe),pattern:Ye.from(Te.pattern)??void 0,exclusive:Te.exclusive,notebookType:Te.notebookType,isBuiltin:Ke?.isBuiltin}}function J(Te,Fe){return Fe&&typeof Te=="string"?Fe.transformOutgoingScheme(Te):Te}})(re||(e.DocumentSelector=re={}));var q;(function(ke){function Ce(J){switch(J){case P.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case P.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}ke.from=Ce;function $e(J){switch(J){case t.MarkerTag.Unnecessary:return P.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return P.DiagnosticTag.Deprecated;default:return}}ke.to=$e})(q||(e.DiagnosticTag=q={}));var te;(function(ke){function Ce(J){let Te;return J.code&&((0,f.$ag)(J.code)||(0,f.$eg)(J.code)?Te=String(J.code):Te={value:String(J.code.value),target:J.code.target}),{...X.from(J.range),message:J.message,source:J.source,code:Te,severity:M.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(le.from),tags:Array.isArray(J.tags)?(0,n.$Hb)(J.tags.map(q.from)):void 0}}ke.from=Ce;function $e(J){const Te=new P.$LM(X.to(J),J.message,M.to(J.severity));return Te.source=J.source,Te.code=(0,f.$ag)(J.code)?J.code:J.code?.value,Te.relatedInformation=J.relatedInformation&&J.relatedInformation.map(le.to),Te.tags=J.tags&&(0,n.$Hb)(J.tags.map(q.to)),Te}ke.to=$e})(te||(e.Diagnostic=te={}));var le;(function(ke){function Ce(J){return{...X.from(J.location.range),message:J.message,resource:J.location.uri}}ke.from=Ce;function $e(J){return new P.$KM(new P.$JM(J.resource,X.to(J)),J.message)}ke.to=$e})(le||(e.DiagnosticRelatedInformation=le={}));var M;(function(ke){function Ce(J){switch(J){case P.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case P.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case P.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case P.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}ke.from=Ce;function $e(J){switch(J){case t.MarkerSeverity.Info:return P.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return P.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return P.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return P.DiagnosticSeverity.Hint;default:return P.DiagnosticSeverity.Error}}ke.to=$e})(M||(e.DiagnosticSeverity=M={}));var z;(function(ke){function Ce(J){return typeof J=="number"&&J>=P.ViewColumn.One?J-1:J===P.ViewColumn.Beside?C.$eE:C.$dE}ke.from=Ce;function $e(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}ke.to=$e})(z||(e.ViewColumn=z={}));function oe(ke){return typeof ke.range<"u"}function ce(ke){return ke.length===0?!0:!!oe(ke[0])}var pe;(function(ke){function Ce(ze){return ze.map(ke.from)}ke.fromMany=Ce;function $e(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function J(ze){let it;if($e(ze)){const{language:vt,value:Bt}=ze;it={value:"```"+vt+`
`+Bt+"\n```\n"}}else P.$ZM.isMarkdownString(ze)?it={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?it={value:ze}:it={value:""};const dt=Object.create(null);it.uris=dt;const jt=vt=>{try{let Bt=c.URI.parse(vt,!0);Bt=Bt.with({query:Te(Bt.query,dt)}),dt[vt]=Bt}catch{}return""},Jt=new v.marked.Renderer;return Jt.link=jt,Jt.image=vt=>typeof vt=="string"?jt(R.$6k(vt).href):"",(0,v.marked)(it.value,{renderer:Jt}),it}ke.from=J;function Te(ze,it){if(!ze)return ze;let dt;try{dt=(0,s.$9h)(ze)}catch{}if(!dt)return ze;let jt=!1;return dt=(0,y.$_n)(dt,Jt=>{if(c.URI.isUri(Jt)){const vt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[vt]=Jt,jt=!0,vt}else return}),jt?JSON.stringify(dt):ze}function Fe(ze){const it=new P.$ZM(ze.value,ze.supportThemeIcons);return it.isTrusted=ze.isTrusted,it.supportHtml=ze.supportHtml,it.baseUri=ze.baseUri?c.URI.from(ze.baseUri):void 0,it}ke.to=Fe;function Ke(ze){if(ze)return typeof ze=="string"?ze:ke.from(ze)}ke.fromStrict=Ke})(pe||(e.MarkdownString=pe={}));function W(ke){return ce(ke)?ke.map(Ce=>({range:X.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?pe.fromMany(Ce.hoverMessage):Ce.hoverMessage?pe.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):ke.map(Ce=>({range:X.from(Ce)}))}function ae(ke){return typeof ke>"u"?ke:typeof ke=="string"?c.URI.file(ke):ke}var ee;(function(ke){function Ce($e){return typeof $e>"u"?$e:{contentText:$e.contentText,contentIconPath:$e.contentIconPath?ae($e.contentIconPath):void 0,border:$e.border,borderColor:$e.borderColor,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,color:$e.color,backgroundColor:$e.backgroundColor,margin:$e.margin,width:$e.width,height:$e.height}}ke.from=Ce})(ee||(e.ThemableDecorationAttachmentRenderOptions=ee={}));var H;(function(ke){function Ce($e){return typeof $e>"u"?$e:{backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?ae($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?ee.from($e.before):void 0,after:$e.after?ee.from($e.after):void 0}}ke.from=Ce})(H||(e.ThemableDecorationRenderOptions=H={}));var L;(function(ke){function Ce($e){if(typeof $e>"u")return $e;switch($e){case P.DecorationRangeBehavior.OpenOpen:return l.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case P.DecorationRangeBehavior.ClosedClosed:return l.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case P.DecorationRangeBehavior.OpenClosed:return l.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case P.DecorationRangeBehavior.ClosedOpen:return l.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ke.from=Ce})(L||(e.DecorationRangeBehavior=L={}));var V;(function(ke){function Ce($e){return{isWholeLine:$e.isWholeLine,rangeBehavior:$e.rangeBehavior?L.from($e.rangeBehavior):void 0,overviewRulerLane:$e.overviewRulerLane,light:$e.light?H.from($e.light):void 0,dark:$e.dark?H.from($e.dark):void 0,backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?ae($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?ee.from($e.before):void 0,after:$e.after?ee.from($e.after):void 0}}ke.from=Ce})(V||(e.DecorationRenderOptions=V={}));var B;(function(ke){function Ce(J){return{text:J.newText,eol:J.newEol&&Y.from(J.newEol),range:X.from(J.range)}}ke.from=Ce;function $e(J){const Te=new P.$EM(X.to(J.range),J.text);return Te.newEol=typeof J.eol>"u"?void 0:Y.to(J.eol),Te}ke.to=$e})(B||(e.TextEdit=B={}));var U;(function(ke){function Ce(J,Te){const Fe={edits:[]};if(J instanceof P.$HM){const Ke=new A.$Bc;for(const ze of J._allEntries())ze._type===P.FileEditType.File&&c.URI.isUri(ze.to)&&ze.from===void 0&&Ke.add(ze.to);for(const ze of J._allEntries())if(ze._type===P.FileEditType.File){let it;ze.options?.contents&&(ArrayBuffer.isView(ze.options.contents)?it={type:"base64",value:(0,r.$4e)(r.$Je.wrap(ze.options.contents))}:it={type:"dataTransferItem",id:ze.options.contents._itemId}),Fe.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contents:it},metadata:ze.metadata})}else ze._type===P.FileEditType.Text?Fe.edits.push({resource:ze.uri,textEdit:B.from(ze.edit),versionId:Ke.has(ze.uri)?void 0:Te?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===P.FileEditType.Snippet?Fe.edits.push({resource:ze.uri,textEdit:{range:X.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:Ke.has(ze.uri)?void 0:Te?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===P.FileEditType.Cell?Fe.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Te?.getNotebookDocumentVersion(ze.uri)}):ze._type===P.FileEditType.CellReplace&&Fe.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:Te?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:I.CellEditType.Replace,index:ze.index,count:ze.count,cells:ze.cells.map(yt.from)}})}return Fe}ke.from=Ce;function $e(J){const Te=new P.$HM,Fe=new A.$Ac;for(const Ke of J.edits)if(Ke.textEdit){const ze=Ke,it=c.URI.revive(ze.resource),dt=X.to(ze.textEdit.range),jt=ze.textEdit.text,Jt=ze.textEdit.insertAsSnippet;let vt;Jt?vt=P.$GM.replace(dt,new P.$IM(jt)):vt=P.$EM.replace(dt,jt);const Bt=Fe.get(it);Bt?Bt.push(vt):Fe.set(it,[vt])}else Te.renameFile(c.URI.revive(Ke.oldResource),c.URI.revive(Ke.newResource),Ke.options);for(const[Ke,ze]of Fe)Te.set(Ke,ze);return Te}ke.to=$e})(U||(e.WorkspaceEdit=U={}));var K;(function(ke){const Ce=Object.create(null);Ce[P.SymbolKind.File]=b.SymbolKind.File,Ce[P.SymbolKind.Module]=b.SymbolKind.Module,Ce[P.SymbolKind.Namespace]=b.SymbolKind.Namespace,Ce[P.SymbolKind.Package]=b.SymbolKind.Package,Ce[P.SymbolKind.Class]=b.SymbolKind.Class,Ce[P.SymbolKind.Method]=b.SymbolKind.Method,Ce[P.SymbolKind.Property]=b.SymbolKind.Property,Ce[P.SymbolKind.Field]=b.SymbolKind.Field,Ce[P.SymbolKind.Constructor]=b.SymbolKind.Constructor,Ce[P.SymbolKind.Enum]=b.SymbolKind.Enum,Ce[P.SymbolKind.Interface]=b.SymbolKind.Interface,Ce[P.SymbolKind.Function]=b.SymbolKind.Function,Ce[P.SymbolKind.Variable]=b.SymbolKind.Variable,Ce[P.SymbolKind.Constant]=b.SymbolKind.Constant,Ce[P.SymbolKind.String]=b.SymbolKind.String,Ce[P.SymbolKind.Number]=b.SymbolKind.Number,Ce[P.SymbolKind.Boolean]=b.SymbolKind.Boolean,Ce[P.SymbolKind.Array]=b.SymbolKind.Array,Ce[P.SymbolKind.Object]=b.SymbolKind.Object,Ce[P.SymbolKind.Key]=b.SymbolKind.Key,Ce[P.SymbolKind.Null]=b.SymbolKind.Null,Ce[P.SymbolKind.EnumMember]=b.SymbolKind.EnumMember,Ce[P.SymbolKind.Struct]=b.SymbolKind.Struct,Ce[P.SymbolKind.Event]=b.SymbolKind.Event,Ce[P.SymbolKind.Operator]=b.SymbolKind.Operator,Ce[P.SymbolKind.TypeParameter]=b.SymbolKind.TypeParameter;function $e(Te){return typeof Ce[Te]=="number"?Ce[Te]:b.SymbolKind.Property}ke.from=$e;function J(Te){for(const Fe in Ce)if(Ce[Fe]===Te)return Number(Fe);return P.SymbolKind.Property}ke.to=J})(K||(e.SymbolKind=K={}));var Z;(function(ke){function Ce(J){switch(J){case P.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}ke.from=Ce;function $e(J){switch(J){case b.SymbolTag.Deprecated:return P.SymbolTag.Deprecated}}ke.to=$e})(Z||(e.SymbolTag=Z={}));var j;(function(ke){function Ce(J){return{name:J.name,kind:K.from(J.kind),tags:J.tags&&J.tags.map(Z.from),containerName:J.containerName,location:Le.from(J.location)}}ke.from=Ce;function $e(J){const Te=new P.$QM(J.name,K.to(J.kind),J.containerName,Le.to(J.location));return Te.tags=J.tags&&J.tags.map(Z.to),Te}ke.to=$e})(j||(e.WorkspaceSymbol=j={}));var G;(function(ke){function Ce(J){const Te={name:J.name||"!!MISSING: name!!",detail:J.detail,range:X.from(J.range),selectionRange:X.from(J.selectionRange),kind:K.from(J.kind),tags:J.tags?.map(Z.from)??[]};return J.children&&(Te.children=J.children.map(Ce)),Te}ke.from=Ce;function $e(J){const Te=new P.$RM(J.name,J.detail,K.to(J.kind),X.to(J.range),X.to(J.selectionRange));return(0,n.$Lb)(J.tags)&&(Te.tags=J.tags.map(Z.to)),J.children&&(Te.children=J.children.map($e)),Te}ke.to=$e})(G||(e.DocumentSymbol=G={}));var se;(function(ke){function Ce(J){const Te=new P.$VM(K.to(J.kind),J.name,J.detail||"",c.URI.revive(J.uri),X.to(J.range),X.to(J.selectionRange));return Te._sessionId=J._sessionId,Te._itemId=J._itemId,Te}ke.to=Ce;function $e(J,Te,Fe){if(Te=Te??J._sessionId,Fe=Fe??J._itemId,Te===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Fe,name:J.name,detail:J.detail,kind:K.from(J.kind),uri:J.uri,range:X.from(J.range),selectionRange:X.from(J.selectionRange),tags:J.tags?.map(Z.from)}}ke.from=$e})(se||(e.CallHierarchyItem=se={}));var fe;(function(ke){function Ce($e){return new P.$WM(se.to($e.from),$e.fromRanges.map(J=>X.to(J)))}ke.to=Ce})(fe||(e.CallHierarchyIncomingCall=fe={}));var Ee;(function(ke){function Ce($e){return new P.$XM(se.to($e.to),$e.fromRanges.map(J=>X.to(J)))}ke.to=Ce})(Ee||(e.CallHierarchyOutgoingCall=Ee={}));var Le;(function(ke){function Ce(J){return{range:J.range&&X.from(J.range),uri:J.uri}}ke.from=Ce;function $e(J){return new P.$JM(c.URI.revive(J.uri),X.to(J.range))}ke.to=$e})(Le||(e.location=Le={}));var de;(function(ke){function Ce(J){const Te=J,Fe=J;return{originSelectionRange:Te.originSelectionRange?X.from(Te.originSelectionRange):void 0,uri:Te.targetUri?Te.targetUri:Fe.uri,range:X.from(Te.targetRange?Te.targetRange:Fe.range),targetSelectionRange:Te.targetSelectionRange?X.from(Te.targetSelectionRange):void 0}}ke.from=Ce;function $e(J){return{targetUri:c.URI.revive(J.uri),targetRange:X.to(J.range),targetSelectionRange:J.targetSelectionRange?X.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?X.to(J.originSelectionRange):void 0}}ke.to=$e})(de||(e.DefinitionLink=de={}));var we;(function(ke){function Ce(J){return{range:X.from(J.range),contents:pe.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}ke.from=Ce;function $e(J){const Te=J.contents.map(pe.to),Fe=X.to(J.range),Ke=J.canIncreaseVerbosity,ze=J.canDecreaseVerbosity;return new P.$NM(Te,Fe,Ke,ze)}ke.to=$e})(we||(e.Hover=we={}));var Re;(function(ke){function Ce(J){return{range:X.from(J.range),expression:J.expression}}ke.from=Ce;function $e(J){return new P.$IN(X.to(J.range),J.expression)}ke.to=$e})(Re||(e.EvaluatableExpression=Re={}));var Oe;(function(ke){function Ce(J){if(J instanceof P.$JN)return{type:"text",range:X.from(J.range),text:J.text};if(J instanceof P.$KN)return{type:"variable",range:X.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof P.$LN)return{type:"expression",range:X.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}ke.from=Ce;function $e(J){switch(J.type){case"text":return{range:X.to(J.range),text:J.text};case"variable":return{range:X.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:X.to(J.range),expression:J.expression}}}ke.to=$e})(Oe||(e.InlineValue=Oe={}));var me;(function(ke){function Ce(J){return{frameId:J.frameId,stoppedLocation:X.from(J.stoppedLocation)}}ke.from=Ce;function $e(J){return new P.$MN(J.frameId,X.to(J.stoppedLocation))}ke.to=$e})(me||(e.InlineValueContext=me={}));var Ie;(function(ke){function Ce(J){return{range:X.from(J.range),kind:J.kind}}ke.from=Ce;function $e(J){return new P.$OM(X.to(J.range),J.kind)}ke.to=$e})(Ie||(e.DocumentHighlight=Ie={}));var Ae;(function(ke){function Ce(J){return{uri:J.uri,highlights:J.highlights.map(Ie.from)}}ke.from=Ce;function $e(J){return new P.$PM(c.URI.revive(J.uri),J.highlights.map(Ie.to))}ke.to=$e})(Ae||(e.MultiDocumentHighlight=Ae={}));var je;(function(ke){function Ce($e){switch($e){case b.CompletionTriggerKind.TriggerCharacter:return P.CompletionTriggerKind.TriggerCharacter;case b.CompletionTriggerKind.TriggerForIncompleteCompletions:return P.CompletionTriggerKind.TriggerForIncompleteCompletions;case b.CompletionTriggerKind.Invoke:default:return P.CompletionTriggerKind.Invoke}}ke.to=Ce})(je||(e.CompletionTriggerKind=je={}));var Be;(function(ke){function Ce($e){return{triggerKind:je.to($e.triggerKind),triggerCharacter:$e.triggerCharacter}}ke.to=Ce})(Be||(e.CompletionContext=Be={}));var Je;(function(ke){function Ce(J){switch(J){case P.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}ke.from=Ce;function $e(J){switch(J){case b.CompletionItemTag.Deprecated:return P.CompletionItemTag.Deprecated}}ke.to=$e})(Je||(e.CompletionItemTag=Je={}));var We;(function(ke){const Ce=new Map([[P.CompletionItemKind.Method,b.CompletionItemKind.Method],[P.CompletionItemKind.Function,b.CompletionItemKind.Function],[P.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[P.CompletionItemKind.Field,b.CompletionItemKind.Field],[P.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[P.CompletionItemKind.Class,b.CompletionItemKind.Class],[P.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[P.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[P.CompletionItemKind.Module,b.CompletionItemKind.Module],[P.CompletionItemKind.Property,b.CompletionItemKind.Property],[P.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[P.CompletionItemKind.Value,b.CompletionItemKind.Value],[P.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[P.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[P.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[P.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[P.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[P.CompletionItemKind.Text,b.CompletionItemKind.Text],[P.CompletionItemKind.Color,b.CompletionItemKind.Color],[P.CompletionItemKind.File,b.CompletionItemKind.File],[P.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[P.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[P.CompletionItemKind.Event,b.CompletionItemKind.Event],[P.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[P.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[P.CompletionItemKind.Issue,b.CompletionItemKind.Issue],[P.CompletionItemKind.User,b.CompletionItemKind.User]]);function $e(Fe){return Ce.get(Fe)??b.CompletionItemKind.Property}ke.from=$e;const J=new Map([[b.CompletionItemKind.Method,P.CompletionItemKind.Method],[b.CompletionItemKind.Function,P.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,P.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,P.CompletionItemKind.Field],[b.CompletionItemKind.Variable,P.CompletionItemKind.Variable],[b.CompletionItemKind.Class,P.CompletionItemKind.Class],[b.CompletionItemKind.Interface,P.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,P.CompletionItemKind.Struct],[b.CompletionItemKind.Module,P.CompletionItemKind.Module],[b.CompletionItemKind.Property,P.CompletionItemKind.Property],[b.CompletionItemKind.Unit,P.CompletionItemKind.Unit],[b.CompletionItemKind.Value,P.CompletionItemKind.Value],[b.CompletionItemKind.Constant,P.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,P.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,P.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,P.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,P.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,P.CompletionItemKind.Text],[b.CompletionItemKind.Color,P.CompletionItemKind.Color],[b.CompletionItemKind.File,P.CompletionItemKind.File],[b.CompletionItemKind.Reference,P.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,P.CompletionItemKind.Folder],[b.CompletionItemKind.Event,P.CompletionItemKind.Event],[b.CompletionItemKind.Operator,P.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,P.CompletionItemKind.TypeParameter],[b.CompletionItemKind.User,P.CompletionItemKind.User],[b.CompletionItemKind.Issue,P.CompletionItemKind.Issue]]);function Te(Fe){return J.get(Fe)??P.CompletionItemKind.Property}ke.to=Te})(We||(e.CompletionItemKind=We={}));var Qe;(function(ke){function Ce($e,J){const Te=new P.$6M($e.label);return Te.insertText=$e.insertText,Te.kind=We.to($e.kind),Te.tags=$e.tags?.map(Je.to),Te.detail=$e.detail,Te.documentation=R.$Zk($e.documentation)?pe.to($e.documentation):$e.documentation,Te.sortText=$e.sortText,Te.filterText=$e.filterText,Te.preselect=$e.preselect,Te.commitCharacters=$e.commitCharacters,p.$dt.isIRange($e.range)?Te.range=X.to($e.range):typeof $e.range=="object"&&(Te.range={inserting:X.to($e.range.insert),replacing:X.to($e.range.replace)}),Te.keepWhitespace=typeof $e.insertTextRules>"u"?!1:!!($e.insertTextRules&b.CompletionItemInsertTextRule.KeepWhitespace),typeof $e.insertTextRules<"u"&&$e.insertTextRules&b.CompletionItemInsertTextRule.InsertAsSnippet?Te.insertText=new P.$IM($e.insertText):(Te.insertText=$e.insertText,Te.textEdit=Te.range instanceof P.$zM?new P.$EM(Te.range,Te.insertText):void 0),$e.additionalTextEdits&&$e.additionalTextEdits.length>0&&(Te.additionalTextEdits=$e.additionalTextEdits.map(Fe=>B.to(Fe))),Te.command=J&&$e.command?J.fromInternal($e.command):void 0,Te}ke.to=Ce})(Qe||(e.CompletionItem=Qe={}));var He;(function(ke){function Ce(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:pe.fromStrict(J.documentation)}}ke.from=Ce;function $e(J){return{label:J.label,documentation:R.$Zk(J.documentation)?pe.to(J.documentation):J.documentation}}ke.to=$e})(He||(e.ParameterInformation=He={}));var nt;(function(ke){function Ce(J){return{label:J.label,documentation:pe.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(He.from):[],activeParameter:J.activeParameter}}ke.from=Ce;function $e(J){return{label:J.label,documentation:R.$Zk(J.documentation)?pe.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(He.to):[],activeParameter:J.activeParameter}}ke.to=$e})(nt||(e.SignatureInformation=nt={}));var et;(function(ke){function Ce(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(nt.from):[]}}ke.from=Ce;function $e(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(nt.to):[]}}ke.to=$e})(et||(e.SignatureHelp=et={}));var rt;(function(ke){function Ce($e,J){const Te=new P.$5M(x.to(J.position),typeof J.label=="string"?J.label:J.label.map(lt.to.bind(void 0,$e)),J.kind&&tt.to(J.kind));return Te.textEdits=J.textEdits&&J.textEdits.map(B.to),Te.tooltip=R.$Zk(J.tooltip)?pe.to(J.tooltip):J.tooltip,Te.paddingLeft=J.paddingLeft,Te.paddingRight=J.paddingRight,Te}ke.to=Ce})(rt||(e.InlayHint=rt={}));var lt;(function(ke){function Ce($e,J){const Te=new P.$4M(J.label);return Te.tooltip=R.$Zk(J.tooltip)?pe.to(J.tooltip):J.tooltip,b.Command.is(J.command)&&(Te.command=$e.fromInternal(J.command)),J.location&&(Te.location=Le.to(J.location)),Te}ke.to=Ce})(lt||(e.InlayHintLabelPart=lt={}));var tt;(function(ke){function Ce(J){return J}ke.from=Ce;function $e(J){return J}ke.to=$e})(tt||(e.InlayHintKind=tt={}));var Xe;(function(ke){function Ce(J){return{range:X.from(J.range),url:J.target,tooltip:J.tooltip}}ke.from=Ce;function $e(J){let Te;if(J.url)try{Te=typeof J.url=="string"?c.URI.parse(J.url,!0):c.URI.revive(J.url)}catch{}return new P.$$M(X.to(J.range),Te)}ke.to=$e})(Xe||(e.DocumentLink=Xe={}));var Ge;(function(ke){function Ce(J){const Te=new P.$bN(J.label);return J.textEdit&&(Te.textEdit=B.to(J.textEdit)),J.additionalTextEdits&&(Te.additionalTextEdits=J.additionalTextEdits.map(Fe=>B.to(Fe))),Te}ke.to=Ce;function $e(J){return{label:J.label,textEdit:J.textEdit?B.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Te=>B.from(Te)):void 0}}ke.from=$e})(Ge||(e.ColorPresentation=Ge={}));var xe;(function(ke){function Ce(J){return new P.$_M(J[0],J[1],J[2],J[3])}ke.to=Ce;function $e(J){return[J.red,J.green,J.blue,J.alpha]}ke.from=$e})(xe||(e.Color=xe={}));var ve;(function(ke){function Ce(J){return{range:X.from(J.range)}}ke.from=Ce;function $e(J){return new P.$UM(X.to(J.range))}ke.to=$e})(ve||(e.SelectionRange=ve={}));var ge;(function(ke){function Ce($e){switch($e){case i.SaveReason.AUTO:return P.TextDocumentSaveReason.AfterDelay;case i.SaveReason.EXPLICIT:return P.TextDocumentSaveReason.Manual;case i.SaveReason.FOCUS_CHANGE:case i.SaveReason.WINDOW_CHANGE:return P.TextDocumentSaveReason.FocusOut}}ke.to=Ce})(ge||(e.TextDocumentSaveReason=ge={}));var be;(function(ke){function Ce(J){switch(J){case P.TextEditorLineNumbersStyle.Off:return g.RenderLineNumbersType.Off;case P.TextEditorLineNumbersStyle.Relative:return g.RenderLineNumbersType.Relative;case P.TextEditorLineNumbersStyle.Interval:return g.RenderLineNumbersType.Interval;case P.TextEditorLineNumbersStyle.On:default:return g.RenderLineNumbersType.On}}ke.from=Ce;function $e(J){switch(J){case g.RenderLineNumbersType.Off:return P.TextEditorLineNumbersStyle.Off;case g.RenderLineNumbersType.Relative:return P.TextEditorLineNumbersStyle.Relative;case g.RenderLineNumbersType.Interval:return P.TextEditorLineNumbersStyle.Interval;case g.RenderLineNumbersType.On:default:return P.TextEditorLineNumbersStyle.On}}ke.to=$e})(be||(e.TextEditorLineNumbersStyle=be={}));var Y;(function(ke){function Ce(J){if(J===P.EndOfLine.CRLF)return l.EndOfLineSequence.CRLF;if(J===P.EndOfLine.LF)return l.EndOfLineSequence.LF}ke.from=Ce;function $e(J){if(J===l.EndOfLineSequence.CRLF)return P.EndOfLine.CRLF;if(J===l.EndOfLineSequence.LF)return P.EndOfLine.LF}ke.to=$e})(Y||(e.EndOfLine=Y={}));var _;(function(ke){function Ce($e){if(typeof $e=="object")return $e.viewId;switch($e){case P.ProgressLocation.SourceControl:return o.ProgressLocation.Scm;case P.ProgressLocation.Window:return o.ProgressLocation.Window;case P.ProgressLocation.Notification:return o.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ke.from=Ce})(_||(e.ProgressLocation=_={}));var ye;(function(ke){function Ce(J){const Te={start:J.start+1,end:J.end+1};return J.kind&&(Te.kind=Me.from(J.kind)),Te}ke.from=Ce;function $e(J){const Te={start:J.start-1,end:J.end-1};return J.kind&&(Te.kind=Me.to(J.kind)),Te}ke.to=$e})(ye||(e.FoldingRange=ye={}));var Me;(function(ke){function Ce(J){if(J)switch(J){case P.FoldingRangeKind.Comment:return b.$Qv.Comment;case P.FoldingRangeKind.Imports:return b.$Qv.Imports;case P.FoldingRangeKind.Region:return b.$Qv.Region}}ke.from=Ce;function $e(J){if(J)switch(J.value){case b.$Qv.Comment.value:return P.FoldingRangeKind.Comment;case b.$Qv.Imports.value:return P.FoldingRangeKind.Imports;case b.$Qv.Region.value:return P.FoldingRangeKind.Region}}ke.to=$e})(Me||(e.FoldingRangeKind=Me={}));var Ve;(function(ke){function Ce($e){if($e)return{pinned:typeof $e.preview=="boolean"?!$e.preview:void 0,inactive:$e.background,preserveFocus:$e.preserveFocus,selection:typeof $e.selection=="object"?X.from($e.selection):void 0,override:typeof $e.override=="boolean"?i.$GF.id:void 0}}ke.from=Ce})(Ve||(e.TextEditorOpenOptions=Ve={}));var Ye;(function(ke){function Ce(Fe){return Fe instanceof P.$wN?Fe.toJSON():typeof Fe=="string"?Fe:$e(Fe)||J(Fe)?new P.$wN(Fe.baseUri??Fe.base,Fe.pattern).toJSON():Fe}ke.from=Ce;function $e(Fe){const Ke=Fe;return Ke?c.URI.isUri(Ke.baseUri)&&typeof Ke.pattern=="string":!1}function J(Fe){const Ke=Fe;return Ke?typeof Ke.base=="string"&&typeof Ke.pattern=="string":!1}function Te(Fe){return typeof Fe=="string"?Fe:new P.$wN(c.URI.revive(Fe.baseUri),Fe.pattern)}ke.to=Te})(Ye||(e.GlobPattern=Ye={}));var _e;(function(ke){function Ce($e){if($e){if(Array.isArray($e))return $e.map(Ce);if(typeof $e=="string")return $e;{const J=$e;return{language:J.language,scheme:J.scheme,pattern:Ye.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}ke.from=Ce})(_e||(e.LanguageSelector=_e={}));var ot;(function(ke){function Ce(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Te=>Array.isArray(Te)&&Te.every(Fe=>Fe&&typeof Fe=="object"&&"uri"in Fe&&c.URI.isUri(Fe.uri)&&"version"in Fe&&typeof Fe.version=="number"&&"ranges"in Fe&&Array.isArray(Fe.ranges)&&Fe.ranges.every(Ke=>Ke instanceof P.$zM)))}ke.is=Ce;function $e(J){return{documents:J.documents.map(Te=>Te.map(Fe=>({uri:c.URI.from(Fe.uri),version:Fe.version,ranges:Fe.ranges.map(Ke=>X.from(Ke))})))}}ke.from=$e})(ot||(e.MappedEditsContext=ot={}));var ht;(function(ke){function Ce(J){return{start:J.start,end:J.end}}ke.from=Ce;function $e(J){return new P.$ZN(J.start,J.end)}ke.to=$e})(ht||(e.NotebookRange=ht={}));var gt;(function(ke){function Ce(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}ke.to=Ce;function $e(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}ke.from=$e})(gt||(e.NotebookCellExecutionSummary=gt={}));var Ct;(function(ke){function Ce($e){if($e===I.NotebookCellExecutionState.Unconfirmed)return P.NotebookCellExecutionState.Pending;if($e===I.NotebookCellExecutionState.Pending)return;if($e===I.NotebookCellExecutionState.Executing)return P.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${$e}`)}ke.to=Ce})(Ct||(e.NotebookCellExecutionState=Ct={}));var Ot;(function(ke){function Ce(J){switch(J){case P.NotebookCellKind.Markup:return I.CellKind.Markup;case P.NotebookCellKind.Code:default:return I.CellKind.Code}}ke.from=Ce;function $e(J){switch(J){case I.CellKind.Markup:return P.NotebookCellKind.Markup;case I.CellKind.Code:default:return P.NotebookCellKind.Code}}ke.to=$e})(Ot||(e.NotebookCellKind=Ot={}));var mt;(function(ke){function Ce(J){const Te={metadata:J.metadata??Object.create(null),cells:[]};for(const Fe of J.cells)P.$1N.validate(Fe),Te.cells.push(yt.from(Fe));return Te}ke.from=Ce;function $e(J){const Te=new P.$2N(J.cells.map(yt.to));return(0,f.$ng)(J.metadata)||(Te.metadata=J.metadata),Te}ke.to=$e})(mt||(e.NotebookData=mt={}));var yt;(function(ke){function Ce(J){return{cellKind:Ot.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:gt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(kt.from):[]}}ke.from=Ce;function $e(J){return new P.$1N(Ot.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(kt.to):void 0,J.metadata,J.internalMetadata?gt.to(J.internalMetadata):void 0)}ke.to=$e})(yt||(e.NotebookCellData=yt={}));var pt;(function(ke){function Ce(J){return{mime:J.mime,valueBytes:r.$Je.wrap(J.data)}}ke.from=Ce;function $e(J){return new P.$3N(J.valueBytes.buffer,J.mime)}ke.to=$e})(pt||(e.NotebookCellOutputItem=pt={}));var kt;(function(ke){function Ce(J){return{outputId:J.id,items:J.items.map(pt.from),metadata:J.metadata}}ke.from=Ce;function $e(J){const Te=J.items.map(pt.to);return new P.$4N(Te,J.outputId,J.metadata)}ke.to=$e})(kt||(e.NotebookCellOutput=kt={}));var Ht;(function(ke){function Ce(Te){return J(Te)?{include:Ye.from(Te.include)??void 0,exclude:Ye.from(Te.exclude)??void 0}:Ye.from(Te)??void 0}ke.from=Ce;function $e(Te){return J(Te)?{include:Ye.to(Te.include),exclude:Ye.to(Te.exclude)}:Ye.to(Te)}ke.to=$e;function J(Te){const Fe=Te;return Fe?!(0,f.$jg)(Fe.include)&&!(0,f.$jg)(Fe.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var It;(function(ke){function Ce($e,J,Te){const Fe=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{alignment:$e.alignment===P.NotebookCellStatusBarAlignment.Left?I.CellStatusbarAlignment.Left:I.CellStatusbarAlignment.Right,command:J.toInternal(Fe,Te),text:$e.text,tooltip:$e.tooltip,accessibilityInformation:$e.accessibilityInformation,priority:$e.priority}}ke.from=Ce})(It||(e.NotebookStatusBarItem=It={}));var bt;(function(ke){function Ce($e,J,Te){const Fe=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{command:J.toInternal(Fe,Te),label:$e.label,description:$e.description,detail:$e.detail,documentation:$e.documentation}}ke.from=Ce})(bt||(e.NotebookKernelSourceAction=bt={}));var qt;(function(ke){function Ce($e){return{transientOutputs:$e?.transientOutputs??!1,transientCellMetadata:$e?.transientCellMetadata??{},transientDocumentMetadata:$e?.transientDocumentMetadata??{},cellContentMetadata:$e?.cellContentMetadata??{}}}ke.from=Ce})(qt||(e.NotebookDocumentContentOptions=qt={}));var Pt;(function(ke){function Ce(J){return{uri:J.uri,provides:J.provides}}ke.from=Ce;function $e(J){return new P.$6N(c.URI.revive(J.uri),J.provides)}ke.to=$e})(Pt||(e.NotebookRendererScript=Pt={}));var at;(function(ke){function Ce(J){return{message:pe.fromStrict(J.message)||"",type:O.TestMessageType.Error,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:X.from(J.location.range),uri:J.location.uri}}}ke.from=Ce;function $e(J){const Te=new P.$_N(typeof J.message=="string"?J.message:pe.to(J.message));return Te.actualOutput=J.actual,Te.expectedOutput=J.expected,Te.contextValue=J.contextValue,Te.location=J.location?Le.to(J.location):void 0,Te}ke.to=$e})(at||(e.TestMessage=at={}));var ft;(function(ke){ke.namespace=O.$mL,ke.denamespace=O.$nL})(ft||(e.TestTag=ft={}));var $t;(function(ke){function Ce(J){const Te=(0,d.$VO)(J).controllerId;return{extId:T.$hL.fromExtHostTestItem(J,Te).toString(),label:J.label,uri:c.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Fe=>ft.namespace(Te,Fe.id)),range:p.$dt.lift(X.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&pe.fromStrict(J.error)||null}}ke.from=Ce;function $e(J){return{parent:void 0,error:void 0,id:T.$hL.fromString(J.extId).localId,label:J.label,uri:c.URI.revive(J.uri),tags:(J.tags||[]).map(Te=>{const{tagId:Fe}=ft.denamespace(Te);return new P.$aO(Fe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:X.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}ke.toPlain=$e})($t||(e.TestItem=$t={})),function(ke){function Ce(J){return{id:J.id}}ke.from=Ce;function $e(J){return new P.$aO(J.id)}ke.to=$e}(ft||(e.TestTag=ft={}));var Wt;(function(ke){const Ce=(J,Te)=>{const Fe=J.value;if(!Fe)return;const Ke={...$t.toPlain(Fe.item),parent:Te,taskStates:Fe.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(it=>it.type===O.TestMessageType.Error).map(at.to)})),children:[]};if(J.children)for(const ze of J.children.values()){const it=Ce(ze,Ke);it&&Ke.children.push(it)}return Ke};function $e(J){const Te=new $.$OO;for(const ze of J.items)Te.insert(T.$hL.fromString(ze.item.extId).path,ze);const Fe=[Te.nodes],Ke=[];for(;Fe.length;)for(const ze of Fe.pop())ze.value?Ke.push(ze):ze.children&&Fe.push(ze.children.values());return{completedAt:J.completedAt,results:Ke.map(ze=>Ce(ze)).filter(f.$ig)}}ke.to=$e})(Wt||(e.TestResults=Wt={}));var Rt;(function(ke){function Ce(Fe){return{covered:Fe.covered,total:Fe.total}}function $e(Fe){return"line"in Fe?x.from(Fe):X.from(Fe)}function J(Fe){if(typeof Fe.executed=="number"&&Fe.executed<0)throw new Error(`Invalid coverage count ${Fe.executed}`);return"branches"in Fe?{count:Fe.executed,location:$e(Fe.location),type:O.DetailType.Statement,branches:Fe.branches.length?Fe.branches.map(Ke=>({count:Ke.executed,location:Ke.location&&$e(Ke.location),label:Ke.label})):void 0}:{type:O.DetailType.Declaration,name:Fe.name,count:Fe.executed,location:$e(Fe.location)}}ke.fromDetails=J;function Te(Fe,Ke,ze){return P.$cO(ze.statementCoverage),P.$cO(ze.branchCoverage),P.$cO(ze.declarationCoverage),{id:Ke,uri:ze.uri,statement:Ce(ze.statementCoverage),branch:ze.branchCoverage&&Ce(ze.branchCoverage),declaration:ze.declarationCoverage&&Ce(ze.declarationCoverage),testId:ze instanceof P.$dO&&ze.testItem?T.$hL.fromExtHostTestItem(ze.testItem,Fe).toString():void 0}}ke.fromFile=Te})(Rt||(e.TestCoverage=Rt={}));var Lt;(function(ke){function Ce($e){switch($e){case b.CodeActionTriggerType.Invoke:return P.CodeActionTriggerKind.Invoke;case b.CodeActionTriggerType.Auto:return P.CodeActionTriggerKind.Automatic}}ke.to=Ce})(Lt||(e.CodeActionTriggerKind=Lt={}));var Vt;(function(ke){function Ce(J){const Te=new P.$hO(K.to(J.kind),J.name,J.detail||"",c.URI.revive(J.uri),X.to(J.range),X.to(J.selectionRange));return Te._sessionId=J._sessionId,Te._itemId=J._itemId,Te}ke.to=Ce;function $e(J,Te,Fe){if(Te=Te??J._sessionId,Fe=Fe??J._itemId,Te===void 0||Fe===void 0)throw new Error("invalid item");return{_sessionId:Te,_itemId:Fe,kind:K.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:X.from(J.range),selectionRange:X.from(J.selectionRange),tags:J.tags?.map(Z.from)}}ke.from=$e})(Vt||(e.TypeHierarchyItem=Vt={}));var Kt;(function(ke){function Ce($e){if($e)return{value:$e.value,tooltip:$e.tooltip}}ke.from=Ce})(Kt||(e.ViewBadge=Kt={}));var Et;(function(ke){function Ce(Fe,Ke,ze){const it=Ke.fileData;return it?new P.$oN(new P.$pN(it.name,c.URI.revive(it.uri),it.id,(0,k.$db)(()=>ze(it.id)))):Fe===E.$Zs.uriList&&Ke.uriListData?new P.$nN(Te(Ke.uriListData)):new P.$nN(Ke.asString)}ke.to=Ce;async function $e(Fe,Ke){const ze=await Ke.asString();if(Fe===E.$Zs.uriList)return{asString:ze,fileData:void 0,uriListData:J(ze)};const it=Ke.asFile();return{asString:ze,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}ke.from=$e;function J(Fe){return S.$at.split(Fe).map(Ke=>{if(Ke.startsWith("#"))return Ke;try{return c.URI.parse(Ke)}catch{}return Ke})}function Te(Fe){return S.$at.create(Fe.map(Ke=>typeof Ke=="string"?Ke:c.URI.revive(Ke)))}})(Et||(e.DataTransferItem=Et={}));var At;(function(ke){function Ce(J,Te){const Fe=J.items.map(([Ke,ze])=>[Ke,Et.to(Ke,ze,Te)]);return new P.$qN(Fe)}ke.toDataTransfer=Ce;async function $e(J){const Te={items:[]},Fe=[];for(const[Ke,ze]of J)Fe.push((async()=>{Te.items.push([Ke,await Et.from(Ke,ze)])})());return await Promise.all(Fe),Te}ke.from=$e})(At||(e.DataTransfer=At={}));var Ut;(function(ke){function Ce(J,Te){return{kind:"reply",agentId:J.participant??Te?.agentId??"",subCommand:J.command??Te?.command,message:J.prompt,title:J.label}}ke.from=Ce;function $e(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}ke.to=$e})(Ut||(e.ChatFollowup=Ut={}));var Nt;(function(ke){function Ce(J){switch(J.role){case u.ChatMessageRole.System:return new P.$IO(P.LanguageModelChatMessageRole.System,J.content);case u.ChatMessageRole.User:return new P.$IO(P.LanguageModelChatMessageRole.User,J.content);case u.ChatMessageRole.Assistant:return new P.$IO(P.LanguageModelChatMessageRole.Assistant,J.content)}}ke.to=Ce;function $e(J){switch(J.role){case P.LanguageModelChatMessageRole.System:return{role:u.ChatMessageRole.System,content:J.content};case P.LanguageModelChatMessageRole.User:return{role:u.ChatMessageRole.User,content:J.content};case P.LanguageModelChatMessageRole.Assistant:return{role:u.ChatMessageRole.Assistant,content:J.content}}}ke.from=$e})(Nt||(e.LanguageModelChatMessage=Nt={}));var Qt;(function(ke){function Ce(J){return{kind:"markdownContent",content:pe.from(J.value)}}ke.from=Ce;function $e(J){return new P.$uO(pe.to(J.content))}ke.to=$e})(Qt||(e.ChatResponseMarkdownPart=Qt={}));var Zt;(function(ke){function Ce(J){return{kind:"markdownVuln",content:pe.from(J.value),vulnerabilities:J.vulnerabilities}}ke.from=Ce;function $e(J){return new P.$vO(pe.to(J.content),J.vulnerabilities)}ke.to=$e})(Zt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Zt={}));var Xt;(function(ke){function Ce(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}ke.from=Ce;function $e(J){return new P.$wO(J.agentId,J.command)}ke.to=$e})(Xt||(e.ChatResponseDetectedParticipantPart=Xt={}));var Tt;(function(ke){function Ce($e){return{kind:"confirmation",title:$e.title,message:$e.message,data:$e.data}}ke.from=Ce})(Tt||(e.ChatResponseConfirmationPart=Tt={}));var Yt;(function(ke){function Ce(J){const{value:Te,baseUri:Fe}=J;function Ke(ze,it){return ze.map(dt=>{const jt=c.URI.joinPath(it,dt.name);return{label:dt.name,uri:jt,children:dt.children&&Ke(dt.children,jt)}})}return{kind:"treeData",treeData:{label:(0,w.$$g)(Fe),uri:Fe,children:Ke(Te,Fe)}}}ke.from=Ce;function $e(J){const Te=(0,s.$0h)(J.treeData);function Fe(it){return it.map(dt=>({name:dt.label,children:dt.children&&Fe(dt.children)}))}const Ke=Te.uri,ze=Te.children?Fe(Te.children):[];return new P.$yO(ze,Ke)}ke.to=$e})(Yt||(e.ChatResponseFilesPart=Yt={}));var St;(function(ke){function Ce(J){const Te=Fe=>c.URI.isUri(Fe);return{kind:"inlineReference",name:J.title,inlineReference:Te(J.value)?J.value:ie.from(J.value)}}ke.from=Ce;function $e(J){const Te=(0,s.$0h)(J);return new P.$zO(c.URI.isUri(Te.inlineReference)?Te.inlineReference:ie.to(Te.inlineReference),J.name)}ke.to=$e})(St||(e.ChatResponseAnchorPart=St={}));var Ft;(function(ke){function Ce(J){return{kind:"progressMessage",content:pe.from(J.value)}}ke.from=Ce;function $e(J){return new P.$AO(J.content.value)}ke.to=$e})(Ft||(e.ChatResponseProgressPart=Ft={}));var wt;(function(ke){function Ce(J){return{kind:"warning",content:pe.from(J.value)}}ke.from=Ce;function $e(J){return new P.$CO(J.content.value)}ke.to=$e})(wt||(e.ChatResponseWarningPart=wt={}));var zt;(function(ke){function Ce($e){return{kind:"progressTask",content:pe.from($e.value)}}ke.from=Ce})(zt||(e.ChatTask=zt={}));var Gt;(function(ke){function Ce($e){return{kind:"progressTaskResult",content:typeof $e=="string"?pe.from($e):void 0}}ke.from=Ce})(Gt||(e.ChatTaskResult=Gt={}));var Mt;(function(ke){function Ce(J,Te,Fe){return{kind:"command",command:Te.toInternal(J.value,Fe)??{command:J.value.command,title:J.value.title}}}ke.from=Ce;function $e(J,Te){return new P.$DO(Te.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}ke.to=$e})(Mt||(e.ChatResponseCommandButtonPart=Mt={}));var sn;(function(ke){function Ce(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Te=>B.from(Te))}}ke.from=Ce;function $e(J){return new P.$FO(c.URI.revive(J.uri),J.edits.map(Te=>B.to(Te)))}ke.to=$e})(sn||(e.ChatResponseTextEditPart=sn={}));var hn;(function(ke){function Ce(J){const Te=a.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:c.URI.isUri(J.iconPath)?{light:c.URI.revive(J.iconPath)}:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&c.URI.isUri(J.iconPath.light)&&c.URI.isUri(J.iconPath.dark)?{light:c.URI.revive(J.iconPath.light),dark:c.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:c.URI.isUri(J.value.value)||!J.value.value?J.value.value:ie.from(J.value.value)},iconPath:Te}:{kind:"reference",reference:c.URI.isUri(J.value)?J.value:ie.from(J.value),iconPath:Te}}ke.from=Ce;function $e(J){const Te=(0,s.$0h)(J),Fe=Ke=>c.URI.isUri(Ke)?Ke:ie.to(Ke);return new P.$EO("variableName"in Te.reference?{variableName:Te.reference.variableName,value:Te.reference.value&&Fe(Te.reference.value)}:Fe(Te.reference))}ke.to=$e})(hn||(e.ChatResponseReferencePart=hn={}));var fn;(function(ke){function Ce(Te,Fe,Ke){return Te instanceof P.$uO?Qt.from(Te):Te instanceof P.$zO?St.from(Te):Te instanceof P.$EO?hn.from(Te):Te instanceof P.$AO?Ft.from(Te):Te instanceof P.$yO?Yt.from(Te):Te instanceof P.$DO?Mt.from(Te,Fe,Ke):Te instanceof P.$FO?sn.from(Te):Te instanceof P.$vO?Zt.from(Te):Te instanceof P.$wO?Xt.from(Te):Te instanceof P.$CO?wt.from(Te):{kind:"markdownContent",content:pe.from("")}}ke.from=Ce;function $e(Te,Fe){switch(Te.kind){case"reference":return hn.to(Te);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Te,Fe)}}ke.to=$e;function J(Te,Fe){switch(Te.kind){case"markdownContent":return Qt.to(Te);case"inlineReference":return St.to(Te);case"progressMessage":return;case"treeData":return Yt.to(Te);case"command":return Mt.to(Te,Fe)}}ke.toContent=J})(fn||(e.ChatResponsePart=fn={}));var on;(function(ke){function Ce($e){return{prompt:$e.message,command:$e.command,attempt:$e.attempt??0,enableCommandDetection:$e.enableCommandDetection??!0,references:$e.variables.variables.map(ln.to),location:an.to($e.location),acceptedConfirmationData:$e.acceptedConfirmationData,rejectedConfirmationData:$e.rejectedConfirmationData}}ke.to=Ce})(on||(e.ChatAgentRequest=on={}));var an;(function(ke){function Ce(J){switch(J){case h.ChatAgentLocation.Notebook:return P.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return P.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return P.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return P.ChatLocation.Editor}}ke.to=Ce;function $e(J){switch(J){case P.ChatLocation.Notebook:return h.ChatAgentLocation.Notebook;case P.ChatLocation.Terminal:return h.ChatAgentLocation.Terminal;case P.ChatLocation.Panel:return h.ChatAgentLocation.Panel;case P.ChatLocation.Editor:return h.ChatAgentLocation.Editor}}ke.from=$e})(an||(e.ChatLocation=an={}));var ln;(function(ke){function Ce($e){const J=$e.value;if(!J)throw new Error("Invalid value reference");return{id:$e.id,name:$e.name,range:$e.range&&[$e.range.start,$e.range.endExclusive],value:(0,c.$vc)(J)?c.URI.revive(J):J&&typeof J=="object"&&"uri"in J&&"range"in J&&(0,c.$vc)(J.uri)?ie.to((0,s.$0h)(J)):J,modelDescription:$e.modelDescription}}ke.to=Ce})(ln||(e.ChatAgentValueReference=ln={}));var $n;(function(ke){function Ce($e,J,Te){return{id:$e.id,label:$e.label,fullName:$e.fullName,icon:$e.icon?.id,value:$e.values[0].value,insertText:$e.insertText,detail:$e.detail,documentation:$e.documentation,command:J.toInternal($e.command,Te)}}ke.from=Ce})($n||(e.ChatAgentCompletionItem=$n={}));var pn;(function(ke){function Ce($e){return{errorDetails:$e.errorDetails,metadata:$e.metadata}}ke.to=Ce})(pn||(e.ChatAgentResult=pn={}));var vn;(function(ke){function Ce($e,J,Te){if(J.action.kind==="vote")return;const Fe=pn.to($e);if(J.action.kind==="command"){const Ke=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Te.fromInternal(Ke)??{command:Ke.id,title:Ke.title}}},result:Fe}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:Ut.to(J.action.followup)},result:Fe}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Fe}:{action:J.action,result:Fe}}ke.to=Ce})(vn||(e.ChatAgentUserActionEvent=vn={}));var dn;(function(ke){function Ce($e,J,Te){return"terminalCommand"in $e?{terminalCommand:$e.terminalCommand,shouldExecute:$e.shouldExecute}:"uri"in $e?{uri:$e.uri}:J.toInternal($e,Te)}ke.from=Ce})(dn||(e.TerminalQuickFix=dn={}));var mn;(function(ke){function Ce($e){return{kind:gn.to($e.kind)}}ke.to=Ce})(mn||(e.PartialAcceptInfo=mn={}));var gn;(function(ke){function Ce($e){switch($e){case b.PartialAcceptTriggerKind.Word:return P.PartialAcceptTriggerKind.Word;case b.PartialAcceptTriggerKind.Line:return P.PartialAcceptTriggerKind.Line;case b.PartialAcceptTriggerKind.Suggest:return P.PartialAcceptTriggerKind.Suggest;default:return P.PartialAcceptTriggerKind.Unknown}}ke.to=Ce})(gn||(e.PartialAcceptTriggerKind=gn={}));var _t;(function(ke){function Ce($e,J){return{id:J,label:$e.label,description:$e.description,canEdit:$e.canEdit,collapsibleState:$e.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:$e.contextValue}}ke.from=Ce})(_t||(e.DebugTreeItem=_t={}))}),define(Se[322],De([1,0,50,147,75,146,104,153,4]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.$bP=e.$aP=e.$_O=void 0;const s=(m,b,l,t)=>{let o=b;return{enumerable:!0,configurable:!1,get(){return o},set(d){if(!l(o,d)){const i=o;o=d,m.listener?.(t(d,i))}}}},E=(m,b)=>m===b,y={range:(m,b)=>m===b?!0:!m||!b?!1:m.isEqual(b),label:E,description:E,sortText:E,busy:E,error:E,canResolveChildren:E,tags:(m,b)=>!(m.length!==b.length||m.some(l=>!b.find(t=>l.id===t.id)))},$=m=>b=>({op:k.TestItemEventOp.SetProp,update:m(b)}),w=(m,b)=>({range:(()=>{let l;const t=$(o=>({range:n.$dt.lift(A.Range.from(o))}));return{enumerable:!0,configurable:!1,get(){return l},set(o){m.listener?.({op:k.TestItemEventOp.DocumentSynced}),y.range(l,o)||(l=o,m.listener?.(t(o)))}}})(),label:s(m,b,y.label,$(l=>({label:l}))),description:s(m,void 0,y.description,$(l=>({description:l}))),sortText:s(m,void 0,y.sortText,$(l=>({sortText:l}))),canResolveChildren:s(m,!1,y.canResolveChildren,l=>({op:k.TestItemEventOp.UpdateCanResolveChildren,state:l})),busy:s(m,!1,y.busy,$(l=>({busy:l}))),error:s(m,void 0,y.error,$(l=>({error:A.MarkdownString.fromStrict(l)||null}))),tags:s(m,[],y.tags,(l,t)=>({op:k.TestItemEventOp.SetTags,new:l.map(A.TestTag.from),old:t.map(A.TestTag.from)}))}),a=m=>{const b=S.$hL.fromString(m.extId),l=new c(b.controllerId,b.localId,m.label,v.URI.revive(m.uri)||void 0);return l.range=A.Range.to(m.range||void 0),l.description=m.description||void 0,l.sortText=m.sortText||void 0,l.tags=m.tags.map(t=>A.TestTag.to({id:(0,R.$nL)(t).tagId})),l},f=m=>{let b;for(const l of m.tests){const t=a(l.item);(0,r.$VO)(t).parent=b,b=t}return b};e.$_O=f;class c{constructor(b,l,t,o){if(l.includes(S.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(l)} symbol`);const d=(0,r.$UO)(this,b);Object.defineProperties(this,{id:{value:l,enumerable:!0,writable:!1},uri:{value:o,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof g?void 0:d.parent}},children:{value:(0,k.$TO)(d,r.$VO,c),enumerable:!0,writable:!1},...w(d,t)})}}e.$aP=c;class g extends c{constructor(b,l){super(b,b,l,void 0),this._isRoot=!0}}e.$bP=g;class p extends k.$PO{constructor(b,l,t){super({controllerId:b,getDocumentVersion:o=>o&&t.getDocument(o)?.version,getApiFor:r.$VO,getChildren:o=>o.children,root:new g(b,l),toITestItem:A.TestItem.from})}}e.$cP=p});var rn=this&&this.__classPrivateFieldSet||function(he,e,n,r,S){if(r==="m")throw new TypeError("Private method is not writable");if(r==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?he!==e||!S:!e.has(he))throw new TypeError("Cannot write private member to an object whose class did not declare it");return r==="a"?S.call(he,n):S?S.value=n:e.set(he,n),n},ut=this&&this.__classPrivateFieldGet||function(he,e,n,r){if(n==="a"&&!r)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?he!==e||!r:!e.has(he))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?r:n==="a"?r.call(he):r?r.value:e.get(he)};define(Se[323],De([1,0,11,152,153,21,320,18,12,48,50,85,4,2,5,299,322,15,150,42,55,41,313,22]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m,b,l,t,o){"use strict";var d,i,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=void 0;let u=class{constructor(P,Q,X){d.set(this,void 0),this.b=new Map,this.c=new Map,i.set(this,void 0),h.set(this,void 0),rn(this,d,P.getProxy(R.$vM.MainThreadCommands),"f"),this.d=Q,rn(this,h,X,"f"),rn(this,i,P.getProxy(R.$vM.MainThreadTelemetry),"f"),this.converter=new D(this,ie=>{const ne=this.c.get(ie);return ne?.result===T.Void?ne:void 0},Q),this.f=[{processArgument(ie){return(0,s.$0h)(ie)}},{processArgument(ie){return(0,k.$_n)(ie,function(ne){if(E.$dt.isIRange(ne))return S.Range.to(ne);if(y.$ct.isIPosition(ne))return S.Position.to(ne);if(E.$dt.isIRange(ne.range)&&$.URI.isUri(ne.uri))return S.location.to(ne);if(ne instanceof g.$Je)return ne.buffer.buffer;if(!Array.isArray(ne))return ne})}}]}registerArgumentProcessor(P){this.f.push(P)}registerApiCommand(P){const Q=this.registerCommand(!1,P.id,async(...X)=>{const ie=P.args.map((x,re)=>{if(!x.validate(X[re]))throw new Error(`Invalid argument '${x.name}' when running '${P.id}', received: ${typeof X[re]=="object"?JSON.stringify(X[re],null,"	"):X[re]} `);return x.convert(X[re])}),ne=await this.executeCommand(P.internalId,...ie);return P.result.convert(ne,X,this.converter)},void 0,{description:P.description,args:P.args,returns:P.result.description});return this.c.set(P.id,P),new r.$xM(()=>{Q.dispose(),this.c.delete(P.id)})}registerCommand(P,Q,X,ie,ne,x){if(this.d.trace("ExtHostCommands#registerCommand",Q),!Q.trim().length)throw new Error("invalid id");if(this.b.has(Q))throw new Error(`command '${Q}' already exists`);return this.b.set(Q,{callback:X,thisArg:ie,metadata:ne,extension:x}),P&&ut(this,d,"f").$registerCommand(Q),new r.$xM(()=>{this.b.delete(Q)&&P&&ut(this,d,"f").$unregisterCommand(Q)})}executeCommand(P,...Q){return this.d.trace("ExtHostCommands#executeCommand",P),this.g(P,Q,!0)}async g(P,Q,X){if(this.b.has(P))return ut(this,d,"f").$fireCommandActivationEvent(P),this.h(P,Q,!1);{let ie=!1;const ne=(0,k.$_n)(Q,function(x){if(x instanceof r.$yM)return S.Position.from(x);if(x instanceof r.$zM)return S.Range.from(x);if(x instanceof r.$JM)return S.location.from(x);if(r.$ZN.isNotebookRange(x))return S.NotebookRange.from(x);if(x instanceof ArrayBuffer)return ie=!0,g.$Je.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return ie=!0,g.$Je.wrap(x);if(x instanceof g.$Je)return ie=!0,x;if(!Array.isArray(x))return x});try{const x=await ut(this,d,"f").$executeCommand(P,ie?new p.$Lw(ne):ne,X);return(0,s.$0h)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this.g(P,Q,!1);throw x}}}async h(P,Q,X){const ie=this.b.get(P);if(!ie)throw new Error("Unknown command");const{callback:ne,thisArg:x,metadata:re}=ie;if(re?.args)for(let te=0;te<re.args.length;te++)try{(0,n.$rg)(Q[te],re.args[te].constraint)}catch{throw new Error(`Running the contributed command: '${P}' failed. Illegal argument '${re.args[te].name}' - ${re.args[te].description}`)}const q=b.$be.create();try{return await ne.apply(x,Q)}catch(te){if(P===this.converter.delegatingCommandId){const le=this.converter.getActualCommand(...Q);le&&(P=le.command)}if(this.d.error(te,P,ie.extension?.identifier),!X)throw te;if(ie.extension?.identifier){const le=ut(this,h,"f").onExtensionError(ie.extension.identifier,te);this.d.trace("forwarded error to extension?",le,ie.extension?.identifier)}throw new class extends Error{constructor(){super((0,m.$lj)(te)),this.id=P,this.source=ie.extension?.displayName??ie.extension?.name}}}finally{this.j(ie,P,q.elapsed())}}j(P,Q,X){P.extension&&ut(this,i,"f").$publicLog2("Extension:ActionExecuted",{extensionId:P.extension.identifier.value,id:new l.$op(Q),duration:X})}$executeContributedCommand(P,...Q){this.d.trace("ExtHostCommands#$executeContributedCommand",P);const X=this.b.get(P);return X?(Q=Q.map(ie=>this.f.reduce((ne,x)=>x.processArgument(ne,X.extension?.identifier),ie)),this.h(P,Q,!0)):Promise.reject(new Error(`Contributed command '${P}' does not exist.`))}getCommands(P=!1){return this.d.trace("ExtHostCommands#getCommands",P),ut(this,d,"f").$getCommands().then(Q=>(P&&(Q=Q.filter(X=>X[0]!=="_")),Q))}$getContributedCommandMetadata(){const P=Object.create(null);for(const[Q,X]of this.b){const{metadata:ie}=X;ie&&(P[Q]=ie)}return Promise.resolve(P)}};e.$iP=u,d=new WeakMap,i=new WeakMap,h=new WeakMap,e.$iP=u=Ue([Ne(0,f.$ZO),Ne(1,v.$7j),Ne(2,t.$hP)],u),e.$jP=(0,a.$Ai)("IExtHostCommands");class D{constructor(P,Q,X){this.d=P,this.f=Q,this.g=X,this.delegatingCommandId=`__vsc${(0,o.$Wg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(P,Q){if(!P)return;const X={$ident:void 0,id:P.command,title:P.title,tooltip:P.tooltip};if(!P.command)return X;const ie=this.f(P.command);if(ie)X.id=ie.internalId,X.arguments=ie.args.map((ne,x)=>ne.convert(P.arguments&&P.arguments[x]));else if((0,A.$Lb)(P.arguments)){const ne=`${P.command} /${++this.c}`;this.b.set(ne,P),Q.add((0,w.$Sc)(()=>{this.b.delete(ne),this.g.trace("CommandsConverter#DISPOSE",ne)})),X.$ident=ne,X.id=this.delegatingCommandId,X.arguments=[ne],this.g.trace("CommandsConverter#CREATE",P.command,ne)}return X}fromInternal(P){return typeof P.$ident=="string"?this.b.get(P.$ident):{command:P.id,title:P.title,arguments:P.arguments}}getActualCommand(...P){return this.b.get(P[0])}h(...P){const Q=this.getActualCommand(...P);return this.g.trace("CommandsConverter#EXECUTE",P[0],Q?Q.command:"MISSING"),Q?this.d.executeCommand(Q.command,...Q.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${P[0]}`)}}e.$kP=D;class I{static Arr(P){return new I(`${P.name}_array`,`Array of ${P.name}, ${P.description}`,Q=>Array.isArray(Q)&&Q.every(X=>P.validate(X)),Q=>Q.map(X=>P.convert(X)))}constructor(P,Q,X,ie){this.name=P,this.description=Q,this.validate=X,this.convert=ie}optional(){return new I(this.name,`(optional) ${this.description}`,P=>P==null||this.validate(P),P=>P===void 0?void 0:P===null?null:this.convert(P))}with(P,Q){return new I(P??this.name,Q??this.description,this.validate,this.convert)}}e.$lP=I,I.Uri=new I("uri","Uri of a text document",C=>$.URI.isUri(C),C=>C),I.Position=new I("position","A position in a text document",C=>r.$yM.isPosition(C),S.Position.from),I.Range=new I("range","A range in a text document",C=>r.$zM.isRange(C),S.Range.from),I.Selection=new I("selection","A selection in a text document",C=>r.$AM.isSelection(C),S.Selection.from),I.Number=new I("number","",C=>typeof C=="number",C=>C),I.String=new I("string","",C=>typeof C=="string",C=>C),I.StringArray=I.Arr(I.String),I.CallHierarchyItem=new I("item","A call hierarchy item",C=>C instanceof r.$VM,S.CallHierarchyItem.from),I.TypeHierarchyItem=new I("item","A type hierarchy item",C=>C instanceof r.$hO,S.TypeHierarchyItem.from),I.TestItem=new I("testItem","A VS Code TestItem",C=>C instanceof c.$aP,S.TestItem.from);class T{constructor(P,Q){this.description=P,this.convert=Q}}e.$mP=T,T.Void=new T("no result",C=>C);class O{constructor(P,Q,X,ie,ne){this.id=P,this.internalId=Q,this.description=X,this.args=ie,this.result=ne}}e.$nP=O}),define(Se[324],De([1,0,10,2,13,3,249]),function(he,e,n,r,S,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=e.$0P=void 0,e.$0P="remoteFilesystem";class A extends R.$9P{static register(s,E,y){const $=s.getConnection();if(!$)return r.$Uc.None;const w=new r.$Tc,a=(async()=>{try{const f=await s.getRawEnvironment();f?E.registerProvider(S.Schemas.vscodeRemote,w.add(new A(f,$))):y.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(f){y.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,n.$0)(f))}})();return w.add(E.onWillActivateFileSystemProvider(f=>{f.scheme===S.Schemas.vscodeRemote&&f.join(a)})),w}constructor(s,E){super(E.getChannel(e.$0P),{pathCaseSensitive:s.os===k.OperatingSystem.Linux})}}e.$$P=A}),define(Se[76],De([1,0,96,84,32,325,15,10,6,2,9,3,22,49,61]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ri=e.$qi=e.$pi=void 0,e.$si=d,e.$ti=i,e.$vi=D,e.$wi=I;class f{traceSocketEvent(O,C){a.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,O,C)}constructor(O,C=""){this.f=!0,this.debugLabel=C,this.socket=O,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent(a.SocketDiagnosticsEventType.Error,{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,A.$1)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Close,{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(O){const C=P=>{this.traceSocketEvent(a.SocketDiagnosticsEventType.Read,P),O(R.$Je.wrap(P))};return this.socket.on("data",C),{dispose:()=>this.socket.off("data",C)}}onClose(O){const C=P=>{O({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:P,error:void 0})};return this.socket.on("close",C),{dispose:()=>this.socket.off("close",C)}}onEnd(O){const C=()=>{O()};return this.socket.on("end",C),{dispose:()=>this.socket.off("end",C)}}write(O){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(a.SocketDiagnosticsEventType.Write,O),this.socket.write(O.buffer,C=>{if(C){if(C.code==="EPIPE")return;(0,A.$1)(C)}})}catch(C){if(C.code==="EPIPE")return;(0,A.$1)(C)}}end(){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((O,C)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),O();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent(a.SocketDiagnosticsEventType.NodeDrainEnd),O()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$pi=f;var c;(function(T){T[T.MinHeaderByteSize=2]="MinHeaderByteSize",T[T.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var g;(function(T){T[T.PeekHeader=1]="PeekHeader",T[T.ReadHeader=2]="ReadHeader",T[T.ReadBody=3]="ReadBody",T[T.Fin=4]="Fin"})(g||(g={}));class p extends s.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(O,C){this.socket.traceSocketEvent(O,C)}constructor(O,C,P,Q){super(),this.f=this.B(new v.$he),this.g=this.B(new v.$he),this.h=!1,this.j={state:g.PeekHeader,readLen:c.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=O,this.traceSocketEvent(a.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:C,inflateBytesLength:P?.byteLength||0,recordInflateBytes:Q}),this.a=this.B(new m(this,C,P,Q,this.f,(X,ie)=>this.m(X,ie))),this.B(this.a.onError(X=>{console.error(X),(0,A.$1)(X),this.g.fire({type:a.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:X})})),this.b=new a.$ki,this.B(this.socket.onData(X=>this.n(X))),this.B(this.socket.onClose(async X=>{this.a.isProcessingReadQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(X)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(O){return this.f.event(O)}onClose(O){return this.g.event(O)}onEnd(O){return this.socket.onEnd(O)}write(O){let C=0;for(;C<O.byteLength;)this.a.writeMessage(O.slice(C,Math.min(C+c.MaxWebSocketMessageLength,O.byteLength)),{compressed:!0,opcode:2}),C+=c.MaxWebSocketMessageLength}m(O,{compressed:C,opcode:P}){if(this.h)return;this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,O);let Q=c.MinHeaderByteSize;O.byteLength<126?Q+=0:O.byteLength<2**16?Q+=2:Q+=8;const X=R.$Je.alloc(Q),ie=C?64:0,ne=P&15;if(X.writeUInt8(128|ie|ne,0),O.byteLength<126)X.writeUInt8(O.byteLength,1);else if(O.byteLength<2**16){X.writeUInt8(126,1);let x=1;X.writeUInt8(O.byteLength>>>8&255,++x),X.writeUInt8(O.byteLength>>>0&255,++x)}else{X.writeUInt8(127,1);let x=1;X.writeUInt8(0,++x),X.writeUInt8(0,++x),X.writeUInt8(0,++x),X.writeUInt8(0,++x),X.writeUInt8(O.byteLength>>>24&255,++x),X.writeUInt8(O.byteLength>>>16&255,++x),X.writeUInt8(O.byteLength>>>8&255,++x),X.writeUInt8(O.byteLength>>>0&255,++x)}this.socket.write(R.$Je.concat([X,O]))}end(){this.h=!0,this.socket.end()}n(O){if(O.byteLength!==0){for(this.b.acceptChunk(O);this.b.byteLength>=this.j.readLen;)if(this.j.state===g.PeekHeader){const C=this.b.peek(this.j.readLen),P=C.readUInt8(0),Q=(P&128)>>>7,X=(P&64)>>>6,ie=P&15,ne=C.readUInt8(1),x=(ne&128)>>>7,re=ne&127;this.j.state=g.ReadHeader,this.j.readLen=c.MinHeaderByteSize+(x?4:0)+(re===126?2:0)+(re===127?8:0),this.j.fin=Q,this.j.firstFrameOfMessage&&(this.j.compressed=!!X),this.j.firstFrameOfMessage=!!Q,this.j.mask=0,this.j.opcode=ie,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===g.ReadHeader){const C=this.b.read(this.j.readLen),P=C.readUInt8(1),Q=(P&128)>>>7;let X=P&127,ie=1;X===126?X=C.readUInt8(++ie)*2**8+C.readUInt8(++ie):X===127&&(X=C.readUInt8(++ie)*0+C.readUInt8(++ie)*0+C.readUInt8(++ie)*0+C.readUInt8(++ie)*0+C.readUInt8(++ie)*2**24+C.readUInt8(++ie)*2**16+C.readUInt8(++ie)*2**8+C.readUInt8(++ie));let ne=0;Q&&(ne=C.readUInt8(++ie)*2**24+C.readUInt8(++ie)*2**16+C.readUInt8(++ie)*2**8+C.readUInt8(++ie)),this.j.state=g.ReadBody,this.j.readLen=X,this.j.mask=ne,this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===g.ReadBody){const C=this.b.read(this.j.readLen);this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,C),t(C,this.j.mask),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,C),this.j.state=g.PeekHeader,this.j.readLen=c.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(C,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(C,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await v.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(a.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$qi=p;class m extends s.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Je.alloc(0)}constructor(O,C,P,Q,X,ie){super(),this.n=O,this.r=X,this.s=ie,this.a=this.B(new v.$he),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new v.$he),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new v.$he),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,C?(this.b=this.B(new b(this.n,Q,P,{windowBits:15})),this.f=this.B(new l(this.n,{windowBits:15})),this.B(this.b.onError(ne=>this.a.fire(ne))),this.B(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(O,C){this.g.push({data:O,options:C}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:O,options:C}=this.g.shift();if(this.f&&C.compressed){const P=await this.w(this.f,O);this.s(P,C)}else this.s(O,{...C,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(O,C){return new Promise((P,Q)=>{O.write(C),O.flush(X=>P(X))})}acceptFrame(O,C,P){this.h.push({data:O,isCompressed:C,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const O=this.h.shift();if(this.b&&O.isCompressed){const C=await this.C(this.b,O.data,O.isLastFrameOfMessage);this.r.fire(C)}else this.r.fire(O.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(O,C,P){return new Promise((Q,X)=>{O.write(C),P&&O.write(R.$Je.fromByteArray([0,0,255,255])),O.flush(ie=>Q(ie))})}}class b extends s.$Uc{get recordedInflateBytes(){return this.j?R.$Je.concat(this.f):R.$Je.alloc(0)}constructor(O,C,P,Q){super(),this.h=O,this.j=C,this.a=this.B(new v.$he),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,k.createInflateRaw)(Q),this.b.on("error",X=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateError,{message:X?.message,code:X?.code}),this.a.fire(X)}),this.b.on("data",X=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateData,X),this.g.push(R.$Je.wrap(X))}),P&&(this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialWrite,P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(O){this.j&&this.f.push(O.clone()),this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateWrite,O),this.b.write(O.buffer)}flush(O){this.b.flush(()=>{this.h.traceSocketEvent(a.SocketDiagnosticsEventType.zlibInflateFlushFired);const C=R.$Je.concat(this.g);this.g.length=0,O(C)})}}class l extends s.$Uc{constructor(O,C){super(),this.g=O,this.a=this.B(new v.$he),this.onError=this.a.event,this.f=[],this.b=(0,k.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateError,{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateData,P),this.f.push(R.$Je.wrap(P))})}write(O){this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateWrite,O.buffer),this.b.write(O.buffer)}flush(O){this.b.flush(2,()=>{this.g.traceSocketEvent(a.SocketDiagnosticsEventType.zlibDeflateFlushFired);let C=R.$Je.concat(this.f);this.f.length=0,C=C.slice(0,C.byteLength-4),O(C)})}}function t(T,O){if(O===0)return;const C=T.byteLength>>>2;for(let x=0;x<C;x++){const re=T.readUInt32BE(x*4);T.writeUInt32BE(re^O,x*4)}const P=C*4,Q=T.byteLength-P,X=O>>>24&255,ie=O>>>16&255,ne=O>>>8&255;Q>=1&&T.writeUInt8(T.readUInt8(P)^X,P),Q>=2&&T.writeUInt8(T.readUInt8(P+1)^ie,P+1),Q>=3&&T.writeUInt8(T.readUInt8(P+2)^ne,P+2)}e.$ri=process.env.XDG_RUNTIME_DIR;const o={[y.Platform.Linux]:107,[y.Platform.Mac]:103};function d(){const T=(0,$.$Wg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${T}-sock`;const O=process.platform!=="darwin"&&e.$ri?e.$ri:(0,S.tmpdir)(),C=(0,E.$jc)(O,`vscode-ipc-${T}.sock`);return h(C),C}function i(T,O,C){const Q=(0,n.createHash)("sha256").update(T).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${Q}-${C}-${O}-sock`;const X=C.substr(0,4),ie=O.substr(0,6);let ne;return process.platform!=="darwin"&&e.$ri&&!process.env.VSCODE_PORTABLE?ne=(0,E.$jc)(e.$ri,`vscode-${Q}-${X}-${ie}.sock`):ne=(0,E.$jc)(T,`${X}-${ie}.sock`),h(ne),ne}function h(T){const O=o[y.$o];typeof O=="number"&&T.length>=O&&console.warn(`WARNING: IPC handle "${T}" is longer than ${O} chars, try a shorter --user-data-dir`)}class u extends w.$ei{static b(O){const C=v.Event.fromNodeEventEmitter(O,"connection");return v.Event.map(C,P=>({protocol:new a.$li(new f(P,"ipc-server-connection")),onDidClientDisconnect:v.Event.once(v.Event.fromNodeEventEmitter(P,"close"))}))}constructor(O){super(u.b(O)),this.d=O}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ui=u;function D(T){return new Promise((O,C)=>{const P=(0,r.createServer)();P.on("error",C),P.listen(T,()=>{P.removeListener("error",C),O(new u(P))})})}function I(T,O){return new Promise((C,P)=>{const Q=(0,r.createConnection)(T,()=>{Q.removeListener("error",P),C(a.$mi.fromSocket(new f(Q,`ipc-client${O}`),O))});Q.once("error",P)})}}),define(Se[154],De([1,0,93,14,15,10,11,27,28,94,12,47,268,325]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7r=void 0,e.$8r=c;let a=class extends y.$Xp{constructor(p,m,b,l){super(l),this.m=p,this.n=m,this.r=b,this.s(),this.B(p.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const p=this.m.getValue("http");this.f=p?.proxy,this.g=!!p?.proxyStrictSSL,this.h=p?.proxyAuthorization}async request(p,m){const{f:b,g:l}=this;let t;try{t=await(0,s.$Mm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$0)(i)))}const o={...process.env,...t},d=p.agent?p.agent:await(0,$.$6r)(p.url||"",o,{proxyUrl:b,strictSSL:l});return p.agent=d,p.strictSSL=l,this.h&&(p.headers={...p.headers||{},"Proxy-Authorization":this.h}),this.c(p.isChromiumNetwork?"electron":"node",p,()=>c(p,m))}async resolveProxy(p){}async loadCertificates(){return(await new Promise((m,b)=>{he(["@vscode/proxy-agent"],m,b)})).loadSystemCertificates({log:this.r})}};e.$7r=a,e.$7r=a=Ue([Ne(0,A.$7i),Ne(1,v.$Ii),Ne(2,E.$7j),Ne(3,E.$8j)],a);async function f(g){return((0,n.parse)(g.url).protocol==="https:"?await new Promise((b,l)=>{he(["https"],b,l)}):await new Promise((b,l)=>{he(["http"],b,l)})).request}async function c(g,p){return r.Promises.withAsyncBody(async(m,b)=>{const l=(0,n.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await f(g),o={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,R.$gg)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(o.auth=g.user+":"+g.password);const d=t(o,i=>{const h=(0,R.$eg)(g.followRedirects)?g.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&h>0&&i.headers.location)c({...g,url:i.headers.location,followRedirects:h-1},p).then(m,b);else{let u=i;!g.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(u=i.pipe((0,w.createGunzip)())),m({res:i,stream:(0,S.$Ye)(u)})}});d.on("error",b),g.timeout&&d.setTimeout(g.timeout),g.isChromiumNetwork&&d.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&d.write(g.data),d.end(),p.onCancellationRequested(()=>{d.abort(),b(new k.$5)})})}}),define(Se[155],De([1,0,60,84,101,13,9,15,6,76,94,12,54,3,67,143,2,311,27]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wn=void 0,e.$vn=m;async function m(i={},h,u,D,I,T){const O=await(0,S.$fm)(u,D.userDataPath);let C={};if(h)try{C=await(0,E.$Mm)(T,I,D.args,process.env)}catch(x){I.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",x)}const Q={...process.env,...C,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(O,void 0,0),...i},X=D.isBuilt?(0,R.$jc)(D.appRoot,"bin"):(0,R.$jc)(D.appRoot,"resources","server","bin-dev"),ie=(0,R.$jc)(X,"remote-cli");let ne=t(Q,"PATH");return ne?ne=ie+R.$tc+ne:ne=ie,o(Q,"PATH",ne),D.args["without-browser-env-var"]||(Q.BROWSER=(0,R.$jc)(X,"helpers",w.$c?"browser.cmd":"browser.sh")),d(Q),Q}class b{constructor(h,u){this.socket=h,this.initialDataChunk=u}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let h,u,D;return this.socket instanceof s.$pi?(h=!0,u=!1,D=A.$Je.alloc(0)):(h=!1,u=this.socket.permessageDeflate,D=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:h,permessageDeflate:u,inflateBytes:D.buffer.toString("base64")}}}let l=class{constructor(h,u,D,I,T,O,C,P){this.i=h,this.j=T,this.l=O,this.m=C,this.n=P,this.b=new v.$he,this.onClose=this.b.event,this.c=!w.$c||!this.j.args["socket-path"],this.d=!1,this.f=u,this.g=null,this.h=new b(D,I),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(h){this.l.info(`${this.o}${h}`)}q(h){this.l.error(`${this.o}${h}`)}async r(h,u){const D=new c.$Tc;D.add(u.socket),D.add((0,c.$Sc)(()=>{h.destroy()}));const I=()=>{D.dispose()};D.add(u.socket.onEnd(I)),D.add(u.socket.onClose(I)),D.add(v.Event.fromNodeEventEmitter(h,"end")(I)),D.add(v.Event.fromNodeEventEmitter(h,"close")(I)),D.add(v.Event.fromNodeEventEmitter(h,"error")(I)),D.add(u.socket.onData(T=>h.write(T.buffer))),D.add(v.Event.fromNodeEventEmitter(h,"data")(T=>{u.socket.write(A.$Je.wrap(T))})),u.initialDataChunk.byteLength>0&&h.write(u.initialDataChunk.buffer)}async s(h,u){await u.socketDrain();const D=u.toIExtHostSocketMessage();let I;u.socket instanceof s.$pi?I=u.socket.socket:I=u.socket.socket.socket,h.send(D,I)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const h={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(h)}acceptReconnection(h,u,D){this.f=h,this.p("The client has reconnected.");const I=new b(u,D);if(!this.g){this.h=I;return}this.s(this.g,I)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(h){try{let u=process.execArgv?process.execArgv.filter(ie=>!/^--inspect(-brk)?=/.test(ie)):[];h.port&&!process.pkg&&(u=[`--inspect${h.break?"-brk":""}=${h.port}`]);const D=await m(h.env,!0,h.language,this.j,this.l,this.n);(0,a.$tm)(D);let I;if(this.c)(0,g.$tn)(new g.$rn,D),I=null;else{const{namedPipeServer:ie,pipeName:ne}=await this.u();(0,g.$tn)(new g.$qn(ne),D),I=ie}const T={env:D,execArgv:u,silent:!0};T.execArgv.unshift("--dns-result-order=ipv4first");const O=["--type=extensionHost","--transformURIs"],C=this.j.args["use-host-proxy"];O.push(`--useHostProxy=${C?"true":"false"}`),this.g=n.fork(k.$Ug.asFileUri("bootstrap-fork").fsPath,O,T);const P=this.g.pid;this.p(`<${P}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const Q=v.Event.fromNodeEventEmitter(this.g.stdout,"data"),X=v.Event.fromNodeEventEmitter(this.g.stderr,"data");if(Q(ie=>this.p(`<${P}> ${ie}`)),X(ie=>this.p(`<${P}><stderr> ${ie}`)),this.g.on("error",ie=>{this.q(`<${P}> Extension Host Process had an error`),this.l.error(ie),this.t()}),this.g.on("exit",(ie,ne)=>{this.m.setExitInfo(this.i,{code:ie,signal:ne}),this.p(`<${P}> Extension Host Process exited with code: ${ie}, signal: ${ne}.`),this.t()}),I)I.on("connection",ie=>{I.close(),this.r(ie,this.h)});else{const ie=ne=>{ne.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",ie),this.s(this.g,this.h),this.h=null)};this.g.on("message",ie)}}catch(u){console.error("ExtensionHostConnection errored"),u&&console.error(u)}}u(){return new Promise((h,u)=>{const D=(0,s.$si)(),I=r.createServer();I.on("error",u),I.listen(D,()=>{I?.removeListener("error",u),h({pipeName:D,namedPipeServer:I})})})}};e.$wn=l,e.$wn=l=Ue([Ne(4,$.$gn),Ne(5,y.$7j),Ne(6,f.$on),Ne(7,p.$7i)],l);function t(i,h){const u=Object.keys(i).filter(I=>I.toLowerCase()===h.toLowerCase()),D=u.length>0?u[0]:h;return i[D]}function o(i,h,u){const D=Object.keys(i).filter(T=>T.toLowerCase()===h.toLowerCase()),I=D.length>0?D[0]:h;i[I]=u}function d(i){for(const h of Object.keys(i))i[h]===null&&delete i[h]}}),define(Se[326],De([1,0,89,12,71,129,27,47,154,41,24,30,141,139,95,122,63,2,123,72,13,16,29,54,132,92,133,10,4,9,33,266,88,36,137,70,3,64,144,34,53,73,142,140,125,126,227,327]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m,b,l,t,o,d,i,h,u,D,I,T,O,C,P,Q,X,ie,ne,x,re,q,te,le,M,z,oe,ce,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=ee;class W extends g.$Uc{constructor(L,V){super(),this.a=L,this.b=V,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const L=await this.f();await L.invokeFunction(async V=>{const B=V.get(R.$7i),U=V.get(r.$7j);ie.$c&&(B.getValue("security.restrictUNCAccess")===!1?(0,pe.disableUNCAccessRestrictions)():(0,pe.addUNCHostToAllowlist)(B.getValue("security.allowedUNCHosts")));try{await this.g(L.createInstance(d.$lq,new r.$ck(U.getLevel(),!1)))}catch(K){throw U.error(K),console.error((0,u.$0)(K)),K}})}async f(){const L=new n.$yi,V={_serviceBrand:void 0,...c.default};L.set(t.$nk,V);const B=new o.$hn(this.a,V);L.set(o.$gn,B);const U=new oe.$eQ((0,r.$ik)(B),B.logsHome);L.set(r.$8j,U);const K=new z.$oQ(this.B(U.createLogger("remoteCLI",{name:(0,ce.localize)(0,null)})));L.set(r.$7j,K),K.trace(`Remote configuration data at ${this.b}`),K.trace("process arguments:",this.a);const Z=this.B(new p.$Rq(K));L.set(l.$7k,Z),Z.registerProvider(b.Schemas.file,this.B(new m.$ir(K)));const j=new Q.$Js(Z);L.set(P.$El,j);const G=this.B(new le.$mQ(j,B,Z,K));L.set(re.$Gl,G);const se=this.B(new k.$Oo(G.defaultProfile.settingsResource,Z,new te.$oo,K));return L.set(R.$7i,se),await Promise.all([se.initialize(),G.init()]),L.set(A.$Wp,new S.$xi(v.$7r)),L.set(C.$So,new S.$xi(O.$HQ)),L.set(E.$6l,s.$qp),L.set(y.$cp,new S.$xi($.$hq)),L.set(q.$yq,new S.$xi(M.$nQ)),L.set(ne.$Cq,new S.$xi(x.$_P)),L.set(a.$iq,new S.$xi(a.$kq)),L.set(w.$Nq,new S.$xi(w.$Oq)),L.set(i.$1r,new S.$xi(h.$3r)),new f.$lr(L)}async g(L){if(this.a["list-extensions"])return L.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const V={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return L.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),V,!!this.a.force)}else{if(this.a["uninstall-extension"])return L.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return L.updateExtensions();if(this.a["locate-extension"])return L.locateExtension(this.a["locate-extension"])}}h(L){return L.map(V=>/\.vsix$/i.test(V)?D.URI.file((0,I.$ic)(V)?V:(0,I.$jc)((0,T.cwd)(),V)):V)}}function ae(H){setTimeout(()=>process.exit(H),0)}async function ee(H,L,V){if(H.help){const U=c.default.serverApplicationName+(ie.$c?".cmd":"");console.log((0,X.$Bm)(c.default.nameLong,U,c.default.version,V,{noInputFiles:!0,noPipe:!0}));return}if(H.version){console.log((0,X.$Cm)(c.default.version,c.default.commit));return}const B=new W(H,L);try{await B.run(),ae(0)}catch{ae(1)}finally{B.dispose()}}}),define(Se[328],De([1,0,76,296,31,323,4,12,98]),function(he,e,n,r,S,k,R,A,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.$oP=void 0;class s{constructor($,w,a){this.b=$,this.c=w,this.f=a,this.a=r.createServer((f,c)=>this.h(f,c)),this.g().catch(f=>(w.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,w){const a=(c,g)=>{w.writeHead(c,{"content-type":"application/json"}),w.end(JSON.stringify(g||null),p=>p&&this.c.error(p))},f=[];$.setEncoding("utf8"),$.on("data",c=>f.push(c)),$.on("end",async()=>{try{const c=JSON.parse(f.join(""));let g;switch(c.type){case"open":g=await this.i(c);break;case"openExternal":g=await this.j(c);break;case"status":g=await this.l(c);break;case"extensionManagement":g=await this.k(c);break;case"clipboard":g=await this.m(c);break;default:a(404,`Unknown message type: ${c.type}`);break}a(200,g)}catch(c){const g=c instanceof Error?c.message:JSON.stringify(c);a(500,g),this.c.error("Error while processing pipe request",c)}})}async i($){const{fileURIs:w,folderURIs:a,forceNewWindow:f,diffMode:c,mergeMode:g,addMode:p,forceReuseWindow:m,gotoLineMode:b,waitMarkerFilePath:l,remoteAuthority:t}=$,o=[];if(Array.isArray(a))for(const u of a)try{o.push({folderUri:R.URI.parse(u)})}catch{}if(Array.isArray(w))for(const u of w)try{(0,v.$6i)(u)?o.push({workspaceUri:R.URI.parse(u)}):o.push({fileUri:R.URI.parse(u)})}catch{}const d=l?R.URI.file(l):void 0,h={forceNewWindow:f,diffMode:c,mergeMode:g,addMode:p,gotoLineMode:b,forceReuseWindow:m,preferNewWindow:!m&&!d&&!p,waitMarkerFileURI:d,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",o,h)}async j($){for(const w of $.uris){const a=R.URI.parse(w),f=a.scheme==="file"?a:w;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k($){const w=f=>f?.map(c=>/\.vsix$/i.test(c)?R.URI.parse(c):c),a={list:$.list,install:w($.install),uninstall:w($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",a)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}async m($){return await this.b.executeCommand("_remoteCLI.setClipboard",$.content)}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&S.existsSync(this.f)&&S.unlinkSync(this.f)}}e.$oP=s;let E=class extends s{constructor($,w){super($,w,(0,n.$si)())}};e.$pP=E,e.$pP=E=Ue([Ne(0,k.$jP),Ne(1,A.$7j)],E)}),define(Se[329],De([1,0,32,6,21,2,9,3,4,76,74,328,135,97,145,306,308,155,14,136]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;class b extends c.$4P{constructor(o,d,i,h,u){super({getFolderUri:D=>{const I=d.filter(T=>T.name===D);if(I&&I.length>0)return I[0].uri},getWorkspaceFolderCount:()=>d.length,getConfigurationValue:(D,I)=>h[`config:${I}`],getExecPath:()=>o.VSCODE_EXEC_PATH,getAppRoot:()=>o.VSCODE_CWD,getFilePath:()=>{if(i)return R.$hc(i.fsPath)},getSelectedText:()=>h.selectedText,getLineNumber:()=>h.lineNumber,getExtension:async D=>{const T=(await u.getInstalled()).find(O=>O.identifier.id===D);return T&&{extensionLocation:T.location}}},void 0,Promise.resolve(n.homedir()),Promise.resolve(o))}}class l extends k.$Uc{constructor(o,d,i,h,u,D){super(),this.g=o,this.h=d,this.j=i,this.m=h,this.n=u,this.r=D,this.a=0,this.b=new Map,this.c=this.B(new r.$he),this.onExecuteCommand=this.c.event}async call(o,d,i){switch(d){case a.RemoteTerminalChannelRequest.RestartPtyHost:return this.j.restartPtyHost.apply(this.j,i);case a.RemoteTerminalChannelRequest.CreateProcess:{const h=(0,E.$Ks)(o.remoteAuthority);return this.s(h,i)}case a.RemoteTerminalChannelRequest.AttachToProcess:return this.j.attachToProcess.apply(this.j,i);case a.RemoteTerminalChannelRequest.DetachFromProcess:return this.j.detachFromProcess.apply(this.j,i);case a.RemoteTerminalChannelRequest.ListProcesses:return this.j.listProcesses.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetLatency:return this.j.getLatency.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetPerformanceMarks:return this.j.getPerformanceMarks.apply(this.j,i);case a.RemoteTerminalChannelRequest.OrphanQuestionReply:return this.j.orphanQuestionReply.apply(this.j,i);case a.RemoteTerminalChannelRequest.AcceptPtyHostResolvedVariables:return this.j.acceptPtyHostResolvedVariables.apply(this.j,i);case a.RemoteTerminalChannelRequest.Start:return this.j.start.apply(this.j,i);case a.RemoteTerminalChannelRequest.Input:return this.j.input.apply(this.j,i);case a.RemoteTerminalChannelRequest.AcknowledgeDataEvent:return this.j.acknowledgeDataEvent.apply(this.j,i);case a.RemoteTerminalChannelRequest.Shutdown:return this.j.shutdown.apply(this.j,i);case a.RemoteTerminalChannelRequest.Resize:return this.j.resize.apply(this.j,i);case a.RemoteTerminalChannelRequest.ClearBuffer:return this.j.clearBuffer.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetInitialCwd:return this.j.getInitialCwd.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetCwd:return this.j.getCwd.apply(this.j,i);case a.RemoteTerminalChannelRequest.ProcessBinary:return this.j.processBinary.apply(this.j,i);case a.RemoteTerminalChannelRequest.SendCommandResult:return this.u(i[0],i[1],i[2]);case a.RemoteTerminalChannelRequest.InstallAutoReply:return this.j.installAutoReply.apply(this.j,i);case a.RemoteTerminalChannelRequest.UninstallAllAutoReplies:return this.j.uninstallAllAutoReplies.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetDefaultSystemShell:return this.w.apply(this,i);case a.RemoteTerminalChannelRequest.GetProfiles:return this.y.apply(this,i);case a.RemoteTerminalChannelRequest.GetEnvironment:return this.z();case a.RemoteTerminalChannelRequest.GetWslPath:return this.C(i[0],i[1]);case a.RemoteTerminalChannelRequest.GetTerminalLayoutInfo:return this.j.getTerminalLayoutInfo(i);case a.RemoteTerminalChannelRequest.SetTerminalLayoutInfo:return this.j.setTerminalLayoutInfo(i);case a.RemoteTerminalChannelRequest.SerializeTerminalState:return this.j.serializeTerminalState.apply(this.j,i);case a.RemoteTerminalChannelRequest.ReviveTerminalProcesses:return this.j.reviveTerminalProcesses.apply(this.j,i);case a.RemoteTerminalChannelRequest.GetRevivedPtyNewId:return this.j.getRevivedPtyNewId.apply(this.j,i);case a.RemoteTerminalChannelRequest.SetUnicodeVersion:return this.j.setUnicodeVersion.apply(this.j,i);case a.RemoteTerminalChannelRequest.ReduceConnectionGraceTime:return this.D();case a.RemoteTerminalChannelRequest.UpdateIcon:return this.j.updateIcon.apply(this.j,i);case a.RemoteTerminalChannelRequest.UpdateTitle:return this.j.updateTitle.apply(this.j,i);case a.RemoteTerminalChannelRequest.UpdateProperty:return this.j.updateProperty.apply(this.j,i);case a.RemoteTerminalChannelRequest.RefreshProperty:return this.j.refreshProperty.apply(this.j,i);case a.RemoteTerminalChannelRequest.RequestDetachInstance:return this.j.requestDetachInstance(i[0],i[1]);case a.RemoteTerminalChannelRequest.AcceptDetachedInstance:return this.j.acceptDetachInstanceReply(i[0],i[1]);case a.RemoteTerminalChannelRequest.FreePortKillProcess:return this.j.freePortKillProcess.apply(this.j,i);case a.RemoteTerminalChannelRequest.AcceptDetachInstanceReply:return this.j.acceptDetachInstanceReply.apply(this.j,i)}throw new Error(`IPC Command ${d} not found`)}listen(o,d,i){switch(d){case a.RemoteTerminalChannelEvent.OnPtyHostExitEvent:return this.j.onPtyHostExit||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostStartEvent:return this.j.onPtyHostStart||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostUnresponsiveEvent:return this.j.onPtyHostUnresponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostResponsiveEvent:return this.j.onPtyHostResponsive||r.Event.None;case a.RemoteTerminalChannelEvent.OnPtyHostRequestResolveVariablesEvent:return this.j.onPtyHostRequestResolveVariables||r.Event.None;case a.RemoteTerminalChannelEvent.OnProcessDataEvent:return this.j.onProcessData;case a.RemoteTerminalChannelEvent.OnProcessReadyEvent:return this.j.onProcessReady;case a.RemoteTerminalChannelEvent.OnProcessExitEvent:return this.j.onProcessExit;case a.RemoteTerminalChannelEvent.OnProcessReplayEvent:return this.j.onProcessReplay;case a.RemoteTerminalChannelEvent.OnProcessOrphanQuestion:return this.j.onProcessOrphanQuestion;case a.RemoteTerminalChannelEvent.OnExecuteCommand:return this.onExecuteCommand;case a.RemoteTerminalChannelEvent.OnDidRequestDetach:return this.j.onDidRequestDetach||r.Event.None;case a.RemoteTerminalChannelEvent.OnDidChangeProperty:return this.j.onDidChangeProperty}throw new Error(`IPC Command ${d} not found`)}async s(o,d){const i={name:d.shellLaunchConfig.name,executable:d.shellLaunchConfig.executable,args:d.shellLaunchConfig.args,cwd:typeof d.shellLaunchConfig.cwd=="string"||typeof d.shellLaunchConfig.cwd>"u"?d.shellLaunchConfig.cwd:v.URI.revive(o.transformIncoming(d.shellLaunchConfig.cwd)),env:d.shellLaunchConfig.env,useShellEnvironment:d.shellLaunchConfig.useShellEnvironment,reconnectionProperties:d.shellLaunchConfig.reconnectionProperties,type:d.shellLaunchConfig.type,isFeatureTerminal:d.shellLaunchConfig.isFeatureTerminal},h=await(0,g.$vn)(d.resolverEnv,!!d.shellLaunchConfig.useShellEnvironment,A.$q,this.g,this.h,this.r);this.h.trace("baseEnv",h);const u=te=>({uri:v.URI.revive(o.transformIncoming(te.uri)),name:te.name,index:te.index,toResource:()=>{throw new Error("Not implemented")}}),D=d.workspaceFolders.map(u),I=d.activeWorkspaceFolder?u(d.activeWorkspaceFolder):void 0,T=d.activeFileResource?v.URI.revive(o.transformIncoming(d.activeFileResource)):void 0,O=new b(h,D,T,d.resolvedVariables,this.n),C=f.$ZP(I,process.env,O),P=await f.$YP(i,n.homedir(),C,I?.uri,d.configuration["terminal.integrated.cwd"],this.h);i.cwd=P;const Q=A.$c?"terminal.integrated.env.windows":A.$d?"terminal.integrated.env.osx":"terminal.integrated.env.linux",X=d.configuration[Q],ie=await f.$1P(i,X,C,this.m.version,d.configuration["terminal.integrated.detectLocale"],h);if((0,m.$SP)(i)){const te=[];for(const[oe,ce,pe]of d.envVariableCollections)te.push([oe,{map:(0,w.$ws)(ce),descriptionMap:(0,w.$xs)(pe)}]);const le=new Map(te),M=new $.$As(le),z=I?I??void 0:void 0;await M.applyToProcessEnvironment(ie,{workspaceFolder:z},C)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:i,initialCwd:P,cols:d.cols,rows:d.rows,env:ie});const ne=(0,s.$si)();ie.VSCODE_IPC_HOOK_CLI=ne;const x=await this.j.createProcess(i,P,d.cols,d.rows,d.unicodeVersion,ie,h,d.options,d.shouldPersistTerminal,d.workspaceId,d.workspaceName),re={executeCommand:(te,...le)=>this.t(x,te,le,o)},q=new y.$oP(re,this.h,ne);return this.j.onProcessExit(te=>te.id===x&&q.dispose()),{persistentTerminalId:x,resolvedShellLaunchConfig:i}}t(o,d,i,h){const{resolve:u,reject:D,promise:I}=(0,p.$th)(),T=++this.a;this.b.set(T,{resolve:u,reject:D,uriTransformer:h});const O=(0,S.$_n)(i,C=>{if(C&&C.$mid===1)return h.transformOutgoing(C);if(C&&C instanceof v.URI)return h.transformOutgoingURI(C)});return this.c.fire({reqId:T,persistentProcessId:o,commandId:d,commandArgs:O}),I}u(o,d,i){const h=this.b.get(o);if(!h)return;this.b.delete(o);const u=(0,S.$_n)(i,D=>{if(D&&D.$mid===1)return h.uriTransformer.transformIncoming(D)});d?h.reject(u):h.resolve(u)}w(o){return this.j.getDefaultSystemShell(o)}async y(o,d,i,h){return this.j.getProfiles(o,d,i,h)||[]}z(){return{...process.env}}C(o,d){return this.j.getWslPath(o,d)}D(){return this.j.reduceConnectionGraceTime()}}e.$5P=l}),define(Se[330],De([1,0,32,6,2,13,9,112,25,49,61,27,129,239,88,240,28,141,30,95,132,264,139,16,123,72,71,122,89,92,133,12,63,29,47,267,154,131,24,41,280,52,287,36,137,300,301,273,277,329,74,54,310,324,143,64,144,53,34,295,73,278,126,142,140,125,124,229,319,263,292,284]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m,b,l,t,o,d,i,h,u,D,I,T,O,C,P,Q,X,ie,ne,x,re,q,te,le,M,z,oe,ce,pe,W,ae,ee,H,L,V,B,U,K,Z,j,G,se,fe,Ee,Le,de,we,Re,Oe,me,Ie,Ae,je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=void 0,e.$xQ=Je;const Be="monacoworkbench";async function Je(tt,Xe,Ge,xe){const ve=new D.$yi,ge=new He,be={_serviceBrand:void 0,...C.default};ve.set(P.$nk,be);const Y=new H.$hn(Xe,be);ve.set(c.$Hi,Y),ve.set(c.$Ii,Y);const _=new Ee.$eQ((0,O.$ik)(Y),Y.logsHome);ve.set(O.$8j,_),ge.registerChannel("logger",new Re.$js(_,at=>Qe(at.remoteAuthority)));const ye=_.createLogger("remoteagent",{name:(0,Oe.localize)(0,null)}),Me=new we.$oQ(ye,[new nt((0,O.$ik)(Y))]);ve.set(O.$7j,Me),setTimeout(()=>lt(Y.logsHome.with({scheme:k.Schemas.file}).fsPath).then(null,at=>Me.error(at)),1e4),Me.onDidChangeLogLevel(at=>(0,O.log)(Me,at,`Log level changed to ${(0,O.$jk)(Me.getLevel())}`)),Me.trace(`Remote configuration data at ${Ge}`),Me.trace("process arguments:",Y.args),Array.isArray(be.serverGreeting)&&Me.info(`

${be.serverGreeting.join(`
`)}

`),ge.registerChannel(w.$Qo.ChannelName,new w.$Qo);const Ve=new s.$ii(at=>at.clientId==="renderer"),Ye=xe.add(new d.$Rq(Me));ve.set(o.$7k,Ye),Ye.registerProvider(k.Schemas.file,xe.add(new i.$ir(Me)));const _e=new z.$Js(Ye);ve.set(M.$El,_e);const ot=new $.$Oo(Y.machineSettingsResource,Ye,new se.$oo,Me);ve.set(y.$7i,ot);const ht=new Le.$mQ(_e,Y,Ye,Me);ve.set(j.$Gl,ht),ge.registerChannel("userDataProfiles",new Ae.$uQ(ht,at=>Qe(at.remoteAuthority)));const[,,gt,Ct,Ot]=await Promise.all([ot.initialize(),ht.init(),(0,A.$Ln)(Me.error.bind(Me)),(0,A.$Mn)(Me.error.bind(Me)),(0,A.$Nn)(Me.error.bind(Me))]),mt=new B.$pn;ve.set(B.$on,mt);const yt=new ie.$7r(ot,Y,Me,_);ve.set(Q.$Wp,yt);let pt;try{await v.Promises.stat("/run/.containerenv"),pt=!0}catch{}if(!pt)try{pt=(await v.Promises.readFile("/proc/self/cgroup","utf8")).includes("docker")}catch{}let kt=re.$up;const Ht=(0,re.$Ap)(be,ot);if((0,re.$vp)(be,Y)){!(0,re.$wp)(be,Y)&&be.telemetryEndpoint&&(kt=new fe.$cQ(yt,Ht,Be,null,()=>new G.$aQ(be.telemetryEndpoint,gt,pt)),xe.add((0,S.$Sc)(()=>kt?.flush())));const at={appenders:[kt],commonProperties:(0,ne.$mp)((0,n.release)(),(0,n.hostname)(),process.arch,be.commit,be.version+"-remote",gt,Ct,Ot,Ht,"remoteAgent"),piiPaths:(0,re.$Bp)(Y)},ft=Y.args["telemetry-level"];let $t=x.TelemetryLevel.USAGE;ft==="all"?$t=x.TelemetryLevel.USAGE:ft==="error"?$t=x.TelemetryLevel.ERROR:ft==="crash"?$t=x.TelemetryLevel.CRASH:ft!==void 0&&($t=x.TelemetryLevel.NONE),ve.set(W.$Xs,new h.$xi(W.$Vs,[at,$t]))}else ve.set(W.$Xs,W.$Ws);ve.set(p.$cp,new h.$xi(g.$hq));const It=ge.getChannel("download",Ve);ve.set(a.$So,new f.$Uo(It,()=>Qe("renderer"))),ve.set(Z.$yq,new h.$xi(de.$nQ)),ve.set(U.$Cq,new h.$xi(K.$_P)),ve.set(m.$iq,new h.$xi(m.$kq)),ve.set(t.$Nq,new h.$xi(t.$Oq));const bt=new u.$lr(ve);ve.set(I.$1r,bt.createInstance(T.$3r));const qt=bt.createInstance(je.$wQ,{graceTime:E.ProtocolConstants.ReconnectionGraceTime,shortGraceTime:E.ProtocolConstants.ReconnectionShortGraceTime,scrollback:ot.getValue(te.TerminalSettingId.PersistentSessionScrollback)??100}),Pt=bt.createInstance(le.$Fs,qt);return ve.set(te.$es,Pt),bt.invokeFunction(at=>{const ft=at.get(t.$Nq),$t=at.get(U.$Cq),Wt=at.get(p.$cp),Rt=at.get(I.$1r),Lt=new oe.$Rs(tt,Y,ht,mt);ge.registerChannel("remoteextensionsenvironment",Lt);const Vt=new pe.$Ys(at.get(W.$Xs),kt);ge.registerChannel("telemetry",Vt),ge.registerChannel(L.$6P,new ae.$5P(Y,Me,Pt,be,ft,ot));const Kt=new me.$sQ(bt.createInstance(b.$lq,Me),Y,ht,$t,Me,Wt,Rt);ge.registerChannel(Ie.$rQ,new me.$tQ(Kt,Nt=>Qe(Nt.remoteAuthority)));const Et=xe.add(new ce.$Us(Me,Y));ge.registerChannel(V.$0P,Et),ge.registerChannel("request",new X.$4r(at.get(Q.$Wp)));const At=new l.$mq(ft,Nt=>Qe(Nt.remoteAuthority));ge.registerChannel("extensions",At);const Ut=s.ProxyChannel.fromService(at.get(I.$1r),xe);return ge.registerChannel("languagePacks",Ut),Kt.whenExtensionsReady().then(()=>ft.cleanUp()),xe.add(new q.default(at.get(x.$6l))),{telemetryService:at.get(x.$6l)}}),{socketServer:ge,instantiationService:bt}}const We=Object.create(null);function Qe(tt){return We[tt]||(We[tt]=(0,ee.$Ks)(tt)),We[tt]}class He extends s.$ei{constructor(){const Xe=new r.$he;super(Xe.event),this.b=Xe}acceptConnection(Xe,Ge){this.b.fire({protocol:Xe,onDidClientDisconnect:Ge})}}e.$yQ=He;class nt extends O.$_j{constructor(Xe=O.$0j){super(),this.setLevel(Xe),this.g=!!process.stdout.isTTY}trace(Xe,...Ge){this.f(O.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${et()}]\x1B[0m`,Xe,...Ge):console.log(`[${et()}]`,Xe,...Ge))}debug(Xe,...Ge){this.f(O.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${et()}]\x1B[0m`,Xe,...Ge):console.log(`[${et()}]`,Xe,...Ge))}info(Xe,...Ge){this.f(O.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${et()}]\x1B[0m`,Xe,...Ge):console.log(`[${et()}]`,Xe,...Ge))}warn(Xe,...Ge){this.f(O.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${et()}]\x1B[0m`,Xe,...Ge):console.warn(`[${et()}]`,Xe,...Ge))}error(Xe,...Ge){this.f(O.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${et()}]\x1B[0m`,Xe,...Ge):console.error(`[${et()}]`,Xe,...Ge))}flush(){}}function et(){const tt=new Date;return`${rt(tt.getHours())}:${rt(tt.getMinutes())}:${rt(tt.getSeconds())}`}function rt(tt){return tt<10?`0${tt}`:String(tt)}async function lt(tt){const Xe=R.$nc(tt),Ge=R.$mc(tt),ge=(await v.Promises.readdir(Ge)).filter(Y=>/^\d{8}T\d{6}$/.test(Y)).sort().filter(Y=>Y!==Xe),be=ge.slice(0,Math.max(0,ge.length-9));await Promise.all(be.map(Y=>v.Promises.rm(R.$jc(Ge,Y))))}}),define(Se[331],De([1,0,96,31,84,332,93,105,15,35,10,37,2,13,9,45,3,17,4,22,180,182,327,61,76,27,5,12,29,262,24,155,293,102,54,330,297]),function(he,e,n,r,S,k,R,A,v,s,E,y,$,w,a,f,c,g,p,m,b,l,t,o,d,i,h,u,D,I,T,O,C,P,Q,X,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GQ=re;const ne=5*60*1e3;let x=class extends $.$Uc{constructor(le,M,z,oe,ce,pe,W,ae,ee){super(),this.n=le,this.r=M,this.s=z,this.t=pe,this.u=W,this.w=ae,this.y=ee,this.h=q.create(this.u),this.j=(0,w.$Og)(W,ce),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=oe?this.y.createInstance(ie.$BQ,this.r,ce??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(le,M){if(le.method!=="GET")return(0,ie.$zQ)(le,M,405,`Unsupported method ${le.method}`);if(!le.url)return(0,ie.$zQ)(le,M,400,"Bad request.");const z=R.parse(le.url,!0);let oe=z.pathname;if(!oe)return(0,ie.$zQ)(le,M,400,"Bad request.");if(oe.startsWith(this.j)&&oe.charCodeAt(this.j.length)===s.CharCode.Slash&&(oe=oe.substring(this.j.length)),oe==="/version")return M.writeHead(200,{"Content-Type":"text/plain"}),void M.end(this.u.commit||"");if(oe==="/delay-shutdown")return this.N(),M.writeHead(200),void M.end("OK");if(!(0,P.$Dn)(this.r,le,z))return(0,ie.$zQ)(le,M,403,"Forbidden.");if(oe==="/vscode-remote-resource"){const ce=z.query.path;if(typeof ce!="string")return(0,ie.$zQ)(le,M,400,"Bad request.");let pe;try{pe=p.URI.from({scheme:w.Schemas.file,path:ce}).fsPath}catch{return(0,ie.$zQ)(le,M,400,"Bad request.")}const W=Object.create(null);this.t.isBuilt&&((0,y.$zg)(pe,this.t.builtinExtensionsPath,!c.$e)||(0,y.$zg)(pe,this.t.extensionsPath,!c.$e))&&(W["Cache-Control"]="public, max-age=31536000"),W.Vary="Origin";const ae=le.headers.origin;return ae&&this.h.matches(ae)&&(W["Access-Control-Allow-Origin"]=ae),(0,ie.$AQ)(pe,ie.CacheControl.ETAG,this.w,le,M,W)}if(this.g){this.g.handle(le,M,z);return}return M.writeHead(404,{"Content-Type":"text/plain"}),void M.end("Not found")}handleUpgrade(le,M){let z=(0,m.$Wg)(),oe=!1,ce=!1;if(le.url){const L=R.parse(le.url,!0).query;typeof L.reconnectionToken=="string"&&(z=L.reconnectionToken),L.reconnection==="true"&&(oe=!0),L.skipWebSocketFrames==="true"&&(ce=!0)}if(le.headers.upgrade===void 0||le.headers.upgrade.toLowerCase()!=="websocket"){M.end("HTTP/1.1 400 Bad Request");return}const pe=le.headers["sec-websocket-key"],W=n.createHash("sha1");W.update(pe+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ee=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${W.digest("base64")}`];let H=!1;if(!ce&&!this.t.args["disable-websocket-compression"]&&le.headers["sec-websocket-extensions"]){const L=Array.isArray(le.headers["sec-websocket-extensions"])?le.headers["sec-websocket-extensions"]:[le.headers["sec-websocket-extensions"]];for(const V of L)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(V)){if(/\b(permessage-deflate)\b/.test(V)){H=!0,ee.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(V)){H=!0,ee.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}M.write(ee.join(`\r
`)+`\r
\r
`),M.setTimeout(0),M.setNoDelay(!0),ce?this.D(new d.$pi(M,`server-connection-${z}`),oe,z):this.D(new d.$qi(new d.$pi(M,`server-connection-${z}`),H,null,!0),oe,z)}handleServerError(le){this.w.error("Error occurred in server"),this.w.error(le)}z(le){let M;return le instanceof d.$pi?M=le.socket:M=le.socket.socket,M.remoteAddress||"<unknown>"}async C(le,M,z){const oe=M.getSocket();this.w.error(`${le} ${z}.`);const ce={type:"error",reason:z};M.sendControl(v.$Je.fromString(JSON.stringify(ce))),M.dispose(),await oe.drain(),oe.dispose()}D(le,M,z){const oe=this.z(le),ce=`[${oe}][${z.substr(0,8)}]`,pe=new o.$oi({socket:le}),W=this.s?new this.s.validator:null,ae=this.s?new this.s.signer:null;let ee;(function(B){B[B.WaitingForAuth=0]="WaitingForAuth",B[B.WaitingForConnectionType=1]="WaitingForConnectionType",B[B.Done=2]="Done",B[B.Error=3]="Error"})(ee||(ee={}));let H=ee.WaitingForAuth;const L=B=>{H=ee.Error,V.dispose(),this.C(ce,pe,B)},V=pe.onControlMessage(B=>{if(H===ee.WaitingForAuth){let U;try{U=JSON.parse(B.toString())}catch{return L("Malformed first message")}if(U.type!=="auth")return L("Invalid first message");if(this.r.type===P.ServerConnectionTokenType.Mandatory&&!this.r.validate(U.auth))return L("Unauthorized client refused: auth mismatch");let K=(0,m.$Wg)();if(ae)try{K=ae.sign(U.data)}catch{}let Z=(0,m.$Wg)();if(W)try{Z=W.createNewMessage(Z)}catch{}const j={type:"sign",data:Z,signedData:K};pe.sendControl(v.$Je.fromString(JSON.stringify(j))),H=ee.WaitingForConnectionType}else if(H===ee.WaitingForConnectionType){let U;try{U=JSON.parse(B.toString())}catch{return L("Malformed second message")}if(U.type!=="connectionType")return L("Invalid second message");if(typeof U.signedData!="string")return L("Invalid second message field type");const K=U.commit,Z=this.u.commit;if(K&&Z&&K!==Z)return L("Client refused: version mismatch");let j=!1;if(!W)j=!0;else if(this.r.validate(U.signedData))j=!0;else try{j=W.validate(U.signedData)==="ok"}catch{}if(!j){if(this.t.isBuilt)return L("Unauthorized client refused");this.w.error(`${ce} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const G in this.b)this.b[G].shortenReconnectionGraceTimeIfNecessary();for(const G in this.a)this.a[G].shortenReconnectionGraceTimeIfNecessary();H=ee.Done,V.dispose(),this.F(oe,ce,pe,le,M,z,U)}})}async F(le,M,z,oe,ce,pe,W){const ae=W.desiredConnectionType===I.ConnectionType.Management?`${M}[ManagementConnection]`:W.desiredConnectionType===I.ConnectionType.ExtensionHost?`${M}[ExtensionHostConnection]`:M;if(W.desiredConnectionType===I.ConnectionType.Management)if(ce){if(!this.b[pe])return this.f.has(pe)?this.C(ae,z,"Unknown reconnection token (seen before)"):this.C(ae,z,"Unknown reconnection token (never seen)");z.sendControl(v.$Je.fromString(JSON.stringify({type:"ok"})));const ee=z.readEntireBuffer();z.dispose(),this.b[pe].acceptReconnection(le,oe,ee)}else{if(this.b[pe])return this.C(ae,z,"Duplicate reconnection token");z.sendControl(v.$Je.fromString(JSON.stringify({type:"ok"})));const ee=new C.$xn(this.w,pe,le,z);this.n.acceptConnection(ee.protocol,ee.onClose),this.b[pe]=ee,this.f.add(pe),ee.onClose(()=>{delete this.b[pe]})}else if(W.desiredConnectionType===I.ConnectionType.ExtensionHost){const ee=W.args||{language:"en"},H=await this.I(ee);if(H.port&&this.w.trace(`${ae} - startParams debug port ${H.port}`),this.w.trace(`${ae} - startParams language: ${H.language}`),this.w.trace(`${ae} - startParams env: ${JSON.stringify(H.env)}`),ce){if(!this.a[pe])return this.f.has(pe)?this.C(ae,z,"Unknown reconnection token (seen before)"):this.C(ae,z,"Unknown reconnection token (never seen)");z.sendPause(),z.sendControl(v.$Je.fromString(JSON.stringify(H.port?{debugPort:H.port}:{})));const L=z.readEntireBuffer();z.dispose(),this.a[pe].acceptReconnection(le,oe,L)}else{if(this.a[pe])return this.C(ae,z,"Duplicate reconnection token");z.sendPause(),z.sendControl(v.$Je.fromString(JSON.stringify(H.port?{debugPort:H.port}:{})));const L=z.readEntireBuffer();z.dispose();const V=this.y.createInstance(O.$wn,pe,le,oe,L);this.a[pe]=V,this.f.add(pe),V.onClose(()=>{delete this.a[pe],this.J()}),V.start(H)}}else if(W.desiredConnectionType===I.ConnectionType.Tunnel){const ee=W.args;this.G(z,ee)}else return this.C(ae,z,"Unknown initial data received")}async G(le,M){const z=le.getSocket().socket,oe=le.readEntireBuffer();le.dispose(),z.pause();const ce=await this.H(M.host,M.port);oe.byteLength>0&&ce.write(oe.buffer),ce.on("end",()=>z.end()),ce.on("close",()=>z.end()),ce.on("error",()=>z.destroy()),z.on("end",()=>ce.end()),z.on("close",()=>ce.end()),z.on("error",()=>ce.destroy()),ce.pipe(z),z.pipe(ce)}H(le,M){return new Promise((z,oe)=>{const ce=S.createConnection({host:le,port:M,autoSelectFamily:!0},()=>{ce.removeListener("error",oe),ce.pause(),z(ce)});ce.once("error",oe)})}I(le){return typeof le.port=="number"?(0,l.$Yg)(le.port,10,5e3).then(M=>(le.port=M,le)):(le.debugId=void 0,le.port=void 0,le.break=void 0,Promise.resolve(le))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(le=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!le?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},ne))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};x=Ue([Ne(5,Q.$gn),Ne(6,D.$nk),Ne(7,u.$7j),Ne(8,h.$zi)],x);async function re(te,le,M){const z=await(0,P.$Cn)(le);z instanceof P.$An&&(console.warn(z.message),process.exit(1));function oe(G){(0,E.setUnexpectedErrorHandler)(se=>{(0,E.$Z)(se)&&se.stack&&/unexpectedErrorHandler/.test(se.stack)||G(se)})}const ce=[];oe(G=>{ce.push(G),console.error(G)});let pe=!1;process.on("SIGPIPE",()=>{pe||(pe=!0,(0,E.$1)(new Error("Unexpected SIGPIPE")))});const W=new $.$Tc,{socketServer:ae,instantiationService:ee}=await(0,X.$xQ)(z,le,M,W);ee.invokeFunction(G=>{const se=G.get(u.$7j);ce.forEach(fe=>se.error(fe)),ce.length=0,oe(fe=>se.error(fe))}),ee.invokeFunction(G=>{const se=G.get(i.$7i);c.$c&&(se.getValue("security.restrictUNCAccess")===!1?(0,t.disableUNCAccessRestrictions)():(0,t.addUNCHostToAllowlist)(se.getValue("security.allowedUNCHosts")))}),ee.invokeFunction(G=>{const se=G.get(u.$7j);if(c.$c&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const fe=(0,a.$jc)(process.env.HOMEDRIVE,"node_modules"),Ee=(0,a.$mc)((0,a.$jc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),Le=(0,a.$jc)(Ee,"node_modules");if(r.existsSync(fe)||r.existsSync(Le)){const de=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${fe}
* ${Le}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;se.warn(de),console.warn(de),process.exit(0)}}});const H=ee.invokeFunction(G=>{const se=G.get(u.$7j);if(r.existsSync((0,a.$jc)(w.$Ug.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(Ee){se.error(Ee)}return null});let L=le["server-base-path"];L&&!L.startsWith("/")&&(L=`/${L}`);const V=r.existsSync(w.$Ug.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(V&&te&&typeof te!="string"){const G=z.type!==P.ServerConnectionTokenType.None?`?${w.$Mg}=${z.value}`:"";console.log(`Web UI available at http://localhost${te.port===80?"":`:${te.port}`}${L??""}${G}`)}const B=ee.createInstance(x,ae,z,H,V,L);f.mark("code/server/ready");const U=k.performance.now(),K=global.vscodeServerStartTime,Z=global.vscodeServerListenTime,j=global.vscodeServerCodeLoadedTime;if(ee.invokeFunction(async G=>{const se=G.get(T.$6l);if(se.publicLog2("serverStart",{startTime:K,startedTime:Z,codeLoadedTime:j,readyTime:U}),c.$e){const fe=G.get(u.$7j),Ee=await(0,b.$Xg)(fe.error.bind(fe));Ee&&se.publicLog2("serverPlatformInfo",{platformId:Ee.id,platformVersionId:Ee.version_id,platformIdLike:Ee.id_like})}}),le["print-startup-performance"]){const G=A.$U.get();let se="";se+=`

### Load AMD-module
`,se+=A.$U.toMarkdownTable(["Module","Duration"],G.amdLoad),se+=`

### Load commonjs-module
`,se+=A.$U.toMarkdownTable(["Module","Duration"],G.nodeRequire),se+=`

### Invoke AMD-module factory
`,se+=A.$U.toMarkdownTable(["Module","Duration"],G.amdInvoke),se+=`

### Invoke commonjs-module
`,se+=A.$U.toMarkdownTable(["Module","Duration"],G.nodeEval),se+=`Start-up time: ${Z-K}
`,se+=`Code loading time: ${j-K}
`,se+=`Initialized time: ${U-K}
`,se+=`
`,console.log(se)}return B}class q{static create(le){const M=le.webEndpointUrlTemplate,z=le.commit,oe=le.quality;if(!M||!z||!oe)return new q(null);const ce=(0,m.$Wg)(),W=new URL(M.replace("{{uuid}}",ce).replace("{{commit}}",z).replace("{{quality}}",oe)).origin,ae=(0,g.$df)(W).replace(ce,"[a-zA-Z0-9\\-]+");try{const ee=(0,g.$mf)(`^${ae}$`,!0,{matchCase:!1});return new q(ee)}catch{return new q(null)}}constructor(le){this.a=le}matches(le){return this.a?this.a.test(le):!1}}}),define(Se[340],De([1,0,32,31,13,326,331,70,9,332,54,63,45]),function(he,e,n,r,S,k,R,A,v,s,E,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=c,e.createServer=g,$.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=s.performance.now();const w={onMultipleValues:(p,m)=>{console.error(`Option '${p}' can only be defined once. Using value ${m}.`)},onEmptyValue:p=>{console.error(`Ignoring option '${p}': Value must not be empty.`)},onUnknownOption:p=>{console.error(`Ignoring option '${p}': not supported for server.`)},onDeprecatedOption:(p,m)=>{console.warn(`Option '${p}' is deprecated: ${m}`)}};function a(){return(0,A.$zm)(process.argv.slice(2),E.$fn,w)}function f(p){const m=p["server-data-dir"]||p["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,v.$jc)(n.homedir(),y.default.serverDataFolderName||".vscode-remote"),b=p["user-data-dir"]||(0,v.$jc)(m,"data"),l=(0,v.$jc)(b,"User"),t=(0,v.$jc)(l,"globalStorage"),o=(0,v.$jc)(l,"History"),d=(0,v.$jc)(b,"Machine");p["user-data-dir"]=b;const i=(0,v.$mc)(S.$Ug.asFileUri("").fsPath),h=p["builtin-extensions-dir"]||(0,v.$jc)(i,"extensions");return p["builtin-extensions-dir"]=h,p["extensions-dir"]=p["extensions-dir"]||(0,v.$jc)(m,"extensions"),[m,p["extensions-dir"],b,l,d,t,o].forEach(u=>{try{r.existsSync(u)||r.mkdirSync(u,{mode:448})}catch(D){console.error(D)}}),m}function c(p=a()){return(0,k.run)(p,f(p),E.$fn)}function g(p,m=a()){return(0,R.$GQ)(p,m,f(m))}})}).call(this);

//# sourceMappingURL=server.main.js.map
