"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/async","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/network","vs/base/common/path","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/base/common/charCode","vs/platform/files/common/files","vs/base/common/map","vs/workbench/api/common/extHostInitDataService","vs/editor/common/core/range","vs/base/common/extpath","vs/base/common/uuid","vs/base/node/pfs","vs/platform/contextkey/common/contextkey","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/base/common/glob","vs/base/common/iterator","vs/base/common/marshallingIds","vs/workbench/api/common/extHostWorkspace","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostExtensionService","vs/base/common/process","vs/base/common/marshalling","fs","child_process","vs/editor/common/core/position","vs/editor/common/model","vs/base/common/decorators","vs/base/common/hash","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","os","net","vs/base/parts/ipc/common/ipc.net","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codicons","vs/base/common/uint","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/progress/common/progress","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/stream","vs/base/common/codiconsUtil","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/textModelSearch","vs/platform/instantiation/common/descriptors","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/serviceCollection","vs/platform/product/common/productService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","http","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostLanguageModels","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/arraysFind","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/cache","vs/base/common/scrollable","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/console","vs/amdX","vs/base/common/dataTransfer","vs/base/node/ports","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/request/common/request","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(oe){for(var e=[],r=0,u=oe.length;r<u;r++)e[r]=Ee[oe[r]];return e};define(Ee[173],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.LoaderEventType=e.$T=void 0,e.$T=!1;var r;(function(P){P[P.LoaderAvailable=1]="LoaderAvailable",P[P.BeginLoadingScript=10]="BeginLoadingScript",P[P.EndLoadingScriptOK=11]="EndLoadingScriptOK",P[P.EndLoadingScriptError=12]="EndLoadingScriptError",P[P.BeginInvokeFactory=21]="BeginInvokeFactory",P[P.EndInvokeFactory=22]="EndInvokeFactory",P[P.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",P[P.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",P[P.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",P[P.NodeEndNativeRequire=34]="NodeEndNativeRequire",P[P.CachedDataFound=60]="CachedDataFound",P[P.CachedDataMissed=61]="CachedDataMissed",P[P.CachedDataRejected=62]="CachedDataRejected",P[P.CachedDataCreated=63]="CachedDataCreated"})(r||(e.LoaderEventType=r={}));class u{static get(){const T=new Map,L=new Map,R=new Map,p=new Map;function l(w,a){w.has(a.detail)||w.set(a.detail,-a.timestamp)}function I(w,a){const d=w.get(a.detail);d&&(d>=0||w.set(a.detail,d+a.timestamp))}let D=[];typeof oe=="function"&&typeof oe.getStats=="function"&&(D=oe.getStats().slice(0).sort((w,a)=>w.timestamp-a.timestamp));for(const w of D)switch(w.type){case r.BeginLoadingScript:l(T,w);break;case r.EndLoadingScriptOK:case r.EndLoadingScriptError:I(T,w);break;case r.BeginInvokeFactory:l(L,w);break;case r.EndInvokeFactory:I(L,w);break;case r.NodeBeginNativeRequire:l(R,w);break;case r.NodeEndNativeRequire:I(R,w);break;case r.NodeBeginEvaluatingScript:l(p,w);break;case r.NodeEndEvaluatingScript:I(p,w);break}let f=0;R.forEach(w=>f+=w);function A(w){const a=[];return w.forEach((d,g)=>a.push([g,d])),a}return{amdLoad:A(T),amdInvoke:A(L),nodeRequire:A(R),nodeEval:A(p),nodeRequireTotal:f}}static toMarkdownTable(T,L){let R="";const p=[];return T.forEach((l,I)=>{p[I]=l.length}),L.forEach(l=>{l.forEach((I,D)=>{typeof I>"u"&&(I=l[D]="-");const f=I.toString().length;p[D]=Math.max(f,p[D])})}),T.forEach((l,I)=>{R+=`| ${l+" ".repeat(p[I]-l.toString().length)} `}),R+=`|
`,T.forEach((l,I)=>{R+=`| ${"-".repeat(p[I])} `}),R+=`|
`,L.forEach(l=>{l.forEach((I,D)=>{typeof I<"u"&&(R+=`| ${I+" ".repeat(p[D]-I.toString().length)} `)}),R+=`|
`}),R}}e.$U=u}),define(Ee[132],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=r,e.$gb=u,e.$hb=P,e.$ib=T,e.$jb=L,e.$kb=R,e.$lb=p,e.$nb=I,e.$ob=D,e.$pb=f,e.$qb=A,e.$rb=w;function r(a,d){const g=u(a,d);if(g!==-1)return a[g]}function u(a,d,g=a.length-1){for(let $=g;$>=0;$--){const i=a[$];if(d(i))return $}return-1}function P(a,d){const g=T(a,d);return g===-1?void 0:a[g]}function T(a,d,g=0,$=a.length){let i=g,o=$;for(;i<o;){const n=Math.floor((i+o)/2);d(a[n])?i=n+1:o=n}return i-1}function L(a,d){const g=R(a,d);return g===a.length?void 0:a[g]}function R(a,d,g=0,$=a.length){let i=g,o=$;for(;i<o;){const n=Math.floor((i+o)/2);d(a[n])?o=n:i=n+1}return i}function p(a,d,g=0,$=a.length){const i=R(a,d,g,$);return i===a.length?-1:i}class l{constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(l.assertInvariants){if(this.d){for(const $ of this.e)if(this.d($)&&!d($))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const g=T(this.e,d,this.c);return this.c=g+1,g===-1?void 0:this.e[g]}}e.$mb=l,l.assertInvariants=!1;function I(a,d){if(a.length===0)return;let g=a[0];for(let $=1;$<a.length;$++){const i=a[$];d(i,g)>0&&(g=i)}return g}function D(a,d){if(a.length===0)return;let g=a[0];for(let $=1;$<a.length;$++){const i=a[$];d(i,g)>=0&&(g=i)}return g}function f(a,d){return I(a,(g,$)=>-d(g,$))}function A(a,d){if(a.length===0)return-1;let g=0;for(let $=1;$<a.length;$++){const i=a[$];d(i,a[g])>0&&(g=$)}return g}function w(a,d){for(const g of a){const $=d(g);if($!==void 0)return $}}}),define(Ee[27],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var r;(function(u){u[u.Null=0]="Null",u[u.Backspace=8]="Backspace",u[u.Tab=9]="Tab",u[u.LineFeed=10]="LineFeed",u[u.CarriageReturn=13]="CarriageReturn",u[u.Space=32]="Space",u[u.ExclamationMark=33]="ExclamationMark",u[u.DoubleQuote=34]="DoubleQuote",u[u.Hash=35]="Hash",u[u.DollarSign=36]="DollarSign",u[u.PercentSign=37]="PercentSign",u[u.Ampersand=38]="Ampersand",u[u.SingleQuote=39]="SingleQuote",u[u.OpenParen=40]="OpenParen",u[u.CloseParen=41]="CloseParen",u[u.Asterisk=42]="Asterisk",u[u.Plus=43]="Plus",u[u.Comma=44]="Comma",u[u.Dash=45]="Dash",u[u.Period=46]="Period",u[u.Slash=47]="Slash",u[u.Digit0=48]="Digit0",u[u.Digit1=49]="Digit1",u[u.Digit2=50]="Digit2",u[u.Digit3=51]="Digit3",u[u.Digit4=52]="Digit4",u[u.Digit5=53]="Digit5",u[u.Digit6=54]="Digit6",u[u.Digit7=55]="Digit7",u[u.Digit8=56]="Digit8",u[u.Digit9=57]="Digit9",u[u.Colon=58]="Colon",u[u.Semicolon=59]="Semicolon",u[u.LessThan=60]="LessThan",u[u.Equals=61]="Equals",u[u.GreaterThan=62]="GreaterThan",u[u.QuestionMark=63]="QuestionMark",u[u.AtSign=64]="AtSign",u[u.A=65]="A",u[u.B=66]="B",u[u.C=67]="C",u[u.D=68]="D",u[u.E=69]="E",u[u.F=70]="F",u[u.G=71]="G",u[u.H=72]="H",u[u.I=73]="I",u[u.J=74]="J",u[u.K=75]="K",u[u.L=76]="L",u[u.M=77]="M",u[u.N=78]="N",u[u.O=79]="O",u[u.P=80]="P",u[u.Q=81]="Q",u[u.R=82]="R",u[u.S=83]="S",u[u.T=84]="T",u[u.U=85]="U",u[u.V=86]="V",u[u.W=87]="W",u[u.X=88]="X",u[u.Y=89]="Y",u[u.Z=90]="Z",u[u.OpenSquareBracket=91]="OpenSquareBracket",u[u.Backslash=92]="Backslash",u[u.CloseSquareBracket=93]="CloseSquareBracket",u[u.Caret=94]="Caret",u[u.Underline=95]="Underline",u[u.BackTick=96]="BackTick",u[u.a=97]="a",u[u.b=98]="b",u[u.c=99]="c",u[u.d=100]="d",u[u.e=101]="e",u[u.f=102]="f",u[u.g=103]="g",u[u.h=104]="h",u[u.i=105]="i",u[u.j=106]="j",u[u.k=107]="k",u[u.l=108]="l",u[u.m=109]="m",u[u.n=110]="n",u[u.o=111]="o",u[u.p=112]="p",u[u.q=113]="q",u[u.r=114]="r",u[u.s=115]="s",u[u.t=116]="t",u[u.u=117]="u",u[u.v=118]="v",u[u.w=119]="w",u[u.x=120]="x",u[u.y=121]="y",u[u.z=122]="z",u[u.OpenCurlyBrace=123]="OpenCurlyBrace",u[u.Pipe=124]="Pipe",u[u.CloseCurlyBrace=125]="CloseCurlyBrace",u[u.Tilde=126]="Tilde",u[u.NoBreakSpace=160]="NoBreakSpace",u[u.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",u[u.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",u[u.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",u[u.U_Combining_Tilde=771]="U_Combining_Tilde",u[u.U_Combining_Macron=772]="U_Combining_Macron",u[u.U_Combining_Overline=773]="U_Combining_Overline",u[u.U_Combining_Breve=774]="U_Combining_Breve",u[u.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",u[u.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",u[u.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",u[u.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",u[u.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",u[u.U_Combining_Caron=780]="U_Combining_Caron",u[u.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",u[u.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",u[u.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",u[u.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",u[u.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",u[u.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",u[u.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",u[u.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",u[u.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",u[u.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",u[u.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",u[u.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",u[u.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",u[u.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",u[u.U_Combining_Horn=795]="U_Combining_Horn",u[u.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",u[u.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",u[u.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",u[u.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",u[u.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",u[u.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",u[u.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",u[u.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",u[u.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",u[u.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",u[u.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",u[u.U_Combining_Cedilla=807]="U_Combining_Cedilla",u[u.U_Combining_Ogonek=808]="U_Combining_Ogonek",u[u.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",u[u.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",u[u.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",u[u.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",u[u.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",u[u.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",u[u.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",u[u.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",u[u.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",u[u.U_Combining_Low_Line=818]="U_Combining_Low_Line",u[u.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",u[u.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",u[u.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",u[u.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",u[u.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",u[u.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",u[u.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",u[u.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",u[u.U_Combining_Square_Below=827]="U_Combining_Square_Below",u[u.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",u[u.U_Combining_X_Above=829]="U_Combining_X_Above",u[u.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",u[u.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",u[u.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",u[u.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",u[u.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",u[u.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",u[u.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",u[u.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",u[u.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",u[u.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",u[u.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",u[u.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",u[u.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",u[u.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",u[u.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",u[u.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",u[u.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",u[u.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",u[u.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",u[u.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",u[u.U_Combining_Fermata=850]="U_Combining_Fermata",u[u.U_Combining_X_Below=851]="U_Combining_X_Below",u[u.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",u[u.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",u[u.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",u[u.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",u[u.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",u[u.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",u[u.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",u[u.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",u[u.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",u[u.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",u[u.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",u[u.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",u[u.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",u[u.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",u[u.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",u[u.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",u[u.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",u[u.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",u[u.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",u[u.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",u[u.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",u[u.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",u[u.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",u[u.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",u[u.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",u[u.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",u[u.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",u[u.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",u[u.LINE_SEPARATOR=8232]="LINE_SEPARATOR",u[u.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",u[u.NEXT_LINE=133]="NEXT_LINE",u[u.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",u[u.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",u[u.U_DIAERESIS=168]="U_DIAERESIS",u[u.U_MACRON=175]="U_MACRON",u[u.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",u[u.U_CEDILLA=184]="U_CEDILLA",u[u.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",u[u.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",u[u.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",u[u.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",u[u.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",u[u.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",u[u.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",u[u.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",u[u.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",u[u.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",u[u.U_BREVE=728]="U_BREVE",u[u.U_DOT_ABOVE=729]="U_DOT_ABOVE",u[u.U_RING_ABOVE=730]="U_RING_ABOVE",u[u.U_OGONEK=731]="U_OGONEK",u[u.U_SMALL_TILDE=732]="U_SMALL_TILDE",u[u.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",u[u.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",u[u.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",u[u.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",u[u.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",u[u.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",u[u.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",u[u.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",u[u.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",u[u.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",u[u.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",u[u.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",u[u.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",u[u.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",u[u.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",u[u.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",u[u.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",u[u.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",u[u.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",u[u.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",u[u.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",u[u.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",u[u.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",u[u.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",u[u.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",u[u.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",u[u.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",u[u.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",u[u.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",u[u.U_GREEK_TONOS=900]="U_GREEK_TONOS",u[u.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",u[u.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",u[u.U_GREEK_PSILI=8127]="U_GREEK_PSILI",u[u.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",u[u.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",u[u.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",u[u.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",u[u.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",u[u.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",u[u.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",u[u.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",u[u.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",u[u.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",u[u.U_GREEK_VARIA=8175]="U_GREEK_VARIA",u[u.U_GREEK_OXIA=8189]="U_GREEK_OXIA",u[u.U_GREEK_DASIA=8190]="U_GREEK_DASIA",u[u.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",u[u.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",u[u.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",u[u.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",u[u.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",u[u.U_OVERLINE=8254]="U_OVERLINE",u[u.UTF8_BOM=65279]="UTF8_BOM",u[u.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",u[u.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(r||(e.CharCode=r={}))}),define(Ee[79],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E=r,e.$F=u,e.$G=P,e.$H=T;function r(L,R){const p=Object.create(null);for(const l of L){const I=R(l);let D=p[I];D||(D=p[I]=[]),D.push(l)}return p}function u(L,R){const p=[],l=[];for(const I of L)R.has(I)||p.push(I);for(const I of R)L.has(I)||l.push(I);return{removed:p,added:l}}function P(L,R){const p=[],l=[];for(const[I,D]of L)R.has(I)||p.push(D);for(const[I,D]of R)L.has(I)||l.push(D);return{removed:p,added:l}}function T(L,R){const p=new Set;for(const l of R)L.has(l)&&p.add(l);return p}}),define(Ee[60],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=u,e.$6h=P,e.$7h=T;function r(L){return(R,p,l)=>{let I=null,D=null;if(typeof l.value=="function"?(I="value",D=l.value):typeof l.get=="function"&&(I="get",D=l.get),!D)throw new Error("not supported");l[I]=L(D,p)}}function u(L,R,p){let l=null,I=null;if(typeof p.value=="function"?(l="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(l="get",I=p.get),!I)throw new Error("not supported");const D=`$memoize$${R}`;p[l]=function(...f){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,f)}),this[D]}}function P(L,R,p){return r((l,I)=>{const D=`$debounce$${I}`,f=`$debounce$result$${I}`;return function(...A){this[f]||(this[f]=p?p():void 0),clearTimeout(this[D]),R&&(this[f]=R(this[f],...A),A=[this[f]]),this[D]=setTimeout(()=>{l.apply(this,A),this[f]=p?p():void 0},L)}})}function T(L,R,p){return r((l,I)=>{const D=`$throttle$timer$${I}`,f=`$throttle$result$${I}`,A=`$throttle$lastRun$${I}`,w=`$throttle$pending$${I}`;return function(...a){if(this[f]||(this[f]=p?p():void 0),(this[A]===null||this[A]===void 0)&&(this[A]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...a)),this[w])return;const d=this[A]+L;d<=Date.now()?(this[A]=Date.now(),l.apply(this,[this[f]]),this[f]=p?p():void 0):(this[w]=!0,this[D]=setTimeout(()=>{this[w]=!1,this[A]=Date.now(),l.apply(this,[this[f]]),this[f]=p?p():void 0},d-Date.now()))}})}}),define(Ee[14],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=u,e.$Z=P,e.$1=T,e.$2=L,e.$3=R,e.$4=l,e.$6=D,e.$7=f,e.$8=A,e.$0=a;class r{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?i.isErrorNoTelemetry(t)?new i(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(c=>{c(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=r,e.$X=new r;function u(n){e.$X.setUnexpectedErrorHandler(n)}function P(n){if(!n||typeof n!="object")return!1;const t=n;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function T(n){l(n)||e.$X.onUnexpectedError(n)}function L(n){l(n)||e.$X.onUnexpectedExternalError(n)}function R(n){if(n instanceof Error){const{name:t,message:c}=n,h=n.stacktrace||n.stack;return{$isError:!0,name:t,message:c,stack:h,noTelemetry:i.isErrorNoTelemetry(n)}}return n}const p="Canceled";function l(n){return n instanceof I?!0:n instanceof Error&&n.name===p&&n.message===p}class I extends Error{constructor(){super(p),this.name=this.message}}e.$5=I;function D(){const n=new Error(p);return n.name=n.message,n}function f(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}function A(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}class w extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=w;function a(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=d;class g extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=g;class $ extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=$;class i extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof i)return t;const c=new i;return c.message=t.message,c.stack=t.stack,c}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=i;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$cb=o}),define(Ee[19],Se([1,0,14,132]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=P,e.$tb=T,e.$ub=L,e.$vb=R,e.$wb=p,e.$xb=l,e.$yb=I,e.$zb=D,e.$Ab=f,e.$Bb=A,e.$Cb=w,e.$Db=a,e.$Eb=d,e.top=g,e.$Gb=$,e.$Hb=o,e.$Ib=n,e.$Jb=t,e.$Kb=c,e.$Lb=h,e.$Mb=s,e.$Nb=m,e.$Ob=y,e.$Pb=S,e.$Qb=E,e.$Rb=k,e.$Sb=C,e.$Tb=v,e.$Ub=b,e.$Vb=O,e.$Wb=U,e.$Xb=z,e.$Yb=j,e.$Zb=M,e.$1b=N,e.$2b=F,e.$3b=X,e.$4b=se,e.$5b=W,e.$6b=x,e.$7b=he,e.$0b=pe;function P(te,ee=0){return te[te.length-(1+ee)]}function T(te){if(te.length===0)throw new Error("Invalid tail call");return[te.slice(0,te.length-1),te[te.length-1]]}function L(te,ee,ie=(le,Z)=>le===Z){if(te===ee)return!0;if(!te||!ee||te.length!==ee.length)return!1;for(let le=0,Z=te.length;le<Z;le++)if(!ie(te[le],ee[le]))return!1;return!0}function R(te,ee){const ie=te.length-1;ee<ie&&(te[ee]=te[ie]),te.pop()}function p(te,ee,ie){return l(te.length,le=>ie(te[le],ee))}function l(te,ee){let ie=0,le=te-1;for(;ie<=le;){const Z=(ie+le)/2|0,ae=ee(Z);if(ae<0)ie=Z+1;else if(ae>0)le=Z-1;else return Z}return-(ie+1)}function I(te,ee,ie){if(te=te|0,te>=ee.length)throw new TypeError("invalid index");const le=ee[Math.floor(ee.length*Math.random())],Z=[],ae=[],$e=[];for(const be of ee){const Me=ie(be,le);Me<0?Z.push(be):Me>0?ae.push(be):$e.push(be)}return te<Z.length?I(te,Z,ie):te<Z.length+$e.length?$e[0]:I(te-(Z.length+$e.length),ae,ie)}function D(te,ee){const ie=[];let le;for(const Z of te.slice(0).sort(ee))!le||ee(le[0],Z)!==0?(le=[Z],ie.push(le)):le.push(Z);return ie}function*f(te,ee){let ie,le;for(const Z of te)le!==void 0&&ee(le,Z)?ie.push(Z):(ie&&(yield ie),ie=[Z]),le=Z;ie&&(yield ie)}function A(te,ee){for(let ie=0;ie<=te.length;ie++)ee(ie===0?void 0:te[ie-1],ie===te.length?void 0:te[ie])}function w(te,ee){for(let ie=0;ie<te.length;ie++)ee(ie===0?void 0:te[ie-1],te[ie],ie+1===te.length?void 0:te[ie+1])}function a(te,ee,ie){const le=[];function Z(be,Me,qe){if(Me===0&&qe.length===0)return;const De=le[le.length-1];De&&De.start+De.deleteCount===be?(De.deleteCount+=Me,De.toInsert.push(...qe)):le.push({start:be,deleteCount:Me,toInsert:qe})}let ae=0,$e=0;for(;;){if(ae===te.length){Z(ae,0,ee.slice($e));break}if($e===ee.length){Z(ae,te.length-ae,[]);break}const be=te[ae],Me=ee[$e],qe=ie(be,Me);qe===0?(ae+=1,$e+=1):qe<0?(Z(ae,1,[]),ae+=1):qe>0&&(Z(ae,0,[Me]),$e+=1)}return le}function d(te,ee,ie){const le=a(te,ee,ie),Z=[],ae=[];for(const $e of le)Z.push(...te.slice($e.start,$e.start+$e.deleteCount)),ae.push(...$e.toInsert);return{removed:Z,added:ae}}function g(te,ee,ie){if(ie===0)return[];const le=te.slice(0,ie).sort(ee);return i(te,ee,le,ie,te.length),le}function $(te,ee,ie,le,Z){return ie===0?Promise.resolve([]):new Promise((ae,$e)=>{(async()=>{const be=te.length,Me=te.slice(0,ie).sort(ee);for(let qe=ie,De=Math.min(ie+le,be);qe<be;qe=De,De=Math.min(De+le,be)){if(qe>ie&&await new Promise(Pe=>setTimeout(Pe)),Z&&Z.isCancellationRequested)throw new r.$5;i(te,ee,Me,qe,De)}return Me})().then(ae,$e)})}function i(te,ee,ie,le,Z){for(const ae=ie.length;le<Z;le++){const $e=te[le];if(ee($e,ie[ae-1])<0){ie.pop();const be=(0,u.$kb)(ie,Me=>ee($e,Me)<0);ie.splice(be,0,$e)}}}function o(te){return te.filter(ee=>!!ee)}function n(te){let ee=0;for(let ie=0;ie<te.length;ie++)te[ie]&&(te[ee]=te[ie],ee+=1);te.length=ee}function t(te,ee,ie){te.splice(ie,0,te.splice(ee,1)[0])}function c(te){return!Array.isArray(te)||te.length===0}function h(te){return Array.isArray(te)&&te.length>0}function s(te,ee=ie=>ie){const ie=new Set;return te.filter(le=>{const Z=ee(le);return ie.has(Z)?!1:(ie.add(Z),!0)})}function m(te){const ee=new Set;return ie=>{const le=te(ie);return ee.has(le)?!1:(ee.add(le),!0)}}function y(te,ee){return te.length>0?te[0]:ee}function S(te,ee){return te.length>0?te[te.length-1]:ee}function E(te,ee,ie=(le,Z)=>le===Z){let le=0;for(let Z=0,ae=Math.min(te.length,ee.length);Z<ae&&ie(te[Z],ee[Z]);Z++)le++;return le}function k(te,ee){let ie=typeof ee=="number"?te:0;typeof ee=="number"?ie=te:(ie=0,ee=te);const le=[];if(ie<=ee)for(let Z=ie;Z<ee;Z++)le.push(Z);else for(let Z=ie;Z>ee;Z--)le.push(Z);return le}function C(te,ee,ie){return te.reduce((le,Z)=>(le[ee(Z)]=ie?ie(Z):Z,le),Object.create(null))}function v(te,ee){return te.push(ee),()=>b(te,ee)}function b(te,ee){const ie=te.indexOf(ee);if(ie>-1)return te.splice(ie,1),ee}function O(te,ee,ie){const le=te.slice(0,ee),Z=te.slice(ee);return le.concat(ie,Z)}function U(te,ee){let ie;if(typeof ee=="number"){let le=ee;ie=()=>{const Z=Math.sin(le++)*179426549;return Z-Math.floor(Z)}}else ie=Math.random;for(let le=te.length-1;le>0;le-=1){const Z=Math.floor(ie()*(le+1)),ae=te[le];te[le]=te[Z],te[Z]=ae}}function z(te,ee){const ie=te.indexOf(ee);ie>-1&&(te.splice(ie,1),te.unshift(ee))}function j(te,ee){const ie=te.indexOf(ee);ie>-1&&(te.splice(ie,1),te.push(ee))}function M(te,ee){for(const ie of ee)te.push(ie)}function N(te,ee){return Array.isArray(te)?te.map(ee):ee(te)}function F(te){return Array.isArray(te)?te:[te]}function X(te){return te[Math.floor(Math.random()*te.length)]}function se(te,ee,ie){const le=H(te,ee),Z=te.length,ae=ie.length;te.length=Z+ae;for(let $e=Z-1;$e>=le;$e--)te[$e+ae]=te[$e];for(let $e=0;$e<ae;$e++)te[$e+le]=ie[$e]}function W(te,ee,ie,le){const Z=H(te,ee);let ae=te.splice(Z,ie);return ae===void 0&&(ae=[]),se(te,Z,le),ae}function H(te,ee){return ee<0?Math.max(ee+te.length,0):Math.min(ee,te.length)}var V;(function(te){function ee(ae){return ae<0}te.isLessThan=ee;function ie(ae){return ae<=0}te.isLessThanOrEqual=ie;function le(ae){return ae>0}te.isGreaterThan=le;function Z(ae){return ae===0}te.isNeitherLessOrGreaterThan=Z,te.greaterThan=1,te.lessThan=-1,te.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function x(te,ee){return(ie,le)=>ee(te(ie),te(le))}function he(...te){return(ee,ie)=>{for(const le of te){const Z=le(ee,ie);if(!V.isNeitherLessOrGreaterThan(Z))return Z}return V.neitherLessOrGreaterThan}}const ne=(te,ee)=>te-ee;e.$8b=ne;const we=(te,ee)=>(0,e.$8b)(te?1:0,ee?1:0);e.$9b=we;function pe(te){return(ee,ie)=>-te(ee,ie)}class ce{constructor(ee){this.g=ee,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let ie=this.c;for(;ie<this.g.length&&ee(this.g[ie]);)ie++;const le=ie===this.c?null:this.g.slice(this.c,ie);return this.c=ie,le}takeFromEndWhile(ee){let ie=this.d;for(;ie>=0&&ee(this.g[ie]);)ie--;const le=ie===this.d?null:this.g.slice(ie+1,this.d+1);return this.d=ie,le}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const ee=this.g[this.c];return this.c++,ee}removeLast(){const ee=this.g[this.d];return this.d--,ee}takeCount(ee){const ie=this.g.slice(this.c,this.c+ee);return this.c+=ee,ie}}e.$$b=ce;class K{constructor(ee){this.iterate=ee}forEach(ee){this.iterate(ie=>(ee(ie),!0))}toArray(){const ee=[];return this.iterate(ie=>(ee.push(ie),!0)),ee}filter(ee){return new K(ie=>this.iterate(le=>ee(le)?ie(le):!0))}map(ee){return new K(ie=>this.iterate(le=>ie(ee(le))))}some(ee){let ie=!1;return this.iterate(le=>(ie=ee(le),!ie)),ie}findFirst(ee){let ie;return this.iterate(le=>ee(le)?(ie=le,!1):!0),ie}findLast(ee){let ie;return this.iterate(le=>(ee(le)&&(ie=le),!0)),ie}findLastMaxBy(ee){let ie,le=!0;return this.iterate(Z=>((le||V.isGreaterThan(ee(Z,ie)))&&(le=!1,ie=Z),!0)),ie}}e.$_b=K,K.empty=new K(te=>{});class de{constructor(ee){this.c=ee}static createSortPermutation(ee,ie){const le=Array.from(ee.keys()).sort((Z,ae)=>ie(ee[Z],ee[ae]));return new de(le)}apply(ee){return ee.map((ie,le)=>ee[this.c[le]])}inverse(){const ee=this.c.slice();for(let ie=0;ie<this.c.length;ie++)ee[this.c[ie]]=ie;return new de(ee)}}e.$ac=de}),define(Ee[65],Se([1,0,14]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=u,e.$ed=P,e.$fd=T,e.$gd=L,e.$hd=R,e.$id=p;function u(l,I){if(!l)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}function P(l,I="Unreachable"){throw new Error(I)}function T(l,I="unexpected state"){if(!l)throw new r.$cb(`Assertion Failed: ${I}`)}function L(l){l||(0,r.$1)(new r.$cb("Soft Assertion Failed"))}function R(l){if(!l()){debugger;l(),(0,r.$1)(new r.$cb("Assertion Failed"))}}function p(l,I){let D=0;for(;D<l.length-1;){const f=l[D],A=l[D+1];if(!I(f,A))return!1;D++}return!0}}),define(Ee[174],Se([1,0,19]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=P,e.$8c=T,e.$9c=L,e.$0c=R,e.$$c=p,e.$_c=l;const u=(A,w)=>A===w;e.$6c=u;function P(A=e.$6c){return(w,a)=>r.$ub(w,a,A)}function T(){return(A,w)=>JSON.stringify(A)===JSON.stringify(w)}function L(){return(A,w)=>A.equals(w)}function R(A,w,a){return!A||!w?A===w:a(A,w)}function p(A,w){if(A===w)return!0;if(Array.isArray(A)&&Array.isArray(w)){if(A.length!==w.length)return!1;for(let a=0;a<A.length;a++)if(!p(A[a],w[a]))return!1;return!0}if(A&&typeof A=="object"&&w&&typeof w=="object"&&Object.getPrototypeOf(A)===Object.prototype&&Object.getPrototypeOf(w)===Object.prototype){const a=A,d=w,g=Object.keys(a),$=Object.keys(d),i=new Set($);if(g.length!==$.length)return!1;for(const o of g)if(!i.has(o)||!p(a[o],d[o]))return!1;return!0}return!1}function l(A){return JSON.stringify(f(A))}let I=0;const D=new WeakMap;function f(A){if(Array.isArray(A))return A.map(f);if(A&&typeof A=="object")if(Object.getPrototypeOf(A)===Object.prototype){const w=A,a=Object.create(null);for(const d of Object.keys(w).sort())a[d]=f(w[d]);return a}else{let w=D.get(A);return w===void 0&&(w=I++,D.set(A,w)),w+"----2b76a038c20c4bcc"}return A}}),define(Ee[80],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=r;function r(u,P){const T=this;let L=!1,R;return function(){if(L)return R;if(L=!0,P)try{R=u.apply(T,arguments)}finally{P()}else R=u.apply(T,arguments);return R}}}),define(Ee[133],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6O=e.$5O=void 0;class r{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$5O=r,e.$6O=new r("id#")}),define(Ee[40],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var r;(function(u){function P(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}u.is=P;const T=Object.freeze([]);function L(){return T}u.empty=L;function*R(t){yield t}u.single=R;function p(t){return P(t)?t:R(t)}u.wrap=p;function l(t){return t||T}u.from=l;function*I(t){for(let c=t.length-1;c>=0;c--)yield t[c]}u.reverse=I;function D(t){return!t||t[Symbol.iterator]().next().done===!0}u.isEmpty=D;function f(t){return t[Symbol.iterator]().next().value}u.first=f;function A(t,c){for(const h of t)if(c(h))return!0;return!1}u.some=A;function w(t,c){for(const h of t)if(c(h))return h}u.find=w;function*a(t,c){for(const h of t)c(h)&&(yield h)}u.filter=a;function*d(t,c){let h=0;for(const s of t)yield c(s,h++)}u.map=d;function*g(...t){for(const c of t)yield*c}u.concat=g;function $(t,c,h){let s=h;for(const m of t)s=c(s,m);return s}u.reduce=$;function*i(t,c,h=t.length){for(c<0&&(c+=t.length),h<0?h+=t.length:h>t.length&&(h=t.length);c<h;c++)yield t[c]}u.slice=i;function o(t,c=Number.POSITIVE_INFINITY){const h=[];if(c===0)return[h,t];const s=t[Symbol.iterator]();for(let m=0;m<c;m++){const y=s.next();if(y.done)return[h,u.empty()];h.push(y.value)}return[h,{[Symbol.iterator](){return s}}]}u.consume=o;async function n(t){const c=[];for await(const h of t)c.push(h);return Promise.resolve(c)}u.asyncToArray=n})(r||(e.Iterable=r={}))}),define(Ee[175],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$On=L,e.$Pn=D,e.$Qn=f,e.$Rn=A,e.$Sn=w,e.$Tn=a,e.$Un=d,e.$Vn=g,e.$Wn=$,e.$Xn=i,e.$Yn=o,e.$Zn=n;var r;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(r||(e.ScanError=r={}));var u;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(u||(e.SyntaxKind=u={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function L(t,c=!1){let h=0;const s=t.length;let m="",y=0,S=u.Unknown,E=r.None;function k(j){let M=0,N=0;for(;M<j;){const F=t.charCodeAt(h);if(F>=I._0&&F<=I._9)N=N*16+F-I._0;else if(F>=I.A&&F<=I.F)N=N*16+F-I.A+10;else if(F>=I.a&&F<=I.f)N=N*16+F-I.a+10;else break;h++,M++}return M<j&&(N=-1),N}function C(j){h=j,m="",y=0,S=u.Unknown,E=r.None}function v(){const j=h;if(t.charCodeAt(h)===I._0)h++;else for(h++;h<t.length&&l(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===I.dot)if(h++,h<t.length&&l(t.charCodeAt(h)))for(h++;h<t.length&&l(t.charCodeAt(h));)h++;else return E=r.UnexpectedEndOfNumber,t.substring(j,h);let M=h;if(h<t.length&&(t.charCodeAt(h)===I.E||t.charCodeAt(h)===I.e))if(h++,(h<t.length&&t.charCodeAt(h)===I.plus||t.charCodeAt(h)===I.minus)&&h++,h<t.length&&l(t.charCodeAt(h))){for(h++;h<t.length&&l(t.charCodeAt(h));)h++;M=h}else E=r.UnexpectedEndOfNumber;return t.substring(j,M)}function b(){let j="",M=h;for(;;){if(h>=s){j+=t.substring(M,h),E=r.UnexpectedEndOfString;break}const N=t.charCodeAt(h);if(N===I.doubleQuote){j+=t.substring(M,h),h++;break}if(N===I.backslash){if(j+=t.substring(M,h),h++,h>=s){E=r.UnexpectedEndOfString;break}switch(t.charCodeAt(h++)){case I.doubleQuote:j+='"';break;case I.backslash:j+="\\";break;case I.slash:j+="/";break;case I.b:j+="\b";break;case I.f:j+="\f";break;case I.n:j+=`
`;break;case I.r:j+="\r";break;case I.t:j+="	";break;case I.u:{const X=k(4);X>=0?j+=String.fromCharCode(X):E=r.InvalidUnicode;break}default:E=r.InvalidEscapeCharacter}M=h;continue}if(N>=0&&N<=31)if(p(N)){j+=t.substring(M,h),E=r.UnexpectedEndOfString;break}else E=r.InvalidCharacter;h++}return j}function O(){if(m="",E=r.None,y=h,h>=s)return y=s,S=u.EOF;let j=t.charCodeAt(h);if(R(j)){do h++,m+=String.fromCharCode(j),j=t.charCodeAt(h);while(R(j));return S=u.Trivia}if(p(j))return h++,m+=String.fromCharCode(j),j===I.carriageReturn&&t.charCodeAt(h)===I.lineFeed&&(h++,m+=`
`),S=u.LineBreakTrivia;switch(j){case I.openBrace:return h++,S=u.OpenBraceToken;case I.closeBrace:return h++,S=u.CloseBraceToken;case I.openBracket:return h++,S=u.OpenBracketToken;case I.closeBracket:return h++,S=u.CloseBracketToken;case I.colon:return h++,S=u.ColonToken;case I.comma:return h++,S=u.CommaToken;case I.doubleQuote:return h++,m=b(),S=u.StringLiteral;case I.slash:{const M=h-1;if(t.charCodeAt(h+1)===I.slash){for(h+=2;h<s&&!p(t.charCodeAt(h));)h++;return m=t.substring(M,h),S=u.LineCommentTrivia}if(t.charCodeAt(h+1)===I.asterisk){h+=2;const N=s-1;let F=!1;for(;h<N;){if(t.charCodeAt(h)===I.asterisk&&t.charCodeAt(h+1)===I.slash){h+=2,F=!0;break}h++}return F||(h++,E=r.UnexpectedEndOfComment),m=t.substring(M,h),S=u.BlockCommentTrivia}return m+=String.fromCharCode(j),h++,S=u.Unknown}case I.minus:if(m+=String.fromCharCode(j),h++,h===s||!l(t.charCodeAt(h)))return S=u.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return m+=v(),S=u.NumericLiteral;default:for(;h<s&&U(j);)h++,j=t.charCodeAt(h);if(y!==h){switch(m=t.substring(y,h),m){case"true":return S=u.TrueKeyword;case"false":return S=u.FalseKeyword;case"null":return S=u.NullKeyword}return S=u.Unknown}return m+=String.fromCharCode(j),h++,S=u.Unknown}}function U(j){if(R(j)||p(j))return!1;switch(j){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function z(){let j;do j=O();while(j>=u.LineCommentTrivia&&j<=u.Trivia);return j}return{setPosition:C,getPosition:()=>h,scan:c?z:O,getToken:()=>S,getTokenValue:()=>m,getTokenOffset:()=>y,getTokenLength:()=>h-y,getTokenError:()=>E}}function R(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function p(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function l(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function D(t,c){const h=[],s=new Object;let m;const y={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function E(k,C,v,b){y.value=k,y.offset=C,y.length=v,y.type=b,y.colonOffset=void 0,m=y}try{i(t,{onObjectBegin:(k,C)=>{if(c<=k)throw s;m=void 0,S=c>k,h.push("")},onObjectProperty:(k,C,v)=>{if(c<C||(E(k,C,v,"property"),h[h.length-1]=k,c<=C+v))throw s},onObjectEnd:(k,C)=>{if(c<=k)throw s;m=void 0,h.pop()},onArrayBegin:(k,C)=>{if(c<=k)throw s;m=void 0,h.push(0)},onArrayEnd:(k,C)=>{if(c<=k)throw s;m=void 0,h.pop()},onLiteralValue:(k,C,v)=>{if(c<C||(E(k,C,v,n(k)),c<=C+v))throw s},onSeparator:(k,C,v)=>{if(c<=C)throw s;if(k===":"&&m&&m.type==="property")m.colonOffset=C,S=!1,m=void 0;else if(k===","){const b=h[h.length-1];typeof b=="number"?h[h.length-1]=b+1:(S=!0,h[h.length-1]=""),m=void 0}}})}catch(k){if(k!==s)throw k}return{path:h,previousNode:m,isAtPropertyKey:S,matches:k=>{let C=0;for(let v=0;C<k.length&&v<h.length;v++)if(k[C]===h[v]||k[C]==="*")C++;else if(k[C]!=="**")return!1;return C===k.length}}}function f(t,c=[],h=T.DEFAULT){let s=null,m=[];const y=[];function S(k){Array.isArray(m)?m.push(k):s!==null&&(m[s]=k)}return i(t,{onObjectBegin:()=>{const k={};S(k),y.push(m),m=k,s=null},onObjectProperty:k=>{s=k},onObjectEnd:()=>{m=y.pop()},onArrayBegin:()=>{const k=[];S(k),y.push(m),m=k,s=null},onArrayEnd:()=>{m=y.pop()},onLiteralValue:S,onError:(k,C,v)=>{c.push({error:k,offset:C,length:v})}},h),m[0]}function A(t,c=[],h=T.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(k){s.type==="property"&&(s.length=k-s.offset,s=s.parent)}function y(k){return s.children.push(k),k}i(t,{onObjectBegin:k=>{s=y({type:"object",offset:k,length:-1,parent:s,children:[]})},onObjectProperty:(k,C,v)=>{s=y({type:"property",offset:C,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:k,offset:C,length:v,parent:s})},onObjectEnd:(k,C)=>{s.length=k+C-s.offset,s=s.parent,m(k+C)},onArrayBegin:(k,C)=>{s=y({type:"array",offset:k,length:-1,parent:s,children:[]})},onArrayEnd:(k,C)=>{s.length=k+C-s.offset,s=s.parent,m(k+C)},onLiteralValue:(k,C,v)=>{y({type:n(k),offset:C,length:v,parent:s,value:k}),m(C+v)},onSeparator:(k,C,v)=>{s.type==="property"&&(k===":"?s.colonOffset=C:k===","&&m(C))},onError:(k,C,v)=>{c.push({error:k,offset:C,length:v})}},h);const E=s.children[0];return E&&delete E.parent,E}function w(t,c){if(!t)return;let h=t;for(const s of c)if(typeof s=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let m=!1;for(const y of h.children)if(Array.isArray(y.children)&&y.children[0].value===s){h=y.children[1],m=!0;break}if(!m)return}else{const m=s;if(h.type!=="array"||m<0||!Array.isArray(h.children)||m>=h.children.length)return;h=h.children[m]}return h}function a(t){if(!t.parent||!t.parent.children)return[];const c=a(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;c.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&c.push(h)}return c}function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const c=Object.create(null);for(const h of t.children){const s=h.children[1];s&&(c[h.children[0].value]=d(s))}return c}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function g(t,c,h=!1){return c>=t.offset&&c<t.offset+t.length||h&&c===t.offset+t.length}function $(t,c,h=!1){if(g(t,c,h)){const s=t.children;if(Array.isArray(s))for(let m=0;m<s.length&&s[m].offset<=c;m++){const y=$(s[m],c,h);if(y)return y}return t}}function i(t,c,h=T.DEFAULT){const s=L(t,!1);function m(he){return he?()=>he(s.getTokenOffset(),s.getTokenLength()):()=>!0}function y(he){return he?ne=>he(ne,s.getTokenOffset(),s.getTokenLength()):()=>!0}const S=m(c.onObjectBegin),E=y(c.onObjectProperty),k=m(c.onObjectEnd),C=m(c.onArrayBegin),v=m(c.onArrayEnd),b=y(c.onLiteralValue),O=y(c.onSeparator),U=m(c.onComment),z=y(c.onError),j=h&&h.disallowComments,M=h&&h.allowTrailingComma;function N(){for(;;){const he=s.scan();switch(s.getTokenError()){case r.InvalidUnicode:F(P.InvalidUnicode);break;case r.InvalidEscapeCharacter:F(P.InvalidEscapeCharacter);break;case r.UnexpectedEndOfNumber:F(P.UnexpectedEndOfNumber);break;case r.UnexpectedEndOfComment:j||F(P.UnexpectedEndOfComment);break;case r.UnexpectedEndOfString:F(P.UnexpectedEndOfString);break;case r.InvalidCharacter:F(P.InvalidCharacter);break}switch(he){case u.LineCommentTrivia:case u.BlockCommentTrivia:j?F(P.InvalidCommentToken):U();break;case u.Unknown:F(P.InvalidSymbol);break;case u.Trivia:case u.LineBreakTrivia:break;default:return he}}}function F(he,ne=[],we=[]){if(z(he),ne.length+we.length>0){let pe=s.getToken();for(;pe!==u.EOF;){if(ne.indexOf(pe)!==-1){N();break}else if(we.indexOf(pe)!==-1)break;pe=N()}}}function X(he){const ne=s.getTokenValue();return he?b(ne):E(ne),N(),!0}function se(){switch(s.getToken()){case u.NumericLiteral:{let he=0;try{he=JSON.parse(s.getTokenValue()),typeof he!="number"&&(F(P.InvalidNumberFormat),he=0)}catch{F(P.InvalidNumberFormat)}b(he);break}case u.NullKeyword:b(null);break;case u.TrueKeyword:b(!0);break;case u.FalseKeyword:b(!1);break;default:return!1}return N(),!0}function W(){return s.getToken()!==u.StringLiteral?(F(P.PropertyNameExpected,[],[u.CloseBraceToken,u.CommaToken]),!1):(X(!1),s.getToken()===u.ColonToken?(O(":"),N(),x()||F(P.ValueExpected,[],[u.CloseBraceToken,u.CommaToken])):F(P.ColonExpected,[],[u.CloseBraceToken,u.CommaToken]),!0)}function H(){S(),N();let he=!1;for(;s.getToken()!==u.CloseBraceToken&&s.getToken()!==u.EOF;){if(s.getToken()===u.CommaToken){if(he||F(P.ValueExpected,[],[]),O(","),N(),s.getToken()===u.CloseBraceToken&&M)break}else he&&F(P.CommaExpected,[],[]);W()||F(P.ValueExpected,[],[u.CloseBraceToken,u.CommaToken]),he=!0}return k(),s.getToken()!==u.CloseBraceToken?F(P.CloseBraceExpected,[u.CloseBraceToken],[]):N(),!0}function V(){C(),N();let he=!1;for(;s.getToken()!==u.CloseBracketToken&&s.getToken()!==u.EOF;){if(s.getToken()===u.CommaToken){if(he||F(P.ValueExpected,[],[]),O(","),N(),s.getToken()===u.CloseBracketToken&&M)break}else he&&F(P.CommaExpected,[],[]);x()||F(P.ValueExpected,[],[u.CloseBracketToken,u.CommaToken]),he=!0}return v(),s.getToken()!==u.CloseBracketToken?F(P.CloseBracketExpected,[u.CloseBracketToken],[]):N(),!0}function x(){switch(s.getToken()){case u.OpenBracketToken:return V();case u.OpenBraceToken:return H();case u.StringLiteral:return X(!0);default:return se()}}return N(),s.getToken()===u.EOF?h.allowEmptyContent?!0:(F(P.ValueExpected,[],[]),!1):x()?(s.getToken()!==u.EOF&&F(P.EndOfFileExpected,[],[]),!0):(F(P.ValueExpected,[],[]),!1)}function o(t,c){const h=L(t),s=[];let m,y=0,S;do switch(S=h.getPosition(),m=h.scan(),m){case u.LineCommentTrivia:case u.BlockCommentTrivia:case u.EOF:y!==S&&s.push(t.substring(y,S)),c!==void 0&&s.push(h.getTokenValue().replace(/[^\r\n]/g,c)),y=h.getPosition();break}while(m!==u.EOF);return s.join("")}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ee[49],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class r{constructor(P){this.d=P,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(P){this.c=P}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=r}),define(Ee[81],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class r{constructor(T){this.element=T,this.next=r.Undefined,this.prev=r.Undefined}}r.Undefined=new r(void 0);class u{constructor(){this.a=r.Undefined,this.b=r.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===r.Undefined}clear(){let T=this.a;for(;T!==r.Undefined;){const L=T.next;T.prev=r.Undefined,T.next=r.Undefined,T=L}this.a=r.Undefined,this.b=r.Undefined,this.c=0}unshift(T){return this.d(T,!1)}push(T){return this.d(T,!0)}d(T,L){const R=new r(T);if(this.a===r.Undefined)this.a=R,this.b=R;else if(L){const l=this.b;this.b=R,R.prev=l,l.next=R}else{const l=this.a;this.a=R,R.next=l,l.prev=R}this.c+=1;let p=!1;return()=>{p||(p=!0,this.e(R))}}shift(){if(this.a!==r.Undefined){const T=this.a.element;return this.e(this.a),T}}pop(){if(this.b!==r.Undefined){const T=this.b.element;return this.e(this.b),T}}e(T){if(T.prev!==r.Undefined&&T.next!==r.Undefined){const L=T.prev;L.next=T.next,T.next.prev=L}else T.prev===r.Undefined&&T.next===r.Undefined?(this.a=r.Undefined,this.b=r.Undefined):T.next===r.Undefined?(this.b=this.b.prev,this.b.next=r.Undefined):T.prev===r.Undefined&&(this.a=this.a.next,this.a.prev=r.Undefined);this.c-=1}*[Symbol.iterator](){let T=this.a;for(;T!==r.Undefined;)yield T.element,T=T.next}}e.$5c=u}),define(Ee[29],Se([1,0]),function(oe,e){"use strict";var r,u,P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=T,e.$yc=L,e.$zc=R,e.$Ic=o;function T(n,t,c){let h=n.get(t);return h===void 0&&(h=c,n.set(t,h)),h}function L(n){const t=[];return n.forEach((c,h)=>{t.push(`${h} => ${c}`)}),`Map(${n.size}) {${t.join(", ")}}`}function R(n){const t=[];return n.forEach(c=>{t.push(c)}),`Set(${n.size}) {${t.join(", ")}}`}class p{constructor(t,c){this.uri=t,this.value=c}}function l(n){return Array.isArray(n)}class I{constructor(t,c){if(this[r]="ResourceMap",t instanceof I)this.d=new Map(t.d),this.e=c??I.c;else if(l(t)){this.d=new Map,this.e=c??I.c;for(const[h,s]of t)this.set(h,s)}else this.d=new Map,this.e=t??I.c}set(t,c){return this.d.set(this.e(t),new p(t,c)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,c){typeof c<"u"&&(t=t.bind(c));for(const[h,s]of this.d)t(s.value,s.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(r=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=I,I.c=n=>n.toString();class D{constructor(t,c){this[u]="ResourceSet",!t||typeof t=="function"?this.c=new I(t):(this.c=new I(c),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,c){this.c.forEach((h,s)=>t.call(c,s,s,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(u=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=D;var f;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(f||(e.Touch=f={}));class A{constructor(){this[P]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,c=f.None){const h=this.c.get(t);if(h)return c!==f.None&&this.m(h,c),h.value}set(t,c,h=f.None){let s=this.c.get(t);if(s)s.value=c,h!==f.None&&this.m(s,h);else{switch(s={key:t,value:c,next:void 0,previous:void 0},h){case f.None:this.k(s);break;case f.AsOld:this.j(s);break;case f.AsNew:this.k(s);break;default:this.k(s);break}this.c.set(t,s),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this.c.get(t);if(c)return this.c.delete(t),this.l(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,c){const h=this.g;let s=this.d;for(;s;){if(c?t.bind(c)(s.value,s.key,this):t(s.value,s.key,this),this.g!==h)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const t=this,c=this.g;let h=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:h.key,done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return s}values(){const t=this,c=this.g;let h=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:h.value,done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return s}entries(){const t=this,c=this.g;let h=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(h){const m={value:[h.key,h.value],done:!1};return h=h.next,m}else return{value:void 0,done:!0}}};return s}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.d,h=this.size;for(;c&&h>t;)this.c.delete(c.key),c=c.next,h--;this.d=c,this.f=h,c&&(c.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.e,h=this.size;for(;c&&h>t;)this.c.delete(c.key),c=c.previous,h--;this.e=c,this.f=h,c&&(c.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const c=t.next,h=t.previous;if(!c||!h)throw new Error("Invalid list");c.previous=h,h.next=c}t.next=void 0,t.previous=void 0,this.g++}m(t,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==f.AsOld&&c!==f.AsNew)){if(c===f.AsOld){if(t===this.d)return;const h=t.next,s=t.previous;t===this.e?(s.next=void 0,this.e=s):(h.previous=s,s.next=h),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(c===f.AsNew){if(t===this.e)return;const h=t.next,s=t.previous;t===this.d?(h.previous=void 0,this.d=h):(h.previous=s,s.next=h),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((c,h)=>{t.push([h,c])}),t}fromJSON(t){this.clear();for(const[c,h]of t)this.set(c,h)}}e.$Cc=A;class w extends A{constructor(t,c=1){super(),this.n=t,this.o=Math.min(Math.max(0,c),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,c=f.AsNew){return super.get(t,c)}peek(t){return super.get(t,f.None)}set(t,c){return super.set(t,c,f.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends w{constructor(t,c=1){super(t,c)}q(t){this.h(t)}set(t,c){return super.set(t,c),this.p(),this}}e.$Dc=a;class d extends w{constructor(t,c=1){super(t,c)}q(t){this.i(t)}set(t,c){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,c),this}}e.$Ec=d;class g{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let c=this.c.get(t)||0;return c===0?!1:(c--,c===0?this.c.delete(t):this.c.set(t,c),!0)}has(t){return this.c.has(t)}}e.$Fc=g;class ${constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[c,h]of t)this.set(c,h)}clear(){this.c.clear(),this.d.clear()}set(t,c){this.c.set(t,c),this.d.set(c,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const c=this.c.get(t);return c===void 0?!1:(this.c.delete(t),this.d.delete(c),!0)}forEach(t,c){this.c.forEach((h,s)=>{t.call(c,h,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=$;class i{constructor(){this.c=new Map}add(t,c){let h=this.c.get(t);h||(h=new Set,this.c.set(t,h)),h.add(c)}delete(t,c){const h=this.c.get(t);h&&(h.delete(c),h.size===0&&this.c.delete(t))}forEach(t,c){const h=this.c.get(t);h&&h.forEach(c)}get(t){const c=this.c.get(t);return c||new Set}}e.$Hc=i;function o(n,t){if(n===t)return!0;if(n.size!==t.size)return!1;for(const[c,h]of n)if(!t.has(c)||t.get(c)!==h)return!1;for(const[c]of t)if(!n.has(c))return!1;return!0}}),define(Ee[3],Se([1,0,19,79,29,80,40]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=I,e.$Lc=D,e.$Mc=f,e.$Nc=a,e.$Oc=d,e.$Pc=g,e.$Qc=$,e.$Rc=i,e.$Sc=o,e.$3c=k;const R=!1;let p=null;class l{constructor(){this.b=new Map}c(b){let O=this.b.get(b);return O||(O={parent:null,source:null,isSingleton:!1,value:b,idx:l.a++},this.b.set(b,O)),O}trackDisposable(b){const O=this.c(b);O.source||(O.source=new Error().stack)}setParent(b,O){const U=this.c(b);U.parent=O}markAsDisposed(b){this.b.delete(b)}markAsSingleton(b){this.c(b).isSingleton=!0}f(b,O){const U=O.get(b);if(U)return U;const z=b.parent?this.f(this.c(b.parent),O):b;return O.set(b,z),z}getTrackedDisposables(){const b=new Map;return[...this.b.entries()].filter(([,U])=>U.source!==null&&!this.f(U,b).isSingleton).flatMap(([U])=>U)}computeLeakingDisposables(b=10,O){let U;if(O)U=O;else{const F=new Map,X=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,F).isSingleton);if(X.length===0)return;const se=new Set(X.map(W=>W.value));if(U=X.filter(W=>!(W.parent&&se.has(W.parent))),U.length===0)throw new Error("There are cyclic diposable chains!")}if(!U)return;function z(F){function X(W,H){for(;W.length>0&&H.some(V=>typeof V=="string"?V===W[0]:W[0].match(V));)W.shift()}const se=F.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return X(se,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),se.reverse()}const j=new P.$Hc;for(const F of U){const X=z(F);for(let se=0;se<=X.length;se++)j.add(X.slice(0,se).join(`
`),F)}U.sort((0,r.$6b)(F=>F.idx,r.$8b));let M="",N=0;for(const F of U.slice(0,b)){N++;const X=z(F),se=[];for(let W=0;W<X.length;W++){let H=X[W];H=`(shared with ${j.get(X.slice(0,W+1).join(`
`)).size}/${U.length} leaks) at ${H}`;const x=j.get(X.slice(0,W).join(`
`)),he=(0,u.$E)([...x].map(ne=>z(ne)[W]),ne=>ne);delete he[X[W]];for(const[ne,we]of Object.entries(he))se.unshift(`    - stacktraces of ${we.length} other leaks continue with ${ne}`);se.unshift(H)}M+=`


==================== Leaking disposable ${N}/${U.length}: ${F.value.constructor.name} ====================
${se.join(`
`)}
============================================================

`}return U.length>b&&(M+=`


... and ${U.length-b} more leaking disposables

`),{leaks:U,details:M}}}e.$Jc=l,l.a=0;function I(v){p=v}if(R){const v="__is_disposable_tracked__";I(new class{trackDisposable(b){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{b[v]||console.log(O)},3e3)}setParent(b,O){if(b&&b!==t.None)try{b[v]=!0}catch{}}markAsDisposed(b){if(b&&b!==t.None)try{b[v]=!0}catch{}}markAsSingleton(b){}})}function D(v){return p?.trackDisposable(v),v}function f(v){p?.markAsDisposed(v)}function A(v,b){p?.setParent(v,b)}function w(v,b){if(p)for(const O of v)p.setParent(O,b)}function a(v){return p?.markAsSingleton(v),v}function d(v){return typeof v=="object"&&v!==null&&typeof v.dispose=="function"&&v.dispose.length===0}function g(v){if(L.Iterable.is(v)){const b=[];for(const O of v)if(O)try{O.dispose()}catch(U){b.push(U)}if(b.length===1)throw b[0];if(b.length>1)throw new AggregateError(b,"Encountered errors while disposing of store");return Array.isArray(v)?[]:v}else if(v)return v.dispose(),v}function $(v){for(const b of v)d(b)&&b.dispose();return[]}function i(...v){const b=o(()=>g(v));return w(v,b),b}function o(v){const b=D({dispose:(0,T.$db)(()=>{f(b),v()})});return b}class n{constructor(){this.f=new Set,this.g=!1,D(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(b){if(!b)return b;if(b===this)throw new Error("Cannot register a disposable on itself!");return A(b,this),this.g?n.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(b),b}delete(b){if(b){if(b===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(b),b.dispose()}}deleteAndLeak(b){b&&this.f.has(b)&&(this.f.delete(b),A(b,null))}}e.$Tc=n,n.DISABLE_DISPOSED_WARNING=!1;class t{constructor(){this.q=new n,D(this),A(this.q,this)}dispose(){f(this),this.q.dispose()}B(b){if(b===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(b)}}e.$Uc=t,t.None=Object.freeze({dispose(){}});class c{constructor(){this.b=!1,D(this)}get value(){return this.b?void 0:this.a}set value(b){this.b||b===this.a||(this.a?.dispose(),b&&A(b,this),this.a=b)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const b=this.a;return this.a=void 0,b&&A(b,null),b}}e.$Vc=c;class h{constructor(b){this.a=new c,this.b=!1,this.a.value=b}get value(){return this.a.value}set value(b){this.b||b===this.a.value||(this.a.value=b)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=h;class s{constructor(b){this.b=b,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(b){let O=b;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,f(this))},this}}e.$Yc=m;class y{constructor(){this.a=new Map}acquire(b,...O){let U=this.a.get(b);U||(U={counter:0,object:this.b(b,...O)},this.a.set(b,U));const{object:z}=U,j=(0,T.$db)(()=>{--U.counter===0&&(this.c(b,U.object),this.a.delete(b))});return U.counter++,{object:z,dispose:j}}}e.$Zc=y;class S{constructor(b){this.a=b}async acquire(b,...O){const U=this.a.acquire(b,...O);try{return{object:await U.object,dispose:()=>U.dispose()}}catch(z){throw U.dispose(),z}}}e.$1c=S;class E{constructor(b){this.object=b}dispose(){}}e.$2c=E;function k(v){const b=new n;try{v(b)}finally{b.dispose()}}class C{constructor(){this.a=new Map,this.b=!1,D(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(b){return this.a.has(b)}get size(){return this.a.size}get(b){return this.a.get(b)}set(b,O,U=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),U||this.a.get(b)?.dispose(),this.a.set(b,O)}deleteAndDispose(b){this.a.get(b)?.dispose(),this.a.delete(b)}deleteAndLeak(b){const O=this.a.get(b);return this.a.delete(b),O}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=C}),function(oe,e){typeof define=="function"&&define.amd?define(Ee[176],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(ee,ie){for(var le=0;le<ie.length;le++){var Z=ie[le];Z.enumerable=Z.enumerable||!1,Z.configurable=!0,"value"in Z&&(Z.writable=!0),Object.defineProperty(ee,Z.key,Z)}}function r(ee,ie,le){return ie&&e(ee.prototype,ie),le&&e(ee,le),Object.defineProperty(ee,"prototype",{writable:!1}),ee}function u(ee,ie){if(ee){if(typeof ee=="string")return P(ee,ie);var le=Object.prototype.toString.call(ee).slice(8,-1);if(le==="Object"&&ee.constructor&&(le=ee.constructor.name),le==="Map"||le==="Set")return Array.from(ee);if(le==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(le))return P(ee,ie)}}function P(ee,ie){(ie==null||ie>ee.length)&&(ie=ee.length);for(var le=0,Z=new Array(ie);le<ie;le++)Z[le]=ee[le];return Z}function T(ee,ie){var le=typeof Symbol<"u"&&ee[Symbol.iterator]||ee["@@iterator"];if(le)return(le=le.call(ee)).next.bind(le);if(Array.isArray(ee)||(le=u(ee))||ie&&ee&&typeof ee.length=="number"){le&&(ee=le);var Z=0;return function(){return Z>=ee.length?{done:!0}:{done:!1,value:ee[Z++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=L();function R(ee){oe.defaults=ee}var p=/[&<>"']/,l=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,f={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},A=function(ie){return f[ie]};function w(ee,ie){if(ie){if(p.test(ee))return ee.replace(l,A)}else if(I.test(ee))return ee.replace(D,A);return ee}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(ee){return ee.replace(a,function(ie,le){return le=le.toLowerCase(),le==="colon"?":":le.charAt(0)==="#"?le.charAt(1)==="x"?String.fromCharCode(parseInt(le.substring(2),16)):String.fromCharCode(+le.substring(1)):""})}var g=/(^|[^\[])\^/g;function $(ee,ie){ee=typeof ee=="string"?ee:ee.source,ie=ie||"";var le={replace:function(ae,$e){return $e=$e.source||$e,$e=$e.replace(g,"$1"),ee=ee.replace(ae,$e),le},getRegex:function(){return new RegExp(ee,ie)}};return le}var i=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function n(ee,ie,le){if(ee){var Z;try{Z=decodeURIComponent(d(le)).replace(i,"").toLowerCase()}catch{return null}if(Z.indexOf("javascript:")===0||Z.indexOf("vbscript:")===0||Z.indexOf("data:")===0)return null}ie&&!o.test(le)&&(le=m(ie,le));try{le=encodeURI(le).replace(/%25/g,"%")}catch{return null}return le}var t={},c=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function m(ee,ie){t[" "+ee]||(c.test(ee)?t[" "+ee]=ee+"/":t[" "+ee]=k(ee,"/",!0)),ee=t[" "+ee];var le=ee.indexOf(":")===-1;return ie.substring(0,2)==="//"?le?ie:ee.replace(h,"$1")+ie:ie.charAt(0)==="/"?le?ie:ee.replace(s,"$1")+ie:ee+ie}var y={exec:function(){}};function S(ee){for(var ie=1,le,Z;ie<arguments.length;ie++){le=arguments[ie];for(Z in le)Object.prototype.hasOwnProperty.call(le,Z)&&(ee[Z]=le[Z])}return ee}function E(ee,ie){var le=ee.replace(/\|/g,function($e,be,Me){for(var qe=!1,De=be;--De>=0&&Me[De]==="\\";)qe=!qe;return qe?"|":" |"}),Z=le.split(/ \|/),ae=0;if(Z[0].trim()||Z.shift(),Z.length>0&&!Z[Z.length-1].trim()&&Z.pop(),Z.length>ie)Z.splice(ie);else for(;Z.length<ie;)Z.push("");for(;ae<Z.length;ae++)Z[ae]=Z[ae].trim().replace(/\\\|/g,"|");return Z}function k(ee,ie,le){var Z=ee.length;if(Z===0)return"";for(var ae=0;ae<Z;){var $e=ee.charAt(Z-ae-1);if($e===ie&&!le)ae++;else if($e!==ie&&le)ae++;else break}return ee.slice(0,Z-ae)}function C(ee,ie){if(ee.indexOf(ie[1])===-1)return-1;for(var le=ee.length,Z=0,ae=0;ae<le;ae++)if(ee[ae]==="\\")ae++;else if(ee[ae]===ie[0])Z++;else if(ee[ae]===ie[1]&&(Z--,Z<0))return ae;return-1}function v(ee){ee&&ee.sanitize&&!ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(ee,ie){if(ie<1)return"";for(var le="";ie>1;)ie&1&&(le+=ee),ie>>=1,ee+=ee;return le+ee}function O(ee,ie,le,Z){var ae=ie.href,$e=ie.title?w(ie.title):null,be=ee[1].replace(/\\([\[\]])/g,"$1");if(ee[0].charAt(0)!=="!"){Z.state.inLink=!0;var Me={type:"link",raw:le,href:ae,title:$e,text:be,tokens:Z.inlineTokens(be)};return Z.state.inLink=!1,Me}return{type:"image",raw:le,href:ae,title:$e,text:w(be)}}function U(ee,ie){var le=ee.match(/^(\s+)(?:```)/);if(le===null)return ie;var Z=le[1];return ie.split(`
`).map(function(ae){var $e=ae.match(/^\s+/);if($e===null)return ae;var be=$e[0];return be.length>=Z.length?ae.slice(Z.length):ae}).join(`
`)}var z=function(){function ee(le){this.options=le||oe.defaults}var ie=ee.prototype;return ie.space=function(Z){var ae=this.rules.block.newline.exec(Z);if(ae&&ae[0].length>0)return{type:"space",raw:ae[0]}},ie.code=function(Z){var ae=this.rules.block.code.exec(Z);if(ae){var $e=ae[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ae[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:k($e,`
`)}}},ie.fences=function(Z){var ae=this.rules.block.fences.exec(Z);if(ae){var $e=ae[0],be=U($e,ae[3]||"");return{type:"code",raw:$e,lang:ae[2]?ae[2].trim():ae[2],text:be}}},ie.heading=function(Z){var ae=this.rules.block.heading.exec(Z);if(ae){var $e=ae[2].trim();if(/#$/.test($e)){var be=k($e,"#");(this.options.pedantic||!be||/ $/.test(be))&&($e=be.trim())}return{type:"heading",raw:ae[0],depth:ae[1].length,text:$e,tokens:this.lexer.inline($e)}}},ie.hr=function(Z){var ae=this.rules.block.hr.exec(Z);if(ae)return{type:"hr",raw:ae[0]}},ie.blockquote=function(Z){var ae=this.rules.block.blockquote.exec(Z);if(ae){var $e=ae[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ae[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},ie.list=function(Z){var ae=this.rules.block.list.exec(Z);if(ae){var $e,be,Me,qe,De,Pe,Te,B,q,Y,_,fe,ve=ae[1].trim(),Ne=ve.length>1,Be={type:"list",raw:"",ordered:Ne,start:Ne?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Ne?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Ne?ve:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");Z&&(fe=!1,!(!(ae=Qe.exec(Z))||this.rules.block.hr.test(Z)));){if($e=ae[0],Z=Z.substring($e.length),B=ae[2].split(`
`,1)[0],q=Z.split(`
`,1)[0],this.options.pedantic?(qe=2,_=B.trimLeft()):(qe=ae[2].search(/[^ ]/),qe=qe>4?1:qe,_=B.slice(qe),qe+=ae[1].length),Pe=!1,!B&&/^ *$/.test(q)&&($e+=q+`
`,Z=Z.substring(q.length+1),fe=!0),!fe)for(var He=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,qe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,qe-1)+"}(?:```|~~~)"),ot=new RegExp("^ {0,"+Math.min(3,qe-1)+"}#");Z&&(Y=Z.split(`
`,1)[0],B=Y,this.options.pedantic&&(B=B.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(B)||ot.test(B)||He.test(B)||tt.test(Z)));){if(B.search(/[^ ]/)>=qe||!B.trim())_+=`
`+B.slice(qe);else if(!Pe)_+=`
`+B;else break;!Pe&&!B.trim()&&(Pe=!0),$e+=Y+`
`,Z=Z.substring(Y.length+1)}Be.loose||(Te?Be.loose=!0:/\n *\n *$/.test($e)&&(Te=!0)),this.options.gfm&&(be=/^\[[ xX]\] /.exec(_),be&&(Me=be[0]!=="[ ] ",_=_.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:$e,task:!!be,checked:Me,loose:!1,text:_}),Be.raw+=$e}Be.items[Be.items.length-1].raw=$e.trimRight(),Be.items[Be.items.length-1].text=_.trimRight(),Be.raw=Be.raw.trimRight();var at=Be.items.length;for(De=0;De<at;De++){this.lexer.state.top=!1,Be.items[De].tokens=this.lexer.blockTokens(Be.items[De].text,[]);var pt=Be.items[De].tokens.filter(function(st){return st.type==="space"}),ft=pt.every(function(st){for(var ht=st.raw.split(""),Re=0,Ie=T(ht),Ae;!(Ae=Ie()).done;){var ue=Ae.value;if(ue===`
`&&(Re+=1),Re>1)return!0}return!1});!Be.loose&&pt.length&&ft&&(Be.loose=!0,Be.items[De].loose=!0)}return Be}},ie.html=function(Z){var ae=this.rules.block.html.exec(Z);if(ae){var $e={type:"html",raw:ae[0],pre:!this.options.sanitizer&&(ae[1]==="pre"||ae[1]==="script"||ae[1]==="style"),text:ae[0]};if(this.options.sanitize){var be=this.options.sanitizer?this.options.sanitizer(ae[0]):w(ae[0]);$e.type="paragraph",$e.text=be,$e.tokens=this.lexer.inline(be)}return $e}},ie.def=function(Z){var ae=this.rules.block.def.exec(Z);if(ae){ae[3]&&(ae[3]=ae[3].substring(1,ae[3].length-1));var $e=ae[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:ae[0],href:ae[2],title:ae[3]}}},ie.table=function(Z){var ae=this.rules.block.table.exec(Z);if(ae){var $e={type:"table",header:E(ae[1]).map(function(Te){return{text:Te}}),align:ae[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ae[3]&&ae[3].trim()?ae[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=ae[0];var be=$e.align.length,Me,qe,De,Pe;for(Me=0;Me<be;Me++)/^ *-+: *$/.test($e.align[Me])?$e.align[Me]="right":/^ *:-+: *$/.test($e.align[Me])?$e.align[Me]="center":/^ *:-+ *$/.test($e.align[Me])?$e.align[Me]="left":$e.align[Me]=null;for(be=$e.rows.length,Me=0;Me<be;Me++)$e.rows[Me]=E($e.rows[Me],$e.header.length).map(function(Te){return{text:Te}});for(be=$e.header.length,qe=0;qe<be;qe++)$e.header[qe].tokens=this.lexer.inline($e.header[qe].text);for(be=$e.rows.length,qe=0;qe<be;qe++)for(Pe=$e.rows[qe],De=0;De<Pe.length;De++)Pe[De].tokens=this.lexer.inline(Pe[De].text);return $e}}},ie.lheading=function(Z){var ae=this.rules.block.lheading.exec(Z);if(ae)return{type:"heading",raw:ae[0],depth:ae[2].charAt(0)==="="?1:2,text:ae[1],tokens:this.lexer.inline(ae[1])}},ie.paragraph=function(Z){var ae=this.rules.block.paragraph.exec(Z);if(ae){var $e=ae[1].charAt(ae[1].length-1)===`
`?ae[1].slice(0,-1):ae[1];return{type:"paragraph",raw:ae[0],text:$e,tokens:this.lexer.inline($e)}}},ie.text=function(Z){var ae=this.rules.block.text.exec(Z);if(ae)return{type:"text",raw:ae[0],text:ae[0],tokens:this.lexer.inline(ae[0])}},ie.escape=function(Z){var ae=this.rules.inline.escape.exec(Z);if(ae)return{type:"escape",raw:ae[0],text:w(ae[1])}},ie.tag=function(Z){var ae=this.rules.inline.tag.exec(Z);if(ae)return!this.lexer.state.inLink&&/^<a /i.test(ae[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ae[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ae[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ae[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ae[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ae[0]):w(ae[0]):ae[0]}},ie.link=function(Z){var ae=this.rules.inline.link.exec(Z);if(ae){var $e=ae[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var be=k($e.slice(0,-1),"\\");if(($e.length-be.length)%2===0)return}else{var Me=C(ae[2],"()");if(Me>-1){var qe=ae[0].indexOf("!")===0?5:4,De=qe+ae[1].length+Me;ae[2]=ae[2].substring(0,Me),ae[0]=ae[0].substring(0,De).trim(),ae[3]=""}}var Pe=ae[2],Te="";if(this.options.pedantic){var B=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);B&&(Pe=B[1],Te=B[3])}else Te=ae[3]?ae[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test($e)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),O(ae,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},ae[0],this.lexer)}},ie.reflink=function(Z,ae){var $e;if(($e=this.rules.inline.reflink.exec(Z))||($e=this.rules.inline.nolink.exec(Z))){var be=($e[2]||$e[1]).replace(/\s+/g," ");if(be=ae[be.toLowerCase()],!be||!be.href){var Me=$e[0].charAt(0);return{type:"text",raw:Me,text:Me}}return O($e,be,$e[0],this.lexer)}},ie.emStrong=function(Z,ae,$e){$e===void 0&&($e="");var be=this.rules.inline.emStrong.lDelim.exec(Z);if(be&&!(be[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=be[1]||be[2]||"";if(!Me||Me&&($e===""||this.rules.inline.punctuation.exec($e))){var qe=be[0].length-1,De,Pe,Te=qe,B=0,q=be[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,ae=ae.slice(-1*Z.length+qe);(be=q.exec(ae))!=null;)if(De=be[1]||be[2]||be[3]||be[4]||be[5]||be[6],!!De){if(Pe=De.length,be[3]||be[4]){Te+=Pe;continue}else if((be[5]||be[6])&&qe%3&&!((qe+Pe)%3)){B+=Pe;continue}if(Te-=Pe,!(Te>0)){if(Pe=Math.min(Pe,Pe+Te+B),Math.min(qe,Pe)%2){var Y=Z.slice(1,qe+be.index+Pe);return{type:"em",raw:Z.slice(0,qe+be.index+Pe+1),text:Y,tokens:this.lexer.inlineTokens(Y)}}var _=Z.slice(2,qe+be.index+Pe-1);return{type:"strong",raw:Z.slice(0,qe+be.index+Pe+1),text:_,tokens:this.lexer.inlineTokens(_)}}}}}},ie.codespan=function(Z){var ae=this.rules.inline.code.exec(Z);if(ae){var $e=ae[2].replace(/\n/g," "),be=/[^ ]/.test($e),Me=/^ /.test($e)&&/ $/.test($e);return be&&Me&&($e=$e.substring(1,$e.length-1)),$e=w($e,!0),{type:"codespan",raw:ae[0],text:$e}}},ie.br=function(Z){var ae=this.rules.inline.br.exec(Z);if(ae)return{type:"br",raw:ae[0]}},ie.del=function(Z){var ae=this.rules.inline.del.exec(Z);if(ae)return{type:"del",raw:ae[0],text:ae[2],tokens:this.lexer.inlineTokens(ae[2])}},ie.autolink=function(Z,ae){var $e=this.rules.inline.autolink.exec(Z);if($e){var be,Me;return $e[2]==="@"?(be=w(this.options.mangle?ae($e[1]):$e[1]),Me="mailto:"+be):(be=w($e[1]),Me=be),{type:"link",raw:$e[0],text:be,href:Me,tokens:[{type:"text",raw:be,text:be}]}}},ie.url=function(Z,ae){var $e;if($e=this.rules.inline.url.exec(Z)){var be,Me;if($e[2]==="@")be=w(this.options.mangle?ae($e[0]):$e[0]),Me="mailto:"+be;else{var qe;do qe=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(qe!==$e[0]);be=w($e[0]),$e[1]==="www."?Me="http://"+be:Me=be}return{type:"link",raw:$e[0],text:be,href:Me,tokens:[{type:"text",raw:be,text:be}]}}},ie.inlineText=function(Z,ae){var $e=this.rules.inline.text.exec(Z);if($e){var be;return this.lexer.state.inRawBlock?be=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):w($e[0]):$e[0]:be=w(this.options.smartypants?ae($e[0]):$e[0]),{type:"text",raw:$e[0],text:be}}},ee}(),j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:y,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=$(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.listItemStart=$(/^( *)(bull) */).replace("bull",j.bullet).getRegex(),j.list=$(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=$(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=$(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.blockquote=$(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=S({},j),j.gfm=S({},j.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.table=$(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.gfm.paragraph=$(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",j.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",j._tag).getRegex(),j.pedantic=S({},j.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:y,paragraph:$(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:y,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:y,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=$(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=$(j._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=$(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=$(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=$(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=$(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=$(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=$(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=$(M.reflink).replace("label",M._label).replace("ref",j._label).getRegex(),M.nolink=$(M.nolink).replace("ref",j._label).getRegex(),M.reflinkSearch=$(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=S({},M),M.pedantic=S({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=S({},M.normal,{escape:$(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=$(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=S({},M.gfm,{br:$(M.br).replace("{2,}","*").getRegex(),text:$(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(ee){return ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(ee){var ie="",le,Z,ae=ee.length;for(le=0;le<ae;le++)Z=ee.charCodeAt(le),Math.random()>.5&&(Z="x"+Z.toString(16)),ie+="&#"+Z+";";return ie}var X=function(){function ee(le){this.tokens=[],this.tokens.links=Object.create(null),this.options=le||oe.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Z={block:j.normal,inline:M.normal};this.options.pedantic?(Z.block=j.pedantic,Z.inline=M.pedantic):this.options.gfm&&(Z.block=j.gfm,this.options.breaks?Z.inline=M.breaks:Z.inline=M.gfm),this.tokenizer.rules=Z}ee.lex=function(Z,ae){var $e=new ee(ae);return $e.lex(Z)},ee.lexInline=function(Z,ae){var $e=new ee(ae);return $e.inlineTokens(Z)};var ie=ee.prototype;return ie.lex=function(Z){Z=Z.replace(/\r\n|\r/g,`
`),this.blockTokens(Z,this.tokens);for(var ae;ae=this.inlineQueue.shift();)this.inlineTokens(ae.src,ae.tokens);return this.tokens},ie.blockTokens=function(Z,ae){var $e=this;ae===void 0&&(ae=[]),this.options.pedantic?Z=Z.replace(/\t/g,"    ").replace(/^ +$/gm,""):Z=Z.replace(/^( *)(\t+)/gm,function(Te,B,q){return B+"    ".repeat(q.length)});for(var be,Me,qe,De;Z;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(be=Te.call({lexer:$e},Z,ae))?(Z=Z.substring(be.raw.length),ae.push(be),!0):!1}))){if(be=this.tokenizer.space(Z)){Z=Z.substring(be.raw.length),be.raw.length===1&&ae.length>0?ae[ae.length-1].raw+=`
`:ae.push(be);continue}if(be=this.tokenizer.code(Z)){Z=Z.substring(be.raw.length),Me=ae[ae.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ae.push(be);continue}if(be=this.tokenizer.fences(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.heading(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.hr(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.blockquote(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.list(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.html(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.def(Z)){Z=Z.substring(be.raw.length),Me=ae[ae.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[be.tag]||(this.tokens.links[be.tag]={href:be.href,title:be.title});continue}if(be=this.tokenizer.table(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.lheading(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(qe=Z,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,B=Z.slice(1),q=void 0;$e.options.extensions.startBlock.forEach(function(Y){q=Y.call({lexer:this},B),typeof q=="number"&&q>=0&&(Te=Math.min(Te,q))}),Te<1/0&&Te>=0&&(qe=Z.substring(0,Te+1))}(),this.state.top&&(be=this.tokenizer.paragraph(qe))){Me=ae[ae.length-1],De&&Me.type==="paragraph"?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ae.push(be),De=qe.length!==Z.length,Z=Z.substring(be.raw.length);continue}if(be=this.tokenizer.text(Z)){Z=Z.substring(be.raw.length),Me=ae[ae.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+be.raw,Me.text+=`
`+be.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):ae.push(be);continue}if(Z){var Pe="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,ae},ie.inline=function(Z,ae){return ae===void 0&&(ae=[]),this.inlineQueue.push({src:Z,tokens:ae}),ae},ie.inlineTokens=function(Z,ae){var $e=this;ae===void 0&&(ae=[]);var be,Me,qe,De=Z,Pe,Te,B;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(De))!=null;)q.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(De=De.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(De))!=null;)De=De.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+De.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(De))!=null;)De=De.slice(0,Pe.index)+"++"+De.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Z;)if(Te||(B=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_){return(be=_.call({lexer:$e},Z,ae))?(Z=Z.substring(be.raw.length),ae.push(be),!0):!1}))){if(be=this.tokenizer.escape(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.tag(Z)){Z=Z.substring(be.raw.length),Me=ae[ae.length-1],Me&&be.type==="text"&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ae.push(be);continue}if(be=this.tokenizer.link(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.reflink(Z,this.tokens.links)){Z=Z.substring(be.raw.length),Me=ae[ae.length-1],Me&&be.type==="text"&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ae.push(be);continue}if(be=this.tokenizer.emStrong(Z,De,B)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.codespan(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.br(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.del(Z)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(be=this.tokenizer.autolink(Z,F)){Z=Z.substring(be.raw.length),ae.push(be);continue}if(!this.state.inLink&&(be=this.tokenizer.url(Z,F))){Z=Z.substring(be.raw.length),ae.push(be);continue}if(qe=Z,this.options.extensions&&this.options.extensions.startInline&&function(){var _=1/0,fe=Z.slice(1),ve=void 0;$e.options.extensions.startInline.forEach(function(Ne){ve=Ne.call({lexer:this},fe),typeof ve=="number"&&ve>=0&&(_=Math.min(_,ve))}),_<1/0&&_>=0&&(qe=Z.substring(0,_+1))}(),be=this.tokenizer.inlineText(qe,N)){Z=Z.substring(be.raw.length),be.raw.slice(-1)!=="_"&&(B=be.raw.slice(-1)),Te=!0,Me=ae[ae.length-1],Me&&Me.type==="text"?(Me.raw+=be.raw,Me.text+=be.text):ae.push(be);continue}if(Z){var Y="Infinite loop on byte: "+Z.charCodeAt(0);if(this.options.silent){console.error(Y);break}else throw new Error(Y)}}return ae},r(ee,null,[{key:"rules",get:function(){return{block:j,inline:M}}}]),ee}(),se=function(){function ee(le){this.options=le||oe.defaults}var ie=ee.prototype;return ie.code=function(Z,ae,$e){var be=(ae||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(Z,be);Me!=null&&Me!==Z&&($e=!0,Z=Me)}return Z=Z.replace(/\n$/,"")+`
`,be?'<pre><code class="'+this.options.langPrefix+w(be,!0)+'">'+($e?Z:w(Z,!0))+`</code></pre>
`:"<pre><code>"+($e?Z:w(Z,!0))+`</code></pre>
`},ie.blockquote=function(Z){return`<blockquote>
`+Z+`</blockquote>
`},ie.html=function(Z){return Z},ie.heading=function(Z,ae,$e,be){if(this.options.headerIds){var Me=this.options.headerPrefix+be.slug($e);return"<h"+ae+' id="'+Me+'">'+Z+"</h"+ae+`>
`}return"<h"+ae+">"+Z+"</h"+ae+`>
`},ie.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ie.list=function(Z,ae,$e){var be=ae?"ol":"ul",Me=ae&&$e!==1?' start="'+$e+'"':"";return"<"+be+Me+`>
`+Z+"</"+be+`>
`},ie.listitem=function(Z){return"<li>"+Z+`</li>
`},ie.checkbox=function(Z){return"<input "+(Z?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ie.paragraph=function(Z){return"<p>"+Z+`</p>
`},ie.table=function(Z,ae){return ae&&(ae="<tbody>"+ae+"</tbody>"),`<table>
<thead>
`+Z+`</thead>
`+ae+`</table>
`},ie.tablerow=function(Z){return`<tr>
`+Z+`</tr>
`},ie.tablecell=function(Z,ae){var $e=ae.header?"th":"td",be=ae.align?"<"+$e+' align="'+ae.align+'">':"<"+$e+">";return be+Z+("</"+$e+`>
`)},ie.strong=function(Z){return"<strong>"+Z+"</strong>"},ie.em=function(Z){return"<em>"+Z+"</em>"},ie.codespan=function(Z){return"<code>"+Z+"</code>"},ie.br=function(){return this.options.xhtml?"<br/>":"<br>"},ie.del=function(Z){return"<del>"+Z+"</del>"},ie.link=function(Z,ae,$e){if(Z=n(this.options.sanitize,this.options.baseUrl,Z),Z===null)return $e;var be='<a href="'+w(Z)+'"';return ae&&(be+=' title="'+ae+'"'),be+=">"+$e+"</a>",be},ie.image=function(Z,ae,$e){if(Z=n(this.options.sanitize,this.options.baseUrl,Z),Z===null)return $e;var be='<img src="'+Z+'" alt="'+$e+'"';return ae&&(be+=' title="'+ae+'"'),be+=this.options.xhtml?"/>":">",be},ie.text=function(Z){return Z},ee}(),W=function(){function ee(){}var ie=ee.prototype;return ie.strong=function(Z){return Z},ie.em=function(Z){return Z},ie.codespan=function(Z){return Z},ie.del=function(Z){return Z},ie.html=function(Z){return Z},ie.text=function(Z){return Z},ie.link=function(Z,ae,$e){return""+$e},ie.image=function(Z,ae,$e){return""+$e},ie.br=function(){return""},ee}(),H=function(){function ee(){this.seen={}}var ie=ee.prototype;return ie.serialize=function(Z){return Z.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ie.getNextSafeSlug=function(Z,ae){var $e=Z,be=0;if(this.seen.hasOwnProperty($e)){be=this.seen[Z];do be++,$e=Z+"-"+be;while(this.seen.hasOwnProperty($e))}return ae||(this.seen[Z]=be,this.seen[$e]=0),$e},ie.slug=function(Z,ae){ae===void 0&&(ae={});var $e=this.serialize(Z);return this.getNextSafeSlug($e,ae.dryrun)},ee}(),V=function(){function ee(le){this.options=le||oe.defaults,this.options.renderer=this.options.renderer||new se,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new W,this.slugger=new H}ee.parse=function(Z,ae){var $e=new ee(ae);return $e.parse(Z)},ee.parseInline=function(Z,ae){var $e=new ee(ae);return $e.parseInline(Z)};var ie=ee.prototype;return ie.parse=function(Z,ae){ae===void 0&&(ae=!0);var $e="",be,Me,qe,De,Pe,Te,B,q,Y,_,fe,ve,Ne,Be,Qe,He,tt,nt,ot,at=Z.length;for(be=0;be<at;be++){if(_=Z[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(ot=this.options.extensions.renderers[_.type].call({parser:this},_),ot!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_.type))){$e+=ot||"";continue}switch(_.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(_.tokens),_.depth,d(this.parseInline(_.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(_.text,_.lang,_.escaped);continue}case"table":{for(q="",B="",De=_.header.length,Me=0;Me<De;Me++)B+=this.renderer.tablecell(this.parseInline(_.header[Me].tokens),{header:!0,align:_.align[Me]});for(q+=this.renderer.tablerow(B),Y="",De=_.rows.length,Me=0;Me<De;Me++){for(Te=_.rows[Me],B="",Pe=Te.length,qe=0;qe<Pe;qe++)B+=this.renderer.tablecell(this.parseInline(Te[qe].tokens),{header:!1,align:_.align[qe]});Y+=this.renderer.tablerow(B)}$e+=this.renderer.table(q,Y);continue}case"blockquote":{Y=this.parse(_.tokens),$e+=this.renderer.blockquote(Y);continue}case"list":{for(fe=_.ordered,ve=_.start,Ne=_.loose,De=_.items.length,Y="",Me=0;Me<De;Me++)Qe=_.items[Me],He=Qe.checked,tt=Qe.task,Be="",Qe.task&&(nt=this.renderer.checkbox(He),Ne?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=nt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=nt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:nt}):Be+=nt),Be+=this.parse(Qe.tokens,Ne),Y+=this.renderer.listitem(Be,tt,He);$e+=this.renderer.list(Y,fe,ve);continue}case"html":{$e+=this.renderer.html(_.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(_.tokens));continue}case"text":{for(Y=_.tokens?this.parseInline(_.tokens):_.text;be+1<at&&Z[be+1].type==="text";)_=Z[++be],Y+=`
`+(_.tokens?this.parseInline(_.tokens):_.text);$e+=ae?this.renderer.paragraph(Y):Y;continue}default:{var pt='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(pt);return}else throw new Error(pt)}}}return $e},ie.parseInline=function(Z,ae){ae=ae||this.renderer;var $e="",be,Me,qe,De=Z.length;for(be=0;be<De;be++){if(Me=Z[be],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(qe=this.options.extensions.renderers[Me.type].call({parser:this},Me),qe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){$e+=qe||"";continue}switch(Me.type){case"escape":{$e+=ae.text(Me.text);break}case"html":{$e+=ae.html(Me.text);break}case"link":{$e+=ae.link(Me.href,Me.title,this.parseInline(Me.tokens,ae));break}case"image":{$e+=ae.image(Me.href,Me.title,Me.text);break}case"strong":{$e+=ae.strong(this.parseInline(Me.tokens,ae));break}case"em":{$e+=ae.em(this.parseInline(Me.tokens,ae));break}case"codespan":{$e+=ae.codespan(Me.text);break}case"br":{$e+=ae.br();break}case"del":{$e+=ae.del(this.parseInline(Me.tokens,ae));break}case"text":{$e+=ae.text(Me.text);break}default:{var Pe='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return $e},ee}();function x(ee,ie,le){if(typeof ee>"u"||ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");if(typeof ie=="function"&&(le=ie,ie=null),ie=S({},x.defaults,ie||{}),v(ie),le){var Z=ie.highlight,ae;try{ae=X.lex(ee,ie)}catch(De){return le(De)}var $e=function(Pe){var Te;if(!Pe)try{ie.walkTokens&&x.walkTokens(ae,ie.walkTokens),Te=V.parse(ae,ie)}catch(B){Pe=B}return ie.highlight=Z,Pe?le(Pe):le(null,Te)};if(!Z||Z.length<3||(delete ie.highlight,!ae.length))return $e();var be=0;x.walkTokens(ae,function(De){De.type==="code"&&(be++,setTimeout(function(){Z(De.text,De.lang,function(Pe,Te){if(Pe)return $e(Pe);Te!=null&&Te!==De.text&&(De.text=Te,De.escaped=!0),be--,be===0&&$e()})},0))}),be===0&&$e();return}function Me(De){if(De.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+w(De.message+"",!0)+"</pre>";throw De}try{var qe=X.lex(ee,ie);if(ie.walkTokens){if(ie.async)return Promise.all(x.walkTokens(qe,ie.walkTokens)).then(function(){return V.parse(qe,ie)}).catch(Me);x.walkTokens(qe,ie.walkTokens)}return V.parse(qe,ie)}catch(De){Me(De)}}x.options=x.setOptions=function(ee){return S(x.defaults,ee),R(x.defaults),x},x.getDefaults=L,x.defaults=oe.defaults,x.use=function(){for(var ee=arguments.length,ie=new Array(ee),le=0;le<ee;le++)ie[le]=arguments[le];var Z=S.apply(void 0,[{}].concat(ie)),ae=x.defaults.extensions||{renderers:{},childTokens:{}},$e;ie.forEach(function(be){if(be.extensions&&($e=!0,be.extensions.forEach(function(qe){if(!qe.name)throw new Error("extension name required");if(qe.renderer){var De=ae.renderers?ae.renderers[qe.name]:null;De?ae.renderers[qe.name]=function(){for(var Pe=arguments.length,Te=new Array(Pe),B=0;B<Pe;B++)Te[B]=arguments[B];var q=qe.renderer.apply(this,Te);return q===!1&&(q=De.apply(this,Te)),q}:ae.renderers[qe.name]=qe.renderer}if(qe.tokenizer){if(!qe.level||qe.level!=="block"&&qe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ae[qe.level]?ae[qe.level].unshift(qe.tokenizer):ae[qe.level]=[qe.tokenizer],qe.start&&(qe.level==="block"?ae.startBlock?ae.startBlock.push(qe.start):ae.startBlock=[qe.start]:qe.level==="inline"&&(ae.startInline?ae.startInline.push(qe.start):ae.startInline=[qe.start]))}qe.childTokens&&(ae.childTokens[qe.name]=qe.childTokens)})),be.renderer&&function(){var qe=x.defaults.renderer||new se,De=function(B){var q=qe[B];qe[B]=function(){for(var Y=arguments.length,_=new Array(Y),fe=0;fe<Y;fe++)_[fe]=arguments[fe];var ve=be.renderer[B].apply(qe,_);return ve===!1&&(ve=q.apply(qe,_)),ve}};for(var Pe in be.renderer)De(Pe);Z.renderer=qe}(),be.tokenizer&&function(){var qe=x.defaults.tokenizer||new z,De=function(B){var q=qe[B];qe[B]=function(){for(var Y=arguments.length,_=new Array(Y),fe=0;fe<Y;fe++)_[fe]=arguments[fe];var ve=be.tokenizer[B].apply(qe,_);return ve===!1&&(ve=q.apply(qe,_)),ve}};for(var Pe in be.tokenizer)De(Pe);Z.tokenizer=qe}(),be.walkTokens){var Me=x.defaults.walkTokens;Z.walkTokens=function(qe){var De=[];return De.push(be.walkTokens.call(this,qe)),Me&&(De=De.concat(Me.call(this,qe))),De}}$e&&(Z.extensions=ae),x.setOptions(Z)})},x.walkTokens=function(ee,ie){for(var le=[],Z=function(){var Me=$e.value;switch(le=le.concat(ie.call(x,Me)),Me.type){case"table":{for(var qe=T(Me.header),De;!(De=qe()).done;){var Pe=De.value;le=le.concat(x.walkTokens(Pe.tokens,ie))}for(var Te=T(Me.rows),B;!(B=Te()).done;)for(var q=B.value,Y=T(q),_;!(_=Y()).done;){var fe=_.value;le=le.concat(x.walkTokens(fe.tokens,ie))}break}case"list":{le=le.concat(x.walkTokens(Me.items,ie));break}default:x.defaults.extensions&&x.defaults.extensions.childTokens&&x.defaults.extensions.childTokens[Me.type]?x.defaults.extensions.childTokens[Me.type].forEach(function(ve){le=le.concat(x.walkTokens(Me[ve],ie))}):Me.tokens&&(le=le.concat(x.walkTokens(Me.tokens,ie)))}},ae=T(ee),$e;!($e=ae()).done;)Z();return le},x.parseInline=function(ee,ie){if(typeof ee>"u"||ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ee)+", string expected");ie=S({},x.defaults,ie||{}),v(ie);try{var le=X.lexInline(ee,ie);return ie.walkTokens&&x.walkTokens(le,ie.walkTokens),V.parseInline(le,ie)}catch(Z){if(Z.message+=`
Please report this to https://github.com/markedjs/marked.`,ie.silent)return"<p>An error occurred:</p><pre>"+w(Z.message+"",!0)+"</pre>";throw Z}},x.Parser=V,x.parser=V.parse,x.Renderer=se,x.TextRenderer=W,x.Lexer=X,x.lexer=X.lex,x.Tokenizer=z,x.Slugger=H,x.parse=x;var he=x.options,ne=x.setOptions,we=x.use,pe=x.walkTokens,ce=x.parseInline,K=x,de=V.parse,te=X.lex;oe.Lexer=X,oe.Parser=V,oe.Renderer=se,oe.Slugger=H,oe.TextRenderer=W,oe.Tokenizer=z,oe.getDefaults=L,oe.lexer=te,oe.marked=x,oe.options=he,oe.parse=K,oe.parseInline=ce,oe.parser=de,oe.setOptions=ne,oe.use=we,oe.walkTokens=pe,Object.defineProperty(oe,"__esModule",{value:!0})}),define(Ee[41],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var r;(function(u){u[u.Uri=1]="Uri",u[u.Regexp=2]="Regexp",u[u.ScmResource=3]="ScmResource",u[u.ScmResourceGroup=4]="ScmResourceGroup",u[u.ScmProvider=5]="ScmProvider",u[u.CommentController=6]="CommentController",u[u.CommentThread=7]="CommentThread",u[u.CommentThreadInstance=8]="CommentThreadInstance",u[u.CommentThreadReply=9]="CommentThreadReply",u[u.CommentNode=10]="CommentNode",u[u.CommentThreadNode=11]="CommentThreadNode",u[u.TimelineActionContext=12]="TimelineActionContext",u[u.NotebookCellActionContext=13]="NotebookCellActionContext",u[u.NotebookActionContext=14]="NotebookActionContext",u[u.TerminalContext=15]="TerminalContext",u[u.TestItemContext=16]="TestItemContext",u[u.Date=17]="Date",u[u.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(r||(e.MarshalledId=r={}))}),define(Ee[177],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=r;function r(a){const d=T(a);if(d&&d.length>0)return new Uint32Array(d)}let u=0;const P=new Uint32Array(10);function T(a){if(u=0,L(a,D,p.InitialConsonant),u>0||(L(a,f,p.Vowel),u>0)||(L(a,A,p.FinalConsonant),u>0)||(L(a,w,p.CompatibilityJamo),u))return P.subarray(0,u);if(a>=44032&&a<=55203){const d=a-44032,g=d%588,$=Math.floor(d/588),i=Math.floor(g/28),o=g%28-1;if($<D.length?L($,D,0):p.InitialConsonant+$-p.CompatibilityJamo<w.length&&L(p.InitialConsonant+$,w,p.CompatibilityJamo),i<f.length?L(i,f,0):p.Vowel+i-p.CompatibilityJamo<w.length&&L(p.Vowel+i-p.CompatibilityJamo,w,p.CompatibilityJamo),o>=0&&(o<A.length?L(o,A,0):p.FinalConsonant+o-p.CompatibilityJamo<w.length&&L(p.FinalConsonant+o-p.CompatibilityJamo,w,p.CompatibilityJamo)),u>0)return P.subarray(0,u)}}function L(a,d,g){a>=g&&a<g+d.length&&R(d[a-g])}function R(a){a!==l.NUL&&(P[u++]=a&255,a>>8&&(P[u++]=a>>8&255),a>>16&&(P[u++]=a>>16&255))}var p;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var l;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(l||(l={}));var I;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(I||(I={}));const D=new Uint8Array([l.r,l.R,l.s,l.e,l.E,l.f,l.a,l.q,l.Q,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g]),f=new Uint16Array([l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,I.hk,I.ho,I.hl,l.y,l.n,I.nj,I.np,I.nl,l.b,l.m,I.ml,l.l]),A=new Uint16Array([l.r,l.R,I.rt,l.s,I.sw,I.sg,l.e,l.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,l.a,l.q,I.qt,l.t,l.T,l.d,l.w,l.c,l.z,l.x,l.v,l.g]),w=new Uint16Array([l.r,l.R,I.rt,l.s,I.sw,I.sg,l.e,l.E,l.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,l.a,l.q,l.Q,I.qt,l.t,l.T,l.d,l.w,l.W,l.c,l.z,l.x,l.v,l.g,l.k,l.o,l.i,l.O,l.j,l.p,l.u,l.P,l.h,I.hk,I.ho,I.hl,l.y,l.n,I.nj,I.np,I.nl,l.b,l.m,I.ml,l.l])}),define(Ee[82],Se([1,0,29]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=void 0,e.$hm=P,e.$im=L;const u=new r.$Dc(1e4);function P(l){return p(l,"NFC",u)}const T=new r.$Dc(1e4);function L(l){return p(l,"NFD",T)}const R=/[^\u0000-\u0080]/;function p(l,I,D){if(!l)return l;const f=D.get(l);if(f)return f;let A;return R.test(l)?A=l.normalize(I):A=l,D.set(l,A),A}e.$jm=function(){const l=/[\u0300-\u036f]/g;return function(I){return L(I).replace(l,"")}}()}),define(Ee[134],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=r,e.rot=u;function r(R,p,l){return Math.min(Math.max(R,p),l)}function u(R,p){return(p+R%p)%p}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=P;class T{constructor(){this.a=1,this.b=0}update(p){return this.b=this.b+(p-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=T;class L{constructor(p){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(p),this.c.fill(0,0,p)}update(p){const l=this.c[this.d];return this.c[this.d]=p,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=p,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=L}),define(Ee[178],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=T,e.$cd=f;class r{constructor(w,a,d){this.owner=w,this.debugNameSource=a,this.referenceFn=d}getDebugName(w){return T(w,this)}}e.$ad=r;const u=new Map,P=new WeakMap;function T(A,w){const a=P.get(A);if(a)return a;const d=L(A,w);if(d){let g=u.get(d)??0;g++,u.set(d,g);const $=g===1?d:`${d}#${g}`;return P.set(A,$),$}}function L(A,w){const a=P.get(A);if(a)return a;const d=w.owner?I(w.owner)+".":"";let g;const $=w.debugNameSource;if($!==void 0)if(typeof $=="function"){if(g=$(),g!==void 0)return d+g}else return d+$;const i=w.referenceFn;if(i!==void 0&&(g=f(i),g!==void 0))return d+g;if(w.owner!==void 0){const o=R(w.owner,A);if(o!==void 0)return d+o}}function R(A,w){for(const a in A)if(A[a]===w)return a}const p=new Map,l=new WeakMap;function I(A){const w=l.get(A);if(w)return w;const a=D(A);let d=p.get(a)??0;d++,p.set(a,d);const g=d===1?a:`${a}#${d}`;return l.set(A,g),g}function D(A){const w=A.constructor;return w?w.name:"Object"}function f(A){const w=A.toString(),d=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(w);return(d?d[1]:void 0)?.trim()}}),define(Ee[179],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=u,e.$Id=P;let r;function u(a){r=a}function P(){return r}class T{constructor(){this.a=0,this.d=new WeakMap}b(d){return L([R(A("|  ",this.a)),d])}c(d){return d.hadValue?d.didChange?[R(" "),l(I(d.oldValue,70),{color:"red",strikeThrough:!0}),R(" "),l(I(d.newValue,60),{color:"green"})]:[R(" (unchanged)")]:[R(" "),l(I(d.newValue,60),{color:"green"}),R(" (initial)")]}handleObservableChanged(d,g){console.log(...this.b([p("observable value changed"),l(d.debugName,{color:"BlueViolet"}),...this.c(g)]))}formatChanges(d){if(d.size!==0)return l(" (changed deps: "+[...d].map(g=>g.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(d){const g=d.handleChange;this.d.set(d,new Set),d.handleChange=($,i)=>(this.d.get(d).add($),g.apply(d,[$,i]))}handleDerivedRecomputed(d,g){const $=this.d.get(d);console.log(...this.b([p("derived recomputed"),l(d.debugName,{color:"BlueViolet"}),...this.c(g),this.formatChanges($),{data:[{fn:d._computeFn}]}])),$.clear()}handleFromEventObservableTriggered(d,g){console.log(...this.b([p("observable from event triggered"),l(d.debugName,{color:"BlueViolet"}),...this.c(g),{data:[{fn:d._getValue}]}]))}handleAutorunCreated(d){const g=d.handleChange;this.d.set(d,new Set),d.handleChange=($,i)=>(this.d.get(d).add($),g.apply(d,[$,i]))}handleAutorunTriggered(d){const g=this.d.get(d);console.log(...this.b([p("autorun"),l(d.debugName,{color:"BlueViolet"}),this.formatChanges(g),{data:[{fn:d._runFn}]}])),g.clear(),this.a++}handleAutorunFinished(d){this.a--}handleBeginTransaction(d){let g=d.getDebugName();g===void 0&&(g=""),console.log(...this.b([p("transaction"),l(g,{color:"BlueViolet"}),{data:[{fn:d._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=T;function L(a){const d=new Array,g=[];let $="";function i(n){if("length"in n)for(const t of n)t&&i(t);else"text"in n?($+=`%c${n.text}`,d.push(n.style),n.data&&g.push(...n.data)):"data"in n&&g.push(...n.data)}i(a);const o=[$,...d];return o.push(...g),o}function R(a){return l(a,{color:"black"})}function p(a){return l(w(`${a}: `,10),{color:"black",bold:!0})}function l(a,d={color:"black"}){function g(i){return Object.entries(i).reduce((o,[n,t])=>`${o}${n}:${t};`,"")}const $={color:d.color};return d.strikeThrough&&($["text-decoration"]="line-through"),d.bold&&($["font-weight"]="bold"),{text:a,style:g($)}}function I(a,d){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=d?`"${a}"`:`"${a.substr(0,d-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?D(a,d):f(a,d);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function D(a,d){let g="[ ",$=!0;for(const i of a){if($||(g+=", "),g.length-5>d){g+="...";break}$=!1,g+=`${I(i,d-g.length)}`}return g+=" ]",g}function f(a,d){let g="{ ",$=!0;for(const[i,o]of Object.entries(a)){if($||(g+=", "),g.length-5>d){g+="...";break}$=!1,g+=`${i}: ${I(o,d-g.length)}`}return g+=" }",g}function A(a,d){let g="";for(let $=1;$<=d;$++)g+=a;return g}function w(a,d){for(;a.length<d;)a+=" ";return a}}),define(Ee[180],Se([1,0,174,178,179]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=L,e.$Td=p,e.$Ud=I,e.$Xd=A,e.$Yd=a,e.$Zd=d,e.$1d=g,e.$3d=i,e.$4d=o,e.$6d=t;let T;function L(h){T=h}let R;function p(h){R=h}let l;function I(h){l=h}class D{get TChange(){return null}reportChanges(){this.get()}read(s){return s?s.readObservable(this):this.get()}map(s,m){const y=m===void 0?void 0:s,S=m===void 0?s:m;return l({owner:y,debugName:()=>{const E=(0,u.$cd)(S);if(E!==void 0)return E;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(C)return`${this.debugName}.${C[2]}`;if(!y)return`${this.debugName} (mapped)`},debugReferenceFn:S},E=>S(this.read(E),E))}recomputeInitiallyAndOnChange(s,m){return s.add(T(this,m)),this}keepObserved(s){return s.add(R(this)),this}get a(){return this.get()}}e.$Vd=D;class f extends D{constructor(){super(...arguments),this.b=new Set}addObserver(s){const m=this.b.size;this.b.add(s),m===0&&this.c()}removeObserver(s){this.b.delete(s)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=f;function A(h,s){const m=new $(h,s);try{h(m)}finally{m.finish()}}let w;function a(h){if(w)h(w);else{const s=new $(h,void 0);w=s;try{h(s)}finally{s.finish(),w=void 0}}}async function d(h,s){const m=new $(h,s);try{await h(m)}finally{m.finish()}}function g(h,s,m){h?s(h):A(s,m)}class ${constructor(s,m){this._fn=s,this.b=m,this.a=[],(0,P.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,u.$cd)(this._fn)}updateObserver(s,m){this.a.push({observer:s,observable:m}),s.beginUpdate(m)}finish(){const s=this.a;for(let m=0;m<s.length;m++){const{observer:y,observable:S}=s[m];y.endUpdate(S)}this.a=null,(0,P.$Id)()?.handleEndTransaction()}}e.$2d=$;function i(h,s){let m;return typeof h=="string"?m=new u.$ad(void 0,h,void 0):m=new u.$ad(h,void 0,void 0),new n(m,s,r.$6c)}function o(h,s){return new n(new u.$ad(h.owner,h.debugName,void 0),s,h.equalsFn??r.$6c)}class n extends f{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(s,m,y){super(),this.e=s,this.g=y,this.d=m}get(){return this.d}set(s,m,y){if(y===void 0&&this.g(this.d,s))return;let S;m||(m=S=new $(()=>{},()=>`Setting ${this.debugName}`));try{const E=this.d;this.h(s),(0,P.$Id)()?.handleObservableChanged(this,{oldValue:E,newValue:s,change:y,didChange:!0,hadValue:!0});for(const k of this.b)m.updateObserver(k,this),k.handleChange(this,y)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(s){this.d=s}}e.$5d=n;function t(h,s){let m;return typeof h=="string"?m=new u.$ad(void 0,h,void 0):m=new u.$ad(h,void 0,void 0),new c(m,s,r.$6c)}class c extends n{h(s){this.d!==s&&(this.d&&this.d.dispose(),this.d=s)}dispose(){this.d?.dispose()}}e.$7d=c}),function(){function oe(P){const T=[];typeof P=="number"&&T.push("code/timeOrigin",P);function L(p){T.push(p,Date.now())}function R(){const p=[];for(let l=0;l<T.length;l+=2)p.push({name:T[l],startTime:T[l+1]});return p}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const L of performance.getEntriesByType("mark"))T.push({name:L.name,startTime:Math.round(P+L.startTime)});return T}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function r(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var u;typeof global=="object"?u=global:typeof self=="object"?u=self:u={},typeof define=="function"?define("vs/base/common/performance",[],function(){return r(u)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=r(u):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),u.perf=r(u))}(),define(Ee[11],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C=e.$B=e.$A=e.$z=e.$y=e.OS=e.OperatingSystem=e.$v=e.$u=e.$t=e.$s=e.$r=e.Language=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.$g=e.$f=e.$e=e.$d=e.$c=e.Platform=e.$a=void 0,e.$b=t,e.$x=S,e.$D=E,e.$a="en";let r=!1,u=!1,P=!1,T=!1,L=!1,R=!1,p=!1,l=!1,I=!1,D=!1,f,A=e.$a,w=e.$a,a,d;const g=globalThis;let $;typeof g.vscode<"u"&&typeof g.vscode.process<"u"?$=g.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&($=process);const i=typeof $?.versions?.electron=="string",o=i&&$?.type==="renderer";if(typeof $=="object"){r=$.platform==="win32",u=$.platform==="darwin",P=$.platform==="linux",T=P&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,p=i,I=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.$a,A=e.$a;const k=$.env.VSCODE_NLS_CONFIG;if(k)try{const C=JSON.parse(k),v=C.availableLanguages["*"];f=C.locale,w=C.osLocale,A=v||e.$a,a=C._translationsConfigFile}catch{}L=!0}else if(typeof navigator=="object"&&!o){d=navigator.userAgent,r=d.indexOf("Windows")>=0,u=d.indexOf("Macintosh")>=0,l=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=d.indexOf("Linux")>=0,D=d?.indexOf("Mobi")>=0,R=!0,f=e.$a,A=f,w=navigator.language;const k=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),C=k&&k.getAttribute("data-settings");if(C)try{const v=JSON.parse(C),b=v.availableLanguages["*"];f=v.locale,w=v.osLocale,A=b||e.$a,a=v._translationsConfigFile}catch{}}else console.error("Unable to resolve platform.");var n;(function(k){k[k.Web=0]="Web",k[k.Mac=1]="Mac",k[k.Linux=2]="Linux",k[k.Windows=3]="Windows"})(n||(e.Platform=n={}));function t(k){switch(k){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let c=n.Web;u?c=n.Mac:r?c=n.Windows:P&&(c=n.Linux),e.$c=r,e.$d=u,e.$e=P,e.$f=T,e.$g=L,e.$h=p,e.$i=R,e.$j=R&&typeof g.importScripts=="function",e.$k=e.$j?g.origin:void 0,e.$l=l,e.$m=D,e.$n=I,e.$o=c,e.$p=d,e.$q=A;var h;(function(k){function C(){return e.$q}k.value=C;function v(){return e.$q.length===2?e.$q==="en":e.$q.length>=3?e.$q[0]==="e"&&e.$q[1]==="n"&&e.$q[2]==="-":!1}k.isDefaultVariant=v;function b(){return e.$q==="en"}k.isDefault=b})(h||(e.Language=h={})),e.$r=f,e.$s=w,e.$t=a,e.$u=typeof g.postMessage=="function"&&!g.importScripts,e.$v=(()=>{if(e.$u){const k=[];g.addEventListener("message",v=>{if(v.data&&v.data.vscodeScheduleAsyncWork)for(let b=0,O=k.length;b<O;b++){const U=k[b];if(U.id===v.data.vscodeScheduleAsyncWork){k.splice(b,1),U.callback();return}}});let C=0;return v=>{const b=++C;k.push({id:b,callback:v}),g.postMessage({vscodeScheduleAsyncWork:b},"*")}}return k=>setTimeout(k)})();var s;(function(k){k[k.Windows=1]="Windows",k[k.Macintosh=2]="Macintosh",k[k.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=u||l?s.Macintosh:r?s.Windows:s.Linux;let m=!0,y=!1;function S(){if(!y){y=!0;const k=new Uint8Array(2);k[0]=1,k[1]=2,m=new Uint16Array(k.buffer)[0]===513}return m}e.$y=!!(e.$p&&e.$p.indexOf("Chrome")>=0),e.$z=!!(e.$p&&e.$p.indexOf("Firefox")>=0),e.$A=!!(!e.$y&&e.$p&&e.$p.indexOf("Safari")>=0),e.$B=!!(e.$p&&e.$p.indexOf("Edg/")>=0),e.$C=!!(e.$p&&e.$p.indexOf("Android")>=0);function E(k){return parseFloat(k)>=20}}),define(Ee[181],Se([1,0,40]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OO=void 0;const u=Symbol("unset");class P{constructor(){this.a=new L,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||r.Iterable.empty()}insert(p,l,I){this.d(p,D=>D._value=l,I)}mutate(p,l){this.d(p,I=>I._value=l(I._value===u?void 0:I._value))}mutatePath(p,l){this.d(p,()=>{},I=>l(I))}delete(p){const l=this.c(p);if(!l)return;let I=l.length-1;const D=l[I].node._value;if(D!==u){for(this.b--,l[I].node._value=u;I>0;I--){const{node:f,part:A}=l[I];if(f.children?.size||f._value!==u)break;l[I-1].node.children.delete(A)}return D}}*deleteRecursive(p){const l=this.c(p);if(!l)return;const I=l[l.length-1].node;for(let D=l.length-1;D>0;D--){const f=l[D-1];if(f.node.children.delete(l[D].part),f.node.children.size>0||f.node._value!==u)break}for(const D of T(I))D._value!==u&&(this.b--,yield D._value)}find(p){let l=this.a;for(const I of p){const D=l.children?.get(I);if(!D)return;l=D}return l._value===u?void 0:l._value}hasKeyOrParent(p){let l=this.a;for(const I of p){const D=l.children?.get(I);if(!D)return!1;if(D._value!==u)return!0;l=D}return!1}hasKeyOrChildren(p){let l=this.a;for(const I of p){const D=l.children?.get(I);if(!D)return!1;l=D}return!0}hasKey(p){let l=this.a;for(const I of p){const D=l.children?.get(I);if(!D)return!1;l=D}return l._value!==u}c(p){const l=[{part:"",node:this.a}];let I=0;for(const D of p){const f=l[I].node.children?.get(D);if(!f)return;l.push({part:D,node:f}),I++}return l}d(p,l,I){let D=this.a;for(const w of p){if(D.children)if(D.children.has(w))D=D.children.get(w);else{const a=new L;D.children.set(w,a),D=a}else{const a=new L;D.children=new Map([[w,a]]),D=a}I?.(D)}const f=D._value===u?0:1;l(D);const A=D._value===u?0:1;this.b+=A-f}*values(){for(const{_value:p}of T(this.a))p!==u&&(yield p)}}e.$OO=P;function*T(R){const p=[R];for(;p.length>0;){const l=p.pop();if(yield l,l.children)for(const I of l.children.values())p.push(I)}}class L{constructor(){this._value=u}get value(){return this._value===u?void 0:this._value}set value(p){this._value=p===void 0?u:p}}}),define(Ee[54],Se([1,0,11]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let u;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.process<"u"){const T=P.process;u={get platform(){return T.platform},get arch(){return T.arch},get env(){return T.env},cwd(){return T.cwd()}}}else typeof process<"u"?u={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:u={get platform(){return r.$c?"win32":r.$d?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=u.cwd,e.env=u.env,e.$dc=u.platform,e.$ec=u.arch}),define(Ee[16],Se([1,0,54]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const u=65,P=97,T=90,L=122,R=46,p=47,l=92,I=58,D=63;class f extends Error{constructor(c,h,s){let m;typeof h=="string"&&h.indexOf("not ")===0?(m="must not be",h=h.replace(/^not /,"")):m="must be";const y=c.indexOf(".")!==-1?"property":"argument";let S=`The "${c}" ${y} ${m} of type ${h}`;S+=`. Received type ${typeof s}`,super(S),this.code="ERR_INVALID_ARG_TYPE"}}function A(t,c){if(t===null||typeof t!="object")throw new f(c,"Object",t)}function w(t,c){if(typeof t!="string")throw new f(c,"string",t)}const a=r.$dc==="win32";function d(t){return t===p||t===l}function g(t){return t===p}function $(t){return t>=u&&t<=T||t>=P&&t<=L}function i(t,c,h,s){let m="",y=0,S=-1,E=0,k=0;for(let C=0;C<=t.length;++C){if(C<t.length)k=t.charCodeAt(C);else{if(s(k))break;k=p}if(s(k)){if(!(S===C-1||E===1))if(E===2){if(m.length<2||y!==2||m.charCodeAt(m.length-1)!==R||m.charCodeAt(m.length-2)!==R){if(m.length>2){const v=m.lastIndexOf(h);v===-1?(m="",y=0):(m=m.slice(0,v),y=m.length-1-m.lastIndexOf(h)),S=C,E=0;continue}else if(m.length!==0){m="",y=0,S=C,E=0;continue}}c&&(m+=m.length>0?`${h}..`:"..",y=2)}else m.length>0?m+=`${h}${t.slice(S+1,C)}`:m=t.slice(S+1,C),y=C-S-1;S=C,E=0}else k===R&&E!==-1?++E:E=-1}return m}function o(t,c){A(c,"pathObject");const h=c.dir||c.root,s=c.base||`${c.name||""}${c.ext||""}`;return h?h===c.root?`${h}${s}`:`${h}${t}${s}`:s}e.$fc={resolve(...t){let c="",h="",s=!1;for(let m=t.length-1;m>=-1;m--){let y;if(m>=0){if(y=t[m],w(y,"path"),y.length===0)continue}else c.length===0?y=r.cwd():(y=r.env[`=${c}`]||r.cwd(),(y===void 0||y.slice(0,2).toLowerCase()!==c.toLowerCase()&&y.charCodeAt(2)===l)&&(y=`${c}\\`));const S=y.length;let E=0,k="",C=!1;const v=y.charCodeAt(0);if(S===1)d(v)&&(E=1,C=!0);else if(d(v))if(C=!0,d(y.charCodeAt(1))){let b=2,O=b;for(;b<S&&!d(y.charCodeAt(b));)b++;if(b<S&&b!==O){const U=y.slice(O,b);for(O=b;b<S&&d(y.charCodeAt(b));)b++;if(b<S&&b!==O){for(O=b;b<S&&!d(y.charCodeAt(b));)b++;(b===S||b!==O)&&(k=`\\\\${U}\\${y.slice(O,b)}`,E=b)}}}else E=1;else $(v)&&y.charCodeAt(1)===I&&(k=y.slice(0,2),E=2,S>2&&d(y.charCodeAt(2))&&(C=!0,E=3));if(k.length>0)if(c.length>0){if(k.toLowerCase()!==c.toLowerCase())continue}else c=k;if(s){if(c.length>0)break}else if(h=`${y.slice(E)}\\${h}`,s=C,C&&c.length>0)break}return h=i(h,!s,"\\",d),s?`${c}\\${h}`:`${c}${h}`||"."},normalize(t){w(t,"path");const c=t.length;if(c===0)return".";let h=0,s,m=!1;const y=t.charCodeAt(0);if(c===1)return g(y)?"\\":t;if(d(y))if(m=!0,d(t.charCodeAt(1))){let E=2,k=E;for(;E<c&&!d(t.charCodeAt(E));)E++;if(E<c&&E!==k){const C=t.slice(k,E);for(k=E;E<c&&d(t.charCodeAt(E));)E++;if(E<c&&E!==k){for(k=E;E<c&&!d(t.charCodeAt(E));)E++;if(E===c)return`\\\\${C}\\${t.slice(k)}\\`;E!==k&&(s=`\\\\${C}\\${t.slice(k,E)}`,h=E)}}}else h=1;else $(y)&&t.charCodeAt(1)===I&&(s=t.slice(0,2),h=2,c>2&&d(t.charCodeAt(2))&&(m=!0,h=3));let S=h<c?i(t.slice(h),!m,"\\",d):"";return S.length===0&&!m&&(S="."),S.length>0&&d(t.charCodeAt(c-1))&&(S+="\\"),s===void 0?m?`\\${S}`:S:m?`${s}\\${S}`:`${s}${S}`},isAbsolute(t){w(t,"path");const c=t.length;if(c===0)return!1;const h=t.charCodeAt(0);return d(h)||c>2&&$(h)&&t.charCodeAt(1)===I&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,h;for(let y=0;y<t.length;++y){const S=t[y];w(S,"path"),S.length>0&&(c===void 0?c=h=S:c+=`\\${S}`)}if(c===void 0)return".";let s=!0,m=0;if(typeof h=="string"&&d(h.charCodeAt(0))){++m;const y=h.length;y>1&&d(h.charCodeAt(1))&&(++m,y>2&&(d(h.charCodeAt(2))?++m:s=!1))}if(s){for(;m<c.length&&d(c.charCodeAt(m));)m++;m>=2&&(c=`\\${c.slice(m)}`)}return e.$fc.normalize(c)},relative(t,c){if(w(t,"from"),w(c,"to"),t===c)return"";const h=e.$fc.resolve(t),s=e.$fc.resolve(c);if(h===s||(t=h.toLowerCase(),c=s.toLowerCase(),t===c))return"";let m=0;for(;m<t.length&&t.charCodeAt(m)===l;)m++;let y=t.length;for(;y-1>m&&t.charCodeAt(y-1)===l;)y--;const S=y-m;let E=0;for(;E<c.length&&c.charCodeAt(E)===l;)E++;let k=c.length;for(;k-1>E&&c.charCodeAt(k-1)===l;)k--;const C=k-E,v=S<C?S:C;let b=-1,O=0;for(;O<v;O++){const z=t.charCodeAt(m+O);if(z!==c.charCodeAt(E+O))break;z===l&&(b=O)}if(O!==v){if(b===-1)return s}else{if(C>v){if(c.charCodeAt(E+O)===l)return s.slice(E+O+1);if(O===2)return s.slice(E+O)}S>v&&(t.charCodeAt(m+O)===l?b=O:O===2&&(b=3)),b===-1&&(b=0)}let U="";for(O=m+b+1;O<=y;++O)(O===y||t.charCodeAt(O)===l)&&(U+=U.length===0?"..":"\\..");return E+=b,U.length>0?`${U}${s.slice(E,k)}`:(s.charCodeAt(E)===l&&++E,s.slice(E,k))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.$fc.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===l){if(c.charCodeAt(1)===l){const h=c.charCodeAt(2);if(h!==D&&h!==R)return`\\\\?\\UNC\\${c.slice(2)}`}}else if($(c.charCodeAt(0))&&c.charCodeAt(1)===I&&c.charCodeAt(2)===l)return`\\\\?\\${c}`;return t},dirname(t){w(t,"path");const c=t.length;if(c===0)return".";let h=-1,s=0;const m=t.charCodeAt(0);if(c===1)return d(m)?t:".";if(d(m)){if(h=s=1,d(t.charCodeAt(1))){let E=2,k=E;for(;E<c&&!d(t.charCodeAt(E));)E++;if(E<c&&E!==k){for(k=E;E<c&&d(t.charCodeAt(E));)E++;if(E<c&&E!==k){for(k=E;E<c&&!d(t.charCodeAt(E));)E++;if(E===c)return t;E!==k&&(h=s=E+1)}}}}else $(m)&&t.charCodeAt(1)===I&&(h=c>2&&d(t.charCodeAt(2))?3:2,s=h);let y=-1,S=!0;for(let E=c-1;E>=s;--E)if(d(t.charCodeAt(E))){if(!S){y=E;break}}else S=!1;if(y===-1){if(h===-1)return".";y=h}return t.slice(0,y)},basename(t,c){c!==void 0&&w(c,"ext"),w(t,"path");let h=0,s=-1,m=!0,y;if(t.length>=2&&$(t.charCodeAt(0))&&t.charCodeAt(1)===I&&(h=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let S=c.length-1,E=-1;for(y=t.length-1;y>=h;--y){const k=t.charCodeAt(y);if(d(k)){if(!m){h=y+1;break}}else E===-1&&(m=!1,E=y+1),S>=0&&(k===c.charCodeAt(S)?--S===-1&&(s=y):(S=-1,s=E))}return h===s?s=E:s===-1&&(s=t.length),t.slice(h,s)}for(y=t.length-1;y>=h;--y)if(d(t.charCodeAt(y))){if(!m){h=y+1;break}}else s===-1&&(m=!1,s=y+1);return s===-1?"":t.slice(h,s)},extname(t){w(t,"path");let c=0,h=-1,s=0,m=-1,y=!0,S=0;t.length>=2&&t.charCodeAt(1)===I&&$(t.charCodeAt(0))&&(c=s=2);for(let E=t.length-1;E>=c;--E){const k=t.charCodeAt(E);if(d(k)){if(!y){s=E+1;break}continue}m===-1&&(y=!1,m=E+1),k===R?h===-1?h=E:S!==1&&(S=1):h!==-1&&(S=-1)}return h===-1||m===-1||S===0||S===1&&h===m-1&&h===s+1?"":t.slice(h,m)},format:o.bind(null,"\\"),parse(t){w(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const h=t.length;let s=0,m=t.charCodeAt(0);if(h===1)return d(m)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(d(m)){if(s=1,d(t.charCodeAt(1))){let b=2,O=b;for(;b<h&&!d(t.charCodeAt(b));)b++;if(b<h&&b!==O){for(O=b;b<h&&d(t.charCodeAt(b));)b++;if(b<h&&b!==O){for(O=b;b<h&&!d(t.charCodeAt(b));)b++;b===h?s=b:b!==O&&(s=b+1)}}}}else if($(m)&&t.charCodeAt(1)===I){if(h<=2)return c.root=c.dir=t,c;if(s=2,d(t.charCodeAt(2))){if(h===3)return c.root=c.dir=t,c;s=3}}s>0&&(c.root=t.slice(0,s));let y=-1,S=s,E=-1,k=!0,C=t.length-1,v=0;for(;C>=s;--C){if(m=t.charCodeAt(C),d(m)){if(!k){S=C+1;break}continue}E===-1&&(k=!1,E=C+1),m===R?y===-1?y=C:v!==1&&(v=1):y!==-1&&(v=-1)}return E!==-1&&(y===-1||v===0||v===1&&y===E-1&&y===S+1?c.base=c.name=t.slice(S,E):(c.name=t.slice(S,y),c.base=t.slice(S,E),c.ext=t.slice(y,E))),S>0&&S!==s?c.dir=t.slice(0,S-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const n=(()=>{if(a){const t=/\\/g;return()=>{const c=r.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>r.cwd()})();e.$gc={resolve(...t){let c="",h=!1;for(let s=t.length-1;s>=-1&&!h;s--){const m=s>=0?t[s]:n();w(m,"path"),m.length!==0&&(c=`${m}/${c}`,h=m.charCodeAt(0)===p)}return c=i(c,!h,"/",g),h?`/${c}`:c.length>0?c:"."},normalize(t){if(w(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===p,h=t.charCodeAt(t.length-1)===p;return t=i(t,!c,"/",g),t.length===0?c?"/":h?"./":".":(h&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return w(t,"path"),t.length>0&&t.charCodeAt(0)===p},join(...t){if(t.length===0)return".";let c;for(let h=0;h<t.length;++h){const s=t[h];w(s,"path"),s.length>0&&(c===void 0?c=s:c+=`/${s}`)}return c===void 0?".":e.$gc.normalize(c)},relative(t,c){if(w(t,"from"),w(c,"to"),t===c||(t=e.$gc.resolve(t),c=e.$gc.resolve(c),t===c))return"";const h=1,s=t.length,m=s-h,y=1,S=c.length-y,E=m<S?m:S;let k=-1,C=0;for(;C<E;C++){const b=t.charCodeAt(h+C);if(b!==c.charCodeAt(y+C))break;b===p&&(k=C)}if(C===E)if(S>E){if(c.charCodeAt(y+C)===p)return c.slice(y+C+1);if(C===0)return c.slice(y+C)}else m>E&&(t.charCodeAt(h+C)===p?k=C:C===0&&(k=0));let v="";for(C=h+k+1;C<=s;++C)(C===s||t.charCodeAt(C)===p)&&(v+=v.length===0?"..":"/..");return`${v}${c.slice(y+k)}`},toNamespacedPath(t){return t},dirname(t){if(w(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===p;let h=-1,s=!0;for(let m=t.length-1;m>=1;--m)if(t.charCodeAt(m)===p){if(!s){h=m;break}}else s=!1;return h===-1?c?"/":".":c&&h===1?"//":t.slice(0,h)},basename(t,c){c!==void 0&&w(c,"ext"),w(t,"path");let h=0,s=-1,m=!0,y;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let S=c.length-1,E=-1;for(y=t.length-1;y>=0;--y){const k=t.charCodeAt(y);if(k===p){if(!m){h=y+1;break}}else E===-1&&(m=!1,E=y+1),S>=0&&(k===c.charCodeAt(S)?--S===-1&&(s=y):(S=-1,s=E))}return h===s?s=E:s===-1&&(s=t.length),t.slice(h,s)}for(y=t.length-1;y>=0;--y)if(t.charCodeAt(y)===p){if(!m){h=y+1;break}}else s===-1&&(m=!1,s=y+1);return s===-1?"":t.slice(h,s)},extname(t){w(t,"path");let c=-1,h=0,s=-1,m=!0,y=0;for(let S=t.length-1;S>=0;--S){const E=t.charCodeAt(S);if(E===p){if(!m){h=S+1;break}continue}s===-1&&(m=!1,s=S+1),E===R?c===-1?c=S:y!==1&&(y=1):c!==-1&&(y=-1)}return c===-1||s===-1||y===0||y===1&&c===s-1&&c===h+1?"":t.slice(c,s)},format:o.bind(null,"/"),parse(t){w(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const h=t.charCodeAt(0)===p;let s;h?(c.root="/",s=1):s=0;let m=-1,y=0,S=-1,E=!0,k=t.length-1,C=0;for(;k>=s;--k){const v=t.charCodeAt(k);if(v===p){if(!E){y=k+1;break}continue}S===-1&&(E=!1,S=k+1),v===R?m===-1?m=k:C!==1&&(C=1):m!==-1&&(C=-1)}if(S!==-1){const v=y===0&&h?1:y;m===-1||C===0||C===1&&m===S-1&&m===y+1?c.base=c.name=t.slice(v,S):(c.name=t.slice(v,m),c.base=t.slice(v,S),c.ext=t.slice(m,S))}return y>0?c.dir=t.slice(0,y-1):h&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=a?e.$fc.normalize:e.$gc.normalize,e.$ic=a?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=a?e.$fc.join:e.$gc.join,e.$kc=a?e.$fc.resolve:e.$gc.resolve,e.$lc=a?e.$fc.relative:e.$gc.relative,e.$mc=a?e.$fc.dirname:e.$gc.dirname,e.$nc=a?e.$fc.basename:e.$gc.basename,e.$oc=a?e.$fc.extname:e.$gc.extname,e.$pc=a?e.$fc.format:e.$gc.format,e.$qc=a?e.$fc.parse:e.$gc.parse,e.$rc=a?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=a?e.$fc.sep:e.$gc.sep,e.$tc=a?e.$fc.delimiter:e.$gc.delimiter}),define(Ee[135],Se([1,0,49,16]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=R,e.$qr=p,e.$rr=l,e.$sr=I,e.$tr=D,e.$ur=f,e.$vr=A,e.$wr=w,e.$xr=a,e.$yr=d,e.$zr=m,e.$Ar=y,e.$Br=S;const P=new r.$V(()=>{const E=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:E,collatorIsNumeric:E.resolvedOptions().numeric}}),T=new r.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new r.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function R(E,k,C=!1){const v=E||"",b=k||"",O=P.value.collator.compare(v,b);return P.value.collatorIsNumeric&&O===0&&v!==b?v<b?-1:1:O}function p(E,k){const C=T.value.collator;return E=E||"",k=k||"",o(C,E,k)}function l(E,k){const C=T.value.collator;return E=E||"",k=k||"",h(E,k)||o(C,E,k)}function I(E,k){const C=T.value.collator;return E=E||"",k=k||"",c(E,k)||o(C,E,k)}function D(E,k){return E=E||"",k=k||"",E===k?0:E<k?-1:1}function f(E,k){const[C,v]=$(E),[b,O]=$(k);let U=P.value.collator.compare(v,O);if(U===0){if(P.value.collatorIsNumeric&&v!==O)return v<O?-1:1;if(U=P.value.collator.compare(C,b),P.value.collatorIsNumeric&&U===0&&C!==b)return C<b?-1:1}return U}function A(E,k){E=E||"",k=k||"";const C=i(E),v=i(k),b=T.value.collator,O=L.value.collator;return o(O,C,v)||o(b,E,k)}function w(E,k){E=E||"",k=k||"";const C=i(E),v=i(k),b=T.value.collator,O=L.value.collator;return o(O,C,v)||h(E,k)||o(b,E,k)}function a(E,k){E=E||"",k=k||"";const C=i(E),v=i(k),b=T.value.collator,O=L.value.collator;return o(O,C,v)||c(E,k)||o(b,E,k)}function d(E,k){E=E||"",k=k||"";const C=i(E).toLowerCase(),v=i(k).toLowerCase();return C!==v?C<v?-1:1:E!==k?E<k?-1:1:0}const g=/^(.*?)(\.([^.]*))?$/;function $(E,k=!1){const C=E?g.exec(E):[];let v=[C&&C[1]||"",C&&C[3]||""];return k&&(!v[0]&&v[1]||v[0]&&v[0].charAt(0)===".")&&(v=[v[0]+"."+v[1],""]),v}function i(E){const k=E?g.exec(E):[];return k&&k[1]&&k[1].charAt(0)!=="."&&k[3]||""}function o(E,k,C){const v=E.compare(k,C);return v!==0?v:k.length!==C.length?k.length<C.length?-1:1:0}function n(E){const k=E.charAt(0);return k.toLocaleUpperCase()!==k}function t(E){const k=E.charAt(0);return k.toLocaleLowerCase()!==k}function c(E,k){return n(E)&&t(k)?-1:t(E)&&n(k)?1:0}function h(E,k){return t(E)&&n(k)?-1:n(E)&&t(k)?1:0}function s(E,k,C=!1){return C||(E=E&&E.toLowerCase(),k=k&&k.toLowerCase()),E===k?0:E<k?-1:1}function m(E,k,C=!1){const v=E.split(u.sep),b=k.split(u.sep),O=v.length-1,U=b.length-1;let z,j;for(let M=0;;M++){if(z=O===M,j=U===M,z&&j)return R(v[M],b[M],C);if(z)return-1;if(j)return 1;const N=s(v[M],b[M],C);if(N!==0)return N}}function y(E,k,C){const v=E.toLowerCase(),b=k.toLowerCase(),O=S(E,k,C);if(O)return O;const U=v.endsWith(C),z=b.endsWith(C);if(U!==z)return U?-1:1;const j=R(v,b);return j!==0?j:v.localeCompare(b)}function S(E,k,C){const v=E.toLowerCase(),b=k.toLowerCase(),O=v.startsWith(C),U=b.startsWith(C);if(O!==U)return O?-1:1;if(O&&U){if(v.length<b.length)return-1;if(v.length>b.length)return 1}return 0}}),define(Ee[103],Se([1,0,16]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0,e.$1s=T,e.$2s=L,e.$3s=R,e.$4s=l,e.$Zs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const u={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(I){const D=(0,r.$oc)(I),f=u[D.toLowerCase()];return f!==void 0?f:L(I)}function L(I){const D=(0,r.$oc)(I);return P[D.toLowerCase()]}function R(I){for(const D in P)if(P[D]===I)return D}const p=/^(.+)\/(.+?)(;.+)?$/;function l(I,D){const f=p.exec(I);return f?`${f[1].toLowerCase()}/${f[2].toLowerCase()}${f[3]??""}`:D?void 0:I}}),define(Ee[104],Se([1,0,11]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$sm=T,e.$tm=L;var u;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(u||(e.Source=u={}));var P;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(P||(e.TerminateResponseCode=P={}));function T(R,...p){const l=p.reduce((f,A)=>(f[A]=!0,f),{}),I=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(R).filter(f=>!l[f]).forEach(f=>{for(let A=0;A<I.length;A++)if(f.search(I[A])!==-1){delete R[f];break}})}function L(R){R&&(delete R.DEBUG,r.$d&&delete R.DYLD_LIBRARY_PATH,r.$e&&delete R.LD_PRELOAD)}}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var r=e();for(var u in r)(typeof exports=="object"?exports:oe)[u]=r[u]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function r(u){if(e[u])return e[u].exports;var P=e[u]={i:u,l:!1,exports:{}};return oe[u].call(P.exports,P,P.exports,r),P.l=!0,P.exports}return r.m=oe,r.c=e,r.d=function(u,P,T){r.o(u,P)||Object.defineProperty(u,P,{enumerable:!0,get:T})},r.r=function(u){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(u,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(u,"__esModule",{value:!0})},r.t=function(u,P){if(1&P&&(u=r(u)),8&P||4&P&&typeof u=="object"&&u&&u.__esModule)return u;var T=Object.create(null);if(r.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:u}),2&P&&typeof u!="string")for(var L in u)r.d(T,L,function(R){return u[R]}.bind(null,L));return T},r.n=function(u){var P=u&&u.__esModule?function(){return u.default}:function(){return u};return r.d(P,"a",P),P},r.o=function(u,P){return Object.prototype.hasOwnProperty.call(u,P)},r.p="",r(r.s=0)}([function(oe,e,r){(function(u){var P;e=oe.exports=we,P=typeof u=="object"&&u.env&&u.env.NODE_DEBUG&&/\bsemver\b/i.test(u.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],p=e.src=[],l=0,I=l++;p[I]="0|[1-9]\\d*";var D=l++;p[D]="[0-9]+";var f=l++;p[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var A=l++;p[A]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var w=l++;p[w]="("+p[D]+")\\.("+p[D]+")\\.("+p[D]+")";var a=l++;p[a]="(?:"+p[I]+"|"+p[f]+")";var d=l++;p[d]="(?:"+p[D]+"|"+p[f]+")";var g=l++;p[g]="(?:-("+p[a]+"(?:\\."+p[a]+")*))";var $=l++;p[$]="(?:-?("+p[d]+"(?:\\."+p[d]+")*))";var i=l++;p[i]="[0-9A-Za-z-]+";var o=l++;p[o]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var n=l++,t="v?"+p[A]+p[g]+"?"+p[o]+"?";p[n]="^"+t+"$";var c="[v=\\s]*"+p[w]+p[$]+"?"+p[o]+"?",h=l++;p[h]="^"+c+"$";var s=l++;p[s]="((?:<|>)?=?)";var m=l++;p[m]=p[D]+"|x|X|\\*";var y=l++;p[y]=p[I]+"|x|X|\\*";var S=l++;p[S]="[v=\\s]*("+p[y]+")(?:\\.("+p[y]+")(?:\\.("+p[y]+")(?:"+p[g]+")?"+p[o]+"?)?)?";var E=l++;p[E]="[v=\\s]*("+p[m]+")(?:\\.("+p[m]+")(?:\\.("+p[m]+")(?:"+p[$]+")?"+p[o]+"?)?)?";var k=l++;p[k]="^"+p[s]+"\\s*"+p[S]+"$";var C=l++;p[C]="^"+p[s]+"\\s*"+p[E]+"$";var v=l++;p[v]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=l++;p[b]="(?:~>?)";var O=l++;p[O]="(\\s*)"+p[b]+"\\s+",R[O]=new RegExp(p[O],"g");var U=l++;p[U]="^"+p[b]+p[S]+"$";var z=l++;p[z]="^"+p[b]+p[E]+"$";var j=l++;p[j]="(?:\\^)";var M=l++;p[M]="(\\s*)"+p[j]+"\\s+",R[M]=new RegExp(p[M],"g");var N=l++;p[N]="^"+p[j]+p[S]+"$";var F=l++;p[F]="^"+p[j]+p[E]+"$";var X=l++;p[X]="^"+p[s]+"\\s*("+c+")$|^$";var se=l++;p[se]="^"+p[s]+"\\s*("+t+")$|^$";var W=l++;p[W]="(\\s*)"+p[s]+"\\s*("+c+"|"+p[S]+")",R[W]=new RegExp(p[W],"g");var H=l++;p[H]="^\\s*("+p[S]+")\\s+-\\s+("+p[S]+")\\s*$";var V=l++;p[V]="^\\s*("+p[E]+")\\s+-\\s+("+p[E]+")\\s*$";var x=l++;p[x]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)P(he,p[he]),R[he]||(R[he]=new RegExp(p[he]));function ne(q,Y){if(q instanceof we)return q;if(typeof q!="string"||q.length>T||!(Y?R[h]:R[n]).test(q))return null;try{return new we(q,Y)}catch{return null}}function we(q,Y){if(q instanceof we){if(q.loose===Y)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof we))return new we(q,Y);P("SemVer",q,Y),this.loose=Y;var _=q.trim().match(Y?R[h]:R[n]);if(!_)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(fe){if(/^[0-9]+$/.test(fe)){var ve=+fe;if(ve>=0&&ve<L)return ve}return fe}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=ne,e.valid=function(q,Y){var _=ne(q,Y);return _?_.version:null},e.clean=function(q,Y){var _=ne(q.trim().replace(/^[=v]+/,""),Y);return _?_.version:null},e.SemVer=we,we.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},we.prototype.toString=function(){return this.version},we.prototype.compare=function(q){return P("SemVer.compare",this.version,this.loose,q),q instanceof we||(q=new we(q,this.loose)),this.compareMain(q)||this.comparePre(q)},we.prototype.compareMain=function(q){return q instanceof we||(q=new we(q,this.loose)),ce(this.major,q.major)||ce(this.minor,q.minor)||ce(this.patch,q.patch)},we.prototype.comparePre=function(q){if(q instanceof we||(q=new we(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Y=0;do{var _=this.prerelease[Y],fe=q.prerelease[Y];if(P("prerelease compare",Y,_,fe),_===void 0&&fe===void 0)return 0;if(fe===void 0)return 1;if(_===void 0)return-1;if(_!==fe)return ce(_,fe)}while(++Y)},we.prototype.inc=function(q,Y){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Y,_,fe){typeof _=="string"&&(fe=_,_=void 0);try{return new we(q,_).inc(Y,fe).version}catch{return null}},e.diff=function(q,Y){if(ee(q,Y))return null;var _=ne(q),fe=ne(Y);if(_.prerelease.length||fe.prerelease.length){for(var ve in _)if((ve==="major"||ve==="minor"||ve==="patch")&&_[ve]!==fe[ve])return"pre"+ve;return"prerelease"}for(var ve in _)if((ve==="major"||ve==="minor"||ve==="patch")&&_[ve]!==fe[ve])return ve},e.compareIdentifiers=ce;var pe=/^[0-9]+$/;function ce(q,Y){var _=pe.test(q),fe=pe.test(Y);return _&&fe&&(q=+q,Y=+Y),_&&!fe?-1:fe&&!_?1:q<Y?-1:q>Y?1:0}function K(q,Y,_){return new we(q,_).compare(new we(Y,_))}function de(q,Y,_){return K(q,Y,_)>0}function te(q,Y,_){return K(q,Y,_)<0}function ee(q,Y,_){return K(q,Y,_)===0}function ie(q,Y,_){return K(q,Y,_)!==0}function le(q,Y,_){return K(q,Y,_)>=0}function Z(q,Y,_){return K(q,Y,_)<=0}function ae(q,Y,_,fe){var ve;switch(Y){case"===":typeof q=="object"&&(q=q.version),typeof _=="object"&&(_=_.version),ve=q===_;break;case"!==":typeof q=="object"&&(q=q.version),typeof _=="object"&&(_=_.version),ve=q!==_;break;case"":case"=":case"==":ve=ee(q,_,fe);break;case"!=":ve=ie(q,_,fe);break;case">":ve=de(q,_,fe);break;case">=":ve=le(q,_,fe);break;case"<":ve=te(q,_,fe);break;case"<=":ve=Z(q,_,fe);break;default:throw new TypeError("Invalid operator: "+Y)}return ve}function $e(q,Y){if(q instanceof $e){if(q.loose===Y)return q;q=q.value}if(!(this instanceof $e))return new $e(q,Y);P("comparator",q,Y),this.loose=Y,this.parse(q),this.semver===be?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(q,Y){return ce(Y,q)},e.major=function(q,Y){return new we(q,Y).major},e.minor=function(q,Y){return new we(q,Y).minor},e.patch=function(q,Y){return new we(q,Y).patch},e.compare=K,e.compareLoose=function(q,Y){return K(q,Y,!0)},e.rcompare=function(q,Y,_){return K(Y,q,_)},e.sort=function(q,Y){return q.sort(function(_,fe){return e.compare(_,fe,Y)})},e.rsort=function(q,Y){return q.sort(function(_,fe){return e.rcompare(_,fe,Y)})},e.gt=de,e.lt=te,e.eq=ee,e.neq=ie,e.gte=le,e.lte=Z,e.cmp=ae,e.Comparator=$e;var be={};function Me(q,Y){if(q instanceof Me)return q.loose===Y?q:new Me(q.raw,Y);if(q instanceof $e)return new Me(q.value,Y);if(!(this instanceof Me))return new Me(q,Y);if(this.loose=Y,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function qe(q){return!q||q.toLowerCase()==="x"||q==="*"}function De(q,Y,_,fe,ve,Ne,Be,Qe,He,tt,nt,ot,at){return((Y=qe(_)?"":qe(fe)?">="+_+".0.0":qe(ve)?">="+_+"."+fe+".0":">="+Y)+" "+(Qe=qe(He)?"":qe(tt)?"<"+(+He+1)+".0.0":qe(nt)?"<"+He+"."+(+tt+1)+".0":ot?"<="+He+"."+tt+"."+nt+"-"+ot:"<="+Qe)).trim()}function Pe(q,Y){for(var _=0;_<q.length;_++)if(!q[_].test(Y))return!1;if(Y.prerelease.length){for(_=0;_<q.length;_++)if(P(q[_].semver),q[_].semver!==be&&q[_].semver.prerelease.length>0){var fe=q[_].semver;if(fe.major===Y.major&&fe.minor===Y.minor&&fe.patch===Y.patch)return!0}return!1}return!0}function Te(q,Y,_){try{Y=new Me(Y,_)}catch{return!1}return Y.test(q)}function B(q,Y,_,fe){var ve,Ne,Be,Qe,He;switch(q=new we(q,fe),Y=new Me(Y,fe),_){case">":ve=de,Ne=Z,Be=te,Qe=">",He=">=";break;case"<":ve=te,Ne=le,Be=de,Qe="<",He="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(q,Y,fe))return!1;for(var tt=0;tt<Y.set.length;++tt){var nt=Y.set[tt],ot=null,at=null;if(nt.forEach(function(pt){pt.semver===be&&(pt=new $e(">=0.0.0")),ot=ot||pt,at=at||pt,ve(pt.semver,ot.semver,fe)?ot=pt:Be(pt.semver,at.semver,fe)&&(at=pt)}),ot.operator===Qe||ot.operator===He||(!at.operator||at.operator===Qe)&&Ne(q,at.semver)||at.operator===He&&Be(q,at.semver))return!1}return!0}$e.prototype.parse=function(q){var Y=this.loose?R[X]:R[se],_=q.match(Y);if(!_)throw new TypeError("Invalid comparator: "+q);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new we(_[2],this.loose):this.semver=be},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(q){return P("Comparator.test",q,this.loose),this.semver===be||(typeof q=="string"&&(q=new we(q,this.loose)),ae(q,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(q,Y){if(!(q instanceof $e))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new Me(q.value,Y),Te(this.value,_,Y);if(q.operator==="")return _=new Me(this.value,Y),Te(q.semver,_,Y);var fe=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Ne=this.semver.version===q.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Qe=ae(this.semver,"<",q.semver,Y)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),He=ae(this.semver,">",q.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return fe||ve||Ne&&Be||Qe||He},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(q){var Y=this.loose;q=q.trim(),P("range",q,Y);var _=Y?R[V]:R[H];q=q.replace(_,De),P("hyphen replace",q),q=q.replace(R[W],"$1$2$3"),P("comparator trim",q,R[W]),q=(q=(q=q.replace(R[O],"$1~")).replace(R[M],"$1^")).split(/\s+/).join(" ");var fe=Y?R[X]:R[se],ve=q.split(" ").map(function(Ne){return function(Be,Qe){return P("comp",Be),Be=function(He,tt){return He.trim().split(/\s+/).map(function(nt){return function(ot,at){P("caret",ot,at);var pt=at?R[F]:R[N];return ot.replace(pt,function(ft,st,ht,Re,Ie){var Ae;return P("caret",ot,ft,st,ht,Re,Ie),qe(st)?Ae="":qe(ht)?Ae=">="+st+".0.0 <"+(+st+1)+".0.0":qe(Re)?Ae=st==="0"?">="+st+"."+ht+".0 <"+st+"."+(+ht+1)+".0":">="+st+"."+ht+".0 <"+(+st+1)+".0.0":Ie?(P("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=st==="0"?ht==="0"?">="+st+"."+ht+"."+Re+Ie+" <"+st+"."+ht+"."+(+Re+1):">="+st+"."+ht+"."+Re+Ie+" <"+st+"."+(+ht+1)+".0":">="+st+"."+ht+"."+Re+Ie+" <"+(+st+1)+".0.0"):(P("no pr"),Ae=st==="0"?ht==="0"?">="+st+"."+ht+"."+Re+" <"+st+"."+ht+"."+(+Re+1):">="+st+"."+ht+"."+Re+" <"+st+"."+(+ht+1)+".0":">="+st+"."+ht+"."+Re+" <"+(+st+1)+".0.0"),P("caret return",Ae),Ae})}(nt,tt)}).join(" ")}(Be,Qe),P("caret",Be),Be=function(He,tt){return He.trim().split(/\s+/).map(function(nt){return function(ot,at){var pt=at?R[z]:R[U];return ot.replace(pt,function(ft,st,ht,Re,Ie){var Ae;return P("tilde",ot,ft,st,ht,Re,Ie),qe(st)?Ae="":qe(ht)?Ae=">="+st+".0.0 <"+(+st+1)+".0.0":qe(Re)?Ae=">="+st+"."+ht+".0 <"+st+"."+(+ht+1)+".0":Ie?(P("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Ae=">="+st+"."+ht+"."+Re+Ie+" <"+st+"."+(+ht+1)+".0"):Ae=">="+st+"."+ht+"."+Re+" <"+st+"."+(+ht+1)+".0",P("tilde return",Ae),Ae})}(nt,tt)}).join(" ")}(Be,Qe),P("tildes",Be),Be=function(He,tt){return P("replaceXRanges",He,tt),He.split(/\s+/).map(function(nt){return function(ot,at){ot=ot.trim();var pt=at?R[C]:R[k];return ot.replace(pt,function(ft,st,ht,Re,Ie,Ae){P("xRange",ot,ft,st,ht,Re,Ie,Ae);var ue=qe(ht),Q=ue||qe(Re),Ce=Q||qe(Ie);return st==="="&&Ce&&(st=""),ue?ft=st===">"||st==="<"?"<0.0.0":"*":st&&Ce?(Q&&(Re=0),Ce&&(Ie=0),st===">"?(st=">=",Q?(ht=+ht+1,Re=0,Ie=0):Ce&&(Re=+Re+1,Ie=0)):st==="<="&&(st="<",Q?ht=+ht+1:Re=+Re+1),ft=st+ht+"."+Re+"."+Ie):Q?ft=">="+ht+".0.0 <"+(+ht+1)+".0.0":Ce&&(ft=">="+ht+"."+Re+".0 <"+ht+"."+(+Re+1)+".0"),P("xRange return",ft),ft})}(nt,tt)}).join(" ")}(Be,Qe),P("xrange",Be),Be=function(He,tt){return P("replaceStars",He,tt),He.trim().replace(R[x],"")}(Be,Qe),P("stars",Be),Be}(Ne,Y)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Ne){return!!Ne.match(fe)})),ve=ve.map(function(Ne){return new $e(Ne,Y)})},Me.prototype.intersects=function(q,Y){if(!(q instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(fe){return q.set.some(function(ve){return ve.every(function(Ne){return fe.intersects(Ne,Y)})})})})},e.toComparators=function(q,Y){return new Me(q,Y).set.map(function(_){return _.map(function(fe){return fe.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new we(q,this.loose));for(var Y=0;Y<this.set.length;Y++)if(Pe(this.set[Y],q))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(q,Y,_){var fe=null,ve=null;try{var Ne=new Me(Y,_)}catch{return null}return q.forEach(function(Be){Ne.test(Be)&&(fe&&ve.compare(Be)!==-1||(ve=new we(fe=Be,_)))}),fe},e.minSatisfying=function(q,Y,_){var fe=null,ve=null;try{var Ne=new Me(Y,_)}catch{return null}return q.forEach(function(Be){Ne.test(Be)&&(fe&&ve.compare(Be)!==1||(ve=new we(fe=Be,_)))}),fe},e.validRange=function(q,Y){try{return new Me(q,Y).range||"*"}catch{return null}},e.ltr=function(q,Y,_){return B(q,Y,"<",_)},e.gtr=function(q,Y,_){return B(q,Y,">",_)},e.outside=B,e.prerelease=function(q,Y){var _=ne(q,Y);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(q,Y,_){return q=new Me(q,_),Y=new Me(Y,_),q.intersects(Y)},e.coerce=function(q){if(q instanceof we)return q;if(typeof q!="string")return null;var Y=q.match(R[v]);return Y==null?null:ne((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,r(1))},function(oe,e){var r,u,P=oe.exports={};function T(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(d){if(r===setTimeout)return setTimeout(d,0);if((r===T||!r)&&setTimeout)return r=setTimeout,setTimeout(d,0);try{return r(d,0)}catch{try{return r.call(null,d,0)}catch{return r.call(this,d,0)}}}(function(){try{r=typeof setTimeout=="function"?setTimeout:T}catch{r=T}try{u=typeof clearTimeout=="function"?clearTimeout:L}catch{u=L}})();var p,l=[],I=!1,D=-1;function f(){I&&p&&(I=!1,p.length?l=p.concat(l):D=-1,l.length&&A())}function A(){if(!I){var d=R(f);I=!0;for(var g=l.length;g;){for(p=l,l=[];++D<g;)p&&p[D].run();D=-1,g=l.length}p=null,I=!1,function($){if(u===clearTimeout)return clearTimeout($);if((u===L||!u)&&clearTimeout)return u=clearTimeout,clearTimeout($);try{u($)}catch{try{return u.call(null,$)}catch{return u.call(this,$)}}}(d)}}function w(d,g){this.fun=d,this.array=g}function a(){}P.nextTick=function(d){var g=new Array(arguments.length-1);if(arguments.length>1)for(var $=1;$<arguments.length;$++)g[$-1]=arguments[$];l.push(new w(d,g)),l.length!==1||I||R(A)},w.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=a,P.addListener=a,P.once=a,P.off=a,P.removeListener=a,P.removeAllListeners=a,P.emit=a,P.prependListener=a,P.prependOnceListener=a,P.listeners=function(d){return[]},P.binding=function(d){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(d){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ee[43],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const r=globalThis.performance&&typeof globalThis.performance.now=="function";class u{static create(T){return new u(T)}constructor(T){this.c=r&&T===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=u}),define(Ee[4],Se([1,0,14,80,3,81,43]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=A;const R=!1,p=!1,l=!1;var I;(function(z){z.None=()=>P.$Uc.None;function j(De){if(l){const{onDidAddListener:Pe}=De,Te=a.create();let B=0;De.onDidAddListener=()=>{++B===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Te.print()),Pe?.()}}}function M(De,Pe){return ne(De,()=>{},0,void 0,!0,void 0,Pe)}z.defer=M;function N(De){return(Pe,Te=null,B)=>{let q=!1,Y;return Y=De(_=>{if(!q)return Y?Y.dispose():q=!0,Pe.call(Te,_)},null,B),q&&Y.dispose(),Y}}z.once=N;function F(De,Pe,Te){return x((B,q=null,Y)=>De(_=>B.call(q,Pe(_)),null,Y),Te)}z.map=F;function X(De,Pe,Te){return x((B,q=null,Y)=>De(_=>{Pe(_),B.call(q,_)},null,Y),Te)}z.forEach=X;function se(De,Pe,Te){return x((B,q=null,Y)=>De(_=>Pe(_)&&B.call(q,_),null,Y),Te)}z.filter=se;function W(De){return De}z.signal=W;function H(...De){return(Pe,Te=null,B)=>{const q=(0,P.$Rc)(...De.map(Y=>Y(_=>Pe.call(Te,_))));return he(q,B)}}z.any=H;function V(De,Pe,Te,B){let q=Te;return F(De,Y=>(q=Pe(q,Y),q),B)}z.reduce=V;function x(De,Pe){let Te;const B={onWillAddFirstListener(){Te=De(q.fire,q)},onDidRemoveLastListener(){Te?.dispose()}};Pe||j(B);const q=new c(B);return Pe?.add(q),q.event}function he(De,Pe){return Pe instanceof Array?Pe.push(De):Pe&&Pe.add(De),De}function ne(De,Pe,Te=100,B=!1,q=!1,Y,_){let fe,ve,Ne,Be=0,Qe;const He={leakWarningThreshold:Y,onWillAddFirstListener(){fe=De(nt=>{Be++,ve=Pe(ve,nt),B&&!Ne&&(tt.fire(ve),ve=void 0),Qe=()=>{const ot=ve;ve=void 0,Ne=void 0,(!B||Be>1)&&tt.fire(ot),Be=0},typeof Te=="number"?(clearTimeout(Ne),Ne=setTimeout(Qe,Te)):Ne===void 0&&(Ne=0,queueMicrotask(Qe))})},onWillRemoveListener(){q&&Be>0&&Qe?.()},onDidRemoveLastListener(){Qe=void 0,fe.dispose()}};_||j(He);const tt=new c(He);return _?.add(tt),tt.event}z.debounce=ne;function we(De,Pe=0,Te){return z.debounce(De,(B,q)=>B?(B.push(q),B):[q],Pe,void 0,!0,void 0,Te)}z.accumulate=we;function pe(De,Pe=(B,q)=>B===q,Te){let B=!0,q;return se(De,Y=>{const _=B||!Pe(Y,q);return B=!1,q=Y,_},Te)}z.latch=pe;function ce(De,Pe,Te){return[z.filter(De,Pe,Te),z.filter(De,B=>!Pe(B),Te)]}z.split=ce;function K(De,Pe=!1,Te=[],B){let q=Te.slice(),Y=De(ve=>{q?q.push(ve):fe.fire(ve)});B&&B.add(Y);const _=()=>{q?.forEach(ve=>fe.fire(ve)),q=null},fe=new c({onWillAddFirstListener(){Y||(Y=De(ve=>fe.fire(ve)),B&&B.add(Y))},onDidAddFirstListener(){q&&(Pe?setTimeout(_):_())},onDidRemoveLastListener(){Y&&Y.dispose(),Y=null}});return B&&B.add(fe),fe.event}z.buffer=K;function de(De,Pe){return(B,q,Y)=>{const _=Pe(new ee);return De(function(fe){const ve=_.evaluate(fe);ve!==te&&B.call(q,ve)},void 0,Y)}}z.chain=de;const te=Symbol("HaltChainable");class ee{constructor(){this.f=[]}map(Pe){return this.f.push(Pe),this}forEach(Pe){return this.f.push(Te=>(Pe(Te),Te)),this}filter(Pe){return this.f.push(Te=>Pe(Te)?Te:te),this}reduce(Pe,Te){let B=Te;return this.f.push(q=>(B=Pe(B,q),B)),this}latch(Pe=(Te,B)=>Te===B){let Te=!0,B;return this.f.push(q=>{const Y=Te||!Pe(q,B);return Te=!1,B=q,Y?q:te}),this}evaluate(Pe){for(const Te of this.f)if(Pe=Te(Pe),Pe===te)break;return Pe}}function ie(De,Pe,Te=B=>B){const B=(...fe)=>_.fire(Te(...fe)),q=()=>De.on(Pe,B),Y=()=>De.removeListener(Pe,B),_=new c({onWillAddFirstListener:q,onDidRemoveLastListener:Y});return _.event}z.fromNodeEventEmitter=ie;function le(De,Pe,Te=B=>B){const B=(...fe)=>_.fire(Te(...fe)),q=()=>De.addEventListener(Pe,B),Y=()=>De.removeEventListener(Pe,B),_=new c({onWillAddFirstListener:q,onDidRemoveLastListener:Y});return _.event}z.fromDOMEventEmitter=le;function Z(De){return new Promise(Pe=>N(De)(Pe))}z.toPromise=Z;function ae(De){const Pe=new c;return De.then(Te=>{Pe.fire(Te)},()=>{Pe.fire(void 0)}).finally(()=>{Pe.dispose()}),Pe.event}z.fromPromise=ae;function $e(De,Pe,Te){return Pe(Te),De(B=>Pe(B))}z.runAndSubscribe=$e;class be{constructor(Pe,Te){this._observable=Pe,this.f=0,this.g=!1;const B={onWillAddFirstListener:()=>{Pe.addObserver(this)},onDidRemoveLastListener:()=>{Pe.removeObserver(this)}};Te||j(B),this.emitter=new c(B),Te&&Te.add(this.emitter)}beginUpdate(Pe){this.f++}handlePossibleChange(Pe){}handleChange(Pe,Te){this.g=!0}endUpdate(Pe){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function Me(De,Pe){return new be(De,Pe).emitter.event}z.fromObservable=Me;function qe(De){return(Pe,Te,B)=>{let q=0,Y=!1;const _={beginUpdate(){q++},endUpdate(){q--,q===0&&(De.reportChanges(),Y&&(Y=!1,Pe.call(Te)))},handlePossibleChange(){},handleChange(){Y=!0}};De.addObserver(_),De.reportChanges();const fe={dispose(){De.removeObserver(_)}};return B instanceof P.$Tc?B.add(fe):Array.isArray(B)&&B.push(fe),fe}}z.fromObservableLight=qe})(I||(e.Event=I={}));class D{constructor(j){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${j}_${D.f++}`,D.all.add(this)}start(j){this.g=new L.$be,this.listenerCount=j}stop(){if(this.g){const j=this.g.elapsed();this.durations.push(j),this.elapsedOverall+=j,this.invocationCount+=1,this.g=void 0}}}e.$de=D,D.all=new Set,D.f=0;let f=-1;function A(z){const j=f;return f=z,{dispose(){f=j}}}class w{constructor(j,M,N=Math.random().toString(18).slice(2,5)){this.h=j,this.threshold=M,this.name=N,this.g=0}dispose(){this.f?.clear()}check(j,M){const N=this.threshold;if(N<=0||M<N)return;this.f||(this.f=new Map);const F=this.f.get(j.value)||0;if(this.f.set(j.value,F+1),this.g-=1,this.g<=0){this.g=N*.5;const[X,se]=this.getMostFrequentStack(),W=`[${this.name}] potential listener LEAK detected, having ${M} listeners already. MOST frequent listener (${se}):`;console.warn(W),console.warn(X);const H=new d(W,X);this.h(H)}return()=>{const X=this.f.get(j.value)||0;this.f.set(j.value,X-1)}}getMostFrequentStack(){if(!this.f)return;let j,M=0;for(const[N,F]of this.f)(!j||M<F)&&(j=[N,F],M=F);return j}}class a{static create(){const j=new Error;return new a(j.stack??"")}constructor(j){this.value=j}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class d extends Error{constructor(j,M){super(j),this.name="ListenerLeakError",this.stack=M}}e.$fe=d;class g extends Error{constructor(j,M){super(j),this.name="ListenerRefusalError",this.stack=M}}e.$ge=g;let $=0;class i{constructor(j){this.value=j,this.id=$++}}const o=2,n=(z,j)=>{if(z instanceof i)j(z);else for(let M=0;M<z.length;M++){const N=z[M];N&&j(N)}},t=R?new FinalizationRegistry(z=>{typeof z=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(z))}):void 0;class c{constructor(j){this.w=0,this.f=j,this.g=f>0||this.f?.leakWarningThreshold?new w(j?.onListenerError??r.$1,this.f?.leakWarningThreshold??f):void 0,this.j=this.f?._profName?new D(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(p){const j=this.t;queueMicrotask(()=>{n(j,M=>M.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??(this.q=(j,M,N)=>{if(this.g&&this.w>this.g.threshold**2){const H=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.w} vs ${this.g.threshold})`;console.warn(H);const V=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],x=new g(`${H}. HINT: Stack shows most frequent listener (${V[1]}-times)`,V[0]);return(this.f?.onListenerError||r.$1)(x),P.$Uc.None}if(this.m)return P.$Uc.None;M&&(j=j.bind(M));const F=new i(j);let X,se;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=a.create(),X=this.g.check(F.stack,this.w+1)),p&&(F.stack=se??a.create()),this.t?this.t instanceof i?(this.u??(this.u=new s),this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const W=(0,P.$Sc)(()=>{t?.unregister(W),X?.(),this.x(F)});if(N instanceof P.$Tc?N.add(W):Array.isArray(N)&&N.push(W),t){const H=new Error().stack.split(`
`).slice(2).join(`
`).trim();t.register(W,H,W)}return W}),this.q}x(j){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const M=this.t,N=M.indexOf(j);if(N===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,M[N]=void 0;const F=this.u.current===this;if(this.w*o<=M.length){let X=0;for(let se=0;se<M.length;se++)M[se]?M[X++]=M[se]:F&&(this.u.end--,X<this.u.i&&this.u.i--);M.length=X}}y(j,M){if(!j)return;const N=this.f?.onListenerError||r.$1;if(!N){j.value(M);return}try{j.value(M)}catch(F){N(F)}}z(j){const M=j.current.t;for(;j.i<j.end;)this.y(M[j.i++],j.value);j.reset()}fire(j){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof i)this.y(this.t,j);else{const M=this.u;M.enqueue(this,j,this.t.length),this.z(M)}this.j?.stop()}hasListeners(){return this.w>0}}e.$he=c;const h=()=>new s;e.$ie=h;class s{constructor(){this.i=-1,this.end=0}enqueue(j,M,N){this.i=0,this.end=N,this.current=j,this.value=M}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class m extends c{async fireAsync(j,M,N){if(this.t)for(this.h||(this.h=new T.$5c),n(this.t,F=>this.h.push([F.value,j]));this.h.size>0&&!M.isCancellationRequested;){const[F,X]=this.h.shift(),se=[],W={...X,token:M,waitUntil:H=>{if(Object.isFrozen(se))throw new Error("waitUntil can NOT be called asynchronous");N&&(H=N(H,F)),se.push(H)}};try{F(W)}catch(H){(0,r.$1)(H);continue}Object.freeze(se),await Promise.allSettled(se).then(H=>{for(const V of H)V.status==="rejected"&&(0,r.$1)(V.reason)})}}}e.$je=m;class y extends c{get isPaused(){return this.h!==0}constructor(j){super(j),this.h=0,this.s=new T.$5c,this.A=j?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const j=Array.from(this.s);this.s.clear(),super.fire(this.A(j))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(j){this.w&&(this.h!==0?this.s.push(j):super.fire(j))}}e.$ke=y;class S extends y{constructor(j){super(j),this.k=j.delay??100}fire(j){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(j)}}e.$le=S;class E extends c{constructor(j){super(j),this.h=[],this.k=j?.merge}fire(j){this.hasListeners()&&(this.h.push(j),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(M=>super.fire(M)),this.h=[]}))}}e.$me=E;class k{constructor(){this.g=!1,this.h=[],this.f=new c({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(j){const M={event:j,listener:null};this.h.push(M),this.g&&this.m(M);const N=()=>{this.g&&this.o(M);const F=this.h.indexOf(M);this.h.splice(F,1)};return(0,P.$Sc)((0,u.$db)(N))}j(){this.g=!0,this.h.forEach(j=>this.m(j))}k(){this.g=!1,this.h.forEach(j=>this.o(j))}m(j){j.listener=j.event(M=>this.f.fire(M))}o(j){j.listener?.dispose(),j.listener=null}dispose(){this.f.dispose();for(const j of this.h)j.listener?.dispose();this.h=[]}}e.$ne=k;class C{constructor(j,M,N,F){this.f=new P.$Tc;const X=this.f.add(new k),se=this.f.add(new P.$4c);function W(H){se.set(H,X.add(F(H)))}for(const H of j)W(H);this.f.add(M(H=>{W(H)})),this.f.add(N(H=>{se.deleteAndDispose(H)})),this.event=X.event}dispose(){this.f.dispose()}}e.$oe=C;class v{constructor(){this.f=[]}wrapEvent(j,M,N){return(F,X,se)=>j(W=>{const H=this.f[this.f.length-1];if(!M){H?H.buffers.push(()=>F.call(X,W)):F.call(X,W);return}const V=H;if(!V){F.call(X,M(N,W));return}V.items??(V.items=[]),V.items.push(W),V.buffers.length===0&&H.buffers.push(()=>{V.reducedResult??(V.reducedResult=N?V.items.reduce(M,N):V.items.reduce(M)),F.call(X,V.reducedResult)})},void 0,se)}bufferEvents(j){const M={buffers:new Array};this.f.push(M);const N=j();return this.f.pop(),M.buffers.forEach(F=>F()),N}}e.$pe=v;class b{constructor(){this.f=!1,this.g=I.None,this.h=P.$Uc.None,this.j=new c({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(j){this.g=j,this.f&&(this.h.dispose(),this.h=j(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$qe=b;class O{static const(j){return new U(j)}constructor(j){this.g=j,this.f=new c,this.onDidChange=this.f.event}get value(){return this.g}set value(j){j!==this.g&&(this.g=j,this.f.fire(void 0))}}e.$re=O;class U{constructor(j){this.value=j,this.onDidChange=I.None}}}),define(Ee[21],Se([1,0,4]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=e.CancellationToken=void 0,e.$te=R;const u=Object.freeze(function(p,l){const I=setTimeout(p.bind(l),0);return{dispose(){clearTimeout(I)}}});var P;(function(p){function l(I){return I===p.None||I===p.Cancelled||I instanceof T?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}p.isCancellationToken=l,p.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:r.Event.None}),p.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:u})})(P||(e.CancellationToken=P={}));class T{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?u:(this.b||(this.b=new r.$he),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(l){this.f=void 0,this.g=void 0,this.g=l&&l.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new T),this.f}cancel(){this.f?this.f instanceof T&&this.f.cancel():this.f=P.Cancelled}dispose(l=!1){l&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof T&&this.f.dispose():this.f=P.None}}e.$se=L;function R(p){const l=new L;return p.add({dispose(){l.cancel()}}),l.token}}),define(Ee[182],Se([1,0,21]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8e=e.$7e=e.$5e=void 0,e.$6e=P;class u{constructor(p){this.b=p,this.a=null}get(){if(this.a)return this.a;const p=new r.$se,l=this.b(p.token);return this.a={promise:l,dispose:()=>{this.a=null,p.cancel(),p.dispose()}},this.a}}e.$5e=u;function P(R){return R}class T{constructor(p,l){this.a=void 0,this.b=void 0,typeof p=="function"?(this.c=p,this.d=P):(this.c=l,this.d=p.getCacheKey)}get(p){const l=this.d(p);return this.b!==l&&(this.b=l,this.a=this.c(p)),this.a}}e.$7e=T;class L{get cachedValues(){return this.a}constructor(p,l){this.a=new Map,this.b=new Map,typeof p=="function"?(this.c=p,this.d=P):(this.c=l,this.d=p.getCacheKey)}get(p){const l=this.d(p);if(this.b.has(l))return this.b.get(l);const I=this.c(p);return this.a.set(p,I),this.b.set(l,I),I}}e.$8e=L}),define(Ee[183],Se([1,0,4,3]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=e.$iu=e.$hu=e.$gu=e.ScrollbarVisibility=void 0;var P;(function(A){A[A.Auto=1]="Auto",A[A.Hidden=2]="Hidden",A[A.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class T{constructor(w,a,d,g,$,i,o){this.c=w,this._scrollStateBrand=void 0,this.c&&(a=a|0,d=d|0,g=g|0,$=$|0,i=i|0,o=o|0),this.rawScrollLeft=g,this.rawScrollTop=o,a<0&&(a=0),g+a>d&&(g=d-a),g<0&&(g=0),$<0&&($=0),o+$>i&&(o=i-$),o<0&&(o=0),this.width=a,this.scrollWidth=d,this.scrollLeft=g,this.height=$,this.scrollHeight=i,this.scrollTop=o}equals(w){return this.rawScrollLeft===w.rawScrollLeft&&this.rawScrollTop===w.rawScrollTop&&this.width===w.width&&this.scrollWidth===w.scrollWidth&&this.scrollLeft===w.scrollLeft&&this.height===w.height&&this.scrollHeight===w.scrollHeight&&this.scrollTop===w.scrollTop}withScrollDimensions(w,a){return new T(this.c,typeof w.width<"u"?w.width:this.width,typeof w.scrollWidth<"u"?w.scrollWidth:this.scrollWidth,a?this.rawScrollLeft:this.scrollLeft,typeof w.height<"u"?w.height:this.height,typeof w.scrollHeight<"u"?w.scrollHeight:this.scrollHeight,a?this.rawScrollTop:this.scrollTop)}withScrollPosition(w){return new T(this.c,this.width,this.scrollWidth,typeof w.scrollLeft<"u"?w.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof w.scrollTop<"u"?w.scrollTop:this.rawScrollTop)}createScrollEvent(w,a){const d=this.width!==w.width,g=this.scrollWidth!==w.scrollWidth,$=this.scrollLeft!==w.scrollLeft,i=this.height!==w.height,o=this.scrollHeight!==w.scrollHeight,n=this.scrollTop!==w.scrollTop;return{inSmoothScrolling:a,oldWidth:w.width,oldScrollWidth:w.scrollWidth,oldScrollLeft:w.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:w.height,oldScrollHeight:w.scrollHeight,oldScrollTop:w.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:d,scrollWidthChanged:g,scrollLeftChanged:$,heightChanged:i,scrollHeightChanged:o,scrollTopChanged:n}}}e.$gu=T;class L extends u.$Uc{constructor(w){super(),this._scrollableBrand=void 0,this.j=this.B(new r.$he),this.onScroll=this.j.event,this.c=w.smoothScrollDuration,this.f=w.scheduleAtNextAnimationFrame,this.g=new T(w.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(w){this.c=w}validateScrollPosition(w){return this.g.withScrollPosition(w)}getScrollDimensions(){return this.g}setScrollDimensions(w,a){const d=this.g.withScrollDimensions(w,a);this.n(d,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(w){const a=this.g.withScrollPosition(w);this.h&&(this.h.dispose(),this.h=null),this.n(a,!1)}setScrollPositionSmooth(w,a){if(this.c===0)return this.setScrollPositionNow(w);if(this.h){w={scrollLeft:typeof w.scrollLeft>"u"?this.h.to.scrollLeft:w.scrollLeft,scrollTop:typeof w.scrollTop>"u"?this.h.to.scrollTop:w.scrollTop};const d=this.g.withScrollPosition(w);if(this.h.to.scrollLeft===d.scrollLeft&&this.h.to.scrollTop===d.scrollTop)return;let g;a?g=new I(this.h.from,d,this.h.startTime,this.h.duration):g=this.h.combine(this.g,d,this.c),this.h.dispose(),this.h=g}else{const d=this.g.withScrollPosition(w);this.h=I.start(this.g,d,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const w=this.h.tick(),a=this.g.withScrollPosition(w);if(this.n(a,!0),!!this.h){if(w.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(w,a){const d=this.g;d.equals(w)||(this.g=w,this.j.fire(this.g.createScrollEvent(d,a)))}}e.$hu=L;class R{constructor(w,a,d){this.scrollLeft=w,this.scrollTop=a,this.isDone=d}}e.$iu=R;function p(A,w){const a=w-A;return function(d){return A+a*f(d)}}function l(A,w,a){return function(d){return d<a?A(d/a):w((d-a)/(1-a))}}class I{constructor(w,a,d,g){this.from=w,this.to=a,this.duration=g,this.startTime=d,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(w,a,d){if(Math.abs(w-a)>2.5*d){let $,i;return w<a?($=w+.75*d,i=a-.75*d):($=w-.75*d,i=a+.75*d),l(p(w,$),p(i,a),.33)}return p(w,a)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(w){this.to=w.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(w){const a=(w-this.startTime)/this.duration;if(a<1){const d=this.c(a),g=this.d(a);return new R(d,g,!1)}return new R(this.to.scrollLeft,this.to.scrollTop,!0)}combine(w,a,d){return I.start(w,a,d)}static start(w,a,d){d=d+10;const g=Date.now()-10;return new I(w,a,g,d)}}e.$ju=I;function D(A){return Math.pow(A,3)}function f(A){return 1-D(1-A)}}),define(Ee[105],Se([1,0,14,3]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=P,e.$ve=T,e.$we=L,e.$xe=R,e.$ye=l,e.$ze=I,e.$Ae=D,e.$Be=f,e.$Ce=A,e.$De=w,e.$Ee=a,e.$Fe=d,e.$Ge=g,e.$He=$,e.$Ie=i;function P(o){const n=o;return n?typeof n.read=="function":!1}function T(o){const n=o;return n?[n.on,n.pause,n.resume,n.destroy].every(t=>typeof t=="function"):!1}function L(o){const n=o;return n?T(n.stream)&&Array.isArray(n.buffer)&&typeof n.ended=="boolean":!1}function R(o,n){return new p(o,n)}class p{constructor(n,t){this.e=n,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(n){if(!this.a.destroyed){if(this.a.flowing)this.g(n);else if(this.b.data.push(n),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(n){this.a.destroyed||(this.a.flowing?this.h(n):this.b.error.push(n))}end(n){this.a.destroyed||(typeof n<"u"&&this.write(n),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(n){this.c.data.slice(0).forEach(t=>t(n))}h(n){this.c.error.length===0?(0,r.$1)(n):this.c.error.slice(0).forEach(t=>t(n))}i(){this.c.end.slice(0).forEach(n=>n())}on(n,t){if(!this.a.destroyed)switch(n){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(n,t){if(this.a.destroyed)return;let c;switch(n){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const h=c.indexOf(t);h>=0&&c.splice(h,1)}}j(){if(this.b.data.length>0){const n=this.e(this.b.data);this.g(n),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const n of this.b.error)this.h(n);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(o,n){const t=[];let c;for(;(c=o.read())!==null;)t.push(c);return n(t)}function I(o,n,t){const c=[];let h;for(;(h=o.read())!==null&&c.length<t;)c.push(h);return h===null&&c.length>0?n(c):{read:()=>{if(c.length>0)return c.shift();if(typeof h<"u"){const s=h;return h=void 0,s}return o.read()}}}function D(o,n){return new Promise((t,c)=>{const h=[];f(o,{onData:s=>{n&&h.push(s)},onError:s=>{n?c(s):t(void 0)},onEnd:()=>{t(n?n(h):void 0)}})})}function f(o,n,t){o.on("error",c=>{t?.isCancellationRequested||n.onError(c)}),o.on("end",()=>{t?.isCancellationRequested||n.onEnd()}),o.on("data",c=>{t?.isCancellationRequested||n.onData(c)})}function A(o,n){return new Promise((t,c)=>{const h=new u.$Tc,s=[],m=E=>{if(s.push(E),s.length>n)return h.dispose(),o.pause(),t({stream:o,buffer:s,ended:!1})},y=E=>(h.dispose(),c(E)),S=()=>(h.dispose(),t({stream:o,buffer:s,ended:!0}));h.add((0,u.$Sc)(()=>o.removeListener("error",y))),o.on("error",y),h.add((0,u.$Sc)(()=>o.removeListener("end",S))),o.on("end",S),h.add((0,u.$Sc)(()=>o.removeListener("data",m))),o.on("data",m)})}function w(o,n){const t=R(n);return t.end(o),t}function a(){const o=R(()=>{throw new Error("not supported")});return o.end(),o}function d(o){let n=!1;return{read:()=>n?null:(n=!0,o)}}function g(o,n,t){const c=R(t);return f(o,{onData:h=>c.write(n.data(h)),onError:h=>c.error(n.error?n.error(h):h),onEnd:()=>c.end()}),c}function $(o,n,t){let c=!1;return{read:()=>{const h=n.read();return c?h:(c=!0,h!==null?t([o,h]):o)}}}function i(o,n,t){let c=!1;const h=R(t);return f(n,{onData:s=>c?h.write(s):(c=!0,h.write(t([o,s]))),onError:s=>h.error(s),onEnd:()=>{c||(c=!0,h.write(o)),h.end()}}),h}}),define(Ee[22],Se([1,0,49,105]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=l,e.$Le=I,e.$Me=D,e.$Ne=f,e.$Oe=A,e.$Pe=w,e.$Qe=a,e.$Re=d,e.$Se=g,e.$Te=$,e.$Ue=i,e.$Ve=o,e.$We=n,e.$Xe=t,e.$Ye=c,e.$Ze=h,e.$1e=s,e.$2e=m,e.$3e=y,e.$4e=k;const P=typeof Buffer<"u",T=new r.$V(()=>new Uint8Array(256));let L,R;class p{static alloc(v){return P?new p(Buffer.allocUnsafe(v)):new p(new Uint8Array(v))}static wrap(v){return P&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new p(v)}static fromString(v,b){return!(b?.dontUseNodeBuffer||!1)&&P?new p(Buffer.from(v)):(L||(L=new TextEncoder),new p(L.encode(v)))}static fromByteArray(v){const b=p.alloc(v.length);for(let O=0,U=v.length;O<U;O++)b.buffer[O]=v[O];return b}static concat(v,b){if(typeof b>"u"){b=0;for(let z=0,j=v.length;z<j;z++)b+=v[z].byteLength}const O=p.alloc(b);let U=0;for(let z=0,j=v.length;z<j;z++){const M=v[z];O.set(M,U),U+=M.byteLength}return O}constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}clone(){const v=p.alloc(this.byteLength);return v.set(this),v}toString(){return P?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(v,b){return new p(this.buffer.subarray(v,b))}set(v,b){if(v instanceof p)this.buffer.set(v.buffer,b);else if(v instanceof Uint8Array)this.buffer.set(v,b);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),b);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return f(this.buffer,v)}writeUInt32BE(v,b){A(this.buffer,v,b)}readUInt32LE(v){return w(this.buffer,v)}writeUInt32LE(v,b){a(this.buffer,v,b)}readUInt8(v){return d(this.buffer,v)}writeUInt8(v,b){g(this.buffer,v,b)}indexOf(v,b=0){return l(this.buffer,v instanceof p?v.buffer:v,b)}}e.$Je=p;function l(C,v,b=0){const O=v.byteLength,U=C.byteLength;if(O===0)return 0;if(O===1)return C.indexOf(v[0]);if(O>U-b)return-1;const z=T.value;z.fill(v.length);for(let F=0;F<v.length;F++)z[v[F]]=v.length-F-1;let j=b+v.length-1,M=j,N=-1;for(;j<U;)if(C[j]===v[M]){if(M===0){N=j;break}j--,M--}else j+=Math.max(v.length-M,z[C[j]]),M=v.length-1;return N}function I(C,v){return C[v+0]<<0>>>0|C[v+1]<<8>>>0}function D(C,v,b){C[b+0]=v&255,v=v>>>8,C[b+1]=v&255}function f(C,v){return C[v]*2**24+C[v+1]*2**16+C[v+2]*2**8+C[v+3]}function A(C,v,b){C[b+3]=v,v=v>>>8,C[b+2]=v,v=v>>>8,C[b+1]=v,v=v>>>8,C[b]=v}function w(C,v){return C[v+0]<<0>>>0|C[v+1]<<8>>>0|C[v+2]<<16>>>0|C[v+3]<<24>>>0}function a(C,v,b){C[b+0]=v&255,v=v>>>8,C[b+1]=v&255,v=v>>>8,C[b+2]=v&255,v=v>>>8,C[b+3]=v&255}function d(C,v){return C[v]}function g(C,v,b){C[b]=v}function $(C){return u.$ye(C,v=>p.concat(v))}function i(C){return u.$Fe(C)}function o(C){return u.$Ae(C,v=>p.concat(v))}async function n(C){return C.ended?p.concat(C.buffer):p.concat([...C.buffer,await o(C.stream)])}function t(C){return u.$De(C,v=>p.concat(v))}function c(C){return u.$Ge(C,{data:v=>typeof v=="string"?p.fromString(v):p.wrap(v)},v=>p.concat(v))}function h(C){return u.$xe(v=>p.concat(v),C)}function s(C,v){return u.$He(C,v,b=>p.concat(b))}function m(C,v){return u.$Ie(C,v,b=>p.concat(b))}function y(C){let v=0,b=0,O=0;const U=new Uint8Array(Math.floor(C.length/4*3)),z=M=>{switch(b){case 3:U[O++]=v|M,b=0;break;case 2:U[O++]=v|M>>>2,v=M<<6,b=3;break;case 1:U[O++]=v|M>>>4,v=M<<4,b=2;break;default:v=M<<2,b=1}};for(let M=0;M<C.length;M++){const N=C.charCodeAt(M);if(N>=65&&N<=90)z(N-65);else if(N>=97&&N<=122)z(N-97+26);else if(N>=48&&N<=57)z(N-48+52);else if(N===43||N===45)z(62);else if(N===47||N===95)z(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${C[M]}`)}}const j=O;for(;b>0;)z(0);return p.wrap(U).slice(0,j)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:C},v=!0,b=!1){const O=b?E:S;let U="";const z=C.byteLength%3;let j=0;for(;j<C.byteLength-z;j+=3){const M=C[j+0],N=C[j+1],F=C[j+2];U+=O[M>>>2],U+=O[(M<<4|N>>>4)&63],U+=O[(N<<2|F>>>6)&63],U+=O[F&63]}if(z===1){const M=C[j+0];U+=O[M>>>2],U+=O[M<<4&63],v&&(U+="==")}else if(z===2){const M=C[j+0],N=C[j+1];U+=O[M>>>2],U+=O[(M<<4|N>>>4)&63],U+=O[N<<2&63],v&&(U+="=")}return U}}),define(Ee[184],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(Ee[18],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ag=r,e.$bg=u,e.$cg=P,e.$dg=T,e.$eg=L,e.$fg=R,e.$gg=p,e.$hg=l,e.$ig=I,e.$jg=D,e.$kg=f,e.$lg=A,e.$mg=w,e.$ng=d,e.$og=g,e.$pg=$,e.$qg=i,e.$rg=o;function r(n){return typeof n=="string"}function u(n){return Array.isArray(n)&&n.every(t=>r(t))}function P(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}function T(n){const t=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof t}function L(n){return typeof n=="number"&&!isNaN(n)}function R(n){return!!n&&typeof n[Symbol.iterator]=="function"}function p(n){return n===!0||n===!1}function l(n){return typeof n>"u"}function I(n){return!D(n)}function D(n){return l(n)||n===null}function f(n,t){if(!n)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function A(n){if(D(n))throw new Error("Assertion Failed: argument is undefined or null");return n}function w(...n){const t=[];for(let c=0;c<n.length;c++){const h=n[c];if(D(h))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);t.push(h)}return t}const a=Object.prototype.hasOwnProperty;function d(n){if(!P(n))return!1;for(const t in n)if(a.call(n,t))return!1;return!0}function g(n){return typeof n=="function"}function $(...n){return n.length>0&&n.every(g)}function i(n,t){const c=Math.min(n.length,t.length);for(let h=0;h<c;h++)o(n[h],t[h])}function o(n,t){if(r(t)){if(typeof n!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(g(t)){try{if(n instanceof t)return}catch{}if(!D(n)&&n.constructor===t||t.length===1&&t.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(Ee[106],Se([1,0,18]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=P,e.$Vj=T;const u=Object.create(null);function P(L,R){if((0,r.$ag)(R)){const p=u[R];if(p===void 0)throw new Error(`${L} references an unknown codicon: ${R}`);R=p}return u[L]=R,{id:L}}function T(){return u}}),define(Ee[185],Se([1,0,106]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=void 0,e.$Wj={add:(0,r.$Uj)("add",6e4),plus:(0,r.$Uj)("plus",6e4),gistNew:(0,r.$Uj)("gist-new",6e4),repoCreate:(0,r.$Uj)("repo-create",6e4),lightbulb:(0,r.$Uj)("lightbulb",60001),lightBulb:(0,r.$Uj)("light-bulb",60001),repo:(0,r.$Uj)("repo",60002),repoDelete:(0,r.$Uj)("repo-delete",60002),gistFork:(0,r.$Uj)("gist-fork",60003),repoForked:(0,r.$Uj)("repo-forked",60003),gitPullRequest:(0,r.$Uj)("git-pull-request",60004),gitPullRequestAbandoned:(0,r.$Uj)("git-pull-request-abandoned",60004),recordKeys:(0,r.$Uj)("record-keys",60005),keyboard:(0,r.$Uj)("keyboard",60005),tag:(0,r.$Uj)("tag",60006),gitPullRequestLabel:(0,r.$Uj)("git-pull-request-label",60006),tagAdd:(0,r.$Uj)("tag-add",60006),tagRemove:(0,r.$Uj)("tag-remove",60006),person:(0,r.$Uj)("person",60007),personFollow:(0,r.$Uj)("person-follow",60007),personOutline:(0,r.$Uj)("person-outline",60007),personFilled:(0,r.$Uj)("person-filled",60007),gitBranch:(0,r.$Uj)("git-branch",60008),gitBranchCreate:(0,r.$Uj)("git-branch-create",60008),gitBranchDelete:(0,r.$Uj)("git-branch-delete",60008),sourceControl:(0,r.$Uj)("source-control",60008),mirror:(0,r.$Uj)("mirror",60009),mirrorPublic:(0,r.$Uj)("mirror-public",60009),star:(0,r.$Uj)("star",60010),starAdd:(0,r.$Uj)("star-add",60010),starDelete:(0,r.$Uj)("star-delete",60010),starEmpty:(0,r.$Uj)("star-empty",60010),comment:(0,r.$Uj)("comment",60011),commentAdd:(0,r.$Uj)("comment-add",60011),alert:(0,r.$Uj)("alert",60012),warning:(0,r.$Uj)("warning",60012),search:(0,r.$Uj)("search",60013),searchSave:(0,r.$Uj)("search-save",60013),logOut:(0,r.$Uj)("log-out",60014),signOut:(0,r.$Uj)("sign-out",60014),logIn:(0,r.$Uj)("log-in",60015),signIn:(0,r.$Uj)("sign-in",60015),eye:(0,r.$Uj)("eye",60016),eyeUnwatch:(0,r.$Uj)("eye-unwatch",60016),eyeWatch:(0,r.$Uj)("eye-watch",60016),circleFilled:(0,r.$Uj)("circle-filled",60017),primitiveDot:(0,r.$Uj)("primitive-dot",60017),closeDirty:(0,r.$Uj)("close-dirty",60017),debugBreakpoint:(0,r.$Uj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,r.$Uj)("debug-breakpoint-disabled",60017),debugHint:(0,r.$Uj)("debug-hint",60017),terminalDecorationSuccess:(0,r.$Uj)("terminal-decoration-success",60017),primitiveSquare:(0,r.$Uj)("primitive-square",60018),edit:(0,r.$Uj)("edit",60019),pencil:(0,r.$Uj)("pencil",60019),info:(0,r.$Uj)("info",60020),issueOpened:(0,r.$Uj)("issue-opened",60020),gistPrivate:(0,r.$Uj)("gist-private",60021),gitForkPrivate:(0,r.$Uj)("git-fork-private",60021),lock:(0,r.$Uj)("lock",60021),mirrorPrivate:(0,r.$Uj)("mirror-private",60021),close:(0,r.$Uj)("close",60022),removeClose:(0,r.$Uj)("remove-close",60022),x:(0,r.$Uj)("x",60022),repoSync:(0,r.$Uj)("repo-sync",60023),sync:(0,r.$Uj)("sync",60023),clone:(0,r.$Uj)("clone",60024),desktopDownload:(0,r.$Uj)("desktop-download",60024),beaker:(0,r.$Uj)("beaker",60025),microscope:(0,r.$Uj)("microscope",60025),vm:(0,r.$Uj)("vm",60026),deviceDesktop:(0,r.$Uj)("device-desktop",60026),file:(0,r.$Uj)("file",60027),fileText:(0,r.$Uj)("file-text",60027),more:(0,r.$Uj)("more",60028),ellipsis:(0,r.$Uj)("ellipsis",60028),kebabHorizontal:(0,r.$Uj)("kebab-horizontal",60028),mailReply:(0,r.$Uj)("mail-reply",60029),reply:(0,r.$Uj)("reply",60029),organization:(0,r.$Uj)("organization",60030),organizationFilled:(0,r.$Uj)("organization-filled",60030),organizationOutline:(0,r.$Uj)("organization-outline",60030),newFile:(0,r.$Uj)("new-file",60031),fileAdd:(0,r.$Uj)("file-add",60031),newFolder:(0,r.$Uj)("new-folder",60032),fileDirectoryCreate:(0,r.$Uj)("file-directory-create",60032),trash:(0,r.$Uj)("trash",60033),trashcan:(0,r.$Uj)("trashcan",60033),history:(0,r.$Uj)("history",60034),clock:(0,r.$Uj)("clock",60034),folder:(0,r.$Uj)("folder",60035),fileDirectory:(0,r.$Uj)("file-directory",60035),symbolFolder:(0,r.$Uj)("symbol-folder",60035),logoGithub:(0,r.$Uj)("logo-github",60036),markGithub:(0,r.$Uj)("mark-github",60036),github:(0,r.$Uj)("github",60036),terminal:(0,r.$Uj)("terminal",60037),console:(0,r.$Uj)("console",60037),repl:(0,r.$Uj)("repl",60037),zap:(0,r.$Uj)("zap",60038),symbolEvent:(0,r.$Uj)("symbol-event",60038),error:(0,r.$Uj)("error",60039),stop:(0,r.$Uj)("stop",60039),variable:(0,r.$Uj)("variable",60040),symbolVariable:(0,r.$Uj)("symbol-variable",60040),array:(0,r.$Uj)("array",60042),symbolArray:(0,r.$Uj)("symbol-array",60042),symbolModule:(0,r.$Uj)("symbol-module",60043),symbolPackage:(0,r.$Uj)("symbol-package",60043),symbolNamespace:(0,r.$Uj)("symbol-namespace",60043),symbolObject:(0,r.$Uj)("symbol-object",60043),symbolMethod:(0,r.$Uj)("symbol-method",60044),symbolFunction:(0,r.$Uj)("symbol-function",60044),symbolConstructor:(0,r.$Uj)("symbol-constructor",60044),symbolBoolean:(0,r.$Uj)("symbol-boolean",60047),symbolNull:(0,r.$Uj)("symbol-null",60047),symbolNumeric:(0,r.$Uj)("symbol-numeric",60048),symbolNumber:(0,r.$Uj)("symbol-number",60048),symbolStructure:(0,r.$Uj)("symbol-structure",60049),symbolStruct:(0,r.$Uj)("symbol-struct",60049),symbolParameter:(0,r.$Uj)("symbol-parameter",60050),symbolTypeParameter:(0,r.$Uj)("symbol-type-parameter",60050),symbolKey:(0,r.$Uj)("symbol-key",60051),symbolText:(0,r.$Uj)("symbol-text",60051),symbolReference:(0,r.$Uj)("symbol-reference",60052),goToFile:(0,r.$Uj)("go-to-file",60052),symbolEnum:(0,r.$Uj)("symbol-enum",60053),symbolValue:(0,r.$Uj)("symbol-value",60053),symbolRuler:(0,r.$Uj)("symbol-ruler",60054),symbolUnit:(0,r.$Uj)("symbol-unit",60054),activateBreakpoints:(0,r.$Uj)("activate-breakpoints",60055),archive:(0,r.$Uj)("archive",60056),arrowBoth:(0,r.$Uj)("arrow-both",60057),arrowDown:(0,r.$Uj)("arrow-down",60058),arrowLeft:(0,r.$Uj)("arrow-left",60059),arrowRight:(0,r.$Uj)("arrow-right",60060),arrowSmallDown:(0,r.$Uj)("arrow-small-down",60061),arrowSmallLeft:(0,r.$Uj)("arrow-small-left",60062),arrowSmallRight:(0,r.$Uj)("arrow-small-right",60063),arrowSmallUp:(0,r.$Uj)("arrow-small-up",60064),arrowUp:(0,r.$Uj)("arrow-up",60065),bell:(0,r.$Uj)("bell",60066),bold:(0,r.$Uj)("bold",60067),book:(0,r.$Uj)("book",60068),bookmark:(0,r.$Uj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,r.$Uj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,r.$Uj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,r.$Uj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,r.$Uj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,r.$Uj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,r.$Uj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,r.$Uj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,r.$Uj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,r.$Uj)("debug-breakpoint-log-disabled",60075),briefcase:(0,r.$Uj)("briefcase",60076),broadcast:(0,r.$Uj)("broadcast",60077),browser:(0,r.$Uj)("browser",60078),bug:(0,r.$Uj)("bug",60079),calendar:(0,r.$Uj)("calendar",60080),caseSensitive:(0,r.$Uj)("case-sensitive",60081),check:(0,r.$Uj)("check",60082),checklist:(0,r.$Uj)("checklist",60083),chevronDown:(0,r.$Uj)("chevron-down",60084),chevronLeft:(0,r.$Uj)("chevron-left",60085),chevronRight:(0,r.$Uj)("chevron-right",60086),chevronUp:(0,r.$Uj)("chevron-up",60087),chromeClose:(0,r.$Uj)("chrome-close",60088),chromeMaximize:(0,r.$Uj)("chrome-maximize",60089),chromeMinimize:(0,r.$Uj)("chrome-minimize",60090),chromeRestore:(0,r.$Uj)("chrome-restore",60091),circleOutline:(0,r.$Uj)("circle-outline",60092),circle:(0,r.$Uj)("circle",60092),debugBreakpointUnverified:(0,r.$Uj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,r.$Uj)("terminal-decoration-incomplete",60092),circleSlash:(0,r.$Uj)("circle-slash",60093),circuitBoard:(0,r.$Uj)("circuit-board",60094),clearAll:(0,r.$Uj)("clear-all",60095),clippy:(0,r.$Uj)("clippy",60096),closeAll:(0,r.$Uj)("close-all",60097),cloudDownload:(0,r.$Uj)("cloud-download",60098),cloudUpload:(0,r.$Uj)("cloud-upload",60099),code:(0,r.$Uj)("code",60100),collapseAll:(0,r.$Uj)("collapse-all",60101),colorMode:(0,r.$Uj)("color-mode",60102),commentDiscussion:(0,r.$Uj)("comment-discussion",60103),creditCard:(0,r.$Uj)("credit-card",60105),dash:(0,r.$Uj)("dash",60108),dashboard:(0,r.$Uj)("dashboard",60109),database:(0,r.$Uj)("database",60110),debugContinue:(0,r.$Uj)("debug-continue",60111),debugDisconnect:(0,r.$Uj)("debug-disconnect",60112),debugPause:(0,r.$Uj)("debug-pause",60113),debugRestart:(0,r.$Uj)("debug-restart",60114),debugStart:(0,r.$Uj)("debug-start",60115),debugStepInto:(0,r.$Uj)("debug-step-into",60116),debugStepOut:(0,r.$Uj)("debug-step-out",60117),debugStepOver:(0,r.$Uj)("debug-step-over",60118),debugStop:(0,r.$Uj)("debug-stop",60119),debug:(0,r.$Uj)("debug",60120),deviceCameraVideo:(0,r.$Uj)("device-camera-video",60121),deviceCamera:(0,r.$Uj)("device-camera",60122),deviceMobile:(0,r.$Uj)("device-mobile",60123),diffAdded:(0,r.$Uj)("diff-added",60124),diffIgnored:(0,r.$Uj)("diff-ignored",60125),diffModified:(0,r.$Uj)("diff-modified",60126),diffRemoved:(0,r.$Uj)("diff-removed",60127),diffRenamed:(0,r.$Uj)("diff-renamed",60128),diff:(0,r.$Uj)("diff",60129),diffSidebyside:(0,r.$Uj)("diff-sidebyside",60129),discard:(0,r.$Uj)("discard",60130),editorLayout:(0,r.$Uj)("editor-layout",60131),emptyWindow:(0,r.$Uj)("empty-window",60132),exclude:(0,r.$Uj)("exclude",60133),extensions:(0,r.$Uj)("extensions",60134),eyeClosed:(0,r.$Uj)("eye-closed",60135),fileBinary:(0,r.$Uj)("file-binary",60136),fileCode:(0,r.$Uj)("file-code",60137),fileMedia:(0,r.$Uj)("file-media",60138),filePdf:(0,r.$Uj)("file-pdf",60139),fileSubmodule:(0,r.$Uj)("file-submodule",60140),fileSymlinkDirectory:(0,r.$Uj)("file-symlink-directory",60141),fileSymlinkFile:(0,r.$Uj)("file-symlink-file",60142),fileZip:(0,r.$Uj)("file-zip",60143),files:(0,r.$Uj)("files",60144),filter:(0,r.$Uj)("filter",60145),flame:(0,r.$Uj)("flame",60146),foldDown:(0,r.$Uj)("fold-down",60147),foldUp:(0,r.$Uj)("fold-up",60148),fold:(0,r.$Uj)("fold",60149),folderActive:(0,r.$Uj)("folder-active",60150),folderOpened:(0,r.$Uj)("folder-opened",60151),gear:(0,r.$Uj)("gear",60152),gift:(0,r.$Uj)("gift",60153),gistSecret:(0,r.$Uj)("gist-secret",60154),gist:(0,r.$Uj)("gist",60155),gitCommit:(0,r.$Uj)("git-commit",60156),gitCompare:(0,r.$Uj)("git-compare",60157),compareChanges:(0,r.$Uj)("compare-changes",60157),gitMerge:(0,r.$Uj)("git-merge",60158),githubAction:(0,r.$Uj)("github-action",60159),githubAlt:(0,r.$Uj)("github-alt",60160),globe:(0,r.$Uj)("globe",60161),grabber:(0,r.$Uj)("grabber",60162),graph:(0,r.$Uj)("graph",60163),gripper:(0,r.$Uj)("gripper",60164),heart:(0,r.$Uj)("heart",60165),home:(0,r.$Uj)("home",60166),horizontalRule:(0,r.$Uj)("horizontal-rule",60167),hubot:(0,r.$Uj)("hubot",60168),inbox:(0,r.$Uj)("inbox",60169),issueReopened:(0,r.$Uj)("issue-reopened",60171),issues:(0,r.$Uj)("issues",60172),italic:(0,r.$Uj)("italic",60173),jersey:(0,r.$Uj)("jersey",60174),json:(0,r.$Uj)("json",60175),kebabVertical:(0,r.$Uj)("kebab-vertical",60176),key:(0,r.$Uj)("key",60177),law:(0,r.$Uj)("law",60178),lightbulbAutofix:(0,r.$Uj)("lightbulb-autofix",60179),linkExternal:(0,r.$Uj)("link-external",60180),link:(0,r.$Uj)("link",60181),listOrdered:(0,r.$Uj)("list-ordered",60182),listUnordered:(0,r.$Uj)("list-unordered",60183),liveShare:(0,r.$Uj)("live-share",60184),loading:(0,r.$Uj)("loading",60185),location:(0,r.$Uj)("location",60186),mailRead:(0,r.$Uj)("mail-read",60187),mail:(0,r.$Uj)("mail",60188),markdown:(0,r.$Uj)("markdown",60189),megaphone:(0,r.$Uj)("megaphone",60190),mention:(0,r.$Uj)("mention",60191),milestone:(0,r.$Uj)("milestone",60192),gitPullRequestMilestone:(0,r.$Uj)("git-pull-request-milestone",60192),mortarBoard:(0,r.$Uj)("mortar-board",60193),move:(0,r.$Uj)("move",60194),multipleWindows:(0,r.$Uj)("multiple-windows",60195),mute:(0,r.$Uj)("mute",60196),noNewline:(0,r.$Uj)("no-newline",60197),note:(0,r.$Uj)("note",60198),octoface:(0,r.$Uj)("octoface",60199),openPreview:(0,r.$Uj)("open-preview",60200),package:(0,r.$Uj)("package",60201),paintcan:(0,r.$Uj)("paintcan",60202),pin:(0,r.$Uj)("pin",60203),play:(0,r.$Uj)("play",60204),run:(0,r.$Uj)("run",60204),plug:(0,r.$Uj)("plug",60205),preserveCase:(0,r.$Uj)("preserve-case",60206),preview:(0,r.$Uj)("preview",60207),project:(0,r.$Uj)("project",60208),pulse:(0,r.$Uj)("pulse",60209),question:(0,r.$Uj)("question",60210),quote:(0,r.$Uj)("quote",60211),radioTower:(0,r.$Uj)("radio-tower",60212),reactions:(0,r.$Uj)("reactions",60213),references:(0,r.$Uj)("references",60214),refresh:(0,r.$Uj)("refresh",60215),regex:(0,r.$Uj)("regex",60216),remoteExplorer:(0,r.$Uj)("remote-explorer",60217),remote:(0,r.$Uj)("remote",60218),remove:(0,r.$Uj)("remove",60219),replaceAll:(0,r.$Uj)("replace-all",60220),replace:(0,r.$Uj)("replace",60221),repoClone:(0,r.$Uj)("repo-clone",60222),repoForcePush:(0,r.$Uj)("repo-force-push",60223),repoPull:(0,r.$Uj)("repo-pull",60224),repoPush:(0,r.$Uj)("repo-push",60225),report:(0,r.$Uj)("report",60226),requestChanges:(0,r.$Uj)("request-changes",60227),rocket:(0,r.$Uj)("rocket",60228),rootFolderOpened:(0,r.$Uj)("root-folder-opened",60229),rootFolder:(0,r.$Uj)("root-folder",60230),rss:(0,r.$Uj)("rss",60231),ruby:(0,r.$Uj)("ruby",60232),saveAll:(0,r.$Uj)("save-all",60233),saveAs:(0,r.$Uj)("save-as",60234),save:(0,r.$Uj)("save",60235),screenFull:(0,r.$Uj)("screen-full",60236),screenNormal:(0,r.$Uj)("screen-normal",60237),searchStop:(0,r.$Uj)("search-stop",60238),server:(0,r.$Uj)("server",60240),settingsGear:(0,r.$Uj)("settings-gear",60241),settings:(0,r.$Uj)("settings",60242),shield:(0,r.$Uj)("shield",60243),smiley:(0,r.$Uj)("smiley",60244),sortPrecedence:(0,r.$Uj)("sort-precedence",60245),splitHorizontal:(0,r.$Uj)("split-horizontal",60246),splitVertical:(0,r.$Uj)("split-vertical",60247),squirrel:(0,r.$Uj)("squirrel",60248),starFull:(0,r.$Uj)("star-full",60249),starHalf:(0,r.$Uj)("star-half",60250),symbolClass:(0,r.$Uj)("symbol-class",60251),symbolColor:(0,r.$Uj)("symbol-color",60252),symbolConstant:(0,r.$Uj)("symbol-constant",60253),symbolEnumMember:(0,r.$Uj)("symbol-enum-member",60254),symbolField:(0,r.$Uj)("symbol-field",60255),symbolFile:(0,r.$Uj)("symbol-file",60256),symbolInterface:(0,r.$Uj)("symbol-interface",60257),symbolKeyword:(0,r.$Uj)("symbol-keyword",60258),symbolMisc:(0,r.$Uj)("symbol-misc",60259),symbolOperator:(0,r.$Uj)("symbol-operator",60260),symbolProperty:(0,r.$Uj)("symbol-property",60261),wrench:(0,r.$Uj)("wrench",60261),wrenchSubaction:(0,r.$Uj)("wrench-subaction",60261),symbolSnippet:(0,r.$Uj)("symbol-snippet",60262),tasklist:(0,r.$Uj)("tasklist",60263),telescope:(0,r.$Uj)("telescope",60264),textSize:(0,r.$Uj)("text-size",60265),threeBars:(0,r.$Uj)("three-bars",60266),thumbsdown:(0,r.$Uj)("thumbsdown",60267),thumbsup:(0,r.$Uj)("thumbsup",60268),tools:(0,r.$Uj)("tools",60269),triangleDown:(0,r.$Uj)("triangle-down",60270),triangleLeft:(0,r.$Uj)("triangle-left",60271),triangleRight:(0,r.$Uj)("triangle-right",60272),triangleUp:(0,r.$Uj)("triangle-up",60273),twitter:(0,r.$Uj)("twitter",60274),unfold:(0,r.$Uj)("unfold",60275),unlock:(0,r.$Uj)("unlock",60276),unmute:(0,r.$Uj)("unmute",60277),unverified:(0,r.$Uj)("unverified",60278),verified:(0,r.$Uj)("verified",60279),versions:(0,r.$Uj)("versions",60280),vmActive:(0,r.$Uj)("vm-active",60281),vmOutline:(0,r.$Uj)("vm-outline",60282),vmRunning:(0,r.$Uj)("vm-running",60283),watch:(0,r.$Uj)("watch",60284),whitespace:(0,r.$Uj)("whitespace",60285),wholeWord:(0,r.$Uj)("whole-word",60286),window:(0,r.$Uj)("window",60287),wordWrap:(0,r.$Uj)("word-wrap",60288),zoomIn:(0,r.$Uj)("zoom-in",60289),zoomOut:(0,r.$Uj)("zoom-out",60290),listFilter:(0,r.$Uj)("list-filter",60291),listFlat:(0,r.$Uj)("list-flat",60292),listSelection:(0,r.$Uj)("list-selection",60293),selection:(0,r.$Uj)("selection",60293),listTree:(0,r.$Uj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,r.$Uj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,r.$Uj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,r.$Uj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,r.$Uj)("debug-stackframe-active",60297),circleSmallFilled:(0,r.$Uj)("circle-small-filled",60298),debugStackframeDot:(0,r.$Uj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,r.$Uj)("terminal-decoration-mark",60298),debugStackframe:(0,r.$Uj)("debug-stackframe",60299),debugStackframeFocused:(0,r.$Uj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,r.$Uj)("debug-breakpoint-unsupported",60300),symbolString:(0,r.$Uj)("symbol-string",60301),debugReverseContinue:(0,r.$Uj)("debug-reverse-continue",60302),debugStepBack:(0,r.$Uj)("debug-step-back",60303),debugRestartFrame:(0,r.$Uj)("debug-restart-frame",60304),debugAlt:(0,r.$Uj)("debug-alt",60305),callIncoming:(0,r.$Uj)("call-incoming",60306),callOutgoing:(0,r.$Uj)("call-outgoing",60307),menu:(0,r.$Uj)("menu",60308),expandAll:(0,r.$Uj)("expand-all",60309),feedback:(0,r.$Uj)("feedback",60310),gitPullRequestReviewer:(0,r.$Uj)("git-pull-request-reviewer",60310),groupByRefType:(0,r.$Uj)("group-by-ref-type",60311),ungroupByRefType:(0,r.$Uj)("ungroup-by-ref-type",60312),account:(0,r.$Uj)("account",60313),gitPullRequestAssignee:(0,r.$Uj)("git-pull-request-assignee",60313),bellDot:(0,r.$Uj)("bell-dot",60314),debugConsole:(0,r.$Uj)("debug-console",60315),library:(0,r.$Uj)("library",60316),output:(0,r.$Uj)("output",60317),runAll:(0,r.$Uj)("run-all",60318),syncIgnored:(0,r.$Uj)("sync-ignored",60319),pinned:(0,r.$Uj)("pinned",60320),githubInverted:(0,r.$Uj)("github-inverted",60321),serverProcess:(0,r.$Uj)("server-process",60322),serverEnvironment:(0,r.$Uj)("server-environment",60323),pass:(0,r.$Uj)("pass",60324),issueClosed:(0,r.$Uj)("issue-closed",60324),stopCircle:(0,r.$Uj)("stop-circle",60325),playCircle:(0,r.$Uj)("play-circle",60326),record:(0,r.$Uj)("record",60327),debugAltSmall:(0,r.$Uj)("debug-alt-small",60328),vmConnect:(0,r.$Uj)("vm-connect",60329),cloud:(0,r.$Uj)("cloud",60330),merge:(0,r.$Uj)("merge",60331),export:(0,r.$Uj)("export",60332),graphLeft:(0,r.$Uj)("graph-left",60333),magnet:(0,r.$Uj)("magnet",60334),notebook:(0,r.$Uj)("notebook",60335),redo:(0,r.$Uj)("redo",60336),checkAll:(0,r.$Uj)("check-all",60337),pinnedDirty:(0,r.$Uj)("pinned-dirty",60338),passFilled:(0,r.$Uj)("pass-filled",60339),circleLargeFilled:(0,r.$Uj)("circle-large-filled",60340),circleLarge:(0,r.$Uj)("circle-large",60341),circleLargeOutline:(0,r.$Uj)("circle-large-outline",60341),combine:(0,r.$Uj)("combine",60342),gather:(0,r.$Uj)("gather",60342),table:(0,r.$Uj)("table",60343),variableGroup:(0,r.$Uj)("variable-group",60344),typeHierarchy:(0,r.$Uj)("type-hierarchy",60345),typeHierarchySub:(0,r.$Uj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,r.$Uj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,r.$Uj)("git-pull-request-create",60348),runAbove:(0,r.$Uj)("run-above",60349),runBelow:(0,r.$Uj)("run-below",60350),notebookTemplate:(0,r.$Uj)("notebook-template",60351),debugRerun:(0,r.$Uj)("debug-rerun",60352),workspaceTrusted:(0,r.$Uj)("workspace-trusted",60353),workspaceUntrusted:(0,r.$Uj)("workspace-untrusted",60354),workspaceUnknown:(0,r.$Uj)("workspace-unknown",60355),terminalCmd:(0,r.$Uj)("terminal-cmd",60356),terminalDebian:(0,r.$Uj)("terminal-debian",60357),terminalLinux:(0,r.$Uj)("terminal-linux",60358),terminalPowershell:(0,r.$Uj)("terminal-powershell",60359),terminalTmux:(0,r.$Uj)("terminal-tmux",60360),terminalUbuntu:(0,r.$Uj)("terminal-ubuntu",60361),terminalBash:(0,r.$Uj)("terminal-bash",60362),arrowSwap:(0,r.$Uj)("arrow-swap",60363),copy:(0,r.$Uj)("copy",60364),personAdd:(0,r.$Uj)("person-add",60365),filterFilled:(0,r.$Uj)("filter-filled",60366),wand:(0,r.$Uj)("wand",60367),debugLineByLine:(0,r.$Uj)("debug-line-by-line",60368),inspect:(0,r.$Uj)("inspect",60369),layers:(0,r.$Uj)("layers",60370),layersDot:(0,r.$Uj)("layers-dot",60371),layersActive:(0,r.$Uj)("layers-active",60372),compass:(0,r.$Uj)("compass",60373),compassDot:(0,r.$Uj)("compass-dot",60374),compassActive:(0,r.$Uj)("compass-active",60375),azure:(0,r.$Uj)("azure",60376),issueDraft:(0,r.$Uj)("issue-draft",60377),gitPullRequestClosed:(0,r.$Uj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,r.$Uj)("git-pull-request-draft",60379),debugAll:(0,r.$Uj)("debug-all",60380),debugCoverage:(0,r.$Uj)("debug-coverage",60381),runErrors:(0,r.$Uj)("run-errors",60382),folderLibrary:(0,r.$Uj)("folder-library",60383),debugContinueSmall:(0,r.$Uj)("debug-continue-small",60384),beakerStop:(0,r.$Uj)("beaker-stop",60385),graphLine:(0,r.$Uj)("graph-line",60386),graphScatter:(0,r.$Uj)("graph-scatter",60387),pieChart:(0,r.$Uj)("pie-chart",60388),bracket:(0,r.$Uj)("bracket",60175),bracketDot:(0,r.$Uj)("bracket-dot",60389),bracketError:(0,r.$Uj)("bracket-error",60390),lockSmall:(0,r.$Uj)("lock-small",60391),azureDevops:(0,r.$Uj)("azure-devops",60392),verifiedFilled:(0,r.$Uj)("verified-filled",60393),newline:(0,r.$Uj)("newline",60394),layout:(0,r.$Uj)("layout",60395),layoutActivitybarLeft:(0,r.$Uj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,r.$Uj)("layout-activitybar-right",60397),layoutPanelLeft:(0,r.$Uj)("layout-panel-left",60398),layoutPanelCenter:(0,r.$Uj)("layout-panel-center",60399),layoutPanelJustify:(0,r.$Uj)("layout-panel-justify",60400),layoutPanelRight:(0,r.$Uj)("layout-panel-right",60401),layoutPanel:(0,r.$Uj)("layout-panel",60402),layoutSidebarLeft:(0,r.$Uj)("layout-sidebar-left",60403),layoutSidebarRight:(0,r.$Uj)("layout-sidebar-right",60404),layoutStatusbar:(0,r.$Uj)("layout-statusbar",60405),layoutMenubar:(0,r.$Uj)("layout-menubar",60406),layoutCentered:(0,r.$Uj)("layout-centered",60407),target:(0,r.$Uj)("target",60408),indent:(0,r.$Uj)("indent",60409),recordSmall:(0,r.$Uj)("record-small",60410),errorSmall:(0,r.$Uj)("error-small",60411),terminalDecorationError:(0,r.$Uj)("terminal-decoration-error",60411),arrowCircleDown:(0,r.$Uj)("arrow-circle-down",60412),arrowCircleLeft:(0,r.$Uj)("arrow-circle-left",60413),arrowCircleRight:(0,r.$Uj)("arrow-circle-right",60414),arrowCircleUp:(0,r.$Uj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,r.$Uj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,r.$Uj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,r.$Uj)("layout-sidebar-left-off",60418),blank:(0,r.$Uj)("blank",60419),heartFilled:(0,r.$Uj)("heart-filled",60420),map:(0,r.$Uj)("map",60421),mapHorizontal:(0,r.$Uj)("map-horizontal",60421),foldHorizontal:(0,r.$Uj)("fold-horizontal",60421),mapFilled:(0,r.$Uj)("map-filled",60422),mapHorizontalFilled:(0,r.$Uj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,r.$Uj)("fold-horizontal-filled",60422),circleSmall:(0,r.$Uj)("circle-small",60423),bellSlash:(0,r.$Uj)("bell-slash",60424),bellSlashDot:(0,r.$Uj)("bell-slash-dot",60425),commentUnresolved:(0,r.$Uj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,r.$Uj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,r.$Uj)("git-pull-request-new-changes",60428),searchFuzzy:(0,r.$Uj)("search-fuzzy",60429),commentDraft:(0,r.$Uj)("comment-draft",60430),send:(0,r.$Uj)("send",60431),sparkle:(0,r.$Uj)("sparkle",60432),insert:(0,r.$Uj)("insert",60433),mic:(0,r.$Uj)("mic",60434),thumbsdownFilled:(0,r.$Uj)("thumbsdown-filled",60435),thumbsupFilled:(0,r.$Uj)("thumbsup-filled",60436),coffee:(0,r.$Uj)("coffee",60437),snake:(0,r.$Uj)("snake",60438),game:(0,r.$Uj)("game",60439),vr:(0,r.$Uj)("vr",60440),chip:(0,r.$Uj)("chip",60441),piano:(0,r.$Uj)("piano",60442),music:(0,r.$Uj)("music",60443),micFilled:(0,r.$Uj)("mic-filled",60444),repoFetch:(0,r.$Uj)("repo-fetch",60445),copilot:(0,r.$Uj)("copilot",60446),lightbulbSparkle:(0,r.$Uj)("lightbulb-sparkle",60447),robot:(0,r.$Uj)("robot",60448),sparkleFilled:(0,r.$Uj)("sparkle-filled",60449),diffSingle:(0,r.$Uj)("diff-single",60450),diffMultiple:(0,r.$Uj)("diff-multiple",60451),surroundWith:(0,r.$Uj)("surround-with",60452),share:(0,r.$Uj)("share",60453),gitStash:(0,r.$Uj)("git-stash",60454),gitStashApply:(0,r.$Uj)("git-stash-apply",60455),gitStashPop:(0,r.$Uj)("git-stash-pop",60456),vscode:(0,r.$Uj)("vscode",60457),vscodeInsiders:(0,r.$Uj)("vscode-insiders",60458),codeOss:(0,r.$Uj)("code-oss",60459),runCoverage:(0,r.$Uj)("run-coverage",60460),runAllCoverage:(0,r.$Uj)("run-all-coverage",60461),coverage:(0,r.$Uj)("coverage",60462),githubProject:(0,r.$Uj)("github-project",60463),mapVertical:(0,r.$Uj)("map-vertical",60464),foldVertical:(0,r.$Uj)("fold-vertical",60464),mapVerticalFilled:(0,r.$Uj)("map-vertical-filled",60465),foldVerticalFilled:(0,r.$Uj)("fold-vertical-filled",60465),goToSearch:(0,r.$Uj)("go-to-search",60466),percentage:(0,r.$Uj)("percentage",60467),sortPercentage:(0,r.$Uj)("sort-percentage",60467),attach:(0,r.$Uj)("attach",60468)}}),define(Ee[83],Se([1,0,106,185]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zj=e.$Yj=void 0,e.$Xj=P;function P(){return Object.values(e.$Zj)}e.$Yj={dialogError:(0,r.$Uj)("dialog-error","error"),dialogWarning:(0,r.$Uj)("dialog-warning","warning"),dialogInfo:(0,r.$Uj)("dialog-info","info"),dialogClose:(0,r.$Uj)("dialog-close","close"),treeItemExpanded:(0,r.$Uj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,r.$Uj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,r.$Uj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,r.$Uj)("tree-filter-clear","close"),treeItemLoading:(0,r.$Uj)("tree-item-loading","loading"),menuSelection:(0,r.$Uj)("menu-selection","check"),menuSubmenu:(0,r.$Uj)("menu-submenu","chevron-right"),menuBarMore:(0,r.$Uj)("menubar-more","more"),scrollbarButtonLeft:(0,r.$Uj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,r.$Uj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,r.$Uj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,r.$Uj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,r.$Uj)("toolbar-more","more"),quickInputBack:(0,r.$Uj)("quick-input-back","arrow-left"),dropDownButton:(0,r.$Uj)("drop-down-button",60084),symbolCustomColor:(0,r.$Uj)("symbol-customcolor",60252),exportIcon:(0,r.$Uj)("export",60332),workspaceUnspecified:(0,r.$Uj)("workspace-unspecified",60355),newLine:(0,r.$Uj)("newline",60394),thumbsDownFilled:(0,r.$Uj)("thumbsdown-filled",60435),thumbsUpFilled:(0,r.$Uj)("thumbsup-filled",60436),gitFetch:(0,r.$Uj)("git-fetch",60445),lightbulbSparkleAutofix:(0,r.$Uj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,r.$Uj)("debug-breakpoint-pending",60377)},e.$Zj={...u.$Wj,...e.$Yj}}),define(Ee[25],Se([1,0,18]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0n=u,e.$$n=P,e.$_n=L,e.$ao=p,e.$bo=l,e.$co=I,e.$do=D,e.$eo=f,e.$fo=A,e.$go=w,e.$ho=a,e.$io=d,e.$jo=g;function u($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const i=Array.isArray($)?[]:{};return Object.entries($).forEach(([o,n])=>{i[o]=n&&typeof n=="object"?u(n):n}),i}function P($){if(!$||typeof $!="object")return $;const i=[$];for(;i.length>0;){const o=i.shift();Object.freeze(o);for(const n in o)if(T.call(o,n)){const t=o[n];typeof t=="object"&&!Object.isFrozen(t)&&!(0,r.$dg)(t)&&i.push(t)}}return $}const T=Object.prototype.hasOwnProperty;function L($,i){return R($,i,new Set)}function R($,i,o){if((0,r.$jg)($))return $;const n=i($);if(typeof n<"u")return n;if(Array.isArray($)){const t=[];for(const c of $)t.push(R(c,i,o));return t}if((0,r.$cg)($)){if(o.has($))throw new Error("Cannot clone recursive data-structure");o.add($);const t={};for(const c in $)T.call($,c)&&(t[c]=R($[c],i,o));return o.delete($),t}return $}function p($,i,o=!0){return(0,r.$cg)($)?((0,r.$cg)(i)&&Object.keys(i).forEach(n=>{n in $?o&&((0,r.$cg)($[n])&&(0,r.$cg)(i[n])?p($[n],i[n],o):$[n]=i[n]):$[n]=i[n]}),$):i}function l($,i){if($===i)return!0;if($==null||i===null||i===void 0||typeof $!=typeof i||typeof $!="object"||Array.isArray($)!==Array.isArray(i))return!1;let o,n;if(Array.isArray($)){if($.length!==i.length)return!1;for(o=0;o<$.length;o++)if(!l($[o],i[o]))return!1}else{const t=[];for(n in $)t.push(n);t.sort();const c=[];for(n in i)c.push(n);if(c.sort(),!l(t,c))return!1;for(o=0;o<t.length;o++)if(!l($[t[o]],i[t[o]]))return!1}return!0}function I($){const i=new Set;return JSON.stringify($,(o,n)=>{if((0,r.$cg)(n)||Array.isArray(n)){if(i.has(n))return"[Circular]";i.add(n)}return typeof n=="bigint"?`[BigInt ${n.toString()}]`:n})}function D($,i){const o=Object.create(null);return!$||!i||Object.keys(i).forEach(t=>{const c=$[t],h=i[t];l(c,h)||(o[t]=h)}),o}function f($,i){const o=i.toLowerCase(),n=Object.keys($).find(t=>t.toLowerCase()===o);return n?$[n]:$[i]}function A($,i){const o=Object.create(null);for(const[n,t]of Object.entries($))i(n,t)&&(o[n]=t);return o}function w($){let i=[];for(;Object.prototype!==$;)i=i.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return i}function a($){const i=[];for(const o of w($))typeof $[o]=="function"&&i.push(o);return i}function d($,i){const o=t=>function(){const c=Array.prototype.slice.call(arguments,0);return i(t,c)},n={};for(const t of $)n[t]=o(t);return n}function g($,i){const o={};for(const[n,t]of Object.entries($))o[n]=i(t,n);return o}}),define(Ee[50],Se([1,0,83]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=P;var u;(function(L){function R(p){return p&&typeof p=="object"&&typeof p.id=="string"}L.isThemeColor=R})(u||(e.ThemeColor=u={}));function P(L){return{id:L}}var T;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const R=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function p($){const i=R.exec($.id);if(!i)return p(r.$Zj.error);const[,o,n]=i,t=["codicon","codicon-"+o];return n&&t.push("codicon-modifier-"+n.substring(1)),t}L.asClassNameArray=p;function l($){return p($).join(" ")}L.asClassName=l;function I($){return"."+p($).join(".")}L.asCSSSelector=I;function D($){return $&&typeof $=="object"&&typeof $.id=="string"&&(typeof $.color>"u"||u.isThemeColor($.color))}L.isThemeIcon=D;const f=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function A($){const i=f.exec($);if(!i)return;const[,o]=i;return{id:o}}L.fromString=A;function w($){return{id:$}}L.fromId=w;function a($,i){let o=$.id;const n=o.lastIndexOf("~");return n!==-1&&(o=o.substring(0,n)),i&&(o=`${o}~${i}`),{id:o}}L.modify=a;function d($){const i=$.id.lastIndexOf("~");if(i!==-1)return $.id.substring(i+1)}L.getModifier=d;function g($,i){return $.id===i.id&&$.color?.id===i.color?.id}L.isEqual=g})(T||(e.ThemeIcon=T={}))}),define(Ee[84],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$9e=u,e.$0e=P;var r;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(r||(e.Constants=r={}));function u(T){return T<0?0:T>r.MAX_UINT_8?r.MAX_UINT_8:T|0}function P(T){return T<0?0:T>r.MAX_UINT_32?r.MAX_UINT_32:T|0}}),define(Ee[13],Se([1,0,182,27,49,84]),function(oe,e,r,u,P,T){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$_f=e.$$f=e.$0f=e.GraphemeBreakType=e.$Zf=e.$Rf=e.$Kf=e.$Jf=void 0,e.$$e=R,e.$_e=l,e.$af=D,e.$bf=f,e.$cf=A,e.$df=w,e.$ef=a,e.$ff=d,e.$gf=g,e.$hf=$,e.$if=i,e.$jf=o,e.$kf=n,e.$lf=t,e.$mf=c,e.$nf=h,e.$of=s,e.$pf=m,e.$qf=y,e.$rf=S,e.$sf=E,e.$tf=k,e.$uf=C,e.$vf=v,e.$wf=b,e.$xf=O,e.$yf=U,e.$zf=z,e.$Af=j,e.$Bf=M,e.$Cf=N,e.$Df=F,e.$Ef=X,e.$Ff=se,e.$Gf=W,e.$Hf=H,e.$If=V,e.$Lf=we,e.$Mf=pe,e.$Nf=ce,e.$Of=K,e.$Pf=ee,e.$Qf=le,e.$Sf=Z,e.$Tf=ae,e.$Uf=$e,e.$Vf=be,e.$Wf=qe,e.$Xf=De,e.$Yf=Te,e.$1f=B,e.$2f=q,e.$3f=Y,e.$4f=_,e.$5f=fe,e.$6f=ve,e.$7f=Ne,e.$8f=Be,e.$9f=ot;function R(Re){return!Re||typeof Re!="string"?!0:Re.trim().length===0}const p=/{(\d+)}/g;function l(Re,...Ie){return Ie.length===0?Re:Re.replace(p,function(Ae,ue){const Q=parseInt(ue,10);return isNaN(Q)||Q<0||Q>=Ie.length?Ae:Ie[Q]})}const I=/{([^}]+)}/g;function D(Re,Ie){return Object.keys(Ie).length===0?Re:Re.replace(I,(Ae,ue)=>Ie[ue]??Ae)}function f(Re){return Re.replace(/[<>"'&]/g,Ie=>{switch(Ie){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ie})}function A(Re){return Re.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}function w(Re){return Re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function a(Re,Ie){let Ae=0,ue=Re.indexOf(Ie);for(;ue!==-1;)Ae++,ue=Re.indexOf(Ie,ue+Ie.length);return Ae}function d(Re,Ie,Ae="\u2026"){return Re.length<=Ie?Re:`${Re.substr(0,Ie)}${Ae}`}function g(Re,Ie,Ae="\u2026"){if(Re.length<=Ie)return Re;const ue=Math.ceil(Ie/2)-Ae.length/2,Q=Math.floor(Ie/2)-Ae.length/2;return`${Re.substr(0,ue)}${Ae}${Re.substr(Re.length-Q)}`}function $(Re,Ie=" "){const Ae=i(Re,Ie);return o(Ae,Ie)}function i(Re,Ie){if(!Re||!Ie)return Re;const Ae=Ie.length;if(Ae===0||Re.length===0)return Re;let ue=0;for(;Re.indexOf(Ie,ue)===ue;)ue=ue+Ae;return Re.substring(ue)}function o(Re,Ie){if(!Re||!Ie)return Re;const Ae=Ie.length,ue=Re.length;if(Ae===0||ue===0)return Re;let Q=ue,Ce=-1;for(;Ce=Re.lastIndexOf(Ie,Q-1),!(Ce===-1||Ce+Ae!==Q);){if(Ce===0)return"";Q=Ce}return Re.substring(0,Q)}function n(Re){return Re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function t(Re){return Re.replace(/\*/g,"")}function c(Re,Ie,Ae={}){if(!Re)throw new Error("Cannot create regex from empty string");Ie||(Re=w(Re)),Ae.wholeWord&&(/\B/.test(Re.charAt(0))||(Re="\\b"+Re),/\B/.test(Re.charAt(Re.length-1))||(Re=Re+"\\b"));let ue="";return Ae.global&&(ue+="g"),Ae.matchCase||(ue+="i"),Ae.multiline&&(ue+="m"),Ae.unicode&&(ue+="u"),new RegExp(Re,ue)}function h(Re){return Re.source==="^"||Re.source==="^$"||Re.source==="$"||Re.source==="^\\s*$"?!1:!!(Re.exec("")&&Re.lastIndex===0)}function s(Re){return Re.split(/\r\n|\r|\n/)}function m(Re){const Ie=[],Ae=Re.split(/(\r\n|\r|\n)/);for(let ue=0;ue<Math.ceil(Ae.length/2);ue++)Ie.push(Ae[2*ue]+(Ae[2*ue+1]??""));return Ie}function y(Re){for(let Ie=0,Ae=Re.length;Ie<Ae;Ie++){const ue=Re.charCodeAt(Ie);if(ue!==u.CharCode.Space&&ue!==u.CharCode.Tab)return Ie}return-1}function S(Re,Ie=0,Ae=Re.length){for(let ue=Ie;ue<Ae;ue++){const Q=Re.charCodeAt(ue);if(Q!==u.CharCode.Space&&Q!==u.CharCode.Tab)return Re.substring(Ie,ue)}return Re.substring(Ie,Ae)}function E(Re,Ie=Re.length-1){for(let Ae=Ie;Ae>=0;Ae--){const ue=Re.charCodeAt(Ae);if(ue!==u.CharCode.Space&&ue!==u.CharCode.Tab)return Ae}return-1}function k(Re,Ie,Ae){const ue=[];let Q=0;for(const Ce of Re.matchAll(Ie)){if(ue.push(Re.slice(Q,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");Q=Ce.index+Ce[0].length,ue.push(Ae(Ce[0],...Ce.slice(1),Ce.index,Re,Ce.groups))}return ue.push(Re.slice(Q)),Promise.all(ue).then(Ce=>Ce.join(""))}function C(Re,Ie){return Re<Ie?-1:Re>Ie?1:0}function v(Re,Ie,Ae=0,ue=Re.length,Q=0,Ce=Ie.length){for(;Ae<ue&&Q<Ce;Ae++,Q++){const ct=Re.charCodeAt(Ae),lt=Ie.charCodeAt(Q);if(ct<lt)return-1;if(ct>lt)return 1}const Je=ue-Ae,_e=Ce-Q;return Je<_e?-1:Je>_e?1:0}function b(Re,Ie){return O(Re,Ie,0,Re.length,0,Ie.length)}function O(Re,Ie,Ae=0,ue=Re.length,Q=0,Ce=Ie.length){for(;Ae<ue&&Q<Ce;Ae++,Q++){let ct=Re.charCodeAt(Ae),lt=Ie.charCodeAt(Q);if(ct===lt)continue;if(ct>=128||lt>=128)return v(Re.toLowerCase(),Ie.toLowerCase(),Ae,ue,Q,Ce);z(ct)&&(ct-=32),z(lt)&&(lt-=32);const yt=ct-lt;if(yt!==0)return yt}const Je=ue-Ae,_e=Ce-Q;return Je<_e?-1:Je>_e?1:0}function U(Re){return Re>=u.CharCode.Digit0&&Re<=u.CharCode.Digit9}function z(Re){return Re>=u.CharCode.a&&Re<=u.CharCode.z}function j(Re){return Re>=u.CharCode.A&&Re<=u.CharCode.Z}function M(Re,Ie){return Re.length===Ie.length&&O(Re,Ie)===0}function N(Re,Ie){const Ae=Ie.length;return Ie.length>Re.length?!1:O(Re,Ie,0,Ae)===0}function F(Re,Ie){const Ae=Math.min(Re.length,Ie.length);let ue;for(ue=0;ue<Ae;ue++)if(Re.charCodeAt(ue)!==Ie.charCodeAt(ue))return ue;return Ae}function X(Re,Ie){const Ae=Math.min(Re.length,Ie.length);let ue;const Q=Re.length-1,Ce=Ie.length-1;for(ue=0;ue<Ae;ue++)if(Re.charCodeAt(Q-ue)!==Ie.charCodeAt(Ce-ue))return ue;return Ae}function se(Re){return 55296<=Re&&Re<=56319}function W(Re){return 56320<=Re&&Re<=57343}function H(Re,Ie){return(Re-55296<<10)+(Ie-56320)+65536}function V(Re,Ie,Ae){const ue=Re.charCodeAt(Ae);if(se(ue)&&Ae+1<Ie){const Q=Re.charCodeAt(Ae+1);if(W(Q))return H(ue,Q)}return ue}function x(Re,Ie){const Ae=Re.charCodeAt(Ie-1);if(W(Ae)&&Ie>1){const ue=Re.charCodeAt(Ie-2);if(se(ue))return H(ue,Ae)}return Ae}class he{get offset(){return this.e}constructor(Ie,Ae=0){this.c=Ie,this.d=Ie.length,this.e=Ae}setOffset(Ie){this.e=Ie}prevCodePoint(){const Ie=x(this.c,this.e);return this.e-=Ie>=T.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ie}nextCodePoint(){const Ie=V(this.c,this.d,this.e);return this.e+=Ie>=T.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Ie}eol(){return this.e>=this.d}}e.$Jf=he;class ne{get offset(){return this.c.offset}constructor(Ie,Ae=0){this.c=new he(Ie,Ae)}nextGraphemeLength(){const Ie=tt.getInstance(),Ae=this.c,ue=Ae.offset;let Q=Ie.getGraphemeBreakType(Ae.nextCodePoint());for(;!Ae.eol();){const Ce=Ae.offset,Je=Ie.getGraphemeBreakType(Ae.nextCodePoint());if(Qe(Q,Je)){Ae.setOffset(Ce);break}Q=Je}return Ae.offset-ue}prevGraphemeLength(){const Ie=tt.getInstance(),Ae=this.c,ue=Ae.offset;let Q=Ie.getGraphemeBreakType(Ae.prevCodePoint());for(;Ae.offset>0;){const Ce=Ae.offset,Je=Ie.getGraphemeBreakType(Ae.prevCodePoint());if(Qe(Je,Q)){Ae.setOffset(Ce);break}Q=Je}return ue-Ae.offset}eol(){return this.c.eol()}}e.$Kf=ne;function we(Re,Ie){return new ne(Re,Ie).nextGraphemeLength()}function pe(Re,Ie){return new ne(Re,Ie).prevGraphemeLength()}function ce(Re,Ie){Ie>0&&W(Re.charCodeAt(Ie))&&Ie--;const Ae=Ie+we(Re,Ie);return[Ae-pe(Re,Ae),Ae]}function K(Re){const Ie=new ne(Re);let Ae=0;for(;!Ie.eol();)Ae++,Ie.nextGraphemeLength();return Ae}let de;function te(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ee(Re){return de||(de=te()),de.test(Re)}const ie=/^[\t\n\r\x20-\x7E]*$/;function le(Re){return ie.test(Re)}e.$Rf=/[\u2028\u2029]/;function Z(Re){return e.$Rf.test(Re)}function ae(Re){return Re>=11904&&Re<=55215||Re>=63744&&Re<=64255||Re>=65281&&Re<=65374}function $e(Re){return Re>=127462&&Re<=127487||Re===8986||Re===8987||Re===9200||Re===9203||Re>=9728&&Re<=10175||Re===11088||Re===11093||Re>=127744&&Re<=128591||Re>=128640&&Re<=128764||Re>=128992&&Re<=129008||Re>=129280&&Re<=129535||Re>=129648&&Re<=129782}function be(Re,Ie,Ae=""){const ue=Re.trimStart();if(ue.length<Ie)return ue;const Q=/\b/g;let Ce=0;for(;Q.test(ue)&&!(ue.length-Q.lastIndex<Ie);)Ce=Q.lastIndex,Q.lastIndex+=1;return Ce===0?ue:Ae+ue.substring(Ce).trimStart()}const Me=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*qe(Re){let Ie=0;for(const Ae of Re.matchAll(Me))Ie!==Ae.index&&(yield{isCode:!1,str:Re.substring(Ie,Ae.index)}),yield{isCode:!0,str:Ae[0]},Ie=Ae.index+Ae[0].length;Ie!==Re.length&&(yield{isCode:!1,str:Re.substring(Ie)})}function De(Re){return Re&&(Re=Re.replace(Me,"")),Re}const Pe=/\\\[.*?\\\]/g;function Te(Re){return De(Re).replace(Pe,"")}e.$Zf=String.fromCharCode(u.CharCode.UTF8_BOM);function B(Re){return!!(Re&&Re.length>0&&Re.charCodeAt(0)===u.CharCode.UTF8_BOM)}function q(Re){return B(Re)?Re.substr(1):Re}function Y(Re,Ie){if(!Re||!Ie||Re.length<Ie.length)return!1;const Ae=Ie.length,ue=Re.toLowerCase();let Q=0,Ce=-1;for(;Q<Ae;){const Je=ue.indexOf(Ie[Q],Ce+1);if(Je<0)return!1;Ce=Je,Q++}return!0}function _(Re,Ie=!1){return Re?(Ie&&(Re=Re.replace(/\\./g,"")),Re.toLowerCase()!==Re):!1}function fe(Re){return Re.charAt(0).toUpperCase()+Re.slice(1)}function ve(Re,Ie=1){if(Ie===0)return"";let Ae=-1;do Ae=Re.indexOf(`
`,Ae+1),Ie--;while(Ie>0&&Ae>=0);return Ae===-1?Re:(Re[Ae-1]==="\r"&&Ae--,Re.substr(0,Ae))}function Ne(Re){const Ie=u.CharCode.Z-u.CharCode.A+1;return Re=Re%(2*Ie),Re<Ie?String.fromCharCode(u.CharCode.a+Re):String.fromCharCode(u.CharCode.A+Re-Ie)}function Be(Re){return tt.getInstance().getGraphemeBreakType(Re)}function Qe(Re,Ie){return Re===He.Other?Ie!==He.Extend&&Ie!==He.SpacingMark:Re===He.CR&&Ie===He.LF?!1:Re===He.Control||Re===He.CR||Re===He.LF||Ie===He.Control||Ie===He.CR||Ie===He.LF?!0:!(Re===He.L&&(Ie===He.L||Ie===He.V||Ie===He.LV||Ie===He.LVT)||(Re===He.LV||Re===He.V)&&(Ie===He.V||Ie===He.T)||(Re===He.LVT||Re===He.T)&&Ie===He.T||Ie===He.Extend||Ie===He.ZWJ||Ie===He.SpacingMark||Re===He.Prepend||Re===He.ZWJ&&Ie===He.Extended_Pictographic||Re===He.Regional_Indicator&&Ie===He.Regional_Indicator)}var He;(function(Re){Re[Re.Other=0]="Other",Re[Re.Prepend=1]="Prepend",Re[Re.CR=2]="CR",Re[Re.LF=3]="LF",Re[Re.Control=4]="Control",Re[Re.Extend=5]="Extend",Re[Re.Regional_Indicator=6]="Regional_Indicator",Re[Re.SpacingMark=7]="SpacingMark",Re[Re.L=8]="L",Re[Re.V=9]="V",Re[Re.T=10]="T",Re[Re.LV=11]="LV",Re[Re.LVT=12]="LVT",Re[Re.ZWJ=13]="ZWJ",Re[Re.Extended_Pictographic=14]="Extended_Pictographic"})(He||(e.GraphemeBreakType=He={}));class tt{static getInstance(){return tt.c||(tt.c=new tt),tt.c}constructor(){this.d=nt()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===u.CharCode.LineFeed?He.LF:Ie===u.CharCode.CarriageReturn?He.CR:He.Control;if(Ie<127)return He.Other;const Ae=this.d,ue=Ae.length/3;let Q=1;for(;Q<=ue;)if(Ie<Ae[3*Q])Q=2*Q;else if(Ie>Ae[3*Q+1])Q=2*Q+1;else return Ae[3*Q+2];return He.Other}}tt.c=null;function nt(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ot(Re,Ie){if(Re===0)return 0;const Ae=at(Re,Ie);if(Ae!==void 0)return Ae;const ue=new he(Ie,Re);return ue.prevCodePoint(),ue.offset}function at(Re,Ie){const Ae=new he(Ie,Re);let ue=Ae.prevCodePoint();for(;pt(ue)||ue===ft.emojiVariantSelector||ue===ft.enclosingKeyCap;){if(Ae.offset===0)return;ue=Ae.prevCodePoint()}if(!$e(ue))return;let Q=Ae.offset;return Q>0&&Ae.prevCodePoint()===ft.zwj&&(Q=Ae.offset),Q}function pt(Re){return 127995<=Re&&Re<=127999}var ft;(function(Re){Re[Re.zwj=8205]="zwj",Re[Re.emojiVariantSelector=65039]="emojiVariantSelector",Re[Re.enclosingKeyCap=8419]="enclosingKeyCap"})(ft||(ft={})),e.$0f="\xA0";class st{static getInstance(Ie){return L.d.get(Array.from(Ie))}static getLocales(){return L.e.value}constructor(Ie){this.f=Ie}isAmbiguous(Ie){return this.f.has(Ie)}containsAmbiguousCharacter(Ie){for(let Ae=0;Ae<Ie.length;Ae++){const ue=Ie.codePointAt(Ae);if(typeof ue=="number"&&this.isAmbiguous(ue))return!0}return!1}getPrimaryConfusable(Ie){return this.f.get(Ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$$f=st,L=st,st.c=new P.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),st.d=new r.$7e({getCacheKey:JSON.stringify},Re=>{function Ie(lt){const yt=new Map;for(let At=0;At<lt.length;At+=2)yt.set(lt[At],lt[At+1]);return yt}function Ae(lt,yt){const At=new Map(lt);for(const[Ot,_t]of yt)At.set(Ot,_t);return At}function ue(lt,yt){if(!lt)return yt;const At=new Map;for(const[Ot,_t]of lt)yt.has(Ot)&&At.set(Ot,_t);return At}const Q=L.c.value;let Ce=Re.filter(lt=>!lt.startsWith("_")&&lt in Q);Ce.length===0&&(Ce=["_default"]);let Je;for(const lt of Ce){const yt=Ie(Q[lt]);Je=ue(Je,yt)}const _e=Ie(Q._common),ct=Ae(_e,Je);return new L(ct)}),st.e=new P.$V(()=>Object.keys(L.c.value).filter(Re=>!Re.startsWith("_")));class ht{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(ht.c())),this.d}static isInvisibleCharacter(Ie){return ht.e().has(Ie)}static containsInvisibleCharacter(Ie){for(let Ae=0;Ae<Ie.length;Ae++){const ue=Ie.codePointAt(Ae);if(typeof ue=="number"&&ht.isInvisibleCharacter(ue))return!0}return!1}static get codePoints(){return ht.e()}}e.$_f=ht,ht.d=void 0}),define(Ee[32],Se([1,0,27,16,11,13,18]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=R,e.$tg=p,e.$ug=l,e.$vg=I,e.$wg=D,e.$xg=a,e.$yg=d,e.$zg=g,e.$Ag=$,e.$Bg=i,e.$Cg=o,e.$Dg=n,e.$Eg=t,e.$Fg=c,e.$Gg=h,e.$Hg=s,e.$Ig=S;function R(E){return E===r.CharCode.Slash||E===r.CharCode.Backslash}function p(E){return E.replace(/[\\/]/g,u.$gc.sep)}function l(E){return E.indexOf("/")===-1&&(E=p(E)),/^[a-zA-Z]:(\/|$)/.test(E)&&(E="/"+E),E}function I(E,k=u.$gc.sep){if(!E)return"";const C=E.length,v=E.charCodeAt(0);if(R(v)){if(R(E.charCodeAt(1))&&!R(E.charCodeAt(2))){let O=3;const U=O;for(;O<C&&!R(E.charCodeAt(O));O++);if(U!==O&&!R(E.charCodeAt(O+1))){for(O+=1;O<C;O++)if(R(E.charCodeAt(O)))return E.slice(0,O+1).replace(/[\\/]/g,k)}}return k}else if($(v)&&E.charCodeAt(1)===r.CharCode.Colon)return R(E.charCodeAt(2))?E.slice(0,2)+k:E.slice(0,2);let b=E.indexOf("://");if(b!==-1){for(b+=3;b<C;b++)if(R(E.charCodeAt(b)))return E.slice(0,b+1)}return""}function D(E){if(!P.$c||!E||E.length<5)return!1;let k=E.charCodeAt(0);if(k!==r.CharCode.Backslash||(k=E.charCodeAt(1),k!==r.CharCode.Backslash))return!1;let C=2;const v=C;for(;C<E.length&&(k=E.charCodeAt(C),k!==r.CharCode.Backslash);C++);return!(v===C||(k=E.charCodeAt(C+1),isNaN(k)||k===r.CharCode.Backslash))}const f=/[\\/:\*\?"<>\|]/g,A=/[/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(E,k=P.$c){const C=k?f:A;return!(!E||E.length===0||/^\s+$/.test(E)||(C.lastIndex=0,C.test(E))||k&&w.test(E)||E==="."||E===".."||k&&E[E.length-1]==="."||k&&E.length!==E.trim().length||E.length>255)}function d(E,k,C){const v=E===k;return!C||v?v:!E||!k?!1:(0,T.$Bf)(E,k)}function g(E,k,C,v=u.sep){if(E===k)return!0;if(!E||!k||k.length>E.length)return!1;if(C){if(!(0,T.$Cf)(E,k))return!1;if(k.length===E.length)return!0;let O=k.length;return k.charAt(k.length-1)===v&&O--,E.charAt(O)===v}return k.charAt(k.length-1)!==v&&(k+=v),E.indexOf(k)===0}function $(E){return E>=r.CharCode.A&&E<=r.CharCode.Z||E>=r.CharCode.a&&E<=r.CharCode.z}function i(E,k){return P.$c&&E.endsWith(":")&&(E+=u.sep),(0,u.$ic)(E)||(E=(0,u.$jc)(k,E)),E=(0,u.$hc)(E),o(E)}function o(E){return P.$c?(E=(0,T.$jf)(E,u.sep),E.endsWith(":")&&(E+=u.sep)):(E=(0,T.$jf)(E,u.sep),E||(E=u.sep)),E}function n(E){const k=(0,u.$hc)(E);return P.$c?E.length>3?!1:t(k)&&(E.length===2||k.charCodeAt(2)===r.CharCode.Backslash):k===u.$gc.sep}function t(E,k=P.$c){return k?$(E.charCodeAt(0))&&E.charCodeAt(1)===r.CharCode.Colon:!1}function c(E,k=P.$c){return t(E,k)?E[0]:void 0}function h(E,k,C){return k.length>E.length?-1:E===k?0:(C&&(E=E.toLowerCase(),k=k.toLowerCase()),E.indexOf(k))}function s(E){const k=E.split(":");let C,v,b;for(const O of k){const U=Number(O);(0,L.$eg)(U)?v===void 0?v=U:b===void 0&&(b=U):C=C?[C,O].join(":"):O}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:v!==void 0?v:void 0,column:b!==void 0?b:v!==void 0?1:void 0}}const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",y="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(E,k,C=8){let v="";for(let O=0;O<C;O++){let U;O===0&&P.$c&&!k&&(C===3||C===4)?U=y:U=m,v+=U.charAt(Math.floor(Math.random()*U.length))}let b;return k?b=`${k}-${v}`:b=v,E?(0,u.$jc)(E,b):b}}),define(Ee[136],Se([1,0,27,29,177,13]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.FuzzyScore=e.$Ck=e.$Bk=void 0,e.or=L,e.$Dk=p,e.$Ek=l,e.$Fk=f,e.$Gk=S,e.$Hk=E,e.$Ik=U,e.$Jk=z,e.$Kk=j,e.$Lk=M,e.$Mk=de,e.$Ok=le,e.$Pk=$e,e.$Qk=be;function L(...De){return function(Pe,Te){for(let B=0,q=De.length;B<q;B++){const Y=De[B](Pe,Te);if(Y)return Y}return null}}e.$Bk=R.bind(void 0,!1),e.$Ck=R.bind(void 0,!0);function R(De,Pe,Te){if(!Te||Te.length<Pe.length)return null;let B;return De?B=T.$Cf(Te,Pe):B=Te.indexOf(Pe)===0,B?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(De,Pe){const Te=Pe.toLowerCase().indexOf(De.toLowerCase());return Te===-1?null:[{start:Te,end:Te+De.length}]}function l(De,Pe){return I(De.toLowerCase(),Pe.toLowerCase(),0,0)}function I(De,Pe,Te,B){if(Te===De.length)return[];if(B===Pe.length)return null;if(De[Te]===Pe[B]){let q=null;return(q=I(De,Pe,Te+1,B+1))?n({start:B,end:B+1},q):null}return I(De,Pe,Te,B+1)}function D(De){return r.CharCode.a<=De&&De<=r.CharCode.z}function f(De){return r.CharCode.A<=De&&De<=r.CharCode.Z}function A(De){return r.CharCode.Digit0<=De&&De<=r.CharCode.Digit9}function w(De){return De===r.CharCode.Space||De===r.CharCode.Tab||De===r.CharCode.LineFeed||De===r.CharCode.CarriageReturn}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(De=>a.add(De.charCodeAt(0)));function d(De){return w(De)||a.has(De)}function g(De,Pe){return De===Pe||d(De)&&d(Pe)}const $=new Map;function i(De){if($.has(De))return $.get(De);let Pe;const Te=(0,P.$zk)(De);return Te&&(Pe=Te),$.set(De,Pe),Pe}function o(De){return D(De)||f(De)||A(De)}function n(De,Pe){return Pe.length===0?Pe=[De]:De.end===Pe[0].start?Pe[0].start=De.start:Pe.unshift(De),Pe}function t(De,Pe){for(let Te=Pe;Te<De.length;Te++){const B=De.charCodeAt(Te);if(f(B)||A(B)||Te>0&&!o(De.charCodeAt(Te-1)))return Te}return De.length}function c(De,Pe,Te,B){if(Te===De.length)return[];if(B===Pe.length)return null;if(De[Te]!==Pe[B].toLowerCase())return null;{let q=null,Y=B+1;for(q=c(De,Pe,Te+1,B+1);!q&&(Y=t(Pe,Y))<Pe.length;)q=c(De,Pe,Te+1,Y),Y++;return q===null?null:n({start:B,end:B+1},q)}}function h(De){let Pe=0,Te=0,B=0,q=0,Y=0;for(let Be=0;Be<De.length;Be++)Y=De.charCodeAt(Be),f(Y)&&Pe++,D(Y)&&Te++,o(Y)&&B++,A(Y)&&q++;const _=Pe/De.length,fe=Te/De.length,ve=B/De.length,Ne=q/De.length;return{upperPercent:_,lowerPercent:fe,alphaPercent:ve,numericPercent:Ne}}function s(De){const{upperPercent:Pe,lowerPercent:Te}=De;return Te===0&&Pe>.6}function m(De){const{upperPercent:Pe,lowerPercent:Te,alphaPercent:B,numericPercent:q}=De;return Te>.2&&Pe<.8&&B>.6&&q<.2}function y(De){let Pe=0,Te=0,B=0,q=0;for(let Y=0;Y<De.length;Y++)B=De.charCodeAt(Y),f(B)&&Pe++,D(B)&&Te++,w(B)&&q++;return(Pe===0||Te===0)&&q===0?De.length<=30:Pe<=5}function S(De,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!y(De))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Te=h(Pe);if(!m(Te)){if(!s(Te))return null;Pe=Pe.toLowerCase()}let B=null,q=0;for(De=De.toLowerCase();q<Pe.length&&(B=c(De,Pe,0,q))===null;)q=t(Pe,q+1);return B}function E(De,Pe,Te=!1){if(!Pe||Pe.length===0)return null;let B=null,q=0;for(De=De.toLowerCase(),Pe=Pe.toLowerCase();q<Pe.length&&(B=k(De,Pe,0,q,Te),B===null);)q=C(Pe,q+1);return B}function k(De,Pe,Te,B,q){let Y=0;if(Te===De.length)return[];if(B===Pe.length)return null;if(!g(De.charCodeAt(Te),Pe.charCodeAt(B))){const ve=i(De.charCodeAt(Te));if(!ve)return null;for(let Ne=0;Ne<ve.length;Ne++)if(!g(ve[Ne],Pe.charCodeAt(B+Ne)))return null;Y+=ve.length-1}let _=null,fe=B+Y+1;if(_=k(De,Pe,Te+1,fe,q),!q)for(;!_&&(fe=C(Pe,fe))<Pe.length;)_=k(De,Pe,Te+1,fe,q),fe++;if(!_)return null;if(De.charCodeAt(Te)!==Pe.charCodeAt(B)){const ve=i(De.charCodeAt(Te));if(!ve)return _;for(let Ne=0;Ne<ve.length;Ne++)if(ve[Ne]!==Pe.charCodeAt(B+Ne))return _}return n({start:B,end:B+Y+1},_)}function C(De,Pe){for(let Te=Pe;Te<De.length;Te++)if(d(De.charCodeAt(Te))||Te>0&&d(De.charCodeAt(Te-1)))return Te;return De.length}const v=L(e.$Ck,S,p),b=L(e.$Ck,S,l),O=new u.$Dc(1e4);function U(De,Pe,Te=!1){if(typeof De!="string"||typeof Pe!="string")return null;let B=O.get(De);B||(B=new RegExp(T.$kf(De),"i"),O.set(De,B));const q=B.exec(Pe);return q?[{start:q.index,end:q.index+q[0].length}]:Te?b(De,Pe):v(De,Pe)}function z(De,Pe){const Te=le(De,De.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?M(Te):null}function j(De,Pe,Te,B,q,Y){const _=Math.min(13,De.length);for(;Te<_;Te++){const fe=le(De,Pe,Te,B,q,Y,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,Y]}function M(De){if(typeof De>"u")return[];const Pe=[],Te=De[1];for(let B=De.length-1;B>1;B--){const q=De[B]+Te,Y=Pe[Pe.length-1];Y&&Y.end===q?Y.end=q+1:Pe.push({start:q,end:q+1})}return Pe}const N=128;function F(){const De=[],Pe=[];for(let Te=0;Te<=N;Te++)Pe[Te]=0;for(let Te=0;Te<=N;Te++)De.push(Pe.slice(0));return De}function X(De){const Pe=[];for(let Te=0;Te<=De;Te++)Pe[Te]=0;return Pe}const se=X(2*N),W=X(2*N),H=F(),V=F(),x=F(),he=!1;function ne(De,Pe,Te,B,q){function Y(fe,ve,Ne=" "){for(;fe.length<ve;)fe=Ne+fe;return fe}let _=` |   |${B.split("").map(fe=>Y(fe,3)).join("|")}
`;for(let fe=0;fe<=Te;fe++)fe===0?_+=" |":_+=`${Pe[fe-1]}|`,_+=De[fe].slice(0,q+1).map(ve=>Y(ve.toString(),3)).join("|")+`
`;return _}function we(De,Pe,Te,B){De=De.substr(Pe),Te=Te.substr(B),console.log(ne(V,De,De.length,Te,Te.length)),console.log(ne(x,De,De.length,Te,Te.length)),console.log(ne(H,De,De.length,Te,Te.length))}function pe(De,Pe){if(Pe<0||Pe>=De.length)return!1;const Te=De.codePointAt(Pe);switch(Te){case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.Slash:case r.CharCode.Backslash:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:case r.CharCode.DollarSign:case r.CharCode.LessThan:case r.CharCode.GreaterThan:case r.CharCode.OpenParen:case r.CharCode.CloseParen:case r.CharCode.OpenSquareBracket:case r.CharCode.CloseSquareBracket:case r.CharCode.OpenCurlyBrace:case r.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!T.$Uf(Te)}}function ce(De,Pe){if(Pe<0||Pe>=De.length)return!1;switch(De.charCodeAt(Pe)){case r.CharCode.Space:case r.CharCode.Tab:return!0;default:return!1}}function K(De,Pe,Te){return Pe[De]!==Te[De]}function de(De,Pe,Te,B,q,Y,_=!1){for(;Pe<Te&&q<Y;)De[Pe]===B[q]&&(_&&(se[Pe]=q),Pe+=1),q+=1;return Pe===Te}var te;(function(De){De[De.Diag=1]="Diag",De[De.Left=2]="Left",De[De.LeftLeft=3]="LeftLeft"})(te||(te={}));var ee;(function(De){De.Default=[-100,0];function Pe(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}De.isDefault=Pe})(ee||(e.FuzzyScore=ee={}));class ie{constructor(Pe,Te){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Te}}e.$Nk=ie,ie.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function le(De,Pe,Te,B,q,Y,_=ie.default){const fe=De.length>N?N:De.length,ve=B.length>N?N:B.length;if(Te>=fe||Y>=ve||fe-Te>ve-Y||!de(Pe,Te,fe,q,Y,ve,!0))return;Z(fe,ve,Te,Y,Pe,q);let Ne=1,Be=1,Qe=Te,He=Y;const tt=[!1];for(Ne=1,Qe=Te;Qe<fe;Ne++,Qe++){const ft=se[Qe],st=W[Qe],ht=Qe+1<fe?W[Qe+1]:ve;for(Be=ft-Y+1,He=ft;He<ht;Be++,He++){let Re=Number.MIN_SAFE_INTEGER,Ie=!1;He<=st&&(Re=ae(De,Pe,Qe,Te,B,q,He,ve,Y,H[Ne-1][Be-1]===0,tt));let Ae=0;Re!==Number.MAX_SAFE_INTEGER&&(Ie=!0,Ae=Re+V[Ne-1][Be-1]);const ue=He>ft,Q=ue?V[Ne][Be-1]+(H[Ne][Be-1]>0?-5:0):0,Ce=He>ft+1&&H[Ne][Be-1]>0,Je=Ce?V[Ne][Be-2]+(H[Ne][Be-2]>0?-5:0):0;if(Ce&&(!ue||Je>=Q)&&(!Ie||Je>=Ae))V[Ne][Be]=Je,x[Ne][Be]=te.LeftLeft,H[Ne][Be]=0;else if(ue&&(!Ie||Q>=Ae))V[Ne][Be]=Q,x[Ne][Be]=te.Left,H[Ne][Be]=0;else if(Ie)V[Ne][Be]=Ae,x[Ne][Be]=te.Diag,H[Ne][Be]=H[Ne-1][Be-1]+1;else throw new Error("not possible")}}if(he&&we(De,Te,B,Y),!tt[0]&&!_.firstMatchCanBeWeak)return;Ne--,Be--;const nt=[V[Ne][Be],Y];let ot=0,at=0;for(;Ne>=1;){let ft=Be;do{const st=x[Ne][ft];if(st===te.LeftLeft)ft=ft-2;else if(st===te.Left)ft=ft-1;else break}while(ft>=1);ot>1&&Pe[Te+Ne-1]===q[Y+Be-1]&&!K(ft+Y-1,B,q)&&ot+1>H[Ne][ft]&&(ft=Be),ft===Be?ot++:ot=1,at||(at=ft),Ne--,Be=ft-1,nt.push(Be)}ve-Y===fe&&_.boostFullMatch&&(nt[0]+=2);const pt=at-fe;return nt[0]-=pt,nt}function Z(De,Pe,Te,B,q,Y){let _=De-1,fe=Pe-1;for(;_>=Te&&fe>=B;)q[_]===Y[fe]&&(W[_]=fe,_--),fe--}function ae(De,Pe,Te,B,q,Y,_,fe,ve,Ne,Be){if(Pe[Te]!==Y[_])return Number.MIN_SAFE_INTEGER;let Qe=1,He=!1;return _===Te-B?Qe=De[Te]===q[_]?7:5:K(_,q,Y)&&(_===0||!K(_-1,q,Y))?(Qe=De[Te]===q[_]?7:5,He=!0):pe(Y,_)&&(_===0||!pe(Y,_-1))?Qe=5:(pe(Y,_-1)||ce(Y,_-1))&&(Qe=5,He=!0),Qe>1&&Te===B&&(Be[0]=!0),He||(He=K(_,q,Y)||pe(Y,_-1)||ce(Y,_-1)),Te===B?_>ve&&(Qe-=He?3:5):Ne?Qe+=He?2:0:Qe+=He?0:1,_+1===fe&&(Qe-=He?3:5),Qe}function $e(De,Pe,Te,B,q,Y,_){return Me(De,Pe,Te,B,q,Y,!0,_)}function be(De,Pe,Te,B,q,Y,_){return Me(De,Pe,Te,B,q,Y,!1,_)}function Me(De,Pe,Te,B,q,Y,_,fe){let ve=le(De,Pe,Te,B,q,Y,fe);if(ve&&!_)return ve;if(De.length>=3){const Ne=Math.min(7,De.length-1);for(let Be=Te+1;Be<Ne;Be++){const Qe=qe(De,Be);if(Qe){const He=le(Qe,Qe.toLowerCase(),Te,B,q,Y,fe);He&&(He[0]-=3,(!ve||He[0]>ve[0])&&(ve=He))}}}return ve}function qe(De,Pe){if(Pe+1>=De.length)return;const Te=De[Pe],B=De[Pe+1];if(Te!==B)return De.slice(0,Pe)+B+Te+De.slice(Pe+2)}}),define(Ee[61],Se([1,0,13]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uj=e.$sj=void 0,e.$oj=u,e.$pj=P,e.$qj=T,e.$rj=R,e.$tj=a;function u(g){return P(g,0)}function P(g,$){switch(typeof g){case"object":return g===null?T(349,$):Array.isArray(g)?p(g,$):l(g,$);case"string":return R(g,$);case"boolean":return L(g,$);case"number":return T(g,$);case"undefined":return T(937,$);default:return T(617,$)}}function T(g,$){return($<<5)-$+g|0}function L(g,$){return T(g?433:863,$)}function R(g,$){$=T(149417,$);for(let i=0,o=g.length;i<o;i++)$=T(g.charCodeAt(i),$);return $}function p(g,$){return $=T(104579,$),g.reduce((i,o)=>P(o,i),$)}function l(g,$){return $=T(181387,$),Object.keys(g).sort().reduce((i,o)=>(i=R(o,i),P(g[o],i)),$)}class I{constructor(){this.g=0}get value(){return this.g}hash($){return this.g=P($,this.g),this.g}}e.$sj=I;var D;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function f(g,$,i=32){const o=i-$,n=~((1<<o)-1);return(g<<$|(n&g)>>>o)>>>0}function A(g,$=0,i=g.byteLength,o=0){for(let n=0;n<i;n++)g[$+n]=o}function w(g,$,i="0"){for(;g.length<$;)g=i+g;return g}function a(g,$=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(i=>i.toString(16).padStart(2,"0")).join(""):w((g>>>0).toString(16),$/4)}class d{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(D.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update($){const i=$.length;if(i===0)return;const o=this.p;let n=this.r,t=this.u,c,h;for(t!==0?(c=t,h=-1,t=0):(c=$.charCodeAt(0),h=0);;){let s=c;if(r.$Ff(c))if(h+1<i){const m=$.charCodeAt(h+1);r.$Gf(m)?(h++,s=r.$Hf(c,m)):s=D.UNICODE_REPLACEMENT}else{t=c;break}else r.$Gf(c)&&(s=D.UNICODE_REPLACEMENT);if(n=this.w(o,n,s),h++,h<i)c=$.charCodeAt(h);else break}this.r=n,this.u=t}w($,i,o){return o<128?$[i++]=o:o<2048?($[i++]=192|(o&1984)>>>6,$[i++]=128|(o&63)>>>0):o<65536?($[i++]=224|(o&61440)>>>12,$[i++]=128|(o&4032)>>>6,$[i++]=128|(o&63)>>>0):($[i++]=240|(o&1835008)>>>18,$[i++]=128|(o&258048)>>>12,$[i++]=128|(o&4032)>>>6,$[i++]=128|(o&63)>>>0),i>=D.BLOCK_SIZE&&(this.y(),i-=D.BLOCK_SIZE,this.t+=D.BLOCK_SIZE,$[0]=$[D.BLOCK_SIZE+0],$[1]=$[D.BLOCK_SIZE+1],$[2]=$[D.BLOCK_SIZE+2]),i}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,D.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,A(this.p,this.r),this.r>56&&(this.y(),A(this.p));const $=8*this.t;this.q.setUint32(56,Math.floor($/4294967296),!1),this.q.setUint32(60,$%4294967296,!1),this.y()}y(){const $=d.g,i=this.q;for(let S=0;S<64;S+=4)$.setUint32(S,i.getUint32(S,!1),!1);for(let S=64;S<320;S+=4)$.setUint32(S,f($.getUint32(S-12,!1)^$.getUint32(S-32,!1)^$.getUint32(S-56,!1)^$.getUint32(S-64,!1),1),!1);let o=this.h,n=this.l,t=this.m,c=this.n,h=this.o,s,m,y;for(let S=0;S<80;S++)S<20?(s=n&t|~n&c,m=1518500249):S<40?(s=n^t^c,m=1859775393):S<60?(s=n&t|n&c|t&c,m=2400959708):(s=n^t^c,m=3395469782),y=f(o,5)+s+h+m+$.getUint32(S*4,!1)&4294967295,h=c,c=t,t=f(n,30),n=o,o=y;this.h=this.h+o&4294967295,this.l=this.l+n&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+h&4294967295}}e.$uj=d,d.g=new DataView(new ArrayBuffer(320))}),define(Ee[137],Se([1,0,27,135,136,61,16,11,13]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=D,e.$Dr=g,e.$Er=s,e.$Fr=v,e.$Gr=M,e.$Hr=F;const l=0,I=[l,[]];function D(X,se,W,H){if(!X||!se)return I;const V=X.length,x=se.length;if(V<x)return I;const he=X.toLowerCase();return f(se,W,x,X,he,V,H)}function f(X,se,W,H,V,x,he){const ne=[],we=[];for(let de=0;de<W;de++){const te=de*x,ee=te-x,ie=de>0,le=X[de],Z=se[de];for(let ae=0;ae<x;ae++){const $e=ae>0,be=te+ae,Me=be-1,qe=ee+ae-1,De=$e?ne[Me]:0,Pe=ie&&$e?ne[qe]:0,Te=ie&&$e?we[qe]:0;let B;!Pe&&ie?B=0:B=A(le,Z,H,V,ae,Te),B&&Pe+B>=De&&(he||ie||V.startsWith(se,ae))?(we[be]=Te+1,ne[be]=Pe+B):(we[be]=l,ne[be]=De)}}const pe=[];let ce=W-1,K=x-1;for(;ce>=0&&K>=0;){const de=ce*x+K;we[de]===l||(pe.push(K),ce--),K--}return[ne[W*x-1],pe.reverse()]}function A(X,se,W,H,V,x){let he=0;if(!w(se,H[V]))return he;if(he+=1,x>0&&(he+=x*5),X===W[V]&&(he+=1),V===0)he+=8;else{const ne=a(W.charCodeAt(V-1));ne?he+=ne:(0,P.$Fk)(W.charCodeAt(V))&&x===0&&(he+=2)}return he}function w(X,se){return X===se?!0:X==="/"||X==="\\"?se==="/"||se==="\\":!1}function a(X){switch(X){case r.CharCode.Slash:case r.CharCode.Backslash:return 5;case r.CharCode.Underline:case r.CharCode.Dash:case r.CharCode.Period:case r.CharCode.Space:case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.Colon:return 4;default:return 0}}const d=[void 0,[]];function g(X,se,W=0,H=0){const V=se;return V.values&&V.values.length>1?$(X,V.values,W,H):i(X,se,W,H)}function $(X,se,W,H){let V=0;const x=[];for(const he of se){const[ne,we]=i(X,he,W,H);if(typeof ne!="number")return d;V+=ne,x.push(...we)}return[V,k(x)]}function i(X,se,W,H){const V=(0,P.$Ok)(se.original,se.originalLowercase,W,X,X.toLowerCase(),H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?[V[0],(0,P.$Lk)(V)]:d}const o=Object.freeze({score:0}),n=1<<18,t=1<<17,c=65536;function h(X,se,W,H){const V=H.values?H.values:[H];return(0,T.$oj)({[H.normalized]:{values:V.map(he=>({value:he.normalized,expectContiguousMatch:he.expectContiguousMatch})),label:X,description:se,allowNonContiguousMatches:W}})}function s(X,se,W,H,V){if(!X||!se.normalized)return o;const x=H.getItemLabel(X);if(!x)return o;const he=H.getItemDescription(X),ne=h(x,he,W,se),we=V[ne];if(we)return we;const pe=m(x,he,H.getItemPath(X),se,W);return V[ne]=pe,pe}function m(X,se,W,H,V){const x=!W||!H.containsPathSeparator;return W&&(R.$e?H.pathNormalized===W:(0,p.$Bf)(H.pathNormalized,W))?{score:n,labelMatch:[{start:0,end:X.length}],descriptionMatch:se?[{start:0,end:se.length}]:void 0}:H.values&&H.values.length>1?y(X,se,W,H.values,x,V):S(X,se,W,H,x,V)}function y(X,se,W,H,V,x){let he=0;const ne=[],we=[];for(const pe of H){const{score:ce,labelMatch:K,descriptionMatch:de}=S(X,se,W,pe,V,x);if(ce===l)return o;he+=ce,K&&ne.push(...K),de&&we.push(...de)}return{score:he,labelMatch:k(ne),descriptionMatch:k(we)}}function S(X,se,W,H,V,x){if(V||!se){const[he,ne]=D(X,H.normalized,H.normalizedLowercase,x&&!H.expectContiguousMatch);if(he){const we=(0,P.$Ck)(H.normalized,X);let pe;if(we){pe=t;const ce=Math.round(H.normalized.length/X.length*100);pe+=ce}else pe=c;return{score:pe+he,labelMatch:we||E(ne)}}}if(se){let he=se;W&&(he=`${se}${L.sep}`);const ne=he.length,we=`${he}${X}`,[pe,ce]=D(we,H.normalized,H.normalizedLowercase,x&&!H.expectContiguousMatch);if(pe){const K=E(ce),de=[],te=[];return K.forEach(ee=>{ee.start<ne&&ee.end>ne?(de.push({start:0,end:ee.end-ne}),te.push({start:ee.start,end:ne})):ee.start>=ne?de.push({start:ee.start-ne,end:ee.end-ne}):te.push(ee)}),{score:pe,labelMatch:de,descriptionMatch:te}}}return o}function E(X){const se=[];if(!X)return se;let W;for(const H of X)W&&W.end===H?W.end+=1:(W={start:H,end:H+1},se.push(W));return se}function k(X){const se=X.sort((V,x)=>V.start-x.start),W=[];let H;for(const V of se)!H||!C(H,V)?(H=V,W.push(V)):(H.start=Math.min(H.start,V.start),H.end=Math.max(H.end,V.end));return W}function C(X,se){return!(X.end<se.start||se.end<X.start)}function v(X,se,W,H,V,x){const he=s(X,W,H,V,x),ne=s(se,W,H,V,x),we=he.score,pe=ne.score;if((we===n||pe===n)&&we!==pe)return we===n?-1:1;if(we>c||pe>c){if(we!==pe)return we>pe?-1:1;if(we<t&&pe<t){const le=O(he.labelMatch,ne.labelMatch);if(le!==0)return le}const ee=V.getItemLabel(X)||"",ie=V.getItemLabel(se)||"";if(ee.length!==ie.length)return ee.length-ie.length}if(we!==pe)return we>pe?-1:1;const ce=Array.isArray(he.labelMatch)&&he.labelMatch.length>0,K=Array.isArray(ne.labelMatch)&&ne.labelMatch.length>0;if(ce&&!K)return-1;if(K&&!ce)return 1;const de=b(X,he,V),te=b(se,ne,V);return de&&te&&de!==te?te>de?-1:1:U(X,se,W,V)}function b(X,se,W){let H=-1,V=-1;if(se.descriptionMatch&&se.descriptionMatch.length?H=se.descriptionMatch[0].start:se.labelMatch&&se.labelMatch.length&&(H=se.labelMatch[0].start),se.labelMatch&&se.labelMatch.length){if(V=se.labelMatch[se.labelMatch.length-1].end,se.descriptionMatch&&se.descriptionMatch.length){const x=W.getItemDescription(X);x&&(V+=x.length)}}else se.descriptionMatch&&se.descriptionMatch.length&&(V=se.descriptionMatch[se.descriptionMatch.length-1].end);return V-H}function O(X,se){if(!X&&!se||(!X||!X.length)&&(!se||!se.length))return 0;if(!se||!se.length)return-1;if(!X||!X.length)return 1;const W=X[0].start,V=X[X.length-1].end-W,x=se[0].start,ne=se[se.length-1].end-x;return V===ne?0:ne<V?1:-1}function U(X,se,W,H){const V=H.getItemLabel(X)||"",x=H.getItemLabel(se)||"",he=H.getItemDescription(X),ne=H.getItemDescription(se),we=V.length+(he?he.length:0),pe=x.length+(ne?ne.length:0);if(we!==pe)return we-pe;const ce=H.getItemPath(X),K=H.getItemPath(se);return ce&&K&&ce.length!==K.length?ce.length-K.length:V!==x?(0,u.$Ar)(V,x,W.normalized):he&&ne&&he!==ne?(0,u.$Ar)(he,ne,W.normalized):ce&&K&&ce!==K?(0,u.$Ar)(ce,K,W.normalized):0}function z(X){return X.startsWith('"')&&X.endsWith('"')}const j=" ";function M(X){typeof X!="string"&&(X="");const se=X.toLowerCase(),{pathNormalized:W,normalized:H,normalizedLowercase:V}=N(X),x=W.indexOf(L.sep)>=0,he=z(X);let ne;const we=X.split(j);if(we.length>1)for(const pe of we){const ce=z(pe),{pathNormalized:K,normalized:de,normalizedLowercase:te}=N(pe);de&&(ne||(ne=[]),ne.push({original:pe,originalLowercase:pe.toLowerCase(),pathNormalized:K,normalized:de,normalizedLowercase:te,expectContiguousMatch:ce}))}return{original:X,originalLowercase:se,pathNormalized:W,normalized:H,normalizedLowercase:V,values:ne,containsPathSeparator:x,expectContiguousMatch:he}}function N(X){let se;R.$c?se=X.replace(/\//g,L.sep):se=X.replace(/\\/g,L.sep);const W=(0,p.$lf)(se).replace(/\s|"/g,"");return{pathNormalized:se,normalized:W,normalizedLowercase:W.toLowerCase()}}function F(X){return Array.isArray(X)?M(X.map(se=>se.original).join(j)):M(X.original)}}),define(Ee[138],Se([1,0,136,13,50]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=p,e.$Sk=I,e.$Tk=f,e.$Uk=A,e.$Vk=a,e.$Wk=d;const T="$(",L=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${L.source}`,"g");function p(g){return g.replace(R,($,i)=>i?$:`\\${$}`)}const l=new RegExp(`\\\\${L.source}`,"g");function I(g){return g.replace(l,$=>`\\${$}`)}const D=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function f(g){return g.indexOf(T)===-1?g:g.replace(D,($,i,o,n)=>o?$:i||n||"")}function A(g){return g?g.replace(/\$\((.*?)\)/g,($,i)=>` ${i} `).trim():""}const w=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(g){w.lastIndex=0;let $="";const i=[];let o=0;for(;;){const n=w.lastIndex,t=w.exec(g),c=g.substring(n,t?.index);if(c.length>0){$+=c;for(let h=0;h<c.length;h++)i.push(o)}if(!t)break;o+=t[0].length}return{text:$,iconOffsets:i}}function d(g,$,i=!1){const{text:o,iconOffsets:n}=$;if(!n||n.length===0)return(0,r.$Ik)(g,o,i);const t=(0,u.$if)(o," "),c=o.length-t.length,h=(0,r.$Ik)(g,t,i);if(h)for(const s of h){const m=n[s.start+c]+c;s.start+=m,s.end+=m}return h}}),define(Ee[44],Se([1,0,13]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var u;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(u||(u={})),function(P){const T="error",L="warning",R="warn",p="info",l="ignore";function I(f){return f?r.$Bf(T,f)?P.Error:r.$Bf(L,f)||r.$Bf(R,f)?P.Warning:r.$Bf(p,f)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function D(f){switch(f){case P.Error:return T;case P.Warning:return L;case P.Info:return p;default:return l}}P.toString=D}(u||(u={})),e.default=u}),define(Ee[85],Se([1,0,19,27,13]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class T{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const a=w.charCodeAt(0),d=this.b.charCodeAt(this.c);return a-d}value(){return this.b[this.c]}}e.$Ci=T;class L{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===u.CharCode.Period)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,P.$vf)(w,this.b,0,w.length,this.c,this.d):(0,P.$xf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=L;class R{constructor(w=!0,a=!0){this.f=w,this.g=a}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let a=w.length-1;a>=0;a--,this.c--){const d=this.b.charCodeAt(a);if(!(d===u.CharCode.Slash||this.f&&d===u.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===u.CharCode.Slash||this.f&&a===u.CharCode.Backslash)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,P.$vf)(w,this.b,0,w.length,this.d,this.e):(0,P.$xf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=R;var p;(function(A){A[A.Scheme=1]="Scheme",A[A.Authority=2]="Authority",A[A.Path=3]="Path",A[A.Query=4]="Query",A[A.Fragment=5]="Fragment"})(p||(p={}));class l{constructor(w,a){this.f=w,this.g=a,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new R(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(p.Path)),this.g(w)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===p.Scheme)return(0,P.$wf)(w,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,P.$wf)(w,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(w);if(this.d[this.e]===p.Query)return(0,P.$uf)(w,this.c.query);if(this.d[this.e]===p.Fragment)return(0,P.$uf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Fi=l;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var D;(function(A){A[A.Left=-1]="Left",A[A.Mid=0]="Mid",A[A.Right=1]="Right"})(D||(D={}));class f{static forUris(w=()=>!1,a=()=>!1){return new f(new l(w,a))}static forPaths(w=!1){return new f(new R(void 0,!w))}static forStrings(){return new f(new T)}static forConfigKeys(){return new f(new L)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,a){if(a){const d=a.slice(0);(0,r.$Wb)(d);for(const g of d)this.set(g,w)}else{const d=w.slice(0);(0,r.$Wb)(d);for(const g of d)this.set(g[0],g[1])}}set(w,a){const d=this.b.reset(w);let g;this.c||(this.c=new I,this.c.segment=d.value());const $=[];for(g=this.c;;){const o=d.cmp(g.segment);if(o>0)g.left||(g.left=new I,g.left.segment=d.value()),$.push([D.Left,g]),g=g.left;else if(o<0)g.right||(g.right=new I,g.right.segment=d.value()),$.push([D.Right,g]),g=g.right;else if(d.hasNext())d.next(),g.mid||(g.mid=new I,g.mid.segment=d.value()),$.push([D.Mid,g]),g=g.mid;else break}const i=g.value;g.value=a,g.key=w;for(let o=$.length-1;o>=0;o--){const n=$[o][1];n.updateHeight();const t=n.balanceFactor();if(t<-1||t>1){const c=$[o][0],h=$[o+1][0];if(c===D.Right&&h===D.Right)$[o][1]=n.rotateLeft();else if(c===D.Left&&h===D.Left)$[o][1]=n.rotateRight();else if(c===D.Right&&h===D.Left)n.right=$[o+1][1]=$[o+1][1].rotateRight(),$[o][1]=n.rotateLeft();else if(c===D.Left&&h===D.Right)n.left=$[o+1][1]=$[o+1][1].rotateLeft(),$[o][1]=n.rotateRight();else throw new Error;if(o>0)switch($[o-1][0]){case D.Left:$[o-1][1].left=$[o][1];break;case D.Right:$[o-1][1].right=$[o][1];break;case D.Mid:$[o-1][1].mid=$[o][1];break}else this.c=$[0][1]}}return i}get(w){return this.d(w)?.value}d(w){const a=this.b.reset(w);let d=this.c;for(;d;){const g=a.cmp(d.segment);if(g>0)d=d.left;else if(g<0)d=d.right;else if(a.hasNext())a.next(),d=d.mid;else break}return d}has(w){const a=this.d(w);return!(a?.value===void 0&&a?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,a){const d=this.b.reset(w),g=[];let $=this.c;for(;$;){const i=d.cmp($.segment);if(i>0)g.push([D.Left,$]),$=$.left;else if(i<0)g.push([D.Right,$]),$=$.right;else if(d.hasNext())d.next(),g.push([D.Mid,$]),$=$.mid;else break}if($){if(a?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const i=this.f($.right);if(i.key){const{key:o,value:n,segment:t}=i;this.e(i.key,!1),$.key=o,$.value=n,$.segment=t}}else{const i=$.left??$.right;if(g.length>0){const[o,n]=g[g.length-1];switch(o){case D.Left:n.left=i;break;case D.Mid:n.mid=i;break;case D.Right:n.right=i;break}}else this.c=i}for(let i=g.length-1;i>=0;i--){const o=g[i][1];o.updateHeight();const n=o.balanceFactor();if(n>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),g[i][1]=o.rotateLeft()):n<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),g[i][1]=o.rotateRight()),i>0)switch(g[i-1][0]){case D.Left:g[i-1][1].left=g[i][1];break;case D.Right:g[i-1][1].right=g[i][1];break;case D.Mid:g[i-1][1].mid=g[i][1];break}else this.c=g[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const a=this.b.reset(w);let d=this.c,g;for(;d;){const $=a.cmp(d.segment);if($>0)d=d.left;else if($<0)d=d.right;else if(a.hasNext())a.next(),g=d.value||g,d=d.mid;else break}return d&&d.value||g}findSuperstr(w){return this.g(w,!1)}g(w,a){const d=this.b.reset(w);let g=this.c;for(;g;){const $=d.cmp(g.segment);if($>0)g=g.left;else if($<0)g=g.right;else if(d.hasNext())d.next(),g=g.mid;else return g.mid?this.h(g.mid):a?g.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[a,d]of this)w(d,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const a=[];return this.j(w,a),a[Symbol.iterator]()}j(w,a){w&&(w.left&&this.j(w.left,a),w.value&&a.push([w.key,w.value]),w.mid&&this.j(w.mid,a),w.right&&this.j(w.right,a))}_isBalanced(){const w=a=>{if(!a)return!0;const d=a.balanceFactor();return d<-1||d>1?!1:w(a.left)&&w(a.right)};return w(this.c)}}e.$Gi=f}),define(Ee[2],Se([1,0,27,41,16,11]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=d,e.$wc=t;const L=/^\w[\w\d+.-]*$/,R=/^\//,p=/^\/\//;function l(y,S){if(!y.scheme&&S)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${y.authority}", path: "${y.path}", query: "${y.query}", fragment: "${y.fragment}"}`);if(y.scheme&&!L.test(y.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(y.path){if(y.authority){if(!R.test(y.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(y.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(y,S){return!y&&!S?"file":y}function D(y,S){switch(y){case"https":case"http":case"file":S?S[0]!==A&&(S=A+S):S=A;break}return S}const f="",A="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(S){return S instanceof a?!0:S?typeof S.authority=="string"&&typeof S.fragment=="string"&&typeof S.path=="string"&&typeof S.query=="string"&&typeof S.scheme=="string"&&typeof S.fsPath=="string"&&typeof S.with=="function"&&typeof S.toString=="function":!1}constructor(S,E,k,C,v,b=!1){typeof S=="object"?(this.scheme=S.scheme||f,this.authority=S.authority||f,this.path=S.path||f,this.query=S.query||f,this.fragment=S.fragment||f):(this.scheme=I(S,b),this.authority=E||f,this.path=D(this.scheme,k||f),this.query=C||f,this.fragment=v||f,l(this,b))}get fsPath(){return t(this,!1)}with(S){if(!S)return this;let{scheme:E,authority:k,path:C,query:v,fragment:b}=S;return E===void 0?E=this.scheme:E===null&&(E=f),k===void 0?k=this.authority:k===null&&(k=f),C===void 0?C=this.path:C===null&&(C=f),v===void 0?v=this.query:v===null&&(v=f),b===void 0?b=this.fragment:b===null&&(b=f),E===this.scheme&&k===this.authority&&C===this.path&&v===this.query&&b===this.fragment?this:new $(E,k,C,v,b)}static parse(S,E=!1){const k=w.exec(S);return k?new $(k[2]||f,m(k[4]||f),m(k[5]||f),m(k[7]||f),m(k[9]||f),E):new $(f,f,f,f,f)}static file(S){let E=f;if(T.$c&&(S=S.replace(/\\/g,A)),S[0]===A&&S[1]===A){const k=S.indexOf(A,2);k===-1?(E=S.substring(2),S=A):(E=S.substring(2,k),S=S.substring(k)||A)}return new $("file",E,S,f,f)}static from(S,E){return new $(S.scheme,S.authority,S.path,S.query,S.fragment,E)}static joinPath(S,...E){if(!S.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return T.$c&&S.scheme==="file"?k=a.file(P.$fc.join(t(S,!0),...E)).path:k=P.$gc.join(S.path,...E),S.with({path:k})}toString(S=!1){return c(this,S)}toJSON(){return this}static revive(S){if(S){if(S instanceof a)return S;{const E=new $(S);return E._formatted=S.external??null,E._fsPath=S._sep===g?S.fsPath??null:null,E}}else return S}}e.URI=a;function d(y){return!y||typeof y!="object"?!1:typeof y.scheme=="string"&&(typeof y.authority=="string"||typeof y.authority>"u")&&(typeof y.path=="string"||typeof y.path>"u")&&(typeof y.query=="string"||typeof y.query>"u")&&(typeof y.fragment=="string"||typeof y.fragment>"u")}const g=T.$c?1:void 0;class $ extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=t(this,!1)),this._fsPath}toString(S=!1){return S?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const S={$mid:u.MarshalledId.Uri};return this._fsPath&&(S.fsPath=this._fsPath,S._sep=g),this._formatted&&(S.external=this._formatted),this.path&&(S.path=this.path),this.scheme&&(S.scheme=this.scheme),this.authority&&(S.authority=this.authority),this.query&&(S.query=this.query),this.fragment&&(S.fragment=this.fragment),S}}const i={[r.CharCode.Colon]:"%3A",[r.CharCode.Slash]:"%2F",[r.CharCode.QuestionMark]:"%3F",[r.CharCode.Hash]:"%23",[r.CharCode.OpenSquareBracket]:"%5B",[r.CharCode.CloseSquareBracket]:"%5D",[r.CharCode.AtSign]:"%40",[r.CharCode.ExclamationMark]:"%21",[r.CharCode.DollarSign]:"%24",[r.CharCode.Ampersand]:"%26",[r.CharCode.SingleQuote]:"%27",[r.CharCode.OpenParen]:"%28",[r.CharCode.CloseParen]:"%29",[r.CharCode.Asterisk]:"%2A",[r.CharCode.Plus]:"%2B",[r.CharCode.Comma]:"%2C",[r.CharCode.Semicolon]:"%3B",[r.CharCode.Equals]:"%3D",[r.CharCode.Space]:"%20"};function o(y,S,E){let k,C=-1;for(let v=0;v<y.length;v++){const b=y.charCodeAt(v);if(b>=r.CharCode.a&&b<=r.CharCode.z||b>=r.CharCode.A&&b<=r.CharCode.Z||b>=r.CharCode.Digit0&&b<=r.CharCode.Digit9||b===r.CharCode.Dash||b===r.CharCode.Period||b===r.CharCode.Underline||b===r.CharCode.Tilde||S&&b===r.CharCode.Slash||E&&b===r.CharCode.OpenSquareBracket||E&&b===r.CharCode.CloseSquareBracket||E&&b===r.CharCode.Colon)C!==-1&&(k+=encodeURIComponent(y.substring(C,v)),C=-1),k!==void 0&&(k+=y.charAt(v));else{k===void 0&&(k=y.substr(0,v));const O=i[b];O!==void 0?(C!==-1&&(k+=encodeURIComponent(y.substring(C,v)),C=-1),k+=O):C===-1&&(C=v)}}return C!==-1&&(k+=encodeURIComponent(y.substring(C))),k!==void 0?k:y}function n(y){let S;for(let E=0;E<y.length;E++){const k=y.charCodeAt(E);k===r.CharCode.Hash||k===r.CharCode.QuestionMark?(S===void 0&&(S=y.substr(0,E)),S+=i[k]):S!==void 0&&(S+=y[E])}return S!==void 0?S:y}function t(y,S){let E;return y.authority&&y.path.length>1&&y.scheme==="file"?E=`//${y.authority}${y.path}`:y.path.charCodeAt(0)===r.CharCode.Slash&&(y.path.charCodeAt(1)>=r.CharCode.A&&y.path.charCodeAt(1)<=r.CharCode.Z||y.path.charCodeAt(1)>=r.CharCode.a&&y.path.charCodeAt(1)<=r.CharCode.z)&&y.path.charCodeAt(2)===r.CharCode.Colon?S?E=y.path.substr(1):E=y.path[1].toLowerCase()+y.path.substr(2):E=y.path,T.$c&&(E=E.replace(/\//g,"\\")),E}function c(y,S){const E=S?n:o;let k="",{scheme:C,authority:v,path:b,query:O,fragment:U}=y;if(C&&(k+=C,k+=":"),(v||C==="file")&&(k+=A,k+=A),v){let z=v.indexOf("@");if(z!==-1){const j=v.substr(0,z);v=v.substr(z+1),z=j.lastIndexOf(":"),z===-1?k+=E(j,!1,!1):(k+=E(j.substr(0,z),!1,!1),k+=":",k+=E(j.substr(z+1),!1,!0)),k+="@"}v=v.toLowerCase(),z=v.lastIndexOf(":"),z===-1?k+=E(v,!1,!0):(k+=E(v.substr(0,z),!1,!0),k+=v.substr(z))}if(b){if(b.length>=3&&b.charCodeAt(0)===r.CharCode.Slash&&b.charCodeAt(2)===r.CharCode.Colon){const z=b.charCodeAt(1);z>=r.CharCode.A&&z<=r.CharCode.Z&&(b=`/${String.fromCharCode(z+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===r.CharCode.Colon){const z=b.charCodeAt(0);z>=r.CharCode.A&&z<=r.CharCode.Z&&(b=`${String.fromCharCode(z+32)}:${b.substr(2)}`)}k+=E(b,!0,!1)}return O&&(k+="?",k+=E(O,!1,!1)),U&&(k+="#",k+=S?U:o(U,!1,!1)),k}function h(y){try{return decodeURIComponent(y)}catch{return y.length>3?y.substr(0,3)+h(y.substr(3)):y}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function m(y){return y.match(s)?y.replace(s,S=>h(S)):y}}),define(Ee[186],Se([1,0,2]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=u,e.$6q=P,e.$7q=T,e.log=R;function u(l){const I=l;return I&&typeof I.type=="string"&&typeof I.severity=="string"}function P(l){const I=[];let D;try{const f=JSON.parse(l.arguments),A=f[f.length-1];A&&A.__$stack&&(f.pop(),D=A.__$stack),I.push(...f)}catch{I.push("Unable to log remote console arguments",l.arguments)}return{args:I,stack:D}}function T(l){if(typeof l!="string")return T(P(l).stack);const I=l;if(I){const D=L(I),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if(f&&f.length===4)return{uri:r.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}function L(l){if(!l)return l;const I=l.indexOf(`
`);return I===-1?l:l.substring(0,I)}function R(l,I){const{args:D,stack:f}=P(l),A=typeof D[0]=="string"&&D.length===1;let w=L(f);w&&(w=`(${w.trim()})`);let a=[];if(typeof D[0]=="string"?w&&A?a=[`%c[${I}] %c${D[0]} %c${w}`,p("blue"),p(""),p("grey")]:a=[`%c[${I}] %c${D[0]}`,p("blue"),p(""),...D.slice(1)]:a=[`%c[${I}]%`,p("blue"),...D],w&&!A&&a.push(w),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,a)}function p(l){return`color: ${l}`}}),define(Ee[55],Se([1,0,22,2,41]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=T,e.$9h=L,e.$0h=p;function T(l){return JSON.stringify(l,R)}function L(l){let I=JSON.parse(l);return I=p(I),I}function R(l,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function p(l,I=0){if(!l||I>200)return l;if(typeof l=="object"){switch(l.$mid){case P.MarshalledId.Uri:return u.URI.revive(l);case P.MarshalledId.Regexp:return new RegExp(l.source,l.flags);case P.MarshalledId.Date:return new Date(l.source)}if(l instanceof r.$Je||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let D=0;D<l.length;++D)l[D]=p(l[D],I+1);else for(const D in l)Object.hasOwnProperty.call(l,D)&&(l[D]=p(l[D],I+1))}return l}}),define(Ee[15],Se([1,0,14,11,13,2,16]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=p,e.$Kg=l,e.$Og=D;var R;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatCodeBlock="vscode-chat-code-block",w.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",w.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm",w.commentsInput="comment",w.codeSetting="code-setting"})(R||(e.Schemas=R={}));function p(w,a){return T.URI.isUri(w)?(0,P.$Bf)(w.scheme,a):(0,P.$Cf)(w,a+":")}function l(w,...a){return a.some(d=>p(w,d))}e.$Lg="vscode-tkn",e.$Mg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,d){this.f=D(a,d)}getServerRootPath(){return this.f}get g(){return L.$gc.join(this.f,R.vscodeRemoteResource)}set(a,d,g){this.a[a]=d,this.b[a]=g}setConnectionToken(a,d){this.c[a]=d}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(n){return r.$1(n),a}const d=a.authority;let g=this.a[d];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const $=this.b[d],i=this.c[d];let o=`path=${encodeURIComponent(a.path)}`;return typeof i=="string"&&(o+=`&${e.$Mg}=${encodeURIComponent(i)}`),T.URI.from({scheme:u.$i?this.d:R.vscodeRemoteResource,authority:`${g}:${$}`,path:u.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:o})}}e.$Ng=new I;function D(w,a){return L.$gc.join(a??"/",`${w.quality??"oss"}-${w.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class f{asBrowserUri(a){const d=this.b(a,oe);return this.uriToBrowserUri(d)}uriToBrowserUri(a){return a.scheme===R.vscodeRemote?e.$Ng.rewrite(a):a.scheme===R.file&&(u.$g||u.$k===`${R.vscodeFileResource}://${f.a}`)?a.with({scheme:R.vscodeFileResource,authority:a.authority||f.a,query:null,fragment:null}):a}asFileUri(a){const d=this.b(a,oe);return this.uriToFileUri(d)}uriToFileUri(a){return a.scheme===R.vscodeFileResource?a.with({scheme:R.file,authority:a.authority!==f.a?a.authority:null,query:null,fragment:null}):a}b(a,d){return T.URI.isUri(a)?a:T.URI.parse(d.toUrl(a))}}f.a=e.$Tg,e.$Ug=new f;var A;(function(w){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(a.get("3"));const d="vscode-coi";function g(i){let o;typeof i=="string"?o=new URL(i).searchParams:i instanceof URL?o=i.searchParams:T.URI.isUri(i)&&(o=new URL(i.toString(!0)).searchParams);const n=o?.get(d);if(n)return a.get(n)}w.getHeadersFromQuery=g;function $(i,o,n){if(!globalThis.crossOriginIsolated)return;const t=o&&n?"3":n?"2":"1";i instanceof URLSearchParams?i.set(d,t):i[d]=t}w.addSearchParam=$})(A||(e.COI=A={}))}),define(Ee[187],Se([1,0,173,15,11,2]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hE=I;class L{constructor(f,A,w){this.id=f,this.dependencies=A,this.callback=w}}class R{constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(f,A,w)=>{typeof f!="string"&&(w=A,A=f,f=null),(typeof A!="object"||!Array.isArray(A))&&(w=A,A=null),this.c.push(new L(f,A,w))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){if(f.startsWith(window.location.origin)||f.startsWith("vscode-file://vscode-app"))return f;throw new Error(`[trusted_script_src] Invalid script url: ${f}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(f){return f}})))}async load(f){this.g();const A=await(this.a?this.i(f):this.b?this.h(f):this.j(f));if(!A)throw new Error(`Did not receive a define call from script ${f}`);if(Array.isArray(A.dependencies)&&A.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${f}. The dependencies are: ${A.dependencies.join(", ")}`);return typeof A.callback=="function"?A.callback([]):A.callback}h(f){return new Promise((A,w)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const d=()=>{a.removeEventListener("load",g),a.removeEventListener("error",$)},g=i=>{d(),A(this.c.pop())},$=i=>{d(),w(i)};a.addEventListener("load",g),a.addEventListener("error",$),this.f&&(f=this.f.createScriptURL(f)),a.setAttribute("src",f),window.document.getElementsByTagName("head")[0].appendChild(a)})}i(f){return new Promise((A,w)=>{try{this.f&&(f=this.f.createScriptURL(f)),importScripts(f),A(this.c.pop())}catch(a){w(a)}})}async j(f){try{const A=globalThis._VSCODE_NODE_MODULES.fs,w=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,d=T.URI.parse(f).fsPath,g=A.readFileSync(d).toString(),$=a.wrap(g.replace(/^#!.*/,""));return new w.Script($).runInThisContext().apply(),this.c.pop()}catch(A){throw A}}}R.INSTANCE=new R;const p=new Map;let l={};typeof globalThis.require=="object"&&(l=globalThis.require.paths??{});async function I(D,f,A){if(r.$T){A===void 0&&(A=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),l[D]&&(D=l[D]);const w=`${D}/${f}`;if(p.has(w))return p.get(w);let a;if(/^\w[\w\d+.-]*:\/\//.test(w))a=w;else{const i=`${A&&!P.$i?u.$Rg:u.$Qg}/${w}`;a=u.$Ug.asBrowserUri(i).toString(!0)}const d=R.INSTANCE.load(a);return p.set(w,d),d}else return await new Promise((w,a)=>{oe([D],w,a)})}}),define(Ee[23],Se([1,0,27,32,15,16,11,13,2]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=l,e.$kh=D,e.$lh=A;function l(w){return(0,p.$wc)(w,!0)}class I{constructor(a){this.a=a}compare(a,d,g=!1){return a===d?0:(0,R.$uf)(this.getComparisonKey(a,g),this.getComparisonKey(d,g))}isEqual(a,d,g=!1){return a===d?!0:!a||!d?!1:this.getComparisonKey(a,g)===this.getComparisonKey(d,g)}getComparisonKey(a,d=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,d,g=!1){if(a.scheme===d.scheme){if(a.scheme===P.Schemas.file)return u.$zg(l(a),l(d),this.a(a))&&a.query===d.query&&(g||a.fragment===d.fragment);if((0,e.$gh)(a.authority,d.authority))return u.$zg(a.path,d.path,this.a(a),"/")&&a.query===d.query&&(g||a.fragment===d.fragment)}return!1}joinPath(a,...d){return p.URI.joinPath(a,...d)}basenameOrAuthority(a){return(0,e.$$g)(a)||a.authority}basename(a){return T.$gc.basename(a.path)}extname(a){return T.$gc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let d;return a.scheme===P.Schemas.file?d=p.URI.file(T.$mc(l(a))).path:(d=T.$gc.dirname(a.path),a.authority&&d.length&&d.charCodeAt(0)!==r.CharCode.Slash&&(console.error(`dirname("${a.toString})) resulted in a relative path`),d="/")),a.with({path:d})}normalizePath(a){if(!a.path.length)return a;let d;return a.scheme===P.Schemas.file?d=p.URI.file(T.$hc(l(a))).path:d=T.$gc.normalize(a.path),a.with({path:d})}relativePath(a,d){if(a.scheme!==d.scheme||!(0,e.$gh)(a.authority,d.authority))return;if(a.scheme===P.Schemas.file){const i=T.$lc(l(a),l(d));return L.$c?u.$tg(i):i}let g=a.path||"/";const $=d.path||"/";if(this.a(a)){let i=0;for(const o=Math.min(g.length,$.length);i<o&&!(g.charCodeAt(i)!==$.charCodeAt(i)&&g.charAt(i).toLowerCase()!==$.charAt(i).toLowerCase());i++);g=$.substr(0,i)+g.substr(i)}return T.$gc.relative(g,$)}resolvePath(a,d){if(a.scheme===P.Schemas.file){const g=p.URI.file(T.$kc(l(a),d));return a.with({authority:g.authority,path:g.path})}return d=u.$ug(d),a.with({path:T.$gc.resolve(a.path,d)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,d){return a===d||a!==void 0&&d!==void 0&&(0,R.$Bf)(a,d)}hasTrailingPathSeparator(a,d=T.sep){if(a.scheme===P.Schemas.file){const g=l(a);return g.length>u.$vg(g).length&&g[g.length-1]===d}else{const g=a.path;return g.length>1&&g.charCodeAt(g.length-1)===r.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,d=T.sep){return(0,e.$hh)(a,d)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,d=T.sep){let g=!1;if(a.scheme===P.Schemas.file){const $=l(a);g=$!==void 0&&$.length===u.$vg($).length&&$[$.length-1]===d}else{d="/";const $=a.path;g=$.length===1&&$.charCodeAt($.length-1)===r.CharCode.Slash}return!g&&!(0,e.$hh)(a,d)?a.with({path:a.path+"/"}):a}}e.$3g=I,e.$4g=new I(()=>!1),e.$5g=new I(w=>w.scheme===P.Schemas.file?!L.$e:!0),e.$6g=new I(w=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function D(w,a){const d=[];for(let g=0;g<w.length;g++){const $=a(w[g]);w.some((i,o)=>o===g?!1:(0,e.$8g)($,a(i)))||d.push(w[g])}return d}var f;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function a(d){const g=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(o=>{const[n,t]=o.split(":");n&&t&&g.set(n,t)});const i=d.path.substring(0,d.path.indexOf(";"));return i&&g.set(w.META_DATA_MIME,i),g}w.parseMetaData=a})(f||(e.DataUri=f={}));function A(w,a,d){if(a){let g=w.path;return g&&g[0]!==T.$gc.sep&&(g=T.$gc.sep+g),w.with({scheme:d,authority:a,path:g})}return w.with({scheme:d})}}),define(Ee[7],Se([1,0,21,14,4,3,23,11,184,49]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=I,e.$nh=D,e.$oh=f,e.$ph=A,e.$qh=w,e.$rh=a,e.$sh=d,e.$th=g,e.$Bh=y,e.$Ch=S,e.$Dh=E,e.$Eh=k,e.$Fh=C,e.$Uh=H,e.$3h=ee;function I(le){return!!le&&typeof le.then=="function"}function D(le){const Z=new r.$se,ae=le(Z.token),$e=new Promise((be,Me)=>{const qe=Z.token.onCancellationRequested(()=>{qe.dispose(),Me(new u.$5)});Promise.resolve(ae).then(De=>{qe.dispose(),Z.dispose(),be(De)},De=>{qe.dispose(),Z.dispose(),Me(De)})});return new class{cancel(){Z.cancel(),Z.dispose()}then(be,Me){return $e.then(be,Me)}catch(be){return this.then(void 0,be)}finally(be){return $e.finally(be)}}}function f(le,Z,ae){return new Promise(($e,be)=>{const Me=Z.onCancellationRequested(()=>{Me.dispose(),$e(ae)});le.then($e,be).finally(()=>Me.dispose())})}function A(le,Z){return new Promise((ae,$e)=>{const be=Z.onCancellationRequested(()=>{be.dispose(),$e(new u.$5)});le.then(ae,$e).finally(()=>be.dispose())})}async function w(le){let Z=-1;const ae=le.map(($e,be)=>$e.then(Me=>(Z=be,Me)));try{return await Promise.race(ae)}finally{le.forEach(($e,be)=>{be!==Z&&$e.cancel()})}}function a(le,Z,ae){let $e;const be=setTimeout(()=>{$e?.(void 0),ae?.()},Z);return Promise.race([le.finally(()=>clearTimeout(be)),new Promise(Me=>$e=Me)])}function d(le){return new Promise((Z,ae)=>{const $e=le();I($e)?$e.then(Z,ae):Z($e)})}function g(){let le,Z;return{promise:new Promise(($e,be)=>{le=$e,Z=be}),resolve:le,reject:Z}}class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Z){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Z,!this.b){const ae=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(ae,ae).then($e)})}return new Promise((ae,$e)=>{this.b.then(ae,$e)})}return this.a=Z(),new Promise((ae,$e)=>{this.a.then(be=>{this.a=null,ae(be)},be=>{this.a=null,$e(be)})})}dispose(){this.f=!0}}e.$uh=$;class i{constructor(){this.a=Promise.resolve(null)}queue(Z){return this.a=this.a.then(()=>Z(),()=>Z())}}e.$vh=i;class o{constructor(){this.a=new Map}queue(Z,ae){const be=(this.a.get(Z)??Promise.resolve()).catch(()=>{}).then(ae).finally(()=>{this.a.get(Z)===be&&this.a.delete(Z)});return this.a.set(Z,be),be}}e.$wh=o;const n=(le,Z)=>{let ae=!0;const $e=setTimeout(()=>{ae=!1,Z()},le);return{isTriggered:()=>ae,dispose:()=>{clearTimeout($e),ae=!1}}},t=le=>{let Z=!0;return queueMicrotask(()=>{Z&&(Z=!1,le())}),{isTriggered:()=>Z,dispose:()=>{Z=!1}}};class c{constructor(Z){this.defaultDelay=Z,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Z,ae=this.defaultDelay){this.g=Z,this.h(),this.b||(this.b=new Promise((be,Me)=>{this.d=be,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const be=this.g;return this.g=null,be()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=ae===p.$ce?t($e):n(ae,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new u.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=c;class h{constructor(Z){this.a=new c(Z),this.b=new $}trigger(Z,ae){return this.a.trigger(()=>this.b.queue(Z),ae)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=h;class s{constructor(){this.a=!1,this.b=new Promise((Z,ae)=>{this.d=Z})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=s;class m extends s{constructor(Z){super(),this.f=setTimeout(()=>this.open(),Z)}open(){clearTimeout(this.f),super.open()}}e.$Ah=m;function y(le,Z){return Z?new Promise((ae,$e)=>{const be=setTimeout(()=>{Me.dispose(),ae()},le),Me=Z.onCancellationRequested(()=>{clearTimeout(be),Me.dispose(),$e(new u.$5)})}):D(ae=>y(le,ae))}function S(le,Z=0,ae){const $e=setTimeout(()=>{le(),ae&&be.dispose()},Z),be=(0,T.$Sc)(()=>{clearTimeout($e),ae?.deleteAndLeak(be)});return ae?.add(be),be}function E(le){const Z=[];let ae=0;const $e=le.length;function be(){return ae<$e?le[ae++]():null}function Me(qe){qe!=null&&Z.push(qe);const De=be();return De?De.then(Me):Promise.resolve(Z)}return Promise.resolve(null).then(Me)}function k(le,Z=$e=>!!$e,ae=null){let $e=0;const be=le.length,Me=()=>{if($e>=be)return Promise.resolve(ae);const qe=le[$e++];return Promise.resolve(qe()).then(Pe=>Z(Pe)?Promise.resolve(Pe):Me())};return Me()}function C(le,Z=$e=>!!$e,ae=null){if(le.length===0)return Promise.resolve(ae);let $e=le.length;const be=()=>{$e=-1;for(const Me of le)Me.cancel?.()};return new Promise((Me,qe)=>{for(const De of le)De.then(Pe=>{--$e>=0&&Z(Pe)?(be(),Me(Pe)):$e===0&&Me(ae)}).catch(Pe=>{--$e>=0&&(be(),qe(Pe))})})}class v{constructor(Z){this.a=0,this.b=!1,this.f=Z,this.g=[],this.d=0,this.h=new P.$he}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Z){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ae,$e)=>{this.g.push({factory:Z,c:ae,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Z=this.g.shift();this.d++;const ae=Z.factory();ae.then(Z.c,Z.e),ae.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=v;class b extends v{constructor(){super(1)}}e.$Hh=b;class O{constructor(){this.a=new V,this.b=0}queue(Z){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Z())):this.a.run(this.b++,Z())}}e.$Ih=O;class U{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Z=new ne;return this.b.add(Z),Z.p}g(){for(const[,Z]of this.a)if(Z.size>0)return!1;return!0}queueSize(Z,ae=L.$4g){const $e=ae.getComparisonKey(Z);return this.a.get($e)?.size??0}queueFor(Z,ae,$e=L.$4g){const be=$e.getComparisonKey(Z);let Me=this.a.get(be);if(!Me){Me=new b;const qe=this.f++,De=P.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(be),this.h(),this.d?.deleteAndDispose(qe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$4c),this.d.set(qe,De),this.a.set(be,Me)}return Me.queue(ae)}h(){this.g()&&this.j()}j(){for(const Z of this.b)Z.complete();this.b.clear()}dispose(){for(const[,Z]of this.a)Z.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=U;class z{constructor(Z,ae){this.b=!1,this.a=-1,typeof Z=="function"&&typeof ae=="number"&&this.setIfNotSet(Z,ae)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Z,ae){if(this.b)throw new u.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,Z()},ae)}setIfNotSet(Z,ae){if(this.b)throw new u.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Z()},ae))}}e.$Kh=z;class j{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Z,ae,$e=globalThis){if(this.f)throw new u.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const be=$e.setInterval(()=>{Z()},ae);this.d=(0,T.$Sc)(()=>{$e.clearInterval(be),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=j;class M{constructor(Z,ae){this.b=-1,this.a=Z,this.d=ae,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Z=this.d){this.cancel(),this.b=setTimeout(this.f,Z)}get delay(){return this.d}set delay(Z){this.d=Z}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=M;class N{constructor(Z,ae){ae%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ae}ms is not a multiple of 1000ms.`),this.a=Z,this.b=ae,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Z=this.b){Z%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Z}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Z/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=N;class F extends M{constructor(Z,ae){super(Z,ae),this.j=[]}work(Z){this.j.push(Z),this.isScheduled()||this.schedule()}h(){const Z=this.j;this.j=[],this.a?.(Z)}dispose(){this.j=[],super.dispose()}}e.$Oh=F;class X extends T.$Uc{constructor(Z,ae){super(),this.g=Z,this.h=ae,this.a=[],this.b=this.B(new T.$Vc),this.f=!1}get pending(){return this.a.length}work(Z){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Z.length>this.g.maxBufferedWork)return!1}else if(this.pending+Z.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ae of Z)this.a.push(ae);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new M(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(le,Z)=>{(0,R.$v)(()=>{if(ae)return;const $e=Date.now()+15;Z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let ae=!1;return{dispose(){ae||(ae=!0)}}}:e.$Rh=(le,Z,ae)=>{const $e=le.requestIdleCallback(Z,typeof ae=="number"?{timeout:ae}:void 0);let be=!1;return{dispose(){be||(be=!0,le.cancelIdleCallback($e))}}},e.$Qh=le=>(0,e.$Rh)(globalThis,le)}();class se{constructor(Z,ae){this.g=!1,this.d=()=>{try{this.j=ae()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Rh)(Z,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=se;class W extends se{constructor(Z){super(globalThis,Z)}}e.$Th=W;async function H(le,Z,ae){let $e;for(let be=0;be<ae;be++)try{return await le()}catch(Me){$e=Me,await y(Z)}throw $e}class V{isRunning(Z){return typeof Z=="number"?this.a?.taskId===Z:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Z,ae,$e){return this.a={taskId:Z,cancel:()=>$e?.(),promise:ae},ae.then(()=>this.d(Z),()=>this.d(Z)),ae}d(Z){this.a&&Z===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Z=this.b;this.b=void 0,Z.run().then(Z.promiseResolve,Z.promiseReject)}}queue(Z){if(this.b)this.b.run=Z;else{const{promise:ae,resolve:$e,reject:be}=g();this.b={run:Z,promise:ae,promiseResolve:$e,promiseReject:be}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=V;class x{constructor(Z,ae=()=>Date.now()){this.d=Z,this.f=ae,this.a=0,this.b=0}increment(){const Z=this.f();return Z-this.a>this.d&&(this.a=Z,this.b=0),this.b++,this.b}}e.$Wh=x;var he;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(he||(he={}));class ne{get isRejected(){return this.d?.outcome===he.Rejected}get isResolved(){return this.d?.outcome===he.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===he.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((Z,ae)=>{this.a=Z,this.b=ae})}complete(Z){return new Promise(ae=>{this.a(Z),this.d={outcome:he.Resolved,value:Z},ae()})}error(Z){return new Promise(ae=>{this.b(Z),this.d={outcome:he.Rejected,value:Z},ae()})}cancel(){return this.error(new u.$5)}}e.$Xh=ne;var we;(function(le){async function Z($e){let be;const Me=await Promise.all($e.map(qe=>qe.then(De=>De,De=>{be||(be=De)})));if(typeof be<"u")throw be;return Me}le.settled=Z;function ae($e){return new Promise(async(be,Me)=>{try{await $e(be,Me)}catch(qe){Me(qe)}})}le.withAsyncBody=ae})(we||(e.Promises=we={}));class pe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Z){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Z.then(ae=>(this.a=ae,this.d=!0,ae),ae=>{throw this.b=ae,this.d=!0,ae})}requireValue(){if(!this.d)throw new u.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=pe;class ce{constructor(Z){this.b=Z,this.a=new l.$V(()=>new pe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=ce;var K;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(K||(K={}));class de{static fromArray(Z){return new de(ae=>{ae.emitMany(Z)})}static fromPromise(Z){return new de(async ae=>{ae.emitMany(await Z)})}static fromPromises(Z){return new de(async ae=>{await Promise.all(Z.map(async $e=>ae.emitOne(await $e)))})}static merge(Z){return new de(async ae=>{await Promise.all(Z.map(async $e=>{for await(const be of $e)ae.emitOne(be)}))})}constructor(Z,ae){this.a=K.Initial,this.b=[],this.d=null,this.f=ae,this.g=new P.$he,queueMicrotask(async()=>{const $e={emitOne:be=>this.h(be),emitMany:be=>this.j(be),reject:be=>this.l(be)};try{await Promise.resolve(Z($e)),this.k()}catch(be){this.l(be)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let Z=0;return{next:async()=>{do{if(this.a===K.DoneError)throw this.d;if(Z<this.b.length)return{done:!1,value:this.b[Z++]};if(this.a===K.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Z,ae){return new de(async $e=>{for await(const be of Z)$e.emitOne(ae(be))})}map(Z){return de.map(this,Z)}static filter(Z,ae){return new de(async $e=>{for await(const be of Z)ae(be)&&$e.emitOne(be)})}filter(Z){return de.filter(this,Z)}static coalesce(Z){return de.filter(Z,ae=>!!ae)}coalesce(){return de.coalesce(this)}static async toPromise(Z){const ae=[];for await(const $e of Z)ae.push($e);return ae}toPromise(){return de.toPromise(this)}h(Z){this.a===K.Initial&&(this.b.push(Z),this.g.fire())}j(Z){this.a===K.Initial&&(this.b=this.b.concat(Z),this.g.fire())}k(){this.a===K.Initial&&(this.a=K.DoneOK,this.g.fire())}l(Z){this.a===K.Initial&&(this.a=K.DoneError,this.d=Z,this.g.fire())}}e.$1h=de,de.EMPTY=de.fromArray([]);class te extends de{constructor(Z,ae){super(ae),this.m=Z}cancel(){this.m.cancel()}}e.$2h=te;function ee(le){const Z=new r.$se,ae=le(Z.token);return new te(Z,async $e=>{const be=Z.token.onCancellationRequested(()=>{be.dispose(),Z.dispose(),$e.reject(new u.$5)});try{for await(const Me of ae){if(Z.token.isCancellationRequested)return;$e.emitOne(Me)}be.dispose(),Z.dispose()}catch(Me){be.dispose(),Z.dispose(),$e.reject(Me)}})}class ie{constructor(Z){this.a=new ne,this.b=new de(be=>{if(ae){be.reject(ae);return}return $e&&be.emitMany($e),this.d=Me=>be.reject(Me),this.f=Me=>be.emitOne(Me),this.a.p},Z);let ae,$e;this.f=be=>{$e||($e=[]),$e.push(be)},this.d=be=>{ae||(ae=be)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Z){this.d(Z),this.a.complete()}emitOne(Z){this.f(Z)}}e.$4h=ie}),define(Ee[39],Se([1,0,19,7,27,32,29,16,11,13]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=I,e.$sk=a,e.$tk=O,e.$uk=U,e.$vk=z,e.$wk=j,e.$xk=M,e.$yk=se;function I(){return Object.create(null)}e.$qk="**",e.$rk="/";const D="[/\\\\]",f="[^/\\\\]",A=/\//g;function w(W,H){switch(W){case 0:return"";case 1:return`${f}*?`;default:return`(?:${D}|${f}+${D}${H?`|${D}${f}+`:""})*?`}}function a(W,H){if(!W)return[];const V=[];let x=!1,he=!1,ne="";for(const we of W){switch(we){case H:if(!x&&!he){V.push(ne),ne="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":he=!0;break;case"]":he=!1;break}ne+=we}return ne&&V.push(ne),V}function d(W){if(!W)return"";let H="";const V=a(W,e.$rk);if(V.every(x=>x===e.$qk))H=".*";else{let x=!1;V.forEach((he,ne)=>{if(he===e.$qk){if(x)return;H+=w(2,ne===V.length-1)}else{let we=!1,pe="",ce=!1,K="";for(const de of he){if(de!=="}"&&we){pe+=de;continue}if(ce&&(de!=="]"||!K)){let te;de==="-"?te=de:(de==="^"||de==="!")&&!K?te="^":de===e.$rk?te="":te=(0,l.$df)(de),K+=te;continue}switch(de){case"{":we=!0;continue;case"[":ce=!0;continue;case"}":{const ee=`(?:${a(pe,",").map(ie=>d(ie)).join("|")})`;H+=ee,we=!1,pe="";break}case"]":{H+="["+K+"]",ce=!1,K="";break}case"?":H+=f;continue;case"*":H+=w(1);continue;default:H+=(0,l.$df)(de)}}ne<V.length-1&&(V[ne+1]!==e.$qk||ne+2<V.length)&&(H+=D)}x=he===e.$qk})}return H}const g=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,t=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,c=new L.$Dc(1e4),h=function(){return!1},s=function(){return null};function m(W,H){if(!W)return s;let V;typeof W!="string"?V=W.pattern:V=W,V=V.trim();const x=`${V}_${!!H.trimForExclusions}`;let he=c.get(x);if(he)return y(he,W);let ne;return g.test(V)?he=E(V.substr(4),V):(ne=$.exec(S(V,H)))?he=k(ne[1],V):(H.trimForExclusions?o:i).test(V)?he=C(V,H):(ne=n.exec(S(V,H)))?he=v(ne[1].substr(1),V,!0):(ne=t.exec(S(V,H)))?he=v(ne[1],V,!1):he=b(V),c.set(x,he),y(he,W)}function y(W,H){if(typeof H=="string")return W;const V=function(x,he){return(0,T.$zg)(x,H.base,!p.$e)?W((0,l.$if)(x.substr(H.base.length),R.sep),he):null};return V.allBasenames=W.allBasenames,V.allPaths=W.allPaths,V.basenames=W.basenames,V.patterns=W.patterns,V}function S(W,H){return H.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function E(W,H){return function(V,x){return typeof V=="string"&&V.endsWith(W)?H:null}}function k(W,H){const V=`/${W}`,x=`\\${W}`,he=function(we,pe){return typeof we!="string"?null:pe?pe===W?H:null:we===W||we.endsWith(V)||we.endsWith(x)?H:null},ne=[W];return he.basenames=ne,he.patterns=[H],he.allBasenames=ne,he}function C(W,H){const V=X(W.slice(1,-1).split(",").map(pe=>m(pe,H)).filter(pe=>pe!==s),W),x=V.length;if(!x)return s;if(x===1)return V[0];const he=function(pe,ce){for(let K=0,de=V.length;K<de;K++)if(V[K](pe,ce))return W;return null},ne=V.find(pe=>!!pe.allBasenames);ne&&(he.allBasenames=ne.allBasenames);const we=V.reduce((pe,ce)=>ce.allPaths?pe.concat(ce.allPaths):pe,[]);return we.length&&(he.allPaths=we),he}function v(W,H,V){const x=R.sep===R.$gc.sep,he=x?W:W.replace(A,R.sep),ne=R.sep+he,we=R.$gc.sep+W;let pe;return V?pe=function(ce,K){return typeof ce=="string"&&(ce===he||ce.endsWith(ne)||!x&&(ce===W||ce.endsWith(we)))?H:null}:pe=function(ce,K){return typeof ce=="string"&&(ce===he||!x&&ce===W)?H:null},pe.allPaths=[(V?"*/":"./")+W],pe}function b(W){try{const H=new RegExp(`^${d(W)}$`);return function(V){return H.lastIndex=0,typeof V=="string"&&H.test(V)?W:null}}catch{return s}}function O(W,H,V){return!W||typeof H!="string"?!1:U(W)(H,void 0,V)}function U(W,H={}){if(!W)return h;if(typeof W=="string"||z(W)){const V=m(W,H);if(V===s)return h;const x=function(he,ne){return!!V(he,ne)};return V.allBasenames&&(x.allBasenames=V.allBasenames),V.allPaths&&(x.allPaths=V.allPaths),x}return N(W,H)}function z(W){const H=W;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}function j(W){return W.allBasenames||[]}function M(W){return W.allPaths||[]}function N(W,H){const V=X(Object.getOwnPropertyNames(W).map(pe=>F(pe,W[pe],H)).filter(pe=>pe!==s)),x=V.length;if(!x)return s;if(!V.some(pe=>!!pe.requiresSiblings)){if(x===1)return V[0];const pe=function(de,te){let ee;for(let ie=0,le=V.length;ie<le;ie++){const Z=V[ie](de,te);if(typeof Z=="string")return Z;(0,u.$mh)(Z)&&(ee||(ee=[]),ee.push(Z))}return ee?(async()=>{for(const ie of ee){const le=await ie;if(typeof le=="string")return le}return null})():null},ce=V.find(de=>!!de.allBasenames);ce&&(pe.allBasenames=ce.allBasenames);const K=V.reduce((de,te)=>te.allPaths?de.concat(te.allPaths):de,[]);return K.length&&(pe.allPaths=K),pe}const he=function(pe,ce,K){let de,te;for(let ee=0,ie=V.length;ee<ie;ee++){const le=V[ee];le.requiresSiblings&&K&&(ce||(ce=(0,R.$nc)(pe)),de||(de=ce.substr(0,ce.length-(0,R.$oc)(pe).length)));const Z=le(pe,ce,de,K);if(typeof Z=="string")return Z;(0,u.$mh)(Z)&&(te||(te=[]),te.push(Z))}return te?(async()=>{for(const ee of te){const ie=await ee;if(typeof ie=="string")return ie}return null})():null},ne=V.find(pe=>!!pe.allBasenames);ne&&(he.allBasenames=ne.allBasenames);const we=V.reduce((pe,ce)=>ce.allPaths?pe.concat(ce.allPaths):pe,[]);return we.length&&(he.allPaths=we),he}function F(W,H,V){if(H===!1)return s;const x=m(W,V);if(x===s)return s;if(typeof H=="boolean")return x;if(H){const he=H.when;if(typeof he=="string"){const ne=(we,pe,ce,K)=>{if(!K||!x(we,pe))return null;const de=he.replace("$(basename)",()=>ce),te=K(de);return(0,u.$mh)(te)?te.then(ee=>ee?W:null):te?W:null};return ne.requiresSiblings=!0,ne}}return x}function X(W,H){const V=W.filter(pe=>!!pe.basenames);if(V.length<2)return W;const x=V.reduce((pe,ce)=>{const K=ce.basenames;return K?pe.concat(K):pe},[]);let he;if(H){he=[];for(let pe=0,ce=x.length;pe<ce;pe++)he.push(H)}else he=V.reduce((pe,ce)=>{const K=ce.patterns;return K?pe.concat(K):pe},[]);const ne=function(pe,ce){if(typeof pe!="string")return null;if(!ce){let de;for(de=pe.length;de>0;de--){const te=pe.charCodeAt(de-1);if(te===P.CharCode.Slash||te===P.CharCode.Backslash)break}ce=pe.substr(de)}const K=x.indexOf(ce);return K!==-1?he[K]:null};ne.basenames=x,ne.patterns=he,ne.allBasenames=x;const we=W.filter(pe=>!pe.basenames);return we.push(ne),we}function se(W,H){return(0,r.$ub)(W,H,(V,x)=>typeof V=="string"&&typeof x=="string"?V===x:typeof V!="string"&&typeof x!="string"?V.base===x.base&&V.pattern===x.pattern:!1)}}),define(Ee[86],Se([1,0,14,138,23,13,2]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.MarkdownStringTextNewlineStyle=void 0,e.$Yk=l,e.$Zk=I,e.$1k=D,e.$2k=f,e.$3k=A,e.$4k=w,e.$5k=a,e.$6k=d;var R;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(R||(e.MarkdownStringTextNewlineStyle=R={}));class p{constructor($="",i=!1){if(this.value=$,typeof this.value!="string")throw(0,r.$7)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText($,i=R.Paragraph){return this.value+=f(this.supportThemeIcons?(0,u.$Rk)($):$).replace(/([ \t]+)/g,(o,n)=>"&nbsp;".repeat(n.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===R.Break?`\\
`:`

`),this}appendMarkdown($){return this.value+=$,this}appendCodeblock($,i){return this.value+=`
${A(i,$)}
`,this}appendLink($,i,o){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String($),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c($,i){const o=new RegExp((0,T.$df)(i),"g");return $.replace(o,(n,t)=>$.charAt(t-1)!=="\\"?`\\${n}`:n)}}e.$Xk=p;function l(g){return I(g)?!g.value:Array.isArray(g)?g.every(l):!0}function I(g){return g instanceof p?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||typeof g.isTrusted=="object"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}function D(g,$){return g===$?!0:!g||!$?!1:g.value===$.value&&g.isTrusted===$.isTrusted&&g.supportThemeIcons===$.supportThemeIcons&&g.supportHtml===$.supportHtml&&(g.baseUri===$.baseUri||!!g.baseUri&&!!$.baseUri&&(0,P.$7g)(L.URI.from(g.baseUri),L.URI.from($.baseUri)))}function f(g){return g.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function A(g,$){const i=g.match(/^`+/gm)?.reduce((n,t)=>n.length>t.length?n:t).length??0,o=i>=3?i+1:3;return[`${"`".repeat(o)}${$}`,g,`${"`".repeat(o)}`].join(`
`)}function w(g){return g.replace(/"/g,"&quot;")}function a(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function d(g){const $=[],i=g.split("|").map(n=>n.trim());g=i[0];const o=i[1];if(o){const n=/height=(\d+)/.exec(o),t=/width=(\d+)/.exec(o),c=n?n[1]:"",h=t?t[1]:"",s=isFinite(parseInt(h)),m=isFinite(parseInt(c));s&&$.push(`width="${h}"`),m&&$.push(`height="${c}"`)}return{href:g,dimensions:$}}}),define(Ee[107],Se([1,0,19,32,16,11,23,13]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=p,e.$Ow=I,e.$Pw=f,e.$Qw=A,e.$Rw=g,e.$Sw=i,e.$Tw=o,e.$Uw=n,e.$Vw=t,e.$Ww=c;function p(s,m){const{os:y,tildify:S,relative:E}=m;if(E){const v=l(s,E,y);if(typeof v=="string")return v}let k=s.fsPath;if(y===T.OperatingSystem.Windows&&!T.$c?k=k.replace(/\//g,"\\"):y!==T.OperatingSystem.Windows&&T.$c&&(k=k.replace(/\\/g,"/")),y!==T.OperatingSystem.Windows&&S?.userHome){const v=S.userHome.fsPath;let b;s.scheme!==S.userHome.scheme&&s.path[0]===P.$gc.sep&&s.path[1]!==P.$gc.sep?b=S.userHome.with({path:s.path}).fsPath:b=k,k=f(b,v,y)}return(y===T.OperatingSystem.Windows?P.$fc:P.$gc).normalize(I(k,y===T.OperatingSystem.Windows))}function l(s,m,y){const S=y===T.OperatingSystem.Windows?P.$fc:P.$gc,E=y===T.OperatingSystem.Linux?L.$4g:L.$6g,k=m.getWorkspace(),C=(0,r.$Ob)(k.folders);if(!C)return;s.scheme!==C.uri.scheme&&s.path[0]===P.$gc.sep&&s.path[1]!==P.$gc.sep&&(s=C.uri.with({path:s.path}));const v=m.getWorkspaceFolder(s);if(!v)return;let b;if(E.isEqual(v.uri,s)?b="":b=E.relativePath(v.uri,s)??"",b&&(b=S.normalize(b)),k.folders.length>1&&!m.noPrefix){const O=v.name?v.name:E.basenameOrAuthority(v.uri);b=b?`${O} \u2022 ${b}`:O}return b}function I(s,m=T.$c){return(0,u.$Eg)(s,m)?s.charAt(0).toUpperCase()+s.slice(1):s}let D=Object.create(null);function f(s,m,y=T.OS){if(y===T.OperatingSystem.Windows||!s||!m)return s;let S=D.original===m?D.normalized:void 0;S||(S=m,T.$c&&(S=(0,u.$tg)(S)),S=`${(0,R.$jf)(S,P.$gc.sep)}${P.$gc.sep}`,D={original:m,normalized:S});let E=s;return T.$c&&(E=(0,u.$tg)(E)),(y===T.OperatingSystem.Linux?E.startsWith(S):(0,R.$Cf)(E,S))?`~/${E.substr(S.length)}`:s}function A(s,m){return s.replace(/^~($|\/|\\)/,`${m}$1`)}const w="\u2026",a="\\\\",d="~";function g(s,m=P.sep){const y=new Array(s.length);let S=!1;for(let E=0;E<s.length;E++){const k=s[E];if(k===""){y[E]=`.${m}`;continue}if(!k){y[E]=k;continue}S=!0;let C="",v=k;v.indexOf(a)===0?(C=v.substr(0,v.indexOf(a)+a.length),v=v.substr(v.indexOf(a)+a.length)):v.indexOf(m)===0?(C=v.substr(0,v.indexOf(m)+m.length),v=v.substr(v.indexOf(m)+m.length)):v.indexOf(d)===0&&(C=v.substr(0,v.indexOf(d)+d.length),v=v.substr(v.indexOf(d)+d.length));const b=v.split(m);for(let O=1;S&&O<=b.length;O++)for(let U=b.length-O;S&&U>=0;U--){S=!1;let z=b.slice(U,U+O).join(m);for(let j=0;!S&&j<s.length;j++)if(j!==E&&s[j]&&s[j].indexOf(z)>-1){const M=U+O===b.length,N=U>0&&s[j].indexOf(m)>-1?m+z:z,F=s[j].endsWith(N);S=!M||F}if(!S){let j="";(b[0].endsWith(":")||C!=="")&&(U===1&&(U=0,O++,z=b[0]+m+z),U>0&&(j=b[0]+m),j=C+j),U>0&&(j=j+w+m),j=j+z,U+O<b.length&&(j=j+m+w),y[E]=j}}S&&(y[E]=k)}return y}var $;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})($||($={}));function i(s,m=Object.create(null)){const y=[];let S=!1,E="";for(const k of s)if(k==="$"||S&&k==="{")E&&y.push({value:E,type:$.TEXT}),E="",S=!0;else if(k==="}"&&S){const C=m[E];if(typeof C=="string")C.length&&y.push({value:C,type:$.VARIABLE});else if(C){const v=y[y.length-1];(!v||v.type!==$.SEPARATOR)&&y.push({value:C.label,type:$.SEPARATOR})}E="",S=!1}else E+=k;return E&&!S&&y.push({value:E,type:$.TEXT}),y.filter((k,C)=>{if(k.type===$.SEPARATOR){const v=y[C-1],b=y[C+1];return[v,b].every(O=>O&&(O.type===$.VARIABLE||O.type===$.TEXT)&&O.value.length>0)}return!0}).map(k=>k.value).join("")}function o(s,m){return T.$d||m?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$d?"&":"&&"):s.replace(/&&|&/g,y=>y==="&"?"&&":"&")}function n(s,m){return T.$d||m?s.replace(/\(&&\w\)|&&/g,""):T.$c?s.replace(/&&|&/g,y=>y==="&"?"&&":"&"):s.replace(/&&/g,"_")}function t(s){return s.replace(/&/g,"&&")}function c(s){if(s.endsWith("]")){const m=s.lastIndexOf(" [",s.length-2);if(m!==-1){const y=h(s.substring(0,m)),S=s.substring(m);return{name:y.name+S,parentPath:y.parentPath}}}return h(s)}function h(s){const m=s.indexOf("/")!==-1?P.$gc:P.$fc,y=m.basename(s),S=m.dirname(s);return y.length?{name:y,parentPath:S}:{name:S,parentPath:""}}}),define(Ee[139],Se([1,0,22,41,2]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=void 0,e.$Gn=p,e.$Hn=I,e.$In=D;function T(f){return f.toJSON()}class L{constructor(A){this.a=A}transformIncoming(A){const w=this.a.transformIncoming(A);return w===A?A:T(P.URI.from(w))}transformOutgoing(A){const w=this.a.transformOutgoing(A);return w===A?A:T(P.URI.from(w))}transformOutgoingURI(A){const w=this.a.transformOutgoing(A);return w===A?A:P.URI.from(w)}transformOutgoingScheme(A){return this.a.transformOutgoingScheme(A)}}e.$En=L,e.$Fn=new class{transformIncoming(f){return f}transformOutgoing(f){return f}transformOutgoingURI(f){return f}transformOutgoingScheme(f){return f}};function R(f,A,w){if(!f||w>200)return null;if(typeof f=="object"){if(f instanceof P.URI)return A.transformOutgoing(f);for(const a in f)if(Object.hasOwnProperty.call(f,a)){const d=R(f[a],A,w+1);d!==null&&(f[a]=d)}}return null}function p(f,A){const w=R(f,A,0);return w===null?f:w}function l(f,A,w,a){if(!f||a>200)return null;if(typeof f=="object"){if(f.$mid===u.MarshalledId.Uri)return w?P.URI.revive(A.transformIncoming(f)):A.transformIncoming(f);if(f instanceof r.$Je)return null;for(const d in f)if(Object.hasOwnProperty.call(f,d)){const g=l(f[d],A,w,a+1);g!==null&&(f[d]=g)}}return null}function I(f,A){const w=l(f,A,!1,0);return w===null?f:w}function D(f,A){const w=l(f,A,!0,0);return w===null?f:w}}),define(Ee[33],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=u;const r=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function u(P){return r.test(P)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(R){for(let p=0;p<R.length;p++)R[p]=Math.floor(Math.random()*256);return R};const T=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){P(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let p=0,l="";return l+=L[T[p++]],l+=L[T[p++]],l+=L[T[p++]],l+=L[T[p++]],l+="-",l+=L[T[p++]],l+=L[T[p++]],l+="-",l+=L[T[p++]],l+=L[T[p++]],l+="-",l+=L[T[p++]],l+=L[T[p++]],l+="-",l+=L[T[p++]],l+=L[T[p++]],l+=L[T[p++]],l+=L[T[p++]],l+=L[T[p++]],l+=L[T[p++]],l}}()}),define(Ee[188],Se([1,0,19,40,33]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$$s=void 0,e.$9s=T,e.$0s=L,e.$_s=l;function T(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}function L(D,f,A){const w={id:(0,P.$Wg)(),name:D,uri:f,data:A};return{asString:async()=>"",asFile:()=>w,value:void 0}}class R{constructor(){this.a=new Map}get size(){let f=0;for(const A of this.a)f++;return f}has(f){return this.a.has(this.b(f))}matches(f){const A=[...this.a.keys()];return u.Iterable.some(this,([w,a])=>a.asFile())&&A.push("files"),I(p(f),A)}get(f){return this.a.get(this.b(f))?.[0]}append(f,A){const w=this.a.get(f);w?w.push(A):this.a.set(this.b(f),[A])}replace(f,A){this.a.set(this.b(f),[A])}delete(f){this.a.delete(this.b(f))}*[Symbol.iterator](){for(const[f,A]of this.a)for(const w of A)yield[f,w]}b(f){return p(f)}}e.$$s=R;function p(D){return D.toLowerCase()}function l(D,f){return I(p(D),f.map(p))}function I(D,f){if(D==="*/*")return f.length>0;if(f.includes(D))return!0;const A=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!A)return!1;const[w,a,d]=A;return d==="*"?f.some(g=>g.startsWith(a+"/")):!1}e.$at=Object.freeze({create:D=>(0,r.$Mb)(D.map(f=>f.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$at.split(D).filter(f=>!f.startsWith("#"))})}),define(Ee[34],Se([1,0,56,66,409,7,32,82,16,11,23,2]),function(oe,e,r,u,P,T,L,R,p,l,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=d,e.readdirSync=i,e.whenDeleted=t,e.configureFlushOnWrite=y,e.writeFileSync=E;var f;(function(N){N[N.UNLINK=0]="UNLINK",N[N.MOVE=1]="MOVE"})(f||(e.RimRafMode=f={}));async function A(N,F=f.UNLINK,X){if((0,L.$Dg)(N))throw new Error("rimraf - will refuse to recursively delete root");return F===f.UNLINK?a(N):w(N,X)}async function w(N,F=(0,L.$Ig)((0,u.tmpdir)())){try{try{await r.promises.rename(N,F)}catch(X){return X.code==="ENOENT"?void 0:a(N)}a(F).catch(X=>{})}catch(X){if(X.code!=="ENOENT")throw X}}async function a(N){return(0,P.promisify)(r.rm)(N,{recursive:!0,force:!0,maxRetries:3})}function d(N){if((0,L.$Dg)(N))throw new Error("rimraf - will refuse to recursively delete root");r.rmSync(N,{recursive:!0,force:!0,maxRetries:3})}async function g(N,F){return o(await(F?$(N):(0,P.promisify)(r.readdir)(N)))}async function $(N){try{return await(0,P.promisify)(r.readdir)(N,{withFileTypes:!0})}catch(se){console.warn("[node.js fs] readdir with filetypes failed with error: ",se)}const F=[],X=await g(N);for(const se of X){let W=!1,H=!1,V=!1;try{const x=await e.Promises.lstat((0,p.$jc)(N,se));W=x.isFile(),H=x.isDirectory(),V=x.isSymbolicLink()}catch(x){console.warn("[node.js fs] unexpected error from lstat after readdir: ",x)}F.push({name:se,isFile:()=>W,isDirectory:()=>H,isSymbolicLink:()=>V})}return F}function i(N){return o(r.readdirSync(N))}function o(N){return N.map(F=>typeof F=="string"?l.$d?(0,R.$hm)(F):F:(F.name=l.$d?(0,R.$hm)(F.name):F.name,F))}async function n(N){const F=await g(N),X=[];for(const se of F)await c.existsDirectory((0,p.$jc)(N,se))&&X.push(se);return X}function t(N,F=1e3){return new Promise(X=>{let se=!1;const W=setInterval(()=>{se||(se=!0,r.access(N,H=>{se=!1,H&&(clearInterval(W),X(void 0))}))},F)})}var c;(function(N){async function F(W){let H;try{if(H=await e.Promises.lstat(W),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(V){if(V.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(l.$c&&V.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(x){if(x.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw x}throw V}}N.stat=F;async function X(W){try{const{stat:H,symbolicLink:V}=await N.stat(W);return H.isFile()&&V?.dangling!==!0}catch{}return!1}N.existsFile=X;async function se(W){try{const{stat:H,symbolicLink:V}=await N.stat(W);return H.isDirectory()&&V?.dangling!==!0}catch{}return!1}N.existsDirectory=se})(c||(e.SymlinkSupport=c={}));const h=new T.$Jh;function s(N,F,X){return h.queueFor(D.URI.file(N),()=>{const se=k(X);return new Promise((W,H)=>S(N,F,se,V=>V?H(V):W()))},I.$5g)}let m=!0;function y(N){m=N}function S(N,F,X,se){if(!m)return r.writeFile(N,F,{mode:X.mode,flag:X.flag},se);r.open(N,X.flag,X.mode,(W,H)=>{if(W)return se(W);r.writeFile(H,F,V=>{if(V)return r.close(H,()=>se(V));r.fdatasync(H,x=>(x&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",x),y(!1)),r.close(H,he=>se(he))))})})}function E(N,F,X){const se=k(X);if(!m)return r.writeFileSync(N,F,{mode:se.mode,flag:se.flag});const W=r.openSync(N,se.flag,se.mode);try{r.writeFileSync(W,F);try{r.fdatasyncSync(W)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),y(!1)}}finally{r.closeSync(W)}}function k(N){return N?{mode:typeof N.mode=="number"?N.mode:438,flag:typeof N.flag=="string"?N.flag:"w"}:{mode:438,flag:"w"}}async function C(N,F,X=6e4){if(N!==F)try{l.$c&&typeof X=="number"?await v(N,F,Date.now(),X):await(0,P.promisify)(r.rename)(N,F)}catch(se){if(N.toLowerCase()!==F.toLowerCase()&&se.code==="EXDEV"||N.endsWith("."))await b(N,F,{preserveSymlinks:!1}),await A(N,f.MOVE);else throw se}}async function v(N,F,X,se,W=0){try{return await(0,P.promisify)(r.rename)(N,F)}catch(H){if(H.code!=="EACCES"&&H.code!=="EPERM"&&H.code!=="EBUSY")throw H;if(Date.now()-X>=se)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${H}`),H;if(W===0){let V=!1;try{const{stat:x}=await c.stat(F);x.isFile()||(V=!0)}catch{}if(V)throw H}return await(0,T.$Bh)(Math.min(100,W*10)),v(N,F,X,se,W+1)}}async function b(N,F,X){return U(N,F,{root:{source:N,target:F},options:X,handledSourcePaths:new Set})}const O=511;async function U(N,F,X){if(X.handledSourcePaths.has(N))return;X.handledSourcePaths.add(N);const{stat:se,symbolicLink:W}=await c.stat(N);if(W){if(X.options.preserveSymlinks)try{return await M(N,F,X)}catch{}if(W.dangling)return}return se.isDirectory()?z(N,F,se.mode&O,X):j(N,F,se.mode&O)}async function z(N,F,X,se){await e.Promises.mkdir(F,{recursive:!0,mode:X});const W=await g(N);for(const H of W)await U((0,p.$jc)(N,H),(0,p.$jc)(F,H),se)}async function j(N,F,X){await e.Promises.copyFile(N,F),await e.Promises.chmod(F,X)}async function M(N,F,X){let se=await e.Promises.readlink(N);(0,L.$zg)(se,X.root.source,!l.$e)&&(se=(0,p.$jc)(X.root.target,se.substr(X.root.source.length+1))),await e.Promises.symlink(se,F)}e.Promises=new class{get access(){return(0,P.promisify)(r.access)}get stat(){return(0,P.promisify)(r.stat)}get lstat(){return(0,P.promisify)(r.lstat)}get utimes(){return(0,P.promisify)(r.utimes)}get read(){return(N,F,X,se,W)=>new Promise((H,V)=>{r.read(N,F,X,se,W,(x,he,ne)=>x?V(x):H({bytesRead:he,buffer:ne}))})}get readFile(){return(0,P.promisify)(r.readFile)}get write(){return(N,F,X,se,W)=>new Promise((H,V)=>{r.write(N,F,X,se,W,(x,he,ne)=>x?V(x):H({bytesWritten:he,buffer:ne}))})}get appendFile(){return(0,P.promisify)(r.appendFile)}get fdatasync(){return(0,P.promisify)(r.fdatasync)}get truncate(){return(0,P.promisify)(r.truncate)}get copyFile(){return(0,P.promisify)(r.copyFile)}get open(){return(0,P.promisify)(r.open)}get close(){return(0,P.promisify)(r.close)}get symlink(){return(0,P.promisify)(r.symlink)}get readlink(){return(0,P.promisify)(r.readlink)}get chmod(){return(0,P.promisify)(r.chmod)}get mkdir(){return(0,P.promisify)(r.mkdir)}get unlink(){return(0,P.promisify)(r.unlink)}get rmdir(){return(0,P.promisify)(r.rmdir)}get realpath(){return(0,P.promisify)(r.realpath)}async exists(N){try{return await e.Promises.access(N),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return n}get writeFile(){return s}get rm(){return A}get rename(){return C}get copy(){return b}}}),define(Ee[108],Se([1,0,56,16,11,13,34]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=R,e.$br=p,e.$cr=l,e.$dr=I;function R(f){if(P.$e)return f;const A=(0,u.$mc)(f);if(f===A)return f;const w=((0,u.$nc)(f)||f).toLowerCase();try{const d=(0,L.readdirSync)(A).filter(g=>g.toLowerCase()===w);if(d.length===1){const g=R(A);if(g)return(0,u.$jc)(g,d[0])}else if(d.length>1){const g=d.indexOf(w);if(g>=0){const $=R(A);if($)return(0,u.$jc)($,d[g])}}}catch{}return null}async function p(f,A){if(P.$e)return f;const w=(0,u.$mc)(f);if(f===w)return f;const a=((0,u.$nc)(f)||f).toLowerCase();try{if(A?.isCancellationRequested)return null;const g=(await L.Promises.readdir(w)).filter($=>$.toLowerCase()===a);if(g.length===1){const $=await p(w,A);if($)return(0,u.$jc)($,g[0])}else if(g.length>1){const $=g.indexOf(a);if($>=0){const i=await p(w,A);if(i)return(0,u.$jc)(i,g[$])}}}catch{}return null}async function l(f){try{return await L.Promises.realpath(f)}catch{const w=D(f);return await L.Promises.access(w,r.constants.R_OK),w}}function I(f){try{return r.realpathSync(f)}catch{const w=D(f);return r.accessSync(w,r.constants.R_OK),w}}function D(f){return(0,T.$jf)((0,u.$hc)(f),u.sep)}}),define(Ee[189],Se([1,0,67]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zg=void 0,e.$Yg=u,e.$1g=T;function u(R,p,l,I=1){let D=!1;return new Promise(f=>{const A=setTimeout(()=>{if(!D)return D=!0,f(0)},l);P(R,p,I,w=>{if(!D)return D=!0,clearTimeout(A),f(w)})})}function P(R,p,l,I){if(p===0)return I(0);const D=new r.Socket;D.once("connect",()=>(L(D),P(R+l,p-1,l,I))),D.once("data",()=>{}),D.once("error",f=>(L(D),f.code!=="ECONNREFUSED"?P(R+l,p-1,l,I):I(R))),D.connect(R,"127.0.0.1")}e.$Zg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(R,p,l,I="127.0.0.1"){let D=!1,f,A=1;const w=r.createServer({pauseOnConnect:!0});function a(d,g){D||(D=!0,w.removeAllListeners(),w.close(),f&&clearTimeout(f),g(d))}return new Promise(d=>{f=setTimeout(()=>{a(0,d)},l),w.on("listening",()=>{a(R,d)}),w.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&A<p?(R++,A++,w.listen(R,I)):a(0,d)}),w.on("close",()=>{a(0,d)}),w.listen(R,I)})}function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(p){console.error(p)}}}),define(Ee[109],Se([1,0,16,11,54,104,18,34]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$um=p,e.$vm=l,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return T.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return T.TerminateResponseCode}});function p(D=P.env){return D.comspec||"cmd.exe"}function l(D){let f=[],A=!1;const w=function(a){if(A){f.push(a);return}(!D.send(a,g=>{if(g&&console.error(g),A=!1,f.length>0){const $=f.slice(0);f=[],$.forEach(i=>w(i))}})||u.$c)&&(A=!0)};return{send:w}}var I;(function(D){async function f(A,w,a){if(r.$ic(A))return A;if(w===void 0&&(w=P.cwd()),r.$mc(A)!=="."||(a===void 0&&L.$ag(P.env.PATH)&&(a=P.env.PATH.split(r.$tc)),a===void 0||a.length===0))return r.$jc(w,A);async function g($){if(await R.Promises.exists($)){let i;try{i=await R.Promises.stat($)}catch(o){o.message.startsWith("EACCES")&&(i=await R.Promises.lstat($))}return i?!i.isDirectory():!1}return!1}for(const $ of a){let i;if(r.$ic($)?i=r.$jc($,A):i=r.$jc(w,$,A),await g(i))return i;let o=i+".com";if(await g(o)||(o=i+".exe",await g(o)))return o}return r.$jc(w,A)}D.findExecutable=f})(I||(e.win32=I={}))});var Ze=this&&this.__decorate||function(oe,e,r,u){var P=arguments.length,T=P<3?e:u===null?u=Object.getOwnPropertyDescriptor(e,r):u,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(oe,e,r,u);else for(var R=oe.length-1;R>=0;R--)(L=oe[R])&&(T=(P<3?L(T):P>3?L(e,r,T):L(e,r))||T);return P>3&&T&&Object.defineProperty(e,r,T),T};define(Ee[87],Se([1,0,19,7,22,21,60,14,4,3,55,13,18]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.ProxyChannel=e.$ii=e.$fi=e.$ei=e.$di=e.RequestInitiator=e.$ci=e.$_h=e.$$h=void 0,e.$ai=y,e.$bi=S,e.$gi=O,e.$hi=U;var A;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(A||(A={}));function w(W){switch(W){case A.Promise:return"req";case A.PromiseCancel:return"cancel";case A.EventListen:return"subscribe";case A.EventDispose:return"unsubscribe"}}var a;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(a||(a={}));function d(W){switch(W){case a.Initialize:return"init";case a.PromiseSuccess:return"reply:";case a.PromiseError:case a.PromiseErrorObj:return"replyErr:";case a.EventFire:return"event:"}}var g;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(g||(g={}));function $(W){let H=0;for(let V=0;;V+=7){const x=W.read(1);if(H|=(x.buffer[0]&127)<<V,!(x.buffer[0]&128))return H}}const i=h(0);function o(W,H){if(H===0){W.write(i);return}let V=0;for(let he=H;he!==0;he=he>>>7)V++;const x=P.$Je.alloc(V);for(let he=0;H!==0;he++)x.buffer[he]=H&127,H=H>>>7,H>0&&(x.buffer[he]|=128);W.write(x)}class n{constructor(H){this.b=H,this.a=0}read(H){const V=this.b.slice(this.a,this.a+H);return this.a+=V.byteLength,V}}e.$$h=n;class t{constructor(){this.a=[]}get buffer(){return P.$Je.concat(this.a)}write(H){this.a.push(H)}}e.$_h=t;var c;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(c||(c={}));function h(W){const H=P.$Je.alloc(1);return H.writeUInt8(W,0),H}const s={Undefined:h(c.Undefined),String:h(c.String),Buffer:h(c.Buffer),VSBuffer:h(c.VSBuffer),Array:h(c.Array),Object:h(c.Object),Uint:h(c.Int)},m=typeof Buffer<"u";function y(W,H){if(typeof H>"u")W.write(s.Undefined);else if(typeof H=="string"){const V=P.$Je.fromString(H);W.write(s.String),o(W,V.byteLength),W.write(V)}else if(m&&Buffer.isBuffer(H)){const V=P.$Je.wrap(H);W.write(s.Buffer),o(W,V.byteLength),W.write(V)}else if(H instanceof P.$Je)W.write(s.VSBuffer),o(W,H.byteLength),W.write(H);else if(Array.isArray(H)){W.write(s.Array),o(W,H.length);for(const V of H)y(W,V)}else if(typeof H=="number"&&(H|0)===H)W.write(s.Uint),o(W,H);else{const V=P.$Je.fromString(JSON.stringify(H));W.write(s.Object),o(W,V.byteLength),W.write(V)}}function S(W){switch(W.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return W.read($(W)).toString();case c.Buffer:return W.read($(W)).buffer;case c.VSBuffer:return W.read($(W));case c.Array:{const V=$(W),x=[];for(let he=0;he<V;he++)x.push(S(W));return x}case c.Object:return JSON.parse(W.read($(W)).toString());case c.Int:return $(W)}}class E{constructor(H,V,x=null,he=1e3){this.h=H,this.j=V,this.k=x,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:a.Initialize})}registerChannel(H,V){this.b.set(H,V),setTimeout(()=>this.w(H),0)}m(H){switch(H.type){case a.Initialize:{const V=this.o([H.type]);this.k?.logOutgoing(V,0,k.OtherSide,d(H.type));return}case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:{const V=this.o([H.type,H.id],H.data);this.k?.logOutgoing(V,H.id,k.OtherSide,d(H.type),H.data);return}}}o(H,V=void 0){const x=new t;return y(x,H),y(x,V),this.p(x.buffer)}p(H){try{return this.h.send(H),H.byteLength}catch{return 0}}q(H){const V=new n(H),x=S(V),he=S(V),ne=x[0];switch(ne){case A.Promise:return this.k?.logIncoming(H.byteLength,x[1],k.OtherSide,`${w(ne)}: ${x[2]}.${x[3]}`,he),this.s({type:ne,id:x[1],channelName:x[2],name:x[3],arg:he});case A.EventListen:return this.k?.logIncoming(H.byteLength,x[1],k.OtherSide,`${w(ne)}: ${x[2]}.${x[3]}`,he),this.t({type:ne,id:x[1],channelName:x[2],name:x[3],arg:he});case A.PromiseCancel:return this.k?.logIncoming(H.byteLength,x[1],k.OtherSide,`${w(ne)}`),this.u({type:ne,id:x[1]});case A.EventDispose:return this.k?.logIncoming(H.byteLength,x[1],k.OtherSide,`${w(ne)}`),this.u({type:ne,id:x[1]})}}s(H){const V=this.b.get(H.channelName);if(!V){this.v(H);return}const x=new T.$se;let he;try{he=V.call(this.j,H.name,H.arg,x.token)}catch(pe){he=Promise.reject(pe)}const ne=H.id;he.then(pe=>{this.m({id:ne,data:pe,type:a.PromiseSuccess})},pe=>{pe instanceof Error?this.m({id:ne,data:{message:pe.message,name:pe.name,stack:pe.stack?pe.stack.split?pe.stack.split(`
`):pe.stack:void 0},type:a.PromiseError}):this.m({id:ne,data:pe,type:a.PromiseErrorObj})}).finally(()=>{we.dispose(),this.d.delete(H.id)});const we=(0,l.$Sc)(()=>x.cancel());this.d.set(H.id,we)}t(H){const V=this.b.get(H.channelName);if(!V){this.v(H);return}const x=H.id,ne=V.listen(this.j,H.name,H.arg)(we=>this.m({id:x,data:we,type:a.EventFire}));this.d.set(H.id,ne)}u(H){const V=this.d.get(H.id);V&&(V.dispose(),this.d.delete(H.id))}v(H){let V=this.g.get(H.channelName);V||(V=[],this.g.set(H.channelName,V));const x=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===A.Promise&&this.m({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.l}ms`,stack:void 0},type:a.PromiseError})},this.l);V.push({request:H,timeoutTimer:x})}w(H){const V=this.g.get(H);if(V){for(const x of V)switch(clearTimeout(x.timeoutTimer),x.request.type){case A.Promise:this.s(x.request);break;case A.EventListen:this.t(x.request);break}this.g.delete(H)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Pc)(this.d.values()),this.d.clear()}}e.$ci=E;var k;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class C{constructor(H,V=null){this.l=H,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new p.$he,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(x=>this.s(x)),this.j=V}getChannel(H){const V=this;return{call(x,he,ne){return V.a?Promise.reject(new R.$5):V.m(H,x,he,ne)},listen(x,he){return V.a?p.Event.None:V.o(H,x,he)}}}m(H,V,x,he=T.CancellationToken.None){const ne=this.g++,we=A.Promise,pe={id:ne,type:we,channelName:H,name:V,arg:x};if(he.isCancellationRequested)return Promise.reject(new R.$5);let ce;return new Promise((de,te)=>{if(he.isCancellationRequested)return te(new R.$5);const ee=()=>{const ae=$e=>{switch($e.type){case a.PromiseSuccess:this.f.delete(ne),de($e.data);break;case a.PromiseError:{this.f.delete(ne);const be=new Error($e.data.message);be.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,be.name=$e.data.name,te(be);break}case a.PromiseErrorObj:this.f.delete(ne),te($e.data);break}};this.f.set(ne,ae),this.p(pe)};let ie=null;this.b===g.Idle?ee():(ie=(0,u.$nh)(ae=>this.u()),ie.then(()=>{ie=null,ee()}));const le=()=>{ie?(ie.cancel(),ie=null):this.p({id:ne,type:A.PromiseCancel}),te(new R.$5)},Z=he.onCancellationRequested(le);ce=(0,l.$Rc)((0,l.$Sc)(le),Z),this.d.add(ce)}).finally(()=>{ce.dispose(),this.d.delete(ce)})}o(H,V,x){const he=this.g++,ne=A.EventListen,we={id:he,type:ne,channelName:H,name:V,arg:x};let pe=null;const ce=new p.$he({onWillAddFirstListener:()=>{pe=(0,u.$nh)(de=>this.u()),pe.then(()=>{pe=null,this.d.add(ce),this.p(we)})},onDidRemoveLastListener:()=>{pe?(pe.cancel(),pe=null):(this.d.delete(ce),this.p({id:he,type:A.EventDispose}))}}),K=de=>ce.fire(de.data);return this.f.set(he,K),ce.event}p(H){switch(H.type){case A.Promise:case A.EventListen:{const V=this.q([H.type,H.id,H.channelName,H.name],H.arg);this.j?.logOutgoing(V,H.id,k.LocalSide,`${w(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case A.PromiseCancel:case A.EventDispose:{const V=this.q([H.type,H.id]);this.j?.logOutgoing(V,H.id,k.LocalSide,w(H.type));return}}}q(H,V=void 0){const x=new t;return y(x,H),y(x,V),this.r(x.buffer)}r(H){try{return this.l.send(H),H.byteLength}catch{return 0}}s(H){const V=new n(H),x=S(V),he=S(V),ne=x[0];switch(ne){case a.Initialize:return this.j?.logIncoming(H.byteLength,0,k.LocalSide,d(ne)),this.t({type:x[0]});case a.PromiseSuccess:case a.PromiseError:case a.EventFire:case a.PromiseErrorObj:return this.j?.logIncoming(H.byteLength,x[1],k.LocalSide,d(ne),he),this.t({type:x[0],id:x[1],data:he})}}t(H){if(H.type===a.Initialize){this.b=g.Idle,this.k.fire();return}this.f.get(H.id)?.(H)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Pc)(this.d.values()),this.d.clear()}}e.$di=C,Ze([L.$5h],C.prototype,"onDidInitializePromise",null);class v{get connections(){const H=[];return this.f.forEach(V=>H.push(V)),H}constructor(H,V,x){this.a=new Map,this.f=new Set,this.g=new p.$he,this.onDidAddConnection=this.g.event,this.h=new p.$he,this.onDidRemoveConnection=this.h.event,this.j=new l.$Tc,this.j.add(H(({protocol:he,onDidClientDisconnect:ne})=>{const we=p.Event.once(he.onMessage);this.j.add(we(pe=>{const ce=new n(pe),K=S(ce),de=new E(he,K,V,x),te=new C(he,V);this.a.forEach((ie,le)=>de.registerChannel(le,ie));const ee={channelServer:de,channelClient:te,ctx:K};this.f.add(ee),this.g.fire(ee),this.j.add(ne(()=>{de.dispose(),te.dispose(),this.f.delete(ee),this.h.fire(ee)}))}))}))}getChannel(H,V){const x=this;return{call(he,ne,we){let pe;if((0,f.$og)(V)){const K=(0,r.$3b)(x.connections.filter(V));pe=K?Promise.resolve(K):p.Event.toPromise(p.Event.filter(x.onDidAddConnection,V))}else pe=V.routeCall(x,he,ne);const ce=pe.then(K=>K.channelClient.getChannel(H));return O(ce).call(he,ne,we)},listen(he,ne){if((0,f.$og)(V))return x.k(H,V,he,ne);const we=V.routeEvent(x,he,ne).then(pe=>pe.channelClient.getChannel(H));return O(we).listen(he,ne)}}}k(H,V,x,he){const ne=this;let we;const pe=new p.$he({onWillAddFirstListener:()=>{we=new l.$Tc;const ce=new p.$ne,K=new Map,de=ee=>{const le=ee.channelClient.getChannel(H).listen(x,he),Z=ce.add(le);K.set(ee,Z)},te=ee=>{const ie=K.get(ee);ie&&(ie.dispose(),K.delete(ee))};ne.connections.filter(V).forEach(de),p.Event.filter(ne.onDidAddConnection,V)(de,void 0,we),ne.onDidRemoveConnection(te,void 0,we),ce.event(pe.fire,pe,we),we.add(ce)},onDidRemoveLastListener:()=>{we?.dispose(),we=void 0}});return pe.event}registerChannel(H,V){this.a.set(H,V);for(const x of this.f)x.channelServer.registerChannel(H,V)}dispose(){this.j.dispose();for(const H of this.f)H.channelClient.dispose(),H.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ei=v;class b{constructor(H,V,x=null){const he=new t;y(he,V),H.send(he.buffer),this.a=new C(H,x),this.d=new E(H,V,x)}getChannel(H){return this.a.getChannel(H)}registerChannel(H,V){this.d.registerChannel(H,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$fi=b;function O(W){return{call(H,V,x){return W.then(he=>he.call(H,V,x))},listen(H,V){const x=new p.$qe;return W.then(he=>x.input=he.listen(H,V)),x.event}}}function U(W){let H=!1;return{call(V,x,he){return H?W.call(V,x,he):(0,u.$Bh)(0).then(()=>H=!0).then(()=>W.call(V,x,he))},listen(V,x){if(H)return W.listen(V,x);const he=new p.$qe;return(0,u.$Bh)(0).then(()=>H=!0).then(()=>he.input=W.listen(V,x)),he.event}}}class z{constructor(H){this.a=H}routeCall(H){return this.b(H)}routeEvent(H){return this.b(H)}async b(H){for(const V of H.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await p.Event.toPromise(H.onDidAddConnection),await this.b(H)}}e.$ii=z;var j;(function(W){function H(ne,we,pe){const ce=ne,K=pe&&pe.disableMarshalling,de=new Map;for(const te in ce)x(te)&&de.set(te,p.Event.buffer(ce[te],!0,void 0,we));return new class{listen(te,ee,ie){const le=de.get(ee);if(le)return le;const Z=ce[ee];if(typeof Z=="function"){if(he(ee))return Z.call(ce,ie);if(x(ee))return de.set(ee,p.Event.buffer(ce[ee],!0,void 0,we)),de.get(ee)}throw new R.$bb(`Event not found: ${ee}`)}call(te,ee,ie){const le=ce[ee];if(typeof le=="function"){if(!K&&Array.isArray(ie))for(let ae=0;ae<ie.length;ae++)ie[ae]=(0,I.$0h)(ie[ae]);let Z=le.apply(ce,ie);return Z instanceof Promise||(Z=Promise.resolve(Z)),Z}throw new R.$bb(`Method not found: ${ee}`)}}}W.fromService=H;function V(ne,we){const pe=we&&we.disableMarshalling;return new Proxy({},{get(ce,K){if(typeof K=="string")return we?.properties?.has(K)?we.properties.get(K):he(K)?function(de){return ne.listen(K,de)}:x(K)?ne.listen(K):async function(...de){let te;we&&!(0,f.$jg)(we.context)?te=[we.context,...de]:te=de;const ee=await ne.call(K,te);return pe?ee:(0,I.$0h)(ee)};throw new R.$bb(`Property not found: ${String(K)}`)}})}W.toService=V;function x(ne){return ne[0]==="o"&&ne[1]==="n"&&D.$Af(ne.charCodeAt(2))}function he(ne){return/^onDynamic/.test(ne)&&D.$Af(ne.charCodeAt(9))}})(j||(e.ProxyChannel=j={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const H=W.toString();if(H!=="[object Object]")return H}return W}function F(W){return Array.isArray(W)?W.map(N):N(W)}function X(W,H,V,x,he,ne,we){we=F(we);const pe=M[he],ce=pe[x%pe.length];let K=[`%c[${W}]%c[${String(H).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(x).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${ce}`];/\($/.test(ne)?(K=K.concat(we),K.push(")")):K.push(we),console.log.apply(console,K)}class se{constructor(H,V){this.d=H,this.f=V,this.a=0,this.b=0}logOutgoing(H,V,x,he,ne){this.b+=H,X(this.d,this.b,H,V,x,he,ne)}logIncoming(H,V,x,he,ne){this.a+=H,X(this.f,this.a,H,V,x,he,ne)}}e.$ji=se}),define(Ee[68],Se([1,0,22,4,3,87]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oi=e.$ni=e.$mi=e.$li=e.ProtocolConstants=e.$ki=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const m=new WeakMap;let y=0;function S(k,C){if(!m.has(k)){const v=String(++y);m.set(k,v)}return m.get(k)}function E(k,C,v,b){if(!s.enableDiagnostics)return;const O=S(k,C);if(b instanceof r.$Je||b instanceof Uint8Array||b instanceof ArrayBuffer||ArrayBuffer.isView(b)){const U=r.$Je.alloc(b.byteLength);U.set(b),s.records.push({timestamp:Date.now(),id:O,label:C,type:v,buff:U})}else s.records.push({timestamp:Date.now(),id:O,label:C,type:v,data:b})}s.traceSocketEvent=E})(R||(e.SocketDiagnostics=R={}));var p;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let l=null;function I(){return l||(l=r.$Je.alloc(0)),l}class D{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(m){this.a.push(m),this.b+=m.byteLength}read(m){return this.c(m,!0)}peek(m){return this.c(m,!1)}c(m,y){if(m===0)return I();if(m>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===m){const C=this.a[0];return y&&(this.a.shift(),this.b-=m),C}if(this.a[0].byteLength>m){const C=this.a[0].slice(0,m);return y&&(this.a[0]=this.a[0].slice(m),this.b-=m),C}const S=r.$Je.alloc(m);let E=0,k=0;for(;m>0;){const C=this.a[k];if(C.byteLength>m){const v=C.slice(0,m);S.set(v,E),E+=m,y&&(this.a[k]=C.slice(m),this.b-=m),m-=m}else S.set(C,E),E+=C.byteLength,y?(this.a.shift(),this.b-=C.byteLength):k++,m-=C.byteLength}return S}}e.$ki=D;var f;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(f||(f={}));function A(s){switch(s){case f.None:return"None";case f.Regular:return"Regular";case f.Control:return"Control";case f.Ack:return"Ack";case f.Disconnect:return"Disconnect";case f.ReplayRequest:return"ReplayRequest";case f.Pause:return"PauseWriting";case f.Resume:return"ResumeWriting";case f.KeepAlive:return"KeepAlive"}}var w;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(w||(e.ProtocolConstants=w={}));class a{constructor(m,y,S,E){this.type=m,this.id=y,this.ack=S,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends P.$Uc{constructor(m){super(),this.f=this.B(new u.$he),this.onMessage=this.f.event,this.g={readHead:!0,readLen:w.HeaderLength,messageType:f.None,id:0,ack:0},this.a=m,this.b=!1,this.c=new D,this.B(this.a.onData(y=>this.acceptChunk(y))),this.lastReadTime=Date.now()}acceptChunk(m){if(!(!m||m.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(m);this.c.byteLength>=this.g.readLen;){const y=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=y.readUInt32BE(9),this.g.messageType=y.readUInt8(0),this.g.id=y.readUInt32BE(1),this.g.ack=y.readUInt32BE(5),this.a.traceSocketEvent(L.ProtocolHeaderRead,{messageType:A(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const S=this.g.messageType,E=this.g.id,k=this.g.ack;if(this.g.readHead=!0,this.g.readLen=w.HeaderLength,this.g.messageType=f.None,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent(L.ProtocolMessageRead,y),this.f.fire(new a(S,E,k,y)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(m){this.k=null,this.a=!1,this.b=!1,this.c=m,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(m){if(this.a)return;m.writtenTime=Date.now(),this.lastWriteTime=Date.now();const y=r.$Je.alloc(w.HeaderLength);y.writeUInt8(m.type,0),y.writeUInt32BE(m.id,1),y.writeUInt32BE(m.ack,5),y.writeUInt32BE(m.data.byteLength,9),this.c.traceSocketEvent(L.ProtocolHeaderWrite,{messageType:A(m.type),id:m.id,ack:m.ack,messageSize:m.data.byteLength}),this.c.traceSocketEvent(L.ProtocolMessageWrite,m.data),this.j(y,m.data)}g(m,y){const S=this.f===0;return this.d.push(m,y),this.f+=m.byteLength+y.byteLength,S}h(){const m=r.$Je.concat(this.d,this.f);return this.d.length=0,this.f=0,m}j(m,y){this.g(m,y)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const m=this.h();this.c.traceSocketEvent(L.ProtocolWrite,{byteLength:m.byteLength}),this.c.write(m)}}class $ extends P.$Uc{constructor(m){super(),this.f=new u.$he,this.onMessage=this.f.event,this.g=new u.$he,this.onDidDispose=this.g.event,this.a=m,this.b=this.B(new g(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(y=>{y.type===f.Regular&&this.f.fire(y.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(m){this.b.write(new a(f.Regular,0,0,m))}}e.$li=$;class i extends T.$fi{static fromSocket(m,y){return new i(new $(m),y)}get onDidDispose(){return this.b.onDidDispose}constructor(m,y,S=null){super(m,y,S),this.b=m}dispose(){super.dispose();const m=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),m.end()}}e.$mi=i;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new u.$he({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(m){this.b?this.d.length>0?this.d.push(m):this.a.fire(m):this.d.push(m)}flushBuffer(){this.d=[]}}e.$ni=o;class n{constructor(m){this.data=m,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let m=0,y=this.a;for(;y;)y=y.next,m++;return m}peek(){return this.a?this.a.data:null}toArray(){const m=[];let y=0,S=this.a;for(;S;)m[y++]=S.data,S=S.next;return m}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(m){const y=new n(m);if(!this.a){this.a=y,this.b=y;return}this.b.next=y,this.b=y}}class c{static getInstance(){return c.b||(c.b=new c),c.b}constructor(){this.c=[];const m=Date.now();for(let y=0;y<c.a;y++)this.c[y]=m-1e3*y;setInterval(()=>{for(let y=c.a;y>=1;y--)this.c[y]=this.c[y-1];this.c[0]=Date.now()},1e3)}d(){const m=Date.now(),y=(1+c.a)*1e3;let S=0;for(let E=0;E<c.a;E++)m-this.c[E]<=y&&S++;return 1-S/c.a}hasHighLoad(){return this.d()>=.5}}c.a=10,c.b=null;class h{get unacknowledgedCount(){return this.c-this.d}constructor(m){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=m.loadEstimator??c.getInstance(),this.t=m.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new P.$Tc,this.o=m.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(y=>this.z(y))),this.r.add(this.o.onClose(y=>this.x.fire(y))),m.initialChunk&&this.q.acceptChunk(m.initialChunk),this.t?this.l=setInterval(()=>{this.D()},w.KeepAliveSendTime):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const m=new a(f.Disconnect,0,0,I());this.p.write(m),this.p.flush()}sendPause(){const m=new a(f.Pause,0,0,I());this.p.write(m)}sendResume(){const m=new a(f.Resume,0,0,I());this.p.write(m)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(m,y){this.a=!0,this.r.dispose(),this.r=new P.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=m,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(S=>this.z(S))),this.r.add(this.o.onClose(S=>this.x.fire(S))),this.q.acceptChunk(y)}endAcceptReconnection(){this.a=!1,this.h=this.g;const m=new a(f.Ack,0,this.h,I());this.p.write(m);const y=this.b.toArray();for(let S=0,E=y.length;S<E;S++)this.p.write(y[S]);this.B()}acceptDisconnect(){this.w.fire()}z(m){if(m.ack>this.d){this.d=m.ack;do{const y=this.b.peek();if(y&&y.id<=m.ack)this.b.pop();else break}while(!0)}switch(m.type){case f.None:break;case f.Regular:{if(m.id>this.g)if(m.id!==this.g+1){const y=Date.now();y-this.m>1e4&&(this.m=y,this.p.write(new a(f.ReplayRequest,0,0,I())))}else this.g=m.id,this.j=Date.now(),this.A(),this.v.fire(m.data);break}case f.Control:{this.u.fire(m.data);break}case f.Ack:break;case f.Disconnect:{this.w.fire();break}case f.ReplayRequest:{const y=this.b.toArray();for(let S=0,E=y.length;S<E;S++)this.p.write(y[S]);this.B();break}case f.Pause:{this.p.pause();break}case f.Resume:{this.p.resume();break}case f.KeepAlive:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(m){const y=++this.c;this.h=this.g;const S=new a(f.Regular,y,this.h,m);this.b.push(S),this.a||(this.p.write(S),this.B())}sendControl(m){const y=new a(f.Control,0,0,m);this.p.write(y)}A(){if(this.g<=this.h||this.k)return;const m=Date.now()-this.j;if(m>=w.AcknowledgeTime){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},w.AcknowledgeTime-m+5)}B(){if(this.c<=this.d||this.f||this.a)return;const m=this.b.peek(),y=Date.now()-m.writtenTime,S=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(y>=w.TimeoutTime&&S>=w.TimeoutTime&&E>=w.TimeoutTime&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:y,timeSinceLastReceivedSomeData:S});return}const k=Math.max(w.TimeoutTime-y,w.TimeoutTime-S,w.TimeoutTime-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},k)}C(){if(this.g<=this.h)return;this.h=this.g;const m=new a(f.Ack,0,this.h,I());this.p.write(m)}D(){this.h=this.g;const m=new a(f.KeepAlive,0,this.h,I());this.p.write(m)}}e.$oi=h}),define(Ee[190],Se([1,0,57,7,22,21,186,14,4,3,25,109,104,87]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=e.$9q=void 0;class w extends A.$ci{constructor(g){super({send:$=>{try{process.send?.($.buffer.toString("base64"))}catch{}},onMessage:p.Event.fromNodeEventEmitter(process,"message",$=>P.$Je.wrap(Buffer.from($,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$9q=w;class a{constructor(g,$){this.i=g,this.j=$,this.c=new Set,this.g=new Map,this.h=new p.$he,this.onDidProcessExit=this.h.event;const i=$&&$.timeout?$.timeout:6e4;this.b=new u.$xh(i),this.d=null,this.f=null}getChannel(g){const $=this;return{call(i,o,n){return $.k(g,i,o,n)},listen(i,o){return $.l(g,i,o)}}}k(g,$,i,o=T.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(R.$6());this.b.cancel();const n=this.n(g),t=(0,u.$nh)(s=>n.call($,i,s)),c=o.onCancellationRequested(()=>t.cancel()),h=(0,l.$Sc)(()=>t.cancel());return this.c.add(h),t.finally(()=>{c.dispose(),this.c.delete(h),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,$,i){if(!this.b)return p.Event.None;this.b.cancel();let o;const n=new p.$he({onWillAddFirstListener:()=>{o=this.n(g).listen($,i)(n.fire,n),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return n.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],$=Object.create(null);$.env={...(0,I.$0n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&($.env={...$.env,...this.j.env}),this.j&&this.j.freshExecArgv&&($.execArgv=[]),this.j&&typeof this.j.debug=="number"&&($.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&($.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),$.execArgv===void 0&&($.execArgv=process.execArgv.filter(y=>!/^--inspect(-brk)?=/.test(y)).filter(y=>!y.startsWith("--vscode-"))),(0,f.$tm)($.env),this.d=(0,r.fork)(this.i,g,$);const i=new p.$he,n=p.Event.fromNodeEventEmitter(this.d,"message",y=>y)(y=>{if((0,L.$5q)(y)){(0,L.log)(y,`IPC Library: ${this.j.serverName}`);return}i.fire(P.$Je.wrap(Buffer.from(y,"base64")))}),t=this.j.useQueue?(0,D.$vm)(this.d):this.d,c=y=>this.d&&this.d.connected&&t.send(y.buffer.toString("base64")),h=i.event,s={send:c,onMessage:h};this.f=new A.$di(s);const m=()=>this.o();process.once("exit",m),this.d.on("error",y=>console.warn('IPC "'+this.j.serverName+'" errored with '+y)),this.d.on("exit",(y,S)=>{process.removeListener("exit",m),n.dispose(),this.c.forEach(E=>(0,l.$Pc)(E)),this.c.clear(),y!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+y+" and signal "+S),this.b?.cancel(),this.o(),this.h.fire({code:y,signal:S})})}return this.f}n(g){let $=this.g.get(g);return $||($=this.m.getChannel(g),this.g.set(g,$)),$}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$0q=a}),define(Ee[191],Se([1,0,7,4,3,55,18]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=e.StorageState=e.StorageHint=void 0,e.$5p=p;var R;(function(f){f[f.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",f[f.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function p(f){const A=f;return A?.changed instanceof Map||A?.deleted instanceof Set}var l;(function(f){f[f.None=0]="None",f[f.Initialized=1]="Initialized",f[f.Closed=2]="Closed"})(l||(e.StorageState=l={}));class I extends P.$Uc{constructor(A,w=Object.create(null)){super(),this.r=A,this.s=w,this.b=this.B(new u.$ke),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new r.$yh(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(A=>this.u(A)))}u(A){this.b.pause();try{A.changed?.forEach((w,a)=>this.w(a,w)),A.deleted?.forEach(w=>this.w(w,void 0))}finally{this.b.resume()}}w(A,w){if(this.c===l.Closed)return;let a=!1;(0,L.$jg)(w)?a=this.f.delete(A):this.f.get(A)!==w&&(this.f.set(A,w),a=!0),a&&this.b.fire({key:A,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(A,w){const a=this.f.get(A);return(0,L.$jg)(a)?w:a}getBoolean(A,w){const a=this.get(A);return(0,L.$jg)(a)?w:a==="true"}getNumber(A,w){const a=this.get(A);return(0,L.$jg)(a)?w:parseInt(a,10)}getObject(A,w){const a=this.get(A);return(0,L.$jg)(a)?w:(0,T.$9h)(a)}async set(A,w,a=!1){if(this.c===l.Closed)return;if((0,L.$jg)(w))return this.delete(A,a);const d=(0,L.$cg)(w)||Array.isArray(w)?(0,T.$8h)(w):String(w);if(this.f.get(A)!==d)return this.f.set(A,d),this.j.set(A,d),this.h.delete(A),this.b.fire({key:A,external:a}),this.D()}async delete(A,w=!1){if(!(this.c===l.Closed||!this.f.delete(A)))return this.h.has(A)||this.h.add(A),this.j.delete(A),this.b.fire({key:A,external:w}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const A={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(A).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(A){if(!(this.c===l.Closed||this.m))return this.D(A)}async D(A){return this.s.hint===R.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),A)}async whenFlushed(){if(this.z)return new Promise(A=>this.n.push(A))}isInMemory(){return this.s.hint===R.STORAGE_IN_MEMORY}}e.$6p=I,I.a=100;class D{constructor(){this.onDidChangeItemsExternal=u.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(A){A.insert?.forEach((w,a)=>this.a.set(a,w)),A.delete?.forEach(w=>this.a.delete(w))}async optimize(){}async close(){}}e.$7p=D}),define(Ee[140],Se([1,0,84]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pt=e.$ot=void 0;class u{constructor(R){const p=(0,r.$9e)(R);this.c=p,this.a=u.d(p),this.b=new Map}static d(R){const p=new Uint8Array(256);return p.fill(R),p}set(R,p){const l=(0,r.$9e)(p);R>=0&&R<256?this.a[R]=l:this.b.set(R,l)}get(R){return R>=0&&R<256?this.a[R]:this.b.get(R)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ot=u;var P;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(P||(P={}));class T{constructor(){this.a=new u(P.False)}add(R){this.a.set(R,P.True)}has(R){return this.a.get(R)===P.True}clear(){return this.a.clear()}}e.$pt=T}),define(Ee[192],Se([1,0,27]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$kv=P;var u;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(u||(e.StringEOL=u={}));function P(T){let L=0,R=0,p=0,l=u.Unknown;for(let I=0,D=T.length;I<D;I++){const f=T.charCodeAt(I);f===r.CharCode.CarriageReturn?(L===0&&(R=I),L++,I+1<D&&T.charCodeAt(I+1)===r.CharCode.LineFeed?(l|=u.CRLF,I++):l|=u.Invalid,p=I+1):f===r.CharCode.LineFeed&&(l|=u.LF,L===0&&(R=I),L++,p=I+1)}return L===0&&(R=T.length),[L,R,T.length-p,l]}}),define(Ee[58],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class r{constructor(P,T){this.lineNumber=P,this.column=T}with(P=this.lineNumber,T=this.column){return P===this.lineNumber&&T===this.column?this:new r(P,T)}delta(P=0,T=0){return this.with(this.lineNumber+P,this.column+T)}equals(P){return r.equals(this,P)}static equals(P,T){return!P&&!T?!0:!!P&&!!T&&P.lineNumber===T.lineNumber&&P.column===T.column}isBefore(P){return r.isBefore(this,P)}static isBefore(P,T){return P.lineNumber<T.lineNumber?!0:T.lineNumber<P.lineNumber?!1:P.column<T.column}isBeforeOrEqual(P){return r.isBeforeOrEqual(this,P)}static isBeforeOrEqual(P,T){return P.lineNumber<T.lineNumber?!0:T.lineNumber<P.lineNumber?!1:P.column<=T.column}static compare(P,T){const L=P.lineNumber|0,R=T.lineNumber|0;if(L===R){const p=P.column|0,l=T.column|0;return p-l}return L-R}clone(){return new r(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(P){return new r(P.lineNumber,P.column)}static isIPosition(P){return P&&typeof P.lineNumber=="number"&&typeof P.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$ct=r}),define(Ee[31],Se([1,0,58]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=void 0;class u{constructor(T,L,R,p){T>R||T===R&&L>p?(this.startLineNumber=R,this.startColumn=p,this.endLineNumber=T,this.endColumn=L):(this.startLineNumber=T,this.startColumn=L,this.endLineNumber=R,this.endColumn=p)}isEmpty(){return u.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return u.containsPosition(this,T)}static containsPosition(T,L){return!(L.lineNumber<T.startLineNumber||L.lineNumber>T.endLineNumber||L.lineNumber===T.startLineNumber&&L.column<T.startColumn||L.lineNumber===T.endLineNumber&&L.column>T.endColumn)}static strictContainsPosition(T,L){return!(L.lineNumber<T.startLineNumber||L.lineNumber>T.endLineNumber||L.lineNumber===T.startLineNumber&&L.column<=T.startColumn||L.lineNumber===T.endLineNumber&&L.column>=T.endColumn)}containsRange(T){return u.containsRange(this,T)}static containsRange(T,L){return!(L.startLineNumber<T.startLineNumber||L.endLineNumber<T.startLineNumber||L.startLineNumber>T.endLineNumber||L.endLineNumber>T.endLineNumber||L.startLineNumber===T.startLineNumber&&L.startColumn<T.startColumn||L.endLineNumber===T.endLineNumber&&L.endColumn>T.endColumn)}strictContainsRange(T){return u.strictContainsRange(this,T)}static strictContainsRange(T,L){return!(L.startLineNumber<T.startLineNumber||L.endLineNumber<T.startLineNumber||L.startLineNumber>T.endLineNumber||L.endLineNumber>T.endLineNumber||L.startLineNumber===T.startLineNumber&&L.startColumn<=T.startColumn||L.endLineNumber===T.endLineNumber&&L.endColumn>=T.endColumn)}plusRange(T){return u.plusRange(this,T)}static plusRange(T,L){let R,p,l,I;return L.startLineNumber<T.startLineNumber?(R=L.startLineNumber,p=L.startColumn):L.startLineNumber===T.startLineNumber?(R=L.startLineNumber,p=Math.min(L.startColumn,T.startColumn)):(R=T.startLineNumber,p=T.startColumn),L.endLineNumber>T.endLineNumber?(l=L.endLineNumber,I=L.endColumn):L.endLineNumber===T.endLineNumber?(l=L.endLineNumber,I=Math.max(L.endColumn,T.endColumn)):(l=T.endLineNumber,I=T.endColumn),new u(R,p,l,I)}intersectRanges(T){return u.intersectRanges(this,T)}static intersectRanges(T,L){let R=T.startLineNumber,p=T.startColumn,l=T.endLineNumber,I=T.endColumn;const D=L.startLineNumber,f=L.startColumn,A=L.endLineNumber,w=L.endColumn;return R<D?(R=D,p=f):R===D&&(p=Math.max(p,f)),l>A?(l=A,I=w):l===A&&(I=Math.min(I,w)),R>l||R===l&&p>I?null:new u(R,p,l,I)}equalsRange(T){return u.equalsRange(this,T)}static equalsRange(T,L){return!T&&!L?!0:!!T&&!!L&&T.startLineNumber===L.startLineNumber&&T.startColumn===L.startColumn&&T.endLineNumber===L.endLineNumber&&T.endColumn===L.endColumn}getEndPosition(){return u.getEndPosition(this)}static getEndPosition(T){return new r.$ct(T.endLineNumber,T.endColumn)}getStartPosition(){return u.getStartPosition(this)}static getStartPosition(T){return new r.$ct(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,L){return new u(this.startLineNumber,this.startColumn,T,L)}setStartPosition(T,L){return new u(T,L,this.endLineNumber,this.endColumn)}collapseToStart(){return u.collapseToStart(this)}static collapseToStart(T){return new u(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}collapseToEnd(){return u.collapseToEnd(this)}static collapseToEnd(T){return new u(T.endLineNumber,T.endColumn,T.endLineNumber,T.endColumn)}delta(T){return new u(this.startLineNumber+T,this.startColumn,this.endLineNumber+T,this.endColumn)}static fromPositions(T,L=T){return new u(T.lineNumber,T.column,L.lineNumber,L.column)}static lift(T){return T?new u(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,L){return!(T.endLineNumber<L.startLineNumber||T.endLineNumber===L.startLineNumber&&T.endColumn<L.startColumn||L.endLineNumber<T.startLineNumber||L.endLineNumber===T.startLineNumber&&L.endColumn<T.startColumn)}static areIntersecting(T,L){return!(T.endLineNumber<L.startLineNumber||T.endLineNumber===L.startLineNumber&&T.endColumn<=L.startColumn||L.endLineNumber<T.startLineNumber||L.endLineNumber===T.startLineNumber&&L.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,L){if(T&&L){const l=T.startLineNumber|0,I=L.startLineNumber|0;if(l===I){const D=T.startColumn|0,f=L.startColumn|0;if(D===f){const A=T.endLineNumber|0,w=L.endLineNumber|0;if(A===w){const a=T.endColumn|0,d=L.endColumn|0;return a-d}return A-w}return D-f}return l-I}return(T?1:0)-(L?1:0)}static compareRangesUsingEnds(T,L){return T.endLineNumber===L.endLineNumber?T.endColumn===L.endColumn?T.startLineNumber===L.startLineNumber?T.startColumn-L.startColumn:T.startLineNumber-L.startLineNumber:T.endColumn-L.endColumn:T.endLineNumber-L.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}toJSON(){return this}}e.$dt=u}),define(Ee[193],Se([1,0,31]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=void 0;class u{static insert(T,L){return{range:new r.$dt(T.lineNumber,T.column,T.lineNumber,T.column),text:L,forceMoveMarkers:!0}}static delete(T){return{range:T,text:null}}static replace(T,L){return{range:T,text:L}}static replaceMove(T,L){return{range:T,text:L,forceMoveMarkers:!0}}}e.$et=u}),define(Ee[194],Se([1,0,58,31]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.SelectionDirection=void 0;var P;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(P||(e.SelectionDirection=P={}));class T extends u.$dt{constructor(R,p,l,I){super(R,p,l,I),this.selectionStartLineNumber=R,this.selectionStartColumn=p,this.positionLineNumber=l,this.positionColumn=I}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(R){return T.selectionsEqual(this,R)}static selectionsEqual(R,p){return R.selectionStartLineNumber===p.selectionStartLineNumber&&R.selectionStartColumn===p.selectionStartColumn&&R.positionLineNumber===p.positionLineNumber&&R.positionColumn===p.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?P.LTR:P.RTL}setEndPosition(R,p){return this.getDirection()===P.LTR?new T(this.startLineNumber,this.startColumn,R,p):new T(R,p,this.startLineNumber,this.startColumn)}getPosition(){return new r.$ct(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new r.$ct(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(R,p){return this.getDirection()===P.LTR?new T(R,p,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,R,p)}static fromPositions(R,p=R){return new T(R.lineNumber,R.column,p.lineNumber,p.column)}static fromRange(R,p){return p===P.LTR?new T(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):new T(R.endLineNumber,R.endColumn,R.startLineNumber,R.startColumn)}static liftSelection(R){return new T(R.selectionStartLineNumber,R.selectionStartColumn,R.positionLineNumber,R.positionColumn)}static selectionsArrEqual(R,p){if(R&&!p||!R&&p)return!1;if(!R&&!p)return!0;if(R.length!==p.length)return!1;for(let l=0,I=R.length;l<I;l++)if(!this.selectionsEqual(R[l],p[l]))return!1;return!0}static isISelection(R){return R&&typeof R.selectionStartLineNumber=="number"&&typeof R.selectionStartColumn=="number"&&typeof R.positionLineNumber=="number"&&typeof R.positionColumn=="number"}static createWithDirection(R,p,l,I,D){return D===P.LTR?new T(R,p,l,I):new T(l,I,R,p)}}e.$ft=T}),define(Ee[195],Se([1,0,13,11,22]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0,e.$jt=I,e.$kt=D;let T;function L(){return T||(T=new TextDecoder("UTF-16LE")),T}let R;function p(){return R||(R=new TextDecoder("UTF-16BE")),R}let l;function I(){return l||(l=u.$x()?L():p()),l}function D(w,a,d){const g=new Uint16Array(w.buffer,a,d);return d>0&&(g[0]===65279||g[0]===65534)?f(w,a,d):L().decode(g)}function f(w,a,d){const g=[];let $=0;for(let i=0;i<d;i++){const o=P.$Le(w,a);a+=2,g[$++]=String.fromCharCode(o)}return g.join("")}class A{constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return I().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const d=this.a-this.d;d<=1&&(d===0||r.$Ff(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const d=a.length;if(this.d+d>=this.a){this.f(),this.c[this.c.length]=a;return}for(let g=0;g<d;g++)this.b[this.d++]=a.charCodeAt(g)}}e.$lt=A}),define(Ee[196],Se([1,0,22,195]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=void 0,e.$nt=L;function P(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class T{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(l,I,D,f){this.oldPosition=l,this.oldText=I,this.newPosition=D,this.newText=f}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(l){return 4+2*l.length}static c(l,I,D){const f=I.length;r.$Oe(l,f,D),D+=4;for(let A=0;A<f;A++)r.$Me(l,I.charCodeAt(A),D),D+=2;return D}static d(l,I){const D=r.$Ne(l,I);return I+=4,(0,u.$kt)(l,I,D)}writeSize(){return 8+T.a(this.oldText)+T.a(this.newText)}write(l,I){return r.$Oe(l,this.oldPosition,I),I+=4,r.$Oe(l,this.newPosition,I),I+=4,I=T.c(l,this.oldText,I),I=T.c(l,this.newText,I),I}static read(l,I,D){const f=r.$Ne(l,I);I+=4;const A=r.$Ne(l,I);I+=4;const w=T.d(l,I);I+=T.a(w);const a=T.d(l,I);return I+=T.a(a),D.push(new T(f,w,A,a)),I}}e.$mt=T;function L(p,l){return p===null||p.length===0?l:new R(p,l).compress()}class R{constructor(l,I){this.a=l,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let l=0,I=0,D=this.n(l),f=this.l(I);for(;l<this.f||I<this.h;){if(D===null){this.k(f),f=this.l(++I);continue}if(f===null){this.m(D),D=this.n(++l);continue}if(f.oldEnd<=D.newPosition){this.k(f),f=this.l(++I);continue}if(D.newEnd<=f.oldPosition){this.m(D),D=this.n(++l);continue}if(f.oldPosition<D.newPosition){const[g,$]=R.r(f,D.newPosition-f.oldPosition);this.k(g),f=$;continue}if(D.newPosition<f.oldPosition){const[g,$]=R.q(D,f.oldPosition-D.newPosition);this.m(g),D=$;continue}let a,d;if(f.oldEnd===D.newEnd)a=D,d=f,D=this.n(++l),f=this.l(++I);else if(f.oldEnd<D.newEnd){const[g,$]=R.q(D,f.oldLength);a=g,d=f,D=$,f=this.l(++I)}else{const[g,$]=R.r(f,D.newLength);a=D,d=g,D=this.n(++l),f=$}this.d[this.e++]=new T(a.oldPosition,a.oldText,d.newPosition,d.newText),this.g+=a.newLength-a.oldLength,this.j+=d.newLength-d.oldLength}const A=R.s(this.d);return R.t(A)}k(l){this.d[this.e++]=R.o(this.g,l),this.j+=l.newLength-l.oldLength}l(l){return l<this.h?this.c[l]:null}m(l){this.d[this.e++]=R.p(this.j,l),this.g+=l.newLength-l.oldLength}n(l){return l<this.f?this.a[l]:null}static o(l,I){return new T(I.oldPosition-l,I.oldText,I.newPosition,I.newText)}static p(l,I){return new T(I.oldPosition,I.oldText,I.newPosition+l,I.newText)}static q(l,I){const D=l.newText.substr(0,I),f=l.newText.substr(I);return[new T(l.oldPosition,l.oldText,l.newPosition,D),new T(l.oldEnd,"",l.newPosition+I,f)]}static r(l,I){const D=l.oldText.substr(0,I),f=l.oldText.substr(I);return[new T(l.oldPosition,D,l.newPosition,l.newText),new T(l.oldPosition+I,f,l.newEnd,"")]}static s(l){if(l.length===0)return l;const I=[];let D=0,f=l[0];for(let A=1;A<l.length;A++){const w=l[A];f.oldEnd===w.oldPosition?f=new T(f.oldPosition,f.oldText+w.oldText,f.newPosition,f.newText+w.newText):(I[D++]=f,f=w)}return I[D++]=f,I}static t(l){if(l.length===0)return l;const I=[];let D=0;for(let f=0;f<l.length;f++){const A=l[f];A.oldText!==A.newText&&(I[D++]=A)}return I}}}),define(Ee[197],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=void 0,e.$ou={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[198],Se([1,0,27,29,140]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qt=e.WordCharacterClass=void 0,e.$rt=p;var T;(function(l){l[l.Regular=0]="Regular",l[l.Whitespace=1]="Whitespace",l[l.WordSeparator=2]="WordSeparator"})(T||(e.WordCharacterClass=T={}));class L extends P.$ot{constructor(I,D){super(T.Regular),this.e=null,this.f=null,this.g=[],this.intlSegmenterLocales=D,this.intlSegmenterLocales.length>0?this.e=new Intl.Segmenter(this.intlSegmenterLocales,{granularity:"word"}):this.e=null;for(let f=0,A=I.length;f<A;f++)this.set(I.charCodeAt(f),T.WordSeparator);this.set(r.CharCode.Space,T.Whitespace),this.set(r.CharCode.Tab,T.Whitespace)}findPrevIntlWordBeforeOrAtOffset(I,D){let f=null;for(const A of this.h(I)){if(A.index>D)break;f=A}return f}findNextIntlWordAtOrAfterOffset(I,D){for(const f of this.h(I))if(!(f.index<D))return f;return null}h(I){return this.e?this.f===I?this.g:(this.f=I,this.g=this.j(this.e.segment(I)),this.g):[]}j(I){const D=[];for(const f of I)this.k(f)&&D.push(f);return D}k(I){return!!I.isWordLike}}e.$qt=L;const R=new u.$Dc(10);function p(l,I){const D=`${l}/${I.join(",")}`;let f=R.get(D);return f||(f=new L(l,I),R.set(D,f)),f}}),define(Ee[141],Se([1,0,40,3,81]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=void 0,e.$ut=L,e.$vt=p,e.$wt=l,e.$st="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function T(D=""){let f="(-?\\d*\\.\\d\\w*)|([^";for(const A of e.$st)D.indexOf(A)>=0||(f+="\\"+A);return f+="\\s]+)",new RegExp(f,"g")}e.$tt=T();function L(D){let f=e.$tt;if(D&&D instanceof RegExp)if(D.global)f=D;else{let A="g";D.ignoreCase&&(A+="i"),D.multiline&&(A+="m"),D.unicode&&(A+="u"),f=new RegExp(D.source,A)}return f.lastIndex=0,f}const R=new P.$5c;R.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function p(D){const f=R.unshift(D);return(0,u.$Sc)(f)}function l(D,f,A,w,a){if(f=L(f),a||(a=r.Iterable.first(R)),A.length>a.maxLen){let o=D-a.maxLen/2;return o<0?o=0:w+=o,A=A.substring(o,D+a.maxLen/2),l(D,f,A,w,a)}const d=Date.now(),g=D-1-w;let $=-1,i=null;for(let o=1;!(Date.now()-d>=a.timeBudget);o++){const n=g-a.windowSize*o;f.lastIndex=Math.max(0,n);const t=I(f,A,g,$);if(!t&&i||(i=t,n<=0))break;$=n}if(i){const o={word:i[0],startColumn:w+1+i.index,endColumn:w+1+i.index+i[0].length};return f.lastIndex=0,o}return null}function I(D,f,A,w){let a;for(;a=D.exec(f);){const d=a.index||0;if(d<=A&&D.lastIndex>=A)return a;if(w>0&&d>w)return null}return null}}),define(Ee[110],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var r;(function(p){p[p.Null=0]="Null",p[p.PlainText=1]="PlainText"})(r||(e.LanguageId=r={}));var u;(function(p){p[p.NotSet=-1]="NotSet",p[p.None=0]="None",p[p.Italic=1]="Italic",p[p.Bold=2]="Bold",p[p.Underline=4]="Underline",p[p.Strikethrough=8]="Strikethrough"})(u||(e.FontStyle=u={}));var P;(function(p){p[p.None=0]="None",p[p.DefaultForeground=1]="DefaultForeground",p[p.DefaultBackground=2]="DefaultBackground"})(P||(e.ColorId=P={}));var T;(function(p){p[p.Other=0]="Other",p[p.Comment=1]="Comment",p[p.String=2]="String",p[p.RegEx=3]="RegEx"})(T||(e.StandardTokenType=T={}));var L;(function(p){p[p.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",p[p.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",p[p.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",p[p.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",p[p.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",p[p.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",p[p.ITALIC_MASK=2048]="ITALIC_MASK",p[p.BOLD_MASK=4096]="BOLD_MASK",p[p.UNDERLINE_MASK=8192]="UNDERLINE_MASK",p[p.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",p[p.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",p[p.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",p[p.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",p[p.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",p[p.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",p[p.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",p[p.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",p[p.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",p[p.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",p[p.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",p[p.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",p[p.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(L||(e.MetadataConsts=L={}));class R{static getLanguageId(l){return(l&L.LANGUAGEID_MASK)>>>L.LANGUAGEID_OFFSET}static getTokenType(l){return(l&L.TOKEN_TYPE_MASK)>>>L.TOKEN_TYPE_OFFSET}static containsBalancedBrackets(l){return(l&L.BALANCED_BRACKETS_MASK)!==0}static getFontStyle(l){return(l&L.FONT_STYLE_MASK)>>>L.FONT_STYLE_OFFSET}static getForeground(l){return(l&L.FOREGROUND_MASK)>>>L.FOREGROUND_OFFSET}static getBackground(l){return(l&L.BACKGROUND_MASK)>>>L.BACKGROUND_OFFSET}static getClassNameFromMetadata(l){let D="mtk"+this.getForeground(l);const f=this.getFontStyle(l);return f&u.Italic&&(D+=" mtki"),f&u.Bold&&(D+=" mtkb"),f&u.Underline&&(D+=" mtku"),f&u.Strikethrough&&(D+=" mtks"),D}static getInlineStyleFromMetadata(l,I){const D=this.getForeground(l),f=this.getFontStyle(l);let A=`color: ${I[D]};`;f&u.Italic&&(A+="font-style: italic;"),f&u.Bold&&(A+="font-weight: bold;");let w="";return f&u.Underline&&(w+=" underline"),f&u.Strikethrough&&(w+=" line-through"),w&&(A+=`text-decoration:${w};`),A}static getPresentationFromMetadata(l){const I=this.getForeground(l),D=this.getFontStyle(l);return{foreground:I,italic:!!(D&u.Italic),bold:!!(D&u.Bold),underline:!!(D&u.Underline),strikethrough:!!(D&u.Strikethrough)}}}e.$gt=R}),define(Ee[199],Se([1,0,39,16]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=P,e.$it=T;function P(L,R,p,l,I,D){if(Array.isArray(L)){let f=0;for(const A of L){const w=P(A,R,p,l,I,D);if(w===10)return w;w>f&&(f=w)}return f}else{if(typeof L=="string")return l?L==="*"?5:L===p?10:0:0;if(L){const{language:f,pattern:A,scheme:w,hasAccessToAllModels:a,notebookType:d}=L;if(!l&&!a)return 0;d&&I&&(R=I);let g=0;if(w)if(w===R.scheme)g=10;else if(w==="*")g=5;else return 0;if(f)if(f===p)g=10;else if(f==="*")g=Math.max(g,5);else return 0;if(d)if(d===D)g=10;else if(d==="*"&&D!==void 0)g=Math.max(g,5);else return 0;if(A){let $;if(typeof A=="string"?$=A:$={...A,base:(0,u.$hc)(A.base)},$===R.fsPath||(0,r.$tk)($,R.fsPath))g=10;else return 0}return g}else return 0}}function T(L){return typeof L=="string"?!1:Array.isArray(L)?L.some(T):!!L.notebookType}}),define(Ee[200],Se([1,0,27,110]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=e.$Dt=e.IndentAction=void 0;var P;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class T{constructor(l){if(this.e=null,this.f=!1,this.open=l.open,this.close=l.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(l.notIn))for(let I=0,D=l.notIn.length;I<D;I++)switch(l.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(l){switch(l){case u.StandardTokenType.Other:return!0;case u.StandardTokenType.Comment:return this.c;case u.StandardTokenType.String:return this.b;case u.StandardTokenType.RegEx:return this.d}}shouldAutoClose(l,I){if(l.getTokenCount()===0)return!0;const D=l.findTokenIndexAtOffset(I-2),f=l.getStandardTokenType(D);return this.isOK(f)}g(l,I){for(let D=l;D<=I;D++){const f=String.fromCharCode(D);if(!this.open.includes(f)&&!this.close.includes(f))return f}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(r.CharCode.Digit0,r.CharCode.Digit9)),this.e||(this.e=this.g(r.CharCode.a,r.CharCode.z)),this.e||(this.e=this.g(r.CharCode.A,r.CharCode.Z))),this.e}}e.$Dt=T;class L{constructor(l){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of l)R(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),R(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),R(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),R(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&R(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Et=L;function R(p,l,I){p.has(l)?p.get(l).push(I):p.set(l,[I])}}),define(Ee[201],Se([1,0,27,140]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_2=e.$$2=e.State=void 0,e.$a3=A;var P;(function(w){w[w.Invalid=0]="Invalid",w[w.Start=1]="Start",w[w.H=2]="H",w[w.HT=3]="HT",w[w.HTT=4]="HTT",w[w.HTTP=5]="HTTP",w[w.F=6]="F",w[w.FI=7]="FI",w[w.FIL=8]="FIL",w[w.BeforeColon=9]="BeforeColon",w[w.AfterColon=10]="AfterColon",w[w.AlmostThere=11]="AlmostThere",w[w.End=12]="End",w[w.Accept=13]="Accept",w[w.LastKnownState=14]="LastKnownState"})(P||(e.State=P={}));class T{constructor(a,d,g){const $=new Uint8Array(a*d);for(let i=0,o=a*d;i<o;i++)$[i]=g;this.a=$,this.rows=a,this.cols=d}get(a,d){return this.a[a*this.cols+d]}set(a,d,g){this.a[a*this.cols+d]=g}}class L{constructor(a){let d=0,g=P.Invalid;for(let i=0,o=a.length;i<o;i++){const[n,t,c]=a[i];t>d&&(d=t),n>g&&(g=n),c>g&&(g=c)}d++,g++;const $=new T(g,d,P.Invalid);for(let i=0,o=a.length;i<o;i++){const[n,t,c]=a[i];$.set(n,t,c)}this.a=$,this.b=d}nextState(a,d){return d<0||d>=this.b?P.Invalid:this.a.get(a,d)}}e.$$2=L;let R=null;function p(){return R===null&&(R=new L([[P.Start,r.CharCode.h,P.H],[P.Start,r.CharCode.H,P.H],[P.Start,r.CharCode.f,P.F],[P.Start,r.CharCode.F,P.F],[P.H,r.CharCode.t,P.HT],[P.H,r.CharCode.T,P.HT],[P.HT,r.CharCode.t,P.HTT],[P.HT,r.CharCode.T,P.HTT],[P.HTT,r.CharCode.p,P.HTTP],[P.HTT,r.CharCode.P,P.HTTP],[P.HTTP,r.CharCode.s,P.BeforeColon],[P.HTTP,r.CharCode.S,P.BeforeColon],[P.HTTP,r.CharCode.Colon,P.AfterColon],[P.F,r.CharCode.i,P.FI],[P.F,r.CharCode.I,P.FI],[P.FI,r.CharCode.l,P.FIL],[P.FI,r.CharCode.L,P.FIL],[P.FIL,r.CharCode.e,P.BeforeColon],[P.FIL,r.CharCode.E,P.BeforeColon],[P.BeforeColon,r.CharCode.Colon,P.AfterColon],[P.AfterColon,r.CharCode.Slash,P.AlmostThere],[P.AlmostThere,r.CharCode.Slash,P.End]])),R}var l;(function(w){w[w.None=0]="None",w[w.ForceTermination=1]="ForceTermination",w[w.CannotEndIn=2]="CannotEndIn"})(l||(l={}));let I=null;function D(){if(I===null){I=new u.$ot(l.None);const w=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<w.length;d++)I.set(w.charCodeAt(d),l.ForceTermination);const a=".,;:";for(let d=0;d<a.length;d++)I.set(a.charCodeAt(d),l.CannotEndIn)}return I}class f{static a(a,d,g,$,i){let o=i-1;do{const n=d.charCodeAt(o);if(a.get(n)!==l.CannotEndIn)break;o--}while(o>$);if($>0){const n=d.charCodeAt($-1),t=d.charCodeAt(o);(n===r.CharCode.OpenParen&&t===r.CharCode.CloseParen||n===r.CharCode.OpenSquareBracket&&t===r.CharCode.CloseSquareBracket||n===r.CharCode.OpenCurlyBrace&&t===r.CharCode.CloseCurlyBrace)&&o--}return{range:{startLineNumber:g,startColumn:$+1,endLineNumber:g,endColumn:o+2},url:d.substring($,o+1)}}static computeLinks(a,d=p()){const g=D(),$=[];for(let i=1,o=a.getLineCount();i<=o;i++){const n=a.getLineContent(i),t=n.length;let c=0,h=0,s=0,m=P.Start,y=!1,S=!1,E=!1,k=!1;for(;c<t;){let C=!1;const v=n.charCodeAt(c);if(m===P.Accept){let b;switch(v){case r.CharCode.OpenParen:y=!0,b=l.None;break;case r.CharCode.CloseParen:b=y?l.None:l.ForceTermination;break;case r.CharCode.OpenSquareBracket:E=!0,S=!0,b=l.None;break;case r.CharCode.CloseSquareBracket:E=!1,b=S?l.None:l.ForceTermination;break;case r.CharCode.OpenCurlyBrace:k=!0,b=l.None;break;case r.CharCode.CloseCurlyBrace:b=k?l.None:l.ForceTermination;break;case r.CharCode.SingleQuote:case r.CharCode.DoubleQuote:case r.CharCode.BackTick:s===v?b=l.ForceTermination:s===r.CharCode.SingleQuote||s===r.CharCode.DoubleQuote||s===r.CharCode.BackTick?b=l.None:b=l.ForceTermination;break;case r.CharCode.Asterisk:b=s===r.CharCode.Asterisk?l.ForceTermination:l.None;break;case r.CharCode.Pipe:b=s===r.CharCode.Pipe?l.ForceTermination:l.None;break;case r.CharCode.Space:b=E?l.None:l.ForceTermination;break;default:b=g.get(v)}b===l.ForceTermination&&($.push(f.a(g,n,i,h,c)),C=!0)}else if(m===P.End){let b;v===r.CharCode.OpenSquareBracket?(S=!0,b=l.None):b=g.get(v),b===l.ForceTermination?C=!0:m=P.Accept}else m=d.nextState(m,v),m===P.Invalid&&(C=!0);C&&(m=P.Start,y=!1,S=!1,k=!1,h=c+1,s=v),c++}m===P.Accept&&$.push(f.a(g,n,i,h,t))}return $}}e.$_2=f;function A(w){return!w||typeof w.getLineCount!="function"||typeof w.getLineContent!="function"?[]:f.computeLinks(w)}}),define(Ee[59],Se([1,0,25]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wv=e.$vv=e.$uv=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.$sv=e.$rv=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapSectionHeaderStyle=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0,e.$tv=w,e.$xv=o;var u;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(u||(e.OverviewRulerLane=u={}));var P;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(P||(e.GlyphMarginLane=P={}));var T;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(T||(e.MinimapPosition=T={}));var L;(function(n){n[n.Normal=1]="Normal",n[n.Underlined=2]="Underlined"})(L||(e.MinimapSectionHeaderStyle=L={}));var R;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var p;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(p||(e.EndOfLinePreference=p={}));var l;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(l||(e.DefaultEndOfLine=l={}));var I;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(I||(e.EndOfLineSequence=I={}));class D{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(t){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,t.tabSize|0),t.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,t.indentSize|0),this.a=!1),this.insertSpaces=!!t.insertSpaces,this.defaultEOL=t.defaultEOL|0,this.trimAutoWhitespace=!!t.trimAutoWhitespace,this.bracketPairColorizationOptions=t.bracketPairColorizationOptions}equals(t){return this.tabSize===t.tabSize&&this.a===t.a&&this.indentSize===t.indentSize&&this.insertSpaces===t.insertSpaces&&this.defaultEOL===t.defaultEOL&&this.trimAutoWhitespace===t.trimAutoWhitespace&&(0,r.$bo)(this.bracketPairColorizationOptions,t.bracketPairColorizationOptions)}createChangeEvent(t){return{tabSize:this.tabSize!==t.tabSize,indentSize:this.indentSize!==t.indentSize,insertSpaces:this.insertSpaces!==t.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==t.trimAutoWhitespace}}}e.$rv=D;class f{constructor(t,c){this._findMatchBrand=void 0,this.range=t,this.matches=c}}e.$sv=f;var A;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(A||(e.TrackedRangeStickiness=A={}));function w(n){return n&&typeof n.read=="function"}var a;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(a||(e.PositionAffinity=a={}));var d;(function(n){n[n.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(d||(e.ModelConstants=d={}));class g{constructor(t,c,h,s,m,y){this.identifier=t,this.range=c,this.text=h,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=m,this._isTracked=y}}e.$uv=g;class ${constructor(t,c,h){this.regex=t,this.wordSeparators=c,this.simpleSearch=h}}e.$vv=$;class i{constructor(t,c,h){this.reverseEdits=t,this.changes=c,this.trimAutoWhitespaceLineNumbers=h}}e.$wv=i;function o(n){return!n.isTooLargeForSyncing()&&!n.isForSimpleWidget}}),define(Ee[202],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SC=e.NodeColor=e.$RC=void 0,e.$TC=P,e.$UC=T,e.$VC=l,e.$WC=I,e.$XC=D,e.$YC=f,e.$ZC=A,e.$1C=w;class r{constructor(d,g){this.piece=d,this.color=g,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$SC)return P(this.right);let d=this;for(;d.parent!==e.$SC&&d.parent.left!==d;)d=d.parent;return d.parent===e.$SC?e.$SC:d.parent}prev(){if(this.left!==e.$SC)return T(this.left);let d=this;for(;d.parent!==e.$SC&&d.parent.right!==d;)d=d.parent;return d.parent===e.$SC?e.$SC:d.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$RC=r;var u;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(u||(e.NodeColor=u={})),e.$SC=new r(null,u.Black),e.$SC.parent=e.$SC,e.$SC.left=e.$SC,e.$SC.right=e.$SC,e.$SC.color=u.Black;function P(a){for(;a.left!==e.$SC;)a=a.left;return a}function T(a){for(;a.right!==e.$SC;)a=a.right;return a}function L(a){return a===e.$SC?0:a.size_left+a.piece.length+L(a.right)}function R(a){return a===e.$SC?0:a.lf_left+a.piece.lineFeedCnt+R(a.right)}function p(){e.$SC.parent=e.$SC}function l(a,d){const g=d.right;g.size_left+=d.size_left+(d.piece?d.piece.length:0),g.lf_left+=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),d.right=g.left,g.left!==e.$SC&&(g.left.parent=d),g.parent=d.parent,d.parent===e.$SC?a.root=g:d.parent.left===d?d.parent.left=g:d.parent.right=g,g.left=d,d.parent=g}function I(a,d){const g=d.left;d.left=g.right,g.right!==e.$SC&&(g.right.parent=d),g.parent=d.parent,d.size_left-=g.size_left+(g.piece?g.piece.length:0),d.lf_left-=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),d.parent===e.$SC?a.root=g:d===d.parent.right?d.parent.right=g:d.parent.left=g,g.right=d,d.parent=g}function D(a,d){let g,$;if(d.left===e.$SC?($=d,g=$.right):d.right===e.$SC?($=d,g=$.left):($=P(d.right),g=$.right),$===a.root){a.root=g,g.color=u.Black,d.detach(),p(),a.root.parent=e.$SC;return}const i=$.color===u.Red;if($===$.parent.left?$.parent.left=g:$.parent.right=g,$===d?(g.parent=$.parent,w(a,g)):($.parent===d?g.parent=$:g.parent=$.parent,w(a,g),$.left=d.left,$.right=d.right,$.parent=d.parent,$.color=d.color,d===a.root?a.root=$:d===d.parent.left?d.parent.left=$:d.parent.right=$,$.left!==e.$SC&&($.left.parent=$),$.right!==e.$SC&&($.right.parent=$),$.size_left=d.size_left,$.lf_left=d.lf_left,w(a,$)),d.detach(),g.parent.left===g){const n=L(g),t=R(g);if(n!==g.parent.size_left||t!==g.parent.lf_left){const c=n-g.parent.size_left,h=t-g.parent.lf_left;g.parent.size_left=n,g.parent.lf_left=t,A(a,g.parent,c,h)}}if(w(a,g.parent),i){p();return}let o;for(;g!==a.root&&g.color===u.Black;)g===g.parent.left?(o=g.parent.right,o.color===u.Red&&(o.color=u.Black,g.parent.color=u.Red,l(a,g.parent),o=g.parent.right),o.left.color===u.Black&&o.right.color===u.Black?(o.color=u.Red,g=g.parent):(o.right.color===u.Black&&(o.left.color=u.Black,o.color=u.Red,I(a,o),o=g.parent.right),o.color=g.parent.color,g.parent.color=u.Black,o.right.color=u.Black,l(a,g.parent),g=a.root)):(o=g.parent.left,o.color===u.Red&&(o.color=u.Black,g.parent.color=u.Red,I(a,g.parent),o=g.parent.left),o.left.color===u.Black&&o.right.color===u.Black?(o.color=u.Red,g=g.parent):(o.left.color===u.Black&&(o.right.color=u.Black,o.color=u.Red,l(a,o),o=g.parent.left),o.color=g.parent.color,g.parent.color=u.Black,o.left.color=u.Black,I(a,g.parent),g=a.root));g.color=u.Black,p()}function f(a,d){for(w(a,d);d!==a.root&&d.parent.color===u.Red;)if(d.parent===d.parent.parent.left){const g=d.parent.parent.right;g.color===u.Red?(d.parent.color=u.Black,g.color=u.Black,d.parent.parent.color=u.Red,d=d.parent.parent):(d===d.parent.right&&(d=d.parent,l(a,d)),d.parent.color=u.Black,d.parent.parent.color=u.Red,I(a,d.parent.parent))}else{const g=d.parent.parent.left;g.color===u.Red?(d.parent.color=u.Black,g.color=u.Black,d.parent.parent.color=u.Red,d=d.parent.parent):(d===d.parent.left&&(d=d.parent,I(a,d)),d.parent.color=u.Black,d.parent.parent.color=u.Red,l(a,d.parent.parent))}a.root.color=u.Black}function A(a,d,g,$){for(;d!==a.root&&d!==e.$SC;)d.parent.left===d&&(d.parent.size_left+=g,d.parent.lf_left+=$),d=d.parent}function w(a,d){let g=0,$=0;if(d!==a.root){for(;d!==a.root&&d===d.parent.right;)d=d.parent;if(d!==a.root)for(d=d.parent,g=L(d.left)-d.size_left,$=R(d.left)-d.lf_left,d.size_left+=g,d.lf_left+=$;d!==a.root&&(g!==0||$!==0);)d.parent.left===d&&(d.parent.size_left+=g,d.parent.lf_left+=$),d=d.parent}}}),define(Ee[203],Se([1,0,19,84]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cw=e.$bw=e.$aw=void 0;class P{constructor(p){this.a=p,this.b=new Uint32Array(p.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(p,l){p=(0,u.$0e)(p);const I=this.a,D=this.b,f=l.length;return f===0?!1:(this.a=new Uint32Array(I.length+f),this.a.set(I.subarray(0,p),0),this.a.set(I.subarray(p),p+f),this.a.set(l,p),p-1<this.c[0]&&(this.c[0]=p-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(D.subarray(0,this.c[0]+1)),!0)}setValue(p,l){return p=(0,u.$0e)(p),l=(0,u.$0e)(l),this.a[p]===l?!1:(this.a[p]=l,p-1<this.c[0]&&(this.c[0]=p-1),!0)}removeValues(p,l){p=(0,u.$0e)(p),l=(0,u.$0e)(l);const I=this.a,D=this.b;if(p>=I.length)return!1;const f=I.length-p;return l>=f&&(l=f),l===0?!1:(this.a=new Uint32Array(I.length-l),this.a.set(I.subarray(0,p),0),this.a.set(I.subarray(p+l),p),this.b=new Uint32Array(this.a.length),p-1<this.c[0]&&(this.c[0]=p-1),this.c[0]>=0&&this.b.set(D.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(p){return p<0?0:(p=(0,u.$0e)(p),this.d(p))}d(p){if(p<=this.c[0])return this.b[p];let l=this.c[0]+1;l===0&&(this.b[0]=this.a[0],l++),p>=this.a.length&&(p=this.a.length-1);for(let I=l;I<=p;I++)this.b[I]=this.b[I-1]+this.a[I];return this.c[0]=Math.max(this.c[0],p),this.b[p]}getIndexOf(p){p=Math.floor(p),this.getTotalSum();let l=0,I=this.a.length-1,D=0,f=0,A=0;for(;l<=I;)if(D=l+(I-l)/2|0,f=this.b[D],A=f-this.a[D],p<A)I=D-1;else if(p>=f)l=D+1;else break;return new L(D,p-A)}}e.$aw=P;class T{constructor(p){this.a=p,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(p){return this.g(),p===0?0:this.d[p-1]}getIndexOf(p){this.g();const l=this.e[p],I=l>0?this.d[l-1]:0;return new L(l,p-I)}removeValues(p,l){this.a.splice(p,l),this.f(p)}insertValues(p,l){this.a=(0,r.$Vb)(this.a,p,l),this.f(p)}f(p){this.b=!1,this.c=Math.min(this.c,p-1)}g(){if(!this.b){for(let p=this.c+1,l=this.a.length;p<l;p++){const I=this.a[p],D=p>0?this.d[p-1]:0;this.d[p]=D+I;for(let f=0;f<I;f++)this.e[D+f]=p}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(p,l){this.a[p]!==l&&(this.a[p]=l,this.f(p))}}e.$bw=T;class L{constructor(p,l){this.index=p,this.remainder=l,this._prefixSumIndexOfResultBrand=void 0,this.index=p,this.remainder=l}}e.$cw=L}),define(Ee[204],Se([1,0,13,58,203]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dw=void 0;class T{constructor(R,p,l,I){this.d=R,this.f=p,this.g=l,this.h=I,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(R){R.eol&&R.eol!==this.g&&(this.g=R.eol,this.j=null);const p=R.changes;for(const l of p)this.o(l.range),this.p(new u.$ct(l.range.startLineNumber,l.range.startColumn),l.text);this.h=R.versionId,this.k=null}l(){if(!this.j){const R=this.g.length,p=this.f.length,l=new Uint32Array(p);for(let I=0;I<p;I++)l[I]=this.f[I].length+R;this.j=new P.$aw(l)}}n(R,p){this.f[R]=p,this.j&&this.j.setValue(R,this.f[R].length+this.g.length)}o(R){if(R.startLineNumber===R.endLineNumber){if(R.startColumn===R.endColumn)return;this.n(R.startLineNumber-1,this.f[R.startLineNumber-1].substring(0,R.startColumn-1)+this.f[R.startLineNumber-1].substring(R.endColumn-1));return}this.n(R.startLineNumber-1,this.f[R.startLineNumber-1].substring(0,R.startColumn-1)+this.f[R.endLineNumber-1].substring(R.endColumn-1)),this.f.splice(R.startLineNumber,R.endLineNumber-R.startLineNumber),this.j&&this.j.removeValues(R.startLineNumber,R.endLineNumber-R.startLineNumber)}p(R,p){if(p.length===0)return;const l=(0,r.$of)(p);if(l.length===1){this.n(R.lineNumber-1,this.f[R.lineNumber-1].substring(0,R.column-1)+l[0]+this.f[R.lineNumber-1].substring(R.column-1));return}l[l.length-1]+=this.f[R.lineNumber-1].substring(R.column-1),this.n(R.lineNumber-1,this.f[R.lineNumber-1].substring(0,R.column-1)+l[0]);const I=new Uint32Array(l.length-1);for(let D=1;D<l.length;D++)this.f.splice(R.lineNumber+D-1,0,l[D]),I[D-1]=l[D].length+this.g.length;this.j&&this.j.insertValues(R.lineNumber,I)}}e.$dw=T}),define(Ee[111],Se([1,0,27,13,198,58,31,59]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7C=e.$5C=e.$2C=void 0,e.$3C=I,e.$4C=D,e.$6C=d;const p=999;class l{constructor(i,o,n,t){this.searchString=i,this.isRegex=o,this.matchCase=n,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=I(this.searchString):i=this.searchString.indexOf(`
`)>=0;let o=null;try{o=u.$mf(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!o)return null;let n=!this.isRegex&&!i;return n&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(n=this.matchCase),new R.$vv(o,this.wordSeparators?(0,P.$rt)(this.wordSeparators,[]):null,n?this.searchString:null)}}e.$2C=l;function I($){if(!$||$.length===0)return!1;for(let i=0,o=$.length;i<o;i++){const n=$.charCodeAt(i);if(n===r.CharCode.LineFeed)return!0;if(n===r.CharCode.Backslash){if(i++,i>=o)break;const t=$.charCodeAt(i);if(t===r.CharCode.n||t===r.CharCode.r||t===r.CharCode.W)return!0}}return!1}function D($,i,o){if(!o)return new R.$sv($,null);const n=[];for(let t=0,c=i.length;t<c;t++)n[t]=i[t];return new R.$sv($,n)}class f{constructor(i){const o=[];let n=0;for(let t=0,c=i.length;t<c;t++)i.charCodeAt(t)===r.CharCode.LineFeed&&(o[n++]=t);this.a=o}findLineFeedCountBeforeOffset(i){const o=this.a;let n=0,t=o.length-1;if(t===-1||i<=o[0])return 0;for(;n<t;){const c=n+((t-n)/2>>0);o[c]>=i?t=c-1:o[c+1]>=i?(n=c,t=c):n=c+1}return n+1}}class A{static findMatches(i,o,n,t,c){const h=o.parseSearchRequest();return h?h.regex.multiline?this.b(i,n,new g(h.wordSeparators,h.regex),t,c):this.c(i,n,h,t,c):[]}static a(i,o,n,t,c,h){let s,m=0;t?(m=t.findLineFeedCountBeforeOffset(c),s=o+c+m):s=o+c;let y;if(t){const C=t.findLineFeedCountBeforeOffset(c+h.length)-m;y=s+h.length+C}else y=s+h.length;const S=i.getPositionAt(s),E=i.getPositionAt(y);return new L.$dt(S.lineNumber,S.column,E.lineNumber,E.column)}static b(i,o,n,t,c){const h=i.getOffsetAt(o.getStartPosition()),s=i.getValueInRange(o,R.EndOfLinePreference.LF),m=i.getEOL()===`\r
`?new f(s):null,y=[];let S=0,E;for(n.reset(0);E=n.next(s);)if(y[S++]=D(this.a(i,h,s,m,E.index,E[0]),E,t),S>=c)return y;return y}static c(i,o,n,t,c){const h=[];let s=0;if(o.startLineNumber===o.endLineNumber){const y=i.getLineContent(o.startLineNumber).substring(o.startColumn-1,o.endColumn-1);return s=this.d(n,y,o.startLineNumber,o.startColumn-1,s,h,t,c),h}const m=i.getLineContent(o.startLineNumber).substring(o.startColumn-1);s=this.d(n,m,o.startLineNumber,o.startColumn-1,s,h,t,c);for(let y=o.startLineNumber+1;y<o.endLineNumber&&s<c;y++)s=this.d(n,i.getLineContent(y),y,0,s,h,t,c);if(s<c){const y=i.getLineContent(o.endLineNumber).substring(0,o.endColumn-1);s=this.d(n,y,o.endLineNumber,0,s,h,t,c)}return h}static d(i,o,n,t,c,h,s,m){const y=i.wordSeparators;if(!s&&i.simpleSearch){const k=i.simpleSearch,C=k.length,v=o.length;let b=-C;for(;(b=o.indexOf(k,b+C))!==-1;)if((!y||d(y,o,v,b,C))&&(h[c++]=new R.$sv(new L.$dt(n,b+1+t,n,b+1+C+t),null),c>=m))return c;return c}const S=new g(i.wordSeparators,i.regex);let E;S.reset(0);do if(E=S.next(o),E&&(h[c++]=D(new L.$dt(n,E.index+1+t,n,E.index+1+E[0].length+t),E,s),c>=m))return c;while(E);return c}static findNextMatch(i,o,n,t){const c=o.parseSearchRequest();if(!c)return null;const h=new g(c.wordSeparators,c.regex);return c.regex.multiline?this.e(i,n,h,t):this.f(i,n,h,t)}static e(i,o,n,t){const c=new T.$ct(o.lineNumber,1),h=i.getOffsetAt(c),s=i.getLineCount(),m=i.getValueInRange(new L.$dt(c.lineNumber,c.column,s,i.getLineMaxColumn(s)),R.EndOfLinePreference.LF),y=i.getEOL()===`\r
`?new f(m):null;n.reset(o.column-1);const S=n.next(m);return S?D(this.a(i,h,m,y,S.index,S[0]),S,t):o.lineNumber!==1||o.column!==1?this.e(i,new T.$ct(1,1),n,t):null}static f(i,o,n,t){const c=i.getLineCount(),h=o.lineNumber,s=i.getLineContent(h),m=this.g(n,s,h,o.column,t);if(m)return m;for(let y=1;y<=c;y++){const S=(h+y-1)%c,E=i.getLineContent(S+1),k=this.g(n,E,S+1,1,t);if(k)return k}return null}static g(i,o,n,t,c){i.reset(t-1);const h=i.next(o);return h?D(new L.$dt(n,h.index+1,n,h.index+1+h[0].length),h,c):null}static findPreviousMatch(i,o,n,t){const c=o.parseSearchRequest();if(!c)return null;const h=new g(c.wordSeparators,c.regex);return c.regex.multiline?this.h(i,n,h,t):this.j(i,n,h,t)}static h(i,o,n,t){const c=this.b(i,new L.$dt(1,1,o.lineNumber,o.column),n,t,10*p);if(c.length>0)return c[c.length-1];const h=i.getLineCount();return o.lineNumber!==h||o.column!==i.getLineMaxColumn(h)?this.h(i,new T.$ct(h,i.getLineMaxColumn(h)),n,t):null}static j(i,o,n,t){const c=i.getLineCount(),h=o.lineNumber,s=i.getLineContent(h).substring(0,o.column-1),m=this.k(n,s,h,t);if(m)return m;for(let y=1;y<=c;y++){const S=(c+h-y-1)%c,E=i.getLineContent(S+1),k=this.k(n,E,S+1,t);if(k)return k}return null}static k(i,o,n,t){let c=null,h;for(i.reset(0);h=i.next(o);)c=D(new L.$dt(n,h.index+1,n,h.index+1+h[0].length),h,t);return c}}e.$5C=A;function w($,i,o,n,t){if(n===0)return!0;const c=i.charCodeAt(n-1);if($.get(c)!==P.WordCharacterClass.Regular||c===r.CharCode.CarriageReturn||c===r.CharCode.LineFeed)return!0;if(t>0){const h=i.charCodeAt(n);if($.get(h)!==P.WordCharacterClass.Regular)return!0}return!1}function a($,i,o,n,t){if(n+t===o)return!0;const c=i.charCodeAt(n+t);if($.get(c)!==P.WordCharacterClass.Regular||c===r.CharCode.CarriageReturn||c===r.CharCode.LineFeed)return!0;if(t>0){const h=i.charCodeAt(n+t-1);if($.get(h)!==P.WordCharacterClass.Regular)return!0}return!1}function d($,i,o,n,t){return w($,i,o,n,t)&&a($,i,o,n,t)}class g{constructor(i,o){this._wordSeparators=i,this.a=o,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const o=i.length;let n;do{if(this.b+this.c===o||(n=this.a.exec(i),!n))return null;const t=n.index,c=n[0].length;if(t===this.b&&c===this.c){if(c===0){u.$If(i,o,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=t,this.c=c,!this._wordSeparators||d(this._wordSeparators,i,o,t,c))return n}while(n);return null}}e.$7C=g}),define(Ee[142],Se([1,0,27,58,31,59,202,111]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.$0C=void 0,e.$8C=D,e.$9C=f;const p=65535;function l($){let i;return $[$.length-1]<65536?i=new Uint16Array($.length):i=new Uint32Array($.length),i.set($,0),i}class I{constructor(i,o,n,t,c){this.lineStarts=i,this.cr=o,this.lf=n,this.crlf=t,this.isBasicASCII=c}}function D($,i=!0){const o=[0];let n=1;for(let t=0,c=$.length;t<c;t++){const h=$.charCodeAt(t);h===r.CharCode.CarriageReturn?t+1<c&&$.charCodeAt(t+1)===r.CharCode.LineFeed?(o[n++]=t+2,t++):o[n++]=t+1:h===r.CharCode.LineFeed&&(o[n++]=t+1)}return i?l(o):o}function f($,i){$.length=0,$[0]=0;let o=1,n=0,t=0,c=0,h=!0;for(let m=0,y=i.length;m<y;m++){const S=i.charCodeAt(m);S===r.CharCode.CarriageReturn?m+1<y&&i.charCodeAt(m+1)===r.CharCode.LineFeed?(c++,$[o++]=m+2,m++):(n++,$[o++]=m+1):S===r.CharCode.LineFeed?(t++,$[o++]=m+1):h&&S!==r.CharCode.Tab&&(S<32||S>126)&&(h=!1)}const s=new I(l($),n,t,c,h);return $.length=0,s}class A{constructor(i,o,n,t,c){this.bufferIndex=i,this.start=o,this.end=n,this.lineFeedCnt=t,this.length=c}}e.$0C=A;class w{constructor(i,o){this.buffer=i,this.lineStarts=o}}e.$$C=w;class a{constructor(i,o){this.a=[],this.c=i,this.d=o,this.b=0,i.root!==L.$SC&&i.iterate(i.root,n=>(n!==L.$SC&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class d{constructor(i){this.a=i,this.b=[]}get(i){for(let o=this.b.length-1;o>=0;o--){const n=this.b[o];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let o=this.b.length-1;o>=0;o--){const n=this.b[o];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let o=!1;const n=this.b;for(let t=0;t<n.length;t++){const c=n[t];if(c.node.parent===null||c.nodeStartOffset>=i){n[t]=null,o=!0;continue}}if(o){const t=[];for(const c of n)c!==null&&t.push(c);this.b=t}}}class g{constructor(i,o,n){this.create(i,o,n)}create(i,o,n){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=L.$SC,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=n;let t=null;for(let c=0,h=i.length;c<h;c++)if(i[c].buffer.length>0){i[c].lineStarts||(i[c].lineStarts=D(i[c].buffer));const s=new A(c+1,{line:0,column:0},{line:i[c].lineStarts.length-1,column:i[c].buffer.length-i[c].lineStarts[i[c].lineStarts.length-1]},i[c].lineStarts.length-1,i[c].buffer.length);this.a.push(i[c]),t=this.S(t,s)}this.h=new d(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const o=p,n=o-Math.floor(o/3),t=n*2;let c="",h=0;const s=[];if(this.iterate(this.root,m=>{const y=this.R(m),S=y.length;if(h<=n||h+S<t)return c+=y,h+=S,!0;const E=c.replace(/\r\n|\r|\n/g,i);return s.push(new w(E,D(E))),c=y,h=S,!0}),h>0){const m=c.replace(/\r\n|\r|\n/g,i);s.push(new w(m,D(m)))}this.create(s,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new a(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let o=0;return this.iterate(this.root,t=>{if(t===L.$SC)return!0;const c=this.R(t),h=c.length,s=i.G(o),m=i.G(o+h),y=i.getValueInRange2(s,m);return o+=h,c===y})}getOffsetAt(i,o){let n=0,t=this.root;for(;t!==L.$SC;)if(t.left!==L.$SC&&t.lf_left+1>=i)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt+1>=i){n+=t.size_left;const c=this.B(t,i-t.lf_left-2);return n+=c+o-1}else i-=t.lf_left+t.piece.lineFeedCnt,n+=t.size_left+t.piece.length,t=t.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let o=this.root,n=0;const t=i;for(;o!==L.$SC;)if(o.size_left!==0&&o.size_left>=i)o=o.left;else if(o.size_left+o.piece.length>=i){const c=this.A(o,i-o.size_left);if(n+=o.lf_left+c.index,c.index===0){const h=this.getOffsetAt(n+1,1),s=t-h;return new u.$ct(n+1,s+1)}return new u.$ct(n+1,c.remainder+1)}else if(i-=o.size_left+o.piece.length,n+=o.lf_left+o.piece.lineFeedCnt,o.right===L.$SC){const c=this.getOffsetAt(n+1,1),h=t-i-c;return new u.$ct(n+1,h+1)}else o=o.right;return new u.$ct(1,1)}getValueInRange(i,o){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.H(i.startLineNumber,i.startColumn),t=this.H(i.endLineNumber,i.endColumn),c=this.getValueInRange2(n,t);return o?o!==this.d||!this.f?c.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?c:c.replace(/\r\n|\r|\n/g,o):c}getValueInRange2(i,o){if(i.node===o.node){const s=i.node,m=this.a[s.piece.bufferIndex].buffer,y=this.u(s.piece.bufferIndex,s.piece.start);return m.substring(y+i.remainder,y+o.remainder)}let n=i.node;const t=this.a[n.piece.bufferIndex].buffer,c=this.u(n.piece.bufferIndex,n.piece.start);let h=t.substring(c+i.remainder,c+n.piece.length);for(n=n.next();n!==L.$SC;){const s=this.a[n.piece.bufferIndex].buffer,m=this.u(n.piece.bufferIndex,n.piece.start);if(n===o.node){h+=s.substring(m,m+o.remainder);break}else h+=s.substr(m,n.piece.length);n=n.next()}return h}getLinesContent(){const i=[];let o=0,n="",t=!1;return this.iterate(this.root,c=>{if(c===L.$SC)return!0;const h=c.piece;let s=h.length;if(s===0)return!0;const m=this.a[h.bufferIndex].buffer,y=this.a[h.bufferIndex].lineStarts,S=h.start.line,E=h.end.line;let k=y[S]+h.start.column;if(t&&(m.charCodeAt(k)===r.CharCode.LineFeed&&(k++,s--),i[o++]=n,n="",t=!1,s===0))return!0;if(S===E)return!this.f&&m.charCodeAt(k+s-1)===r.CharCode.CarriageReturn?(t=!0,n+=m.substr(k,s-1)):n+=m.substr(k,s),!0;n+=this.f?m.substring(k,Math.max(k,y[S+1]-this.e)):m.substring(k,y[S+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=n;for(let C=S+1;C<E;C++)n=this.f?m.substring(y[C],y[C+1]-this.e):m.substring(y[C],y[C+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=n;return!this.f&&m.charCodeAt(y[E]+h.end.column-1)===r.CharCode.CarriageReturn?(t=!0,h.end.column===0?o--:n=m.substr(y[E],h.end.column-1)):n=m.substr(y[E],h.end.column),!0}),t&&(i[o++]=n,n=""),i[o++]=n,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const o=i.node.next();if(!o)return 0;const n=this.a[o.piece.bufferIndex],t=this.u(o.piece.bufferIndex,o.piece.start);return n.buffer.charCodeAt(t)}else{const o=this.a[i.node.piece.bufferIndex],t=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return o.buffer.charCodeAt(t)}}getLineCharCode(i,o){const n=this.H(i,o+1);return this.l(n)}getLineLength(i){if(i===this.getLineCount()){const o=this.getOffsetAt(i,1);return this.getLength()-o}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const o=this.G(i);return this.l(o)}findMatchesInNode(i,o,n,t,c,h,s,m,y,S,E){const k=this.a[i.piece.bufferIndex],C=this.u(i.piece.bufferIndex,i.piece.start),v=this.u(i.piece.bufferIndex,c),b=this.u(i.piece.bufferIndex,h);let O;const U={line:0,column:0};let z,j;o._wordSeparators?(z=k.buffer.substring(v,b),j=M=>M+v,o.reset(0)):(z=k.buffer,j=M=>M,o.reset(v));do if(O=o.next(z),O){if(j(O.index)>=b)return S;this.s(i,j(O.index)-C,U);const M=this.t(i.piece.bufferIndex,c,U),N=U.line===c.line?U.column-c.column+t:U.column+1,F=N+O[0].length;if(E[S++]=(0,R.$4C)(new P.$dt(n+M,N,n+M,F),O,m),j(O.index)+O[0].length>=b||S>=y)return S}while(O);return S}findMatchesLineByLine(i,o,n,t){const c=[];let h=0;const s=new R.$7C(o.wordSeparators,o.regex);let m=this.H(i.startLineNumber,i.startColumn);if(m===null)return[];const y=this.H(i.endLineNumber,i.endColumn);if(y===null)return[];let S=this.s(m.node,m.remainder);const E=this.s(y.node,y.remainder);if(m.node===y.node)return this.findMatchesInNode(m.node,s,i.startLineNumber,i.startColumn,S,E,o,n,t,h,c),c;let k=i.startLineNumber,C=m.node;for(;C!==y.node;){const b=this.t(C.piece.bufferIndex,S,C.piece.end);if(b>=1){const U=this.a[C.piece.bufferIndex].lineStarts,z=this.u(C.piece.bufferIndex,C.piece.start),j=U[S.line+b],M=k===i.startLineNumber?i.startColumn:1;if(h=this.findMatchesInNode(C,s,k,M,S,this.s(C,j-z),o,n,t,h,c),h>=t)return c;k+=b}const O=k===i.startLineNumber?i.startColumn-1:0;if(k===i.endLineNumber){const U=this.getLineContent(k).substring(O,i.endColumn-1);return h=this.n(o,s,U,i.endLineNumber,O,h,c,n,t),c}if(h=this.n(o,s,this.getLineContent(k).substr(O),k,O,h,c,n,t),h>=t)return c;k++,m=this.H(k,1),C=m.node,S=this.s(m.node,m.remainder)}if(k===i.endLineNumber){const b=k===i.startLineNumber?i.startColumn-1:0,O=this.getLineContent(k).substring(b,i.endColumn-1);return h=this.n(o,s,O,i.endLineNumber,b,h,c,n,t),c}const v=k===i.startLineNumber?i.startColumn:1;return h=this.findMatchesInNode(y.node,s,k,v,S,E,o,n,t,h,c),c}n(i,o,n,t,c,h,s,m,y){const S=i.wordSeparators;if(!m&&i.simpleSearch){const k=i.simpleSearch,C=k.length,v=n.length;let b=-C;for(;(b=n.indexOf(k,b+C))!==-1;)if((!S||(0,R.$6C)(S,n,v,b,C))&&(s[h++]=new T.$sv(new P.$dt(t,b+1+c,t,b+1+C+c),null),h>=y))return h;return h}let E;o.reset(0);do if(E=o.next(n),E&&(s[h++]=(0,R.$4C)(new P.$dt(t,E.index+1+c,t,E.index+1+E[0].length+c),E,m),h>=y))return h;while(E);return h}insert(i,o,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==L.$SC){const{node:t,remainder:c,nodeStartOffset:h}=this.G(i),s=t.piece,m=s.bufferIndex,y=this.s(t,c);if(t.piece.bufferIndex===0&&s.end.line===this.g.line&&s.end.column===this.g.column&&h+s.length===i&&o.length<p){this.F(t,o),this.y();return}if(h===i)this.o(o,t),this.h.validate(i);else if(h+t.piece.length>i){const S=[];let E=new A(s.bufferIndex,y,s.end,this.t(s.bufferIndex,y,s.end),this.u(m,s.end)-this.u(m,y));if(this.K()&&this.M(o)&&this.I(t,c)===10){const b={line:E.start.line+1,column:0};E=new A(E.bufferIndex,b,E.end,this.t(E.bufferIndex,b,E.end),E.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(t,c-1)===13){const b=this.s(t,c-1);this.C(t,b),o="\r"+o,t.piece.length===0&&S.push(t)}else this.C(t,y);else this.C(t,y);const k=this.w(o);E.length>0&&this.S(t,E);let C=t;for(let v=0;v<k.length;v++)C=this.S(C,k[v]);this.v(S)}else this.q(o,t)}else{const t=this.w(o);let c=this.T(null,t[0]);for(let h=1;h<t.length;h++)c=this.S(c,t[h])}this.y()}delete(i,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===L.$SC)return;const n=this.G(i),t=this.G(i+o),c=n.node,h=t.node;if(c===h){const k=this.s(c,n.remainder),C=this.s(c,t.remainder);if(n.nodeStartOffset===i){if(o===c.piece.length){const v=c.next();(0,L.$XC)(this,c),this.N(v),this.y();return}this.D(c,C),this.h.validate(i),this.N(c),this.y();return}if(n.nodeStartOffset+c.piece.length===i+o){this.C(c,k),this.O(c),this.y();return}this.E(c,k,C),this.y();return}const s=[],m=this.s(c,n.remainder);this.C(c,m),this.h.validate(i),c.piece.length===0&&s.push(c);const y=this.s(h,t.remainder);this.D(h,y),h.piece.length===0&&s.push(h);const S=c.next();for(let k=S;k!==L.$SC&&k!==h;k=k.next())s.push(k);const E=c.piece.length===0?c.prev():c;this.v(s),this.O(E),this.y()}o(i,o){const n=[];if(this.K()&&this.M(i)&&this.L(o)){const h=o.piece,s={line:h.start.line+1,column:0},m=new A(h.bufferIndex,s,h.end,this.t(h.bufferIndex,s,h.end),h.length-1);o.piece=m,i+=`
`,(0,L.$ZC)(this,o,-1,-1),o.piece.length===0&&n.push(o)}const t=this.w(i);let c=this.T(o,t[t.length-1]);for(let h=t.length-2;h>=0;h--)c=this.T(c,t[h]);this.N(c),this.v(n)}q(i,o){this.Q(i,o)&&(i+=`
`);const n=this.w(i),t=this.S(o,n[0]);let c=t;for(let h=1;h<n.length;h++)c=this.S(c,n[h]);this.N(t)}s(i,o,n){const t=i.piece,c=i.piece.bufferIndex,h=this.a[c].lineStarts,m=h[t.start.line]+t.start.column+o;let y=t.start.line,S=t.end.line,E=0,k=0,C=0;for(;y<=S&&(E=y+(S-y)/2|0,C=h[E],E!==S);)if(k=h[E+1],m<C)S=E-1;else if(m>=k)y=E+1;else break;return n?(n.line=E,n.column=m-C,null):{line:E,column:m-C}}t(i,o,n){if(n.column===0)return n.line-o.line;const t=this.a[i].lineStarts;if(n.line===t.length-1)return n.line-o.line;const c=t[n.line+1],h=t[n.line]+n.column;if(c>h+1)return n.line-o.line;const s=h-1;return this.a[i].buffer.charCodeAt(s)===13?n.line-o.line+1:n.line-o.line}u(i,o){return this.a[i].lineStarts[o.line]+o.column}v(i){for(let o=0;o<i.length;o++)(0,L.$XC)(this,i[o])}w(i){if(i.length>p){const S=[];for(;i.length>p;){const k=i.charCodeAt(p-1);let C;k===r.CharCode.CarriageReturn||k>=55296&&k<=56319?(C=i.substring(0,p-1),i=i.substring(p-1)):(C=i.substring(0,p),i=i.substring(p));const v=D(C);S.push(new A(this.a.length,{line:0,column:0},{line:v.length-1,column:C.length-v[v.length-1]},v.length-1,C.length)),this.a.push(new w(C,v))}const E=D(i);return S.push(new A(this.a.length,{line:0,column:0},{line:E.length-1,column:i.length-E[E.length-1]},E.length-1,i.length)),this.a.push(new w(i,E)),S}let o=this.a[0].buffer.length;const n=D(i,!1);let t=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},t=this.g;for(let S=0;S<n.length;S++)n[S]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+i,o+=1}else{if(o!==0)for(let S=0;S<n.length;S++)n[S]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=i}const c=this.a[0].buffer.length,h=this.a[0].lineStarts.length-1,s=c-this.a[0].lineStarts[h],m={line:h,column:s},y=new A(0,t,m,this.t(0,t,m),c-o);return this.g=m,[y]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,o=0){let n=this.root,t="";const c=this.h.get2(i);if(c){n=c.node;const h=this.B(n,i-c.nodeStartLineNumber-1),s=this.a[n.piece.bufferIndex].buffer,m=this.u(n.piece.bufferIndex,n.piece.start);if(c.nodeStartLineNumber+n.piece.lineFeedCnt===i)t=s.substring(m+h,m+n.piece.length);else{const y=this.B(n,i-c.nodeStartLineNumber);return s.substring(m+h,m+y-o)}}else{let h=0;const s=i;for(;n!==L.$SC;)if(n.left!==L.$SC&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const m=this.B(n,i-n.lf_left-2),y=this.B(n,i-n.lf_left-1),S=this.a[n.piece.bufferIndex].buffer,E=this.u(n.piece.bufferIndex,n.piece.start);return h+=n.size_left,this.h.set({node:n,nodeStartOffset:h,nodeStartLineNumber:s-(i-1-n.lf_left)}),S.substring(E+m,E+y-o)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const m=this.B(n,i-n.lf_left-2),y=this.a[n.piece.bufferIndex].buffer,S=this.u(n.piece.bufferIndex,n.piece.start);t=y.substring(S+m,S+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,h+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==L.$SC;){const h=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const s=this.B(n,0),m=this.u(n.piece.bufferIndex,n.piece.start);return t+=h.substring(m,m+s-o),t}else{const s=this.u(n.piece.bufferIndex,n.piece.start);t+=h.substr(s,n.piece.length)}n=n.next()}return t}y(){let i=this.root,o=1,n=0;for(;i!==L.$SC;)o+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this.b=o,this.c=n,this.h.validate(this.c)}A(i,o){const n=i.piece,t=this.s(i,o),c=t.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===o){const h=this.t(i.piece.bufferIndex,n.start,t);if(h!==c)return{index:h,remainder:0}}return{index:c,remainder:t.column}}B(i,o){if(o<0)return 0;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,c=n.start.line+o+1;return c>n.end.line?t[n.end.line]+n.end.column-t[n.start.line]-n.start.column:t[c]-t[n.start.line]-n.start.column}C(i,o){const n=i.piece,t=n.lineFeedCnt,c=this.u(n.bufferIndex,n.end),h=o,s=this.u(n.bufferIndex,h),m=this.t(n.bufferIndex,n.start,h),y=m-t,S=s-c,E=n.length+S;i.piece=new A(n.bufferIndex,n.start,h,m,E),(0,L.$ZC)(this,i,S,y)}D(i,o){const n=i.piece,t=n.lineFeedCnt,c=this.u(n.bufferIndex,n.start),h=o,s=this.t(n.bufferIndex,h,n.end),m=this.u(n.bufferIndex,h),y=s-t,S=c-m,E=n.length+S;i.piece=new A(n.bufferIndex,h,n.end,s,E),(0,L.$ZC)(this,i,S,y)}E(i,o,n){const t=i.piece,c=t.start,h=t.end,s=t.length,m=t.lineFeedCnt,y=o,S=this.t(t.bufferIndex,t.start,y),E=this.u(t.bufferIndex,o)-this.u(t.bufferIndex,c);i.piece=new A(t.bufferIndex,t.start,y,S,E),(0,L.$ZC)(this,i,E-s,S-m);const k=new A(t.bufferIndex,n,h,this.t(t.bufferIndex,n,h),this.u(t.bufferIndex,h)-this.u(t.bufferIndex,n)),C=this.S(i,k);this.N(C)}F(i,o){this.Q(o,i)&&(o+=`
`);const n=this.K()&&this.L(o)&&this.M(i),t=this.a[0].buffer.length;this.a[0].buffer+=o;const c=D(o,!1);for(let C=0;C<c.length;C++)c[C]+=t;if(n){const C=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:t-C}}this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1));const h=this.a[0].lineStarts.length-1,s=this.a[0].buffer.length-this.a[0].lineStarts[h],m={line:h,column:s},y=i.piece.length+o.length,S=i.piece.lineFeedCnt,E=this.t(0,i.piece.start,m),k=E-S;i.piece=new A(i.piece.bufferIndex,i.piece.start,m,E,y),this.g=m,(0,L.$ZC)(this,i,o.length,k)}G(i){let o=this.root;const n=this.h.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let t=0;for(;o!==L.$SC;)if(o.size_left>i)o=o.left;else if(o.size_left+o.piece.length>=i){t+=o.size_left;const c={node:o,remainder:i-o.size_left,nodeStartOffset:t};return this.h.set(c),c}else i-=o.size_left+o.piece.length,t+=o.size_left+o.piece.length,o=o.right;return null}H(i,o){let n=this.root,t=0;for(;n!==L.$SC;)if(n.left!==L.$SC&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const c=this.B(n,i-n.lf_left-2),h=this.B(n,i-n.lf_left-1);return t+=n.size_left,{node:n,remainder:Math.min(c+o-1,h),nodeStartOffset:t}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const c=this.B(n,i-n.lf_left-2);if(c+o-1<=n.piece.length)return{node:n,remainder:c+o-1,nodeStartOffset:t};o-=n.piece.length-c;break}else i-=n.lf_left+n.piece.lineFeedCnt,t+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==L.$SC;){if(n.piece.lineFeedCnt>0){const c=this.B(n,0),h=this.J(n);return{node:n,remainder:Math.min(o-1,c),nodeStartOffset:h}}else if(n.piece.length>=o-1){const c=this.J(n);return{node:n,remainder:o-1,nodeStartOffset:c}}else o-=n.piece.length;n=n.next()}return null}I(i,o){if(i.piece.lineFeedCnt<1)return-1;const n=this.a[i.piece.bufferIndex],t=this.u(i.piece.bufferIndex,i.piece.start)+o;return n.buffer.charCodeAt(t)}J(i){if(!i)return 0;let o=i.size_left;for(;i!==this.root;)i.parent.right===i&&(o+=i.parent.size_left+i.parent.piece.length),i=i.parent;return o}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===L.$SC||i.piece.lineFeedCnt===0)return!1;const o=i.piece,n=this.a[o.bufferIndex].lineStarts,t=o.start.line,c=n[t]+o.start.column;return t===n.length-1||n[t+1]>c+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(c)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===L.$SC||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const o=i.prev();this.M(o)&&this.P(o,i)}}O(i){if(this.K()&&this.M(i)){const o=i.next();this.L(o)&&this.P(i,o)}}P(i,o){const n=[],t=this.a[i.piece.bufferIndex].lineStarts;let c;i.piece.end.column===0?c={line:i.piece.end.line-1,column:t[i.piece.end.line]-t[i.piece.end.line-1]-1}:c={line:i.piece.end.line,column:i.piece.end.column-1};const h=i.piece.length-1,s=i.piece.lineFeedCnt-1;i.piece=new A(i.piece.bufferIndex,i.piece.start,c,s,h),(0,L.$ZC)(this,i,-1,-1),i.piece.length===0&&n.push(i);const m={line:o.piece.start.line+1,column:0},y=o.piece.length-1,S=this.t(o.piece.bufferIndex,m,o.piece.end);o.piece=new A(o.piece.bufferIndex,m,o.piece.end,S,y),(0,L.$ZC)(this,o,-1,-1),o.piece.length===0&&n.push(o);const E=this.w(`\r
`);this.S(i,E[0]);for(let k=0;k<n.length;k++)(0,L.$XC)(this,n[k])}Q(i,o){if(this.K()&&this.M(i)){const n=o.next();if(this.L(n)){if(i+=`
`,n.piece.length===1)(0,L.$XC)(this,n);else{const t=n.piece,c={line:t.start.line+1,column:0},h=t.length-1,s=this.t(t.bufferIndex,c,t.end);n.piece=new A(t.bufferIndex,c,t.end,s,h),(0,L.$ZC)(this,n,-1,-1)}return!0}}return!1}iterate(i,o){if(i===L.$SC)return o(L.$SC);const n=this.iterate(i.left,o);return n&&o(i)&&this.iterate(i.right,o)}R(i){if(i===L.$SC)return"";const o=this.a[i.piece.bufferIndex],n=i.piece,t=this.u(n.bufferIndex,n.start),c=this.u(n.bufferIndex,n.end);return o.buffer.substring(t,c)}getPieceContent(i){const o=this.a[i.bufferIndex],n=this.u(i.bufferIndex,i.start),t=this.u(i.bufferIndex,i.end);return o.buffer.substring(n,t)}S(i,o){const n=new L.$RC(o,L.NodeColor.Red);if(n.left=L.$SC,n.right=L.$SC,n.parent=L.$SC,n.size_left=0,n.lf_left=0,this.root===L.$SC)this.root=n,n.color=L.NodeColor.Black;else if(i.right===L.$SC)i.right=n,n.parent=i;else{const c=(0,L.$TC)(i.right);c.left=n,n.parent=c}return(0,L.$YC)(this,n),n}T(i,o){const n=new L.$RC(o,L.NodeColor.Red);if(n.left=L.$SC,n.right=L.$SC,n.parent=L.$SC,n.size_left=0,n.lf_left=0,this.root===L.$SC)this.root=n,n.color=L.NodeColor.Black;else if(i.left===L.$SC)i.left=n,n.parent=i;else{const t=(0,L.$UC)(i.left);t.right=n,n.parent=t}return(0,L.$YC)(this,n),n}U(i){let o="";return this.iterate(i,n=>(o+=this.R(n),!0)),o}}e.$_C=g}),define(Ee[205],Se([1,0,4,13,31,59,142,192,196,3]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=void 0;class I extends l.$Uc{constructor(f,A,w,a,d,g,$){super(),this.m=this.B(new r.$he),this.onDidChangeContent=this.m.event,this.f=A,this.j=!g,this.g=a,this.h=d,this.c=new L.$_C(f,w,$)}equals(f){return!(f instanceof I)||this.f!==f.f||this.getEOL()!==f.getEOL()?!1:this.c.equal(f.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(f){return this.c.createSnapshot(f?this.f:"")}getOffsetAt(f,A){return this.c.getOffsetAt(f,A)}getPositionAt(f){return this.c.getPositionAt(f)}getRangeAt(f,A){const w=f+A,a=this.getPositionAt(f),d=this.getPositionAt(w);return new P.$dt(a.lineNumber,a.column,d.lineNumber,d.column)}getValueInRange(f,A=T.EndOfLinePreference.TextDefined){if(f.isEmpty())return"";const w=this.n(A);return this.c.getValueInRange(f,w)}getValueLengthInRange(f,A=T.EndOfLinePreference.TextDefined){if(f.isEmpty())return 0;if(f.startLineNumber===f.endLineNumber)return f.endColumn-f.startColumn;const w=this.getOffsetAt(f.startLineNumber,f.startColumn),a=this.getOffsetAt(f.endLineNumber,f.endColumn);let d=0;const g=this.n(A),$=this.getEOL();if(g.length!==$.length){const i=g.length-$.length,o=f.endLineNumber-f.startLineNumber;d=i*o}return a-w+d}getCharacterCountInRange(f,A=T.EndOfLinePreference.TextDefined){if(this.j){let w=0;const a=f.startLineNumber,d=f.endLineNumber;for(let g=a;g<=d;g++){const $=this.getLineContent(g),i=g===a?f.startColumn-1:0,o=g===d?f.endColumn-1:$.length;for(let n=i;n<o;n++)u.$Ff($.charCodeAt(n))?(w=w+1,n=n+1):w=w+1}return w+=this.n(A).length*(d-a),w}return this.getValueLengthInRange(f,A)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(f){return this.c.getLineContent(f)}getLineCharCode(f,A){return this.c.getLineCharCode(f,A)}getCharCode(f){return this.c.getCharCode(f)}getLineLength(f){return this.c.getLineLength(f)}getLineMinColumn(f){return 1}getLineMaxColumn(f){return this.getLineLength(f)+1}getLineFirstNonWhitespaceColumn(f){const A=u.$qf(this.getLineContent(f));return A===-1?0:A+1}getLineLastNonWhitespaceColumn(f){const A=u.$sf(this.getLineContent(f));return A===-1?0:A+2}n(f){switch(f){case T.EndOfLinePreference.LF:return`
`;case T.EndOfLinePreference.CRLF:return`\r
`;case T.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(f){this.c.setEOL(f)}applyEdits(f,A,w){let a=this.g,d=this.h,g=this.j,$=!0,i=[];for(let m=0;m<f.length;m++){const y=f[m];$&&y._isTracked&&($=!1);const S=y.range;if(y.text){let b=!0;g||(b=!u.$Qf(y.text),g=b),!a&&b&&(a=u.$Pf(y.text)),!d&&b&&(d=u.$Sf(y.text))}let E="",k=0,C=0,v=0;if(y.text){let b;[k,C,v,b]=(0,R.$kv)(y.text);const O=this.getEOL(),U=O===`\r
`?R.StringEOL.CRLF:R.StringEOL.LF;b===R.StringEOL.Unknown||b===U?E=y.text:E=y.text.replace(/\r\n|\r|\n/g,O)}i[m]={sortIndex:m,identifier:y.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:E,eolCount:k,firstLineLength:C,lastLineLength:v,forceMoveMarkers:!!y.forceMoveMarkers,isAutoWhitespaceEdit:y.isAutoWhitespaceEdit||!1}}i.sort(I.u);let o=!1;for(let m=0,y=i.length-1;m<y;m++){const S=i[m].range.getEndPosition(),E=i[m+1].range.getStartPosition();if(E.isBeforeOrEqual(S)){if(E.isBefore(S))throw new Error("Overlapping ranges are not allowed!");o=!0}}$&&(i=this.s(i));const n=w||A?I._getInverseEditRanges(i):[],t=[];if(A)for(let m=0;m<i.length;m++){const y=i[m],S=n[m];if(y.isAutoWhitespaceEdit&&y.range.isEmpty())for(let E=S.startLineNumber;E<=S.endLineNumber;E++){let k="";E===S.startLineNumber&&(k=this.getLineContent(y.range.startLineNumber),u.$qf(k)!==-1)||t.push({lineNumber:E,oldContent:k})}}let c=null;if(w){let m=0;c=[];for(let y=0;y<i.length;y++){const S=i[y],E=n[y],k=this.getValueInRange(S.range),C=S.rangeOffset+m;m+=S.text.length-k.length,c[y]={sortIndex:S.sortIndex,identifier:S.identifier,range:E,text:k,textChange:new p.$mt(S.rangeOffset,k,C,S.text)}}o||c.sort((y,S)=>y.sortIndex-S.sortIndex)}this.g=a,this.h=d,this.j=g;const h=this.t(i);let s=null;if(A&&t.length>0){t.sort((m,y)=>y.lineNumber-m.lineNumber),s=[];for(let m=0,y=t.length;m<y;m++){const S=t[m].lineNumber;if(m>0&&t[m-1].lineNumber===S)continue;const E=t[m].oldContent,k=this.getLineContent(S);k.length===0||k===E||u.$qf(k)!==-1||s.push(S)}}return this.m.fire(),new T.$wv(c,h,s)}s(f){return f.length<1e3?f:[this._toSingleEditOperation(f)]}_toSingleEditOperation(f){let A=!1;const w=f[0].range,a=f[f.length-1].range,d=new P.$dt(w.startLineNumber,w.startColumn,a.endLineNumber,a.endColumn);let g=w.startLineNumber,$=w.startColumn;const i=[];for(let h=0,s=f.length;h<s;h++){const m=f[h],y=m.range;A=A||m.forceMoveMarkers,i.push(this.getValueInRange(new P.$dt(g,$,y.startLineNumber,y.startColumn))),m.text.length>0&&i.push(m.text),g=y.endLineNumber,$=y.endColumn}const o=i.join(""),[n,t,c]=(0,R.$kv)(o);return{sortIndex:0,identifier:f[0].identifier,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d,T.EndOfLinePreference.TextDefined),text:o,eolCount:n,firstLineLength:t,lastLineLength:c,forceMoveMarkers:A,isAutoWhitespaceEdit:!1}}t(f){f.sort(I.w);const A=[];for(let w=0;w<f.length;w++){const a=f[w],d=a.range.startLineNumber,g=a.range.startColumn,$=a.range.endLineNumber,i=a.range.endColumn;if(d===$&&g===i&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const o=new P.$dt(d,g,$,i);A.push({range:o,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return A}findMatchesLineByLine(f,A,w,a){return this.c.findMatchesLineByLine(f,A,w,a)}getPieceTree(){return this.c}static _getInverseEditRange(f,A){const w=f.startLineNumber,a=f.startColumn,[d,g,$]=(0,R.$kv)(A);let i;if(A.length>0){const o=d+1;o===1?i=new P.$dt(w,a,w,a+g):i=new P.$dt(w,a,w+o-1,$+1)}else i=new P.$dt(w,a,w,a);return i}static _getInverseEditRanges(f){const A=[];let w=0,a=0,d=null;for(let g=0,$=f.length;g<$;g++){const i=f[g];let o,n;d?d.range.endLineNumber===i.range.startLineNumber?(o=w,n=a+(i.range.startColumn-d.range.endColumn)):(o=w+(i.range.startLineNumber-d.range.endLineNumber),n=i.range.startColumn):(o=i.range.startLineNumber,n=i.range.startColumn);let t;if(i.text.length>0){const c=i.eolCount+1;c===1?t=new P.$dt(o,n,o,n+i.firstLineLength):t=new P.$dt(o,n,o+c-1,i.lastLineLength+1)}else t=new P.$dt(o,n,o,n);w=t.endLineNumber,a=t.endColumn,A.push(t),d=i}return A}static u(f,A){const w=P.$dt.compareRangesUsingEnds(f.range,A.range);return w===0?f.sortIndex-A.sortIndex:w}static w(f,A){const w=P.$dt.compareRangesUsingEnds(f.range,A.range);return w===0?A.sortIndex-f.sortIndex:-w}}e.$aD=I}),define(Ee[206],Se([1,0,27,13,59,142,205]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bD=void 0;class R{constructor(I,D,f,A,w,a,d,g,$){this.a=I,this.b=D,this.c=f,this.d=A,this.e=w,this.f=a,this.g=d,this.h=g,this.j=$}k(I){const D=this.c+this.d+this.e,f=this.c+this.e;return D===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:f>D/2?`\r
`:`
`}create(I){const D=this.k(I),f=this.a;if(this.j&&(D===`\r
`&&(this.c>0||this.d>0)||D===`
`&&(this.c>0||this.e>0)))for(let w=0,a=f.length;w<a;w++){const d=f[w].buffer.replace(/\r\n|\r|\n/g,D),g=(0,T.$8C)(d);f[w]=new T.$$C(d,g)}const A=new L.$aD(f,this.b,D,this.f,this.g,this.h,this.j);return{textBuffer:A,disposable:A}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&u.$1f(I)&&(this.b=u.$Zf,I=I.substr(1));const D=I.charCodeAt(I.length-1);D===r.CharCode.CarriageReturn||D>=55296&&D<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=D):(this.m(I,!1),this.c=!1,this.d=D)}m(I,D){!D&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const D=(0,T.$9C)(this.e,I);this.a.push(new T.$$C(I,D.lineStarts)),this.f+=D.cr,this.g+=D.lf,this.h+=D.crlf,D.isBasicASCII||(this.l=!1,this.j||(this.j=u.$Pf(I)),this.k||(this.k=u.$Sf(I)))}finish(I=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const D=(0,T.$8C)(I.buffer);I.lineStarts=D,this.d===r.CharCode.CarriageReturn&&this.f++}}}e.$bD=p}),define(Ee[143],Se([1,0,22,11]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bb=p,e.$_bb=I;var P;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(P||(P={}));function T(D){for(let f=0,A=D.length;f<A;f+=4){const w=D[f+0],a=D[f+1],d=D[f+2],g=D[f+3];D[f+0]=g,D[f+1]=d,D[f+2]=a,D[f+3]=w}}function L(D){const f=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return u.$x()||T(f),r.$Je.wrap(f)}function R(D){const f=D.buffer;if(u.$x()||T(f),f.byteOffset%4===0)return new Uint32Array(f.buffer,f.byteOffset,f.length/4);{const A=new Uint8Array(f.byteLength);return A.set(f),new Uint32Array(A.buffer,A.byteOffset,A.length/4)}}function p(D){const f=new Uint32Array(l(D));let A=0;if(f[A++]=D.id,D.type==="full")f[A++]=P.Full,f[A++]=D.data.length,f.set(D.data,A),A+=D.data.length;else{f[A++]=P.Delta,f[A++]=D.deltas.length;for(const w of D.deltas)f[A++]=w.start,f[A++]=w.deleteCount,w.data?(f[A++]=w.data.length,f.set(w.data,A),A+=w.data.length):f[A++]=0}return L(f)}function l(D){let f=0;if(f+=2,D.type==="full")f+=1+D.data.length;else{f+=1,f+=3*D.deltas.length;for(const A of D.deltas)A.data&&(f+=A.data.length)}return f}function I(D){const f=R(D);let A=0;const w=f[A++];if(f[A++]===P.Full){const $=f[A++],i=f.subarray(A,A+$);return A+=$,{id:w,type:"full",data:i}}const d=f[A++],g=[];for(let $=0;$<d;$++){const i=f[A++],o=f[A++],n=f[A++];let t;n>0&&(t=f.subarray(A,A+n),A+=n),g[$]={start:i,deleteCount:o,data:t}}return{id:w,type:"delta",deltas:g}}}),define(Ee[207],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$=e.$d$=void 0;class r{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const L=this.a.get(T);return this.a.delete(T),L}}addDragOperationTransfer(T,L){this.a.set(T,L)}}e.$d$=r;class u{constructor(T){this.identifier=T}}e.$e$=u}),define(Ee[208],Se([1,0,4,3,110]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yv=void 0;class T{constructor(){this.a=new Map,this.b=new Map,this.c=new r.$he,this.onDidChange=this.c.event,this.d=null}handleChange(p){this.c.fire({changedLanguages:p,changedColorMap:!1})}register(p,l){return this.a.set(p,l),this.handleChange([p]),(0,u.$Sc)(()=>{this.a.get(p)===l&&(this.a.delete(p),this.handleChange([p]))})}get(p){return this.a.get(p)||null}registerFactory(p,l){this.b.get(p)?.dispose();const I=new L(this,p,l);return this.b.set(p,I),(0,u.$Sc)(()=>{const D=this.b.get(p);!D||D!==I||(this.b.delete(p),D.dispose())})}async getOrCreate(p){const l=this.get(p);if(l)return l;const I=this.b.get(p);return!I||I.isResolved?null:(await I.resolve(),this.get(p))}isResolved(p){if(this.get(p))return!0;const I=this.b.get(p);return!!(!I||I.isResolved)}setColorMap(p){this.d=p,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>P.ColorId.DefaultBackground?this.d[P.ColorId.DefaultBackground]:null}}e.$yv=T;class L extends u.$Uc{get isResolved(){return this.c}constructor(p,l,I){super(),this.f=p,this.g=l,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const p=await this.h.tokenizationSupport;this.c=!0,p&&!this.a&&this.B(this.f.register(this.g,p))}}}),define(Ee[209],Se([9,10]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(Ee[210],Se([1,0,4,3,209]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=void 0,e.$kj=I;class T extends u.$Uc{constructor(f,A="",w="",a=!0,d){super(),this.j=this.B(new r.$he),this.onDidChange=this.j.event,this.z=!0,this.m=f,this.n=A,this.w=w,this.z=a,this.D=d}get id(){return this.m}get label(){return this.n}set label(f){this.F(f)}F(f){this.n!==f&&(this.n=f,this.j.fire({label:f}))}get tooltip(){return this.u||""}set tooltip(f){this.G(f)}G(f){this.u!==f&&(this.u=f,this.j.fire({tooltip:f}))}get class(){return this.w}set class(f){this.H(f)}H(f){this.w!==f&&(this.w=f,this.j.fire({class:f}))}get enabled(){return this.z}set enabled(f){this.I(f)}I(f){this.z!==f&&(this.z=f,this.j.fire({enabled:f}))}get checked(){return this.C}set checked(f){this.J(f)}J(f){this.C!==f&&(this.C=f,this.j.fire({checked:f}))}async run(f,A){this.D&&await this.D(f)}}e.$fj=T;class L extends u.$Uc{constructor(){super(...arguments),this.f=this.B(new r.$he),this.onWillRun=this.f.event,this.m=this.B(new r.$he),this.onDidRun=this.m.event}async run(f,A){if(!f.enabled)return;this.f.fire({action:f});let w;try{await this.u(f,A)}catch(a){w=a}this.m.fire({action:f,error:w})}async u(f,A){await f.run(A)}}e.$gj=L;class R{constructor(){this.id=R.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...f){let A=[];for(const w of f)w.length&&(A.length?A=[...A,new R,...w]:A=w);return A}async run(){}}e.$hj=R,R.ID="vs.actions.separator";class p{get actions(){return this.a}constructor(f,A,w,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=f,this.label=A,this.class=a,this.a=w}async run(){}}e.$ij=p;class l extends T{constructor(){super(l.ID,P.localize(0,null),void 0,!1)}}e.$jj=l,l.ID="vs.actions.empty";function I(D){return{id:D.id,label:D.label,tooltip:D.tooltip??D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked,run:async(...f)=>D.run(...f)}}}),define(Ee[211],Se([9,10]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(Ee[212],Se([1,0,211]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=l,e.$9m=I,e.$0m=D;const u=60,P=u*60,T=P*24,L=T*7,R=T*30,p=T*365;function l(f,A,w,a){typeof f!="number"&&(f=f.getTime());const d=Math.round((new Date().getTime()-f)/1e3);if(d<-30)return(0,r.localize)(0,null,l(new Date().getTime()+d*1e3,!1));if(!a&&d<30)return(0,r.localize)(1,null);let g;return d<u?(g=d,A?g===1?w?(0,r.localize)(2,null,g):(0,r.localize)(3,null,g):w?(0,r.localize)(4,null,g):(0,r.localize)(5,null,g):g===1?w?(0,r.localize)(6,null,g):(0,r.localize)(7,null,g):w?(0,r.localize)(8,null,g):(0,r.localize)(9,null,g)):d<P?(g=Math.floor(d/u),A?g===1?w?(0,r.localize)(10,null,g):(0,r.localize)(11,null,g):w?(0,r.localize)(12,null,g):(0,r.localize)(13,null,g):g===1?w?(0,r.localize)(14,null,g):(0,r.localize)(15,null,g):w?(0,r.localize)(16,null,g):(0,r.localize)(17,null,g)):d<T?(g=Math.floor(d/P),A?g===1?w?(0,r.localize)(18,null,g):(0,r.localize)(19,null,g):w?(0,r.localize)(20,null,g):(0,r.localize)(21,null,g):g===1?w?(0,r.localize)(22,null,g):(0,r.localize)(23,null,g):w?(0,r.localize)(24,null,g):(0,r.localize)(25,null,g)):d<L?(g=Math.floor(d/T),A?g===1?(0,r.localize)(26,null,g):(0,r.localize)(27,null,g):g===1?(0,r.localize)(28,null,g):(0,r.localize)(29,null,g)):d<R?(g=Math.floor(d/L),A?g===1?w?(0,r.localize)(30,null,g):(0,r.localize)(31,null,g):w?(0,r.localize)(32,null,g):(0,r.localize)(33,null,g):g===1?w?(0,r.localize)(34,null,g):(0,r.localize)(35,null,g):w?(0,r.localize)(36,null,g):(0,r.localize)(37,null,g)):d<p?(g=Math.floor(d/R),A?g===1?w?(0,r.localize)(38,null,g):(0,r.localize)(39,null,g):w?(0,r.localize)(40,null,g):(0,r.localize)(41,null,g):g===1?w?(0,r.localize)(42,null,g):(0,r.localize)(43,null,g):w?(0,r.localize)(44,null,g):(0,r.localize)(45,null,g)):(g=Math.floor(d/p),A?g===1?w?(0,r.localize)(46,null,g):(0,r.localize)(47,null,g):w?(0,r.localize)(48,null,g):(0,r.localize)(49,null,g):g===1?w?(0,r.localize)(50,null,g):(0,r.localize)(51,null,g):w?(0,r.localize)(52,null,g):(0,r.localize)(53,null,g))}function I(f,A){const w=Math.abs(f/1e3);return w<1?A?(0,r.localize)(54,null,f):(0,r.localize)(55,null,f):w<u?A?(0,r.localize)(56,null,Math.round(f)/1e3):(0,r.localize)(57,null,Math.round(f)/1e3):w<P?A?(0,r.localize)(58,null,Math.round(f/(1e3*u))):(0,r.localize)(59,null,Math.round(f/(1e3*u))):w<T?A?(0,r.localize)(60,null,Math.round(f/(1e3*P))):(0,r.localize)(61,null,Math.round(f/(1e3*P))):(0,r.localize)(62,null,Math.round(f/(1e3*T)))}function D(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ee[213],Se([9,10]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(Ee[51],Se([1,0,19,18,213]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=p,e.$mj=l,e.$nj=I;function T(D,f){return f&&(D.stack||D.stacktrace)?P.localize(0,null,R(D),L(D.stack)||L(D.stacktrace)):R(D)}function L(D){return Array.isArray(D)?D.join(`
`):D}function R(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?P.localize(1,null,D.message):D.message||P.localize(2,null)}function p(D=null,f=!1){if(!D)return P.localize(3,null);if(Array.isArray(D)){const A=r.$Hb(D),w=p(A[0],f);return A.length>1?P.localize(4,null,w,A.length):w}if(u.$ag(D))return D;if(D.detail){const A=D.detail;if(A.error)return T(A.error,f);if(A.exception)return T(A.exception,f)}return D.stack?T(D,f):D.message?D.message:P.localize(5,null)}function l(D){const f=D;return f instanceof Error&&Array.isArray(f.actions)}function I(D,f){let A;return typeof D=="string"?A=new Error(D):A=D,A.actions=f,A}}),define(Ee[214],Se([9,10]),function(oe,e){return oe.create("vs/editor/common/config/editorOptions",e)}),define(Ee[215],Se([9,10]),function(oe,e){return oe.create("vs/editor/common/languages",e)}),define(Ee[88],Se([1,0,83,2,193,31,208,215]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$Sv=e.$Rv=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$Qv=e.$Pv=e.SymbolKinds=e.SymbolTag=e.$Nv=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$Lv=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$Kv=e.$Jv=e.$Iv=void 0,e.$Mv=h,e.$Ov=m;class p{constructor(H,V,x){this.offset=H,this.type=V,this.language=x,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Iv=p;class l{constructor(H,V){this.tokens=H,this.endState=V,this._tokenizationResultBrand=void 0}}e.$Jv=l;class I{constructor(H,V){this.tokens=H,this.endState=V,this._encodedTokenizationResultBrand=void 0}}e.$Kv=I;var D;(function(W){W[W.Increase=0]="Increase",W[W.Decrease=1]="Decrease"})(D||(e.HoverVerbosityAction=D={}));var f;(function(W){W[W.Method=0]="Method",W[W.Function=1]="Function",W[W.Constructor=2]="Constructor",W[W.Field=3]="Field",W[W.Variable=4]="Variable",W[W.Class=5]="Class",W[W.Struct=6]="Struct",W[W.Interface=7]="Interface",W[W.Module=8]="Module",W[W.Property=9]="Property",W[W.Event=10]="Event",W[W.Operator=11]="Operator",W[W.Unit=12]="Unit",W[W.Value=13]="Value",W[W.Constant=14]="Constant",W[W.Enum=15]="Enum",W[W.EnumMember=16]="EnumMember",W[W.Keyword=17]="Keyword",W[W.Text=18]="Text",W[W.Color=19]="Color",W[W.File=20]="File",W[W.Reference=21]="Reference",W[W.Customcolor=22]="Customcolor",W[W.Folder=23]="Folder",W[W.TypeParameter=24]="TypeParameter",W[W.User=25]="User",W[W.Issue=26]="Issue",W[W.Snippet=27]="Snippet"})(f||(e.CompletionItemKind=f={}));var A;(function(W){const H=new Map;H.set(f.Method,r.$Zj.symbolMethod),H.set(f.Function,r.$Zj.symbolFunction),H.set(f.Constructor,r.$Zj.symbolConstructor),H.set(f.Field,r.$Zj.symbolField),H.set(f.Variable,r.$Zj.symbolVariable),H.set(f.Class,r.$Zj.symbolClass),H.set(f.Struct,r.$Zj.symbolStruct),H.set(f.Interface,r.$Zj.symbolInterface),H.set(f.Module,r.$Zj.symbolModule),H.set(f.Property,r.$Zj.symbolProperty),H.set(f.Event,r.$Zj.symbolEvent),H.set(f.Operator,r.$Zj.symbolOperator),H.set(f.Unit,r.$Zj.symbolUnit),H.set(f.Value,r.$Zj.symbolValue),H.set(f.Enum,r.$Zj.symbolEnum),H.set(f.Constant,r.$Zj.symbolConstant),H.set(f.Enum,r.$Zj.symbolEnum),H.set(f.EnumMember,r.$Zj.symbolEnumMember),H.set(f.Keyword,r.$Zj.symbolKeyword),H.set(f.Snippet,r.$Zj.symbolSnippet),H.set(f.Text,r.$Zj.symbolText),H.set(f.Color,r.$Zj.symbolColor),H.set(f.File,r.$Zj.symbolFile),H.set(f.Reference,r.$Zj.symbolReference),H.set(f.Customcolor,r.$Zj.symbolCustomColor),H.set(f.Folder,r.$Zj.symbolFolder),H.set(f.TypeParameter,r.$Zj.symbolTypeParameter),H.set(f.User,r.$Zj.account),H.set(f.Issue,r.$Zj.issues);function V(ne){let we=H.get(ne);return we||(console.info("No codicon found for CompletionItemKind "+ne),we=r.$Zj.symbolProperty),we}W.toIcon=V;const x=new Map;x.set("method",f.Method),x.set("function",f.Function),x.set("constructor",f.Constructor),x.set("field",f.Field),x.set("variable",f.Variable),x.set("class",f.Class),x.set("struct",f.Struct),x.set("interface",f.Interface),x.set("module",f.Module),x.set("property",f.Property),x.set("event",f.Event),x.set("operator",f.Operator),x.set("unit",f.Unit),x.set("value",f.Value),x.set("constant",f.Constant),x.set("enum",f.Enum),x.set("enum-member",f.EnumMember),x.set("enumMember",f.EnumMember),x.set("keyword",f.Keyword),x.set("snippet",f.Snippet),x.set("text",f.Text),x.set("color",f.Color),x.set("file",f.File),x.set("reference",f.Reference),x.set("customcolor",f.Customcolor),x.set("folder",f.Folder),x.set("type-parameter",f.TypeParameter),x.set("typeParameter",f.TypeParameter),x.set("account",f.User),x.set("issue",f.Issue);function he(ne,we){let pe=x.get(ne);return typeof pe>"u"&&!we&&(pe=f.Property),pe}W.fromString=he})(A||(e.CompletionItemKinds=A={}));var w;(function(W){W[W.Deprecated=1]="Deprecated"})(w||(e.CompletionItemTag=w={}));var a;(function(W){W[W.None=0]="None",W[W.KeepWhitespace=1]="KeepWhitespace",W[W.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var d;(function(W){W[W.Word=0]="Word",W[W.Line=1]="Line",W[W.Suggest=2]="Suggest"})(d||(e.PartialAcceptTriggerKind=d={}));var g;(function(W){W[W.Invoke=0]="Invoke",W[W.TriggerCharacter=1]="TriggerCharacter",W[W.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(g||(e.CompletionTriggerKind=g={}));var $;(function(W){W[W.Automatic=0]="Automatic",W[W.Explicit=1]="Explicit"})($||(e.InlineCompletionTriggerKind=$={}));class i{constructor(H,V,x,he){this.range=H,this.text=V,this.completionKind=x,this.isSnippetText=he}equals(H){return T.$dt.lift(this.range).equalsRange(H.range)&&this.text===H.text&&this.completionKind===H.completionKind&&this.isSnippetText===H.isSnippetText}}e.$Lv=i;var o;(function(W){W[W.Invoke=1]="Invoke",W[W.Auto=2]="Auto"})(o||(e.CodeActionTriggerType=o={}));var n;(function(W){W[W.Automatic=0]="Automatic",W[W.PasteAs=1]="PasteAs"})(n||(e.DocumentPasteTriggerKind=n={}));var t;(function(W){W[W.Invoke=1]="Invoke",W[W.TriggerCharacter=2]="TriggerCharacter",W[W.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var c;(function(W){W[W.Text=0]="Text",W[W.Read=1]="Read",W[W.Write=2]="Write"})(c||(e.DocumentHighlightKind=c={}));function h(W){return W&&u.URI.isUri(W.uri)&&T.$dt.isIRange(W.range)&&(T.$dt.isIRange(W.originSelectionRange)||T.$dt.isIRange(W.targetSelectionRange))}var s;(function(W){W[W.File=0]="File",W[W.Module=1]="Module",W[W.Namespace=2]="Namespace",W[W.Package=3]="Package",W[W.Class=4]="Class",W[W.Method=5]="Method",W[W.Property=6]="Property",W[W.Field=7]="Field",W[W.Constructor=8]="Constructor",W[W.Enum=9]="Enum",W[W.Interface=10]="Interface",W[W.Function=11]="Function",W[W.Variable=12]="Variable",W[W.Constant=13]="Constant",W[W.String=14]="String",W[W.Number=15]="Number",W[W.Boolean=16]="Boolean",W[W.Array=17]="Array",W[W.Object=18]="Object",W[W.Key=19]="Key",W[W.Null=20]="Null",W[W.EnumMember=21]="EnumMember",W[W.Struct=22]="Struct",W[W.Event=23]="Event",W[W.Operator=24]="Operator",W[W.TypeParameter=25]="TypeParameter"})(s||(e.SymbolKind=s={})),e.$Nv={[s.Array]:(0,R.localize)(0,null),[s.Boolean]:(0,R.localize)(1,null),[s.Class]:(0,R.localize)(2,null),[s.Constant]:(0,R.localize)(3,null),[s.Constructor]:(0,R.localize)(4,null),[s.Enum]:(0,R.localize)(5,null),[s.EnumMember]:(0,R.localize)(6,null),[s.Event]:(0,R.localize)(7,null),[s.Field]:(0,R.localize)(8,null),[s.File]:(0,R.localize)(9,null),[s.Function]:(0,R.localize)(10,null),[s.Interface]:(0,R.localize)(11,null),[s.Key]:(0,R.localize)(12,null),[s.Method]:(0,R.localize)(13,null),[s.Module]:(0,R.localize)(14,null),[s.Namespace]:(0,R.localize)(15,null),[s.Null]:(0,R.localize)(16,null),[s.Number]:(0,R.localize)(17,null),[s.Object]:(0,R.localize)(18,null),[s.Operator]:(0,R.localize)(19,null),[s.Package]:(0,R.localize)(20,null),[s.Property]:(0,R.localize)(21,null),[s.String]:(0,R.localize)(22,null),[s.Struct]:(0,R.localize)(23,null),[s.TypeParameter]:(0,R.localize)(24,null),[s.Variable]:(0,R.localize)(25,null)};function m(W,H){return(0,R.localize)(26,null,W,e.$Nv[H])}var y;(function(W){W[W.Deprecated=1]="Deprecated"})(y||(e.SymbolTag=y={}));var S;(function(W){const H=new Map;H.set(s.File,r.$Zj.symbolFile),H.set(s.Module,r.$Zj.symbolModule),H.set(s.Namespace,r.$Zj.symbolNamespace),H.set(s.Package,r.$Zj.symbolPackage),H.set(s.Class,r.$Zj.symbolClass),H.set(s.Method,r.$Zj.symbolMethod),H.set(s.Property,r.$Zj.symbolProperty),H.set(s.Field,r.$Zj.symbolField),H.set(s.Constructor,r.$Zj.symbolConstructor),H.set(s.Enum,r.$Zj.symbolEnum),H.set(s.Interface,r.$Zj.symbolInterface),H.set(s.Function,r.$Zj.symbolFunction),H.set(s.Variable,r.$Zj.symbolVariable),H.set(s.Constant,r.$Zj.symbolConstant),H.set(s.String,r.$Zj.symbolString),H.set(s.Number,r.$Zj.symbolNumber),H.set(s.Boolean,r.$Zj.symbolBoolean),H.set(s.Array,r.$Zj.symbolArray),H.set(s.Object,r.$Zj.symbolObject),H.set(s.Key,r.$Zj.symbolKey),H.set(s.Null,r.$Zj.symbolNull),H.set(s.EnumMember,r.$Zj.symbolEnumMember),H.set(s.Struct,r.$Zj.symbolStruct),H.set(s.Event,r.$Zj.symbolEvent),H.set(s.Operator,r.$Zj.symbolOperator),H.set(s.TypeParameter,r.$Zj.symbolTypeParameter);function V(x){let he=H.get(x);return he||(console.info("No codicon found for SymbolKind "+x),he=r.$Zj.symbolProperty),he}W.toIcon=V})(S||(e.SymbolKinds=S={}));class E{static asEditOperation(H){return P.$et.replace(T.$dt.lift(H.range),H.text)}}e.$Pv=E;class k{static fromValue(H){switch(H){case"comment":return k.Comment;case"imports":return k.Imports;case"region":return k.Region}return new k(H)}constructor(H){this.value=H}}e.$Qv=k,k.Comment=new k("comment"),k.Imports=new k("imports"),k.Region=new k("region");var C;(function(W){W[W.AIGenerated=1]="AIGenerated"})(C||(e.NewSymbolNameTag=C={}));var v;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(v||(e.NewSymbolNameTriggerKind=v={}));var b;(function(W){function H(V){return!V||typeof V!="object"?!1:typeof V.id=="string"&&typeof V.title=="string"}W.is=H})(b||(e.Command=b={}));var O;(function(W){W[W.Collapsed=0]="Collapsed",W[W.Expanded=1]="Expanded"})(O||(e.CommentThreadCollapsibleState=O={}));var U;(function(W){W[W.Unresolved=0]="Unresolved",W[W.Resolved=1]="Resolved"})(U||(e.CommentThreadState=U={}));var z;(function(W){W[W.Current=0]="Current",W[W.Outdated=1]="Outdated"})(z||(e.CommentThreadApplicability=z={}));var j;(function(W){W[W.Editing=0]="Editing",W[W.Preview=1]="Preview"})(j||(e.CommentMode=j={}));var M;(function(W){W[W.Published=0]="Published",W[W.Draft=1]="Draft"})(M||(e.CommentState=M={}));var N;(function(W){W[W.Type=1]="Type",W[W.Parameter=2]="Parameter"})(N||(e.InlayHintKind=N={}));class F{constructor(H){this.b=H,this.a=null}dispose(){this.a&&this.a.then(H=>{H&&H.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Rv=F,e.$Sv=new L.$yv;var X;(function(W){W[W.None=0]="None",W[W.Option=1]="Option",W[W.Default=2]="Default",W[W.Preferred=3]="Preferred"})(X||(e.ExternalUriOpenerPriority=X={}));var se;(function(W){W[W.Invoke=0]="Invoke",W[W.Automatic=1]="Automatic"})(se||(e.InlineEditTriggerKind=se={}))}),define(Ee[216],Se([9,10]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[217],Se([9,10]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[218],Se([9,10]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[219],Se([9,10]),function(oe,e){return oe.create("vs/platform/dialogs/common/dialogs",e)}),define(Ee[220],Se([9,10]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[221],Se([9,10]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[222],Se([9,10]),function(oe,e){return oe.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[223],Se([9,10]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(Ee[224],Se([9,10]),function(oe,e){return oe.create("vs/platform/files/common/io",e)}),define(Ee[225],Se([9,10]),function(oe,e){return oe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[226],Se([9,10]),function(oe,e){return oe.create("vs/platform/log/common/log",e)}),define(Ee[227],Se([9,10]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(Ee[228],Se([9,10]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(Ee[229],Se([9,10]),function(oe,e){return oe.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[230],Se([9,10]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[231],Se([9,10]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(Ee[232],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[233],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[234],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ee[235],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ee[236],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostLogService",e)}),define(Ee[237],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ee[238],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[239],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[240],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[241],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[242],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ee[243],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[244],Se([9,10]),function(oe,e){return oe.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[245],Se([9,10]),function(oe,e){return oe.create("vs/workbench/common/configuration",e)}),define(Ee[246],Se([9,10]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(Ee[247],Se([9,10]),function(oe,e){return oe.create("vs/workbench/common/views",e)}),define(Ee[248],Se([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ee[249],Se([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ee[250],Se([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[251],Se([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[252],Se([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[253],Se([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ee[254],Se([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ee[255],Se([9,10]),function(oe,e){return oe.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ee[256],Se([9,10]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[257],Se([9,10]),function(oe,e){return oe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ee[258],Se([9,10]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[259],Se([9,10]),function(oe,e){return oe.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ee[260],Se([9,10]),function(oe,e){return oe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[261],Se([1,0,27,14,218]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var T;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(T||(e.TokenType=T={}));function L(...I){switch(I.length){case 1:return(0,P.localize)(0,null,I[0]);case 2:return(0,P.localize)(1,null,I[0],I[1]);case 3:return(0,P.localize)(2,null,I[0],I[1],I[2]);default:return}}const R=(0,P.localize)(3,null),p=(0,P.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(D){switch(D.type){case T.LParen:return"(";case T.RParen:return")";case T.Neg:return"!";case T.Eq:return D.isTripleEq?"===":"==";case T.NotEq:return D.isTripleEq?"!==":"!=";case T.Lt:return"<";case T.LtEq:return"<=";case T.Gt:return">=";case T.GtEq:return">=";case T.RegexOp:return"=~";case T.RegexStr:return D.lexeme;case T.True:return"true";case T.False:return"false";case T.In:return"in";case T.Not:return"not";case T.And:return"&&";case T.Or:return"||";case T.Str:return D.lexeme;case T.QuotedStr:return D.lexeme;case T.Error:return D.lexeme;case T.EOF:return"EOF";default:throw(0,u.$8)(`unhandled token type: ${JSON.stringify(D)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(D){return this.c=D,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case r.CharCode.OpenParen:this.k(T.LParen);break;case r.CharCode.CloseParen:this.k(T.RParen);break;case r.CharCode.ExclamationMark:if(this.h(r.CharCode.Equals)){const f=this.h(r.CharCode.Equals);this.f.push({type:T.NotEq,offset:this.d,isTripleEq:f})}else this.k(T.Neg);break;case r.CharCode.SingleQuote:this.o();break;case r.CharCode.Slash:this.q();break;case r.CharCode.Equals:if(this.h(r.CharCode.Equals)){const f=this.h(r.CharCode.Equals);this.f.push({type:T.Eq,offset:this.d,isTripleEq:f})}else this.h(r.CharCode.Tilde)?this.k(T.RegexOp):this.l(L("==","=~"));break;case r.CharCode.LessThan:this.k(this.h(r.CharCode.Equals)?T.LtEq:T.Lt);break;case r.CharCode.GreaterThan:this.k(this.h(r.CharCode.Equals)?T.GtEq:T.Gt);break;case r.CharCode.Ampersand:this.h(r.CharCode.Ampersand)?this.k(T.And):this.l(L("&&"));break;case r.CharCode.Pipe:this.h(r.CharCode.Pipe)?this.k(T.Or):this.l(L("||"));break;case r.CharCode.Space:case r.CharCode.CarriageReturn:case r.CharCode.Tab:case r.CharCode.LineFeed:case r.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(T.EOF),Array.from(this.f)}h(D){return this.r()||this.c.charCodeAt(this.e)!==D?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?r.CharCode.Null:this.c.charCodeAt(this.e)}k(D){this.f.push({type:D,offset:this.d})}l(D){const f=this.d,A=this.c.substring(this.d,this.e),w={type:T.Error,offset:this.d,lexeme:A};this.g.push({offset:f,lexeme:A,additionalInfo:D}),this.f.push(w)}n(){this.m.lastIndex=this.d;const D=this.m.exec(this.c);if(D){this.e=this.d+D[0].length;const f=this.c.substring(this.d,this.e),A=l.b.get(f);A?this.k(A):this.f.push({type:T.Str,lexeme:f,offset:this.d})}}o(){for(;this.j()!==r.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:T.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let D=this.e,f=!1,A=!1;for(;;){if(D>=this.c.length){this.e=D,this.l(p);return}const a=this.c.charCodeAt(D);if(f)f=!1;else if(a===r.CharCode.Slash&&!A){D++;break}else a===r.CharCode.OpenSquareBracket?A=!0:a===r.CharCode.Backslash?f=!0:a===r.CharCode.CloseSquareBracket&&(A=!1);D++}for(;D<this.c.length&&l.a.has(this.c.charCodeAt(D));)D++;this.e=D;const w=this.c.substring(this.d,this.e);this.f.push({type:T.RegexStr,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=l,l.a=new Set(["i","g","s","m","y","u"].map(I=>I.charCodeAt(0))),l.b=new Map([["not",T.Not],["in",T.In],["false",T.False],["true",T.True]])}),define(Ee[262],Se([1,0,23,44,221,410]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=p,e.$Qp=l,e.$Rp=I,e.$Sp=D,e.$Tp=f,e.$Up=A,e.$Vp=w;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function p(g){return g=g.trim(),g==="*"||L.test(g)}function l(g){if(!p(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const $=g.match(L);return $?{hasCaret:$[1]==="^",hasGreaterEquals:$[1]===">=",majorBase:$[2]==="x"?0:parseInt($[2],10),majorMustEqual:$[2]!=="x",minorBase:$[4]==="x"?0:parseInt($[4],10),minorMustEqual:$[4]!=="x",patchBase:$[6]==="x"?0:parseInt($[6],10),patchMustEqual:$[6]!=="x",preRelease:$[8]||null}:null}function I(g){if(!g)return null;const $=g.majorBase,i=g.majorMustEqual,o=g.minorBase;let n=g.minorMustEqual;const t=g.patchBase;let c=g.patchMustEqual;g.hasCaret&&($===0||(n=!1),c=!1);let h=0;if(g.preRelease){const s=R.exec(g.preRelease);if(s){const[,m,y,S]=s;h=Date.UTC(Number(m),Number(y)-1,Number(S))}}return{majorBase:$,majorMustEqual:i,minorBase:o,minorMustEqual:n,patchBase:t,patchMustEqual:c,isMinimum:g.hasGreaterEquals,notBefore:h}}function D(g,$,i){let o;typeof g=="string"?o=I(l(g)):o=g;let n;$ instanceof Date?n=$.getTime():typeof $=="string"&&(n=new Date($).getTime());let t;if(typeof i=="string"?t=I(l(i)):t=i,!o||!t)return!1;const c=o.majorBase,h=o.minorBase,s=o.patchBase;let m=t.majorBase,y=t.minorBase,S=t.patchBase;const E=t.notBefore;let k=t.majorMustEqual,C=t.minorMustEqual,v=t.patchMustEqual;return t.isMinimum?c>m?!0:c<m?!1:h>y?!0:h<y||n&&n<E?!1:s>=S:(c===1&&m===0&&(!k||!C||!v)&&(m=1,y=0,S=0,k=!0,C=!1,v=!1),c<m?!1:c>m?!k:h<y?!1:h>y?!C:s<S?!1:s>S?!v:!(n&&n<E))}function f(g,$,i,o,n){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([u.default.Error,P.localize(0,null)]),t;if(typeof o.name!="string")return t.push([u.default.Error,P.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([u.default.Error,P.localize(2,null,"version")]),t;if(!o.engines)return t.push([u.default.Error,P.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([u.default.Error,P.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!d(o.extensionDependencies))return t.push([u.default.Error,P.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!d(o.activationEvents))return t.push([u.default.Error,P.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([u.default.Error,P.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([u.default.Warning,P.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([u.default.Error,P.localize(9,null,"main")]),t;{const s=(0,r.$bh)(i,o.main);(0,r.$8g)(s,i)||t.push([u.default.Warning,P.localize(10,null,s.path,i.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([u.default.Error,P.localize(11,null,"browser")]),t;{const s=(0,r.$bh)(i,o.browser);(0,r.$8g)(s,i)||t.push([u.default.Warning,P.localize(12,null,s.path,i.path)])}}if(!T.valid(o.version))return t.push([u.default.Error,P.localize(13,null)]),t;const c=[];if(!A(g,$,o,n,c))for(const s of c)t.push([u.default.Error,s]);return t}function A(g,$,i,o,n){return o||typeof i.main>"u"&&typeof i.browser>"u"?!0:a(g,$,i.engines.vscode,n)}function w(g,$,i){return g==="*"||a($,i,g)}function a(g,$,i,o=[]){const n=I(l(i));if(!n)return o.push(P.localize(14,null,i)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return o.push(P.localize(15,null,i)),!1}else if(!n.majorMustEqual)return o.push(P.localize(16,null,i)),!1;return D(g,$,n)?!0:(o.push(P.localize(17,null,g,i)),!1)}function d(g){if(!Array.isArray(g))return!1;for(let $=0,i=g.length;$<i;$++)if(typeof g[$]!="string")return!1;return!0}}),define(Ee[112],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class r{constructor(P,T=[],L=!1){this.ctor=P,this.staticArguments=T,this.supportsDelayedInstantiation=L}}e.$xi=r}),define(Ee[89],Se([1,0,112]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Gs=T,e.$Hs=L;const u=[];var P;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function T(R,p,l){p instanceof r.$xi||(p=new r.$xi(p,[],!!l)),u.push([R,p])}function L(){return u}}),define(Ee[263],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=void 0;class r{constructor(T,L){this.key=T,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$jr=r;class u{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const L of this.a.values())L.outgoing.size===0&&T.push(L);return T}insertEdge(T,L){const R=this.lookupOrInsertNode(T),p=this.lookupOrInsertNode(L);R.outgoing.set(p.key,p),p.incoming.set(R.key,R)}removeNode(T){const L=this.b(T);this.a.delete(L);for(const R of this.a.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(T){const L=this.b(T);let R=this.a.get(L);return R||(R=new r(L,T),this.a.set(L,R)),R}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[L,R]of this.a)T.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,L]of this.a){const R=new Set([T]),p=this.c(L,R);if(p)return p}}c(T,L){for(const[R,p]of T.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const l=this.c(p,L);if(l)return l;L.delete(R)}}}e.$kr=u}),define(Ee[5],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=P,e.$Bi=T;var r;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function R(p){return p[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=R})(r||(e._util=r={})),e.$zi=P("instantiationService");function u(L,R,p){R[r.DI_TARGET]===R?R[r.DI_DEPENDENCIES].push({id:L,index:p}):(R[r.DI_DEPENDENCIES]=[{id:L,index:p}],R[r.DI_TARGET]=R)}function P(L){if(r.serviceIds.has(L))return r.serviceIds.get(L);const R=function(p,l,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");u(R,p,I)};return R.toString=()=>L,r.serviceIds.set(L,R),R}function T(L){return L}}),define(Ee[45],Se([1,0,18,2,5]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=T,e.$9i=L,e.$0i=p,e.$$i=l,e.$_i=I,e.$aj=D,e.$bj=f,e.$cj=w,e.$dj=a,e.$ej=d,e.$7i=(0,P.$Ai)("configurationService");function T(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof u.URI)}function L(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof u.URI)}var R;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function p(g){switch(g){case R.APPLICATION:return"APPLICATION";case R.USER:return"USER";case R.USER_LOCAL:return"USER_LOCAL";case R.USER_REMOTE:return"USER_REMOTE";case R.WORKSPACE:return"WORKSPACE";case R.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case R.DEFAULT:return"DEFAULT";case R.MEMORY:return"MEMORY"}}function l(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}function I(g,$){const i=Object.create(null);for(const o in g)D(i,o,g[o],$);return i}function D(g,$,i,o){const n=$.split("."),t=n.pop();let c=g;for(let h=0;h<n.length;h++){const s=n[h];let m=c[s];switch(typeof m){case"undefined":m=c[s]=Object.create(null);break;case"object":if(m===null){o(`Ignoring ${$} as ${n.slice(0,h+1).join(".")} is null`);return}break;default:o(`Ignoring ${$} as ${n.slice(0,h+1).join(".")} is ${JSON.stringify(m)}`);return}c=m}if(typeof c=="object"&&c!==null)try{c[t]=i}catch{o(`Ignoring ${$} as ${n.join(".")} is ${JSON.stringify(c)}`)}else o(`Ignoring ${$} as ${n.join(".")} is ${JSON.stringify(c)}`)}function f(g,$){const i=$.split(".");A(g,i)}function A(g,$){const i=$.shift();if($.length===0){delete g[i];return}if(Object.keys(g).indexOf(i)!==-1){const o=g[i];typeof o=="object"&&!Array.isArray(o)&&(A(o,$),Object.keys(o).length===0&&delete g[i])}}function w(g,$,i){function o(c,h){let s=c;for(const m of h){if(typeof s!="object"||s===null)return;s=s[m]}return s}const n=$.split("."),t=o(g,n);return typeof t>"u"?i:t}function a(g,$,i){Object.keys($).forEach(o=>{o!=="__proto__"&&(o in g?r.$cg(g[o])&&r.$cg($[o])?a(g[o],$[o],i):i&&(g[o]=$[o]):g[o]=$[o])})}function d(g){return g.replace(/[\[\]]/g,"")}}),define(Ee[35],Se([1,0,27,11,13,261,5,217,14]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=I,e.$zj=h,e.$Aj=s,e.$Tj=ne;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",u.$d),l.set("isLinux",u.$e),l.set("isWindows",u.$c),l.set("isWeb",u.$i),l.set("isMacNative",u.$d&&!u.$i),l.set("isEdge",u.$B),l.set("isFirefox",u.$z),l.set("isChrome",u.$y),l.set("isSafari",u.$A);function I(ce,K){if(l.get(ce)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(ce,K)}const D=Object.prototype.hasOwnProperty;var f;(function(ce){ce[ce.False=0]="False",ce[ce.True=1]="True",ce[ce.Defined=2]="Defined",ce[ce.Not=3]="Not",ce[ce.Equals=4]="Equals",ce[ce.NotEquals=5]="NotEquals",ce[ce.And=6]="And",ce[ce.Regex=7]="Regex",ce[ce.NotRegex=8]="NotRegex",ce[ce.Or=9]="Or",ce[ce.In=10]="In",ce[ce.NotIn=11]="NotIn",ce[ce.Greater=12]="Greater",ce[ce.GreaterEquals=13]="GreaterEquals",ce[ce.Smaller=14]="Smaller",ce[ce.SmallerEquals=15]="SmallerEquals"})(f||(e.ContextKeyExprType=f={}));const A={regexParsingWithErrorRecovery:!0},w=(0,R.localize)(0,null),a=(0,R.localize)(1,null),d=(0,R.localize)(2,null),g=(0,R.localize)(3,null),$=(0,R.localize)(4,null),i=(0,R.localize)(5,null),o=(0,R.localize)(6,null),n=(0,R.localize)(7,null);class t{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(K=A){this.k=K,this.d=new T.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(K){if(K===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(K).scan(),this.g=0,this.h=[];try{const de=this.l();if(!this.E()){const te=this.D(),ee=te.type===T.TokenType.Str?i:void 0;throw this.h.push({message:$,offset:te.offset,lexeme:T.$vj.getLexeme(te),additionalInfo:ee}),t.c}return de}catch(de){if(de!==t.c)throw de;return}}l(){return this.m()}m(){const K=[this.o()];for(;this.y(T.TokenType.Or);){const de=this.o();K.push(de)}return K.length===1?K[0]:c.or(...K)}o(){const K=[this.s()];for(;this.y(T.TokenType.And);){const de=this.s();K.push(de)}return K.length===1?K[0]:c.and(...K)}s(){if(this.y(T.TokenType.Neg)){const K=this.D();switch(K.type){case T.TokenType.True:return this.z(),y.INSTANCE;case T.TokenType.False:return this.z(),S.INSTANCE;case T.TokenType.LParen:{this.z();const de=this.l();return this.A(T.TokenType.RParen,g),de?.negate()}case T.TokenType.Str:return this.z(),O.create(K.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",K)}}return this.t()}t(){const K=this.D();switch(K.type){case T.TokenType.True:return this.z(),c.true();case T.TokenType.False:return this.z(),c.false();case T.TokenType.LParen:{this.z();const de=this.l();return this.A(T.TokenType.RParen,g),de}case T.TokenType.Str:{const de=K.lexeme;if(this.z(),this.y(T.TokenType.RegexOp)){const ee=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ee.type!==T.TokenType.RegexStr)throw this.B("REGEX",ee);const ie=ee.lexeme,le=ie.lastIndexOf("/"),Z=le===ie.length-1?void 0:this.w(ie.substring(le+1));let ae;try{ae=new RegExp(ie.substring(1,le),Z)}catch{throw this.B("REGEX",ee)}return F.create(de,ae)}switch(ee.type){case T.TokenType.RegexStr:case T.TokenType.Error:{const ie=[ee.lexeme];this.z();let le=this.D(),Z=0;for(let qe=0;qe<ee.lexeme.length;qe++)ee.lexeme.charCodeAt(qe)===r.CharCode.OpenParen?Z++:ee.lexeme.charCodeAt(qe)===r.CharCode.CloseParen&&Z--;for(;!this.E()&&le.type!==T.TokenType.And&&le.type!==T.TokenType.Or;){switch(le.type){case T.TokenType.LParen:Z++;break;case T.TokenType.RParen:Z--;break;case T.TokenType.RegexStr:case T.TokenType.QuotedStr:for(let qe=0;qe<le.lexeme.length;qe++)le.lexeme.charCodeAt(qe)===r.CharCode.OpenParen?Z++:ee.lexeme.charCodeAt(qe)===r.CharCode.CloseParen&&Z--}if(Z<0)break;ie.push(T.$vj.getLexeme(le)),this.z(),le=this.D()}const ae=ie.join(""),$e=ae.lastIndexOf("/"),be=$e===ae.length-1?void 0:this.w(ae.substring($e+1));let Me;try{Me=new RegExp(ae.substring(1,$e),be)}catch{throw this.B("REGEX",ee)}return c.regex(de,Me)}case T.TokenType.QuotedStr:{const ie=ee.lexeme;this.z();let le=null;if(!(0,P.$$e)(ie)){const Z=ie.indexOf("/"),ae=ie.lastIndexOf("/");if(Z!==ae&&Z>=0){const $e=ie.slice(Z+1,ae),be=ie[ae+1]==="i"?"i":"";try{le=new RegExp($e,be)}catch{throw this.B("REGEX",ee)}}}if(le===null)throw this.B("REGEX",ee);return F.create(de,le)}default:throw this.B("REGEX",this.D())}}if(this.y(T.TokenType.Not)){this.A(T.TokenType.In,d);const ee=this.u();return c.notIn(de,ee)}switch(this.D().type){case T.TokenType.Eq:{this.z();const ee=this.u();if(this.x().type===T.TokenType.QuotedStr)return c.equals(de,ee);switch(ee){case"true":return c.has(de);case"false":return c.not(de);default:return c.equals(de,ee)}}case T.TokenType.NotEq:{this.z();const ee=this.u();if(this.x().type===T.TokenType.QuotedStr)return c.notEquals(de,ee);switch(ee){case"true":return c.not(de);case"false":return c.has(de);default:return c.notEquals(de,ee)}}case T.TokenType.Lt:return this.z(),M.create(de,this.u());case T.TokenType.LtEq:return this.z(),N.create(de,this.u());case T.TokenType.Gt:return this.z(),z.create(de,this.u());case T.TokenType.GtEq:return this.z(),j.create(de,this.u());case T.TokenType.In:return this.z(),c.in(de,this.u());default:return c.has(de)}}case T.TokenType.EOF:throw this.h.push({message:o,offset:K.offset,lexeme:"",additionalInfo:n}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const K=this.D();switch(K.type){case T.TokenType.Str:case T.TokenType.QuotedStr:return this.z(),K.lexeme;case T.TokenType.True:return this.z(),"true";case T.TokenType.False:return this.z(),"false";case T.TokenType.In:return this.z(),"in";default:return""}}w(K){return K.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(K){return this.C(K)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(K,de){if(this.C(K))return this.z();throw this.B(de,this.D())}B(K,de,te){const ee=(0,R.localize)(8,null,K,T.$vj.getLexeme(de)),ie=de.offset,le=T.$vj.getLexeme(de);return this.h.push({message:ee,offset:ie,lexeme:le,additionalInfo:te}),t.c}C(K){return this.D().type===K}D(){return this.f[this.g]}E(){return this.D().type===T.TokenType.EOF}}e.$xj=t,t.c=new Error;class c{static false(){return y.INSTANCE}static true(){return S.INSTANCE}static has(K){return E.create(K)}static equals(K,de){return k.create(K,de)}static notEquals(K,de){return b.create(K,de)}static regex(K,de){return F.create(K,de)}static in(K,de){return C.create(K,de)}static notIn(K,de){return v.create(K,de)}static not(K){return O.create(K)}static and(...K){return W.create(K,null,!0)}static or(...K){return H.create(K,null,!0)}static greater(K,de){return z.create(K,de)}static greaterEquals(K,de){return j.create(K,de)}static smaller(K,de){return M.create(K,de)}static smallerEquals(K,de){return N.create(K,de)}static deserialize(K){return K==null?void 0:this.c.parse(K)}}e.$yj=c,c.c=new t({regexParsingWithErrorRecovery:!1});function h(ce){const K=new t({regexParsingWithErrorRecovery:!1});return ce.map(de=>(K.parse(de),K.lexingErrors.length>0?K.lexingErrors.map(te=>({errorMessage:te.additionalInfo?(0,R.localize)(9,null,te.additionalInfo):(0,R.localize)(10,null),offset:te.offset,length:te.lexeme.length})):K.parsingErrors.length>0?K.parsingErrors.map(te=>({errorMessage:te.additionalInfo?`${te.message}. ${te.additionalInfo}`:te.message,offset:te.offset,length:te.lexeme.length})):[]))}function s(ce,K){const de=ce?ce.substituteConstants():void 0,te=K?K.substituteConstants():void 0;return!de&&!te?!0:!de||!te?!1:de.equals(te)}function m(ce,K){return ce.cmp(K)}class y{constructor(){this.type=f.False}cmp(K){return this.type-K.type}equals(K){return K.type===this.type}substituteConstants(){return this}evaluate(K){return!1}serialize(){return"false"}keys(){return[]}map(K){return this}negate(){return S.INSTANCE}}e.$Bj=y,y.INSTANCE=new y;class S{constructor(){this.type=f.True}cmp(K){return this.type-K.type}equals(K){return K.type===this.type}substituteConstants(){return this}evaluate(K){return!0}serialize(){return"true"}keys(){return[]}map(K){return this}negate(){return y.INSTANCE}}e.$Cj=S,S.INSTANCE=new S;class E{static create(K,de=null){const te=l.get(K);return typeof te=="boolean"?te?S.INSTANCE:y.INSTANCE:new E(K,de)}constructor(K,de){this.key=K,this.c=de,this.type=f.Defined}cmp(K){return K.type!==this.type?this.type-K.type:x(this.key,K.key)}equals(K){return K.type===this.type?this.key===K.key:!1}substituteConstants(){const K=l.get(this.key);return typeof K=="boolean"?K?S.INSTANCE:y.INSTANCE:this}evaluate(K){return!!K.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(K){return K.mapDefined(this.key)}negate(){return this.c||(this.c=O.create(this.key,this)),this.c}}e.$Dj=E;class k{static create(K,de,te=null){if(typeof de=="boolean")return de?E.create(K,te):O.create(K,te);const ee=l.get(K);return typeof ee=="boolean"?de===(ee?"true":"false")?S.INSTANCE:y.INSTANCE:new k(K,de,te)}constructor(K,de,te){this.c=K,this.d=de,this.f=te,this.type=f.Equals}cmp(K){return K.type!==this.type?this.type-K.type:he(this.c,this.d,K.c,K.d)}equals(K){return K.type===this.type?this.c===K.c&&this.d===K.d:!1}substituteConstants(){const K=l.get(this.c);if(typeof K=="boolean"){const de=K?"true":"false";return this.d===de?S.INSTANCE:y.INSTANCE}return this}evaluate(K){return K.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(K){return K.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Ej=k;class C{static create(K,de){return new C(K,de)}constructor(K,de){this.d=K,this.f=de,this.type=f.In,this.c=null}cmp(K){return K.type!==this.type?this.type-K.type:he(this.d,this.f,K.d,K.f)}equals(K){return K.type===this.type?this.d===K.d&&this.f===K.f:!1}substituteConstants(){return this}evaluate(K){const de=K.getValue(this.f),te=K.getValue(this.d);return Array.isArray(de)?de.includes(te):typeof te=="string"&&typeof de=="object"&&de!==null?D.call(de,te):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(K){return K.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Fj=C;class v{static create(K,de){return new v(K,de)}constructor(K,de){this.d=K,this.f=de,this.type=f.NotIn,this.c=C.create(K,de)}cmp(K){return K.type!==this.type?this.type-K.type:this.c.cmp(K.c)}equals(K){return K.type===this.type?this.c.equals(K.c):!1}substituteConstants(){return this}evaluate(K){return!this.c.evaluate(K)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(K){return K.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=v;class b{static create(K,de,te=null){if(typeof de=="boolean")return de?O.create(K,te):E.create(K,te);const ee=l.get(K);return typeof ee=="boolean"?de===(ee?"true":"false")?y.INSTANCE:S.INSTANCE:new b(K,de,te)}constructor(K,de,te){this.c=K,this.d=de,this.f=te,this.type=f.NotEquals}cmp(K){return K.type!==this.type?this.type-K.type:he(this.c,this.d,K.c,K.d)}equals(K){return K.type===this.type?this.c===K.c&&this.d===K.d:!1}substituteConstants(){const K=l.get(this.c);if(typeof K=="boolean"){const de=K?"true":"false";return this.d===de?y.INSTANCE:S.INSTANCE}return this}evaluate(K){return K.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(K){return K.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Hj=b;class O{static create(K,de=null){const te=l.get(K);return typeof te=="boolean"?te?y.INSTANCE:S.INSTANCE:new O(K,de)}constructor(K,de){this.c=K,this.d=de,this.type=f.Not}cmp(K){return K.type!==this.type?this.type-K.type:x(this.c,K.c)}equals(K){return K.type===this.type?this.c===K.c:!1}substituteConstants(){const K=l.get(this.c);return typeof K=="boolean"?K?y.INSTANCE:S.INSTANCE:this}evaluate(K){return!K.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(K){return K.mapNot(this.c)}negate(){return this.d||(this.d=E.create(this.c,this)),this.d}}e.$Ij=O;function U(ce,K){if(typeof ce=="string"){const de=parseFloat(ce);isNaN(de)||(ce=de)}return typeof ce=="string"||typeof ce=="number"?K(ce):y.INSTANCE}class z{static create(K,de,te=null){return U(de,ee=>new z(K,ee,te))}constructor(K,de,te){this.c=K,this.d=de,this.f=te,this.type=f.Greater}cmp(K){return K.type!==this.type?this.type-K.type:he(this.c,this.d,K.c,K.d)}equals(K){return K.type===this.type?this.c===K.c&&this.d===K.d:!1}substituteConstants(){return this}evaluate(K){return typeof this.d=="string"?!1:parseFloat(K.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(K){return K.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Jj=z;class j{static create(K,de,te=null){return U(de,ee=>new j(K,ee,te))}constructor(K,de,te){this.c=K,this.d=de,this.f=te,this.type=f.GreaterEquals}cmp(K){return K.type!==this.type?this.type-K.type:he(this.c,this.d,K.c,K.d)}equals(K){return K.type===this.type?this.c===K.c&&this.d===K.d:!1}substituteConstants(){return this}evaluate(K){return typeof this.d=="string"?!1:parseFloat(K.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(K){return K.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Kj=j;class M{static create(K,de,te=null){return U(de,ee=>new M(K,ee,te))}constructor(K,de,te){this.c=K,this.d=de,this.f=te,this.type=f.Smaller}cmp(K){return K.type!==this.type?this.type-K.type:he(this.c,this.d,K.c,K.d)}equals(K){return K.type===this.type?this.c===K.c&&this.d===K.d:!1}substituteConstants(){return this}evaluate(K){return typeof this.d=="string"?!1:parseFloat(K.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(K){return K.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Lj=M;class N{static create(K,de,te=null){return U(de,ee=>new N(K,ee,te))}constructor(K,de,te){this.c=K,this.d=de,this.f=te,this.type=f.SmallerEquals}cmp(K){return K.type!==this.type?this.type-K.type:he(this.c,this.d,K.c,K.d)}equals(K){return K.type===this.type?this.c===K.c&&this.d===K.d:!1}substituteConstants(){return this}evaluate(K){return typeof this.d=="string"?!1:parseFloat(K.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(K){return K.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Mj=N;class F{static create(K,de){return new F(K,de)}constructor(K,de){this.d=K,this.f=de,this.type=f.Regex,this.c=null}cmp(K){if(K.type!==this.type)return this.type-K.type;if(this.d<K.d)return-1;if(this.d>K.d)return 1;const de=this.f?this.f.source:"",te=K.f?K.f.source:"";return de<te?-1:de>te?1:0}equals(K){if(K.type===this.type){const de=this.f?this.f.source:"",te=K.f?K.f.source:"";return this.d===K.d&&de===te}return!1}substituteConstants(){return this}evaluate(K){const de=K.getValue(this.d);return this.f?this.f.test(de):!1}serialize(){const K=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${K}`}keys(){return[this.d]}map(K){return K.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$Nj=F;class X{static create(K){return new X(K)}constructor(K){this.c=K,this.type=f.NotRegex}cmp(K){return K.type!==this.type?this.type-K.type:this.c.cmp(K.c)}equals(K){return K.type===this.type?this.c.equals(K.c):!1}substituteConstants(){return this}evaluate(K){return!this.c.evaluate(K)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(K){return new X(this.c.map(K))}negate(){return this.c}}e.$Oj=X;function se(ce){let K=null;for(let de=0,te=ce.length;de<te;de++){const ee=ce[de].substituteConstants();if(ce[de]!==ee&&K===null){K=[];for(let ie=0;ie<de;ie++)K[ie]=ce[ie]}K!==null&&(K[de]=ee)}return K===null?ce:K}class W{static create(K,de,te){return W.d(K,de,te)}constructor(K,de){this.expr=K,this.c=de,this.type=f.And}cmp(K){if(K.type!==this.type)return this.type-K.type;if(this.expr.length<K.expr.length)return-1;if(this.expr.length>K.expr.length)return 1;for(let de=0,te=this.expr.length;de<te;de++){const ee=m(this.expr[de],K.expr[de]);if(ee!==0)return ee}return 0}equals(K){if(K.type===this.type){if(this.expr.length!==K.expr.length)return!1;for(let de=0,te=this.expr.length;de<te;de++)if(!this.expr[de].equals(K.expr[de]))return!1;return!0}return!1}substituteConstants(){const K=se(this.expr);return K===this.expr?this:W.create(K,this.c,!1)}evaluate(K){for(let de=0,te=this.expr.length;de<te;de++)if(!this.expr[de].evaluate(K))return!1;return!0}static d(K,de,te){const ee=[];let ie=!1;for(const le of K)if(le){if(le.type===f.True){ie=!0;continue}if(le.type===f.False)return y.INSTANCE;if(le.type===f.And){ee.push(...le.expr);continue}ee.push(le)}if(ee.length===0&&ie)return S.INSTANCE;if(ee.length!==0){if(ee.length===1)return ee[0];ee.sort(m);for(let le=1;le<ee.length;le++)ee[le-1].equals(ee[le])&&(ee.splice(le,1),le--);if(ee.length===1)return ee[0];for(;ee.length>1;){const le=ee[ee.length-1];if(le.type!==f.Or)break;ee.pop();const Z=ee.pop(),ae=ee.length===0,$e=H.create(le.expr.map(be=>W.create([be,Z],null,te)),null,ae);$e&&(ee.push($e),ee.sort(m))}if(ee.length===1)return ee[0];if(te){for(let le=0;le<ee.length;le++)for(let Z=le+1;Z<ee.length;Z++)if(ee[le].negate().equals(ee[Z]))return y.INSTANCE;if(ee.length===1)return ee[0]}return new W(ee,de)}}serialize(){return this.expr.map(K=>K.serialize()).join(" && ")}keys(){const K=[];for(const de of this.expr)K.push(...de.keys());return K}map(K){return new W(this.expr.map(de=>de.map(K)),null)}negate(){if(!this.c){const K=[];for(const de of this.expr)K.push(de.negate());this.c=H.create(K,this,!0)}return this.c}}e.$Pj=W;class H{static create(K,de,te){return H.d(K,de,te)}constructor(K,de){this.expr=K,this.c=de,this.type=f.Or}cmp(K){if(K.type!==this.type)return this.type-K.type;if(this.expr.length<K.expr.length)return-1;if(this.expr.length>K.expr.length)return 1;for(let de=0,te=this.expr.length;de<te;de++){const ee=m(this.expr[de],K.expr[de]);if(ee!==0)return ee}return 0}equals(K){if(K.type===this.type){if(this.expr.length!==K.expr.length)return!1;for(let de=0,te=this.expr.length;de<te;de++)if(!this.expr[de].equals(K.expr[de]))return!1;return!0}return!1}substituteConstants(){const K=se(this.expr);return K===this.expr?this:H.create(K,this.c,!1)}evaluate(K){for(let de=0,te=this.expr.length;de<te;de++)if(this.expr[de].evaluate(K))return!0;return!1}static d(K,de,te){let ee=[],ie=!1;if(K){for(let le=0,Z=K.length;le<Z;le++){const ae=K[le];if(ae){if(ae.type===f.False){ie=!0;continue}if(ae.type===f.True)return S.INSTANCE;if(ae.type===f.Or){ee=ee.concat(ae.expr);continue}ee.push(ae)}}if(ee.length===0&&ie)return y.INSTANCE;ee.sort(m)}if(ee.length!==0){if(ee.length===1)return ee[0];for(let le=1;le<ee.length;le++)ee[le-1].equals(ee[le])&&(ee.splice(le,1),le--);if(ee.length===1)return ee[0];if(te){for(let le=0;le<ee.length;le++)for(let Z=le+1;Z<ee.length;Z++)if(ee[le].negate().equals(ee[Z]))return S.INSTANCE;if(ee.length===1)return ee[0]}return new H(ee,de)}}serialize(){return this.expr.map(K=>K.serialize()).join(" || ")}keys(){const K=[];for(const de of this.expr)K.push(...de.keys());return K}map(K){return new H(this.expr.map(de=>de.map(K)),null)}negate(){if(!this.c){const K=[];for(const de of this.expr)K.push(de.negate());for(;K.length>1;){const de=K.shift(),te=K.shift(),ee=[];for(const ie of pe(de))for(const le of pe(te))ee.push(W.create([ie,le],null,!1));K.unshift(H.create(ee,null,!1))}this.c=H.create(K,this,!0)}return this.c}}e.$Qj=H;class V extends E{static all(){return V.d.values()}constructor(K,de,te){super(K,null),this.f=de,typeof te=="object"?V.d.push({...te,key:K}):te!==!0&&V.d.push({key:K,description:te,type:de!=null?typeof de:void 0})}bindTo(K){return K.createKey(this.key,this.f)}getValue(K){return K.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(K){return k.create(this.key,K)}notEqualsTo(K){return b.create(this.key,K)}}e.$Rj=V,V.d=[],e.$Sj=(0,L.$Ai)("contextKeyService");function x(ce,K){return ce<K?-1:ce>K?1:0}function he(ce,K,de,te){return ce<de?-1:ce>de?1:K<te?-1:K>te?1:0}function ne(ce,K){if(ce.type===f.False||K.type===f.True)return!0;if(ce.type===f.Or)return K.type===f.Or?we(ce.expr,K.expr):!1;if(K.type===f.Or){for(const de of K.expr)if(ne(ce,de))return!0;return!1}if(ce.type===f.And){if(K.type===f.And)return we(K.expr,ce.expr);for(const de of ce.expr)if(ne(de,K))return!0;return!1}return ce.equals(K)}function we(ce,K){let de=0,te=0;for(;de<ce.length&&te<K.length;){const ee=ce[de].cmp(K[te]);if(ee<0)return!1;ee===0&&de++,te++}return de===ce.length}function pe(ce){return ce.type===f.Or?ce.expr:[ce]}}),define(Ee[264],Se([1,0,35,5]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=e.$qu=e.AccessibilitySupport=e.$pu=void 0,e.$ru=T,e.$pu=(0,u.$Ai)("accessibilityService");var P;(function(L){L[L.Unknown=0]="Unknown",L[L.Disabled=1]="Disabled",L[L.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$qu=new r.$Rj("accessibilityModeEnabled",!1);function T(L){return L&&typeof L=="object"&&typeof L.label=="string"&&(typeof L.role>"u"||typeof L.role=="string")}e.$su="ACCESSIBLE_VIEW_SHOWN_"}),define(Ee[113],Se([1,0,19,25,11,183,84,197,141,214,264]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=n,e.clampedFloat=c,e.stringSet=m,e.cursorStyleToString=U,e.filterValidationDecorations=De;var D;(function(ue){ue[ue.None=0]="None",ue[ue.Keep=1]="Keep",ue[ue.Brackets=2]="Brackets",ue[ue.Advanced=3]="Advanced",ue[ue.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class f{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=f;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class w{constructor(Q,Ce,Je,_e){this.id=Q,this.name=Ce,this.defaultValue=Je,this.schema=_e}applyUpdate(Q,Ce){return d(Q,Ce)}compute(Q,Ce,Je){return Je}}class a{constructor(Q,Ce){this.newValue=Q,this.didChange=Ce}}e.ApplyUpdateResult=a;function d(ue,Q){if(typeof ue!="object"||typeof Q!="object"||!ue||!Q)return new a(Q,ue!==Q);if(Array.isArray(ue)||Array.isArray(Q)){const Je=Array.isArray(ue)&&Array.isArray(Q)&&r.$ub(ue,Q);return new a(Q,!Je)}let Ce=!1;for(const Je in Q)if(Q.hasOwnProperty(Je)){const _e=d(ue[Je],Q[Je]);_e.didChange&&(ue[Je]=_e.newValue,Ce=!0)}return new a(ue,Ce)}class g{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,Ce){return d(Q,Ce)}validate(Q){return this.defaultValue}}class ${constructor(Q,Ce,Je,_e){this.id=Q,this.name=Ce,this.defaultValue=Je,this.schema=_e}applyUpdate(Q,Ce){return d(Q,Ce)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,Ce,Je){return Je}}function i(ue,Q){return typeof ue>"u"?Q:ue==="false"?!1:!!ue}class o extends ${constructor(Q,Ce,Je,_e=void 0){typeof _e<"u"&&(_e.type="boolean",_e.default=Je),super(Q,Ce,Je,_e)}validate(Q){return i(Q,this.defaultValue)}}function n(ue,Q,Ce,Je){if(typeof ue>"u")return Q;let _e=parseInt(ue,10);return isNaN(_e)?Q:(_e=Math.max(Ce,_e),_e=Math.min(Je,_e),_e|0)}class t extends ${static clampedInt(Q,Ce,Je,_e){return n(Q,Ce,Je,_e)}constructor(Q,Ce,Je,_e,ct,lt=void 0){typeof lt<"u"&&(lt.type="integer",lt.default=Je,lt.minimum=_e,lt.maximum=ct),super(Q,Ce,Je,lt),this.minimum=_e,this.maximum=ct}validate(Q){return t.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function c(ue,Q,Ce,Je){if(typeof ue>"u")return Q;const _e=h.float(ue,Q);return h.clamp(_e,Ce,Je)}class h extends ${static clamp(Q,Ce,Je){return Q<Ce?Ce:Q>Je?Je:Q}static float(Q,Ce){if(typeof Q=="number")return Q;if(typeof Q>"u")return Ce;const Je=parseFloat(Q);return isNaN(Je)?Ce:Je}constructor(Q,Ce,Je,_e,ct){typeof ct<"u"&&(ct.type="number",ct.default=Je),super(Q,Ce,Je,ct),this.validationFn=_e}validate(Q){return this.validationFn(h.float(Q,this.defaultValue))}}class s extends ${static string(Q,Ce){return typeof Q!="string"?Ce:Q}constructor(Q,Ce,Je,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.default=Je),super(Q,Ce,Je,_e)}validate(Q){return s.string(Q,this.defaultValue)}}function m(ue,Q,Ce,Je){return typeof ue!="string"?Q:Je&&ue in Je?Je[ue]:Ce.indexOf(ue)===-1?Q:ue}class y extends ${constructor(Q,Ce,Je,_e,ct=void 0){typeof ct<"u"&&(ct.type="string",ct.enum=_e,ct.default=Je),super(Q,Ce,Je,ct),this.c=_e}validate(Q){return m(Q,this.defaultValue,this.c)}}class S extends w{constructor(Q,Ce,Je,_e,ct,lt,yt=void 0){typeof yt<"u"&&(yt.type="string",yt.enum=ct,yt.default=_e),super(Q,Ce,Je,yt),this.c=ct,this.d=lt}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function E(ue){switch(ue){case"none":return D.None;case"keep":return D.Keep;case"brackets":return D.Brackets;case"advanced":return D.Advanced;case"full":return D.Full}}class k extends w{constructor(){super(Ae.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[l.localize(0,null),l.localize(1,null),l.localize(2,null)],default:"auto",tags:["accessibility"],description:l.localize(3,null)})}validate(Q){switch(Q){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(Q,Ce,Je){return Je===I.AccessibilitySupport.Unknown?Q.accessibilitySupport:Je}}class C extends w{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(Ae.comments,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:l.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:l.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{insertSpace:i(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var v;(function(ue){ue[ue.Hidden=0]="Hidden",ue[ue.Blink=1]="Blink",ue[ue.Smooth=2]="Smooth",ue[ue.Phase=3]="Phase",ue[ue.Expand=4]="Expand",ue[ue.Solid=5]="Solid"})(v||(e.TextEditorCursorBlinkingStyle=v={}));function b(ue){switch(ue){case"blink":return v.Blink;case"smooth":return v.Smooth;case"phase":return v.Phase;case"expand":return v.Expand;case"solid":return v.Solid}}var O;(function(ue){ue[ue.Line=1]="Line",ue[ue.Block=2]="Block",ue[ue.Underline=3]="Underline",ue[ue.LineThin=4]="LineThin",ue[ue.BlockOutline=5]="BlockOutline",ue[ue.UnderlineThin=6]="UnderlineThin"})(O||(e.TextEditorCursorStyle=O={}));function U(ue){switch(ue){case O.Line:return"line";case O.Block:return"block";case O.Underline:return"underline";case O.LineThin:return"line-thin";case O.BlockOutline:return"block-outline";case O.UnderlineThin:return"underline-thin"}}function z(ue){switch(ue){case"line":return O.Line;case"block":return O.Block;case"underline":return O.Underline;case"line-thin":return O.LineThin;case"block-outline":return O.BlockOutline;case"underline-thin":return O.UnderlineThin}}class j extends g{constructor(){super(Ae.editorClassName)}compute(Q,Ce,Je){const _e=["monaco-editor"];return Ce.get(Ae.extraEditorClassName)&&_e.push(Ce.get(Ae.extraEditorClassName)),Q.extraEditorClassName&&_e.push(Q.extraEditorClassName),Ce.get(Ae.mouseStyle)==="default"?_e.push("mouse-default"):Ce.get(Ae.mouseStyle)==="copy"&&_e.push("mouse-copy"),Ce.get(Ae.showUnused)&&_e.push("showUnused"),Ce.get(Ae.showDeprecated)&&_e.push("showDeprecated"),_e.join(" ")}}class M extends o{constructor(){super(Ae.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:l.localize(6,null)})}compute(Q,Ce,Je){return Je&&Q.emptySelectionClipboard}}class N extends w{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(Ae.find,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:l.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[l.localize(8,null),l.localize(9,null),l.localize(10,null)],description:l.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[l.localize(12,null),l.localize(13,null),l.localize(14,null)],description:l.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:l.localize(16,null),included:P.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:l.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:l.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{cursorMoveOnType:i(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":m(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":m(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Ce.loop,this.defaultValue.loop)}}}class F extends w{constructor(){super(Ae.fontLigatures,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:l.localize(19,null)},{type:"string",description:l.localize(20,null)}],description:l.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"||Q.length===0?F.OFF:Q==="true"?F.ON:Q:Q?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class X extends w{constructor(){super(Ae.fontVariations,"fontVariations",X.OFF,{anyOf:[{type:"boolean",description:l.localize(22,null)},{type:"string",description:l.localize(23,null)}],description:l.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?X.OFF:Q==="true"?X.TRANSLATE:Q:Q?X.TRANSLATE:X.OFF}compute(Q,Ce,Je){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=X,X.OFF="normal",X.TRANSLATE="translate";class se extends g{constructor(){super(Ae.fontInfo)}compute(Q,Ce,Je){return Q.fontInfo}}class W extends ${constructor(){super(Ae.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:l.localize(25,null)})}validate(Q){const Ce=h.float(Q,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(Ce,6,100)}compute(Q,Ce,Je){return Q.fontInfo.fontSize}}class H extends w{constructor(){super(Ae.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:l.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:l.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(t.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}H.c=["normal","bold","100","200","300","400","500","600","700","800","900"],H.d=1,H.e=1e3;class V extends w{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[l.localize(28,null),l.localize(29,null),l.localize(30,null)]},Je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(Ae.gotoLocation,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:l.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:l.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:l.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:l.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:l.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:l.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Je,description:l.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Je,description:l.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Je,description:l.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Je,description:l.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Je,description:l.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{multiple:m(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??m(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??m(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??m(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??m(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??m(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:s.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:s.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:s.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:s.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:s.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class x extends w{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(Ae.hover,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:l.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:l.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:l.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:l.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:l.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),delay:t.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:i(Ce.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Ce.above,this.defaultValue.above)}}}var he;(function(ue){ue[ue.None=0]="None",ue[ue.Text=1]="Text",ue[ue.Blocks=2]="Blocks"})(he||(e.RenderMinimap=he={}));class ne extends g{constructor(){super(Ae.layoutInfo)}compute(Q,Ce,Je){return ne.computeLayout(Ce,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const Ce=Q.height/Q.lineHeight,Je=Math.floor(Q.paddingTop/Q.lineHeight);let _e=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(_e=Math.max(_e,Ce-1));const ct=(Je+Q.viewLineCount+_e)/(Q.pixelRatio*Q.height),lt=Math.floor(Q.viewLineCount/ct);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Je,extraLinesBeyondLastLine:_e,desiredRatio:ct,minimapLineCount:lt}}static c(Q,Ce){const Je=Q.outerWidth,_e=Q.outerHeight,ct=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:he.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ct*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const lt=Ce.stableMinimapLayoutInput,yt=lt&&Q.outerHeight===lt.outerHeight&&Q.lineHeight===lt.lineHeight&&Q.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&Q.pixelRatio===lt.pixelRatio&&Q.scrollBeyondLastLine===lt.scrollBeyondLastLine&&Q.paddingTop===lt.paddingTop&&Q.paddingBottom===lt.paddingBottom&&Q.minimap.enabled===lt.minimap.enabled&&Q.minimap.side===lt.minimap.side&&Q.minimap.size===lt.minimap.size&&Q.minimap.showSlider===lt.minimap.showSlider&&Q.minimap.renderCharacters===lt.minimap.renderCharacters&&Q.minimap.maxColumn===lt.minimap.maxColumn&&Q.minimap.scale===lt.minimap.scale&&Q.verticalScrollbarWidth===lt.verticalScrollbarWidth&&Q.isViewportWrapping===lt.isViewportWrapping,At=Q.lineHeight,Ot=Q.typicalHalfwidthCharacterWidth,_t=Q.scrollBeyondLastLine,rn=Q.minimap.renderCharacters;let xe=ct>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const en=Q.minimap.maxColumn,Zt=Q.minimap.size,$t=Q.minimap.side,wt=Q.verticalScrollbarWidth,Qt=Q.viewLineCount,tn=Q.remainingWidth,qt=Q.isViewportWrapping,bt=rn?2:3;let Mt=Math.floor(ct*_e);const Wt=Mt/ct;let Ut=!1,Ye=!1,nn=bt*xe,sn=xe/ct,un=1;if(Zt==="fill"||Zt==="fit"){const{typicalViewportLineCount:cn,extraLinesBeforeFirstLine:Gt,extraLinesBeyondLastLine:zt,desiredRatio:ln,minimapLineCount:Rt}=ne.computeContainedMinimapLineCount({viewLineCount:Qt,scrollBeyondLastLine:_t,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:_e,lineHeight:At,pixelRatio:ct});if(Qt/Rt>1)Ut=!0,Ye=!0,xe=1,nn=1,sn=xe/ct;else{let Et=!1,Kt=xe+1;if(Zt==="fit"){const Dt=Math.ceil((Gt+Qt+zt)*nn);qt&&yt&&tn<=Ce.stableFitRemainingWidth?(Et=!0,Kt=Ce.stableFitMaxMinimapScale):Et=Dt>Mt}if(Zt==="fill"||Et){Ut=!0;const Dt=xe;nn=Math.min(At*ct,Math.max(1,Math.floor(1/ln))),qt&&yt&&tn<=Ce.stableFitRemainingWidth&&(Kt=Ce.stableFitMaxMinimapScale),xe=Math.min(Kt,Math.max(1,Math.floor(nn/bt))),xe>Dt&&(un=Math.min(2,xe/Dt)),sn=xe/ct/un,Mt=Math.ceil(Math.max(cn,Gt+Qt+zt)*nn),qt?(Ce.stableMinimapLayoutInput=Q,Ce.stableFitRemainingWidth=tn,Ce.stableFitMaxMinimapScale=xe):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const Pt=Math.floor(en*sn),jt=Math.min(Pt,Math.max(0,Math.floor((tn-wt-2)*sn/(Ot+sn)))+e.MINIMAP_GUTTER_WIDTH);let Nt=Math.floor(ct*jt);const Ht=Nt/ct;Nt=Math.floor(Nt*un);const hn=rn?he.Text:he.Blocks,on=$t==="left"?0:Je-jt-wt;return{renderMinimap:hn,minimapLeft:on,minimapWidth:jt,minimapHeightIsEditorHeight:Ut,minimapIsSampling:Ye,minimapScale:xe,minimapLineHeight:nn,minimapCanvasInnerWidth:Nt,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Ht,minimapCanvasOuterHeight:Wt}}static computeLayout(Q,Ce){const Je=Ce.outerWidth|0,_e=Ce.outerHeight|0,ct=Ce.lineHeight|0,lt=Ce.lineNumbersDigitCount|0,yt=Ce.typicalHalfwidthCharacterWidth,At=Ce.maxDigitWidth,Ot=Ce.pixelRatio,_t=Ce.viewLineCount,rn=Q.get(Ae.wordWrapOverride2),xe=rn==="inherit"?Q.get(Ae.wordWrapOverride1):rn,en=xe==="inherit"?Q.get(Ae.wordWrap):xe,Zt=Q.get(Ae.wordWrapColumn),$t=Ce.isDominatedByLongLines,wt=Q.get(Ae.glyphMargin),Qt=Q.get(Ae.lineNumbers).renderType!==Me.Off,tn=Q.get(Ae.lineNumbersMinChars),qt=Q.get(Ae.scrollBeyondLastLine),bt=Q.get(Ae.padding),Mt=Q.get(Ae.minimap),Wt=Q.get(Ae.scrollbar),Ut=Wt.verticalScrollbarSize,Ye=Wt.verticalHasArrows,nn=Wt.arrowSize,sn=Wt.horizontalScrollbarSize,un=Q.get(Ae.folding),Pt=Q.get(Ae.showFoldingControls)!=="never";let jt=Q.get(Ae.lineDecorationsWidth);un&&Pt&&(jt+=16);let Nt=0;if(Qt){const Jt=Math.max(lt,tn);Nt=Math.round(Jt*At)}let Ht=0;wt&&(Ht=ct*Ce.glyphMarginDecorationLaneCount);let hn=0,on=hn+Ht,cn=on+Nt,Gt=cn+jt;const zt=Je-Ht-Nt-jt;let ln=!1,Rt=!1,St=-1;xe==="inherit"&&$t?(ln=!0,Rt=!0):en==="on"||en==="bounded"?Rt=!0:en==="wordWrapColumn"&&(St=Zt);const Et=ne.c({outerWidth:Je,outerHeight:_e,lineHeight:ct,typicalHalfwidthCharacterWidth:yt,pixelRatio:Ot,scrollBeyondLastLine:qt,paddingTop:bt.top,paddingBottom:bt.bottom,minimap:Mt,verticalScrollbarWidth:Ut,viewLineCount:_t,remainingWidth:zt,isViewportWrapping:Rt},Ce.memory||new A);Et.renderMinimap!==he.None&&Et.minimapLeft===0&&(hn+=Et.minimapWidth,on+=Et.minimapWidth,cn+=Et.minimapWidth,Gt+=Et.minimapWidth);const Kt=zt-Et.minimapWidth,Dt=Math.max(1,Math.floor((Kt-Ut-2)/yt)),Vt=Ye?nn:0;return Rt&&(St=Math.max(1,Dt),en==="bounded"&&(St=Math.min(St,Zt))),{width:Je,height:_e,glyphMarginLeft:hn,glyphMarginWidth:Ht,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:on,lineNumbersWidth:Nt,decorationsLeft:cn,decorationsWidth:jt,contentLeft:Gt,contentWidth:Kt,minimap:Et,viewportColumn:Dt,isWordWrapMinified:ln,isViewportWrapping:Rt,wrappingColumn:St,verticalScrollbarWidth:Ut,horizontalScrollbarHeight:sn,overviewRuler:{top:Vt,width:Ut,height:_e-2*Vt,right:0}}}}e.EditorLayoutInfoComputer=ne;class we extends w{constructor(){super(Ae.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[l.localize(47,null),l.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:l.localize(49,null)}})}validate(Q){return m(Q,"simple",["simple","advanced"])}compute(Q,Ce,Je){return Ce.get(Ae.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Je}}var pe;(function(ue){ue.Off="off",ue.OnCode="onCode",ue.On="on"})(pe||(e.ShowLightbulbIconMode=pe={}));class ce extends w{constructor(){const Q={enabled:pe.On};super(Ae.lightbulb,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[pe.Off,pe.OnCode,pe.On],default:Q.enabled,enumDescriptions:[l.localize(50,null),l.localize(51,null),l.localize(52,null)],description:l.localize(53,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:m(Q.enabled,this.defaultValue.enabled,[pe.Off,pe.OnCode,pe.On])}}}class K extends w{constructor(){const Q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(Ae.stickyScroll,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:l.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:20,description:l.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:l.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:l.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:m(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class de extends w{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(Ae.inlayHints,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:l.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[l.localize(59,null),l.localize(60,null,P.$d?"Ctrl+Option":"Ctrl+Alt"),l.localize(61,null,P.$d?"Ctrl+Option":"Ctrl+Alt"),l.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:l.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:l.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:l.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:m(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:s.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:i(Ce.padding,this.defaultValue.padding)}}}class te extends w{constructor(){super(Ae.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):t.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,Ce,Je){return Je<0?t.clampedInt(-Je*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Je}}class ee extends h{constructor(){super(Ae.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>h.clamp(Q,0,150),{markdownDescription:l.localize(66,null)})}compute(Q,Ce,Je){return Q.fontInfo.lineHeight}}class ie extends w{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(Ae.minimap,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:l.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:l.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[l.localize(69,null),l.localize(70,null),l.localize(71,null)],default:Q.size,description:l.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:l.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:l.localize(74,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:l.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:l.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:l.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Q.showRegionSectionHeaders,description:l.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Q.showMarkSectionHeaders,description:l.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Q.sectionHeaderFontSize,description:l.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:Q.sectionHeaderLetterSpacing,description:l.localize(81,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),autohide:i(Ce.autohide,this.defaultValue.autohide),size:m(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:m(Ce.side,this.defaultValue.side,["right","left"]),showSlider:m(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt(Ce.scale,1,1,3),maxColumn:t.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Ce.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Ce.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp(Ce.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:h.clamp(Ce.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function le(ue){return ue==="ctrlCmd"?P.$d?"metaKey":"ctrlKey":"altKey"}class Z extends w{constructor(){super(Ae.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:l.localize(83,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{top:t.clampedInt(Ce.top,0,0,1e3),bottom:t.clampedInt(Ce.bottom,0,0,1e3)}}}class ae extends w{constructor(){const Q={enabled:!0,cycle:!0};super(Ae.parameterHints,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:l.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:l.localize(85,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),cycle:i(Ce.cycle,this.defaultValue.cycle)}}}class $e extends g{constructor(){super(Ae.pixelRatio)}compute(Q,Ce,Je){return Q.pixelRatio}}class be extends w{constructor(){const Q={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[l.localize(86,null),l.localize(87,null),l.localize(88,null)]}];super(Ae.quickSuggestions,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:Q.strings,description:l.localize(89,null)},comments:{anyOf:Ce,default:Q.comments,description:l.localize(90,null)},other:{anyOf:Ce,default:Q.other,description:l.localize(91,null)}},default:Q,markdownDescription:l.localize(92,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Ot=Q?"on":"off";return{comments:Ot,strings:Ot,other:Ot}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:Ce,comments:Je,strings:_e}=Q,ct=["on","inline","off"];let lt,yt,At;return typeof Ce=="boolean"?lt=Ce?"on":"off":lt=m(Ce,this.defaultValue.other,ct),typeof Je=="boolean"?yt=Je?"on":"off":yt=m(Je,this.defaultValue.comments,ct),typeof _e=="boolean"?At=_e?"on":"off":At=m(_e,this.defaultValue.strings,ct),{other:lt,comments:yt,strings:At}}}var Me;(function(ue){ue[ue.Off=0]="Off",ue[ue.On=1]="On",ue[ue.Relative=2]="Relative",ue[ue.Interval=3]="Interval",ue[ue.Custom=4]="Custom"})(Me||(e.RenderLineNumbersType=Me={}));class qe extends w{constructor(){super(Ae.lineNumbers,"lineNumbers",{renderType:Me.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[l.localize(93,null),l.localize(94,null),l.localize(95,null),l.localize(96,null)],default:"on",description:l.localize(97,null)})}validate(Q){let Ce=this.defaultValue.renderType,Je=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?(Ce=Me.Custom,Je=Q):Q==="interval"?Ce=Me.Interval:Q==="relative"?Ce=Me.Relative:Q==="on"?Ce=Me.On:Ce=Me.Off),{renderType:Ce,renderFn:Je}}}function De(ue){const Q=ue.get(Ae.renderValidationDecorations);return Q==="editable"?ue.get(Ae.readOnly):Q!=="on"}class Pe extends w{constructor(){const Q=[],Ce={type:"number",description:l.localize(98,null)};super(Ae.rulers,"rulers",Q,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:l.localize(99,null),format:"color-hex"}}}]},default:Q,description:l.localize(100,null)})}validate(Q){if(Array.isArray(Q)){const Ce=[];for(const Je of Q)if(typeof Je=="number")Ce.push({column:t.clampedInt(Je,0,0,1e4),color:null});else if(Je&&typeof Je=="object"){const _e=Je;Ce.push({column:t.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Ce.sort((Je,_e)=>Je.column-_e.column),Ce}return this.defaultValue}}class Te extends w{constructor(){super(Ae.readOnlyMessage,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function B(ue,Q){if(typeof ue!="string")return Q;switch(ue){case"hidden":return T.ScrollbarVisibility.Hidden;case"visible":return T.ScrollbarVisibility.Visible;default:return T.ScrollbarVisibility.Auto}}class q extends w{constructor(){const Q={vertical:T.ScrollbarVisibility.Auto,horizontal:T.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(Ae.scrollbar,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(101,null),l.localize(102,null),l.localize(103,null)],default:"auto",description:l.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[l.localize(105,null),l.localize(106,null),l.localize(107,null)],default:"auto",description:l.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:l.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:l.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:l.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:l.localize(112,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q,Je=t.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=t.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:B(Ce.vertical,this.defaultValue.vertical),horizontal:B(Ce.horizontal,this.defaultValue.horizontal),useShadows:i(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Je,horizontalSliderSize:t.clampedInt(Ce.horizontalSliderSize,Je,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:t.clampedInt(Ce.verticalSliderSize,_e,0,1e3),scrollByPage:i(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Y extends w{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(Ae.unicodeHighlighting,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:l.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:l.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:l.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:l.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:l.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:l.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:l.localize(119,null)}})}applyUpdate(Q,Ce){let Je=!1;Ce.allowedCharacters&&Q&&(u.$bo(Q.allowedCharacters,Ce.allowedCharacters)||(Q={...Q,allowedCharacters:Ce.allowedCharacters},Je=!0)),Ce.allowedLocales&&Q&&(u.$bo(Q.allowedLocales,Ce.allowedLocales)||(Q={...Q,allowedLocales:Ce.allowedLocales},Je=!0));const _e=super.applyUpdate(Q,Ce);return Je?new a(_e.newValue,!0):_e}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{nonBasicASCII:Be(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Be(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Be(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,Ce){if(typeof Q!="object"||!Q)return Ce;const Je={};for(const[_e,ct]of Object.entries(Q))ct===!0&&(Je[_e]=!0);return Je}}class _ extends w{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(Ae.inlineSuggest,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:l.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(121,null),l.localize(122,null),l.localize(123,null)],description:l.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:l.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Q.fontFamily,description:l.localize(126,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),mode:m(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:m(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:s.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class fe extends w{constructor(){const Q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(Ae.inlineEdit,"experimentalInlineEdit",Q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Q.enabled,description:l.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[l.localize(128,null),l.localize(129,null),l.localize(130,null)],description:l.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Q.fontFamily,description:l.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Q.backgroundColoring,description:l.localize(133,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),showToolbar:m(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:s.string(Ce.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Ce.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:i(Ce.backgroundColoring,this.defaultValue.backgroundColoring)}}}class ve extends w{constructor(){const Q={enabled:R.$ou.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$ou.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(Ae.bracketPairColorization,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:l.localize(135,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Ne extends w{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(Ae.guides,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(136,null),l.localize(137,null),l.localize(138,null)],default:Q.bracketPairs,description:l.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[l.localize(140,null),l.localize(141,null),l.localize(142,null)],default:Q.bracketPairsHorizontal,description:l.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:l.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:l.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[l.localize(146,null),l.localize(147,null),l.localize(148,null)],default:Q.highlightActiveIndentation,description:l.localize(149,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{bracketPairs:Be(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Be(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:Be(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Be(ue,Q,Ce){const Je=Ce.indexOf(ue);return Je===-1?Q:Ce[Je]}class Qe extends w{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(Ae.suggest,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[l.localize(150,null),l.localize(151,null)],default:Q.insertMode,description:l.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:l.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:l.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:l.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[l.localize(156,null),l.localize(157,null),l.localize(158,null),l.localize(159,null)],default:Q.selectionMode,markdownDescription:l.localize(160,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:l.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:l.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:l.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:l.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:l.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:l.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:l.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:l.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:l.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:l.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:l.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:l.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:l.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:l.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:l.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:l.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:l.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:l.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:l.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:l.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:l.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:l.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:l.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:l.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:l.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:l.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:l.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:l.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:l.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:l.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:l.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:l.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:l.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:l.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:l.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:l.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:l.localize(197,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{insertMode:m(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:m(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:i(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:i(Ce.preview,this.defaultValue.preview),previewMode:m(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Ce.showMethods,this.defaultValue.showMethods),showFunctions:i(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Ce.showFields,this.defaultValue.showFields),showVariables:i(Ce.showVariables,this.defaultValue.showVariables),showClasses:i(Ce.showClasses,this.defaultValue.showClasses),showStructs:i(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:i(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Ce.showModules,this.defaultValue.showModules),showProperties:i(Ce.showProperties,this.defaultValue.showProperties),showEvents:i(Ce.showEvents,this.defaultValue.showEvents),showOperators:i(Ce.showOperators,this.defaultValue.showOperators),showUnits:i(Ce.showUnits,this.defaultValue.showUnits),showValues:i(Ce.showValues,this.defaultValue.showValues),showConstants:i(Ce.showConstants,this.defaultValue.showConstants),showEnums:i(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Ce.showKeywords,this.defaultValue.showKeywords),showWords:i(Ce.showWords,this.defaultValue.showWords),showColors:i(Ce.showColors,this.defaultValue.showColors),showFiles:i(Ce.showFiles,this.defaultValue.showFiles),showReferences:i(Ce.showReferences,this.defaultValue.showReferences),showFolders:i(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:i(Ce.showUsers,this.defaultValue.showUsers),showIssues:i(Ce.showIssues,this.defaultValue.showIssues)}}}class He extends w{constructor(){super(Ae.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:l.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:l.localize(199,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(Q.selectSubwords,this.defaultValue.selectSubwords)}}}class tt extends w{constructor(){const Q=[];super(Ae.wordSegmenterLocales,"wordSegmenterLocales",Q,{anyOf:[{description:l.localize(200,null),type:"string"},{description:l.localize(201,null),type:"array",items:{type:"string"}}]})}validate(Q){if(typeof Q=="string"&&(Q=[Q]),Array.isArray(Q)){const Ce=[];for(const Je of Q)if(typeof Je=="string")try{Intl.Segmenter.supportedLocalesOf(Je).length>0&&Ce.push(Je)}catch{}return Ce}return this.defaultValue}}var nt;(function(ue){ue[ue.None=0]="None",ue[ue.Same=1]="Same",ue[ue.Indent=2]="Indent",ue[ue.DeepIndent=3]="DeepIndent"})(nt||(e.WrappingIndent=nt={}));class ot extends w{constructor(){super(Ae.wrappingIndent,"wrappingIndent",nt.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[l.localize(202,null),l.localize(203,null),l.localize(204,null),l.localize(205,null)],description:l.localize(206,null),default:"same"}})}validate(Q){switch(Q){case"none":return nt.None;case"same":return nt.Same;case"indent":return nt.Indent;case"deepIndent":return nt.DeepIndent}return nt.Same}compute(Q,Ce,Je){return Ce.get(Ae.accessibilitySupport)===I.AccessibilitySupport.Enabled?nt.None:Je}}class at extends g{constructor(){super(Ae.wrappingInfo)}compute(Q,Ce,Je){const _e=Ce.get(Ae.layoutInfo);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}class pt extends w{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(Ae.dropIntoEditor,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:l.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[l.localize(209,null),l.localize(210,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),showDropSelector:m(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class ft extends w{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(Ae.pasteAs,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:l.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:l.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[l.localize(213,null),l.localize(214,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const Ce=Q;return{enabled:i(Ce.enabled,this.defaultValue.enabled),showPasteSelector:m(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",ht="Menlo, Monaco, 'Courier New', monospace",Re="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$d?ht:P.$e?Re:st,fontWeight:"normal",fontSize:P.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ie(ue){return e.editorOptionsRegistry[ue.id]=ue,ue}var Ae;(function(ue){ue[ue.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ue[ue.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ue[ue.accessibilitySupport=2]="accessibilitySupport",ue[ue.accessibilityPageSize=3]="accessibilityPageSize",ue[ue.ariaLabel=4]="ariaLabel",ue[ue.ariaRequired=5]="ariaRequired",ue[ue.autoClosingBrackets=6]="autoClosingBrackets",ue[ue.autoClosingComments=7]="autoClosingComments",ue[ue.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ue[ue.autoClosingDelete=9]="autoClosingDelete",ue[ue.autoClosingOvertype=10]="autoClosingOvertype",ue[ue.autoClosingQuotes=11]="autoClosingQuotes",ue[ue.autoIndent=12]="autoIndent",ue[ue.automaticLayout=13]="automaticLayout",ue[ue.autoSurround=14]="autoSurround",ue[ue.bracketPairColorization=15]="bracketPairColorization",ue[ue.guides=16]="guides",ue[ue.codeLens=17]="codeLens",ue[ue.codeLensFontFamily=18]="codeLensFontFamily",ue[ue.codeLensFontSize=19]="codeLensFontSize",ue[ue.colorDecorators=20]="colorDecorators",ue[ue.colorDecoratorsLimit=21]="colorDecoratorsLimit",ue[ue.columnSelection=22]="columnSelection",ue[ue.comments=23]="comments",ue[ue.contextmenu=24]="contextmenu",ue[ue.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ue[ue.cursorBlinking=26]="cursorBlinking",ue[ue.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ue[ue.cursorStyle=28]="cursorStyle",ue[ue.cursorSurroundingLines=29]="cursorSurroundingLines",ue[ue.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ue[ue.cursorWidth=31]="cursorWidth",ue[ue.disableLayerHinting=32]="disableLayerHinting",ue[ue.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ue[ue.domReadOnly=34]="domReadOnly",ue[ue.dragAndDrop=35]="dragAndDrop",ue[ue.dropIntoEditor=36]="dropIntoEditor",ue[ue.emptySelectionClipboard=37]="emptySelectionClipboard",ue[ue.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ue[ue.extraEditorClassName=39]="extraEditorClassName",ue[ue.fastScrollSensitivity=40]="fastScrollSensitivity",ue[ue.find=41]="find",ue[ue.fixedOverflowWidgets=42]="fixedOverflowWidgets",ue[ue.folding=43]="folding",ue[ue.foldingStrategy=44]="foldingStrategy",ue[ue.foldingHighlight=45]="foldingHighlight",ue[ue.foldingImportsByDefault=46]="foldingImportsByDefault",ue[ue.foldingMaximumRegions=47]="foldingMaximumRegions",ue[ue.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ue[ue.fontFamily=49]="fontFamily",ue[ue.fontInfo=50]="fontInfo",ue[ue.fontLigatures=51]="fontLigatures",ue[ue.fontSize=52]="fontSize",ue[ue.fontWeight=53]="fontWeight",ue[ue.fontVariations=54]="fontVariations",ue[ue.formatOnPaste=55]="formatOnPaste",ue[ue.formatOnType=56]="formatOnType",ue[ue.glyphMargin=57]="glyphMargin",ue[ue.gotoLocation=58]="gotoLocation",ue[ue.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ue[ue.hover=60]="hover",ue[ue.inDiffEditor=61]="inDiffEditor",ue[ue.inlineSuggest=62]="inlineSuggest",ue[ue.inlineEdit=63]="inlineEdit",ue[ue.letterSpacing=64]="letterSpacing",ue[ue.lightbulb=65]="lightbulb",ue[ue.lineDecorationsWidth=66]="lineDecorationsWidth",ue[ue.lineHeight=67]="lineHeight",ue[ue.lineNumbers=68]="lineNumbers",ue[ue.lineNumbersMinChars=69]="lineNumbersMinChars",ue[ue.linkedEditing=70]="linkedEditing",ue[ue.links=71]="links",ue[ue.matchBrackets=72]="matchBrackets",ue[ue.minimap=73]="minimap",ue[ue.mouseStyle=74]="mouseStyle",ue[ue.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ue[ue.mouseWheelZoom=76]="mouseWheelZoom",ue[ue.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ue[ue.multiCursorModifier=78]="multiCursorModifier",ue[ue.multiCursorPaste=79]="multiCursorPaste",ue[ue.multiCursorLimit=80]="multiCursorLimit",ue[ue.occurrencesHighlight=81]="occurrencesHighlight",ue[ue.overviewRulerBorder=82]="overviewRulerBorder",ue[ue.overviewRulerLanes=83]="overviewRulerLanes",ue[ue.padding=84]="padding",ue[ue.pasteAs=85]="pasteAs",ue[ue.parameterHints=86]="parameterHints",ue[ue.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ue[ue.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",ue[ue.quickSuggestions=89]="quickSuggestions",ue[ue.quickSuggestionsDelay=90]="quickSuggestionsDelay",ue[ue.readOnly=91]="readOnly",ue[ue.readOnlyMessage=92]="readOnlyMessage",ue[ue.renameOnType=93]="renameOnType",ue[ue.renderControlCharacters=94]="renderControlCharacters",ue[ue.renderFinalNewline=95]="renderFinalNewline",ue[ue.renderLineHighlight=96]="renderLineHighlight",ue[ue.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",ue[ue.renderValidationDecorations=98]="renderValidationDecorations",ue[ue.renderWhitespace=99]="renderWhitespace",ue[ue.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",ue[ue.roundedSelection=101]="roundedSelection",ue[ue.rulers=102]="rulers",ue[ue.scrollbar=103]="scrollbar",ue[ue.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",ue[ue.scrollBeyondLastLine=105]="scrollBeyondLastLine",ue[ue.scrollPredominantAxis=106]="scrollPredominantAxis",ue[ue.selectionClipboard=107]="selectionClipboard",ue[ue.selectionHighlight=108]="selectionHighlight",ue[ue.selectOnLineNumbers=109]="selectOnLineNumbers",ue[ue.showFoldingControls=110]="showFoldingControls",ue[ue.showUnused=111]="showUnused",ue[ue.snippetSuggestions=112]="snippetSuggestions",ue[ue.smartSelect=113]="smartSelect",ue[ue.smoothScrolling=114]="smoothScrolling",ue[ue.stickyScroll=115]="stickyScroll",ue[ue.stickyTabStops=116]="stickyTabStops",ue[ue.stopRenderingLineAfter=117]="stopRenderingLineAfter",ue[ue.suggest=118]="suggest",ue[ue.suggestFontSize=119]="suggestFontSize",ue[ue.suggestLineHeight=120]="suggestLineHeight",ue[ue.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",ue[ue.suggestSelection=122]="suggestSelection",ue[ue.tabCompletion=123]="tabCompletion",ue[ue.tabIndex=124]="tabIndex",ue[ue.unicodeHighlighting=125]="unicodeHighlighting",ue[ue.unusualLineTerminators=126]="unusualLineTerminators",ue[ue.useShadowDOM=127]="useShadowDOM",ue[ue.useTabStops=128]="useTabStops",ue[ue.wordBreak=129]="wordBreak",ue[ue.wordSegmenterLocales=130]="wordSegmenterLocales",ue[ue.wordSeparators=131]="wordSeparators",ue[ue.wordWrap=132]="wordWrap",ue[ue.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",ue[ue.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",ue[ue.wordWrapColumn=135]="wordWrapColumn",ue[ue.wordWrapOverride1=136]="wordWrapOverride1",ue[ue.wordWrapOverride2=137]="wordWrapOverride2",ue[ue.wrappingIndent=138]="wrappingIndent",ue[ue.wrappingStrategy=139]="wrappingStrategy",ue[ue.showDeprecated=140]="showDeprecated",ue[ue.inlayHints=141]="inlayHints",ue[ue.editorClassName=142]="editorClassName",ue[ue.pixelRatio=143]="pixelRatio",ue[ue.tabFocusMode=144]="tabFocusMode",ue[ue.layoutInfo=145]="layoutInfo",ue[ue.wrappingInfo=146]="wrappingInfo",ue[ue.defaultColorDecorators=147]="defaultColorDecorators",ue[ue.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",ue[ue.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(Ae||(e.EditorOption=Ae={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ie(new o(Ae.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:l.localize(215,null)})),acceptSuggestionOnEnter:Ie(new y(Ae.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",l.localize(216,null),""],markdownDescription:l.localize(217,null)})),accessibilitySupport:Ie(new k),accessibilityPageSize:Ie(new t(Ae.accessibilityPageSize,"accessibilityPageSize",10,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(218,null),tags:["accessibility"]})),ariaLabel:Ie(new s(Ae.ariaLabel,"ariaLabel",l.localize(219,null))),ariaRequired:Ie(new o(Ae.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ie(new o(Ae.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:l.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:Ie(new y(Ae.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(221,null),l.localize(222,null),""],description:l.localize(223,null)})),autoClosingComments:Ie(new y(Ae.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(224,null),l.localize(225,null),""],description:l.localize(226,null)})),autoClosingDelete:Ie(new y(Ae.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",l.localize(227,null),""],description:l.localize(228,null)})),autoClosingOvertype:Ie(new y(Ae.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",l.localize(229,null),""],description:l.localize(230,null)})),autoClosingQuotes:Ie(new y(Ae.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",l.localize(231,null),l.localize(232,null),""],description:l.localize(233,null)})),autoIndent:Ie(new S(Ae.autoIndent,"autoIndent",D.Full,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[l.localize(234,null),l.localize(235,null),l.localize(236,null),l.localize(237,null),l.localize(238,null)],description:l.localize(239,null)})),automaticLayout:Ie(new o(Ae.automaticLayout,"automaticLayout",!1)),autoSurround:Ie(new y(Ae.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[l.localize(240,null),l.localize(241,null),l.localize(242,null),""],description:l.localize(243,null)})),bracketPairColorization:Ie(new ve),bracketPairGuides:Ie(new Ne),stickyTabStops:Ie(new o(Ae.stickyTabStops,"stickyTabStops",!1,{description:l.localize(244,null)})),codeLens:Ie(new o(Ae.codeLens,"codeLens",!0,{description:l.localize(245,null)})),codeLensFontFamily:Ie(new s(Ae.codeLensFontFamily,"codeLensFontFamily","",{description:l.localize(246,null)})),codeLensFontSize:Ie(new t(Ae.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:l.localize(247,null)})),colorDecorators:Ie(new o(Ae.colorDecorators,"colorDecorators",!0,{description:l.localize(248,null)})),colorDecoratorActivatedOn:Ie(new y(Ae.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[l.localize(249,null),l.localize(250,null),l.localize(251,null)],description:l.localize(252,null)})),colorDecoratorsLimit:Ie(new t(Ae.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:l.localize(253,null)})),columnSelection:Ie(new o(Ae.columnSelection,"columnSelection",!1,{description:l.localize(254,null)})),comments:Ie(new C),contextmenu:Ie(new o(Ae.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:Ie(new o(Ae.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:l.localize(255,null)})),cursorBlinking:Ie(new S(Ae.cursorBlinking,"cursorBlinking",v.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:l.localize(256,null)})),cursorSmoothCaretAnimation:Ie(new y(Ae.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[l.localize(257,null),l.localize(258,null),l.localize(259,null)],description:l.localize(260,null)})),cursorStyle:Ie(new S(Ae.cursorStyle,"cursorStyle",O.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],z,{description:l.localize(261,null)})),cursorSurroundingLines:Ie(new t(Ae.cursorSurroundingLines,"cursorSurroundingLines",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(262,null)})),cursorSurroundingLinesStyle:Ie(new y(Ae.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[l.localize(263,null),l.localize(264,null)],markdownDescription:l.localize(265,null)})),cursorWidth:Ie(new t(Ae.cursorWidth,"cursorWidth",0,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(266,null)})),disableLayerHinting:Ie(new o(Ae.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ie(new o(Ae.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:Ie(new o(Ae.domReadOnly,"domReadOnly",!1)),dragAndDrop:Ie(new o(Ae.dragAndDrop,"dragAndDrop",!0,{description:l.localize(267,null)})),emptySelectionClipboard:Ie(new M),dropIntoEditor:Ie(new pt),stickyScroll:Ie(new K),experimentalWhitespaceRendering:Ie(new y(Ae.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[l.localize(268,null),l.localize(269,null),l.localize(270,null)],description:l.localize(271,null)})),extraEditorClassName:Ie(new s(Ae.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:Ie(new h(Ae.fastScrollSensitivity,"fastScrollSensitivity",5,ue=>ue<=0?5:ue,{markdownDescription:l.localize(272,null)})),find:Ie(new N),fixedOverflowWidgets:Ie(new o(Ae.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:Ie(new o(Ae.folding,"folding",!0,{description:l.localize(273,null)})),foldingStrategy:Ie(new y(Ae.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[l.localize(274,null),l.localize(275,null)],description:l.localize(276,null)})),foldingHighlight:Ie(new o(Ae.foldingHighlight,"foldingHighlight",!0,{description:l.localize(277,null)})),foldingImportsByDefault:Ie(new o(Ae.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:l.localize(278,null)})),foldingMaximumRegions:Ie(new t(Ae.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:l.localize(279,null)})),unfoldOnClickAfterEndOfLine:Ie(new o(Ae.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:l.localize(280,null)})),fontFamily:Ie(new s(Ae.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:l.localize(281,null)})),fontInfo:Ie(new se),fontLigatures2:Ie(new F),fontSize:Ie(new W),fontWeight:Ie(new H),fontVariations:Ie(new X),formatOnPaste:Ie(new o(Ae.formatOnPaste,"formatOnPaste",!1,{description:l.localize(282,null)})),formatOnType:Ie(new o(Ae.formatOnType,"formatOnType",!1,{description:l.localize(283,null)})),glyphMargin:Ie(new o(Ae.glyphMargin,"glyphMargin",!0,{description:l.localize(284,null)})),gotoLocation:Ie(new V),hideCursorInOverviewRuler:Ie(new o(Ae.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:l.localize(285,null)})),hover:Ie(new x),inDiffEditor:Ie(new o(Ae.inDiffEditor,"inDiffEditor",!1)),letterSpacing:Ie(new h(Ae.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ue=>h.clamp(ue,-5,20),{description:l.localize(286,null)})),lightbulb:Ie(new ce),lineDecorationsWidth:Ie(new te),lineHeight:Ie(new ee),lineNumbers:Ie(new qe),lineNumbersMinChars:Ie(new t(Ae.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:Ie(new o(Ae.linkedEditing,"linkedEditing",!1,{description:l.localize(287,null)})),links:Ie(new o(Ae.links,"links",!0,{description:l.localize(288,null)})),matchBrackets:Ie(new y(Ae.matchBrackets,"matchBrackets","always",["always","near","never"],{description:l.localize(289,null)})),minimap:Ie(new ie),mouseStyle:Ie(new y(Ae.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ie(new h(Ae.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ue=>ue===0?1:ue,{markdownDescription:l.localize(290,null)})),mouseWheelZoom:Ie(new o(Ae.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$d?l.localize(291,null):l.localize(292,null)})),multiCursorMergeOverlapping:Ie(new o(Ae.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:l.localize(293,null)})),multiCursorModifier:Ie(new S(Ae.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],le,{markdownEnumDescriptions:[l.localize(294,null),l.localize(295,null)],markdownDescription:l.localize(296,null)})),multiCursorPaste:Ie(new y(Ae.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[l.localize(297,null),l.localize(298,null)],markdownDescription:l.localize(299,null)})),multiCursorLimit:Ie(new t(Ae.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:l.localize(300,null)})),occurrencesHighlight:Ie(new y(Ae.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[l.localize(301,null),l.localize(302,null),l.localize(303,null)],markdownDescription:l.localize(304,null)})),overviewRulerBorder:Ie(new o(Ae.overviewRulerBorder,"overviewRulerBorder",!0,{description:l.localize(305,null)})),overviewRulerLanes:Ie(new t(Ae.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:Ie(new Z),pasteAs:Ie(new ft),parameterHints:Ie(new ae),peekWidgetDefaultFocus:Ie(new y(Ae.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[l.localize(306,null),l.localize(307,null)],description:l.localize(308,null)})),definitionLinkOpensInPeek:Ie(new o(Ae.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:l.localize(309,null)})),quickSuggestions:Ie(new be),quickSuggestionsDelay:Ie(new t(Ae.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(310,null)})),readOnly:Ie(new o(Ae.readOnly,"readOnly",!1)),readOnlyMessage:Ie(new Te),renameOnType:Ie(new o(Ae.renameOnType,"renameOnType",!1,{description:l.localize(311,null),markdownDeprecationMessage:l.localize(312,null)})),renderControlCharacters:Ie(new o(Ae.renderControlCharacters,"renderControlCharacters",!0,{description:l.localize(313,null),restricted:!0})),renderFinalNewline:Ie(new y(Ae.renderFinalNewline,"renderFinalNewline",P.$e?"dimmed":"on",["off","on","dimmed"],{description:l.localize(314,null)})),renderLineHighlight:Ie(new y(Ae.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",l.localize(315,null)],description:l.localize(316,null)})),renderLineHighlightOnlyWhenFocus:Ie(new o(Ae.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:l.localize(317,null)})),renderValidationDecorations:Ie(new y(Ae.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ie(new y(Ae.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",l.localize(318,null),l.localize(319,null),l.localize(320,null),""],description:l.localize(321,null)})),revealHorizontalRightPadding:Ie(new t(Ae.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ie(new o(Ae.roundedSelection,"roundedSelection",!0,{description:l.localize(322,null)})),rulers:Ie(new Pe),scrollbar:Ie(new q),scrollBeyondLastColumn:Ie(new t(Ae.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,L.Constants.MAX_SAFE_SMALL_INTEGER,{description:l.localize(323,null)})),scrollBeyondLastLine:Ie(new o(Ae.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:l.localize(324,null)})),scrollPredominantAxis:Ie(new o(Ae.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:l.localize(325,null)})),selectionClipboard:Ie(new o(Ae.selectionClipboard,"selectionClipboard",!0,{description:l.localize(326,null),included:P.$e})),selectionHighlight:Ie(new o(Ae.selectionHighlight,"selectionHighlight",!0,{description:l.localize(327,null)})),selectOnLineNumbers:Ie(new o(Ae.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:Ie(new y(Ae.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[l.localize(328,null),l.localize(329,null),l.localize(330,null)],description:l.localize(331,null)})),showUnused:Ie(new o(Ae.showUnused,"showUnused",!0,{description:l.localize(332,null)})),showDeprecated:Ie(new o(Ae.showDeprecated,"showDeprecated",!0,{description:l.localize(333,null)})),inlayHints:Ie(new de),snippetSuggestions:Ie(new y(Ae.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[l.localize(334,null),l.localize(335,null),l.localize(336,null),l.localize(337,null)],description:l.localize(338,null)})),smartSelect:Ie(new He),smoothScrolling:Ie(new o(Ae.smoothScrolling,"smoothScrolling",!1,{description:l.localize(339,null)})),stopRenderingLineAfter:Ie(new t(Ae.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:Ie(new Qe),inlineSuggest:Ie(new _),inlineEdit:Ie(new fe),inlineCompletionsAccessibilityVerbose:Ie(new o(Ae.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:l.localize(340,null)})),suggestFontSize:Ie(new t(Ae.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:l.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ie(new t(Ae.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:l.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ie(new o(Ae.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:l.localize(343,null)})),suggestSelection:Ie(new y(Ae.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[l.localize(344,null),l.localize(345,null),l.localize(346,null)],description:l.localize(347,null)})),tabCompletion:Ie(new y(Ae.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[l.localize(348,null),l.localize(349,null),l.localize(350,null)],description:l.localize(351,null)})),tabIndex:Ie(new t(Ae.tabIndex,"tabIndex",0,-1,L.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:Ie(new Y),unusualLineTerminators:Ie(new y(Ae.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[l.localize(352,null),l.localize(353,null),l.localize(354,null)],description:l.localize(355,null)})),useShadowDOM:Ie(new o(Ae.useShadowDOM,"useShadowDOM",!0)),useTabStops:Ie(new o(Ae.useTabStops,"useTabStops",!0,{description:l.localize(356,null)})),wordBreak:Ie(new y(Ae.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[l.localize(357,null),l.localize(358,null)],description:l.localize(359,null)})),wordSegmenterLocales:Ie(new tt),wordSeparators:Ie(new s(Ae.wordSeparators,"wordSeparators",p.$st,{description:l.localize(360,null)})),wordWrap:Ie(new y(Ae.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[l.localize(361,null),l.localize(362,null),l.localize(363,null),l.localize(364,null)],description:l.localize(365,null)})),wordWrapBreakAfterCharacters:Ie(new s(Ae.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ie(new s(Ae.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ie(new t(Ae.wordWrapColumn,"wordWrapColumn",80,1,L.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:l.localize(366,null)})),wordWrapOverride1:Ie(new y(Ae.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ie(new y(Ae.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ie(new j),defaultColorDecorators:Ie(new o(Ae.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:l.localize(367,null)})),pixelRatio:Ie(new $e),tabFocusMode:Ie(new o(Ae.tabFocusMode,"tabFocusMode",!1,{markdownDescription:l.localize(368,null)})),layoutInfo:Ie(new ne),wrappingInfo:Ie(new at),wrappingIndent:Ie(new ot),wrappingStrategy:Ie(new we)}}),define(Ee[265],Se([1,0,23,44,219,5,107,11,25]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Zw=e.$Yw=e.$Xw=void 0,e.$1w=A,e.$2w=w,e.$Xw=(0,T.$Ai)("dialogService");var l;(function(a){a[a.Confirmation=1]="Confirmation",a[a.Prompt=2]="Prompt",a[a.Input=3]="Input"})(l||(l={}));class I{a(d){return this.d(d,l.Confirmation)}b(d){return this.d(d,l.Prompt)}c(d){return this.d(d,l.Input)}d(d,g){const $=[];switch(g){case l.Confirmation:{const i=d;i.primaryButton?$.push(i.primaryButton):$.push((0,P.localize)(0,null)),i.cancelButton?$.push(i.cancelButton):$.push((0,P.localize)(1,null));break}case l.Prompt:{const i=d;Array.isArray(i.buttons)&&i.buttons.length>0&&$.push(...i.buttons.map(o=>o.label)),i.cancelButton&&(i.cancelButton===!0?$.push((0,P.localize)(2,null)):typeof i.cancelButton=="string"?$.push(i.cancelButton):i.cancelButton.label?$.push(i.cancelButton.label):$.push((0,P.localize)(3,null))),$.length===0&&$.push((0,P.localize)(4,null));break}case l.Input:{const i=d;i.primaryButton?$.push(i.primaryButton):$.push((0,P.localize)(5,null)),i.cancelButton?$.push(i.cancelButton):$.push((0,P.localize)(6,null));break}}return $}e(d){if(typeof d=="string")return d;if(typeof d=="number")return d===u.default.Info?"info":d===u.default.Error?"error":d===u.default.Warning?"warning":"none"}f(d,g,$){const i=[...d.buttons??[]];d.cancelButton&&typeof d.cancelButton!="string"&&typeof d.cancelButton!="boolean"&&i.push(d.cancelButton);let o=i[g]?.run({checkboxChecked:$});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:$}}}e.$Yw=I,e.$Zw=(0,T.$Ai)("fileDialogService");var D;(function(a){a[a.SAVE=0]="SAVE",a[a.DONT_SAVE=1]="DONT_SAVE",a[a.CANCEL=2]="CANCEL"})(D||(e.ConfirmResult=D={}));const f=10;function A(a){const d=[];return d.push(...a.slice(0,f).map(g=>typeof g=="string"?g:(0,r.$$g)(g))),a.length>f&&(a.length-f===1?d.push((0,P.localize)(7,null)):d.push((0,P.localize)(8,null,a.length-f))),d.push(""),d.join(`
`)}function w(a,d){const g=(0,p.$0n)(a);let $=(g.buttons??[]).map(t=>(0,L.$Uw)(t)),i=(a.buttons||[]).map((t,c)=>c),o=0,n=g.cancelId??$.length-1;if($.length>1){const t=typeof n=="number"?$[n]:void 0;if(R.$e||R.$d){if(typeof t=="string"&&$.length>1&&n!==1){$.splice(n,1),$.splice(1,0,t);const c=i[n];i.splice(n,1),i.splice(1,0,c),n=1}R.$e&&$.length>1&&($=$.reverse(),i=i.reverse(),o=$.length-1,typeof t=="string"&&(n=o-1))}else if(R.$c&&typeof t=="string"&&$.length>1&&n!==$.length-1){$.splice(n,1),$.push(t);const c=i[n];i.splice(n,1),i.push(c),n=$.length-1}}return g.buttons=$,g.defaultId=o,g.cancelId=n,g.noLink=!0,g.title=g.title||d.nameLong,{options:g,buttonIndeces:i}}}),define(Ee[144],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,r.$Ai)("environmentService"),e.$Ii=(0,r.$Bi)(e.$Hi)}),define(Ee[266],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s8b=e.$r8b=void 0,e.$r8b=(0,r.$Ai)("externalTerminal"),e.$s8b="Terminal.app"}),define(Ee[267],Se([1,0,57,60,15,16,11,104,34,109,222,266]),function(oe,e,r,u,P,T,L,R,p,l,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=e.$$dc=void 0;const f=I.localize(0,null);class A{async getDefaultTerminalForPlatforms(){return{windows:w.getDefaultTerminalWindows(),linux:await d.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class w extends A{openTerminal(n,t){return this.spawnTerminal(r,n,l.$um(),t)}spawnTerminal(n,t,c,h){const s=t.windowsExec||w.getDefaultTerminalWindows();h&&h[1]===":"&&(h=h[0].toUpperCase()+h.substr(1));const m=T.$nc(s,".exe").toLowerCase();if(m==="cmder")return n.spawn(s,h?[h]:void 0),Promise.resolve(void 0);const y=["/c","start","/wait"];return s.indexOf(" ")>=0&&y.push('""'),y.push(s),m==="wt"&&y.push("-d ."),new Promise((S,E)=>{const k=g(process),C=n.spawn(c,y,{cwd:h,env:k,detached:!0});C.on("error",E),C.on("exit",()=>S())})}async runInTerminal(n,t,c,h,s){const m="windowsExec"in s&&s.windowsExec?s.windowsExec:w.getDefaultTerminalWindows(),y=await w.f();return new Promise((S,E)=>{const k=`"${t} - ${f}"`,C=`"${c.join('" "')}" & pause`,v=Object.assign({},g(process),h);Object.keys(v).filter(j=>v[j]===null).forEach(j=>delete v[j]);const b={cwd:t,env:v,windowsVerbatimArguments:!0};let O,U;T.$nc(m,".exe")==="wt"?(O=m,U=["-d",".",w.b,"/c",C]):y?(O=y,U=["-d",".",m,"/c",C]):(O=w.b,U=["/c","start",k,"/wait",m,"/c",`"${C}"`]),r.spawn(O,U,b).on("error",j=>{E($(j))}),S(void 0)})}static getDefaultTerminalWindows(){if(!w.d){const n=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");w.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${n?"Sysnative":"System32"}\\cmd.exe`}return w.d}static async f(){try{const n=await l.win32.findExecutable("wt");return await p.Promises.exists(n)?n:void 0}catch{return}}}e.$$dc=w,w.b="cmd.exe",Ze([u.$5h],w,"f",null);class a extends A{openTerminal(n,t){return this.spawnTerminal(r,n,t)}runInTerminal(n,t,c,h,s){const m=s.osxExec||D.$s8b;return new Promise((y,S)=>{if(m===D.$s8b||m==="iTerm.app"){const E=m===D.$s8b?"TerminalHelper":"iTermHelper",C=[P.$Ug.asFileUri(`vs/workbench/contrib/externalTerminal/node/${E}.scpt`).fsPath,"-t",n||f,"-w",t];for(const O of c)C.push("-a"),C.push(O);if(h){const O=Object.assign({},g(process),h);for(const U in O){const z=O[U];z===null?(C.push("-u"),C.push(U)):(C.push("-e"),C.push(`${U}=${z}`))}}let v="";const b=r.spawn(a.b,C);b.on("error",O=>{S($(O))}),b.stderr.on("data",O=>{v+=O.toString()}),b.on("exit",O=>{if(O===0)y(void 0);else if(v){const U=v.split(`
`,1);S(new Error(U[0]))}else S(new Error(I.localize(1,null,E,O)))})}else S(new Error(I.localize(2,null,m)))})}spawnTerminal(n,t,c){const h=t.osxExec||D.$s8b;return new Promise((s,m)=>{const y=["-a",h];c&&y.push(c);const S=g(process),E=n.spawn("/usr/bin/open",y,{cwd:c,env:S});E.on("error",m),E.on("exit",()=>s())})}}e.$_dc=a,a.b="/usr/bin/osascript";class d extends A{openTerminal(n,t){return this.spawnTerminal(r,n,t)}runInTerminal(n,t,c,h,s){const m=s.linuxExec?Promise.resolve(s.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((y,S)=>{const E=[];m.then(k=>{k.indexOf("gnome-terminal")>=0?E.push("-x"):E.push("-e"),E.push("bash"),E.push("-c");const C=`${i(c)}; echo; read -p "${d.b}" -n1;`;E.push(`''${C}''`);const v=Object.assign({},g(process),h);Object.keys(v).filter(z=>v[z]===null).forEach(z=>delete v[z]);const b={cwd:t,env:v};let O="";const U=r.spawn(k,E,b);U.on("error",z=>{S($(z))}),U.stderr.on("data",z=>{O+=z.toString()}),U.on("exit",z=>{if(z===0)y(void 0);else if(O){const j=O.split(`
`,1);S(new Error(j[0]))}else S(new Error(I.localize(4,null,k,z)))})})})}static async getDefaultTerminalLinuxReady(){if(!d.d)if(!L.$e)d.d=Promise.resolve("xterm");else{const n=await p.Promises.exists("/etc/debian_version");d.d=new Promise(t=>{n?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return d.d}spawnTerminal(n,t,c){const h=t.linuxExec?Promise.resolve(t.linuxExec):d.getDefaultTerminalLinuxReady();return new Promise((s,m)=>{h.then(y=>{const S=g(process),E=n.spawn(y,[],{cwd:c,env:S});E.on("error",m),E.on("exit",()=>s())})})}}e.$aec=d,d.b=I.localize(3,null);function g(o){const n={...o.env};return(0,R.$sm)(n),n}function $(o){return"errno"in o&&o.errno==="ENOENT"&&"path"in o&&typeof o.path=="string"?new Error(I.localize(5,null,o.path)):o}function i(o){let n="";for(const t of o)t.indexOf(" ")>=0?n+='"'+t+'"':n+=t,n+=" ";return n}}),define(Ee[28],Se([1,0,85,16,13,18,2,223,5,11,15,49]),function(oe,e,r,u,P,T,L,R,p,l,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=f,e.$9k=d,e.$0k=$,e.$$k=i,e.$_k=o,e.$al=n,e.$bl=t,e.$cl=c,e.$dl=h,e.$el=s,e.$fl=m,e.$hl=E,e.$il=k,e.$jl=C,e.$kl=v,e.$ll=b,e.$ol=M,e.$Al=H,e.$Bl=V,e.$Dl=he,e.$7k=(0,p.$Ai)("fileService");function f(ne){return ne.create===!0}var A;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})(A||(e.FileType=A={}));var w;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(w||(e.FilePermission=w={}));var a;(function(ne){ne[ne.UPDATED=2]="UPDATED",ne[ne.ADDED=4]="ADDED",ne[ne.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function d(ne){const we=ne;return!!we&&typeof we.onDidChange=="function"}var g;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function $(ne){return!!(ne.capabilities&g.FileReadWrite)}function i(ne){return!!(ne.capabilities&g.FileFolderCopy)}function o(ne){return!!(ne.capabilities&g.FileClone)}function n(ne){return!!(ne.capabilities&g.FileOpenReadWriteClose)}function t(ne){return!!(ne.capabilities&g.FileReadStream)}function c(ne){return $(ne)?!!(ne.capabilities&g.FileAtomicRead):!1}function h(ne){return $(ne)?!!(ne.capabilities&g.FileAtomicWrite):!1}function s(ne){return!!(ne.capabilities&g.FileAtomicDelete)}function m(ne){return!!(ne.capabilities&g.Readonly)}var y;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(y||(e.FileSystemProviderErrorCode=y={}));class S extends Error{static create(we,pe){const ce=new S(we.toString(),pe);return C(ce,pe),ce}constructor(we,pe){super(we),this.code=pe}}e.$gl=S;function E(ne,we){return S.create(ne,we)}function k(ne){return ne||E((0,R.localize)(0,null),y.Unknown)}function C(ne,we){return ne.name=we?`${we} (FileSystemError)`:"FileSystemError",ne}function v(ne){if(!ne)return y.Unknown;if(ne instanceof S)return ne.code;const we=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!we)return y.Unknown;switch(we[1]){case y.FileExists:return y.FileExists;case y.FileIsADirectory:return y.FileIsADirectory;case y.FileNotADirectory:return y.FileNotADirectory;case y.FileNotFound:return y.FileNotFound;case y.FileTooLarge:return y.FileTooLarge;case y.FileWriteLocked:return y.FileWriteLocked;case y.NoPermissions:return y.NoPermissions;case y.Unavailable:return y.Unavailable}return y.Unknown}function b(ne){if(ne instanceof N)return ne.fileOperationResult;switch(v(ne)){case y.FileNotFound:return se.FILE_NOT_FOUND;case y.FileIsADirectory:return se.FILE_IS_DIRECTORY;case y.FileNotADirectory:return se.FILE_NOT_DIRECTORY;case y.FileWriteLocked:return se.FILE_WRITE_LOCKED;case y.NoPermissions:return se.FILE_PERMISSION_DENIED;case y.FileExists:return se.FILE_MOVE_CONFLICT;case y.FileTooLarge:return se.FILE_TOO_LARGE;default:return se.FILE_OTHER_ERROR}}var O;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class U{constructor(we,pe,ce){this.resource=we,this.operation=pe,this.target=ce}isOperation(we){return this.operation===we}}e.$ml=U;var z;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class j{constructor(we,pe){this.c=pe,this.b=void 0,this.d=new D.$V(()=>{const ce=r.$Gi.forUris(()=>this.c);return ce.fill(this.rawAdded.map(K=>[K,!0])),ce}),this.f=new D.$V(()=>{const ce=r.$Gi.forUris(()=>this.c);return ce.fill(this.rawUpdated.map(K=>[K,!0])),ce}),this.g=new D.$V(()=>{const ce=r.$Gi.forUris(()=>this.c);return ce.fill(this.rawDeleted.map(K=>[K,!0])),ce}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ce of we){switch(ce.type){case z.ADDED:this.rawAdded.push(ce.resource);break;case z.UPDATED:this.rawUpdated.push(ce.resource);break;case z.DELETED:this.rawDeleted.push(ce.resource);break}this.b!==j.a&&(typeof ce.cId=="number"?this.b===void 0?this.b=ce.cId:this.b!==ce.cId&&(this.b=j.a):this.b!==void 0&&(this.b=j.a))}}contains(we,...pe){return this.h(we,{includeChildren:!1},...pe)}affects(we,...pe){return this.h(we,{includeChildren:!0},...pe)}h(we,pe,...ce){if(!we)return!1;const K=ce.length>0;return!!((!K||ce.includes(z.ADDED))&&(this.d.value.get(we)||pe.includeChildren&&this.d.value.findSuperstr(we))||(!K||ce.includes(z.UPDATED))&&(this.f.value.get(we)||pe.includeChildren&&this.f.value.findSuperstr(we))||(!K||ce.includes(z.DELETED))&&(this.g.value.findSubstr(we)||pe.includeChildren&&this.g.value.findSuperstr(we)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(we){return this.b===we}hasCorrelation(){return typeof this.b=="number"}}e.$nl=j,j.a=null;function M(ne,we,pe){return!ne||!we||ne===we||we.length>ne.length?!1:(we.charAt(we.length-1)!==u.sep&&(we+=u.sep),pe?(0,P.$Cf)(ne,we):ne.indexOf(we)===0)}class N extends Error{constructor(we,pe,ce){super(we),this.fileOperationResult=pe,this.options=ce}}e.$pl=N;class F extends N{constructor(we,pe,ce,K){super(we,pe,K),this.fileOperationResult=pe,this.size=ce}}e.$ql=F;class X extends N{constructor(we,pe,ce){super(we,se.FILE_NOT_MODIFIED_SINCE,ce),this.stat=pe}}e.$rl=X;var se;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(se||(e.FileOperationResult=se={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var W;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(W||(e.FileKind=W={})),e.$zl="";function H(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}async function V(ne,we){if(!we.hasProvider(L.URI.from({scheme:ne.scheme})))return new Promise(pe=>{const ce=we.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===ne.scheme&&K.added&&(ce.dispose(),pe())})})}class x{static formatSize(we){return(0,T.$eg)(we)||(we=0),we<x.KB?(0,R.localize)(1,null,we.toFixed(0)):we<x.MB?(0,R.localize)(2,null,(we/x.KB).toFixed(2)):we<x.GB?(0,R.localize)(3,null,(we/x.MB).toFixed(2)):we<x.TB?(0,R.localize)(4,null,(we/x.GB).toFixed(2)):(0,R.localize)(5,null,(we/x.TB).toFixed(2))}}e.$Cl=x,x.KB=1024,x.MB=x.KB*x.KB,x.GB=x.MB*x.KB,x.TB=x.GB*x.KB;function he(ne){const we=typeof ne=="string"||ne?.scheme===I.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===I.Schemas.file?1024*x.MB:we?10*x.MB:l.$i?50*x.MB:1024*x.MB}}),define(Ee[268],Se([1,0,22,14,224,28]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=L;async function L(I,D,f,A,w,a){let d;try{await R(I,D,f,A,w,a)}catch(g){d=g}finally{d&&w.errorTransformer&&(d=w.errorTransformer(d)),typeof d<"u"&&f.error(d),f.end()}}async function R(I,D,f,A,w,a){p(a);const d=await I.open(D,{create:!1});try{p(a);let g=0,$=0,i=w&&typeof w.length=="number"?w.length:void 0,o=r.$Je.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),n=w&&typeof w.position=="number"?w.position:0,t=0;do $=await I.read(d,n,o.buffer,t,o.byteLength-t),n+=$,t+=$,g+=$,typeof i=="number"&&(i-=$),t===o.byteLength&&(await f.write(A(o)),o=r.$Je.alloc(Math.min(w.bufferSize,typeof i=="number"?i:w.bufferSize)),t=0);while($>0&&(typeof i!="number"||i>0)&&p(a)&&l(g,w));if(t>0){let c=t;typeof i=="number"&&(c=Math.min(t,i)),f.write(A(o.slice(0,c)))}}catch(g){throw(0,T.$il)(g)}finally{await I.close(d)}}function p(I){if(I.isCancellationRequested)throw(0,u.$6)();return!0}function l(I,D){if(typeof D?.limits?.size=="number"&&I>D.limits.size)throw(0,T.$hl)((0,P.localize)(0,null),T.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[69],Se([1,0,39,3,16,11,2,28]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=void 0,e.$Sq=p,e.$Tq=l,e.$Xq=A,e.$Yq=w,e.$Zq=a,e.$1q=d,e.$2q=$,e.$3q=i;function p(o){return typeof o.correlationId=="number"}function l(o){return o.recursive===!0}class I extends u.$Uc{constructor(n,t,c,h){super(),this.m=n,this.n=t,this.r=c,this.s=h,this.f=this.B(new u.$Vc),this.g=void 0,this.h=new Map,this.j=0}u(){const n=new u.$Tc;this.f.value=n,this.c=this.t(n),this.c.setVerboseLogging(this.r),n.add(this.c.onDidChangeFile(t=>this.m(t))),n.add(this.c.onDidLogMessage(t=>this.n(t))),n.add(this.c.onDidError(t=>this.w(t.error,t.request)))}w(n,t){if(this.s.restartOnError&&this.g?.length)if(t){const c=this.h.get(t.path)??0;c<I.a?(this.z(`restarting watcher from error in watch request (retrying request): ${n} (${JSON.stringify(t)})`),this.h.set(t.path,c+1),this.y(this.g)):(this.z(`restarting watcher from error in watch request (skipping request): ${n} (${JSON.stringify(t)})`),this.y(this.g.filter(h=>h.path!==t.path)))}else this.j<I.b?(this.z(`restarting watcher after unknown global error: ${n}`),this.j++,this.y(this.g)):this.z(`giving up attempting to restart watcher after error: ${n}`);else this.z(n)}y(n){this.u(),this.watch(n)}async watch(n){this.g=n,await this.c?.watch(n)}async setVerboseLogging(n){this.r=n,await this.c?.setVerboseLogging(n)}z(n){this.n({type:"error",message:`[File Watcher (${this.s.type})] ${n}`})}C(n){this.n({type:"trace",message:`[File Watcher (${this.s.type})] ${n}`})}dispose(){return this.c=void 0,super.dispose()}}e.$Uq=I,I.a=3,I.b=10;class D extends I{constructor(n,t,c){super(n,t,c,{type:"node.js",restartOnError:!1})}}e.$Vq=D;class f extends I{constructor(n,t,c){super(n,t,c,{type:"universal",restartOnError:!0})}}e.$Wq=f;function A(o){return o.map(n=>({type:n.type,resource:L.URI.revive(n.resource),cId:n.cId}))}function w(o){const n=new g;for(const t of o)n.processEvent(t);return n.coalesce()}function a(o,n){return typeof n=="string"&&!n.startsWith(r.$qk)&&!(0,P.$ic)(n)?{base:o,pattern:n}:n}function d(o,n){const t=[];for(const c of n)t.push((0,r.$uk)(a(o,c)));return t}class g{constructor(){this.a=new Set,this.b=new Map}c(n){return T.$e?n.resource.fsPath:n.resource.fsPath.toLowerCase()}processEvent(n){const t=this.b.get(this.c(n));let c=!1;if(t){const h=t.type,s=n.type;t.resource.fsPath!==n.resource.fsPath&&(n.type===R.FileChangeType.DELETED||n.type===R.FileChangeType.ADDED)?c=!0:h===R.FileChangeType.ADDED&&s===R.FileChangeType.DELETED?(this.b.delete(this.c(n)),this.a.delete(t)):h===R.FileChangeType.DELETED&&s===R.FileChangeType.ADDED?t.type=R.FileChangeType.UPDATED:h===R.FileChangeType.ADDED&&s===R.FileChangeType.UPDATED||(t.type=s)}else c=!0;c&&(this.a.add(n),this.b.set(this.c(n),n))}coalesce(){const n=[],t=[];return Array.from(this.a).filter(c=>c.type!==R.FileChangeType.DELETED?(n.push(c),!1):!0).sort((c,h)=>c.resource.fsPath.length-h.resource.fsPath.length).filter(c=>t.some(h=>(0,R.$ol)(c.resource.fsPath,h,!T.$e))?!1:(t.push(c.resource.fsPath),!0)).concat(n)}}function $(o,n){if(typeof n=="number")switch(o.type){case R.FileChangeType.ADDED:return(n&R.FileChangeFilter.ADDED)===0;case R.FileChangeType.DELETED:return(n&R.FileChangeFilter.DELETED)===0;case R.FileChangeType.UPDATED:return(n&R.FileChangeFilter.UPDATED)===0}return!1}function i(o){if(typeof o=="number"){const n=[];return o&R.FileChangeFilter.ADDED&&n.push("Added"),o&R.FileChangeFilter.DELETED&&n.push("Deleted"),o&R.FileChangeFilter.UPDATED&&n.push("Updated"),n.length===0?"<all>":`[${n.join(", ")}]`}return"<none>"}}),define(Ee[269],Se([1,0,56,3,69,4,28,2,7]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class l extends u.$Uc{constructor(){super(),this.a=this.B(new T.$he),this.onDidChangeFile=this.a.event,this.b=this.B(new T.$he),this.onDidLogMessage=this.b.event,this.c=this.B(new T.$he),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new u.$4c),this.m=new Set,this.n=5007,this.r=new p.$Xh,this.P=!1,this.B(this.f(D=>this.s(D)))}s(D){this.t(D)&&this.w(D)}t(D){return(0,P.$Sq)(D)}async watch(D){this.r.isSettled||this.r.complete(),this.r=new p.$Xh;try{this.h.clear(),this.g.clear();for(const f of D)this.t(f)?this.h.set(f.correlationId,f):this.g.add(f);for(const[f]of this.j)this.h.has(f)||(this.j.deleteAndDispose(f),this.m.delete(f));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(D=>!this.j.has(D.correlationId))])}isSuspended(D){return typeof D.correlationId!="number"?!1:this.m.has(D.correlationId)?"polling":this.j.has(D.correlationId)}async w(D){if(this.j.has(D.correlationId))return;const f=new u.$Tc;this.j.set(D.correlationId,f),await this.r.p,!f.isDisposed&&(this.z(D,f),this.u())}y(D){this.j.deleteAndDispose(D.correlationId),this.m.delete(D.correlationId),this.u()}z(D,f){this.C(D,f)?(this.N(`reusing an existing recursive watcher to monitor ${D.path}`),this.m.delete(D.correlationId)):(this.D(D,f),this.m.add(D.correlationId))}C(D,f){const A=this.M?.subscribe(D.path,(w,a)=>{f.isDisposed||(w?this.z(D,f):a?.type===L.FileChangeType.ADDED&&this.F(D))});return A?(f.add(A),!0):!1}D(D,f){let A=!1;const w=(a,d)=>{if(f.isDisposed)return;const g=this.G(a),$=this.G(d),i=A;A=g,!g&&($||i)&&this.F(D)};this.N(`starting fs.watchFile() on ${D.path} (correlationId: ${D.correlationId})`);try{(0,r.watchFile)(D.path,{persistent:!1,interval:this.n},w)}catch(a){this.O(`fs.watchFile() failed with error ${a} on path ${D.path} (correlationId: ${D.correlationId})`)}f.add((0,u.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${D.path} (correlationId: ${D.correlationId})`);try{(0,r.unwatchFile)(D.path,w)}catch(a){this.O(`fs.unwatchFile() failed with error ${a} on path ${D.path} (correlationId: ${D.correlationId})`)}}))}F(D){this.N(`detected ${D.path} exists again, resuming watcher (correlationId: ${D.correlationId})`);const f={resource:R.URI.file(D.path),type:L.FileChangeType.ADDED,cId:D.correlationId};this.a.fire([f]),this.H(f,D),this.y(D)}G(D){return D.ctimeMs===0&&D.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(D,f){if(this.P){const A=` >> normalized ${D.type===L.FileChangeType.ADDED?"[ADDED]":D.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${D.resource.fsPath}`;this.I(A,f)}}I(D,f){this.P&&this.N(`${D}${typeof f.correlationId=="number"?` <${f.correlationId}> `:""}`)}J(D){return`${D.path} (excludes: ${D.excludes.length>0?D.excludes:"<none>"}, includes: ${D.includes&&D.includes.length>0?JSON.stringify(D.includes):"<all>"}, filter: ${(0,P.$3q)(D.filter)}, correlationId: ${typeof D.correlationId=="number"?D.correlationId:"<none>"})`}async setVerboseLogging(D){this.P=D}}e.$_q=l}),define(Ee[270],Se([1,0,56,7,21,32,3,82,16,11,23,2,108,34,28,69]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0,e.$fr=g;class d extends L.$Uc{get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(i,o,n,t,c,h){super(),this.s=i,this.t=o,this.u=n,this.w=t,this.y=c,this.z=h,this.c=this.B(new u.$Ph({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new u.$Oh(s=>this.M(s),d.b)),this.g=(0,a.$1q)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,a.$1q)(this.s.path,this.s.includes):void 0,this.j=(0,a.$Sq)(this.s)?this.s.filter:void 0,this.m=new P.$se,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const i=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const o=await A.Promises.stat(i);if(this.m.token.isCancellationRequested)return;this.B(await this.G(i,o.isDirectory()))}catch(i){i.code!=="ENOENT"?this.O(i):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${i})`),this.D()}}D(){this.r=!0,this.w?.()}async F(i){let o=i.path;try{o=await A.Promises.realpath(i.path),i.path===o&&(o=await(0,f.$br)(i.path,this.m.token)??i.path),i.path!==o&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${o})`)}catch{}return o}async G(i,o){const n=new L.$Tc;return this.H(i,o,n)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(i,o,n)),n}H(i,o,n){if(o)return!1;const t=D.URI.file(this.s.path),c=this.t?.subscribe(this.s.path,async(h,s)=>{if(!n.isDisposed)if(h){const m=await this.G(i,o);n.isDisposed?m.dispose():n.add(m)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:t,type:s.type,cId:this.s.correlationId},!0)});return c?(n.add(c),!0):!1}async I(i,o,n){if(l.$d&&(0,T.$zg)(i,"/Volumes/",!0)){this.O(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const t=new P.$se(this.m.token);n.add((0,L.$Sc)(()=>t.dispose(!0)));const c=new L.$Tc;n.add(c);try{const h=D.URI.file(this.s.path),s=(0,p.$nc)(i),m=(0,r.watch)(i);c.add((0,L.$Sc)(()=>{m.removeAllListeners(),m.close()})),this.Q(`Started watching: '${i}'`);const y=new Set;if(o)try{for(const E of await A.Promises.readdir(i))y.add(E)}catch(E){this.O(E)}if(t.token.isCancellationRequested)return;const S=new Map;c.add((0,L.$Sc)(()=>{for(const[,E]of S)E.dispose();S.clear()})),m.on("error",(E,k)=>{t.token.isCancellationRequested||(this.O(`Failed to watch ${i} for changes using fs.watch() (${E}, ${k})`),this.D())}),m.on("change",(E,k)=>{if(t.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${E}"] ${k}`);let C="";if(k&&(C=k.toString(),l.$d&&(C=(0,R.$hm)(C))),!(!C||E!=="change"&&E!=="rename"))if(o)if(E==="rename"){S.get(C)?.dispose();const v=setTimeout(async()=>{if(S.delete(C),C===s&&!await A.Promises.exists(i)){this.J(h);return}if(t.token.isCancellationRequested)return;const b=await this.N((0,p.$jc)(i,C));if(t.token.isCancellationRequested)return;let O;b?y.has(C)?O=w.FileChangeType.UPDATED:(O=w.FileChangeType.ADDED,y.add(C)):(y.delete(C),O=w.FileChangeType.DELETED),this.L({resource:(0,I.$bh)(h,C),type:O,cId:this.s.correlationId})},d.a);S.set(C,(0,L.$Sc)(()=>clearTimeout(v)))}else{let v;y.has(C)?v=w.FileChangeType.UPDATED:(v=w.FileChangeType.ADDED,y.add(C)),this.L({resource:(0,I.$bh)(h,C),type:v,cId:this.s.correlationId})}else if(E==="rename"||C!==s){const v=setTimeout(async()=>{const b=await A.Promises.exists(i);t.token.isCancellationRequested||(b?(this.L({resource:h,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0),c.add(await this.G(i,!1))):this.J(h))},d.a);c.clear(),c.add((0,L.$Sc)(()=>clearTimeout(v)))}else this.L({resource:h,type:w.FileChangeType.UPDATED,cId:this.s.correlationId},!0)})}catch(h){t.token.isCancellationRequested||this.O(`Failed to watch ${i} for changes using fs.watch() (${h.toString()})`),this.D()}}J(i){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:i,type:w.FileChangeType.DELETED,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(i,o=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${i.type===w.FileChangeType.ADDED?"[ADDED]":i.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!o&&this.g.some(n=>n(i.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${i.resource.fsPath}`):!o&&this.h&&this.h.length>0&&!this.h.some(n=>n(i.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}M(i){const o=(0,a.$Yq)(i),n=[];for(const c of o){if((0,a.$2q)(c,this.j)){this.z&&this.R(` >> ignored (filtered) ${c.resource.fsPath}`);continue}n.push(c)}if(n.length===0)return;if(this.z)for(const c of n)this.R(` >> normalized ${c.type===w.FileChangeType.ADDED?"[ADDED]":c.type===w.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(i){if(l.$e)return A.Promises.exists(i);try{const o=(0,p.$nc)(i);return(await A.Promises.readdir((0,p.$mc)(i))).some(t=>t===o)}catch(o){return this.Q(o),!1}}setVerboseLogging(i){this.z=i}O(i){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}P(i){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}Q(i){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}R(i){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${i}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$er=d,d.a=100,d.b=75;async function g($,i,o,n,t=512){const c=await A.Promises.open($,"r"),h=Buffer.allocUnsafe(t),s=new P.$se(n);let m,y=!1;const S={path:$,excludes:[],recursive:!1},E=new d(S,void 0,k=>{(async()=>{for(const{type:C}of k)if(C===w.FileChangeType.UPDATED){if(y)return;y=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:v}=await A.Promises.read(c,h,0,t,null);if(!v||s.token.isCancellationRequested)break;i(h.slice(0,v))}}catch(v){m=new Error(v),s.dispose(!0)}finally{y=!1}}})()});return await E.ready,o(),new Promise((k,C)=>{s.token.onCancellationRequested(async()=>{E.dispose();try{await A.Promises.close(c)}catch(v){m=new Error(v)}m?C(m):k()})})}}),define(Ee[271],Se([1,0,4,39,269,11,270,32]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=void 0;class p extends P.$_q{constructor(I){super(),this.M=I,this.onDidError=r.Event.None,this.watchers=new Set}async L(I){I=this.X(I);const D=[],f=new Set(Array.from(this.watchers));for(const A of I){const w=this.S(A);w&&(0,u.$yk)(w.request.excludes,A.excludes)&&(0,u.$yk)(w.request.includes,A.includes)?f.delete(w):D.push(A)}D.length&&this.N(`Request to start watching: ${D.map(A=>this.J(A)).join(",")}`),f.size&&this.N(`Request to stop watching: ${Array.from(f).map(A=>this.J(A.request)).join(",")}`);for(const A of f)this.W(A);for(const A of D)this.U(A)}S(I){for(const D of this.watchers)if(typeof I.correlationId=="number"||typeof D.request.correlationId=="number"){if(D.request.correlationId===I.correlationId)return D}else if((0,R.$yg)(D.request.path,I.path,!T.$e))return D}U(I){const D=new L.$er(I,this.M,A=>this.a.fire(A),()=>this.c.fire(I),A=>this.b.fire(A),this.P),f={request:I,instance:D};this.watchers.add(f)}async stop(){await super.stop();for(const I of this.watchers)this.W(I)}W(I){this.N("stopping file watcher",I),this.watchers.delete(I),I.instance.dispose()}X(I){const D=new Map;for(const f of I){const A=T.$e?f.path:f.path.toLowerCase();let w=D.get(f.correlationId);w||(w=new Map,D.set(f.correlationId,w)),w.has(A)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(f)}`),w.set(A,f)}return Array.from(D.values()).map(f=>Array.from(f.values())).flat()}async setVerboseLogging(I){super.setVerboseLogging(I);for(const D of this.watchers)D.instance.setVerboseLogging(I)}N(I,D){this.P&&this.b.fire({type:"trace",message:this.$(I,D)})}O(I){this.b.fire({type:"warn",message:this.$(I)})}$(I,D){return D?`[File Watcher (node.js)] ${I} (${this.J(D.request)})`:`[File Watcher (node.js)] ${I}`}}e.$gr=p}),define(Ee[272],Se([1,0,69,271]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=void 0;class P extends r.$Vq{constructor(L,R,p){super(L,R,p),this.u()}t(L){return L.add(new u.$gr(void 0))}}e.$hr=P}),define(Ee[273],Se([1,0,15,87,190,69]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class L extends T.$Wq{constructor(p,l,I){super(p,l,I),this.u()}t(p){const l=p.add(new P.$0q(r.$Ug.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return p.add(l.onDidProcessExit(({code:I,signal:D})=>this.w(`terminated by itself with code ${I}, signal: ${D} (ETERM)`))),u.ProxyChannel.toService((0,u.$hi)(l.getChannel("watcher")))}}e.$$q=L}),define(Ee[114],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class r{constructor(...P){this.a=new Map;for(const[T,L]of P)this.set(T,L)}set(P,T){const L=this.a.get(P);return this.a.set(P,T),L}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$yi=r}),define(Ee[274],Se([1,0,7,14,3,112,263,5,114,81]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=void 0;const I=!1;class D extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class f{constructor(d=new p.$yi,g=!1,$,i=I){this.i=d,this.j=g,this.k=$,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(R.$zi,this),this._globalGraph=i?$?._globalGraph??new L.$kr(o=>o):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Pc)(this.h),this.h.clear();for(const d of this.g)(0,P.$Oc)(d)&&d.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(d,g){this.m();const $=this,i=new class extends f{dispose(){$.h.delete(i),super.dispose()}}(d,this.j,this,this.l);return this.h.add(i),g?.add(i),i}invokeFunction(d,...g){this.m();const $=w.traceInvocation(this.l,d);let i=!1;try{return d({get:n=>{if(i)throw(0,u.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(n,$);if(!t)throw new Error(`[invokeFunction] unknown service '${n}'`);return t}},...g)}finally{i=!0,$.stop()}}createInstance(d,...g){this.m();let $,i;return d instanceof T.$xi?($=w.traceCreation(this.l,d.ctor),i=this.o(d.ctor,d.staticArguments.concat(g),$)):($=w.traceCreation(this.l,d),i=this.o(d,g,$)),$.stop(),i}o(d,g=[],$){const i=R._util.getServiceDependencies(d).sort((t,c)=>t.index-c.index),o=[];for(const t of i){const c=this.s(t.id,$);c||this.y(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(c)}const n=i.length>0?i[0].index:g.length;if(g.length!==n){console.trace(`[createInstance] First service dependency of ${d.name} at position ${n+1} conflicts with ${g.length} static arguments`);const t=n-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,n)}return Reflect.construct(d,g.concat(o))}q(d,g){if(this.i.get(d)instanceof T.$xi)this.i.set(d,g);else if(this.k)this.k.q(d,g);else throw new Error("illegalState - setting UNKNOWN service instance")}r(d){const g=this.i.get(d);return!g&&this.k?this.k.r(d):g}s(d,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const $=this.r(d);return $ instanceof T.$xi?this.u(d,$,g.branch(d,!0)):(g.branch(d,!1),$)}u(d,g,$){if(this.t.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.t.add(d);try{return this.v(d,g,$)}finally{this.t.delete(d)}}v(d,g,$){const i=new L.$kr(t=>t.id.toString());let o=0;const n=[{id:d,desc:g,_trace:$}];for(;n.length;){const t=n.pop();if(i.lookupOrInsertNode(t),o++>1e3)throw new D(i);for(const c of R._util.getServiceDependencies(t.desc.ctor)){const h=this.r(c.id);if(h||this.y(`[createInstance] ${d} depends on ${c.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(c.id)),h instanceof T.$xi){const s={id:c.id,desc:h,_trace:t._trace.branch(c.id,!0)};i.insertEdge(t,s),n.push(s)}}}for(;;){const t=i.roots();if(t.length===0){if(!i.isEmpty())throw new D(i);break}for(const{data:c}of t){if(this.r(c.id)instanceof T.$xi){const s=this.w(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this.q(c.id,s)}i.removeNode(c)}}return this.r(d)}w(d,g,$=[],i,o){if(this.i.get(d)instanceof T.$xi)return this.x(d,g,$,i,o,this.g);if(this.k)return this.k.w(d,g,$,i,o);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}x(d,g,$=[],i,o,n){if(i){const t=new f(void 0,this.j,this,this.l);t.c=String(d);const c=new Map,h=new r.$Th(()=>{const s=t.o(g,$,o);for(const[m,y]of c){const S=s[m];if(typeof S=="function")for(const E of y)E.disposable=S.apply(s,E.listener)}return c.clear(),n.add(s),s});return new Proxy(Object.create(null),{get(s,m){if(!h.isInitialized&&typeof m=="string"&&(m.startsWith("onDid")||m.startsWith("onWill"))){let E=c.get(m);return E||(E=new l.$5c,c.set(m,E)),(C,v,b)=>{if(h.isInitialized)return h.value[m](C,v,b);{const O={listener:[C,v,b],disposable:void 0},U=E.push(O);return(0,P.$Sc)(()=>{U(),O.disposable?.dispose()})}}}if(m in s)return s[m];const y=h.value;let S=y[m];return typeof S!="function"||(S=S.bind(y),s[m]=S),S},set(s,m,y){return h.value[m]=y,!0},getPrototypeOf(s){return g.prototype}})}else{const t=this.o(g,$,o);return n.add(t),t}}y(d,g){if(g&&console.warn(d),this.j)throw new Error(d)}}e.$lr=f;var A;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(A||(A={}));class w{static traceInvocation(d,g){return d?new w(A.Invocation,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):w.c}static traceCreation(d,g){return d?new w(A.Creation,g.name):w.c}constructor(d,g){this.type=d,this.name=g,this.g=Date.now(),this.h=[]}branch(d,g){const $=new w(A.Branch,d.toString());return this.h.push([d,g,$]),$}stop(){const d=Date.now()-this.g;w.f+=d;let g=!1;function $(o,n){const t=[],c=new Array(o+1).join("	");for(const[h,s,m]of n.h)if(s&&m){g=!0,t.push(`${c}CREATES -> ${h}`);const y=$(o+1,m);y&&t.push(y)}else t.push(`${c}uses -> ${h}`);return t.join(`
`)}const i=[`${this.type===A.Creation?"CREATE":"CALL"} ${this.name}`,`${$(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${w.f.toFixed(2)}ms)`];(d>2||g)&&w.all.add(i.join(`
`))}}e.$mr=w,w.all=new Set,w.c=new class extends w{constructor(){super(A.None,null)}stop(){}branch(){return this}},w.f=0}),define(Ee[12],Se([1,0,226,51,4,61,3,29,11,23,18,2,35,5]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=a,e.log=g,e.$ik=S,e.$jk=E,e.$kk=k,e.$lk=C,e.$7j=(0,A.$Ai)("logService"),e.$8j=(0,A.$Ai)("loggerService");function w(){return new Date().toISOString()}function a(v){return(0,I.$eg)(v)}var d;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$0j=d.Info;function g(v,b,O){switch(b){case d.Trace:v.trace(O);break;case d.Debug:v.debug(O);break;case d.Info:v.info(O);break;case d.Warning:v.warn(O);break;case d.Error:v.error(O);break;case d.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function $(v,b=!1){let O="";for(let U=0;U<v.length;U++){let z=v[U];if(z instanceof Error&&(z=(0,u.$lj)(z,b)),typeof z=="object")try{z=JSON.stringify(z)}catch{}O+=(U>0?" ":"")+z}return O}class i extends L.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new P.$he),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==d.Off&&this.b<=b}}e.$_j=i;class o extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...O){this.f(d.Trace)&&this.g(d.Trace,$([b,...O],!0))}debug(b,...O){this.f(d.Debug)&&this.g(d.Debug,$([b,...O]))}info(b,...O){this.f(d.Info)&&this.g(d.Info,$([b,...O]))}warn(b,...O){this.f(d.Warning)&&this.g(d.Warning,$([b,...O]))}error(b,...O){if(this.f(d.Error))if(b instanceof Error){const U=Array.prototype.slice.call(arguments);U[0]=b.stack,this.g(d.Error,$(U))}else this.g(d.Error,$([b,...O]))}flush(){}}e.$ak=o;class n extends i{constructor(b=e.$0j){super(),this.setLevel(b),this.g=!p.$c}trace(b,...O){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,b,...O):console.log(`[main ${w()}]`,b,...O))}debug(b,...O){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,b,...O):console.log(`[main ${w()}]`,b,...O))}info(b,...O){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${w()}]\x1B[0m`,b,...O):console.log(`[main ${w()}]`,b,...O))}warn(b,...O){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${w()}]\x1B[0m`,b,...O):console.warn(`[main ${w()}]`,b,...O))}error(b,...O){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${w()}]\x1B[0m`,b,...O):console.error(`[main ${w()}]`,b,...O))}flush(){}}e.$bk=n;class t extends i{constructor(b=e.$0j,O=!0){super(),this.g=O,this.setLevel(b)}trace(b,...O){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...O):console.log(b,...O))}debug(b,...O){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...O):console.log(b,...O))}info(b,...O){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...O):console.log(b,...O))}warn(b,...O){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...O):console.log(b,...O))}error(b,...O){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...O):console.error(b,...O))}flush(){}}e.$ck=t;class c extends i{constructor(b,O=e.$0j){super(),this.g=b,this.setLevel(O)}trace(b,...O){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(b),...O])}debug(b,...O){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(b),...O])}info(b,...O){this.f(d.Info)&&this.g.log(d.Info,[this.h(b),...O])}warn(b,...O){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(b),...O])}error(b,...O){this.f(d.Error)&&this.g.log(d.Error,[this.h(b),...O])}h(b){return typeof b=="string"?b:(0,u.$lj)(b,this.f(d.Trace))}flush(){}}e.$dk=c;class h extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const O of this.g)O.setLevel(b);super.setLevel(b)}trace(b,...O){for(const U of this.g)U.trace(b,...O)}debug(b,...O){for(const U of this.g)U.debug(b,...O)}info(b,...O){for(const U of this.g)U.info(b,...O)}warn(b,...O){for(const U of this.g)U.warn(b,...O)}error(b,...O){for(const U of this.g)U.error(b,...O)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$ek=h;class s extends L.$Uc{constructor(b,O,U){if(super(),this.h=b,this.j=O,this.b=new R.$Ac,this.c=this.B(new P.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$he),this.onDidChangeVisibility=this.g.event,U)for(const z of U)this.b.set(z.resource,{logger:void 0,info:z})}m(b){return(0,I.$ag)(b)?[...this.b.values()].find(O=>O.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,O){const U=this.n(b),z=(0,I.$ag)(b)?b:O?.id??(0,T.$oj)(U.toString()).toString(16);let j=this.b.get(U)?.logger;const M=O?.logLevel==="always"?d.Trace:O?.logLevel;j||(j=this.s(U,M??this.getLogLevel(U)??this.h,{...O,id:z}));const N={logger:j,info:{resource:U,id:z,logLevel:M,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(N.info),this.b.set(U,N),j}n(b){return(0,I.$ag)(b)?(0,l.$bh)(this.j,`${b}.log`):b}setLogLevel(b,O){if(D.URI.isUri(b)){const U=b,z=O,j=this.b.get(U);j&&z!==j.info.logLevel&&(j.info.logLevel=z===this.h?void 0:z,j.logger?.setLevel(z),this.b.set(j.info.resource,j),this.f.fire([U,z]))}else{this.h=b;for(const[U,z]of this.b.entries())this.b.get(U)?.info.logLevel===void 0&&z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,O){const U=this.m(b);U&&O!==!U.info.hidden&&(U.info.hidden=!O,this.b.set(U.info.resource,U),this.g.fire([U.info.resource,O]))}getLogLevel(b){let O;return b&&(O=this.b.get(b)?.info.logLevel),O??this.h}registerLogger(b){const O=this.b.get(b.resource);O?O.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const O=this.b.get(b);O&&(O.logger&&O.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=s;class m{constructor(){this.onDidChangeLogLevel=new P.$he().event}setLevel(b){}getLevel(){return d.Info}trace(b,...O){}debug(b,...O){}info(b,...O){}warn(b,...O){}error(b,...O){}critical(b,...O){}dispose(){}flush(){}}e.$gk=m;class y extends m{}e.$hk=y;function S(v){if(v.verbose)return d.Trace;if(typeof v.logLevel=="string"){const b=C(v.logLevel.toLowerCase());if(b!==void 0)return b}return e.$0j}function E(v){switch(v){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function k(v){switch(v){case d.Trace:return{original:"Trace",value:r.localize(0,null)};case d.Debug:return{original:"Debug",value:r.localize(1,null)};case d.Info:return{original:"Info",value:r.localize(2,null)};case d.Warning:return{original:"Warning",value:r.localize(3,null)};case d.Error:return{original:"Error",value:r.localize(4,null)};case d.Off:return{original:"Off",value:r.localize(5,null)}}}function C(v){switch(v){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$mk=new f.$Rj("logLevel",E(d.Info))}),define(Ee[275],Se([1,0,19,7,14,4,32,3,16,69,12]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;class D extends R.$Uc{constructor(A,w){super(),this.a=A,this.b=w,this.c=this.B(new T.$he),this.onDidChangeFile=this.c.event,this.g=this.B(new T.$he),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new u.$yh(0)),this.w=[],this.y=this.B(new u.$yh(0))}watch(A,w){return w.recursive||this.b?.watcher?.forceUniversal?this.n(A,w):this.z(A,w)}n(A,w){const a={path:this.J(A),excludes:w.excludes,includes:w.includes,recursive:w.recursive,filter:w.filter,correlationId:w.correlationId},d=(0,r.$Tb)(this.j,a);return this.r(),(0,R.$Sc)(()=>{d(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(A=>(0,P.$1)(A))}s(){this.h||(this.h=this.B(this.t(w=>this.c.fire((0,l.$Xq)(w)),w=>this.G(w),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)})));const A=this.b?.watcher?.recursive?.usePolling;if(A===!0)for(const w of this.j)(0,l.$Tq)(w)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(A))for(const w of this.j)(0,l.$Tq)(w)&&A.includes(w.path)&&(w.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(A,w){const a={path:this.J(A),excludes:w.excludes,includes:w.includes,recursive:!1,filter:w.filter,correlationId:w.correlationId},d=(0,r.$Tb)(this.w,a);return this.C(),(0,R.$Sc)(()=>{d(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(A=>(0,P.$1)(A))}D(){return this.u||(this.u=this.B(this.F(A=>this.c.fire((0,l.$Xq)(A)),A=>this.G(A),this.a.getLevel()===I.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===I.LogLevel.Trace)}))),this.u.watch(this.w)}G(A){A.type==="error"&&this.g.fire(A.message),this.H(A)}H(A){this.a[A.type](A.message)}I(A){return(0,p.$hc)(A.fsPath)}J(A){const w=this.I(A);return(0,L.$Cg)(w)}}e.$4q=D}),define(Ee[276],Se([1,0,56,411,7,29,22,4,32,3,16,11,23,105,34,225,28,268,275,51,273,272]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0,(()=>{try{(0,u.gracefulify)(r)}catch(c){console.error(`Error enabling graceful-fs: ${(0,i.$lj)(c)}`)}})();class t extends $.$4q{constructor(h,s){super(h,s),this.onDidChangeCapabilities=R.Event.None,this.P=new T.$Ac(m=>f.$5g.getComparisonKey(m)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=d.FileSystemProviderCapabilities.FileReadWrite|d.FileSystemProviderCapabilities.FileOpenReadWriteClose|d.FileSystemProviderCapabilities.FileReadStream|d.FileSystemProviderCapabilities.FileFolderCopy|d.FileSystemProviderCapabilities.FileWriteUnlock|d.FileSystemProviderCapabilities.FileAtomicRead|d.FileSystemProviderCapabilities.FileAtomicWrite|d.FileSystemProviderCapabilities.FileAtomicDelete|d.FileSystemProviderCapabilities.FileClone,D.$e&&(this.M|=d.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(h){try{const{stat:s,symbolicLink:m}=await w.SymlinkSupport.stat(this.I(h));return{type:this.O(s,m),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:d.FilePermission.Locked}}catch(s){throw this.hb(s)}}async N(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const s=await w.Promises.readdir(this.I(h),{withFileTypes:!0}),m=[];return await Promise.all(s.map(async y=>{try{let S;y.isSymbolicLink()?S=(await this.stat((0,f.$bh)(h,y.name))).type:S=this.O(y),m.push([y.name,S])}catch(S){this.a.trace(S)}})),m}catch(s){throw this.hb(s)}}O(h,s){let m;return s?.dangling?m=d.FileType.Unknown:h.isFile()?m=d.FileType.File:h.isDirectory()?m=d.FileType.Directory:m=d.FileType.Unknown,s&&(m|=d.FileType.SymbolicLink),m}async Q(h){const s=this.I(h);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let m;for(;m=this.P.get(h);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await m.wait();const y=new P.$zh;return this.P.set(h,y),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,l.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.P.get(h)===y&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.P.delete(h)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),y.open()})}async readFile(h,s){let m;try{s?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(h)})`),m=await this.Q(h));const y=this.I(h);return await w.Promises.readFile(y)}catch(y){throw this.hb(y)}finally{m?.dispose()}}R(h){t.L&&this.a.trace(h)}readFileStream(h,s,m){const y=(0,A.$xe)(S=>L.$Je.concat(S.map(E=>L.$Je.wrap(E))).buffer);return(0,g.$Qq)(this,h,y,S=>S.buffer,{...s,bufferSize:256*1024},m),y}async writeFile(h,s,m){return m?.atomic!==!1&&m?.atomic?.postfix&&await this.S(h)?this.U(h,(0,f.$bh)((0,f.$ah)(h),`${(0,f.$$g)(h)}${m.atomic.postfix}`),s,m):this.W(h,s,m)}async S(h){try{const s=this.I(h),{symbolicLink:m}=await w.SymlinkSupport.stat(s);if(m)return!1}catch{}return!0}async U(h,s,m,y){const S=new l.$Tc;try{S.add(await this.Q(h)),S.add(await this.Q(s)),await this.W(s,m,y,!0);try{await this.rename(s,h,{overwrite:!0})}catch(E){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{S.dispose()}}async W(h,s,m,y){let S;try{const E=this.I(h);if(!m.create||!m.overwrite){if(await w.Promises.exists(E)){if(!m.overwrite)throw(0,d.$hl)((0,a.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!m.create)throw(0,d.$hl)((0,a.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(h,{create:!0,unlock:m.unlock},y),await this.write(S,0,s,0,s.byteLength)}catch(E){throw await this.ib(h,E)}finally{typeof S=="number"&&await this.close(S)}}static configureFlushOnWrite(h){t.$=h}async open(h,s,m){const y=this.I(h);let S;(0,d.$8k)(s)&&!m&&(S=await this.Q(h));let E;try{if((0,d.$8k)(s)&&s.unlock)try{const{stat:C}=await w.SymlinkSupport.stat(y);C.mode&128||await w.Promises.chmod(y,C.mode|128)}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}let k;if((0,d.$8k)(s)){if(D.$c)try{await w.Promises.truncate(y,0),k="r+"}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}k||(k="w")}else k="r";E=await w.Promises.open(y,k)}catch(k){throw S?.dispose(),(0,d.$8k)(s)?await this.ib(h,k):this.hb(k)}if(this.X.set(E,0),(0,d.$8k)(s)&&this.Z.set(E,h),S){const k=this.Y.get(E);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${y})`),this.Y.set(E,S),k&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${y})`),k.dispose())}return E}async close(h){const s=this.Y.get(h);try{if(this.X.delete(h),this.Z.delete(h)&&t.$)try{await w.Promises.fdatasync(h)}catch(m){t.configureFlushOnWrite(!1),this.a.error(m)}return await w.Promises.close(h)}catch(m){throw this.hb(m)}finally{s&&(this.Y.get(h)===s&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.Y.delete(h)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),s.dispose())}}async read(h,s,m,y,S){const E=this.ab(h,s);let k=null;try{k=(await w.Promises.read(h,m,y,S,E)).bytesRead}catch(C){throw this.hb(C)}finally{this.bb(h,E,k)}return k}ab(h,s){return s===this.X.get(h)?null:s}bb(h,s,m){const y=this.X.get(h);typeof y=="number"&&(typeof s=="number"||(typeof m=="number"?this.X.set(h,y+m):this.X.delete(h)))}async write(h,s,m,y,S){return(0,P.$Uh)(()=>this.cb(h,s,m,y,S),100,3)}async cb(h,s,m,y,S){const E=this.ab(h,s);let k=null;try{k=(await w.Promises.write(h,m,y,S,E)).bytesWritten}catch(C){throw await this.ib(this.Z.get(h),C)}finally{this.bb(h,E,k)}return k}async mkdir(h){try{await w.Promises.mkdir(this.I(h))}catch(s){throw this.hb(s)}}async delete(h,s){try{const m=this.I(h);if(s.recursive){let y;s?.atomic!==!1&&s.atomic.postfix&&(y=(0,I.$jc)((0,I.$mc)(m),`${(0,I.$nc)(m)}${s.atomic.postfix}`)),await w.Promises.rm(m,w.RimRafMode.MOVE,y)}else try{await w.Promises.unlink(m)}catch(y){if(y.code==="EPERM"||y.code==="EISDIR"){let S=!1;try{const{stat:E,symbolicLink:k}=await w.SymlinkSupport.stat(m);S=E.isDirectory()&&!k}catch{}if(S)await w.Promises.rmdir(m);else throw y}else throw y}}catch(m){throw this.hb(m)}}async rename(h,s,m){const y=this.I(h),S=this.I(s);if(y!==S)try{await this.db(h,s,"move",m.overwrite),await w.Promises.rename(y,S)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,a.localize)(2,null,(0,I.$nc)(y),(0,I.$nc)((0,I.$mc)(S)),E.toString()))),this.hb(E)}}async copy(h,s,m){const y=this.I(h),S=this.I(s);if(y!==S)try{await this.db(h,s,"copy",m.overwrite),await w.Promises.copy(y,S,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,a.localize)(3,null,(0,I.$nc)(y),(0,I.$nc)((0,I.$mc)(S)),E.toString()))),this.hb(E)}}async db(h,s,m,y){const S=this.I(h),E=this.I(s);let k=!1;if(!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive)||(k=(0,p.$yg)(S,E,!0)),k){if(m==="copy")throw(0,d.$hl)((0,a.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(m==="move")return}const v=await this.N(h);if(!v)throw(0,d.$hl)((0,a.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const b=await this.N(s);if(b){if(!y)throw(0,d.$hl)((0,a.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);v.type&d.FileType.File&&b.type&d.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,s){return this.eb(h,s,!1)}async eb(h,s,m){const y=this.I(h),S=this.I(s),E=!!(this.capabilities&d.FileSystemProviderCapabilities.PathCaseSensitive);if((0,p.$yg)(y,S,!E))return;const k=new l.$Tc;try{k.add(await this.Q(h)),k.add(await this.Q(s)),m&&await w.Promises.mkdir((0,I.$mc)(S),{recursive:!0}),await w.Promises.copyFile(y,S)}catch(C){if(C.code==="ENOENT"&&!m)return this.eb(h,s,!0);throw this.hb(C)}finally{k.dispose()}}t(h,s,m){return new o.$$q(y=>h(y),y=>s(y),m)}F(h,s,m){return new n.$hr(y=>h(y),y=>s(y),m)}hb(h){if(h instanceof d.$gl)return h;let s=h,m;switch(h.code){case"ENOENT":m=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":m=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":m=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":m=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":m=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,m=d.FileSystemProviderErrorCode.Unknown;break;default:m=d.FileSystemProviderErrorCode.Unknown}return(0,d.$hl)(s,m)}async ib(h,s){let m=this.hb(s);if(h&&m.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:y}=await w.SymlinkSupport.stat(this.I(h));y.mode&128||(m=(0,d.$hl)(s,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(y){this.a.trace(y)}return m}}e.$ir=t,t.L=!1,t.$=!0}),define(Ee[277],Se([1,0,3,12]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=void 0;class P extends r.$Uc{constructor(L,R=[]){super(),this.a=new u.$ek([L,...R]),this.B(L.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...R){this.a.trace(L,...R)}debug(L,...R){this.a.debug(L,...R)}info(L,...R){this.a.info(L,...R)}warn(L,...R){this.a.warn(L,...R)}error(L,...R){this.a.error(L,...R)}flush(){this.a.flush()}}e.$oQ=P}),define(Ee[278],Se([1,0,28,12]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=void 0;var P;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(P||(P={}));async function T(l,I,D,f,A){try{const w=await new Promise((d,g)=>{oe(["@vscode/spdlog"],d,g)});w.setFlushOn(P.Trace);const a=await w.createAsyncRotatingLogger(l,I,D,f);return A?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(w){console.error(w)}return null}function L(l,I,D){switch(I){case u.LogLevel.Trace:l.trace(D);break;case u.LogLevel.Debug:l.debug(D);break;case u.LogLevel.Info:l.info(D);break;case u.LogLevel.Warning:l.warn(D);break;case u.LogLevel.Error:l.error(D);break;case u.LogLevel.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function R(l,I){switch(I){case u.LogLevel.Trace:l.setLevel(P.Trace);break;case u.LogLevel.Debug:l.setLevel(P.Debug);break;case u.LogLevel.Info:l.setLevel(P.Info);break;case u.LogLevel.Warning:l.setLevel(P.Warning);break;case u.LogLevel.Error:l.setLevel(P.Error);break;case u.LogLevel.Off:l.setLevel(P.Off);break;default:throw new Error(`Invalid log level ${I}`)}}class p extends u.$ak{constructor(I,D,f,A,w){super(),this.m=[],this.setLevel(w),this.n=this.s(I,D,f,A),this.B(this.onDidChangeLogLevel(a=>{this.r&&R(this.r,a)}))}async s(I,D,f,A){const w=f?6:1,a=30/w*r.$Cl.MB,d=await T(I,D,a,w,A);if(d){this.r=d,R(this.r,this.getLevel());for(const{level:g,message:$}of this.m)L(this.r,g,$);this.m=[]}}g(I,D){this.r?L(this.r,I,D):this.getLevel()<=I&&this.m.push({level:I,message:D})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$dQ=p}),define(Ee[145],Se([1,0,44,227,5]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var L;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(p){function l(w,a){return a-w}p.compare=l;const I=Object.create(null);I[p.Error]=(0,u.localize)(0,null),I[p.Warning]=(0,u.localize)(1,null),I[p.Info]=(0,u.localize)(2,null);function D(w){return I[w]||""}p.toString=D;function f(w){switch(w){case r.default.Error:return p.Error;case r.default.Warning:return p.Warning;case r.default.Info:return p.Info;case r.default.Ignore:return p.Hint}}p.fromSeverity=f;function A(w){switch(w){case p.Error:return r.default.Error;case p.Warning:return r.default.Warning;case p.Info:return r.default.Info;case p.Hint:return r.default.Ignore}}p.toSeverity=A}(L||(e.MarkerSeverity=L={}));var R;(function(p){const l="";function I(f){return D(f,!0)}p.makeKey=I;function D(f,A){const w=[l];return f.source?w.push(f.source.replace("\xA6","\\\xA6")):w.push(l),f.code?typeof f.code=="string"?w.push(f.code.replace("\xA6","\\\xA6")):w.push(f.code.value.replace("\xA6","\\\xA6")):w.push(l),f.severity!==void 0&&f.severity!==null?w.push(L.toString(f.severity)):w.push(l),f.message&&A?w.push(f.message.replace("\xA6","\\\xA6")):w.push(l),f.startLineNumber!==void 0&&f.startLineNumber!==null?w.push(f.startLineNumber.toString()):w.push(l),f.startColumn!==void 0&&f.startColumn!==null?w.push(f.startColumn.toString()):w.push(l),f.endLineNumber!==void 0&&f.endLineNumber!==null?w.push(f.endLineNumber.toString()):w.push(l),f.endColumn!==void 0&&f.endColumn!==null?w.push(f.endColumn.toString()):w.push(l),w.push(l),w.join("\xA6")}p.makeKeyOptionalMessage=D})(R||(e.IMarkerData=R={})),e.$Hv=(0,P.$Ai)("markerService")}),define(Ee[279],Se([1,0,4,44,5]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kw=e.$jw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$hw=e.Severity=void 0,e.$iw=R,e.Severity=u.default,e.$hw=(0,P.$Ai)("notificationService");var T;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var L;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function R(D){if(D){const f=D;return typeof f.id=="string"&&typeof f.label=="string"}return!1}var p;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class l{constructor(){this.progress=new I,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(f){}updateMessage(f){}updateActions(f){}close(){}}e.$jw=l;class I{infinite(){}done(){}total(f){}worked(f){}}e.$kw=I}),define(Ee[280],Se([1,0,54]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let u;const P=globalThis.vscode;if(typeof P<"u"&&typeof P.context<"u"){const T=P.context.configuration();if(T)u=T.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(u=globalThis._VSCODE_PRODUCT_JSON,r.env.VSCODE_DEV&&Object.assign(u,{nameShort:`${u.nameShort} Dev`,nameLong:`${u.nameLong} Dev`,dataFolderName:`${u.dataFolderName}-dev`,serverDataFolderName:u.serverDataFolderName?`${u.serverDataFolderName}-dev`:void 0}),!u.version){const T=globalThis._VSCODE_PACKAGE_JSON;Object.assign(u,{version:T.version})}Object.assign(u,{extensionsGallery:r.env.EXTENSIONS_GALLERY?JSON.parse(r.env.EXTENSIONS_GALLERY):u.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""},telemetryEndpoint:r.env.CS_TELEMETRY_URL||u.telemetryEndpoint||"https://v1.telemetry.coder.com/track"})}else u={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",win32TunnelServiceMutex:"vscodeoss-tunnelservice",win32TunnelMutex:"vscodeoss-tunnel",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",nodejsRepository:"https://nodejs.org",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.90.0",sha256:"1317dd7d1ac50641c1534a3e957ecbc94349f4fbd897acb916da11eea3208a66",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],trustedExtensionAuthAccess:["vscode.git","vscode.github","github.vscode-pull-request-github","github.copilot","github.copilot-chat"],aiConfig:{ariaKey:"code-server"},version:"1.90.2",commit:"c26ac35b25b09e9d58e6716f2aae41d8d1dfbb6c",date:"2024-06-20T22:15:21.422Z"},Object.keys(u).length===0&&Object.assign(u,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=u}),define(Ee[115],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,r.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"});var Ve=this&&this.__param||function(oe,e){return function(r,u){e(r,u,oe)}};define(Ee[90],Se([1,0,7,21,3,5]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rw=e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.ProgressLocation=e.$lw=void 0,e.$lw=(0,T.$Ai)("progressService");var L;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$mw=Object.freeze({total(){},worked(){},done(){}});class R{get value(){return this.a}constructor(f){this.b=f}report(f){this.a=f,this.b(this.a)}}e.$nw=R,R.None=Object.freeze({report(){}});class p{get value(){return this.a}constructor(f){this.e=f}report(f){this.b?this.b.push(f):this.b=[f],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const f=this.b.shift();this.a=f,await this.e(this.a)}}finally{this.c=!1;const f=this.d;this.d=void 0,f?.()}}drain(){return this.c?new Promise(f=>{const A=this.d;this.d=()=>{A?.(),f()}}):Promise.resolve()}}e.$ow=p;let l=class extends P.$Uc{constructor(f,A){super(),this.a=new r.$Xh,A.withProgress(f,w=>(this.b=w,this.c&&w.report(this.c),this.a.p)),this.B((0,P.$Sc)(()=>this.a.complete()))}report(f){this.b?this.b.report(f):this.c=f}};e.$pw=l,e.$pw=l=Ze([Ve(1,e.$lw)],l);class I extends P.$Uc{constructor(f){super(),this.g=f,this.a=0,this.b=this.B(new P.$Tc)}start(f){this.stop();const A=++this.a,w=new u.$se;return this.f=setTimeout(()=>{A===this.a&&(this.c=this.g.show(!0))},f),this.b.add((0,P.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Sc)(()=>w.cancel())),this.b.add((0,P.$Sc)(()=>this.c?this.c.done():void 0)),{id:A,token:w.token,stop:()=>this.h(A),isCurrent:()=>this.a===A}}stop(){this.h(this.a)}h(f){this.a===f&&this.b.clear()}}e.$qw=I,e.$rw=(0,T.$Ai)("editorProgressService")}),define(Ee[36],Se([1,0,65,18]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=void 0;class P{constructor(){this.a=new Map}add(L,R){r.ok(u.$ag(L)),r.ok(u.$cg(R)),r.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,R)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$ko=new P}),define(Ee[116],Se([1,0,4,36]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=void 0,e.$lo={JSONContribution:"base.contributions.json"};function P(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class T{constructor(){this.b=new r.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(p,l){this.a[P(p)]=l,this.b.fire(p)}notifySchemaChanged(p){this.b.fire(p)}getSchemaContributions(){return{schemas:this.a}}}const L=new T;u.$ko.add(e.$lo.JSONContribution,L)}),define(Ee[70],Se([1,0,19,4,18,216,45,116,36]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.ConfigurationScope=e.$po=e.EditPresentationTypes=void 0,e.$Ao=a,e.$Bo=d,e.$Co=g,e.$Do=i,e.$Eo=o;var l;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$po={Configuration:"base.contributions.configuration"};var I;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo="vscode://schemas/settings/resourceLanguage",e.$xo="vscode://schemas/settings/configurationDefaults";const D=p.$ko.as(R.$lo.JSONContribution);class f{constructor(){this.h=new Set,this.i=new u.$he,this.onDidSchemaChange=this.i.event,this.j=new u.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$wo,this.g),this.v()}registerConfiguration(t,c=!0){this.registerConfigurations([t],c)}registerConfigurations(t,c=!0){const h=new Set;this.n(t,c,h),D.registerSchema(e.$wo,this.g),this.i.fire(),this.j.fire({properties:h})}deregisterConfigurations(t){const c=new Set;this.o(t,c),D.registerSchema(e.$wo,this.g),this.i.fire(),this.j.fire({properties:c})}updateConfigurations({add:t,remove:c}){const h=new Set;this.o(c,h),this.n(t,!1,h),D.registerSchema(e.$wo,this.g),this.i.fire(),this.j.fire({properties:h})}registerDefaultConfigurations(t){const c=new Set;this.k(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}k(t,c){const h=[];for(const{overrides:s,source:m}of t)for(const y in s)if(c.add(y),e.$zo.test(y)){const S=this.a.get(y),E=S?.valuesSources??new Map;if(m)for(const b of Object.keys(s[y]))E.set(b,m);const k={...S?.value||{},...s[y]};this.a.set(y,{source:m,value:k,valuesSources:E});const C=(0,L.$ej)(y),v={type:"object",default:k,description:T.localize(1,null,C),$ref:e.$wo,defaultDefaultValue:k,source:P.$ag(m)?void 0:m,defaultValueSource:m};h.push(...a(y)),this.d[y]=v,this.b.properties[y]=v}else{this.a.set(y,{value:s[y],source:m});const S=this.d[y];S&&(this.w(y,S),this.r(y,S))}this.m(h)}deregisterDefaultConfigurations(t){const c=new Set;this.l(t,c),this.i.fire(),this.j.fire({properties:c,defaultsOverrides:!0})}l(t,c){for(const{overrides:h,source:s}of t)for(const m in h){const y=this.a.get(m),S=P.$ag(s)?s:s?.id,E=P.$ag(y?.source)?y?.source:y?.source?.id;if(S===E)if(c.add(m),this.a.delete(m),e.$zo.test(m))delete this.d[m],delete this.b.properties[m];else{const k=this.d[m];k&&(this.w(m,k),this.r(m,k))}}this.u()}deltaConfiguration(t){let c=!1;const h=new Set;t.removedDefaults&&(this.l(t.removedDefaults,h),c=!0),t.addedDefaults&&(this.k(t.addedDefaults,h),c=!0),t.removedConfigurations&&this.o(t.removedConfigurations,h),t.addedConfigurations&&this.n(t.addedConfigurations,!1,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:c})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const c of t)this.h.add(c);this.u()}n(t,c,h){t.forEach(s=>{this.p(s,c,s.extensionInfo,s.restrictedProperties,void 0,h),this.c.push(s),this.q(s)})}o(t,c){const h=s=>{if(s.properties)for(const m in s.properties){c.add(m);const y=this.d[m];y?.policy?.name&&this.e.delete(y.policy.name),delete this.d[m],this.s(m,s.properties[m])}s.allOf?.forEach(m=>h(m))};for(const s of t){h(s);const m=this.c.indexOf(s);m!==-1&&this.c.splice(m,1)}}p(t,c=!0,h,s,m=I.WINDOW,y){m=P.$jg(t.scope)?m:t.scope;const S=t.properties;if(S)for(const k in S){const C=S[k];if(c&&i(k,C)){delete S[k];continue}if(C.source=h,C.defaultDefaultValue=S[k].default,this.w(k,C),e.$zo.test(k)?C.scope=void 0:(C.scope=P.$jg(C.scope)?m:C.scope,C.restricted=P.$jg(C.restricted)?!!s?.includes(k):C.restricted),S[k].hasOwnProperty("included")&&!S[k].included){this.f[k]=S[k],delete S[k];continue}else this.d[k]=S[k],S[k].policy?.name&&this.e.set(S[k].policy.name,k);!S[k].deprecationMessage&&S[k].markdownDeprecationMessage&&(S[k].deprecationMessage=S[k].markdownDeprecationMessage),y.add(k)}const E=t.allOf;if(E)for(const k of E)this.p(k,c,h,s,m,y)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const c=h=>{const s=h.properties;if(s)for(const y in s)this.r(y,s[y]);h.allOf?.forEach(c)};c(t)}r(t,c){switch(e.$qo.properties[t]=c,c.scope){case I.APPLICATION:e.$ro.properties[t]=c;break;case I.MACHINE:e.$so.properties[t]=c;break;case I.MACHINE_OVERRIDABLE:e.$to.properties[t]=c;break;case I.WINDOW:e.$uo.properties[t]=c;break;case I.RESOURCE:e.$vo.properties[t]=c;break;case I.LANGUAGE_OVERRIDABLE:e.$vo.properties[t]=c,this.g.properties[t]=c;break}}s(t,c){switch(delete e.$qo.properties[t],c.scope){case I.APPLICATION:delete e.$ro.properties[t];break;case I.MACHINE:delete e.$so.properties[t];break;case I.MACHINE_OVERRIDABLE:delete e.$to.properties[t];break;case I.WINDOW:delete e.$uo.properties[t];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$vo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const c=`[${t}]`,h={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$wo};this.w(c,h),e.$qo.properties[c]=h,e.$ro.properties[c]=h,e.$so.properties[c]=h,e.$to.properties[c]=h,e.$uo.properties[c]=h,e.$vo.properties[c]=h}}v(){const t={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$wo};e.$qo.patternProperties[e.$yo]=t,e.$ro.patternProperties[e.$yo]=t,e.$so.patternProperties[e.$yo]=t,e.$to.patternProperties[e.$yo]=t,e.$uo.patternProperties[e.$yo]=t,e.$vo.patternProperties[e.$yo]=t,this.i.fire()}w(t,c){const h=this.a.get(t);let s=h?.value,m=h?.source;P.$hg(s)&&(s=c.defaultDefaultValue,m=void 0),P.$hg(s)&&(s=g(c.type)),c.default=s,c.defaultValueSource=m}}const A="\\[([^\\]]+)\\]",w=new RegExp(A,"g");e.$yo=`^(${A})+$`,e.$zo=new RegExp(e.$yo);function a(n){const t=[];if(e.$zo.test(n)){let c=w.exec(n);for(;c?.length;){const h=c[1].trim();h&&t.push(h),c=w.exec(n)}}return(0,r.$Mb)(t)}function d(n){return n.reduce((t,c)=>`${t}[${c}]`,"")}function g(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const $=new f;p.$ko.add(e.$po.Configuration,$);function i(n,t){return n.trim()?e.$zo.test(n)?T.localize(7,null,n):$.getConfigurationProperties()[n]!==void 0?T.localize(8,null,n):t.policy?.name&&$.getPolicyConfigurations().get(t.policy?.name)!==void 0?T.localize(9,null,n,t.policy?.name,$.getPolicyConfigurations().get(t.policy?.name)):null:T.localize(6,null)}function o(){const n=[],t=$.getConfigurationProperties();for(const c of Object.keys(t))n.push([c,t[c].scope]);return n.push(["launch",I.RESOURCE]),n.push(["task",I.RESOURCE]),n}}),define(Ee[281],Se([1,0,19,4,175,3,29,25,18,2,45,70,28,36]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Jo=o;function w(h){return Object.isFrozen(h)?h:R.$$n(h)}class a{static createEmptyModel(s){return new a({},[],[],void 0,s)}constructor(s,m,y,S,E){this.b=s,this.c=m,this.d=y,this.raw=S,this.f=E,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(m=>{if(m instanceof a)return m;const y=new d("",this.f);return y.parseRaw(m),y.configurationModel});this.g=s.reduce((m,y)=>y===m?y:m.merge(y),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,I.$cj)(this.contents,s):this.contents}inspect(s,m){const y=this;return{get value(){return w(y.rawConfiguration.getValue(s))},get override(){return m?w(y.rawConfiguration.getOverrideValue(s,m)):void 0},get merged(){return w(m?y.rawConfiguration.override(m).getValue(s):y.rawConfiguration.getValue(s))},get overrides(){const S=[];for(const{contents:E,identifiers:k,keys:C}of y.rawConfiguration.overrides){const v=new a(E,C,[],void 0,y.f).getValue(s);v!==void 0&&S.push({identifiers:k,value:v})}return S.length?w(S):void 0}}}getOverrideValue(s,m){const y=this.j(m);return y?s?(0,I.$cj)(y,s):y:void 0}getKeysForOverrideIdentifier(s){const m=[];for(const y of this.overrides)y.identifiers.includes(s)&&m.push(...y.keys);return r.$Mb(m)}getAllOverrideIdentifiers(){const s=[];for(const m of this.overrides)s.push(...m.identifiers);return r.$Mb(s)}override(s){let m=this.a.get(s);return m||(m=this.h(s),this.a.set(s,m)),m}merge(...s){const m=R.$0n(this.contents),y=R.$0n(this.overrides),S=[...this.keys],E=this.raw?.length?[...this.raw]:[this];for(const k of s)if(E.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(m,k.contents);for(const C of k.overrides){const[v]=y.filter(b=>r.$ub(b.identifiers,C.identifiers));v?(this.i(v.contents,C.contents),v.keys.push(...C.keys),v.keys=r.$Mb(v.keys)):y.push(R.$0n(C))}for(const C of k.keys)S.indexOf(C)===-1&&S.push(C)}return new a(m,S,y,E.every(k=>k instanceof a)?void 0:E,this.f)}h(s){const m=this.j(s);if(!m||typeof m!="object"||!Object.keys(m).length)return this;const y={};for(const S of r.$Mb([...Object.keys(this.contents),...Object.keys(m)])){let E=this.contents[S];const k=m[S];k&&(typeof E=="object"&&typeof k=="object"?(E=R.$0n(E),this.i(E,k)):E=k),y[S]=E}return new a(y,this.keys,this.overrides,void 0,this.f)}i(s,m){for(const y of Object.keys(m)){if(y in s&&p.$cg(s[y])&&p.$cg(m[y])){this.i(s[y],m[y]);continue}s[y]=R.$0n(m[y])}}j(s){let m=null,y=null;const S=E=>{E&&(y?this.i(y,E):y=R.$0n(E))};for(const E of this.overrides)E.identifiers.length===1&&E.identifiers[0]===s?m=E.contents:E.identifiers.includes(s)&&S(E.contents);return S(m),y}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,m){this.k(s,m,!0)}setValue(s,m){this.k(s,m,!1)}removeValue(s){const m=this.keys.indexOf(s);m!==-1&&(this.keys.splice(m,1),(0,I.$bj)(this.contents,s),D.$zo.test(s)&&this.overrides.splice(this.overrides.findIndex(y=>r.$ub(y.identifiers,(0,D.$Ao)(s))),1))}k(s,m,y){(0,I.$aj)(this.contents,s,m,S=>this.f.error(S)),y=y||this.keys.indexOf(s)===-1,y&&this.keys.push(s),D.$zo.test(s)&&this.overrides.push({identifiers:(0,D.$Ao)(s),keys:Object.keys(this.contents[s]),contents:(0,I.$_i)(this.contents[s],S=>this.f.error(S))})}}e.$Fo=a;class d{constructor(s,m){this.f=s,this.g=m,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||a.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,m){if(!p.$jg(s)){const y=this.h(s);this.parseRaw(y,m)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,m){this.a=s;const{contents:y,keys:S,overrides:E,restricted:k,hasExcludedProperties:C}=this.i(s,m);this.b=new a(y,S,E,C?[s]:void 0,this.g),this.c=k||[]}h(s){let m={},y=null,S=[];const E=[],k=[];function C(b){Array.isArray(S)?S.push(b):y!==null&&(S[y]=b)}const v={onObjectBegin:()=>{const b={};C(b),E.push(S),S=b,y=null},onObjectProperty:b=>{y=b},onObjectEnd:()=>{S=E.pop()},onArrayBegin:()=>{const b=[];C(b),E.push(S),S=b,y=null},onArrayEnd:()=>{S=E.pop()},onLiteralValue:C,onError:(b,O,U)=>{k.push({error:b,offset:O,length:U})}};if(s)try{P.$Xn(s,v),m=S[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return m}i(s,m){const y=A.$ko.as(D.$po.Configuration).getConfigurationProperties(),S=this.j(s,y,!0,m);s=S.raw;const E=(0,I.$_i)(s,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`)),k=Object.keys(s),C=this.l(s,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:E,keys:k,overrides:C,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(s,m,y,S){let E=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:E};const k={},C=[];for(const v in s)if(D.$zo.test(v)&&y){const b=this.j(s[v],m,!1,S);k[v]=b.raw,E=E||b.hasExcludedProperties,C.push(...b.restricted)}else{const b=m[v],O=b?typeof b.scope<"u"?b.scope:D.ConfigurationScope.WINDOW:void 0;b?.restricted&&C.push(v),!S.exclude?.includes(v)&&(S.include?.includes(v)||(O===void 0||S.scopes===void 0||S.scopes.includes(O))&&!(S.skipRestricted&&b?.restricted))?k[v]=s[v]:E=!0}return{raw:k,restricted:C,hasExcludedProperties:E}}l(s,m){const y=[];for(const S of Object.keys(s))if(D.$zo.test(S)){const E={};for(const k in s[S])E[k]=s[S][k];y.push({identifiers:(0,D.$Ao)(S),keys:Object.keys(E),contents:(0,I.$_i)(E,m)})}return y}}e.$Go=d;class g extends T.$Uc{constructor(s,m,y,S,E){super(),this.c=s,this.f=m,this.g=S,this.h=E,this.b=this.B(new u.$he),this.onDidChange=this.b.event,this.a=new d(this.c.toString(),E),this.B(this.g.watch(y.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(u.Event.any(u.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),u.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(f.FileOperation.CREATE)||k.isOperation(f.FileOperation.COPY)||k.isOperation(f.FileOperation.DELETE)||k.isOperation(f.FileOperation.WRITE))&&y.isEqual(k.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return a.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ho=g;class ${constructor(s,m,y,S,E,k,C,v,b,O,U,z,j){this.a=s,this.b=m,this.c=y,this.overrideIdentifiers=S,this.d=E,this.f=k,this.g=C,this.h=v,this.i=b,this.j=O,this.k=U,this.l=z,this.m=j}get value(){return w(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(s,m,y,S,E,k,C,v,b,O){this.j=s,this.l=m,this.m=y,this.n=S,this.p=E,this.q=k,this.r=C,this.s=v,this.t=b,this.u=O,this.h=null,this.i=new L.$Ac,this.v=null}getValue(s,m,y){return this.w(s,m,y).getValue(s)}updateValue(s,m,y={}){let S;y.resource?(S=this.t.get(y.resource),S||(S=a.createEmptyModel(this.u),this.t.set(y.resource,S))):S=this.s,m===void 0?S.removeValue(s):S.setValue(s,m),y.resource||(this.h=null)}inspect(s,m,y){const S=this.w(s,m,y),E=this.A(m.resource,y),k=m.resource?this.t.get(m.resource)||this.s:this.s,C=new Set;for(const v of S.overrides)for(const b of v.identifiers)S.getOverrideValue(s,b)!==void 0&&C.add(b);return new $(s,m,S.getValue(s),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,y?this.q:void 0,E||void 0,k)}keys(s){const m=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:m?m.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,m){this.r.set(s,m),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,m){const y=[];if(!m){const{added:S,updated:E,removed:k}=t(this.j,s);m=[...S,...E,...k]}for(const S of m)for(const E of(0,D.$Ao)(S)){const k=this.j.getKeysForOverrideIdentifier(E),C=s.getKeysForOverrideIdentifier(E),v=[...C.filter(b=>k.indexOf(b)===-1),...k.filter(b=>C.indexOf(b)===-1),...k.filter(b=>!R.$bo(this.j.override(E).getValue(b),s.override(E).getValue(b)))];y.push([E,v])}return this.updateDefaultConfiguration(s),{keys:m,overrides:y}}compareAndUpdatePolicyConfiguration(s){const{added:m,updated:y,removed:S}=t(this.l,s),E=[...m,...y,...S];return E.length&&this.updatePolicyConfiguration(s),{keys:E,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:m,updated:y,removed:S,overrides:E}=t(this.applicationConfiguration,s),k=[...m,...y,...S];return k.length&&this.updateApplicationConfiguration(s),{keys:k,overrides:E}}compareAndUpdateLocalUserConfiguration(s){const{added:m,updated:y,removed:S,overrides:E}=t(this.localUserConfiguration,s),k=[...m,...y,...S];return k.length&&this.updateLocalUserConfiguration(s),{keys:k,overrides:E}}compareAndUpdateRemoteUserConfiguration(s){const{added:m,updated:y,removed:S,overrides:E}=t(this.remoteUserConfiguration,s),k=[...m,...y,...S];return k.length&&this.updateRemoteUserConfiguration(s),{keys:k,overrides:E}}compareAndUpdateWorkspaceConfiguration(s){const{added:m,updated:y,removed:S,overrides:E}=t(this.workspaceConfiguration,s),k=[...m,...y,...S];return k.length&&this.updateWorkspaceConfiguration(s),{keys:k,overrides:E}}compareAndUpdateFolderConfiguration(s,m){const y=this.folderConfigurations.get(s),{added:S,updated:E,removed:k,overrides:C}=t(y,m),v=[...S,...E,...k];return(v.length||!y)&&this.updateFolderConfiguration(s,m),{keys:v,overrides:C}}compareAndDeleteFolderConfiguration(s){const m=this.folderConfigurations.get(s);if(!m)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:y,updated:S,removed:E,overrides:k}=t(m,void 0);return{keys:[...y,...S,...E],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,m,y){let S=this.x(m,y);return m.overrideIdentifier&&(S=S.override(m.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(S=S.merge(this.l)),S}x({resource:s},m){let y=this.y();if(m&&s){const S=m.getFolder(s);S&&(y=this.z(S.uri)||y);const E=this.t.get(s);E&&(y=y.merge(E))}return y}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let m=this.i.get(s);if(!m){const y=this.y(),S=this.r.get(s);S?(m=y.merge(S),this.i.set(s,m)):m=y}return m}A(s,m){if(m&&s){const y=m.getFolder(s);if(y)return this.r.get(y.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,m)=>{const{contents:y,overrides:S,keys:E}=this.r.get(m);return s.push([m,{contents:y,overrides:S,keys:E}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(m=>s.add(m)),this.userConfiguration.keys.forEach(m=>s.add(m)),this.q.keys.forEach(m=>s.add(m)),this.r.forEach(m=>m.keys.forEach(y=>s.add(y))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(m=>s.add(m)),this.userConfiguration.getAllOverrideIdentifiers().forEach(m=>s.add(m)),this.q.getAllOverrideIdentifiers().forEach(m=>s.add(m)),this.r.forEach(m=>m.getAllOverrideIdentifiers().forEach(y=>s.add(y))),[...s.values()]}D(s){const m=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(y=>m.add(y)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(y=>m.add(y)),this.q.getKeysForOverrideIdentifier(s).forEach(y=>m.add(y)),this.r.forEach(y=>y.getKeysForOverrideIdentifier(s).forEach(S=>m.add(S))),[...m.values()]}static parse(s,m){const y=this.E(s.defaults,m),S=this.E(s.policy,m),E=this.E(s.application,m),k=this.E(s.user,m),C=this.E(s.workspace,m),v=s.folders.reduce((b,O)=>(b.set(l.URI.revive(O[0]),this.E(O[1],m)),b),new L.$Ac);return new i(y,S,E,k,a.createEmptyModel(m),C,v,a.createEmptyModel(m),new L.$Ac,m)}static E(s,m){return new a(s.contents,s.keys,s.overrides,void 0,m)}}e.$Io=i;function o(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const s=new Set,m=new Map;for(const S of h)S.keys.forEach(E=>s.add(E)),S.overrides.forEach(([E,k])=>{const C=(0,L.$xc)(m,E,new Set);k.forEach(v=>C.add(v))});const y=[];return m.forEach((S,E)=>y.push([E,[...S.values()]])),{keys:[...s.values()],overrides:y}}class n{constructor(s,m,y,S,E){this.change=s,this.f=m,this.g=y,this.h=S,this.i=E,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of s.keys)this.affectedKeys.add(k);for(const[,k]of s.overrides)for(const C of k)this.affectedKeys.add(C);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,m){const y=this.a+s,S=this.d.indexOf(y);if(S<0)return!1;const E=S+y.length;if(E>=this.d.length)return!1;const k=this.d.charCodeAt(E);if(k!==this.b&&k!==this.c)return!1;if(m){const C=this.previousConfiguration?this.previousConfiguration.getValue(s,m,this.f?.workspace):void 0,v=this.g.getValue(s,m,this.h);return!R.$bo(C,v)}return!0}}e.$Ko=n;function t(h,s){const{added:m,removed:y,updated:S}=c(s?.rawConfiguration,h?.rawConfiguration),E=[],k=h?.getAllOverrideIdentifiers()||[],C=s?.getAllOverrideIdentifiers()||[];if(s){const v=C.filter(b=>!k.includes(b));for(const b of v)E.push([b,s.getKeysForOverrideIdentifier(b)])}if(h){const v=k.filter(b=>!C.includes(b));for(const b of v)E.push([b,h.getKeysForOverrideIdentifier(b)])}if(s&&h){for(const v of k)if(C.includes(v)){const b=c({contents:h.getOverrideValue(void 0,v)||{},keys:h.getKeysForOverrideIdentifier(v)},{contents:s.getOverrideValue(void 0,v)||{},keys:s.getKeysForOverrideIdentifier(v)});E.push([v,[...b.added,...b.removed,...b.updated]])}}return{added:m,removed:y,updated:S,overrides:E}}function c(h,s){const m=h?s?h.keys.filter(E=>s.keys.indexOf(E)===-1):[...h.keys]:[],y=s?h?s.keys.filter(E=>h.keys.indexOf(E)===-1):[...s.keys]:[],S=[];if(h&&s){for(const E of s.keys)if(h.keys.indexOf(E)!==-1){const k=(0,I.$cj)(s.contents,E),C=(0,I.$cj)(h.contents,E);R.$bo(k,C)||S.push(E)}}return{added:m,removed:y,updated:S}}}),define(Ee[282],Se([1,0,22,4,3,68]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vvb=e.$Tvb=e.$Svb=void 0,e.$Uvb=R;const L=(l,I,D)=>{const f=new Uint8Array(16);for(let a=0;a<16;a++)f[a]=Math.round(Math.random()*256);const A=(0,r.$4e)(r.$Je.wrap(f));return[`GET ws://localhost${l}?${I}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${A}`].join(`\r
`)+`\r
\r
`};e.$Svb=L,e.$Tvb=r.$Je.fromString(`\r
\r
`);async function R(l,I,D,f,A){l.write(r.$Je.fromString((0,e.$Svb)(I,D,f)));const w=new P.$Tc;try{return await new Promise((a,d)=>{let g;w.add(l.onData($=>{g?g=r.$Je.concat([g,$],g.byteLength+$.byteLength):g=$;const i=g.indexOf(e.$Tvb);if(i===-1)return;a(l),l.pauseData();const o=g.slice(i+e.$Tvb.byteLength);o.byteLength&&A.onData.fire(o)})),w.add(l.onClose($=>d($??new Error("socket closed")))),w.add(l.onEnd(()=>d(new Error("socket ended"))))})}catch(a){throw l.dispose(),a}finally{w.dispose()}}class p extends P.$Uc{constructor(I,D){super(),this.g=I,this.a=this.B(new u.$ke),this.onData=(...f)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...f)),this.b=this.B(new u.$he),this.onDidDispose=this.b.event,this.f=!1,this.B(D.onData),this.B(D.onData.event(f=>this.a.fire(f))),this.onClose=this.B(D.onClose).event,this.onEnd=this.B(D.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(I,D){T.SocketDiagnostics.traceSocketEvent(this,this.g,I,D)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Vvb=p}),define(Ee[71],Se([1,0,14,5]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=l,e.$Ll=(0,u.$Ai)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class T{constructor(D){this.id=D,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Ml=T;class L{constructor(D,f){this.host=D,this.port=f,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=L;var R;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class p extends r.$bb{static isNotAvailable(D){return D instanceof p&&D._code===R.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof p&&D._code===R.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof p&&D._code===R.NoResolverFound}static isInvalidAuthority(D){return D instanceof p&&D._code===R.InvalidAuthority}static isHandled(D){return D instanceof p&&D.isHandled}constructor(D,f=R.Unknown,A){super(D),this._message=D,this._code=f,this._detail=A,this.isHandled=f===R.NotAvailable&&A===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Ol=p;function l(I){const D=I.indexOf("+");return D===-1?I:I.substring(0,D)}}),define(Ee[283],Se([1,0,7,22,21,14,4,3,15,62,43,33,68,71]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Ul=E,e.$Vl=k,e.$Wl=v;const w=30*1e3;var a;(function(pe){pe[pe.Management=1]="Management",pe[pe.ExtensionHost=2]="ExtensionHost",pe[pe.Tunnel=3]="Tunnel"})(a||(e.ConnectionType=a={}));function d(pe){switch(pe){case a.Management:return"Management";case a.ExtensionHost:return"ExtensionHost";case a.Tunnel:return"Tunnel"}}function g(pe){const ce=new P.$se;return setTimeout(()=>ce.cancel(),pe),ce.token}function $(pe,ce){if(pe.isCancellationRequested||ce.isCancellationRequested)return P.CancellationToken.Cancelled;const K=new P.$se;return pe.onCancellationRequested(()=>K.cancel()),ce.onCancellationRequested(()=>K.cancel()),K.token}class i{get didTimeout(){return this.c==="timedout"}constructor(ce){this.c="pending",this.d=new R.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,r.$th)(),ce.isCancellationRequested?this.h():this.d.add(ce.onCancellationRequested(()=>this.h()))}registerDisposable(ce){this.c==="pending"?this.d.add(ce):ce.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const ce=new Error("Time limit reached");return ce.code="ETIMEDOUT",ce.syscall="connect",ce}resolve(ce){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(ce))}reject(ce){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(ce))}}function o(pe,ce){const K=new i(ce);return K.registerDisposable(pe.onControlMessage(de=>{const te=JSON.parse(de.toString()),ee=H(te);ee?K.reject(ee):K.resolve(te)})),K.promise}function n(pe,ce,K,de,te,ee,ie,le){const Z=new i(le),ae=I.$be.create(!1);return pe.info(`Creating a socket (${ie})...`),l.mark(`code/willCreateSocket/${ee}`),ce.connect(K,de,te,ie).then($e=>{Z.didTimeout?(l.mark(`code/didCreateSocketError/${ee}`),pe.info(`Creating a socket (${ie}) finished after ${ae.elapsed()} ms, but this is too late and has timed out already.`),$e?.dispose()):(l.mark(`code/didCreateSocketOK/${ee}`),pe.info(`Creating a socket (${ie}) was successful after ${ae.elapsed()} ms.`),Z.resolve($e))},$e=>{l.mark(`code/didCreateSocketError/${ee}`),pe.info(`Creating a socket (${ie}) returned an error after ${ae.elapsed()} ms.`),pe.error($e),Z.reject($e)}),Z.promise}function t(pe,ce){const K=new i(ce);return pe.then(de=>{K.didTimeout||K.resolve(de)},de=>{K.didTimeout||K.reject(de)}),K.promise}async function c(pe,ce,K,de){const te=ne(pe,ce);pe.logService.trace(`${te} 1/6. invoking socketFactory.connect().`);let ee;try{ee=await n(pe.logService,pe.remoteSocketFactoryService,pe.connectTo,p.$Ng.getServerRootPath(),`reconnectionToken=${pe.reconnectionToken}&reconnection=${pe.reconnectionProtocol?"true":"false"}`,d(ce),`renderer-${d(ce)}-${pe.reconnectionToken}`,de)}catch($e){throw pe.logService.error(`${te} socketFactory.connect() failed or timed out. Error:`),pe.logService.error($e),$e}pe.logService.trace(`${te} 2/6. socketFactory.connect() was successful.`);let ie,le;pe.reconnectionProtocol?(pe.reconnectionProtocol.beginAcceptReconnection(ee,null),ie=pe.reconnectionProtocol,le=!1):(ie=new f.$oi({socket:ee}),le=!0),pe.logService.trace(`${te} 3/6. sending AuthRequest control message.`);const Z=await t(pe.signService.createNewMessage((0,D.$Wg)()),de),ae={type:"auth",auth:pe.connectionToken||"00000000000000000000",data:Z.data};ie.sendControl(u.$Je.fromString(JSON.stringify(ae)));try{const $e=await o(ie,$(de,g(1e4)));if($e.type!=="sign"||typeof $e.data!="string"){const De=new Error("Unexpected handshake message");throw De.code="VSCODE_CONNECTION_ERROR",De}if(pe.logService.trace(`${te} 4/6. received SignRequest control message.`),!await t(pe.signService.validate(Z,$e.signedData),de)){const De=new Error("Refused to connect to unsupported server");throw De.code="VSCODE_CONNECTION_ERROR",De}const Me=await t(pe.signService.sign($e.data),de),qe={type:"connectionType",commit:pe.commit,signedData:Me,desiredConnectionType:ce};return K&&(qe.args=K),pe.logService.trace(`${te} 5/6. sending ConnectionTypeRequest control message.`),ie.sendControl(u.$Je.fromString(JSON.stringify(qe))),{protocol:ie,ownsProtocol:le}}catch($e){throw $e&&$e.code==="ETIMEDOUT"&&(pe.logService.error(`${te} the handshake timed out. Error:`),pe.logService.error($e)),$e&&$e.code==="VSCODE_CONNECTION_ERROR"&&(pe.logService.error(`${te} received error control message when negotiating connection. Error:`),pe.logService.error($e)),le&&W(ie),$e}}async function h(pe,ce,K,de){const te=Date.now(),ee=ne(pe,ce),{protocol:ie,ownsProtocol:le}=await c(pe,ce,K,de),Z=new i(de);return Z.registerDisposable(ie.onControlMessage(ae=>{const $e=JSON.parse(ae.toString()),be=H($e);be?(pe.logService.error(`${ee} received error control message when negotiating connection. Error:`),pe.logService.error(be),le&&W(ie),Z.reject(be)):(pe.reconnectionProtocol?.endAcceptReconnection(),pe.logService.trace(`${ee} 6/6. handshake finished, connection is up and running after ${we(te)}!`),Z.resolve({protocol:ie,firstMessage:$e}))})),Z.promise}async function s(pe,ce){const{protocol:K}=await h(pe,a.Management,void 0,ce);return{protocol:K}}async function m(pe,ce,K){const{protocol:de,firstMessage:te}=await h(pe,a.ExtensionHost,ce,K),ee=te&&te.debugPort;return{protocol:de,debugPort:ee}}async function y(pe,ce,K){const de=Date.now(),te=ne(pe,a.Tunnel),{protocol:ee}=await c(pe,a.Tunnel,ce,K);return pe.logService.trace(`${te} 6/6. handshake finished, connection is up and running after ${we(de)}!`),ee}async function S(pe,ce,K){const{connectTo:de,connectionToken:te}=await pe.addressProvider.getAddress();return{commit:pe.commit,quality:pe.quality,connectTo:de,connectionToken:te,reconnectionToken:ce,reconnectionProtocol:K,remoteSocketFactoryService:pe.remoteSocketFactoryService,signService:pe.signService,logService:pe.logService}}async function E(pe,ce,K){return C(pe,async de=>{const{protocol:te}=await s(de,P.CancellationToken.None);return new X(pe,ce,K,de.reconnectionToken,te)})}async function k(pe,ce){return C(pe,async K=>{const{protocol:de,debugPort:te}=await m(K,ce,P.CancellationToken.None);return new se(pe,ce,K.reconnectionToken,de,te)})}async function C(pe,ce){for(let de=1;;de++)try{const te=(0,D.$Wg)(),ee=await S(pe,te,null);return await ce(ee)}catch(te){if(de<5)pe.logService.error(`[remote-connection][attempt ${de}] An error occurred in initial connection! Will retry... Error:`),pe.logService.error(te);else throw pe.logService.error(`[remote-connection][attempt ${de}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),pe.logService.error(te),F.triggerPermanentFailure(0,0,A.$Ol.isHandled(te)),te}}async function v(pe,ce,K){const de=await S(pe,(0,D.$Wg)(),null);return await y(de,{host:ce,port:K},P.CancellationToken.None)}function b(pe){return(0,r.$nh)(ce=>new Promise((K,de)=>{const te=setTimeout(K,pe*1e3);ce.onCancellationRequested(()=>{clearTimeout(te),K()})}))}var O;(function(pe){pe[pe.ConnectionLost=0]="ConnectionLost",pe[pe.ReconnectionWait=1]="ReconnectionWait",pe[pe.ReconnectionRunning=2]="ReconnectionRunning",pe[pe.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",pe[pe.ConnectionGain=4]="ConnectionGain"})(O||(e.PersistentConnectionEventType=O={}));class U{constructor(ce,K){this.reconnectionToken=ce,this.millisSinceLastIncomingData=K,this.type=O.ConnectionLost}}e.$Xl=U;class z{constructor(ce,K,de,te){this.reconnectionToken=ce,this.millisSinceLastIncomingData=K,this.durationSeconds=de,this.c=te,this.type=O.ReconnectionWait}skipWait(){this.c.cancel()}}e.$Yl=z;class j{constructor(ce,K,de){this.reconnectionToken=ce,this.millisSinceLastIncomingData=K,this.attempt=de,this.type=O.ReconnectionRunning}}e.$Zl=j;class M{constructor(ce,K,de){this.reconnectionToken=ce,this.millisSinceLastIncomingData=K,this.attempt=de,this.type=O.ConnectionGain}}e.$1l=M;class N{constructor(ce,K,de,te){this.reconnectionToken=ce,this.millisSinceLastIncomingData=K,this.attempt=de,this.handled=te,this.type=O.ReconnectionPermanentFailure}}e.$2l=N;class F extends R.$Uc{static triggerPermanentFailure(ce,K,de){this._permanentFailure=!0,this.f=ce,this.g=K,this.h=de,this.j.forEach(te=>te.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(ce=>ce.y())}static debugPauseSocketWriting(){this.j.forEach(ce=>ce.F())}get n(){return this.c||F._permanentFailure}constructor(ce,K,de,te,ee){super(),this.t=ce,this.u=K,this.reconnectionToken=de,this.protocol=te,this.w=ee,this.m=this.B(new L.$he),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(te.onSocketClose(ie=>{const le=he(this.t,this.reconnectionToken,!0);ie?ie.type===f.SocketCloseEventType.NodeSocketCloseEvent?(this.u.logService.info(`${le} received socket close event (hadError: ${ie.hadError}).`),ie.error&&this.u.logService.error(ie.error)):(this.u.logService.info(`${le} received socket close event (wasClean: ${ie.wasClean}, code: ${ie.code}, reason: ${ie.reason}).`),ie.event&&this.u.logService.error(ie.event)):this.u.logService.info(`${le} received socket close event.`),this.y()})),this.B(te.onSocketTimeout(ie=>{const le=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${le} received socket timeout event (unacknowledgedMsgCount: ${ie.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ie.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ie.timeSinceLastReceivedSomeData}).`),this.y()})),F.j.push(this),this.B((0,R.$Sc)(()=>{const ie=F.j.indexOf(this);ie>=0&&F.j.splice(ie,1)})),this.n&&this.D(F.f,F.g,F.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const ce=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ce} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const K=[0,5,5,10,10,10,10,10,30];let de=-1;do{de++;const te=de<K.length?K[de]:K[K.length-1];try{if(te>0){const ie=b(te);this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),te,ie)),this.u.logService.info(`${ce} waiting for ${te} seconds before reconnecting...`);try{await ie}catch{}}if(this.n){this.u.logService.error(`${ce} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de+1)),this.u.logService.info(`${ce} resolving connection...`);const ee=await S(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${ce} connecting to ${ee.connectTo}...`),await this.G(ee,g(w)),this.u.logService.info(`${ce} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${ce} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),de+1,!1);break}if(de>360){this.u.logService.error(`${ce} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),de+1,!1);break}if(A.$Ol.isTemporarilyNotAvailable(ee)){this.u.logService.info(`${ce} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this.u.logService.info(`${ce} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if((0,T.$4)(ee)){this.u.logService.info(`${ce} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(ee);continue}if(ee instanceof A.$Ol){this.u.logService.error(`${ce} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),de+1,A.$Ol.isHandled(ee));break}this.u.logService.error(`${ce} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(ee),this.C(this.protocol.getMillisSinceLastIncomingData(),de+1,!1);break}}while(!this.n&&!this.s)}C(ce,K,de){this.w?F.triggerPermanentFailure(ce,K,de):this.D(ce,K,de)}D(ce,K,de){this.m.fire(new N(this.reconnectionToken,ce,K,de)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$3l=F,F._permanentFailure=!1,F.f=0,F.g=0,F.h=!1,F.j=[];class X extends F{constructor(ce,K,de,te,ee){super(a.Management,ce,te,ee,!0),this.client=this.B(new f.$mi(ee,{remoteAuthority:K,clientId:de},ce.ipcLogger))}async G(ce,K){await s(ce,K)}}e.$4l=X;class se extends F{constructor(ce,K,de,te,ee){super(a.ExtensionHost,ce,de,te,!1),this.H=K,this.debugPort=ee}async G(ce,K){await m(ce,this.H,K)}}e.$5l=se;function W(pe){try{pe.acceptDisconnect();const ce=pe.getSocket();pe.dispose(),ce.dispose()}catch(ce){(0,T.$1)(ce)}}function H(pe){if(pe&&pe.type==="error"){const ce=new Error(`Connection error: ${pe.reason}`);return ce.code="VSCODE_CONNECTION_ERROR",ce}return null}function V(pe,ce){for(;pe.length<ce;)pe+=" ";return pe}function x(pe,ce){return`[remote-connection][${V(d(pe),13)}][${ce.substr(0,5)}\u2026]`}function he(pe,ce,K){return`${x(pe,ce)}[${K?"reconnect":"initial"}]`}function ne(pe,ce){return`${he(ce,pe.reconnectionToken,!!pe.reconnectionProtocol)}[${pe.connectTo}]`}function we(pe){return`${Date.now()-pe} ms`}}),define(Ee[91],Se([1,0,15]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=u,e.$Om=P,e.$Pm=T,e.$Qm=L;function u(p){return p.scheme===r.Schemas.vscodeRemote?p.authority:void 0}function P(p){if(!p)return;const l=p.indexOf("+");return l<0?p:p.substr(0,l)}function T(p){const{host:l,port:I}=R(p);if(typeof I>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:I}}function L(p,l){let{host:I,port:D}=R(p);return typeof D>"u"&&(D=l),{host:I,port:D}}function R(p){const l=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const D=p.match(/(.*):(\d+)$/);return D?{host:D[1],port:parseInt(D[2],10)}:{host:p,port:void 0}}}),define(Ee[24],Se([1,0,13,5,91]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$Zm=e.$Ym=e.$Xm=e.TargetPlatform=e.ExtensionType=e.$Wm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0,e.$Vm=T,e.$1m=D,e.$2m=f,e.$3m=A,e.$4m=w,e.$Rm="extensions.user.cache",e.$Sm="extensions.builtin.cache",e.$Tm="undefined_publisher",e.$Um=["ui","workspace","web"];function T(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$Wm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var L;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(L||(e.ExtensionType=L={}));var R;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class p{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,g){if(typeof d>"u"||d===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof d=="string"||typeof g=="string"){const $=typeof d=="string"?d:d.value,i=typeof g=="string"?g:g.value;return r.$Bf($,i)}return d._lower===g._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Xm=p;class l{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const g of d)this.add(g)}add(d){this.c.add(p.toKey(d))}delete(d){return this.c.delete(p.toKey(d))}has(d){return this.c.has(p.toKey(d))}}e.$Ym=l;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(p.toKey(d))}get(d){return this.c.get(p.toKey(d))}has(d){return this.c.has(p.toKey(d))}set(d,g){this.c.set(p.toKey(d),g)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Zm=I;function D(a){return f(a)}function f(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function A(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function w(a,d){if(d){const g=`onResolveRemoteAuthority:${(0,P.$Om)(d)}`;return!!a.activationEvents?.includes(g)}return!1}e.$5m=(0,u.$Ai)("IBuiltinExtensionsScannerService")}),define(Ee[146],Se([1,0,11,220,24,5]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.ExtensionManagementErrorCode=e.$dp=e.ExtensionGalleryErrorCode=e.$cp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0,e.$9o=R,e.$0o=p,e.$$o=l,e.$_o=I,e.$ap=D,e.$bp=f,e.$2o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3o=new RegExp(e.$2o),e.$4o="__web_extension",e.$5o="skipWalkthrough",e.$6o="extensionInstallSource",e.$7o="dependecyOrPackExtensionInstall",e.$8o="clientTargetPlatform";var L;(function(n){n.COMMAND="command",n.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function R(n){switch(n){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function p(n){switch(n){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function l(n,t){switch(n){case r.Platform.Windows:return t==="x64"?P.TargetPlatform.WIN32_X64:t==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Linux:return t==="x64"?P.TargetPlatform.LINUX_X64:t==="arm64"?P.TargetPlatform.LINUX_ARM64:t==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return t==="x64"?P.TargetPlatform.ALPINE_X64:t==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Mac:return t==="x64"?P.TargetPlatform.DARWIN_X64:t==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case r.Platform.Web:return P.TargetPlatform.WEB}}function I(n,t){return t===P.TargetPlatform.WEB&&!n.includes(P.TargetPlatform.WEB)}function D(n,t,c){return I(t,c)?!1:n===P.TargetPlatform.UNDEFINED||n===P.TargetPlatform.UNIVERSAL?!0:n===P.TargetPlatform.UNKNOWN?!1:n===c}function f(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var A;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var w;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(w||(e.SortOrder=w={}));var a;(function(n){n.Install="install",n.Uninstall="uninstall"})(a||(e.StatisticType=a={}));var d;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$cp=(0,T.$Ai)("extensionGalleryService");var g;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed",n.DownloadFailedWriting="DownloadFailedWriting"})(g||(e.ExtensionGalleryErrorCode=g={}));class $ extends Error{constructor(t,c){super(t),this.code=c,this.name=c}}e.$dp=$;var i;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.DownloadFailedWriting="DownloadFailedWriting",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.ScanningExtension="ScanningExtension",n.ReadUninstalled="ReadUninstalled",n.UnsetUninstalled="UnsetUninstalled",n.Delete="Delete",n.Rename="Rename",n.IntializeDefaultProfile="IntializeDefaultProfile",n.AddToProfile="AddToProfile",n.InstalledExtensionNotFound="InstalledExtensionNotFound",n.PostInstall="PostInstall",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class o extends Error{constructor(t,c){super(t),this.code=c,this.name=c}}e.$ep=o,e.$fp=(0,T.$Ai)("extensionManagementService"),e.$gp="extensionsIdentifiers/disabled",e.$hp="extensionsIdentifiers/enabled",e.$ip=(0,T.$Ai)("IGlobalExtensionEnablementService"),e.$jp=(0,T.$Ai)("IExtensionTipsService"),e.$kp=(0,u.localize2)(0,"Extensions"),e.$lp=(0,u.localize2)(1,"Preferences")}),define(Ee[147],Se([1,0,14,24]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AG=e.$zG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(L,R){this.a.set(L,R)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const R=Object.create(null);for(const p of L){const l=this.readActivationEvents(p);l.length>0&&(R[u.$Xm.toKey(p.identifier)]=l)}return R}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const R=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let p=0;p<R.length;p++)R[p]==="onUri"&&(R[p]=`onUri:${u.$Xm.toKey(L.identifier)}`);if(!L.contributes)return R;for(const p in L.contributes){const l=this.a.get(p);if(!l)continue;const I=L.contributes[p],D=Array.isArray(I)?I:[I];try{l(D,R)}catch(f){(0,r.$1)(f)}}return R}}e.$zG=P,e.$AG=new P}),define(Ee[284],Se([1,0,3,5]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql=(0,u.$Ai)("remoteSocketFactoryService");class P{constructor(){this.a={}}register(L,R){var p;return(p=this.a)[L]??(p[L]=[]),this.a[L].push(R),(0,r.$Sc)(()=>{const l=this.a[L]?.indexOf(R);typeof l=="number"&&l>=0&&this.a[L]?.splice(l,1)})}b(L){return(this.a[L.type]||[]).find(p=>p.supports(L))}connect(L,R,p,l){const I=this.b(L);if(!I)throw new Error(`No socket factory found for ${L}`);return I.connect(L,R,p,l)}}e.$Rl=P}),define(Ee[285],Se([1,0,22,14,3,228,70,5,12,36]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0,e.$Yp=f,e.$Zp=A,e.$1p=w,e.$2p=a,e.$3p=d,e.$4p=g,e.$Wp=(0,R.$Ai)("requestService");class I{constructor(n){this.b=n}toJSON(){if(!this.a){const n=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?n[t]="*****":n[t]=this.b[t];this.a=n}return this.a}}class D extends P.$Uc{constructor(n){super(),this.b=0,this.a=n.createLogger("network",{name:(0,T.localize)(0,null),when:p.$mk.isEqualTo((0,p.$jk)(p.LogLevel.Trace)).serialize()})}async c(n,t,c){const h=`${n} #${++this.b}: ${t.url}`;this.a.trace(`${h} - begin`,t.type,new I(t.headers??{}));try{const s=await c();return this.a.trace(`${h} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${h} - error`,t.type,(0,u.$0)(s)),s}}}e.$Xp=D;function f(o){return o.res.statusCode&&o.res.statusCode>=200&&o.res.statusCode<300||o.res.statusCode===1223}function A(o){return o.res.statusCode===204}async function w(o){return A(o)?null:(await(0,r.$Ve)(o.stream)).toString()}async function a(o){if(!f(o))throw new Error("Server returned "+o.res.statusCode);return w(o)}async function d(o){if(!f(o))throw new Error("Server returned "+o.res.statusCode);if(A(o))return null;const t=(await(0,r.$Ve)(o.stream)).toString();try{return JSON.parse(t)}catch(c){throw c.message+=`:
`+t,c}}function g(o){i(o)}let $;function i(o){const n=l.$ko.as(L.$po.Configuration),t=$;$={id:"http",order:15,title:(0,T.localize)(1,null),type:"object",scope:o,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(6,null),(0,T.localize)(7,null),(0,T.localize)(8,null),(0,T.localize)(9,null)],default:"override",description:(0,T.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(12,null),restricted:!0}}},n.updateConfigurations({add:[$],remove:t?[t]:[]})}i(L.ConfigurationScope.APPLICATION)}),define(Ee[286],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=void 0;class r{constructor(){this.b=new Map}async createNewMessage(P){try{const T=await this.c();if(T){const L=String(r.a++);return this.b.set(L,T),{id:L,data:T.createNewMessage(P)}}}catch{}return{id:"",data:P}}async validate(P,T){if(!P.id)return!0;const L=this.b.get(P.id);if(!L)return!1;this.b.delete(P.id);try{return L.validate(T)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(P){try{return await this.d(P)}catch{}return P}}e.$kac=r,r.a=1}),define(Ee[117],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.$Sl=void 0,e.$Sl="signService",e.$Tl=(0,r.$Ai)(e.$Sl)}),define(Ee[148],Se([1,0,286]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class u extends r.$kac{c(){return this.h().then(T=>new T.validator)}d(T){return this.h().then(L=>new L.signer().sign(T))}h(){return new Promise((T,L)=>oe(["vsda"],T,L))}}e.$pfc=u}),define(Ee[287],Se([1,0,11,54,33]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=L,e.$np=R;function T(p){if(r.$o===r.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function L(p,l,I,D,f,A,w,a,d,g){const $=Object.create(null);$["common.machineId"]=A,$["common.sqmId"]=w,$["common.devDeviceId"]=a,$.sessionID=(0,P.$Wg)()+Date.now(),$.commitHash=D,$.version=f,$["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,r.$b)(r.$o),$["common.nodePlatform"]=u.$dc,$["common.nodeArch"]=I,$["common.product"]=g||"desktop",d&&($["common.msftInternal"]=d);let i=0;const o=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),r.$f&&($["common.snap"]="true");const n=T(l);return n&&($["common.platformDetail"]=n),$}function R(p){const l=u.env.USERDNSDOMAIN;if(!l)return!1;const I=l.toLowerCase();return p.some(D=>I===D)}}),define(Ee[149],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,r.$Ai)("telemetryService"),e.$7l=(0,r.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry.devDeviceId",e.$bm="telemetry",e.$cm="telemetry.telemetryLevel",e.$dm="telemetry.enableCrashReporter",e.$em="telemetry.enableTelemetry";var u;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(u||(e.TelemetryLevel=u={}));var P;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ee[92],Se([1,0,25,18,91,287,149]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=void 0,e.$vp=I,e.$wp=D,e.$xp=f,e.$yp=A,e.$zp=a,e.$Ap=g,e.$Bp=$,e.$Cp=n;class R{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$op=R;class p{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$pp=p,e.$qp=new p;class l{async publicLog(c,h,s){}async publicLogError(c,h,s){}}e.$rp=l,e.$sp="telemetry",e.$tp="extensionTelemetryLog",e.$up={log:()=>null,flush:()=>Promise.resolve(null)};function I(t,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!t.enableTelemetry)}function D(t,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function f(t){const c=t.getValue(L.$cm),h=t.getValue(L.$dm);if(t.getValue(L.$em)===!1||h===!1)return L.TelemetryLevel.NONE;switch(c??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function A(t){const c={},h={},s={};d(t,s);for(let m in s){m=m.length>150?m.substr(m.length-149):m;const y=s[m];typeof y=="number"?h[m]=y:typeof y=="boolean"?h[m]=y?1:0:typeof y=="string"?(y.length>8192&&console.warn(`Telemetry property: ${m} has been trimmed to 8192, the original length is ${y.length}`),c[m]=y.substring(0,8191)):typeof y<"u"&&y!==null&&(c[m]=y)}return{properties:c,measurements:h}}const w=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const c=(0,P.$Om)(t);return w.has(c)?c:"other"}function d(t,c,h=0,s){if(t)for(const m of Object.getOwnPropertyNames(t)){const y=t[m],S=s?s+m:m;Array.isArray(y)?c[S]=(0,r.$co)(y):y instanceof Date?c[S]=y.toISOString():(0,u.$cg)(y)?h<2?d(y,c,h+1,S+"."):c[S]=(0,r.$co)(y):c[S]=y}}function g(t,c){const h=t.msftInternalDomains||[],s=c.getValue("telemetry.internalTesting");return(0,T.$np)(h)||s}function $(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function i(t,c){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let h=t;const s=[];for(const E of c)for(;;){const k=E.exec(t);if(!k)break;s.push([k.index,E.lastIndex])}const m=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,y=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(h="";;){const E=y.exec(t);if(!E)break;const k=s.some(([C,v])=>E.index<v&&C<y.lastIndex);!m.test(E[0])&&!k&&(h+=t.substring(S,E.index)+"<REDACTED: user-file-path>",S=y.lastIndex)}return S<t.length&&(h+=t.substr(S)),h}function o(t){if(!t)return t;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const h of c)if(h.regex.test(t))return`<REDACTED: ${h.label}>`;return t}function n(t,c){return(0,r.$_n)(t,h=>{if(h instanceof R||Object.hasOwnProperty.call(h,"isTrustedTelemetryValue"))return h.value;if(typeof h=="string"){let s=h.replaceAll("%20"," ");s=i(s,c);for(const m of c)s=s.replace(m,"");return s=o(s),s}})}}),define(Ee[288],Se([1,0,13,146,24,11,2,14,54,92]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Ep=void 0,e.$Dp=I,e.$Fp=w,e.$Gp=a,e.$Hp=d,e.$Ip=g,e.$Jp=$,e.$Kp=i,e.$Lp=o,e.$Np=n,e.$Op=c;function I(h,s){return h.uuid&&s.uuid?h.uuid===s.uuid:h.id===s.id?!0:(0,r.$wf)(h.id,s.id)===0}const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class f{static create(s){const m=s.manifest?s.manifest.version:s.version,y=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new f(s.identifier,m,y)}static parse(s){const m=D.exec(s);return m&&m[1]&&m[2]?new f({id:m[1]},m[2],m[4]||void 0):null}constructor(s,m,y=P.TargetPlatform.UNDEFINED){this.identifier=s,this.version=m,this.targetPlatform=y,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof f?I(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$Ep=f;const A=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function w(h){const s=A.exec(h);return s&&s[1]?[d(s[1]),s[2]]:[d(h),void 0]}function a(h,s){return`${h}.${s}`}function d(h){return h.toLowerCase()}function g(h,s){return d(a(h??P.$Tm,s))}function $(h,s){const m=[],y=S=>{for(const E of m)if(E.some(k=>I(s(k),s(S))))return E;return null};for(const S of h){const E=y(S);E?E.push(S):m.push([S])}return m}function i(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}function o(h){return{id:new l.$op(h.identifier.id),name:new l.$op(h.name),version:h.version,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.$Mp=new P.$Xm("pprice.better-merge");function n(h,s){const m=[],y=s.manifest.extensionDependencies?.slice(0)??[];for(;y.length;){const S=y.shift();if(S&&m.every(E=>!I(E.identifier,{id:S}))){const E=h.filter(k=>I(k.identifier,{id:S}));E.length===1&&(m.push(E[0]),y.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return m}async function t(h,s){if(!T.$e)return!1;let m;try{m=(await h.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{m=(await h.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){s.debug("Error while getting the os-release file.",(0,R.$0)(S))}}return!!m&&(m.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function c(h,s){const m=await t(h,s),y=(0,u.$$o)(m?"alpine":T.$o,p.$ec);return s.debug("ComputeTargetPlatform:",y),y}}),define(Ee[289],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=r,e.$vs=u,e.$ws=P,e.$xs=T,e.$ys=L,e.$zs=R;function r(p){return[...p.entries()]}function u(p){return p?[...p.entries()]:[]}function P(p){return new Map(p)}function T(p){return new Map(p??[])}function L(p){return Array.from(p.entries()).map(l=>[l[0],r(l[1].map),u(l[1].descriptionMap)])}function R(p){return new Map(p.map(l=>[l[0],{map:P(l[1]),descriptionMap:T(l[2])}]))}}),define(Ee[290],Se([1,0,5,35,36]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$es=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ds=void 0,e.$ds=new u.$Rj("terminalTabFocusMode",!1,!0);var T;(function(n){n.AutomationProfile="terminal.integrated.automationProfile.",n.DefaultProfile="terminal.integrated.defaultProfile.",n.Profiles="terminal.integrated.profiles."})(T||(e.TerminalSettingPrefix=T={}));var L;(function(n){n.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",n.AutomationProfileLinux="terminal.integrated.automationProfile.linux",n.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",n.AutomationProfileWindows="terminal.integrated.automationProfile.windows",n.ProfilesWindows="terminal.integrated.profiles.windows",n.ProfilesMacOs="terminal.integrated.profiles.osx",n.ProfilesLinux="terminal.integrated.profiles.linux",n.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",n.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",n.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",n.UseWslProfiles="terminal.integrated.useWslProfiles",n.TabsDefaultColor="terminal.integrated.tabs.defaultColor",n.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",n.TabsEnabled="terminal.integrated.tabs.enabled",n.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",n.TabsHideCondition="terminal.integrated.tabs.hideCondition",n.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",n.TabsShowActions="terminal.integrated.tabs.showActions",n.TabsLocation="terminal.integrated.tabs.location",n.TabsFocusMode="terminal.integrated.tabs.focusMode",n.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",n.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",n.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",n.CopyOnSelection="terminal.integrated.copyOnSelection",n.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",n.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",n.FontFamily="terminal.integrated.fontFamily",n.FontSize="terminal.integrated.fontSize",n.LetterSpacing="terminal.integrated.letterSpacing",n.LineHeight="terminal.integrated.lineHeight",n.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",n.TabStopWidth="terminal.integrated.tabStopWidth",n.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",n.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",n.BellDuration="terminal.integrated.bellDuration",n.FontWeight="terminal.integrated.fontWeight",n.FontWeightBold="terminal.integrated.fontWeightBold",n.CursorBlinking="terminal.integrated.cursorBlinking",n.CursorStyle="terminal.integrated.cursorStyle",n.CursorStyleInactive="terminal.integrated.cursorStyleInactive",n.CursorWidth="terminal.integrated.cursorWidth",n.Scrollback="terminal.integrated.scrollback",n.DetectLocale="terminal.integrated.detectLocale",n.DefaultLocation="terminal.integrated.defaultLocation",n.GpuAcceleration="terminal.integrated.gpuAcceleration",n.TerminalTitleSeparator="terminal.integrated.tabs.separator",n.TerminalTitle="terminal.integrated.tabs.title",n.TerminalDescription="terminal.integrated.tabs.description",n.RightClickBehavior="terminal.integrated.rightClickBehavior",n.MiddleClickBehavior="terminal.integrated.middleClickBehavior",n.Cwd="terminal.integrated.cwd",n.ConfirmOnExit="terminal.integrated.confirmOnExit",n.ConfirmOnKill="terminal.integrated.confirmOnKill",n.EnableBell="terminal.integrated.enableBell",n.EnableVisualBell="terminal.integrated.enableVisualBell",n.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",n.AllowChords="terminal.integrated.allowChords",n.AllowMnemonics="terminal.integrated.allowMnemonics",n.TabFocusMode="terminal.integrated.tabFocusMode",n.EnvMacOs="terminal.integrated.env.osx",n.EnvLinux="terminal.integrated.env.linux",n.EnvWindows="terminal.integrated.env.windows",n.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",n.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",n.ShowExitAlert="terminal.integrated.showExitAlert",n.SplitCwd="terminal.integrated.splitCwd",n.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",n.WordSeparators="terminal.integrated.wordSeparators",n.EnableFileLinks="terminal.integrated.enableFileLinks",n.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",n.UnicodeVersion="terminal.integrated.unicodeVersion",n.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",n.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",n.HideOnStartup="terminal.integrated.hideOnStartup",n.CustomGlyphs="terminal.integrated.customGlyphs",n.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",n.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",n.InheritEnv="terminal.integrated.inheritEnv",n.ShowLinkHover="terminal.integrated.showLinkHover",n.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",n.AutoReplies="terminal.integrated.autoReplies",n.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",n.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",n.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",n.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",n.EnableImages="terminal.integrated.enableImages",n.SmoothScrolling="terminal.integrated.smoothScrolling",n.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",n.FocusAfterRun="terminal.integrated.focusAfterRun",n.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",n.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",n.DevMode="terminal.integrated.developer.devMode"})(L||(e.TerminalSettingId=L={}));var R;(function(n){n.PowerShell="pwsh",n.Bash="bash",n.Fish="fish",n.Sh="sh",n.Csh="csh",n.Ksh="ksh",n.Zsh="zsh",n.Python="python"})(R||(e.PosixShellType=R={}));var p;(function(n){n.CommandPrompt="cmd",n.PowerShell="pwsh",n.Wsl="wsl",n.GitBash="gitbash",n.Python="python"})(p||(e.WindowsShellType=p={}));var l;(function(n){n[n.Api=0]="Api",n[n.Process=1]="Process",n[n.Sequence=2]="Sequence",n[n.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var I;(function(n){n.LocalPty="localPty",n.PtyHost="ptyHost",n.PtyHostWindow="ptyHostWindow",n.Logger="logger",n.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var D;(function(n){n.Cwd="cwd",n.InitialCwd="initialCwd",n.FixedDimensions="fixedDimensions",n.Title="title",n.ShellType="shellType",n.HasChildProcesses="hasChildProcesses",n.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",n.OverrideDimensions="overrideDimensions",n.FailedShellIntegrationActivation="failedShellIntegrationActivation",n.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(D||(e.ProcessPropertyType=D={})),e.$es=(0,r.$Ai)("ptyService");var f;(function(n){n[n.BeatInterval=5e3]="BeatInterval",n[n.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",n[n.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",n[n.SecondWaitMultiplier=1]="SecondWaitMultiplier",n[n.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(f||(e.HeartbeatConstants=f={}));var A;(function(n){n[n.Panel=1]="Panel",n[n.Editor=2]="Editor"})(A||(e.TerminalLocation=A={}));var w;(function(n){n.TerminalView="view",n.Editor="editor"})(w||(e.TerminalLocationString=w={}));var a;(function(n){n[n.GraceTime=6e4]="GraceTime",n[n.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var d;(function(n){n[n.HighWatermarkChars=1e5]="HighWatermarkChars",n[n.LowWatermarkChars=5e3]="LowWatermarkChars",n[n.CharCountAckSize=5e3]="CharCountAckSize"})(d||(e.FlowControlConstants=d={}));var g;(function(n){n.GitBash="Git Bash",n.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var $;(function(n){n[n.Off=0]="Off",n[n.FinalTerm=1]="FinalTerm",n[n.VSCode=2]="VSCode"})($||(e.ShellIntegrationStatus=$={}));var i;(function(n){n[n.Unknown=0]="Unknown",n[n.Shutdown=1]="Shutdown",n[n.Process=2]="Process",n[n.User=3]="User",n[n.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$fs={Backend:"workbench.contributions.terminal.processBackend"};class o{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const c=this.b(t.remoteAuthority);if(this.a.has(c))throw new Error(`A terminal backend with remote authority '${c}' was already registered.`);this.a.set(c,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}P.$ko.add(e.$fs.Backend,new o),e.$gs=(0,r.$Ai)("localPtyService"),e.$hs=(0,r.$Ai)("terminalLogService")}),define(Ee[291],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bwb=void 0;class r{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,T,L=5){const R=T(p=>{const l=typeof p=="string"?p:p.data;let I=this.a.get(P);if(I){I.data.push(l);return}const D=setTimeout(()=>this.flushBuffer(P),L);I={data:[l],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(P),R.dispose()}},this.a.set(P,I)});return R}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const T=this.a.get(P);T&&(this.a.delete(P),this.b(P,T.data.join("")))}}e.$bwb=r}),define(Ee[292],Se([1,0,7,83,106,50,4,18,2,229,116,36]),function(oe,e,r,u,P,T,L,R,p,l,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wx=e.$vx=e.$ux=e.$tx=e.$sx=e.$rx=e.IconFontDefinition=e.IconContribution=e.$ox=void 0,e.$px=d,e.$qx=g,e.$ox={IconContribution:"base.contributions.icons"};var f;(function(n){function t(c,h){let s=c.defaults;for(;T.ThemeIcon.isThemeIcon(s);){const m=a.getIcon(s.id);if(!m)return;s=m.defaults}return s}n.getDefinition=t})(f||(e.IconContribution=f={}));var A;(function(n){function t(h){return{weight:h.weight,style:h.style,src:h.src.map(s=>({format:s.format,location:s.location.toString()}))}}n.toJSONObject=t;function c(h){const s=m=>(0,R.$ag)(m)?m:void 0;if(h&&Array.isArray(h.src)&&h.src.every(m=>(0,R.$ag)(m.format)&&(0,R.$ag)(m.location)))return{weight:s(h.weight),style:s(h.style),src:h.src.map(m=>({format:m.format,location:p.URI.parse(m.location)}))}}n.fromJSONObject=c})(A||(e.IconFontDefinition=A={}));class w{constructor(){this.a=new L.$he,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,l.localize)(0,null)},fontCharacter:{type:"string",description:(0,l.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${T.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(t,c,h,s){const m=this.b[t];if(m){if(h&&!m.description){m.description=h,this.d.properties[t].markdownDescription=`${h} $(${t})`;const E=this.e.enum.indexOf(t);E!==-1&&(this.e.enumDescriptions[E]=h),this.a.fire()}return m}const y={id:t,description:h,defaults:c,deprecationMessage:s};this.b[t]=y;const S={$ref:"#/definitions/icons"};return s&&(S.deprecationMessage=s),h&&(S.markdownDescription=`${h}: $(${t})`),this.d.properties[t]=S,this.e.enum.push(t),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:t}}deregisterIcon(t){delete this.b[t],delete this.d.properties[t];const c=this.e.enum.indexOf(t);c!==-1&&(this.e.enum.splice(c,1),this.e.enumDescriptions.splice(c,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(t=>this.b[t])}getIcon(t){return this.b[t]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(t,c){const h=this.f[t];return h||(this.f[t]=c,this.a.fire(),c)}deregisterIconFont(t){delete this.f[t]}getIconFont(t){return this.f[t]}toString(){const t=(m,y)=>m.id.localeCompare(y.id),c=m=>{for(;T.ThemeIcon.isThemeIcon(m.defaults);)m=this.b[m.defaults.id];return`codicon codicon-${m?m.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(m=>this.b[m]);for(const m of s.filter(y=>!!y.description).sort(t))h.push(`|<i class="${c(m)}"></i>|${m.id}|${T.ThemeIcon.isThemeIcon(m.defaults)?m.defaults.id:m.id}|${m.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const m of s.filter(y=>!T.ThemeIcon.isThemeIcon(y.defaults)).sort(t))h.push(`|<i class="${c(m)}"></i>|${m.id}|`);return h.join(`
`)}}const a=new w;D.$ko.add(e.$ox.IconContribution,a);function d(n,t,c,h){return a.registerIcon(n,t,c,h)}function g(){return a}function $(){const n=(0,P.$Vj)();for(const t in n){const c="\\"+n[t].toString(16);a.registerIcon(t,{fontCharacter:c})}}$(),e.$rx="vscode://schemas/icons";const i=D.$ko.as(I.$lo.JSONContribution);i.registerSchema(e.$rx,a.getIconSchema());const o=new r.$Mh(()=>i.notifySchemaChanged(e.$rx),200);a.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$sx=d("widget-close",u.$Zj.close,(0,l.localize)(2,null)),e.$tx=d("goto-previous-location",u.$Zj.arrowUp,(0,l.localize)(3,null)),e.$ux=d("goto-next-location",u.$Zj.arrowDown,(0,l.localize)(4,null)),e.$vx=T.ThemeIcon.modify(u.$Zj.sync,"spin"),e.$wx=T.ThemeIcon.modify(u.$Zj.loading,"spin")}),define(Ee[93],Se([1,0,4,11,2,45,5,12]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=e.$Cw=e.$zw=e.$xw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$tw=e.$sw=void 0,e.$uw=I,e.$vw=f,e.$ww=A,e.$yw=w,e.$Aw=a,e.$Bw=d,e.$sw=(0,L.$Ai)("tunnelService"),e.$tw=(0,L.$Ai)("sharedTunnelsService");var p;(function(i){i.Http="http",i.Https="https"})(p||(e.TunnelProtocol=p={}));var l;(function(i){i.ConstantPrivate="constantPrivate",i.Private="private",i.Public="public"})(l||(e.TunnelPrivacyId=l={}));function I(i){return!!i.forwardPort}var D;(function(i){i[i.Notify=1]="Notify",i[i.OpenBrowser=2]="OpenBrowser",i[i.OpenPreview=3]="OpenPreview",i[i.Silent=4]="Silent",i[i.Ignore=5]="Ignore",i[i.OpenBrowserOnce=6]="OpenBrowserOnce"})(D||(e.ProvidedOnAutoForward=D={}));function f(i){if(i.scheme!=="http"&&i.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(i.authority);if(o)return{address:o[1],port:+o[2]}}function A(i){if(i.scheme!=="http"&&i.scheme!=="https"||!i.query)return;const o=i.query.split("&");for(const n of o){const t=n.split("=")[1];if(/^https?:/.exec(t)){const c=f(P.URI.parse(t));if(c)return c}}}e.$xw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(i){return e.$xw.indexOf(i)>=0}e.$zw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function a(i){return e.$zw.indexOf(i)>=0}function d(i,o,n,t){if(n===u.OperatingSystem.Windows)return!1;if(n===u.OperatingSystem.Macintosh&&a(o)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(t);if(c?.length===4&&parseInt(c[1])>=18)return!1}return i<1024}class g{constructor(o,n,t){this.remoteAddress=o,this.localAddress=n,this.b=t,this.a=new r.$he,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Cw=g;let $=class{constructor(o,n){this.k=o,this.l=n,this.a=new r.$he,this.onTunnelOpened=this.a.event,this.b=new r.$he,this.onTunnelClosed=this.b.event,this.c=new r.$he,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const o=this.l.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.i=o.privacyOptions,this.h=o.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const o=[],n=Array.from(this.e.values());for(const t of n){const c=Array.from(t.values());for(const h of c){const s=await h.value;s&&typeof s!="string"&&o.push(s)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:n}of o.values())await n.then(t=>typeof t!="string"?t?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,n,t,c,h){this.q(o,n,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:n,localAddress:t,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,n){(a(o)||w(o))&&(o=e.$xw[0]);const t=this.s(o,n);if(t)return++t.refcount,t.value}openTunnel(o,n,t,c,h,s=!1,m,y){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${t} on local port ${h}.`);const S=this.f??o;if(!S)return;if(n||(n="localhost"),c||(c=this.m),this.f&&this.j.has(t)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const E=this.t(S,n,t,c,h,s,m,y);return E?E.then(k=>{if(k){if(typeof k=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,t),k}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,t);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const C=this.o(k);return(k.tunnelRemoteHost!==n||k.tunnelRemotePort!==t)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),m&&k.privacy!==m&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(C),C}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),E)}o(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const n=this.e.get(o.tunnelRemoteHost);if(n){const t=n.get(o.tunnelRemotePort);t&&(t.refcount--,await this.p(o.tunnelRemoteHost,o.tunnelRemotePort,t))}}}}async p(o,n,t){if(t.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${n}.`);const c=t.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(n),c}}async closeTunnel(o,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${n} `);const t=this.e.get(o);if(t&&t.has(n)){const c=t.get(n);c.refcount=0,await this.p(o,n,c)}}q(o,n,t){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(n,{refcount:1,value:t})}async r(o,n){const t=this.e.get(o);if(t){const c=t.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&t.delete(n),t.size===0&&this.e.delete(o)}}s(o,n){const t=[o];w(o)?(t.push(...e.$xw),t.push(...e.$zw)):a(o)&&t.push(...e.$zw);const c=t.map(h=>this.e.get(h));for(const h of c){const s=h?.get(n);if(s)return s}}canTunnel(o){return!!f(o)}u(o,n,t,c,h,s,m){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${t} on local port ${c}.`);const y=t;this.j.add(y);const S=c===void 0?t:c,E={elevationRequired:h?this.isPortPrivileged(S):!1},k={remoteAddress:{host:n,port:t},localAddressPort:c,privacy:s,public:s?s!==l.Private:void 0,protocol:m},C=o.forwardPort(k,E);return C?(this.q(n,t,C),C.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(y)})):this.j.delete(y),C}};e.$Dw=$,e.$Dw=$=Ze([Ve(0,R.$7j),Ve(1,T.$7i)],$)}),define(Ee[293],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,r.$Ai)("IUriIdentityService")}),define(Ee[294],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Ew=void 0,e.$Ew=(0,r.$Ai)("editSessionIdentityService");var u;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(u||(e.EditSessionIdentityMatch=u={}))}),define(Ee[295],Se([1,0,15]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=u,e.$6L=P,e.$7L=T,e.$8L=L,e.$9L=R;function u(p){return p.scheme!==r.Schemas.file&&p.scheme!==r.Schemas.vscodeRemote}function P(p){if(p.folders.length)return p.folders.every(l=>u(l.uri))?p.folders[0].uri:void 0;if(p.configuration&&u(p.configuration))return p.configuration}function T(p){return P(p)?.scheme}function L(p){return P(p)?.authority}function R(p){return P(p)!==void 0}}),define(Ee[46],Se([1,0,231,16,85,23,2,5,15]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=l,e.$Li=I,e.$Oi=D,e.$Pi=f,e.$Qi=A,e.$Ri=a,e.$Si=d,e.$Vi=i,e.$1i=o,e.$2i=n,e.$4i=t,e.$5i=c,e.$6i=h,e.$Ji=(0,R.$Ai)("contextService");function l(s){const m=s;return typeof m?.id=="string"&&L.URI.isUri(m.uri)}function I(s){return typeof s?.id=="string"&&!l(s)&&!f(s)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function D(s,m){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,u.$nc)(s)}:m?e.$Mi:e.$Ni;const y=s;return y.configuration?{id:y.id,configPath:y.configuration}:y.folders.length===1?{id:y.id,uri:y.folders[0].uri}:{id:y.id}}function f(s){const m=s;return typeof m?.id=="string"&&L.URI.isUri(m.configPath)}function A(s){const m=s;if(m?.uri)return{id:m.id,uri:L.URI.revive(m.uri)};const y=s;if(y?.configPath)return{id:y.id,configPath:L.URI.revive(y.configPath)};if(s?.id)return{id:s.id}}var w;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(w||(e.WorkbenchState=w={}));function a(s){const m=s;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}function d(s){const m=s;return!!(m&&typeof m=="object"&&L.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}class g{constructor(m,y,S,E,k){this.h=m,this.j=S,this.k=E,this.l=k,this.c=P.$Gi.forUris(this.l,()=>!0),this.folders=y}update(m){this.h=m.id,this.k=m.configuration,this.j=m.transient,this.l=m.l,this.folders=m.folders}get folders(){return this.g}set folders(m){this.g=m,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(m){this.k=m}getFolder(m){return m&&this.c.findSubstr(m)||null}n(){this.c=P.$Gi.forUris(this.l,()=>!0);for(const m of this.folders)this.c.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=g;class ${constructor(m,y){this.raw=y,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,T.$bh)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=$;function i(s){return new $({uri:s,index:0,name:(0,T.$0g)(s)},{uri:s.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,r.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function o(s,m){return T.$5g.isEqualOrParent(s,m.untitledWorkspacesHome)}function n(s){let m;return L.URI.isUri(s)?m=s:m=s.configuration,m?.scheme===p.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$3i}function c(s,m){return!o(s,m)&&!n(s)}function h(s){return(typeof s=="string"?(0,u.$oc)(s):(0,T.$_g)(s))===e.$Xi}}),define(Ee[150],Se([1,0,61,4,3,23,2,230,144,28,5,12,46,29,293,7,33,13,18]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=o,e.$Hl=n,e.$Il=t;var i;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function o(s){const m=s;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&typeof m.isDefault=="boolean"&&typeof m.name=="string"&&L.URI.isUri(m.location)&&L.URI.isUri(m.globalStorageHome)&&L.URI.isUri(m.settingsResource)&&L.URI.isUri(m.keybindingsResource)&&L.URI.isUri(m.tasksResource)&&L.URI.isUri(m.snippetsHome)&&L.URI.isUri(m.extensionsResource))}e.$Gl=(0,I.$Ai)("IUserDataProfilesService");function n(s,m){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:L.URI.revive(s.location).with({scheme:m}),globalStorageHome:L.URI.revive(s.globalStorageHome).with({scheme:m}),settingsResource:L.URI.revive(s.settingsResource).with({scheme:m}),keybindingsResource:L.URI.revive(s.keybindingsResource).with({scheme:m}),tasksResource:L.URI.revive(s.tasksResource).with({scheme:m}),snippetsHome:L.URI.revive(s.snippetsHome).with({scheme:m}),extensionsResource:L.URI.revive(s.extensionsResource).with({scheme:m}),cacheHome:L.URI.revive(s.cacheHome).with({scheme:m}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function t(s,m,y,S,E,k){return{id:s,name:m,location:y,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:k&&E?.useDefaultFlags?.globalState?k.globalStorageHome:(0,T.$bh)(y,"globalStorage"),settingsResource:k&&E?.useDefaultFlags?.settings?k.settingsResource:(0,T.$bh)(y,"settings.json"),keybindingsResource:k&&E?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,T.$bh)(y,"keybindings.json"),tasksResource:k&&E?.useDefaultFlags?.tasks?k.tasksResource:(0,T.$bh)(y,"tasks.json"),snippetsHome:k&&E?.useDefaultFlags?.snippets?k.snippetsHome:(0,T.$bh)(y,"snippets"),extensionsResource:k&&E?.useDefaultFlags?.extensions?k.extensionsResource:(0,T.$bh)(y,"extensions.json"),cacheHome:(0,T.$bh)(S,s),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}let c=class extends P.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(m,y,S,E){super(),this.t=m,this.u=y,this.w=S,this.y=E,this.f=!0,this.h=this.B(new u.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new u.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new u.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new u.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new A.$Ac,emptyWindows:new Map},this.profilesHome=(0,T.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,T.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(m){this.f!==m&&(this.z=void 0,this.f=m)}isEnabled(){return this.f}get C(){if(!this.z){const m=this.D(),y=[m];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,$.$ag)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}y.push(t((0,T.$$g)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},m))}}catch(k){this.y.error(k)}const S=new A.$Ac,E=new Map;if(y.length)try{const k=this.Q();if(k.workspaces)for(const[C,v]of Object.entries(k.workspaces)){const b=L.URI.parse(C),O=y.find(U=>U.id===v);O&&S.set(b,O)}if(k.emptyWindows)for(const[C,v]of Object.entries(k.emptyWindows)){const b=y.find(O=>O.id===v);b&&E.set(C,b)}}catch(k){this.y.error(k)}this.z={profiles:y,workspaces:S,emptyWindows:E}}return this.z}D(){const m=t("__default__profile__",(0,R.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...m,extensionsResource:this.S()??m.extensionsResource,isDefault:!0}}async createTransientProfile(m){const y="Temp",S=new RegExp(`${(0,g.$df)(y)}\\s(\\d+)`);let E=0;for(const C of this.profiles){const v=S.exec(C.name),b=v?parseInt(v[1]):0;E=b>E?b:E}const k=`${y} ${E+1}`;return this.createProfile((0,r.$oj)((0,d.$Wg)()).toString(16),k,{transient:!0},m)}async createNamedProfile(m,y,S){return this.createProfile((0,r.$oj)((0,d.$Wg)()).toString(16),m,y,S)}async createProfile(m,y,S,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(m,y,S);return E&&await this.setProfileForWorkspace(E,k),k}async F(m,y,S){if(!(0,$.$ag)(y)||!y)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(y);return E||(E=(async()=>{try{if(this.profiles.find(b=>b.name===y||b.id===m))throw new Error(`Profile with ${y} name already exists`);const C=t(m,y,(0,T.$bh)(this.profilesHome,m),this.g,S,this.defaultProfile);await this.u.createFolder(C.location);const v=[];return this.j.fire({profile:C,join(b){v.push(b)}}),await a.Promises.settled(v),this.I([C],[],[]),C}finally{this.r.delete(y)}})(),this.r.set(y,E)),E}async updateProfile(m,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(E=>E.id===m.id);if(!S)throw new Error(`Profile '${m.name}' does not exist`);return S=t(S.id,y.name??S.name,S.location,this.g,{shortName:y.shortName??S.shortName,icon:y.icon===null?void 0:y.icon??S.icon,transient:y.transient??S.isTransient,useDefaultFlags:y.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(m){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(m.isDefault)throw new Error("Cannot remove default profile");const y=this.profiles.find(E=>E.id===m.id);if(!y)throw new Error(`Profile '${m.name}' does not exist`);const S=[];this.m.fire({profile:y,join(E){S.push(E)}});try{await Promise.allSettled(S)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])y.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])y.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[y],[]);try{await this.u.del(y.cacheHome,{recursive:!0})}catch(E){(0,l.$ll)(E)!==l.FileOperationResult.FILE_NOT_FOUND&&this.y.error(E)}}async setProfileForWorkspace(m,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(E=>E.id===y.id);if(!S)throw new Error(`Profile '${y.name}' does not exist`);this.L(m,S)}unsetWorkspace(m,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(m,void 0,y)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const m=await this.u.resolve(this.profilesHome);await Promise.all((m.children||[]).filter(y=>y.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,y.resource))).map(y=>this.u.del(y.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const m=this.s.profiles.filter(y=>!this.H(y));await Promise.allSettled(m.map(y=>this.removeProfile(y)))}getProfileForWorkspace(m){const y=this.G(m);return L.URI.isUri(y)?this.s.workspaces.get(y)??this.C.workspaces.get(y):this.s.emptyWindows.get(y)??this.C.emptyWindows.get(y)}G(m){return(0,f.$Ki)(m)?m.uri:(0,f.$Pi)(m)?m.configPath:m.id}H(m){return!!([...this.s.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,m.location))||[...this.s.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,m.location))||[...this.C.emptyWindows.values()].some(y=>this.w.extUri.isEqual(y.location,m.location))||[...this.C.workspaces.values()].some(y=>this.w.extUri.isEqual(y.location,m.location)))}I(m,y,S){const E=[...this.profiles,...m],k=[];this.s.profiles=[];for(let C of E)C.isDefault||y.some(v=>C.id===v.id)||(C=S.find(v=>C.id===v.id)??C,C.isTransient?this.s.profiles.push(C):k.push({location:C.location,name:C.name,shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags}));this.P(k),this.z=void 0,this.J(m,y,S)}J(m,y,S){this.h.fire({added:m,removed:y,updated:S,all:this.profiles})}L(m,y,S){S=y?.isTransient?!0:S,S||this.L(m,void 0,!0);const E=this.G(m),k=S?this.s:this.C;L.URI.isUri(E)?(k.workspaces.delete(E),y&&k.workspaces.set(E,y)):(k.emptyWindows.delete(E),y&&k.emptyWindows.set(E,y)),S||this.M()}M(){const m={};for(const[S,E]of this.C.workspaces.entries())m[S.toString()]=E.id;const y={};for(const[S,E]of this.C.emptyWindows.entries())y[S.toString()]=E.id;this.R({workspaces:m,emptyWindows:y}),this.z=void 0}N(m){const y={},S=this.D();if(m.workspaces)for(const[k,C]of Object.entries(m.workspaces)){const v=L.URI.parse(C);y[k]=this.w.extUri.isEqual(v,S.location)?S.id:this.w.extUri.basename(v)}const E={};if(m.emptyWindows)for(const[k,C]of Object.entries(m.emptyWindows)){const v=L.URI.parse(C);E[k]=this.w.extUri.isEqual(v,S.location)?S.id:this.w.extUri.basename(v)}return{workspaces:y,emptyWindows:E}}O(){return[]}P(m){throw new Error("not implemented")}Q(){return{}}R(m){throw new Error("not implemented")}S(){}};e.$Jl=c,c.b="userDataProfiles",c.c="profileAssociations",e.$Jl=c=Ze([Ve(0,p.$Hi),Ve(1,l.$7k),Ve(2,w.$El),Ve(3,D.$7j)],c);class h extends c{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(m){this.a=m}Q(){return this.X}R(m){this.X=m}}e.$Kl=h}),define(Ee[151],Se([1,0,7,4,3,62,18,191,5,150]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$_p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$0p=e.$9p=e.$8p=void 0,e.$$p=A,e.$aq=a,e.$cq=g,e.$8p="__$__isNewStorageMarker",e.$9p="__$__targetStorageMarker",e.$0p=(0,p.$Ai)("storageService");var I;(function($){$[$.NONE=0]="NONE",$[$.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var D;(function($){$[$.APPLICATION=-1]="APPLICATION",$[$.PROFILE=0]="PROFILE",$[$.WORKSPACE=1]="WORKSPACE"})(D||(e.StorageScope=D={}));var f;(function($){$[$.USER=0]="USER",$[$.MACHINE=1]="MACHINE"})(f||(e.StorageTarget=f={}));function A($){const i=$.get(e.$9p);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class w extends P.$Uc{constructor(i={flushInterval:w.a}){super(),this.m=i,this.b=this.B(new u.$ke),this.c=this.B(new u.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new u.$he),this.onWillSaveState=this.f.event,this.h=this.B(new r.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,o,n){return u.Event.filter(this.b.event,t=>t.scope===i&&(o===void 0||t.key===o),n)}n(){this.j.value=(0,r.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.O()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,o){const{key:n,external:t}=o;if(n===e.$9p){switch(i){case D.APPLICATION:this.H=void 0;break;case D.PROFILE:this.F=void 0;break;case D.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:n,target:this.J(i)[n],external:t})}w(i){this.f.fire({reason:i})}get(i,o,n){return this.P(o)?.get(i,n)}getBoolean(i,o,n){return this.P(o)?.getBoolean(i,n)}getNumber(i,o,n){return this.P(o)?.getNumber(i,n)}getObject(i,o,n){return this.P(o)?.getObject(i,n)}storeAll(i,o){this.y(()=>{for(const n of i)this.store(n.key,n.value,n.scope,n.target,o)})}store(i,o,n,t,c=!1){if((0,L.$jg)(o)){this.remove(i,n,c);return}this.y(()=>{this.z(i,n,t),this.P(n)?.set(i,o,c)})}remove(i,o,n=!1){this.y(()=>{this.z(i,o,void 0),this.P(o)?.delete(i,n)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,o){const n=[],t=this.J(i);for(const c of Object.keys(t))t[c]===o&&n.push(c);return n}z(i,o,n,t=!1){const c=this.J(o);typeof n=="number"?c[i]!==n&&(c[i]=n,this.P(o)?.set(e.$9p,JSON.stringify(c),t)):typeof c[i]=="number"&&(delete c[i],this.P(o)?.set(e.$9p,JSON.stringify(c),t))}get D(){return this.C||(this.C=this.L(D.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(D.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(D.APPLICATION)),this.H}J(i){switch(i){case D.APPLICATION:return this.I;case D.PROFILE:return this.G;default:return this.D}}L(i){const o=this.P(i);return o?A(o):Object.create(null)}isNew(i){return this.getBoolean(e.$8p,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const o=this.P(D.APPLICATION),n=this.P(D.PROFILE),t=this.P(D.WORKSPACE);switch(i){case I.NONE:await r.Promises.settled([o?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await r.Promises.settled([o?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(D.APPLICATION)?.items??new Map,o=this.P(D.PROFILE)?.items??new Map,n=this.P(D.WORKSPACE)?.items??new Map;return g(i,o,n,this.Q(D.APPLICATION)??"",this.Q(D.PROFILE)??"",this.Q(D.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,o){return this.w(I.NONE),(0,l.$Fl)(i)?this.R(i,o):this.S(i,o)}M(i,o){return!(i.id===o.id||a(o)&&a(i))}N(i,o,n){this.y(()=>{const t=new Set;for(const[c,h]of i)t.add(c),o.get(c)!==h&&this.u(n,{key:c,external:!0});for(const[c]of o.items)t.has(c)||this.u(n,{key:c,external:!0})})}}e.$_p=w,w.a=60*1e3;function a($){return $.isDefault||!!$.useDefaultFlags?.globalState}class d extends w{constructor(){super(),this.U=this.B(new R.$6p(new R.$7p,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new R.$6p(new R.$7p,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new R.$6p(new R.$7p,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(D.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(D.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(D.APPLICATION,i)))}P(i){switch(i){case D.APPLICATION:return this.U;case D.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case D.APPLICATION:return"inMemory (application)";case D.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$bq=d;async function g($,i,o,n,t,c){const h=b=>{try{return JSON.parse(b)}catch{return b}},s=new Map,m=new Map;$.forEach((b,O)=>{s.set(O,b),m.set(O,h(b))});const y=new Map,S=new Map;i.forEach((b,O)=>{y.set(O,b),S.set(O,h(b))});const E=new Map,k=new Map;o.forEach((b,O)=>{E.set(O,b),k.set(O,h(b))}),console.group(n!==t?`Storage: Application (path: ${n})`:`Storage: Application & Profile (path: ${n}, default profile)`);const C=[];if(s.forEach((b,O)=>{C.push({key:O,value:b})}),console.table(C),console.groupEnd(),console.log(m),n!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const b=[];y.forEach((O,U)=>{b.push({key:U,value:O})}),console.table(b),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${c})`);const v=[];E.forEach((b,O)=>{v.push({key:O,value:b})}),console.table(v),console.groupEnd(),console.log(k)}}),define(Ee[118],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=void 0;class r{constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const T=this.c++;return this.b.set(T,P),this.e(),T}get(P,T){return this.b.has(P)?this.b.get(P)[T]:void 0}delete(P){this.b.delete(P),this.e()}e(){r.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Qmc=r,r.a=!1}),define(Ee[63],Se([1,0,15,23,28,5]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=e.$Vmc=void 0;class L{constructor(){this.a=new Set(Object.keys(r.Schemas)),this.b=new Map,this.extUri=new u.$3g(p=>{const l=this.b.get(p.scheme);return!(l===void 0||l&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,l){l===null?this.b.delete(p.scheme):this.b.set(p.scheme,l)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Vmc=L,e.$Wmc=(0,T.$Ai)("IExtHostFileSystemInfo")}),define(Ee[30],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=void 0,e.$dP=(0,r.$Ai)("IExtHostInitDataService")}),define(Ee[296],Se([1,0,236,12,277,30]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3oc=void 0;let L=class extends P.$oQ{constructor(p,l,I){const D=I.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",f=I.remote.isRemote?(0,r.localize)(0,null):p?(0,r.localize)(1,null):(0,r.localize)(2,null);super(l.createLogger(D,{name:f}))}};e.$3oc=L,e.$3oc=L=Ze([Ve(1,u.$8j),Ve(2,T.$dP)],L)}),define(Ee[297],Se([1,0,7]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=e.$Bnc=void 0;class u{constructor(L,R,p){this.h=new Map,this.a=L,this.b=R,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(l=>(this.f=l,this)),this.g=this.c.onDidChangeStorage(l=>{l.shared===this.b&&l.key===this.a&&(this.f=l.value)}),this.i=new r.$Mh(()=>{const l=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of l.values())I.complete()}catch(I){for(const D of l.values())D.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,R){let p=this.f[L];return typeof p>"u"&&(p=R),p}update(L,R){this.f[L]=R;const p=this.h.get(L);if(p!==void 0)return p.p;const l=new r.$Xh;return this.h.set(L,l),this.i.isScheduled()||this.i.schedule(),l.p}dispose(){this.g.dispose()}}e.$Bnc=u;class P extends u{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,R){super(L.identifier.value,!0,R),this.j=L}}e.$Cnc=P}),define(Ee[298],Se([1,0,4,2]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0;class P{constructor(L){this.c=L,this.a=new r.$he,this.onDidSaveNotebookDocument=this.a.event,this.b=new r.$he,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,R,p,l){const D=this.c.getNotebookDocument(u.URI.revive(L)).acceptModelChanged(R.value,p,l);this.b.fire(D)}$acceptDirtyStateChanged(L,R){this.c.getNotebookDocument(u.URI.revive(L)).acceptDirty(R)}$acceptModelSaved(L){const R=this.c.getNotebookDocument(u.URI.revive(L));this.a.fire(R.apiNotebook)}}e.$qoc=P}),define(Ee[20],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=void 0,e.$ZO=(0,r.$Ai)("IExtHostRpcService");class u{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$1O=u});var rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r},Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)};define(Ee[299],Se([1,0,24,4]),function(oe,e,r,u){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=void 0;class T{constructor(R,p){P.set(this,void 0),this.b=new u.$he,this.onDidChange=this.b.event,this.a=r.$Xm.toKey(R.identifier),rt(this,P,p,"f"),Ge(this,P,"f").onDidChangePassword(l=>{l.extensionId===this.a&&this.b.fire({key:l.key})})}get(R){return Ge(this,P,"f").get(this.a,R)}store(R,p){return Ge(this,P,"f").store(this.a,R,p)}delete(R){return Ge(this,P,"f").delete(this.a,R)}}e.$Lnc=T,P=new WeakMap}),define(Ee[72],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=void 0,e.$_mc=(0,r.$Ai)("IURITransformerService");class u{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$anc=u}),define(Ee[300],Se([1,0,119,412,413,67,2,12,414]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=I;const l=!1;function I(i,o,n,t,c,h){const s=h.environment.useHostProxy,m=typeof s=="boolean"?s:!h.remote.isRemote,y={resolveProxy:k=>i.resolveProxy(k),lookupProxyAuthorization:d.bind(void 0,t,c,o,{},h.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>f(o),addCertificatesV2:()=>A(o),log:t,getLogLevel:()=>{const k=t.getLevel();switch(k){case R.LogLevel.Trace:return p.LogLevel.Trace;case R.LogLevel.Debug:return p.LogLevel.Debug;case R.LogLevel.Info:return p.LogLevel.Info;case R.LogLevel.Warning:return p.LogLevel.Warning;case R.LogLevel.Error:return p.LogLevel.Error;case R.LogLevel.Off:return p.LogLevel.Off;default:return C(k)}function C(v){return t.error("Unknown log level",v),p.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:m,loadAdditionalCertificates:async()=>{const k=[];if(h.remote.isRemote&&k.push((0,p.loadSystemCertificates)({log:t})),m){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const C=i.loadCertificates();C.then(v=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",v.length)),k.push(C)}return(await Promise.all(k)).flat()},env:process.env},S=(0,p.createProxyResolver)(y),E=D(y,S);return a(n,E)}function D(i,o){return{http:Object.assign(r,(0,p.createHttpPatch)(i,r,o)),https:Object.assign(u,(0,p.createHttpPatch)(i,u,o)),net:Object.assign(T,(0,p.createNetPatch)(i,T)),tls:Object.assign(P,(0,p.createTlsPatch)(i,P))}}function f(i){const o=i.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",l)&&!!o.get("systemCertificates")}function A(i){const o=i.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",l)&&!!o.get("systemCertificates")}const w=new Map;function a(i,o){return i.getExtensionPathIndex().then(n=>{const t=globalThis._VSCODE_NODE_MODULES.module,c=t._load;t._load=function(s,m,y){if(s==="net")return o.net;if(s==="tls")return o.tls;if(s!=="http"&&s!=="https")return c.apply(this,arguments);const S=n.findSubstr(L.URI.file(m.filename));let E=w.get(S);if(E||w.set(S,E={}),!E[s]){const k=o[s];E[s]={...k}}return E[s]}})}async function d(i,o,n,t,c,h,s,m){const y=t[h];s&&(t[h]=s),i.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${s}`,`proxyAuthenticateCache:${y}`);const S=s||y,E=Array.isArray(S)?S:typeof S=="string"?[S]:[];if($(o,E,c),E.some(k=>/^(Negotiate|Kerberos)( |$)/i.test(k))&&!m.kerberosRequested)try{m.kerberosRequested=!0;const k=await new Promise((U,z)=>{oe(["kerberos"],U,z)}),C=new URL(h),v=n.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${C.hostname}`:`HTTP@${C.hostname}`);return i.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${v}`),"Negotiate "+await(await k.initializeClient(v)).step("")}catch(k){i.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",k)}}let g=!1;function $(i,o,n){g||!o.length||(g=!0,i.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:n?"remote":"local"}))}}),define(Ee[301],Se([1,0,139]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=P;function u(T){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:T,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function P(T){return new r.$En(u(T))}}),define(Ee[152],Se([1,0,246,18,2,3,5,36,28,15,51,210,44]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$5F=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$UF=e.EditorInputCapabilities=e.$TF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$KF=a,e.$LF=d,e.$MF=g,e.$NF=$,e.$OF=i,e.$PF=o,e.$QF=n,e.$RF=t,e.$SF=c,e.$VF=E,e.$WF=C,e.$XF=v,e.$YF=b,e.$ZF=O,e.$1F=U,e.$2F=z,e.$3F=j,e.$4F=W,e.$6F=x,e.$7F=ne,e.$8F=we,e.$9F=pe,e.$FF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$GF={id:"default",displayName:(0,r.localize)(0,null),providerDisplayName:(0,r.localize)(1,null)},e.$HF="workbench.editor.sidebysideEditor",e.$IF="workbench.editors.textDiffEditor",e.$JF="workbench.editors.binaryResourceDiffEditor";var A;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(A||(e.EditorPaneSelectionChangeReason=A={}));var w;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(w||(e.EditorPaneSelectionCompareResult=w={}));function a(ce){const K=ce;return!!K&&typeof K.getSelection=="function"&&!!K.onDidChangeSelection}function d(ce){const K=ce;return!!K&&typeof K.getScrollPosition=="function"&&typeof K.setScrollPosition=="function"&&!!K.onDidChangeScroll}function g(ce,K,de){for(const te of de.visibleEditorPanes)if(te.group.id===K&&ce.matches(te.input))return te.getViewState()}function $(ce){if(E(ce))return!1;const K=ce;return P.URI.isUri(K?.resource)}function i(ce){if(E(ce))return!1;const K=ce;return K?.original!==void 0&&K.modified!==void 0}function o(ce){if(E(ce))return!1;const K=ce;return!K||K.resources&&!Array.isArray(K.resources)?!1:!!K.resources||!!K.multiDiffSource}function n(ce){if(E(ce)||i(ce))return!1;const K=ce;return K?.primary!==void 0&&K.secondary!==void 0}function t(ce){if(E(ce))return!1;const K=ce;return K?K.resource===void 0||K.resource.scheme===l.Schemas.untitled||K.forceUntitled===!0:!1}function c(ce){if(E(ce))return!1;const K=ce;return P.URI.isUri(K?.base?.resource)&&P.URI.isUri(K?.input1?.resource)&&P.URI.isUri(K?.input2?.resource)&&P.URI.isUri(K?.result?.resource)}var h;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var s;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class m{constructor(){this.a=new Map}registerSource(K,de){let te=this.a.get(K);return te||(te={source:K,label:de},this.a.set(K,te)),te.source}getSourceLabel(K){return this.a.get(K)?.label??K}}e.$TF=new m;var y;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(y||(e.EditorInputCapabilities=y={}));class S extends T.$Uc{}e.$UF=S;function E(ce){return ce instanceof S}function k(ce){const K=ce;return P.URI.isUri(K?.preferredResource)}function C(ce){const K=ce;return E(K?.primary)&&E(K?.secondary)}function v(ce){const K=ce;return E(K?.modified)&&E(K?.original)}function b(ce,K,de,te,ee){return pe(te,[(0,D.$kj)({id:"workbench.action.openLargeFile",label:(0,r.localize)(2,null),run:()=>{const ie={...de,limits:{size:Number.MAX_VALUE}};ce.openEditor(K,ie)}}),(0,D.$kj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,r.localize)(3,null),run:()=>ee.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:f.default.Warning})}function O(ce){return E(ce?.editor)}function U(ce){const K=ce;return O(ce)&&K?.group!==void 0}function z(ce){const K=ce;return typeof K?.groupId=="number"&&E(K.editor)}function j(ce){return typeof ce?.groupId=="number"}var M;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(M||(e.EditorCloseContext=M={}));var N;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LABEL=2]="GROUP_LABEL",ce[ce.GROUP_LOCKED=3]="GROUP_LOCKED",ce[ce.EDITORS_SELECTION=4]="EDITORS_SELECTION",ce[ce.EDITOR_OPEN=5]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=6]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=7]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=9]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=11]="EDITOR_PIN",ce[ce.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",ce[ce.EDITOR_STICKY=13]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=14]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(N||(e.GroupModelChangeKind=N={}));var F;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class X{getOriginalUri(K,de){if(!K)return;if(c(K))return e.$5F.getOriginalUri(K.result,de);if(de?.supportSideBySide){const{primary:ee,secondary:ie}=this.a(K);if(ee&&ie){if(de?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(ee,{filterByScheme:de.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===F.ANY)return this.getOriginalUri(ee,{filterByScheme:de.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:de.filterByScheme});K=de.supportSideBySide===F.PRIMARY?ee:ie}}if(i(K)||o(K)||n(K)||c(K))return;const te=k(K)?K.preferredResource:K.resource;return!te||!de||!de.filterByScheme?te:this.b(te,de.filterByScheme)}a(K){return C(K)||n(K)?{primary:K.primary,secondary:K.secondary}:v(K)||i(K)?{primary:K.modified,secondary:K.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(K,de){if(!K)return;if(c(K))return e.$5F.getCanonicalUri(K.result,de);if(de?.supportSideBySide){const{primary:ee,secondary:ie}=this.a(K);if(ee&&ie){if(de?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(ee,{filterByScheme:de.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:de.filterByScheme})};if(de?.supportSideBySide===F.ANY)return this.getCanonicalUri(ee,{filterByScheme:de.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:de.filterByScheme});K=de.supportSideBySide===F.PRIMARY?ee:ie}}if(i(K)||o(K)||n(K)||c(K))return;const te=K.resource;return!te||!de||!de.filterByScheme?te:this.b(te,de.filterByScheme)}b(K,de){if(Array.isArray(de)){if(de.some(te=>K.scheme===te))return K}else if(de===K.scheme)return K}}var se;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(se||(e.EditorCloseMethod=se={}));function W(ce,K,de,te){if(!ce.isSticky(K))return!1;switch(te.preventPinnedEditorClose){case"keyboardAndMouse":return de===se.MOUSE||de===se.KEYBOARD;case"mouse":return de===se.MOUSE;case"keyboard":return de===se.KEYBOARD}return!1}e.$5F=new X;var H;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(H||(e.CloseDirection=H={}));class V{constructor(){this.c=new Map,this.d=new Map}start(K){const de=this.a=K.get(L.$zi);for(const[te,ee]of this.c)this.e(te,ee,de);this.c.clear()}e(K,de,te){const ee=te.createInstance(de);this.d.set(K,ee)}registerFileEditorFactory(K){if(this.b)throw new Error("Can only register one file editor factory.");this.b=K}getFileEditorFactory(){return(0,u.$lg)(this.b)}registerEditorSerializer(K,de){if(this.c.has(K)||this.d.has(K))throw new Error(`A editor serializer with type ID '${K}' was already registered.`);return this.a?this.e(K,de,this.a):this.c.set(K,de),(0,T.$Sc)(()=>{this.c.delete(K),this.d.delete(K)})}getEditorSerializer(K){return this.d.get(typeof K=="string"?K:K.typeId)}}R.$ko.add(e.$FF.EditorFactory,new V);async function x(ce,K,de){return!ce||!ce.length?[]:await Promise.all(ce.map(async te=>{const ee=P.URI.revive(te.fileUri);if(!ee){de.info("Cannot resolve the path because it is not valid.",te);return}if(!await K.canHandleResource(ee)){de.info("Cannot resolve the path because it cannot be handled",te);return}let le=te.exists,Z=te.type;if(typeof le!="boolean"||typeof Z!="number")try{Z=(await K.stat(ee)).isDirectory?p.FileType.Directory:p.FileType.Unknown,le=!0}catch($e){de.error($e),le=!1}if(!le&&te.openOnlyIfExists){de.info("Cannot resolve the path because it does not exist",te);return}if(Z===p.FileType.Directory){de.info("Cannot resolve the path because it is a directory",te);return}const ae={...te.options,pinned:!0};return le?{resource:ee,options:ae}:{resource:ee,options:ae,forceUntitled:!0}}))}var he;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(he||(e.EditorsOrder=he={}));function ne(ce){const K=ce;if(!K)return!1;const de=K;if(de.modified)return ne(de.modified);const te=K;return!!(te.contributionsState&&te.viewState&&Array.isArray(te.cursorState))}function we(ce){return(0,I.$mj)(ce)}function pe(ce,K,de){const te=(0,I.$nj)(ce,K);return te.forceMessage=de?.forceMessage,te.forceSeverity=de?.forceSeverity,te.allowDialog=de?.allowDialog,te}}),define(Ee[302],Se([1,0,4,247,5,3,29,36,25,83,292]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eG=e.$dG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$cG=e.ViewContentGroups=e.$aG=e.ViewContainerLocation=e.Extensions=e.$_F=e.$$F=e.$0F=void 0,e.$bG=A,e.$0F="views",e.$$F=(0,u.localize)(0,null),e.$_F=(0,I.$px)("default-view-icon",l.$Zj.window,(0,u.localize)(1,null));var D;(function(t){t.ViewContainersRegistry="workbench.registry.view.containers",t.ViewsRegistry="workbench.registry.view"})(D||(e.Extensions=D={}));var f;(function(t){t[t.Sidebar=0]="Sidebar",t[t.Panel=1]="Panel",t[t.AuxiliaryBar=2]="AuxiliaryBar"})(f||(e.ViewContainerLocation=f={})),e.$aG=[f.Sidebar,f.Panel,f.AuxiliaryBar];function A(t){switch(t){case f.Sidebar:return"sidebar";case f.Panel:return"panel";case f.AuxiliaryBar:return"auxiliarybar"}}class w extends T.$Uc{constructor(){super(...arguments),this.c=this.B(new r.$he),this.onDidRegister=this.c.event,this.f=this.B(new r.$he),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(c,h,s){const m=this.get(c.id);if(m)return m;const y=c;return y.openCommandActionDescriptor=s?.doNotRegisterOpenCommand?void 0:y.openCommandActionDescriptor??{id:y.id},(0,L.$xc)(this.g,h,[]).push(y),s?.isDefault&&this.h.push(y),this.c.fire({viewContainer:y,viewContainerLocation:h}),y}deregisterViewContainer(c){for(const h of this.g.keys()){const s=this.g.get(h),m=s?.indexOf(c);if(m!==-1){s?.splice(m,1),s.length===0&&this.g.delete(h),this.f.fire({viewContainer:c,viewContainerLocation:h});return}}}get(c){return this.all.filter(h=>h.id===c)[0]}getViewContainers(c){return[...this.g.get(c)||[]]}getViewContainerLocation(c){return[...this.g.keys()].filter(h=>this.getViewContainers(h).filter(s=>s?.id===c.id).length>0)[0]}getDefaultViewContainer(c){return this.h.find(h=>this.getViewContainerLocation(h)===c)}}R.$ko.add(D.ViewContainersRegistry,new w);var a;(function(t){t.Open="2_open",t.Debug="4_debug",t.SCM="5_scm",t.More="9_more"})(a||(e.ViewContentGroups=a={}));function d(t,c){const h=t.group??a.More,s=c.group??a.More;return h!==s?h.localeCompare(s):(t.order??5)-(c.order??5)}class g extends T.$Uc{constructor(){super(...arguments),this.c=this.B(new r.$he),this.onViewsRegistered=this.c.event,this.f=this.B(new r.$he),this.onViewsDeregistered=this.f.event,this.g=this.B(new r.$he),this.onDidChangeContainer=this.g.event,this.h=this.B(new r.$he),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Hc}registerViews(c,h){this.registerViews2([{views:c,viewContainer:h}])}registerViews2(c){c.forEach(({views:h,viewContainer:s})=>this.r(h,s)),this.c.fire(c)}deregisterViews(c,h){const s=this.s(c,h);s.length&&this.f.fire({views:s,viewContainer:h})}moveViews(c,h){for(const s of this.m.keys())if(s!==h){const m=this.s(c,s);m.length&&(this.r(m,h),this.g.fire({views:m,from:s,to:h}))}}getViews(c){return this.m.get(c)||[]}getView(c){for(const h of this.j){const s=(this.m.get(h)||[]).filter(m=>m.id===c)[0];if(s)return s}return null}getViewContainer(c){for(const h of this.j)if((this.m.get(h)||[]).filter(m=>m.id===c)[0])return h;return null}registerViewWelcomeContent(c,h){return this.n.add(c,h),this.h.fire(c),(0,T.$Sc)(()=>{this.n.delete(c,h),this.h.fire(c)})}registerViewWelcomeContent2(c,h){const s=new Map;for(const[m,y]of h)this.n.add(c,y),s.set(m,(0,T.$Sc)(()=>{this.n.delete(c,y),this.h.fire(c)}));return this.h.fire(c),s}getViewWelcomeContent(c){const h=[];return this.n.forEach(c,s=>h.push(s)),h.sort(d)}r(c,h){let s=this.m.get(h);s||(s=[],this.m.set(h,s),this.j.push(h));for(const m of c){if(this.getView(m.id)!==null)throw new Error((0,u.localize)(2,null,m.id));s.push(m)}}s(c,h){const s=this.m.get(h);if(!s)return[];const m=[],y=[];for(const S of s)c.includes(S)?m.push(S):y.push(S);return m.length&&(y.length?this.m.set(h,y):(this.m.delete(h),this.j.splice(this.j.indexOf(h),1))),m}}R.$ko.add(D.ViewsRegistry,new g),e.$cG=(0,P.$Ai)("viewDescriptorService");var $;(function(t){t[t.Default=0]="Default",t[t.Expand=1]="Expand"})($||(e.ViewVisibilityState=$={}));var i;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class o{constructor(c,h){this.c=!1,this.d=!1,(0,p.$ao)(this,c),this.d=!!h,this.resolve=async s=>{if(h&&!this.c){const m=await h(s);m&&(this.tooltip=this.tooltip??m.tooltip,this.command=this.command??m.command)}s.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$dG=o;class n extends Error{constructor(c){super((0,u.localize)(3,null,c)),this.name="NoTreeViewError"}static is(c){return c.name==="NoTreeViewError"}}e.$eG=n}),define(Ee[303],Se([1,0,248,35]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=void 0,e.$iG=new u.$Rj("chatSessionResponseVote","",{type:"string",description:(0,r.localize)(0,null)}),e.$jG=new u.$Rj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,r.localize)(1,null)}),e.$kG=new u.$Rj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,r.localize)(2,null)}),e.$lG=new u.$Rj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,r.localize)(3,null)}),e.$mG=new u.$Rj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,r.localize)(4,null)}),e.$nG=new u.$Rj("chatResponse",!1,{type:"boolean",description:(0,r.localize)(5,null)}),e.$oG=new u.$Rj("chatRequest",!1,{type:"boolean",description:(0,r.localize)(6,null)}),e.$pG=new u.$Rj("chatEditApplied",!1,{type:"boolean",description:(0,r.localize)(7,null)}),e.$qG=new u.$Rj("chatInputHasText",!1,{type:"boolean",description:(0,r.localize)(8,null)}),e.$rG=new u.$Rj("chatInputHasFocus",!1,{type:"boolean",description:(0,r.localize)(9,null)}),e.$sG=new u.$Rj("inChatInput",!1,{type:"boolean",description:(0,r.localize)(10,null)}),e.$tG=new u.$Rj("inChat",!1,{type:"boolean",description:(0,r.localize)(11,null)}),e.$uG=new u.$Rj("chatIsEnabled",!1,{type:"boolean",description:(0,r.localize)(12,null)}),e.$vG=new u.$Rj("chatCursorAtTop",!1),e.$wG=new u.$Rj("chatInputHasAgent",!1),e.$xG=new u.$Rj("chatLocation",void 0),e.$yG=new u.$Rj("quickChatHasFocus",!1,{type:"boolean",description:(0,r.localize)(13,null)})}),define(Ee[304],Se([1,0,132,7,21,4,40,3,55,180,13,35,24,5,12,115,285,151,303]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.ChatAgentLocation=void 0,e.$DH=h,e.$EH=s;var o;(function(m){m.Panel="panel",m.Terminal="terminal",m.Notebook="notebook",m.Editor="editor"})(o||(e.ChatAgentLocation=o={})),function(m){function y(S){switch(S){case"panel":return m.Panel;case"terminal":return m.Terminal;case"notebook":return m.Notebook;case"editor":return m.Editor}return m.Panel}m.fromRaw=y}(o||(e.ChatAgentLocation=o={})),e.$yH=(0,A.$Ai)("chatAgentService");let n=class{constructor(y){this.f=y,this.b=new Map,this.d=new T.$he,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=$.$uG.bindTo(this.f)}registerAgent(y,S){if(this.getAgent(y))throw new Error(`Agent already registered: ${JSON.stringify(y)}`);const k=this,C=S.slashCommands;S={...S,get slashCommands(){return C.filter(b=>!b.when||k.f.contextMatchesRules(D.$yj.deserialize(b.when)))}};const v={data:S};return this.b.set(y,v),(0,R.$Sc)(()=>{this.b.delete(y),this.d.fire(void 0)})}registerAgentImplementation(y,S){const E=this.b.get(y);if(!E)throw new Error(`Unknown agent: ${JSON.stringify(y)}`);if(E.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(y)}`);return E.data.isDefault&&this.e.set(!0),E.impl=S,this.d.fire(new t(E.data,S)),(0,R.$Sc)(()=>{E.impl=void 0,this.d.fire(void 0),E.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(y,S){y.isDynamic=!0;const E={data:y,impl:S};return this.b.set(y.id,E),this.d.fire(new t(y,S)),(0,R.$Sc)(()=>{this.b.delete(y.id),this.d.fire(void 0)})}registerAgentCompletionProvider(y,S){return this.g.set(y,S),{dispose:()=>{this.g.delete(y)}}}async getAgentCompletionItems(y,S,E){return await this.g.get(y)?.(S,E)??[]}updateAgent(y,S){const E=this.b.get(y);if(!E?.impl)throw new Error(`No activated agent with id ${JSON.stringify(y)} registered`);E.data.metadata={...E.data.metadata,...S},this.d.fire(new t(E.data,E.impl))}getDefaultAgent(y){return(0,r.$fb)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(y))}getContributedDefaultAgent(y){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(y))}getSecondaryAgent(){return L.Iterable.find(this.b.values(),y=>!!y.data.metadata.isSecondary)?.data}getAgent(y){if(this.h(y))return this.b.get(y)?.data}h(y){const S=this.b.get(y);return!S?.data.when||this.f.contextMatchesRules(D.$yj.deserialize(S.data.when))}getAgentByFullyQualifiedId(y){const S=L.Iterable.find(this.b.values(),E=>h(E.data)===y)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(y=>y.data).filter(y=>this.h(y.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(y=>!!y.impl).filter(y=>this.h(y.data.id)).map(y=>new t(y.data,y.impl))}getAgentsByName(y){return this.getAgents().filter(S=>S.name===y)}async invokeAgent(y,S,E,k,C){const v=this.b.get(y);if(!v?.impl)throw new Error(`No activated agent with id "${y}"`);return await v.impl.invoke(S,E,k,C)}async getFollowups(y,S,E,k,C){const v=this.b.get(y);if(!v?.impl)throw new Error(`No activated agent with id "${y}"`);return v.impl?.provideFollowups?v.impl.provideFollowups(S,E,k,C):[]}};e.$zH=n,n.AGENT_LEADER="@",e.$zH=n=Ze([Ve(0,D.$Sj)],n);class t{constructor(y,S){this.b=y,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(y,S,E,k){return this.d.invoke(y,S,E,k)}async provideFollowups(y,S,E,k){return this.d.provideFollowups?this.d.provideFollowups(y,S,E,k):[]}provideWelcomeMessage(y,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(y,S)}provideSampleQuestions(y,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(y,S)}}e.$AH=t,e.$BH=(0,A.$Ai)("chatAgentNameService");let c=i=class{constructor(y,S,E,k){if(this.g=S,this.h=E,this.i=k,this.e=(0,l.$3d)(this,Object.create(null)),this.f=!1,!y.chatParticipantRegistry)return;this.d=y.chatParticipantRegistry;const C=k.get(i.b,g.StorageScope.APPLICATION);try{this.e.set(JSON.parse(C??"{}"),void 0)}catch{k.remove(i.b,g.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(y=>this.h.warn("Failed to fetch chat participant registry",y)).then(()=>(0,u.$Bh)(5*60*1e3)).then(()=>this.j())}async k(){const y=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(y.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,d.$3p)(y);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const E=S.restrictedChatParticipants;this.e.set(E,void 0),this.i.store(i.b,JSON.stringify(E),g.StorageScope.APPLICATION,g.StorageTarget.MACHINE)}getAgentNameRestriction(y){const S=this.l(y.name,y).get(),E=!y.fullName||this.l(y.fullName.replace(/\s/g,""),y).get();return S&&E}l(y,S){return this.e.map(k=>k[y.toLowerCase()]).map(k=>k?k.some(C=>(0,I.$Bf)(C,C.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$CH=c,c.b="chat.participantNameRegistry",e.$CH=c=i=Ze([Ve(0,a.$nk),Ve(1,d.$Wp),Ve(2,w.$7j),Ve(3,g.$0p)],c);function h(m){return`${m.extensionId.value}.${m.id}`}function s(m){const y="name"in m?m:{...m,name:m.id};return"extensionPublisherId"in y||(y.extensionPublisherId=y.extensionPublisher??""),"extensionDisplayName"in y||(y.extensionDisplayName=""),"extensionId"in y||(y.extensionId=new f.$Xm("")),(0,p.$0h)(y)}}),define(Ee[305],Se([1,0,2,31,5]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=e.$9G=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$7G=T,e.$8G=L;function T(l){return!!l&&typeof l=="object"&&"uri"in l&&l.uri instanceof r.URI&&"version"in l&&typeof l.version=="number"&&"ranges"in l&&Array.isArray(l.ranges)&&l.ranges.every(u.$dt.isIRange)}function L(l){return!!l&&typeof l=="object"&&"documents"in l&&Array.isArray(l.documents)&&l.documents.every(T)}var R;(function(l){l[l.Down=0]="Down",l[l.Up=1]="Up"})(R||(e.ChatAgentVoteDirection=R={}));var p;(function(l){l[l.Action=1]="Action",l[l.Toolbar=2]="Toolbar"})(p||(e.ChatCopyKind=p={})),e.$9G=(0,P.$Ai)("IChatService"),e.$0G="accessibility.voice.keywordActivation"}),define(Ee[153],Se([1,0,4,7,250]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$osb=void 0;class T{constructor(){this.f=new Map,this.m=[],this.n=new r.$he,this.o=new r.$he,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(R){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=R}onEvent(R){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=R}onRequest(R){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=R}sendResponse(R){R.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${R.command}`)):this.u("response",R)}sendRequest(R,p,l,I){const D={command:R};if(p&&Object.keys(p).length>0&&(D.arguments=p),this.u("request",D),typeof I=="number"){const f=setTimeout(()=>{clearTimeout(f);const A=this.f.get(D.seq);if(A){this.f.delete(D.seq);const w={type:"response",seq:0,request_seq:D.seq,success:!1,command:R,message:(0,P.localize)(0,null,I,R)};A(w)}},I)}return l&&this.f.set(D.seq,l),D.seq}acceptMessage(R){this.k?this.k(R):(this.m.push(R),this.m.length===1&&this.s())}q(R,p){return R.type!=="event"||p.type!=="event"}async s(){let R;for(;this.m.length;){if((!R||this.q(this.m[0],R))&&await(0,u.$Bh)(0),R=this.m.shift(),!R)return;switch(R.type){case"event":this.j?.(R);break;case"request":this.g?.(R);break;case"response":{const p=R,l=this.f.get(p.request_seq);l&&(this.f.delete(p.request_seq),l(p));break}}}}u(R,p){p.type=R,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const R=new Map;this.f.forEach((p,l)=>R.set(l,p)),await(0,u.$Bh)(500),R.forEach((p,l)=>{p({type:"response",seq:0,request_seq:l,success:!1,command:"canceled",message:"canceled"}),this.f.delete(l)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$osb=T}),define(Ee[120],Se([1,0,2,251,35,5]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$UJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$SJ=e.MemoryRangeType=e.State=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=void 0,e.$RJ=p,e.$TJ=I,e.$FI="workbench.view.debug",e.$GI="workbench.debug.variablesView",e.$HI="workbench.debug.watchExpressionsView",e.$II="workbench.debug.callStackView",e.$JI="workbench.debug.loadedScriptsView",e.$KI="workbench.debug.breakPointsView",e.$LI="workbench.debug.disassemblyView",e.$MI="workbench.panel.repl",e.$NI="workbench.panel.repl.view",e.$OI=new P.$Rj("debugType",void 0,{type:"string",description:u.localize(0,null)}),e.$PI=new P.$Rj("debugConfigurationType",void 0,{type:"string",description:u.localize(1,null)}),e.$QI=new P.$Rj("debugState","inactive",{type:"string",description:u.localize(2,null)}),e.$RI="debugUx",e.$SI=new P.$Rj(e.$RI,"default",{type:"string",description:u.localize(3,null)}),e.$TI=new P.$Rj("hasDebugged",!1,{type:"boolean",description:u.localize(4,null)}),e.$UI=new P.$Rj("inDebugMode",!1,{type:"boolean",description:u.localize(5,null)}),e.$VI=new P.$Rj("inDebugRepl",!1,{type:"boolean",description:u.localize(6,null)}),e.$WI=new P.$Rj("breakpointWidgetVisible",!1,{type:"boolean",description:u.localize(7,null)}),e.$XI=new P.$Rj("inBreakpointWidget",!1,{type:"boolean",description:u.localize(8,null)}),e.$YI=new P.$Rj("breakpointsFocused",!0,{type:"boolean",description:u.localize(9,null)}),e.$ZI=new P.$Rj("watchExpressionsFocused",!0,{type:"boolean",description:u.localize(10,null)}),e.$1I=new P.$Rj("watchExpressionsExist",!1,{type:"boolean",description:u.localize(11,null)}),e.$2I=new P.$Rj("variablesFocused",!0,{type:"boolean",description:u.localize(12,null)}),e.$3I=new P.$Rj("expressionSelected",!1,{type:"boolean",description:u.localize(13,null)}),e.$4I=new P.$Rj("breakpointInputFocused",!1,{type:"boolean",description:u.localize(14,null)}),e.$5I=new P.$Rj("callStackItemType",void 0,{type:"string",description:u.localize(15,null)}),e.$6I=new P.$Rj("callStackSessionIsAttach",!1,{type:"boolean",description:u.localize(16,null)}),e.$7I=new P.$Rj("callStackItemStopped",!1,{type:"boolean",description:u.localize(17,null)}),e.$8I=new P.$Rj("callStackSessionHasOneThread",!1,{type:"boolean",description:u.localize(18,null)}),e.$9I=new P.$Rj("watchItemType",void 0,{type:"string",description:u.localize(19,null)}),e.$0I=new P.$Rj("canViewMemory",void 0,{type:"boolean",description:u.localize(20,null)}),e.$$I=new P.$Rj("breakpointItemType",void 0,{type:"string",description:u.localize(21,null)}),e.$_I=new P.$Rj("breakpointItemBytes",void 0,{type:"boolean",description:u.localize(22,null)}),e.$aJ=new P.$Rj("breakpointHasModes",!1,{type:"boolean",description:u.localize(23,null)}),e.$bJ=new P.$Rj("breakpointSupportsCondition",!1,{type:"boolean",description:u.localize(24,null)}),e.$cJ=new P.$Rj("loadedScriptsSupported",!1,{type:"boolean",description:u.localize(25,null)}),e.$dJ=new P.$Rj("loadedScriptsItemType",void 0,{type:"string",description:u.localize(26,null)}),e.$eJ=new P.$Rj("focusedSessionIsAttach",!1,{type:"boolean",description:u.localize(27,null)}),e.$fJ=new P.$Rj("focusedSessionIsNoDebug",!1,{type:"boolean",description:u.localize(28,null)}),e.$gJ=new P.$Rj("stepBackSupported",!1,{type:"boolean",description:u.localize(29,null)}),e.$hJ=new P.$Rj("restartFrameSupported",!1,{type:"boolean",description:u.localize(30,null)}),e.$iJ=new P.$Rj("stackFrameSupportsRestart",!1,{type:"boolean",description:u.localize(31,null)}),e.$jJ=new P.$Rj("jumpToCursorSupported",!1,{type:"boolean",description:u.localize(32,null)}),e.$kJ=new P.$Rj("stepIntoTargetsSupported",!1,{type:"boolean",description:u.localize(33,null)}),e.$lJ=new P.$Rj("breakpointsExist",!1,{type:"boolean",description:u.localize(34,null)}),e.$mJ=new P.$Rj("debuggersAvailable",!1,{type:"boolean",description:u.localize(35,null)}),e.$nJ=new P.$Rj("debugExtensionAvailable",!0,{type:"boolean",description:u.localize(36,null)}),e.$oJ=new P.$Rj("debugProtocolVariableMenuContext",void 0,{type:"string",description:u.localize(37,null)}),e.$pJ=new P.$Rj("debugSetVariableSupported",!1,{type:"boolean",description:u.localize(38,null)}),e.$qJ=new P.$Rj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:u.localize(39,null)}),e.$rJ=new P.$Rj("debugSetExpressionSupported",!1,{type:"boolean",description:u.localize(40,null)}),e.$sJ=new P.$Rj("breakWhenValueChangesSupported",!1,{type:"boolean",description:u.localize(41,null)}),e.$tJ=new P.$Rj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:u.localize(42,null)}),e.$uJ=new P.$Rj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:u.localize(43,null)}),e.$vJ=new P.$Rj("terminateDebuggeeSupported",!1,{type:"boolean",description:u.localize(44,null)}),e.$wJ=new P.$Rj("suspendDebuggeeSupported",!1,{type:"boolean",description:u.localize(45,null)}),e.$xJ=new P.$Rj("variableEvaluateNamePresent",!1,{type:"boolean",description:u.localize(46,null)}),e.$yJ=new P.$Rj("variableIsReadonly",!1,{type:"boolean",description:u.localize(47,null)}),e.$zJ=new P.$Rj("variableValue",!1,{type:"string",description:u.localize(48,null)}),e.$AJ=new P.$Rj("variableType",!1,{type:"string",description:u.localize(49,null)}),e.$BJ=new P.$Rj("variableInterfaces",!1,{type:"array",description:u.localize(50,null)}),e.$CJ=new P.$Rj("variableName",!1,{type:"string",description:u.localize(51,null)}),e.$DJ=new P.$Rj("variableLanguage",!1,{type:"string",description:u.localize(52,null)}),e.$EJ=new P.$Rj("variableExtensionId",!1,{type:"string",description:u.localize(53,null)}),e.$FJ=new P.$Rj("exceptionWidgetVisible",!1,{type:"boolean",description:u.localize(54,null)}),e.$GJ=new P.$Rj("multiSessionRepl",!1,{type:"boolean",description:u.localize(55,null)}),e.$HJ=new P.$Rj("multiSessionDebug",!1,{type:"boolean",description:u.localize(56,null)}),e.$IJ=new P.$Rj("disassembleRequestSupported",!1,{type:"boolean",description:u.localize(57,null)}),e.$JJ=new P.$Rj("disassemblyViewFocus",!1,{type:"boolean",description:u.localize(58,null)}),e.$KJ=new P.$Rj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:u.localize(59,null)}),e.$LJ=new P.$Rj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:u.localize(60,null)});const L=i=>u.localize(61,null,i);e.$MJ=L,e.$NJ="editor.contrib.debug",e.$OJ="editor.contrib.breakpoint",e.$PJ="debug",e.$QJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:u.localize(62,null)};var R;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(R||(e.State=R={}));function p(i){switch(i){case R.Initializing:return"initializing";case R.Stopped:return"stopped";case R.Running:return"running";default:return"inactive"}}var l;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(l||(e.MemoryRangeType=l={})),e.$SJ="vscode-debug-memory";function I(i){return i.source.presentationHint==="deemphasize"||i.presentationHint==="deemphasize"||i.presentationHint==="subtle"}var D;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(D||(e.DataBreakpointSetType=D={}));var f;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(f||(e.DebugConfigurationProviderTriggerKind=f={}));var A;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$UJ=(0,T.$Ai)("debugService");var w;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var a;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(a||(e.DebugVisualizationType=a={}));var d;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(d||(e.DebugTreeItemCollapsibleState=d={}));var g;(function(i){i.deserialize=o=>o,i.serialize=o=>o})(g||(e.IDebugVisualizationTreeItem=g={}));var $;(function(i){i.deserialize=o=>({id:o.id,name:o.name,iconPath:o.iconPath&&{light:r.URI.revive(o.iconPath.light),dark:r.URI.revive(o.iconPath.dark)},iconClass:o.iconClass,visualization:o.visualization}),i.serialize=o=>o})($||(e.IDebugVisualization=$={}))}),define(Ee[306],Se([1,0,13,2,16,25,15,31,21,19]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TH=void 0,e.$HH=D,e.$IH=f,e.$JH=A,e.$KH=w,e.$LH=a,e.$MH=d,e.$NH=g,e.$OH=i,e.$PH=t,e.$QH=c,e.$RH=s,e.$SH=y;const I=/{([^}]+)}/g;function D(E,k,C){return E.replace(I,function(v,b){return k&&b.length>0&&b[0]!=="_"?v:C&&C.hasOwnProperty(b)?C[b]:v})}function f(E){const k={};for(const C of Object.keys(E))C.startsWith("!")||(k[C]=E[C]);return k}function A(E){return E.configuration.request==="attach"&&!w(E)&&(!E.parentSession||A(E.parentSession))}function w(E){let k=E.configuration.type;if(k)return k==="vslsShare"&&(k=E.configuration.adapterProxy.configuration.type),(0,r.$Bf)(k,"extensionhost")||(0,r.$Bf)(k,"pwa-extensionhost")?E:E.parentSession?w(E.parentSession):void 0}function a(E){return E.type&&(E.label||E.program||E.runtime)}function d(E,k,C){let v,b=0;const O=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let U=null;for(;U=O.exec(E);){const z=U.index+1,j=z+U[0].length;if(z<=k&&j>=C){v=U[0],b=z;break}}if(v){const z=/\w+/g;let j=null;for(;(j=z.exec(v))&&!(j.index+1+b+j[0].length>=C););j&&(v=v.substring(0,z.lastIndex))}return v?{start:b,end:b+v.length-1}:{start:0,end:0}}async function g(E,k,C,v){if(E.evaluatableExpressionProvider.has(k)){const b=E.evaluatableExpressionProvider.ordered(k),O=(0,l.$Hb)(await Promise.all(b.map(async U=>{try{return await U.provideEvaluatableExpression(k,C,v??p.CancellationToken.None)}catch{return}})));if(O.length>0){let U=O[0].expression;const z=O[0].range;return U||(U=k.getLineContent(C.lineNumber).substring(z.startColumn-1,z.endColumn-1)),{range:z,matchingExpression:U}}}else{const b=k.getLineContent(C.lineNumber),{start:O,end:U}=d(b,C.column,C.column),z=b.substring(O-1,U);return{matchingExpression:z,range:new R.$dt(C.lineNumber,O,C.lineNumber,O+z.length)}}return null}const $=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(E){return!!(E&&E.match($))}function o(E){if(typeof E.path=="string"&&!(typeof E.sourceReference=="number"&&E.sourceReference>0)){if(i(E.path))return u.URI.parse(E.path);if((0,P.$ic)(E.path))return u.URI.file(E.path)}return E.path}function n(E){if(typeof E.path=="object"){const k=u.URI.revive(E.path);if(k)return k.scheme===L.Schemas.file?k.fsPath:k.toString()}return E.path}function t(E,k){const C=k?o:n,v=(0,T.$0n)(E);return h(v,(b,O)=>{b&&O&&(O.path=C(O))}),v}function c(E,k){const C=k?o:n,v=(0,T.$0n)(E);return h(v,(b,O)=>{!b&&O&&(O.path=C(O))}),v}function h(E,k){switch(E.type){case"event":{const C=E;switch(C.event){case"output":k(!1,C.body.source);break;case"loadedSource":k(!1,C.body.source);break;case"breakpoint":k(!1,C.body.breakpoint.source);break;default:break}break}case"request":{const C=E;switch(C.command){case"setBreakpoints":k(!0,C.arguments.source);break;case"breakpointLocations":k(!0,C.arguments.source);break;case"source":k(!0,C.arguments.source);break;case"gotoTargets":k(!0,C.arguments.source);break;case"launchVSCode":C.arguments.args.forEach(v=>k(!1,v));break;default:break}break}case"response":{const C=E;if(C.success&&C.body)switch(C.command){case"stackTrace":C.body.stackFrames.forEach(v=>k(!1,v.source));break;case"loadedSources":C.body.sources.forEach(v=>k(!1,v));break;case"scopes":C.body.scopes.forEach(v=>k(!1,v.source));break;case"setFunctionBreakpoints":C.body.breakpoints.forEach(v=>k(!1,v.source));break;case"setBreakpoints":C.body.breakpoints.forEach(v=>k(!1,v.source));break;case"disassemble":C.body?.instructions.forEach(b=>k(!1,b.location));break;default:break}break}}}function s(E){return E.filter(k=>!k.presentation?.hidden).sort((k,C)=>k.presentation?C.presentation?k.presentation.group?C.presentation.group?k.presentation.group!==C.presentation.group?k.presentation.group.localeCompare(C.presentation.group):m(k.presentation.order,C.presentation.order):-1:C.presentation.group?1:m(k.presentation.order,C.presentation.order):-1:C.presentation?1:0)}function m(E,k){return typeof E!="number"?typeof k!="number"?0:1:typeof k!="number"?-1:E-k}async function y(E,k){const C=E.getValue("debug.saveBeforeStart",{overrideIdentifier:k.activeTextEditorLanguageId});if(C!=="none"&&(await k.saveAll(),C==="allEditorsInActiveGroup")){const v=k.activeEditorPane;v&&v.input.resource?.scheme===L.Schemas.untitled&&await k.save({editor:v.input,groupId:v.group.id})}await E.reloadConfiguration()}const S=(E,k)=>!E||!k?E===k:E.name===k.name&&E.path===k.path&&E.sourceReference===k.sourceReference;e.$TH=S}),define(Ee[307],Se([1,0,57,67,25,16,11,13,34,252,153]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=e.$_oc=e.$$oc=e.$0oc=e.$9oc=void 0;class D extends I.$osb{constructor(){super(),this.p=Buffer.allocUnsafe(0),this.r=-1}t(g,$){this.l=$,this.p=Buffer.allocUnsafe(0),this.r=-1,g.on("data",i=>this.v(i))}sendMessage(g){if(this.l){const $=JSON.stringify(g);this.l.write(`Content-Length: ${Buffer.byteLength($,"utf8")}${D.a}${$}`,"utf8")}}v(g){for(this.p=Buffer.concat([this.p,g]);;){if(this.r>=0){if(this.p.length>=this.r){const $=this.p.toString("utf8",0,this.r);if(this.p=this.p.slice(this.r),this.r=-1,$.length>0)try{this.acceptMessage(JSON.parse($))}catch(i){this.n.fire(new Error((i.message||i)+`
`+$))}continue}}else{const $=this.p.indexOf(D.a);if($!==-1){const o=this.p.toString("utf8",0,$).split(D.b);for(const n of o){const t=n.split(D.i);t[0]==="Content-Length"&&(this.r=Number(t[1]))}this.p=this.p.slice($+D.a.length);continue}}break}}}e.$9oc=D,D.a=`\r
\r
`,D.b=/\r?\n/,D.i=/: */;class f extends D{startSession(){return new Promise((g,$)=>{let i=!1;this.x=this.y(()=>{this.t(this.x,this.x),g(),i=!0}),this.x.on("close",()=>{i?this.n.fire(new Error("connection closed")):$(new Error("connection closed"))}),this.x.on("error",o=>{i?this.n.fire(o):$(o)})})}async stopSession(){await this.w(),this.x&&(this.x.end(),this.x=void 0)}}e.$0oc=f;class A extends f{constructor(g){super(),this.z=g}y(g){return u.createConnection(this.z.port,this.z.host||"127.0.0.1",g)}}e.$$oc=A;class w extends f{constructor(g){super(),this.z=g}y(g){return u.createConnection(this.z.path,g)}}e.$_oc=w;class a extends D{constructor(g,$){super(),this.y=g,this.z=$}async startSession(){const g=this.y.command,$=this.y.args,i=this.y.options||{};try{if(g)if(T.$ic(g)){if(!await p.Promises.exists(g))throw new Error(l.localize(0,null,g))}else g.indexOf("/")<0&&g.indexOf("\\")<0;else throw new Error(l.localize(1,null,this.z));let o=process.env;if(i.env&&Object.keys(i.env).length>0&&(o=P.$ao(P.$0n(process.env),i.env)),g==="node")if(Array.isArray($)&&$.length>0){const n=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:n?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};i.cwd&&(t.cwd=i.cwd);const c=r.fork($[0],$.slice(1),t);if(!c.pid)throw new Error(l.localize(2,null,$[0]));this.x=c}else throw new Error(l.localize(3,null));else{const n={env:o};i.cwd&&(n.cwd=i.cwd),this.x=r.spawn(g,$,n)}this.x.on("error",n=>{this.n.fire(n)}),this.x.on("exit",(n,t)=>{this.o.fire(n)}),this.x.stdout.on("close",()=>{this.n.fire(new Error("read error"))}),this.x.stdout.on("error",n=>{this.n.fire(n)}),this.x.stdin.on("error",n=>{this.n.fire(n)}),this.x.stderr.resume(),this.t(this.x.stdout,this.x.stdin)}catch(o){this.n.fire(o)}}async stopSession(){return this.x?(await this.w(),L.$c?new Promise((g,$)=>{const i=r.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,n,t){if(o)return $(o)});i.on("exit",g),i.on("error",$)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(g,$){if(!g)return;const i=Object.create(null);g.runtime&&(g.runtime.indexOf("./")===0?i.runtime=T.$jc($,g.runtime):i.runtime=g.runtime),g.runtimeArgs&&(i.runtimeArgs=g.runtimeArgs),g.program&&(T.$ic(g.program)?i.program=g.program:i.program=T.$jc($,g.program)),g.args&&(i.args=g.args);const o=g;return o.win&&(i.win=a.A(o.win,$)),o.winx86&&(i.winx86=a.A(o.winx86,$)),o.windows&&(i.windows=a.A(o.windows,$)),o.osx&&(i.osx=a.A(o.osx,$)),o.linux&&(i.linux=a.A(o.linux,$)),i}static platformAdapterExecutable(g,$){let i=Object.create(null);$=$.toLowerCase();for(const s of g)if(s.contributes){const m=s.contributes.debuggers;m&&m.length>0&&m.filter(y=>typeof y.type=="string"&&R.$Bf(y.type,$)).forEach(y=>{const S=a.A(y,s.extensionLocation.fsPath);i=P.$ao(i,S,s.isBuiltin)})}let o;L.$c&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=i.winx86||i.win||i.windows:L.$c?o=i.win||i.windows:L.$d?o=i.osx:L.$e&&(o=i.linux),o=o||i;const n=o.program||i.program,t=o.args||i.args,c=o.runtime||i.runtime,h=o.runtimeArgs||i.runtimeArgs;if(c)return{type:"executable",command:c,args:(h||[]).concat(typeof n=="string"?[n]:[]).concat(t||[])};if(n)return{type:"executable",command:n,args:t||[]}}}e.$apc=a}),define(Ee[308],Se([1,0,57,32,11]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bpc=L,e.$cpc=p;function T(l,I){return new Promise((D,f)=>{let A="";const w=r.spawn(l,I);w.pid&&w.stdout.on("data",a=>{A+=a.toString()}),w.on("error",a=>{f(a)}),w.on("close",a=>{D(A)})})}async function L(l){if(l)if(P.$c){const I=await new Promise((D,f)=>{oe(["@vscode/windows-process-tree"],D,f)});return new Promise(D=>{I.getProcessTree(l,f=>{D(!!f&&f.children.length>0)})})}else return T("/usr/bin/pgrep",["-lP",String(l)]).then(I=>{const D=I.trim();return!(D.length===0||D.indexOf(" tmux")>=0)},I=>!0);return Promise.resolve(!0)}var R;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(R||(R={}));function p(l,I,D,f,A){l=l.trim().toLowerCase();let w;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?w=R.powershell:l.indexOf("cmd.exe")>=0?w=R.cmd:l.indexOf("bash")>=0?w=R.bash:P.$c?w=R.cmd:w=R.bash;let a,d=" ";switch(w){case R.powershell:if(a=g=>(g=g.replace(/\'/g,"''"),g.length>0&&g.charAt(g.length-1)==="\\"?`'${g}\\'`:`'${g}'`),f){const g=(0,u.$Fg)(f);g&&(d+=`${g}:; `),d+=`cd ${a(f)}; `}if(A)for(const g in A){const $=A[g];$===null?d+=`Remove-Item env:${g}; `:d+=`\${env:${g}}='${$}'; `}if(I.length>0){const g=I.shift(),$=D?g:a(g);d+=$[0]==="'"?`& ${$} `:`${$} `;for(const i of I)d+=i==="<"||i===">"||D?i:a(i),d+=" "}break;case R.cmd:if(a=g=>(g=g.replace(/\"/g,'""'),g=g.replace(/([><!^&|])/g,"^$1"),' "'.split("").some($=>g.includes($))||g.length===0?`"${g}"`:g),f){const g=(0,u.$Fg)(f);g&&(d+=`${g}: && `),d+=`cd ${a(f)} && `}if(A){d+='cmd /C "';for(const g in A){let $=A[g];$===null?d+=`set "${g}=" && `:($=$.replace(/[&^|<>]/g,i=>`^${i}`),d+=`set "${g}=${$}" && `)}}for(const g of I)d+=g==="<"||g===">"||D?g:a(g),d+=" ";A&&(d+='"');break;case R.bash:{a=$=>($=$.replace(/(["'\\\$!><#()\[\]*&^| ;{}?`])/g,"\\$1"),$.length===0?'""':$);const g=$=>/[^\w@%\/+=,.:^-]/.test($)?`'${$.replace(/'/g,"'\\''")}'`:$;if(f&&(d+=`cd ${a(f)} ; `),A){d+="/usr/bin/env";for(const $ in A){const i=A[$];i===null?d+=` -u ${g($)}`:d+=` ${g(`${$}=${i}`)}`}d+=" "}for(const $ of I)d+=$==="<"||$===">"||D?$:a($),d+=" ";break}}return d}}),define(Ee[309],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.CellExecutionUpdateType=void 0;var u;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(u||(e.CellExecutionUpdateType=u={})),e.$aK=(0,r.$Ai)("INotebookExecutionService")}),define(Ee[310],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djb=e.$Cjb=e.ProxyKernelState=e.$Bjb=void 0,e.$Bjb=100;var u;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(u||(e.ProxyKernelState=u={})),e.$Cjb=(0,r.$Ai)("INotebookKernelService"),e.$Djb=(0,r.$Ai)("INotebookKernelHistoryService")}),define(Ee[311],Se([1,0,3,31,59,206,111]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gYb=void 0;class R extends r.$Uc{constructor(l,I,D){super(),this._source=l,this.b=I,this.c=D,this.a=void 0}f(l){const I=l.getLineCount();return new u.$dt(1,1,I,this.g(l,I))}g(l,I){if(I<1||I>l.getLineCount())throw new Error("Illegal value for lineNumber");return l.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const l=new T.$bD;l.acceptChunk(this._source);const I=l.finish(!0),{textBuffer:D,disposable:f}=I.create(P.DefaultEndOfLine.LF);this.b=D,this.B(f)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(l=>{const I=new T.$bD;I.acceptChunk(l);const D=I.finish(!0),{textBuffer:f,disposable:A}=D.create(P.DefaultEndOfLine.LF);return this.B(A),f})),this.a}findInInputs(l){const D=new L.$2C(l,!1,!1,null).parseSearchRequest();if(!D)return[];const f=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(f,D,!0,5e3)}findInOutputs(l){const D=new L.$2C(l,!1,!1,null).parseSearchRequest();return D?this.outputTextBuffers.map(f=>{const A=f.findMatchesLineByLine(this.f(f),D,!0,5e3);if(A.length!==0)return{textBuffer:f,matches:A}}).filter(f=>!!f):[]}}e.$gYb=R}),define(Ee[73],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.TestPosition=e.TestIdPathParts=void 0;var r;(function(T){T.Delimiter="\0"})(r||(e.TestIdPathParts=r={}));var u;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(u||(e.TestPosition=u={}));class P{static fromExtHostTestItem(L,R,p=L.parent){if(L._isRoot)return new P([R]);const l=[L.id];for(let I=p;I&&I.id!==R;I=I.parent)l.push(I.id);return l.push(R),new P(l.reverse())}static isRoot(L){return!L.includes(r.Delimiter)}static root(L){const R=L.indexOf(r.Delimiter);return R===-1?L:L.slice(0,R)}static fromString(L){return new P(L.split(r.Delimiter))}static join(L,R){return new P([...L.path,R])}static joinToString(L,R){return L.toString()+r.Delimiter+R}static parentId(L){const R=L.lastIndexOf(r.Delimiter);return R===-1?void 0:L.slice(0,R)}static localId(L){const R=L.lastIndexOf(r.Delimiter);return R===-1?L:L.slice(R+r.Delimiter.length)}static isChild(L,R){return R.startsWith(L)&&R[L.length]===r.Delimiter}static compare(L,R){return L===R?u.IsSame:P.isChild(L,R)?u.IsChild:P.isChild(R,L)?u.IsParent:u.Disconnected}static getLengthOfCommonPrefix(L,R){if(L===0)return 0;let p=0;for(;p<L-1;){for(let l=1;l<L;l++){const I=R(l-1),D=R(l);if(I.path[p]!==D.path[p])return p}p++}return p}constructor(L,R=L.length){if(this.path=L,this.d=R,L.length===0||R<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new P(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new P(this.path,L)}compare(L){if(typeof L=="string")return P.compare(this.toString(),L);for(let R=0;R<L.d&&R<this.d;R++)if(L.path[R]!==this.path[R])return u.Disconnected;return L.d>this.d?u.IsChild:L.d<this.d?u.IsParent:u.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+=r.Delimiter,this.c+=this.path[L]}return this.c}}e.$hL=P}),define(Ee[74],Se([1,0,2,58,31,73]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$pL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$oL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$nL=e.$mL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$lL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$kL=e.$jL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$iL=e.TestResultState=void 0;var L;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(L||(e.TestResultState=L={})),e.$iL={[L.Unset]:"unset",[L.Queued]:"queued",[L.Running]:"running",[L.Passed]:"passed",[L.Failed]:"failed",[L.Skipped]:"skipped",[L.Errored]:"errored"};var R;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var p;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})(p||(e.TestRunProfileBitset=p={})),e.$jL=[p.Run,p.Debug,p.Coverage,p.HasNonDefaultProfile,p.HasConfigurable,p.SupportsContinuousRun];const l=M=>"runId"in M;e.$kL=l;var I;(function(M){M.serialize=N=>({range:N.range.toJSON(),uri:N.uri.toJSON()}),M.deserialize=(N,F)=>({range:P.$dt.lift(F.range),uri:N.asCanonicalUri(r.URI.revive(F.uri))})})(I||(e.IRichLocation=I={}));var D;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(D||(e.TestMessageType=D={}));var f;(function(M){M.serialize=N=>({message:N.message,type:D.Error,expected:N.expected,actual:N.actual,contextValue:N.contextValue,location:N.location&&I.serialize(N.location)}),M.deserialize=(N,F)=>({message:F.message,type:D.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&I.deserialize(N,F.location)})})(f||(e.ITestErrorMessage=f={}));const A=(M,N)=>`${N?"s":"e"}${M}`;e.$lL=A;var w;(function(M){M.serialize=N=>({message:N.message,type:D.Output,offset:N.offset,length:N.length,location:N.location&&I.serialize(N.location)}),M.deserialize=(N,F)=>({message:F.message,type:D.Output,offset:F.offset,length:F.length,location:F.location&&I.deserialize(N,F.location)})})(w||(e.ITestOutputMessage=w={}));var a;(function(M){M.serialize=N=>N.type===D.Error?f.serialize(N):w.serialize(N),M.deserialize=(N,F)=>F.type===D.Error?f.deserialize(N,F):w.deserialize(N,F)})(a||(e.ITestMessage=a={}));var d;(function(M){M.serializeWithoutMessages=N=>({state:N.state,duration:N.duration,messages:[]}),M.serialize=N=>({state:N.state,duration:N.duration,messages:N.messages.map(a.serialize)}),M.deserialize=(N,F)=>({state:F.state,duration:F.duration,messages:F.messages.map(X=>a.deserialize(N,X))})})(d||(e.ITestTaskState=d={}));const g="\0",$=(M,N)=>M+g+N;e.$mL=$;const i=M=>{const N=M.indexOf(g);return{ctrlId:M.slice(0,N),tagId:M.slice(N+1)}};e.$nL=i;var o;(function(M){M.serialize=N=>({extId:N.extId,label:N.label,tags:N.tags,busy:N.busy,children:void 0,uri:N.uri?.toJSON(),range:N.range?.toJSON()||null,description:N.description,error:N.error,sortText:N.sortText}),M.deserialize=(N,F)=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?N.asCanonicalUri(r.URI.revive(F.uri)):void 0,range:F.range?P.$dt.lift(F.range):null,description:F.description,error:F.error,sortText:F.sortText})})(o||(e.ITestItem=o={}));var n;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var t;(function(M){M.serialize=N=>({expand:N.expand,item:o.serialize(N.item)}),M.deserialize=(N,F)=>({controllerId:T.$hL.root(F.item.extId),expand:F.expand,item:o.deserialize(N,F.item)})})(t||(e.InternalTestItem=t={}));var c;(function(M){M.serialize=N=>{let F;return N.item&&(F={},N.item.label!==void 0&&(F.label=N.item.label),N.item.tags!==void 0&&(F.tags=N.item.tags),N.item.busy!==void 0&&(F.busy=N.item.busy),N.item.uri!==void 0&&(F.uri=N.item.uri?.toJSON()),N.item.range!==void 0&&(F.range=N.item.range?.toJSON()),N.item.description!==void 0&&(F.description=N.item.description),N.item.error!==void 0&&(F.error=N.item.error),N.item.sortText!==void 0&&(F.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:F}},M.deserialize=N=>{let F;return N.item&&(F={},N.item.label!==void 0&&(F.label=N.item.label),N.item.tags!==void 0&&(F.tags=N.item.tags),N.item.busy!==void 0&&(F.busy=N.item.busy),N.item.range!==void 0&&(F.range=N.item.range?P.$dt.lift(N.item.range):null),N.item.description!==void 0&&(F.description=N.item.description),N.item.error!==void 0&&(F.error=N.item.error),N.item.sortText!==void 0&&(F.sortText=N.item.sortText)),{extId:N.extId,expand:N.expand,item:F}}})(c||(e.ITestItemUpdate=c={}));const h=(M,N)=>{N.expand!==void 0&&(M.expand=N.expand),N.item!==void 0&&(M.item=M.item?Object.assign(M.item,N.item):N.item)};e.$oL=h;var s;(function(M){M.serializeWithoutMessages=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(d.serializeWithoutMessages)}),M.serialize=N=>({...t.serialize(N),ownComputedState:N.ownComputedState,computedState:N.computedState,tasks:N.tasks.map(d.serialize)}),M.deserialize=(N,F)=>({...t.deserialize(N,F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(X=>d.deserialize(N,X)),retired:!0})})(s||(e.TestResultItem=s={}));var m;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(N,F)=>{N.covered+=F.covered,N.total+=F.total}})(m||(e.ICoverageCount=m={}));var y;(function(M){M.serialize=N=>({id:N.id,statement:N.statement,branch:N.branch,declaration:N.declaration,testId:N.testId?.toString(),uri:N.uri.toJSON()}),M.deserialize=(N,F)=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testId:F.testId?T.$hL.fromString(F.testId):void 0,uri:N.asCanonicalUri(r.URI.revive(F.uri))}),M.empty=(N,F)=>({id:N,uri:F,testId:void 0,statement:m.empty()})})(y||(e.IFileCoverage=y={}));function S(M){return{...M,location:M.location?.toJSON()}}function E(M){return M.location=M.location?u.$ct.isIPosition(M.location)?u.$ct.lift(M.location):P.$dt.lift(M.location):void 0,M}e.$pL=3;var k;(function(M){M[M.Declaration=0]="Declaration",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(k||(e.DetailType=k={}));var C;(function(M){M.serialize=N=>N.type===k.Declaration?b.serialize(N):O.serialize(N),M.deserialize=N=>N.type===k.Declaration?b.deserialize(N):O.deserialize(N)})(C||(e.CoverageDetails=C={}));var v;(function(M){M.serialize=S,M.deserialize=E})(v||(e.IBranchCoverage=v={}));var b;(function(M){M.serialize=S,M.deserialize=E})(b||(e.IDeclarationCoverage=b={}));var O;(function(M){M.serialize=N=>({...S(N),branches:N.branches?.map(v.serialize)}),M.deserialize=N=>({...E(N),branches:N.branches?.map(v.deserialize)})})(O||(e.IStatementCoverage=O={}));var U;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(U||(e.TestDiffOpType=U={}));var z;(function(M){M.deserialize=(N,F)=>F.op===U.Add?{op:F.op,item:t.deserialize(N,F.item)}:F.op===U.Update?{op:F.op,item:c.deserialize(F.item)}:F.op===U.DocumentSynced?{op:F.op,uri:N.asCanonicalUri(r.URI.revive(F.uri)),docv:F.docv}:F,M.serialize=N=>N.op===U.Add?{op:N.op,item:t.serialize(N.item)}:N.op===U.Update?{op:N.op,item:c.serialize(N.item)}:N})(z||(e.TestsDiffOp=z={}));class j{constructor(N){this.k=N,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(N){const F=this.w();for(const X of N)switch(X.op){case U.Add:this.l(t.deserialize(this.k,X.item),F);break;case U.Update:this.p(c.deserialize(X.item),F);break;case U.Remove:this.q(X.itemId,F);break;case U.Retire:this.v(X.itemId);break;case U.IncrementPendingExtHosts:this.updatePendingRoots(X.amount);break;case U.AddTag:this.c.set(X.tag.id,X.tag);break;case U.RemoveTag:this.c.delete(X.id);break}F.complete?.()}l(N,F){const X=T.$hL.parentId(N.item.extId)?.toString();let se;if(!X)se=this.x(N),this.g.add(se),this.f.set(N.item.extId,se);else if(this.f.has(X)){const W=this.f.get(X);W.children.add(N.item.extId),se=this.x(N,W),this.f.set(N.item.extId,se)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(N)}`);return}return F.add?.(se),N.expand===n.BusyExpanding&&this.h++,se}p(N,F){const X=this.f.get(N.extId);if(X)return N.expand!==void 0&&(X.expand===n.BusyExpanding&&this.h--,N.expand===n.BusyExpanding&&this.h++),(0,e.$oL)(X,N),F.update?.(X),X}q(N,F){const X=this.f.get(N);if(!X)return;const se=T.$hL.parentId(X.item.extId)?.toString();se?this.f.get(se).children.delete(X.item.extId):this.g.delete(X);const W=[[N]];for(;W.length;)for(const H of W.pop()){const V=this.f.get(H);V&&(W.push(V.children),this.f.delete(H),F.remove?.(V,V!==X),V.expand===n.BusyExpanding&&this.h--)}}v(N){}updatePendingRoots(N){this.j+=N}w(){return{}}}e.$qL=j}),define(Ee[312],Se([1,0,138,255,74]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$iFb=e.$hFb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var T;(function(D){D.ViewletId="workbench.view.extension.test",D.ExplorerViewId="workbench.view.testing",D.OutputPeekContributionId="editor.contrib.testingOutputPeek",D.DecorationsContributionId="editor.contrib.testingDecorations",D.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",D.CoverageViewId="workbench.view.testCoverage",D.ResultsPanelId="workbench.panel.testResults",D.ResultsViewId="workbench.panel.testResults.view",D.MessageLanguageId="vscodeInternalTestMessage"})(T||(e.Testing=T={}));var L;(function(D){D.List="list",D.Tree="true"})(L||(e.TestExplorerViewMode=L={}));var R;(function(D){D.ByLocation="location",D.ByStatus="status",D.ByDuration="duration"})(R||(e.TestExplorerViewSorting=R={}));const p={[P.TestResultState.Errored]:(0,u.localize)(0,null),[P.TestResultState.Failed]:(0,u.localize)(1,null),[P.TestResultState.Passed]:(0,u.localize)(2,null),[P.TestResultState.Queued]:(0,u.localize)(3,null),[P.TestResultState.Running]:(0,u.localize)(4,null),[P.TestResultState.Skipped]:(0,u.localize)(5,null),[P.TestResultState.Unset]:(0,u.localize)(6,null)},l=(D,f)=>(0,u.localize)(7,null,(0,r.$Tk)(D),p[f]);e.$hFb=l,e.$iFb={[P.TestRunProfileBitset.Debug]:(0,u.localize)(8,null),[P.TestRunProfileBitset.Run]:(0,u.localize)(9,null),[P.TestRunProfileBitset.Coverage]:(0,u.localize)(10,null)};var I;(function(D){D.CancelTestRefreshAction="testing.cancelTestRefresh",D.CancelTestRunAction="testing.cancelRun",D.ClearTestResultsAction="testing.clearTestResults",D.CollapseAllAction="testing.collapseAll",D.ConfigureTestProfilesAction="testing.configureProfile",D.ContinousRunUsingForTest="testing.continuousRunUsingForTest",D.CoverageAtCursor="testing.coverageAtCursor",D.CoverageByUri="testing.coverage.uri",D.CoverageClear="testing.coverage.close",D.CoverageCurrentFile="testing.coverageCurrentFile",D.CoverageFilterToTest="testing.coverageFilterToTest",D.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",D.CoverageLastRun="testing.coverageLastRun",D.CoverageSelectedAction="testing.coverageSelected",D.CoverageToggleToolbar="testing.coverageToggleToolbar",D.CoverageViewChangeSorting="testing.coverageViewChangeSorting",D.DebugAction="testing.debug",D.DebugAllAction="testing.debugAll",D.DebugAtCursor="testing.debugAtCursor",D.DebugByUri="testing.debug.uri",D.DebugCurrentFile="testing.debugCurrentFile",D.DebugFailedTests="testing.debugFailTests",D.DebugLastRun="testing.debugLastRun",D.DebugSelectedAction="testing.debugSelected",D.FilterAction="workbench.actions.treeView.testExplorer.filter",D.GetExplorerSelection="_testing.getExplorerSelection",D.GetSelectedProfiles="testing.getSelectedProfiles",D.GoToTest="testing.editFocusedTest",D.HideTestAction="testing.hideTest",D.OpenCoverage="testing.openCoverage",D.OpenOutputPeek="testing.openOutputPeek",D.RefreshTestsAction="testing.refreshTests",D.ReRunFailedTests="testing.reRunFailTests",D.ReRunLastRun="testing.reRunLastRun",D.RunAction="testing.run",D.RunAllAction="testing.runAll",D.RunAllWithCoverageAction="testing.coverageAll",D.RunAtCursor="testing.runAtCursor",D.RunByUri="testing.run.uri",D.RunCurrentFile="testing.runCurrentFile",D.RunSelectedAction="testing.runSelected",D.RunUsingProfileAction="testing.runUsing",D.RunWithCoverageAction="testing.coverage",D.SearchForTestExtension="testing.searchForTestExtension",D.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",D.ShowMostRecentOutputAction="testing.showMostRecentOutput",D.StartContinousRun="testing.startContinuousRun",D.StopContinousRun="testing.stopContinuousRun",D.TestingSortByDurationAction="testing.sortByDuration",D.TestingSortByLocationAction="testing.sortByLocation",D.TestingSortByStatusAction="testing.sortByStatus",D.TestingViewAsListAction="testing.viewAsList",D.TestingViewAsTreeAction="testing.viewAsTree",D.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",D.ToggleInlineTestOutput="testing.toggleInlineTestOutput",D.UnhideAllTestsAction="testing.unhideAllTests",D.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Ee[121],Se([1,0,7,4,3,65,74,73]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.TestItemEventOp=void 0;var p;(function($){$[$.Upsert=0]="Upsert",$[$.SetTags=1]="SetTags",$[$.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",$[$.RemoveChild=3]="RemoveChild",$[$.SetProp=4]="SetProp",$[$.Bulk=5]="Bulk",$[$.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const l=($,i)=>$===i,D=Object.entries({range:($,i)=>$===i?!0:!$||!i?!1:$.equalsRange(i),busy:l,label:l,description:l,error:l,sortText:l,tags:($,i)=>!($.length!==i.length||$.some(o=>!i.includes(o)))}),f=($,i)=>{let o;for(const[n,t]of D)t($[n],i[n])||(o?o[n]=i[n]:o={[n]:i[n]});return o};class A extends P.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new r.$Mh(()=>this.flushDiff(),200)),this.g=this.B(new u.$he),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const o of this.tree.values())this.J(o)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case L.TestDiffOpType.DocumentSynced:{for(const o of this.m)if(o.op===L.TestDiffOpType.DocumentSynced&&o.uri===i.uri){o.docv=i.docv;return}break}case L.TestDiffOpType.Update:{const o=this.m[this.m.length-1];if(o){if(o.op===L.TestDiffOpType.Update&&o.item.extId===i.item.extId){(0,L.$oL)(o.item,i.item);return}if(o.op===L.TestDiffOpType.Add&&o.item.item.extId===i.item.extId){(0,L.$oL)(o.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,o){const n=this.tree.get(i);if(n){if((n.expandLevels===void 0||o>n.expandLevels)&&(n.expandLevels=o),n.expand===L.TestItemExpandState.Expandable){const t=this.M(n);return t.isOpen()?this.L(n,o-1):t.wait().then(()=>this.L(n,o-1))}else if(n.expand===L.TestItemExpandState.Expanded)return n.resolveBarrier?.isOpen()===!1?n.resolveBarrier.wait().then(()=>this.L(n,o-1)):this.L(n,o-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,o){switch(o.op){case p.RemoveChild:this.O(R.$hL.joinToString(i.fullId,o.id));break;case p.Upsert:this.z(o.item,i);break;case p.Bulk:for(const n of o.ops)this.w(i,n);break;case p.SetTags:this.C(o.new,o.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:o.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,T.$ed)(o)}}y(i){i&&this.pushDiff({op:L.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,o){const n=R.$hL.fromExtHostTestItem(i,this.root.id,o?.actual),t=this.s.getApiFor(i);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(i.id);let c=this.tree.get(n.toString());if(!c){c={fullId:n,actual:i,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:L.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(c.fullId.toString(),c),this.G(i,o),this.pushDiff({op:L.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:c.expand,item:this.s.toITestItem(i)}}),this.I(i,c,o);return}if(c.actual===i){this.H(i,c,o);return}if(c.actual.uri?.toString()!==i.uri?.toString())return this.O(n.toString()),this.z(i,o);const h=this.s.getChildren(c.actual),s=c.actual,m=f(this.s.toITestItem(s),this.s.toITestItem(i));this.s.getApiFor(s).listener=void 0,c.actual=i,c.resolveBarrier=void 0,c.expand=L.TestItemExpandState.NotExpandable,m&&(m.hasOwnProperty("tags")&&(this.C(i.tags,s.tags,n.toString()),delete m.tags),this.w(c,{op:p.SetProp,update:m})),this.I(i,c,o);for(const[S,E]of h)this.s.getChildren(i).get(E.id)||this.O(R.$hL.joinToString(n,E.id));const y=c.expandLevels;y!==void 0&&queueMicrotask(()=>{c.expand===L.TestItemExpandState.Expandable&&(c.expandLevels=void 0,this.expand(n.toString(),y))}),this.y(c.actual.uri)}C(i,o,n){const t=new Set(o.map(c=>c.id));for(const c of i)t.delete(c.id)||this.D(c);this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:n,item:{tags:i.map(c=>(0,L.$mL)(this.s.controllerId,c.id))}}}),t.forEach(this.F,this)}D(i){const o=this.j.get(i.id);o?o.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:L.TestDiffOpType.AddTag,tag:{id:(0,L.$mL)(this.s.controllerId,i.id)}}))}F(i){const o=this.j.get(i);o&&!--o.refCount&&(this.j.delete(i),this.pushDiff({op:L.TestDiffOpType.RemoveTag,id:(0,L.$mL)(this.s.controllerId,i)}))}G(i,o){this.s.getApiFor(i).parent=o&&o.actual!==this.root?o.actual:void 0}H(i,o,n){this.G(i,n);const t=this.s.getApiFor(i);t.parent=n?.actual,t.listener=c=>this.w(o,c),this.J(o)}I(i,o,n){this.H(i,o,n);for(const[t,c]of this.s.getChildren(i))this.z(c,o)}J(i){let o;this.h?i.resolveBarrier?o=i.resolveBarrier.isOpen()?L.TestItemExpandState.Expanded:L.TestItemExpandState.BusyExpanding:o=i.actual.canResolveChildren?L.TestItemExpandState.Expandable:L.TestItemExpandState.NotExpandable:o=L.TestItemExpandState.NotExpandable,o!==i.expand&&(i.expand=o,this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:o}}),o===L.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,o){if(o<0)return;const n=[];for(const[t,c]of this.s.getChildren(i.actual)){const h=this.expand(R.$hL.joinToString(i.fullId,c.id),o);(0,r.$mh)(h)&&n.push(h)}if(n.length)return Promise.all(n).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const c=new r.$zh;return c.open(),c}i.expand=L.TestItemExpandState.BusyExpanding,this.N(i);const o=i.resolveBarrier=new r.$zh,n=c=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,c)};let t;try{t=this.h(i.actual===this.root?void 0:i.actual)}catch(c){n(c)}return(0,r.$mh)(t)?t.catch(n).then(()=>{o.open(),this.J(i)}):(o.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:L.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const o=this.tree.get(i);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:L.TestDiffOpType.Remove,itemId:i});const n=[o];for(;n.length;){const t=n.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const c of t.actual.tags)this.F(c.id);this.tree.delete(t.fullId.toString());for(const[c,h]of this.s.getChildren(t.actual))n.push(this.tree.get(R.$hL.joinToString(t.fullId,h.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$PO=A;class w extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$QO=w;class a extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$RO=a;class d extends Error{constructor(i,o,n){super(`TestItem with ID "${i}" is from controller "${o}" and cannot be added as a child of an item from controller "${n}".`)}}e.$SO=d;const g=($,i,o)=>{let n=new Map;return{get size(){return n.size},forEach(t,c){for(const h of n.values())t.call(c,h,this)},[Symbol.iterator](){return n.entries()},replace(t){const c=new Map,h=new Set(n.keys()),s={op:p.Bulk,ops:[]};for(const m of t){if(!(m instanceof o))throw new a(m.id);const y=i(m).controllerId;if(y!==$.controllerId)throw new d(m.id,y,$.controllerId);if(c.has(m.id))throw new w(m.id);c.set(m.id,m),h.delete(m.id),s.ops.push({op:p.Upsert,item:m})}for(const m of h.keys())s.ops.push({op:p.RemoveChild,id:m});$.listener?.(s),n=c},add(t){if(!(t instanceof o))throw new a(t.id);n.set(t.id,t),$.listener?.({op:p.Upsert,item:t})},delete(t){n.delete(t)&&$.listener?.({op:p.RemoveChild,id:t})},get(t){return n.get(t)},toJSON(){return Array.from(n.values())}}};e.$TO=g}),define(Ee[154],Se([1,0,121]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=void 0;const u=new WeakMap,P=(L,R)=>{const p={controllerId:R};return u.set(L,p),p};e.$UO=P;const T=L=>{const R=u.get(L);if(!R)throw new r.$RO(L?.id||"<unknown>");return R};e.$VO=T}),define(Ee[122],Se([1,0,27,15,2]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OBb=e.$NBb=e.$MBb=void 0,e.$PBb=T,e.$QBb=R,e.$MBb="vscode-cdn.net",e.$NBb=`vscode-resource.${e.$MBb}`,e.$OBb=`'self' https://*.${e.$MBb}`;function T(p,l){return p.scheme===u.Schemas.http||p.scheme===u.Schemas.https?p:(l&&l.authority&&l.isRemote&&p.scheme===u.Schemas.file&&(p=P.URI.from({scheme:u.Schemas.vscodeRemote,authority:l.authority,path:p.path})),P.URI.from({scheme:u.Schemas.https,authority:`${p.scheme}+${L(p.authority)}.${e.$NBb}`,path:p.path,fragment:p.fragment,query:p.query}))}function L(p){return p.replace(/./g,l=>{const I=l.charCodeAt(0);return I>=r.CharCode.a&&I<=r.CharCode.z||I>=r.CharCode.A&&I<=r.CharCode.Z||I>=r.CharCode.Digit0&&I<=r.CharCode.Digit9?l:"-"+I.toString(16).padStart(4,"0")})}function R(p){return p.replace(/-([0-9a-f]{4})/g,(l,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Ee[313],Se([1,0,4,3,122]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0;class T{constructor(R,p,l){this.d=R,this.e=p,this.f=l,this.a=0,this.b=new u.$Tc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const I=p.getVisibleTextEditors();for(const D of this.c.values())I.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(R=>R.inset.dispose()),this.b.dispose()}createWebviewEditorInset(R,p,l,I,D){let f;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===R){f=i;break}if(!f)throw new Error("not a visible editor");const A=this,w=this.a++,a=new r.$he,d=new r.$he,g=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$PBb)(i,A.f)}get cspSource(){return P.$OBb}set options(i){this.b=i,A.d.$setOptions(w,i)}get options(){return this.b}set html(i){this.a=i,A.d.$setHtml(w,i)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(i){return A.d.$postMessage(w,i)}},$=new class{constructor(){this.editor=R,this.line=p,this.height=l,this.webview=g,this.onDidDispose=d.event}dispose(){A.c.has(w)&&(A.c.delete(w),A.d.$disposeEditorInset(w),d.fire(),d.dispose(),a.dispose())}};return this.d.$createEditorInset(w,f.id,f.value.document.uri,p+1,l,I||{},D.identifier,D.extensionLocation),this.c.set(w,{editor:R,inset:$,onDidReceiveMessage:a}),$}$onDidDispose(R){const p=this.c.get(R);p&&p.inset.dispose()}$onDidReceiveMessage(R,p){this.c.get(R)?.onDidReceiveMessage.fire(p)}}e.$0mc=T}),define(Ee[155],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zL=e.$yL=e.$xL=void 0,e.$xL="__",e.$yL=(0,r.$Ai)("IAuthenticationService"),e.$zL=(0,r.$Ai)("IAuthenticationExtensionsService")}),define(Ee[314],Se([1,0,5]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=e.VariableKind=e.$NP=void 0,e.$NP=(0,r.$Ai)("configurationResolverService");var u;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(u||(e.VariableKind=u={}));class P extends Error{constructor(L,R){super(R),this.variable=L}}e.$OP=P}),define(Ee[315],Se([1,0,16,54,18,25,11,107,256,314,13]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;class D{constructor(A,w,a,d){this.h=new Map,this.a=A,this.b=w,this.g=a,d&&(this.c=d.then(g=>this.i(g)))}i(A){if(L.$c){const w=Object.create(null);return Object.keys(A).forEach(a=>{w[a.toLowerCase()]=A[a]}),w}return A}resolveWithEnvironment(A,w,a){return this.l({env:this.i(A),userHome:void 0},w?w.uri:void 0,a)}async resolveAsync(A,w){const a={env:await this.c,userHome:await this.g};return this.l(a,A?A.uri:void 0,w)}async j(A,w,a,d){const g=T.$0n(w);L.$c&&g.windows?Object.keys(g.windows).forEach(i=>g[i]=g.windows[i]):L.$d&&g.osx?Object.keys(g.osx).forEach(i=>g[i]=g.osx[i]):L.$e&&g.linux&&Object.keys(g.linux).forEach(i=>g[i]=g.linux[i]),delete g.windows,delete g.osx,delete g.linux;const $={env:await this.c,userHome:await this.g};return this.l($,A?A.uri:void 0,g,a,d)}async resolveAnyAsync(A,w,a){return this.j(A,w,a)}async resolveAnyMap(A,w,a){const d=new Map;return{newConfig:await this.j(A,w,a,d),resolvedVariables:d}}resolveWithInteractionReplace(A,w,a,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(A,w,a,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(A,w){if(this.h.has(A))throw new Error("Variable "+A+" is contributed twice.");this.h.set(A,w)}async l(A,w,a,d,g){if(P.$ag(a))return this.m(A,w,a,d,g);if(Array.isArray(a))return Promise.all(a.map($=>this.l(A,w,$,d,g)));if(P.$cg(a)){const $=Object.create(null),i=await Promise.all(Object.keys(a).map(async o=>[await this.m(A,w,o,d,g),await this.l(A,w,a[o],d,g)]));for(const[o,n]of i)$[o]=n;return $}return a}m(A,w,a,d,g){return(0,I.$tf)(a,D.VARIABLE_REGEXP,async($,i)=>{if(i.includes(D.VARIABLE_LHS))return $;let o=await this.o(A,$,i,w,d);return g?.set(i,o),o!==$&&P.$ag(o)&&o.match(D.VARIABLE_REGEXP)&&(o=await this.m(A,w,o,d,g)),o})}n(A){return this.b?this.b.getUriLabel(A,{noPrefix:!0}):A.fsPath}async o(A,w,a,d,g){let $;const i=a.split(":");i.length>1&&(a=i[0],$=i[1]);const o=c=>{const h=this.a.getFilePath();if(h)return(0,R.$Ow)(h);throw new l.$OP(c,(0,p.localize)(0,null,w))},n=c=>{const h=o(c);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,R.$Ow)(s)}throw new l.$OP(c,(0,p.localize)(1,null,w,r.$nc(h)))},t=c=>{if($){const h=this.a.getFolderUri($);if(h)return h;throw new l.$OP(c,(0,p.localize)(2,null,w,$))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new l.$OP(c,(0,p.localize)(3,null,w)):new l.$OP(c,(0,p.localize)(4,null,w))};switch(a){case"env":if($){if(A.env){const c=A.env[L.$c?$.toLowerCase():$];if(P.$ag(c))return c}return""}throw new l.$OP(l.VariableKind.Env,(0,p.localize)(5,null,w));case"config":if($){const c=this.a.getConfigurationValue(d,$);if(P.$jg(c))throw new l.$OP(l.VariableKind.Config,(0,p.localize)(6,null,w,$));if(P.$cg(c))throw new l.$OP(l.VariableKind.Config,(0,p.localize)(7,null,w,$));return c}throw new l.$OP(l.VariableKind.Config,(0,p.localize)(8,null,w));case"command":return this.p(l.VariableKind.Command,w,$,g,"command");case"input":return this.p(l.VariableKind.Input,w,$,g,"input");case"extensionInstallFolder":if($){const c=await this.a.getExtension($);if(!c)throw new l.$OP(l.VariableKind.ExtensionInstallFolder,(0,p.localize)(9,null,w,$));return this.n(c.extensionLocation)}throw new l.$OP(l.VariableKind.ExtensionInstallFolder,(0,p.localize)(10,null,w));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,R.$Ow)(this.n(t(l.VariableKind.WorkspaceFolder)));case"cwd":return d||$?(0,R.$Ow)(this.n(t(l.VariableKind.Cwd))):u.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,R.$Ow)(r.$nc(this.n(t(l.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(A.userHome)return A.userHome;throw new l.$OP(l.VariableKind.UserHome,(0,p.localize)(11,null,w))}case"lineNumber":{const c=this.a.getLineNumber();if(c)return c;throw new l.$OP(l.VariableKind.LineNumber,(0,p.localize)(12,null,w))}case"selectedText":{const c=this.a.getSelectedText();if(c)return c;throw new l.$OP(l.VariableKind.SelectedText,(0,p.localize)(13,null,w))}case"file":return o(l.VariableKind.File);case"fileWorkspaceFolder":return n(l.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return r.$nc(n(l.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return d||$?r.$lc(this.n(t(l.VariableKind.RelativeFile)),o(l.VariableKind.RelativeFile)):o(l.VariableKind.RelativeFile);case"relativeFileDirname":{const c=r.$mc(o(l.VariableKind.RelativeFileDirname));if(d||$){const h=r.$lc(this.n(t(l.VariableKind.RelativeFileDirname)),c);return h.length===0?".":h}return c}case"fileDirname":return r.$mc(o(l.VariableKind.FileDirname));case"fileExtname":return r.$oc(o(l.VariableKind.FileExtname));case"fileBasename":return r.$nc(o(l.VariableKind.FileBasename));case"fileBasenameNoExtension":{const c=r.$nc(o(l.VariableKind.FileBasenameNoExtension));return c.slice(0,c.length-r.$oc(c).length)}case"fileDirnameBasename":return r.$nc(r.$mc(o(l.VariableKind.FileDirnameBasename)));case"execPath":{const c=this.a.getExecPath();return c||w}case"execInstallFolder":{const c=this.a.getAppRoot();return c||w}case"pathSeparator":case"/":return r.sep;default:try{const c=$?`${a}:${$}`:a;return this.p(l.VariableKind.Unknown,w,c,g,void 0)}catch{return w}}}}p(A,w,a,d,g){if(a&&d){const $=g===void 0?d[a]:d[g+":"+a];if(typeof $=="string")return $;throw new l.$OP(A,(0,p.localize)(14,null,w))}return w}}e.$4P=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ee[156],Se([1,0,5,152]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$$D=void 0,e.$_D=l,e.$aE=f,e.$bE=A,e.$$D=(0,r.$Ai)("editorGroupsService");var P;(function(w){w[w.UP=0]="UP",w[w.DOWN=1]="DOWN",w[w.LEFT=2]="LEFT",w[w.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var T;(function(w){w[w.HORIZONTAL=0]="HORIZONTAL",w[w.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var L;(function(w){w[w.FIRST=0]="FIRST",w[w.LAST=1]="LAST",w[w.NEXT=2]="NEXT",w[w.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var R;(function(w){w[w.MAXIMIZE=0]="MAXIMIZE",w[w.EXPAND=1]="EXPAND",w[w.EVEN=2]="EVEN"})(R||(e.GroupsArrangement=R={}));var p;(function(w){w[w.COPY_EDITORS=0]="COPY_EDITORS",w[w.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function l(w){const a=w;return(0,u.$VF)(a?.editor)&&(0,u.$VF)(a?.replacement)}var I;(function(w){w[w.CREATION_TIME=0]="CREATION_TIME",w[w.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",w[w.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var D;(function(w){w[w.NEW_EDITOR=1]="NEW_EDITOR",w[w.MOVE_EDITOR=2]="MOVE_EDITOR",w[w.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function f(w){const a=w;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function A(w){return w.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Ee[316],Se([1,0,5,156]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fE=e.$eE=e.$dE=e.$cE=void 0,e.$gE=P,e.$cE=(0,r.$Ai)("editorService"),e.$dE=-1,e.$eE=-2,e.$fE=-3;function P(T){const L=T;return typeof T=="number"||(0,u.$aE)(L)}}),define(Ee[157],Se([1,0,5,144]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=void 0,e.$SL=(0,r.$Bi)(u.$Hi)}),define(Ee[158],Se([1,0,24,4,16,3,7]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=e.$nbc=e.$mbc=e.$lbc=e.$kbc=void 0;class R{constructor($,i){this.versionId=$,this.removedDueToLooping=i}}e.$kbc=R;class p{static isHostExtension($,i,o){if(i.getExtensionDescription($))return!1;const n=o.getExtensionDescription($);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor($,i){this.j=$,this.c=new u.$he,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(a),this.f=new r.$Zm,this.g=[],this.h=new Map;for(const $ of this.e){if(this.f.has($.identifier)){console.error("Extension `"+$.identifier.value+"` is already registered");continue}this.f.set($.identifier,$),this.g.push($);const i=this.j.readActivationEvents($);for(const o of i)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push($)}}set($){return this.e=$,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions($,i){this.e=d(this.e,i),this.e=this.e.concat($);const o=p.l(this.e);return this.e=d(this.e,o.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,o)}static l($){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,s){this.addNode(h),this.addNode(s),this.c.has(h)?this.c.get(h).push(s):this.c.set(h,[s])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,s){const m=i.getArcs(h);for(let y=0;y<m.length;y++)if(!s.has(m[y]))return!1;return!0}getNodes(){return this.e}},o=new r.$Zm;for(const h of $)if(o.set(h.identifier,h),h.extensionDependencies)for(const s of h.extensionDependencies)i.addArc(r.$Xm.toKey(h.identifier),r.$Xm.toKey(s));const n=new Set;i.getNodes().filter(h=>i.getArcs(h).length===0).forEach(h=>n.add(h));const t=i.getNodes().filter(h=>!n.has(h));let c;do{c=!1;for(let h=0;h<t.length;h++){const s=t[h];i.hasOnlyGoodArcs(s,n)&&(t.splice(h,1),h--,n.add(s),c=!0)}}while(c);return t.map(h=>o.get(h))}containsActivationEvent($){return this.h.has($)}containsExtension($){return this.f.has($)}getExtensionDescriptionsForActivationEvent($){const i=this.h.get($);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new l(this.d,this.getAllExtensionDescriptions())}getExtensionDescription($){const i=this.f.get($);return i||void 0}getExtensionDescriptionByUUID($){for(const i of this.g)if(i.uuid===$)return i}getExtensionDescriptionByIdOrUUID($,i){return this.getExtensionDescription($)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$lbc=p;class l{constructor($,i){this.versionId=$,this.extensions=i}}e.$mbc=l;class I{constructor($){this.d=new A,this.c=new p($,[])}async acquireLock($){const i=await this.d.acquire($);return new D(this,i)}deltaExtensions($,i,o){if(!$.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,o)}containsActivationEvent($){return this.c.containsActivationEvent($)}containsExtension($){return this.c.containsExtension($)}getExtensionDescriptionsForActivationEvent($){return this.c.getExtensionDescriptionsForActivationEvent($)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription($){return this.c.getExtensionDescription($)}getExtensionDescriptionByUUID($){return this.c.getExtensionDescriptionByUUID($)}getExtensionDescriptionByIdOrUUID($,i){return this.c.getExtensionDescriptionByIdOrUUID($,i)}}e.$nbc=I;class D extends T.$Uc{constructor($,i){super(),this.f=$,this.c=!1,this.B(i)}isAcquiredFor($){return!this.c&&this.f===$}}e.$obc=D;class f{constructor($){this.name=$;const i=(0,L.$th)();this.promise=i.promise,this.c=i.resolve}resolve($){this.c($)}}class A{constructor(){this.c=[],this.d=!1}async acquire($){const i=new f($);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const $=this.c.shift();this.d=!0;let i=!0;const o=setTimeout(()=>{i&&console.warn(`The customer named ${$.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{i&&(clearTimeout(o),i=!1,this.d=!1,this.e())};$.resolve((0,T.$Sc)(n))}}var w;(function(g){g[g.Builtin=0]="Builtin",g[g.User=1]="User",g[g.Dev=2]="Dev"})(w||(w={}));function a(g,$){const i=g.isBuiltin?w.Builtin:g.isUnderDevelopment?w.Dev:w.User,o=$.isBuiltin?w.Builtin:$.isUnderDevelopment?w.Dev:w.User;if(i!==o)return i-o;const n=P.$gc.basename(g.extensionLocation.path),t=P.$gc.basename($.extensionLocation.path);return n<t?-1:n>t?1:0}function d(g,$){const i=new r.$Ym($);return g.filter(o=>!i.has(o.identifier))}}),define(Ee[317],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=e.$rn=e.$qn=e.ExtHostConnectionType=void 0,e.$tn=R,e.$un=p;var r;(function(I){I[I.IPC=1]="IPC",I[I.Socket=2]="Socket",I[I.MessagePort=3]="MessagePort"})(r||(e.ExtHostConnectionType=r={}));class u{constructor(D){this.pipeName=D,this.type=r.IPC}serialize(D){D[u.ENV_KEY]=this.pipeName}}e.$qn=u,u.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class P{constructor(){this.type=r.Socket}serialize(D){D[P.ENV_KEY]="1"}}e.$rn=P,P.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class T{constructor(){this.type=r.MessagePort}serialize(D){D[T.ENV_KEY]="1"}}e.$sn=T,T.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function L(I){delete I[u.ENV_KEY],delete I[P.ENV_KEY],delete I[T.ENV_KEY]}function R(I,D){L(D),I.serialize(D)}function p(I){if(I[u.ENV_KEY])return l(I,new u(I[u.ENV_KEY]));if(I[P.ENV_KEY])return l(I,new P);if(I[T.ENV_KEY])return l(I,new T);throw new Error("No connection information defined in environment!")}function l(I,D){return L(I),D}}),define(Ee[94],Se([1,0,22]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$6m=L,e.$7m=R;var u;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(u||(e.UIKind=u={}));var P;(function(l){l[l.VersionMismatch=55]="VersionMismatch",l[l.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var T;(function(l){l[l.Initialized=0]="Initialized",l[l.Ready=1]="Ready",l[l.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function L(l){const I=r.$Je.alloc(1);switch(l){case T.Initialized:I.writeUInt8(1,0);break;case T.Ready:I.writeUInt8(2,0);break;case T.Terminate:I.writeUInt8(3,0);break}return I}function R(l,I){if(l.byteLength!==1)return!1;switch(l.readUInt8(0)){case 1:return I===T.Initialized;case 2:return I===T.Ready;case 3:return I===T.Terminate;default:return!1}}var p;(function(l){l.Start="START_NATIVE_LOG",l.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ee[95],Se([1,0,5,4,149,12,30,94,91,92,25,2,3,239]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hP=e.$fP=e.$eP=void 0,e.$gP=d;let w=class extends f.$Uc{constructor($,i){super(),this.s=$,this.t=i,this.a=this.B(new u.$he),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new u.$he),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=D.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:l.$tp,name:(0,A.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(o=>{(0,T.$9j)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===T.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger($,i,o){const n=this.getTelemetryDetails(),t=new a(i,o,$,this.n,this.j,this.getBuiltInCommonProperties($),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),c=this.r.get($.identifier.value)??[];return this.r.set($.identifier.value,[...c,t]),t.apiTelemetryLogger}$initializeTelemetryLevel($,i,o){this.f=$,this.g=i,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties($){const i=Object.create(null);switch(i["common.extname"]=`${$.publisher}.${$.name}`,i["common.extversion"]=$.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=d(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$Om)((0,l.$zp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel($){this.h=this.getTelemetryConfiguration(),this.f=$;const i=this.getTelemetryDetails();this.r.forEach((o,n)=>{const t=o.filter(c=>!c.isDisposed);t.length===0?this.r.delete(n):this.r.set(n,t)}),this.r.forEach(o=>{for(const n of o)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError($,i){const n=this.r.get($.value)?.filter(c=>!c.isDisposed);if(!n)return this.r.delete($.value),!1;let t=!1;for(const c of n)c.ignoreUnhandledExtHostErrors||(c.logError(i),t=!0);return t}};e.$eP=w,e.$eP=w=Ze([Ve(0,L.$dP),Ve(1,T.$8j)],w);class a{static validateSender($){if(typeof $!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof $.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof $.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof $.flush<"u"&&typeof $.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor($,i,o,n,t,c,h){this.g=o,this.h=n,this.i=t,this.j=c,this.a=new u.$he,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=$,this.d={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements($,i){this.e&&(this.d={isUsageEnabled:$,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData($){let i="properties"in $?$.properties??{}:$;return i=(0,l.$Cp)(i,[]),this.c&&(i=(0,I.$ao)(i,this.c)),this.b||(i=(0,I.$ao)(i,this.j)),"properties"in $?$.properties=i:$=i,$}k($,i){this.f&&(this.g.publisher==="vscode"?$=this.g.name+"/"+$:$=this.g.identifier.value+"/"+$,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData($,i),this.h.trace($,i))}logUsage($,i){this.d.isUsageEnabled&&this.k($,i)}logError($,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof $=="string")this.k($,i);else{const o={name:$.name,message:$.message,stack:$.stack,cause:$.cause},n=(0,l.$Cp)(o,[]),t=new Error(n.message,{cause:n.cause});t.stack=n.stack,t.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(t,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const $=this,i={logUsage:$.logUsage.bind($),get isUsageEnabled(){return $.d.isUsageEnabled},get isErrorsEnabled(){return $.d.isErrorsEnabled},logError:$.logError.bind($),dispose:$.dispose.bind($),onDidChangeEnableStates:$.a.event.bind($)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let $=this.f;this.f=void 0,Promise.resolve($.flush()).then($=void 0),this.e=void 0}else this.f=void 0}}e.$fP=a;function d(g){const $=Date.now()-new Date(g).getTime();return isNaN($)?!1:$<1e3*60*60*24}e.$hP=(0,r.$Ai)("IExtHostTelemetry")}),define(Ee[26],Se([1,0,4,2,288,147,24,5]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1G=e.ActivationKind=e.$XG=e.$WG=e.$TG=e.ExtensionHostStartup=e.$SG=e.$RG=e.$QG=e.$PG=void 0,e.$UG=f,e.$VG=A,e.$YG=g,e.$ZG=$,e.$PG=Object.freeze({identifier:new L.$Xm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:u.URI.parse("void:location"),isBuiltin:!1,targetPlatform:L.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$QG="extensions.webWorker",e.$RG=(0,R.$Ai)("extensionService");class p{constructor(n){this.dependency=n}}e.$SG=p;var l;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(l||(e.ExtensionHostStartup=l={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(n,t,c){this.c=n,this.d=t.slice(0),this.e=c.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$AG.createActivationEventsMap(this.d)}}set(n,t,c){if(this.c>n)throw new Error(`ExtensionHostExtensions: invalid versionId ${n} (current: ${this.c})`);const h=[],s=[],m=[],y=[],S=D(this.d),E=D(t),k=(U,z)=>U.extensionLocation.toString()===z.extensionLocation.toString()||U.isBuiltin===z.isBuiltin||U.isUserBuiltin===z.isUserBuiltin||U.isUnderDevelopment===z.isUnderDevelopment;for(const U of this.d){const z=E.get(U.identifier);if(!z){h.push(U.identifier),S.delete(U.identifier);continue}if(!k(U,z)){h.push(U.identifier),S.delete(U.identifier);continue}}for(const U of t){const z=S.get(U.identifier);if(!z){s.push(U);continue}if(!k(z,U)){h.push(z.identifier),S.delete(z.identifier);continue}}const C=new L.$Ym(this.e),v=new L.$Ym(c);for(const U of this.e)v.has(U)||m.push(U);for(const U of c)C.has(U)||y.push(U);const b=T.$AG.createActivationEventsMap(s),O={versionId:n,toRemove:h,toAdd:s,addActivationEvents:b,myToRemove:m,myToAdd:y};return this.delta(O),O}delta(n){if(this.c>=n.versionId)return null;const{toRemove:t,toAdd:c,myToRemove:h,myToAdd:s}=n,m=new L.$Ym(t),y=new L.$Ym(h);for(let S=0;S<this.d.length;S++)m.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)y.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of c)this.d.push(S);for(const S of s)this.e.push(S);return this.f=null,n}containsExtension(n){for(const t of this.e)if(L.$Xm.equals(t,n))return!0;return!1}containsActivationEvent(n){return this.f||(this.f=this.g()),this.f.has(n)}g(){const n=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const c=T.$AG.readActivationEvents(t);for(const h of c)n.add(h)}return n}}e.$TG=I;function D(o){const n=new L.$Zm;for(const t of o)n.set(t.identifier,t);return n}function f(o,n){return!0}function A(o,n){if(!f(o,n))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${n}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${n}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}class w{constructor(n,t,c,h){this.codeLoadingTime=n,this.activateCallTime=t,this.activateResolvedTime=c,this.activationReason=h}}e.$WG=w;class a{constructor(n,t){this.description=n,this.value=t}}e.$XG=a;var d;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(d||(e.ActivationKind=d={}));function g(o){return{type:o.isBuiltin?L.ExtensionType.System:L.ExtensionType.User,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,P.$Ip)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}function $(o,n){return{identifier:new L.$Xm((0,P.$Gp)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===L.ExtensionType.System,isUserBuiltin:o.type===L.ExtensionType.User&&o.isBuiltin,isUnderDevelopment:!!n,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,publisherDisplayName:o.publisherDisplayName}}class i{constructor(){this.onDidRegisterExtensions=r.Event.None,this.onDidChangeExtensionsStatus=r.Event.None,this.onDidChangeExtensions=r.Event.None,this.onWillActivateByEvent=r.Event.None,this.onDidChangeResponsiveChange=r.Event.None,this.onWillStop=r.Event.None,this.extensions=[]}activateByEvent(n){return Promise.resolve(void 0)}activateById(n,t){return Promise.resolve(void 0)}activationEventIsDone(n){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(n){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(n,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(n){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$1G=i}),define(Ee[318],Se([1,0,14,158,24,26,12,7]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=e.$xnc=e.$wnc=e.$vnc=e.$unc=e.$tnc=void 0;class p{constructor(g,$,i,o){this.startup=g,this.codeLoadingTime=$,this.activateCallTime=i,this.activateResolvedTime=o}}e.$tnc=p,p.NONE=new p(!1,-1,-1,-1);class l{constructor(g){this.a=g,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(g,$){return g===-1||$===-1?-1:$-g}build(){return new p(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$unc=l;class I{constructor(g,$,i,o,n,t){this.activationFailed=g,this.activationFailedError=$,this.activationTimes=i,this.module=o,this.exports=n,this.subscriptions=t}}e.$vnc=I;class D extends I{constructor(g){super(!1,null,g,{activate:void 0,deactivate:void 0},void 0,[])}}e.$wnc=D;class f extends I{constructor(){super(!1,null,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xnc=f;class A extends I{constructor(g){super(!0,g,p.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let w=class{constructor(g,$,i,o){this.g=o,this.a=g,this.b=$,this.c=i,this.d=new P.$Zm,this.f=Object.create(null)}dispose(){for(const[g,$]of this.d)$.dispose()}async waitForActivatingExtensions(){const g=[];for(const[$,i]of this.d)g.push(i.wait());await Promise.all(g)}isActivated(g){const $=this.d.get(g);return!!($&&$.value)}getActivatedExtension(g){const $=this.d.get(g);if(!$||!$.value)throw new Error(`Extension '${g.value}' is not known or not activated`);return $.value}async activateByEvent(g,$){if(this.f[g])return;const i=this.a.getExtensionDescriptionsForActivationEvent(g);await this.h(i.map(o=>({id:o.identifier,reason:{startup:$,extensionId:o.identifier,activationEvent:g}}))),this.f[g]=!0}activateById(g,$){const i=this.a.getExtensionDescription(g);if(!i)throw new Error(`Extension '${g.value}' is not known`);return this.h([{id:i.identifier,reason:$}])}async h(g){const $=g.filter(i=>!this.isActivated(i.id)).map(i=>this.j(i));await Promise.all($.map(i=>i.wait()))}j(g){if(this.d.has(g.id))return this.d.get(g.id);if(this.l(g.id))return this.k(g,null,[],null);const $=this.a.getExtensionDescription(g.id);if(!$){const n=new Error(`Cannot activate unknown extension '${g.id.value}'`),t=this.k(g,null,[],new A(n));return this.c.onExtensionActivationError(g.id,n,new T.$SG(g.id.value)),t}const i=[],o=typeof $.extensionDependencies>"u"?[]:$.extensionDependencies;for(const n of o){if(this.m(n))continue;const t=this.d.get(n);if(t){i.push(t);continue}if(this.l(n)){i.push(this.j({id:this.b.getExtensionDescription(n).identifier,reason:g.reason}));continue}const c=this.a.getExtensionDescription(n);if(c){if(!c.main&&!c.browser)continue;i.push(this.j({id:c.identifier,reason:g.reason}));continue}const h=$.displayName||$.identifier.value,s=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${n}'`),m=this.k(g,$.displayName,[],new A(s));return this.c.onExtensionActivationError($.identifier,s,new T.$SG(n)),m}return this.k(g,$.displayName,i,null)}k(g,$,i,o){const n=new a(g.id,$,g.reason,i,o,this.c,this.g);return this.d.set(g.id,n),n}l(g){return u.$lbc.isHostExtension(g,this.a,this.b)}m(g){const $=this.b.getExtensionDescription(g);return $?!$.main&&!$.browser:!1}};e.$ync=w,e.$ync=w=Ze([Ve(3,L.$7j)],w);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(g,$,i,o,n,t,c){this.c=g,this.d=$,this.f=i,this.g=o,this.h=n,this.j=t,this.k=c,this.a=new R.$zh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let g=0;g<this.g.length;g++){const $=this.g[g];if($.value&&!$.value.activationFailed){this.g.splice(g,1),g--;continue}if($.value&&$.value.activationFailed){const i=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${$.friendlyName}' failed to activate`);i.detail=$.value.activationFailedError,this.h=new A(i),this.j.onExtensionActivationError(this.c,i,null);return}}this.g.length>0&&await Promise.race(this.g.map(g=>g.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(g){const $=new Error;if(g&&g.name&&($.name=g.name),g&&g.message?$.message=`Activating extension '${this.c.value}' failed: ${g.message}.`:$.message=`Activating extension '${this.c.value}' failed: ${g}.`,g&&g.stack&&($.stack=g.stack),this.h=new A($),this.b&&r.$4(g))return;this.j.onExtensionActivationError(this.c,$,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(g)}}};a=Ze([Ve(6,L.$7j)],a)}),define(Ee[319],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ee[159],Se([1,0,258,14,44,146,116,36,24,319,115,147]),function(oe,e,r,u,P,T,L,R,p,l,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=void 0;const f=R.$ko.as(L.$lo.JSONContribution);class A{constructor(n,t,c){this.a=n,this.b=t,this.c=c}d(n,t){this.a({type:n,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(n){this.d(P.default.Error,n)}warn(n){this.d(P.default.Warning,n)}info(n){this.d(P.default.Info,n)}}e.$JG=A;class w{static a(n){const t=new p.$Ym;for(let c=0,h=n.length;c<h;c++)t.add(n[c].description.identifier);return t}static compute(n,t){if(!n||!n.length)return new w(t,[]);if(!t||!t.length)return new w([],n);const c=this.a(n),h=this.a(t),s=t.filter(y=>!c.has(y.description.identifier)),m=n.filter(y=>!h.has(y.description.identifier));return new w(s,m)}constructor(n,t){this.added=n,this.removed=t}}e.$KG=w;class a{constructor(n,t){this.name=n,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(n){if(this.a!==null)throw new Error("Handler already set!");return this.a=n,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(n){this.c=w.compute(this.b,n),this.b=n,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(n){(0,u.$1)(n)}}}e.$LG=a;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[r.localize(0,null),r.localize(1,null)]},g="vscode://schemas/vscode-extensions";e.$MG={properties:{engines:{type:"object",description:r.localize(2,null),properties:{vscode:{type:"string",description:r.localize(3,null),default:"^1.22.0"}}},publisher:{description:r.localize(4,null),type:"string"},displayName:{description:r.localize(5,null),type:"string"},categories:{description:r.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$Wm},{type:"string",const:"Languages",deprecationMessage:r.localize(7,null)}]}},galleryBanner:{type:"object",description:r.localize(8,null),properties:{color:{description:r.localize(9,null),type:"string"},theme:{description:r.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:r.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:r.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:r.localize(13,null)},enabledApiProposals:{markdownDescription:r.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}},api:{markdownDescription:r.localize(15,null),type:"string",enum:["none"],enumDescriptions:[r.localize(16,null)]},activationEvents:{description:r.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:r.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:r.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:r.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:r.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:r.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:r.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:r.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:r.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:r.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:r.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:r.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:r.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:r.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:r.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:r.localize(32,null)},{label:"onUri",body:"onUri",description:r.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:r.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:r.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:r.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:r.localize(37,null)},{label:"onRenderer",description:r.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:r.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:r.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:r.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:r.localize(42,null)},{label:"*",description:r.localize(43,null),body:"*"}]}},badges:{type:"array",description:r.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:r.localize(45,null)},href:{type:"string",description:r.localize(46,null)},description:{type:"string",description:r.localize(47,null)}}}},markdown:{type:"string",description:r.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:r.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:r.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$2o}},extensionPack:{description:r.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$2o}},extensionKind:{description:r.localize(52,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:r.localize(53,null)},{body:["workspace"],description:r.localize(54,null)},{body:["ui","workspace"],description:r.localize(55,null)},{body:["workspace","ui"],description:r.localize(56,null)},{body:[],description:r.localize(57,null)}]},capabilities:{description:r.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:r.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:r.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(61,null),r.localize(62,null),r.localize(63,null)]},description:{type:"string",markdownDescription:r.localize(64,null)}}},untrustedWorkspaces:{description:r.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:r.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[r.localize(67,null),r.localize(68,null),r.localize(69,null)]},restrictedConfigurations:{description:r.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:r.localize(71,null)}}}}},sponsor:{description:r.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:r.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:r.localize(74,null),type:"string"},"vscode:uninstall":{description:r.localize(75,null),type:"string"}}},icon:{type:"string",description:r.localize(76,null)},l10n:{type:"string",description:r.localize(77,null)},pricing:{type:"string",markdownDescription:r.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class ${constructor(){this.a=new Map}registerExtensionPoint(n){if(this.a.has(n.extensionPoint))throw new Error("Duplicate extension point: "+n.extensionPoint);const t=new a(n.extensionPoint,n.defaultExtensionKind);return this.a.set(n.extensionPoint,t),n.activationEventsGenerator&&D.$AG.register(n.extensionPoint,n.activationEventsGenerator),e.$MG.properties.contributes.properties[n.extensionPoint]=n.jsonSchema,f.registerSchema(g,e.$MG),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$NG=$;const i={ExtensionsRegistry:"ExtensionsRegistry"};R.$ko.add(i.ExtensionsRegistry,new $),e.$OG=R.$ko.as(i.ExtensionsRegistry),f.registerSchema(g,e.$MG),f.registerSchema(I.$ok,{properties:{extensionEnabledApiProposals:{description:r.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(l.allApiProposals),markdownEnumDescriptions:Object.values(l.allApiProposals)}}]}}}})}),define(Ee[320],Se([1,0,4,40,3,13,249,24,5,12,26,159]),function(oe,e,r,u,P,T,L,R,p,l,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4G=e.$3G=e.$2G=e.ChatMessageRole=void 0;var f;(function(a){a[a.System=0]="System",a[a.User=1]="User",a[a.Assistant=2]="Assistant"})(f||(e.ChatMessageRole=f={})),e.$2G=(0,p.$Ai)("ILanguageModelsService");const A={type:"object",properties:{vendor:{type:"string",description:(0,L.localize)(0,null)}}};e.$3G=D.$OG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,L.localize)(1,null),oneOf:[A,{type:"array",items:A}]},activationEventsGenerator:(a,d)=>{for(const g of a)d.push(`onLanguageModelChat:${g.vendor}`)}});let w=class{constructor(d,g){this.e=d,this.f=g,this.a=new P.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new r.$he),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$3G.setHandler($=>{this.c.clear();for(const o of $){if(!(0,I.$UG)(o.description,"chatProvider")){o.collector.error((0,L.localize)(2,null));continue}for(const n of u.Iterable.wrap(o.value)){if(this.c.has(n.vendor)){o.collector.error((0,L.localize)(3,null,n.vendor));continue}if((0,T.$$e)(n.vendor)){o.collector.error((0,L.localize)(4,null));continue}if(n.vendor.trim()!==n.vendor){o.collector.error((0,L.localize)(5,null));continue}this.c.add(n.vendor)}}const i=[];for(const[o,n]of this.b)this.c.has(n.metadata.vendor)||(this.b.delete(o),i.push(o));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(d){return this.b.get(d)?.metadata}async selectLanguageModels(d){if(d.vendor)await this.e.activateByEvent(`onLanguageModelChat:${d.vendor}}`);else{const $=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all($)}const g=[];for(const[$,i]of this.b)(d.vendor===void 0||i.metadata.vendor===d.vendor)&&(d.family===void 0||i.metadata.family===d.family)&&(d.version===void 0||i.metadata.version===d.version)&&(d.identifier===void 0||i.metadata.id===d.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(o=>R.$Xm.equals(o,d.extension)))&&g.push($);return this.f.trace("[LM] selected language models",d,g),g}registerLanguageModelChat(d,g){if(this.f.trace("[LM] registering language model chat",d,g.metadata),!this.c.has(g.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${g.metadata.vendor}.`);if(this.b.has(d))throw new Error(`Chat response provider with identifier ${d} is already registered.`);return this.b.set(d,g),this.d.fire({added:[{identifier:d,metadata:g.metadata}]}),(0,P.$Sc)(()=>{this.b.delete(d)&&(this.d.fire({removed:[d]}),this.f.trace("[LM] UNregistered language model chat",d,g.metadata))})}makeLanguageModelChatRequest(d,g,$,i,o,n){const t=this.b.get(d);if(!t)throw new Error(`Chat response provider with identifier ${d} is not registered.`);return t.provideChatResponse($,g,i,o,n)}computeTokenLength(d,g,$){const i=this.b.get(d);if(!i)throw new Error(`Chat response provider with identifier ${d} is not registered.`);return i.provideTokenCount(g,$)}};e.$4G=w,e.$4G=w=Ze([Ve(0,I.$RG),Ve(1,l.$7j)],w)}),define(Ee[321],Se([1,0,253,18,25,159,35,4]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uI=void 0;const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:r.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:r.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:r.localize(2,null),default:""}}};var l;(function(f){function A(w,a,d){if(!w)return;const g=u.$ag(w.type)?w.type:void 0;if(!g||g.length===0){d.error(r.localize(3,null));return}const $=[];if(Array.isArray(w.required))for(const i of w.required)u.$ag(i)&&$.push(i);return{extensionId:a.value,taskType:g,required:$,properties:w.properties?P.$0n(w.properties):{},when:w.when?L.$yj.deserialize(w.when):void 0}}f.from=A})(l||(l={}));const I=T.$OG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(f,A)=>{for(const w of f)w.type&&A.push(`onTaskType:${w.type}`)},jsonSchema:{description:r.localize(4,null),type:"array",items:p}});class D{constructor(){this.d=new R.$he,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((A,w)=>{I.setHandler((a,d)=>{this.c=void 0;try{for(const g of d.removed){const $=g.value;for(const i of $)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const g of d.added){const $=g.value;for(const i of $){const o=l.from(i,g.description.identifier,g.collector);o&&(this.a[o.taskType]=o)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}A(void 0)})})}onReady(){return this.b}get(A){return this.a[A]}all(){return Object.keys(this.a).map(A=>this.a[A])}getJsonSchema(){if(this.c===void 0){const A=[];for(const w of this.all()){const a={type:"object",additionalProperties:!1};w.required.length>0&&(a.required=w.required.slice(0)),w.properties!==void 0?a.properties=P.$0n(w.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[w.taskType]},A.push(a)}this.c={oneOf:A}}return this.c}}e.$uI=new D}),define(Ee[322],Se([1,0,254,18,23,25,35,321,45]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$EI=e.JsonSchemaVersion=e.ExecutionEngine=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$yI=e.ShellQuoting=e.$xI=e.$wI=e.$vI=void 0,e.$vI="settings",e.$wI=new L.$Rj("taskRunning",!1,r.localize(0,null)),e.$xI=r.localize2(2,"Tasks");var l;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(l||(e.ShellQuoting=l={})),e.$yI="$customized",function(N){function F(X){if(!X)return N.Strong;switch(X.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=F}(l||(e.ShellQuoting=l={}));var I;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var D;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(D||(e.RevealKind=D={})),function(N){function F(X){switch(X.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=F}(D||(e.RevealKind=D={}));var f;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(f||(e.RevealProblemKind=f={})),function(N){function F(X){switch(X.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=F}(f||(e.RevealProblemKind=f={}));var A;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(A||(e.PanelKind=A={})),function(N){function F(X){switch(X.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=F}(A||(e.PanelKind=A={}));var w;(function(N){N.defaults={echo:!0,reveal:D.Always,revealProblems:f.Never,focus:!1,panel:A.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var a;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(a||(e.RuntimeType=a={})),function(N){function F(se){switch(se.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=F;function X(se){switch(se){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=X}(a||(e.RuntimeType=a={}));var d;(function(N){function F(X){return u.$ag(X)?X:X.value}N.value=F})(d||(e.CommandString=d={}));var g;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function F(se){return se===N.Clean._id||se===N.Build._id||se===N.Rebuild._id||se===N.Test._id}N.is=F;function X(se){if(se!==void 0)return u.$ag(se)?F(se)?{_id:se,isDefault:!1}:void 0:se}N.from=X})(g||(e.TaskGroup=g={}));var $;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})($||(e.TaskScope=$={}));var i;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function F(X){switch(X){case N.User:return p.ConfigurationTarget.USER;case N.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}N.toConfigurationTarget=F})(i||(e.TaskSourceKind=i={}));var o;(function(N){N.parallel="parallel",N.sequence="sequence"})(o||(e.DependsOrder=o={}));var n;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var t;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(t||(e.RunOptions=t={}));class c{constructor(F,X,se,W,H,V){this._label="",this._id=F,X&&(this._label=X),se&&(this.type=se),this.runOptions=W,this.configurationProperties=H,this._source=V}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,X=!1){if(F===void 0)return!1;if(u.$ag(F))return F===this._label||F===this.configurationProperties.identifier||X&&F===this._id;const se=this.getDefinition(!0);return se!==void 0&&se._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$zI=c;class h extends c{constructor(F,X,se,W,H,V,x,he){super(F,se,void 0,x,he,X),this.command={},this._source=X,this.hasDefinedMatchers=V,H&&(this.command=H)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let X;switch(this.command?this.command.runtime:void 0){case a.Shell:X="shell";break;case a.Process:X="process";break;case a.CustomExecution:X="customExecution";break;case void 0:X="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:X,_key:this._id,id:this._id}}}static is(F){return F instanceof h}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$vI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let X=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(X+=this._source.kind);const se={type:e.$yI,folder:F,id:X};return JSON.stringify(se)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$$g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new h(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$AI=h;class s extends c{constructor(F,X,se,W,H,V,x){super(F,se,W,V,x,X),this._source=X,this.configures=H}static is(F){return F instanceof s}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$$g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$vI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let X=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(X+=this._source.kind);const se={type:e.$yI,folder:F,id:X};return JSON.stringify(se)}}e.$BI=s;class m extends c{constructor(F,X,se,W,H,V,x,he,ne){super(F,se,W,he,ne,X),this.defines=H,this.hasDefinedMatchers=x,this.command=V,this.icon=ne.icon,this.hide=ne.hide}clone(){return new m(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof m}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===$.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new m(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$CI=m;class y extends c{constructor(F,X,se,W,H,V){super(F,se,W,H,V,X),this._source=X}clone(){return new y(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof y}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new y(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$DI=y;var S;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(N){N._default=N.Terminal}(S||(e.ExecutionEngine=S={}));var E;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(E||(e.JsonSchemaVersion=E={}));class k{constructor(F){this.c=new Map;for(let X=0;X<F.length;X++)this.c.set(F[X].uri.toString(),X)}compare(F,X){const se=F.getWorkspaceFolder(),W=X.getWorkspaceFolder();if(se&&W){let H=this.c.get(se.uri.toString());H=H===void 0?0:H+1;let V=this.c.get(W.uri.toString());return V=V===void 0?0:V+1,H===V?F._label.localeCompare(X._label):H-V}else return!se&&W?-1:se&&!W?1:0}}e.$EI=k;var C;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(C||(e.TaskEventKind=C={}));var v;(function(N){N.SingleRun="singleRun",N.Background="background"})(v||(e.TaskRunType=v={}));var b;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var O;(function(N){function F(he){return{taskId:he._id,taskName:he.configurationProperties.name,runType:he.configurationProperties.isBackground?v.Background:v.SingleRun,group:he.configurationProperties.group,__task:he}}function X(he,ne,we){return{...F(he),kind:C.Start,terminalId:ne,resolvedVariables:we}}N.start=X;function se(he,ne,we){return{...F(he),kind:C.ProcessStarted,terminalId:ne,processId:we}}N.processStarted=se;function W(he,ne,we){return{...F(he),kind:C.ProcessEnded,terminalId:ne,exitCode:we}}N.processEnded=W;function H(he,ne,we){return{...F(he),kind:C.Terminated,exitReason:we,terminalId:ne}}N.terminated=H;function V(he,ne,we){return{...F(ne),kind:he,terminalId:we}}N.general=V;function x(){return{kind:C.Changed}}N.changed=x})(O||(e.TaskEvent=O={}));var U;(function(N){function F(se){const W=Object.keys(se).sort();let H="";for(const V of W){let x=se[V];x instanceof Object?x=F(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),H+=V+","+x+","}return H}function X(se){const H={_key:F(se),type:se.taskType};return Object.assign(H,se),H}N.create=X})(U||(e.KeyedTaskIdentifier=U={}));var z;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.reconnection",N.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var j;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(j||(e.TasksSchemaProperties=j={}));var M;(function(N){function F(X,se){const W=R.$uI.get(X.type);if(W===void 0){const he=T.$0n(X);return delete he._key,U.create(he)}const H=Object.create(null);H.type=W.taskType;const V=new Set;W.required.forEach(he=>V.add(he));const x=W.properties;for(const he of Object.keys(x)){const ne=X[he];if(ne!=null)H[he]=ne;else if(V.has(he)){const we=x[he];if(we.default!==void 0)H[he]=T.$0n(we.default);else switch(we.type){case"boolean":H[he]=!1;break;case"number":case"integer":H[he]=0;break;case"string":H[he]="";break;default:se.error(r.localize(1,null,JSON.stringify(X,void 0,0),he));return}}}return U.create(H)}N.createTaskIdentifier=F})(M||(e.TaskDefinition=M={}))}),define(Ee[323],Se([1,0,14]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=e.$pbc=void 0;class u{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,R)=>{this.b=L,this.d=R,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,r.$1)(L))}then(L,R){return this.j().then(L,R)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$pbc=u;class P extends u{constructor(){super(),this.h=!0,this.i=new r.$5}}e.$qbc=P}),define(Ee[52],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lw=e.$Iw=void 0,e.$Jw=P,e.$Kw=T;class r{constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++r.count}}e.$Iw=r,r.count=0;const u=[];function P(R){const p=new r(R);return u[p.nid]=p,p}function T(R){return u[R].sid}class L{constructor(p){this.value=p}}e.$Lw=L}),define(Ee[6],Se([1,0,52]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$uM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var u;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(u||(e.TextEditorRevealType=u={}));var P;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var T;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var L;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var R;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(R||(e.WebviewMessageArrayBufferViewType=R={}));var p;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var l;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(l||(e.NotebookEditorRevealType=l={}));var I;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output",a[a.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class D{static mixin(d){return d._id=D.a++,d}}e.$uM=D,D.a=0;var f;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(f||(e.ISuggestDataDtoField=f={}));var A;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(A||(e.ISuggestResultDtoField=A={}));var w;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(w||(e.ExtHostTestingResource=w={})),e.$vM={MainThreadAuthentication:(0,r.$Jw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,r.$Jw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,r.$Jw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,r.$Jw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,r.$Jw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,r.$Jw)("MainThreadChatVariables"),MainThreadClipboard:(0,r.$Jw)("MainThreadClipboard"),MainThreadCommands:(0,r.$Jw)("MainThreadCommands"),MainThreadComments:(0,r.$Jw)("MainThreadComments"),MainThreadConfiguration:(0,r.$Jw)("MainThreadConfiguration"),MainThreadConsole:(0,r.$Jw)("MainThreadConsole"),MainThreadDebugService:(0,r.$Jw)("MainThreadDebugService"),MainThreadDecorations:(0,r.$Jw)("MainThreadDecorations"),MainThreadDiagnostics:(0,r.$Jw)("MainThreadDiagnostics"),MainThreadDialogs:(0,r.$Jw)("MainThreadDiaglogs"),MainThreadDocuments:(0,r.$Jw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,r.$Jw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,r.$Jw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,r.$Jw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,r.$Jw)("MainThreadEditorTabs"),MainThreadErrors:(0,r.$Jw)("MainThreadErrors"),MainThreadTreeViews:(0,r.$Jw)("MainThreadTreeViews"),MainThreadDownloadService:(0,r.$Jw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,r.$Jw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,r.$Jw)("MainThreadLanguages"),MainThreadLogger:(0,r.$Jw)("MainThreadLogger"),MainThreadMessageService:(0,r.$Jw)("MainThreadMessageService"),MainThreadOutputService:(0,r.$Jw)("MainThreadOutputService"),MainThreadProgress:(0,r.$Jw)("MainThreadProgress"),MainThreadQuickDiff:(0,r.$Jw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,r.$Jw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,r.$Jw)("MainThreadStatusBar"),MainThreadSecretState:(0,r.$Jw)("MainThreadSecretState"),MainThreadStorage:(0,r.$Jw)("MainThreadStorage"),MainThreadSpeech:(0,r.$Jw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,r.$Jw)("MainThreadTelemetry"),MainThreadTerminalService:(0,r.$Jw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,r.$Jw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,r.$Jw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,r.$Jw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,r.$Jw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,r.$Jw)("MainThreadCustomEditors"),MainThreadUrls:(0,r.$Jw)("MainThreadUrls"),MainThreadUriOpeners:(0,r.$Jw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,r.$Jw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,r.$Jw)("MainThreadWorkspace"),MainThreadFileSystem:(0,r.$Jw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,r.$Jw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,r.$Jw)("MainThreadExtensionService"),MainThreadSCM:(0,r.$Jw)("MainThreadSCM"),MainThreadSearch:(0,r.$Jw)("MainThreadSearch"),MainThreadShare:(0,r.$Jw)("MainThreadShare"),MainThreadTask:(0,r.$Jw)("MainThreadTask"),MainThreadWindow:(0,r.$Jw)("MainThreadWindow"),MainThreadLabelService:(0,r.$Jw)("MainThreadLabelService"),MainThreadNotebook:(0,r.$Jw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,r.$Jw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,r.$Jw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,r.$Jw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,r.$Jw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,r.$Jw)("MainThreadInteractive"),MainThreadTheming:(0,r.$Jw)("MainThreadTheming"),MainThreadTunnelService:(0,r.$Jw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,r.$Jw)("MainThreadManagedSockets"),MainThreadTimeline:(0,r.$Jw)("MainThreadTimeline"),MainThreadTesting:(0,r.$Jw)("MainThreadTesting"),MainThreadLocalization:(0,r.$Jw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,r.$Jw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,r.$Jw)("MainThreadAiEmbeddingVector")},e.$wM={ExtHostCommands:(0,r.$Jw)("ExtHostCommands"),ExtHostConfiguration:(0,r.$Jw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,r.$Jw)("ExtHostDiagnostics"),ExtHostDebugService:(0,r.$Jw)("ExtHostDebugService"),ExtHostDecorations:(0,r.$Jw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,r.$Jw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,r.$Jw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,r.$Jw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,r.$Jw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,r.$Jw)("ExtHostEditors"),ExtHostTreeViews:(0,r.$Jw)("ExtHostTreeViews"),ExtHostFileSystem:(0,r.$Jw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,r.$Jw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,r.$Jw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,r.$Jw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,r.$Jw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,r.$Jw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,r.$Jw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,r.$Jw)("ExtHostStatusBar"),ExtHostShare:(0,r.$Jw)("ExtHostShare"),ExtHostExtensionService:(0,r.$Jw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,r.$Jw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,r.$Jw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,r.$Jw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,r.$Jw)("ExtHostSCM"),ExtHostSearch:(0,r.$Jw)("ExtHostSearch"),ExtHostTask:(0,r.$Jw)("ExtHostTask"),ExtHostWorkspace:(0,r.$Jw)("ExtHostWorkspace"),ExtHostWindow:(0,r.$Jw)("ExtHostWindow"),ExtHostWebviews:(0,r.$Jw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,r.$Jw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,r.$Jw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,r.$Jw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,r.$Jw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,r.$Jw)("ExtHostEditorTabs"),ExtHostProgress:(0,r.$Jw)("ExtHostProgress"),ExtHostComments:(0,r.$Jw)("ExtHostComments"),ExtHostSecretState:(0,r.$Jw)("ExtHostSecretState"),ExtHostStorage:(0,r.$Jw)("ExtHostStorage"),ExtHostUrls:(0,r.$Jw)("ExtHostUrls"),ExtHostUriOpeners:(0,r.$Jw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,r.$Jw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,r.$Jw)("ExtHostOutputService"),ExtHostLabelService:(0,r.$Jw)("ExtHostLabelService"),ExtHostNotebook:(0,r.$Jw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,r.$Jw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,r.$Jw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,r.$Jw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,r.$Jw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,r.$Jw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,r.$Jw)("ExtHostInteractive"),ExtHostChatAgents2:(0,r.$Jw)("ExtHostChatAgents"),ExtHostChatVariables:(0,r.$Jw)("ExtHostChatVariables"),ExtHostChatProvider:(0,r.$Jw)("ExtHostChatProvider"),ExtHostSpeech:(0,r.$Jw)("ExtHostSpeech"),ExtHostEmbeddings:(0,r.$Jw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,r.$Jw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,r.$Jw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,r.$Jw)("ExtHostTheming"),ExtHostTunnelService:(0,r.$Jw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,r.$Jw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,r.$Jw)("ExtHostAuthentication"),ExtHostTimeline:(0,r.$Jw)("ExtHostTimeline"),ExtHostTesting:(0,r.$Jw)("ExtHostTesting"),ExtHostTelemetry:(0,r.$Jw)("ExtHostTelemetry"),ExtHostLocalization:(0,r.$Jw)("ExtHostLocalization")}}),define(Ee[96],Se([1,0,5,12,6,20]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=e.$Tmc=e.$Smc=void 0,e.$Smc=(0,r.$Ai)("IExtHostApiDeprecationService");let L=class{constructor(p,l){this.c=l,this.a=new Set,this.b=p.getProxy(P.$vM.MainThreadTelemetry)}report(p,l,I){const D=this.d(p,l);this.a.has(D)||(this.a.add(D),l.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:l.identifier.value,apiId:p}))}d(p,l){return`${p}-${l.identifier.value}`}};e.$Tmc=L,e.$Tmc=L=Ze([Ve(0,T.$ZO),Ve(1,u.$7j)],L),e.$Umc=Object.freeze(new class{report(R,p,l){}})}),define(Ee[324],Se([1,0,6]),function(oe,e,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=void 0;class u{constructor(T){const L=T.getProxy(r.$vM.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(R){return L.$writeText(R)}})}}e.$8mc=u}),define(Ee[325],Se([1,0,25,6,30,20]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=void 0;let L=class{constructor(I,D){this.a=I.getProxy(u.$vM.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,D){const f=this,A=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){f.e(I,D,A,arguments)}})}e(I,D,f,A){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:p(A,this.b)}),this.c&&this.f(I,f,A)}};e.$2oc=L,e.$2oc=L=Ze([Ve(0,T.$ZO),Ve(1,P.$dP)],L);const R=1e5;function p(l,I){const D=[];if(l.length)for(let f=0;f<l.length;f++){let A=l[f];if(typeof A>"u")A="undefined";else if(A instanceof Error){const w=A;w.stack?A=w.stack:A=w.toString()}D.push(A)}if(I){const f=new Error().stack;f&&D.push({__$stack:f.split(`
`).slice(3).join(`
`)})}try{const f=(0,r.$co)(D);return f.length>R?"Output omitted for a large object that exceeds the limits":f}catch(f){return`Output omitted for an object that cannot be inspected ('${f.toString()}')`}}}),define(Ee[326],Se([1,0,2,6,26]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=void 0;class T{constructor(R){this.a=R.getProxy(u.$vM.MainThreadDialogs)}showOpenDialog(R,p){return p?.allowUIResources&&(0,P.$VG)(R,"showLocal"),this.a.$showOpenDialog(p).then(l=>l?l.map(I=>r.URI.revive(I)):void 0)}showSaveDialog(R){return this.a.$showSaveDialog(R).then(p=>p?r.URI.revive(p):void 0)}}e.$5nc=T}),define(Ee[327],Se([1,0,21,4,3,6]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=void 0;class L{constructor(p){this.b=new Map,this.c=new u.$he,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(T.$vM.MainThreadEmbeddings)}registerEmbeddingsProvider(p,l,I){if(this.d.has(l))throw new Error("An embeddings provider for this model is already registered");const D=this.e++;return this.a.$registerEmbeddingProvider(D,l),this.b.set(D,{id:l,provider:I}),(0,P.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(D),this.b.delete(D)})}async computeEmbeddings(p,l,I){I??(I=r.CancellationToken.None);let D=!1;typeof l=="string"&&(l=[l],D=!0);const f=await this.a.$computeEmbeddings(p,l,I);if(f.length!==l.length)throw new Error;if(D){if(f.length!==1)throw new Error;return f[0]}return f}async $provideEmbeddings(p,l,I){const D=this.b.get(p);if(!D)return[];const f=await D.provider.provideEmbeddings(l,I);return f||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$8nc=L}),define(Ee[328],Se([1,0,3,6]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=void 0;class P{constructor(L){this.b=0,this.a=L.getProxy(u.$vM.MainThreadLabelService)}$registerResourceLabelFormatter(L){const R=this.b++;return this.a.$registerResourceLabelFormatter(R,L),(0,r.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(R)})}}e.$moc=P}),define(Ee[123],Se([1,0,11,13,2,5,12,6,30,20]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=e.$Mnc=void 0;let I=class{constructor(f,A,w){this.f=w,this.d=new Map,this.a=A.getProxy(R.$vM.MainThreadLocalization),this.b=f.environment.appLanguage,this.c=this.b===r.$a}getMessage(f,A){const{message:w,args:a,comment:d}=A;if(this.c)return(0,u.$af)(w,a??{});let g=w;d&&d.length>0&&(g+=`/${Array.isArray(d)?d.join(""):d}`);const $=this.d.get(f)?.contents[g];return $||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${g}`),(0,u.$af)($??w,a??{})}getBundle(f){return this.d.get(f)?.contents}getBundleUri(f){return this.d.get(f)?.uri}async initializeLocalizedMessages(f){if(this.c||!f.l10n&&!f.isBuiltin||this.d.has(f.identifier.value))return;let A;const w=await this.g(f);if(!w){this.f.error(`No bundle location found for extension ${f.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(w),d=JSON.parse(a);A=f.isBuiltin?d.contents?.bundle:d}catch(a){this.f.error(`Failed to load translations for ${f.identifier.value} from ${w}: ${a.message}`);return}A&&this.d.set(f.identifier.value,{contents:A,uri:w})}async g(f){if(f.isBuiltin){const A=await this.a.$fetchBuiltInBundleUri(f.identifier.value,this.b);return P.URI.revive(A)}return f.l10n?P.URI.joinPath(f.extensionLocation,f.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Mnc=I,e.$Mnc=I=Ze([Ve(0,p.$dP),Ve(1,l.$ZO),Ve(2,L.$7j)],I),e.$Nnc=(0,T.$Ai)("IExtHostLocalizationService")}),define(Ee[160],Se([1,0,12,6,30,20,2,55]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1oc=void 0;let p=class extends r.$fk{constructor(D,f){super(f.logLevel,f.logsLocation,f.loggers.map(A=>(0,R.$0h)(A))),this.r=D.getProxy(u.$vM.MainThreadLogger)}$setLogLevel(D,f){f?this.setLogLevel(L.URI.revive(f),D):this.setLogLevel(D)}setVisibility(D,f){super.setVisibility(D,f),this.r.$setVisibility(D,f)}s(D,f,A){return new l(this.r,D,f,A)}};e.$1oc=p,e.$1oc=p=Ze([Ve(0,T.$ZO),Ve(1,P.$dP)],p);class l extends r.$ak{constructor(D,f,A,w){super(w?.logLevel==="always"),this.r=D,this.s=f,this.m=!1,this.n=[],this.setLevel(A),this.r.$createLogger(f,w).then(()=>{this.u(this.n),this.m=!0})}g(D,f){const A=[[D,f]];this.m?this.u(A):this.n.push(...A)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(Ee[124],Se([1,0,6,5,3,20,22]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=e.$Onc=void 0,e.$Onc=(0,u.$Ai)("IExtHostManagedSockets");let R=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(r.$vM.MainThreadManagedSockets)}setFactory(D,f){for(const A of this.d.values())A.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(D,f),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const f=++this.b,A=await this.c.makeConnection(),w=new P.$Tc;return this.d.set(f,new l(f,A,w)),w.add((0,P.$Sc)(()=>this.d.delete(f))),w.add(A.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(f),w.dispose()})),w.add(A.onDidClose(a=>{this.a.$onDidManagedSocketClose(f,a?.stack??a?.message),w.dispose()})),w.add(A.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(f,L.$Je.wrap(a)))),f}$remoteSocketWrite(D,f){this.d.get(D)?.actual.send(f.buffer)}$remoteSocketEnd(D){const f=this.d.get(D);f&&(f.actual.end(),f.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Pnc=R,e.$Pnc=R=Ze([Ve(0,T.$ZO)],R);class p{constructor(D,f){this.socketFactoryId=D,this.makeConnection=f}}class l extends P.$Uc{constructor(D,f,A){super(),this.socketId=D,this.actual=f,this.B(A)}}}),define(Ee[329],Se([1,0,6,12,26]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=void 0;function T(R){return R&&R.title}let L=class{constructor(p,l){this.b=l,this.a=p.getProxy(r.$vM.MainThreadMessageService)}showMessage(p,l,I,D,f){const A={source:{identifier:p.identifier,label:p.displayName||p.name}};let w;typeof D=="string"||T(D)?w=[D,...f]:(A.modal=D?.modal,A.useCustom=D?.useCustom,A.detail=D?.detail,w=f),A.useCustom&&(0,P.$VG)(p,"resolvers");const a=[];let d=!1;for(let g=0;g<w.length;g++){const $=w[g];if(typeof $=="string")a.push({title:$,handle:g,isCloseAffordance:!1});else if(typeof $=="object"){const{title:i,isCloseAffordance:o}=$;a.push({title:i,isCloseAffordance:!!o,handle:g}),o&&(d?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,$):d=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,$)}return this.a.$showMessage(l,I,A,a).then(g=>{if(typeof g=="number")return w[g]})}};e.$ooc=L,e.$ooc=L=Ze([Ve(1,u.$7j)],L)}),define(Ee[330],Se([1,0,3,18,2,26,6]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=void 0;class R{constructor(l){this.b=new Map,this.a=l.getProxy(L.$vM.MainThreadProfileContentHandlers)}registerProfileContentHandler(l,I,D){if((0,T.$VG)(l,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,D),this.a.$registerProfileContentHandler(I,D.name,D.description,l.identifier.value),(0,r.$Sc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(l,I,D,f){const A=this.b.get(l);if(!A)throw new Error(`Unknown handler with id: ${l}`);return A.saveProfile(I,D,f)}async $readProfile(l,I,D){const f=this.b.get(l);if(!f)throw new Error(`Unknown handler with id: ${l}`);return f.readProfile((0,u.$ag)(I)?I:P.URI.revive(I),D)}}e.$xoc=R}),define(Ee[125],Se([1,0,6,4,5]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=e.$Jnc=void 0;class T{constructor(R){this.b=new u.$he,this.onDidChangePassword=this.b.event,this.a=R.getProxy(r.$vM.MainThreadSecretState)}async $onDidChangePassword(R){this.b.fire(R)}get(R,p){return this.a.$getPassword(R,p)}store(R,p,l){return this.a.$setPassword(R,p,l)}delete(R,p){return this.a.$deletePassword(R,p)}}e.$Jnc=T,e.$Knc=(0,P.$Ai)("IExtHostSecretState")}),define(Ee[331],Se([1,0,21,3,6]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0;class T{constructor(R){this.c=new Map,this.d=new Map,this.f=new Map,this.b=R.getProxy(P.$vM.MainThreadSpeech)}async $createSpeechToTextSession(R,p,l){const I=this.c.get(R);if(!I)return;const D=new u.$Tc,f=new r.$se;this.d.set(p,f);const A=await I.provideSpeechToTextSession(f.token,l?{language:l}:void 0);A&&(D.add(A.onDidChange(w=>{f.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,w)})),D.add(f.token.onCancellationRequested(()=>D.dispose())))}async $cancelSpeechToTextSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R)}async $createTextToSpeechSession(R,p,l){const I=this.c.get(R);if(!I)return;const D=new u.$Tc,f=new r.$se;this.d.set(p,f);const A=await I.provideTextToSpeechSession(f.token,l?{language:l}:void 0);A&&(this.f.set(p,A),D.add(A.onDidChange(w=>{f.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,w)})),D.add(f.token.onCancellationRequested(()=>D.dispose())))}async $synthesizeSpeech(R,p){this.f.get(R)?.synthesize(p)}async $cancelTextToSpeechSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R),this.f.delete(R)}async $createKeywordRecognitionSession(R,p){const l=this.c.get(R);if(!l)return;const I=new u.$Tc,D=new r.$se;this.d.set(p,D);const f=await l.provideKeywordRecognitionSession(D.token);f&&(I.add(f.onDidChange(A=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,A)})),I.add(D.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(R){this.d.get(R)?.dispose(!0),this.d.delete(R)}registerProvider(R,p,l){const I=T.a++;return this.c.set(I,l),this.b.$registerProvider(I,p,{extension:R,displayName:R.value}),(0,u.$Sc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$Eoc=T,T.a=1}),define(Ee[126],Se([1,0,6,4,5]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=e.$znc=void 0;class T{constructor(R,p){this.c=p,this.b=new u.$he,this.onDidChangeStorage=this.b.event,this.a=R.getProxy(r.$vM.MainThreadStorage)}registerExtensionStorageKeysToSync(R,p){this.a.$registerExtensionStorageKeysToSync(R,p)}async initializeExtensionStorage(R,p,l){const I=await this.a.$initializeExtensionStorage(R,p);let D;return I&&(D=this.d(R,p,I)),D||l}setValue(R,p,l){return this.a.$setValue(R,p,l)}$acceptValue(R,p,l){const I=this.d(R,p,l);I&&this.b.fire({shared:R,key:p,value:I})}d(R,p,l){try{return JSON.parse(l)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${R}): ${I}`)}}}e.$znc=T,e.$Anc=(0,P.$Ai)("IExtHostStorage")}),define(Ee[332],Se([1,0,3,15,2,6]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uoc=void 0;class L{constructor(p){this.c=new Map,this.b=p.getProxy(T.$vM.MainThreadUriOpeners)}registerExternalUriOpener(p,l,I,D){if(this.c.has(l))throw new Error(`Opener with id '${l}' already registered`);const f=D.schemes.find(A=>!L.a.has(A));if(f)throw new Error(`Scheme '${f}' is not supported. Only http and https are currently supported.`);return this.c.set(l,I),this.b.$registerUriOpener(l,D.schemes,p,D.label),(0,r.$Sc)(()=>{this.c.delete(l),this.b.$unregisterUriOpener(l)})}async $canOpenUri(p,l,I){const D=this.c.get(p);if(!D)throw new Error(`Unknown opener with id: ${p}`);const f=P.URI.revive(l);return D.canOpenExternalUri(f,I)}async $openUri(p,l,I){const D=this.c.get(p);if(!D)throw new Error(`Unknown opener id: '${p}'`);return D.openExternalUri(P.URI.revive(l.resolvedUri),{sourceUri:P.URI.revive(l.sourceUri)},I)}}e.$Uoc=L,L.a=new Set([u.Schemas.http,u.Schemas.https])}),define(Ee[333],Se([1,0,6,2,3,14,24]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;class R{constructor(l){this.c=new L.$Ym,this.d=new Map,this.b=l.getProxy(r.$vM.MainThreadUrls)}registerUriHandler(l,I){const D=l.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const f=R.a++;return this.c.add(D),this.d.set(f,I),this.b.$registerUriHandler(f,D,l.displayName||l.name),(0,P.$Sc)(()=>{this.c.delete(D),this.d.delete(f),this.b.$unregisterUriHandler(f)})}$handleExternalUri(l,I){const D=this.d.get(l);if(!D)return Promise.resolve(void 0);try{D.handleUri(u.URI.revive(I))}catch(f){(0,T.$1)(f)}return Promise.resolve(void 0)}async createAppUri(l){return u.URI.revive(await this.b.$createAppUri(l))}}e.$Voc=R,R.a=0}),define(Ee[334],Se([1,0,22,6]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bsb=T,e.$csb=R;class P{constructor(){this.buffers=[]}add(l){let I=this.buffers.indexOf(l);return I<0&&(I=this.buffers.length,this.buffers.push(l)),I}}function T(p,l){if(l.serializeBuffersForPostMessage){const I=new P,f=JSON.stringify(p,(w,a)=>{if(a instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a)};if(ArrayBuffer.isView(a)){const d=L(a);if(d)return{$$vscode_array_buffer_reference$$:!0,index:I.add(a.buffer),view:{type:d,byteLength:a.byteLength,byteOffset:a.byteOffset}}}return a}),A=I.buffers.map(w=>{const a=new Uint8Array(w);return r.$Je.wrap(a)});return{message:f,buffers:A}}else return{message:JSON.stringify(p),buffers:[]}}function L(p){switch(p.constructor.name){case"Int8Array":return u.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return u.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return u.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return u.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return u.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return u.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return u.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return u.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return u.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return u.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return u.WebviewMessageArrayBufferViewType.BigUint64Array}}function R(p,l){const I=l.map(A=>{const w=new ArrayBuffer(A.byteLength);return new Uint8Array(w).set(A.buffer),w}),D=l.length?(A,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const a=w,{index:d}=a,g=I[d];if(a.view)switch(a.view.type){case u.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(g,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case u.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(g,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case u.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(g,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case u.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(g,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case u.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(g,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case u.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(g,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case u.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(g,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case u.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(g,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case u.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(g,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case u.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(g,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case u.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(g,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return w}:void 0;return{message:JSON.parse(p,D),arrayBuffers:I}}});var rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r},Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)};define(Ee[97],Se([1,0,4,3,15,25,2,262,334,122,6]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";var D,f,A,w,a,d,g,$,i,o,n,t,c;Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=e.$knc=void 0,e.$lnc=s,e.$nnc=S,e.$onc=E;class h{constructor(b,O,U,z,j,M,N){D.set(this,void 0),f.set(this,void 0),A.set(this,void 0),w.set(this,void 0),a.set(this,void 0),d.set(this,void 0),g.set(this,""),$.set(this,void 0),i.set(this,!1),o.set(this,!1),n.set(this,void 0),t.set(this,void 0),this._onMessageEmitter=new r.$he,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new r.$he),this._onDidDispose=Ge(this,c,"f").event,rt(this,D,b,"f"),rt(this,f,O,"f"),rt(this,$,U,"f"),rt(this,w,z,"f"),rt(this,a,j,"f"),rt(this,d,M,"f"),rt(this,n,s(M),"f"),rt(this,t,m(M),"f"),rt(this,A,N,"f")}dispose(){rt(this,i,!0,"f"),Ge(this,c,"f").fire(),Ge(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return rt(this,o,!0,"f"),(0,l.$PBb)(b,Ge(this,w,"f"))}get cspSource(){const b=Ge(this,d,"f").extensionLocation;if(b.scheme===P.Schemas.https||b.scheme===P.Schemas.http){let O=b.toString();return O.endsWith("/")||(O+="/"),O+" "+l.$OBb}return l.$OBb}get html(){return this.a(),Ge(this,g,"f")}set html(b){this.a(),Ge(this,g,"f")!==b&&(rt(this,g,b,"f"),Ge(this,t,"f")&&!Ge(this,o,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(rt(this,o,!0,"f"),Ge(this,A,"f").report("Webview vscode-resource: uris",Ge(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ge(this,f,"f").$setHtml(Ge(this,D,"f"),this.b(b)))}get options(){return this.a(),Ge(this,$,"f")}set options(b){this.a(),T.$bo(Ge(this,$,"f"),b)||Ge(this,f,"f").$setOptions(Ge(this,D,"f"),E(Ge(this,d,"f"),Ge(this,a,"f"),b)),rt(this,$,b,"f")}async postMessage(b){if(Ge(this,i,"f"))return!1;const O=(0,p.$bsb)(b,{serializeBuffersForPostMessage:Ge(this,n,"f")});return Ge(this,f,"f").$postMessage(Ge(this,D,"f"),O.message,...O.buffers)}a(){if(Ge(this,i,"f"))throw new Error("Webview is disposed")}b(b){if(!Ge(this,t,"f"))return b;const O=Ge(this,d,"f").extensionLocation?.scheme===P.Schemas.vscodeRemote,U=Ge(this,d,"f").extensionLocation.scheme===P.Schemas.vscodeRemote?Ge(this,d,"f").extensionLocation.authority:void 0;return b.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(z,j,M,N,F,X)=>{const se=L.URI.from({scheme:N||"file",path:decodeURIComponent(F)}),W=(0,l.$PBb)(se,{isRemote:O,authority:U}).toString();return`${j}${W}${X}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(z,j,M,N,F,X)=>{const se=L.URI.from({scheme:N||"file",path:decodeURIComponent(F)}),W=(0,l.$PBb)(se,{isRemote:O,authority:U}).toString();return`${j}${W}${X}`})}}e.$knc=h,D=new WeakMap,f=new WeakMap,A=new WeakMap,w=new WeakMap,a=new WeakMap,d=new WeakMap,g=new WeakMap,$=new WeakMap,i=new WeakMap,o=new WeakMap,n=new WeakMap,t=new WeakMap,c=new WeakMap;function s(v){try{const b=(0,R.$Rp)((0,R.$Qp)(v.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch{return!1}}function m(v){try{const b=(0,R.$Rp)((0,R.$Qp)(v.engines.vscode));return b?b.majorBase<1||b.majorBase===1&&b.minorBase<60:!1}catch{return!1}}class y extends u.$Uc{constructor(b,O,U,z,j){super(),this.c=O,this.f=U,this.g=z,this.h=j,this.b=new Map,this.a=b.getProxy(I.$vM.MainThreadWebviews)}dispose(){super.dispose();for(const b of this.b.values())b.dispose();this.b.clear()}$onMessage(b,O,U){const z=this.j(b);if(z){const{message:j}=(0,p.$csb)(O,U.value);z._onMessageEmitter.fire(j)}}$onMissingCsp(b,O){this.g.warn(`${O} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,O,U){const z=new h(b,this.a,k(O),this.c,this.f,U,this.h);this.b.set(b,z);const j=z._onDidDispose(()=>{j.dispose(),this.deleteWebview(b)});return z}deleteWebview(b){this.b.delete(b)}j(b){return this.b.get(b)}}e.$mnc=y;function S(v){return{id:v.identifier,location:v.extensionLocation}}function E(v,b,O){return{enableCommandUris:O.enableCommandUris,enableScripts:O.enableScripts,enableForms:O.enableForms,portMapping:O.portMapping,localResourceRoots:O.localResourceRoots||C(v,b)}}function k(v){return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,enableForms:v.enableForms,portMapping:v.portMapping,localResourceRoots:v.localResourceRoots?.map(b=>L.URI.from(b))}}function C(v,b){return[...(b?.getWorkspaceFolders()||[]).map(O=>O.uri),v.extensionLocation]}}),define(Ee[161],Se([1,0,4,15,13,2,5,20,6]),function(oe,e,r,u,P,T,L,R,p){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=e.$Xoc=void 0;let I=l=class{getState(){const f=this.d;return{get focused(){return f.focused},get active(){return f.active}}}constructor(f){this.c=new r.$he,this.onDidChangeWindowState=this.c.event,this.d=l.a,this.b=f.getProxy(p.$vM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:A,isActive:w})=>{this.onDidChangeWindowProperty("focused",A),this.onDidChangeWindowProperty("active",w)})}$onDidChangeWindowFocus(f){this.onDidChangeWindowProperty("focused",f)}$onDidChangeWindowActive(f){this.onDidChangeWindowProperty("active",f)}onDidChangeWindowProperty(f,A){A!==this.d[f]&&(this.d={...this.d,[f]:A},this.c.fire(this.d))}openUri(f,A){let w;if(typeof f=="string"){w=f;try{f=T.URI.parse(f)}catch{return Promise.reject(`Invalid uri - '${f}'`)}}return(0,P.$$e)(f.scheme)?Promise.reject("Invalid scheme - cannot be empty"):f.scheme===u.Schemas.command?Promise.reject(`Invalid scheme '${f.scheme}'`):this.b.$openUri(f,w,A)}async asExternalUri(f,A){if((0,P.$$e)(f.scheme))return Promise.reject("Invalid scheme - cannot be empty");const w=await this.b.$asExternalUri(f,A);return T.URI.from(w)}};e.$Xoc=I,I.a={focused:!0,active:!0},e.$Xoc=I=l=Ze([Ve(0,R.$ZO)],I),e.$Yoc=(0,L.$Ai)("IExtHostWindow")}),define(Ee[335],Se([1,0,325,30,20,94]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=void 0;const L=1024*1024;let R=class extends r.$2oc{constructor(l,I){super(l,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(l,I,D){const f=l==="error"||l==="warn"?process.stderr:process.stdout;this.g=!0,f.write(`
${T.NativeLogMarkers.Start}
`),I.apply(console,D),f.write(`
${T.NativeLogMarkers.End}
`),this.g=!1}j(l,I){const D=process[l],f=D.write;let A="";Object.defineProperty(D,"write",{set:()=>{},get:()=>(w,a,d)=>{if(!this.g){A+=w.toString(a);const g=A.length>L?A.length:A.lastIndexOf(`
`);g!==-1&&(console[I](A.slice(0,g)),A=A.slice(g+1))}f.call(D,w,a,d)}})}};e.$Apc=R,e.$Apc=R=Ze([Ve(0,P.$ZO),Ve(1,u.$dP)],R)}),define(Ee[336],Se([1,0,160,15,278,33]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=void 0;class L extends r.$1oc{s(p,l,I){return p.scheme===u.Schemas.file?new P.$dQ(I?.name||(0,T.$Wg)(),p.fsPath,!I?.donotRotate,!!I?.donotUseFormatters,l):super.s(p,l,I)}registerLogger(p){super.registerLogger(p),this.r.$registerLogger(p)}deregisterLogger(p){super.deregisterLogger(p),this.r.$deregisterLogger(p)}}e.$Mpc=L}),define(Ee[337],Se([1,0,7,22,21,27,14,4,3,41,139,323,52]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.ResponsiveState=e.RequestInitiator=void 0,e.$rbc=$,e.$sbc=i;function w(O,U){try{return JSON.stringify(O,U)}catch{return"null"}}const a="$$ref$$",d={[a]:-1};class g{constructor(U,z){this.jsonString=U,this.referencedBuffers=z}}function $(O,U=null,z=!1){const j=[];return{jsonString:(z?w:JSON.stringify)(O,(N,F)=>{if(typeof F>"u")return d;if(typeof F=="object"){if(F instanceof u.$Je){const X=j.push(F)-1;return{[a]:X}}if(U)return U(N,F)}return F}),referencedBuffers:j}}function i(O,U,z){return JSON.parse(O,(j,M)=>{if(M){const N=M[a];if(typeof N=="number")return U[N];if(z&&M.$mid===l.MarshalledId.Uri)return z.transformIncoming(M)}return M})}function o(O,U){return JSON.stringify(O,U)}function n(O){return O?(U,z)=>z&&z.$mid===l.MarshalledId.Uri?O.transformOutgoing(z):z:null}var t;(function(O){O[O.LocalSide=0]="LocalSide",O[O.OtherSide=1]="OtherSide"})(t||(e.RequestInitiator=t={}));var c;(function(O){O[O.Responsive=0]="Responsive",O[O.Unresponsive=1]="Unresponsive"})(c||(e.ResponsiveState=c={}));const h=()=>{},s=Symbol.for("rpcProtocol"),m=Symbol.for("rpcProxy");class y extends p.$Uc{constructor(U,z=null,j=null){super(),this[A]=!0,this.b=this.B(new R.$he),this.onDidChangeResponsiveState=this.b.event,this.c=U,this.f=z,this.g=j,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let M=0,N=f.$Iw.count;M<N;M++)this.m[M]=null,this.s[M]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=c.Responsive,this.z=0,this.C=0,this.D=this.B(new r.$Mh(()=>this.H(),1e3)),this.c.onMessage(M=>this.L(M))}dispose(){this.j=!0,Object.keys(this.w).forEach(U=>{const z=this.w[U];delete this.w[U],z.resolveErr(L.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(U){this.z===0&&(this.C=Date.now()+y.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(U){this.C=Date.now()+y.a,this.z--,this.z===0&&this.D.cancel(),this.I(c.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(c.Unresponsive):this.D.schedule())}I(U){this.y!==U&&(this.y=U,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(U){return this.g?(0,I.$Hn)(U,this.g):U}getProxy(U){const{nid:z,sid:j}=U;return this.s[z]||(this.s[z]=this.J(z,j)),this.s[z]}J(U,z){const j={get:(M,N)=>(typeof N=="string"&&!M[N]&&N.charCodeAt(0)===T.CharCode.DollarSign&&(M[N]=(...F)=>this.U(U,N,F)),N===m?z:M[N])};return new Proxy(Object.create(null),j)}set(U,z){return this.m[U.nid]=z,z}assertRegistered(U){for(let z=0,j=U.length;z<j;z++){const M=U[z];if(!this.m[M.nid])throw new Error(`Missing proxy instance ${M.sid}`)}}L(U){if(this.j)return;const z=U.byteLength,j=E.read(U,0),M=j.readUInt8(),N=j.readUInt32();switch(M){case v.RequestJSONArgs:case v.RequestJSONArgsWithCancellation:{let{rpcId:F,method:X,args:se}=C.deserializeRequestJSONArgs(j);this.g&&(se=(0,I.$Hn)(se,this.g)),this.M(z,N,F,X,se,M===v.RequestJSONArgsWithCancellation);break}case v.RequestMixedArgs:case v.RequestMixedArgsWithCancellation:{let{rpcId:F,method:X,args:se}=C.deserializeRequestMixedArgs(j);this.g&&(se=(0,I.$Hn)(se,this.g)),this.M(z,N,F,X,se,M===v.RequestMixedArgsWithCancellation);break}case v.Acknowledged:{this.f?.logIncoming(z,N,t.LocalSide,"ack"),this.G(N);break}case v.Cancel:{this.N(z,N);break}case v.ReplyOKEmpty:{this.O(z,N,void 0);break}case v.ReplyOKJSON:{let F=C.deserializeReplyOKJSON(j);this.g&&(F=(0,I.$Hn)(F,this.g)),this.O(z,N,F);break}case v.ReplyOKJSONWithBuffers:{const F=C.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(z,N,F);break}case v.ReplyOKVSBuffer:{const F=C.deserializeReplyOKVSBuffer(j);this.O(z,N,F);break}case v.ReplyErrError:{let F=C.deserializeReplyErrError(j);this.g&&(F=(0,I.$Hn)(F,this.g)),this.P(z,N,F);break}case v.ReplyErrEmpty:{this.P(z,N,void 0);break}default:console.error("received unexpected message"),console.error(U)}}M(U,z,j,M,N,F){this.f?.logIncoming(U,z,t.OtherSide,`receiveRequest ${(0,f.$Kw)(j)}.${M}(`,N);const X=String(z);let se,W;if(F){const V=new P.$se;N.push(V.token),se=this.Q(j,M,N),W=()=>V.cancel()}else se=this.Q(j,M,N),W=h;this.u[X]=W;const H=C.serializeAcknowledged(z);this.f?.logOutgoing(H.byteLength,z,t.OtherSide,"ack"),this.c.send(H),se.then(V=>{delete this.u[X];const x=C.serializeReplyOK(z,V,this.h);this.f?.logOutgoing(x.byteLength,z,t.OtherSide,"reply:",V),this.c.send(x)},V=>{delete this.u[X];const x=C.serializeReplyErr(z,V);this.f?.logOutgoing(x.byteLength,z,t.OtherSide,"replyErr:",V),this.c.send(x)})}N(U,z){this.f?.logIncoming(U,z,t.OtherSide,"receiveCancel");const j=String(z);this.u[j]?.()}O(U,z,j){this.f?.logIncoming(U,z,t.LocalSide,"receiveReply:",j);const M=String(z);if(!this.w.hasOwnProperty(M))return;const N=this.w[M];delete this.w[M],N.resolveOk(j)}P(U,z,j){this.f?.logIncoming(U,z,t.LocalSide,"receiveReplyErr:",j);const M=String(z);if(!this.w.hasOwnProperty(M))return;const N=this.w[M];delete this.w[M];let F;j&&(j.$isError?(F=new Error,F.name=j.name,F.message=j.message,F.stack=j.stack):F=j),N.resolveErr(F)}Q(U,z,j){try{return Promise.resolve(this.S(U,z,j))}catch(M){return Promise.reject(M)}}S(U,z,j){const M=this.m[U];if(!M)throw new Error("Unknown actor "+(0,f.$Kw)(U));const N=M[z];if(typeof N!="function")throw new Error("Unknown method "+z+" on actor "+(0,f.$Kw)(U));return N.apply(M,j)}U(U,z,j){if(this.j)return new D.$qbc;let M=null;if(j.length>0&&P.CancellationToken.isCancellationToken(j[j.length-1])&&(M=j.pop()),M&&M.isCancellationRequested)return Promise.reject(L.$6());const N=C.serializeRequestArguments(j,this.h),F=++this.t,X=String(F),se=new D.$pbc,W=new p.$Tc;M&&W.add(M.onCancellationRequested(()=>{const V=C.serializeCancel(F);this.f?.logOutgoing(V.byteLength,F,t.LocalSide,"cancel"),this.c.send(C.serializeCancel(F))})),this.w[X]=new S(se,W),this.F(F);const H=C.serializeRequest(F,U,z,N,!!M);return this.f?.logOutgoing(H.byteLength,F,t.LocalSide,`request: ${(0,f.$Kw)(U)}.${z}(`,j),this.c.send(H),se}}e.$tbc=y,A=s,y.a=3*1e3;class S{constructor(U,z){this.a=U,this.b=z}resolveOk(U){this.a.resolveOk(U),this.b.dispose()}resolveErr(U){this.a.resolveErr(U),this.b.dispose()}}class E{static alloc(U,z,j){const M=new E(u.$Je.alloc(j+1+4),0);return M.writeUInt8(U),M.writeUInt32(z),M}static read(U,z){return new E(U,z)}get buffer(){return this.a}constructor(U,z){this.a=U,this.b=z}static sizeUInt8(){return 1}writeUInt8(U){this.a.writeUInt8(U,this.b),this.b+=1}readUInt8(){const U=this.a.readUInt8(this.b);return this.b+=1,U}writeUInt32(U){this.a.writeUInt32BE(U,this.b),this.b+=4}readUInt32(){const U=this.a.readUInt32BE(this.b);return this.b+=4,U}static sizeShortString(U){return 1+U.byteLength}writeShortString(U){this.a.writeUInt8(U.byteLength,this.b),this.b+=1,this.a.set(U,this.b),this.b+=U.byteLength}readShortString(){const U=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+U).toString();return this.b+=U,j}static sizeLongString(U){return 4+U.byteLength}writeLongString(U){this.a.writeUInt32BE(U.byteLength,this.b),this.b+=4,this.a.set(U,this.b),this.b+=U.byteLength}readLongString(){const U=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+U).toString();return this.b+=U,j}writeBuffer(U){this.a.writeUInt32BE(U.byteLength,this.b),this.b+=4,this.a.set(U,this.b),this.b+=U.byteLength}static sizeVSBuffer(U){return 4+U.byteLength}writeVSBuffer(U){this.a.writeUInt32BE(U.byteLength,this.b),this.b+=4,this.a.set(U,this.b),this.b+=U.byteLength}readVSBuffer(){const U=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+U);return this.b+=U,z}static sizeMixedArray(U){let z=0;z+=1;for(let j=0,M=U.length;j<M;j++){const N=U[j];switch(z+=1,N.type){case b.String:z+=this.sizeLongString(N.value);break;case b.VSBuffer:z+=this.sizeVSBuffer(N.value);break;case b.SerializedObjectWithBuffers:z+=this.sizeUInt32,z+=this.sizeLongString(N.value);for(let F=0;F<N.buffers.length;++F)z+=this.sizeVSBuffer(N.buffers[F]);break;case b.Undefined:break}}return z}writeMixedArray(U){this.a.writeUInt8(U.length,this.b),this.b+=1;for(let z=0,j=U.length;z<j;z++){const M=U[z];switch(M.type){case b.String:this.writeUInt8(b.String),this.writeLongString(M.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(M.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(M.buffers.length),this.writeLongString(M.value);for(let N=0;N<M.buffers.length;++N)this.writeBuffer(M.buffers[N]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const U=this.a.readUInt8(this.b);this.b+=1;const z=new Array(U);for(let j=0;j<U;j++)switch(this.readUInt8()){case b.String:z[j]=this.readLongString();break;case b.VSBuffer:z[j]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const N=this.readUInt32(),F=this.readLongString(),X=[];for(let se=0;se<N;++se)X.push(this.readVSBuffer());z[j]=new f.$Lw(i(F,X,null));break}case b.Undefined:z[j]=void 0;break}return z}}E.sizeUInt32=4;var k;(function(O){O[O.Simple=0]="Simple",O[O.Mixed=1]="Mixed"})(k||(k={}));class C{static a(U){for(let z=0,j=U.length;z<j;z++)if(U[z]instanceof u.$Je||U[z]instanceof f.$Lw||typeof U[z]>"u")return!0;return!1}static serializeRequestArguments(U,z){if(this.a(U)){const j=[];for(let M=0,N=U.length;M<N;M++){const F=U[M];if(F instanceof u.$Je)j[M]={type:b.VSBuffer,value:F};else if(typeof F>"u")j[M]={type:b.Undefined};else if(F instanceof f.$Lw){const{jsonString:X,referencedBuffers:se}=$(F.value,z);j[M]={type:b.SerializedObjectWithBuffers,value:u.$Je.fromString(X),buffers:se}}else j[M]={type:b.String,value:u.$Je.fromString(o(F,z))}}return{type:k.Mixed,args:j}}return{type:k.Simple,args:o(U,z)}}static serializeRequest(U,z,j,M,N){switch(M.type){case k.Simple:return this.b(U,z,j,M.args,N);case k.Mixed:return this.c(U,z,j,M.args,N)}}static b(U,z,j,M,N){const F=u.$Je.fromString(j),X=u.$Je.fromString(M);let se=0;se+=E.sizeUInt8(),se+=E.sizeShortString(F),se+=E.sizeLongString(X);const W=E.alloc(N?v.RequestJSONArgsWithCancellation:v.RequestJSONArgs,U,se);return W.writeUInt8(z),W.writeShortString(F),W.writeLongString(X),W.buffer}static deserializeRequestJSONArgs(U){const z=U.readUInt8(),j=U.readShortString(),M=U.readLongString();return{rpcId:z,method:j,args:JSON.parse(M)}}static c(U,z,j,M,N){const F=u.$Je.fromString(j);let X=0;X+=E.sizeUInt8(),X+=E.sizeShortString(F),X+=E.sizeMixedArray(M);const se=E.alloc(N?v.RequestMixedArgsWithCancellation:v.RequestMixedArgs,U,X);return se.writeUInt8(z),se.writeShortString(F),se.writeMixedArray(M),se.buffer}static deserializeRequestMixedArgs(U){const z=U.readUInt8(),j=U.readShortString(),M=U.readMixedArray(),N=new Array(M.length);for(let F=0,X=M.length;F<X;F++){const se=M[F];typeof se=="string"?N[F]=JSON.parse(se):N[F]=se}return{rpcId:z,method:j,args:N}}static serializeAcknowledged(U){return E.alloc(v.Acknowledged,U,0).buffer}static serializeCancel(U){return E.alloc(v.Cancel,U,0).buffer}static serializeReplyOK(U,z,j){if(typeof z>"u")return this.d(U);if(z instanceof u.$Je)return this.e(U,z);if(z instanceof f.$Lw){const{jsonString:M,referencedBuffers:N}=$(z.value,j,!0);return this.g(U,M,N)}else return this.f(U,w(z,j))}static d(U){return E.alloc(v.ReplyOKEmpty,U,0).buffer}static e(U,z){let j=0;j+=E.sizeVSBuffer(z);const M=E.alloc(v.ReplyOKVSBuffer,U,j);return M.writeVSBuffer(z),M.buffer}static deserializeReplyOKVSBuffer(U){return U.readVSBuffer()}static f(U,z){const j=u.$Je.fromString(z);let M=0;M+=E.sizeLongString(j);const N=E.alloc(v.ReplyOKJSON,U,M);return N.writeLongString(j),N.buffer}static g(U,z,j){const M=u.$Je.fromString(z);let N=0;N+=E.sizeUInt32,N+=E.sizeLongString(M);for(const X of j)N+=E.sizeVSBuffer(X);const F=E.alloc(v.ReplyOKJSONWithBuffers,U,N);F.writeUInt32(j.length),F.writeLongString(M);for(const X of j)F.writeBuffer(X);return F.buffer}static deserializeReplyOKJSON(U){const z=U.readLongString();return JSON.parse(z)}static deserializeReplyOKJSONWithBuffers(U,z){const j=U.readUInt32(),M=U.readLongString(),N=[];for(let F=0;F<j;++F)N.push(U.readVSBuffer());return new f.$Lw(i(M,N,z))}static serializeReplyErr(U,z){const j=z?w(L.$3(z),null):void 0;if(typeof j!="string")return this.h(U);const M=u.$Je.fromString(j);let N=0;N+=E.sizeLongString(M);const F=E.alloc(v.ReplyErrError,U,N);return F.writeLongString(M),F.buffer}static deserializeReplyErrError(U){const z=U.readLongString();return JSON.parse(z)}static h(U){return E.alloc(v.ReplyErrEmpty,U,0).buffer}}var v;(function(O){O[O.RequestJSONArgs=1]="RequestJSONArgs",O[O.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",O[O.RequestMixedArgs=3]="RequestMixedArgs",O[O.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",O[O.Acknowledged=5]="Acknowledged",O[O.Cancel=6]="Cancel",O[O.ReplyOKEmpty=7]="ReplyOKEmpty",O[O.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",O[O.ReplyOKJSON=9]="ReplyOKJSON",O[O.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",O[O.ReplyErrError=11]="ReplyErrError",O[O.ReplyErrEmpty=12]="ReplyErrEmpty"})(v||(v={}));var b;(function(O){O[O.String=1]="String",O[O.VSBuffer=2]="VSBuffer",O[O.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",O[O.Undefined=4]="Undefined"})(b||(b={}))}),define(Ee[338],Se([1,0,22,29,15,89,5]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=e.$9J=void 0,e.$0J=I,e.$$J=D,e.$9J=(0,L.$Ai)("notebookDocumentService");const R=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${R.join("")}]+`),l=7;function I(A){if(A.scheme!==P.Schemas.vscodeNotebookCell)return;const w=A.fragment.indexOf("s");if(w<0)return;const a=parseInt(A.fragment.substring(0,w).replace(p,""),l),d=(0,r.$3e)(A.fragment.substring(w+1)).toString();if(!isNaN(a))return{handle:a,notebook:A.with({scheme:d,fragment:null})}}function D(A,w){const a=w.toString(l),g=`${a.length<R.length?R[a.length-1]:"z"}${a}s${(0,r.$4e)(r.$Je.fromString(A.scheme),!0,!0)}`;return A.with({scheme:P.Schemas.vscodeNotebookCell,fragment:g})}class f{constructor(){this.a=new u.$Ac}getNotebook(w){if(w.scheme===P.Schemas.vscodeNotebookCell){const a=I(w);if(a){const d=this.a.get(a.notebook);if(d)return d}}return this.a.get(w)}addNotebookDocument(w){this.a.set(w.uri,w)}removeNotebookDocument(w){this.a.delete(w.uri)}}e.$_J=f,(0,T.$Gs)(e.$9J,f,T.InstantiationType.Delayed)}),define(Ee[127],Se([1,0,22,39,40,103,15,16,11,35,338]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$qK=e.CellStatusbarAlignment=e.$pK=e.NotebookEditorPriority=e.$mK=e.$lK=e.$jK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$iK=e.$hK=e.$gK=e.$fK=e.CellKind=e.$eK=e.$dK=e.$cK=void 0,e.$kK=c,e.$nK=s,e.$oK=m,e.$rK=E,e.$sK=C,e.$cK="workbench.editor.notebook",e.$dK="workbench.editor.notebookTextDiffEditor",e.$eK="workbench.editor.interactive";var D;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(D||(e.CellKind=D={})),e.$fK=["application/json","application/javascript","text/html","image/svg+xml",T.$Zs.latex,T.$Zs.markdown,"image/png","image/jpeg",T.$Zs.text],e.$gK=[T.$Zs.latex,T.$Zs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$Zs.text],e.$hK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$iK="_notAvailable";var f;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(f||(e.NotebookRunState=f={}));var A;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(A||(e.NotebookCellExecutionState=A={}));var w;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(w||(e.NotebookExecutionState=w={}));var a;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var d;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(d||(e.RendererMessagingSpec=d={}));var g;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(g||(e.NotebookCellsChangeType=g={}));var $;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})($||(e.SelectionStateType=$={}));var i;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var o;(function(F){F.scheme=L.Schemas.vscodeNotebookCell;function X(he,ne){return(0,I.$$J)(he,ne)}F.generate=X;function se(he){return(0,I.$0J)(he)}F.parse=se;function W(he,ne){return he.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${ne??""},${he.scheme!==L.Schemas.file?he.scheme:""}`})}F.generateCellOutputUri=W;function H(he){if(he.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const ne=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(he.fragment);if(!ne)return;const we=ne[1]&&ne[1]!==""?ne[1]:void 0,pe=ne[2];return{outputId:we,notebook:he.with({scheme:pe||L.Schemas.file,fragment:null})}}F.parseCellOutputUri=H;function V(he,ne,we){return F.generate(he,ne).with({scheme:we})}F.generateCellPropertyUri=V;function x(he,ne){if(he.scheme===ne)return F.parse(he.with({scheme:F.scheme}))}F.parseCellPropertyUri=x})(o||(e.CellUri=o={}));const n=F=>p.$c?F.replace(/\//g,"\\"):F;class t{constructor(X=[],se=e.$fK){this.e=se,this.d=[...new Set(X)].map(W=>({pattern:W,matches:u.$uk(n(W))}))}sort(X){const se=new Map(P.Iterable.map(X,H=>[H,n(H)]));let W=[];for(const{matches:H}of this.d)for(const[V,x]of se)if(H(x)){W.push(V),se.delete(V);break}return se.size&&(W=W.concat([...se.keys()].sort((H,V)=>this.e.indexOf(H)-this.e.indexOf(V)))),W}prioritize(X,se){const W=this.f(X);if(W===-1){this.d.unshift({pattern:X,matches:u.$uk(n(X))});return}const H=new Set(se.map(x=>this.f(x,W)));H.delete(-1);const V=Array.from(H).sort();this.d.splice(W+1,0,...V.map(x=>this.d[x]));for(let x=V.length-1;x>=0;x--)this.d.splice(V[x],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,se=this.d.length){const W=n(X);for(let H=0;H<se;H++)if(this.d[H].matches(W))return H;return-1}}e.$jK=t;function c(F,X,se,W=(H,V)=>H===V){const H=[];function V(ne,we,pe){if(we===0&&pe.length===0)return;const ce=H[H.length-1];ce&&ce.start+ce.deleteCount===ne?(ce.deleteCount+=we,ce.toInsert.push(...pe)):H.push({start:ne,deleteCount:we,toInsert:pe})}let x=0,he=0;for(;;){if(x===F.length){V(x,0,X.slice(he));break}if(he===X.length){V(x,F.length-x,[]);break}const ne=F[x],we=X[he];if(W(ne,we)){x+=1,he+=1;continue}se(we)?(V(x,1,[]),x+=1):(V(x,0,[we]),he+=1)}return H}e.$lK=new l.$Rj("notebookEditorCursorAtBoundary","none"),e.$mK=new l.$Rj("notebookEditorCursorAtLineBoundary","none");var h;(function(F){F.default="default",F.option="option"})(h||(e.NotebookEditorPriority=h={}));function s(F){const X=F;return!!((typeof X.include=="string"||u.$vk(X.include))&&(typeof X.exclude=="string"||u.$vk(X.exclude)))}function m(F,X,se){if(Array.isArray(F.viewType)&&F.viewType.indexOf(X)>=0||F.viewType===X)return!0;if(F.filenamePattern){const W=s(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,H=s(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(u.$tk(W,(0,R.$nc)(se.fsPath).toLowerCase()))return!(H&&u.$tk(H,(0,R.$nc)(se.fsPath).toLowerCase()))}return!1}e.$pK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var y;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(y||(e.CellStatusbarAlignment=y={}));class S{static create(X){return`${S.d}${X}`}static parse(X){if(X.startsWith(S.d))return X.substring(S.d.length)}}e.$qK=S,S.d="notebook/";function E(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}const k=new TextDecoder;function C(F){const X=[];let se=!1;for(const x of F)(X.length===0||se)&&(X.push(x),se=!0);let W=O(X);const H=r.$Je.concat(X.map(x=>r.$Je.wrap(x))),V=N(H);return W=W||V.byteLength!==H.byteLength,{data:V,didCompression:W}}e.$tK="\x1B[A";const v=e.$tK.split("").map(F=>F.charCodeAt(0)),b=10;function O(F){let X=!1;return F.forEach((se,W)=>{if(W===0||se.length<e.$tK.length)return;const H=F[W-1],V=se.subarray(0,e.$tK.length);if(V[0]===v[0]&&V[1]===v[1]&&V[2]===v[2]){const x=H.lastIndexOf(b);if(x===-1)return;X=!0,F[W-1]=H.subarray(0,x),F[W]=se.subarray(e.$tK.length)}}),X}function U(F){let X=F;do F=X,X=F.replace(/[^\n]\x08/gm,"");while(X.length<F.length);return F}function z(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const X=F.match(/^(.*)\r+/m)[1];let se=F.match(/\r+(.*)$/m)[1];se=se+X.slice(se.length,X.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,se)}return F}const j=8,M=13;function N(F){return!F.buffer.includes(j)&&!F.buffer.includes(M)?F:r.$Je.fromString(z(U(k.decode(F.buffer))))}});var rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r},Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)};define(Ee[8],Se([1,0,19,14,86,29,103,13,18,2,33,24,28,71,127]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w){"use strict";var a,d,g,$,i,o,n,t,c,h,s,m,y,S,E,k,C,v,b,O,U,z,j,M,N;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$NO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$tO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$gO=e.$fO=e.$eO=e.$dO=e.$bO=e.$aO=e.$_N=e.$$N=e.TestRunProfileKind=e.TestResultState=e.$0N=e.$9N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$8N=e.NotebookVariablesRequestKind=e.$7N=e.$6N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$5N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.ColorThemeKind=e.$YN=e.$XN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$WN=e.$VN=e.DebugConsoleMode=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$PN=e.$ON=e.FileChangeType=e.$NN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$MN=e.$LN=e.$KN=e.$JN=e.InlineCompletionTriggerKind=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$wN=e.ConfigurationTarget=e.$vN=e.$uN=e.$tN=e.$sN=e.DocumentPasteTriggerKind=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$lN=e.ViewBadge=e.ProgressLocation=e.$kN=e.$jN=e.TaskScope=e.ShellQuoting=e.$iN=e.$hN=e.$gN=e.TaskPanelKind=e.TaskRevealKind=e.$fN=e.TerminalLocation=e.$eN=e.$dN=e.$cN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$bN=e.$aN=e.$_M=e.$$M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$9M=e.$8M=e.$7M=e.$6M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$5M=e.$4M=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.LanguageStatusSeverity=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.CodeActionTriggerKind=e.$RM=e.$QM=e.SymbolTag=e.SymbolKind=e.$PM=e.$OM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.DiagnosticSeverity=e.DiagnosticTag=e.$IM=e.$HM=e.FileEditType=e.$GM=e.$FM=e.$EM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$0M=en,e.$xN=et,e.$cO=Ri;function F(J){return Object.assign(J,{apply:function(...me){if(me.length===0)return Reflect.construct(J,[]);{const Oe=me.length===1?[]:me[1];return Reflect.construct(J,Oe,me[0].constructor)}},call:function(...me){if(me.length===0)return Reflect.construct(J,[]);{const[Oe,...Xe]=me;return Reflect.construct(J,Xe,Oe.constructor)}}})}var X;(function(J){J[J.Top=0]="Top",J[J.Bottom=1]="Bottom"})(X||(e.TerminalOutputAnchor=X={}));var se;(function(J){J[J.TerminalCommand=0]="TerminalCommand",J[J.Opener=1]="Opener",J[J.Command=3]="Command"})(se||(e.TerminalQuickFixType=se={}));let W=c=class{static from(...G){let me=G;return new c(function(){if(me){for(const Oe of me)Oe&&typeof Oe.dispose=="function"&&Oe.dispose();me=void 0}})}constructor(G){a.set(this,void 0),rt(this,a,G,"f")}dispose(){typeof Ge(this,a,"f")=="function"&&(Ge(this,a,"f").call(this),rt(this,a,void 0,"f"))}};e.$xM=W,a=new WeakMap,e.$xM=W=c=Ze([F],W);let H=h=class{static Min(...G){if(G.length===0)throw new TypeError;let me=G[0];for(let Oe=1;Oe<G.length;Oe++){const Xe=G[Oe];Xe.isBefore(me)&&(me=Xe)}return me}static Max(...G){if(G.length===0)throw new TypeError;let me=G[0];for(let Oe=1;Oe<G.length;Oe++){const Xe=G[Oe];Xe.isAfter(me)&&(me=Xe)}return me}static isPosition(G){if(!G)return!1;if(G instanceof h)return!0;const{line:me,character:Oe}=G;return typeof me=="number"&&typeof Oe=="number"}static of(G){if(G instanceof h)return G;if(this.isPosition(G))return new h(G.line,G.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(G,me){if(G<0)throw(0,u.$7)("line must be non-negative");if(me<0)throw(0,u.$7)("character must be non-negative");this.c=G,this.e=me}isBefore(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<G.e}isBeforeOrEqual(G){return this.c<G.c?!0:G.c<this.c?!1:this.e<=G.e}isAfter(G){return!this.isBeforeOrEqual(G)}isAfterOrEqual(G){return!this.isBefore(G)}isEqual(G){return this.c===G.c&&this.e===G.e}compareTo(G){return this.c<G.c?-1:this.c>G.line?1:this.e<G.e?-1:this.e>G.e?1:0}translate(G,me=0){if(G===null||me===null)throw(0,u.$7)();let Oe;return typeof G>"u"?Oe=0:typeof G=="number"?Oe=G:(Oe=typeof G.lineDelta=="number"?G.lineDelta:0,me=typeof G.characterDelta=="number"?G.characterDelta:0),Oe===0&&me===0?this:new h(this.line+Oe,this.character+me)}with(G,me=this.character){if(G===null||me===null)throw(0,u.$7)();let Oe;return typeof G>"u"?Oe=this.line:typeof G=="number"?Oe=G:(Oe=typeof G.line=="number"?G.line:this.line,me=typeof G.character=="number"?G.character:this.character),Oe===this.line&&me===this.character?this:new h(Oe,me)}toJSON(){return{line:this.line,character:this.character}}};e.$yM=H,e.$yM=H=h=Ze([F],H);let V=s=class{static isRange(G){return G instanceof s?!0:G?H.isPosition(G.start)&&H.isPosition(G.end):!1}static of(G){if(G instanceof s)return G;if(this.isRange(G))return new s(G.start,G.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(G,me,Oe,Xe){let it,mt;if(typeof G=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Xe=="number"?(it=new H(G,me),mt=new H(Oe,Xe)):H.isPosition(G)&&H.isPosition(me)&&(it=H.of(G),mt=H.of(me)),!it||!mt)throw new Error("Invalid arguments");it.isBefore(mt)?(this.c=it,this.e=mt):(this.c=mt,this.e=it)}contains(G){return s.isRange(G)?this.contains(G.start)&&this.contains(G.end):H.isPosition(G)?!(H.of(G).isBefore(this.c)||this.e.isBefore(G)):!1}isEqual(G){return this.c.isEqual(G.c)&&this.e.isEqual(G.e)}intersection(G){const me=H.Max(G.start,this.c),Oe=H.Min(G.end,this.e);if(!me.isAfter(Oe))return new s(me,Oe)}union(G){if(this.contains(G))return this;if(G.contains(this))return G;const me=H.Min(G.start,this.c),Oe=H.Max(G.end,this.end);return new s(me,Oe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(G,me=this.end){if(G===null||me===null)throw(0,u.$7)();let Oe;return G?H.isPosition(G)?Oe=G:(Oe=G.start||this.start,me=G.end||this.end):Oe=this.start,Oe.isEqual(this.c)&&me.isEqual(this.end)?this:new s(Oe,me)}toJSON(){return[this.start,this.end]}};e.$zM=V,e.$zM=V=s=Ze([F],V);let x=m=class extends V{static isSelection(G){return G instanceof m?!0:G?V.isRange(G)&&H.isPosition(G.anchor)&&H.isPosition(G.active)&&typeof G.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(G,me,Oe,Xe){let it,mt;if(typeof G=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Xe=="number"?(it=new H(G,me),mt=new H(Oe,Xe)):H.isPosition(G)&&H.isPosition(me)&&(it=H.of(G),mt=H.of(me)),!it||!mt)throw new Error("Invalid arguments");super(it,mt),this.f=it,this.g=mt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$AM=x,e.$AM=x=m=Ze([F],x);const he=J=>{if(typeof J!="string"||J.length===0||!/^[0-9A-Za-z_\-]+$/.test(J))throw(0,u.$7)("connectionToken")};class ne{static isResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.host=="string"&&typeof G.port=="number"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,me,Oe){if(typeof G!="string"||G.length===0)throw(0,u.$7)("host");if(typeof me!="number"||me===0||Math.round(me)!==me)throw(0,u.$7)("port");typeof Oe<"u"&&he(Oe),this.host=G,this.port=Math.round(me),this.connectionToken=Oe}}e.$BM=ne;class we{static isManagedResolvedAuthority(G){return G&&typeof G=="object"&&typeof G.makeConnection=="function"&&(G.connectionToken===void 0||typeof G.connectionToken=="string")}constructor(G,me){this.makeConnection=G,this.connectionToken=me,typeof me<"u"&&he(me)}}e.$CM=we;class pe extends Error{static NotAvailable(G,me){return new pe(G,A.RemoteAuthorityResolverErrorCode.NotAvailable,me)}static TemporarilyNotAvailable(G){return new pe(G,A.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(G,me=A.RemoteAuthorityResolverErrorCode.Unknown,Oe){super(G),this._message=G,this._code=me,this._detail=Oe,Object.setPrototypeOf(this,pe.prototype)}}e.$DM=pe;var ce;(function(J){J[J.LF=1]="LF",J[J.CRLF=2]="CRLF"})(ce||(e.EndOfLine=ce={}));var K;(function(J){J[J.Replace=1]="Replace",J[J.Append=2]="Append",J[J.Prepend=3]="Prepend"})(K||(e.EnvironmentVariableMutatorType=K={}));let de=y=class{static isTextEdit(G){return G instanceof y?!0:G?V.isRange(G)&&typeof G.newText=="string":!1}static replace(G,me){return new y(G,me)}static insert(G,me){return y.replace(new V(G,G),me)}static delete(G){return y.replace(G,"")}static setEndOfLine(G){const me=new y(new V(new H(0,0),new H(0,0)),"");return me.newEol=G,me}get range(){return this.c}set range(G){if(G&&!V.isRange(G))throw(0,u.$7)("range");this.c=G}get newText(){return this.e||""}set newText(G){if(G&&typeof G!="string")throw(0,u.$7)("newText");this.e=G}get newEol(){return this.f}set newEol(G){if(G&&typeof G!="number")throw(0,u.$7)("newEol");this.f=G}constructor(G,me){this.c=G,this.e=me}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$EM=de,e.$EM=de=y=Ze([F],de);let te=S=class{static isNotebookCellEdit(G){return G instanceof S?!0:G?yn.isNotebookRange(G)&&Array.isArray(G.newCells):!1}static replaceCells(G,me){return new S(G,me)}static insertCells(G,me){return new S(new yn(G,G),me)}static deleteCells(G){return new S(G,[])}static updateCellMetadata(G,me){const Oe=new S(new yn(G,G),[]);return Oe.newCellMetadata=me,Oe}static updateNotebookMetadata(G){const me=new S(new yn(0,0),[]);return me.newNotebookMetadata=G,me}constructor(G,me){this.range=G,this.newCells=me}};e.$FM=te,e.$FM=te=S=Ze([F],te);class ee{static isSnippetTextEdit(G){return G instanceof ee?!0:G?V.isRange(G.range)&&Z.isSnippetString(G.snippet):!1}static replace(G,me){return new ee(G,me)}static insert(G,me){return ee.replace(new V(G,G),me)}constructor(G,me){this.range=G,this.snippet=me}}e.$GM=ee;var ie;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.Cell=3]="Cell",J[J.CellReplace=5]="CellReplace",J[J.Snippet=6]="Snippet"})(ie||(e.FileEditType=ie={}));let le=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(G,me,Oe,Xe){this.c.push({_type:ie.File,from:G,to:me,options:Oe,metadata:Xe})}createFile(G,me,Oe){this.c.push({_type:ie.File,from:void 0,to:G,options:me,metadata:Oe})}deleteFile(G,me,Oe){this.c.push({_type:ie.File,from:G,to:void 0,options:me,metadata:Oe})}e(G,me,Oe){this.c.push({_type:ie.Cell,metadata:Oe,uri:G,edit:{editType:w.CellEditType.DocumentMetadata,metadata:me},notebookMetadata:me})}f(G,me,Oe,Xe){const it=me.start,mt=me.end;(it!==mt||Oe.length>0)&&this.c.push({_type:ie.CellReplace,uri:G,index:it,count:mt-it,cells:Oe,metadata:Xe})}g(G,me,Oe,Xe){this.c.push({_type:ie.Cell,metadata:Xe,uri:G,edit:{editType:w.CellEditType.Metadata,index:me,metadata:Oe}})}replace(G,me,Oe,Xe){this.c.push({_type:ie.Text,uri:G,edit:new de(me,Oe),metadata:Xe})}insert(G,me,Oe,Xe){this.replace(G,new V(me,me),Oe,Xe)}delete(G,me,Oe){this.replace(G,me,"",Oe)}has(G){return this.c.some(me=>me._type===ie.Text&&me.uri.toString()===G.toString())}set(G,me){if(me)for(const Oe of me){if(!Oe)continue;let Xe,it;Array.isArray(Oe)?(Xe=Oe[0],it=Oe[1]):Xe=Oe,te.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(G,Xe.range.start,Xe.newCellMetadata,it):Xe.newNotebookMetadata?this.e(G,Xe.newNotebookMetadata,it):this.f(G,Xe.range,Xe.newCells,it):ee.isSnippetTextEdit(Xe)?this.c.push({_type:ie.Snippet,uri:G,range:Xe.range,edit:Xe.snippet,metadata:it}):this.c.push({_type:ie.Text,uri:G,edit:Xe,metadata:it})}else{for(let Oe=0;Oe<this.c.length;Oe++){const Xe=this.c[Oe];switch(Xe._type){case ie.Text:case ie.Snippet:case ie.Cell:case ie.CellReplace:Xe.uri.toString()===G.toString()&&(this.c[Oe]=void 0);break}}(0,r.$Ib)(this.c)}}get(G){const me=[];for(const Oe of this.c)Oe._type===ie.Text&&Oe.uri.toString()===G.toString()&&me.push(Oe.edit);return me}entries(){const G=new T.$Ac;for(const me of this.c)if(me._type===ie.Text){let Oe=G.get(me.uri);Oe||(Oe=[me.uri,[]],G.set(me.uri,Oe)),Oe[1].push(me.edit)}return[...G.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$HM=le,e.$HM=le=Ze([F],le);let Z=E=class{static isSnippetString(G){return G instanceof E?!0:G?typeof G.value=="string":!1}static c(G){return G.replace(/\$|}|\\/g,"\\$&")}constructor(G){this.e=1,this.value=G||""}appendText(G){return this.value+=E.c(G),this}appendTabstop(G=this.e++){return this.value+="$",this.value+=G,this}appendPlaceholder(G,me=this.e++){if(typeof G=="function"){const Oe=new E;Oe.e=this.e,G(Oe),this.e=Oe.e,G=Oe.value}else G=E.c(G);return this.value+="${",this.value+=me,this.value+=":",this.value+=G,this.value+="}",this}appendChoice(G,me=this.e++){const Oe=G.map(Xe=>Xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=me,this.value+="|",this.value+=Oe,this.value+="|}",this}appendVariable(G,me){if(typeof me=="function"){const Oe=new E;Oe.e=this.e,me(Oe),this.e=Oe.e,me=Oe.value}else typeof me=="string"&&(me=me.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=G,me&&(this.value+=":",this.value+=me),this.value+="}",this}};e.$IM=Z,e.$IM=Z=E=Ze([F],Z);var ae;(function(J){J[J.Unnecessary=1]="Unnecessary",J[J.Deprecated=2]="Deprecated"})(ae||(e.DiagnosticTag=ae={}));var $e;(function(J){J[J.Hint=3]="Hint",J[J.Information=2]="Information",J[J.Warning=1]="Warning",J[J.Error=0]="Error"})($e||(e.DiagnosticSeverity=$e={}));let be=k=class{static isLocation(G){return G instanceof k?!0:G?V.isRange(G.range)&&l.URI.isUri(G.uri):!1}constructor(G,me){if(this.uri=G,me)if(V.isRange(me))this.range=V.of(me);else if(H.isPosition(me))this.range=new V(me,me);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$JM=be,e.$JM=be=k=Ze([F],be);let Me=class{static is(G){return G?typeof G.message=="string"&&G.location&&V.isRange(G.location.range)&&l.URI.isUri(G.location.uri):!1}constructor(G,me){this.location=G,this.message=me}static isEqual(G,me){return G===me?!0:!G||!me?!1:G.message===me.message&&G.location.range.isEqual(me.location.range)&&G.location.uri.toString()===me.location.uri.toString()}};e.$KM=Me,e.$KM=Me=Ze([F],Me);let qe=class{constructor(G,me,Oe=$e.Error){if(!V.isRange(G))throw new TypeError("range must be set");if(!me)throw new TypeError("message must be set");this.range=G,this.message=me,this.severity=Oe}toJSON(){return{severity:$e[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(G,me){return G===me?!0:!G||!me?!1:G.message===me.message&&G.severity===me.severity&&G.code===me.code&&G.severity===me.severity&&G.source===me.source&&G.range.isEqual(me.range)&&(0,r.$ub)(G.tags,me.tags)&&(0,r.$ub)(G.relatedInformation,me.relatedInformation,Me.isEqual)}};e.$LM=qe,e.$LM=qe=Ze([F],qe);let De=class{constructor(G,me){if(!G)throw new Error("Illegal argument, contents must be defined");Array.isArray(G)?this.contents=G:this.contents=[G],this.range=me}};e.$MM=De,e.$MM=De=Ze([F],De);let Pe=class extends De{constructor(G,me,Oe,Xe){super(G,me),this.canIncreaseHover=Oe,this.canDecreaseHover=Xe}};e.$NM=Pe,e.$NM=Pe=Ze([F],Pe);var Te;(function(J){J[J.Increase=0]="Increase",J[J.Decrease=1]="Decrease"})(Te||(e.HoverVerbosityAction=Te={}));var B;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})(B||(e.DocumentHighlightKind=B={}));let q=class{constructor(G,me=B.Text){this.range=G,this.kind=me}toJSON(){return{range:this.range,kind:B[this.kind]}}};e.$OM=q,e.$OM=q=Ze([F],q);let Y=class{constructor(G,me){this.uri=G,this.highlights=me}toJSON(){return{uri:this.uri,highlights:this.highlights.map(G=>G.toJSON())}}};e.$PM=Y,e.$PM=Y=Ze([F],Y);var _;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(_||(e.SymbolKind=_={}));var fe;(function(J){J[J.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let ve=C=class{static validate(G){if(!G.name)throw new Error("name must not be falsy")}constructor(G,me,Oe,Xe,it){this.name=G,this.kind=me,this.containerName=it,typeof Oe=="string"&&(this.containerName=Oe),Xe instanceof be?this.location=Xe:Oe instanceof V&&(this.location=new be(Xe,Oe)),C.validate(this)}toJSON(){return{name:this.name,kind:_[this.kind],location:this.location,containerName:this.containerName}}};e.$QM=ve,e.$QM=ve=C=Ze([F],ve);let Ne=v=class{static validate(G){if(!G.name)throw new Error("name must not be falsy");if(!G.range.contains(G.selectionRange))throw new Error("selectionRange must be contained in fullRange");G.children?.forEach(v.validate)}constructor(G,me,Oe,Xe,it){this.name=G,this.detail=me,this.kind=Oe,this.range=Xe,this.selectionRange=it,this.children=[],v.validate(this)}};e.$RM=Ne,e.$RM=Ne=v=Ze([F],Ne);var Be;(function(J){J[J.Invoke=1]="Invoke",J[J.Automatic=2]="Automatic"})(Be||(e.CodeActionTriggerKind=Be={}));let Qe=class{constructor(G,me){this.title=G,this.kind=me}};e.$SM=Qe,e.$SM=Qe=Ze([F],Qe);let He=b=class{constructor(G){this.value=G}append(G){return new b(this.value?this.value+b.c+G:G)}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+b.c)}};e.$TM=He,He.c=".",e.$TM=He=b=Ze([F],He),He.Empty=new He(""),He.QuickFix=He.Empty.append("quickfix"),He.Refactor=He.Empty.append("refactor"),He.RefactorExtract=He.Refactor.append("extract"),He.RefactorInline=He.Refactor.append("inline"),He.RefactorMove=He.Refactor.append("move"),He.RefactorRewrite=He.Refactor.append("rewrite"),He.Source=He.Empty.append("source"),He.SourceOrganizeImports=He.Source.append("organizeImports"),He.SourceFixAll=He.Source.append("fixAll"),He.Notebook=He.Empty.append("notebook");let tt=class{constructor(G,me){if(this.range=G,this.parent=me,me&&!me.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$UM=tt,e.$UM=tt=Ze([F],tt);class nt{constructor(G,me,Oe,Xe,it,mt){this.kind=G,this.name=me,this.detail=Oe,this.uri=Xe,this.range=it,this.selectionRange=mt}}e.$VM=nt;class ot{constructor(G,me){this.fromRanges=me,this.from=G}}e.$WM=ot;class at{constructor(G,me){this.fromRanges=me,this.to=G}}e.$XM=at;var pt;(function(J){J[J.Information=0]="Information",J[J.Warning=1]="Warning",J[J.Error=2]="Error"})(pt||(e.LanguageStatusSeverity=pt={}));let ft=class{constructor(G,me){this.range=G,this.command=me}get isResolved(){return!!this.command}};e.$YM=ft,e.$YM=ft=Ze([F],ft);let st=O=class{static isMarkdownString(G){return G instanceof O?!0:G&&G.appendCodeblock&&G.appendMarkdown&&G.appendText&&G.value!==void 0}constructor(G,me=!1){d.set(this,void 0),rt(this,d,new P.$Xk(G,{supportThemeIcons:me}),"f")}get value(){return Ge(this,d,"f").value}set value(G){Ge(this,d,"f").value=G}get isTrusted(){return Ge(this,d,"f").isTrusted}set isTrusted(G){Ge(this,d,"f").isTrusted=G}get supportThemeIcons(){return Ge(this,d,"f").supportThemeIcons}set supportThemeIcons(G){Ge(this,d,"f").supportThemeIcons=G}get supportHtml(){return Ge(this,d,"f").supportHtml}set supportHtml(G){Ge(this,d,"f").supportHtml=G}get baseUri(){return Ge(this,d,"f").baseUri}set baseUri(G){Ge(this,d,"f").baseUri=G}appendText(G){return Ge(this,d,"f").appendText(G),this}appendMarkdown(G){return Ge(this,d,"f").appendMarkdown(G),this}appendCodeblock(G,me){return Ge(this,d,"f").appendCodeblock(me??"",G),this}};e.$ZM=st,d=new WeakMap,e.$ZM=st=O=Ze([F],st);let ht=class{constructor(G,me){this.label=G,this.documentation=me}};e.$1M=ht,e.$1M=ht=Ze([F],ht);let Re=class{constructor(G,me){this.label=G,this.documentation=me,this.parameters=[]}};e.$2M=Re,e.$2M=Re=Ze([F],Re);let Ie=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$3M=Ie,e.$3M=Ie=Ze([F],Ie);var Ae;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(Ae||(e.SignatureHelpTriggerKind=Ae={}));var ue;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(ue||(e.InlayHintKind=ue={}));let Q=class{constructor(G){this.value=G}};e.$4M=Q,e.$4M=Q=Ze([F],Q);let Ce=class{constructor(G,me,Oe){this.position=G,this.label=me,this.kind=Oe}};e.$5M=Ce,e.$5M=Ce=Ze([F],Ce);var Je;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Je||(e.CompletionTriggerKind=Je={}));var _e;(function(J){J[J.Text=0]="Text",J[J.Method=1]="Method",J[J.Function=2]="Function",J[J.Constructor=3]="Constructor",J[J.Field=4]="Field",J[J.Variable=5]="Variable",J[J.Class=6]="Class",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Unit=10]="Unit",J[J.Value=11]="Value",J[J.Enum=12]="Enum",J[J.Keyword=13]="Keyword",J[J.Snippet=14]="Snippet",J[J.Color=15]="Color",J[J.File=16]="File",J[J.Reference=17]="Reference",J[J.Folder=18]="Folder",J[J.EnumMember=19]="EnumMember",J[J.Constant=20]="Constant",J[J.Struct=21]="Struct",J[J.Event=22]="Event",J[J.Operator=23]="Operator",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue"})(_e||(e.CompletionItemKind=_e={}));var ct;(function(J){J[J.Deprecated=1]="Deprecated"})(ct||(e.CompletionItemTag=ct={}));let lt=class{constructor(G,me){this.label=G,this.kind=me}toJSON(){return{label:this.label,kind:this.kind&&_e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$6M=lt,e.$6M=lt=Ze([F],lt);let yt=class{constructor(G=[],me=!1){this.items=G,this.isIncomplete=me}};e.$7M=yt,e.$7M=yt=Ze([F],yt);let At=class{constructor(G,me,Oe){this.insertText=G,this.range=me,this.command=Oe}};e.$8M=At,e.$8M=At=Ze([F],At);let Ot=class{constructor(G){this.commands=void 0,this.suppressSuggestions=void 0,this.items=G}};e.$9M=Ot,e.$9M=Ot=Ze([F],Ot);var _t;(function(J){J[J.Unknown=0]="Unknown",J[J.Word=1]="Word",J[J.Line=2]="Line",J[J.Suggest=3]="Suggest"})(_t||(e.PartialAcceptTriggerKind=_t={}));var rn;(function(J){J[J.Active=-1]="Active",J[J.Beside=-2]="Beside",J[J.One=1]="One",J[J.Two=2]="Two",J[J.Three=3]="Three",J[J.Four=4]="Four",J[J.Five=5]="Five",J[J.Six=6]="Six",J[J.Seven=7]="Seven",J[J.Eight=8]="Eight",J[J.Nine=9]="Nine"})(rn||(e.ViewColumn=rn={}));var xe;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(xe||(e.StatusBarAlignment=xe={}));function en(J,G){return`${D.$Xm.toKey(J)}.${G}`}var Zt;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative",J[J.Interval=3]="Interval"})(Zt||(e.TextEditorLineNumbersStyle=Zt={}));var $t;(function(J){J[J.Manual=1]="Manual",J[J.AfterDelay=2]="AfterDelay",J[J.FocusOut=3]="FocusOut"})($t||(e.TextDocumentSaveReason=$t={}));var wt;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(wt||(e.TextEditorRevealType=wt={}));var Qt;(function(J){J[J.Keyboard=1]="Keyboard",J[J.Mouse=2]="Mouse",J[J.Command=3]="Command"})(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var tn;(function(J){J[J.Undo=1]="Undo",J[J.Redo=2]="Redo"})(tn||(e.TextDocumentChangeReason=tn={}));var qt;(function(J){J[J.OpenOpen=0]="OpenOpen",J[J.ClosedClosed=1]="ClosedClosed",J[J.OpenClosed=2]="OpenClosed",J[J.ClosedOpen=3]="ClosedOpen"})(qt||(e.DecorationRangeBehavior=qt={})),function(J){function G(me){switch(me){case"keyboard":return J.Keyboard;case"mouse":return J.Mouse;case"api":return J.Command}}J.fromValue=G}(Qt||(e.TextEditorSelectionChangeKind=Qt={}));var bt;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(bt||(e.SyntaxTokenType=bt={})),function(J){function G(me){switch(me){case J.Other:return"other";case J.Comment:return"comment";case J.String:return"string";case J.RegEx:return"regex"}return"other"}J.toString=G}(bt||(e.SyntaxTokenType=bt={}));let Mt=class{constructor(G,me){if(me&&!l.URI.isUri(me))throw(0,u.$7)("target");if(!V.isRange(G)||G.isEmpty)throw(0,u.$7)("range");this.range=G,this.target=me}};e.$$M=Mt,e.$$M=Mt=Ze([F],Mt);let Wt=class{constructor(G,me,Oe,Xe){this.red=G,this.green=me,this.blue=Oe,this.alpha=Xe}};e.$_M=Wt,e.$_M=Wt=Ze([F],Wt);let Ut=class{constructor(G,me){if(me&&!(me instanceof Wt))throw(0,u.$7)("color");if(!V.isRange(G)||G.isEmpty)throw(0,u.$7)("range");this.range=G,this.color=me}};e.$aN=Ut,e.$aN=Ut=Ze([F],Ut);let Ye=class{constructor(G){if(!G||typeof G!="string")throw(0,u.$7)("label");this.label=G}};e.$bN=Ye,e.$bN=Ye=Ze([F],Ye);var nn;(function(J){J[J.RGB=0]="RGB",J[J.HEX=1]="HEX",J[J.HSL=2]="HSL"})(nn||(e.ColorFormat=nn={}));var sn;(function(J){J[J.Error=0]="Error",J[J.Warning=1]="Warning",J[J.Information=2]="Information"})(sn||(e.SourceControlInputBoxValidationType=sn={}));var un;(function(J){J[J.Unknown=0]="Unknown",J[J.Shutdown=1]="Shutdown",J[J.Process=2]="Process",J[J.User=3]="User",J[J.Extension=4]="Extension"})(un||(e.TerminalExitReason=un={}));var Pt;(function(J){J[J.Low=0]="Low",J[J.Medium=1]="Medium",J[J.High=2]="High"})(Pt||(e.TerminalShellExecutionCommandLineConfidence=Pt={}));class jt{constructor(G,me,Oe){if(this.startIndex=G,this.length=me,this.tooltip=Oe,typeof G!="number"||G<0)throw(0,u.$7)("startIndex");if(typeof me!="number"||me<1)throw(0,u.$7)("length");if(Oe!==void 0&&typeof Oe!="string")throw(0,u.$7)("tooltip")}}e.$cN=jt;class Nt{constructor(G){this.uri=G}}e.$dN=Nt;class Ht{constructor(G){this.terminalCommand=G}}e.$eN=Ht;var hn;(function(J){J[J.Panel=1]="Panel",J[J.Editor=2]="Editor"})(hn||(e.TerminalLocation=hn={}));class on{constructor(G){if(this.options=G,typeof G!="object")throw(0,u.$7)("options")}}e.$fN=on;var cn;(function(J){J[J.Always=1]="Always",J[J.Silent=2]="Silent",J[J.Never=3]="Never"})(cn||(e.TaskRevealKind=cn={}));var Gt;(function(J){J[J.Shared=1]="Shared",J[J.Dedicated=2]="Dedicated",J[J.New=3]="New"})(Gt||(e.TaskPanelKind=Gt={}));let zt=U=class{static from(G){switch(G){case"clean":return U.Clean;case"build":return U.Build;case"rebuild":return U.Rebuild;case"test":return U.Test;default:return}}constructor(G,me){if(this.label=me,typeof G!="string"||typeof me!="string")throw(0,u.$7)("name");this.c=G}get id(){return this.c}};e.$gN=zt,zt.Clean=new U("clean","Clean"),zt.Build=new U("build","Build"),zt.Rebuild=new U("rebuild","Rebuild"),zt.Test=new U("test","Test"),e.$gN=zt=U=Ze([F],zt);function ln(J){let G="";for(let me=0;me<J.length;me++)G+=J[me].replace(/,/g,",,")+",";return G}let Rt=class{constructor(G,me,Oe){if(typeof G!="string")throw(0,u.$7)("process");this.e=[],this.c=G,me!==void 0&&(Array.isArray(me)?(this.e=me,this.f=Oe):this.f=me)}get process(){return this.c}set process(G){if(typeof G!="string")throw(0,u.$7)("process");this.c=G}get args(){return this.e}set args(G){Array.isArray(G)||(G=[]),this.e=G}get options(){return this.f}set options(G){this.f=G}computeId(){const G=[];if(G.push("process"),this.c!==void 0&&G.push(this.c),this.e&&this.e.length>0)for(const me of this.e)G.push(me);return ln(G)}};e.$hN=Rt,e.$hN=Rt=Ze([F],Rt);let St=class{constructor(G,me,Oe){if(this.f=[],Array.isArray(me)){if(!G)throw(0,u.$7)("command can't be undefined or null");if(typeof G!="string"&&typeof G.value!="string")throw(0,u.$7)("command");this.e=G,this.f=me,this.g=Oe}else{if(typeof G!="string")throw(0,u.$7)("commandLine");this.c=G,this.g=me}}get commandLine(){return this.c}set commandLine(G){if(typeof G!="string")throw(0,u.$7)("commandLine");this.c=G}get command(){return this.e?this.e:""}set command(G){if(typeof G!="string"&&typeof G.value!="string")throw(0,u.$7)("command");this.e=G}get args(){return this.f}set args(G){this.f=G||[]}get options(){return this.g}set options(G){this.g=G}computeId(){const G=[];if(G.push("shell"),this.c!==void 0&&G.push(this.c),this.e!==void 0&&G.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const me of this.f)G.push(typeof me=="string"?me:me.value);return ln(G)}};e.$iN=St,e.$iN=St=Ze([F],St);var Et;(function(J){J[J.Escape=1]="Escape",J[J.Strong=2]="Strong",J[J.Weak=3]="Weak"})(Et||(e.ShellQuoting=Et={}));var Kt;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace"})(Kt||(e.TaskScope=Kt={}));class Dt{constructor(G){this.c=G}computeId(){return"customExecution"+(0,I.$Wg)()}set callback(G){this.c=G}get callback(){return this.c}}e.$jN=Dt;let Vt=z=class{constructor(G,me,Oe,Xe,it,mt){this.k=!1,this.l=this.definition=G;let vt;typeof me=="string"?(this.o=this.name=me,this.w=this.source=Oe,this.execution=Xe,vt=it,this.k=!0):me===Kt.Global||me===Kt.Workspace?(this.target=me,this.o=this.name=Oe,this.w=this.source=Xe,this.execution=it,vt=mt):(this.target=me,this.o=this.name=Oe,this.w=this.source=Xe,this.execution=it,vt=mt),typeof vt=="string"?(this.r=[vt],this.t=!0):Array.isArray(vt)?(this.r=vt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(G){this.j=G}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Rt?this.l={type:z.e,id:this.q.computeId()}:this.q instanceof St?this.l={type:z.f,id:this.q.computeId()}:this.q instanceof Dt?this.l={type:z.c,id:this.q.computeId()}:this.l={type:z.g,id:(0,I.$Wg)()}}get definition(){return this.l}set definition(G){if(G==null)throw(0,u.$7)("Kind can't be undefined or null");this.B(),this.l=G}get scope(){return this.m}set target(G){this.B(),this.m=G}get name(){return this.o}set name(G){if(typeof G!="string")throw(0,u.$7)("name");this.B(),this.o=G}get execution(){return this.q}set execution(G){G===null&&(G=void 0),this.B(),this.q=G;const me=this.l.type;(z.g===me||z.e===me||z.f===me||z.c===me)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(G){if(Array.isArray(G))this.B(),this.r=G,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(G){G!==!0&&G!==!1&&(G=!1),this.B(),this.u=G}get source(){return this.w}set source(G){if(typeof G!="string"||G.length===0)throw(0,u.$7)("source must be a string of length > 0");this.B(),this.w=G}get group(){return this.x}set group(G){G===null&&(G=void 0),this.B(),this.x=G}get detail(){return this.A}set detail(G){G===null&&(G=void 0),this.A=G}get presentationOptions(){return this.y}set presentationOptions(G){G==null&&(G=Object.create(null)),this.B(),this.y=G}get runOptions(){return this.z}set runOptions(G){G==null&&(G=Object.create(null)),this.B(),this.z=G}};e.$kN=Vt,Vt.c="customExecution",Vt.e="process",Vt.f="shell",Vt.g="$empty",e.$kN=Vt=z=Ze([F],Vt);var Jt;(function(J){J[J.SourceControl=1]="SourceControl",J[J.Window=10]="Window",J[J.Notification=15]="Notification"})(Jt||(e.ProgressLocation=Jt={}));var Sn;(function(J){function G(me){const Oe=me;return(0,p.$eg)(Oe.value)?Oe.tooltip&&!(0,p.$ag)(Oe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Oe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Oe.value),!1)}J.isViewBadge=G})(Sn||(e.ViewBadge=Sn={}));let mn=j=class{static isTreeItem(G,me){const Oe=G;if(Oe.checkboxState!==void 0){const Xe=(0,p.$eg)(Oe.checkboxState)?Oe.checkboxState:(0,p.$cg)(Oe.checkboxState)&&(0,p.$eg)(Oe.checkboxState.state)?Oe.checkboxState.state:void 0,it=!(0,p.$eg)(Oe.checkboxState)&&(0,p.$cg)(Oe.checkboxState)?Oe.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==Ft.Checked&&Xe!==Ft.Unchecked||it!==void 0&&!(0,p.$ag)(it))return console.log("INVALID tree item, invalid checkboxState",Oe.checkboxState),!1}if(G instanceof j)return!0;if(Oe.label!==void 0&&!(0,p.$ag)(Oe.label)&&!Oe.label?.label)return console.log("INVALID tree item, invalid label",Oe.label),!1;if(Oe.id!==void 0&&!(0,p.$ag)(Oe.id))return console.log("INVALID tree item, invalid id",Oe.id),!1;if(Oe.iconPath!==void 0&&!(0,p.$ag)(Oe.iconPath)&&!l.URI.isUri(Oe.iconPath)&&(!Oe.iconPath||!(0,p.$ag)(Oe.iconPath.id))){const Xe=Oe.iconPath;if(!Xe||!(0,p.$ag)(Xe.light)&&!l.URI.isUri(Xe.light)&&!(0,p.$ag)(Xe.dark)&&!l.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Oe.iconPath),!1}return Oe.description!==void 0&&!(0,p.$ag)(Oe.description)&&typeof Oe.description!="boolean"?(console.log("INVALID tree item, invalid description",Oe.description),!1):Oe.resourceUri!==void 0&&!l.URI.isUri(Oe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Oe.resourceUri),!1):Oe.tooltip!==void 0&&!(0,p.$ag)(Oe.tooltip)&&!(Oe.tooltip instanceof st)?(console.log("INVALID tree item, invalid tooltip",Oe.tooltip),!1):Oe.command!==void 0&&!Oe.command.command?(console.log("INVALID tree item, invalid command",Oe.command),!1):Oe.collapsibleState!==void 0&&Oe.collapsibleState<$n.None&&Oe.collapsibleState>$n.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Oe.collapsibleState),!1):Oe.contextValue!==void 0&&!(0,p.$ag)(Oe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Oe.contextValue),!1):Oe.accessibilityInformation!==void 0&&!Oe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Oe.accessibilityInformation),!1):!0}constructor(G,me=$n.None){this.collapsibleState=me,l.URI.isUri(G)?this.resourceUri=G:this.label=G}};e.$lN=mn,e.$lN=mn=j=Ze([F],mn);var $n;(function(J){J[J.None=0]="None",J[J.Collapsed=1]="Collapsed",J[J.Expanded=2]="Expanded"})($n||(e.TreeItemCollapsibleState=$n={}));var Ft;(function(J){J[J.Unchecked=0]="Unchecked",J[J.Checked=1]="Checked"})(Ft||(e.TreeItemCheckboxState=Ft={}));let wn=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(G){this.value=G}};e.$mN=wn,e.$mN=wn=Ze([F],wn);class Rn extends wn{}e.$nN=Rn;class Tt extends Rn{constructor(G){super(""),g.set(this,void 0),rt(this,g,G,"f")}asFile(){return Ge(this,g,"f")}}e.$oN=Tt,g=new WeakMap;class Tn{constructor(G,me,Oe,Xe){this.name=G,this.uri=me,this._itemId=Oe,this.c=Xe}data(){return this.c()}}e.$pN=Tn;let kn=class{constructor(G){$.add(this),i.set(this,new Map);for(const[me,Oe]of G??[]){const Xe=Ge(this,i,"f").get(Ge(this,$,"m",o).call(this,me));Xe?Xe.push(Oe):Ge(this,i,"f").set(Ge(this,$,"m",o).call(this,me),[Oe])}}get(G){return Ge(this,i,"f").get(Ge(this,$,"m",o).call(this,G))?.[0]}set(G,me){Ge(this,i,"f").set(Ge(this,$,"m",o).call(this,G),[me])}forEach(G,me){for(const[Oe,Xe]of Ge(this,i,"f"))for(const it of Xe)G.call(me,it,Oe,this)}*[(i=new WeakMap,$=new WeakSet,Symbol.iterator)](){for(const[G,me]of Ge(this,i,"f"))for(const Oe of me)yield[G,Oe]}};e.$qN=kn,o=function(G){return G.toLowerCase()},e.$qN=kn=Ze([F],kn);let pn=class{constructor(G,me,Oe){this.insertText=G,this.title=me,this.kind=Oe}};e.$rN=pn,e.$rN=pn=Ze([F],pn);var In;(function(J){J[J.Automatic=0]="Automatic",J[J.PasteAs=1]="PasteAs"})(In||(e.DocumentPasteTriggerKind=In={}));class dn{constructor(G){this.value=G}append(...G){return new dn((this.value?[this.value,...G]:G).join(dn.c))}intersects(G){return this.contains(G)||G.contains(this)}contains(G){return this.value===G.value||G.value.startsWith(this.value+dn.c)}}e.$sN=dn,dn.c=".",dn.Empty=new dn("");class Le{constructor(G,me,Oe){this.title=me,this.insertText=G,this.kind=Oe}}e.$tN=Le;let je=class{constructor(G,me){this.id=G,this.color=me}static isThemeIcon(G){return typeof G.id!="string"?(console.log("INVALID ThemeIcon, invalid id",G.id),!1):!0}};e.$uN=je,e.$uN=je=Ze([F],je),je.File=new je("file"),je.Folder=new je("folder");let ke=class{constructor(G){this.id=G}};e.$vN=ke,e.$vN=ke=Ze([F],ke);var re;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace",J[J.WorkspaceFolder=3]="WorkspaceFolder"})(re||(e.ConfigurationTarget=re={}));let Fe=class{get base(){return this.c}set base(G){this.c=G,this.e=l.URI.file(G)}get baseUri(){return this.e}set baseUri(G){this.e=G,this.c=G.fsPath}constructor(G,me){if(typeof G!="string"&&(!G||!l.URI.isUri(G)&&!l.URI.isUri(G.uri)))throw(0,u.$7)("base");if(typeof me!="string")throw(0,u.$7)("pattern");typeof G=="string"?this.baseUri=l.URI.file(G):l.URI.isUri(G)?this.baseUri=G:this.baseUri=G.uri,this.pattern=me}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wN=Fe,e.$wN=Fe=Ze([F],Fe);const We=new WeakMap;function et(J,G){We.set(J,G)}let Ke=class{constructor(G,me,Oe,Xe,it){this.enabled=typeof G=="boolean"?G:!0,typeof me=="string"&&(this.condition=me),typeof Oe=="string"&&(this.hitCondition=Oe),typeof Xe=="string"&&(this.logMessage=Xe),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=We.get(this)??(0,I.$Wg)()),this.c}};e.$yN=Ke,e.$yN=Ke=Ze([F],Ke);let gt=class extends Ke{constructor(G,me,Oe,Xe,it,mt){if(super(me,Oe,Xe,it,mt),G===null)throw(0,u.$7)("location");this.location=G}};e.$zN=gt,e.$zN=gt=Ze([F],gt);let Ct=class extends Ke{constructor(G,me,Oe,Xe,it,mt){super(me,Oe,Xe,it,mt),this.functionName=G}};e.$AN=Ct,e.$AN=Ct=Ze([F],Ct);let Xt=class extends Ke{constructor(G,me,Oe,Xe,it,mt,vt,xt){if(super(Xe,it,mt,vt,xt),!me)throw(0,u.$7)("dataId");this.label=G,this.dataId=me,this.canPersist=Oe}};e.$BN=Xt,e.$BN=Xt=Ze([F],Xt);let an=class{constructor(G,me,Oe){this.command=G,this.args=me||[],this.options=Oe}};e.$CN=an,e.$CN=an=Ze([F],an);let Bt=class{constructor(G,me){this.port=G,this.host=me}};e.$DN=Bt,e.$DN=Bt=Ze([F],Bt);let Yt=class{constructor(G){this.path=G}};e.$EN=Yt,e.$EN=Yt=Ze([F],Yt);let Vn=class{constructor(G){this.implementation=G}};e.$FN=Vn,e.$FN=Vn=Ze([F],Vn);class xn{constructor(G,me,Oe){this.session=G,this.threadId=me,this.frameId=Oe}}e.$GN=xn;class wi{constructor(G,me){this.session=G,this.threadId=me}}e.$HN=wi;let Ln=class{constructor(G,me){this.range=G,this.expression=me}};e.$IN=Ln,e.$IN=Ln=Ze([F],Ln);var Nn;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(Nn||(e.InlineCompletionTriggerKind=Nn={}));let qn=class{constructor(G,me){this.range=G,this.text=me}};e.$JN=qn,e.$JN=qn=Ze([F],qn);let Gn=class{constructor(G,me,Oe=!0){this.range=G,this.variableName=me,this.caseSensitiveLookup=Oe}};e.$KN=Gn,e.$KN=Gn=Ze([F],Gn);let vn=class{constructor(G,me){this.range=G,this.expression=me}};e.$LN=vn,e.$LN=vn=Ze([F],vn);let Hn=class{constructor(G,me){this.frameId=G,this.stoppedLocation=me}};e.$MN=Hn,e.$MN=Hn=Ze([F],Hn);var _n;(function(J){J[J.AIGenerated=1]="AIGenerated"})(_n||(e.NewSymbolNameTag=_n={}));var Fn;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(Fn||(e.NewSymbolNameTriggerKind=Fn={}));class ei{constructor(G,me){this.newSymbolName=G,this.tags=me}}e.$NN=ei;var Kn;(function(J){J[J.Changed=1]="Changed",J[J.Created=2]="Created",J[J.Deleted=3]="Deleted"})(Kn||(e.FileChangeType=Kn={}));let Jn=M=class extends Error{static FileExists(G){return new M(G,f.FileSystemProviderErrorCode.FileExists,M.FileExists)}static FileNotFound(G){return new M(G,f.FileSystemProviderErrorCode.FileNotFound,M.FileNotFound)}static FileNotADirectory(G){return new M(G,f.FileSystemProviderErrorCode.FileNotADirectory,M.FileNotADirectory)}static FileIsADirectory(G){return new M(G,f.FileSystemProviderErrorCode.FileIsADirectory,M.FileIsADirectory)}static NoPermissions(G){return new M(G,f.FileSystemProviderErrorCode.NoPermissions,M.NoPermissions)}static Unavailable(G){return new M(G,f.FileSystemProviderErrorCode.Unavailable,M.Unavailable)}constructor(G,me=f.FileSystemProviderErrorCode.Unknown,Oe){super(l.URI.isUri(G)?G.toString(!0):G),this.code=Oe?.name??"Unknown",(0,f.$jl)(this,me),Object.setPrototypeOf(this,M.prototype),typeof Error.captureStackTrace=="function"&&typeof Oe=="function"&&Error.captureStackTrace(this,Oe)}};e.$ON=Jn,e.$ON=Jn=M=Ze([F],Jn);let jn=class{constructor(G,me,Oe){this.start=G,this.end=me,this.kind=Oe}};e.$PN=jn,e.$PN=jn=Ze([F],jn);var ti;(function(J){J[J.Comment=1]="Comment",J[J.Imports=2]="Imports",J[J.Region=3]="Region"})(ti||(e.FoldingRangeKind=ti={}));var Pn;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(Pn||(e.CommentThreadCollapsibleState=Pn={}));var ni;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(ni||(e.CommentMode=ni={}));var ii;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(ii||(e.CommentState=ii={}));var ri;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(ri||(e.CommentThreadState=ri={}));var Un;(function(J){J[J.Current=0]="Current",J[J.Outdated=1]="Outdated"})(Un||(e.CommentThreadApplicability=Un={}));class si{constructor(G,me=[]){this.tokenTypes=G,this.tokenModifiers=me}}e.$QN=si;function ze(J){return typeof J>"u"||(0,p.$bg)(J)}class fn{constructor(G){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,G){this.m=!0;for(let me=0,Oe=G.tokenTypes.length;me<Oe;me++)this.k.set(G.tokenTypes[me],me);for(let me=0,Oe=G.tokenModifiers.length;me<Oe;me++)this.l.set(G.tokenModifiers[me],me)}}push(G,me,Oe,Xe,it){if(typeof G=="number"&&typeof me=="number"&&typeof Oe=="number"&&typeof Xe=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(G,me,Oe,Xe,it);if(V.isRange(G)&&typeof me=="string"&&ze(Oe))return this.o(G,me,Oe);throw(0,u.$7)()}o(G,me,Oe){if(!this.m)throw new Error("Legend must be provided in constructor");if(G.start.line!==G.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(me))throw new Error("`tokenType` is not in the provided legend");const Xe=G.start.line,it=G.start.character,mt=G.end.character-G.start.character,vt=this.k.get(me);let xt=0;if(Oe)for(const gn of Oe){if(!this.l.has(gn))throw new Error("`tokenModifier` is not in the provided legend");const bn=this.l.get(gn);xt|=1<<bn>>>0}this.q(Xe,it,mt,vt,xt)}q(G,me,Oe,Xe,it){if(this.f&&(G<this.c||G===this.c&&me<this.e)){this.f=!1;const xt=this.g.length/5|0;let gn=0,bn=0;for(let En=0;En<xt;En++){let Dn=this.g[5*En],Xn=this.g[5*En+1];Dn===0?(Dn=gn,Xn+=bn):Dn+=gn,this.g[5*En]=Dn,this.g[5*En+1]=Xn,gn=Dn,bn=Xn}}let mt=G,vt=me;this.f&&this.j>0&&(mt-=this.c,mt===0&&(vt-=this.e)),this.g[this.j++]=mt,this.g[this.j++]=vt,this.g[this.j++]=Oe,this.g[this.j++]=Xe,this.g[this.j++]=it,this.c=G,this.e=me}static r(G){const me=[],Oe=G.length/5|0;for(let vt=0;vt<Oe;vt++)me[vt]=vt;me.sort((vt,xt)=>{const gn=G[5*vt],bn=G[5*xt];if(gn===bn){const En=G[5*vt+1],Dn=G[5*xt+1];return En-Dn}return gn-bn});const Xe=new Uint32Array(G.length);let it=0,mt=0;for(let vt=0;vt<Oe;vt++){const xt=5*me[vt],gn=G[xt+0],bn=G[xt+1],En=G[xt+2],Dn=G[xt+3],Xn=G[xt+4],Hi=gn-it,Cr=Hi===0?bn-mt:bn,Yn=5*vt;Xe[Yn+0]=Hi,Xe[Yn+1]=Cr,Xe[Yn+2]=En,Xe[Yn+3]=Dn,Xe[Yn+4]=Xn,it=gn,mt=bn}return Xe}build(G){return this.f?new zn(new Uint32Array(this.g),G):new zn(fn.r(this.g),G)}}e.$RN=fn;class zn{constructor(G,me){this.resultId=me,this.data=G}}e.$SN=zn;class ut{constructor(G,me,Oe){this.start=G,this.deleteCount=me,this.data=Oe}}e.$TN=ut;class It{constructor(G,me){this.resultId=me,this.edits=G}}e.$UN=It;var oi;(function(J){J[J.Separate=0]="Separate",J[J.MergeWithParent=1]="MergeWithParent"})(oi||(e.DebugConsoleMode=oi={}));class vi{constructor(G){this.name=G}}e.$VN=vi;let On=class{constructor(){}};e.$WN=On,On.Back={iconPath:new je("arrow-left")},e.$WN=On=Ze([F],On);var ai;(function(J){J[J.Separator=-1]="Separator",J[J.Default=0]="Default"})(ai||(e.QuickPickItemKind=ai={}));var Mn;(function(J){J[J.Info=1]="Info",J[J.Warning=2]="Warning",J[J.Error=3]="Error"})(Mn||(e.InputBoxValidationSeverity=Mn={}));var ci;(function(J){J[J.UI=1]="UI",J[J.Workspace=2]="Workspace"})(ci||(e.ExtensionKind=ci={}));class yi{static validate(G){if(typeof G.badge=="string"){let me=(0,R.$Lf)(G.badge,0);if(me<G.badge.length&&(me+=(0,R.$Lf)(G.badge,me)),G.badge.length>me)throw new Error("The 'badge'-property must be undefined or a short character")}else if(G.badge&&!je.isThemeIcon(G.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!G.color&&!G.badge&&!G.tooltip)throw new Error("The decoration is empty");return!0}constructor(G,me,Oe){this.badge=G,this.tooltip=me,this.color=Oe}}e.$XN=yi;let Zn=class{constructor(G){this.kind=G}};e.$YN=Zn,e.$YN=Zn=Ze([F],Zn);var Qn;(function(J){J[J.Light=1]="Light",J[J.Dark=2]="Dark",J[J.HighContrast=3]="HighContrast",J[J.HighContrastLight=4]="HighContrastLight"})(Qn||(e.ColorThemeKind=Qn={}));class yn{static isNotebookRange(G){return G instanceof yn?!0:G?typeof G.start=="number"&&typeof G.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(G,me){if(G<0)throw(0,u.$7)("start must be positive");if(me<0)throw(0,u.$7)("end must be positive");G<=me?(this.c=G,this.e=me):(this.c=me,this.e=G)}with(G){let me=this.c,Oe=this.e;return G.start!==void 0&&(me=G.start),G.end!==void 0&&(Oe=G.end),me===this.c&&Oe===this.e?this:new yn(me,Oe)}}e.$ZN=yn;class Bn{static validate(G){if(typeof G.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof G.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof G.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(G){return Array.isArray(G)&&G.every(me=>Bn.isNotebookCellData(me))}static isNotebookCellData(G){return!0}constructor(G,me,Oe,Xe,it,mt,vt){this.kind=G,this.value=me,this.languageId=Oe,this.mime=Xe,this.outputs=it??[],this.metadata=mt,this.executionSummary=vt,Bn.validate(this)}}e.$1N=Bn;class Ei{constructor(G){this.cells=G}}e.$2N=Ei;class li{static isNotebookCellOutputItem(G){return G instanceof n?!0:G?typeof G.mime=="string"&&G.data instanceof Uint8Array:!1}static error(G){const me={name:G.name,message:G.message,stack:G.stack};return n.json(me,"application/vnd.code.notebook.error")}static stdout(G){return n.text(G,"application/vnd.code.notebook.stdout")}static stderr(G){return n.text(G,"application/vnd.code.notebook.stderr")}static bytes(G,me="application/octet-stream"){return new n(G,me)}static text(G,me=L.$Zs.text){const Oe=Ge(n,n,"f",t).encode(String(G));return new n(Oe,me)}static json(G,me="text/x-json"){const Oe=JSON.stringify(G,void 0,"	");return n.text(Oe,me)}constructor(G,me){this.data=G,this.mime=me;const Oe=(0,L.$4s)(me,!0);if(!Oe)throw new Error(`INVALID mime type: ${me}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Oe}}e.$3N=li,n=li,t={value:new TextEncoder};class Wn{static isNotebookCellOutput(G){return G instanceof Wn?!0:!G||typeof G!="object"?!1:typeof G.id=="string"&&Array.isArray(G.items)}static ensureUniqueMimeTypes(G,me=!1){const Oe=new Set,Xe=new Set;for(let it=0;it<G.length;it++){const mt=G[it],vt=(0,L.$4s)(mt.mime);if(!Oe.has(vt)||(0,w.$rK)(vt)){Oe.add(vt);continue}Xe.add(it),me&&console.warn(`DUPLICATED mime type '${mt.mime}' will be dropped`)}return Xe.size===0?G:G.filter((it,mt)=>!Xe.has(mt))}constructor(G,me,Oe){this.items=Wn.ensureUniqueMimeTypes(G,!0),typeof me=="string"?(this.id=me,this.metadata=Oe):(this.id=(0,I.$Wg)(),this.metadata=me??Oe)}}e.$4N=Wn;var ui;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(ui||(e.NotebookCellKind=ui={}));var hi;(function(J){J[J.Idle=1]="Idle",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(hi||(e.NotebookCellExecutionState=hi={}));var di;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(di||(e.NotebookCellStatusBarAlignment=di={}));var fi;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(fi||(e.NotebookEditorRevealType=fi={}));class Si{constructor(G,me){this.text=G,this.alignment=me}}e.$5N=Si;var gi;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred"})(gi||(e.NotebookControllerAffinity=gi={}));var ge;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred",J[J.Hidden=-1]="Hidden"})(ge||(e.NotebookControllerAffinity2=ge={}));class ye{constructor(G,me=[]){this.uri=G,this.provides=(0,r.$2b)(me)}}e.$6N=ye;class Ue{constructor(G){this.label=G}}e.$7N=Ue;var dt;(function(J){J[J.Named=1]="Named",J[J.Indexed=2]="Indexed"})(dt||(e.NotebookVariablesRequestKind=dt={}));let kt=class{constructor(G,me){this.label=G,this.timestamp=me}};e.$8N=kt,e.$8N=kt=Ze([F],kt);var Lt;(function(J){J[J.Production=1]="Production",J[J.Development=2]="Development",J[J.Test=3]="Test"})(Lt||(e.ExtensionMode=Lt={}));var Cn;(function(J){J[J.Node=1]="Node",J[J.Webworker=2]="Webworker"})(Cn||(e.ExtensionRuntime=Cn={}));var mi;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(mi||(e.StandardTokenType=mi={}));class Ki{constructor(G,me){this.ranges=G,this.wordPattern=me}}e.$9N=Ki;class Ji{constructor(G){this.c=G}get autoForwardAction(){return this.c}}e.$0N=Ji;var Ci;(function(J){J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})(Ci||(e.TestResultState=Ci={}));var Ai;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(Ai||(e.TestRunProfileKind=Ai={}));let ki=class{constructor(G=void 0,me=void 0,Oe=void 0,Xe=!1,it=!0){this.include=G,this.exclude=me,this.profile=Oe,this.continuous=Xe,this.preserveFocus=it}};e.$$N=ki,e.$$N=ki=Ze([F],ki);let Di=N=class{static diff(G,me,Oe){const Xe=new N(G);return Xe.expectedOutput=me,Xe.actualOutput=Oe,Xe}constructor(G){this.message=G}};e.$_N=Di,e.$_N=Di=N=Ze([F],Di);let Ii=class{constructor(G){this.id=G}};e.$aO=Ii,e.$aO=Ii=Ze([F],Ii);class $i{constructor(G,me){this.covered=G,this.total=me,Ri(this)}}e.$bO=$i;function Ri(J){if(J){if(J.covered>J.total)throw new Error(`The total number of covered items (${J.covered}) cannot be greater than the total (${J.total})`);if(J.total<0)throw new Error(`The number of covered items (${J.total}) cannot be negative`)}}class Pi{static fromDetails(G,me){const Oe=new $i(0,0),Xe=new $i(0,0),it=new $i(0,0);for(const vt of me)if("branches"in vt){Oe.total+=1,Oe.covered+=vt.executed?1:0;for(const xt of vt.branches)Xe.total+=1,Xe.covered+=xt.executed?1:0}else it.total+=1,it.covered+=vt.executed?1:0;const mt=new Pi(G,Oe,Xe.total>0?Xe:void 0,it.total>0?it:void 0);return mt.detailedCoverage=me,mt}constructor(G,me,Oe,Xe,it){this.uri=G,this.statementCoverage=me,this.branchCoverage=Oe,this.declarationCoverage=Xe,this.testItem=it}}e.$dO=Pi;class Zi{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,me,Oe=[]){this.executed=G,this.location=me,this.branches=Oe}}e.$eO=Zi;class Qi{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,me,Oe){this.executed=G,this.location=me,this.label=Oe}}e.$fO=Qi;class Xi{get executionCount(){return+this.executed}set executionCount(G){this.executed=G}constructor(G,me,Oe){this.name=G,this.executed=me,this.location=Oe}}e.$gO=Xi;var Ti;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(Ti||(e.ExternalUriOpenerPriority=Ti={}));var Li;(function(J){J[J.Untrusted=0]="Untrusted",J[J.Trusted=1]="Trusted",J[J.Unspecified=2]="Unspecified"})(Li||(e.WorkspaceTrustState=Li={}));var Oi;(function(J){J[J.Notify=1]="Notify",J[J.OpenBrowser=2]="OpenBrowser",J[J.OpenPreview=3]="OpenPreview",J[J.Silent=4]="Silent",J[J.Ignore=5]="Ignore",J[J.OpenBrowserOnce=6]="OpenBrowserOnce"})(Oi||(e.PortAutoForwardAction=Oi={}));class Yi{constructor(G,me,Oe,Xe,it,mt){this.kind=G,this.name=me,this.detail=Oe,this.uri=Xe,this.range=it,this.selectionRange=mt}}e.$hO=Yi;class xi{constructor(G){this.uri=G}}e.$iO=xi;class _i{constructor(G,me){this.original=G,this.modified=me}}e.$jO=_i;class er{constructor(G,me,Oe,Xe){this.base=G,this.input1=me,this.input2=Oe,this.result=Xe}}e.$kO=er;class tr{constructor(G,me){this.uri=G,this.viewType=me}}e.$lO=tr;class nr{constructor(G){this.viewType=G}}e.$mO=nr;class ir{constructor(G,me){this.uri=G,this.notebookType=me}}e.$nO=ir;class rr{constructor(G,me,Oe){this.original=G,this.modified=me,this.notebookType=Oe}}e.$oO=rr;class sr{constructor(){}}e.$pO=sr;class or{constructor(G,me){this.uri=G,this.inputBoxUri=me}}e.$qO=or;class ar{constructor(){}}e.$rO=ar;class cr{constructor(G){this.textDiffs=G}}e.$sO=cr;var Mi;(function(J){J[J.Down=0]="Down",J[J.Up=1]="Up"})(Mi||(e.InteractiveSessionVoteDirection=Mi={}));var Ni;(function(J){J[J.Action=1]="Action",J[J.Toolbar=2]="Toolbar"})(Ni||(e.ChatCopyKind=Ni={}));var Fi;(function(J){J[J.Short=1]="Short",J[J.Medium=2]="Medium",J[J.Full=3]="Full"})(Fi||(e.ChatVariableLevel=Fi={}));class lr{constructor(G,me,Oe){this.id=G,this.label=me,this.values=Oe}}e.$tO=lr;var ji;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful",J[J.Undone=2]="Undone",J[J.Accepted=3]="Accepted",J[J.Bug=4]="Bug"})(ji||(e.InteractiveEditorResponseFeedbackKind=ji={}));var Ui;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful"})(Ui||(e.ChatResultFeedbackKind=Ui={}));class ur{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new st(G):G}}e.$uO=ur;class hr{constructor(G,me){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new st(G):G,this.vulnerabilities=me}}e.$vO=hr;class dr{constructor(G,me){this.participant=G,this.command=me}}e.$wO=dr;class fr{constructor(G,me,Oe){this.title=G,this.message=me,this.data=Oe}}e.$xO=fr;class gr{constructor(G,me){this.value=G,this.baseUri=me}}e.$yO=gr;class mr{constructor(G,me){this.value=G,this.title=me}}e.$zO=mr;class $r{constructor(G){this.value=G}}e.$AO=$r;class pr{constructor(G,me){this.value=G,this.task=me}}e.$BO=pr;class br{constructor(G){if(typeof G!="string"&&G.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof G=="string"?new st(G):G}}e.$CO=br;class wr{constructor(G){this.value=G}}e.$DO=wr;class vr{constructor(G,me){this.value=G,this.iconPath=me}}e.$EO=vr;class yr{constructor(G,me){this.uri=G,this.edits=Array.isArray(me)?me:[me]}}e.$FO=yr;class Er{constructor(G,me,Oe,Xe){this.prompt=G,this.command=me,this.references=Oe,this.participant=Xe}}e.$GO=Er;class Sr{constructor(G,me,Oe,Xe){this.response=G,this.result=me,this.participant=Oe,this.command=Xe}}e.$HO=Sr;var zi;(function(J){J[J.Panel=1]="Panel",J[J.Terminal=2]="Terminal",J[J.Notebook=3]="Notebook",J[J.Editor=4]="Editor"})(zi||(e.ChatLocation=zi={}));var pi;(function(J){J[J.User=1]="User",J[J.Assistant=2]="Assistant",J[J.System=3]="System"})(pi||(e.LanguageModelChatMessageRole=pi={}));class bi{static User(G,me){return new bi(pi.User,G,me)}static Assistant(G,me){return new bi(pi.Assistant,G,me)}constructor(G,me,Oe){this.role=G,this.content=me,this.name=Oe}}e.$IO=bi;class kr{constructor(G){this.content=G}}e.$JO=kr;class Dr{constructor(G,me){this.content=G,this.name=me}}e.$KO=Dr;class Ir{constructor(G,me){this.content=G,this.name=me}}e.$LO=Ir;class An extends Error{static NotFound(G){return new An(G,An.NotFound.name)}static NoPermissions(G){return new An(G,An.NoPermissions.name)}static Blocked(G){return new An(G,An.Blocked.name)}constructor(G,me,Oe){super(G,{cause:Oe}),this.name="LanguageModelError",this.code=me??""}}e.$MO=An;var Bi;(function(J){J[J.SymbolInformation=1]="SymbolInformation",J[J.CommandInformation=2]="CommandInformation",J[J.SearchInformation=3]="SearchInformation",J[J.SettingInformation=4]="SettingInformation"})(Bi||(e.RelatedInformationType=Bi={}));var Wi;(function(J){J[J.Started=1]="Started",J[J.Recognizing=2]="Recognizing",J[J.Recognized=3]="Recognized",J[J.Stopped=4]="Stopped",J[J.Error=5]="Error"})(Wi||(e.SpeechToTextStatus=Wi={}));var Vi;(function(J){J[J.Started=1]="Started",J[J.Stopped=2]="Stopped",J[J.Error=3]="Error"})(Vi||(e.TextToSpeechStatus=Vi={}));var qi;(function(J){J[J.Recognized=1]="Recognized",J[J.Stopped=2]="Stopped"})(qi||(e.KeywordRecognitionStatus=qi={}));class Pr{constructor(G,me){this.text=G,this.range=me}}e.$NO=Pr;var Gi;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(Gi||(e.InlineEditTriggerKind=Gi={}))}),define(Ee[339],Se([1,0,6,8]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;class P{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$vM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,R,p){if(this.a.size===0)throw new Error("No related information providers registered");const l=this.a.get(L);if(!l)throw new Error("related information provider not found");return await l.provideRelatedInformation(R,p)??[]}getRelatedInformation(L,R,p){return this.c.$getAiRelatedInformation(R,p)}registerRelatedInformationProvider(L,R,p){const l=this.b;return this.b++,this.a.set(l,p),this.c.$registerAiRelatedInformationProvider(l,R),new u.$xM(()=>{this.c.$unregisterAiRelatedInformationProvider(l),this.a.delete(l)})}}e.$Rmc=P}),define(Ee[128],Se([1,0,4,6,8,24,155,5,20]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=e.$3mc=void 0,e.$3mc=(0,R.$Ai)("IExtHostAuthentication");let l=class{constructor(f){this.b=new Map,this.c=new r.$he,this.onDidChangeSessions=this.c.event,this.d=new I,this.f=new I,this.a=f.getProxy(u.$vM.MainThreadAuthentication)}async getSession(f,A,w,a={}){const d=T.$Xm.toKey(f.identifier),g=[...w].sort().join(" ");return await this.d.getOrCreate(`${d} ${A} ${g}`,async()=>{await this.a.$ensureProvider(A);const $=f.displayName||f.name;return this.a.$getSession(A,w,d,$,a)})}async getSessions(f,A,w){const a=T.$Xm.toKey(f.identifier),d=[...w].sort().join(" ");return await this.f.getOrCreate(`${a} ${d}`,async()=>{await this.a.$ensureProvider(A);const g=f.displayName||f.name;return this.a.$getSessions(A,w,a,g)})}async removeSession(f,A){const w=this.b.get(f);return w?w.provider.removeSession(A):this.a.$removeSession(f,A)}registerAuthenticationProvider(f,A,w,a){if(this.b.get(f))throw new Error(`An authentication provider with id '${f}' is already registered.`);this.b.set(f,{label:A,provider:w,options:a??{supportsMultipleAccounts:!1}});const d=w.onDidChangeSessions(g=>this.a.$sendDidChangeSessions(f,g));return this.a.$registerAuthenticationProvider(f,A,a?.supportsMultipleAccounts??!1),new P.$xM(()=>{d.dispose(),this.b.delete(f),this.a.$unregisterAuthenticationProvider(f)})}async $createSession(f,A,w){const a=this.b.get(f);if(a)return await a.provider.createSession(A,w);throw new Error(`Unable to find authentication provider with handle: ${f}`)}async $removeSession(f,A){const w=this.b.get(f);if(w)return await w.provider.removeSession(A);throw new Error(`Unable to find authentication provider with handle: ${f}`)}async $getSessions(f,A){const w=this.b.get(f);if(w)return await w.provider.getSessions(A);throw new Error(`Unable to find authentication provider with handle: ${f}`)}$onDidChangeAuthenticationSessions(f,A){return f.startsWith(L.$xL)||this.c.fire({provider:{id:f,label:A}}),Promise.resolve()}};e.$4mc=l,e.$4mc=l=Ze([Ve(0,p.$ZO)],l);class I{constructor(){this.a=new Map}getOrCreate(f,A){const w=this.a.get(f);if(w)return w;const a=A().finally(()=>this.a.delete(f));return this.a.set(f,a),a}}}),define(Ee[162],Se([1,0,2,6,8,5,20,12,19,13,16,26]),function(oe,e,r,u,P,T,L,R,p,l,I,D){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=e.$3nc=void 0;let A=f=class{constructor(a,d){this.h=d,this.f=new Map,this.g=a.getProxy(u.$vM.MainThreadDecorations)}registerFileDecorationProvider(a,d){const g=f.c++;this.f.set(g,{provider:a,extensionDescription:d}),this.g.$registerDecorationProvider(g,d.identifier.value);const $=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(g,null);return}const o=(0,p.$2b)(i);if(o.length<=f.d){this.g.$onDidChange(g,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,o.length);const n=o.map(h=>({uri:h,rank:(0,l.$ef)(h.path,"/")})),t=(0,p.$zb)(n,(h,s)=>h.rank-s.rank||(0,l.$uf)(h.uri.path,s.uri.path)),c=[];e:for(const h of t){let s;for(const m of h){const y=(0,I.$mc)(m.uri.path);if(s!==y&&(s=y,c.push(m.uri)>=f.d))break e}}this.g.$onDidChange(g,c)});return new P.$xM(()=>{$?.dispose(),this.g.$unregisterDecorationProvider(g),this.f.delete(g)})}async $provideDecorations(a,d,g){if(!this.f.has(a))return Object.create(null);const $=Object.create(null),{provider:i,extensionDescription:o}=this.f.get(a);return await Promise.all(d.map(async n=>{try{const{uri:t,id:c}=n,h=await Promise.resolve(i.provideFileDecoration(r.URI.revive(t),g));if(!h)return;try{P.$XN.validate(h),h.badge&&typeof h.badge!="string"&&(0,D.$VG)(o,"codiconDecoration"),$[c]=[h.propagate,h.tooltip,h.badge,h.color]}catch(s){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${s}`)}}catch(t){this.h.error(t)}})),$}};e.$3nc=A,A.c=0,A.d=250,e.$3nc=A=f=Ze([Ve(0,L.$ZO),Ve(1,R.$7j)],A),e.$4nc=(0,T.$Ai)("IExtHostDecorations")}),define(Ee[340],Se([1,0,14,2,8,6,15,21,13]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class l{constructor(D,f,A){this.d=f,this.e=A,this.b=new Map,this.c=D.getProxy(T.$vM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,f){if(Object.keys(L.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const A=l.a++;this.b.set(A,f),this.c.$registerTextContentProvider(A,D);let w;if(typeof f.onDidChange=="function"){let a;w=f.onDidChange(async d=>{if(d.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(d))return;a&&await a;const g=this.$provideTextDocumentContent(A,d).then(async $=>{if(!$&&typeof $!="string")return;const i=this.d.getDocument(d);if(!i)return;const o=(0,p.$of)($);if(!i.equalLines(o))return this.c.$onVirtualDocumentChange(d,$)}).catch(r.$1).finally(()=>{a===g&&(a=void 0)});a=g})}return new P.$xM(()=>{this.b.delete(A)&&this.c.$unregisterTextContentProvider(A),w&&(w.dispose(),w=void 0)})}$provideTextDocumentContent(D,f){const A=this.b.get(D);return A?Promise.resolve(A.provideTextDocumentContent(u.URI.revive(f),R.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${f.scheme}`))}}e.$6nc=l,l.a=0}),define(Ee[163],Se([1,0,65,15,13,204,141,8,19]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=void 0,e.$2O=I;const l=new Map;function I(w,a){a?l.set(w,a):l.delete(w)}function D(w){return l.get(w)}class f extends T.$dw{constructor(a,d,g,$,i,o,n){super(d,g,$,i),this.c=a,this.m=o,this.q=n,this.b=!1}dispose(){(0,r.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,p.$ub)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===u.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(d){return d?a.s(d):a.getText()},get eol(){return a.g===`
`?R.EndOfLine.LF:R.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(d){return a.t(d)},offsetAt(d){return a.u(d)},positionAt(d){return a.v(d)},validateRange(d){return a.w(d)},validatePosition(d){return a.x(d)},getWordRangeAtPosition(d,g){return a.y(d,g)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,r.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,r.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const d=this.w(a);if(d.isEmpty)return"";if(d.isSingleLine)return this.f[d.start.line].substring(d.start.character,d.end.character);const g=this.g,$=d.start.line,i=d.end.line,o=[];o.push(this.f[$].substring(d.start.character));for(let n=$+1;n<i;n++)o.push(this.f[n]);return o.push(this.f[i].substring(0,d.end.character)),o.join(g)}t(a){let d;if(a instanceof R.$yM?d=a.line:typeof a=="number"&&(d=a),typeof d!="number"||d<0||d>=this.f.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new A(d,this.f[d],d===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const d=this.j.getIndexOf(a),g=this.f[d.index].length;return new R.$yM(d.index,Math.min(d.remainder,g))}w(a){if(!(a instanceof R.$zM))throw new Error("Invalid argument");const d=this.x(a.start),g=this.x(a.end);return d===a.start&&g===a.end?a:new R.$zM(d.line,d.character,g.line,g.character)}x(a){if(!(a instanceof R.$yM))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:d,character:g}=a,$=!1;if(d<0)d=0,g=0,$=!0;else if(d>=this.f.length)d=this.f.length-1,g=this.f[d].length,$=!0;else{const i=this.f[d].length;g<0?(g=0,$=!0):g>i&&(g=i,$=!0)}return $?new R.$yM(d,g):a}y(a,d){const g=this.x(a);if(!d)d=D(this.m);else if((0,P.$nf)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const $=(0,L.$wt)(g.character+1,(0,L.$ut)(d),this.f[g.line],0);if($)return new R.$zM(g.line,$.startColumn-1,g.line,$.endColumn-1)}}e.$3O=f;class A{constructor(a,d,g){this.a=a,this.b=d,this.c=g}get lineNumber(){return this.a}get text(){return this.b}get range(){return new R.$zM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new R.$zM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$4O=A}),define(Ee[341],Se([1,0,6,8]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=void 0;class P{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(r.$vM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,R,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const l=this.a.get(L);if(!l)throw new Error("Embedding vector provider not found");const I=await l.provideEmbeddingVector(R,p);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(L,R,p){const l=this.b;return this.b++,this.a.set(l,p),this.c.$registerAiEmbeddingVectorProvider(R,l),new u.$xM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(l),this.a.delete(l)})}}e.$9nc=P}),define(Ee[75],Se([1,0,6,28,8,22,5,20,63,3,7,23,15]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=e.$gnc=void 0;let w=A=class{constructor(d,g){this.b=new Map,this.c=new I.$Jh,this.a=d.getProxy(r.$vM.MainThreadFileSystem);const $=this;this.value=Object.freeze({async stat(i){try{let o;const n=$.b.get(i.scheme);return n?(await $.a.$ensureActivation(i.scheme),o=await n.impl.stat(i)):o=await $.a.$stat(i),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===u.FilePermission.Readonly?1:void 0}}catch(o){A.e(o)}},async readDirectory(i){try{const o=$.b.get(i.scheme);return o?(await $.a.$ensureActivation(i.scheme),(await o.impl.readDirectory(i)).slice()):await $.a.$readdir(i)}catch(o){return A.e(o)}},async createDirectory(i){try{const o=$.b.get(i.scheme);return o&&!o.isReadonly?(await $.a.$ensureActivation(i.scheme),await $.d(o.impl,o.extUri,i)):await $.a.$mkdir(i)}catch(o){return A.e(o)}},async readFile(i){try{const o=$.b.get(i.scheme);return o?(await $.a.$ensureActivation(i.scheme),(await o.impl.readFile(i)).slice()):(await $.a.$readFile(i)).buffer}catch(o){return A.e(o)}},async writeFile(i,o){try{const n=$.b.get(i.scheme);return n&&!n.isReadonly?(await $.a.$ensureActivation(i.scheme),await $.d(n.impl,n.extUri,n.extUri.dirname(i)),await $.c.queueFor(i,()=>Promise.resolve(n.impl.writeFile(i,o,{create:!0,overwrite:!0})))):await $.a.$writeFile(i,T.$Je.wrap(o))}catch(n){return A.e(n)}},async delete(i,o){try{const n=$.b.get(i.scheme);return n&&!n.isReadonly&&!o?.useTrash?(await $.a.$ensureActivation(i.scheme),await n.impl.delete(i,{recursive:!1,...o})):await $.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(n){return A.e(n)}},async rename(i,o,n){try{return await $.a.$rename(i,o,{overwrite:!1,...n})}catch(t){return A.e(t)}},async copy(i,o,n){try{return await $.a.$copy(i,o,{overwrite:!1,...n})}catch(t){return A.e(t)}},isWritableFileSystem(i){const o=g.getCapabilities(i);if(typeof o=="number")return!(o&u.FileSystemProviderCapabilities.Readonly)}})}async d(d,g,$){const i=[];for(;!g.isEqual($,g.dirname($));)try{if(!((await d.stat($)).type&u.FileType.Directory))throw P.$ON.FileExists(`Unable to create folder '${$.scheme===f.Schemas.file?$.fsPath:$.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(u.$kl(o)!==u.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(g.basename($)),$=g.dirname($)}for(let o=i.length-1;o>=0;o--){$=g.joinPath($,i[o]);try{await d.createDirectory($)}catch(n){if(u.$kl(n)!==u.FileSystemProviderErrorCode.FileExists)throw n}}}static e(d){if(d instanceof P.$ON)throw d;if(d instanceof u.$gl)switch(d.code){case u.FileSystemProviderErrorCode.FileExists:throw P.$ON.FileExists(d.message);case u.FileSystemProviderErrorCode.FileNotFound:throw P.$ON.FileNotFound(d.message);case u.FileSystemProviderErrorCode.FileNotADirectory:throw P.$ON.FileNotADirectory(d.message);case u.FileSystemProviderErrorCode.FileIsADirectory:throw P.$ON.FileIsADirectory(d.message);case u.FileSystemProviderErrorCode.NoPermissions:throw P.$ON.NoPermissions(d.message);case u.FileSystemProviderErrorCode.Unavailable:throw P.$ON.Unavailable(d.message);default:throw new P.$ON(d.message,d.name)}if(!(d instanceof Error))throw new P.$ON(String(d));if(d.name==="ENOPRO"||d.message.includes("ENOPRO"))throw P.$ON.Unavailable(d.message);switch(d.name){case u.FileSystemProviderErrorCode.FileExists:throw P.$ON.FileExists(d.message);case u.FileSystemProviderErrorCode.FileNotFound:throw P.$ON.FileNotFound(d.message);case u.FileSystemProviderErrorCode.FileNotADirectory:throw P.$ON.FileNotADirectory(d.message);case u.FileSystemProviderErrorCode.FileIsADirectory:throw P.$ON.FileIsADirectory(d.message);case u.FileSystemProviderErrorCode.NoPermissions:throw P.$ON.NoPermissions(d.message);case u.FileSystemProviderErrorCode.Unavailable:throw P.$ON.Unavailable(d.message);default:throw new P.$ON(d.message,d.name)}}addFileSystemProvider(d,g,$){return this.b.set(d,{impl:g,extUri:$?.isCaseSensitive?D.$4g:D.$6g,isReadonly:!!$?.isReadonly}),(0,l.$Sc)(()=>this.b.delete(d))}getFileSystemProviderExtUri(d){return this.b.get(d)?.extUri??D.$4g}};e.$gnc=w,e.$gnc=w=A=Ze([Ve(0,R.$ZO),Ve(1,p.$Wmc)],w),e.$hnc=(0,L.$Ai)("IExtHostConsumerFileSystem")}),define(Ee[98],Se([1,0,5,30,12,75,2]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=e.$inc=void 0,e.$inc=(0,r.$Ai)("IExtensionStoragePaths");let R=class{constructor(l,I,D){this.d=I,this.f=D,this.a=l.workspace??void 0,this.b=l.environment,this.whenReady=this.h().then(f=>this.c=f)}async g(l){return L.URI.joinPath(this.b.workspaceStorageHome,l)}async h(){if(!this.a)return Promise.resolve(void 0);const l=this.a.id,I=await this.g(l);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(L.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(l){if(this.c)return L.URI.joinPath(this.c,l.identifier.value)}globalValue(l){return L.URI.joinPath(this.b.globalStorageHome,l.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$jnc=R,e.$jnc=R=Ze([Ve(0,u.$dP),Ve(1,P.$7j),Ve(2,T.$hnc)],R)}),define(Ee[342],Se([1,0,8,20,4]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=void 0;let T=class{constructor(R){this.a=new r.$YN(r.ColorThemeKind.Dark),this.b=new P.$he}get activeColorTheme(){return this.a}$onColorThemeChange(R){let p;switch(R){case"light":p=r.ColorThemeKind.Light;break;case"hcDark":p=r.ColorThemeKind.HighContrast;break;case"hcLight":p=r.ColorThemeKind.HighContrastLight;break;default:p=r.ColorThemeKind.Dark}this.a=new r.$YN(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Qoc=T,e.$Qoc=T=Ze([Ve(0,u.$ZO)],T)}),define(Ee[76],Se([1,0,21,4,3,242,5,12,93,6,30,20,8]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xEb=e.$wEb=e.TunnelDtoConverter=void 0;class A extends p.$Cw{}var w;(function(d){function g(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}d.fromApiTunnel=g;function $(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}d.fromServiceTunnel=$})(w||(e.TunnelDtoConverter=w={})),e.$wEb=(0,L.$Ai)("IExtHostTunnelService");let a=class extends P.$Uc{constructor(g,$,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new u.$he,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=g.getProxy(l.$vM.MainThreadTunnelService)}async openTunnel(g,$){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${g.identifier.value} called openTunnel API for ${$.remoteAddress.host}:${$.remoteAddress.port}.`);const i=await this.a.$openTunnel($,g.displayName);if(i){const o=new A(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(g,$){g.portRange===void 0&&g.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:g,provider:$}),this.a.$registerPortsAttributesProvider(g,i),new f.$xM(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(g,$,i,o,n){const t=[];for(const h of g){const s=this.r.get(h);if(!s)return[];t.push(...await Promise.all($.map(async m=>{let y;try{y=await s.provider.providePortAttributes({port:m,pid:i,commandLine:o},n)}catch{y=await s.provider.providePortAttributes(m,i,o,n)}return{providedAttributes:y,port:m}})))}const c=t.filter(h=>!!h.providedAttributes);return c.length>0?c.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(g){}registerTunnelProvider(g,$){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,n)=>await g.provideTunnel(o,n,r.CancellationToken.None)??void 0;const i=$.tunnelFeatures?{elevation:!!$.tunnelFeatures?.elevation,privacyOptions:$.tunnelFeatures?.privacyOptions,protocol:$.tunnelFeatures.protocol===void 0?!0:$.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(g,$){if(g){g.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(g.candidatePortSource),g.showCandidatePort&&(this.f=g.showCandidatePort,this.a.$setCandidateFilter());const i=g.tunnelFactory??($?this.w($):void 0);if(i){this.b=i;let o=g.tunnelFeatures?.privacyOptions??[];g.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const n=g.tunnelFeatures?{elevation:!!g.tunnelFeatures?.elevation,public:!!g.tunnelFeatures?.public,privacyOptions:o,protocol:!0}:void 0;this.a.$setTunnelProvider(n)}}else this.b=void 0;return(0,P.$Sc)(()=>{this.b=void 0})}w(g){}async $closeTunnel(g,$){if(this.g.has(g.host)){const i=this.g.get(g.host);i.has(g.port)&&($&&i.get(g.port).disposeListener.dispose(),await i.get(g.port).tunnel.dispose(),i.delete(g.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(g,$){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(g,$);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const o=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(g.remoteAddress.host)||this.g.set(g.remoteAddress.host,new Map);const n=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(g.remoteAddress.host).set(g.remoteAddress.port,{tunnel:o,disposeListener:n}),w.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(g){const $=await Promise.all(g.map(o=>this.f(o.host,o.port,o.detail??""))),i=g.filter((o,n)=>$[n]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${g.map(o=>o.port).join(", ")} to ${i.map(o=>o.port).join(", ")}`),i}};e.$xEb=a,e.$xEb=a=Ze([Ve(0,D.$ZO),Ve(1,I.$dP),Ve(2,R.$7j)],a)}),define(Ee[17],Se([1,0,19,22,188,80,86,29,176,55,103,25,181,23,50,18,2,113,31,110,88,59,145,90,154,152,304,320,120,127,73,74,316,8]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n,t,c,h,s,m,y,S,E,k,C,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$WO=x,e.$XO=ne,e.$YO=we;var O;(function(Le){function je(re){const{selectionStartLineNumber:Fe,selectionStartColumn:We,positionLineNumber:et,positionColumn:Ke}=re,gt=new b.$yM(Fe-1,We-1),Ct=new b.$yM(et-1,Ke-1);return new b.$AM(gt,Ct)}Le.to=je;function ke(re){const{anchor:Fe,active:We}=re;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Le.from=ke})(O||(e.Selection=O={}));var U;(function(Le){function je(re){if(!re)return;const{start:Fe,end:We}=re;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Le.from=je;function ke(re){if(!re)return;const{startLineNumber:Fe,startColumn:We,endLineNumber:et,endColumn:Ke}=re;return new b.$zM(Fe-1,We-1,et-1,Ke-1)}Le.to=ke})(U||(e.Range=U={}));var z;(function(Le){function je(re){return{uri:re.uri,range:U.from(re.range)}}Le.from=je;function ke(re){return new b.$JM(d.URI.revive(re.uri),U.to(re.range))}Le.to=ke})(z||(e.Location=z={}));var j;(function(Le){function je(ke){switch(ke){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}Le.to=je})(j||(e.TokenType=j={}));var M;(function(Le){function je(re){return new b.$yM(re.lineNumber-1,re.column-1)}Le.to=je;function ke(re){return{lineNumber:re.line+1,column:re.character+1}}Le.from=ke})(M||(e.Position=M={}));var N;(function(Le){function je(Fe,We,et){return(0,r.$Hb)((0,r.$2b)(Fe).map(Ke=>ke(Ke,We,et)))}Le.from=je;function ke(Fe,We,et){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:et?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:re(Fe.scheme,We),pattern:ct.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:et?.isBuiltin}}function re(Fe,We){return We&&typeof Fe=="string"?We.transformOutgoingScheme(Fe):Fe}})(N||(e.DocumentSelector=N={}));var F;(function(Le){function je(re){switch(re){case b.DiagnosticTag.Unnecessary:return t.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return t.MarkerTag.Deprecated}}Le.from=je;function ke(re){switch(re){case t.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case t.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}Le.to=ke})(F||(e.DiagnosticTag=F={}));var X;(function(Le){function je(re){let Fe;return re.code&&((0,a.$ag)(re.code)||(0,a.$eg)(re.code)?Fe=String(re.code):Fe={value:String(re.code.value),target:re.code.target}),{...U.from(re.range),message:re.message,source:re.source,code:Fe,severity:W.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(se.from),tags:Array.isArray(re.tags)?(0,r.$Hb)(re.tags.map(F.from)):void 0}}Le.from=je;function ke(re){const Fe=new b.$LM(U.to(re),re.message,W.to(re.severity));return Fe.source=re.source,Fe.code=(0,a.$ag)(re.code)?re.code:re.code?.value,Fe.relatedInformation=re.relatedInformation&&re.relatedInformation.map(se.to),Fe.tags=re.tags&&(0,r.$Hb)(re.tags.map(F.to)),Fe}Le.to=ke})(X||(e.Diagnostic=X={}));var se;(function(Le){function je(re){return{...U.from(re.location.range),message:re.message,resource:re.location.uri}}Le.from=je;function ke(re){return new b.$KM(new b.$JM(re.resource,U.to(re)),re.message)}Le.to=ke})(se||(e.DiagnosticRelatedInformation=se={}));var W;(function(Le){function je(re){switch(re){case b.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Le.from=je;function ke(re){switch(re){case t.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}Le.to=ke})(W||(e.DiagnosticSeverity=W={}));var H;(function(Le){function je(re){return typeof re=="number"&&re>=b.ViewColumn.One?re-1:re===b.ViewColumn.Beside?v.$eE:v.$dE}Le.from=je;function ke(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=ke})(H||(e.ViewColumn=H={}));function V(Le){return typeof Le.range<"u"}function x(Le){return Le.length===0?!0:!!V(Le[0])}var he;(function(Le){function je(Ke){return Ke.map(Le.from)}Le.fromMany=je;function ke(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function re(Ke){let gt;if(ke(Ke)){const{language:Bt,value:Yt}=Ke;gt={value:"```"+Bt+`
`+Yt+"\n```\n"}}else b.$ZM.isMarkdownString(Ke)?gt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?gt={value:Ke}:gt={value:""};const Ct=Object.create(null);gt.uris=Ct;const Xt=Bt=>{try{let Yt=d.URI.parse(Bt,!0);Yt=Yt.with({query:Fe(Yt.query,Ct)}),Ct[Bt]=Yt}catch{}return""},an=new p.marked.Renderer;return an.link=Xt,an.image=Bt=>typeof Bt=="string"?Xt(L.$6k(Bt).href):"",(0,p.marked)(gt.value,{renderer:an}),gt}Le.from=re;function Fe(Ke,gt){if(!Ke)return Ke;let Ct;try{Ct=(0,l.$9h)(Ke)}catch{}if(!Ct)return Ke;let Xt=!1;return Ct=(0,D.$_n)(Ct,an=>{if(d.URI.isUri(an)){const Bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return gt[Bt]=an,Xt=!0,Bt}else return}),Xt?JSON.stringify(Ct):Ke}function We(Ke){const gt=new b.$ZM(Ke.value,Ke.supportThemeIcons);return gt.isTrusted=Ke.isTrusted,gt.supportHtml=Ke.supportHtml,gt.baseUri=Ke.baseUri?d.URI.from(Ke.baseUri):void 0,gt}Le.to=We;function et(Ke){if(Ke)return typeof Ke=="string"?Ke:Le.from(Ke)}Le.fromStrict=et})(he||(e.MarkdownString=he={}));function ne(Le){return x(Le)?Le.map(je=>({range:U.from(je.range),hoverMessage:Array.isArray(je.hoverMessage)?he.fromMany(je.hoverMessage):je.hoverMessage?he.from(je.hoverMessage):void 0,renderOptions:je.renderOptions})):Le.map(je=>({range:U.from(je)}))}function we(Le){return typeof Le>"u"?Le:typeof Le=="string"?d.URI.file(Le):Le}var pe;(function(Le){function je(ke){return typeof ke>"u"?ke:{contentText:ke.contentText,contentIconPath:ke.contentIconPath?we(ke.contentIconPath):void 0,border:ke.border,borderColor:ke.borderColor,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,color:ke.color,backgroundColor:ke.backgroundColor,margin:ke.margin,width:ke.width,height:ke.height}}Le.from=je})(pe||(e.ThemableDecorationAttachmentRenderOptions=pe={}));var ce;(function(Le){function je(ke){return typeof ke>"u"?ke:{backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?we(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?pe.from(ke.before):void 0,after:ke.after?pe.from(ke.after):void 0}}Le.from=je})(ce||(e.ThemableDecorationRenderOptions=ce={}));var K;(function(Le){function je(ke){if(typeof ke>"u")return ke;switch(ke){case b.DecorationRangeBehavior.OpenOpen:return n.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return n.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}Le.from=je})(K||(e.DecorationRangeBehavior=K={}));var de;(function(Le){function je(ke){return{isWholeLine:ke.isWholeLine,rangeBehavior:ke.rangeBehavior?K.from(ke.rangeBehavior):void 0,overviewRulerLane:ke.overviewRulerLane,light:ke.light?ce.from(ke.light):void 0,dark:ke.dark?ce.from(ke.dark):void 0,backgroundColor:ke.backgroundColor,outline:ke.outline,outlineColor:ke.outlineColor,outlineStyle:ke.outlineStyle,outlineWidth:ke.outlineWidth,border:ke.border,borderColor:ke.borderColor,borderRadius:ke.borderRadius,borderSpacing:ke.borderSpacing,borderStyle:ke.borderStyle,borderWidth:ke.borderWidth,fontStyle:ke.fontStyle,fontWeight:ke.fontWeight,textDecoration:ke.textDecoration,cursor:ke.cursor,color:ke.color,opacity:ke.opacity,letterSpacing:ke.letterSpacing,gutterIconPath:ke.gutterIconPath?we(ke.gutterIconPath):void 0,gutterIconSize:ke.gutterIconSize,overviewRulerColor:ke.overviewRulerColor,before:ke.before?pe.from(ke.before):void 0,after:ke.after?pe.from(ke.after):void 0}}Le.from=je})(de||(e.DecorationRenderOptions=de={}));var te;(function(Le){function je(re){return{text:re.newText,eol:re.newEol&&ue.from(re.newEol),range:U.from(re.range)}}Le.from=je;function ke(re){const Fe=new b.$EM(U.to(re.range),re.text);return Fe.newEol=typeof re.eol>"u"?void 0:ue.to(re.eol),Fe}Le.to=ke})(te||(e.TextEdit=te={}));var ee;(function(Le){function je(re,Fe){const We={edits:[]};if(re instanceof b.$HM){const et=new R.$Bc;for(const Ke of re._allEntries())Ke._type===b.FileEditType.File&&d.URI.isUri(Ke.to)&&Ke.from===void 0&&et.add(Ke.to);for(const Ke of re._allEntries())if(Ke._type===b.FileEditType.File){let gt;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?gt={type:"base64",value:(0,u.$4e)(u.$Je.wrap(Ke.options.contents))}:gt={type:"dataTransferItem",id:Ke.options.contents._itemId}),We.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:gt},metadata:Ke.metadata})}else Ke._type===b.FileEditType.Text?We.edits.push({resource:Ke.uri,textEdit:te.from(Ke.edit),versionId:et.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===b.FileEditType.Snippet?We.edits.push({resource:Ke.uri,textEdit:{range:U.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:et.has(Ke.uri)?void 0:Fe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===b.FileEditType.Cell?We.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===b.FileEditType.CellReplace&&We.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:E.CellEditType.Replace,index:Ke.index,count:Ke.count,cells:Ke.cells.map(en.from)}})}return We}Le.from=je;function ke(re){const Fe=new b.$HM,We=new R.$Ac;for(const et of re.edits)if(et.textEdit){const Ke=et,gt=d.URI.revive(Ke.resource),Ct=U.to(Ke.textEdit.range),Xt=Ke.textEdit.text,an=Ke.textEdit.insertAsSnippet;let Bt;an?Bt=b.$GM.replace(Ct,new b.$IM(Xt)):Bt=b.$EM.replace(Ct,Xt);const Yt=We.get(gt);Yt?Yt.push(Bt):We.set(gt,[Bt])}else Fe.renameFile(d.URI.revive(et.oldResource),d.URI.revive(et.newResource),et.options);for(const[et,Ke]of We)Fe.set(et,Ke);return Fe}Le.to=ke})(ee||(e.WorkspaceEdit=ee={}));var ie;(function(Le){const je=Object.create(null);je[b.SymbolKind.File]=o.SymbolKind.File,je[b.SymbolKind.Module]=o.SymbolKind.Module,je[b.SymbolKind.Namespace]=o.SymbolKind.Namespace,je[b.SymbolKind.Package]=o.SymbolKind.Package,je[b.SymbolKind.Class]=o.SymbolKind.Class,je[b.SymbolKind.Method]=o.SymbolKind.Method,je[b.SymbolKind.Property]=o.SymbolKind.Property,je[b.SymbolKind.Field]=o.SymbolKind.Field,je[b.SymbolKind.Constructor]=o.SymbolKind.Constructor,je[b.SymbolKind.Enum]=o.SymbolKind.Enum,je[b.SymbolKind.Interface]=o.SymbolKind.Interface,je[b.SymbolKind.Function]=o.SymbolKind.Function,je[b.SymbolKind.Variable]=o.SymbolKind.Variable,je[b.SymbolKind.Constant]=o.SymbolKind.Constant,je[b.SymbolKind.String]=o.SymbolKind.String,je[b.SymbolKind.Number]=o.SymbolKind.Number,je[b.SymbolKind.Boolean]=o.SymbolKind.Boolean,je[b.SymbolKind.Array]=o.SymbolKind.Array,je[b.SymbolKind.Object]=o.SymbolKind.Object,je[b.SymbolKind.Key]=o.SymbolKind.Key,je[b.SymbolKind.Null]=o.SymbolKind.Null,je[b.SymbolKind.EnumMember]=o.SymbolKind.EnumMember,je[b.SymbolKind.Struct]=o.SymbolKind.Struct,je[b.SymbolKind.Event]=o.SymbolKind.Event,je[b.SymbolKind.Operator]=o.SymbolKind.Operator,je[b.SymbolKind.TypeParameter]=o.SymbolKind.TypeParameter;function ke(Fe){return typeof je[Fe]=="number"?je[Fe]:o.SymbolKind.Property}Le.from=ke;function re(Fe){for(const We in je)if(je[We]===Fe)return Number(We);return b.SymbolKind.Property}Le.to=re})(ie||(e.SymbolKind=ie={}));var le;(function(Le){function je(re){switch(re){case b.SymbolTag.Deprecated:return o.SymbolTag.Deprecated}}Le.from=je;function ke(re){switch(re){case o.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}Le.to=ke})(le||(e.SymbolTag=le={}));var Z;(function(Le){function je(re){return{name:re.name,kind:ie.from(re.kind),tags:re.tags&&re.tags.map(le.from),containerName:re.containerName,location:qe.from(re.location)}}Le.from=je;function ke(re){const Fe=new b.$QM(re.name,ie.to(re.kind),re.containerName,qe.to(re.location));return Fe.tags=re.tags&&re.tags.map(le.to),Fe}Le.to=ke})(Z||(e.WorkspaceSymbol=Z={}));var ae;(function(Le){function je(re){const Fe={name:re.name||"!!MISSING: name!!",detail:re.detail,range:U.from(re.range),selectionRange:U.from(re.selectionRange),kind:ie.from(re.kind),tags:re.tags?.map(le.from)??[]};return re.children&&(Fe.children=re.children.map(je)),Fe}Le.from=je;function ke(re){const Fe=new b.$RM(re.name,re.detail,ie.to(re.kind),U.to(re.range),U.to(re.selectionRange));return(0,r.$Lb)(re.tags)&&(Fe.tags=re.tags.map(le.to)),re.children&&(Fe.children=re.children.map(ke)),Fe}Le.to=ke})(ae||(e.DocumentSymbol=ae={}));var $e;(function(Le){function je(re){const Fe=new b.$VM(ie.to(re.kind),re.name,re.detail||"",d.URI.revive(re.uri),U.to(re.range),U.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Le.to=je;function ke(re,Fe,We){if(Fe=Fe??re._sessionId,We=We??re._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,name:re.name,detail:re.detail,kind:ie.from(re.kind),uri:re.uri,range:U.from(re.range),selectionRange:U.from(re.selectionRange),tags:re.tags?.map(le.from)}}Le.from=ke})($e||(e.CallHierarchyItem=$e={}));var be;(function(Le){function je(ke){return new b.$WM($e.to(ke.from),ke.fromRanges.map(re=>U.to(re)))}Le.to=je})(be||(e.CallHierarchyIncomingCall=be={}));var Me;(function(Le){function je(ke){return new b.$XM($e.to(ke.to),ke.fromRanges.map(re=>U.to(re)))}Le.to=je})(Me||(e.CallHierarchyOutgoingCall=Me={}));var qe;(function(Le){function je(re){return{range:re.range&&U.from(re.range),uri:re.uri}}Le.from=je;function ke(re){return new b.$JM(d.URI.revive(re.uri),U.to(re.range))}Le.to=ke})(qe||(e.location=qe={}));var De;(function(Le){function je(re){const Fe=re,We=re;return{originSelectionRange:Fe.originSelectionRange?U.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:We.uri,range:U.from(Fe.targetRange?Fe.targetRange:We.range),targetSelectionRange:Fe.targetSelectionRange?U.from(Fe.targetSelectionRange):void 0}}Le.from=je;function ke(re){return{targetUri:d.URI.revive(re.uri),targetRange:U.to(re.range),targetSelectionRange:re.targetSelectionRange?U.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?U.to(re.originSelectionRange):void 0}}Le.to=ke})(De||(e.DefinitionLink=De={}));var Pe;(function(Le){function je(re){return{range:U.from(re.range),contents:he.fromMany(re.contents),canIncreaseVerbosity:re.canIncreaseVerbosity,canDecreaseVerbosity:re.canDecreaseVerbosity}}Le.from=je;function ke(re){const Fe=re.contents.map(he.to),We=U.to(re.range),et=re.canIncreaseVerbosity,Ke=re.canDecreaseVerbosity;return new b.$NM(Fe,We,et,Ke)}Le.to=ke})(Pe||(e.Hover=Pe={}));var Te;(function(Le){function je(re){return{range:U.from(re.range),expression:re.expression}}Le.from=je;function ke(re){return new b.$IN(U.to(re.range),re.expression)}Le.to=ke})(Te||(e.EvaluatableExpression=Te={}));var B;(function(Le){function je(re){if(re instanceof b.$JN)return{type:"text",range:U.from(re.range),text:re.text};if(re instanceof b.$KN)return{type:"variable",range:U.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof b.$LN)return{type:"expression",range:U.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=je;function ke(re){switch(re.type){case"text":return{range:U.to(re.range),text:re.text};case"variable":return{range:U.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:U.to(re.range),expression:re.expression}}}Le.to=ke})(B||(e.InlineValue=B={}));var q;(function(Le){function je(re){return{frameId:re.frameId,stoppedLocation:U.from(re.stoppedLocation)}}Le.from=je;function ke(re){return new b.$MN(re.frameId,U.to(re.stoppedLocation))}Le.to=ke})(q||(e.InlineValueContext=q={}));var Y;(function(Le){function je(re){return{range:U.from(re.range),kind:re.kind}}Le.from=je;function ke(re){return new b.$OM(U.to(re.range),re.kind)}Le.to=ke})(Y||(e.DocumentHighlight=Y={}));var _;(function(Le){function je(re){return{uri:re.uri,highlights:re.highlights.map(Y.from)}}Le.from=je;function ke(re){return new b.$PM(d.URI.revive(re.uri),re.highlights.map(Y.to))}Le.to=ke})(_||(e.MultiDocumentHighlight=_={}));var fe;(function(Le){function je(ke){switch(ke){case o.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case o.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case o.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}Le.to=je})(fe||(e.CompletionTriggerKind=fe={}));var ve;(function(Le){function je(ke){return{triggerKind:fe.to(ke.triggerKind),triggerCharacter:ke.triggerCharacter}}Le.to=je})(ve||(e.CompletionContext=ve={}));var Ne;(function(Le){function je(re){switch(re){case b.CompletionItemTag.Deprecated:return o.CompletionItemTag.Deprecated}}Le.from=je;function ke(re){switch(re){case o.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}Le.to=ke})(Ne||(e.CompletionItemTag=Ne={}));var Be;(function(Le){const je=new Map([[b.CompletionItemKind.Method,o.CompletionItemKind.Method],[b.CompletionItemKind.Function,o.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,o.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,o.CompletionItemKind.Field],[b.CompletionItemKind.Variable,o.CompletionItemKind.Variable],[b.CompletionItemKind.Class,o.CompletionItemKind.Class],[b.CompletionItemKind.Interface,o.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,o.CompletionItemKind.Struct],[b.CompletionItemKind.Module,o.CompletionItemKind.Module],[b.CompletionItemKind.Property,o.CompletionItemKind.Property],[b.CompletionItemKind.Unit,o.CompletionItemKind.Unit],[b.CompletionItemKind.Value,o.CompletionItemKind.Value],[b.CompletionItemKind.Constant,o.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,o.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,o.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,o.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,o.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,o.CompletionItemKind.Text],[b.CompletionItemKind.Color,o.CompletionItemKind.Color],[b.CompletionItemKind.File,o.CompletionItemKind.File],[b.CompletionItemKind.Reference,o.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,o.CompletionItemKind.Folder],[b.CompletionItemKind.Event,o.CompletionItemKind.Event],[b.CompletionItemKind.Operator,o.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,o.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,o.CompletionItemKind.Issue],[b.CompletionItemKind.User,o.CompletionItemKind.User]]);function ke(We){return je.get(We)??o.CompletionItemKind.Property}Le.from=ke;const re=new Map([[o.CompletionItemKind.Method,b.CompletionItemKind.Method],[o.CompletionItemKind.Function,b.CompletionItemKind.Function],[o.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[o.CompletionItemKind.Field,b.CompletionItemKind.Field],[o.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[o.CompletionItemKind.Class,b.CompletionItemKind.Class],[o.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[o.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[o.CompletionItemKind.Module,b.CompletionItemKind.Module],[o.CompletionItemKind.Property,b.CompletionItemKind.Property],[o.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[o.CompletionItemKind.Value,b.CompletionItemKind.Value],[o.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[o.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[o.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[o.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[o.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[o.CompletionItemKind.Text,b.CompletionItemKind.Text],[o.CompletionItemKind.Color,b.CompletionItemKind.Color],[o.CompletionItemKind.File,b.CompletionItemKind.File],[o.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[o.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[o.CompletionItemKind.Event,b.CompletionItemKind.Event],[o.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[o.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[o.CompletionItemKind.User,b.CompletionItemKind.User],[o.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function Fe(We){return re.get(We)??b.CompletionItemKind.Property}Le.to=Fe})(Be||(e.CompletionItemKind=Be={}));var Qe;(function(Le){function je(ke,re){const Fe=new b.$6M(ke.label);return Fe.insertText=ke.insertText,Fe.kind=Be.to(ke.kind),Fe.tags=ke.tags?.map(Ne.to),Fe.detail=ke.detail,Fe.documentation=L.$Zk(ke.documentation)?he.to(ke.documentation):ke.documentation,Fe.sortText=ke.sortText,Fe.filterText=ke.filterText,Fe.preselect=ke.preselect,Fe.commitCharacters=ke.commitCharacters,$.$dt.isIRange(ke.range)?Fe.range=U.to(ke.range):typeof ke.range=="object"&&(Fe.range={inserting:U.to(ke.range.insert),replacing:U.to(ke.range.replace)}),Fe.keepWhitespace=typeof ke.insertTextRules>"u"?!1:!!(ke.insertTextRules&o.CompletionItemInsertTextRule.KeepWhitespace),typeof ke.insertTextRules<"u"&&ke.insertTextRules&o.CompletionItemInsertTextRule.InsertAsSnippet?Fe.insertText=new b.$IM(ke.insertText):(Fe.insertText=ke.insertText,Fe.textEdit=Fe.range instanceof b.$zM?new b.$EM(Fe.range,Fe.insertText):void 0),ke.additionalTextEdits&&ke.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ke.additionalTextEdits.map(We=>te.to(We))),Fe.command=re&&ke.command?re.fromInternal(ke.command):void 0,Fe}Le.to=je})(Qe||(e.CompletionItem=Qe={}));var He;(function(Le){function je(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:he.fromStrict(re.documentation)}}Le.from=je;function ke(re){return{label:re.label,documentation:L.$Zk(re.documentation)?he.to(re.documentation):re.documentation}}Le.to=ke})(He||(e.ParameterInformation=He={}));var tt;(function(Le){function je(re){return{label:re.label,documentation:he.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(He.from):[],activeParameter:re.activeParameter}}Le.from=je;function ke(re){return{label:re.label,documentation:L.$Zk(re.documentation)?he.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(He.to):[],activeParameter:re.activeParameter}}Le.to=ke})(tt||(e.SignatureInformation=tt={}));var nt;(function(Le){function je(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(tt.from):[]}}Le.from=je;function ke(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(tt.to):[]}}Le.to=ke})(nt||(e.SignatureHelp=nt={}));var ot;(function(Le){function je(ke,re){const Fe=new b.$5M(M.to(re.position),typeof re.label=="string"?re.label:re.label.map(at.to.bind(void 0,ke)),re.kind&&pt.to(re.kind));return Fe.textEdits=re.textEdits&&re.textEdits.map(te.to),Fe.tooltip=L.$Zk(re.tooltip)?he.to(re.tooltip):re.tooltip,Fe.paddingLeft=re.paddingLeft,Fe.paddingRight=re.paddingRight,Fe}Le.to=je})(ot||(e.InlayHint=ot={}));var at;(function(Le){function je(ke,re){const Fe=new b.$4M(re.label);return Fe.tooltip=L.$Zk(re.tooltip)?he.to(re.tooltip):re.tooltip,o.Command.is(re.command)&&(Fe.command=ke.fromInternal(re.command)),re.location&&(Fe.location=qe.to(re.location)),Fe}Le.to=je})(at||(e.InlayHintLabelPart=at={}));var pt;(function(Le){function je(re){return re}Le.from=je;function ke(re){return re}Le.to=ke})(pt||(e.InlayHintKind=pt={}));var ft;(function(Le){function je(re){return{range:U.from(re.range),url:re.target,tooltip:re.tooltip}}Le.from=je;function ke(re){let Fe;if(re.url)try{Fe=typeof re.url=="string"?d.URI.parse(re.url,!0):d.URI.revive(re.url)}catch{}return new b.$$M(U.to(re.range),Fe)}Le.to=ke})(ft||(e.DocumentLink=ft={}));var st;(function(Le){function je(re){const Fe=new b.$bN(re.label);return re.textEdit&&(Fe.textEdit=te.to(re.textEdit)),re.additionalTextEdits&&(Fe.additionalTextEdits=re.additionalTextEdits.map(We=>te.to(We))),Fe}Le.to=je;function ke(re){return{label:re.label,textEdit:re.textEdit?te.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Fe=>te.from(Fe)):void 0}}Le.from=ke})(st||(e.ColorPresentation=st={}));var ht;(function(Le){function je(re){return new b.$_M(re[0],re[1],re[2],re[3])}Le.to=je;function ke(re){return[re.red,re.green,re.blue,re.alpha]}Le.from=ke})(ht||(e.Color=ht={}));var Re;(function(Le){function je(re){return{range:U.from(re.range)}}Le.from=je;function ke(re){return new b.$UM(U.to(re.range))}Le.to=ke})(Re||(e.SelectionRange=Re={}));var Ie;(function(Le){function je(ke){switch(ke){case s.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case s.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case s.SaveReason.FOCUS_CHANGE:case s.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}Le.to=je})(Ie||(e.TextDocumentSaveReason=Ie={}));var Ae;(function(Le){function je(re){switch(re){case b.TextEditorLineNumbersStyle.Off:return g.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return g.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return g.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return g.RenderLineNumbersType.On}}Le.from=je;function ke(re){switch(re){case g.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case g.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case g.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case g.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}Le.to=ke})(Ae||(e.TextEditorLineNumbersStyle=Ae={}));var ue;(function(Le){function je(re){if(re===b.EndOfLine.CRLF)return n.EndOfLineSequence.CRLF;if(re===b.EndOfLine.LF)return n.EndOfLineSequence.LF}Le.from=je;function ke(re){if(re===n.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(re===n.EndOfLineSequence.LF)return b.EndOfLine.LF}Le.to=ke})(ue||(e.EndOfLine=ue={}));var Q;(function(Le){function je(ke){if(typeof ke=="object")return ke.viewId;switch(ke){case b.ProgressLocation.SourceControl:return c.ProgressLocation.Scm;case b.ProgressLocation.Window:return c.ProgressLocation.Window;case b.ProgressLocation.Notification:return c.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}Le.from=je})(Q||(e.ProgressLocation=Q={}));var Ce;(function(Le){function je(re){const Fe={start:re.start+1,end:re.end+1};return re.kind&&(Fe.kind=Je.from(re.kind)),Fe}Le.from=je;function ke(re){const Fe={start:re.start-1,end:re.end-1};return re.kind&&(Fe.kind=Je.to(re.kind)),Fe}Le.to=ke})(Ce||(e.FoldingRange=Ce={}));var Je;(function(Le){function je(re){if(re)switch(re){case b.FoldingRangeKind.Comment:return o.$Qv.Comment;case b.FoldingRangeKind.Imports:return o.$Qv.Imports;case b.FoldingRangeKind.Region:return o.$Qv.Region}}Le.from=je;function ke(re){if(re)switch(re.value){case o.$Qv.Comment.value:return b.FoldingRangeKind.Comment;case o.$Qv.Imports.value:return b.FoldingRangeKind.Imports;case o.$Qv.Region.value:return b.FoldingRangeKind.Region}}Le.to=ke})(Je||(e.FoldingRangeKind=Je={}));var _e;(function(Le){function je(ke){if(ke)return{pinned:typeof ke.preview=="boolean"?!ke.preview:void 0,inactive:ke.background,preserveFocus:ke.preserveFocus,selection:typeof ke.selection=="object"?U.from(ke.selection):void 0,override:typeof ke.override=="boolean"?s.$GF.id:void 0}}Le.from=je})(_e||(e.TextEditorOpenOptions=_e={}));var ct;(function(Le){function je(We){return We instanceof b.$wN?We.toJSON():typeof We=="string"?We:ke(We)||re(We)?new b.$wN(We.baseUri??We.base,We.pattern).toJSON():We}Le.from=je;function ke(We){const et=We;return et?d.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function re(We){const et=We;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Fe(We){return typeof We=="string"?We:new b.$wN(d.URI.revive(We.baseUri),We.pattern)}Le.to=Fe})(ct||(e.GlobPattern=ct={}));var lt;(function(Le){function je(ke){if(ke){if(Array.isArray(ke))return ke.map(je);if(typeof ke=="string")return ke;{const re=ke;return{language:re.language,scheme:re.scheme,pattern:ct.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Le.from=je})(lt||(e.LanguageSelector=lt={}));var yt;(function(Le){function je(re){return!!re&&typeof re=="object"&&"documents"in re&&Array.isArray(re.documents)&&re.documents.every(Fe=>Array.isArray(Fe)&&Fe.every(We=>We&&typeof We=="object"&&"uri"in We&&d.URI.isUri(We.uri)&&"version"in We&&typeof We.version=="number"&&"ranges"in We&&Array.isArray(We.ranges)&&We.ranges.every(et=>et instanceof b.$zM)))}Le.is=je;function ke(re){return{documents:re.documents.map(Fe=>Fe.map(We=>({uri:d.URI.from(We.uri),version:We.version,ranges:We.ranges.map(et=>U.from(et))})))}}Le.from=ke})(yt||(e.MappedEditsContext=yt={}));var At;(function(Le){function je(re){return{start:re.start,end:re.end}}Le.from=je;function ke(re){return new b.$ZN(re.start,re.end)}Le.to=ke})(At||(e.NotebookRange=At={}));var Ot;(function(Le){function je(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Le.to=je;function ke(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Le.from=ke})(Ot||(e.NotebookCellExecutionSummary=Ot={}));var _t;(function(Le){function je(ke){if(ke===E.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(ke===E.NotebookCellExecutionState.Pending)return;if(ke===E.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ke}`)}Le.to=je})(_t||(e.NotebookCellExecutionState=_t={}));var rn;(function(Le){function je(re){switch(re){case b.NotebookCellKind.Markup:return E.CellKind.Markup;case b.NotebookCellKind.Code:default:return E.CellKind.Code}}Le.from=je;function ke(re){switch(re){case E.CellKind.Markup:return b.NotebookCellKind.Markup;case E.CellKind.Code:default:return b.NotebookCellKind.Code}}Le.to=ke})(rn||(e.NotebookCellKind=rn={}));var xe;(function(Le){function je(re){const Fe={metadata:re.metadata??Object.create(null),cells:[]};for(const We of re.cells)b.$1N.validate(We),Fe.cells.push(en.from(We));return Fe}Le.from=je;function ke(re){const Fe=new b.$2N(re.cells.map(en.to));return(0,a.$ng)(re.metadata)||(Fe.metadata=re.metadata),Fe}Le.to=ke})(xe||(e.NotebookData=xe={}));var en;(function(Le){function je(re){return{cellKind:rn.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:Ot.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map($t.from):[]}}Le.from=je;function ke(re){return new b.$1N(rn.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map($t.to):void 0,re.metadata,re.internalMetadata?Ot.to(re.internalMetadata):void 0)}Le.to=ke})(en||(e.NotebookCellData=en={}));var Zt;(function(Le){function je(re){return{mime:re.mime,valueBytes:u.$Je.wrap(re.data)}}Le.from=je;function ke(re){return new b.$3N(re.valueBytes.buffer,re.mime)}Le.to=ke})(Zt||(e.NotebookCellOutputItem=Zt={}));var $t;(function(Le){function je(re){return{outputId:re.id,items:re.items.map(Zt.from),metadata:re.metadata}}Le.from=je;function ke(re){const Fe=re.items.map(Zt.to);return new b.$4N(Fe,re.outputId,re.metadata)}Le.to=ke})($t||(e.NotebookCellOutput=$t={}));var wt;(function(Le){function je(Fe){return re(Fe)?{include:ct.from(Fe.include)??void 0,exclude:ct.from(Fe.exclude)??void 0}:ct.from(Fe)??void 0}Le.from=je;function ke(Fe){return re(Fe)?{include:ct.to(Fe.include),exclude:ct.to(Fe.exclude)}:ct.to(Fe)}Le.to=ke;function re(Fe){const We=Fe;return We?!(0,a.$jg)(We.include)&&!(0,a.$jg)(We.exclude):!1}})(wt||(e.NotebookExclusiveDocumentPattern=wt={}));var Qt;(function(Le){function je(ke,re,Fe){const We=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{alignment:ke.alignment===b.NotebookCellStatusBarAlignment.Left?E.CellStatusbarAlignment.Left:E.CellStatusbarAlignment.Right,command:re.toInternal(We,Fe),text:ke.text,tooltip:ke.tooltip,accessibilityInformation:ke.accessibilityInformation,priority:ke.priority}}Le.from=je})(Qt||(e.NotebookStatusBarItem=Qt={}));var tn;(function(Le){function je(ke,re,Fe){const We=typeof ke.command=="string"?{title:"",command:ke.command}:ke.command;return{command:re.toInternal(We,Fe),label:ke.label,description:ke.description,detail:ke.detail,documentation:ke.documentation}}Le.from=je})(tn||(e.NotebookKernelSourceAction=tn={}));var qt;(function(Le){function je(ke){return{transientOutputs:ke?.transientOutputs??!1,transientCellMetadata:ke?.transientCellMetadata??{},transientDocumentMetadata:ke?.transientDocumentMetadata??{},cellContentMetadata:ke?.cellContentMetadata??{}}}Le.from=je})(qt||(e.NotebookDocumentContentOptions=qt={}));var bt;(function(Le){function je(re){return{uri:re.uri,provides:re.provides}}Le.from=je;function ke(re){return new b.$6N(d.URI.revive(re.uri),re.provides)}Le.to=ke})(bt||(e.NotebookRendererScript=bt={}));var Mt;(function(Le){function je(re){return{message:he.fromStrict(re.message)||"",type:C.TestMessageType.Error,expected:re.expectedOutput,actual:re.actualOutput,contextValue:re.contextValue,location:re.location&&{range:U.from(re.location.range),uri:re.location.uri}}}Le.from=je;function ke(re){const Fe=new b.$_N(typeof re.message=="string"?re.message:he.to(re.message));return Fe.actualOutput=re.actual,Fe.expectedOutput=re.expected,Fe.contextValue=re.contextValue,Fe.location=re.location?qe.to(re.location):void 0,Fe}Le.to=ke})(Mt||(e.TestMessage=Mt={}));var Wt;(function(Le){Le.namespace=C.$mL,Le.denamespace=C.$nL})(Wt||(e.TestTag=Wt={}));var Ut;(function(Le){function je(re){const Fe=(0,h.$VO)(re).controllerId;return{extId:k.$hL.fromExtHostTestItem(re,Fe).toString(),label:re.label,uri:d.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(We=>Wt.namespace(Fe,We.id)),range:$.$dt.lift(U.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&he.fromStrict(re.error)||null}}Le.from=je;function ke(re){return{parent:void 0,error:void 0,id:k.$hL.fromString(re.extId).localId,label:re.label,uri:d.URI.revive(re.uri),tags:(re.tags||[]).map(Fe=>{const{tagId:We}=Wt.denamespace(Fe);return new b.$aO(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:U.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Le.toPlain=ke})(Ut||(e.TestItem=Ut={})),function(Le){function je(re){return{id:re.id}}Le.from=je;function ke(re){return new b.$aO(re.id)}Le.to=ke}(Wt||(e.TestTag=Wt={}));var Ye;(function(Le){const je=(re,Fe)=>{const We=re.value;if(!We)return;const et={...Ut.toPlain(We.item),parent:Fe,taskStates:We.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(gt=>gt.type===C.TestMessageType.Error).map(Mt.to)})),children:[]};if(re.children)for(const Ke of re.children.values()){const gt=je(Ke,et);gt&&et.children.push(gt)}return et};function ke(re){const Fe=new f.$OO;for(const Ke of re.items)Fe.insert(k.$hL.fromString(Ke.item.extId).path,Ke);const We=[Fe.nodes],et=[];for(;We.length;)for(const Ke of We.pop())Ke.value?et.push(Ke):Ke.children&&We.push(Ke.children.values());return{completedAt:re.completedAt,results:et.map(Ke=>je(Ke)).filter(a.$ig)}}Le.to=ke})(Ye||(e.TestResults=Ye={}));var nn;(function(Le){function je(We){return{covered:We.covered,total:We.total}}function ke(We){return"line"in We?M.from(We):U.from(We)}function re(We){if(typeof We.executed=="number"&&We.executed<0)throw new Error(`Invalid coverage count ${We.executed}`);return"branches"in We?{count:We.executed,location:ke(We.location),type:C.DetailType.Statement,branches:We.branches.length?We.branches.map(et=>({count:et.executed,location:et.location&&ke(et.location),label:et.label})):void 0}:{type:C.DetailType.Declaration,name:We.name,count:We.executed,location:ke(We.location)}}Le.fromDetails=re;function Fe(We,et,Ke){return b.$cO(Ke.statementCoverage),b.$cO(Ke.branchCoverage),b.$cO(Ke.declarationCoverage),{id:et,uri:Ke.uri,statement:je(Ke.statementCoverage),branch:Ke.branchCoverage&&je(Ke.branchCoverage),declaration:Ke.declarationCoverage&&je(Ke.declarationCoverage),testId:Ke instanceof b.$dO&&Ke.testItem?k.$hL.fromExtHostTestItem(Ke.testItem,We).toString():void 0}}Le.fromFile=Fe})(nn||(e.TestCoverage=nn={}));var sn;(function(Le){function je(ke){switch(ke){case o.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case o.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}Le.to=je})(sn||(e.CodeActionTriggerKind=sn={}));var un;(function(Le){function je(re){const Fe=new b.$hO(ie.to(re.kind),re.name,re.detail||"",d.URI.revive(re.uri),U.to(re.range),U.to(re.selectionRange));return Fe._sessionId=re._sessionId,Fe._itemId=re._itemId,Fe}Le.to=je;function ke(re,Fe,We){if(Fe=Fe??re._sessionId,We=We??re._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,kind:ie.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:U.from(re.range),selectionRange:U.from(re.selectionRange),tags:re.tags?.map(le.from)}}Le.from=ke})(un||(e.TypeHierarchyItem=un={}));var Pt;(function(Le){function je(ke){if(ke)return{value:ke.value,tooltip:ke.tooltip}}Le.from=je})(Pt||(e.ViewBadge=Pt={}));var jt;(function(Le){function je(We,et,Ke){const gt=et.fileData;return gt?new b.$oN(new b.$pN(gt.name,d.URI.revive(gt.uri),gt.id,(0,T.$db)(()=>Ke(gt.id)))):We===I.$Zs.uriList&&et.uriListData?new b.$nN(Fe(et.uriListData)):new b.$nN(et.asString)}Le.to=je;async function ke(We,et){const Ke=await et.asString();if(We===I.$Zs.uriList)return{asString:Ke,fileData:void 0,uriListData:re(Ke)};const gt=et.asFile();return{asString:Ke,fileData:gt?{name:gt.name,uri:gt.uri,id:gt._itemId??gt.id}:void 0}}Le.from=ke;function re(We){return P.$at.split(We).map(et=>{if(et.startsWith("#"))return et;try{return d.URI.parse(et)}catch{}return et})}function Fe(We){return P.$at.create(We.map(et=>typeof et=="string"?et:d.URI.revive(et)))}})(jt||(e.DataTransferItem=jt={}));var Nt;(function(Le){function je(re,Fe){const We=re.items.map(([et,Ke])=>[et,jt.to(et,Ke,Fe)]);return new b.$qN(We)}Le.toDataTransfer=je;async function ke(re){const Fe={items:[]},We=[];for(const[et,Ke]of re)We.push((async()=>{Fe.items.push([et,await jt.from(et,Ke)])})());return await Promise.all(We),Fe}Le.from=ke})(Nt||(e.DataTransfer=Nt={}));var Ht;(function(Le){function je(re,Fe){return{kind:"reply",agentId:re.participant??Fe?.agentId??"",subCommand:re.command??Fe?.command,message:re.prompt,title:re.label}}Le.from=je;function ke(re){return{prompt:re.message,label:re.title,participant:re.agentId,command:re.subCommand}}Le.to=ke})(Ht||(e.ChatFollowup=Ht={}));var hn;(function(Le){function je(re){switch(re.role){case y.ChatMessageRole.System:return new b.$IO(b.LanguageModelChatMessageRole.System,re.content);case y.ChatMessageRole.User:return new b.$IO(b.LanguageModelChatMessageRole.User,re.content);case y.ChatMessageRole.Assistant:return new b.$IO(b.LanguageModelChatMessageRole.Assistant,re.content)}}Le.to=je;function ke(re){switch(re.role){case b.LanguageModelChatMessageRole.System:return{role:y.ChatMessageRole.System,content:re.content};case b.LanguageModelChatMessageRole.User:return{role:y.ChatMessageRole.User,content:re.content};case b.LanguageModelChatMessageRole.Assistant:return{role:y.ChatMessageRole.Assistant,content:re.content}}}Le.from=ke})(hn||(e.LanguageModelChatMessage=hn={}));var on;(function(Le){function je(re){return{kind:"markdownContent",content:he.from(re.value)}}Le.from=je;function ke(re){return new b.$uO(he.to(re.content))}Le.to=ke})(on||(e.ChatResponseMarkdownPart=on={}));var cn;(function(Le){function je(re){return{kind:"markdownVuln",content:he.from(re.value),vulnerabilities:re.vulnerabilities}}Le.from=je;function ke(re){return new b.$vO(he.to(re.content),re.vulnerabilities)}Le.to=ke})(cn||(e.ChatResponseMarkdownWithVulnerabilitiesPart=cn={}));var Gt;(function(Le){function je(re){return{kind:"agentDetection",agentId:re.participant,command:re.command}}Le.from=je;function ke(re){return new b.$wO(re.agentId,re.command)}Le.to=ke})(Gt||(e.ChatResponseDetectedParticipantPart=Gt={}));var zt;(function(Le){function je(ke){return{kind:"confirmation",title:ke.title,message:ke.message,data:ke.data}}Le.from=je})(zt||(e.ChatResponseConfirmationPart=zt={}));var ln;(function(Le){function je(re){const{value:Fe,baseUri:We}=re;function et(Ke,gt){return Ke.map(Ct=>{const Xt=d.URI.joinPath(gt,Ct.name);return{label:Ct.name,uri:Xt,children:Ct.children&&et(Ct.children,Xt)}})}return{kind:"treeData",treeData:{label:(0,A.$$g)(We),uri:We,children:et(Fe,We)}}}Le.from=je;function ke(re){const Fe=(0,l.$0h)(re.treeData);function We(gt){return gt.map(Ct=>({name:Ct.label,children:Ct.children&&We(Ct.children)}))}const et=Fe.uri,Ke=Fe.children?We(Fe.children):[];return new b.$yO(Ke,et)}Le.to=ke})(ln||(e.ChatResponseFilesPart=ln={}));var Rt;(function(Le){function je(re){const Fe=We=>d.URI.isUri(We);return{kind:"inlineReference",name:re.title,inlineReference:Fe(re.value)?re.value:z.from(re.value)}}Le.from=je;function ke(re){const Fe=(0,l.$0h)(re);return new b.$zO(d.URI.isUri(Fe.inlineReference)?Fe.inlineReference:z.to(Fe.inlineReference),re.name)}Le.to=ke})(Rt||(e.ChatResponseAnchorPart=Rt={}));var St;(function(Le){function je(re){return{kind:"progressMessage",content:he.from(re.value)}}Le.from=je;function ke(re){return new b.$AO(re.content.value)}Le.to=ke})(St||(e.ChatResponseProgressPart=St={}));var Et;(function(Le){function je(re){return{kind:"warning",content:he.from(re.value)}}Le.from=je;function ke(re){return new b.$CO(re.content.value)}Le.to=ke})(Et||(e.ChatResponseWarningPart=Et={}));var Kt;(function(Le){function je(ke){return{kind:"progressTask",content:he.from(ke.value)}}Le.from=je})(Kt||(e.ChatTask=Kt={}));var Dt;(function(Le){function je(ke){return{kind:"progressTaskResult",content:typeof ke=="string"?he.from(ke):void 0}}Le.from=je})(Dt||(e.ChatTaskResult=Dt={}));var Vt;(function(Le){function je(re,Fe,We){return{kind:"command",command:Fe.toInternal(re.value,We)??{command:re.value.command,title:re.value.title}}}Le.from=je;function ke(re,Fe){return new b.$DO(Fe.fromInternal(re.command)??{command:re.command.id,title:re.command.title})}Le.to=ke})(Vt||(e.ChatResponseCommandButtonPart=Vt={}));var Jt;(function(Le){function je(re){return{kind:"textEdit",uri:re.uri,edits:re.edits.map(Fe=>te.from(Fe))}}Le.from=je;function ke(re){return new b.$FO(d.URI.revive(re.uri),re.edits.map(Fe=>te.to(Fe)))}Le.to=ke})(Jt||(e.ChatResponseTextEditPart=Jt={}));var Sn;(function(Le){function je(re){const Fe=w.ThemeIcon.isThemeIcon(re.iconPath)?re.iconPath:d.URI.isUri(re.iconPath)?{light:d.URI.revive(re.iconPath)}:re.iconPath&&"light"in re.iconPath&&"dark"in re.iconPath&&d.URI.isUri(re.iconPath.light)&&d.URI.isUri(re.iconPath.dark)?{light:d.URI.revive(re.iconPath.light),dark:d.URI.revive(re.iconPath.dark)}:void 0;return"variableName"in re.value?{kind:"reference",reference:{variableName:re.value.variableName,value:d.URI.isUri(re.value.value)||!re.value.value?re.value.value:z.from(re.value.value)},iconPath:Fe}:{kind:"reference",reference:d.URI.isUri(re.value)?re.value:z.from(re.value),iconPath:Fe}}Le.from=je;function ke(re){const Fe=(0,l.$0h)(re),We=et=>d.URI.isUri(et)?et:z.to(et);return new b.$EO("variableName"in Fe.reference?{variableName:Fe.reference.variableName,value:Fe.reference.value&&We(Fe.reference.value)}:We(Fe.reference))}Le.to=ke})(Sn||(e.ChatResponseReferencePart=Sn={}));var mn;(function(Le){function je(Fe,We,et){return Fe instanceof b.$uO?on.from(Fe):Fe instanceof b.$zO?Rt.from(Fe):Fe instanceof b.$EO?Sn.from(Fe):Fe instanceof b.$AO?St.from(Fe):Fe instanceof b.$yO?ln.from(Fe):Fe instanceof b.$DO?Vt.from(Fe,We,et):Fe instanceof b.$FO?Jt.from(Fe):Fe instanceof b.$vO?cn.from(Fe):Fe instanceof b.$wO?Gt.from(Fe):Fe instanceof b.$CO?Et.from(Fe):{kind:"markdownContent",content:he.from("")}}Le.from=je;function ke(Fe,We){switch(Fe.kind){case"reference":return Sn.to(Fe);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return re(Fe,We)}}Le.to=ke;function re(Fe,We){switch(Fe.kind){case"markdownContent":return on.to(Fe);case"inlineReference":return Rt.to(Fe);case"progressMessage":return;case"treeData":return ln.to(Fe);case"command":return Vt.to(Fe,We)}}Le.toContent=re})(mn||(e.ChatResponsePart=mn={}));var $n;(function(Le){function je(ke){return{prompt:ke.message,command:ke.command,attempt:ke.attempt??0,enableCommandDetection:ke.enableCommandDetection??!0,references:ke.variables.variables.map(wn.to),location:Ft.to(ke.location),acceptedConfirmationData:ke.acceptedConfirmationData,rejectedConfirmationData:ke.rejectedConfirmationData}}Le.to=je})($n||(e.ChatAgentRequest=$n={}));var Ft;(function(Le){function je(re){switch(re){case m.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case m.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case m.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case m.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}Le.to=je;function ke(re){switch(re){case b.ChatLocation.Notebook:return m.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return m.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return m.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return m.ChatAgentLocation.Editor}}Le.from=ke})(Ft||(e.ChatLocation=Ft={}));var wn;(function(Le){function je(ke){const re=ke.value;if(!re)throw new Error("Invalid value reference");return{id:ke.id,name:ke.name,range:ke.range&&[ke.range.start,ke.range.endExclusive],value:(0,d.$vc)(re)?d.URI.revive(re):re&&typeof re=="object"&&"uri"in re&&"range"in re&&(0,d.$vc)(re.uri)?z.to((0,l.$0h)(re)):re,modelDescription:ke.modelDescription}}Le.to=je})(wn||(e.ChatAgentValueReference=wn={}));var Rn;(function(Le){function je(ke,re,Fe){return{id:ke.id,label:ke.label,fullName:ke.fullName,icon:ke.icon?.id,value:ke.values[0].value,insertText:ke.insertText,detail:ke.detail,documentation:ke.documentation,command:re.toInternal(ke.command,Fe)}}Le.from=je})(Rn||(e.ChatAgentCompletionItem=Rn={}));var Tt;(function(Le){function je(ke){return{errorDetails:ke.errorDetails,metadata:ke.metadata}}Le.to=je})(Tt||(e.ChatAgentResult=Tt={}));var Tn;(function(Le){function je(ke,re,Fe){if(re.action.kind==="vote")return;const We=Tt.to(ke);if(re.action.kind==="command"){const et=re.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Fe.fromInternal(et)??{command:et.id,title:et.title}}},result:We}}else return re.action.kind==="followUp"?{action:{kind:"followUp",followup:Ht.to(re.action.followup)},result:We}:re.action.kind==="inlineChat"?{action:{kind:"editor",accepted:re.action.action==="accepted"},result:We}:{action:re.action,result:We}}Le.to=je})(Tn||(e.ChatAgentUserActionEvent=Tn={}));var kn;(function(Le){function je(ke,re,Fe){return"terminalCommand"in ke?{terminalCommand:ke.terminalCommand,shouldExecute:ke.shouldExecute}:"uri"in ke?{uri:ke.uri}:re.toInternal(ke,Fe)}Le.from=je})(kn||(e.TerminalQuickFix=kn={}));var pn;(function(Le){function je(ke){return{kind:In.to(ke.kind)}}Le.to=je})(pn||(e.PartialAcceptInfo=pn={}));var In;(function(Le){function je(ke){switch(ke){case o.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case o.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case o.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}Le.to=je})(In||(e.PartialAcceptTriggerKind=In={}));var dn;(function(Le){function je(ke,re){return{id:re,label:ke.label,description:ke.description,canEdit:ke.canEdit,collapsibleState:ke.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:ke.contextValue}}Le.from=je})(dn||(e.DebugTreeItem=dn={}))}),define(Ee[343],Se([1,0,6,20,17,52]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;let L=class{constructor(p,l){this.a=p.getProxy(r.$vM.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>l.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,l,I){const D=new T.$Lw(P.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(D,void 0,I?.isRefactoring??!1)}};e.$5mc=L,e.$5mc=L=Ze([Ve(0,u.$ZO)],L)}),define(Ee[344],Se([1,0,19,7,51,4,40,3,43,18,2,24,6,17,8,305,26]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class g{constructor(n,t,c,h,s){this.j=n,this.k=t,this.l=c,this.m=h,this.n=s,this.b=p.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let t=function(h){if(n.c){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,h),s}};const n=this;this.b.reset();const c=(h,s)=>{if(typeof this.d>"u"&&"content"in h&&(this.d=this.b.elapsed()),s){const m=this.l.$handleProgressChunk(this.k.requestId,h),y={report:S=>{m?.then(E=>{E&&(w.$ZM.isMarkdownString(S.value)?this.l.$handleProgressChunk(this.k.requestId,A.ChatResponseWarningPart.from(S),E):this.l.$handleProgressChunk(this.k.requestId,A.ChatResponseReferencePart.from(S),E))})}};Promise.all([m,s?.(y)]).then(([S,E])=>{S!==void 0&&E!==void 0&&this.l.$handleProgressChunk(this.k.requestId,A.ChatTaskResult.from(E),S)})}else this.l.$handleProgressChunk(this.k.requestId,h)};this.g={markdown(h){t(this.markdown);const s=new w.$uO(h),m=A.ChatResponseMarkdownPart.from(s);return c(m),this},markdownWithVulnerabilities(h,s){t(this.markdown),s&&(0,d.$VG)(n.j,"chatParticipantAdditions");const m=new w.$vO(h,s),y=A.ChatResponseMarkdownWithVulnerabilitiesPart.from(m);return c(y),this},filetree(h,s){t(this.filetree);const m=new w.$yO(h,s),y=A.ChatResponseFilesPart.from(m);return c(y),this},anchor(h,s){t(this.anchor);const m=new w.$zO(h,s),y=A.ChatResponseAnchorPart.from(m);return c(y),this},button(h){t(this.anchor);const s=new w.$DO(h),m=A.ChatResponseCommandButtonPart.from(s,n.m,n.n);return c(m),this},progress(h,s){t(this.progress);const m=new w.$BO(h,s),y=s?A.ChatTask.from(m):A.ChatResponseProgressPart.from(m);return c(y,s),this},warning(h){t(this.progress),(0,d.$VG)(n.j,"chatParticipantAdditions");const s=new w.$CO(h),m=A.ChatResponseWarningPart.from(s);return c(m),this},reference(h,s){if(t(this.reference),"variableName"in h&&(0,d.$VG)(n.j,"chatParticipantAdditions"),"variableName"in h&&!h.value){const m=n.k.variables.variables.find(y=>y.name===h.variableName);if(m){let y;if(m.references?.length)y=m.references.map(S=>({kind:"reference",reference:{variableName:h.variableName,value:S.reference}}));else{const S=new w.$EO(h,s);y=[A.ChatResponseReferencePart.from(S)]}return y.forEach(S=>c(S)),this}}else{const m=new w.$EO(h,s),y=A.ChatResponseReferencePart.from(m);c(y)}return this},textEdit(h,s){t(this.textEdit),(0,d.$VG)(n.j,"chatParticipantAdditions");const m=new w.$FO(h,s),y=A.ChatResponseTextEditPart.from(m);return c(y),this},detectedParticipant(h,s){t(this.detectedParticipant),(0,d.$VG)(n.j,"chatParticipantAdditions");const m=new w.$wO(h,s),y=A.ChatResponseDetectedParticipantPart.from(m);return c(y),this},confirmation(h,s,m){t(this.confirmation),(0,d.$VG)(n.j,"chatParticipantAdditions");const y=new w.$xO(h,s,m),S=A.ChatResponseConfirmationPart.from(y);return c(S),this},push(h){if(t(this.push),(h instanceof w.$FO||h instanceof w.$vO||h instanceof w.$wO||h instanceof w.$CO||h instanceof w.$xO)&&(0,d.$VG)(n.j,"chatParticipantAdditions"),h instanceof w.$EO)this.reference(h.value,h.iconPath);else{const s=A.ChatResponsePart.from(h,n.m,n.n);c(s)}return this}}}return this.g}}class $ extends R.$Uc{constructor(n,t,c,h){super(),this.n=t,this.s=c,this.t=h,this.c=new Map,this.j=this.B(new R.$4c),this.m=this.B(new R.$4c),this.g=n.getProxy(f.$vM.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,t,c){const h=$.b++,s=new i(n,this.t,t,this.g,h,c);return this.c.set(h,s),s.isAgentEnabled()&&this.g.$registerAgent(h,n.identifier,t,{},void 0),s.apiAgent}createDynamicChatAgent(n,t,c,h){const s=$.b++,m=new i(n,this.t,t,this.g,s,h);return this.c.set(s,m),this.g.$registerAgent(s,n.identifier,t,{isSticky:!0},c),m.apiAgent}async $invokeAgent(n,t,c,h){const s=this.c.get(n);if(!s)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let m=this.j.get(t.sessionId);m||(m=new R.$Tc,this.j.set(t.sessionId,m));const y=new g(s.extension,t,this.g,this.s.converter,m);try{const S=await this.u(t.agentId,c),E=s.invoke(A.ChatAgentRequest.to(t),{history:S},y.apiObject,h);return await(0,u.$oh)(Promise.resolve(E).then(k=>{if(k?.metadata)try{JSON.stringify(k.metadata)}catch(v){const b=`result.metadata MUST be JSON.stringify-able. Got error: ${v.message}`;return this.n.error(`[${s.extension.identifier.value}] [@${s.id}] ${b}`,s.extension),{errorDetails:{message:b},timings:y.timings}}let C;return k?.errorDetails&&(C={...k.errorDetails,responseIsIncomplete:!0}),C?.responseIsRedacted&&(0,d.$VG)(s.extension,"chatParticipantPrivate"),{errorDetails:C,timings:y.timings,metadata:k?.metadata}}),h)}catch(S){return this.n.error(S,s.extension),S instanceof w.$MO&&S.cause&&(S=S.cause),{errorDetails:{message:(0,P.$lj)(S),responseIsIncomplete:!0}}}finally{y.close()}}async u(n,t){const c=[];for(const h of t.history){const s=A.ChatAgentResult.to(h.result),m=n===h.request.agentId?s:{...s,metadata:void 0};c.push(new w.$GO(h.request.message,h.request.command,h.request.variables.variables.map(A.ChatAgentValueReference.to),h.request.agentId));const y=(0,r.$Hb)(h.response.map(S=>A.ChatResponsePart.toContent(S,this.s.converter)));c.push(new w.$HO(y,m,h.request.agentId,h.request.command))}return c}$releaseSession(n){this.j.deleteAndDispose(n)}async $provideFollowups(n,t,c,h,s){const m=this.c.get(t);if(!m)return Promise.resolve([]);const y=await this.u(m.id,h),S=A.ChatAgentResult.to(c);return(await m.provideFollowups(S,{history:y},s)).filter(E=>{const k=!E.participant||L.Iterable.some(this.c.values(),C=>C.id===E.participant&&D.$Xm.equals(C.extension.identifier,m.extension.identifier));return k||this.n.warn(`[@${m.id}] ChatFollowup refers to an unknown participant: ${E.participant}`),k}).map(E=>A.ChatFollowup.from(E,n))}$acceptFeedback(n,t,c,h){const s=this.c.get(n);if(!s)return;const m=A.ChatAgentResult.to(t);let y;switch(c){case a.ChatAgentVoteDirection.Down:y=w.ChatResultFeedbackKind.Unhelpful;break;case a.ChatAgentVoteDirection.Up:y=w.ChatResultFeedbackKind.Helpful;break}s.acceptFeedback(Object.freeze(h?{result:m,kind:y,reportIssue:h}:{result:m,kind:y}))}$acceptAction(n,t,c){const h=this.c.get(n);if(!h||c.action.kind==="vote")return;const s=A.ChatAgentUserActionEvent.to(t,c,this.s.converter);s&&h.acceptAction(Object.freeze(s))}async $invokeCompletionProvider(n,t,c){const h=this.c.get(n);if(!h)return[];let s=this.m.get(n);return s?s.clear():(s=new R.$Tc,this.m.set(n,s)),(await h.invokeCompletionProvider(t,c)).map(y=>A.ChatAgentCompletionItem.from(y,this.s.converter,s))}async $provideWelcomeMessage(n,t,c){const h=this.c.get(n);if(h)return await h.provideWelcomeMessage(A.ChatLocation.to(t),c)}async $provideSampleQuestions(n,t,c){const h=this.c.get(n);if(h)return(await h.provideSampleQuestions(A.ChatLocation.to(t),c)).map(s=>A.ChatFollowup.from(s,void 0))}}e.$6mc=$,$.b=0;class i{constructor(n,t,c,h,s,m){this.extension=n,this.w=t,this.id=c,this.x=h,this.y=s,this.z=m,this.m=new T.$he,this.n=new T.$he}acceptFeedback(n){this.m.fire(n)}acceptAction(n){this.n.fire(n)}async invokeCompletionProvider(n,t){return this.q?await this.q.provider.provideCompletionItems(n,t)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,d.$UG)(this.extension,"chatParticipantPrivate"))}async provideFollowups(n,t,c){if(!this.b)return[];const h=await this.b.provideFollowups(n,t,c);return h?h.filter(s=>!(s&&"commandId"in s)).filter(s=>!(s&&"message"in s)):[]}async provideWelcomeMessage(n,t){if(!this.s)return[];const c=await this.s.provideWelcomeMessage(n,t);return c?c.map(h=>typeof h=="string"?h:A.MarkdownString.from(h)):[]}async provideSampleQuestions(n,t){if(!this.s||!this.s.provideSampleQuestions)return[];const c=await this.s.provideSampleQuestions(n,t);return c||[]}get apiAgent(){let n=!1,t=!1;const c=()=>{n||t||(t=!0,queueMicrotask(()=>{h.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof I.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof w.$uN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:A.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:A.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:A.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),t=!1)}))},h=this;return{get id(){return h.id},get iconPath(){return h.c},set iconPath(s){h.c=s,c()},get requestHandler(){return h.z},set requestHandler(s){(0,l.$kg)(typeof s=="function","Invalid request handler"),h.z=s},get followupProvider(){return h.b},set followupProvider(s){h.b=s,c()},get isDefault(){return(0,d.$VG)(h.extension,"defaultChatParticipant"),h.d},set isDefault(s){(0,d.$VG)(h.extension,"defaultChatParticipant"),h.d=s,c()},get helpTextPrefix(){return(0,d.$VG)(h.extension,"defaultChatParticipant"),h.g},set helpTextPrefix(s){(0,d.$VG)(h.extension,"defaultChatParticipant"),h.g=s,c()},get helpTextVariablesPrefix(){return(0,d.$VG)(h.extension,"defaultChatParticipant"),h.j},set helpTextVariablesPrefix(s){(0,d.$VG)(h.extension,"defaultChatParticipant"),h.j=s,c()},get helpTextPostfix(){return(0,d.$VG)(h.extension,"defaultChatParticipant"),h.k},set helpTextPostfix(s){(0,d.$VG)(h.extension,"defaultChatParticipant"),h.k=s,c()},get isSecondary(){return(0,d.$VG)(h.extension,"defaultChatParticipant"),h.l},set isSecondary(s){(0,d.$VG)(h.extension,"defaultChatParticipant"),h.l=s,c()},get supportIssueReporting(){return(0,d.$VG)(h.extension,"chatParticipantPrivate"),h.o},set supportIssueReporting(s){(0,d.$VG)(h.extension,"chatParticipantPrivate"),h.o=s,c()},get onDidReceiveFeedback(){return h.m.event},set participantVariableProvider(s){if((0,d.$VG)(h.extension,"chatParticipantAdditions"),h.q=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");h.x.$registerAgentCompletionsProvider(h.y,h.id,s.triggerCharacters)}else h.x.$unregisterAgentCompletionsProvider(h.y,h.id)},get participantVariableProvider(){return(0,d.$VG)(h.extension,"chatParticipantAdditions"),h.q},set welcomeMessageProvider(s){(0,d.$VG)(h.extension,"defaultChatParticipant"),h.s=s,c()},get welcomeMessageProvider(){return(0,d.$VG)(h.extension,"defaultChatParticipant"),h.s},onDidPerformAction:(0,d.$UG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(s){h.t=s,c()},get requester(){return h.t},set supportsSlowReferences(s){(0,d.$VG)(h.extension,"chatParticipantPrivate"),h.u=s,c()},get supportsSlowReferences(){return(0,d.$VG)(h.extension,"chatParticipantPrivate"),h.u},dispose(){n=!0,h.b=void 0,h.m.dispose(),h.x.$unregisterAgent(h.y)}}}invoke(n,t,c,h){return this.z(n,t,c,h)}}}),define(Ee[345],Se([1,0,14,3,50,6,17,8,26]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class l{constructor(f){this.b=new Map,this.c=f.getProxy(T.$vM.MainThreadChatVariables)}async $resolveVariable(f,A,w,a){const d=this.b.get(f);if(d)try{if(d.resolver.resolve2){(0,p.$VG)(d.extension,"chatParticipantAdditions");const g=new I(A,this.c),$=await d.resolver.resolve2(d.data.name,{prompt:w},g.apiObject,a);if($&&$[0])return $[0].value}else{const g=await d.resolver.resolve(d.data.name,{prompt:w},a);if(g&&g[0])return g[0].value}}catch(g){(0,r.$2)(g)}}registerVariableResolver(f,A,w,a,d,g,$,i,o){const n=l.a++,t=o?P.ThemeIcon.fromId(o):void 0;return this.b.set(n,{extension:f,data:{id:A,name:w,description:a,modelDescription:d,icon:t},resolver:$}),this.c.$registerVariable(n,{id:A,name:w,description:a,modelDescription:d,isSlow:g,fullName:i,icon:t}),(0,u.$Sc)(()=>{this.b.delete(n),this.c.$unregisterVariable(n)})}attachContext(f,A,w){this.c.$attachContext(f,R.$JM.isLocation(A)?L.Location.from(A):A,L.ChatLocation.from(w))}}e.$7mc=l,l.a=0;class I{constructor(f,A){this.c=f,this.d=A,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let A=function(a){if(f.a){const d=new Error("Response stream has been closed");throw Error.captureStackTrace(d,a),d}};const f=this,w=a=>{this.d.$handleProgressChunk(this.c,a)};this.b={progress(a){A(this.progress);const d=new R.$AO(a),g=L.ChatResponseProgressPart.from(d);return w(g),this},reference(a){A(this.reference);const d=new R.$EO(a),g=L.ChatResponseReferencePart.from(d);return w(g),this},push(a){return A(this.push),a instanceof R.$EO?w(L.ChatResponseReferencePart.from(a)):a instanceof R.$AO&&w(L.ChatResponseProgressPart.from(a)),this}}}return this.b}}}),define(Ee[346],Se([1,0,7,60,4,3,41,2,88,24,17,8,6,26]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=w;function w(a,d,g){const $=a.getProxy(f.$vM.MainThreadComments);class i{constructor(){this.b=new Map,this.c=new l.$Zm,d.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===L.MarshalledId.CommentController){const k=this.b.get(E.handle);return k?k.value:E}else if(E&&E.$mid===L.MarshalledId.CommentThread){const k=E,C=this.b.get(k.commentControlHandle);if(!C)return k;const v=C.getCommentThread(k.commentThreadHandle);return v?v.value:k}else if(E&&(E.$mid===L.MarshalledId.CommentThreadReply||E.$mid===L.MarshalledId.CommentThreadInstance)){const k=this.b.get(E.thread.commentControlHandle);if(!k)return E;const C=k.getCommentThread(E.thread.commentThreadHandle);return C?E.$mid===L.MarshalledId.CommentThreadInstance?C.value:{thread:C.value,text:E.text}:E}else if(E&&E.$mid===L.MarshalledId.CommentNode){const k=this.b.get(E.thread.commentControlHandle);if(!k)return E;const C=k.getCommentThread(E.thread.commentThreadHandle);if(!C)return E;const v=E.commentUniqueId,b=C.getCommentByUniqueId(v);return b||E}else if(E&&E.$mid===L.MarshalledId.CommentThreadNode){const k=this.b.get(E.thread.commentControlHandle);if(!k)return E;const C=k.getCommentThread(E.thread.commentThreadHandle);if(!C)return E;const v=E.text,b=E.commentUniqueId,O=C.getCommentByUniqueId(b);return O?(typeof O.body=="string"?O.body=v:O.body=new D.$ZM(v),O):E}return E}})}createCommentController(E,k,C){const v=i.a++,b=new n(E,v,k,C);this.b.set(b.handle,b);const O=this.c.get(E.identifier)||[];return O.push(b),this.c.set(E.identifier,O),b.value}async $createCommentThreadTemplate(E,k,C,v){const b=this.b.get(E);b&&b.$createCommentThreadTemplate(k,C,v)}async $setActiveComment(E,k){const C=this.b.get(E);C&&C.$setActiveComment(k??void 0)}async $updateCommentThreadTemplate(E,k,C){const v=this.b.get(E);v&&v.$updateCommentThreadTemplate(k,C)}$deleteCommentThread(E,k){this.b.get(E)?.$deleteCommentThread(k)}async $provideCommentingRanges(E,k,C){const v=this.b.get(E);if(!v||!v.commentingRangeProvider)return Promise.resolve(void 0);const b=await g.ensureDocumentData(R.URI.revive(k));return(0,r.$sh)(async()=>{const O=await v.commentingRangeProvider.provideCommentingRanges(b.document,C);let U;return Array.isArray(O)?U={ranges:O,fileComments:!1}:O?U={ranges:O.ranges||[],fileComments:O.fileComments||!1}:U=O??void 0,U}).then(O=>{let U;return O&&(U={ranges:O.ranges.map(z=>I.Range.from(z)),fileComments:O.fileComments}),U})}$toggleReaction(E,k,C,v,b){const O=this.b.get(E);return!O||!O.reactionHandler?Promise.resolve(void 0):(0,r.$sh)(()=>{const U=O.getCommentThread(k);if(U){const z=U.getCommentByUniqueId(v.uniqueIdInThread);if(O!==void 0&&z&&O.reactionHandler)return O.reactionHandler(z,h(b))}return Promise.resolve(void 0)})}}i.a=0;class o{set threadId(E){this.n=E}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(E){(E===void 0!=(this.p===void 0)||!E||!this.p||!E.isEqual(this.p))&&(this.p=E,this.b.range=E,this.c.fire())}get range(){return this.p}set canReply(E){this.d!==E&&(this.d=E,this.b.canReply=E,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(E){this.e=E,this.b.label=E,this.c.fire()}get contextValue(){return this.f}set contextValue(E){this.f=E,this.b.contextValue=E,this.c.fire()}get comments(){return this.q}set comments(E){this.q=E,this.b.comments=E,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(E){this.g=E,this.b.collapsibleState=E,this.c.fire()}get state(){return this.h}set state(E){this.h=E,typeof E=="object"?((0,A.$VG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=E.resolved,this.b.applicability=E.applicability):this.b.state=E,this.c.fire()}get isDisposed(){return this.j}constructor(E,k,C,v,b,O,U,z,j){this.m=k,this.n=C,this.o=v,this.p=b,this.q=O,this.extensionDescription=U,this.r=z,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$he,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Vc,this.l.value=new T.$Tc,this.n===void 0&&(this.n=`${E}.${this.handle}`),$.$createCommentThread(k,this.handle,this.n,this.o,I.Range.from(this.p),U.identifier,this.r,j),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=O,this.i.push({dispose:()=>{$.$deleteCommentThread(k,this.handle)}});const M=this;this.value={get uri(){return M.uri},get range(){return M.range},set range(N){M.range=N},get comments(){return M.comments},set comments(N){M.comments=N},get collapsibleState(){return M.collapsibleState},set collapsibleState(N){M.collapsibleState=N},get canReply(){return M.canReply},set canReply(N){M.canReply=N},get contextValue(){return M.contextValue},set contextValue(N){M.contextValue=N},get label(){return M.label},set label(N){M.label=N},get state(){return M.state},set state(N){M.state=N},dispose:()=>{M.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Tc);const E=C=>Object.prototype.hasOwnProperty.call(this.b,C),k={};E("range")&&(k.range=I.Range.from(this.p)),E("label")&&(k.label=this.label),E("contextValue")&&(k.contextValue=this.contextValue??null),E("comments")&&(k.comments=this.q.map(C=>t(this,C,this.k,this.extensionDescription))),E("collapsibleState")&&(k.collapseState=s(this.g)),E("canReply")&&(k.canReply=this.canReply),E("state")&&(k.state=m(this.h)),E("applicability")&&(k.applicability=y(this.h)),E("isTemplate")&&(k.isTemplate=this.r),this.b={},$.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(E){for(const k of this.k){const C=k[0],v=k[1];if(E===v)return C}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(E=>E.dispose())}}o.a=0,Ze([(0,u.$6h)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(E){this.b=E,E?.resourceHints&&(0,A.$VG)(this.h,"commentingRangeHint"),$.$updateCommentingRanges(this.handle,E?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(E){this.c=E,$.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!E})}get options(){return this.d}set options(E){this.d=E,$.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,A.$VG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,A.$VG)(this.h,"activeComment"),this.f}constructor(E,k,C,v){this.h=E,this.i=k,this.j=C,this.k=v,this.a=new Map,$.$registerCommentController(this.handle,C,v,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(O){b.options=O},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(O){b.commentingRangeProvider=O},get reactionHandler(){return b.reactionHandler},set reactionHandler(O){b.reactionHandler=O},get activeCommentThread(){return b.activeCommentThread},createCommentThread(O,U,z){return b.createCommentThread(O,U,z).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{$.$unregisterCommentController(this.handle)}})}createCommentThread(E,k,C){k===void 0&&(0,A.$VG)(this.h,"fileComments");const v=new o(this.id,this.handle,void 0,E,k,C,this.h,!1);return this.a.set(v.handle,v),v}$setActiveComment(E){if(!E){this.e=void 0,this.f=void 0;return}const k=this.a.get(E.commentThreadHandle);k&&(this.e=E.uniqueIdInThread?k.getCommentByUniqueId(E.uniqueIdInThread):void 0,this.f=k)}$createCommentThreadTemplate(E,k,C){const v=new o(this.id,this.handle,void 0,R.URI.revive(E),I.Range.to(k),[],this.h,!0,C);return v.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(v.handle,v),v}$updateCommentThreadTemplate(E,k){const C=this.a.get(E);C&&(C.range=I.Range.to(k))}$deleteCommentThread(E){this.a.get(E)?.dispose(),this.a.delete(E)}getCommentThread(E){return this.a.get(E)}dispose(){this.a.forEach(E=>{E.dispose()}),this.g.forEach(E=>E.dispose())}}function t(S,E,k,C){let v=k.get(E);return v||(v=++S.commentHandle,k.set(E,v)),E.state!==void 0&&(0,A.$VG)(C,"commentsDraftState"),E.reactions?.some(b=>b.reactors!==void 0)&&(0,A.$VG)(C,"commentReactor"),{mode:E.mode,contextValue:E.contextValue,uniqueIdInThread:v,body:typeof E.body=="string"?E.body:I.MarkdownString.from(E.body),userName:E.author.name,userIconPath:E.author.iconPath,label:E.label,commentReactions:E.reactions?E.reactions.map(b=>c(b)):void 0,state:E.state,timestamp:E.timestamp?.toJSON()}}function c(S){return{label:S.label,iconPath:S.iconPath?I.$YO(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(E=>E.name):S.reactors}}function h(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?R.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(E=>({name:E}))}}function s(S){if(S!==void 0)switch(S){case D.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case D.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function m(S){let E;if(typeof S=="object"?E=S.resolved:E=S,E!==void 0)switch(E){case D.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case D.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function y(S){let E;if(typeof S=="object"&&(E=S.applicability),E!==void 0)switch(E){case D.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case D.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Ee[347],Se([1,0,21,61,3,15,23,2,17,97,118,6,8]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=void 0;class A{constructor(c,h){this.document=c,this.b=h,this.a=1,this.c=new I.$Qmc("custom documents")}addEdit(c){return this.c.add([c])}async undo(c,h){await this.f(c).undo(),h||this.disposeBackup()}async redo(c,h){await this.f(c).redo(),h||this.disposeBackup()}disposeEdits(c){for(const h of c)this.c.delete(h)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const c=n(this.document.uri)+this.a++;return(0,L.$bh)(this.b,c)}updateBackup(c){this.d?.delete(),this.d=c}disposeBackup(){this.d?.delete(),this.d=void 0}f(c){const h=this.c.get(c,0);if(!h)throw new Error("No edit found");return h}}class w{constructor(){this.a=new Map}get(c,h){return this.a.get(this.b(c,h))}add(c,h,s){const m=this.b(c,h.uri);if(this.a.has(m))throw new Error(`Document already exists for viewType:${c} resource:${h.uri}`);const y=new A(h,s);return this.a.set(m,y),y}delete(c,h){const s=this.b(c,h.uri);this.a.delete(s)}b(c,h){return`${c}@@@${h}`}}var a;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(a||(a={}));class d{constructor(){this.a=new Map}addTextProvider(c,h,s){return this.b(c,{type:a.Text,extension:h,provider:s})}addCustomProvider(c,h,s){return this.b(c,{type:a.Custom,extension:h,provider:s})}get(c){return this.a.get(c)}b(c,h){if(this.a.has(c))throw new Error(`Provider for viewType:${c} already registered`);return this.a.set(c,h),new f.$xM(()=>this.a.delete(c))}}class g{constructor(c,h,s,m,y){this.d=h,this.f=s,this.g=m,this.h=y,this.b=new d,this.c=new w,this.a=c.getProxy(D.$vM.MainThreadCustomEditors)}registerCustomEditorProvider(c,h,s,m){const y=new P.$Tc;return i(s)?(y.add(this.b.addTextProvider(h,c,s)),this.a.$registerTextEditorProvider((0,l.$nnc)(c),h,m.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,l.$lnc)(c))):(y.add(this.b.addCustomProvider(h,c,s)),$(s)&&y.add(s.onDidChangeCustomDocument(S=>{const E=this.i(h,S.document.uri);if(o(S)){const k=E.addEdit(S);this.a.$onDidEdit(S.document.uri,h,k,S.label)}else this.a.$onContentChange(S.document.uri,h)})),this.a.$registerCustomEditorProvider((0,l.$nnc)(c),h,m.webviewOptions||{},!!m.supportsMultipleEditorsPerDocument,(0,l.$lnc)(c))),f.$xM.from(y,new f.$xM(()=>{this.a.$unregisterEditorProvider(h)}))}async $createCustomDocument(c,h,s,m,y){const S=this.b.get(h);if(!S)throw new Error(`No provider found for '${h}'`);if(S.type!==a.Custom)throw new Error(`Invalid provide type for '${h}'`);const E=R.URI.revive(c),k=await S.provider.openCustomDocument(E,{backupId:s,untitledDocumentData:m?.buffer},y);let C;return $(S.provider)&&this.f&&(C=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(h,k,C),{editable:$(S.provider)}}async $disposeCustomDocument(c,h){const s=this.b.get(h);if(!s)throw new Error(`No provider found for '${h}'`);if(s.type!==a.Custom)throw new Error(`Invalid provider type for '${h}'`);const m=R.URI.revive(c),{document:y}=this.i(h,m);this.c.delete(h,y),y.dispose()}async $resolveCustomEditor(c,h,s,m,y,S){const E=this.b.get(s);if(!E)throw new Error(`No provider found for '${s}'`);const k=p.ViewColumn.to(y),C=this.g.createNewWebview(h,m.contentOptions,E.extension),v=this.h.createNewWebviewPanel(h,s,m.title,k,m.options,C,m.active),b=R.URI.revive(c);switch(E.type){case a.Custom:{const{document:O}=this.i(s,b);return E.provider.resolveCustomEditor(O,v,S)}case a.Text:{const O=this.d.getDocument(b);return E.provider.resolveCustomTextEditor(O,v,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(c,h,s){this.i(h,c).disposeEdits(s)}async $onMoveCustomEditor(c,h,s){const m=this.b.get(s);if(!m)throw new Error(`No provider found for '${s}'`);if(!m.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const y=this.h.getWebviewPanel(c);if(!y)throw new Error("No webview found");const S=R.URI.revive(h),E=this.d.getDocument(S);await m.provider.moveCustomTextEditor(E,y,r.CancellationToken.None)}async $undo(c,h,s,m){return this.i(h,c).undo(s,m)}async $redo(c,h,s,m){return this.i(h,c).redo(s,m)}async $revert(c,h,s){const m=this.i(h,c);await this.j(h).revertCustomDocument(m.document,s),m.disposeBackup()}async $onSave(c,h,s){const m=this.i(h,c);await this.j(h).saveCustomDocument(m.document,s),m.disposeBackup()}async $onSaveAs(c,h,s,m){const y=this.i(h,c);return this.j(h).saveCustomDocumentAs(y.document,R.URI.revive(s),m)}async $backup(c,h,s){const m=this.i(h,c),S=await this.j(h).backupCustomDocument(m.document,{destination:m.getNewBackupUri()},s);return m.updateBackup(S),S.id}i(c,h){const s=this.c.get(c,R.URI.revive(h));if(!s)throw new Error("No custom document found");return s}j(c){const s=this.b.get(c)?.provider;if(!s||!$(s))throw new Error("Custom document is not editable");return s}}e.$qnc=g;function $(t){return!!t.onDidChangeCustomDocument}function i(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function n(t){const c=t.scheme===T.Schemas.file||t.scheme===T.Schemas.untitled?t.fsPath:t.toString();return(0,u.$oj)(c)+""}});var rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r},Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)};define(Ee[348],Se([1,0,232,145,2,6,8,17,4,12,29,63]),function(oe,e,r,u,P,T,L,R,p,l,I,D){"use strict";var f,A,w,a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=e.$Xmc=void 0;class d{constructor(i,o,n,t,c,h,s,m){this.d=i,this.e=o,this.f=n,this.g=t,this.h=c,f.set(this,void 0),A.set(this,void 0),w.set(this,void 0),this.c=!1,this.f=Math.max(t,n),rt(this,w,new I.$Ac(y=>h.getComparisonKey(y)),"f"),rt(this,f,s,"f"),rt(this,A,m,"f")}dispose(){this.c||(Ge(this,A,"f").fire([...Ge(this,w,"f").keys()]),Ge(this,f,"f")?.$clear(this.e),Ge(this,w,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(i,o){if(!i){this.clear();return}this.j();let n=[];if(P.URI.isUri(i)){if(!o){this.delete(i);return}Ge(this,w,"f").set(i,o.slice()),n=[i]}else if(Array.isArray(i)){n=[];let h;i=[...i].sort(d.k);for(const s of i){const[m,y]=s;if((!h||m.toString()!==h.toString())&&(h&&Ge(this,w,"f").get(h).length===0&&Ge(this,w,"f").delete(h),h=m,n.push(m),Ge(this,w,"f").set(m,[])),y)Ge(this,w,"f").get(m)?.push(...y);else{const S=Ge(this,w,"f").get(m);S&&(S.length=0)}}}if(Ge(this,A,"f").fire(n),!Ge(this,f,"f"))return;const t=[];let c=0;for(const h of n){let s=[];const m=Ge(this,w,"f").get(h);if(m)if(m.length>this.g){s=[];const y=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let S=0;S<4;S++)for(const E of m)if(E.severity===y[S]&&s.push({...R.Diagnostic.from(E),modelVersionId:this.h(h)})===this.g)break e;s.push({severity:u.MarkerSeverity.Info,message:(0,r.localize)(0,null,m.length-this.g),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=m.map(y=>({...R.Diagnostic.from(y),modelVersionId:this.h(h)}));if(t.push([h,s]),c+=s.length,c>this.f)break}Ge(this,f,"f").$changeMany(this.e,t)}delete(i){this.j(),Ge(this,A,"f").fire([i]),Ge(this,w,"f").delete(i),Ge(this,f,"f")?.$changeMany(this.e,[[i,void 0]])}clear(){this.j(),Ge(this,A,"f").fire([...Ge(this,w,"f").keys()]),Ge(this,w,"f").clear(),Ge(this,f,"f")?.$clear(this.e)}forEach(i,o){this.j();for(const[n,t]of this)i.call(o,n,t,this)}*[(f=new WeakMap,A=new WeakMap,w=new WeakMap,Symbol.iterator)](){this.j();for(const i of Ge(this,w,"f").keys())yield[i,this.get(i)]}get(i){this.j();const o=Ge(this,w,"f").get(i);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(i){return this.j(),Array.isArray(Ge(this,w,"f").get(i))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(i,o){return i[0].toString()<o[0].toString()?-1:i[0].toString()>o[0].toString()?1:0}}e.$Xmc=d;let g=a=class{static _mapper(i){const o=new I.$Ac;for(const n of i)o.set(n,n);return{uris:Object.freeze(Array.from(o.values()))}}constructor(i,o,n,t){this.j=o,this.k=n,this.l=t,this.g=new Map,this.h=new p.$le({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,a._mapper),this.f=i.getProxy(T.$vM.MainThreadDiagnostics)}createDiagnosticCollection(i,o){const{g:n,f:t,h:c,j:h,k:s,l:m}=this,y=new class{$changeMany(k,C){t.$changeMany(k,C),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",i.value,k,C.length===0?"CLEARING":C)}$clear(k){t.$clear(k),h.trace("[DiagnosticCollection] remove all (extension, owner)",i.value,k)}dispose(){t.dispose()}};let S;if(!o)o="_generated_diagnostic_collection_name_#"+a.c++,S=o;else if(!n.has(o))S=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do S=o+a.c++;while(n.has(S))}return new class extends d{constructor(){super(o,S,a.e,a.d,k=>m.getDocument(k)?.version,s.extUri,y,c),n.set(S,this)}dispose(){super.dispose(),n.delete(S)}}}getDiagnostics(i){if(i)return this.m(i);{const o=new Map,n=[];for(const t of this.g.values())t.forEach((c,h)=>{let s=o.get(c.toString());typeof s>"u"&&(s=n.length,o.set(c.toString(),s),n.push([c,[]])),n[s][1]=n[s][1].concat(...h)});return n}}m(i){let o=[];for(const n of this.g.values())n.has(i)&&(o=o.concat(n.get(i)));return o}$acceptMarkersChange(i){if(!this.n){const o="_generated_mirror",n=new d(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(o,n),this.n=n}for(const[o,n]of i)this.n.set(P.URI.revive(o),n.map(R.Diagnostic.to))}};e.$Ymc=g,g.c=0,g.d=1e3,g.e=1.1*a.d,e.$Ymc=g=a=Ze([Ve(1,l.$7j),Ve(2,D.$Wmc)],g)}),define(Ee[349],Se([1,0,2,14,8,17,81,52]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=void 0;class p{constructor(I,D,f,A={timeout:1500,errors:3}){this.c=I,this.d=D,this.f=f,this.g=A,this.a=new L.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(D,f,A)=>{const a={dispose:this.a.push([D,f,I])};return Array.isArray(A)&&A.push(a),a}}async $participateInSave(I,D){const f=r.URI.revive(I);let A=!1;const w=setTimeout(()=>A=!0,this.g.timeout),a=[];try{for(const d of[...this.a]){if(A)break;const g=this.d.getDocument(f),$=await this.h(d,{document:g,reason:T.TextDocumentSaveReason.to(D)});a.push($)}}finally{clearTimeout(w)}return a}h([I,D,f],A){const w=this.b.get(I);return typeof w=="number"&&w>this.g.errors?Promise.resolve(!1):this.i(f,I,D,A).then(()=>!0,a=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' threw ERROR`),this.c.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const d=this.b.get(I);this.b.set(I,d?d+1:1),typeof d=="number"&&d>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${f.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,D,f,A){const w=[],a=Date.now(),{document:d,reason:g}=A,{version:$}=d,i=Object.freeze({document:d,reason:g,waitUntil(o){if(Object.isFrozen(w))throw(0,u.$8)("waitUntil can not be called async");w.push(Promise.resolve(o))}});try{D.apply(f,[i])}catch(o){return Promise.reject(o)}return Object.freeze(w),new Promise((o,n)=>{const t=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(w).then(c=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(t),o(c)}).catch(c=>{clearTimeout(t),n(c)})}).then(o=>{const n={edits:[]};for(const t of o)if(Array.isArray(t)&&t.every(c=>c instanceof P.$EM))for(const{newText:c,newEol:h,range:s}of t)n.edits.push({resource:d.uri,versionId:void 0,textEdit:{range:s&&T.Range.from(s),text:c,eol:h&&T.EndOfLine.from(h)}});if(n.edits.length!==0)return $===d.version?this.f.$tryApplyWorkspaceEdit(new R.$Lw(n)):Promise.reject(new Error("concurrent_edits"))})}}e.$7nc=p}),define(Ee[350],Se([1,0,4,3,2,6,163,17,18,25,8]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=void 0;class D{constructor(A,w){this.a=new r.$he,this.b=new r.$he,this.c=new r.$he,this.d=new r.$he,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new u.$Tc,this.h=new Map,this.f=A.getProxy(T.$vM.MainThreadDocuments),this.g=w,this.g.onDidRemoveDocuments(a=>{for(const d of a)this.b.fire(d.document)},void 0,this.e),this.g.onDidAddDocuments(a=>{for(const d of a)this.a.fire(d.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(A){if(!A)return;const w=this.g.getDocument(A);if(w)return w}getDocument(A){const w=this.getDocumentData(A);if(!w?.document)throw new Error(`Unable to retrieve document from URI '${A}'`);return w.document}ensureDocumentData(A){const w=this.g.getDocument(A);if(w)return Promise.resolve(w);let a=this.h.get(A.toString());return a||(a=this.f.$tryOpenDocument(A).then(d=>{this.h.delete(A.toString());const g=P.URI.revive(d);return(0,p.$lg)(this.g.getDocument(g))},d=>(this.h.delete(A.toString()),Promise.reject(d))),this.h.set(A.toString(),a)),a}createDocumentData(A){return this.f.$tryCreateDocument(A).then(w=>P.URI.revive(w))}$acceptModelLanguageChanged(A,w){const a=P.URI.revive(A),d=this.g.getDocument(a);if(!d)throw new Error("unknown document");this.b.fire(d.document),d._acceptLanguageId(w),this.a.fire(d.document)}$acceptModelSaved(A){const w=P.URI.revive(A),a=this.g.getDocument(w);if(!a)throw new Error("unknown document");this.$acceptDirtyStateChanged(A,!1),this.d.fire(a.document)}$acceptDirtyStateChanged(A,w){const a=P.URI.revive(A),d=this.g.getDocument(a);if(!d)throw new Error("unknown document");d._acceptIsDirty(w),this.c.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(A,w,a){const d=P.URI.revive(A),g=this.g.getDocument(d);if(!g)throw new Error("unknown document");g._acceptIsDirty(a),g.onEvents(w);let $;w.isUndoing?$=I.TextDocumentChangeReason.Undo:w.isRedoing&&($=I.TextDocumentChangeReason.Redo),this.c.fire((0,l.$$n)({document:g.document,contentChanges:w.changes.map(i=>({range:R.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:$}))}setWordDefinitionFor(A,w){(0,L.$2O)(A,w)}}e.$Zmc=D}),define(Ee[77],Se([1,0,79,4,18,2,5,6,20,17,8]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=e.$rnc=void 0,e.$rnc=(0,L.$Ai)("IExtHostEditorTabs");class D{constructor(d,g,$){this.e=$,this.d=g,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,g={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(g)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case R.TabInputKind.TextInput:return new I.$iO(T.URI.revive(this.b.input.uri));case R.TabInputKind.TextDiffInput:return new I.$jO(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case R.TabInputKind.TextMergeInput:return new I.$kO(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case R.TabInputKind.CustomEditorInput:return new I.$lO(T.URI.revive(this.b.input.uri),this.b.input.viewType);case R.TabInputKind.WebviewEditorInput:return new I.$mO(this.b.input.viewType);case R.TabInputKind.NotebookInput:return new I.$nO(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case R.TabInputKind.NotebookDiffInput:return new I.$oO(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case R.TabInputKind.TerminalEditorInput:return new I.$pO;case R.TabInputKind.InteractiveEditorInput:return new I.$qO(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));case R.TabInputKind.ChatEditorInput:return new I.$rO;case R.TabInputKind.MultiDiffEditorInput:return new I.$sO(this.b.input.diffEditors.map(d=>new I.$jO(T.URI.revive(d.original),T.URI.revive(d.modified))));default:return}}}class f{constructor(d,g){this.c=[],this.d="",this.b=d,this.e=g;for(const $ of d.tabs)$.isActive&&(this.d=$.id),this.c.push(new D($,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,g={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return l.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find($=>$.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map($=>$.apiObject))}};this.a=Object.freeze(g)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===R.TabModelOperationKind.TAB_OPEN){const $=new D(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,$),d.tabDto.isActive&&(this.d=$.tabId),$}else if(d.kind===R.TabModelOperationKind.TAB_CLOSE){const $=this.c.splice(d.index,1)[0];if(!$)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return $.tabId===this.d&&(this.d=""),$}else if(d.kind===R.TabModelOperationKind.TAB_MOVE){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const $=this.c.splice(d.oldIndex,1)[0];if(!$)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,$),$}const g=this.c.find($=>$.tabId===d.tabDto.id);if(!g)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),g.acceptDtoUpdate(d.tabDto),g}activeTabId(){return this.d}}let A=class{constructor(d){this.b=new u.$he,this.c=new u.$he,this.e=[],this.a=d.getProxy(R.$vM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,g={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map($=>$.apiObject))},get activeTabGroup(){const $=d.d;return(0,P.$lg)(d.e.find(o=>o.groupId===$)?.apiObject)},close:async($,i)=>{const o=Array.isArray($)?$:[$];return o.length?w(o[0])?this.j(o,i):this.i(o,i):!0}};this.f=Object.freeze(g)}return this.f}$acceptEditorTabModel(d){const g=new Set(this.e.map(h=>h.groupId)),$=new Set(d.map(h=>h.groupId)),i=(0,r.$F)(g,$),o=this.e.filter(h=>i.removed.includes(h.groupId)).map(h=>h.apiObject),n=[],t=[];this.e=d.map(h=>{const s=new f(h,()=>this.d);return i.added.includes(s.groupId)?n.push(s.apiObject):t.push(s.apiObject),s});const c=(0,P.$lg)(d.find(h=>h.isActive===!0)?.groupId);c!==void 0&&this.d!==c&&(this.d=c),this.c.fire(Object.freeze({opened:n,closed:o,changed:t}))}$acceptTabGroupUpdate(d){const g=this.e.find($=>$.groupId===d.groupId);if(!g)throw new Error("Update Group IPC call received before group creation.");g.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[g.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const g=this.e.find(i=>i.groupId===d.groupId);if(!g)throw new Error("Update Tabs IPC call received before group creation.");const $=g.acceptTabOperation(d);switch(d.kind){case R.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[$.apiObject],closed:[],changed:[]}));return;case R.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[$.apiObject],changed:[]}));return;case R.TabModelOperationKind.TAB_MOVE:case R.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[$.apiObject]}));return}}g(d){for(const g of this.e)for(const $ of g.tabs)if($.apiObject===d)return $}h(d){return this.e.find(g=>g.apiObject===d)}async i(d,g){const $=[];for(const i of d){const o=this.g(i);if(!o)throw new Error("Tab close: Invalid tab not found!");$.push(o.tabId)}return this.a.$closeTab($,g)}async j(d,g){const $=[];for(const i of d){const o=this.h(i);if(!o)throw new Error("Group close: Invalid group not found!");$.push(o.groupId)}return this.a.$closeGroup($,g)}};e.$snc=A,e.$snc=A=Ze([Ve(0,p.$ZO)],A);function w(a){return a.tabs!==void 0}}),define(Ee[351],Se([1,0,2,6,28,3,8,17,201,13,27,22,26,86]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=void 0;class w{constructor(){this.a=[]}add(g){this.b=void 0,this.a.push(g)}delete(g){const $=this.a.indexOf(g);$>=0&&(this.a.splice($,1),this.b=void 0)}c(){if(!this.b){const g=this.a.sort(),$=[];let i,o,n=p.State.LastKnownState,t=p.State.LastKnownState;for(const c of g){let h=i?(0,l.$Df)(i,c):0;for(h===0?o=p.State.Start:o=t;h<c.length;h++)h+1===c.length?(n=t,t=p.State.BeforeColon):t+=1,$.push([o,c.toUpperCase().charCodeAt(h),t]),$.push([o,c.toLowerCase().charCodeAt(h),t]),o=t;i=c,t=n}$.push([p.State.BeforeColon,I.CharCode.Colon,p.State.AfterColon]),$.push([p.State.AfterColon,I.CharCode.Slash,p.State.End]),this.b=new p.$$2($)}}provideDocumentLinks(g){this.c();const $=[],i=p.$_2.computeLinks({getLineContent(o){return g.lineAt(o-1).text},getLineCount(){return g.lineCount}},this.b);for(const o of i){const n=R.DocumentLink.to(o);n.target&&$.push(n)}return $}}class a{constructor(g,$){this.i=$,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=g.getProxy(u.$vM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(g,$,i,o={}){if(a.j(i),this.d.has($))throw new Error(`a provider for the scheme '${$}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(g,"*",this.b));const n=this.h++;this.b.add($),this.d.add($),this.c.set(n,i);let t=P.FileSystemProviderCapabilities.FileReadWrite;o.isCaseSensitive&&(t+=P.FileSystemProviderCapabilities.PathCaseSensitive),o.isReadonly&&(t+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(t+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,f.$VG)(g,"fsChunks"),t+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let c;o.isReadonly&&(0,A.$Zk)(o.isReadonly)&&o.isReadonly.value!==""&&(c={value:o.isReadonly.value,isTrusted:o.isReadonly.isTrusted,supportThemeIcons:o.isReadonly.supportThemeIcons,supportHtml:o.isReadonly.supportHtml,baseUri:o.isReadonly.baseUri,uris:o.isReadonly.uris}),this.a.$registerFileSystemProvider(n,$,t,c).catch(s=>{console.error(`FAILED to register filesystem provider of ${g.identifier.value}-extension for the scheme ${$}`),console.error(s)});const h=i.onDidChangeFile(s=>{const m=[];for(const y of s){const{uri:S,type:E}=y;if(S.scheme!==$)continue;let k;switch(E){case L.FileChangeType.Changed:k=P.FileChangeType.UPDATED;break;case L.FileChangeType.Created:k=P.FileChangeType.ADDED;break;case L.FileChangeType.Deleted:k=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}m.push({resource:S,type:k})}this.a.$onFileSystemChange(n,m)});return(0,T.$Sc)(()=>{h.dispose(),this.b.delete($),this.d.delete($),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(g){if(!g)throw new Error("MISSING provider");if(typeof g.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof g.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof g.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof g.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof g.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof g.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof g.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof g.rename!="function")throw new Error("Provider does NOT implement rename")}static k(g){const{type:$,ctime:i,mtime:o,size:n,permissions:t}=g;return{type:$,ctime:i,mtime:o,size:n,permissions:t}}$stat(g,$){return Promise.resolve(this.l(g).stat(r.URI.revive($))).then(i=>a.k(i))}$readdir(g,$){return Promise.resolve(this.l(g).readDirectory(r.URI.revive($)))}$readFile(g,$){return Promise.resolve(this.l(g).readFile(r.URI.revive($))).then(i=>D.$Je.wrap(i))}$writeFile(g,$,i,o){return Promise.resolve(this.l(g).writeFile(r.URI.revive($),i.buffer,o))}$delete(g,$,i){return Promise.resolve(this.l(g).delete(r.URI.revive($),i))}$rename(g,$,i,o){return Promise.resolve(this.l(g).rename(r.URI.revive($),r.URI.revive(i),o))}$copy(g,$,i,o){const n=this.l(g);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(r.URI.revive($),r.URI.revive(i),o))}$mkdir(g,$){return Promise.resolve(this.l(g).createDirectory(r.URI.revive($)))}$watch(g,$,i,o){const n=this.l(g).watch(r.URI.revive(i),o);this.f.set($,n)}$unwatch(g,$){const i=this.f.get($);i&&(i.dispose(),this.f.delete($))}$open(g,$,i){const o=this.l(g);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(r.URI.revive($),i))}$close(g,$){const i=this.l(g);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close($))}$read(g,$,i,o){const n=this.l(g);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const t=D.$Je.alloc(o);return Promise.resolve(n.read($,i,t.buffer,0,o)).then(c=>t.slice(0,c))}$write(g,$,i,o){const n=this.l(g);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write($,i,o.buffer,0,o.byteLength))}l(g){const $=this.c.get(g);if(!$){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return $}}e.$0nc=a}),define(Ee[352],Se([1,0,4,39,2,6,17,8,28,49]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,a,d,g,$,i){this.a=Math.random(),this.b=new r.$he,this.c=new r.$he,this.d=new r.$he,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const o=(0,u.$uk)($),n=typeof $=="string",t=i?.correlate,c=g(h=>{if(!(typeof h.session=="number"&&h.session!==this.a)&&!(t&&typeof h.session>"u")){if(!i?.ignoreCreateEvents)for(const s of h.created){const m=P.URI.revive(s);o(m.fsPath)&&(!n||a.getWorkspaceFolder(m))&&this.b.fire(m)}if(!i?.ignoreChangeEvents)for(const s of h.changed){const m=P.URI.revive(s);o(m.fsPath)&&(!n||a.getWorkspaceFolder(m))&&this.c.fire(m)}if(!i?.ignoreDeleteEvents)for(const s of h.deleted){const m=P.URI.revive(s);o(m.fsPath)&&(!n||a.getWorkspaceFolder(m))&&this.d.fire(m)}}});this.g=R.$xM.from(this.i(w,d,$,i,i?.correlate),this.b,this.c,this.d,c)}i(w,a,d,g,$){const i=R.$xM.from();if(typeof d=="string"||g?.ignoreChangeEvents&&g?.ignoreCreateEvents&&g?.ignoreDeleteEvents)return i;const o=w.getProxy(T.$vM.MainThreadFileSystemEventService);let n=!1;(d.pattern.includes(u.$qk)||d.pattern.includes(u.$rk))&&(n=!0);let t;return $&&(g?.ignoreChangeEvents||g?.ignoreCreateEvents||g?.ignoreDeleteEvents)&&(t=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,g?.ignoreChangeEvents&&(t&=~p.FileChangeFilter.UPDATED),g?.ignoreCreateEvents&&(t&=~p.FileChangeFilter.ADDED),g?.ignoreDeleteEvents&&(t&=~p.FileChangeFilter.DELETED)),o.$watch(a.identifier.value,this.a,d.baseUri,{recursive:n,excludes:g?.excludes??[],filter:t},!!$),R.$xM.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class D{constructor(w){this.a=w,this.session=this.a.session,this.b=new l.$V(()=>this.a.created.map(P.URI.revive)),this.c=new l.$V(()=>this.a.changed.map(P.URI.revive)),this.d=new l.$V(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class f{constructor(w,a,d){this.j=w,this.k=a,this.l=d,this.a=new r.$he,this.b=new r.$he,this.c=new r.$he,this.d=new r.$he,this.g=new r.$je,this.h=new r.$je,this.i=new r.$je,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,a,d,g){return new I(this.j,w,a,this.a.event,L.GlobPattern.from(d),g)}$onFileEvent(w){this.a.fire(new D(w))}$onDidRunFileOperation(w,a){switch(w){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:a.map(d=>({oldUri:P.URI.revive(d.source),newUri:P.URI.revive(d.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:a.map(d=>P.URI.revive(d.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:a.map(d=>P.URI.revive(d.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,a){return(d,g,$)=>{const i=function(n){d.call(g,n)};return i.extension=w,a.event(i,void 0,$)}}async $onWillRunFileOperation(w,a,d,g){switch(w){case p.FileOperation.MOVE:return await this.n(this.g,{files:a.map($=>({oldUri:P.URI.revive($.source),newUri:P.URI.revive($.target)}))},d,g);case p.FileOperation.DELETE:return await this.n(this.i,{files:a.map($=>P.URI.revive($.target))},d,g);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:a.map($=>P.URI.revive($.target))},d,g)}}async n(w,a,d,g){const $=new Set,i=[];if(await w.fireAsync(a,g,async(n,t)=>{const c=Date.now(),h=await Promise.resolve(n);h instanceof R.$HM&&(i.push([t.extension,h]),$.add(t.extension.displayName??t.extension.identifier.value)),Date.now()-c>d&&this.k.warn("SLOW file-participant",t.extension.identifier)}),g.isCancellationRequested||i.length===0)return;const o={edits:[]};for(const[,n]of i){const{edits:t}=L.WorkspaceEdit.from(n,{getTextDocumentVersion:c=>this.l.getDocument(c)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(t)}return{edit:o,extensionNames:Array.from($)}}}e.$$nc=f}),define(Ee[353],Se([1,0,19,7,21,14,133,3,25,43,13,18,2,31,194,88,143,234,24,17,8,26,118,6]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class h{constructor(B,q){this.d=B,this.e=q}async provideDocumentSymbols(B,q){const Y=this.d.getDocument(B),_=await this.e.provideDocumentSymbols(Y,q);if(!(0,r.$Kb)(_))return _[0]instanceof o.$RM?_.map(i.DocumentSymbol.from):h.f(_)}static f(B){B=B.slice(0).sort((_,fe)=>{let ve=_.location.range.start.compareTo(fe.location.range.start);return ve===0&&(ve=fe.location.range.end.compareTo(_.location.range.end)),ve});const q=[],Y=[];for(const _ of B){const fe={name:_.name||"!!MISSING: name!!",kind:i.SymbolKind.from(_.kind),tags:_.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:_.containerName,range:i.Range.from(_.location.range),selectionRange:i.Range.from(_.location.range),children:[]};for(;;){if(Y.length===0){Y.push(fe),q.push(fe);break}const ve=Y[Y.length-1];if(A.$dt.containsRange(ve.range,fe.range)&&!A.$dt.equalsRange(ve.range,fe.range)){ve.children?.push(fe),Y.push(fe);break}Y.pop()}}return q}}class s{constructor(B,q,Y,_,fe,ve){this.f=B,this.g=q,this.h=Y,this.j=_,this.k=fe,this.l=ve,this.d=new t.$Qmc("CodeLens"),this.e=new Map}async provideCodeLenses(B,q){const Y=this.f.getDocument(B),_=await this.h.provideCodeLenses(Y,q);if(!_||q.isCancellationRequested)return;const fe=this.d.add(_),ve=new R.$Tc;this.e.set(fe,ve);const Ne={cacheId:fe,lenses:[]};for(let Be=0;Be<_.length;Be++)Ne.lenses.push({cacheId:[fe,Be],range:i.Range.from(_[Be].range),command:this.g.toInternal(_[Be].command,ve)});return Ne}async resolveCodeLens(B,q){const Y=B.cacheId&&this.d.get(...B.cacheId);if(!Y)return;let _;if(typeof this.h.resolveCodeLens!="function"||Y.isResolved?_=Y:_=await this.h.resolveCodeLens(Y,q),_||(_=Y),q.isCancellationRequested)return;const fe=B.cacheId&&this.e.get(B.cacheId[0]);if(fe){if(!_.command){const ve=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ve),this.l.error(ve);return}return B.command=this.g.toInternal(_.command,fe),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function m(Te){return Array.isArray(Te)?Te.map(i.DefinitionLink.from):Te?[i.DefinitionLink.from(Te)]:[]}class y{constructor(B,q){this.d=B,this.e=q}async provideDefinition(B,q,Y){const _=this.d.getDocument(B),fe=i.Position.to(q),ve=await this.e.provideDefinition(_,fe,Y);return m(ve)}}class S{constructor(B,q){this.d=B,this.e=q}async provideDeclaration(B,q,Y){const _=this.d.getDocument(B),fe=i.Position.to(q),ve=await this.e.provideDeclaration(_,fe,Y);return m(ve)}}class E{constructor(B,q){this.d=B,this.e=q}async provideImplementation(B,q,Y){const _=this.d.getDocument(B),fe=i.Position.to(q),ve=await this.e.provideImplementation(_,fe,Y);return m(ve)}}class k{constructor(B,q){this.d=B,this.e=q}async provideTypeDefinition(B,q,Y){const _=this.d.getDocument(B),fe=i.Position.to(q),ve=await this.e.provideTypeDefinition(_,fe,Y);return m(ve)}}class C{constructor(B,q){this.g=B,this.h=q,this.d=0,this.e=new Map}async provideHover(B,q,Y,_){const fe=this.g.getDocument(B),ve=i.Position.to(q);let Ne;if(Y&&Y.verbosityRequest){const tt=Y.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const ot={verbosityDelta:Y.verbosityRequest.verbosityDelta,previousHover:nt};Ne=await this.h.provideHover(fe,ve,_,ot)}else Ne=await this.h.provideHover(fe,ve,_);if(!Ne||(0,r.$Kb)(Ne.contents))return;Ne.range||(Ne.range=fe.getWordRangeAtPosition(ve)),Ne.range||(Ne.range=new o.$zM(ve,ve));const Be=i.Hover.from(Ne),Qe=this.d;if(this.e.size===C.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Qe,Ne),this.d+=1,{...Be,id:Qe}}releaseHover(B){this.e.delete(B)}}C.f=10;class v{constructor(B,q){this.d=B,this.e=q}async provideEvaluatableExpression(B,q,Y){const _=this.d.getDocument(B),fe=i.Position.to(q),ve=await this.e.provideEvaluatableExpression(_,fe,Y);if(ve)return i.EvaluatableExpression.from(ve)}}class b{constructor(B,q){this.d=B,this.e=q}async provideInlineValues(B,q,Y,_){const fe=this.d.getDocument(B),ve=await this.e.provideInlineValues(fe,i.Range.to(q),i.InlineValueContext.to(Y),_);if(Array.isArray(ve))return ve.map(Ne=>i.InlineValue.from(Ne))}}class O{constructor(B,q){this.d=B,this.e=q}async provideDocumentHighlights(B,q,Y){const _=this.d.getDocument(B),fe=i.Position.to(q),ve=await this.e.provideDocumentHighlights(_,fe,Y);if(Array.isArray(ve))return ve.map(i.DocumentHighlight.from)}}class U{constructor(B,q){this.d=B,this.e=q}async provideMultiDocumentHighlights(B,q,Y,_){const fe=this.d.getDocument(B),ve=Y.map(Qe=>this.d.getDocument(Qe)),Ne=i.Position.to(q),Be=await this.e.provideMultiDocumentHighlights(fe,Ne,ve,_);if(Array.isArray(Be))return Be.map(i.MultiDocumentHighlight.from)}}class z{constructor(B,q){this.d=B,this.e=q}async provideLinkedEditingRanges(B,q,Y){const _=this.d.getDocument(B),fe=i.Position.to(q),ve=await this.e.provideLinkedEditingRanges(_,fe,Y);if(ve&&Array.isArray(ve.ranges))return{ranges:(0,r.$Hb)(ve.ranges.map(i.Range.from)),wordPattern:ve.wordPattern}}}class j{constructor(B,q){this.d=B,this.e=q}async provideReferences(B,q,Y,_){const fe=this.d.getDocument(B),ve=i.Position.to(q),Ne=await this.e.provideReferences(fe,ve,Y,_);if(Array.isArray(Ne))return Ne.map(i.location.from)}}class M{constructor(B,q,Y,_,fe,ve,Ne){this.g=B,this.h=q,this.j=Y,this.k=_,this.l=fe,this.m=ve,this.n=Ne,this.e=new t.$Qmc("CodeAction"),this.f=new Map}async provideCodeActions(B,q,Y,_){const fe=this.g.getDocument(B),ve=w.$ft.isISelection(q)?i.Selection.to(q):i.Range.to(q),Ne=[];for(const ot of this.j.getDiagnostics(B))if(ve.intersection(ot.range)&&Ne.push(ot)>M.d)break;const Be={diagnostics:Ne,only:Y.only?new o.$TM(Y.only):void 0,triggerKind:i.CodeActionTriggerKind.to(Y.trigger)},Qe=await this.k.provideCodeActions(fe,ve,Be,_);if(!(0,r.$Lb)(Qe)||_.isCancellationRequested)return;const He=this.e.add(Qe),tt=new R.$Tc;this.f.set(He,tt);const nt=[];for(let ot=0;ot<Qe.length;ot++){const at=Qe[ot];if(at)if(M.o(at))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:at.title,command:this.h.toInternal(at,tt)});else{Be.only&&(at.kind?Be.only.contains(at.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${at.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const pt=at.ranges??[];nt.push({cacheId:[He,ot],title:at.title,command:at.command&&this.h.toInternal(at.command,tt),diagnostics:at.diagnostics&&at.diagnostics.map(i.Diagnostic.from),edit:at.edit&&i.WorkspaceEdit.from(at.edit,void 0),kind:at.kind&&at.kind.value,isPreferred:at.isPreferred,isAI:(0,n.$UG)(this.m,"codeActionAI")?at.isAI:!1,ranges:(0,n.$UG)(this.m,"codeActionRanges")?(0,r.$Hb)(pt.map(i.Range.from)):void 0,disabled:at.disabled?.reason})}}return{cacheId:He,actions:nt}}async resolveCodeAction(B,q){const[Y,_]=B,fe=this.e.get(Y,_);if(!fe||M.o(fe))return{};if(!this.k.resolveCodeAction)return{};const ve=await this.k.resolveCodeAction(fe,q)??fe;let Ne;ve.edit&&(Ne=i.WorkspaceEdit.from(ve.edit,void 0));let Be;if(ve.command){const Qe=this.f.get(Y);Qe&&(Be=this.h.toInternal(ve.command,Qe))}return{edit:Ne,command:Be}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}M.d=1e3;class N{constructor(B,q,Y,_,fe){this.e=B,this.f=q,this.g=Y,this.h=_,this.j=fe,this.d=new t.$Qmc("DocumentPasteEdit")}async prepareDocumentPaste(B,q,Y,_){if(!this.g.prepareDocumentPaste)return;const fe=this.f.getDocument(B),ve=q.map(Qe=>i.Range.to(Qe)),Ne=i.DataTransfer.toDataTransfer(Y,()=>{throw new T.$$});if(await this.g.prepareDocumentPaste(fe,ve,Ne,_),_.isCancellationRequested)return;const Be=Array.from(Ne).filter(([,Qe])=>!(Qe instanceof o.$nN));return i.DataTransfer.from(Be)}async providePasteEdits(B,q,Y,_,fe,ve){if(!this.g.provideDocumentPasteEdits)return[];const Ne=this.f.getDocument(q),Be=Y.map(nt=>i.Range.to(nt)),Qe=i.DataTransfer.toDataTransfer(_,async nt=>(await this.e.$resolvePasteFileData(this.h,B,nt)).buffer),He=await this.g.provideDocumentPasteEdits(Ne,Be,Qe,{only:fe.only?new o.$sN(fe.only):void 0,triggerKind:fe.triggerKind},ve);if(!He||ve.isCancellationRequested)return[];const tt=this.d.add(He);return He.map((nt,ot)=>({_cacheId:[tt,ot],title:nt.title??(0,g.localize)(0,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(at=>at.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,q){const[Y,_]=B,fe=this.d.get(Y,_);if(!fe||!this.g.resolveDocumentPasteEdit)return{};const ve=await this.g.resolveDocumentPasteEdit(fe,q)??fe;return{additionalEdit:ve.additionalEdit?i.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}releasePasteEdits(B){this.d.delete(B)}}class F{constructor(B,q){this.d=B,this.e=q}async provideDocumentFormattingEdits(B,q,Y){const _=this.d.getDocument(B),fe=await this.e.provideDocumentFormattingEdits(_,q,Y);if(Array.isArray(fe))return fe.map(i.TextEdit.from)}}class X{constructor(B,q){this.d=B,this.e=q}async provideDocumentRangeFormattingEdits(B,q,Y,_){const fe=this.d.getDocument(B),ve=i.Range.to(q),Ne=await this.e.provideDocumentRangeFormattingEdits(fe,ve,Y,_);if(Array.isArray(Ne))return Ne.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,q,Y,_){(0,D.$kg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const fe=this.d.getDocument(B),ve=q.map(i.Range.to),Ne=await this.e.provideDocumentRangesFormattingEdits(fe,ve,Y,_);if(Array.isArray(Ne))return Ne.map(i.TextEdit.from)}}class se{constructor(B,q){this.d=B,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,q,Y,_,fe){const ve=this.d.getDocument(B),Ne=i.Position.to(q),Be=await this.e.provideOnTypeFormattingEdits(ve,Ne,Y,_,fe);if(Array.isArray(Be))return Be.map(i.TextEdit.from)}}class W{constructor(B,q){this.e=B,this.f=q,this.d=new t.$Qmc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,q){const Y=await this.e.provideWorkspaceSymbols(B,q);if(!(0,r.$Lb)(Y))return{symbols:[]};const _=this.d.add(Y),fe={cacheId:_,symbols:[]};for(let ve=0;ve<Y.length;ve++){const Ne=Y[ve];if(!Ne||!Ne.name){this.f.warn("INVALID SymbolInformation",Ne);continue}fe.symbols.push({...i.WorkspaceSymbol.from(Ne),cacheId:[_,ve]})}return fe}async resolveWorkspaceSymbol(B,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const Y=this.d.get(...B.cacheId);if(Y){const _=await this.e.resolveWorkspaceSymbol(Y,q);return _&&(0,p.$ao)(B,i.WorkspaceSymbol.from(_),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class H{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,q,Y){this.d=B,this.e=q,this.f=Y}async provideRenameEdits(B,q,Y,_){const fe=this.d.getDocument(B),ve=i.Position.to(q);try{const Ne=await this.e.provideRenameEdits(fe,ve,Y,_);return Ne?i.WorkspaceEdit.from(Ne):void 0}catch(Ne){const Be=H.g(Ne);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Ne)}}async resolveRenameLocation(B,q,Y){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const _=this.d.getDocument(B),fe=i.Position.to(q);try{const ve=await this.e.prepareRename(_,fe,Y);let Ne,Be;if(o.$zM.isRange(ve)?(Ne=ve,Be=_.getText(ve)):(0,D.$cg)(ve)&&(Ne=ve.range,Be=ve.placeholder),!Ne||!Be)return;if(Ne.start.line>fe.line||Ne.end.line<fe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ne),text:Be}}catch(ve){const Ne=H.g(ve);return Ne?{rejectReason:Ne,range:void 0,text:void 0}:Promise.reject(ve)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class V{constructor(B,q,Y){this.e=B,this.f=q,this.g=Y}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(B,q,Y,_){const fe=this.e.getDocument(B),ve=i.Range.to(q);try{const Ne=V.d[Y],Be=await this.f.provideNewSymbolNames(fe,ve,Ne,_);return Be?Be.map(Qe=>typeof Qe=="string"?{newSymbolName:Qe}:{newSymbolName:Qe.newSymbolName,tags:Qe.tags}):void 0}catch(Ne){this.g.error(V.h(Ne)??JSON.stringify(Ne,null,"	"));return}}static h(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}V.d={[a.NewSymbolNameTriggerKind.Invoke]:o.NewSymbolNameTriggerKind.Invoke,[a.NewSymbolNameTriggerKind.Automatic]:o.NewSymbolNameTriggerKind.Automatic};class x{constructor(B,q){this.resultId=B,this.tokens=q}}class he{constructor(B,q){this.f=B,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,q,Y){const _=this.f.getDocument(B),fe=q!==0?this.d.get(q):null;let ve=typeof fe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(_,fe.resultId,Y):await this.g.provideDocumentSemanticTokens(_,Y);return fe&&this.d.delete(q),ve?(ve=he.h(ve),this.o(he.n(fe,ve),ve)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return he.j(B)?he.k(B)?B:new o.$SN(new Uint32Array(B.data),B.resultId):he.l(B)?he.m(B)?B:new o.$UN(B.edits.map(q=>new o.$TN(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const q of B.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(B,q){if(!he.j(q)||!B||!B.tokens)return q;const Y=B.tokens,_=Y.length,fe=q.data,ve=fe.length;let Ne=0;const Be=Math.min(_,ve);for(;Ne<Be&&Y[Ne]===fe[Ne];)Ne++;if(Ne===_&&Ne===ve)return new o.$UN([],q.resultId);let Qe=0;const He=Be-Ne;for(;Qe<He&&Y[_-Qe-1]===fe[ve-Qe-1];)Qe++;return new o.$UN([{start:Ne,deleteCount:_-Ne-Qe,data:fe.subarray(Ne,ve-Qe)}],q.resultId)}o(B,q){if(he.j(B)){const Y=this.e++;return this.d.set(Y,new x(B.resultId,B.data)),(0,d.$$bb)({id:Y,type:"full",data:B.data})}if(he.l(B)){const Y=this.e++;return he.j(q)?this.d.set(Y,new x(q.resultId,q.data)):this.d.set(Y,new x(B.resultId)),(0,d.$$bb)({id:Y,type:"delta",deltas:(B.edits||[]).map(_=>({start:_.start,deleteCount:_.deleteCount,data:_.data}))})}return null}}class ne{constructor(B,q){this.d=B,this.e=q}async provideDocumentRangeSemanticTokens(B,q,Y){const _=this.d.getDocument(B),fe=await this.e.provideDocumentRangeSemanticTokens(_,i.Range.to(q),Y);return fe?this.f(fe):null}f(B){return(0,d.$$bb)({id:0,type:"full",data:B.data})}}class we{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,q,Y,_,fe){this.f=B,this.g=q,this.h=Y,this.j=_,this.k=fe,this.d=new t.$Qmc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,q,Y,_){const fe=this.f.getDocument(B),ve=i.Position.to(q),Ne=fe.getWordRangeAtPosition(ve)||new o.$zM(ve,ve),Be=Ne.with({end:ve}),Qe=new l.$be,He=await this.h.provideCompletionItems(fe,ve,_,i.CompletionContext.to(Y));if(!He||_.isCancellationRequested)return;const tt=Array.isArray(He)?new o.$7M(He):He,nt=we.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),ot=new R.$Tc;this.e.set(nt,ot);const at=[],pt={x:nt,[c.ISuggestResultDtoField.completions]:at,[c.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ne),insert:i.Range.from(Be)},[c.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[c.ISuggestResultDtoField.duration]:Qe.elapsed()};for(let ft=0;ft<tt.items.length;ft++){const st=tt.items[ft],ht=this.l(st,[nt,ft],Be,Ne);at.push(ht)}return pt}async resolveCompletionItem(B,q){if(typeof this.h.resolveCompletionItem!="function")return;const Y=this.d.get(...B);if(!Y)return;const _=this.l(Y,B),fe=await this.h.resolveCompletionItem(Y,q);if(!fe)return;const ve=this.l(fe,B);return(_[c.ISuggestDataDtoField.insertText]!==ve[c.ISuggestDataDtoField.insertText]||_[c.ISuggestDataDtoField.insertTextRules]!==ve[c.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(_[c.ISuggestDataDtoField.commandIdent]!==ve[c.ISuggestDataDtoField.commandIdent]||_[c.ISuggestDataDtoField.commandId]!==ve[c.ISuggestDataDtoField.commandId]||!(0,p.$bo)(_[c.ISuggestDataDtoField.commandArguments],ve[c.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{..._,[c.ISuggestDataDtoField.documentation]:ve[c.ISuggestDataDtoField.documentation],[c.ISuggestDataDtoField.detail]:ve[c.ISuggestDataDtoField.detail],[c.ISuggestDataDtoField.additionalTextEdits]:ve[c.ISuggestDataDtoField.additionalTextEdits],[c.ISuggestDataDtoField.insertText]:ve[c.ISuggestDataDtoField.insertText],[c.ISuggestDataDtoField.insertTextRules]:ve[c.ISuggestDataDtoField.insertTextRules],[c.ISuggestDataDtoField.commandIdent]:ve[c.ISuggestDataDtoField.commandIdent],[c.ISuggestDataDtoField.commandId]:ve[c.ISuggestDataDtoField.commandId],[c.ISuggestDataDtoField.commandArguments]:ve[c.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,q,Y,_){const fe=this.e.get(q[0]);if(!fe)throw Error("DisposableStore is missing...");const ve=this.g.toInternal(B.command,fe),Ne={x:q,[c.ISuggestDataDtoField.label]:B.label,[c.ISuggestDataDtoField.kind]:B.kind!==void 0?i.CompletionItemKind.from(B.kind):void 0,[c.ISuggestDataDtoField.kindModifier]:B.tags&&B.tags.map(i.CompletionItemTag.from),[c.ISuggestDataDtoField.detail]:B.detail,[c.ISuggestDataDtoField.documentation]:typeof B.documentation>"u"?void 0:i.MarkdownString.fromStrict(B.documentation),[c.ISuggestDataDtoField.sortText]:B.sortText!==B.label?B.sortText:void 0,[c.ISuggestDataDtoField.filterText]:B.filterText!==B.label?B.filterText:void 0,[c.ISuggestDataDtoField.preselect]:B.preselect||void 0,[c.ISuggestDataDtoField.insertTextRules]:B.keepWhitespace?a.CompletionItemInsertTextRule.KeepWhitespace:a.CompletionItemInsertTextRule.None,[c.ISuggestDataDtoField.commitCharacters]:B.commitCharacters?.join(""),[c.ISuggestDataDtoField.additionalTextEdits]:B.additionalTextEdits&&B.additionalTextEdits.map(i.TextEdit.from),[c.ISuggestDataDtoField.commandIdent]:ve?.$ident,[c.ISuggestDataDtoField.commandId]:ve?.id,[c.ISuggestDataDtoField.commandArguments]:ve?.$ident?void 0:ve?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ne[c.ISuggestDataDtoField.insertText]=B.textEdit.newText):typeof B.insertText=="string"?Ne[c.ISuggestDataDtoField.insertText]=B.insertText:B.insertText instanceof o.$IM&&(Ne[c.ISuggestDataDtoField.insertText]=B.insertText.value,Ne[c.ISuggestDataDtoField.insertTextRules]|=a.CompletionItemInsertTextRule.InsertAsSnippet);let Be;return B.textEdit?Be=B.textEdit.range:B.range&&(Be=B.range),o.$zM.isRange(Be)?Ne[c.ISuggestDataDtoField.range]=i.Range.from(Be):Be&&(!Y?.isEqual(Be.inserting)||!_?.isEqual(Be.replacing))&&(Ne[c.ISuggestDataDtoField.range]={insert:i.Range.from(Be.inserting),replace:i.Range.from(Be.replacing)}),Ne}}class pe{async provideInlineCompletions(B,q,Y,_){}disposeCompletions(B){}handleDidShowCompletionItem(B,q,Y){}handlePartialAccept(B,q,Y,_){}}class ce extends pe{constructor(B,q,Y,_){super(),this.f=B,this.g=q,this.h=Y,this.j=_,this.d=new de,this.e=(0,n.$UG)(this.f,"inlineCompletionsAdditions"),this.k={[a.InlineCompletionTriggerKind.Automatic]:o.InlineCompletionTriggerKind.Automatic,[a.InlineCompletionTriggerKind.Explicit]:o.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$UG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,q,Y,_){const fe=this.g.getDocument(B),ve=i.Position.to(q),Ne=await this.h.provideInlineCompletionItems(fe,ve,{selectedCompletionInfo:Y.selectedSuggestionInfo?{range:i.Range.to(Y.selectedSuggestionInfo.range),text:Y.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[Y.triggerKind]},_);if(!Ne||_.isCancellationRequested)return;const Be=Array.isArray(Ne)?Ne:Ne.items,Qe=this.e?Array.isArray(Ne)?[]:Ne.commands||[]:[],He=this.e&&!Array.isArray(Ne)?Ne.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:Be}),items:Be.map((ot,at)=>{let pt;ot.command&&(tt||(tt=new R.$Tc),pt=this.j.toInternal(ot.command,tt));const ft=ot.insertText;return{insertText:typeof ft=="string"?ft:{snippet:ft.value},filterText:ot.filterText,range:ot.range?i.Range.from(ot.range):void 0,command:pt,idx:at,completeBracketPairs:this.e?ot.completeBracketPairs:!1}}),commands:Qe.map(ot=>(tt||(tt=new R.$Tc),this.j.toInternal(ot,tt))),suppressSuggestions:!1,enableForwardStability:He}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,q,Y){const _=this.d.get(B)?.items[q];_&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(_,Y)}handlePartialAccept(B,q,Y,_){const fe=this.d.get(B)?.items[q];fe&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(fe,Y),this.h.handleDidPartiallyAcceptCompletionItem(fe,i.PartialAcceptInfo.to(_)))}}class K{async provideInlineEdits(B,q,Y){const _=this.f.getDocument(B),fe=await this.g.provideInlineEdit(_,{triggerKind:this.e[q.triggerKind]},Y);if(!fe||Y.isCancellationRequested)return;let ve;const Ne=this.d.createReferenceId({dispose(){ve?.dispose()},item:fe});let Be;fe.accepted&&(ve||(ve=new R.$Tc),Be=this.h.toInternal(fe.accepted,ve));let Qe;return fe.rejected&&(ve||(ve=new R.$Tc),Qe=this.h.toInternal(fe.rejected,ve)),{pid:Ne,text:fe.text,range:i.Range.from(fe.range),accepted:Be,rejected:Qe}}disposeEdit(B){this.d.disposeReferenceId(B)?.dispose()}constructor(B,q,Y,_){this.f=q,this.g=Y,this.h=_,this.d=new de,this.e={[a.InlineEditTriggerKind.Automatic]:o.InlineEditTriggerKind.Automatic,[a.InlineEditTriggerKind.Invoke]:o.InlineEditTriggerKind.Invoke}}}class de{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const q=this.e++;return this.d.set(q,B),q}disposeReferenceId(B){const q=this.d.get(B);return this.d.delete(B),q}get(B){return this.d.get(B)}}class te{constructor(B,q){this.e=B,this.f=q,this.d=new t.$Qmc("SignatureHelp")}async provideSignatureHelp(B,q,Y,_){const fe=this.e.getDocument(B),ve=i.Position.to(q),Ne=this.g(Y),Be=await this.f.provideSignatureHelp(fe,ve,_,Ne);if(Be){const Qe=this.d.add([Be]);return{...i.SignatureHelp.from(Be),id:Qe}}}g(B){let q;if(B.activeSignatureHelp){const Y=i.SignatureHelp.to(B.activeSignatureHelp),_=this.d.get(B.activeSignatureHelp.id,0);_?(q=_,q.activeSignature=Y.activeSignature,q.activeParameter=Y.activeParameter):q=Y}return{...B,activeSignatureHelp:q}}releaseSignatureHelp(B){this.d.delete(B)}}class ee{constructor(B,q,Y,_,fe){this.f=B,this.g=q,this.h=Y,this.j=_,this.k=fe,this.d=new t.$Qmc("InlayHints"),this.e=new Map}async provideInlayHints(B,q,Y){const _=this.f.getDocument(B),fe=i.Range.to(q),ve=await this.h.provideInlayHints(_,fe,Y);if(!Array.isArray(ve)||ve.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`);return}if(Y.isCancellationRequested)return;const Ne=this.d.add(ve);this.e.set(Ne,new R.$Tc);const Be={hints:[],cacheId:Ne};for(let Qe=0;Qe<ve.length;Qe++)this.l(ve[Qe],fe)&&Be.hints.push(this.m(ve[Qe],[Ne,Qe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(q)}`),Be}async resolveInlayHint(B,q){if(typeof this.h.resolveInlayHint!="function")return;const Y=this.d.get(...B);if(!Y)return;const _=await this.h.resolveInlayHint(Y,q);if(_&&this.l(_))return this.m(_,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,q){return B.label.length===0||Array.isArray(B.label)&&B.label.every(Y=>Y.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(q&&!q.contains(B.position))}m(B,q){const Y=this.e.get(q[0]);if(!Y)throw Error("DisposableStore is missing...");const _={label:"",cacheId:q,tooltip:i.MarkdownString.fromStrict(B.tooltip),position:i.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(i.TextEdit.from),kind:B.kind&&i.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")_.label=B.label;else{const fe=[];_.label=fe;for(const ve of B.label){if(!ve.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ne={label:ve.value,tooltip:i.MarkdownString.fromStrict(ve.tooltip)};o.$JM.isLocation(ve.location)&&(Ne.location=i.location.from(ve.location)),ve.command&&(Ne.command=this.g.toInternal(ve.command,Y)),fe.push(Ne)}}return _}}class ie{constructor(B,q){this.e=B,this.f=q,this.d=new t.$Qmc("DocumentLink")}async provideLinks(B,q){const Y=this.e.getDocument(B),_=await this.f.provideDocumentLinks(Y,q);if(!(!Array.isArray(_)||_.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:_.filter(ie.g).map(i.DocumentLink.from)};{const fe=this.d.add(_),ve={links:[],cacheId:fe};for(let Ne=0;Ne<_.length;Ne++){if(!ie.g(_[Ne]))continue;const Be=i.DocumentLink.from(_[Ne]);Be.cacheId=[fe,Ne],ve.links.push(Be)}return ve}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,q){if(typeof this.f.resolveDocumentLink!="function")return;const Y=this.d.get(...B);if(!Y)return;const _=await this.f.resolveDocumentLink(Y,q);if(!(!_||!ie.g(_)))return i.DocumentLink.from(_)}releaseLinks(B){this.d.delete(B)}}class le{constructor(B,q){this.d=B,this.e=q}async provideColors(B,q){const Y=this.d.getDocument(B),_=await this.e.provideDocumentColors(Y,q);return Array.isArray(_)?_.map(ve=>({color:i.Color.from(ve.color),range:i.Range.from(ve.range)})):[]}async provideColorPresentations(B,q,Y){const _=this.d.getDocument(B),fe=i.Range.to(q.range),ve=i.Color.to(q.color),Ne=await this.e.provideColorPresentations(ve,{document:_,range:fe},Y);if(Array.isArray(Ne))return Ne.map(i.ColorPresentation.from)}}class Z{constructor(B,q){this.d=B,this.e=q}async provideFoldingRanges(B,q,Y){const _=this.d.getDocument(B),fe=await this.e.provideFoldingRanges(_,q,Y);if(Array.isArray(fe))return fe.map(i.FoldingRange.from)}}class ae{constructor(B,q,Y){this.d=B,this.e=q,this.f=Y}async provideSelectionRanges(B,q,Y){const _=this.d.getDocument(B),fe=q.map(i.Position.to),ve=await this.e.provideSelectionRanges(_,fe,Y);if(!(0,r.$Lb)(ve))return[];if(ve.length!==fe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ne=[];for(let Be=0;Be<fe.length;Be++){const Qe=[];Ne.push(Qe);let He=fe[Be],tt=ve[Be];for(;;){if(!tt.range.contains(He))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(tt)),!tt.parent)break;He=tt.range,tt=tt.parent}}return Ne}}class $e{constructor(B,q){this.f=B,this.g=q,this.d=new L.$5O(""),this.e=new Map}async prepareSession(B,q,Y){const _=this.f.getDocument(B),fe=i.Position.to(q),ve=await this.g.prepareCallHierarchy(_,fe,Y);if(!ve)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(ve)?ve.map(Be=>this.h(Ne,Be)):[this.h(Ne,ve)]}async provideCallsTo(B,q,Y){const _=this.j(B,q);if(!_)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyIncomingCalls(_,Y);if(fe)return fe.map(ve=>({from:this.h(B,ve.from),fromRanges:ve.fromRanges.map(Ne=>i.Range.from(Ne))}))}async provideCallsFrom(B,q,Y){const _=this.j(B,q);if(!_)throw new Error("missing call hierarchy item");const fe=await this.g.provideCallHierarchyOutgoingCalls(_,Y);if(fe)return fe.map(ve=>({to:this.h(B,ve.to),fromRanges:ve.fromRanges.map(Ne=>i.Range.from(Ne))}))}releaseSession(B){this.e.delete(B)}h(B,q){const Y=this.e.get(B),_=i.CallHierarchyItem.from(q,B,Y.size.toString(36));return Y.set(_._itemId,q),_}j(B,q){return this.e.get(B)?.get(q)}}class be{constructor(B,q){this.f=B,this.g=q,this.d=new L.$5O(""),this.e=new Map}async prepareSession(B,q,Y){const _=this.f.getDocument(B),fe=i.Position.to(q),ve=await this.g.prepareTypeHierarchy(_,fe,Y);if(!ve)return;const Ne=this.d.nextId();return this.e.set(Ne,new Map),Array.isArray(ve)?ve.map(Be=>this.h(Ne,Be)):[this.h(Ne,ve)]}async provideSupertypes(B,q,Y){const _=this.j(B,q);if(!_)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySupertypes(_,Y);if(fe)return fe.map(ve=>this.h(B,ve))}async provideSubtypes(B,q,Y){const _=this.j(B,q);if(!_)throw new Error("missing type hierarchy item");const fe=await this.g.provideTypeHierarchySubtypes(_,Y);if(fe)return fe.map(ve=>this.h(B,ve))}releaseSession(B){this.e.delete(B)}h(B,q){const Y=this.e.get(B),_=i.TypeHierarchyItem.from(q,B,Y.size.toString(36));return Y.set(_._itemId,q),_}j(B,q){return this.e.get(B)?.get(q)}}class Me{constructor(B,q,Y,_,fe){this.e=B,this.f=q,this.g=Y,this.h=_,this.j=fe,this.d=new t.$Qmc("DocumentDropEdit")}async provideDocumentOnDropEdits(B,q,Y,_,fe){const ve=this.f.getDocument(q),Ne=i.Position.to(Y),Be=i.DataTransfer.toDataTransfer(_,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,B,nt)).buffer),Qe=await this.g.provideDocumentDropEdits(ve,Ne,Be,fe);if(!Qe)return;const He=(0,r.$2b)(Qe),tt=this.d.add(He);return He.map((nt,ot)=>({_cacheId:[tt,ot],title:nt.title??(0,g.localize)(1,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(at=>at.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(B,q){const[Y,_]=B,fe=this.d.get(Y,_);if(!fe||!this.g.resolveDocumentDropEdit)return{};const ve=await this.g.resolveDocumentDropEdit(fe,q)??fe;return{additionalEdit:ve.additionalEdit?i.WorkspaceEdit.from(ve.additionalEdit,void 0):void 0}}releaseDropEdits(B){this.d.delete(B)}}class qe{constructor(B,q){this.d=B,this.e=q}async provideMappedEdits(B,q,Y,_){const fe=f.URI.revive(B),ve=this.d.getDocument(fe),Ne=Y.documents.map(He=>He.map(tt=>({uri:f.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),Be={documents:Ne,selections:Ne[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(ve,q,Be,_);return Qe?i.WorkspaceEdit.from(Qe):null}}class De{constructor(B,q){this.adapter=B,this.extension=q}}class Pe{constructor(B,q,Y,_,fe,ve,Ne,Be){this.g=q,this.h=Y,this.j=_,this.k=fe,this.l=ve,this.m=Ne,this.n=Be,this.f=new Map,this.e=B.getProxy(c.$vM.MainThreadLanguageFeatures)}o(B,q){return i.DocumentSelector.from(B,this.g,q)}p(B){return new o.$xM(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return Pe.d++}async s(B,q,Y,_,fe,ve=!1){const Ne=this.f.get(B);if(!Ne||!(Ne.adapter instanceof q))return _;const Be=Date.now();ve||this.l.trace(`[${Ne.extension.identifier.value}] INVOKE provider '${Y.toString().replace(/[\r\n]/g,"")}'`);const Qe=Y(Ne.adapter,Ne.extension);return Promise.resolve(Qe).catch(He=>{(0,T.$4)(He)||(this.l.error(`[${Ne.extension.identifier.value}] provider FAILED`),this.l.error(He),this.n.onExtensionError(Ne.extension.identifier,He))}).finally(()=>{ve||this.l.trace(`[${Ne.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),P.CancellationToken.isCancellationToken(fe)?(0,u.$ph)(Qe,fe):Qe}t(B,q){const Y=this.q();return this.f.set(Y,new De(B,q)),Y}static u(B){return B.displayName||B.name}static w(B){return B.identifier.value}registerDocumentSymbolProvider(B,q,Y,_){const fe=this.t(new h(this.h,Y),B),ve=_&&_.label||Pe.u(B);return this.e.$registerDocumentSymbolProvider(fe,this.o(q,B),ve),this.p(fe)}$provideDocumentSymbols(B,q,Y){return this.s(B,h,_=>_.provideDocumentSymbols(f.URI.revive(q),Y),void 0,Y)}registerCodeLensProvider(B,q,Y){const _=this.q(),fe=typeof Y.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(_,new De(new s(this.h,this.j.converter,Y,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(_,this.o(q,B),fe);let ve=this.p(_);if(fe!==void 0){const Ne=Y.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(fe));ve=o.$xM.from(ve,Ne)}return ve}$provideCodeLenses(B,q,Y){return this.s(B,s,_=>_.provideCodeLenses(f.URI.revive(q),Y),void 0,Y)}$resolveCodeLens(B,q,Y){return this.s(B,s,_=>_.resolveCodeLens(q,Y),void 0,void 0)}$releaseCodeLenses(B,q){this.s(B,s,Y=>Promise.resolve(Y.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(B,q,Y){const _=this.t(new y(this.h,Y),B);return this.e.$registerDefinitionSupport(_,this.o(q,B)),this.p(_)}$provideDefinition(B,q,Y,_){return this.s(B,y,fe=>fe.provideDefinition(f.URI.revive(q),Y,_),[],_)}registerDeclarationProvider(B,q,Y){const _=this.t(new S(this.h,Y),B);return this.e.$registerDeclarationSupport(_,this.o(q,B)),this.p(_)}$provideDeclaration(B,q,Y,_){return this.s(B,S,fe=>fe.provideDeclaration(f.URI.revive(q),Y,_),[],_)}registerImplementationProvider(B,q,Y){const _=this.t(new E(this.h,Y),B);return this.e.$registerImplementationSupport(_,this.o(q,B)),this.p(_)}$provideImplementation(B,q,Y,_){return this.s(B,E,fe=>fe.provideImplementation(f.URI.revive(q),Y,_),[],_)}registerTypeDefinitionProvider(B,q,Y){const _=this.t(new k(this.h,Y),B);return this.e.$registerTypeDefinitionSupport(_,this.o(q,B)),this.p(_)}$provideTypeDefinition(B,q,Y,_){return this.s(B,k,fe=>fe.provideTypeDefinition(f.URI.revive(q),Y,_),[],_)}registerHoverProvider(B,q,Y,_){const fe=this.t(new C(this.h,Y),B);return this.e.$registerHoverProvider(fe,this.o(q,B)),this.p(fe)}$provideHover(B,q,Y,_,fe){return this.s(B,C,ve=>ve.provideHover(f.URI.revive(q),Y,_,fe),void 0,fe)}$releaseHover(B,q){this.s(B,C,Y=>Promise.resolve(Y.releaseHover(q)),void 0,void 0)}registerEvaluatableExpressionProvider(B,q,Y,_){const fe=this.t(new v(this.h,Y),B);return this.e.$registerEvaluatableExpressionProvider(fe,this.o(q,B)),this.p(fe)}$provideEvaluatableExpression(B,q,Y,_){return this.s(B,v,fe=>fe.provideEvaluatableExpression(f.URI.revive(q),Y,_),void 0,_)}registerInlineValuesProvider(B,q,Y,_){const fe=typeof Y.onDidChangeInlineValues=="function"?this.q():void 0,ve=this.t(new b(this.h,Y),B);this.e.$registerInlineValuesProvider(ve,this.o(q,B),fe);let Ne=this.p(ve);if(fe!==void 0){const Be=Y.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(fe));Ne=o.$xM.from(Ne,Be)}return Ne}$provideInlineValues(B,q,Y,_,fe){return this.s(B,b,ve=>ve.provideInlineValues(f.URI.revive(q),Y,_,fe),void 0,fe)}registerDocumentHighlightProvider(B,q,Y){const _=this.t(new O(this.h,Y),B);return this.e.$registerDocumentHighlightProvider(_,this.o(q,B)),this.p(_)}registerMultiDocumentHighlightProvider(B,q,Y){const _=this.t(new U(this.h,Y),B);return this.e.$registerMultiDocumentHighlightProvider(_,this.o(q,B)),this.p(_)}$provideDocumentHighlights(B,q,Y,_){return this.s(B,O,fe=>fe.provideDocumentHighlights(f.URI.revive(q),Y,_),void 0,_)}$provideMultiDocumentHighlights(B,q,Y,_,fe){return this.s(B,U,ve=>ve.provideMultiDocumentHighlights(f.URI.revive(q),Y,_.map(Ne=>f.URI.revive(Ne)),fe),void 0,fe)}registerLinkedEditingRangeProvider(B,q,Y){const _=this.t(new z(this.h,Y),B);return this.e.$registerLinkedEditingRangeProvider(_,this.o(q,B)),this.p(_)}$provideLinkedEditingRanges(B,q,Y,_){return this.s(B,z,async fe=>{const ve=await fe.provideLinkedEditingRanges(f.URI.revive(q),Y,_);if(ve)return{ranges:ve.ranges,wordPattern:ve.wordPattern?Pe.y(ve.wordPattern):void 0}},void 0,_)}registerReferenceProvider(B,q,Y){const _=this.t(new j(this.h,Y),B);return this.e.$registerReferenceSupport(_,this.o(q,B)),this.p(_)}$provideReferences(B,q,Y,_,fe){return this.s(B,j,ve=>ve.provideReferences(f.URI.revive(q),Y,_,fe),void 0,fe)}registerCodeActionProvider(B,q,Y,_){const fe=new R.$Tc,ve=this.t(new M(this.h,this.j.converter,this.k,Y,this.l,B,this.m),B);return this.e.$registerCodeActionSupport(ve,this.o(q,B),{providedKinds:_?.providedCodeActionKinds?.map(Ne=>Ne.value),documentation:_?.documentation?.map(Ne=>({kind:Ne.kind.value,command:this.j.converter.toInternal(Ne.command,fe)}))},Pe.u(B),Pe.w(B),!!Y.resolveCodeAction),fe.add(this.p(ve)),fe}$provideCodeActions(B,q,Y,_,fe){return this.s(B,M,ve=>ve.provideCodeActions(f.URI.revive(q),Y,_,fe),void 0,fe)}$resolveCodeAction(B,q,Y){return this.s(B,M,_=>_.resolveCodeAction(q,Y),{},void 0)}$releaseCodeActions(B,q){this.s(B,M,Y=>Promise.resolve(Y.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(B,q,Y){const _=this.t(new F(this.h,Y),B);return this.e.$registerDocumentFormattingSupport(_,this.o(q,B),B.identifier,B.displayName||B.name),this.p(_)}$provideDocumentFormattingEdits(B,q,Y,_){return this.s(B,F,fe=>fe.provideDocumentFormattingEdits(f.URI.revive(q),Y,_),void 0,_)}registerDocumentRangeFormattingEditProvider(B,q,Y){const _=typeof Y.provideDocumentRangesFormattingEdits=="function",fe=this.t(new X(this.h,Y),B);return this.e.$registerRangeFormattingSupport(fe,this.o(q,B),B.identifier,B.displayName||B.name,_),this.p(fe)}$provideDocumentRangeFormattingEdits(B,q,Y,_,fe){return this.s(B,X,ve=>ve.provideDocumentRangeFormattingEdits(f.URI.revive(q),Y,_,fe),void 0,fe)}$provideDocumentRangesFormattingEdits(B,q,Y,_,fe){return this.s(B,X,ve=>ve.provideDocumentRangesFormattingEdits(f.URI.revive(q),Y,_,fe),void 0,fe)}registerOnTypeFormattingEditProvider(B,q,Y,_){const fe=this.t(new se(this.h,Y),B);return this.e.$registerOnTypeFormattingSupport(fe,this.o(q,B),_,B.identifier),this.p(fe)}$provideOnTypeFormattingEdits(B,q,Y,_,fe,ve){return this.s(B,se,Ne=>Ne.provideOnTypeFormattingEdits(f.URI.revive(q),Y,_,fe,ve),void 0,ve)}registerWorkspaceSymbolProvider(B,q){const Y=this.t(new W(q,this.l),B);return this.e.$registerNavigateTypeSupport(Y,typeof q.resolveWorkspaceSymbol=="function"),this.p(Y)}$provideWorkspaceSymbols(B,q,Y){return this.s(B,W,_=>_.provideWorkspaceSymbols(q,Y),{symbols:[]},Y)}$resolveWorkspaceSymbol(B,q,Y){return this.s(B,W,_=>_.resolveWorkspaceSymbol(q,Y),void 0,void 0)}$releaseWorkspaceSymbols(B,q){this.s(B,W,Y=>Y.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(B,q,Y){const _=this.t(new H(this.h,Y,this.l),B);return this.e.$registerRenameSupport(_,this.o(q,B),H.supportsResolving(Y)),this.p(_)}$provideRenameEdits(B,q,Y,_,fe){return this.s(B,H,ve=>ve.provideRenameEdits(f.URI.revive(q),Y,_,fe),void 0,fe)}$resolveRenameLocation(B,q,Y,_){return this.s(B,H,fe=>fe.resolveRenameLocation(f.URI.revive(q),Y,_),void 0,_)}registerNewSymbolNamesProvider(B,q,Y){const _=this.t(new V(this.h,Y,this.l),B);return this.e.$registerNewSymbolNamesProvider(_,this.o(q,B)),this.p(_)}$supportsAutomaticNewSymbolNamesTriggerKind(B){return this.s(B,V,q=>q.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(B,q,Y,_,fe){return this.s(B,V,ve=>ve.provideNewSymbolNames(f.URI.revive(q),Y,_,fe),void 0,fe)}registerDocumentSemanticTokensProvider(B,q,Y,_){const fe=this.t(new he(this.h,Y),B),ve=typeof Y.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(fe,this.o(q,B),_,ve);let Ne=this.p(fe);if(ve){const Be=Y.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(ve));Ne=o.$xM.from(Ne,Be)}return Ne}$provideDocumentSemanticTokens(B,q,Y,_){return this.s(B,he,fe=>fe.provideDocumentSemanticTokens(f.URI.revive(q),Y,_),null,_)}$releaseDocumentSemanticTokens(B,q){this.s(B,he,Y=>Y.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,q,Y,_){const fe=this.t(new ne(this.h,Y),B);return this.e.$registerDocumentRangeSemanticTokensProvider(fe,this.o(q,B),_),this.p(fe)}$provideDocumentRangeSemanticTokens(B,q,Y,_){return this.s(B,ne,fe=>fe.provideDocumentRangeSemanticTokens(f.URI.revive(q),Y,_),null,_)}registerCompletionItemProvider(B,q,Y,_){const fe=this.t(new we(this.h,this.j.converter,Y,this.m,B),B);return this.e.$registerCompletionsProvider(fe,this.o(q,B),_,we.supportsResolving(Y),B.identifier),this.p(fe)}$provideCompletionItems(B,q,Y,_,fe){return this.s(B,we,ve=>ve.provideCompletionItems(f.URI.revive(q),Y,_,fe),void 0,fe)}$resolveCompletionItem(B,q,Y){return this.s(B,we,_=>_.resolveCompletionItem(q,Y),void 0,Y)}$releaseCompletionItems(B,q){this.s(B,we,Y=>Y.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(B,q,Y,_){const fe=new ce(B,this.h,Y,this.j.converter),ve=this.t(fe,B);return this.e.$registerInlineCompletionsSupport(ve,this.o(q,B),fe.supportsHandleEvents,$.$Xm.toKey(B.identifier.value),_?.yieldTo?.map(Ne=>$.$Xm.toKey(Ne))||[]),this.p(ve)}$provideInlineCompletions(B,q,Y,_,fe){return this.s(B,pe,ve=>ve.provideInlineCompletions(f.URI.revive(q),Y,_,fe),void 0,fe)}$handleInlineCompletionDidShow(B,q,Y,_){this.s(B,pe,async fe=>{fe.handleDidShowCompletionItem(q,Y,_)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,q,Y,_,fe){this.s(B,pe,async ve=>{ve.handlePartialAccept(q,Y,_,fe)},void 0,void 0)}$freeInlineCompletionsList(B,q){this.s(B,pe,async Y=>{Y.disposeCompletions(q)},void 0,void 0)}registerInlineEditProvider(B,q,Y){const _=new K(B,this.h,Y,this.j.converter),fe=this.t(_,B);return this.e.$registerInlineEditProvider(fe,this.o(q,B),B.identifier),this.p(fe)}$provideInlineEdit(B,q,Y,_){return this.s(B,K,fe=>fe.provideInlineEdits(f.URI.revive(q),Y,_),void 0,_)}$freeInlineEdit(B,q){this.s(B,K,async Y=>{Y.disposeEdit(q)},void 0,void 0)}registerSignatureHelpProvider(B,q,Y,_){const fe=Array.isArray(_)?{triggerCharacters:_,retriggerCharacters:[]}:_,ve=this.t(new te(this.h,Y),B);return this.e.$registerSignatureHelpProvider(ve,this.o(q,B),fe),this.p(ve)}$provideSignatureHelp(B,q,Y,_,fe){return this.s(B,te,ve=>ve.provideSignatureHelp(f.URI.revive(q),Y,_,fe),void 0,fe)}$releaseSignatureHelp(B,q){this.s(B,te,Y=>Y.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(B,q,Y){const _=typeof Y.onDidChangeInlayHints=="function"?this.q():void 0,fe=this.t(new ee(this.h,this.j.converter,Y,this.l,B),B);this.e.$registerInlayHintsProvider(fe,this.o(q,B),typeof Y.resolveInlayHint=="function",_,Pe.u(B));let ve=this.p(fe);if(_!==void 0){const Ne=Y.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(_));ve=o.$xM.from(ve,Ne)}return ve}$provideInlayHints(B,q,Y,_){return this.s(B,ee,fe=>fe.provideInlayHints(f.URI.revive(q),Y,_),void 0,_)}$resolveInlayHint(B,q,Y){return this.s(B,ee,_=>_.resolveInlayHint(q,Y),void 0,Y)}$releaseInlayHints(B,q){this.s(B,ee,Y=>Y.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(B,q,Y){const _=this.t(new ie(this.h,Y),B);return this.e.$registerDocumentLinkProvider(_,this.o(q,B),typeof Y.resolveDocumentLink=="function"),this.p(_)}$provideDocumentLinks(B,q,Y){return this.s(B,ie,_=>_.provideLinks(f.URI.revive(q),Y),void 0,Y,q.scheme==="output")}$resolveDocumentLink(B,q,Y){return this.s(B,ie,_=>_.resolveLink(q,Y),void 0,void 0,!0)}$releaseDocumentLinks(B,q){this.s(B,ie,Y=>Y.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(B,q,Y){const _=this.t(new le(this.h,Y),B);return this.e.$registerDocumentColorProvider(_,this.o(q,B)),this.p(_)}$provideDocumentColors(B,q,Y){return this.s(B,le,_=>_.provideColors(f.URI.revive(q),Y),[],Y)}$provideColorPresentations(B,q,Y,_){return this.s(B,le,fe=>fe.provideColorPresentations(f.URI.revive(q),Y,_),void 0,_)}registerFoldingRangeProvider(B,q,Y){const _=this.q(),fe=typeof Y.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(_,new De(new Z(this.h,Y),B)),this.e.$registerFoldingRangeProvider(_,this.o(q,B),B.identifier,fe);let ve=this.p(_);if(fe!==void 0){const Ne=Y.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(fe));ve=o.$xM.from(ve,Ne)}return ve}$provideFoldingRanges(B,q,Y,_){return this.s(B,Z,fe=>fe.provideFoldingRanges(f.URI.revive(q),Y,_),void 0,_)}registerSelectionRangeProvider(B,q,Y){const _=this.t(new ae(this.h,Y,this.l),B);return this.e.$registerSelectionRangeProvider(_,this.o(q,B)),this.p(_)}$provideSelectionRanges(B,q,Y,_){return this.s(B,ae,fe=>fe.provideSelectionRanges(f.URI.revive(q),Y,_),[],_)}registerCallHierarchyProvider(B,q,Y){const _=this.t(new $e(this.h,Y),B);return this.e.$registerCallHierarchyProvider(_,this.o(q,B)),this.p(_)}$prepareCallHierarchy(B,q,Y,_){return this.s(B,$e,fe=>Promise.resolve(fe.prepareSession(f.URI.revive(q),Y,_)),void 0,_)}$provideCallHierarchyIncomingCalls(B,q,Y,_){return this.s(B,$e,fe=>fe.provideCallsTo(q,Y,_),void 0,_)}$provideCallHierarchyOutgoingCalls(B,q,Y,_){return this.s(B,$e,fe=>fe.provideCallsFrom(q,Y,_),void 0,_)}$releaseCallHierarchy(B,q){this.s(B,$e,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(B,q,Y){const _=this.t(new be(this.h,Y),B);return this.e.$registerTypeHierarchyProvider(_,this.o(q,B)),this.p(_)}$prepareTypeHierarchy(B,q,Y,_){return this.s(B,be,fe=>Promise.resolve(fe.prepareSession(f.URI.revive(q),Y,_)),void 0,_)}$provideTypeHierarchySupertypes(B,q,Y,_){return this.s(B,be,fe=>fe.provideSupertypes(q,Y,_),void 0,_)}$provideTypeHierarchySubtypes(B,q,Y,_){return this.s(B,be,fe=>fe.provideSubtypes(q,Y,_),void 0,_)}$releaseTypeHierarchy(B,q){this.s(B,be,Y=>Promise.resolve(Y.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(B,q,Y,_){const fe=this.q();return this.f.set(fe,new De(new Me(this.e,this.h,Y,fe,B),B)),this.e.$registerDocumentOnDropEditProvider(fe,this.o(q,B),(0,n.$UG)(B,"documentPaste")&&_?{supportsResolve:!!Y.resolveDocumentDropEdit,dropMimeTypes:_.dropMimeTypes}:void 0),this.p(fe)}$provideDocumentOnDropEdits(B,q,Y,_,fe,ve){return this.s(B,Me,Ne=>Promise.resolve(Ne.provideDocumentOnDropEdits(q,f.URI.revive(Y),_,fe,ve)),void 0,void 0)}$resolveDropEdit(B,q,Y){return this.s(B,Me,_=>_.resolveDropEdit(q,Y),{},void 0)}$releaseDropEdits(B,q){this.s(B,Me,Y=>Promise.resolve(Y.releaseDropEdits(q)),void 0,void 0)}registerMappedEditsProvider(B,q,Y){const _=this.t(new qe(this.h,Y),B);return this.e.$registerMappedEditsProvider(_,this.o(q,B)),this.p(_)}$provideMappedEdits(B,q,Y,_,fe){return this.s(B,qe,ve=>Promise.resolve(ve.provideMappedEdits(q,Y,_,fe)),null,fe)}registerDocumentPasteEditProvider(B,q,Y,_){const fe=this.q();return this.f.set(fe,new De(new N(this.e,this.h,Y,fe,B),B)),this.e.$registerPasteEditProvider(fe,this.o(q,B),{supportsCopy:!!Y.prepareDocumentPaste,supportsPaste:!!Y.provideDocumentPasteEdits,supportsResolve:!!Y.resolveDocumentPasteEdit,providedPasteEditKinds:_.providedPasteEditKinds?.map(ve=>ve.value),copyMimeTypes:_.copyMimeTypes,pasteMimeTypes:_.pasteMimeTypes}),this.p(fe)}$prepareDocumentPaste(B,q,Y,_,fe){return this.s(B,N,ve=>ve.prepareDocumentPaste(f.URI.revive(q),Y,_,fe),void 0,fe)}$providePasteEdits(B,q,Y,_,fe,ve,Ne){return this.s(B,N,Be=>Be.providePasteEdits(q,f.URI.revive(Y),_,fe,ve,Ne),void 0,Ne)}$resolvePasteEdit(B,q,Y){return this.s(B,N,_=>_.resolvePasteEdit(q,Y),{},void 0)}$releasePasteEdits(B,q){this.s(B,N,Y=>Promise.resolve(Y.releasePasteEdits(q)),void 0,void 0)}static y(B){return{pattern:B.source,flags:B.flags}}static z(B){return{decreaseIndentPattern:Pe.y(B.decreaseIndentPattern),increaseIndentPattern:Pe.y(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Pe.y(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Pe.y(B.unIndentedLinePattern):void 0}}static B(B){return{beforeText:Pe.y(B.beforeText),afterText:B.afterText?Pe.y(B.afterText):void 0,previousLineText:B.previousLineText?Pe.y(B.previousLineText):void 0,action:B.action}}static C(B){return B.map(Pe.B)}static D(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(q=>o.SyntaxTokenType.toString(q)):void 0}}static E(B){return B.map(Pe.D)}setLanguageConfiguration(B,q,Y){const{wordPattern:_}=Y;if(_&&(0,I.$nf)(_))throw new Error(`Invalid language configuration: wordPattern '${_}' is not allowed to match the empty string.`);_?this.h.setWordDefinitionFor(q,_):this.h.setWordDefinitionFor(q,void 0),Y.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),Y.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const fe=this.q(),ve={comments:Y.comments,brackets:Y.brackets,wordPattern:Y.wordPattern?Pe.y(Y.wordPattern):void 0,indentationRules:Y.indentationRules?Pe.z(Y.indentationRules):void 0,onEnterRules:Y.onEnterRules?Pe.C(Y.onEnterRules):void 0,__electricCharacterSupport:Y.__electricCharacterSupport,__characterPairSupport:Y.__characterPairSupport,autoClosingPairs:Y.autoClosingPairs?Pe.E(Y.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(fe,q,ve),this.p(fe)}$setWordDefinitions(B){for(const q of B)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$1mc=Pe,Pe.d=0}),define(Ee[129],Se([1,0,7,21,14,4,40,3,235,24,5,12,90,6,128,20,17,8,155,26]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$Inc=e.$Hnc=void 0,e.$Hnc=(0,I.$Ai)("IExtHostLanguageModels");class n{constructor(s,m){this.option=s,this.stream=new r.$4h,this.stream=m??new r.$4h}}class t{constructor(){this.a=new Map,this.b=new r.$4h,this.c=!1,this.d=!1;const s=this;this.apiObject={text:s.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,s]of this.a)yield s.stream;else yield this.b}handleFragment(s){if(this.c)return;this.d=!0;let m=this.a.get(s.index);m||(this.a.size===0?m=new n(s.index,this.b):m=new n(s.index),this.a.set(s.index,m)),m.stream.emitOne(s.part)}get isStreaming(){return this.d}reject(s){this.c=!0;for(const m of this.f())m.reject(s)}resolve(){this.c=!0;for(const s of this.f())s.resolve()}}let c=o=class{constructor(s,m,y){this.j=m,this.k=y,this.c=new T.$he,this.d=new T.$he,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new l.$Zm,this.i=new Map,this.r=new Set,this.b=s.getProxy(A.$vM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(s,m,y,S){const E=o.a++;this.f.set(E,{extension:s.identifier,provider:y,languageModelId:m});let k;S.auth&&(k={providerLabel:s.displayName||s.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(E,`${l.$Xm.toKey(s.identifier)}/${E}/${m}`,{extension:s.identifier,id:m,vendor:S.vendor??l.$Xm.toKey(s.identifier),name:S.name??"",family:S.family??"",version:S.version,maxInputTokens:S.maxInputTokens,maxOutputTokens:S.maxOutputTokens,auth:k,targetExtensions:S.extensions});const C=y.onDidReceiveLanguageModelResponse2?.(({extensionId:v,participant:b,tokenCount:O})=>{this.b.$whenLanguageModelChatRequestMade(m,new l.$Xm(v),b,O)});return(0,R.$Sc)(()=>{this.f.delete(E),this.b.$unregisterProvider(E),C?.dispose()})}async $provideLanguageModelResponse(s,m,y,S,E,k){const C=this.f.get(s);if(!C)return;const v=new f.$nw(async b=>{if(k.isCancellationRequested){this.j.warn(`[CHAT](${C.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(m,{index:b.index,part:b.part})});return C.provider.provideLanguageModelResponse(S.map(d.LanguageModelChatMessage.to),E,l.$Xm.toKey(y),v,k)}$provideTokenLength(s,m,y){const S=this.f.get(s);return S?Promise.resolve(S.provider.provideTokenCount(m,y)):Promise.resolve(0)}$acceptChatModelMetadata(s){if(s.added)for(const{identifier:m,metadata:y}of s.added)this.g.set(m,{metadata:y,apiObjects:new l.$Zm});if(s.removed)for(const m of s.removed){this.g.delete(m);for(const[y,S]of this.i)S.languageModelId===m&&(S.res.reject(new P.$5),this.i.delete(y))}s.added?.forEach(m=>this.p(m.metadata)),this.d.fire(void 0)}async selectLanguageModels(s,m){const y=await this.b.$selectChatModels({...m,extension:s.identifier}),S=[],E=this;for(const k of y){const C=this.g.get(k);if(!C)continue;this.o(s.identifier,C.metadata)&&await this.p(C.metadata);let v=C.apiObjects.get(s.identifier);v||(v={id:k,vendor:C.metadata.vendor,family:C.metadata.family,version:C.metadata.version,name:C.metadata.name,maxInputTokens:C.metadata.maxInputTokens,countTokens(b,O){if(!E.g.has(k))throw g.$MO.NotFound(k);return E.q(k,b,O??u.CancellationToken.None)},sendRequest(b,O,U){if(!E.g.has(k))throw g.$MO.NotFound(k);return E.l(s,k,b,O??{},U??u.CancellationToken.None)}},Object.freeze(v),C.apiObjects.set(s.identifier,v)),S.push(v)}return S}async l(s,m,y,S,E){const k=this.m(s,y),C=s.identifier,v=this.g.get(m)?.metadata;if(!v||!this.g.has(m))throw g.$MO.NotFound(`Language model '${m}' is unknown.`);if(this.o(C,v)&&(!await this.n(s,{identifier:v.extension,displayName:v.auth.providerLabel},S.justification,!1)||!this.h.get(C)?.has(v.extension)))throw g.$MO.NoPermissions(`Language model '${m}' cannot be used by '${C.value}'.`);const b=Math.random()*1e6|0,O=this.b.$fetchResponse(C,m,b,k,S.modelOptions??{},E),U=new r.$zh,z=new t;this.i.set(b,{languageModelId:m,res:z});let j;if(O.catch(M=>{U.isOpen()?z.reject(M):j=M}).finally(()=>{this.i.delete(b),z.resolve(),U.open()}),await U.wait(),j)throw j.name===g.$MO.name?j:new g.$MO(`Language model '${m}' errored, check cause for more details`,"Unknown",j);return z.apiObject}m(s,m){const y=[];for(const S of m)S.role===g.LanguageModelChatMessageRole.System&&(0,i.$VG)(s,"languageModelSystem"),y.push(d.LanguageModelChatMessage.from(S));return y}async $handleResponseFragment(s,m){const y=this.i.get(s);y&&y.res.handleFragment(m)}async n(s,m,y,S){const E=$.$xL+m.identifier.value;if(await this.k.getSession(s,E,[],{silent:!0}))return this.$updateModelAccesslist([{from:s.identifier,to:m.identifier,enabled:!0}]),!0;if(S)return!1;try{const C=y?(0,p.localize)(0,null,m.displayName,y):void 0;return await this.k.getSession(s,E,[],{forceNewSession:{detail:C}}),this.$updateModelAccesslist([{from:s.identifier,to:m.identifier,enabled:!0}]),!0}catch{return!1}}o(s,m){return!!m.auth&&!l.$Xm.equals(m.extension,s)}async p(s){if(s.auth)for(const m of this.r)try{await this.n(m,{identifier:s.extension,displayName:""},void 0,!0)}catch(y){this.j.error("Fake Auth request failed"),this.j.error(y)}}async q(s,m,y){if(!this.g.get(s))throw g.$MO.NotFound(`Language model '${s}' is unknown.`);const E=L.Iterable.find(this.f.values(),k=>k.languageModelId===s);return E?E.provider.provideTokenCount(m,y):this.b.$countTokens(s,typeof m=="string"?m:d.LanguageModelChatMessage.from(m),y)}$updateModelAccesslist(s){const m=new Array;for(const{from:y,to:S,enabled:E}of s){const k=this.h.get(y)??new l.$Ym;if(k.has(S)!==E){E?k.add(S):k.delete(S),this.h.set(y,k);const v={from:y,to:S};m.push(v),this.c.fire(v)}}}createLanguageModelAccessInformation(s){this.r.add(s);const m=this,y=T.Event.signal(T.Event.filter(this.c.event,E=>l.$Xm.equals(E.from,s.identifier))),S=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(y,S)},canSendRequest(E){let k;e:for(const[v,b]of m.g)for(const O of b.apiObjects.values())if(O===E){k=b.metadata;break e}if(!k)return;if(!m.o(s.identifier,k))return!0;const C=m.h.get(s.identifier);if(C)return C.has(k.extension)}}}};e.$Inc=c,c.a=1,e.$Inc=c=o=Ze([Ve(0,a.$ZO),Ve(1,D.$7j),Ve(2,w.$3mc)],c)}),define(Ee[354],Se([1,0,6,17,8,44,7,3,26]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=void 0;class l{constructor(D,f,A,w){this.c=f,this.d=A,this.e=w,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(r.$vM.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,f){await this.a.$changeLanguage(D,f);const A=this.c.getDocumentData(D);if(!A)throw new Error(`document '${D.toString()}' NOT found`);return A.document}async tokenAtPosition(D,f){const A=D.version,w=u.Position.from(f),a=await this.a.$tokensAtPosition(D.uri,w),d={type:P.StandardTokenType.Other,range:D.getWordRangeAtPosition(f)??new P.$zM(f.line,f.character,f.line,f.character)};if(!a)return d;const g={range:u.Range.to(a.range),type:u.TokenType.to(a.type)};return!g.range.contains(f)||A!==D.version?d:g}createLanguageStatusItem(D,f,A){const w=this.f++,a=this.a,d=this.g,g=`${D.identifier.value}/${f}`;if(d.has(g))throw new Error(`LanguageStatusItem with id '${f}' ALREADY exists`);d.add(g);const $={selector:A,id:f,name:D.displayName??D.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const o=new R.$Tc,n=()=>{if(i?.dispose(),!d.has(g)){console.warn(`LanguageStatusItem (${f}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,L.$Ch)(()=>{o.clear(),this.a.$setLanguageStatus(w,{id:g,name:$.name??D.displayName??D.name,source:D.displayName??D.name,selector:u.DocumentSelector.from($.selector,this.e),label:$.text,detail:$.detail??"",severity:$.severity===P.LanguageStatusSeverity.Error?T.default.Error:$.severity===P.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:$.command&&this.d.toInternal($.command,o),accessibilityInfo:$.accessibilityInformation,busy:$.busy})},0)},t={dispose(){o.dispose(),i?.dispose(),a.$removeLanguageStatus(w),d.delete(g)},get id(){return $.id},get name(){return $.name},set name(c){$.name=c,n()},get selector(){return $.selector},set selector(c){$.selector=c,n()},get text(){return $.text},set text(c){$.text=c,n()},set text2(c){(0,p.$VG)(D,"languageStatusText"),$.text=c,n()},get text2(){return(0,p.$VG)(D,"languageStatusText"),$.text},get detail(){return $.detail},set detail(c){$.detail=c,n()},get severity(){return $.severity},set severity(c){$.severity=c,n()},get accessibilityInformation(){return $.accessibilityInformation},set accessibilityInformation(c){$.accessibilityInformation=c,n()},get command(){return $.command},set command(c){$.command=c,n()},get busy(){return $.busy},set busy(c){$.busy=c,n()}};return n(),t}}e.$noc=l}),define(Ee[355],Se([1,0,15,2,17,8,127]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=e.$_nc=void 0;class R{constructor(D,f,A,w){this.start=D,this.deletedCount=f,this.deletedItems=A,this.items=w}asApiEvent(){return{range:new T.$ZN(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(D){return{EOL:D.eol,lines:D.source,languageId:D.language,uri:D.uri,isDirty:!1,versionId:1}}constructor(D,f,A){this.notebook=D,this.h=f,this.j=A,this.handle=A.handle,this.uri=u.URI.revive(A.uri),this.cellKind=A.cellKind,this.a=A.outputs.map(P.NotebookCellOutput.to),this.e=A.internalMetadata??{},this.b=Object.freeze(A.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(A.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,f=this.h.getDocument(this.uri);if(!f)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const A={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:f.document,get mime(){return D.g},set mime(w){D.g=w},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(A)}return this.f}setOutputs(D){this.a=D.map(P.NotebookCellOutput.to)}setOutputItems(D,f,A){const w=A.map(P.NotebookCellOutputItem.to),a=this.a.find(d=>d.id===D);if(a&&(f||(a.items.length=0),a.items.push(...w),a.items.length>1&&a.items.every(d=>L.$rK(d.mime)))){const d=new Map,g=[];a.items.forEach($=>{let i;d.has($.mime)?i=d.get($.mime):(i=[],d.set($.mime,i),g.push($.mime)),i.push($.data)}),a.items.length=0,g.forEach($=>{const i=L.$sK(d.get($));a.items.push({mime:$,data:i.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$_nc=p;class l{constructor(D,f,A,w,a){this.k=D,this.l=f,this.m=A,this.uri=w,this.handle=l.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,f={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===r.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(A){return A=D.n(A),D.b[A].apiCell},getCells(A){return(A?D.p(A):D.b).map(a=>a.apiCell)},save(){return D.q()}};this.e=Object.freeze(f)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,f,A){this.g=D.versionId,this.h=f,this.acceptDocumentPropertiesChanged({metadata:A});const w={notebook:this.apiNotebook,metadata:A,cellChanges:[],contentChanges:[]},a=[];for(const g of D.rawEvents)g.kind===L.NotebookCellsChangeType.ModelChange?this.r(g.changes,!1,w.contentChanges):g.kind===L.NotebookCellsChangeType.Move?this.s(g.index,g.length,g.newIdx,w.contentChanges):g.kind===L.NotebookCellsChangeType.Output?(this.t(g.index,g.outputs),a.push({cell:this.b[g.index].apiCell,outputs:this.b[g.index].apiCell.outputs})):g.kind===L.NotebookCellsChangeType.OutputItem?(this.u(g.index,g.outputId,g.append,g.outputItems),a.push({cell:this.b[g.index].apiCell,outputs:this.b[g.index].apiCell.outputs})):g.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(g.index,g.language),a.push({cell:this.b[g.index].apiCell,document:this.b[g.index].apiCell.document})):g.kind===L.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[g.index].apiCell,document:this.b[g.index].apiCell.document}):g.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(g.index,g.mime):g.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(g.index,g.metadata),a.push({cell:this.b[g.index].apiCell,metadata:this.b[g.index].apiCell.metadata})):g.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(g.index,g.internalMetadata),a.push({cell:this.b[g.index].apiCell,executionSummary:this.b[g.index].apiCell.executionSummary}));const d=new Map;for(let g=0;g<a.length;g++){const $=a[g],i=d.get($.cell);if(i===void 0){const o=w.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...$});d.set($.cell,o-1)}else w.cellChanges[i]={...w.cellChanges[i],...$}}return Object.freeze(w),Object.freeze(w.cellChanges),Object.freeze(w.contentChanges),w}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let f=D.start|0,A=D.end|0;return f<0&&(f=0),A>this.b.length&&(A=this.b.length),D.with({start:f,end:A})}p(D){D=this.o(D);const f=[];for(let A=D.start;A<D.end;A++)f.push(this.b[A]);return f}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,f,A){if(this.j)return;const w=[],a=[],d=[];if(D.reverse().forEach(g=>{const i=g[2].map(t=>{const c=new p(this,this.l,t);return f||a.push(p.asModelAddData(t)),c}),o=new R(g[0],g[1],[],i),n=this.b.splice(g[0],g[1],...i);for(const t of n)d.push(t.uri),o.deletedItems.push(t.apiCell);w.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:d}),A)for(const g of w)A.push(g.asApiEvent())}s(D,f,A,w){const a=this.b.splice(D,f);this.b.splice(A,0,...a);const d=[new R(D,f,a.map(g=>g.apiCell),[]),new R(A,0,[],a)];for(const g of d)w.push(g.asApiEvent())}t(D,f){this.b[D].setOutputs(f)}u(D,f,A,w){this.b[D].setOutputItems(f,A,w)}v(D,f){const A=this.b[D];A.apiCell.document.languageId!==f&&this.m.$acceptModelLanguageChanged(A.uri,f)}w(D,f){const A=this.b[D];A.apiCell.mime=f}x(D,f){this.b[D].setMetadata(f)}y(D,f){this.b[D].setInternalMetadata(f)}getCellFromApiCell(D){return this.b.find(f=>f.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(f=>f.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$aoc=l,l.a=0}),define(Ee[356],Se([1,0,4,2,17,8,52]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=void 0;class R{constructor(l,I,D,f={timeout:1500,errors:3}){this.b=l,this.c=I,this.d=D,this.f=f,this.a=new r.$je}dispose(){}getOnWillSaveNotebookDocumentEvent(l){return(I,D,f)=>{const A=function(a){I.call(D,a)};return A.extension=l,this.a.event(A,void 0,f)}}async $participateInSave(l,I,D){const f=u.URI.revive(l),A=this.c.getNotebookDocument(f);if(!A)throw new Error("Unable to resolve notebook document");const w=[];if(await this.a.fireAsync({notebook:A.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},D,async(d,g)=>{const $=Date.now(),i=await await Promise.resolve(d);Date.now()-$>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier),!D.isCancellationRequested&&i&&(i instanceof T.$HM?w.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier,"ignored due to invalid data"))}),D.isCancellationRequested)return!1;if(w.length===0)return!0;const a={edits:[]};for(const d of w){const{edits:g}=P.WorkspaceEdit.from(d);a.edits=a.edits.concat(g)}return this.d.$tryApplyWorkspaceEdit(new L.$Lw(a))}}e.$poc=R}),define(Ee[164],Se([1,0,14,17,8]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=void 0;class T{constructor(R,p,l,I,D,f){this.id=R,this.f=p,this.notebookData=l,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=I,this.c=f}get apiEditor(){if(!this.e){const R=this;this.e={get notebook(){return R.notebookData.apiNotebook},get selection(){return R.a[0]},set selection(p){this.selections=[p]},get selections(){return R.a},set selections(p){if(!Array.isArray(p)||!p.every(P.$ZN.isNotebookRange))throw(0,r.$7)("selections");R.a=p,R.g(p)},get visibleRanges(){return R.b},revealRange(p,l){R.f.$tryRevealRange(R.id,u.NotebookRange.from(p),l??P.NotebookEditorRevealType.Default)},get viewColumn(){return R.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(R){this.d=R}_acceptVisibleRanges(R){this.b=R}_acceptSelections(R){this.a=R}g(R){this.f.$trySetSelections(this.id,R.map(u.NotebookRange.from))}_acceptViewColumn(R){this.c=R}}e.$boc=T,T.apiEditorsToExtHost=new WeakMap}),define(Ee[357],Se([1,0,4,12,17]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0;let T=class{constructor(R,p){this.c=R,this.d=p,this.a=new r.$he,this.b=new r.$he,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(R,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",R,p);const l=this.d.getEditorById(R);p.visibleRanges&&l._acceptVisibleRanges(p.visibleRanges.ranges.map(P.NotebookRange.to)),p.selections&&l._acceptSelections(p.selections.selections.map(P.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:l.apiEditor,visibleRanges:l.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:l.apiEditor,selections:l.apiEditor.selections}))}$acceptEditorViewColumns(R){for(const p in R)this.d.getEditorById(p)._acceptViewColumn(P.ViewColumn.to(R[p]))}};e.$roc=T,e.$roc=T=Ze([Ve(0,u.$7j)],T)}),define(Ee[358],Se([1,0,4,6,164]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=void 0;class T{constructor(R,p){this.c=p,this.a=new Map,this.b=R.getProxy(u.$vM.MainThreadNotebookRenderers)}$postRendererMessage(R,p,l){const I=this.c.getEditorById(R);this.a.get(p)?.fire({editor:I.apiEditor,message:l})}createRendererMessaging(R,p){if(!R.contributes?.notebookRenderer?.some(I=>I.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(I,D,f)=>this.d(p).event(I,D,f),postMessage:(I,D)=>{P.$boc.apiEditorsToExtHost.has(I)&&([I,D]=[D,I]);const f=D&&P.$boc.apiEditorsToExtHost.get(D);return this.b.$postMessage(f?.id,p,I)}}}d(R){let p=this.a.get(R);return p||(p=new r.$he({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(R)}}),this.a.set(R,p),p)}}e.$uoc=T}),define(Ee[359],Se([1,0,17,90,21,60,14]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0;class R{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,f,A){const w=this.b++,{title:a,location:d,cancellable:g}=f,$={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(w,{location:r.ProgressLocation.from(d),title:a,source:$,cancellable:g},D.isUnderDevelopment?void 0:D.identifier.value).catch(L.$2),this.d(w,A,!!g)}d(D,f,A){let w;A&&(w=new P.$se,this.c.set(D,w));const a=g=>{this.a.$progressEnd(g),this.c.delete(g),w?.dispose()};let d;try{d=f(new l(this.a,D),A&&w?w.token:P.CancellationToken.None)}catch(g){throw a(D),g}return d.then(g=>a(D),g=>a(D)),d}$acceptProgressCanceled(D){const f=this.c.get(D);f&&(f.cancel(),this.c.delete(D))}}e.$yoc=R;function p(I,D){return I.message=D.message,typeof D.increment=="number"&&(typeof I.increment=="number"?I.increment+=D.increment:I.increment=D.increment),I}class l extends u.$nw{constructor(D,f){super(A=>this.throttledReport(A)),this.c=D,this.d=f}throttledReport(D){this.c.$progressReport(this.d,D)}}Ze([(0,T.$7h)(100,(I,D)=>p(I,D),()=>Object.create(null))],l.prototype,"throttledReport",null)}),define(Ee[360],Se([1,0,2,6,7,17]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0;class L{constructor(p,l){this.d=l,this.c=new Map,this.b=p.getProxy(u.$vM.MainThreadQuickDiff)}$provideOriginalResource(p,l,I){const D=r.URI.revive(l),f=this.c.get(p);return f?(0,P.$sh)(()=>f.provideOriginalResource(D,I)).then(A=>A||null):Promise.resolve(null)}registerQuickDiffProvider(p,l,I,D){const f=L.a++;return this.c.set(f,l),this.b.$registerQuickDiffProvider(f,T.DocumentSelector.from(p,this.d),I,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(f),this.c.delete(f)}}}}e.$zoc=L,L.a=0}),define(Ee[361],Se([1,0,21,4,3,6,2,8,14,19,44,50,26,17]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=w;function w(a,d,g){const $=a.getProxy(T.$vM.MainThreadQuickOpen);class i{constructor(S,E){this.e=new Map,this.f=0,this.a=S,this.b=E}showQuickPick(S,E,k,C=r.CancellationToken.None){this.c=void 0;const v=Promise.resolve(E),b=++this.f,O=$.$show(b,{title:k?.title,placeHolder:k?.placeHolder,matchOnDescription:k?.matchOnDescription,matchOnDetail:k?.matchOnDetail,ignoreFocusLost:k?.ignoreFocusOut,canPickMany:k?.canPickMany},C),U={},z=O.then(()=>U);return Promise.race([z,v]).then(j=>{if(j===U)return;const M=(0,f.$UG)(S,"quickPickItemTooltip");return v.then(N=>{const F=[];for(let X=0;X<N.length;X++){const se=N[X];if(typeof se=="string")F.push({label:se,handle:X});else if(se.kind===R.QuickPickItemKind.Separator)F.push({type:"separator",label:se.label});else{se.tooltip&&!M&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const W=se.iconPath?h(se.iconPath):void 0;F.push({label:se.label,iconPath:W?.iconPath,iconClass:W?.iconClass,description:se.description,detail:se.detail,picked:se.picked,alwaysShow:se.alwaysShow,tooltip:M?A.MarkdownString.fromStrict(se.tooltip):void 0,handle:X})}}return k&&typeof k.onDidSelectItem=="function"&&(this.c=X=>{k.onDidSelectItem(N[X])}),$.$setItems(b,F),O.then(X=>{if(typeof X=="number")return N[X];if(Array.isArray(X))return X.map(se=>N[se])})})}).then(void 0,j=>{if(!(0,p.$4)(j))return $.$setError(b,j),Promise.reject(j)})}$onItemSelected(S){this.c?.(S)}showInput(S,E=r.CancellationToken.None){return this.d=S?.validateInput,$.$input(S,typeof this.d=="function",E).then(void 0,k=>{if(!(0,p.$4)(k))return Promise.reject(k)})}async $validateInput(S){if(!this.d)return;const E=await this.d(S);if(!E||typeof E=="string")return E;let k;switch(E.severity){case R.InputBoxValidationSeverity.Info:k=I.default.Info;break;case R.InputBoxValidationSeverity.Warning:k=I.default.Warning;break;case R.InputBoxValidationSeverity.Error:k=I.default.Error;break;default:k=E.message?I.default.Error:I.default.Ignore;break}return{content:E.message,severity:k}}async showWorkspaceFolderPick(S,E=r.CancellationToken.None){const k=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!k)return;const C=await this.a.getWorkspaceFolders2();if(C)return C.find(v=>v.uri.toString()===k.uri.toString())}createQuickPick(S){const E=new s(S,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}createInputBox(S){const E=new m(S,()=>this.e.delete(E._id));return this.e.set(E._id,E),E}$onDidChangeValue(S,E){this.e.get(S)?._fireDidChangeValue(E)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,E){const k=this.e.get(S);k instanceof s&&k._fireDidChangeActive(E)}$onDidChangeSelection(S,E){const k=this.e.get(S);k instanceof s&&k._fireDidChangeSelection(E)}$onDidTriggerButton(S,E){this.e.get(S)?._fireDidTriggerButton(E)}$onDidTriggerItemButton(S,E,k){const C=this.e.get(S);C instanceof s&&C._fireDidTriggerItemButton(E,k)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class o{constructor(S,E){this.x=S,this.y=E,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new u.$he,this.q=new u.$he,this.r=new u.$he,this.s=new u.$he,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((E,k)=>{const C=E===R.$WN.Back?-1:k;this.o.set(C,E)}),this.z({buttons:S.map((E,k)=>({...h(E.iconPath),tooltip:E.tooltip,handle:E===R.$WN.Back?-1:k}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const E=this.o.get(S);E&&this.r.fire(E)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),$.$dispose(this._id))}z(S){if(!this.v){for(const E of Object.keys(S)){const k=S[E];this.u[E]=k===void 0?null:k}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){$.$createOrUpdate(this.u),this.u={id:this._id}}}o.a=1;function n(y){if(y instanceof R.$uN)return{id:y.id};const S=c(y),E=t(y);return{dark:typeof S=="string"?L.URI.file(S):S,light:typeof E=="string"?L.URI.file(E):E}}function t(y){return typeof y=="object"&&"light"in y?y.light:y}function c(y){return typeof y=="object"&&"dark"in y?y.dark:y}function h(y){const S=n(y);let E,k;return"id"in S?k=D.ThemeIcon.asClassName(S):E=S,{iconPath:E,iconClass:k}}class s extends o{constructor(S,E){super(S.identifier,E),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new u.$he,this.L=[],this.M=new u.$he,this.N=new u.$he,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((C,v)=>{this.C.set(v,C),this.D.set(C,v)});const E=(0,f.$UG)(this.O,"quickPickItemTooltip"),k=[];for(let C=0;C<S.length;C++){const v=S[C];if(v.kind===R.QuickPickItemKind.Separator)k.push({type:"separator",label:v.label});else{v.tooltip&&!E&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const b=v.iconPath?h(v.iconPath):void 0;k.push({handle:C,label:v.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:v.description,detail:v.detail,picked:v.picked,alwaysShow:v.alwaysShow,tooltip:E?A.MarkdownString.fromStrict(v.tooltip):void 0,buttons:v.buttons?.map((O,U)=>({...h(O.iconPath),tooltip:O.tooltip,handle:U}))})}}this.z({items:k})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(E=>this.D.has(E)),this.z({activeItems:this.J.map(E=>this.D.get(E))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(E=>this.D.has(E)),this.z({selectedItems:this.L.map(E=>this.D.get(E))})}_fireDidChangeActive(S){const E=(0,l.$Hb)(S.map(k=>this.C.get(k)));this.J=E,this.K.fire(E)}_fireDidChangeSelection(S){const E=(0,l.$Hb)(S.map(k=>this.C.get(k)));this.L=E,this.M.fire(E)}_fireDidTriggerItemButton(S,E){const k=this.C.get(S);if(!k||!k.buttons||!k.buttons.length)return;const C=k.buttons[E];C&&this.N.fire({button:C,item:k})}}class m extends o{constructor(S,E){super(S.identifier,E),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:I.default.Error}):this.z({validationMessage:S.message,severity:S.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(d,g)}});var Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)},rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r};define(Ee[362],Se([1,0,2,4,60,3,7,6,19,135,12,24,41,50,17,26,15,11]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g){"use strict";var $,i,o,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=e.$Boc=void 0;function t(j){return j instanceof r.URI}function c(j,M){return j.scheme===d.Schemas.file&&M.scheme===d.Schemas.file&&g.$e?j.toString()===M.toString():j.toString().toLowerCase()===M.toString().toLowerCase()}function h(j){if(j)return typeof j.iconPath=="string"?r.URI.file(j.iconPath):r.URI.isUri(j.iconPath)||A.ThemeIcon.isThemeIcon(j.iconPath)?j.iconPath:void 0}function s(j){if(j.icon){if(r.URI.isUri(j.icon))return j.icon;if(A.ThemeIcon.isThemeIcon(j.icon))return j.icon;{const M=j.icon;return{light:M.light,dark:M.dark}}}else return}function m(j,M){if(!j.iconPath&&!M.iconPath)return 0;if(j.iconPath){if(!M.iconPath)return 1}else return-1;const N=typeof j.iconPath=="string"?j.iconPath:r.URI.isUri(j.iconPath)?j.iconPath.fsPath:j.iconPath.id,F=typeof M.iconPath=="string"?M.iconPath:r.URI.isUri(M.iconPath)?M.iconPath.fsPath:M.iconPath.id;return(0,l.$zr)(N,F)}function y(j,M){let N=0;if(j.strikeThrough!==M.strikeThrough)return j.strikeThrough?1:-1;if(j.faded!==M.faded)return j.faded?1:-1;if(j.tooltip!==M.tooltip)return(j.tooltip||"").localeCompare(M.tooltip||"");if(N=m(j,M),N!==0)return N;if(j.light&&M.light)N=m(j.light,M.light);else{if(j.light)return 1;if(M.light)return-1}if(N!==0)return N;if(j.dark&&M.dark)N=m(j.dark,M.dark);else{if(j.dark)return 1;if(M.dark)return-1}return N}function S(j,M){if(j.command!==M.command)return j.command<M.command?-1:1;if(j.title!==M.title)return j.title<M.title?-1:1;if(j.tooltip!==M.tooltip){if(j.tooltip!==void 0&&M.tooltip!==void 0)return j.tooltip<M.tooltip?-1:1;if(j.tooltip!==void 0)return 1;if(M.tooltip!==void 0)return-1}if(j.arguments===M.arguments)return 0;if(j.arguments)if(M.arguments){if(j.arguments.length!==M.arguments.length)return j.arguments.length-M.arguments.length}else return 1;else return-1;for(let N=0;N<j.arguments.length;N++){const F=j.arguments[N],X=M.arguments[N];if(F!==X&&!(t(F)&&t(X)&&c(F,X)))return F<X?-1:1}return 0}function E(j,M){let N=(0,l.$zr)(j.resourceUri.fsPath,M.resourceUri.fsPath,!0);if(N!==0)return N;if(j.command&&M.command)N=S(j.command,M.command);else{if(j.command)return 1;if(M.command)return-1}if(N!==0)return N;if(j.decorations&&M.decorations)N=y(j.decorations,M.decorations);else{if(j.decorations)return 1;if(M.decorations)return-1}if(j.multiFileDiffEditorModifiedUri&&M.multiFileDiffEditorModifiedUri)N=(0,l.$zr)(j.multiFileDiffEditorModifiedUri.fsPath,M.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(j.multiFileDiffEditorModifiedUri)return 1;if(M.multiFileDiffEditorModifiedUri)return-1}if(j.multiDiffEditorOriginalUri&&M.multiDiffEditorOriginalUri)N=(0,l.$zr)(j.multiDiffEditorOriginalUri.fsPath,M.multiDiffEditorOriginalUri.fsPath,!0);else{if(j.multiDiffEditorOriginalUri)return 1;if(M.multiDiffEditorOriginalUri)return-1}return N}function k(j,M){for(let N=0;N<j.length;N++)if(j[N]!==M[N])return!1;return!0}function C(j,M){return j.command===M.command&&j.title===M.title&&j.tooltip===M.tooltip&&(j.arguments&&M.arguments?k(j.arguments,M.arguments):j.arguments===M.arguments)}function v(j,M){return(0,p.$ub)(j,M,C)}class b{get value(){return this.d}set value(M){M=M??"",this.l.queue(async()=>Ge(this,$,"f").$setInputBoxValue(this.m,M)),this.o(M)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(M){this.l.queue(async()=>Ge(this,$,"f").$setInputBoxPlaceholder(this.m,M)),this.f=M}get validateInput(){return(0,a.$VG)(this.k,"scmValidation"),this.g}set validateInput(M){if((0,a.$VG)(this.k,"scmValidation"),M&&typeof M!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=M,this.l.queue(async()=>Ge(this,$,"f").$setValidationProviderIsEnabled(this.m,!!M))}get enabled(){return this.h}set enabled(M){M=!!M,this.h!==M&&(this.h=M,this.l.queue(async()=>Ge(this,$,"f").$setInputBoxEnablement(this.m,M)))}get visible(){return this.j}set visible(M){M=!!M,this.j!==M&&(this.j=M,this.l.queue(async()=>Ge(this,$,"f").$setInputBoxVisibility(this.m,M)))}get document(){return(0,a.$VG)(this.k,"scmTextDocument"),Ge(this,i,"f").getDocument(this.n)}constructor(M,N,F,X,se,W){this.k=M,this.l=X,this.m=se,this.n=W,$.set(this,void 0),i.set(this,void 0),this.d="",this.e=new u.$he,this.f="",this.h=!0,this.j=!0,rt(this,i,N,"f"),rt(this,$,F,"f")}showValidationMessage(M,N){(0,a.$VG)(this.k,"scmValidation"),this.l.queue(async()=>Ge(this,$,"f").$showValidationMessage(this.m,M,N))}$onInputBoxValueChange(M){this.o(M)}o(M){this.d=M,this.e.fire(M)}}e.$Boc=b,$=new WeakMap,i=new WeakMap;class O{get disposed(){return this.l}get id(){return this.v}get label(){return this.w}set label(M){this.w=M,this.t.queue(async()=>this.q.$updateGroupLabel(this.u,this.handle,M))}get hideWhenEmpty(){return this.p}set hideWhenEmpty(M){this.p=M,this.t.queue(async()=>this.q.$updateGroup(this.u,this.handle,this.features))}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(M){this.f=[...M],this.k.fire()}constructor(M,N,F,X,se,W,H,V){this.q=M,this.s=N,this.t=F,this.u=X,this.v=se,this.w=W,this.multiDiffEditorEnableViewChanges=H,this.x=V,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new u.$he,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new u.$he,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=O.d++}getResourceState(M){return this.g.get(M)}$executeResourceCommand(M,N){const F=this.h.get(M);return F?(0,L.$sh)(()=>this.s.executeCommand(F.command,...F.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const M=[...this.f].sort(E),F=(0,p.$Db)(this.o,M,E).map(W=>{const H=W.toInsert.map(V=>{const x=this.e++;this.g.set(x,V);const he=V.resourceUri;let ne;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"||V.command.command==="vscode.changes"){const be=new T.$Tc;ne=this.s.converter.toInternal(V.command,be),this.j.set(x,be)}else this.h.set(x,V.command);const we=(0,a.$UG)(this.x,"scmMultiDiffEditor"),pe=we?V.multiDiffEditorOriginalUri:void 0,ce=we?V.multiFileDiffEditorModifiedUri:void 0,K=h(V.decorations),de=V.decorations&&h(V.decorations.light)||K,te=V.decorations&&h(V.decorations.dark)||K,ee=[de,te],ie=V.decorations&&V.decorations.tooltip||"",le=V.decorations&&!!V.decorations.strikeThrough,Z=V.decorations&&!!V.decorations.faded,ae=V.contextValue||"";return{rawResource:[x,he,ee,ie,le,Z,ae,ne,pe,ce],handle:x}});return{start:W.start,deleteCount:W.deleteCount,toInsert:H}}),X=F.map(({start:W,deleteCount:H,toInsert:V})=>[W,H,V.map(x=>x.rawResource)]),se=F.reverse();for(const{start:W,deleteCount:H,toInsert:V}of se){const x=V.map(ne=>ne.handle),he=this.n.splice(W,H,...x);for(const ne of he)this.g.delete(ne),this.h.delete(ne),this.j.get(ne)?.dispose(),this.j.delete(ne)}return this.o=M,X}dispose(){this.l=!0,this.m.fire()}}O.d=0;class U{get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.g}get count(){return this.h}set count(M){this.h!==M&&(this.h=M,this.e.queue(async()=>Ge(this,o,"f").$updateSourceControl(this.x,{count:M})))}get quickDiffProvider(){return this.j}set quickDiffProvider(M){this.j=M;let N;(0,a.$UG)(this.y,"quickDiffProvider")&&(N=M?.label),this.e.queue(async()=>Ge(this,o,"f").$updateSourceControl(this.x,{hasQuickDiffProvider:!!M,quickDiffLabel:N}))}get historyProvider(){return(0,a.$VG)(this.y,"scmHistoryProvider"),this.k}set historyProvider(M){(0,a.$VG)(this.y,"scmHistoryProvider"),this.k=M,this.l.value=new T.$Tc,this.e.queue(async()=>Ge(this,o,"f").$updateSourceControl(this.x,{hasHistoryProvider:!!M})),M&&this.l.value.add(M.onDidChangeCurrentHistoryItemGroup(()=>{this.m=M?.currentHistoryItemGroup,this.e.queue(async()=>Ge(this,o,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m))}))}get commitTemplate(){return this.n}set commitTemplate(M){M!==this.n&&(this.n=M,this.e.queue(async()=>Ge(this,o,"f").$updateSourceControl(this.x,{commitTemplate:M})))}get acceptInputCommand(){return this.p}set acceptInputCommand(M){this.o.value=new T.$Tc,this.p=M;const N=this.z.converter.toInternal(M,this.o.value);this.e.queue(async()=>Ge(this,o,"f").$updateSourceControl(this.x,{acceptInputCommand:N}))}get actionButton(){return(0,a.$VG)(this.y,"scmActionButton"),this.s}set actionButton(M){(0,a.$VG)(this.y,"scmActionButton"),this.q.value=new T.$Tc,this.s=M;const N=M!==void 0?{command:this.z.converter.toInternal(M.command,this.q.value),secondaryCommands:M.secondaryCommands?.map(F=>F.map(X=>this.z.converter.toInternal(X,this.q.value))),description:M.description,enabled:M.enabled}:void 0;this.e.queue(async()=>Ge(this,o,"f").$updateSourceControl(this.x,{actionButton:N??null}))}get statusBarCommands(){return this.u}set statusBarCommands(M){if(this.u&&M&&v(this.u,M))return;this.t.value=new T.$Tc,this.u=M;const N=(M||[]).map(F=>this.z.converter.toInternal(F,this.t.value));this.e.queue(async()=>Ge(this,o,"f").$updateSourceControl(this.x,{statusBarCommands:N}))}get selected(){return this.v}constructor(M,N,F,X,se,W,H){this.y=M,this.z=X,this.A=se,this.B=W,this.C=H,o.set(this,void 0),this.e=new L.$vh,this.f=new Map,this.h=void 0,this.j=void 0,this.l=new T.$Vc,this.n=void 0,this.o=new T.$Vc,this.p=void 0,this.q=new T.$Vc,this.t=new T.$Vc,this.u=void 0,this.v=!1,this.w=new u.$he,this.onDidChangeSelection=this.w.event,this.x=U.d++,this.D=new Map,this.E=new Set,rt(this,o,F,"f");const V=r.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${se}/scm${this.x}/input`,query:H?`rootUri=${encodeURIComponent(H.toString())}`:void 0});this.e.queue(()=>Ge(this,o,"f").$registerSourceControl(this.x,se,W,H,V)),this.g=new b(M,N,Ge(this,o,"f"),this.e,this.x,V)}createResourceGroup(M,N,F){const X=(0,a.$UG)(this.y,"scmMultiDiffEditor")&&F?.multiDiffEditorEnableViewChanges===!0,se=new O(Ge(this,o,"f"),this.z,this.e,this.x,M,N,X,this.y),W=u.Event.once(se.onDidDispose)(()=>this.D.delete(se));return this.D.set(se,W),this.eventuallyAddResourceGroups(),se}eventuallyAddResourceGroups(){const M=[],N=[];for(const[F,X]of this.D){X.dispose();const se=F.onDidUpdateResourceStates(()=>{this.E.add(F),this.eventuallyUpdateResourceStates()});u.Event.once(F.onDidDispose)(()=>{this.E.delete(F),se.dispose(),this.f.delete(F.handle),this.e.queue(async()=>Ge(this,o,"f").$unregisterGroup(this.x,F.handle))}),M.push([F.handle,F.id,F.label,F.features,F.multiDiffEditorEnableViewChanges]);const W=F._takeResourceStateSnapshot();W.length>0&&N.push([F.handle,W]),this.f.set(F.handle,F)}this.e.queue(async()=>Ge(this,o,"f").$registerGroups(this.x,M,N)),this.D.clear()}eventuallyUpdateResourceStates(){const M=[];this.E.forEach(N=>{const F=N._takeResourceStateSnapshot();F.length!==0&&M.push([N.handle,F])}),M.length>0&&this.e.queue(async()=>Ge(this,o,"f").$spliceResourceStates(this.x,M)),this.E.clear()}getResourceGroup(M){return this.f.get(M)}setSelectionState(M){this.v=M,this.w.fire(M)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.f.forEach(M=>M.dispose()),this.e.queue(async()=>Ge(this,o,"f").$unregisterSourceControl(this.x))}}o=new WeakMap,U.d=0,Ze([(0,P.$6h)(100)],U.prototype,"eventuallyAddResourceGroups",null),Ze([(0,P.$6h)(100)],U.prototype,"eventuallyUpdateResourceStates",null);let z=n=class{get onDidChangeActiveProvider(){return this.j.event}constructor(M,N,F,X){this.l=N,this.m=F,this.n=X,this.g=new Map,this.h=new D.$Zm,this.j=new u.$he,this.e=M.getProxy(R.$vM.MainThreadSCM),this.f=M.getProxy(R.$vM.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:se=>{if(se&&se.$mid===f.MarshalledId.ScmResource){const W=this.g.get(se.sourceControlHandle);if(!W)return se;const H=W.getResourceGroup(se.groupHandle);return H?H.getResourceState(se.handle):se}else if(se&&se.$mid===f.MarshalledId.ScmResourceGroup){const W=this.g.get(se.sourceControlHandle);return W?W.getResourceGroup(se.groupHandle):se}else if(se&&se.$mid===f.MarshalledId.ScmProvider){const W=this.g.get(se.handle);return W||se}return se}})}createSourceControl(M,N,F,X){this.n.trace("ExtHostSCM#createSourceControl",M.identifier.value,N,F,X),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:M.identifier.value});const se=n.d++,W=new U(M,this.m,this.e,this.l,N,F,X);this.g.set(se,W);const H=this.h.get(M.identifier)||[];return H.push(W),this.h.set(M.identifier,H),W}getLastInputBox(M){this.n.trace("ExtHostSCM#getLastInputBox",M.identifier.value);const N=this.h.get(M.identifier),F=N&&N[N.length-1];return F&&F.inputBox}$provideOriginalResource(M,N,F){const X=r.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",M,X.toString());const se=this.g.get(M);return!se||!se.quickDiffProvider||!se.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$sh)(()=>se.quickDiffProvider.provideOriginalResource(X,F)).then(W=>W||null)}$onInputBoxValueChange(M,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",M);const F=this.g.get(M);return F&&F.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(M,N,F,X){this.n.trace("ExtHostSCM#$executeResourceCommand",M,N,F);const se=this.g.get(M);if(!se)return Promise.resolve(void 0);const W=se.getResourceGroup(N);return W?W.$executeResourceCommand(F,X):Promise.resolve(void 0)}$validateInput(M,N,F){this.n.trace("ExtHostSCM#$validateInput",M);const X=this.g.get(M);return!X||!X.inputBox.validateInput?Promise.resolve(void 0):(0,L.$sh)(()=>X.inputBox.validateInput(N,F)).then(se=>{if(!se)return Promise.resolve(void 0);const W=w.MarkdownString.fromStrict(se.message);return W?Promise.resolve([W,se.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(M){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",M),M!==void 0&&this.g.get(M)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=M,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(M,N,F,X){return await this.g.get(M)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(N,F,X)??void 0}async $provideHistoryItems(M,N,F,X){return(await this.g.get(M)?.historyProvider?.provideHistoryItems(N,F,X))?.map(H=>({...H,icon:s(H)}))??void 0}async $provideHistoryItemSummary(M,N,F,X){const se=this.g.get(M)?.historyProvider;if(typeof se?.provideHistoryItemSummary!="function")return;const W=await se.provideHistoryItemSummary(N,F,X);return W?{...W,icon:s(W)}:void 0}async $provideHistoryItemChanges(M,N,F,X){return await this.g.get(M)?.historyProvider?.provideHistoryItemChanges(N,F,X)??void 0}};e.$Coc=z,z.d=0,e.$Coc=z=n=Ze([Ve(3,I.$7j)],z)}),define(Ee[363],Se([1,0,6,17,2]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=void 0;class T{constructor(R,p){this.d=p,this.c=new Map,this.b=R.getProxy(r.$vM.MainThreadShare)}async $provideShare(R,p,l){return await this.c.get(R)?.provideShare({selection:u.Range.to(p.selection),resourceUri:P.URI.revive(p.resourceUri)},l)??void 0}registerShareProvider(R,p){const l=T.a++;return this.c.set(l,p),this.b.$registerShareProvider(l,u.DocumentSelector.from(R,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(l),this.c.delete(l)}}}}e.$Doc=T,T.a=0});var rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r},Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)};define(Ee[364],Se([1,0,8,6,238,3,17,18]),function(oe,e,r,u,P,T,L,R){"use strict";var p,l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=e.$Foc=void 0;class I{constructor(w,a,d,g,$,i=r.StatusBarAlignment.Left,o){if(p.set(this,void 0),l.set(this,void 0),this.i=!1,this.k="",this.q=new T.$Tc,rt(this,p,w,"f"),rt(this,l,a,"f"),$&&g){this.c=(0,r.$0M)(g.identifier,$);const n=d.get(this.c);n&&(i=n.alignLeft?r.StatusBarAlignment.Left:r.StatusBarAlignment.Right,o=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(I.a++);this.e=g,this.f=$,this.g=i,this.h=this.u(o)}u(w){if((0,R.$eg)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!I.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new T.$Tc,typeof w=="string"?this.r={fromApi:w,internal:Ge(this,l,"f").toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:Ge(this,l,"f").toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ge(this,p,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let a;this.m?a=this.m:a=(0,P.localize)(0,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=I.b.get(this.o.id));const g=L.MarkdownString.fromStrict(this.l);Ge(this,p,"f").$setEntry(this.c,w,this.e?.identifier.value,a,this.k,g,this.r?.internal,d,this.o,this.g===r.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Foc=I,p=new WeakMap,l=new WeakMap,I.a=0,I.b=new Map([["statusBarItem.errorBackground",new r.$vN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new r.$vN("statusBarItem.warningForeground")]]);class D{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",r.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const a={message:w};return this.b.unshift(a),this.c(),new r.$xM(()=>{const d=this.b.indexOf(a);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class f{constructor(w,a){this.e=new Map,this.a=w.getProxy(u.$vM.MainThreadStatusBar),this.b=a,this.c=new D(this)}$acceptStaticEntries(w){for(const a of w)this.e.set(a.entryId,a)}createStatusBarEntry(w,a,d,g){return new I(this.a,this.b,this.e,w,a,d,g)}setStatusBarMessage(w,a){const d=this.c.setMessage(w);let g;return typeof a=="number"?g=setTimeout(()=>d.dispose(),a):typeof a<"u"&&a.then(()=>d.dispose(),()=>d.dispose()),new r.$xM(()=>{d.dispose(),clearTimeout(g)})}}e.$Goc=f}),define(Ee[165],Se([1,0,31,154,73,121,74,17,2]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.$bP=e.$aP=e.$_O=void 0;const l=(i,o,n,t)=>{let c=o;return{enumerable:!0,configurable:!1,get(){return c},set(h){if(!n(c,h)){const s=c;c=h,i.listener?.(t(h,s))}}}},I=(i,o)=>i===o,D={range:(i,o)=>i===o?!0:!i||!o?!1:i.isEqual(o),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,o)=>!(i.length!==o.length||i.some(n=>!o.find(t=>n.id===t.id)))},f=i=>o=>({op:T.TestItemEventOp.SetProp,update:i(o)}),A=(i,o)=>({range:(()=>{let n;const t=f(c=>({range:r.$dt.lift(R.Range.from(c))}));return{enumerable:!0,configurable:!1,get(){return n},set(c){i.listener?.({op:T.TestItemEventOp.DocumentSynced}),D.range(n,c)||(n=c,i.listener?.(t(c)))}}})(),label:l(i,o,D.label,f(n=>({label:n}))),description:l(i,void 0,D.description,f(n=>({description:n}))),sortText:l(i,void 0,D.sortText,f(n=>({sortText:n}))),canResolveChildren:l(i,!1,D.canResolveChildren,n=>({op:T.TestItemEventOp.UpdateCanResolveChildren,state:n})),busy:l(i,!1,D.busy,f(n=>({busy:n}))),error:l(i,void 0,D.error,f(n=>({error:R.MarkdownString.fromStrict(n)||null}))),tags:l(i,[],D.tags,(n,t)=>({op:T.TestItemEventOp.SetTags,new:n.map(R.TestTag.from),old:t.map(R.TestTag.from)}))}),w=i=>{const o=P.$hL.fromString(i.extId),n=new d(o.controllerId,o.localId,i.label,p.URI.revive(i.uri)||void 0);return n.range=R.Range.to(i.range||void 0),n.description=i.description||void 0,n.sortText=i.sortText||void 0,n.tags=i.tags.map(t=>R.TestTag.to({id:(0,L.$nL)(t).tagId})),n},a=i=>{let o;for(const n of i.tests){const t=w(n.item);(0,u.$VO)(t).parent=o,o=t}return o};e.$_O=a;class d{constructor(o,n,t,c){if(n.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(n)} symbol`);const h=(0,u.$UO)(this,o);Object.defineProperties(this,{id:{value:n,enumerable:!0,writable:!1},uri:{value:c,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof g?void 0:h.parent}},children:{value:(0,T.$TO)(h,u.$VO,d),enumerable:!0,writable:!1},...A(h,t)})}}e.$aP=d;class g extends d{constructor(o,n){super(o,o,n,void 0),this._isRoot=!0}}e.$bP=g;class $ extends T.$PO{constructor(o,n,t){super({controllerId:o,getDocumentVersion:c=>c&&t.getDocument(c)?.version,getApiFor:u.$VO,getChildren:c=>c.children,root:new g(o,n),toITestItem:R.TestItem.from})}}e.$cP=$});var rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r},Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)};define(Ee[37],Se([1,0,18,8,17,25,6,19,12,55,31,58,2,3,5,20,165,22,52,51,43,92,95,33]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n,t,c){"use strict";var h,s,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=void 0;let y=class{constructor(b,O,U){h.set(this,void 0),this.b=new Map,this.c=new Map,s.set(this,void 0),m.set(this,void 0),rt(this,h,b.getProxy(L.$vM.MainThreadCommands),"f"),this.d=O,rt(this,m,U,"f"),rt(this,s,b.getProxy(L.$vM.MainThreadTelemetry),"f"),this.converter=new S(this,z=>{const j=this.c.get(z);return j?.result===k.Void?j:void 0},O),this.f=[{processArgument(z){return(0,l.$0h)(z)}},{processArgument(z){return(0,T.$_n)(z,function(j){if(I.$dt.isIRange(j))return P.Range.to(j);if(D.$ct.isIPosition(j))return P.Position.to(j);if(I.$dt.isIRange(j.range)&&f.URI.isUri(j.uri))return P.location.to(j);if(j instanceof g.$Je)return j.buffer.buffer;if(!Array.isArray(j))return j})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const O=this.registerCommand(!1,b.id,async(...U)=>{const z=b.args.map((M,N)=>{if(!M.validate(U[N]))throw new Error(`Invalid argument '${M.name}' when running '${b.id}', received: ${typeof U[N]=="object"?JSON.stringify(U[N],null,"	"):U[N]} `);return M.convert(U[N])}),j=await this.executeCommand(b.internalId,...z);return b.result.convert(j,U,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new u.$xM(()=>{O.dispose(),this.c.delete(b.id)})}registerCommand(b,O,U,z,j,M){if(this.d.trace("ExtHostCommands#registerCommand",O),!O.trim().length)throw new Error("invalid id");if(this.b.has(O))throw new Error(`command '${O}' already exists`);return this.b.set(O,{callback:U,thisArg:z,metadata:j,extension:M}),b&&Ge(this,h,"f").$registerCommand(O),new u.$xM(()=>{this.b.delete(O)&&b&&Ge(this,h,"f").$unregisterCommand(O)})}executeCommand(b,...O){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,O,!0)}async g(b,O,U){if(this.b.has(b))return Ge(this,h,"f").$fireCommandActivationEvent(b),this.h(b,O,!1);{let z=!1;const j=(0,T.$_n)(O,function(M){if(M instanceof u.$yM)return P.Position.from(M);if(M instanceof u.$zM)return P.Range.from(M);if(M instanceof u.$JM)return P.location.from(M);if(u.$ZN.isNotebookRange(M))return P.NotebookRange.from(M);if(M instanceof ArrayBuffer)return z=!0,g.$Je.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return z=!0,g.$Je.wrap(M);if(M instanceof g.$Je)return z=!0,M;if(!Array.isArray(M))return M});try{const M=await Ge(this,h,"f").$executeCommand(b,z?new $.$Lw(j):j,U);return(0,l.$0h)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this.g(b,O,!1);throw M}}}async h(b,O,U){const z=this.b.get(b);if(!z)throw new Error("Unknown command");const{callback:j,thisArg:M,metadata:N}=z;if(N?.args)for(let X=0;X<N.args.length;X++)try{(0,r.$rg)(O[X],N.args[X].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${N.args[X].name}' - ${N.args[X].description}`)}const F=o.$be.create();try{return await j.apply(M,O)}catch(X){if(b===this.converter.delegatingCommandId){const se=this.converter.getActualCommand(...O);se&&(b=se.command)}if(this.d.error(X,b,z.extension?.identifier),!U)throw X;if(z.extension?.identifier){const se=Ge(this,m,"f").onExtensionError(z.extension.identifier,X);this.d.trace("forwarded error to extension?",se,z.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$lj)(X)),this.id=b,this.source=z.extension?.displayName??z.extension?.name}}}finally{this.j(z,b,F.elapsed())}}j(b,O,U){b.extension&&Ge(this,s,"f").$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new n.$op(O),duration:U})}$executeContributedCommand(b,...O){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const U=this.b.get(b);return U?(O=O.map(z=>this.f.reduce((j,M)=>M.processArgument(j,U.extension?.identifier),z)),this.h(b,O,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),Ge(this,h,"f").$getCommands().then(O=>(b&&(O=O.filter(U=>U[0]!=="_")),O))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[O,U]of this.b){const{metadata:z}=U;z&&(b[O]=z)}return Promise.resolve(b)}};e.$iP=y,h=new WeakMap,s=new WeakMap,m=new WeakMap,e.$iP=y=Ze([Ve(0,a.$ZO),Ve(1,p.$7j),Ve(2,t.$hP)],y),e.$jP=(0,w.$Ai)("IExtHostCommands");class S{constructor(b,O,U){this.d=b,this.f=O,this.g=U,this.delegatingCommandId=`__vsc${(0,c.$Wg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,O){if(!b)return;const U={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return U;const z=this.f(b.command);if(z)U.id=z.internalId,U.arguments=z.args.map((j,M)=>j.convert(b.arguments&&b.arguments[M]));else if((0,R.$Lb)(b.arguments)){const j=`${b.command} /${++this.c}`;this.b.set(j,b),O.add((0,A.$Sc)(()=>{this.b.delete(j),this.g.trace("CommandsConverter#DISPOSE",j)})),U.$ident=j,U.id=this.delegatingCommandId,U.arguments=[j],this.g.trace("CommandsConverter#CREATE",b.command,j)}return U}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const O=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],O?O.command:"MISSING"),O?this.d.executeCommand(O.command,...O.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$kP=S;class E{static Arr(b){return new E(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,O=>Array.isArray(O)&&O.every(U=>b.validate(U)),O=>O.map(U=>b.convert(U)))}constructor(b,O,U,z){this.name=b,this.description=O,this.validate=U,this.convert=z}optional(){return new E(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,O){return new E(b??this.name,O??this.description,this.validate,this.convert)}}e.$lP=E,E.Uri=new E("uri","Uri of a text document",v=>f.URI.isUri(v),v=>v),E.Position=new E("position","A position in a text document",v=>u.$yM.isPosition(v),P.Position.from),E.Range=new E("range","A range in a text document",v=>u.$zM.isRange(v),P.Range.from),E.Selection=new E("selection","A selection in a text document",v=>u.$AM.isSelection(v),P.Selection.from),E.Number=new E("number","",v=>typeof v=="number",v=>v),E.String=new E("string","",v=>typeof v=="string",v=>v),E.StringArray=E.Arr(E.String),E.CallHierarchyItem=new E("item","A call hierarchy item",v=>v instanceof u.$VM,P.CallHierarchyItem.from),E.TypeHierarchyItem=new E("item","A type hierarchy item",v=>v instanceof u.$hO,P.TypeHierarchyItem.from),E.TestItem=new E("testItem","A VS Code TestItem",v=>v instanceof d.$aP,P.TestItem.from);class k{constructor(b,O){this.description=b,this.convert=O}}e.$mP=k,k.Void=new k("no result",v=>v);class C{constructor(b,O,U,z,j){this.id=b,this.internalId=O,this.description=U,this.args=z,this.result=j}}e.$nP=C}),define(Ee[365],Se([1,0,19,15,2,88,143,35,37,17,8]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;const D=[new p.$nP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$lP.Uri,p.$lP.Position],new p.$mP("A promise that resolves to an array of DocumentHighlight-instances.",A(l.DocumentHighlight.to))),new p.$nP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$lP.Uri],new p.$mP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,d)=>{if((0,r.$Kb)(a))return;class g extends I.$QM{static to(i){const o=new g(i.name,l.SymbolKind.to(i.kind),i.containerName||"",new I.$JM(d[0],l.Range.to(i.range)));return o.detail=i.detail,o.range=o.location.range,o.selectionRange=l.Range.to(i.selectionRange),o.children=i.children?i.children.map(g.to):[],o}}return a.map(g.to)})),new p.$nP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$lP.Uri,new p.$lP("options","Formatting options",a=>!0,a=>a)],new p.$mP("A promise that resolves to an array of TextEdits.",A(l.TextEdit.to))),new p.$nP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$lP.Uri,p.$lP.Range,new p.$lP("options","Formatting options",a=>!0,a=>a)],new p.$mP("A promise that resolves to an array of TextEdits.",A(l.TextEdit.to))),new p.$nP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$lP.Uri,p.$lP.Position,new p.$lP("ch","Trigger character",a=>typeof a=="string",a=>a),new p.$lP("options","Formatting options",a=>!0,a=>a)],new p.$mP("A promise that resolves to an array of TextEdits.",A(l.TextEdit.to))),new p.$nP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$lP.Uri,p.$lP.Position],new p.$mP("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$nP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$lP.Uri,p.$lP.Position],new p.$mP("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$nP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$lP.Uri,p.$lP.Position],new p.$mP("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$nP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$lP.Uri,p.$lP.Position],new p.$mP("A promise that resolves to an array of Location or LocationLink instances.",w)),new p.$nP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$lP.Uri,p.$lP.Position],new p.$mP("A promise that resolves to an array of Location-instances.",A(l.location.to))),new p.$nP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$lP.Uri,p.$lP.Position],new p.$mP("A promise that resolves to an array of Hover-instances.",A(l.Hover.to))),new p.$nP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$lP.Uri,new p.$lP("position","A position in a text document",a=>Array.isArray(a)&&a.every(d=>I.$yM.isPosition(d)),a=>a.map(l.Position.from))],new p.$mP("A promise that resolves to an array of ranges.",a=>a.map(d=>{let g;for(const $ of d.reverse())g=new I.$UM(l.Range.to($),g);return g}))),new p.$nP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$lP.String.with("query","Search string")],new p.$mP("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(l.WorkspaceSymbol.to))),new p.$nP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$lP.Uri,p.$lP.Position],new p.$mP("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(l.CallHierarchyItem.to))),new p.$nP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$lP.CallHierarchyItem],new p.$mP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(l.CallHierarchyIncomingCall.to))),new p.$nP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$lP.CallHierarchyItem],new p.$mP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(l.CallHierarchyOutgoingCall.to))),new p.$nP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$lP.Uri,p.$lP.Position],new p.$mP("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:l.Range.to(a.range),placeholder:a.text}})),new p.$nP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$lP.Uri,p.$lP.Position,p.$lP.String.with("newName","The new symbol name")],new p.$mP("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return l.WorkspaceEdit.to(a)}})),new p.$nP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$lP.Uri,p.$lP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$mP("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(l.DocumentLink.to))),new p.$nP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$lP.Uri],new p.$mP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$QN(a.tokenTypes,a.tokenModifiers)})),new p.$nP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$lP.Uri],new p.$mP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const d=(0,L.$_bb)(a);if(d.type==="full")return new I.$SN(d.data,void 0)})),new p.$nP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$lP.Uri,p.$lP.Range.optional()],new p.$mP("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new I.$QN(a.tokenTypes,a.tokenModifiers)})),new p.$nP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$lP.Uri,p.$lP.Range],new p.$mP("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const d=(0,L.$_bb)(a);if(d.type==="full")return new I.$SN(d.data,void 0)})),new p.$nP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$lP.Uri,p.$lP.Position,p.$lP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$lP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$mP("A promise that resolves to a CompletionList-instance.",(a,d,g)=>{if(!a)return new I.$7M([]);const $=a.suggestions.map(i=>l.CompletionItem.to(i,g));return new I.$7M($,a.incomplete)})),new p.$nP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$lP.Uri,p.$lP.Position,p.$lP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$mP("A promise that resolves to SignatureHelp.",a=>{if(a)return l.SignatureHelp.to(a)})),new p.$nP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$lP.Uri,p.$lP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$mP("A promise that resolves to an array of CodeLens-instances.",(a,d,g)=>A($=>new I.$YM(l.Range.to($.range),$.command&&g.fromInternal($.command)))(a))),new p.$nP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$lP.Uri,new p.$lP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>I.$zM.isRange(a),a=>I.$AM.isSelection(a)?l.Selection.from(a):l.Range.from(a)),p.$lP.String.with("kind","Code action kind to return code actions for").optional(),p.$lP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$mP("A promise that resolves to an array of Command-instances.",(a,d,g)=>A($=>{if($._isSynthetic){if(!$.command)throw new Error("Synthetic code actions must have a command");return g.fromInternal($.command)}else{const i=new I.$SM($.title,$.kind?new I.$TM($.kind):void 0);return $.edit&&(i.edit=l.WorkspaceEdit.to($.edit)),$.command&&(i.command=g.fromInternal($.command)),i.isPreferred=$.isPreferred,i}})(a))),new p.$nP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$lP.Uri],new p.$mP("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(d=>new I.$aN(l.Range.to(d.range),l.Color.to(d.color))):[])),new p.$nP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$lP("color","The color to show and insert",a=>a instanceof I.$_M,l.Color.from),new p.$lP("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:l.Range.from(a.range)}))],new p.$mP("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(l.ColorPresentation.to):[])),new p.$nP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$lP.Uri,p.$lP.Range],new p.$mP("A promise that resolves to an array of Inlay objects",(a,d,g)=>a.map(l.InlayHint.to.bind(void 0,g)))),new p.$nP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$lP.Uri],new p.$mP("A promise that resolves to an array of FoldingRange objects",(a,d)=>{if(a)return a.map(l.FoldingRange.to)})),new p.$nP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$mP("A promise that resolves to an array of NotebookContentProvider static info objects.",A(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(d=>l.NotebookExclusiveDocumentPattern.to(d))})))),new p.$nP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$lP.Uri,p.$lP.Range,new p.$lP("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof I.$zM,a=>l.InlineValueContext.from(a))],new p.$mP("A promise that resolves to an array of InlineValue objects",a=>a.map(l.InlineValue.to))),new p.$nP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$lP("uriOrString","Uri-instance or string (only http/https)",a=>P.URI.isUri(a)||typeof a=="string"&&(0,u.$Kg)(a,u.Schemas.http,u.Schemas.https),a=>a),new p.$lP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[l.ViewColumn.from(a),void 0]:[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)])).optional(),p.$lP.String.with("label","").optional()],p.$mP.Void),new p.$nP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$lP.Uri.with("resource","Resource to open"),p.$lP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$lP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[l.ViewColumn.from(a),void 0]:[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)])).optional()],p.$mP.Void),new p.$nP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$lP.Uri.with("left","Left-hand side resource of the diff editor"),p.$lP.Uri.with("right","Right-hand side resource of the diff editor"),p.$lP.String.with("title","Human readable title for the diff editor").optional(),new p.$lP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[l.ViewColumn.from(a.viewColumn),l.TextEditorOpenOptions.from(a)]).optional()],p.$mP.Void),new p.$nP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$lP.String.with("title","Human readable title for the changes editor"),new p.$lP("resourceList","List of resources to compare",a=>{for(const d of a){if(d.length!==3)return!1;const[g,$,i]=d;if(!P.URI.isUri(g)||!P.URI.isUri($)&&$!==void 0&&$!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},a=>a)],p.$mP.Void),new p.$nP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$lP.Uri,p.$lP.Position],new p.$mP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new p.$nP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$lP.TypeHierarchyItem],new p.$mP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new p.$nP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$lP.TypeHierarchyItem],new p.$mP("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(l.TypeHierarchyItem.to))),new p.$nP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$lP.TestItem],p.$mP.Void),new p.$nP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$lP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$mP.Void),new p.$nP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$lP.String.with("name","The context key name"),new p.$lP("value","The context key value",()=>!0,a=>a)],p.$mP.Void),new p.$nP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$lP.Uri,p.$lP.StringArray,new p.$lP("MappedEditsContext","Mapped Edits Context",a=>l.MappedEditsContext.is(a),a=>l.MappedEditsContext.from(a))],new p.$mP("A promise that resolves to a workspace edit or null",a=>a?l.WorkspaceEdit.to(a):null)),new p.$nP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$lP("Run arguments","",a=>!0,a=>{if(a)return{initialRange:a.initialRange?l.Range.from(a.initialRange):void 0,initialSelection:I.$AM.isSelection(a.initialSelection)?l.Selection.from(a.initialSelection):void 0,message:a.message,autoSend:a.autoSend,position:a.position?l.Position.from(a.position):void 0}})],p.$mP.Void)];class f{static register(d){D.forEach(d.registerApiCommand,d),this.a(d)}static a(d){d.registerCommand(!1,"_validateWhenClauses",R.$zj)}}e.$2mc=f;function A(a){return d=>{if(Array.isArray(d))return d.map(a)}}function w(a){if(!Array.isArray(a))return;const d=[];for(const g of a)T.$Mv(g)?d.push(l.DefinitionLink.to(g)):d.push(l.location.to(g));return d}}),define(Ee[366],Se([1,0,2,37]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=void 0;class P{constructor(L,R,p,l,I){this.a=R,this.b=p,this.c=l;const D=new u.$nP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new u.$lP("showOptions","Show Options",f=>!0,f=>f),new u.$lP("resource","Interactive resource Uri",f=>!0,f=>f),new u.$lP("controllerId","Notebook controller Id",f=>!0,f=>f),new u.$lP("title","Interactive editor title",f=>!0,f=>f)],new u.$mP("Notebook and input URI",f=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",f.notebookEditorId),f.notebookEditorId!==void 0){const A=this.a.getEditorById(f.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",A.id),{notebookUri:r.URI.revive(f.notebookUri),inputUri:r.URI.revive(f.inputUri),notebookEditor:A.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",f.notebookUri,f.inputUri),{notebookUri:r.URI.revive(f.notebookUri),inputUri:r.URI.revive(f.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(L,R,p,l){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:R,lines:[""],languageId:p,uri:L,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(L,R){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$loc=P}),define(Ee[367],Se([1,0,19,7,21,4,3,29,2,24,12,6,37,17,8,122,309,26,52,310]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=void 0,e.$toc=m;let o=class{constructor(S,E,k,C,v){this.m=E,this.n=k,this.o=C,this.q=v,this.b=new R.$Ac,this.c=new R.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new T.$he,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=S.getProxy(D.$vM.MainThreadNotebookKernels);const b=new f.$nP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new f.$lP("options","Select kernel options",U=>!0,U=>{if(U&&"notebookEditor"in U&&"id"in U){const z=this.n.getIdByEditor(U.notebookEditor);return{id:U.id,extension:U.extension,notebookEditorId:z}}else if(U&&"notebookEditor"in U){const z=this.n.getIdByEditor(U.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${U.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return U})],f.$mP.Void),O=new f.$nP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[f.$lP.Uri],new f.$mP("A promise that resolves to an array of variables",(U,z)=>U.map(j=>({variable:{name:j.name,value:j.value,expression:j.expression,type:j.type,language:j.language},hasNamedChildren:j.hasNamedChildren,indexedChildrenCount:j.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(O)}createNotebookController(S,E,k,C,v,b){for(const ne of this.j.values())if(ne.controller.id===E&&l.$Xm.equals(S.identifier,ne.extensionId))throw new Error(`notebook controller with id '${E}' ALREADY exist`);const O=this.k++,U=this;this.q.trace(`NotebookController[${O}], CREATED by ${S.identifier.value}, ${E}`);const z=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${S.identifier}'`);let j=!1;const M=new T.$he,N=new T.$he,F={id:m(S.identifier,E),notebookType:k,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:C||S.identifier.value,preloads:b?b.map(A.NotebookRendererScript.from):[]};let X=v??z,se,W;this.a.$addKernel(O,F).catch(ne=>{console.log(ne),j=!0});let H=0;const V=()=>{if(j)return;const ne=++H;Promise.resolve().then(()=>{ne===H&&this.a.$updateKernel(O,F)})},x=new R.$Ac,he={get id(){return E},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return F.label},set label(ne){F.label=ne??S.displayName??S.name,V()},get detail(){return F.detail??""},set detail(ne){F.detail=ne,V()},get description(){return F.description??""},set description(ne){F.description=ne,V()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(ne){F.supportedLanguages=ne,V()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){F.supportsExecutionOrder=ne,V()},get rendererScripts(){return F.preloads?F.preloads.map(A.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(ne){X=ne??z},get interruptHandler(){return se},set interruptHandler(ne){se=ne,F.supportsInterrupt=!!ne,V()},set variableProvider(ne){(0,g.$VG)(S,"notebookVariableProvider"),W=ne,F.hasVariableProvider=!!ne,ne?.onDidChangeVariables(we=>U.a.$variablesUpdated(we.uri)),V()},get variableProvider(){return W},createNotebookCellExecution(ne){if(j)throw new Error("notebook controller is DISPOSED");if(!x.has(ne.notebook.uri))throw U.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return U._createNotebookCellExecution(ne,m(S.identifier,this.id))},createNotebookExecution(ne){if((0,g.$VG)(S,"notebookExecution"),j)throw new Error("notebook controller is DISPOSED");if(!x.has(ne.uri))throw U.q.trace(`NotebookController[${O}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(we=>we.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return U._createNotebookExecution(ne,m(S.identifier,this.id))},dispose:()=>{j||(this.q.trace(`NotebookController[${O}], DISPOSED`),j=!0,this.j.delete(O),M.dispose(),N.dispose(),this.a.$removeKernel(O))},updateNotebookAffinity(ne,we){we===w.NotebookControllerAffinity2.Hidden&&(0,g.$VG)(S,"notebookControllerAffinityHidden"),U.a.$updateNotebookPriority(O,ne.uri,we)},onDidReceiveMessage:N.event,postMessage(ne,we){return(0,g.$VG)(S,"notebookMessaging"),U.a.$postMessage(O,we&&U.n.getIdByEditor(we),ne)},asWebviewUri(ne){return(0,g.$VG)(S,"notebookMessaging"),(0,a.$PBb)(ne,U.m.remote)}};return this.j.set(O,{extensionId:S.identifier,controller:he,onDidReceiveMessage:N,onDidChangeSelection:M,associatedNotebooks:x}),he}getIdByController(S){for(const[E,k]of this.j)if(k.controller===S)return m(k.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,E){const k=this.g++,C=this;this.q.trace(`NotebookControllerDetectionTask[${k}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(k,E);const v={dispose:()=>{this.f.delete(k),C.a.$removeKernelDetectionTask(k)}};return this.f.set(k,v),v}registerKernelSourceActionProvider(S,E,k){const C=this.i++,v=typeof k.onDidChangeNotebookKernelSourceActions=="function"?C:void 0,b=this;this.h.set(C,k),this.q.trace(`NotebookKernelSourceActionProvider[${C}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(C,C,E);let O;return v!==void 0&&(O=k.onDidChangeNotebookKernelSourceActions(U=>this.a.$emitNotebookKernelSourceActionsChangeEvent(v))),{dispose:()=>{this.h.delete(C),b.a.$removeKernelSourceActionProvider(C,C),O?.dispose()}}}async $provideKernelSourceActions(S,E){const k=this.h.get(S);if(k){const C=new L.$Tc;return(await k.provideNotebookKernelSourceActions(E)??[]).map(b=>A.NotebookKernelSourceAction.from(b,this.o.converter,C))}return[]}$acceptNotebookAssociation(S,E,k){const C=this.j.get(S);if(C){const v=this.n.getNotebookDocument(p.URI.revive(E));k?C.associatedNotebooks.set(v.uri,!0):C.associatedNotebooks.delete(v.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,v.uri.toString(),k),C.onDidChangeSelection.fire({selected:k,notebook:v.apiNotebook})}}async $executeCells(S,E,k){const C=this.j.get(S);if(!C)return;const v=this.n.getNotebookDocument(p.URI.revive(E)),b=[];for(const O of k){const U=v.getCell(O);U&&b.push(U.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,v.uri.toString(),b.length),await C.controller.executeHandler.call(C.controller,b,v.apiNotebook,C.controller)}catch(O){this.q.error(`NotebookController[${S}] execute cells FAILED`,O),console.error(O)}}async $cancelCells(S,E,k){const C=this.j.get(S);if(!C)return;const v=this.n.getNotebookDocument(p.URI.revive(E));if(C.controller.interruptHandler)await C.controller.interruptHandler.call(C.controller,v.apiNotebook);else for(const b of k){const O=v.getCell(b);O&&this.b.get(O.uri)?.cancel()}if(C.controller.interruptHandler){const b=this.c.get(v.uri);this.c.delete(v.uri),k.length&&Array.isArray(b)&&b.length&&b.forEach(O=>O.dispose())}}async $provideVariables(S,E,k,C,v,b,O){const U=this.j.get(S);if(!U)return;const z=this.n.getNotebookDocument(p.URI.revive(k)),j=U.controller.variableProvider;if(!j)return;let M;if(C!==void 0){if(M=this.s[C],!M)return}else this.s={};const N=v==="named"?w.NotebookVariablesRequestKind.Named:w.NotebookVariablesRequestKind.Indexed,F=j.provideVariables(z.apiNotebook,M,N,b,O);let X=0;for await(const se of F){if(O.isCancellationRequested)return;const W={id:this.r++,name:se.variable.name,value:se.variable.value,type:se.variable.type,interfaces:se.variable.interfaces,language:se.variable.language,expression:se.variable.expression,hasNamedChildren:se.hasNamedChildren,indexedChildrenCount:se.indexedChildrenCount,extensionId:U.extensionId.value};if(this.s[W.id]=se.variable,this.a.$receiveVariable(E,W),X++>=i.$Bjb)return}}$acceptKernelMessageFromRenderer(S,E,k){const C=this.j.get(S);if(!C)return;const v=this.n.getEditorById(E);C.onDidReceiveMessage.fire(Object.freeze({editor:v.apiEditor,message:k}))}$cellExecutionChanged(S,E,k){const v=this.n.getNotebookDocument(p.URI.revive(S)).getCell(E);if(v){const b=k?A.NotebookCellExecutionState.to(k):w.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:v.apiCell,state:b})}}_createNotebookCellExecution(S,E){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const C=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!C)throw new Error("invalid cell");if(this.b.has(C.uri))throw new Error(`duplicate execution for ${C.uri}`);const v=new t(E,C,this.a);this.b.set(C.uri,v);const b=v.onDidChangeState(()=>{v.state===n.Resolved&&(v.dispose(),b.dispose(),this.b.delete(C.uri))});return v.asApiObject()}_createNotebookExecution(S,E){const k=this.n.getNotebookDocument(S.uri),C=S.getCells().find(O=>{const U=k.getCellFromApiCell(O);return U&&this.b.has(U.uri)});if(C)throw new Error(`duplicate cell execution for ${C.document.uri}`);if(this.c.has(k.uri))throw new Error(`duplicate notebook execution for ${k.uri}`);const v=new h(E,k,this.a),b=v.onDidChangeState(()=>{v.state===c.Resolved&&(v.dispose(),b.dispose(),this.c.delete(k.uri))});return this.c.set(k.uri,[v,b]),v.asApiObject()}};e.$soc=o,e.$soc=o=Ze([Ve(4,I.$7j)],o);var n;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(n||(n={}));class t extends L.$Uc{get state(){return this.f}constructor(S,E,k){super(),this.m=E,this.n=k,this.b=t.a++,this.c=new T.$he,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new P.$se),this.h=new s(10,C=>this.s(C)),this.j=E.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const E=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new $.$Lw(E))}t(){if(this.f===n.Init)throw new Error("Must call start before modifying cell output");if(this.f===n.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let E=this.m;if(S&&(E=this.m.notebook.getCellFromApiCell(S)),!E)throw new Error("INVALID cell");return E.handle}y(S){return S.map(E=>{const k=w.$4N.ensureUniqueMimeTypes(E.items,!0);return k===E.items?A.NotebookCellOutput.from(E):A.NotebookCellOutput.from({items:k,id:E.id,metadata:E.metadata})})}async z(S,E,k){const C=this.w(E),v=this.y((0,r.$2b)(S));return this.r({editType:d.CellExecutionUpdateType.Output,cellHandle:C,append:k,outputs:v})}async C(S,E,k){return S=w.$4N.ensureUniqueMimeTypes((0,r.$2b)(S),!0),this.r({editType:d.CellExecutionUpdateType.OutputItems,items:S.map(A.NotebookCellOutputItem.from),outputId:E.id,append:k})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(k){S.j=k,S.s([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(k){if(S.f===n.Resolved||S.f===n.Started)throw new Error("Cannot call start again");S.f=n.Started,S.c.fire(),S.s({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:k})},end(k,C,v){if(S.f===n.Resolved)throw new Error("Cannot call resolve twice");S.f=n.Resolved,S.c.fire(),S.h.flush();const b=v?{message:v.message,stack:v.stack,location:v?.location?{startLineNumber:v.location.start.line,startColumn:v.location.start.character,endLineNumber:v.location.end.line,endColumn:v.location.end.character}:void 0,uri:v.uri}:void 0;S.n.$completeExecution(S.b,new $.$Lw({runEndTime:C,lastRunSuccess:k,error:b}))},clearOutput(k){return S.t(),S.z([],k,!1)},appendOutput(k,C){return S.t(),S.z(k,C,!0)},replaceOutput(k,C){return S.t(),S.z(k,C,!1)},appendOutputItems(k,C){return S.t(),S.C(k,C,!0)},replaceOutputItems(k,C){return S.t(),S.C(k,C,!1)}})}}t.a=0;var c;(function(y){y[y.Init=0]="Init",y[y.Started=1]="Started",y[y.Resolved=2]="Resolved"})(c||(c={}));class h extends L.$Uc{get state(){return this.f}constructor(S,E,k){super(),this.h=E,this.j=k,this.b=h.a++,this.c=new T.$he,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new P.$se),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===c.Resolved||this.f===c.Started)throw new Error("Cannot call start again");this.f=c.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===c.Resolved)throw new Error("Cannot call resolve twice");this.f=c.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}h.a=0;class s{constructor(S,E){this.f=S,this.g=E,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new u.$Xh,this.b=Date.now(),(0,u.$Bh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const E=this.a;return this.a=[],this.g(E).finally(()=>S.complete())}}function m(y,S){return`${y.value}/${S}`}}),define(Ee[47],Se([1,0,4,6,5,2,20,3,8,240,14,289,21,33,290,291,50,7,17,37,41]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=e.$Fnc=e.$Enc=e.$Dnc=void 0,e.$Dnc=(0,P.$Ai)("IExtHostTerminalService");class n extends R.$Uc{constructor(v,b,O,U){super(),this.u=v,this._id=b,this.w=O,this.y=U,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new r.$he),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(j=>this.g=j);const z=this;this.value={get name(){return z.y||""},get processId(){return z.b},get creationOptions(){return z.w},get exitStatus(){return z.j},get state(){return z.m},get selection(){return z.n},get shellIntegration(){return z.shellIntegration},sendText(j,M=!0){z.C(),z.u.$sendText(z._id,j,M)},show(j){z.C(),z.u.$show(z._id,j)},hide(){z.C(),z.u.$hide(z._id)},dispose(){z.a||(z.a=!0,z.u.$dispose(z._id))},get dimensions(){if(!(z.f===void 0||z.h===void 0))return{columns:z.f,rows:z.h}}}}dispose(){this.s.fire(),super.dispose()}async create(v,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:v.name,shellPath:v.shellPath??void 0,shellArgs:v.shellArgs??void 0,cwd:v.cwd??b?.cwd??void 0,env:v.env??void 0,icon:S(v.iconPath)??void 0,color:d.ThemeColor.isThemeColor(v.color)?v.color.id:void 0,initialText:v.message??void 0,strictEnv:v.strictEnv??void 0,hideFromUser:v.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(v.location,b?.resolvedExtHostIdentifier),isTransient:v.isTransient??void 0})}async createExtensionTerminal(v,b,O,U,z){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:U,color:d.ThemeColor.isThemeColor(z)?z.id:void 0,location:b?.location||this.z(v,O),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(v,b){return typeof v=="object"?"parentTerminal"in v&&v.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in v?{viewColumn:$.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus}:void 0:v}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(v){this.y=v}setExitStatus(v,b){this.j=Object.freeze({code:v,reason:b})}setDimensions(v,b){return v===this.f&&b===this.h||v===0||b===0?!1:(this.f=v,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(v){this.n=v}_setProcessId(v){this.g?(this.g(v),this.g=void 0):this.b.then(b=>{b!==v&&(this.b=Promise.resolve(v))})}}e.$Enc=n;class t{get onProcessReady(){return this.b.event}constructor(v){this.g=v,this.id=0,this.shouldPersist=!1,this.a=new r.$he,this.onProcessData=this.a.event,this.b=new r.$he,this.d=new r.$he,this.onDidChangeProperty=this.d.event,this.f=new r.$he,this.onProcessExit=this.f.event}refreshProperty(v){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${v}`)}updateProperty(v,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${v}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(v){this.g.handleInput?.(v)}resize(v,b){this.g.setDimensions?.({columns:v,rows:b})}clearBuffer(){}async processBinary(v){}acknowledgeDataEvent(v){}async setUnicodeVersion(v){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(v){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:w.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:w.ProcessPropertyType.Title,value:b})}),this.g.open(v||void 0),v&&this.g.setDimensions?.(v),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let c=1,h=class extends R.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(v=>v.value)}constructor(v,b,O){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new R.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new r.$he,this.onDidCloseTerminal=this.H.event,this.I=new r.$he,this.onDidOpenTerminal=this.I.event,this.J=new r.$he,this.onDidChangeActiveTerminal=this.J.event,this.L=new r.$he,this.onDidChangeTerminalDimensions=this.L.event,this.M=new r.$he,this.onDidChangeTerminalState=this.M.event,this.N=new r.$he,this.onDidChangeShell=this.N.event,this.O=new r.$he({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new r.$he({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=O.getProxy(u.$vM.MainThreadTerminalService),this.y=new a.$bwb(this.a.$sendProcessData),this.a.$registerProcessSupport(v),this.Q.registerArgumentProcessor({processArgument:U=>{const z=j=>{const M=j;return this.getTerminalById(M.instanceId)?.value};switch(U?.$mid){case o.MarshalledId.TerminalContext:return z(U);default:{if(Array.isArray(U))for(let j=0;j<U.length&&U[j].$mid===o.MarshalledId.TerminalContext;j++)U[j]=z(U[j]);return U}}}}),this.B({dispose:()=>{for(const[U,z]of this.g)z.shutdown(!0)}})}getDefaultShell(v){return(v?this.u:this.s)?.path||""}getDefaultShellArgs(v){return(v?this.u:this.s)?.args||[]}createExtensionTerminal(v,b){const O=new n(this.a,(0,A.$Wg)(),v,v.name),U=new t(v.pty);return O.createExtensionTerminal(v.location,b,this.R(v,b).resolvedExtHostIdentifier,S(v.iconPath),E(v.color)).then(z=>{const j=this.S(z,U);this.h[z]=j}),this.f.push(O),O.value}R(v,b){if(b=b||{},v.location&&typeof v.location=="object"&&"parentTerminal"in v.location){const O=v.location.parentTerminal;if(O){const U=this.f.find(z=>z.value===O);U&&(b.resolvedExtHostIdentifier=U._id)}}else v.location&&typeof v.location!="object"?b.location=v.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(v,b){if(!this.getTerminalById(v))throw new Error(`Cannot resolve terminal with id ${v} for virtual process`);const U=new t(b),z=this.S(v,U);this.h[v]=z}async $acceptActiveTerminalChanged(v){const b=this.b;if(v===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const O=this.getTerminalById(v);O&&(this.b=O,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(v,b){const O=this.getTerminalById(v);O&&this.O.fire({terminal:O.value,data:b})}async $acceptTerminalDimensions(v,b,O){const U=this.getTerminalById(v);U&&U.setDimensions(b,O)&&this.L.fire({terminal:U.value,dimensions:U.value.dimensions})}async $acceptDidExecuteCommand(v,b){const O=this.getTerminalById(v);O&&this.P.fire({terminal:O.value,...b})}async $acceptTerminalMaximumDimensions(v,b,O){this.g.get(v)?.resize(b,O)}async $acceptTerminalTitleChange(v,b){const O=this.getTerminalById(v);O&&(O.name=b)}async $acceptTerminalClosed(v,b,O){const U=this.X(this.f,v);if(U!==null){const z=this.f.splice(U,1)[0];z.setExitStatus(b,O),this.H.fire(z.value)}}$acceptTerminalOpened(v,b,O,U){if(b){const M=this.X(this.f,b);if(M!==null){this.f[M]._id=v,this.I.fire(this.terminals[M]),this.f[M].isOpen=!0;return}}const z={name:U.name,shellPath:U.executable,shellArgs:U.args,cwd:typeof U.cwd=="string"?U.cwd:T.URI.revive(U.cwd),env:U.env,hideFromUser:U.hideFromUser},j=new n(this.a,v,z,O);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(v,b){this.getTerminalById(v)?._setProcessId(b)}async $startExtensionTerminal(v,b){const O=this.getTerminalById(v);if(!O)return{message:(0,l.localize)(0,null,v)};O.isOpen||await new Promise(z=>{const j=this.onDidOpenTerminal(async M=>{M===O.value&&(j.dispose(),z())})});const U=this.g.get(v);U?U.startSendingEvents(b):this.j[v]={initialDimensions:b}}S(v,b){const O=new R.$Tc;O.add(b.onProcessReady(z=>this.a.$sendProcessReady(v,z.pid,z.cwd,z.windowsPty))),O.add(b.onDidChangeProperty(z=>this.a.$sendProcessProperty(v,z))),this.y.startBuffering(v,b.onProcessData),O.add(b.onProcessExit(z=>this.U(v,z))),this.g.set(v,b);const U=this.j[v];return U&&b instanceof t&&(b.startSendingEvents(U.initialDimensions),delete this.j[v]),O}$acceptProcessAckDataEvent(v,b){this.g.get(v)?.acknowledgeDataEvent(b)}$acceptProcessInput(v,b){this.g.get(v)?.input(b)}$acceptTerminalInteraction(v){const b=this.getTerminalById(v);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(v,b){this.getTerminalById(v)?.setSelection(b)}$acceptProcessResize(v,b,O){try{this.g.get(v)?.resize(b,O)}catch(U){if(U.code!=="EPIPE"&&U.code!=="ERR_IPC_CHANNEL_CLOSED")throw U}}$acceptProcessShutdown(v,b){this.g.get(v)?.shutdown(b)}$acceptProcessRequestInitialCwd(v){this.g.get(v)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(v,{type:w.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(v){this.g.get(v)?.getCwd().then(b=>this.a.$sendProcessProperty(v,{type:w.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(v){return Promise.resolve(v)}registerLinkProvider(v){return this.z.add(v),this.z.size===1&&this.a.$startLinkProvider(),new p.$xM(()=>{this.z.delete(v),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(v,b,O){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,O),this.a.$registerProfileProvider(b,v.identifier.value),new p.$xM(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(v,b,O){if(this.D.has(v))throw new Error(`Terminal quick fix provider "${v}" is already registered`);return this.D.set(v,O),this.a.$registerQuickFixProvider(v,b),new p.$xM(()=>{this.D.delete(v),this.a.$unregisterQuickFixProvider(v)})}async $provideTerminalQuickFixes(v,b){const O=new f.$se().token;if(O.isCancellationRequested)return;const U=this.D.get(v);if(!U)return;const z=await U.provideTerminalQuickFixes(b,O);if(z===null||Array.isArray(z)&&z.length===0)return;const j=new R.$Tc;if(this.w.value=j,!Array.isArray(z))return z?$.TerminalQuickFix.from(z,this.Q.converter,j):void 0;const M=[];for(const N of z){const F=$.TerminalQuickFix.from(N,this.Q.converter,j);F&&M.push(F)}return M}async $createContributedProfileTerminal(v,b){const O=new f.$se().token;let U=await this.C.get(v)?.provideTerminalProfile(O);if(!O.isCancellationRequested){if(U&&!("options"in U)&&(U={options:U}),!U||!("options"in U))throw new Error(`No terminal profile options provided for id "${v}"`);if("pty"in U.options){this.createExtensionTerminal(U.options,b);return}this.createTerminalFromOptions(U.options,b)}}async $provideLinks(v,b){const O=this.getTerminalById(v);if(!O)return[];this.F.delete(v),this.G.get(v)?.dispose(!0);const z=new f.$se;this.G.set(v,z);const j=[],M={terminal:O.value,line:b},N=[];for(const se of this.z)N.push(g.Promises.withAsyncBody(async W=>{z.token.onCancellationRequested(()=>W({provider:se,links:[]}));const H=await se.provideTerminalLinks(M,z.token)||[];z.token.isCancellationRequested||W({provider:se,links:H})}));const F=await Promise.all(N);if(z.token.isCancellationRequested)return[];const X=new Map;for(const se of F)se&&se.links.length>0&&j.push(...se.links.map(W=>{const H={id:c++,startIndex:W.startIndex,length:W.length,label:W.tooltip};return X.set(H.id,{provider:se.provider,link:W}),H}));return this.F.set(v,X),j}$activateLink(v,b){const O=this.F.get(v)?.get(b);O&&O.provider.handleTerminalLink(O.link)}U(v,b){this.y.stopBuffering(v),this.g.delete(v),delete this.j[v];const O=this.h[v];O&&(O.dispose(),delete this.h[v]),this.a.$sendProcessExit(v,b)}getTerminalById(v){return this.W(this.f,v)}getTerminalIdByApiObject(v){const b=this.f.findIndex(O=>O.value===v);return b>=0?b:null}W(v,b){const O=this.X(v,b);return O!==null?v[O]:null}X(v,b){const O=v.findIndex(U=>U._id===b);return O>=0?O:null}getEnvironmentVariableCollection(v){let b=this.n.get(v.identifier.value);return b||(b=new s,this.Z(v.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(v,b){const O=(0,D.$us)(b.map),U=(0,D.$vs)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(v,b.persistent,O.length===0?void 0:O,U)}$initEnvironmentVariableCollections(v){v.forEach(b=>{const O=b[0],U=new s(b[1]);this.Z(O,U)})}$acceptDefaultProfile(v,b){const O=this.s;this.s=v,this.u=b,O?.path!==v.path&&this.N.fire(v.path)}Z(v,b){this.n.set(v,b),b.onDidChangeCollection(()=>{this.Y(v,b)})}};e.$Fnc=h,e.$Fnc=h=Ze([Ve(1,i.$jP),Ve(2,L.$ZO)],h);class s{get persistent(){return this.b}set persistent(v){this.b=v,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(v){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new r.$he,this.map=new Map(v)}getScopedEnvironmentVariableCollection(v){const b=this.h(v);let O=this.a.get(b);return O||(O=new m(this,v),this.a.set(b,O),O.onDidChangeCollection(()=>this.d.fire())),O}replace(v,b,O,U){this.f(v,{value:b,type:p.EnvironmentVariableMutatorType.Replace,options:O??{applyAtProcessCreation:!0},scope:U})}append(v,b,O,U){this.f(v,{value:b,type:p.EnvironmentVariableMutatorType.Append,options:O??{applyAtProcessCreation:!0},scope:U})}prepend(v,b,O,U){this.f(v,{value:b,type:p.EnvironmentVariableMutatorType.Prepend,options:O??{applyAtProcessCreation:!0},scope:U})}f(v,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const O=this.g(v,b.scope),U=this.map.get(O),z=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!U||U.value!==b.value||U.type!==b.type||U.options?.applyAtProcessCreation!==z.applyAtProcessCreation||U.options?.applyAtShellIntegration!==z.applyAtShellIntegration||U.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const j=this.g(v,b.scope),M={variable:v,...b,options:z};this.map.set(j,M),this.d.fire()}}get(v,b){const O=this.g(v,b),U=this.map.get(O);return U?k(U):void 0}g(v,b){const O=this.h(b);return O.length?`${v}:::${O}`:v}h(v){return this.j(v?.workspaceFolder)??""}j(v){return v?v.uri.toString():void 0}getVariableMap(v){const b=new Map;for(const[O,U]of this.map)this.h(U.scope)===this.h(v)&&b.set(U.variable,k(U));return b}delete(v,b){const O=this.g(v,b);this.map.delete(O),this.d.fire()}clear(v){if(v?.workspaceFolder){for(const[b,O]of this.map)O.scope?.workspaceFolder?.index===v.workspaceFolder.index&&this.map.delete(b);this.k(v)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(v,b){const O=this.h(b),U=this.descriptionMap.get(O);if(!U||U.description!==v){let z;typeof v=="string"?z=v:z=v?.value.split(`

`)[0];const j={description:z,scope:b};this.descriptionMap.set(O,j),this.d.fire()}}getDescription(v){const b=this.h(v);return this.descriptionMap.get(b)?.description}k(v){const b=this.h(v);this.descriptionMap.delete(b)}}class m{get persistent(){return this.b.persistent}set persistent(v){this.b.persistent=v}get onDidChangeCollection(){return this.a&&this.a.event}constructor(v,b){this.b=v,this.d=b,this.a=new r.$he}getScoped(v){return this.b.getScopedEnvironmentVariableCollection(v)}replace(v,b,O){this.b.replace(v,b,O,this.d)}append(v,b,O){this.b.append(v,b,O,this.d)}prepend(v,b,O){this.b.prepend(v,b,O,this.d)}get(v){return this.b.get(v,this.d)}forEach(v,b){this.b.getVariableMap(this.d).forEach((O,U)=>v.call(b,U,O,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(v){this.b.delete(v,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(v){this.b.setDescription(v,this.d)}get description(){return this.b.getDescription(this.d)}}let y=class extends h{constructor(v,b){super(!1,v,b)}createTerminal(v,b,O){throw new I.$_}createTerminalFromOptions(v,b){throw new I.$_}};e.$Gnc=y,e.$Gnc=y=Ze([Ve(0,i.$jP),Ve(1,L.$ZO)],y);function S(C){if(!(!C||typeof C=="string"))return"id"in C?{id:C.id,color:C.color}:C}function E(C){return d.ThemeColor.isThemeColor(C)?C:void 0}function k(C){const v={...C};return delete v.scope,v.options=v.options??void 0,delete v.variable,v}}),define(Ee[166],Se([1,0,8,3,5,6,20,47,4,2,7]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=e.$Koc=void 0,e.$Koc=(0,P.$Ai)("IExtHostTerminalShellIntegration");let D=class extends u.$Uc{constructor(d,g){super(),this.h=g,this.b=new Map,this.c=new p.$he,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$he,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$he,this.onDidEndTerminalShellExecution=this.g.event,this.a=d.getProxy(T.$vM.MainThreadTerminalShellIntegration),this.B((0,u.$Sc)(()=>{for(const[$,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(d){const g=this.h.getTerminalById(d);if(!g)return;const $=g.value;let i=this.b.get(d);i||(i=new f(g.value,this.f),this.b.set(d,i),i.store.add(g.onWillDispose(()=>this.b.get(d)?.dispose())),i.store.add(i.onDidRequestShellExecution(o=>this.a.$executeCommand(d,o))),i.store.add(i.onDidRequestEndExecution(o=>this.g.fire(o))),i.store.add(i.onDidRequestChangeShellIntegration(o=>this.c.fire(o))),g.shellIntegration=i.value),this.c.fire({terminal:$,shellIntegration:i.value})}$shellExecutionStart(d,g,$,i,o){this.b.has(d)||this.$shellIntegrationChange(d);const n={value:g,confidence:$,isTrusted:i};this.b.get(d)?.startShellExecution(n,o)}$shellExecutionEnd(d,g,$,i,o){const n={value:g,confidence:$,isTrusted:i};this.b.get(d)?.endShellExecution(n,o)}$shellExecutionData(d,g){this.b.get(d)?.emitData(g)}$cwdChange(d,g){this.b.get(d)?.setCwd((0,l.$vc)(g)?l.URI.revive(g):g)}$closeTerminal(d){this.b.get(d)?.dispose(),this.b.delete(d)}};e.$Loc=D,e.$Loc=D=Ze([Ve(0,L.$ZO),Ve(1,R.$Dnc)],D);class f extends u.$Uc{get currentExecution(){return this.a}constructor(d,g){super(),this.j=d,this.m=g,this.b=!1,this.store=this.B(new u.$Tc),this.f=this.B(new p.$he),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$he),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$he),this.onDidRequestEndExecution=this.h.event;const $=this;this.value={get cwd(){return $.c},executeCommand(i,o){let n=i;o&&(n+=` "${o.map(h=>`${h.replaceAll('"','\\"')}`).join('" "')}"`),$.g.fire(n);const t={value:n,confidence:r.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},c=$.startShellExecution(t,$.c,!0).value;return $.b=!0,c}}}startShellExecution(d,g,$){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new A(d,g);$?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(d){this.currentExecution?.emitData(d)}endShellExecution(d,g){this.a&&(this.a.endExecution(d),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:g}),this.a=void 0)}setCwd(d){let g=!1;l.URI.isUri(this.c)?g=!l.URI.isUri(d)||this.c.toString()!==d.toString():this.c!==d&&(g=!0),g&&(this.c=d,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class A{constructor(d,g){this.c=d,this.cwd=g,this.b=!1;const $=this;this.value={get commandLine(){return $.c},get cwd(){return $.cwd},read(){return $.d()}}}d(){if(!this.a){if(this.b)return I.$1h.EMPTY;this.a=new w}return this.a.createIterable()}emitData(d){this.a?.emitData(d)}endExecution(d){d&&(this.c=d),this.a?.endExecution(),this.a=void 0,this.b=!0}}class w extends u.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$zh);const d=this.a;return new I.$1h(async $=>{this.b.push($),await d.wait()})}emitData(d){for(const g of this.b)g.emitOne(d)}endExecution(){this.a?.open(),this.a=void 0}}});var Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)},rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r};define(Ee[368],Se([1,0,7,22,21,4,80,61,3,41,18,33,12,6,20,165,17,8,312,73,121,74,26]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n,t){"use strict";var c,h,s,m,y;Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=e.$Ooc=e.$Noc=e.$Moc=void 0;let S=0;const E=new WeakMap;let k=class extends p.$Uc{constructor(V,x,he,ne){super(),this.C=x,this.D=he,this.F=ne,this.f=this.B(new T.$he),this.g=new Map,this.w=this.B(new T.$he),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=V.getProxy(A.$vM.MainThreadTesting),this.m=new N(this.h),this.j=new O(this.h,x),he.registerArgumentProcessor({processArgument:we=>{switch(we?.$mid){case l.MarshalledId.TestItemContext:{const pe=we,ce=pe.tests[pe.tests.length-1].item.extId;return this.g.get(i.$hL.root(ce))?.collection.tree.get(ce)?.actual??(0,a.$_O)(we)}case l.MarshalledId.TestMessageMenuArgs:{const{test:pe,message:ce}=we,K=pe.item.extId;return{test:this.g.get(i.$hL.root(K))?.collection.tree.get(K)?.actual??(0,a.$_O)({$mid:l.MarshalledId.TestItemContext,tests:[pe]}),message:d.TestMessage.to(ce)}}default:return we}}}),he.registerCommand(!1,"testing.getExplorerSelection",async()=>{const we=await he.executeCommand($.TestCommandId.GetExplorerSelection),pe=ce=>{const K=this.g.get(i.$hL.root(ce));if(K)return i.$hL.isRoot(ce)?K.controller:K.collection.tree.get(ce)?.actual};return{include:we?.include.map(pe).filter(I.$ig)||[],exclude:we?.exclude.map(pe).filter(I.$ig)||[]}})}createTestController(V,x,he,ne){if(this.g.has(x))throw new Error(`Attempt to insert a duplicate controller with ID "${x}"`);const we=new p.$Tc,pe=we.add(new a.$cP(x,he,this.F));pe.root.label=he;const ce=new Map,K=new Set,de=this.h,te={items:pe.root.children,get label(){return he},set label(ie){he=ie,pe.root.label=ie,de.$updateController(x,{label:he})},get refreshHandler(){return ne},set refreshHandler(ie){ne=ie,de.$updateController(x,{canRefresh:!!ie})},get id(){return x},createRunProfile:(ie,le,Z,ae,$e,be)=>{let Me=(0,R.$oj)(ie);for(;ce.has(Me);)Me++;return new X(this.h,ce,K,this.w.event,x,Me,ie,le,Z,ae,$e,be)},createTestItem(ie,le,Z){return new a.$aP(x,ie,le,Z)},createTestRun:(ie,le,Z=!0)=>this.j.createTestRun(V,x,pe,ie,le,Z),invalidateTestResults:ie=>{if(ie===void 0)this.h.$markTestRetired(void 0);else{const le=ie instanceof Array?ie:[ie];this.h.$markTestRetired(le.map(Z=>i.$hL.fromExtHostTestItem(Z,x).toString()))}},set resolveHandler(ie){pe.resolveHandler=ie},get resolveHandler(){return pe.resolveHandler},dispose:()=>{we.dispose()}};de.$registerTestController(x,he,!!ne),we.add((0,p.$Sc)(()=>de.$unregisterTestController(x)));const ee={controller:te,collection:pe,profiles:ce,extension:V,activeProfiles:K};return this.g.set(x,ee),we.add((0,p.$Sc)(()=>this.g.delete(x))),we.add(pe.onDidGenerateDiff(ie=>de.$publishDiff(x,ie.map(n.TestsDiffOp.serialize)))),te}createTestObserver(){return this.m.checkout()}async runTests(V,x=P.CancellationToken.None){const he=U(V);if(!he)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ne=this.g.get(he.controllerId);if(!ne)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:V.preserveFocus??!0,targets:[{testIds:V.include?.map(we=>i.$hL.fromExtHostTestItem(we,ne.collection.root.id).toString())??[ne.collection.root.id],profileGroup:se[he.kind],profileId:he.profileId,controllerId:he.controllerId}],exclude:V.exclude?.map(we=>we.id)},x)}registerTestFollowupProvider(V){return this.y.add(V),{dispose:()=>{this.y.delete(V)}}}$syncTests(){for(const{collection:V}of this.g.values())V.flushDiff();return Promise.resolve()}async $getCoverageDetails(V,x){return(await this.j.getCoverageDetails(V,x))?.map(d.TestCoverage.fromDetails)}async $disposeRun(V){this.j.disposeTestRun(V)}$configureRunProfile(V,x){this.g.get(V)?.profiles.get(x)?.configureHandler?.()}$setDefaultRunProfiles(V){const x=new Map;for(const[he,ne]of Object.entries(V)){const we=this.g.get(he);if(!we)continue;const pe=new Map,ce=ne.filter(de=>!we.activeProfiles.has(de)),K=[...we.activeProfiles].filter(de=>!ne.includes(de));for(const de of ce)pe.set(de,!0),we.activeProfiles.add(de);for(const de of K)pe.set(de,!1),we.activeProfiles.delete(de);pe.size&&x.set(he,pe)}this.w.fire(x)}async $refreshTests(V,x){await this.g.get(V)?.controller.refreshHandler?.(x)}$publishTestResults(V){this.results=Object.freeze(V.map(x=>{const he=d.TestResults.to(x);return E.set(he,x.id),he}).concat(this.results).sort((x,he)=>he.completedAt-x.completedAt).slice(0,32)),this.f.fire()}async $expandTest(V,x){const he=this.g.get(i.$hL.fromString(V).controllerId)?.collection;he&&(await he.expand(V,x<0?1/0:x),he.flushDiff())}$acceptDiff(V){this.m.applyDiff(V.map(x=>n.TestsDiffOp.deserialize({asCanonicalUri:he=>he},x)))}async $runControllerTests(V,x){return Promise.all(V.map(he=>this.G(he,!1,x)))}async $startContinuousRun(V,x){const he=new P.$se(x),ne=await Promise.all(V.map(we=>this.G(we,!0,he.token)));return!x.isCancellationRequested&&!ne.some(we=>we.error)&&await new Promise(we=>x.onCancellationRequested(we)),he.dispose(!0),ne}async $provideTestFollowups(V,x){const he=this.results.find(pe=>E.get(pe)===V.resultId),ne=he&&W(i.$hL.fromString(V.extId),he?.results);if(!ne)return[];let we=[];return await Promise.all([...this.y].map(async pe=>{try{const ce=await pe.provideFollowup(he,ne,V.taskIndex,V.messageIndex,x);ce&&(we=we.concat(ce))}catch(ce){this.C.error("Error thrown while providing followup for test message",ce)}})),x.isCancellationRequested?[]:we.map(pe=>{const ce=S++;return this.z.set(ce,pe),{title:pe.title,id:ce}})}$disposeTestFollowups(V){for(const x of V)this.z.delete(x)}$executeTestFollowup(V){const x=this.z.get(V);return x?this.D.executeCommand(x.command,...x.arguments||[]):Promise.resolve()}async G(V,x,he){const ne=this.g.get(V.controllerId);if(!ne)return{};const{collection:we,profiles:pe,extension:ce}=ne,K=pe.get(V.profileId);if(!K)return{};const de=V.testIds.map(le=>we.tree.get(le)).filter(I.$ig),te=V.excludeExtIds.map(le=>ne.collection.tree.get(le)).filter(I.$ig).filter(le=>de.some(Z=>Z.fullId.compare(le.fullId)===i.TestPosition.IsChild));if(!de.length)return{};const ee=new g.$$N(de.some(le=>le.actual instanceof a.$bP)?void 0:de.map(le=>le.actual),te.map(le=>le.actual),K,x),ie=(0,n.$kL)(V)&&this.j.prepareForMainThreadTestRun(ce,ee,z.fromInternal(V,ne.collection),K,he);try{return await K.runHandler(ee,he),{}}catch(le){return{error:String(le)}}finally{ie&&ie.hasRunningTasks&&!he.isCancellationRequested&&await T.Event.toPromise(ie.onEnd)}}$cancelExtensionTestRun(V){V===void 0?this.j.cancelAllRuns():this.j.cancelRunById(V)}};e.$Moc=k,e.$Moc=k=Ze([Ve(0,w.$ZO),Ve(1,f.$7j)],k);const C=1e4;var v;(function(H){H[H.Running=0]="Running",H[H.Cancelling=1]="Cancelling",H[H.Ended=2]="Ended"})(v||(v={}));class b extends p.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(V,x,he,ne,we,pe){super(),this.z=V,this.C=x,this.D=he,this.F=ne,this.G=we,this.c=v.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new T.$he),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new P.$se(pe));const ce=this.B(new r.$Mh(()=>this.H(),C));this.B(this.j.token.onCancellationRequested(()=>ce.schedule()));const K=new T.$he;this.w=K.event,this.B((0,p.$Sc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===v.Running?(this.j.cancel(),this.c=v.Cancelling):this.c===v.Cancelling&&this.H()}getCoverageDetails(V,x){const[,he]=i.$hL.fromString(V).path,ne=this.y.get(V);if(!ne)return[];const we=this.g.get(he);if(!we)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(we.run,ne,x)??[]}createRun(V){const x=this.z.id,he=this.z.controllerId,ne=(0,D.$Wg)(),we=te=>(ee,...ie)=>{if(ce){this.D.warn(`Setting the state of test "${ee.id}" is a no-op after the run ends.`);return}this.z.isIncluded(ee)&&(this.J(ee),te(ee,...ie))},pe=(te,ee)=>{const ie=ee instanceof Array?ee.map(d.TestMessage.from):[d.TestMessage.from(ee)];if(te.uri&&te.range){const le={range:d.Range.from(te.range),uri:te.uri};for(const Z of ie)Z.location=Z.location||le}this.C.$appendTestMessagesInRun(x,ne,i.$hL.fromExtHostTestItem(te,he).toString(),ie)};let ce=!1;const K=new Map,de={isPersisted:this.z.isPersisted,token:this.j.token,name:V,onDidDispose:this.w,addCoverage:te=>{if(ce)return;const ee=te instanceof g.$dO?te.testItem:void 0;let ie;if(ee){if((0,t.$VG)(this.G,"attributableCoverage"),!this.z.isIncluded(ee))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.J(ee),ie=K.get(ee),ie===void 0&&(ie=K.size,K.set(ee,ie))}const le=te.uri.toString(),Z=new i.$hL(ie!==void 0?[x,ne,le,String(ie)]:[x,ne,le]).toString();this.y.set(Z,te),this.C.$appendCoverage(x,ne,d.TestCoverage.fromFile(he,Z,te))},enqueued:we(te=>{this.C.$updateTestStateInRun(x,ne,i.$hL.fromExtHostTestItem(te,he).toString(),n.TestResultState.Queued)}),skipped:we(te=>{this.C.$updateTestStateInRun(x,ne,i.$hL.fromExtHostTestItem(te,he).toString(),n.TestResultState.Skipped)}),started:we(te=>{this.C.$updateTestStateInRun(x,ne,i.$hL.fromExtHostTestItem(te,he).toString(),n.TestResultState.Running)}),errored:we((te,ee,ie)=>{pe(te,ee),this.C.$updateTestStateInRun(x,ne,i.$hL.fromExtHostTestItem(te,he).toString(),n.TestResultState.Errored,ie)}),failed:we((te,ee,ie)=>{pe(te,ee),this.C.$updateTestStateInRun(x,ne,i.$hL.fromExtHostTestItem(te,he).toString(),n.TestResultState.Failed,ie)}),passed:we((te,ee)=>{this.C.$updateTestStateInRun(x,ne,i.$hL.fromExtHostTestItem(te,this.z.controllerId).toString(),n.TestResultState.Passed,ee)}),appendOutput:(te,ee,ie)=>{ce||(ie&&(this.z.isIncluded(ie)?this.J(ie):ie=void 0),this.C.$appendOutputToRun(x,ne,u.$Je.fromString(te),ee&&d.location.from(ee),ie&&i.$hL.fromExtHostTestItem(ie,he).toString()))},end:()=>{ce||(ce=!0,K.clear(),this.C.$finishedTestRunTask(x,ne),--this.f||this.I())}};return this.f++,this.g.set(ne,{run:de}),this.C.$startedTestRunTask(x,{id:ne,name:V,running:!0}),de}H(){for(const{run:V}of this.g.values())V.end()}I(){this.c!==v.Ended&&(this.c=v.Ended,this.m.fire())}J(V){if(!(V instanceof a.$aP))throw new o.$RO(V.id);if(this.h.has(i.$hL.fromExtHostTestItem(V,this.z.controllerId).toString()))return;const x=[],he=this.z.colllection.root;for(;;){const ne=d.TestItem.from(V);if(x.unshift(ne),this.h.has(ne.extId)||(this.h.add(ne.extId),V===he))break;V=V.parent||he}this.C.$addTestsToRun(this.z.controllerId,this.z.id,x)}dispose(){this.I(),super.dispose()}}class O{get trackers(){return this.c.values()}constructor(V,x){this.g=V,this.h=x,this.c=new Map,this.f=new Map}getCoverageDetails(V,x){const he=i.$hL.root(V);return this.f.get(he)?.getCoverageDetails(V,x)||[]}disposeTestRun(V){this.f.get(V)?.dispose(),this.f.delete(V);for(const[x,{id:he}]of this.c)he===V&&this.c.delete(x)}prepareForMainThreadTestRun(V,x,he,ne,we){return this.j(x,he,ne,V,we)}cancelRunById(V){this.f.get(V)?.cancel()}cancelAllRuns(){for(const V of this.c.values())V.cancel()}createTestRun(V,x,he,ne,we,pe){const ce=this.c.get(ne);if(ce)return ce.createRun(we);const K=z.fromPublic(x,he,ne,pe),de=U(ne);this.g.$startedExtensionTestRun({controllerId:x,continuous:!!ne.continuous,profile:de&&{group:se[de.kind],id:de.profileId},exclude:ne.exclude?.map(ee=>i.$hL.fromExtHostTestItem(ee,he.root.id).toString())??[],id:K.id,include:ne.include?.map(ee=>i.$hL.fromExtHostTestItem(ee,he.root.id).toString())??[he.root.id],preserveFocus:ne.preserveFocus??!0,persist:pe});const te=this.j(ne,K,ne.profile,V);return T.Event.once(te.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),te.createRun(we)}j(V,x,he,ne,we){const pe=new b(x,this.g,this.h,he,ne,we);return this.c.set(V,pe),this.f.set(pe.id,pe),pe}}e.$Noc=O;const U=H=>{if(H.profile){if(!(H.profile instanceof X))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return H.profile}};class z{static fromPublic(V,x,he,ne){return new z(V,(0,D.$Wg)(),he.include?.map(we=>i.$hL.fromExtHostTestItem(we,V).toString())??[V],he.exclude?.map(we=>i.$hL.fromExtHostTestItem(we,V).toString())??[],ne,x)}static fromInternal(V,x){return new z(V.controllerId,V.runId,V.testIds,V.excludeExtIds,!0,x)}constructor(V,x,he,ne,we,pe){this.controllerId=V,this.id=x,this.isPersisted=we,this.colllection=pe,this.c=he.map(ce=>ce+i.TestIdPathParts.Delimiter),this.f=ne.map(ce=>ce+i.TestIdPathParts.Delimiter)}isIncluded(V){const x=i.$hL.fromExtHostTestItem(V,this.controllerId).toString()+i.TestIdPathParts.Delimiter;for(const he of this.f)if(x===he||x.startsWith(he))return!1;for(const he of this.c)if(x===he||x.startsWith(he))return!0;return!1}}e.$Ooc=z;class j{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(V){this.j=V,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(V){this.c.add(V)}update(V){Object.assign(V.revived,d.TestItem.toPlain(V.item)),this.c.has(V)||this.f.add(V)}remove(V){if(this.c.has(V)){this.c.delete(V);return}this.f.delete(V);const x=i.$hL.parentId(V.item.extId);if(x&&this.h.has(x.toString())){this.h.add(V.item.extId);return}this.g.add(V)}getChangeEvent(){const{c:V,f:x,g:he}=this;return{get added(){return[...V].map(ne=>ne.revived)},get updated(){return[...x].map(ne=>ne.revived)},get removed(){return[...he].map(ne=>ne.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class M extends n.$qL{constructor(){super(...arguments),this.y=new T.$he,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(V){return this.f.get(V)}getMirroredTestDataByReference(V){return this.f.get(V.id)}x(V,x){return{...V,revived:d.TestItem.toPlain(V.item),depth:x?x.depth+1:0,children:new Set}}w(){return new j(this.y)}}class N{constructor(V){this.f=V}checkout(){this.c||(this.c=this.g());const V=this.c;return V.observers++,{onDidChangeTest:V.tests.onDidChangeTests,get tests(){return[...V.tests.rootTests].map(x=>x.revived)},dispose:(0,L.$db)(()=>{--V.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(V){return this.c?.tests.getMirroredTestDataByReference(V)}applyDiff(V){this.c?.tests.apply(V)}g(){const V=new M({asCanonicalUri:x=>x});return this.f.$subscribeToDiffs(),{observers:0,tests:V}}}const F=(H,V,x,he)=>{x?Object.assign(x,he):V.$updateTestRunConfig(H.controllerId,H.profileId,he)};class X{get label(){return this.f}set label(V){V!==this.f&&(this.f=V,F(this,Ge(this,c,"f"),Ge(this,m,"f"),{label:V}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(V){V!==this.g&&(this.g=V,F(this,Ge(this,c,"f"),Ge(this,m,"f"),{supportsContinuousRun:V}))}get isDefault(){return Ge(this,h,"f").has(this.profileId)}set isDefault(V){V!==this.isDefault&&(V?Ge(this,h,"f").add(this.profileId):Ge(this,h,"f").delete(this.profileId),F(this,Ge(this,c,"f"),Ge(this,m,"f"),{isDefault:V}))}get tag(){return this._tag}set tag(V){V?.id!==this._tag?.id&&(this._tag=V,F(this,Ge(this,c,"f"),Ge(this,m,"f"),{tag:V?d.TestTag.namespace(this.controllerId,V.id):null}))}get configureHandler(){return this.c}set configureHandler(V){V!==this.c&&(this.c=V,F(this,Ge(this,c,"f"),Ge(this,m,"f"),{hasConfigurationHandler:!!V}))}get onDidChangeDefault(){return T.Event.chain(Ge(this,s,"f"),V=>V.map(x=>x.get(this.controllerId)?.get(this.profileId)).filter(I.$ig))}constructor(V,x,he,ne,we,pe,ce,K,de,te=!1,ee=void 0,ie=!1){this.controllerId=we,this.profileId=pe,this.f=ce,this.kind=K,this.runHandler=de,this._tag=ee,this.g=ie,c.set(this,void 0),h.set(this,void 0),s.set(this,void 0),m.set(this,void 0),y.set(this,void 0),rt(this,c,V,"f"),rt(this,y,x,"f"),rt(this,h,he,"f"),rt(this,s,ne,"f"),x.set(pe,this);const le=se[K];if(typeof le!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);te&&he.add(pe),rt(this,m,{profileId:pe,controllerId:we,tag:ee?d.TestTag.namespace(this.controllerId,ee.id):null,label:ce,group:le,isDefault:te,hasConfigurationHandler:!1,supportsContinuousRun:ie},"f"),queueMicrotask(()=>{Ge(this,m,"f")&&(Ge(this,c,"f").$publishTestRunProfile(Ge(this,m,"f")),rt(this,m,void 0,"f"))})}dispose(){Ge(this,y,"f")?.delete(this.profileId)&&(rt(this,y,void 0,"f"),Ge(this,c,"f").$removeTestProfile(this.controllerId,this.profileId)),rt(this,m,void 0,"f")}}e.$Poc=X,c=new WeakMap,h=new WeakMap,s=new WeakMap,m=new WeakMap,y=new WeakMap;const se={[g.TestRunProfileKind.Coverage]:n.TestRunProfileBitset.Coverage,[g.TestRunProfileKind.Debug]:n.TestRunProfileBitset.Debug,[g.TestRunProfileKind.Run]:n.TestRunProfileBitset.Run};function W(H,V){for(let x=0;x<H.path.length;x++){const he=V.find(ne=>ne.id===H.path[x]);if(!he)return;if(x===H.path.length-1)return he;V=he.children}}}),define(Ee[167],Se([1,0,65,14,133,17,8]),function(oe,e,r,u,P,T,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=e.$7O=void 0;class R{constructor(f,A,w){const a=R.c.nextId();f.$registerTextEditorDecorationType(A.identifier,a,T.DecorationRenderOptions.from(w)),this.value=Object.freeze({key:a,dispose(){f.$removeTextEditorDecorationType(a)}})}}e.$7O=R,R.c=new P.$5O("TextEditorDecorationType");class p{constructor(f,A){this.g=[],this.h=void 0,this.j=!1,this.c=f,this.d=f.version,this.e=A.undoStopBefore,this.f=A.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(f,A){this.k();let w=null;if(f instanceof L.$yM)w=new L.$zM(f,f);else if(f instanceof L.$zM)w=f;else throw new Error("Unrecognized location");this.l(w,A,!1)}insert(f,A){this.k(),this.l(new L.$zM(f,f),A,!0)}delete(f){this.k();let A=null;if(f instanceof L.$zM)A=f;else throw new Error("Unrecognized location");this.l(A,null,!0)}l(f,A,w){const a=this.c.validateRange(f);this.g.push({range:a,text:A,forceMoveMarkers:w})}setEndOfLine(f){if(this.k(),f!==L.EndOfLine.LF&&f!==L.EndOfLine.CRLF)throw(0,u.$7)("endOfLine");this.h=f}}class l{constructor(f,A,w,a){this.c=f,this.d=A,this._accept(w),this.e=a;const d=this;this.value={get tabSize(){return d.f},set tabSize(g){d.n(g)},get indentSize(){return d.g},set indentSize(g){d.p(g)},get insertSpaces(){return d.j},set insertSpaces(g){d.s(g)},get cursorStyle(){return d.k},set cursorStyle(g){d.t(g)},get lineNumbers(){return d.l},set lineNumbers(g){d.u(g)}}}_accept(f){this.f=f.tabSize,this.g=f.indentSize,this.h=f.originalIndentSize,this.j=f.insertSpaces,this.k=f.cursorStyle,this.l=T.TextEditorLineNumbersStyle.to(f.lineNumbers)}m(f){if(f==="auto")return"auto";if(typeof f=="number"){const A=Math.floor(f);return A>0?A:null}if(typeof f=="string"){const A=parseInt(f,10);return isNaN(A)?null:A>0?A:null}return null}n(f){const A=this.m(f);if(A!==null){if(typeof A=="number"){if(this.f===A)return;this.f=A}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:A}))}}o(f){if(f==="tabSize")return"tabSize";if(typeof f=="number"){const A=Math.floor(f);return A>0?A:null}if(typeof f=="string"){const A=parseInt(f,10);return isNaN(A)?null:A>0?A:null}return null}p(f){const A=this.o(f);if(A!==null){if(typeof A=="number"){if(this.h===A)return;this.g=A,this.h=A}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:A}))}}q(f){return f==="auto"?"auto":f==="false"?!1:!!f}s(f){const A=this.q(f);if(typeof A=="boolean"){if(this.j===A)return;this.j=A}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:A}))}t(f){this.k!==f&&(this.k=f,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:f})))}u(f){this.l!==f&&(this.l=f,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(f)})))}assign(f){const A={};let w=!1;if(typeof f.tabSize<"u"){const a=this.m(f.tabSize);a==="auto"?(w=!0,A.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,w=!0,A.tabSize=a)}if(typeof f.indentSize<"u"){const a=this.o(f.indentSize);a==="tabSize"?(w=!0,A.indentSize=a):typeof a=="number"&&this.h!==a&&(this.g=a,this.h=a,w=!0,A.indentSize=a)}if(typeof f.insertSpaces<"u"){const a=this.q(f.insertSpaces);a==="auto"?(w=!0,A.insertSpaces=a):this.j!==a&&(this.j=a,w=!0,A.insertSpaces=a)}typeof f.cursorStyle<"u"&&this.k!==f.cursorStyle&&(this.k=f.cursorStyle,w=!0,A.cursorStyle=f.cursorStyle),typeof f.lineNumbers<"u"&&this.l!==f.lineNumbers&&(this.l=f.lineNumbers,w=!0,A.lineNumbers=T.TextEditorLineNumbersStyle.from(f.lineNumbers)),w&&this.v("setOptions",this.c.$trySetOptions(this.d,A))}v(f,A){A.catch(w=>{this.e.warn(`ExtHostTextEditorOptions '${f}' failed:'`),this.e.warn(w)})}}e.$8O=l;class I{constructor(f,A,w,a,d,g,$,i){this.id=f,this.j=A,this.k=w,this.g=!1,this.h=new Set,this.c=d,this.d=new l(this.j,this.id,g,w),this.e=$,this.f=i;const o=this;this.value=Object.freeze({get document(){return a.value},set document(n){throw new u.$9("document")},get selection(){return o.c&&o.c[0]},set selection(n){if(!(n instanceof L.$AM))throw(0,u.$7)("selection");o.c=[n],o.l()},get selections(){return o.c},set selections(n){if(!Array.isArray(n)||n.some(t=>!(t instanceof L.$AM)))throw(0,u.$7)("selections");o.c=n,o.l()},get visibleRanges(){return o.e},set visibleRanges(n){throw new u.$9("visibleRanges")},get options(){return o.d.value},set options(n){o.g||o.d.assign(n)},get viewColumn(){return o.f},set viewColumn(n){throw new u.$9("viewColumn")},edit(n,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const c=new p(a.value,t);return n(c),o.m(c)},insertSnippet(n,t,c={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=o.c.map(s=>T.Range.from(s));else if(t instanceof L.$yM){const{lineNumber:s,column:m}=T.Position.from(t);h=[{startLineNumber:s,startColumn:m,endLineNumber:s,endColumn:m}]}else if(t instanceof L.$zM)h=[T.Range.from(t)];else{h=[];for(const s of t)if(s instanceof L.$zM)h.push(T.Range.from(s));else{const{lineNumber:m,column:y}=T.Position.from(s);h.push({startLineNumber:m,startColumn:y,endLineNumber:m,endColumn:y})}}return A.$tryInsertSnippet(f,a.value.version,n.value,h,c)},setDecorations(n,t){const c=t.length===0;c&&!o.h.has(n.key)||(c?o.h.delete(n.key):o.h.add(n.key),o.n(()=>{if(T.$WO(t))return A.$trySetDecorations(f,n.key,T.$XO(t));{const h=new Array(4*t.length);for(let s=0,m=t.length;s<m;s++){const y=t[s];h[4*s]=y.start.line+1,h[4*s+1]=y.start.character+1,h[4*s+2]=y.end.line+1,h[4*s+3]=y.end.character+1}return A.$trySetDecorationsFast(f,n.key,h)}}))},revealRange(n,t){o.n(()=>A.$tryRevealRange(f,T.Range.from(n),t||L.TextEditorRevealType.Default))},show(n){A.$tryShowEditor(f,T.ViewColumn.from(n))},hide(){A.$tryHideEditor(f)}})}dispose(){(0,r.ok)(!this.g),this.g=!0}_acceptOptions(f){(0,r.ok)(!this.g),this.d._accept(f)}_acceptVisibleRanges(f){(0,r.ok)(!this.g),this.e=f}_acceptViewColumn(f){(0,r.ok)(!this.g),this.f=f}_acceptSelections(f){(0,r.ok)(!this.g),this.c=f}async l(){const f=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,f)),this.value}m(f){const A=f.finalize();if(A.edits.length===0&&!A.setEndOfLine)return Promise.resolve(!0);const w=A.edits.map(d=>d.range);w.sort((d,g)=>d.end.line===g.end.line?d.end.character===g.end.character?d.start.line===g.start.line?d.start.character-g.start.character:d.start.line-g.start.line:d.end.character-g.end.character:d.end.line-g.end.line);for(let d=0,g=w.length-1;d<g;d++){const $=w[d].end;if(w[d+1].start.isBefore($))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=A.edits.map(d=>({range:T.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,A.documentVersionId,a,{setEndOfLine:typeof A.setEndOfLine=="number"?T.EndOfLine.from(A.setEndOfLine):void 0,undoStopBefore:A.undoStopBefore,undoStopAfter:A.undoStopAfter})}n(f){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):f().then(()=>this,A=>(A instanceof Error&&A.name==="DISPOSED"||this.k.warn(A),null))}}e.$9O=I}),define(Ee[78],Se([1,0,65,4,3,2,5,6,163,20,167,17,12,29,15,40,49]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=e.$0O=void 0;class g{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let $=class{constructor(o,n){this.h=o,this.i=n,this.a=null,this.b=new Map,this.c=new A.$Ac,this.d=new u.$he,this.e=new u.$he,this.f=new u.$he,this.g=new u.$he,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const n=[],t=[],c=[];if(o.removedDocuments)for(const h of o.removedDocuments){const s=T.URI.revive(h),m=this.c.get(s);m?.unref()&&(this.c.delete(s),n.push(m.value))}if(o.addedDocuments)for(const h of o.addedDocuments){const s=T.URI.revive(h.uri);let m=this.c.get(s);if(m&&s.scheme!==w.Schemas.vscodeNotebookCell&&s.scheme!==w.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);m||(m=new g(new p.$3O(this.h.getProxy(R.$vM.MainThreadDocuments),s,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty)),this.c.set(s,m),t.push(m.value)),m.ref()}if(o.removedEditors)for(const h of o.removedEditors){const s=this.b.get(h);this.b.delete(h),s&&c.push(s)}if(o.addedEditors)for(const h of o.addedEditors){const s=T.URI.revive(h.documentUri);r.ok(this.c.has(s),`document '${s}' does not exist`),r.ok(!this.b.has(h.id),`editor '${h.id}' already exists!`);const m=this.c.get(s).value,y=new I.$9O(h.id,this.h.getProxy(R.$vM.MainThreadTextEditors),this.i,new d.$V(()=>m.document),h.selections.map(D.Selection.to),h.options,h.visibleRanges.map(S=>D.Range.to(S)),typeof h.editorPosition=="number"?D.ViewColumn.to(h.editorPosition):void 0);this.b.set(h.id,y)}o.newActiveEditor!==void 0&&(r.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,P.$Pc)(n),(0,P.$Pc)(c),o.removedDocuments&&this.e.fire(n),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(h=>h.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return a.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const n=this.b.get(this.a);return o?n:n?.value}allEditors(){return[...this.b.values()]}};e.$0O=$,e.$0O=$=Ze([Ve(0,l.$ZO),Ve(1,f.$7j)],$),e.$$O=(0,L.$Ai)("IExtHostDocumentsAndEditors")}),define(Ee[369],Se([1,0,19,4,6,167,17,8]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=void 0;class p{constructor(I,D){this.i=D,this.a=new u.$he,this.b=new u.$he,this.c=new u.$he,this.d=new u.$he,this.f=new u.$he,this.g=new u.$he,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(P.$vM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(f=>this.g.fire(f)),this.i.onDidChangeActiveTextEditor(f=>this.f.fire(f))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const D=this.i.allEditors();return I?D:D.map(f=>f.value)}async showTextDocument(I,D,f){let A;typeof D=="number"?A={position:L.ViewColumn.from(D),preserveFocus:f}:typeof D=="object"?A={position:L.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?L.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:A={preserveFocus:!1};const w=await this.h.$tryShowTextDocument(I.uri,A),a=w&&this.i.getEditor(w);if(a)return a.value;throw w?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,D){return new T.$7O(this.h,I,D).value}$acceptEditorPropertiesChanged(I,D){const f=this.i.getEditor(I);if(!f)throw new Error("unknown text editor");if(D.options&&f._acceptOptions(D.options),D.selections){const A=D.selections.selections.map(L.Selection.to);f._acceptSelections(A)}if(D.visibleRanges){const A=r.$Hb(D.visibleRanges.map(L.Range.to));f._acceptVisibleRanges(A)}if(D.options&&this.b.fire({textEditor:f.value,options:{...D.options,lineNumbers:L.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const A=R.TextEditorSelectionChangeKind.fromValue(D.selections.source),w=D.selections.selections.map(L.Selection.to);this.a.fire({textEditor:f.value,selections:w,kind:A})}if(D.visibleRanges){const A=r.$Hb(D.visibleRanges.map(L.Range.to));this.c.fire({textEditor:f.value,visibleRanges:A})}}$acceptEditorPositionData(I){for(const D in I){const f=this.i.getEditor(D);if(!f)throw new Error("Unknown text editor");const A=L.ViewColumn.to(I[D]);f.value.viewColumn!==A&&(f._acceptViewColumn(A),this.d.fire({textEditor:f.value,viewColumn:A}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$9mc=p}),define(Ee[370],Se([1,0,2,5,6,3,8,17,24,41,18]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=e.$Roc=void 0,e.$Roc=(0,u.$Ai)("IExtHostTimeline");class D{constructor(w,a){this.b=new Map,this.c=new Map,this.a=w.getProxy(P.$vM.MainThreadTimeline),a.registerArgumentProcessor({processArgument:(d,g)=>{if(d&&d.$mid===l.MarshalledId.TimelineActionContext)if(this.b.get(d.source)&&p.$Xm.equals(g,this.b.get(d.source)?.extension)){const $=d.uri===void 0?void 0:r.URI.revive(d.uri);return this.c.get(d.source)?.get(f($))?.get(d.handle)}else return;return d}})}async $getTimeline(w,a,d,g){return this.b.get(w)?.provider.provideTimeline(r.URI.revive(a),d,g)}registerTimelineProvider(w,a,d,g){const $=new T.$Tc,i=this.d(a.id,g,$).bind(this);let o;a.onDidChange&&(o=a.onDidChange(t=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...t,id:a.id}),this));const n=this.c;return this.f({...a,scheme:w,onDidChange:void 0,async provideTimeline(t,c,h){c?.resetCache&&($.clear(),n.get(a.id)?.clear());const s=await a.provideTimeline(t,c,h);if(s==null)return;const m=i(t,c);return{...s,source:a.id,items:s.items.map(m)}},dispose(){for(const t of n.values())t.get(a.id)?.clear();o?.dispose(),$.dispose()}},d)}d(w,a,d){return(g,$)=>{let i;if($?.cacheResults){let o=this.c.get(w);o===void 0&&(o=new Map,this.c.set(w,o));const n=f(g);i=o.get(n),i===void 0&&(i=new Map,o.set(n,i))}return o=>{const{iconPath:n,...t}=o,c=`${w}|${o.id??o.timestamp}`;i?.set(c,o);let h,s,m;o.iconPath&&(n instanceof L.$uN?m={id:n.id,color:n.color}:r.URI.isUri(n)?(h=n,s=n):{light:h,dark:s}=n);let y;return L.$ZM.isMarkdownString(t.tooltip)?y=R.MarkdownString.from(t.tooltip):(0,I.$ag)(t.tooltip)?y=t.tooltip:L.$ZM.isMarkdownString(t.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=R.MarkdownString.from(t.detail)):(0,I.$ag)(t.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),y=t.detail),{...t,id:t.id??void 0,handle:c,source:w,command:o.command?a.toInternal(o.command,d):void 0,icon:h,iconDark:s,themeIcon:m,tooltip:y,accessibilityInformation:o.accessibilityInformation}}}}f(w,a){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:a}),(0,T.$Sc)(()=>{for(const g of this.c.values())g.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$Soc=D;function f(A){return A?.toString()}}),define(Ee[371],Se([1,0,241,23,2,4,3,302,7,8,18,19,17,86,21,207,26]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;function g(o,n){if((0,I.$ag)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(c=>c.length===2&&typeof c[0]=="number"&&typeof c[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class $ extends L.$Uc{constructor(n,t,c){super(),this.f=n,this.g=t,this.h=c,this.a=new Map,this.b=new a.$d$;function h(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:s=>h(s)?this.r(s):Array.isArray(s)&&s.length>0?s.map(m=>h(m)?this.r(m):m):s})}registerTreeDataProvider(n,t,c){const h=this.createTreeView(n,{treeDataProvider:t},c);return{dispose:()=>h.dispose()}}createTreeView(n,t,c){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],s=t.dragAndDropController?.dragMimeTypes??[],m=!!t.dragAndDropController?.handleDrag,y=!!t.dragAndDropController?.handleDrop,S=this.m(n,t,c),E={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:s,hasHandleDrag:m,hasHandleDrop:y,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},k=this.f.$registerTreeViewDataProvider(n,E),C={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,d.$VG)(c,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,d.$VG)(c,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(v){(0,A.$Zk)(v)&&(0,d.$VG)(c,"treeViewMarkdownMessage"),S.message=v},get title(){return S.title},set title(v){S.title=v},get description(){return S.description},set description(v){S.description=v},get badge(){return S.badge},set badge(v){v!==void 0&&l.ViewBadge.isViewBadge(v)?S.badge={value:Math.floor(Math.abs(v.value)),tooltip:v.tooltip}:v===void 0&&(S.badge=void 0)},reveal:(v,b)=>S.reveal(v,b),dispose:async()=>{await k,this.a.delete(n),S.dispose()}};return this.B(C),C}$getChildren(n,t){const c=this.a.get(n);return c?c.getChildren(t):Promise.reject(new R.$eG(n))}async $handleDrop(n,t,c,h,s,m,y,S){const E=this.a.get(n);if(!E)return Promise.reject(new R.$eG(n));const k=f.DataTransfer.toDataTransfer(c,async C=>(await this.f.$resolveDropFileData(n,t,C)).buffer);return y===n&&S&&await this.j(k,E,S,s,m),E.onDrop(k,h,s)}async j(n,t,c,h,s){const m=this.b.removeDragOperationTransfer(s);if(m)(await m)?.forEach((y,S)=>{y&&n.set(S,y)});else if(s&&t.handleDrag){const y=t.handleDrag(c,n,h);this.b.addDragOperationTransfer(s,y),await y}return n}async $handleDrag(n,t,c,h){const s=this.a.get(n);if(!s)return Promise.reject(new R.$eG(n));const m=await this.j(new l.$qN,s,t,h,c);if(!(!m||h.isCancellationRequested))return f.DataTransfer.from(m)}async $hasResolve(n){const t=this.a.get(n);if(!t)throw new R.$eG(n);return t.hasResolve}$resolve(n,t,c){const h=this.a.get(n);if(!h)throw new R.$eG(n);return h.resolveTreeItem(t,c)}$setExpanded(n,t,c){const h=this.a.get(n);if(!h)throw new R.$eG(n);h.setExpanded(t,c)}$setSelectionAndFocus(n,t,c){const h=this.a.get(n);if(!h)throw new R.$eG(n);h.setSelectionAndFocus(t,c)}$setVisible(n,t){const c=this.a.get(n);if(!c){if(!t)return;throw new R.$eG(n)}c.setVisible(t)}$changeCheckboxState(n,t){const c=this.a.get(n);if(!c)throw new R.$eG(n);c.setCheckboxState(t)}m(n,t,c){const h=this.B(new i(n,t,this.f,this.g.converter,this.h,c));return this.a.set(n,h),h}r(n){const t=this.a.get(n.$treeViewId);return t&&"$treeItemHandle"in n?t.getExtensionElement(n.$treeItemHandle):t&&"$focusedTreeItem"in n&&n.$focusedTreeItem?t.focusedElement:null}}e.$Toc=$;class i extends L.$Uc{get visible(){return this.r}get selectedElements(){return this.s.map(n=>this.getExtensionElement(n)).filter(n=>!(0,I.$jg)(n))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(n,t,c,h,s,m){if(super(),this.I=n,this.J=c,this.L=h,this.M=s,this.N=m,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$he),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$he),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$he),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$he),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$he),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$he),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$he),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new w.$se,m.contributes&&m.contributes.views)for(const k in m.contributes.views)for(const C of m.contributes.views[k])C.id===n&&(this.P=C.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(k=>{Array.isArray(k)&&k.length===0||this.F.fire({message:!1,element:k})}));let y,S;const E=T.Event.debounce(this.F.event,(k,C)=>(k||(k={message:!1,elements:[]}),C.element!==!1&&(y||(y=new Promise(v=>S=v),this.G=this.G.then(()=>y)),Array.isArray(C.element)?k.elements.push(...C.element):k.elements.push(C.element)),C.message&&(k.message=!0),k),200,!0);this.B(E(({message:k,elements:C})=>{C.length&&(this.H=this.H.then(()=>{const v=S;return y=null,this.$(C).then(()=>v())})),k&&this.J.$setMessage(this.I,f.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(n){const t=n?this.getExtensionElement(n):void 0;if(n&&!t)return this.M.error(`No tree item with id '${n}' found.`),Promise.resolve([]);let c=this.X(n);return c||(c=await this.Y(t)),c?c.map(h=>h.item):void 0}getExtensionElement(n){return this.j.get(n)}reveal(n,t){t=t||{select:!0,focus:!1};const c=(0,I.$jg)(t.select)?!0:t.select,h=(0,I.$jg)(t.focus)?!1:t.focus,s=(0,I.$jg)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):n?this.G.then(()=>this.S(n)).then(m=>this.W(n,m[m.length-1]).then(y=>this.J.$reveal(this.I,{item:y.item,parentChain:m.map(S=>S.item)},{select:c,focus:h,expand:s})),m=>this.M.error(m)):this.J.$reveal(this.I,void 0,{select:c,focus:h,expand:s})}get message(){return this.O}set message(n){this.O=n,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(n){this.P=n,this.J.$setTitle(this.I,n,this.Q)}get description(){return this.Q}set description(n){this.Q=n,this.J.$setTitle(this.I,this.P,n)}get badge(){return this.R}set badge(n){this.R?.value===n?.value&&this.R?.tooltip===n?.tooltip||(this.R=f.ViewBadge.from(n),this.J.$setBadge(this.I,n))}setExpanded(n,t){const c=this.getExtensionElement(n);c&&(t?this.u.fire(Object.freeze({element:c})):this.w.fire(Object.freeze({element:c})))}setSelectionAndFocus(n,t){const c=!(0,D.$ub)(this.s,n);this.s=n;const h=this.t!==t;this.t=t,c&&this.y.fire(Object.freeze({selection:this.selectedElements})),h&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(n){n!==this.r&&(this.r=n,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(n){const t=(await Promise.all(n.map(async c=>{const h=this.getExtensionElement(c.treeItemHandle);return h?{extensionItem:h,treeItem:await this.f.getTreeItem(h),newState:c.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(c=>c!==void 0);t.forEach(c=>{c.treeItem.checkboxState=c.newState?l.TreeItemCheckboxState.Checked:l.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(c=>[c.extensionItem,c.newState])})}async handleDrag(n,t,c){const h=[];for(const s of n){const m=this.getExtensionElement(s);m&&h.push(m)}if(!(!this.g?.handleDrag||h.length===0))return await this.g.handleDrag(h,t,c),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(n,t,c){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.g?.handleDrop))return(0,p.$sh)(()=>this.g?.handleDrop?this.g.handleDrop(h,n,c):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(n,t){if(!this.f.resolveTreeItem)return;const c=this.j.get(n);if(c){const h=this.m.get(c);if(h){const s=await this.f.resolveTreeItem(h.extensionItem,c,t)??h.extensionItem;return this.hb(s),h.item.tooltip=this.eb(s.tooltip),h.item.command=this.fb(h.disposableStore,s.command),h.item}}}S(n){return this.U(n).then(t=>t?this.S(t).then(c=>this.W(t,c[c.length-1]).then(h=>(c.push(h),c))):Promise.resolve([]))}U(n){const t=this.m.get(n);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,p.$sh)(()=>this.f.getParent(n))}W(n,t){const c=this.m.get(n);return c?Promise.resolve(c):(0,p.$sh)(()=>this.f.getTreeItem(n)).then(h=>this.kb(n,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const s=this.getExtensionElement(h);if(s){const m=this.m.get(s);if(m)return Promise.resolve(m)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.N.identifier.value}`)}))}X(n){if(n){let t;if(typeof n=="string"){const c=this.getExtensionElement(n);t=c?this.m.get(c):void 0}else t=n;return t&&t.children||void 0}return this.h}async Y(n){this.rb(n);const t=new w.$se(this.Z.token);try{const c=n?this.m.get(n):void 0,h=await this.f.getChildren(n);if(t.token.isCancellationRequested)return;const s=(0,D.$Hb)(h||[]),m=await Promise.all((0,D.$Hb)(s).map(S=>this.f.getTreeItem(S)));if(t.token.isCancellationRequested)return;const y=m.map((S,E)=>S?this.db(s[E],S,c):null);return(0,D.$Hb)(y)}finally{t.dispose()}}$(n){if(n.some(c=>!c))return this.Z.dispose(!0),this.Z=new w.$se,this.tb(),this.J.$refresh(this.I);{const c=this.ab(n);if(c.length)return this.bb(c)}return Promise.resolve(void 0)}ab(n){const t=new Set,c=n.map(s=>this.m.get(s));for(const s of c)if(s&&!t.has(s.item.handle)){let m=s;for(;m&&m.parent&&c.findIndex(y=>m&&m.parent&&y&&y.item.handle===m.parent.item.handle)===-1;){const y=this.j.get(m.parent.item.handle);m=y?this.m.get(y):void 0}m&&!m.parent&&t.add(s.item.handle)}const h=[];return t.forEach(s=>{const m=this.j.get(s);if(m){const y=this.m.get(m);y&&(!y.parent||!t.has(y.parent.item.handle))&&h.push(s)}}),h}bb(n){const t={};return Promise.all(n.map(c=>this.cb(c).then(h=>{h&&(t[c]=h.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(n){const t=this.getExtensionElement(n);if(t){const c=this.m.get(t);if(c)return this.rb(t),(0,p.$sh)(()=>this.f.getTreeItem(t)).then(h=>{if(h){const s=this.ib(t,h,c.parent);return this.pb(t,s,c,c.parent),c.dispose(),s}return null})}return Promise.resolve(null)}db(n,t,c){const h=this.ib(n,t,c);if(t.id&&this.j.has(h.item.handle))throw new Error((0,r.localize)(0,null,t.id));return this.ob(n,h),this.qb(h,c),h}eb(n){return l.$ZM.isMarkdownString(n)?f.MarkdownString.from(n):n}fb(n,t){return t?{...this.L.toInternal(t,n),originalId:t.command}:void 0}gb(n){if(n.checkboxState===void 0)return;let t,c,h;return typeof n.checkboxState=="number"?t=n.checkboxState:(t=n.checkboxState.state,c=n.checkboxState.tooltip,h=n.checkboxState.accessibilityInformation),{isChecked:t===l.TreeItemCheckboxState.Checked,tooltip:c,accessibilityInformation:h}}hb(n){if(!l.$lN.isTreeItem(n,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(n,t,c){this.hb(t);const h=this.B(new L.$Tc),s=this.kb(n,t,c),m=this.lb(t);return{item:{handle:s,parentHandle:c?c.item.handle:void 0,label:g(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(h,t.command),contextValue:t.contextValue,icon:m,iconDark:this.mb(t)||m,themeIcon:this.jb(t),collapsibleState:(0,I.$jg)(t.collapsibleState)?l.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:c,children:void 0,disposableStore:h,dispose(){h.dispose()}}}jb(n){return n.iconPath instanceof l.$uN?n.iconPath:void 0}kb(n,{id:t,label:c,resourceUri:h},s,m){if(t)return`${i.b}/${t}`;const y=g(c,this.N),S=s?s.item.handle:i.a;let E=y?y.label:h?(0,u.$$g)(h):"";E=E.indexOf("/")!==-1?E.replace("/","//"):E;const k=this.m.has(n)?this.m.get(n).item.handle:void 0,C=this.X(s)||[];let v,b=0;do{if(v=`${S}/${b}:${E}`,m||!this.j.has(v)||k===v)break;b++}while(b<=C.length);return v}lb(n){if(n.iconPath&&!(n.iconPath instanceof l.$uN))return typeof n.iconPath=="string"||P.URI.isUri(n.iconPath)?this.nb(n.iconPath):this.nb(n.iconPath.light)}mb(n){if(n.iconPath&&!(n.iconPath instanceof l.$uN)&&n.iconPath.dark)return this.nb(n.iconPath.dark)}nb(n){return P.URI.isUri(n)?n:P.URI.file(n)}ob(n,t){this.j.set(t.item.handle,n),this.m.set(n,t)}pb(n,t,c,h){this.j.delete(t.item.handle),this.m.delete(n),t.item.handle!==c.item.handle&&this.j.delete(c.item.handle),this.ob(n,t);const s=this.X(h)||[],m=s.filter(y=>y.item.handle===c.item.handle)[0];m&&s.splice(s.indexOf(m),1,t)}qb(n,t){t?(t.children||(t.children=[]),t.children.push(n)):(this.h||(this.h=[]),this.h.push(n))}rb(n){if(n){const t=this.m.get(n);if(t){if(t.children)for(const c of t.children){const h=this.j.get(c.item.handle);h&&this.sb(h)}t.children=void 0}}else this.tb()}sb(n){const t=this.m.get(n);if(t){if(t.children)for(const c of t.children){const h=this.j.get(c.item.handle);h&&this.sb(h)}this.m.delete(n),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(n=>n.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}i.a="0",i.b="1"});var rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r},Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)};define(Ee[372],Se([1,0,4,3,2,33,17,97,6,8]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";var I,D,f,A,w,a,d,g,$,i,o,n,t;Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;class c extends u.$Uc{constructor(y,S,E,k){super(),I.set(this,void 0),D.set(this,void 0),f.set(this,void 0),A.set(this,void 0),w.set(this,void 0),a.set(this,void 0),d.set(this,void 0),g.set(this,void 0),$.set(this,!0),i.set(this,void 0),o.set(this,!1),n.set(this,this.B(new r.$he)),this.onDidDispose=Ge(this,n,"f").event,t.set(this,this.B(new r.$he)),this.onDidChangeViewState=Ge(this,t,"f").event,rt(this,I,y,"f"),rt(this,D,S,"f"),rt(this,A,E,"f"),rt(this,f,k.viewType,"f"),rt(this,w,k.panelOptions,"f"),rt(this,g,k.viewColumn,"f"),rt(this,a,k.title,"f"),rt(this,i,k.active,"f")}dispose(){Ge(this,o,"f")||(rt(this,o,!0,"f"),Ge(this,n,"f").fire(),Ge(this,D,"f").$disposeWebview(Ge(this,I,"f")),Ge(this,A,"f").dispose(),super.dispose())}get webview(){return this.c(),Ge(this,A,"f")}get viewType(){return this.c(),Ge(this,f,"f")}get title(){return this.c(),Ge(this,a,"f")}set title(y){this.c(),Ge(this,a,"f")!==y&&(rt(this,a,y,"f"),Ge(this,D,"f").$setTitle(Ge(this,I,"f"),y))}get iconPath(){return this.c(),Ge(this,d,"f")}set iconPath(y){this.c(),Ge(this,d,"f")!==y&&(rt(this,d,y,"f"),Ge(this,D,"f").$setIconPath(Ge(this,I,"f"),P.URI.isUri(y)?{light:y,dark:y}:y))}get options(){return Ge(this,w,"f")}get viewColumn(){if(this.c(),!(typeof Ge(this,g,"f")=="number"&&Ge(this,g,"f")<0))return Ge(this,g,"f")}get active(){return this.c(),Ge(this,i,"f")}get visible(){return this.c(),Ge(this,$,"f")}_updateViewState(y){Ge(this,o,"f")||(this.active!==y.active||this.visible!==y.visible||this.viewColumn!==y.viewColumn)&&(rt(this,i,y.active,"f"),rt(this,$,y.visible,"f"),rt(this,g,y.viewColumn,"f"),Ge(this,t,"f").fire({webviewPanel:this}))}reveal(y,S){this.c(),Ge(this,D,"f").$reveal(Ge(this,I,"f"),{viewColumn:typeof y>"u"?void 0:L.ViewColumn.from(y),preserveFocus:!!S})}c(){if(Ge(this,o,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,D=new WeakMap,f=new WeakMap,A=new WeakMap,w=new WeakMap,a=new WeakMap,d=new WeakMap,g=new WeakMap,$=new WeakMap,i=new WeakMap,o=new WeakMap,n=new WeakMap,t=new WeakMap;class h extends u.$Uc{static c(){return(0,T.$Wg)()}constructor(y,S,E){super(),this.j=S,this.m=E,this.g=new Map,this.h=new Map,this.f=y.getProxy(p.$vM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(y=>y.dispose()),this.g.clear()}createWebviewPanel(y,S,E,k,C={}){const v=typeof k=="object"?k.viewColumn:k,b={viewColumn:L.ViewColumn.from(v),preserveFocus:typeof k=="object"&&!!k.preserveFocus},O=(0,R.$lnc)(y),U=h.c();this.f.$createWebviewPanel((0,R.$nnc)(y),U,S,{title:E,panelOptions:s(C),webviewOptions:(0,R.$onc)(y,this.m,C),serializeBuffersForPostMessage:O},b);const z=this.j.createNewWebview(U,C,y);return this.createNewWebviewPanel(U,S,E,v,C,z,!0)}$onDidChangeWebviewPanelViewStates(y){const S=Object.keys(y);S.sort((E,k)=>{const C=y[E],v=y[k];return C.active?1:v.active?-1:+C.visible-+v.visible});for(const E of S){const k=this.getWebviewPanel(E);if(!k)continue;const C=y[E];k._updateViewState({active:C.active,visible:C.visible,viewColumn:L.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(y){this.getWebviewPanel(y)?.dispose(),this.g.delete(y),this.j.deleteWebview(y)}registerWebviewPanelSerializer(y,S,E){if(this.h.has(S))throw new Error(`Serializer for '${S}' already registered`);return this.h.set(S,{serializer:E,extension:y}),this.f.$registerSerializer(S,{serializeBuffersForPostMessage:(0,R.$lnc)(y)}),new l.$xM(()=>{this.h.delete(S),this.f.$unregisterSerializer(S)})}async $deserializeWebviewPanel(y,S,E,k){const C=this.h.get(S);if(!C)throw new Error(`No serializer found for '${S}'`);const{serializer:v,extension:b}=C,O=this.j.createNewWebview(y,E.webviewOptions,b),U=this.createNewWebviewPanel(y,S,E.title,k,E.panelOptions,O,E.active);await v.deserializeWebviewPanel(U,E.state)}createNewWebviewPanel(y,S,E,k,C,v,b){const O=new c(y,this.f,v,{viewType:S,title:E,viewColumn:k,panelOptions:C,active:b});return this.g.set(y,O),O}getWebviewPanel(y){return this.g.get(y)}}e.$pnc=h;function s(m){return{enableFindWidget:m.enableFindWidget,retainContextWhenHidden:m.retainContextWhenHidden}}});var rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r},Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)};define(Ee[373],Se([1,0,4,3,97,17,6,8]),function(oe,e,r,u,P,T,L,R){"use strict";var p,l,I,D,f,A,w,a,d,g,$;Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0;class i extends u.$Uc{constructor(t,c,h,s,m,y){super(),p.set(this,void 0),l.set(this,void 0),I.set(this,void 0),D.set(this,void 0),f.set(this,!1),A.set(this,void 0),w.set(this,void 0),a.set(this,void 0),d.set(this,void 0),g.set(this,this.B(new r.$he)),this.onDidChangeVisibility=Ge(this,g,"f").event,$.set(this,this.B(new r.$he)),this.onDidDispose=Ge(this,$,"f").event,rt(this,I,h,"f"),rt(this,w,s,"f"),rt(this,p,t,"f"),rt(this,l,c,"f"),rt(this,D,m,"f"),rt(this,A,y,"f")}dispose(){Ge(this,f,"f")||(rt(this,f,!0,"f"),Ge(this,$,"f").fire(),Ge(this,D,"f").dispose(),super.dispose())}get title(){return this.a(),Ge(this,w,"f")}set title(t){this.a(),Ge(this,w,"f")!==t&&(rt(this,w,t,"f"),Ge(this,l,"f").$setWebviewViewTitle(Ge(this,p,"f"),t))}get description(){return this.a(),Ge(this,a,"f")}set description(t){this.a(),Ge(this,a,"f")!==t&&(rt(this,a,t,"f"),Ge(this,l,"f").$setWebviewViewDescription(Ge(this,p,"f"),t))}get visible(){return Ge(this,A,"f")}get webview(){return Ge(this,D,"f")}get viewType(){return Ge(this,I,"f")}_setVisible(t){t===Ge(this,A,"f")||Ge(this,f,"f")||(rt(this,A,t,"f"),Ge(this,g,"f").fire())}get badge(){return this.a(),Ge(this,d,"f")}set badge(t){this.a(),!(t?.value===Ge(this,d,"f")?.value&&t?.tooltip===Ge(this,d,"f")?.tooltip)&&(rt(this,d,T.ViewBadge.from(t),"f"),Ge(this,l,"f").$setWebviewViewBadge(Ge(this,p,"f"),t))}show(t){this.a(),Ge(this,l,"f").$show(Ge(this,p,"f"),!!t)}a(){if(Ge(this,f,"f"))throw new Error("Webview is disposed")}}p=new WeakMap,l=new WeakMap,I=new WeakMap,D=new WeakMap,f=new WeakMap,A=new WeakMap,w=new WeakMap,a=new WeakMap,d=new WeakMap,g=new WeakMap,$=new WeakMap;class o{constructor(t,c){this.d=c,this.b=new Map,this.c=new Map,this.a=t.getProxy(L.$vM.MainThreadWebviewViews)}registerWebviewViewProvider(t,c,h,s){if(this.b.has(c))throw new Error(`View provider for '${c}' already registered`);return this.b.set(c,{provider:h,extension:t}),this.a.$registerWebviewViewProvider((0,P.$nnc)(t),c,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$lnc)(t)}),new R.$xM(()=>{this.b.delete(c),this.a.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(t,c,h,s,m){const y=this.b.get(c);if(!y)throw new Error(`No view provider found for '${c}'`);const{provider:S,extension:E}=y,k=this.d.createNewWebview(t,{},E),C=new i(t,this.a,c,h,k,!0);this.c.set(t,C),await S.resolveWebviewView(C,{state:s},m)}async $onDidChangeWebviewViewVisibility(t,c){this.e(t)._setVisible(c)}async $disposeWebviewView(t){const c=this.e(t);this.c.delete(t),c.dispose(),this.d.deleteWebview(t)}e(t){const c=this.c.get(t);if(!c)throw new Error("No webview found");return c}}e.$Woc=o}),define(Ee[374],Se([1,0,75,15,12,276,28,11]),function(oe,e,r,u,P,T,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=void 0;let p=class{constructor(D,f){D.addFileSystemProvider(u.Schemas.file,new l(f),{isCaseSensitive:R.$e})}};e.$Bpc=p,e.$Bpc=p=Ze([Ve(0,r.$hnc),Ve(1,P.$7j)],p);class l{constructor(D){this.b=D,this.a=new T.$ir(this.b)}async stat(D){const f=await this.a.stat(D);return{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(D){return this.a.readdir(D)}createDirectory(D){return this.a.mkdir(D)}readFile(D){return this.a.readFile(D)}writeFile(D,f,A){return this.a.writeFile(D,f,{...A,unlock:!1,atomic:!1})}delete(D,f){return this.a.delete(D,{...f,useTrash:!1,atomic:!1})}rename(D,f,A){return this.a.rename(D,f,A)}copy(D,f,A){return this.a.copy(D,f,A)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(D,f){throw new Error("Method not implemented.")}}}),define(Ee[375],Se([1,0,16,66,33,37,3,6,2,20]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=void 0;let I=class extends L.$Uc{constructor(f,A){super();const w=f.getProxy(R.$vM.MainThreadDownloadService);A.registerCommand(!1,"_workbench.downloadResource",async a=>{const d=p.URI.file((0,r.$jc)((0,u.tmpdir)(),(0,P.$Wg)()));return await w.$download(a,d),d})}};e.$zpc=I,e.$zpc=I=Ze([Ve(0,l.$ZO),Ve(1,T.$jP)],I)}),define(Ee[376],Se([1,0,56,16,2,98,3,15,7,34]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lpc=void 0;class I extends T.$jnc{constructor(){super(...arguments),this.i=null}async g(t){const c=await super.g(t);if(c.scheme!==R.Schemas.file)return c;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${c.fsPath}.`),c;const h=c.fsPath;let s=0;do{let m;s===0?m=h:m=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${s}`:`${h}-${s}`,await D(m);const y=u.$jc(m,"vscode.lock"),S=await a(this.d,y,!1);if(S)return this.i=S,process.on("exit",()=>{S.dispose()}),P.URI.file(m);s++}while(s<10);return c}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$Lpc=I;async function D(n){try{await l.Promises.stat(n);return}catch{}try{await l.Promises.mkdir(n,{recursive:!0})}catch{}}const f=1e3,A=10*60*1e3;class w extends L.$Uc{constructor(t,c){super(),this.b=t,this.c=c,this.a=this.B(new p.$Lh),this.a.cancelAndSet(async()=>{const h=await d(t,c);(!h||h.pid!==process.pid)&&(t.info(`Lock '${c}': The lock was lost unexpectedly.`),this.a.cancel());try{await l.Promises.utimes(c,new Date,new Date)}catch(s){t.error(s),t.info(`Lock '${c}': Could not update mtime.`)}},f)}dispose(){super.dispose();try{r.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const c={pid:process.pid,willReleaseAt:Date.now()+t};await l.Promises.writeFile(this.c,JSON.stringify(c),{flag:"w"})}catch(c){this.b.error(c)}}}async function a(n,t,c){try{const s={pid:process.pid,willReleaseAt:0};await l.Promises.writeFile(t,JSON.stringify(s),{flag:"wx"})}catch(s){n.error(s)}const h=await d(n,t);return!h||h.pid!==process.pid?c?(n.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(n.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),i(n,t)):(n.info(`Lock '${t}': Lock acquired.`),new w(n,t))}async function d(n,t){let c;try{c=await l.Promises.readFile(t)}catch(h){return n.error(h),null}try{return JSON.parse(String(c))}catch(h){return n.error(h),null}}async function g(n,t){let c;try{c=await l.Promises.stat(t)}catch(h){return n.error(h),0}return c.mtime.getTime()}function $(n){try{return process.kill(n,0),!0}catch{return!1}}async function i(n,t){const c=await d(n,t);if(!c)return n.info(`Lock '${t}': Could not read pid of lock holder.`),o(n,t);if(c.willReleaseAt){let S=c.willReleaseAt-Date.now();if(S<5e3){for(S>0?n.info(`Lock '${t}': The lockfile is scheduled to be released in ${S} ms.`):n.info(`Lock '${t}': The lockfile is scheduled to have been released.`);S>0;){if(await(0,p.$Bh)(Math.min(100,S)),await g(n,t)===0)return o(n,t);S=c.willReleaseAt-Date.now()}return o(n,t)}}if(!$(c.pid))return n.info(`Lock '${t}': The pid ${c.pid} appears to be gone.`),o(n,t);const h=await g(n,t),s=Date.now()-h;if(s<=A)return n.info(`Lock '${t}': The lock does not look stale, elapsed: ${s} ms, giving up.`),null;n.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,p.$Bh)(2e3);const m=await g(n,t),y=Date.now()-m;return y<=A?(n.info(`Lock '${t}': The lock does not look stale, elapsed: ${y} ms, giving up.`),null):(n.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(n,t))}async function o(n,t){n.info(`Lock '${t}': Deleting a stale lock.`);try{await l.Promises.unlink(t)}catch{}return a(n,t,!0)}}),define(Ee[377],Se([1,0,33,20,47,37]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7oc=void 0;let L=class extends P.$Fnc{constructor(p,l){super(!0,p,l)}createTerminal(p,l,I){return this.createTerminalFromOptions({name:p,shellPath:l,shellArgs:I})}createTerminalFromOptions(p,l){const I=new P.$Enc(this.a,(0,r.$Wg)(),p,p.name);return this.f.push(I),I.create(p,this.R(p,l)),I.value}};e.$7oc=L,e.$7oc=L=Ze([Ve(0,T.$jP),Ve(1,u.$ZO)],L)}),define(Ee[378],Se([1,0,4,36,35,5]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=e.$QL=e.OutputChannelUpdateMode=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=void 0,e.$DL="text/x-code-output",e.$EL="output",e.$FL="Log",e.$GL="text/x-code-log-output",e.$HL="log",e.$IL="workbench.panel.output",e.$JL=new P.$Rj("inOutput",!1),e.$KL=new P.$Rj("activeLogOutput",!1),e.$LL=new P.$Rj("activeLogOutput.levelSettable",!1),e.$ML=new P.$Rj("activeLogOutput.level",""),e.$NL=new P.$Rj("activeLogOutput.levelIsDefault",!1),e.$OL=new P.$Rj("outputView.scrollLock",!1),e.$PL=(0,T.$Ai)("outputService");var L;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$QL={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.a=new Map,this.b=new r.$he,this.onDidRegisterChannel=this.b.event,this.c=new r.$he,this.onDidRemoveChannel=this.c.event}registerChannel(l){this.a.has(l.id)||(this.a.set(l.id,l),this.b.fire(l.id))}getChannels(){const l=[];return this.a.forEach(I=>l.push(I)),l}getChannel(l){return this.a.get(l)}removeChannel(l){this.a.delete(l),this.c.fire(l)}}u.$ko.add(e.$QL.OutputChannels,new R),e.$RL=new P.$Rj("activeOutputChannel","")}),define(Ee[168],Se([1,0,6,5,20,24,12,378,75,30,63,212,22,18,28,4,3]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=e.$voc=void 0;class g extends L.$ak{get disposed(){return this.n}constructor(n,t,c,h,s){super(),this.id=n,this.name=t,this.r=c,this.s=h,this.extension=s,this.m=0,this.n=!1,this.visible=!1,this.setLevel(c.getLevel()),this.B(c.onDidChangeLogLevel(m=>this.setLevel(m)))}get logLevel(){return this.getLevel()}appendLine(n){this.append(n+`
`)}append(n){this.info(n)}clear(){const n=this.m;this.r.flush(),this.s.$update(this.id,R.OutputChannelUpdateMode.Clear,n)}replace(n){const t=this.m;this.info(n),this.s.$update(this.id,R.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(n,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof n=="boolean"?n:t))}hide(){this.s.$close(this.id)}g(n,t){this.m+=f.$Je.fromString(t).byteLength,(0,L.log)(this.r,n,t),this.visible&&(this.r.flush(),this.s.$update(this.id,R.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class $ extends g{appendLine(n){this.append(n)}}let i=class{constructor(n,t,c,h,s,m){this.i=t,this.j=c,this.k=h,this.l=s,this.m=m,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=n.getProxy(r.$vM.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$0m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(n){this.h=n;for(const[t,c]of this.g)c.visible=t===this.h}createOutputChannel(n,t,c){if(n=n.trim(),!n)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,s=(0,A.$ag)(t)?t:void 0;if((0,A.$ag)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let m;const y=this.i.environment.extensionLogLevel?.find(([E])=>T.$Xm.equals(c.identifier,E))?.[1];y&&(m=(0,L.$lk)(y));const S=h?this.o(n,m,c):this.n(n,s,c);return S.then(E=>{this.g.set(E.id,E),E.visible=E.id===this.h}),h?this.r(n,m??this.m.getLevel(),S):this.q(n,S)}async n(n,t,c){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const h=await this.c,s=this.k.extUri.joinPath(h,`${this.f++}-${n.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),m=this.l.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),y=await this.a.$register(n,s,t,c.identifier.value);return new g(y,n,m,this.a,c)}async o(n,t,c){const h=await this.p(c),s=n.replace(/[\\/:\*\?"<>\|]/g,""),m=this.k.extUri.joinPath(h,`${s}.log`),y=`${c.identifier.value}.${s}`,S=this.l.createLogger(m,{id:y,name:n,logLevel:t,extensionId:c.identifier.value});return new $(y,n,S,this.a,c)}p(n){let t=this.d.get(n.identifier.value);if(!t){const c=this.k.extUri.joinPath(this.i.logsLocation,n.identifier.value);this.d.set(n.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(c)}catch(h){if((0,w.$kl)(h)!==w.FileSystemProviderErrorCode.FileExists)throw h}return c})())}return t}q(n,t){let c=!1;const h=()=>{if(c)throw new Error("Channel has been closed")};return{get name(){return n},append(s){h(),t.then(m=>m.append(s))},appendLine(s){h(),t.then(m=>m.appendLine(s))},clear(){h(),t.then(s=>s.clear())},replace(s){h(),t.then(m=>m.replace(s))},show(s,m){h(),t.then(y=>y.show(s,m))},hide(){h(),t.then(s=>s.hide())},dispose(){c=!0,t.then(s=>s.dispose())}}}r(n,t,c){const h=new d.$Tc,s=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},m=h.add(new a.$he);function y(S){t=S,m.fire(S)}return c.then(S=>{h.add(S),S.logLevel!==t&&y(S.logLevel),h.add(S.onDidChangeLogLevel(E=>y(E)))}),{...this.q(n,c),get logLevel(){return t},onDidChangeLogLevel:m.event,trace(S,...E){s(),c.then(k=>k.trace(S,...E))},debug(S,...E){s(),c.then(k=>k.debug(S,...E))},info(S,...E){s(),c.then(k=>k.info(S,...E))},warn(S,...E){s(),c.then(k=>k.warn(S,...E))},error(S,...E){s(),c.then(k=>k.error(S,...E))},dispose(){h.dispose()}}}};e.$voc=i,e.$voc=i=Ze([Ve(0,P.$ZO),Ve(1,l.$dP),Ve(2,p.$hnc),Ve(3,I.$Wmc),Ve(4,L.$8j),Ve(5,L.$7j)],i),e.$woc=(0,u.$Ai)("IExtHostOutputService")}),define(Ee[169],Se([1,0,5,7]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=void 0,e.$mn=(0,r.$Ai)("remoteAgentService"),e.$nn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let T=1/0;for(let R=0;R<this.maxSampleCount;R++){const p=await P.getRoundTripTime();if(p===void 0)return;T=Math.min(T,p/2),await(0,u.$Bh)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(T):L=this.initial.reduce((R,p)=>R+p,0)/this.initial.length,this.lastMeasurement={initial:L,current:T,average:this.average.reduce((R,p)=>R+p,0)/this.average.length,high:typeof L>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ee[379],Se([1,0,245,70,36,46,45,3,4,169,11,25,7,150]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhb=e.$thb=e.$shb=e.$rhb=e.$qhb=e.$phb=e.$ohb=e.$nhb=e.$mhb=void 0,e.$mhb=Object.freeze({id:"application",order:100,title:(0,r.localize)(0,null),type:"object"}),e.$nhb=Object.freeze({id:"workbench",order:7,title:(0,r.localize)(1,null),type:"object"}),e.$ohb=Object.freeze({id:"security",scope:u.ConfigurationScope.APPLICATION,title:(0,r.localize)(2,null),type:"object",order:7}),e.$phb=Object.freeze({id:"problems",title:(0,r.localize)(3,null),type:"object",order:101}),e.$qhb=Object.freeze({id:"window",order:8,title:(0,r.localize)(4,null),type:"object"}),e.$rhb={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new p.$he,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const a=new w;P.$ko.add(e.$rhb.ConfigurationMigration,a);let d=class extends R.$Uc{constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const h of c.added)await this.f(h,a.migrations)})),this.c(a.migrations),this.B(a.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(c=>this.g(c,n?.uri))])}async g(n,t){const c=this.a.inspect(n.key,{resource:t}),h=this.b.getWorkbenchState()===T.WorkbenchState.WORKSPACE?[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE],["workspaceFolder",L.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",L.ConfigurationTarget.USER],["userLocal",L.ConfigurationTarget.USER_LOCAL],["userRemote",L.ConfigurationTarget.USER_REMOTE],["workspace",L.ConfigurationTarget.WORKSPACE]];for(const[s,m]of h){const y=c[s];if(!y)continue;const S=[];if(y.value!==void 0){const E=await this.h(n,s,y.value,t,void 0);for(const k of E??[])S.push([k,[]])}for(const{identifiers:E,value:k}of y.overrides??[])if(k!==void 0){const C=await this.h(n,s,k,t,E);for(const v of C??[])S.push([v,E])}S.length&&await Promise.allSettled(S.map(async([[E,k],C])=>this.a.updateValue(E,k.value,{resource:t,overrideIdentifiers:C},m)))}}async h(n,t,c,h,s){const m=S=>{const k=this.a.inspect(S,{resource:h})[t];if(k)return s?k.overrides?.find(({identifiers:C})=>(0,D.$bo)(C,s))?.value:k.value},y=await n.migrateFn(c,m);return Array.isArray(y)?y:[[n.key,y]]}};e.$shb=d,d.ID="workbench.contrib.configurationMigration",e.$shb=d=Ze([Ve(0,L.$7i),Ve(1,T.$Ji)],d);let g=class extends R.$Uc{constructor(n){super(),this.b=n,this.a=new f.$Xh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$c&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.$ko.as(u.$po.Configuration).registerConfiguration({...e.$ohb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,r.localize)(5,null)},default:[],markdownDescription:(0,r.localize)(6,null),scope:u.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,r.localize)(7,null),scope:u.ConfigurationScope.MACHINE}}})}};e.$thb=g,g.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration",e.$thb=g=Ze([Ve(0,l.$mn)],g);const $="window.newWindowProfile";let i=class extends R.$Uc{constructor(n,t){super(),this.c=n,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(c=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(c=>{c.source!==L.ConfigurationTarget.DEFAULT&&c.affectsConfiguration($)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=P.$ko.as(u.$po.Configuration),t={...e.$qhb,properties:{[$]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(c=>c.name),null],enumItemLabels:[...this.c.profiles.map(c=>""),(0,r.localize)(8,null)],description:(0,r.localize)(9,null),scope:u.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[t],remove:[this.a]}):n.registerConfiguration(t),this.a=t}h(){const n=this.f.getValue($);this.b=n?this.c.profiles.find(t=>t.name===n):void 0}j(){const n=this.f.getValue($);if(!n)return;const t=this.b?this.c.profiles.find(c=>c.id===this.b.id):void 0;n!==t?.name&&this.f.updateValue($,t?.name)}};e.$uhb=i,i.ID="workbench.contrib.dynamicWindowConfiguration",e.$uhb=i=Ze([Ve(0,A.$Gl),Ve(1,L.$7i)],i)}),define(Ee[380],Se([1,0,39,15,16,23,257,379,70,5,36]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$whb=e.$vhb=void 0,e.$xhb=a,e.$yhb=d,e.$vhb=(0,l.$Ai)("editorResolverService"),e.$whb="workbench.editorAssociations";const D=I.$ko.as(p.$po.Configuration),f={...R.$nhb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(f);var A;(function(g){g.builtin="builtin",g.option="option",g.exclusive="exclusive",g.default="default"})(A||(e.RegisteredEditorPriority=A={}));var w;(function(g){g[g.ABORT=1]="ABORT",g[g.NONE=2]="NONE"})(w||(e.ResolvedStatus=w={}));function a(g){switch(g){case A.exclusive:return 5;case A.default:return 4;case A.builtin:return 3;case A.option:default:return 1}}function d(g,$){if(new Set([u.Schemas.extension,u.Schemas.webviewPanel,u.Schemas.vscodeWorkspaceTrust,u.Schemas.vscodeSettings]).has($.scheme))return!1;const n=typeof g=="string"&&g.indexOf(P.$gc.sep)>=0?`${$.scheme}:${$.path}`:(0,T.$$g)($);return r.$tk(typeof g=="string"?g.toLowerCase():g,n.toLowerCase())}}),define(Ee[381],Se([1,0,32,15,16,11,23,2,5,295,46,157,169]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=void 0,e.$0L=(0,p.$Ai)("pathService");let w=A=class{constructor(d,g,$,i){this.d=d,this.e=g,this.f=$,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??d})()}hasValidBasename(d,g,$){return typeof g=="string"||typeof g>"u"?this.a.then(i=>this.h(d,i,g)):this.h(d,g,$)}h(d,g,$){return d.scheme===u.Schemas.file||d.scheme===u.Schemas.vscodeRemote?(0,r.$xg)($??(0,L.$$g)(d),g===T.OperatingSystem.Windows):!0}get defaultUriScheme(){return A.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,g){if(d.remoteAuthority)return u.Schemas.vscodeRemote;const $=(0,l.$7L)(g.getWorkspace());if($)return $;const i=g.getWorkspace().folders[0];if(i)return i.uri.scheme;const o=g.getWorkspace().configuration;return o?o.scheme:u.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===T.OperatingSystem.Windows?P.$fc:P.$gc)}async fileURI(d){let g="";if(await this.a===T.OperatingSystem.Windows&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const i=d.indexOf("/",2);i===-1?(g=d.substring(2),d="/"):(g=d.substring(2,i),d=d.substring(i)||"/")}return R.URI.from({scheme:u.Schemas.file,authority:g,path:d,query:"",fragment:""})}};e.$$L=w,e.$$L=w=A=Ze([Ve(1,f.$mn),Ve(2,D.$SL),Ve(3,I.$Ji)],w)}),define(Ee[382],Se([1,0,259,60,4,61,3,2,45,265,12,71,151,93,46,157,26,21,18,25,35]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.$3L=e.OnPortForward=e.$XL=e.$WL=e.TunnelSource=e.TunnelCloseReason=e.$UL=e.$TL=void 0,e.$VL=s,e.$YL=S,e.$ZL=E,e.$1L=k,e.$2L=v;const n=10*1e3,t="remote.tunnels.toRestore",c="remote.tunnels.toRestoreExpiration",h=1e3*60*60*24*14;e.$TL="onTunnel",e.$UL=new o.$Rj("forwardedPortsViewEnabled",!1,r.localize(0,null));function s(U){const z=U.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}var m;(function(U){U.Other="Other",U.User="User",U.AutoForwardEnd="AutoForwardEnd"})(m||(e.TunnelCloseReason=m={}));var y;(function(U){U[U.User=0]="User",U[U.Auto=1]="Auto",U[U.Extension=2]="Extension"})(y||(e.TunnelSource=y={})),e.$WL={source:y.User,description:r.localize(1,null)},e.$XL={source:y.Auto,description:r.localize(2,null)};function S(U,z,j){const M=U.get(k(z,j));if(M)return M;if((0,A.$yw)(z))for(const N of A.$xw){const F=k(N,j);if(U.has(F))return U.get(F)}else if((0,A.$Aw)(z))for(const N of A.$zw){const F=k(N,j);if(U.has(F))return U.get(F)}}function E(U,z,j){const M=S(U,z,j);if(M)return M;const N=(0,A.$Aw)(z)?"localhost":(0,A.$yw)(z)?"0.0.0.0":void 0;if(N)return S(U,N,j)}function k(U,z){return U+":"+z}var C;(function(U){U.Notify="notify",U.OpenBrowser="openBrowser",U.OpenBrowserOnce="openBrowserOnce",U.OpenPreview="openPreview",U.Silent="silent",U.Ignore="ignore"})(C||(e.OnPortForward=C={}));function v(U){return U&&"host"in U&&typeof U.host=="string"&&"port"in U&&typeof U.port=="number"&&(!("detail"in U)||typeof U.detail=="string")&&(!("pid"in U)||typeof U.pid=="string")}class b extends L.$Uc{constructor(z){super(),this.r=z,this.j=[],this.n=new P.$he,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(j=>{(j.affectsConfiguration(b.c)||j.affectsConfiguration(b.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,j,M){let N=this.w(z,j,M,this.j,0);const F={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;N>=0;){const X=this.j[N];X.key===z?(F.onAutoForward=X.onAutoForward??F.onAutoForward,F.elevateIfNeeded=X.elevateIfNeeded!==void 0?X.elevateIfNeeded:F.elevateIfNeeded,F.label=X.label??F.label,F.requireLocalPort=X.requireLocalPort,F.protocol=X.protocol):(F.onAutoForward=F.onAutoForward??X.onAutoForward,F.elevateIfNeeded=F.elevateIfNeeded!==void 0?F.elevateIfNeeded:X.elevateIfNeeded,F.label=F.label??X.label,F.requireLocalPort=F.requireLocalPort!==void 0?F.requireLocalPort:void 0,F.protocol=F.protocol??X.protocol),N=this.w(z,j,M,this.j,N+1)}return F.onAutoForward!==void 0||F.elevateIfNeeded!==void 0||F.label!==void 0||F.requireLocalPort!==void 0||F.protocol!==void 0?F:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,$.$ag)(z.host)&&(0,$.$eg)(z.port)}w(z,j,M,N,F){if(F>=N.length)return-1;const X=!(0,A.$yw)(j)&&!(0,A.$Aw)(j),W=N.slice(F).findIndex(H=>(0,$.$eg)(H.key)?X?!1:H.key===z:this.t(H.key)?X?!1:z>=H.key.start&&z<=H.key.end:this.u(H.key)?z===H.key.port&&j===H.key.host:M?H.key.test(M):!1);return W>=0?W+F:-1}y(){const z=this.r.getValue(b.c);if(!z||!(0,$.$cg)(z))return[];const j=[];for(const N in z){if(N===void 0)continue;const F=z[N];let X;if(Number(N))X=Number(N);else if((0,$.$ag)(N))if(b.g.test(N)){const se=N.match(b.g);X={start:Number(se[1]),end:Number(se[2])}}else if(b.h.test(N)){const se=N.match(b.h);X={host:se[1],port:Number(se[2])}}else{let se;try{se=RegExp(N)}catch{}se&&(X=se)}X&&j.push({key:X,elevateIfNeeded:F.elevateIfNeeded,onAutoForward:F.onAutoForward,label:F.label,requireLocalPort:F.requireLocalPort,protocol:F.protocol})}const M=this.r.getValue(b.f);return M&&(this.m={elevateIfNeeded:M.elevateIfNeeded,label:M.label,onAutoForward:M.onAutoForward,requireLocalPort:M.requireLocalPort,protocol:M.protocol}),this.z(j)}z(z){function j(M,N){return(0,$.$eg)(M.key)?M.key:N.t(M.key)?M.key.start:N.u(M.key)?M.key.port:Number.MAX_VALUE}return z.sort((M,N)=>j(M,this)-j(N,this))}C(){return this.m}static providedActionToAction(z){switch(z){case A.ProvidedOnAutoForward.Notify:return C.Notify;case A.ProvidedOnAutoForward.OpenBrowser:return C.OpenBrowser;case A.ProvidedOnAutoForward.OpenBrowserOnce:return C.OpenBrowserOnce;case A.ProvidedOnAutoForward.OpenPreview:return C.OpenPreview;case A.ProvidedOnAutoForward.Silent:return C.Silent;case A.ProvidedOnAutoForward.Ignore:return C.Ignore;default:return}}async addAttributes(z,j,M){const F=this.r.inspect(b.c).userRemoteValue;let X;!F||!(0,$.$cg)(F)?X={}:X=(0,i.$0n)(F),X[`${z}`]||(X[`${z}`]={});for(const se in j)X[`${z}`][se]=j[se];return this.r.updateValue(b.c,X,M)}}e.$3L=b,b.c="remote.portsAttributes",b.f="remote.otherPortsAttributes",b.g=/^(\d+)\-(\d+)$/,b.h=/^([a-z0-9\-]+):(\d{1,5})$/;let O=class extends L.$Uc{constructor(z,j,M,N,F,X,se,W,H,V){super(),this.H=z,this.I=j,this.J=M,this.L=N,this.M=F,this.N=X,this.O=se,this.P=W,this.Q=H,this.R=V,this.c=new Map,this.g=new P.$he,this.onForwardPort=this.g.event,this.h=new P.$he,this.onClosePort=this.h.event,this.j=new P.$he,this.onPortName=this.j.event,this.n=new P.$he,this.onCandidatesChanged=this.n.event,this.t=new P.$he,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$he,this.D=new Map,this.F=new Map,this.G=[],this.db=new Date,this.configPortsAttributes=new b(M),this.s=this.ab(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.jb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async x=>{const he=await this.getAttributes(x.map(ne=>({port:ne.tunnelRemotePort,host:ne.tunnelRemoteHost})));for(const ne of x)if(ne.localAddress){const we=k(ne.tunnelRemoteHost,ne.tunnelRemotePort),pe=E(this.m??new Map,ne.tunnelRemoteHost,ne.tunnelRemotePort);this.forwarded.set(we,{remotePort:ne.tunnelRemotePort,remoteHost:ne.tunnelRemoteHost,localAddress:ne.localAddress,protocol:he?.get(ne.tunnelRemotePort)?.protocol??A.TunnelProtocol.Http,localUri:await this.X(ne.localAddress,he?.get(ne.tunnelRemotePort)),localPort:ne.tunnelLocalPort,runningProcess:pe?.detail,hasRunningProcess:!!pe,pid:pe?.pid,privacy:ne.privacy,source:e.$WL}),this.f.set(we,ne)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async x=>{const he=k(x.tunnelRemoteHost,x.tunnelRemotePort);if(!E(this.forwarded,x.tunnelRemoteHost,x.tunnelRemotePort)&&!E(this.detected,x.tunnelRemoteHost,x.tunnelRemotePort)&&!E(this.c,x.tunnelRemoteHost,x.tunnelRemotePort)&&x.localAddress){const ne=E(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort),we=(await this.getAttributes([{port:x.tunnelRemotePort,host:x.tunnelRemoteHost}]))?.get(x.tunnelRemotePort);this.forwarded.set(he,{remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localAddress:x.localAddress,protocol:we?.protocol??A.TunnelProtocol.Http,localUri:await this.X(x.localAddress,we),localPort:x.tunnelLocalPort,closeable:!0,runningProcess:ne?.detail,hasRunningProcess:!!ne,pid:ne?.pid,privacy:x.privacy,source:e.$WL})}await this.cb(),this.f.set(he,x),this.g.fire(this.forwarded.get(he))})),this.B(this.H.onTunnelClosed(x=>this.W(x,m.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$TL))?(this.R.createKey(e.$UL.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,j){const M=k(z.host,z.port);this.forwarded.has(M)&&(this.forwarded.delete(M),await this.cb(),this.h.fire(z))}X(z,j){if(z.startsWith("http"))return R.URI.parse(z);const M=j?.protocol??"http";return R.URI.parse(`${M}://${z}`)}async Y(z){const j=this.N.getWorkspace(),M=j.configuration?(0,T.$oj)(j.configuration.path):j.folders.length>0?(0,T.$oj)(j.folders[0].uri.path):void 0;if(M===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${z}.${this.L.remoteAuthority}.${M}`}async Z(){return this.Y(t)}async $(){return this.Y(c)}async ab(){const z=this.I.get(t,f.StorageScope.WORKSPACE);if(z)return this.I.remove(t,f.StorageScope.WORKSPACE),await this.cb(),z;const j=await this.Z();if(j)return this.I.get(j,f.StorageScope.PROFILE)}async restoreForwarded(){if(this.bb(),this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const j=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${j.map(M=>M.remotePort).join(", ")}`);for(const M of j){const N=E(this.detected,M.remoteHost,M.remotePort);M.source.source!==y.Extension&&!N||M.source.source===y.Extension&&N?await this.fb({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,elevateIfNeeded:!0,source:M.source}):M.source.source===y.Extension&&!N&&this.D.set(k(M.remoteHost,M.remotePort),M)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Z();this.w=this.B(new L.$Tc),this.w.add(this.I.onDidChangeValue(f.StorageScope.PROFILE,void 0,this.w)(async j=>{j.key===z&&(this.s=Promise.resolve(this.I.get(z,f.StorageScope.PROFILE)),await this.restoreForwarded())}))}}bb(){const z=this.I.keys(f.StorageScope.PROFILE,f.StorageTarget.USER).filter(j=>j.startsWith(c));for(const j of z){const M=this.I.getNumber(j,f.StorageScope.PROFILE);if(M&&M<Date.now()){this.s=Promise.resolve(void 0);const N=j.replace(c,t);this.I.remove(j,f.StorageScope.PROFILE),this.I.remove(N,f.StorageScope.PROFILE)}}}async cb(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=Array.from(this.forwarded.values()),j=z.map(X=>({remoteHost:X.remoteHost,remotePort:X.remotePort,localPort:X.localPort,name:X.name,localAddress:X.localAddress,localUri:X.localUri,protocol:X.protocol,source:X.source}));let M;z.length>0&&(M=JSON.stringify(j));const N=await this.Z(),F=await this.$();!M&&N&&F?(this.I.remove(N,f.StorageScope.PROFILE),this.I.remove(F,f.StorageScope.PROFILE)):M!==this.y&&N&&F&&(this.I.store(N,M,f.StorageScope.PROFILE,f.StorageTarget.USER),this.I.store(F,Date.now()+h,f.StorageScope.PROFILE,f.StorageTarget.USER)),this.y=M}}async eb(z,j,M){if(!z.tunnelLocalPort||!M?.requireLocalPort||z.tunnelLocalPort===j)return;const N=new Date;if(this.db.getTime()+n>N.getTime())return;this.db=N;const F=r.localize(3,null,j,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(F)}async forward(z,j){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.fb(z,j)}async fb(z,j){await this.Q.activateByEvent(e.$TL);const M=E(this.forwarded,z.remote.host,z.remote.port);j=j??(j!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const N=z.local!==void 0?z.local:z.remote.port;let F;if(M)return this.hb(M,z,j);{const X=this.L.remoteAuthority,se=X?{getAddress:async()=>(await this.M.resolveAuthority(X)).authority}:void 0,W=k(z.remote.host,z.remote.port);this.c.set(W,!0),z=this.gb(W,z);const H=await this.H.openTunnel(se,z.remote.host,z.remote.port,void 0,N,z.elevateIfNeeded?z.elevateIfNeeded:j?.elevateIfNeeded,z.privacy,j?.protocol);if(typeof H=="string")F=H;else if(H&&H.localAddress){const V=E(this.m??new Map,z.remote.host,z.remote.port),x=H.protocol?H.protocol===A.TunnelProtocol.Https?A.TunnelProtocol.Https:A.TunnelProtocol.Http:j?.protocol??A.TunnelProtocol.Http,he={remoteHost:H.tunnelRemoteHost,remotePort:H.tunnelRemotePort,localPort:H.tunnelLocalPort,name:j?.label??z.name,closeable:!0,localAddress:H.localAddress,protocol:x,localUri:await this.X(H.localAddress,j),runningProcess:V?.detail,hasRunningProcess:!!V,pid:V?.pid,source:z.source??e.$WL,privacy:H.privacy};return this.forwarded.set(W,he),this.f.set(W,H),this.c.delete(W),await this.cb(),await this.eb(H,N,j),this.g.fire(he),H}this.c.delete(W)}return F}gb(z,j){const M=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(M){const N=M.get(z);M.delete(z),N&&(j.name=N.name??j.name,j.local=("local"in N?N.local:"localPort"in N?N.localPort:void 0)??j.local,j.privacy=j.privacy)}return j}async hb(z,j,M){const N=M?.label??j.name;let F;(function(se){se[se.None=0]="None",se[se.Fire=1]="Fire",se[se.Reopen=2]="Reopen"})(F||(F={}));let X=F.None;switch(N!==z.name&&(z.name=N,X=F.Fire),(M?.protocol||z.protocol!==A.TunnelProtocol.Http)&&M?.protocol!==z.protocol&&(j.source=z.source,X=F.Reopen),j.privacy&&z.privacy!==j.privacy&&(X=F.Reopen),X){case F.Fire:{this.g.fire();break}case F.Reopen:await this.close(z.remoteHost,z.remotePort,m.User),await this.fb(j,M)}return E(this.f,j.remote.host,j.remote.port)}async name(z,j,M){const N=E(this.forwarded,z,j),F=k(z,j);if(N){N.name=M,await this.cb(),this.j.fire({host:z,port:j});return}else this.detected.has(F)&&(this.detected.get(F).name=M,this.j.fire({host:z,port:j}))}async close(z,j,M){const N=k(z,j),F=this.forwarded.get(N);return M===m.AutoForwardEnd&&F&&F.source.source===y.Auto&&this.F.set(N,{local:F.localPort,name:F.name,privacy:F.privacy}),await this.H.closeTunnel(z,j),this.W({host:z,port:j},M)}address(z,j){const M=k(z,j);return(this.forwarded.get(M)||this.detected.get(M))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const j of z){const M=E(this.m??new Map,j.remoteAddress.host,j.remoteAddress.port),N=typeof j.localAddress=="string"?j.localAddress:k(j.localAddress.host,j.localAddress.port);this.detected.set(k(j.remoteAddress.host,j.remoteAddress.port),{remoteHost:j.remoteAddress.host,remotePort:j.remoteAddress.port,localAddress:N,protocol:A.TunnelProtocol.Http,localUri:this.X(N),closeable:!1,runningProcess:M?.detail,hasRunningProcess:!!M,pid:M?.pid,privacy:A.TunnelPrivacyId.ConstantPrivate,source:{source:y.Extension,description:r.localize(4,null)}}),this.H.setEnvironmentTunnel(j.remoteAddress.host,j.remoteAddress.port,N,A.TunnelPrivacyId.ConstantPrivate,A.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let j=z;this.r&&(j=await this.r(z));const M=this.ib(j);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(M.values()).map(N=>N.port).join(", ")}`),this.n.fire(M)}ib(z){const j=this.m??new Map,M=new Map;return this.m=M,z.forEach(N=>{const F=k(N.host,N.port);M.set(F,{host:N.host,port:N.port,detail:N.detail,pid:N.pid}),j.has(F)&&j.delete(F);const X=E(this.forwarded,N.host,N.port);X&&(X.runningProcess=N.detail,X.hasRunningProcess=!0,X.pid=N.pid)}),j.forEach((N,F)=>{const X=s(F);if(!X)return;const se=E(this.forwarded,X.host,X.port);se&&(se.runningProcess=void 0,se.hasRunningProcess=!1,se.pid=void 0);const W=E(this.detected,X.host,X.port);W&&(W.runningProcess=void 0,W.hasRunningProcess=!1,W.pid=void 0)}),j}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async jb(){const z=Array.from(this.forwarded.values()),j=await this.getAttributes(z.map(M=>({port:M.remotePort,host:M.remoteHost})),!1);if(j)for(const M of z){const N=j.get(M.remotePort);(N?.protocol||M.protocol!==A.TunnelProtocol.Http)&&N?.protocol!==M.protocol&&await this.fb({remote:{host:M.remoteHost,port:M.remotePort},local:M.localPort,name:M.name,source:M.source},N),N&&N.label&&N.label!==M.name&&await this.name(M.remoteHost,M.remotePort,N.label)}}async getAttributes(z,j=!0){const M=new Map,N=new Map;z.forEach(H=>{const V=E(this.m??new Map,A.$xw[0],H.port)??H;if(V){M.set(H.port,V);const x=v(V)?V.pid:void 0;N.has(x)||N.set(x,[]),N.get(x)?.push(H.port)}});const F=new Map;if(z.forEach(H=>{const V=this.configPortsAttributes.getAttributes(H.port,H.host,M.get(H.port)?.detail);V&&F.set(H.port,V)}),this.G.length===0||!j)return F.size>0?F:void 0;const X=await Promise.all(this.G.flatMap(H=>Array.from(N.entries()).map(V=>{const x=V[1],he=M.get(x[0]);return H.providePortAttributes(x,he?.pid,he?.detail,g.CancellationToken.None)}))),se=new Map;if(X.forEach(H=>H.forEach(V=>{V&&se.set(V.port,V)})),!F&&!se)return;const W=new Map;return z.forEach(H=>{const V=F.get(H.port),x=se.get(H.port);W.set(H.port,{elevateIfNeeded:V?.elevateIfNeeded,label:V?.label,onAutoForward:V?.onAutoForward??b.providedActionToAction(x?.autoForwardAction),requireLocalPort:V?.requireLocalPort,protocol:V?.protocol})}),W}addAttributesProvider(z){this.G.push(z)}};e.$4L=O,Ze([(0,u.$6h)(1e3)],O.prototype,"cb",null),e.$4L=O=Ze([Ve(0,A.$sw),Ve(1,f.$0p),Ve(2,p.$7i),Ve(3,a.$SL),Ve(4,D.$Ll),Ve(5,w.$Ji),Ve(6,I.$7j),Ve(7,l.$Xw),Ve(8,d.$RG),Ve(9,o.$Sj)],O)}),define(Ee[99],Se([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$CK=e.$BK=void 0;class r{constructor(L,R){this.line=L,this.character=R}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,R){return new r(0,0)}with(L){return new r(0,0)}}e.$BK=r;class u{constructor(L,R,p,l){this.isEmpty=!1,this.isSingleLine=!1,this.start=new r(L,R),this.end=new r(p,l)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new u(0,0,0,0)}with(L){return new u(0,0,0,0)}}e.$CK=u;var P;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Ee[38],Se([1,0,19,39,25,32,13,5,16,14,99,7]),function(oe,e,r,u,P,T,L,R,p,l,I,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.$ZK=e.$SK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$PK=e.$OK=e.$NK=e.$MK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.TextSearchCompleteMessageType=void 0,e.$JK=g,e.$KK=$,e.$LK=i,e.$QK=S,e.$RK=E,e.$TK=v,e.$UK=b,e.$VK=O,e.$WK=U,e.$XK=z,e.$YK=j,e.$1K=N,e.$3K=se,e.$4K=W,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$DK="workbench.view.search",e.$EK="workbench.panel.search",e.$FK="workbench.view.search",e.$GK="search-result",e.$HK="search.exclude";const f="\u27EA ",A=" characters skipped \u27EB",w=(f.length+A.length+5)*2;e.$IK=(0,R.$Ai)("searchService");var a;(function(V){V[V.file=0]="file",V[V.text=1]="text",V[V.aiText=2]="aiText"})(a||(e.SearchProviderType=a={}));var d;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.aiText=3]="aiText"})(d||(e.QueryType=d={}));function g(V){return!!V.preview}function $(V){return!!V.resource}function i(V){return!!V.message}var o;(function(V){V[V.Normal=0]="Normal",V[V.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class n{constructor(x){this.resource=x,this.results=[]}}e.$MK=n;class t{constructor(x,he,ne,we){this.ranges=he,this.webviewIndex=we;const pe=Array.isArray(he)?he:[he];if(ne&&ne.matchLines===1&&c(pe)){x=(0,L.$6f)(x,ne.matchLines);let ce="",K=0,de=0;const te=Math.floor(ne.charsPerLine/5),ee=[];for(const ie of pe){const le=Math.max(ie.startColumn-te,0),Z=ie.startColumn+ne.charsPerLine;if(le>de+te+w){const ae=f+(le-de)+A;ce+=ae+x.slice(le,Z),K+=le-(de+ae.length)}else ce+=x.slice(de,Z);ee.push(new s(0,ie.startColumn-K,ie.endColumn-K)),de=Z}this.preview={text:ce,matches:Array.isArray(this.ranges)?ee:ee[0]}}else{const ce=Array.isArray(he)?he[0].startLineNumber:he.startLineNumber;this.preview={text:x,matches:(0,r.$1b)(he,K=>new h(K.startLineNumber-ce,K.startColumn,K.endLineNumber-ce,K.endColumn))}}}}e.$NK=t;function c(V){const x=V[0].startLineNumber;for(const he of V)if(he.startLineNumber!==x||he.endLineNumber!==x)return!1;return!0}class h{constructor(x,he,ne,we){this.startLineNumber=x,this.startColumn=he,this.endLineNumber=ne,this.endColumn=we}}e.$OK=h;class s extends h{constructor(x,he,ne){super(x,he,x,ne)}}e.$PK=s;var m;(function(V){V.List="list",V.Tree="tree"})(m||(e.ViewMode=m={}));var y;(function(V){V.Default="default",V.FileNames="fileNames",V.Type="type",V.Modified="modified",V.CountDescending="countDescending",V.CountAscending="countAscending"})(y||(e.SearchSortOrder=y={}));function S(V,x=!0){const he=V&&V.files&&V.files.exclude,ne=x&&V&&V.search&&V.search.exclude;if(!he&&!ne)return;if(!he||!ne)return he||ne;let we=Object.create(null);return we=P.$ao(we,P.$0n(he)),we=P.$ao(we,P.$0n(ne),!0),we}function E(V,x){return V.excludePattern&&u.$tk(V.excludePattern,x)?!1:V.includePattern||V.usingSearchPaths?V.includePattern&&u.$tk(V.includePattern,x)?!0:V.usingSearchPaths?!!V.folderQueries&&V.folderQueries.some(he=>{const ne=he.folder.fsPath;if(T.$zg(x,ne)){const we=p.$lc(ne,x);return!he.includePattern||!!u.$tk(he.includePattern,we)}else return!1}):!1:!0}var k;(function(V){V[V.unknownEncoding=1]="unknownEncoding",V[V.regexParseError=2]="regexParseError",V[V.globParseError=3]="globParseError",V[V.invalidLiteral=4]="invalidLiteral",V[V.rgProcessError=5]="rgProcessError",V[V.other=6]="other",V[V.canceled=7]="canceled"})(k||(e.SearchErrorCode=k={}));class C extends Error{constructor(x,he){super(x),this.code=he}}e.$SK=C;function v(V){const x=V.message;if((0,l.$4)(V))return new C(x,k.canceled);try{const he=JSON.parse(x);return new C(he.message,he.code)}catch{return new C(x,k.other)}}function b(V){const x={message:V.message,code:V.code};return new Error(JSON.stringify(x))}function O(V){return V.type==="error"?!0:V.type==="success"}function U(V){return V.type==="success"}function z(V){return!!V.path}function j(V,x,he=!0){const ne=V.searchPath?V.searchPath:V.relativePath;return he?(0,L.$3f)(ne,x):u.$tk(x,ne)}class M{constructor(x){this.path=x,this.results=[]}addMatch(x){this.results.push(x)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$ZK=M;function N(V,x){const he={...V||{},...x||{}};return Object.keys(he).filter(ne=>{const we=he[ne];return typeof we=="boolean"&&we})}class F{constructor(x,he){this.c=null,this.a={...x.excludePattern||{},...he.excludePattern||{}},this.b=u.$uk(this.a);let ne=x.includePattern;he.includePattern&&(ne?ne={...ne,...he.includePattern}:ne=he.includePattern),ne&&(this.c=u.$uk(ne))}matchesExcludesSync(x,he,ne){return!!(this.b&&this.b(x,he,ne))}includedInQuerySync(x,he,ne){return!(this.b&&this.b(x,he,ne)||this.c&&!this.c(x,he,ne))}includedInQuery(x,he,ne){const we=this.b(x,he,ne),pe=()=>this.c?!!this.c(x,he,ne):!0;return(0,D.$mh)(we)?we.then(ce=>ce?!1:pe()):pe()}hasSiblingExcludeClauses(){return X(this.a)}}e.$2K=F;function X(V){for(const x in V)if(typeof V[x]!="boolean")return!0;return!1}function se(V){if(!V)return;let x;return he=>(x||(x=(V()||Promise.resolve([])).then(ne=>ne?H(ne):{})),x.then(ne=>!!ne[he]))}function W(V){if(!V)return;let x;return he=>{if(!x){const ne=V();x=ne?H(ne):{}}return!!x[he]}}function H(V){const x={};for(const he of V)x[he]=!0;return x}}),define(Ee[42],Se([1,0,19,7,21,4,3,85,15,134,23,13,2,243,28,5,12,279,46,63,30,20,17,8,72,38,6,55]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n,t,c,h,s,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$bnc=void 0;function S(z,j,M){return new I.$3g(N=>v(N,M)).isEqual(z,j)}function E(z,j,M){return S(z.uri,j.uri,M)?0:(0,D.$uf)(z.uri.toString(),j.uri.toString())}function k(z,j,M){return z.index!==j.index?z.index<j.index?-1:1:S(z.uri,j.uri,M)?(0,D.$uf)(z.name,j.name):(0,D.$uf)(z.uri.toString(),j.uri.toString())}function C(z,j,M,N){const F=z.slice(0).sort((se,W)=>M(se,W,N)),X=j.slice(0).sort((se,W)=>M(se,W,N));return(0,r.$Eb)(F,X,(se,W)=>M(se,W,N))}function v(z,j){const M=j.getCapabilities(z.scheme);return!(M&&M&w.FileSystemProviderCapabilities.PathCaseSensitive)}class b extends $.$Ti{static toExtHostWorkspace(j,M,N,F){if(!j)return{workspace:null,added:[],removed:[]};const{id:X,name:se,folders:W,configuration:H,transient:V,isUntitled:x}=j,he=[],ne=M;M?W.forEach((K,de)=>{const te=f.URI.revive(K.uri),ee=b.o(N||M,te,F);ee?(ee.name=K.name,ee.index=K.index,he.push(ee)):he.push({uri:te,name:K.name,index:de})}):he.push(...W.map(({uri:K,name:de,index:te})=>({uri:f.URI.revive(K),name:de,index:te}))),he.sort((K,de)=>K.index<de.index?-1:1);const we=new b(X,se,he,!!V,H?f.URI.revive(H):null,!!x,K=>v(K,F)),{added:pe,removed:ce}=C(ne?ne.workspaceFolders:[],we.workspaceFolders,E,F);return{workspace:we,added:pe,removed:ce}}static o(j,M,N){for(let F=0;F<j.folders.length;F++){const X=j.workspaceFolders[F];if(S(X.uri,M,N))return X}}constructor(j,M,N,F,X,se,W){super(j,N.map(H=>new $.$Ui(H)),F,X,W),this.t=M,this.u=se,this.q=[],this.s=R.$Gi.forUris(W),N.forEach(H=>{this.q.push(H),this.s.set(H.uri,H)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(j,M){return M&&this.s.get(j)&&(j=(0,I.$ah)(j)),this.s.findSubstr(j)}resolveWorkspaceFolder(j){return this.s.get(j)}}let O=class{constructor(j,M,N,F,X){this.c=new T.$he,this.onDidChangeWorkspace=this.c.event,this.g=new T.$he,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new T.$je,this.C=new Map,this.h=F,this.s=N,this.t=X,this.j=new l.$Jm,this.k=new u.$zh,this.o=j.getProxy(m.$vM.MainThreadWorkspace),this.q=j.getProxy(m.$vM.MainThreadMessageService);const se=M.workspace;this.l=se?new b(se.id,se.name,[],!!se.transient,se.configuration?f.URI.revive(se.configuration):null,!!se.isUntitled,W=>v(W,N)):void 0}$initializeWorkspace(j,M){this.v=M,this.$acceptWorkspaceData(j),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?f.URI.from({scheme:p.Schemas.untitled,path:(0,I.$$g)((0,I.$ah)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(j,M,N,...F){const X=[];if(Array.isArray(F)&&F.forEach(x=>{f.URI.isUri(x.uri)&&!X.some(he=>S(he.uri,x.uri,this.s))&&X.push({uri:x.uri,name:x.name||(0,I.$0g)(x.uri)})}),this.n||[M,N].some(x=>typeof x!="number"||x<0)||N===0&&X.length===0)return!1;const se=this.x?this.x.workspaceFolders:[];if(M+N>se.length)return!1;const W=se.slice(0);W.splice(M,N,...X.map(x=>({uri:x.uri,name:x.name||(0,I.$0g)(x.uri),index:void 0})));for(let x=0;x<W.length;x++){const he=W[x];if(W.some((ne,we)=>we!==x&&S(he.uri,ne.uri,this.s)))return!1}W.forEach((x,he)=>x.index=he);const{added:H,removed:V}=C(se,W,k,this.s);if(H.length===0&&V.length===0)return!1;if(this.o){const x=j.displayName||j.name;this.o.$updateWorkspaceFolders(x,M,N,X).then(void 0,he=>{this.n=void 0;const ne={source:{identifier:j.identifier,label:j.displayName||j.name}};this.q.$showMessage(g.Severity.Error,(0,A.localize)(0,null,x,he.toString()),ne,[])})}return this.y(W),!0}getWorkspaceFolder(j,M){if(this.x)return this.x.getWorkspaceFolder(j,M)}async getWorkspaceFolder2(j,M){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(j,M)}async resolveWorkspaceFolder(j){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(j)}getPath(){if(!this.x)return;const{folders:j}=this.x;if(j.length!==0)return j[0].uri.fsPath}getRelativePath(j,M){let N,F="";if(typeof j=="string"?(N=f.URI.file(j),F=j):typeof j<"u"&&(N=j,F=j.fsPath),!N)return F;const X=this.getWorkspaceFolder(N,!0);if(!X)return F;typeof M>"u"&&this.x&&(M=this.x.folders.length>1);let se=(0,I.$dh)(X.uri,N);return M&&X.name&&(se=`${X.name}/${se}`),se}y(j){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:j,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(j){const{workspace:M,added:N,removed:F}=b.toExtHostWorkspace(j,this.l,this.n,this.s);this.l=M||void 0,this.n=void 0,this.c.fire(Object.freeze({added:N,removed:F}))}findFiles(j,M,N,F,X=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let se="",W=!0;return M===null?W=!1:M!==void 0&&(typeof M=="string"?se=M:se=M.pattern),this.z(j,void 0,{exclude:se,maxResults:N,useDefaultExcludes:W,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},X)}findFiles2(j,M={},N,F=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${N.value}, entryPoint: findFiles2`),this.z(void 0,j,M,F)}async z(j,M,N,F=P.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const X=typeof N.exclude=="string"?N.exclude:N.exclude?N.exclude.pattern:void 0,se={ignoreSymlinks:typeof N.followSymlinks=="boolean"?!N.followSymlinks:void 0,disregardIgnoreFiles:typeof N.useIgnoreFiles=="boolean"?!N.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof N.useGlobalIgnoreFiles=="boolean"?!N.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof N.useParentIgnoreFiles=="boolean"?!N.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof N.useDefaultExcludes=="boolean"?!N.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof N.useDefaultSearchExcludes=="boolean"?!N.useDefaultSearchExcludes:!1,maxResults:N.maxResults,excludePattern:X,shouldGlobSearch:typeof N.fuzzy=="boolean"?!N.fuzzy:!0,_reason:"startFileSearch"};let W;if(j){const{includePattern:H,folder:V}=U(t.GlobPattern.from(j));W=V,se.includePattern=H}else{const{includePattern:H,folder:V}=U(t.GlobPattern.from(M));W=V,se.filePattern=H}return this.o.$startFileSearch(W??null,se,F).then(H=>Array.isArray(H)?H.map(V=>f.URI.revive(V)):[])}async findTextInFiles(j,M,N,F,X=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const se=this.j.getNext(),W=typeof M.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:M.previewOptions,{includePattern:H,folder:V}=U(t.GlobPattern.from(M.include)),x=typeof M.exclude=="string"?M.exclude:M.exclude?M.exclude.pattern:void 0,he={ignoreSymlinks:typeof M.followSymlinks=="boolean"?!M.followSymlinks:void 0,disregardIgnoreFiles:typeof M.useIgnoreFiles=="boolean"?!M.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof M.useGlobalIgnoreFiles=="boolean"?!M.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof M.useParentIgnoreFiles=="boolean"?!M.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof M.useDefaultExcludes=="boolean"?!M.useDefaultExcludes:!0,fileEncoding:M.encoding,maxResults:M.maxResults,previewOptions:W,afterContext:M.afterContext,beforeContext:M.beforeContext,includePattern:H,excludePattern:x},ne=!1;if(this.u[se]=we=>{if(ne)return;const pe=f.URI.revive(we.resource);we.results.forEach(ce=>{const K=(0,y.$0h)(ce);(0,s.$JK)(K)?N({uri:pe,preview:{text:K.preview.text,matches:(0,r.$1b)(K.preview.matches,de=>new c.$zM(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))},ranges:(0,r.$1b)(K.ranges,de=>new c.$zM(de.startLineNumber,de.startColumn,de.endLineNumber,de.endColumn))}):N({uri:pe,text:K.text,lineNumber:K.lineNumber})})},X.isCancellationRequested)return{};try{const we=await this.o.$startTextSearch(j,V??null,he,se,X);return delete this.u[se],we||{}}catch(we){throw delete this.u[se],we}}$handleTextSearchResult(j,M){this.u[M]?.(j)}async save(j){const M=await this.o.$save(j,{saveAs:!1});return f.URI.revive(M)}async saveAs(j){const M=await this.o.$save(j,{saveAs:!0});return f.URI.revive(M)}saveAll(j){return this.o.$saveAll(j)}resolveProxy(j){return this.o.$resolveProxy(j)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(j){return this.o.$requestWorkspaceTrust(j)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(j,M){if(this.w.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.w.set(j,M);const N=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,N),(0,L.$Sc)(()=>{this.w.delete(j),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(j,M){this.h.info("Getting edit session identifier for workspaceFolder",j);const N=await this.resolveWorkspaceFolder(f.URI.revive(j));if(!N){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",N);const F=this.w.get(N.uri.scheme);if(this.h.info(`Provider for scheme ${N.uri.scheme} is defined: `,!!F),!F)return;const X=await F.provideEditSessionIdentity(N,M);if(this.h.info("Provider returned edit session identifier: ",X),!!X)return X}async $provideEditSessionIdentityMatch(j,M,N,F){this.h.info("Getting edit session identifier for workspaceFolder",j);const X=await this.resolveWorkspaceFolder(f.URI.revive(j));if(!X){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",X);const se=this.w.get(X.uri.scheme);if(this.h.info(`Provider for scheme ${X.uri.scheme} is defined: `,!!se),!se)return;const W=await se.provideEditSessionIdentityMatch?.(M,N,F);if(this.h.info("Provider returned edit session identifier match result: ",W),!!W)return W}getOnWillCreateEditSessionIdentityEvent(j){return(M,N,F)=>{const X=function(W){M.call(N,W)};return X.extension=j,this.B.event(X,void 0,F)}}async $onWillCreateEditSessionIdentity(j,M,N){const F=await this.resolveWorkspaceFolder(f.URI.revive(j));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},M,async(X,se)=>{const W=Date.now();await Promise.resolve(X),Date.now()-W>N&&this.h.warn("SLOW edit session create-participant",se.extension.identifier)}),M.isCancellationRequested}registerCanonicalUriProvider(j,M){if(this.C.has(j))throw new Error(`A provider has already been registered for scheme ${j}`);this.C.set(j,M);const N=this.t.transformOutgoingScheme(j),F=this.A++;return this.o.$registerCanonicalUriProvider(F,N),(0,L.$Sc)(()=>{this.C.delete(j),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(j,M,N){const F=this.C.get(j.scheme);if(!F)return;const X=await F.provideCanonicalUri?.(f.URI.revive(j),M,N);if(X)return X}async $provideCanonicalUri(j,M,N){return this.provideCanonicalUri(f.URI.revive(j),{targetScheme:M},N)}};e.$bnc=O,e.$bnc=O=Ze([Ve(0,n.$ZO),Ve(1,o.$dP),Ve(2,i.$Wmc),Ve(3,d.$7j),Ve(4,h.$_mc)],O),e.$cnc=(0,a.$Ai)("IExtHostWorkspace");function U(z){let j,M;return z&&(typeof z=="string"?j=z:(j=z.pattern,M=f.URI.revive(z.baseUri))),{includePattern:j,folder:M}}}),define(Ee[48],Se([1,0,25,4,42,6,8,45,281,70,18,7,5,20,12,2]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=e.$enc=e.$dnc=void 0;function d(h,s){if(s){const m=s.split(".");let y=h;for(let S=0;y&&S<m.length;S++)y=y[m[S]];return y}}function g(h){return h instanceof a.URI}function $(h){return h&&h.uri instanceof a.URI&&h.languageId&&typeof h.languageId=="string"}function i(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function o(h){return h&&h.uri instanceof a.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function n(h){if(g(h))return{resource:h};if($(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(i(h))return{overrideIdentifier:h.languageId};if(o(h))return{resource:h.uri};if(h===null)return{resource:null}}let t=class{constructor(s,m,y){this.a=s.getProxy(T.$vM.MainThreadConfiguration),this.c=m,this.b=y,this.d=new D.$zh,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new c(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,m){this.getConfigProvider().then(y=>y.$acceptConfigurationChanged(s,m))}};e.$dnc=t,e.$dnc=t=Ze([Ve(0,A.$ZO),Ve(1,P.$cnc),Ve(2,w.$7j)],t);class c{constructor(s,m,y,S){this.a=new u.$he,this.b=s,this.f=S,this.c=m,this.e=p.$Io.parse(y,S),this.d=this.k(y.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,m){const y={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Io.parse(s,this.f),this.d=this.k(s.configurationScopes),this.a.fire(this.j(m,y))}getConfiguration(s,m,y){const S=n(m)||{},E=this.g(s?d(this.e.getValue(void 0,S,this.c.workspace),s):this.e.getValue(void 0,S,this.c.workspace));s&&this.h(s,S,y?.identifier);function k(v){if(v==null)return null;if(typeof v=="boolean")return v?R.ConfigurationTarget.USER:R.ConfigurationTarget.WORKSPACE;switch(v){case L.ConfigurationTarget.Global:return R.ConfigurationTarget.USER;case L.ConfigurationTarget.Workspace:return R.ConfigurationTarget.WORKSPACE;case L.ConfigurationTarget.WorkspaceFolder:return R.ConfigurationTarget.WORKSPACE_FOLDER}}const C={has(v){return typeof d(E,v)<"u"},get:(v,b)=>{this.h(s?`${s}.${v}`:v,S,y?.identifier);let O=d(E,v);if(typeof O>"u")O=b;else{let U;const z=(j,M)=>{if((0,I.$cg)(j)){let N;const F=()=>{U=U||(0,r.$0n)(E),N=N||d(U,M)};return new Proxy(j,{get:(X,se)=>{if(typeof se=="string"&&se.toLowerCase()==="tojson")return F(),()=>N;if(U)return N=N||d(U,M),N[se];const W=X[se];return typeof se=="string"?z(W,`${M}.${se}`):W},set:(X,se,W)=>(F(),N&&(N[se]=W),!0),deleteProperty:(X,se)=>(F(),N&&delete N[se],!0),defineProperty:(X,se,W)=>(F(),N&&Object.defineProperty(N,se,W),!0)})}return Array.isArray(j)?(0,r.$0n)(j):j};O=z(O,v)}return O},update:(v,b,O,U)=>{v=s?`${s}.${v}`:v;const z=k(O);return b!==void 0?this.b.$updateConfigurationOption(z,v,b,S,U):this.b.$removeConfigurationOption(z,v,S,U)},inspect:v=>{v=s?`${s}.${v}`:v;const b=this.e.inspect(v,S,this.c.workspace);if(b)return{key:v,defaultValue:(0,r.$0n)(b.policy?.value??b.default?.value),globalValue:(0,r.$0n)(b.user?.value??b.application?.value),workspaceValue:(0,r.$0n)(b.workspace?.value),workspaceFolderValue:(0,r.$0n)(b.workspaceFolder?.value),defaultLanguageValue:(0,r.$0n)(b.default?.override),globalLanguageValue:(0,r.$0n)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,r.$0n)(b.workspace?.override),workspaceFolderLanguageValue:(0,r.$0n)(b.workspaceFolder?.override),languageIds:(0,r.$0n)(b.overrideIdentifiers)}}};return typeof E=="object"&&(0,r.$ao)(C,E,!1),Object.freeze(C)}g(s){const m=y=>(0,I.$cg)(y)?new Proxy(y,{get:(S,E)=>m(S[E]),set:(S,E,k)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(E)}' of object`)},deleteProperty:(S,E)=>{throw new Error(`TypeError: Cannot delete read only property '${String(E)}' of object`)},defineProperty:(S,E)=>{throw new Error(`TypeError: Cannot define property '${String(E)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):y;return m(s)}h(s,m,y){const S=l.$zo.test(s)?l.ConfigurationScope.RESOURCE:this.d.get(s),E=y?`[${y.value}] `:"";if(l.ConfigurationScope.RESOURCE===S){typeof m?.resource>"u"&&this.f.warn(`${E}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(l.ConfigurationScope.WINDOW===S){m?.resource&&this.f.warn(`${E}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,m){const y=new p.$Ko(s,m,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,E)=>y.affectsConfiguration(S,n(E))})}k(s){return s.reduce((m,y)=>(m.set(y[0],y[1]),m),new Map)}}e.$enc=c,e.$fnc=(0,f.$Ai)("IExtHostConfiguration")});var rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r},Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)};define(Ee[100],Se([1,0,2,7,4,6,8,42,78,48,21,47,20,30,5,15,11,12,96,322,14]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=e.$Ioc=e.$Hoc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(z){function j(N){if(N!=null)return N}z.from=j;function M(N){if(N!=null)return N}z.to=M})(t||(t={}));var c;(function(z){function j(N){if(N!=null)return N}z.from=j;function M(N){if(N!=null)return N}z.to=M})(c||(c={}));var h;(function(z){function j(N){if(N!=null)return N}z.from=j;function M(N){if(N!=null)return N}z.to=M})(h||(h={}));var s;(function(z){function j(F){if(F){const X=F;return X&&!!X.process}else return!1}z.is=j;function M(F){if(F==null)return;const X={process:F.process,args:F.args};return F.options&&(X.options=h.from(F.options)),X}z.from=M;function N(F){if(F!=null)return new L.$hN(F.process,F.args,F.options)}z.to=N})(s||(s={}));var m;(function(z){function j(N){if(N!=null)return N}z.from=j;function M(N){if(N!=null)return N}z.to=M})(m||(m={}));var y;(function(z){function j(F){if(F){const X=F;return X&&(!!X.commandLine||!!X.command)}else return!1}z.is=j;function M(F){if(F==null)return;const X={};return F.commandLine!==void 0?X.commandLine=F.commandLine:(X.command=F.command,X.args=F.args),F.options&&(X.options=m.from(F.options)),X}z.from=M;function N(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new L.$iN(F.commandLine,F.options):new L.$iN(F.command,F.args?F.args:[],F.options)}z.to=N})(y||(y={}));var S;(function(z){function j(F){if(F){const X=F;return X&&X.customExecution==="customExecution"}else return!1}z.is=j;function M(F){return{customExecution:"customExecution"}}z.from=M;function N(F,X){return X.get(F)}z.to=N})(S||(e.CustomExecutionDTO=S={}));var E;(function(z){function j(M,N){let F;return M.scope!==void 0&&typeof M.scope!="number"?F=M.scope.uri:M.scope!==void 0&&typeof M.scope=="number"&&(M.scope===L.TaskScope.Workspace&&N&&N.workspaceFile?F=N.workspaceFile:F=i.$vI),{id:M._id,workspaceFolder:F}}z.from=j})(E||(e.TaskHandleDTO=E={}));var k;(function(z){function j(M){if(M!=null)return{_id:M.id,isDefault:M.isDefault}}z.from=j})(k||(k={}));var C;(function(z){function j(F,X){if(F==null)return[];const se=[];for(const W of F){const H=M(W,X);H&&se.push(H)}return se}z.fromMany=j;function M(F,X){if(F==null)return;let se;F.execution instanceof L.$hN?se=s.from(F.execution):F.execution instanceof L.$iN?se=y.from(F.execution):F.execution&&F.execution instanceof L.$jN&&(se=S.from(F.execution));const W=t.from(F.definition);let H;return F.scope?typeof F.scope=="number"?H=F.scope:H=F.scope.uri:H=L.TaskScope.Workspace,!W||!H?void 0:{_id:F._id,definition:W,name:F.name,source:{extensionId:X.identifier.value,label:F.source,scope:H},execution:se,isBackground:F.isBackground,group:k.from(F.group),presentationOptions:c.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}z.from=M;async function N(F,X,se){if(F==null)return;let W;s.is(F.execution)?W=s.to(F.execution):y.is(F.execution)?W=y.to(F.execution):S.is(F.execution)&&(W=S.to(F._id,se));const H=t.to(F.definition);let V;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?V=F.source.scope:V=await X.resolveWorkspaceFolder(r.URI.revive(F.source.scope)):V=L.TaskScope.Workspace),!H||!V)return;const x=new L.$kN(H,V,F.name,F.source.label,W,F.problemMatchers);return F.isBackground!==void 0&&(x.isBackground=F.isBackground),F.group!==void 0&&(x.group=L.$gN.from(F.group._id),x.group&&F.group.isDefault&&(x.group=new L.$gN(x.group.id,x.group.label),F.group.isDefault===!0&&(x.group.isDefault=F.group.isDefault))),F.presentationOptions&&(x.presentationOptions=c.to(F.presentationOptions)),F._id&&(x._id=F._id),F.detail&&(x.detail=F.detail),x}z.to=N})(C||(e.TaskDTO=C={}));var v;(function(z){function j(N){return N}z.from=j;function M(N){if(N)return Object.assign(Object.create(null),N)}z.to=M})(v||(v={}));class b{constructor(j,M,N){this._id=M,this.a=N,n.set(this,void 0),rt(this,n,j,"f")}get task(){return this.a}terminate(){Ge(this,n,"f").terminateTask(this)}fireDidStartProcess(j){}fireDidEndProcess(j){}}n=new WeakMap;let O=class{constructor(j,M,N,F,X,se,W,H){this.q=new P.$he,this.r=new P.$he,this.s=new P.$he,this.u=new P.$he,this.a=j.getProxy(T.$vM.MainThreadTask),this.b=N,this.c=F,this.d=X,this.e=se,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=W,this.g=H,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(j,M,N){if(!N)return new L.$xM(()=>{});const F=this.x();return this.j.set(F,{type:M,provider:N,extension:j}),this.a.$registerTaskProvider(F,M),new L.$xM(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(j,M){this.a.$registerTaskSystem(j,M)}fetchTasks(j){return this.a.$fetchTasks(v.from(j)).then(async M=>{const N=[];for(const F of M){const X=await C.to(F,this.b,this.m);X&&N.push(X)}return N})}get taskExecutions(){const j=[];return this.k.forEach(M=>j.push(M)),j}terminateTask(j){if(!(j instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(j._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(j,M,N){const F=this.m.get(j.id);F&&(this.o.set(j.id,F),this.e.attachPtyToTerminal(M,await F.callback(N))),this.p=j.id,this.q.fire({execution:await this.z(j)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(j){if(!this.l.has(j.id))return;const M=await this.z(j);this.l.delete(j.id),this.k.delete(j.id),this.B(j),this.r.fire({execution:M})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(j){const M=await this.z(j.id);this.s.fire({execution:M,processId:j.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(j){const M=await this.z(j.id);this.u.fire({execution:M,exitCode:j.exitCode})}$provideTasks(j,M){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));const F=[],X=(0,u.$sh)(()=>N.provider.provideTasks(I.CancellationToken.None)).then(se=>this.v(M,F,N,se));return new Promise(se=>{X.then(W=>{Promise.all(F).then(()=>{se(W)})})})}async $resolveTask(j,M){const N=this.j.get(j);if(!N)return Promise.reject(new Error("no handler found"));if(M.definition.type!==N.type)throw new Error(`Unexpected: Task of type [${M.definition.type}] cannot be resolved by provider of type [${N.type}].`);const F=await C.to(M,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const X=await N.provider.resolveTask(F,I.CancellationToken.None);if(!X)return;this.A(X,N);const se=C.from(X,N.extension);if(!se)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(se.execution)&&await this.y(se,X,!0),await this.w(se)}x(){return this.h++}async y(j,M,N){const F=await this.a.$createTaskId(j);!N&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,M.execution)),this.m.set(F,M.execution)}async z(j,M){if(typeof j=="string"){const X=this.l.get(j);if(!X)throw new o.$bb("Unexpected: The specified task is missing an execution");return X}const N=this.l.get(j.id);if(N)return N;let F;return M?F=Promise.resolve(new b(this,j.id,M)):F=C.to(j.task,this.b,this.m).then(X=>{if(!X)throw new o.$bb("Unexpected: Task does not exist.");return new b(this,j.id,X)}),this.l.set(j.id,F),F.then(X=>(this.k.set(j.id,X),X))}A(j,M){j._deprecated&&this.g.report("Task.constructor",M.extension,"Use the Task constructor that takes a `scope` instead.")}B(j){this.o.get(j.id)&&this.o.delete(j.id),this.n.has(j.id)&&this.p!==j.id&&(this.m.delete(j.id),this.n.delete(j.id));const N=this.n.values();let F=N.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=N.next()}};e.$Hoc=O,e.$Hoc=O=Ze([Ve(0,f.$ZO),Ve(1,A.$dP),Ve(2,R.$cnc),Ve(3,p.$$O),Ve(4,l.$fnc),Ve(5,D.$Dnc),Ve(6,g.$7j),Ve(7,$.$Smc)],O);let U=class extends O{constructor(j,M,N,F,X,se,W,H){super(j,M,N,F,X,se,W,H),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:d.$b(d.Platform.Web)})}async executeTask(j,M){if(!M.execution)throw new Error("Tasks to execute must include an execution");const N=C.from(M,j);if(N===void 0)throw new Error("Task is not valid");if(S.is(N.execution))await this.y(N,M,!1);else throw new o.$_;const F=await this.z(await this.a.$getTaskExecution(N),M);return this.a.$executeTask(N).catch(X=>{throw new Error(X)}),F}v(j,M,N,F){const X=[];if(F)for(const se of F){if(this.A(se,N),!se.definition||!j[se.definition.type]){const H=se.source?se.source:"No task source";this.f.warn(`The task [${H}, ${se.name}] uses an undefined task type. The task will be ignored in the future.`)}const W=C.from(se,N.extension);W&&S.is(W.execution)?(X.push(W),M.push(this.y(W,se,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:X,extension:N.extension}}async w(j){if(S.is(j.execution))return j;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(j,M){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(j,M,N){}};e.$Ioc=U,e.$Ioc=U=Ze([Ve(0,f.$ZO),Ve(1,A.$dP),Ve(2,R.$cnc),Ve(3,p.$$O),Ve(4,l.$fnc),Ve(5,D.$Dnc),Ve(6,g.$7j),Ve(7,$.$Smc)],U),e.$Joc=(0,w.$Ai)("IExtHostTask")}),define(Ee[383],Se([1,0,38,31]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$K=void 0,e.$0K=P,e.$_K=T;function P(L){return"cellResults"in L}e.$$K="rawCell#";function T(L,R){let p=-1;const l=[];let I=[];return L.forEach(f=>{f.range.startLineNumber!==p&&I.length>0&&(l.push([...I]),I=[]),I.push(f),p=f.range.endLineNumber}),I.length>0&&l.push([...I]),l.map(f=>{const A=[],w=f[0].range.startLineNumber,a=f[f.length-1].range.endLineNumber;for(let d=w;d<=a;d++)A.push(R.getLineContent(d));return new r.$NK(A.join(`
`)+`
`,f.map(d=>new u.$dt(d.range.startLineNumber-1,d.range.startColumn-1,d.range.endLineNumber-1,d.range.endColumn-1)))})}}),define(Ee[384],Se([1,0,237,22,4,3,29,41,13,18,2,28,118,6,37,17,8,52,355,164,25,15,38,311,383,380]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n,t,c,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=void 0;class m{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(S=>S.apiEditor)}constructor(S,E,k,C,v,b,O){this.q=k,this.r=C,this.s=v,this.t=b,this.u=O,this.f=new Map,this.g=new L.$Ac,this.h=new Map,this.j=new P.$he,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$he,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$he,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$he,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new f.$Qmc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=S.getProxy(A.$vM.MainThreadNotebook),this.c=S.getProxy(A.$vM.MainThreadNotebookDocuments),this.d=S.getProxy(A.$vM.MainThreadNotebookEditors),this.i=E.converter,E.registerArgumentProcessor({processArgument:U=>{if(U&&U.$mid===R.MarshalledId.NotebookCellActionContext){const z=U.notebookEditor?.notebookUri,j=U.cell.handle,N=this.g.get(z)?.getCell(j);if(N)return N.apiCell}if(U&&U.$mid===R.MarshalledId.NotebookActionContext){const z=U.uri,j=this.g.get(z);if(j)return j.apiNotebook}return U}}),m.C(E)}getEditorById(S){const E=this.h.get(S);if(!E)throw new Error(`unknown text editor: ${S}. known editors: ${[...this.h.keys()]} `);return E}getIdByEditor(S){for(const[E,k]of this.h)if(k.apiEditor===S)return E}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(S,E){const k=this.g.get(S);if(!k&&!E)throw new Error(`NO notebook document for '${S}'`);return k}static w(S,E){if(!E)return;const k=E.filenamePattern.map(C=>a.NotebookExclusiveDocumentPattern.from(C)).filter(C=>C!==void 0);if(E.filenamePattern&&!k){console.warn(`Notebook content provider view options file name pattern is invalid ${E.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:E.displayName,filenamePattern:k,exclusive:E.exclusive||!1}}registerNotebookCellStatusBarItemProvider(S,E,k){const C=m.a++,v=typeof k.onDidChangeCellStatusBarItems=="function"?m.a++:void 0;this.f.set(C,k),this.b.$registerNotebookCellStatusBarItemProvider(C,v,E);let b;return v!==void 0&&(b=k.onDidChangeCellStatusBarItems(O=>this.b.$emitCellStatusBarEvent(v))),new d.$xM(()=>{this.f.delete(C),this.b.$unregisterNotebookCellStatusBarItemProvider(C,v),b?.dispose()})}async createNotebookDocument(S){const E=await this.c.$tryCreateNotebook({viewType:S.viewType,content:S.content&&a.NotebookData.from(S.content)});return I.URI.revive(E)}async openNotebookDocument(S){const E=this.g.get(S);if(E)return E.apiNotebook;const k=await this.c.$tryOpenNotebook(S),C=this.g.get(I.URI.revive(k));return(0,l.$lg)(C?.apiNotebook)}async showNotebookDocument(S,E){I.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let k;typeof E=="object"?k={position:a.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selections:E.selections&&E.selections.map(a.NotebookRange.from),pinned:typeof E.preview=="boolean"?!E.preview:void 0}:k={preserveFocus:!1};const C=await this.d.$tryShowNotebookDocument(S.uri,S.notebookType,k),v=C&&this.h.get(C)?.apiEditor;if(v)return v;throw C?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,E,k,C){const v=this.f.get(S),b=I.URI.revive(E),O=this.g.get(b);if(!O||!v)return;const U=O.getCellFromIndex(k);if(!U)return;const z=await v.provideCellStatusBarItems(U.apiCell,C);if(!z)return;const j=new T.$Tc,M=this.p.add([j]),F=(Array.isArray(z)?z:[z]).map(X=>a.NotebookStatusBarItem.from(X,this.i,j));return{cacheId:M,items:F}}$releaseNotebookCellStatusBarItems(S){this.p.delete(S)}registerNotebookSerializer(S,E,k,C,v){if((0,p.$$e)(E))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:E,serializer:k,options:C}),this.b.$registerNotebookSerializer(b,{id:S.identifier,location:S.extensionLocation},E,a.NotebookDocumentContentOptions.from(C),m.w(S,v)),(0,T.$Sc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(S,E,k){const C=this.y.get(S);if(!C)throw new Error("NO serializer found");const v=await C.serializer.deserializeNotebook(E.buffer,k);return new g.$Lw(a.NotebookData.from(v))}async $notebookToData(S,E,k){const C=this.y.get(S);if(!C)throw new Error("NO serializer found");const v=await C.serializer.serializeNotebook(a.NotebookData.to(E.value),k);return u.$Je.wrap(v)}async $saveNotebook(S,E,k,C,v){const b=I.URI.revive(E),O=this.y.get(S);if(this.D(`enter saveNotebook(versionId: ${k}, ${b.toString()})`),!O)throw new Error("NO serializer found");const U=this.g.get(b);if(!U)throw new Error("Document NOT found");if(U.versionId!==k)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new D.$pl((0,r.localize)(0,null,this.A(b)),D.FileOperationResult.FILE_PERMISSION_DENIED);const z={metadata:(0,o.$fo)(U.apiNotebook.metadata,X=>!(O.options?.transientDocumentMetadata??{})[X]),cells:[]};for(const X of U.apiNotebook.getCells()){const se=new d.$1N(X.kind,X.document.getText(),X.document.languageId,X.mime,O.options?.transientOutputs?[]:[...X.outputs],X.metadata,X.executionSummary);se.metadata=(0,o.$fo)(X.metadata,W=>!(O.options?.transientCellMetadata??{})[W]),z.cells.push(se)}if(await this.z(b,C),v.isCancellationRequested)throw new Error("canceled");const j=await O.serializer.serializeNotebook(z,v);if(v.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${k} ${b.toString()}`),await this.s.value.writeFile(b,j),this.D(`Finished write versionId: ${k} ${b.toString()}`);const M=this.s.getFileSystemProviderExtUri(b.scheme),N=await this.s.value.stat(b),F={name:M.basename(b),isFile:(N.type&D.FileType.File)!==0,isDirectory:(N.type&D.FileType.Directory)!==0,isSymbolicLink:(N.type&D.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&D.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((N.permissions??0)&D.FilePermission.Locked),etag:D.$Al({mtime:N.mtime,size:N.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${k}, ${b.toString()})`),F}async $searchInNotebooks(S,E,k,C,v){const b=this.y.get(S)?.serializer;if(!b)return{limitHit:!1,results:[]};const O=new L.$Bc;await(async(N,F,X)=>{await Promise.all(N.map(async se=>await Promise.all(se.filenamePatterns.map(W=>{const H={_reason:X._reason,folderQueries:X.folderQueries,includePattern:X.includePattern,excludePattern:X.excludePattern,maxResults:X.maxResults,type:t.QueryType.File,filePattern:W};return this.t.doInternalFileSearchWithCustomCallback(H,F,V=>{V.forEach(x=>{O.has(x)||C.some(ne=>se.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(we=>(0,s.$yhb)(we,x)))||O.add(x)})}).catch(V=>{if(V.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw V})}))))})(k,v,E);const z=new L.$Ac;let j=!1;const M=Array.from(O).map(async N=>{const F=[];try{if(v.isCancellationRequested)return;if(E.maxResults&&[...z.values()].reduce((H,V)=>H+V.cellResults.length,0)>E.maxResults){j=!0;return}const X=[],se=this.g.get(N);if(se)se.apiNotebook.getCells().forEach(V=>X.push({input:V.document.getText(),outputs:V.outputs.flatMap(x=>x.items.map(he=>he.data.toString()))}));else{const H=await this.s.value.readFile(N),V=u.$Je.fromString(H.toString()),x=await b.deserializeNotebook(V.buffer,v);if(v.isCancellationRequested)return;a.NotebookData.from(x).cells.forEach(ne=>X.push({input:ne.source,outputs:ne.outputs.flatMap(we=>we.items.map(pe=>pe.valueBytes.toString()))}))}if(v.isCancellationRequested)return;X.forEach((H,V)=>{const x=E.contentPattern.pattern,he=new c.$gYb(H.input,void 0,H.outputs),ne=he.findInInputs(x),we=he.findInOutputs(x),pe=we.flatMap(ce=>(0,h.$_K)(ce.matches,ce.textBuffer)).map((ce,K)=>(ce.webviewIndex=K,ce));if(ne.length>0||we.length>0){const ce={index:V,contentResults:(0,h.$_K)(ne,he.inputTextBuffer),webviewResults:pe};F.push(ce)}});const W={resource:N,cellResults:F};z.set(N,W);return}catch{return}});return await Promise.all(M),{limitHit:j,results:[...z.values()]}}async z(S,E){const k=await this.s.value.stat(S);if(typeof E?.mtime=="number"&&typeof E.etag=="string"&&E.etag!==D.$zl&&typeof k.mtime=="number"&&typeof k.size=="number"&&E.mtime<k.mtime&&E.etag!==D.$Al({mtime:E.mtime,size:k.size}))throw new D.$pl((0,r.localize)(1,null),D.FileOperationResult.FILE_MODIFIED_SINCE,E)}A(S){return S.scheme===n.Schemas.file?S.fsPath:S.toString()}B(S,E,k){if(this.h.has(E))throw new Error(`editor with id ALREADY EXSIST: ${E}`);const C=new i.$boc(E,this.d,S,k.visibleRanges.map(a.NotebookRange.to),k.selections.map(a.NotebookRange.to),typeof k.viewColumn=="number"?a.ViewColumn.to(k.viewColumn):void 0);this.h.set(E,C)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const k of S.value.removedDocuments){const C=I.URI.revive(k),v=this.g.get(C);v&&(v.dispose(),this.g.delete(C),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:v.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(v.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===C.toString()&&this.h.delete(b.id)}if(S.value.addedDocuments){const k=[];for(const C of S.value.addedDocuments){const v=I.URI.revive(C.uri);if(this.g.has(v))throw new Error(`adding EXISTING notebook ${v} `);const b=new $.$aoc(this.c,this.q,this.r,v,C);k.push(...C.cells.map(O=>$.$_nc.asModelAddData(O))),this.g.get(v)?.dispose(),this.g.set(v,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:k}),this.m.fire(b.apiNotebook)}}if(S.value.addedEditors)for(const k of S.value.addedEditors){if(this.h.has(k.id))return;const C=I.URI.revive(k.documentUri),v=this.g.get(C);v&&this.B(v,k.id,k)}const E=[];if(S.value.removedEditors)for(const k of S.value.removedEditors){const C=this.h.get(k);C&&(this.h.delete(k),this.k?.id===C.id&&(this.k=void 0),E.push(C))}if(S.value.visibleEditors){this.l=S.value.visibleEditors.map(C=>this.h.get(C)).filter(C=>!!C);const k=new Set;this.l.forEach(C=>k.add(C.id));for(const C of this.h.values()){const v=k.has(C.id);C._acceptVisibility(v)}this.l=[...this.h.values()].map(C=>C).filter(C=>C.visible),this.o.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this.k=void 0:S.value.newActiveEditor&&(this.h.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this.k=this.h.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(S){const E=w.$lP.String.with("notebookType","A notebook type"),k=new w.$nP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[E,new w.$lP("data","Bytes to convert to data",v=>v instanceof Uint8Array,v=>u.$Je.wrap(v))],new w.$mP("Notebook Data",v=>a.NotebookData.to(v.value))),C=new w.$nP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[E,new w.$lP("NotebookData","Notebook data to convert to bytes",v=>!0,v=>new g.$Lw(a.NotebookData.from(v)))],new w.$mP("Bytes",v=>v.buffer));S.registerApiCommand(k),S.registerApiCommand(C)}D(S){this.u.trace(`[Extension Host Notebook] ${S}`)}}e.$koc=m,m.a=0}),define(Ee[385],Se([1,0,16,21,51,39,23,43,38]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=void 0;class l{constructor(f,A,w){this.k=f,this.l=A,this.o=w,this.e=!1,this.f=0,this.g=!1,this.a=f.filePattern,this.b=f.includePattern&&T.$uk(f.includePattern),this.c=f.maxResults||void 0,this.d=f.exists,this.h=new Set,this.j=f.excludePattern&&T.$uk(f.excludePattern)}cancel(){this.g=!0,this.h.forEach(f=>f.cancel()),this.h=new Set}search(f){const A=this.k.folderQueries||[];return new Promise((w,a)=>{const d=g=>{this.f++,f(g)};if(this.g)return w({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(g=>{const $=g.toString(),i=r.$nc($);this.j&&this.j($,i)||this.v(d,{base:g,basename:i})}),Promise.all(A.map(g=>this.p(g,d))).then(g=>{w({limitHit:this.e,stats:g[0]||void 0})},g=>{a(new Error((0,P.$lj)(g)))})})}async p(f,A){const w=new u.$se,a=this.q(f),d=this.r(),g=new p.$2K(this.k,f),$=!g.hasSiblingExcludeClauses();let i;try{this.h.add(w),i=R.$be.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,w.token),n=i.elapsed(),t=R.$be.create();return this.g&&!this.e||(o&&o.forEach(c=>{const h=r.$gc.relative(f.folder.path,c.path);if($){const s=r.$nc(c.path);this.v(A,{base:f.folder,relativePath:h,basename:s});return}this.s(d,f.folder,h,A)}),this.g&&!this.e)?null:(this.u(d,g,A),{providerTime:n,postProcessTime:t.elapsed()})}finally{w.dispose(),this.h.delete(w)}}q(f){const A=(0,p.$1K)(this.k.includePattern,f.includePattern),w=(0,p.$1K)(this.k.excludePattern,f.excludePattern);return{folder:f.folder,excludes:w,includes:A,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const f={rootEntries:[],pathToEntries:Object.create(null)};return f.pathToEntries["."]=f.rootEntries,f}s({pathToEntries:f},A,w,a){if(w===this.a){const g=r.$nc(this.a);this.v(a,{base:A,relativePath:this.a,basename:g})}function d(g){const $=r.$nc(g),i=r.$mc(g);let o=f[i];o||(o=f[i]=[],d(i)),o.push({base:A,relativePath:g,basename:$})}d(w)}u({rootEntries:f,pathToEntries:A},w,a){const d=this,g=this.a;function $(i){const o=(0,p.$4K)(()=>i.map(n=>n.basename));for(let n=0,t=i.length;n<t;n++){const c=i[n],{relativePath:h,basename:s}=c;if(w.matchesExcludesSync(h,s,g!==s?o:void 0))continue;const m=A[h];if(m)$(m);else{if(h===g)continue;d.v(a,c)}if(d.e)break}}$(f)}v(f,A){(!this.b||A.relativePath&&this.b(A.relativePath,A.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||f(A))}}class I{constructor(){this.b=new Map}fileSearch(f,A,w,a){const d=this.c(f.cacheKey),g=new l(f,A,d&&d.token);let $=0;const i=o=>{$+=o.length,w(o.map(n=>this.d(n)))};return this.e(g,I.a,i,a).then(o=>({limitHit:o.limitHit,stats:o.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:$,detailStats:o.stats}:void 0,messages:[]}))}clearCache(f){this.c(f)?.cancel()}c(f){if(f)return this.b.has(f)||this.b.set(f,new u.$se),this.b.get(f)}d(f){return f.relativePath?{resource:L.$bh(f.base,f.relativePath)}:{resource:f.base}}e(f,A,w,a){const d=a.onCancellationRequested(()=>{f.cancel()}),g=i=>{i&&($.push(i),A>0&&$.length>=A&&(w($),$=[]))};let $=[];return f.search(g).then(i=>($.length&&w($),d.dispose(),i),i=>($.length&&w($),d.dispose(),Promise.reject(i)))}}e.$coc=I,I.a=512}),define(Ee[386],Se([1,0,19,79,39,107,29,15,16,23,13,18,2,111,260,45,12,46,156,381,38]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=void 0,e.$aM=E;let n=class{constructor(C,v,b,O,U){this.a=C,this.b=v,this.c=b,this.d=O,this.e=U}text(C,v,b={}){C=this.f(C,b);const O=this.a.getValue(),U=v&&v.some(j=>!this.a.getValue({resource:j}).search.useRipgrep);return{...this.h(v?.map(g.$Vi),b),type:o.QueryType.Text,contentPattern:C,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:O.search.usePCRE2||U||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}f(C,v){const b=this.a.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const O={...C,wordSeparators:b.editor.wordSeparators};return this.j(C,v)&&(O.isCaseSensitive=!0),this.k(C)&&(O.isMultiline=!0),v.notebookSearchConfig?.includeMarkupInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownInput=v.notebookSearchConfig.includeMarkupInput),v.notebookSearchConfig?.includeMarkupPreview&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookMarkdownPreview=v.notebookSearchConfig.includeMarkupPreview),v.notebookSearchConfig?.includeCodeInput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellInput=v.notebookSearchConfig.includeCodeInput),v.notebookSearchConfig?.includeOutput&&(O.notebookInfo||(O.notebookInfo={}),O.notebookInfo.isInNotebookCellOutput=v.notebookSearchConfig.includeOutput),O}file(C,v={}){return{...this.h(C,v),type:o.QueryType.File,filePattern:v.filePattern?v.filePattern.trim():v.filePattern,exists:v.exists,sortByScore:v.sortByScore,cacheKey:v.cacheKey,shouldGlobMatchFilePattern:v.shouldGlobSearch}}g(C,v){return C?(C=Array.isArray(C)?C.map(m):m(C),v?this.parseSearchPaths(C):{pattern:c(...Array.isArray(C)?C:[C])}):{}}h(C=[],v={}){const b=this.g(v.includePattern,v.expandPatterns),O=this.g(v.excludePattern,v.expandPatterns),U=C.length>1,z=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(N=>this.q(N,v,O)):C.map(N=>this.r(N,v,O,U))).filter(N=>!!N),j={_reason:v._reason,folderQueries:z,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:v.extraFileResources,excludePattern:O.pattern,includePattern:b.pattern,onlyOpenEditors:v.onlyOpenEditors,maxResults:v.maxResults};if(v.onlyOpenEditors){const N=r.$Hb(this.c.groups.flatMap(se=>se.editors.map(W=>W.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const F=N.filter(se=>(0,o.$RK)(j,se.fsPath)),X=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(X)),{...j,...X}}const M=v.extraFileResources&&v.extraFileResources.filter(N=>(0,o.$RK)(j,N.fsPath));return j.extraFileResources=M&&M.length?M:void 0,j}i(C){const v=[],b=new L.$Ac,O={};let U=!1;return C.forEach(z=>{if(z.scheme===R.Schemas.walkThrough)return;if((0,l.$fh)(z)){const M=this.b.getWorkspaceFolder(z)?.uri??z.with({path:p.$mc(z.fsPath)});let N=b.get(M);N||(U=!0,N={folder:M,includePattern:{}},v.push(N),b.set(M,N));const F=p.$lc(M.fsPath,z.fsPath);(0,D.$lg)(N.includePattern)[F.replace(/\\/g,"/")]=!0}else z.fsPath&&(U=!0,O[z.fsPath]=!0)}),{folderQueries:v,includePattern:O,usingSearchPaths:!0,excludePattern:U?void 0:{"**/*":!0}}}j(C,v){if(v.isSmartCase){if(C.isRegExp){if(I.$4f(C.pattern,!0))return!0}else if(I.$4f(C.pattern))return!0}return!!C.isCaseSensitive}k(C){return C.isMultiline||C.isRegExp&&(0,A.$3C)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const v=X=>p.$ic(X)||/^\.\.?([\/\\]|$)/.test(X),O=(Array.isArray(C)?C:h(C)).map(X=>{const se=this.e.resolvedUserHome;return se?(0,T.$Qw)(X,se.scheme===R.Schemas.file?se.fsPath:se.path):X}),U=u.$E(O,X=>v(X)?"searchPaths":"exprSegments"),z=(U.exprSegments||[]).map(X=>I.$jf(X,"/")).map(X=>I.$jf(X,"\\")).map(X=>(X[0]==="."&&(X="*"+X),s(X))),j={},M=this.m(U.searchPaths||[]);M&&M.length&&(j.searchPaths=M);const N=z.flat(),F=c(...N);return F&&(j.pattern=F),j}l(C,v){return v.disregardExcludeSettings?void 0:(0,o.$QK)(C,!v.disregardSearchExcludeSettings)}m(C){if(!C||!C.length)return[];const v=C.flatMap(O=>{let{pathPortion:U,globPortion:z}=t(O);return z&&(z=y(z)),this.n(U).flatMap(M=>this.o(M,z))}),b=new Map;return v.forEach(O=>{const U=O.searchPath.toString(),z=b.get(U);z?O.pattern&&(z.pattern=z.pattern||{},z.pattern[O.pattern]=!0):b.set(U,{searchPath:O.searchPath,pattern:O.pattern?c(O.pattern):void 0})}),Array.from(b.values())}n(C){if(p.$ic(C)){const v=this.b.getWorkspace().folders;return v[0]&&v[0].uri.scheme!==R.Schemas.file?[{searchPath:v[0].uri.with({path:C})}]:[{searchPath:f.URI.file(p.$hc(C))}]}if(this.b.getWorkbenchState()===g.WorkbenchState.FOLDER){const v=this.b.getWorkspace().folders[0].uri;if(C=m(C),C.startsWith("../")||C===".."){const O=p.$gc.resolve(v.path,C);return[{searchPath:v.with({path:O})}]}const b=y(C);return[{searchPath:v,pattern:b}]}else{if(C==="./"||C===".\\")return[];{const v=C.replace(/^\.[\/\\]/,""),O=this.b.getWorkspace().folders.map(U=>{const z=v.match(new RegExp(`^${I.$df(U.name)}(?:/(.*)|$)`));return z?{match:z,folder:U}:null}).filter(D.$ig);if(O.length)return O.map(U=>{const z=U.match[1];return{searchPath:U.folder.uri,pattern:z&&y(z)}});{const U=C.match(/\.[\/\\](.+)[\/\\]?/),z=U?U[1]:C,j=w.localize(0,null,z);throw new Error(j)}}}}o(C,v){const b=C.pattern&&v?`${C.pattern}/${v}`:C.pattern||v,O=[{searchPath:C.searchPath,pattern:b}];return b&&!b.endsWith("**")&&O.push({searchPath:C.searchPath,pattern:b+"/**"}),O}q(C,v,b){const O=this.r((0,g.$Vi)(C.searchPath),v,b,!1);return O?{...O,includePattern:C.pattern}:null}r(C,v,b,O){let U;const z=f.URI.isUri(C)?C:C.uri;if(b.searchPaths){const X=b.searchPaths.filter(se=>(0,l.$7g)(se.searchPath,z))[0];if(X&&!X.pattern)return null;X&&(U=X.pattern)}const j=this.a.getValue({resource:z}),N={...this.l(j,v)||{},...U||{}},F=f.URI.isUri(C)?(0,l.$$g)(C):C.name;return{folder:z,folderName:O?F:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:j.files&&j.files.encoding,disregardIgnoreFiles:typeof v.disregardIgnoreFiles=="boolean"?v.disregardIgnoreFiles:!j.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof v.disregardGlobalIgnoreFiles=="boolean"?v.disregardGlobalIgnoreFiles:!j.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof v.disregardParentIgnoreFiles=="boolean"?v.disregardParentIgnoreFiles:!j.search.useParentIgnoreFiles,ignoreSymlinks:typeof v.ignoreSymlinks=="boolean"?v.ignoreSymlinks:!j.search.followSymlinks}}};e.$_L=n,e.$_L=n=Ze([Ve(0,a.$7i),Ve(1,g.$Ji),Ve(2,$.$$D),Ve(3,d.$7j),Ve(4,i.$0L)],n);function t(k){const C=k.match(/[\*\{\}\(\)\[\]\?]/);if(C){const v=C.index,b=k.substr(0,v).match(/[/|\\][^/\\]*$/);if(b){let O=k.substr(0,b.index);return O.match(/[/\\]/)||(O+="/"),{pathPortion:O,globPortion:k.substr((b.index||0)+1)}}}return{pathPortion:k}}function c(...k){return k.length?k.reduce((C,v)=>(C[v]=!0,C),Object.create(null)):void 0}function h(k){return P.$sk(k,",").map(C=>C.trim()).filter(C=>!!C.length)}function s(k){return[`**/${k}/**`,`**/${k}`].map(v=>v.replace(/\*\*\/\*\*/g,"**"))}function m(k){return k.replace(/\\/g,"/")}function y(k){return m(k).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(k){return k.replace(/([?*[\]])/g,"[$1]")}function E(k,C){k=r.$Mb(k,O=>O.toString());const v=[],b=C.getWorkspace();return k&&k.forEach(O=>{let U;if(C.getWorkbenchState()===g.WorkbenchState.FOLDER)U=(0,l.$dh)(b.folders[0].uri,O),U&&U!=="."&&(U="./"+U);else{const z=C.getWorkspaceFolder(O);if(z){const j=z.name;if(b.folders.filter(N=>N.name===j).length===1){const N=(0,l.$dh)(z.uri,O);N===""?U=`./${z.name}`:U=`./${z.name}/${N}`}else U=O.fsPath}}U&&v.push(S(U))}),v}}),define(Ee[387],Se([1,0,23,2,21,14,5,386,38,46,7]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Twb=f,e.$Uwb=a;const D=7e3;function f(d,g){const $=g.activationEvents;if(!$)return Promise.resolve(void 0);const i=[],o=[];for(const m of $)if(/^workspaceContains:/.test(m)){const y=m.substr(18);y.indexOf("*")>=0||y.indexOf("?")>=0||d.forceUsingSearch?o.push(y):i.push(y)}if(i.length===0&&o.length===0)return Promise.resolve(void 0);const{promise:n,resolve:t}=(0,I.$th)(),c=m=>t({activationEvent:m}),h=Promise.all(i.map(m=>A(d,m,c))).then(()=>{}),s=w(d,g.identifier,o,c);return Promise.all([h,s]).then(()=>{t(void 0)}),n}async function A(d,g,$){for(const i of d.folders)if(await d.exists(r.$bh(u.URI.revive(i),g))){$(`workspaceContains:${g}`);return}}async function w(d,g,$,i){if($.length===0)return Promise.resolve(void 0);const o=new P.$se,n=d.checkExists(d.folders,$,o.token),t=setTimeout(async()=>{o.cancel(),d.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${$.join(",")}`)},D);let c=!1;try{c=await n}catch(h){T.$4(h)||T.$1(h)}o.dispose(),clearTimeout(t),c&&i(`workspaceContains:${$.join(",")}`)}function a(d,g,$,i){const o=d.get(L.$zi),n=d.get(p.$IK),c=o.createInstance(R.$_L).file(g.map(h=>(0,l.$Vi)(u.URI.revive(h))),{_reason:"checkExists",includePattern:$,exists:!0});return n.fileSearch(c,i).then(h=>!!h.limitHit,h=>T.$4(h)?!1:Promise.reject(h))}});var rt=this&&this.__classPrivateFieldSet||function(oe,e,r,u,P){if(u==="m")throw new TypeError("Private method is not writable");if(u==="a"&&!P)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!P:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return u==="a"?P.call(oe,r):P?P.value=r:e.set(oe,r),r},Ge=this&&this.__classPrivateFieldGet||function(oe,e,r,u){if(r==="a"&&!u)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!u:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return r==="m"?u:r==="a"?u.call(oe):u?u.value:e.get(oe)};define(Ee[53],Se([1,0,233,16,62,23,7,3,85,2,12,6,48,318,126,42,26,158,14,24,22,297,8,71,5,30,98,20,114,76,47,129,4,387,125,299,15,123,43,11,124]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n,t,c,h,s,m,y,S,E,k,C,v,b,O,U,z,j,M,N,F){"use strict";var X,se,W,H;Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=e.$Tnc=e.$Snc=e.$Rnc=e.$Qnc=void 0,e.$Qnc=(0,h.$Ai)("IHostUtils");let V=H=class extends R.$Uc{constructor(te,ee,ie,le,Z,ae,$e,be,Me,qe,De,Pe,Te){super(),this.Y=Pe,this.Z=Te,this.a=this.B(new v.$he),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=ee,this.g=ie,this.f=$e,this.j=le,this.m=Z,this.s=ae,this.t=Me,this.u=qe,this.w=De,this.y=this.g.getProxy(D.$vM.MainThreadWorkspace),this.z=this.g.getProxy(D.$vM.MainThreadTelemetry),this.C=this.g.getProxy(D.$vM.MainThreadExtensionService),this.D=new L.$zh,this.F=new L.$zh,this.G=new L.$zh,this.H=new L.$zh,this.I=new K(this.f.extensions.activationEvents),this.L=new g.$lbc(this.I,this.f.extensions.allExtensions);const B=new i.$Ym(this.f.extensions.myExtensions);this.J=new g.$lbc(this.I,pe(this.L,B)),N.$n&&(this.s.info(`Creating extension host with the following global extensions: ${ne(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ne(this.J)}`)),this.M=new w.$znc(this.g,this.s),this.N=new O.$Jnc(this.g),this.O=be,this.h=te.createChild(new S.$yi([w.$Anc,this.M],[O.$Knc,this.N])),this.P=this.B(new A.$ync(this.J,this.L,{onExtensionActivationError:(q,Y,_)=>{this.C.$onExtensionActivationError(q,$.$3(Y),_)},actualActivateExtension:async(q,Y)=>{if(g.$lbc.isHostExtension(q,this.J,this.L))return await this.C.$activateExtension(q,Y),new A.$xnc;const _=this.J.getExtensionDescription(q);return this.fb(_,Y)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(te){$.$1(te)}}async $(){this.O.onWillDeactivateAll();let te=[];try{te=this.J.getAllExtensionDescriptions().map(Z=>Z.identifier).filter(Z=>this.isActivated(Z)).map(Z=>this.eb(Z))}catch{}await Promise.all(te)}terminate(te,ee=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${te}`),this.s.flush(),this.u.dispose(),this.P.dispose(),$.setUnexpectedErrorHandler(le=>{this.s.error(le)}),this.g.dispose();const ie=this.$();Promise.race([(0,L.$Bh)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${ee}`):this.s.info(`Extension host exiting with code ${ee}`),this.s.flush(),this.s.dispose(),this.c.exit(ee)})}isActivated(te){return this.G.isOpen()?this.P.isActivated(te):!1}async getExtension(te){const ee=await this.C.$getExtension(te);return ee&&{...ee,identifier:new i.$Xm(ee.identifier.value),extensionLocation:l.URI.revive(ee.extensionLocation)}}ab(te,ee){return this.P.activateByEvent(te,ee)}bb(te,ee){return this.P.activateById(te,ee)}activateByIdWithErrors(te,ee){return this.bb(te,ee).then(()=>{const ie=this.P.getActivatedExtension(te);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(te=>this.J)}getExtensionExports(te){if(this.G.isOpen())return this.P.getActivatedExtension(te).exports;try{return this.P.getActivatedExtension(te).exports}catch{return null}}async cb(te){if(te.scheme===z.Schemas.file&&this.c.fsRealpath){const ee=te.fsPath;this.R.has(ee)||this.R.set(ee,this.c.fsRealpath(ee));const ie=await this.R.get(ee);return l.URI.file(ie)}return te}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(te=>new ce(te))),this.Q}async db(te){const ee=p.$Gi.forUris(ie=>T.$5g.ignorePathCasing(ie));return await Promise.all(te.map(async ie=>{if(this.wb(ie)){const le=await this.cb(ie.extensionLocation);ee.set(le,ie)}})),ee}eb(te){let ee=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(te))return ee;const ie=this.P.getActivatedExtension(te);if(!ie)return ee;try{typeof ie.module.deactivate=="function"&&(ee=Promise.resolve(ie.module.deactivate()).then(void 0,le=>(this.s.error(le),Promise.resolve(void 0))))}catch(le){this.s.error(`An error occurred when deactivating the extension '${te.value}':`),this.s.error(le)}try{(0,R.$Pc)(ie.subscriptions)}catch(le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${te.value}':`),this.s.error(le)}return ee}async fb(te,ee){return this.f.remote.isRemote?this.C.$onWillActivateExtension(te.identifier):await this.C.$onWillActivateExtension(te.identifier),this.hb(te,ee).then(ie=>{const le=ie.activationTimes;return this.C.$onDidActivateExtension(te.identifier,le.codeLoadingTime,le.activateCallTime,le.activateResolvedTime,ee),this.gb(te,ee,"success",le),ie},ie=>{throw this.gb(te,ee,"failure"),ie})}gb(te,ee,ie,le){const Z=he(te,ee);this.z.$publicLog2("extensionActivationTimes",{...Z,...le||{},outcome:ie})}hb(te,ee){const ie=he(te,ee);this.z.$publicLog2("activatePlugin",ie);const le=this.wb(te);if(!le)return Promise.resolve(new A.$wnc(A.$tnc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${te.identifier.value}, startup: ${ee.startup}, activationEvent: '${ee.activationEvent}'${te.identifier.value!==ee.extensionId.value?`, root cause: ${ee.extensionId.value}`:""}`),this.s.flush();const Z=new A.$unc(ee.startup);return Promise.all([this.xb(te,(0,T.$bh)(te.extensionLocation,le),Z),this.ib(te)]).then(ae=>(P.mark(`code/extHost/willActivateExtension/${te.identifier.value}`),H.jb(this.s,te.identifier,ae[0],ae[1],Z))).then(ae=>(P.mark(`code/extHost/didActivateExtension/${te.identifier.value}`),ae))}ib(te){const ee=this.Z.createLanguageModelAccessInformation(te),ie=new n.$Cnc(te,this.M),le=new n.$Bnc(te.identifier.value,!1,this.M),Z=new U.$Lnc(te,this.N),ae=te.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,$e=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${te.identifier.value}`),Promise.all([ie.whenReady,le.whenReady,this.O.whenReady]).then(()=>{const be=this;let Me,qe;const De=(0,d.$UG)(te,"ipc")?this.f.messagePorts?.get(i.$Xm.toKey(te.identifier)):void 0;return Object.freeze({globalState:ie,workspaceState:le,secrets:Z,subscriptions:[],get languageModelAccessInformation(){return ee},get extensionUri(){return te.extensionLocation},get extensionPath(){return te.extensionLocation.fsPath},asAbsolutePath(Pe){return u.$jc(te.extensionLocation.fsPath,Pe)},get storagePath(){return be.O.workspaceValue(te)?.fsPath},get globalStoragePath(){return be.O.globalValue(te).fsPath},get logPath(){return u.$jc(be.f.logsLocation.fsPath,te.identifier.value)},get logUri(){return l.URI.joinPath(be.f.logsLocation,te.identifier.value)},get storageUri(){return be.O.workspaceValue(te)},get globalStorageUri(){return be.O.globalValue(te)},get extensionMode(){return ae},get extension(){return Me===void 0&&(Me=new we(be,te.identifier,te,$e,!1)),Me},get extensionRuntime(){return(0,d.$VG)(te,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be.u.getEnvironmentVariableCollection(te)},get messagePassingProtocol(){if(!qe){if(!De)return;const Pe=v.Event.buffer(v.Event.fromDOMEventEmitter(De,"message",Te=>Te.data));De.start(),qe={onDidReceiveMessage:Pe,postMessage:De.postMessage.bind(De)}}return qe}})})}static jb(te,ee,ie,le,Z){return ie=ie||{activate:void 0,deactivate:void 0},this.kb(te,ee,ie,le,Z).then(ae=>new A.$vnc(!1,null,Z.build(),ie,ae,le.subscriptions))}static kb(te,ee,ie,le,Z){if(typeof ie.activate=="function")try{Z.activateCallStart(),te.trace(`ExtensionService#_callActivateOptional ${ee.value}`);const ae=typeof global=="object"?global:self,$e=ie.activate.apply(ae,[le]);return Z.activateCallStop(),Z.activateResolveStart(),Promise.resolve($e).then(be=>(Z.activateResolveStop(),be))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(ie)}lb(te,ee){this.bb(te.identifier,{startup:!1,extensionId:te.identifier,activationEvent:ee}).then(void 0,ie=>{this.s.error(ie)})}mb(te,ee=0){const le=Date.now();(0,N.$v)(()=>{for(let Z=ee;Z<te.length;Z+=1){const ae=te[Z];for(const $e of ae.activationEvents??[])if($e==="onStartupFinished")if(Date.now()-le>50){this.mb(te,Z);break}else this.lb(ae,$e)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(te=>{const ee=te.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(ee)this.mb(ie);else for(const le of ie)if(le.activationEvents)for(const Z of le.activationEvents)Z==="onStartupFinished"&&this.lb(le,Z)})}ob(){const te=this.ab("*",!0).then(void 0,ae=>{this.s.error(ae)});this.B(this.j.onDidChangeWorkspace(ae=>this.pb(ae.added)));const ee=this.j.workspace?this.j.workspace.folders:[],ie=this.pb(ee),le=this.rb(),Z=Promise.all([le,te,ie]).then(()=>{});return Promise.race([Z,(0,L.$Bh)(1e4)]).then(()=>{this.nb()}),Z}pb(te){return te.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(ee=>this.qb(te,ee))).then(()=>{})}async qb(te,ee){if(this.isActivated(ee.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,le={logService:this.s,folders:te.map(ae=>ae.uri),forceUsingSearch:ie||!this.c.fsExists,exists:ae=>this.c.fsExists(ae.fsPath),checkExists:(ae,$e,be)=>this.y.$checkExists(ae,$e,be)},Z=await(0,b.$Twb)(le,ee);if(Z)return this.bb(ee.identifier,{startup:!0,extensionId:ee.identifier,activationEvent:Z.activationEvent}).then(void 0,ae=>this.s.error(ae))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(te){throw console.error(te),te}}async sb(){const{extensionDevelopmentLocationURI:te,extensionTestsLocationURI:ee}=this.f.environment;if(!te||!ee)throw new Error(r.localize(0,null));const ie=await this.xb(null,ee,new A.$unc(!1));if(!ie||typeof ie.run!="function")throw new Error(r.localize(1,null,ee.toString()));return new Promise((le,Z)=>{const ae=(Me,qe)=>{Me?(N.$n&&this.s.error("Test runner called back with error",Me),Z(Me)):(N.$n&&(qe?this.s.info(`Test runner called back with ${qe} failures.`):this.s.info("Test runner called back with successful outcome.")),le(typeof qe=="number"&&qe>0?1:0))},$e=(0,T.$2g)(ee),be=ie.run($e,ae);be&&be.then&&be.then(()=>{N.$n&&this.s.info("Test runner finished successfully."),le(0)}).catch(Me=>{N.$n&&this.s.error("Test runner finished with error",Me),Z(Me instanceof Error&&Me.stack?Me.stack:String(Me))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$Bh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(te,ee){return this.S[te]=ee,(0,R.$Sc)(()=>{delete this.S[te]})}async getRemoteExecServer(te){const{resolver:ee}=await this.ub(te);return ee?.resolveExecServer?.(te,{resolveAttempt:0})}async ub(te){const ee=te.indexOf("+");if(ee===-1)throw new t.$DM("Not an authority that can be resolved!",c.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=te.substr(0,ee);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.S[ie]}}async $resolveAuthority(te,ee){const ie=M.$be.create(!1),le=()=>`[resolveAuthority(${(0,c.$Pl)(te)},${ee})][${ie.elapsed()}ms] `,Z=fe=>this.s.info(`${le()}${fe}`),ae=fe=>this.s.warn(`${le()}${fe}`),$e=(fe,ve=void 0)=>this.s.error(`${le()}${fe}`,ve),be=fe=>{if(fe instanceof t.$DM)return{type:"error",error:{code:fe._code,message:fe._message,detail:fe._detail}};throw fe},Me=async fe=>{Z(`activating resolver for ${fe}...`);const{resolver:ve,authorityPrefix:Ne}=await this.ub(fe);if(!ve)throw $e(`no resolver for ${Ne}`),new t.$DM(`No remote extension installed to resolve ${Ne}.`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:ve,authorityPrefix:Ne,remoteAuthority:fe}},qe=te.split(/@|%40/g).reverse();Z(`activating remote resolvers ${qe.join(" -> ")}`);let De;try{De=await Promise.all(qe.map(Me)).catch(async fe=>{if(!(fe instanceof t.$DM)||fe._code!==c.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw fe;return ae(`resolving nested authorities failed: ${fe.message}`),[await Me(te)]})}catch(fe){return be(fe)}const Pe=new L.$Lh;Pe.cancelAndSet(()=>Z("waiting..."),1e3);let Te,B;for(const[fe,{authorityPrefix:ve,resolver:Ne,remoteAuthority:Be}]of De.entries())try{if(fe===De.length-1)Z("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${ve}`),Te=await Ne.resolve(Be,{resolveAttempt:ee,execServer:B}),P.mark(`code/extHost/didResolveAuthorityOK/${ve}`),Z("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Ne,t.$CM.isManagedResolvedAuthority(Te)?Te:void 0));else{if(Z(`invoking resolveExecServer() for ${Be}`),P.mark(`code/extHost/willResolveExecServer/${ve}`),B=await Ne.resolveExecServer?.(Be,{resolveAttempt:ee,execServer:B}),!B)throw new t.$DM(`Exec server was not available for ${Be}`,c.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${ve}`)}}catch(Qe){return P.mark(`code/extHost/didResolveAuthorityError/${ve}`),$e("returned an error",Qe),Pe.dispose(),be(Qe)}Pe.dispose();const q={environmentTunnels:Te.environmentTunnels,features:Te.tunnelFeatures?{elevation:Te.tunnelFeatures.elevation,privacyOptions:Te.tunnelFeatures.privacyOptions,protocol:Te.tunnelFeatures.protocol===void 0?!0:Te.tunnelFeatures.protocol}:void 0},Y={extensionHostEnv:Te.extensionHostEnv,isTrusted:Te.isTrusted,authenticationSession:Te.authenticationSessionForInitializingExtensions?{id:Te.authenticationSessionForInitializingExtensions.id,providerId:Te.authenticationSessionForInitializingExtensions.providerId}:void 0};Z(`returned ${t.$CM.isManagedResolvedAuthority(Te)?"managed authority":`${Te.host}:${Te.port}`}`);let _;if(t.$CM.isManagedResolvedAuthority(Te)){const fe=ee;this.Y.setFactory(fe,Te.makeConnection),_={authority:te,connectTo:new c.$Ml(fe),connectionToken:Te.connectionToken}}else _={authority:te,connectTo:new c.$Nl(Te.host,Te.port),connectionToken:Te.connectionToken};return{type:"ok",value:{authority:_,options:Y,tunnelInformation:q}}}async $getCanonicalURI(te,ee){this.s.info(`$getCanonicalURI invoked for authority (${(0,c.$Pl)(te)})`);const{resolver:ie}=await this.ub(te);if(!ie)return null;const le=l.URI.revive(ee);if(typeof ie.getCanonicalURI>"u")return le;const Z=await(0,L.$sh)(()=>ie.getCanonicalURI(le));return Z||le}async $startExtensionHost(te){te.toAdd.forEach(ae=>ae.extensionLocation=l.URI.revive(ae.extensionLocation));const{globalRegistry:ee,myExtensions:ie}=x(this.I,this.L,this.J,te),le=await this.db(ie);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(ee.getAllExtensionDescriptions()),this.J.set(ie),N.$n&&(this.s.info(`$startExtensionHost: global extensions: ${ne(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ne(this.J)}`)),this.tb()}$activateByEvent(te,ee){return ee===d.ActivationKind.Immediate?this.D.wait().then(ie=>this.ab(te,!1)):this.G.wait().then(ie=>this.ab(te,!1))}async $activate(te,ee){return await this.G.wait(),this.J.getExtensionDescription(te)?(await this.bb(te,ee),!0):!1}async $deltaExtensions(te){te.toAdd.forEach(ae=>ae.extensionLocation=l.URI.revive(ae.extensionLocation));const{globalRegistry:ee,myExtensions:ie}=x(this.I,this.L,this.J,te),le=await this.db(ie);return(await this.getExtensionPathIndex()).setSearchTree(le),this.L.set(ee.getAllExtensionDescriptions()),this.J.set(ie),N.$n&&(this.s.info(`$deltaExtensions: global extensions: ${ne(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ne(this.J)}`)),Promise.resolve(void 0)}async $test_latency(te){return te}async $test_up(te){return te.byteLength}async $test_down(te){const ee=o.$Je.alloc(te),ie=Math.random()%256;for(let le=0;le<te;le++)ee.writeUInt8(ie,le);return ee}async $updateRemoteConnectionData(te){this.X=te,this.a.fire()}};e.$Rnc=V,e.$Rnc=V=H=Ze([Ve(0,h.$zi),Ve(1,e.$Qnc),Ve(2,y.$ZO),Ve(3,a.$cnc),Ve(4,f.$fnc),Ve(5,I.$7j),Ve(6,s.$dP),Ve(7,m.$inc),Ve(8,E.$wEb),Ve(9,k.$Dnc),Ve(10,j.$Nnc),Ve(11,F.$Onc),Ve(12,C.$Hnc)],V);function x(de,te,ee,ie){de.addActivationEvents(ie.addActivationEvents);const le=new g.$lbc(de,te.getAllExtensionDescriptions());le.deltaExtensions(ie.toAdd,ie.toRemove);const Z=new i.$Ym(ee.getAllExtensionDescriptions().map($e=>$e.identifier));for(const $e of ie.myToRemove)Z.delete($e);for(const $e of ie.myToAdd)Z.add($e);const ae=pe(le,Z);return{globalRegistry:le,myExtensions:ae}}function he(de,te){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:te.activationEvent,reasonId:te.extensionId.value}}function ne(de){return de.getAllExtensionDescriptions().map(te=>te.identifier.value).join(",")}e.$Snc=(0,h.$Ai)("IExtHostExtensionService");class we{constructor(te,ee,ie,le,Z){X.set(this,void 0),se.set(this,void 0),W.set(this,void 0),rt(this,X,te,"f"),rt(this,se,ee,"f"),rt(this,W,ie.identifier,"f"),this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=u.$hc((0,T.$2g)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=le,this.isFromDifferentExtensionHost=Z}get isActive(){return Ge(this,X,"f").isActivated(Ge(this,W,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ge(this,X,"f").getExtensionExports(Ge(this,W,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ge(this,X,"f").activateByIdWithErrors(Ge(this,W,"f"),{startup:!1,extensionId:Ge(this,se,"f"),activationEvent:"api"}),this.exports}}e.$Tnc=we,X=new WeakMap,se=new WeakMap,W=new WeakMap;function pe(de,te){return de.getAllExtensionDescriptions().filter(ee=>te.has(ee.identifier))}class ce{constructor(te){this.a=te}setSearchTree(te){this.a=te}findSubstr(te){return this.a.findSubstr(te)}forEach(te){return this.a.forEach(te)}}e.$Unc=ce;class K{constructor(te){this.a=new i.$Zm,this.addActivationEvents(te)}readActivationEvents(te){return this.a.get(te.identifier)??[]}addActivationEvents(te){for(const ee of Object.keys(te))this.a.set(ee,te[ee])}}}),define(Ee[388],Se([1,0,62,2,6,48,26,24,20,30,5,53,12,13]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=void 0;let a=class{constructor(o,n,t,c,h,s,m){this.c=o,this.d=n,this.f=t,this.g=c,this.h=h,this.i=s,this.j=m,this.a=new Map,this.b=[]}async install(){this.k(),r.mark("code/extHost/willWaitForConfig");const o=await this.g.getConfigProvider();r.mark("code/extHost/didWaitForConfig");const n=await this.h.getExtensionPathIndex();this.register(new g(this.c,n,this.d,o,this.j)),this.register(this.f.createInstance(d)),this.i.remote.isRemote&&this.register(this.f.createInstance($,n,this.i.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const n of o.nodeModuleName)this.a.set(n,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(n=>o.alternativeModuleName(n))}};e.$4oc=a,e.$4oc=a=Ze([Ve(2,I.$zi),Ve(3,T.$fnc),Ve(4,D.$Snc),Ve(5,l.$dP),Ve(6,f.$7j)],a);let d=w=class{constructor(o){if(o.environment.appRoot&&w.a.size){const n=(0,A.$df)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",c=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${n}/${h}\\/)(${c})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const n=this.b.exec(this.c(o));if(!n)return;const[,t,c,h]=n,s=w.a.get(c);if(s!==void 0)return console.warn(`${c} as been renamed to ${s}, please update your imports`),t+s+h}c(o){return o.replace(/\\/g,"/")}};d.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=w=Ze([Ve(0,l.$dP)],d);class g{constructor(o,n,t,c,h){this.c=o,this.d=n,this.e=t,this.f=c,this.g=h,this.nodeModuleName="vscode",this.a=new R.$Zm}load(o,n){const t=this.d.findSubstr(n);if(t){let c=this.a.get(t.identifier);return c||(c=this.c(t,this.e,this.f),this.a.set(t.identifier,c)),c}if(!this.b){let c="";this.d.forEach((h,s)=>c+=`	${s} -> ${h.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${c}`),this.b=this.c(L.$PG,this.e,this.f)}return this.b}}let $=class{constructor(o,n,t){this.e=o,this.f=n,this.nodeModuleName=["open","opn"],this.d=t.getProxy(P.$vM.MainThreadTelemetry);const c=t.getProxy(P.$vM.MainThreadWindow);this.c=(h,s)=>{const m=u.URI.parse(h);return s?this.g(h,s):m.scheme==="http"||m.scheme==="https"?c.$openUri(m,h,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?c.$openUri(m,h,{}):this.g(h,s)}}load(o,n,t){const c=this.e.findSubstr(n);return c&&(this.a=c.identifier.value,this.h()),this.b=t(o),this.c}g(o,n){return this.i(),this.b(o,n)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};$=Ze([Ve(2,p.$ZO)],$)}),define(Ee[64],Se([1,0,49,3,16,54,5,78,77,53,8,42,315,48]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=e.$Vnc=void 0,e.$Vnc=(0,L.$Ai)("IExtHostVariableResolverProvider");class w extends f.$4P{constructor(g,$,i,o,n,t,c){function h(){if(i){const s=i.activeEditor();if(s)return s.document.uri;const m=o.tabGroups.all.find(y=>y.isActive)?.activeTab;if(m!==void 0){if(m.input instanceof I.$jO||m.input instanceof I.$oO)return m.input.modified;if(m.input instanceof I.$iO||m.input instanceof I.$nO||m.input instanceof I.$lO)return m.input.uri}}}super({getFolderUri:s=>{const m=t.folders.filter(y=>y.name===s);if(m&&m.length>0)return m[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(s,m)=>n.getConfiguration(void 0,s).get(m),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=h();if(s)return P.$hc(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if($){const s=h();if(s){const m=$.getWorkspaceFolder(s);if(m)return P.$hc(m.uri.fsPath)}}},getSelectedText:()=>{if(i){const s=i.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(i){const s=i.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>g.getExtension(s)},void 0,c?Promise.resolve(c):void 0,Promise.resolve(T.env))}}let a=class extends u.$Uc{constructor(g,$,i,o,n){super(),this.b=g,this.c=$,this.g=i,this.h=o,this.j=n,this.a=new r.$V(async()=>{const t=await this.h.getConfigProvider(),h={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async s=>{h.folders=await this.c.getWorkspaceFolders2()||[]})),new w(this.b,this.c,this.g,this.j,t,h,this.m())})}getResolver(){return this.a.value}m(){}};e.$Wnc=a,e.$Wnc=a=Ze([Ve(0,l.$Snc),Ve(1,D.$cnc),Ve(2,R.$$O),Ve(3,A.$fnc),Ve(4,p.$rnc)],a)}),define(Ee[101],Se([1,0,7,4,2,24,5,6,77,53,20,8,42,153,120,306,48,64,3,50,37,17,19]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=e.$1nc=e.$Znc=e.$Ync=e.$Xnc=void 0,e.$Xnc=(0,L.$Ai)("IExtHostDebugService");let c=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(k,C,v,b,O,U,z){this.N=C,this.O=v,this.P=b,this.Q=O,this.R=U,this.S=z,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new u.$he,this.o=new u.$he,this.q=new u.$he,this.w=new u.$he,this.l=k.getProxy(R.$vM.MainThreadDebugService),this.A=new u.$he,this.C=new u.$he,this.y=new s(this.l),this.z=new Map,this.O.getExtensionRegistry().then(j=>{j.onDidChange(M=>{this.V(j)}),this.V(j)})}async $getVisualizerTreeItem(k,C){const v=this.W(C);if(!v)return;const b=await this.H.get(k)?.getTreeItem?.(v);return b?this.U(k,b):void 0}registerDebugVisualizationTree(k,C,v){const b=T.$Xm.toKey(k.identifier),O=this.jb(b,C);if(this.G.has(O))throw new Error(`A debug visualization provider with id '${C}' is already registered`);return this.H.set(O,v),this.l.$registerDebugVisualizerTree(O,!!v.editItem),(0,$.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(O),this.H.delete(C)})}async $getVisualizerTreeItemChildren(k,C){const v=this.J.get(C)?.item;return v?(await this.H.get(k)?.getChildren?.(v))?.map(O=>this.U(k,O))||[]:[]}async $editVisualizerTreeItem(k,C){const v=this.J.get(k);if(!v)return;const b=await this.H.get(v.provider)?.editItem?.(v.item,C);return this.U(v.provider,b||v.item)}$disposeVisualizedTree(k){const C=this.J.get(k);if(!C)return;const v=[C.children];for(const b of v)if(b)for(const O of b)v.push(this.J.get(O)?.children),this.J.delete(O)}U(k,C){let v=this.I.get(C);return v||(v=this.F++,this.I.set(C,v),this.J.set(v,{provider:k,item:C})),n.DebugTreeItem.from(C,v)}asDebugSourceUri(k,C){const v=k;if(typeof v.sourceReference=="number"&&v.sourceReference>0){let b=`debug:${encodeURIComponent(v.path||"")}`,O="?";return C&&(b+=`${O}session=${encodeURIComponent(C.id)}`,O="&"),b+=`${O}ref=${v.sourceReference}`,P.URI.parse(b)}else{if(v.path)return P.URI.file(v.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(k){const C=[];for(const v of k.getAllExtensionDescriptions())if(v.contributes){const b=v.contributes.debuggers;if(b&&b.length>0)for(const O of b)(0,a.$LH)(O)&&C.push(O.type)}this.l.$registerDebugTypes(C)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const k=[];return this.z.forEach(C=>k.push(C)),k}async $resolveDebugVisualizer(k,C){const v=this.L.get(k);if(!v)throw new Error(`No debug visualizer found with id '${k}'`);let{v:b,provider:O,extensionId:U}=v;if(b.visualization||(b=await O.resolveDebugVisualization?.(b,C)||b,v.v=b),!b.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${O}'`);return this.kb(U,b.visualization)}async $executeDebugVisualizerCommand(k){const C=this.L.get(k);if(!C)throw new Error(`No debug visualizer found with id '${k}'`);const v=C.v.visualization;v&&"command"in v&&this.S.executeCommand(v.command,...v.arguments||[])}W(k){const C=this.m.get(k.sessionId);return C&&{session:C.api,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId}}async $provideDebugVisualizers(k,C,v,b){const O=this.W(v),U=this.jb(k,C),z=this.G.get(U);if(!O||!z)return[];const j=await z.provideDebugVisualization(O,b);return j?j.map(M=>{const N=++this.M;this.L.set(N,{v:M,provider:z,extensionId:k});const F=M.iconPath?this.lb(M.iconPath):void 0;return{id:N,name:M.name,iconClass:F?.iconClass,iconPath:F?.iconPath,visualization:this.kb(k,M.visualization)}}):[]}$disposeDebugVisualizers(k){for(const C of k)this.L.delete(C)}registerDebugVisualizationProvider(k,C,v){if(!k.contributes?.debugVisualizers?.some(U=>U.id===C))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${C})`);const b=T.$Xm.toKey(k.identifier),O=this.jb(b,C);if(this.G.has(O))throw new Error(`A debug visualization provider with id '${C}' is already registered`);return this.G.set(O,v),this.l.$registerDebugVisualizer(b,C),(0,$.$Sc)(()=>{this.l.$unregisterDebugVisualizer(b,C),this.G.delete(C)})}addBreakpoints(k){const C=k.filter(O=>{const U=O.id;return this.z.has(U)?!1:(this.z.set(U,O),!0)});this.gb(C,[],[]);const v=[],b=new Map;for(const O of C)if(O instanceof D.$zN){let U=b.get(O.location.uri.toString());U||(U={type:"sourceMulti",uri:O.location.uri,lines:[]},b.set(O.location.uri.toString(),U),v.push(U)),U.lines.push({id:O.id,enabled:O.enabled,condition:O.condition,hitCondition:O.hitCondition,logMessage:O.logMessage,line:O.location.range.start.line,character:O.location.range.start.character,mode:O.mode})}else O instanceof D.$AN&&v.push({type:"function",id:O.id,enabled:O.enabled,hitCondition:O.hitCondition,logMessage:O.logMessage,condition:O.condition,functionName:O.functionName,mode:O.mode});return this.l.$registerBreakpoints(v)}removeBreakpoints(k){const C=k.filter(U=>this.z.delete(U.id));this.gb([],C,[]);const v=C.filter(U=>U instanceof D.$zN).map(U=>U.id),b=C.filter(U=>U instanceof D.$AN).map(U=>U.id),O=C.filter(U=>U instanceof D.$BN).map(U=>U.id);return this.l.$unregisterBreakpoints(v,b,O)}startDebugging(k,C,v){return this.l.$startDebugging(k?k.uri:void 0,C,{parentSessionID:v.parentSession?v.parentSession.id:void 0,lifecycleManagedByParent:v.lifecycleManagedByParent,repl:v.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:v.noDebug,compact:v.compact,suppressSaveBeforeStart:v.suppressSaveBeforeStart,suppressDebugStatusbar:v.suppressDebugStatusbar??v.debugUI?.simple,suppressDebugToolbar:v.suppressDebugToolbar??v.debugUI?.simple,suppressDebugView:v.suppressDebugView??v.debugUI?.simple})}stopDebugging(k){return this.l.$stopDebugging(k?k.id:void 0)}registerDebugConfigurationProvider(k,C,v){if(!C)return new D.$xM(()=>{});const b=this.d++;return this.f.push({type:k,handle:b,provider:C}),this.l.$registerDebugConfigurationProvider(k,v,!!C.provideDebugConfigurations,!!C.resolveDebugConfiguration,!!C.resolveDebugConfigurationWithSubstitutedVariables,b),new D.$xM(()=>{this.f=this.f.filter(O=>O.provider!==C),this.l.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(k,C,v){if(!v)return new D.$xM(()=>{});if(!this.cb(k,C))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${C}' debugger.`);if(this.$(C))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:C,handle:b,factory:v}),this.l.$registerDebugAdapterDescriptorFactory(C,b),new D.$xM(()=>{this.h=this.h.filter(O=>O.factory!==v),this.l.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(k,C){if(!C)return new D.$xM(()=>{});const v=this.j++;return this.k.push({type:k,handle:v,factory:C}),new D.$xM(()=>{this.k=this.k.filter(b=>b.factory!==C)})}async $runInTerminal(k,C){return Promise.resolve(void 0)}async $substituteVariables(k,C){let v;const b=await this.ib(k);return b&&(v={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(v,C)}X(k,C){if(k.type==="implementation")return new y(k.implementation)}Y(){}async $startDASession(k,C){const v=this,b=await this.hb(C);return this.eb(this.$(b.type),b).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const U=this.Z(O),z=this.X(U,b);if(!z)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const j=z;return this.D.set(k,j),this.db(b).then(M=>(M&&this.E.set(k,M),j.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const F=N,X={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const se=await this.K.sign(F.arguments.value);X.body={signature:se},j.sendResponse(X)}else throw new Error("no signer")}catch(se){X.success=!1,X.message=se.message,j.sendResponse(X)}}else M&&M.onDidSendMessage&&M.onDidSendMessage(N),N=(0,a.$QH)(N,!0),v.l.$acceptDAMessage(k,N)}),j.onError(N=>{M&&M.onError&&M.onError(N),this.l.$acceptDAError(k,N.name,N.message,N.stack)}),j.onExit(N=>{M&&M.onExit&&M.onExit(N??void 0,void 0),this.l.$acceptDAExit(k,N??void 0,void 0)}),M&&M.onWillStartSession&&M.onWillStartSession(),j.startSession()))})}$sendDAMessage(k,C){C=(0,a.$PH)(C,!1);const v=this.E.get(k);v&&v.onWillReceiveMessage&&v.onWillReceiveMessage(C),this.D.get(k)?.sendMessage(C)}$stopDASession(k){const C=this.E.get(k);this.E.delete(k),C&&C.onWillStopSession&&C.onWillStopSession();const v=this.D.get(k);return this.D.delete(k),v?v.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(k){const C=[],v=[],b=[];if(k.added)for(const O of k.added){const U=O.id;if(U&&!this.z.has(U)){let z;if(O.type==="function")z=new D.$AN(O.functionName,O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode);else if(O.type==="data")z=new D.$BN(O.label,O.dataId,O.canPersist,O.enabled,O.hitCondition,O.condition,O.logMessage,O.mode);else{const j=P.URI.revive(O.uri);z=new D.$zN(new D.$JM(j,new D.$yM(O.line,O.character)),O.enabled,O.condition,O.hitCondition,O.logMessage,O.mode)}(0,D.$xN)(z,U),this.z.set(U,z),C.push(z)}}if(k.removed)for(const O of k.removed){const U=this.z.get(O);U&&(this.z.delete(O),v.push(U))}if(k.changed){for(const O of k.changed)if(O.id){const U=this.z.get(O.id);if(U){if(U instanceof D.$AN&&O.type==="function"){const z=U;z.enabled=O.enabled,z.condition=O.condition,z.hitCondition=O.hitCondition,z.logMessage=O.logMessage,z.functionName=O.functionName}else if(U instanceof D.$zN&&O.type==="source"){const z=U;z.enabled=O.enabled,z.condition=O.condition,z.hitCondition=O.hitCondition,z.logMessage=O.logMessage,z.location=new D.$JM(P.URI.revive(O.uri),new D.$yM(O.line,O.character))}b.push(U)}}}this.gb(C,v,b)}async $acceptStackFrameFocus(k){let C;if(k){const v=await this.hb(k.sessionId);k.kind==="thread"?C=new D.$HN(v.api,k.threadId):C=new D.$GN(v.api,k.threadId,k.frameId)}this.B=C,this.C.fire(this.B)}$provideDebugConfigurations(k,C,v){return(0,r.$sh)(async()=>{const b=this.bb(k);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const O=await this.ib(C);return b.provideDebugConfigurations(O,v)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(k,C,v,b){return(0,r.$sh)(async()=>{const O=this.bb(k);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const U=await this.ib(C);return O.resolveDebugConfiguration(U,v,b)})}$resolveDebugConfigurationWithSubstitutedVariables(k,C,v,b){return(0,r.$sh)(async()=>{const O=this.bb(k);if(!O)throw new Error("no DebugConfigurationProvider found");if(!O.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const U=await this.ib(C);return O.resolveDebugConfigurationWithSubstitutedVariables(U,v,b)})}async $provideDebugAdapter(k,C){const v=this.ab(k);if(!v)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.hb(C);return this.eb(v,b).then(O=>{if(!O)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.Z(O)})}async $acceptDebugSessionStarted(k){const C=await this.hb(k);this.n.fire(C.api)}async $acceptDebugSessionTerminated(k){const C=await this.hb(k);C&&(this.o.fire(C.api),this.m.delete(C.id))}async $acceptDebugSessionActiveChanged(k){this.u=k?await this.hb(k):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(k,C){(await this.hb(k))?._acceptNameChanged(C)}async $acceptDebugSessionCustomEvent(k,C){const b={session:(await this.hb(k)).api,event:C.event,body:C.body};this.w.fire(b)}Z(k){if(k instanceof D.$CN)return{type:"executable",command:k.command,args:k.args,options:k.options};if(k instanceof D.$DN)return{type:"server",port:k.port,host:k.host};if(k instanceof D.$EN)return{type:"pipeServer",path:k.path};if(k instanceof D.$FN)return{type:"implementation",implementation:k.implementation};throw new Error("convertToDto unexpected type")}$(k){const C=this.h.filter(v=>v.type===k);if(C.length>0)return C[0].factory}ab(k){const C=this.h.filter(v=>v.handle===k);if(C.length>0)return C[0].factory}bb(k){const C=this.f.filter(v=>v.handle===k);if(C.length>0)return C[0].provider}cb(k,C){if(k.contributes){const v=k.contributes.debuggers;if(v&&v.length>0){for(const b of v)if(b.label&&b.type&&b.type===C)return!0}}return!1}db(k){const v=k.configuration.type,b=this.k.filter(O=>O.type===v||O.type==="*").map(O=>(0,r.$sh)(()=>O.factory.createDebugAdapterTracker(k.api)).then(U=>U,U=>null));return Promise.race([Promise.all(b).then(O=>{const U=(0,t.$Hb)(O);if(U.length>0)return new m(U)}),new Promise(O=>setTimeout(()=>O(void 0),1e3))]).catch(O=>{})}async eb(k,C){const v=C.configuration.debugServer;if(typeof v=="number")return Promise.resolve(new D.$DN(v));if(k){const O=await this.O.getExtensionRegistry();return(0,r.$sh)(()=>k.createDebugAdapterDescriptor(C.api,this.fb(C,O))).then(U=>{if(U)return U})}const b=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(C,b))}fb(k,C){}gb(k,C,v){(k.length>0||C.length>0||v.length>0)&&this.A.fire(Object.freeze({added:k,removed:C,changed:v}))}async hb(k){if(k)if(typeof k=="string"){const C=this.m.get(k);if(C)return C}else{let C=this.m.get(k.id);if(!C){const v=await this.ib(k.folderUri),b=k.parent?this.m.get(k.parent):void 0;C=new h(this.l,k.id,k.type,k.name,v,k.configuration,b?.api),this.m.set(C.id,C),this.l.$sessionCached(C.id)}return C}throw new Error("cannot find session")}ib(k){if(k){const C=P.URI.revive(k);return this.N.resolveWorkspaceFolder(C)}return Promise.resolve(void 0)}jb(k,C){return`${k}\0${C}`}kb(k,C){if(C){if("title"in C&&"command"in C)return{type:w.DebugVisualizationType.Command};if("treeId"in C)return{type:w.DebugVisualizationType.Tree,id:`${k}\0${C.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(k){const C=this.mb(k);let v,b;return"id"in C?b=i.ThemeIcon.asClassName(C):v=C,{iconPath:v,iconClass:b}}mb(k){if(k instanceof D.$uN)return{id:k.id};const C=typeof k=="object"&&"dark"in k?k.dark:k,v=typeof k=="object"&&"light"in k?k.light:k;return{dark:typeof C=="string"?P.URI.file(C):C,light:typeof v=="string"?P.URI.file(v):v}}};e.$Ync=c,e.$Ync=c=Ze([Ve(0,I.$ZO),Ve(1,f.$cnc),Ve(2,l.$Snc),Ve(3,d.$fnc),Ve(4,p.$rnc),Ve(5,g.$Vnc),Ve(6,o.$jP)],c);class h{constructor(k,C,v,b,O,U,z){this.f=k,this.g=C,this.h=v,this.j=b,this.k=O,this.l=U,this.m=z}get api(){const k=this;return this.d??(this.d=Object.freeze({id:k.g,type:k.h,get name(){return k.j},set name(C){k.j=C,k.f.$setDebugSessionName(k.g,C)},parentSession:k.m,workspaceFolder:k.k,configuration:k.l,customRequest(C,v){return k.f.$customDebugAdapterRequest(k.g,C,v)},getDebugProtocolBreakpoint(C){return k.f.$getDebugProtocolBreakpoint(k.g,C.id)}}))}get id(){return this.g}get type(){return this.h}_acceptNameChanged(k){this.j=k}get configuration(){return this.l}}e.$Znc=h;class s{constructor(k){this.value=Object.freeze({append(C){k.$appendDebugConsole(C)},appendLine(C){this.append(C+`
`)}})}}e.$1nc=s;class m{constructor(k){this.d=k}onWillStartSession(){this.d.forEach(k=>k.onWillStartSession?k.onWillStartSession():void 0)}onWillReceiveMessage(k){this.d.forEach(C=>C.onWillReceiveMessage?C.onWillReceiveMessage(k):void 0)}onDidSendMessage(k){this.d.forEach(C=>C.onDidSendMessage?C.onDidSendMessage(k):void 0)}onWillStopSession(){this.d.forEach(k=>k.onWillStopSession?k.onWillStopSession():void 0)}onError(k){this.d.forEach(C=>C.onError?C.onError(k):void 0)}onExit(k,C){this.d.forEach(v=>v.onExit?v.onExit(k,C):void 0)}}class y extends A.$osb{constructor(k){super(),this.h=k,k.onDidSendMessage(C=>{this.acceptMessage(C)})}startSession(){return Promise.resolve(void 0)}sendMessage(k){this.h.handleMessage(k)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let S=class extends c{constructor(k,C,v,b,O,U,z){super(k,C,v,b,O,U,z)}};e.$2nc=S,e.$2nc=S=Ze([Ve(0,I.$ZO),Ve(1,f.$cnc),Ve(2,l.$Snc),Ve(3,d.$fnc),Ve(4,p.$rnc),Ve(5,g.$Vnc),Ve(6,o.$jP)],S)}),define(Ee[389],Se([1,0,14,62,2,6,337,12,89,114,30,274,20,72,53,95]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=e.$5oc=void 0;class d{static async installEarlyHandler(i){Error.stackTraceLimit=100;const o=i.get(R.$7j),t=i.get(f.$ZO).getProxy(T.$vM.MainThreadErrors);r.setUnexpectedErrorHandler(c=>{o.error(c);const h=r.$3(c);t.$onUnexpectedError(h)})}static async installFullHandler(i){const o=i.get(R.$7j),n=i.get(f.$ZO),t=i.get(w.$Snc),c=i.get(a.$hP),h=n.getProxy(T.$vM.MainThreadExtensionService),s=n.getProxy(T.$vM.MainThreadErrors),m=await t.getExtensionPathIndex(),y=new WeakMap;function S(C,v){if(y.has(C))return y.get(C).stack;let b="",O,U;for(const j of v)b+=`
	at ${j.toString()}`,U=j.getFileName(),!O&&U&&(O=m.findSubstr(P.URI.file(U)));const z=`${C.name||"Error"}: ${C.message||""}${b}`;return y.set(C,{extensionIdentifier:O?.identifier,stack:z}),z}const E=Symbol("prepareStackTrace wrapped");let k=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return k},set(C){if(C===S||!C||C[E]){k=C||S;return}k=function(v,b){return S(v,b),C.call(Error,v,b)},Object.assign(k,{[E]:!0})}}),r.setUnexpectedErrorHandler(C=>{o.error(C);const v=r.$3(C),b=y.get(C);if(!b?.extensionIdentifier){s.$onUnexpectedError(v);return}h.$onExtensionRuntimeError(b.extensionIdentifier,v);const O=c.onExtensionError(b.extensionIdentifier,C);o.trace("forwarded error to extension?",O,b)})}}e.$5oc=d;class g{constructor(i,o,n,t,c){this.a=n,this.b=new L.$tbc(i,null,t),o=g.e(o,this.b);const h=new l.$yi(...(0,p.$Hs)());h.set(I.$dP,{_serviceBrand:void 0,...o,messagePorts:c}),h.set(f.$ZO,new f.$1O(this.b)),h.set(A.$_mc,new A.$anc(t)),h.set(w.$Qnc,n);const s=new D.$lr(h,!0);s.invokeFunction(d.installEarlyHandler),this.d=s.invokeFunction(m=>m.get(R.$7j)),u.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=s.invokeFunction(m=>m.get(w.$Snc)),this.c.initialize(),s.invokeFunction(d.installFullHandler)}async asBrowserUri(i){const o=this.b.getProxy(T.$vM.MainThreadExtensionService);return P.URI.revive(await o.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,o){i.extensions.allExtensions.forEach(t=>{t.extensionLocation=P.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),i.environment.appRoot=P.URI.revive(o.transformIncomingURIs(i.environment.appRoot));const n=i.environment.extensionDevelopmentLocationURI;return n&&(i.environment.extensionDevelopmentLocationURI=n.map(t=>P.URI.revive(o.transformIncomingURIs(t)))),i.environment.extensionTestsLocationURI=P.URI.revive(o.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(o.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(o.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(o.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(o.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(o.transformIncomingURIs(i.logsLocation)),i.workspace=o.transformIncomingURIs(i.workspace),i}}e.$6oc=g}),define(Ee[390],Se([1,0,7,11,244,267,148,101,77,53,20,47,8,64,42,307,308,48,37]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dpc=void 0;let i=class extends R.$Ync{constructor(h,s,m,y,S,E,k,C){super(h,s,m,y,E,k,C),this.pb=S,this.nb=new t}X(h,s){switch(h.type){case"server":return new a.$$oc(h);case"pipeServer":return new a.$_oc(h);case"executable":return new a.$apc(h,s.type)}return super.X(h,s)}fb(h,s){const m=a.$apc.platformAdapterExecutable(s.getAllExtensionDescriptions(),h.type);if(m)return new f.$CN(m.command,m.args,m.options)}Y(){return new L.$pfc}async $runInTerminal(h,s){if(h.kind==="integrated"){this.ob||(this.ob=this.pb.onDidCloseTerminal(j=>{this.nb.onTerminalClosed(j)}));const m=await this.P.getConfigProvider(),y=this.pb.getDefaultShell(!0),S=this.pb.getDefaultShellArgs(!0),E=h.title||P.localize(0,null),k=JSON.stringify({shell:y,shellArgs:S});let C=await this.nb.checkout(k,E),v,b=!1;if(C)v=h.cwd;else{const j={shellPath:y,shellArgs:S,cwd:h.cwd,name:E,iconPath:new f.$uN("debug")};b=!0,C=this.pb.createTerminalFromOptions(j,{isFeatureTerminal:!0,forceShellIntegration:!0,useShellEnvironment:!0}),this.nb.insert(C,k)}C.show(!0);const O=await C.processId;b?await new Promise(j=>setTimeout(j,1e3)):(C.state.isInteractedWith&&(C.sendText(""),await(0,r.$Bh)(200)),m.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0||y.indexOf("cmd.exe")>=0?C.sendText("cls"):y.indexOf("bash")>=0?C.sendText("clear"):u.$c?C.sendText("cls"):C.sendText("clear")));const U=(0,d.$cpc)(y,h.args,!!h.argsCanBeInterpretedByShell,v,h.env);C.sendText(U);const z=this.onDidTerminateDebugSession(j=>{j.id===s&&(this.nb.free(C),z.dispose())});return O}else if(h.kind==="external")return n(h,await this.P.getConfigProvider());return super.$runInTerminal(h,s)}};e.$dpc=i,e.$dpc=i=Ze([Ve(0,I.$ZO),Ve(1,w.$cnc),Ve(2,l.$Snc),Ve(3,g.$fnc),Ve(4,D.$Dnc),Ve(5,p.$rnc),Ve(6,A.$Vnc),Ve(7,$.$jP)],i);let o;function n(c,h){if(!o)if(u.$c)o=new T.$$dc;else if(u.$d)o=new T.$_dc;else if(u.$e)o=new T.$aec;else throw new Error("external terminals not supported on this platform");const s=h.getConfiguration("terminal");return o.runInTerminal(c.title,c.cwd,c.args,c.env||{},s.external||{})}class t{constructor(){this.b=new Map}async checkout(h,s,m=!1){const S=[...this.b.entries()].map(([E,k])=>(0,r.$nh)(async C=>{if(E.name!==s||k.lastUsedAt!==-1&&await(0,d.$bpc)(await E.processId))return null;const v=Date.now();return k.lastUsedAt+t.a>v||C.isCancellationRequested?null:k.config!==h?(m&&E.dispose(),null):(k.lastUsedAt=v,E)}));return await(0,r.$Fh)(S,E=>!!E)}insert(h,s){this.b.set(h,{lastUsedAt:Date.now(),config:s})}free(h){const s=this.b.get(h);s&&(s.lastUsedAt=-1)}onTerminalClosed(h){this.b.delete(h)}}t.a=1e3}),define(Ee[391],Se([1,0,16,2,109,42,78,48,46,47,20,30,100,15,12,96,23,66,64]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8oc=void 0;let i=class extends f.$Hoc{constructor(n,t,c,h,s,m,y,S,E){super(n,t,c,h,s,m,y,S),this.C=c,this.D=E,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(A.Schemas.vscodeRemote,{scheme:A.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(A.Schemas.file,{scheme:A.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(n,t){const c=t;if(!t.execution&&c._id===void 0)throw new Error("Tasks to execute must include an execution");if(c._id!==void 0){const h=f.TaskHandleDTO.from(c,this.C),s=await this.a.$getTaskExecution(h);if(s.task===void 0)throw new Error("Task from execution DTO is undefined");const m=await this.z(s,t);return this.a.$executeTask(h).catch(()=>{}),m}else{const h=f.TaskDTO.from(t,n);if(h===void 0)return Promise.reject(new Error("Task is not valid"));f.CustomExecutionDTO.is(h.execution)&&await this.y(h,t,!1);const s=await this.z(await this.a.$getTaskExecution(h),t);return this.a.$executeTask(h).catch(()=>{}),s}}v(n,t,c,h){const s=[];if(h)for(const m of h){this.A(m,c),(!m.definition||!n[m.definition.type])&&this.f.warn(`The task [${m.source}, ${m.name}] uses an undefined task type. The task will be ignored in the future.`);const y=f.TaskDTO.from(m,c.extension);y&&(s.push(y),f.CustomExecutionDTO.is(y.execution)&&t.push(this.y(y,m,!0)))}return{tasks:s,extension:c.extension}}async w(n){return n}async G(n){let t=n&&n.length>0?n[0]:void 0;if(!t){const c=u.URI.file((0,g.homedir)());t=new p.$Ui({uri:c,name:d.$$g(c),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(n,t){const c=u.URI.revive(n),h={process:void 0,variables:Object.create(null)},s=await this.b.resolveWorkspaceFolder(c),m=await this.b.getWorkspaceFolders2()??[],y=await this.D.getResolver(),S=s?{uri:s.uri,name:s.name,index:s.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(m);for(const E of t.variables)h.variables[E]=await y.resolveAsync(S,E);if(t.process!==void 0){let E;if(t.process.path!==void 0){E=t.process.path.split(r.$tc);for(let k=0;k<E.length;k++)E[k]=await y.resolveAsync(S,E[k])}h.process=await P.win32.findExecutable(await y.resolveAsync(S,t.process.name),t.process.cwd!==void 0?await y.resolveAsync(S,t.process.cwd):void 0,E)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(n,t,c){return P.win32.findExecutable(n,t,c)}};e.$8oc=i,e.$8oc=i=Ze([Ve(0,I.$ZO),Ve(1,D.$dP),Ve(2,T.$cnc),Ve(3,L.$$O),Ve(4,R.$fnc),Ve(5,l.$Dnc),Ve(6,w.$7j),Ve(7,a.$Smc),Ve(8,$.$Vnc)],i)}),define(Ee[392],Se([1,0,66,64]),function(oe,e,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Npc=void 0;class P extends u.$Wnc{m(){return(0,r.homedir)()}}e.$Npc=P}),define(Ee[170],Se([1,0,19,7,21,51,15,16,23,2,38]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=e.$eoc=e.$doc=void 0,e.$foc=a;class D{constructor($,i,o){this.d=$,this.e=i,this.f=o,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search($,i){const o=this.g.folderQueries||[],n=new P.$se(i);return new Promise((t,c)=>{this.a=new A($);let h=!1;const s=(m,y)=>{if(!h&&!this.b){const S=this.h(m);a(m)&&typeof this.g.maxResults=="number"&&this.c+S>this.g.maxResults&&(this.b=!0,h=!0,n.cancel(),m=this.j(m,this.g.maxResults-this.c));const E=this.h(m);this.c+=E,(E>0||!a(m))&&this.a.add(m,y)}};Promise.all(o.map((m,y)=>this.k(m,S=>s(S,y),n.token))).then(m=>{n.dispose(),this.a.flush();const y=m.some(S=>!!S&&!!S.limitHit);t({limitHit:this.b||y,messages:m.flatMap(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[]),stats:{type:this.f}})},m=>{n.dispose();const y=(0,T.$lj)(m);c(new Error(y))})})}h($){return a($)?Array.isArray($.ranges)?$.ranges.length:1:0}j($,i){const o=Array.isArray($.ranges)?$.ranges:[$.ranges],n=Array.isArray($.preview.matches)?$.preview.matches:[$.preview.matches];return{ranges:o.slice(0,i),preview:{matches:n.slice(0,i),text:$.preview.text},uri:$.uri}}async k($,i,o){const n=new I.$2K(this.g,$),t=[],c={report:m=>{if(!this.l(m))return;const y=$.folder.scheme===L.Schemas.file?(0,I.$3K)(()=>this.e.readdir(p.$ah(m.uri))):void 0,S=p.$dh($.folder,m.uri);if(S){const E=n.includedInQuery(S,R.$nc(S),y);(0,u.$mh)(E)?t.push(E.then(k=>{k&&i(m)})):E&&i(m)}}},h=this.n($);let s;return this.d.query.type===I.QueryType.aiText?s=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,h,c,o):s=await this.d.provider.provideTextSearchResults(f(this.d.query.contentPattern),h,c,o),t.length&&await Promise.all(t),s}l($){if(a($)){if(Array.isArray($.ranges)){if(!Array.isArray($.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if($.preview.matches.length!==$.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray($.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n($){const i=(0,I.$1K)(this.g.includePattern,$.includePattern),o=(0,I.$1K)(this.g.excludePattern,$.excludePattern),n={folder:l.URI.from($.folder),excludes:o,includes:i,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,encoding:$.fileEncoding&&this.e.toCanonicalName($.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(n.usePCRE2=this.g.usePCRE2),n}}e.$doc=D;function f(g){return{isCaseSensitive:g.isCaseSensitive||!1,isRegExp:g.isRegExp||!1,isWordMatch:g.isWordMatch||!1,isMultiline:g.isMultiline||!1,pattern:g.pattern}}class A{constructor($){this.e=$,this.b=-1,this.d=null,this.a=new d(512,i=>this.g(i))}add($,i){this.d&&(this.b!==i||!p.$7g(this.c,$.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:$.uri,results:[]}),this.d.results.push(w($))}f(){const $=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,$)}flush(){this.f(),this.a.flush()}g($){this.e($)}}e.$eoc=A;function w(g){return a(g)?{preview:{matches:(0,r.$1b)(g.preview.matches,$=>({startLineNumber:$.start.line,startColumn:$.start.character,endLineNumber:$.end.line,endColumn:$.end.character})),text:g.preview.text},ranges:(0,r.$1b)(g.ranges,$=>({startLineNumber:$.start.line,startColumn:$.start.character,endLineNumber:$.end.line,endColumn:$.end.character}))}:{text:g.text,lineNumber:g.lineNumber}}function a(g){return!!g.preview}class d{constructor($,i){this.g=$,this.h=i,this.c=0,this.d=[],this.e=0}addItem($,i){$&&this.j($,i)}addItems($,i){$&&this.k($,i)}j($,i){this.d.push($),this.e+=i,this.l()}k($,i){this.d=this.d.concat($),this.e+=i,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$goc=d,d.a=4e3,d.b=50}),define(Ee[102],Se([1,0,3,6,5,385,20,72,12,2,170]),function(oe,e,r,u,P,T,L,R,p,l,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=e.$hoc=void 0,e.$joc=f,e.$hoc=(0,P.$Ai)("IExtHostSearch");let D=class{constructor(a,d,g){this.n=a,this.o=d,this.q=g,this.c=this.n.getProxy(u.$vM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new T.$coc}s(a){return this.o.transformOutgoingScheme(a)}registerTextSearchProvider(a,d){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const g=this.d++;return this.e.set(g,d),this.c.$registerTextSearchProvider(g,this.s(a)),(0,r.$Sc)(()=>{this.g.delete(a),this.e.delete(g),this.c.$unregisterProvider(g)})}registerAITextSearchProvider(a,d){if(this.i.has(a))throw new Error(`an AI text search provider for the scheme '${a}'is already registered`);this.i.add(a);const g=this.d++;return this.h.set(g,d),this.c.$registerAITextSearchProvider(g,this.s(a)),(0,r.$Sc)(()=>{this.i.delete(a),this.h.delete(g),this.c.$unregisterProvider(g)})}registerFileSearchProvider(a,d){if(this.k.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.k.add(a);const g=this.d++;return this.j.set(g,d),this.c.$registerFileSearchProvider(g,this.s(a)),(0,r.$Sc)(()=>{this.k.delete(a),this.j.delete(g),this.c.$unregisterProvider(g)})}$provideFileSearchResults(a,d,g,$){const i=f(g),o=this.j.get(a);if(o)return this.l.fileSearch(i,o,n=>{this.c.$handleFileMatch(a,d,n.map(t=>t.resource))},$);throw new Error("3 unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,d,g){return{messages:[]}}$clearCache(a){return this.l.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,d,g,$){const i=this.e.get(a);if(!i||!i.provideTextSearchResults)throw new Error(`2 Unknown provider ${a}`);const o=f(g);return this.t(o,i).search(t=>this.c.$handleTextMatch(a,d,t),$)}$provideAITextSearchResults(a,d,g,$){const i=this.h.get(a);if(!i||!i.provideAITextSearchResults)throw new Error(`1 Unknown provider ${a}`);const o=f(g);return this.v(o,i).search(t=>this.c.$handleTextMatch(a,d,t),$)}$enableExtensionHostSearch(){}t(a,d){return new I.$doc({query:a,provider:d},{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g},"textSearchProvider")}v(a,d){return new I.$doc({query:a,provider:d},{readdir:g=>Promise.resolve([]),toCanonicalName:g=>g},"aiTextSearchProvider")}};e.$ioc=D,e.$ioc=D=Ze([Ve(0,L.$ZO),Ve(1,R.$_mc),Ve(2,p.$7j)],D);function f(w){return{...w,folderQueries:w.folderQueries&&w.folderQueries.map(A),extraFileResources:w.extraFileResources&&w.extraFileResources.map(a=>l.URI.revive(a))}}function A(w){return{...w,folder:l.URI.revive(w.folder)}}}),define(Ee[393],Se([1,0,21,14,4,3,15,44,2,113,199,200,59,24,28,12,91,92,294,6,339,365,96,128,343,344,345,324,313,37,346,48,347,101,162,348,326,340,349,350,78,77,327,341,53,351,75,352,63,30,366,328,353,129,354,123,124,329,384,356,298,357,367,358,168,330,359,360,361,20,362,102,125,363,331,364,126,98,100,95,47,166,368,369,342,370,371,76,17,8,332,72,333,97,372,373,161,42,120,94,26,99]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n,t,c,h,s,m,y,S,E,k,C,v,b,O,U,z,j,M,N,F,X,se,W,H,V,x,he,ne,we,pe,ce,K,de,te,ee,ie,le,Z,ae,$e,be,Me,qe,De,Pe,Te,B,q,Y,_,fe,ve,Ne,Be,Qe,He,tt,nt,ot,at,pt,ft,st,ht,Re,Ie,Ae,ue,Q,Ce,Je,_e,ct,lt,yt,At,Ot,_t,rn,xe,en){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=Zt;function Zt($t){const wt=$t.get(we.$dP),Qt=$t.get(ne.$Wmc),tn=$t.get(x.$hnc),qt=$t.get(H.$Snc),bt=$t.get(Ot.$cnc),Mt=$t.get(ot.$hP),Wt=$t.get(C.$fnc),Ut=$t.get(Je.$_mc),Ye=$t.get(Y.$ZO),nn=$t.get(He.$Anc),sn=$t.get(tt.$inc),un=$t.get(a.$8j),Pt=$t.get(a.$7j),jt=$t.get(Ae.$wEb),Nt=$t.get(t.$Smc),Ht=$t.get(At.$Yoc),hn=$t.get(ve.$Knc),on=$t.get(X.$rnc),cn=$t.get(ie.$Onc),Gt=$t.get(c.$3mc),zt=$t.get(de.$Hnc);Ye.set(i.$wM.ExtHostFileSystemInfo,Qt),Ye.set(i.$wM.ExtHostLogLevelServiceShape,un),Ye.set(i.$wM.ExtHostWorkspace,bt),Ye.set(i.$wM.ExtHostConfiguration,Wt),Ye.set(i.$wM.ExtHostExtensionService,qt),Ye.set(i.$wM.ExtHostStorage,nn),Ye.set(i.$wM.ExtHostTunnelService,jt),Ye.set(i.$wM.ExtHostWindow,Ht),Ye.set(i.$wM.ExtHostSecretState,hn),Ye.set(i.$wM.ExtHostTelemetry,Mt),Ye.set(i.$wM.ExtHostEditorTabs,on),Ye.set(i.$wM.ExtHostManagedSockets,cn),Ye.set(i.$wM.ExtHostAuthentication,Gt),Ye.set(i.$wM.ExtHostChatProvider,zt);const ln=Ye.set(i.$wM.ExtHostDecorations,$t.get(O.$4nc)),Rt=Ye.set(i.$wM.ExtHostDocumentsAndEditors,$t.get(F.$$O)),St=Ye.set(i.$wM.ExtHostCommands,$t.get(E.$jP)),Et=Ye.set(i.$wM.ExtHostTerminalService,$t.get(at.$Dnc)),Kt=Ye.set(i.$wM.ExtHostTerminalShellIntegration,$t.get(pt.$Koc)),Dt=Ye.set(i.$wM.ExtHostDebugService,$t.get(b.$Xnc)),Vt=Ye.set(i.$wM.ExtHostSearch,$t.get(fe.$hoc)),Jt=Ye.set(i.$wM.ExtHostTask,$t.get(nt.$Joc)),Sn=Ye.set(i.$wM.ExtHostOutputService,$t.get(De.$woc)),mn=Ye.set(i.$wM.ExtHostLocalization,$t.get(ee.$Nnc)),$n=Ye.set(i.$wM.ExtHostUrls,new _e.$Voc(Ye)),Ft=Ye.set(i.$wM.ExtHostDocuments,new N.$Zmc(Ye,Rt)),wn=Ye.set(i.$wM.ExtHostDocumentContentProviders,new j.$6nc(Ye,Rt,Pt)),Rn=Ye.set(i.$wM.ExtHostDocumentSaveParticipant,new M.$7nc(Pt,Ft,Ye.getProxy(i.$vM.MainThreadBulkEdits))),Tt=Ye.set(i.$wM.ExtHostNotebook,new Z.$koc(Ye,St,Rt,Ft,tn,Vt,Pt)),Tn=Ye.set(i.$wM.ExtHostNotebookDocuments,new $e.$qoc(Tt)),kn=Ye.set(i.$wM.ExtHostNotebookEditors,new be.$roc(Pt,Tt)),pn=Ye.set(i.$wM.ExtHostNotebookKernels,new Me.$soc(Ye,wt,Tt,St,Pt)),In=Ye.set(i.$wM.ExtHostNotebookRenderers,new qe.$uoc(Ye,Tt)),dn=Ye.set(i.$wM.ExtHostNotebookDocumentSaveParticipant,new ae.$poc(Pt,Tt,Ye.getProxy(i.$vM.MainThreadBulkEdits))),Le=Ye.set(i.$wM.ExtHostEditors,new st.$9mc(Ye,Rt)),je=Ye.set(i.$wM.ExtHostTreeViews,new Ie.$Toc(Ye.getProxy(i.$vM.MainThreadTreeViews),St,Pt)),ke=Ye.set(i.$wM.ExtHostEditorInsets,new S.$0mc(Ye.getProxy(i.$vM.MainThreadEditorInsets),Le,wt.remote)),re=Ye.set(i.$wM.ExtHostDiagnostics,new U.$Ymc(Ye,Pt,Qt,Rt)),Fe=Ye.set(i.$wM.ExtHostLanguages,new te.$noc(Ye,Ft,St.converter,Ut)),We=Ye.set(i.$wM.ExtHostLanguageFeatures,new K.$1mc(Ye,Ut,Ft,St,re,Pt,Nt,Mt)),et=Ye.set(i.$wM.ExtHostFileSystem,new V.$0nc(Ye,We)),Ke=Ye.set(i.$wM.ExtHostFileSystemEventService,new he.$$nc(Ye,Pt,Rt)),gt=Ye.set(i.$wM.ExtHostQuickOpen,(0,q.$Aoc)(Ye,bt,St)),Ct=Ye.set(i.$wM.ExtHostSCM,new _.$Coc(Ye,St,Ft,Pt)),Xt=Ye.set(i.$wM.ExtHostQuickDiff,new B.$zoc(Ye,Ut)),an=Ye.set(i.$wM.ExtHostShare,new Ne.$Doc(Ye,Ut)),Bt=Ye.set(i.$wM.ExtHostComments,(0,k.$$mc)(Ye,St,Ft)),Yt=Ye.set(i.$wM.ExtHostProgress,new Te.$yoc(Ye.getProxy(i.$vM.MainThreadProgress))),Vn=Ye.set(i.$wM.ExtHostLabelService,new ce.$moc(Ye)),xn=Ye.set(i.$wM.ExtHostTheming,new ht.$Qoc(Ye)),wi=Ye.set(i.$wM.ExtHostTimeline,new Re.$Soc(Ye,St)),Ln=Ye.set(i.$wM.ExtHostWebviews,new ct.$mnc(Ye,wt.remote,bt,Pt,Nt)),Nn=Ye.set(i.$wM.ExtHostWebviewPanels,new lt.$pnc(Ye,Ln,bt)),qn=Ye.set(i.$wM.ExtHostCustomEditors,new v.$qnc(Ye,Ft,sn,Ln,Nn)),Gn=Ye.set(i.$wM.ExtHostWebviewViews,new yt.$Woc(Ye,Ln)),vn=Ye.set(i.$wM.ExtHostTesting,new ft.$Moc(Ye,Pt,St,Rt)),Hn=Ye.set(i.$wM.ExtHostUriOpeners,new Ce.$Uoc(Ye)),_n=Ye.set(i.$wM.ExtHostProfileContentHandlers,new Pe.$xoc(Ye));Ye.set(i.$wM.ExtHostInteractive,new pe.$loc(Ye,Tt,Rt,St,Pt));const Fn=Ye.set(i.$wM.ExtHostChatAgents2,new s.$6mc(Ye,Pt,St,wt.quality)),ei=Ye.set(i.$wM.ExtHostChatVariables,new m.$7mc(Ye)),Kn=Ye.set(i.$wM.ExtHostAiRelatedInformation,new o.$Rmc(Ye)),Jn=Ye.set(i.$wM.ExtHostAiEmbeddingVector,new W.$9nc(Ye)),jn=Ye.set(i.$wM.ExtHostStatusBar,new Qe.$Goc(Ye,St.converter)),ti=Ye.set(i.$wM.ExtHostSpeech,new Be.$Eoc(Ye)),Pn=Ye.set(i.$wM.ExtHostEmbeddings,new se.$8nc(Ye)),ni=Object.values(i.$wM);Ye.assertRegistered(ni);const ii=new h.$5mc(Ye,Rt),ri=new y.$8mc(Ye),Un=new le.$ooc(Ye,Pt),si=new z.$5nc(Ye);return n.$2mc.register(St),function(ze,fn,zn){function ut(ge){return(ye,Ue,dt)=>{const kt=ge(Lt=>{try{ye.call(Ue,Lt)}catch(Cn){u.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Cn.toString()}`,{cause:Cn})),Mt.onExtensionError(ze.identifier,Cn)}});return dt?.push(kt),kt}}const It=function(){let ge=!ze.isUnderDevelopment;function ye(){ge||(Pt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ge=!0)}return function Ue(dt){if(Array.isArray(dt))dt.forEach(Ue);else if(typeof dt=="string")ye();else{const kt=dt;typeof kt.scheme>"u"&&ye(),typeof kt.exclusive=="boolean"&&(0,xe.$VG)(ze,"documentFiltersExclusive")}return dt}}(),oi={getSession(ge,ye,Ue){return typeof Ue?.forceNewSession=="object"&&Ue.forceNewSession.learnMore&&(0,xe.$VG)(ze,"authLearnMore"),Gt.getSession(ze,ge,ye,Ue)},getSessions(ge,ye){return(0,xe.$VG)(ze,"authGetSessions"),Gt.getSessions(ze,ge,ye)},async hasSession(ge,ye){return(0,xe.$VG)(ze,"authSession"),!!await Gt.getSession(ze,ge,ye,{silent:!0})},get onDidChangeSessions(){return ut(Gt.onDidChangeSessions)},registerAuthenticationProvider(ge,ye,Ue,dt){return Gt.registerAuthenticationProvider(ge,ye,Ue,dt)}},vi={registerCommand(ge,ye,Ue){return St.registerCommand(!0,ge,ye,Ue,void 0,ze)},registerTextEditorCommand(ge,ye,Ue){return St.registerCommand(!0,ge,(...dt)=>{const kt=Le.getActiveTextEditor();if(!kt){Pt.warn("Cannot execute "+ge+" because there is no active text editor.");return}return kt.edit(Lt=>{ye.apply(Ue,[kt,Lt,...dt])}).then(Lt=>{Lt||Pt.warn("Edits from command "+ge+" were not applied.")},Lt=>{Pt.warn("An error occurred while running command "+ge,Lt)})},void 0,void 0,ze)},registerDiffInformationCommand:(ge,ye,Ue)=>((0,xe.$VG)(ze,"diffCommand"),St.registerCommand(!0,ge,async(...dt)=>{const kt=Rt.activeEditor(!0);if(!kt){Pt.warn("Cannot execute "+ge+" because there is no active text editor.");return}const Lt=await Le.getDiffInformation(kt.id);ye.apply(Ue,[Lt,...dt])},void 0,void 0,ze)),executeCommand(ge,...ye){return St.executeCommand(ge,...ye)},getCommands(ge=!1){return St.getCommands(ge)}},On={get machineId(){return wt.telemetryInfo.machineId},get sessionId(){return wt.telemetryInfo.sessionId},get language(){return wt.environment.appLanguage},get appName(){return wt.environment.appName},get appRoot(){return wt.environment.appRoot?.fsPath??""},get appHost(){return wt.environment.appHost},get uriScheme(){return wt.environment.appUriScheme},get clipboard(){return ri.value},get shell(){return Et.getDefaultShell(!1)},get onDidChangeShell(){return ut(Et.onDidChangeShell)},get isTelemetryEnabled(){return Mt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ut(Mt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,xe.$VG)(ze,"telemetry"),Mt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,xe.$VG)(ze,"telemetry"),ut(Mt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ot.$gP)(wt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ge,ye){return ot.$fP.validateSender(ge),Mt.instantiateLogger(ze,ge,ye)},openExternal(ge,ye){return Ht.openUri(ge,{allowTunneling:!!wt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(ge){if(ge.scheme===wt.environment.appUriScheme)return $n.createAppUri(ge);try{return await Ht.asExternalUri(ge,{allowTunneling:!!wt.remote.authority})}catch(ye){if((0,L.$Jg)(ge,L.Schemas.http)||(0,L.$Jg)(ge,L.Schemas.https))return ge;throw ye}},get remoteName(){return(0,d.$Om)(wt.remote.authority)},get remoteAuthority(){return(0,xe.$VG)(ze,"resolvers"),wt.remote.authority},get uiKind(){return wt.uiKind},get logLevel(){return Pt.getLevel()},get onDidChangeLogLevel(){return ut(Pt.onDidChangeLogLevel)},get appQuality(){return(0,xe.$VG)(ze,"resolvers"),wt.quality},get appCommit(){return(0,xe.$VG)(ze,"resolvers"),wt.commit}};wt.environment.extensionTestsLocationURI||Object.freeze(On);const ai={createTestController(ge,ye,Ue){return vn.createTestController(ze,ge,ye,Ue)},createTestObserver(){return(0,xe.$VG)(ze,"testObserver"),vn.createTestObserver()},runTests(ge){return(0,xe.$VG)(ze,"testObserver"),vn.runTests(ge)},registerTestFollowupProvider(ge){return(0,xe.$VG)(ze,"testObserver"),vn.registerTestFollowupProvider(ge)},get onDidChangeTestResults(){return(0,xe.$VG)(ze,"testObserver"),ut(vn.onResultsChanged)},get testResults(){return(0,xe.$VG)(ze,"testObserver"),vn.results}},Mn=wt.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,ci={getExtension(ge,ye){(0,xe.$UG)(ze,"extensionsAny")||(ye=!1);const Ue=fn.mine.getExtensionDescription(ge);if(Ue)return new H.$Tnc(qt,ze.identifier,Ue,Mn,!1);if(ye){const dt=fn.all.getExtensionDescription(ge);if(dt)return new H.$Tnc(qt,ze.identifier,dt,Mn,!0)}},get all(){const ge=[];for(const ye of fn.mine.getAllExtensionDescriptions())ge.push(new H.$Tnc(qt,ze.identifier,ye,Mn,!1));return ge},get allAcrossExtensionHosts(){(0,xe.$VG)(ze,"extensionsAny");const ge=new A.$Ym(fn.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ye=[];for(const Ue of fn.all.getAllExtensionDescriptions()){const dt=!ge.has(Ue.identifier);ye.push(new H.$Tnc(qt,ze.identifier,Ue,Mn,dt))}return ye},get onDidChange(){return(0,xe.$UG)(ze,"extensionsAny")?ut(P.Event.any(fn.mine.onDidChange,fn.all.onDidChange)):ut(fn.mine.onDidChange)}},yi={createDiagnosticCollection(ge){return re.createDiagnosticCollection(ze.identifier,ge)},get onDidChangeDiagnostics(){return ut(re.onDidChangeDiagnostics)},getDiagnostics:ge=>re.getDiagnostics(ge),getLanguages(){return Fe.getLanguages()},setTextDocumentLanguage(ge,ye){return Fe.changeLanguage(ge.uri,ye)},match(ge,ye){const Ue=ue.LanguageSelector.from(ge);let dt;return(0,I.$it)(Ue)&&(dt=Tt.notebookDocuments.find(kt=>kt.apiNotebook.getCells().find(Lt=>Lt.document===ye))?.apiNotebook),(0,I.$ht)(Ue,ye.uri,ye.languageId,!0,dt?.uri,dt?.notebookType)},registerCodeActionsProvider(ge,ye,Ue){return We.registerCodeActionProvider(ze,It(ge),ye,Ue)},registerDocumentPasteEditProvider(ge,ye,Ue){return(0,xe.$VG)(ze,"documentPaste"),We.registerDocumentPasteEditProvider(ze,It(ge),ye,Ue)},registerCodeLensProvider(ge,ye){return We.registerCodeLensProvider(ze,It(ge),ye)},registerDefinitionProvider(ge,ye){return We.registerDefinitionProvider(ze,It(ge),ye)},registerDeclarationProvider(ge,ye){return We.registerDeclarationProvider(ze,It(ge),ye)},registerImplementationProvider(ge,ye){return We.registerImplementationProvider(ze,It(ge),ye)},registerTypeDefinitionProvider(ge,ye){return We.registerTypeDefinitionProvider(ze,It(ge),ye)},registerHoverProvider(ge,ye){return We.registerHoverProvider(ze,It(ge),ye,ze.identifier)},registerEvaluatableExpressionProvider(ge,ye){return We.registerEvaluatableExpressionProvider(ze,It(ge),ye,ze.identifier)},registerInlineValuesProvider(ge,ye){return We.registerInlineValuesProvider(ze,It(ge),ye,ze.identifier)},registerDocumentHighlightProvider(ge,ye){return We.registerDocumentHighlightProvider(ze,It(ge),ye)},registerMultiDocumentHighlightProvider(ge,ye){return We.registerMultiDocumentHighlightProvider(ze,It(ge),ye)},registerLinkedEditingRangeProvider(ge,ye){return We.registerLinkedEditingRangeProvider(ze,It(ge),ye)},registerReferenceProvider(ge,ye){return We.registerReferenceProvider(ze,It(ge),ye)},registerRenameProvider(ge,ye){return We.registerRenameProvider(ze,It(ge),ye)},registerNewSymbolNamesProvider(ge,ye){return(0,xe.$VG)(ze,"newSymbolNamesProvider"),We.registerNewSymbolNamesProvider(ze,It(ge),ye)},registerDocumentSymbolProvider(ge,ye,Ue){return We.registerDocumentSymbolProvider(ze,It(ge),ye,Ue)},registerWorkspaceSymbolProvider(ge){return We.registerWorkspaceSymbolProvider(ze,ge)},registerDocumentFormattingEditProvider(ge,ye){return We.registerDocumentFormattingEditProvider(ze,It(ge),ye)},registerDocumentRangeFormattingEditProvider(ge,ye){return We.registerDocumentRangeFormattingEditProvider(ze,It(ge),ye)},registerOnTypeFormattingEditProvider(ge,ye,Ue,...dt){return We.registerOnTypeFormattingEditProvider(ze,It(ge),ye,[Ue].concat(dt))},registerDocumentSemanticTokensProvider(ge,ye,Ue){return We.registerDocumentSemanticTokensProvider(ze,It(ge),ye,Ue)},registerDocumentRangeSemanticTokensProvider(ge,ye,Ue){return We.registerDocumentRangeSemanticTokensProvider(ze,It(ge),ye,Ue)},registerSignatureHelpProvider(ge,ye,Ue,...dt){return typeof Ue=="object"?We.registerSignatureHelpProvider(ze,It(ge),ye,Ue):We.registerSignatureHelpProvider(ze,It(ge),ye,typeof Ue>"u"?[]:[Ue,...dt])},registerCompletionItemProvider(ge,ye,...Ue){return We.registerCompletionItemProvider(ze,It(ge),ye,Ue)},registerInlineCompletionItemProvider(ge,ye,Ue){return ye.handleDidShowCompletionItem&&(0,xe.$VG)(ze,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,xe.$VG)(ze,"inlineCompletionsAdditions"),Ue&&(0,xe.$VG)(ze,"inlineCompletionsAdditions"),We.registerInlineCompletionsProvider(ze,It(ge),ye,Ue)},registerInlineEditProvider(ge,ye){return(0,xe.$VG)(ze,"inlineEdit"),We.registerInlineEditProvider(ze,It(ge),ye)},registerDocumentLinkProvider(ge,ye){return We.registerDocumentLinkProvider(ze,It(ge),ye)},registerColorProvider(ge,ye){return We.registerColorProvider(ze,It(ge),ye)},registerFoldingRangeProvider(ge,ye){return We.registerFoldingRangeProvider(ze,It(ge),ye)},registerSelectionRangeProvider(ge,ye){return We.registerSelectionRangeProvider(ze,ge,ye)},registerCallHierarchyProvider(ge,ye){return We.registerCallHierarchyProvider(ze,ge,ye)},registerTypeHierarchyProvider(ge,ye){return We.registerTypeHierarchyProvider(ze,ge,ye)},setLanguageConfiguration:(ge,ye)=>We.setLanguageConfiguration(ze,ge,ye),getTokenInformationAtPosition(ge,ye){return(0,xe.$VG)(ze,"tokenInformation"),Fe.tokenAtPosition(ge,ye)},registerInlayHintsProvider(ge,ye){return We.registerInlayHintsProvider(ze,ge,ye)},createLanguageStatusItem(ge,ye){return Fe.createLanguageStatusItem(ze,ge,ye)},registerDocumentDropEditProvider(ge,ye,Ue){return We.registerDocumentOnDropEditProvider(ze,ge,ye,(0,xe.$UG)(ze,"documentPaste")?Ue:void 0)}},Zn={get activeTextEditor(){return Le.getActiveTextEditor()},get visibleTextEditors(){return Le.getVisibleTextEditors()},get activeTerminal(){return Et.activeTerminal},get terminals(){return Et.terminals},async showTextDocument(ge,ye,Ue){p.URI.isUri(ge)&&ge.scheme===L.Schemas.vscodeRemote&&!ge.authority&&Nt.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const dt=await(p.URI.isUri(ge)?Promise.resolve(Qn.openTextDocument(ge)):Promise.resolve(ge));return Le.showTextDocument(dt,ye,Ue)},createTextEditorDecorationType(ge){return Le.createTextEditorDecorationType(ze,ge)},onDidChangeActiveTextEditor(ge,ye,Ue){return ut(Le.onDidChangeActiveTextEditor)(ge,ye,Ue)},onDidChangeVisibleTextEditors(ge,ye,Ue){return ut(Le.onDidChangeVisibleTextEditors)(ge,ye,Ue)},onDidChangeTextEditorSelection(ge,ye,Ue){return ut(Le.onDidChangeTextEditorSelection)(ge,ye,Ue)},onDidChangeTextEditorOptions(ge,ye,Ue){return ut(Le.onDidChangeTextEditorOptions)(ge,ye,Ue)},onDidChangeTextEditorVisibleRanges(ge,ye,Ue){return ut(Le.onDidChangeTextEditorVisibleRanges)(ge,ye,Ue)},onDidChangeTextEditorViewColumn(ge,ye,Ue){return ut(Le.onDidChangeTextEditorViewColumn)(ge,ye,Ue)},onDidCloseTerminal(ge,ye,Ue){return ut(Et.onDidCloseTerminal)(ge,ye,Ue)},onDidOpenTerminal(ge,ye,Ue){return ut(Et.onDidOpenTerminal)(ge,ye,Ue)},onDidChangeActiveTerminal(ge,ye,Ue){return ut(Et.onDidChangeActiveTerminal)(ge,ye,Ue)},onDidChangeTerminalDimensions(ge,ye,Ue){return(0,xe.$VG)(ze,"terminalDimensions"),ut(Et.onDidChangeTerminalDimensions)(ge,ye,Ue)},onDidChangeTerminalState(ge,ye,Ue){return ut(Et.onDidChangeTerminalState)(ge,ye,Ue)},onDidWriteTerminalData(ge,ye,Ue){return(0,xe.$VG)(ze,"terminalDataWriteEvent"),ut(Et.onDidWriteTerminalData)(ge,ye,Ue)},onDidExecuteTerminalCommand(ge,ye,Ue){return(0,xe.$VG)(ze,"terminalExecuteCommandEvent"),ut(Et.onDidExecuteTerminalCommand)(ge,ye,Ue)},onDidChangeTerminalShellIntegration(ge,ye,Ue){return(0,xe.$VG)(ze,"terminalShellIntegration"),ut(Kt.onDidChangeTerminalShellIntegration)(ge,ye,Ue)},onDidStartTerminalShellExecution(ge,ye,Ue){return(0,xe.$VG)(ze,"terminalShellIntegration"),ut(Kt.onDidStartTerminalShellExecution)(ge,ye,Ue)},onDidEndTerminalShellExecution(ge,ye,Ue){return(0,xe.$VG)(ze,"terminalShellIntegration"),ut(Kt.onDidEndTerminalShellExecution)(ge,ye,Ue)},get state(){return Ht.getState()},onDidChangeWindowState(ge,ye,Ue){return ut(Ht.onDidChangeWindowState)(ge,ye,Ue)},showInformationMessage(ge,...ye){return Un.showMessage(ze,R.default.Info,ge,ye[0],ye.slice(1))},showWarningMessage(ge,...ye){return Un.showMessage(ze,R.default.Warning,ge,ye[0],ye.slice(1))},showErrorMessage(ge,...ye){return Un.showMessage(ze,R.default.Error,ge,ye[0],ye.slice(1))},showQuickPick(ge,ye,Ue){return gt.showQuickPick(ze,ge,ye,Ue)},showWorkspaceFolderPick(ge){return gt.showWorkspaceFolderPick(ge)},showInputBox(ge,ye){return gt.showInput(ge,ye)},showOpenDialog(ge){return si.showOpenDialog(ze,ge)},showSaveDialog(ge){return si.showSaveDialog(ge)},createStatusBarItem(ge,ye,Ue){let dt,kt,Lt;return typeof ge=="string"?(dt=ge,kt=ye,Lt=Ue):(kt=ge,Lt=ye),jn.createStatusBarEntry(ze,dt,kt,Lt)},setStatusBarMessage(ge,ye){return jn.setStatusBarMessage(ge,ye)},withScmProgress(ge){return Nt.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Yt.withProgress(ze,{location:Q.ProgressLocation.SourceControl},(ye,Ue)=>ge({report(dt){}}))},withProgress(ge,ye){return Yt.withProgress(ze,ge,ye)},createOutputChannel(ge,ye){return Sn.createOutputChannel(ge,ye,ze)},createWebviewPanel(ge,ye,Ue,dt){return Nn.createWebviewPanel(ze,ge,ye,Ue,dt)},createWebviewTextEditorInset(ge,ye,Ue,dt){return(0,xe.$VG)(ze,"editorInsets"),ke.createWebviewEditorInset(ge,ye,Ue,dt,ze)},createTerminal(ge,ye,Ue){return typeof ge=="object"?"pty"in ge?Et.createExtensionTerminal(ge):Et.createTerminalFromOptions(ge):Et.createTerminal(ge,ye,Ue)},registerTerminalLinkProvider(ge){return Et.registerLinkProvider(ge)},registerTerminalProfileProvider(ge,ye){return Et.registerProfileProvider(ze,ge,ye)},registerTerminalQuickFixProvider(ge,ye){return(0,xe.$VG)(ze,"terminalQuickFixProvider"),Et.registerTerminalQuickFixProvider(ge,ze.identifier.value,ye)},registerTreeDataProvider(ge,ye){return je.registerTreeDataProvider(ge,ye,ze)},createTreeView(ge,ye){return je.createTreeView(ge,ye,ze)},registerWebviewPanelSerializer:(ge,ye)=>Nn.registerWebviewPanelSerializer(ze,ge,ye),registerCustomEditorProvider:(ge,ye,Ue={})=>qn.registerCustomEditorProvider(ze,ge,ye,Ue),registerFileDecorationProvider(ge){return ln.registerFileDecorationProvider(ge,ze)},registerUriHandler(ge){return $n.registerUriHandler(ze,ge)},createQuickPick(){return gt.createQuickPick(ze)},createInputBox(){return gt.createInputBox(ze)},get activeColorTheme(){return xn.activeColorTheme},onDidChangeActiveColorTheme(ge,ye,Ue){return ut(xn.onDidChangeActiveColorTheme)(ge,ye,Ue)},registerWebviewViewProvider(ge,ye,Ue){return Gn.registerWebviewViewProvider(ze,ge,ye,Ue?.webviewOptions)},get activeNotebookEditor(){return Tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ge,ye,Ue){return ut(Tt.onDidChangeActiveNotebookEditor)(ge,ye,Ue)},get visibleNotebookEditors(){return Tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ut(Tt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ge,ye,Ue){return ut(kn.onDidChangeNotebookEditorSelection)(ge,ye,Ue)},onDidChangeNotebookEditorVisibleRanges(ge,ye,Ue){return ut(kn.onDidChangeNotebookEditorVisibleRanges)(ge,ye,Ue)},showNotebookDocument(ge,ye){return Tt.showNotebookDocument(ge,ye)},registerExternalUriOpener(ge,ye,Ue){return(0,xe.$VG)(ze,"externalUriOpener"),Hn.registerExternalUriOpener(ze.identifier,ge,ye,Ue)},registerProfileContentHandler(ge,ye){return(0,xe.$VG)(ze,"profileContentHandlers"),_n.registerProfileContentHandler(ze,ge,ye)},registerQuickDiffProvider(ge,ye,Ue,dt){return(0,xe.$VG)(ze,"quickDiffProvider"),Xt.registerQuickDiffProvider(It(ge),ye,Ue,dt)},get tabGroups(){return on.tabGroups},registerShareProvider(ge,ye){return(0,xe.$VG)(ze,"shareProvider"),an.registerShareProvider(It(ge),ye)}},Qn={get rootPath(){return Nt.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),bt.getPath()},set rootPath(ge){throw new u.$9("rootPath")},getWorkspaceFolder(ge){return bt.getWorkspaceFolder(ge)},get workspaceFolders(){return bt.getWorkspaceFolders()},get name(){return bt.name},set name(ge){throw new u.$9("name")},get workspaceFile(){return bt.workspaceFile},set workspaceFile(ge){throw new u.$9("workspaceFile")},updateWorkspaceFolders:(ge,ye,...Ue)=>bt.updateWorkspaceFolders(ze,ge,ye||0,...Ue),onDidChangeWorkspaceFolders:function(ge,ye,Ue){return ut(bt.onDidChangeWorkspace)(ge,ye,Ue)},asRelativePath:(ge,ye)=>bt.getRelativePath(ge,ye),findFiles:(ge,ye,Ue,dt)=>bt.findFiles(ge,ye,Ue,ze.identifier,dt),findFiles2:(ge,ye,Ue)=>((0,xe.$VG)(ze,"findFiles2"),bt.findFiles2(ge,ye,ze.identifier,Ue)),findTextInFiles:(ge,ye,Ue,dt)=>{(0,xe.$VG)(ze,"findTextInFiles");let kt,Lt;return typeof ye=="object"?(kt=ye,Lt=Ue):(kt={},Lt=ye,dt=Ue),bt.findTextInFiles(ge,kt||{},Lt,ze.identifier,dt)},save:ge=>bt.save(ge),saveAs:ge=>bt.saveAs(ge),saveAll:ge=>bt.saveAll(ge),applyEdit(ge,ye){return ii.applyWorkspaceEdit(ge,ze,ye)},createFileSystemWatcher:(ge,ye,Ue,dt)=>{let kt;return typeof ye=="boolean"?kt={ignoreCreateEvents:!!ye,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!dt,correlate:!1}:ye&&((0,xe.$VG)(ze,"createFileSystemWatcher"),kt={...ye,correlate:!0}),Ke.createFileSystemWatcher(bt,ze,ge,kt)},get textDocuments(){return Ft.getAllDocumentData().map(ge=>ge.document)},set textDocuments(ge){throw new u.$9("textDocuments")},openTextDocument(ge){let ye;const Ue=ge;if(typeof ge=="string")ye=Promise.resolve(p.URI.file(ge));else if(p.URI.isUri(ge))ye=Promise.resolve(ge);else if(!Ue||typeof Ue=="object")ye=Ft.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(dt=>(dt.scheme===L.Schemas.vscodeRemote&&!dt.authority&&Nt.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),Ft.ensureDocumentData(dt).then(kt=>kt.document)))},onDidOpenTextDocument:(ge,ye,Ue)=>ut(Ft.onDidAddDocument)(ge,ye,Ue),onDidCloseTextDocument:(ge,ye,Ue)=>ut(Ft.onDidRemoveDocument)(ge,ye,Ue),onDidChangeTextDocument:(ge,ye,Ue)=>ut(Ft.onDidChangeDocument)(ge,ye,Ue),onDidSaveTextDocument:(ge,ye,Ue)=>ut(Ft.onDidSaveDocument)(ge,ye,Ue),onWillSaveTextDocument:(ge,ye,Ue)=>ut(Rn.getOnWillSaveTextDocumentEvent(ze))(ge,ye,Ue),get notebookDocuments(){return Tt.notebookDocuments.map(ge=>ge.apiNotebook)},async openNotebookDocument(ge,ye){let Ue;if(p.URI.isUri(ge))Ue=ge,await Tt.openNotebookDocument(ge);else if(typeof ge=="string")Ue=p.URI.revive(await Tt.createNotebookDocument({viewType:ge,content:ye}));else throw new Error("Invalid arguments");return Tt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(ge,ye,Ue){return ut(Tn.onDidSaveNotebookDocument)(ge,ye,Ue)},onDidChangeNotebookDocument(ge,ye,Ue){return ut(Tn.onDidChangeNotebookDocument)(ge,ye,Ue)},onWillSaveNotebookDocument(ge,ye,Ue){return ut(dn.getOnWillSaveNotebookDocumentEvent(ze))(ge,ye,Ue)},get onDidOpenNotebookDocument(){return ut(Tt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ut(Tt.onDidCloseNotebookDocument)},registerNotebookSerializer(ge,ye,Ue,dt){return Tt.registerNotebookSerializer(ze,ge,ye,Ue,(0,xe.$UG)(ze,"notebookLiveShare")?dt:void 0)},onDidChangeConfiguration:(ge,ye,Ue)=>ut(zn.onDidChangeConfiguration)(ge,ye,Ue),getConfiguration(ge,ye){return ye=arguments.length===1?void 0:ye,zn.getConfiguration(ge,ye,ze)},registerTextDocumentContentProvider(ge,ye){return wn.registerTextDocumentContentProvider(ge,ye)},registerTaskProvider:(ge,ye)=>(Nt.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Jt.registerTaskProvider(ze,ge,ye)),registerFileSystemProvider(ge,ye,Ue){return(0,T.$Rc)(et.registerFileSystemProvider(ze,ge,ye,Ue),tn.addFileSystemProvider(ge,ye,Ue))},get fs(){return tn.value},registerFileSearchProvider:(ge,ye)=>((0,xe.$VG)(ze,"fileSearchProvider"),Vt.registerFileSearchProvider(ge,ye)),registerTextSearchProvider:(ge,ye)=>((0,xe.$VG)(ze,"textSearchProvider"),Vt.registerTextSearchProvider(ge,ye)),registerAITextSearchProvider:(ge,ye)=>((0,xe.$VG)(ze,"aiTextSearchProvider"),(0,xe.$VG)(ze,"textSearchProvider"),Vt.registerAITextSearchProvider(ge,ye)),registerRemoteAuthorityResolver:(ge,ye)=>((0,xe.$VG)(ze,"resolvers"),qt.registerRemoteAuthorityResolver(ge,ye)),registerResourceLabelFormatter:ge=>((0,xe.$VG)(ze,"resolvers"),Vn.$registerResourceLabelFormatter(ge)),getRemoteExecServer:ge=>((0,xe.$VG)(ze,"resolvers"),qt.getRemoteExecServer(ge)),onDidCreateFiles:(ge,ye,Ue)=>ut(Ke.onDidCreateFile)(ge,ye,Ue),onDidDeleteFiles:(ge,ye,Ue)=>ut(Ke.onDidDeleteFile)(ge,ye,Ue),onDidRenameFiles:(ge,ye,Ue)=>ut(Ke.onDidRenameFile)(ge,ye,Ue),onWillCreateFiles:(ge,ye,Ue)=>ut(Ke.getOnWillCreateFileEvent(ze))(ge,ye,Ue),onWillDeleteFiles:(ge,ye,Ue)=>ut(Ke.getOnWillDeleteFileEvent(ze))(ge,ye,Ue),onWillRenameFiles:(ge,ye,Ue)=>ut(Ke.getOnWillRenameFileEvent(ze))(ge,ye,Ue),openTunnel:ge=>((0,xe.$VG)(ze,"tunnels"),jt.openTunnel(ze,ge).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,xe.$VG)(ze,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(ge,ye,Ue)=>((0,xe.$VG)(ze,"tunnels"),ut(jt.onDidChangeTunnels)(ge,ye,Ue)),registerPortAttributesProvider:(ge,ye)=>((0,xe.$VG)(ze,"portsAttributes"),jt.registerPortsAttributesProvider(ge,ye)),registerTunnelProvider:(ge,ye)=>((0,xe.$VG)(ze,"tunnelFactory"),jt.registerTunnelProvider(ge,ye)),registerTimelineProvider:(ge,ye)=>((0,xe.$VG)(ze,"timeline"),wi.registerTimelineProvider(ge,ye,ze.identifier,St.converter)),get isTrusted(){return bt.trusted},requestWorkspaceTrust:ge=>((0,xe.$VG)(ze,"workspaceTrust"),bt.requestWorkspaceTrust(ge)),onDidGrantWorkspaceTrust:(ge,ye,Ue)=>ut(bt.onDidGrantWorkspaceTrust)(ge,ye,Ue),registerEditSessionIdentityProvider:(ge,ye)=>((0,xe.$VG)(ze,"editSessionIdentityProvider"),bt.registerEditSessionIdentityProvider(ge,ye)),onWillCreateEditSessionIdentity:(ge,ye,Ue)=>((0,xe.$VG)(ze,"editSessionIdentityProvider"),ut(bt.getOnWillCreateEditSessionIdentityEvent(ze))(ge,ye,Ue)),registerCanonicalUriProvider:(ge,ye)=>((0,xe.$VG)(ze,"canonicalUriProvider"),bt.registerCanonicalUriProvider(ge,ye)),getCanonicalUri:(ge,ye,Ue)=>((0,xe.$VG)(ze,"canonicalUriProvider"),bt.provideCanonicalUri(ge,ye,Ue))},yn={get inputBox(){return Nt.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ct.getLastInputBox(ze)},createSourceControl(ge,ye,Ue){return Ct.createSourceControl(ze,ge,ye,Ue)}},Bn={createCommentController(ge,ye){return Bt.createCommentController(ze,ge,ye)}},Ei={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){return Dt.activeStackItem},registerDebugVisualizationProvider(ge,ye){return(0,xe.$VG)(ze,"debugVisualization"),Dt.registerDebugVisualizationProvider(ze,ge,ye)},registerDebugVisualizationTreeProvider(ge,ye){return(0,xe.$VG)(ze,"debugVisualization"),Dt.registerDebugVisualizationTree(ze,ge,ye)},onDidStartDebugSession(ge,ye,Ue){return ut(Dt.onDidStartDebugSession)(ge,ye,Ue)},onDidTerminateDebugSession(ge,ye,Ue){return ut(Dt.onDidTerminateDebugSession)(ge,ye,Ue)},onDidChangeActiveDebugSession(ge,ye,Ue){return ut(Dt.onDidChangeActiveDebugSession)(ge,ye,Ue)},onDidReceiveDebugSessionCustomEvent(ge,ye,Ue){return ut(Dt.onDidReceiveDebugSessionCustomEvent)(ge,ye,Ue)},onDidChangeBreakpoints(ge,ye,Ue){return ut(Dt.onDidChangeBreakpoints)(ge,ye,Ue)},onDidChangeActiveStackItem(ge,ye,Ue){return ut(Dt.onDidChangeActiveStackItem)(ge,ye,Ue)},registerDebugConfigurationProvider(ge,ye,Ue){return Dt.registerDebugConfigurationProvider(ge,ye,Ue||_t.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ge,ye){return Dt.registerDebugAdapterDescriptorFactory(ze,ge,ye)},registerDebugAdapterTrackerFactory(ge,ye){return Dt.registerDebugAdapterTrackerFactory(ge,ye)},startDebugging(ge,ye,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Dt.startDebugging(ge,ye,{parentSession:Ue}):Dt.startDebugging(ge,ye,Ue||{})},stopDebugging(ge){return Dt.stopDebugging(ge)},addBreakpoints(ge){return Dt.addBreakpoints(ge)},removeBreakpoints(ge){return Dt.removeBreakpoints(ge)},asDebugSourceUri(ge,ye){return Dt.asDebugSourceUri(ge,ye)}},li={registerTaskProvider:(ge,ye)=>Jt.registerTaskProvider(ze,ge,ye),fetchTasks:ge=>Jt.fetchTasks(ge),executeTask:ge=>Jt.executeTask(ze,ge),get taskExecutions(){return Jt.taskExecutions},onDidStartTask:(ge,ye,Ue)=>ut(Jt.onDidStartTask)(ge,ye,Ue),onDidEndTask:(ge,ye,Ue)=>ut(Jt.onDidEndTask)(ge,ye,Ue),onDidStartTaskProcess:(ge,ye,Ue)=>ut(Jt.onDidStartTaskProcess)(ge,ye,Ue),onDidEndTaskProcess:(ge,ye,Ue)=>ut(Jt.onDidEndTaskProcess)(ge,ye,Ue)},Wn={createNotebookController(ge,ye,Ue,dt,kt){return pn.createNotebookController(ze,ge,ye,Ue,dt,(0,xe.$UG)(ze,"notebookMessaging")?kt:void 0)},registerNotebookCellStatusBarItemProvider:(ge,ye)=>Tt.registerNotebookCellStatusBarItemProvider(ze,ge,ye),createRendererMessaging(ge){return In.createRendererMessaging(ze,ge)},createNotebookControllerDetectionTask(ge){return(0,xe.$VG)(ze,"notebookKernelSource"),pn.createNotebookControllerDetectionTask(ze,ge)},registerKernelSourceActionProvider(ge,ye){return(0,xe.$VG)(ze,"notebookKernelSource"),pn.registerKernelSourceActionProvider(ze,ge,ye)},onDidChangeNotebookCellExecutionState(ge,ye,Ue){return(0,xe.$VG)(ze,"notebookCellExecutionState"),ut(pn.onDidChangeNotebookCellExecutionState)(ge,ye,Ue)}},ui={t(...ge){if(typeof ge[0]=="string"){const ye=ge.shift(),Ue=!ge||typeof ge[0]!="object"?ge:ge[0];return mn.getMessage(ze.identifier.value,{message:ye,args:Ue})}return mn.getMessage(ze.identifier.value,ge[0])},get bundle(){return mn.getBundle(ze.identifier.value)},get uri(){return mn.getBundleUri(ze.identifier.value)}},hi={_version:1,transferActiveChat(ge){return(0,xe.$VG)(ze,"interactive"),Fn.transferActiveChat(ge)}},di={getRelatedInformation(ge,ye){return(0,xe.$VG)(ze,"aiRelatedInformation"),Kn.getRelatedInformation(ze,ge,ye)},registerRelatedInformationProvider(ge,ye){return(0,xe.$VG)(ze,"aiRelatedInformation"),Kn.registerRelatedInformationProvider(ze,ge,ye)},registerEmbeddingVectorProvider(ge,ye){return(0,xe.$VG)(ze,"aiRelatedInformation"),Jn.registerEmbeddingVectorProvider(ze,ge,ye)}},fi={_version:1,registerChatResponseProvider(ge,ye,Ue){return(0,xe.$VG)(ze,"chatProvider"),zt.registerLanguageModel(ze,ge,ye,Ue)},registerChatVariableResolver(ge,ye,Ue,dt,kt,Lt,Cn,mi){return(0,xe.$VG)(ze,"chatVariableResolver"),ei.registerVariableResolver(ze,ge,ye,Ue,dt,kt,Lt,Cn,mi?.id)},registerMappedEditsProvider(ge,ye){return(0,xe.$VG)(ze,"mappedEditsProvider"),We.registerMappedEditsProvider(ze,ge,ye)},createChatParticipant(ge,ye){return Fn.createChatAgent(ze,ge,ye)},createDynamicChatParticipant(ge,ye,Ue){return(0,xe.$VG)(ze,"chatParticipantPrivate"),Fn.createDynamicChatAgent(ze,ge,ye,Ue)},attachContext(ge,ye,Ue){return(0,xe.$VG)(ze,"chatVariableResolver"),ei.attachContext(ge,ye,Ue)}},Si={selectChatModels:ge=>wt.quality==="stable"?(console.warn(`[${A.$Xm.toKey(ze.identifier)}] This API is disabled in '${wt.environment.appName}'-stable.`),Promise.resolve([])):zt.selectLanguageModels(ze,ge??{}),onDidChangeChatModels:(ge,ye,Ue)=>wt.quality==="stable"?(console.warn(`[${A.$Xm.toKey(ze.identifier)}] This API is disabled in '${wt.environment.appName}'-stable.`),P.Event.None(ge,ye,Ue)):zt.onDidChangeProviders(ge,ye,Ue),get embeddingModels(){return(0,xe.$VG)(ze,"embeddings"),Pn.embeddingsModels},onDidChangeEmbeddingModels:(ge,ye,Ue)=>((0,xe.$VG)(ze,"embeddings"),Pn.onDidChange(ge,ye,Ue)),registerEmbeddingsProvider(ge,ye){return(0,xe.$VG)(ze,"embeddings"),Pn.registerEmbeddingsProvider(ze,ge,ye)},async computeEmbeddings(ge,ye,Ue){return(0,xe.$VG)(ze,"embeddings"),Pn.computeEmbeddings(ge,ye,Ue)}},gi={registerSpeechProvider(ge,ye){return(0,xe.$VG)(ze,"speech"),ti.registerProvider(ze.identifier,ge,ye)}};return{version:wt.version,ai:di,authentication:oi,commands:vi,comments:Bn,chat:fi,debug:Ei,env:On,extensions:ci,interactive:hi,l10n:ui,languages:yi,lm:Si,notebooks:Wn,scm:yn,speech:gi,tasks:li,tests:ai,window:Zn,workspace:Qn,Breakpoint:Q.$yN,TerminalOutputAnchor:Q.TerminalOutputAnchor,ChatResultFeedbackKind:Q.ChatResultFeedbackKind,ChatVariableLevel:Q.ChatVariableLevel,ChatCompletionItem:Q.$tO,CallHierarchyIncomingCall:Q.$WM,CallHierarchyItem:Q.$VM,CallHierarchyOutgoingCall:Q.$XM,CancellationError:u.$5,CancellationTokenSource:r.$se,CandidatePortSource:i.CandidatePortSource,CodeAction:Q.$SM,CodeActionKind:Q.$TM,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.$YM,Color:Q.$_M,ColorInformation:Q.$aN,ColorPresentation:Q.$bN,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CommentThreadApplicability:Q.CommentThreadApplicability,CompletionItem:Q.$6M,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.$7M,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.$jN,DebugAdapterExecutable:Q.$CN,DebugAdapterInlineImplementation:Q.$FN,DebugAdapterNamedPipeServer:Q.$EN,DebugAdapterServer:Q.$DN,DebugConfigurationProviderTriggerKind:_t.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DebugVisualization:Q.$VN,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.$LM,DiagnosticRelatedInformation:Q.$KM,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.$xM,DocumentHighlight:Q.$OM,DocumentHighlightKind:Q.DocumentHighlightKind,MultiDocumentHighlight:Q.$PM,DocumentLink:Q.$$M,DocumentSymbol:Q.$RM,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.$IN,InlineValueText:Q.$JN,InlineValueVariableLookup:Q.$KN,InlineValueEvaluatableExpression:Q.$LN,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:P.$he,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.$XN,FileDecoration2:Q.$XN,FileSystemError:Q.$ON,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:Q.$PN,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.$AN,InlineCompletionItem:Q.$8M,InlineCompletionList:Q.$9M,Hover:Q.$MM,VerboseHover:Q.$NM,HoverVerbosityAction:Q.HoverVerbosityAction,IndentAction:D.IndentAction,Location:Q.$JM,MarkdownString:Q.$ZM,OverviewRulerLane:f.OverviewRulerLane,ParameterInformation:Q.$1M,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.$yM,ProcessExecution:Q.$hN,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.$WN,Range:Q.$zM,RelativePattern:Q.$wN,Selection:Q.$AM,SelectionRange:Q.$UM,SemanticTokens:Q.$SN,SemanticTokensBuilder:Q.$RN,SemanticTokensEdit:Q.$TN,SemanticTokensEdits:Q.$UN,SemanticTokensLegend:Q.$QN,ShellExecution:Q.$iN,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.$3M,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.$2M,SnippetString:Q.$IM,SourceBreakpoint:Q.$zN,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.$QM,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.$kN,TaskGroup:Q.$gN,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.$cN,TerminalQuickFixTerminalCommand:Q.$eN,TerminalQuickFixOpener:Q.$dN,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.$fN,TerminalExitReason:Q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.$EM,SnippetTextEdit:Q.$GM,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,SyntaxTokenType:Q.SyntaxTokenType,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.$vN,ThemeIcon:Q.$uN,TreeItem:Q.$lN,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.$hO,UIKind:rn.UIKind,Uri:p.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.$HM,DocumentPasteTriggerKind:Q.DocumentPasteTriggerKind,DocumentDropEdit:Q.$rN,DocumentDropOrPasteEditKind:Q.$sN,DocumentPasteEdit:Q.$tN,InlayHint:Q.$5M,InlayHintLabelPart:Q.$4M,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.$DM,ResolvedAuthority:Q.$BM,ManagedResolvedAuthority:Q.$CM,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.$8N,NotebookRange:Q.$ZN,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.$1N,NotebookData:Q.$2N,NotebookRendererScript:Q.$6N,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.$4N,NotebookCellOutputItem:Q.$3N,NotebookCellStatusBarItem:Q.$5N,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.$FM,NotebookKernelSourceAction:Q.$7N,NotebookVariablesRequestKind:Q.NotebookVariablesRequestKind,PortAttributes:Q.$0N,LinkedEditingRanges:Q.$9N,TestResultState:Q.TestResultState,TestRunRequest:Q.$$N,TestMessage:Q.$_N,TestTag:Q.$aO,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:en.TextSearchCompleteMessageType,DataTransfer:Q.$qN,DataTransferItem:Q.$mN,TestCoverageCount:Q.$bO,FileCoverage:Q.$dO,FileCoverage2:Q.$dO,StatementCoverage:Q.$eO,BranchCoverage:Q.$fO,DeclarationCoverage:Q.$gO,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.$iO,TabInputTextDiff:Q.$jO,TabInputTextMerge:Q.$kO,TabInputCustom:Q.$lO,TabInputNotebook:Q.$nO,TabInputNotebookDiff:Q.$oO,TabInputWebview:Q.$mO,TabInputTerminal:Q.$pO,TabInputInteractiveWindow:Q.$qO,TabInputChat:Q.$rO,TabInputTextMultiDiff:Q.$sO,TelemetryTrustedValue:g.$op,LogLevel:a.LogLevel,EditSessionIdentityMatch:$.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,ChatCopyKind:Q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Q.$GN,DebugThread:Q.$HN,RelatedInformationType:Q.RelatedInformationType,SpeechToTextStatus:Q.SpeechToTextStatus,TextToSpeechStatus:Q.TextToSpeechStatus,PartialAcceptTriggerKind:Q.PartialAcceptTriggerKind,KeywordRecognitionStatus:Q.KeywordRecognitionStatus,ChatResponseMarkdownPart:Q.$uO,ChatResponseFileTreePart:Q.$yO,ChatResponseAnchorPart:Q.$zO,ChatResponseProgressPart:Q.$AO,ChatResponseProgressPart2:Q.$BO,ChatResponseReferencePart:Q.$EO,ChatResponseWarningPart:Q.$CO,ChatResponseTextEditPart:Q.$FO,ChatResponseMarkdownWithVulnerabilitiesPart:Q.$vO,ChatResponseCommandButtonPart:Q.$DO,ChatResponseDetectedParticipantPart:Q.$wO,ChatResponseConfirmationPart:Q.$xO,ChatRequestTurn:Q.$GO,ChatResponseTurn:Q.$HO,ChatLocation:Q.ChatLocation,LanguageModelChatMessageRole:Q.LanguageModelChatMessageRole,LanguageModelChatMessage:Q.$IO,LanguageModelChatMessage2:Q.$IO,LanguageModelChatSystemMessage:Q.$JO,LanguageModelChatUserMessage:Q.$KO,LanguageModelChatAssistantMessage:Q.$LO,LanguageModelError:Q.$MO,NewSymbolName:Q.$NN,NewSymbolNameTag:Q.NewSymbolNameTag,NewSymbolNameTriggerKind:Q.NewSymbolNameTriggerKind,InlineEdit:Q.$NO,InlineEditTriggerKind:Q.InlineEditTriggerKind}}}}),define(Ee[394],Se([1,0,89,168,42,162,48,37,78,47,100,101,102,126,76,96,161,75,63,125,95,77,160,12,64,123,124,128,129,166]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n,t,c,h,s,m,y,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Gs)(s.$Nnc,s.$Mnc,r.InstantiationType.Delayed),(0,r.$Gs)(c.$8j,t.$1oc,r.InstantiationType.Delayed),(0,r.$Gs)(a.$Smc,a.$Tmc,r.InstantiationType.Delayed),(0,r.$Gs)(R.$jP,R.$iP,r.InstantiationType.Eager),(0,r.$Gs)(y.$3mc,y.$4mc,r.InstantiationType.Eager),(0,r.$Gs)(S.$Hnc,S.$Inc,r.InstantiationType.Eager),(0,r.$Gs)(L.$fnc,L.$dnc,r.InstantiationType.Eager),(0,r.$Gs)(g.$hnc,g.$gnc,r.InstantiationType.Eager),(0,r.$Gs)(D.$Xnc,D.$2nc,r.InstantiationType.Eager),(0,r.$Gs)(T.$4nc,T.$3nc,r.InstantiationType.Eager),(0,r.$Gs)(p.$$O,p.$0O,r.InstantiationType.Eager),(0,r.$Gs)(m.$Onc,m.$Pnc,r.InstantiationType.Eager),(0,r.$Gs)($.$Wmc,$.$Vmc,r.InstantiationType.Eager),(0,r.$Gs)(u.$woc,u.$voc,r.InstantiationType.Delayed),(0,r.$Gs)(f.$hoc,f.$ioc,r.InstantiationType.Eager),(0,r.$Gs)(A.$Anc,A.$znc,r.InstantiationType.Eager),(0,r.$Gs)(I.$Joc,I.$Ioc,r.InstantiationType.Eager),(0,r.$Gs)(l.$Dnc,l.$Gnc,r.InstantiationType.Eager),(0,r.$Gs)(E.$Koc,E.$Loc,r.InstantiationType.Eager),(0,r.$Gs)(w.$wEb,w.$xEb,r.InstantiationType.Eager),(0,r.$Gs)(d.$Yoc,d.$Xoc,r.InstantiationType.Eager),(0,r.$Gs)(P.$cnc,P.$bnc,r.InstantiationType.Eager),(0,r.$Gs)(i.$Knc,i.$Jnc,r.InstantiationType.Eager),(0,r.$Gs)(o.$hP,o.$eP,r.InstantiationType.Eager),(0,r.$Gs)(n.$rnc,n.$snc,r.InstantiationType.Eager),(0,r.$Gs)(h.$Vnc,h.$Wnc,r.InstantiationType.Eager)}),define(Ee[130],Se([1,0,19,12,38,99]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gpc=void 0,e.$epc=L,e.$fpc=R;function L(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}function R(D,f,A,w){const a=(0,r.$1b)(A,p),d=new P.$NK(f,a,w),g=d.preview.matches;return{ranges:(0,r.$1b)(a,l),uri:D,preview:{text:d.preview.text,matches:(0,r.$1b)(g,l)}}}function p(D){return new P.$OK(D.start.line,D.start.character,D.end.line,D.end.character)}function l(D){return new T.$CK(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let I=class{constructor(f,A){this.a=f,this.b=A}appendLine(f){this.b.debug(`${this.a}#search`,f)}};e.$gpc=I,e.$gpc=I=Ze([Ve(1,u.$7j)],I)}),define(Ee[395],Se([1,0,57,16,82,32,11,13,130,396]),function(oe,e,r,u,P,T,L,R,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hpc=D,e.$ipc=d,e.$jpc=$;const I=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(i,o,n,t){const c=f(i,o,n,t),h=o.folder.fsPath;return{cmd:r.spawn(I,c.args,{cwd:h}),rgDiskPath:I,siblingClauses:c.siblingClauses,rgArgs:c,cwd:h}}function f(i,o,n,t){const c=["--files","--hidden","--case-sensitive","--no-require-git"];w([o],n,!1).forEach(s=>{const m=(0,p.$epc)(s);if(c.push("-g",m),L.$d){const y=(0,P.$im)(m);y!==m&&c.push("-g",y)}});const h=A([o],t,void 0,!1);return h.globArgs.forEach(s=>{const m=`!${(0,p.$epc)(s)}`;if(c.push("-g",m),L.$d){const y=(0,P.$im)(m);y!==m&&c.push("-g",y)}}),o.disregardIgnoreFiles!==!1?c.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&c.push("--no-ignore-parent"),o.ignoreSymlinks||c.push("--follow"),i.exists&&c.push("--quiet"),c.push("--no-config"),o.disregardGlobalIgnoreFiles&&c.push("--no-ignore-global"),{args:c,siblingClauses:h.siblingClauses}}function A(i,o,n,t=!0){const c=[];let h={};return i.forEach(s=>{const m=Object.assign({},s.excludePattern||{},o||{}),y=a(m,t?s.folder.fsPath:void 0,n);c.push(...y.globArgs),y.siblingClauses&&(h=Object.assign(h,y.siblingClauses))}),{globArgs:c,siblingClauses:h}}function w(i,o,n=!0){const t=[];return i.forEach(c=>{const h=Object.assign({},o||{},c.includePattern||{}),s=a(h,n?c.folder.fsPath:void 0);t.push(...s.globArgs)}),t}function a(i,o,n){const t=[],c={};return Object.keys(i).forEach(h=>{if(n&&n.has(h)||!h)return;const s=i[h];h=g(o?d(o,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof s=="boolean"&&s?(h.startsWith("\\\\")&&(h+="**"),t.push($(h))):s&&s.when&&(c[h]=s)}),{globArgs:t,siblingClauses:c}}function d(i,o){return u.$ic(o)?o:u.$jc(i,o)}function g(i){return i=R.$jf(i,"\\"),R.$jf(i,"/")}function $(i){return T.$vg(i).toLowerCase()==="c:/"?i.replace(/^c:[/\\]/i,"/"):i}}),define(Ee[397],Se([1,0,57,56,16,398,19,51,39,82,32,11,43,13,18,34,38,395,137]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=e.$kpc=void 0;const i=new Set;process.on("exit",()=>{i.forEach(h=>h())});class o{constructor(s){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=s,this.b=s.filePattern||"",this.d=s.includePattern&&p.$uk(s.includePattern),this.f=s.maxResults||null,this.g=!!s.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=s.shouldGlobMatchFilePattern?null:(0,$.$Gr)(this.b).normalizedLowercase),this.u=s.excludePattern&&p.$uk(s.excludePattern),this.t=new Map,s.folderQueries.forEach(m=>{const y=Object.assign({},m.excludePattern||{},this.a.excludePattern||{}),S=m.folder.fsPath;s.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==S).forEach(E=>{(0,I.$zg)(E,S)&&(y[P.$lc(S,E)]=!0)}),this.t.set(S,new t(y,S))})}cancel(){this.l=!0,i.forEach(s=>s())}walk(s,m,y,S,E){if(this.m=f.$be.create(!1),this.l)return E(null,this.j);m.forEach(k=>{const C=P.$nc(k.fsPath);this.u&&this.u(k.fsPath,C)||this.J(y,{relativePath:k.fsPath,searchPath:void 0})}),this.r=f.$be.create(!1),this.w(s,(k,C)=>{this.x(this.y,this,k,y,S,v=>{if(v){const b=(0,R.$lj)(v);console.error(b),this.q.push(b),C(v,void 0)}else C(null,void 0)})},(k,C)=>{this.m.stop();const v=k?L.$Hb(k)[0]:null;E(v,this.j)})}w(s,m,y){const S=new Array(s.length),E=new Array(s.length);let k=!1,C=0;if(s.length===0)return y(null,[]);s.forEach((v,b)=>{m(v,(O,U)=>{if(O?(k=!0,S[b]=null,E[b]=O):(S[b]=U,E[b]=null),++C===s.length)return y(k?E:null,S)})})}x(s,m,...y){try{s.apply(m,y)}catch(S){y[y.length-1](S)}}y(s,m,y,S){const E=s.folder.fsPath,k=D.$d,C=()=>z&&z.kill();i.add(C);let v=F=>{i.delete(C),v=()=>{},S(F)},b="";const O=this.D(),U=(0,g.$hpc)(this.a,s,this.a.includePattern,this.t.get(s.folder.fsPath).expression),z=U.cmd,j=!Object.keys(U.siblingClauses).length,M=U.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let N=`${U.rgDiskPath} ${M}
 - cwd: ${U.cwd}`;U.rgArgs.siblingClauses&&(N+=`
 - Sibling clauses: ${JSON.stringify(U.rgArgs.siblingClauses)}`),y({message:N}),this.s=0,this.z(z,"utf8",y,(F,X,se)=>{if(F){v(F);return}if(this.j){v();return}const H=(b+(k?l.$hm(X||""):X)).split(`
`);if(se){const V=H.length;H[V-1]=H[V-1].trim(),H[V-1]||H.pop()}else b=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){v(new Error("Splitting up files failed"));return}if(this.s+=H.length,j){for(const V of H)if(this.J(m,{base:E,relativePath:V,searchPath:this.N(s,V)}),this.j){C();break}(se||this.j)&&v();return}this.G(s,O,E,H,m),se&&(this.H(O,E,m),v())})}spawnFindCmd(s){const m=this.t.get(s.folder.fsPath),y=m.getBasenameTerms(),S=m.getPathTerms(),E=["-L","."];if(y.length||S.length){E.push("-not","(","(");for(const k of y)E.push("-name",k),E.push("-o");for(const k of S)E.push("-path",k),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),r.spawn("find",E,{cwd:s.folder.fsPath})}readStdout(s,m,y){let S="";this.z(s,m,()=>{},(E,k,C)=>{if(E){y(E);return}S+=k,C&&y(null,S)})}z(s,m,y,S){let E=(v,b,O)=>{(v||O)&&(E=()=>{},this.r?.stop()),S(v,b,O)},k=!1;s.stdout?(this.A(s.stdout,m,E),s.stdout.once("data",()=>k=!0)):y({message:"stdout is null"});let C;s.stderr?C=this.B(s.stderr):y({message:"stderr is null"}),s.on("error",v=>{E(v)}),s.on("close",v=>{let b;!k&&(b=this.C(C,m))&&c(b)?E(new Error(`command failed with error code ${v}: ${this.C(C,m)}`)):(this.g&&v===0&&(this.j=!0),E(null,"",!0))})}A(s,m,y){const S=new T.StringDecoder(m);return s.on("data",E=>{y(null,S.write(E))}),S}B(s){const m=[];return s.on("data",y=>{m.push(y)}),m}C(s,m){const y=new T.StringDecoder(m);return s.map(S=>y.write(S)).join("")}D(){const s={rootEntries:[],pathToEntries:Object.create(null)};return s.pathToEntries["."]=s.rootEntries,s}G(s,{pathToEntries:m},y,S,E){S.indexOf(this.b)!==-1&&this.J(E,{base:y,relativePath:this.b,searchPath:this.N(s,this.b)});const k=C=>{const v=P.$nc(C),b=P.$mc(C);let O=m[b];O||(O=m[b]=[],k(b)),O.push({base:y,relativePath:C,basename:v,searchPath:this.N(s,C)})};S.forEach(k)}H({rootEntries:s,pathToEntries:m},y,S){const E=this,k=this.t.get(y),C=this.b;function v(b){E.o++;const O=(0,d.$4K)(()=>b.map(U=>U.basename));for(let U=0,z=b.length;U<z;U++){const j=b[U],{relativePath:M,basename:N}=j;if(k.test(M,N,C!==N?O:void 0))continue;const F=m[M];if(F)v(F);else{if(E.p++,M===C)continue;E.J(S,j)}if(E.j)break}}v(s)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(s,m,y,S,E){const k=s.folder,C=(0,d.$4K)(()=>y);this.w(y,(v,b)=>{if(this.l||this.j)return b(null);const O=m?[m,v].join(P.sep):v;if(this.t.get(s.folder.fsPath).test(O,v,this.a.filePattern!==v?C:void 0))return b(null);const U=[k.fsPath,O].join(P.sep);u.lstat(U,(z,j)=>{if(z||this.l||this.j)return b(null);this.L(U,j,(M,N)=>M||this.l||this.j?b(null):N.isDirectory()?(this.o++,this.M(U,j,(F,X)=>F||this.l||this.j||(X=X||"",this.v[X])?b(null):(this.v[X]=!0,a.Promises.readdir(U).then(se=>{if(this.l||this.j)return b(null);this.I(s,O,se,S,W=>b(W||null))},se=>{b(null)})))):(this.p++,O===this.b||this.h&&w.$eg(N.size)&&N.size>this.h||this.J(S,{base:k.fsPath,relativePath:O,searchPath:this.N(s,O)}),b(null,void 0)))})},v=>{const b=v&&L.$Hb(v);return E(b&&b.length>0?b[0]:void 0)})}J(s,m){this.K(m)&&(!this.d||this.d(m.relativePath,P.$nc(m.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||s(m))}K(s){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.$YK)(s,this.c);if(this.b)return(0,d.$YK)(s,this.b,!1)}return!0}L(s,m,y){return m.isSymbolicLink()?u.stat(s,y):y(null,m)}M(s,m,y){return m.isSymbolicLink()?u.realpath(s,(S,E)=>S?y(S):y(null,E)):y(null,s)}N(s,m){return s.folderName?P.$jc(s.folderName,m):m}}e.$kpc=o;class n{constructor(s){this.a=s.folderQueries,this.b=s.extraFileResources||[],this.c=new o(s)}search(s,m,y){this.c.walk(this.a,this.b,s,m,(S,E)=>{y(S,{limitHit:E,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$lpc=n;class t{constructor(s,m){this.expression=s,this.c=m,this.d(s)}d(s){let m,y;Object.keys(s).filter(S=>s[S]).forEach(S=>{P.$ic(S)?(m=m||p.$pk(),m[S]=s[S]):(y=y||p.$pk(),y[S]=s[S])}),this.a=m&&p.$uk(m,{trimForExclusions:!0}),this.b=y&&p.$uk(y,{trimForExclusions:!0})}test(s,m,y){return this.b&&this.b(s,m,y)||this.a&&this.a(P.$jc(this.c,s),m,y)}getBasenameTerms(){const s=[];return this.a&&s.push(...p.$wk(this.a)),this.b&&s.push(...p.$wk(this.b)),s}getPathTerms(){const s=[];return this.a&&s.push(...p.$xk(this.a)),this.b&&s.push(...p.$xk(this.b)),s}}function c(h){const s=h.trim().split(`
`),m=s[0].trim();if(m.startsWith("Error parsing regex"))return m;if(m.startsWith("regex parse error"))return A.$5f(s[s.length-1].trim());if(m.startsWith("error parsing glob")||m.startsWith("unsupported encoding"))return m.charAt(0).toUpperCase()+m.substr(1);if(m==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(m.startsWith("Literal "))return m}}),define(Ee[399],Se([1,0,105,22,187,21]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yE=e.$qE=e.DecodeStreamErrorKind=e.$pE=e.$oE=e.$nE=e.$lE=e.$kE=e.$jE=e.$iE=void 0,e.$mE=L,e.$rE=w,e.$sE=a,e.$tE=d,e.$uE=g,e.$vE=$,e.$wE=h,e.$xE=s,e.$iE="utf8",e.$jE="utf8bom",e.$kE="utf16be",e.$lE="utf16le";function L(m){return[e.$iE,e.$jE,e.$kE,e.$lE].some(y=>y===m)}e.$nE=[254,255],e.$oE=[255,254],e.$pE=[239,187,191];const R=512,p=512,l=512*8,I=512*128;var D;(function(m){m[m.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D||(e.DecodeStreamErrorKind=D={}));class f extends Error{constructor(y,S){super(y),this.decodeStreamErrorKind=S}}e.$qE=f;class A{static async create(y){let S;if(y!==e.$iE)S=(await(0,P.$hE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(g(y));else{const E=new TextDecoder;S={write(k){return E.decode(k,{stream:!0})},end(){return E.decode()}}}return new A(S)}constructor(y){this.a=y}write(y){return this.a.write(y)}end(){return this.a.end()}}function w(m,y){const S=y.minBytesRequiredForDetection??y.guessEncoding?l:p;return new Promise((E,k)=>{const C=(0,r.$xe)(j=>j.join("")),v=[];let b=0,O;const U=new T.$se,z=async()=>{try{const j=await s({buffer:u.$Je.concat(v),bytesRead:b},y.guessEncoding);if(j.seemsBinary&&y.acceptTextOnly)throw new f("Stream is binary but only text is accepted for decoding",D.STREAM_IS_BINARY);j.encoding=await y.overwriteEncoding(j.encoding),O=await A.create(j.encoding);const M=O.write(u.$Je.concat(v).buffer);C.write(M),v.length=0,b=0,E({stream:C,detected:j})}catch(j){U.cancel(),C.destroy(),k(j)}};(0,r.$Be)(m,{onData:async j=>{O?C.write(O.write(j.buffer)):(v.push(j),b+=j.byteLength,b>=S&&(m.pause(),await z(),setTimeout(()=>m.resume())))},onError:j=>C.error(j),onEnd:async()=>{O||await z(),C.end(O?.end())}},U.token)})}async function a(m,y,S){const k=(await(0,P.$hE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(g(y),S);let C=!1,v=!1;return{read(){if(v)return null;const b=m.read();if(typeof b!="string"){if(v=!0,!C&&S?.addBOM)switch(y){case e.$iE:case e.$jE:return u.$Je.wrap(Uint8Array.from(e.$pE));case e.$kE:return u.$Je.wrap(Uint8Array.from(e.$nE));case e.$lE:return u.$Je.wrap(Uint8Array.from(e.$oE))}const O=k.end();return O&&O.length>0?(C=!0,u.$Je.wrap(O)):null}return C=!0,u.$Je.wrap(k.write(b))}}}async function d(m){return(await(0,P.$hE)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(g(m))}function g(m){return m===e.$jE||m===null?e.$iE:m}function $(m,y){if(!m||y<e.$nE.length)return null;const S=m.readUInt8(0),E=m.readUInt8(1);if(S===e.$nE[0]&&E===e.$nE[1])return e.$kE;if(S===e.$oE[0]&&E===e.$oE[1])return e.$lE;if(y<e.$pE.length)return null;const k=m.readUInt8(2);return S===e.$pE[0]&&E===e.$pE[1]&&k===e.$pE[2]?e.$jE:null}const i=["ascii","utf-16","utf-32"];async function o(m){const y=await(0,P.$hE)("jschardet","dist/jschardet.min.js"),S=m.slice(0,I),E=c(S.buffer),k=y.detect(E);if(!k||!k.encoding)return null;const C=k.encoding.toLowerCase();return 0<=i.indexOf(C)?null:t(k.encoding)}const n={ibm866:"cp866",big5:"cp950"};function t(m){const y=m.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return n[y]||y}function c(m){let y="";for(let S=0;S<m.length;S++)y+=String.fromCharCode(m[S]);return y}function h(m){switch(m){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const y=m.match(/windows(\d+)/);return y?"windows-"+y[1]:m}}}function s({buffer:m,bytesRead:y},S){let E=$(m,y),k=!1;if(E!==e.$kE&&E!==e.$lE&&m){let C=!0,v=!0,b=!1;for(let O=0;O<y&&O<R;O++){const U=O%2===1,z=m.readUInt8(O)===0;if(z&&(b=!0),C&&(U&&!z||!U&&z)&&(C=!1),v&&(U&&z||!U&&!z)&&(v=!1),z&&!C&&!v)break}b&&(C?E=e.$lE:v?E=e.$kE:k=!0)}return S&&!k&&!E&&m?o(m.slice(0,y)).then(C=>({seemsBinary:!1,encoding:C})):{seemsBinary:k,encoding:E}}e.$yE={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ee[171],Se([1,0,399,34,170]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=void 0;class T extends P.$doc{constructor(R,p,l=u,I="searchProcess"){super({query:R,provider:p},{readdir:D=>l.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,r.$wE)(D)},I)}}e.$tpc=T}),define(Ee[172],Se([1,0,57,415,398,19,79,39,13,2,38,99,416,396,130]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$npc=e.$mpc=void 0,e.$opc=t,e.$ppc=h,e.$qpc=m,e.$rpc=y,e.$spc=E;const a=A.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(C){this.a=C}provideTextSearchResults(C,v,b,O){return this.a.appendLine(`provideTextSearchResults ${C.pattern}, ${JSON.stringify({...v,folder:v.folder.toString()})}`),new Promise((U,z)=>{O.onCancellationRequested(()=>H());const j=t(C,v),M=v.folder.fsPath,N=j.map(we=>we.match(/^-/)?we:`'${we}'`).join(" ");this.a.appendLine(`${a} ${N}
 - cwd: ${M}`);let F=r.spawn(a,j,{cwd:M});F.on("error",we=>{console.error(we),this.a.appendLine("Error: "+(we&&we.message)),z((0,I.$UK)(new I.$SK(we&&we.message,I.SearchErrorCode.rgProcessError)))});let X=!1;const se=new i(v.maxResults,v.folder,v.previewOptions);se.on("result",we=>{X=!0,x="",b.report(we)});let W=!1;const H=()=>{W=!0,F?.kill(),se?.cancel()};let V=!1;se.on("hitLimit",()=>{V=!0,H()});let x="";F.stdout.on("data",we=>{se.handleData(we),X||(x+=we)});let he=!1;F.stdout.once("data",()=>he=!0);let ne="";F.stderr.on("data",we=>{const pe=we.toString();this.a.appendLine(pe),ne.length+pe.length<1e6&&(ne+=pe)}),F.on("close",()=>{if(this.a.appendLine(he?"Got data from stdout":"No data from stdout"),this.a.appendLine(X?"Got result from parser":"No result from parser"),x&&this.a.appendLine(`Got data without result: ${x}`),this.a.appendLine(""),W)U({limitHit:V});else{se.flush(),F=null;let we;ne&&!he&&(we=g(ne))?z((0,I.$UK)(new I.$SK(we.message,we.code))):U({limitHit:V})}})})}}e.$mpc=d;function g(k){const C=k.split(`
`),v=C[0].trim();if(C.some(O=>O.startsWith("regex parse error")))return new I.$SK($(C),I.SearchErrorCode.regexParseError);const b=v.match(/grep config error: unknown encoding: (.*)/);if(b)return new I.$SK(`Unknown encoding: ${b[1]}`,I.SearchErrorCode.unknownEncoding);if(v.startsWith("error parsing glob"))return new I.$SK(v.charAt(0).toUpperCase()+v.substr(1),I.SearchErrorCode.globParseError);if(v.startsWith("the literal"))return new I.$SK(v.charAt(0).toUpperCase()+v.substr(1),I.SearchErrorCode.invalidLiteral);if(v.startsWith("PCRE2: error compiling pattern"))return new I.$SK(v,I.SearchErrorCode.regexParseError)}function $(k){const C=["Regex parse error"],v=k.filter(b=>b.startsWith("PCRE2:"));if(v.length>=1){const b=v[0].replace("PCRE2:","");if(b.indexOf(":")!==-1&&b.split(":").length>=2){const O=b.split(":")[1];C.push(":"+O)}}return C.join("")}class i extends u.EventEmitter{constructor(C,v,b){super(),this.g=C,this.h=v,this.j=b,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new P.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(C,v){return super.on(C,v),this}handleData(C){if(this.b)return;const v=typeof C=="string"?C:this.d.write(C);this.k(v)}k(C){let v=C.indexOf(`
`);const b=this.a+C;if(v>=0)v+=this.a.length;else{this.a=b;return}let O=0;for(;v>=0;)this.m(b.substring(O,v).trim()),O=v+1,v=b.indexOf(`
`,O);this.a=b.substring(O)}m(C){if(this.b||!C)return;let v;try{v=JSON.parse(C)}catch{throw new Error(`malformed line from rg: ${C}`)}if(v.type==="match"){const b=o(v.data.path),O=l.URI.joinPath(this.h,b),U=this.n(v.data,O);this.p(U),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(v.type==="context"){const b=o(v.data.path),O=l.URI.joinPath(this.h,b);this.o(v.data,O).forEach(z=>this.p(z))}}n(C,v){const b=C.line_number-1,O=o(C.lines),U=Buffer.from(O);let z=0,j=0,M=b;C.submatches.length===0&&C.submatches.push(O.length?{start:0,end:1,match:{text:O[0]}}:{start:0,end:0,match:{text:""}});const N=(0,T.$Hb)(C.submatches.map((F,X)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const se=o(F.match),W=U.slice(z,F.start).toString(),H=n(W),V=H.numLines>0?H.lastLineLength:H.lastLineLength+j,x=n(se),he=H.numLines+M,ne=x.numLines+he,we=x.numLines>0?x.lastLineLength:x.lastLineLength+V;return z=F.end,j=we,M=ne,new D.$CK(he,V,ne,we)}));return(0,w.$fpc)(v,O,N,this.j)}o(C,v){const b=o(C.lines),O=C.line_number;return b.replace(/\r?\n$/,"").split(`
`).map((U,z)=>({text:U,uri:v,lineNumber:O+z}))}p(C){this.emit("result",C)}}e.$npc=i;function o(k){return k.bytes?Buffer.from(k.bytes,"base64").toString():k.text}function n(k){const C=/\n/g;let v=0,b=-1,O;for(;O=C.exec(k);)v++,b=O.index;const U=b>=0?k.length-b-1:k.length;return{numLines:v,lastLineLength:U}}function t(k,C){const v=["--hidden","--no-require-git"];v.push(k.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:b,otherIncludes:O}=(0,L.$E)(C.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const z=new Set;O.forEach(j=>{z.add(j)}),v.push("-g","!*"),z.forEach(j=>{c(j).map(w.$epc).forEach(M=>{v.push("-g",M)})})}b&&b.length&&b.forEach(z=>{v.push("-g",z)}),C.excludes.map(w.$epc).forEach(z=>v.push("-g",`!${z}`)),C.maxFileSize&&v.push("--max-filesize",C.maxFileSize+""),C.useIgnoreFiles?C.useParentIgnoreFiles||v.push("--no-ignore-parent"):v.push("--no-ignore"),C.followSymlinks&&v.push("--follow"),C.encoding&&C.encoding!=="utf8"&&v.push("--encoding",C.encoding),k.pattern==="--"&&(k.isRegExp=!0,k.pattern="\\-\\-"),k.isMultiline&&!k.isRegExp&&(k.pattern=(0,p.$df)(k.pattern),k.isRegExp=!0),C.usePCRE2&&v.push("--pcre2"),v.push("--crlf"),k.isRegExp&&(k.pattern=h(k.pattern),v.push("--engine","auto"));let U;if(k.isWordMatch){const j=(0,p.$mf)(k.pattern,!!k.isRegExp,{wholeWord:k.isWordMatch}).source.replace(/\\\//g,"/");v.push("--regexp",j)}else if(k.isRegExp){let z=m(k.pattern);z=y(z),v.push("--regexp",z)}else U=k.pattern,v.push("--fixed-strings");return v.push("--no-config"),C.useGlobalIgnoreFiles||v.push("--no-ignore-global"),v.push("--json"),k.isMultiline&&v.push("--multiline"),C.beforeContext&&v.push("--before-context",C.beforeContext+""),C.afterContext&&v.push("--after-context",C.afterContext+""),v.push("--"),U&&v.push(U),v.push("."),v}function c(k){return E(k).flatMap(v=>{const b=(0,R.$sk)(v,"/");return b.map((O,U)=>b.slice(0,U+1).join("/"))})}function h(k){const C=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;k.match(C);)k=k.replace(C,"$1\\x{$2}");const v=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;k.match(v);)k=k.replace(v,"$1\\x{$2}");return k}const s=k=>k.type==="Assertion"&&k.kind==="lookbehind";function m(k){let C;try{C=new f.RegExpParser().parsePattern(k)}catch{return k}let v="",b=0;const O=(j,M,N)=>{v+=k.slice(b,j)+N,b=M},U=[];return new f.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const M=U[0];if(!M)O(j.start,j.end,"\\r?\\n");else if(!U.some(s))if(M.type==="CharacterClass")if(M.negate){const N=k.slice(M.start+2,j.start)+k.slice(j.end,M.end-1);M.parent?.type==="Quantifier"?O(M.start,M.end,N?`[^${N}]`:"."):O(M.start,M.end,"(?!\\r?\\n"+(N?`|[${N}]`:"")+")")}else{const N=k.slice(M.start+1,j.start)+k.slice(j.end,M.end-1);O(M.start,M.end,N===""?"\\r?\\n":`(?:[${N}]|\\r?\\n)`)}else M.type==="Quantifier"&&O(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){U.unshift(j)},onQuantifierLeave(){U.shift()},onCharacterClassRangeEnter(j){U.unshift(j)},onCharacterClassRangeLeave(){U.shift()},onCharacterClassEnter(j){U.unshift(j)},onCharacterClassLeave(){U.shift()},onAssertionEnter(j){s(j)&&U.push(j)},onAssertionLeave(j){U[0]===j&&U.shift()}}).visit(C),v+=k.slice(b),v}function y(k){return k.replace(/\n/g,"\\r?\\n")}function S(k){let C=!1,v=!1,b="",O="";for(let U=0;U<k.length;U++){const z=k[U];switch(z){case"\\":v?(C?O+="\\"+z:b+="\\"+z,v=!1):v=!0;break;case"{":if(v)C?O+=z:b+=z,v=!1;else{if(C)return{strInBraces:b+"{"+O+"{"+k.substring(U+1)};C=!0}break;case"}":if(v)C?O+=z:b+=z,v=!1;else{if(C)return{fixedStart:b,strInBraces:O,fixedEnd:k.substring(U+1)};b+=z}break;default:C?O+=(v?"\\":"")+z:b+=(v?"\\":"")+z,v=!1;break}}return{strInBraces:b+(C?"{"+O:"")}}function E(k){const{fixedStart:C,strInBraces:v,fixedEnd:b}=S(k);if(C===void 0||b===void 0)return[v];let O=(0,R.$sk)(v,",");O.length||(O=[""]);const U=E(b);return O.flatMap(z=>{const j=C+z;return U.map(M=>j+M)})}}),define(Ee[400],Se([1,0,21,172,90,15]),function(oe,e,r,u,P,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=void 0;class L{constructor(l){this.b=l,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(l,I,D,f){const A=new u.$mpc(this.b);if(I.folder.scheme===T.Schemas.vscodeUserData){const w={...I,folder:I.folder.with({scheme:T.Schemas.file})},a=new P.$nw(d=>D.report({...d,uri:d.uri.with({scheme:I.folder.scheme})}));return this.c(f,d=>A.provideTextSearchResults(l,w,a,d))}else return this.c(f,w=>A.provideTextSearchResults(l,I,D,w))}async c(l,I){const D=R(l);this.a.add(D);const f=await I(D.token);return this.a.delete(D),f}d(){this.a.forEach(l=>l.cancel())}}e.$wpc=L;function R(p){const l=new r.$se;return p.onCancellationRequested(()=>l.cancel()),l}}),define(Ee[401],Se([1,0,34,172,171]),function(oe,e,r,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=void 0;class T{constructor(p){this.a=p}search(p,l,I){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"},messages:[]});const D={appendLine(A){I({message:A})}},f=new P.$tpc(this.a,new u.$mpc(D),r);return new Promise((A,w)=>f.search(a=>{l(a.map(L))},p).then(a=>A({limitHit:a.limitHit??!1,type:"success",stats:a.stats,messages:[]}),w))}}e.$upc=T;function L(R){return{path:R.resource&&R.resource.fsPath,results:R.results,numMatches:(R.results||[]).reduce((p,l)=>{if(l.ranges){const I=l;return p+(Array.isArray(I.ranges)?I.ranges.length:1)}else return p+1},0)}}}),define(Ee[402],Se([1,0,19,7,14,4,137,16,43,2,28,38,397,401]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpc=void 0;class w{constructor(o="searchProcess"){this.d=o,this.b=Object.create(null)}fileSearch(o){let n;const t=g(o),c=new T.$he({onDidAddFirstListener:()=>{n=(0,u.$nh)(h=>this.doFileSearchWithEngine(f.$lpc,t,s=>c.fire(s),h)),n.then(h=>c.fire(h),h=>c.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{n.cancel()}});return c.event}textSearch(o){let n;const t=g(o),c=new T.$he({onDidAddFirstListener:()=>{n=(0,u.$nh)(h=>this.f(t,s=>c.fire(s),h)),n.then(h=>c.fire(h),h=>c.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{n.cancel()}});return c.event}f(o,n,t){return o.maxFileSize=this.g().maxFileSize,new A.$upc(o).search(t,n,n)}g(){return{maxFileSize:16*I.$Cl.GB}}doFileSearch(o,n,t){return this.doFileSearchWithEngine(f.$lpc,o,n,t)}doFileSearchWithEngine(o,n,t,c,h=w.a){let s=0;const m=S=>{Array.isArray(S)?(s+=S.length,t(S.map(E=>this.h(E)))):S.relativePath?(s++,t(this.h(S))):t(S)};if(n.sortByScore){let S=this.l(n,m,c);if(!S){const E=n.maxResults?Object.assign({},n,{maxResults:null}):n,k=new o(E);S=this.j(k,n,t,m,c)}return new Promise((E,k)=>{S.then(([C,v])=>{const b=v.map(O=>this.h(O));this.o(b,t,h),E(C)},k)})}const y=new o(n);return this.r(y,m,h,c).then(S=>({limitHit:S.limitHit,type:"success",stats:{detailStats:S.stats,type:this.d,fromCache:!1,resultCount:s,sortingTime:void 0},messages:[]}))}h(o){return{path:o.base?(0,R.$jc)(o.base,o.relativePath):o.relativePath}}j(o,n,t,c,h){const s=new T.$he;let m=(0,u.$nh)(S=>{let E=[];const k=C=>{Array.isArray(C)?E=C:(c(C),s.fire(C))};return this.r(o,k,-1,S).then(C=>[C,E])}),y;if(n.cacheKey){y=this.k(n.cacheKey);const S={promise:m,event:s.event,resolved:!1};y.resultsToSearchCache[n.filePattern||""]=S,m.then(()=>{S.resolved=!0},E=>{delete y.resultsToSearchCache[n.filePattern||""]}),m=this.s(m)}return m.then(([S,E])=>{const k=y?y.scorerCache:Object.create(null),C=(typeof n.maxResults!="number"||n.maxResults>0)&&p.$be.create(!1);return this.n(n,E,k,h).then(v=>{const b=C?C.elapsed():-1;return[{type:"success",stats:{detailStats:S.stats,sortingTime:b,fromCache:!1,type:this.d,resultCount:v.length},messages:S.messages,limitHit:S.limitHit||typeof n.maxResults=="number"&&E.length>n.maxResults},v]})})}k(o){const n=this.b[o];return n||(this.b[o]=new a)}l(o,n,t){const c=o.cacheKey&&this.b[o.cacheKey];if(!c)return;const h=this.q(c,o.filePattern||"",n,t);if(h)return h.then(([s,m,y])=>{const S=p.$be.create(!1);return this.n(o,m,c.scorerCache,t).then(E=>{const k=S.elapsed(),C={fromCache:!0,detailStats:y,type:this.d,resultCount:m.length,sortingTime:k};return[{type:"success",limitHit:s.limitHit||typeof o.maxResults=="number"&&m.length>o.maxResults,stats:C,messages:[]},E]})})}n(o,n,t,c){const h=(0,L.$Gr)(o.filePattern||""),s=(y,S)=>(0,L.$Fr)(y,S,h,!0,d,t),m=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return r.$Gb(n,s,m,1e4,c)}o(o,n,t){if(t&&t>0)for(let c=0;c<o.length;c+=t)n(o.slice(c,c+t));else n(o)}q(o,n,t,c){const h=p.$be.create(!1),s=n.indexOf(R.sep)>=0;let m;for(const k in o.resultsToSearchCache)if(n.startsWith(k)){if(s&&k.indexOf(R.sep)<0&&k!=="")continue;const C=o.resultsToSearchCache[k];m={promise:this.s(C.promise),event:C.event,resolved:C.resolved};break}if(!m)return null;const y=h.elapsed(),S=p.$be.create(!1),E=m.event(t);return c&&c.onCancellationRequested(()=>{E.dispose()}),m.promise.then(([k,C])=>{if(c&&c.isCancellationRequested)throw(0,P.$6)();const v=[],b=(0,L.$Gr)(n).normalizedLowercase;for(const O of C)(0,D.$YK)(O,b)&&v.push(O);return[k,v,{cacheWasResolved:m.resolved,cacheLookupTime:y,cacheFilterTime:S.elapsed(),cacheEntryCount:C.length}]})}r(o,n,t,c){return new Promise((h,s)=>{let m=[];c?.onCancellationRequested(()=>o.cancel()),o.search(y=>{y&&(t?(m.push(y),t>0&&m.length>=t&&(n(m),m=[])):n(y))},y=>{n(y)},(y,S)=>{m.length&&n(m),y?(n({message:"Search finished. Error: "+y.message}),s(y)):(n({message:"Search finished. Stats: "+JSON.stringify(S.stats)}),h(S))})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}s(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(n,t){return o.then(n,t)}catch(n){return this.then(void 0,n)}finally(n){return o.finally(n)}}}}e.$vpc=w,w.a=512;class a{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(i){return(0,R.$nc)(i.relativePath)}getItemDescription(i){return(0,R.$mc)(i.relativePath)}getItemPath(i){return i.relativePath}};function g(i){return{...i,folderQueries:i.folderQueries&&i.folderQueries.map($),extraFileResources:i.extraFileResources&&i.extraFileResources.map(o=>l.URI.revive(o))}}function $(i){return{...i,folder:l.URI.revive(i.folder)}}}),define(Ee[403],Se([1,0,3,15,2,34,12,30,20,102,72,38,402,400,130,171]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xpc=void 0;let d=class extends l.$ioc{constructor($,i,o,n){super($,o,n),this.w=T,this.x=-1,this.y=null,this.z=!1,this.A=new r.$Tc;const t=new w.$gpc("RipgrepSearchUD",this.q);this.A.add(this.registerTextSearchProvider(u.Schemas.vscodeUserData,new A.$wpc(t))),i.remote.isRemote&&i.remote.authority&&this.B()}dispose(){this.A.dispose()}$enableExtensionHostSearch(){this.B()}B(){if(this.z)return;this.z=!0;const $=new w.$gpc("RipgrepSearchEH",this.q);this.A.add(this.registerTextSearchProvider(u.Schemas.file,new A.$wpc($))),this.A.add(this.C(u.Schemas.file,new f.$vpc("fileSearchProvider")))}C($,i){const o=this.d++;return this.y=i,this.x=o,this.c.$registerFileSearchProvider(o,this.s($)),(0,r.$Sc)(()=>{this.y=null,this.c.$unregisterProvider(o)})}$provideFileSearchResults($,i,o,n){const t=(0,l.$joc)(o);if($===this.x){const c=Date.now();return this.D($,i,t,n).then(h=>{const s=Date.now()-c;return this.q.debug(`Ext host file search time: ${s}ms`),h})}return super.$provideFileSearchResults($,i,o,n)}doInternalFileSearchWithCustomCallback($,i,o){const n=t=>{if((0,D.$XK)(t)&&(t=[t]),Array.isArray(t)){o(t.map(c=>P.URI.file(c.path)));return}t.message&&this.q.debug("ExtHostSearch",t.message)};if(!this.y)throw new Error("No internal file search handler");return this.y.doFileSearch($,n,i)}async D($,i,o,n){return this.doInternalFileSearchWithCustomCallback(o,n,t=>{this.c.$handleFileMatch($,i,t)})}$clearCache($){return this.y?.clearCache($),super.$clearCache($)}t($,i){return new a.$tpc($,i,void 0,"textSearchProvider")}};e.$xpc=d,e.$xpc=d=Ze([Ve(0,p.$ZO),Ve(1,R.$dP),Ve(2,I.$_mc),Ve(3,L.$7j)],d)}),define(Ee[131],Se([1,0,417,67,66,418,22,14,4,3,16,11,33,87,68]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e.$ri=e.$qi=e.$pi=void 0,e.$si=h,e.$ti=s,e.$vi=S,e.$wi=E;class a{traceSocketEvent(C,v){w.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,v)}constructor(C,v=""){this.f=!0,this.debugLabel=v,this.socket=C,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"NodeSocket"}),this.a=b=>{if(this.traceSocketEvent(w.SocketDiagnosticsEventType.Error,{code:b?.code,message:b?.message}),b){if(b.code==="EPIPE")return;(0,R.$1)(b)}},this.socket.on("error",this.a),this.b=b=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Close,{hadError:b}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndReceived),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(C){const v=b=>{this.traceSocketEvent(w.SocketDiagnosticsEventType.Read,b),C(L.$Je.wrap(b))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(C){const v=b=>{C({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:b,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(C){const v=()=>{C()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(C){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent(w.SocketDiagnosticsEventType.Write,C),this.socket.write(C.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,R.$1)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,R.$1)(v)}}end(){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeEndSent),this.socket.end()}drain(){return this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainBegin),new Promise((C,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),C();return}const b=()=>{this.socket.off("close",b),this.socket.off("end",b),this.socket.off("error",b),this.socket.off("timeout",b),this.socket.off("drain",b),this.traceSocketEvent(w.SocketDiagnosticsEventType.NodeDrainEnd),C()};this.socket.on("close",b),this.socket.on("end",b),this.socket.on("error",b),this.socket.on("timeout",b),this.socket.on("drain",b)})}}e.$pi=a;var d;(function(k){k[k.MinHeaderByteSize=2]="MinHeaderByteSize",k[k.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var g;(function(k){k[k.PeekHeader=1]="PeekHeader",k[k.ReadHeader=2]="ReadHeader",k[k.ReadBody=3]="ReadBody",k[k.Fin=4]="Fin"})(g||(g={}));class $ extends l.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(C,v){this.socket.traceSocketEvent(C,v)}constructor(C,v,b,O){super(),this.f=this.B(new p.$he),this.g=this.B(new p.$he),this.h=!1,this.j={state:g.PeekHeader,readLen:d.MinHeaderByteSize,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=C,this.traceSocketEvent(w.SocketDiagnosticsEventType.Created,{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:b?.byteLength||0,recordInflateBytes:O}),this.a=this.B(new i(this,v,b,O,this.f,(U,z)=>this.m(U,z))),this.B(this.a.onError(U=>{console.error(U),(0,R.$1)(U),this.g.fire({type:w.SocketCloseEventType.NodeSocketCloseEvent,hadError:!0,error:U})})),this.b=new w.$ki,this.B(this.socket.onData(U=>this.n(U))),this.B(this.socket.onClose(async U=>{this.a.isProcessingReadQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(U)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this.f.event(C)}onClose(C){return this.g.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let v=0;for(;v<C.byteLength;)this.a.writeMessage(C.slice(v,Math.min(v+d.MaxWebSocketMessageLength,C.byteLength)),{compressed:!0,opcode:2}),v+=d.MaxWebSocketMessageLength}m(C,{compressed:v,opcode:b}){if(this.h)return;this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketWrite,C);let O=d.MinHeaderByteSize;C.byteLength<126?O+=0:C.byteLength<2**16?O+=2:O+=8;const U=L.$Je.alloc(O),z=v?64:0,j=b&15;if(U.writeUInt8(128|z|j,0),C.byteLength<126)U.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){U.writeUInt8(126,1);let M=1;U.writeUInt8(C.byteLength>>>8&255,++M),U.writeUInt8(C.byteLength>>>0&255,++M)}else{U.writeUInt8(127,1);let M=1;U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(0,++M),U.writeUInt8(C.byteLength>>>24&255,++M),U.writeUInt8(C.byteLength>>>16&255,++M),U.writeUInt8(C.byteLength>>>8&255,++M),U.writeUInt8(C.byteLength>>>0&255,++M)}this.socket.write(L.$Je.concat([U,C]))}end(){this.h=!0,this.socket.end()}n(C){if(C.byteLength!==0){for(this.b.acceptChunk(C);this.b.byteLength>=this.j.readLen;)if(this.j.state===g.PeekHeader){const v=this.b.peek(this.j.readLen),b=v.readUInt8(0),O=(b&128)>>>7,U=(b&64)>>>6,z=b&15,j=v.readUInt8(1),M=(j&128)>>>7,N=j&127;this.j.state=g.ReadHeader,this.j.readLen=d.MinHeaderByteSize+(M?4:0)+(N===126?2:0)+(N===127?8:0),this.j.fin=O,this.j.firstFrameOfMessage&&(this.j.compressed=!!U),this.j.firstFrameOfMessage=!!O,this.j.mask=0,this.j.opcode=z,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===g.ReadHeader){const v=this.b.read(this.j.readLen),b=v.readUInt8(1),O=(b&128)>>>7;let U=b&127,z=1;U===126?U=v.readUInt8(++z)*2**8+v.readUInt8(++z):U===127&&(U=v.readUInt8(++z)*0+v.readUInt8(++z)*0+v.readUInt8(++z)*0+v.readUInt8(++z)*0+v.readUInt8(++z)*2**24+v.readUInt8(++z)*2**16+v.readUInt8(++z)*2**8+v.readUInt8(++z));let j=0;O&&(j=v.readUInt8(++z)*2**24+v.readUInt8(++z)*2**16+v.readUInt8(++z)*2**8+v.readUInt8(++z)),this.j.state=g.ReadBody,this.j.readLen=U,this.j.mask=j,this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketPeekedHeader,{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===g.ReadBody){const v=this.b.read(this.j.readLen);this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketReadData,v),t(v,this.j.mask),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketUnmaskedData,v),this.j.state=g.PeekHeader,this.j.readLen=d.MinHeaderByteSize,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(v,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(v,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainBegin),this.a.isProcessingWriteQueue()&&await p.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent(w.SocketDiagnosticsEventType.WebSocketNodeSocketDrainEnd)}}e.$qi=$;class i extends l.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Je.alloc(0)}constructor(C,v,b,O,U,z){super(),this.n=C,this.r=U,this.s=z,this.a=this.B(new p.$he),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new p.$he),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new p.$he),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,v?(this.b=this.B(new o(this.n,O,b,{windowBits:15})),this.f=this.B(new n(this.n,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(C,v){this.g.push({data:C,options:v}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:C,options:v}=this.g.shift();if(this.f&&v.compressed){const b=await this.w(this.f,C);this.s(b,v)}else this.s(C,{...v,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(C,v){return new Promise((b,O)=>{C.write(v),C.flush(U=>b(U))})}acceptFrame(C,v,b){this.h.push({data:C,isCompressed:v,isLastFrameOfMessage:b}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const C=this.h.shift();if(this.b&&C.isCompressed){const v=await this.C(this.b,C.data,C.isLastFrameOfMessage);this.r.fire(v)}else this.r.fire(C.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(C,v,b){return new Promise((O,U)=>{C.write(v),b&&C.write(L.$Je.fromByteArray([0,0,255,255])),C.flush(z=>O(z))})}}class o extends l.$Uc{get recordedInflateBytes(){return this.j?L.$Je.concat(this.f):L.$Je.alloc(0)}constructor(C,v,b,O){super(),this.h=C,this.j=v,this.a=this.B(new p.$he),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,T.createInflateRaw)(O),this.b.on("error",U=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateError,{message:U?.message,code:U?.code}),this.a.fire(U)}),this.b.on("data",U=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateData,U),this.g.push(L.$Je.wrap(U))}),b&&(this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialWrite,b.buffer),this.b.write(b.buffer),this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateInitialFlushFired),this.g.length=0}))}write(C){this.j&&this.f.push(C.clone()),this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateWrite,C),this.b.write(C.buffer)}flush(C){this.b.flush(()=>{this.h.traceSocketEvent(w.SocketDiagnosticsEventType.zlibInflateFlushFired);const v=L.$Je.concat(this.g);this.g.length=0,C(v)})}}class n extends l.$Uc{constructor(C,v){super(),this.g=C,this.a=this.B(new p.$he),this.onError=this.a.event,this.f=[],this.b=(0,T.createDeflateRaw)({windowBits:15}),this.b.on("error",b=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateError,{message:b?.message,code:b?.code}),this.a.fire(b)}),this.b.on("data",b=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateData,b),this.f.push(L.$Je.wrap(b))})}write(C){this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateWrite,C.buffer),this.b.write(C.buffer)}flush(C){this.b.flush(2,()=>{this.g.traceSocketEvent(w.SocketDiagnosticsEventType.zlibDeflateFlushFired);let v=L.$Je.concat(this.f);this.f.length=0,v=v.slice(0,v.byteLength-4),C(v)})}}function t(k,C){if(C===0)return;const v=k.byteLength>>>2;for(let M=0;M<v;M++){const N=k.readUInt32BE(M*4);k.writeUInt32BE(N^C,M*4)}const b=v*4,O=k.byteLength-b,U=C>>>24&255,z=C>>>16&255,j=C>>>8&255;O>=1&&k.writeUInt8(k.readUInt8(b)^U,b),O>=2&&k.writeUInt8(k.readUInt8(b+1)^z,b+1),O>=3&&k.writeUInt8(k.readUInt8(b+2)^j,b+2)}e.$ri=process.env.XDG_RUNTIME_DIR;const c={[D.Platform.Linux]:107,[D.Platform.Mac]:103};function h(){const k=(0,f.$Wg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${k}-sock`;const C=process.platform!=="darwin"&&e.$ri?e.$ri:(0,P.tmpdir)(),v=(0,I.$jc)(C,`vscode-ipc-${k}.sock`);return m(v),v}function s(k,C,v){const O=(0,r.createHash)("sha256").update(k).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${O}-${v}-${C}-sock`;const U=v.substr(0,4),z=C.substr(0,6);let j;return process.platform!=="darwin"&&e.$ri&&!process.env.VSCODE_PORTABLE?j=(0,I.$jc)(e.$ri,`vscode-${O}-${U}-${z}.sock`):j=(0,I.$jc)(k,`${U}-${z}.sock`),m(j),j}function m(k){const C=c[D.$o];typeof C=="number"&&k.length>=C&&console.warn(`WARNING: IPC handle "${k}" is longer than ${C} chars, try a shorter --user-data-dir`)}class y extends A.$ei{static b(C){const v=p.Event.fromNodeEventEmitter(C,"connection");return p.Event.map(v,b=>({protocol:new w.$li(new a(b,"ipc-server-connection")),onDidClientDisconnect:p.Event.once(p.Event.fromNodeEventEmitter(b,"close"))}))}constructor(C){super(y.b(C)),this.d=C}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$ui=y;function S(k){return new Promise((C,v)=>{const b=(0,u.createServer)();b.on("error",v),b.listen(k,()=>{b.removeListener("error",v),C(new y(b))})})}function E(k,C){return new Promise((v,b)=>{const O=(0,u.createConnection)(k,()=>{O.removeListener("error",b),v(w.$mi.fromSocket(new a(O,`ipc-client${C}`),C))});O.once("error",b)})}}),define(Ee[404],Se([1,0,67,66,189,131,7,3,11,45,12,115,283,284,117,93,22]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nfc=e.$mfc=e.$lfc=e.$kfc=void 0;async function g(t,c,h,s,m){let y;for(let S=3;S&&(y?.dispose(),y=await new $(t,c,h,s,m).waitForReady(),!(m&&P.$Zg[m]||!P.$Zg[y.tunnelLocalPort]));S--);return y}class $ extends R.$Uc{constructor(c,h,s,m,y){super(),this.m=h,this.n=y,this.privacy=a.TunnelPrivacyId.Private,this.j=new Map,this.a=c,this.b=r.createServer(),this.c=new L.$zh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=S=>this.r(S),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=m,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(h=>{h()})}async waitForReady(){const c=this.n??this.tunnelRemotePort,h=(0,a.$Aw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,P.$1g)(c,2,1e3,h),m=null;return this.b.listen(s,this.m),await this.c.wait(),m=this.b.address(),m||(s=0,this.b.listen(s,this.m),await this.c.wait(),m=this.b.address()),this.tunnelLocalPort=m.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${m.port}`,this}async r(c){c.pause();const h=(0,a.$yw)(this.tunnelRemoteHost)||(0,a.$Aw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,f.$Wl)(this.a,h,this.tunnelRemotePort),m=s.getSocket(),y=s.readEntireBuffer();s.dispose(),y.byteLength>0&&c.write(y.buffer),c.on("end",()=>{c.localAddress&&this.j.delete(c.localAddress),m.end()}),c.on("close",()=>m.end()),c.on("error",()=>{c.localAddress&&this.j.delete(c.localAddress),m instanceof T.$pi?m.socket.destroy():m.end()}),m instanceof T.$pi?this.t(c,m):this.s(c,m),c.localAddress&&this.j.set(c.localAddress,()=>{c.end(),m.end()})}s(c,h){h.onClose(()=>c.destroy()),h.onEnd(()=>c.end()),h.onData(s=>c.write(s.buffer)),c.on("data",s=>h.write(d.$Je.wrap(s))),c.resume()}t(c,h){const s=h.socket;s.on("end",()=>c.end()),s.on("close",()=>c.end()),s.on("error",()=>{c.destroy()}),s.pipe(c),c.pipe(s)}}e.$kfc=$;let i=class extends a.$Dw{constructor(c,h,s,m,y){super(h,y),this.v=c,this.w=s,this.y=m}isPortPrivileged(c){return(0,a.$Bw)(c,this.m,p.OS,u.release())}t(c,h,s,m,y,S,E,k){const C=this.s(h,s);if(C)return++C.refcount,C.value;if((0,a.$uw)(c))return this.u(c,h,s,y,S,E,k);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${s} on local port ${y}.`);const v={commit:this.y.commit,quality:this.y.quality,addressProvider:c,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},b=g(v,m,h,s,y);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(h,s,b),b}}};e.$lfc=i,e.$lfc=i=Ze([Ve(0,A.$Ql),Ve(1,I.$7j),Ve(2,w.$Tl),Ve(3,D.$nk),Ve(4,l.$7i)],i);let o=class extends i{constructor(c,h,s,m,y){super(c,h,s,m,y)}};e.$mfc=o,e.$mfc=o=Ze([Ve(0,A.$Ql),Ve(1,I.$7j),Ve(2,w.$Tl),Ve(3,D.$nk),Ve(4,l.$7i)],o);let n=class extends R.$Uc{constructor(c,h,s,m,y){super(),this.b=c,this.c=h,this.f=s,this.g=m,this.h=y,this.a=new Map}async openTunnel(c,h,s,m,y,S,E,k,C){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${m} on local port ${S}.`),!this.a.has(c)){const v=new o(this.b,this.c,this.g,this.f,this.h);this.B(v),this.a.set(c,v),v.onTunnelClosed(async()=>{(await v.tunnels).length===0&&(v.dispose(),this.a.delete(c))})}return this.a.get(c).openTunnel(h,s,m,y,S,E,k,C)}};e.$nfc=n,e.$nfc=n=Ze([Ve(0,A.$Ql),Ve(1,I.$7j),Ve(2,D.$nk),Ve(3,w.$Tl),Ve(4,l.$7i)],n)}),define(Ee[405],Se([1,0,131,119,56,37,2,12,46]),function(oe,e,r,u,P,T,L,R,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.$oP=void 0;class l{constructor(f,A,w){this.b=f,this.c=A,this.f=w,this.a=u.createServer((a,d)=>this.h(a,d)),this.g().catch(a=>(A.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",f=>this.c.error(f))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(f,A){const w=(d,g)=>{A.writeHead(d,{"content-type":"application/json"}),A.end(JSON.stringify(g||null),$=>$&&this.c.error($))},a=[];f.setEncoding("utf8"),f.on("data",d=>a.push(d)),f.on("end",async()=>{try{const d=JSON.parse(a.join(""));let g;switch(d.type){case"open":g=await this.i(d);break;case"openExternal":g=await this.j(d);break;case"status":g=await this.l(d);break;case"extensionManagement":g=await this.k(d);break;case"clipboard":g=await this.m(d);break;default:w(404,`Unknown message type: ${d.type}`);break}w(200,g)}catch(d){const g=d instanceof Error?d.message:JSON.stringify(d);w(500,g),this.c.error("Error while processing pipe request",d)}})}async i(f){const{fileURIs:A,folderURIs:w,forceNewWindow:a,diffMode:d,mergeMode:g,addMode:$,forceReuseWindow:i,gotoLineMode:o,waitMarkerFilePath:n,remoteAuthority:t}=f,c=[];if(Array.isArray(w))for(const y of w)try{c.push({folderUri:L.URI.parse(y)})}catch{}if(Array.isArray(A))for(const y of A)try{(0,p.$6i)(y)?c.push({workspaceUri:L.URI.parse(y)}):c.push({fileUri:L.URI.parse(y)})}catch{}const h=n?L.URI.file(n):void 0,m={forceNewWindow:a,diffMode:d,mergeMode:g,addMode:$,gotoLineMode:o,forceReuseWindow:i,preferNewWindow:!i&&!h&&!$,waitMarkerFileURI:h,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",c,m)}async j(f){for(const A of f.uris){const w=L.URI.parse(A),a=w.scheme==="file"?w:A;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(f){const A=a=>a?.map(d=>/\.vsix$/i.test(d)?L.URI.parse(d):d),w={list:f.list,install:A(f.install),uninstall:A(f.uninstall),force:f.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",w)}async l(f){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}async m(f){return await this.b.executeCommand("_remoteCLI.setClipboard",f.content)}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&P.existsSync(this.f)&&P.unlinkSync(this.f)}}e.$oP=l;let I=class extends l{constructor(f,A){super(f,A,(0,r.$si)())}};e.$pP=I,e.$pP=I=Ze([Ve(0,T.$jP),Ve(1,R.$7j)],I)}),define(Ee[406],Se([1,0,119,62,393,388,300,53,375,2,15,8,405,108,335,42,374]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=void 0;class g extends T.$4oc{k(){const o=this,n=globalThis._VSCODE_NODE_MODULES.module,t=n._load;n._load=function(m,y,S){return m=h(m),o.a.has(m)?o.a.get(m).load(m,l.URI.file((0,A.$dr)(y.filename)),E=>t.apply(this,[E,y,S])):t.apply(this,arguments)};const c=n._resolveLookupPaths;n._resolveLookupPaths=(s,m)=>c.call(this,h(s),m);const h=s=>{for(const m of o.b){const y=m(s);if(y){s=y;break}}return s}}}class $ extends R.$Rnc{constructor(){super(...arguments),this.extensionRuntime=D.ExtensionRuntime.Node}async vb(){this.h.createInstance(w.$Apc);const o=this.h.invokeFunction(P.$Zoc);if(this.h.createInstance(p.$zpc),this.f.remote.isRemote&&this.f.remote.authority){const c=this.h.createInstance(f.$pP);process.env.VSCODE_IPC_HOOK_CLI=c.ipcHandlePath}this.h.createInstance(d.$Bpc),await this.h.createInstance(g,o,{mine:this.J,all:this.L}).install(),u.mark("code/extHost/didInitAPI"),(async()=>{const c=process.env.VSCODE_IPC_HOOK_CLI,h=process.env.CODE_SERVER_SESSION_SOCKET;if(!c||!h)return;const m={workspace:this.h.invokeFunction(S=>S.get(a.$cnc).workspace),socketPath:c},y=JSON.stringify({entry:m});await new Promise((S,E)=>{const k={path:"/add-session",socketPath:h,method:"POST",headers:{"content-type":"application/json"}},C=r.request(k,v=>{v.on("error",E),v.on("end",()=>{try{v.statusCode===200?S():E(new Error("Unexpected status code: "+v.statusCode))}catch(b){E(b)}})});C.on("error",E),C.write(y),C.end()})})().catch(c=>{this.s.error(c)});const t=await this.m.getConfigProvider();await(0,L.$ypc)(this.j,t,this,this.s,this.z,this.f),u.mark("code/extHost/didInitProxyResolver")}wb(o){return o.main}async xb(o,n,t){if(n.scheme!==I.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let c=null;t.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const h=o?.identifier.value;o&&await this.w.initializeLocalizedMessages(o);try{h&&u.mark(`code/extHost/willLoadExtensionCode/${h}`),c=oe.__$__nodeRequire(n.fsPath)}finally{h&&u.mark(`code/extHost/didLoadExtensionCode/${h}`),t.codeLoadingStop()}return c}async $setRemoteEnvironment(o){if(this.f.remote.isRemote)for(const n in o){const t=o[n];t===null?delete process.env[n]:process.env[n]=t}}}e.$Cpc=$}),define(Ee[407],Se([1,0,57,22,4,3,134,11,23,2,34,68,12,282,71,117,93,404,30,20,76,382]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kpc=void 0,e.$Dpc=t,e.$Epc=c,e.$Fpc=h,e.$Gpc=s,e.$Hpc=y,e.$Ipc=S,e.$Jpc=E;function t(v){const b=v.trim().split(`
`),O=[];return b.forEach(z=>{const j=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);j&&j.length>=3&&O.push({pid:parseInt(j[1],10),socket:parseInt(j[2],10)})}),O.reduce((z,j)=>(z[j.socket]=j,z),{})}function c(...v){const b=[].concat(...v.map(s));return[...new Map(b.filter(O=>O.st==="0A").map(O=>{const U=O.local_address.split(":");return{socket:parseInt(O.inode,10),ip:h(U[0]),port:parseInt(U[1],16)}}).map(O=>[O.ip+":"+O.port,O])).values()]}function h(v){let b="";if(v.length===8)for(let O=v.length-2;O>=0;O-=2)b+=parseInt(v.substr(O,2),16),O!==0&&(b+=".");else for(let O=0;O<v.length;O+=8){const U=v.substring(O,O+8);let z="";for(let j=8;j>=2;j-=2)z+=U.substring(j-2,j),(j===6||j===2)&&(z=parseInt(z,16).toString(16),b+=`${z}`,z="",O+j!==v.length-6&&(b+=":"))}return b}function s(v){const b=v.trim().split(`
`),O=b.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return b.map(z=>z.trim().split(/\s+/).reduce((j,M,N)=>(j[O[N]||N]=M,j),{}))}function m(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/server-main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function y(v){const b=v.trim().split(`
`),O=[];return b.forEach(U=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(U);z&&z.length>=4&&O.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),O}async function S(v,b,O){const U=O.reduce((j,M)=>(j[M.pid]=M,j),{}),z=[];return v.forEach(({socket:j,ip:M,port:N})=>{const F=b[j]?b[j].pid:void 0,X=F?U[F]?.cmd:void 0;F&&X&&!m(X)&&z.push({host:M,port:N,detail:X,pid:F})}),z}function E(v,b,O){const U=new Map,z=y(b);for(const j of v){const M=O.get(j.port);if(M){U.set(j.port,M);continue}const N=z.find(F=>F.cmd.includes(`${j.port}`));if(N){let F=N,X;do X=z.find(se=>se.ppid===F.pid),X&&(F=X);while(X);U.set(j.port,{host:j.ip,port:j.port,pid:F.pid,detail:F.cmd,ppid:F.ppid})}else U.set(j.port,{host:j.ip,port:j.port,ppid:Number.MAX_VALUE})}return U}let k=class extends o.$xEb{constructor(b,O,U,z){super(b,O,U),this.D=O,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,R.$e&&O.remote.isRemote&&O.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(b){if(b&&this.C)return;this.C=b;let O;this.y&&(O=this.y,await this.a.$onFoundNewCandidates(this.y));const U=new L.$Km;let z=0;for(;this.C;){const j=new Date().getTime(),M=(await this.I()).filter(X=>(0,d.$yw)(X.host)||(0,d.$Aw)(X.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(X=>X.port).join(", ")}`);const N=new Date().getTime()-j;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${N} ms.`),z++>3&&U.update(N),(!O||JSON.stringify(O)!==JSON.stringify(M))&&(O=M,await this.a.$onFoundNewCandidates(O));const F=this.G(U.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${F} ms.`),await new Promise(X=>setTimeout(()=>X(),F))}}G(b){return Math.max(b*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(b=>b.port).join(", ")}`)}async I(){let b="",O="";try{b=await I.Promises.readFile("/proc/net/tcp","utf8"),O=await I.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const U=c(b,O),z=await new Promise(H=>{(0,r.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(V,x,he)=>{H(x)})}),j=t(z),M=await I.Promises.readdir("/proc"),N=[];for(const H of M)try{const V=Number(H),x=p.$bh(l.URI.file("/proc"),H);if((await I.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(V)){const ne=await I.Promises.readlink(p.$bh(x,"cwd").fsPath),we=await I.Promises.readFile(p.$bh(x,"cmdline").fsPath,"utf8");N.push({pid:V,cwd:ne,cmd:we})}}catch{}const F=[],X=U.filter(H=>{const V=j[H.socket];return V||F.push(H),V}),se=S(X,j,N);let W;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${F.length}`),F.length>0){const H=await new Promise(V=>{(0,r.exec)("ps -F -A -l | grep root",(x,he,ne)=>{V(he)})});this.z=E(F,H,this.z),W=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${W.map(V=>V.port).join(", ")}`)}return se.then(H=>W?H.concat(W):H)}w(b){return async O=>{const U=new g.$kfc({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(j,M,N,F){const X=await b.makeConnection();return C.connect(X,M,N,F)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new w.$Ml(0),connectionToken:b.connectionToken})}},signService:this.F},"localhost",O.remoteAddress.host||"localhost",O.remoteAddress.port,O.localAddressPort);await U.waitForReady();const z=new P.$he;return{localAddress:(0,n.$VL)(U.localAddress)??U.localAddress,remoteAddress:{port:U.tunnelRemotePort,host:U.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{U.dispose(),z.fire(),z.dispose()}}}}};e.$Kpc=k,e.$Kpc=k=Ze([Ve(0,i.$ZO),Ve(1,$.$dP),Ve(2,f.$7j),Ve(3,a.$Tl)],k);class C extends A.$Vvb{static connect(b,O,U,z){const j=new T.$Tc,M={onClose:j.add(new P.$he),onData:j.add(new P.$he),onEnd:j.add(new P.$he)};j.add(b.onDidReceiveMessage(F=>M.onData.fire(u.$Je.wrap(F)))),j.add(b.onDidEnd(()=>M.onEnd.fire())),j.add(b.onDidClose(F=>M.onClose.fire({type:D.SocketCloseEventType.NodeSocketCloseEvent,error:F,hadError:!!F})));const N=new C(b,z,M);return N.B(j),(0,A.$Uvb)(N,O,U,z,M)}constructor(b,O,U){super(O,U),this.n=b}write(b){this.n.send(b.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ee[408],Se([1,0,89,377,391,390,403,406,407,101,53,102,100,47,76,98,376,336,12,392,64,296,112,117,148]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$,i,o,n,t,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,r.$Gs)(I.$Snc,R.$Cpc,r.InstantiationType.Eager),(0,r.$Gs)($.$8j,g.$Mpc,r.InstantiationType.Delayed),(0,r.$Gs)($.$7j,new t.$xi(n.$3oc,[!1],!0)),(0,r.$Gs)(c.$Tl,h.$pfc,r.InstantiationType.Delayed),(0,r.$Gs)(a.$inc,d.$Lpc,r.InstantiationType.Eager),(0,r.$Gs)(l.$Xnc,T.$dpc,r.InstantiationType.Eager),(0,r.$Gs)(D.$hoc,L.$xpc,r.InstantiationType.Eager),(0,r.$Gs)(f.$Joc,P.$8oc,r.InstantiationType.Eager),(0,r.$Gs)(A.$Dnc,u.$7oc,r.InstantiationType.Eager),(0,r.$Gs)(w.$wEb,p.$Kpc,r.InstantiationType.Eager),(0,r.$Gs)(o.$Vnc,i.$Npc,r.InstantiationType.Eager)}),define(Ee[419],Se([1,0,119,67,420,62,14,68,131,280,94,389,22,34,108,7,113,301,317,394,408]),function(oe,e,r,u,P,T,L,R,p,l,I,D,f,A,w,a,d,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let E=0;E<process.execArgv.length;E++)process.execArgv[E]==="--inspect-port=0"&&(process.execArgv.splice(E,1),E--)}();const i=P(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const S=globalThis._VSCODE_NODE_MODULES.module,E=S._load;S._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return E.apply(this,arguments)}})();const o=process.exit.bind(process),n=process.on.bind(process);function t(S){process.exit=function(E){if(S)o(E);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const E=new Error("An extension called process.crash() and this was prevented.");console.warn(E.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(E,k){E==="uncaughtException"&&(k=function(){try{return k.call(void 0,arguments)}catch{}}),n(E,k)}}let c=function(S){o()};function h(){const S=(0,$.$un)(process.env);if(S.type===$.ExtHostConnectionType.MessagePort)return new Promise((E,k)=>{const C=v=>{const b=v[0],O=new R.$ni;b.on("message",U=>O.fire(f.$Je.wrap(U.data))),b.on("close",()=>{c("renderer closed the MessagePort")}),b.start(),E({onMessage:O.event,send:U=>b.postMessage(U.buffer)})};process.parentPort.on("message",v=>C(v.ports))});if(S.type===$.ExtHostConnectionType.Socket)return new Promise((E,k)=>{let C=null;const v=setTimeout(()=>{c("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),b=R.ProtocolConstants.ReconnectionGraceTime,O=R.ProtocolConstants.ReconnectionShortGraceTime,U=new a.$Nh(()=>c("renderer disconnected for too long (1)"),b),z=new a.$Nh(()=>c("renderer disconnected for too long (2)"),O);process.on("message",(M,N)=>{if(M&&M.type==="VSCODE_EXTHOST_IPC_SOCKET"){N.setNoDelay(!0);const F=f.$Je.wrap(Buffer.from(M.initialDataChunk,"base64"));let X;if(M.skipWebSocketFrames)X=new p.$pi(N,"extHost-socket");else{const se=f.$Je.wrap(Buffer.from(M.inflateBytes,"base64"));X=new p.$qi(new p.$pi(N,"extHost-socket"),M.permessageDeflate,se,!1)}C?(U.cancel(),z.cancel(),C.beginAcceptReconnection(X,F),C.endAcceptReconnection(),C.sendResume()):(clearTimeout(v),C=new R.$oi({socket:X,initialChunk:F}),C.sendResume(),C.onDidDispose(()=>c("renderer disconnected")),E(C),C.onSocketClose(()=>{U.schedule()}))}if(M&&M.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;U.isScheduled()&&z.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const E=S.pipeName;return new Promise((k,C)=>{const v=u.createConnection(E,()=>{v.removeListener("error",C);const b=new R.$oi({socket:new p.$pi(v,"extHost-renderer")});b.sendResume(),k(b)});v.once("error",C),v.on("close",()=>{c("renderer closed the socket")})})}}async function s(){const S=await h();return new class{constructor(){this.a=new R.$ni,this.onMessage=this.a.event,this.b=!1,S.onMessage(E=>{(0,I.$7m)(E,I.MessageType.Terminate)?(this.b=!0,c("received terminate message from renderer")):this.a.fire(E)})}send(E){this.b||S.send(E)}async drain(){if(S.drain)return S.drain()}}}function m(S){return new Promise(E=>{const k=S.onMessage(C=>{k.dispose();const v=JSON.parse(C.toString()),b=v.commit,O=l.default.commit;if(b&&O&&b!==O&&o(I.ExtensionHostExitCode.VersionMismatch),v.parentPid){let U=0;setInterval(function(){try{process.kill(v.parentPid,0),U=0}catch(j){j&&j.code==="EPERM"?(U++,U>=3&&c(`parent process ${v.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):c(`parent process ${v.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(v.parentPid)}catch(j){(0,L.$1)(j)}}S.send((0,I.$6m)(I.MessageType.Initialized)),E({protocol:S,initData:v})});S.send((0,I.$6m)(I.MessageType.Ready))})}async function y(){const S=[];process.on("unhandledRejection",(U,z)=>{S.push(z),setTimeout(()=>{const j=S.indexOf(z);j>=0&&z.catch(M=>{S.splice(j,1),(0,L.$4)(M)||(console.warn(`rejected promise not handled within 1 second: ${M}`),M&&M.stack&&console.warn(`stack trace: ${M.stack}`),U&&(0,L.$1)(U))})},1e3)}),process.on("rejectionHandled",U=>{const z=S.indexOf(U);z>=0&&S.splice(z,1)}),process.on("uncaughtException",function(U){(0,L.$Z)(U)||(0,L.$1)(U)}),T.mark("code/extHost/willConnectToRenderer");const E=await s();T.mark("code/extHost/didConnectToRenderer");const k=await m(E);T.mark("code/extHost/didWaitForInitData");const{initData:C}=k;t(!!C.environment.extensionTestsLocationURI),C.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,C.environment.skipWorkspaceStorageLock=(0,d.boolean)(i.skipWorkspaceStorageLock,!1);const v=new class{constructor(){this.pid=process.pid}exit(z){o(z)}fsExists(z){return A.Promises.exists(z)}fsRealpath(z){return(0,w.$cr)(z)}};let b=null;C.remote.authority&&i.transformURIs&&(b=(0,g.$Ks)(C.remote.authority));const O=new D.$6oc(k.protocol,C,v,b);c=U=>{O.terminate(U);const z=process.env.VSCODE_IPC_HOOK_CLI,j=process.env.CODE_SERVER_SESSION_SOCKET;if(!z||!j)return;const M=JSON.stringify({socketPath:z}),N={path:"/delete-session",socketPath:j,method:"POST",headers:{"content-type":"application/json",accept:"application/json"}},F=r.request(N);F.write(M),F.end()}}y().catch(S=>console.log(S))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
