"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/iterator","vs/base/common/glob","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/marshalling","vs/base/common/errorMessage","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/chat/common/languageModels","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/contrib/testing/common/constants","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/uint","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(_){for(var e=[],b=0,D=_.length;b<D;b++)e[b]=Ce[_[b]];return e};define(Ce[72],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=D,e.$6h=I,e.$7h=T;function b(A){return(M,$,a)=>{let P=null,y=null;if(typeof a.value=="function"?(P="value",y=a.value):typeof a.get=="function"&&(P="get",y=a.get),!y)throw new Error("not supported");a[P]=A(y,$)}}function D(A,M,$){let a=null,P=null;if(typeof $.value=="function"?(a="value",P=$.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(a="get",P=$.get),!P)throw new Error("not supported");const y=`$memoize$${M}`;$[a]=function(...u){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,u)}),this[y]}}function I(A,M,$){return b((a,P)=>{const y=`$debounce$${P}`,u=`$debounce$result$${P}`;return function(...k){this[u]||(this[u]=$?$():void 0),clearTimeout(this[y]),M&&(this[u]=M(this[u],...k),k=[this[u]]),this[y]=setTimeout(()=>{a.apply(this,k),this[u]=$?$():void 0},A)}})}function T(A,M,$){return b((a,P)=>{const y=`$throttle$timer$${P}`,u=`$throttle$result$${P}`,k=`$throttle$lastRun$${P}`,h=`$throttle$pending$${P}`;return function(...r){if(this[u]||(this[u]=$?$():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),M&&(this[u]=M(this[u],...r)),this[h])return;const o=this[k]+A;o<=Date.now()?(this[k]=Date.now(),a.apply(this,[this[u]]),this[u]=$?$():void 0):(this[h]=!0,this[y]=setTimeout(()=>{this[h]=!1,this[k]=Date.now(),a.apply(this,[this[u]]),this[u]=$?$():void 0},o-Date.now()))}})}}),define(Ce[133],Ie([1,0,18]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=I,e.$8c=T,e.$9c=A,e.$0c=M,e.$$c=$,e.$_c=a;const D=(k,h)=>k===h;e.$6c=D;function I(k=e.$6c){return(h,r)=>b.$ub(h,r,k)}function T(){return(k,h)=>JSON.stringify(k)===JSON.stringify(h)}function A(){return(k,h)=>k.equals(h)}function M(k,h,r){return!k||!h?k===h:r(k,h)}function $(k,h){if(k===h)return!0;if(Array.isArray(k)&&Array.isArray(h)){if(k.length!==h.length)return!1;for(let r=0;r<k.length;r++)if(!$(k[r],h[r]))return!1;return!0}if(k&&typeof k=="object"&&h&&typeof h=="object"&&Object.getPrototypeOf(k)===Object.prototype&&Object.getPrototypeOf(h)===Object.prototype){const r=k,o=h,c=Object.keys(r),f=Object.keys(o),t=new Set(f);if(c.length!==f.length)return!1;for(const s of c)if(!t.has(s)||!$(r[s],o[s]))return!1;return!0}return!1}function a(k){return JSON.stringify(u(k))}let P=0;const y=new WeakMap;function u(k){if(Array.isArray(k))return k.map(u);if(k&&typeof k=="object")if(Object.getPrototypeOf(k)===Object.prototype){const h=k,r=Object.create(null);for(const o of Object.keys(h).sort())r[o]=u(h[o]);return r}else{let h=y.get(k);return h===void 0&&(h=P++,y.set(k,h)),h+"----2b76a038c20c4bcc"}return k}}),define(Ce[96],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6O=e.$5O=void 0;class b{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$5O=b,e.$6O=new b("id#")}),define(Ce[134],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$On=A,e.$Pn=y,e.$Qn=u,e.$Rn=k,e.$Sn=h,e.$Tn=r,e.$Un=o,e.$Vn=c,e.$Wn=f,e.$Xn=t,e.$Yn=s,e.$Zn=n;var b;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(b||(e.ScanError=b={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var I;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function A(i,g=!1){let d=0;const l=i.length;let p="",C=0,S=D.Unknown,v=b.None;function E(V){let O=0,L=0;for(;O<V;){const F=i.charCodeAt(d);if(F>=P._0&&F<=P._9)L=L*16+F-P._0;else if(F>=P.A&&F<=P.F)L=L*16+F-P.A+10;else if(F>=P.a&&F<=P.f)L=L*16+F-P.a+10;else break;d++,O++}return O<V&&(L=-1),L}function R(V){d=V,p="",C=0,S=D.Unknown,v=b.None}function w(){const V=d;if(i.charCodeAt(d)===P._0)d++;else for(d++;d<i.length&&a(i.charCodeAt(d));)d++;if(d<i.length&&i.charCodeAt(d)===P.dot)if(d++,d<i.length&&a(i.charCodeAt(d)))for(d++;d<i.length&&a(i.charCodeAt(d));)d++;else return v=b.UnexpectedEndOfNumber,i.substring(V,d);let O=d;if(d<i.length&&(i.charCodeAt(d)===P.E||i.charCodeAt(d)===P.e))if(d++,(d<i.length&&i.charCodeAt(d)===P.plus||i.charCodeAt(d)===P.minus)&&d++,d<i.length&&a(i.charCodeAt(d))){for(d++;d<i.length&&a(i.charCodeAt(d));)d++;O=d}else v=b.UnexpectedEndOfNumber;return i.substring(V,O)}function m(){let V="",O=d;for(;;){if(d>=l){V+=i.substring(O,d),v=b.UnexpectedEndOfString;break}const L=i.charCodeAt(d);if(L===P.doubleQuote){V+=i.substring(O,d),d++;break}if(L===P.backslash){if(V+=i.substring(O,d),d++,d>=l){v=b.UnexpectedEndOfString;break}switch(i.charCodeAt(d++)){case P.doubleQuote:V+='"';break;case P.backslash:V+="\\";break;case P.slash:V+="/";break;case P.b:V+="\b";break;case P.f:V+="\f";break;case P.n:V+=`
`;break;case P.r:V+="\r";break;case P.t:V+="	";break;case P.u:{const ie=E(4);ie>=0?V+=String.fromCharCode(ie):v=b.InvalidUnicode;break}default:v=b.InvalidEscapeCharacter}O=d;continue}if(L>=0&&L<=31)if($(L)){V+=i.substring(O,d),v=b.UnexpectedEndOfString;break}else v=b.InvalidCharacter;d++}return V}function N(){if(p="",v=b.None,C=d,d>=l)return C=l,S=D.EOF;let V=i.charCodeAt(d);if(M(V)){do d++,p+=String.fromCharCode(V),V=i.charCodeAt(d);while(M(V));return S=D.Trivia}if($(V))return d++,p+=String.fromCharCode(V),V===P.carriageReturn&&i.charCodeAt(d)===P.lineFeed&&(d++,p+=`
`),S=D.LineBreakTrivia;switch(V){case P.openBrace:return d++,S=D.OpenBraceToken;case P.closeBrace:return d++,S=D.CloseBraceToken;case P.openBracket:return d++,S=D.OpenBracketToken;case P.closeBracket:return d++,S=D.CloseBracketToken;case P.colon:return d++,S=D.ColonToken;case P.comma:return d++,S=D.CommaToken;case P.doubleQuote:return d++,p=m(),S=D.StringLiteral;case P.slash:{const O=d-1;if(i.charCodeAt(d+1)===P.slash){for(d+=2;d<l&&!$(i.charCodeAt(d));)d++;return p=i.substring(O,d),S=D.LineCommentTrivia}if(i.charCodeAt(d+1)===P.asterisk){d+=2;const L=l-1;let F=!1;for(;d<L;){if(i.charCodeAt(d)===P.asterisk&&i.charCodeAt(d+1)===P.slash){d+=2,F=!0;break}d++}return F||(d++,v=b.UnexpectedEndOfComment),p=i.substring(O,d),S=D.BlockCommentTrivia}return p+=String.fromCharCode(V),d++,S=D.Unknown}case P.minus:if(p+=String.fromCharCode(V),d++,d===l||!a(i.charCodeAt(d)))return S=D.Unknown;case P._0:case P._1:case P._2:case P._3:case P._4:case P._5:case P._6:case P._7:case P._8:case P._9:return p+=w(),S=D.NumericLiteral;default:for(;d<l&&B(V);)d++,V=i.charCodeAt(d);if(C!==d){switch(p=i.substring(C,d),p){case"true":return S=D.TrueKeyword;case"false":return S=D.FalseKeyword;case"null":return S=D.NullKeyword}return S=D.Unknown}return p+=String.fromCharCode(V),d++,S=D.Unknown}}function B(V){if(M(V)||$(V))return!1;switch(V){case P.closeBrace:case P.closeBracket:case P.openBrace:case P.openBracket:case P.doubleQuote:case P.colon:case P.comma:case P.slash:return!1}return!0}function X(){let V;do V=N();while(V>=D.LineCommentTrivia&&V<=D.Trivia);return V}return{setPosition:R,getPosition:()=>d,scan:g?X:N,getToken:()=>S,getTokenValue:()=>p,getTokenOffset:()=>C,getTokenLength:()=>d-C,getTokenError:()=>v}}function M(i){return i===P.space||i===P.tab||i===P.verticalTab||i===P.formFeed||i===P.nonBreakingSpace||i===P.ogham||i>=P.enQuad&&i<=P.zeroWidthSpace||i===P.narrowNoBreakSpace||i===P.mathematicalSpace||i===P.ideographicSpace||i===P.byteOrderMark}function $(i){return i===P.lineFeed||i===P.carriageReturn||i===P.lineSeparator||i===P.paragraphSeparator}function a(i){return i>=P._0&&i<=P._9}var P;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(P||(P={}));function y(i,g){const d=[],l=new Object;let p;const C={value:{},offset:0,length:0,type:"object",parent:void 0};let S=!1;function v(E,R,w,m){C.value=E,C.offset=R,C.length=w,C.type=m,C.colonOffset=void 0,p=C}try{t(i,{onObjectBegin:(E,R)=>{if(g<=E)throw l;p=void 0,S=g>E,d.push("")},onObjectProperty:(E,R,w)=>{if(g<R||(v(E,R,w,"property"),d[d.length-1]=E,g<=R+w))throw l},onObjectEnd:(E,R)=>{if(g<=E)throw l;p=void 0,d.pop()},onArrayBegin:(E,R)=>{if(g<=E)throw l;p=void 0,d.push(0)},onArrayEnd:(E,R)=>{if(g<=E)throw l;p=void 0,d.pop()},onLiteralValue:(E,R,w)=>{if(g<R||(v(E,R,w,n(E)),g<=R+w))throw l},onSeparator:(E,R,w)=>{if(g<=R)throw l;if(E===":"&&p&&p.type==="property")p.colonOffset=R,S=!1,p=void 0;else if(E===","){const m=d[d.length-1];typeof m=="number"?d[d.length-1]=m+1:(S=!0,d[d.length-1]=""),p=void 0}}})}catch(E){if(E!==l)throw E}return{path:d,previousNode:p,isAtPropertyKey:S,matches:E=>{let R=0;for(let w=0;R<E.length&&w<d.length;w++)if(E[R]===d[w]||E[R]==="*")R++;else if(E[R]!=="**")return!1;return R===E.length}}}function u(i,g=[],d=T.DEFAULT){let l=null,p=[];const C=[];function S(E){Array.isArray(p)?p.push(E):l!==null&&(p[l]=E)}return t(i,{onObjectBegin:()=>{const E={};S(E),C.push(p),p=E,l=null},onObjectProperty:E=>{l=E},onObjectEnd:()=>{p=C.pop()},onArrayBegin:()=>{const E=[];S(E),C.push(p),p=E,l=null},onArrayEnd:()=>{p=C.pop()},onLiteralValue:S,onError:(E,R,w)=>{g.push({error:E,offset:R,length:w})}},d),p[0]}function k(i,g=[],d=T.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(E){l.type==="property"&&(l.length=E-l.offset,l=l.parent)}function C(E){return l.children.push(E),E}t(i,{onObjectBegin:E=>{l=C({type:"object",offset:E,length:-1,parent:l,children:[]})},onObjectProperty:(E,R,w)=>{l=C({type:"property",offset:R,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:E,offset:R,length:w,parent:l})},onObjectEnd:(E,R)=>{l.length=E+R-l.offset,l=l.parent,p(E+R)},onArrayBegin:(E,R)=>{l=C({type:"array",offset:E,length:-1,parent:l,children:[]})},onArrayEnd:(E,R)=>{l.length=E+R-l.offset,l=l.parent,p(E+R)},onLiteralValue:(E,R,w)=>{C({type:n(E),offset:R,length:w,parent:l,value:E}),p(R+w)},onSeparator:(E,R,w)=>{l.type==="property"&&(E===":"?l.colonOffset=R:E===","&&p(R))},onError:(E,R,w)=>{g.push({error:E,offset:R,length:w})}},d);const v=l.children[0];return v&&delete v.parent,v}function h(i,g){if(!i)return;let d=i;for(const l of g)if(typeof l=="string"){if(d.type!=="object"||!Array.isArray(d.children))return;let p=!1;for(const C of d.children)if(Array.isArray(C.children)&&C.children[0].value===l){d=C.children[1],p=!0;break}if(!p)return}else{const p=l;if(d.type!=="array"||p<0||!Array.isArray(d.children)||p>=d.children.length)return;d=d.children[p]}return d}function r(i){if(!i.parent||!i.parent.children)return[];const g=r(i.parent);if(i.parent.type==="property"){const d=i.parent.children[0].value;g.push(d)}else if(i.parent.type==="array"){const d=i.parent.children.indexOf(i);d!==-1&&g.push(d)}return g}function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const g=Object.create(null);for(const d of i.children){const l=d.children[1];l&&(g[d.children[0].value]=o(l))}return g}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function c(i,g,d=!1){return g>=i.offset&&g<i.offset+i.length||d&&g===i.offset+i.length}function f(i,g,d=!1){if(c(i,g,d)){const l=i.children;if(Array.isArray(l))for(let p=0;p<l.length&&l[p].offset<=g;p++){const C=f(l[p],g,d);if(C)return C}return i}}function t(i,g,d=T.DEFAULT){const l=A(i,!1);function p(fe){return fe?()=>fe(l.getTokenOffset(),l.getTokenLength()):()=>!0}function C(fe){return fe?ee=>fe(ee,l.getTokenOffset(),l.getTokenLength()):()=>!0}const S=p(g.onObjectBegin),v=C(g.onObjectProperty),E=p(g.onObjectEnd),R=p(g.onArrayBegin),w=p(g.onArrayEnd),m=C(g.onLiteralValue),N=C(g.onSeparator),B=p(g.onComment),X=C(g.onError),V=d&&d.disallowComments,O=d&&d.allowTrailingComma;function L(){for(;;){const fe=l.scan();switch(l.getTokenError()){case b.InvalidUnicode:F(I.InvalidUnicode);break;case b.InvalidEscapeCharacter:F(I.InvalidEscapeCharacter);break;case b.UnexpectedEndOfNumber:F(I.UnexpectedEndOfNumber);break;case b.UnexpectedEndOfComment:V||F(I.UnexpectedEndOfComment);break;case b.UnexpectedEndOfString:F(I.UnexpectedEndOfString);break;case b.InvalidCharacter:F(I.InvalidCharacter);break}switch(fe){case D.LineCommentTrivia:case D.BlockCommentTrivia:V?F(I.InvalidCommentToken):B();break;case D.Unknown:F(I.InvalidSymbol);break;case D.Trivia:case D.LineBreakTrivia:break;default:return fe}}}function F(fe,ee=[],De=[]){if(X(fe),ee.length+De.length>0){let Fe=l.getToken();for(;Fe!==D.EOF;){if(ee.indexOf(Fe)!==-1){L();break}else if(De.indexOf(Fe)!==-1)break;Fe=L()}}}function ie(fe){const ee=l.getTokenValue();return fe?m(ee):v(ee),L(),!0}function de(){switch(l.getToken()){case D.NumericLiteral:{let fe=0;try{fe=JSON.parse(l.getTokenValue()),typeof fe!="number"&&(F(I.InvalidNumberFormat),fe=0)}catch{F(I.InvalidNumberFormat)}m(fe);break}case D.NullKeyword:m(null);break;case D.TrueKeyword:m(!0);break;case D.FalseKeyword:m(!1);break;default:return!1}return L(),!0}function be(){return l.getToken()!==D.StringLiteral?(F(I.PropertyNameExpected,[],[D.CloseBraceToken,D.CommaToken]),!1):(ie(!1),l.getToken()===D.ColonToken?(N(":"),L(),ae()||F(I.ValueExpected,[],[D.CloseBraceToken,D.CommaToken])):F(I.ColonExpected,[],[D.CloseBraceToken,D.CommaToken]),!0)}function ve(){S(),L();let fe=!1;for(;l.getToken()!==D.CloseBraceToken&&l.getToken()!==D.EOF;){if(l.getToken()===D.CommaToken){if(fe||F(I.ValueExpected,[],[]),N(","),L(),l.getToken()===D.CloseBraceToken&&O)break}else fe&&F(I.CommaExpected,[],[]);be()||F(I.ValueExpected,[],[D.CloseBraceToken,D.CommaToken]),fe=!0}return E(),l.getToken()!==D.CloseBraceToken?F(I.CloseBraceExpected,[D.CloseBraceToken],[]):L(),!0}function Z(){R(),L();let fe=!1;for(;l.getToken()!==D.CloseBracketToken&&l.getToken()!==D.EOF;){if(l.getToken()===D.CommaToken){if(fe||F(I.ValueExpected,[],[]),N(","),L(),l.getToken()===D.CloseBracketToken&&O)break}else fe&&F(I.CommaExpected,[],[]);ae()||F(I.ValueExpected,[],[D.CloseBracketToken,D.CommaToken]),fe=!0}return w(),l.getToken()!==D.CloseBracketToken?F(I.CloseBracketExpected,[D.CloseBracketToken],[]):L(),!0}function ae(){switch(l.getToken()){case D.OpenBracketToken:return Z();case D.OpenBraceToken:return ve();case D.StringLiteral:return ie(!0);default:return de()}}return L(),l.getToken()===D.EOF?d.allowEmptyContent?!0:(F(I.ValueExpected,[],[]),!1):ae()?(l.getToken()!==D.EOF&&F(I.EndOfFileExpected,[],[]),!0):(F(I.ValueExpected,[],[]),!1)}function s(i,g){const d=A(i),l=[];let p,C=0,S;do switch(S=d.getPosition(),p=d.scan(),p){case D.LineCommentTrivia:case D.BlockCommentTrivia:case D.EOF:C!==S&&l.push(i.substring(C,S)),g!==void 0&&l.push(d.getTokenValue().replace(/[^\r\n]/g,g)),C=d.getPosition();break}while(p!==D.EOF);return l.join("")}function n(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(_,e){typeof define=="function"&&define.amd?define(Ce[135],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(_=typeof globalThis<"u"?globalThis:_||self,e(_.marked={}))}(this,function(_){"use strict";function e(re,ue){for(var oe=0;oe<ue.length;oe++){var J=ue[oe];J.enumerable=J.enumerable||!1,J.configurable=!0,"value"in J&&(J.writable=!0),Object.defineProperty(re,J.key,J)}}function b(re,ue,oe){return ue&&e(re.prototype,ue),oe&&e(re,oe),Object.defineProperty(re,"prototype",{writable:!1}),re}function D(re,ue){if(re){if(typeof re=="string")return I(re,ue);var oe=Object.prototype.toString.call(re).slice(8,-1);if(oe==="Object"&&re.constructor&&(oe=re.constructor.name),oe==="Map"||oe==="Set")return Array.from(re);if(oe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(oe))return I(re,ue)}}function I(re,ue){(ue==null||ue>re.length)&&(ue=re.length);for(var oe=0,J=new Array(ue);oe<ue;oe++)J[oe]=re[oe];return J}function T(re,ue){var oe=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(oe)return(oe=oe.call(re)).next.bind(oe);if(Array.isArray(re)||(oe=D(re))||ue&&re&&typeof re.length=="number"){oe&&(re=oe);var J=0;return function(){return J>=re.length?{done:!0}:{done:!1,value:re[J++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}_.defaults=A();function M(re){_.defaults=re}var $=/[&<>"']/,a=/[&<>"']/g,P=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,u={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(ue){return u[ue]};function h(re,ue){if(ue){if($.test(re))return re.replace(a,k)}else if(P.test(re))return re.replace(y,k);return re}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(re){return re.replace(r,function(ue,oe){return oe=oe.toLowerCase(),oe==="colon"?":":oe.charAt(0)==="#"?oe.charAt(1)==="x"?String.fromCharCode(parseInt(oe.substring(2),16)):String.fromCharCode(+oe.substring(1)):""})}var c=/(^|[^\[])\^/g;function f(re,ue){re=typeof re=="string"?re:re.source,ue=ue||"";var oe={replace:function(Y,we){return we=we.source||we,we=we.replace(c,"$1"),re=re.replace(Y,we),oe},getRegex:function(){return new RegExp(re,ue)}};return oe}var t=/[^\w:]/g,s=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function n(re,ue,oe){if(re){var J;try{J=decodeURIComponent(o(oe)).replace(t,"").toLowerCase()}catch{return null}if(J.indexOf("javascript:")===0||J.indexOf("vbscript:")===0||J.indexOf("data:")===0)return null}ue&&!s.test(oe)&&(oe=p(ue,oe));try{oe=encodeURI(oe).replace(/%25/g,"%")}catch{return null}return oe}var i={},g=/^[^:]+:\/*[^/]*$/,d=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(re,ue){i[" "+re]||(g.test(re)?i[" "+re]=re+"/":i[" "+re]=E(re,"/",!0)),re=i[" "+re];var oe=re.indexOf(":")===-1;return ue.substring(0,2)==="//"?oe?ue:re.replace(d,"$1")+ue:ue.charAt(0)==="/"?oe?ue:re.replace(l,"$1")+ue:re+ue}var C={exec:function(){}};function S(re){for(var ue=1,oe,J;ue<arguments.length;ue++){oe=arguments[ue];for(J in oe)Object.prototype.hasOwnProperty.call(oe,J)&&(re[J]=oe[J])}return re}function v(re,ue){var oe=re.replace(/\|/g,function(we,pe,Me){for(var Ve=!1,Se=pe;--Se>=0&&Me[Se]==="\\";)Ve=!Ve;return Ve?"|":" |"}),J=oe.split(/ \|/),Y=0;if(J[0].trim()||J.shift(),J.length>0&&!J[J.length-1].trim()&&J.pop(),J.length>ue)J.splice(ue);else for(;J.length<ue;)J.push("");for(;Y<J.length;Y++)J[Y]=J[Y].trim().replace(/\\\|/g,"|");return J}function E(re,ue,oe){var J=re.length;if(J===0)return"";for(var Y=0;Y<J;){var we=re.charAt(J-Y-1);if(we===ue&&!oe)Y++;else if(we!==ue&&oe)Y++;else break}return re.slice(0,J-Y)}function R(re,ue){if(re.indexOf(ue[1])===-1)return-1;for(var oe=re.length,J=0,Y=0;Y<oe;Y++)if(re[Y]==="\\")Y++;else if(re[Y]===ue[0])J++;else if(re[Y]===ue[1]&&(J--,J<0))return Y;return-1}function w(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function m(re,ue){if(ue<1)return"";for(var oe="";ue>1;)ue&1&&(oe+=re),ue>>=1,re+=re;return oe+re}function N(re,ue,oe,J){var Y=ue.href,we=ue.title?h(ue.title):null,pe=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){J.state.inLink=!0;var Me={type:"link",raw:oe,href:Y,title:we,text:pe,tokens:J.inlineTokens(pe)};return J.state.inLink=!1,Me}return{type:"image",raw:oe,href:Y,title:we,text:h(pe)}}function B(re,ue){var oe=re.match(/^(\s+)(?:```)/);if(oe===null)return ue;var J=oe[1];return ue.split(`
`).map(function(Y){var we=Y.match(/^\s+/);if(we===null)return Y;var pe=we[0];return pe.length>=J.length?Y.slice(J.length):Y}).join(`
`)}var X=function(){function re(oe){this.options=oe||_.defaults}var ue=re.prototype;return ue.space=function(J){var Y=this.rules.block.newline.exec(J);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},ue.code=function(J){var Y=this.rules.block.code.exec(J);if(Y){var we=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?we:E(we,`
`)}}},ue.fences=function(J){var Y=this.rules.block.fences.exec(J);if(Y){var we=Y[0],pe=B(we,Y[3]||"");return{type:"code",raw:we,lang:Y[2]?Y[2].trim():Y[2],text:pe}}},ue.heading=function(J){var Y=this.rules.block.heading.exec(J);if(Y){var we=Y[2].trim();if(/#$/.test(we)){var pe=E(we,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(we=pe.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:we,tokens:this.lexer.inline(we)}}},ue.hr=function(J){var Y=this.rules.block.hr.exec(J);if(Y)return{type:"hr",raw:Y[0]}},ue.blockquote=function(J){var Y=this.rules.block.blockquote.exec(J);if(Y){var we=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(we,[]),text:we}}},ue.list=function(J){var Y=this.rules.block.list.exec(J);if(Y){var we,pe,Me,Ve,Se,Pe,Te,U,W,G,K,x,ge=Y[1].trim(),Re=ge.length>1,Ue={type:"list",raw:"",ordered:Re,start:Re?+ge.slice(0,-1):"",loose:!1,items:[]};ge=Re?"\\d{1,9}\\"+ge.slice(-1):"\\"+ge,this.options.pedantic&&(ge=Re?ge:"[*+-]");for(var Ke=new RegExp("^( {0,3}"+ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");J&&(x=!1,!(!(Y=Ke.exec(J))||this.rules.block.hr.test(J)));){if(we=Y[0],J=J.substring(we.length),U=Y[2].split(`
`,1)[0],W=J.split(`
`,1)[0],this.options.pedantic?(Ve=2,K=U.trimLeft()):(Ve=Y[2].search(/[^ ]/),Ve=Ve>4?1:Ve,K=U.slice(Ve),Ve+=Y[1].length),Pe=!1,!U&&/^ *$/.test(W)&&(we+=W+`
`,J=J.substring(W.length+1),x=!0),!x)for(var Ze=new RegExp("^ {0,"+Math.min(3,Ve-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,Ve-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,Ve-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,Ve-1)+"}#");J&&(G=J.split(`
`,1)[0],U=G,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(U)||st.test(U)||Ze.test(U)||nt.test(J)));){if(U.search(/[^ ]/)>=Ve||!U.trim())K+=`
`+U.slice(Ve);else if(!Pe)K+=`
`+U;else break;!Pe&&!U.trim()&&(Pe=!0),we+=G+`
`,J=J.substring(G.length+1)}Ue.loose||(Te?Ue.loose=!0:/\n *\n *$/.test(we)&&(Te=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(K),pe&&(Me=pe[0]!=="[ ] ",K=K.replace(/^\[[ xX]\] +/,""))),Ue.items.push({type:"list_item",raw:we,task:!!pe,checked:Me,loose:!1,text:K}),Ue.raw+=we}Ue.items[Ue.items.length-1].raw=we.trimRight(),Ue.items[Ue.items.length-1].text=K.trimRight(),Ue.raw=Ue.raw.trimRight();var ot=Ue.items.length;for(Se=0;Se<ot;Se++){this.lexer.state.top=!1,Ue.items[Se].tokens=this.lexer.blockTokens(Ue.items[Se].text,[]);var $t=Ue.items[Se].tokens.filter(function(rt){return rt.type==="space"}),dt=$t.every(function(rt){for(var ut=rt.raw.split(""),gt=0,We=T(ut),je;!(je=We()).done;){var te=je.value;if(te===`
`&&(gt+=1),gt>1)return!0}return!1});!Ue.loose&&$t.length&&dt&&(Ue.loose=!0,Ue.items[Se].loose=!0)}return Ue}},ue.html=function(J){var Y=this.rules.block.html.exec(J);if(Y){var we={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(Y[0]):h(Y[0]);we.type="paragraph",we.text=pe,we.tokens=this.lexer.inline(pe)}return we}},ue.def=function(J){var Y=this.rules.block.def.exec(J);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var we=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:we,raw:Y[0],href:Y[2],title:Y[3]}}},ue.table=function(J){var Y=this.rules.block.table.exec(J);if(Y){var we={type:"table",header:v(Y[1]).map(function(Te){return{text:Te}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(we.header.length===we.align.length){we.raw=Y[0];var pe=we.align.length,Me,Ve,Se,Pe;for(Me=0;Me<pe;Me++)/^ *-+: *$/.test(we.align[Me])?we.align[Me]="right":/^ *:-+: *$/.test(we.align[Me])?we.align[Me]="center":/^ *:-+ *$/.test(we.align[Me])?we.align[Me]="left":we.align[Me]=null;for(pe=we.rows.length,Me=0;Me<pe;Me++)we.rows[Me]=v(we.rows[Me],we.header.length).map(function(Te){return{text:Te}});for(pe=we.header.length,Ve=0;Ve<pe;Ve++)we.header[Ve].tokens=this.lexer.inline(we.header[Ve].text);for(pe=we.rows.length,Ve=0;Ve<pe;Ve++)for(Pe=we.rows[Ve],Se=0;Se<Pe.length;Se++)Pe[Se].tokens=this.lexer.inline(Pe[Se].text);return we}}},ue.lheading=function(J){var Y=this.rules.block.lheading.exec(J);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},ue.paragraph=function(J){var Y=this.rules.block.paragraph.exec(J);if(Y){var we=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:we,tokens:this.lexer.inline(we)}}},ue.text=function(J){var Y=this.rules.block.text.exec(J);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},ue.escape=function(J){var Y=this.rules.inline.escape.exec(J);if(Y)return{type:"escape",raw:Y[0],text:h(Y[1])}},ue.tag=function(J){var Y=this.rules.inline.tag.exec(J);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):h(Y[0]):Y[0]}},ue.link=function(J){var Y=this.rules.inline.link.exec(J);if(Y){var we=Y[2].trim();if(!this.options.pedantic&&/^</.test(we)){if(!/>$/.test(we))return;var pe=E(we.slice(0,-1),"\\");if((we.length-pe.length)%2===0)return}else{var Me=R(Y[2],"()");if(Me>-1){var Ve=Y[0].indexOf("!")===0?5:4,Se=Ve+Y[1].length+Me;Y[2]=Y[2].substring(0,Me),Y[0]=Y[0].substring(0,Se).trim(),Y[3]=""}}var Pe=Y[2],Te="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);U&&(Pe=U[1],Te=U[3])}else Te=Y[3]?Y[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test(we)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),N(Y,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Te&&Te.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},ue.reflink=function(J,Y){var we;if((we=this.rules.inline.reflink.exec(J))||(we=this.rules.inline.nolink.exec(J))){var pe=(we[2]||we[1]).replace(/\s+/g," ");if(pe=Y[pe.toLowerCase()],!pe||!pe.href){var Me=we[0].charAt(0);return{type:"text",raw:Me,text:Me}}return N(we,pe,we[0],this.lexer)}},ue.emStrong=function(J,Y,we){we===void 0&&(we="");var pe=this.rules.inline.emStrong.lDelim.exec(J);if(pe&&!(pe[3]&&we.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Me=pe[1]||pe[2]||"";if(!Me||Me&&(we===""||this.rules.inline.punctuation.exec(we))){var Ve=pe[0].length-1,Se,Pe,Te=Ve,U=0,W=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(W.lastIndex=0,Y=Y.slice(-1*J.length+Ve);(pe=W.exec(Y))!=null;)if(Se=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Se){if(Pe=Se.length,pe[3]||pe[4]){Te+=Pe;continue}else if((pe[5]||pe[6])&&Ve%3&&!((Ve+Pe)%3)){U+=Pe;continue}if(Te-=Pe,!(Te>0)){if(Pe=Math.min(Pe,Pe+Te+U),Math.min(Ve,Pe)%2){var G=J.slice(1,Ve+pe.index+Pe);return{type:"em",raw:J.slice(0,Ve+pe.index+Pe+1),text:G,tokens:this.lexer.inlineTokens(G)}}var K=J.slice(2,Ve+pe.index+Pe-1);return{type:"strong",raw:J.slice(0,Ve+pe.index+Pe+1),text:K,tokens:this.lexer.inlineTokens(K)}}}}}},ue.codespan=function(J){var Y=this.rules.inline.code.exec(J);if(Y){var we=Y[2].replace(/\n/g," "),pe=/[^ ]/.test(we),Me=/^ /.test(we)&&/ $/.test(we);return pe&&Me&&(we=we.substring(1,we.length-1)),we=h(we,!0),{type:"codespan",raw:Y[0],text:we}}},ue.br=function(J){var Y=this.rules.inline.br.exec(J);if(Y)return{type:"br",raw:Y[0]}},ue.del=function(J){var Y=this.rules.inline.del.exec(J);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},ue.autolink=function(J,Y){var we=this.rules.inline.autolink.exec(J);if(we){var pe,Me;return we[2]==="@"?(pe=h(this.options.mangle?Y(we[1]):we[1]),Me="mailto:"+pe):(pe=h(we[1]),Me=pe),{type:"link",raw:we[0],text:pe,href:Me,tokens:[{type:"text",raw:pe,text:pe}]}}},ue.url=function(J,Y){var we;if(we=this.rules.inline.url.exec(J)){var pe,Me;if(we[2]==="@")pe=h(this.options.mangle?Y(we[0]):we[0]),Me="mailto:"+pe;else{var Ve;do Ve=we[0],we[0]=this.rules.inline._backpedal.exec(we[0])[0];while(Ve!==we[0]);pe=h(we[0]),we[1]==="www."?Me="http://"+pe:Me=pe}return{type:"link",raw:we[0],text:pe,href:Me,tokens:[{type:"text",raw:pe,text:pe}]}}},ue.inlineText=function(J,Y){var we=this.rules.inline.text.exec(J);if(we){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(we[0]):h(we[0]):we[0]:pe=h(this.options.smartypants?Y(we[0]):we[0]),{type:"text",raw:we[0],text:pe}}},re}(),V={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:C,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};V._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,V._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,V.def=f(V.def).replace("label",V._label).replace("title",V._title).getRegex(),V.bullet=/(?:[*+-]|\d{1,9}[.)])/,V.listItemStart=f(/^( *)(bull) */).replace("bull",V.bullet).getRegex(),V.list=f(V.list).replace(/bull/g,V.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+V.def.source+")").getRegex(),V._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",V._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,V.html=f(V.html,"i").replace("comment",V._comment).replace("tag",V._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),V.paragraph=f(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.blockquote=f(V.blockquote).replace("paragraph",V.paragraph).getRegex(),V.normal=S({},V),V.gfm=S({},V.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),V.gfm.table=f(V.gfm.table).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.gfm.paragraph=f(V._paragraph).replace("hr",V.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",V.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",V._tag).getRegex(),V.pedantic=S({},V.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",V._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:C,paragraph:f(V.normal._paragraph).replace("hr",V.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",V.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:C,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:C,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=f(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=f(V._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=f(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=f(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=f(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=f(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=f(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=f(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=f(O.reflink).replace("label",O._label).replace("ref",V._label).getRegex(),O.nolink=f(O.nolink).replace("ref",V._label).getRegex(),O.reflinkSearch=f(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=S({},O),O.pedantic=S({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=S({},O.normal,{escape:f(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=f(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=S({},O.gfm,{br:f(O.br).replace("{2,}","*").getRegex(),text:f(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function L(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(re){var ue="",oe,J,Y=re.length;for(oe=0;oe<Y;oe++)J=re.charCodeAt(oe),Math.random()>.5&&(J="x"+J.toString(16)),ue+="&#"+J+";";return ue}var ie=function(){function re(oe){this.tokens=[],this.tokens.links=Object.create(null),this.options=oe||_.defaults,this.options.tokenizer=this.options.tokenizer||new X,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var J={block:V.normal,inline:O.normal};this.options.pedantic?(J.block=V.pedantic,J.inline=O.pedantic):this.options.gfm&&(J.block=V.gfm,this.options.breaks?J.inline=O.breaks:J.inline=O.gfm),this.tokenizer.rules=J}re.lex=function(J,Y){var we=new re(Y);return we.lex(J)},re.lexInline=function(J,Y){var we=new re(Y);return we.inlineTokens(J)};var ue=re.prototype;return ue.lex=function(J){J=J.replace(/\r\n|\r/g,`
`),this.blockTokens(J,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},ue.blockTokens=function(J,Y){var we=this;Y===void 0&&(Y=[]),this.options.pedantic?J=J.replace(/\t/g,"    ").replace(/^ +$/gm,""):J=J.replace(/^( *)(\t+)/gm,function(Te,U,W){return U+"    ".repeat(W.length)});for(var pe,Me,Ve,Se;J;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Te){return(pe=Te.call({lexer:we},J,Y))?(J=J.substring(pe.raw.length),Y.push(pe),!0):!1}))){if(pe=this.tokenizer.space(J)){J=J.substring(pe.raw.length),pe.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(pe);continue}if(pe=this.tokenizer.code(J)){J=J.substring(pe.raw.length),Me=Y[Y.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+pe.raw,Me.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Y.push(pe);continue}if(pe=this.tokenizer.fences(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.heading(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.hr(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.blockquote(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.list(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.html(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.def(J)){J=J.substring(pe.raw.length),Me=Y[Y.length-1],Me&&(Me.type==="paragraph"||Me.type==="text")?(Me.raw+=`
`+pe.raw,Me.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Me.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.lheading(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(Ve=J,this.options.extensions&&this.options.extensions.startBlock&&function(){var Te=1/0,U=J.slice(1),W=void 0;we.options.extensions.startBlock.forEach(function(G){W=G.call({lexer:this},U),typeof W=="number"&&W>=0&&(Te=Math.min(Te,W))}),Te<1/0&&Te>=0&&(Ve=J.substring(0,Te+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(Ve))){Me=Y[Y.length-1],Se&&Me.type==="paragraph"?(Me.raw+=`
`+pe.raw,Me.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Y.push(pe),Se=Ve.length!==J.length,J=J.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(J)){J=J.substring(pe.raw.length),Me=Y[Y.length-1],Me&&Me.type==="text"?(Me.raw+=`
`+pe.raw,Me.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Me.text):Y.push(pe);continue}if(J){var Pe="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,Y},ue.inline=function(J,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:J,tokens:Y}),Y},ue.inlineTokens=function(J,Y){var we=this;Y===void 0&&(Y=[]);var pe,Me,Ve,Se=J,Pe,Te,U;if(this.tokens.links){var W=Object.keys(this.tokens.links);if(W.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(Se))!=null;)W.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(Se=Se.slice(0,Pe.index)+"["+m("a",Pe[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(Se))!=null;)Se=Se.slice(0,Pe.index)+"["+m("a",Pe[0].length-2)+"]"+Se.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(Se))!=null;)Se=Se.slice(0,Pe.index)+"++"+Se.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;J;)if(Te||(U=""),Te=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(K){return(pe=K.call({lexer:we},J,Y))?(J=J.substring(pe.raw.length),Y.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.tag(J)){J=J.substring(pe.raw.length),Me=Y[Y.length-1],Me&&pe.type==="text"&&Me.type==="text"?(Me.raw+=pe.raw,Me.text+=pe.text):Y.push(pe);continue}if(pe=this.tokenizer.link(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.reflink(J,this.tokens.links)){J=J.substring(pe.raw.length),Me=Y[Y.length-1],Me&&pe.type==="text"&&Me.type==="text"?(Me.raw+=pe.raw,Me.text+=pe.text):Y.push(pe);continue}if(pe=this.tokenizer.emStrong(J,Se,U)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.codespan(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.br(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.del(J)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(pe=this.tokenizer.autolink(J,F)){J=J.substring(pe.raw.length),Y.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(J,F))){J=J.substring(pe.raw.length),Y.push(pe);continue}if(Ve=J,this.options.extensions&&this.options.extensions.startInline&&function(){var K=1/0,x=J.slice(1),ge=void 0;we.options.extensions.startInline.forEach(function(Re){ge=Re.call({lexer:this},x),typeof ge=="number"&&ge>=0&&(K=Math.min(K,ge))}),K<1/0&&K>=0&&(Ve=J.substring(0,K+1))}(),pe=this.tokenizer.inlineText(Ve,L)){J=J.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(U=pe.raw.slice(-1)),Te=!0,Me=Y[Y.length-1],Me&&Me.type==="text"?(Me.raw+=pe.raw,Me.text+=pe.text):Y.push(pe);continue}if(J){var G="Infinite loop on byte: "+J.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return Y},b(re,null,[{key:"rules",get:function(){return{block:V,inline:O}}}]),re}(),de=function(){function re(oe){this.options=oe||_.defaults}var ue=re.prototype;return ue.code=function(J,Y,we){var pe=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Me=this.options.highlight(J,pe);Me!=null&&Me!==J&&(we=!0,J=Me)}return J=J.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+h(pe,!0)+'">'+(we?J:h(J,!0))+`</code></pre>
`:"<pre><code>"+(we?J:h(J,!0))+`</code></pre>
`},ue.blockquote=function(J){return`<blockquote>
`+J+`</blockquote>
`},ue.html=function(J){return J},ue.heading=function(J,Y,we,pe){if(this.options.headerIds){var Me=this.options.headerPrefix+pe.slug(we);return"<h"+Y+' id="'+Me+'">'+J+"</h"+Y+`>
`}return"<h"+Y+">"+J+"</h"+Y+`>
`},ue.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ue.list=function(J,Y,we){var pe=Y?"ol":"ul",Me=Y&&we!==1?' start="'+we+'"':"";return"<"+pe+Me+`>
`+J+"</"+pe+`>
`},ue.listitem=function(J){return"<li>"+J+`</li>
`},ue.checkbox=function(J){return"<input "+(J?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ue.paragraph=function(J){return"<p>"+J+`</p>
`},ue.table=function(J,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+J+`</thead>
`+Y+`</table>
`},ue.tablerow=function(J){return`<tr>
`+J+`</tr>
`},ue.tablecell=function(J,Y){var we=Y.header?"th":"td",pe=Y.align?"<"+we+' align="'+Y.align+'">':"<"+we+">";return pe+J+("</"+we+`>
`)},ue.strong=function(J){return"<strong>"+J+"</strong>"},ue.em=function(J){return"<em>"+J+"</em>"},ue.codespan=function(J){return"<code>"+J+"</code>"},ue.br=function(){return this.options.xhtml?"<br/>":"<br>"},ue.del=function(J){return"<del>"+J+"</del>"},ue.link=function(J,Y,we){if(J=n(this.options.sanitize,this.options.baseUrl,J),J===null)return we;var pe='<a href="'+h(J)+'"';return Y&&(pe+=' title="'+Y+'"'),pe+=">"+we+"</a>",pe},ue.image=function(J,Y,we){if(J=n(this.options.sanitize,this.options.baseUrl,J),J===null)return we;var pe='<img src="'+J+'" alt="'+we+'"';return Y&&(pe+=' title="'+Y+'"'),pe+=this.options.xhtml?"/>":">",pe},ue.text=function(J){return J},re}(),be=function(){function re(){}var ue=re.prototype;return ue.strong=function(J){return J},ue.em=function(J){return J},ue.codespan=function(J){return J},ue.del=function(J){return J},ue.html=function(J){return J},ue.text=function(J){return J},ue.link=function(J,Y,we){return""+we},ue.image=function(J,Y,we){return""+we},ue.br=function(){return""},re}(),ve=function(){function re(){this.seen={}}var ue=re.prototype;return ue.serialize=function(J){return J.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ue.getNextSafeSlug=function(J,Y){var we=J,pe=0;if(this.seen.hasOwnProperty(we)){pe=this.seen[J];do pe++,we=J+"-"+pe;while(this.seen.hasOwnProperty(we))}return Y||(this.seen[J]=pe,this.seen[we]=0),we},ue.slug=function(J,Y){Y===void 0&&(Y={});var we=this.serialize(J);return this.getNextSafeSlug(we,Y.dryrun)},re}(),Z=function(){function re(oe){this.options=oe||_.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new ve}re.parse=function(J,Y){var we=new re(Y);return we.parse(J)},re.parseInline=function(J,Y){var we=new re(Y);return we.parseInline(J)};var ue=re.prototype;return ue.parse=function(J,Y){Y===void 0&&(Y=!0);var we="",pe,Me,Ve,Se,Pe,Te,U,W,G,K,x,ge,Re,Ue,Ke,Ze,nt,it,st,ot=J.length;for(pe=0;pe<ot;pe++){if(K=J[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[K.type]&&(st=this.options.extensions.renderers[K.type].call({parser:this},K),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(K.type))){we+=st||"";continue}switch(K.type){case"space":continue;case"hr":{we+=this.renderer.hr();continue}case"heading":{we+=this.renderer.heading(this.parseInline(K.tokens),K.depth,o(this.parseInline(K.tokens,this.textRenderer)),this.slugger);continue}case"code":{we+=this.renderer.code(K.text,K.lang,K.escaped);continue}case"table":{for(W="",U="",Se=K.header.length,Me=0;Me<Se;Me++)U+=this.renderer.tablecell(this.parseInline(K.header[Me].tokens),{header:!0,align:K.align[Me]});for(W+=this.renderer.tablerow(U),G="",Se=K.rows.length,Me=0;Me<Se;Me++){for(Te=K.rows[Me],U="",Pe=Te.length,Ve=0;Ve<Pe;Ve++)U+=this.renderer.tablecell(this.parseInline(Te[Ve].tokens),{header:!1,align:K.align[Ve]});G+=this.renderer.tablerow(U)}we+=this.renderer.table(W,G);continue}case"blockquote":{G=this.parse(K.tokens),we+=this.renderer.blockquote(G);continue}case"list":{for(x=K.ordered,ge=K.start,Re=K.loose,Se=K.items.length,G="",Me=0;Me<Se;Me++)Ke=K.items[Me],Ze=Ke.checked,nt=Ke.task,Ue="",Ke.task&&(it=this.renderer.checkbox(Ze),Re?Ke.tokens.length>0&&Ke.tokens[0].type==="paragraph"?(Ke.tokens[0].text=it+" "+Ke.tokens[0].text,Ke.tokens[0].tokens&&Ke.tokens[0].tokens.length>0&&Ke.tokens[0].tokens[0].type==="text"&&(Ke.tokens[0].tokens[0].text=it+" "+Ke.tokens[0].tokens[0].text)):Ke.tokens.unshift({type:"text",text:it}):Ue+=it),Ue+=this.parse(Ke.tokens,Re),G+=this.renderer.listitem(Ue,nt,Ze);we+=this.renderer.list(G,x,ge);continue}case"html":{we+=this.renderer.html(K.text);continue}case"paragraph":{we+=this.renderer.paragraph(this.parseInline(K.tokens));continue}case"text":{for(G=K.tokens?this.parseInline(K.tokens):K.text;pe+1<ot&&J[pe+1].type==="text";)K=J[++pe],G+=`
`+(K.tokens?this.parseInline(K.tokens):K.text);we+=Y?this.renderer.paragraph(G):G;continue}default:{var $t='Token with "'+K.type+'" type was not found.';if(this.options.silent){console.error($t);return}else throw new Error($t)}}}return we},ue.parseInline=function(J,Y){Y=Y||this.renderer;var we="",pe,Me,Ve,Se=J.length;for(pe=0;pe<Se;pe++){if(Me=J[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Me.type]&&(Ve=this.options.extensions.renderers[Me.type].call({parser:this},Me),Ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Me.type))){we+=Ve||"";continue}switch(Me.type){case"escape":{we+=Y.text(Me.text);break}case"html":{we+=Y.html(Me.text);break}case"link":{we+=Y.link(Me.href,Me.title,this.parseInline(Me.tokens,Y));break}case"image":{we+=Y.image(Me.href,Me.title,Me.text);break}case"strong":{we+=Y.strong(this.parseInline(Me.tokens,Y));break}case"em":{we+=Y.em(this.parseInline(Me.tokens,Y));break}case"codespan":{we+=Y.codespan(Me.text);break}case"br":{we+=Y.br();break}case"del":{we+=Y.del(this.parseInline(Me.tokens,Y));break}case"text":{we+=Y.text(Me.text);break}default:{var Pe='Token with "'+Me.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return we},re}();function ae(re,ue,oe){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof ue=="function"&&(oe=ue,ue=null),ue=S({},ae.defaults,ue||{}),w(ue),oe){var J=ue.highlight,Y;try{Y=ie.lex(re,ue)}catch(Se){return oe(Se)}var we=function(Pe){var Te;if(!Pe)try{ue.walkTokens&&ae.walkTokens(Y,ue.walkTokens),Te=Z.parse(Y,ue)}catch(U){Pe=U}return ue.highlight=J,Pe?oe(Pe):oe(null,Te)};if(!J||J.length<3||(delete ue.highlight,!Y.length))return we();var pe=0;ae.walkTokens(Y,function(Se){Se.type==="code"&&(pe++,setTimeout(function(){J(Se.text,Se.lang,function(Pe,Te){if(Pe)return we(Pe);Te!=null&&Te!==Se.text&&(Se.text=Te,Se.escaped=!0),pe--,pe===0&&we()})},0))}),pe===0&&we();return}function Me(Se){if(Se.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+h(Se.message+"",!0)+"</pre>";throw Se}try{var Ve=ie.lex(re,ue);if(ue.walkTokens){if(ue.async)return Promise.all(ae.walkTokens(Ve,ue.walkTokens)).then(function(){return Z.parse(Ve,ue)}).catch(Me);ae.walkTokens(Ve,ue.walkTokens)}return Z.parse(Ve,ue)}catch(Se){Me(Se)}}ae.options=ae.setOptions=function(re){return S(ae.defaults,re),M(ae.defaults),ae},ae.getDefaults=A,ae.defaults=_.defaults,ae.use=function(){for(var re=arguments.length,ue=new Array(re),oe=0;oe<re;oe++)ue[oe]=arguments[oe];var J=S.apply(void 0,[{}].concat(ue)),Y=ae.defaults.extensions||{renderers:{},childTokens:{}},we;ue.forEach(function(pe){if(pe.extensions&&(we=!0,pe.extensions.forEach(function(Ve){if(!Ve.name)throw new Error("extension name required");if(Ve.renderer){var Se=Y.renderers?Y.renderers[Ve.name]:null;Se?Y.renderers[Ve.name]=function(){for(var Pe=arguments.length,Te=new Array(Pe),U=0;U<Pe;U++)Te[U]=arguments[U];var W=Ve.renderer.apply(this,Te);return W===!1&&(W=Se.apply(this,Te)),W}:Y.renderers[Ve.name]=Ve.renderer}if(Ve.tokenizer){if(!Ve.level||Ve.level!=="block"&&Ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[Ve.level]?Y[Ve.level].unshift(Ve.tokenizer):Y[Ve.level]=[Ve.tokenizer],Ve.start&&(Ve.level==="block"?Y.startBlock?Y.startBlock.push(Ve.start):Y.startBlock=[Ve.start]:Ve.level==="inline"&&(Y.startInline?Y.startInline.push(Ve.start):Y.startInline=[Ve.start]))}Ve.childTokens&&(Y.childTokens[Ve.name]=Ve.childTokens)})),pe.renderer&&function(){var Ve=ae.defaults.renderer||new de,Se=function(U){var W=Ve[U];Ve[U]=function(){for(var G=arguments.length,K=new Array(G),x=0;x<G;x++)K[x]=arguments[x];var ge=pe.renderer[U].apply(Ve,K);return ge===!1&&(ge=W.apply(Ve,K)),ge}};for(var Pe in pe.renderer)Se(Pe);J.renderer=Ve}(),pe.tokenizer&&function(){var Ve=ae.defaults.tokenizer||new X,Se=function(U){var W=Ve[U];Ve[U]=function(){for(var G=arguments.length,K=new Array(G),x=0;x<G;x++)K[x]=arguments[x];var ge=pe.tokenizer[U].apply(Ve,K);return ge===!1&&(ge=W.apply(Ve,K)),ge}};for(var Pe in pe.tokenizer)Se(Pe);J.tokenizer=Ve}(),pe.walkTokens){var Me=ae.defaults.walkTokens;J.walkTokens=function(Ve){var Se=[];return Se.push(pe.walkTokens.call(this,Ve)),Me&&(Se=Se.concat(Me.call(this,Ve))),Se}}we&&(J.extensions=Y),ae.setOptions(J)})},ae.walkTokens=function(re,ue){for(var oe=[],J=function(){var Me=we.value;switch(oe=oe.concat(ue.call(ae,Me)),Me.type){case"table":{for(var Ve=T(Me.header),Se;!(Se=Ve()).done;){var Pe=Se.value;oe=oe.concat(ae.walkTokens(Pe.tokens,ue))}for(var Te=T(Me.rows),U;!(U=Te()).done;)for(var W=U.value,G=T(W),K;!(K=G()).done;){var x=K.value;oe=oe.concat(ae.walkTokens(x.tokens,ue))}break}case"list":{oe=oe.concat(ae.walkTokens(Me.items,ue));break}default:ae.defaults.extensions&&ae.defaults.extensions.childTokens&&ae.defaults.extensions.childTokens[Me.type]?ae.defaults.extensions.childTokens[Me.type].forEach(function(ge){oe=oe.concat(ae.walkTokens(Me[ge],ue))}):Me.tokens&&(oe=oe.concat(ae.walkTokens(Me.tokens,ue)))}},Y=T(re),we;!(we=Y()).done;)J();return oe},ae.parseInline=function(re,ue){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");ue=S({},ae.defaults,ue||{}),w(ue);try{var oe=ie.lexInline(re,ue);return ue.walkTokens&&ae.walkTokens(oe,ue.walkTokens),Z.parseInline(oe,ue)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ue.silent)return"<p>An error occurred:</p><pre>"+h(J.message+"",!0)+"</pre>";throw J}},ae.Parser=Z,ae.parser=Z.parse,ae.Renderer=de,ae.TextRenderer=be,ae.Lexer=ie,ae.lexer=ie.lex,ae.Tokenizer=X,ae.Slugger=ve,ae.parse=ae;var fe=ae.options,ee=ae.setOptions,De=ae.use,Fe=ae.walkTokens,ce=ae.parseInline,H=ae,he=Z.parse,le=ie.lex;_.Lexer=ie,_.Parser=Z,_.Renderer=de,_.Slugger=ve,_.TextRenderer=be,_.Tokenizer=X,_.getDefaults=A,_.lexer=le,_.marked=ae,_.options=fe,_.parse=H,_.parseInline=ce,_.parser=he,_.setOptions=ee,_.use=De,_.walkTokens=Fe,Object.defineProperty(_,"__esModule",{value:!0})}),define(Ce[136],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zk=b;function b(r){const o=T(r);if(o&&o.length>0)return new Uint32Array(o)}let D=0;const I=new Uint32Array(10);function T(r){if(D=0,A(r,y,$.InitialConsonant),D>0||(A(r,u,$.Vowel),D>0)||(A(r,k,$.FinalConsonant),D>0)||(A(r,h,$.CompatibilityJamo),D))return I.subarray(0,D);if(r>=44032&&r<=55203){const o=r-44032,c=o%588,f=Math.floor(o/588),t=Math.floor(c/28),s=c%28-1;if(f<y.length?A(f,y,0):$.InitialConsonant+f-$.CompatibilityJamo<h.length&&A($.InitialConsonant+f,h,$.CompatibilityJamo),t<u.length?A(t,u,0):$.Vowel+t-$.CompatibilityJamo<h.length&&A($.Vowel+t-$.CompatibilityJamo,h,$.CompatibilityJamo),s>=0&&(s<k.length?A(s,k,0):$.FinalConsonant+s-$.CompatibilityJamo<h.length&&A($.FinalConsonant+s-$.CompatibilityJamo,h,$.CompatibilityJamo)),D>0)return I.subarray(0,D)}}function A(r,o,c){r>=c&&r<c+o.length&&M(o[r-c])}function M(r){r!==a.NUL&&(I[D++]=r&255,r>>8&&(I[D++]=r>>8&255),r>>16&&(I[D++]=r>>16&255))}var $;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var a;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(a||(a={}));var P;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(P||(P={}));const y=new Uint8Array([a.r,a.R,a.s,a.e,a.E,a.f,a.a,a.q,a.Q,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g]),u=new Uint16Array([a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,P.hk,P.ho,P.hl,a.y,a.n,P.nj,P.np,P.nl,a.b,a.m,P.ml,a.l]),k=new Uint16Array([a.r,a.R,P.rt,a.s,P.sw,P.sg,a.e,a.f,P.fr,P.fa,P.fq,P.ft,P.fx,P.fv,P.fg,a.a,a.q,P.qt,a.t,a.T,a.d,a.w,a.c,a.z,a.x,a.v,a.g]),h=new Uint16Array([a.r,a.R,P.rt,a.s,P.sw,P.sg,a.e,a.E,a.f,P.fr,P.fa,P.fq,P.ft,P.fx,P.fv,P.fg,a.a,a.q,a.Q,P.qt,a.t,a.T,a.d,a.w,a.W,a.c,a.z,a.x,a.v,a.g,a.k,a.o,a.i,a.O,a.j,a.p,a.u,a.P,a.h,P.hk,P.ho,P.hl,a.y,a.n,P.nj,P.np,P.nl,a.b,a.m,P.ml,a.l])}),define(Ce[137],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=void 0,e.$Hm=b,e.rot=D;function b(M,$,a){return Math.min(Math.max(M,$),a)}function D(M,$){return($+M%$)%$}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Jm=I;class T{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Km=T;class A{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const a=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Lm=A}),define(Ce[138],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=T,e.$cd=u;class b{constructor(h,r,o){this.owner=h,this.debugNameSource=r,this.referenceFn=o}getDebugName(h){return T(h,this)}}e.$ad=b;const D=new Map,I=new WeakMap;function T(k,h){const r=I.get(k);if(r)return r;const o=A(k,h);if(o){let c=D.get(o)??0;c++,D.set(o,c);const f=c===1?o:`${o}#${c}`;return I.set(k,f),f}}function A(k,h){const r=I.get(k);if(r)return r;const o=h.owner?P(h.owner)+".":"";let c;const f=h.debugNameSource;if(f!==void 0)if(typeof f=="function"){if(c=f(),c!==void 0)return o+c}else return o+f;const t=h.referenceFn;if(t!==void 0&&(c=u(t),c!==void 0))return o+c;if(h.owner!==void 0){const s=M(h.owner,k);if(s!==void 0)return o+s}}function M(k,h){for(const r in k)if(k[r]===h)return r}const $=new Map,a=new WeakMap;function P(k){const h=a.get(k);if(h)return h;const r=y(k);let o=$.get(r)??0;o++,$.set(r,o);const c=o===1?r:`${r}#${o}`;return a.set(k,c),c}function y(k){const h=k.constructor;return h?h.name:"Object"}function u(k){const h=k.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(h);return(o?o[1]:void 0)?.trim()}}),define(Ce[139],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=D,e.$Id=I;let b;function D(r){b=r}function I(){return b}class T{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([M(k("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[M(" "),a(P(o.oldValue,70),{color:"red",strikeThrough:!0}),M(" "),a(P(o.newValue,60),{color:"green"})]:[M(" (unchanged)")]:[M(" "),a(P(o.newValue,60),{color:"green"}),M(" (initial)")]}handleObservableChanged(o,c){console.log(...this.b([$("observable value changed"),a(o.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(o){if(o.size!==0)return a(" (changed deps: "+[...o].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const c=o.handleChange;this.d.set(o,new Set),o.handleChange=(f,t)=>(this.d.get(o).add(f),c.apply(o,[f,t]))}handleDerivedRecomputed(o,c){const f=this.d.get(o);console.log(...this.b([$("derived recomputed"),a(o.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(f),{data:[{fn:o._computeFn}]}])),f.clear()}handleFromEventObservableTriggered(o,c){console.log(...this.b([$("observable from event triggered"),a(o.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const c=o.handleChange;this.d.set(o,new Set),o.handleChange=(f,t)=>(this.d.get(o).add(f),c.apply(o,[f,t]))}handleAutorunTriggered(o){const c=this.d.get(o);console.log(...this.b([$("autorun"),a(o.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:o._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let c=o.getDebugName();c===void 0&&(c=""),console.log(...this.b([$("transaction"),a(c,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=T;function A(r){const o=new Array,c=[];let f="";function t(n){if("length"in n)for(const i of n)i&&t(i);else"text"in n?(f+=`%c${n.text}`,o.push(n.style),n.data&&c.push(...n.data)):"data"in n&&c.push(...n.data)}t(r);const s=[f,...o];return s.push(...c),s}function M(r){return a(r,{color:"black"})}function $(r){return a(h(`${r}: `,10),{color:"black",bold:!0})}function a(r,o={color:"black"}){function c(t){return Object.entries(t).reduce((s,[n,i])=>`${s}${n}:${i};`,"")}const f={color:o.color};return o.strikeThrough&&(f["text-decoration"]="line-through"),o.bold&&(f["font-weight"]="bold"),{text:r,style:c(f)}}function P(r,o){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=o?`"${r}"`:`"${r.substr(0,o-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?y(r,o):u(r,o);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function y(r,o){let c="[ ",f=!0;for(const t of r){if(f||(c+=", "),c.length-5>o){c+="...";break}f=!1,c+=`${P(t,o-c.length)}`}return c+=" ]",c}function u(r,o){let c="{ ",f=!0;for(const[t,s]of Object.entries(r)){if(f||(c+=", "),c.length-5>o){c+="...";break}f=!1,c+=`${t}: ${P(s,o-c.length)}`}return c+=" }",c}function k(r,o){let c="";for(let f=1;f<=o;f++)c+=r;return c}function h(r,o){for(;r.length<o;)r+=" ";return r}}),define(Ce[140],Ie([1,0,133,138,139]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=A,e.$Td=$,e.$Ud=P,e.$Xd=k,e.$Yd=r,e.$Zd=o,e.$1d=c,e.$3d=t,e.$4d=s,e.$6d=i;let T;function A(d){T=d}let M;function $(d){M=d}let a;function P(d){a=d}class y{get TChange(){return null}reportChanges(){this.get()}read(l){return l?l.readObservable(this):this.get()}map(l,p){const C=p===void 0?void 0:l,S=p===void 0?l:p;return a({owner:C,debugName:()=>{const v=(0,D.$cd)(S);if(v!==void 0)return v;const R=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(S.toString());if(R)return`${this.debugName}.${R[2]}`;if(!C)return`${this.debugName} (mapped)`},debugReferenceFn:S},v=>S(this.read(v),v))}recomputeInitiallyAndOnChange(l,p){return l.add(T(this,p)),this}keepObserved(l){return l.add(M(this)),this}get a(){return this.get()}}e.$Vd=y;class u extends y{constructor(){super(...arguments),this.b=new Set}addObserver(l){const p=this.b.size;this.b.add(l),p===0&&this.c()}removeObserver(l){this.b.delete(l)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=u;function k(d,l){const p=new f(d,l);try{d(p)}finally{p.finish()}}let h;function r(d){if(h)d(h);else{const l=new f(d,void 0);h=l;try{d(l)}finally{l.finish(),h=void 0}}}async function o(d,l){const p=new f(d,l);try{await d(p)}finally{p.finish()}}function c(d,l,p){d?l(d):k(l,p)}class f{constructor(l,p){this._fn=l,this.b=p,this.a=[],(0,I.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,D.$cd)(this._fn)}updateObserver(l,p){this.a.push({observer:l,observable:p}),l.beginUpdate(p)}finish(){const l=this.a;for(let p=0;p<l.length;p++){const{observer:C,observable:S}=l[p];C.endUpdate(S)}this.a=null,(0,I.$Id)()?.handleEndTransaction()}}e.$2d=f;function t(d,l){let p;return typeof d=="string"?p=new D.$ad(void 0,d,void 0):p=new D.$ad(d,void 0,void 0),new n(p,l,b.$6c)}function s(d,l){return new n(new D.$ad(d.owner,d.debugName,void 0),l,d.equalsFn??b.$6c)}class n extends u{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(l,p,C){super(),this.e=l,this.g=C,this.d=p}get(){return this.d}set(l,p,C){if(C===void 0&&this.g(this.d,l))return;let S;p||(p=S=new f(()=>{},()=>`Setting ${this.debugName}`));try{const v=this.d;this.h(l),(0,I.$Id)()?.handleObservableChanged(this,{oldValue:v,newValue:l,change:C,didChange:!0,hadValue:!0});for(const E of this.b)p.updateObserver(E,this),E.handleChange(this,C)}finally{S&&S.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(l){this.d=l}}e.$5d=n;function i(d,l){let p;return typeof d=="string"?p=new D.$ad(void 0,d,void 0):p=new D.$ad(d,void 0,void 0),new g(p,l,b.$6c)}class g extends n{h(l){this.d!==l&&(this.d&&this.d.dispose(),this.d=l)}dispose(){this.d?.dispose()}}e.$7d=g}),function(){function _(I){const T=[];typeof I=="number"&&T.push("code/timeOrigin",I);function A($){T.push($,Date.now())}function M(){const $=[];for(let a=0;a<T.length;a+=2)$.push({name:T[a],startTime:T[a+1]});return $}return{mark:A,getMarks:M}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?_():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(I+A.startTime)});return T}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return _(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),_()}function b(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return b(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=b(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=b(D))}(),define(Ce[141],Ie([1,0,40]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OO=void 0;const D=Symbol("unset");class I{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||b.Iterable.empty()}insert($,a,P){this.d($,y=>y._value=a,P)}mutate($,a){this.d($,P=>P._value=a(P._value===D?void 0:P._value))}mutatePath($,a){this.d($,()=>{},P=>a(P))}delete($){const a=this.c($);if(!a)return;let P=a.length-1;const y=a[P].node._value;if(y!==D){for(this.b--,a[P].node._value=D;P>0;P--){const{node:u,part:k}=a[P];if(u.children?.size||u._value!==D)break;a[P-1].node.children.delete(k)}return y}}*deleteRecursive($){const a=this.c($);if(!a)return;const P=a[a.length-1].node;for(let y=a.length-1;y>0;y--){const u=a[y-1];if(u.node.children.delete(a[y].part),u.node.children.size>0||u.node._value!==D)break}for(const y of T(P))y._value!==D&&(this.b--,yield y._value)}find($){let a=this.a;for(const P of $){const y=a.children?.get(P);if(!y)return;a=y}return a._value===D?void 0:a._value}hasKeyOrParent($){let a=this.a;for(const P of $){const y=a.children?.get(P);if(!y)return!1;if(y._value!==D)return!0;a=y}return!1}hasKeyOrChildren($){let a=this.a;for(const P of $){const y=a.children?.get(P);if(!y)return!1;a=y}return!0}hasKey($){let a=this.a;for(const P of $){const y=a.children?.get(P);if(!y)return!1;a=y}return a._value!==D}c($){const a=[{part:"",node:this.a}];let P=0;for(const y of $){const u=a[P].node.children?.get(y);if(!u)return;a.push({part:y,node:u}),P++}return a}d($,a,P){let y=this.a;for(const h of $){if(y.children)if(y.children.has(h))y=y.children.get(h);else{const r=new A;y.children.set(h,r),y=r}else{const r=new A;y.children=new Map([[h,r]]),y=r}P?.(y)}const u=y._value===D?0:1;a(y);const k=y._value===D?0:1;this.b+=k-u}*values(){for(const{_value:$}of T(this.a))$!==D&&(yield $)}}e.$OO=I;function*T(M){const $=[M];for(;$.length>0;){const a=$.pop();if(yield a,a.children)for(const P of a.children.values())$.push(P)}}class A{constructor(){this._value=D}get value(){return this._value===D?void 0:this._value}set value($){this._value=$===void 0?D:$}}}),define(Ce[142],Ie([1,0,47,20]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=M,e.$qr=$,e.$rr=a,e.$sr=P,e.$tr=y,e.$ur=u,e.$vr=k,e.$wr=h,e.$xr=r,e.$yr=o,e.$zr=p,e.$Ar=C,e.$Br=S;const I=new b.$V(()=>{const v=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:v,collatorIsNumeric:v.resolvedOptions().numeric}}),T=new b.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new b.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function M(v,E,R=!1){const w=v||"",m=E||"",N=I.value.collator.compare(w,m);return I.value.collatorIsNumeric&&N===0&&w!==m?w<m?-1:1:N}function $(v,E){const R=T.value.collator;return v=v||"",E=E||"",s(R,v,E)}function a(v,E){const R=T.value.collator;return v=v||"",E=E||"",d(v,E)||s(R,v,E)}function P(v,E){const R=T.value.collator;return v=v||"",E=E||"",g(v,E)||s(R,v,E)}function y(v,E){return v=v||"",E=E||"",v===E?0:v<E?-1:1}function u(v,E){const[R,w]=f(v),[m,N]=f(E);let B=I.value.collator.compare(w,N);if(B===0){if(I.value.collatorIsNumeric&&w!==N)return w<N?-1:1;if(B=I.value.collator.compare(R,m),I.value.collatorIsNumeric&&B===0&&R!==m)return R<m?-1:1}return B}function k(v,E){v=v||"",E=E||"";const R=t(v),w=t(E),m=T.value.collator,N=A.value.collator;return s(N,R,w)||s(m,v,E)}function h(v,E){v=v||"",E=E||"";const R=t(v),w=t(E),m=T.value.collator,N=A.value.collator;return s(N,R,w)||d(v,E)||s(m,v,E)}function r(v,E){v=v||"",E=E||"";const R=t(v),w=t(E),m=T.value.collator,N=A.value.collator;return s(N,R,w)||g(v,E)||s(m,v,E)}function o(v,E){v=v||"",E=E||"";const R=t(v).toLowerCase(),w=t(E).toLowerCase();return R!==w?R<w?-1:1:v!==E?v<E?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function f(v,E=!1){const R=v?c.exec(v):[];let w=[R&&R[1]||"",R&&R[3]||""];return E&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function t(v){const E=v?c.exec(v):[];return E&&E[1]&&E[1].charAt(0)!=="."&&E[3]||""}function s(v,E,R){const w=v.compare(E,R);return w!==0?w:E.length!==R.length?E.length<R.length?-1:1:0}function n(v){const E=v.charAt(0);return E.toLocaleUpperCase()!==E}function i(v){const E=v.charAt(0);return E.toLocaleLowerCase()!==E}function g(v,E){return n(v)&&i(E)?-1:i(v)&&n(E)?1:0}function d(v,E){return i(v)&&n(E)?-1:n(v)&&i(E)?1:0}function l(v,E,R=!1){return R||(v=v&&v.toLowerCase(),E=E&&E.toLowerCase()),v===E?0:v<E?-1:1}function p(v,E,R=!1){const w=v.split(D.sep),m=E.split(D.sep),N=w.length-1,B=m.length-1;let X,V;for(let O=0;;O++){if(X=N===O,V=B===O,X&&V)return M(w[O],m[O],R);if(X)return-1;if(V)return 1;const L=l(w[O],m[O],R);if(L!==0)return L}}function C(v,E,R){const w=v.toLowerCase(),m=E.toLowerCase(),N=S(v,E,R);if(N)return N;const B=w.endsWith(R),X=m.endsWith(R);if(B!==X)return B?-1:1;const V=M(w,m);return V!==0?V:w.localeCompare(m)}function S(v,E,R){const w=v.toLowerCase(),m=E.toLowerCase(),N=w.startsWith(R),B=m.startsWith(R);if(N!==B)return N?-1:1;if(N&&B){if(w.length<m.length)return-1;if(w.length>m.length)return 1}return 0}}),define(Ce[73],Ie([1,0,20]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=void 0,e.$1s=T,e.$2s=A,e.$3s=M,e.$4s=a,e.$Zs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const D={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(P){const y=(0,b.$oc)(P),u=D[y.toLowerCase()];return u!==void 0?u:A(P)}function A(P){const y=(0,b.$oc)(P);return I[y.toLowerCase()]}function M(P){for(const y in I)if(I[y]===P)return y}const $=/^(.+)\/(.+?)(;.+)?$/;function a(P,y){const u=$.exec(P);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${u[3]??""}`:y?void 0:P}}),function(_,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var b=e();for(var D in b)(typeof exports=="object"?exports:_)[D]=b[D]}}(typeof self<"u"?self:this,function(){return function(_){var e={};function b(D){if(e[D])return e[D].exports;var I=e[D]={i:D,l:!1,exports:{}};return _[D].call(I.exports,I,I.exports,b),I.l=!0,I.exports}return b.m=_,b.c=e,b.d=function(D,I,T){b.o(D,I)||Object.defineProperty(D,I,{enumerable:!0,get:T})},b.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},b.t=function(D,I){if(1&I&&(D=b(D)),8&I||4&I&&typeof D=="object"&&D&&D.__esModule)return D;var T=Object.create(null);if(b.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:D}),2&I&&typeof D!="string")for(var A in D)b.d(T,A,function(M){return D[M]}.bind(null,A));return T},b.n=function(D){var I=D&&D.__esModule?function(){return D.default}:function(){return D};return b.d(I,"a",I),I},b.o=function(D,I){return Object.prototype.hasOwnProperty.call(D,I)},b.p="",b(b.s=0)}([function(_,e,b){(function(D){var I;e=_.exports=De,I=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var W=Array.prototype.slice.call(arguments,0);W.unshift("SEMVER"),console.log.apply(console,W)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,M=e.re=[],$=e.src=[],a=0,P=a++;$[P]="0|[1-9]\\d*";var y=a++;$[y]="[0-9]+";var u=a++;$[u]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=a++;$[k]="("+$[P]+")\\.("+$[P]+")\\.("+$[P]+")";var h=a++;$[h]="("+$[y]+")\\.("+$[y]+")\\.("+$[y]+")";var r=a++;$[r]="(?:"+$[P]+"|"+$[u]+")";var o=a++;$[o]="(?:"+$[y]+"|"+$[u]+")";var c=a++;$[c]="(?:-("+$[r]+"(?:\\."+$[r]+")*))";var f=a++;$[f]="(?:-?("+$[o]+"(?:\\."+$[o]+")*))";var t=a++;$[t]="[0-9A-Za-z-]+";var s=a++;$[s]="(?:\\+("+$[t]+"(?:\\."+$[t]+")*))";var n=a++,i="v?"+$[k]+$[c]+"?"+$[s]+"?";$[n]="^"+i+"$";var g="[v=\\s]*"+$[h]+$[f]+"?"+$[s]+"?",d=a++;$[d]="^"+g+"$";var l=a++;$[l]="((?:<|>)?=?)";var p=a++;$[p]=$[y]+"|x|X|\\*";var C=a++;$[C]=$[P]+"|x|X|\\*";var S=a++;$[S]="[v=\\s]*("+$[C]+")(?:\\.("+$[C]+")(?:\\.("+$[C]+")(?:"+$[c]+")?"+$[s]+"?)?)?";var v=a++;$[v]="[v=\\s]*("+$[p]+")(?:\\.("+$[p]+")(?:\\.("+$[p]+")(?:"+$[f]+")?"+$[s]+"?)?)?";var E=a++;$[E]="^"+$[l]+"\\s*"+$[S]+"$";var R=a++;$[R]="^"+$[l]+"\\s*"+$[v]+"$";var w=a++;$[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var m=a++;$[m]="(?:~>?)";var N=a++;$[N]="(\\s*)"+$[m]+"\\s+",M[N]=new RegExp($[N],"g");var B=a++;$[B]="^"+$[m]+$[S]+"$";var X=a++;$[X]="^"+$[m]+$[v]+"$";var V=a++;$[V]="(?:\\^)";var O=a++;$[O]="(\\s*)"+$[V]+"\\s+",M[O]=new RegExp($[O],"g");var L=a++;$[L]="^"+$[V]+$[S]+"$";var F=a++;$[F]="^"+$[V]+$[v]+"$";var ie=a++;$[ie]="^"+$[l]+"\\s*("+g+")$|^$";var de=a++;$[de]="^"+$[l]+"\\s*("+i+")$|^$";var be=a++;$[be]="(\\s*)"+$[l]+"\\s*("+g+"|"+$[S]+")",M[be]=new RegExp($[be],"g");var ve=a++;$[ve]="^\\s*("+$[S]+")\\s+-\\s+("+$[S]+")\\s*$";var Z=a++;$[Z]="^\\s*("+$[v]+")\\s+-\\s+("+$[v]+")\\s*$";var ae=a++;$[ae]="(<|>)?=?\\s*\\*";for(var fe=0;fe<35;fe++)I(fe,$[fe]),M[fe]||(M[fe]=new RegExp($[fe]));function ee(W,G){if(W instanceof De)return W;if(typeof W!="string"||W.length>T||!(G?M[d]:M[n]).test(W))return null;try{return new De(W,G)}catch{return null}}function De(W,G){if(W instanceof De){if(W.loose===G)return W;W=W.version}else if(typeof W!="string")throw new TypeError("Invalid Version: "+W);if(W.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof De))return new De(W,G);I("SemVer",W,G),this.loose=G;var K=W.trim().match(G?M[d]:M[n]);if(!K)throw new TypeError("Invalid Version: "+W);if(this.raw=W,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(x){if(/^[0-9]+$/.test(x)){var ge=+x;if(ge>=0&&ge<A)return ge}return x}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=ee,e.valid=function(W,G){var K=ee(W,G);return K?K.version:null},e.clean=function(W,G){var K=ee(W.trim().replace(/^[=v]+/,""),G);return K?K.version:null},e.SemVer=De,De.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},De.prototype.toString=function(){return this.version},De.prototype.compare=function(W){return I("SemVer.compare",this.version,this.loose,W),W instanceof De||(W=new De(W,this.loose)),this.compareMain(W)||this.comparePre(W)},De.prototype.compareMain=function(W){return W instanceof De||(W=new De(W,this.loose)),ce(this.major,W.major)||ce(this.minor,W.minor)||ce(this.patch,W.patch)},De.prototype.comparePre=function(W){if(W instanceof De||(W=new De(W,this.loose)),this.prerelease.length&&!W.prerelease.length)return-1;if(!this.prerelease.length&&W.prerelease.length)return 1;if(!this.prerelease.length&&!W.prerelease.length)return 0;var G=0;do{var K=this.prerelease[G],x=W.prerelease[G];if(I("prerelease compare",G,K,x),K===void 0&&x===void 0)return 0;if(x===void 0)return 1;if(K===void 0)return-1;if(K!==x)return ce(K,x)}while(++G)},De.prototype.inc=function(W,G){switch(W){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",G);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",G);break;case"prepatch":this.prerelease.length=0,this.inc("patch",G),this.inc("pre",G);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",G),this.inc("pre",G);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}G&&(this.prerelease[0]===G?isNaN(this.prerelease[1])&&(this.prerelease=[G,0]):this.prerelease=[G,0]);break;default:throw new Error("invalid increment argument: "+W)}return this.format(),this.raw=this.version,this},e.inc=function(W,G,K,x){typeof K=="string"&&(x=K,K=void 0);try{return new De(W,K).inc(G,x).version}catch{return null}},e.diff=function(W,G){if(re(W,G))return null;var K=ee(W),x=ee(G);if(K.prerelease.length||x.prerelease.length){for(var ge in K)if((ge==="major"||ge==="minor"||ge==="patch")&&K[ge]!==x[ge])return"pre"+ge;return"prerelease"}for(var ge in K)if((ge==="major"||ge==="minor"||ge==="patch")&&K[ge]!==x[ge])return ge},e.compareIdentifiers=ce;var Fe=/^[0-9]+$/;function ce(W,G){var K=Fe.test(W),x=Fe.test(G);return K&&x&&(W=+W,G=+G),K&&!x?-1:x&&!K?1:W<G?-1:W>G?1:0}function H(W,G,K){return new De(W,K).compare(new De(G,K))}function he(W,G,K){return H(W,G,K)>0}function le(W,G,K){return H(W,G,K)<0}function re(W,G,K){return H(W,G,K)===0}function ue(W,G,K){return H(W,G,K)!==0}function oe(W,G,K){return H(W,G,K)>=0}function J(W,G,K){return H(W,G,K)<=0}function Y(W,G,K,x){var ge;switch(G){case"===":typeof W=="object"&&(W=W.version),typeof K=="object"&&(K=K.version),ge=W===K;break;case"!==":typeof W=="object"&&(W=W.version),typeof K=="object"&&(K=K.version),ge=W!==K;break;case"":case"=":case"==":ge=re(W,K,x);break;case"!=":ge=ue(W,K,x);break;case">":ge=he(W,K,x);break;case">=":ge=oe(W,K,x);break;case"<":ge=le(W,K,x);break;case"<=":ge=J(W,K,x);break;default:throw new TypeError("Invalid operator: "+G)}return ge}function we(W,G){if(W instanceof we){if(W.loose===G)return W;W=W.value}if(!(this instanceof we))return new we(W,G);I("comparator",W,G),this.loose=G,this.parse(W),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(W,G){return ce(G,W)},e.major=function(W,G){return new De(W,G).major},e.minor=function(W,G){return new De(W,G).minor},e.patch=function(W,G){return new De(W,G).patch},e.compare=H,e.compareLoose=function(W,G){return H(W,G,!0)},e.rcompare=function(W,G,K){return H(G,W,K)},e.sort=function(W,G){return W.sort(function(K,x){return e.compare(K,x,G)})},e.rsort=function(W,G){return W.sort(function(K,x){return e.rcompare(K,x,G)})},e.gt=he,e.lt=le,e.eq=re,e.neq=ue,e.gte=oe,e.lte=J,e.cmp=Y,e.Comparator=we;var pe={};function Me(W,G){if(W instanceof Me)return W.loose===G?W:new Me(W.raw,G);if(W instanceof we)return new Me(W.value,G);if(!(this instanceof Me))return new Me(W,G);if(this.loose=G,this.raw=W,this.set=W.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+W);this.format()}function Ve(W){return!W||W.toLowerCase()==="x"||W==="*"}function Se(W,G,K,x,ge,Re,Ue,Ke,Ze,nt,it,st,ot){return((G=Ve(K)?"":Ve(x)?">="+K+".0.0":Ve(ge)?">="+K+"."+x+".0":">="+G)+" "+(Ke=Ve(Ze)?"":Ve(nt)?"<"+(+Ze+1)+".0.0":Ve(it)?"<"+Ze+"."+(+nt+1)+".0":st?"<="+Ze+"."+nt+"."+it+"-"+st:"<="+Ke)).trim()}function Pe(W,G){for(var K=0;K<W.length;K++)if(!W[K].test(G))return!1;if(G.prerelease.length){for(K=0;K<W.length;K++)if(I(W[K].semver),W[K].semver!==pe&&W[K].semver.prerelease.length>0){var x=W[K].semver;if(x.major===G.major&&x.minor===G.minor&&x.patch===G.patch)return!0}return!1}return!0}function Te(W,G,K){try{G=new Me(G,K)}catch{return!1}return G.test(W)}function U(W,G,K,x){var ge,Re,Ue,Ke,Ze;switch(W=new De(W,x),G=new Me(G,x),K){case">":ge=he,Re=J,Ue=le,Ke=">",Ze=">=";break;case"<":ge=le,Re=oe,Ue=he,Ke="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Te(W,G,x))return!1;for(var nt=0;nt<G.set.length;++nt){var it=G.set[nt],st=null,ot=null;if(it.forEach(function($t){$t.semver===pe&&($t=new we(">=0.0.0")),st=st||$t,ot=ot||$t,ge($t.semver,st.semver,x)?st=$t:Ue($t.semver,ot.semver,x)&&(ot=$t)}),st.operator===Ke||st.operator===Ze||(!ot.operator||ot.operator===Ke)&&Re(W,ot.semver)||ot.operator===Ze&&Ue(W,ot.semver))return!1}return!0}we.prototype.parse=function(W){var G=this.loose?M[ie]:M[de],K=W.match(G);if(!K)throw new TypeError("Invalid comparator: "+W);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new De(K[2],this.loose):this.semver=pe},we.prototype.toString=function(){return this.value},we.prototype.test=function(W){return I("Comparator.test",W,this.loose),this.semver===pe||(typeof W=="string"&&(W=new De(W,this.loose)),Y(W,this.operator,this.semver,this.loose))},we.prototype.intersects=function(W,G){if(!(W instanceof we))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new Me(W.value,G),Te(this.value,K,G);if(W.operator==="")return K=new Me(this.value,G),Te(W.semver,K,G);var x=!(this.operator!==">="&&this.operator!==">"||W.operator!==">="&&W.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||W.operator!=="<="&&W.operator!=="<"),Re=this.semver.version===W.semver.version,Ue=!(this.operator!==">="&&this.operator!=="<="||W.operator!==">="&&W.operator!=="<="),Ke=Y(this.semver,"<",W.semver,G)&&(this.operator===">="||this.operator===">")&&(W.operator==="<="||W.operator==="<"),Ze=Y(this.semver,">",W.semver,G)&&(this.operator==="<="||this.operator==="<")&&(W.operator===">="||W.operator===">");return x||ge||Re&&Ue||Ke||Ze},e.Range=Me,Me.prototype.format=function(){return this.range=this.set.map(function(W){return W.join(" ").trim()}).join("||").trim(),this.range},Me.prototype.toString=function(){return this.range},Me.prototype.parseRange=function(W){var G=this.loose;W=W.trim(),I("range",W,G);var K=G?M[Z]:M[ve];W=W.replace(K,Se),I("hyphen replace",W),W=W.replace(M[be],"$1$2$3"),I("comparator trim",W,M[be]),W=(W=(W=W.replace(M[N],"$1~")).replace(M[O],"$1^")).split(/\s+/).join(" ");var x=G?M[ie]:M[de],ge=W.split(" ").map(function(Re){return function(Ue,Ke){return I("comp",Ue),Ue=function(Ze,nt){return Ze.trim().split(/\s+/).map(function(it){return function(st,ot){I("caret",st,ot);var $t=ot?M[F]:M[L];return st.replace($t,function(dt,rt,ut,gt,We){var je;return I("caret",st,dt,rt,ut,gt,We),Ve(rt)?je="":Ve(ut)?je=">="+rt+".0.0 <"+(+rt+1)+".0.0":Ve(gt)?je=rt==="0"?">="+rt+"."+ut+".0 <"+rt+"."+(+ut+1)+".0":">="+rt+"."+ut+".0 <"+(+rt+1)+".0.0":We?(I("replaceCaret pr",We),We.charAt(0)!=="-"&&(We="-"+We),je=rt==="0"?ut==="0"?">="+rt+"."+ut+"."+gt+We+" <"+rt+"."+ut+"."+(+gt+1):">="+rt+"."+ut+"."+gt+We+" <"+rt+"."+(+ut+1)+".0":">="+rt+"."+ut+"."+gt+We+" <"+(+rt+1)+".0.0"):(I("no pr"),je=rt==="0"?ut==="0"?">="+rt+"."+ut+"."+gt+" <"+rt+"."+ut+"."+(+gt+1):">="+rt+"."+ut+"."+gt+" <"+rt+"."+(+ut+1)+".0":">="+rt+"."+ut+"."+gt+" <"+(+rt+1)+".0.0"),I("caret return",je),je})}(it,nt)}).join(" ")}(Ue,Ke),I("caret",Ue),Ue=function(Ze,nt){return Ze.trim().split(/\s+/).map(function(it){return function(st,ot){var $t=ot?M[X]:M[B];return st.replace($t,function(dt,rt,ut,gt,We){var je;return I("tilde",st,dt,rt,ut,gt,We),Ve(rt)?je="":Ve(ut)?je=">="+rt+".0.0 <"+(+rt+1)+".0.0":Ve(gt)?je=">="+rt+"."+ut+".0 <"+rt+"."+(+ut+1)+".0":We?(I("replaceTilde pr",We),We.charAt(0)!=="-"&&(We="-"+We),je=">="+rt+"."+ut+"."+gt+We+" <"+rt+"."+(+ut+1)+".0"):je=">="+rt+"."+ut+"."+gt+" <"+rt+"."+(+ut+1)+".0",I("tilde return",je),je})}(it,nt)}).join(" ")}(Ue,Ke),I("tildes",Ue),Ue=function(Ze,nt){return I("replaceXRanges",Ze,nt),Ze.split(/\s+/).map(function(it){return function(st,ot){st=st.trim();var $t=ot?M[R]:M[E];return st.replace($t,function(dt,rt,ut,gt,We,je){I("xRange",st,dt,rt,ut,gt,We,je);var te=Ve(ut),q=te||Ve(gt),Ee=q||Ve(We);return rt==="="&&Ee&&(rt=""),te?dt=rt===">"||rt==="<"?"<0.0.0":"*":rt&&Ee?(q&&(gt=0),Ee&&(We=0),rt===">"?(rt=">=",q?(ut=+ut+1,gt=0,We=0):Ee&&(gt=+gt+1,We=0)):rt==="<="&&(rt="<",q?ut=+ut+1:gt=+gt+1),dt=rt+ut+"."+gt+"."+We):q?dt=">="+ut+".0.0 <"+(+ut+1)+".0.0":Ee&&(dt=">="+ut+"."+gt+".0 <"+ut+"."+(+gt+1)+".0"),I("xRange return",dt),dt})}(it,nt)}).join(" ")}(Ue,Ke),I("xrange",Ue),Ue=function(Ze,nt){return I("replaceStars",Ze,nt),Ze.trim().replace(M[ae],"")}(Ue,Ke),I("stars",Ue),Ue}(Re,G)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Re){return!!Re.match(x)})),ge=ge.map(function(Re){return new we(Re,G)})},Me.prototype.intersects=function(W,G){if(!(W instanceof Me))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(x){return W.set.some(function(ge){return ge.every(function(Re){return x.intersects(Re,G)})})})})},e.toComparators=function(W,G){return new Me(W,G).set.map(function(K){return K.map(function(x){return x.value}).join(" ").trim().split(" ")})},Me.prototype.test=function(W){if(!W)return!1;typeof W=="string"&&(W=new De(W,this.loose));for(var G=0;G<this.set.length;G++)if(Pe(this.set[G],W))return!0;return!1},e.satisfies=Te,e.maxSatisfying=function(W,G,K){var x=null,ge=null;try{var Re=new Me(G,K)}catch{return null}return W.forEach(function(Ue){Re.test(Ue)&&(x&&ge.compare(Ue)!==-1||(ge=new De(x=Ue,K)))}),x},e.minSatisfying=function(W,G,K){var x=null,ge=null;try{var Re=new Me(G,K)}catch{return null}return W.forEach(function(Ue){Re.test(Ue)&&(x&&ge.compare(Ue)!==1||(ge=new De(x=Ue,K)))}),x},e.validRange=function(W,G){try{return new Me(W,G).range||"*"}catch{return null}},e.ltr=function(W,G,K){return U(W,G,"<",K)},e.gtr=function(W,G,K){return U(W,G,">",K)},e.outside=U,e.prerelease=function(W,G){var K=ee(W,G);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(W,G,K){return W=new Me(W,K),G=new Me(G,K),W.intersects(G)},e.coerce=function(W){if(W instanceof De)return W;if(typeof W!="string")return null;var G=W.match(M[w]);return G==null?null:ee((G[1]||"0")+"."+(G[2]||"0")+"."+(G[3]||"0"))}}).call(this,b(1))},function(_,e){var b,D,I=_.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function M(o){if(b===setTimeout)return setTimeout(o,0);if((b===T||!b)&&setTimeout)return b=setTimeout,setTimeout(o,0);try{return b(o,0)}catch{try{return b.call(null,o,0)}catch{return b.call(this,o,0)}}}(function(){try{b=typeof setTimeout=="function"?setTimeout:T}catch{b=T}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var $,a=[],P=!1,y=-1;function u(){P&&$&&(P=!1,$.length?a=$.concat(a):y=-1,a.length&&k())}function k(){if(!P){var o=M(u);P=!0;for(var c=a.length;c;){for($=a,a=[];++y<c;)$&&$[y].run();y=-1,c=a.length}$=null,P=!1,function(f){if(D===clearTimeout)return clearTimeout(f);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(f);try{D(f)}catch{try{return D.call(null,f)}catch{return D.call(this,f)}}}(o)}}function h(o,c){this.fun=o,this.array=c}function r(){}I.nextTick=function(o){var c=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)c[f-1]=arguments[f];a.push(new h(o,c)),a.length!==1||P||M(k)},h.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=r,I.addListener=r,I.once=r,I.off=r,I.removeListener=r,I.removeAllListeners=r,I.emit=r,I.prependListener=r,I.prependOnceListener=r,I.listeners=function(o){return[]},I.binding=function(o){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(o){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ce[143],Ie([1,0,4,6]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ju=e.$iu=e.$hu=e.$gu=e.ScrollbarVisibility=void 0;var I;(function(k){k[k.Auto=1]="Auto",k[k.Hidden=2]="Hidden",k[k.Visible=3]="Visible"})(I||(e.ScrollbarVisibility=I={}));class T{constructor(h,r,o,c,f,t,s){this.c=h,this._scrollStateBrand=void 0,this.c&&(r=r|0,o=o|0,c=c|0,f=f|0,t=t|0,s=s|0),this.rawScrollLeft=c,this.rawScrollTop=s,r<0&&(r=0),c+r>o&&(c=o-r),c<0&&(c=0),f<0&&(f=0),s+f>t&&(s=t-f),s<0&&(s=0),this.width=r,this.scrollWidth=o,this.scrollLeft=c,this.height=f,this.scrollHeight=t,this.scrollTop=s}equals(h){return this.rawScrollLeft===h.rawScrollLeft&&this.rawScrollTop===h.rawScrollTop&&this.width===h.width&&this.scrollWidth===h.scrollWidth&&this.scrollLeft===h.scrollLeft&&this.height===h.height&&this.scrollHeight===h.scrollHeight&&this.scrollTop===h.scrollTop}withScrollDimensions(h,r){return new T(this.c,typeof h.width<"u"?h.width:this.width,typeof h.scrollWidth<"u"?h.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof h.height<"u"?h.height:this.height,typeof h.scrollHeight<"u"?h.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(h){return new T(this.c,this.width,this.scrollWidth,typeof h.scrollLeft<"u"?h.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof h.scrollTop<"u"?h.scrollTop:this.rawScrollTop)}createScrollEvent(h,r){const o=this.width!==h.width,c=this.scrollWidth!==h.scrollWidth,f=this.scrollLeft!==h.scrollLeft,t=this.height!==h.height,s=this.scrollHeight!==h.scrollHeight,n=this.scrollTop!==h.scrollTop;return{inSmoothScrolling:r,oldWidth:h.width,oldScrollWidth:h.scrollWidth,oldScrollLeft:h.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:h.height,oldScrollHeight:h.scrollHeight,oldScrollTop:h.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:c,scrollLeftChanged:f,heightChanged:t,scrollHeightChanged:s,scrollTopChanged:n}}}e.$gu=T;class A extends D.$Uc{constructor(h){super(),this._scrollableBrand=void 0,this.j=this.B(new b.$he),this.onScroll=this.j.event,this.c=h.smoothScrollDuration,this.f=h.scheduleAtNextAnimationFrame,this.g=new T(h.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(h){this.c=h}validateScrollPosition(h){return this.g.withScrollPosition(h)}getScrollDimensions(){return this.g}setScrollDimensions(h,r){const o=this.g.withScrollDimensions(h,r);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(h){const r=this.g.withScrollPosition(h);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(h,r){if(this.c===0)return this.setScrollPositionNow(h);if(this.h){h={scrollLeft:typeof h.scrollLeft>"u"?this.h.to.scrollLeft:h.scrollLeft,scrollTop:typeof h.scrollTop>"u"?this.h.to.scrollTop:h.scrollTop};const o=this.g.withScrollPosition(h);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let c;r?c=new P(this.h.from,o,this.h.startTime,this.h.duration):c=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=c}else{const o=this.g.withScrollPosition(h);this.h=P.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const h=this.h.tick(),r=this.g.withScrollPosition(h);if(this.n(r,!0),!!this.h){if(h.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(h,r){const o=this.g;o.equals(h)||(this.g=h,this.j.fire(this.g.createScrollEvent(o,r)))}}e.$hu=A;class M{constructor(h,r,o){this.scrollLeft=h,this.scrollTop=r,this.isDone=o}}e.$iu=M;function $(k,h){const r=h-k;return function(o){return k+r*u(o)}}function a(k,h,r){return function(o){return o<r?k(o/r):h((o-r)/(1-r))}}class P{constructor(h,r,o,c){this.from=h,this.to=r,this.duration=c,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(h,r,o){if(Math.abs(h-r)>2.5*o){let f,t;return h<r?(f=h+.75*o,t=r-.75*o):(f=h-.75*o,t=r+.75*o),a($(h,f),$(t,r),.33)}return $(h,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(h){this.to=h.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(h){const r=(h-this.startTime)/this.duration;if(r<1){const o=this.c(r),c=this.d(r);return new M(o,c,!1)}return new M(this.to.scrollLeft,this.to.scrollTop,!0)}combine(h,r,o){return P.start(h,r,o)}static start(h,r,o){o=o+10;const c=Date.now()-10;return new P(h,r,c,o)}}e.$ju=P;function y(k){return Math.pow(k,3)}function u(k){return 1-y(1-k)}}),define(Ce[144],Ie([1,0,14,6]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ue=I,e.$ve=T,e.$we=A,e.$xe=M,e.$ye=a,e.$ze=P,e.$Ae=y,e.$Be=u,e.$Ce=k,e.$De=h,e.$Ee=r,e.$Fe=o,e.$Ge=c,e.$He=f,e.$Ie=t;function I(s){const n=s;return n?typeof n.read=="function":!1}function T(s){const n=s;return n?[n.on,n.pause,n.resume,n.destroy].every(i=>typeof i=="function"):!1}function A(s){const n=s;return n?T(n.stream)&&Array.isArray(n.buffer)&&typeof n.ended=="boolean":!1}function M(s,n){return new $(s,n)}class ${constructor(n,i){this.e=n,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(n){if(!this.a.destroyed){if(this.a.flowing)this.g(n);else if(this.b.data.push(n),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(n){this.a.destroyed||(this.a.flowing?this.h(n):this.b.error.push(n))}end(n){this.a.destroyed||(typeof n<"u"&&this.write(n),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(n){this.c.data.slice(0).forEach(i=>i(n))}h(n){this.c.error.length===0?(0,b.$1)(n):this.c.error.slice(0).forEach(i=>i(n))}i(){this.c.end.slice(0).forEach(n=>n())}on(n,i){if(!this.a.destroyed)switch(n){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(n,i){if(this.a.destroyed)return;let g;switch(n){case"data":g=this.c.data;break;case"end":g=this.c.end;break;case"error":g=this.c.error;break}if(g){const d=g.indexOf(i);d>=0&&g.splice(d,1)}}j(){if(this.b.data.length>0){const n=this.e(this.b.data);this.g(n),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(g=>g())}}k(){if(this.c.error.length>0){for(const n of this.b.error)this.h(n);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(s,n){const i=[];let g;for(;(g=s.read())!==null;)i.push(g);return n(i)}function P(s,n,i){const g=[];let d;for(;(d=s.read())!==null&&g.length<i;)g.push(d);return d===null&&g.length>0?n(g):{read:()=>{if(g.length>0)return g.shift();if(typeof d<"u"){const l=d;return d=void 0,l}return s.read()}}}function y(s,n){return new Promise((i,g)=>{const d=[];u(s,{onData:l=>{n&&d.push(l)},onError:l=>{n?g(l):i(void 0)},onEnd:()=>{i(n?n(d):void 0)}})})}function u(s,n,i){s.on("error",g=>{i?.isCancellationRequested||n.onError(g)}),s.on("end",()=>{i?.isCancellationRequested||n.onEnd()}),s.on("data",g=>{i?.isCancellationRequested||n.onData(g)})}function k(s,n){return new Promise((i,g)=>{const d=new D.$Tc,l=[],p=v=>{if(l.push(v),l.length>n)return d.dispose(),s.pause(),i({stream:s,buffer:l,ended:!1})},C=v=>(d.dispose(),g(v)),S=()=>(d.dispose(),i({stream:s,buffer:l,ended:!0}));d.add((0,D.$Sc)(()=>s.removeListener("error",C))),s.on("error",C),d.add((0,D.$Sc)(()=>s.removeListener("end",S))),s.on("end",S),d.add((0,D.$Sc)(()=>s.removeListener("data",p))),s.on("data",p)})}function h(s,n){const i=M(n);return i.end(s),i}function r(){const s=M(()=>{throw new Error("not supported")});return s.end(),s}function o(s){let n=!1;return{read:()=>n?null:(n=!0,s)}}function c(s,n,i){const g=M(i);return u(s,{onData:d=>g.write(n.data(d)),onError:d=>g.error(n.error?n.error(d):d),onEnd:()=>g.end()}),g}function f(s,n,i){let g=!1;return{read:()=>{const d=n.read();return g?d:(g=!0,d!==null?i([s,d]):s)}}}function t(s,n,i){let g=!1;const d=M(i);return u(n,{onData:l=>g?d.write(l):(g=!0,d.write(i([s,l]))),onError:l=>d.error(l),onEnd:()=>{g||(g=!0,d.write(s)),d.end()}}),d}}),define(Ce[23],Ie([1,0,47,144]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Je=void 0,e.$Ke=a,e.$Le=P,e.$Me=y,e.$Ne=u,e.$Oe=k,e.$Pe=h,e.$Qe=r,e.$Re=o,e.$Se=c,e.$Te=f,e.$Ue=t,e.$Ve=s,e.$We=n,e.$Xe=i,e.$Ye=g,e.$Ze=d,e.$1e=l,e.$2e=p,e.$3e=C,e.$4e=E;const I=typeof Buffer<"u",T=new b.$V(()=>new Uint8Array(256));let A,M;class ${static alloc(w){return I?new $(Buffer.allocUnsafe(w)):new $(new Uint8Array(w))}static wrap(w){return I&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new $(w)}static fromString(w,m){return!(m?.dontUseNodeBuffer||!1)&&I?new $(Buffer.from(w)):(A||(A=new TextEncoder),new $(A.encode(w)))}static fromByteArray(w){const m=$.alloc(w.length);for(let N=0,B=w.length;N<B;N++)m.buffer[N]=w[N];return m}static concat(w,m){if(typeof m>"u"){m=0;for(let X=0,V=w.length;X<V;X++)m+=w[X].byteLength}const N=$.alloc(m);let B=0;for(let X=0,V=w.length;X<V;X++){const O=w[X];N.set(O,B),B+=O.byteLength}return N}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=$.alloc(this.byteLength);return w.set(this),w}toString(){return I?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(w,m){return new $(this.buffer.subarray(w,m))}set(w,m){if(w instanceof $)this.buffer.set(w.buffer,m);else if(w instanceof Uint8Array)this.buffer.set(w,m);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),m);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return u(this.buffer,w)}writeUInt32BE(w,m){k(this.buffer,w,m)}readUInt32LE(w){return h(this.buffer,w)}writeUInt32LE(w,m){r(this.buffer,w,m)}readUInt8(w){return o(this.buffer,w)}writeUInt8(w,m){c(this.buffer,w,m)}indexOf(w,m=0){return a(this.buffer,w instanceof $?w.buffer:w,m)}}e.$Je=$;function a(R,w,m=0){const N=w.byteLength,B=R.byteLength;if(N===0)return 0;if(N===1)return R.indexOf(w[0]);if(N>B-m)return-1;const X=T.value;X.fill(w.length);for(let F=0;F<w.length;F++)X[w[F]]=w.length-F-1;let V=m+w.length-1,O=V,L=-1;for(;V<B;)if(R[V]===w[O]){if(O===0){L=V;break}V--,O--}else V+=Math.max(w.length-O,X[R[V]]),O=w.length-1;return L}function P(R,w){return R[w+0]<<0>>>0|R[w+1]<<8>>>0}function y(R,w,m){R[m+0]=w&255,w=w>>>8,R[m+1]=w&255}function u(R,w){return R[w]*2**24+R[w+1]*2**16+R[w+2]*2**8+R[w+3]}function k(R,w,m){R[m+3]=w,w=w>>>8,R[m+2]=w,w=w>>>8,R[m+1]=w,w=w>>>8,R[m]=w}function h(R,w){return R[w+0]<<0>>>0|R[w+1]<<8>>>0|R[w+2]<<16>>>0|R[w+3]<<24>>>0}function r(R,w,m){R[m+0]=w&255,w=w>>>8,R[m+1]=w&255,w=w>>>8,R[m+2]=w&255,w=w>>>8,R[m+3]=w&255}function o(R,w){return R[w]}function c(R,w,m){R[m]=w}function f(R){return D.$ye(R,w=>$.concat(w))}function t(R){return D.$Fe(R)}function s(R){return D.$Ae(R,w=>$.concat(w))}async function n(R){return R.ended?$.concat(R.buffer):$.concat([...R.buffer,await s(R.stream)])}function i(R){return D.$De(R,w=>$.concat(w))}function g(R){return D.$Ge(R,{data:w=>typeof w=="string"?$.fromString(w):$.wrap(w)},w=>$.concat(w))}function d(R){return D.$xe(w=>$.concat(w),R)}function l(R,w){return D.$He(R,w,m=>$.concat(m))}function p(R,w){return D.$Ie(R,w,m=>$.concat(m))}function C(R){let w=0,m=0,N=0;const B=new Uint8Array(Math.floor(R.length/4*3)),X=O=>{switch(m){case 3:B[N++]=w|O,m=0;break;case 2:B[N++]=w|O>>>2,w=O<<6,m=3;break;case 1:B[N++]=w|O>>>4,w=O<<4,m=2;break;default:w=O<<2,m=1}};for(let O=0;O<R.length;O++){const L=R.charCodeAt(O);if(L>=65&&L<=90)X(L-65);else if(L>=97&&L<=122)X(L-97+26);else if(L>=48&&L<=57)X(L-48+52);else if(L===43||L===45)X(62);else if(L===47||L===95)X(63);else{if(L===61)break;throw new SyntaxError(`Unexpected base64 character ${R[O]}`)}}const V=N;for(;m>0;)X(0);return $.wrap(B).slice(0,V)}const S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:R},w=!0,m=!1){const N=m?v:S;let B="";const X=R.byteLength%3;let V=0;for(;V<R.byteLength-X;V+=3){const O=R[V+0],L=R[V+1],F=R[V+2];B+=N[O>>>2],B+=N[(O<<4|L>>>4)&63],B+=N[(L<<2|F>>>6)&63],B+=N[F&63]}if(X===1){const O=R[V+0];B+=N[O>>>2],B+=N[O<<4&63],w&&(B+="==")}else if(X===2){const O=R[V+0],L=R[V+1];B+=N[O>>>2],B+=N[(O<<4|L>>>4)&63],B+=N[L<<2&63],w&&(B+="=")}return B}}),define(Ce[145],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(Ce[34],Ie([1,0,97]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$1j=I;var D;(function(A){function M($){return $&&typeof $=="object"&&typeof $.id=="string"}A.isThemeColor=M})(D||(e.ThemeColor=D={}));function I(A){return{id:A}}var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const M=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function $(f){const t=M.exec(f.id);if(!t)return $(b.$Zj.error);const[,s,n]=t,i=["codicon","codicon-"+s];return n&&i.push("codicon-modifier-"+n.substring(1)),i}A.asClassNameArray=$;function a(f){return $(f).join(" ")}A.asClassName=a;function P(f){return"."+$(f).join(".")}A.asCSSSelector=P;function y(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||D.isThemeColor(f.color))}A.isThemeIcon=y;const u=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function k(f){const t=u.exec(f);if(!t)return;const[,s]=t;return{id:s}}A.fromString=k;function h(f){return{id:f}}A.fromId=h;function r(f,t){let s=f.id;const n=s.lastIndexOf("~");return n!==-1&&(s=s.substring(0,n)),t&&(s=`${s}~${t}`),{id:s}}A.modify=r;function o(f){const t=f.id.lastIndexOf("~");if(t!==-1)return f.id.substring(t+1)}A.getModifier=o;function c(f,t){return f.id===t.id&&f.color?.id===t.color?.id}A.isEqual=c})(T||(e.ThemeIcon=T={}))}),define(Ce[52],Ie([1,0,28,20,21,13,15]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sg=M,e.$tg=$,e.$ug=a,e.$vg=P,e.$wg=y,e.$xg=r,e.$yg=o,e.$zg=c,e.$Ag=f,e.$Bg=t,e.$Cg=s,e.$Dg=n,e.$Eg=i,e.$Fg=g,e.$Gg=d,e.$Hg=l,e.$Ig=S;function M(v){return v===b.CharCode.Slash||v===b.CharCode.Backslash}function $(v){return v.replace(/[\\/]/g,D.$gc.sep)}function a(v){return v.indexOf("/")===-1&&(v=$(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function P(v,E=D.$gc.sep){if(!v)return"";const R=v.length,w=v.charCodeAt(0);if(M(w)){if(M(v.charCodeAt(1))&&!M(v.charCodeAt(2))){let N=3;const B=N;for(;N<R&&!M(v.charCodeAt(N));N++);if(B!==N&&!M(v.charCodeAt(N+1))){for(N+=1;N<R;N++)if(M(v.charCodeAt(N)))return v.slice(0,N+1).replace(/[\\/]/g,E)}}return E}else if(f(w)&&v.charCodeAt(1)===b.CharCode.Colon)return M(v.charCodeAt(2))?v.slice(0,2)+E:v.slice(0,2);let m=v.indexOf("://");if(m!==-1){for(m+=3;m<R;m++)if(M(v.charCodeAt(m)))return v.slice(0,m+1)}return""}function y(v){if(!I.$c||!v||v.length<5)return!1;let E=v.charCodeAt(0);if(E!==b.CharCode.Backslash||(E=v.charCodeAt(1),E!==b.CharCode.Backslash))return!1;let R=2;const w=R;for(;R<v.length&&(E=v.charCodeAt(R),E!==b.CharCode.Backslash);R++);return!(w===R||(E=v.charCodeAt(R+1),isNaN(E)||E===b.CharCode.Backslash))}const u=/[\\/:\*\?"<>\|]/g,k=/[/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(v,E=I.$c){const R=E?u:k;return!(!v||v.length===0||/^\s+$/.test(v)||(R.lastIndex=0,R.test(v))||E&&h.test(v)||v==="."||v===".."||E&&v[v.length-1]==="."||E&&v.length!==v.trim().length||v.length>255)}function o(v,E,R){const w=v===E;return!R||w?w:!v||!E?!1:(0,T.$Bf)(v,E)}function c(v,E,R,w=D.sep){if(v===E)return!0;if(!v||!E||E.length>v.length)return!1;if(R){if(!(0,T.$Cf)(v,E))return!1;if(E.length===v.length)return!0;let N=E.length;return E.charAt(E.length-1)===w&&N--,v.charAt(N)===w}return E.charAt(E.length-1)!==w&&(E+=w),v.indexOf(E)===0}function f(v){return v>=b.CharCode.A&&v<=b.CharCode.Z||v>=b.CharCode.a&&v<=b.CharCode.z}function t(v,E){return I.$c&&v.endsWith(":")&&(v+=D.sep),(0,D.$ic)(v)||(v=(0,D.$jc)(E,v)),v=(0,D.$hc)(v),s(v)}function s(v){return I.$c?(v=(0,T.$jf)(v,D.sep),v.endsWith(":")&&(v+=D.sep)):(v=(0,T.$jf)(v,D.sep),v||(v=D.sep)),v}function n(v){const E=(0,D.$hc)(v);return I.$c?v.length>3?!1:i(E)&&(v.length===2||E.charCodeAt(2)===b.CharCode.Backslash):E===D.$gc.sep}function i(v,E=I.$c){return E?f(v.charCodeAt(0))&&v.charCodeAt(1)===b.CharCode.Colon:!1}function g(v,E=I.$c){return i(v,E)?v[0]:void 0}function d(v,E,R){return E.length>v.length?-1:v===E?0:(R&&(v=v.toLowerCase(),E=E.toLowerCase()),v.indexOf(E))}function l(v){const E=v.split(":");let R,w,m;for(const N of E){const B=Number(N);(0,A.$eg)(B)?w===void 0?w=B:m===void 0&&(m=B):R=R?[R,N].join(":"):N}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:w!==void 0?w:void 0,column:m!==void 0?m:w!==void 0?1:void 0}}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",C="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function S(v,E,R=8){let w="";for(let N=0;N<R;N++){let B;N===0&&I.$c&&!E&&(R===3||R===4)?B=C:B=p,w+=B.charAt(Math.floor(Math.random()*B.length))}let m;return E?m=`${E}-${w}`:m=w,v?(0,D.$jc)(v,m):m}}),define(Ce[146],Ie([1,0,28,29,136,13]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=e.FuzzyScore=e.$Ck=e.$Bk=void 0,e.or=A,e.$Dk=$,e.$Ek=a,e.$Fk=u,e.$Gk=S,e.$Hk=v,e.$Ik=B,e.$Jk=X,e.$Kk=V,e.$Lk=O,e.$Mk=he,e.$Ok=oe,e.$Pk=we,e.$Qk=pe;function A(...Se){return function(Pe,Te){for(let U=0,W=Se.length;U<W;U++){const G=Se[U](Pe,Te);if(G)return G}return null}}e.$Bk=M.bind(void 0,!1),e.$Ck=M.bind(void 0,!0);function M(Se,Pe,Te){if(!Te||Te.length<Pe.length)return null;let U;return Se?U=T.$Cf(Te,Pe):U=Te.indexOf(Pe)===0,U?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function $(Se,Pe){const Te=Pe.toLowerCase().indexOf(Se.toLowerCase());return Te===-1?null:[{start:Te,end:Te+Se.length}]}function a(Se,Pe){return P(Se.toLowerCase(),Pe.toLowerCase(),0,0)}function P(Se,Pe,Te,U){if(Te===Se.length)return[];if(U===Pe.length)return null;if(Se[Te]===Pe[U]){let W=null;return(W=P(Se,Pe,Te+1,U+1))?n({start:U,end:U+1},W):null}return P(Se,Pe,Te,U+1)}function y(Se){return b.CharCode.a<=Se&&Se<=b.CharCode.z}function u(Se){return b.CharCode.A<=Se&&Se<=b.CharCode.Z}function k(Se){return b.CharCode.Digit0<=Se&&Se<=b.CharCode.Digit9}function h(Se){return Se===b.CharCode.Space||Se===b.CharCode.Tab||Se===b.CharCode.LineFeed||Se===b.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Se=>r.add(Se.charCodeAt(0)));function o(Se){return h(Se)||r.has(Se)}function c(Se,Pe){return Se===Pe||o(Se)&&o(Pe)}const f=new Map;function t(Se){if(f.has(Se))return f.get(Se);let Pe;const Te=(0,I.$zk)(Se);return Te&&(Pe=Te),f.set(Se,Pe),Pe}function s(Se){return y(Se)||u(Se)||k(Se)}function n(Se,Pe){return Pe.length===0?Pe=[Se]:Se.end===Pe[0].start?Pe[0].start=Se.start:Pe.unshift(Se),Pe}function i(Se,Pe){for(let Te=Pe;Te<Se.length;Te++){const U=Se.charCodeAt(Te);if(u(U)||k(U)||Te>0&&!s(Se.charCodeAt(Te-1)))return Te}return Se.length}function g(Se,Pe,Te,U){if(Te===Se.length)return[];if(U===Pe.length)return null;if(Se[Te]!==Pe[U].toLowerCase())return null;{let W=null,G=U+1;for(W=g(Se,Pe,Te+1,U+1);!W&&(G=i(Pe,G))<Pe.length;)W=g(Se,Pe,Te+1,G),G++;return W===null?null:n({start:U,end:U+1},W)}}function d(Se){let Pe=0,Te=0,U=0,W=0,G=0;for(let Ue=0;Ue<Se.length;Ue++)G=Se.charCodeAt(Ue),u(G)&&Pe++,y(G)&&Te++,s(G)&&U++,k(G)&&W++;const K=Pe/Se.length,x=Te/Se.length,ge=U/Se.length,Re=W/Se.length;return{upperPercent:K,lowerPercent:x,alphaPercent:ge,numericPercent:Re}}function l(Se){const{upperPercent:Pe,lowerPercent:Te}=Se;return Te===0&&Pe>.6}function p(Se){const{upperPercent:Pe,lowerPercent:Te,alphaPercent:U,numericPercent:W}=Se;return Te>.2&&Pe<.8&&U>.6&&W<.2}function C(Se){let Pe=0,Te=0,U=0,W=0;for(let G=0;G<Se.length;G++)U=Se.charCodeAt(G),u(U)&&Pe++,y(U)&&Te++,h(U)&&W++;return(Pe===0||Te===0)&&W===0?Se.length<=30:Pe<=5}function S(Se,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!C(Se))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Te=d(Pe);if(!p(Te)){if(!l(Te))return null;Pe=Pe.toLowerCase()}let U=null,W=0;for(Se=Se.toLowerCase();W<Pe.length&&(U=g(Se,Pe,0,W))===null;)W=i(Pe,W+1);return U}function v(Se,Pe,Te=!1){if(!Pe||Pe.length===0)return null;let U=null,W=0;for(Se=Se.toLowerCase(),Pe=Pe.toLowerCase();W<Pe.length&&(U=E(Se,Pe,0,W,Te),U===null);)W=R(Pe,W+1);return U}function E(Se,Pe,Te,U,W){let G=0;if(Te===Se.length)return[];if(U===Pe.length)return null;if(!c(Se.charCodeAt(Te),Pe.charCodeAt(U))){const ge=t(Se.charCodeAt(Te));if(!ge)return null;for(let Re=0;Re<ge.length;Re++)if(!c(ge[Re],Pe.charCodeAt(U+Re)))return null;G+=ge.length-1}let K=null,x=U+G+1;if(K=E(Se,Pe,Te+1,x,W),!W)for(;!K&&(x=R(Pe,x))<Pe.length;)K=E(Se,Pe,Te+1,x,W),x++;if(!K)return null;if(Se.charCodeAt(Te)!==Pe.charCodeAt(U)){const ge=t(Se.charCodeAt(Te));if(!ge)return K;for(let Re=0;Re<ge.length;Re++)if(ge[Re]!==Pe.charCodeAt(U+Re))return K}return n({start:U,end:U+G+1},K)}function R(Se,Pe){for(let Te=Pe;Te<Se.length;Te++)if(o(Se.charCodeAt(Te))||Te>0&&o(Se.charCodeAt(Te-1)))return Te;return Se.length}const w=A(e.$Ck,S,$),m=A(e.$Ck,S,a),N=new D.$Dc(1e4);function B(Se,Pe,Te=!1){if(typeof Se!="string"||typeof Pe!="string")return null;let U=N.get(Se);U||(U=new RegExp(T.$kf(Se),"i"),N.set(Se,U));const W=U.exec(Pe);return W?[{start:W.index,end:W.index+W[0].length}]:Te?m(Se,Pe):w(Se,Pe)}function X(Se,Pe){const Te=oe(Se,Se.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Te?O(Te):null}function V(Se,Pe,Te,U,W,G){const K=Math.min(13,Se.length);for(;Te<K;Te++){const x=oe(Se,Pe,Te,U,W,G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(x)return x}return[0,G]}function O(Se){if(typeof Se>"u")return[];const Pe=[],Te=Se[1];for(let U=Se.length-1;U>1;U--){const W=Se[U]+Te,G=Pe[Pe.length-1];G&&G.end===W?G.end=W+1:Pe.push({start:W,end:W+1})}return Pe}const L=128;function F(){const Se=[],Pe=[];for(let Te=0;Te<=L;Te++)Pe[Te]=0;for(let Te=0;Te<=L;Te++)Se.push(Pe.slice(0));return Se}function ie(Se){const Pe=[];for(let Te=0;Te<=Se;Te++)Pe[Te]=0;return Pe}const de=ie(2*L),be=ie(2*L),ve=F(),Z=F(),ae=F(),fe=!1;function ee(Se,Pe,Te,U,W){function G(x,ge,Re=" "){for(;x.length<ge;)x=Re+x;return x}let K=` |   |${U.split("").map(x=>G(x,3)).join("|")}
`;for(let x=0;x<=Te;x++)x===0?K+=" |":K+=`${Pe[x-1]}|`,K+=Se[x].slice(0,W+1).map(ge=>G(ge.toString(),3)).join("|")+`
`;return K}function De(Se,Pe,Te,U){Se=Se.substr(Pe),Te=Te.substr(U),console.log(ee(Z,Se,Se.length,Te,Te.length)),console.log(ee(ae,Se,Se.length,Te,Te.length)),console.log(ee(ve,Se,Se.length,Te,Te.length))}function Fe(Se,Pe){if(Pe<0||Pe>=Se.length)return!1;const Te=Se.codePointAt(Pe);switch(Te){case b.CharCode.Underline:case b.CharCode.Dash:case b.CharCode.Period:case b.CharCode.Space:case b.CharCode.Slash:case b.CharCode.Backslash:case b.CharCode.SingleQuote:case b.CharCode.DoubleQuote:case b.CharCode.Colon:case b.CharCode.DollarSign:case b.CharCode.LessThan:case b.CharCode.GreaterThan:case b.CharCode.OpenParen:case b.CharCode.CloseParen:case b.CharCode.OpenSquareBracket:case b.CharCode.CloseSquareBracket:case b.CharCode.OpenCurlyBrace:case b.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!T.$Uf(Te)}}function ce(Se,Pe){if(Pe<0||Pe>=Se.length)return!1;switch(Se.charCodeAt(Pe)){case b.CharCode.Space:case b.CharCode.Tab:return!0;default:return!1}}function H(Se,Pe,Te){return Pe[Se]!==Te[Se]}function he(Se,Pe,Te,U,W,G,K=!1){for(;Pe<Te&&W<G;)Se[Pe]===U[W]&&(K&&(de[Pe]=W),Pe+=1),W+=1;return Pe===Te}var le;(function(Se){Se[Se.Diag=1]="Diag",Se[Se.Left=2]="Left",Se[Se.LeftLeft=3]="LeftLeft"})(le||(le={}));var re;(function(Se){Se.Default=[-100,0];function Pe(Te){return!Te||Te.length===2&&Te[0]===-100&&Te[1]===0}Se.isDefault=Pe})(re||(e.FuzzyScore=re={}));class ue{constructor(Pe,Te){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Te}}e.$Nk=ue,ue.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function oe(Se,Pe,Te,U,W,G,K=ue.default){const x=Se.length>L?L:Se.length,ge=U.length>L?L:U.length;if(Te>=x||G>=ge||x-Te>ge-G||!he(Pe,Te,x,W,G,ge,!0))return;J(x,ge,Te,G,Pe,W);let Re=1,Ue=1,Ke=Te,Ze=G;const nt=[!1];for(Re=1,Ke=Te;Ke<x;Re++,Ke++){const dt=de[Ke],rt=be[Ke],ut=Ke+1<x?be[Ke+1]:ge;for(Ue=dt-G+1,Ze=dt;Ze<ut;Ue++,Ze++){let gt=Number.MIN_SAFE_INTEGER,We=!1;Ze<=rt&&(gt=Y(Se,Pe,Ke,Te,U,W,Ze,ge,G,ve[Re-1][Ue-1]===0,nt));let je=0;gt!==Number.MAX_SAFE_INTEGER&&(We=!0,je=gt+Z[Re-1][Ue-1]);const te=Ze>dt,q=te?Z[Re][Ue-1]+(ve[Re][Ue-1]>0?-5:0):0,Ee=Ze>dt+1&&ve[Re][Ue-1]>0,He=Ee?Z[Re][Ue-2]+(ve[Re][Ue-2]>0?-5:0):0;if(Ee&&(!te||He>=q)&&(!We||He>=je))Z[Re][Ue]=He,ae[Re][Ue]=le.LeftLeft,ve[Re][Ue]=0;else if(te&&(!We||q>=je))Z[Re][Ue]=q,ae[Re][Ue]=le.Left,ve[Re][Ue]=0;else if(We)Z[Re][Ue]=je,ae[Re][Ue]=le.Diag,ve[Re][Ue]=ve[Re-1][Ue-1]+1;else throw new Error("not possible")}}if(fe&&De(Se,Te,U,G),!nt[0]&&!K.firstMatchCanBeWeak)return;Re--,Ue--;const it=[Z[Re][Ue],G];let st=0,ot=0;for(;Re>=1;){let dt=Ue;do{const rt=ae[Re][dt];if(rt===le.LeftLeft)dt=dt-2;else if(rt===le.Left)dt=dt-1;else break}while(dt>=1);st>1&&Pe[Te+Re-1]===W[G+Ue-1]&&!H(dt+G-1,U,W)&&st+1>ve[Re][dt]&&(dt=Ue),dt===Ue?st++:st=1,ot||(ot=dt),Re--,Ue=dt-1,it.push(Ue)}ge-G===x&&K.boostFullMatch&&(it[0]+=2);const $t=ot-x;return it[0]-=$t,it}function J(Se,Pe,Te,U,W,G){let K=Se-1,x=Pe-1;for(;K>=Te&&x>=U;)W[K]===G[x]&&(be[K]=x,K--),x--}function Y(Se,Pe,Te,U,W,G,K,x,ge,Re,Ue){if(Pe[Te]!==G[K])return Number.MIN_SAFE_INTEGER;let Ke=1,Ze=!1;return K===Te-U?Ke=Se[Te]===W[K]?7:5:H(K,W,G)&&(K===0||!H(K-1,W,G))?(Ke=Se[Te]===W[K]?7:5,Ze=!0):Fe(G,K)&&(K===0||!Fe(G,K-1))?Ke=5:(Fe(G,K-1)||ce(G,K-1))&&(Ke=5,Ze=!0),Ke>1&&Te===U&&(Ue[0]=!0),Ze||(Ze=H(K,W,G)||Fe(G,K-1)||ce(G,K-1)),Te===U?K>ge&&(Ke-=Ze?3:5):Re?Ke+=Ze?2:0:Ke+=Ze?0:1,K+1===x&&(Ke-=Ze?3:5),Ke}function we(Se,Pe,Te,U,W,G,K){return Me(Se,Pe,Te,U,W,G,!0,K)}function pe(Se,Pe,Te,U,W,G,K){return Me(Se,Pe,Te,U,W,G,!1,K)}function Me(Se,Pe,Te,U,W,G,K,x){let ge=oe(Se,Pe,Te,U,W,G,x);if(ge&&!K)return ge;if(Se.length>=3){const Re=Math.min(7,Se.length-1);for(let Ue=Te+1;Ue<Re;Ue++){const Ke=Ve(Se,Ue);if(Ke){const Ze=oe(Ke,Ke.toLowerCase(),Te,U,W,G,x);Ze&&(Ze[0]-=3,(!ge||Ze[0]>ge[0])&&(ge=Ze))}}}return ge}function Ve(Se,Pe){if(Pe+1>=Se.length)return;const Te=Se[Pe],U=Se[Pe+1];if(Te!==U)return Se.slice(0,Pe)+U+Te+Se.slice(Pe+2)}}),define(Ce[98],Ie([1,0,146,13,34]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=$,e.$Sk=P,e.$Tk=u,e.$Uk=k,e.$Vk=r,e.$Wk=o;const T="$(",A=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),M=new RegExp(`(\\\\)?${A.source}`,"g");function $(c){return c.replace(M,(f,t)=>t?f:`\\${f}`)}const a=new RegExp(`\\\\${A.source}`,"g");function P(c){return c.replace(a,f=>`\\${f}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function u(c){return c.indexOf(T)===-1?c:c.replace(y,(f,t,s,n)=>s?f:t||n||"")}function k(c){return c?c.replace(/\$\((.*?)\)/g,(f,t)=>` ${t} `).trim():""}const h=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(c){h.lastIndex=0;let f="";const t=[];let s=0;for(;;){const n=h.lastIndex,i=h.exec(c),g=c.substring(n,i?.index);if(g.length>0){f+=g;for(let d=0;d<g.length;d++)t.push(s)}if(!i)break;s+=i[0].length}return{text:f,iconOffsets:t}}function o(c,f,t=!1){const{text:s,iconOffsets:n}=f;if(!n||n.length===0)return(0,b.$Ik)(c,s,t);const i=(0,D.$if)(s," "),g=s.length-i.length,d=(0,b.$Ik)(c,i,t);if(d)for(const l of d){const p=n[l.start+g]+g;l.start+=p,l.end+=p}return d}}),define(Ce[35],Ie([1,0,13]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(D||(D={})),function(I){const T="error",A="warning",M="warn",$="info",a="ignore";function P(u){return u?b.$Bf(T,u)?I.Error:b.$Bf(A,u)||b.$Bf(M,u)?I.Warning:b.$Bf($,u)?I.Info:I.Ignore:I.Ignore}I.fromValue=P;function y(u){switch(u){case I.Error:return T;case I.Warning:return A;case I.Info:return $;default:return a}}I.toString=y}(D||(D={})),e.default=D}),define(Ce[58],Ie([1,0,18,28,13]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=void 0;class T{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const r=h.charCodeAt(0),o=this.b.charCodeAt(this.c);return r-o}value(){return this.b[this.c]}}e.$Ci=T;class A{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===D.CharCode.Period)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,I.$vf)(h,this.b,0,h.length,this.c,this.d):(0,I.$xf)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Di=A;class M{constructor(h=!0,r=!0){this.f=h,this.g=r}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let r=h.length-1;r>=0;r--,this.c--){const o=this.b.charCodeAt(r);if(!(o===D.CharCode.Slash||this.f&&o===D.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===D.CharCode.Slash||this.f&&r===D.CharCode.Backslash)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,I.$vf)(h,this.b,0,h.length,this.d,this.e):(0,I.$xf)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ei=M;var $;(function(k){k[k.Scheme=1]="Scheme",k[k.Authority=2]="Authority",k[k.Path=3]="Path",k[k.Query=4]="Query",k[k.Fragment=5]="Fragment"})($||($={}));class a{constructor(h,r){this.f=h,this.g=r,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new M(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push($.Path)),this.g(h)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===$.Scheme)return(0,I.$wf)(h,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,I.$wf)(h,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(h);if(this.d[this.e]===$.Query)return(0,I.$uf)(h,this.c.query);if(this.d[this.e]===$.Fragment)return(0,I.$uf)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Fi=a;class P{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(k){k[k.Left=-1]="Left",k[k.Mid=0]="Mid",k[k.Right=1]="Right"})(y||(y={}));class u{static forUris(h=()=>!1,r=()=>!1){return new u(new a(h,r))}static forPaths(h=!1){return new u(new M(void 0,!h))}static forStrings(){return new u(new T)}static forConfigKeys(){return new u(new A)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,r){if(r){const o=r.slice(0);(0,b.$Wb)(o);for(const c of o)this.set(c,h)}else{const o=h.slice(0);(0,b.$Wb)(o);for(const c of o)this.set(c[0],c[1])}}set(h,r){const o=this.b.reset(h);let c;this.c||(this.c=new P,this.c.segment=o.value());const f=[];for(c=this.c;;){const s=o.cmp(c.segment);if(s>0)c.left||(c.left=new P,c.left.segment=o.value()),f.push([y.Left,c]),c=c.left;else if(s<0)c.right||(c.right=new P,c.right.segment=o.value()),f.push([y.Right,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new P,c.mid.segment=o.value()),f.push([y.Mid,c]),c=c.mid;else break}const t=c.value;c.value=r,c.key=h;for(let s=f.length-1;s>=0;s--){const n=f[s][1];n.updateHeight();const i=n.balanceFactor();if(i<-1||i>1){const g=f[s][0],d=f[s+1][0];if(g===y.Right&&d===y.Right)f[s][1]=n.rotateLeft();else if(g===y.Left&&d===y.Left)f[s][1]=n.rotateRight();else if(g===y.Right&&d===y.Left)n.right=f[s+1][1]=f[s+1][1].rotateRight(),f[s][1]=n.rotateLeft();else if(g===y.Left&&d===y.Right)n.left=f[s+1][1]=f[s+1][1].rotateLeft(),f[s][1]=n.rotateRight();else throw new Error;if(s>0)switch(f[s-1][0]){case y.Left:f[s-1][1].left=f[s][1];break;case y.Right:f[s-1][1].right=f[s][1];break;case y.Mid:f[s-1][1].mid=f[s][1];break}else this.c=f[0][1]}}return t}get(h){return this.d(h)?.value}d(h){const r=this.b.reset(h);let o=this.c;for(;o;){const c=r.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(h){const r=this.d(h);return!(r?.value===void 0&&r?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,r){const o=this.b.reset(h),c=[];let f=this.c;for(;f;){const t=o.cmp(f.segment);if(t>0)c.push([y.Left,f]),f=f.left;else if(t<0)c.push([y.Right,f]),f=f.right;else if(o.hasNext())o.next(),c.push([y.Mid,f]),f=f.mid;else break}if(f){if(r?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const t=this.f(f.right);if(t.key){const{key:s,value:n,segment:i}=t;this.e(t.key,!1),f.key=s,f.value=n,f.segment=i}}else{const t=f.left??f.right;if(c.length>0){const[s,n]=c[c.length-1];switch(s){case y.Left:n.left=t;break;case y.Mid:n.mid=t;break;case y.Right:n.right=t;break}}else this.c=t}for(let t=c.length-1;t>=0;t--){const s=c[t][1];s.updateHeight();const n=s.balanceFactor();if(n>1?(s.right.balanceFactor()>=0||(s.right=s.right.rotateRight()),c[t][1]=s.rotateLeft()):n<-1&&(s.left.balanceFactor()<=0||(s.left=s.left.rotateLeft()),c[t][1]=s.rotateRight()),t>0)switch(c[t-1][0]){case y.Left:c[t-1][1].left=c[t][1];break;case y.Right:c[t-1][1].right=c[t][1];break;case y.Mid:c[t-1][1].mid=c[t][1];break}else this.c=c[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const r=this.b.reset(h);let o=this.c,c;for(;o;){const f=r.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(r.hasNext())r.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(h){return this.g(h,!1)}g(h,r){const o=this.b.reset(h);let c=this.c;for(;c;){const f=o.cmp(c.segment);if(f>0)c=c.left;else if(f<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else return c.mid?this.h(c.mid):r?c.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[r,o]of this)h(o,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const r=[];return this.j(h,r),r[Symbol.iterator]()}j(h,r){h&&(h.left&&this.j(h.left,r),h.value&&r.push([h.key,h.value]),h.mid&&this.j(h.mid,r),h.right&&this.j(h.right,r))}_isBalanced(){const h=r=>{if(!r)return!0;const o=r.balanceFactor();return o<-1||o>1?!1:h(r.left)&&h(r.right)};return h(this.c)}}e.$Gi=u}),define(Ce[48],Ie([1,0,23,2,36]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=T,e.$9h=A,e.$0h=$;function T(a){return JSON.stringify(a,M)}function A(a){let P=JSON.parse(a);return P=$(P),P}function M(a,P){return P instanceof RegExp?{$mid:I.MarshalledId.Regexp,source:P.source,flags:P.flags}:P}function $(a,P=0){if(!a||P>200)return a;if(typeof a=="object"){switch(a.$mid){case I.MarshalledId.Uri:return D.URI.revive(a);case I.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case I.MarshalledId.Date:return new Date(a.source)}if(a instanceof b.$Je||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let y=0;y<a.length;++y)a[y]=$(a[y],P+1);else for(const y in a)Object.hasOwnProperty.call(a,y)&&(a[y]=$(a[y],P+1))}return a}}),define(Ce[16],Ie([1,0,14,21,13,2,20]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Ng=e.$Mg=e.$Lg=e.Schemas=void 0,e.$Jg=$,e.$Kg=a,e.$Og=y;var M;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeManagedRemoteResource="vscode-managed-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeChatCodeBlock="vscode-chat-code-block",h.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",h.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",h.vscodeChatSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm",h.commentsInput="comment",h.codeSetting="code-setting"})(M||(e.Schemas=M={}));function $(h,r){return T.URI.isUri(h)?(0,I.$Bf)(h.scheme,r):(0,I.$Cf)(h,r+":")}function a(h,...r){return r.some(o=>$(h,o))}e.$Lg="vscode-tkn",e.$Mg="tkn";class P{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,o){this.f=y(r,o)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,M.vscodeRemoteResource)}set(r,o,c){this.a[r]=o,this.b[r]=c}setConnectionToken(r,o){this.c[r]=o}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(n){return b.$1(n),r}const o=r.authority;let c=this.a[o];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const f=this.b[o],t=this.c[o];let s=`path=${encodeURIComponent(r.path)}`;return typeof t=="string"&&(s+=`&${e.$Mg}=${encodeURIComponent(t)}`),T.URI.from({scheme:D.$i?this.d:M.vscodeRemoteResource,authority:`${c}:${f}`,path:D.$i?(window.location.pathname+"/"+this.g).replace(/\/\/+/g,"/"):this.g,query:s})}}e.$Ng=new P;function y(h,r){return A.$gc.join(r??"/",`${h.quality??"oss"}-${h.commit??"dev"}`)}e.$Pg="vs/../../extensions",e.$Qg="vs/../../node_modules",e.$Rg="vs/../../node_modules.asar",e.$Sg="vs/../../node_modules.asar.unpacked",e.$Tg="vscode-app";class u{asBrowserUri(r){const o=this.b(r,_);return this.uriToBrowserUri(o)}uriToBrowserUri(r){return r.scheme===M.vscodeRemote?e.$Ng.rewrite(r):r.scheme===M.file&&(D.$g||D.$k===`${M.vscodeFileResource}://${u.a}`)?r.with({scheme:M.vscodeFileResource,authority:r.authority||u.a,query:null,fragment:null}):r}asFileUri(r){const o=this.b(r,_);return this.uriToFileUri(o)}uriToFileUri(r){return r.scheme===M.vscodeFileResource?r.with({scheme:M.file,authority:r.authority!==u.a?r.authority:null,query:null,fragment:null}):r}b(r,o){return T.URI.isUri(r)?r:T.URI.parse(o.toUrl(r))}}u.a=e.$Tg,e.$Ug=new u;var k;(function(h){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(r.get("3"));const o="vscode-coi";function c(t){let s;typeof t=="string"?s=new URL(t).searchParams:t instanceof URL?s=t.searchParams:T.URI.isUri(t)&&(s=new URL(t.toString(!0)).searchParams);const n=s?.get(o);if(n)return r.get(n)}h.getHeadersFromQuery=c;function f(t,s,n){if(!globalThis.crossOriginIsolated)return;const i=s&&n?"3":n?"2":"1";t instanceof URLSearchParams?t.set(o,i):t[o]=i}h.addSearchParam=f})(k||(e.COI=k={}))}),define(Ce[24],Ie([1,0,28,52,16,20,21,13,2]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=void 0,e.$2g=a,e.$kh=y,e.$lh=k;function a(h){return(0,$.$wc)(h,!0)}class P{constructor(r){this.a=r}compare(r,o,c=!1){return r===o?0:(0,M.$uf)(this.getComparisonKey(r,c),this.getComparisonKey(o,c))}isEqual(r,o,c=!1){return r===o?!0:!r||!o?!1:this.getComparisonKey(r,c)===this.getComparisonKey(o,c)}getComparisonKey(r,o=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,o,c=!1){if(r.scheme===o.scheme){if(r.scheme===I.Schemas.file)return D.$zg(a(r),a(o),this.a(r))&&r.query===o.query&&(c||r.fragment===o.fragment);if((0,e.$gh)(r.authority,o.authority))return D.$zg(r.path,o.path,this.a(r),"/")&&r.query===o.query&&(c||r.fragment===o.fragment)}return!1}joinPath(r,...o){return $.URI.joinPath(r,...o)}basenameOrAuthority(r){return(0,e.$$g)(r)||r.authority}basename(r){return T.$gc.basename(r.path)}extname(r){return T.$gc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let o;return r.scheme===I.Schemas.file?o=$.URI.file(T.$mc(a(r))).path:(o=T.$gc.dirname(r.path),r.authority&&o.length&&o.charCodeAt(0)!==b.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),o="/")),r.with({path:o})}normalizePath(r){if(!r.path.length)return r;let o;return r.scheme===I.Schemas.file?o=$.URI.file(T.$hc(a(r))).path:o=T.$gc.normalize(r.path),r.with({path:o})}relativePath(r,o){if(r.scheme!==o.scheme||!(0,e.$gh)(r.authority,o.authority))return;if(r.scheme===I.Schemas.file){const t=T.$lc(a(r),a(o));return A.$c?D.$tg(t):t}let c=r.path||"/";const f=o.path||"/";if(this.a(r)){let t=0;for(const s=Math.min(c.length,f.length);t<s&&!(c.charCodeAt(t)!==f.charCodeAt(t)&&c.charAt(t).toLowerCase()!==f.charAt(t).toLowerCase());t++);c=f.substr(0,t)+c.substr(t)}return T.$gc.relative(c,f)}resolvePath(r,o){if(r.scheme===I.Schemas.file){const c=$.URI.file(T.$kc(a(r),o));return r.with({authority:c.authority,path:c.path})}return o=D.$ug(o),r.with({path:T.$gc.resolve(r.path,o)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,o){return r===o||r!==void 0&&o!==void 0&&(0,M.$Bf)(r,o)}hasTrailingPathSeparator(r,o=T.sep){if(r.scheme===I.Schemas.file){const c=a(r);return c.length>D.$vg(c).length&&c[c.length-1]===o}else{const c=r.path;return c.length>1&&c.charCodeAt(c.length-1)===b.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,o=T.sep){return(0,e.$hh)(r,o)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,o=T.sep){let c=!1;if(r.scheme===I.Schemas.file){const f=a(r);c=f!==void 0&&f.length===D.$vg(f).length&&f[f.length-1]===o}else{o="/";const f=r.path;c=f.length===1&&f.charCodeAt(f.length-1)===b.CharCode.Slash}return!c&&!(0,e.$hh)(r,o)?r.with({path:r.path+"/"}):r}}e.$3g=P,e.$4g=new P(()=>!1),e.$5g=new P(h=>h.scheme===I.Schemas.file?!A.$e:!0),e.$6g=new P(h=>!0),e.$7g=e.$4g.isEqual.bind(e.$4g),e.$8g=e.$4g.isEqualOrParent.bind(e.$4g),e.$9g=e.$4g.getComparisonKey.bind(e.$4g),e.$0g=e.$4g.basenameOrAuthority.bind(e.$4g),e.$$g=e.$4g.basename.bind(e.$4g),e.$_g=e.$4g.extname.bind(e.$4g),e.$ah=e.$4g.dirname.bind(e.$4g),e.$bh=e.$4g.joinPath.bind(e.$4g),e.$ch=e.$4g.normalizePath.bind(e.$4g),e.$dh=e.$4g.relativePath.bind(e.$4g),e.$eh=e.$4g.resolvePath.bind(e.$4g),e.$fh=e.$4g.isAbsolutePath.bind(e.$4g),e.$gh=e.$4g.isEqualAuthority.bind(e.$4g),e.$hh=e.$4g.hasTrailingPathSeparator.bind(e.$4g),e.$ih=e.$4g.removeTrailingPathSeparator.bind(e.$4g),e.$jh=e.$4g.addTrailingPathSeparator.bind(e.$4g);function y(h,r){const o=[];for(let c=0;c<h.length;c++){const f=r(h[c]);h.some((t,s)=>s===c?!1:(0,e.$8g)(f,r(t)))||o.push(h[c])}return o}var u;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function r(o){const c=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(s=>{const[n,i]=s.split(":");n&&i&&c.set(n,i)});const t=o.path.substring(0,o.path.indexOf(";"));return t&&c.set(h.META_DATA_MIME,t),c}h.parseMetaData=r})(u||(e.DataUri=u={}));function k(h,r,o){if(r){let c=h.path;return c&&c[0]!==T.$gc.sep&&(c=T.$gc.sep+c),h.with({scheme:o,authority:r,path:c})}return h.with({scheme:o})}}),define(Ce[11],Ie([1,0,22,14,4,6,24,21,145,47]),function(_,e,b,D,I,T,A,M,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.Promises=e.$Xh=e.$Wh=e.$Vh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=void 0,e.$mh=P,e.$nh=y,e.$oh=u,e.$ph=k,e.$qh=h,e.$rh=r,e.$sh=o,e.$th=c,e.$Bh=C,e.$Ch=S,e.$Dh=v,e.$Eh=E,e.$Fh=R,e.$Uh=ve,e.$3h=re;function P(oe){return!!oe&&typeof oe.then=="function"}function y(oe){const J=new b.$se,Y=oe(J.token),we=new Promise((pe,Me)=>{const Ve=J.token.onCancellationRequested(()=>{Ve.dispose(),Me(new D.$5)});Promise.resolve(Y).then(Se=>{Ve.dispose(),J.dispose(),pe(Se)},Se=>{Ve.dispose(),J.dispose(),Me(Se)})});return new class{cancel(){J.cancel(),J.dispose()}then(pe,Me){return we.then(pe,Me)}catch(pe){return this.then(void 0,pe)}finally(pe){return we.finally(pe)}}}function u(oe,J,Y){return new Promise((we,pe)=>{const Me=J.onCancellationRequested(()=>{Me.dispose(),we(Y)});oe.then(we,pe).finally(()=>Me.dispose())})}function k(oe,J){return new Promise((Y,we)=>{const pe=J.onCancellationRequested(()=>{pe.dispose(),we(new D.$5)});oe.then(Y,we).finally(()=>pe.dispose())})}async function h(oe){let J=-1;const Y=oe.map((we,pe)=>we.then(Me=>(J=pe,Me)));try{return await Promise.race(Y)}finally{oe.forEach((we,pe)=>{pe!==J&&we.cancel()})}}function r(oe,J,Y){let we;const pe=setTimeout(()=>{we?.(void 0),Y?.()},J);return Promise.race([oe.finally(()=>clearTimeout(pe)),new Promise(Me=>we=Me)])}function o(oe){return new Promise((J,Y)=>{const we=oe();P(we)?we.then(J,Y):J(we)})}function c(){let oe,J;return{promise:new Promise((we,pe)=>{oe=we,J=pe}),resolve:oe,reject:J}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const Y=()=>{if(this.b=null,this.f)return;const we=this.queue(this.d);return this.d=null,we};this.b=new Promise(we=>{this.a.then(Y,Y).then(we)})}return new Promise((Y,we)=>{this.b.then(Y,we)})}return this.a=J(),new Promise((Y,we)=>{this.a.then(pe=>{this.a=null,Y(pe)},pe=>{this.a=null,we(pe)})})}dispose(){this.f=!0}}e.$uh=f;class t{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$vh=t;class s{constructor(){this.a=new Map}queue(J,Y){const pe=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(J)===pe&&this.a.delete(J)});return this.a.set(J,pe),pe}}e.$wh=s;const n=(oe,J)=>{let Y=!0;const we=setTimeout(()=>{Y=!1,J()},oe);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(we),Y=!1}}},i=oe=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,oe())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class g{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,Y=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((pe,Me)=>{this.d=pe,this.f=Me}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const we=()=>{this.a=null,this.d?.(null)};return this.a=Y===$.$ce?i(we):n(Y,we),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new D.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$xh=g;class d{constructor(J){this.a=new g(J),this.b=new f}trigger(J,Y){return this.a.trigger(()=>this.b.queue(J),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$yh=d;class l{constructor(){this.a=!1,this.b=new Promise((J,Y)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$zh=l;class p extends l{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$Ah=p;function C(oe,J){return J?new Promise((Y,we)=>{const pe=setTimeout(()=>{Me.dispose(),Y()},oe),Me=J.onCancellationRequested(()=>{clearTimeout(pe),Me.dispose(),we(new D.$5)})}):y(Y=>C(oe,Y))}function S(oe,J=0,Y){const we=setTimeout(()=>{oe(),Y&&pe.dispose()},J),pe=(0,T.$Sc)(()=>{clearTimeout(we),Y?.deleteAndLeak(pe)});return Y?.add(pe),pe}function v(oe){const J=[];let Y=0;const we=oe.length;function pe(){return Y<we?oe[Y++]():null}function Me(Ve){Ve!=null&&J.push(Ve);const Se=pe();return Se?Se.then(Me):Promise.resolve(J)}return Promise.resolve(null).then(Me)}function E(oe,J=we=>!!we,Y=null){let we=0;const pe=oe.length,Me=()=>{if(we>=pe)return Promise.resolve(Y);const Ve=oe[we++];return Promise.resolve(Ve()).then(Pe=>J(Pe)?Promise.resolve(Pe):Me())};return Me()}function R(oe,J=we=>!!we,Y=null){if(oe.length===0)return Promise.resolve(Y);let we=oe.length;const pe=()=>{we=-1;for(const Me of oe)Me.cancel?.()};return new Promise((Me,Ve)=>{for(const Se of oe)Se.then(Pe=>{--we>=0&&J(Pe)?(pe(),Me(Pe)):we===0&&Me(Y)}).catch(Pe=>{--we>=0&&(pe(),Ve(Pe))})})}class w{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new I.$he}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,we)=>{this.g.push({factory:J,c:Y,e:we}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const Y=J.factory();Y.then(J.c,J.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Gh=w;class m extends w{constructor(){super(1)}}e.$Hh=m;class N{constructor(){this.a=new Z,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$Ih=N;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ee;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,Y=A.$4g){const we=Y.getComparisonKey(J);return this.a.get(we)?.size??0}queueFor(J,Y,we=A.$4g){const pe=we.getComparisonKey(J);let Me=this.a.get(pe);if(!Me){Me=new m;const Ve=this.f++,Se=I.Event.once(Me.onDrained)(()=>{Me?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(Ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$4c),this.d.set(Ve,Se),this.a.set(pe,Me)}return Me.queue(Y)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Jh=B;class X{constructor(J,Y){this.b=!1,this.a=-1,typeof J=="function"&&typeof Y=="number"&&this.setIfNotSet(J,Y)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,Y){if(this.b)throw new D.$cb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},Y)}setIfNotSet(J,Y){if(this.b)throw new D.$cb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},Y))}}e.$Kh=X;class V{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,Y,we=globalThis){if(this.f)throw new D.$cb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const pe=we.setInterval(()=>{J()},Y);this.d=(0,T.$Sc)(()=>{we.clearInterval(pe),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Lh=V;class O{constructor(J,Y){this.b=-1,this.a=J,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Mh=O;class L{constructor(J,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=J,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Nh=L;class F extends O{constructor(J,Y){super(J,Y),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$Oh=F;class ie extends T.$Uc{constructor(J,Y){super(),this.g=J,this.h=Y,this.a=[],this.b=this.B(new T.$Vc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of J)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Ph=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Rh=(oe,J)=>{(0,M.$v)(()=>{if(Y)return;const we=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,we-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Rh=(oe,J,Y)=>{const we=oe.requestIdleCallback(J,typeof Y=="number"?{timeout:Y}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,oe.cancelIdleCallback(we))}}},e.$Qh=oe=>(0,e.$Rh)(globalThis,oe)}();class de{constructor(J,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(we){this.l=we}finally{this.g=!0}},this.f=(0,e.$Rh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Sh=de;class be extends de{constructor(J){super(globalThis,J)}}e.$Th=be;async function ve(oe,J,Y){let we;for(let pe=0;pe<Y;pe++)try{return await oe()}catch(Me){we=Me,await C(J)}throw we}class Z{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,Y,we){return this.a={taskId:J,cancel:()=>we?.(),promise:Y},Y.then(()=>this.d(J),()=>this.d(J)),Y}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{const{promise:Y,resolve:we,reject:pe}=c();this.b={run:J,promise:Y,promiseResolve:we,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Vh=Z;class ae{constructor(J,Y=()=>Date.now()){this.d=J,this.f=Y,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$Wh=ae;var fe;(function(oe){oe[oe.Resolved=0]="Resolved",oe[oe.Rejected=1]="Rejected"})(fe||(fe={}));class ee{get isRejected(){return this.d?.outcome===fe.Rejected}get isResolved(){return this.d?.outcome===fe.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===fe.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((J,Y)=>{this.a=J,this.b=Y})}complete(J){return new Promise(Y=>{this.a(J),this.d={outcome:fe.Resolved,value:J},Y()})}error(J){return new Promise(Y=>{this.b(J),this.d={outcome:fe.Rejected,value:J},Y()})}cancel(){return this.error(new D.$5)}}e.$Xh=ee;var De;(function(oe){async function J(we){let pe;const Me=await Promise.all(we.map(Ve=>Ve.then(Se=>Se,Se=>{pe||(pe=Se)})));if(typeof pe<"u")throw pe;return Me}oe.settled=J;function Y(we){return new Promise(async(pe,Me)=>{try{await we(pe,Me)}catch(Ve){Me(Ve)}})}oe.withAsyncBody=Y})(De||(e.Promises=De={}));class Fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new D.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Yh=Fe;class ce{constructor(J){this.b=J,this.a=new a.$V(()=>new Fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Zh=ce;var H;(function(oe){oe[oe.Initial=0]="Initial",oe[oe.DoneOK=1]="DoneOK",oe[oe.DoneError=2]="DoneError"})(H||(H={}));class he{static fromArray(J){return new he(Y=>{Y.emitMany(J)})}static fromPromise(J){return new he(async Y=>{Y.emitMany(await J)})}static fromPromises(J){return new he(async Y=>{await Promise.all(J.map(async we=>Y.emitOne(await we)))})}static merge(J){return new he(async Y=>{await Promise.all(J.map(async we=>{for await(const pe of we)Y.emitOne(pe)}))})}constructor(J,Y){this.a=H.Initial,this.b=[],this.d=null,this.f=Y,this.g=new I.$he,queueMicrotask(async()=>{const we={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(J(we)),this.k()}catch(pe){this.l(pe)}finally{we.emitOne=void 0,we.emitMany=void 0,we.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===H.DoneError)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===H.DoneOK)return{done:!0,value:void 0};await I.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(J,Y){return new he(async we=>{for await(const pe of J)we.emitOne(Y(pe))})}map(J){return he.map(this,J)}static filter(J,Y){return new he(async we=>{for await(const pe of J)Y(pe)&&we.emitOne(pe)})}filter(J){return he.filter(this,J)}static coalesce(J){return he.filter(J,Y=>!!Y)}coalesce(){return he.coalesce(this)}static async toPromise(J){const Y=[];for await(const we of J)Y.push(we);return Y}toPromise(){return he.toPromise(this)}h(J){this.a===H.Initial&&(this.b.push(J),this.g.fire())}j(J){this.a===H.Initial&&(this.b=this.b.concat(J),this.g.fire())}k(){this.a===H.Initial&&(this.a=H.DoneOK,this.g.fire())}l(J){this.a===H.Initial&&(this.a=H.DoneError,this.d=J,this.g.fire())}}e.$1h=he,he.EMPTY=he.fromArray([]);class le extends he{constructor(J,Y){super(Y),this.m=J}cancel(){this.m.cancel()}}e.$2h=le;function re(oe){const J=new b.$se,Y=oe(J.token);return new le(J,async we=>{const pe=J.token.onCancellationRequested(()=>{pe.dispose(),J.dispose(),we.reject(new D.$5)});try{for await(const Me of Y){if(J.token.isCancellationRequested)return;we.emitOne(Me)}pe.dispose(),J.dispose()}catch(Me){pe.dispose(),J.dispose(),we.reject(Me)}})}class ue{constructor(J){this.a=new ee,this.b=new he(pe=>{if(Y){pe.reject(Y);return}return we&&pe.emitMany(we),this.d=Me=>pe.reject(Me),this.f=Me=>pe.emitOne(Me),this.a.p},J);let Y,we;this.f=pe=>{we||(we=[]),we.push(pe)},this.d=pe=>{Y||(Y=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$4h=ue}),define(Ce[41],Ie([1,0,18,11,28,52,29,20,21,13]),function(_,e,b,D,I,T,A,M,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=void 0,e.$pk=P,e.$sk=r,e.$tk=N,e.$uk=B,e.$vk=X,e.$wk=V,e.$xk=O,e.$yk=de;function P(){return Object.create(null)}e.$qk="**",e.$rk="/";const y="[/\\\\]",u="[^/\\\\]",k=/\//g;function h(be,ve){switch(be){case 0:return"";case 1:return`${u}*?`;default:return`(?:${y}|${u}+${y}${ve?`|${y}${u}+`:""})*?`}}function r(be,ve){if(!be)return[];const Z=[];let ae=!1,fe=!1,ee="";for(const De of be){switch(De){case ve:if(!ae&&!fe){Z.push(ee),ee="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":fe=!0;break;case"]":fe=!1;break}ee+=De}return ee&&Z.push(ee),Z}function o(be){if(!be)return"";let ve="";const Z=r(be,e.$rk);if(Z.every(ae=>ae===e.$qk))ve=".*";else{let ae=!1;Z.forEach((fe,ee)=>{if(fe===e.$qk){if(ae)return;ve+=h(2,ee===Z.length-1)}else{let De=!1,Fe="",ce=!1,H="";for(const he of fe){if(he!=="}"&&De){Fe+=he;continue}if(ce&&(he!=="]"||!H)){let le;he==="-"?le=he:(he==="^"||he==="!")&&!H?le="^":he===e.$rk?le="":le=(0,a.$df)(he),H+=le;continue}switch(he){case"{":De=!0;continue;case"[":ce=!0;continue;case"}":{const re=`(?:${r(Fe,",").map(ue=>o(ue)).join("|")})`;ve+=re,De=!1,Fe="";break}case"]":{ve+="["+H+"]",ce=!1,H="";break}case"?":ve+=u;continue;case"*":ve+=h(1);continue;default:ve+=(0,a.$df)(he)}}ee<Z.length-1&&(Z[ee+1]!==e.$qk||ee+2<Z.length)&&(ve+=y)}ae=fe===e.$qk})}return ve}const c=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,t=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,s=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,i=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,g=new A.$Dc(1e4),d=function(){return!1},l=function(){return null};function p(be,ve){if(!be)return l;let Z;typeof be!="string"?Z=be.pattern:Z=be,Z=Z.trim();const ae=`${Z}_${!!ve.trimForExclusions}`;let fe=g.get(ae);if(fe)return C(fe,be);let ee;return c.test(Z)?fe=v(Z.substr(4),Z):(ee=f.exec(S(Z,ve)))?fe=E(ee[1],Z):(ve.trimForExclusions?s:t).test(Z)?fe=R(Z,ve):(ee=n.exec(S(Z,ve)))?fe=w(ee[1].substr(1),Z,!0):(ee=i.exec(S(Z,ve)))?fe=w(ee[1],Z,!1):fe=m(Z),g.set(ae,fe),C(fe,be)}function C(be,ve){if(typeof ve=="string")return be;const Z=function(ae,fe){return(0,T.$zg)(ae,ve.base,!$.$e)?be((0,a.$if)(ae.substr(ve.base.length),M.sep),fe):null};return Z.allBasenames=be.allBasenames,Z.allPaths=be.allPaths,Z.basenames=be.basenames,Z.patterns=be.patterns,Z}function S(be,ve){return ve.trimForExclusions&&be.endsWith("/**")?be.substr(0,be.length-2):be}function v(be,ve){return function(Z,ae){return typeof Z=="string"&&Z.endsWith(be)?ve:null}}function E(be,ve){const Z=`/${be}`,ae=`\\${be}`,fe=function(De,Fe){return typeof De!="string"?null:Fe?Fe===be?ve:null:De===be||De.endsWith(Z)||De.endsWith(ae)?ve:null},ee=[be];return fe.basenames=ee,fe.patterns=[ve],fe.allBasenames=ee,fe}function R(be,ve){const Z=ie(be.slice(1,-1).split(",").map(Fe=>p(Fe,ve)).filter(Fe=>Fe!==l),be),ae=Z.length;if(!ae)return l;if(ae===1)return Z[0];const fe=function(Fe,ce){for(let H=0,he=Z.length;H<he;H++)if(Z[H](Fe,ce))return be;return null},ee=Z.find(Fe=>!!Fe.allBasenames);ee&&(fe.allBasenames=ee.allBasenames);const De=Z.reduce((Fe,ce)=>ce.allPaths?Fe.concat(ce.allPaths):Fe,[]);return De.length&&(fe.allPaths=De),fe}function w(be,ve,Z){const ae=M.sep===M.$gc.sep,fe=ae?be:be.replace(k,M.sep),ee=M.sep+fe,De=M.$gc.sep+be;let Fe;return Z?Fe=function(ce,H){return typeof ce=="string"&&(ce===fe||ce.endsWith(ee)||!ae&&(ce===be||ce.endsWith(De)))?ve:null}:Fe=function(ce,H){return typeof ce=="string"&&(ce===fe||!ae&&ce===be)?ve:null},Fe.allPaths=[(Z?"*/":"./")+be],Fe}function m(be){try{const ve=new RegExp(`^${o(be)}$`);return function(Z){return ve.lastIndex=0,typeof Z=="string"&&ve.test(Z)?be:null}}catch{return l}}function N(be,ve,Z){return!be||typeof ve!="string"?!1:B(be)(ve,void 0,Z)}function B(be,ve={}){if(!be)return d;if(typeof be=="string"||X(be)){const Z=p(be,ve);if(Z===l)return d;const ae=function(fe,ee){return!!Z(fe,ee)};return Z.allBasenames&&(ae.allBasenames=Z.allBasenames),Z.allPaths&&(ae.allPaths=Z.allPaths),ae}return L(be,ve)}function X(be){const ve=be;return ve?typeof ve.base=="string"&&typeof ve.pattern=="string":!1}function V(be){return be.allBasenames||[]}function O(be){return be.allPaths||[]}function L(be,ve){const Z=ie(Object.getOwnPropertyNames(be).map(Fe=>F(Fe,be[Fe],ve)).filter(Fe=>Fe!==l)),ae=Z.length;if(!ae)return l;if(!Z.some(Fe=>!!Fe.requiresSiblings)){if(ae===1)return Z[0];const Fe=function(he,le){let re;for(let ue=0,oe=Z.length;ue<oe;ue++){const J=Z[ue](he,le);if(typeof J=="string")return J;(0,D.$mh)(J)&&(re||(re=[]),re.push(J))}return re?(async()=>{for(const ue of re){const oe=await ue;if(typeof oe=="string")return oe}return null})():null},ce=Z.find(he=>!!he.allBasenames);ce&&(Fe.allBasenames=ce.allBasenames);const H=Z.reduce((he,le)=>le.allPaths?he.concat(le.allPaths):he,[]);return H.length&&(Fe.allPaths=H),Fe}const fe=function(Fe,ce,H){let he,le;for(let re=0,ue=Z.length;re<ue;re++){const oe=Z[re];oe.requiresSiblings&&H&&(ce||(ce=(0,M.$nc)(Fe)),he||(he=ce.substr(0,ce.length-(0,M.$oc)(Fe).length)));const J=oe(Fe,ce,he,H);if(typeof J=="string")return J;(0,D.$mh)(J)&&(le||(le=[]),le.push(J))}return le?(async()=>{for(const re of le){const ue=await re;if(typeof ue=="string")return ue}return null})():null},ee=Z.find(Fe=>!!Fe.allBasenames);ee&&(fe.allBasenames=ee.allBasenames);const De=Z.reduce((Fe,ce)=>ce.allPaths?Fe.concat(ce.allPaths):Fe,[]);return De.length&&(fe.allPaths=De),fe}function F(be,ve,Z){if(ve===!1)return l;const ae=p(be,Z);if(ae===l)return l;if(typeof ve=="boolean")return ae;if(ve){const fe=ve.when;if(typeof fe=="string"){const ee=(De,Fe,ce,H)=>{if(!H||!ae(De,Fe))return null;const he=fe.replace("$(basename)",()=>ce),le=H(he);return(0,D.$mh)(le)?le.then(re=>re?be:null):le?be:null};return ee.requiresSiblings=!0,ee}}return ae}function ie(be,ve){const Z=be.filter(Fe=>!!Fe.basenames);if(Z.length<2)return be;const ae=Z.reduce((Fe,ce)=>{const H=ce.basenames;return H?Fe.concat(H):Fe},[]);let fe;if(ve){fe=[];for(let Fe=0,ce=ae.length;Fe<ce;Fe++)fe.push(ve)}else fe=Z.reduce((Fe,ce)=>{const H=ce.patterns;return H?Fe.concat(H):Fe},[]);const ee=function(Fe,ce){if(typeof Fe!="string")return null;if(!ce){let he;for(he=Fe.length;he>0;he--){const le=Fe.charCodeAt(he-1);if(le===I.CharCode.Slash||le===I.CharCode.Backslash)break}ce=Fe.substr(he)}const H=ae.indexOf(ce);return H!==-1?fe[H]:null};ee.basenames=ae,ee.patterns=fe,ee.allBasenames=ae;const De=be.filter(Fe=>!Fe.basenames);return De.push(ee),De}function de(be,ve){return(0,b.$ub)(be,ve,(Z,ae)=>typeof Z=="string"&&typeof ae=="string"?Z===ae:typeof Z!="string"&&typeof ae!="string"?Z.base===ae.base&&Z.pattern===ae.pattern:!1)}}),define(Ce[59],Ie([1,0,14,98,24,13,2]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xk=e.MarkdownStringTextNewlineStyle=void 0,e.$Yk=a,e.$Zk=P,e.$1k=y,e.$2k=u,e.$3k=k,e.$4k=h,e.$5k=r,e.$6k=o;var M;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(M||(e.MarkdownStringTextNewlineStyle=M={}));class ${constructor(f="",t=!1){if(this.value=f,typeof this.value!="string")throw(0,b.$7)("value");typeof t=="boolean"?(this.isTrusted=t,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=t.isTrusted??void 0,this.supportThemeIcons=t.supportThemeIcons??!1,this.supportHtml=t.supportHtml??!1)}appendText(f,t=M.Paragraph){return this.value+=u(this.supportThemeIcons?(0,D.$Rk)(f):f).replace(/([ \t]+)/g,(s,n)=>"&nbsp;".repeat(n.length)).replace(/\>/gm,"\\>").replace(/\n/g,t===M.Break?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,t){return this.value+=`
${k(t,f)}
`,this}appendLink(f,t,s){return this.value+="[",this.value+=this.c(t,"]"),this.value+="](",this.value+=this.c(String(f),")"),s&&(this.value+=` "${this.c(this.c(s,'"'),")")}"`),this.value+=")",this}c(f,t){const s=new RegExp((0,T.$df)(t),"g");return f.replace(s,(n,i)=>f.charAt(i-1)!=="\\"?`\\${n}`:n)}}e.$Xk=$;function a(c){return P(c)?!c.value:Array.isArray(c)?c.every(a):!0}function P(c){return c instanceof $?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function y(c,f){return c===f?!0:!c||!f?!1:c.value===f.value&&c.isTrusted===f.isTrusted&&c.supportThemeIcons===f.supportThemeIcons&&c.supportHtml===f.supportHtml&&(c.baseUri===f.baseUri||!!c.baseUri&&!!f.baseUri&&(0,I.$7g)(A.URI.from(c.baseUri),A.URI.from(f.baseUri)))}function u(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function k(c,f){const t=c.match(/^`+/gm)?.reduce((n,i)=>n.length>i.length?n:i).length??0,s=t>=3?t+1:3;return[`${"`".repeat(s)}${f}`,c,`${"`".repeat(s)}`].join(`
`)}function h(c){return c.replace(/"/g,"&quot;")}function r(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(c){const f=[],t=c.split("|").map(n=>n.trim());c=t[0];const s=t[1];if(s){const n=/height=(\d+)/.exec(s),i=/width=(\d+)/.exec(s),g=n?n[1]:"",d=i?i[1]:"",l=isFinite(parseInt(d)),p=isFinite(parseInt(g));l&&f.push(`width="${d}"`),p&&f.push(`height="${g}"`)}return{href:c,dimensions:f}}}),define(Ce[99],Ie([1,0,18,52,20,21,24,13]),function(_,e,b,D,I,T,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nw=$,e.$Ow=P,e.$Pw=u,e.$Qw=k,e.$Rw=c,e.$Sw=t,e.$Tw=s,e.$Uw=n,e.$Vw=i,e.$Ww=g;function $(l,p){const{os:C,tildify:S,relative:v}=p;if(v){const w=a(l,v,C);if(typeof w=="string")return w}let E=l.fsPath;if(C===T.OperatingSystem.Windows&&!T.$c?E=E.replace(/\//g,"\\"):C!==T.OperatingSystem.Windows&&T.$c&&(E=E.replace(/\\/g,"/")),C!==T.OperatingSystem.Windows&&S?.userHome){const w=S.userHome.fsPath;let m;l.scheme!==S.userHome.scheme&&l.path[0]===I.$gc.sep&&l.path[1]!==I.$gc.sep?m=S.userHome.with({path:l.path}).fsPath:m=E,E=u(m,w,C)}return(C===T.OperatingSystem.Windows?I.$fc:I.$gc).normalize(P(E,C===T.OperatingSystem.Windows))}function a(l,p,C){const S=C===T.OperatingSystem.Windows?I.$fc:I.$gc,v=C===T.OperatingSystem.Linux?A.$4g:A.$6g,E=p.getWorkspace(),R=(0,b.$Ob)(E.folders);if(!R)return;l.scheme!==R.uri.scheme&&l.path[0]===I.$gc.sep&&l.path[1]!==I.$gc.sep&&(l=R.uri.with({path:l.path}));const w=p.getWorkspaceFolder(l);if(!w)return;let m;if(v.isEqual(w.uri,l)?m="":m=v.relativePath(w.uri,l)??"",m&&(m=S.normalize(m)),E.folders.length>1&&!p.noPrefix){const N=w.name?w.name:v.basenameOrAuthority(w.uri);m=m?`${N} \u2022 ${m}`:N}return m}function P(l,p=T.$c){return(0,D.$Eg)(l,p)?l.charAt(0).toUpperCase()+l.slice(1):l}let y=Object.create(null);function u(l,p,C=T.OS){if(C===T.OperatingSystem.Windows||!l||!p)return l;let S=y.original===p?y.normalized:void 0;S||(S=p,T.$c&&(S=(0,D.$tg)(S)),S=`${(0,M.$jf)(S,I.$gc.sep)}${I.$gc.sep}`,y={original:p,normalized:S});let v=l;return T.$c&&(v=(0,D.$tg)(v)),(C===T.OperatingSystem.Linux?v.startsWith(S):(0,M.$Cf)(v,S))?`~/${v.substr(S.length)}`:l}function k(l,p){return l.replace(/^~($|\/|\\)/,`${p}$1`)}const h="\u2026",r="\\\\",o="~";function c(l,p=I.sep){const C=new Array(l.length);let S=!1;for(let v=0;v<l.length;v++){const E=l[v];if(E===""){C[v]=`.${p}`;continue}if(!E){C[v]=E;continue}S=!0;let R="",w=E;w.indexOf(r)===0?(R=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length)):w.indexOf(p)===0?(R=w.substr(0,w.indexOf(p)+p.length),w=w.substr(w.indexOf(p)+p.length)):w.indexOf(o)===0&&(R=w.substr(0,w.indexOf(o)+o.length),w=w.substr(w.indexOf(o)+o.length));const m=w.split(p);for(let N=1;S&&N<=m.length;N++)for(let B=m.length-N;S&&B>=0;B--){S=!1;let X=m.slice(B,B+N).join(p);for(let V=0;!S&&V<l.length;V++)if(V!==v&&l[V]&&l[V].indexOf(X)>-1){const O=B+N===m.length,L=B>0&&l[V].indexOf(p)>-1?p+X:X,F=l[V].endsWith(L);S=!O||F}if(!S){let V="";(m[0].endsWith(":")||R!=="")&&(B===1&&(B=0,N++,X=m[0]+p+X),B>0&&(V=m[0]+p),V=R+V),B>0&&(V=V+h+p),V=V+X,B+N<m.length&&(V=V+p+h),C[v]=V}}S&&(C[v]=E)}return C}var f;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function t(l,p=Object.create(null)){const C=[];let S=!1,v="";for(const E of l)if(E==="$"||S&&E==="{")v&&C.push({value:v,type:f.TEXT}),v="",S=!0;else if(E==="}"&&S){const R=p[v];if(typeof R=="string")R.length&&C.push({value:R,type:f.VARIABLE});else if(R){const w=C[C.length-1];(!w||w.type!==f.SEPARATOR)&&C.push({value:R.label,type:f.SEPARATOR})}v="",S=!1}else v+=E;return v&&!S&&C.push({value:v,type:f.TEXT}),C.filter((E,R)=>{if(E.type===f.SEPARATOR){const w=C[R-1],m=C[R+1];return[w,m].every(N=>N&&(N.type===f.VARIABLE||N.type===f.TEXT)&&N.value.length>0)}return!0}).map(E=>E.value).join("")}function s(l,p){return T.$d||p?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$d?"&":"&&"):l.replace(/&&|&/g,C=>C==="&"?"&&":"&")}function n(l,p){return T.$d||p?l.replace(/\(&&\w\)|&&/g,""):T.$c?l.replace(/&&|&/g,C=>C==="&"?"&&":"&"):l.replace(/&&/g,"_")}function i(l){return l.replace(/&/g,"&&")}function g(l){if(l.endsWith("]")){const p=l.lastIndexOf(" [",l.length-2);if(p!==-1){const C=d(l.substring(0,p)),S=l.substring(p);return{name:C.name+S,parentPath:C.parentPath}}}return d(l)}function d(l){const p=l.indexOf("/")!==-1?I.$gc:I.$fc,C=p.basename(l),S=p.dirname(l);return C.length?{name:C,parentPath:S}:{name:S,parentPath:""}}}),define(Ce[147],Ie([1,0,23,36,2]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=e.$En=void 0,e.$Gn=$,e.$Hn=P,e.$In=y;function T(u){return u.toJSON()}class A{constructor(k){this.a=k}transformIncoming(k){const h=this.a.transformIncoming(k);return h===k?k:T(I.URI.from(h))}transformOutgoing(k){const h=this.a.transformOutgoing(k);return h===k?k:T(I.URI.from(h))}transformOutgoingURI(k){const h=this.a.transformOutgoing(k);return h===k?k:I.URI.from(h)}transformOutgoingScheme(k){return this.a.transformOutgoingScheme(k)}}e.$En=A,e.$Fn=new class{transformIncoming(u){return u}transformOutgoing(u){return u}transformOutgoingURI(u){return u}transformOutgoingScheme(u){return u}};function M(u,k,h){if(!u||h>200)return null;if(typeof u=="object"){if(u instanceof I.URI)return k.transformOutgoing(u);for(const r in u)if(Object.hasOwnProperty.call(u,r)){const o=M(u[r],k,h+1);o!==null&&(u[r]=o)}}return null}function $(u,k){const h=M(u,k,0);return h===null?u:h}function a(u,k,h,r){if(!u||r>200)return null;if(typeof u=="object"){if(u.$mid===D.MarshalledId.Uri)return h?I.URI.revive(k.transformIncoming(u)):k.transformIncoming(u);if(u instanceof b.$Je)return null;for(const o in u)if(Object.hasOwnProperty.call(u,o)){const c=a(u[o],k,h,r+1);c!==null&&(u[o]=c)}}return null}function P(u,k){const h=a(u,k,!1,0);return h===null?u:h}function y(u,k){const h=a(u,k,!0,0);return h===null?u:h}}),define(Ce[37],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=void 0,e.$Vg=D;const b=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(I){return b.test(I)}e.$Wg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(M){for(let $=0;$<M.length;$++)M[$]=Math.floor(Math.random()*256);return M};const T=new Uint8Array(16),A=[];for(let M=0;M<256;M++)A.push(M.toString(16).padStart(2,"0"));return function(){I(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let $=0,a="";return a+=A[T[$++]],a+=A[T[$++]],a+=A[T[$++]],a+=A[T[$++]],a+="-",a+=A[T[$++]],a+=A[T[$++]],a+="-",a+=A[T[$++]],a+=A[T[$++]],a+="-",a+=A[T[$++]],a+=A[T[$++]],a+="-",a+=A[T[$++]],a+=A[T[$++]],a+=A[T[$++]],a+=A[T[$++]],a+=A[T[$++]],a+=A[T[$++]],a}}()}),define(Ce[148],Ie([1,0,18,40,37]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$$s=void 0,e.$9s=T,e.$0s=A,e.$_s=a;function T(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,u,k){const h={id:(0,I.$Wg)(),name:y,uri:u,data:k};return{asString:async()=>"",asFile:()=>h,value:void 0}}class M{constructor(){this.a=new Map}get size(){let u=0;for(const k of this.a)u++;return u}has(u){return this.a.has(this.b(u))}matches(u){const k=[...this.a.keys()];return D.Iterable.some(this,([h,r])=>r.asFile())&&k.push("files"),P($(u),k)}get(u){return this.a.get(this.b(u))?.[0]}append(u,k){const h=this.a.get(u);h?h.push(k):this.a.set(this.b(u),[k])}replace(u,k){this.a.set(this.b(u),[k])}delete(u){this.a.delete(this.b(u))}*[Symbol.iterator](){for(const[u,k]of this.a)for(const h of k)yield[u,h]}b(u){return $(u)}}e.$$s=M;function $(y){return y.toLowerCase()}function a(y,u){return P($(y),u.map($))}function P(y,u){if(y==="*/*")return u.length>0;if(u.includes(y))return!0;const k=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!k)return!1;const[h,r,o]=k;return o==="*"?u.some(c=>c.startsWith(r+"/")):!1}e.$at=Object.freeze({create:y=>(0,b.$Mb)(y.map(u=>u.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$at.split(y).filter(u=>!u.startsWith("#"))})}),define(Ce[149],Ie([1,0,11,4,6,48,15]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=e.$6p=e.StorageState=e.StorageHint=void 0,e.$5p=$;var M;(function(u){u[u.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",u[u.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(M||(e.StorageHint=M={}));function $(u){const k=u;return k?.changed instanceof Map||k?.deleted instanceof Set}var a;(function(u){u[u.None=0]="None",u[u.Initialized=1]="Initialized",u[u.Closed=2]="Closed"})(a||(e.StorageState=a={}));class P extends I.$Uc{constructor(k,h=Object.create(null)){super(),this.r=k,this.s=h,this.b=this.B(new D.$ke),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new b.$yh(P.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(k=>this.u(k)))}u(k){this.b.pause();try{k.changed?.forEach((h,r)=>this.w(r,h)),k.deleted?.forEach(h=>this.w(h,void 0))}finally{this.b.resume()}}w(k,h){if(this.c===a.Closed)return;let r=!1;(0,A.$jg)(h)?r=this.f.delete(k):this.f.get(k)!==h&&(this.f.set(k,h),r=!0),r&&this.b.fire({key:k,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(k,h){const r=this.f.get(k);return(0,A.$jg)(r)?h:r}getBoolean(k,h){const r=this.get(k);return(0,A.$jg)(r)?h:r==="true"}getNumber(k,h){const r=this.get(k);return(0,A.$jg)(r)?h:parseInt(r,10)}getObject(k,h){const r=this.get(k);return(0,A.$jg)(r)?h:(0,T.$9h)(r)}async set(k,h,r=!1){if(this.c===a.Closed)return;if((0,A.$jg)(h))return this.delete(k,r);const o=(0,A.$cg)(h)||Array.isArray(h)?(0,T.$8h)(h):String(h);if(this.f.get(k)!==o)return this.f.set(k,o),this.j.set(k,o),this.h.delete(k),this.b.fire({key:k,external:r}),this.D()}async delete(k,h=!1){if(!(this.c===a.Closed||!this.f.delete(k)))return this.h.has(k)||this.h.add(k),this.j.delete(k),this.b.fire({key:k,external:h}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const k={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(k).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(k){if(!(this.c===a.Closed||this.m))return this.D(k)}async D(k){return this.s.hint===M.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),k)}async whenFlushed(){if(this.z)return new Promise(k=>this.n.push(k))}isInMemory(){return this.s.hint===M.STORAGE_IN_MEMORY}}e.$6p=P,P.a=100;class y{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(k){k.insert?.forEach((h,r)=>this.a.set(r,h)),k.delete?.forEach(h=>this.a.delete(h))}async optimize(){}async close(){}}e.$7p=y}),define(Ce[150],Ie([1,0,28]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$kv=I;var D;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function I(T){let A=0,M=0,$=0,a=D.Unknown;for(let P=0,y=T.length;P<y;P++){const u=T.charCodeAt(P);u===b.CharCode.CarriageReturn?(A===0&&(M=P),A++,P+1<y&&T.charCodeAt(P+1)===b.CharCode.LineFeed?(a|=D.CRLF,P++):a|=D.Invalid,$=P+1):u===b.CharCode.LineFeed&&(a|=D.LF,A===0&&(M=P),A++,$=P+1)}return A===0&&(M=T.length),[A,M,T.length-$,a]}}),define(Ce[151],Ie([1,0,13,21,23]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lt=void 0,e.$jt=P,e.$kt=y;let T;function A(){return T||(T=new TextDecoder("UTF-16LE")),T}let M;function $(){return M||(M=new TextDecoder("UTF-16BE")),M}let a;function P(){return a||(a=D.$x()?A():$()),a}function y(h,r,o){const c=new Uint16Array(h.buffer,r,o);return o>0&&(c[0]===65279||c[0]===65534)?u(h,r,o):A().decode(c)}function u(h,r,o){const c=[];let f=0;for(let t=0;t<o;t++){const s=I.$Le(h,r);r+=2,c[f++]=String.fromCharCode(s)}return c.join("")}class k{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return P().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const o=this.a-this.d;o<=1&&(o===0||b.$Ff(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const o=r.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=r;return}for(let c=0;c<o;c++)this.b[this.d++]=r.charCodeAt(c)}}e.$lt=k}),define(Ce[152],Ie([1,0,23,151]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=void 0,e.$nt=A;function I($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class T{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(a,P,y,u){this.oldPosition=a,this.oldText=P,this.newPosition=y,this.newText=u}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(a){return 4+2*a.length}static c(a,P,y){const u=P.length;b.$Oe(a,u,y),y+=4;for(let k=0;k<u;k++)b.$Me(a,P.charCodeAt(k),y),y+=2;return y}static d(a,P){const y=b.$Ne(a,P);return P+=4,(0,D.$kt)(a,P,y)}writeSize(){return 8+T.a(this.oldText)+T.a(this.newText)}write(a,P){return b.$Oe(a,this.oldPosition,P),P+=4,b.$Oe(a,this.newPosition,P),P+=4,P=T.c(a,this.oldText,P),P=T.c(a,this.newText,P),P}static read(a,P,y){const u=b.$Ne(a,P);P+=4;const k=b.$Ne(a,P);P+=4;const h=T.d(a,P);P+=T.a(h);const r=T.d(a,P);return P+=T.a(r),y.push(new T(u,h,k,r)),P}}e.$mt=T;function A($,a){return $===null||$.length===0?a:new M($,a).compress()}class M{constructor(a,P){this.a=a,this.c=P,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let a=0,P=0,y=this.n(a),u=this.l(P);for(;a<this.f||P<this.h;){if(y===null){this.k(u),u=this.l(++P);continue}if(u===null){this.m(y),y=this.n(++a);continue}if(u.oldEnd<=y.newPosition){this.k(u),u=this.l(++P);continue}if(y.newEnd<=u.oldPosition){this.m(y),y=this.n(++a);continue}if(u.oldPosition<y.newPosition){const[c,f]=M.r(u,y.newPosition-u.oldPosition);this.k(c),u=f;continue}if(y.newPosition<u.oldPosition){const[c,f]=M.q(y,u.oldPosition-y.newPosition);this.m(c),y=f;continue}let r,o;if(u.oldEnd===y.newEnd)r=y,o=u,y=this.n(++a),u=this.l(++P);else if(u.oldEnd<y.newEnd){const[c,f]=M.q(y,u.oldLength);r=c,o=u,y=f,u=this.l(++P)}else{const[c,f]=M.r(u,y.newLength);r=y,o=c,y=this.n(++a),u=f}this.d[this.e++]=new T(r.oldPosition,r.oldText,o.newPosition,o.newText),this.g+=r.newLength-r.oldLength,this.j+=o.newLength-o.oldLength}const k=M.s(this.d);return M.t(k)}k(a){this.d[this.e++]=M.o(this.g,a),this.j+=a.newLength-a.oldLength}l(a){return a<this.h?this.c[a]:null}m(a){this.d[this.e++]=M.p(this.j,a),this.g+=a.newLength-a.oldLength}n(a){return a<this.f?this.a[a]:null}static o(a,P){return new T(P.oldPosition-a,P.oldText,P.newPosition,P.newText)}static p(a,P){return new T(P.oldPosition,P.oldText,P.newPosition+a,P.newText)}static q(a,P){const y=a.newText.substr(0,P),u=a.newText.substr(P);return[new T(a.oldPosition,a.oldText,a.newPosition,y),new T(a.oldEnd,"",a.newPosition+P,u)]}static r(a,P){const y=a.oldText.substr(0,P),u=a.oldText.substr(P);return[new T(a.oldPosition,y,a.newPosition,a.newText),new T(a.oldPosition+P,u,a.newEnd,"")]}static s(a){if(a.length===0)return a;const P=[];let y=0,u=a[0];for(let k=1;k<a.length;k++){const h=a[k];u.oldEnd===h.oldPosition?u=new T(u.oldPosition,u.oldText+h.oldText,u.newPosition,u.newText+h.newText):(P[y++]=u,u=h)}return P[y++]=u,P}static t(a){if(a.length===0)return a;const P=[];let y=0;for(let u=0;u<a.length;u++){const k=a[u];k.oldText!==k.newText&&(P[y++]=k)}return P}}}),define(Ce[153],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ou=void 0,e.$ou={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[154],Ie([1,0,41,20]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ht=I,e.$it=T;function I(A,M,$,a,P,y){if(Array.isArray(A)){let u=0;for(const k of A){const h=I(k,M,$,a,P,y);if(h===10)return h;h>u&&(u=h)}return u}else{if(typeof A=="string")return a?A==="*"?5:A===$?10:0:0;if(A){const{language:u,pattern:k,scheme:h,hasAccessToAllModels:r,notebookType:o}=A;if(!a&&!r)return 0;o&&P&&(M=P);let c=0;if(h)if(h===M.scheme)c=10;else if(h==="*")c=5;else return 0;if(u)if(u===$)c=10;else if(u==="*")c=Math.max(c,5);else return 0;if(o)if(o===y)c=10;else if(o==="*"&&y!==void 0)c=Math.max(c,5);else return 0;if(k){let f;if(typeof k=="string"?f=k:f={...k,base:(0,D.$hc)(k.base)},f===M.fsPath||(0,b.$tk)(f,M.fsPath))c=10;else return 0}return c}else return 0}}function T(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(T):!!A.notebookType}}),define(Ce[155],Ie([1,0,28,156]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=e.$Dt=e.IndentAction=void 0;var I;(function($){$[$.None=0]="None",$[$.Indent=1]="Indent",$[$.IndentOutdent=2]="IndentOutdent",$[$.Outdent=3]="Outdent"})(I||(e.IndentAction=I={}));class T{constructor(a){if(this.e=null,this.f=!1,this.open=a.open,this.close=a.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(a.notIn))for(let P=0,y=a.notIn.length;P<y;P++)switch(a.notIn[P]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(a){switch(a){case D.StandardTokenType.Other:return!0;case D.StandardTokenType.Comment:return this.c;case D.StandardTokenType.String:return this.b;case D.StandardTokenType.RegEx:return this.d}}shouldAutoClose(a,P){if(a.getTokenCount()===0)return!0;const y=a.findTokenIndexAtOffset(P-2),u=a.getStandardTokenType(y);return this.isOK(u)}g(a,P){for(let y=a;y<=P;y++){const u=String.fromCharCode(y);if(!this.open.includes(u)&&!this.close.includes(u))return u}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(b.CharCode.Digit0,b.CharCode.Digit9)),this.e||(this.e=this.g(b.CharCode.a,b.CharCode.z)),this.e||(this.e=this.g(b.CharCode.A,b.CharCode.Z))),this.e}}e.$Dt=T;class A{constructor(a){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const P of a)M(this.autoClosingPairsOpenByStart,P.open.charAt(0),P),M(this.autoClosingPairsOpenByEnd,P.open.charAt(P.open.length-1),P),M(this.autoClosingPairsCloseByStart,P.close.charAt(0),P),M(this.autoClosingPairsCloseByEnd,P.close.charAt(P.close.length-1),P),P.close.length===1&&P.open.length===1&&M(this.autoClosingPairsCloseSingleChar,P.close,P)}}e.$Et=A;function M($,a,P){$.has(a)?$.get(a).push(P):$.set(a,[P])}}),define(Ce[157],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SC=e.NodeColor=e.$RC=void 0,e.$TC=I,e.$UC=T,e.$VC=a,e.$WC=P,e.$XC=y,e.$YC=u,e.$ZC=k,e.$1C=h;class b{constructor(o,c){this.piece=o,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$SC)return I(this.right);let o=this;for(;o.parent!==e.$SC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$SC?e.$SC:o.parent}prev(){if(this.left!==e.$SC)return T(this.left);let o=this;for(;o.parent!==e.$SC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$SC?e.$SC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$RC=b;var D;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(D||(e.NodeColor=D={})),e.$SC=new b(null,D.Black),e.$SC.parent=e.$SC,e.$SC.left=e.$SC,e.$SC.right=e.$SC,e.$SC.color=D.Black;function I(r){for(;r.left!==e.$SC;)r=r.left;return r}function T(r){for(;r.right!==e.$SC;)r=r.right;return r}function A(r){return r===e.$SC?0:r.size_left+r.piece.length+A(r.right)}function M(r){return r===e.$SC?0:r.lf_left+r.piece.lineFeedCnt+M(r.right)}function $(){e.$SC.parent=e.$SC}function a(r,o){const c=o.right;c.size_left+=o.size_left+(o.piece?o.piece.length:0),c.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=c.left,c.left!==e.$SC&&(c.left.parent=o),c.parent=o.parent,o.parent===e.$SC?r.root=c:o.parent.left===o?o.parent.left=c:o.parent.right=c,c.left=o,o.parent=c}function P(r,o){const c=o.left;o.left=c.right,c.right!==e.$SC&&(c.right.parent=o),c.parent=o.parent,o.size_left-=c.size_left+(c.piece?c.piece.length:0),o.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),o.parent===e.$SC?r.root=c:o===o.parent.right?o.parent.right=c:o.parent.left=c,c.right=o,o.parent=c}function y(r,o){let c,f;if(o.left===e.$SC?(f=o,c=f.right):o.right===e.$SC?(f=o,c=f.left):(f=I(o.right),c=f.right),f===r.root){r.root=c,c.color=D.Black,o.detach(),$(),r.root.parent=e.$SC;return}const t=f.color===D.Red;if(f===f.parent.left?f.parent.left=c:f.parent.right=c,f===o?(c.parent=f.parent,h(r,c)):(f.parent===o?c.parent=f:c.parent=f.parent,h(r,c),f.left=o.left,f.right=o.right,f.parent=o.parent,f.color=o.color,o===r.root?r.root=f:o===o.parent.left?o.parent.left=f:o.parent.right=f,f.left!==e.$SC&&(f.left.parent=f),f.right!==e.$SC&&(f.right.parent=f),f.size_left=o.size_left,f.lf_left=o.lf_left,h(r,f)),o.detach(),c.parent.left===c){const n=A(c),i=M(c);if(n!==c.parent.size_left||i!==c.parent.lf_left){const g=n-c.parent.size_left,d=i-c.parent.lf_left;c.parent.size_left=n,c.parent.lf_left=i,k(r,c.parent,g,d)}}if(h(r,c.parent),t){$();return}let s;for(;c!==r.root&&c.color===D.Black;)c===c.parent.left?(s=c.parent.right,s.color===D.Red&&(s.color=D.Black,c.parent.color=D.Red,a(r,c.parent),s=c.parent.right),s.left.color===D.Black&&s.right.color===D.Black?(s.color=D.Red,c=c.parent):(s.right.color===D.Black&&(s.left.color=D.Black,s.color=D.Red,P(r,s),s=c.parent.right),s.color=c.parent.color,c.parent.color=D.Black,s.right.color=D.Black,a(r,c.parent),c=r.root)):(s=c.parent.left,s.color===D.Red&&(s.color=D.Black,c.parent.color=D.Red,P(r,c.parent),s=c.parent.left),s.left.color===D.Black&&s.right.color===D.Black?(s.color=D.Red,c=c.parent):(s.left.color===D.Black&&(s.right.color=D.Black,s.color=D.Red,a(r,s),s=c.parent.left),s.color=c.parent.color,c.parent.color=D.Black,s.left.color=D.Black,P(r,c.parent),c=r.root));c.color=D.Black,$()}function u(r,o){for(h(r,o);o!==r.root&&o.parent.color===D.Red;)if(o.parent===o.parent.parent.left){const c=o.parent.parent.right;c.color===D.Red?(o.parent.color=D.Black,c.color=D.Black,o.parent.parent.color=D.Red,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,a(r,o)),o.parent.color=D.Black,o.parent.parent.color=D.Red,P(r,o.parent.parent))}else{const c=o.parent.parent.left;c.color===D.Red?(o.parent.color=D.Black,c.color=D.Black,o.parent.parent.color=D.Red,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,P(r,o)),o.parent.color=D.Black,o.parent.parent.color=D.Red,a(r,o.parent.parent))}r.root.color=D.Black}function k(r,o,c,f){for(;o!==r.root&&o!==e.$SC;)o.parent.left===o&&(o.parent.size_left+=c,o.parent.lf_left+=f),o=o.parent}function h(r,o){let c=0,f=0;if(o!==r.root){for(;o!==r.root&&o===o.parent.right;)o=o.parent;if(o!==r.root)for(o=o.parent,c=A(o.left)-o.size_left,f=M(o.left)-o.lf_left,o.size_left+=c,o.lf_left+=f;o!==r.root&&(c!==0||f!==0);)o.parent.left===o&&(o.parent.size_left+=c,o.parent.lf_left+=f),o=o.parent}}}),define(Ce[100],Ie([1,0,28,101,33,53,157,102]),function(_,e,b,D,I,T,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.$0C=void 0,e.$8C=y,e.$9C=u;const $=65535;function a(f){let t;return f[f.length-1]<65536?t=new Uint16Array(f.length):t=new Uint32Array(f.length),t.set(f,0),t}class P{constructor(t,s,n,i,g){this.lineStarts=t,this.cr=s,this.lf=n,this.crlf=i,this.isBasicASCII=g}}function y(f,t=!0){const s=[0];let n=1;for(let i=0,g=f.length;i<g;i++){const d=f.charCodeAt(i);d===b.CharCode.CarriageReturn?i+1<g&&f.charCodeAt(i+1)===b.CharCode.LineFeed?(s[n++]=i+2,i++):s[n++]=i+1:d===b.CharCode.LineFeed&&(s[n++]=i+1)}return t?a(s):s}function u(f,t){f.length=0,f[0]=0;let s=1,n=0,i=0,g=0,d=!0;for(let p=0,C=t.length;p<C;p++){const S=t.charCodeAt(p);S===b.CharCode.CarriageReturn?p+1<C&&t.charCodeAt(p+1)===b.CharCode.LineFeed?(g++,f[s++]=p+2,p++):(n++,f[s++]=p+1):S===b.CharCode.LineFeed?(i++,f[s++]=p+1):d&&S!==b.CharCode.Tab&&(S<32||S>126)&&(d=!1)}const l=new P(a(f),n,i,g,d);return f.length=0,l}class k{constructor(t,s,n,i,g){this.bufferIndex=t,this.start=s,this.end=n,this.lineFeedCnt=i,this.length=g}}e.$0C=k;class h{constructor(t,s){this.buffer=t,this.lineStarts=s}}e.$$C=h;class r{constructor(t,s){this.a=[],this.c=t,this.d=s,this.b=0,t.root!==A.$SC&&t.iterate(t.root,n=>(n!==A.$SC&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(t){this.a=t,this.b=[]}get(t){for(let s=this.b.length-1;s>=0;s--){const n=this.b[s];if(n.nodeStartOffset<=t&&n.nodeStartOffset+n.node.piece.length>=t)return n}return null}get2(t){for(let s=this.b.length-1;s>=0;s--){const n=this.b[s];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<t&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=t)return n}return null}set(t){this.b.length>=this.a&&this.b.shift(),this.b.push(t)}validate(t){let s=!1;const n=this.b;for(let i=0;i<n.length;i++){const g=n[i];if(g.node.parent===null||g.nodeStartOffset>=t){n[i]=null,s=!0;continue}}if(s){const i=[];for(const g of n)g!==null&&i.push(g);this.b=i}}}class c{constructor(t,s,n){this.create(t,s,n)}create(t,s,n){this.a=[new h("",[0])],this.g={line:0,column:0},this.root=A.$SC,this.b=1,this.c=0,this.d=s,this.e=s.length,this.f=n;let i=null;for(let g=0,d=t.length;g<d;g++)if(t[g].buffer.length>0){t[g].lineStarts||(t[g].lineStarts=y(t[g].buffer));const l=new k(g+1,{line:0,column:0},{line:t[g].lineStarts.length-1,column:t[g].buffer.length-t[g].lineStarts[t[g].lineStarts.length-1]},t[g].lineStarts.length-1,t[g].buffer.length);this.a.push(t[g]),i=this.S(i,l)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(t){const s=$,n=s-Math.floor(s/3),i=n*2;let g="",d=0;const l=[];if(this.iterate(this.root,p=>{const C=this.R(p),S=C.length;if(d<=n||d+S<i)return g+=C,d+=S,!0;const v=g.replace(/\r\n|\r|\n/g,t);return l.push(new h(v,y(v))),g=C,d=S,!0}),d>0){const p=g.replace(/\r\n|\r|\n/g,t);l.push(new h(p,y(p)))}this.create(l,t,!0)}getEOL(){return this.d}setEOL(t){this.d=t,this.e=this.d.length,this.normalizeEOL(t)}createSnapshot(t){return new r(this,t)}equal(t){if(this.getLength()!==t.getLength()||this.getLineCount()!==t.getLineCount())return!1;let s=0;return this.iterate(this.root,i=>{if(i===A.$SC)return!0;const g=this.R(i),d=g.length,l=t.G(s),p=t.G(s+d),C=t.getValueInRange2(l,p);return s+=d,g===C})}getOffsetAt(t,s){let n=0,i=this.root;for(;i!==A.$SC;)if(i.left!==A.$SC&&i.lf_left+1>=t)i=i.left;else if(i.lf_left+i.piece.lineFeedCnt+1>=t){n+=i.size_left;const g=this.B(i,t-i.lf_left-2);return n+=g+s-1}else t-=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;return n}getPositionAt(t){t=Math.floor(t),t=Math.max(0,t);let s=this.root,n=0;const i=t;for(;s!==A.$SC;)if(s.size_left!==0&&s.size_left>=t)s=s.left;else if(s.size_left+s.piece.length>=t){const g=this.A(s,t-s.size_left);if(n+=s.lf_left+g.index,g.index===0){const d=this.getOffsetAt(n+1,1),l=i-d;return new D.$ct(n+1,l+1)}return new D.$ct(n+1,g.remainder+1)}else if(t-=s.size_left+s.piece.length,n+=s.lf_left+s.piece.lineFeedCnt,s.right===A.$SC){const g=this.getOffsetAt(n+1,1),d=i-t-g;return new D.$ct(n+1,d+1)}else s=s.right;return new D.$ct(1,1)}getValueInRange(t,s){if(t.startLineNumber===t.endLineNumber&&t.startColumn===t.endColumn)return"";const n=this.H(t.startLineNumber,t.startColumn),i=this.H(t.endLineNumber,t.endColumn),g=this.getValueInRange2(n,i);return s?s!==this.d||!this.f?g.replace(/\r\n|\r|\n/g,s):s===this.getEOL()&&this.f?g:g.replace(/\r\n|\r|\n/g,s):g}getValueInRange2(t,s){if(t.node===s.node){const l=t.node,p=this.a[l.piece.bufferIndex].buffer,C=this.u(l.piece.bufferIndex,l.piece.start);return p.substring(C+t.remainder,C+s.remainder)}let n=t.node;const i=this.a[n.piece.bufferIndex].buffer,g=this.u(n.piece.bufferIndex,n.piece.start);let d=i.substring(g+t.remainder,g+n.piece.length);for(n=n.next();n!==A.$SC;){const l=this.a[n.piece.bufferIndex].buffer,p=this.u(n.piece.bufferIndex,n.piece.start);if(n===s.node){d+=l.substring(p,p+s.remainder);break}else d+=l.substr(p,n.piece.length);n=n.next()}return d}getLinesContent(){const t=[];let s=0,n="",i=!1;return this.iterate(this.root,g=>{if(g===A.$SC)return!0;const d=g.piece;let l=d.length;if(l===0)return!0;const p=this.a[d.bufferIndex].buffer,C=this.a[d.bufferIndex].lineStarts,S=d.start.line,v=d.end.line;let E=C[S]+d.start.column;if(i&&(p.charCodeAt(E)===b.CharCode.LineFeed&&(E++,l--),t[s++]=n,n="",i=!1,l===0))return!0;if(S===v)return!this.f&&p.charCodeAt(E+l-1)===b.CharCode.CarriageReturn?(i=!0,n+=p.substr(E,l-1)):n+=p.substr(E,l),!0;n+=this.f?p.substring(E,Math.max(E,C[S+1]-this.e)):p.substring(E,C[S+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=n;for(let R=S+1;R<v;R++)n=this.f?p.substring(C[R],C[R+1]-this.e):p.substring(C[R],C[R+1]).replace(/(\r\n|\r|\n)$/,""),t[s++]=n;return!this.f&&p.charCodeAt(C[v]+d.end.column-1)===b.CharCode.CarriageReturn?(i=!0,d.end.column===0?s--:n=p.substr(C[v],d.end.column-1)):n=p.substr(C[v],d.end.column),!0}),i&&(t[s++]=n,n=""),t[s++]=n,t}getLength(){return this.c}getLineCount(){return this.b}getLineContent(t){return this.j.lineNumber===t?this.j.value:(this.j.lineNumber=t,t===this.b?this.j.value=this.getLineRawContent(t):this.f?this.j.value=this.getLineRawContent(t,this.e):this.j.value=this.getLineRawContent(t).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(t){if(t.remainder===t.node.piece.length){const s=t.node.next();if(!s)return 0;const n=this.a[s.piece.bufferIndex],i=this.u(s.piece.bufferIndex,s.piece.start);return n.buffer.charCodeAt(i)}else{const s=this.a[t.node.piece.bufferIndex],i=this.u(t.node.piece.bufferIndex,t.node.piece.start)+t.remainder;return s.buffer.charCodeAt(i)}}getLineCharCode(t,s){const n=this.H(t,s+1);return this.l(n)}getLineLength(t){if(t===this.getLineCount()){const s=this.getOffsetAt(t,1);return this.getLength()-s}return this.getOffsetAt(t+1,1)-this.getOffsetAt(t,1)-this.e}getCharCode(t){const s=this.G(t);return this.l(s)}findMatchesInNode(t,s,n,i,g,d,l,p,C,S,v){const E=this.a[t.piece.bufferIndex],R=this.u(t.piece.bufferIndex,t.piece.start),w=this.u(t.piece.bufferIndex,g),m=this.u(t.piece.bufferIndex,d);let N;const B={line:0,column:0};let X,V;s._wordSeparators?(X=E.buffer.substring(w,m),V=O=>O+w,s.reset(0)):(X=E.buffer,V=O=>O,s.reset(w));do if(N=s.next(X),N){if(V(N.index)>=m)return S;this.s(t,V(N.index)-R,B);const O=this.t(t.piece.bufferIndex,g,B),L=B.line===g.line?B.column-g.column+i:B.column+1,F=L+N[0].length;if(v[S++]=(0,M.$4C)(new I.$dt(n+O,L,n+O,F),N,p),V(N.index)+N[0].length>=m||S>=C)return S}while(N);return S}findMatchesLineByLine(t,s,n,i){const g=[];let d=0;const l=new M.$7C(s.wordSeparators,s.regex);let p=this.H(t.startLineNumber,t.startColumn);if(p===null)return[];const C=this.H(t.endLineNumber,t.endColumn);if(C===null)return[];let S=this.s(p.node,p.remainder);const v=this.s(C.node,C.remainder);if(p.node===C.node)return this.findMatchesInNode(p.node,l,t.startLineNumber,t.startColumn,S,v,s,n,i,d,g),g;let E=t.startLineNumber,R=p.node;for(;R!==C.node;){const m=this.t(R.piece.bufferIndex,S,R.piece.end);if(m>=1){const B=this.a[R.piece.bufferIndex].lineStarts,X=this.u(R.piece.bufferIndex,R.piece.start),V=B[S.line+m],O=E===t.startLineNumber?t.startColumn:1;if(d=this.findMatchesInNode(R,l,E,O,S,this.s(R,V-X),s,n,i,d,g),d>=i)return g;E+=m}const N=E===t.startLineNumber?t.startColumn-1:0;if(E===t.endLineNumber){const B=this.getLineContent(E).substring(N,t.endColumn-1);return d=this.n(s,l,B,t.endLineNumber,N,d,g,n,i),g}if(d=this.n(s,l,this.getLineContent(E).substr(N),E,N,d,g,n,i),d>=i)return g;E++,p=this.H(E,1),R=p.node,S=this.s(p.node,p.remainder)}if(E===t.endLineNumber){const m=E===t.startLineNumber?t.startColumn-1:0,N=this.getLineContent(E).substring(m,t.endColumn-1);return d=this.n(s,l,N,t.endLineNumber,m,d,g,n,i),g}const w=E===t.startLineNumber?t.startColumn:1;return d=this.findMatchesInNode(C.node,l,E,w,S,v,s,n,i,d,g),g}n(t,s,n,i,g,d,l,p,C){const S=t.wordSeparators;if(!p&&t.simpleSearch){const E=t.simpleSearch,R=E.length,w=n.length;let m=-R;for(;(m=n.indexOf(E,m+R))!==-1;)if((!S||(0,M.$6C)(S,n,w,m,R))&&(l[d++]=new T.$sv(new I.$dt(i,m+1+g,i,m+1+R+g),null),d>=C))return d;return d}let v;s.reset(0);do if(v=s.next(n),v&&(l[d++]=(0,M.$4C)(new I.$dt(i,v.index+1+g,i,v.index+1+v[0].length+g),v,p),d>=C))return d;while(v);return d}insert(t,s,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==A.$SC){const{node:i,remainder:g,nodeStartOffset:d}=this.G(t),l=i.piece,p=l.bufferIndex,C=this.s(i,g);if(i.piece.bufferIndex===0&&l.end.line===this.g.line&&l.end.column===this.g.column&&d+l.length===t&&s.length<$){this.F(i,s),this.y();return}if(d===t)this.o(s,i),this.h.validate(t);else if(d+i.piece.length>t){const S=[];let v=new k(l.bufferIndex,C,l.end,this.t(l.bufferIndex,C,l.end),this.u(p,l.end)-this.u(p,C));if(this.K()&&this.M(s)&&this.I(i,g)===10){const m={line:v.start.line+1,column:0};v=new k(v.bufferIndex,m,v.end,this.t(v.bufferIndex,m,v.end),v.length-1),s+=`
`}if(this.K()&&this.L(s))if(this.I(i,g-1)===13){const m=this.s(i,g-1);this.C(i,m),s="\r"+s,i.piece.length===0&&S.push(i)}else this.C(i,C);else this.C(i,C);const E=this.w(s);v.length>0&&this.S(i,v);let R=i;for(let w=0;w<E.length;w++)R=this.S(R,E[w]);this.v(S)}else this.q(s,i)}else{const i=this.w(s);let g=this.T(null,i[0]);for(let d=1;d<i.length;d++)g=this.S(g,i[d])}this.y()}delete(t,s){if(this.j.lineNumber=0,this.j.value="",s<=0||this.root===A.$SC)return;const n=this.G(t),i=this.G(t+s),g=n.node,d=i.node;if(g===d){const E=this.s(g,n.remainder),R=this.s(g,i.remainder);if(n.nodeStartOffset===t){if(s===g.piece.length){const w=g.next();(0,A.$XC)(this,g),this.N(w),this.y();return}this.D(g,R),this.h.validate(t),this.N(g),this.y();return}if(n.nodeStartOffset+g.piece.length===t+s){this.C(g,E),this.O(g),this.y();return}this.E(g,E,R),this.y();return}const l=[],p=this.s(g,n.remainder);this.C(g,p),this.h.validate(t),g.piece.length===0&&l.push(g);const C=this.s(d,i.remainder);this.D(d,C),d.piece.length===0&&l.push(d);const S=g.next();for(let E=S;E!==A.$SC&&E!==d;E=E.next())l.push(E);const v=g.piece.length===0?g.prev():g;this.v(l),this.O(v),this.y()}o(t,s){const n=[];if(this.K()&&this.M(t)&&this.L(s)){const d=s.piece,l={line:d.start.line+1,column:0},p=new k(d.bufferIndex,l,d.end,this.t(d.bufferIndex,l,d.end),d.length-1);s.piece=p,t+=`
`,(0,A.$ZC)(this,s,-1,-1),s.piece.length===0&&n.push(s)}const i=this.w(t);let g=this.T(s,i[i.length-1]);for(let d=i.length-2;d>=0;d--)g=this.T(g,i[d]);this.N(g),this.v(n)}q(t,s){this.Q(t,s)&&(t+=`
`);const n=this.w(t),i=this.S(s,n[0]);let g=i;for(let d=1;d<n.length;d++)g=this.S(g,n[d]);this.N(i)}s(t,s,n){const i=t.piece,g=t.piece.bufferIndex,d=this.a[g].lineStarts,p=d[i.start.line]+i.start.column+s;let C=i.start.line,S=i.end.line,v=0,E=0,R=0;for(;C<=S&&(v=C+(S-C)/2|0,R=d[v],v!==S);)if(E=d[v+1],p<R)S=v-1;else if(p>=E)C=v+1;else break;return n?(n.line=v,n.column=p-R,null):{line:v,column:p-R}}t(t,s,n){if(n.column===0)return n.line-s.line;const i=this.a[t].lineStarts;if(n.line===i.length-1)return n.line-s.line;const g=i[n.line+1],d=i[n.line]+n.column;if(g>d+1)return n.line-s.line;const l=d-1;return this.a[t].buffer.charCodeAt(l)===13?n.line-s.line+1:n.line-s.line}u(t,s){return this.a[t].lineStarts[s.line]+s.column}v(t){for(let s=0;s<t.length;s++)(0,A.$XC)(this,t[s])}w(t){if(t.length>$){const S=[];for(;t.length>$;){const E=t.charCodeAt($-1);let R;E===b.CharCode.CarriageReturn||E>=55296&&E<=56319?(R=t.substring(0,$-1),t=t.substring($-1)):(R=t.substring(0,$),t=t.substring($));const w=y(R);S.push(new k(this.a.length,{line:0,column:0},{line:w.length-1,column:R.length-w[w.length-1]},w.length-1,R.length)),this.a.push(new h(R,w))}const v=y(t);return S.push(new k(this.a.length,{line:0,column:0},{line:v.length-1,column:t.length-v[v.length-1]},v.length-1,t.length)),this.a.push(new h(t,v)),S}let s=this.a[0].buffer.length;const n=y(t,!1);let i=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===s&&s!==0&&this.L(t)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},i=this.g;for(let S=0;S<n.length;S++)n[S]+=s+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+t,s+=1}else{if(s!==0)for(let S=0;S<n.length;S++)n[S]+=s;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=t}const g=this.a[0].buffer.length,d=this.a[0].lineStarts.length-1,l=g-this.a[0].lineStarts[d],p={line:d,column:l},C=new k(0,i,p,this.t(0,i,p),g-s);return this.g=p,[C]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(t,s=0){let n=this.root,i="";const g=this.h.get2(t);if(g){n=g.node;const d=this.B(n,t-g.nodeStartLineNumber-1),l=this.a[n.piece.bufferIndex].buffer,p=this.u(n.piece.bufferIndex,n.piece.start);if(g.nodeStartLineNumber+n.piece.lineFeedCnt===t)i=l.substring(p+d,p+n.piece.length);else{const C=this.B(n,t-g.nodeStartLineNumber);return l.substring(p+d,p+C-s)}}else{let d=0;const l=t;for(;n!==A.$SC;)if(n.left!==A.$SC&&n.lf_left>=t-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>t-1){const p=this.B(n,t-n.lf_left-2),C=this.B(n,t-n.lf_left-1),S=this.a[n.piece.bufferIndex].buffer,v=this.u(n.piece.bufferIndex,n.piece.start);return d+=n.size_left,this.h.set({node:n,nodeStartOffset:d,nodeStartLineNumber:l-(t-1-n.lf_left)}),S.substring(v+p,v+C-s)}else if(n.lf_left+n.piece.lineFeedCnt===t-1){const p=this.B(n,t-n.lf_left-2),C=this.a[n.piece.bufferIndex].buffer,S=this.u(n.piece.bufferIndex,n.piece.start);i=C.substring(S+p,S+n.piece.length);break}else t-=n.lf_left+n.piece.lineFeedCnt,d+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==A.$SC;){const d=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const l=this.B(n,0),p=this.u(n.piece.bufferIndex,n.piece.start);return i+=d.substring(p,p+l-s),i}else{const l=this.u(n.piece.bufferIndex,n.piece.start);i+=d.substr(l,n.piece.length)}n=n.next()}return i}y(){let t=this.root,s=1,n=0;for(;t!==A.$SC;)s+=t.lf_left+t.piece.lineFeedCnt,n+=t.size_left+t.piece.length,t=t.right;this.b=s,this.c=n,this.h.validate(this.c)}A(t,s){const n=t.piece,i=this.s(t,s),g=i.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===s){const d=this.t(t.piece.bufferIndex,n.start,i);if(d!==g)return{index:d,remainder:0}}return{index:g,remainder:i.column}}B(t,s){if(s<0)return 0;const n=t.piece,i=this.a[n.bufferIndex].lineStarts,g=n.start.line+s+1;return g>n.end.line?i[n.end.line]+n.end.column-i[n.start.line]-n.start.column:i[g]-i[n.start.line]-n.start.column}C(t,s){const n=t.piece,i=n.lineFeedCnt,g=this.u(n.bufferIndex,n.end),d=s,l=this.u(n.bufferIndex,d),p=this.t(n.bufferIndex,n.start,d),C=p-i,S=l-g,v=n.length+S;t.piece=new k(n.bufferIndex,n.start,d,p,v),(0,A.$ZC)(this,t,S,C)}D(t,s){const n=t.piece,i=n.lineFeedCnt,g=this.u(n.bufferIndex,n.start),d=s,l=this.t(n.bufferIndex,d,n.end),p=this.u(n.bufferIndex,d),C=l-i,S=g-p,v=n.length+S;t.piece=new k(n.bufferIndex,d,n.end,l,v),(0,A.$ZC)(this,t,S,C)}E(t,s,n){const i=t.piece,g=i.start,d=i.end,l=i.length,p=i.lineFeedCnt,C=s,S=this.t(i.bufferIndex,i.start,C),v=this.u(i.bufferIndex,s)-this.u(i.bufferIndex,g);t.piece=new k(i.bufferIndex,i.start,C,S,v),(0,A.$ZC)(this,t,v-l,S-p);const E=new k(i.bufferIndex,n,d,this.t(i.bufferIndex,n,d),this.u(i.bufferIndex,d)-this.u(i.bufferIndex,n)),R=this.S(t,E);this.N(R)}F(t,s){this.Q(s,t)&&(s+=`
`);const n=this.K()&&this.L(s)&&this.M(t),i=this.a[0].buffer.length;this.a[0].buffer+=s;const g=y(s,!1);for(let R=0;R<g.length;R++)g[R]+=i;if(n){const R=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:i-R}}this.a[0].lineStarts=this.a[0].lineStarts.concat(g.slice(1));const d=this.a[0].lineStarts.length-1,l=this.a[0].buffer.length-this.a[0].lineStarts[d],p={line:d,column:l},C=t.piece.length+s.length,S=t.piece.lineFeedCnt,v=this.t(0,t.piece.start,p),E=v-S;t.piece=new k(t.piece.bufferIndex,t.piece.start,p,v,C),this.g=p,(0,A.$ZC)(this,t,s.length,E)}G(t){let s=this.root;const n=this.h.get(t);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:t-n.nodeStartOffset};let i=0;for(;s!==A.$SC;)if(s.size_left>t)s=s.left;else if(s.size_left+s.piece.length>=t){i+=s.size_left;const g={node:s,remainder:t-s.size_left,nodeStartOffset:i};return this.h.set(g),g}else t-=s.size_left+s.piece.length,i+=s.size_left+s.piece.length,s=s.right;return null}H(t,s){let n=this.root,i=0;for(;n!==A.$SC;)if(n.left!==A.$SC&&n.lf_left>=t-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>t-1){const g=this.B(n,t-n.lf_left-2),d=this.B(n,t-n.lf_left-1);return i+=n.size_left,{node:n,remainder:Math.min(g+s-1,d),nodeStartOffset:i}}else if(n.lf_left+n.piece.lineFeedCnt===t-1){const g=this.B(n,t-n.lf_left-2);if(g+s-1<=n.piece.length)return{node:n,remainder:g+s-1,nodeStartOffset:i};s-=n.piece.length-g;break}else t-=n.lf_left+n.piece.lineFeedCnt,i+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==A.$SC;){if(n.piece.lineFeedCnt>0){const g=this.B(n,0),d=this.J(n);return{node:n,remainder:Math.min(s-1,g),nodeStartOffset:d}}else if(n.piece.length>=s-1){const g=this.J(n);return{node:n,remainder:s-1,nodeStartOffset:g}}else s-=n.piece.length;n=n.next()}return null}I(t,s){if(t.piece.lineFeedCnt<1)return-1;const n=this.a[t.piece.bufferIndex],i=this.u(t.piece.bufferIndex,t.piece.start)+s;return n.buffer.charCodeAt(i)}J(t){if(!t)return 0;let s=t.size_left;for(;t!==this.root;)t.parent.right===t&&(s+=t.parent.size_left+t.parent.piece.length),t=t.parent;return s}K(){return!(this.f&&this.d===`
`)}L(t){if(typeof t=="string")return t.charCodeAt(0)===10;if(t===A.$SC||t.piece.lineFeedCnt===0)return!1;const s=t.piece,n=this.a[s.bufferIndex].lineStarts,i=s.start.line,g=n[i]+s.start.column;return i===n.length-1||n[i+1]>g+1?!1:this.a[s.bufferIndex].buffer.charCodeAt(g)===10}M(t){return typeof t=="string"?t.charCodeAt(t.length-1)===13:t===A.$SC||t.piece.lineFeedCnt===0?!1:this.I(t,t.piece.length-1)===13}N(t){if(this.K()&&this.L(t)){const s=t.prev();this.M(s)&&this.P(s,t)}}O(t){if(this.K()&&this.M(t)){const s=t.next();this.L(s)&&this.P(t,s)}}P(t,s){const n=[],i=this.a[t.piece.bufferIndex].lineStarts;let g;t.piece.end.column===0?g={line:t.piece.end.line-1,column:i[t.piece.end.line]-i[t.piece.end.line-1]-1}:g={line:t.piece.end.line,column:t.piece.end.column-1};const d=t.piece.length-1,l=t.piece.lineFeedCnt-1;t.piece=new k(t.piece.bufferIndex,t.piece.start,g,l,d),(0,A.$ZC)(this,t,-1,-1),t.piece.length===0&&n.push(t);const p={line:s.piece.start.line+1,column:0},C=s.piece.length-1,S=this.t(s.piece.bufferIndex,p,s.piece.end);s.piece=new k(s.piece.bufferIndex,p,s.piece.end,S,C),(0,A.$ZC)(this,s,-1,-1),s.piece.length===0&&n.push(s);const v=this.w(`\r
`);this.S(t,v[0]);for(let E=0;E<n.length;E++)(0,A.$XC)(this,n[E])}Q(t,s){if(this.K()&&this.M(t)){const n=s.next();if(this.L(n)){if(t+=`
`,n.piece.length===1)(0,A.$XC)(this,n);else{const i=n.piece,g={line:i.start.line+1,column:0},d=i.length-1,l=this.t(i.bufferIndex,g,i.end);n.piece=new k(i.bufferIndex,g,i.end,l,d),(0,A.$ZC)(this,n,-1,-1)}return!0}}return!1}iterate(t,s){if(t===A.$SC)return s(A.$SC);const n=this.iterate(t.left,s);return n&&s(t)&&this.iterate(t.right,s)}R(t){if(t===A.$SC)return"";const s=this.a[t.piece.bufferIndex],n=t.piece,i=this.u(n.bufferIndex,n.start),g=this.u(n.bufferIndex,n.end);return s.buffer.substring(i,g)}getPieceContent(t){const s=this.a[t.bufferIndex],n=this.u(t.bufferIndex,t.start),i=this.u(t.bufferIndex,t.end);return s.buffer.substring(n,i)}S(t,s){const n=new A.$RC(s,A.NodeColor.Red);if(n.left=A.$SC,n.right=A.$SC,n.parent=A.$SC,n.size_left=0,n.lf_left=0,this.root===A.$SC)this.root=n,n.color=A.NodeColor.Black;else if(t.right===A.$SC)t.right=n,n.parent=t;else{const g=(0,A.$TC)(t.right);g.left=n,n.parent=g}return(0,A.$YC)(this,n),n}T(t,s){const n=new A.$RC(s,A.NodeColor.Red);if(n.left=A.$SC,n.right=A.$SC,n.parent=A.$SC,n.size_left=0,n.lf_left=0,this.root===A.$SC)this.root=n,n.color=A.NodeColor.Black;else if(t.left===A.$SC)t.left=n,n.parent=t;else{const i=(0,A.$UC)(t.left);i.right=n,n.parent=i}return(0,A.$YC)(this,n),n}U(t){let s="";return this.iterate(t,n=>(s+=this.R(n),!0)),s}}e.$_C=c}),define(Ce[158],Ie([1,0,4,13,33,53,100,150,152,6]),function(_,e,b,D,I,T,A,M,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=void 0;class P extends a.$Uc{constructor(u,k,h,r,o,c,f){super(),this.m=this.B(new b.$he),this.onDidChangeContent=this.m.event,this.f=k,this.j=!c,this.g=r,this.h=o,this.c=new A.$_C(u,h,f)}equals(u){return!(u instanceof P)||this.f!==u.f||this.getEOL()!==u.getEOL()?!1:this.c.equal(u.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(u){return this.c.createSnapshot(u?this.f:"")}getOffsetAt(u,k){return this.c.getOffsetAt(u,k)}getPositionAt(u){return this.c.getPositionAt(u)}getRangeAt(u,k){const h=u+k,r=this.getPositionAt(u),o=this.getPositionAt(h);return new I.$dt(r.lineNumber,r.column,o.lineNumber,o.column)}getValueInRange(u,k=T.EndOfLinePreference.TextDefined){if(u.isEmpty())return"";const h=this.n(k);return this.c.getValueInRange(u,h)}getValueLengthInRange(u,k=T.EndOfLinePreference.TextDefined){if(u.isEmpty())return 0;if(u.startLineNumber===u.endLineNumber)return u.endColumn-u.startColumn;const h=this.getOffsetAt(u.startLineNumber,u.startColumn),r=this.getOffsetAt(u.endLineNumber,u.endColumn);let o=0;const c=this.n(k),f=this.getEOL();if(c.length!==f.length){const t=c.length-f.length,s=u.endLineNumber-u.startLineNumber;o=t*s}return r-h+o}getCharacterCountInRange(u,k=T.EndOfLinePreference.TextDefined){if(this.j){let h=0;const r=u.startLineNumber,o=u.endLineNumber;for(let c=r;c<=o;c++){const f=this.getLineContent(c),t=c===r?u.startColumn-1:0,s=c===o?u.endColumn-1:f.length;for(let n=t;n<s;n++)D.$Ff(f.charCodeAt(n))?(h=h+1,n=n+1):h=h+1}return h+=this.n(k).length*(o-r),h}return this.getValueLengthInRange(u,k)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(u){return this.c.getLineContent(u)}getLineCharCode(u,k){return this.c.getLineCharCode(u,k)}getCharCode(u){return this.c.getCharCode(u)}getLineLength(u){return this.c.getLineLength(u)}getLineMinColumn(u){return 1}getLineMaxColumn(u){return this.getLineLength(u)+1}getLineFirstNonWhitespaceColumn(u){const k=D.$qf(this.getLineContent(u));return k===-1?0:k+1}getLineLastNonWhitespaceColumn(u){const k=D.$sf(this.getLineContent(u));return k===-1?0:k+2}n(u){switch(u){case T.EndOfLinePreference.LF:return`
`;case T.EndOfLinePreference.CRLF:return`\r
`;case T.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(u){this.c.setEOL(u)}applyEdits(u,k,h){let r=this.g,o=this.h,c=this.j,f=!0,t=[];for(let p=0;p<u.length;p++){const C=u[p];f&&C._isTracked&&(f=!1);const S=C.range;if(C.text){let m=!0;c||(m=!D.$Qf(C.text),c=m),!r&&m&&(r=D.$Pf(C.text)),!o&&m&&(o=D.$Sf(C.text))}let v="",E=0,R=0,w=0;if(C.text){let m;[E,R,w,m]=(0,M.$kv)(C.text);const N=this.getEOL(),B=N===`\r
`?M.StringEOL.CRLF:M.StringEOL.LF;m===M.StringEOL.Unknown||m===B?v=C.text:v=C.text.replace(/\r\n|\r|\n/g,N)}t[p]={sortIndex:p,identifier:C.identifier||null,range:S,rangeOffset:this.getOffsetAt(S.startLineNumber,S.startColumn),rangeLength:this.getValueLengthInRange(S),text:v,eolCount:E,firstLineLength:R,lastLineLength:w,forceMoveMarkers:!!C.forceMoveMarkers,isAutoWhitespaceEdit:C.isAutoWhitespaceEdit||!1}}t.sort(P.u);let s=!1;for(let p=0,C=t.length-1;p<C;p++){const S=t[p].range.getEndPosition(),v=t[p+1].range.getStartPosition();if(v.isBeforeOrEqual(S)){if(v.isBefore(S))throw new Error("Overlapping ranges are not allowed!");s=!0}}f&&(t=this.s(t));const n=h||k?P._getInverseEditRanges(t):[],i=[];if(k)for(let p=0;p<t.length;p++){const C=t[p],S=n[p];if(C.isAutoWhitespaceEdit&&C.range.isEmpty())for(let v=S.startLineNumber;v<=S.endLineNumber;v++){let E="";v===S.startLineNumber&&(E=this.getLineContent(C.range.startLineNumber),D.$qf(E)!==-1)||i.push({lineNumber:v,oldContent:E})}}let g=null;if(h){let p=0;g=[];for(let C=0;C<t.length;C++){const S=t[C],v=n[C],E=this.getValueInRange(S.range),R=S.rangeOffset+p;p+=S.text.length-E.length,g[C]={sortIndex:S.sortIndex,identifier:S.identifier,range:v,text:E,textChange:new $.$mt(S.rangeOffset,E,R,S.text)}}s||g.sort((C,S)=>C.sortIndex-S.sortIndex)}this.g=r,this.h=o,this.j=c;const d=this.t(t);let l=null;if(k&&i.length>0){i.sort((p,C)=>C.lineNumber-p.lineNumber),l=[];for(let p=0,C=i.length;p<C;p++){const S=i[p].lineNumber;if(p>0&&i[p-1].lineNumber===S)continue;const v=i[p].oldContent,E=this.getLineContent(S);E.length===0||E===v||D.$qf(E)!==-1||l.push(S)}}return this.m.fire(),new T.$wv(g,d,l)}s(u){return u.length<1e3?u:[this._toSingleEditOperation(u)]}_toSingleEditOperation(u){let k=!1;const h=u[0].range,r=u[u.length-1].range,o=new I.$dt(h.startLineNumber,h.startColumn,r.endLineNumber,r.endColumn);let c=h.startLineNumber,f=h.startColumn;const t=[];for(let d=0,l=u.length;d<l;d++){const p=u[d],C=p.range;k=k||p.forceMoveMarkers,t.push(this.getValueInRange(new I.$dt(c,f,C.startLineNumber,C.startColumn))),p.text.length>0&&t.push(p.text),c=C.endLineNumber,f=C.endColumn}const s=t.join(""),[n,i,g]=(0,M.$kv)(s);return{sortIndex:0,identifier:u[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,T.EndOfLinePreference.TextDefined),text:s,eolCount:n,firstLineLength:i,lastLineLength:g,forceMoveMarkers:k,isAutoWhitespaceEdit:!1}}t(u){u.sort(P.w);const k=[];for(let h=0;h<u.length;h++){const r=u[h],o=r.range.startLineNumber,c=r.range.startColumn,f=r.range.endLineNumber,t=r.range.endColumn;if(o===f&&c===t&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const s=new I.$dt(o,c,f,t);k.push({range:s,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return k}findMatchesLineByLine(u,k,h,r){return this.c.findMatchesLineByLine(u,k,h,r)}getPieceTree(){return this.c}static _getInverseEditRange(u,k){const h=u.startLineNumber,r=u.startColumn,[o,c,f]=(0,M.$kv)(k);let t;if(k.length>0){const s=o+1;s===1?t=new I.$dt(h,r,h,r+c):t=new I.$dt(h,r,h+s-1,f+1)}else t=new I.$dt(h,r,h,r);return t}static _getInverseEditRanges(u){const k=[];let h=0,r=0,o=null;for(let c=0,f=u.length;c<f;c++){const t=u[c];let s,n;o?o.range.endLineNumber===t.range.startLineNumber?(s=h,n=r+(t.range.startColumn-o.range.endColumn)):(s=h+(t.range.startLineNumber-o.range.endLineNumber),n=t.range.startColumn):(s=t.range.startLineNumber,n=t.range.startColumn);let i;if(t.text.length>0){const g=t.eolCount+1;g===1?i=new I.$dt(s,n,s,n+t.firstLineLength):i=new I.$dt(s,n,s+g-1,t.lastLineLength+1)}else i=new I.$dt(s,n,s,n);h=i.endLineNumber,r=i.endColumn,k.push(i),o=t}return k}static u(u,k){const h=I.$dt.compareRangesUsingEnds(u.range,k.range);return h===0?u.sortIndex-k.sortIndex:h}static w(u,k){const h=I.$dt.compareRangesUsingEnds(u.range,k.range);return h===0?k.sortIndex-u.sortIndex:-h}}e.$aD=P}),define(Ce[159],Ie([1,0,28,13,53,100,158]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bD=void 0;class M{constructor(P,y,u,k,h,r,o,c,f){this.a=P,this.b=y,this.c=u,this.d=k,this.e=h,this.f=r,this.g=o,this.h=c,this.j=f}k(P){const y=this.c+this.d+this.e,u=this.c+this.e;return y===0?P===I.DefaultEndOfLine.LF?`
`:`\r
`:u>y/2?`\r
`:`
`}create(P){const y=this.k(P),u=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let h=0,r=u.length;h<r;h++){const o=u[h].buffer.replace(/\r\n|\r|\n/g,y),c=(0,T.$8C)(o);u[h]=new T.$$C(o,c)}const k=new A.$aD(u,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(P){return this.a[0].buffer.substr(0,P).split(/\r\n|\r|\n/)[0]}}class ${constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(P){if(P.length===0)return;this.a.length===0&&D.$1f(P)&&(this.b=D.$Zf,P=P.substr(1));const y=P.charCodeAt(P.length-1);y===b.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(P.substr(0,P.length-1),!1),this.c=!0,this.d=y):(this.m(P,!1),this.c=!1,this.d=y)}m(P,y){!y&&P.length===0||(this.c?this.n(String.fromCharCode(this.d)+P):this.n(P))}n(P){const y=(0,T.$9C)(this.e,P);this.a.push(new T.$$C(P,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$Pf(P)),this.k||(this.k=D.$Sf(P)))}finish(P=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,P)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const P=this.a[this.a.length-1];P.buffer+=String.fromCharCode(this.d);const y=(0,T.$8C)(P.buffer);P.lineStarts=y,this.d===b.CharCode.CarriageReturn&&this.f++}}}e.$bD=$}),define(Ce[103],Ie([1,0,23,21]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$bb=$,e.$_bb=P;var I;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(I||(I={}));function T(y){for(let u=0,k=y.length;u<k;u+=4){const h=y[u+0],r=y[u+1],o=y[u+2],c=y[u+3];y[u+0]=c,y[u+1]=o,y[u+2]=r,y[u+3]=h}}function A(y){const u=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return D.$x()||T(u),b.$Je.wrap(u)}function M(y){const u=y.buffer;if(D.$x()||T(u),u.byteOffset%4===0)return new Uint32Array(u.buffer,u.byteOffset,u.length/4);{const k=new Uint8Array(u.byteLength);return k.set(u),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function $(y){const u=new Uint32Array(a(y));let k=0;if(u[k++]=y.id,y.type==="full")u[k++]=I.Full,u[k++]=y.data.length,u.set(y.data,k),k+=y.data.length;else{u[k++]=I.Delta,u[k++]=y.deltas.length;for(const h of y.deltas)u[k++]=h.start,u[k++]=h.deleteCount,h.data?(u[k++]=h.data.length,u.set(h.data,k),k+=h.data.length):u[k++]=0}return A(u)}function a(y){let u=0;if(u+=2,y.type==="full")u+=1+y.data.length;else{u+=1,u+=3*y.deltas.length;for(const k of y.deltas)k.data&&(u+=k.data.length)}return u}function P(y){const u=M(y);let k=0;const h=u[k++];if(u[k++]===I.Full){const f=u[k++],t=u.subarray(k,k+f);return k+=f,{id:h,type:"full",data:t}}const o=u[k++],c=[];for(let f=0;f<o;f++){const t=u[k++],s=u[k++],n=u[k++];let i;n>0&&(i=u.subarray(k,k+n),k+=n),c[f]={start:t,deleteCount:s,data:i}}return{id:h,type:"delta",deltas:c}}}),define(Ce[160],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$=e.$d$=void 0;class b{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const A=this.a.get(T);return this.a.delete(T),A}}addDragOperationTransfer(T,A){this.a.set(T,A)}}e.$d$=b;class D{constructor(T){this.identifier=T}}e.$e$=D}),define(Ce[161],Ie([8,9]),function(_,e){return _.create("vs/base/common/actions",e)}),define(Ce[162],Ie([1,0,4,6,161]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=void 0,e.$kj=P;class T extends D.$Uc{constructor(u,k="",h="",r=!0,o){super(),this.j=this.B(new b.$he),this.onDidChange=this.j.event,this.z=!0,this.m=u,this.n=k,this.w=h,this.z=r,this.D=o}get id(){return this.m}get label(){return this.n}set label(u){this.F(u)}F(u){this.n!==u&&(this.n=u,this.j.fire({label:u}))}get tooltip(){return this.u||""}set tooltip(u){this.G(u)}G(u){this.u!==u&&(this.u=u,this.j.fire({tooltip:u}))}get class(){return this.w}set class(u){this.H(u)}H(u){this.w!==u&&(this.w=u,this.j.fire({class:u}))}get enabled(){return this.z}set enabled(u){this.I(u)}I(u){this.z!==u&&(this.z=u,this.j.fire({enabled:u}))}get checked(){return this.C}set checked(u){this.J(u)}J(u){this.C!==u&&(this.C=u,this.j.fire({checked:u}))}async run(u,k){this.D&&await this.D(u)}}e.$fj=T;class A extends D.$Uc{constructor(){super(...arguments),this.f=this.B(new b.$he),this.onWillRun=this.f.event,this.m=this.B(new b.$he),this.onDidRun=this.m.event}async run(u,k){if(!u.enabled)return;this.f.fire({action:u});let h;try{await this.u(u,k)}catch(r){h=r}this.m.fire({action:u,error:h})}async u(u,k){await u.run(k)}}e.$gj=A;class M{constructor(){this.id=M.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...u){let k=[];for(const h of u)h.length&&(k.length?k=[...k,new M,...h]:k=h);return k}async run(){}}e.$hj=M,M.ID="vs.actions.separator";class ${get actions(){return this.a}constructor(u,k,h,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=u,this.label=k,this.class=r,this.a=h}async run(){}}e.$ij=$;class a extends T{constructor(){super(a.ID,I.localize(0,null),void 0,!1)}}e.$jj=a,a.ID="vs.actions.empty";function P(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...u)=>y.run(...u)}}}),define(Ce[163],Ie([8,9]),function(_,e){return _.create("vs/base/common/date",e)}),define(Ce[164],Ie([1,0,163]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=a,e.$9m=P,e.$0m=y;const D=60,I=D*60,T=I*24,A=T*7,M=T*30,$=T*365;function a(u,k,h,r){typeof u!="number"&&(u=u.getTime());const o=Math.round((new Date().getTime()-u)/1e3);if(o<-30)return(0,b.localize)(0,null,a(new Date().getTime()+o*1e3,!1));if(!r&&o<30)return(0,b.localize)(1,null);let c;return o<D?(c=o,k?c===1?h?(0,b.localize)(2,null,c):(0,b.localize)(3,null,c):h?(0,b.localize)(4,null,c):(0,b.localize)(5,null,c):c===1?h?(0,b.localize)(6,null,c):(0,b.localize)(7,null,c):h?(0,b.localize)(8,null,c):(0,b.localize)(9,null,c)):o<I?(c=Math.floor(o/D),k?c===1?h?(0,b.localize)(10,null,c):(0,b.localize)(11,null,c):h?(0,b.localize)(12,null,c):(0,b.localize)(13,null,c):c===1?h?(0,b.localize)(14,null,c):(0,b.localize)(15,null,c):h?(0,b.localize)(16,null,c):(0,b.localize)(17,null,c)):o<T?(c=Math.floor(o/I),k?c===1?h?(0,b.localize)(18,null,c):(0,b.localize)(19,null,c):h?(0,b.localize)(20,null,c):(0,b.localize)(21,null,c):c===1?h?(0,b.localize)(22,null,c):(0,b.localize)(23,null,c):h?(0,b.localize)(24,null,c):(0,b.localize)(25,null,c)):o<A?(c=Math.floor(o/T),k?c===1?(0,b.localize)(26,null,c):(0,b.localize)(27,null,c):c===1?(0,b.localize)(28,null,c):(0,b.localize)(29,null,c)):o<M?(c=Math.floor(o/A),k?c===1?h?(0,b.localize)(30,null,c):(0,b.localize)(31,null,c):h?(0,b.localize)(32,null,c):(0,b.localize)(33,null,c):c===1?h?(0,b.localize)(34,null,c):(0,b.localize)(35,null,c):h?(0,b.localize)(36,null,c):(0,b.localize)(37,null,c)):o<$?(c=Math.floor(o/M),k?c===1?h?(0,b.localize)(38,null,c):(0,b.localize)(39,null,c):h?(0,b.localize)(40,null,c):(0,b.localize)(41,null,c):c===1?h?(0,b.localize)(42,null,c):(0,b.localize)(43,null,c):h?(0,b.localize)(44,null,c):(0,b.localize)(45,null,c)):(c=Math.floor(o/$),k?c===1?h?(0,b.localize)(46,null,c):(0,b.localize)(47,null,c):h?(0,b.localize)(48,null,c):(0,b.localize)(49,null,c):c===1?h?(0,b.localize)(50,null,c):(0,b.localize)(51,null,c):h?(0,b.localize)(52,null,c):(0,b.localize)(53,null,c))}function P(u,k){const h=Math.abs(u/1e3);return h<1?k?(0,b.localize)(54,null,u):(0,b.localize)(55,null,u):h<D?k?(0,b.localize)(56,null,Math.round(u)/1e3):(0,b.localize)(57,null,Math.round(u)/1e3):h<I?k?(0,b.localize)(58,null,Math.round(u/(1e3*D))):(0,b.localize)(59,null,Math.round(u/(1e3*D))):h<T?k?(0,b.localize)(60,null,Math.round(u/(1e3*I))):(0,b.localize)(61,null,Math.round(u/(1e3*I))):(0,b.localize)(62,null,Math.round(u/(1e3*T)))}function y(u){return u.getFullYear()+"-"+String(u.getMonth()+1).padStart(2,"0")+"-"+String(u.getDate()).padStart(2,"0")+"T"+String(u.getHours()).padStart(2,"0")+":"+String(u.getMinutes()).padStart(2,"0")+":"+String(u.getSeconds()).padStart(2,"0")+"."+(u.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[165],Ie([8,9]),function(_,e){return _.create("vs/base/common/errorMessage",e)}),define(Ce[49],Ie([1,0,18,15,165]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lj=$,e.$mj=a,e.$nj=P;function T(y,u){return u&&(y.stack||y.stacktrace)?I.localize(0,null,M(y),A(y.stack)||A(y.stacktrace)):M(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function M(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?I.localize(1,null,y.message):y.message||I.localize(2,null)}function $(y=null,u=!1){if(!y)return I.localize(3,null);if(Array.isArray(y)){const k=b.$Hb(y),h=$(k[0],u);return k.length>1?I.localize(4,null,h,k.length):h}if(D.$ag(y))return y;if(y.detail){const k=y.detail;if(k.error)return T(k.error,u);if(k.exception)return T(k.exception,u)}return y.stack?T(y,u):y.message?y.message:I.localize(5,null)}function a(y){const u=y;return u instanceof Error&&Array.isArray(u.actions)}function P(y,u){let k;return typeof y=="string"?k=new Error(y):k=y,k.actions=u,k}}),define(Ce[166],Ie([8,9]),function(_,e){return _.create("vs/editor/common/config/editorOptions",e)}),define(Ce[167],Ie([8,9]),function(_,e){return _.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[168],Ie([8,9]),function(_,e){return _.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[169],Ie([8,9]),function(_,e){return _.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[170],Ie([8,9]),function(_,e){return _.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[171],Ie([8,9]),function(_,e){return _.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[172],Ie([8,9]),function(_,e){return _.create("vs/platform/files/common/files",e)}),define(Ce[173],Ie([8,9]),function(_,e){return _.create("vs/platform/log/common/log",e)}),define(Ce[174],Ie([8,9]),function(_,e){return _.create("vs/platform/markers/common/markers",e)}),define(Ce[175],Ie([8,9]),function(_,e){return _.create("vs/platform/request/common/request",e)}),define(Ce[176],Ie([8,9]),function(_,e){return _.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[177],Ie([8,9]),function(_,e){return _.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ce[178],Ie([8,9]),function(_,e){return _.create("vs/platform/workspace/common/workspace",e)}),define(Ce[179],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[180],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[181],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[182],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[183],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[184],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[185],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[186],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[187],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[188],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[189],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[190],Ie([8,9]),function(_,e){return _.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[191],Ie([8,9]),function(_,e){return _.create("vs/workbench/common/configuration",e)}),define(Ce[192],Ie([8,9]),function(_,e){return _.create("vs/workbench/common/editor",e)}),define(Ce[193],Ie([8,9]),function(_,e){return _.create("vs/workbench/common/views",e)}),define(Ce[194],Ie([8,9]),function(_,e){return _.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ce[195],Ie([8,9]),function(_,e){return _.create("vs/workbench/contrib/chat/common/languageModels",e)}),define(Ce[196],Ie([8,9]),function(_,e){return _.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[197],Ie([8,9]),function(_,e){return _.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[198],Ie([8,9]),function(_,e){return _.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[199],Ie([8,9]),function(_,e){return _.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[200],Ie([8,9]),function(_,e){return _.create("vs/workbench/contrib/testing/common/constants",e)}),define(Ce[201],Ie([8,9]),function(_,e){return _.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[202],Ie([8,9]),function(_,e){return _.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[203],Ie([8,9]),function(_,e){return _.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[204],Ie([8,9]),function(_,e){return _.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[205],Ie([1,0,28,14,169]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vj=e.TokenType=void 0;var T;(function(P){P[P.LParen=0]="LParen",P[P.RParen=1]="RParen",P[P.Neg=2]="Neg",P[P.Eq=3]="Eq",P[P.NotEq=4]="NotEq",P[P.Lt=5]="Lt",P[P.LtEq=6]="LtEq",P[P.Gt=7]="Gt",P[P.GtEq=8]="GtEq",P[P.RegexOp=9]="RegexOp",P[P.RegexStr=10]="RegexStr",P[P.True=11]="True",P[P.False=12]="False",P[P.In=13]="In",P[P.Not=14]="Not",P[P.And=15]="And",P[P.Or=16]="Or",P[P.Str=17]="Str",P[P.QuotedStr=18]="QuotedStr",P[P.Error=19]="Error",P[P.EOF=20]="EOF"})(T||(e.TokenType=T={}));function A(...P){switch(P.length){case 1:return(0,I.localize)(0,null,P[0]);case 2:return(0,I.localize)(1,null,P[0],P[1]);case 3:return(0,I.localize)(2,null,P[0],P[1],P[2]);default:return}}const M=(0,I.localize)(3,null),$=(0,I.localize)(4,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case T.LParen:return"(";case T.RParen:return")";case T.Neg:return"!";case T.Eq:return y.isTripleEq?"===":"==";case T.NotEq:return y.isTripleEq?"!==":"!=";case T.Lt:return"<";case T.LtEq:return"<=";case T.Gt:return">=";case T.GtEq:return">=";case T.RegexOp:return"=~";case T.RegexStr:return y.lexeme;case T.True:return"true";case T.False:return"false";case T.In:return"in";case T.Not:return"not";case T.And:return"&&";case T.Or:return"||";case T.Str:return y.lexeme;case T.QuotedStr:return y.lexeme;case T.Error:return y.lexeme;case T.EOF:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case b.CharCode.OpenParen:this.k(T.LParen);break;case b.CharCode.CloseParen:this.k(T.RParen);break;case b.CharCode.ExclamationMark:if(this.h(b.CharCode.Equals)){const u=this.h(b.CharCode.Equals);this.f.push({type:T.NotEq,offset:this.d,isTripleEq:u})}else this.k(T.Neg);break;case b.CharCode.SingleQuote:this.o();break;case b.CharCode.Slash:this.q();break;case b.CharCode.Equals:if(this.h(b.CharCode.Equals)){const u=this.h(b.CharCode.Equals);this.f.push({type:T.Eq,offset:this.d,isTripleEq:u})}else this.h(b.CharCode.Tilde)?this.k(T.RegexOp):this.l(A("==","=~"));break;case b.CharCode.LessThan:this.k(this.h(b.CharCode.Equals)?T.LtEq:T.Lt);break;case b.CharCode.GreaterThan:this.k(this.h(b.CharCode.Equals)?T.GtEq:T.Gt);break;case b.CharCode.Ampersand:this.h(b.CharCode.Ampersand)?this.k(T.And):this.l(A("&&"));break;case b.CharCode.Pipe:this.h(b.CharCode.Pipe)?this.k(T.Or):this.l(A("||"));break;case b.CharCode.Space:case b.CharCode.CarriageReturn:case b.CharCode.Tab:case b.CharCode.LineFeed:case b.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(T.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?b.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const u=this.d,k=this.c.substring(this.d,this.e),h={type:T.Error,offset:this.d,lexeme:k};this.g.push({offset:u,lexeme:k,additionalInfo:y}),this.f.push(h)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const u=this.c.substring(this.d,this.e),k=a.b.get(u);k?this.k(k):this.f.push({type:T.Str,lexeme:u,offset:this.d})}}o(){for(;this.j()!==b.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:T.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,u=!1,k=!1;for(;;){if(y>=this.c.length){this.e=y,this.l($);return}const r=this.c.charCodeAt(y);if(u)u=!1;else if(r===b.CharCode.Slash&&!k){y++;break}else r===b.CharCode.OpenSquareBracket?k=!0:r===b.CharCode.Backslash?u=!0:r===b.CharCode.CloseSquareBracket&&(k=!1);y++}for(;y<this.c.length&&a.a.has(this.c.charCodeAt(y));)y++;this.e=y;const h=this.c.substring(this.d,this.e);this.f.push({type:T.RegexStr,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$vj=a,a.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0))),a.b=new Map([["not",T.Not],["in",T.In],["false",T.False],["true",T.True]])}),define(Ce[206],Ie([1,0,24,35,171,321]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=$,e.$Qp=a,e.$Rp=P,e.$Sp=y,e.$Tp=u,e.$Up=k,e.$Vp=h;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,M=/^-(\d{4})(\d{2})(\d{2})$/;function $(c){return c=c.trim(),c==="*"||A.test(c)}function a(c){if(!$(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=c.match(A);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}function P(c){if(!c)return null;const f=c.majorBase,t=c.majorMustEqual,s=c.minorBase;let n=c.minorMustEqual;const i=c.patchBase;let g=c.patchMustEqual;c.hasCaret&&(f===0||(n=!1),g=!1);let d=0;if(c.preRelease){const l=M.exec(c.preRelease);if(l){const[,p,C,S]=l;d=Date.UTC(Number(p),Number(C)-1,Number(S))}}return{majorBase:f,majorMustEqual:t,minorBase:s,minorMustEqual:n,patchBase:i,patchMustEqual:g,isMinimum:c.hasGreaterEquals,notBefore:d}}function y(c,f,t){let s;typeof c=="string"?s=P(a(c)):s=c;let n;f instanceof Date?n=f.getTime():typeof f=="string"&&(n=new Date(f).getTime());let i;if(typeof t=="string"?i=P(a(t)):i=t,!s||!i)return!1;const g=s.majorBase,d=s.minorBase,l=s.patchBase;let p=i.majorBase,C=i.minorBase,S=i.patchBase;const v=i.notBefore;let E=i.majorMustEqual,R=i.minorMustEqual,w=i.patchMustEqual;return i.isMinimum?g>p?!0:g<p?!1:d>C?!0:d<C||n&&n<v?!1:l>=S:(g===1&&p===0&&(!E||!R||!w)&&(p=1,C=0,S=0,E=!0,R=!1,w=!1),g<p?!1:g>p?!E:d<C?!1:d>C?!R:l<S?!1:l>S?!w:!(n&&n<v))}function u(c,f,t,s,n){const i=[];if(typeof s.publisher<"u"&&typeof s.publisher!="string")return i.push([D.default.Error,I.localize(0,null)]),i;if(typeof s.name!="string")return i.push([D.default.Error,I.localize(1,null,"name")]),i;if(typeof s.version!="string")return i.push([D.default.Error,I.localize(2,null,"version")]),i;if(!s.engines)return i.push([D.default.Error,I.localize(3,null,"engines")]),i;if(typeof s.engines.vscode!="string")return i.push([D.default.Error,I.localize(4,null,"engines.vscode")]),i;if(typeof s.extensionDependencies<"u"&&!o(s.extensionDependencies))return i.push([D.default.Error,I.localize(5,null,"extensionDependencies")]),i;if(typeof s.activationEvents<"u"){if(!o(s.activationEvents))return i.push([D.default.Error,I.localize(6,null,"activationEvents")]),i;if(typeof s.main>"u"&&typeof s.browser>"u")return i.push([D.default.Error,I.localize(7,null,"activationEvents","main","browser")]),i}if(typeof s.extensionKind<"u"&&typeof s.main>"u"&&i.push([D.default.Warning,I.localize(8,null,"extensionKind")]),typeof s.main<"u"){if(typeof s.main!="string")return i.push([D.default.Error,I.localize(9,null,"main")]),i;{const l=(0,b.$bh)(t,s.main);(0,b.$8g)(l,t)||i.push([D.default.Warning,I.localize(10,null,l.path,t.path)])}}if(typeof s.browser<"u"){if(typeof s.browser!="string")return i.push([D.default.Error,I.localize(11,null,"browser")]),i;{const l=(0,b.$bh)(t,s.browser);(0,b.$8g)(l,t)||i.push([D.default.Warning,I.localize(12,null,l.path,t.path)])}}if(!T.valid(s.version))return i.push([D.default.Error,I.localize(13,null)]),i;const g=[];if(!k(c,f,s,n,g))for(const l of g)i.push([D.default.Error,l]);return i}function k(c,f,t,s,n){return s||typeof t.main>"u"&&typeof t.browser>"u"?!0:r(c,f,t.engines.vscode,n)}function h(c,f,t){return c==="*"||r(f,t,c)}function r(c,f,t,s=[]){const n=P(a(t));if(!n)return s.push(I.localize(14,null,t)),!1;if(n.majorBase===0){if(!n.majorMustEqual||!n.minorMustEqual)return s.push(I.localize(15,null,t)),!1}else if(!n.majorMustEqual)return s.push(I.localize(16,null,t)),!1;return y(c,f,n)?!0:(s.push(I.localize(17,null,c,t)),!1)}function o(c){if(!Array.isArray(c))return!1;for(let f=0,t=c.length;f<t;f++)if(typeof c[f]!="string")return!1;return!0}}),define(Ce[74],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=void 0;class b{constructor(I,T=[],A=!1){this.ctor=I,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.$xi=b}),define(Ce[60],Ie([1,0,74]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Gs=T,e.$Hs=A;const D=[];var I;(function(M){M[M.Eager=0]="Eager",M[M.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function T(M,$,a){$ instanceof b.$xi||($=new b.$xi($,[],!!a)),D.push([M,$])}function A(){return D}}),define(Ce[207],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=void 0;class b{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$jr=b;class D{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const A of this.a.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const M=this.lookupOrInsertNode(T),$=this.lookupOrInsertNode(A);M.outgoing.set($.key,$),$.incoming.set(M.key,M)}removeNode(T){const A=this.b(T);this.a.delete(A);for(const M of this.a.values())M.outgoing.delete(A),M.incoming.delete(A)}lookupOrInsertNode(T){const A=this.b(T);let M=this.a.get(A);return M||(M=new b(A,T),this.a.set(A,M)),M}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[A,M]of this.a)T.push(`${A}
	(-> incoming)[${[...M.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...M.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this.a){const M=new Set([T]),$=this.c(A,M);if($)return $}}c(T,A){for(const[M,$]of T.outgoing){if(A.has(M))return[...A,M].join(" -> ");A.add(M);const a=this.c($,A);if(a)return a;A.delete(M)}}}e.$kr=D}),define(Ce[3],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zi=e._util=void 0,e.$Ai=I,e.$Bi=T;var b;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function M($){return $[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=M})(b||(e._util=b={})),e.$zi=I("instantiationService");function D(A,M,$){M[b.DI_TARGET]===M?M[b.DI_DEPENDENCIES].push({id:A,index:$}):(M[b.DI_DEPENDENCIES]=[{id:A,index:$}],M[b.DI_TARGET]=M)}function I(A){if(b.serviceIds.has(A))return b.serviceIds.get(A);const M=function($,a,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(M,$,P)};return M.toString=()=>A,b.serviceIds.set(A,M),M}function T(A){return A}}),define(Ce[42],Ie([1,0,15,2,3]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$7i=void 0,e.$8i=T,e.$9i=A,e.$0i=$,e.$$i=a,e.$_i=P,e.$aj=y,e.$bj=u,e.$cj=h,e.$dj=r,e.$ej=o,e.$7i=(0,I.$Ai)("configurationService");function T(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}var M;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(M||(e.ConfigurationTarget=M={}));function $(c){switch(c){case M.APPLICATION:return"APPLICATION";case M.USER:return"USER";case M.USER_LOCAL:return"USER_LOCAL";case M.USER_REMOTE:return"USER_REMOTE";case M.WORKSPACE:return"WORKSPACE";case M.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case M.DEFAULT:return"DEFAULT";case M.MEMORY:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function P(c,f){const t=Object.create(null);for(const s in c)y(t,s,c[s],f);return t}function y(c,f,t,s){const n=f.split("."),i=n.pop();let g=c;for(let d=0;d<n.length;d++){const l=n[d];let p=g[l];switch(typeof p){case"undefined":p=g[l]=Object.create(null);break;case"object":if(p===null){s(`Ignoring ${f} as ${n.slice(0,d+1).join(".")} is null`);return}break;default:s(`Ignoring ${f} as ${n.slice(0,d+1).join(".")} is ${JSON.stringify(p)}`);return}g=p}if(typeof g=="object"&&g!==null)try{g[i]=t}catch{s(`Ignoring ${f} as ${n.join(".")} is ${JSON.stringify(g)}`)}else s(`Ignoring ${f} as ${n.join(".")} is ${JSON.stringify(g)}`)}function u(c,f){const t=f.split(".");k(c,t)}function k(c,f){const t=f.shift();if(f.length===0){delete c[t];return}if(Object.keys(c).indexOf(t)!==-1){const s=c[t];typeof s=="object"&&!Array.isArray(s)&&(k(s,f),Object.keys(s).length===0&&delete c[t])}}function h(c,f,t){function s(g,d){let l=g;for(const p of d){if(typeof l!="object"||l===null)return;l=l[p]}return l}const n=f.split("."),i=s(c,n);return typeof i>"u"?t:i}function r(c,f,t){Object.keys(f).forEach(s=>{s!=="__proto__"&&(s in c?b.$cg(c[s])&&b.$cg(f[s])?r(c[s],f[s],t):t&&(c[s]=f[s]):c[s]=f[s])})}function o(c){return c.replace(/[\[\]]/g,"")}}),define(Ce[32],Ie([1,0,28,21,13,205,3,168,14]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$yj=e.$xj=e.ContextKeyExprType=void 0,e.$wj=P,e.$zj=d,e.$Aj=l,e.$Tj=ee;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",D.$d),a.set("isLinux",D.$e),a.set("isWindows",D.$c),a.set("isWeb",D.$i),a.set("isMacNative",D.$d&&!D.$i),a.set("isEdge",D.$B),a.set("isFirefox",D.$z),a.set("isChrome",D.$y),a.set("isSafari",D.$A);function P(ce,H){if(a.get(ce)!==void 0)throw(0,$.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(ce,H)}const y=Object.prototype.hasOwnProperty;var u;(function(ce){ce[ce.False=0]="False",ce[ce.True=1]="True",ce[ce.Defined=2]="Defined",ce[ce.Not=3]="Not",ce[ce.Equals=4]="Equals",ce[ce.NotEquals=5]="NotEquals",ce[ce.And=6]="And",ce[ce.Regex=7]="Regex",ce[ce.NotRegex=8]="NotRegex",ce[ce.Or=9]="Or",ce[ce.In=10]="In",ce[ce.NotIn=11]="NotIn",ce[ce.Greater=12]="Greater",ce[ce.GreaterEquals=13]="GreaterEquals",ce[ce.Smaller=14]="Smaller",ce[ce.SmallerEquals=15]="SmallerEquals"})(u||(e.ContextKeyExprType=u={}));const k={regexParsingWithErrorRecovery:!0},h=(0,M.localize)(0,null),r=(0,M.localize)(1,null),o=(0,M.localize)(2,null),c=(0,M.localize)(3,null),f=(0,M.localize)(4,null),t=(0,M.localize)(5,null),s=(0,M.localize)(6,null),n=(0,M.localize)(7,null);class i{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(H=k){this.k=H,this.d=new T.$vj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(H){if(H===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(H).scan(),this.g=0,this.h=[];try{const he=this.l();if(!this.E()){const le=this.D(),re=le.type===T.TokenType.Str?t:void 0;throw this.h.push({message:f,offset:le.offset,lexeme:T.$vj.getLexeme(le),additionalInfo:re}),i.c}return he}catch(he){if(he!==i.c)throw he;return}}l(){return this.m()}m(){const H=[this.o()];for(;this.y(T.TokenType.Or);){const he=this.o();H.push(he)}return H.length===1?H[0]:g.or(...H)}o(){const H=[this.s()];for(;this.y(T.TokenType.And);){const he=this.s();H.push(he)}return H.length===1?H[0]:g.and(...H)}s(){if(this.y(T.TokenType.Neg)){const H=this.D();switch(H.type){case T.TokenType.True:return this.z(),C.INSTANCE;case T.TokenType.False:return this.z(),S.INSTANCE;case T.TokenType.LParen:{this.z();const he=this.l();return this.A(T.TokenType.RParen,c),he?.negate()}case T.TokenType.Str:return this.z(),N.create(H.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",H)}}return this.t()}t(){const H=this.D();switch(H.type){case T.TokenType.True:return this.z(),g.true();case T.TokenType.False:return this.z(),g.false();case T.TokenType.LParen:{this.z();const he=this.l();return this.A(T.TokenType.RParen,c),he}case T.TokenType.Str:{const he=H.lexeme;if(this.z(),this.y(T.TokenType.RegexOp)){const re=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),re.type!==T.TokenType.RegexStr)throw this.B("REGEX",re);const ue=re.lexeme,oe=ue.lastIndexOf("/"),J=oe===ue.length-1?void 0:this.w(ue.substring(oe+1));let Y;try{Y=new RegExp(ue.substring(1,oe),J)}catch{throw this.B("REGEX",re)}return F.create(he,Y)}switch(re.type){case T.TokenType.RegexStr:case T.TokenType.Error:{const ue=[re.lexeme];this.z();let oe=this.D(),J=0;for(let Ve=0;Ve<re.lexeme.length;Ve++)re.lexeme.charCodeAt(Ve)===b.CharCode.OpenParen?J++:re.lexeme.charCodeAt(Ve)===b.CharCode.CloseParen&&J--;for(;!this.E()&&oe.type!==T.TokenType.And&&oe.type!==T.TokenType.Or;){switch(oe.type){case T.TokenType.LParen:J++;break;case T.TokenType.RParen:J--;break;case T.TokenType.RegexStr:case T.TokenType.QuotedStr:for(let Ve=0;Ve<oe.lexeme.length;Ve++)oe.lexeme.charCodeAt(Ve)===b.CharCode.OpenParen?J++:re.lexeme.charCodeAt(Ve)===b.CharCode.CloseParen&&J--}if(J<0)break;ue.push(T.$vj.getLexeme(oe)),this.z(),oe=this.D()}const Y=ue.join(""),we=Y.lastIndexOf("/"),pe=we===Y.length-1?void 0:this.w(Y.substring(we+1));let Me;try{Me=new RegExp(Y.substring(1,we),pe)}catch{throw this.B("REGEX",re)}return g.regex(he,Me)}case T.TokenType.QuotedStr:{const ue=re.lexeme;this.z();let oe=null;if(!(0,I.$$e)(ue)){const J=ue.indexOf("/"),Y=ue.lastIndexOf("/");if(J!==Y&&J>=0){const we=ue.slice(J+1,Y),pe=ue[Y+1]==="i"?"i":"";try{oe=new RegExp(we,pe)}catch{throw this.B("REGEX",re)}}}if(oe===null)throw this.B("REGEX",re);return F.create(he,oe)}default:throw this.B("REGEX",this.D())}}if(this.y(T.TokenType.Not)){this.A(T.TokenType.In,o);const re=this.u();return g.notIn(he,re)}switch(this.D().type){case T.TokenType.Eq:{this.z();const re=this.u();if(this.x().type===T.TokenType.QuotedStr)return g.equals(he,re);switch(re){case"true":return g.has(he);case"false":return g.not(he);default:return g.equals(he,re)}}case T.TokenType.NotEq:{this.z();const re=this.u();if(this.x().type===T.TokenType.QuotedStr)return g.notEquals(he,re);switch(re){case"true":return g.not(he);case"false":return g.has(he);default:return g.notEquals(he,re)}}case T.TokenType.Lt:return this.z(),O.create(he,this.u());case T.TokenType.LtEq:return this.z(),L.create(he,this.u());case T.TokenType.Gt:return this.z(),X.create(he,this.u());case T.TokenType.GtEq:return this.z(),V.create(he,this.u());case T.TokenType.In:return this.z(),g.in(he,this.u());default:return g.has(he)}}case T.TokenType.EOF:throw this.h.push({message:s,offset:H.offset,lexeme:"",additionalInfo:n}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const H=this.D();switch(H.type){case T.TokenType.Str:case T.TokenType.QuotedStr:return this.z(),H.lexeme;case T.TokenType.True:return this.z(),"true";case T.TokenType.False:return this.z(),"false";case T.TokenType.In:return this.z(),"in";default:return""}}w(H){return H.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(H){return this.C(H)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(H,he){if(this.C(H))return this.z();throw this.B(he,this.D())}B(H,he,le){const re=(0,M.localize)(8,null,H,T.$vj.getLexeme(he)),ue=he.offset,oe=T.$vj.getLexeme(he);return this.h.push({message:re,offset:ue,lexeme:oe,additionalInfo:le}),i.c}C(H){return this.D().type===H}D(){return this.f[this.g]}E(){return this.D().type===T.TokenType.EOF}}e.$xj=i,i.c=new Error;class g{static false(){return C.INSTANCE}static true(){return S.INSTANCE}static has(H){return v.create(H)}static equals(H,he){return E.create(H,he)}static notEquals(H,he){return m.create(H,he)}static regex(H,he){return F.create(H,he)}static in(H,he){return R.create(H,he)}static notIn(H,he){return w.create(H,he)}static not(H){return N.create(H)}static and(...H){return be.create(H,null,!0)}static or(...H){return ve.create(H,null,!0)}static greater(H,he){return X.create(H,he)}static greaterEquals(H,he){return V.create(H,he)}static smaller(H,he){return O.create(H,he)}static smallerEquals(H,he){return L.create(H,he)}static deserialize(H){return H==null?void 0:this.c.parse(H)}}e.$yj=g,g.c=new i({regexParsingWithErrorRecovery:!1});function d(ce){const H=new i({regexParsingWithErrorRecovery:!1});return ce.map(he=>(H.parse(he),H.lexingErrors.length>0?H.lexingErrors.map(le=>({errorMessage:le.additionalInfo?(0,M.localize)(9,null,le.additionalInfo):(0,M.localize)(10,null),offset:le.offset,length:le.lexeme.length})):H.parsingErrors.length>0?H.parsingErrors.map(le=>({errorMessage:le.additionalInfo?`${le.message}. ${le.additionalInfo}`:le.message,offset:le.offset,length:le.lexeme.length})):[]))}function l(ce,H){const he=ce?ce.substituteConstants():void 0,le=H?H.substituteConstants():void 0;return!he&&!le?!0:!he||!le?!1:he.equals(le)}function p(ce,H){return ce.cmp(H)}class C{constructor(){this.type=u.False}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!1}serialize(){return"false"}keys(){return[]}map(H){return this}negate(){return S.INSTANCE}}e.$Bj=C,C.INSTANCE=new C;class S{constructor(){this.type=u.True}cmp(H){return this.type-H.type}equals(H){return H.type===this.type}substituteConstants(){return this}evaluate(H){return!0}serialize(){return"true"}keys(){return[]}map(H){return this}negate(){return C.INSTANCE}}e.$Cj=S,S.INSTANCE=new S;class v{static create(H,he=null){const le=a.get(H);return typeof le=="boolean"?le?S.INSTANCE:C.INSTANCE:new v(H,he)}constructor(H,he){this.key=H,this.c=he,this.type=u.Defined}cmp(H){return H.type!==this.type?this.type-H.type:ae(this.key,H.key)}equals(H){return H.type===this.type?this.key===H.key:!1}substituteConstants(){const H=a.get(this.key);return typeof H=="boolean"?H?S.INSTANCE:C.INSTANCE:this}evaluate(H){return!!H.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(H){return H.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$Dj=v;class E{static create(H,he,le=null){if(typeof he=="boolean")return he?v.create(H,le):N.create(H,le);const re=a.get(H);return typeof re=="boolean"?he===(re?"true":"false")?S.INSTANCE:C.INSTANCE:new E(H,he,le)}constructor(H,he,le){this.c=H,this.d=he,this.f=le,this.type=u.Equals}cmp(H){return H.type!==this.type?this.type-H.type:fe(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){const H=a.get(this.c);if(typeof H=="boolean"){const he=H?"true":"false";return this.d===he?S.INSTANCE:C.INSTANCE}return this}evaluate(H){return H.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(H){return H.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=m.create(this.c,this.d,this)),this.f}}e.$Ej=E;class R{static create(H,he){return new R(H,he)}constructor(H,he){this.d=H,this.f=he,this.type=u.In,this.c=null}cmp(H){return H.type!==this.type?this.type-H.type:fe(this.d,this.f,H.d,H.f)}equals(H){return H.type===this.type?this.d===H.d&&this.f===H.f:!1}substituteConstants(){return this}evaluate(H){const he=H.getValue(this.f),le=H.getValue(this.d);return Array.isArray(he)?he.includes(le):typeof le=="string"&&typeof he=="object"&&he!==null?y.call(he,le):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(H){return H.mapIn(this.d,this.f)}negate(){return this.c||(this.c=w.create(this.d,this.f)),this.c}}e.$Fj=R;class w{static create(H,he){return new w(H,he)}constructor(H,he){this.d=H,this.f=he,this.type=u.NotIn,this.c=R.create(H,he)}cmp(H){return H.type!==this.type?this.type-H.type:this.c.cmp(H.c)}equals(H){return H.type===this.type?this.c.equals(H.c):!1}substituteConstants(){return this}evaluate(H){return!this.c.evaluate(H)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(H){return H.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Gj=w;class m{static create(H,he,le=null){if(typeof he=="boolean")return he?N.create(H,le):v.create(H,le);const re=a.get(H);return typeof re=="boolean"?he===(re?"true":"false")?C.INSTANCE:S.INSTANCE:new m(H,he,le)}constructor(H,he,le){this.c=H,this.d=he,this.f=le,this.type=u.NotEquals}cmp(H){return H.type!==this.type?this.type-H.type:fe(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){const H=a.get(this.c);if(typeof H=="boolean"){const he=H?"true":"false";return this.d===he?C.INSTANCE:S.INSTANCE}return this}evaluate(H){return H.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(H){return H.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$Hj=m;class N{static create(H,he=null){const le=a.get(H);return typeof le=="boolean"?le?C.INSTANCE:S.INSTANCE:new N(H,he)}constructor(H,he){this.c=H,this.d=he,this.type=u.Not}cmp(H){return H.type!==this.type?this.type-H.type:ae(this.c,H.c)}equals(H){return H.type===this.type?this.c===H.c:!1}substituteConstants(){const H=a.get(this.c);return typeof H=="boolean"?H?C.INSTANCE:S.INSTANCE:this}evaluate(H){return!H.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(H){return H.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Ij=N;function B(ce,H){if(typeof ce=="string"){const he=parseFloat(ce);isNaN(he)||(ce=he)}return typeof ce=="string"||typeof ce=="number"?H(ce):C.INSTANCE}class X{static create(H,he,le=null){return B(he,re=>new X(H,re,le))}constructor(H,he,le){this.c=H,this.d=he,this.f=le,this.type=u.Greater}cmp(H){return H.type!==this.type?this.type-H.type:fe(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(H){return H.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Jj=X;class V{static create(H,he,le=null){return B(he,re=>new V(H,re,le))}constructor(H,he,le){this.c=H,this.d=he,this.f=le,this.type=u.GreaterEquals}cmp(H){return H.type!==this.type?this.type-H.type:fe(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(H){return H.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Kj=V;class O{static create(H,he,le=null){return B(he,re=>new O(H,re,le))}constructor(H,he,le){this.c=H,this.d=he,this.f=le,this.type=u.Smaller}cmp(H){return H.type!==this.type?this.type-H.type:fe(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(H){return H.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Lj=O;class L{static create(H,he,le=null){return B(he,re=>new L(H,re,le))}constructor(H,he,le){this.c=H,this.d=he,this.f=le,this.type=u.SmallerEquals}cmp(H){return H.type!==this.type?this.type-H.type:fe(this.c,this.d,H.c,H.d)}equals(H){return H.type===this.type?this.c===H.c&&this.d===H.d:!1}substituteConstants(){return this}evaluate(H){return typeof this.d=="string"?!1:parseFloat(H.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(H){return H.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=X.create(this.c,this.d,this)),this.f}}e.$Mj=L;class F{static create(H,he){return new F(H,he)}constructor(H,he){this.d=H,this.f=he,this.type=u.Regex,this.c=null}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.d<H.d)return-1;if(this.d>H.d)return 1;const he=this.f?this.f.source:"",le=H.f?H.f.source:"";return he<le?-1:he>le?1:0}equals(H){if(H.type===this.type){const he=this.f?this.f.source:"",le=H.f?H.f.source:"";return this.d===H.d&&he===le}return!1}substituteConstants(){return this}evaluate(H){const he=H.getValue(this.d);return this.f?this.f.test(he):!1}serialize(){const H=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${H}`}keys(){return[this.d]}map(H){return H.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ie.create(this)),this.c}}e.$Nj=F;class ie{static create(H){return new ie(H)}constructor(H){this.c=H,this.type=u.NotRegex}cmp(H){return H.type!==this.type?this.type-H.type:this.c.cmp(H.c)}equals(H){return H.type===this.type?this.c.equals(H.c):!1}substituteConstants(){return this}evaluate(H){return!this.c.evaluate(H)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(H){return new ie(this.c.map(H))}negate(){return this.c}}e.$Oj=ie;function de(ce){let H=null;for(let he=0,le=ce.length;he<le;he++){const re=ce[he].substituteConstants();if(ce[he]!==re&&H===null){H=[];for(let ue=0;ue<he;ue++)H[ue]=ce[ue]}H!==null&&(H[he]=re)}return H===null?ce:H}class be{static create(H,he,le){return be.d(H,he,le)}constructor(H,he){this.expr=H,this.c=he,this.type=u.And}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let he=0,le=this.expr.length;he<le;he++){const re=p(this.expr[he],H.expr[he]);if(re!==0)return re}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let he=0,le=this.expr.length;he<le;he++)if(!this.expr[he].equals(H.expr[he]))return!1;return!0}return!1}substituteConstants(){const H=de(this.expr);return H===this.expr?this:be.create(H,this.c,!1)}evaluate(H){for(let he=0,le=this.expr.length;he<le;he++)if(!this.expr[he].evaluate(H))return!1;return!0}static d(H,he,le){const re=[];let ue=!1;for(const oe of H)if(oe){if(oe.type===u.True){ue=!0;continue}if(oe.type===u.False)return C.INSTANCE;if(oe.type===u.And){re.push(...oe.expr);continue}re.push(oe)}if(re.length===0&&ue)return S.INSTANCE;if(re.length!==0){if(re.length===1)return re[0];re.sort(p);for(let oe=1;oe<re.length;oe++)re[oe-1].equals(re[oe])&&(re.splice(oe,1),oe--);if(re.length===1)return re[0];for(;re.length>1;){const oe=re[re.length-1];if(oe.type!==u.Or)break;re.pop();const J=re.pop(),Y=re.length===0,we=ve.create(oe.expr.map(pe=>be.create([pe,J],null,le)),null,Y);we&&(re.push(we),re.sort(p))}if(re.length===1)return re[0];if(le){for(let oe=0;oe<re.length;oe++)for(let J=oe+1;J<re.length;J++)if(re[oe].negate().equals(re[J]))return C.INSTANCE;if(re.length===1)return re[0]}return new be(re,he)}}serialize(){return this.expr.map(H=>H.serialize()).join(" && ")}keys(){const H=[];for(const he of this.expr)H.push(...he.keys());return H}map(H){return new be(this.expr.map(he=>he.map(H)),null)}negate(){if(!this.c){const H=[];for(const he of this.expr)H.push(he.negate());this.c=ve.create(H,this,!0)}return this.c}}e.$Pj=be;class ve{static create(H,he,le){return ve.d(H,he,le)}constructor(H,he){this.expr=H,this.c=he,this.type=u.Or}cmp(H){if(H.type!==this.type)return this.type-H.type;if(this.expr.length<H.expr.length)return-1;if(this.expr.length>H.expr.length)return 1;for(let he=0,le=this.expr.length;he<le;he++){const re=p(this.expr[he],H.expr[he]);if(re!==0)return re}return 0}equals(H){if(H.type===this.type){if(this.expr.length!==H.expr.length)return!1;for(let he=0,le=this.expr.length;he<le;he++)if(!this.expr[he].equals(H.expr[he]))return!1;return!0}return!1}substituteConstants(){const H=de(this.expr);return H===this.expr?this:ve.create(H,this.c,!1)}evaluate(H){for(let he=0,le=this.expr.length;he<le;he++)if(this.expr[he].evaluate(H))return!0;return!1}static d(H,he,le){let re=[],ue=!1;if(H){for(let oe=0,J=H.length;oe<J;oe++){const Y=H[oe];if(Y){if(Y.type===u.False){ue=!0;continue}if(Y.type===u.True)return S.INSTANCE;if(Y.type===u.Or){re=re.concat(Y.expr);continue}re.push(Y)}}if(re.length===0&&ue)return C.INSTANCE;re.sort(p)}if(re.length!==0){if(re.length===1)return re[0];for(let oe=1;oe<re.length;oe++)re[oe-1].equals(re[oe])&&(re.splice(oe,1),oe--);if(re.length===1)return re[0];if(le){for(let oe=0;oe<re.length;oe++)for(let J=oe+1;J<re.length;J++)if(re[oe].negate().equals(re[J]))return S.INSTANCE;if(re.length===1)return re[0]}return new ve(re,he)}}serialize(){return this.expr.map(H=>H.serialize()).join(" || ")}keys(){const H=[];for(const he of this.expr)H.push(...he.keys());return H}map(H){return new ve(this.expr.map(he=>he.map(H)),null)}negate(){if(!this.c){const H=[];for(const he of this.expr)H.push(he.negate());for(;H.length>1;){const he=H.shift(),le=H.shift(),re=[];for(const ue of Fe(he))for(const oe of Fe(le))re.push(be.create([ue,oe],null,!1));H.unshift(ve.create(re,null,!1))}this.c=ve.create(H,this,!0)}return this.c}}e.$Qj=ve;class Z extends v{static all(){return Z.d.values()}constructor(H,he,le){super(H,null),this.f=he,typeof le=="object"?Z.d.push({...le,key:H}):le!==!0&&Z.d.push({key:H,description:le,type:he!=null?typeof he:void 0})}bindTo(H){return H.createKey(this.key,this.f)}getValue(H){return H.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(H){return E.create(this.key,H)}notEqualsTo(H){return m.create(this.key,H)}}e.$Rj=Z,Z.d=[],e.$Sj=(0,A.$Ai)("contextKeyService");function ae(ce,H){return ce<H?-1:ce>H?1:0}function fe(ce,H,he,le){return ce<he?-1:ce>he?1:H<le?-1:H>le?1:0}function ee(ce,H){if(ce.type===u.False||H.type===u.True)return!0;if(ce.type===u.Or)return H.type===u.Or?De(ce.expr,H.expr):!1;if(H.type===u.Or){for(const he of H.expr)if(ee(ce,he))return!0;return!1}if(ce.type===u.And){if(H.type===u.And)return De(H.expr,ce.expr);for(const he of ce.expr)if(ee(he,H))return!0;return!1}return ce.equals(H)}function De(ce,H){let he=0,le=0;for(;he<ce.length&&le<H.length;){const re=ce[he].cmp(H[le]);if(re<0)return!1;re===0&&he++,le++}return he===ce.length}function Fe(ce){return ce.type===u.Or?ce.expr:[ce]}}),define(Ce[208],Ie([1,0,32,3]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=e.$qu=e.AccessibilitySupport=e.$pu=void 0,e.$ru=T,e.$pu=(0,D.$Ai)("accessibilityService");var I;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(I||(e.AccessibilitySupport=I={})),e.$qu=new b.$Rj("accessibilityModeEnabled",!1);function T(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$su="ACCESSIBLE_VIEW_SHOWN_"}),define(Ce[104],Ie([1,0,18,26,21,143,322,153,209,166,208]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=t,e.clampedInt=n,e.clampedFloat=g,e.stringSet=p,e.cursorStyleToString=B,e.filterValidationDecorations=Se;var y;(function(te){te[te.None=0]="None",te[te.Keep=1]="Keep",te[te.Brackets=2]="Brackets",te[te.Advanced=3]="Advanced",te[te.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class u{constructor(q){this.c=q}hasChanged(q){return this.c[q]}}e.ConfigurationChangedEvent=u;class k{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=k;class h{constructor(q,Ee,He,_e){this.id=q,this.name=Ee,this.defaultValue=He,this.schema=_e}applyUpdate(q,Ee){return o(q,Ee)}compute(q,Ee,He){return He}}class r{constructor(q,Ee){this.newValue=q,this.didChange=Ee}}e.ApplyUpdateResult=r;function o(te,q){if(typeof te!="object"||typeof q!="object"||!te||!q)return new r(q,te!==q);if(Array.isArray(te)||Array.isArray(q)){const He=Array.isArray(te)&&Array.isArray(q)&&b.$ub(te,q);return new r(q,!He)}let Ee=!1;for(const He in q)if(q.hasOwnProperty(He)){const _e=o(te[He],q[He]);_e.didChange&&(te[He]=_e.newValue,Ee=!0)}return new r(te,Ee)}class c{constructor(q){this.schema=void 0,this.id=q,this.name="_never_",this.defaultValue=void 0}applyUpdate(q,Ee){return o(q,Ee)}validate(q){return this.defaultValue}}class f{constructor(q,Ee,He,_e){this.id=q,this.name=Ee,this.defaultValue=He,this.schema=_e}applyUpdate(q,Ee){return o(q,Ee)}validate(q){return typeof q>"u"?this.defaultValue:q}compute(q,Ee,He){return He}}function t(te,q){return typeof te>"u"?q:te==="false"?!1:!!te}class s extends f{constructor(q,Ee,He,_e=void 0){typeof _e<"u"&&(_e.type="boolean",_e.default=He),super(q,Ee,He,_e)}validate(q){return t(q,this.defaultValue)}}function n(te,q,Ee,He){if(typeof te>"u")return q;let _e=parseInt(te,10);return isNaN(_e)?q:(_e=Math.max(Ee,_e),_e=Math.min(He,_e),_e|0)}class i extends f{static clampedInt(q,Ee,He,_e){return n(q,Ee,He,_e)}constructor(q,Ee,He,_e,lt,mt=void 0){typeof mt<"u"&&(mt.type="integer",mt.default=He,mt.minimum=_e,mt.maximum=lt),super(q,Ee,He,mt),this.minimum=_e,this.maximum=lt}validate(q){return i.clampedInt(q,this.defaultValue,this.minimum,this.maximum)}}function g(te,q,Ee,He){if(typeof te>"u")return q;const _e=d.float(te,q);return d.clamp(_e,Ee,He)}class d extends f{static clamp(q,Ee,He){return q<Ee?Ee:q>He?He:q}static float(q,Ee){if(typeof q=="number")return q;if(typeof q>"u")return Ee;const He=parseFloat(q);return isNaN(He)?Ee:He}constructor(q,Ee,He,_e,lt){typeof lt<"u"&&(lt.type="number",lt.default=He),super(q,Ee,He,lt),this.validationFn=_e}validate(q){return this.validationFn(d.float(q,this.defaultValue))}}class l extends f{static string(q,Ee){return typeof q!="string"?Ee:q}constructor(q,Ee,He,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.default=He),super(q,Ee,He,_e)}validate(q){return l.string(q,this.defaultValue)}}function p(te,q,Ee,He){return typeof te!="string"?q:He&&te in He?He[te]:Ee.indexOf(te)===-1?q:te}class C extends f{constructor(q,Ee,He,_e,lt=void 0){typeof lt<"u"&&(lt.type="string",lt.enum=_e,lt.default=He),super(q,Ee,He,lt),this.c=_e}validate(q){return p(q,this.defaultValue,this.c)}}class S extends h{constructor(q,Ee,He,_e,lt,mt,At=void 0){typeof At<"u"&&(At.type="string",At.enum=lt,At.default=_e),super(q,Ee,He,At),this.c=lt,this.d=mt}validate(q){return typeof q!="string"?this.defaultValue:this.c.indexOf(q)===-1?this.defaultValue:this.d(q)}}function v(te){switch(te){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class E extends h{constructor(){super(je.accessibilitySupport,"accessibilitySupport",P.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(q){switch(q){case"auto":return P.AccessibilitySupport.Unknown;case"off":return P.AccessibilitySupport.Disabled;case"on":return P.AccessibilitySupport.Enabled}return this.defaultValue}compute(q,Ee,He){return He===P.AccessibilitySupport.Unknown?q.accessibilitySupport:He}}class R extends h{constructor(){const q={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",q,{"editor.comments.insertSpace":{type:"boolean",default:q.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:q.ignoreEmptyLines,description:a.localize(5,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{insertSpace:t(Ee.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Ee.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var w;(function(te){te[te.Hidden=0]="Hidden",te[te.Blink=1]="Blink",te[te.Smooth=2]="Smooth",te[te.Phase=3]="Phase",te[te.Expand=4]="Expand",te[te.Solid=5]="Solid"})(w||(e.TextEditorCursorBlinkingStyle=w={}));function m(te){switch(te){case"blink":return w.Blink;case"smooth":return w.Smooth;case"phase":return w.Phase;case"expand":return w.Expand;case"solid":return w.Solid}}var N;(function(te){te[te.Line=1]="Line",te[te.Block=2]="Block",te[te.Underline=3]="Underline",te[te.LineThin=4]="LineThin",te[te.BlockOutline=5]="BlockOutline",te[te.UnderlineThin=6]="UnderlineThin"})(N||(e.TextEditorCursorStyle=N={}));function B(te){switch(te){case N.Line:return"line";case N.Block:return"block";case N.Underline:return"underline";case N.LineThin:return"line-thin";case N.BlockOutline:return"block-outline";case N.UnderlineThin:return"underline-thin"}}function X(te){switch(te){case"line":return N.Line;case"block":return N.Block;case"underline":return N.Underline;case"line-thin":return N.LineThin;case"block-outline":return N.BlockOutline;case"underline-thin":return N.UnderlineThin}}class V extends c{constructor(){super(je.editorClassName)}compute(q,Ee,He){const _e=["monaco-editor"];return Ee.get(je.extraEditorClassName)&&_e.push(Ee.get(je.extraEditorClassName)),q.extraEditorClassName&&_e.push(q.extraEditorClassName),Ee.get(je.mouseStyle)==="default"?_e.push("mouse-default"):Ee.get(je.mouseStyle)==="copy"&&_e.push("mouse-copy"),Ee.get(je.showUnused)&&_e.push("showUnused"),Ee.get(je.showDeprecated)&&_e.push("showDeprecated"),_e.join(" ")}}class O extends s{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(q,Ee,He){return He&&q.emptySelectionClipboard}}class L extends h{constructor(){const q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",q,{"editor.find.cursorMoveOnType":{type:"boolean",default:q.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:q.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:q.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:q.globalFindClipboard,description:a.localize(16,null),included:I.$d},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:q.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:q.loop,description:a.localize(18,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{cursorMoveOnType:t(Ee.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof q.seedSearchStringFromSelection=="boolean"?q.seedSearchStringFromSelection?"always":"never":p(Ee.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof q.autoFindInSelection=="boolean"?q.autoFindInSelection?"always":"never":p(Ee.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Ee.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Ee.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Ee.loop,this.defaultValue.loop)}}}class F extends h{constructor(){super(je.fontLigatures,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q==="false"||q.length===0?F.OFF:q==="true"?F.ON:q:q?F.ON:F.OFF}}e.EditorFontLigatures=F,F.OFF='"liga" off, "calt" off',F.ON='"liga" on, "calt" on';class ie extends h{constructor(){super(je.fontVariations,"fontVariations",ie.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(q){return typeof q>"u"?this.defaultValue:typeof q=="string"?q==="false"?ie.OFF:q==="true"?ie.TRANSLATE:q:q?ie.TRANSLATE:ie.OFF}compute(q,Ee,He){return q.fontInfo.fontVariationSettings}}e.EditorFontVariations=ie,ie.OFF="normal",ie.TRANSLATE="translate";class de extends c{constructor(){super(je.fontInfo)}compute(q,Ee,He){return q.fontInfo}}class be extends f{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(q){const Ee=d.float(q,this.defaultValue);return Ee===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(Ee,6,100)}compute(q,Ee,He){return q.fontInfo.fontSize}}class ve extends h{constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ve.d,maximum:ve.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ve.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(q){return q==="normal"||q==="bold"?q:String(i.clampedInt(q,e.EDITOR_FONT_DEFAULTS.fontWeight,ve.d,ve.e))}}ve.c=["normal","bold","100","200","300","400","500","600","700","800","900"],ve.d=1,ve.e=1e3;class Z extends h{constructor(){const q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ee={type:"string",enum:["peek","gotoAndPeek","goto"],default:q.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",q,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...Ee},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...Ee},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...Ee},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...Ee},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...Ee},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:q.alternativeDefinitionCommand,enum:He,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:q.alternativeTypeDefinitionCommand,enum:He,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:q.alternativeDeclarationCommand,enum:He,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:q.alternativeImplementationCommand,enum:He,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:q.alternativeReferenceCommand,enum:He,description:a.localize(41,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{multiple:p(Ee.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ee.multipleDefinitions??p(Ee.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ee.multipleTypeDefinitions??p(Ee.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ee.multipleDeclarations??p(Ee.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ee.multipleImplementations??p(Ee.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ee.multipleReferences??p(Ee.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:l.string(Ee.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:l.string(Ee.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:l.string(Ee.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:l.string(Ee.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:l.string(Ee.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ae extends h{constructor(){const q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",q,{"editor.hover.enabled":{type:"boolean",default:q.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:q.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:q.sticky,description:a.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:q.hidingDelay,description:a.localize(45,null)},"editor.hover.above":{type:"boolean",default:q.above,description:a.localize(46,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),delay:i.clampedInt(Ee.delay,this.defaultValue.delay,0,1e4),sticky:t(Ee.sticky,this.defaultValue.sticky),hidingDelay:i.clampedInt(Ee.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:t(Ee.above,this.defaultValue.above)}}}var fe;(function(te){te[te.None=0]="None",te[te.Text=1]="Text",te[te.Blocks=2]="Blocks"})(fe||(e.RenderMinimap=fe={}));class ee extends c{constructor(){super(je.layoutInfo)}compute(q,Ee,He){return ee.computeLayout(Ee,{memory:q.memory,outerWidth:q.outerWidth,outerHeight:q.outerHeight,isDominatedByLongLines:q.isDominatedByLongLines,lineHeight:q.fontInfo.lineHeight,viewLineCount:q.viewLineCount,lineNumbersDigitCount:q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:q.fontInfo.maxDigitWidth,pixelRatio:q.pixelRatio,glyphMarginDecorationLaneCount:q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(q){const Ee=q.height/q.lineHeight,He=Math.floor(q.paddingTop/q.lineHeight);let _e=Math.floor(q.paddingBottom/q.lineHeight);q.scrollBeyondLastLine&&(_e=Math.max(_e,Ee-1));const lt=(He+q.viewLineCount+_e)/(q.pixelRatio*q.height),mt=Math.floor(q.viewLineCount/lt);return{typicalViewportLineCount:Ee,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:_e,desiredRatio:lt,minimapLineCount:mt}}static c(q,Ee){const He=q.outerWidth,_e=q.outerHeight,lt=q.pixelRatio;if(!q.minimap.enabled)return{renderMinimap:fe.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(lt*_e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:_e};const mt=Ee.stableMinimapLayoutInput,At=mt&&q.outerHeight===mt.outerHeight&&q.lineHeight===mt.lineHeight&&q.typicalHalfwidthCharacterWidth===mt.typicalHalfwidthCharacterWidth&&q.pixelRatio===mt.pixelRatio&&q.scrollBeyondLastLine===mt.scrollBeyondLastLine&&q.paddingTop===mt.paddingTop&&q.paddingBottom===mt.paddingBottom&&q.minimap.enabled===mt.minimap.enabled&&q.minimap.side===mt.minimap.side&&q.minimap.size===mt.minimap.size&&q.minimap.showSlider===mt.minimap.showSlider&&q.minimap.renderCharacters===mt.minimap.renderCharacters&&q.minimap.maxColumn===mt.minimap.maxColumn&&q.minimap.scale===mt.minimap.scale&&q.verticalScrollbarWidth===mt.verticalScrollbarWidth&&q.isViewportWrapping===mt.isViewportWrapping,Jt=q.lineHeight,qt=q.typicalHalfwidthCharacterWidth,hi=q.scrollBeyondLastLine,ii=q.minimap.renderCharacters;let Ye=lt>=2?Math.round(q.minimap.scale*2):q.minimap.scale;const _t=q.minimap.maxColumn,Qt=q.minimap.size,pt=q.minimap.side,bt=q.verticalScrollbarWidth,Xt=q.viewLineCount,ei=q.remainingWidth,Wt=q.isViewportWrapping,wt=ii?2:3;let Tt=Math.floor(lt*_e);const jt=Tt/lt;let Lt=!1,Xe=!1,ti=wt*Ye,ni=Ye/lt,ci=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:oi,extraLinesBeforeFirstLine:Vt,extraLinesBeyondLastLine:zt,desiredRatio:ai,minimapLineCount:Pt}=ee.computeContainedMinimapLineCount({viewLineCount:Xt,scrollBeyondLastLine:hi,paddingTop:q.paddingTop,paddingBottom:q.paddingBottom,height:_e,lineHeight:Jt,pixelRatio:lt});if(Xt/Pt>1)Lt=!0,Xe=!0,Ye=1,ti=1,ni=Ye/lt;else{let yt=!1,Kt=Ye+1;if(Qt==="fit"){const Dt=Math.ceil((Vt+Xt+zt)*ti);Wt&&At&&ei<=Ee.stableFitRemainingWidth?(yt=!0,Kt=Ee.stableFitMaxMinimapScale):yt=Dt>Tt}if(Qt==="fill"||yt){Lt=!0;const Dt=Ye;ti=Math.min(Jt*lt,Math.max(1,Math.floor(1/ai))),Wt&&At&&ei<=Ee.stableFitRemainingWidth&&(Kt=Ee.stableFitMaxMinimapScale),Ye=Math.min(Kt,Math.max(1,Math.floor(ti/wt))),Ye>Dt&&(ci=Math.min(2,Ye/Dt)),ni=Ye/lt/ci,Tt=Math.ceil(Math.max(oi,Vt+Xt+zt)*ti),Wt?(Ee.stableMinimapLayoutInput=q,Ee.stableFitRemainingWidth=ei,Ee.stableFitMaxMinimapScale=Ye):(Ee.stableMinimapLayoutInput=null,Ee.stableFitRemainingWidth=0)}}}const Ct=Math.floor(_t*ni),Ft=Math.min(Ct,Math.max(0,Math.floor((ei-bt-2)*ni/(qt+ni)))+e.MINIMAP_GUTTER_WIDTH);let Ot=Math.floor(lt*Ft);const Gt=Ot/lt;Ot=Math.floor(Ot*ci);const li=ii?fe.Text:fe.Blocks,ri=pt==="left"?0:He-Ft-bt;return{renderMinimap:li,minimapLeft:ri,minimapWidth:Ft,minimapHeightIsEditorHeight:Lt,minimapIsSampling:Xe,minimapScale:Ye,minimapLineHeight:ti,minimapCanvasInnerWidth:Ot,minimapCanvasInnerHeight:Tt,minimapCanvasOuterWidth:Gt,minimapCanvasOuterHeight:jt}}static computeLayout(q,Ee){const He=Ee.outerWidth|0,_e=Ee.outerHeight|0,lt=Ee.lineHeight|0,mt=Ee.lineNumbersDigitCount|0,At=Ee.typicalHalfwidthCharacterWidth,Jt=Ee.maxDigitWidth,qt=Ee.pixelRatio,hi=Ee.viewLineCount,ii=q.get(je.wordWrapOverride2),Ye=ii==="inherit"?q.get(je.wordWrapOverride1):ii,_t=Ye==="inherit"?q.get(je.wordWrap):Ye,Qt=q.get(je.wordWrapColumn),pt=Ee.isDominatedByLongLines,bt=q.get(je.glyphMargin),Xt=q.get(je.lineNumbers).renderType!==Me.Off,ei=q.get(je.lineNumbersMinChars),Wt=q.get(je.scrollBeyondLastLine),wt=q.get(je.padding),Tt=q.get(je.minimap),jt=q.get(je.scrollbar),Lt=jt.verticalScrollbarSize,Xe=jt.verticalHasArrows,ti=jt.arrowSize,ni=jt.horizontalScrollbarSize,ci=q.get(je.folding),Ct=q.get(je.showFoldingControls)!=="never";let Ft=q.get(je.lineDecorationsWidth);ci&&Ct&&(Ft+=16);let Ot=0;if(Xt){const Ht=Math.max(mt,ei);Ot=Math.round(Ht*Jt)}let Gt=0;bt&&(Gt=lt*Ee.glyphMarginDecorationLaneCount);let li=0,ri=li+Gt,oi=ri+Ot,Vt=oi+Ft;const zt=He-Gt-Ot-Ft;let ai=!1,Pt=!1,Et=-1;Ye==="inherit"&&pt?(ai=!0,Pt=!0):_t==="on"||_t==="bounded"?Pt=!0:_t==="wordWrapColumn"&&(Et=Qt);const yt=ee.c({outerWidth:He,outerHeight:_e,lineHeight:lt,typicalHalfwidthCharacterWidth:At,pixelRatio:qt,scrollBeyondLastLine:Wt,paddingTop:wt.top,paddingBottom:wt.bottom,minimap:Tt,verticalScrollbarWidth:Lt,viewLineCount:hi,remainingWidth:zt,isViewportWrapping:Pt},Ee.memory||new k);yt.renderMinimap!==fe.None&&yt.minimapLeft===0&&(li+=yt.minimapWidth,ri+=yt.minimapWidth,oi+=yt.minimapWidth,Vt+=yt.minimapWidth);const Kt=zt-yt.minimapWidth,Dt=Math.max(1,Math.floor((Kt-Lt-2)/At)),Bt=Xe?ti:0;return Pt&&(Et=Math.max(1,Dt),_t==="bounded"&&(Et=Math.min(Et,Qt))),{width:He,height:_e,glyphMarginLeft:li,glyphMarginWidth:Gt,glyphMarginDecorationLaneCount:Ee.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:Ot,decorationsLeft:oi,decorationsWidth:Ft,contentLeft:Vt,contentWidth:Kt,minimap:yt,viewportColumn:Dt,isWordWrapMinified:ai,isViewportWrapping:Pt,wrappingColumn:Et,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:ni,overviewRuler:{top:Bt,width:Lt,height:_e-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=ee;class De extends h{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(47,null),a.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(49,null)}})}validate(q){return p(q,"simple",["simple","advanced"])}compute(q,Ee,He){return Ee.get(je.accessibilitySupport)===P.AccessibilitySupport.Enabled?"advanced":He}}var Fe;(function(te){te.Off="off",te.OnCode="onCode",te.On="on"})(Fe||(e.ShowLightbulbIconMode=Fe={}));class ce extends h{constructor(){const q={enabled:Fe.On};super(je.lightbulb,"lightbulb",q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Fe.Off,Fe.OnCode,Fe.On],default:q.enabled,enumDescriptions:[a.localize(50,null),a.localize(51,null),a.localize(52,null)],description:a.localize(53,null)}})}validate(q){return!q||typeof q!="object"?this.defaultValue:{enabled:p(q.enabled,this.defaultValue.enabled,[Fe.Off,Fe.OnCode,Fe.On])}}}class H extends h{constructor(){const q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",q,{"editor.stickyScroll.enabled":{type:"boolean",default:q.enabled,description:a.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:q.maxLineCount,minimum:1,maximum:20,description:a.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:q.defaultModel,description:a.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:q.scrollWithEditor,description:a.localize(57,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),maxLineCount:i.clampedInt(Ee.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:p(Ee.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:t(Ee.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class he extends h{constructor(){const q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",q,{"editor.inlayHints.enabled":{type:"string",default:q.enabled,description:a.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(59,null),a.localize(60,null,I.$d?"Ctrl+Option":"Ctrl+Alt"),a.localize(61,null,I.$d?"Ctrl+Option":"Ctrl+Alt"),a.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:q.fontSize,markdownDescription:a.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:q.fontFamily,markdownDescription:a.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:q.padding,description:a.localize(65,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return typeof Ee.enabled=="boolean"&&(Ee.enabled=Ee.enabled?"on":"off"),{enabled:p(Ee.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:i.clampedInt(Ee.fontSize,this.defaultValue.fontSize,0,100),fontFamily:l.string(Ee.fontFamily,this.defaultValue.fontFamily),padding:t(Ee.padding,this.defaultValue.padding)}}}class le extends h{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(q){return typeof q=="string"&&/^\d+(\.\d+)?ch$/.test(q)?-parseFloat(q.substring(0,q.length-2)):i.clampedInt(q,this.defaultValue,0,1e3)}compute(q,Ee,He){return He<0?i.clampedInt(-He*q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class re extends d{constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,q=>d.clamp(q,0,150),{markdownDescription:a.localize(66,null)})}compute(q,Ee,He){return q.fontInfo.lineHeight}}class ue extends h{constructor(){const q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",q,{"editor.minimap.enabled":{type:"boolean",default:q.enabled,description:a.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:q.autohide,description:a.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(69,null),a.localize(70,null),a.localize(71,null)],default:q.size,description:a.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:q.side,description:a.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:q.showSlider,description:a.localize(74,null)},"editor.minimap.scale":{type:"number",default:q.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:q.renderCharacters,description:a.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:q.maxColumn,description:a.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:q.showRegionSectionHeaders,description:a.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:q.showMarkSectionHeaders,description:a.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:q.sectionHeaderFontSize,description:a.localize(80,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:q.sectionHeaderLetterSpacing,description:a.localize(81,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),autohide:t(Ee.autohide,this.defaultValue.autohide),size:p(Ee.size,this.defaultValue.size,["proportional","fill","fit"]),side:p(Ee.side,this.defaultValue.side,["right","left"]),showSlider:p(Ee.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Ee.renderCharacters,this.defaultValue.renderCharacters),scale:i.clampedInt(Ee.scale,1,1,3),maxColumn:i.clampedInt(Ee.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:t(Ee.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:t(Ee.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:d.clamp(Ee.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:d.clamp(Ee.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function oe(te){return te==="ctrlCmd"?I.$d?"metaKey":"ctrlKey":"altKey"}class J extends h{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(82,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(83,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{top:i.clampedInt(Ee.top,0,0,1e3),bottom:i.clampedInt(Ee.bottom,0,0,1e3)}}}class Y extends h{constructor(){const q={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",q,{"editor.parameterHints.enabled":{type:"boolean",default:q.enabled,description:a.localize(84,null)},"editor.parameterHints.cycle":{type:"boolean",default:q.cycle,description:a.localize(85,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),cycle:t(Ee.cycle,this.defaultValue.cycle)}}}class we extends c{constructor(){super(je.pixelRatio)}compute(q,Ee,He){return q.pixelRatio}}class pe extends h{constructor(){const q={other:"on",comments:"off",strings:"off"},Ee=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(86,null),a.localize(87,null),a.localize(88,null)]}];super(je.quickSuggestions,"quickSuggestions",q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ee,default:q.strings,description:a.localize(89,null)},comments:{anyOf:Ee,default:q.comments,description:a.localize(90,null)},other:{anyOf:Ee,default:q.other,description:a.localize(91,null)}},default:q,markdownDescription:a.localize(92,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=q}validate(q){if(typeof q=="boolean"){const qt=q?"on":"off";return{comments:qt,strings:qt,other:qt}}if(!q||typeof q!="object")return this.defaultValue;const{other:Ee,comments:He,strings:_e}=q,lt=["on","inline","off"];let mt,At,Jt;return typeof Ee=="boolean"?mt=Ee?"on":"off":mt=p(Ee,this.defaultValue.other,lt),typeof He=="boolean"?At=He?"on":"off":At=p(He,this.defaultValue.comments,lt),typeof _e=="boolean"?Jt=_e?"on":"off":Jt=p(_e,this.defaultValue.strings,lt),{other:mt,comments:At,strings:Jt}}}var Me;(function(te){te[te.Off=0]="Off",te[te.On=1]="On",te[te.Relative=2]="Relative",te[te.Interval=3]="Interval",te[te.Custom=4]="Custom"})(Me||(e.RenderLineNumbersType=Me={}));class Ve extends h{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:Me.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(93,null),a.localize(94,null),a.localize(95,null),a.localize(96,null)],default:"on",description:a.localize(97,null)})}validate(q){let Ee=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof q<"u"&&(typeof q=="function"?(Ee=Me.Custom,He=q):q==="interval"?Ee=Me.Interval:q==="relative"?Ee=Me.Relative:q==="on"?Ee=Me.On:Ee=Me.Off),{renderType:Ee,renderFn:He}}}function Se(te){const q=te.get(je.renderValidationDecorations);return q==="editable"?te.get(je.readOnly):q!=="on"}class Pe extends h{constructor(){const q=[],Ee={type:"number",description:a.localize(98,null)};super(je.rulers,"rulers",q,{type:"array",items:{anyOf:[Ee,{type:["object"],properties:{column:Ee,color:{type:"string",description:a.localize(99,null),format:"color-hex"}}}]},default:q,description:a.localize(100,null)})}validate(q){if(Array.isArray(q)){const Ee=[];for(const He of q)if(typeof He=="number")Ee.push({column:i.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const _e=He;Ee.push({column:i.clampedInt(_e.column,0,0,1e4),color:_e.color})}return Ee.sort((He,_e)=>He.column-_e.column),Ee}return this.defaultValue}}class Te extends h{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(q){return!q||typeof q!="object"?this.defaultValue:q}}function U(te,q){if(typeof te!="string")return q;switch(te){case"hidden":return T.ScrollbarVisibility.Hidden;case"visible":return T.ScrollbarVisibility.Visible;default:return T.ScrollbarVisibility.Auto}}class W extends h{constructor(){const q={vertical:T.ScrollbarVisibility.Auto,horizontal:T.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(101,null),a.localize(102,null),a.localize(103,null)],default:"auto",description:a.localize(104,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(105,null),a.localize(106,null),a.localize(107,null)],default:"auto",description:a.localize(108,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:q.verticalScrollbarSize,description:a.localize(109,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:q.horizontalScrollbarSize,description:a.localize(110,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:q.scrollByPage,description:a.localize(111,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:q.ignoreHorizontalScrollbarInContentHeight,description:a.localize(112,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q,He=i.clampedInt(Ee.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),_e=i.clampedInt(Ee.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:i.clampedInt(Ee.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:U(Ee.vertical,this.defaultValue.vertical),horizontal:U(Ee.horizontal,this.defaultValue.horizontal),useShadows:t(Ee.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Ee.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Ee.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Ee.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Ee.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:i.clampedInt(Ee.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:_e,verticalSliderSize:i.clampedInt(Ee.verticalSliderSize,_e,0,1e3),scrollByPage:t(Ee.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:t(Ee.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends h{constructor(){const q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.nonBasicASCII,description:a.localize(113,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:q.invisibleCharacters,description:a.localize(114,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:q.ambiguousCharacters,description:a.localize(115,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.includeComments,description:a.localize(116,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:q.includeStrings,description:a.localize(117,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:q.allowedCharacters,description:a.localize(118,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:q.allowedLocales,description:a.localize(119,null)}})}applyUpdate(q,Ee){let He=!1;Ee.allowedCharacters&&q&&(D.$bo(q.allowedCharacters,Ee.allowedCharacters)||(q={...q,allowedCharacters:Ee.allowedCharacters},He=!0)),Ee.allowedLocales&&q&&(D.$bo(q.allowedLocales,Ee.allowedLocales)||(q={...q,allowedLocales:Ee.allowedLocales},He=!0));const _e=super.applyUpdate(q,Ee);return He?new r(_e.newValue,!0):_e}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{nonBasicASCII:Ue(Ee.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Ee.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Ee.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Ue(Ee.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Ue(Ee.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(q.allowedLocales,this.defaultValue.allowedLocales)}}c(q,Ee){if(typeof q!="object"||!q)return Ee;const He={};for(const[_e,lt]of Object.entries(q))lt===!0&&(He[_e]=!0);return He}}class K extends h{constructor(){const q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",q,{"editor.inlineSuggest.enabled":{type:"boolean",default:q.enabled,description:a.localize(120,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(121,null),a.localize(122,null),a.localize(123,null)],description:a.localize(124,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:q.suppressSuggestions,description:a.localize(125,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:q.fontFamily,description:a.localize(126,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),mode:p(Ee.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:p(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:t(Ee.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:l.string(Ee.fontFamily,this.defaultValue.fontFamily)}}}class x extends h{constructor(){const q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(je.inlineEdit,"experimentalInlineEdit",q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:q.enabled,description:a.localize(127,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[a.localize(128,null),a.localize(129,null),a.localize(130,null)],description:a.localize(131,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:q.fontFamily,description:a.localize(132,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:q.backgroundColoring,description:a.localize(133,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showToolbar:p(Ee.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:l.string(Ee.fontFamily,this.defaultValue.fontFamily),keepOnBlur:t(Ee.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:t(Ee.backgroundColoring,this.defaultValue.backgroundColoring)}}}class ge extends h{constructor(){const q={enabled:M.$ou.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$ou.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:q.enabled,markdownDescription:a.localize(134,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:q.independentColorPoolPerBracketType,description:a.localize(135,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Ee.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class Re extends h{constructor(){const q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:q.bracketPairs,description:a.localize(139,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(140,null),a.localize(141,null),a.localize(142,null)],default:q.bracketPairsHorizontal,description:a.localize(143,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:q.highlightActiveBracketPair,description:a.localize(144,null)},"editor.guides.indentation":{type:"boolean",default:q.indentation,description:a.localize(145,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(146,null),a.localize(147,null),a.localize(148,null)],default:q.highlightActiveIndentation,description:a.localize(149,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{bracketPairs:Ue(Ee.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Ue(Ee.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Ee.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Ee.indentation,this.defaultValue.indentation),highlightActiveIndentation:Ue(Ee.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Ue(te,q,Ee){const He=Ee.indexOf(te);return He===-1?q:Ee[He]}class Ke extends h{constructor(){const q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(150,null),a.localize(151,null)],default:q.insertMode,description:a.localize(152,null)},"editor.suggest.filterGraceful":{type:"boolean",default:q.filterGraceful,description:a.localize(153,null)},"editor.suggest.localityBonus":{type:"boolean",default:q.localityBonus,description:a.localize(154,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:q.shareSuggestSelections,markdownDescription:a.localize(155,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(156,null),a.localize(157,null),a.localize(158,null),a.localize(159,null)],default:q.selectionMode,markdownDescription:a.localize(160,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:q.snippetsPreventQuickSuggestions,description:a.localize(161,null)},"editor.suggest.showIcons":{type:"boolean",default:q.showIcons,description:a.localize(162,null)},"editor.suggest.showStatusBar":{type:"boolean",default:q.showStatusBar,description:a.localize(163,null)},"editor.suggest.preview":{type:"boolean",default:q.preview,description:a.localize(164,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:q.showInlineDetails,description:a.localize(165,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(166,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(167,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(177,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(178,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(179,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(180,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(181,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(182,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(183,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(184,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(185,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(186,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(187,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(188,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(189,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(190,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(191,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(192,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(193,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(194,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(195,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(196,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(197,null)}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{insertMode:p(Ee.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Ee.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Ee.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Ee.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Ee.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:p(Ee.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Ee.showIcons,this.defaultValue.showIcons),showStatusBar:t(Ee.showStatusBar,this.defaultValue.showStatusBar),preview:t(Ee.preview,this.defaultValue.preview),previewMode:p(Ee.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Ee.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Ee.showMethods,this.defaultValue.showMethods),showFunctions:t(Ee.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Ee.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Ee.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Ee.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Ee.showFields,this.defaultValue.showFields),showVariables:t(Ee.showVariables,this.defaultValue.showVariables),showClasses:t(Ee.showClasses,this.defaultValue.showClasses),showStructs:t(Ee.showStructs,this.defaultValue.showStructs),showInterfaces:t(Ee.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Ee.showModules,this.defaultValue.showModules),showProperties:t(Ee.showProperties,this.defaultValue.showProperties),showEvents:t(Ee.showEvents,this.defaultValue.showEvents),showOperators:t(Ee.showOperators,this.defaultValue.showOperators),showUnits:t(Ee.showUnits,this.defaultValue.showUnits),showValues:t(Ee.showValues,this.defaultValue.showValues),showConstants:t(Ee.showConstants,this.defaultValue.showConstants),showEnums:t(Ee.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Ee.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Ee.showKeywords,this.defaultValue.showKeywords),showWords:t(Ee.showWords,this.defaultValue.showWords),showColors:t(Ee.showColors,this.defaultValue.showColors),showFiles:t(Ee.showFiles,this.defaultValue.showFiles),showReferences:t(Ee.showReferences,this.defaultValue.showReferences),showFolders:t(Ee.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Ee.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Ee.showSnippets,this.defaultValue.showSnippets),showUsers:t(Ee.showUsers,this.defaultValue.showUsers),showIssues:t(Ee.showIssues,this.defaultValue.showIssues)}}}class Ze extends h{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(198,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:a.localize(199,null),default:!0,type:"boolean"}})}validate(q){return!q||typeof q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(q.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends h{constructor(){const q=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",q,{anyOf:[{description:a.localize(200,null),type:"string"},{description:a.localize(201,null),type:"array",items:{type:"string"}}]})}validate(q){if(typeof q=="string"&&(q=[q]),Array.isArray(q)){const Ee=[];for(const He of q)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&Ee.push(He)}catch{}return Ee}return this.defaultValue}}var it;(function(te){te[te.None=0]="None",te[te.Same=1]="Same",te[te.Indent=2]="Indent",te[te.DeepIndent=3]="DeepIndent"})(it||(e.WrappingIndent=it={}));class st extends h{constructor(){super(je.wrappingIndent,"wrappingIndent",it.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(202,null),a.localize(203,null),a.localize(204,null),a.localize(205,null)],description:a.localize(206,null),default:"same"}})}validate(q){switch(q){case"none":return it.None;case"same":return it.Same;case"indent":return it.Indent;case"deepIndent":return it.DeepIndent}return it.Same}compute(q,Ee,He){return Ee.get(je.accessibilitySupport)===P.AccessibilitySupport.Enabled?it.None:He}}class ot extends c{constructor(){super(je.wrappingInfo)}compute(q,Ee,He){const _e=Ee.get(je.layoutInfo);return{isDominatedByLongLines:q.isDominatedByLongLines,isWordWrapMinified:_e.isWordWrapMinified,isViewportWrapping:_e.isViewportWrapping,wrappingColumn:_e.wrappingColumn}}}class $t extends h{constructor(){const q={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:q.enabled,markdownDescription:a.localize(207,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:a.localize(208,null),enum:["afterDrop","never"],enumDescriptions:[a.localize(209,null),a.localize(210,null)],default:"afterDrop"}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showDropSelector:p(Ee.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class dt extends h{constructor(){const q={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",q,{"editor.pasteAs.enabled":{type:"boolean",default:q.enabled,markdownDescription:a.localize(211,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:a.localize(212,null),enum:["afterPaste","never"],enumDescriptions:[a.localize(213,null),a.localize(214,null)],default:"afterPaste"}})}validate(q){if(!q||typeof q!="object")return this.defaultValue;const Ee=q;return{enabled:t(Ee.enabled,this.defaultValue.enabled),showPasteSelector:p(Ee.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",ut="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$d?ut:I.$e?gt:rt,fontWeight:"normal",fontSize:I.$d?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function We(te){return e.editorOptionsRegistry[te.id]=te,te}var je;(function(te){te[te.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",te[te.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",te[te.accessibilitySupport=2]="accessibilitySupport",te[te.accessibilityPageSize=3]="accessibilityPageSize",te[te.ariaLabel=4]="ariaLabel",te[te.ariaRequired=5]="ariaRequired",te[te.autoClosingBrackets=6]="autoClosingBrackets",te[te.autoClosingComments=7]="autoClosingComments",te[te.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",te[te.autoClosingDelete=9]="autoClosingDelete",te[te.autoClosingOvertype=10]="autoClosingOvertype",te[te.autoClosingQuotes=11]="autoClosingQuotes",te[te.autoIndent=12]="autoIndent",te[te.automaticLayout=13]="automaticLayout",te[te.autoSurround=14]="autoSurround",te[te.bracketPairColorization=15]="bracketPairColorization",te[te.guides=16]="guides",te[te.codeLens=17]="codeLens",te[te.codeLensFontFamily=18]="codeLensFontFamily",te[te.codeLensFontSize=19]="codeLensFontSize",te[te.colorDecorators=20]="colorDecorators",te[te.colorDecoratorsLimit=21]="colorDecoratorsLimit",te[te.columnSelection=22]="columnSelection",te[te.comments=23]="comments",te[te.contextmenu=24]="contextmenu",te[te.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",te[te.cursorBlinking=26]="cursorBlinking",te[te.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",te[te.cursorStyle=28]="cursorStyle",te[te.cursorSurroundingLines=29]="cursorSurroundingLines",te[te.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",te[te.cursorWidth=31]="cursorWidth",te[te.disableLayerHinting=32]="disableLayerHinting",te[te.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",te[te.domReadOnly=34]="domReadOnly",te[te.dragAndDrop=35]="dragAndDrop",te[te.dropIntoEditor=36]="dropIntoEditor",te[te.emptySelectionClipboard=37]="emptySelectionClipboard",te[te.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",te[te.extraEditorClassName=39]="extraEditorClassName",te[te.fastScrollSensitivity=40]="fastScrollSensitivity",te[te.find=41]="find",te[te.fixedOverflowWidgets=42]="fixedOverflowWidgets",te[te.folding=43]="folding",te[te.foldingStrategy=44]="foldingStrategy",te[te.foldingHighlight=45]="foldingHighlight",te[te.foldingImportsByDefault=46]="foldingImportsByDefault",te[te.foldingMaximumRegions=47]="foldingMaximumRegions",te[te.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",te[te.fontFamily=49]="fontFamily",te[te.fontInfo=50]="fontInfo",te[te.fontLigatures=51]="fontLigatures",te[te.fontSize=52]="fontSize",te[te.fontWeight=53]="fontWeight",te[te.fontVariations=54]="fontVariations",te[te.formatOnPaste=55]="formatOnPaste",te[te.formatOnType=56]="formatOnType",te[te.glyphMargin=57]="glyphMargin",te[te.gotoLocation=58]="gotoLocation",te[te.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",te[te.hover=60]="hover",te[te.inDiffEditor=61]="inDiffEditor",te[te.inlineSuggest=62]="inlineSuggest",te[te.inlineEdit=63]="inlineEdit",te[te.letterSpacing=64]="letterSpacing",te[te.lightbulb=65]="lightbulb",te[te.lineDecorationsWidth=66]="lineDecorationsWidth",te[te.lineHeight=67]="lineHeight",te[te.lineNumbers=68]="lineNumbers",te[te.lineNumbersMinChars=69]="lineNumbersMinChars",te[te.linkedEditing=70]="linkedEditing",te[te.links=71]="links",te[te.matchBrackets=72]="matchBrackets",te[te.minimap=73]="minimap",te[te.mouseStyle=74]="mouseStyle",te[te.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",te[te.mouseWheelZoom=76]="mouseWheelZoom",te[te.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",te[te.multiCursorModifier=78]="multiCursorModifier",te[te.multiCursorPaste=79]="multiCursorPaste",te[te.multiCursorLimit=80]="multiCursorLimit",te[te.occurrencesHighlight=81]="occurrencesHighlight",te[te.overviewRulerBorder=82]="overviewRulerBorder",te[te.overviewRulerLanes=83]="overviewRulerLanes",te[te.padding=84]="padding",te[te.pasteAs=85]="pasteAs",te[te.parameterHints=86]="parameterHints",te[te.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",te[te.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",te[te.quickSuggestions=89]="quickSuggestions",te[te.quickSuggestionsDelay=90]="quickSuggestionsDelay",te[te.readOnly=91]="readOnly",te[te.readOnlyMessage=92]="readOnlyMessage",te[te.renameOnType=93]="renameOnType",te[te.renderControlCharacters=94]="renderControlCharacters",te[te.renderFinalNewline=95]="renderFinalNewline",te[te.renderLineHighlight=96]="renderLineHighlight",te[te.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",te[te.renderValidationDecorations=98]="renderValidationDecorations",te[te.renderWhitespace=99]="renderWhitespace",te[te.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",te[te.roundedSelection=101]="roundedSelection",te[te.rulers=102]="rulers",te[te.scrollbar=103]="scrollbar",te[te.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",te[te.scrollBeyondLastLine=105]="scrollBeyondLastLine",te[te.scrollPredominantAxis=106]="scrollPredominantAxis",te[te.selectionClipboard=107]="selectionClipboard",te[te.selectionHighlight=108]="selectionHighlight",te[te.selectOnLineNumbers=109]="selectOnLineNumbers",te[te.showFoldingControls=110]="showFoldingControls",te[te.showUnused=111]="showUnused",te[te.snippetSuggestions=112]="snippetSuggestions",te[te.smartSelect=113]="smartSelect",te[te.smoothScrolling=114]="smoothScrolling",te[te.stickyScroll=115]="stickyScroll",te[te.stickyTabStops=116]="stickyTabStops",te[te.stopRenderingLineAfter=117]="stopRenderingLineAfter",te[te.suggest=118]="suggest",te[te.suggestFontSize=119]="suggestFontSize",te[te.suggestLineHeight=120]="suggestLineHeight",te[te.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",te[te.suggestSelection=122]="suggestSelection",te[te.tabCompletion=123]="tabCompletion",te[te.tabIndex=124]="tabIndex",te[te.unicodeHighlighting=125]="unicodeHighlighting",te[te.unusualLineTerminators=126]="unusualLineTerminators",te[te.useShadowDOM=127]="useShadowDOM",te[te.useTabStops=128]="useTabStops",te[te.wordBreak=129]="wordBreak",te[te.wordSegmenterLocales=130]="wordSegmenterLocales",te[te.wordSeparators=131]="wordSeparators",te[te.wordWrap=132]="wordWrap",te[te.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",te[te.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",te[te.wordWrapColumn=135]="wordWrapColumn",te[te.wordWrapOverride1=136]="wordWrapOverride1",te[te.wordWrapOverride2=137]="wordWrapOverride2",te[te.wrappingIndent=138]="wrappingIndent",te[te.wrappingStrategy=139]="wrappingStrategy",te[te.showDeprecated=140]="showDeprecated",te[te.inlayHints=141]="inlayHints",te[te.editorClassName=142]="editorClassName",te[te.pixelRatio=143]="pixelRatio",te[te.tabFocusMode=144]="tabFocusMode",te[te.layoutInfo=145]="layoutInfo",te[te.wrappingInfo=146]="wrappingInfo",te[te.defaultColorDecorators=147]="defaultColorDecorators",te[te.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",te[te.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:We(new s(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(215,null)})),acceptSuggestionOnEnter:We(new C(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(216,null),""],markdownDescription:a.localize(217,null)})),accessibilitySupport:We(new E),accessibilityPageSize:We(new i(je.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(218,null),tags:["accessibility"]})),ariaLabel:We(new l(je.ariaLabel,"ariaLabel",a.localize(219,null))),ariaRequired:We(new s(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:We(new s(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:a.localize(220,null),tags:["accessibility"]})),autoClosingBrackets:We(new C(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(221,null),a.localize(222,null),""],description:a.localize(223,null)})),autoClosingComments:We(new C(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(224,null),a.localize(225,null),""],description:a.localize(226,null)})),autoClosingDelete:We(new C(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(227,null),""],description:a.localize(228,null)})),autoClosingOvertype:We(new C(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(229,null),""],description:a.localize(230,null)})),autoClosingQuotes:We(new C(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(231,null),a.localize(232,null),""],description:a.localize(233,null)})),autoIndent:We(new S(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[a.localize(234,null),a.localize(235,null),a.localize(236,null),a.localize(237,null),a.localize(238,null)],description:a.localize(239,null)})),automaticLayout:We(new s(je.automaticLayout,"automaticLayout",!1)),autoSurround:We(new C(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(240,null),a.localize(241,null),a.localize(242,null),""],description:a.localize(243,null)})),bracketPairColorization:We(new ge),bracketPairGuides:We(new Re),stickyTabStops:We(new s(je.stickyTabStops,"stickyTabStops",!1,{description:a.localize(244,null)})),codeLens:We(new s(je.codeLens,"codeLens",!0,{description:a.localize(245,null)})),codeLensFontFamily:We(new l(je.codeLensFontFamily,"codeLensFontFamily","",{description:a.localize(246,null)})),codeLensFontSize:We(new i(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(247,null)})),colorDecorators:We(new s(je.colorDecorators,"colorDecorators",!0,{description:a.localize(248,null)})),colorDecoratorActivatedOn:We(new C(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[a.localize(249,null),a.localize(250,null),a.localize(251,null)],description:a.localize(252,null)})),colorDecoratorsLimit:We(new i(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(253,null)})),columnSelection:We(new s(je.columnSelection,"columnSelection",!1,{description:a.localize(254,null)})),comments:We(new R),contextmenu:We(new s(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:We(new s(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:a.localize(255,null)})),cursorBlinking:We(new S(je.cursorBlinking,"cursorBlinking",w.Blink,"blink",["blink","smooth","phase","expand","solid"],m,{description:a.localize(256,null)})),cursorSmoothCaretAnimation:We(new C(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(257,null),a.localize(258,null),a.localize(259,null)],description:a.localize(260,null)})),cursorStyle:We(new S(je.cursorStyle,"cursorStyle",N.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],X,{description:a.localize(261,null)})),cursorSurroundingLines:We(new i(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(262,null)})),cursorSurroundingLinesStyle:We(new C(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],markdownDescription:a.localize(265,null)})),cursorWidth:We(new i(je.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(266,null)})),disableLayerHinting:We(new s(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:We(new s(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:We(new s(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:We(new s(je.dragAndDrop,"dragAndDrop",!0,{description:a.localize(267,null)})),emptySelectionClipboard:We(new O),dropIntoEditor:We(new $t),stickyScroll:We(new H),experimentalWhitespaceRendering:We(new C(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(268,null),a.localize(269,null),a.localize(270,null)],description:a.localize(271,null)})),extraEditorClassName:We(new l(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:We(new d(je.fastScrollSensitivity,"fastScrollSensitivity",5,te=>te<=0?5:te,{markdownDescription:a.localize(272,null)})),find:We(new L),fixedOverflowWidgets:We(new s(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:We(new s(je.folding,"folding",!0,{description:a.localize(273,null)})),foldingStrategy:We(new C(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(274,null),a.localize(275,null)],description:a.localize(276,null)})),foldingHighlight:We(new s(je.foldingHighlight,"foldingHighlight",!0,{description:a.localize(277,null)})),foldingImportsByDefault:We(new s(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:a.localize(278,null)})),foldingMaximumRegions:We(new i(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(279,null)})),unfoldOnClickAfterEndOfLine:We(new s(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(280,null)})),fontFamily:We(new l(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(281,null)})),fontInfo:We(new de),fontLigatures2:We(new F),fontSize:We(new be),fontWeight:We(new ve),fontVariations:We(new ie),formatOnPaste:We(new s(je.formatOnPaste,"formatOnPaste",!1,{description:a.localize(282,null)})),formatOnType:We(new s(je.formatOnType,"formatOnType",!1,{description:a.localize(283,null)})),glyphMargin:We(new s(je.glyphMargin,"glyphMargin",!0,{description:a.localize(284,null)})),gotoLocation:We(new Z),hideCursorInOverviewRuler:We(new s(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:a.localize(285,null)})),hover:We(new ae),inDiffEditor:We(new s(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:We(new d(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,te=>d.clamp(te,-5,20),{description:a.localize(286,null)})),lightbulb:We(new ce),lineDecorationsWidth:We(new le),lineHeight:We(new re),lineNumbers:We(new Ve),lineNumbersMinChars:We(new i(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:We(new s(je.linkedEditing,"linkedEditing",!1,{description:a.localize(287,null)})),links:We(new s(je.links,"links",!0,{description:a.localize(288,null)})),matchBrackets:We(new C(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:a.localize(289,null)})),minimap:We(new ue),mouseStyle:We(new C(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:We(new d(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,te=>te===0?1:te,{markdownDescription:a.localize(290,null)})),mouseWheelZoom:We(new s(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:I.$d?a.localize(291,null):a.localize(292,null)})),multiCursorMergeOverlapping:We(new s(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:a.localize(293,null)})),multiCursorModifier:We(new S(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],oe,{markdownEnumDescriptions:[a.localize(294,null),a.localize(295,null)],markdownDescription:a.localize(296,null)})),multiCursorPaste:We(new C(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(297,null),a.localize(298,null)],markdownDescription:a.localize(299,null)})),multiCursorLimit:We(new i(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(300,null)})),occurrencesHighlight:We(new C(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[a.localize(301,null),a.localize(302,null),a.localize(303,null)],markdownDescription:a.localize(304,null)})),overviewRulerBorder:We(new s(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:a.localize(305,null)})),overviewRulerLanes:We(new i(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:We(new J),pasteAs:We(new dt),parameterHints:We(new Y),peekWidgetDefaultFocus:We(new C(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(306,null),a.localize(307,null)],description:a.localize(308,null)})),definitionLinkOpensInPeek:We(new s(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:a.localize(309,null)})),quickSuggestions:We(new pe),quickSuggestionsDelay:We(new i(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(310,null)})),readOnly:We(new s(je.readOnly,"readOnly",!1)),readOnlyMessage:We(new Te),renameOnType:We(new s(je.renameOnType,"renameOnType",!1,{description:a.localize(311,null),markdownDeprecationMessage:a.localize(312,null)})),renderControlCharacters:We(new s(je.renderControlCharacters,"renderControlCharacters",!0,{description:a.localize(313,null),restricted:!0})),renderFinalNewline:We(new C(je.renderFinalNewline,"renderFinalNewline",I.$e?"dimmed":"on",["off","on","dimmed"],{description:a.localize(314,null)})),renderLineHighlight:We(new C(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(315,null)],description:a.localize(316,null)})),renderLineHighlightOnlyWhenFocus:We(new s(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(317,null)})),renderValidationDecorations:We(new C(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:We(new C(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(318,null),a.localize(319,null),a.localize(320,null),""],description:a.localize(321,null)})),revealHorizontalRightPadding:We(new i(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:We(new s(je.roundedSelection,"roundedSelection",!0,{description:a.localize(322,null)})),rulers:We(new Pe),scrollbar:We(new W),scrollBeyondLastColumn:We(new i(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:a.localize(323,null)})),scrollBeyondLastLine:We(new s(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:a.localize(324,null)})),scrollPredominantAxis:We(new s(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:a.localize(325,null)})),selectionClipboard:We(new s(je.selectionClipboard,"selectionClipboard",!0,{description:a.localize(326,null),included:I.$e})),selectionHighlight:We(new s(je.selectionHighlight,"selectionHighlight",!0,{description:a.localize(327,null)})),selectOnLineNumbers:We(new s(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:We(new C(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(328,null),a.localize(329,null),a.localize(330,null)],description:a.localize(331,null)})),showUnused:We(new s(je.showUnused,"showUnused",!0,{description:a.localize(332,null)})),showDeprecated:We(new s(je.showDeprecated,"showDeprecated",!0,{description:a.localize(333,null)})),inlayHints:We(new he),snippetSuggestions:We(new C(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(334,null),a.localize(335,null),a.localize(336,null),a.localize(337,null)],description:a.localize(338,null)})),smartSelect:We(new Ze),smoothScrolling:We(new s(je.smoothScrolling,"smoothScrolling",!1,{description:a.localize(339,null)})),stopRenderingLineAfter:We(new i(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:We(new Ke),inlineSuggest:We(new K),inlineEdit:We(new x),inlineCompletionsAccessibilityVerbose:We(new s(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:a.localize(340,null)})),suggestFontSize:We(new i(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(341,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:We(new i(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(342,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:We(new s(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:a.localize(343,null)})),suggestSelection:We(new C(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(344,null),a.localize(345,null),a.localize(346,null)],description:a.localize(347,null)})),tabCompletion:We(new C(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(348,null),a.localize(349,null),a.localize(350,null)],description:a.localize(351,null)})),tabIndex:We(new i(je.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:We(new G),unusualLineTerminators:We(new C(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(352,null),a.localize(353,null),a.localize(354,null)],description:a.localize(355,null)})),useShadowDOM:We(new s(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:We(new s(je.useTabStops,"useTabStops",!0,{description:a.localize(356,null)})),wordBreak:We(new C(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(357,null),a.localize(358,null)],description:a.localize(359,null)})),wordSegmenterLocales:We(new nt),wordSeparators:We(new l(je.wordSeparators,"wordSeparators",$.$st,{description:a.localize(360,null)})),wordWrap:We(new C(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(361,null),a.localize(362,null),a.localize(363,null),a.localize(364,null)],description:a.localize(365,null)})),wordWrapBreakAfterCharacters:We(new l(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:We(new l(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:We(new i(je.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:a.localize(366,null)})),wordWrapOverride1:We(new C(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:We(new C(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:We(new V),defaultColorDecorators:We(new s(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:a.localize(367,null)})),pixelRatio:We(new we),tabFocusMode:We(new s(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:a.localize(368,null)})),layoutInfo:We(new ee),wrappingInfo:We(new ot),wrappingIndent:We(new st),wrappingStrategy:We(new De)}}),define(Ce[105],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ii=e.$Hi=void 0,e.$Hi=(0,b.$Ai)("environmentService"),e.$Ii=(0,b.$Bi)(e.$Hi)}),define(Ce[30],Ie([1,0,58,20,13,15,2,172,3,21,16,47]),function(_,e,b,D,I,T,A,M,$,a,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=e.$zl=e.FileKind=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.FileOperationResult=e.$rl=e.$ql=e.$pl=e.$nl=e.FileChangeType=e.$ml=e.FileOperation=e.$gl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$7k=void 0,e.$8k=u,e.$9k=o,e.$0k=f,e.$$k=t,e.$_k=s,e.$al=n,e.$bl=i,e.$cl=g,e.$dl=d,e.$el=l,e.$fl=p,e.$hl=v,e.$il=E,e.$jl=R,e.$kl=w,e.$ll=m,e.$ol=O,e.$Al=ve,e.$Bl=Z,e.$Dl=fe,e.$7k=(0,$.$Ai)("fileService");function u(ee){return ee.create===!0}var k;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(k||(e.FileType=k={}));var h;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var r;(function(ee){ee[ee.UPDATED=2]="UPDATED",ee[ee.ADDED=4]="ADDED",ee[ee.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function o(ee){const De=ee;return!!De&&typeof De.onDidChange=="function"}var c;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function f(ee){return!!(ee.capabilities&c.FileReadWrite)}function t(ee){return!!(ee.capabilities&c.FileFolderCopy)}function s(ee){return!!(ee.capabilities&c.FileClone)}function n(ee){return!!(ee.capabilities&c.FileOpenReadWriteClose)}function i(ee){return!!(ee.capabilities&c.FileReadStream)}function g(ee){return f(ee)?!!(ee.capabilities&c.FileAtomicRead):!1}function d(ee){return f(ee)?!!(ee.capabilities&c.FileAtomicWrite):!1}function l(ee){return!!(ee.capabilities&c.FileAtomicDelete)}function p(ee){return!!(ee.capabilities&c.Readonly)}var C;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(C||(e.FileSystemProviderErrorCode=C={}));class S extends Error{static create(De,Fe){const ce=new S(De.toString(),Fe);return R(ce,Fe),ce}constructor(De,Fe){super(De),this.code=Fe}}e.$gl=S;function v(ee,De){return S.create(ee,De)}function E(ee){return ee||v((0,M.localize)(0,null),C.Unknown)}function R(ee,De){return ee.name=De?`${De} (FileSystemError)`:"FileSystemError",ee}function w(ee){if(!ee)return C.Unknown;if(ee instanceof S)return ee.code;const De=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!De)return C.Unknown;switch(De[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}function m(ee){if(ee instanceof L)return ee.fileOperationResult;switch(w(ee)){case C.FileNotFound:return de.FILE_NOT_FOUND;case C.FileIsADirectory:return de.FILE_IS_DIRECTORY;case C.FileNotADirectory:return de.FILE_NOT_DIRECTORY;case C.FileWriteLocked:return de.FILE_WRITE_LOCKED;case C.NoPermissions:return de.FILE_PERMISSION_DENIED;case C.FileExists:return de.FILE_MOVE_CONFLICT;case C.FileTooLarge:return de.FILE_TOO_LARGE;default:return de.FILE_OTHER_ERROR}}var N;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class B{constructor(De,Fe,ce){this.resource=De,this.operation=Fe,this.target=ce}isOperation(De){return this.operation===De}}e.$ml=B;var X;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(X||(e.FileChangeType=X={}));class V{constructor(De,Fe){this.c=Fe,this.b=void 0,this.d=new y.$V(()=>{const ce=b.$Gi.forUris(()=>this.c);return ce.fill(this.rawAdded.map(H=>[H,!0])),ce}),this.f=new y.$V(()=>{const ce=b.$Gi.forUris(()=>this.c);return ce.fill(this.rawUpdated.map(H=>[H,!0])),ce}),this.g=new y.$V(()=>{const ce=b.$Gi.forUris(()=>this.c);return ce.fill(this.rawDeleted.map(H=>[H,!0])),ce}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const ce of De){switch(ce.type){case X.ADDED:this.rawAdded.push(ce.resource);break;case X.UPDATED:this.rawUpdated.push(ce.resource);break;case X.DELETED:this.rawDeleted.push(ce.resource);break}this.b!==V.a&&(typeof ce.cId=="number"?this.b===void 0?this.b=ce.cId:this.b!==ce.cId&&(this.b=V.a):this.b!==void 0&&(this.b=V.a))}}contains(De,...Fe){return this.h(De,{includeChildren:!1},...Fe)}affects(De,...Fe){return this.h(De,{includeChildren:!0},...Fe)}h(De,Fe,...ce){if(!De)return!1;const H=ce.length>0;return!!((!H||ce.includes(X.ADDED))&&(this.d.value.get(De)||Fe.includeChildren&&this.d.value.findSuperstr(De))||(!H||ce.includes(X.UPDATED))&&(this.f.value.get(De)||Fe.includeChildren&&this.f.value.findSuperstr(De))||(!H||ce.includes(X.DELETED))&&(this.g.value.findSubstr(De)||Fe.includeChildren&&this.g.value.findSuperstr(De)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(De){return this.b===De}hasCorrelation(){return typeof this.b=="number"}}e.$nl=V,V.a=null;function O(ee,De,Fe){return!ee||!De||ee===De||De.length>ee.length?!1:(De.charAt(De.length-1)!==D.sep&&(De+=D.sep),Fe?(0,I.$Cf)(ee,De):ee.indexOf(De)===0)}class L extends Error{constructor(De,Fe,ce){super(De),this.fileOperationResult=Fe,this.options=ce}}e.$pl=L;class F extends L{constructor(De,Fe,ce,H){super(De,Fe,H),this.fileOperationResult=Fe,this.size=ce}}e.$ql=F;class ie extends L{constructor(De,Fe,ce){super(De,de.FILE_NOT_MODIFIED_SINCE,ce),this.stat=Fe}}e.$rl=ie;var de;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(de||(e.FileOperationResult=de={})),e.$sl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$tl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ul="files.associations",e.$vl="files.exclude",e.$wl="files.readonlyInclude",e.$xl="files.readonlyExclude",e.$yl="files.readonlyFromPermissions";var be;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(be||(e.FileKind=be={})),e.$zl="";function ve(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function Z(ee,De){if(!De.hasProvider(A.URI.from({scheme:ee.scheme})))return new Promise(Fe=>{const ce=De.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===ee.scheme&&H.added&&(ce.dispose(),Fe())})})}class ae{static formatSize(De){return(0,T.$eg)(De)||(De=0),De<ae.KB?(0,M.localize)(1,null,De.toFixed(0)):De<ae.MB?(0,M.localize)(2,null,(De/ae.KB).toFixed(2)):De<ae.GB?(0,M.localize)(3,null,(De/ae.MB).toFixed(2)):De<ae.TB?(0,M.localize)(4,null,(De/ae.GB).toFixed(2)):(0,M.localize)(5,null,(De/ae.TB).toFixed(2))}}e.$Cl=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;function fe(ee){const De=typeof ee=="string"||ee?.scheme===P.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===P.Schemas.file?1024*ae.MB:De?10*ae.MB:a.$i?50*ae.MB:1024*ae.MB}}),define(Ce[75],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=void 0;class b{constructor(...I){this.a=new Map;for(const[T,A]of I)this.set(T,A)}set(I,T){const A=this.a.get(I);return this.a.set(I,T),A}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$yi=b}),define(Ce[210],Ie([1,0,11,14,6,74,207,3,75,211]),function(_,e,b,D,I,T,A,M,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=e.$lr=void 0;const P=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class u{constructor(o=new $.$yi,c=!1,f,t=P){this.i=o,this.j=c,this.k=f,this.l=t,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(M.$zi,this),this._globalGraph=t?f?._globalGraph??new A.$kr(s=>s):void 0}dispose(){if(!this.f){this.f=!0,(0,I.$Pc)(this.h),this.h.clear();for(const o of this.g)(0,I.$Oc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o,c){this.m();const f=this,t=new class extends u{dispose(){f.h.delete(t),super.dispose()}}(o,this.j,this,this.l);return this.h.add(t),c?.add(t),t}invokeFunction(o,...c){this.m();const f=h.traceInvocation(this.l,o);let t=!1;try{return o({get:n=>{if(t)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(n,f);if(!i)throw new Error(`[invokeFunction] unknown service '${n}'`);return i}},...c)}finally{t=!0,f.stop()}}createInstance(o,...c){this.m();let f,t;return o instanceof T.$xi?(f=h.traceCreation(this.l,o.ctor),t=this.o(o.ctor,o.staticArguments.concat(c),f)):(f=h.traceCreation(this.l,o),t=this.o(o,c,f)),f.stop(),t}o(o,c=[],f){const t=M._util.getServiceDependencies(o).sort((i,g)=>i.index-g.index),s=[];for(const i of t){const g=this.s(i.id,f);g||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),s.push(g)}const n=t.length>0?t[0].index:c.length;if(c.length!==n){console.trace(`[createInstance] First service dependency of ${o.name} at position ${n+1} conflicts with ${c.length} static arguments`);const i=n-c.length;i>0?c=c.concat(new Array(i)):c=c.slice(0,n)}return Reflect.construct(o,c.concat(s))}q(o,c){if(this.i.get(o)instanceof T.$xi)this.i.set(o,c);else if(this.k)this.k.q(o,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const c=this.i.get(o);return!c&&this.k?this.k.r(o):c}s(o,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const f=this.r(o);return f instanceof T.$xi?this.u(o,f,c.branch(o,!0)):(c.branch(o,!1),f)}u(o,c,f){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,c,f)}finally{this.t.delete(o)}}v(o,c,f){const t=new A.$kr(i=>i.id.toString());let s=0;const n=[{id:o,desc:c,_trace:f}];for(;n.length;){const i=n.pop();if(t.lookupOrInsertNode(i),s++>1e3)throw new y(t);for(const g of M._util.getServiceDependencies(i.desc.ctor)){const d=this.r(g.id);if(d||this.y(`[createInstance] ${o} depends on ${g.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(g.id)),d instanceof T.$xi){const l={id:g.id,desc:d,_trace:i._trace.branch(g.id,!0)};t.insertEdge(i,l),n.push(l)}}}for(;;){const i=t.roots();if(i.length===0){if(!t.isEmpty())throw new y(t);break}for(const{data:g}of i){if(this.r(g.id)instanceof T.$xi){const l=this.w(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this.q(g.id,l)}t.removeNode(g)}}return this.r(o)}w(o,c,f=[],t,s){if(this.i.get(o)instanceof T.$xi)return this.x(o,c,f,t,s,this.g);if(this.k)return this.k.w(o,c,f,t,s);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(o,c,f=[],t,s,n){if(t){const i=new u(void 0,this.j,this,this.l);i.c=String(o);const g=new Map,d=new b.$Th(()=>{const l=i.o(c,f,s);for(const[p,C]of g){const S=l[p];if(typeof S=="function")for(const v of C)v.disposable=S.apply(l,v.listener)}return g.clear(),n.add(l),l});return new Proxy(Object.create(null),{get(l,p){if(!d.isInitialized&&typeof p=="string"&&(p.startsWith("onDid")||p.startsWith("onWill"))){let v=g.get(p);return v||(v=new a.$5c,g.set(p,v)),(R,w,m)=>{if(d.isInitialized)return d.value[p](R,w,m);{const N={listener:[R,w,m],disposable:void 0},B=v.push(N);return(0,I.$Sc)(()=>{B(),N.disposable?.dispose()})}}}if(p in l)return l[p];const C=d.value;let S=C[p];return typeof S!="function"||(S=S.bind(C),l[p]=S),S},set(l,p,C){return d.value[p]=C,!0},getPrototypeOf(l){return c.prototype}})}else{const i=this.o(c,f,s);return n.add(i),i}}y(o,c){if(c&&console.warn(o),this.j)throw new Error(o)}}e.$lr=u;var k;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(k||(k={}));class h{static traceInvocation(o,c){return o?new h(k.Invocation,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):h.c}static traceCreation(o,c){return o?new h(k.Creation,c.name):h.c}constructor(o,c){this.type=o,this.name=c,this.g=Date.now(),this.h=[]}branch(o,c){const f=new h(k.Branch,o.toString());return this.h.push([o,c,f]),f}stop(){const o=Date.now()-this.g;h.f+=o;let c=!1;function f(s,n){const i=[],g=new Array(s+1).join("	");for(const[d,l,p]of n.h)if(l&&p){c=!0,i.push(`${g}CREATES -> ${d}`);const C=f(s+1,p);C&&i.push(C)}else i.push(`${g}uses -> ${d}`);return i.join(`
`)}const t=[`${this.type===k.Creation?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${h.f.toFixed(2)}ms)`];(o>2||c)&&h.all.add(t.join(`
`))}}e.$mr=h,h.all=new Set,h.c=new class extends h{constructor(){super(k.None,null)}stop(){}branch(){return this}},h.f=0}),define(Ce[12],Ie([1,0,173,49,4,76,6,29,21,24,15,2,32,3]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$0j=e.LogLevel=e.$8j=e.$7j=void 0,e.$9j=r,e.log=c,e.$ik=S,e.$jk=v,e.$kk=E,e.$lk=R,e.$7j=(0,k.$Ai)("logService"),e.$8j=(0,k.$Ai)("loggerService");function h(){return new Date().toISOString()}function r(w){return(0,P.$eg)(w)}var o;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$0j=o.Info;function c(w,m,N){switch(m){case o.Trace:w.trace(N);break;case o.Debug:w.debug(N);break;case o.Info:w.info(N);break;case o.Warning:w.warn(N);break;case o.Error:w.error(N);break;case o.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function f(w,m=!1){let N="";for(let B=0;B<w.length;B++){let X=w[B];if(X instanceof Error&&(X=(0,D.$lj)(X,m)),typeof X=="object")try{X=JSON.stringify(X)}catch{}N+=(B>0?" ":"")+X}return N}class t extends A.$Uc{constructor(){super(...arguments),this.b=e.$0j,this.c=this.B(new I.$he),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==o.Off&&this.b<=m}}e.$_j=t;class s extends t{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...N){this.f(o.Trace)&&this.g(o.Trace,f([m,...N],!0))}debug(m,...N){this.f(o.Debug)&&this.g(o.Debug,f([m,...N]))}info(m,...N){this.f(o.Info)&&this.g(o.Info,f([m,...N]))}warn(m,...N){this.f(o.Warning)&&this.g(o.Warning,f([m,...N]))}error(m,...N){if(this.f(o.Error))if(m instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=m.stack,this.g(o.Error,f(B))}else this.g(o.Error,f([m,...N]))}flush(){}}e.$ak=s;class n extends t{constructor(m=e.$0j){super(),this.setLevel(m),this.g=!$.$c}trace(m,...N){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,m,...N):console.log(`[main ${h()}]`,m,...N))}debug(m,...N){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,m,...N):console.log(`[main ${h()}]`,m,...N))}info(m,...N){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,m,...N):console.log(`[main ${h()}]`,m,...N))}warn(m,...N){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,m,...N):console.warn(`[main ${h()}]`,m,...N))}error(m,...N){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,m,...N):console.error(`[main ${h()}]`,m,...N))}flush(){}}e.$bk=n;class i extends t{constructor(m=e.$0j,N=!0){super(),this.g=N,this.setLevel(m)}trace(m,...N){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...N):console.log(m,...N))}debug(m,...N){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...N):console.log(m,...N))}info(m,...N){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...N):console.log(m,...N))}warn(m,...N){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...N):console.log(m,...N))}error(m,...N){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...N):console.error(m,...N))}flush(){}}e.$ck=i;class g extends t{constructor(m,N=e.$0j){super(),this.g=m,this.setLevel(N)}trace(m,...N){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(m),...N])}debug(m,...N){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(m),...N])}info(m,...N){this.f(o.Info)&&this.g.log(o.Info,[this.h(m),...N])}warn(m,...N){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(m),...N])}error(m,...N){this.f(o.Error)&&this.g.log(o.Error,[this.h(m),...N])}h(m){return typeof m=="string"?m:(0,D.$lj)(m,this.f(o.Trace))}flush(){}}e.$dk=g;class d extends t{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const N of this.g)N.setLevel(m);super.setLevel(m)}trace(m,...N){for(const B of this.g)B.trace(m,...N)}debug(m,...N){for(const B of this.g)B.debug(m,...N)}info(m,...N){for(const B of this.g)B.info(m,...N)}warn(m,...N){for(const B of this.g)B.warn(m,...N)}error(m,...N){for(const B of this.g)B.error(m,...N)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose();super.dispose()}}e.$ek=d;class l extends A.$Uc{constructor(m,N,B){if(super(),this.h=m,this.j=N,this.b=new M.$Ac,this.c=this.B(new I.$he),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$he),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$he),this.onDidChangeVisibility=this.g.event,B)for(const X of B)this.b.set(X.resource,{logger:void 0,info:X})}m(m){return(0,P.$ag)(m)?[...this.b.values()].find(N=>N.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,N){const B=this.n(m),X=(0,P.$ag)(m)?m:N?.id??(0,T.$oj)(B.toString()).toString(16);let V=this.b.get(B)?.logger;const O=N?.logLevel==="always"?o.Trace:N?.logLevel;V||(V=this.s(B,O??this.getLogLevel(B)??this.h,{...N,id:X}));const L={logger:V,info:{resource:B,id:X,logLevel:O,name:N?.name,hidden:N?.hidden,extensionId:N?.extensionId,when:N?.when}};return this.registerLogger(L.info),this.b.set(B,L),V}n(m){return(0,P.$ag)(m)?(0,a.$bh)(this.j,`${m}.log`):m}setLogLevel(m,N){if(y.URI.isUri(m)){const B=m,X=N,V=this.b.get(B);V&&X!==V.info.logLevel&&(V.info.logLevel=X===this.h?void 0:X,V.logger?.setLevel(X),this.b.set(V.info.resource,V),this.f.fire([B,X]))}else{this.h=m;for(const[B,X]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&X.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,N){const B=this.m(m);B&&N!==!B.info.hidden&&(B.info.hidden=!N,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,N]))}getLogLevel(m){let N;return m&&(N=this.b.get(m)?.info.logLevel),N??this.h}registerLogger(m){const N=this.b.get(m.resource);N?N.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const N=this.b.get(m);N&&(N.logger&&N.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[N.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$fk=l;class p{constructor(){this.onDidChangeLogLevel=new I.$he().event}setLevel(m){}getLevel(){return o.Info}trace(m,...N){}debug(m,...N){}info(m,...N){}warn(m,...N){}error(m,...N){}critical(m,...N){}dispose(){}flush(){}}e.$gk=p;class C extends p{}e.$hk=C;function S(w){if(w.verbose)return o.Trace;if(typeof w.logLevel=="string"){const m=R(w.logLevel.toLowerCase());if(m!==void 0)return m}return e.$0j}function v(w){switch(w){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function E(w){switch(w){case o.Trace:return{original:"Trace",value:b.localize(0,null)};case o.Debug:return{original:"Debug",value:b.localize(1,null)};case o.Info:return{original:"Info",value:b.localize(2,null)};case o.Warning:return{original:"Warning",value:b.localize(3,null)};case o.Error:return{original:"Error",value:b.localize(4,null)};case o.Off:return{original:"Off",value:b.localize(5,null)}}}function R(w){switch(w){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$mk=new u.$Rj("logLevel",v(o.Info))}),define(Ce[212],Ie([1,0,6,12]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oQ=void 0;class I extends b.$Uc{constructor(A,M=[]){super(),this.a=new D.$ek([A,...M]),this.B(A.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...M){this.a.trace(A,...M)}debug(A,...M){this.a.debug(A,...M)}info(A,...M){this.a.info(A,...M)}warn(A,...M){this.a.warn(A,...M)}error(A,...M){this.a.error(A,...M)}flush(){this.a.flush()}}e.$oQ=I}),define(Ce[106],Ie([1,0,35,174,3]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hv=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var A;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function($){function a(h,r){return r-h}$.compare=a;const P=Object.create(null);P[$.Error]=(0,D.localize)(0,null),P[$.Warning]=(0,D.localize)(1,null),P[$.Info]=(0,D.localize)(2,null);function y(h){return P[h]||""}$.toString=y;function u(h){switch(h){case b.default.Error:return $.Error;case b.default.Warning:return $.Warning;case b.default.Info:return $.Info;case b.default.Ignore:return $.Hint}}$.fromSeverity=u;function k(h){switch(h){case $.Error:return b.default.Error;case $.Warning:return b.default.Warning;case $.Info:return b.default.Info;case $.Hint:return b.default.Ignore}}$.toSeverity=k}(A||(e.MarkerSeverity=A={}));var M;(function($){const a="";function P(u){return y(u,!0)}$.makeKey=P;function y(u,k){const h=[a];return u.source?h.push(u.source.replace("\xA6","\\\xA6")):h.push(a),u.code?typeof u.code=="string"?h.push(u.code.replace("\xA6","\\\xA6")):h.push(u.code.value.replace("\xA6","\\\xA6")):h.push(a),u.severity!==void 0&&u.severity!==null?h.push(A.toString(u.severity)):h.push(a),u.message&&k?h.push(u.message.replace("\xA6","\\\xA6")):h.push(a),u.startLineNumber!==void 0&&u.startLineNumber!==null?h.push(u.startLineNumber.toString()):h.push(a),u.startColumn!==void 0&&u.startColumn!==null?h.push(u.startColumn.toString()):h.push(a),u.endLineNumber!==void 0&&u.endLineNumber!==null?h.push(u.endLineNumber.toString()):h.push(a),u.endColumn!==void 0&&u.endColumn!==null?h.push(u.endColumn.toString()):h.push(a),h.push(a),h.join("\xA6")}$.makeKeyOptionalMessage=y})(M||(e.IMarkerData=M={})),e.$Hv=(0,I.$Ai)("markerService")}),define(Ce[213],Ie([1,0,4,35,3]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kw=e.$jw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$hw=e.Severity=void 0,e.$iw=M,e.Severity=D.default,e.$hw=(0,I.$Ai)("notificationService");var T;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function M(y){if(y){const u=y;return typeof u.id=="string"&&typeof u.label=="string"}return!1}var $;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class a{constructor(){this.progress=new P,this.onDidClose=b.Event.None,this.onDidChangeVisibility=b.Event.None}updateSeverity(u){}updateMessage(u){}updateActions(u){}close(){}}e.$jw=a;class P{infinite(){}done(){}total(u){}worked(u){}}e.$kw=P}),define(Ce[107],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ok=e.$nk=void 0,e.$nk=(0,b.$Ai)("productService"),e.$ok="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(_,e,b,D){var I=arguments.length,T=I<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,b):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(_,e,b,D);else for(var M=_.length-1;M>=0;M--)(A=_[M])&&(T=(I<3?A(T):I>3?A(e,b,T):A(e,b))||T);return I>3&&T&&Object.defineProperty(e,b,T),T},qe=this&&this.__param||function(_,e){return function(b,D){e(b,D,_)}};define(Ce[77],Ie([1,0,11,22,6,3]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rw=e.$qw=e.$pw=e.$ow=e.$nw=e.$mw=e.ProgressLocation=e.$lw=void 0,e.$lw=(0,T.$Ai)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$mw=Object.freeze({total(){},worked(){},done(){}});class M{get value(){return this.a}constructor(u){this.b=u}report(u){this.a=u,this.b(this.a)}}e.$nw=M,M.None=Object.freeze({report(){}});class ${get value(){return this.a}constructor(u){this.e=u}report(u){this.b?this.b.push(u):this.b=[u],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const u=this.b.shift();this.a=u,await this.e(this.a)}}finally{this.c=!1;const u=this.d;this.d=void 0,u?.()}}drain(){return this.c?new Promise(u=>{const k=this.d;this.d=()=>{k?.(),u()}}):Promise.resolve()}}e.$ow=$;let a=class extends I.$Uc{constructor(u,k){super(),this.a=new b.$Xh,k.withProgress(u,h=>(this.b=h,this.c&&h.report(this.c),this.a.p)),this.B((0,I.$Sc)(()=>this.a.complete()))}report(u){this.b?this.b.report(u):this.c=u}};e.$pw=a,e.$pw=a=Je([qe(1,e.$lw)],a);class P extends I.$Uc{constructor(u){super(),this.g=u,this.a=0,this.b=this.B(new I.$Tc)}start(u){this.stop();const k=++this.a,h=new D.$se;return this.f=setTimeout(()=>{k===this.a&&(this.c=this.g.show(!0))},u),this.b.add((0,I.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Sc)(()=>h.cancel())),this.b.add((0,I.$Sc)(()=>this.c?this.c.done():void 0)),{id:k,token:h.token,stop:()=>this.h(k),isCurrent:()=>this.a===k}}stop(){this.h(this.a)}h(u){this.a===u&&this.b.clear()}}e.$qw=P,e.$rw=(0,T.$Ai)("editorProgressService")}),define(Ce[31],Ie([1,0,61,15]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ko=void 0;class I{constructor(){this.a=new Map}add(A,M){b.ok(D.$ag(A)),b.ok(D.$cg(M)),b.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,M)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$ko=new I}),define(Ce[78],Ie([1,0,4,31]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lo=void 0,e.$lo={JSONContribution:"base.contributions.json"};function I(M){return M.length>0&&M.charAt(M.length-1)==="#"?M.substring(0,M.length-1):M}class T{constructor(){this.b=new b.$he,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,a){this.a[I($)]=a,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const A=new T;D.$ko.add(e.$lo.JSONContribution,A)}),define(Ce[54],Ie([1,0,18,4,15,167,42,78,31]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.ConfigurationScope=e.$po=e.EditPresentationTypes=void 0,e.$Ao=r,e.$Bo=o,e.$Co=c,e.$Do=t,e.$Eo=s;var a;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$po={Configuration:"base.contributions.configuration"};var P;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$qo={properties:{},patternProperties:{}},e.$ro={properties:{},patternProperties:{}},e.$so={properties:{},patternProperties:{}},e.$to={properties:{},patternProperties:{}},e.$uo={properties:{},patternProperties:{}},e.$vo={properties:{},patternProperties:{}},e.$wo="vscode://schemas/settings/resourceLanguage",e.$xo="vscode://schemas/settings/configurationDefaults";const y=$.$ko.as(M.$lo.JSONContribution);class u{constructor(){this.h=new Set,this.i=new D.$he,this.onDidSchemaChange=this.i.event,this.j=new D.$he,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$wo,this.g),this.v()}registerConfiguration(i,g=!0){this.registerConfigurations([i],g)}registerConfigurations(i,g=!0){const d=new Set;this.n(i,g,d),y.registerSchema(e.$wo,this.g),this.i.fire(),this.j.fire({properties:d})}deregisterConfigurations(i){const g=new Set;this.o(i,g),y.registerSchema(e.$wo,this.g),this.i.fire(),this.j.fire({properties:g})}updateConfigurations({add:i,remove:g}){const d=new Set;this.o(g,d),this.n(i,!1,d),y.registerSchema(e.$wo,this.g),this.i.fire(),this.j.fire({properties:d})}registerDefaultConfigurations(i){const g=new Set;this.k(i,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}k(i,g){const d=[];for(const{overrides:l,source:p}of i)for(const C in l)if(g.add(C),e.$zo.test(C)){const S=this.a.get(C),v=S?.valuesSources??new Map;if(p)for(const m of Object.keys(l[C]))v.set(m,p);const E={...S?.value||{},...l[C]};this.a.set(C,{source:p,value:E,valuesSources:v});const R=(0,A.$ej)(C),w={type:"object",default:E,description:T.localize(1,null,R),$ref:e.$wo,defaultDefaultValue:E,source:I.$ag(p)?void 0:p,defaultValueSource:p};d.push(...r(C)),this.d[C]=w,this.b.properties[C]=w}else{this.a.set(C,{value:l[C],source:p});const S=this.d[C];S&&(this.w(C,S),this.r(C,S))}this.m(d)}deregisterDefaultConfigurations(i){const g=new Set;this.l(i,g),this.i.fire(),this.j.fire({properties:g,defaultsOverrides:!0})}l(i,g){for(const{overrides:d,source:l}of i)for(const p in d){const C=this.a.get(p),S=I.$ag(l)?l:l?.id,v=I.$ag(C?.source)?C?.source:C?.source?.id;if(S===v)if(g.add(p),this.a.delete(p),e.$zo.test(p))delete this.d[p],delete this.b.properties[p];else{const E=this.d[p];E&&(this.w(p,E),this.r(p,E))}}this.u()}deltaConfiguration(i){let g=!1;const d=new Set;i.removedDefaults&&(this.l(i.removedDefaults,d),g=!0),i.addedDefaults&&(this.k(i.addedDefaults,d),g=!0),i.removedConfigurations&&this.o(i.removedConfigurations,d),i.addedConfigurations&&this.n(i.addedConfigurations,!1,d),this.i.fire(),this.j.fire({properties:d,defaultsOverrides:g})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const g of i)this.h.add(g);this.u()}n(i,g,d){i.forEach(l=>{this.p(l,g,l.extensionInfo,l.restrictedProperties,void 0,d),this.c.push(l),this.q(l)})}o(i,g){const d=l=>{if(l.properties)for(const p in l.properties){g.add(p);const C=this.d[p];C?.policy?.name&&this.e.delete(C.policy.name),delete this.d[p],this.s(p,l.properties[p])}l.allOf?.forEach(p=>d(p))};for(const l of i){d(l);const p=this.c.indexOf(l);p!==-1&&this.c.splice(p,1)}}p(i,g=!0,d,l,p=P.WINDOW,C){p=I.$jg(i.scope)?p:i.scope;const S=i.properties;if(S)for(const E in S){const R=S[E];if(g&&t(E,R)){delete S[E];continue}if(R.source=d,R.defaultDefaultValue=S[E].default,this.w(E,R),e.$zo.test(E)?R.scope=void 0:(R.scope=I.$jg(R.scope)?p:R.scope,R.restricted=I.$jg(R.restricted)?!!l?.includes(E):R.restricted),S[E].hasOwnProperty("included")&&!S[E].included){this.f[E]=S[E],delete S[E];continue}else this.d[E]=S[E],S[E].policy?.name&&this.e.set(S[E].policy.name,E);!S[E].deprecationMessage&&S[E].markdownDeprecationMessage&&(S[E].deprecationMessage=S[E].markdownDeprecationMessage),C.add(E)}const v=i.allOf;if(v)for(const E of v)this.p(E,g,d,l,p,C)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const g=d=>{const l=d.properties;if(l)for(const C in l)this.r(C,l[C]);d.allOf?.forEach(g)};g(i)}r(i,g){switch(e.$qo.properties[i]=g,g.scope){case P.APPLICATION:e.$ro.properties[i]=g;break;case P.MACHINE:e.$so.properties[i]=g;break;case P.MACHINE_OVERRIDABLE:e.$to.properties[i]=g;break;case P.WINDOW:e.$uo.properties[i]=g;break;case P.RESOURCE:e.$vo.properties[i]=g;break;case P.LANGUAGE_OVERRIDABLE:e.$vo.properties[i]=g,this.g.properties[i]=g;break}}s(i,g){switch(delete e.$qo.properties[i],g.scope){case P.APPLICATION:delete e.$ro.properties[i];break;case P.MACHINE:delete e.$so.properties[i];break;case P.MACHINE_OVERRIDABLE:delete e.$to.properties[i];break;case P.WINDOW:delete e.$uo.properties[i];break;case P.RESOURCE:case P.LANGUAGE_OVERRIDABLE:delete e.$vo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const g=`[${i}]`,d={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$wo};this.w(g,d),e.$qo.properties[g]=d,e.$ro.properties[g]=d,e.$so.properties[g]=d,e.$to.properties[g]=d,e.$uo.properties[g]=d,e.$vo.properties[g]=d}}v(){const i={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$wo};e.$qo.patternProperties[e.$yo]=i,e.$ro.patternProperties[e.$yo]=i,e.$so.patternProperties[e.$yo]=i,e.$to.patternProperties[e.$yo]=i,e.$uo.patternProperties[e.$yo]=i,e.$vo.patternProperties[e.$yo]=i,this.i.fire()}w(i,g){const d=this.a.get(i);let l=d?.value,p=d?.source;I.$hg(l)&&(l=g.defaultDefaultValue,p=void 0),I.$hg(l)&&(l=c(g.type)),g.default=l,g.defaultValueSource=p}}const k="\\[([^\\]]+)\\]",h=new RegExp(k,"g");e.$yo=`^(${k})+$`,e.$zo=new RegExp(e.$yo);function r(n){const i=[];if(e.$zo.test(n)){let g=h.exec(n);for(;g?.length;){const d=g[1].trim();d&&i.push(d),g=h.exec(n)}}return(0,b.$Mb)(i)}function o(n){return n.reduce((i,g)=>`${i}[${g}]`,"")}function c(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new u;$.$ko.add(e.$po.Configuration,f);function t(n,i){return n.trim()?e.$zo.test(n)?T.localize(7,null,n):f.getConfigurationProperties()[n]!==void 0?T.localize(8,null,n):i.policy?.name&&f.getPolicyConfigurations().get(i.policy?.name)!==void 0?T.localize(9,null,n,i.policy?.name,f.getPolicyConfigurations().get(i.policy?.name)):null:T.localize(6,null)}function s(){const n=[],i=f.getConfigurationProperties();for(const g of Object.keys(i))n.push([g,i[g].scope]);return n.push(["launch",P.RESOURCE]),n.push(["task",P.RESOURCE]),n}}),define(Ce[214],Ie([1,0,18,4,134,6,29,26,15,2,42,54,30,31]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Io=e.$Ho=e.$Go=e.$Fo=void 0,e.$Jo=s;function h(d){return Object.isFrozen(d)?d:M.$$n(d)}class r{static createEmptyModel(l){return new r({},[],[],void 0,l)}constructor(l,p,C,S,v){this.b=l,this.c=p,this.d=C,this.raw=S,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const l=this.raw.map(p=>{if(p instanceof r)return p;const C=new o("",this.f);return C.parseRaw(p),C.configurationModel});this.g=l.reduce((p,C)=>C===p?C:p.merge(C),l[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(l){return l?(0,P.$cj)(this.contents,l):this.contents}inspect(l,p){const C=this;return{get value(){return h(C.rawConfiguration.getValue(l))},get override(){return p?h(C.rawConfiguration.getOverrideValue(l,p)):void 0},get merged(){return h(p?C.rawConfiguration.override(p).getValue(l):C.rawConfiguration.getValue(l))},get overrides(){const S=[];for(const{contents:v,identifiers:E,keys:R}of C.rawConfiguration.overrides){const w=new r(v,R,[],void 0,C.f).getValue(l);w!==void 0&&S.push({identifiers:E,value:w})}return S.length?h(S):void 0}}}getOverrideValue(l,p){const C=this.j(p);return C?l?(0,P.$cj)(C,l):C:void 0}getKeysForOverrideIdentifier(l){const p=[];for(const C of this.overrides)C.identifiers.includes(l)&&p.push(...C.keys);return b.$Mb(p)}getAllOverrideIdentifiers(){const l=[];for(const p of this.overrides)l.push(...p.identifiers);return b.$Mb(l)}override(l){let p=this.a.get(l);return p||(p=this.h(l),this.a.set(l,p)),p}merge(...l){const p=M.$0n(this.contents),C=M.$0n(this.overrides),S=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const E of l)if(v.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.i(p,E.contents);for(const R of E.overrides){const[w]=C.filter(m=>b.$ub(m.identifiers,R.identifiers));w?(this.i(w.contents,R.contents),w.keys.push(...R.keys),w.keys=b.$Mb(w.keys)):C.push(M.$0n(R))}for(const R of E.keys)S.indexOf(R)===-1&&S.push(R)}return new r(p,S,C,v.every(E=>E instanceof r)?void 0:v,this.f)}h(l){const p=this.j(l);if(!p||typeof p!="object"||!Object.keys(p).length)return this;const C={};for(const S of b.$Mb([...Object.keys(this.contents),...Object.keys(p)])){let v=this.contents[S];const E=p[S];E&&(typeof v=="object"&&typeof E=="object"?(v=M.$0n(v),this.i(v,E)):v=E),C[S]=v}return new r(C,this.keys,this.overrides,void 0,this.f)}i(l,p){for(const C of Object.keys(p)){if(C in l&&$.$cg(l[C])&&$.$cg(p[C])){this.i(l[C],p[C]);continue}l[C]=M.$0n(p[C])}}j(l){let p=null,C=null;const S=v=>{v&&(C?this.i(C,v):C=M.$0n(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===l?p=v.contents:v.identifiers.includes(l)&&S(v.contents);return S(p),C}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(l,p){this.k(l,p,!0)}setValue(l,p){this.k(l,p,!1)}removeValue(l){const p=this.keys.indexOf(l);p!==-1&&(this.keys.splice(p,1),(0,P.$bj)(this.contents,l),y.$zo.test(l)&&this.overrides.splice(this.overrides.findIndex(C=>b.$ub(C.identifiers,(0,y.$Ao)(l))),1))}k(l,p,C){(0,P.$aj)(this.contents,l,p,S=>this.f.error(S)),C=C||this.keys.indexOf(l)===-1,C&&this.keys.push(l),y.$zo.test(l)&&this.overrides.push({identifiers:(0,y.$Ao)(l),keys:Object.keys(this.contents[l]),contents:(0,P.$_i)(this.contents[l],S=>this.f.error(S))})}}e.$Fo=r;class o{constructor(l,p){this.f=l,this.g=p,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(l,p){if(!$.$jg(l)){const C=this.h(l);this.parseRaw(C,p)}}reparse(l){this.a&&this.parseRaw(this.a,l)}parseRaw(l,p){this.a=l;const{contents:C,keys:S,overrides:v,restricted:E,hasExcludedProperties:R}=this.i(l,p);this.b=new r(C,S,v,R?[l]:void 0,this.g),this.c=E||[]}h(l){let p={},C=null,S=[];const v=[],E=[];function R(m){Array.isArray(S)?S.push(m):C!==null&&(S[C]=m)}const w={onObjectBegin:()=>{const m={};R(m),v.push(S),S=m,C=null},onObjectProperty:m=>{C=m},onObjectEnd:()=>{S=v.pop()},onArrayBegin:()=>{const m=[];R(m),v.push(S),S=m,C=null},onArrayEnd:()=>{S=v.pop()},onLiteralValue:R,onError:(m,N,B)=>{E.push({error:m,offset:N,length:B})}};if(l)try{I.$Xn(l,w),p=S[0]||{}}catch(m){this.g.error(`Error while parsing settings file ${this.f}: ${m}`),this.d=[m]}return p}i(l,p){const C=k.$ko.as(y.$po.Configuration).getConfigurationProperties(),S=this.j(l,C,!0,p);l=S.raw;const v=(0,P.$_i)(l,w=>this.g.error(`Conflict in settings file ${this.f}: ${w}`)),E=Object.keys(l),R=this.l(l,w=>this.g.error(`Conflict in settings file ${this.f}: ${w}`));return{contents:v,keys:E,overrides:R,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}j(l,p,C,S){let v=!1;if(!S?.scopes&&!S?.skipRestricted&&!S?.exclude?.length)return{raw:l,restricted:[],hasExcludedProperties:v};const E={},R=[];for(const w in l)if(y.$zo.test(w)&&C){const m=this.j(l[w],p,!1,S);E[w]=m.raw,v=v||m.hasExcludedProperties,R.push(...m.restricted)}else{const m=p[w],N=m?typeof m.scope<"u"?m.scope:y.ConfigurationScope.WINDOW:void 0;m?.restricted&&R.push(w),!S.exclude?.includes(w)&&(S.include?.includes(w)||(N===void 0||S.scopes===void 0||S.scopes.includes(N))&&!(S.skipRestricted&&m?.restricted))?E[w]=l[w]:v=!0}return{raw:E,restricted:R,hasExcludedProperties:v}}l(l,p){const C=[];for(const S of Object.keys(l))if(y.$zo.test(S)){const v={};for(const E in l[S])v[E]=l[S][E];C.push({identifiers:(0,y.$Ao)(S),keys:Object.keys(v),contents:(0,P.$_i)(v,p)})}return C}}e.$Go=o;class c extends T.$Uc{constructor(l,p,C,S,v){super(),this.c=l,this.f=p,this.g=S,this.h=v,this.b=this.B(new D.$he),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),v),this.B(this.g.watch(C.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,E=>E.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,E=>(E.isOperation(u.FileOperation.CREATE)||E.isOperation(u.FileOperation.COPY)||E.isOperation(u.FileOperation.DELETE)||E.isOperation(u.FileOperation.WRITE))&&C.isEqual(E.resource,l)))(()=>this.b.fire()))}async loadConfiguration(){try{const l=await this.g.readFile(this.c);return this.a.parse(l.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(l){return l&&(this.f=l),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Ho=c;class f{constructor(l,p,C,S,v,E,R,w,m,N,B,X,V){this.a=l,this.b=p,this.c=C,this.overrideIdentifiers=S,this.d=v,this.f=E,this.g=R,this.h=w,this.i=m,this.j=N,this.k=B,this.l=X,this.m=V}get value(){return h(this.c)}n(l){return l?.value!==void 0||l?.override!==void 0||l?.overrides!==void 0?l:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class t{constructor(l,p,C,S,v,E,R,w,m,N){this.j=l,this.l=p,this.m=C,this.n=S,this.p=v,this.q=E,this.r=R,this.s=w,this.t=m,this.u=N,this.h=null,this.i=new A.$Ac,this.v=null}getValue(l,p,C){return this.w(l,p,C).getValue(l)}updateValue(l,p,C={}){let S;C.resource?(S=this.t.get(C.resource),S||(S=r.createEmptyModel(this.u),this.t.set(C.resource,S))):S=this.s,p===void 0?S.removeValue(l):S.setValue(l,p),C.resource||(this.h=null)}inspect(l,p,C){const S=this.w(l,p,C),v=this.A(p.resource,C),E=p.resource?this.t.get(p.resource)||this.s:this.s,R=new Set;for(const w of S.overrides)for(const m of w.identifiers)S.getOverrideValue(l,m)!==void 0&&R.add(m);return new f(l,p,S.getValue(l),R.size?[...R]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,C?this.q:void 0,v||void 0,E)}keys(l){const p=this.A(void 0,l);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:p?p.keys.slice(0):[]}}updateDefaultConfiguration(l){this.j=l,this.h=null,this.i.clear()}updatePolicyConfiguration(l){this.l=l}updateApplicationConfiguration(l){this.m=l,this.h=null,this.i.clear()}updateLocalUserConfiguration(l){this.n=l,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(l){this.p=l,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(l){this.q=l,this.h=null,this.i.clear()}updateFolderConfiguration(l,p){this.r.set(l,p),this.i.delete(l)}deleteFolderConfiguration(l){this.folderConfigurations.delete(l),this.i.delete(l)}compareAndUpdateDefaultConfiguration(l,p){const C=[];if(!p){const{added:S,updated:v,removed:E}=i(this.j,l);p=[...S,...v,...E]}for(const S of p)for(const v of(0,y.$Ao)(S)){const E=this.j.getKeysForOverrideIdentifier(v),R=l.getKeysForOverrideIdentifier(v),w=[...R.filter(m=>E.indexOf(m)===-1),...E.filter(m=>R.indexOf(m)===-1),...E.filter(m=>!M.$bo(this.j.override(v).getValue(m),l.override(v).getValue(m)))];C.push([v,w])}return this.updateDefaultConfiguration(l),{keys:p,overrides:C}}compareAndUpdatePolicyConfiguration(l){const{added:p,updated:C,removed:S}=i(this.l,l),v=[...p,...C,...S];return v.length&&this.updatePolicyConfiguration(l),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(l){const{added:p,updated:C,removed:S,overrides:v}=i(this.applicationConfiguration,l),E=[...p,...C,...S];return E.length&&this.updateApplicationConfiguration(l),{keys:E,overrides:v}}compareAndUpdateLocalUserConfiguration(l){const{added:p,updated:C,removed:S,overrides:v}=i(this.localUserConfiguration,l),E=[...p,...C,...S];return E.length&&this.updateLocalUserConfiguration(l),{keys:E,overrides:v}}compareAndUpdateRemoteUserConfiguration(l){const{added:p,updated:C,removed:S,overrides:v}=i(this.remoteUserConfiguration,l),E=[...p,...C,...S];return E.length&&this.updateRemoteUserConfiguration(l),{keys:E,overrides:v}}compareAndUpdateWorkspaceConfiguration(l){const{added:p,updated:C,removed:S,overrides:v}=i(this.workspaceConfiguration,l),E=[...p,...C,...S];return E.length&&this.updateWorkspaceConfiguration(l),{keys:E,overrides:v}}compareAndUpdateFolderConfiguration(l,p){const C=this.folderConfigurations.get(l),{added:S,updated:v,removed:E,overrides:R}=i(C,p),w=[...S,...v,...E];return(w.length||!C)&&this.updateFolderConfiguration(l,p),{keys:w,overrides:R}}compareAndDeleteFolderConfiguration(l){const p=this.folderConfigurations.get(l);if(!p)throw new Error("Unknown folder");this.deleteFolderConfiguration(l);const{added:C,updated:S,removed:v,overrides:E}=i(p,void 0);return{keys:[...C,...S,...v],overrides:E}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(l,p,C){let S=this.x(p,C);return p.overrideIdentifier&&(S=S.override(p.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(l)!==void 0&&(S=S.merge(this.l)),S}x({resource:l},p){let C=this.y();if(p&&l){const S=p.getFolder(l);S&&(C=this.z(S.uri)||C);const v=this.t.get(l);v&&(C=C.merge(v))}return C}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(l){let p=this.i.get(l);if(!p){const C=this.y(),S=this.r.get(l);S?(p=C.merge(S),this.i.set(l,p)):p=C}return p}A(l,p){if(p&&l){const C=p.getFolder(l);if(C)return this.r.get(C.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((l,p)=>{const{contents:C,overrides:S,keys:v}=this.r.get(p);return l.push([p,{contents:C,overrides:S,keys:v}]),l},[])}}allKeys(){const l=new Set;return this.j.keys.forEach(p=>l.add(p)),this.userConfiguration.keys.forEach(p=>l.add(p)),this.q.keys.forEach(p=>l.add(p)),this.r.forEach(p=>p.keys.forEach(C=>l.add(C))),[...l.values()]}B(){const l=new Set;return this.j.getAllOverrideIdentifiers().forEach(p=>l.add(p)),this.userConfiguration.getAllOverrideIdentifiers().forEach(p=>l.add(p)),this.q.getAllOverrideIdentifiers().forEach(p=>l.add(p)),this.r.forEach(p=>p.getAllOverrideIdentifiers().forEach(C=>l.add(C))),[...l.values()]}D(l){const p=new Set;return this.j.getKeysForOverrideIdentifier(l).forEach(C=>p.add(C)),this.userConfiguration.getKeysForOverrideIdentifier(l).forEach(C=>p.add(C)),this.q.getKeysForOverrideIdentifier(l).forEach(C=>p.add(C)),this.r.forEach(C=>C.getKeysForOverrideIdentifier(l).forEach(S=>p.add(S))),[...p.values()]}static parse(l,p){const C=this.E(l.defaults,p),S=this.E(l.policy,p),v=this.E(l.application,p),E=this.E(l.user,p),R=this.E(l.workspace,p),w=l.folders.reduce((m,N)=>(m.set(a.URI.revive(N[0]),this.E(N[1],p)),m),new A.$Ac);return new t(C,S,v,E,r.createEmptyModel(p),R,w,r.createEmptyModel(p),new A.$Ac,p)}static E(l,p){return new r(l.contents,l.keys,l.overrides,void 0,p)}}e.$Io=t;function s(...d){if(d.length===0)return{keys:[],overrides:[]};if(d.length===1)return d[0];const l=new Set,p=new Map;for(const S of d)S.keys.forEach(v=>l.add(v)),S.overrides.forEach(([v,E])=>{const R=(0,A.$xc)(p,v,new Set);E.forEach(w=>R.add(w))});const C=[];return p.forEach((S,v)=>C.push([v,[...S.values()]])),{keys:[...l.values()],overrides:C}}class n{constructor(l,p,C,S,v){this.change=l,this.f=p,this.g=C,this.h=S,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const E of l.keys)this.affectedKeys.add(E);for(const[,E]of l.overrides)for(const R of E)this.affectedKeys.add(R);this.d=this.a;for(const E of this.affectedKeys)this.d+=E+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=t.parse(this.f.data,this.i)),this.j}affectsConfiguration(l,p){const C=this.a+l,S=this.d.indexOf(C);if(S<0)return!1;const v=S+C.length;if(v>=this.d.length)return!1;const E=this.d.charCodeAt(v);if(E!==this.b&&E!==this.c)return!1;if(p){const R=this.previousConfiguration?this.previousConfiguration.getValue(l,p,this.f?.workspace):void 0,w=this.g.getValue(l,p,this.h);return!M.$bo(R,w)}return!0}}e.$Ko=n;function i(d,l){const{added:p,removed:C,updated:S}=g(l?.rawConfiguration,d?.rawConfiguration),v=[],E=d?.getAllOverrideIdentifiers()||[],R=l?.getAllOverrideIdentifiers()||[];if(l){const w=R.filter(m=>!E.includes(m));for(const m of w)v.push([m,l.getKeysForOverrideIdentifier(m)])}if(d){const w=E.filter(m=>!R.includes(m));for(const m of w)v.push([m,d.getKeysForOverrideIdentifier(m)])}if(l&&d){for(const w of E)if(R.includes(w)){const m=g({contents:d.getOverrideValue(void 0,w)||{},keys:d.getKeysForOverrideIdentifier(w)},{contents:l.getOverrideValue(void 0,w)||{},keys:l.getKeysForOverrideIdentifier(w)});v.push([w,[...m.added,...m.removed,...m.updated]])}}return{added:p,removed:C,updated:S,overrides:v}}function g(d,l){const p=d?l?d.keys.filter(v=>l.keys.indexOf(v)===-1):[...d.keys]:[],C=l?d?l.keys.filter(v=>d.keys.indexOf(v)===-1):[...l.keys]:[],S=[];if(d&&l){for(const v of l.keys)if(d.keys.indexOf(v)!==-1){const E=(0,P.$cj)(l.contents,v),R=(0,P.$cj)(d.contents,v);M.$bo(E,R)||S.push(v)}}return{added:p,removed:C,updated:S}}}),define(Ce[108],Ie([1,0,14,3]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.RemoteAuthorityResolverErrorCode=e.$Nl=e.$Ml=e.RemoteConnectionType=e.$Ll=void 0,e.$Pl=a,e.$Ll=(0,D.$Ai)("remoteAuthorityResolverService");var I;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class T{constructor(y){this.id=y,this.type=I.Managed}toString(){return`Managed(${this.id})`}}e.$Ml=T;class A{constructor(y,u){this.host=y,this.port=u,this.type=I.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Nl=A;var M;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(M||(e.RemoteAuthorityResolverErrorCode=M={}));class $ extends b.$bb{static isNotAvailable(y){return y instanceof $&&y._code===M.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof $&&y._code===M.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof $&&y._code===M.NoResolverFound}static isInvalidAuthority(y){return y instanceof $&&y._code===M.InvalidAuthority}static isHandled(y){return y instanceof $&&y.isHandled}constructor(y,u=M.Unknown,k){super(y),this._message=y,this._code=u,this._detail=k,this.isHandled=u===M.NotAvailable&&k===!0,Object.setPrototypeOf(this,$.prototype)}}e.$Ol=$;function a(P){const y=P.indexOf("+");return y===-1?P:P.substring(0,y)}}),define(Ce[62],Ie([1,0,16]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nm=D,e.$Om=I,e.$Pm=T,e.$Qm=A;function D($){return $.scheme===b.Schemas.vscodeRemote?$.authority:void 0}function I($){if(!$)return;const a=$.indexOf("+");return a<0?$:$.substr(0,a)}function T($){const{host:a,port:P}=M($);if(typeof P>"u")throw new Error(`Invalid remote authority: ${$}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:P}}function A($,a){let{host:P,port:y}=M($);return typeof y>"u"&&(y=a),{host:P,port:y}}function M($){const a=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const P=$.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const y=$.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:$,port:void 0}}}),define(Ce[19],Ie([1,0,13,3,62]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$Zm=e.$Ym=e.$Xm=e.TargetPlatform=e.ExtensionType=e.$Wm=e.$Um=e.$Tm=e.$Sm=e.$Rm=void 0,e.$Vm=T,e.$1m=y,e.$2m=u,e.$3m=k,e.$4m=h,e.$Rm="extensions.user.cache",e.$Sm="extensions.builtin.cache",e.$Tm="undefined_publisher",e.$Um=["ui","workspace","web"];function T(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$Wm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A||(e.ExtensionType=A={}));var M;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(M||(e.TargetPlatform=M={}));class ${constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,c){if(typeof o>"u"||o===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof o=="string"||typeof c=="string"){const f=typeof o=="string"?o:o.value,t=typeof c=="string"?c:c.value;return b.$Bf(f,t)}return o._lower===c._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Xm=$;class a{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const c of o)this.add(c)}add(o){this.c.add($.toKey(o))}delete(o){return this.c.delete($.toKey(o))}has(o){return this.c.has($.toKey(o))}}e.$Ym=a;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete($.toKey(o))}get(o){return this.c.get($.toKey(o))}has(o){return this.c.has($.toKey(o))}set(o,c){this.c.set($.toKey(o),c)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Zm=P;function y(r){return u(r)}function u(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}function k(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}function h(r,o){if(o){const c=`onResolveRemoteAuthority:${(0,I.$Om)(o)}`;return!!r.activationEvents?.includes(c)}return!1}e.$5m=(0,D.$Ai)("IBuiltinExtensionsScannerService")}),define(Ce[109],Ie([1,0,21,170,19,3]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.ExtensionManagementErrorCode=e.$dp=e.ExtensionGalleryErrorCode=e.$cp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=void 0,e.$9o=M,e.$0o=$,e.$$o=a,e.$_o=P,e.$ap=y,e.$bp=u,e.$2o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$3o=new RegExp(e.$2o),e.$4o="__web_extension",e.$5o="skipWalkthrough",e.$6o="extensionInstallSource",e.$7o="dependecyOrPackExtensionInstall",e.$8o="clientTargetPlatform";var A;(function(n){n.COMMAND="command",n.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function M(n){switch(n){case I.TargetPlatform.WIN32_X64:return"Windows 64 bit";case I.TargetPlatform.WIN32_ARM64:return"Windows ARM";case I.TargetPlatform.LINUX_X64:return"Linux 64 bit";case I.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case I.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case I.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case I.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case I.TargetPlatform.DARWIN_X64:return"Mac";case I.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case I.TargetPlatform.WEB:return"Web";case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;case I.TargetPlatform.UNKNOWN:return I.TargetPlatform.UNKNOWN;case I.TargetPlatform.UNDEFINED:return I.TargetPlatform.UNDEFINED}}function $(n){switch(n){case I.TargetPlatform.WIN32_X64:return I.TargetPlatform.WIN32_X64;case I.TargetPlatform.WIN32_ARM64:return I.TargetPlatform.WIN32_ARM64;case I.TargetPlatform.LINUX_X64:return I.TargetPlatform.LINUX_X64;case I.TargetPlatform.LINUX_ARM64:return I.TargetPlatform.LINUX_ARM64;case I.TargetPlatform.LINUX_ARMHF:return I.TargetPlatform.LINUX_ARMHF;case I.TargetPlatform.ALPINE_X64:return I.TargetPlatform.ALPINE_X64;case I.TargetPlatform.ALPINE_ARM64:return I.TargetPlatform.ALPINE_ARM64;case I.TargetPlatform.DARWIN_X64:return I.TargetPlatform.DARWIN_X64;case I.TargetPlatform.DARWIN_ARM64:return I.TargetPlatform.DARWIN_ARM64;case I.TargetPlatform.WEB:return I.TargetPlatform.WEB;case I.TargetPlatform.UNIVERSAL:return I.TargetPlatform.UNIVERSAL;default:return I.TargetPlatform.UNKNOWN}}function a(n,i){switch(n){case b.Platform.Windows:return i==="x64"?I.TargetPlatform.WIN32_X64:i==="arm64"?I.TargetPlatform.WIN32_ARM64:I.TargetPlatform.UNKNOWN;case b.Platform.Linux:return i==="x64"?I.TargetPlatform.LINUX_X64:i==="arm64"?I.TargetPlatform.LINUX_ARM64:i==="arm"?I.TargetPlatform.LINUX_ARMHF:I.TargetPlatform.UNKNOWN;case"alpine":return i==="x64"?I.TargetPlatform.ALPINE_X64:i==="arm64"?I.TargetPlatform.ALPINE_ARM64:I.TargetPlatform.UNKNOWN;case b.Platform.Mac:return i==="x64"?I.TargetPlatform.DARWIN_X64:i==="arm64"?I.TargetPlatform.DARWIN_ARM64:I.TargetPlatform.UNKNOWN;case b.Platform.Web:return I.TargetPlatform.WEB}}function P(n,i){return i===I.TargetPlatform.WEB&&!n.includes(I.TargetPlatform.WEB)}function y(n,i,g){return P(i,g)?!1:n===I.TargetPlatform.UNDEFINED||n===I.TargetPlatform.UNIVERSAL?!0:n===I.TargetPlatform.UNKNOWN?!1:n===g}function u(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}var k;(function(n){n[n.NoneOrRelevance=0]="NoneOrRelevance",n[n.LastUpdatedDate=1]="LastUpdatedDate",n[n.Title=2]="Title",n[n.PublisherName=3]="PublisherName",n[n.InstallCount=4]="InstallCount",n[n.PublishedDate=10]="PublishedDate",n[n.AverageRating=6]="AverageRating",n[n.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var h;(function(n){n[n.Default=0]="Default",n[n.Ascending=1]="Ascending",n[n.Descending=2]="Descending"})(h||(e.SortOrder=h={}));var r;(function(n){n.Install="install",n.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var o;(function(n){n[n.None=1]="None",n[n.Install=2]="Install",n[n.Update=3]="Update",n[n.Migrate=4]="Migrate"})(o||(e.InstallOperation=o={})),e.$cp=(0,T.$Ai)("extensionGalleryService");var c;(function(n){n.Timeout="Timeout",n.Cancelled="Cancelled",n.Failed="Failed",n.DownloadFailedWriting="DownloadFailedWriting"})(c||(e.ExtensionGalleryErrorCode=c={}));class f extends Error{constructor(i,g){super(i),this.code=g,this.name=g}}e.$dp=f;var t;(function(n){n.Unsupported="Unsupported",n.Deprecated="Deprecated",n.Malicious="Malicious",n.Incompatible="Incompatible",n.IncompatibleTargetPlatform="IncompatibleTargetPlatform",n.ReleaseVersionNotFound="ReleaseVersionNotFound",n.Invalid="Invalid",n.Download="Download",n.DownloadSignature="DownloadSignature",n.DownloadFailedWriting="DownloadFailedWriting",n.UpdateMetadata="UpdateMetadata",n.Extract="Extract",n.Scanning="Scanning",n.ScanningExtension="ScanningExtension",n.ReadUninstalled="ReadUninstalled",n.UnsetUninstalled="UnsetUninstalled",n.Delete="Delete",n.Rename="Rename",n.IntializeDefaultProfile="IntializeDefaultProfile",n.AddToProfile="AddToProfile",n.InstalledExtensionNotFound="InstalledExtensionNotFound",n.PostInstall="PostInstall",n.CorruptZip="CorruptZip",n.IncompleteZip="IncompleteZip",n.Signature="Signature",n.NotAllowed="NotAllowed",n.Gallery="Gallery",n.Cancelled="Cancelled",n.Unknown="Unknown",n.Internal="Internal"})(t||(e.ExtensionManagementErrorCode=t={}));class s extends Error{constructor(i,g){super(i),this.code=g,this.name=g}}e.$ep=s,e.$fp=(0,T.$Ai)("extensionManagementService"),e.$gp="extensionsIdentifiers/disabled",e.$hp="extensionsIdentifiers/enabled",e.$ip=(0,T.$Ai)("IGlobalExtensionEnablementService"),e.$jp=(0,T.$Ai)("IExtensionTipsService"),e.$kp=(0,D.localize2)(0,"Extensions"),e.$lp=(0,D.localize2)(1,"Preferences")}),define(Ce[110],Ie([1,0,14,19]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AG=e.$zG=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(A,M){this.a.set(A,M)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const M=Object.create(null);for(const $ of A){const a=this.readActivationEvents($);a.length>0&&(M[D.$Xm.toKey($.identifier)]=a)}return M}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const M=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let $=0;$<M.length;$++)M[$]==="onUri"&&(M[$]=`onUri:${D.$Xm.toKey(A.identifier)}`);if(!A.contributes)return M;for(const $ in A.contributes){const a=this.a.get($);if(!a)continue;const P=A.contributes[$],y=Array.isArray(P)?P:[P];try{a(y,M)}catch(u){(0,b.$1)(u)}}return M}}e.$zG=I,e.$AG=new I}),define(Ce[215],Ie([1,0,23,14,6,175,54,3,12,31]),function(_,e,b,D,I,T,A,M,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=void 0,e.$Yp=u,e.$Zp=k,e.$1p=h,e.$2p=r,e.$3p=o,e.$4p=c,e.$Wp=(0,M.$Ai)("requestService");class P{constructor(n){this.b=n}toJSON(){if(!this.a){const n=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?n[i]="*****":n[i]=this.b[i];this.a=n}return this.a}}class y extends I.$Uc{constructor(n){super(),this.b=0,this.a=n.createLogger("network",{name:(0,T.localize)(0,null),when:$.$mk.isEqualTo((0,$.$jk)($.LogLevel.Trace)).serialize()})}async c(n,i,g){const d=`${n} #${++this.b}: ${i.url}`;this.a.trace(`${d} - begin`,i.type,new P(i.headers??{}));try{const l=await g();return this.a.trace(`${d} - end`,i.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${d} - error`,i.type,(0,D.$0)(l)),l}}}e.$Xp=y;function u(s){return s.res.statusCode&&s.res.statusCode>=200&&s.res.statusCode<300||s.res.statusCode===1223}function k(s){return s.res.statusCode===204}async function h(s){return k(s)?null:(await(0,b.$Ve)(s.stream)).toString()}async function r(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);return h(s)}async function o(s){if(!u(s))throw new Error("Server returned "+s.res.statusCode);if(k(s))return null;const i=(await(0,b.$Ve)(s.stream)).toString();try{return JSON.parse(i)}catch(g){throw g.message+=`:
`+i,g}}function c(s){t(s)}let f;function t(s){const n=a.$ko.as(A.$po.Configuration),i=f;f={id:"http",order:15,title:(0,T.localize)(1,null),type:"object",scope:s,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(6,null),(0,T.localize)(7,null),(0,T.localize)(8,null),(0,T.localize)(9,null)],default:"override",description:(0,T.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(12,null),restricted:!0}}},n.updateConfigurations({add:[f],remove:i?[i]:[]})}t(A.ConfigurationScope.APPLICATION)}),define(Ce[216],Ie([1,0,21,79,37]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mp=A,e.$np=M;function T($){if(b.$o===b.Platform.Linux&&/^penguin(\.|$)/i.test($))return"chromebook"}function A($,a,P,y,u,k,h,r,o,c){const f=Object.create(null);f["common.machineId"]=k,f["common.sqmId"]=h,f["common.devDeviceId"]=r,f.sessionID=(0,I.$Wg)()+Date.now(),f.commitHash=y,f.version=u,f["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,b.$b)(b.$o),f["common.nodePlatform"]=D.$dc,f["common.nodeArch"]=P,f["common.product"]=c||"desktop",o&&(f["common.msftInternal"]=o);let t=0;const s=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>t++,enumerable:!0}}),b.$f&&(f["common.snap"]="true");const n=T(a);return n&&(f["common.platformDetail"]=n),f}function M($){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const P=a.toLowerCase();return $.some(y=>P===y)}}),define(Ce[111],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=void 0,e.$6l=(0,b.$Ai)("telemetryService"),e.$7l=(0,b.$Ai)("customEndpointTelemetryService"),e.$8l="telemetry.currentSessionDate",e.$9l="telemetry.firstSessionDate",e.$0l="telemetry.lastSessionDate",e.$$l="telemetry.machineId",e.$_l="telemetry.sqmId",e.$am="telemetry.devDeviceId",e.$bm="telemetry",e.$cm="telemetry.telemetryLevel",e.$dm="telemetry.enableCrashReporter",e.$em="telemetry.enableTelemetry";var D;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var I;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ce[63],Ie([1,0,26,15,62,216,111]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=void 0,e.$vp=P,e.$wp=y,e.$xp=u,e.$yp=k,e.$zp=r,e.$Ap=c,e.$Bp=f,e.$Cp=n;class M{constructor(g){this.value=g,this.isTrustedTelemetryValue=!0}}e.$op=M;class ${constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$pp=$,e.$qp=new $;class a{async publicLog(g,d,l){}async publicLogError(g,d,l){}}e.$rp=a,e.$sp="telemetry",e.$tp="extensionTelemetryLog",e.$up={log:()=>null,flush:()=>Promise.resolve(null)};function P(i,g){return!g.isBuilt&&!g.disableTelemetry?!0:!(g.disableTelemetry||!i.enableTelemetry)}function y(i,g){return g.extensionTestsLocationURI?!0:!(g.isBuilt||g.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function u(i){const g=i.getValue(A.$cm),d=i.getValue(A.$dm);if(i.getValue(A.$em)===!1||d===!1)return A.TelemetryLevel.NONE;switch(g??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function k(i){const g={},d={},l={};o(i,l);for(let p in l){p=p.length>150?p.substr(p.length-149):p;const C=l[p];typeof C=="number"?d[p]=C:typeof C=="boolean"?d[p]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${p} has been trimmed to 8192, the original length is ${C.length}`),g[p]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(g[p]=C)}return{properties:g,measurements:d}}const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(i){if(!i)return"none";const g=(0,I.$Om)(i);return h.has(g)?g:"other"}function o(i,g,d=0,l){if(i)for(const p of Object.getOwnPropertyNames(i)){const C=i[p],S=l?l+p:p;Array.isArray(C)?g[S]=(0,b.$co)(C):C instanceof Date?g[S]=C.toISOString():(0,D.$cg)(C)?d<2?o(C,g,d+1,S+"."):g[S]=(0,b.$co)(C):g[S]=C}}function c(i,g){const d=i.msftInternalDomains||[],l=g.getValue("telemetry.internalTesting");return(0,T.$np)(d)||l}function f(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function t(i,g){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let d=i;const l=[];for(const v of g)for(;;){const E=v.exec(i);if(!E)break;l.push([E.index,v.lastIndex])}const p=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(d="";;){const v=C.exec(i);if(!v)break;const E=l.some(([R,w])=>v.index<w&&R<C.lastIndex);!p.test(v[0])&&!E&&(d+=i.substring(S,v.index)+"<REDACTED: user-file-path>",S=C.lastIndex)}return S<i.length&&(d+=i.substr(S)),d}function s(i){if(!i)return i;const g=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const d of g)if(d.regex.test(i))return`<REDACTED: ${d.label}>`;return i}function n(i,g){return(0,b.$_n)(i,d=>{if(d instanceof M||Object.hasOwnProperty.call(d,"isTrustedTelemetryValue"))return d.value;if(typeof d=="string"){let l=d.replaceAll("%20"," ");l=t(l,g);for(const p of g)l=l.replace(p,"");return l=s(l),l}})}}),define(Ce[217],Ie([1,0,13,109,19,21,2,14,79,63]),function(_,e,b,D,I,T,A,M,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Ep=void 0,e.$Dp=P,e.$Fp=h,e.$Gp=r,e.$Hp=o,e.$Ip=c,e.$Jp=f,e.$Kp=t,e.$Lp=s,e.$Np=n,e.$Op=g;function P(d,l){return d.uuid&&l.uuid?d.uuid===l.uuid:d.id===l.id?!0:(0,b.$wf)(d.id,l.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class u{static create(l){const p=l.manifest?l.manifest.version:l.version,C=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new u(l.identifier,p,C)}static parse(l){const p=y.exec(l);return p&&p[1]&&p[2]?new u({id:p[1]},p[2],p[4]||void 0):null}constructor(l,p,C=I.TargetPlatform.UNDEFINED){this.identifier=l,this.version=p,this.targetPlatform=C,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==I.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof u?P(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$Ep=u;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function h(d){const l=k.exec(d);return l&&l[1]?[o(l[1]),l[2]]:[o(d),void 0]}function r(d,l){return`${d}.${l}`}function o(d){return d.toLowerCase()}function c(d,l){return o(r(d??I.$Tm,l))}function f(d,l){const p=[],C=S=>{for(const v of p)if(v.some(E=>P(l(E),l(S))))return v;return null};for(const S of d){const v=C(S);v?v.push(S):p.push([S])}return p}function t(d){return{id:d.identifier.id,name:d.manifest.name,galleryId:null,publisherId:d.publisherId,publisherName:d.manifest.publisher,publisherDisplayName:d.publisherDisplayName,dependencies:d.manifest.extensionDependencies&&d.manifest.extensionDependencies.length>0}}function s(d){return{id:new a.$op(d.identifier.id),name:new a.$op(d.name),version:d.version,galleryId:d.identifier.uuid,publisherId:d.publisherId,publisherName:d.publisher,publisherDisplayName:d.publisherDisplayName,isPreReleaseVersion:d.properties.isPreReleaseVersion,dependencies:!!(d.properties.dependencies&&d.properties.dependencies.length>0),isSigned:d.isSigned,...d.telemetryData}}e.$Mp=new I.$Xm("pprice.better-merge");function n(d,l){const p=[],C=l.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const S=C.shift();if(S&&p.every(v=>!P(v.identifier,{id:S}))){const v=d.filter(E=>P(E.identifier,{id:S}));v.length===1&&(p.push(v[0]),C.push(...v[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}async function i(d,l){if(!T.$e)return!1;let p;try{p=(await d.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{p=(await d.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){l.debug("Error while getting the os-release file.",(0,M.$0)(S))}}return!!p&&(p.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function g(d,l){const p=await i(d,l),C=(0,D.$$o)(p?"alpine":T.$o,$.$ec);return l.debug("ComputeTargetPlatform:",C),C}}),define(Ce[218],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=b,e.$vs=D,e.$ws=I,e.$xs=T,e.$ys=A,e.$zs=M;function b($){return[...$.entries()]}function D($){return $?[...$.entries()]:[]}function I($){return new Map($)}function T($){return new Map($??[])}function A($){return Array.from($.entries()).map(a=>[a[0],b(a[1].map),D(a[1].descriptionMap)])}function M($){return new Map($.map(a=>[a[0],{map:I(a[1]),descriptionMap:T(a[2])}]))}}),define(Ce[219],Ie([1,0,3,32,31]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$es=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ds=void 0,e.$ds=new D.$Rj("terminalTabFocusMode",!1,!0);var T;(function(n){n.AutomationProfile="terminal.integrated.automationProfile.",n.DefaultProfile="terminal.integrated.defaultProfile.",n.Profiles="terminal.integrated.profiles."})(T||(e.TerminalSettingPrefix=T={}));var A;(function(n){n.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",n.AutomationProfileLinux="terminal.integrated.automationProfile.linux",n.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",n.AutomationProfileWindows="terminal.integrated.automationProfile.windows",n.ProfilesWindows="terminal.integrated.profiles.windows",n.ProfilesMacOs="terminal.integrated.profiles.osx",n.ProfilesLinux="terminal.integrated.profiles.linux",n.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",n.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",n.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",n.UseWslProfiles="terminal.integrated.useWslProfiles",n.TabsDefaultColor="terminal.integrated.tabs.defaultColor",n.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",n.TabsEnabled="terminal.integrated.tabs.enabled",n.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",n.TabsHideCondition="terminal.integrated.tabs.hideCondition",n.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",n.TabsShowActions="terminal.integrated.tabs.showActions",n.TabsLocation="terminal.integrated.tabs.location",n.TabsFocusMode="terminal.integrated.tabs.focusMode",n.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",n.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",n.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",n.CopyOnSelection="terminal.integrated.copyOnSelection",n.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",n.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",n.FontFamily="terminal.integrated.fontFamily",n.FontSize="terminal.integrated.fontSize",n.LetterSpacing="terminal.integrated.letterSpacing",n.LineHeight="terminal.integrated.lineHeight",n.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",n.TabStopWidth="terminal.integrated.tabStopWidth",n.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",n.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",n.BellDuration="terminal.integrated.bellDuration",n.FontWeight="terminal.integrated.fontWeight",n.FontWeightBold="terminal.integrated.fontWeightBold",n.CursorBlinking="terminal.integrated.cursorBlinking",n.CursorStyle="terminal.integrated.cursorStyle",n.CursorStyleInactive="terminal.integrated.cursorStyleInactive",n.CursorWidth="terminal.integrated.cursorWidth",n.Scrollback="terminal.integrated.scrollback",n.DetectLocale="terminal.integrated.detectLocale",n.DefaultLocation="terminal.integrated.defaultLocation",n.GpuAcceleration="terminal.integrated.gpuAcceleration",n.TerminalTitleSeparator="terminal.integrated.tabs.separator",n.TerminalTitle="terminal.integrated.tabs.title",n.TerminalDescription="terminal.integrated.tabs.description",n.RightClickBehavior="terminal.integrated.rightClickBehavior",n.MiddleClickBehavior="terminal.integrated.middleClickBehavior",n.Cwd="terminal.integrated.cwd",n.ConfirmOnExit="terminal.integrated.confirmOnExit",n.ConfirmOnKill="terminal.integrated.confirmOnKill",n.EnableBell="terminal.integrated.enableBell",n.EnableVisualBell="terminal.integrated.enableVisualBell",n.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",n.AllowChords="terminal.integrated.allowChords",n.AllowMnemonics="terminal.integrated.allowMnemonics",n.TabFocusMode="terminal.integrated.tabFocusMode",n.EnvMacOs="terminal.integrated.env.osx",n.EnvLinux="terminal.integrated.env.linux",n.EnvWindows="terminal.integrated.env.windows",n.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",n.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",n.ShowExitAlert="terminal.integrated.showExitAlert",n.SplitCwd="terminal.integrated.splitCwd",n.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",n.WordSeparators="terminal.integrated.wordSeparators",n.EnableFileLinks="terminal.integrated.enableFileLinks",n.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",n.UnicodeVersion="terminal.integrated.unicodeVersion",n.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",n.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",n.HideOnStartup="terminal.integrated.hideOnStartup",n.CustomGlyphs="terminal.integrated.customGlyphs",n.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",n.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",n.InheritEnv="terminal.integrated.inheritEnv",n.ShowLinkHover="terminal.integrated.showLinkHover",n.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",n.AutoReplies="terminal.integrated.autoReplies",n.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",n.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",n.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",n.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",n.EnableImages="terminal.integrated.enableImages",n.SmoothScrolling="terminal.integrated.smoothScrolling",n.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",n.FocusAfterRun="terminal.integrated.focusAfterRun",n.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",n.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",n.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var M;(function(n){n.PowerShell="pwsh",n.Bash="bash",n.Fish="fish",n.Sh="sh",n.Csh="csh",n.Ksh="ksh",n.Zsh="zsh",n.Python="python"})(M||(e.PosixShellType=M={}));var $;(function(n){n.CommandPrompt="cmd",n.PowerShell="pwsh",n.Wsl="wsl",n.GitBash="gitbash",n.Python="python"})($||(e.WindowsShellType=$={}));var a;(function(n){n[n.Api=0]="Api",n[n.Process=1]="Process",n[n.Sequence=2]="Sequence",n[n.Config=3]="Config"})(a||(e.TitleEventSource=a={}));var P;(function(n){n.LocalPty="localPty",n.PtyHost="ptyHost",n.PtyHostWindow="ptyHostWindow",n.Logger="logger",n.Heartbeat="heartbeat"})(P||(e.TerminalIpcChannels=P={}));var y;(function(n){n.Cwd="cwd",n.InitialCwd="initialCwd",n.FixedDimensions="fixedDimensions",n.Title="title",n.ShellType="shellType",n.HasChildProcesses="hasChildProcesses",n.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",n.OverrideDimensions="overrideDimensions",n.FailedShellIntegrationActivation="failedShellIntegrationActivation",n.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$es=(0,b.$Ai)("ptyService");var u;(function(n){n[n.BeatInterval=5e3]="BeatInterval",n[n.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",n[n.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",n[n.SecondWaitMultiplier=1]="SecondWaitMultiplier",n[n.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(u||(e.HeartbeatConstants=u={}));var k;(function(n){n[n.Panel=1]="Panel",n[n.Editor=2]="Editor"})(k||(e.TerminalLocation=k={}));var h;(function(n){n.TerminalView="view",n.Editor="editor"})(h||(e.TerminalLocationString=h={}));var r;(function(n){n[n.GraceTime=6e4]="GraceTime",n[n.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var o;(function(n){n[n.HighWatermarkChars=1e5]="HighWatermarkChars",n[n.LowWatermarkChars=5e3]="LowWatermarkChars",n[n.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var c;(function(n){n.GitBash="Git Bash",n.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var f;(function(n){n[n.Off=0]="Off",n[n.FinalTerm=1]="FinalTerm",n[n.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var t;(function(n){n[n.Unknown=0]="Unknown",n[n.Shutdown=1]="Shutdown",n[n.Process=2]="Process",n[n.User=3]="User",n[n.Extension=4]="Extension"})(t||(e.TerminalExitReason=t={})),e.$fs={Backend:"workbench.contributions.terminal.processBackend"};class s{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const g=this.b(i.remoteAuthority);if(this.a.has(g))throw new Error(`A terminal backend with remote authority '${g}' was already registered.`);this.a.set(g,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}I.$ko.add(e.$fs.Backend,new s),e.$gs=(0,b.$Ai)("localPtyService"),e.$hs=(0,b.$Ai)("terminalLogService")}),define(Ce[220],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bwb=void 0;class b{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,T,A=5){const M=T($=>{const a=typeof $=="string"?$:$.data;let P=this.a.get(I);if(P){P.data.push(a);return}const y=setTimeout(()=>this.flushBuffer(I),A);P={data:[a],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(I),M.dispose()}},this.a.set(I,P)});return M}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const T=this.a.get(I);T&&(this.a.delete(I),this.b(I,T.data.join("")))}}e.$bwb=b}),define(Ce[221],Ie([1,0,11,97,323,34,4,15,2,176,78,31]),function(_,e,b,D,I,T,A,M,$,a,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wx=e.$vx=e.$ux=e.$tx=e.$sx=e.$rx=e.IconFontDefinition=e.IconContribution=e.$ox=void 0,e.$px=o,e.$qx=c,e.$ox={IconContribution:"base.contributions.icons"};var u;(function(n){function i(g,d){let l=g.defaults;for(;T.ThemeIcon.isThemeIcon(l);){const p=r.getIcon(l.id);if(!p)return;l=p.defaults}return l}n.getDefinition=i})(u||(e.IconContribution=u={}));var k;(function(n){function i(d){return{weight:d.weight,style:d.style,src:d.src.map(l=>({format:l.format,location:l.location.toString()}))}}n.toJSONObject=i;function g(d){const l=p=>(0,M.$ag)(p)?p:void 0;if(d&&Array.isArray(d.src)&&d.src.every(p=>(0,M.$ag)(p.format)&&(0,M.$ag)(p.location)))return{weight:l(d.weight),style:l(d.style),src:d.src.map(p=>({format:p.format,location:$.URI.parse(p.location)}))}}n.fromJSONObject=g})(k||(e.IconFontDefinition=k={}));class h{constructor(){this.a=new A.$he,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,a.localize)(0,null)},fontCharacter:{type:"string",description:(0,a.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${T.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,g,d,l){const p=this.b[i];if(p){if(d&&!p.description){p.description=d,this.d.properties[i].markdownDescription=`${d} $(${i})`;const v=this.e.enum.indexOf(i);v!==-1&&(this.e.enumDescriptions[v]=d),this.a.fire()}return p}const C={id:i,description:d,defaults:g,deprecationMessage:l};this.b[i]=C;const S={$ref:"#/definitions/icons"};return l&&(S.deprecationMessage=l),d&&(S.markdownDescription=`${d}: $(${i})`),this.d.properties[i]=S,this.e.enum.push(i),this.e.enumDescriptions.push(d||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const g=this.e.enum.indexOf(i);g!==-1&&(this.e.enum.splice(g,1),this.e.enumDescriptions.splice(g,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,g){const d=this.f[i];return d||(this.f[i]=g,this.a.fire(),g)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(p,C)=>p.id.localeCompare(C.id),g=p=>{for(;T.ThemeIcon.isThemeIcon(p.defaults);)p=this.b[p.defaults.id];return`codicon codicon-${p?p.id:""}`},d=[];d.push("| preview     | identifier                        | default codicon ID                | description"),d.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(p=>this.b[p]);for(const p of l.filter(C=>!!C.description).sort(i))d.push(`|<i class="${g(p)}"></i>|${p.id}|${T.ThemeIcon.isThemeIcon(p.defaults)?p.defaults.id:p.id}|${p.description||""}|`);d.push("| preview     | identifier                        "),d.push("| ----------- | --------------------------------- |");for(const p of l.filter(C=>!T.ThemeIcon.isThemeIcon(C.defaults)).sort(i))d.push(`|<i class="${g(p)}"></i>|${p.id}|`);return d.join(`
`)}}const r=new h;y.$ko.add(e.$ox.IconContribution,r);function o(n,i,g,d){return r.registerIcon(n,i,g,d)}function c(){return r}function f(){const n=(0,I.$Vj)();for(const i in n){const g="\\"+n[i].toString(16);r.registerIcon(i,{fontCharacter:g})}}f(),e.$rx="vscode://schemas/icons";const t=y.$ko.as(P.$lo.JSONContribution);t.registerSchema(e.$rx,r.getIconSchema());const s=new b.$Mh(()=>t.notifySchemaChanged(e.$rx),200);r.onDidChange(()=>{s.isScheduled()||s.schedule()}),e.$sx=o("widget-close",D.$Zj.close,(0,a.localize)(2,null)),e.$tx=o("goto-previous-location",D.$Zj.arrowUp,(0,a.localize)(3,null)),e.$ux=o("goto-next-location",D.$Zj.arrowDown,(0,a.localize)(4,null)),e.$vx=T.ThemeIcon.modify(D.$Zj.sync,"spin"),e.$wx=T.ThemeIcon.modify(D.$Zj.loading,"spin")}),define(Ce[222],Ie([1,0,4,21,2,42,3,12]),function(_,e,b,D,I,T,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=e.$Cw=e.$zw=e.$xw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$tw=e.$sw=void 0,e.$uw=P,e.$vw=u,e.$ww=k,e.$yw=h,e.$Aw=r,e.$Bw=o,e.$sw=(0,A.$Ai)("tunnelService"),e.$tw=(0,A.$Ai)("sharedTunnelsService");var $;(function(t){t.Http="http",t.Https="https"})($||(e.TunnelProtocol=$={}));var a;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(a||(e.TunnelPrivacyId=a={}));function P(t){return!!t.forwardPort}var y;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function u(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(s)return{address:s[1],port:+s[2]}}function k(t){if(t.scheme!=="http"&&t.scheme!=="https"||!t.query)return;const s=t.query.split("&");for(const n of s){const i=n.split("=")[1];if(/^https?:/.exec(i)){const g=u(I.URI.parse(i));if(g)return g}}}e.$xw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function h(t){return e.$xw.indexOf(t)>=0}e.$zw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function r(t){return e.$zw.indexOf(t)>=0}function o(t,s,n,i){if(n===D.OperatingSystem.Windows)return!1;if(n===D.OperatingSystem.Macintosh&&r(s)){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(i);if(g?.length===4&&parseInt(g[1])>=18)return!1}return t<1024}class c{constructor(s,n,i){this.remoteAddress=s,this.localAddress=n,this.b=i,this.a=new b.$he,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Cw=c;let f=class{constructor(s,n){this.k=s,this.l=n,this.a=new b.$he,this.onTunnelOpened=this.a.event,this.b=new b.$he,this.onTunnelClosed=this.b.event,this.c=new b.$he,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const s=this.l.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.i=s.privacyOptions,this.h=s.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const s=[],n=Array.from(this.e.values());for(const i of n){const g=Array.from(i.values());for(const d of g){const l=await d.value;l&&typeof l!="string"&&s.push(l)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:n}of s.values())await n.then(i=>typeof i!="string"?i?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,n,i,g,d){this.q(s,n,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:n,localAddress:i,privacy:g,protocol:d,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,n){(r(s)||h(s))&&(s=e.$xw[0]);const i=this.s(s,n);if(i)return++i.refcount,i.value}openTunnel(s,n,i,g,d,l=!1,p,C){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${i} on local port ${d}.`);const S=this.f??s;if(!S)return;if(n||(n="localhost"),g||(g=this.m),this.f&&this.j.has(i)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.t(S,n,i,g,d,l,p,C);return v?v.then(E=>{if(E){if(typeof E=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(n,i),E}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(n,i);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const R=this.o(E);return(E.tunnelRemoteHost!==n||E.tunnelRemotePort!==i)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),p&&E.privacy!==p&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(R),R}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}o(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const n=this.e.get(s.tunnelRemoteHost);if(n){const i=n.get(s.tunnelRemotePort);i&&(i.refcount--,await this.p(s.tunnelRemoteHost,s.tunnelRemotePort,i))}}}}async p(s,n,i){if(i.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${n}.`);const g=i.value.then(async d=>{d&&typeof d!="string"&&(await d.dispose(!0),this.b.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(n),g}}async closeTunnel(s,n){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${n} `);const i=this.e.get(s);if(i&&i.has(n)){const g=i.get(n);g.refcount=0,await this.p(s,n,g)}}q(s,n,i){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(n,{refcount:1,value:i})}async r(s,n){const i=this.e.get(s);if(i){const g=i.get(n),d=g?await g.value:void 0;(!d||typeof d=="string")&&i.delete(n),i.size===0&&this.e.delete(s)}}s(s,n){const i=[s];h(s)?(i.push(...e.$xw),i.push(...e.$zw)):r(s)&&i.push(...e.$zw);const g=i.map(d=>this.e.get(d));for(const d of g){const l=d?.get(n);if(l)return l}}canTunnel(s){return!!u(s)}u(s,n,i,g,d,l,p){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${i} on local port ${g}.`);const C=i;this.j.add(C);const S=g===void 0?i:g,v={elevationRequired:d?this.isPortPrivileged(S):!1},E={remoteAddress:{host:n,port:i},localAddressPort:g,privacy:l,public:l?l!==a.Private:void 0,protocol:p},R=s.forwardPort(E,v);return R?(this.q(n,i,R),R.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(C)})):this.j.delete(C),R}};e.$Dw=f,e.$Dw=f=Je([qe(0,M.$7j),qe(1,T.$7i)],f)}),define(Ce[223],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$El=void 0,e.$El=(0,b.$Ai)("IUriIdentityService")}),define(Ce[224],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Ew=void 0,e.$Ew=(0,b.$Ai)("editSessionIdentityService");var D;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(D||(e.EditSessionIdentityMatch=D={}))}),define(Ce[225],Ie([1,0,16]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5L=D,e.$6L=I,e.$7L=T,e.$8L=A,e.$9L=M;function D($){return $.scheme!==b.Schemas.file&&$.scheme!==b.Schemas.vscodeRemote}function I($){if($.folders.length)return $.folders.every(a=>D(a.uri))?$.folders[0].uri:void 0;if($.configuration&&D($.configuration))return $.configuration}function T($){return I($)?.scheme}function A($){return I($)?.authority}function M($){return I($)!==void 0}}),define(Ce[50],Ie([1,0,178,20,58,24,2,3,16]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Ui=e.$Ti=e.WorkbenchState=e.$Ni=e.$Mi=e.$Ji=void 0,e.$Ki=a,e.$Li=P,e.$Oi=y,e.$Pi=u,e.$Qi=k,e.$Ri=r,e.$Si=o,e.$Vi=t,e.$1i=s,e.$2i=n,e.$4i=i,e.$5i=g,e.$6i=d,e.$Ji=(0,M.$Ai)("contextService");function a(l){const p=l;return typeof p?.id=="string"&&A.URI.isUri(p.uri)}function P(l){return typeof l?.id=="string"&&!a(l)&&!u(l)}e.$Mi={id:"ext-dev"},e.$Ni={id:"empty-window"};function y(l,p){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,D.$nc)(l)}:p?e.$Mi:e.$Ni;const C=l;return C.configuration?{id:C.id,configPath:C.configuration}:C.folders.length===1?{id:C.id,uri:C.folders[0].uri}:{id:C.id}}function u(l){const p=l;return typeof p?.id=="string"&&A.URI.isUri(p.configPath)}function k(l){const p=l;if(p?.uri)return{id:p.id,uri:A.URI.revive(p.uri)};const C=l;if(C?.configPath)return{id:C.id,configPath:A.URI.revive(C.configPath)};if(l?.id)return{id:l.id}}var h;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(h||(e.WorkbenchState=h={}));function r(l){const p=l;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}function o(l){const p=l;return!!(p&&typeof p=="object"&&A.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}class c{constructor(p,C,S,v,E){this.h=p,this.j=S,this.k=v,this.l=E,this.c=I.$Gi.forUris(this.l,()=>!0),this.folders=C}update(p){this.h=p.id,this.k=p.configuration,this.j=p.transient,this.l=p.l,this.folders=p.folders}get folders(){return this.g}set folders(p){this.g=p,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(p){this.k=p}getFolder(p){return p&&this.c.findSubstr(p)||null}n(){this.c=I.$Gi.forUris(this.l,()=>!0);for(const p of this.folders)this.c.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ti=c;class f{constructor(p,C){this.raw=C,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,T.$bh)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Ui=f;function t(l){return new f({uri:l,index:0,name:(0,T.$0g)(l)},{uri:l.toString()})}e.$Wi="code-workspace",e.$Xi=`.${e.$Wi}`,e.$Yi=[{name:(0,b.localize)(0,null),extensions:[e.$Wi]}],e.$Zi="workspace.json";function s(l,p){return T.$5g.isEqualOrParent(l,p.untitledWorkspacesHome)}function n(l){let p;return A.URI.isUri(l)?p=l:p=l.configuration,p?.scheme===$.Schemas.tmp}e.$3i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(l){return l.id===e.$3i}function g(l,p){return!s(l,p)&&!n(l)}function d(l){return(typeof l=="string"?(0,D.$oc)(l):(0,T.$_g)(l))===e.$Xi}}),define(Ce[112],Ie([1,0,76,4,6,24,2,177,105,30,3,12,50,29,223,11,37,13,15]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.$Gl=e.ProfileResourceType=void 0,e.$Fl=s,e.$Hl=n,e.$Il=i;var t;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(t||(e.ProfileResourceType=t={}));function s(l){const p=l;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&typeof p.isDefault=="boolean"&&typeof p.name=="string"&&A.URI.isUri(p.location)&&A.URI.isUri(p.globalStorageHome)&&A.URI.isUri(p.settingsResource)&&A.URI.isUri(p.keybindingsResource)&&A.URI.isUri(p.tasksResource)&&A.URI.isUri(p.snippetsHome)&&A.URI.isUri(p.extensionsResource))}e.$Gl=(0,P.$Ai)("IUserDataProfilesService");function n(l,p){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:A.URI.revive(l.location).with({scheme:p}),globalStorageHome:A.URI.revive(l.globalStorageHome).with({scheme:p}),settingsResource:A.URI.revive(l.settingsResource).with({scheme:p}),keybindingsResource:A.URI.revive(l.keybindingsResource).with({scheme:p}),tasksResource:A.URI.revive(l.tasksResource).with({scheme:p}),snippetsHome:A.URI.revive(l.snippetsHome).with({scheme:p}),extensionsResource:A.URI.revive(l.extensionsResource).with({scheme:p}),cacheHome:A.URI.revive(l.cacheHome).with({scheme:p}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function i(l,p,C,S,v,E){return{id:l,name:p,location:C,isDefault:!1,shortName:v?.shortName,icon:v?.icon,globalStorageHome:E&&v?.useDefaultFlags?.globalState?E.globalStorageHome:(0,T.$bh)(C,"globalStorage"),settingsResource:E&&v?.useDefaultFlags?.settings?E.settingsResource:(0,T.$bh)(C,"settings.json"),keybindingsResource:E&&v?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,T.$bh)(C,"keybindings.json"),tasksResource:E&&v?.useDefaultFlags?.tasks?E.tasksResource:(0,T.$bh)(C,"tasks.json"),snippetsHome:E&&v?.useDefaultFlags?.snippets?E.snippetsHome:(0,T.$bh)(C,"snippets"),extensionsResource:E&&v?.useDefaultFlags?.extensions?E.extensionsResource:(0,T.$bh)(C,"extensions.json"),cacheHome:(0,T.$bh)(S,l),useDefaultFlags:v?.useDefaultFlags,isTransient:v?.transient}}let g=class extends I.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(p,C,S,v){super(),this.t=p,this.u=C,this.w=S,this.y=v,this.f=!0,this.h=this.B(new D.$he),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$he),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$he),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$he),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new k.$Ac,emptyWindows:new Map},this.profilesHome=(0,T.$bh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,T.$bh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(p){this.f!==p&&(this.z=void 0,this.f=p)}isEnabled(){return this.f}get C(){if(!this.z){const p=this.D(),C=[p];if(this.f)try{for(const E of this.O()){if(!E.name||!(0,f.$ag)(E.name)||!E.location){this.y.warn("Skipping the invalid stored profile",E.location||E.name);continue}C.push(i((0,T.$$g)(E.location),E.name,E.location,this.g,{shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags},p))}}catch(E){this.y.error(E)}const S=new k.$Ac,v=new Map;if(C.length)try{const E=this.Q();if(E.workspaces)for(const[R,w]of Object.entries(E.workspaces)){const m=A.URI.parse(R),N=C.find(B=>B.id===w);N&&S.set(m,N)}if(E.emptyWindows)for(const[R,w]of Object.entries(E.emptyWindows)){const m=C.find(N=>N.id===w);m&&v.set(R,m)}}catch(E){this.y.error(E)}this.z={profiles:C,workspaces:S,emptyWindows:v}}return this.z}D(){const p=i("__default__profile__",(0,M.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...p,extensionsResource:this.S()??p.extensionsResource,isDefault:!0}}async createTransientProfile(p){const C="Temp",S=new RegExp(`${(0,c.$df)(C)}\\s(\\d+)`);let v=0;for(const R of this.profiles){const w=S.exec(R.name),m=w?parseInt(w[1]):0;v=m>v?m:v}const E=`${C} ${v+1}`;return this.createProfile((0,b.$oj)((0,o.$Wg)()).toString(16),E,{transient:!0},p)}async createNamedProfile(p,C,S){return this.createProfile((0,b.$oj)((0,o.$Wg)()).toString(16),p,C,S)}async createProfile(p,C,S,v){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=await this.F(p,C,S);return v&&await this.setProfileForWorkspace(v,E),E}async F(p,C,S){if(!(0,f.$ag)(C)||!C)throw new Error("Name of the profile is mandatory and must be of type `string`");let v=this.r.get(C);return v||(v=(async()=>{try{if(this.profiles.find(m=>m.name===C||m.id===p))throw new Error(`Profile with ${C} name already exists`);const R=i(p,C,(0,T.$bh)(this.profilesHome,p),this.g,S,this.defaultProfile);await this.u.createFolder(R.location);const w=[];return this.j.fire({profile:R,join(m){w.push(m)}}),await r.Promises.settled(w),this.I([R],[],[]),R}finally{this.r.delete(C)}})(),this.r.set(C,v)),v}async updateProfile(p,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let S=this.profiles.find(v=>v.id===p.id);if(!S)throw new Error(`Profile '${p.name}' does not exist`);return S=i(S.id,C.name??S.name,S.location,this.g,{shortName:C.shortName??S.shortName,icon:C.icon===null?void 0:C.icon??S.icon,transient:C.transient??S.isTransient,useDefaultFlags:C.useDefaultFlags??S.useDefaultFlags},this.defaultProfile),this.I([],[],[S]),S}async removeProfile(p){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(p.isDefault)throw new Error("Cannot remove default profile");const C=this.profiles.find(v=>v.id===p.id);if(!C)throw new Error(`Profile '${p.name}' does not exist`);const S=[];this.m.fire({profile:C,join(v){S.push(v)}});try{await Promise.allSettled(S)}catch(v){this.y.error(v)}for(const v of[...this.C.emptyWindows.keys()])C.id===this.C.emptyWindows.get(v)?.id&&this.C.emptyWindows.delete(v);for(const v of[...this.C.workspaces.keys()])C.id===this.C.workspaces.get(v)?.id&&this.C.workspaces.delete(v);this.M(),this.I([],[C],[]);try{await this.u.del(C.cacheHome,{recursive:!0})}catch(v){(0,a.$ll)(v)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error(v)}}async setProfileForWorkspace(p,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=this.profiles.find(v=>v.id===C.id);if(!S)throw new Error(`Profile '${C.name}' does not exist`);this.L(p,S)}unsetWorkspace(p,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(p,void 0,C)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const p=await this.u.resolve(this.profilesHome);await Promise.all((p.children||[]).filter(C=>C.isDirectory&&this.profiles.every(S=>!this.w.extUri.isEqual(S.location,C.resource))).map(C=>this.u.del(C.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const p=this.s.profiles.filter(C=>!this.H(C));await Promise.allSettled(p.map(C=>this.removeProfile(C)))}getProfileForWorkspace(p){const C=this.G(p);return A.URI.isUri(C)?this.s.workspaces.get(C)??this.C.workspaces.get(C):this.s.emptyWindows.get(C)??this.C.emptyWindows.get(C)}G(p){return(0,u.$Ki)(p)?p.uri:(0,u.$Pi)(p)?p.configPath:p.id}H(p){return!!([...this.s.emptyWindows.values()].some(C=>this.w.extUri.isEqual(C.location,p.location))||[...this.s.workspaces.values()].some(C=>this.w.extUri.isEqual(C.location,p.location))||[...this.C.emptyWindows.values()].some(C=>this.w.extUri.isEqual(C.location,p.location))||[...this.C.workspaces.values()].some(C=>this.w.extUri.isEqual(C.location,p.location)))}I(p,C,S){const v=[...this.profiles,...p],E=[];this.s.profiles=[];for(let R of v)R.isDefault||C.some(w=>R.id===w.id)||(R=S.find(w=>R.id===w.id)??R,R.isTransient?this.s.profiles.push(R):E.push({location:R.location,name:R.name,shortName:R.shortName,icon:R.icon,useDefaultFlags:R.useDefaultFlags}));this.P(E),this.z=void 0,this.J(p,C,S)}J(p,C,S){this.h.fire({added:p,removed:C,updated:S,all:this.profiles})}L(p,C,S){S=C?.isTransient?!0:S,S||this.L(p,void 0,!0);const v=this.G(p),E=S?this.s:this.C;A.URI.isUri(v)?(E.workspaces.delete(v),C&&E.workspaces.set(v,C)):(E.emptyWindows.delete(v),C&&E.emptyWindows.set(v,C)),S||this.M()}M(){const p={};for(const[S,v]of this.C.workspaces.entries())p[S.toString()]=v.id;const C={};for(const[S,v]of this.C.emptyWindows.entries())C[S.toString()]=v.id;this.R({workspaces:p,emptyWindows:C}),this.z=void 0}N(p){const C={},S=this.D();if(p.workspaces)for(const[E,R]of Object.entries(p.workspaces)){const w=A.URI.parse(R);C[E]=this.w.extUri.isEqual(w,S.location)?S.id:this.w.extUri.basename(w)}const v={};if(p.emptyWindows)for(const[E,R]of Object.entries(p.emptyWindows)){const w=A.URI.parse(R);v[E]=this.w.extUri.isEqual(w,S.location)?S.id:this.w.extUri.basename(w)}return{workspaces:C,emptyWindows:v}}O(){return[]}P(p){throw new Error("not implemented")}Q(){return{}}R(p){throw new Error("not implemented")}S(){}};e.$Jl=g,g.b="userDataProfiles",g.c="profileAssociations",e.$Jl=g=Je([qe(0,$.$Hi),qe(1,a.$7k),qe(2,h.$El),qe(3,y.$7j)],g);class d extends g{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(p){this.a=p}Q(){return this.X}R(p){this.X=p}}e.$Kl=d}),define(Ce[226],Ie([1,0,11,4,6,64,15,149,3,112]),function(_,e,b,D,I,T,A,M,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$_p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$0p=e.$9p=e.$8p=void 0,e.$$p=k,e.$aq=r,e.$cq=c,e.$8p="__$__isNewStorageMarker",e.$9p="__$__targetStorageMarker",e.$0p=(0,$.$Ai)("storageService");var P;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var y;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var u;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(u||(e.StorageTarget=u={}));function k(f){const t=f.get(e.$9p);if(t)try{return JSON.parse(t)}catch{}return Object.create(null)}class h extends I.$Uc{constructor(t={flushInterval:h.a}){super(),this.m=t,this.b=this.B(new D.$ke),this.c=this.B(new D.$ke),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$he),this.onWillSaveState=this.f.event,this.h=this.B(new b.$Mh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(t,s,n){return D.Event.filter(this.b.event,i=>i.scope===t&&(s===void 0||i.key===s),n)}n(){this.j.value=(0,b.$Qh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.O()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(t,s){const{key:n,external:i}=s;if(n===e.$9p){switch(t){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:t})}else this.b.fire({scope:t,key:n,target:this.J(t)[n],external:i})}w(t){this.f.fire({reason:t})}get(t,s,n){return this.P(s)?.get(t,n)}getBoolean(t,s,n){return this.P(s)?.getBoolean(t,n)}getNumber(t,s,n){return this.P(s)?.getNumber(t,n)}getObject(t,s,n){return this.P(s)?.getObject(t,n)}storeAll(t,s){this.y(()=>{for(const n of t)this.store(n.key,n.value,n.scope,n.target,s)})}store(t,s,n,i,g=!1){if((0,A.$jg)(s)){this.remove(t,n,g);return}this.y(()=>{this.z(t,n,i),this.P(n)?.set(t,s,g)})}remove(t,s,n=!1){this.y(()=>{this.z(t,s,void 0),this.P(s)?.delete(t,n)})}y(t){this.b.pause(),this.c.pause();try{t()}finally{this.b.resume(),this.c.resume()}}keys(t,s){const n=[],i=this.J(t);for(const g of Object.keys(i))i[g]===s&&n.push(g);return n}z(t,s,n,i=!1){const g=this.J(s);typeof n=="number"?g[t]!==n&&(g[t]=n,this.P(s)?.set(e.$9p,JSON.stringify(g),i)):typeof g[t]=="number"&&(delete g[t],this.P(s)?.set(e.$9p,JSON.stringify(g),i))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(t){switch(t){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(t){const s=this.P(t);return s?k(s):Object.create(null)}isNew(t){return this.getBoolean(e.$8p,t)===!0}async flush(t=P.NONE){this.f.fire({reason:t});const s=this.P(y.APPLICATION),n=this.P(y.PROFILE),i=this.P(y.WORKSPACE);switch(t){case P.NONE:await b.Promises.settled([s?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await b.Promises.settled([s?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const t=this.P(y.APPLICATION)?.items??new Map,s=this.P(y.PROFILE)?.items??new Map,n=this.P(y.WORKSPACE)?.items??new Map;return c(t,s,n,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(t){return await this.flush(),this.P(t)?.optimize()}async switch(t,s){return this.w(P.NONE),(0,a.$Fl)(t)?this.R(t,s):this.S(t,s)}M(t,s){return!(t.id===s.id||r(s)&&r(t))}N(t,s,n){this.y(()=>{const i=new Set;for(const[g,d]of t)i.add(g),s.get(g)!==d&&this.u(n,{key:g,external:!0});for(const[g]of s.items)i.has(g)||this.u(n,{key:g,external:!0})})}}e.$_p=h,h.a=60*1e3;function r(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class o extends h{constructor(){super(),this.U=this.B(new M.$6p(new M.$7p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new M.$6p(new M.$7p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new M.$6p(new M.$7p,{hint:M.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(t=>this.u(y.WORKSPACE,t))),this.B(this.W.onDidChangeStorage(t=>this.u(y.PROFILE,t))),this.B(this.U.onDidChangeStorage(t=>this.u(y.APPLICATION,t)))}P(t){switch(t){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(t){switch(t){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(t){return!1}}e.$bq=o;async function c(f,t,s,n,i,g){const d=m=>{try{return JSON.parse(m)}catch{return m}},l=new Map,p=new Map;f.forEach((m,N)=>{l.set(N,m),p.set(N,d(m))});const C=new Map,S=new Map;t.forEach((m,N)=>{C.set(N,m),S.set(N,d(m))});const v=new Map,E=new Map;s.forEach((m,N)=>{v.set(N,m),E.set(N,d(m))}),console.group(n!==i?`Storage: Application (path: ${n})`:`Storage: Application & Profile (path: ${n}, default profile)`);const R=[];if(l.forEach((m,N)=>{R.push({key:N,value:m})}),console.table(R),console.groupEnd(),console.log(p),n!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const m=[];C.forEach((N,B)=>{m.push({key:B,value:N})}),console.table(m),console.groupEnd(),console.log(S)}console.group(`Storage: Workspace (path: ${g})`);const w=[];v.forEach((m,N)=>{w.push({key:N,value:m})}),console.table(w),console.groupEnd(),console.log(E)}}),define(Ce[80],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=void 0;class b{constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const T=this.c++;return this.b.set(T,I),this.e(),T}get(I,T){return this.b.has(I)?this.b.get(I)[T]:void 0}delete(I){this.b.delete(I),this.e()}e(){b.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Qmc=b,b.a=!1}),define(Ce[51],Ie([1,0,16,24,30,3]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=e.$Vmc=void 0;class A{constructor(){this.a=new Set(Object.keys(b.Schemas)),this.b=new Map,this.extUri=new D.$3g($=>{const a=this.b.get($.scheme);return!(a===void 0||a&I.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos($,a){a===null?this.b.delete($.scheme):this.b.set($.scheme,a)}isFreeScheme($){return!this.b.has($)&&!this.a.has($)}getCapabilities($){return this.b.get($)}}e.$Vmc=A,e.$Wmc=(0,T.$Ai)("IExtHostFileSystemInfo")}),define(Ce[27],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=void 0,e.$dP=(0,b.$Ai)("IExtHostInitDataService")}),define(Ce[227],Ie([1,0,183,12,212,27]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3oc=void 0;let A=class extends I.$oQ{constructor($,a,P){const y=P.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",u=P.remote.isRemote?(0,b.localize)(0,null):$?(0,b.localize)(1,null):(0,b.localize)(2,null);super(a.createLogger(y,{name:u}))}};e.$3oc=A,e.$3oc=A=Je([qe(1,D.$8j),qe(2,T.$dP)],A)}),define(Ce[228],Ie([1,0,11]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=e.$Bnc=void 0;class D{constructor(A,M,$){this.h=new Map,this.a=A,this.b=M,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(a=>(this.f=a,this)),this.g=this.c.onDidChangeStorage(a=>{a.shared===this.b&&a.key===this.a&&(this.f=a.value)}),this.i=new b.$Mh(()=>{const a=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const P of a.values())P.complete()}catch(P){for(const y of a.values())y.error(P)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,M){let $=this.f[A];return typeof $>"u"&&($=M),$}update(A,M){this.f[A]=M;const $=this.h.get(A);if($!==void 0)return $.p;const a=new b.$Xh;return this.h.set(A,a),this.i.isScheduled()||this.i.schedule(),a.p}dispose(){this.g.dispose()}}e.$Bnc=D;class I extends D{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,M){super(A.identifier.value,!0,M),this.j=A}}e.$Cnc=I}),define(Ce[229],Ie([1,0,4,2]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qoc=void 0;class I{constructor(A){this.c=A,this.a=new b.$he,this.onDidSaveNotebookDocument=this.a.event,this.b=new b.$he,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,M,$,a){const y=this.c.getNotebookDocument(D.URI.revive(A)).acceptModelChanged(M.value,$,a);this.b.fire(y)}$acceptDirtyStateChanged(A,M){this.c.getNotebookDocument(D.URI.revive(A)).acceptDirty(M)}$acceptModelSaved(A){const M=this.c.getNotebookDocument(D.URI.revive(A));this.a.fire(M.apiNotebook)}}e.$qoc=I}),define(Ce[17],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=void 0,e.$ZO=(0,b.$Ai)("IExtHostRpcService");class D{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$1O=D});var tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b},Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)};define(Ce[230],Ie([1,0,19,4]),function(_,e,b,D){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=void 0;class T{constructor(M,$){I.set(this,void 0),this.b=new D.$he,this.onDidChange=this.b.event,this.a=b.$Xm.toKey(M.identifier),tt(this,I,$,"f"),Be(this,I,"f").onDidChangePassword(a=>{a.extensionId===this.a&&this.b.fire({key:a.key})})}get(M){return Be(this,I,"f").get(this.a,M)}store(M,$){return Be(this,I,"f").store(this.a,M,$)}delete(M){return Be(this,I,"f").delete(this.a,M)}}e.$Lnc=T,I=new WeakMap}),define(Ce[65],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$anc=e.$_mc=void 0,e.$_mc=(0,b.$Ai)("IURITransformerService");class D{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$anc=D}),define(Ce[113],Ie([1,0,192,15,2,6,3,31,30,16,49,162,35]),function(_,e,b,D,I,T,A,M,$,a,P,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$5F=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$UF=e.EditorInputCapabilities=e.$TF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$JF=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$KF=r,e.$LF=o,e.$MF=c,e.$NF=f,e.$OF=t,e.$PF=s,e.$QF=n,e.$RF=i,e.$SF=g,e.$VF=v,e.$WF=R,e.$XF=w,e.$YF=m,e.$ZF=N,e.$1F=B,e.$2F=X,e.$3F=V,e.$4F=be,e.$6F=ae,e.$7F=ee,e.$8F=De,e.$9F=Fe,e.$FF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$GF={id:"default",displayName:(0,b.localize)(0,null),providerDisplayName:(0,b.localize)(1,null)},e.$HF="workbench.editor.sidebysideEditor",e.$IF="workbench.editors.textDiffEditor",e.$JF="workbench.editors.binaryResourceDiffEditor";var k;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})(k||(e.EditorPaneSelectionChangeReason=k={}));var h;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(h||(e.EditorPaneSelectionCompareResult=h={}));function r(ce){const H=ce;return!!H&&typeof H.getSelection=="function"&&!!H.onDidChangeSelection}function o(ce){const H=ce;return!!H&&typeof H.getScrollPosition=="function"&&typeof H.setScrollPosition=="function"&&!!H.onDidChangeScroll}function c(ce,H,he){for(const le of he.visibleEditorPanes)if(le.group.id===H&&ce.matches(le.input))return le.getViewState()}function f(ce){if(v(ce))return!1;const H=ce;return I.URI.isUri(H?.resource)}function t(ce){if(v(ce))return!1;const H=ce;return H?.original!==void 0&&H.modified!==void 0}function s(ce){if(v(ce))return!1;const H=ce;return!H||H.resources&&!Array.isArray(H.resources)?!1:!!H.resources||!!H.multiDiffSource}function n(ce){if(v(ce)||t(ce))return!1;const H=ce;return H?.primary!==void 0&&H.secondary!==void 0}function i(ce){if(v(ce))return!1;const H=ce;return H?H.resource===void 0||H.resource.scheme===a.Schemas.untitled||H.forceUntitled===!0:!1}function g(ce){if(v(ce))return!1;const H=ce;return I.URI.isUri(H?.base?.resource)&&I.URI.isUri(H?.input1?.resource)&&I.URI.isUri(H?.input2?.resource)&&I.URI.isUri(H?.result?.resource)}var d;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(d||(e.Verbosity=d={}));var l;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class p{constructor(){this.a=new Map}registerSource(H,he){let le=this.a.get(H);return le||(le={source:H,label:he},this.a.set(H,le)),le.source}getSourceLabel(H){return this.a.get(H)?.label??H}}e.$TF=new p;var C;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad"})(C||(e.EditorInputCapabilities=C={}));class S extends T.$Uc{}e.$UF=S;function v(ce){return ce instanceof S}function E(ce){const H=ce;return I.URI.isUri(H?.preferredResource)}function R(ce){const H=ce;return v(H?.primary)&&v(H?.secondary)}function w(ce){const H=ce;return v(H?.modified)&&v(H?.original)}function m(ce,H,he,le,re){return Fe(le,[(0,y.$kj)({id:"workbench.action.openLargeFile",label:(0,b.localize)(2,null),run:()=>{const ue={...he,limits:{size:Number.MAX_VALUE}};ce.openEditor(H,ue)}}),(0,y.$kj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,b.localize)(3,null),run:()=>re.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:u.default.Warning})}function N(ce){return v(ce?.editor)}function B(ce){const H=ce;return N(ce)&&H?.group!==void 0}function X(ce){const H=ce;return typeof H?.groupId=="number"&&v(H.editor)}function V(ce){return typeof ce?.groupId=="number"}var O;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(O||(e.EditorCloseContext=O={}));var L;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LABEL=2]="GROUP_LABEL",ce[ce.GROUP_LOCKED=3]="GROUP_LOCKED",ce[ce.EDITORS_SELECTION=4]="EDITORS_SELECTION",ce[ce.EDITOR_OPEN=5]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=6]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=7]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=9]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=11]="EDITOR_PIN",ce[ce.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",ce[ce.EDITOR_STICKY=13]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=14]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(L||(e.GroupModelChangeKind=L={}));var F;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(F||(e.SideBySideEditor=F={}));class ie{getOriginalUri(H,he){if(!H)return;if(g(H))return e.$5F.getOriginalUri(H.result,he);if(he?.supportSideBySide){const{primary:re,secondary:ue}=this.a(H);if(re&&ue){if(he?.supportSideBySide===F.BOTH)return{primary:this.getOriginalUri(re,{filterByScheme:he.filterByScheme}),secondary:this.getOriginalUri(ue,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===F.ANY)return this.getOriginalUri(re,{filterByScheme:he.filterByScheme})??this.getOriginalUri(ue,{filterByScheme:he.filterByScheme});H=he.supportSideBySide===F.PRIMARY?re:ue}}if(t(H)||s(H)||n(H)||g(H))return;const le=E(H)?H.preferredResource:H.resource;return!le||!he||!he.filterByScheme?le:this.b(le,he.filterByScheme)}a(H){return R(H)||n(H)?{primary:H.primary,secondary:H.secondary}:w(H)||t(H)?{primary:H.modified,secondary:H.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(H,he){if(!H)return;if(g(H))return e.$5F.getCanonicalUri(H.result,he);if(he?.supportSideBySide){const{primary:re,secondary:ue}=this.a(H);if(re&&ue){if(he?.supportSideBySide===F.BOTH)return{primary:this.getCanonicalUri(re,{filterByScheme:he.filterByScheme}),secondary:this.getCanonicalUri(ue,{filterByScheme:he.filterByScheme})};if(he?.supportSideBySide===F.ANY)return this.getCanonicalUri(re,{filterByScheme:he.filterByScheme})??this.getCanonicalUri(ue,{filterByScheme:he.filterByScheme});H=he.supportSideBySide===F.PRIMARY?re:ue}}if(t(H)||s(H)||n(H)||g(H))return;const le=H.resource;return!le||!he||!he.filterByScheme?le:this.b(le,he.filterByScheme)}b(H,he){if(Array.isArray(he)){if(he.some(le=>H.scheme===le))return H}else if(he===H.scheme)return H}}var de;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(de||(e.EditorCloseMethod=de={}));function be(ce,H,he,le){if(!ce.isSticky(H))return!1;switch(le.preventPinnedEditorClose){case"keyboardAndMouse":return he===de.MOUSE||he===de.KEYBOARD;case"mouse":return he===de.MOUSE;case"keyboard":return he===de.KEYBOARD}return!1}e.$5F=new ie;var ve;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(ve||(e.CloseDirection=ve={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(H){const he=this.a=H.get(A.$zi);for(const[le,re]of this.c)this.e(le,re,he);this.c.clear()}e(H,he,le){const re=le.createInstance(he);this.d.set(H,re)}registerFileEditorFactory(H){if(this.b)throw new Error("Can only register one file editor factory.");this.b=H}getFileEditorFactory(){return(0,D.$lg)(this.b)}registerEditorSerializer(H,he){if(this.c.has(H)||this.d.has(H))throw new Error(`A editor serializer with type ID '${H}' was already registered.`);return this.a?this.e(H,he,this.a):this.c.set(H,he),(0,T.$Sc)(()=>{this.c.delete(H),this.d.delete(H)})}getEditorSerializer(H){return this.d.get(typeof H=="string"?H:H.typeId)}}M.$ko.add(e.$FF.EditorFactory,new Z);async function ae(ce,H,he){return!ce||!ce.length?[]:await Promise.all(ce.map(async le=>{const re=I.URI.revive(le.fileUri);if(!re){he.info("Cannot resolve the path because it is not valid.",le);return}if(!await H.canHandleResource(re)){he.info("Cannot resolve the path because it cannot be handled",le);return}let oe=le.exists,J=le.type;if(typeof oe!="boolean"||typeof J!="number")try{J=(await H.stat(re)).isDirectory?$.FileType.Directory:$.FileType.Unknown,oe=!0}catch(we){he.error(we),oe=!1}if(!oe&&le.openOnlyIfExists){he.info("Cannot resolve the path because it does not exist",le);return}if(J===$.FileType.Directory){he.info("Cannot resolve the path because it is a directory",le);return}const Y={...le.options,pinned:!0};return oe?{resource:re,options:Y}:{resource:re,options:Y,forceUntitled:!0}}))}var fe;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(fe||(e.EditorsOrder=fe={}));function ee(ce){const H=ce;if(!H)return!1;const he=H;if(he.modified)return ee(he.modified);const le=H;return!!(le.contributionsState&&le.viewState&&Array.isArray(le.cursorState))}function De(ce){return(0,P.$mj)(ce)}function Fe(ce,H,he){const le=(0,P.$nj)(ce,H);return le.forceMessage=he?.forceMessage,le.forceSeverity=he?.forceSeverity,le.allowDialog=he?.allowDialog,le}}),define(Ce[231],Ie([1,0,4,193,3,6,29,31,26,97,221]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eG=e.$dG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$cG=e.ViewContentGroups=e.$aG=e.ViewContainerLocation=e.Extensions=e.$_F=e.$$F=e.$0F=void 0,e.$bG=k,e.$0F="views",e.$$F=(0,D.localize)(0,null),e.$_F=(0,P.$px)("default-view-icon",a.$Zj.window,(0,D.localize)(1,null));var y;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var u;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(u||(e.ViewContainerLocation=u={})),e.$aG=[u.Sidebar,u.Panel,u.AuxiliaryBar];function k(i){switch(i){case u.Sidebar:return"sidebar";case u.Panel:return"panel";case u.AuxiliaryBar:return"auxiliarybar"}}class h extends T.$Uc{constructor(){super(...arguments),this.c=this.B(new b.$he),this.onDidRegister=this.c.event,this.f=this.B(new b.$he),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(g,d,l){const p=this.get(g.id);if(p)return p;const C=g;return C.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:C.openCommandActionDescriptor??{id:C.id},(0,A.$xc)(this.g,d,[]).push(C),l?.isDefault&&this.h.push(C),this.c.fire({viewContainer:C,viewContainerLocation:d}),C}deregisterViewContainer(g){for(const d of this.g.keys()){const l=this.g.get(d),p=l?.indexOf(g);if(p!==-1){l?.splice(p,1),l.length===0&&this.g.delete(d),this.f.fire({viewContainer:g,viewContainerLocation:d});return}}}get(g){return this.all.filter(d=>d.id===g)[0]}getViewContainers(g){return[...this.g.get(g)||[]]}getViewContainerLocation(g){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(l=>l?.id===g.id).length>0)[0]}getDefaultViewContainer(g){return this.h.find(d=>this.getViewContainerLocation(d)===g)}}M.$ko.add(y.ViewContainersRegistry,new h);var r;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(r||(e.ViewContentGroups=r={}));function o(i,g){const d=i.group??r.More,l=g.group??r.More;return d!==l?d.localeCompare(l):(i.order??5)-(g.order??5)}class c extends T.$Uc{constructor(){super(...arguments),this.c=this.B(new b.$he),this.onViewsRegistered=this.c.event,this.f=this.B(new b.$he),this.onViewsDeregistered=this.f.event,this.g=this.B(new b.$he),this.onDidChangeContainer=this.g.event,this.h=this.B(new b.$he),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(g,d){this.registerViews2([{views:g,viewContainer:d}])}registerViews2(g){g.forEach(({views:d,viewContainer:l})=>this.r(d,l)),this.c.fire(g)}deregisterViews(g,d){const l=this.s(g,d);l.length&&this.f.fire({views:l,viewContainer:d})}moveViews(g,d){for(const l of this.m.keys())if(l!==d){const p=this.s(g,l);p.length&&(this.r(p,d),this.g.fire({views:p,from:l,to:d}))}}getViews(g){return this.m.get(g)||[]}getView(g){for(const d of this.j){const l=(this.m.get(d)||[]).filter(p=>p.id===g)[0];if(l)return l}return null}getViewContainer(g){for(const d of this.j)if((this.m.get(d)||[]).filter(p=>p.id===g)[0])return d;return null}registerViewWelcomeContent(g,d){return this.n.add(g,d),this.h.fire(g),(0,T.$Sc)(()=>{this.n.delete(g,d),this.h.fire(g)})}registerViewWelcomeContent2(g,d){const l=new Map;for(const[p,C]of d)this.n.add(g,C),l.set(p,(0,T.$Sc)(()=>{this.n.delete(g,C),this.h.fire(g)}));return this.h.fire(g),l}getViewWelcomeContent(g){const d=[];return this.n.forEach(g,l=>d.push(l)),d.sort(o)}r(g,d){let l=this.m.get(d);l||(l=[],this.m.set(d,l),this.j.push(d));for(const p of g){if(this.getView(p.id)!==null)throw new Error((0,D.localize)(2,null,p.id));l.push(p)}}s(g,d){const l=this.m.get(d);if(!l)return[];const p=[],C=[];for(const S of l)g.includes(S)?p.push(S):C.push(S);return p.length&&(C.length?this.m.set(d,C):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),p}}M.$ko.add(y.ViewsRegistry,new c),e.$cG=(0,I.$Ai)("viewDescriptorService");var f;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(f||(e.ViewVisibilityState=f={}));var t;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(t||(e.TreeItemCollapsibleState=t={}));class s{constructor(g,d){this.c=!1,this.d=!1,(0,$.$ao)(this,g),this.d=!!d,this.resolve=async l=>{if(d&&!this.c){const p=await d(l);p&&(this.tooltip=this.tooltip??p.tooltip,this.command=this.command??p.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$dG=s;class n extends Error{constructor(g){super((0,D.localize)(3,null,g)),this.name="NoTreeViewError"}static is(g){return g.name==="NoTreeViewError"}}e.$eG=n}),define(Ce[232],Ie([1,0,194,32]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=void 0,e.$iG=new D.$Rj("chatSessionResponseVote","",{type:"string",description:(0,b.localize)(0,null)}),e.$jG=new D.$Rj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,b.localize)(1,null)}),e.$kG=new D.$Rj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,b.localize)(2,null)}),e.$lG=new D.$Rj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,b.localize)(3,null)}),e.$mG=new D.$Rj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,b.localize)(4,null)}),e.$nG=new D.$Rj("chatResponse",!1,{type:"boolean",description:(0,b.localize)(5,null)}),e.$oG=new D.$Rj("chatRequest",!1,{type:"boolean",description:(0,b.localize)(6,null)}),e.$pG=new D.$Rj("chatEditApplied",!1,{type:"boolean",description:(0,b.localize)(7,null)}),e.$qG=new D.$Rj("chatInputHasText",!1,{type:"boolean",description:(0,b.localize)(8,null)}),e.$rG=new D.$Rj("chatInputHasFocus",!1,{type:"boolean",description:(0,b.localize)(9,null)}),e.$sG=new D.$Rj("inChatInput",!1,{type:"boolean",description:(0,b.localize)(10,null)}),e.$tG=new D.$Rj("inChat",!1,{type:"boolean",description:(0,b.localize)(11,null)}),e.$uG=new D.$Rj("chatIsEnabled",!1,{type:"boolean",description:(0,b.localize)(12,null)}),e.$vG=new D.$Rj("chatCursorAtTop",!1),e.$wG=new D.$Rj("chatInputHasAgent",!1),e.$xG=new D.$Rj("chatLocation",void 0),e.$yG=new D.$Rj("quickChatHasFocus",!1,{type:"boolean",description:(0,b.localize)(13,null)})}),define(Ce[233],Ie([1,0,324,11,22,4,40,6,48,140,13,32,19,3,12,107,215,226,232]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.ChatAgentLocation=void 0,e.$DH=d,e.$EH=l;var s;(function(p){p.Panel="panel",p.Terminal="terminal",p.Notebook="notebook",p.Editor="editor"})(s||(e.ChatAgentLocation=s={})),function(p){function C(S){switch(S){case"panel":return p.Panel;case"terminal":return p.Terminal;case"notebook":return p.Notebook;case"editor":return p.Editor}return p.Panel}p.fromRaw=C}(s||(e.ChatAgentLocation=s={})),e.$yH=(0,k.$Ai)("chatAgentService");let n=class{constructor(C){this.f=C,this.b=new Map,this.d=new T.$he,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=f.$uG.bindTo(this.f)}registerAgent(C,S){if(this.getAgent(C))throw new Error(`Agent already registered: ${JSON.stringify(C)}`);const E=this,R=S.slashCommands;S={...S,get slashCommands(){return R.filter(m=>!m.when||E.f.contextMatchesRules(y.$yj.deserialize(m.when)))}};const w={data:S};return this.b.set(C,w),(0,M.$Sc)(()=>{this.b.delete(C),this.d.fire(void 0)})}registerAgentImplementation(C,S){const v=this.b.get(C);if(!v)throw new Error(`Unknown agent: ${JSON.stringify(C)}`);if(v.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(C)}`);return v.data.isDefault&&this.e.set(!0),v.impl=S,this.d.fire(new i(v.data,S)),(0,M.$Sc)(()=>{v.impl=void 0,this.d.fire(void 0),v.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(C,S){C.isDynamic=!0;const v={data:C,impl:S};return this.b.set(C.id,v),this.d.fire(new i(C,S)),(0,M.$Sc)(()=>{this.b.delete(C.id),this.d.fire(void 0)})}registerAgentCompletionProvider(C,S){return this.g.set(C,S),{dispose:()=>{this.g.delete(C)}}}async getAgentCompletionItems(C,S,v){return await this.g.get(C)?.(S,v)??[]}updateAgent(C,S){const v=this.b.get(C);if(!v?.impl)throw new Error(`No activated agent with id ${JSON.stringify(C)} registered`);v.data.metadata={...v.data.metadata,...S},this.d.fire(new i(v.data,v.impl))}getDefaultAgent(C){return(0,b.$fb)(this.getActivatedAgents(),S=>!!S.isDefault&&S.locations.includes(C))}getContributedDefaultAgent(C){return this.getAgents().find(S=>!!S.isDefault&&S.locations.includes(C))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),C=>!!C.data.metadata.isSecondary)?.data}getAgent(C){if(this.h(C))return this.b.get(C)?.data}h(C){const S=this.b.get(C);return!S?.data.when||this.f.contextMatchesRules(y.$yj.deserialize(S.data.when))}getAgentByFullyQualifiedId(C){const S=A.Iterable.find(this.b.values(),v=>d(v.data)===C)?.data;if(!(S&&!this.h(S.id)))return S}getAgents(){return Array.from(this.b.values()).map(C=>C.data).filter(C=>this.h(C.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(C=>!!C.impl).filter(C=>this.h(C.data.id)).map(C=>new i(C.data,C.impl))}getAgentsByName(C){return this.getAgents().filter(S=>S.name===C)}async invokeAgent(C,S,v,E,R){const w=this.b.get(C);if(!w?.impl)throw new Error(`No activated agent with id "${C}"`);return await w.impl.invoke(S,v,E,R)}async getFollowups(C,S,v,E,R){const w=this.b.get(C);if(!w?.impl)throw new Error(`No activated agent with id "${C}"`);return w.impl?.provideFollowups?w.impl.provideFollowups(S,v,E,R):[]}};e.$zH=n,n.AGENT_LEADER="@",e.$zH=n=Je([qe(0,y.$Sj)],n);class i{constructor(C,S){this.b=C,this.d=S}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(C,S,v,E){return this.d.invoke(C,S,v,E)}async provideFollowups(C,S,v,E){return this.d.provideFollowups?this.d.provideFollowups(C,S,v,E):[]}provideWelcomeMessage(C,S){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(C,S)}provideSampleQuestions(C,S){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(C,S)}}e.$AH=i,e.$BH=(0,k.$Ai)("chatAgentNameService");let g=t=class{constructor(C,S,v,E){if(this.g=S,this.h=v,this.i=E,this.e=(0,a.$3d)(this,Object.create(null)),this.f=!1,!C.chatParticipantRegistry)return;this.d=C.chatParticipantRegistry;const R=E.get(t.b,c.StorageScope.APPLICATION);try{this.e.set(JSON.parse(R??"{}"),void 0)}catch{E.remove(t.b,c.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(C=>this.h.warn("Failed to fetch chat participant registry",C)).then(()=>(0,D.$Bh)(5*60*1e3)).then(()=>this.j())}async k(){const C=await this.g.request({type:"GET",url:this.d},I.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const S=await(0,o.$3p)(C);if(!S||S.version!==1)throw new Error("Unexpected chat participant registry response.");const v=S.restrictedChatParticipants;this.e.set(v,void 0),this.i.store(t.b,JSON.stringify(v),c.StorageScope.APPLICATION,c.StorageTarget.MACHINE)}getAgentNameRestriction(C){const S=this.l(C.name,C).get(),v=!C.fullName||this.l(C.fullName.replace(/\s/g,""),C).get();return S&&v}l(C,S){return this.e.map(E=>E[C.toLowerCase()]).map(E=>E?E.some(R=>(0,P.$Bf)(R,R.includes(".")?S.extensionId.value:S.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$CH=g,g.b="chat.participantNameRegistry",e.$CH=g=t=Je([qe(0,r.$nk),qe(1,o.$Wp),qe(2,h.$7j),qe(3,c.$0p)],g);function d(p){return`${p.extensionId.value}.${p.id}`}function l(p){const C="name"in p?p:{...p,name:p.id};return"extensionPublisherId"in C||(C.extensionPublisherId=C.extensionPublisher??""),"extensionDisplayName"in C||(C.extensionDisplayName=""),"extensionId"in C||(C.extensionId=new u.$Xm("")),(0,$.$0h)(C)}}),define(Ce[234],Ie([1,0,2,33,3]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0G=e.$9G=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$7G=T,e.$8G=A;function T(a){return!!a&&typeof a=="object"&&"uri"in a&&a.uri instanceof b.URI&&"version"in a&&typeof a.version=="number"&&"ranges"in a&&Array.isArray(a.ranges)&&a.ranges.every(D.$dt.isIRange)}function A(a){return!!a&&typeof a=="object"&&"documents"in a&&Array.isArray(a.documents)&&a.documents.every(T)}var M;(function(a){a[a.Down=0]="Down",a[a.Up=1]="Up"})(M||(e.ChatAgentVoteDirection=M={}));var $;(function(a){a[a.Action=1]="Action",a[a.Toolbar=2]="Toolbar"})($||(e.ChatCopyKind=$={})),e.$9G=(0,I.$Ai)("IChatService"),e.$0G="accessibility.voice.keywordActivation"}),define(Ce[235],Ie([1,0,4,11,196]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$osb=void 0;class T{constructor(){this.f=new Map,this.m=[],this.n=new b.$he,this.o=new b.$he,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(M){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=M}onEvent(M){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=M}onRequest(M){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=M}sendResponse(M){M.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${M.command}`)):this.u("response",M)}sendRequest(M,$,a,P){const y={command:M};if($&&Object.keys($).length>0&&(y.arguments=$),this.u("request",y),typeof P=="number"){const u=setTimeout(()=>{clearTimeout(u);const k=this.f.get(y.seq);if(k){this.f.delete(y.seq);const h={type:"response",seq:0,request_seq:y.seq,success:!1,command:M,message:(0,I.localize)(0,null,P,M)};k(h)}},P)}return a&&this.f.set(y.seq,a),y.seq}acceptMessage(M){this.k?this.k(M):(this.m.push(M),this.m.length===1&&this.s())}q(M,$){return M.type!=="event"||$.type!=="event"}async s(){let M;for(;this.m.length;){if((!M||this.q(this.m[0],M))&&await(0,D.$Bh)(0),M=this.m.shift(),!M)return;switch(M.type){case"event":this.j?.(M);break;case"request":this.g?.(M);break;case"response":{const $=M,a=this.f.get($.request_seq);a&&(this.f.delete($.request_seq),a($));break}}}}u(M,$){$.type=M,$.seq=this.d++,this.sendMessage($)}async w(){if(this.f.size===0)return Promise.resolve();const M=new Map;this.f.forEach(($,a)=>M.set(a,$)),await(0,D.$Bh)(500),M.forEach(($,a)=>{$({type:"response",seq:0,request_seq:a,success:!1,command:"canceled",message:"canceled"}),this.f.delete(a)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$osb=T}),define(Ce[81],Ie([1,0,2,197,32,3]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$UJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$SJ=e.MemoryRangeType=e.State=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=void 0,e.$RJ=$,e.$TJ=P,e.$FI="workbench.view.debug",e.$GI="workbench.debug.variablesView",e.$HI="workbench.debug.watchExpressionsView",e.$II="workbench.debug.callStackView",e.$JI="workbench.debug.loadedScriptsView",e.$KI="workbench.debug.breakPointsView",e.$LI="workbench.debug.disassemblyView",e.$MI="workbench.panel.repl",e.$NI="workbench.panel.repl.view",e.$OI=new I.$Rj("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$PI=new I.$Rj("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$QI=new I.$Rj("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$RI="debugUx",e.$SI=new I.$Rj(e.$RI,"default",{type:"string",description:D.localize(3,null)}),e.$TI=new I.$Rj("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$UI=new I.$Rj("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$VI=new I.$Rj("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$WI=new I.$Rj("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$XI=new I.$Rj("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$YI=new I.$Rj("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$ZI=new I.$Rj("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$1I=new I.$Rj("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$2I=new I.$Rj("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$3I=new I.$Rj("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$4I=new I.$Rj("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$5I=new I.$Rj("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$6I=new I.$Rj("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$7I=new I.$Rj("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$8I=new I.$Rj("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$9I=new I.$Rj("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$0I=new I.$Rj("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$$I=new I.$Rj("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$_I=new I.$Rj("breakpointItemBytes",void 0,{type:"boolean",description:D.localize(22,null)}),e.$aJ=new I.$Rj("breakpointHasModes",!1,{type:"boolean",description:D.localize(23,null)}),e.$bJ=new I.$Rj("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(24,null)}),e.$cJ=new I.$Rj("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(25,null)}),e.$dJ=new I.$Rj("loadedScriptsItemType",void 0,{type:"string",description:D.localize(26,null)}),e.$eJ=new I.$Rj("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(27,null)}),e.$fJ=new I.$Rj("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(28,null)}),e.$gJ=new I.$Rj("stepBackSupported",!1,{type:"boolean",description:D.localize(29,null)}),e.$hJ=new I.$Rj("restartFrameSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$iJ=new I.$Rj("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(31,null)}),e.$jJ=new I.$Rj("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(32,null)}),e.$kJ=new I.$Rj("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(33,null)}),e.$lJ=new I.$Rj("breakpointsExist",!1,{type:"boolean",description:D.localize(34,null)}),e.$mJ=new I.$Rj("debuggersAvailable",!1,{type:"boolean",description:D.localize(35,null)}),e.$nJ=new I.$Rj("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(36,null)}),e.$oJ=new I.$Rj("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(37,null)}),e.$pJ=new I.$Rj("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$qJ=new I.$Rj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$rJ=new I.$Rj("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$sJ=new I.$Rj("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$tJ=new I.$Rj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$uJ=new I.$Rj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(43,null)}),e.$vJ=new I.$Rj("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(44,null)}),e.$wJ=new I.$Rj("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(45,null)}),e.$xJ=new I.$Rj("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(46,null)}),e.$yJ=new I.$Rj("variableIsReadonly",!1,{type:"boolean",description:D.localize(47,null)}),e.$zJ=new I.$Rj("variableValue",!1,{type:"string",description:D.localize(48,null)}),e.$AJ=new I.$Rj("variableType",!1,{type:"string",description:D.localize(49,null)}),e.$BJ=new I.$Rj("variableInterfaces",!1,{type:"array",description:D.localize(50,null)}),e.$CJ=new I.$Rj("variableName",!1,{type:"string",description:D.localize(51,null)}),e.$DJ=new I.$Rj("variableLanguage",!1,{type:"string",description:D.localize(52,null)}),e.$EJ=new I.$Rj("variableExtensionId",!1,{type:"string",description:D.localize(53,null)}),e.$FJ=new I.$Rj("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(54,null)}),e.$GJ=new I.$Rj("multiSessionRepl",!1,{type:"boolean",description:D.localize(55,null)}),e.$HJ=new I.$Rj("multiSessionDebug",!1,{type:"boolean",description:D.localize(56,null)}),e.$IJ=new I.$Rj("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(57,null)}),e.$JJ=new I.$Rj("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(58,null)}),e.$KJ=new I.$Rj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(59,null)}),e.$LJ=new I.$Rj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(60,null)});const A=t=>D.localize(61,null,t);e.$MJ=A,e.$NJ="editor.contrib.debug",e.$OJ="editor.contrib.breakpoint",e.$PJ="debug",e.$QJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(62,null)};var M;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(M||(e.State=M={}));function $(t){switch(t){case M.Initializing:return"initializing";case M.Stopped:return"stopped";case M.Running:return"running";default:return"inactive"}}var a;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(a||(e.MemoryRangeType=a={})),e.$SJ="vscode-debug-memory";function P(t){return t.source.presentationHint==="deemphasize"||t.presentationHint==="deemphasize"||t.presentationHint==="subtle"}var y;(function(t){t[t.Variable=0]="Variable",t[t.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var u;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(u||(e.DebugConfigurationProviderTriggerKind=u={}));var k;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$UJ=(0,T.$Ai)("debugService");var h;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(h||(e.BreakpointWidgetContext=h={}));var r;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var o;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var c;(function(t){t.deserialize=s=>s,t.serialize=s=>s})(c||(e.IDebugVisualizationTreeItem=c={}));var f;(function(t){t.deserialize=s=>({id:s.id,name:s.name,iconPath:s.iconPath&&{light:b.URI.revive(s.iconPath.light),dark:b.URI.revive(s.iconPath.dark)},iconClass:s.iconClass,visualization:s.visualization}),t.serialize=s=>s})(f||(e.IDebugVisualization=f={}))}),define(Ce[236],Ie([1,0,13,2,20,26,16,33,22,18]),function(_,e,b,D,I,T,A,M,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TH=void 0,e.$HH=y,e.$IH=u,e.$JH=k,e.$KH=h,e.$LH=r,e.$MH=o,e.$NH=c,e.$OH=t,e.$PH=i,e.$QH=g,e.$RH=l,e.$SH=C;const P=/{([^}]+)}/g;function y(v,E,R){return v.replace(P,function(w,m){return E&&m.length>0&&m[0]!=="_"?w:R&&R.hasOwnProperty(m)?R[m]:w})}function u(v){const E={};for(const R of Object.keys(v))R.startsWith("!")||(E[R]=v[R]);return E}function k(v){return v.configuration.request==="attach"&&!h(v)&&(!v.parentSession||k(v.parentSession))}function h(v){let E=v.configuration.type;if(E)return E==="vslsShare"&&(E=v.configuration.adapterProxy.configuration.type),(0,b.$Bf)(E,"extensionhost")||(0,b.$Bf)(E,"pwa-extensionhost")?v:v.parentSession?h(v.parentSession):void 0}function r(v){return v.type&&(v.label||v.program||v.runtime)}function o(v,E,R){let w,m=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let B=null;for(;B=N.exec(v);){const X=B.index+1,V=X+B[0].length;if(X<=E&&V>=R){w=B[0],m=X;break}}if(w){const X=/\w+/g;let V=null;for(;(V=X.exec(w))&&!(V.index+1+m+V[0].length>=R););V&&(w=w.substring(0,X.lastIndex))}return w?{start:m,end:m+w.length-1}:{start:0,end:0}}async function c(v,E,R,w){if(v.evaluatableExpressionProvider.has(E)){const m=v.evaluatableExpressionProvider.ordered(E),N=(0,a.$Hb)(await Promise.all(m.map(async B=>{try{return await B.provideEvaluatableExpression(E,R,w??$.CancellationToken.None)}catch{return}})));if(N.length>0){let B=N[0].expression;const X=N[0].range;return B||(B=E.getLineContent(R.lineNumber).substring(X.startColumn-1,X.endColumn-1)),{range:X,matchingExpression:B}}}else{const m=E.getLineContent(R.lineNumber),{start:N,end:B}=o(m,R.column,R.column),X=m.substring(N-1,B);return{matchingExpression:X,range:new M.$dt(R.lineNumber,N,R.lineNumber,N+X.length)}}return null}const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(v){return!!(v&&v.match(f))}function s(v){if(typeof v.path=="string"&&!(typeof v.sourceReference=="number"&&v.sourceReference>0)){if(t(v.path))return D.URI.parse(v.path);if((0,I.$ic)(v.path))return D.URI.file(v.path)}return v.path}function n(v){if(typeof v.path=="object"){const E=D.URI.revive(v.path);if(E)return E.scheme===A.Schemas.file?E.fsPath:E.toString()}return v.path}function i(v,E){const R=E?s:n,w=(0,T.$0n)(v);return d(w,(m,N)=>{m&&N&&(N.path=R(N))}),w}function g(v,E){const R=E?s:n,w=(0,T.$0n)(v);return d(w,(m,N)=>{!m&&N&&(N.path=R(N))}),w}function d(v,E){switch(v.type){case"event":{const R=v;switch(R.event){case"output":E(!1,R.body.source);break;case"loadedSource":E(!1,R.body.source);break;case"breakpoint":E(!1,R.body.breakpoint.source);break;default:break}break}case"request":{const R=v;switch(R.command){case"setBreakpoints":E(!0,R.arguments.source);break;case"breakpointLocations":E(!0,R.arguments.source);break;case"source":E(!0,R.arguments.source);break;case"gotoTargets":E(!0,R.arguments.source);break;case"launchVSCode":R.arguments.args.forEach(w=>E(!1,w));break;default:break}break}case"response":{const R=v;if(R.success&&R.body)switch(R.command){case"stackTrace":R.body.stackFrames.forEach(w=>E(!1,w.source));break;case"loadedSources":R.body.sources.forEach(w=>E(!1,w));break;case"scopes":R.body.scopes.forEach(w=>E(!1,w.source));break;case"setFunctionBreakpoints":R.body.breakpoints.forEach(w=>E(!1,w.source));break;case"setBreakpoints":R.body.breakpoints.forEach(w=>E(!1,w.source));break;case"disassemble":R.body?.instructions.forEach(m=>E(!1,m.location));break;default:break}break}}}function l(v){return v.filter(E=>!E.presentation?.hidden).sort((E,R)=>E.presentation?R.presentation?E.presentation.group?R.presentation.group?E.presentation.group!==R.presentation.group?E.presentation.group.localeCompare(R.presentation.group):p(E.presentation.order,R.presentation.order):-1:R.presentation.group?1:p(E.presentation.order,R.presentation.order):-1:R.presentation?1:0)}function p(v,E){return typeof v!="number"?typeof E!="number"?0:1:typeof E!="number"?-1:v-E}async function C(v,E){const R=v.getValue("debug.saveBeforeStart",{overrideIdentifier:E.activeTextEditorLanguageId});if(R!=="none"&&(await E.saveAll(),R==="allEditorsInActiveGroup")){const w=E.activeEditorPane;w&&w.input.resource?.scheme===A.Schemas.untitled&&await E.save({editor:w.input,groupId:w.group.id})}await v.reloadConfiguration()}const S=(v,E)=>!v||!E?v===E:v.name===E.name&&v.path===E.path&&v.sourceReference===E.sourceReference;e.$TH=S}),define(Ce[237],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.CellExecutionUpdateType=void 0;var D;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(D||(e.CellExecutionUpdateType=D={})),e.$aK=(0,b.$Ai)("INotebookExecutionService")}),define(Ce[238],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Djb=e.$Cjb=e.ProxyKernelState=e.$Bjb=void 0,e.$Bjb=100;var D;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(D||(e.ProxyKernelState=D={})),e.$Cjb=(0,b.$Ai)("INotebookKernelService"),e.$Djb=(0,b.$Ai)("INotebookKernelHistoryService")}),define(Ce[239],Ie([1,0,6,33,53,159,102]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gYb=void 0;class M extends b.$Uc{constructor(a,P,y){super(),this._source=a,this.b=P,this.c=y,this.a=void 0}f(a){const P=a.getLineCount();return new D.$dt(1,1,P,this.g(a,P))}g(a,P){if(P<1||P>a.getLineCount())throw new Error("Illegal value for lineNumber");return a.getLineLength(P)+1}get inputTextBuffer(){if(!this.b){const a=new T.$bD;a.acceptChunk(this._source);const P=a.finish(!0),{textBuffer:y,disposable:u}=P.create(I.DefaultEndOfLine.LF);this.b=y,this.B(u)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(a=>{const P=new T.$bD;P.acceptChunk(a);const y=P.finish(!0),{textBuffer:u,disposable:k}=y.create(I.DefaultEndOfLine.LF);return this.B(k),u})),this.a}findInInputs(a){const y=new A.$2C(a,!1,!1,null).parseSearchRequest();if(!y)return[];const u=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(u,y,!0,5e3)}findInOutputs(a){const y=new A.$2C(a,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(u=>{const k=u.findMatchesLineByLine(this.f(u),y,!0,5e3);if(k.length!==0)return{textBuffer:u,matches:k}}).filter(u=>!!u):[]}}e.$gYb=M}),define(Ce[55],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hL=e.TestPosition=e.TestIdPathParts=void 0;var b;(function(T){T.Delimiter="\0"})(b||(e.TestIdPathParts=b={}));var D;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(D||(e.TestPosition=D={}));class I{static fromExtHostTestItem(A,M,$=A.parent){if(A._isRoot)return new I([M]);const a=[A.id];for(let P=$;P&&P.id!==M;P=P.parent)a.push(P.id);return a.push(M),new I(a.reverse())}static isRoot(A){return!A.includes(b.Delimiter)}static root(A){const M=A.indexOf(b.Delimiter);return M===-1?A:A.slice(0,M)}static fromString(A){return new I(A.split(b.Delimiter))}static join(A,M){return new I([...A.path,M])}static joinToString(A,M){return A.toString()+b.Delimiter+M}static parentId(A){const M=A.lastIndexOf(b.Delimiter);return M===-1?void 0:A.slice(0,M)}static localId(A){const M=A.lastIndexOf(b.Delimiter);return M===-1?A:A.slice(M+b.Delimiter.length)}static isChild(A,M){return M.startsWith(A)&&M[A.length]===b.Delimiter}static compare(A,M){return A===M?D.IsSame:I.isChild(A,M)?D.IsChild:I.isChild(M,A)?D.IsParent:D.Disconnected}static getLengthOfCommonPrefix(A,M){if(A===0)return 0;let $=0;for(;$<A-1;){for(let a=1;a<A;a++){const P=M(a-1),y=M(a);if(P.path[$]!==y.path[$])return $}$++}return $}constructor(A,M=A.length){if(this.path=A,this.d=M,A.length===0||M<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new I(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new I(this.path,A)}compare(A){if(typeof A=="string")return I.compare(this.toString(),A);for(let M=0;M<A.d&&M<this.d;M++)if(A.path[M]!==this.path[M])return D.Disconnected;return A.d>this.d?D.IsChild:A.d<this.d?D.IsParent:D.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=b.Delimiter,this.c+=this.path[A]}return this.c}}e.$hL=I}),define(Ce[56],Ie([1,0,2,101,33,55]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$pL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$oL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$nL=e.$mL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$lL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$kL=e.$jL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$iL=e.TestResultState=void 0;var A;(function(O){O[O.Unset=0]="Unset",O[O.Queued=1]="Queued",O[O.Running=2]="Running",O[O.Passed=3]="Passed",O[O.Failed=4]="Failed",O[O.Skipped=5]="Skipped",O[O.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$iL={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var M;(function(O){O[O.Run=1]="Run",O[O.Debug=2]="Debug",O[O.Coverage=3]="Coverage"})(M||(e.ExtTestRunProfileKind=M={}));var $;(function(O){O[O.Run=2]="Run",O[O.Debug=4]="Debug",O[O.Coverage=8]="Coverage",O[O.HasNonDefaultProfile=16]="HasNonDefaultProfile",O[O.HasConfigurable=32]="HasConfigurable",O[O.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$jL=[$.Run,$.Debug,$.Coverage,$.HasNonDefaultProfile,$.HasConfigurable,$.SupportsContinuousRun];const a=O=>"runId"in O;e.$kL=a;var P;(function(O){O.serialize=L=>({range:L.range.toJSON(),uri:L.uri.toJSON()}),O.deserialize=(L,F)=>({range:I.$dt.lift(F.range),uri:L.asCanonicalUri(b.URI.revive(F.uri))})})(P||(e.IRichLocation=P={}));var y;(function(O){O[O.Error=0]="Error",O[O.Output=1]="Output"})(y||(e.TestMessageType=y={}));var u;(function(O){O.serialize=L=>({message:L.message,type:y.Error,expected:L.expected,actual:L.actual,contextValue:L.contextValue,location:L.location&&P.serialize(L.location)}),O.deserialize=(L,F)=>({message:F.message,type:y.Error,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&P.deserialize(L,F.location)})})(u||(e.ITestErrorMessage=u={}));const k=(O,L)=>`${L?"s":"e"}${O}`;e.$lL=k;var h;(function(O){O.serialize=L=>({message:L.message,type:y.Output,offset:L.offset,length:L.length,location:L.location&&P.serialize(L.location)}),O.deserialize=(L,F)=>({message:F.message,type:y.Output,offset:F.offset,length:F.length,location:F.location&&P.deserialize(L,F.location)})})(h||(e.ITestOutputMessage=h={}));var r;(function(O){O.serialize=L=>L.type===y.Error?u.serialize(L):h.serialize(L),O.deserialize=(L,F)=>F.type===y.Error?u.deserialize(L,F):h.deserialize(L,F)})(r||(e.ITestMessage=r={}));var o;(function(O){O.serializeWithoutMessages=L=>({state:L.state,duration:L.duration,messages:[]}),O.serialize=L=>({state:L.state,duration:L.duration,messages:L.messages.map(r.serialize)}),O.deserialize=(L,F)=>({state:F.state,duration:F.duration,messages:F.messages.map(ie=>r.deserialize(L,ie))})})(o||(e.ITestTaskState=o={}));const c="\0",f=(O,L)=>O+c+L;e.$mL=f;const t=O=>{const L=O.indexOf(c);return{ctrlId:O.slice(0,L),tagId:O.slice(L+1)}};e.$nL=t;var s;(function(O){O.serialize=L=>({extId:L.extId,label:L.label,tags:L.tags,busy:L.busy,children:void 0,uri:L.uri?.toJSON(),range:L.range?.toJSON()||null,description:L.description,error:L.error,sortText:L.sortText}),O.deserialize=(L,F)=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?L.asCanonicalUri(b.URI.revive(F.uri)):void 0,range:F.range?I.$dt.lift(F.range):null,description:F.description,error:F.error,sortText:F.sortText})})(s||(e.ITestItem=s={}));var n;(function(O){O[O.NotExpandable=0]="NotExpandable",O[O.Expandable=1]="Expandable",O[O.BusyExpanding=2]="BusyExpanding",O[O.Expanded=3]="Expanded"})(n||(e.TestItemExpandState=n={}));var i;(function(O){O.serialize=L=>({expand:L.expand,item:s.serialize(L.item)}),O.deserialize=(L,F)=>({controllerId:T.$hL.root(F.item.extId),expand:F.expand,item:s.deserialize(L,F.item)})})(i||(e.InternalTestItem=i={}));var g;(function(O){O.serialize=L=>{let F;return L.item&&(F={},L.item.label!==void 0&&(F.label=L.item.label),L.item.tags!==void 0&&(F.tags=L.item.tags),L.item.busy!==void 0&&(F.busy=L.item.busy),L.item.uri!==void 0&&(F.uri=L.item.uri?.toJSON()),L.item.range!==void 0&&(F.range=L.item.range?.toJSON()),L.item.description!==void 0&&(F.description=L.item.description),L.item.error!==void 0&&(F.error=L.item.error),L.item.sortText!==void 0&&(F.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:F}},O.deserialize=L=>{let F;return L.item&&(F={},L.item.label!==void 0&&(F.label=L.item.label),L.item.tags!==void 0&&(F.tags=L.item.tags),L.item.busy!==void 0&&(F.busy=L.item.busy),L.item.range!==void 0&&(F.range=L.item.range?I.$dt.lift(L.item.range):null),L.item.description!==void 0&&(F.description=L.item.description),L.item.error!==void 0&&(F.error=L.item.error),L.item.sortText!==void 0&&(F.sortText=L.item.sortText)),{extId:L.extId,expand:L.expand,item:F}}})(g||(e.ITestItemUpdate=g={}));const d=(O,L)=>{L.expand!==void 0&&(O.expand=L.expand),L.item!==void 0&&(O.item=O.item?Object.assign(O.item,L.item):L.item)};e.$oL=d;var l;(function(O){O.serializeWithoutMessages=L=>({...i.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serializeWithoutMessages)}),O.serialize=L=>({...i.serialize(L),ownComputedState:L.ownComputedState,computedState:L.computedState,tasks:L.tasks.map(o.serialize)}),O.deserialize=(L,F)=>({...i.deserialize(L,F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(ie=>o.deserialize(L,ie)),retired:!0})})(l||(e.TestResultItem=l={}));var p;(function(O){O.empty=()=>({covered:0,total:0}),O.sum=(L,F)=>{L.covered+=F.covered,L.total+=F.total}})(p||(e.ICoverageCount=p={}));var C;(function(O){O.serialize=L=>({id:L.id,statement:L.statement,branch:L.branch,declaration:L.declaration,testId:L.testId?.toString(),uri:L.uri.toJSON()}),O.deserialize=(L,F)=>({id:F.id,statement:F.statement,branch:F.branch,declaration:F.declaration,testId:F.testId?T.$hL.fromString(F.testId):void 0,uri:L.asCanonicalUri(b.URI.revive(F.uri))}),O.empty=(L,F)=>({id:L,uri:F,testId:void 0,statement:p.empty()})})(C||(e.IFileCoverage=C={}));function S(O){return{...O,location:O.location?.toJSON()}}function v(O){return O.location=O.location?D.$ct.isIPosition(O.location)?D.$ct.lift(O.location):I.$dt.lift(O.location):void 0,O}e.$pL=3;var E;(function(O){O[O.Declaration=0]="Declaration",O[O.Statement=1]="Statement",O[O.Branch=2]="Branch"})(E||(e.DetailType=E={}));var R;(function(O){O.serialize=L=>L.type===E.Declaration?m.serialize(L):N.serialize(L),O.deserialize=L=>L.type===E.Declaration?m.deserialize(L):N.deserialize(L)})(R||(e.CoverageDetails=R={}));var w;(function(O){O.serialize=S,O.deserialize=v})(w||(e.IBranchCoverage=w={}));var m;(function(O){O.serialize=S,O.deserialize=v})(m||(e.IDeclarationCoverage=m={}));var N;(function(O){O.serialize=L=>({...S(L),branches:L.branches?.map(w.serialize)}),O.deserialize=L=>({...v(L),branches:L.branches?.map(w.deserialize)})})(N||(e.IStatementCoverage=N={}));var B;(function(O){O[O.Add=0]="Add",O[O.Update=1]="Update",O[O.DocumentSynced=2]="DocumentSynced",O[O.Remove=3]="Remove",O[O.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",O[O.Retire=5]="Retire",O[O.AddTag=6]="AddTag",O[O.RemoveTag=7]="RemoveTag"})(B||(e.TestDiffOpType=B={}));var X;(function(O){O.deserialize=(L,F)=>F.op===B.Add?{op:F.op,item:i.deserialize(L,F.item)}:F.op===B.Update?{op:F.op,item:g.deserialize(F.item)}:F.op===B.DocumentSynced?{op:F.op,uri:L.asCanonicalUri(b.URI.revive(F.uri)),docv:F.docv}:F,O.serialize=L=>L.op===B.Add?{op:L.op,item:i.serialize(L.item)}:L.op===B.Update?{op:L.op,item:g.serialize(L.item)}:L})(X||(e.TestsDiffOp=X={}));class V{constructor(L){this.k=L,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(L){const F=this.w();for(const ie of L)switch(ie.op){case B.Add:this.l(i.deserialize(this.k,ie.item),F);break;case B.Update:this.p(g.deserialize(ie.item),F);break;case B.Remove:this.q(ie.itemId,F);break;case B.Retire:this.v(ie.itemId);break;case B.IncrementPendingExtHosts:this.updatePendingRoots(ie.amount);break;case B.AddTag:this.c.set(ie.tag.id,ie.tag);break;case B.RemoveTag:this.c.delete(ie.id);break}F.complete?.()}l(L,F){const ie=T.$hL.parentId(L.item.extId)?.toString();let de;if(!ie)de=this.x(L),this.g.add(de),this.f.set(L.item.extId,de);else if(this.f.has(ie)){const be=this.f.get(ie);be.children.add(L.item.extId),de=this.x(L,be),this.f.set(L.item.extId,de)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(L)}`);return}return F.add?.(de),L.expand===n.BusyExpanding&&this.h++,de}p(L,F){const ie=this.f.get(L.extId);if(ie)return L.expand!==void 0&&(ie.expand===n.BusyExpanding&&this.h--,L.expand===n.BusyExpanding&&this.h++),(0,e.$oL)(ie,L),F.update?.(ie),ie}q(L,F){const ie=this.f.get(L);if(!ie)return;const de=T.$hL.parentId(ie.item.extId)?.toString();de?this.f.get(de).children.delete(ie.item.extId):this.g.delete(ie);const be=[[L]];for(;be.length;)for(const ve of be.pop()){const Z=this.f.get(ve);Z&&(be.push(Z.children),this.f.delete(ve),F.remove?.(Z,Z!==ie),Z.expand===n.BusyExpanding&&this.h--)}}v(L){}updatePendingRoots(L){this.j+=L}w(){return{}}}e.$qL=V}),define(Ce[240],Ie([1,0,98,200,56]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$iFb=e.$hFb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var T;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(T||(e.Testing=T={}));var A;(function(y){y.List="list",y.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var M;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(M||(e.TestExplorerViewSorting=M={}));const $={[I.TestResultState.Errored]:(0,D.localize)(0,null),[I.TestResultState.Failed]:(0,D.localize)(1,null),[I.TestResultState.Passed]:(0,D.localize)(2,null),[I.TestResultState.Queued]:(0,D.localize)(3,null),[I.TestResultState.Running]:(0,D.localize)(4,null),[I.TestResultState.Skipped]:(0,D.localize)(5,null),[I.TestResultState.Unset]:(0,D.localize)(6,null)},a=(y,u)=>(0,D.localize)(7,null,(0,b.$Tk)(y),$[u]);e.$hFb=a,e.$iFb={[I.TestRunProfileBitset.Debug]:(0,D.localize)(8,null),[I.TestRunProfileBitset.Run]:(0,D.localize)(9,null),[I.TestRunProfileBitset.Coverage]:(0,D.localize)(10,null)};var P;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(P||(e.TestCommandId=P={}))}),define(Ce[82],Ie([1,0,11,4,6,61,56,55]),function(_,e,b,D,I,T,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.TestItemEventOp=void 0;var $;(function(f){f[f.Upsert=0]="Upsert",f[f.SetTags=1]="SetTags",f[f.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",f[f.RemoveChild=3]="RemoveChild",f[f.SetProp=4]="SetProp",f[f.Bulk=5]="Bulk",f[f.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const a=(f,t)=>f===t,y=Object.entries({range:(f,t)=>f===t?!0:!f||!t?!1:f.equalsRange(t),busy:a,label:a,description:a,error:a,sortText:a,tags:(f,t)=>!(f.length!==t.length||f.some(s=>!t.includes(s)))}),u=(f,t)=>{let s;for(const[n,i]of y)i(f[n],t[n])||(s?s[n]=t[n]:s={[n]:t[n]});return s};class k extends I.$Uc{get root(){return this.s.root}constructor(t){super(),this.s=t,this.f=this.B(new b.$Mh(()=>this.flushDiff(),200)),this.g=this.B(new D.$he),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(t){this.h=t;for(const s of this.tree.values())this.J(s)}get resolveHandler(){return this.h}collectDiff(){const t=this.m;return this.m=[],t}pushDiff(t){switch(t.op){case A.TestDiffOpType.DocumentSynced:{for(const s of this.m)if(s.op===A.TestDiffOpType.DocumentSynced&&s.uri===t.uri){s.docv=t.docv;return}break}case A.TestDiffOpType.Update:{const s=this.m[this.m.length-1];if(s){if(s.op===A.TestDiffOpType.Update&&s.item.extId===t.item.extId){(0,A.$oL)(s.item,t.item);return}if(s.op===A.TestDiffOpType.Add&&s.item.item.extId===t.item.extId){(0,A.$oL)(s.item,t.item);return}}break}}this.m.push(t),this.f.isScheduled()||this.f.schedule()}expand(t,s){const n=this.tree.get(t);if(n){if((n.expandLevels===void 0||s>n.expandLevels)&&(n.expandLevels=s),n.expand===A.TestItemExpandState.Expandable){const i=this.M(n);return i.isOpen()?this.L(n,s-1):i.wait().then(()=>this.L(n,s-1))}else if(n.expand===A.TestItemExpandState.Expanded)return n.resolveBarrier?.isOpen()===!1?n.resolveBarrier.wait().then(()=>this.L(n,s-1)):this.L(n,s-1)}}dispose(){for(const t of this.tree.values())this.s.getApiFor(t.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(t,s){switch(s.op){case $.RemoveChild:this.O(M.$hL.joinToString(t.fullId,s.id));break;case $.Upsert:this.z(s.item,t);break;case $.Bulk:for(const n of s.ops)this.w(t,n);break;case $.SetTags:this.C(s.new,s.old,t.fullId.toString());break;case $.UpdateCanResolveChildren:this.J(t);break;case $.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),item:s.update}});break;case $.DocumentSynced:this.y(t.actual.uri);break;default:(0,T.$ed)(s)}}y(t){t&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:t,docv:this.s.getDocumentVersion(t)})}z(t,s){const n=M.$hL.fromExtHostTestItem(t,this.root.id,s?.actual),i=this.s.getApiFor(t);i.parent&&i.parent!==s?.actual&&this.s.getChildren(i.parent).delete(t.id);let g=this.tree.get(n.toString());if(!g){g={fullId:n,actual:t,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},t.tags.forEach(this.D,this),this.tree.set(g.fullId.toString(),g),this.G(t,s),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:g.expand,item:this.s.toITestItem(t)}}),this.I(t,g,s);return}if(g.actual===t){this.H(t,g,s);return}if(g.actual.uri?.toString()!==t.uri?.toString())return this.O(n.toString()),this.z(t,s);const d=this.s.getChildren(g.actual),l=g.actual,p=u(this.s.toITestItem(l),this.s.toITestItem(t));this.s.getApiFor(l).listener=void 0,g.actual=t,g.resolveBarrier=void 0,g.expand=A.TestItemExpandState.NotExpandable,p&&(p.hasOwnProperty("tags")&&(this.C(t.tags,l.tags,n.toString()),delete p.tags),this.w(g,{op:$.SetProp,update:p})),this.I(t,g,s);for(const[S,v]of d)this.s.getChildren(t).get(v.id)||this.O(M.$hL.joinToString(n,v.id));const C=g.expandLevels;C!==void 0&&queueMicrotask(()=>{g.expand===A.TestItemExpandState.Expandable&&(g.expandLevels=void 0,this.expand(n.toString(),C))}),this.y(g.actual.uri)}C(t,s,n){const i=new Set(s.map(g=>g.id));for(const g of t)i.delete(g.id)||this.D(g);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:n,item:{tags:t.map(g=>(0,A.$mL)(this.s.controllerId,g.id))}}}),i.forEach(this.F,this)}D(t){const s=this.j.get(t.id);s?s.refCount++:(this.j.set(t.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$mL)(this.s.controllerId,t.id)}}))}F(t){const s=this.j.get(t);s&&!--s.refCount&&(this.j.delete(t),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$mL)(this.s.controllerId,t)}))}G(t,s){this.s.getApiFor(t).parent=s&&s.actual!==this.root?s.actual:void 0}H(t,s,n){this.G(t,n);const i=this.s.getApiFor(t);i.parent=n?.actual,i.listener=g=>this.w(s,g),this.J(s)}I(t,s,n){this.H(t,s,n);for(const[i,g]of this.s.getChildren(t))this.z(g,s)}J(t){let s;this.h?t.resolveBarrier?s=t.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:s=t.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:s=A.TestItemExpandState.NotExpandable,s!==t.expand&&(t.expand=s,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),expand:s}}),s===A.TestItemExpandState.Expandable&&t.expandLevels!==void 0&&this.M(t))}L(t,s){if(s<0)return;const n=[];for(const[i,g]of this.s.getChildren(t.actual)){const d=this.expand(M.$hL.joinToString(t.fullId,g.id),s);(0,b.$mh)(d)&&n.push(d)}if(n.length)return Promise.all(n).then(()=>{})}M(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this.h){const g=new b.$zh;return g.open(),g}t.expand=A.TestItemExpandState.BusyExpanding,this.N(t);const s=t.resolveBarrier=new b.$zh,n=g=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,g)};let i;try{i=this.h(t.actual===this.root?void 0:t.actual)}catch(g){n(g)}return(0,b.$mh)(i)?i.catch(n).then(()=>{s.open(),this.J(t)}):(s.open(),this.J(t)),t.resolveBarrier}N(t){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t.fullId.toString(),expand:t.expand}})}O(t){const s=this.tree.get(t);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:t});const n=[s];for(;n.length;){const i=n.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const g of i.actual.tags)this.F(g.id);this.tree.delete(i.fullId.toString());for(const[g,d]of this.s.getChildren(i.actual))n.push(this.tree.get(M.$hL.joinToString(i.fullId,d.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.g.fire(t)}}e.$PO=k;class h extends Error{constructor(t){super(`Attempted to insert a duplicate test item ID ${t}`)}}e.$QO=h;class r extends Error{constructor(t){super(`TestItem with ID "${t}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$RO=r;class o extends Error{constructor(t,s,n){super(`TestItem with ID "${t}" is from controller "${s}" and cannot be added as a child of an item from controller "${n}".`)}}e.$SO=o;const c=(f,t,s)=>{let n=new Map;return{get size(){return n.size},forEach(i,g){for(const d of n.values())i.call(g,d,this)},[Symbol.iterator](){return n.entries()},replace(i){const g=new Map,d=new Set(n.keys()),l={op:$.Bulk,ops:[]};for(const p of i){if(!(p instanceof s))throw new r(p.id);const C=t(p).controllerId;if(C!==f.controllerId)throw new o(p.id,C,f.controllerId);if(g.has(p.id))throw new h(p.id);g.set(p.id,p),d.delete(p.id),l.ops.push({op:$.Upsert,item:p})}for(const p of d.keys())l.ops.push({op:$.RemoveChild,id:p});f.listener?.(l),n=g},add(i){if(!(i instanceof s))throw new r(i.id);n.set(i.id,i),f.listener?.({op:$.Upsert,item:i})},delete(i){n.delete(i)&&f.listener?.({op:$.RemoveChild,id:i})},get(i){return n.get(i)},toJSON(){return Array.from(n.values())}}};e.$TO=c}),define(Ce[114],Ie([1,0,82]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=void 0;const D=new WeakMap,I=(A,M)=>{const $={controllerId:M};return D.set(A,$),$};e.$UO=I;const T=A=>{const M=D.get(A);if(!M)throw new b.$RO(A?.id||"<unknown>");return M};e.$VO=T}),define(Ce[83],Ie([1,0,28,16,2]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OBb=e.$NBb=e.$MBb=void 0,e.$PBb=T,e.$QBb=M,e.$MBb="vscode-cdn.net",e.$NBb=`vscode-resource.${e.$MBb}`,e.$OBb=`'self' https://*.${e.$MBb}`;function T($,a){return $.scheme===D.Schemas.http||$.scheme===D.Schemas.https?$:(a&&a.authority&&a.isRemote&&$.scheme===D.Schemas.file&&($=I.URI.from({scheme:D.Schemas.vscodeRemote,authority:a.authority,path:$.path})),I.URI.from({scheme:D.Schemas.https,authority:`${$.scheme}+${A($.authority)}.${e.$NBb}`,path:$.path,fragment:$.fragment,query:$.query}))}function A($){return $.replace(/./g,a=>{const P=a.charCodeAt(0);return P>=b.CharCode.a&&P<=b.CharCode.z||P>=b.CharCode.A&&P<=b.CharCode.Z||P>=b.CharCode.Digit0&&P<=b.CharCode.Digit9?a:"-"+P.toString(16).padStart(4,"0")})}function M($){return $.replace(/-([0-9a-f]{4})/g,(a,P)=>String.fromCharCode(parseInt(P,16)))}}),define(Ce[241],Ie([1,0,4,6,83]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=void 0;class T{constructor(M,$,a){this.d=M,this.e=$,this.f=a,this.a=0,this.b=new D.$Tc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const P=$.getVisibleTextEditors();for(const y of this.c.values())P.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(M=>M.inset.dispose()),this.b.dispose()}createWebviewEditorInset(M,$,a,P,y){let u;for(const t of this.e.getVisibleTextEditors(!0))if(t.value===M){u=t;break}if(!u)throw new Error("not a visible editor");const k=this,h=this.a++,r=new b.$he,o=new b.$he,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(t){return(0,I.$PBb)(t,k.f)}get cspSource(){return I.$OBb}set options(t){this.b=t,k.d.$setOptions(h,t)}get options(){return this.b}set html(t){this.a=t,k.d.$setHtml(h,t)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(t){return k.d.$postMessage(h,t)}},f=new class{constructor(){this.editor=M,this.line=$,this.height=a,this.webview=c,this.onDidDispose=o.event}dispose(){k.c.has(h)&&(k.c.delete(h),k.d.$disposeEditorInset(h),o.fire(),o.dispose(),r.dispose())}};return this.d.$createEditorInset(h,u.id,u.value.document.uri,$+1,a,P||{},y.identifier,y.extensionLocation),this.c.set(h,{editor:M,inset:f,onDidReceiveMessage:r}),f}$onDidDispose(M){const $=this.c.get(M);$&&$.inset.dispose()}$onDidReceiveMessage(M,$){this.c.get(M)?.onDidReceiveMessage.fire($)}}e.$0mc=T}),define(Ce[115],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zL=e.$yL=e.$xL=void 0,e.$xL="__",e.$yL=(0,b.$Ai)("IAuthenticationService"),e.$zL=(0,b.$Ai)("IAuthenticationExtensionsService")}),define(Ce[242],Ie([1,0,3]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OP=e.VariableKind=e.$NP=void 0,e.$NP=(0,b.$Ai)("configurationResolverService");var D;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(D||(e.VariableKind=D={}));class I extends Error{constructor(A,M){super(M),this.variable=A}}e.$OP=I}),define(Ce[243],Ie([1,0,20,79,15,26,21,99,201,242,13]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;class y{constructor(k,h,r,o){this.h=new Map,this.a=k,this.b=h,this.g=r,o&&(this.c=o.then(c=>this.i(c)))}i(k){if(A.$c){const h=Object.create(null);return Object.keys(k).forEach(r=>{h[r.toLowerCase()]=k[r]}),h}return k}resolveWithEnvironment(k,h,r){return this.l({env:this.i(k),userHome:void 0},h?h.uri:void 0,r)}async resolveAsync(k,h){const r={env:await this.c,userHome:await this.g};return this.l(r,k?k.uri:void 0,h)}async j(k,h,r,o){const c=T.$0n(h);A.$c&&c.windows?Object.keys(c.windows).forEach(t=>c[t]=c.windows[t]):A.$d&&c.osx?Object.keys(c.osx).forEach(t=>c[t]=c.osx[t]):A.$e&&c.linux&&Object.keys(c.linux).forEach(t=>c[t]=c.linux[t]),delete c.windows,delete c.osx,delete c.linux;const f={env:await this.c,userHome:await this.g};return this.l(f,k?k.uri:void 0,c,r,o)}async resolveAnyAsync(k,h,r){return this.j(k,h,r)}async resolveAnyMap(k,h,r){const o=new Map;return{newConfig:await this.j(k,h,r,o),resolvedVariables:o}}resolveWithInteractionReplace(k,h,r,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,h,r,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,h){if(this.h.has(k))throw new Error("Variable "+k+" is contributed twice.");this.h.set(k,h)}async l(k,h,r,o,c){if(I.$ag(r))return this.m(k,h,r,o,c);if(Array.isArray(r))return Promise.all(r.map(f=>this.l(k,h,f,o,c)));if(I.$cg(r)){const f=Object.create(null),t=await Promise.all(Object.keys(r).map(async s=>[await this.m(k,h,s,o,c),await this.l(k,h,r[s],o,c)]));for(const[s,n]of t)f[s]=n;return f}return r}m(k,h,r,o,c){return(0,P.$tf)(r,y.VARIABLE_REGEXP,async(f,t)=>{if(t.includes(y.VARIABLE_LHS))return f;let s=await this.o(k,f,t,h,o);return c?.set(t,s),s!==f&&I.$ag(s)&&s.match(y.VARIABLE_REGEXP)&&(s=await this.m(k,h,s,o,c)),s})}n(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async o(k,h,r,o,c){let f;const t=r.split(":");t.length>1&&(r=t[0],f=t[1]);const s=g=>{const d=this.a.getFilePath();if(d)return(0,M.$Ow)(d);throw new a.$OP(g,(0,$.localize)(0,null,h))},n=g=>{const d=s(g);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,M.$Ow)(l)}throw new a.$OP(g,(0,$.localize)(1,null,h,b.$nc(d)))},i=g=>{if(f){const d=this.a.getFolderUri(f);if(d)return d;throw new a.$OP(g,(0,$.localize)(2,null,h,f))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new a.$OP(g,(0,$.localize)(3,null,h)):new a.$OP(g,(0,$.localize)(4,null,h))};switch(r){case"env":if(f){if(k.env){const g=k.env[A.$c?f.toLowerCase():f];if(I.$ag(g))return g}return""}throw new a.$OP(a.VariableKind.Env,(0,$.localize)(5,null,h));case"config":if(f){const g=this.a.getConfigurationValue(o,f);if(I.$jg(g))throw new a.$OP(a.VariableKind.Config,(0,$.localize)(6,null,h,f));if(I.$cg(g))throw new a.$OP(a.VariableKind.Config,(0,$.localize)(7,null,h,f));return g}throw new a.$OP(a.VariableKind.Config,(0,$.localize)(8,null,h));case"command":return this.p(a.VariableKind.Command,h,f,c,"command");case"input":return this.p(a.VariableKind.Input,h,f,c,"input");case"extensionInstallFolder":if(f){const g=await this.a.getExtension(f);if(!g)throw new a.$OP(a.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,h,f));return this.n(g.extensionLocation)}throw new a.$OP(a.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,h));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,M.$Ow)(this.n(i(a.VariableKind.WorkspaceFolder)));case"cwd":return o||f?(0,M.$Ow)(this.n(i(a.VariableKind.Cwd))):D.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,M.$Ow)(b.$nc(this.n(i(a.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new a.$OP(a.VariableKind.UserHome,(0,$.localize)(11,null,h))}case"lineNumber":{const g=this.a.getLineNumber();if(g)return g;throw new a.$OP(a.VariableKind.LineNumber,(0,$.localize)(12,null,h))}case"selectedText":{const g=this.a.getSelectedText();if(g)return g;throw new a.$OP(a.VariableKind.SelectedText,(0,$.localize)(13,null,h))}case"file":return s(a.VariableKind.File);case"fileWorkspaceFolder":return n(a.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return b.$nc(n(a.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||f?b.$lc(this.n(i(a.VariableKind.RelativeFile)),s(a.VariableKind.RelativeFile)):s(a.VariableKind.RelativeFile);case"relativeFileDirname":{const g=b.$mc(s(a.VariableKind.RelativeFileDirname));if(o||f){const d=b.$lc(this.n(i(a.VariableKind.RelativeFileDirname)),g);return d.length===0?".":d}return g}case"fileDirname":return b.$mc(s(a.VariableKind.FileDirname));case"fileExtname":return b.$oc(s(a.VariableKind.FileExtname));case"fileBasename":return b.$nc(s(a.VariableKind.FileBasename));case"fileBasenameNoExtension":{const g=b.$nc(s(a.VariableKind.FileBasenameNoExtension));return g.slice(0,g.length-b.$oc(g).length)}case"fileDirnameBasename":return b.$nc(b.$mc(s(a.VariableKind.FileDirnameBasename)));case"execPath":{const g=this.a.getExecPath();return g||h}case"execInstallFolder":{const g=this.a.getAppRoot();return g||h}case"pathSeparator":case"/":return b.sep;default:try{const g=f?`${r}:${f}`:r;return this.p(a.VariableKind.Unknown,h,g,c,void 0)}catch{return h}}}}p(k,h,r,o,c){if(r&&o){const f=c===void 0?o[r]:o[c+":"+r];if(typeof f=="string")return f;throw new a.$OP(k,(0,$.localize)(14,null,h))}return h}}e.$4P=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[116],Ie([1,0,3,113]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$$D=void 0,e.$_D=a,e.$aE=u,e.$bE=k,e.$$D=(0,b.$Ai)("editorGroupsService");var I;(function(h){h[h.UP=0]="UP",h[h.DOWN=1]="DOWN",h[h.LEFT=2]="LEFT",h[h.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var T;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var A;(function(h){h[h.FIRST=0]="FIRST",h[h.LAST=1]="LAST",h[h.NEXT=2]="NEXT",h[h.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var M;(function(h){h[h.MAXIMIZE=0]="MAXIMIZE",h[h.EXPAND=1]="EXPAND",h[h.EVEN=2]="EVEN"})(M||(e.GroupsArrangement=M={}));var $;(function(h){h[h.COPY_EDITORS=0]="COPY_EDITORS",h[h.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function a(h){const r=h;return(0,D.$VF)(r?.editor)&&(0,D.$VF)(r?.replacement)}var P;(function(h){h[h.CREATION_TIME=0]="CREATION_TIME",h[h.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",h[h.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(P||(e.GroupsOrder=P={}));var y;(function(h){h[h.NEW_EDITOR=1]="NEW_EDITOR",h[h.MOVE_EDITOR=2]="MOVE_EDITOR",h[h.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function u(h){const r=h;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function k(h){return h.getValue("workbench.editor.openSideBySideDirection")==="down"?I.DOWN:I.RIGHT}}),define(Ce[244],Ie([1,0,3,116]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fE=e.$eE=e.$dE=e.$cE=void 0,e.$gE=I,e.$cE=(0,b.$Ai)("editorService"),e.$dE=-1,e.$eE=-2,e.$fE=-3;function I(T){const A=T;return typeof T=="number"||(0,D.$aE)(A)}}),define(Ce[245],Ie([1,0,3,105]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SL=void 0,e.$SL=(0,b.$Bi)(D.$Hi)}),define(Ce[117],Ie([1,0,19,4,20,6,11]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$obc=e.$nbc=e.$mbc=e.$lbc=e.$kbc=void 0;class M{constructor(f,t){this.versionId=f,this.removedDueToLooping=t}}e.$kbc=M;class ${static isHostExtension(f,t,s){if(t.getExtensionDescription(f))return!1;const n=s.getExtensionDescription(f);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(f,t){this.j=f,this.c=new D.$he,this.onDidChange=this.c.event,this.d=0,this.e=t,this.k()}k(){this.e.sort(r),this.f=new b.$Zm,this.g=[],this.h=new Map;for(const f of this.e){if(this.f.has(f.identifier)){console.error("Extension `"+f.identifier.value+"` is already registered");continue}this.f.set(f.identifier,f),this.g.push(f);const t=this.j.readActivationEvents(f);for(const s of t)this.h.has(s)||this.h.set(s,[]),this.h.get(s).push(f)}}set(f){return this.e=f,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(f,t){this.e=o(this.e,t),this.e=this.e.concat(f);const s=$.l(this.e);return this.e=o(this.e,s.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new M(this.d,s)}static l(f){const t=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(d){this.d.has(d)||(this.d.add(d),this.e.push(d))}addArc(d,l){this.addNode(d),this.addNode(l),this.c.has(d)?this.c.get(d).push(l):this.c.set(d,[l])}getArcs(d){return this.c.has(d)?this.c.get(d):[]}hasOnlyGoodArcs(d,l){const p=t.getArcs(d);for(let C=0;C<p.length;C++)if(!l.has(p[C]))return!1;return!0}getNodes(){return this.e}},s=new b.$Zm;for(const d of f)if(s.set(d.identifier,d),d.extensionDependencies)for(const l of d.extensionDependencies)t.addArc(b.$Xm.toKey(d.identifier),b.$Xm.toKey(l));const n=new Set;t.getNodes().filter(d=>t.getArcs(d).length===0).forEach(d=>n.add(d));const i=t.getNodes().filter(d=>!n.has(d));let g;do{g=!1;for(let d=0;d<i.length;d++){const l=i[d];t.hasOnlyGoodArcs(l,n)&&(i.splice(d,1),d--,n.add(l),g=!0)}}while(g);return i.map(d=>s.get(d))}containsActivationEvent(f){return this.h.has(f)}containsExtension(f){return this.f.has(f)}getExtensionDescriptionsForActivationEvent(f){const t=this.h.get(f);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new a(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(f){const t=this.f.get(f);return t||void 0}getExtensionDescriptionByUUID(f){for(const t of this.g)if(t.uuid===f)return t}getExtensionDescriptionByIdOrUUID(f,t){return this.getExtensionDescription(f)??(t?this.getExtensionDescriptionByUUID(t):void 0)}}e.$lbc=$;class a{constructor(f,t){this.versionId=f,this.extensions=t}}e.$mbc=a;class P{constructor(f){this.d=new k,this.c=new $(f,[])}async acquireLock(f){const t=await this.d.acquire(f);return new y(this,t)}deltaExtensions(f,t,s){if(!f.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(t,s)}containsActivationEvent(f){return this.c.containsActivationEvent(f)}containsExtension(f){return this.c.containsExtension(f)}getExtensionDescriptionsForActivationEvent(f){return this.c.getExtensionDescriptionsForActivationEvent(f)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(f){return this.c.getExtensionDescription(f)}getExtensionDescriptionByUUID(f){return this.c.getExtensionDescriptionByUUID(f)}getExtensionDescriptionByIdOrUUID(f,t){return this.c.getExtensionDescriptionByIdOrUUID(f,t)}}e.$nbc=P;class y extends T.$Uc{constructor(f,t){super(),this.f=f,this.c=!1,this.B(t)}isAcquiredFor(f){return!this.c&&this.f===f}}e.$obc=y;class u{constructor(f){this.name=f;const t=(0,A.$th)();this.promise=t.promise,this.c=t.resolve}resolve(f){this.c(f)}}class k{constructor(){this.c=[],this.d=!1}async acquire(f){const t=new u(f);return this.c.push(t),this.e(),t.promise}e(){if(this.d||this.c.length===0)return;const f=this.c.shift();this.d=!0;let t=!0;const s=setTimeout(()=>{t&&console.warn(`The customer named ${f.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{t&&(clearTimeout(s),t=!1,this.d=!1,this.e())};f.resolve((0,T.$Sc)(n))}}var h;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(h||(h={}));function r(c,f){const t=c.isBuiltin?h.Builtin:c.isUnderDevelopment?h.Dev:h.User,s=f.isBuiltin?h.Builtin:f.isUnderDevelopment?h.Dev:h.User;if(t!==s)return t-s;const n=I.$gc.basename(c.extensionLocation.path),i=I.$gc.basename(f.extensionLocation.path);return n<i?-1:n>i?1:0}function o(c,f){const t=new b.$Ym(f);return c.filter(s=>!t.has(s.identifier))}}),define(Ce[84],Ie([1,0,23]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$6m=A,e.$7m=M;var D;(function(a){a[a.Desktop=1]="Desktop",a[a.Web=2]="Web"})(D||(e.UIKind=D={}));var I;(function(a){a[a.VersionMismatch=55]="VersionMismatch",a[a.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var T;(function(a){a[a.Initialized=0]="Initialized",a[a.Ready=1]="Ready",a[a.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function A(a){const P=b.$Je.alloc(1);switch(a){case T.Initialized:P.writeUInt8(1,0);break;case T.Ready:P.writeUInt8(2,0);break;case T.Terminate:P.writeUInt8(3,0);break}return P}function M(a,P){if(a.byteLength!==1)return!1;switch(a.readUInt8(0)){case 1:return P===T.Initialized;case 2:return P===T.Ready;case 3:return P===T.Terminate;default:return!1}}var $;(function(a){a.Start="START_NATIVE_LOG",a.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ce[66],Ie([1,0,3,4,111,12,27,84,62,63,26,2,6,186]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hP=e.$fP=e.$eP=void 0,e.$gP=o;let h=class extends u.$Uc{constructor(f,t){super(),this.s=f,this.t=t,this.a=this.B(new D.$he),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new D.$he),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=I.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=t.createLogger(this.m,{id:a.$tp,name:(0,k.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(t.onDidChangeLogLevel(s=>{(0,T.$9j)(s)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===T.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===I.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=I.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=I.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=I.TelemetryLevel.USAGE:!1}}instantiateLogger(f,t,s){const n=this.getTelemetryDetails(),i=new r(t,s,f,this.n,this.j,this.getBuiltInCommonProperties(f),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),g=this.r.get(f.identifier.value)??[];return this.r.set(f.identifier.value,[...g,i]),i.apiTelemetryLogger}$initializeTelemetryLevel(f,t,s){this.f=f,this.g=t,this.c=s??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(f){const t=Object.create(null);switch(t["common.extname"]=`${f.publisher}.${f.name}`,t["common.extversion"]=f.version,t["common.vscodemachineid"]=this.s.telemetryInfo.machineId,t["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,t["common.sqmid"]=this.s.telemetryInfo.sqmId,t["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,t["common.vscodeversion"]=this.s.version,t["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),t["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:t["common.uikind"]="web";break;case M.UIKind.Desktop:t["common.uikind"]="desktop";break;default:t["common.uikind"]="unknown"}return t["common.remotename"]=(0,$.$Om)((0,a.$zp)(this.s.remote.authority)),t}$onDidChangeTelemetryLevel(f){this.h=this.getTelemetryConfiguration(),this.f=f;const t=this.getTelemetryDetails();this.r.forEach((s,n)=>{const i=s.filter(g=>!g.isDisposed);i.length===0?this.r.delete(n):this.r.set(n,i)}),this.r.forEach(s=>{for(const n of s)n.updateTelemetryEnablements(t.isUsageEnabled,t.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(f,t){const n=this.r.get(f.value)?.filter(g=>!g.isDisposed);if(!n)return this.r.delete(f.value),!1;let i=!1;for(const g of n)g.ignoreUnhandledExtHostErrors||(g.logError(t),i=!0);return i}};e.$eP=h,e.$eP=h=Je([qe(0,A.$dP),qe(1,T.$8j)],h);class r{static validateSender(f){if(typeof f!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof f.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof f.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof f.flush<"u"&&typeof f.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(f,t,s,n,i,g,d){this.g=s,this.h=n,this.i=i,this.j=g,this.a=new D.$he,this.ignoreUnhandledExtHostErrors=t?.ignoreUnhandledErrors??!1,this.b=t?.ignoreBuiltInCommonProperties??!1,this.c=t?.additionalCommonProperties,this.f=f,this.d={isUsageEnabled:d.isUsageEnabled,isErrorsEnabled:d.isErrorsEnabled}}updateTelemetryEnablements(f,t){this.e&&(this.d={isUsageEnabled:f,isErrorsEnabled:t},this.a.fire(this.e))}mixInCommonPropsAndCleanData(f){let t="properties"in f?f.properties??{}:f;return t=(0,a.$Cp)(t,[]),this.c&&(t=(0,P.$ao)(t,this.c)),this.b||(t=(0,P.$ao)(t,this.j)),"properties"in f?f.properties=t:f=t,f}k(f,t){this.f&&(this.g.publisher==="vscode"?f=this.g.name+"/"+f:f=this.g.identifier.value+"/"+f,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f?.sendEventData(f,t),this.h.trace(f,t))}logUsage(f,t){this.d.isUsageEnabled&&this.k(f,t)}logError(f,t){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof f=="string")this.k(f,t);else{const s={name:f.name,message:f.message,stack:f.stack,cause:f.cause},n=(0,a.$Cp)(s,[]),i=new Error(n.message,{cause:n.cause});i.stack=n.stack,i.name=n.name,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f.sendErrorData(i,t),this.h.trace("exception",t)}}get apiTelemetryLogger(){if(!this.e){const f=this,t={logUsage:f.logUsage.bind(f),get isUsageEnabled(){return f.d.isUsageEnabled},get isErrorsEnabled(){return f.d.isErrorsEnabled},logError:f.logError.bind(f),dispose:f.dispose.bind(f),onDidChangeEnableStates:f.a.event.bind(f)};this.e=Object.freeze(t)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let f=this.f;this.f=void 0,Promise.resolve(f.flush()).then(f=void 0),this.e=void 0}else this.f=void 0}}e.$fP=r;function o(c){const f=Date.now()-new Date(c).getTime();return isNaN(f)?!1:f<1e3*60*60*24}e.$hP=(0,b.$Ai)("IExtHostTelemetry")}),define(Ce[25],Ie([1,0,4,2,217,110,19,3]),function(_,e,b,D,I,T,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1G=e.ActivationKind=e.$XG=e.$WG=e.$TG=e.ExtensionHostStartup=e.$SG=e.$RG=e.$QG=e.$PG=void 0,e.$UG=u,e.$VG=k,e.$YG=c,e.$ZG=f,e.$PG=Object.freeze({identifier:new A.$Xm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:D.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$QG="extensions.webWorker",e.$RG=(0,M.$Ai)("extensionService");class ${constructor(n){this.dependency=n}}e.$SG=$;var a;(function(s){s[s.EagerAutoStart=1]="EagerAutoStart",s[s.EagerManualStart=2]="EagerManualStart",s[s.Lazy=3]="Lazy"})(a||(e.ExtensionHostStartup=a={}));class P{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(n,i,g){this.c=n,this.d=i.slice(0),this.e=g.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$AG.createActivationEventsMap(this.d)}}set(n,i,g){if(this.c>n)throw new Error(`ExtensionHostExtensions: invalid versionId ${n} (current: ${this.c})`);const d=[],l=[],p=[],C=[],S=y(this.d),v=y(i),E=(B,X)=>B.extensionLocation.toString()===X.extensionLocation.toString()||B.isBuiltin===X.isBuiltin||B.isUserBuiltin===X.isUserBuiltin||B.isUnderDevelopment===X.isUnderDevelopment;for(const B of this.d){const X=v.get(B.identifier);if(!X){d.push(B.identifier),S.delete(B.identifier);continue}if(!E(B,X)){d.push(B.identifier),S.delete(B.identifier);continue}}for(const B of i){const X=S.get(B.identifier);if(!X){l.push(B);continue}if(!E(X,B)){d.push(X.identifier),S.delete(X.identifier);continue}}const R=new A.$Ym(this.e),w=new A.$Ym(g);for(const B of this.e)w.has(B)||p.push(B);for(const B of g)R.has(B)||C.push(B);const m=T.$AG.createActivationEventsMap(l),N={versionId:n,toRemove:d,toAdd:l,addActivationEvents:m,myToRemove:p,myToAdd:C};return this.delta(N),N}delta(n){if(this.c>=n.versionId)return null;const{toRemove:i,toAdd:g,myToRemove:d,myToAdd:l}=n,p=new A.$Ym(i),C=new A.$Ym(d);for(let S=0;S<this.d.length;S++)p.has(this.d[S].identifier)&&(this.d.splice(S,1),S--);for(let S=0;S<this.e.length;S++)C.has(this.e[S])&&(this.e.splice(S,1),S--);for(const S of g)this.d.push(S);for(const S of l)this.e.push(S);return this.f=null,n}containsExtension(n){for(const i of this.e)if(A.$Xm.equals(i,n))return!0;return!1}containsActivationEvent(n){return this.f||(this.f=this.g()),this.f.has(n)}g(){const n=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const g=T.$AG.readActivationEvents(i);for(const d of g)n.add(d)}return n}}e.$TG=P;function y(s){const n=new A.$Zm;for(const i of s)n.set(i.identifier,i);return n}function u(s,n){return!0}function k(s,n){if(!u(s,n))throw new Error(`Extension '${s.identifier.value}' CANNOT use API proposal: ${n}.
Its package.json#enabledApiProposals-property declares: ${s.enabledApiProposals?.join(", ")??"[]"} but NOT ${n}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${s.identifier.value}`)}class h{constructor(n,i,g,d){this.codeLoadingTime=n,this.activateCallTime=i,this.activateResolvedTime=g,this.activationReason=d}}e.$WG=h;class r{constructor(n,i){this.description=n,this.value=i}}e.$XG=r;var o;(function(s){s[s.Normal=0]="Normal",s[s.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function c(s){return{type:s.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:s.isBuiltin||s.isUserBuiltin,identifier:{id:(0,I.$Ip)(s.publisher,s.name),uuid:s.uuid},manifest:s,location:s.extensionLocation,targetPlatform:s.targetPlatform,validations:[],isValid:!0}}function f(s,n){return{identifier:new A.$Xm((0,I.$Gp)(s.manifest.publisher,s.manifest.name)),isBuiltin:s.type===A.ExtensionType.System,isUserBuiltin:s.type===A.ExtensionType.User&&s.isBuiltin,isUnderDevelopment:!!n,extensionLocation:s.location,...s.manifest,uuid:s.identifier.uuid,targetPlatform:s.targetPlatform,publisherDisplayName:s.publisherDisplayName}}class t{constructor(){this.onDidRegisterExtensions=b.Event.None,this.onDidChangeExtensionsStatus=b.Event.None,this.onDidChangeExtensions=b.Event.None,this.onWillActivateByEvent=b.Event.None,this.onDidChangeResponsiveChange=b.Event.None,this.onWillStop=b.Event.None,this.extensions=[]}activateByEvent(n){return Promise.resolve(void 0)}activateById(n,i){return Promise.resolve(void 0)}activationEventIsDone(n){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(n){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(n,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(n){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$1G=t}),define(Ce[246],Ie([1,0,14,117,19,25,12,11]),function(_,e,b,D,I,T,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ync=e.$xnc=e.$wnc=e.$vnc=e.$unc=e.$tnc=void 0;class ${constructor(c,f,t,s){this.startup=c,this.codeLoadingTime=f,this.activateCallTime=t,this.activateResolvedTime=s}}e.$tnc=$,$.NONE=new $(!1,-1,-1,-1);class a{constructor(c){this.a=c,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(c,f){return c===-1||f===-1?-1:f-c}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$unc=a;class P{constructor(c,f,t,s,n,i){this.activationFailed=c,this.activationFailedError=f,this.activationTimes=t,this.module=s,this.exports=n,this.subscriptions=i}}e.$vnc=P;class y extends P{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.$wnc=y;class u extends P{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xnc=u;class k extends P{constructor(c){super(!0,c,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let h=class{constructor(c,f,t,s){this.g=s,this.a=c,this.b=f,this.c=t,this.d=new I.$Zm,this.f=Object.create(null)}dispose(){for(const[c,f]of this.d)f.dispose()}async waitForActivatingExtensions(){const c=[];for(const[f,t]of this.d)c.push(t.wait());await Promise.all(c)}isActivated(c){const f=this.d.get(c);return!!(f&&f.value)}getActivatedExtension(c){const f=this.d.get(c);if(!f||!f.value)throw new Error(`Extension '${c.value}' is not known or not activated`);return f.value}async activateByEvent(c,f){if(this.f[c])return;const t=this.a.getExtensionDescriptionsForActivationEvent(c);await this.h(t.map(s=>({id:s.identifier,reason:{startup:f,extensionId:s.identifier,activationEvent:c}}))),this.f[c]=!0}activateById(c,f){const t=this.a.getExtensionDescription(c);if(!t)throw new Error(`Extension '${c.value}' is not known`);return this.h([{id:t.identifier,reason:f}])}async h(c){const f=c.filter(t=>!this.isActivated(t.id)).map(t=>this.j(t));await Promise.all(f.map(t=>t.wait()))}j(c){if(this.d.has(c.id))return this.d.get(c.id);if(this.l(c.id))return this.k(c,null,[],null);const f=this.a.getExtensionDescription(c.id);if(!f){const n=new Error(`Cannot activate unknown extension '${c.id.value}'`),i=this.k(c,null,[],new k(n));return this.c.onExtensionActivationError(c.id,n,new T.$SG(c.id.value)),i}const t=[],s=typeof f.extensionDependencies>"u"?[]:f.extensionDependencies;for(const n of s){if(this.m(n))continue;const i=this.d.get(n);if(i){t.push(i);continue}if(this.l(n)){t.push(this.j({id:this.b.getExtensionDescription(n).identifier,reason:c.reason}));continue}const g=this.a.getExtensionDescription(n);if(g){if(!g.main&&!g.browser)continue;t.push(this.j({id:g.identifier,reason:c.reason}));continue}const d=f.displayName||f.identifier.value,l=new Error(`Cannot activate the '${d}' extension because it depends on unknown extension '${n}'`),p=this.k(c,f.displayName,[],new k(l));return this.c.onExtensionActivationError(f.identifier,l,new T.$SG(n)),p}return this.k(c,f.displayName,t,null)}k(c,f,t,s){const n=new r(c.id,f,c.reason,t,s,this.c,this.g);return this.d.set(c.id,n),n}l(c){return D.$lbc.isHostExtension(c,this.a,this.b)}m(c){const f=this.b.getExtensionDescription(c);return f?!f.main&&!f.browser:!1}};e.$ync=h,e.$ync=h=Je([qe(3,A.$7j)],h);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(c,f,t,s,n,i,g){this.c=c,this.d=f,this.f=t,this.g=s,this.h=n,this.j=i,this.k=g,this.a=new M.$zh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let c=0;c<this.g.length;c++){const f=this.g[c];if(f.value&&!f.value.activationFailed){this.g.splice(c,1),c--;continue}if(f.value&&f.value.activationFailed){const t=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${f.friendlyName}' failed to activate`);t.detail=f.value.activationFailedError,this.h=new k(t),this.j.onExtensionActivationError(this.c,t,null);return}}this.g.length>0&&await Promise.race(this.g.map(c=>c.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(c){const f=new Error;if(c&&c.name&&(f.name=c.name),c&&c.message?f.message=`Activating extension '${this.c.value}' failed: ${c.message}.`:f.message=`Activating extension '${this.c.value}' failed: ${c}.`,c&&c.stack&&(f.stack=c.stack),this.h=new k(f),this.b&&b.$4(c))return;this.j.onExtensionActivationError(this.c,f,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(c)}}};r=Je([qe(6,A.$7j)],r)}),define(Ce[247],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatParticipantPrivate:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[118],Ie([1,0,203,14,35,109,78,31,19,247,107,110]),function(_,e,b,D,I,T,A,M,$,a,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=void 0;const u=M.$ko.as(A.$lo.JSONContribution);class k{constructor(n,i,g){this.a=n,this.b=i,this.c=g}d(n,i){this.a({type:n,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(n){this.d(I.default.Error,n)}warn(n){this.d(I.default.Warning,n)}info(n){this.d(I.default.Info,n)}}e.$JG=k;class h{static a(n){const i=new $.$Ym;for(let g=0,d=n.length;g<d;g++)i.add(n[g].description.identifier);return i}static compute(n,i){if(!n||!n.length)return new h(i,[]);if(!i||!i.length)return new h([],n);const g=this.a(n),d=this.a(i),l=i.filter(C=>!g.has(C.description.identifier)),p=n.filter(C=>!d.has(C.description.identifier));return new h(l,p)}constructor(n,i){this.added=n,this.removed=i}}e.$KG=h;class r{constructor(n,i){this.name=n,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(n){if(this.a!==null)throw new Error("Handler already set!");return this.a=n,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(n){this.c=h.compute(this.b,n),this.b=n,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(n){(0,D.$1)(n)}}}e.$LG=r;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[b.localize(0,null),b.localize(1,null)]},c="vscode://schemas/vscode-extensions";e.$MG={properties:{engines:{type:"object",description:b.localize(2,null),properties:{vscode:{type:"string",description:b.localize(3,null),default:"^1.22.0"}}},publisher:{description:b.localize(4,null),type:"string"},displayName:{description:b.localize(5,null),type:"string"},categories:{description:b.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$Wm},{type:"string",const:"Languages",deprecationMessage:b.localize(7,null)}]}},galleryBanner:{type:"object",description:b.localize(8,null),properties:{color:{description:b.localize(9,null),type:"string"},theme:{description:b.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:b.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:b.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:b.localize(13,null)},enabledApiProposals:{markdownDescription:b.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(a.allApiProposals),markdownEnumDescriptions:Object.values(a.allApiProposals)}},api:{markdownDescription:b.localize(15,null),type:"string",enum:["none"],enumDescriptions:[b.localize(16,null)]},activationEvents:{description:b.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:b.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:b.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:b.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:b.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:b.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:b.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:b.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:b.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:b.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:b.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:b.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:b.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:b.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:b.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:b.localize(32,null)},{label:"onUri",body:"onUri",description:b.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:b.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:b.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:b.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:b.localize(37,null)},{label:"onRenderer",description:b.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:b.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:b.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:b.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:b.localize(42,null)},{label:"*",description:b.localize(43,null),body:"*"}]}},badges:{type:"array",description:b.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:b.localize(45,null)},href:{type:"string",description:b.localize(46,null)},description:{type:"string",description:b.localize(47,null)}}}},markdown:{type:"string",description:b.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:b.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:b.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$2o}},extensionPack:{description:b.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$2o}},extensionKind:{description:b.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:b.localize(53,null)},{body:["workspace"],description:b.localize(54,null)},{body:["ui","workspace"],description:b.localize(55,null)},{body:["workspace","ui"],description:b.localize(56,null)},{body:[],description:b.localize(57,null)}]},capabilities:{description:b.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:b.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:b.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[b.localize(61,null),b.localize(62,null),b.localize(63,null)]},description:{type:"string",markdownDescription:b.localize(64,null)}}},untrustedWorkspaces:{description:b.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:b.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[b.localize(67,null),b.localize(68,null),b.localize(69,null)]},restrictedConfigurations:{description:b.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:b.localize(71,null)}}}}},sponsor:{description:b.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:b.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:b.localize(74,null),type:"string"},"vscode:uninstall":{description:b.localize(75,null),type:"string"}}},icon:{type:"string",description:b.localize(76,null)},l10n:{type:"string",description:b.localize(77,null)},pricing:{type:"string",markdownDescription:b.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class f{constructor(){this.a=new Map}registerExtensionPoint(n){if(this.a.has(n.extensionPoint))throw new Error("Duplicate extension point: "+n.extensionPoint);const i=new r(n.extensionPoint,n.defaultExtensionKind);return this.a.set(n.extensionPoint,i),n.activationEventsGenerator&&y.$AG.register(n.extensionPoint,n.activationEventsGenerator),e.$MG.properties.contributes.properties[n.extensionPoint]=n.jsonSchema,u.registerSchema(c,e.$MG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$NG=f;const t={ExtensionsRegistry:"ExtensionsRegistry"};M.$ko.add(t.ExtensionsRegistry,new f),e.$OG=M.$ko.as(t.ExtensionsRegistry),u.registerSchema(c,e.$MG),u.registerSchema(P.$ok,{properties:{extensionEnabledApiProposals:{description:b.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(a.allApiProposals),markdownEnumDescriptions:Object.values(a.allApiProposals)}}]}}}})}),define(Ce[248],Ie([1,0,4,40,6,13,195,19,3,12,25,118]),function(_,e,b,D,I,T,A,M,$,a,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4G=e.$3G=e.$2G=e.ChatMessageRole=void 0;var u;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(u||(e.ChatMessageRole=u={})),e.$2G=(0,$.$Ai)("ILanguageModelsService");const k={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(0,null)}}};e.$3G=y.$OG.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(1,null),oneOf:[k,{type:"array",items:k}]},activationEventsGenerator:(r,o)=>{for(const c of r)o.push(`onLanguageModelChat:${c.vendor}`)}});let h=class{constructor(o,c){this.e=o,this.f=c,this.a=new I.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new b.$he),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$3G.setHandler(f=>{this.c.clear();for(const s of f){if(!(0,P.$UG)(s.description,"chatProvider")){s.collector.error((0,A.localize)(2,null));continue}for(const n of D.Iterable.wrap(s.value)){if(this.c.has(n.vendor)){s.collector.error((0,A.localize)(3,null,n.vendor));continue}if((0,T.$$e)(n.vendor)){s.collector.error((0,A.localize)(4,null));continue}if(n.vendor.trim()!==n.vendor){s.collector.error((0,A.localize)(5,null));continue}this.c.add(n.vendor)}}const t=[];for(const[s,n]of this.b)this.c.has(n.metadata.vendor)||(this.b.delete(s),t.push(s));t.length>0&&this.d.fire({removed:t})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(o){return this.b.get(o)?.metadata}async selectLanguageModels(o){if(o.vendor)await this.e.activateByEvent(`onLanguageModelChat:${o.vendor}}`);else{const f=Array.from(this.c).map(t=>this.e.activateByEvent(`onLanguageModelChat:${t}`));await Promise.all(f)}const c=[];for(const[f,t]of this.b)(o.vendor===void 0||t.metadata.vendor===o.vendor)&&(o.family===void 0||t.metadata.family===o.family)&&(o.version===void 0||t.metadata.version===o.version)&&(o.identifier===void 0||t.metadata.id===o.identifier)&&(!t.metadata.targetExtensions||t.metadata.targetExtensions.some(s=>M.$Xm.equals(s,o.extension)))&&c.push(f);return this.f.trace("[LM] selected language models",o,c),c}registerLanguageModelChat(o,c){if(this.f.trace("[LM] registering language model chat",o,c.metadata),!this.c.has(c.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${c.metadata.vendor}.`);if(this.b.has(o))throw new Error(`Chat response provider with identifier ${o} is already registered.`);return this.b.set(o,c),this.d.fire({added:[{identifier:o,metadata:c.metadata}]}),(0,I.$Sc)(()=>{this.b.delete(o)&&(this.d.fire({removed:[o]}),this.f.trace("[LM] UNregistered language model chat",o,c.metadata))})}makeLanguageModelChatRequest(o,c,f,t,s,n){const i=this.b.get(o);if(!i)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return i.provideChatResponse(f,c,t,s,n)}computeTokenLength(o,c,f){const t=this.b.get(o);if(!t)throw new Error(`Chat response provider with identifier ${o} is not registered.`);return t.provideTokenCount(c,f)}};e.$4G=h,e.$4G=h=Je([qe(0,P.$RG),qe(1,a.$7j)],h)}),define(Ce[249],Ie([1,0,198,15,26,118,32,4]),function(_,e,b,D,I,T,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uI=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:b.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:b.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:b.localize(2,null),default:""}}};var a;(function(u){function k(h,r,o){if(!h)return;const c=D.$ag(h.type)?h.type:void 0;if(!c||c.length===0){o.error(b.localize(3,null));return}const f=[];if(Array.isArray(h.required))for(const t of h.required)D.$ag(t)&&f.push(t);return{extensionId:r.value,taskType:c,required:f,properties:h.properties?I.$0n(h.properties):{},when:h.when?A.$yj.deserialize(h.when):void 0}}u.from=k})(a||(a={}));const P=T.$OG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(u,k)=>{for(const h of u)h.type&&k.push(`onTaskType:${h.type}`)},jsonSchema:{description:b.localize(4,null),type:"array",items:$}});class y{constructor(){this.d=new M.$he,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,h)=>{P.setHandler((r,o)=>{this.c=void 0;try{for(const c of o.removed){const f=c.value;for(const t of f)this.a&&t.type&&this.a[t.type]&&delete this.a[t.type]}for(const c of o.added){const f=c.value;for(const t of f){const s=a.from(t,c.description.identifier,c.collector);s&&(this.a[s.taskType]=s)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const h of this.all()){const r={type:"object",additionalProperties:!1};h.required.length>0&&(r.required=h.required.slice(0)),h.properties!==void 0?r.properties=I.$0n(h.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[h.taskType]},k.push(r)}this.c={oneOf:k}}return this.c}}e.$uI=new y}),define(Ce[250],Ie([1,0,199,15,24,26,32,249,42]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$EI=e.JsonSchemaVersion=e.ExecutionEngine=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$yI=e.ShellQuoting=e.$xI=e.$wI=e.$vI=void 0,e.$vI="settings",e.$wI=new A.$Rj("taskRunning",!1,b.localize(0,null)),e.$xI=b.localize2(2,"Tasks");var a;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(a||(e.ShellQuoting=a={})),e.$yI="$customized",function(L){function F(ie){if(!ie)return L.Strong;switch(ie.toLowerCase()){case"escape":return L.Escape;case"strong":return L.Strong;case"weak":return L.Weak;default:return L.Strong}}L.from=F}(a||(e.ShellQuoting=a={}));var P;(function(L){L.defaults={cwd:"${workspaceFolder}"}})(P||(e.CommandOptions=P={}));var y;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(y||(e.RevealKind=y={})),function(L){function F(ie){switch(ie.toLowerCase()){case"always":return L.Always;case"silent":return L.Silent;case"never":return L.Never;default:return L.Always}}L.fromString=F}(y||(e.RevealKind=y={}));var u;(function(L){L[L.Never=1]="Never",L[L.OnProblem=2]="OnProblem",L[L.Always=3]="Always"})(u||(e.RevealProblemKind=u={})),function(L){function F(ie){switch(ie.toLowerCase()){case"always":return L.Always;case"never":return L.Never;case"onproblem":return L.OnProblem;default:return L.OnProblem}}L.fromString=F}(u||(e.RevealProblemKind=u={}));var k;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(k||(e.PanelKind=k={})),function(L){function F(ie){switch(ie.toLowerCase()){case"shared":return L.Shared;case"dedicated":return L.Dedicated;case"new":return L.New;default:return L.Shared}}L.fromString=F}(k||(e.PanelKind=k={}));var h;(function(L){L.defaults={echo:!0,reveal:y.Always,revealProblems:u.Never,focus:!1,panel:k.Shared,showReuseMessage:!0,clear:!1}})(h||(e.PresentationOptions=h={}));var r;(function(L){L[L.Shell=1]="Shell",L[L.Process=2]="Process",L[L.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(L){function F(de){switch(de.toLowerCase()){case"shell":return L.Shell;case"process":return L.Process;case"customExecution":return L.CustomExecution;default:return L.Process}}L.fromString=F;function ie(de){switch(de){case L.Shell:return"shell";case L.Process:return"process";case L.CustomExecution:return"customExecution";default:return"process"}}L.toString=ie}(r||(e.RuntimeType=r={}));var o;(function(L){function F(ie){return D.$ag(ie)?ie:ie.value}L.value=F})(o||(e.CommandString=o={}));var c;(function(L){L.Clean={_id:"clean",isDefault:!1},L.Build={_id:"build",isDefault:!1},L.Rebuild={_id:"rebuild",isDefault:!1},L.Test={_id:"test",isDefault:!1};function F(de){return de===L.Clean._id||de===L.Build._id||de===L.Rebuild._id||de===L.Test._id}L.is=F;function ie(de){if(de!==void 0)return D.$ag(de)?F(de)?{_id:de,isDefault:!1}:void 0:de}L.from=ie})(c||(e.TaskGroup=c={}));var f;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.Folder=3]="Folder"})(f||(e.TaskScope=f={}));var t;(function(L){L.Workspace="workspace",L.Extension="extension",L.InMemory="inMemory",L.WorkspaceFile="workspaceFile",L.User="user";function F(ie){switch(ie){case L.User:return $.ConfigurationTarget.USER;case L.WorkspaceFile:return $.ConfigurationTarget.WORKSPACE;default:return $.ConfigurationTarget.WORKSPACE_FOLDER}}L.toConfigurationTarget=F})(t||(e.TaskSourceKind=t={}));var s;(function(L){L.parallel="parallel",L.sequence="sequence"})(s||(e.DependsOrder=s={}));var n;(function(L){L[L.default=1]="default",L[L.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var i;(function(L){L.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(i||(e.RunOptions=i={}));class g{constructor(F,ie,de,be,ve,Z){this._label="",this._id=F,ie&&(this._label=ie),de&&(this.type=de),this.runOptions=be,this.configurationProperties=ve,this._source=Z}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,ie=!1){if(F===void 0)return!1;if(D.$ag(F))return F===this._label||F===this.configurationProperties.identifier||ie&&F===this._id;const de=this.getDefinition(!0);return de!==void 0&&de._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$zI=g;class d extends g{constructor(F,ie,de,be,ve,Z,ae,fe){super(F,de,void 0,ae,fe,ie),this.command={},this._source=ie,this.hasDefinedMatchers=Z,ve&&(this.command=ve)}clone(){return new d(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let ie;switch(this.command?this.command.runtime:void 0){case r.Shell:ie="shell";break;case r.Process:ie="process";break;case r.CustomExecution:ie="customExecution";break;case void 0:ie="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ie,_key:this._id,id:this._id}}}static is(F){return F instanceof d}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===t.User?e.$vI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let ie=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(ie+=this._source.kind);const de={type:e.$yI,folder:F,id:ie};return JSON.stringify(de)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$$g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new d(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$AI=d;class l extends g{constructor(F,ie,de,be,ve,Z,ae){super(F,de,be,Z,ae,ie),this._source=ie,this.configures=ve}static is(F){return F instanceof l}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$$g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===t.User?e.$vI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let ie=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(ie+=this._source.kind);const de={type:e.$yI,folder:F,id:ie};return JSON.stringify(de)}}e.$BI=l;class p extends g{constructor(F,ie,de,be,ve,Z,ae,fe,ee){super(F,de,be,fe,ee,ie),this.defines=ve,this.hasDefinedMatchers=ae,this.command=Z,this.icon=ee.icon,this.hide=ee.hide}clone(){return new p(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof p}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===f.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new p(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$CI=p;class C extends g{constructor(F,ie,de,be,ve,Z){super(F,de,be,ve,Z,ie),this._source=ie}clone(){return new C(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof C}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new C(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$DI=C;var S;(function(L){L[L.Process=1]="Process",L[L.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(L){L._default=L.Terminal}(S||(e.ExecutionEngine=S={}));var v;(function(L){L[L.V0_1_0=1]="V0_1_0",L[L.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class E{constructor(F){this.c=new Map;for(let ie=0;ie<F.length;ie++)this.c.set(F[ie].uri.toString(),ie)}compare(F,ie){const de=F.getWorkspaceFolder(),be=ie.getWorkspaceFolder();if(de&&be){let ve=this.c.get(de.uri.toString());ve=ve===void 0?0:ve+1;let Z=this.c.get(be.uri.toString());return Z=Z===void 0?0:Z+1,ve===Z?F._label.localeCompare(ie._label):ve-Z}else return!de&&be?-1:de&&!be?1:0}}e.$EI=E;var R;(function(L){L.DependsOnStarted="dependsOnStarted",L.AcquiredInput="acquiredInput",L.Start="start",L.ProcessStarted="processStarted",L.Active="active",L.Inactive="inactive",L.Changed="changed",L.Terminated="terminated",L.ProcessEnded="processEnded",L.End="end"})(R||(e.TaskEventKind=R={}));var w;(function(L){L.SingleRun="singleRun",L.Background="background"})(w||(e.TaskRunType=w={}));var m;(function(L){L[L.System=0]="System",L[L.User=1]="User",L[L.FolderOpen=2]="FolderOpen",L[L.ConfigurationChange=3]="ConfigurationChange",L[L.Reconnect=4]="Reconnect"})(m||(e.TaskRunSource=m={}));var N;(function(L){function F(fe){return{taskId:fe._id,taskName:fe.configurationProperties.name,runType:fe.configurationProperties.isBackground?w.Background:w.SingleRun,group:fe.configurationProperties.group,__task:fe}}function ie(fe,ee,De){return{...F(fe),kind:R.Start,terminalId:ee,resolvedVariables:De}}L.start=ie;function de(fe,ee,De){return{...F(fe),kind:R.ProcessStarted,terminalId:ee,processId:De}}L.processStarted=de;function be(fe,ee,De){return{...F(fe),kind:R.ProcessEnded,terminalId:ee,exitCode:De}}L.processEnded=be;function ve(fe,ee,De){return{...F(fe),kind:R.Terminated,exitReason:De,terminalId:ee}}L.terminated=ve;function Z(fe,ee,De){return{...F(ee),kind:fe,terminalId:De}}L.general=Z;function ae(){return{kind:R.Changed}}L.changed=ae})(N||(e.TaskEvent=N={}));var B;(function(L){function F(de){const be=Object.keys(de).sort();let ve="";for(const Z of be){let ae=de[Z];ae instanceof Object?ae=F(ae):typeof ae=="string"&&(ae=ae.replace(/,/g,",,")),ve+=Z+","+ae+","}return ve}function ie(de){const ve={_key:F(de),type:de.taskType};return Object.assign(ve,de),ve}L.create=ie})(B||(e.KeyedTaskIdentifier=B={}));var X;(function(L){L.AutoDetect="task.autoDetect",L.SaveBeforeRun="task.saveBeforeRun",L.ShowDecorations="task.showDecorations",L.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",L.SlowProviderWarning="task.slowProviderWarning",L.QuickOpenHistory="task.quickOpen.history",L.QuickOpenDetail="task.quickOpen.detail",L.QuickOpenSkip="task.quickOpen.skip",L.QuickOpenShowAll="task.quickOpen.showAll",L.AllowAutomaticTasks="task.allowAutomaticTasks",L.Reconnection="task.reconnection",L.VerboseLogging="task.verboseLogging"})(X||(e.TaskSettingId=X={}));var V;(function(L){L.Tasks="tasks",L.SuppressTaskName="tasks.suppressTaskName",L.Windows="tasks.windows",L.Osx="tasks.osx",L.Linux="tasks.linux",L.ShowOutput="tasks.showOutput",L.IsShellCommand="tasks.isShellCommand",L.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var O;(function(L){function F(ie,de){const be=M.$uI.get(ie.type);if(be===void 0){const fe=T.$0n(ie);return delete fe._key,B.create(fe)}const ve=Object.create(null);ve.type=be.taskType;const Z=new Set;be.required.forEach(fe=>Z.add(fe));const ae=be.properties;for(const fe of Object.keys(ae)){const ee=ie[fe];if(ee!=null)ve[fe]=ee;else if(Z.has(fe)){const De=ae[fe];if(De.default!==void 0)ve[fe]=T.$0n(De.default);else switch(De.type){case"boolean":ve[fe]=!1;break;case"number":case"integer":ve[fe]=0;break;case"string":ve[fe]="";break;default:de.error(b.localize(1,null,JSON.stringify(ie,void 0,0),fe));return}}}return B.create(ve)}L.createTaskIdentifier=F})(O||(e.TaskDefinition=O={}))}),define(Ce[251],Ie([1,0,14]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=e.$pbc=void 0;class D{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,M)=>{this.b=A,this.d=M,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,b.$1)(A))}then(A,M){return this.j().then(A,M)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$pbc=D;class I extends D{constructor(){super(),this.h=!0,this.i=new b.$5}}e.$qbc=I}),define(Ce[38],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lw=e.$Iw=void 0,e.$Jw=I,e.$Kw=T;class b{constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++b.count}}e.$Iw=b,b.count=0;const D=[];function I(M){const $=new b(M);return D[$.nid]=$,$}function T(M){return D[M].sid}class A{constructor($){this.value=$}}e.$Lw=A}),define(Ce[5],Ie([1,0,38]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=e.$vM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$uM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var D;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(D||(e.TextEditorRevealType=D={}));var I;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(I||(e.TabInputKind=I={}));var T;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var M;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(M||(e.WebviewMessageArrayBufferViewType=M={}));var $;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var a;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(a||(e.NotebookEditorRevealType=a={}));var P;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(P||(e.CandidatePortSource=P={}));class y{static mixin(o){return o._id=y.a++,o}}e.$uM=y,y.a=0;var u;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(u||(e.ISuggestDataDtoField=u={}));var k;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(k||(e.ISuggestResultDtoField=k={}));var h;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(h||(e.ExtHostTestingResource=h={})),e.$vM={MainThreadAuthentication:(0,b.$Jw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,b.$Jw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,b.$Jw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,b.$Jw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,b.$Jw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,b.$Jw)("MainThreadChatVariables"),MainThreadClipboard:(0,b.$Jw)("MainThreadClipboard"),MainThreadCommands:(0,b.$Jw)("MainThreadCommands"),MainThreadComments:(0,b.$Jw)("MainThreadComments"),MainThreadConfiguration:(0,b.$Jw)("MainThreadConfiguration"),MainThreadConsole:(0,b.$Jw)("MainThreadConsole"),MainThreadDebugService:(0,b.$Jw)("MainThreadDebugService"),MainThreadDecorations:(0,b.$Jw)("MainThreadDecorations"),MainThreadDiagnostics:(0,b.$Jw)("MainThreadDiagnostics"),MainThreadDialogs:(0,b.$Jw)("MainThreadDiaglogs"),MainThreadDocuments:(0,b.$Jw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,b.$Jw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,b.$Jw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,b.$Jw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,b.$Jw)("MainThreadEditorTabs"),MainThreadErrors:(0,b.$Jw)("MainThreadErrors"),MainThreadTreeViews:(0,b.$Jw)("MainThreadTreeViews"),MainThreadDownloadService:(0,b.$Jw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,b.$Jw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,b.$Jw)("MainThreadLanguages"),MainThreadLogger:(0,b.$Jw)("MainThreadLogger"),MainThreadMessageService:(0,b.$Jw)("MainThreadMessageService"),MainThreadOutputService:(0,b.$Jw)("MainThreadOutputService"),MainThreadProgress:(0,b.$Jw)("MainThreadProgress"),MainThreadQuickDiff:(0,b.$Jw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,b.$Jw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,b.$Jw)("MainThreadStatusBar"),MainThreadSecretState:(0,b.$Jw)("MainThreadSecretState"),MainThreadStorage:(0,b.$Jw)("MainThreadStorage"),MainThreadSpeech:(0,b.$Jw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,b.$Jw)("MainThreadTelemetry"),MainThreadTerminalService:(0,b.$Jw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,b.$Jw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,b.$Jw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,b.$Jw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,b.$Jw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,b.$Jw)("MainThreadCustomEditors"),MainThreadUrls:(0,b.$Jw)("MainThreadUrls"),MainThreadUriOpeners:(0,b.$Jw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,b.$Jw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,b.$Jw)("MainThreadWorkspace"),MainThreadFileSystem:(0,b.$Jw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,b.$Jw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,b.$Jw)("MainThreadExtensionService"),MainThreadSCM:(0,b.$Jw)("MainThreadSCM"),MainThreadSearch:(0,b.$Jw)("MainThreadSearch"),MainThreadShare:(0,b.$Jw)("MainThreadShare"),MainThreadTask:(0,b.$Jw)("MainThreadTask"),MainThreadWindow:(0,b.$Jw)("MainThreadWindow"),MainThreadLabelService:(0,b.$Jw)("MainThreadLabelService"),MainThreadNotebook:(0,b.$Jw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,b.$Jw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,b.$Jw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,b.$Jw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,b.$Jw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,b.$Jw)("MainThreadInteractive"),MainThreadTheming:(0,b.$Jw)("MainThreadTheming"),MainThreadTunnelService:(0,b.$Jw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,b.$Jw)("MainThreadManagedSockets"),MainThreadTimeline:(0,b.$Jw)("MainThreadTimeline"),MainThreadTesting:(0,b.$Jw)("MainThreadTesting"),MainThreadLocalization:(0,b.$Jw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,b.$Jw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,b.$Jw)("MainThreadAiEmbeddingVector")},e.$wM={ExtHostCommands:(0,b.$Jw)("ExtHostCommands"),ExtHostConfiguration:(0,b.$Jw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,b.$Jw)("ExtHostDiagnostics"),ExtHostDebugService:(0,b.$Jw)("ExtHostDebugService"),ExtHostDecorations:(0,b.$Jw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,b.$Jw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,b.$Jw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,b.$Jw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,b.$Jw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,b.$Jw)("ExtHostEditors"),ExtHostTreeViews:(0,b.$Jw)("ExtHostTreeViews"),ExtHostFileSystem:(0,b.$Jw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,b.$Jw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,b.$Jw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,b.$Jw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,b.$Jw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,b.$Jw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,b.$Jw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,b.$Jw)("ExtHostStatusBar"),ExtHostShare:(0,b.$Jw)("ExtHostShare"),ExtHostExtensionService:(0,b.$Jw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,b.$Jw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,b.$Jw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,b.$Jw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,b.$Jw)("ExtHostSCM"),ExtHostSearch:(0,b.$Jw)("ExtHostSearch"),ExtHostTask:(0,b.$Jw)("ExtHostTask"),ExtHostWorkspace:(0,b.$Jw)("ExtHostWorkspace"),ExtHostWindow:(0,b.$Jw)("ExtHostWindow"),ExtHostWebviews:(0,b.$Jw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,b.$Jw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,b.$Jw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,b.$Jw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,b.$Jw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,b.$Jw)("ExtHostEditorTabs"),ExtHostProgress:(0,b.$Jw)("ExtHostProgress"),ExtHostComments:(0,b.$Jw)("ExtHostComments"),ExtHostSecretState:(0,b.$Jw)("ExtHostSecretState"),ExtHostStorage:(0,b.$Jw)("ExtHostStorage"),ExtHostUrls:(0,b.$Jw)("ExtHostUrls"),ExtHostUriOpeners:(0,b.$Jw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,b.$Jw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,b.$Jw)("ExtHostOutputService"),ExtHostLabelService:(0,b.$Jw)("ExtHostLabelService"),ExtHostNotebook:(0,b.$Jw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,b.$Jw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,b.$Jw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,b.$Jw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,b.$Jw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,b.$Jw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,b.$Jw)("ExtHostInteractive"),ExtHostChatAgents2:(0,b.$Jw)("ExtHostChatAgents"),ExtHostChatVariables:(0,b.$Jw)("ExtHostChatVariables"),ExtHostChatProvider:(0,b.$Jw)("ExtHostChatProvider"),ExtHostSpeech:(0,b.$Jw)("ExtHostSpeech"),ExtHostEmbeddings:(0,b.$Jw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,b.$Jw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,b.$Jw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,b.$Jw)("ExtHostTheming"),ExtHostTunnelService:(0,b.$Jw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,b.$Jw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,b.$Jw)("ExtHostAuthentication"),ExtHostTimeline:(0,b.$Jw)("ExtHostTimeline"),ExtHostTesting:(0,b.$Jw)("ExtHostTesting"),ExtHostTelemetry:(0,b.$Jw)("ExtHostTelemetry"),ExtHostLocalization:(0,b.$Jw)("ExtHostLocalization")}}),define(Ce[85],Ie([1,0,3,12,5,17]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=e.$Tmc=e.$Smc=void 0,e.$Smc=(0,b.$Ai)("IExtHostApiDeprecationService");let A=class{constructor($,a){this.c=a,this.a=new Set,this.b=$.getProxy(I.$vM.MainThreadTelemetry)}report($,a,P){const y=this.d($,a);this.a.has(y)||(this.a.add(y),a.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${P}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:a.identifier.value,apiId:$}))}d($,a){return`${$}-${a.identifier.value}`}};e.$Tmc=A,e.$Tmc=A=Je([qe(0,T.$ZO),qe(1,D.$7j)],A),e.$Umc=Object.freeze(new class{report(M,$,a){}})}),define(Ce[252],Ie([1,0,5]),function(_,e,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8mc=void 0;class D{constructor(T){const A=T.getProxy(b.$vM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(M){return A.$writeText(M)}})}}e.$8mc=D}),define(Ce[253],Ie([1,0,26,5,27,17]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2oc=void 0;let A=class{constructor(P,y){this.a=P.getProxy(D.$vM.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(P,y){const u=this,k=console[P];Object.defineProperty(console,P,{set:()=>{},get:()=>function(){u.e(P,y,k,arguments)}})}e(P,y,u,k){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:$(k,this.b)}),this.c&&this.f(P,u,k)}};e.$2oc=A,e.$2oc=A=Je([qe(0,T.$ZO),qe(1,I.$dP)],A);const M=1e5;function $(a,P){const y=[];if(a.length)for(let u=0;u<a.length;u++){let k=a[u];if(typeof k>"u")k="undefined";else if(k instanceof Error){const h=k;h.stack?k=h.stack:k=h.toString()}y.push(k)}if(P){const u=new Error().stack;u&&y.push({__$stack:u.split(`
`).slice(3).join(`
`)})}try{const u=(0,b.$co)(y);return u.length>M?"Output omitted for a large object that exceeds the limits":u}catch(u){return`Output omitted for an object that cannot be inspected ('${u.toString()}')`}}}),define(Ce[254],Ie([1,0,2,5,25]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=void 0;class T{constructor(M){this.a=M.getProxy(D.$vM.MainThreadDialogs)}showOpenDialog(M,$){return $?.allowUIResources&&(0,I.$VG)(M,"showLocal"),this.a.$showOpenDialog($).then(a=>a?a.map(P=>b.URI.revive(P)):void 0)}showSaveDialog(M){return this.a.$showSaveDialog(M).then($=>$?b.URI.revive($):void 0)}}e.$5nc=T}),define(Ce[255],Ie([1,0,22,4,6,5]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=void 0;class A{constructor($){this.b=new Map,this.c=new D.$he,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=$.getProxy(T.$vM.MainThreadEmbeddings)}registerEmbeddingsProvider($,a,P){if(this.d.has(a))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,a),this.b.set(y,{id:a,provider:P}),(0,I.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings($,a,P){P??(P=b.CancellationToken.None);let y=!1;typeof a=="string"&&(a=[a],y=!0);const u=await this.a.$computeEmbeddings($,a,P);if(u.length!==a.length)throw new Error;if(y){if(u.length!==1)throw new Error;return u[0]}return u}async $provideEmbeddings($,a,P){const y=this.b.get($);if(!y)return[];const u=await y.provider.provideEmbeddings(a,P);return u||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels($){this.d=new Set($),this.c.fire()}}e.$8nc=A}),define(Ce[256],Ie([1,0,6,5]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$moc=void 0;class I{constructor(A){this.b=0,this.a=A.getProxy(D.$vM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const M=this.b++;return this.a.$registerResourceLabelFormatter(M,A),(0,b.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(M)})}}e.$moc=I}),define(Ce[86],Ie([1,0,21,13,2,3,12,5,27,17]),function(_,e,b,D,I,T,A,M,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=e.$Mnc=void 0;let P=class{constructor(u,k,h){this.f=h,this.d=new Map,this.a=k.getProxy(M.$vM.MainThreadLocalization),this.b=u.environment.appLanguage,this.c=this.b===b.$a}getMessage(u,k){const{message:h,args:r,comment:o}=k;if(this.c)return(0,D.$af)(h,r??{});let c=h;o&&o.length>0&&(c+=`/${Array.isArray(o)?o.join(""):o}`);const f=this.d.get(u)?.contents[c];return f||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,D.$af)(f??h,r??{})}getBundle(u){return this.d.get(u)?.contents}getBundleUri(u){return this.d.get(u)?.uri}async initializeLocalizedMessages(u){if(this.c||!u.l10n&&!u.isBuiltin||this.d.has(u.identifier.value))return;let k;const h=await this.g(u);if(!h){this.f.error(`No bundle location found for extension ${u.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(h),o=JSON.parse(r);k=u.isBuiltin?o.contents?.bundle:o}catch(r){this.f.error(`Failed to load translations for ${u.identifier.value} from ${h}: ${r.message}`);return}k&&this.d.set(u.identifier.value,{contents:k,uri:h})}async g(u){if(u.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(u.identifier.value,this.b);return I.URI.revive(k)}return u.l10n?I.URI.joinPath(u.extensionLocation,u.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Mnc=P,e.$Mnc=P=Je([qe(0,$.$dP),qe(1,a.$ZO),qe(2,A.$7j)],P),e.$Nnc=(0,T.$Ai)("IExtHostLocalizationService")}),define(Ce[257],Ie([1,0,12,5,27,17,2,48]),function(_,e,b,D,I,T,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1oc=void 0;let $=class extends b.$fk{constructor(y,u){super(u.logLevel,u.logsLocation,u.loggers.map(k=>(0,M.$0h)(k))),this.r=y.getProxy(D.$vM.MainThreadLogger)}$setLogLevel(y,u){u?this.setLogLevel(A.URI.revive(u),y):this.setLogLevel(y)}setVisibility(y,u){super.setVisibility(y,u),this.r.$setVisibility(y,u)}s(y,u,k){return new a(this.r,y,u,k)}};e.$1oc=$,e.$1oc=$=Je([qe(0,T.$ZO),qe(1,I.$dP)],$);class a extends b.$ak{constructor(y,u,k,h){super(h?.logLevel==="always"),this.r=y,this.s=u,this.m=!1,this.n=[],this.setLevel(k),this.r.$createLogger(u,h).then(()=>{this.u(this.n),this.m=!0})}g(y,u){const k=[[y,u]];this.m?this.u(k):this.n.push(...k)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ce[87],Ie([1,0,5,3,6,17,23]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=e.$Onc=void 0,e.$Onc=(0,D.$Ai)("IExtHostManagedSockets");let M=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(b.$vM.MainThreadManagedSockets)}setFactory(y,u){for(const k of this.d.values())k.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(y,u),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const u=++this.b,k=await this.c.makeConnection(),h=new I.$Tc;return this.d.set(u,new a(u,k,h)),h.add((0,I.$Sc)(()=>this.d.delete(u))),h.add(k.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(u),h.dispose()})),h.add(k.onDidClose(r=>{this.a.$onDidManagedSocketClose(u,r?.stack??r?.message),h.dispose()})),h.add(k.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(u,A.$Je.wrap(r)))),u}$remoteSocketWrite(y,u){this.d.get(y)?.actual.send(u.buffer)}$remoteSocketEnd(y){const u=this.d.get(y);u&&(u.actual.end(),u.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$Pnc=M,e.$Pnc=M=Je([qe(0,T.$ZO)],M);class ${constructor(y,u){this.socketFactoryId=y,this.makeConnection=u}}class a extends I.$Uc{constructor(y,u,k){super(),this.socketId=y,this.actual=u,this.B(k)}}}),define(Ce[258],Ie([1,0,5,12,25]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ooc=void 0;function T(M){return M&&M.title}let A=class{constructor($,a){this.b=a,this.a=$.getProxy(b.$vM.MainThreadMessageService)}showMessage($,a,P,y,u){const k={source:{identifier:$.identifier,label:$.displayName||$.name}};let h;typeof y=="string"||T(y)?h=[y,...u]:(k.modal=y?.modal,k.useCustom=y?.useCustom,k.detail=y?.detail,h=u),k.useCustom&&(0,I.$VG)($,"resolvers");const r=[];let o=!1;for(let c=0;c<h.length;c++){const f=h[c];if(typeof f=="string")r.push({title:f,handle:c,isCloseAffordance:!1});else if(typeof f=="object"){const{title:t,isCloseAffordance:s}=f;r.push({title:t,isCloseAffordance:!!s,handle:c}),s&&(o?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,f):o=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,f)}return this.a.$showMessage(a,P,k,r).then(c=>{if(typeof c=="number")return h[c]})}};e.$ooc=A,e.$ooc=A=Je([qe(1,D.$7j)],A)}),define(Ce[259],Ie([1,0,6,15,2,25,5]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xoc=void 0;class M{constructor(a){this.b=new Map,this.a=a.getProxy(A.$vM.MainThreadProfileContentHandlers)}registerProfileContentHandler(a,P,y){if((0,T.$VG)(a,"profileContentHandlers"),this.b.has(P))throw new Error(`Handler with id '${P}' already registered`);return this.b.set(P,y),this.a.$registerProfileContentHandler(P,y.name,y.description,a.identifier.value),(0,b.$Sc)(()=>{this.b.delete(P),this.a.$unregisterProfileContentHandler(P)})}async $saveProfile(a,P,y,u){const k=this.b.get(a);if(!k)throw new Error(`Unknown handler with id: ${a}`);return k.saveProfile(P,y,u)}async $readProfile(a,P,y){const u=this.b.get(a);if(!u)throw new Error(`Unknown handler with id: ${a}`);return u.readProfile((0,D.$ag)(P)?P:I.URI.revive(P),y)}}e.$xoc=M}),define(Ce[88],Ie([1,0,5,4,3]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Knc=e.$Jnc=void 0;class T{constructor(M){this.b=new D.$he,this.onDidChangePassword=this.b.event,this.a=M.getProxy(b.$vM.MainThreadSecretState)}async $onDidChangePassword(M){this.b.fire(M)}get(M,$){return this.a.$getPassword(M,$)}store(M,$,a){return this.a.$setPassword(M,$,a)}delete(M,$){return this.a.$deletePassword(M,$)}}e.$Jnc=T,e.$Knc=(0,I.$Ai)("IExtHostSecretState")}),define(Ce[260],Ie([1,0,22,6,5]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eoc=void 0;class T{constructor(M){this.c=new Map,this.d=new Map,this.f=new Map,this.b=M.getProxy(I.$vM.MainThreadSpeech)}async $createSpeechToTextSession(M,$,a){const P=this.c.get(M);if(!P)return;const y=new D.$Tc,u=new b.$se;this.d.set($,u);const k=await P.provideSpeechToTextSession(u.token,a?{language:a}:void 0);k&&(y.add(k.onDidChange(h=>{u.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,h)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M)}async $createTextToSpeechSession(M,$,a){const P=this.c.get(M);if(!P)return;const y=new D.$Tc,u=new b.$se;this.d.set($,u);const k=await P.provideTextToSpeechSession(u.token,a?{language:a}:void 0);k&&(this.f.set($,k),y.add(k.onDidChange(h=>{u.token.isCancellationRequested||this.b.$emitTextToSpeechEvent($,h)})),y.add(u.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(M,$){this.f.get(M)?.synthesize($)}async $cancelTextToSpeechSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M),this.f.delete(M)}async $createKeywordRecognitionSession(M,$){const a=this.c.get(M);if(!a)return;const P=new D.$Tc,y=new b.$se;this.d.set($,y);const u=await a.provideKeywordRecognitionSession(y.token);u&&(P.add(u.onDidChange(k=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,k)})),P.add(y.token.onCancellationRequested(()=>P.dispose())))}async $cancelKeywordRecognitionSession(M){this.d.get(M)?.dispose(!0),this.d.delete(M)}registerProvider(M,$,a){const P=T.a++;return this.c.set(P,a),this.b.$registerProvider(P,$,{extension:M,displayName:M.value}),(0,D.$Sc)(()=>{this.b.$unregisterProvider(P),this.c.delete(P)})}}e.$Eoc=T,T.a=1}),define(Ce[89],Ie([1,0,5,4,3]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=e.$znc=void 0;class T{constructor(M,$){this.c=$,this.b=new D.$he,this.onDidChangeStorage=this.b.event,this.a=M.getProxy(b.$vM.MainThreadStorage)}registerExtensionStorageKeysToSync(M,$){this.a.$registerExtensionStorageKeysToSync(M,$)}async initializeExtensionStorage(M,$,a){const P=await this.a.$initializeExtensionStorage(M,$);let y;return P&&(y=this.d(M,$,P)),y||a}setValue(M,$,a){return this.a.$setValue(M,$,a)}$acceptValue(M,$,a){const P=this.d(M,$,a);P&&this.b.fire({shared:M,key:$,value:P})}d(M,$,a){try{return JSON.parse(a)}catch(P){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${M}): ${P}`)}}}e.$znc=T,e.$Anc=(0,I.$Ai)("IExtHostStorage")}),define(Ce[261],Ie([1,0,6,16,2,5]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uoc=void 0;class A{constructor($){this.c=new Map,this.b=$.getProxy(T.$vM.MainThreadUriOpeners)}registerExternalUriOpener($,a,P,y){if(this.c.has(a))throw new Error(`Opener with id '${a}' already registered`);const u=y.schemes.find(k=>!A.a.has(k));if(u)throw new Error(`Scheme '${u}' is not supported. Only http and https are currently supported.`);return this.c.set(a,P),this.b.$registerUriOpener(a,y.schemes,$,y.label),(0,b.$Sc)(()=>{this.c.delete(a),this.b.$unregisterUriOpener(a)})}async $canOpenUri($,a,P){const y=this.c.get($);if(!y)throw new Error(`Unknown opener with id: ${$}`);const u=I.URI.revive(a);return y.canOpenExternalUri(u,P)}async $openUri($,a,P){const y=this.c.get($);if(!y)throw new Error(`Unknown opener id: '${$}'`);return y.openExternalUri(I.URI.revive(a.resolvedUri),{sourceUri:I.URI.revive(a.sourceUri)},P)}}e.$Uoc=A,A.a=new Set([D.Schemas.http,D.Schemas.https])}),define(Ce[262],Ie([1,0,5,2,6,14,19]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Voc=void 0;class M{constructor(a){this.c=new A.$Ym,this.d=new Map,this.b=a.getProxy(b.$vM.MainThreadUrls)}registerUriHandler(a,P){const y=a.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const u=M.a++;return this.c.add(y),this.d.set(u,P),this.b.$registerUriHandler(u,y,a.displayName||a.name),(0,I.$Sc)(()=>{this.c.delete(y),this.d.delete(u),this.b.$unregisterUriHandler(u)})}$handleExternalUri(a,P){const y=this.d.get(a);if(!y)return Promise.resolve(void 0);try{y.handleUri(D.URI.revive(P))}catch(u){(0,T.$1)(u)}return Promise.resolve(void 0)}async createAppUri(a){return D.URI.revive(await this.b.$createAppUri(a))}}e.$Voc=M,M.a=0}),define(Ce[263],Ie([1,0,23,5]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bsb=T,e.$csb=M;class I{constructor(){this.buffers=[]}add(a){let P=this.buffers.indexOf(a);return P<0&&(P=this.buffers.length,this.buffers.push(a)),P}}function T($,a){if(a.serializeBuffersForPostMessage){const P=new I,u=JSON.stringify($,(h,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:P.add(r)};if(ArrayBuffer.isView(r)){const o=A(r);if(o)return{$$vscode_array_buffer_reference$$:!0,index:P.add(r.buffer),view:{type:o,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),k=P.buffers.map(h=>{const r=new Uint8Array(h);return b.$Je.wrap(r)});return{message:u,buffers:k}}else return{message:JSON.stringify($),buffers:[]}}function A($){switch($.constructor.name){case"Int8Array":return D.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return D.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return D.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return D.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return D.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return D.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return D.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return D.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return D.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return D.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return D.WebviewMessageArrayBufferViewType.BigUint64Array}}function M($,a){const P=a.map(k=>{const h=new ArrayBuffer(k.byteLength);return new Uint8Array(h).set(k.buffer),h}),y=a.length?(k,h)=>{if(h&&typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const r=h,{index:o}=r,c=P[o];if(r.view)switch(r.view.type){case D.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(c,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(c,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(c,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(c,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(c,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(c,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(c,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(c,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(c,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(c,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case D.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(c,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return h}:void 0;return{message:JSON.parse($,y),arrayBuffers:P}}});var tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b},Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)};define(Ce[67],Ie([1,0,4,6,16,26,2,206,263,83,5]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";var y,u,k,h,r,o,c,f,t,s,n,i,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=e.$knc=void 0,e.$lnc=l,e.$nnc=S,e.$onc=v;class d{constructor(m,N,B,X,V,O,L){y.set(this,void 0),u.set(this,void 0),k.set(this,void 0),h.set(this,void 0),r.set(this,void 0),o.set(this,void 0),c.set(this,""),f.set(this,void 0),t.set(this,!1),s.set(this,!1),n.set(this,void 0),i.set(this,void 0),this._onMessageEmitter=new b.$he,this.onDidReceiveMessage=this._onMessageEmitter.event,g.set(this,new b.$he),this._onDidDispose=Be(this,g,"f").event,tt(this,y,m,"f"),tt(this,u,N,"f"),tt(this,f,B,"f"),tt(this,h,X,"f"),tt(this,r,V,"f"),tt(this,o,O,"f"),tt(this,n,l(O),"f"),tt(this,i,p(O),"f"),tt(this,k,L,"f")}dispose(){tt(this,t,!0,"f"),Be(this,g,"f").fire(),Be(this,g,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return tt(this,s,!0,"f"),(0,a.$PBb)(m,Be(this,h,"f"))}get cspSource(){const m=Be(this,o,"f").extensionLocation;if(m.scheme===I.Schemas.https||m.scheme===I.Schemas.http){let N=m.toString();return N.endsWith("/")||(N+="/"),N+" "+a.$OBb}return a.$OBb}get html(){return this.a(),Be(this,c,"f")}set html(m){this.a(),Be(this,c,"f")!==m&&(tt(this,c,m,"f"),Be(this,i,"f")&&!Be(this,s,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(tt(this,s,!0,"f"),Be(this,k,"f").report("Webview vscode-resource: uris",Be(this,o,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,u,"f").$setHtml(Be(this,y,"f"),this.b(m)))}get options(){return this.a(),Be(this,f,"f")}set options(m){this.a(),T.$bo(Be(this,f,"f"),m)||Be(this,u,"f").$setOptions(Be(this,y,"f"),v(Be(this,o,"f"),Be(this,r,"f"),m)),tt(this,f,m,"f")}async postMessage(m){if(Be(this,t,"f"))return!1;const N=(0,$.$bsb)(m,{serializeBuffersForPostMessage:Be(this,n,"f")});return Be(this,u,"f").$postMessage(Be(this,y,"f"),N.message,...N.buffers)}a(){if(Be(this,t,"f"))throw new Error("Webview is disposed")}b(m){if(!Be(this,i,"f"))return m;const N=Be(this,o,"f").extensionLocation?.scheme===I.Schemas.vscodeRemote,B=Be(this,o,"f").extensionLocation.scheme===I.Schemas.vscodeRemote?Be(this,o,"f").extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(X,V,O,L,F,ie)=>{const de=A.URI.from({scheme:L||"file",path:decodeURIComponent(F)}),be=(0,a.$PBb)(de,{isRemote:N,authority:B}).toString();return`${V}${be}${ie}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(X,V,O,L,F,ie)=>{const de=A.URI.from({scheme:L||"file",path:decodeURIComponent(F)}),be=(0,a.$PBb)(de,{isRemote:N,authority:B}).toString();return`${V}${be}${ie}`})}}e.$knc=d,y=new WeakMap,u=new WeakMap,k=new WeakMap,h=new WeakMap,r=new WeakMap,o=new WeakMap,c=new WeakMap,f=new WeakMap,t=new WeakMap,s=new WeakMap,n=new WeakMap,i=new WeakMap,g=new WeakMap;function l(w){try{const m=(0,M.$Rp)((0,M.$Qp)(w.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}function p(w){try{const m=(0,M.$Rp)((0,M.$Qp)(w.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class C extends D.$Uc{constructor(m,N,B,X,V){super(),this.c=N,this.f=B,this.g=X,this.h=V,this.b=new Map,this.a=m.getProxy(P.$vM.MainThreadWebviews)}dispose(){super.dispose();for(const m of this.b.values())m.dispose();this.b.clear()}$onMessage(m,N,B){const X=this.j(m);if(X){const{message:V}=(0,$.$csb)(N,B.value);X._onMessageEmitter.fire(V)}}$onMissingCsp(m,N){this.g.warn(`${N} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,N,B){const X=new d(m,this.a,E(N),this.c,this.f,B,this.h);this.b.set(m,X);const V=X._onDidDispose(()=>{V.dispose(),this.deleteWebview(m)});return X}deleteWebview(m){this.b.delete(m)}j(m){return this.b.get(m)}}e.$mnc=C;function S(w){return{id:w.identifier,location:w.extensionLocation}}function v(w,m,N){return{enableCommandUris:N.enableCommandUris,enableScripts:N.enableScripts,enableForms:N.enableForms,portMapping:N.portMapping,localResourceRoots:N.localResourceRoots||R(w,m)}}function E(w){return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,enableForms:w.enableForms,portMapping:w.portMapping,localResourceRoots:w.localResourceRoots?.map(m=>A.URI.from(m))}}function R(w,m){return[...(m?.getWorkspaceFolders()||[]).map(N=>N.uri),w.extensionLocation]}}),define(Ce[119],Ie([1,0,4,16,13,2,3,17,5]),function(_,e,b,D,I,T,A,M,$){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Yoc=e.$Xoc=void 0;let P=a=class{getState(){const u=this.d;return{get focused(){return u.focused},get active(){return u.active}}}constructor(u){this.c=new b.$he,this.onDidChangeWindowState=this.c.event,this.d=a.a,this.b=u.getProxy($.$vM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:k,isActive:h})=>{this.onDidChangeWindowProperty("focused",k),this.onDidChangeWindowProperty("active",h)})}$onDidChangeWindowFocus(u){this.onDidChangeWindowProperty("focused",u)}$onDidChangeWindowActive(u){this.onDidChangeWindowProperty("active",u)}onDidChangeWindowProperty(u,k){k!==this.d[u]&&(this.d={...this.d,[u]:k},this.c.fire(this.d))}openUri(u,k){let h;if(typeof u=="string"){h=u;try{u=T.URI.parse(u)}catch{return Promise.reject(`Invalid uri - '${u}'`)}}return(0,I.$$e)(u.scheme)?Promise.reject("Invalid scheme - cannot be empty"):u.scheme===D.Schemas.command?Promise.reject(`Invalid scheme '${u.scheme}'`):this.b.$openUri(u,h,k)}async asExternalUri(u,k){if((0,I.$$e)(u.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this.b.$asExternalUri(u,k);return T.URI.from(h)}};e.$Xoc=P,P.a={focused:!0,active:!0},e.$Xoc=P=a=Je([qe(0,M.$ZO)],P),e.$Yoc=(0,A.$Ai)("IExtHostWindow")}),define(Ce[264],Ie([1,0,253,27,17]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_qc=void 0;let T=class extends b.$2oc{constructor(M,$){super(M,$)}f(M,$,a){$.apply(console,a)}};e.$_qc=T,e.$_qc=T=Je([qe(0,I.$ZO),qe(1,D.$dP)],T)}),define(Ce[265],Ie([1,0,11,23,22,28,14,4,6,36,147,251,38]),function(_,e,b,D,I,T,A,M,$,a,P,y,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=e.ResponsiveState=e.RequestInitiator=void 0,e.$rbc=f,e.$sbc=t;function h(N,B){try{return JSON.stringify(N,B)}catch{return"null"}}const r="$$ref$$",o={[r]:-1};class c{constructor(B,X){this.jsonString=B,this.referencedBuffers=X}}function f(N,B=null,X=!1){const V=[];return{jsonString:(X?h:JSON.stringify)(N,(L,F)=>{if(typeof F>"u")return o;if(typeof F=="object"){if(F instanceof D.$Je){const ie=V.push(F)-1;return{[r]:ie}}if(B)return B(L,F)}return F}),referencedBuffers:V}}function t(N,B,X){return JSON.parse(N,(V,O)=>{if(O){const L=O[r];if(typeof L=="number")return B[L];if(X&&O.$mid===a.MarshalledId.Uri)return X.transformIncoming(O)}return O})}function s(N,B){return JSON.stringify(N,B)}function n(N){return N?(B,X)=>X&&X.$mid===a.MarshalledId.Uri?N.transformOutgoing(X):X:null}var i;(function(N){N[N.LocalSide=0]="LocalSide",N[N.OtherSide=1]="OtherSide"})(i||(e.RequestInitiator=i={}));var g;(function(N){N[N.Responsive=0]="Responsive",N[N.Unresponsive=1]="Unresponsive"})(g||(e.ResponsiveState=g={}));const d=()=>{},l=Symbol.for("rpcProtocol"),p=Symbol.for("rpcProxy");class C extends $.$Uc{constructor(B,X=null,V=null){super(),this[k]=!0,this.b=this.B(new M.$he),this.onDidChangeResponsiveState=this.b.event,this.c=B,this.f=X,this.g=V,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let O=0,L=u.$Iw.count;O<L;O++)this.m[O]=null,this.s[O]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=g.Responsive,this.z=0,this.C=0,this.D=this.B(new b.$Mh(()=>this.H(),1e3)),this.c.onMessage(O=>this.L(O))}dispose(){this.j=!0,Object.keys(this.w).forEach(B=>{const X=this.w[B];delete this.w[B],X.resolveErr(A.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(B){this.z===0&&(this.C=Date.now()+C.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(B){this.C=Date.now()+C.a,this.z--,this.z===0&&this.D.cancel(),this.I(g.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(g.Unresponsive):this.D.schedule())}I(B){this.y!==B&&(this.y=B,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(B){return this.g?(0,P.$Hn)(B,this.g):B}getProxy(B){const{nid:X,sid:V}=B;return this.s[X]||(this.s[X]=this.J(X,V)),this.s[X]}J(B,X){const V={get:(O,L)=>(typeof L=="string"&&!O[L]&&L.charCodeAt(0)===T.CharCode.DollarSign&&(O[L]=(...F)=>this.U(B,L,F)),L===p?X:O[L])};return new Proxy(Object.create(null),V)}set(B,X){return this.m[B.nid]=X,X}assertRegistered(B){for(let X=0,V=B.length;X<V;X++){const O=B[X];if(!this.m[O.nid])throw new Error(`Missing proxy instance ${O.sid}`)}}L(B){if(this.j)return;const X=B.byteLength,V=v.read(B,0),O=V.readUInt8(),L=V.readUInt32();switch(O){case w.RequestJSONArgs:case w.RequestJSONArgsWithCancellation:{let{rpcId:F,method:ie,args:de}=R.deserializeRequestJSONArgs(V);this.g&&(de=(0,P.$Hn)(de,this.g)),this.M(X,L,F,ie,de,O===w.RequestJSONArgsWithCancellation);break}case w.RequestMixedArgs:case w.RequestMixedArgsWithCancellation:{let{rpcId:F,method:ie,args:de}=R.deserializeRequestMixedArgs(V);this.g&&(de=(0,P.$Hn)(de,this.g)),this.M(X,L,F,ie,de,O===w.RequestMixedArgsWithCancellation);break}case w.Acknowledged:{this.f?.logIncoming(X,L,i.LocalSide,"ack"),this.G(L);break}case w.Cancel:{this.N(X,L);break}case w.ReplyOKEmpty:{this.O(X,L,void 0);break}case w.ReplyOKJSON:{let F=R.deserializeReplyOKJSON(V);this.g&&(F=(0,P.$Hn)(F,this.g)),this.O(X,L,F);break}case w.ReplyOKJSONWithBuffers:{const F=R.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(X,L,F);break}case w.ReplyOKVSBuffer:{const F=R.deserializeReplyOKVSBuffer(V);this.O(X,L,F);break}case w.ReplyErrError:{let F=R.deserializeReplyErrError(V);this.g&&(F=(0,P.$Hn)(F,this.g)),this.P(X,L,F);break}case w.ReplyErrEmpty:{this.P(X,L,void 0);break}default:console.error("received unexpected message"),console.error(B)}}M(B,X,V,O,L,F){this.f?.logIncoming(B,X,i.OtherSide,`receiveRequest ${(0,u.$Kw)(V)}.${O}(`,L);const ie=String(X);let de,be;if(F){const Z=new I.$se;L.push(Z.token),de=this.Q(V,O,L),be=()=>Z.cancel()}else de=this.Q(V,O,L),be=d;this.u[ie]=be;const ve=R.serializeAcknowledged(X);this.f?.logOutgoing(ve.byteLength,X,i.OtherSide,"ack"),this.c.send(ve),de.then(Z=>{delete this.u[ie];const ae=R.serializeReplyOK(X,Z,this.h);this.f?.logOutgoing(ae.byteLength,X,i.OtherSide,"reply:",Z),this.c.send(ae)},Z=>{delete this.u[ie];const ae=R.serializeReplyErr(X,Z);this.f?.logOutgoing(ae.byteLength,X,i.OtherSide,"replyErr:",Z),this.c.send(ae)})}N(B,X){this.f?.logIncoming(B,X,i.OtherSide,"receiveCancel");const V=String(X);this.u[V]?.()}O(B,X,V){this.f?.logIncoming(B,X,i.LocalSide,"receiveReply:",V);const O=String(X);if(!this.w.hasOwnProperty(O))return;const L=this.w[O];delete this.w[O],L.resolveOk(V)}P(B,X,V){this.f?.logIncoming(B,X,i.LocalSide,"receiveReplyErr:",V);const O=String(X);if(!this.w.hasOwnProperty(O))return;const L=this.w[O];delete this.w[O];let F;V&&(V.$isError?(F=new Error,F.name=V.name,F.message=V.message,F.stack=V.stack):F=V),L.resolveErr(F)}Q(B,X,V){try{return Promise.resolve(this.S(B,X,V))}catch(O){return Promise.reject(O)}}S(B,X,V){const O=this.m[B];if(!O)throw new Error("Unknown actor "+(0,u.$Kw)(B));const L=O[X];if(typeof L!="function")throw new Error("Unknown method "+X+" on actor "+(0,u.$Kw)(B));return L.apply(O,V)}U(B,X,V){if(this.j)return new y.$qbc;let O=null;if(V.length>0&&I.CancellationToken.isCancellationToken(V[V.length-1])&&(O=V.pop()),O&&O.isCancellationRequested)return Promise.reject(A.$6());const L=R.serializeRequestArguments(V,this.h),F=++this.t,ie=String(F),de=new y.$pbc,be=new $.$Tc;O&&be.add(O.onCancellationRequested(()=>{const Z=R.serializeCancel(F);this.f?.logOutgoing(Z.byteLength,F,i.LocalSide,"cancel"),this.c.send(R.serializeCancel(F))})),this.w[ie]=new S(de,be),this.F(F);const ve=R.serializeRequest(F,B,X,L,!!O);return this.f?.logOutgoing(ve.byteLength,F,i.LocalSide,`request: ${(0,u.$Kw)(B)}.${X}(`,V),this.c.send(ve),de}}e.$tbc=C,k=l,C.a=3*1e3;class S{constructor(B,X){this.a=B,this.b=X}resolveOk(B){this.a.resolveOk(B),this.b.dispose()}resolveErr(B){this.a.resolveErr(B),this.b.dispose()}}class v{static alloc(B,X,V){const O=new v(D.$Je.alloc(V+1+4),0);return O.writeUInt8(B),O.writeUInt32(X),O}static read(B,X){return new v(B,X)}get buffer(){return this.a}constructor(B,X){this.a=B,this.b=X}static sizeUInt8(){return 1}writeUInt8(B){this.a.writeUInt8(B,this.b),this.b+=1}readUInt8(){const B=this.a.readUInt8(this.b);return this.b+=1,B}writeUInt32(B){this.a.writeUInt32BE(B,this.b),this.b+=4}readUInt32(){const B=this.a.readUInt32BE(this.b);return this.b+=4,B}static sizeShortString(B){return 1+B.byteLength}writeShortString(B){this.a.writeUInt8(B.byteLength,this.b),this.b+=1,this.a.set(B,this.b),this.b+=B.byteLength}readShortString(){const B=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+B).toString();return this.b+=B,V}static sizeLongString(B){return 4+B.byteLength}writeLongString(B){this.a.writeUInt32BE(B.byteLength,this.b),this.b+=4,this.a.set(B,this.b),this.b+=B.byteLength}readLongString(){const B=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+B).toString();return this.b+=B,V}writeBuffer(B){this.a.writeUInt32BE(B.byteLength,this.b),this.b+=4,this.a.set(B,this.b),this.b+=B.byteLength}static sizeVSBuffer(B){return 4+B.byteLength}writeVSBuffer(B){this.a.writeUInt32BE(B.byteLength,this.b),this.b+=4,this.a.set(B,this.b),this.b+=B.byteLength}readVSBuffer(){const B=this.a.readUInt32BE(this.b);this.b+=4;const X=this.a.slice(this.b,this.b+B);return this.b+=B,X}static sizeMixedArray(B){let X=0;X+=1;for(let V=0,O=B.length;V<O;V++){const L=B[V];switch(X+=1,L.type){case m.String:X+=this.sizeLongString(L.value);break;case m.VSBuffer:X+=this.sizeVSBuffer(L.value);break;case m.SerializedObjectWithBuffers:X+=this.sizeUInt32,X+=this.sizeLongString(L.value);for(let F=0;F<L.buffers.length;++F)X+=this.sizeVSBuffer(L.buffers[F]);break;case m.Undefined:break}}return X}writeMixedArray(B){this.a.writeUInt8(B.length,this.b),this.b+=1;for(let X=0,V=B.length;X<V;X++){const O=B[X];switch(O.type){case m.String:this.writeUInt8(m.String),this.writeLongString(O.value);break;case m.VSBuffer:this.writeUInt8(m.VSBuffer),this.writeVSBuffer(O.value);break;case m.SerializedObjectWithBuffers:this.writeUInt8(m.SerializedObjectWithBuffers),this.writeUInt32(O.buffers.length),this.writeLongString(O.value);for(let L=0;L<O.buffers.length;++L)this.writeBuffer(O.buffers[L]);break;case m.Undefined:this.writeUInt8(m.Undefined);break}}}readMixedArray(){const B=this.a.readUInt8(this.b);this.b+=1;const X=new Array(B);for(let V=0;V<B;V++)switch(this.readUInt8()){case m.String:X[V]=this.readLongString();break;case m.VSBuffer:X[V]=this.readVSBuffer();break;case m.SerializedObjectWithBuffers:{const L=this.readUInt32(),F=this.readLongString(),ie=[];for(let de=0;de<L;++de)ie.push(this.readVSBuffer());X[V]=new u.$Lw(t(F,ie,null));break}case m.Undefined:X[V]=void 0;break}return X}}v.sizeUInt32=4;var E;(function(N){N[N.Simple=0]="Simple",N[N.Mixed=1]="Mixed"})(E||(E={}));class R{static a(B){for(let X=0,V=B.length;X<V;X++)if(B[X]instanceof D.$Je||B[X]instanceof u.$Lw||typeof B[X]>"u")return!0;return!1}static serializeRequestArguments(B,X){if(this.a(B)){const V=[];for(let O=0,L=B.length;O<L;O++){const F=B[O];if(F instanceof D.$Je)V[O]={type:m.VSBuffer,value:F};else if(typeof F>"u")V[O]={type:m.Undefined};else if(F instanceof u.$Lw){const{jsonString:ie,referencedBuffers:de}=f(F.value,X);V[O]={type:m.SerializedObjectWithBuffers,value:D.$Je.fromString(ie),buffers:de}}else V[O]={type:m.String,value:D.$Je.fromString(s(F,X))}}return{type:E.Mixed,args:V}}return{type:E.Simple,args:s(B,X)}}static serializeRequest(B,X,V,O,L){switch(O.type){case E.Simple:return this.b(B,X,V,O.args,L);case E.Mixed:return this.c(B,X,V,O.args,L)}}static b(B,X,V,O,L){const F=D.$Je.fromString(V),ie=D.$Je.fromString(O);let de=0;de+=v.sizeUInt8(),de+=v.sizeShortString(F),de+=v.sizeLongString(ie);const be=v.alloc(L?w.RequestJSONArgsWithCancellation:w.RequestJSONArgs,B,de);return be.writeUInt8(X),be.writeShortString(F),be.writeLongString(ie),be.buffer}static deserializeRequestJSONArgs(B){const X=B.readUInt8(),V=B.readShortString(),O=B.readLongString();return{rpcId:X,method:V,args:JSON.parse(O)}}static c(B,X,V,O,L){const F=D.$Je.fromString(V);let ie=0;ie+=v.sizeUInt8(),ie+=v.sizeShortString(F),ie+=v.sizeMixedArray(O);const de=v.alloc(L?w.RequestMixedArgsWithCancellation:w.RequestMixedArgs,B,ie);return de.writeUInt8(X),de.writeShortString(F),de.writeMixedArray(O),de.buffer}static deserializeRequestMixedArgs(B){const X=B.readUInt8(),V=B.readShortString(),O=B.readMixedArray(),L=new Array(O.length);for(let F=0,ie=O.length;F<ie;F++){const de=O[F];typeof de=="string"?L[F]=JSON.parse(de):L[F]=de}return{rpcId:X,method:V,args:L}}static serializeAcknowledged(B){return v.alloc(w.Acknowledged,B,0).buffer}static serializeCancel(B){return v.alloc(w.Cancel,B,0).buffer}static serializeReplyOK(B,X,V){if(typeof X>"u")return this.d(B);if(X instanceof D.$Je)return this.e(B,X);if(X instanceof u.$Lw){const{jsonString:O,referencedBuffers:L}=f(X.value,V,!0);return this.g(B,O,L)}else return this.f(B,h(X,V))}static d(B){return v.alloc(w.ReplyOKEmpty,B,0).buffer}static e(B,X){let V=0;V+=v.sizeVSBuffer(X);const O=v.alloc(w.ReplyOKVSBuffer,B,V);return O.writeVSBuffer(X),O.buffer}static deserializeReplyOKVSBuffer(B){return B.readVSBuffer()}static f(B,X){const V=D.$Je.fromString(X);let O=0;O+=v.sizeLongString(V);const L=v.alloc(w.ReplyOKJSON,B,O);return L.writeLongString(V),L.buffer}static g(B,X,V){const O=D.$Je.fromString(X);let L=0;L+=v.sizeUInt32,L+=v.sizeLongString(O);for(const ie of V)L+=v.sizeVSBuffer(ie);const F=v.alloc(w.ReplyOKJSONWithBuffers,B,L);F.writeUInt32(V.length),F.writeLongString(O);for(const ie of V)F.writeBuffer(ie);return F.buffer}static deserializeReplyOKJSON(B){const X=B.readLongString();return JSON.parse(X)}static deserializeReplyOKJSONWithBuffers(B,X){const V=B.readUInt32(),O=B.readLongString(),L=[];for(let F=0;F<V;++F)L.push(B.readVSBuffer());return new u.$Lw(t(O,L,X))}static serializeReplyErr(B,X){const V=X?h(A.$3(X),null):void 0;if(typeof V!="string")return this.h(B);const O=D.$Je.fromString(V);let L=0;L+=v.sizeLongString(O);const F=v.alloc(w.ReplyErrError,B,L);return F.writeLongString(O),F.buffer}static deserializeReplyErrError(B){const X=B.readLongString();return JSON.parse(X)}static h(B){return v.alloc(w.ReplyErrEmpty,B,0).buffer}}var w;(function(N){N[N.RequestJSONArgs=1]="RequestJSONArgs",N[N.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",N[N.RequestMixedArgs=3]="RequestMixedArgs",N[N.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",N[N.Acknowledged=5]="Acknowledged",N[N.Cancel=6]="Cancel",N[N.ReplyOKEmpty=7]="ReplyOKEmpty",N[N.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",N[N.ReplyOKJSON=9]="ReplyOKJSON",N[N.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",N[N.ReplyErrError=11]="ReplyErrError",N[N.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var m;(function(N){N[N.String=1]="String",N[N.VSBuffer=2]="VSBuffer",N[N.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",N[N.Undefined=4]="Undefined"})(m||(m={}))}),define(Ce[266],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$brc=void 0;const b=function(T){const A=M=>{globalThis.removeEventListener("message",A);const $=M.data;Object.defineProperties(globalThis,{postMessage:{value(a,P){$.postMessage(a,P)}},onmessage:{get(){return $.onmessage},set(a){$.onmessage=a}}}),$.addEventListener("message",a=>{globalThis.dispatchEvent(new MessageEvent("message",{data:a.data,ports:a.ports?[...a.ports]:void 0}))}),$.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",A)}.toString();class D extends EventTarget{constructor(T,A,M){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const $=`((${b})('${A}'))`,a=new Blob([$],{type:"application/javascript"}),P=URL.createObjectURL(a),y=new MessageChannel,u=P,k={type:"_newWorker",id:u,port:y.port2,url:P,options:M};T(k,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{T({type:"_terminateWorker",id:u}),URL.revokeObjectURL(P),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(h){y.port1.onmessage=h}},onmessageerror:{get(){return y.port1.onmessageerror},set(h){y.port1.onmessageerror=h}}}),y.port1.addEventListener("messageerror",h=>{const r=new MessageEvent("messageerror",{data:h.data});this.dispatchEvent(r)}),y.port1.addEventListener("message",h=>{const r=new MessageEvent("message",{data:h.data});this.dispatchEvent(r)}),y.port1.start()}}e.$brc=D}),define(Ce[267],Ie([1,0,23,29,16,60,3]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_J=e.$9J=void 0,e.$0J=P,e.$$J=y,e.$9J=(0,A.$Ai)("notebookDocumentService");const M=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${M.join("")}]+`),a=7;function P(k){if(k.scheme!==I.Schemas.vscodeNotebookCell)return;const h=k.fragment.indexOf("s");if(h<0)return;const r=parseInt(k.fragment.substring(0,h).replace($,""),a),o=(0,b.$3e)(k.fragment.substring(h+1)).toString();if(!isNaN(r))return{handle:r,notebook:k.with({scheme:o,fragment:null})}}function y(k,h){const r=h.toString(a),c=`${r.length<M.length?M[r.length-1]:"z"}${r}s${(0,b.$4e)(b.$Je.fromString(k.scheme),!0,!0)}`;return k.with({scheme:I.Schemas.vscodeNotebookCell,fragment:c})}class u{constructor(){this.a=new D.$Ac}getNotebook(h){if(h.scheme===I.Schemas.vscodeNotebookCell){const r=P(h);if(r){const o=this.a.get(r.notebook);if(o)return o}}return this.a.get(h)}addNotebookDocument(h){this.a.set(h.uri,h)}removeNotebookDocument(h){this.a.delete(h.uri)}}e.$_J=u,(0,T.$Gs)(e.$9J,u,T.InstantiationType.Delayed)}),define(Ce[90],Ie([1,0,23,41,40,73,16,20,21,32,267]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tK=e.$qK=e.CellStatusbarAlignment=e.$pK=e.NotebookEditorPriority=e.$mK=e.$lK=e.$jK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$iK=e.$hK=e.$gK=e.$fK=e.CellKind=e.$eK=e.$dK=e.$cK=void 0,e.$kK=g,e.$nK=l,e.$oK=p,e.$rK=v,e.$sK=R,e.$cK="workbench.editor.notebook",e.$dK="workbench.editor.notebookTextDiffEditor",e.$eK="workbench.editor.interactive";var y;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(y||(e.CellKind=y={})),e.$fK=["application/json","application/javascript","text/html","image/svg+xml",T.$Zs.latex,T.$Zs.markdown,"image/png","image/jpeg",T.$Zs.text],e.$gK=[T.$Zs.latex,T.$Zs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$Zs.text],e.$hK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$iK="_notAvailable";var u;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(u||(e.NotebookRunState=u={}));var k;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(k||(e.NotebookCellExecutionState=k={}));var h;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(h||(e.NotebookExecutionState=h={}));var r;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var o;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var c;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var f;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(f||(e.SelectionStateType=f={}));var t;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(t||(e.CellEditType=t={}));var s;(function(F){F.scheme=A.Schemas.vscodeNotebookCell;function ie(fe,ee){return(0,P.$$J)(fe,ee)}F.generate=ie;function de(fe){return(0,P.$0J)(fe)}F.parse=de;function be(fe,ee){return fe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ee??""},${fe.scheme!==A.Schemas.file?fe.scheme:""}`})}F.generateCellOutputUri=be;function ve(fe){if(fe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ee=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(fe.fragment);if(!ee)return;const De=ee[1]&&ee[1]!==""?ee[1]:void 0,Fe=ee[2];return{outputId:De,notebook:fe.with({scheme:Fe||A.Schemas.file,fragment:null})}}F.parseCellOutputUri=ve;function Z(fe,ee,De){return F.generate(fe,ee).with({scheme:De})}F.generateCellPropertyUri=Z;function ae(fe,ee){if(fe.scheme===ee)return F.parse(fe.with({scheme:F.scheme}))}F.parseCellPropertyUri=ae})(s||(e.CellUri=s={}));const n=F=>$.$c?F.replace(/\//g,"\\"):F;class i{constructor(ie=[],de=e.$fK){this.e=de,this.d=[...new Set(ie)].map(be=>({pattern:be,matches:D.$uk(n(be))}))}sort(ie){const de=new Map(I.Iterable.map(ie,ve=>[ve,n(ve)]));let be=[];for(const{matches:ve}of this.d)for(const[Z,ae]of de)if(ve(ae)){be.push(Z),de.delete(Z);break}return de.size&&(be=be.concat([...de.keys()].sort((ve,Z)=>this.e.indexOf(ve)-this.e.indexOf(Z)))),be}prioritize(ie,de){const be=this.f(ie);if(be===-1){this.d.unshift({pattern:ie,matches:D.$uk(n(ie))});return}const ve=new Set(de.map(ae=>this.f(ae,be)));ve.delete(-1);const Z=Array.from(ve).sort();this.d.splice(be+1,0,...Z.map(ae=>this.d[ae]));for(let ae=Z.length-1;ae>=0;ae--)this.d.splice(Z[ae],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,de=this.d.length){const be=n(ie);for(let ve=0;ve<de;ve++)if(this.d[ve].matches(be))return ve;return-1}}e.$jK=i;function g(F,ie,de,be=(ve,Z)=>ve===Z){const ve=[];function Z(ee,De,Fe){if(De===0&&Fe.length===0)return;const ce=ve[ve.length-1];ce&&ce.start+ce.deleteCount===ee?(ce.deleteCount+=De,ce.toInsert.push(...Fe)):ve.push({start:ee,deleteCount:De,toInsert:Fe})}let ae=0,fe=0;for(;;){if(ae===F.length){Z(ae,0,ie.slice(fe));break}if(fe===ie.length){Z(ae,F.length-ae,[]);break}const ee=F[ae],De=ie[fe];if(be(ee,De)){ae+=1,fe+=1;continue}de(De)?(Z(ae,1,[]),ae+=1):(Z(ae,0,[De]),fe+=1)}return ve}e.$lK=new a.$Rj("notebookEditorCursorAtBoundary","none"),e.$mK=new a.$Rj("notebookEditorCursorAtLineBoundary","none");var d;(function(F){F.default="default",F.option="option"})(d||(e.NotebookEditorPriority=d={}));function l(F){const ie=F;return!!((typeof ie.include=="string"||D.$vk(ie.include))&&(typeof ie.exclude=="string"||D.$vk(ie.exclude)))}function p(F,ie,de){if(Array.isArray(F.viewType)&&F.viewType.indexOf(ie)>=0||F.viewType===ie)return!0;if(F.filenamePattern){const be=l(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,ve=l(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(D.$tk(be,(0,M.$nc)(de.fsPath).toLowerCase()))return!(ve&&D.$tk(ve,(0,M.$nc)(de.fsPath).toLowerCase()))}return!1}e.$pK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",findScope:"notebook.experimental.find.scope.enabled",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var C;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(C||(e.CellStatusbarAlignment=C={}));class S{static create(ie){return`${S.d}${ie}`}static parse(ie){if(ie.startsWith(S.d))return ie.substring(S.d.length)}}e.$qK=S,S.d="notebook/";function v(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}const E=new TextDecoder;function R(F){const ie=[];let de=!1;for(const ae of F)(ie.length===0||de)&&(ie.push(ae),de=!0);let be=N(ie);const ve=b.$Je.concat(ie.map(ae=>b.$Je.wrap(ae))),Z=L(ve);return be=be||Z.byteLength!==ve.byteLength,{data:Z,didCompression:be}}e.$tK="\x1B[A";const w=e.$tK.split("").map(F=>F.charCodeAt(0)),m=10;function N(F){let ie=!1;return F.forEach((de,be)=>{if(be===0||de.length<e.$tK.length)return;const ve=F[be-1],Z=de.subarray(0,e.$tK.length);if(Z[0]===w[0]&&Z[1]===w[1]&&Z[2]===w[2]){const ae=ve.lastIndexOf(m);if(ae===-1)return;ie=!0,F[be-1]=ve.subarray(0,ae),F[be]=de.subarray(e.$tK.length)}}),ie}function B(F){let ie=F;do F=ie,ie=F.replace(/[^\n]\x08/gm,"");while(ie.length<F.length);return F}function X(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const ie=F.match(/^(.*)\r+/m)[1];let de=F.match(/\r+(.*)$/m)[1];de=de+ie.slice(de.length,ie.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,de)}return F}const V=8,O=13;function L(F){return!F.buffer.includes(V)&&!F.buffer.includes(O)?F:b.$Je.fromString(X(B(E.decode(F.buffer))))}});var tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b},Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)};define(Ce[7],Ie([1,0,18,14,59,29,73,13,15,2,37,19,30,108,90]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h){"use strict";var r,o,c,f,t,s,n,i,g,d,l,p,C,S,v,E,R,w,m,N,B,X,V,O,L;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$NO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$MO=e.$LO=e.$KO=e.$JO=e.$IO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.$xO=e.$wO=e.$vO=e.$uO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$tO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.$jO=e.$iO=e.$hO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$gO=e.$fO=e.$eO=e.$dO=e.$bO=e.$aO=e.$_N=e.$$N=e.TestRunProfileKind=e.TestResultState=e.$0N=e.$9N=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$8N=e.NotebookVariablesRequestKind=e.$7N=e.$6N=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$5N=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.ColorThemeKind=e.$YN=e.$XN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$WN=e.$VN=e.DebugConsoleMode=e.$UN=e.$TN=e.$SN=e.$RN=e.$QN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$PN=e.$ON=e.FileChangeType=e.$NN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$MN=e.$LN=e.$KN=e.$JN=e.InlineCompletionTriggerKind=e.$IN=e.$HN=e.$GN=e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.$yN=e.$wN=e.ConfigurationTarget=e.$vN=e.$uN=e.$tN=e.$sN=e.DocumentPasteTriggerKind=e.$rN=e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$lN=e.ViewBadge=e.ProgressLocation=e.$kN=e.$jN=e.TaskScope=e.ShellQuoting=e.$iN=e.$hN=e.$gN=e.TaskPanelKind=e.TaskRevealKind=e.$fN=e.TerminalLocation=e.$eN=e.$dN=e.$cN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$bN=e.$aN=e.$_M=e.$$M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$9M=e.$8M=e.$7M=e.$6M=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$5M=e.$4M=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.LanguageStatusSeverity=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.CodeActionTriggerKind=e.$RM=e.$QM=e.SymbolTag=e.SymbolKind=e.$PM=e.$OM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.DiagnosticSeverity=e.DiagnosticTag=e.$IM=e.$HM=e.FileEditType=e.$GM=e.$FM=e.$EM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$0M=_t,e.$xN=xe,e.$cO=An;function F(j){return Object.assign(j,{apply:function(...se){if(se.length===0)return Reflect.construct(j,[]);{const ke=se.length===1?[]:se[1];return Reflect.construct(j,ke,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(j,[]);{const[ke,...Qe]=se;return Reflect.construct(j,Qe,ke.constructor)}}})}var ie;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(ie||(e.TerminalOutputAnchor=ie={}));var de;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(de||(e.TerminalQuickFixType=de={}));let be=g=class{static from(...z){let se=z;return new g(function(){if(se){for(const ke of se)ke&&typeof ke.dispose=="function"&&ke.dispose();se=void 0}})}constructor(z){r.set(this,void 0),tt(this,r,z,"f")}dispose(){typeof Be(this,r,"f")=="function"&&(Be(this,r,"f").call(this),tt(this,r,void 0,"f"))}};e.$xM=be,r=new WeakMap,e.$xM=be=g=Je([F],be);let ve=d=class{static Min(...z){if(z.length===0)throw new TypeError;let se=z[0];for(let ke=1;ke<z.length;ke++){const Qe=z[ke];Qe.isBefore(se)&&(se=Qe)}return se}static Max(...z){if(z.length===0)throw new TypeError;let se=z[0];for(let ke=1;ke<z.length;ke++){const Qe=z[ke];Qe.isAfter(se)&&(se=Qe)}return se}static isPosition(z){if(!z)return!1;if(z instanceof d)return!0;const{line:se,character:ke}=z;return typeof se=="number"&&typeof ke=="number"}static of(z){if(z instanceof d)return z;if(this.isPosition(z))return new d(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,se){if(z<0)throw(0,D.$7)("line must be non-negative");if(se<0)throw(0,D.$7)("character must be non-negative");this.c=z,this.e=se}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,se=0){if(z===null||se===null)throw(0,D.$7)();let ke;return typeof z>"u"?ke=0:typeof z=="number"?ke=z:(ke=typeof z.lineDelta=="number"?z.lineDelta:0,se=typeof z.characterDelta=="number"?z.characterDelta:0),ke===0&&se===0?this:new d(this.line+ke,this.character+se)}with(z,se=this.character){if(z===null||se===null)throw(0,D.$7)();let ke;return typeof z>"u"?ke=this.line:typeof z=="number"?ke=z:(ke=typeof z.line=="number"?z.line:this.line,se=typeof z.character=="number"?z.character:this.character),ke===this.line&&se===this.character?this:new d(ke,se)}toJSON(){return{line:this.line,character:this.character}}};e.$yM=ve,e.$yM=ve=d=Je([F],ve);let Z=l=class{static isRange(z){return z instanceof l?!0:z?ve.isPosition(z.start)&&ve.isPosition(z.end):!1}static of(z){if(z instanceof l)return z;if(this.isRange(z))return new l(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,se,ke,Qe){let et,ft;if(typeof z=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Qe=="number"?(et=new ve(z,se),ft=new ve(ke,Qe)):ve.isPosition(z)&&ve.isPosition(se)&&(et=ve.of(z),ft=ve.of(se)),!et||!ft)throw new Error("Invalid arguments");et.isBefore(ft)?(this.c=et,this.e=ft):(this.c=ft,this.e=et)}contains(z){return l.isRange(z)?this.contains(z.start)&&this.contains(z.end):ve.isPosition(z)?!(ve.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const se=ve.Max(z.start,this.c),ke=ve.Min(z.end,this.e);if(!se.isAfter(ke))return new l(se,ke)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const se=ve.Min(z.start,this.c),ke=ve.Max(z.end,this.end);return new l(se,ke)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,se=this.end){if(z===null||se===null)throw(0,D.$7)();let ke;return z?ve.isPosition(z)?ke=z:(ke=z.start||this.start,se=z.end||this.end):ke=this.start,ke.isEqual(this.c)&&se.isEqual(this.end)?this:new l(ke,se)}toJSON(){return[this.start,this.end]}};e.$zM=Z,e.$zM=Z=l=Je([F],Z);let ae=p=class extends Z{static isSelection(z){return z instanceof p?!0:z?Z.isRange(z)&&ve.isPosition(z.anchor)&&ve.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,se,ke,Qe){let et,ft;if(typeof z=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Qe=="number"?(et=new ve(z,se),ft=new ve(ke,Qe)):ve.isPosition(z)&&ve.isPosition(se)&&(et=ve.of(z),ft=ve.of(se)),!et||!ft)throw new Error("Invalid arguments");super(et,ft),this.f=et,this.g=ft}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$AM=ae,e.$AM=ae=p=Je([F],ae);const fe=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,D.$7)("connectionToken")};class ee{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,se,ke){if(typeof z!="string"||z.length===0)throw(0,D.$7)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,D.$7)("port");typeof ke<"u"&&fe(ke),this.host=z,this.port=Math.round(se),this.connectionToken=ke}}e.$BM=ee;class De{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,se){this.makeConnection=z,this.connectionToken=se,typeof se<"u"&&fe(se)}}e.$CM=De;class Fe extends Error{static NotAvailable(z,se){return new Fe(z,k.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(z){return new Fe(z,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,se=k.RemoteAuthorityResolverErrorCode.Unknown,ke){super(z),this._message=z,this._code=se,this._detail=ke,Object.setPrototypeOf(this,Fe.prototype)}}e.$DM=Fe;var ce;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ce||(e.EndOfLine=ce={}));var H;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(H||(e.EnvironmentVariableMutatorType=H={}));let he=C=class{static isTextEdit(z){return z instanceof C?!0:z?Z.isRange(z)&&typeof z.newText=="string":!1}static replace(z,se){return new C(z,se)}static insert(z,se){return C.replace(new Z(z,z),se)}static delete(z){return C.replace(z,"")}static setEndOfLine(z){const se=new C(new Z(new ve(0,0),new ve(0,0)),"");return se.newEol=z,se}get range(){return this.c}set range(z){if(z&&!Z.isRange(z))throw(0,D.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,D.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,D.$7)("newEol");this.f=z}constructor(z,se){this.c=z,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$EM=he,e.$EM=he=C=Je([F],he);let le=S=class{static isNotebookCellEdit(z){return z instanceof S?!0:z?vi.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,se){return new S(z,se)}static insertCells(z,se){return new S(new vi(z,z),se)}static deleteCells(z){return new S(z,[])}static updateCellMetadata(z,se){const ke=new S(new vi(z,z),[]);return ke.newCellMetadata=se,ke}static updateNotebookMetadata(z){const se=new S(new vi(0,0),[]);return se.newNotebookMetadata=z,se}constructor(z,se){this.range=z,this.newCells=se}};e.$FM=le,e.$FM=le=S=Je([F],le);class re{static isSnippetTextEdit(z){return z instanceof re?!0:z?Z.isRange(z.range)&&J.isSnippetString(z.snippet):!1}static replace(z,se){return new re(z,se)}static insert(z,se){return re.replace(new Z(z,z),se)}constructor(z,se){this.range=z,this.snippet=se}}e.$GM=re;var ue;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ue||(e.FileEditType=ue={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,se,ke,Qe){this.c.push({_type:ue.File,from:z,to:se,options:ke,metadata:Qe})}createFile(z,se,ke){this.c.push({_type:ue.File,from:void 0,to:z,options:se,metadata:ke})}deleteFile(z,se,ke){this.c.push({_type:ue.File,from:z,to:void 0,options:se,metadata:ke})}e(z,se,ke){this.c.push({_type:ue.Cell,metadata:ke,uri:z,edit:{editType:h.CellEditType.DocumentMetadata,metadata:se},notebookMetadata:se})}f(z,se,ke,Qe){const et=se.start,ft=se.end;(et!==ft||ke.length>0)&&this.c.push({_type:ue.CellReplace,uri:z,index:et,count:ft-et,cells:ke,metadata:Qe})}g(z,se,ke,Qe){this.c.push({_type:ue.Cell,metadata:Qe,uri:z,edit:{editType:h.CellEditType.Metadata,index:se,metadata:ke}})}replace(z,se,ke,Qe){this.c.push({_type:ue.Text,uri:z,edit:new he(se,ke),metadata:Qe})}insert(z,se,ke,Qe){this.replace(z,new Z(se,se),ke,Qe)}delete(z,se,ke){this.replace(z,se,"",ke)}has(z){return this.c.some(se=>se._type===ue.Text&&se.uri.toString()===z.toString())}set(z,se){if(se)for(const ke of se){if(!ke)continue;let Qe,et;Array.isArray(ke)?(Qe=ke[0],et=ke[1]):Qe=ke,le.isNotebookCellEdit(Qe)?Qe.newCellMetadata?this.g(z,Qe.range.start,Qe.newCellMetadata,et):Qe.newNotebookMetadata?this.e(z,Qe.newNotebookMetadata,et):this.f(z,Qe.range,Qe.newCells,et):re.isSnippetTextEdit(Qe)?this.c.push({_type:ue.Snippet,uri:z,range:Qe.range,edit:Qe.snippet,metadata:et}):this.c.push({_type:ue.Text,uri:z,edit:Qe,metadata:et})}else{for(let ke=0;ke<this.c.length;ke++){const Qe=this.c[ke];switch(Qe._type){case ue.Text:case ue.Snippet:case ue.Cell:case ue.CellReplace:Qe.uri.toString()===z.toString()&&(this.c[ke]=void 0);break}}(0,b.$Ib)(this.c)}}get(z){const se=[];for(const ke of this.c)ke._type===ue.Text&&ke.uri.toString()===z.toString()&&se.push(ke.edit);return se}entries(){const z=new T.$Ac;for(const se of this.c)if(se._type===ue.Text){let ke=z.get(se.uri);ke||(ke=[se.uri,[]],z.set(se.uri,ke)),ke[1].push(se.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$HM=oe,e.$HM=oe=Je([F],oe);let J=v=class{static isSnippetString(z){return z instanceof v?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=v.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,se=this.e++){if(typeof z=="function"){const ke=new v;ke.e=this.e,z(ke),this.e=ke.e,z=ke.value}else z=v.c(z);return this.value+="${",this.value+=se,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,se=this.e++){const ke=z.map(Qe=>Qe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(z,se){if(typeof se=="function"){const ke=new v;ke.e=this.e,se(ke),this.e=ke.e,se=ke.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$IM=J,e.$IM=J=v=Je([F],J);var Y;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(Y||(e.DiagnosticTag=Y={}));var we;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(we||(e.DiagnosticSeverity=we={}));let pe=E=class{static isLocation(z){return z instanceof E?!0:z?Z.isRange(z.range)&&a.URI.isUri(z.uri):!1}constructor(z,se){if(this.uri=z,se)if(Z.isRange(se))this.range=Z.of(se);else if(ve.isPosition(se))this.range=new Z(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$JM=pe,e.$JM=pe=E=Je([F],pe);let Me=class{static is(z){return z?typeof z.message=="string"&&z.location&&Z.isRange(z.location.range)&&a.URI.isUri(z.location.uri):!1}constructor(z,se){this.location=z,this.message=se}static isEqual(z,se){return z===se?!0:!z||!se?!1:z.message===se.message&&z.location.range.isEqual(se.location.range)&&z.location.uri.toString()===se.location.uri.toString()}};e.$KM=Me,e.$KM=Me=Je([F],Me);let Ve=class{constructor(z,se,ke=we.Error){if(!Z.isRange(z))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=z,this.message=se,this.severity=ke}toJSON(){return{severity:we[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,se){return z===se?!0:!z||!se?!1:z.message===se.message&&z.severity===se.severity&&z.code===se.code&&z.severity===se.severity&&z.source===se.source&&z.range.isEqual(se.range)&&(0,b.$ub)(z.tags,se.tags)&&(0,b.$ub)(z.relatedInformation,se.relatedInformation,Me.isEqual)}};e.$LM=Ve,e.$LM=Ve=Je([F],Ve);let Se=class{constructor(z,se){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=se}};e.$MM=Se,e.$MM=Se=Je([F],Se);let Pe=class extends Se{constructor(z,se,ke,Qe){super(z,se),this.canIncreaseHover=ke,this.canDecreaseHover=Qe}};e.$NM=Pe,e.$NM=Pe=Je([F],Pe);var Te;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(Te||(e.HoverVerbosityAction=Te={}));var U;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(U||(e.DocumentHighlightKind=U={}));let W=class{constructor(z,se=U.Text){this.range=z,this.kind=se}toJSON(){return{range:this.range,kind:U[this.kind]}}};e.$OM=W,e.$OM=W=Je([F],W);let G=class{constructor(z,se){this.uri=z,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$PM=G,e.$PM=G=Je([F],G);var K;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(K||(e.SymbolKind=K={}));var x;(function(j){j[j.Deprecated=1]="Deprecated"})(x||(e.SymbolTag=x={}));let ge=R=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,se,ke,Qe,et){this.name=z,this.kind=se,this.containerName=et,typeof ke=="string"&&(this.containerName=ke),Qe instanceof pe?this.location=Qe:ke instanceof Z&&(this.location=new pe(Qe,ke)),R.validate(this)}toJSON(){return{name:this.name,kind:K[this.kind],location:this.location,containerName:this.containerName}}};e.$QM=ge,e.$QM=ge=R=Je([F],ge);let Re=w=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(w.validate)}constructor(z,se,ke,Qe,et){this.name=z,this.detail=se,this.kind=ke,this.range=Qe,this.selectionRange=et,this.children=[],w.validate(this)}};e.$RM=Re,e.$RM=Re=w=Je([F],Re);var Ue;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Ue||(e.CodeActionTriggerKind=Ue={}));let Ke=class{constructor(z,se){this.title=z,this.kind=se}};e.$SM=Ke,e.$SM=Ke=Je([F],Ke);let Ze=m=class{constructor(z){this.value=z}append(z){return new m(this.value?this.value+m.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+m.c)}};e.$TM=Ze,Ze.c=".",e.$TM=Ze=m=Je([F],Ze),Ze.Empty=new Ze(""),Ze.QuickFix=Ze.Empty.append("quickfix"),Ze.Refactor=Ze.Empty.append("refactor"),Ze.RefactorExtract=Ze.Refactor.append("extract"),Ze.RefactorInline=Ze.Refactor.append("inline"),Ze.RefactorMove=Ze.Refactor.append("move"),Ze.RefactorRewrite=Ze.Refactor.append("rewrite"),Ze.Source=Ze.Empty.append("source"),Ze.SourceOrganizeImports=Ze.Source.append("organizeImports"),Ze.SourceFixAll=Ze.Source.append("fixAll"),Ze.Notebook=Ze.Empty.append("notebook");let nt=class{constructor(z,se){if(this.range=z,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$UM=nt,e.$UM=nt=Je([F],nt);class it{constructor(z,se,ke,Qe,et,ft){this.kind=z,this.name=se,this.detail=ke,this.uri=Qe,this.range=et,this.selectionRange=ft}}e.$VM=it;class st{constructor(z,se){this.fromRanges=se,this.from=z}}e.$WM=st;class ot{constructor(z,se){this.fromRanges=se,this.to=z}}e.$XM=ot;var $t;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})($t||(e.LanguageStatusSeverity=$t={}));let dt=class{constructor(z,se){this.range=z,this.command=se}get isResolved(){return!!this.command}};e.$YM=dt,e.$YM=dt=Je([F],dt);let rt=N=class{static isMarkdownString(z){return z instanceof N?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,se=!1){o.set(this,void 0),tt(this,o,new I.$Xk(z,{supportThemeIcons:se}),"f")}get value(){return Be(this,o,"f").value}set value(z){Be(this,o,"f").value=z}get isTrusted(){return Be(this,o,"f").isTrusted}set isTrusted(z){Be(this,o,"f").isTrusted=z}get supportThemeIcons(){return Be(this,o,"f").supportThemeIcons}set supportThemeIcons(z){Be(this,o,"f").supportThemeIcons=z}get supportHtml(){return Be(this,o,"f").supportHtml}set supportHtml(z){Be(this,o,"f").supportHtml=z}get baseUri(){return Be(this,o,"f").baseUri}set baseUri(z){Be(this,o,"f").baseUri=z}appendText(z){return Be(this,o,"f").appendText(z),this}appendMarkdown(z){return Be(this,o,"f").appendMarkdown(z),this}appendCodeblock(z,se){return Be(this,o,"f").appendCodeblock(se??"",z),this}};e.$ZM=rt,o=new WeakMap,e.$ZM=rt=N=Je([F],rt);let ut=class{constructor(z,se){this.label=z,this.documentation=se}};e.$1M=ut,e.$1M=ut=Je([F],ut);let gt=class{constructor(z,se){this.label=z,this.documentation=se,this.parameters=[]}};e.$2M=gt,e.$2M=gt=Je([F],gt);let We=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$3M=We,e.$3M=We=Je([F],We);var je;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(je||(e.SignatureHelpTriggerKind=je={}));var te;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(te||(e.InlayHintKind=te={}));let q=class{constructor(z){this.value=z}};e.$4M=q,e.$4M=q=Je([F],q);let Ee=class{constructor(z,se,ke){this.position=z,this.label=se,this.kind=ke}};e.$5M=Ee,e.$5M=Ee=Je([F],Ee);var He;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(He||(e.CompletionTriggerKind=He={}));var _e;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(_e||(e.CompletionItemKind=_e={}));var lt;(function(j){j[j.Deprecated=1]="Deprecated"})(lt||(e.CompletionItemTag=lt={}));let mt=class{constructor(z,se){this.label=z,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&_e[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$6M=mt,e.$6M=mt=Je([F],mt);let At=class{constructor(z=[],se=!1){this.items=z,this.isIncomplete=se}};e.$7M=At,e.$7M=At=Je([F],At);let Jt=class{constructor(z,se,ke){this.insertText=z,this.range=se,this.command=ke}};e.$8M=Jt,e.$8M=Jt=Je([F],Jt);let qt=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$9M=qt,e.$9M=qt=Je([F],qt);var hi;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(hi||(e.PartialAcceptTriggerKind=hi={}));var ii;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ii||(e.ViewColumn=ii={}));var Ye;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ye||(e.StatusBarAlignment=Ye={}));function _t(j,z){return`${y.$Xm.toKey(j)}.${z}`}var Qt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var pt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(pt||(e.TextDocumentSaveReason=pt={}));var bt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(bt||(e.TextEditorRevealType=bt={}));var Xt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Xt||(e.TextEditorSelectionChangeKind=Xt={}));var ei;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(ei||(e.TextDocumentChangeReason=ei={}));var Wt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Wt||(e.DecorationRangeBehavior=Wt={})),function(j){function z(se){switch(se){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=z}(Xt||(e.TextEditorSelectionChangeKind=Xt={}));var wt;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(wt||(e.SyntaxTokenType=wt={})),function(j){function z(se){switch(se){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=z}(wt||(e.SyntaxTokenType=wt={}));let Tt=class{constructor(z,se){if(se&&!a.URI.isUri(se))throw(0,D.$7)("target");if(!Z.isRange(z)||z.isEmpty)throw(0,D.$7)("range");this.range=z,this.target=se}};e.$$M=Tt,e.$$M=Tt=Je([F],Tt);let jt=class{constructor(z,se,ke,Qe){this.red=z,this.green=se,this.blue=ke,this.alpha=Qe}};e.$_M=jt,e.$_M=jt=Je([F],jt);let Lt=class{constructor(z,se){if(se&&!(se instanceof jt))throw(0,D.$7)("color");if(!Z.isRange(z)||z.isEmpty)throw(0,D.$7)("range");this.range=z,this.color=se}};e.$aN=Lt,e.$aN=Lt=Je([F],Lt);let Xe=class{constructor(z){if(!z||typeof z!="string")throw(0,D.$7)("label");this.label=z}};e.$bN=Xe,e.$bN=Xe=Je([F],Xe);var ti;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ni;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(ni||(e.SourceControlInputBoxValidationType=ni={}));var ci;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(ci||(e.TerminalExitReason=ci={}));var Ct;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(Ct||(e.TerminalShellExecutionCommandLineConfidence=Ct={}));class Ft{constructor(z,se,ke){if(this.startIndex=z,this.length=se,this.tooltip=ke,typeof z!="number"||z<0)throw(0,D.$7)("startIndex");if(typeof se!="number"||se<1)throw(0,D.$7)("length");if(ke!==void 0&&typeof ke!="string")throw(0,D.$7)("tooltip")}}e.$cN=Ft;class Ot{constructor(z){this.uri=z}}e.$dN=Ot;class Gt{constructor(z){this.terminalCommand=z}}e.$eN=Gt;var li;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(li||(e.TerminalLocation=li={}));class ri{constructor(z){if(this.options=z,typeof z!="object")throw(0,D.$7)("options")}}e.$fN=ri;var oi;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(oi||(e.TaskRevealKind=oi={}));var Vt;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Vt||(e.TaskPanelKind=Vt={}));let zt=B=class{static from(z){switch(z){case"clean":return B.Clean;case"build":return B.Build;case"rebuild":return B.Rebuild;case"test":return B.Test;default:return}}constructor(z,se){if(this.label=se,typeof z!="string"||typeof se!="string")throw(0,D.$7)("name");this.c=z}get id(){return this.c}};e.$gN=zt,zt.Clean=new B("clean","Clean"),zt.Build=new B("build","Build"),zt.Rebuild=new B("rebuild","Rebuild"),zt.Test=new B("test","Test"),e.$gN=zt=B=Je([F],zt);function ai(j){let z="";for(let se=0;se<j.length;se++)z+=j[se].replace(/,/g,",,")+",";return z}let Pt=class{constructor(z,se,ke){if(typeof z!="string")throw(0,D.$7)("process");this.e=[],this.c=z,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=ke):this.f=se)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,D.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const se of this.e)z.push(se);return ai(z)}};e.$hN=Pt,e.$hN=Pt=Je([F],Pt);let Et=class{constructor(z,se,ke){if(this.f=[],Array.isArray(se)){if(!z)throw(0,D.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,D.$7)("command");this.e=z,this.f=se,this.g=ke}else{if(typeof z!="string")throw(0,D.$7)("commandLine");this.c=z,this.g=se}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,D.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,D.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)z.push(typeof se=="string"?se:se.value);return ai(z)}};e.$iN=Et,e.$iN=Et=Je([F],Et);var yt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(yt||(e.ShellQuoting=yt={}));var Kt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Kt||(e.TaskScope=Kt={}));class Dt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,P.$Wg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$jN=Dt;let Bt=X=class{constructor(z,se,ke,Qe,et,ft){this.k=!1,this.l=this.definition=z;let vt;typeof se=="string"?(this.o=this.name=se,this.w=this.source=ke,this.execution=Qe,vt=et,this.k=!0):se===Kt.Global||se===Kt.Workspace?(this.target=se,this.o=this.name=ke,this.w=this.source=Qe,this.execution=et,vt=ft):(this.target=se,this.o=this.name=ke,this.w=this.source=Qe,this.execution=et,vt=ft),typeof vt=="string"?(this.r=[vt],this.t=!0):Array.isArray(vt)?(this.r=vt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Pt?this.l={type:X.e,id:this.q.computeId()}:this.q instanceof Et?this.l={type:X.f,id:this.q.computeId()}:this.q instanceof Dt?this.l={type:X.c,id:this.q.computeId()}:this.l={type:X.g,id:(0,P.$Wg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,D.$7)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,D.$7)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const se=this.l.type;(X.g===se||X.e===se||X.f===se||X.c===se)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,D.$7)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$kN=Bt,Bt.c="customExecution",Bt.e="process",Bt.f="shell",Bt.g="$empty",e.$kN=Bt=X=Je([F],Bt);var Ht;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Ht||(e.ProgressLocation=Ht={}));var Ei;(function(j){function z(se){const ke=se;return(0,$.$eg)(ke.value)?ke.tooltip&&!(0,$.$ag)(ke.tooltip)?(console.log("INVALID view badge, invalid tooltip",ke.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ke.value),!1)}j.isViewBadge=z})(Ei||(e.ViewBadge=Ei={}));let gi=V=class{static isTreeItem(z,se){const ke=z;if(ke.checkboxState!==void 0){const Qe=(0,$.$eg)(ke.checkboxState)?ke.checkboxState:(0,$.$cg)(ke.checkboxState)&&(0,$.$eg)(ke.checkboxState.state)?ke.checkboxState.state:void 0,et=!(0,$.$eg)(ke.checkboxState)&&(0,$.$cg)(ke.checkboxState)?ke.checkboxState.tooltip:void 0;if(Qe===void 0||Qe!==Nt.Checked&&Qe!==Nt.Unchecked||et!==void 0&&!(0,$.$ag)(et))return console.log("INVALID tree item, invalid checkboxState",ke.checkboxState),!1}if(z instanceof V)return!0;if(ke.label!==void 0&&!(0,$.$ag)(ke.label)&&!ke.label?.label)return console.log("INVALID tree item, invalid label",ke.label),!1;if(ke.id!==void 0&&!(0,$.$ag)(ke.id))return console.log("INVALID tree item, invalid id",ke.id),!1;if(ke.iconPath!==void 0&&!(0,$.$ag)(ke.iconPath)&&!a.URI.isUri(ke.iconPath)&&(!ke.iconPath||!(0,$.$ag)(ke.iconPath.id))){const Qe=ke.iconPath;if(!Qe||!(0,$.$ag)(Qe.light)&&!a.URI.isUri(Qe.light)&&!(0,$.$ag)(Qe.dark)&&!a.URI.isUri(Qe.dark))return console.log("INVALID tree item, invalid iconPath",ke.iconPath),!1}return ke.description!==void 0&&!(0,$.$ag)(ke.description)&&typeof ke.description!="boolean"?(console.log("INVALID tree item, invalid description",ke.description),!1):ke.resourceUri!==void 0&&!a.URI.isUri(ke.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ke.resourceUri),!1):ke.tooltip!==void 0&&!(0,$.$ag)(ke.tooltip)&&!(ke.tooltip instanceof rt)?(console.log("INVALID tree item, invalid tooltip",ke.tooltip),!1):ke.command!==void 0&&!ke.command.command?(console.log("INVALID tree item, invalid command",ke.command),!1):ke.collapsibleState!==void 0&&ke.collapsibleState<mi.None&&ke.collapsibleState>mi.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ke.collapsibleState),!1):ke.contextValue!==void 0&&!(0,$.$ag)(ke.contextValue)?(console.log("INVALID tree item, invalid contextValue",ke.contextValue),!1):ke.accessibilityInformation!==void 0&&!ke.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ke.accessibilityInformation),!1):!0}constructor(z,se=mi.None){this.collapsibleState=se,a.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$lN=gi,e.$lN=gi=V=Je([F],gi);var mi;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(mi||(e.TreeItemCollapsibleState=mi={}));var Nt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Nt||(e.TreeItemCheckboxState=Nt={}));let wi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$mN=wi,e.$mN=wi=Je([F],wi);class Ri extends wi{}e.$nN=Ri;class Rt extends Ri{constructor(z){super(""),c.set(this,void 0),tt(this,c,z,"f")}asFile(){return Be(this,c,"f")}}e.$oN=Rt,c=new WeakMap;class Ai{constructor(z,se,ke,Qe){this.name=z,this.uri=se,this._itemId=ke,this.c=Qe}data(){return this.c()}}e.$pN=Ai;let Si=class{constructor(z){f.add(this),t.set(this,new Map);for(const[se,ke]of z??[]){const Qe=Be(this,t,"f").get(Be(this,f,"m",s).call(this,se));Qe?Qe.push(ke):Be(this,t,"f").set(Be(this,f,"m",s).call(this,se),[ke])}}get(z){return Be(this,t,"f").get(Be(this,f,"m",s).call(this,z))?.[0]}set(z,se){Be(this,t,"f").set(Be(this,f,"m",s).call(this,z),[se])}forEach(z,se){for(const[ke,Qe]of Be(this,t,"f"))for(const et of Qe)z.call(se,et,ke,this)}*[(t=new WeakMap,f=new WeakSet,Symbol.iterator)](){for(const[z,se]of Be(this,t,"f"))for(const ke of se)yield[z,ke]}};e.$qN=Si,s=function(z){return z.toLowerCase()},e.$qN=Si=Je([F],Si);let pi=class{constructor(z,se,ke){this.insertText=z,this.title=se,this.kind=ke}};e.$rN=pi,e.$rN=pi=Je([F],pi);var ki;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(ki||(e.DocumentPasteTriggerKind=ki={}));class ui{constructor(z){this.value=z}append(...z){return new ui((this.value?[this.value,...z]:z).join(ui.c))}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+ui.c)}}e.$sN=ui,ui.c=".",ui.Empty=new ui("");class ye{constructor(z,se,ke){this.title=se,this.insertText=z,this.kind=ke}}e.$tN=ye;let Oe=class{constructor(z,se){this.id=z,this.color=se}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$uN=Oe,e.$uN=Oe=Je([F],Oe),Oe.File=new Oe("file"),Oe.Folder=new Oe("folder");let $e=class{constructor(z){this.id=z}};e.$vN=$e,e.$vN=$e=Je([F],$e);var Q;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Q||(e.ConfigurationTarget=Q={}));let Ae=class{get base(){return this.c}set base(z){this.c=z,this.e=a.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,se){if(typeof z!="string"&&(!z||!a.URI.isUri(z)&&!a.URI.isUri(z.uri)))throw(0,D.$7)("base");if(typeof se!="string")throw(0,D.$7)("pattern");typeof z=="string"?this.baseUri=a.URI.file(z):a.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wN=Ae,e.$wN=Ae=Je([F],Ae);const ze=new WeakMap;function xe(j,z){ze.set(j,z)}let Ge=class{constructor(z,se,ke,Qe,et){this.enabled=typeof z=="boolean"?z:!0,typeof se=="string"&&(this.condition=se),typeof ke=="string"&&(this.hitCondition=ke),typeof Qe=="string"&&(this.logMessage=Qe),typeof et=="string"&&(this.mode=et)}get id(){return this.c||(this.c=ze.get(this)??(0,P.$Wg)()),this.c}};e.$yN=Ge,e.$yN=Ge=Je([F],Ge);let ht=class extends Ge{constructor(z,se,ke,Qe,et,ft){if(super(se,ke,Qe,et,ft),z===null)throw(0,D.$7)("location");this.location=z}};e.$zN=ht,e.$zN=ht=Je([F],ht);let It=class extends Ge{constructor(z,se,ke,Qe,et,ft){super(se,ke,Qe,et,ft),this.functionName=z}};e.$AN=It,e.$AN=It=Je([F],It);let Zt=class extends Ge{constructor(z,se,ke,Qe,et,ft,vt,xt){if(super(Qe,et,ft,vt,xt),!se)throw(0,D.$7)("dataId");this.label=z,this.dataId=se,this.canPersist=ke}};e.$BN=Zt,e.$BN=Zt=Je([F],Zt);let si=class{constructor(z,se,ke){this.command=z,this.args=se||[],this.options=ke}};e.$CN=si,e.$CN=si=Je([F],si);let Ut=class{constructor(z,se){this.port=z,this.host=se}};e.$DN=Ut,e.$DN=Ut=Je([F],Ut);let Yt=class{constructor(z){this.path=z}};e.$EN=Yt,e.$EN=Yt=Je([F],Yt);let Wi=class{constructor(z){this.implementation=z}};e.$FN=Wi,e.$FN=Wi=Je([F],Wi);class Yi{constructor(z,se,ke){this.session=z,this.threadId=se,this.frameId=ke}}e.$GN=Yi;class bn{constructor(z,se){this.session=z,this.threadId=se}}e.$HN=bn;let Mi=class{constructor(z,se){this.range=z,this.expression=se}};e.$IN=Mi,e.$IN=Mi=Je([F],Mi);var Ni;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ni||(e.InlineCompletionTriggerKind=Ni={}));let Vi=class{constructor(z,se){this.range=z,this.text=se}};e.$JN=Vi,e.$JN=Vi=Je([F],Vi);let qi=class{constructor(z,se,ke=!0){this.range=z,this.variableName=se,this.caseSensitiveLookup=ke}};e.$KN=qi,e.$KN=qi=Je([F],qi);let bi=class{constructor(z,se){this.range=z,this.expression=se}};e.$LN=bi,e.$LN=bi=Je([F],bi);let Gi=class{constructor(z,se){this.frameId=z,this.stoppedLocation=se}};e.$MN=Gi,e.$MN=Gi=Je([F],Gi);var xi;(function(j){j[j.AIGenerated=1]="AIGenerated"})(xi||(e.NewSymbolNameTag=xi={}));var Fi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Fi||(e.NewSymbolNameTriggerKind=Fi={}));class _i{constructor(z,se){this.newSymbolName=z,this.tags=se}}e.$NN=_i;var Ki;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Hi=O=class extends Error{static FileExists(z){return new O(z,u.FileSystemProviderErrorCode.FileExists,O.FileExists)}static FileNotFound(z){return new O(z,u.FileSystemProviderErrorCode.FileNotFound,O.FileNotFound)}static FileNotADirectory(z){return new O(z,u.FileSystemProviderErrorCode.FileNotADirectory,O.FileNotADirectory)}static FileIsADirectory(z){return new O(z,u.FileSystemProviderErrorCode.FileIsADirectory,O.FileIsADirectory)}static NoPermissions(z){return new O(z,u.FileSystemProviderErrorCode.NoPermissions,O.NoPermissions)}static Unavailable(z){return new O(z,u.FileSystemProviderErrorCode.Unavailable,O.Unavailable)}constructor(z,se=u.FileSystemProviderErrorCode.Unknown,ke){super(a.URI.isUri(z)?z.toString(!0):z),this.code=ke?.name??"Unknown",(0,u.$jl)(this,se),Object.setPrototypeOf(this,O.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}};e.$ON=Hi,e.$ON=Hi=O=Je([F],Hi);let Li=class{constructor(z,se,ke){this.start=z,this.end=se,this.kind=ke}};e.$PN=Li,e.$PN=Li=Je([F],Li);var en;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(en||(e.FoldingRangeKind=en={}));var Ci;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ci||(e.CommentThreadCollapsibleState=Ci={}));var tn;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(tn||(e.CommentMode=tn={}));var nn;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(nn||(e.CommentState=nn={}));var rn;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(rn||(e.CommentThreadState=rn={}));var zi;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(zi||(e.CommentThreadApplicability=zi={}));class sn{constructor(z,se=[]){this.tokenTypes=z,this.tokenModifiers=se}}e.$QN=sn;function Le(j){return typeof j>"u"||(0,$.$bg)(j)}class di{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let se=0,ke=z.tokenTypes.length;se<ke;se++)this.k.set(z.tokenTypes[se],se);for(let se=0,ke=z.tokenModifiers.length;se<ke;se++)this.l.set(z.tokenModifiers[se],se)}}push(z,se,ke,Qe,et){if(typeof z=="number"&&typeof se=="number"&&typeof ke=="number"&&typeof Qe=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.q(z,se,ke,Qe,et);if(Z.isRange(z)&&typeof se=="string"&&Le(ke))return this.o(z,se,ke);throw(0,D.$7)()}o(z,se,ke){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(se))throw new Error("`tokenType` is not in the provided legend");const Qe=z.start.line,et=z.start.character,ft=z.end.character-z.start.character,vt=this.k.get(se);let xt=0;if(ke)for(const fi of ke){if(!this.l.has(fi))throw new Error("`tokenModifier` is not in the provided legend");const $i=this.l.get(fi);xt|=1<<$i>>>0}this.q(Qe,et,ft,vt,xt)}q(z,se,ke,Qe,et){if(this.f&&(z<this.c||z===this.c&&se<this.e)){this.f=!1;const xt=this.g.length/5|0;let fi=0,$i=0;for(let yi=0;yi<xt;yi++){let Di=this.g[5*yi],Xi=this.g[5*yi+1];Di===0?(Di=fi,Xi+=$i):Di+=fi,this.g[5*yi]=Di,this.g[5*yi+1]=Xi,fi=Di,$i=Xi}}let ft=z,vt=se;this.f&&this.j>0&&(ft-=this.c,ft===0&&(vt-=this.e)),this.g[this.j++]=ft,this.g[this.j++]=vt,this.g[this.j++]=ke,this.g[this.j++]=Qe,this.g[this.j++]=et,this.c=z,this.e=se}static r(z){const se=[],ke=z.length/5|0;for(let vt=0;vt<ke;vt++)se[vt]=vt;se.sort((vt,xt)=>{const fi=z[5*vt],$i=z[5*xt];if(fi===$i){const yi=z[5*vt+1],Di=z[5*xt+1];return yi-Di}return fi-$i});const Qe=new Uint32Array(z.length);let et=0,ft=0;for(let vt=0;vt<ke;vt++){const xt=5*se[vt],fi=z[xt+0],$i=z[xt+1],yi=z[xt+2],Di=z[xt+3],Xi=z[xt+4],Kn=fi-et,Pr=Kn===0?$i-ft:$i,Zi=5*vt;Qe[Zi+0]=Kn,Qe[Zi+1]=Pr,Qe[Zi+2]=yi,Qe[Zi+3]=Di,Qe[Zi+4]=Xi,et=fi,ft=$i}return Qe}build(z){return this.f?new Ui(new Uint32Array(this.g),z):new Ui(di.r(this.g),z)}}e.$RN=di;class Ui{constructor(z,se){this.resultId=se,this.data=z}}e.$SN=Ui;class at{constructor(z,se,ke){this.start=z,this.deleteCount=se,this.data=ke}}e.$TN=at;class kt{constructor(z,se){this.resultId=se,this.edits=z}}e.$UN=kt;var on;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(on||(e.DebugConsoleMode=on={}));class vn{constructor(z){this.name=z}}e.$VN=vn;let Ti=class{constructor(){}};e.$WN=Ti,Ti.Back={iconPath:new Oe("arrow-left")},e.$WN=Ti=Je([F],Ti);var an;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(an||(e.QuickPickItemKind=an={}));var Oi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Oi||(e.InputBoxValidationSeverity=Oi={}));var cn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(cn||(e.ExtensionKind=cn={}));class yn{static validate(z){if(typeof z.badge=="string"){let se=(0,M.$Lf)(z.badge,0);if(se<z.badge.length&&(se+=(0,M.$Lf)(z.badge,se)),z.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!Oe.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,se,ke){this.badge=z,this.tooltip=se,this.color=ke}}e.$XN=yn;let Ji=class{constructor(z){this.kind=z}};e.$YN=Ji,e.$YN=Ji=Je([F],Ji);var Qi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Qi||(e.ColorThemeKind=Qi={}));class vi{static isNotebookRange(z){return z instanceof vi?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,se){if(z<0)throw(0,D.$7)("start must be positive");if(se<0)throw(0,D.$7)("end must be positive");z<=se?(this.c=z,this.e=se):(this.c=se,this.e=z)}with(z){let se=this.c,ke=this.e;return z.start!==void 0&&(se=z.start),z.end!==void 0&&(ke=z.end),se===this.c&&ke===this.e?this:new vi(se,ke)}}e.$ZN=vi;class ji{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(se=>ji.isNotebookCellData(se))}static isNotebookCellData(z){return!0}constructor(z,se,ke,Qe,et,ft,vt){this.kind=z,this.value=se,this.languageId=ke,this.mime=Qe,this.outputs=et??[],this.metadata=ft,this.executionSummary=vt,ji.validate(this)}}e.$1N=ji;class En{constructor(z){this.cells=z}}e.$2N=En;class ln{static isNotebookCellOutputItem(z){return z instanceof n?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const se={name:z.name,message:z.message,stack:z.stack};return n.json(se,"application/vnd.code.notebook.error")}static stdout(z){return n.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return n.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,se="application/octet-stream"){return new n(z,se)}static text(z,se=A.$Zs.text){const ke=Be(n,n,"f",i).encode(String(z));return new n(ke,se)}static json(z,se="text/x-json"){const ke=JSON.stringify(z,void 0,"	");return n.text(ke,se)}constructor(z,se){this.data=z,this.mime=se;const ke=(0,A.$4s)(se,!0);if(!ke)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ke}}e.$3N=ln,n=ln,i={value:new TextEncoder};class Bi{static isNotebookCellOutput(z){return z instanceof Bi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,se=!1){const ke=new Set,Qe=new Set;for(let et=0;et<z.length;et++){const ft=z[et],vt=(0,A.$4s)(ft.mime);if(!ke.has(vt)||(0,h.$rK)(vt)){ke.add(vt);continue}Qe.add(et),se&&console.warn(`DUPLICATED mime type '${ft.mime}' will be dropped`)}return Qe.size===0?z:z.filter((et,ft)=>!Qe.has(ft))}constructor(z,se,ke){this.items=Bi.ensureUniqueMimeTypes(z,!0),typeof se=="string"?(this.id=se,this.metadata=ke):(this.id=(0,P.$Wg)(),this.metadata=se??ke)}}e.$4N=Bi;var un;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(un||(e.NotebookCellKind=un={}));var hn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(hn||(e.NotebookCellExecutionState=hn={}));var dn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(dn||(e.NotebookCellStatusBarAlignment=dn={}));var fn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(fn||(e.NotebookEditorRevealType=fn={}));class Sn{constructor(z,se){this.text=z,this.alignment=se}}e.$5N=Sn;var gn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(gn||(e.NotebookControllerAffinity=gn={}));var ne;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(ne||(e.NotebookControllerAffinity2=ne={}));class me{constructor(z,se=[]){this.uri=z,this.provides=(0,b.$2b)(se)}}e.$6N=me;class Ne{constructor(z){this.label=z}}e.$7N=Ne;var ct;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(ct||(e.NotebookVariablesRequestKind=ct={}));let St=class{constructor(z,se){this.label=z,this.timestamp=se}};e.$8N=St,e.$8N=St=Je([F],St);var Mt;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Mt||(e.ExtensionMode=Mt={}));var Ii;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Ii||(e.ExtensionRuntime=Ii={}));var mn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(mn||(e.StandardTokenType=mn={}));class Hn{constructor(z,se){this.ranges=z,this.wordPattern=se}}e.$9N=Hn;class Jn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$0N=Jn;var Pn;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Pn||(e.TestResultState=Pn={}));var Rn;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(Rn||(e.TestRunProfileKind=Rn={}));let Dn=class{constructor(z=void 0,se=void 0,ke=void 0,Qe=!1,et=!0){this.include=z,this.exclude=se,this.profile=ke,this.continuous=Qe,this.preserveFocus=et}};e.$$N=Dn,e.$$N=Dn=Je([F],Dn);let kn=L=class{static diff(z,se,ke){const Qe=new L(z);return Qe.expectedOutput=se,Qe.actualOutput=ke,Qe}constructor(z){this.message=z}};e.$_N=kn,e.$_N=kn=L=Je([F],kn);let Cn=class{constructor(z){this.id=z}};e.$aO=Cn,e.$aO=Cn=Je([F],Cn);class pn{constructor(z,se){this.covered=z,this.total=se,An(this)}}e.$bO=pn;function An(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class In{static fromDetails(z,se){const ke=new pn(0,0),Qe=new pn(0,0),et=new pn(0,0);for(const vt of se)if("branches"in vt){ke.total+=1,ke.covered+=vt.executed?1:0;for(const xt of vt.branches)Qe.total+=1,Qe.covered+=xt.executed?1:0}else et.total+=1,et.covered+=vt.executed?1:0;const ft=new In(z,ke,Qe.total>0?Qe:void 0,et.total>0?et:void 0);return ft.detailedCoverage=se,ft}constructor(z,se,ke,Qe,et){this.uri=z,this.statementCoverage=se,this.branchCoverage=ke,this.declarationCoverage=Qe,this.testItem=et}}e.$dO=In;class Qn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,se,ke=[]){this.executed=z,this.location=se,this.branches=ke}}e.$eO=Qn;class Xn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,se,ke){this.executed=z,this.location=se,this.label=ke}}e.$fO=Xn;class Zn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,se,ke){this.name=z,this.executed=se,this.location=ke}}e.$gO=Zn;var Mn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Mn||(e.ExternalUriOpenerPriority=Mn={}));var Tn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Tn||(e.WorkspaceTrustState=Tn={}));var On;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(On||(e.PortAutoForwardAction=On={}));class Yn{constructor(z,se,ke,Qe,et,ft){this.kind=z,this.name=se,this.detail=ke,this.uri=Qe,this.range=et,this.selectionRange=ft}}e.$hO=Yn;class xn{constructor(z){this.uri=z}}e.$iO=xn;class _n{constructor(z,se){this.original=z,this.modified=se}}e.$jO=_n;class er{constructor(z,se,ke,Qe){this.base=z,this.input1=se,this.input2=ke,this.result=Qe}}e.$kO=er;class tr{constructor(z,se){this.uri=z,this.viewType=se}}e.$lO=tr;class ir{constructor(z){this.viewType=z}}e.$mO=ir;class nr{constructor(z,se){this.uri=z,this.notebookType=se}}e.$nO=nr;class rr{constructor(z,se,ke){this.original=z,this.modified=se,this.notebookType=ke}}e.$oO=rr;class sr{constructor(){}}e.$pO=sr;class or{constructor(z,se){this.uri=z,this.inputBoxUri=se}}e.$qO=or;class ar{constructor(){}}e.$rO=ar;class cr{constructor(z){this.textDiffs=z}}e.$sO=cr;var Nn;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(Nn||(e.InteractiveSessionVoteDirection=Nn={}));var Fn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Fn||(e.ChatCopyKind=Fn={}));var Ln;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Ln||(e.ChatVariableLevel=Ln={}));class lr{constructor(z,se,ke){this.id=z,this.label=se,this.values=ke}}e.$tO=lr;var zn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(zn||(e.InteractiveEditorResponseFeedbackKind=zn={}));var Un;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Un||(e.ChatResultFeedbackKind=Un={}));class ur{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new rt(z):z}}e.$uO=ur;class hr{constructor(z,se){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new rt(z):z,this.vulnerabilities=se}}e.$vO=hr;class dr{constructor(z,se){this.participant=z,this.command=se}}e.$wO=dr;class fr{constructor(z,se,ke){this.title=z,this.message=se,this.data=ke}}e.$xO=fr;class gr{constructor(z,se){this.value=z,this.baseUri=se}}e.$yO=gr;class mr{constructor(z,se){this.value=z,this.title=se}}e.$zO=mr;class pr{constructor(z){this.value=z}}e.$AO=pr;class $r{constructor(z,se){this.value=z,this.task=se}}e.$BO=$r;class wr{constructor(z){if(typeof z!="string"&&z.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof z=="string"?new rt(z):z}}e.$CO=wr;class br{constructor(z){this.value=z}}e.$DO=br;class vr{constructor(z,se){this.value=z,this.iconPath=se}}e.$EO=vr;class yr{constructor(z,se){this.uri=z,this.edits=Array.isArray(se)?se:[se]}}e.$FO=yr;class Er{constructor(z,se,ke,Qe){this.prompt=z,this.command=se,this.references=ke,this.participant=Qe}}e.$GO=Er;class Sr{constructor(z,se,ke,Qe){this.response=z,this.result=se,this.participant=ke,this.command=Qe}}e.$HO=Sr;var jn;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(jn||(e.ChatLocation=jn={}));var $n;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})($n||(e.LanguageModelChatMessageRole=$n={}));class wn{static User(z,se){return new wn($n.User,z,se)}static Assistant(z,se){return new wn($n.Assistant,z,se)}constructor(z,se,ke){this.role=z,this.content=se,this.name=ke}}e.$IO=wn;class Dr{constructor(z){this.content=z}}e.$JO=Dr;class kr{constructor(z,se){this.content=z,this.name=se}}e.$KO=kr;class Cr{constructor(z,se){this.content=z,this.name=se}}e.$LO=Cr;class Pi extends Error{static NotFound(z){return new Pi(z,Pi.NotFound.name)}static NoPermissions(z){return new Pi(z,Pi.NoPermissions.name)}static Blocked(z){return new Pi(z,Pi.Blocked.name)}constructor(z,se,ke){super(z,{cause:ke}),this.name="LanguageModelError",this.code=se??""}}e.$MO=Pi;var Bn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Bn||(e.RelatedInformationType=Bn={}));var Wn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(Wn||(e.SpeechToTextStatus=Wn={}));var Vn;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Vn||(e.TextToSpeechStatus=Vn={}));var qn;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(qn||(e.KeywordRecognitionStatus=qn={}));class Ir{constructor(z,se){this.text=z,this.range=se}}e.$NO=Ir;var Gn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Gn||(e.InlineEditTriggerKind=Gn={}))}),define(Ce[268],Ie([1,0,5,7]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(b.$vM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,M,$){if(this.a.size===0)throw new Error("No related information providers registered");const a=this.a.get(A);if(!a)throw new Error("related information provider not found");return await a.provideRelatedInformation(M,$)??[]}getRelatedInformation(A,M,$){return this.c.$getAiRelatedInformation(M,$)}registerRelatedInformationProvider(A,M,$){const a=this.b;return this.b++,this.a.set(a,$),this.c.$registerAiRelatedInformationProvider(a,M),new D.$xM(()=>{this.c.$unregisterAiRelatedInformationProvider(a),this.a.delete(a)})}}e.$Rmc=I}),define(Ce[91],Ie([1,0,4,5,7,19,115,3,17]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=e.$3mc=void 0,e.$3mc=(0,M.$Ai)("IExtHostAuthentication");let a=class{constructor(u){this.b=new Map,this.c=new b.$he,this.onDidChangeSessions=this.c.event,this.d=new P,this.f=new P,this.a=u.getProxy(D.$vM.MainThreadAuthentication)}async getSession(u,k,h,r={}){const o=T.$Xm.toKey(u.identifier),c=[...h].sort().join(" ");return await this.d.getOrCreate(`${o} ${k} ${c}`,async()=>{await this.a.$ensureProvider(k);const f=u.displayName||u.name;return this.a.$getSession(k,h,o,f,r)})}async getSessions(u,k,h){const r=T.$Xm.toKey(u.identifier),o=[...h].sort().join(" ");return await this.f.getOrCreate(`${r} ${o}`,async()=>{await this.a.$ensureProvider(k);const c=u.displayName||u.name;return this.a.$getSessions(k,h,r,c)})}async removeSession(u,k){const h=this.b.get(u);return h?h.provider.removeSession(k):this.a.$removeSession(u,k)}registerAuthenticationProvider(u,k,h,r){if(this.b.get(u))throw new Error(`An authentication provider with id '${u}' is already registered.`);this.b.set(u,{label:k,provider:h,options:r??{supportsMultipleAccounts:!1}});const o=h.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(u,c));return this.a.$registerAuthenticationProvider(u,k,r?.supportsMultipleAccounts??!1),new I.$xM(()=>{o.dispose(),this.b.delete(u),this.a.$unregisterAuthenticationProvider(u)})}async $createSession(u,k,h){const r=this.b.get(u);if(r)return await r.provider.createSession(k,h);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $removeSession(u,k){const h=this.b.get(u);if(h)return await h.provider.removeSession(k);throw new Error(`Unable to find authentication provider with handle: ${u}`)}async $getSessions(u,k){const h=this.b.get(u);if(h)return await h.provider.getSessions(k);throw new Error(`Unable to find authentication provider with handle: ${u}`)}$onDidChangeAuthenticationSessions(u,k){return u.startsWith(A.$xL)||this.c.fire({provider:{id:u,label:k}}),Promise.resolve()}};e.$4mc=a,e.$4mc=a=Je([qe(0,$.$ZO)],a);class P{constructor(){this.a=new Map}getOrCreate(u,k){const h=this.a.get(u);if(h)return h;const r=k().finally(()=>this.a.delete(u));return this.a.set(u,r),r}}}),define(Ce[120],Ie([1,0,2,5,7,3,17,12,18,13,20,25]),function(_,e,b,D,I,T,A,M,$,a,P,y){"use strict";var u;Object.defineProperty(e,"__esModule",{value:!0}),e.$4nc=e.$3nc=void 0;let k=u=class{constructor(r,o){this.h=o,this.f=new Map,this.g=r.getProxy(D.$vM.MainThreadDecorations)}registerFileDecorationProvider(r,o){const c=u.c++;this.f.set(c,{provider:r,extensionDescription:o}),this.g.$registerDecorationProvider(c,o.identifier.value);const f=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(t=>{if(!t){this.g.$onDidChange(c,null);return}const s=(0,$.$2b)(t);if(s.length<=u.d){this.g.$onDidChange(c,s);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,s.length);const n=s.map(d=>({uri:d,rank:(0,a.$ef)(d.path,"/")})),i=(0,$.$zb)(n,(d,l)=>d.rank-l.rank||(0,a.$uf)(d.uri.path,l.uri.path)),g=[];e:for(const d of i){let l;for(const p of d){const C=(0,P.$mc)(p.uri.path);if(l!==C&&(l=C,g.push(p.uri)>=u.d))break e}}this.g.$onDidChange(c,g)});return new I.$xM(()=>{f?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(r,o,c){if(!this.f.has(r))return Object.create(null);const f=Object.create(null),{provider:t,extensionDescription:s}=this.f.get(r);return await Promise.all(o.map(async n=>{try{const{uri:i,id:g}=n,d=await Promise.resolve(t.provideFileDecoration(b.URI.revive(i),c));if(!d)return;try{I.$XN.validate(d),d.badge&&typeof d.badge!="string"&&(0,y.$VG)(s,"codiconDecoration"),f[g]=[d.propagate,d.tooltip,d.badge,d.color]}catch(l){this.h.warn(`INVALID decoration from extension '${s.identifier.value}': ${l}`)}}catch(i){this.h.error(i)}})),f}};e.$3nc=k,k.c=0,k.d=250,e.$3nc=k=u=Je([qe(0,A.$ZO),qe(1,M.$7j)],k),e.$4nc=(0,T.$Ai)("IExtHostDecorations")}),define(Ce[269],Ie([1,0,14,2,7,5,16,22,13]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;class a{constructor(y,u,k){this.d=u,this.e=k,this.b=new Map,this.c=y.getProxy(T.$vM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,u){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const k=a.a++;this.b.set(k,u),this.c.$registerTextContentProvider(k,y);let h;if(typeof u.onDidChange=="function"){let r;h=u.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;r&&await r;const c=this.$provideTextDocumentContent(k,o).then(async f=>{if(!f&&typeof f!="string")return;const t=this.d.getDocument(o);if(!t)return;const s=(0,$.$of)(f);if(!t.equalLines(s))return this.c.$onVirtualDocumentChange(o,f)}).catch(b.$1).finally(()=>{r===c&&(r=void 0)});r=c})}return new I.$xM(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),h&&(h.dispose(),h=void 0)})}$provideTextDocumentContent(y,u){const k=this.b.get(y);return k?Promise.resolve(k.provideTextDocumentContent(D.URI.revive(u),M.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${u.scheme}`))}}e.$6nc=a,a.a=0}),define(Ce[121],Ie([1,0,61,16,13,325,209,7,18]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4O=e.$3O=void 0,e.$2O=P;const a=new Map;function P(h,r){r?a.set(h,r):a.delete(h)}function y(h){return a.get(h)}class u extends T.$dw{constructor(r,o,c,f,t,s,n){super(o,c,f,t),this.c=r,this.m=s,this.q=n,this.b=!1}dispose(){(0,b.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,$.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===D.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(o){return o?r.s(o):r.getText()},get eol(){return r.g===`
`?M.EndOfLine.LF:M.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(o){return r.t(o)},offsetAt(o){return r.u(o)},positionAt(o){return r.v(o)},validateRange(o){return r.w(o)},validatePosition(o){return r.x(o)},getWordRangeAtPosition(o,c){return r.y(o,c)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,b.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,b.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const o=this.w(r);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const c=this.g,f=o.start.line,t=o.end.line,s=[];s.push(this.f[f].substring(o.start.character));for(let n=f+1;n<t;n++)s.push(this.f[n]);return s.push(this.f[t].substring(0,o.end.character)),s.join(c)}t(r){let o;if(r instanceof M.$yM?o=r.line:typeof r=="number"&&(o=r),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new k(o,this.f[o],o===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const o=this.j.getIndexOf(r),c=this.f[o.index].length;return new M.$yM(o.index,Math.min(o.remainder,c))}w(r){if(!(r instanceof M.$zM))throw new Error("Invalid argument");const o=this.x(r.start),c=this.x(r.end);return o===r.start&&c===r.end?r:new M.$zM(o.line,o.character,c.line,c.character)}x(r){if(!(r instanceof M.$yM))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:o,character:c}=r,f=!1;if(o<0)o=0,c=0,f=!0;else if(o>=this.f.length)o=this.f.length-1,c=this.f[o].length,f=!0;else{const t=this.f[o].length;c<0?(c=0,f=!0):c>t&&(c=t,f=!0)}return f?new M.$yM(o,c):r}y(r,o){const c=this.x(r);if(!o)o=y(this.m);else if((0,I.$nf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const f=(0,A.$wt)(c.character+1,(0,A.$ut)(o),this.f[c.line],0);if(f)return new M.$zM(c.line,f.startColumn-1,c.line,f.endColumn-1)}}e.$3O=u;class k{constructor(r,o,c){this.a=r,this.b=o,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new M.$zM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new M.$zM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$4O=k}),define(Ce[270],Ie([1,0,5,7]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=void 0;class I{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(b.$vM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,M,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const a=this.a.get(A);if(!a)throw new Error("Embedding vector provider not found");const P=await a.provideEmbeddingVector(M,$);if(!P)throw new Error("Embedding vector provider returned undefined");return P}registerEmbeddingVectorProvider(A,M,$){const a=this.b;return this.b++,this.a.set(a,$),this.c.$registerAiEmbeddingVectorProvider(M,a),new D.$xM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(a),this.a.delete(a)})}}e.$9nc=I}),define(Ce[68],Ie([1,0,5,30,7,23,3,17,51,6,11,24,16]),function(_,e,b,D,I,T,A,M,$,a,P,y,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=e.$gnc=void 0;let h=k=class{constructor(o,c){this.b=new Map,this.c=new P.$Jh,this.a=o.getProxy(b.$vM.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(t){try{let s;const n=f.b.get(t.scheme);return n?(await f.a.$ensureActivation(t.scheme),s=await n.impl.stat(t)):s=await f.a.$stat(t),{type:s.type,ctime:s.ctime,mtime:s.mtime,size:s.size,permissions:s.permissions===D.FilePermission.Readonly?1:void 0}}catch(s){k.e(s)}},async readDirectory(t){try{const s=f.b.get(t.scheme);return s?(await f.a.$ensureActivation(t.scheme),(await s.impl.readDirectory(t)).slice()):await f.a.$readdir(t)}catch(s){return k.e(s)}},async createDirectory(t){try{const s=f.b.get(t.scheme);return s&&!s.isReadonly?(await f.a.$ensureActivation(t.scheme),await f.d(s.impl,s.extUri,t)):await f.a.$mkdir(t)}catch(s){return k.e(s)}},async readFile(t){try{const s=f.b.get(t.scheme);return s?(await f.a.$ensureActivation(t.scheme),(await s.impl.readFile(t)).slice()):(await f.a.$readFile(t)).buffer}catch(s){return k.e(s)}},async writeFile(t,s){try{const n=f.b.get(t.scheme);return n&&!n.isReadonly?(await f.a.$ensureActivation(t.scheme),await f.d(n.impl,n.extUri,n.extUri.dirname(t)),await f.c.queueFor(t,()=>Promise.resolve(n.impl.writeFile(t,s,{create:!0,overwrite:!0})))):await f.a.$writeFile(t,T.$Je.wrap(s))}catch(n){return k.e(n)}},async delete(t,s){try{const n=f.b.get(t.scheme);return n&&!n.isReadonly&&!s?.useTrash?(await f.a.$ensureActivation(t.scheme),await n.impl.delete(t,{recursive:!1,...s})):await f.a.$delete(t,{recursive:!1,useTrash:!1,atomic:!1,...s})}catch(n){return k.e(n)}},async rename(t,s,n){try{return await f.a.$rename(t,s,{overwrite:!1,...n})}catch(i){return k.e(i)}},async copy(t,s,n){try{return await f.a.$copy(t,s,{overwrite:!1,...n})}catch(i){return k.e(i)}},isWritableFileSystem(t){const s=c.getCapabilities(t);if(typeof s=="number")return!(s&D.FileSystemProviderCapabilities.Readonly)}})}async d(o,c,f){const t=[];for(;!c.isEqual(f,c.dirname(f));)try{if(!((await o.stat(f)).type&D.FileType.Directory))throw I.$ON.FileExists(`Unable to create folder '${f.scheme===u.Schemas.file?f.fsPath:f.toString(!0)}' that already exists but is not a directory`);break}catch(s){if(D.$kl(s)!==D.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(c.basename(f)),f=c.dirname(f)}for(let s=t.length-1;s>=0;s--){f=c.joinPath(f,t[s]);try{await o.createDirectory(f)}catch(n){if(D.$kl(n)!==D.FileSystemProviderErrorCode.FileExists)throw n}}}static e(o){if(o instanceof I.$ON)throw o;if(o instanceof D.$gl)switch(o.code){case D.FileSystemProviderErrorCode.FileExists:throw I.$ON.FileExists(o.message);case D.FileSystemProviderErrorCode.FileNotFound:throw I.$ON.FileNotFound(o.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw I.$ON.FileNotADirectory(o.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw I.$ON.FileIsADirectory(o.message);case D.FileSystemProviderErrorCode.NoPermissions:throw I.$ON.NoPermissions(o.message);case D.FileSystemProviderErrorCode.Unavailable:throw I.$ON.Unavailable(o.message);default:throw new I.$ON(o.message,o.name)}if(!(o instanceof Error))throw new I.$ON(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw I.$ON.Unavailable(o.message);switch(o.name){case D.FileSystemProviderErrorCode.FileExists:throw I.$ON.FileExists(o.message);case D.FileSystemProviderErrorCode.FileNotFound:throw I.$ON.FileNotFound(o.message);case D.FileSystemProviderErrorCode.FileNotADirectory:throw I.$ON.FileNotADirectory(o.message);case D.FileSystemProviderErrorCode.FileIsADirectory:throw I.$ON.FileIsADirectory(o.message);case D.FileSystemProviderErrorCode.NoPermissions:throw I.$ON.NoPermissions(o.message);case D.FileSystemProviderErrorCode.Unavailable:throw I.$ON.Unavailable(o.message);default:throw new I.$ON(o.message,o.name)}}addFileSystemProvider(o,c,f){return this.b.set(o,{impl:c,extUri:f?.isCaseSensitive?y.$4g:y.$6g,isReadonly:!!f?.isReadonly}),(0,a.$Sc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$4g}};e.$gnc=h,e.$gnc=h=k=Je([qe(0,M.$ZO),qe(1,$.$Wmc)],h),e.$hnc=(0,A.$Ai)("IExtHostConsumerFileSystem")}),define(Ce[92],Ie([1,0,3,27,12,68,2]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=e.$inc=void 0,e.$inc=(0,b.$Ai)("IExtensionStoragePaths");let M=class{constructor(a,P,y){this.d=P,this.f=y,this.a=a.workspace??void 0,this.b=a.environment,this.whenReady=this.h().then(u=>this.c=u)}async g(a){return A.URI.joinPath(this.b.workspaceStorageHome,a)}async h(){if(!this.a)return Promise.resolve(void 0);const a=this.a.id,P=await this.g(a);try{return await this.f.value.stat(P),this.d.trace("[ExtHostStorage] storage dir already exists",P),P}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",P),await this.f.value.createDirectory(P),await this.f.value.writeFile(A.URI.joinPath(P,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),P}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(a){if(this.c)return A.URI.joinPath(this.c,a.identifier.value)}globalValue(a){return A.URI.joinPath(this.b.globalStorageHome,a.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$jnc=M,e.$jnc=M=Je([qe(0,D.$dP),qe(1,I.$7j),qe(2,T.$hnc)],M)}),define(Ce[271],Ie([1,0,7,17,4]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qoc=void 0;let T=class{constructor(M){this.a=new b.$YN(b.ColorThemeKind.Dark),this.b=new I.$he}get activeColorTheme(){return this.a}$onColorThemeChange(M){let $;switch(M){case"light":$=b.ColorThemeKind.Light;break;case"hcDark":$=b.ColorThemeKind.HighContrast;break;case"hcLight":$=b.ColorThemeKind.HighContrastLight;break;default:$=b.ColorThemeKind.Dark}this.a=new b.$YN($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Qoc=T,e.$Qoc=T=Je([qe(0,D.$ZO)],T)}),define(Ce[93],Ie([1,0,22,4,6,189,3,12,222,5,27,17,7]),function(_,e,b,D,I,T,A,M,$,a,P,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xEb=e.$wEb=e.TunnelDtoConverter=void 0;class k extends $.$Cw{}var h;(function(o){function c(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,privacy:t.privacy??(t.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:t.protocol}}o.fromApiTunnel=c;function f(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.privacy!==$.TunnelPrivacyId.ConstantPrivate&&t.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:t.privacy,protocol:t.protocol}}o.fromServiceTunnel=f})(h||(e.TunnelDtoConverter=h={})),e.$wEb=(0,A.$Ai)("IExtHostTunnelService");let r=class extends I.$Uc{constructor(c,f,t){super(),this.s=t,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new D.$he,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(a.$vM.MainThreadTunnelService)}async openTunnel(c,f){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${f.remoteAddress.host}:${f.remoteAddress.port}.`);const t=await this.a.$openTunnel(f,c.displayName);if(t){const s=new k(t.remoteAddress,t.localAddress,()=>this.a.$closeTunnel(t.remoteAddress));return this.B(s),s}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,f){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const t=this.u();return this.r.set(t,{selector:c,provider:f}),this.a.$registerPortsAttributesProvider(c,t),new u.$xM(()=>{this.r.delete(t),this.a.$unregisterPortsAttributesProvider(t)})}async $providePortAttributes(c,f,t,s,n){const i=[];for(const d of c){const l=this.r.get(d);if(!l)return[];i.push(...await Promise.all(f.map(async p=>{let C;try{C=await l.provider.providePortAttributes({port:p,pid:t,commandLine:s},n)}catch{C=await l.provider.providePortAttributes(p,t,s,n)}return{providedAttributes:C,port:p}})))}const g=i.filter(d=>!!d.providedAttributes);return g.length>0?g.map(d=>({autoForwardAction:d.providedAttributes.autoForwardAction,port:d.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,f){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(s,n)=>await c.provideTunnel(s,n,b.CancellationToken.None)??void 0;const t=f.tunnelFeatures?{elevation:!!f.tunnelFeatures?.elevation,privacyOptions:f.tunnelFeatures?.privacyOptions,protocol:f.tunnelFeatures.protocol===void 0?!0:f.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(t),Promise.resolve((0,I.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,f){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const t=c.tunnelFactory??(f?this.w(f):void 0);if(t){this.b=t;let s=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&s.length===0&&(s=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const n=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:s,protocol:!0}:void 0;this.a.$setTunnelProvider(n)}}else this.b=void 0;return(0,I.$Sc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,f){if(this.g.has(c.host)){const t=this.g.get(c.host);t.has(c.port)&&(f&&t.get(c.port).disposeListener.dispose(),await t.get(c.port).tunnel.dispose(),t.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,f){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const t=this.b(c,f);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),t!==void 0){const s=await t;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),s===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const n=this.B(s.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(s.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:s,disposeListener:n}),h.fromApiTunnel(s)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(t){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),t instanceof Error)return t.message}}async $applyCandidateFilter(c){const f=await Promise.all(c.map(s=>this.f(s.host,s.port,s.detail??""))),t=c.filter((s,n)=>f[n]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(s=>s.port).join(", ")} to ${t.map(s=>s.port).join(", ")}`),t}};e.$xEb=r,e.$xEb=r=Je([qe(0,y.$ZO),qe(1,P.$dP),qe(2,M.$7j)],r)}),define(Ce[10],Ie([1,0,18,23,148,272,59,29,135,48,73,26,141,24,34,15,2,104,33,156,94,53,106,77,114,113,233,248,81,90,55,56,244,7]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s,n,i,g,d,l,p,C,S,v,E,R,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$WO=ae,e.$XO=ee,e.$YO=De;var N;(function(ye){function Oe(Q){const{selectionStartLineNumber:Ae,selectionStartColumn:ze,positionLineNumber:xe,positionColumn:Ge}=Q,ht=new m.$yM(Ae-1,ze-1),It=new m.$yM(xe-1,Ge-1);return new m.$AM(ht,It)}ye.to=Oe;function $e(Q){const{anchor:Ae,active:ze}=Q;return{selectionStartLineNumber:Ae.line+1,selectionStartColumn:Ae.character+1,positionLineNumber:ze.line+1,positionColumn:ze.character+1}}ye.from=$e})(N||(e.Selection=N={}));var B;(function(ye){function Oe(Q){if(!Q)return;const{start:Ae,end:ze}=Q;return{startLineNumber:Ae.line+1,startColumn:Ae.character+1,endLineNumber:ze.line+1,endColumn:ze.character+1}}ye.from=Oe;function $e(Q){if(!Q)return;const{startLineNumber:Ae,startColumn:ze,endLineNumber:xe,endColumn:Ge}=Q;return new m.$zM(Ae-1,ze-1,xe-1,Ge-1)}ye.to=$e})(B||(e.Range=B={}));var X;(function(ye){function Oe(Q){return{uri:Q.uri,range:B.from(Q.range)}}ye.from=Oe;function $e(Q){return new m.$JM(o.URI.revive(Q.uri),B.to(Q.range))}ye.to=$e})(X||(e.Location=X={}));var V;(function(ye){function Oe($e){switch($e){case t.StandardTokenType.Comment:return m.StandardTokenType.Comment;case t.StandardTokenType.Other:return m.StandardTokenType.Other;case t.StandardTokenType.RegEx:return m.StandardTokenType.RegEx;case t.StandardTokenType.String:return m.StandardTokenType.String}}ye.to=Oe})(V||(e.TokenType=V={}));var O;(function(ye){function Oe(Q){return new m.$yM(Q.lineNumber-1,Q.column-1)}ye.to=Oe;function $e(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ye.from=$e})(O||(e.Position=O={}));var L;(function(ye){function Oe(Ae,ze,xe){return(0,b.$Hb)((0,b.$2b)(Ae).map(Ge=>$e(Ge,ze,xe)))}ye.from=Oe;function $e(Ae,ze,xe){if(typeof Ae=="string")return{$serialized:!0,language:Ae,isBuiltin:xe?.isBuiltin};if(Ae)return{$serialized:!0,language:Ae.language,scheme:Q(Ae.scheme,ze),pattern:lt.from(Ae.pattern)??void 0,exclusive:Ae.exclusive,notebookType:Ae.notebookType,isBuiltin:xe?.isBuiltin}}function Q(Ae,ze){return ze&&typeof Ae=="string"?ze.transformOutgoingScheme(Ae):Ae}})(L||(e.DocumentSelector=L={}));var F;(function(ye){function Oe(Q){switch(Q){case m.DiagnosticTag.Unnecessary:return i.MarkerTag.Unnecessary;case m.DiagnosticTag.Deprecated:return i.MarkerTag.Deprecated}}ye.from=Oe;function $e(Q){switch(Q){case i.MarkerTag.Unnecessary:return m.DiagnosticTag.Unnecessary;case i.MarkerTag.Deprecated:return m.DiagnosticTag.Deprecated;default:return}}ye.to=$e})(F||(e.DiagnosticTag=F={}));var ie;(function(ye){function Oe(Q){let Ae;return Q.code&&((0,r.$ag)(Q.code)||(0,r.$eg)(Q.code)?Ae=String(Q.code):Ae={value:String(Q.code.value),target:Q.code.target}),{...B.from(Q.range),message:Q.message,source:Q.source,code:Ae,severity:be.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(de.from),tags:Array.isArray(Q.tags)?(0,b.$Hb)(Q.tags.map(F.from)):void 0}}ye.from=Oe;function $e(Q){const Ae=new m.$LM(B.to(Q),Q.message,be.to(Q.severity));return Ae.source=Q.source,Ae.code=(0,r.$ag)(Q.code)?Q.code:Q.code?.value,Ae.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(de.to),Ae.tags=Q.tags&&(0,b.$Hb)(Q.tags.map(F.to)),Ae}ye.to=$e})(ie||(e.Diagnostic=ie={}));var de;(function(ye){function Oe(Q){return{...B.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ye.from=Oe;function $e(Q){return new m.$KM(new m.$JM(Q.resource,B.to(Q)),Q.message)}ye.to=$e})(de||(e.DiagnosticRelatedInformation=de={}));var be;(function(ye){function Oe(Q){switch(Q){case m.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case m.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case m.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case m.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}ye.from=Oe;function $e(Q){switch(Q){case i.MarkerSeverity.Info:return m.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return m.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return m.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return m.DiagnosticSeverity.Hint;default:return m.DiagnosticSeverity.Error}}ye.to=$e})(be||(e.DiagnosticSeverity=be={}));var ve;(function(ye){function Oe(Q){return typeof Q=="number"&&Q>=m.ViewColumn.One?Q-1:Q===m.ViewColumn.Beside?w.$eE:w.$dE}ye.from=Oe;function $e(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=$e})(ve||(e.ViewColumn=ve={}));function Z(ye){return typeof ye.range<"u"}function ae(ye){return ye.length===0?!0:!!Z(ye[0])}var fe;(function(ye){function Oe(Ge){return Ge.map(ye.from)}ye.fromMany=Oe;function $e(Ge){return Ge&&typeof Ge=="object"&&typeof Ge.language=="string"&&typeof Ge.value=="string"}function Q(Ge){let ht;if($e(Ge)){const{language:Ut,value:Yt}=Ge;ht={value:"```"+Ut+`
`+Yt+"\n```\n"}}else m.$ZM.isMarkdownString(Ge)?ht={value:Ge.value,isTrusted:Ge.isTrusted,supportThemeIcons:Ge.supportThemeIcons,supportHtml:Ge.supportHtml,baseUri:Ge.baseUri}:typeof Ge=="string"?ht={value:Ge}:ht={value:""};const It=Object.create(null);ht.uris=It;const Zt=Ut=>{try{let Yt=o.URI.parse(Ut,!0);Yt=Yt.with({query:Ae(Yt.query,It)}),It[Ut]=Yt}catch{}return""},si=new $.marked.Renderer;return si.link=Zt,si.image=Ut=>typeof Ut=="string"?Zt(A.$6k(Ut).href):"",(0,$.marked)(ht.value,{renderer:si}),ht}ye.from=Q;function Ae(Ge,ht){if(!Ge)return Ge;let It;try{It=(0,a.$9h)(Ge)}catch{}if(!It)return Ge;let Zt=!1;return It=(0,y.$_n)(It,si=>{if(o.URI.isUri(si)){const Ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ht[Ut]=si,Zt=!0,Ut}else return}),Zt?JSON.stringify(It):Ge}function ze(Ge){const ht=new m.$ZM(Ge.value,Ge.supportThemeIcons);return ht.isTrusted=Ge.isTrusted,ht.supportHtml=Ge.supportHtml,ht.baseUri=Ge.baseUri?o.URI.from(Ge.baseUri):void 0,ht}ye.to=ze;function xe(Ge){if(Ge)return typeof Ge=="string"?Ge:ye.from(Ge)}ye.fromStrict=xe})(fe||(e.MarkdownString=fe={}));function ee(ye){return ae(ye)?ye.map(Oe=>({range:B.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?fe.fromMany(Oe.hoverMessage):Oe.hoverMessage?fe.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):ye.map(Oe=>({range:B.from(Oe)}))}function De(ye){return typeof ye>"u"?ye:typeof ye=="string"?o.URI.file(ye):ye}var Fe;(function(ye){function Oe($e){return typeof $e>"u"?$e:{contentText:$e.contentText,contentIconPath:$e.contentIconPath?De($e.contentIconPath):void 0,border:$e.border,borderColor:$e.borderColor,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,color:$e.color,backgroundColor:$e.backgroundColor,margin:$e.margin,width:$e.width,height:$e.height}}ye.from=Oe})(Fe||(e.ThemableDecorationAttachmentRenderOptions=Fe={}));var ce;(function(ye){function Oe($e){return typeof $e>"u"?$e:{backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?De($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?Fe.from($e.before):void 0,after:$e.after?Fe.from($e.after):void 0}}ye.from=Oe})(ce||(e.ThemableDecorationRenderOptions=ce={}));var H;(function(ye){function Oe($e){if(typeof $e>"u")return $e;switch($e){case m.DecorationRangeBehavior.OpenOpen:return n.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case m.DecorationRangeBehavior.ClosedClosed:return n.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case m.DecorationRangeBehavior.OpenClosed:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case m.DecorationRangeBehavior.ClosedOpen:return n.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}ye.from=Oe})(H||(e.DecorationRangeBehavior=H={}));var he;(function(ye){function Oe($e){return{isWholeLine:$e.isWholeLine,rangeBehavior:$e.rangeBehavior?H.from($e.rangeBehavior):void 0,overviewRulerLane:$e.overviewRulerLane,light:$e.light?ce.from($e.light):void 0,dark:$e.dark?ce.from($e.dark):void 0,backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?De($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?Fe.from($e.before):void 0,after:$e.after?Fe.from($e.after):void 0}}ye.from=Oe})(he||(e.DecorationRenderOptions=he={}));var le;(function(ye){function Oe(Q){return{text:Q.newText,eol:Q.newEol&&te.from(Q.newEol),range:B.from(Q.range)}}ye.from=Oe;function $e(Q){const Ae=new m.$EM(B.to(Q.range),Q.text);return Ae.newEol=typeof Q.eol>"u"?void 0:te.to(Q.eol),Ae}ye.to=$e})(le||(e.TextEdit=le={}));var re;(function(ye){function Oe(Q,Ae){const ze={edits:[]};if(Q instanceof m.$HM){const xe=new M.$Bc;for(const Ge of Q._allEntries())Ge._type===m.FileEditType.File&&o.URI.isUri(Ge.to)&&Ge.from===void 0&&xe.add(Ge.to);for(const Ge of Q._allEntries())if(Ge._type===m.FileEditType.File){let ht;Ge.options?.contents&&(ArrayBuffer.isView(Ge.options.contents)?ht={type:"base64",value:(0,D.$4e)(D.$Je.wrap(Ge.options.contents))}:ht={type:"dataTransferItem",id:Ge.options.contents._itemId}),ze.edits.push({oldResource:Ge.from,newResource:Ge.to,options:{...Ge.options,contents:ht},metadata:Ge.metadata})}else Ge._type===m.FileEditType.Text?ze.edits.push({resource:Ge.uri,textEdit:le.from(Ge.edit),versionId:xe.has(Ge.uri)?void 0:Ae?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===m.FileEditType.Snippet?ze.edits.push({resource:Ge.uri,textEdit:{range:B.from(Ge.range),text:Ge.edit.value,insertAsSnippet:!0},versionId:xe.has(Ge.uri)?void 0:Ae?.getTextDocumentVersion(Ge.uri),metadata:Ge.metadata}):Ge._type===m.FileEditType.Cell?ze.edits.push({metadata:Ge.metadata,resource:Ge.uri,cellEdit:Ge.edit,notebookMetadata:Ge.notebookMetadata,notebookVersionId:Ae?.getNotebookDocumentVersion(Ge.uri)}):Ge._type===m.FileEditType.CellReplace&&ze.edits.push({metadata:Ge.metadata,resource:Ge.uri,notebookVersionId:Ae?.getNotebookDocumentVersion(Ge.uri),cellEdit:{editType:v.CellEditType.Replace,index:Ge.index,count:Ge.count,cells:Ge.cells.map(_t.from)}})}return ze}ye.from=Oe;function $e(Q){const Ae=new m.$HM,ze=new M.$Ac;for(const xe of Q.edits)if(xe.textEdit){const Ge=xe,ht=o.URI.revive(Ge.resource),It=B.to(Ge.textEdit.range),Zt=Ge.textEdit.text,si=Ge.textEdit.insertAsSnippet;let Ut;si?Ut=m.$GM.replace(It,new m.$IM(Zt)):Ut=m.$EM.replace(It,Zt);const Yt=ze.get(ht);Yt?Yt.push(Ut):ze.set(ht,[Ut])}else Ae.renameFile(o.URI.revive(xe.oldResource),o.URI.revive(xe.newResource),xe.options);for(const[xe,Ge]of ze)Ae.set(xe,Ge);return Ae}ye.to=$e})(re||(e.WorkspaceEdit=re={}));var ue;(function(ye){const Oe=Object.create(null);Oe[m.SymbolKind.File]=s.SymbolKind.File,Oe[m.SymbolKind.Module]=s.SymbolKind.Module,Oe[m.SymbolKind.Namespace]=s.SymbolKind.Namespace,Oe[m.SymbolKind.Package]=s.SymbolKind.Package,Oe[m.SymbolKind.Class]=s.SymbolKind.Class,Oe[m.SymbolKind.Method]=s.SymbolKind.Method,Oe[m.SymbolKind.Property]=s.SymbolKind.Property,Oe[m.SymbolKind.Field]=s.SymbolKind.Field,Oe[m.SymbolKind.Constructor]=s.SymbolKind.Constructor,Oe[m.SymbolKind.Enum]=s.SymbolKind.Enum,Oe[m.SymbolKind.Interface]=s.SymbolKind.Interface,Oe[m.SymbolKind.Function]=s.SymbolKind.Function,Oe[m.SymbolKind.Variable]=s.SymbolKind.Variable,Oe[m.SymbolKind.Constant]=s.SymbolKind.Constant,Oe[m.SymbolKind.String]=s.SymbolKind.String,Oe[m.SymbolKind.Number]=s.SymbolKind.Number,Oe[m.SymbolKind.Boolean]=s.SymbolKind.Boolean,Oe[m.SymbolKind.Array]=s.SymbolKind.Array,Oe[m.SymbolKind.Object]=s.SymbolKind.Object,Oe[m.SymbolKind.Key]=s.SymbolKind.Key,Oe[m.SymbolKind.Null]=s.SymbolKind.Null,Oe[m.SymbolKind.EnumMember]=s.SymbolKind.EnumMember,Oe[m.SymbolKind.Struct]=s.SymbolKind.Struct,Oe[m.SymbolKind.Event]=s.SymbolKind.Event,Oe[m.SymbolKind.Operator]=s.SymbolKind.Operator,Oe[m.SymbolKind.TypeParameter]=s.SymbolKind.TypeParameter;function $e(Ae){return typeof Oe[Ae]=="number"?Oe[Ae]:s.SymbolKind.Property}ye.from=$e;function Q(Ae){for(const ze in Oe)if(Oe[ze]===Ae)return Number(ze);return m.SymbolKind.Property}ye.to=Q})(ue||(e.SymbolKind=ue={}));var oe;(function(ye){function Oe(Q){switch(Q){case m.SymbolTag.Deprecated:return s.SymbolTag.Deprecated}}ye.from=Oe;function $e(Q){switch(Q){case s.SymbolTag.Deprecated:return m.SymbolTag.Deprecated}}ye.to=$e})(oe||(e.SymbolTag=oe={}));var J;(function(ye){function Oe(Q){return{name:Q.name,kind:ue.from(Q.kind),tags:Q.tags&&Q.tags.map(oe.from),containerName:Q.containerName,location:Ve.from(Q.location)}}ye.from=Oe;function $e(Q){const Ae=new m.$QM(Q.name,ue.to(Q.kind),Q.containerName,Ve.to(Q.location));return Ae.tags=Q.tags&&Q.tags.map(oe.to),Ae}ye.to=$e})(J||(e.WorkspaceSymbol=J={}));var Y;(function(ye){function Oe(Q){const Ae={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:B.from(Q.range),selectionRange:B.from(Q.selectionRange),kind:ue.from(Q.kind),tags:Q.tags?.map(oe.from)??[]};return Q.children&&(Ae.children=Q.children.map(Oe)),Ae}ye.from=Oe;function $e(Q){const Ae=new m.$RM(Q.name,Q.detail,ue.to(Q.kind),B.to(Q.range),B.to(Q.selectionRange));return(0,b.$Lb)(Q.tags)&&(Ae.tags=Q.tags.map(oe.to)),Q.children&&(Ae.children=Q.children.map($e)),Ae}ye.to=$e})(Y||(e.DocumentSymbol=Y={}));var we;(function(ye){function Oe(Q){const Ae=new m.$VM(ue.to(Q.kind),Q.name,Q.detail||"",o.URI.revive(Q.uri),B.to(Q.range),B.to(Q.selectionRange));return Ae._sessionId=Q._sessionId,Ae._itemId=Q._itemId,Ae}ye.to=Oe;function $e(Q,Ae,ze){if(Ae=Ae??Q._sessionId,ze=ze??Q._itemId,Ae===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:ze,name:Q.name,detail:Q.detail,kind:ue.from(Q.kind),uri:Q.uri,range:B.from(Q.range),selectionRange:B.from(Q.selectionRange),tags:Q.tags?.map(oe.from)}}ye.from=$e})(we||(e.CallHierarchyItem=we={}));var pe;(function(ye){function Oe($e){return new m.$WM(we.to($e.from),$e.fromRanges.map(Q=>B.to(Q)))}ye.to=Oe})(pe||(e.CallHierarchyIncomingCall=pe={}));var Me;(function(ye){function Oe($e){return new m.$XM(we.to($e.to),$e.fromRanges.map(Q=>B.to(Q)))}ye.to=Oe})(Me||(e.CallHierarchyOutgoingCall=Me={}));var Ve;(function(ye){function Oe(Q){return{range:Q.range&&B.from(Q.range),uri:Q.uri}}ye.from=Oe;function $e(Q){return new m.$JM(o.URI.revive(Q.uri),B.to(Q.range))}ye.to=$e})(Ve||(e.location=Ve={}));var Se;(function(ye){function Oe(Q){const Ae=Q,ze=Q;return{originSelectionRange:Ae.originSelectionRange?B.from(Ae.originSelectionRange):void 0,uri:Ae.targetUri?Ae.targetUri:ze.uri,range:B.from(Ae.targetRange?Ae.targetRange:ze.range),targetSelectionRange:Ae.targetSelectionRange?B.from(Ae.targetSelectionRange):void 0}}ye.from=Oe;function $e(Q){return{targetUri:o.URI.revive(Q.uri),targetRange:B.to(Q.range),targetSelectionRange:Q.targetSelectionRange?B.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?B.to(Q.originSelectionRange):void 0}}ye.to=$e})(Se||(e.DefinitionLink=Se={}));var Pe;(function(ye){function Oe(Q){return{range:B.from(Q.range),contents:fe.fromMany(Q.contents),canIncreaseVerbosity:Q.canIncreaseVerbosity,canDecreaseVerbosity:Q.canDecreaseVerbosity}}ye.from=Oe;function $e(Q){const Ae=Q.contents.map(fe.to),ze=B.to(Q.range),xe=Q.canIncreaseVerbosity,Ge=Q.canDecreaseVerbosity;return new m.$NM(Ae,ze,xe,Ge)}ye.to=$e})(Pe||(e.Hover=Pe={}));var Te;(function(ye){function Oe(Q){return{range:B.from(Q.range),expression:Q.expression}}ye.from=Oe;function $e(Q){return new m.$IN(B.to(Q.range),Q.expression)}ye.to=$e})(Te||(e.EvaluatableExpression=Te={}));var U;(function(ye){function Oe(Q){if(Q instanceof m.$JN)return{type:"text",range:B.from(Q.range),text:Q.text};if(Q instanceof m.$KN)return{type:"variable",range:B.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof m.$LN)return{type:"expression",range:B.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Oe;function $e(Q){switch(Q.type){case"text":return{range:B.to(Q.range),text:Q.text};case"variable":return{range:B.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:B.to(Q.range),expression:Q.expression}}}ye.to=$e})(U||(e.InlineValue=U={}));var W;(function(ye){function Oe(Q){return{frameId:Q.frameId,stoppedLocation:B.from(Q.stoppedLocation)}}ye.from=Oe;function $e(Q){return new m.$MN(Q.frameId,B.to(Q.stoppedLocation))}ye.to=$e})(W||(e.InlineValueContext=W={}));var G;(function(ye){function Oe(Q){return{range:B.from(Q.range),kind:Q.kind}}ye.from=Oe;function $e(Q){return new m.$OM(B.to(Q.range),Q.kind)}ye.to=$e})(G||(e.DocumentHighlight=G={}));var K;(function(ye){function Oe(Q){return{uri:Q.uri,highlights:Q.highlights.map(G.from)}}ye.from=Oe;function $e(Q){return new m.$PM(o.URI.revive(Q.uri),Q.highlights.map(G.to))}ye.to=$e})(K||(e.MultiDocumentHighlight=K={}));var x;(function(ye){function Oe($e){switch($e){case s.CompletionTriggerKind.TriggerCharacter:return m.CompletionTriggerKind.TriggerCharacter;case s.CompletionTriggerKind.TriggerForIncompleteCompletions:return m.CompletionTriggerKind.TriggerForIncompleteCompletions;case s.CompletionTriggerKind.Invoke:default:return m.CompletionTriggerKind.Invoke}}ye.to=Oe})(x||(e.CompletionTriggerKind=x={}));var ge;(function(ye){function Oe($e){return{triggerKind:x.to($e.triggerKind),triggerCharacter:$e.triggerCharacter}}ye.to=Oe})(ge||(e.CompletionContext=ge={}));var Re;(function(ye){function Oe(Q){switch(Q){case m.CompletionItemTag.Deprecated:return s.CompletionItemTag.Deprecated}}ye.from=Oe;function $e(Q){switch(Q){case s.CompletionItemTag.Deprecated:return m.CompletionItemTag.Deprecated}}ye.to=$e})(Re||(e.CompletionItemTag=Re={}));var Ue;(function(ye){const Oe=new Map([[m.CompletionItemKind.Method,s.CompletionItemKind.Method],[m.CompletionItemKind.Function,s.CompletionItemKind.Function],[m.CompletionItemKind.Constructor,s.CompletionItemKind.Constructor],[m.CompletionItemKind.Field,s.CompletionItemKind.Field],[m.CompletionItemKind.Variable,s.CompletionItemKind.Variable],[m.CompletionItemKind.Class,s.CompletionItemKind.Class],[m.CompletionItemKind.Interface,s.CompletionItemKind.Interface],[m.CompletionItemKind.Struct,s.CompletionItemKind.Struct],[m.CompletionItemKind.Module,s.CompletionItemKind.Module],[m.CompletionItemKind.Property,s.CompletionItemKind.Property],[m.CompletionItemKind.Unit,s.CompletionItemKind.Unit],[m.CompletionItemKind.Value,s.CompletionItemKind.Value],[m.CompletionItemKind.Constant,s.CompletionItemKind.Constant],[m.CompletionItemKind.Enum,s.CompletionItemKind.Enum],[m.CompletionItemKind.EnumMember,s.CompletionItemKind.EnumMember],[m.CompletionItemKind.Keyword,s.CompletionItemKind.Keyword],[m.CompletionItemKind.Snippet,s.CompletionItemKind.Snippet],[m.CompletionItemKind.Text,s.CompletionItemKind.Text],[m.CompletionItemKind.Color,s.CompletionItemKind.Color],[m.CompletionItemKind.File,s.CompletionItemKind.File],[m.CompletionItemKind.Reference,s.CompletionItemKind.Reference],[m.CompletionItemKind.Folder,s.CompletionItemKind.Folder],[m.CompletionItemKind.Event,s.CompletionItemKind.Event],[m.CompletionItemKind.Operator,s.CompletionItemKind.Operator],[m.CompletionItemKind.TypeParameter,s.CompletionItemKind.TypeParameter],[m.CompletionItemKind.Issue,s.CompletionItemKind.Issue],[m.CompletionItemKind.User,s.CompletionItemKind.User]]);function $e(ze){return Oe.get(ze)??s.CompletionItemKind.Property}ye.from=$e;const Q=new Map([[s.CompletionItemKind.Method,m.CompletionItemKind.Method],[s.CompletionItemKind.Function,m.CompletionItemKind.Function],[s.CompletionItemKind.Constructor,m.CompletionItemKind.Constructor],[s.CompletionItemKind.Field,m.CompletionItemKind.Field],[s.CompletionItemKind.Variable,m.CompletionItemKind.Variable],[s.CompletionItemKind.Class,m.CompletionItemKind.Class],[s.CompletionItemKind.Interface,m.CompletionItemKind.Interface],[s.CompletionItemKind.Struct,m.CompletionItemKind.Struct],[s.CompletionItemKind.Module,m.CompletionItemKind.Module],[s.CompletionItemKind.Property,m.CompletionItemKind.Property],[s.CompletionItemKind.Unit,m.CompletionItemKind.Unit],[s.CompletionItemKind.Value,m.CompletionItemKind.Value],[s.CompletionItemKind.Constant,m.CompletionItemKind.Constant],[s.CompletionItemKind.Enum,m.CompletionItemKind.Enum],[s.CompletionItemKind.EnumMember,m.CompletionItemKind.EnumMember],[s.CompletionItemKind.Keyword,m.CompletionItemKind.Keyword],[s.CompletionItemKind.Snippet,m.CompletionItemKind.Snippet],[s.CompletionItemKind.Text,m.CompletionItemKind.Text],[s.CompletionItemKind.Color,m.CompletionItemKind.Color],[s.CompletionItemKind.File,m.CompletionItemKind.File],[s.CompletionItemKind.Reference,m.CompletionItemKind.Reference],[s.CompletionItemKind.Folder,m.CompletionItemKind.Folder],[s.CompletionItemKind.Event,m.CompletionItemKind.Event],[s.CompletionItemKind.Operator,m.CompletionItemKind.Operator],[s.CompletionItemKind.TypeParameter,m.CompletionItemKind.TypeParameter],[s.CompletionItemKind.User,m.CompletionItemKind.User],[s.CompletionItemKind.Issue,m.CompletionItemKind.Issue]]);function Ae(ze){return Q.get(ze)??m.CompletionItemKind.Property}ye.to=Ae})(Ue||(e.CompletionItemKind=Ue={}));var Ke;(function(ye){function Oe($e,Q){const Ae=new m.$6M($e.label);return Ae.insertText=$e.insertText,Ae.kind=Ue.to($e.kind),Ae.tags=$e.tags?.map(Re.to),Ae.detail=$e.detail,Ae.documentation=A.$Zk($e.documentation)?fe.to($e.documentation):$e.documentation,Ae.sortText=$e.sortText,Ae.filterText=$e.filterText,Ae.preselect=$e.preselect,Ae.commitCharacters=$e.commitCharacters,f.$dt.isIRange($e.range)?Ae.range=B.to($e.range):typeof $e.range=="object"&&(Ae.range={inserting:B.to($e.range.insert),replacing:B.to($e.range.replace)}),Ae.keepWhitespace=typeof $e.insertTextRules>"u"?!1:!!($e.insertTextRules&s.CompletionItemInsertTextRule.KeepWhitespace),typeof $e.insertTextRules<"u"&&$e.insertTextRules&s.CompletionItemInsertTextRule.InsertAsSnippet?Ae.insertText=new m.$IM($e.insertText):(Ae.insertText=$e.insertText,Ae.textEdit=Ae.range instanceof m.$zM?new m.$EM(Ae.range,Ae.insertText):void 0),$e.additionalTextEdits&&$e.additionalTextEdits.length>0&&(Ae.additionalTextEdits=$e.additionalTextEdits.map(ze=>le.to(ze))),Ae.command=Q&&$e.command?Q.fromInternal($e.command):void 0,Ae}ye.to=Oe})(Ke||(e.CompletionItem=Ke={}));var Ze;(function(ye){function Oe(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:fe.fromStrict(Q.documentation)}}ye.from=Oe;function $e(Q){return{label:Q.label,documentation:A.$Zk(Q.documentation)?fe.to(Q.documentation):Q.documentation}}ye.to=$e})(Ze||(e.ParameterInformation=Ze={}));var nt;(function(ye){function Oe(Q){return{label:Q.label,documentation:fe.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(Ze.from):[],activeParameter:Q.activeParameter}}ye.from=Oe;function $e(Q){return{label:Q.label,documentation:A.$Zk(Q.documentation)?fe.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(Ze.to):[],activeParameter:Q.activeParameter}}ye.to=$e})(nt||(e.SignatureInformation=nt={}));var it;(function(ye){function Oe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(nt.from):[]}}ye.from=Oe;function $e(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(nt.to):[]}}ye.to=$e})(it||(e.SignatureHelp=it={}));var st;(function(ye){function Oe($e,Q){const Ae=new m.$5M(O.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(ot.to.bind(void 0,$e)),Q.kind&&$t.to(Q.kind));return Ae.textEdits=Q.textEdits&&Q.textEdits.map(le.to),Ae.tooltip=A.$Zk(Q.tooltip)?fe.to(Q.tooltip):Q.tooltip,Ae.paddingLeft=Q.paddingLeft,Ae.paddingRight=Q.paddingRight,Ae}ye.to=Oe})(st||(e.InlayHint=st={}));var ot;(function(ye){function Oe($e,Q){const Ae=new m.$4M(Q.label);return Ae.tooltip=A.$Zk(Q.tooltip)?fe.to(Q.tooltip):Q.tooltip,s.Command.is(Q.command)&&(Ae.command=$e.fromInternal(Q.command)),Q.location&&(Ae.location=Ve.to(Q.location)),Ae}ye.to=Oe})(ot||(e.InlayHintLabelPart=ot={}));var $t;(function(ye){function Oe(Q){return Q}ye.from=Oe;function $e(Q){return Q}ye.to=$e})($t||(e.InlayHintKind=$t={}));var dt;(function(ye){function Oe(Q){return{range:B.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ye.from=Oe;function $e(Q){let Ae;if(Q.url)try{Ae=typeof Q.url=="string"?o.URI.parse(Q.url,!0):o.URI.revive(Q.url)}catch{}return new m.$$M(B.to(Q.range),Ae)}ye.to=$e})(dt||(e.DocumentLink=dt={}));var rt;(function(ye){function Oe(Q){const Ae=new m.$bN(Q.label);return Q.textEdit&&(Ae.textEdit=le.to(Q.textEdit)),Q.additionalTextEdits&&(Ae.additionalTextEdits=Q.additionalTextEdits.map(ze=>le.to(ze))),Ae}ye.to=Oe;function $e(Q){return{label:Q.label,textEdit:Q.textEdit?le.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Ae=>le.from(Ae)):void 0}}ye.from=$e})(rt||(e.ColorPresentation=rt={}));var ut;(function(ye){function Oe(Q){return new m.$_M(Q[0],Q[1],Q[2],Q[3])}ye.to=Oe;function $e(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ye.from=$e})(ut||(e.Color=ut={}));var gt;(function(ye){function Oe(Q){return{range:B.from(Q.range)}}ye.from=Oe;function $e(Q){return new m.$UM(B.to(Q.range))}ye.to=$e})(gt||(e.SelectionRange=gt={}));var We;(function(ye){function Oe($e){switch($e){case l.SaveReason.AUTO:return m.TextDocumentSaveReason.AfterDelay;case l.SaveReason.EXPLICIT:return m.TextDocumentSaveReason.Manual;case l.SaveReason.FOCUS_CHANGE:case l.SaveReason.WINDOW_CHANGE:return m.TextDocumentSaveReason.FocusOut}}ye.to=Oe})(We||(e.TextDocumentSaveReason=We={}));var je;(function(ye){function Oe(Q){switch(Q){case m.TextEditorLineNumbersStyle.Off:return c.RenderLineNumbersType.Off;case m.TextEditorLineNumbersStyle.Relative:return c.RenderLineNumbersType.Relative;case m.TextEditorLineNumbersStyle.Interval:return c.RenderLineNumbersType.Interval;case m.TextEditorLineNumbersStyle.On:default:return c.RenderLineNumbersType.On}}ye.from=Oe;function $e(Q){switch(Q){case c.RenderLineNumbersType.Off:return m.TextEditorLineNumbersStyle.Off;case c.RenderLineNumbersType.Relative:return m.TextEditorLineNumbersStyle.Relative;case c.RenderLineNumbersType.Interval:return m.TextEditorLineNumbersStyle.Interval;case c.RenderLineNumbersType.On:default:return m.TextEditorLineNumbersStyle.On}}ye.to=$e})(je||(e.TextEditorLineNumbersStyle=je={}));var te;(function(ye){function Oe(Q){if(Q===m.EndOfLine.CRLF)return n.EndOfLineSequence.CRLF;if(Q===m.EndOfLine.LF)return n.EndOfLineSequence.LF}ye.from=Oe;function $e(Q){if(Q===n.EndOfLineSequence.CRLF)return m.EndOfLine.CRLF;if(Q===n.EndOfLineSequence.LF)return m.EndOfLine.LF}ye.to=$e})(te||(e.EndOfLine=te={}));var q;(function(ye){function Oe($e){if(typeof $e=="object")return $e.viewId;switch($e){case m.ProgressLocation.SourceControl:return g.ProgressLocation.Scm;case m.ProgressLocation.Window:return g.ProgressLocation.Window;case m.ProgressLocation.Notification:return g.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}ye.from=Oe})(q||(e.ProgressLocation=q={}));var Ee;(function(ye){function Oe(Q){const Ae={start:Q.start+1,end:Q.end+1};return Q.kind&&(Ae.kind=He.from(Q.kind)),Ae}ye.from=Oe;function $e(Q){const Ae={start:Q.start-1,end:Q.end-1};return Q.kind&&(Ae.kind=He.to(Q.kind)),Ae}ye.to=$e})(Ee||(e.FoldingRange=Ee={}));var He;(function(ye){function Oe(Q){if(Q)switch(Q){case m.FoldingRangeKind.Comment:return s.$Qv.Comment;case m.FoldingRangeKind.Imports:return s.$Qv.Imports;case m.FoldingRangeKind.Region:return s.$Qv.Region}}ye.from=Oe;function $e(Q){if(Q)switch(Q.value){case s.$Qv.Comment.value:return m.FoldingRangeKind.Comment;case s.$Qv.Imports.value:return m.FoldingRangeKind.Imports;case s.$Qv.Region.value:return m.FoldingRangeKind.Region}}ye.to=$e})(He||(e.FoldingRangeKind=He={}));var _e;(function(ye){function Oe($e){if($e)return{pinned:typeof $e.preview=="boolean"?!$e.preview:void 0,inactive:$e.background,preserveFocus:$e.preserveFocus,selection:typeof $e.selection=="object"?B.from($e.selection):void 0,override:typeof $e.override=="boolean"?l.$GF.id:void 0}}ye.from=Oe})(_e||(e.TextEditorOpenOptions=_e={}));var lt;(function(ye){function Oe(ze){return ze instanceof m.$wN?ze.toJSON():typeof ze=="string"?ze:$e(ze)||Q(ze)?new m.$wN(ze.baseUri??ze.base,ze.pattern).toJSON():ze}ye.from=Oe;function $e(ze){const xe=ze;return xe?o.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function Q(ze){const xe=ze;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Ae(ze){return typeof ze=="string"?ze:new m.$wN(o.URI.revive(ze.baseUri),ze.pattern)}ye.to=Ae})(lt||(e.GlobPattern=lt={}));var mt;(function(ye){function Oe($e){if($e){if(Array.isArray($e))return $e.map(Oe);if(typeof $e=="string")return $e;{const Q=$e;return{language:Q.language,scheme:Q.scheme,pattern:lt.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}ye.from=Oe})(mt||(e.LanguageSelector=mt={}));var At;(function(ye){function Oe(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Ae=>Array.isArray(Ae)&&Ae.every(ze=>ze&&typeof ze=="object"&&"uri"in ze&&o.URI.isUri(ze.uri)&&"version"in ze&&typeof ze.version=="number"&&"ranges"in ze&&Array.isArray(ze.ranges)&&ze.ranges.every(xe=>xe instanceof m.$zM)))}ye.is=Oe;function $e(Q){return{documents:Q.documents.map(Ae=>Ae.map(ze=>({uri:o.URI.from(ze.uri),version:ze.version,ranges:ze.ranges.map(xe=>B.from(xe))})))}}ye.from=$e})(At||(e.MappedEditsContext=At={}));var Jt;(function(ye){function Oe(Q){return{start:Q.start,end:Q.end}}ye.from=Oe;function $e(Q){return new m.$ZN(Q.start,Q.end)}ye.to=$e})(Jt||(e.NotebookRange=Jt={}));var qt;(function(ye){function Oe(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ye.to=Oe;function $e(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ye.from=$e})(qt||(e.NotebookCellExecutionSummary=qt={}));var hi;(function(ye){function Oe($e){if($e===v.NotebookCellExecutionState.Unconfirmed)return m.NotebookCellExecutionState.Pending;if($e===v.NotebookCellExecutionState.Pending)return;if($e===v.NotebookCellExecutionState.Executing)return m.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${$e}`)}ye.to=Oe})(hi||(e.NotebookCellExecutionState=hi={}));var ii;(function(ye){function Oe(Q){switch(Q){case m.NotebookCellKind.Markup:return v.CellKind.Markup;case m.NotebookCellKind.Code:default:return v.CellKind.Code}}ye.from=Oe;function $e(Q){switch(Q){case v.CellKind.Markup:return m.NotebookCellKind.Markup;case v.CellKind.Code:default:return m.NotebookCellKind.Code}}ye.to=$e})(ii||(e.NotebookCellKind=ii={}));var Ye;(function(ye){function Oe(Q){const Ae={metadata:Q.metadata??Object.create(null),cells:[]};for(const ze of Q.cells)m.$1N.validate(ze),Ae.cells.push(_t.from(ze));return Ae}ye.from=Oe;function $e(Q){const Ae=new m.$2N(Q.cells.map(_t.to));return(0,r.$ng)(Q.metadata)||(Ae.metadata=Q.metadata),Ae}ye.to=$e})(Ye||(e.NotebookData=Ye={}));var _t;(function(ye){function Oe(Q){return{cellKind:ii.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:qt.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(pt.from):[]}}ye.from=Oe;function $e(Q){return new m.$1N(ii.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(pt.to):void 0,Q.metadata,Q.internalMetadata?qt.to(Q.internalMetadata):void 0)}ye.to=$e})(_t||(e.NotebookCellData=_t={}));var Qt;(function(ye){function Oe(Q){return{mime:Q.mime,valueBytes:D.$Je.wrap(Q.data)}}ye.from=Oe;function $e(Q){return new m.$3N(Q.valueBytes.buffer,Q.mime)}ye.to=$e})(Qt||(e.NotebookCellOutputItem=Qt={}));var pt;(function(ye){function Oe(Q){return{outputId:Q.id,items:Q.items.map(Qt.from),metadata:Q.metadata}}ye.from=Oe;function $e(Q){const Ae=Q.items.map(Qt.to);return new m.$4N(Ae,Q.outputId,Q.metadata)}ye.to=$e})(pt||(e.NotebookCellOutput=pt={}));var bt;(function(ye){function Oe(Ae){return Q(Ae)?{include:lt.from(Ae.include)??void 0,exclude:lt.from(Ae.exclude)??void 0}:lt.from(Ae)??void 0}ye.from=Oe;function $e(Ae){return Q(Ae)?{include:lt.to(Ae.include),exclude:lt.to(Ae.exclude)}:lt.to(Ae)}ye.to=$e;function Q(Ae){const ze=Ae;return ze?!(0,r.$jg)(ze.include)&&!(0,r.$jg)(ze.exclude):!1}})(bt||(e.NotebookExclusiveDocumentPattern=bt={}));var Xt;(function(ye){function Oe($e,Q,Ae){const ze=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{alignment:$e.alignment===m.NotebookCellStatusBarAlignment.Left?v.CellStatusbarAlignment.Left:v.CellStatusbarAlignment.Right,command:Q.toInternal(ze,Ae),text:$e.text,tooltip:$e.tooltip,accessibilityInformation:$e.accessibilityInformation,priority:$e.priority}}ye.from=Oe})(Xt||(e.NotebookStatusBarItem=Xt={}));var ei;(function(ye){function Oe($e,Q,Ae){const ze=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{command:Q.toInternal(ze,Ae),label:$e.label,description:$e.description,detail:$e.detail,documentation:$e.documentation}}ye.from=Oe})(ei||(e.NotebookKernelSourceAction=ei={}));var Wt;(function(ye){function Oe($e){return{transientOutputs:$e?.transientOutputs??!1,transientCellMetadata:$e?.transientCellMetadata??{},transientDocumentMetadata:$e?.transientDocumentMetadata??{},cellContentMetadata:$e?.cellContentMetadata??{}}}ye.from=Oe})(Wt||(e.NotebookDocumentContentOptions=Wt={}));var wt;(function(ye){function Oe(Q){return{uri:Q.uri,provides:Q.provides}}ye.from=Oe;function $e(Q){return new m.$6N(o.URI.revive(Q.uri),Q.provides)}ye.to=$e})(wt||(e.NotebookRendererScript=wt={}));var Tt;(function(ye){function Oe(Q){return{message:fe.fromStrict(Q.message)||"",type:R.TestMessageType.Error,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:B.from(Q.location.range),uri:Q.location.uri}}}ye.from=Oe;function $e(Q){const Ae=new m.$_N(typeof Q.message=="string"?Q.message:fe.to(Q.message));return Ae.actualOutput=Q.actual,Ae.expectedOutput=Q.expected,Ae.contextValue=Q.contextValue,Ae.location=Q.location?Ve.to(Q.location):void 0,Ae}ye.to=$e})(Tt||(e.TestMessage=Tt={}));var jt;(function(ye){ye.namespace=R.$mL,ye.denamespace=R.$nL})(jt||(e.TestTag=jt={}));var Lt;(function(ye){function Oe(Q){const Ae=(0,d.$VO)(Q).controllerId;return{extId:E.$hL.fromExtHostTestItem(Q,Ae).toString(),label:Q.label,uri:o.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(ze=>jt.namespace(Ae,ze.id)),range:f.$dt.lift(B.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&fe.fromStrict(Q.error)||null}}ye.from=Oe;function $e(Q){return{parent:void 0,error:void 0,id:E.$hL.fromString(Q.extId).localId,label:Q.label,uri:o.URI.revive(Q.uri),tags:(Q.tags||[]).map(Ae=>{const{tagId:ze}=jt.denamespace(Ae);return new m.$aO(ze)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:B.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}ye.toPlain=$e})(Lt||(e.TestItem=Lt={})),function(ye){function Oe(Q){return{id:Q.id}}ye.from=Oe;function $e(Q){return new m.$aO(Q.id)}ye.to=$e}(jt||(e.TestTag=jt={}));var Xe;(function(ye){const Oe=(Q,Ae)=>{const ze=Q.value;if(!ze)return;const xe={...Lt.toPlain(ze.item),parent:Ae,taskStates:ze.tasks.map(Ge=>({state:Ge.state,duration:Ge.duration,messages:Ge.messages.filter(ht=>ht.type===R.TestMessageType.Error).map(Tt.to)})),children:[]};if(Q.children)for(const Ge of Q.children.values()){const ht=Oe(Ge,xe);ht&&xe.children.push(ht)}return xe};function $e(Q){const Ae=new u.$OO;for(const Ge of Q.items)Ae.insert(E.$hL.fromString(Ge.item.extId).path,Ge);const ze=[Ae.nodes],xe=[];for(;ze.length;)for(const Ge of ze.pop())Ge.value?xe.push(Ge):Ge.children&&ze.push(Ge.children.values());return{completedAt:Q.completedAt,results:xe.map(Ge=>Oe(Ge)).filter(r.$ig)}}ye.to=$e})(Xe||(e.TestResults=Xe={}));var ti;(function(ye){function Oe(ze){return{covered:ze.covered,total:ze.total}}function $e(ze){return"line"in ze?O.from(ze):B.from(ze)}function Q(ze){if(typeof ze.executed=="number"&&ze.executed<0)throw new Error(`Invalid coverage count ${ze.executed}`);return"branches"in ze?{count:ze.executed,location:$e(ze.location),type:R.DetailType.Statement,branches:ze.branches.length?ze.branches.map(xe=>({count:xe.executed,location:xe.location&&$e(xe.location),label:xe.label})):void 0}:{type:R.DetailType.Declaration,name:ze.name,count:ze.executed,location:$e(ze.location)}}ye.fromDetails=Q;function Ae(ze,xe,Ge){return m.$cO(Ge.statementCoverage),m.$cO(Ge.branchCoverage),m.$cO(Ge.declarationCoverage),{id:xe,uri:Ge.uri,statement:Oe(Ge.statementCoverage),branch:Ge.branchCoverage&&Oe(Ge.branchCoverage),declaration:Ge.declarationCoverage&&Oe(Ge.declarationCoverage),testId:Ge instanceof m.$dO&&Ge.testItem?E.$hL.fromExtHostTestItem(Ge.testItem,ze).toString():void 0}}ye.fromFile=Ae})(ti||(e.TestCoverage=ti={}));var ni;(function(ye){function Oe($e){switch($e){case s.CodeActionTriggerType.Invoke:return m.CodeActionTriggerKind.Invoke;case s.CodeActionTriggerType.Auto:return m.CodeActionTriggerKind.Automatic}}ye.to=Oe})(ni||(e.CodeActionTriggerKind=ni={}));var ci;(function(ye){function Oe(Q){const Ae=new m.$hO(ue.to(Q.kind),Q.name,Q.detail||"",o.URI.revive(Q.uri),B.to(Q.range),B.to(Q.selectionRange));return Ae._sessionId=Q._sessionId,Ae._itemId=Q._itemId,Ae}ye.to=Oe;function $e(Q,Ae,ze){if(Ae=Ae??Q._sessionId,ze=ze??Q._itemId,Ae===void 0||ze===void 0)throw new Error("invalid item");return{_sessionId:Ae,_itemId:ze,kind:ue.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:B.from(Q.range),selectionRange:B.from(Q.selectionRange),tags:Q.tags?.map(oe.from)}}ye.from=$e})(ci||(e.TypeHierarchyItem=ci={}));var Ct;(function(ye){function Oe($e){if($e)return{value:$e.value,tooltip:$e.tooltip}}ye.from=Oe})(Ct||(e.ViewBadge=Ct={}));var Ft;(function(ye){function Oe(ze,xe,Ge){const ht=xe.fileData;return ht?new m.$oN(new m.$pN(ht.name,o.URI.revive(ht.uri),ht.id,(0,T.$db)(()=>Ge(ht.id)))):ze===P.$Zs.uriList&&xe.uriListData?new m.$nN(Ae(xe.uriListData)):new m.$nN(xe.asString)}ye.to=Oe;async function $e(ze,xe){const Ge=await xe.asString();if(ze===P.$Zs.uriList)return{asString:Ge,fileData:void 0,uriListData:Q(Ge)};const ht=xe.asFile();return{asString:Ge,fileData:ht?{name:ht.name,uri:ht.uri,id:ht._itemId??ht.id}:void 0}}ye.from=$e;function Q(ze){return I.$at.split(ze).map(xe=>{if(xe.startsWith("#"))return xe;try{return o.URI.parse(xe)}catch{}return xe})}function Ae(ze){return I.$at.create(ze.map(xe=>typeof xe=="string"?xe:o.URI.revive(xe)))}})(Ft||(e.DataTransferItem=Ft={}));var Ot;(function(ye){function Oe(Q,Ae){const ze=Q.items.map(([xe,Ge])=>[xe,Ft.to(xe,Ge,Ae)]);return new m.$qN(ze)}ye.toDataTransfer=Oe;async function $e(Q){const Ae={items:[]},ze=[];for(const[xe,Ge]of Q)ze.push((async()=>{Ae.items.push([xe,await Ft.from(xe,Ge)])})());return await Promise.all(ze),Ae}ye.from=$e})(Ot||(e.DataTransfer=Ot={}));var Gt;(function(ye){function Oe(Q,Ae){return{kind:"reply",agentId:Q.participant??Ae?.agentId??"",subCommand:Q.command??Ae?.command,message:Q.prompt,title:Q.label}}ye.from=Oe;function $e(Q){return{prompt:Q.message,label:Q.title,participant:Q.agentId,command:Q.subCommand}}ye.to=$e})(Gt||(e.ChatFollowup=Gt={}));var li;(function(ye){function Oe(Q){switch(Q.role){case C.ChatMessageRole.System:return new m.$IO(m.LanguageModelChatMessageRole.System,Q.content);case C.ChatMessageRole.User:return new m.$IO(m.LanguageModelChatMessageRole.User,Q.content);case C.ChatMessageRole.Assistant:return new m.$IO(m.LanguageModelChatMessageRole.Assistant,Q.content)}}ye.to=Oe;function $e(Q){switch(Q.role){case m.LanguageModelChatMessageRole.System:return{role:C.ChatMessageRole.System,content:Q.content};case m.LanguageModelChatMessageRole.User:return{role:C.ChatMessageRole.User,content:Q.content};case m.LanguageModelChatMessageRole.Assistant:return{role:C.ChatMessageRole.Assistant,content:Q.content}}}ye.from=$e})(li||(e.LanguageModelChatMessage=li={}));var ri;(function(ye){function Oe(Q){return{kind:"markdownContent",content:fe.from(Q.value)}}ye.from=Oe;function $e(Q){return new m.$uO(fe.to(Q.content))}ye.to=$e})(ri||(e.ChatResponseMarkdownPart=ri={}));var oi;(function(ye){function Oe(Q){return{kind:"markdownVuln",content:fe.from(Q.value),vulnerabilities:Q.vulnerabilities}}ye.from=Oe;function $e(Q){return new m.$vO(fe.to(Q.content),Q.vulnerabilities)}ye.to=$e})(oi||(e.ChatResponseMarkdownWithVulnerabilitiesPart=oi={}));var Vt;(function(ye){function Oe(Q){return{kind:"agentDetection",agentId:Q.participant,command:Q.command}}ye.from=Oe;function $e(Q){return new m.$wO(Q.agentId,Q.command)}ye.to=$e})(Vt||(e.ChatResponseDetectedParticipantPart=Vt={}));var zt;(function(ye){function Oe($e){return{kind:"confirmation",title:$e.title,message:$e.message,data:$e.data}}ye.from=Oe})(zt||(e.ChatResponseConfirmationPart=zt={}));var ai;(function(ye){function Oe(Q){const{value:Ae,baseUri:ze}=Q;function xe(Ge,ht){return Ge.map(It=>{const Zt=o.URI.joinPath(ht,It.name);return{label:It.name,uri:Zt,children:It.children&&xe(It.children,Zt)}})}return{kind:"treeData",treeData:{label:(0,k.$$g)(ze),uri:ze,children:xe(Ae,ze)}}}ye.from=Oe;function $e(Q){const Ae=(0,a.$0h)(Q.treeData);function ze(ht){return ht.map(It=>({name:It.label,children:It.children&&ze(It.children)}))}const xe=Ae.uri,Ge=Ae.children?ze(Ae.children):[];return new m.$yO(Ge,xe)}ye.to=$e})(ai||(e.ChatResponseFilesPart=ai={}));var Pt;(function(ye){function Oe(Q){const Ae=ze=>o.URI.isUri(ze);return{kind:"inlineReference",name:Q.title,inlineReference:Ae(Q.value)?Q.value:X.from(Q.value)}}ye.from=Oe;function $e(Q){const Ae=(0,a.$0h)(Q);return new m.$zO(o.URI.isUri(Ae.inlineReference)?Ae.inlineReference:X.to(Ae.inlineReference),Q.name)}ye.to=$e})(Pt||(e.ChatResponseAnchorPart=Pt={}));var Et;(function(ye){function Oe(Q){return{kind:"progressMessage",content:fe.from(Q.value)}}ye.from=Oe;function $e(Q){return new m.$AO(Q.content.value)}ye.to=$e})(Et||(e.ChatResponseProgressPart=Et={}));var yt;(function(ye){function Oe(Q){return{kind:"warning",content:fe.from(Q.value)}}ye.from=Oe;function $e(Q){return new m.$CO(Q.content.value)}ye.to=$e})(yt||(e.ChatResponseWarningPart=yt={}));var Kt;(function(ye){function Oe($e){return{kind:"progressTask",content:fe.from($e.value)}}ye.from=Oe})(Kt||(e.ChatTask=Kt={}));var Dt;(function(ye){function Oe($e){return{kind:"progressTaskResult",content:typeof $e=="string"?fe.from($e):void 0}}ye.from=Oe})(Dt||(e.ChatTaskResult=Dt={}));var Bt;(function(ye){function Oe(Q,Ae,ze){return{kind:"command",command:Ae.toInternal(Q.value,ze)??{command:Q.value.command,title:Q.value.title}}}ye.from=Oe;function $e(Q,Ae){return new m.$DO(Ae.fromInternal(Q.command)??{command:Q.command.id,title:Q.command.title})}ye.to=$e})(Bt||(e.ChatResponseCommandButtonPart=Bt={}));var Ht;(function(ye){function Oe(Q){return{kind:"textEdit",uri:Q.uri,edits:Q.edits.map(Ae=>le.from(Ae))}}ye.from=Oe;function $e(Q){return new m.$FO(o.URI.revive(Q.uri),Q.edits.map(Ae=>le.to(Ae)))}ye.to=$e})(Ht||(e.ChatResponseTextEditPart=Ht={}));var Ei;(function(ye){function Oe(Q){const Ae=h.ThemeIcon.isThemeIcon(Q.iconPath)?Q.iconPath:o.URI.isUri(Q.iconPath)?{light:o.URI.revive(Q.iconPath)}:Q.iconPath&&"light"in Q.iconPath&&"dark"in Q.iconPath&&o.URI.isUri(Q.iconPath.light)&&o.URI.isUri(Q.iconPath.dark)?{light:o.URI.revive(Q.iconPath.light),dark:o.URI.revive(Q.iconPath.dark)}:void 0;return"variableName"in Q.value?{kind:"reference",reference:{variableName:Q.value.variableName,value:o.URI.isUri(Q.value.value)||!Q.value.value?Q.value.value:X.from(Q.value.value)},iconPath:Ae}:{kind:"reference",reference:o.URI.isUri(Q.value)?Q.value:X.from(Q.value),iconPath:Ae}}ye.from=Oe;function $e(Q){const Ae=(0,a.$0h)(Q),ze=xe=>o.URI.isUri(xe)?xe:X.to(xe);return new m.$EO("variableName"in Ae.reference?{variableName:Ae.reference.variableName,value:Ae.reference.value&&ze(Ae.reference.value)}:ze(Ae.reference))}ye.to=$e})(Ei||(e.ChatResponseReferencePart=Ei={}));var gi;(function(ye){function Oe(Ae,ze,xe){return Ae instanceof m.$uO?ri.from(Ae):Ae instanceof m.$zO?Pt.from(Ae):Ae instanceof m.$EO?Ei.from(Ae):Ae instanceof m.$AO?Et.from(Ae):Ae instanceof m.$yO?ai.from(Ae):Ae instanceof m.$DO?Bt.from(Ae,ze,xe):Ae instanceof m.$FO?Ht.from(Ae):Ae instanceof m.$vO?oi.from(Ae):Ae instanceof m.$wO?Vt.from(Ae):Ae instanceof m.$CO?yt.from(Ae):{kind:"markdownContent",content:fe.from("")}}ye.from=Oe;function $e(Ae,ze){switch(Ae.kind){case"reference":return Ei.to(Ae);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return Q(Ae,ze)}}ye.to=$e;function Q(Ae,ze){switch(Ae.kind){case"markdownContent":return ri.to(Ae);case"inlineReference":return Pt.to(Ae);case"progressMessage":return;case"treeData":return ai.to(Ae);case"command":return Bt.to(Ae,ze)}}ye.toContent=Q})(gi||(e.ChatResponsePart=gi={}));var mi;(function(ye){function Oe($e){return{prompt:$e.message,command:$e.command,attempt:$e.attempt??0,enableCommandDetection:$e.enableCommandDetection??!0,references:$e.variables.variables.map(wi.to),location:Nt.to($e.location),acceptedConfirmationData:$e.acceptedConfirmationData,rejectedConfirmationData:$e.rejectedConfirmationData}}ye.to=Oe})(mi||(e.ChatAgentRequest=mi={}));var Nt;(function(ye){function Oe(Q){switch(Q){case p.ChatAgentLocation.Notebook:return m.ChatLocation.Notebook;case p.ChatAgentLocation.Terminal:return m.ChatLocation.Terminal;case p.ChatAgentLocation.Panel:return m.ChatLocation.Panel;case p.ChatAgentLocation.Editor:return m.ChatLocation.Editor}}ye.to=Oe;function $e(Q){switch(Q){case m.ChatLocation.Notebook:return p.ChatAgentLocation.Notebook;case m.ChatLocation.Terminal:return p.ChatAgentLocation.Terminal;case m.ChatLocation.Panel:return p.ChatAgentLocation.Panel;case m.ChatLocation.Editor:return p.ChatAgentLocation.Editor}}ye.from=$e})(Nt||(e.ChatLocation=Nt={}));var wi;(function(ye){function Oe($e){const Q=$e.value;if(!Q)throw new Error("Invalid value reference");return{id:$e.id,name:$e.name,range:$e.range&&[$e.range.start,$e.range.endExclusive],value:(0,o.$vc)(Q)?o.URI.revive(Q):Q&&typeof Q=="object"&&"uri"in Q&&"range"in Q&&(0,o.$vc)(Q.uri)?X.to((0,a.$0h)(Q)):Q,modelDescription:$e.modelDescription}}ye.to=Oe})(wi||(e.ChatAgentValueReference=wi={}));var Ri;(function(ye){function Oe($e,Q,Ae){return{id:$e.id,label:$e.label,fullName:$e.fullName,icon:$e.icon?.id,value:$e.values[0].value,insertText:$e.insertText,detail:$e.detail,documentation:$e.documentation,command:Q.toInternal($e.command,Ae)}}ye.from=Oe})(Ri||(e.ChatAgentCompletionItem=Ri={}));var Rt;(function(ye){function Oe($e){return{errorDetails:$e.errorDetails,metadata:$e.metadata}}ye.to=Oe})(Rt||(e.ChatAgentResult=Rt={}));var Ai;(function(ye){function Oe($e,Q,Ae){if(Q.action.kind==="vote")return;const ze=Rt.to($e);if(Q.action.kind==="command"){const xe=Q.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Ae.fromInternal(xe)??{command:xe.id,title:xe.title}}},result:ze}}else return Q.action.kind==="followUp"?{action:{kind:"followUp",followup:Gt.to(Q.action.followup)},result:ze}:Q.action.kind==="inlineChat"?{action:{kind:"editor",accepted:Q.action.action==="accepted"},result:ze}:{action:Q.action,result:ze}}ye.to=Oe})(Ai||(e.ChatAgentUserActionEvent=Ai={}));var Si;(function(ye){function Oe($e,Q,Ae){return"terminalCommand"in $e?{terminalCommand:$e.terminalCommand,shouldExecute:$e.shouldExecute}:"uri"in $e?{uri:$e.uri}:Q.toInternal($e,Ae)}ye.from=Oe})(Si||(e.TerminalQuickFix=Si={}));var pi;(function(ye){function Oe($e){return{kind:ki.to($e.kind)}}ye.to=Oe})(pi||(e.PartialAcceptInfo=pi={}));var ki;(function(ye){function Oe($e){switch($e){case s.PartialAcceptTriggerKind.Word:return m.PartialAcceptTriggerKind.Word;case s.PartialAcceptTriggerKind.Line:return m.PartialAcceptTriggerKind.Line;case s.PartialAcceptTriggerKind.Suggest:return m.PartialAcceptTriggerKind.Suggest;default:return m.PartialAcceptTriggerKind.Unknown}}ye.to=Oe})(ki||(e.PartialAcceptTriggerKind=ki={}));var ui;(function(ye){function Oe($e,Q){return{id:Q,label:$e.label,description:$e.description,canEdit:$e.canEdit,collapsibleState:$e.collapsibleState||S.DebugTreeItemCollapsibleState.None,contextValue:$e.contextValue}}ye.from=Oe})(ui||(e.DebugTreeItem=ui={}))}),define(Ce[273],Ie([1,0,5,17,10,38]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;let A=class{constructor($,a){this.a=$.getProxy(b.$vM.MainThreadBulkEdits),this.b={getTextDocumentVersion:P=>a.getDocument(P)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit($,a,P){const y=new T.$Lw(I.WorkspaceEdit.from($,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,P?.isRefactoring??!1)}};e.$5mc=A,e.$5mc=A=Je([qe(0,D.$ZO)],A)}),define(Ce[274],Ie([1,0,18,11,49,4,40,6,69,15,2,19,5,10,7,234,25]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6mc=void 0;class c{constructor(n,i,g,d,l){this.j=n,this.k=i,this.l=g,this.m=d,this.n=l,this.b=$.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(d){if(n.c){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,d),l}};const n=this;this.b.reset();const g=(d,l)=>{if(typeof this.d>"u"&&"content"in d&&(this.d=this.b.elapsed()),l){const p=this.l.$handleProgressChunk(this.k.requestId,d),C={report:S=>{p?.then(v=>{v&&(h.$ZM.isMarkdownString(S.value)?this.l.$handleProgressChunk(this.k.requestId,k.ChatResponseWarningPart.from(S),v):this.l.$handleProgressChunk(this.k.requestId,k.ChatResponseReferencePart.from(S),v))})}};Promise.all([p,l?.(C)]).then(([S,v])=>{S!==void 0&&v!==void 0&&this.l.$handleProgressChunk(this.k.requestId,k.ChatTaskResult.from(v),S)})}else this.l.$handleProgressChunk(this.k.requestId,d)};this.g={markdown(d){i(this.markdown);const l=new h.$uO(d),p=k.ChatResponseMarkdownPart.from(l);return g(p),this},markdownWithVulnerabilities(d,l){i(this.markdown),l&&(0,o.$VG)(n.j,"chatParticipantAdditions");const p=new h.$vO(d,l),C=k.ChatResponseMarkdownWithVulnerabilitiesPart.from(p);return g(C),this},filetree(d,l){i(this.filetree);const p=new h.$yO(d,l),C=k.ChatResponseFilesPart.from(p);return g(C),this},anchor(d,l){i(this.anchor);const p=new h.$zO(d,l),C=k.ChatResponseAnchorPart.from(p);return g(C),this},button(d){i(this.anchor);const l=new h.$DO(d),p=k.ChatResponseCommandButtonPart.from(l,n.m,n.n);return g(p),this},progress(d,l){i(this.progress);const p=new h.$BO(d,l),C=l?k.ChatTask.from(p):k.ChatResponseProgressPart.from(p);return g(C,l),this},warning(d){i(this.progress),(0,o.$VG)(n.j,"chatParticipantAdditions");const l=new h.$CO(d),p=k.ChatResponseWarningPart.from(l);return g(p),this},reference(d,l){if(i(this.reference),"variableName"in d&&(0,o.$VG)(n.j,"chatParticipantAdditions"),"variableName"in d&&!d.value){const p=n.k.variables.variables.find(C=>C.name===d.variableName);if(p){let C;if(p.references?.length)C=p.references.map(S=>({kind:"reference",reference:{variableName:d.variableName,value:S.reference}}));else{const S=new h.$EO(d,l);C=[k.ChatResponseReferencePart.from(S)]}return C.forEach(S=>g(S)),this}}else{const p=new h.$EO(d,l),C=k.ChatResponseReferencePart.from(p);g(C)}return this},textEdit(d,l){i(this.textEdit),(0,o.$VG)(n.j,"chatParticipantAdditions");const p=new h.$FO(d,l),C=k.ChatResponseTextEditPart.from(p);return g(C),this},detectedParticipant(d,l){i(this.detectedParticipant),(0,o.$VG)(n.j,"chatParticipantAdditions");const p=new h.$wO(d,l),C=k.ChatResponseDetectedParticipantPart.from(p);return g(C),this},confirmation(d,l,p){i(this.confirmation),(0,o.$VG)(n.j,"chatParticipantAdditions");const C=new h.$xO(d,l,p),S=k.ChatResponseConfirmationPart.from(C);return g(S),this},push(d){if(i(this.push),(d instanceof h.$FO||d instanceof h.$vO||d instanceof h.$wO||d instanceof h.$CO||d instanceof h.$xO)&&(0,o.$VG)(n.j,"chatParticipantAdditions"),d instanceof h.$EO)this.reference(d.value,d.iconPath);else{const l=k.ChatResponsePart.from(d,n.m,n.n);g(l)}return this}}}return this.g}}class f extends M.$Uc{constructor(n,i,g,d){super(),this.n=i,this.s=g,this.t=d,this.c=new Map,this.j=this.B(new M.$4c),this.m=this.B(new M.$4c),this.g=n.getProxy(u.$vM.MainThreadChatAgents2)}transferActiveChat(n){this.g.$transferActiveChatSession(n)}createChatAgent(n,i,g){const d=f.b++,l=new t(n,this.t,i,this.g,d,g);return this.c.set(d,l),l.isAgentEnabled()&&this.g.$registerAgent(d,n.identifier,i,{},void 0),l.apiAgent}createDynamicChatAgent(n,i,g,d){const l=f.b++,p=new t(n,this.t,i,this.g,l,d);return this.c.set(l,p),this.g.$registerAgent(l,n.identifier,i,{isSticky:!0},g),p.apiAgent}async $invokeAgent(n,i,g,d){const l=this.c.get(n);if(!l)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let p=this.j.get(i.sessionId);p||(p=new M.$Tc,this.j.set(i.sessionId,p));const C=new c(l.extension,i,this.g,this.s.converter,p);try{const S=await this.u(i.agentId,g),v=l.invoke(k.ChatAgentRequest.to(i),{history:S},C.apiObject,d);return await(0,D.$oh)(Promise.resolve(v).then(E=>{if(E?.metadata)try{JSON.stringify(E.metadata)}catch(w){const m=`result.metadata MUST be JSON.stringify-able. Got error: ${w.message}`;return this.n.error(`[${l.extension.identifier.value}] [@${l.id}] ${m}`,l.extension),{errorDetails:{message:m},timings:C.timings}}let R;return E?.errorDetails&&(R={...E.errorDetails,responseIsIncomplete:!0}),R?.responseIsRedacted&&(0,o.$VG)(l.extension,"chatParticipantPrivate"),{errorDetails:R,timings:C.timings,metadata:E?.metadata}}),d)}catch(S){return this.n.error(S,l.extension),S instanceof h.$MO&&S.cause&&(S=S.cause),{errorDetails:{message:(0,I.$lj)(S),responseIsIncomplete:!0}}}finally{C.close()}}async u(n,i){const g=[];for(const d of i.history){const l=k.ChatAgentResult.to(d.result),p=n===d.request.agentId?l:{...l,metadata:void 0};g.push(new h.$GO(d.request.message,d.request.command,d.request.variables.variables.map(k.ChatAgentValueReference.to),d.request.agentId));const C=(0,b.$Hb)(d.response.map(S=>k.ChatResponsePart.toContent(S,this.s.converter)));g.push(new h.$HO(C,p,d.request.agentId,d.request.command))}return g}$releaseSession(n){this.j.deleteAndDispose(n)}async $provideFollowups(n,i,g,d,l){const p=this.c.get(i);if(!p)return Promise.resolve([]);const C=await this.u(p.id,d),S=k.ChatAgentResult.to(g);return(await p.provideFollowups(S,{history:C},l)).filter(v=>{const E=!v.participant||A.Iterable.some(this.c.values(),R=>R.id===v.participant&&y.$Xm.equals(R.extension.identifier,p.extension.identifier));return E||this.n.warn(`[@${p.id}] ChatFollowup refers to an unknown participant: ${v.participant}`),E}).map(v=>k.ChatFollowup.from(v,n))}$acceptFeedback(n,i,g,d){const l=this.c.get(n);if(!l)return;const p=k.ChatAgentResult.to(i);let C;switch(g){case r.ChatAgentVoteDirection.Down:C=h.ChatResultFeedbackKind.Unhelpful;break;case r.ChatAgentVoteDirection.Up:C=h.ChatResultFeedbackKind.Helpful;break}l.acceptFeedback(Object.freeze(d?{result:p,kind:C,reportIssue:d}:{result:p,kind:C}))}$acceptAction(n,i,g){const d=this.c.get(n);if(!d||g.action.kind==="vote")return;const l=k.ChatAgentUserActionEvent.to(i,g,this.s.converter);l&&d.acceptAction(Object.freeze(l))}async $invokeCompletionProvider(n,i,g){const d=this.c.get(n);if(!d)return[];let l=this.m.get(n);return l?l.clear():(l=new M.$Tc,this.m.set(n,l)),(await d.invokeCompletionProvider(i,g)).map(C=>k.ChatAgentCompletionItem.from(C,this.s.converter,l))}async $provideWelcomeMessage(n,i,g){const d=this.c.get(n);if(d)return await d.provideWelcomeMessage(k.ChatLocation.to(i),g)}async $provideSampleQuestions(n,i,g){const d=this.c.get(n);if(d)return(await d.provideSampleQuestions(k.ChatLocation.to(i),g)).map(l=>k.ChatFollowup.from(l,void 0))}}e.$6mc=f,f.b=0;class t{constructor(n,i,g,d,l,p){this.extension=n,this.w=i,this.id=g,this.x=d,this.y=l,this.z=p,this.m=new T.$he,this.n=new T.$he}acceptFeedback(n){this.m.fire(n)}acceptAction(n){this.n.fire(n)}async invokeCompletionProvider(n,i){return this.q?await this.q.provider.provideCompletionItems(n,i)??[]:[]}isAgentEnabled(){return!(this.w==="stable"&&!(0,o.$UG)(this.extension,"chatParticipantPrivate"))}async provideFollowups(n,i,g){if(!this.b)return[];const d=await this.b.provideFollowups(n,i,g);return d?d.filter(l=>!(l&&"commandId"in l)).filter(l=>!(l&&"message"in l)):[]}async provideWelcomeMessage(n,i){if(!this.s)return[];const g=await this.s.provideWelcomeMessage(n,i);return g?g.map(d=>typeof d=="string"?d:k.MarkdownString.from(d)):[]}async provideSampleQuestions(n,i){if(!this.s||!this.s.provideSampleQuestions)return[];const g=await this.s.provideSampleQuestions(n,i);return g||[]}get apiAgent(){let n=!1,i=!1;const g=()=>{n||i||(i=!0,queueMicrotask(()=>{d.isAgentEnabled()&&(this.x.$updateAgent(this.y,{icon:this.c?this.c instanceof P.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof h.$uN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:k.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:k.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:k.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),i=!1)}))},d=this;return{get id(){return d.id},get iconPath(){return d.c},set iconPath(l){d.c=l,g()},get requestHandler(){return d.z},set requestHandler(l){(0,a.$kg)(typeof l=="function","Invalid request handler"),d.z=l},get followupProvider(){return d.b},set followupProvider(l){d.b=l,g()},get isDefault(){return(0,o.$VG)(d.extension,"defaultChatParticipant"),d.d},set isDefault(l){(0,o.$VG)(d.extension,"defaultChatParticipant"),d.d=l,g()},get helpTextPrefix(){return(0,o.$VG)(d.extension,"defaultChatParticipant"),d.g},set helpTextPrefix(l){(0,o.$VG)(d.extension,"defaultChatParticipant"),d.g=l,g()},get helpTextVariablesPrefix(){return(0,o.$VG)(d.extension,"defaultChatParticipant"),d.j},set helpTextVariablesPrefix(l){(0,o.$VG)(d.extension,"defaultChatParticipant"),d.j=l,g()},get helpTextPostfix(){return(0,o.$VG)(d.extension,"defaultChatParticipant"),d.k},set helpTextPostfix(l){(0,o.$VG)(d.extension,"defaultChatParticipant"),d.k=l,g()},get isSecondary(){return(0,o.$VG)(d.extension,"defaultChatParticipant"),d.l},set isSecondary(l){(0,o.$VG)(d.extension,"defaultChatParticipant"),d.l=l,g()},get supportIssueReporting(){return(0,o.$VG)(d.extension,"chatParticipantPrivate"),d.o},set supportIssueReporting(l){(0,o.$VG)(d.extension,"chatParticipantPrivate"),d.o=l,g()},get onDidReceiveFeedback(){return d.m.event},set participantVariableProvider(l){if((0,o.$VG)(d.extension,"chatParticipantAdditions"),d.q=l,l){if(!l.triggerCharacters.length)throw new Error("triggerCharacters are required");d.x.$registerAgentCompletionsProvider(d.y,d.id,l.triggerCharacters)}else d.x.$unregisterAgentCompletionsProvider(d.y,d.id)},get participantVariableProvider(){return(0,o.$VG)(d.extension,"chatParticipantAdditions"),d.q},set welcomeMessageProvider(l){(0,o.$VG)(d.extension,"defaultChatParticipant"),d.s=l,g()},get welcomeMessageProvider(){return(0,o.$VG)(d.extension,"defaultChatParticipant"),d.s},onDidPerformAction:(0,o.$UG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(l){d.t=l,g()},get requester(){return d.t},set supportsSlowReferences(l){(0,o.$VG)(d.extension,"chatParticipantPrivate"),d.u=l,g()},get supportsSlowReferences(){return(0,o.$VG)(d.extension,"chatParticipantPrivate"),d.u},dispose(){n=!0,d.b=void 0,d.m.dispose(),d.x.$unregisterAgent(d.y)}}}invoke(n,i,g,d){return this.z(n,i,g,d)}}}),define(Ce[275],Ie([1,0,14,6,34,5,10,7,25]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=void 0;class a{constructor(u){this.b=new Map,this.c=u.getProxy(T.$vM.MainThreadChatVariables)}async $resolveVariable(u,k,h,r){const o=this.b.get(u);if(o)try{if(o.resolver.resolve2){(0,$.$VG)(o.extension,"chatParticipantAdditions");const c=new P(k,this.c),f=await o.resolver.resolve2(o.data.name,{prompt:h},c.apiObject,r);if(f&&f[0])return f[0].value}else{const c=await o.resolver.resolve(o.data.name,{prompt:h},r);if(c&&c[0])return c[0].value}}catch(c){(0,b.$2)(c)}}registerVariableResolver(u,k,h,r,o,c,f,t,s){const n=a.a++,i=s?I.ThemeIcon.fromId(s):void 0;return this.b.set(n,{extension:u,data:{id:k,name:h,description:r,modelDescription:o,icon:i},resolver:f}),this.c.$registerVariable(n,{id:k,name:h,description:r,modelDescription:o,isSlow:c,fullName:t,icon:i}),(0,D.$Sc)(()=>{this.b.delete(n),this.c.$unregisterVariable(n)})}attachContext(u,k,h){this.c.$attachContext(u,M.$JM.isLocation(k)?A.Location.from(k):k,A.ChatLocation.from(h))}}e.$7mc=a,a.a=0;class P{constructor(u,k){this.c=u,this.d=k,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let k=function(r){if(u.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,r),o}};const u=this,h=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){k(this.progress);const o=new M.$AO(r),c=A.ChatResponseProgressPart.from(o);return h(c),this},reference(r){k(this.reference);const o=new M.$EO(r),c=A.ChatResponseReferencePart.from(o);return h(c),this},push(r){return k(this.push),r instanceof M.$EO?h(A.ChatResponseReferencePart.from(r)):r instanceof M.$AO&&h(A.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Ce[276],Ie([1,0,11,72,4,6,36,2,94,19,10,7,5,25]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$mc=h;function h(r,o,c){const f=r.getProxy(u.$vM.MainThreadComments);class t{constructor(){this.b=new Map,this.c=new a.$Zm,o.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===A.MarshalledId.CommentController){const E=this.b.get(v.handle);return E?E.value:v}else if(v&&v.$mid===A.MarshalledId.CommentThread){const E=v,R=this.b.get(E.commentControlHandle);if(!R)return E;const w=R.getCommentThread(E.commentThreadHandle);return w?w.value:E}else if(v&&(v.$mid===A.MarshalledId.CommentThreadReply||v.$mid===A.MarshalledId.CommentThreadInstance)){const E=this.b.get(v.thread.commentControlHandle);if(!E)return v;const R=E.getCommentThread(v.thread.commentThreadHandle);return R?v.$mid===A.MarshalledId.CommentThreadInstance?R.value:{thread:R.value,text:v.text}:v}else if(v&&v.$mid===A.MarshalledId.CommentNode){const E=this.b.get(v.thread.commentControlHandle);if(!E)return v;const R=E.getCommentThread(v.thread.commentThreadHandle);if(!R)return v;const w=v.commentUniqueId,m=R.getCommentByUniqueId(w);return m||v}else if(v&&v.$mid===A.MarshalledId.CommentThreadNode){const E=this.b.get(v.thread.commentControlHandle);if(!E)return v;const R=E.getCommentThread(v.thread.commentThreadHandle);if(!R)return v;const w=v.text,m=v.commentUniqueId,N=R.getCommentByUniqueId(m);return N?(typeof N.body=="string"?N.body=w:N.body=new y.$ZM(w),N):v}return v}})}createCommentController(v,E,R){const w=t.a++,m=new n(v,w,E,R);this.b.set(m.handle,m);const N=this.c.get(v.identifier)||[];return N.push(m),this.c.set(v.identifier,N),m.value}async $createCommentThreadTemplate(v,E,R,w){const m=this.b.get(v);m&&m.$createCommentThreadTemplate(E,R,w)}async $setActiveComment(v,E){const R=this.b.get(v);R&&R.$setActiveComment(E??void 0)}async $updateCommentThreadTemplate(v,E,R){const w=this.b.get(v);w&&w.$updateCommentThreadTemplate(E,R)}$deleteCommentThread(v,E){this.b.get(v)?.$deleteCommentThread(E)}async $provideCommentingRanges(v,E,R){const w=this.b.get(v);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const m=await c.ensureDocumentData(M.URI.revive(E));return(0,b.$sh)(async()=>{const N=await w.commentingRangeProvider.provideCommentingRanges(m.document,R);let B;return Array.isArray(N)?B={ranges:N,fileComments:!1}:N?B={ranges:N.ranges||[],fileComments:N.fileComments||!1}:B=N??void 0,B}).then(N=>{let B;return N&&(B={ranges:N.ranges.map(X=>P.Range.from(X)),fileComments:N.fileComments}),B})}$toggleReaction(v,E,R,w,m){const N=this.b.get(v);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,b.$sh)(()=>{const B=N.getCommentThread(E);if(B){const X=B.getCommentByUniqueId(w.uniqueIdInThread);if(N!==void 0&&X&&N.reactionHandler)return N.reactionHandler(X,d(m))}return Promise.resolve(void 0)})}}t.a=0;class s{set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,typeof v=="object"?((0,k.$VG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=v.resolved,this.b.applicability=v.applicability):this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,E,R,w,m,N,B,X,V){this.m=E,this.n=R,this.o=w,this.p=m,this.q=N,this.extensionDescription=B,this.r=X,this.handle=s.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$he,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Vc,this.l.value=new T.$Tc,this.n===void 0&&(this.n=`${v}.${this.handle}`),f.$createCommentThread(E,this.handle,this.n,this.o,P.Range.from(this.p),B.identifier,this.r,V),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this.i.push({dispose:()=>{f.$deleteCommentThread(E,this.handle)}});const O=this;this.value={get uri(){return O.uri},get range(){return O.range},set range(L){O.range=L},get comments(){return O.comments},set comments(L){O.comments=L},get collapsibleState(){return O.collapsibleState},set collapsibleState(L){O.collapsibleState=L},get canReply(){return O.canReply},set canReply(L){O.canReply=L},get contextValue(){return O.contextValue},set contextValue(L){O.contextValue=L},get label(){return O.label},set label(L){O.label=L},get state(){return O.state},set state(L){O.state=L},dispose:()=>{O.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Tc);const v=R=>Object.prototype.hasOwnProperty.call(this.b,R),E={};v("range")&&(E.range=P.Range.from(this.p)),v("label")&&(E.label=this.label),v("contextValue")&&(E.contextValue=this.contextValue??null),v("comments")&&(E.comments=this.q.map(R=>i(this,R,this.k,this.extensionDescription))),v("collapsibleState")&&(E.collapseState=l(this.g)),v("canReply")&&(E.canReply=this.canReply),v("state")&&(E.state=p(this.h)),v("applicability")&&(E.applicability=C(this.h)),v("isTemplate")&&(E.isTemplate=this.r),this.b={},f.$updateCommentThread(this.m,this.handle,this.n,this.o,E)}getCommentByUniqueId(v){for(const E of this.k){const R=E[0],w=E[1];if(v===w)return R}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}s.a=0,Je([(0,D.$6h)(100)],s.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,v?.resourceHints&&(0,k.$VG)(this.h,"commentingRangeHint"),f.$updateCommentingRanges(this.handle,v?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,f.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,f.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,k.$VG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,k.$VG)(this.h,"activeComment"),this.f}constructor(v,E,R,w){this.h=v,this.i=E,this.j=R,this.k=w,this.a=new Map,f.$registerCommentController(this.handle,R,w,this.h.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(N){m.options=N},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(N){m.commentingRangeProvider=N},get reactionHandler(){return m.reactionHandler},set reactionHandler(N){m.reactionHandler=N},get activeCommentThread(){return m.activeCommentThread},createCommentThread(N,B,X){return m.createCommentThread(N,B,X).value},dispose:()=>{m.dispose()}}),this.g=[],this.g.push({dispose:()=>{f.$unregisterCommentController(this.handle)}})}createCommentThread(v,E,R){E===void 0&&(0,k.$VG)(this.h,"fileComments");const w=new s(this.id,this.handle,void 0,v,E,R,this.h,!1);return this.a.set(w.handle,w),w}$setActiveComment(v){if(!v){this.e=void 0,this.f=void 0;return}const E=this.a.get(v.commentThreadHandle);E&&(this.e=v.uniqueIdInThread?E.getCommentByUniqueId(v.uniqueIdInThread):void 0,this.f=E)}$createCommentThreadTemplate(v,E,R){const w=new s(this.id,this.handle,void 0,M.URI.revive(v),P.Range.to(E),[],this.h,!0,R);return w.collapsibleState=$.CommentThreadCollapsibleState.Expanded,this.a.set(w.handle,w),w}$updateCommentThreadTemplate(v,E){const R=this.a.get(v);R&&(R.range=P.Range.to(E))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.g.forEach(v=>v.dispose())}}function i(S,v,E,R){let w=E.get(v);return w||(w=++S.commentHandle,E.set(v,w)),v.state!==void 0&&(0,k.$VG)(R,"commentsDraftState"),v.reactions?.some(m=>m.reactors!==void 0)&&(0,k.$VG)(R,"commentReactor"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:w,body:typeof v.body=="string"?v.body:P.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(m=>g(m)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function g(S){return{label:S.label,iconPath:S.iconPath?P.$YO(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted,reactors:S.reactors&&S.reactors.length>0&&typeof S.reactors[0]!="string"?S.reactors.map(v=>v.name):S.reactors}}function d(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?M.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1,reactors:S.reactors?.map(v=>({name:v}))}}function l(S){if(S!==void 0)switch(S){case y.CommentThreadCollapsibleState.Expanded:return $.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return $.CommentThreadCollapsibleState.Collapsed}return $.CommentThreadCollapsibleState.Collapsed}function p(S){let v;if(typeof S=="object"?v=S.resolved:v=S,v!==void 0)switch(v){case y.CommentThreadState.Unresolved:return $.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return $.CommentThreadState.Resolved}return $.CommentThreadState.Unresolved}function C(S){let v;if(typeof S=="object"&&(v=S.applicability),v!==void 0)switch(v){case y.CommentThreadApplicability.Current:return $.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return $.CommentThreadApplicability.Outdated}return $.CommentThreadApplicability.Current}return new t}}),define(Ce[277],Ie([1,0,22,76,6,16,24,2,10,67,80,5,7]),function(_,e,b,D,I,T,A,M,$,a,P,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=void 0;class k{constructor(g,d){this.document=g,this.b=d,this.a=1,this.c=new P.$Qmc("custom documents")}addEdit(g){return this.c.add([g])}async undo(g,d){await this.f(g).undo(),d||this.disposeBackup()}async redo(g,d){await this.f(g).redo(),d||this.disposeBackup()}disposeEdits(g){for(const d of g)this.c.delete(d)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const g=n(this.document.uri)+this.a++;return(0,A.$bh)(this.b,g)}updateBackup(g){this.d?.delete(),this.d=g}disposeBackup(){this.d?.delete(),this.d=void 0}f(g){const d=this.c.get(g,0);if(!d)throw new Error("No edit found");return d}}class h{constructor(){this.a=new Map}get(g,d){return this.a.get(this.b(g,d))}add(g,d,l){const p=this.b(g,d.uri);if(this.a.has(p))throw new Error(`Document already exists for viewType:${g} resource:${d.uri}`);const C=new k(d,l);return this.a.set(p,C),C}delete(g,d){const l=this.b(g,d.uri);this.a.delete(l)}b(g,d){return`${g}@@@${d}`}}var r;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(r||(r={}));class o{constructor(){this.a=new Map}addTextProvider(g,d,l){return this.b(g,{type:r.Text,extension:d,provider:l})}addCustomProvider(g,d,l){return this.b(g,{type:r.Custom,extension:d,provider:l})}get(g){return this.a.get(g)}b(g,d){if(this.a.has(g))throw new Error(`Provider for viewType:${g} already registered`);return this.a.set(g,d),new u.$xM(()=>this.a.delete(g))}}class c{constructor(g,d,l,p,C){this.d=d,this.f=l,this.g=p,this.h=C,this.b=new o,this.c=new h,this.a=g.getProxy(y.$vM.MainThreadCustomEditors)}registerCustomEditorProvider(g,d,l,p){const C=new I.$Tc;return t(l)?(C.add(this.b.addTextProvider(d,g,l)),this.a.$registerTextEditorProvider((0,a.$nnc)(g),d,p.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,a.$lnc)(g))):(C.add(this.b.addCustomProvider(d,g,l)),f(l)&&C.add(l.onDidChangeCustomDocument(S=>{const v=this.i(d,S.document.uri);if(s(S)){const E=v.addEdit(S);this.a.$onDidEdit(S.document.uri,d,E,S.label)}else this.a.$onContentChange(S.document.uri,d)})),this.a.$registerCustomEditorProvider((0,a.$nnc)(g),d,p.webviewOptions||{},!!p.supportsMultipleEditorsPerDocument,(0,a.$lnc)(g))),u.$xM.from(C,new u.$xM(()=>{this.a.$unregisterEditorProvider(d)}))}async $createCustomDocument(g,d,l,p,C){const S=this.b.get(d);if(!S)throw new Error(`No provider found for '${d}'`);if(S.type!==r.Custom)throw new Error(`Invalid provide type for '${d}'`);const v=M.URI.revive(g),E=await S.provider.openCustomDocument(v,{backupId:l,untitledDocumentData:p?.buffer},C);let R;return f(S.provider)&&this.f&&(R=this.f.workspaceValue(S.extension)??this.f.globalValue(S.extension)),this.c.add(d,E,R),{editable:f(S.provider)}}async $disposeCustomDocument(g,d){const l=this.b.get(d);if(!l)throw new Error(`No provider found for '${d}'`);if(l.type!==r.Custom)throw new Error(`Invalid provider type for '${d}'`);const p=M.URI.revive(g),{document:C}=this.i(d,p);this.c.delete(d,C),C.dispose()}async $resolveCustomEditor(g,d,l,p,C,S){const v=this.b.get(l);if(!v)throw new Error(`No provider found for '${l}'`);const E=$.ViewColumn.to(C),R=this.g.createNewWebview(d,p.contentOptions,v.extension),w=this.h.createNewWebviewPanel(d,l,p.title,E,p.options,R,p.active),m=M.URI.revive(g);switch(v.type){case r.Custom:{const{document:N}=this.i(l,m);return v.provider.resolveCustomEditor(N,w,S)}case r.Text:{const N=this.d.getDocument(m);return v.provider.resolveCustomTextEditor(N,w,S)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(g,d,l){this.i(d,g).disposeEdits(l)}async $onMoveCustomEditor(g,d,l){const p=this.b.get(l);if(!p)throw new Error(`No provider found for '${l}'`);if(!p.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const C=this.h.getWebviewPanel(g);if(!C)throw new Error("No webview found");const S=M.URI.revive(d),v=this.d.getDocument(S);await p.provider.moveCustomTextEditor(v,C,b.CancellationToken.None)}async $undo(g,d,l,p){return this.i(d,g).undo(l,p)}async $redo(g,d,l,p){return this.i(d,g).redo(l,p)}async $revert(g,d,l){const p=this.i(d,g);await this.j(d).revertCustomDocument(p.document,l),p.disposeBackup()}async $onSave(g,d,l){const p=this.i(d,g);await this.j(d).saveCustomDocument(p.document,l),p.disposeBackup()}async $onSaveAs(g,d,l,p){const C=this.i(d,g);return this.j(d).saveCustomDocumentAs(C.document,M.URI.revive(l),p)}async $backup(g,d,l){const p=this.i(d,g),S=await this.j(d).backupCustomDocument(p.document,{destination:p.getNewBackupUri()},l);return p.updateBackup(S),S.id}i(g,d){const l=this.c.get(g,M.URI.revive(d));if(!l)throw new Error("No custom document found");return l}j(g){const l=this.b.get(g)?.provider;if(!l||!f(l))throw new Error("Custom document is not editable");return l}}e.$qnc=c;function f(i){return!!i.onDidChangeCustomDocument}function t(i){return typeof i.resolveCustomTextEditor=="function"}function s(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function n(i){const g=i.scheme===T.Schemas.file||i.scheme===T.Schemas.untitled?i.fsPath:i.toString();return(0,D.$oj)(g)+""}});var tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b},Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)};define(Ce[278],Ie([1,0,179,106,2,5,7,10,4,12,29,51]),function(_,e,b,D,I,T,A,M,$,a,P,y){"use strict";var u,k,h,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ymc=e.$Xmc=void 0;class o{constructor(t,s,n,i,g,d,l,p){this.d=t,this.e=s,this.f=n,this.g=i,this.h=g,u.set(this,void 0),k.set(this,void 0),h.set(this,void 0),this.c=!1,this.f=Math.max(i,n),tt(this,h,new P.$Ac(C=>d.getComparisonKey(C)),"f"),tt(this,u,l,"f"),tt(this,k,p,"f")}dispose(){this.c||(Be(this,k,"f").fire([...Be(this,h,"f").keys()]),Be(this,u,"f")?.$clear(this.e),Be(this,h,"f").clear(),this.c=!0)}get name(){return this.j(),this.d}set(t,s){if(!t){this.clear();return}this.j();let n=[];if(I.URI.isUri(t)){if(!s){this.delete(t);return}Be(this,h,"f").set(t,s.slice()),n=[t]}else if(Array.isArray(t)){n=[];let d;t=[...t].sort(o.k);for(const l of t){const[p,C]=l;if((!d||p.toString()!==d.toString())&&(d&&Be(this,h,"f").get(d).length===0&&Be(this,h,"f").delete(d),d=p,n.push(p),Be(this,h,"f").set(p,[])),C)Be(this,h,"f").get(p)?.push(...C);else{const S=Be(this,h,"f").get(p);S&&(S.length=0)}}}if(Be(this,k,"f").fire(n),!Be(this,u,"f"))return;const i=[];let g=0;for(const d of n){let l=[];const p=Be(this,h,"f").get(d);if(p)if(p.length>this.g){l=[];const C=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let S=0;S<4;S++)for(const v of p)if(v.severity===C[S]&&l.push({...M.Diagnostic.from(v),modelVersionId:this.h(d)})===this.g)break e;l.push({severity:D.MarkerSeverity.Info,message:(0,b.localize)(0,null,p.length-this.g),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=p.map(C=>({...M.Diagnostic.from(C),modelVersionId:this.h(d)}));if(i.push([d,l]),g+=l.length,g>this.f)break}Be(this,u,"f").$changeMany(this.e,i)}delete(t){this.j(),Be(this,k,"f").fire([t]),Be(this,h,"f").delete(t),Be(this,u,"f")?.$changeMany(this.e,[[t,void 0]])}clear(){this.j(),Be(this,k,"f").fire([...Be(this,h,"f").keys()]),Be(this,h,"f").clear(),Be(this,u,"f")?.$clear(this.e)}forEach(t,s){this.j();for(const[n,i]of this)t.call(s,n,i,this)}*[(u=new WeakMap,k=new WeakMap,h=new WeakMap,Symbol.iterator)](){this.j();for(const t of Be(this,h,"f").keys())yield[t,this.get(t)]}get(t){this.j();const s=Be(this,h,"f").get(t);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(t){return this.j(),Array.isArray(Be(this,h,"f").get(t))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(t,s){return t[0].toString()<s[0].toString()?-1:t[0].toString()>s[0].toString()?1:0}}e.$Xmc=o;let c=r=class{static _mapper(t){const s=new P.$Ac;for(const n of t)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}constructor(t,s,n,i){this.j=s,this.k=n,this.l=i,this.g=new Map,this.h=new $.$le({merge:g=>g.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,r._mapper),this.f=t.getProxy(T.$vM.MainThreadDiagnostics)}createDiagnosticCollection(t,s){const{g:n,f:i,h:g,j:d,k:l,l:p}=this,C=new class{$changeMany(E,R){i.$changeMany(E,R),d.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,E,R.length===0?"CLEARING":R)}$clear(E){i.$clear(E),d.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,E)}dispose(){i.dispose()}};let S;if(!s)s="_generated_diagnostic_collection_name_#"+r.c++,S=s;else if(!n.has(s))S=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do S=s+r.c++;while(n.has(S))}return new class extends o{constructor(){super(s,S,r.e,r.d,E=>p.getDocument(E)?.version,l.extUri,C,g),n.set(S,this)}dispose(){super.dispose(),n.delete(S)}}}getDiagnostics(t){if(t)return this.m(t);{const s=new Map,n=[];for(const i of this.g.values())i.forEach((g,d)=>{let l=s.get(g.toString());typeof l>"u"&&(l=n.length,s.set(g.toString(),l),n.push([g,[]])),n[l][1]=n[l][1].concat(...d)});return n}}m(t){let s=[];for(const n of this.g.values())n.has(t)&&(s=s.concat(n.get(t)));return s}$acceptMarkersChange(t){if(!this.n){const s="_generated_mirror",n=new o(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(s,n),this.n=n}for(const[s,n]of t)this.n.set(I.URI.revive(s),n.map(M.Diagnostic.to))}};e.$Ymc=c,c.c=0,c.d=1e3,c.e=1.1*r.d,e.$Ymc=c=r=Je([qe(1,a.$7j),qe(2,y.$Wmc)],c)}),define(Ce[279],Ie([1,0,2,14,7,10,211,38]),function(_,e,b,D,I,T,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7nc=void 0;class ${constructor(P,y,u,k={timeout:1500,errors:3}){this.c=P,this.d=y,this.f=u,this.g=k,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(P){return(y,u,k)=>{const r={dispose:this.a.push([y,u,P])};return Array.isArray(k)&&k.push(r),r}}async $participateInSave(P,y){const u=b.URI.revive(P);let k=!1;const h=setTimeout(()=>k=!0,this.g.timeout),r=[];try{for(const o of[...this.a]){if(k)break;const c=this.d.getDocument(u),f=await this.h(o,{document:c,reason:T.TextDocumentSaveReason.to(y)});r.push(f)}}finally{clearTimeout(h)}return r}h([P,y,u],k){const h=this.b.get(P);return typeof h=="number"&&h>this.g.errors?Promise.resolve(!1):this.i(u,P,y,k).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const o=this.b.get(P);this.b.set(P,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${u.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(P,y,u,k){const h=[],r=Date.now(),{document:o,reason:c}=k,{version:f}=o,t=Object.freeze({document:o,reason:c,waitUntil(s){if(Object.isFrozen(h))throw(0,D.$8)("waitUntil can not be called async");h.push(Promise.resolve(s))}});try{y.apply(u,[t])}catch(s){return Promise.reject(s)}return Object.freeze(h),new Promise((s,n)=>{const i=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(h).then(g=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(i),s(g)}).catch(g=>{clearTimeout(i),n(g)})}).then(s=>{const n={edits:[]};for(const i of s)if(Array.isArray(i)&&i.every(g=>g instanceof I.$EM))for(const{newText:g,newEol:d,range:l}of i)n.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:l&&T.Range.from(l),text:g,eol:d&&T.EndOfLine.from(d)}});if(n.edits.length!==0)return f===o.version?this.f.$tryApplyWorkspaceEdit(new M.$Lw(n)):Promise.reject(new Error("concurrent_edits"))})}}e.$7nc=$}),define(Ce[280],Ie([1,0,4,6,2,5,121,10,15,26,7]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=void 0;class y{constructor(k,h){this.a=new b.$he,this.b=new b.$he,this.c=new b.$he,this.d=new b.$he,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new D.$Tc,this.h=new Map,this.f=k.getProxy(T.$vM.MainThreadDocuments),this.g=h,this.g.onDidRemoveDocuments(r=>{for(const o of r)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const o of r)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const h=this.g.getDocument(k);if(h)return h}getDocument(k){const h=this.getDocumentData(k);if(!h?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return h.document}ensureDocumentData(k){const h=this.g.getDocument(k);if(h)return Promise.resolve(h);let r=this.h.get(k.toString());return r||(r=this.f.$tryOpenDocument(k).then(o=>{this.h.delete(k.toString());const c=I.URI.revive(o);return(0,$.$lg)(this.g.getDocument(c))},o=>(this.h.delete(k.toString()),Promise.reject(o))),this.h.set(k.toString(),r)),r}createDocumentData(k){return this.f.$tryCreateDocument(k).then(h=>I.URI.revive(h))}$acceptModelLanguageChanged(k,h){const r=I.URI.revive(k),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(h),this.a.fire(o.document)}$acceptModelSaved(k){const h=I.URI.revive(k),r=this.g.getDocument(h);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(k,h){const r=I.URI.revive(k),o=this.g.getDocument(r);if(!o)throw new Error("unknown document");o._acceptIsDirty(h),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,h,r){const o=I.URI.revive(k),c=this.g.getDocument(o);if(!c)throw new Error("unknown document");c._acceptIsDirty(r),c.onEvents(h);let f;h.isUndoing?f=P.TextDocumentChangeReason.Undo:h.isRedoing&&(f=P.TextDocumentChangeReason.Redo),this.c.fire((0,a.$$n)({document:c.document,contentChanges:h.changes.map(t=>({range:M.Range.to(t.range),rangeOffset:t.rangeOffset,rangeLength:t.rangeLength,text:t.text})),reason:f}))}setWordDefinitionFor(k,h){(0,A.$2O)(k,h)}}e.$Zmc=y}),define(Ce[70],Ie([1,0,281,4,15,2,3,5,17,10,7]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$snc=e.$rnc=void 0,e.$rnc=(0,A.$Ai)("IExtHostEditorTabs");class y{constructor(o,c,f){this.e=f,this.d=c,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,c={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case M.TabInputKind.TextInput:return new P.$iO(T.URI.revive(this.b.input.uri));case M.TabInputKind.TextDiffInput:return new P.$jO(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case M.TabInputKind.TextMergeInput:return new P.$kO(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case M.TabInputKind.CustomEditorInput:return new P.$lO(T.URI.revive(this.b.input.uri),this.b.input.viewType);case M.TabInputKind.WebviewEditorInput:return new P.$mO(this.b.input.viewType);case M.TabInputKind.NotebookInput:return new P.$nO(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case M.TabInputKind.NotebookDiffInput:return new P.$oO(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case M.TabInputKind.TerminalEditorInput:return new P.$pO;case M.TabInputKind.InteractiveEditorInput:return new P.$qO(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));case M.TabInputKind.ChatEditorInput:return new P.$rO;case M.TabInputKind.MultiDiffEditorInput:return new P.$sO(this.b.input.diffEditors.map(o=>new P.$jO(T.URI.revive(o.original),T.URI.revive(o.modified))));default:return}}}class u{constructor(o,c){this.c=[],this.d="",this.b=o,this.e=c;for(const f of o.tabs)f.isActive&&(this.d=f.id),this.c.push(new y(f,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,c={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return a.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(f=>f.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(f=>f.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===M.TabModelOperationKind.TAB_OPEN){const f=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,f),o.tabDto.isActive&&(this.d=f.tabId),f}else if(o.kind===M.TabModelOperationKind.TAB_CLOSE){const f=this.c.splice(o.index,1)[0];if(!f)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return f.tabId===this.d&&(this.d=""),f}else if(o.kind===M.TabModelOperationKind.TAB_MOVE){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const f=this.c.splice(o.oldIndex,1)[0];if(!f)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,f),f}const c=this.c.find(f=>f.tabId===o.tabDto.id);if(!c)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(o.tabDto),c}activeTabId(){return this.d}}let k=class{constructor(o){this.b=new D.$he,this.c=new D.$he,this.e=[],this.a=o.getProxy(M.$vM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,c={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(f=>f.apiObject))},get activeTabGroup(){const f=o.d;return(0,I.$lg)(o.e.find(s=>s.groupId===f)?.apiObject)},close:async(f,t)=>{const s=Array.isArray(f)?f:[f];return s.length?h(s[0])?this.j(s,t):this.i(s,t):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(o){const c=new Set(this.e.map(d=>d.groupId)),f=new Set(o.map(d=>d.groupId)),t=(0,b.$F)(c,f),s=this.e.filter(d=>t.removed.includes(d.groupId)).map(d=>d.apiObject),n=[],i=[];this.e=o.map(d=>{const l=new u(d,()=>this.d);return t.added.includes(l.groupId)?n.push(l.apiObject):i.push(l.apiObject),l});const g=(0,I.$lg)(o.find(d=>d.isActive===!0)?.groupId);g!==void 0&&this.d!==g&&(this.d=g),this.c.fire(Object.freeze({opened:n,closed:s,changed:i}))}$acceptTabGroupUpdate(o){const c=this.e.find(f=>f.groupId===o.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const c=this.e.find(t=>t.groupId===o.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const f=c.acceptTabOperation(o);switch(o.kind){case M.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[f.apiObject],closed:[],changed:[]}));return;case M.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[f.apiObject],changed:[]}));return;case M.TabModelOperationKind.TAB_MOVE:case M.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[f.apiObject]}));return}}g(o){for(const c of this.e)for(const f of c.tabs)if(f.apiObject===o)return f}h(o){return this.e.find(c=>c.apiObject===o)}async i(o,c){const f=[];for(const t of o){const s=this.g(t);if(!s)throw new Error("Tab close: Invalid tab not found!");f.push(s.tabId)}return this.a.$closeTab(f,c)}async j(o,c){const f=[];for(const t of o){const s=this.h(t);if(!s)throw new Error("Group close: Invalid group not found!");f.push(s.groupId)}return this.a.$closeGroup(f,c)}};e.$snc=k,e.$snc=k=Je([qe(0,$.$ZO)],k);function h(r){return r.tabs!==void 0}}),define(Ce[282],Ie([1,0,2,5,30,6,7,10,326,13,28,23,25,59]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=void 0;class h{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const f=this.a.indexOf(c);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),f=[];let t,s,n=$.State.LastKnownState,i=$.State.LastKnownState;for(const g of c){let d=t?(0,a.$Df)(t,g):0;for(d===0?s=$.State.Start:s=i;d<g.length;d++)d+1===g.length?(n=i,i=$.State.BeforeColon):i+=1,f.push([s,g.toUpperCase().charCodeAt(d),i]),f.push([s,g.toLowerCase().charCodeAt(d),i]),s=i;t=g,i=n}f.push([$.State.BeforeColon,P.CharCode.Colon,$.State.AfterColon]),f.push([$.State.AfterColon,P.CharCode.Slash,$.State.End]),this.b=new $.$$2(f)}}provideDocumentLinks(c){this.c();const f=[],t=$.$_2.computeLinks({getLineContent(s){return c.lineAt(s-1).text},getLineCount(){return c.lineCount}},this.b);for(const s of t){const n=M.DocumentLink.to(s);n.target&&f.push(n)}return f}}class r{constructor(c,f){this.i=f,this.b=new h,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(D.$vM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,f,t,s={}){if(r.j(t),this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const n=this.h++;this.b.add(f),this.d.add(f),this.c.set(n,t);let i=I.FileSystemProviderCapabilities.FileReadWrite;s.isCaseSensitive&&(i+=I.FileSystemProviderCapabilities.PathCaseSensitive),s.isReadonly&&(i+=I.FileSystemProviderCapabilities.Readonly),typeof t.copy=="function"&&(i+=I.FileSystemProviderCapabilities.FileFolderCopy),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,u.$VG)(c,"fsChunks"),i+=I.FileSystemProviderCapabilities.FileOpenReadWriteClose);let g;s.isReadonly&&(0,k.$Zk)(s.isReadonly)&&s.isReadonly.value!==""&&(g={value:s.isReadonly.value,isTrusted:s.isReadonly.isTrusted,supportThemeIcons:s.isReadonly.supportThemeIcons,supportHtml:s.isReadonly.supportHtml,baseUri:s.isReadonly.baseUri,uris:s.isReadonly.uris}),this.a.$registerFileSystemProvider(n,f,i,g).catch(l=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${f}`),console.error(l)});const d=t.onDidChangeFile(l=>{const p=[];for(const C of l){const{uri:S,type:v}=C;if(S.scheme!==f)continue;let E;switch(v){case A.FileChangeType.Changed:E=I.FileChangeType.UPDATED;break;case A.FileChangeType.Created:E=I.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:E=I.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}p.push({resource:S,type:E})}this.a.$onFileSystemChange(n,p)});return(0,T.$Sc)(()=>{d.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:f,ctime:t,mtime:s,size:n,permissions:i}=c;return{type:f,ctime:t,mtime:s,size:n,permissions:i}}$stat(c,f){return Promise.resolve(this.l(c).stat(b.URI.revive(f))).then(t=>r.k(t))}$readdir(c,f){return Promise.resolve(this.l(c).readDirectory(b.URI.revive(f)))}$readFile(c,f){return Promise.resolve(this.l(c).readFile(b.URI.revive(f))).then(t=>y.$Je.wrap(t))}$writeFile(c,f,t,s){return Promise.resolve(this.l(c).writeFile(b.URI.revive(f),t.buffer,s))}$delete(c,f,t){return Promise.resolve(this.l(c).delete(b.URI.revive(f),t))}$rename(c,f,t,s){return Promise.resolve(this.l(c).rename(b.URI.revive(f),b.URI.revive(t),s))}$copy(c,f,t,s){const n=this.l(c);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(b.URI.revive(f),b.URI.revive(t),s))}$mkdir(c,f){return Promise.resolve(this.l(c).createDirectory(b.URI.revive(f)))}$watch(c,f,t,s){const n=this.l(c).watch(b.URI.revive(t),s);this.f.set(f,n)}$unwatch(c,f){const t=this.f.get(f);t&&(t.dispose(),this.f.delete(f))}$open(c,f,t){const s=this.l(c);if(!s.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(s.open(b.URI.revive(f),t))}$close(c,f){const t=this.l(c);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(f))}$read(c,f,t,s){const n=this.l(c);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const i=y.$Je.alloc(s);return Promise.resolve(n.read(f,t,i.buffer,0,s)).then(g=>i.slice(0,g))}$write(c,f,t,s){const n=this.l(c);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(f,t,s.buffer,0,s.byteLength))}l(c){const f=this.c.get(c);if(!f){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return f}}e.$0nc=r}),define(Ce[283],Ie([1,0,4,41,2,5,10,7,30,47]),function(_,e,b,D,I,T,A,M,$,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;class P{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(h,r,o,c,f,t){this.a=Math.random(),this.b=new b.$he,this.c=new b.$he,this.d=new b.$he,this.h=0,t?.ignoreCreateEvents&&(this.h+=1),t?.ignoreChangeEvents&&(this.h+=2),t?.ignoreDeleteEvents&&(this.h+=4);const s=(0,D.$uk)(f),n=typeof f=="string",i=t?.correlate,g=c(d=>{if(!(typeof d.session=="number"&&d.session!==this.a)&&!(i&&typeof d.session>"u")){if(!t?.ignoreCreateEvents)for(const l of d.created){const p=I.URI.revive(l);s(p.fsPath)&&(!n||r.getWorkspaceFolder(p))&&this.b.fire(p)}if(!t?.ignoreChangeEvents)for(const l of d.changed){const p=I.URI.revive(l);s(p.fsPath)&&(!n||r.getWorkspaceFolder(p))&&this.c.fire(p)}if(!t?.ignoreDeleteEvents)for(const l of d.deleted){const p=I.URI.revive(l);s(p.fsPath)&&(!n||r.getWorkspaceFolder(p))&&this.d.fire(p)}}});this.g=M.$xM.from(this.i(h,o,f,t,t?.correlate),this.b,this.c,this.d,g)}i(h,r,o,c,f){const t=M.$xM.from();if(typeof o=="string"||c?.ignoreChangeEvents&&c?.ignoreCreateEvents&&c?.ignoreDeleteEvents)return t;const s=h.getProxy(T.$vM.MainThreadFileSystemEventService);let n=!1;(o.pattern.includes(D.$qk)||o.pattern.includes(D.$rk))&&(n=!0);let i;return f&&(c?.ignoreChangeEvents||c?.ignoreCreateEvents||c?.ignoreDeleteEvents)&&(i=$.FileChangeFilter.UPDATED|$.FileChangeFilter.ADDED|$.FileChangeFilter.DELETED,c?.ignoreChangeEvents&&(i&=~$.FileChangeFilter.UPDATED),c?.ignoreCreateEvents&&(i&=~$.FileChangeFilter.ADDED),c?.ignoreDeleteEvents&&(i&=~$.FileChangeFilter.DELETED)),s.$watch(r.identifier.value,this.a,o.baseUri,{recursive:n,excludes:c?.excludes??[],filter:i},!!f),M.$xM.from({dispose:()=>s.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(h){this.a=h,this.session=this.a.session,this.b=new a.$V(()=>this.a.created.map(I.URI.revive)),this.c=new a.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new a.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class u{constructor(h,r,o){this.j=h,this.k=r,this.l=o,this.a=new b.$he,this.b=new b.$he,this.c=new b.$he,this.d=new b.$he,this.g=new b.$je,this.h=new b.$je,this.i=new b.$je,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(h,r,o,c){return new P(this.j,h,r,this.a.event,A.GlobPattern.from(o),c)}$onFileEvent(h){this.a.fire(new y(h))}$onDidRunFileOperation(h,r){switch(h){case $.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(o=>({oldUri:I.URI.revive(o.source),newUri:I.URI.revive(o.target)}))}));break;case $.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(o=>I.URI.revive(o.target))}));break;case $.FileOperation.CREATE:case $.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(o=>I.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(h){return this.m(h,this.g)}getOnWillCreateFileEvent(h){return this.m(h,this.h)}getOnWillDeleteFileEvent(h){return this.m(h,this.i)}m(h,r){return(o,c,f)=>{const t=function(n){o.call(c,n)};return t.extension=h,r.event(t,void 0,f)}}async $onWillRunFileOperation(h,r,o,c){switch(h){case $.FileOperation.MOVE:return await this.n(this.g,{files:r.map(f=>({oldUri:I.URI.revive(f.source),newUri:I.URI.revive(f.target)}))},o,c);case $.FileOperation.DELETE:return await this.n(this.i,{files:r.map(f=>I.URI.revive(f.target))},o,c);case $.FileOperation.CREATE:case $.FileOperation.COPY:return await this.n(this.h,{files:r.map(f=>I.URI.revive(f.target))},o,c)}}async n(h,r,o,c){const f=new Set,t=[];if(await h.fireAsync(r,c,async(n,i)=>{const g=Date.now(),d=await Promise.resolve(n);d instanceof M.$HM&&(t.push([i.extension,d]),f.add(i.extension.displayName??i.extension.identifier.value)),Date.now()-g>o&&this.k.warn("SLOW file-participant",i.extension.identifier)}),c.isCancellationRequested||t.length===0)return;const s={edits:[]};for(const[,n]of t){const{edits:i}=A.WorkspaceEdit.from(n,{getTextDocumentVersion:g=>this.l.getDocument(g)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(i)}return{edit:s,extensionNames:Array.from(f)}}}e.$$nc=u}),define(Ce[284],Ie([1,0,18,11,22,14,96,6,26,69,13,15,2,33,327,94,103,181,19,10,7,25,80,5]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s,n,i,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class d{constructor(U,W){this.d=U,this.e=W}async provideDocumentSymbols(U,W){const G=this.d.getDocument(U),K=await this.e.provideDocumentSymbols(G,W);if(!(0,b.$Kb)(K))return K[0]instanceof s.$RM?K.map(t.DocumentSymbol.from):d.f(K)}static f(U){U=U.slice(0).sort((K,x)=>{let ge=K.location.range.start.compareTo(x.location.range.start);return ge===0&&(ge=x.location.range.end.compareTo(K.location.range.end)),ge});const W=[],G=[];for(const K of U){const x={name:K.name||"!!MISSING: name!!",kind:t.SymbolKind.from(K.kind),tags:K.tags?.map(t.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:t.Range.from(K.location.range),selectionRange:t.Range.from(K.location.range),children:[]};for(;;){if(G.length===0){G.push(x),W.push(x);break}const ge=G[G.length-1];if(k.$dt.containsRange(ge.range,x.range)&&!k.$dt.equalsRange(ge.range,x.range)){ge.children?.push(x),G.push(x);break}G.pop()}}return W}}class l{constructor(U,W,G,K,x,ge){this.f=U,this.g=W,this.h=G,this.j=K,this.k=x,this.l=ge,this.d=new i.$Qmc("CodeLens"),this.e=new Map}async provideCodeLenses(U,W){const G=this.f.getDocument(U),K=await this.h.provideCodeLenses(G,W);if(!K||W.isCancellationRequested)return;const x=this.d.add(K),ge=new M.$Tc;this.e.set(x,ge);const Re={cacheId:x,lenses:[]};for(let Ue=0;Ue<K.length;Ue++)Re.lenses.push({cacheId:[x,Ue],range:t.Range.from(K[Ue].range),command:this.g.toInternal(K[Ue].command,ge)});return Re}async resolveCodeLens(U,W){const G=U.cacheId&&this.d.get(...U.cacheId);if(!G)return;let K;if(typeof this.h.resolveCodeLens!="function"||G.isResolved?K=G:K=await this.h.resolveCodeLens(G,W),K||(K=G),W.isCancellationRequested)return;const x=U.cacheId&&this.e.get(U.cacheId[0]);if(x){if(!K.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ge),this.l.error(ge);return}return U.command=this.g.toInternal(K.command,x),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function p(Te){return Array.isArray(Te)?Te.map(t.DefinitionLink.from):Te?[t.DefinitionLink.from(Te)]:[]}class C{constructor(U,W){this.d=U,this.e=W}async provideDefinition(U,W,G){const K=this.d.getDocument(U),x=t.Position.to(W),ge=await this.e.provideDefinition(K,x,G);return p(ge)}}class S{constructor(U,W){this.d=U,this.e=W}async provideDeclaration(U,W,G){const K=this.d.getDocument(U),x=t.Position.to(W),ge=await this.e.provideDeclaration(K,x,G);return p(ge)}}class v{constructor(U,W){this.d=U,this.e=W}async provideImplementation(U,W,G){const K=this.d.getDocument(U),x=t.Position.to(W),ge=await this.e.provideImplementation(K,x,G);return p(ge)}}class E{constructor(U,W){this.d=U,this.e=W}async provideTypeDefinition(U,W,G){const K=this.d.getDocument(U),x=t.Position.to(W),ge=await this.e.provideTypeDefinition(K,x,G);return p(ge)}}class R{constructor(U,W){this.g=U,this.h=W,this.d=0,this.e=new Map}async provideHover(U,W,G,K){const x=this.g.getDocument(U),ge=t.Position.to(W);let Re;if(G&&G.verbosityRequest){const nt=G.verbosityRequest.previousHover.id,it=this.e.get(nt);if(!it)throw new Error(`Hover with id ${nt} not found`);const st={verbosityDelta:G.verbosityRequest.verbosityDelta,previousHover:it};Re=await this.h.provideHover(x,ge,K,st)}else Re=await this.h.provideHover(x,ge,K);if(!Re||(0,b.$Kb)(Re.contents))return;Re.range||(Re.range=x.getWordRangeAtPosition(ge)),Re.range||(Re.range=new s.$zM(ge,ge));const Ue=t.Hover.from(Re),Ke=this.d;if(this.e.size===R.f){const nt=Math.min(...this.e.keys());this.e.delete(nt)}return this.e.set(Ke,Re),this.d+=1,{...Ue,id:Ke}}releaseHover(U){this.e.delete(U)}}R.f=10;class w{constructor(U,W){this.d=U,this.e=W}async provideEvaluatableExpression(U,W,G){const K=this.d.getDocument(U),x=t.Position.to(W),ge=await this.e.provideEvaluatableExpression(K,x,G);if(ge)return t.EvaluatableExpression.from(ge)}}class m{constructor(U,W){this.d=U,this.e=W}async provideInlineValues(U,W,G,K){const x=this.d.getDocument(U),ge=await this.e.provideInlineValues(x,t.Range.to(W),t.InlineValueContext.to(G),K);if(Array.isArray(ge))return ge.map(Re=>t.InlineValue.from(Re))}}class N{constructor(U,W){this.d=U,this.e=W}async provideDocumentHighlights(U,W,G){const K=this.d.getDocument(U),x=t.Position.to(W),ge=await this.e.provideDocumentHighlights(K,x,G);if(Array.isArray(ge))return ge.map(t.DocumentHighlight.from)}}class B{constructor(U,W){this.d=U,this.e=W}async provideMultiDocumentHighlights(U,W,G,K){const x=this.d.getDocument(U),ge=G.map(Ke=>this.d.getDocument(Ke)),Re=t.Position.to(W),Ue=await this.e.provideMultiDocumentHighlights(x,Re,ge,K);if(Array.isArray(Ue))return Ue.map(t.MultiDocumentHighlight.from)}}class X{constructor(U,W){this.d=U,this.e=W}async provideLinkedEditingRanges(U,W,G){const K=this.d.getDocument(U),x=t.Position.to(W),ge=await this.e.provideLinkedEditingRanges(K,x,G);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,b.$Hb)(ge.ranges.map(t.Range.from)),wordPattern:ge.wordPattern}}}class V{constructor(U,W){this.d=U,this.e=W}async provideReferences(U,W,G,K){const x=this.d.getDocument(U),ge=t.Position.to(W),Re=await this.e.provideReferences(x,ge,G,K);if(Array.isArray(Re))return Re.map(t.location.from)}}class O{constructor(U,W,G,K,x,ge,Re){this.g=U,this.h=W,this.j=G,this.k=K,this.l=x,this.m=ge,this.n=Re,this.e=new i.$Qmc("CodeAction"),this.f=new Map}async provideCodeActions(U,W,G,K){const x=this.g.getDocument(U),ge=h.$ft.isISelection(W)?t.Selection.to(W):t.Range.to(W),Re=[];for(const st of this.j.getDiagnostics(U))if(ge.intersection(st.range)&&Re.push(st)>O.d)break;const Ue={diagnostics:Re,only:G.only?new s.$TM(G.only):void 0,triggerKind:t.CodeActionTriggerKind.to(G.trigger)},Ke=await this.k.provideCodeActions(x,ge,Ue,K);if(!(0,b.$Lb)(Ke)||K.isCancellationRequested)return;const Ze=this.e.add(Ke),nt=new M.$Tc;this.f.set(Ze,nt);const it=[];for(let st=0;st<Ke.length;st++){const ot=Ke[st];if(ot)if(O.o(ot))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:ot.title,command:this.h.toInternal(ot,nt)});else{Ue.only&&(ot.kind?Ue.only.contains(ot.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action is of kind '${ot.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Ue.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const $t=ot.ranges??[];it.push({cacheId:[Ze,st],title:ot.title,command:ot.command&&this.h.toInternal(ot.command,nt),diagnostics:ot.diagnostics&&ot.diagnostics.map(t.Diagnostic.from),edit:ot.edit&&t.WorkspaceEdit.from(ot.edit,void 0),kind:ot.kind&&ot.kind.value,isPreferred:ot.isPreferred,isAI:(0,n.$UG)(this.m,"codeActionAI")?ot.isAI:!1,ranges:(0,n.$UG)(this.m,"codeActionRanges")?(0,b.$Hb)($t.map(t.Range.from)):void 0,disabled:ot.disabled?.reason})}}return{cacheId:Ze,actions:it}}async resolveCodeAction(U,W){const[G,K]=U,x=this.e.get(G,K);if(!x||O.o(x))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(x,W)??x;let Re;ge.edit&&(Re=t.WorkspaceEdit.from(ge.edit,void 0));let Ue;if(ge.command){const Ke=this.f.get(G);Ke&&(Ue=this.h.toInternal(ge.command,Ke))}return{edit:Re,command:Ue}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}O.d=1e3;class L{constructor(U,W,G,K,x){this.e=U,this.f=W,this.g=G,this.h=K,this.j=x,this.d=new i.$Qmc("DocumentPasteEdit")}async prepareDocumentPaste(U,W,G,K){if(!this.g.prepareDocumentPaste)return;const x=this.f.getDocument(U),ge=W.map(Ke=>t.Range.to(Ke)),Re=t.DataTransfer.toDataTransfer(G,()=>{throw new T.$$});if(await this.g.prepareDocumentPaste(x,ge,Re,K),K.isCancellationRequested)return;const Ue=Array.from(Re).filter(([,Ke])=>!(Ke instanceof s.$nN));return t.DataTransfer.from(Ue)}async providePasteEdits(U,W,G,K,x,ge){if(!this.g.provideDocumentPasteEdits)return[];const Re=this.f.getDocument(W),Ue=G.map(it=>t.Range.to(it)),Ke=t.DataTransfer.toDataTransfer(K,async it=>(await this.e.$resolvePasteFileData(this.h,U,it)).buffer),Ze=await this.g.provideDocumentPasteEdits(Re,Ue,Ke,{only:x.only?new s.$sN(x.only):void 0,triggerKind:x.triggerKind},ge);if(!Ze||ge.isCancellationRequested)return[];const nt=this.d.add(Ze);return Ze.map((it,st)=>({_cacheId:[nt,st],title:it.title??(0,c.localize)(0,null,this.j.displayName||this.j.name),kind:it.kind,yieldTo:it.yieldTo?.map(ot=>ot.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?t.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,W){const[G,K]=U,x=this.d.get(G,K);if(!x||!this.g.resolveDocumentPasteEdit)return{};const ge=await this.g.resolveDocumentPasteEdit(x,W)??x;return{additionalEdit:ge.additionalEdit?t.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class F{constructor(U,W){this.d=U,this.e=W}async provideDocumentFormattingEdits(U,W,G){const K=this.d.getDocument(U),x=await this.e.provideDocumentFormattingEdits(K,W,G);if(Array.isArray(x))return x.map(t.TextEdit.from)}}class ie{constructor(U,W){this.d=U,this.e=W}async provideDocumentRangeFormattingEdits(U,W,G,K){const x=this.d.getDocument(U),ge=t.Range.to(W),Re=await this.e.provideDocumentRangeFormattingEdits(x,ge,G,K);if(Array.isArray(Re))return Re.map(t.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,W,G,K){(0,y.$kg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const x=this.d.getDocument(U),ge=W.map(t.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(x,ge,G,K);if(Array.isArray(Re))return Re.map(t.TextEdit.from)}}class de{constructor(U,W){this.d=U,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,W,G,K,x){const ge=this.d.getDocument(U),Re=t.Position.to(W),Ue=await this.e.provideOnTypeFormattingEdits(ge,Re,G,K,x);if(Array.isArray(Ue))return Ue.map(t.TextEdit.from)}}class be{constructor(U,W){this.e=U,this.f=W,this.d=new i.$Qmc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,W){const G=await this.e.provideWorkspaceSymbols(U,W);if(!(0,b.$Lb)(G))return{symbols:[]};const K=this.d.add(G),x={cacheId:K,symbols:[]};for(let ge=0;ge<G.length;ge++){const Re=G[ge];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}x.symbols.push({...t.WorkspaceSymbol.from(Re),cacheId:[K,ge]})}return x}async resolveWorkspaceSymbol(U,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const G=this.d.get(...U.cacheId);if(G){const K=await this.e.resolveWorkspaceSymbol(G,W);return K&&(0,$.$ao)(U,t.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class ve{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,W,G){this.d=U,this.e=W,this.f=G}async provideRenameEdits(U,W,G,K){const x=this.d.getDocument(U),ge=t.Position.to(W);try{const Re=await this.e.provideRenameEdits(x,ge,G,K);return Re?t.WorkspaceEdit.from(Re):void 0}catch(Re){const Ue=ve.g(Re);return Ue?{rejectReason:Ue,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(U,W,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(U),x=t.Position.to(W);try{const ge=await this.e.prepareRename(K,x,G);let Re,Ue;if(s.$zM.isRange(ge)?(Re=ge,Ue=K.getText(ge)):(0,y.$cg)(ge)&&(Re=ge.range,Ue=ge.placeholder),!Re||!Ue)return;if(Re.start.line>x.line||Re.end.line<x.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:t.Range.from(Re),text:Ue}}catch(ge){const Re=ve.g(ge);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(ge)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class Z{constructor(U,W,G){this.e=U,this.f=W,this.g=G}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(U,W,G,K){const x=this.e.getDocument(U),ge=t.Range.to(W);try{const Re=Z.d[G],Ue=await this.f.provideNewSymbolNames(x,ge,Re,K);return Ue?Ue.map(Ke=>typeof Ke=="string"?{newSymbolName:Ke}:{newSymbolName:Ke.newSymbolName,tags:Ke.tags}):void 0}catch(Re){this.g.error(Z.h(Re)??JSON.stringify(Re,null,"	"));return}}static h(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}Z.d={[r.NewSymbolNameTriggerKind.Invoke]:s.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:s.NewSymbolNameTriggerKind.Automatic};class ae{constructor(U,W){this.resultId=U,this.tokens=W}}class fe{constructor(U,W){this.f=U,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,W,G){const K=this.f.getDocument(U),x=W!==0?this.d.get(W):null;let ge=typeof x?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,x.resultId,G):await this.g.provideDocumentSemanticTokens(K,G);return x&&this.d.delete(W),ge?(ge=fe.h(ge),this.o(fe.n(x,ge),ge)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return fe.j(U)?fe.k(U)?U:new s.$SN(new Uint32Array(U.data),U.resultId):fe.l(U)?fe.m(U)?U:new s.$UN(U.edits.map(W=>new s.$TN(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const W of U.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(U,W){if(!fe.j(W)||!U||!U.tokens)return W;const G=U.tokens,K=G.length,x=W.data,ge=x.length;let Re=0;const Ue=Math.min(K,ge);for(;Re<Ue&&G[Re]===x[Re];)Re++;if(Re===K&&Re===ge)return new s.$UN([],W.resultId);let Ke=0;const Ze=Ue-Re;for(;Ke<Ze&&G[K-Ke-1]===x[ge-Ke-1];)Ke++;return new s.$UN([{start:Re,deleteCount:K-Re-Ke,data:x.subarray(Re,ge-Ke)}],W.resultId)}o(U,W){if(fe.j(U)){const G=this.e++;return this.d.set(G,new ae(U.resultId,U.data)),(0,o.$$bb)({id:G,type:"full",data:U.data})}if(fe.l(U)){const G=this.e++;return fe.j(W)?this.d.set(G,new ae(W.resultId,W.data)):this.d.set(G,new ae(U.resultId)),(0,o.$$bb)({id:G,type:"delta",deltas:(U.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class ee{constructor(U,W){this.d=U,this.e=W}async provideDocumentRangeSemanticTokens(U,W,G){const K=this.d.getDocument(U),x=await this.e.provideDocumentRangeSemanticTokens(K,t.Range.to(W),G);return x?this.f(x):null}f(U){return(0,o.$$bb)({id:0,type:"full",data:U.data})}}class De{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,W,G,K,x){this.f=U,this.g=W,this.h=G,this.j=K,this.k=x,this.d=new i.$Qmc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,W,G,K){const x=this.f.getDocument(U),ge=t.Position.to(W),Re=x.getWordRangeAtPosition(ge)||new s.$zM(ge,ge),Ue=Re.with({end:ge}),Ke=new a.$be,Ze=await this.h.provideCompletionItems(x,ge,K,t.CompletionContext.to(G));if(!Ze||K.isCancellationRequested)return;const nt=Array.isArray(Ze)?new s.$7M(Ze):Ze,it=De.supportsResolving(this.h)?this.d.add(nt.items):this.d.add([]),st=new M.$Tc;this.e.set(it,st);const ot=[],$t={x:it,[g.ISuggestResultDtoField.completions]:ot,[g.ISuggestResultDtoField.defaultRanges]:{replace:t.Range.from(Re),insert:t.Range.from(Ue)},[g.ISuggestResultDtoField.isIncomplete]:nt.isIncomplete||void 0,[g.ISuggestResultDtoField.duration]:Ke.elapsed()};for(let dt=0;dt<nt.items.length;dt++){const rt=nt.items[dt],ut=this.l(rt,[it,dt],Ue,Re);ot.push(ut)}return $t}async resolveCompletionItem(U,W){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...U);if(!G)return;const K=this.l(G,U),x=await this.h.resolveCompletionItem(G,W);if(!x)return;const ge=this.l(x,U);return(K[g.ISuggestDataDtoField.insertText]!==ge[g.ISuggestDataDtoField.insertText]||K[g.ISuggestDataDtoField.insertTextRules]!==ge[g.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K[g.ISuggestDataDtoField.commandIdent]!==ge[g.ISuggestDataDtoField.commandIdent]||K[g.ISuggestDataDtoField.commandId]!==ge[g.ISuggestDataDtoField.commandId]||!(0,$.$bo)(K[g.ISuggestDataDtoField.commandArguments],ge[g.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,[g.ISuggestDataDtoField.documentation]:ge[g.ISuggestDataDtoField.documentation],[g.ISuggestDataDtoField.detail]:ge[g.ISuggestDataDtoField.detail],[g.ISuggestDataDtoField.additionalTextEdits]:ge[g.ISuggestDataDtoField.additionalTextEdits],[g.ISuggestDataDtoField.insertText]:ge[g.ISuggestDataDtoField.insertText],[g.ISuggestDataDtoField.insertTextRules]:ge[g.ISuggestDataDtoField.insertTextRules],[g.ISuggestDataDtoField.commandIdent]:ge[g.ISuggestDataDtoField.commandIdent],[g.ISuggestDataDtoField.commandId]:ge[g.ISuggestDataDtoField.commandId],[g.ISuggestDataDtoField.commandArguments]:ge[g.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,W,G,K){const x=this.e.get(W[0]);if(!x)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(U.command,x),Re={x:W,[g.ISuggestDataDtoField.label]:U.label,[g.ISuggestDataDtoField.kind]:U.kind!==void 0?t.CompletionItemKind.from(U.kind):void 0,[g.ISuggestDataDtoField.kindModifier]:U.tags&&U.tags.map(t.CompletionItemTag.from),[g.ISuggestDataDtoField.detail]:U.detail,[g.ISuggestDataDtoField.documentation]:typeof U.documentation>"u"?void 0:t.MarkdownString.fromStrict(U.documentation),[g.ISuggestDataDtoField.sortText]:U.sortText!==U.label?U.sortText:void 0,[g.ISuggestDataDtoField.filterText]:U.filterText!==U.label?U.filterText:void 0,[g.ISuggestDataDtoField.preselect]:U.preselect||void 0,[g.ISuggestDataDtoField.insertTextRules]:U.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[g.ISuggestDataDtoField.commitCharacters]:U.commitCharacters?.join(""),[g.ISuggestDataDtoField.additionalTextEdits]:U.additionalTextEdits&&U.additionalTextEdits.map(t.TextEdit.from),[g.ISuggestDataDtoField.commandIdent]:ge?.$ident,[g.ISuggestDataDtoField.commandId]:ge?.id,[g.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re[g.ISuggestDataDtoField.insertText]=U.textEdit.newText):typeof U.insertText=="string"?Re[g.ISuggestDataDtoField.insertText]=U.insertText:U.insertText instanceof s.$IM&&(Re[g.ISuggestDataDtoField.insertText]=U.insertText.value,Re[g.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let Ue;return U.textEdit?Ue=U.textEdit.range:U.range&&(Ue=U.range),s.$zM.isRange(Ue)?Re[g.ISuggestDataDtoField.range]=t.Range.from(Ue):Ue&&(!G?.isEqual(Ue.inserting)||!K?.isEqual(Ue.replacing))&&(Re[g.ISuggestDataDtoField.range]={insert:t.Range.from(Ue.inserting),replace:t.Range.from(Ue.replacing)}),Re}}class Fe{async provideInlineCompletions(U,W,G,K){}disposeCompletions(U){}handleDidShowCompletionItem(U,W,G){}handlePartialAccept(U,W,G,K){}}class ce extends Fe{constructor(U,W,G,K){super(),this.f=U,this.g=W,this.h=G,this.j=K,this.d=new he,this.e=(0,n.$UG)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:s.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:s.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,n.$UG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,W,G,K){const x=this.g.getDocument(U),ge=t.Position.to(W),Re=await this.h.provideInlineCompletionItems(x,ge,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:t.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},K);if(!Re||K.isCancellationRequested)return;const Ue=Array.isArray(Re)?Re:Re.items,Ke=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],Ze=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let nt;return{pid:this.d.createReferenceId({dispose(){nt?.dispose()},items:Ue}),items:Ue.map((st,ot)=>{let $t;st.command&&(nt||(nt=new M.$Tc),$t=this.j.toInternal(st.command,nt));const dt=st.insertText;return{insertText:typeof dt=="string"?dt:{snippet:dt.value},filterText:st.filterText,range:st.range?t.Range.from(st.range):void 0,command:$t,idx:ot,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:Ke.map(st=>(nt||(nt=new M.$Tc),this.j.toInternal(st,nt))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,W,G){const K=this.d.get(U)?.items[W];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K,G)}handlePartialAccept(U,W,G,K){const x=this.d.get(U)?.items[W];x&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(x,G),this.h.handleDidPartiallyAcceptCompletionItem(x,t.PartialAcceptInfo.to(K)))}}class H{async provideInlineEdits(U,W,G){const K=this.f.getDocument(U),x=await this.g.provideInlineEdit(K,{triggerKind:this.e[W.triggerKind]},G);if(!x||G.isCancellationRequested)return;let ge;const Re=this.d.createReferenceId({dispose(){ge?.dispose()},item:x});let Ue;x.accepted&&(ge||(ge=new M.$Tc),Ue=this.h.toInternal(x.accepted,ge));let Ke;return x.rejected&&(ge||(ge=new M.$Tc),Ke=this.h.toInternal(x.rejected,ge)),{pid:Re,text:x.text,range:t.Range.from(x.range),accepted:Ue,rejected:Ke}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,W,G,K){this.f=W,this.g=G,this.h=K,this.d=new he,this.e={[r.InlineEditTriggerKind.Automatic]:s.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:s.InlineEditTriggerKind.Invoke}}}class he{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const W=this.e++;return this.d.set(W,U),W}disposeReferenceId(U){const W=this.d.get(U);return this.d.delete(U),W}get(U){return this.d.get(U)}}class le{constructor(U,W){this.e=U,this.f=W,this.d=new i.$Qmc("SignatureHelp")}async provideSignatureHelp(U,W,G,K){const x=this.e.getDocument(U),ge=t.Position.to(W),Re=this.g(G),Ue=await this.f.provideSignatureHelp(x,ge,K,Re);if(Ue){const Ke=this.d.add([Ue]);return{...t.SignatureHelp.from(Ue),id:Ke}}}g(U){let W;if(U.activeSignatureHelp){const G=t.SignatureHelp.to(U.activeSignatureHelp),K=this.d.get(U.activeSignatureHelp.id,0);K?(W=K,W.activeSignature=G.activeSignature,W.activeParameter=G.activeParameter):W=G}return{...U,activeSignatureHelp:W}}releaseSignatureHelp(U){this.d.delete(U)}}class re{constructor(U,W,G,K,x){this.f=U,this.g=W,this.h=G,this.j=K,this.k=x,this.d=new i.$Qmc("InlayHints"),this.e=new Map}async provideInlayHints(U,W,G){const K=this.f.getDocument(U),x=t.Range.to(W),ge=await this.h.provideInlayHints(K,x,G);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`);return}if(G.isCancellationRequested)return;const Re=this.d.add(ge);this.e.set(Re,new M.$Tc);const Ue={hints:[],cacheId:Re};for(let Ke=0;Ke<ge.length;Ke++)this.l(ge[Ke],x)&&Ue.hints.push(this.m(ge[Ke],[Re,Ke]));return this.j.trace(`[InlayHints] ${Ue.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(W)}`),Ue}async resolveInlayHint(U,W){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...U);if(!G)return;const K=await this.h.resolveInlayHint(G,W);if(K&&this.l(K))return this.m(K,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,W){return U.label.length===0||Array.isArray(U.label)&&U.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(W&&!W.contains(U.position))}m(U,W){const G=this.e.get(W[0]);if(!G)throw Error("DisposableStore is missing...");const K={label:"",cacheId:W,tooltip:t.MarkdownString.fromStrict(U.tooltip),position:t.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(t.TextEdit.from),kind:U.kind&&t.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")K.label=U.label;else{const x=[];K.label=x;for(const ge of U.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Re={label:ge.value,tooltip:t.MarkdownString.fromStrict(ge.tooltip)};s.$JM.isLocation(ge.location)&&(Re.location=t.location.from(ge.location)),ge.command&&(Re.command=this.g.toInternal(ge.command,G)),x.push(Re)}}return K}}class ue{constructor(U,W){this.e=U,this.f=W,this.d=new i.$Qmc("DocumentLink")}async provideLinks(U,W){const G=this.e.getDocument(U),K=await this.f.provideDocumentLinks(G,W);if(!(!Array.isArray(K)||K.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(ue.g).map(t.DocumentLink.from)};{const x=this.d.add(K),ge={links:[],cacheId:x};for(let Re=0;Re<K.length;Re++){if(!ue.g(K[Re]))continue;const Ue=t.DocumentLink.from(K[Re]);Ue.cacheId=[x,Re],ge.links.push(Ue)}return ge}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,W){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...U);if(!G)return;const K=await this.f.resolveDocumentLink(G,W);if(!(!K||!ue.g(K)))return t.DocumentLink.from(K)}releaseLinks(U){this.d.delete(U)}}class oe{constructor(U,W){this.d=U,this.e=W}async provideColors(U,W){const G=this.d.getDocument(U),K=await this.e.provideDocumentColors(G,W);return Array.isArray(K)?K.map(ge=>({color:t.Color.from(ge.color),range:t.Range.from(ge.range)})):[]}async provideColorPresentations(U,W,G){const K=this.d.getDocument(U),x=t.Range.to(W.range),ge=t.Color.to(W.color),Re=await this.e.provideColorPresentations(ge,{document:K,range:x},G);if(Array.isArray(Re))return Re.map(t.ColorPresentation.from)}}class J{constructor(U,W){this.d=U,this.e=W}async provideFoldingRanges(U,W,G){const K=this.d.getDocument(U),x=await this.e.provideFoldingRanges(K,W,G);if(Array.isArray(x))return x.map(t.FoldingRange.from)}}class Y{constructor(U,W,G){this.d=U,this.e=W,this.f=G}async provideSelectionRanges(U,W,G){const K=this.d.getDocument(U),x=W.map(t.Position.to),ge=await this.e.provideSelectionRanges(K,x,G);if(!(0,b.$Lb)(ge))return[];if(ge.length!==x.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let Ue=0;Ue<x.length;Ue++){const Ke=[];Re.push(Ke);let Ze=x[Ue],nt=ge[Ue];for(;;){if(!nt.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(Ke.push(t.SelectionRange.from(nt)),!nt.parent)break;Ze=nt.range,nt=nt.parent}}return Re}}class we{constructor(U,W){this.f=U,this.g=W,this.d=new A.$5O(""),this.e=new Map}async prepareSession(U,W,G){const K=this.f.getDocument(U),x=t.Position.to(W),ge=await this.g.prepareCallHierarchy(K,x,G);if(!ge)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(ge)?ge.map(Ue=>this.h(Re,Ue)):[this.h(Re,ge)]}async provideCallsTo(U,W,G){const K=this.j(U,W);if(!K)throw new Error("missing call hierarchy item");const x=await this.g.provideCallHierarchyIncomingCalls(K,G);if(x)return x.map(ge=>({from:this.h(U,ge.from),fromRanges:ge.fromRanges.map(Re=>t.Range.from(Re))}))}async provideCallsFrom(U,W,G){const K=this.j(U,W);if(!K)throw new Error("missing call hierarchy item");const x=await this.g.provideCallHierarchyOutgoingCalls(K,G);if(x)return x.map(ge=>({to:this.h(U,ge.to),fromRanges:ge.fromRanges.map(Re=>t.Range.from(Re))}))}releaseSession(U){this.e.delete(U)}h(U,W){const G=this.e.get(U),K=t.CallHierarchyItem.from(W,U,G.size.toString(36));return G.set(K._itemId,W),K}j(U,W){return this.e.get(U)?.get(W)}}class pe{constructor(U,W){this.f=U,this.g=W,this.d=new A.$5O(""),this.e=new Map}async prepareSession(U,W,G){const K=this.f.getDocument(U),x=t.Position.to(W),ge=await this.g.prepareTypeHierarchy(K,x,G);if(!ge)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(ge)?ge.map(Ue=>this.h(Re,Ue)):[this.h(Re,ge)]}async provideSupertypes(U,W,G){const K=this.j(U,W);if(!K)throw new Error("missing type hierarchy item");const x=await this.g.provideTypeHierarchySupertypes(K,G);if(x)return x.map(ge=>this.h(U,ge))}async provideSubtypes(U,W,G){const K=this.j(U,W);if(!K)throw new Error("missing type hierarchy item");const x=await this.g.provideTypeHierarchySubtypes(K,G);if(x)return x.map(ge=>this.h(U,ge))}releaseSession(U){this.e.delete(U)}h(U,W){const G=this.e.get(U),K=t.TypeHierarchyItem.from(W,U,G.size.toString(36));return G.set(K._itemId,W),K}j(U,W){return this.e.get(U)?.get(W)}}class Me{constructor(U,W,G,K,x){this.e=U,this.f=W,this.g=G,this.h=K,this.j=x,this.d=new i.$Qmc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,W,G,K,x){const ge=this.f.getDocument(W),Re=t.Position.to(G),Ue=t.DataTransfer.toDataTransfer(K,async it=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,it)).buffer),Ke=await this.g.provideDocumentDropEdits(ge,Re,Ue,x);if(!Ke)return;const Ze=(0,b.$2b)(Ke),nt=this.d.add(Ze);return Ze.map((it,st)=>({_cacheId:[nt,st],title:it.title??(0,c.localize)(1,null,this.j.displayName||this.j.name),kind:it.kind?.value,yieldTo:it.yieldTo?.map(ot=>ot.value),insertText:typeof it.insertText=="string"?it.insertText:{snippet:it.insertText.value},additionalEdit:it.additionalEdit?t.WorkspaceEdit.from(it.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,W){const[G,K]=U,x=this.d.get(G,K);if(!x||!this.g.resolveDocumentDropEdit)return{};const ge=await this.g.resolveDocumentDropEdit(x,W)??x;return{additionalEdit:ge.additionalEdit?t.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class Ve{constructor(U,W){this.d=U,this.e=W}async provideMappedEdits(U,W,G,K){const x=u.URI.revive(U),ge=this.d.getDocument(x),Re=G.documents.map(Ze=>Ze.map(nt=>({uri:u.URI.revive(nt.uri),version:nt.version,ranges:nt.ranges.map(it=>t.Range.to(it))}))),Ue={documents:Re,selections:Re[0]?.[0]?.ranges??[]},Ke=await this.e.provideMappedEdits(ge,W,Ue,K);return Ke?t.WorkspaceEdit.from(Ke):null}}class Se{constructor(U,W){this.adapter=U,this.extension=W}}class Pe{constructor(U,W,G,K,x,ge,Re,Ue){this.g=W,this.h=G,this.j=K,this.k=x,this.l=ge,this.m=Re,this.n=Ue,this.f=new Map,this.e=U.getProxy(g.$vM.MainThreadLanguageFeatures)}o(U,W){return t.DocumentSelector.from(U,this.g,W)}p(U){return new s.$xM(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Pe.d++}async s(U,W,G,K,x,ge=!1){const Re=this.f.get(U);if(!Re||!(Re.adapter instanceof W))return K;const Ue=Date.now();ge||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ke=G(Re.adapter,Re.extension);return Promise.resolve(Ke).catch(Ze=>{(0,T.$4)(Ze)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(Re.extension.identifier,Ze))}).finally(()=>{ge||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-Ue}ms`)}),I.CancellationToken.isCancellationToken(x)?(0,D.$ph)(Ke,x):Ke}t(U,W){const G=this.q();return this.f.set(G,new Se(U,W)),G}static u(U){return U.displayName||U.name}static w(U){return U.identifier.value}registerDocumentSymbolProvider(U,W,G,K){const x=this.t(new d(this.h,G),U),ge=K&&K.label||Pe.u(U);return this.e.$registerDocumentSymbolProvider(x,this.o(W,U),ge),this.p(x)}$provideDocumentSymbols(U,W,G){return this.s(U,d,K=>K.provideDocumentSymbols(u.URI.revive(W),G),void 0,G)}registerCodeLensProvider(U,W,G){const K=this.q(),x=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new Se(new l(this.h,this.j.converter,G,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(K,this.o(W,U),x);let ge=this.p(K);if(x!==void 0){const Re=G.onDidChangeCodeLenses(Ue=>this.e.$emitCodeLensEvent(x));ge=s.$xM.from(ge,Re)}return ge}$provideCodeLenses(U,W,G){return this.s(U,l,K=>K.provideCodeLenses(u.URI.revive(W),G),void 0,G)}$resolveCodeLens(U,W,G){return this.s(U,l,K=>K.resolveCodeLens(W,G),void 0,void 0)}$releaseCodeLenses(U,W){this.s(U,l,G=>Promise.resolve(G.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(U,W,G){const K=this.t(new C(this.h,G),U);return this.e.$registerDefinitionSupport(K,this.o(W,U)),this.p(K)}$provideDefinition(U,W,G,K){return this.s(U,C,x=>x.provideDefinition(u.URI.revive(W),G,K),[],K)}registerDeclarationProvider(U,W,G){const K=this.t(new S(this.h,G),U);return this.e.$registerDeclarationSupport(K,this.o(W,U)),this.p(K)}$provideDeclaration(U,W,G,K){return this.s(U,S,x=>x.provideDeclaration(u.URI.revive(W),G,K),[],K)}registerImplementationProvider(U,W,G){const K=this.t(new v(this.h,G),U);return this.e.$registerImplementationSupport(K,this.o(W,U)),this.p(K)}$provideImplementation(U,W,G,K){return this.s(U,v,x=>x.provideImplementation(u.URI.revive(W),G,K),[],K)}registerTypeDefinitionProvider(U,W,G){const K=this.t(new E(this.h,G),U);return this.e.$registerTypeDefinitionSupport(K,this.o(W,U)),this.p(K)}$provideTypeDefinition(U,W,G,K){return this.s(U,E,x=>x.provideTypeDefinition(u.URI.revive(W),G,K),[],K)}registerHoverProvider(U,W,G,K){const x=this.t(new R(this.h,G),U);return this.e.$registerHoverProvider(x,this.o(W,U)),this.p(x)}$provideHover(U,W,G,K,x){return this.s(U,R,ge=>ge.provideHover(u.URI.revive(W),G,K,x),void 0,x)}$releaseHover(U,W){this.s(U,R,G=>Promise.resolve(G.releaseHover(W)),void 0,void 0)}registerEvaluatableExpressionProvider(U,W,G,K){const x=this.t(new w(this.h,G),U);return this.e.$registerEvaluatableExpressionProvider(x,this.o(W,U)),this.p(x)}$provideEvaluatableExpression(U,W,G,K){return this.s(U,w,x=>x.provideEvaluatableExpression(u.URI.revive(W),G,K),void 0,K)}registerInlineValuesProvider(U,W,G,K){const x=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new m(this.h,G),U);this.e.$registerInlineValuesProvider(ge,this.o(W,U),x);let Re=this.p(ge);if(x!==void 0){const Ue=G.onDidChangeInlineValues(Ke=>this.e.$emitInlineValuesEvent(x));Re=s.$xM.from(Re,Ue)}return Re}$provideInlineValues(U,W,G,K,x){return this.s(U,m,ge=>ge.provideInlineValues(u.URI.revive(W),G,K,x),void 0,x)}registerDocumentHighlightProvider(U,W,G){const K=this.t(new N(this.h,G),U);return this.e.$registerDocumentHighlightProvider(K,this.o(W,U)),this.p(K)}registerMultiDocumentHighlightProvider(U,W,G){const K=this.t(new B(this.h,G),U);return this.e.$registerMultiDocumentHighlightProvider(K,this.o(W,U)),this.p(K)}$provideDocumentHighlights(U,W,G,K){return this.s(U,N,x=>x.provideDocumentHighlights(u.URI.revive(W),G,K),void 0,K)}$provideMultiDocumentHighlights(U,W,G,K,x){return this.s(U,B,ge=>ge.provideMultiDocumentHighlights(u.URI.revive(W),G,K.map(Re=>u.URI.revive(Re)),x),void 0,x)}registerLinkedEditingRangeProvider(U,W,G){const K=this.t(new X(this.h,G),U);return this.e.$registerLinkedEditingRangeProvider(K,this.o(W,U)),this.p(K)}$provideLinkedEditingRanges(U,W,G,K){return this.s(U,X,async x=>{const ge=await x.provideLinkedEditingRanges(u.URI.revive(W),G,K);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Pe.y(ge.wordPattern):void 0}},void 0,K)}registerReferenceProvider(U,W,G){const K=this.t(new V(this.h,G),U);return this.e.$registerReferenceSupport(K,this.o(W,U)),this.p(K)}$provideReferences(U,W,G,K,x){return this.s(U,V,ge=>ge.provideReferences(u.URI.revive(W),G,K,x),void 0,x)}registerCodeActionProvider(U,W,G,K){const x=new M.$Tc,ge=this.t(new O(this.h,this.j.converter,this.k,G,this.l,U,this.m),U);return this.e.$registerCodeActionSupport(ge,this.o(W,U),{providedKinds:K?.providedCodeActionKinds?.map(Re=>Re.value),documentation:K?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,x)}))},Pe.u(U),Pe.w(U),!!G.resolveCodeAction),x.add(this.p(ge)),x}$provideCodeActions(U,W,G,K,x){return this.s(U,O,ge=>ge.provideCodeActions(u.URI.revive(W),G,K,x),void 0,x)}$resolveCodeAction(U,W,G){return this.s(U,O,K=>K.resolveCodeAction(W,G),{},void 0)}$releaseCodeActions(U,W){this.s(U,O,G=>Promise.resolve(G.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(U,W,G){const K=this.t(new F(this.h,G),U);return this.e.$registerDocumentFormattingSupport(K,this.o(W,U),U.identifier,U.displayName||U.name),this.p(K)}$provideDocumentFormattingEdits(U,W,G,K){return this.s(U,F,x=>x.provideDocumentFormattingEdits(u.URI.revive(W),G,K),void 0,K)}registerDocumentRangeFormattingEditProvider(U,W,G){const K=typeof G.provideDocumentRangesFormattingEdits=="function",x=this.t(new ie(this.h,G),U);return this.e.$registerRangeFormattingSupport(x,this.o(W,U),U.identifier,U.displayName||U.name,K),this.p(x)}$provideDocumentRangeFormattingEdits(U,W,G,K,x){return this.s(U,ie,ge=>ge.provideDocumentRangeFormattingEdits(u.URI.revive(W),G,K,x),void 0,x)}$provideDocumentRangesFormattingEdits(U,W,G,K,x){return this.s(U,ie,ge=>ge.provideDocumentRangesFormattingEdits(u.URI.revive(W),G,K,x),void 0,x)}registerOnTypeFormattingEditProvider(U,W,G,K){const x=this.t(new de(this.h,G),U);return this.e.$registerOnTypeFormattingSupport(x,this.o(W,U),K,U.identifier),this.p(x)}$provideOnTypeFormattingEdits(U,W,G,K,x,ge){return this.s(U,de,Re=>Re.provideOnTypeFormattingEdits(u.URI.revive(W),G,K,x,ge),void 0,ge)}registerWorkspaceSymbolProvider(U,W){const G=this.t(new be(W,this.l),U);return this.e.$registerNavigateTypeSupport(G,typeof W.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(U,W,G){return this.s(U,be,K=>K.provideWorkspaceSymbols(W,G),{symbols:[]},G)}$resolveWorkspaceSymbol(U,W,G){return this.s(U,be,K=>K.resolveWorkspaceSymbol(W,G),void 0,void 0)}$releaseWorkspaceSymbols(U,W){this.s(U,be,G=>G.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(U,W,G){const K=this.t(new ve(this.h,G,this.l),U);return this.e.$registerRenameSupport(K,this.o(W,U),ve.supportsResolving(G)),this.p(K)}$provideRenameEdits(U,W,G,K,x){return this.s(U,ve,ge=>ge.provideRenameEdits(u.URI.revive(W),G,K,x),void 0,x)}$resolveRenameLocation(U,W,G,K){return this.s(U,ve,x=>x.resolveRenameLocation(u.URI.revive(W),G,K),void 0,K)}registerNewSymbolNamesProvider(U,W,G){const K=this.t(new Z(this.h,G,this.l),U);return this.e.$registerNewSymbolNamesProvider(K,this.o(W,U)),this.p(K)}$supportsAutomaticNewSymbolNamesTriggerKind(U){return this.s(U,Z,W=>W.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(U,W,G,K,x){return this.s(U,Z,ge=>ge.provideNewSymbolNames(u.URI.revive(W),G,K,x),void 0,x)}registerDocumentSemanticTokensProvider(U,W,G,K){const x=this.t(new fe(this.h,G),U),ge=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(x,this.o(W,U),K,ge);let Re=this.p(x);if(ge){const Ue=G.onDidChangeSemanticTokens(Ke=>this.e.$emitDocumentSemanticTokensEvent(ge));Re=s.$xM.from(Re,Ue)}return Re}$provideDocumentSemanticTokens(U,W,G,K){return this.s(U,fe,x=>x.provideDocumentSemanticTokens(u.URI.revive(W),G,K),null,K)}$releaseDocumentSemanticTokens(U,W){this.s(U,fe,G=>G.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,W,G,K){const x=this.t(new ee(this.h,G),U);return this.e.$registerDocumentRangeSemanticTokensProvider(x,this.o(W,U),K),this.p(x)}$provideDocumentRangeSemanticTokens(U,W,G,K){return this.s(U,ee,x=>x.provideDocumentRangeSemanticTokens(u.URI.revive(W),G,K),null,K)}registerCompletionItemProvider(U,W,G,K){const x=this.t(new De(this.h,this.j.converter,G,this.m,U),U);return this.e.$registerCompletionsProvider(x,this.o(W,U),K,De.supportsResolving(G),U.identifier),this.p(x)}$provideCompletionItems(U,W,G,K,x){return this.s(U,De,ge=>ge.provideCompletionItems(u.URI.revive(W),G,K,x),void 0,x)}$resolveCompletionItem(U,W,G){return this.s(U,De,K=>K.resolveCompletionItem(W,G),void 0,G)}$releaseCompletionItems(U,W){this.s(U,De,G=>G.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(U,W,G,K){const x=new ce(U,this.h,G,this.j.converter),ge=this.t(x,U);return this.e.$registerInlineCompletionsSupport(ge,this.o(W,U),x.supportsHandleEvents,f.$Xm.toKey(U.identifier.value),K?.yieldTo?.map(Re=>f.$Xm.toKey(Re))||[]),this.p(ge)}$provideInlineCompletions(U,W,G,K,x){return this.s(U,Fe,ge=>ge.provideInlineCompletions(u.URI.revive(W),G,K,x),void 0,x)}$handleInlineCompletionDidShow(U,W,G,K){this.s(U,Fe,async x=>{x.handleDidShowCompletionItem(W,G,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,W,G,K,x){this.s(U,Fe,async ge=>{ge.handlePartialAccept(W,G,K,x)},void 0,void 0)}$freeInlineCompletionsList(U,W){this.s(U,Fe,async G=>{G.disposeCompletions(W)},void 0,void 0)}registerInlineEditProvider(U,W,G){const K=new H(U,this.h,G,this.j.converter),x=this.t(K,U);return this.e.$registerInlineEditProvider(x,this.o(W,U),U.identifier),this.p(x)}$provideInlineEdit(U,W,G,K){return this.s(U,H,x=>x.provideInlineEdits(u.URI.revive(W),G,K),void 0,K)}$freeInlineEdit(U,W){this.s(U,H,async G=>{G.disposeEdit(W)},void 0,void 0)}registerSignatureHelpProvider(U,W,G,K){const x=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,ge=this.t(new le(this.h,G),U);return this.e.$registerSignatureHelpProvider(ge,this.o(W,U),x),this.p(ge)}$provideSignatureHelp(U,W,G,K,x){return this.s(U,le,ge=>ge.provideSignatureHelp(u.URI.revive(W),G,K,x),void 0,x)}$releaseSignatureHelp(U,W){this.s(U,le,G=>G.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(U,W,G){const K=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,x=this.t(new re(this.h,this.j.converter,G,this.l,U),U);this.e.$registerInlayHintsProvider(x,this.o(W,U),typeof G.resolveInlayHint=="function",K,Pe.u(U));let ge=this.p(x);if(K!==void 0){const Re=G.onDidChangeInlayHints(Ue=>this.e.$emitInlayHintsEvent(K));ge=s.$xM.from(ge,Re)}return ge}$provideInlayHints(U,W,G,K){return this.s(U,re,x=>x.provideInlayHints(u.URI.revive(W),G,K),void 0,K)}$resolveInlayHint(U,W,G){return this.s(U,re,K=>K.resolveInlayHint(W,G),void 0,G)}$releaseInlayHints(U,W){this.s(U,re,G=>G.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(U,W,G){const K=this.t(new ue(this.h,G),U);return this.e.$registerDocumentLinkProvider(K,this.o(W,U),typeof G.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(U,W,G){return this.s(U,ue,K=>K.provideLinks(u.URI.revive(W),G),void 0,G,W.scheme==="output")}$resolveDocumentLink(U,W,G){return this.s(U,ue,K=>K.resolveLink(W,G),void 0,void 0,!0)}$releaseDocumentLinks(U,W){this.s(U,ue,G=>G.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(U,W,G){const K=this.t(new oe(this.h,G),U);return this.e.$registerDocumentColorProvider(K,this.o(W,U)),this.p(K)}$provideDocumentColors(U,W,G){return this.s(U,oe,K=>K.provideColors(u.URI.revive(W),G),[],G)}$provideColorPresentations(U,W,G,K){return this.s(U,oe,x=>x.provideColorPresentations(u.URI.revive(W),G,K),void 0,K)}registerFoldingRangeProvider(U,W,G){const K=this.q(),x=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new Se(new J(this.h,G),U)),this.e.$registerFoldingRangeProvider(K,this.o(W,U),U.identifier,x);let ge=this.p(K);if(x!==void 0){const Re=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(x));ge=s.$xM.from(ge,Re)}return ge}$provideFoldingRanges(U,W,G,K){return this.s(U,J,x=>x.provideFoldingRanges(u.URI.revive(W),G,K),void 0,K)}registerSelectionRangeProvider(U,W,G){const K=this.t(new Y(this.h,G,this.l),U);return this.e.$registerSelectionRangeProvider(K,this.o(W,U)),this.p(K)}$provideSelectionRanges(U,W,G,K){return this.s(U,Y,x=>x.provideSelectionRanges(u.URI.revive(W),G,K),[],K)}registerCallHierarchyProvider(U,W,G){const K=this.t(new we(this.h,G),U);return this.e.$registerCallHierarchyProvider(K,this.o(W,U)),this.p(K)}$prepareCallHierarchy(U,W,G,K){return this.s(U,we,x=>Promise.resolve(x.prepareSession(u.URI.revive(W),G,K)),void 0,K)}$provideCallHierarchyIncomingCalls(U,W,G,K){return this.s(U,we,x=>x.provideCallsTo(W,G,K),void 0,K)}$provideCallHierarchyOutgoingCalls(U,W,G,K){return this.s(U,we,x=>x.provideCallsFrom(W,G,K),void 0,K)}$releaseCallHierarchy(U,W){this.s(U,we,G=>Promise.resolve(G.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(U,W,G){const K=this.t(new pe(this.h,G),U);return this.e.$registerTypeHierarchyProvider(K,this.o(W,U)),this.p(K)}$prepareTypeHierarchy(U,W,G,K){return this.s(U,pe,x=>Promise.resolve(x.prepareSession(u.URI.revive(W),G,K)),void 0,K)}$provideTypeHierarchySupertypes(U,W,G,K){return this.s(U,pe,x=>x.provideSupertypes(W,G,K),void 0,K)}$provideTypeHierarchySubtypes(U,W,G,K){return this.s(U,pe,x=>x.provideSubtypes(W,G,K),void 0,K)}$releaseTypeHierarchy(U,W){this.s(U,pe,G=>Promise.resolve(G.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(U,W,G,K){const x=this.q();return this.f.set(x,new Se(new Me(this.e,this.h,G,x,U),U)),this.e.$registerDocumentOnDropEditProvider(x,this.o(W,U),(0,n.$UG)(U,"documentPaste")&&K?{supportsResolve:!!G.resolveDocumentDropEdit,dropMimeTypes:K.dropMimeTypes}:void 0),this.p(x)}$provideDocumentOnDropEdits(U,W,G,K,x,ge){return this.s(U,Me,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(W,u.URI.revive(G),K,x,ge)),void 0,void 0)}$resolveDropEdit(U,W,G){return this.s(U,Me,K=>K.resolveDropEdit(W,G),{},void 0)}$releaseDropEdits(U,W){this.s(U,Me,G=>Promise.resolve(G.releaseDropEdits(W)),void 0,void 0)}registerMappedEditsProvider(U,W,G){const K=this.t(new Ve(this.h,G),U);return this.e.$registerMappedEditsProvider(K,this.o(W,U)),this.p(K)}$provideMappedEdits(U,W,G,K,x){return this.s(U,Ve,ge=>Promise.resolve(ge.provideMappedEdits(W,G,K,x)),null,x)}registerDocumentPasteEditProvider(U,W,G,K){const x=this.q();return this.f.set(x,new Se(new L(this.e,this.h,G,x,U),U)),this.e.$registerPasteEditProvider(x,this.o(W,U),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,supportsResolve:!!G.resolveDocumentPasteEdit,providedPasteEditKinds:K.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this.p(x)}$prepareDocumentPaste(U,W,G,K,x){return this.s(U,L,ge=>ge.prepareDocumentPaste(u.URI.revive(W),G,K,x),void 0,x)}$providePasteEdits(U,W,G,K,x,ge,Re){return this.s(U,L,Ue=>Ue.providePasteEdits(W,u.URI.revive(G),K,x,ge,Re),void 0,Re)}$resolvePasteEdit(U,W,G){return this.s(U,L,K=>K.resolvePasteEdit(W,G),{},void 0)}$releasePasteEdits(U,W){this.s(U,L,G=>Promise.resolve(G.releasePasteEdits(W)),void 0,void 0)}static y(U){return{pattern:U.source,flags:U.flags}}static z(U){return{decreaseIndentPattern:Pe.y(U.decreaseIndentPattern),increaseIndentPattern:Pe.y(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Pe.y(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Pe.y(U.unIndentedLinePattern):void 0}}static B(U){return{beforeText:Pe.y(U.beforeText),afterText:U.afterText?Pe.y(U.afterText):void 0,previousLineText:U.previousLineText?Pe.y(U.previousLineText):void 0,action:U.action}}static C(U){return U.map(Pe.B)}static D(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(W=>s.SyntaxTokenType.toString(W)):void 0}}static E(U){return U.map(Pe.D)}setLanguageConfiguration(U,W,G){const{wordPattern:K}=G;if(K&&(0,P.$nf)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(W,K):this.h.setWordDefinitionFor(W,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const x=this.q(),ge={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?Pe.y(G.wordPattern):void 0,indentationRules:G.indentationRules?Pe.z(G.indentationRules):void 0,onEnterRules:G.onEnterRules?Pe.C(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs?Pe.E(G.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(x,W,ge),this.p(x)}$setWordDefinitions(U){for(const W of U)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.$1mc=Pe,Pe.d=0}),define(Ce[95],Ie([1,0,11,22,14,4,40,6,182,19,3,12,77,5,91,17,10,7,115,25]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Inc=e.$Hnc=void 0,e.$Hnc=(0,P.$Ai)("IExtHostLanguageModels");class n{constructor(l,p){this.option=l,this.stream=new b.$4h,this.stream=p??new b.$4h}}class i{constructor(){this.a=new Map,this.b=new b.$4h,this.c=!1,this.d=!1;const l=this;this.apiObject={text:l.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,l]of this.a)yield l.stream;else yield this.b}handleFragment(l){if(this.c)return;this.d=!0;let p=this.a.get(l.index);p||(this.a.size===0?p=new n(l.index,this.b):p=new n(l.index),this.a.set(l.index,p)),p.stream.emitOne(l.part)}get isStreaming(){return this.d}reject(l){this.c=!0;for(const p of this.f())p.reject(l)}resolve(){this.c=!0;for(const l of this.f())l.resolve()}}let g=s=class{constructor(l,p,C){this.j=p,this.k=C,this.c=new T.$he,this.d=new T.$he,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new a.$Zm,this.i=new Map,this.r=new Set,this.b=l.getProxy(k.$vM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(l,p,C,S){const v=s.a++;this.f.set(v,{extension:l.identifier,provider:C,languageModelId:p});let E;S.auth&&(E={providerLabel:l.displayName||l.name,accountLabel:typeof S.auth=="object"?S.auth.label:void 0}),this.b.$registerLanguageModelProvider(v,`${a.$Xm.toKey(l.identifier)}/${v}/${p}`,{extension:l.identifier,id:p,vendor:S.vendor??a.$Xm.toKey(l.identifier),name:S.name??"",family:S.family??"",version:S.version,maxInputTokens:S.maxInputTokens,maxOutputTokens:S.maxOutputTokens,auth:E,targetExtensions:S.extensions});const R=C.onDidReceiveLanguageModelResponse2?.(({extensionId:w,participant:m,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(p,new a.$Xm(w),m,N)});return(0,M.$Sc)(()=>{this.f.delete(v),this.b.$unregisterProvider(v),R?.dispose()})}async $provideLanguageModelResponse(l,p,C,S,v,E){const R=this.f.get(l);if(!R)return;const w=new u.$nw(async m=>{if(E.isCancellationRequested){this.j.warn(`[CHAT](${R.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(p,{index:m.index,part:m.part})});return R.provider.provideLanguageModelResponse(S.map(o.LanguageModelChatMessage.to),v,a.$Xm.toKey(C),w,E)}$provideTokenLength(l,p,C){const S=this.f.get(l);return S?Promise.resolve(S.provider.provideTokenCount(p,C)):Promise.resolve(0)}$acceptChatModelMetadata(l){if(l.added)for(const{identifier:p,metadata:C}of l.added)this.g.set(p,{metadata:C,apiObjects:new a.$Zm});if(l.removed)for(const p of l.removed){this.g.delete(p);for(const[C,S]of this.i)S.languageModelId===p&&(S.res.reject(new I.$5),this.i.delete(C))}l.added?.forEach(p=>this.p(p.metadata)),this.d.fire(void 0)}async selectLanguageModels(l,p){const C=await this.b.$selectChatModels({...p,extension:l.identifier}),S=[],v=this;for(const E of C){const R=this.g.get(E);if(!R)continue;this.o(l.identifier,R.metadata)&&await this.p(R.metadata);let w=R.apiObjects.get(l.identifier);w||(w={id:E,vendor:R.metadata.vendor,family:R.metadata.family,version:R.metadata.version,name:R.metadata.name,maxInputTokens:R.metadata.maxInputTokens,countTokens(m,N){if(!v.g.has(E))throw c.$MO.NotFound(E);return v.q(E,m,N??D.CancellationToken.None)},sendRequest(m,N,B){if(!v.g.has(E))throw c.$MO.NotFound(E);return v.l(l,E,m,N??{},B??D.CancellationToken.None)}},Object.freeze(w),R.apiObjects.set(l.identifier,w)),S.push(w)}return S}async l(l,p,C,S,v){const E=this.m(l,C),R=l.identifier,w=this.g.get(p)?.metadata;if(!w||!this.g.has(p))throw c.$MO.NotFound(`Language model '${p}' is unknown.`);if(this.o(R,w)&&(!await this.n(l,{identifier:w.extension,displayName:w.auth.providerLabel},S.justification,!1)||!this.h.get(R)?.has(w.extension)))throw c.$MO.NoPermissions(`Language model '${p}' cannot be used by '${R.value}'.`);const m=Math.random()*1e6|0,N=this.b.$fetchResponse(R,p,m,E,S.modelOptions??{},v),B=new b.$zh,X=new i;this.i.set(m,{languageModelId:p,res:X});let V;if(N.catch(O=>{B.isOpen()?X.reject(O):V=O}).finally(()=>{this.i.delete(m),X.resolve(),B.open()}),await B.wait(),V)throw V.name===c.$MO.name?V:new c.$MO(`Language model '${p}' errored, check cause for more details`,"Unknown",V);return X.apiObject}m(l,p){const C=[];for(const S of p)S.role===c.LanguageModelChatMessageRole.System&&(0,t.$VG)(l,"languageModelSystem"),C.push(o.LanguageModelChatMessage.from(S));return C}async $handleResponseFragment(l,p){const C=this.i.get(l);C&&C.res.handleFragment(p)}async n(l,p,C,S){const v=f.$xL+p.identifier.value;if(await this.k.getSession(l,v,[],{silent:!0}))return this.$updateModelAccesslist([{from:l.identifier,to:p.identifier,enabled:!0}]),!0;if(S)return!1;try{const R=C?(0,$.localize)(0,null,p.displayName,C):void 0;return await this.k.getSession(l,v,[],{forceNewSession:{detail:R}}),this.$updateModelAccesslist([{from:l.identifier,to:p.identifier,enabled:!0}]),!0}catch{return!1}}o(l,p){return!!p.auth&&!a.$Xm.equals(p.extension,l)}async p(l){if(l.auth)for(const p of this.r)try{await this.n(p,{identifier:l.extension,displayName:""},void 0,!0)}catch(C){this.j.error("Fake Auth request failed"),this.j.error(C)}}async q(l,p,C){if(!this.g.get(l))throw c.$MO.NotFound(`Language model '${l}' is unknown.`);const v=A.Iterable.find(this.f.values(),E=>E.languageModelId===l);return v?v.provider.provideTokenCount(p,C):this.b.$countTokens(l,typeof p=="string"?p:o.LanguageModelChatMessage.from(p),C)}$updateModelAccesslist(l){const p=new Array;for(const{from:C,to:S,enabled:v}of l){const E=this.h.get(C)??new a.$Ym;if(E.has(S)!==v){v?E.add(S):E.delete(S),this.h.set(C,E);const w={from:C,to:S};p.push(w),this.c.fire(w)}}}createLanguageModelAccessInformation(l){this.r.add(l);const p=this,C=T.Event.signal(T.Event.filter(this.c.event,v=>a.$Xm.equals(v.from,l.identifier))),S=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any(C,S)},canSendRequest(v){let E;e:for(const[w,m]of p.g)for(const N of m.apiObjects.values())if(N===v){E=m.metadata;break e}if(!E)return;if(!p.o(l.identifier,E))return!0;const R=p.h.get(l.identifier);if(R)return R.has(E.extension)}}}};e.$Inc=g,g.a=1,e.$Inc=g=s=Je([qe(0,r.$ZO),qe(1,y.$7j),qe(2,h.$3mc)],g)}),define(Ce[285],Ie([1,0,5,10,7,35,11,6,25]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$noc=void 0;class a{constructor(y,u,k,h){this.c=u,this.d=k,this.e=h,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(b.$vM.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,u){await this.a.$changeLanguage(y,u);const k=this.c.getDocumentData(y);if(!k)throw new Error(`document '${y.toString()}' NOT found`);return k.document}async tokenAtPosition(y,u){const k=y.version,h=D.Position.from(u),r=await this.a.$tokensAtPosition(y.uri,h),o={type:I.StandardTokenType.Other,range:y.getWordRangeAtPosition(u)??new I.$zM(u.line,u.character,u.line,u.character)};if(!r)return o;const c={range:D.Range.to(r.range),type:D.TokenType.to(r.type)};return!c.range.contains(u)||k!==y.version?o:c}createLanguageStatusItem(y,u,k){const h=this.f++,r=this.a,o=this.g,c=`${y.identifier.value}/${u}`;if(o.has(c))throw new Error(`LanguageStatusItem with id '${u}' ALREADY exists`);o.add(c);const f={selector:k,id:u,name:y.displayName??y.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let t;const s=new M.$Tc,n=()=>{if(t?.dispose(),!o.has(c)){console.warn(`LanguageStatusItem (${u}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}t=(0,A.$Ch)(()=>{s.clear(),this.a.$setLanguageStatus(h,{id:c,name:f.name??y.displayName??y.name,source:y.displayName??y.name,selector:D.DocumentSelector.from(f.selector,this.e),label:f.text,detail:f.detail??"",severity:f.severity===I.LanguageStatusSeverity.Error?T.default.Error:f.severity===I.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:f.command&&this.d.toInternal(f.command,s),accessibilityInfo:f.accessibilityInformation,busy:f.busy})},0)},i={dispose(){s.dispose(),t?.dispose(),r.$removeLanguageStatus(h),o.delete(c)},get id(){return f.id},get name(){return f.name},set name(g){f.name=g,n()},get selector(){return f.selector},set selector(g){f.selector=g,n()},get text(){return f.text},set text(g){f.text=g,n()},set text2(g){(0,$.$VG)(y,"languageStatusText"),f.text=g,n()},get text2(){return(0,$.$VG)(y,"languageStatusText"),f.text},get detail(){return f.detail},set detail(g){f.detail=g,n()},get severity(){return f.severity},set severity(g){f.severity=g,n()},get accessibilityInformation(){return f.accessibilityInformation},set accessibilityInformation(g){f.accessibilityInformation=g,n()},get command(){return f.command},set command(g){f.command=g,n()},get busy(){return f.busy},set busy(g){f.busy=g,n()}};return n(),i}}e.$noc=a}),define(Ce[286],Ie([1,0,16,2,10,7,90]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aoc=e.$_nc=void 0;class M{constructor(y,u,k,h){this.start=y,this.deletedCount=u,this.deletedItems=k,this.items=h}asApiEvent(){return{range:new T.$ZN(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,u,k){this.notebook=y,this.h=u,this.j=k,this.handle=k.handle,this.uri=D.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(I.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,u=this.h.getDocument(this.uri);if(!u)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:u.document,get mime(){return y.g},set mime(h){y.g=h},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(k)}return this.f}setOutputs(y){this.a=y.map(I.NotebookCellOutput.to)}setOutputItems(y,u,k){const h=k.map(I.NotebookCellOutputItem.to),r=this.a.find(o=>o.id===y);if(r&&(u||(r.items.length=0),r.items.push(...h),r.items.length>1&&r.items.every(o=>A.$rK(o.mime)))){const o=new Map,c=[];r.items.forEach(f=>{let t;o.has(f.mime)?t=o.get(f.mime):(t=[],o.set(f.mime,t),c.push(f.mime)),t.push(f.data)}),r.items.length=0,c.forEach(f=>{const t=A.$sK(o.get(f));r.items.push({mime:f,data:t.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$_nc=$;class a{constructor(y,u,k,h,r){this.k=y,this.l=u,this.m=k,this.uri=h,this.handle=a.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,u={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===b.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(k){return k=y.n(k),y.b[k].apiCell},getCells(k){return(k?y.p(k):y.b).map(r=>r.apiCell)},save(){return y.q()}};this.e=Object.freeze(u)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,u,k){this.g=y.versionId,this.h=u,this.acceptDocumentPropertiesChanged({metadata:k});const h={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},r=[];for(const c of y.rawEvents)c.kind===A.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,h.contentChanges):c.kind===A.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,h.contentChanges):c.kind===A.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),r.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),r.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const o=new Map;for(let c=0;c<r.length;c++){const f=r[c],t=o.get(f.cell);if(t===void 0){const s=h.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...f});o.set(f.cell,s-1)}else h.cellChanges[t]={...h.cellChanges[t],...f}}return Object.freeze(h),Object.freeze(h.cellChanges),Object.freeze(h.contentChanges),h}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let u=y.start|0,k=y.end|0;return u<0&&(u=0),k>this.b.length&&(k=this.b.length),y.with({start:u,end:k})}p(y){y=this.o(y);const u=[];for(let k=y.start;k<y.end;k++)u.push(this.b[k]);return u}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,u,k){if(this.j)return;const h=[],r=[],o=[];if(y.reverse().forEach(c=>{const t=c[2].map(i=>{const g=new $(this,this.l,i);return u||r.push($.asModelAddData(i)),g}),s=new M(c[0],c[1],[],t),n=this.b.splice(c[0],c[1],...t);for(const i of n)o.push(i.uri),s.deletedItems.push(i.apiCell);h.push(s)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:o}),k)for(const c of h)k.push(c.asApiEvent())}s(y,u,k,h){const r=this.b.splice(y,u);this.b.splice(k,0,...r);const o=[new M(y,u,r.map(c=>c.apiCell),[]),new M(k,0,[],r)];for(const c of o)h.push(c.asApiEvent())}t(y,u){this.b[y].setOutputs(u)}u(y,u,k,h){this.b[y].setOutputItems(u,k,h)}v(y,u){const k=this.b[y];k.apiCell.document.languageId!==u&&this.m.$acceptModelLanguageChanged(k.uri,u)}w(y,u){const k=this.b[y];k.apiCell.mime=u}x(y,u){this.b[y].setMetadata(u)}y(y,u){this.b[y].setInternalMetadata(u)}getCellFromApiCell(y){return this.b.find(u=>u.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(u=>u.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$aoc=a,a.a=0}),define(Ce[287],Ie([1,0,4,2,10,7,38]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$poc=void 0;class M{constructor(a,P,y,u={timeout:1500,errors:3}){this.b=a,this.c=P,this.d=y,this.f=u,this.a=new b.$je}dispose(){}getOnWillSaveNotebookDocumentEvent(a){return(P,y,u)=>{const k=function(r){P.call(y,r)};return k.extension=a,this.a.event(k,void 0,u)}}async $participateInSave(a,P,y){const u=D.URI.revive(a),k=this.c.getNotebookDocument(u);if(!k)throw new Error("Unable to resolve notebook document");const h=[];if(await this.a.fireAsync({notebook:k.apiNotebook,reason:I.TextDocumentSaveReason.to(P)},y,async(o,c)=>{const f=Date.now(),t=await await Promise.resolve(o);Date.now()-f>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!y.isCancellationRequested&&t&&(t instanceof T.$HM?h.push(t):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(h.length===0)return!0;const r={edits:[]};for(const o of h){const{edits:c}=I.WorkspaceEdit.from(o);r.edits=r.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new A.$Lw(r))}}e.$poc=M}),define(Ce[122],Ie([1,0,14,10,7]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=void 0;class T{constructor(M,$,a,P,y,u){this.id=M,this.f=$,this.notebookData=a,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=P,this.c=u}get apiEditor(){if(!this.e){const M=this;this.e={get notebook(){return M.notebookData.apiNotebook},get selection(){return M.a[0]},set selection($){this.selections=[$]},get selections(){return M.a},set selections($){if(!Array.isArray($)||!$.every(I.$ZN.isNotebookRange))throw(0,b.$7)("selections");M.a=$,M.g($)},get visibleRanges(){return M.b},revealRange($,a){M.f.$tryRevealRange(M.id,D.NotebookRange.from($),a??I.NotebookEditorRevealType.Default)},get viewColumn(){return M.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(M){this.d=M}_acceptVisibleRanges(M){this.b=M}_acceptSelections(M){this.a=M}g(M){this.f.$trySetSelections(this.id,M.map(D.NotebookRange.from))}_acceptViewColumn(M){this.c=M}}e.$boc=T,T.apiEditorsToExtHost=new WeakMap}),define(Ce[288],Ie([1,0,4,12,10]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$roc=void 0;let T=class{constructor(M,$){this.c=M,this.d=$,this.a=new b.$he,this.b=new b.$he,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(M,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",M,$);const a=this.d.getEditorById(M);$.visibleRanges&&a._acceptVisibleRanges($.visibleRanges.ranges.map(I.NotebookRange.to)),$.selections&&a._acceptSelections($.selections.selections.map(I.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:a.apiEditor,visibleRanges:a.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:a.apiEditor,selections:a.apiEditor.selections}))}$acceptEditorViewColumns(M){for(const $ in M)this.d.getEditorById($)._acceptViewColumn(I.ViewColumn.to(M[$]))}};e.$roc=T,e.$roc=T=Je([qe(0,D.$7j)],T)}),define(Ce[289],Ie([1,0,4,5,122]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uoc=void 0;class T{constructor(M,$){this.c=$,this.a=new Map,this.b=M.getProxy(D.$vM.MainThreadNotebookRenderers)}$postRendererMessage(M,$,a){const P=this.c.getEditorById(M);this.a.get($)?.fire({editor:P.apiEditor,message:a})}createRendererMessaging(M,$){if(!M.contributes?.notebookRenderer?.some(P=>P.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(P,y,u)=>this.d($).event(P,y,u),postMessage:(P,y)=>{I.$boc.apiEditorsToExtHost.has(P)&&([P,y]=[y,P]);const u=y&&I.$boc.apiEditorsToExtHost.get(y);return this.b.$postMessage(u?.id,$,P)}}}d(M){let $=this.a.get(M);return $||($=new b.$he({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(M)}}),this.a.set(M,$),$)}}e.$uoc=T}),define(Ce[290],Ie([1,0,10,77,22,72,14]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yoc=void 0;class M{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,u,k){const h=this.b++,{title:r,location:o,cancellable:c}=u,f={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(h,{location:b.ProgressLocation.from(o),title:r,source:f,cancellable:c},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$2),this.d(h,k,!!c)}d(y,u,k){let h;k&&(h=new I.$se,this.c.set(y,h));const r=c=>{this.a.$progressEnd(c),this.c.delete(c),h?.dispose()};let o;try{o=u(new a(this.a,y),k&&h?h.token:I.CancellationToken.None)}catch(c){throw r(y),c}return o.then(c=>r(y),c=>r(y)),o}$acceptProgressCanceled(y){const u=this.c.get(y);u&&(u.cancel(),this.c.delete(y))}}e.$yoc=M;function $(P,y){return P.message=y.message,typeof y.increment=="number"&&(typeof P.increment=="number"?P.increment+=y.increment:P.increment=y.increment),P}class a extends D.$nw{constructor(y,u){super(k=>this.throttledReport(k)),this.c=y,this.d=u}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,T.$7h)(100,(P,y)=>$(P,y),()=>Object.create(null))],a.prototype,"throttledReport",null)}),define(Ce[291],Ie([1,0,2,5,11,10]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zoc=void 0;class A{constructor($,a){this.d=a,this.c=new Map,this.b=$.getProxy(D.$vM.MainThreadQuickDiff)}$provideOriginalResource($,a,P){const y=b.URI.revive(a),u=this.c.get($);return u?(0,I.$sh)(()=>u.provideOriginalResource(y,P)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider($,a,P,y){const u=A.a++;return this.c.set(u,a),this.b.$registerQuickDiffProvider(u,T.DocumentSelector.from($,this.d),P,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(u),this.c.delete(u)}}}}e.$zoc=A,A.a=0}),define(Ce[292],Ie([1,0,22,4,6,5,2,7,14,18,35,34,25,10]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aoc=h;function h(r,o,c){const f=r.getProxy(T.$vM.MainThreadQuickOpen);class t{constructor(S,v){this.e=new Map,this.f=0,this.a=S,this.b=v}showQuickPick(S,v,E,R=b.CancellationToken.None){this.c=void 0;const w=Promise.resolve(v),m=++this.f,N=f.$show(m,{title:E?.title,placeHolder:E?.placeHolder,matchOnDescription:E?.matchOnDescription,matchOnDetail:E?.matchOnDetail,ignoreFocusLost:E?.ignoreFocusOut,canPickMany:E?.canPickMany},R),B={},X=N.then(()=>B);return Promise.race([X,w]).then(V=>{if(V===B)return;const O=(0,u.$UG)(S,"quickPickItemTooltip");return w.then(L=>{const F=[];for(let ie=0;ie<L.length;ie++){const de=L[ie];if(typeof de=="string")F.push({label:de,handle:ie});else if(de.kind===M.QuickPickItemKind.Separator)F.push({type:"separator",label:de.label});else{de.tooltip&&!O&&console.warn(`Extension '${S.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${S.identifier.value}`);const be=de.iconPath?d(de.iconPath):void 0;F.push({label:de.label,iconPath:be?.iconPath,iconClass:be?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:O?k.MarkdownString.fromStrict(de.tooltip):void 0,handle:ie})}}return E&&typeof E.onDidSelectItem=="function"&&(this.c=ie=>{E.onDidSelectItem(L[ie])}),f.$setItems(m,F),N.then(ie=>{if(typeof ie=="number")return L[ie];if(Array.isArray(ie))return ie.map(de=>L[de])})})}).then(void 0,V=>{if(!(0,$.$4)(V))return f.$setError(m,V),Promise.reject(V)})}$onItemSelected(S){this.c?.(S)}showInput(S,v=b.CancellationToken.None){return this.d=S?.validateInput,f.$input(S,typeof this.d=="function",v).then(void 0,E=>{if(!(0,$.$4)(E))return Promise.reject(E)})}async $validateInput(S){if(!this.d)return;const v=await this.d(S);if(!v||typeof v=="string")return v;let E;switch(v.severity){case M.InputBoxValidationSeverity.Info:E=P.default.Info;break;case M.InputBoxValidationSeverity.Warning:E=P.default.Warning;break;case M.InputBoxValidationSeverity.Error:E=P.default.Error;break;default:E=v.message?P.default.Error:P.default.Ignore;break}return{content:v.message,severity:E}}async showWorkspaceFolderPick(S,v=b.CancellationToken.None){const E=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[S]);if(!E)return;const R=await this.a.getWorkspaceFolders2();if(R)return R.find(w=>w.uri.toString()===E.uri.toString())}createQuickPick(S){const v=new l(S,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}createInputBox(S){const v=new p(S,()=>this.e.delete(v._id));return this.e.set(v._id,v),v}$onDidChangeValue(S,v){this.e.get(S)?._fireDidChangeValue(v)}$onDidAccept(S){this.e.get(S)?._fireDidAccept()}$onDidChangeActive(S,v){const E=this.e.get(S);E instanceof l&&E._fireDidChangeActive(v)}$onDidChangeSelection(S,v){const E=this.e.get(S);E instanceof l&&E._fireDidChangeSelection(v)}$onDidTriggerButton(S,v){this.e.get(S)?._fireDidTriggerButton(v)}$onDidTriggerItemButton(S,v,E){const R=this.e.get(S);R instanceof l&&R._fireDidTriggerItemButton(v,E)}$onDidHide(S){this.e.get(S)?._fireDidHide()}}class s{constructor(S,v){this.x=S,this.y=v,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new D.$he,this.q=new D.$he,this.r=new D.$he,this.s=new D.$he,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(S){this.b=S,this.z({title:S})}get step(){return this.c}set step(S){this.c=S,this.z({step:S})}get totalSteps(){return this.d}set totalSteps(S){this.d=S,this.z({totalSteps:S})}get enabled(){return this.g}set enabled(S){this.g=S,this.z({enabled:S})}get busy(){return this.j}set busy(S){this.j=S,this.z({busy:S})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(S){this.k=S,this.z({ignoreFocusOut:S})}get value(){return this.l}set value(S){this.l=S,this.z({value:S})}get placeholder(){return this.m}set placeholder(S){this.m=S,this.z({placeholder:S})}get buttons(){return this.n}set buttons(S){this.n=S.slice(),this.o.clear(),S.forEach((v,E)=>{const R=v===M.$WN.Back?-1:E;this.o.set(R,v)}),this.z({buttons:S.map((v,E)=>({...d(v.iconPath),tooltip:v.tooltip,handle:v===M.$WN.Back?-1:E}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(S){this.l=S,this.q.fire(S)}_fireDidTriggerButton(S){const v=this.o.get(S);v&&this.r.fire(v)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),f.$dispose(this._id))}z(S){if(!this.v){for(const v of Object.keys(S)){const E=S[v];this.u[v]=E===void 0?null:E}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){f.$createOrUpdate(this.u),this.u={id:this._id}}}s.a=1;function n(C){if(C instanceof M.$uN)return{id:C.id};const S=g(C),v=i(C);return{dark:typeof S=="string"?A.URI.file(S):S,light:typeof v=="string"?A.URI.file(v):v}}function i(C){return typeof C=="object"&&"light"in C?C.light:C}function g(C){return typeof C=="object"&&"dark"in C?C.dark:C}function d(C){const S=n(C);let v,E;return"id"in S?E=y.ThemeIcon.asClassName(S):v=S,{iconPath:v,iconClass:E}}class l extends s{constructor(S,v){super(S.identifier,v),this.O=S,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new D.$he,this.L=[],this.M=new D.$he,this.N=new D.$he,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(S){this.B=S.slice(),this.C.clear(),this.D.clear(),S.forEach((R,w)=>{this.C.set(w,R),this.D.set(R,w)});const v=(0,u.$UG)(this.O,"quickPickItemTooltip"),E=[];for(let R=0;R<S.length;R++){const w=S[R];if(w.kind===M.QuickPickItemKind.Separator)E.push({type:"separator",label:w.label});else{w.tooltip&&!v&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const m=w.iconPath?d(w.iconPath):void 0;E.push({handle:R,label:w.label,iconPath:m?.iconPath,iconClass:m?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:v?k.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((N,B)=>({...d(N.iconPath),tooltip:N.tooltip,handle:B}))})}}this.z({items:E})}get canSelectMany(){return this.E}set canSelectMany(S){this.E=S,this.z({canSelectMany:S})}get matchOnDescription(){return this.F}set matchOnDescription(S){this.F=S,this.z({matchOnDescription:S})}get matchOnDetail(){return this.G}set matchOnDetail(S){this.G=S,this.z({matchOnDetail:S})}get sortByLabel(){return this.H}set sortByLabel(S){this.H=S,this.z({sortByLabel:S})}get keepScrollPosition(){return this.I}set keepScrollPosition(S){this.I=S,this.z({keepScrollPosition:S})}get activeItems(){return this.J}set activeItems(S){this.J=S.filter(v=>this.D.has(v)),this.z({activeItems:this.J.map(v=>this.D.get(v))})}get selectedItems(){return this.L}set selectedItems(S){this.L=S.filter(v=>this.D.has(v)),this.z({selectedItems:this.L.map(v=>this.D.get(v))})}_fireDidChangeActive(S){const v=(0,a.$Hb)(S.map(E=>this.C.get(E)));this.J=v,this.K.fire(v)}_fireDidChangeSelection(S){const v=(0,a.$Hb)(S.map(E=>this.C.get(E)));this.L=v,this.M.fire(v)}_fireDidTriggerItemButton(S,v){const E=this.C.get(S);if(!E||!E.buttons||!E.buttons.length)return;const R=E.buttons[v];R&&this.N.fire({button:R,item:E})}}class p extends s{constructor(S,v){super(S.identifier,v),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(S){this.B=S,this.z({password:S})}get prompt(){return this.C}set prompt(S){this.C=S,this.z({prompt:S})}get valueSelection(){return this.D}set valueSelection(S){this.D=S,this.z({valueSelection:S})}get validationMessage(){return this.E}set validationMessage(S){this.E=S,S?typeof S=="string"?this.z({validationMessage:S,severity:P.default.Error}):this.z({validationMessage:S.message,severity:S.severity??P.default.Error}):this.z({validationMessage:void 0,severity:P.default.Ignore})}}return new t(o,c)}});var Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)},tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b};define(Ce[293],Ie([1,0,2,4,72,6,11,5,18,142,12,19,36,34,10,25,16,21]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c){"use strict";var f,t,s,n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Coc=e.$Boc=void 0;function i(V){return V instanceof b.URI}function g(V,O){return V.scheme===o.Schemas.file&&O.scheme===o.Schemas.file&&c.$e?V.toString()===O.toString():V.toString().toLowerCase()===O.toString().toLowerCase()}function d(V){if(V)return typeof V.iconPath=="string"?b.URI.file(V.iconPath):b.URI.isUri(V.iconPath)||k.ThemeIcon.isThemeIcon(V.iconPath)?V.iconPath:void 0}function l(V){if(V.icon){if(b.URI.isUri(V.icon))return V.icon;if(k.ThemeIcon.isThemeIcon(V.icon))return V.icon;{const O=V.icon;return{light:O.light,dark:O.dark}}}else return}function p(V,O){if(!V.iconPath&&!O.iconPath)return 0;if(V.iconPath){if(!O.iconPath)return 1}else return-1;const L=typeof V.iconPath=="string"?V.iconPath:b.URI.isUri(V.iconPath)?V.iconPath.fsPath:V.iconPath.id,F=typeof O.iconPath=="string"?O.iconPath:b.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,a.$zr)(L,F)}function C(V,O){let L=0;if(V.strikeThrough!==O.strikeThrough)return V.strikeThrough?1:-1;if(V.faded!==O.faded)return V.faded?1:-1;if(V.tooltip!==O.tooltip)return(V.tooltip||"").localeCompare(O.tooltip||"");if(L=p(V,O),L!==0)return L;if(V.light&&O.light)L=p(V.light,O.light);else{if(V.light)return 1;if(O.light)return-1}if(L!==0)return L;if(V.dark&&O.dark)L=p(V.dark,O.dark);else{if(V.dark)return 1;if(O.dark)return-1}return L}function S(V,O){if(V.command!==O.command)return V.command<O.command?-1:1;if(V.title!==O.title)return V.title<O.title?-1:1;if(V.tooltip!==O.tooltip){if(V.tooltip!==void 0&&O.tooltip!==void 0)return V.tooltip<O.tooltip?-1:1;if(V.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(V.arguments===O.arguments)return 0;if(V.arguments)if(O.arguments){if(V.arguments.length!==O.arguments.length)return V.arguments.length-O.arguments.length}else return 1;else return-1;for(let L=0;L<V.arguments.length;L++){const F=V.arguments[L],ie=O.arguments[L];if(F!==ie&&!(i(F)&&i(ie)&&g(F,ie)))return F<ie?-1:1}return 0}function v(V,O){let L=(0,a.$zr)(V.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(L!==0)return L;if(V.command&&O.command)L=S(V.command,O.command);else{if(V.command)return 1;if(O.command)return-1}if(L!==0)return L;if(V.decorations&&O.decorations)L=C(V.decorations,O.decorations);else{if(V.decorations)return 1;if(O.decorations)return-1}if(V.multiFileDiffEditorModifiedUri&&O.multiFileDiffEditorModifiedUri)L=(0,a.$zr)(V.multiFileDiffEditorModifiedUri.fsPath,O.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(V.multiFileDiffEditorModifiedUri)return 1;if(O.multiFileDiffEditorModifiedUri)return-1}if(V.multiDiffEditorOriginalUri&&O.multiDiffEditorOriginalUri)L=(0,a.$zr)(V.multiDiffEditorOriginalUri.fsPath,O.multiDiffEditorOriginalUri.fsPath,!0);else{if(V.multiDiffEditorOriginalUri)return 1;if(O.multiDiffEditorOriginalUri)return-1}return L}function E(V,O){for(let L=0;L<V.length;L++)if(V[L]!==O[L])return!1;return!0}function R(V,O){return V.command===O.command&&V.title===O.title&&V.tooltip===O.tooltip&&(V.arguments&&O.arguments?E(V.arguments,O.arguments):V.arguments===O.arguments)}function w(V,O){return(0,$.$ub)(V,O,R)}class m{get value(){return this.d}set value(O){O=O??"",this.l.queue(async()=>Be(this,f,"f").$setInputBoxValue(this.m,O)),this.o(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.l.queue(async()=>Be(this,f,"f").$setInputBoxPlaceholder(this.m,O)),this.f=O}get validateInput(){return(0,r.$VG)(this.k,"scmValidation"),this.g}set validateInput(O){if((0,r.$VG)(this.k,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.l.queue(async()=>Be(this,f,"f").$setValidationProviderIsEnabled(this.m,!!O))}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.l.queue(async()=>Be(this,f,"f").$setInputBoxEnablement(this.m,O)))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.l.queue(async()=>Be(this,f,"f").$setInputBoxVisibility(this.m,O)))}get document(){return(0,r.$VG)(this.k,"scmTextDocument"),Be(this,t,"f").getDocument(this.n)}constructor(O,L,F,ie,de,be){this.k=O,this.l=ie,this.m=de,this.n=be,f.set(this,void 0),t.set(this,void 0),this.d="",this.e=new D.$he,this.f="",this.h=!0,this.j=!0,tt(this,t,L,"f"),tt(this,f,F,"f")}showValidationMessage(O,L){(0,r.$VG)(this.k,"scmValidation"),this.l.queue(async()=>Be(this,f,"f").$showValidationMessage(this.m,O,L))}$onInputBoxValueChange(O){this.o(O)}o(O){this.d=O,this.e.fire(O)}}e.$Boc=m,f=new WeakMap,t=new WeakMap;class N{get disposed(){return this.l}get id(){return this.v}get label(){return this.w}set label(O){this.w=O,this.t.queue(async()=>this.q.$updateGroupLabel(this.u,this.handle,O))}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.t.queue(async()=>this.q.$updateGroup(this.u,this.handle,this.features))}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,L,F,ie,de,be,ve,Z){this.q=O,this.s=L,this.t=F,this.u=ie,this.v=de,this.w=be,this.multiDiffEditorEnableViewChanges=ve,this.x=Z,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new D.$he,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new D.$he,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=N.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,L){const F=this.h.get(O);return F?(0,A.$sh)(()=>this.s.executeCommand(F.command,...F.arguments||[],L)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(v),F=(0,$.$Db)(this.o,O,v).map(be=>{const ve=be.toInsert.map(Z=>{const ae=this.e++;this.g.set(ae,Z);const fe=Z.resourceUri;let ee;if(Z.command)if(Z.command.command==="vscode.open"||Z.command.command==="vscode.diff"||Z.command.command==="vscode.changes"){const pe=new T.$Tc;ee=this.s.converter.toInternal(Z.command,pe),this.j.set(ae,pe)}else this.h.set(ae,Z.command);const De=(0,r.$UG)(this.x,"scmMultiDiffEditor"),Fe=De?Z.multiDiffEditorOriginalUri:void 0,ce=De?Z.multiFileDiffEditorModifiedUri:void 0,H=d(Z.decorations),he=Z.decorations&&d(Z.decorations.light)||H,le=Z.decorations&&d(Z.decorations.dark)||H,re=[he,le],ue=Z.decorations&&Z.decorations.tooltip||"",oe=Z.decorations&&!!Z.decorations.strikeThrough,J=Z.decorations&&!!Z.decorations.faded,Y=Z.contextValue||"";return{rawResource:[ae,fe,re,ue,oe,J,Y,ee,Fe,ce],handle:ae}});return{start:be.start,deleteCount:be.deleteCount,toInsert:ve}}),ie=F.map(({start:be,deleteCount:ve,toInsert:Z})=>[be,ve,Z.map(ae=>ae.rawResource)]),de=F.reverse();for(const{start:be,deleteCount:ve,toInsert:Z}of de){const ae=Z.map(ee=>ee.handle),fe=this.n.splice(be,ve,...ae);for(const ee of fe)this.g.delete(ee),this.h.delete(ee),this.j.get(ee)?.dispose(),this.j.delete(ee)}return this.o=O,ie}dispose(){this.l=!0,this.m.fire()}}N.d=0;class B{get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.g}get count(){return this.h}set count(O){this.h!==O&&(this.h=O,this.e.queue(async()=>Be(this,s,"f").$updateSourceControl(this.x,{count:O})))}get quickDiffProvider(){return this.j}set quickDiffProvider(O){this.j=O;let L;(0,r.$UG)(this.y,"quickDiffProvider")&&(L=O?.label),this.e.queue(async()=>Be(this,s,"f").$updateSourceControl(this.x,{hasQuickDiffProvider:!!O,quickDiffLabel:L}))}get historyProvider(){return(0,r.$VG)(this.y,"scmHistoryProvider"),this.k}set historyProvider(O){(0,r.$VG)(this.y,"scmHistoryProvider"),this.k=O,this.l.value=new T.$Tc,this.e.queue(async()=>Be(this,s,"f").$updateSourceControl(this.x,{hasHistoryProvider:!!O})),O&&this.l.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.m=O?.currentHistoryItemGroup,this.e.queue(async()=>Be(this,s,"f").$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m))}))}get commitTemplate(){return this.n}set commitTemplate(O){O!==this.n&&(this.n=O,this.e.queue(async()=>Be(this,s,"f").$updateSourceControl(this.x,{commitTemplate:O})))}get acceptInputCommand(){return this.p}set acceptInputCommand(O){this.o.value=new T.$Tc,this.p=O;const L=this.z.converter.toInternal(O,this.o.value);this.e.queue(async()=>Be(this,s,"f").$updateSourceControl(this.x,{acceptInputCommand:L}))}get actionButton(){return(0,r.$VG)(this.y,"scmActionButton"),this.s}set actionButton(O){(0,r.$VG)(this.y,"scmActionButton"),this.q.value=new T.$Tc,this.s=O;const L=O!==void 0?{command:this.z.converter.toInternal(O.command,this.q.value),secondaryCommands:O.secondaryCommands?.map(F=>F.map(ie=>this.z.converter.toInternal(ie,this.q.value))),description:O.description,enabled:O.enabled}:void 0;this.e.queue(async()=>Be(this,s,"f").$updateSourceControl(this.x,{actionButton:L??null}))}get statusBarCommands(){return this.u}set statusBarCommands(O){if(this.u&&O&&w(this.u,O))return;this.t.value=new T.$Tc,this.u=O;const L=(O||[]).map(F=>this.z.converter.toInternal(F,this.t.value));this.e.queue(async()=>Be(this,s,"f").$updateSourceControl(this.x,{statusBarCommands:L}))}get selected(){return this.v}constructor(O,L,F,ie,de,be,ve){this.y=O,this.z=ie,this.A=de,this.B=be,this.C=ve,s.set(this,void 0),this.e=new A.$vh,this.f=new Map,this.h=void 0,this.j=void 0,this.l=new T.$Vc,this.n=void 0,this.o=new T.$Vc,this.p=void 0,this.q=new T.$Vc,this.t=new T.$Vc,this.u=void 0,this.v=!1,this.w=new D.$he,this.onDidChangeSelection=this.w.event,this.x=B.d++,this.D=new Map,this.E=new Set,tt(this,s,F,"f");const Z=b.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${de}/scm${this.x}/input`,query:ve?`rootUri=${encodeURIComponent(ve.toString())}`:void 0});this.e.queue(()=>Be(this,s,"f").$registerSourceControl(this.x,de,be,ve,Z)),this.g=new m(O,L,Be(this,s,"f"),this.e,this.x,Z)}createResourceGroup(O,L,F){const ie=(0,r.$UG)(this.y,"scmMultiDiffEditor")&&F?.multiDiffEditorEnableViewChanges===!0,de=new N(Be(this,s,"f"),this.z,this.e,this.x,O,L,ie,this.y),be=D.Event.once(de.onDidDispose)(()=>this.D.delete(de));return this.D.set(de,be),this.eventuallyAddResourceGroups(),de}eventuallyAddResourceGroups(){const O=[],L=[];for(const[F,ie]of this.D){ie.dispose();const de=F.onDidUpdateResourceStates(()=>{this.E.add(F),this.eventuallyUpdateResourceStates()});D.Event.once(F.onDidDispose)(()=>{this.E.delete(F),de.dispose(),this.f.delete(F.handle),this.e.queue(async()=>Be(this,s,"f").$unregisterGroup(this.x,F.handle))}),O.push([F.handle,F.id,F.label,F.features,F.multiDiffEditorEnableViewChanges]);const be=F._takeResourceStateSnapshot();be.length>0&&L.push([F.handle,be]),this.f.set(F.handle,F)}this.e.queue(async()=>Be(this,s,"f").$registerGroups(this.x,O,L)),this.D.clear()}eventuallyUpdateResourceStates(){const O=[];this.E.forEach(L=>{const F=L._takeResourceStateSnapshot();F.length!==0&&O.push([L.handle,F])}),O.length>0&&this.e.queue(async()=>Be(this,s,"f").$spliceResourceStates(this.x,O)),this.E.clear()}getResourceGroup(O){return this.f.get(O)}setSelectionState(O){this.v=O,this.w.fire(O)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.f.forEach(O=>O.dispose()),this.e.queue(async()=>Be(this,s,"f").$unregisterSourceControl(this.x))}}s=new WeakMap,B.d=0,Je([(0,I.$6h)(100)],B.prototype,"eventuallyAddResourceGroups",null),Je([(0,I.$6h)(100)],B.prototype,"eventuallyUpdateResourceStates",null);let X=n=class{get onDidChangeActiveProvider(){return this.j.event}constructor(O,L,F,ie){this.l=L,this.m=F,this.n=ie,this.g=new Map,this.h=new y.$Zm,this.j=new D.$he,this.e=O.getProxy(M.$vM.MainThreadSCM),this.f=O.getProxy(M.$vM.MainThreadTelemetry),L.registerArgumentProcessor({processArgument:de=>{if(de&&de.$mid===u.MarshalledId.ScmResource){const be=this.g.get(de.sourceControlHandle);if(!be)return de;const ve=be.getResourceGroup(de.groupHandle);return ve?ve.getResourceState(de.handle):de}else if(de&&de.$mid===u.MarshalledId.ScmResourceGroup){const be=this.g.get(de.sourceControlHandle);return be?be.getResourceGroup(de.groupHandle):de}else if(de&&de.$mid===u.MarshalledId.ScmProvider){const be=this.g.get(de.handle);return be||de}return de}})}createSourceControl(O,L,F,ie){this.n.trace("ExtHostSCM#createSourceControl",O.identifier.value,L,F,ie),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const de=n.d++,be=new B(O,this.m,this.e,this.l,L,F,ie);this.g.set(de,be);const ve=this.h.get(O.identifier)||[];return ve.push(be),this.h.set(O.identifier,ve),be}getLastInputBox(O){this.n.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const L=this.h.get(O.identifier),F=L&&L[L.length-1];return F&&F.inputBox}$provideOriginalResource(O,L,F){const ie=b.URI.revive(L);this.n.trace("ExtHostSCM#$provideOriginalResource",O,ie.toString());const de=this.g.get(O);return!de||!de.quickDiffProvider||!de.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$sh)(()=>de.quickDiffProvider.provideOriginalResource(ie,F)).then(be=>be||null)}$onInputBoxValueChange(O,L){this.n.trace("ExtHostSCM#$onInputBoxValueChange",O);const F=this.g.get(O);return F&&F.inputBox.$onInputBoxValueChange(L),Promise.resolve(void 0)}$executeResourceCommand(O,L,F,ie){this.n.trace("ExtHostSCM#$executeResourceCommand",O,L,F);const de=this.g.get(O);if(!de)return Promise.resolve(void 0);const be=de.getResourceGroup(L);return be?be.$executeResourceCommand(F,ie):Promise.resolve(void 0)}$validateInput(O,L,F){this.n.trace("ExtHostSCM#$validateInput",O);const ie=this.g.get(O);return!ie||!ie.inputBox.validateInput?Promise.resolve(void 0):(0,A.$sh)(()=>ie.inputBox.validateInput(L,F)).then(de=>{if(!de)return Promise.resolve(void 0);const be=h.MarkdownString.fromStrict(de.message);return be?Promise.resolve([be,de.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.g.get(O)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(O,L,F,ie){return await this.g.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(L,F,ie)??void 0}async $provideHistoryItems(O,L,F,ie){return(await this.g.get(O)?.historyProvider?.provideHistoryItems(L,F,ie))?.map(ve=>({...ve,icon:l(ve)}))??void 0}async $provideHistoryItemSummary(O,L,F,ie){const de=this.g.get(O)?.historyProvider;if(typeof de?.provideHistoryItemSummary!="function")return;const be=await de.provideHistoryItemSummary(L,F,ie);return be?{...be,icon:l(be)}:void 0}async $provideHistoryItemChanges(O,L,F,ie){return await this.g.get(O)?.historyProvider?.provideHistoryItemChanges(L,F,ie)??void 0}};e.$Coc=X,X.d=0,e.$Coc=X=n=Je([qe(3,P.$7j)],X)}),define(Ce[294],Ie([1,0,5,10,2]),function(_,e,b,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Doc=void 0;class T{constructor(M,$){this.d=$,this.c=new Map,this.b=M.getProxy(b.$vM.MainThreadShare)}async $provideShare(M,$,a){return await this.c.get(M)?.provideShare({selection:D.Range.to($.selection),resourceUri:I.URI.revive($.resourceUri)},a)??void 0}registerShareProvider(M,$){const a=T.a++;return this.c.set(a,$),this.b.$registerShareProvider(a,D.DocumentSelector.from(M,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(a),this.c.delete(a)}}}}e.$Doc=T,T.a=0});var tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b},Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)};define(Ce[295],Ie([1,0,7,5,185,6,10,15]),function(_,e,b,D,I,T,A,M){"use strict";var $,a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Goc=e.$Foc=void 0;class P{constructor(h,r,o,c,f,t=b.StatusBarAlignment.Left,s){if($.set(this,void 0),a.set(this,void 0),this.i=!1,this.k="",this.q=new T.$Tc,tt(this,$,h,"f"),tt(this,a,r,"f"),f&&c){this.c=(0,b.$0M)(c.identifier,f);const n=o.get(this.c);n&&(t=n.alignLeft?b.StatusBarAlignment.Left:b.StatusBarAlignment.Right,s=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(P.a++);this.e=c,this.f=f,this.g=t,this.h=this.u(s)}u(h){if((0,M.$eg)(h))return h===Number.POSITIVE_INFINITY?Number.MAX_VALUE:h===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:h}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(h){this.k=h,this.v()}set name(h){this.m=h,this.v()}set tooltip(h){this.l=h,this.v()}set color(h){this.n=h,this.v()}set backgroundColor(h){h&&!P.b.has(h.id)&&(h=void 0),this.o=h,this.v()}set command(h){this.r?.fromApi!==h&&(this.p&&this.q.add(this.p),this.p=new T.$Tc,typeof h=="string"?this.r={fromApi:h,internal:Be(this,a,"f").toInternal({title:"",command:h},this.p)}:h?this.r={fromApi:h,internal:Be(this,a,"f").toInternal(h,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(h){this.t=h,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Be(this,$,"f").$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let h;this.e?this.f?h=`${this.e.identifier.value}.${this.f}`:h=this.e.identifier.value:h=this.f;let r;this.m?r=this.m:r=(0,I.localize)(0,null,this.e.displayName||this.e.name);let o=this.n;this.o&&(o=P.b.get(this.o.id));const c=A.MarkdownString.fromStrict(this.l);Be(this,$,"f").$setEntry(this.c,h,this.e?.identifier.value,r,this.k,c,this.r?.internal,o,this.o,this.g===b.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Foc=P,$=new WeakMap,a=new WeakMap,P.a=0,P.b=new Map([["statusBarItem.errorBackground",new b.$vN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new b.$vN("statusBarItem.warningForeground")]]);class y{constructor(h){this.b=[],this.a=h.createStatusBarEntry(void 0,"status.extensionMessage",b.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(h){const r={message:h};return this.b.unshift(r),this.c(),new b.$xM(()=>{const o=this.b.indexOf(r);o>=0&&(this.b.splice(o,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class u{constructor(h,r){this.e=new Map,this.a=h.getProxy(D.$vM.MainThreadStatusBar),this.b=r,this.c=new y(this)}$acceptStaticEntries(h){for(const r of h)this.e.set(r.entryId,r)}createStatusBarEntry(h,r,o,c){return new P(this.a,this.b,this.e,h,r,o,c)}setStatusBarMessage(h,r){const o=this.c.setMessage(h);let c;return typeof r=="number"?c=setTimeout(()=>o.dispose(),r):typeof r<"u"&&r.then(()=>o.dispose(),()=>o.dispose()),new b.$xM(()=>{o.dispose(),clearTimeout(c)})}}e.$Goc=u}),define(Ce[123],Ie([1,0,33,114,55,82,56,10,2]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cP=e.$bP=e.$aP=e.$_O=void 0;const a=(t,s,n,i)=>{let g=s;return{enumerable:!0,configurable:!1,get(){return g},set(d){if(!n(g,d)){const l=g;g=d,t.listener?.(i(d,l))}}}},P=(t,s)=>t===s,y={range:(t,s)=>t===s?!0:!t||!s?!1:t.isEqual(s),label:P,description:P,sortText:P,busy:P,error:P,canResolveChildren:P,tags:(t,s)=>!(t.length!==s.length||t.some(n=>!s.find(i=>n.id===i.id)))},u=t=>s=>({op:T.TestItemEventOp.SetProp,update:t(s)}),k=(t,s)=>({range:(()=>{let n;const i=u(g=>({range:b.$dt.lift(M.Range.from(g))}));return{enumerable:!0,configurable:!1,get(){return n},set(g){t.listener?.({op:T.TestItemEventOp.DocumentSynced}),y.range(n,g)||(n=g,t.listener?.(i(g)))}}})(),label:a(t,s,y.label,u(n=>({label:n}))),description:a(t,void 0,y.description,u(n=>({description:n}))),sortText:a(t,void 0,y.sortText,u(n=>({sortText:n}))),canResolveChildren:a(t,!1,y.canResolveChildren,n=>({op:T.TestItemEventOp.UpdateCanResolveChildren,state:n})),busy:a(t,!1,y.busy,u(n=>({busy:n}))),error:a(t,void 0,y.error,u(n=>({error:M.MarkdownString.fromStrict(n)||null}))),tags:a(t,[],y.tags,(n,i)=>({op:T.TestItemEventOp.SetTags,new:n.map(M.TestTag.from),old:i.map(M.TestTag.from)}))}),h=t=>{const s=I.$hL.fromString(t.extId),n=new o(s.controllerId,s.localId,t.label,$.URI.revive(t.uri)||void 0);return n.range=M.Range.to(t.range||void 0),n.description=t.description||void 0,n.sortText=t.sortText||void 0,n.tags=t.tags.map(i=>M.TestTag.to({id:(0,A.$nL)(i).tagId})),n},r=t=>{let s;for(const n of t.tests){const i=h(n.item);(0,D.$VO)(i).parent=s,s=i}return s};e.$_O=r;class o{constructor(s,n,i,g){if(n.includes(I.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(n)} symbol`);const d=(0,D.$UO)(this,s);Object.defineProperties(this,{id:{value:n,enumerable:!0,writable:!1},uri:{value:g,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return d.parent instanceof c?void 0:d.parent}},children:{value:(0,T.$TO)(d,D.$VO,o),enumerable:!0,writable:!1},...k(d,i)})}}e.$aP=o;class c extends o{constructor(s,n){super(s,s,n,void 0),this._isRoot=!0}}e.$bP=c;class f extends T.$PO{constructor(s,n,i){super({controllerId:s,getDocumentVersion:g=>g&&i.getDocument(g)?.version,getApiFor:D.$VO,getChildren:g=>g.children,root:new c(s,n),toITestItem:M.TestItem.from})}}e.$cP=f});var tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b},Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)};define(Ce[39],Ie([1,0,15,7,10,26,5,18,12,48,33,101,2,6,3,17,123,23,38,49,69,63,66,37]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s,n,i,g){"use strict";var d,l,p;Object.defineProperty(e,"__esModule",{value:!0}),e.$nP=e.$mP=e.$lP=e.$kP=e.$jP=e.$iP=void 0;let C=class{constructor(m,N,B){d.set(this,void 0),this.b=new Map,this.c=new Map,l.set(this,void 0),p.set(this,void 0),tt(this,d,m.getProxy(A.$vM.MainThreadCommands),"f"),this.d=N,tt(this,p,B,"f"),tt(this,l,m.getProxy(A.$vM.MainThreadTelemetry),"f"),this.converter=new S(this,X=>{const V=this.c.get(X);return V?.result===E.Void?V:void 0},N),this.f=[{processArgument(X){return(0,a.$0h)(X)}},{processArgument(X){return(0,T.$_n)(X,function(V){if(P.$dt.isIRange(V))return I.Range.to(V);if(y.$ct.isIPosition(V))return I.Position.to(V);if(P.$dt.isIRange(V.range)&&u.URI.isUri(V.uri))return I.location.to(V);if(V instanceof c.$Je)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(m){this.f.push(m)}registerApiCommand(m){const N=this.registerCommand(!1,m.id,async(...B)=>{const X=m.args.map((O,L)=>{if(!O.validate(B[L]))throw new Error(`Invalid argument '${O.name}' when running '${m.id}', received: ${typeof B[L]=="object"?JSON.stringify(B[L],null,"	"):B[L]} `);return O.convert(B[L])}),V=await this.executeCommand(m.internalId,...X);return m.result.convert(V,B,this.converter)},void 0,{description:m.description,args:m.args,returns:m.result.description});return this.c.set(m.id,m),new D.$xM(()=>{N.dispose(),this.c.delete(m.id)})}registerCommand(m,N,B,X,V,O){if(this.d.trace("ExtHostCommands#registerCommand",N),!N.trim().length)throw new Error("invalid id");if(this.b.has(N))throw new Error(`command '${N}' already exists`);return this.b.set(N,{callback:B,thisArg:X,metadata:V,extension:O}),m&&Be(this,d,"f").$registerCommand(N),new D.$xM(()=>{this.b.delete(N)&&m&&Be(this,d,"f").$unregisterCommand(N)})}executeCommand(m,...N){return this.d.trace("ExtHostCommands#executeCommand",m),this.g(m,N,!0)}async g(m,N,B){if(this.b.has(m))return Be(this,d,"f").$fireCommandActivationEvent(m),this.h(m,N,!1);{let X=!1;const V=(0,T.$_n)(N,function(O){if(O instanceof D.$yM)return I.Position.from(O);if(O instanceof D.$zM)return I.Range.from(O);if(O instanceof D.$JM)return I.location.from(O);if(D.$ZN.isNotebookRange(O))return I.NotebookRange.from(O);if(O instanceof ArrayBuffer)return X=!0,c.$Je.wrap(new Uint8Array(O));if(O instanceof Uint8Array)return X=!0,c.$Je.wrap(O);if(O instanceof c.$Je)return X=!0,O;if(!Array.isArray(O))return O});try{const O=await Be(this,d,"f").$executeCommand(m,X?new f.$Lw(V):V,B);return(0,a.$0h)(O)}catch(O){if(O instanceof Error&&O.message==="$executeCommand:retry")return this.g(m,N,!1);throw O}}}async h(m,N,B){const X=this.b.get(m);if(!X)throw new Error("Unknown command");const{callback:V,thisArg:O,metadata:L}=X;if(L?.args)for(let ie=0;ie<L.args.length;ie++)try{(0,b.$rg)(N[ie],L.args[ie].constraint)}catch{throw new Error(`Running the contributed command: '${m}' failed. Illegal argument '${L.args[ie].name}' - ${L.args[ie].description}`)}const F=s.$be.create();try{return await V.apply(O,N)}catch(ie){if(m===this.converter.delegatingCommandId){const de=this.converter.getActualCommand(...N);de&&(m=de.command)}if(this.d.error(ie,m,X.extension?.identifier),!B)throw ie;if(X.extension?.identifier){const de=Be(this,p,"f").onExtensionError(X.extension.identifier,ie);this.d.trace("forwarded error to extension?",de,X.extension?.identifier)}throw new class extends Error{constructor(){super((0,t.$lj)(ie)),this.id=m,this.source=X.extension?.displayName??X.extension?.name}}}finally{this.j(X,m,F.elapsed())}}j(m,N,B){m.extension&&Be(this,l,"f").$publicLog2("Extension:ActionExecuted",{extensionId:m.extension.identifier.value,id:new n.$op(N),duration:B})}$executeContributedCommand(m,...N){this.d.trace("ExtHostCommands#$executeContributedCommand",m);const B=this.b.get(m);return B?(N=N.map(X=>this.f.reduce((V,O)=>O.processArgument(V,B.extension?.identifier),X)),this.h(m,N,!0)):Promise.reject(new Error(`Contributed command '${m}' does not exist.`))}getCommands(m=!1){return this.d.trace("ExtHostCommands#getCommands",m),Be(this,d,"f").$getCommands().then(N=>(m&&(N=N.filter(B=>B[0]!=="_")),N))}$getContributedCommandMetadata(){const m=Object.create(null);for(const[N,B]of this.b){const{metadata:X}=B;X&&(m[N]=X)}return Promise.resolve(m)}};e.$iP=C,d=new WeakMap,l=new WeakMap,p=new WeakMap,e.$iP=C=Je([qe(0,r.$ZO),qe(1,$.$7j),qe(2,i.$hP)],C),e.$jP=(0,h.$Ai)("IExtHostCommands");class S{constructor(m,N,B){this.d=m,this.f=N,this.g=B,this.delegatingCommandId=`__vsc${(0,g.$Wg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(m,N){if(!m)return;const B={$ident:void 0,id:m.command,title:m.title,tooltip:m.tooltip};if(!m.command)return B;const X=this.f(m.command);if(X)B.id=X.internalId,B.arguments=X.args.map((V,O)=>V.convert(m.arguments&&m.arguments[O]));else if((0,M.$Lb)(m.arguments)){const V=`${m.command} /${++this.c}`;this.b.set(V,m),N.add((0,k.$Sc)(()=>{this.b.delete(V),this.g.trace("CommandsConverter#DISPOSE",V)})),B.$ident=V,B.id=this.delegatingCommandId,B.arguments=[V],this.g.trace("CommandsConverter#CREATE",m.command,V)}return B}fromInternal(m){return typeof m.$ident=="string"?this.b.get(m.$ident):{command:m.id,title:m.title,arguments:m.arguments}}getActualCommand(...m){return this.b.get(m[0])}h(...m){const N=this.getActualCommand(...m);return this.g.trace("CommandsConverter#EXECUTE",m[0],N?N.command:"MISSING"),N?this.d.executeCommand(N.command,...N.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${m[0]}`)}}e.$kP=S;class v{static Arr(m){return new v(`${m.name}_array`,`Array of ${m.name}, ${m.description}`,N=>Array.isArray(N)&&N.every(B=>m.validate(B)),N=>N.map(B=>m.convert(B)))}constructor(m,N,B,X){this.name=m,this.description=N,this.validate=B,this.convert=X}optional(){return new v(this.name,`(optional) ${this.description}`,m=>m==null||this.validate(m),m=>m===void 0?void 0:m===null?null:this.convert(m))}with(m,N){return new v(m??this.name,N??this.description,this.validate,this.convert)}}e.$lP=v,v.Uri=new v("uri","Uri of a text document",w=>u.URI.isUri(w),w=>w),v.Position=new v("position","A position in a text document",w=>D.$yM.isPosition(w),I.Position.from),v.Range=new v("range","A range in a text document",w=>D.$zM.isRange(w),I.Range.from),v.Selection=new v("selection","A selection in a text document",w=>D.$AM.isSelection(w),I.Selection.from),v.Number=new v("number","",w=>typeof w=="number",w=>w),v.String=new v("string","",w=>typeof w=="string",w=>w),v.StringArray=v.Arr(v.String),v.CallHierarchyItem=new v("item","A call hierarchy item",w=>w instanceof D.$VM,I.CallHierarchyItem.from),v.TypeHierarchyItem=new v("item","A type hierarchy item",w=>w instanceof D.$hO,I.TypeHierarchyItem.from),v.TestItem=new v("testItem","A VS Code TestItem",w=>w instanceof o.$aP,I.TestItem.from);class E{constructor(m,N){this.description=m,this.convert=N}}e.$mP=E,E.Void=new E("no result",w=>w);class R{constructor(m,N,B,X,V){this.id=m,this.internalId=N,this.description=B,this.args=X,this.result=V}}e.$nP=R}),define(Ce[296],Ie([1,0,18,16,2,94,103,32,39,10,7]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;const y=[new $.$nP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$lP.Uri,$.$lP.Position],new $.$mP("A promise that resolves to an array of DocumentHighlight-instances.",k(a.DocumentHighlight.to))),new $.$nP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$lP.Uri],new $.$mP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,o)=>{if((0,b.$Kb)(r))return;class c extends P.$QM{static to(t){const s=new c(t.name,a.SymbolKind.to(t.kind),t.containerName||"",new P.$JM(o[0],a.Range.to(t.range)));return s.detail=t.detail,s.range=s.location.range,s.selectionRange=a.Range.to(t.selectionRange),s.children=t.children?t.children.map(c.to):[],s}}return r.map(c.to)})),new $.$nP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$lP.Uri,new $.$lP("options","Formatting options",r=>!0,r=>r)],new $.$mP("A promise that resolves to an array of TextEdits.",k(a.TextEdit.to))),new $.$nP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$lP.Uri,$.$lP.Range,new $.$lP("options","Formatting options",r=>!0,r=>r)],new $.$mP("A promise that resolves to an array of TextEdits.",k(a.TextEdit.to))),new $.$nP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$lP.Uri,$.$lP.Position,new $.$lP("ch","Trigger character",r=>typeof r=="string",r=>r),new $.$lP("options","Formatting options",r=>!0,r=>r)],new $.$mP("A promise that resolves to an array of TextEdits.",k(a.TextEdit.to))),new $.$nP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$lP.Uri,$.$lP.Position],new $.$mP("A promise that resolves to an array of Location or LocationLink instances.",h)),new $.$nP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$lP.Uri,$.$lP.Position],new $.$mP("A promise that resolves to an array of Location or LocationLink instances.",h)),new $.$nP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$lP.Uri,$.$lP.Position],new $.$mP("A promise that resolves to an array of Location or LocationLink instances.",h)),new $.$nP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$lP.Uri,$.$lP.Position],new $.$mP("A promise that resolves to an array of Location or LocationLink instances.",h)),new $.$nP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$lP.Uri,$.$lP.Position],new $.$mP("A promise that resolves to an array of Location-instances.",k(a.location.to))),new $.$nP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$lP.Uri,$.$lP.Position],new $.$mP("A promise that resolves to an array of Hover-instances.",k(a.Hover.to))),new $.$nP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$lP.Uri,new $.$lP("position","A position in a text document",r=>Array.isArray(r)&&r.every(o=>P.$yM.isPosition(o)),r=>r.map(a.Position.from))],new $.$mP("A promise that resolves to an array of ranges.",r=>r.map(o=>{let c;for(const f of o.reverse())c=new P.$UM(a.Range.to(f),c);return c}))),new $.$nP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$lP.String.with("query","Search string")],new $.$mP("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(a.WorkspaceSymbol.to))),new $.$nP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$lP.Uri,$.$lP.Position],new $.$mP("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(a.CallHierarchyItem.to))),new $.$nP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$lP.CallHierarchyItem],new $.$mP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(a.CallHierarchyIncomingCall.to))),new $.$nP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$lP.CallHierarchyItem],new $.$mP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(a.CallHierarchyOutgoingCall.to))),new $.$nP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$lP.Uri,$.$lP.Position],new $.$mP("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:a.Range.to(r.range),placeholder:r.text}})),new $.$nP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$lP.Uri,$.$lP.Position,$.$lP.String.with("newName","The new symbol name")],new $.$mP("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return a.WorkspaceEdit.to(r)}})),new $.$nP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$lP.Uri,$.$lP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$mP("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(a.DocumentLink.to))),new $.$nP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$lP.Uri],new $.$mP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new P.$QN(r.tokenTypes,r.tokenModifiers)})),new $.$nP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$lP.Uri],new $.$mP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$_bb)(r);if(o.type==="full")return new P.$SN(o.data,void 0)})),new $.$nP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$lP.Uri,$.$lP.Range.optional()],new $.$mP("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new P.$QN(r.tokenTypes,r.tokenModifiers)})),new $.$nP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$lP.Uri,$.$lP.Range],new $.$mP("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const o=(0,A.$_bb)(r);if(o.type==="full")return new P.$SN(o.data,void 0)})),new $.$nP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$lP.Uri,$.$lP.Position,$.$lP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$lP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$mP("A promise that resolves to a CompletionList-instance.",(r,o,c)=>{if(!r)return new P.$7M([]);const f=r.suggestions.map(t=>a.CompletionItem.to(t,c));return new P.$7M(f,r.incomplete)})),new $.$nP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$lP.Uri,$.$lP.Position,$.$lP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$mP("A promise that resolves to SignatureHelp.",r=>{if(r)return a.SignatureHelp.to(r)})),new $.$nP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$lP.Uri,$.$lP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$mP("A promise that resolves to an array of CodeLens-instances.",(r,o,c)=>k(f=>new P.$YM(a.Range.to(f.range),f.command&&c.fromInternal(f.command)))(r))),new $.$nP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$lP.Uri,new $.$lP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>P.$zM.isRange(r),r=>P.$AM.isSelection(r)?a.Selection.from(r):a.Range.from(r)),$.$lP.String.with("kind","Code action kind to return code actions for").optional(),$.$lP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$mP("A promise that resolves to an array of Command-instances.",(r,o,c)=>k(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(f.command)}else{const t=new P.$SM(f.title,f.kind?new P.$TM(f.kind):void 0);return f.edit&&(t.edit=a.WorkspaceEdit.to(f.edit)),f.command&&(t.command=c.fromInternal(f.command)),t.isPreferred=f.isPreferred,t}})(r))),new $.$nP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$lP.Uri],new $.$mP("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(o=>new P.$aN(a.Range.to(o.range),a.Color.to(o.color))):[])),new $.$nP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$lP("color","The color to show and insert",r=>r instanceof P.$_M,a.Color.from),new $.$lP("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:a.Range.from(r.range)}))],new $.$mP("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(a.ColorPresentation.to):[])),new $.$nP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$lP.Uri,$.$lP.Range],new $.$mP("A promise that resolves to an array of Inlay objects",(r,o,c)=>r.map(a.InlayHint.to.bind(void 0,c)))),new $.$nP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$lP.Uri],new $.$mP("A promise that resolves to an array of FoldingRange objects",(r,o)=>{if(r)return r.map(a.FoldingRange.to)})),new $.$nP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$mP("A promise that resolves to an array of NotebookContentProvider static info objects.",k(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(o=>a.NotebookExclusiveDocumentPattern.to(o))})))),new $.$nP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$lP.Uri,$.$lP.Range,new $.$lP("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof P.$zM,r=>a.InlineValueContext.from(r))],new $.$mP("A promise that resolves to an array of InlineValue objects",r=>r.map(a.InlineValue.to))),new $.$nP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$lP("uriOrString","Uri-instance or string (only http/https)",r=>I.URI.isUri(r)||typeof r=="string"&&(0,D.$Kg)(r,D.Schemas.http,D.Schemas.https),r=>r),new $.$lP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[a.ViewColumn.from(r),void 0]:[a.ViewColumn.from(r.viewColumn),a.TextEditorOpenOptions.from(r)])).optional(),$.$lP.String.with("label","").optional()],$.$mP.Void),new $.$nP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$lP.Uri.with("resource","Resource to open"),$.$lP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$lP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[a.ViewColumn.from(r),void 0]:[a.ViewColumn.from(r.viewColumn),a.TextEditorOpenOptions.from(r)])).optional()],$.$mP.Void),new $.$nP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$lP.Uri.with("left","Left-hand side resource of the diff editor"),$.$lP.Uri.with("right","Right-hand side resource of the diff editor"),$.$lP.String.with("title","Human readable title for the diff editor").optional(),new $.$lP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[a.ViewColumn.from(r.viewColumn),a.TextEditorOpenOptions.from(r)]).optional()],$.$mP.Void),new $.$nP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$lP.String.with("title","Human readable title for the changes editor"),new $.$lP("resourceList","List of resources to compare",r=>{for(const o of r){if(o.length!==3)return!1;const[c,f,t]=o;if(!I.URI.isUri(c)||!I.URI.isUri(f)&&f!==void 0&&f!==null||!I.URI.isUri(t)&&t!==void 0&&t!==null)return!1}return!0},r=>r)],$.$mP.Void),new $.$nP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$lP.Uri,$.$lP.Position],new $.$mP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(a.TypeHierarchyItem.to))),new $.$nP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$lP.TypeHierarchyItem],new $.$mP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(a.TypeHierarchyItem.to))),new $.$nP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$lP.TypeHierarchyItem],new $.$mP("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(a.TypeHierarchyItem.to))),new $.$nP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$lP.TestItem],$.$mP.Void),new $.$nP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$lP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$mP.Void),new $.$nP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$lP.String.with("name","The context key name"),new $.$lP("value","The context key value",()=>!0,r=>r)],$.$mP.Void),new $.$nP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$lP.Uri,$.$lP.StringArray,new $.$lP("MappedEditsContext","Mapped Edits Context",r=>a.MappedEditsContext.is(r),r=>a.MappedEditsContext.from(r))],new $.$mP("A promise that resolves to a workspace edit or null",r=>r?a.WorkspaceEdit.to(r):null)),new $.$nP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new $.$lP("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?a.Range.from(r.initialRange):void 0,initialSelection:P.$AM.isSelection(r.initialSelection)?a.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?a.Position.from(r.position):void 0}})],$.$mP.Void)];class u{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",M.$zj)}}e.$2mc=u;function k(r){return o=>{if(Array.isArray(o))return o.map(r)}}function h(r){if(!Array.isArray(r))return;const o=[];for(const c of r)T.$Mv(c)?o.push(a.DefinitionLink.to(c)):o.push(a.location.to(c));return o}}),define(Ce[297],Ie([1,0,2,39]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$loc=void 0;class I{constructor(A,M,$,a,P){this.a=M,this.b=$,this.c=a;const y=new D.$nP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new D.$lP("showOptions","Show Options",u=>!0,u=>u),new D.$lP("resource","Interactive resource Uri",u=>!0,u=>u),new D.$lP("controllerId","Notebook controller Id",u=>!0,u=>u),new D.$lP("title","Interactive editor title",u=>!0,u=>u)],new D.$mP("Notebook and input URI",u=>{if(P.debug("[ExtHostInteractive] open iw with notebook editor id",u.notebookEditorId),u.notebookEditorId!==void 0){const k=this.a.getEditorById(u.notebookEditorId);return P.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:b.URI.revive(u.notebookUri),inputUri:b.URI.revive(u.inputUri),notebookEditor:k.apiEditor}}return P.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",u.notebookUri,u.inputUri),{notebookUri:b.URI.revive(u.notebookUri),inputUri:b.URI.revive(u.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,M,$,a){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:M,lines:[""],languageId:$,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,M){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$loc=I}),define(Ce[298],Ie([1,0,18,11,22,4,6,29,2,19,12,5,39,10,7,83,237,25,38,238]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$soc=void 0,e.$toc=p;let s=class{constructor(S,v,E,R,w){this.m=v,this.n=E,this.o=R,this.q=w,this.b=new M.$Ac,this.c=new M.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new T.$he,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=S.getProxy(y.$vM.MainThreadNotebookKernels);const m=new u.$nP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new u.$lP("options","Select kernel options",B=>!0,B=>{if(B&&"notebookEditor"in B&&"id"in B){const X=this.n.getIdByEditor(B.notebookEditor);return{id:B.id,extension:B.extension,notebookEditorId:X}}else if(B&&"notebookEditor"in B){const X=this.n.getIdByEditor(B.notebookEditor);if(X===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${B.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:X}}return B})],u.$mP.Void),N=new u.$nP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[u.$lP.Uri],new u.$mP("A promise that resolves to an array of variables",(B,X)=>B.map(V=>({variable:{name:V.name,value:V.value,expression:V.expression,type:V.type,language:V.language},hasNamedChildren:V.hasNamedChildren,indexedChildrenCount:V.indexedChildrenCount}))));this.o.registerApiCommand(m),this.o.registerApiCommand(N)}createNotebookController(S,v,E,R,w,m){for(const ee of this.j.values())if(ee.controller.id===v&&a.$Xm.equals(S.identifier,ee.extensionId))throw new Error(`notebook controller with id '${v}' ALREADY exist`);const N=this.k++,B=this;this.q.trace(`NotebookController[${N}], CREATED by ${S.identifier.value}, ${v}`);const X=()=>console.warn(`NO execute handler from notebook controller '${F.id}' of extension: '${S.identifier}'`);let V=!1;const O=new T.$he,L=new T.$he,F={id:p(S.identifier,v),notebookType:E,extensionId:S.identifier,extensionLocation:S.extensionLocation,label:R||S.identifier.value,preloads:m?m.map(k.NotebookRendererScript.from):[]};let ie=w??X,de,be;this.a.$addKernel(N,F).catch(ee=>{console.log(ee),V=!0});let ve=0;const Z=()=>{if(V)return;const ee=++ve;Promise.resolve().then(()=>{ee===ve&&this.a.$updateKernel(N,F)})},ae=new M.$Ac,fe={get id(){return v},get notebookType(){return F.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return F.label},set label(ee){F.label=ee??S.displayName??S.name,Z()},get detail(){return F.detail??""},set detail(ee){F.detail=ee,Z()},get description(){return F.description??""},set description(ee){F.description=ee,Z()},get supportedLanguages(){return F.supportedLanguages},set supportedLanguages(ee){F.supportedLanguages=ee,Z()},get supportsExecutionOrder(){return F.supportsExecutionOrder??!1},set supportsExecutionOrder(ee){F.supportsExecutionOrder=ee,Z()},get rendererScripts(){return F.preloads?F.preloads.map(k.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(ee){ie=ee??X},get interruptHandler(){return de},set interruptHandler(ee){de=ee,F.supportsInterrupt=!!ee,Z()},set variableProvider(ee){(0,c.$VG)(S,"notebookVariableProvider"),be=ee,F.hasVariableProvider=!!ee,ee?.onDidChangeVariables(De=>B.a.$variablesUpdated(De.uri)),Z()},get variableProvider(){return be},createNotebookCellExecution(ee){if(V)throw new Error("notebook controller is DISPOSED");if(!ae.has(ee.notebook.uri))throw B.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ee.notebook.uri.toString()}`);return B._createNotebookCellExecution(ee,p(S.identifier,this.id))},createNotebookExecution(ee){if((0,c.$VG)(S,"notebookExecution"),V)throw new Error("notebook controller is DISPOSED");if(!ae.has(ee.uri))throw B.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ae.keys()).map(De=>De.toString())),new Error(`notebook controller is NOT associated to notebook: ${ee.uri.toString()}`);return B._createNotebookExecution(ee,p(S.identifier,this.id))},dispose:()=>{V||(this.q.trace(`NotebookController[${N}], DISPOSED`),V=!0,this.j.delete(N),O.dispose(),L.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(ee,De){De===h.NotebookControllerAffinity2.Hidden&&(0,c.$VG)(S,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(N,ee.uri,De)},onDidReceiveMessage:L.event,postMessage(ee,De){return(0,c.$VG)(S,"notebookMessaging"),B.a.$postMessage(N,De&&B.n.getIdByEditor(De),ee)},asWebviewUri(ee){return(0,c.$VG)(S,"notebookMessaging"),(0,r.$PBb)(ee,B.m.remote)}};return this.j.set(N,{extensionId:S.identifier,controller:fe,onDidReceiveMessage:L,onDidChangeSelection:O,associatedNotebooks:ae}),fe}getIdByController(S){for(const[v,E]of this.j)if(E.controller===S)return p(E.extensionId,S.id);return null}createNotebookControllerDetectionTask(S,v){const E=this.g++,R=this;this.q.trace(`NotebookControllerDetectionTask[${E}], CREATED by ${S.identifier.value}`),this.a.$addKernelDetectionTask(E,v);const w={dispose:()=>{this.f.delete(E),R.a.$removeKernelDetectionTask(E)}};return this.f.set(E,w),w}registerKernelSourceActionProvider(S,v,E){const R=this.i++,w=typeof E.onDidChangeNotebookKernelSourceActions=="function"?R:void 0,m=this;this.h.set(R,E),this.q.trace(`NotebookKernelSourceActionProvider[${R}], CREATED by ${S.identifier.value}`),this.a.$addKernelSourceActionProvider(R,R,v);let N;return w!==void 0&&(N=E.onDidChangeNotebookKernelSourceActions(B=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.h.delete(R),m.a.$removeKernelSourceActionProvider(R,R),N?.dispose()}}}async $provideKernelSourceActions(S,v){const E=this.h.get(S);if(E){const R=new A.$Tc;return(await E.provideNotebookKernelSourceActions(v)??[]).map(m=>k.NotebookKernelSourceAction.from(m,this.o.converter,R))}return[]}$acceptNotebookAssociation(S,v,E){const R=this.j.get(S);if(R){const w=this.n.getNotebookDocument($.URI.revive(v));E?R.associatedNotebooks.set(w.uri,!0):R.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${S}] ASSOCIATE notebook`,w.uri.toString(),E),R.onDidChangeSelection.fire({selected:E,notebook:w.apiNotebook})}}async $executeCells(S,v,E){const R=this.j.get(S);if(!R)return;const w=this.n.getNotebookDocument($.URI.revive(v)),m=[];for(const N of E){const B=w.getCell(N);B&&m.push(B.apiCell)}try{this.q.trace(`NotebookController[${S}] EXECUTE cells`,w.uri.toString(),m.length),await R.controller.executeHandler.call(R.controller,m,w.apiNotebook,R.controller)}catch(N){this.q.error(`NotebookController[${S}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(S,v,E){const R=this.j.get(S);if(!R)return;const w=this.n.getNotebookDocument($.URI.revive(v));if(R.controller.interruptHandler)await R.controller.interruptHandler.call(R.controller,w.apiNotebook);else for(const m of E){const N=w.getCell(m);N&&this.b.get(N.uri)?.cancel()}if(R.controller.interruptHandler){const m=this.c.get(w.uri);this.c.delete(w.uri),E.length&&Array.isArray(m)&&m.length&&m.forEach(N=>N.dispose())}}async $provideVariables(S,v,E,R,w,m,N){const B=this.j.get(S);if(!B)return;const X=this.n.getNotebookDocument($.URI.revive(E)),V=B.controller.variableProvider;if(!V)return;let O;if(R!==void 0){if(O=this.s[R],!O)return}else this.s={};const L=w==="named"?h.NotebookVariablesRequestKind.Named:h.NotebookVariablesRequestKind.Indexed,F=V.provideVariables(X.apiNotebook,O,L,m,N);let ie=0;for await(const de of F){if(N.isCancellationRequested)return;const be={id:this.r++,name:de.variable.name,value:de.variable.value,type:de.variable.type,interfaces:de.variable.interfaces,language:de.variable.language,expression:de.variable.expression,hasNamedChildren:de.hasNamedChildren,indexedChildrenCount:de.indexedChildrenCount,extensionId:B.extensionId.value};if(this.s[be.id]=de.variable,this.a.$receiveVariable(v,be),ie++>=t.$Bjb)return}}$acceptKernelMessageFromRenderer(S,v,E){const R=this.j.get(S);if(!R)return;const w=this.n.getEditorById(v);R.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:E}))}$cellExecutionChanged(S,v,E){const w=this.n.getNotebookDocument($.URI.revive(S)).getCell(v);if(w){const m=E?k.NotebookCellExecutionState.to(E):h.NotebookCellExecutionState.Idle;m!==void 0&&this.l.fire({cell:w.apiCell,state:m})}}_createNotebookCellExecution(S,v){if(S.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const R=this.n.getNotebookDocument(S.notebook.uri).getCellFromApiCell(S);if(!R)throw new Error("invalid cell");if(this.b.has(R.uri))throw new Error(`duplicate execution for ${R.uri}`);const w=new i(v,R,this.a);this.b.set(R.uri,w);const m=w.onDidChangeState(()=>{w.state===n.Resolved&&(w.dispose(),m.dispose(),this.b.delete(R.uri))});return w.asApiObject()}_createNotebookExecution(S,v){const E=this.n.getNotebookDocument(S.uri),R=S.getCells().find(N=>{const B=E.getCellFromApiCell(N);return B&&this.b.has(B.uri)});if(R)throw new Error(`duplicate cell execution for ${R.document.uri}`);if(this.c.has(E.uri))throw new Error(`duplicate notebook execution for ${E.uri}`);const w=new d(v,E,this.a),m=w.onDidChangeState(()=>{w.state===g.Resolved&&(w.dispose(),m.dispose(),this.c.delete(E.uri))});return this.c.set(E.uri,[w,m]),w.asApiObject()}};e.$soc=s,e.$soc=s=Je([qe(4,P.$7j)],s);var n;(function(C){C[C.Init=0]="Init",C[C.Started=1]="Started",C[C.Resolved=2]="Resolved"})(n||(n={}));class i extends A.$Uc{get state(){return this.f}constructor(S,v,E){super(),this.m=v,this.n=E,this.b=i.a++,this.c=new T.$he,this.onDidChangeState=this.c.event,this.f=n.Init,this.g=this.B(new I.$se),this.h=new l(10,R=>this.s(R)),this.j=v.internalMetadata.executionOrder,this.n.$createExecution(this.b,S,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(S){await this.h.addItem(S)}async s(S){const v=Array.isArray(S)?S:[S];return this.n.$updateExecution(this.b,new f.$Lw(v))}t(){if(this.f===n.Init)throw new Error("Must call start before modifying cell output");if(this.f===n.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(S){let v=this.m;if(S&&(v=this.m.notebook.getCellFromApiCell(S)),!v)throw new Error("INVALID cell");return v.handle}y(S){return S.map(v=>{const E=h.$4N.ensureUniqueMimeTypes(v.items,!0);return E===v.items?k.NotebookCellOutput.from(v):k.NotebookCellOutput.from({items:E,id:v.id,metadata:v.metadata})})}async z(S,v,E){const R=this.w(v),w=this.y((0,b.$2b)(S));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:R,append:E,outputs:w})}async C(S,v,E){return S=h.$4N.ensureUniqueMimeTypes((0,b.$2b)(S),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:S.map(k.NotebookCellOutputItem.from),outputId:v.id,append:E})}asApiObject(){const S=this;return Object.freeze({get token(){return S.g.token},get cell(){return S.m.apiCell},get executionOrder(){return S.j},set executionOrder(E){S.j=E,S.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:S.j}])},start(E){if(S.f===n.Resolved||S.f===n.Started)throw new Error("Cannot call start again");S.f=n.Started,S.c.fire(),S.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:E})},end(E,R,w){if(S.f===n.Resolved)throw new Error("Cannot call resolve twice");S.f=n.Resolved,S.c.fire(),S.h.flush();const m=w?{message:w.message,stack:w.stack,location:w?.location?{startLineNumber:w.location.start.line,startColumn:w.location.start.character,endLineNumber:w.location.end.line,endColumn:w.location.end.character}:void 0,uri:w.uri}:void 0;S.n.$completeExecution(S.b,new f.$Lw({runEndTime:R,lastRunSuccess:E,error:m}))},clearOutput(E){return S.t(),S.z([],E,!1)},appendOutput(E,R){return S.t(),S.z(E,R,!0)},replaceOutput(E,R){return S.t(),S.z(E,R,!1)},appendOutputItems(E,R){return S.t(),S.C(E,R,!0)},replaceOutputItems(E,R){return S.t(),S.C(E,R,!1)}})}}i.a=0;var g;(function(C){C[C.Init=0]="Init",C[C.Started=1]="Started",C[C.Resolved=2]="Resolved"})(g||(g={}));class d extends A.$Uc{get state(){return this.f}constructor(S,v,E){super(),this.h=v,this.j=E,this.b=d.a++,this.c=new T.$he,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new I.$se),this.j.$createNotebookExecution(this.b,S,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===g.Resolved||this.f===g.Started)throw new Error("Cannot call start again");this.f=g.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===g.Resolved)throw new Error("Cannot call resolve twice");this.f=g.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}d.a=0;class l{constructor(S,v){this.f=S,this.g=v,this.a=[],this.b=Date.now()}addItem(S){return this.a.push(S),this.c||(this.c=new D.$Xh,this.b=Date.now(),(0,D.$Bh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const S=this.c;this.c=void 0;const v=this.a;return this.a=[],this.g(v).finally(()=>S.complete())}}function p(C,S){return`${C.value}/${S}`}}),define(Ce[57],Ie([1,0,4,5,3,2,17,6,7,187,14,218,22,37,219,220,34,11,10,39,36]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=e.$Fnc=e.$Enc=e.$Dnc=void 0,e.$Dnc=(0,I.$Ai)("IExtHostTerminalService");class n extends M.$Uc{constructor(w,m,N,B){super(),this.u=w,this._id=m,this.w=N,this.y=B,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new b.$he),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const X=this;this.value={get name(){return X.y||""},get processId(){return X.b},get creationOptions(){return X.w},get exitStatus(){return X.j},get state(){return X.m},get selection(){return X.n},get shellIntegration(){return X.shellIntegration},sendText(V,O=!0){X.C(),X.u.$sendText(X._id,V,O)},show(V){X.C(),X.u.$show(X._id,V)},hide(){X.C(),X.u.$hide(X._id)},dispose(){X.a||(X.a=!0,X.u.$dispose(X._id))},get dimensions(){if(!(X.f===void 0||X.h===void 0))return{columns:X.f,rows:X.h}}}}dispose(){this.s.fire(),super.dispose()}async create(w,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??m?.cwd??void 0,env:w.env??void 0,icon:S(w.iconPath)??void 0,color:o.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,forceShellIntegration:m?.forceShellIntegration??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.z(w.location,m?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,m,N,B,X){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:B,color:o.ThemeColor.isThemeColor(X)?X.id:void 0,location:m?.location||this.z(w,N),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(w,m){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in w?{viewColumn:f.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.y=w}setExitStatus(w,m){this.j=Object.freeze({code:w,reason:m})}setDimensions(w,m){return w===this.f&&m===this.h||w===0||m===0?!1:(this.f=w,this.h=m,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(w){this.n=w}_setProcessId(w){this.g?(this.g(w),this.g=void 0):this.b.then(m=>{m!==w&&(this.b=Promise.resolve(w))})}}e.$Enc=n;class i{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new b.$he,this.onProcessData=this.a.event,this.b=new b.$he,this.d=new b.$he,this.onDidChangeProperty=this.d.event,this.f=new b.$he,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,m){this.g.setDimensions?.({columns:w,rows:m})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:h.ProcessPropertyType.OverrideDimensions,value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:h.ProcessPropertyType.Title,value:m})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let g=1,d=class extends M.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,m,N){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new M.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new b.$he,this.onDidCloseTerminal=this.H.event,this.I=new b.$he,this.onDidOpenTerminal=this.I.event,this.J=new b.$he,this.onDidChangeActiveTerminal=this.J.event,this.L=new b.$he,this.onDidChangeTerminalDimensions=this.L.event,this.M=new b.$he,this.onDidChangeTerminalState=this.M.event,this.N=new b.$he,this.onDidChangeShell=this.N.event,this.O=new b.$he({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new b.$he({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=N.getProxy(D.$vM.MainThreadTerminalService),this.y=new r.$bwb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:B=>{const X=V=>{const O=V;return this.getTerminalById(O.instanceId)?.value};switch(B?.$mid){case s.MarshalledId.TerminalContext:return X(B);default:{if(Array.isArray(B))for(let V=0;V<B.length&&B[V].$mid===s.MarshalledId.TerminalContext;V++)B[V]=X(B[V]);return B}}}}),this.B({dispose:()=>{for(const[B,X]of this.g)X.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,m){const N=new n(this.a,(0,k.$Wg)(),w,w.name),B=new i(w.pty);return N.createExtensionTerminal(w.location,m,this.R(w,m).resolvedExtHostIdentifier,S(w.iconPath),v(w.color)).then(X=>{const V=this.S(X,B);this.h[X]=V}),this.f.push(N),N.value}R(w,m){if(m=m||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const N=w.location.parentTerminal;if(N){const B=this.f.find(X=>X.value===N);B&&(m.resolvedExtHostIdentifier=B._id)}}else w.location&&typeof w.location!="object"?m.location=w.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(w,m){if(!this.getTerminalById(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const B=new i(m),X=this.S(w,B);this.h[w]=X}async $acceptActiveTerminalChanged(w){const m=this.b;if(w===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const N=this.getTerminalById(w);N&&(this.b=N,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,m){const N=this.getTerminalById(w);N&&this.O.fire({terminal:N.value,data:m})}async $acceptTerminalDimensions(w,m,N){const B=this.getTerminalById(w);B&&B.setDimensions(m,N)&&this.L.fire({terminal:B.value,dimensions:B.value.dimensions})}async $acceptDidExecuteCommand(w,m){const N=this.getTerminalById(w);N&&this.P.fire({terminal:N.value,...m})}async $acceptTerminalMaximumDimensions(w,m,N){this.g.get(w)?.resize(m,N)}async $acceptTerminalTitleChange(w,m){const N=this.getTerminalById(w);N&&(N.name=m)}async $acceptTerminalClosed(w,m,N){const B=this.X(this.f,w);if(B!==null){const X=this.f.splice(B,1)[0];X.setExitStatus(m,N),this.H.fire(X.value)}}$acceptTerminalOpened(w,m,N,B){if(m){const O=this.X(this.f,m);if(O!==null){this.f[O]._id=w,this.I.fire(this.terminals[O]),this.f[O].isOpen=!0;return}}const X={name:B.name,shellPath:B.executable,shellArgs:B.args,cwd:typeof B.cwd=="string"?B.cwd:T.URI.revive(B.cwd),env:B.env,hideFromUser:B.hideFromUser},V=new n(this.a,w,X,N);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(w,m){this.getTerminalById(w)?._setProcessId(m)}async $startExtensionTerminal(w,m){const N=this.getTerminalById(w);if(!N)return{message:(0,a.localize)(0,null,w)};N.isOpen||await new Promise(X=>{const V=this.onDidOpenTerminal(async O=>{O===N.value&&(V.dispose(),X())})});const B=this.g.get(w);B?B.startSendingEvents(m):this.j[w]={initialDimensions:m}}S(w,m){const N=new M.$Tc;N.add(m.onProcessReady(X=>this.a.$sendProcessReady(w,X.pid,X.cwd,X.windowsPty))),N.add(m.onDidChangeProperty(X=>this.a.$sendProcessProperty(w,X))),this.y.startBuffering(w,m.onProcessData),N.add(m.onProcessExit(X=>this.U(w,X))),this.g.set(w,m);const B=this.j[w];return B&&m instanceof i&&(m.startSendingEvents(B.initialDimensions),delete this.j[w]),N}$acceptProcessAckDataEvent(w,m){this.g.get(w)?.acknowledgeDataEvent(m)}$acceptProcessInput(w,m){this.g.get(w)?.input(m)}$acceptTerminalInteraction(w){const m=this.getTerminalById(w);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(w,m){this.getTerminalById(w)?.setSelection(m)}$acceptProcessResize(w,m,N){try{this.g.get(w)?.resize(m,N)}catch(B){if(B.code!=="EPIPE"&&B.code!=="ERR_IPC_CHANNEL_CLOSED")throw B}}$acceptProcessShutdown(w,m){this.g.get(w)?.shutdown(m)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(w,{type:h.ProcessPropertyType.InitialCwd,value:m}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(m=>this.a.$sendProcessProperty(w,{type:h.ProcessPropertyType.Cwd,value:m}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new $.$xM(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,m,N){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,N),this.a.$registerProfileProvider(m,w.identifier.value),new $.$xM(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(w,m,N){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,N),this.a.$registerQuickFixProvider(w,m),new $.$xM(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,m){const N=new u.$se().token;if(N.isCancellationRequested)return;const B=this.D.get(w);if(!B)return;const X=await B.provideTerminalQuickFixes(m,N);if(X===null||Array.isArray(X)&&X.length===0)return;const V=new M.$Tc;if(this.w.value=V,!Array.isArray(X))return X?f.TerminalQuickFix.from(X,this.Q.converter,V):void 0;const O=[];for(const L of X){const F=f.TerminalQuickFix.from(L,this.Q.converter,V);F&&O.push(F)}return O}async $createContributedProfileTerminal(w,m){const N=new u.$se().token;let B=await this.C.get(w)?.provideTerminalProfile(N);if(!N.isCancellationRequested){if(B&&!("options"in B)&&(B={options:B}),!B||!("options"in B))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in B.options){this.createExtensionTerminal(B.options,m);return}this.createTerminalFromOptions(B.options,m)}}async $provideLinks(w,m){const N=this.getTerminalById(w);if(!N)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const X=new u.$se;this.G.set(w,X);const V=[],O={terminal:N.value,line:m},L=[];for(const de of this.z)L.push(c.Promises.withAsyncBody(async be=>{X.token.onCancellationRequested(()=>be({provider:de,links:[]}));const ve=await de.provideTerminalLinks(O,X.token)||[];X.token.isCancellationRequested||be({provider:de,links:ve})}));const F=await Promise.all(L);if(X.token.isCancellationRequested)return[];const ie=new Map;for(const de of F)de&&de.links.length>0&&V.push(...de.links.map(be=>{const ve={id:g++,startIndex:be.startIndex,length:be.length,label:be.tooltip};return ie.set(ve.id,{provider:de.provider,link:be}),ve}));return this.F.set(w,ie),V}$activateLink(w,m){const N=this.F.get(w)?.get(m);N&&N.provider.handleTerminalLink(N.link)}U(w,m){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const N=this.h[w];N&&(N.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,m)}getTerminalById(w){return this.W(this.f,w)}getTerminalIdByApiObject(w){const m=this.f.findIndex(N=>N.value===w);return m>=0?m:null}W(w,m){const N=this.X(w,m);return N!==null?w[N]:null}X(w,m){const N=w.findIndex(B=>B._id===m);return N>=0?N:null}getEnvironmentVariableCollection(w){let m=this.n.get(w.identifier.value);return m||(m=new l,this.Z(w.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Y(w,m){const N=(0,y.$us)(m.map),B=(0,y.$vs)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(w,m.persistent,N.length===0?void 0:N,B)}$initEnvironmentVariableCollections(w){w.forEach(m=>{const N=m[0],B=new l(m[1]);this.Z(N,B)})}$acceptDefaultProfile(w,m){const N=this.s;this.s=w,this.u=m,N?.path!==w.path&&this.N.fire(w.path)}Z(w,m){this.n.set(w,m),m.onDidChangeCollection(()=>{this.Y(w,m)})}};e.$Fnc=d,e.$Fnc=d=Je([qe(1,t.$jP),qe(2,A.$ZO)],d);class l{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new b.$he,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const m=this.h(w);let N=this.a.get(m);return N||(N=new p(this,w),this.a.set(m,N),N.onDidChangeCollection(()=>this.d.fire())),N}replace(w,m,N,B){this.f(w,{value:m,type:$.EnvironmentVariableMutatorType.Replace,options:N??{applyAtProcessCreation:!0},scope:B})}append(w,m,N,B){this.f(w,{value:m,type:$.EnvironmentVariableMutatorType.Append,options:N??{applyAtProcessCreation:!0},scope:B})}prepend(w,m,N,B){this.f(w,{value:m,type:$.EnvironmentVariableMutatorType.Prepend,options:N??{applyAtProcessCreation:!0},scope:B})}f(w,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const N=this.g(w,m.scope),B=this.map.get(N),X=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!B||B.value!==m.value||B.type!==m.type||B.options?.applyAtProcessCreation!==X.applyAtProcessCreation||B.options?.applyAtShellIntegration!==X.applyAtShellIntegration||B.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const V=this.g(w,m.scope),O={variable:w,...m,options:X};this.map.set(V,O),this.d.fire()}}get(w,m){const N=this.g(w,m),B=this.map.get(N);return B?E(B):void 0}g(w,m){const N=this.h(m);return N.length?`${w}:::${N}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const m=new Map;for(const[N,B]of this.map)this.h(B.scope)===this.h(w)&&m.set(B.variable,E(B));return m}delete(w,m){const N=this.g(w,m);this.map.delete(N),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[m,N]of this.map)N.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(m);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,m){const N=this.h(m),B=this.descriptionMap.get(N);if(!B||B.description!==w){let X;typeof w=="string"?X=w:X=w?.value.split(`

`)[0];const V={description:X,scope:m};this.descriptionMap.set(N,V),this.d.fire()}}getDescription(w){const m=this.h(w);return this.descriptionMap.get(m)?.description}k(w){const m=this.h(w);this.descriptionMap.delete(m)}}class p{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,m){this.b=w,this.d=m,this.a=new b.$he}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,m,N){this.b.replace(w,m,N,this.d)}append(w,m,N){this.b.append(w,m,N,this.d)}prepend(w,m,N){this.b.prepend(w,m,N,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,m){this.b.getVariableMap(this.d).forEach((N,B)=>w.call(m,B,N,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let C=class extends d{constructor(w,m){super(!1,w,m)}createTerminal(w,m,N){throw new P.$_}createTerminalFromOptions(w,m){throw new P.$_}};e.$Gnc=C,e.$Gnc=C=Je([qe(0,t.$jP),qe(1,A.$ZO)],C);function S(R){if(!(!R||typeof R=="string"))return"id"in R?{id:R.id,color:R.color}:R}function v(R){return o.ThemeColor.isThemeColor(R)?R:void 0}function E(R){const w={...R};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(Ce[124],Ie([1,0,7,6,3,5,17,57,4,2,11]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Loc=e.$Koc=void 0,e.$Koc=(0,I.$Ai)("IExtHostTerminalShellIntegration");let y=class extends D.$Uc{constructor(o,c){super(),this.h=c,this.b=new Map,this.c=new $.$he,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new $.$he,this.onDidStartTerminalShellExecution=this.f.event,this.g=new $.$he,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(T.$vM.MainThreadTerminalShellIntegration),this.B((0,D.$Sc)(()=>{for(const[f,t]of this.b)t.dispose();this.b.clear()}))}$shellIntegrationChange(o){const c=this.h.getTerminalById(o);if(!c)return;const f=c.value;let t=this.b.get(o);t||(t=new u(c.value,this.f),this.b.set(o,t),t.store.add(c.onWillDispose(()=>this.b.get(o)?.dispose())),t.store.add(t.onDidRequestShellExecution(s=>this.a.$executeCommand(o,s))),t.store.add(t.onDidRequestEndExecution(s=>this.g.fire(s))),t.store.add(t.onDidRequestChangeShellIntegration(s=>this.c.fire(s))),c.shellIntegration=t.value),this.c.fire({terminal:f,shellIntegration:t.value})}$shellExecutionStart(o,c,f,t,s){this.b.has(o)||this.$shellIntegrationChange(o);const n={value:c,confidence:f,isTrusted:t};this.b.get(o)?.startShellExecution(n,s)}$shellExecutionEnd(o,c,f,t,s){const n={value:c,confidence:f,isTrusted:t};this.b.get(o)?.endShellExecution(n,s)}$shellExecutionData(o,c){this.b.get(o)?.emitData(c)}$cwdChange(o,c){this.b.get(o)?.setCwd((0,a.$vc)(c)?a.URI.revive(c):c)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$Loc=y,e.$Loc=y=Je([qe(0,A.$ZO),qe(1,M.$Dnc)],y);class u extends D.$Uc{get currentExecution(){return this.a}constructor(o,c){super(),this.j=o,this.m=c,this.b=!1,this.store=this.B(new D.$Tc),this.f=this.B(new $.$he),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new $.$he),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new $.$he),this.onDidRequestEndExecution=this.h.event;const f=this;this.value={get cwd(){return f.c},executeCommand(t,s){let n=t;s&&(n+=` "${s.map(d=>`${d.replaceAll('"','\\"')}`).join('" "')}"`),f.g.fire(n);const i={value:n,confidence:b.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},g=f.startShellExecution(i,f.c,!0).value;return f.b=!0,g}}}startShellExecution(o,c,f){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const t=this.a=new k(o,c);f?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:t.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,c){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(o){let c=!1;a.URI.isUri(this.c)?c=!a.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(c=!0),c&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class k{constructor(o,c){this.c=o,this.cwd=c,this.b=!1;const f=this;this.value={get commandLine(){return f.c},get cwd(){return f.cwd},read(){return f.d()}}}d(){if(!this.a){if(this.b)return P.$1h.EMPTY;this.a=new h}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class h extends D.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new P.$zh);const o=this.a;return new P.$1h(async f=>{this.b.push(f),await o.wait()})}emitData(o){for(const c of this.b)c.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}});var Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)},tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b};define(Ce[299],Ie([1,0,11,23,22,4,272,76,6,36,15,37,12,5,17,123,10,7,240,55,82,56,25]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s,n,i){"use strict";var g,d,l,p,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Poc=e.$Ooc=e.$Noc=e.$Moc=void 0;let S=0;const v=new WeakMap;let E=class extends $.$Uc{constructor(Z,ae,fe,ee){super(),this.C=ae,this.D=fe,this.F=ee,this.f=this.B(new T.$he),this.g=new Map,this.w=this.B(new T.$he),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=Z.getProxy(k.$vM.MainThreadTesting),this.m=new L(this.h),this.j=new N(this.h,ae),fe.registerArgumentProcessor({processArgument:De=>{switch(De?.$mid){case a.MarshalledId.TestItemContext:{const Fe=De,ce=Fe.tests[Fe.tests.length-1].item.extId;return this.g.get(t.$hL.root(ce))?.collection.tree.get(ce)?.actual??(0,r.$_O)(De)}case a.MarshalledId.TestMessageMenuArgs:{const{test:Fe,message:ce}=De,H=Fe.item.extId;return{test:this.g.get(t.$hL.root(H))?.collection.tree.get(H)?.actual??(0,r.$_O)({$mid:a.MarshalledId.TestItemContext,tests:[Fe]}),message:o.TestMessage.to(ce)}}default:return De}}}),fe.registerCommand(!1,"testing.getExplorerSelection",async()=>{const De=await fe.executeCommand(f.TestCommandId.GetExplorerSelection),Fe=ce=>{const H=this.g.get(t.$hL.root(ce));if(H)return t.$hL.isRoot(ce)?H.controller:H.collection.tree.get(ce)?.actual};return{include:De?.include.map(Fe).filter(P.$ig)||[],exclude:De?.exclude.map(Fe).filter(P.$ig)||[]}})}createTestController(Z,ae,fe,ee){if(this.g.has(ae))throw new Error(`Attempt to insert a duplicate controller with ID "${ae}"`);const De=new $.$Tc,Fe=De.add(new r.$cP(ae,fe,this.F));Fe.root.label=fe;const ce=new Map,H=new Set,he=this.h,le={items:Fe.root.children,get label(){return fe},set label(ue){fe=ue,Fe.root.label=ue,he.$updateController(ae,{label:fe})},get refreshHandler(){return ee},set refreshHandler(ue){ee=ue,he.$updateController(ae,{canRefresh:!!ue})},get id(){return ae},createRunProfile:(ue,oe,J,Y,we,pe)=>{let Me=(0,M.$oj)(ue);for(;ce.has(Me);)Me++;return new ie(this.h,ce,H,this.w.event,ae,Me,ue,oe,J,Y,we,pe)},createTestItem(ue,oe,J){return new r.$aP(ae,ue,oe,J)},createTestRun:(ue,oe,J=!0)=>this.j.createTestRun(Z,ae,Fe,ue,oe,J),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const oe=ue instanceof Array?ue:[ue];this.h.$markTestRetired(oe.map(J=>t.$hL.fromExtHostTestItem(J,ae).toString()))}},set resolveHandler(ue){Fe.resolveHandler=ue},get resolveHandler(){return Fe.resolveHandler},dispose:()=>{De.dispose()}};he.$registerTestController(ae,fe,!!ee),De.add((0,$.$Sc)(()=>he.$unregisterTestController(ae)));const re={controller:le,collection:Fe,profiles:ce,extension:Z,activeProfiles:H};return this.g.set(ae,re),De.add((0,$.$Sc)(()=>this.g.delete(ae))),De.add(Fe.onDidGenerateDiff(ue=>he.$publishDiff(ae,ue.map(n.TestsDiffOp.serialize)))),le}createTestObserver(){return this.m.checkout()}async runTests(Z,ae=I.CancellationToken.None){const fe=B(Z);if(!fe)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const ee=this.g.get(fe.controllerId);if(!ee)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:Z.preserveFocus??!0,targets:[{testIds:Z.include?.map(De=>t.$hL.fromExtHostTestItem(De,ee.collection.root.id).toString())??[ee.collection.root.id],profileGroup:de[fe.kind],profileId:fe.profileId,controllerId:fe.controllerId}],exclude:Z.exclude?.map(De=>De.id)},ae)}registerTestFollowupProvider(Z){return this.y.add(Z),{dispose:()=>{this.y.delete(Z)}}}$syncTests(){for(const{collection:Z}of this.g.values())Z.flushDiff();return Promise.resolve()}async $getCoverageDetails(Z,ae){return(await this.j.getCoverageDetails(Z,ae))?.map(o.TestCoverage.fromDetails)}async $disposeRun(Z){this.j.disposeTestRun(Z)}$configureRunProfile(Z,ae){this.g.get(Z)?.profiles.get(ae)?.configureHandler?.()}$setDefaultRunProfiles(Z){const ae=new Map;for(const[fe,ee]of Object.entries(Z)){const De=this.g.get(fe);if(!De)continue;const Fe=new Map,ce=ee.filter(he=>!De.activeProfiles.has(he)),H=[...De.activeProfiles].filter(he=>!ee.includes(he));for(const he of ce)Fe.set(he,!0),De.activeProfiles.add(he);for(const he of H)Fe.set(he,!1),De.activeProfiles.delete(he);Fe.size&&ae.set(fe,Fe)}this.w.fire(ae)}async $refreshTests(Z,ae){await this.g.get(Z)?.controller.refreshHandler?.(ae)}$publishTestResults(Z){this.results=Object.freeze(Z.map(ae=>{const fe=o.TestResults.to(ae);return v.set(fe,ae.id),fe}).concat(this.results).sort((ae,fe)=>fe.completedAt-ae.completedAt).slice(0,32)),this.f.fire()}async $expandTest(Z,ae){const fe=this.g.get(t.$hL.fromString(Z).controllerId)?.collection;fe&&(await fe.expand(Z,ae<0?1/0:ae),fe.flushDiff())}$acceptDiff(Z){this.m.applyDiff(Z.map(ae=>n.TestsDiffOp.deserialize({asCanonicalUri:fe=>fe},ae)))}async $runControllerTests(Z,ae){return Promise.all(Z.map(fe=>this.G(fe,!1,ae)))}async $startContinuousRun(Z,ae){const fe=new I.$se(ae),ee=await Promise.all(Z.map(De=>this.G(De,!0,fe.token)));return!ae.isCancellationRequested&&!ee.some(De=>De.error)&&await new Promise(De=>ae.onCancellationRequested(De)),fe.dispose(!0),ee}async $provideTestFollowups(Z,ae){const fe=this.results.find(Fe=>v.get(Fe)===Z.resultId),ee=fe&&be(t.$hL.fromString(Z.extId),fe?.results);if(!ee)return[];let De=[];return await Promise.all([...this.y].map(async Fe=>{try{const ce=await Fe.provideFollowup(fe,ee,Z.taskIndex,Z.messageIndex,ae);ce&&(De=De.concat(ce))}catch(ce){this.C.error("Error thrown while providing followup for test message",ce)}})),ae.isCancellationRequested?[]:De.map(Fe=>{const ce=S++;return this.z.set(ce,Fe),{title:Fe.title,id:ce}})}$disposeTestFollowups(Z){for(const ae of Z)this.z.delete(ae)}$executeTestFollowup(Z){const ae=this.z.get(Z);return ae?this.D.executeCommand(ae.command,...ae.arguments||[]):Promise.resolve()}async G(Z,ae,fe){const ee=this.g.get(Z.controllerId);if(!ee)return{};const{collection:De,profiles:Fe,extension:ce}=ee,H=Fe.get(Z.profileId);if(!H)return{};const he=Z.testIds.map(oe=>De.tree.get(oe)).filter(P.$ig),le=Z.excludeExtIds.map(oe=>ee.collection.tree.get(oe)).filter(P.$ig).filter(oe=>he.some(J=>J.fullId.compare(oe.fullId)===t.TestPosition.IsChild));if(!he.length)return{};const re=new c.$$N(he.some(oe=>oe.actual instanceof r.$bP)?void 0:he.map(oe=>oe.actual),le.map(oe=>oe.actual),H,ae),ue=(0,n.$kL)(Z)&&this.j.prepareForMainThreadTestRun(ce,re,X.fromInternal(Z,ee.collection),H,fe);try{return await H.runHandler(re,fe),{}}catch(oe){return{error:String(oe)}}finally{ue&&ue.hasRunningTasks&&!fe.isCancellationRequested&&await T.Event.toPromise(ue.onEnd)}}$cancelExtensionTestRun(Z){Z===void 0?this.j.cancelAllRuns():this.j.cancelRunById(Z)}};e.$Moc=E,e.$Moc=E=Je([qe(0,h.$ZO),qe(1,u.$7j)],E);const R=1e4;var w;(function(ve){ve[ve.Running=0]="Running",ve[ve.Cancelling=1]="Cancelling",ve[ve.Ended=2]="Ended"})(w||(w={}));class m extends $.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.z.id}constructor(Z,ae,fe,ee,De,Fe){super(),this.z=Z,this.C=ae,this.D=fe,this.F=ee,this.G=De,this.c=w.Running,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new T.$he),this.y=new Map,this.onEnd=this.m.event,this.j=this.B(new I.$se(Fe));const ce=this.B(new b.$Mh(()=>this.H(),R));this.B(this.j.token.onCancellationRequested(()=>ce.schedule()));const H=new T.$he;this.w=H.event,this.B((0,$.$Sc)(()=>{H.fire(),H.dispose()}))}cancel(){this.c===w.Running?(this.j.cancel(),this.c=w.Cancelling):this.c===w.Cancelling&&this.H()}getCoverageDetails(Z,ae){const[,fe]=t.$hL.fromString(Z).path,ee=this.y.get(Z);if(!ee)return[];const De=this.g.get(fe);if(!De)throw new Error("unreachable: run task was not found");return this.F?.loadDetailedCoverage?.(De.run,ee,ae)??[]}createRun(Z){const ae=this.z.id,fe=this.z.controllerId,ee=(0,y.$Wg)(),De=le=>(re,...ue)=>{if(ce){this.D.warn(`Setting the state of test "${re.id}" is a no-op after the run ends.`);return}this.z.isIncluded(re)&&(this.J(re),le(re,...ue))},Fe=(le,re)=>{const ue=re instanceof Array?re.map(o.TestMessage.from):[o.TestMessage.from(re)];if(le.uri&&le.range){const oe={range:o.Range.from(le.range),uri:le.uri};for(const J of ue)J.location=J.location||oe}this.C.$appendTestMessagesInRun(ae,ee,t.$hL.fromExtHostTestItem(le,fe).toString(),ue)};let ce=!1;const H=new Map,he={isPersisted:this.z.isPersisted,token:this.j.token,name:Z,onDidDispose:this.w,addCoverage:le=>{if(ce)return;const re=le instanceof c.$dO?le.testItem:void 0;let ue;if(re){if((0,i.$VG)(this.G,"attributableCoverage"),!this.z.isIncluded(re))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.J(re),ue=H.get(re),ue===void 0&&(ue=H.size,H.set(re,ue))}const oe=le.uri.toString(),J=new t.$hL(ue!==void 0?[ae,ee,oe,String(ue)]:[ae,ee,oe]).toString();this.y.set(J,le),this.C.$appendCoverage(ae,ee,o.TestCoverage.fromFile(fe,J,le))},enqueued:De(le=>{this.C.$updateTestStateInRun(ae,ee,t.$hL.fromExtHostTestItem(le,fe).toString(),n.TestResultState.Queued)}),skipped:De(le=>{this.C.$updateTestStateInRun(ae,ee,t.$hL.fromExtHostTestItem(le,fe).toString(),n.TestResultState.Skipped)}),started:De(le=>{this.C.$updateTestStateInRun(ae,ee,t.$hL.fromExtHostTestItem(le,fe).toString(),n.TestResultState.Running)}),errored:De((le,re,ue)=>{Fe(le,re),this.C.$updateTestStateInRun(ae,ee,t.$hL.fromExtHostTestItem(le,fe).toString(),n.TestResultState.Errored,ue)}),failed:De((le,re,ue)=>{Fe(le,re),this.C.$updateTestStateInRun(ae,ee,t.$hL.fromExtHostTestItem(le,fe).toString(),n.TestResultState.Failed,ue)}),passed:De((le,re)=>{this.C.$updateTestStateInRun(ae,ee,t.$hL.fromExtHostTestItem(le,this.z.controllerId).toString(),n.TestResultState.Passed,re)}),appendOutput:(le,re,ue)=>{ce||(ue&&(this.z.isIncluded(ue)?this.J(ue):ue=void 0),this.C.$appendOutputToRun(ae,ee,D.$Je.fromString(le),re&&o.location.from(re),ue&&t.$hL.fromExtHostTestItem(ue,fe).toString()))},end:()=>{ce||(ce=!0,H.clear(),this.C.$finishedTestRunTask(ae,ee),--this.f||this.I())}};return this.f++,this.g.set(ee,{run:he}),this.C.$startedTestRunTask(ae,{id:ee,name:Z,running:!0}),he}H(){for(const{run:Z}of this.g.values())Z.end()}I(){this.c!==w.Ended&&(this.c=w.Ended,this.m.fire())}J(Z){if(!(Z instanceof r.$aP))throw new s.$RO(Z.id);if(this.h.has(t.$hL.fromExtHostTestItem(Z,this.z.controllerId).toString()))return;const ae=[],fe=this.z.colllection.root;for(;;){const ee=o.TestItem.from(Z);if(ae.unshift(ee),this.h.has(ee.extId)||(this.h.add(ee.extId),Z===fe))break;Z=Z.parent||fe}this.C.$addTestsToRun(this.z.controllerId,this.z.id,ae)}dispose(){this.I(),super.dispose()}}class N{get trackers(){return this.c.values()}constructor(Z,ae){this.g=Z,this.h=ae,this.c=new Map,this.f=new Map}getCoverageDetails(Z,ae){const fe=t.$hL.root(Z);return this.f.get(fe)?.getCoverageDetails(Z,ae)||[]}disposeTestRun(Z){this.f.get(Z)?.dispose(),this.f.delete(Z);for(const[ae,{id:fe}]of this.c)fe===Z&&this.c.delete(ae)}prepareForMainThreadTestRun(Z,ae,fe,ee,De){return this.j(ae,fe,ee,Z,De)}cancelRunById(Z){this.f.get(Z)?.cancel()}cancelAllRuns(){for(const Z of this.c.values())Z.cancel()}createTestRun(Z,ae,fe,ee,De,Fe){const ce=this.c.get(ee);if(ce)return ce.createRun(De);const H=X.fromPublic(ae,fe,ee,Fe),he=B(ee);this.g.$startedExtensionTestRun({controllerId:ae,continuous:!!ee.continuous,profile:he&&{group:de[he.kind],id:he.profileId},exclude:ee.exclude?.map(re=>t.$hL.fromExtHostTestItem(re,fe.root.id).toString())??[],id:H.id,include:ee.include?.map(re=>t.$hL.fromExtHostTestItem(re,fe.root.id).toString())??[fe.root.id],preserveFocus:ee.preserveFocus??!0,persist:Fe});const le=this.j(ee,H,ee.profile,Z);return T.Event.once(le.onEnd)(()=>{this.g.$finishedExtensionTestRun(H.id)}),le.createRun(De)}j(Z,ae,fe,ee,De){const Fe=new m(ae,this.g,this.h,fe,ee,De);return this.c.set(Z,Fe),this.f.set(Fe.id,Fe),Fe}}e.$Noc=N;const B=ve=>{if(ve.profile){if(!(ve.profile instanceof ie))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return ve.profile}};class X{static fromPublic(Z,ae,fe,ee){return new X(Z,(0,y.$Wg)(),fe.include?.map(De=>t.$hL.fromExtHostTestItem(De,Z).toString())??[Z],fe.exclude?.map(De=>t.$hL.fromExtHostTestItem(De,Z).toString())??[],ee,ae)}static fromInternal(Z,ae){return new X(Z.controllerId,Z.runId,Z.testIds,Z.excludeExtIds,!0,ae)}constructor(Z,ae,fe,ee,De,Fe){this.controllerId=Z,this.id=ae,this.isPersisted=De,this.colllection=Fe,this.c=fe.map(ce=>ce+t.TestIdPathParts.Delimiter),this.f=ee.map(ce=>ce+t.TestIdPathParts.Delimiter)}isIncluded(Z){const ae=t.$hL.fromExtHostTestItem(Z,this.controllerId).toString()+t.TestIdPathParts.Delimiter;for(const fe of this.f)if(ae===fe||ae.startsWith(fe))return!1;for(const fe of this.c)if(ae===fe||ae.startsWith(fe))return!0;return!1}}e.$Ooc=X;class V{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(Z){this.j=Z,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(Z){this.c.add(Z)}update(Z){Object.assign(Z.revived,o.TestItem.toPlain(Z.item)),this.c.has(Z)||this.f.add(Z)}remove(Z){if(this.c.has(Z)){this.c.delete(Z);return}this.f.delete(Z);const ae=t.$hL.parentId(Z.item.extId);if(ae&&this.h.has(ae.toString())){this.h.add(Z.item.extId);return}this.g.add(Z)}getChangeEvent(){const{c:Z,f:ae,g:fe}=this;return{get added(){return[...Z].map(ee=>ee.revived)},get updated(){return[...ae].map(ee=>ee.revived)},get removed(){return[...fe].map(ee=>ee.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class O extends n.$qL{constructor(){super(...arguments),this.y=new T.$he,this.onDidChangeTests=this.y.event}get rootTests(){return this.g}getMirroredTestDataById(Z){return this.f.get(Z)}getMirroredTestDataByReference(Z){return this.f.get(Z.id)}x(Z,ae){return{...Z,revived:o.TestItem.toPlain(Z.item),depth:ae?ae.depth+1:0,children:new Set}}w(){return new V(this.y)}}class L{constructor(Z){this.f=Z}checkout(){this.c||(this.c=this.g());const Z=this.c;return Z.observers++,{onDidChangeTest:Z.tests.onDidChangeTests,get tests(){return[...Z.tests.rootTests].map(ae=>ae.revived)},dispose:(0,A.$db)(()=>{--Z.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(Z){return this.c?.tests.getMirroredTestDataByReference(Z)}applyDiff(Z){this.c?.tests.apply(Z)}g(){const Z=new O({asCanonicalUri:ae=>ae});return this.f.$subscribeToDiffs(),{observers:0,tests:Z}}}const F=(ve,Z,ae,fe)=>{ae?Object.assign(ae,fe):Z.$updateTestRunConfig(ve.controllerId,ve.profileId,fe)};class ie{get label(){return this.f}set label(Z){Z!==this.f&&(this.f=Z,F(this,Be(this,g,"f"),Be(this,p,"f"),{label:Z}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(Z){Z!==this.g&&(this.g=Z,F(this,Be(this,g,"f"),Be(this,p,"f"),{supportsContinuousRun:Z}))}get isDefault(){return Be(this,d,"f").has(this.profileId)}set isDefault(Z){Z!==this.isDefault&&(Z?Be(this,d,"f").add(this.profileId):Be(this,d,"f").delete(this.profileId),F(this,Be(this,g,"f"),Be(this,p,"f"),{isDefault:Z}))}get tag(){return this._tag}set tag(Z){Z?.id!==this._tag?.id&&(this._tag=Z,F(this,Be(this,g,"f"),Be(this,p,"f"),{tag:Z?o.TestTag.namespace(this.controllerId,Z.id):null}))}get configureHandler(){return this.c}set configureHandler(Z){Z!==this.c&&(this.c=Z,F(this,Be(this,g,"f"),Be(this,p,"f"),{hasConfigurationHandler:!!Z}))}get onDidChangeDefault(){return T.Event.chain(Be(this,l,"f"),Z=>Z.map(ae=>ae.get(this.controllerId)?.get(this.profileId)).filter(P.$ig))}constructor(Z,ae,fe,ee,De,Fe,ce,H,he,le=!1,re=void 0,ue=!1){this.controllerId=De,this.profileId=Fe,this.f=ce,this.kind=H,this.runHandler=he,this._tag=re,this.g=ue,g.set(this,void 0),d.set(this,void 0),l.set(this,void 0),p.set(this,void 0),C.set(this,void 0),tt(this,g,Z,"f"),tt(this,C,ae,"f"),tt(this,d,fe,"f"),tt(this,l,ee,"f"),ae.set(Fe,this);const oe=de[H];if(typeof oe!="number")throw new Error(`Unknown TestRunProfile.group ${H}`);le&&fe.add(Fe),tt(this,p,{profileId:Fe,controllerId:De,tag:re?o.TestTag.namespace(this.controllerId,re.id):null,label:ce,group:oe,isDefault:le,hasConfigurationHandler:!1,supportsContinuousRun:ue},"f"),queueMicrotask(()=>{Be(this,p,"f")&&(Be(this,g,"f").$publishTestRunProfile(Be(this,p,"f")),tt(this,p,void 0,"f"))})}dispose(){Be(this,C,"f")?.delete(this.profileId)&&(tt(this,C,void 0,"f"),Be(this,g,"f").$removeTestProfile(this.controllerId,this.profileId)),tt(this,p,void 0,"f")}}e.$Poc=ie,g=new WeakMap,d=new WeakMap,l=new WeakMap,p=new WeakMap,C=new WeakMap;const de={[c.TestRunProfileKind.Coverage]:n.TestRunProfileBitset.Coverage,[c.TestRunProfileKind.Debug]:n.TestRunProfileBitset.Debug,[c.TestRunProfileKind.Run]:n.TestRunProfileBitset.Run};function be(ve,Z){for(let ae=0;ae<ve.path.length;ae++){const fe=Z.find(ee=>ee.id===ve.path[ae]);if(!fe)return;if(ae===ve.path.length-1)return fe;Z=fe.children}}}),define(Ce[125],Ie([1,0,61,14,96,10,7]),function(_,e,b,D,I,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9O=e.$8O=e.$7O=void 0;class M{constructor(u,k,h){const r=M.c.nextId();u.$registerTextEditorDecorationType(k.identifier,r,T.DecorationRenderOptions.from(h)),this.value=Object.freeze({key:r,dispose(){u.$removeTextEditorDecorationType(r)}})}}e.$7O=M,M.c=new I.$5O("TextEditorDecorationType");class ${constructor(u,k){this.g=[],this.h=void 0,this.j=!1,this.c=u,this.d=u.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(u,k){this.k();let h=null;if(u instanceof A.$yM)h=new A.$zM(u,u);else if(u instanceof A.$zM)h=u;else throw new Error("Unrecognized location");this.l(h,k,!1)}insert(u,k){this.k(),this.l(new A.$zM(u,u),k,!0)}delete(u){this.k();let k=null;if(u instanceof A.$zM)k=u;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(u,k,h){const r=this.c.validateRange(u);this.g.push({range:r,text:k,forceMoveMarkers:h})}setEndOfLine(u){if(this.k(),u!==A.EndOfLine.LF&&u!==A.EndOfLine.CRLF)throw(0,D.$7)("endOfLine");this.h=u}}class a{constructor(u,k,h,r){this.c=u,this.d=k,this._accept(h),this.e=r;const o=this;this.value={get tabSize(){return o.f},set tabSize(c){o.n(c)},get indentSize(){return o.g},set indentSize(c){o.p(c)},get insertSpaces(){return o.j},set insertSpaces(c){o.s(c)},get cursorStyle(){return o.k},set cursorStyle(c){o.t(c)},get lineNumbers(){return o.l},set lineNumbers(c){o.u(c)}}}_accept(u){this.f=u.tabSize,this.g=u.indentSize,this.h=u.originalIndentSize,this.j=u.insertSpaces,this.k=u.cursorStyle,this.l=T.TextEditorLineNumbersStyle.to(u.lineNumbers)}m(u){if(u==="auto")return"auto";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}n(u){const k=this.m(u);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}o(u){if(u==="tabSize")return"tabSize";if(typeof u=="number"){const k=Math.floor(u);return k>0?k:null}if(typeof u=="string"){const k=parseInt(u,10);return isNaN(k)?null:k>0?k:null}return null}p(u){const k=this.o(u);if(k!==null){if(typeof k=="number"){if(this.h===k)return;this.g=k,this.h=k}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}q(u){return u==="auto"?"auto":u==="false"?!1:!!u}s(u){const k=this.q(u);if(typeof k=="boolean"){if(this.j===k)return;this.j=k}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}t(u){this.k!==u&&(this.k=u,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:u})))}u(u){this.l!==u&&(this.l=u,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(u)})))}assign(u){const k={};let h=!1;if(typeof u.tabSize<"u"){const r=this.m(u.tabSize);r==="auto"?(h=!0,k.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,h=!0,k.tabSize=r)}if(typeof u.indentSize<"u"){const r=this.o(u.indentSize);r==="tabSize"?(h=!0,k.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,h=!0,k.indentSize=r)}if(typeof u.insertSpaces<"u"){const r=this.q(u.insertSpaces);r==="auto"?(h=!0,k.insertSpaces=r):this.j!==r&&(this.j=r,h=!0,k.insertSpaces=r)}typeof u.cursorStyle<"u"&&this.k!==u.cursorStyle&&(this.k=u.cursorStyle,h=!0,k.cursorStyle=u.cursorStyle),typeof u.lineNumbers<"u"&&this.l!==u.lineNumbers&&(this.l=u.lineNumbers,h=!0,k.lineNumbers=T.TextEditorLineNumbersStyle.from(u.lineNumbers)),h&&this.v("setOptions",this.c.$trySetOptions(this.d,k))}v(u,k){k.catch(h=>{this.e.warn(`ExtHostTextEditorOptions '${u}' failed:'`),this.e.warn(h)})}}e.$8O=a;class P{constructor(u,k,h,r,o,c,f,t){this.id=u,this.j=k,this.k=h,this.g=!1,this.h=new Set,this.c=o,this.d=new a(this.j,this.id,c,h),this.e=f,this.f=t;const s=this;this.value=Object.freeze({get document(){return r.value},set document(n){throw new D.$9("document")},get selection(){return s.c&&s.c[0]},set selection(n){if(!(n instanceof A.$AM))throw(0,D.$7)("selection");s.c=[n],s.l()},get selections(){return s.c},set selections(n){if(!Array.isArray(n)||n.some(i=>!(i instanceof A.$AM)))throw(0,D.$7)("selections");s.c=n,s.l()},get visibleRanges(){return s.e},set visibleRanges(n){throw new D.$9("visibleRanges")},get options(){return s.d.value},set options(n){s.g||s.d.assign(n)},get viewColumn(){return s.f},set viewColumn(n){throw new D.$9("viewColumn")},edit(n,i={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const g=new $(r.value,i);return n(g),s.m(g)},insertSnippet(n,i,g={undoStopBefore:!0,undoStopAfter:!0}){if(s.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let d;if(!i||Array.isArray(i)&&i.length===0)d=s.c.map(l=>T.Range.from(l));else if(i instanceof A.$yM){const{lineNumber:l,column:p}=T.Position.from(i);d=[{startLineNumber:l,startColumn:p,endLineNumber:l,endColumn:p}]}else if(i instanceof A.$zM)d=[T.Range.from(i)];else{d=[];for(const l of i)if(l instanceof A.$zM)d.push(T.Range.from(l));else{const{lineNumber:p,column:C}=T.Position.from(l);d.push({startLineNumber:p,startColumn:C,endLineNumber:p,endColumn:C})}}return k.$tryInsertSnippet(u,r.value.version,n.value,d,g)},setDecorations(n,i){const g=i.length===0;g&&!s.h.has(n.key)||(g?s.h.delete(n.key):s.h.add(n.key),s.n(()=>{if(T.$WO(i))return k.$trySetDecorations(u,n.key,T.$XO(i));{const d=new Array(4*i.length);for(let l=0,p=i.length;l<p;l++){const C=i[l];d[4*l]=C.start.line+1,d[4*l+1]=C.start.character+1,d[4*l+2]=C.end.line+1,d[4*l+3]=C.end.character+1}return k.$trySetDecorationsFast(u,n.key,d)}}))},revealRange(n,i){s.n(()=>k.$tryRevealRange(u,T.Range.from(n),i||A.TextEditorRevealType.Default))},show(n){k.$tryShowEditor(u,T.ViewColumn.from(n))},hide(){k.$tryHideEditor(u)}})}dispose(){(0,b.ok)(!this.g),this.g=!0}_acceptOptions(u){(0,b.ok)(!this.g),this.d._accept(u)}_acceptVisibleRanges(u){(0,b.ok)(!this.g),this.e=u}_acceptViewColumn(u){(0,b.ok)(!this.g),this.f=u}_acceptSelections(u){(0,b.ok)(!this.g),this.c=u}async l(){const u=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,u)),this.value}m(u){const k=u.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const h=k.edits.map(o=>o.range);h.sort((o,c)=>o.end.line===c.end.line?o.end.character===c.end.character?o.start.line===c.start.line?o.start.character-c.start.character:o.start.line-c.start.line:o.end.character-c.end.character:o.end.line-c.end.line);for(let o=0,c=h.length-1;o<c;o++){const f=h[o].end;if(h[o+1].start.isBefore(f))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=k.edits.map(o=>({range:T.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,r,{setEndOfLine:typeof k.setEndOfLine=="number"?T.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(u){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):u().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.$9O=P}),define(Ce[71],Ie([1,0,61,4,6,2,3,5,121,17,125,10,12,29,16,40,47]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$O=e.$0O=void 0;class c{constructor(s){this.value=s,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let f=class{constructor(s,n){this.h=s,this.i=n,this.a=null,this.b=new Map,this.c=new k.$Ac,this.d=new D.$he,this.e=new D.$he,this.f=new D.$he,this.g=new D.$he,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(s){this.acceptDocumentsAndEditorsDelta(s)}acceptDocumentsAndEditorsDelta(s){const n=[],i=[],g=[];if(s.removedDocuments)for(const d of s.removedDocuments){const l=T.URI.revive(d),p=this.c.get(l);p?.unref()&&(this.c.delete(l),n.push(p.value))}if(s.addedDocuments)for(const d of s.addedDocuments){const l=T.URI.revive(d.uri);let p=this.c.get(l);if(p&&l.scheme!==h.Schemas.vscodeNotebookCell&&l.scheme!==h.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);p||(p=new c(new $.$3O(this.h.getProxy(M.$vM.MainThreadDocuments),l,d.lines,d.EOL,d.versionId,d.languageId,d.isDirty)),this.c.set(l,p),i.push(p.value)),p.ref()}if(s.removedEditors)for(const d of s.removedEditors){const l=this.b.get(d);this.b.delete(d),l&&g.push(l)}if(s.addedEditors)for(const d of s.addedEditors){const l=T.URI.revive(d.documentUri);b.ok(this.c.has(l),`document '${l}' does not exist`),b.ok(!this.b.has(d.id),`editor '${d.id}' already exists!`);const p=this.c.get(l).value,C=new P.$9O(d.id,this.h.getProxy(M.$vM.MainThreadTextEditors),this.i,new o.$V(()=>p.document),d.selections.map(y.Selection.to),d.options,d.visibleRanges.map(S=>y.Range.to(S)),typeof d.editorPosition=="number"?y.ViewColumn.to(d.editorPosition):void 0);this.b.set(d.id,C)}s.newActiveEditor!==void 0&&(b.ok(s.newActiveEditor===null||this.b.has(s.newActiveEditor),`active editor '${s.newActiveEditor}' does not exist`),this.a=s.newActiveEditor),(0,I.$Pc)(n),(0,I.$Pc)(g),s.removedDocuments&&this.e.fire(n),s.addedDocuments&&this.d.fire(i),(s.removedEditors||s.addedEditors)&&this.f.fire(this.allEditors().map(d=>d.value)),s.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(s){return this.c.get(s)?.value}allDocuments(){return r.Iterable.map(this.c.values(),s=>s.value)}getEditor(s){return this.b.get(s)}activeEditor(s){if(!this.a)return;const n=this.b.get(this.a);return s?n:n?.value}allEditors(){return[...this.b.values()]}};e.$0O=f,e.$0O=f=Je([qe(0,a.$ZO),qe(1,u.$7j)],f),e.$$O=(0,A.$Ai)("IExtHostDocumentsAndEditors")}),define(Ce[300],Ie([1,0,18,4,5,125,10,7]),function(_,e,b,D,I,T,A,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9mc=void 0;class ${constructor(P,y){this.i=y,this.a=new D.$he,this.b=new D.$he,this.c=new D.$he,this.d=new D.$he,this.f=new D.$he,this.g=new D.$he,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=P.getProxy(I.$vM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(u=>this.g.fire(u)),this.i.onDidChangeActiveTextEditor(u=>this.f.fire(u))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(P){const y=this.i.allEditors();return P?y:y.map(u=>u.value)}async showTextDocument(P,y,u){let k;typeof y=="number"?k={position:A.ViewColumn.from(y),preserveFocus:u}:typeof y=="object"?k={position:A.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?A.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:k={preserveFocus:!1};const h=await this.h.$tryShowTextDocument(P.uri,k),r=h&&this.i.getEditor(h);if(r)return r.value;throw h?new Error(`Could NOT open editor for "${P.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${P.uri.toString()}".`)}createTextEditorDecorationType(P,y){return new T.$7O(this.h,P,y).value}$acceptEditorPropertiesChanged(P,y){const u=this.i.getEditor(P);if(!u)throw new Error("unknown text editor");if(y.options&&u._acceptOptions(y.options),y.selections){const k=y.selections.selections.map(A.Selection.to);u._acceptSelections(k)}if(y.visibleRanges){const k=b.$Hb(y.visibleRanges.map(A.Range.to));u._acceptVisibleRanges(k)}if(y.options&&this.b.fire({textEditor:u.value,options:{...y.options,lineNumbers:A.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const k=M.TextEditorSelectionChangeKind.fromValue(y.selections.source),h=y.selections.selections.map(A.Selection.to);this.a.fire({textEditor:u.value,selections:h,kind:k})}if(y.visibleRanges){const k=b.$Hb(y.visibleRanges.map(A.Range.to));this.c.fire({textEditor:u.value,visibleRanges:k})}}$acceptEditorPositionData(P){for(const y in P){const u=this.i.getEditor(y);if(!u)throw new Error("Unknown text editor");const k=A.ViewColumn.to(P[y]);u.value.viewColumn!==k&&(u._acceptViewColumn(k),this.d.fire({textEditor:u.value,viewColumn:k}))}}getDiffInformation(P){return Promise.resolve(this.h.$getDiffInformation(P))}}e.$9mc=$}),define(Ce[301],Ie([1,0,2,3,5,6,7,10,19,36,15]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Soc=e.$Roc=void 0,e.$Roc=(0,D.$Ai)("IExtHostTimeline");class y{constructor(h,r){this.b=new Map,this.c=new Map,this.a=h.getProxy(I.$vM.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(o,c)=>{if(o&&o.$mid===a.MarshalledId.TimelineActionContext)if(this.b.get(o.source)&&$.$Xm.equals(c,this.b.get(o.source)?.extension)){const f=o.uri===void 0?void 0:b.URI.revive(o.uri);return this.c.get(o.source)?.get(u(f))?.get(o.handle)}else return;return o}})}async $getTimeline(h,r,o,c){return this.b.get(h)?.provider.provideTimeline(b.URI.revive(r),o,c)}registerTimelineProvider(h,r,o,c){const f=new T.$Tc,t=this.d(r.id,c,f).bind(this);let s;r.onDidChange&&(s=r.onDidChange(i=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...i,id:r.id}),this));const n=this.c;return this.f({...r,scheme:h,onDidChange:void 0,async provideTimeline(i,g,d){g?.resetCache&&(f.clear(),n.get(r.id)?.clear());const l=await r.provideTimeline(i,g,d);if(l==null)return;const p=t(i,g);return{...l,source:r.id,items:l.items.map(p)}},dispose(){for(const i of n.values())i.get(r.id)?.clear();s?.dispose(),f.dispose()}},o)}d(h,r,o){return(c,f)=>{let t;if(f?.cacheResults){let s=this.c.get(h);s===void 0&&(s=new Map,this.c.set(h,s));const n=u(c);t=s.get(n),t===void 0&&(t=new Map,s.set(n,t))}return s=>{const{iconPath:n,...i}=s,g=`${h}|${s.id??s.timestamp}`;t?.set(g,s);let d,l,p;s.iconPath&&(n instanceof A.$uN?p={id:n.id,color:n.color}:b.URI.isUri(n)?(d=n,l=n):{light:d,dark:l}=n);let C;return A.$ZM.isMarkdownString(i.tooltip)?C=M.MarkdownString.from(i.tooltip):(0,P.$ag)(i.tooltip)?C=i.tooltip:A.$ZM.isMarkdownString(i.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),C=M.MarkdownString.from(i.detail)):(0,P.$ag)(i.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),C=i.detail),{...i,id:i.id??void 0,handle:g,source:h,command:s.command?r.toInternal(s.command,o):void 0,icon:d,iconDark:l,themeIcon:p,tooltip:C,accessibilityInformation:s.accessibilityInformation}}}}f(h,r){if(this.b.get(h.id))throw new Error(`Timeline Provider ${h.id} already exists.`);return this.a.$registerTimelineProvider({id:h.id,label:h.label,scheme:h.scheme}),this.b.set(h.id,{provider:h,extension:r}),(0,T.$Sc)(()=>{for(const c of this.c.values())c.get(h.id)?.clear();this.b.delete(h.id),this.a.$unregisterTimelineProvider(h.id),h.dispose()})}}e.$Soc=y;function u(k){return k?.toString()}}),define(Ce[302],Ie([1,0,188,24,2,4,6,231,11,7,15,18,10,59,22,160,25]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Toc=void 0;function c(s,n){if((0,P.$ag)(s))return{label:s};if(s&&typeof s=="object"&&typeof s.label=="string"){let i;return Array.isArray(s.highlights)&&(i=s.highlights.filter(g=>g.length===2&&typeof g[0]=="number"&&typeof g[1]=="number"),i=i.length?i:void 0),{label:s.label,highlights:i}}}class f extends A.$Uc{constructor(n,i,g){super(),this.f=n,this.g=i,this.h=g,this.a=new Map,this.b=new r.$d$;function d(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:l=>d(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(p=>d(p)?this.r(p):p):l})}registerTreeDataProvider(n,i,g){const d=this.createTreeView(n,{treeDataProvider:i},g);return{dispose:()=>d.dispose()}}createTreeView(n,i,g){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=i.dragAndDropController?.dropMimeTypes??[],l=i.dragAndDropController?.dragMimeTypes??[],p=!!i.dragAndDropController?.handleDrag,C=!!i.dragAndDropController?.handleDrop,S=this.m(n,i,g),v={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:d,dragMimeTypes:l,hasHandleDrag:p,hasHandleDrop:C,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},E=this.f.$registerTreeViewDataProvider(n,v),R={get onDidCollapseElement(){return S.onDidCollapseElement},get onDidExpandElement(){return S.onDidExpandElement},get selection(){return S.selectedElements},get onDidChangeSelection(){return S.onDidChangeSelection},get activeItem(){return(0,o.$VG)(g,"treeViewActiveItem"),S.focusedElement},get onDidChangeActiveItem(){return(0,o.$VG)(g,"treeViewActiveItem"),S.onDidChangeActiveItem},get visible(){return S.visible},get onDidChangeVisibility(){return S.onDidChangeVisibility},get onDidChangeCheckboxState(){return S.onDidChangeCheckboxState},get message(){return S.message},set message(w){(0,k.$Zk)(w)&&(0,o.$VG)(g,"treeViewMarkdownMessage"),S.message=w},get title(){return S.title},set title(w){S.title=w},get description(){return S.description},set description(w){S.description=w},get badge(){return S.badge},set badge(w){w!==void 0&&a.ViewBadge.isViewBadge(w)?S.badge={value:Math.floor(Math.abs(w.value)),tooltip:w.tooltip}:w===void 0&&(S.badge=void 0)},reveal:(w,m)=>S.reveal(w,m),dispose:async()=>{await E,this.a.delete(n),S.dispose()}};return this.B(R),R}$getChildren(n,i){const g=this.a.get(n);return g?g.getChildren(i):Promise.reject(new M.$eG(n))}async $handleDrop(n,i,g,d,l,p,C,S){const v=this.a.get(n);if(!v)return Promise.reject(new M.$eG(n));const E=u.DataTransfer.toDataTransfer(g,async R=>(await this.f.$resolveDropFileData(n,i,R)).buffer);return C===n&&S&&await this.j(E,v,S,l,p),v.onDrop(E,d,l)}async j(n,i,g,d,l){const p=this.b.removeDragOperationTransfer(l);if(p)(await p)?.forEach((C,S)=>{C&&n.set(S,C)});else if(l&&i.handleDrag){const C=i.handleDrag(g,n,d);this.b.addDragOperationTransfer(l,C),await C}return n}async $handleDrag(n,i,g,d){const l=this.a.get(n);if(!l)return Promise.reject(new M.$eG(n));const p=await this.j(new a.$qN,l,i,d,g);if(!(!p||d.isCancellationRequested))return u.DataTransfer.from(p)}async $hasResolve(n){const i=this.a.get(n);if(!i)throw new M.$eG(n);return i.hasResolve}$resolve(n,i,g){const d=this.a.get(n);if(!d)throw new M.$eG(n);return d.resolveTreeItem(i,g)}$setExpanded(n,i,g){const d=this.a.get(n);if(!d)throw new M.$eG(n);d.setExpanded(i,g)}$setSelectionAndFocus(n,i,g){const d=this.a.get(n);if(!d)throw new M.$eG(n);d.setSelectionAndFocus(i,g)}$setVisible(n,i){const g=this.a.get(n);if(!g){if(!i)return;throw new M.$eG(n)}g.setVisible(i)}$changeCheckboxState(n,i){const g=this.a.get(n);if(!g)throw new M.$eG(n);g.setCheckboxState(i)}m(n,i,g){const d=this.B(new t(n,i,this.f,this.g.converter,this.h,g));return this.a.set(n,d),d}r(n){const i=this.a.get(n.$treeViewId);return i&&"$treeItemHandle"in n?i.getExtensionElement(n.$treeItemHandle):i&&"$focusedTreeItem"in n&&n.$focusedTreeItem?i.focusedElement:null}}e.$Toc=f;class t extends A.$Uc{get visible(){return this.r}get selectedElements(){return this.s.map(n=>this.getExtensionElement(n)).filter(n=>!(0,P.$jg)(n))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(n,i,g,d,l,p){if(super(),this.I=n,this.J=g,this.L=d,this.M=l,this.N=p,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$he),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$he),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$he),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$he),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$he),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$he),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$he),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new h.$se,p.contributes&&p.contributes.views)for(const E in p.contributes.views)for(const R of p.contributes.views[E])R.id===n&&(this.P=R.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(E=>{Array.isArray(E)&&E.length===0||this.F.fire({message:!1,element:E})}));let C,S;const v=T.Event.debounce(this.F.event,(E,R)=>(E||(E={message:!1,elements:[]}),R.element!==!1&&(C||(C=new Promise(w=>S=w),this.G=this.G.then(()=>C)),Array.isArray(R.element)?E.elements.push(...R.element):E.elements.push(R.element)),R.message&&(E.message=!0),E),200,!0);this.B(v(({message:E,elements:R})=>{R.length&&(this.H=this.H.then(()=>{const w=S;return C=null,this.$(R).then(()=>w())})),E&&this.J.$setMessage(this.I,u.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(n){const i=n?this.getExtensionElement(n):void 0;if(n&&!i)return this.M.error(`No tree item with id '${n}' found.`),Promise.resolve([]);let g=this.X(n);return g||(g=await this.Y(i)),g?g.map(d=>d.item):void 0}getExtensionElement(n){return this.j.get(n)}reveal(n,i){i=i||{select:!0,focus:!1};const g=(0,P.$jg)(i.select)?!0:i.select,d=(0,P.$jg)(i.focus)?!1:i.focus,l=(0,P.$jg)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):n?this.G.then(()=>this.S(n)).then(p=>this.W(n,p[p.length-1]).then(C=>this.J.$reveal(this.I,{item:C.item,parentChain:p.map(S=>S.item)},{select:g,focus:d,expand:l})),p=>this.M.error(p)):this.J.$reveal(this.I,void 0,{select:g,focus:d,expand:l})}get message(){return this.O}set message(n){this.O=n,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(n){this.P=n,this.J.$setTitle(this.I,n,this.Q)}get description(){return this.Q}set description(n){this.Q=n,this.J.$setTitle(this.I,this.P,n)}get badge(){return this.R}set badge(n){this.R?.value===n?.value&&this.R?.tooltip===n?.tooltip||(this.R=u.ViewBadge.from(n),this.J.$setBadge(this.I,n))}setExpanded(n,i){const g=this.getExtensionElement(n);g&&(i?this.u.fire(Object.freeze({element:g})):this.w.fire(Object.freeze({element:g})))}setSelectionAndFocus(n,i){const g=!(0,y.$ub)(this.s,n);this.s=n;const d=this.t!==i;this.t=i,g&&this.y.fire(Object.freeze({selection:this.selectedElements})),d&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(n){n!==this.r&&(this.r=n,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(n){const i=(await Promise.all(n.map(async g=>{const d=this.getExtensionElement(g.treeItemHandle);return d?{extensionItem:d,treeItem:await this.f.getTreeItem(d),newState:g.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(g=>g!==void 0);i.forEach(g=>{g.treeItem.checkboxState=g.newState?a.TreeItemCheckboxState.Checked:a.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(g=>[g.extensionItem,g.newState])})}async handleDrag(n,i,g){const d=[];for(const l of n){const p=this.getExtensionElement(l);p&&d.push(p)}if(!(!this.g?.handleDrag||d.length===0))return await this.g.handleDrag(d,i,g),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(n,i,g){const d=i?this.getExtensionElement(i):void 0;if(!(!d&&i||!this.g?.handleDrop))return(0,$.$sh)(()=>this.g?.handleDrop?this.g.handleDrop(d,n,g):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(n,i){if(!this.f.resolveTreeItem)return;const g=this.j.get(n);if(g){const d=this.m.get(g);if(d){const l=await this.f.resolveTreeItem(d.extensionItem,g,i)??d.extensionItem;return this.hb(l),d.item.tooltip=this.eb(l.tooltip),d.item.command=this.fb(d.disposableStore,l.command),d.item}}}S(n){return this.U(n).then(i=>i?this.S(i).then(g=>this.W(i,g[g.length-1]).then(d=>(g.push(d),g))):Promise.resolve([]))}U(n){const i=this.m.get(n);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,$.$sh)(()=>this.f.getParent(n))}W(n,i){const g=this.m.get(n);return g?Promise.resolve(g):(0,$.$sh)(()=>this.f.getTreeItem(n)).then(d=>this.kb(n,d,i,!0)).then(d=>this.getChildren(i?i.item.handle:void 0).then(()=>{const l=this.getExtensionElement(d);if(l){const p=this.m.get(l);if(p)return Promise.resolve(p)}throw new Error(`Cannot resolve tree item for element ${d} from extension ${this.N.identifier.value}`)}))}X(n){if(n){let i;if(typeof n=="string"){const g=this.getExtensionElement(n);i=g?this.m.get(g):void 0}else i=n;return i&&i.children||void 0}return this.h}async Y(n){this.rb(n);const i=new h.$se(this.Z.token);try{const g=n?this.m.get(n):void 0,d=await this.f.getChildren(n);if(i.token.isCancellationRequested)return;const l=(0,y.$Hb)(d||[]),p=await Promise.all((0,y.$Hb)(l).map(S=>this.f.getTreeItem(S)));if(i.token.isCancellationRequested)return;const C=p.map((S,v)=>S?this.db(l[v],S,g):null);return(0,y.$Hb)(C)}finally{i.dispose()}}$(n){if(n.some(g=>!g))return this.Z.dispose(!0),this.Z=new h.$se,this.tb(),this.J.$refresh(this.I);{const g=this.ab(n);if(g.length)return this.bb(g)}return Promise.resolve(void 0)}ab(n){const i=new Set,g=n.map(l=>this.m.get(l));for(const l of g)if(l&&!i.has(l.item.handle)){let p=l;for(;p&&p.parent&&g.findIndex(C=>p&&p.parent&&C&&C.item.handle===p.parent.item.handle)===-1;){const C=this.j.get(p.parent.item.handle);p=C?this.m.get(C):void 0}p&&!p.parent&&i.add(l.item.handle)}const d=[];return i.forEach(l=>{const p=this.j.get(l);if(p){const C=this.m.get(p);C&&(!C.parent||!i.has(C.parent.item.handle))&&d.push(l)}}),d}bb(n){const i={};return Promise.all(n.map(g=>this.cb(g).then(d=>{d&&(i[g]=d.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(n){const i=this.getExtensionElement(n);if(i){const g=this.m.get(i);if(g)return this.rb(i),(0,$.$sh)(()=>this.f.getTreeItem(i)).then(d=>{if(d){const l=this.ib(i,d,g.parent);return this.pb(i,l,g,g.parent),g.dispose(),l}return null})}return Promise.resolve(null)}db(n,i,g){const d=this.ib(n,i,g);if(i.id&&this.j.has(d.item.handle))throw new Error((0,b.localize)(0,null,i.id));return this.ob(n,d),this.qb(d,g),d}eb(n){return a.$ZM.isMarkdownString(n)?u.MarkdownString.from(n):n}fb(n,i){return i?{...this.L.toInternal(i,n),originalId:i.command}:void 0}gb(n){if(n.checkboxState===void 0)return;let i,g,d;return typeof n.checkboxState=="number"?i=n.checkboxState:(i=n.checkboxState.state,g=n.checkboxState.tooltip,d=n.checkboxState.accessibilityInformation),{isChecked:i===a.TreeItemCheckboxState.Checked,tooltip:g,accessibilityInformation:d}}hb(n){if(!a.$lN.isTreeItem(n,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(n,i,g){this.hb(i);const d=this.B(new A.$Tc),l=this.kb(n,i,g),p=this.lb(i);return{item:{handle:l,parentHandle:g?g.item.handle:void 0,label:c(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(d,i.command),contextValue:i.contextValue,icon:p,iconDark:this.mb(i)||p,themeIcon:this.jb(i),collapsibleState:(0,P.$jg)(i.collapsibleState)?a.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:g,children:void 0,disposableStore:d,dispose(){d.dispose()}}}jb(n){return n.iconPath instanceof a.$uN?n.iconPath:void 0}kb(n,{id:i,label:g,resourceUri:d},l,p){if(i)return`${t.b}/${i}`;const C=c(g,this.N),S=l?l.item.handle:t.a;let v=C?C.label:d?(0,D.$$g)(d):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const E=this.m.has(n)?this.m.get(n).item.handle:void 0,R=this.X(l)||[];let w,m=0;do{if(w=`${S}/${m}:${v}`,p||!this.j.has(w)||E===w)break;m++}while(m<=R.length);return w}lb(n){if(n.iconPath&&!(n.iconPath instanceof a.$uN))return typeof n.iconPath=="string"||I.URI.isUri(n.iconPath)?this.nb(n.iconPath):this.nb(n.iconPath.light)}mb(n){if(n.iconPath&&!(n.iconPath instanceof a.$uN)&&n.iconPath.dark)return this.nb(n.iconPath.dark)}nb(n){return I.URI.isUri(n)?n:I.URI.file(n)}ob(n,i){this.j.set(i.item.handle,n),this.m.set(n,i)}pb(n,i,g,d){this.j.delete(i.item.handle),this.m.delete(n),i.item.handle!==g.item.handle&&this.j.delete(g.item.handle),this.ob(n,i);const l=this.X(d)||[],p=l.filter(C=>C.item.handle===g.item.handle)[0];p&&l.splice(l.indexOf(p),1,i)}qb(n,i){i?(i.children||(i.children=[]),i.children.push(n)):(this.h||(this.h=[]),this.h.push(n))}rb(n){if(n){const i=this.m.get(n);if(i){if(i.children)for(const g of i.children){const d=this.j.get(g.item.handle);d&&this.sb(d)}i.children=void 0}}else this.tb()}sb(n){const i=this.m.get(n);if(i){if(i.children)for(const g of i.children){const d=this.j.get(g.item.handle);d&&this.sb(d)}this.m.delete(n),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(n=>n.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}t.a="0",t.b="1"});var tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b},Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)};define(Ce[303],Ie([1,0,4,6,2,37,10,67,5,7]),function(_,e,b,D,I,T,A,M,$,a){"use strict";var P,y,u,k,h,r,o,c,f,t,s,n,i;Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=void 0;class g extends D.$Uc{constructor(C,S,v,E){super(),P.set(this,void 0),y.set(this,void 0),u.set(this,void 0),k.set(this,void 0),h.set(this,void 0),r.set(this,void 0),o.set(this,void 0),c.set(this,void 0),f.set(this,!0),t.set(this,void 0),s.set(this,!1),n.set(this,this.B(new b.$he)),this.onDidDispose=Be(this,n,"f").event,i.set(this,this.B(new b.$he)),this.onDidChangeViewState=Be(this,i,"f").event,tt(this,P,C,"f"),tt(this,y,S,"f"),tt(this,k,v,"f"),tt(this,u,E.viewType,"f"),tt(this,h,E.panelOptions,"f"),tt(this,c,E.viewColumn,"f"),tt(this,r,E.title,"f"),tt(this,t,E.active,"f")}dispose(){Be(this,s,"f")||(tt(this,s,!0,"f"),Be(this,n,"f").fire(),Be(this,y,"f").$disposeWebview(Be(this,P,"f")),Be(this,k,"f").dispose(),super.dispose())}get webview(){return this.c(),Be(this,k,"f")}get viewType(){return this.c(),Be(this,u,"f")}get title(){return this.c(),Be(this,r,"f")}set title(C){this.c(),Be(this,r,"f")!==C&&(tt(this,r,C,"f"),Be(this,y,"f").$setTitle(Be(this,P,"f"),C))}get iconPath(){return this.c(),Be(this,o,"f")}set iconPath(C){this.c(),Be(this,o,"f")!==C&&(tt(this,o,C,"f"),Be(this,y,"f").$setIconPath(Be(this,P,"f"),I.URI.isUri(C)?{light:C,dark:C}:C))}get options(){return Be(this,h,"f")}get viewColumn(){if(this.c(),!(typeof Be(this,c,"f")=="number"&&Be(this,c,"f")<0))return Be(this,c,"f")}get active(){return this.c(),Be(this,t,"f")}get visible(){return this.c(),Be(this,f,"f")}_updateViewState(C){Be(this,s,"f")||(this.active!==C.active||this.visible!==C.visible||this.viewColumn!==C.viewColumn)&&(tt(this,t,C.active,"f"),tt(this,f,C.visible,"f"),tt(this,c,C.viewColumn,"f"),Be(this,i,"f").fire({webviewPanel:this}))}reveal(C,S){this.c(),Be(this,y,"f").$reveal(Be(this,P,"f"),{viewColumn:typeof C>"u"?void 0:A.ViewColumn.from(C),preserveFocus:!!S})}c(){if(Be(this,s,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,y=new WeakMap,u=new WeakMap,k=new WeakMap,h=new WeakMap,r=new WeakMap,o=new WeakMap,c=new WeakMap,f=new WeakMap,t=new WeakMap,s=new WeakMap,n=new WeakMap,i=new WeakMap;class d extends D.$Uc{static c(){return(0,T.$Wg)()}constructor(C,S,v){super(),this.j=S,this.m=v,this.g=new Map,this.h=new Map,this.f=C.getProxy($.$vM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(C=>C.dispose()),this.g.clear()}createWebviewPanel(C,S,v,E,R={}){const w=typeof E=="object"?E.viewColumn:E,m={viewColumn:A.ViewColumn.from(w),preserveFocus:typeof E=="object"&&!!E.preserveFocus},N=(0,M.$lnc)(C),B=d.c();this.f.$createWebviewPanel((0,M.$nnc)(C),B,S,{title:v,panelOptions:l(R),webviewOptions:(0,M.$onc)(C,this.m,R),serializeBuffersForPostMessage:N},m);const X=this.j.createNewWebview(B,R,C);return this.createNewWebviewPanel(B,S,v,w,R,X,!0)}$onDidChangeWebviewPanelViewStates(C){const S=Object.keys(C);S.sort((v,E)=>{const R=C[v],w=C[E];return R.active?1:w.active?-1:+R.visible-+w.visible});for(const v of S){const E=this.getWebviewPanel(v);if(!E)continue;const R=C[v];E._updateViewState({active:R.active,visible:R.visible,viewColumn:A.ViewColumn.to(R.position)})}}async $onDidDisposeWebviewPanel(C){this.getWebviewPanel(C)?.dispose(),this.g.delete(C),this.j.deleteWebview(C)}registerWebviewPanelSerializer(C,S,v){if(this.h.has(S))throw new Error(`Serializer for '${S}' already registered`);return this.h.set(S,{serializer:v,extension:C}),this.f.$registerSerializer(S,{serializeBuffersForPostMessage:(0,M.$lnc)(C)}),new a.$xM(()=>{this.h.delete(S),this.f.$unregisterSerializer(S)})}async $deserializeWebviewPanel(C,S,v,E){const R=this.h.get(S);if(!R)throw new Error(`No serializer found for '${S}'`);const{serializer:w,extension:m}=R,N=this.j.createNewWebview(C,v.webviewOptions,m),B=this.createNewWebviewPanel(C,S,v.title,E,v.panelOptions,N,v.active);await w.deserializeWebviewPanel(B,v.state)}createNewWebviewPanel(C,S,v,E,R,w,m){const N=new g(C,this.f,w,{viewType:S,title:v,viewColumn:E,panelOptions:R,active:m});return this.g.set(C,N),N}getWebviewPanel(C){return this.g.get(C)}}e.$pnc=d;function l(p){return{enableFindWidget:p.enableFindWidget,retainContextWhenHidden:p.retainContextWhenHidden}}});var tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b},Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)};define(Ce[304],Ie([1,0,4,6,67,10,5,7]),function(_,e,b,D,I,T,A,M){"use strict";var $,a,P,y,u,k,h,r,o,c,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Woc=void 0;class t extends D.$Uc{constructor(i,g,d,l,p,C){super(),$.set(this,void 0),a.set(this,void 0),P.set(this,void 0),y.set(this,void 0),u.set(this,!1),k.set(this,void 0),h.set(this,void 0),r.set(this,void 0),o.set(this,void 0),c.set(this,this.B(new b.$he)),this.onDidChangeVisibility=Be(this,c,"f").event,f.set(this,this.B(new b.$he)),this.onDidDispose=Be(this,f,"f").event,tt(this,P,d,"f"),tt(this,h,l,"f"),tt(this,$,i,"f"),tt(this,a,g,"f"),tt(this,y,p,"f"),tt(this,k,C,"f")}dispose(){Be(this,u,"f")||(tt(this,u,!0,"f"),Be(this,f,"f").fire(),Be(this,y,"f").dispose(),super.dispose())}get title(){return this.a(),Be(this,h,"f")}set title(i){this.a(),Be(this,h,"f")!==i&&(tt(this,h,i,"f"),Be(this,a,"f").$setWebviewViewTitle(Be(this,$,"f"),i))}get description(){return this.a(),Be(this,r,"f")}set description(i){this.a(),Be(this,r,"f")!==i&&(tt(this,r,i,"f"),Be(this,a,"f").$setWebviewViewDescription(Be(this,$,"f"),i))}get visible(){return Be(this,k,"f")}get webview(){return Be(this,y,"f")}get viewType(){return Be(this,P,"f")}_setVisible(i){i===Be(this,k,"f")||Be(this,u,"f")||(tt(this,k,i,"f"),Be(this,c,"f").fire())}get badge(){return this.a(),Be(this,o,"f")}set badge(i){this.a(),!(i?.value===Be(this,o,"f")?.value&&i?.tooltip===Be(this,o,"f")?.tooltip)&&(tt(this,o,T.ViewBadge.from(i),"f"),Be(this,a,"f").$setWebviewViewBadge(Be(this,$,"f"),i))}show(i){this.a(),Be(this,a,"f").$show(Be(this,$,"f"),!!i)}a(){if(Be(this,u,"f"))throw new Error("Webview is disposed")}}$=new WeakMap,a=new WeakMap,P=new WeakMap,y=new WeakMap,u=new WeakMap,k=new WeakMap,h=new WeakMap,r=new WeakMap,o=new WeakMap,c=new WeakMap,f=new WeakMap;class s{constructor(i,g){this.d=g,this.b=new Map,this.c=new Map,this.a=i.getProxy(A.$vM.MainThreadWebviewViews)}registerWebviewViewProvider(i,g,d,l){if(this.b.has(g))throw new Error(`View provider for '${g}' already registered`);return this.b.set(g,{provider:d,extension:i}),this.a.$registerWebviewViewProvider((0,I.$nnc)(i),g,{retainContextWhenHidden:l?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$lnc)(i)}),new M.$xM(()=>{this.b.delete(g),this.a.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(i,g,d,l,p){const C=this.b.get(g);if(!C)throw new Error(`No view provider found for '${g}'`);const{provider:S,extension:v}=C,E=this.d.createNewWebview(i,{},v),R=new t(i,this.a,g,d,E,!0);this.c.set(i,R),await S.resolveWebviewView(R,{state:l},p)}async $onDidChangeWebviewViewVisibility(i,g){this.e(i)._setVisible(g)}async $disposeWebviewView(i){const g=this.e(i);this.c.delete(i),g.dispose(),this.d.deleteWebview(i)}e(i){const g=this.c.get(i);if(!g)throw new Error("No webview found");return g}}e.$Woc=s}),define(Ce[305],Ie([1,0,4,31,32,3]),function(_,e,b,D,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RL=e.$QL=e.OutputChannelUpdateMode=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=void 0,e.$DL="text/x-code-output",e.$EL="output",e.$FL="Log",e.$GL="text/x-code-log-output",e.$HL="log",e.$IL="workbench.panel.output",e.$JL=new I.$Rj("inOutput",!1),e.$KL=new I.$Rj("activeLogOutput",!1),e.$LL=new I.$Rj("activeLogOutput.levelSettable",!1),e.$ML=new I.$Rj("activeLogOutput.level",""),e.$NL=new I.$Rj("activeLogOutput.levelIsDefault",!1),e.$OL=new I.$Rj("outputView.scrollLock",!1),e.$PL=(0,T.$Ai)("outputService");var A;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$QL={OutputChannels:"workbench.contributions.outputChannels"};class M{constructor(){this.a=new Map,this.b=new b.$he,this.onDidRegisterChannel=this.b.event,this.c=new b.$he,this.onDidRemoveChannel=this.c.event}registerChannel(a){this.a.has(a.id)||(this.a.set(a.id,a),this.b.fire(a.id))}getChannels(){const a=[];return this.a.forEach(P=>a.push(P)),a}getChannel(a){return this.a.get(a)}removeChannel(a){this.a.delete(a),this.c.fire(a)}}D.$ko.add(e.$QL.OutputChannels,new M),e.$RL=new I.$Rj("activeOutputChannel","")}),define(Ce[126],Ie([1,0,5,3,17,19,12,305,68,27,51,164,23,15,30,4,6]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$woc=e.$voc=void 0;class c extends A.$ak{get disposed(){return this.n}constructor(n,i,g,d,l){super(),this.id=n,this.name=i,this.r=g,this.s=d,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(g.getLevel()),this.B(g.onDidChangeLogLevel(p=>this.setLevel(p)))}get logLevel(){return this.getLevel()}appendLine(n){this.append(n+`
`)}append(n){this.info(n)}clear(){const n=this.m;this.r.flush(),this.s.$update(this.id,M.OutputChannelUpdateMode.Clear,n)}replace(n){const i=this.m;this.info(n),this.s.$update(this.id,M.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(n,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof n=="boolean"?n:i))}hide(){this.s.$close(this.id)}g(n,i){this.m+=u.$Je.fromString(i).byteLength,(0,A.log)(this.r,n,i),this.visible&&(this.r.flush(),this.s.$update(this.id,M.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class f extends c{appendLine(n){this.append(n)}}let t=class{constructor(n,i,g,d,l,p){this.i=i,this.j=g,this.k=d,this.l=l,this.m=p,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=n.getProxy(b.$vM.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,y.$0m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(n){this.h=n;for(const[i,g]of this.g)g.visible=i===this.h}createOutputChannel(n,i,g){if(n=n.trim(),!n)throw new Error("illegal argument `name`. must not be falsy");const d=typeof i=="object"&&i.log,l=(0,k.$ag)(i)?i:void 0;if((0,k.$ag)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let p;const C=this.i.environment.extensionLogLevel?.find(([v])=>T.$Xm.equals(g.identifier,v))?.[1];C&&(p=(0,A.$lk)(C));const S=d?this.o(n,p,g):this.n(n,l,g);return S.then(v=>{this.g.set(v.id,v),v.visible=v.id===this.h}),d?this.r(n,p??this.m.getLevel(),S):this.q(n,S)}async n(n,i,g){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const d=await this.c,l=this.k.extUri.joinPath(d,`${this.f++}-${n.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),C=await this.a.$register(n,l,i,g.identifier.value);return new c(C,n,p,this.a,g)}async o(n,i,g){const d=await this.p(g),l=n.replace(/[\\/:\*\?"<>\|]/g,""),p=this.k.extUri.joinPath(d,`${l}.log`),C=`${g.identifier.value}.${l}`,S=this.l.createLogger(p,{id:C,name:n,logLevel:i,extensionId:g.identifier.value});return new f(C,n,S,this.a,g)}p(n){let i=this.d.get(n.identifier.value);if(!i){const g=this.k.extUri.joinPath(this.i.logsLocation,n.identifier.value);this.d.set(n.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(g)}catch(d){if((0,h.$kl)(d)!==h.FileSystemProviderErrorCode.FileExists)throw d}return g})())}return i}q(n,i){let g=!1;const d=()=>{if(g)throw new Error("Channel has been closed")};return{get name(){return n},append(l){d(),i.then(p=>p.append(l))},appendLine(l){d(),i.then(p=>p.appendLine(l))},clear(){d(),i.then(l=>l.clear())},replace(l){d(),i.then(p=>p.replace(l))},show(l,p){d(),i.then(C=>C.show(l,p))},hide(){d(),i.then(l=>l.hide())},dispose(){g=!0,i.then(l=>l.dispose())}}}r(n,i,g){const d=new o.$Tc,l=()=>{if(d.isDisposed)throw new Error("Channel has been closed")},p=d.add(new r.$he);function C(S){i=S,p.fire(S)}return g.then(S=>{d.add(S),S.logLevel!==i&&C(S.logLevel),d.add(S.onDidChangeLogLevel(v=>C(v)))}),{...this.q(n,g),get logLevel(){return i},onDidChangeLogLevel:p.event,trace(S,...v){l(),g.then(E=>E.trace(S,...v))},debug(S,...v){l(),g.then(E=>E.debug(S,...v))},info(S,...v){l(),g.then(E=>E.info(S,...v))},warn(S,...v){l(),g.then(E=>E.warn(S,...v))},error(S,...v){l(),g.then(E=>E.error(S,...v))},dispose(){d.dispose()}}}};e.$voc=t,e.$voc=t=Je([qe(0,I.$ZO),qe(1,a.$dP),qe(2,$.$hnc),qe(3,P.$Wmc),qe(4,A.$8j),qe(5,A.$7j)],t),e.$woc=(0,D.$Ai)("IExtHostOutputService")}),define(Ce[127],Ie([1,0,3,11]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=e.$mn=void 0,e.$mn=(0,b.$Ai)("remoteAgentService"),e.$nn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let T=1/0;for(let M=0;M<this.maxSampleCount;M++){const $=await I.getRoundTripTime();if($===void 0)return;T=Math.min(T,$/2),await(0,D.$Bh)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(T):A=this.initial.reduce((M,$)=>M+$,0)/this.initial.length,this.lastMeasurement={initial:A,current:T,average:this.average.reduce((M,$)=>M+$,0)/this.average.length,high:typeof A>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[306],Ie([1,0,191,54,31,50,42,6,4,127,21,26,11,112]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uhb=e.$thb=e.$shb=e.$rhb=e.$qhb=e.$phb=e.$ohb=e.$nhb=e.$mhb=void 0,e.$mhb=Object.freeze({id:"application",order:100,title:(0,b.localize)(0,null),type:"object"}),e.$nhb=Object.freeze({id:"workbench",order:7,title:(0,b.localize)(1,null),type:"object"}),e.$ohb=Object.freeze({id:"security",scope:D.ConfigurationScope.APPLICATION,title:(0,b.localize)(2,null),type:"object",order:7}),e.$phb=Object.freeze({id:"problems",title:(0,b.localize)(3,null),type:"object",order:101}),e.$qhb=Object.freeze({id:"window",order:8,title:(0,b.localize)(4,null),type:"object"}),e.$rhb={ConfigurationMigration:"base.contributions.configuration.migration"};class h{constructor(){this.migrations=[],this.a=new $.$he,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new h;I.$ko.add(e.$rhb.ConfigurationMigration,r);let o=class extends M.$Uc{constructor(n,i){super(),this.a=n,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async g=>{for(const d of g.added)await this.f(d,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(g=>this.c(g)))}async c(n){await this.f(void 0,n);for(const i of this.b.getWorkspace().folders)await this.f(i,n)}async f(n,i){await Promise.all([i.map(g=>this.g(g,n?.uri))])}async g(n,i){const g=this.a.inspect(n.key,{resource:i}),d=this.b.getWorkbenchState()===T.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[l,p]of d){const C=g[l];if(!C)continue;const S=[];if(C.value!==void 0){const v=await this.h(n,l,C.value,i,void 0);for(const E of v??[])S.push([E,[]])}for(const{identifiers:v,value:E}of C.overrides??[])if(E!==void 0){const R=await this.h(n,l,E,i,v);for(const w of R??[])S.push([w,v])}S.length&&await Promise.allSettled(S.map(async([[v,E],R])=>this.a.updateValue(v,E.value,{resource:i,overrideIdentifiers:R},p)))}}async h(n,i,g,d,l){const p=S=>{const E=this.a.inspect(S,{resource:d})[i];if(E)return l?E.overrides?.find(({identifiers:R})=>(0,y.$bo)(R,l))?.value:E.value},C=await n.migrateFn(g,p);return Array.isArray(C)?C:[[n.key,C]]}};e.$shb=o,o.ID="workbench.contrib.configurationMigration",e.$shb=o=Je([qe(0,A.$7i),qe(1,T.$Ji)],o);let c=class extends M.$Uc{constructor(n){super(),this.b=n,this.a=new u.$Xh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!P.$c&&(await this.b.getEnvironment())?.os!==P.OperatingSystem.Windows)return;I.$ko.as(D.$po.Configuration).registerConfiguration({...e.$ohb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,b.localize)(5,null)},default:[],markdownDescription:(0,b.localize)(6,null),scope:D.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,b.localize)(7,null),scope:D.ConfigurationScope.MACHINE}}})}};e.$thb=c,c.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration",e.$thb=c=Je([qe(0,a.$mn)],c);const f="window.newWindowProfile";let t=class extends M.$Uc{constructor(n,i){super(),this.c=n,this.f=i,this.g(),this.B(this.c.onDidChangeProfiles(g=>this.g())),this.h(),this.j(),this.B(i.onDidChangeConfiguration(g=>{g.source!==A.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(f)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=I.$ko.as(D.$po.Configuration),i={...e.$qhb,properties:{[f]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(g=>g.name),null],enumItemLabels:[...this.c.profiles.map(g=>""),(0,b.localize)(8,null)],description:(0,b.localize)(9,null),scope:D.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[i],remove:[this.a]}):n.registerConfiguration(i),this.a=i}h(){const n=this.f.getValue(f);this.b=n?this.c.profiles.find(i=>i.name===n):void 0}j(){const n=this.f.getValue(f);if(!n)return;const i=this.b?this.c.profiles.find(g=>g.id===this.b.id):void 0;n!==i?.name&&this.f.updateValue(f,i?.name)}};e.$uhb=t,t.ID="workbench.contrib.dynamicWindowConfiguration",e.$uhb=t=Je([qe(0,k.$Gl),qe(1,A.$7i)],t)}),define(Ce[307],Ie([1,0,41,16,20,24,202,306,54,3,31]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$whb=e.$vhb=void 0,e.$xhb=r,e.$yhb=o,e.$vhb=(0,a.$Ai)("editorResolverService"),e.$whb="workbench.editorAssociations";const y=P.$ko.as($.$po.Configuration),u={...M.$nhb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(u);var k;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(k||(e.RegisteredEditorPriority=k={}));var h;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(h||(e.ResolvedStatus=h={}));function r(c){switch(c){case k.exclusive:return 5;case k.default:return 4;case k.builtin:return 3;case k.option:default:return 1}}function o(c,f){if(new Set([D.Schemas.extension,D.Schemas.webviewPanel,D.Schemas.vscodeWorkspaceTrust,D.Schemas.vscodeSettings]).has(f.scheme))return!1;const n=typeof c=="string"&&c.indexOf(I.$gc.sep)>=0?`${f.scheme}:${f.path}`:(0,T.$$g)(f);return b.$tk(typeof c=="string"?c.toLowerCase():c,n.toLowerCase())}}),define(Ce[308],Ie([1,0,52,16,20,21,24,2,3,225,50,245,127]),function(_,e,b,D,I,T,A,M,$,a,P,y,u){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$$L=e.$0L=void 0,e.$0L=(0,$.$Ai)("pathService");let h=k=class{constructor(o,c,f,t){this.d=o,this.e=c,this.f=f,this.g=t,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const s=await this.e.getEnvironment();return this.c=s?.userHome??o})()}hasValidBasename(o,c,f){return typeof c=="string"||typeof c>"u"?this.a.then(t=>this.h(o,t,c)):this.h(o,c,f)}h(o,c,f){return o.scheme===D.Schemas.file||o.scheme===D.Schemas.vscodeRemote?(0,b.$xg)(f??(0,A.$$g)(o),c===T.OperatingSystem.Windows):!0}get defaultUriScheme(){return k.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,c){if(o.remoteAuthority)return D.Schemas.vscodeRemote;const f=(0,a.$7L)(c.getWorkspace());if(f)return f;const t=c.getWorkspace().folders[0];if(t)return t.uri.scheme;const s=c.getWorkspace().configuration;return s?s.scheme:D.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===T.OperatingSystem.Windows?I.$fc:I.$gc)}async fileURI(o){let c="";if(await this.a===T.OperatingSystem.Windows&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const t=o.indexOf("/",2);t===-1?(c=o.substring(2),o="/"):(c=o.substring(2,t),o=o.substring(t)||"/")}return M.URI.from({scheme:D.Schemas.file,authority:c,path:o,query:"",fragment:""})}};e.$$L=h,e.$$L=h=k=Je([qe(1,u.$mn),qe(2,y.$SL),qe(3,P.$Ji)],h)}),define(Ce[128],Ie([1,0]),function(_,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$CK=e.$BK=void 0;class b{constructor(A,M){this.line=A,this.character=M}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,M){return new b(0,0)}with(A){return new b(0,0)}}e.$BK=b;class D{constructor(A,M,$,a){this.isEmpty=!1,this.isSingleLine=!1,this.start=new b(A,M),this.end=new b($,a)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new D(0,0,0,0)}with(A){return new D(0,0,0,0)}}e.$CK=D;var I;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ce[43],Ie([1,0,18,41,26,52,13,3,20,14,128,11]),function(_,e,b,D,I,T,A,M,$,a,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2K=e.$ZK=e.$SK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$PK=e.$OK=e.$NK=e.$MK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.TextSearchCompleteMessageType=void 0,e.$JK=c,e.$KK=f,e.$LK=t,e.$QK=S,e.$RK=v,e.$TK=w,e.$UK=m,e.$VK=N,e.$WK=B,e.$XK=X,e.$YK=V,e.$1K=L,e.$3K=de,e.$4K=be,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return P.TextSearchCompleteMessageType}}),e.$DK="workbench.view.search",e.$EK="workbench.panel.search",e.$FK="workbench.view.search",e.$GK="search-result",e.$HK="search.exclude";const u="\u27EA ",k=" characters skipped \u27EB",h=(u.length+k.length+5)*2;e.$IK=(0,M.$Ai)("searchService");var r;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text",Z[Z.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var o;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text",Z[Z.aiText=3]="aiText"})(o||(e.QueryType=o={}));function c(Z){return!!Z.preview}function f(Z){return!!Z.resource}function t(Z){return!!Z.message}var s;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(s||(e.SearchCompletionExitCode=s={}));class n{constructor(ae){this.resource=ae,this.results=[]}}e.$MK=n;class i{constructor(ae,fe,ee,De){this.ranges=fe,this.webviewIndex=De;const Fe=Array.isArray(fe)?fe:[fe];if(ee&&ee.matchLines===1&&g(Fe)){ae=(0,A.$6f)(ae,ee.matchLines);let ce="",H=0,he=0;const le=Math.floor(ee.charsPerLine/5),re=[];for(const ue of Fe){const oe=Math.max(ue.startColumn-le,0),J=ue.startColumn+ee.charsPerLine;if(oe>he+le+h){const Y=u+(oe-he)+k;ce+=Y+ae.slice(oe,J),H+=oe-(he+Y.length)}else ce+=ae.slice(he,J);re.push(new l(0,ue.startColumn-H,ue.endColumn-H)),he=J}this.preview={text:ce,matches:Array.isArray(this.ranges)?re:re[0]}}else{const ce=Array.isArray(fe)?fe[0].startLineNumber:fe.startLineNumber;this.preview={text:ae,matches:(0,b.$1b)(fe,H=>new d(H.startLineNumber-ce,H.startColumn,H.endLineNumber-ce,H.endColumn))}}}}e.$NK=i;function g(Z){const ae=Z[0].startLineNumber;for(const fe of Z)if(fe.startLineNumber!==ae||fe.endLineNumber!==ae)return!1;return!0}class d{constructor(ae,fe,ee,De){this.startLineNumber=ae,this.startColumn=fe,this.endLineNumber=ee,this.endColumn=De}}e.$OK=d;class l extends d{constructor(ae,fe,ee){super(ae,fe,ae,ee)}}e.$PK=l;var p;(function(Z){Z.List="list",Z.Tree="tree"})(p||(e.ViewMode=p={}));var C;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(C||(e.SearchSortOrder=C={}));function S(Z,ae=!0){const fe=Z&&Z.files&&Z.files.exclude,ee=ae&&Z&&Z.search&&Z.search.exclude;if(!fe&&!ee)return;if(!fe||!ee)return fe||ee;let De=Object.create(null);return De=I.$ao(De,I.$0n(fe)),De=I.$ao(De,I.$0n(ee),!0),De}function v(Z,ae){return Z.excludePattern&&D.$tk(Z.excludePattern,ae)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&D.$tk(Z.includePattern,ae)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(fe=>{const ee=fe.folder.fsPath;if(T.$zg(ae,ee)){const De=$.$lc(ee,ae);return!fe.includePattern||!!D.$tk(fe.includePattern,De)}else return!1}):!1:!0}var E;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(E||(e.SearchErrorCode=E={}));class R extends Error{constructor(ae,fe){super(ae),this.code=fe}}e.$SK=R;function w(Z){const ae=Z.message;if((0,a.$4)(Z))return new R(ae,E.canceled);try{const fe=JSON.parse(ae);return new R(fe.message,fe.code)}catch{return new R(ae,E.other)}}function m(Z){const ae={message:Z.message,code:Z.code};return new Error(JSON.stringify(ae))}function N(Z){return Z.type==="error"?!0:Z.type==="success"}function B(Z){return Z.type==="success"}function X(Z){return!!Z.path}function V(Z,ae,fe=!0){const ee=Z.searchPath?Z.searchPath:Z.relativePath;return fe?(0,A.$3f)(ee,ae):D.$tk(ae,ee)}class O{constructor(ae){this.path=ae,this.results=[]}addMatch(ae){this.results.push(ae)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$ZK=O;function L(Z,ae){const fe={...Z||{},...ae||{}};return Object.keys(fe).filter(ee=>{const De=fe[ee];return typeof De=="boolean"&&De})}class F{constructor(ae,fe){this.c=null,this.a={...ae.excludePattern||{},...fe.excludePattern||{}},this.b=D.$uk(this.a);let ee=ae.includePattern;fe.includePattern&&(ee?ee={...ee,...fe.includePattern}:ee=fe.includePattern),ee&&(this.c=D.$uk(ee))}matchesExcludesSync(ae,fe,ee){return!!(this.b&&this.b(ae,fe,ee))}includedInQuerySync(ae,fe,ee){return!(this.b&&this.b(ae,fe,ee)||this.c&&!this.c(ae,fe,ee))}includedInQuery(ae,fe,ee){const De=this.b(ae,fe,ee),Fe=()=>this.c?!!this.c(ae,fe,ee):!0;return(0,y.$mh)(De)?De.then(ce=>ce?!1:Fe()):Fe()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$2K=F;function ie(Z){for(const ae in Z)if(typeof Z[ae]!="boolean")return!0;return!1}function de(Z){if(!Z)return;let ae;return fe=>(ae||(ae=(Z()||Promise.resolve([])).then(ee=>ee?ve(ee):{})),ae.then(ee=>!!ee[fe]))}function be(Z){if(!Z)return;let ae;return fe=>{if(!ae){const ee=Z();ae=ee?ve(ee):{}}return!!ae[fe]}}function ve(Z){const ae={};for(const fe of Z)ae[fe]=!0;return ae}}),define(Ce[44],Ie([1,0,18,11,22,4,6,58,16,137,24,13,2,190,30,3,12,213,50,51,27,17,10,7,65,43,5,48]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s,n,i,g,d,l,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cnc=e.$bnc=void 0;function S(X,V,O){return new P.$3g(L=>w(L,O)).isEqual(X,V)}function v(X,V,O){return S(X.uri,V.uri,O)?0:(0,y.$uf)(X.uri.toString(),V.uri.toString())}function E(X,V,O){return X.index!==V.index?X.index<V.index?-1:1:S(X.uri,V.uri,O)?(0,y.$uf)(X.name,V.name):(0,y.$uf)(X.uri.toString(),V.uri.toString())}function R(X,V,O,L){const F=X.slice(0).sort((de,be)=>O(de,be,L)),ie=V.slice(0).sort((de,be)=>O(de,be,L));return(0,b.$Eb)(F,ie,(de,be)=>O(de,be,L))}function w(X,V){const O=V.getCapabilities(X.scheme);return!(O&&O&h.FileSystemProviderCapabilities.PathCaseSensitive)}class m extends f.$Ti{static toExtHostWorkspace(V,O,L,F){if(!V)return{workspace:null,added:[],removed:[]};const{id:ie,name:de,folders:be,configuration:ve,transient:Z,isUntitled:ae}=V,fe=[],ee=O;O?be.forEach((H,he)=>{const le=u.URI.revive(H.uri),re=m.o(L||O,le,F);re?(re.name=H.name,re.index=H.index,fe.push(re)):fe.push({uri:le,name:H.name,index:he})}):fe.push(...be.map(({uri:H,name:he,index:le})=>({uri:u.URI.revive(H),name:he,index:le}))),fe.sort((H,he)=>H.index<he.index?-1:1);const De=new m(ie,de,fe,!!Z,ve?u.URI.revive(ve):null,!!ae,H=>w(H,F)),{added:Fe,removed:ce}=R(ee?ee.workspaceFolders:[],De.workspaceFolders,v,F);return{workspace:De,added:Fe,removed:ce}}static o(V,O,L){for(let F=0;F<V.folders.length;F++){const ie=V.workspaceFolders[F];if(S(ie.uri,O,L))return ie}}constructor(V,O,L,F,ie,de,be){super(V,L.map(ve=>new f.$Ui(ve)),F,ie,be),this.t=O,this.u=de,this.q=[],this.s=M.$Gi.forUris(be),L.forEach(ve=>{this.q.push(ve),this.s.set(ve.uri,ve)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,O){return O&&this.s.get(V)&&(V=(0,P.$ah)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let N=class{constructor(V,O,L,F,ie){this.c=new T.$he,this.onDidChangeWorkspace=this.c.event,this.g=new T.$he,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new T.$je,this.C=new Map,this.h=F,this.s=L,this.t=ie,this.j=new a.$Jm,this.k=new D.$zh,this.o=V.getProxy(p.$vM.MainThreadWorkspace),this.q=V.getProxy(p.$vM.MainThreadMessageService);const de=O.workspace;this.l=de?new m(de.id,de.name,[],!!de.transient,de.configuration?u.URI.revive(de.configuration):null,!!de.isUntitled,be=>w(be,L)):void 0}$initializeWorkspace(V,O){this.v=O,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?u.URI.from({scheme:$.Schemas.untitled,path:(0,P.$$g)((0,P.$ah)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,O,L,...F){const ie=[];if(Array.isArray(F)&&F.forEach(ae=>{u.URI.isUri(ae.uri)&&!ie.some(fe=>S(fe.uri,ae.uri,this.s))&&ie.push({uri:ae.uri,name:ae.name||(0,P.$0g)(ae.uri)})}),this.n||[O,L].some(ae=>typeof ae!="number"||ae<0)||L===0&&ie.length===0)return!1;const de=this.x?this.x.workspaceFolders:[];if(O+L>de.length)return!1;const be=de.slice(0);be.splice(O,L,...ie.map(ae=>({uri:ae.uri,name:ae.name||(0,P.$0g)(ae.uri),index:void 0})));for(let ae=0;ae<be.length;ae++){const fe=be[ae];if(be.some((ee,De)=>De!==ae&&S(fe.uri,ee.uri,this.s)))return!1}be.forEach((ae,fe)=>ae.index=fe);const{added:ve,removed:Z}=R(de,be,E,this.s);if(ve.length===0&&Z.length===0)return!1;if(this.o){const ae=V.displayName||V.name;this.o.$updateWorkspaceFolders(ae,O,L,ie).then(void 0,fe=>{this.n=void 0;const ee={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(c.Severity.Error,(0,k.localize)(0,null,ae,fe.toString()),ee,[])})}return this.y(be),!0}getWorkspaceFolder(V,O){if(this.x)return this.x.getWorkspaceFolder(V,O)}async getWorkspaceFolder2(V,O){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,O)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,O){let L,F="";if(typeof V=="string"?(L=u.URI.file(V),F=V):typeof V<"u"&&(L=V,F=V.fsPath),!L)return F;const ie=this.getWorkspaceFolder(L,!0);if(!ie)return F;typeof O>"u"&&this.x&&(O=this.x.folders.length>1);let de=(0,P.$dh)(ie.uri,L);return O&&ie.name&&(de=`${ie.name}/${de}`),de}y(V){this.x&&(this.n=m.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:O,added:L,removed:F}=m.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=O||void 0,this.n=void 0,this.c.fire(Object.freeze({added:L,removed:F}))}findFiles(V,O,L,F,ie=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let de="",be=!0;return O===null?be=!1:O!==void 0&&(typeof O=="string"?de=O:de=O.pattern),this.z(V,void 0,{exclude:de,maxResults:L,useDefaultExcludes:be,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},ie)}findFiles2(V,O={},L,F=I.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${L.value}, entryPoint: findFiles2`),this.z(void 0,V,O,F)}async z(V,O,L,F=I.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const ie=typeof L.exclude=="string"?L.exclude:L.exclude?L.exclude.pattern:void 0,de={ignoreSymlinks:typeof L.followSymlinks=="boolean"?!L.followSymlinks:void 0,disregardIgnoreFiles:typeof L.useIgnoreFiles=="boolean"?!L.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof L.useGlobalIgnoreFiles=="boolean"?!L.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof L.useParentIgnoreFiles=="boolean"?!L.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof L.useDefaultExcludes=="boolean"?!L.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof L.useDefaultSearchExcludes=="boolean"?!L.useDefaultSearchExcludes:!1,maxResults:L.maxResults,excludePattern:ie,shouldGlobSearch:typeof L.fuzzy=="boolean"?!L.fuzzy:!0,_reason:"startFileSearch"};let be;if(V){const{includePattern:ve,folder:Z}=B(i.GlobPattern.from(V));be=Z,de.includePattern=ve}else{const{includePattern:ve,folder:Z}=B(i.GlobPattern.from(O));be=Z,de.filePattern=ve}return this.o.$startFileSearch(be??null,de,F).then(ve=>Array.isArray(ve)?ve.map(Z=>u.URI.revive(Z)):[])}async findTextInFiles(V,O,L,F,ie=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const de=this.j.getNext(),be=typeof O.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:ve,folder:Z}=B(i.GlobPattern.from(O.include)),ae=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,fe={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:be,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:ve,excludePattern:ae},ee=!1;if(this.u[de]=De=>{if(ee)return;const Fe=u.URI.revive(De.resource);De.results.forEach(ce=>{const H=(0,C.$0h)(ce);(0,l.$JK)(H)?L({uri:Fe,preview:{text:H.preview.text,matches:(0,b.$1b)(H.preview.matches,he=>new g.$zM(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))},ranges:(0,b.$1b)(H.ranges,he=>new g.$zM(he.startLineNumber,he.startColumn,he.endLineNumber,he.endColumn))}):L({uri:Fe,text:H.text,lineNumber:H.lineNumber})})},ie.isCancellationRequested)return{};try{const De=await this.o.$startTextSearch(V,Z??null,fe,de,ie);return delete this.u[de],De||{}}catch(De){throw delete this.u[de],De}}$handleTextSearchResult(V,O){this.u[O]?.(V)}async save(V){const O=await this.o.$save(V,{saveAs:!1});return u.URI.revive(O)}async saveAs(V){const O=await this.o.$save(V,{saveAs:!0});return u.URI.revive(O)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,O){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,O);const L=this.t.transformOutgoingScheme(V),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,L),(0,A.$Sc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(V,O){this.h.info("Getting edit session identifier for workspaceFolder",V);const L=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!L){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",L);const F=this.w.get(L.uri.scheme);if(this.h.info(`Provider for scheme ${L.uri.scheme} is defined: `,!!F),!F)return;const ie=await F.provideEditSessionIdentity(L,O);if(this.h.info("Provider returned edit session identifier: ",ie),!!ie)return ie}async $provideEditSessionIdentityMatch(V,O,L,F){this.h.info("Getting edit session identifier for workspaceFolder",V);const ie=await this.resolveWorkspaceFolder(u.URI.revive(V));if(!ie){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ie);const de=this.w.get(ie.uri.scheme);if(this.h.info(`Provider for scheme ${ie.uri.scheme} is defined: `,!!de),!de)return;const be=await de.provideEditSessionIdentityMatch?.(O,L,F);if(this.h.info("Provider returned edit session identifier match result: ",be),!!be)return be}getOnWillCreateEditSessionIdentityEvent(V){return(O,L,F)=>{const ie=function(be){O.call(L,be)};return ie.extension=V,this.B.event(ie,void 0,F)}}async $onWillCreateEditSessionIdentity(V,O,L){const F=await this.resolveWorkspaceFolder(u.URI.revive(V));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},O,async(ie,de)=>{const be=Date.now();await Promise.resolve(ie),Date.now()-be>L&&this.h.warn("SLOW edit session create-participant",de.extension.identifier)}),O.isCancellationRequested}registerCanonicalUriProvider(V,O){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,O);const L=this.t.transformOutgoingScheme(V),F=this.A++;return this.o.$registerCanonicalUriProvider(F,L),(0,A.$Sc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(V,O,L){const F=this.C.get(V.scheme);if(!F)return;const ie=await F.provideCanonicalUri?.(u.URI.revive(V),O,L);if(ie)return ie}async $provideCanonicalUri(V,O,L){return this.provideCanonicalUri(u.URI.revive(V),{targetScheme:O},L)}};e.$bnc=N,e.$bnc=N=Je([qe(0,n.$ZO),qe(1,s.$dP),qe(2,t.$Wmc),qe(3,o.$7j),qe(4,d.$_mc)],N),e.$cnc=(0,r.$Ai)("IExtHostWorkspace");function B(X){let V,O;return X&&(typeof X=="string"?V=X:(V=X.pattern,O=u.URI.revive(X.baseUri))),{includePattern:V,folder:O}}}),define(Ce[45],Ie([1,0,26,4,44,5,7,42,214,54,15,11,3,17,12,2]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fnc=e.$enc=e.$dnc=void 0;function o(d,l){if(l){const p=l.split(".");let C=d;for(let S=0;C&&S<p.length;S++)C=C[p[S]];return C}}function c(d){return d instanceof r.URI}function f(d){return d&&d.uri instanceof r.URI&&d.languageId&&typeof d.languageId=="string"}function t(d){return d&&!d.uri&&d.languageId&&typeof d.languageId=="string"}function s(d){return d&&d.uri instanceof r.URI&&(!d.name||typeof d.name=="string")&&(!d.index||typeof d.index=="number")}function n(d){if(c(d))return{resource:d};if(f(d))return{resource:d.uri,overrideIdentifier:d.languageId};if(t(d))return{overrideIdentifier:d.languageId};if(s(d))return{resource:d.uri};if(d===null)return{resource:null}}let i=class{constructor(l,p,C){this.a=l.getProxy(T.$vM.MainThreadConfiguration),this.c=p,this.b=C,this.d=new y.$zh,this.e=null}getConfigProvider(){return this.d.wait().then(l=>this.e)}$initializeConfiguration(l){this.e=new g(this.a,this.c,l,this.b),this.d.open()}$acceptConfigurationChanged(l,p){this.getConfigProvider().then(C=>C.$acceptConfigurationChanged(l,p))}};e.$dnc=i,e.$dnc=i=Je([qe(0,k.$ZO),qe(1,I.$cnc),qe(2,h.$7j)],i);class g{constructor(l,p,C,S){this.a=new D.$he,this.b=l,this.f=S,this.c=p,this.e=$.$Io.parse(C,S),this.d=this.k(C.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(l,p){const C={data:this.e.toData(),workspace:this.c.workspace};this.e=$.$Io.parse(l,this.f),this.d=this.k(l.configurationScopes),this.a.fire(this.j(p,C))}getConfiguration(l,p,C){const S=n(p)||{},v=this.g(l?o(this.e.getValue(void 0,S,this.c.workspace),l):this.e.getValue(void 0,S,this.c.workspace));l&&this.h(l,S,C?.identifier);function E(w){if(w==null)return null;if(typeof w=="boolean")return w?M.ConfigurationTarget.USER:M.ConfigurationTarget.WORKSPACE;switch(w){case A.ConfigurationTarget.Global:return M.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return M.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return M.ConfigurationTarget.WORKSPACE_FOLDER}}const R={has(w){return typeof o(v,w)<"u"},get:(w,m)=>{this.h(l?`${l}.${w}`:w,S,C?.identifier);let N=o(v,w);if(typeof N>"u")N=m;else{let B;const X=(V,O)=>{if((0,P.$cg)(V)){let L;const F=()=>{B=B||(0,b.$0n)(v),L=L||o(B,O)};return new Proxy(V,{get:(ie,de)=>{if(typeof de=="string"&&de.toLowerCase()==="tojson")return F(),()=>L;if(B)return L=L||o(B,O),L[de];const be=ie[de];return typeof de=="string"?X(be,`${O}.${de}`):be},set:(ie,de,be)=>(F(),L&&(L[de]=be),!0),deleteProperty:(ie,de)=>(F(),L&&delete L[de],!0),defineProperty:(ie,de,be)=>(F(),L&&Object.defineProperty(L,de,be),!0)})}return Array.isArray(V)?(0,b.$0n)(V):V};N=X(N,w)}return N},update:(w,m,N,B)=>{w=l?`${l}.${w}`:w;const X=E(N);return m!==void 0?this.b.$updateConfigurationOption(X,w,m,S,B):this.b.$removeConfigurationOption(X,w,S,B)},inspect:w=>{w=l?`${l}.${w}`:w;const m=this.e.inspect(w,S,this.c.workspace);if(m)return{key:w,defaultValue:(0,b.$0n)(m.policy?.value??m.default?.value),globalValue:(0,b.$0n)(m.user?.value??m.application?.value),workspaceValue:(0,b.$0n)(m.workspace?.value),workspaceFolderValue:(0,b.$0n)(m.workspaceFolder?.value),defaultLanguageValue:(0,b.$0n)(m.default?.override),globalLanguageValue:(0,b.$0n)(m.user?.override??m.application?.override),workspaceLanguageValue:(0,b.$0n)(m.workspace?.override),workspaceFolderLanguageValue:(0,b.$0n)(m.workspaceFolder?.override),languageIds:(0,b.$0n)(m.overrideIdentifiers)}}};return typeof v=="object"&&(0,b.$ao)(R,v,!1),Object.freeze(R)}g(l){const p=C=>(0,P.$cg)(C)?new Proxy(C,{get:(S,v)=>p(S[v]),set:(S,v,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(S,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(S,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):C;return p(l)}h(l,p,C){const S=a.$zo.test(l)?a.ConfigurationScope.RESOURCE:this.d.get(l),v=C?`[${C.value}] `:"";if(a.ConfigurationScope.RESOURCE===S){typeof p?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${l}', provide the URI of a resource or 'null' for any resource.`);return}if(a.ConfigurationScope.WINDOW===S){p?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${l}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(l,p){const C=new $.$Ko(l,p,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(S,v)=>C.affectsConfiguration(S,n(v))})}k(l){return l.reduce((p,C)=>(p.set(C[0],C[1]),p),new Map)}}e.$enc=g,e.$fnc=(0,u.$Ai)("IExtHostConfiguration")});var tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b},Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)};define(Ce[129],Ie([1,0,2,11,4,5,7,44,71,45,22,57,17,27,3,16,21,12,85,250,14]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Joc=e.$Ioc=e.$Hoc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(X){function V(L){if(L!=null)return L}X.from=V;function O(L){if(L!=null)return L}X.to=O})(i||(i={}));var g;(function(X){function V(L){if(L!=null)return L}X.from=V;function O(L){if(L!=null)return L}X.to=O})(g||(g={}));var d;(function(X){function V(L){if(L!=null)return L}X.from=V;function O(L){if(L!=null)return L}X.to=O})(d||(d={}));var l;(function(X){function V(F){if(F){const ie=F;return ie&&!!ie.process}else return!1}X.is=V;function O(F){if(F==null)return;const ie={process:F.process,args:F.args};return F.options&&(ie.options=d.from(F.options)),ie}X.from=O;function L(F){if(F!=null)return new A.$hN(F.process,F.args,F.options)}X.to=L})(l||(l={}));var p;(function(X){function V(L){if(L!=null)return L}X.from=V;function O(L){if(L!=null)return L}X.to=O})(p||(p={}));var C;(function(X){function V(F){if(F){const ie=F;return ie&&(!!ie.commandLine||!!ie.command)}else return!1}X.is=V;function O(F){if(F==null)return;const ie={};return F.commandLine!==void 0?ie.commandLine=F.commandLine:(ie.command=F.command,ie.args=F.args),F.options&&(ie.options=p.from(F.options)),ie}X.from=O;function L(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.$iN(F.commandLine,F.options):new A.$iN(F.command,F.args?F.args:[],F.options)}X.to=L})(C||(C={}));var S;(function(X){function V(F){if(F){const ie=F;return ie&&ie.customExecution==="customExecution"}else return!1}X.is=V;function O(F){return{customExecution:"customExecution"}}X.from=O;function L(F,ie){return ie.get(F)}X.to=L})(S||(e.CustomExecutionDTO=S={}));var v;(function(X){function V(O,L){let F;return O.scope!==void 0&&typeof O.scope!="number"?F=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===A.TaskScope.Workspace&&L&&L.workspaceFile?F=L.workspaceFile:F=t.$vI),{id:O._id,workspaceFolder:F}}X.from=V})(v||(e.TaskHandleDTO=v={}));var E;(function(X){function V(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}X.from=V})(E||(E={}));var R;(function(X){function V(F,ie){if(F==null)return[];const de=[];for(const be of F){const ve=O(be,ie);ve&&de.push(ve)}return de}X.fromMany=V;function O(F,ie){if(F==null)return;let de;F.execution instanceof A.$hN?de=l.from(F.execution):F.execution instanceof A.$iN?de=C.from(F.execution):F.execution&&F.execution instanceof A.$jN&&(de=S.from(F.execution));const be=i.from(F.definition);let ve;return F.scope?typeof F.scope=="number"?ve=F.scope:ve=F.scope.uri:ve=A.TaskScope.Workspace,!be||!ve?void 0:{_id:F._id,definition:be,name:F.name,source:{extensionId:ie.identifier.value,label:F.source,scope:ve},execution:de,isBackground:F.isBackground,group:E.from(F.group),presentationOptions:g.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}X.from=O;async function L(F,ie,de){if(F==null)return;let be;l.is(F.execution)?be=l.to(F.execution):C.is(F.execution)?be=C.to(F.execution):S.is(F.execution)&&(be=S.to(F._id,de));const ve=i.to(F.definition);let Z;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Z=F.source.scope:Z=await ie.resolveWorkspaceFolder(b.URI.revive(F.source.scope)):Z=A.TaskScope.Workspace),!ve||!Z)return;const ae=new A.$kN(ve,Z,F.name,F.source.label,be,F.problemMatchers);return F.isBackground!==void 0&&(ae.isBackground=F.isBackground),F.group!==void 0&&(ae.group=A.$gN.from(F.group._id),ae.group&&F.group.isDefault&&(ae.group=new A.$gN(ae.group.id,ae.group.label),F.group.isDefault===!0&&(ae.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ae.presentationOptions=g.to(F.presentationOptions)),F._id&&(ae._id=F._id),F.detail&&(ae.detail=F.detail),ae}X.to=L})(R||(e.TaskDTO=R={}));var w;(function(X){function V(L){return L}X.from=V;function O(L){if(L)return Object.assign(Object.create(null),L)}X.to=O})(w||(w={}));class m{constructor(V,O,L){this._id=O,this.a=L,n.set(this,void 0),tt(this,n,V,"f")}get task(){return this.a}terminate(){Be(this,n,"f").terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}n=new WeakMap;let N=class{constructor(V,O,L,F,ie,de,be,ve){this.q=new I.$he,this.r=new I.$he,this.s=new I.$he,this.u=new I.$he,this.a=V.getProxy(T.$vM.MainThreadTask),this.b=L,this.c=F,this.d=ie,this.e=de,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=be,this.g=ve,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,O,L){if(!L)return new A.$xM(()=>{});const F=this.x();return this.j.set(F,{type:O,provider:L,extension:V}),this.a.$registerTaskProvider(F,O),new A.$xM(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(V,O){this.a.$registerTaskSystem(V,O)}fetchTasks(V){return this.a.$fetchTasks(w.from(V)).then(async O=>{const L=[];for(const F of O){const ie=await R.to(F,this.b,this.m);ie&&L.push(ie)}return L})}get taskExecutions(){const V=[];return this.k.forEach(O=>V.push(O)),V}terminateTask(V){if(!(V instanceof m))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,O,L){const F=this.m.get(V.id);F&&(this.o.set(V.id,F),this.e.attachPtyToTerminal(O,await F.callback(L))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const O=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const O=await this.z(V.id);this.s.fire({execution:O,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const O=await this.z(V.id);this.u.fire({execution:O,exitCode:V.exitCode})}$provideTasks(V,O){const L=this.j.get(V);if(!L)return Promise.reject(new Error("no handler found"));const F=[],ie=(0,D.$sh)(()=>L.provider.provideTasks(P.CancellationToken.None)).then(de=>this.v(O,F,L,de));return new Promise(de=>{ie.then(be=>{Promise.all(F).then(()=>{de(be)})})})}async $resolveTask(V,O){const L=this.j.get(V);if(!L)return Promise.reject(new Error("no handler found"));if(O.definition.type!==L.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${L.type}].`);const F=await R.to(O,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const ie=await L.provider.resolveTask(F,P.CancellationToken.None);if(!ie)return;this.A(ie,L);const de=R.from(ie,L.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(ie.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return S.is(de.execution)&&await this.y(de,ie,!0),await this.w(de)}x(){return this.h++}async y(V,O,L){const F=await this.a.$createTaskId(V);!L&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,O.execution)),this.m.set(F,O.execution)}async z(V,O){if(typeof V=="string"){const ie=this.l.get(V);if(!ie)throw new s.$bb("Unexpected: The specified task is missing an execution");return ie}const L=this.l.get(V.id);if(L)return L;let F;return O?F=Promise.resolve(new m(this,V.id,O)):F=R.to(V.task,this.b,this.m).then(ie=>{if(!ie)throw new s.$bb("Unexpected: Task does not exist.");return new m(this,V.id,ie)}),this.l.set(V.id,F),F.then(ie=>(this.k.set(V.id,ie),ie))}A(V,O){V._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const L=this.n.values();let F=L.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=L.next()}};e.$Hoc=N,e.$Hoc=N=Je([qe(0,u.$ZO),qe(1,k.$dP),qe(2,M.$cnc),qe(3,$.$$O),qe(4,a.$fnc),qe(5,y.$Dnc),qe(6,c.$7j),qe(7,f.$Smc)],N);let B=class extends N{constructor(V,O,L,F,ie,de,be,ve){super(V,O,L,F,ie,de,be,ve),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:o.$b(o.Platform.Web)})}async executeTask(V,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const L=R.from(O,V);if(L===void 0)throw new Error("Task is not valid");if(S.is(L.execution))await this.y(L,O,!1);else throw new s.$_;const F=await this.z(await this.a.$getTaskExecution(L),O);return this.a.$executeTask(L).catch(ie=>{throw new Error(ie)}),F}v(V,O,L,F){const ie=[];if(F)for(const de of F){if(this.A(de,L),!de.definition||!V[de.definition.type]){const ve=de.source?de.source:"No task source";this.f.warn(`The task [${ve}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`)}const be=R.from(de,L.extension);be&&S.is(be.execution)?(ie.push(be),O.push(this.y(be,de,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ie,extension:L.extension}}async w(V){if(S.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,O,L){}};e.$Ioc=B,e.$Ioc=B=Je([qe(0,u.$ZO),qe(1,k.$dP),qe(2,M.$cnc),qe(3,$.$$O),qe(4,a.$fnc),qe(5,y.$Dnc),qe(6,c.$7j),qe(7,f.$Smc)],B),e.$Joc=(0,h.$Ai)("IExtHostTask")}),define(Ce[309],Ie([1,0,43,33]),function(_,e,b,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$K=void 0,e.$0K=I,e.$_K=T;function I(A){return"cellResults"in A}e.$$K="rawCell#";function T(A,M){let $=-1;const a=[];let P=[];return A.forEach(u=>{u.range.startLineNumber!==$&&P.length>0&&(a.push([...P]),P=[]),P.push(u),$=u.range.endLineNumber}),P.length>0&&a.push([...P]),a.map(u=>{const k=[],h=u[0].range.startLineNumber,r=u[u.length-1].range.endLineNumber;for(let o=h;o<=r;o++)k.push(M.getLineContent(o));return new b.$NK(k.join(`
`)+`
`,u.map(o=>new D.$dt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ce[310],Ie([1,0,184,23,4,6,29,36,13,15,2,30,80,5,39,10,7,38,286,122,26,16,43,239,309,307]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s,n,i,g,d,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$koc=void 0;class p{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(S=>S.apiEditor)}constructor(S,v,E,R,w,m,N){this.q=E,this.r=R,this.s=w,this.t=m,this.u=N,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new I.$he,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$he,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$he,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$he,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new u.$Qmc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=S.getProxy(k.$vM.MainThreadNotebook),this.c=S.getProxy(k.$vM.MainThreadNotebookDocuments),this.d=S.getProxy(k.$vM.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:B=>{if(B&&B.$mid===M.MarshalledId.NotebookCellActionContext){const X=B.notebookEditor?.notebookUri,V=B.cell.handle,L=this.g.get(X)?.getCell(V);if(L)return L.apiCell}if(B&&B.$mid===M.MarshalledId.NotebookActionContext){const X=B.uri,V=this.g.get(X);if(V)return V.apiNotebook}return B}}),p.C(v)}getEditorById(S){const v=this.h.get(S);if(!v)throw new Error(`unknown text editor: ${S}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(S){for(const[v,E]of this.h)if(E.apiEditor===S)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(S,v){const E=this.g.get(S);if(!E&&!v)throw new Error(`NO notebook document for '${S}'`);return E}static w(S,v){if(!v)return;const E=v.filenamePattern.map(R=>r.NotebookExclusiveDocumentPattern.from(R)).filter(R=>R!==void 0);if(v.filenamePattern&&!E){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:S.identifier,providerDisplayName:S.displayName||S.name,displayName:v.displayName,filenamePattern:E,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(S,v,E){const R=p.a++,w=typeof E.onDidChangeCellStatusBarItems=="function"?p.a++:void 0;this.f.set(R,E),this.b.$registerNotebookCellStatusBarItemProvider(R,w,v);let m;return w!==void 0&&(m=E.onDidChangeCellStatusBarItems(N=>this.b.$emitCellStatusBarEvent(w))),new o.$xM(()=>{this.f.delete(R),this.b.$unregisterNotebookCellStatusBarItemProvider(R,w),m?.dispose()})}async createNotebookDocument(S){const v=await this.c.$tryCreateNotebook({viewType:S.viewType,content:S.content&&r.NotebookData.from(S.content)});return P.URI.revive(v)}async openNotebookDocument(S){const v=this.g.get(S);if(v)return v.apiNotebook;const E=await this.c.$tryOpenNotebook(S),R=this.g.get(P.URI.revive(E));return(0,a.$lg)(R?.apiNotebook)}async showNotebookDocument(S,v){P.URI.isUri(S)&&(S=await this.openNotebookDocument(S));let E;typeof v=="object"?E={position:r.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(r.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:E={preserveFocus:!1};const R=await this.d.$tryShowNotebookDocument(S.uri,S.notebookType,E),w=R&&this.h.get(R)?.apiEditor;if(w)return w;throw R?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(S,v,E,R){const w=this.f.get(S),m=P.URI.revive(v),N=this.g.get(m);if(!N||!w)return;const B=N.getCellFromIndex(E);if(!B)return;const X=await w.provideCellStatusBarItems(B.apiCell,R);if(!X)return;const V=new T.$Tc,O=this.p.add([V]),F=(Array.isArray(X)?X:[X]).map(ie=>r.NotebookStatusBarItem.from(ie,this.i,V));return{cacheId:O,items:F}}$releaseNotebookCellStatusBarItems(S){this.p.delete(S)}registerNotebookSerializer(S,v,E,R,w){if((0,$.$$e)(v))throw new Error("viewType cannot be empty or just whitespace");const m=this.x++;return this.y.set(m,{viewType:v,serializer:E,options:R}),this.b.$registerNotebookSerializer(m,{id:S.identifier,location:S.extensionLocation},v,r.NotebookDocumentContentOptions.from(R),p.w(S,w)),(0,T.$Sc)(()=>{this.b.$unregisterNotebookSerializer(m)})}async $dataToNotebook(S,v,E){const R=this.y.get(S);if(!R)throw new Error("NO serializer found");const w=await R.serializer.deserializeNotebook(v.buffer,E);return new c.$Lw(r.NotebookData.from(w))}async $notebookToData(S,v,E){const R=this.y.get(S);if(!R)throw new Error("NO serializer found");const w=await R.serializer.serializeNotebook(r.NotebookData.to(v.value),E);return D.$Je.wrap(w)}async $saveNotebook(S,v,E,R,w){const m=P.URI.revive(v),N=this.y.get(S);if(this.D(`enter saveNotebook(versionId: ${E}, ${m.toString()})`),!N)throw new Error("NO serializer found");const B=this.g.get(m);if(!B)throw new Error("Document NOT found");if(B.versionId!==E)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(m.scheme))throw new y.$pl((0,b.localize)(0,null,this.A(m)),y.FileOperationResult.FILE_PERMISSION_DENIED);const X={metadata:(0,s.$fo)(B.apiNotebook.metadata,ie=>!(N.options?.transientDocumentMetadata??{})[ie]),cells:[]};for(const ie of B.apiNotebook.getCells()){const de=new o.$1N(ie.kind,ie.document.getText(),ie.document.languageId,ie.mime,N.options?.transientOutputs?[]:[...ie.outputs],ie.metadata,ie.executionSummary);de.metadata=(0,s.$fo)(ie.metadata,be=>!(N.options?.transientCellMetadata??{})[be]),X.cells.push(de)}if(await this.z(m,R),w.isCancellationRequested)throw new Error("canceled");const V=await N.serializer.serializeNotebook(X,w);if(w.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${E} ${m.toString()}`),await this.s.value.writeFile(m,V),this.D(`Finished write versionId: ${E} ${m.toString()}`);const O=this.s.getFileSystemProviderExtUri(m.scheme),L=await this.s.value.stat(m),F={name:O.basename(m),isFile:(L.type&y.FileType.File)!==0,isDirectory:(L.type&y.FileType.Directory)!==0,isSymbolicLink:(L.type&y.FileType.SymbolicLink)!==0,mtime:L.mtime,ctime:L.ctime,size:L.size,readonly:!!((L.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(m.scheme),locked:!!((L.permissions??0)&y.FilePermission.Locked),etag:y.$Al({mtime:L.mtime,size:L.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${E}, ${m.toString()})`),F}async $searchInNotebooks(S,v,E,R,w){const m=this.y.get(S)?.serializer;if(!m)return{limitHit:!1,results:[]};const N=new A.$Bc;await(async(L,F,ie)=>{await Promise.all(L.map(async de=>await Promise.all(de.filenamePatterns.map(be=>{const ve={_reason:ie._reason,folderQueries:ie.folderQueries,includePattern:ie.includePattern,excludePattern:ie.excludePattern,maxResults:ie.maxResults,type:i.QueryType.File,filePattern:be};return this.t.doInternalFileSearchWithCustomCallback(ve,F,Z=>{Z.forEach(ae=>{N.has(ae)||R.some(ee=>de.isFromSettings&&!ee.isFromSettings?!1:ee.filenamePatterns.some(De=>(0,l.$yhb)(De,ae)))||N.add(ae)})}).catch(Z=>{if(Z.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw Z})}))))})(E,w,v);const X=new A.$Ac;let V=!1;const O=Array.from(N).map(async L=>{const F=[];try{if(w.isCancellationRequested)return;if(v.maxResults&&[...X.values()].reduce((ve,Z)=>ve+Z.cellResults.length,0)>v.maxResults){V=!0;return}const ie=[],de=this.g.get(L);if(de)de.apiNotebook.getCells().forEach(Z=>ie.push({input:Z.document.getText(),outputs:Z.outputs.flatMap(ae=>ae.items.map(fe=>fe.data.toString()))}));else{const ve=await this.s.value.readFile(L),Z=D.$Je.fromString(ve.toString()),ae=await m.deserializeNotebook(Z.buffer,w);if(w.isCancellationRequested)return;r.NotebookData.from(ae).cells.forEach(ee=>ie.push({input:ee.source,outputs:ee.outputs.flatMap(De=>De.items.map(Fe=>Fe.valueBytes.toString()))}))}if(w.isCancellationRequested)return;ie.forEach((ve,Z)=>{const ae=v.contentPattern.pattern,fe=new g.$gYb(ve.input,void 0,ve.outputs),ee=fe.findInInputs(ae),De=fe.findInOutputs(ae),Fe=De.flatMap(ce=>(0,d.$_K)(ce.matches,ce.textBuffer)).map((ce,H)=>(ce.webviewIndex=H,ce));if(ee.length>0||De.length>0){const ce={index:Z,contentResults:(0,d.$_K)(ee,fe.inputTextBuffer),webviewResults:Fe};F.push(ce)}});const be={resource:L,cellResults:F};X.set(L,be);return}catch{return}});return await Promise.all(O),{limitHit:V,results:[...X.values()]}}async z(S,v){const E=await this.s.value.stat(S);if(typeof v?.mtime=="number"&&typeof v.etag=="string"&&v.etag!==y.$zl&&typeof E.mtime=="number"&&typeof E.size=="number"&&v.mtime<E.mtime&&v.etag!==y.$Al({mtime:v.mtime,size:E.size}))throw new y.$pl((0,b.localize)(1,null),y.FileOperationResult.FILE_MODIFIED_SINCE,v)}A(S){return S.scheme===n.Schemas.file?S.fsPath:S.toString()}B(S,v,E){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const R=new t.$boc(v,this.d,S,E.visibleRanges.map(r.NotebookRange.to),E.selections.map(r.NotebookRange.to),typeof E.viewColumn=="number"?r.ViewColumn.to(E.viewColumn):void 0);this.h.set(v,R)}$acceptDocumentAndEditorsDelta(S){if(S.value.removedDocuments)for(const E of S.value.removedDocuments){const R=P.URI.revive(E),w=this.g.get(R);w&&(w.dispose(),this.g.delete(R),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:w.apiNotebook.getCells().map(m=>m.document.uri)}),this.n.fire(w.apiNotebook));for(const m of this.h.values())m.notebookData.uri.toString()===R.toString()&&this.h.delete(m.id)}if(S.value.addedDocuments){const E=[];for(const R of S.value.addedDocuments){const w=P.URI.revive(R.uri);if(this.g.has(w))throw new Error(`adding EXISTING notebook ${w} `);const m=new f.$aoc(this.c,this.q,this.r,w,R);E.push(...R.cells.map(N=>f.$_nc.asModelAddData(N))),this.g.get(w)?.dispose(),this.g.set(w,m),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:E}),this.m.fire(m.apiNotebook)}}if(S.value.addedEditors)for(const E of S.value.addedEditors){if(this.h.has(E.id))return;const R=P.URI.revive(E.documentUri),w=this.g.get(R);w&&this.B(w,E.id,E)}const v=[];if(S.value.removedEditors)for(const E of S.value.removedEditors){const R=this.h.get(E);R&&(this.h.delete(E),this.k?.id===R.id&&(this.k=void 0),v.push(R))}if(S.value.visibleEditors){this.l=S.value.visibleEditors.map(R=>this.h.get(R)).filter(R=>!!R);const E=new Set;this.l.forEach(R=>E.add(R.id));for(const R of this.h.values()){const w=E.has(R.id);R._acceptVisibility(w)}this.l=[...this.h.values()].map(R=>R).filter(R=>R.visible),this.o.fire(this.visibleNotebookEditors)}S.value.newActiveEditor===null?this.k=void 0:S.value.newActiveEditor&&(this.h.get(S.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${S.value.newActiveEditor}`),this.k=this.h.get(S.value.newActiveEditor)),S.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(S){const v=h.$lP.String.with("notebookType","A notebook type"),E=new h.$nP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new h.$lP("data","Bytes to convert to data",w=>w instanceof Uint8Array,w=>D.$Je.wrap(w))],new h.$mP("Notebook Data",w=>r.NotebookData.to(w.value))),R=new h.$nP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new h.$lP("NotebookData","Notebook data to convert to bytes",w=>!0,w=>new c.$Lw(r.NotebookData.from(w)))],new h.$mP("Bytes",w=>w.buffer));S.registerApiCommand(E),S.registerApiCommand(R)}D(S){this.u.trace(`[Extension Host Notebook] ${S}`)}}e.$koc=p,p.a=0}),define(Ce[311],Ie([1,0,20,22,49,41,24,69,43]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=void 0;class a{constructor(u,k,h){this.k=u,this.l=k,this.o=h,this.e=!1,this.f=0,this.g=!1,this.a=u.filePattern,this.b=u.includePattern&&T.$uk(u.includePattern),this.c=u.maxResults||void 0,this.d=u.exists,this.h=new Set,this.j=u.excludePattern&&T.$uk(u.excludePattern)}cancel(){this.g=!0,this.h.forEach(u=>u.cancel()),this.h=new Set}search(u){const k=this.k.folderQueries||[];return new Promise((h,r)=>{const o=c=>{this.f++,u(c)};if(this.g)return h({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const f=c.toString(),t=b.$nc(f);this.j&&this.j(f,t)||this.v(o,{base:c,basename:t})}),Promise.all(k.map(c=>this.p(c,o))).then(c=>{h({limitHit:this.e,stats:c[0]||void 0})},c=>{r(new Error((0,I.$lj)(c)))})})}async p(u,k){const h=new D.$se,r=this.q(u),o=this.r(),c=new $.$2K(this.k,u),f=!c.hasSiblingExcludeClauses();let t;try{this.h.add(h),t=M.$be.create();const s=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,h.token),n=t.elapsed(),i=M.$be.create();return this.g&&!this.e||(s&&s.forEach(g=>{const d=b.$gc.relative(u.folder.path,g.path);if(f){const l=b.$nc(g.path);this.v(k,{base:u.folder,relativePath:d,basename:l});return}this.s(o,u.folder,d,k)}),this.g&&!this.e)?null:(this.u(o,c,k),{providerTime:n,postProcessTime:i.elapsed()})}finally{h.dispose(),this.h.delete(h)}}q(u){const k=(0,$.$1K)(this.k.includePattern,u.includePattern),h=(0,$.$1K)(this.k.excludePattern,u.excludePattern);return{folder:u.folder,excludes:h,includes:k,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!u.disregardParentIgnoreFiles,followSymlinks:!u.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}s({pathToEntries:u},k,h,r){if(h===this.a){const c=b.$nc(this.a);this.v(r,{base:k,relativePath:this.a,basename:c})}function o(c){const f=b.$nc(c),t=b.$mc(c);let s=u[t];s||(s=u[t]=[],o(t)),s.push({base:k,relativePath:c,basename:f})}o(h)}u({rootEntries:u,pathToEntries:k},h,r){const o=this,c=this.a;function f(t){const s=(0,$.$4K)(()=>t.map(n=>n.basename));for(let n=0,i=t.length;n<i;n++){const g=t[n],{relativePath:d,basename:l}=g;if(h.matchesExcludesSync(d,l,c!==l?s:void 0))continue;const p=k[d];if(p)f(p);else{if(d===c)continue;o.v(r,g)}if(o.e)break}}f(u)}v(u,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||u(k))}}class P{constructor(){this.b=new Map}fileSearch(u,k,h,r){const o=this.c(u.cacheKey),c=new a(u,k,o&&o.token);let f=0;const t=s=>{f+=s.length,h(s.map(n=>this.d(n)))};return this.e(c,P.a,t,r).then(s=>({limitHit:s.limitHit,stats:s.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:f,detailStats:s.stats}:void 0,messages:[]}))}clearCache(u){this.c(u)?.cancel()}c(u){if(u)return this.b.has(u)||this.b.set(u,new D.$se),this.b.get(u)}d(u){return u.relativePath?{resource:A.$bh(u.base,u.relativePath)}:{resource:u.base}}e(u,k,h,r){const o=r.onCancellationRequested(()=>{u.cancel()}),c=t=>{t&&(f.push(t),k>0&&f.length>=k&&(h(f),f=[]))};let f=[];return u.search(c).then(t=>(f.length&&h(f),o.dispose(),t),t=>(f.length&&h(f),o.dispose(),Promise.reject(t)))}}e.$coc=P,P.a=512}),define(Ce[312],Ie([1,0,18,281,41,99,29,16,20,24,13,15,2,102,204,42,12,50,116,308,43]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_L=void 0,e.$aM=v;let n=class{constructor(R,w,m,N,B){this.a=R,this.b=w,this.c=m,this.d=N,this.e=B}text(R,w,m={}){R=this.f(R,m);const N=this.a.getValue(),B=w&&w.some(V=>!this.a.getValue({resource:V}).search.useRipgrep);return{...this.h(w?.map(c.$Vi),m),type:s.QueryType.Text,contentPattern:R,previewOptions:m.previewOptions,maxFileSize:m.maxFileSize,usePCRE2:N.search.usePCRE2||B||!1,beforeContext:m.beforeContext,afterContext:m.afterContext,userDisabledExcludesAndIgnoreFiles:m.disregardExcludeSettings&&m.disregardIgnoreFiles}}f(R,w){const m=this.a.getValue();R.isRegExp&&(R.pattern=R.pattern.replace(/\r?\n/g,"\\n"));const N={...R,wordSeparators:m.editor.wordSeparators};return this.j(R,w)&&(N.isCaseSensitive=!0),this.k(R)&&(N.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),N}file(R,w={}){return{...this.h(R,w),type:s.QueryType.File,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey,shouldGlobMatchFilePattern:w.shouldGlobSearch}}g(R,w){return R?(R=Array.isArray(R)?R.map(p):p(R),w?this.parseSearchPaths(R):{pattern:g(...Array.isArray(R)?R:[R])}):{}}h(R=[],w={}){const m=this.g(w.includePattern,w.expandPatterns),N=this.g(w.excludePattern,w.expandPatterns),B=R.length>1,X=(m.searchPaths&&m.searchPaths.length?m.searchPaths.map(L=>this.q(L,w,N)):R.map(L=>this.r(L,w,N,B))).filter(L=>!!L),V={_reason:w._reason,folderQueries:X,usingSearchPaths:!!(m.searchPaths&&m.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:N.pattern,includePattern:m.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const L=b.$Hb(this.c.groups.flatMap(de=>de.editors.map(be=>be.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(L));const F=L.filter(de=>(0,s.$RK)(V,de.fsPath)),ie=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...V,...ie}}const O=w.extraFileResources&&w.extraFileResources.filter(L=>(0,s.$RK)(V,L.fsPath));return V.extraFileResources=O&&O.length?O:void 0,V}i(R){const w=[],m=new A.$Ac,N={};let B=!1;return R.forEach(X=>{if(X.scheme===M.Schemas.walkThrough)return;if((0,a.$fh)(X)){const O=this.b.getWorkspaceFolder(X)?.uri??X.with({path:$.$mc(X.fsPath)});let L=m.get(O);L||(B=!0,L={folder:O,includePattern:{}},w.push(L),m.set(O,L));const F=$.$lc(O.fsPath,X.fsPath);(0,y.$lg)(L.includePattern)[F.replace(/\\/g,"/")]=!0}else X.fsPath&&(B=!0,N[X.fsPath]=!0)}),{folderQueries:w,includePattern:N,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}j(R,w){if(w.isSmartCase){if(R.isRegExp){if(P.$4f(R.pattern,!0))return!0}else if(P.$4f(R.pattern))return!0}return!!R.isCaseSensitive}k(R){return R.isMultiline||R.isRegExp&&(0,k.$3C)(R.pattern)||R.pattern.indexOf(`
`)>=0?!0:!!R.isMultiline}parseSearchPaths(R){const w=ie=>$.$ic(ie)||/^\.\.?([\/\\]|$)/.test(ie),N=(Array.isArray(R)?R:d(R)).map(ie=>{const de=this.e.resolvedUserHome;return de?(0,T.$Qw)(ie,de.scheme===M.Schemas.file?de.fsPath:de.path):ie}),B=D.$E(N,ie=>w(ie)?"searchPaths":"exprSegments"),X=(B.exprSegments||[]).map(ie=>P.$jf(ie,"/")).map(ie=>P.$jf(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),l(ie))),V={},O=this.m(B.searchPaths||[]);O&&O.length&&(V.searchPaths=O);const L=X.flat(),F=g(...L);return F&&(V.pattern=F),V}l(R,w){return w.disregardExcludeSettings?void 0:(0,s.$QK)(R,!w.disregardSearchExcludeSettings)}m(R){if(!R||!R.length)return[];const w=R.flatMap(N=>{let{pathPortion:B,globPortion:X}=i(N);return X&&(X=C(X)),this.n(B).flatMap(O=>this.o(O,X))}),m=new Map;return w.forEach(N=>{const B=N.searchPath.toString(),X=m.get(B);X?N.pattern&&(X.pattern=X.pattern||{},X.pattern[N.pattern]=!0):m.set(B,{searchPath:N.searchPath,pattern:N.pattern?g(N.pattern):void 0})}),Array.from(m.values())}n(R){if($.$ic(R)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==M.Schemas.file?[{searchPath:w[0].uri.with({path:R})}]:[{searchPath:u.URI.file($.$hc(R))}]}if(this.b.getWorkbenchState()===c.WorkbenchState.FOLDER){const w=this.b.getWorkspace().folders[0].uri;if(R=p(R),R.startsWith("../")||R===".."){const N=$.$gc.resolve(w.path,R);return[{searchPath:w.with({path:N})}]}const m=C(R);return[{searchPath:w,pattern:m}]}else{if(R==="./"||R===".\\")return[];{const w=R.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(B=>{const X=w.match(new RegExp(`^${P.$df(B.name)}(?:/(.*)|$)`));return X?{match:X,folder:B}:null}).filter(y.$ig);if(N.length)return N.map(B=>{const X=B.match[1];return{searchPath:B.folder.uri,pattern:X&&C(X)}});{const B=R.match(/\.[\/\\](.+)[\/\\]?/),X=B?B[1]:R,V=h.localize(0,null,X);throw new Error(V)}}}}o(R,w){const m=R.pattern&&w?`${R.pattern}/${w}`:R.pattern||w,N=[{searchPath:R.searchPath,pattern:m}];return m&&!m.endsWith("**")&&N.push({searchPath:R.searchPath,pattern:m+"/**"}),N}q(R,w,m){const N=this.r((0,c.$Vi)(R.searchPath),w,m,!1);return N?{...N,includePattern:R.pattern}:null}r(R,w,m,N){let B;const X=u.URI.isUri(R)?R:R.uri;if(m.searchPaths){const ie=m.searchPaths.filter(de=>(0,a.$7g)(de.searchPath,X))[0];if(ie&&!ie.pattern)return null;ie&&(B=ie.pattern)}const V=this.a.getValue({resource:X}),L={...this.l(V,w)||{},...B||{}},F=u.URI.isUri(R)?(0,a.$$g)(R):R.name;return{folder:X,folderName:N?F:void 0,excludePattern:Object.keys(L).length>0?L:void 0,fileEncoding:V.files&&V.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!V.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!V.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!V.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!V.search.followSymlinks}}};e.$_L=n,e.$_L=n=Je([qe(0,r.$7i),qe(1,c.$Ji),qe(2,f.$$D),qe(3,o.$7j),qe(4,t.$0L)],n);function i(E){const R=E.match(/[\*\{\}\(\)\[\]\?]/);if(R){const w=R.index,m=E.substr(0,w).match(/[/|\\][^/\\]*$/);if(m){let N=E.substr(0,m.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:E.substr((m.index||0)+1)}}}return{pathPortion:E}}function g(...E){return E.length?E.reduce((R,w)=>(R[w]=!0,R),Object.create(null)):void 0}function d(E){return I.$sk(E,",").map(R=>R.trim()).filter(R=>!!R.length)}function l(E){return[`**/${E}/**`,`**/${E}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function p(E){return E.replace(/\\/g,"/")}function C(E){return p(E).replace(/^\.\//,"").replace(/\/+$/g,"")}function S(E){return E.replace(/([?*[\]])/g,"[$1]")}function v(E,R){E=b.$Mb(E,N=>N.toString());const w=[],m=R.getWorkspace();return E&&E.forEach(N=>{let B;if(R.getWorkbenchState()===c.WorkbenchState.FOLDER)B=(0,a.$dh)(m.folders[0].uri,N),B&&B!=="."&&(B="./"+B);else{const X=R.getWorkspaceFolder(N);if(X){const V=X.name;if(m.folders.filter(L=>L.name===V).length===1){const L=(0,a.$dh)(X.uri,N);L===""?B=`./${X.name}`:B=`./${X.name}/${L}`}else B=N.fsPath}}B&&w.push(S(B))}),w}}),define(Ce[313],Ie([1,0,24,2,22,14,3,312,43,50,11]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Twb=u,e.$Uwb=r;const y=7e3;function u(o,c){const f=c.activationEvents;if(!f)return Promise.resolve(void 0);const t=[],s=[];for(const p of f)if(/^workspaceContains:/.test(p)){const C=p.substr(18);C.indexOf("*")>=0||C.indexOf("?")>=0||o.forceUsingSearch?s.push(C):t.push(C)}if(t.length===0&&s.length===0)return Promise.resolve(void 0);const{promise:n,resolve:i}=(0,P.$th)(),g=p=>i({activationEvent:p}),d=Promise.all(t.map(p=>k(o,p,g))).then(()=>{}),l=h(o,c.identifier,s,g);return Promise.all([d,l]).then(()=>{i(void 0)}),n}async function k(o,c,f){for(const t of o.folders)if(await o.exists(b.$bh(D.URI.revive(t),c))){f(`workspaceContains:${c}`);return}}async function h(o,c,f,t){if(f.length===0)return Promise.resolve(void 0);const s=new I.$se,n=o.checkExists(o.folders,f,s.token),i=setTimeout(async()=>{s.cancel(),o.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${f.join(",")}`)},y);let g=!1;try{g=await n}catch(d){T.$4(d)||T.$1(d)}s.dispose(),clearTimeout(i),g&&t(`workspaceContains:${f.join(",")}`)}function r(o,c,f,t){const s=o.get(A.$zi),n=o.get($.$IK),g=s.createInstance(M.$_L).file(c.map(d=>(0,a.$Vi)(D.URI.revive(d))),{_reason:"checkExists",includePattern:f,exists:!0});return n.fileSearch(g,t).then(d=>!!d.limitHit,d=>T.$4(d)?!1:Promise.reject(d))}});var tt=this&&this.__classPrivateFieldSet||function(_,e,b,D,I){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?_!==e||!I:!e.has(_))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?I.call(_,b):I?I.value=b:e.set(_,b),b},Be=this&&this.__classPrivateFieldGet||function(_,e,b,D){if(b==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?_!==e||!D:!e.has(_))throw new TypeError("Cannot read private member from an object whose class did not declare it");return b==="m"?D:b==="a"?D.call(_):D?D.value:e.get(_)};define(Ce[46],Ie([1,0,180,20,64,24,11,6,58,2,12,5,45,246,89,44,25,117,14,19,23,228,7,108,3,27,92,17,75,93,57,95,4,313,88,230,16,86,69,21,87]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s,n,i,g,d,l,p,C,S,v,E,R,w,m,N,B,X,V,O,L,F){"use strict";var ie,de,be,ve;Object.defineProperty(e,"__esModule",{value:!0}),e.$Unc=e.$Tnc=e.$Snc=e.$Rnc=e.$Qnc=void 0,e.$Qnc=(0,d.$Ai)("IHostUtils");let Z=ve=class extends M.$Uc{constructor(le,re,ue,oe,J,Y,we,pe,Me,Ve,Se,Pe,Te){super(),this.Y=Pe,this.Z=Te,this.a=this.B(new w.$he),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=re,this.g=ue,this.f=we,this.j=oe,this.m=J,this.s=Y,this.t=Me,this.u=Ve,this.w=Se,this.y=this.g.getProxy(y.$vM.MainThreadWorkspace),this.z=this.g.getProxy(y.$vM.MainThreadTelemetry),this.C=this.g.getProxy(y.$vM.MainThreadExtensionService),this.D=new A.$zh,this.F=new A.$zh,this.G=new A.$zh,this.H=new A.$zh,this.I=new H(this.f.extensions.activationEvents),this.L=new c.$lbc(this.I,this.f.extensions.allExtensions);const U=new t.$Ym(this.f.extensions.myExtensions);this.J=new c.$lbc(this.I,Fe(this.L,U)),L.$n&&(this.s.info(`Creating extension host with the following global extensions: ${ee(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ee(this.J)}`)),this.M=new h.$znc(this.g,this.s),this.N=new N.$Jnc(this.g),this.O=pe,this.h=le.createChild(new S.$yi([h.$Anc,this.M],[N.$Knc,this.N])),this.P=this.B(new k.$ync(this.J,this.L,{onExtensionActivationError:(W,G,K)=>{this.C.$onExtensionActivationError(W,f.$3(G),K)},actualActivateExtension:async(W,G)=>{if(c.$lbc.isHostExtension(W,this.J,this.L))return await this.C.$activateExtension(W,G),new k.$xnc;const K=this.J.getExtensionDescription(W);return this.fb(K,G)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(le){f.$1(le)}}async $(){this.O.onWillDeactivateAll();let le=[];try{le=this.J.getAllExtensionDescriptions().map(J=>J.identifier).filter(J=>this.isActivated(J)).map(J=>this.eb(J))}catch{}await Promise.all(le)}terminate(le,re=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${le}`),this.s.flush(),this.u.dispose(),this.P.dispose(),f.setUnexpectedErrorHandler(oe=>{this.s.error(oe)}),this.g.dispose();const ue=this.$();Promise.race([(0,A.$Bh)(5e3),ue]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${re}`):this.s.info(`Extension host exiting with code ${re}`),this.s.flush(),this.s.dispose(),this.c.exit(re)})}isActivated(le){return this.G.isOpen()?this.P.isActivated(le):!1}async getExtension(le){const re=await this.C.$getExtension(le);return re&&{...re,identifier:new t.$Xm(re.identifier.value),extensionLocation:a.URI.revive(re.extensionLocation)}}ab(le,re){return this.P.activateByEvent(le,re)}bb(le,re){return this.P.activateById(le,re)}activateByIdWithErrors(le,re){return this.bb(le,re).then(()=>{const ue=this.P.getActivatedExtension(le);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(le=>this.J)}getExtensionExports(le){if(this.G.isOpen())return this.P.getActivatedExtension(le).exports;try{return this.P.getActivatedExtension(le).exports}catch{return null}}async cb(le){if(le.scheme===X.Schemas.file&&this.c.fsRealpath){const re=le.fsPath;this.R.has(re)||this.R.set(re,this.c.fsRealpath(re));const ue=await this.R.get(re);return a.URI.file(ue)}return le}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(le=>new ce(le))),this.Q}async db(le){const re=$.$Gi.forUris(ue=>T.$5g.ignorePathCasing(ue));return await Promise.all(le.map(async ue=>{if(this.wb(ue)){const oe=await this.cb(ue.extensionLocation);re.set(oe,ue)}})),re}eb(le){let re=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(le))return re;const ue=this.P.getActivatedExtension(le);if(!ue)return re;try{typeof ue.module.deactivate=="function"&&(re=Promise.resolve(ue.module.deactivate()).then(void 0,oe=>(this.s.error(oe),Promise.resolve(void 0))))}catch(oe){this.s.error(`An error occurred when deactivating the extension '${le.value}':`),this.s.error(oe)}try{(0,M.$Pc)(ue.subscriptions)}catch(oe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${le.value}':`),this.s.error(oe)}return re}async fb(le,re){return this.f.remote.isRemote?this.C.$onWillActivateExtension(le.identifier):await this.C.$onWillActivateExtension(le.identifier),this.hb(le,re).then(ue=>{const oe=ue.activationTimes;return this.C.$onDidActivateExtension(le.identifier,oe.codeLoadingTime,oe.activateCallTime,oe.activateResolvedTime,re),this.gb(le,re,"success",oe),ue},ue=>{throw this.gb(le,re,"failure"),ue})}gb(le,re,ue,oe){const J=fe(le,re);this.z.$publicLog2("extensionActivationTimes",{...J,...oe||{},outcome:ue})}hb(le,re){const ue=fe(le,re);this.z.$publicLog2("activatePlugin",ue);const oe=this.wb(le);if(!oe)return Promise.resolve(new k.$wnc(k.$tnc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${le.identifier.value}, startup: ${re.startup}, activationEvent: '${re.activationEvent}'${le.identifier.value!==re.extensionId.value?`, root cause: ${re.extensionId.value}`:""}`),this.s.flush();const J=new k.$unc(re.startup);return Promise.all([this.xb(le,(0,T.$bh)(le.extensionLocation,oe),J),this.ib(le)]).then(Y=>(I.mark(`code/extHost/willActivateExtension/${le.identifier.value}`),ve.jb(this.s,le.identifier,Y[0],Y[1],J))).then(Y=>(I.mark(`code/extHost/didActivateExtension/${le.identifier.value}`),Y))}ib(le){const re=this.Z.createLanguageModelAccessInformation(le),ue=new n.$Cnc(le,this.M),oe=new n.$Bnc(le.identifier.value,!1,this.M),J=new B.$Lnc(le,this.N),Y=le.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,we=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${le.identifier.value}`),Promise.all([ue.whenReady,oe.whenReady,this.O.whenReady]).then(()=>{const pe=this;let Me,Ve;const Se=(0,o.$UG)(le,"ipc")?this.f.messagePorts?.get(t.$Xm.toKey(le.identifier)):void 0;return Object.freeze({globalState:ue,workspaceState:oe,secrets:J,subscriptions:[],get languageModelAccessInformation(){return re},get extensionUri(){return le.extensionLocation},get extensionPath(){return le.extensionLocation.fsPath},asAbsolutePath(Pe){return D.$jc(le.extensionLocation.fsPath,Pe)},get storagePath(){return pe.O.workspaceValue(le)?.fsPath},get globalStoragePath(){return pe.O.globalValue(le).fsPath},get logPath(){return D.$jc(pe.f.logsLocation.fsPath,le.identifier.value)},get logUri(){return a.URI.joinPath(pe.f.logsLocation,le.identifier.value)},get storageUri(){return pe.O.workspaceValue(le)},get globalStorageUri(){return pe.O.globalValue(le)},get extensionMode(){return Y},get extension(){return Me===void 0&&(Me=new De(pe,le.identifier,le,we,!1)),Me},get extensionRuntime(){return(0,o.$VG)(le,"extensionRuntime"),pe.extensionRuntime},get environmentVariableCollection(){return pe.u.getEnvironmentVariableCollection(le)},get messagePassingProtocol(){if(!Ve){if(!Se)return;const Pe=w.Event.buffer(w.Event.fromDOMEventEmitter(Se,"message",Te=>Te.data));Se.start(),Ve={onDidReceiveMessage:Pe,postMessage:Se.postMessage.bind(Se)}}return Ve}})})}static jb(le,re,ue,oe,J){return ue=ue||{activate:void 0,deactivate:void 0},this.kb(le,re,ue,oe,J).then(Y=>new k.$vnc(!1,null,J.build(),ue,Y,oe.subscriptions))}static kb(le,re,ue,oe,J){if(typeof ue.activate=="function")try{J.activateCallStart(),le.trace(`ExtensionService#_callActivateOptional ${re.value}`);const Y=typeof global=="object"?global:self,we=ue.activate.apply(Y,[oe]);return J.activateCallStop(),J.activateResolveStart(),Promise.resolve(we).then(pe=>(J.activateResolveStop(),pe))}catch(Y){return Promise.reject(Y)}else return Promise.resolve(ue)}lb(le,re){this.bb(le.identifier,{startup:!1,extensionId:le.identifier,activationEvent:re}).then(void 0,ue=>{this.s.error(ue)})}mb(le,re=0){const oe=Date.now();(0,L.$v)(()=>{for(let J=re;J<le.length;J+=1){const Y=le[J];for(const we of Y.activationEvents??[])if(we==="onStartupFinished")if(Date.now()-oe>50){this.mb(le,J);break}else this.lb(Y,we)}})}nb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(le=>{const re=le.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ue=this.J.getAllExtensionDescriptions();if(re)this.mb(ue);else for(const oe of ue)if(oe.activationEvents)for(const J of oe.activationEvents)J==="onStartupFinished"&&this.lb(oe,J)})}ob(){const le=this.ab("*",!0).then(void 0,Y=>{this.s.error(Y)});this.B(this.j.onDidChangeWorkspace(Y=>this.pb(Y.added)));const re=this.j.workspace?this.j.workspace.folders:[],ue=this.pb(re),oe=this.rb(),J=Promise.all([oe,le,ue]).then(()=>{});return Promise.race([J,(0,A.$Bh)(1e4)]).then(()=>{this.nb()}),J}pb(le){return le.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(re=>this.qb(le,re))).then(()=>{})}async qb(le,re){if(this.isActivated(re.identifier))return;const ue=!this.f.remote.isRemote&&!!this.f.remote.authority,oe={logService:this.s,folders:le.map(Y=>Y.uri),forceUsingSearch:ue||!this.c.fsExists,exists:Y=>this.c.fsExists(Y.fsPath),checkExists:(Y,we,pe)=>this.y.$checkExists(Y,we,pe)},J=await(0,m.$Twb)(oe,re);if(J)return this.bb(re.identifier,{startup:!0,extensionId:re.identifier,activationEvent:J.activationEvent}).then(void 0,Y=>this.s.error(Y))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(le){throw console.error(le),le}}async sb(){const{extensionDevelopmentLocationURI:le,extensionTestsLocationURI:re}=this.f.environment;if(!le||!re)throw new Error(b.localize(0,null));const ue=await this.xb(null,re,new k.$unc(!1));if(!ue||typeof ue.run!="function")throw new Error(b.localize(1,null,re.toString()));return new Promise((oe,J)=>{const Y=(Me,Ve)=>{Me?(L.$n&&this.s.error("Test runner called back with error",Me),J(Me)):(L.$n&&(Ve?this.s.info(`Test runner called back with ${Ve} failures.`):this.s.info("Test runner called back with successful outcome.")),oe(typeof Ve=="number"&&Ve>0?1:0))},we=(0,T.$2g)(re),pe=ue.run(we,Y);pe&&pe.then&&pe.then(()=>{L.$n&&this.s.info("Test runner finished successfully."),oe(0)}).catch(Me=>{L.$n&&this.s.error("Test runner finished with error",Me),J(Me instanceof Error&&Me.stack?Me.stack:String(Me))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Bh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(le,re){return this.S[le]=re,(0,M.$Sc)(()=>{delete this.S[le]})}async getRemoteExecServer(le){const{resolver:re}=await this.ub(le);return re?.resolveExecServer?.(le,{resolveAttempt:0})}async ub(le){const re=le.indexOf("+");if(re===-1)throw new i.$DM("Not an authority that can be resolved!",g.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ue=le.substr(0,re);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this.S[ue]}}async $resolveAuthority(le,re){const ue=O.$be.create(!1),oe=()=>`[resolveAuthority(${(0,g.$Pl)(le)},${re})][${ue.elapsed()}ms] `,J=x=>this.s.info(`${oe()}${x}`),Y=x=>this.s.warn(`${oe()}${x}`),we=(x,ge=void 0)=>this.s.error(`${oe()}${x}`,ge),pe=x=>{if(x instanceof i.$DM)return{type:"error",error:{code:x._code,message:x._message,detail:x._detail}};throw x},Me=async x=>{J(`activating resolver for ${x}...`);const{resolver:ge,authorityPrefix:Re}=await this.ub(x);if(!ge)throw we(`no resolver for ${Re}`),new i.$DM(`No remote extension installed to resolve ${Re}.`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:ge,authorityPrefix:Re,remoteAuthority:x}},Ve=le.split(/@|%40/g).reverse();J(`activating remote resolvers ${Ve.join(" -> ")}`);let Se;try{Se=await Promise.all(Ve.map(Me)).catch(async x=>{if(!(x instanceof i.$DM)||x._code!==g.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw x;return Y(`resolving nested authorities failed: ${x.message}`),[await Me(le)]})}catch(x){return pe(x)}const Pe=new A.$Lh;Pe.cancelAndSet(()=>J("waiting..."),1e3);let Te,U;for(const[x,{authorityPrefix:ge,resolver:Re,remoteAuthority:Ue}]of Se.entries())try{if(x===Se.length-1)J("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${ge}`),Te=await Re.resolve(Ue,{resolveAttempt:re,execServer:U}),I.mark(`code/extHost/didResolveAuthorityOK/${ge}`),J("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Re,i.$CM.isManagedResolvedAuthority(Te)?Te:void 0));else{if(J(`invoking resolveExecServer() for ${Ue}`),I.mark(`code/extHost/willResolveExecServer/${ge}`),U=await Re.resolveExecServer?.(Ue,{resolveAttempt:re,execServer:U}),!U)throw new i.$DM(`Exec server was not available for ${Ue}`,g.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${ge}`)}}catch(Ke){return I.mark(`code/extHost/didResolveAuthorityError/${ge}`),we("returned an error",Ke),Pe.dispose(),pe(Ke)}Pe.dispose();const W={environmentTunnels:Te.environmentTunnels,features:Te.tunnelFeatures?{elevation:Te.tunnelFeatures.elevation,privacyOptions:Te.tunnelFeatures.privacyOptions,protocol:Te.tunnelFeatures.protocol===void 0?!0:Te.tunnelFeatures.protocol}:void 0},G={extensionHostEnv:Te.extensionHostEnv,isTrusted:Te.isTrusted,authenticationSession:Te.authenticationSessionForInitializingExtensions?{id:Te.authenticationSessionForInitializingExtensions.id,providerId:Te.authenticationSessionForInitializingExtensions.providerId}:void 0};J(`returned ${i.$CM.isManagedResolvedAuthority(Te)?"managed authority":`${Te.host}:${Te.port}`}`);let K;if(i.$CM.isManagedResolvedAuthority(Te)){const x=re;this.Y.setFactory(x,Te.makeConnection),K={authority:le,connectTo:new g.$Ml(x),connectionToken:Te.connectionToken}}else K={authority:le,connectTo:new g.$Nl(Te.host,Te.port),connectionToken:Te.connectionToken};return{type:"ok",value:{authority:K,options:G,tunnelInformation:W}}}async $getCanonicalURI(le,re){this.s.info(`$getCanonicalURI invoked for authority (${(0,g.$Pl)(le)})`);const{resolver:ue}=await this.ub(le);if(!ue)return null;const oe=a.URI.revive(re);if(typeof ue.getCanonicalURI>"u")return oe;const J=await(0,A.$sh)(()=>ue.getCanonicalURI(oe));return J||oe}async $startExtensionHost(le){le.toAdd.forEach(Y=>Y.extensionLocation=a.URI.revive(Y.extensionLocation));const{globalRegistry:re,myExtensions:ue}=ae(this.I,this.L,this.J,le),oe=await this.db(ue);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(re.getAllExtensionDescriptions()),this.J.set(ue),L.$n&&(this.s.info(`$startExtensionHost: global extensions: ${ee(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ee(this.J)}`)),this.tb()}$activateByEvent(le,re){return re===o.ActivationKind.Immediate?this.D.wait().then(ue=>this.ab(le,!1)):this.G.wait().then(ue=>this.ab(le,!1))}async $activate(le,re){return await this.G.wait(),this.J.getExtensionDescription(le)?(await this.bb(le,re),!0):!1}async $deltaExtensions(le){le.toAdd.forEach(Y=>Y.extensionLocation=a.URI.revive(Y.extensionLocation));const{globalRegistry:re,myExtensions:ue}=ae(this.I,this.L,this.J,le),oe=await this.db(ue);return(await this.getExtensionPathIndex()).setSearchTree(oe),this.L.set(re.getAllExtensionDescriptions()),this.J.set(ue),L.$n&&(this.s.info(`$deltaExtensions: global extensions: ${ee(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ee(this.J)}`)),Promise.resolve(void 0)}async $test_latency(le){return le}async $test_up(le){return le.byteLength}async $test_down(le){const re=s.$Je.alloc(le),ue=Math.random()%256;for(let oe=0;oe<le;oe++)re.writeUInt8(ue,oe);return re}async $updateRemoteConnectionData(le){this.X=le,this.a.fire()}};e.$Rnc=Z,e.$Rnc=Z=ve=Je([qe(0,d.$zi),qe(1,e.$Qnc),qe(2,C.$ZO),qe(3,r.$cnc),qe(4,u.$fnc),qe(5,P.$7j),qe(6,l.$dP),qe(7,p.$inc),qe(8,v.$wEb),qe(9,E.$Dnc),qe(10,V.$Nnc),qe(11,F.$Onc),qe(12,R.$Hnc)],Z);function ae(he,le,re,ue){he.addActivationEvents(ue.addActivationEvents);const oe=new c.$lbc(he,le.getAllExtensionDescriptions());oe.deltaExtensions(ue.toAdd,ue.toRemove);const J=new t.$Ym(re.getAllExtensionDescriptions().map(we=>we.identifier));for(const we of ue.myToRemove)J.delete(we);for(const we of ue.myToAdd)J.add(we);const Y=Fe(oe,J);return{globalRegistry:oe,myExtensions:Y}}function fe(he,le){return{id:he.identifier.value,name:he.name,extensionVersion:he.version,publisherDisplayName:he.publisher,activationEvents:he.activationEvents?he.activationEvents.join(","):null,isBuiltin:he.isBuiltin,reason:le.activationEvent,reasonId:le.extensionId.value}}function ee(he){return he.getAllExtensionDescriptions().map(le=>le.identifier.value).join(",")}e.$Snc=(0,d.$Ai)("IExtHostExtensionService");class De{constructor(le,re,ue,oe,J){ie.set(this,void 0),de.set(this,void 0),be.set(this,void 0),tt(this,ie,le,"f"),tt(this,de,re,"f"),tt(this,be,ue.identifier,"f"),this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=D.$hc((0,T.$2g)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=oe,this.isFromDifferentExtensionHost=J}get isActive(){return Be(this,ie,"f").isActivated(Be(this,be,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,ie,"f").getExtensionExports(Be(this,be,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,ie,"f").activateByIdWithErrors(Be(this,be,"f"),{startup:!1,extensionId:Be(this,de,"f"),activationEvent:"api"}),this.exports}}e.$Tnc=De,ie=new WeakMap,de=new WeakMap,be=new WeakMap;function Fe(he,le){return he.getAllExtensionDescriptions().filter(re=>le.has(re.identifier))}class ce{constructor(le){this.a=le}setSearchTree(le){this.a=le}findSubstr(le){return this.a.findSubstr(le)}forEach(le){return this.a.forEach(le)}}e.$Unc=ce;class H{constructor(le){this.a=new t.$Zm,this.addActivationEvents(le)}readActivationEvents(le){return this.a.get(le.identifier)??[]}addActivationEvents(le){for(const re of Object.keys(le))this.a.set(re,le[re])}}}),define(Ce[314],Ie([1,0,64,2,5,45,25,19,17,27,3,46,12,13]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$4oc=void 0;let r=class{constructor(s,n,i,g,d,l,p){this.c=s,this.d=n,this.f=i,this.g=g,this.h=d,this.i=l,this.j=p,this.a=new Map,this.b=[]}async install(){this.k(),b.mark("code/extHost/willWaitForConfig");const s=await this.g.getConfigProvider();b.mark("code/extHost/didWaitForConfig");const n=await this.h.getExtensionPathIndex();this.register(new c(this.c,n,this.d,s,this.j)),this.register(this.f.createInstance(o)),this.i.remote.isRemote&&this.register(this.f.createInstance(f,n,this.i.environment.appUriScheme))}register(s){if("nodeModuleName"in s)if(Array.isArray(s.nodeModuleName))for(const n of s.nodeModuleName)this.a.set(n,s);else this.a.set(s.nodeModuleName,s);typeof s.alternativeModuleName=="function"&&this.b.push(n=>s.alternativeModuleName(n))}};e.$4oc=r,e.$4oc=r=Je([qe(2,P.$zi),qe(3,T.$fnc),qe(4,y.$Snc),qe(5,a.$dP),qe(6,u.$7j)],r);let o=h=class{constructor(s){if(s.environment.appRoot&&h.a.size){const n=(0,k.$df)(this.c(s.environment.appRoot.fsPath)),i="[a-z0-9_.-]",g=`@${i}+\\/${i}+|${i}+`,d="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${n}/${d}\\/)(${g})(.*)$`,"i")}}alternativeModuleName(s){if(!this.b)return;const n=this.b.exec(this.c(s));if(!n)return;const[,i,g,d]=n,l=h.a.get(g);if(l!==void 0)return console.warn(`${g} as been renamed to ${l}, please update your imports`),i+l+d}c(s){return s.replace(/\\/g,"/")}};o.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),o=h=Je([qe(0,a.$dP)],o);class c{constructor(s,n,i,g,d){this.c=s,this.d=n,this.e=i,this.f=g,this.g=d,this.nodeModuleName="vscode",this.a=new M.$Zm}load(s,n){const i=this.d.findSubstr(n);if(i){let g=this.a.get(i.identifier);return g||(g=this.c(i,this.e,this.f),this.a.set(i.identifier,g)),g}if(!this.b){let g="";this.d.forEach((d,l)=>g+=`	${l} -> ${d.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${n}. These are the extension path mappings: 
${g}`),this.b=this.c(A.$PG,this.e,this.f)}return this.b}}let f=class{constructor(s,n,i){this.e=s,this.f=n,this.nodeModuleName=["open","opn"],this.d=i.getProxy(I.$vM.MainThreadTelemetry);const g=i.getProxy(I.$vM.MainThreadWindow);this.c=(d,l)=>{const p=D.URI.parse(d);return l?this.g(d,l):p.scheme==="http"||p.scheme==="https"?g.$openUri(p,d,{allowTunneling:!0}):p.scheme==="mailto"||p.scheme===this.f?g.$openUri(p,d,{}):this.g(d,l)}}load(s,n,i){const g=this.e.findSubstr(n);return g&&(this.a=g.identifier.value,this.h()),this.b=i(s),this.c}g(s,n){return this.i(),this.b(s,n)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};f=Je([qe(2,$.$ZO)],f)}),define(Ce[130],Ie([1,0,47,6,20,79,3,71,70,46,7,44,243,45]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wnc=e.$Vnc=void 0,e.$Vnc=(0,A.$Ai)("IExtHostVariableResolverProvider");class h extends u.$4P{constructor(c,f,t,s,n,i,g){function d(){if(t){const l=t.activeEditor();if(l)return l.document.uri;const p=s.tabGroups.all.find(C=>C.isActive)?.activeTab;if(p!==void 0){if(p.input instanceof P.$jO||p.input instanceof P.$oO)return p.input.modified;if(p.input instanceof P.$iO||p.input instanceof P.$nO||p.input instanceof P.$lO)return p.input.uri}}}super({getFolderUri:l=>{const p=i.folders.filter(C=>C.name===l);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(l,p)=>n.getConfiguration(void 0,l).get(p),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=d();if(l)return I.$hc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(f){const l=d();if(l){const p=f.getWorkspaceFolder(l);if(p)return I.$hc(p.uri.fsPath)}}},getSelectedText:()=>{if(t){const l=t.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(t){const l=t.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>c.getExtension(l)},void 0,g?Promise.resolve(g):void 0,Promise.resolve(T.env))}}let r=class extends D.$Uc{constructor(c,f,t,s,n){super(),this.b=c,this.c=f,this.g=t,this.h=s,this.j=n,this.a=new b.$V(async()=>{const i=await this.h.getConfigProvider(),d={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{d.folders=await this.c.getWorkspaceFolders2()||[]})),new h(this.b,this.c,this.g,this.j,i,d,this.m())})}getResolver(){return this.a.value}m(){}};e.$Wnc=r,e.$Wnc=r=Je([qe(0,a.$Snc),qe(1,y.$cnc),qe(2,M.$$O),qe(3,k.$fnc),qe(4,$.$rnc)],r)}),define(Ce[131],Ie([1,0,11,4,2,19,3,5,70,46,17,7,44,235,81,236,45,130,6,34,39,10,18]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2nc=e.$1nc=e.$Znc=e.$Ync=e.$Xnc=void 0,e.$Xnc=(0,A.$Ai)("IExtHostDebugService");let g=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(E,R,w,m,N,B,X){this.N=R,this.O=w,this.P=m,this.Q=N,this.R=B,this.S=X,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new D.$he,this.o=new D.$he,this.q=new D.$he,this.w=new D.$he,this.l=E.getProxy(M.$vM.MainThreadDebugService),this.A=new D.$he,this.C=new D.$he,this.y=new l(this.l),this.z=new Map,this.O.getExtensionRegistry().then(V=>{V.onDidChange(O=>{this.V(V)}),this.V(V)})}async $getVisualizerTreeItem(E,R){const w=this.W(R);if(!w)return;const m=await this.H.get(E)?.getTreeItem?.(w);return m?this.U(E,m):void 0}registerDebugVisualizationTree(E,R,w){const m=T.$Xm.toKey(E.identifier),N=this.jb(m,R);if(this.G.has(N))throw new Error(`A debug visualization provider with id '${R}' is already registered`);return this.H.set(N,w),this.l.$registerDebugVisualizerTree(N,!!w.editItem),(0,f.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(N),this.H.delete(R)})}async $getVisualizerTreeItemChildren(E,R){const w=this.J.get(R)?.item;return w?(await this.H.get(E)?.getChildren?.(w))?.map(N=>this.U(E,N))||[]:[]}async $editVisualizerTreeItem(E,R){const w=this.J.get(E);if(!w)return;const m=await this.H.get(w.provider)?.editItem?.(w.item,R);return this.U(w.provider,m||w.item)}$disposeVisualizedTree(E){const R=this.J.get(E);if(!R)return;const w=[R.children];for(const m of w)if(m)for(const N of m)w.push(this.J.get(N)?.children),this.J.delete(N)}U(E,R){let w=this.I.get(R);return w||(w=this.F++,this.I.set(R,w),this.J.set(w,{provider:E,item:R})),n.DebugTreeItem.from(R,w)}asDebugSourceUri(E,R){const w=E;if(typeof w.sourceReference=="number"&&w.sourceReference>0){let m=`debug:${encodeURIComponent(w.path||"")}`,N="?";return R&&(m+=`${N}session=${encodeURIComponent(R.id)}`,N="&"),m+=`${N}ref=${w.sourceReference}`,I.URI.parse(m)}else{if(w.path)return I.URI.file(w.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(E){const R=[];for(const w of E.getAllExtensionDescriptions())if(w.contributes){const m=w.contributes.debuggers;if(m&&m.length>0)for(const N of m)(0,r.$LH)(N)&&R.push(N.type)}this.l.$registerDebugTypes(R)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const E=[];return this.z.forEach(R=>E.push(R)),E}async $resolveDebugVisualizer(E,R){const w=this.L.get(E);if(!w)throw new Error(`No debug visualizer found with id '${E}'`);let{v:m,provider:N,extensionId:B}=w;if(m.visualization||(m=await N.resolveDebugVisualization?.(m,R)||m,w.v=m),!m.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.kb(B,m.visualization)}async $executeDebugVisualizerCommand(E){const R=this.L.get(E);if(!R)throw new Error(`No debug visualizer found with id '${E}'`);const w=R.v.visualization;w&&"command"in w&&this.S.executeCommand(w.command,...w.arguments||[])}W(E){const R=this.m.get(E.sessionId);return R&&{session:R.api,variable:E.variable,containerId:E.containerId,frameId:E.frameId,threadId:E.threadId}}async $provideDebugVisualizers(E,R,w,m){const N=this.W(w),B=this.jb(E,R),X=this.G.get(B);if(!N||!X)return[];const V=await X.provideDebugVisualization(N,m);return V?V.map(O=>{const L=++this.M;this.L.set(L,{v:O,provider:X,extensionId:E});const F=O.iconPath?this.lb(O.iconPath):void 0;return{id:L,name:O.name,iconClass:F?.iconClass,iconPath:F?.iconPath,visualization:this.kb(E,O.visualization)}}):[]}$disposeDebugVisualizers(E){for(const R of E)this.L.delete(R)}registerDebugVisualizationProvider(E,R,w){if(!E.contributes?.debugVisualizers?.some(B=>B.id===R))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${R})`);const m=T.$Xm.toKey(E.identifier),N=this.jb(m,R);if(this.G.has(N))throw new Error(`A debug visualization provider with id '${R}' is already registered`);return this.G.set(N,w),this.l.$registerDebugVisualizer(m,R),(0,f.$Sc)(()=>{this.l.$unregisterDebugVisualizer(m,R),this.G.delete(R)})}addBreakpoints(E){const R=E.filter(N=>{const B=N.id;return this.z.has(B)?!1:(this.z.set(B,N),!0)});this.gb(R,[],[]);const w=[],m=new Map;for(const N of R)if(N instanceof y.$zN){let B=m.get(N.location.uri.toString());B||(B={type:"sourceMulti",uri:N.location.uri,lines:[]},m.set(N.location.uri.toString(),B),w.push(B)),B.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof y.$AN&&w.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.l.$registerBreakpoints(w)}removeBreakpoints(E){const R=E.filter(B=>this.z.delete(B.id));this.gb([],R,[]);const w=R.filter(B=>B instanceof y.$zN).map(B=>B.id),m=R.filter(B=>B instanceof y.$AN).map(B=>B.id),N=R.filter(B=>B instanceof y.$BN).map(B=>B.id);return this.l.$unregisterBreakpoints(w,m,N)}startDebugging(E,R,w){return this.l.$startDebugging(E?E.uri:void 0,R,{parentSessionID:w.parentSession?w.parentSession.id:void 0,lifecycleManagedByParent:w.lifecycleManagedByParent,repl:w.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:w.noDebug,compact:w.compact,suppressSaveBeforeStart:w.suppressSaveBeforeStart,suppressDebugStatusbar:w.suppressDebugStatusbar??w.debugUI?.simple,suppressDebugToolbar:w.suppressDebugToolbar??w.debugUI?.simple,suppressDebugView:w.suppressDebugView??w.debugUI?.simple})}stopDebugging(E){return this.l.$stopDebugging(E?E.id:void 0)}registerDebugConfigurationProvider(E,R,w){if(!R)return new y.$xM(()=>{});const m=this.d++;return this.f.push({type:E,handle:m,provider:R}),this.l.$registerDebugConfigurationProvider(E,w,!!R.provideDebugConfigurations,!!R.resolveDebugConfiguration,!!R.resolveDebugConfigurationWithSubstitutedVariables,m),new y.$xM(()=>{this.f=this.f.filter(N=>N.provider!==R),this.l.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(E,R,w){if(!w)return new y.$xM(()=>{});if(!this.cb(E,R))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${R}' debugger.`);if(this.$(R))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:R,handle:m,factory:w}),this.l.$registerDebugAdapterDescriptorFactory(R,m),new y.$xM(()=>{this.h=this.h.filter(N=>N.factory!==w),this.l.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(E,R){if(!R)return new y.$xM(()=>{});const w=this.j++;return this.k.push({type:E,handle:w,factory:R}),new y.$xM(()=>{this.k=this.k.filter(m=>m.factory!==R)})}async $runInTerminal(E,R){return Promise.resolve(void 0)}async $substituteVariables(E,R){let w;const m=await this.ib(E);return m&&(w={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(w,R)}X(E,R){if(E.type==="implementation")return new C(E.implementation)}Y(){}async $startDASession(E,R){const w=this,m=await this.hb(R);return this.eb(this.$(m.type),m).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const B=this.Z(N),X=this.X(B,m);if(!X)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const V=X;return this.D.set(E,V),this.db(m).then(O=>(O&&this.E.set(E,O),V.onMessage(async L=>{if(L.type==="request"&&L.command==="handshake"){const F=L,ie={type:"response",seq:0,command:F.command,request_seq:F.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const de=await this.K.sign(F.arguments.value);ie.body={signature:de},V.sendResponse(ie)}else throw new Error("no signer")}catch(de){ie.success=!1,ie.message=de.message,V.sendResponse(ie)}}else O&&O.onDidSendMessage&&O.onDidSendMessage(L),L=(0,r.$QH)(L,!0),w.l.$acceptDAMessage(E,L)}),V.onError(L=>{O&&O.onError&&O.onError(L),this.l.$acceptDAError(E,L.name,L.message,L.stack)}),V.onExit(L=>{O&&O.onExit&&O.onExit(L??void 0,void 0),this.l.$acceptDAExit(E,L??void 0,void 0)}),O&&O.onWillStartSession&&O.onWillStartSession(),V.startSession()))})}$sendDAMessage(E,R){R=(0,r.$PH)(R,!1);const w=this.E.get(E);w&&w.onWillReceiveMessage&&w.onWillReceiveMessage(R),this.D.get(E)?.sendMessage(R)}$stopDASession(E){const R=this.E.get(E);this.E.delete(E),R&&R.onWillStopSession&&R.onWillStopSession();const w=this.D.get(E);return this.D.delete(E),w?w.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(E){const R=[],w=[],m=[];if(E.added)for(const N of E.added){const B=N.id;if(B&&!this.z.has(B)){let X;if(N.type==="function")X=new y.$AN(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")X=new y.$BN(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const V=I.URI.revive(N.uri);X=new y.$zN(new y.$JM(V,new y.$yM(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,y.$xN)(X,B),this.z.set(B,X),R.push(X)}}if(E.removed)for(const N of E.removed){const B=this.z.get(N);B&&(this.z.delete(N),w.push(B))}if(E.changed){for(const N of E.changed)if(N.id){const B=this.z.get(N.id);if(B){if(B instanceof y.$AN&&N.type==="function"){const X=B;X.enabled=N.enabled,X.condition=N.condition,X.hitCondition=N.hitCondition,X.logMessage=N.logMessage,X.functionName=N.functionName}else if(B instanceof y.$zN&&N.type==="source"){const X=B;X.enabled=N.enabled,X.condition=N.condition,X.hitCondition=N.hitCondition,X.logMessage=N.logMessage,X.location=new y.$JM(I.URI.revive(N.uri),new y.$yM(N.line,N.character))}m.push(B)}}}this.gb(R,w,m)}async $acceptStackFrameFocus(E){let R;if(E){const w=await this.hb(E.sessionId);E.kind==="thread"?R=new y.$HN(w.api,E.threadId):R=new y.$GN(w.api,E.threadId,E.frameId)}this.B=R,this.C.fire(this.B)}$provideDebugConfigurations(E,R,w){return(0,b.$sh)(async()=>{const m=this.bb(E);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.ib(R);return m.provideDebugConfigurations(N,w)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(E,R,w,m){return(0,b.$sh)(async()=>{const N=this.bb(E);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const B=await this.ib(R);return N.resolveDebugConfiguration(B,w,m)})}$resolveDebugConfigurationWithSubstitutedVariables(E,R,w,m){return(0,b.$sh)(async()=>{const N=this.bb(E);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const B=await this.ib(R);return N.resolveDebugConfigurationWithSubstitutedVariables(B,w,m)})}async $provideDebugAdapter(E,R){const w=this.ab(E);if(!w)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.hb(R);return this.eb(w,m).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.Z(N)})}async $acceptDebugSessionStarted(E){const R=await this.hb(E);this.n.fire(R.api)}async $acceptDebugSessionTerminated(E){const R=await this.hb(E);R&&(this.o.fire(R.api),this.m.delete(R.id))}async $acceptDebugSessionActiveChanged(E){this.u=E?await this.hb(E):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(E,R){(await this.hb(E))?._acceptNameChanged(R)}async $acceptDebugSessionCustomEvent(E,R){const m={session:(await this.hb(E)).api,event:R.event,body:R.body};this.w.fire(m)}Z(E){if(E instanceof y.$CN)return{type:"executable",command:E.command,args:E.args,options:E.options};if(E instanceof y.$DN)return{type:"server",port:E.port,host:E.host};if(E instanceof y.$EN)return{type:"pipeServer",path:E.path};if(E instanceof y.$FN)return{type:"implementation",implementation:E.implementation};throw new Error("convertToDto unexpected type")}$(E){const R=this.h.filter(w=>w.type===E);if(R.length>0)return R[0].factory}ab(E){const R=this.h.filter(w=>w.handle===E);if(R.length>0)return R[0].factory}bb(E){const R=this.f.filter(w=>w.handle===E);if(R.length>0)return R[0].provider}cb(E,R){if(E.contributes){const w=E.contributes.debuggers;if(w&&w.length>0){for(const m of w)if(m.label&&m.type&&m.type===R)return!0}}return!1}db(E){const w=E.configuration.type,m=this.k.filter(N=>N.type===w||N.type==="*").map(N=>(0,b.$sh)(()=>N.factory.createDebugAdapterTracker(E.api)).then(B=>B,B=>null));return Promise.race([Promise.all(m).then(N=>{const B=(0,i.$Hb)(N);if(B.length>0)return new p(B)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async eb(E,R){const w=R.configuration.debugServer;if(typeof w=="number")return Promise.resolve(new y.$DN(w));if(E){const N=await this.O.getExtensionRegistry();return(0,b.$sh)(()=>E.createDebugAdapterDescriptor(R.api,this.fb(R,N))).then(B=>{if(B)return B})}const m=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(R,m))}fb(E,R){}gb(E,R,w){(E.length>0||R.length>0||w.length>0)&&this.A.fire(Object.freeze({added:E,removed:R,changed:w}))}async hb(E){if(E)if(typeof E=="string"){const R=this.m.get(E);if(R)return R}else{let R=this.m.get(E.id);if(!R){const w=await this.ib(E.folderUri),m=E.parent?this.m.get(E.parent):void 0;R=new d(this.l,E.id,E.type,E.name,w,E.configuration,m?.api),this.m.set(R.id,R),this.l.$sessionCached(R.id)}return R}throw new Error("cannot find session")}ib(E){if(E){const R=I.URI.revive(E);return this.N.resolveWorkspaceFolder(R)}return Promise.resolve(void 0)}jb(E,R){return`${E}\0${R}`}kb(E,R){if(R){if("title"in R&&"command"in R)return{type:h.DebugVisualizationType.Command};if("treeId"in R)return{type:h.DebugVisualizationType.Tree,id:`${E}\0${R.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(E){const R=this.mb(E);let w,m;return"id"in R?m=t.ThemeIcon.asClassName(R):w=R,{iconPath:w,iconClass:m}}mb(E){if(E instanceof y.$uN)return{id:E.id};const R=typeof E=="object"&&"dark"in E?E.dark:E,w=typeof E=="object"&&"light"in E?E.light:E;return{dark:typeof R=="string"?I.URI.file(R):R,light:typeof w=="string"?I.URI.file(w):w}}};e.$Ync=g,e.$Ync=g=Je([qe(0,P.$ZO),qe(1,u.$cnc),qe(2,a.$Snc),qe(3,o.$fnc),qe(4,$.$rnc),qe(5,c.$Vnc),qe(6,s.$jP)],g);class d{constructor(E,R,w,m,N,B,X){this.f=E,this.g=R,this.h=w,this.j=m,this.k=N,this.l=B,this.m=X}get api(){const E=this;return this.d??(this.d=Object.freeze({id:E.g,type:E.h,get name(){return E.j},set name(R){E.j=R,E.f.$setDebugSessionName(E.g,R)},parentSession:E.m,workspaceFolder:E.k,configuration:E.l,customRequest(R,w){return E.f.$customDebugAdapterRequest(E.g,R,w)},getDebugProtocolBreakpoint(R){return E.f.$getDebugProtocolBreakpoint(E.g,R.id)}}))}get id(){return this.g}get type(){return this.h}_acceptNameChanged(E){this.j=E}get configuration(){return this.l}}e.$Znc=d;class l{constructor(E){this.value=Object.freeze({append(R){E.$appendDebugConsole(R)},appendLine(R){this.append(R+`
`)}})}}e.$1nc=l;class p{constructor(E){this.d=E}onWillStartSession(){this.d.forEach(E=>E.onWillStartSession?E.onWillStartSession():void 0)}onWillReceiveMessage(E){this.d.forEach(R=>R.onWillReceiveMessage?R.onWillReceiveMessage(E):void 0)}onDidSendMessage(E){this.d.forEach(R=>R.onDidSendMessage?R.onDidSendMessage(E):void 0)}onWillStopSession(){this.d.forEach(E=>E.onWillStopSession?E.onWillStopSession():void 0)}onError(E){this.d.forEach(R=>R.onError?R.onError(E):void 0)}onExit(E,R){this.d.forEach(w=>w.onExit?w.onExit(E,R):void 0)}}class C extends k.$osb{constructor(E){super(),this.h=E,E.onDidSendMessage(R=>{this.acceptMessage(R)})}startSession(){return Promise.resolve(void 0)}sendMessage(E){this.h.handleMessage(E)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let S=class extends g{constructor(E,R,w,m,N,B,X){super(E,R,w,m,N,B,X)}};e.$2nc=S,e.$2nc=S=Je([qe(0,P.$ZO),qe(1,u.$cnc),qe(2,a.$Snc),qe(3,o.$fnc),qe(4,$.$rnc),qe(5,c.$Vnc),qe(6,s.$jP)],S)}),define(Ce[315],Ie([1,0,14,64,2,5,265,12,60,75,27,210,17,65,46,66]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6oc=e.$5oc=void 0;class o{static async installEarlyHandler(t){Error.stackTraceLimit=100;const s=t.get(M.$7j),i=t.get(u.$ZO).getProxy(T.$vM.MainThreadErrors);b.setUnexpectedErrorHandler(g=>{s.error(g);const d=b.$3(g);i.$onUnexpectedError(d)})}static async installFullHandler(t){const s=t.get(M.$7j),n=t.get(u.$ZO),i=t.get(h.$Snc),g=t.get(r.$hP),d=n.getProxy(T.$vM.MainThreadExtensionService),l=n.getProxy(T.$vM.MainThreadErrors),p=await i.getExtensionPathIndex(),C=new WeakMap;function S(R,w){if(C.has(R))return C.get(R).stack;let m="",N,B;for(const V of w)m+=`
	at ${V.toString()}`,B=V.getFileName(),!N&&B&&(N=p.findSubstr(I.URI.file(B)));const X=`${R.name||"Error"}: ${R.message||""}${m}`;return C.set(R,{extensionIdentifier:N?.identifier,stack:X}),X}const v=Symbol("prepareStackTrace wrapped");let E=S;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return E},set(R){if(R===S||!R||R[v]){E=R||S;return}E=function(w,m){return S(w,m),R.call(Error,w,m)},Object.assign(E,{[v]:!0})}}),b.setUnexpectedErrorHandler(R=>{s.error(R);const w=b.$3(R),m=C.get(R);if(!m?.extensionIdentifier){l.$onUnexpectedError(w);return}d.$onExtensionRuntimeError(m.extensionIdentifier,w);const N=g.onExtensionError(m.extensionIdentifier,R);s.trace("forwarded error to extension?",N,m)})}}e.$5oc=o;class c{constructor(t,s,n,i,g){this.a=n,this.b=new A.$tbc(t,null,i),s=c.e(s,this.b);const d=new a.$yi(...(0,$.$Hs)());d.set(P.$dP,{_serviceBrand:void 0,...s,messagePorts:g}),d.set(u.$ZO,new u.$1O(this.b)),d.set(k.$_mc,new k.$anc(i)),d.set(h.$Qnc,n);const l=new y.$lr(d,!0);l.invokeFunction(o.installEarlyHandler),this.d=l.invokeFunction(p=>p.get(M.$7j)),D.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",s),this.c=l.invokeFunction(p=>p.get(h.$Snc)),this.c.initialize(),l.invokeFunction(o.installFullHandler)}async asBrowserUri(t){const s=this.b.getProxy(T.$vM.MainThreadExtensionService);return I.URI.revive(await s.$asBrowserUri(t))}terminate(t){this.c.terminate(t)}static e(t,s){t.extensions.allExtensions.forEach(i=>{i.extensionLocation=I.URI.revive(s.transformIncomingURIs(i.extensionLocation))}),t.environment.appRoot=I.URI.revive(s.transformIncomingURIs(t.environment.appRoot));const n=t.environment.extensionDevelopmentLocationURI;return n&&(t.environment.extensionDevelopmentLocationURI=n.map(i=>I.URI.revive(s.transformIncomingURIs(i)))),t.environment.extensionTestsLocationURI=I.URI.revive(s.transformIncomingURIs(t.environment.extensionTestsLocationURI)),t.environment.globalStorageHome=I.URI.revive(s.transformIncomingURIs(t.environment.globalStorageHome)),t.environment.workspaceStorageHome=I.URI.revive(s.transformIncomingURIs(t.environment.workspaceStorageHome)),t.environment.extensionTelemetryLogResource=I.URI.revive(s.transformIncomingURIs(t.environment.extensionTelemetryLogResource)),t.nlsBaseUrl=I.URI.revive(s.transformIncomingURIs(t.nlsBaseUrl)),t.logsLocation=I.URI.revive(s.transformIncomingURIs(t.logsLocation)),t.workspace=s.transformIncomingURIs(t.workspace),t}}e.$6oc=c}),define(Ce[316],Ie([1,0,18,11,22,49,16,20,24,2,43]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=e.$eoc=e.$doc=void 0,e.$foc=r;class y{constructor(f,t,s){this.d=f,this.e=t,this.f=s,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(f,t){const s=this.g.folderQueries||[],n=new I.$se(t);return new Promise((i,g)=>{this.a=new k(f);let d=!1;const l=(p,C)=>{if(!d&&!this.b){const S=this.h(p);r(p)&&typeof this.g.maxResults=="number"&&this.c+S>this.g.maxResults&&(this.b=!0,d=!0,n.cancel(),p=this.j(p,this.g.maxResults-this.c));const v=this.h(p);this.c+=v,(v>0||!r(p))&&this.a.add(p,C)}};Promise.all(s.map((p,C)=>this.k(p,S=>l(S,C),n.token))).then(p=>{n.dispose(),this.a.flush();const C=p.some(S=>!!S&&!!S.limitHit);i({limitHit:this.b||C,messages:p.flatMap(S=>S?.message?Array.isArray(S.message)?S.message:[S.message]:[]),stats:{type:this.f}})},p=>{n.dispose();const C=(0,T.$lj)(p);g(new Error(C))})})}h(f){return r(f)?Array.isArray(f.ranges)?f.ranges.length:1:0}j(f,t){const s=Array.isArray(f.ranges)?f.ranges:[f.ranges],n=Array.isArray(f.preview.matches)?f.preview.matches:[f.preview.matches];return{ranges:s.slice(0,t),preview:{matches:n.slice(0,t),text:f.preview.text},uri:f.uri}}async k(f,t,s){const n=new P.$2K(this.g,f),i=[],g={report:p=>{if(!this.l(p))return;const C=f.folder.scheme===A.Schemas.file?(0,P.$3K)(()=>this.e.readdir($.$ah(p.uri))):void 0,S=$.$dh(f.folder,p.uri);if(S){const v=n.includedInQuery(S,M.$nc(S),C);(0,D.$mh)(v)?i.push(v.then(E=>{E&&t(p)})):v&&t(p)}}},d=this.n(f);let l;return this.d.query.type===P.QueryType.aiText?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,d,g,s):l=await this.d.provider.provideTextSearchResults(u(this.d.query.contentPattern),d,g,s),i.length&&await Promise.all(i),l}l(f){if(r(f)){if(Array.isArray(f.ranges)){if(!Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(f.preview.matches.length!==f.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(f.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(f){const t=(0,P.$1K)(this.g.includePattern,f.includePattern),s=(0,P.$1K)(this.g.excludePattern,f.excludePattern),n={folder:a.URI.from(f.folder),excludes:s,includes:t,useIgnoreFiles:!f.disregardIgnoreFiles,useGlobalIgnoreFiles:!f.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!f.disregardParentIgnoreFiles,followSymlinks:!f.ignoreSymlinks,encoding:f.fileEncoding&&this.e.toCanonicalName(f.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(n.usePCRE2=this.g.usePCRE2),n}}e.$doc=y;function u(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class k{constructor(f){this.e=f,this.b=-1,this.d=null,this.a=new o(512,t=>this.g(t))}add(f,t){this.d&&(this.b!==t||!$.$7g(this.c,f.uri))&&(this.f(),this.d=null),this.d||(this.b=t,this.d={resource:f.uri,results:[]}),this.d.results.push(h(f))}f(){const f=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,f)}flush(){this.f(),this.a.flush()}g(f){this.e(f)}}e.$eoc=k;function h(c){return r(c)?{preview:{matches:(0,b.$1b)(c.preview.matches,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character})),text:c.preview.text},ranges:(0,b.$1b)(c.ranges,f=>({startLineNumber:f.start.line,startColumn:f.start.character,endLineNumber:f.end.line,endColumn:f.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function r(c){return!!c.preview}class o{constructor(f,t){this.g=f,this.h=t,this.c=0,this.d=[],this.e=0}addItem(f,t){f&&this.j(f,t)}addItems(f,t){f&&this.k(f,t)}j(f,t){this.d.push(f),this.e+=t,this.l()}k(f,t){this.d=this.d.concat(f),this.e+=t,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$goc=o,o.a=4e3,o.b=50}),define(Ce[132],Ie([1,0,6,5,3,311,17,65,12,2,316]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=e.$hoc=void 0,e.$joc=u,e.$hoc=(0,I.$Ai)("IExtHostSearch");let y=class{constructor(r,o,c){this.n=r,this.o=o,this.q=c,this.c=this.n.getProxy(D.$vM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new T.$coc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,o){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const c=this.d++;return this.e.set(c,o),this.c.$registerTextSearchProvider(c,this.s(r)),(0,b.$Sc)(()=>{this.g.delete(r),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(r,o){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const c=this.d++;return this.h.set(c,o),this.c.$registerAITextSearchProvider(c,this.s(r)),(0,b.$Sc)(()=>{this.i.delete(r),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(r,o){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const c=this.d++;return this.j.set(c,o),this.c.$registerFileSearchProvider(c,this.s(r)),(0,b.$Sc)(()=>{this.k.delete(r),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(r,o,c,f){const t=u(c),s=this.j.get(r);if(s)return this.l.fileSearch(t,s,n=>{this.c.$handleFileMatch(r,o,n.map(i=>i.resource))},f);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,o,c){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,o,c,f){const t=this.e.get(r);if(!t||!t.provideTextSearchResults)throw new Error(`2 Unknown provider ${r}`);const s=u(c);return this.t(s,t).search(i=>this.c.$handleTextMatch(r,o,i),f)}$provideAITextSearchResults(r,o,c,f){const t=this.h.get(r);if(!t||!t.provideAITextSearchResults)throw new Error(`1 Unknown provider ${r}`);const s=u(c);return this.v(s,t).search(i=>this.c.$handleTextMatch(r,o,i),f)}$enableExtensionHostSearch(){}t(r,o){return new P.$doc({query:r,provider:o},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(r,o){return new P.$doc({query:r,provider:o},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$ioc=y,e.$ioc=y=Je([qe(0,A.$ZO),qe(1,M.$_mc),qe(2,$.$7j)],y);function u(h){return{...h,folderQueries:h.folderQueries&&h.folderQueries.map(k),extraFileResources:h.extraFileResources&&h.extraFileResources.map(r=>a.URI.revive(r))}}function k(h){return{...h,folder:a.URI.revive(h.folder)}}}),define(Ce[317],Ie([1,0,22,14,4,6,16,35,2,104,154,155,53,19,30,12,62,63,224,5,268,296,85,91,273,274,275,252,241,39,276,45,277,131,120,278,254,269,279,280,71,70,255,270,46,282,68,283,51,27,297,256,284,95,285,86,87,258,310,287,229,288,298,289,126,259,290,291,292,17,293,132,88,294,260,295,89,92,129,66,57,124,299,300,271,301,302,93,10,7,261,65,262,67,303,304,119,44,81,84,25,128]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s,n,i,g,d,l,p,C,S,v,E,R,w,m,N,B,X,V,O,L,F,ie,de,be,ve,Z,ae,fe,ee,De,Fe,ce,H,he,le,re,ue,oe,J,Y,we,pe,Me,Ve,Se,Pe,Te,U,W,G,K,x,ge,Re,Ue,Ke,Ze,nt,it,st,ot,$t,dt,rt,ut,gt,We,je,te,q,Ee,He,_e,lt,mt,At,Jt,qt,hi,ii,Ye,_t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zoc=Qt;function Qt(pt){const bt=pt.get(De.$dP),Xt=pt.get(ee.$Wmc),ei=pt.get(ae.$hnc),Wt=pt.get(ve.$Snc),wt=pt.get(qt.$cnc),Tt=pt.get(st.$hP),jt=pt.get(R.$fnc),Lt=pt.get(He.$_mc),Xe=pt.get(G.$ZO),ti=pt.get(Ze.$Anc),ni=pt.get(nt.$inc),ci=pt.get(r.$8j),Ct=pt.get(r.$7j),Ft=pt.get(je.$wEb),Ot=pt.get(i.$Smc),Gt=pt.get(Jt.$Yoc),li=pt.get(ge.$Knc),ri=pt.get(ie.$rnc),oi=pt.get(ue.$Onc),Vt=pt.get(g.$3mc),zt=pt.get(he.$Hnc);Xe.set(t.$wM.ExtHostFileSystemInfo,Xt),Xe.set(t.$wM.ExtHostLogLevelServiceShape,ci),Xe.set(t.$wM.ExtHostWorkspace,wt),Xe.set(t.$wM.ExtHostConfiguration,jt),Xe.set(t.$wM.ExtHostExtensionService,Wt),Xe.set(t.$wM.ExtHostStorage,ti),Xe.set(t.$wM.ExtHostTunnelService,Ft),Xe.set(t.$wM.ExtHostWindow,Gt),Xe.set(t.$wM.ExtHostSecretState,li),Xe.set(t.$wM.ExtHostTelemetry,Tt),Xe.set(t.$wM.ExtHostEditorTabs,ri),Xe.set(t.$wM.ExtHostManagedSockets,oi),Xe.set(t.$wM.ExtHostAuthentication,Vt),Xe.set(t.$wM.ExtHostChatProvider,zt);const ai=Xe.set(t.$wM.ExtHostDecorations,pt.get(N.$4nc)),Pt=Xe.set(t.$wM.ExtHostDocumentsAndEditors,pt.get(F.$$O)),Et=Xe.set(t.$wM.ExtHostCommands,pt.get(v.$jP)),yt=Xe.set(t.$wM.ExtHostTerminalService,pt.get(ot.$Dnc)),Kt=Xe.set(t.$wM.ExtHostTerminalShellIntegration,pt.get($t.$Koc)),Dt=Xe.set(t.$wM.ExtHostDebugService,pt.get(m.$Xnc)),Bt=Xe.set(t.$wM.ExtHostSearch,pt.get(x.$hoc)),Ht=Xe.set(t.$wM.ExtHostTask,pt.get(it.$Joc)),Ei=Xe.set(t.$wM.ExtHostOutputService,pt.get(Se.$woc)),gi=Xe.set(t.$wM.ExtHostLocalization,pt.get(re.$Nnc)),mi=Xe.set(t.$wM.ExtHostUrls,new _e.$Voc(Xe)),Nt=Xe.set(t.$wM.ExtHostDocuments,new L.$Zmc(Xe,Pt)),wi=Xe.set(t.$wM.ExtHostDocumentContentProviders,new V.$6nc(Xe,Pt,Ct)),Ri=Xe.set(t.$wM.ExtHostDocumentSaveParticipant,new O.$7nc(Ct,Nt,Xe.getProxy(t.$vM.MainThreadBulkEdits))),Rt=Xe.set(t.$wM.ExtHostNotebook,new J.$koc(Xe,Et,Pt,Nt,ei,Bt,Ct)),Ai=Xe.set(t.$wM.ExtHostNotebookDocuments,new we.$qoc(Rt)),Si=Xe.set(t.$wM.ExtHostNotebookEditors,new pe.$roc(Ct,Rt)),pi=Xe.set(t.$wM.ExtHostNotebookKernels,new Me.$soc(Xe,bt,Rt,Et,Ct)),ki=Xe.set(t.$wM.ExtHostNotebookRenderers,new Ve.$uoc(Xe,Rt)),ui=Xe.set(t.$wM.ExtHostNotebookDocumentSaveParticipant,new Y.$poc(Ct,Rt,Xe.getProxy(t.$vM.MainThreadBulkEdits))),ye=Xe.set(t.$wM.ExtHostEditors,new rt.$9mc(Xe,Pt)),Oe=Xe.set(t.$wM.ExtHostTreeViews,new We.$Toc(Xe.getProxy(t.$vM.MainThreadTreeViews),Et,Ct)),$e=Xe.set(t.$wM.ExtHostEditorInsets,new S.$0mc(Xe.getProxy(t.$vM.MainThreadEditorInsets),ye,bt.remote)),Q=Xe.set(t.$wM.ExtHostDiagnostics,new B.$Ymc(Xe,Ct,Xt,Pt)),Ae=Xe.set(t.$wM.ExtHostLanguages,new le.$noc(Xe,Nt,Et.converter,Lt)),ze=Xe.set(t.$wM.ExtHostLanguageFeatures,new H.$1mc(Xe,Lt,Nt,Et,Q,Ct,Ot,Tt)),xe=Xe.set(t.$wM.ExtHostFileSystem,new Z.$0nc(Xe,ze)),Ge=Xe.set(t.$wM.ExtHostFileSystemEventService,new fe.$$nc(Xe,Ct,Pt)),ht=Xe.set(t.$wM.ExtHostQuickOpen,(0,W.$Aoc)(Xe,wt,Et)),It=Xe.set(t.$wM.ExtHostSCM,new K.$Coc(Xe,Et,Nt,Ct)),Zt=Xe.set(t.$wM.ExtHostQuickDiff,new U.$zoc(Xe,Lt)),si=Xe.set(t.$wM.ExtHostShare,new Re.$Doc(Xe,Lt)),Ut=Xe.set(t.$wM.ExtHostComments,(0,E.$$mc)(Xe,Et,Nt)),Yt=Xe.set(t.$wM.ExtHostProgress,new Te.$yoc(Xe.getProxy(t.$vM.MainThreadProgress))),Wi=Xe.set(t.$wM.ExtHostLabelService,new ce.$moc(Xe)),Yi=Xe.set(t.$wM.ExtHostTheming,new ut.$Qoc(Xe)),bn=Xe.set(t.$wM.ExtHostTimeline,new gt.$Soc(Xe,Et)),Mi=Xe.set(t.$wM.ExtHostWebviews,new lt.$mnc(Xe,bt.remote,wt,Ct,Ot)),Ni=Xe.set(t.$wM.ExtHostWebviewPanels,new mt.$pnc(Xe,Mi,wt)),Vi=Xe.set(t.$wM.ExtHostCustomEditors,new w.$qnc(Xe,Nt,ni,Mi,Ni)),qi=Xe.set(t.$wM.ExtHostWebviewViews,new At.$Woc(Xe,Mi)),bi=Xe.set(t.$wM.ExtHostTesting,new dt.$Moc(Xe,Ct,Et,Pt)),Gi=Xe.set(t.$wM.ExtHostUriOpeners,new Ee.$Uoc(Xe)),xi=Xe.set(t.$wM.ExtHostProfileContentHandlers,new Pe.$xoc(Xe));Xe.set(t.$wM.ExtHostInteractive,new Fe.$loc(Xe,Rt,Pt,Et,Ct));const Fi=Xe.set(t.$wM.ExtHostChatAgents2,new l.$6mc(Xe,Ct,Et,bt.quality)),_i=Xe.set(t.$wM.ExtHostChatVariables,new p.$7mc(Xe)),Ki=Xe.set(t.$wM.ExtHostAiRelatedInformation,new s.$Rmc(Xe)),Hi=Xe.set(t.$wM.ExtHostAiEmbeddingVector,new be.$9nc(Xe)),Li=Xe.set(t.$wM.ExtHostStatusBar,new Ke.$Goc(Xe,Et.converter)),en=Xe.set(t.$wM.ExtHostSpeech,new Ue.$Eoc(Xe)),Ci=Xe.set(t.$wM.ExtHostEmbeddings,new de.$8nc(Xe)),tn=Object.values(t.$wM);Xe.assertRegistered(tn);const nn=new d.$5mc(Xe,Pt),rn=new C.$8mc(Xe),zi=new oe.$ooc(Xe,Ct),sn=new X.$5nc(Xe);return n.$2mc.register(Et),function(Le,di,Ui){function at(ne){return(me,Ne,ct)=>{const St=ne(Mt=>{try{me.call(Ne,Mt)}catch(Ii){D.$2(new Error(`[ExtensionListenerError] Extension '${Le.identifier.value}' FAILED to handle event: ${Ii.toString()}`,{cause:Ii})),Tt.onExtensionError(Le.identifier,Ii)}});return ct?.push(St),St}}const kt=function(){let ne=!Le.isUnderDevelopment;function me(){ne||(Ct.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ne(ct){if(Array.isArray(ct))ct.forEach(Ne);else if(typeof ct=="string")me();else{const St=ct;typeof St.scheme>"u"&&me(),typeof St.exclusive=="boolean"&&(0,Ye.$VG)(Le,"documentFiltersExclusive")}return ct}}(),on={getSession(ne,me,Ne){return typeof Ne?.forceNewSession=="object"&&Ne.forceNewSession.learnMore&&(0,Ye.$VG)(Le,"authLearnMore"),Vt.getSession(Le,ne,me,Ne)},getSessions(ne,me){return(0,Ye.$VG)(Le,"authGetSessions"),Vt.getSessions(Le,ne,me)},async hasSession(ne,me){return(0,Ye.$VG)(Le,"authSession"),!!await Vt.getSession(Le,ne,me,{silent:!0})},get onDidChangeSessions(){return at(Vt.onDidChangeSessions)},registerAuthenticationProvider(ne,me,Ne,ct){return Vt.registerAuthenticationProvider(ne,me,Ne,ct)}},vn={registerCommand(ne,me,Ne){return Et.registerCommand(!0,ne,me,Ne,void 0,Le)},registerTextEditorCommand(ne,me,Ne){return Et.registerCommand(!0,ne,(...ct)=>{const St=ye.getActiveTextEditor();if(!St){Ct.warn("Cannot execute "+ne+" because there is no active text editor.");return}return St.edit(Mt=>{me.apply(Ne,[St,Mt,...ct])}).then(Mt=>{Mt||Ct.warn("Edits from command "+ne+" were not applied.")},Mt=>{Ct.warn("An error occurred while running command "+ne,Mt)})},void 0,void 0,Le)},registerDiffInformationCommand:(ne,me,Ne)=>((0,Ye.$VG)(Le,"diffCommand"),Et.registerCommand(!0,ne,async(...ct)=>{const St=Pt.activeEditor(!0);if(!St){Ct.warn("Cannot execute "+ne+" because there is no active text editor.");return}const Mt=await ye.getDiffInformation(St.id);me.apply(Ne,[Mt,...ct])},void 0,void 0,Le)),executeCommand(ne,...me){return Et.executeCommand(ne,...me)},getCommands(ne=!1){return Et.getCommands(ne)}},Ti={get machineId(){return bt.telemetryInfo.machineId},get sessionId(){return bt.telemetryInfo.sessionId},get language(){return bt.environment.appLanguage},get appName(){return bt.environment.appName},get appRoot(){return bt.environment.appRoot?.fsPath??""},get appHost(){return bt.environment.appHost},get uriScheme(){return bt.environment.appUriScheme},get clipboard(){return rn.value},get shell(){return yt.getDefaultShell(!1)},get onDidChangeShell(){return at(yt.onDidChangeShell)},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return at(Tt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$VG)(Le,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$VG)(Le,"telemetry"),at(Tt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,st.$gP)(bt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ne,me){return st.$fP.validateSender(ne),Tt.instantiateLogger(Le,ne,me)},openExternal(ne,me){return Gt.openUri(ne,{allowTunneling:!!bt.remote.authority,allowContributedOpeners:me?.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===bt.environment.appUriScheme)return mi.createAppUri(ne);try{return await Gt.asExternalUri(ne,{allowTunneling:!!bt.remote.authority})}catch(me){if((0,A.$Jg)(ne,A.Schemas.http)||(0,A.$Jg)(ne,A.Schemas.https))return ne;throw me}},get remoteName(){return(0,o.$Om)(bt.remote.authority)},get remoteAuthority(){return(0,Ye.$VG)(Le,"resolvers"),bt.remote.authority},get uiKind(){return bt.uiKind},get logLevel(){return Ct.getLevel()},get onDidChangeLogLevel(){return at(Ct.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$VG)(Le,"resolvers"),bt.quality},get appCommit(){return(0,Ye.$VG)(Le,"resolvers"),bt.commit}};bt.environment.extensionTestsLocationURI||Object.freeze(Ti);const an={createTestController(ne,me,Ne){return bi.createTestController(Le,ne,me,Ne)},createTestObserver(){return(0,Ye.$VG)(Le,"testObserver"),bi.createTestObserver()},runTests(ne){return(0,Ye.$VG)(Le,"testObserver"),bi.runTests(ne)},registerTestFollowupProvider(ne){return(0,Ye.$VG)(Le,"testObserver"),bi.registerTestFollowupProvider(ne)},get onDidChangeTestResults(){return(0,Ye.$VG)(Le,"testObserver"),at(bi.onResultsChanged)},get testResults(){return(0,Ye.$VG)(Le,"testObserver"),bi.results}},Oi=bt.remote.isRemote?q.ExtensionKind.Workspace:q.ExtensionKind.UI,cn={getExtension(ne,me){(0,Ye.$UG)(Le,"extensionsAny")||(me=!1);const Ne=di.mine.getExtensionDescription(ne);if(Ne)return new ve.$Tnc(Wt,Le.identifier,Ne,Oi,!1);if(me){const ct=di.all.getExtensionDescription(ne);if(ct)return new ve.$Tnc(Wt,Le.identifier,ct,Oi,!0)}},get all(){const ne=[];for(const me of di.mine.getAllExtensionDescriptions())ne.push(new ve.$Tnc(Wt,Le.identifier,me,Oi,!1));return ne},get allAcrossExtensionHosts(){(0,Ye.$VG)(Le,"extensionsAny");const ne=new k.$Ym(di.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),me=[];for(const Ne of di.all.getAllExtensionDescriptions()){const ct=!ne.has(Ne.identifier);me.push(new ve.$Tnc(Wt,Le.identifier,Ne,Oi,ct))}return me},get onDidChange(){return(0,Ye.$UG)(Le,"extensionsAny")?at(I.Event.any(di.mine.onDidChange,di.all.onDidChange)):at(di.mine.onDidChange)}},yn={createDiagnosticCollection(ne){return Q.createDiagnosticCollection(Le.identifier,ne)},get onDidChangeDiagnostics(){return at(Q.onDidChangeDiagnostics)},getDiagnostics:ne=>Q.getDiagnostics(ne),getLanguages(){return Ae.getLanguages()},setTextDocumentLanguage(ne,me){return Ae.changeLanguage(ne.uri,me)},match(ne,me){const Ne=te.LanguageSelector.from(ne);let ct;return(0,P.$it)(Ne)&&(ct=Rt.notebookDocuments.find(St=>St.apiNotebook.getCells().find(Mt=>Mt.document===me))?.apiNotebook),(0,P.$ht)(Ne,me.uri,me.languageId,!0,ct?.uri,ct?.notebookType)},registerCodeActionsProvider(ne,me,Ne){return ze.registerCodeActionProvider(Le,kt(ne),me,Ne)},registerDocumentPasteEditProvider(ne,me,Ne){return(0,Ye.$VG)(Le,"documentPaste"),ze.registerDocumentPasteEditProvider(Le,kt(ne),me,Ne)},registerCodeLensProvider(ne,me){return ze.registerCodeLensProvider(Le,kt(ne),me)},registerDefinitionProvider(ne,me){return ze.registerDefinitionProvider(Le,kt(ne),me)},registerDeclarationProvider(ne,me){return ze.registerDeclarationProvider(Le,kt(ne),me)},registerImplementationProvider(ne,me){return ze.registerImplementationProvider(Le,kt(ne),me)},registerTypeDefinitionProvider(ne,me){return ze.registerTypeDefinitionProvider(Le,kt(ne),me)},registerHoverProvider(ne,me){return ze.registerHoverProvider(Le,kt(ne),me,Le.identifier)},registerEvaluatableExpressionProvider(ne,me){return ze.registerEvaluatableExpressionProvider(Le,kt(ne),me,Le.identifier)},registerInlineValuesProvider(ne,me){return ze.registerInlineValuesProvider(Le,kt(ne),me,Le.identifier)},registerDocumentHighlightProvider(ne,me){return ze.registerDocumentHighlightProvider(Le,kt(ne),me)},registerMultiDocumentHighlightProvider(ne,me){return ze.registerMultiDocumentHighlightProvider(Le,kt(ne),me)},registerLinkedEditingRangeProvider(ne,me){return ze.registerLinkedEditingRangeProvider(Le,kt(ne),me)},registerReferenceProvider(ne,me){return ze.registerReferenceProvider(Le,kt(ne),me)},registerRenameProvider(ne,me){return ze.registerRenameProvider(Le,kt(ne),me)},registerNewSymbolNamesProvider(ne,me){return(0,Ye.$VG)(Le,"newSymbolNamesProvider"),ze.registerNewSymbolNamesProvider(Le,kt(ne),me)},registerDocumentSymbolProvider(ne,me,Ne){return ze.registerDocumentSymbolProvider(Le,kt(ne),me,Ne)},registerWorkspaceSymbolProvider(ne){return ze.registerWorkspaceSymbolProvider(Le,ne)},registerDocumentFormattingEditProvider(ne,me){return ze.registerDocumentFormattingEditProvider(Le,kt(ne),me)},registerDocumentRangeFormattingEditProvider(ne,me){return ze.registerDocumentRangeFormattingEditProvider(Le,kt(ne),me)},registerOnTypeFormattingEditProvider(ne,me,Ne,...ct){return ze.registerOnTypeFormattingEditProvider(Le,kt(ne),me,[Ne].concat(ct))},registerDocumentSemanticTokensProvider(ne,me,Ne){return ze.registerDocumentSemanticTokensProvider(Le,kt(ne),me,Ne)},registerDocumentRangeSemanticTokensProvider(ne,me,Ne){return ze.registerDocumentRangeSemanticTokensProvider(Le,kt(ne),me,Ne)},registerSignatureHelpProvider(ne,me,Ne,...ct){return typeof Ne=="object"?ze.registerSignatureHelpProvider(Le,kt(ne),me,Ne):ze.registerSignatureHelpProvider(Le,kt(ne),me,typeof Ne>"u"?[]:[Ne,...ct])},registerCompletionItemProvider(ne,me,...Ne){return ze.registerCompletionItemProvider(Le,kt(ne),me,Ne)},registerInlineCompletionItemProvider(ne,me,Ne){return me.handleDidShowCompletionItem&&(0,Ye.$VG)(Le,"inlineCompletionsAdditions"),me.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$VG)(Le,"inlineCompletionsAdditions"),Ne&&(0,Ye.$VG)(Le,"inlineCompletionsAdditions"),ze.registerInlineCompletionsProvider(Le,kt(ne),me,Ne)},registerInlineEditProvider(ne,me){return(0,Ye.$VG)(Le,"inlineEdit"),ze.registerInlineEditProvider(Le,kt(ne),me)},registerDocumentLinkProvider(ne,me){return ze.registerDocumentLinkProvider(Le,kt(ne),me)},registerColorProvider(ne,me){return ze.registerColorProvider(Le,kt(ne),me)},registerFoldingRangeProvider(ne,me){return ze.registerFoldingRangeProvider(Le,kt(ne),me)},registerSelectionRangeProvider(ne,me){return ze.registerSelectionRangeProvider(Le,ne,me)},registerCallHierarchyProvider(ne,me){return ze.registerCallHierarchyProvider(Le,ne,me)},registerTypeHierarchyProvider(ne,me){return ze.registerTypeHierarchyProvider(Le,ne,me)},setLanguageConfiguration:(ne,me)=>ze.setLanguageConfiguration(Le,ne,me),getTokenInformationAtPosition(ne,me){return(0,Ye.$VG)(Le,"tokenInformation"),Ae.tokenAtPosition(ne,me)},registerInlayHintsProvider(ne,me){return ze.registerInlayHintsProvider(Le,ne,me)},createLanguageStatusItem(ne,me){return Ae.createLanguageStatusItem(Le,ne,me)},registerDocumentDropEditProvider(ne,me,Ne){return ze.registerDocumentOnDropEditProvider(Le,ne,me,(0,Ye.$UG)(Le,"documentPaste")?Ne:void 0)}},Ji={get activeTextEditor(){return ye.getActiveTextEditor()},get visibleTextEditors(){return ye.getVisibleTextEditors()},get activeTerminal(){return yt.activeTerminal},get terminals(){return yt.terminals},async showTextDocument(ne,me,Ne){$.URI.isUri(ne)&&ne.scheme===A.Schemas.vscodeRemote&&!ne.authority&&Ot.report("workspace.showTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority.");const ct=await($.URI.isUri(ne)?Promise.resolve(Qi.openTextDocument(ne)):Promise.resolve(ne));return ye.showTextDocument(ct,me,Ne)},createTextEditorDecorationType(ne){return ye.createTextEditorDecorationType(Le,ne)},onDidChangeActiveTextEditor(ne,me,Ne){return at(ye.onDidChangeActiveTextEditor)(ne,me,Ne)},onDidChangeVisibleTextEditors(ne,me,Ne){return at(ye.onDidChangeVisibleTextEditors)(ne,me,Ne)},onDidChangeTextEditorSelection(ne,me,Ne){return at(ye.onDidChangeTextEditorSelection)(ne,me,Ne)},onDidChangeTextEditorOptions(ne,me,Ne){return at(ye.onDidChangeTextEditorOptions)(ne,me,Ne)},onDidChangeTextEditorVisibleRanges(ne,me,Ne){return at(ye.onDidChangeTextEditorVisibleRanges)(ne,me,Ne)},onDidChangeTextEditorViewColumn(ne,me,Ne){return at(ye.onDidChangeTextEditorViewColumn)(ne,me,Ne)},onDidCloseTerminal(ne,me,Ne){return at(yt.onDidCloseTerminal)(ne,me,Ne)},onDidOpenTerminal(ne,me,Ne){return at(yt.onDidOpenTerminal)(ne,me,Ne)},onDidChangeActiveTerminal(ne,me,Ne){return at(yt.onDidChangeActiveTerminal)(ne,me,Ne)},onDidChangeTerminalDimensions(ne,me,Ne){return(0,Ye.$VG)(Le,"terminalDimensions"),at(yt.onDidChangeTerminalDimensions)(ne,me,Ne)},onDidChangeTerminalState(ne,me,Ne){return at(yt.onDidChangeTerminalState)(ne,me,Ne)},onDidWriteTerminalData(ne,me,Ne){return(0,Ye.$VG)(Le,"terminalDataWriteEvent"),at(yt.onDidWriteTerminalData)(ne,me,Ne)},onDidExecuteTerminalCommand(ne,me,Ne){return(0,Ye.$VG)(Le,"terminalExecuteCommandEvent"),at(yt.onDidExecuteTerminalCommand)(ne,me,Ne)},onDidChangeTerminalShellIntegration(ne,me,Ne){return(0,Ye.$VG)(Le,"terminalShellIntegration"),at(Kt.onDidChangeTerminalShellIntegration)(ne,me,Ne)},onDidStartTerminalShellExecution(ne,me,Ne){return(0,Ye.$VG)(Le,"terminalShellIntegration"),at(Kt.onDidStartTerminalShellExecution)(ne,me,Ne)},onDidEndTerminalShellExecution(ne,me,Ne){return(0,Ye.$VG)(Le,"terminalShellIntegration"),at(Kt.onDidEndTerminalShellExecution)(ne,me,Ne)},get state(){return Gt.getState()},onDidChangeWindowState(ne,me,Ne){return at(Gt.onDidChangeWindowState)(ne,me,Ne)},showInformationMessage(ne,...me){return zi.showMessage(Le,M.default.Info,ne,me[0],me.slice(1))},showWarningMessage(ne,...me){return zi.showMessage(Le,M.default.Warning,ne,me[0],me.slice(1))},showErrorMessage(ne,...me){return zi.showMessage(Le,M.default.Error,ne,me[0],me.slice(1))},showQuickPick(ne,me,Ne){return ht.showQuickPick(Le,ne,me,Ne)},showWorkspaceFolderPick(ne){return ht.showWorkspaceFolderPick(ne)},showInputBox(ne,me){return ht.showInput(ne,me)},showOpenDialog(ne){return sn.showOpenDialog(Le,ne)},showSaveDialog(ne){return sn.showSaveDialog(ne)},createStatusBarItem(ne,me,Ne){let ct,St,Mt;return typeof ne=="string"?(ct=ne,St=me,Mt=Ne):(St=ne,Mt=me),Li.createStatusBarEntry(Le,ct,St,Mt)},setStatusBarMessage(ne,me){return Li.setStatusBarMessage(ne,me)},withScmProgress(ne){return Ot.report("window.withScmProgress",Le,"Use 'withProgress' instead."),Yt.withProgress(Le,{location:q.ProgressLocation.SourceControl},(me,Ne)=>ne({report(ct){}}))},withProgress(ne,me){return Yt.withProgress(Le,ne,me)},createOutputChannel(ne,me){return Ei.createOutputChannel(ne,me,Le)},createWebviewPanel(ne,me,Ne,ct){return Ni.createWebviewPanel(Le,ne,me,Ne,ct)},createWebviewTextEditorInset(ne,me,Ne,ct){return(0,Ye.$VG)(Le,"editorInsets"),$e.createWebviewEditorInset(ne,me,Ne,ct,Le)},createTerminal(ne,me,Ne){return typeof ne=="object"?"pty"in ne?yt.createExtensionTerminal(ne):yt.createTerminalFromOptions(ne):yt.createTerminal(ne,me,Ne)},registerTerminalLinkProvider(ne){return yt.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,me){return yt.registerProfileProvider(Le,ne,me)},registerTerminalQuickFixProvider(ne,me){return(0,Ye.$VG)(Le,"terminalQuickFixProvider"),yt.registerTerminalQuickFixProvider(ne,Le.identifier.value,me)},registerTreeDataProvider(ne,me){return Oe.registerTreeDataProvider(ne,me,Le)},createTreeView(ne,me){return Oe.createTreeView(ne,me,Le)},registerWebviewPanelSerializer:(ne,me)=>Ni.registerWebviewPanelSerializer(Le,ne,me),registerCustomEditorProvider:(ne,me,Ne={})=>Vi.registerCustomEditorProvider(Le,ne,me,Ne),registerFileDecorationProvider(ne){return ai.registerFileDecorationProvider(ne,Le)},registerUriHandler(ne){return mi.registerUriHandler(Le,ne)},createQuickPick(){return ht.createQuickPick(Le)},createInputBox(){return ht.createInputBox(Le)},get activeColorTheme(){return Yi.activeColorTheme},onDidChangeActiveColorTheme(ne,me,Ne){return at(Yi.onDidChangeActiveColorTheme)(ne,me,Ne)},registerWebviewViewProvider(ne,me,Ne){return qi.registerWebviewViewProvider(Le,ne,me,Ne?.webviewOptions)},get activeNotebookEditor(){return Rt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,me,Ne){return at(Rt.onDidChangeActiveNotebookEditor)(ne,me,Ne)},get visibleNotebookEditors(){return Rt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return at(Rt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ne,me,Ne){return at(Si.onDidChangeNotebookEditorSelection)(ne,me,Ne)},onDidChangeNotebookEditorVisibleRanges(ne,me,Ne){return at(Si.onDidChangeNotebookEditorVisibleRanges)(ne,me,Ne)},showNotebookDocument(ne,me){return Rt.showNotebookDocument(ne,me)},registerExternalUriOpener(ne,me,Ne){return(0,Ye.$VG)(Le,"externalUriOpener"),Gi.registerExternalUriOpener(Le.identifier,ne,me,Ne)},registerProfileContentHandler(ne,me){return(0,Ye.$VG)(Le,"profileContentHandlers"),xi.registerProfileContentHandler(Le,ne,me)},registerQuickDiffProvider(ne,me,Ne,ct){return(0,Ye.$VG)(Le,"quickDiffProvider"),Zt.registerQuickDiffProvider(kt(ne),me,Ne,ct)},get tabGroups(){return ri.tabGroups},registerShareProvider(ne,me){return(0,Ye.$VG)(Le,"shareProvider"),si.registerShareProvider(kt(ne),me)}},Qi={get rootPath(){return Ot.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),wt.getPath()},set rootPath(ne){throw new D.$9("rootPath")},getWorkspaceFolder(ne){return wt.getWorkspaceFolder(ne)},get workspaceFolders(){return wt.getWorkspaceFolders()},get name(){return wt.name},set name(ne){throw new D.$9("name")},get workspaceFile(){return wt.workspaceFile},set workspaceFile(ne){throw new D.$9("workspaceFile")},updateWorkspaceFolders:(ne,me,...Ne)=>wt.updateWorkspaceFolders(Le,ne,me||0,...Ne),onDidChangeWorkspaceFolders:function(ne,me,Ne){return at(wt.onDidChangeWorkspace)(ne,me,Ne)},asRelativePath:(ne,me)=>wt.getRelativePath(ne,me),findFiles:(ne,me,Ne,ct)=>wt.findFiles(ne,me,Ne,Le.identifier,ct),findFiles2:(ne,me,Ne)=>((0,Ye.$VG)(Le,"findFiles2"),wt.findFiles2(ne,me,Le.identifier,Ne)),findTextInFiles:(ne,me,Ne,ct)=>{(0,Ye.$VG)(Le,"findTextInFiles");let St,Mt;return typeof me=="object"?(St=me,Mt=Ne):(St={},Mt=me,ct=Ne),wt.findTextInFiles(ne,St||{},Mt,Le.identifier,ct)},save:ne=>wt.save(ne),saveAs:ne=>wt.saveAs(ne),saveAll:ne=>wt.saveAll(ne),applyEdit(ne,me){return nn.applyWorkspaceEdit(ne,Le,me)},createFileSystemWatcher:(ne,me,Ne,ct)=>{let St;return typeof me=="boolean"?St={ignoreCreateEvents:!!me,ignoreChangeEvents:!!Ne,ignoreDeleteEvents:!!ct,correlate:!1}:me&&((0,Ye.$VG)(Le,"createFileSystemWatcher"),St={...me,correlate:!0}),Ge.createFileSystemWatcher(wt,Le,ne,St)},get textDocuments(){return Nt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw new D.$9("textDocuments")},openTextDocument(ne){let me;const Ne=ne;if(typeof ne=="string")me=Promise.resolve($.URI.file(ne));else if($.URI.isUri(ne))me=Promise.resolve(ne);else if(!Ne||typeof Ne=="object")me=Nt.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return me.then(ct=>(ct.scheme===A.Schemas.vscodeRemote&&!ct.authority&&Ot.report("workspace.openTextDocument",Le,"A URI of 'vscode-remote' scheme requires an authority."),Nt.ensureDocumentData(ct).then(St=>St.document)))},onDidOpenTextDocument:(ne,me,Ne)=>at(Nt.onDidAddDocument)(ne,me,Ne),onDidCloseTextDocument:(ne,me,Ne)=>at(Nt.onDidRemoveDocument)(ne,me,Ne),onDidChangeTextDocument:(ne,me,Ne)=>at(Nt.onDidChangeDocument)(ne,me,Ne),onDidSaveTextDocument:(ne,me,Ne)=>at(Nt.onDidSaveDocument)(ne,me,Ne),onWillSaveTextDocument:(ne,me,Ne)=>at(Ri.getOnWillSaveTextDocumentEvent(Le))(ne,me,Ne),get notebookDocuments(){return Rt.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,me){let Ne;if($.URI.isUri(ne))Ne=ne,await Rt.openNotebookDocument(ne);else if(typeof ne=="string")Ne=$.URI.revive(await Rt.createNotebookDocument({viewType:ne,content:me}));else throw new Error("Invalid arguments");return Rt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument(ne,me,Ne){return at(Ai.onDidSaveNotebookDocument)(ne,me,Ne)},onDidChangeNotebookDocument(ne,me,Ne){return at(Ai.onDidChangeNotebookDocument)(ne,me,Ne)},onWillSaveNotebookDocument(ne,me,Ne){return at(ui.getOnWillSaveNotebookDocumentEvent(Le))(ne,me,Ne)},get onDidOpenNotebookDocument(){return at(Rt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return at(Rt.onDidCloseNotebookDocument)},registerNotebookSerializer(ne,me,Ne,ct){return Rt.registerNotebookSerializer(Le,ne,me,Ne,(0,Ye.$UG)(Le,"notebookLiveShare")?ct:void 0)},onDidChangeConfiguration:(ne,me,Ne)=>at(Ui.onDidChangeConfiguration)(ne,me,Ne),getConfiguration(ne,me){return me=arguments.length===1?void 0:me,Ui.getConfiguration(ne,me,Le)},registerTextDocumentContentProvider(ne,me){return wi.registerTextDocumentContentProvider(ne,me)},registerTaskProvider:(ne,me)=>(Ot.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),Ht.registerTaskProvider(Le,ne,me)),registerFileSystemProvider(ne,me,Ne){return(0,T.$Rc)(xe.registerFileSystemProvider(Le,ne,me,Ne),ei.addFileSystemProvider(ne,me,Ne))},get fs(){return ei.value},registerFileSearchProvider:(ne,me)=>((0,Ye.$VG)(Le,"fileSearchProvider"),Bt.registerFileSearchProvider(ne,me)),registerTextSearchProvider:(ne,me)=>((0,Ye.$VG)(Le,"textSearchProvider"),Bt.registerTextSearchProvider(ne,me)),registerAITextSearchProvider:(ne,me)=>((0,Ye.$VG)(Le,"aiTextSearchProvider"),(0,Ye.$VG)(Le,"textSearchProvider"),Bt.registerAITextSearchProvider(ne,me)),registerRemoteAuthorityResolver:(ne,me)=>((0,Ye.$VG)(Le,"resolvers"),Wt.registerRemoteAuthorityResolver(ne,me)),registerResourceLabelFormatter:ne=>((0,Ye.$VG)(Le,"resolvers"),Wi.$registerResourceLabelFormatter(ne)),getRemoteExecServer:ne=>((0,Ye.$VG)(Le,"resolvers"),Wt.getRemoteExecServer(ne)),onDidCreateFiles:(ne,me,Ne)=>at(Ge.onDidCreateFile)(ne,me,Ne),onDidDeleteFiles:(ne,me,Ne)=>at(Ge.onDidDeleteFile)(ne,me,Ne),onDidRenameFiles:(ne,me,Ne)=>at(Ge.onDidRenameFile)(ne,me,Ne),onWillCreateFiles:(ne,me,Ne)=>at(Ge.getOnWillCreateFileEvent(Le))(ne,me,Ne),onWillDeleteFiles:(ne,me,Ne)=>at(Ge.getOnWillDeleteFileEvent(Le))(ne,me,Ne),onWillRenameFiles:(ne,me,Ne)=>at(Ge.getOnWillRenameFileEvent(Le))(ne,me,Ne),openTunnel:ne=>((0,Ye.$VG)(Le,"tunnels"),Ft.openTunnel(Le,ne).then(me=>{if(!me)throw new Error("cannot open tunnel");return me})),get tunnels(){return(0,Ye.$VG)(Le,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(ne,me,Ne)=>((0,Ye.$VG)(Le,"tunnels"),at(Ft.onDidChangeTunnels)(ne,me,Ne)),registerPortAttributesProvider:(ne,me)=>((0,Ye.$VG)(Le,"portsAttributes"),Ft.registerPortsAttributesProvider(ne,me)),registerTunnelProvider:(ne,me)=>((0,Ye.$VG)(Le,"tunnelFactory"),Ft.registerTunnelProvider(ne,me)),registerTimelineProvider:(ne,me)=>((0,Ye.$VG)(Le,"timeline"),bn.registerTimelineProvider(ne,me,Le.identifier,Et.converter)),get isTrusted(){return wt.trusted},requestWorkspaceTrust:ne=>((0,Ye.$VG)(Le,"workspaceTrust"),wt.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,me,Ne)=>at(wt.onDidGrantWorkspaceTrust)(ne,me,Ne),registerEditSessionIdentityProvider:(ne,me)=>((0,Ye.$VG)(Le,"editSessionIdentityProvider"),wt.registerEditSessionIdentityProvider(ne,me)),onWillCreateEditSessionIdentity:(ne,me,Ne)=>((0,Ye.$VG)(Le,"editSessionIdentityProvider"),at(wt.getOnWillCreateEditSessionIdentityEvent(Le))(ne,me,Ne)),registerCanonicalUriProvider:(ne,me)=>((0,Ye.$VG)(Le,"canonicalUriProvider"),wt.registerCanonicalUriProvider(ne,me)),getCanonicalUri:(ne,me,Ne)=>((0,Ye.$VG)(Le,"canonicalUriProvider"),wt.provideCanonicalUri(ne,me,Ne))},vi={get inputBox(){return Ot.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),It.getLastInputBox(Le)},createSourceControl(ne,me,Ne){return It.createSourceControl(Le,ne,me,Ne)}},ji={createCommentController(ne,me){return Ut.createCommentController(Le,ne,me)}},En={get activeDebugSession(){return Dt.activeDebugSession},get activeDebugConsole(){return Dt.activeDebugConsole},get breakpoints(){return Dt.breakpoints},get activeStackItem(){return Dt.activeStackItem},registerDebugVisualizationProvider(ne,me){return(0,Ye.$VG)(Le,"debugVisualization"),Dt.registerDebugVisualizationProvider(Le,ne,me)},registerDebugVisualizationTreeProvider(ne,me){return(0,Ye.$VG)(Le,"debugVisualization"),Dt.registerDebugVisualizationTree(Le,ne,me)},onDidStartDebugSession(ne,me,Ne){return at(Dt.onDidStartDebugSession)(ne,me,Ne)},onDidTerminateDebugSession(ne,me,Ne){return at(Dt.onDidTerminateDebugSession)(ne,me,Ne)},onDidChangeActiveDebugSession(ne,me,Ne){return at(Dt.onDidChangeActiveDebugSession)(ne,me,Ne)},onDidReceiveDebugSessionCustomEvent(ne,me,Ne){return at(Dt.onDidReceiveDebugSessionCustomEvent)(ne,me,Ne)},onDidChangeBreakpoints(ne,me,Ne){return at(Dt.onDidChangeBreakpoints)(ne,me,Ne)},onDidChangeActiveStackItem(ne,me,Ne){return at(Dt.onDidChangeActiveStackItem)(ne,me,Ne)},registerDebugConfigurationProvider(ne,me,Ne){return Dt.registerDebugConfigurationProvider(ne,me,Ne||hi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,me){return Dt.registerDebugAdapterDescriptorFactory(Le,ne,me)},registerDebugAdapterTrackerFactory(ne,me){return Dt.registerDebugAdapterTrackerFactory(ne,me)},startDebugging(ne,me,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?Dt.startDebugging(ne,me,{parentSession:Ne}):Dt.startDebugging(ne,me,Ne||{})},stopDebugging(ne){return Dt.stopDebugging(ne)},addBreakpoints(ne){return Dt.addBreakpoints(ne)},removeBreakpoints(ne){return Dt.removeBreakpoints(ne)},asDebugSourceUri(ne,me){return Dt.asDebugSourceUri(ne,me)}},ln={registerTaskProvider:(ne,me)=>Ht.registerTaskProvider(Le,ne,me),fetchTasks:ne=>Ht.fetchTasks(ne),executeTask:ne=>Ht.executeTask(Le,ne),get taskExecutions(){return Ht.taskExecutions},onDidStartTask:(ne,me,Ne)=>at(Ht.onDidStartTask)(ne,me,Ne),onDidEndTask:(ne,me,Ne)=>at(Ht.onDidEndTask)(ne,me,Ne),onDidStartTaskProcess:(ne,me,Ne)=>at(Ht.onDidStartTaskProcess)(ne,me,Ne),onDidEndTaskProcess:(ne,me,Ne)=>at(Ht.onDidEndTaskProcess)(ne,me,Ne)},Bi={createNotebookController(ne,me,Ne,ct,St){return pi.createNotebookController(Le,ne,me,Ne,ct,(0,Ye.$UG)(Le,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(ne,me)=>Rt.registerNotebookCellStatusBarItemProvider(Le,ne,me),createRendererMessaging(ne){return ki.createRendererMessaging(Le,ne)},createNotebookControllerDetectionTask(ne){return(0,Ye.$VG)(Le,"notebookKernelSource"),pi.createNotebookControllerDetectionTask(Le,ne)},registerKernelSourceActionProvider(ne,me){return(0,Ye.$VG)(Le,"notebookKernelSource"),pi.registerKernelSourceActionProvider(Le,ne,me)},onDidChangeNotebookCellExecutionState(ne,me,Ne){return(0,Ye.$VG)(Le,"notebookCellExecutionState"),at(pi.onDidChangeNotebookCellExecutionState)(ne,me,Ne)}},un={t(...ne){if(typeof ne[0]=="string"){const me=ne.shift(),Ne=!ne||typeof ne[0]!="object"?ne:ne[0];return gi.getMessage(Le.identifier.value,{message:me,args:Ne})}return gi.getMessage(Le.identifier.value,ne[0])},get bundle(){return gi.getBundle(Le.identifier.value)},get uri(){return gi.getBundleUri(Le.identifier.value)}},hn={_version:1,transferActiveChat(ne){return(0,Ye.$VG)(Le,"interactive"),Fi.transferActiveChat(ne)}},dn={getRelatedInformation(ne,me){return(0,Ye.$VG)(Le,"aiRelatedInformation"),Ki.getRelatedInformation(Le,ne,me)},registerRelatedInformationProvider(ne,me){return(0,Ye.$VG)(Le,"aiRelatedInformation"),Ki.registerRelatedInformationProvider(Le,ne,me)},registerEmbeddingVectorProvider(ne,me){return(0,Ye.$VG)(Le,"aiRelatedInformation"),Hi.registerEmbeddingVectorProvider(Le,ne,me)}},fn={_version:1,registerChatResponseProvider(ne,me,Ne){return(0,Ye.$VG)(Le,"chatProvider"),zt.registerLanguageModel(Le,ne,me,Ne)},registerChatVariableResolver(ne,me,Ne,ct,St,Mt,Ii,mn){return(0,Ye.$VG)(Le,"chatVariableResolver"),_i.registerVariableResolver(Le,ne,me,Ne,ct,St,Mt,Ii,mn?.id)},registerMappedEditsProvider(ne,me){return(0,Ye.$VG)(Le,"mappedEditsProvider"),ze.registerMappedEditsProvider(Le,ne,me)},createChatParticipant(ne,me){return Fi.createChatAgent(Le,ne,me)},createDynamicChatParticipant(ne,me,Ne){return(0,Ye.$VG)(Le,"chatParticipantPrivate"),Fi.createDynamicChatAgent(Le,ne,me,Ne)},attachContext(ne,me,Ne){return(0,Ye.$VG)(Le,"chatVariableResolver"),_i.attachContext(ne,me,Ne)}},Sn={selectChatModels:ne=>bt.quality==="stable"?(console.warn(`[${k.$Xm.toKey(Le.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),Promise.resolve([])):zt.selectLanguageModels(Le,ne??{}),onDidChangeChatModels:(ne,me,Ne)=>bt.quality==="stable"?(console.warn(`[${k.$Xm.toKey(Le.identifier)}] This API is disabled in '${bt.environment.appName}'-stable.`),I.Event.None(ne,me,Ne)):zt.onDidChangeProviders(ne,me,Ne),get embeddingModels(){return(0,Ye.$VG)(Le,"embeddings"),Ci.embeddingsModels},onDidChangeEmbeddingModels:(ne,me,Ne)=>((0,Ye.$VG)(Le,"embeddings"),Ci.onDidChange(ne,me,Ne)),registerEmbeddingsProvider(ne,me){return(0,Ye.$VG)(Le,"embeddings"),Ci.registerEmbeddingsProvider(Le,ne,me)},async computeEmbeddings(ne,me,Ne){return(0,Ye.$VG)(Le,"embeddings"),Ci.computeEmbeddings(ne,me,Ne)}},gn={registerSpeechProvider(ne,me){return(0,Ye.$VG)(Le,"speech"),en.registerProvider(Le.identifier,ne,me)}};return{version:bt.version,ai:dn,authentication:on,commands:vn,comments:ji,chat:fn,debug:En,env:Ti,extensions:cn,interactive:hn,l10n:un,languages:yn,lm:Sn,notebooks:Bi,scm:vi,speech:gn,tasks:ln,tests:an,window:Ji,workspace:Qi,Breakpoint:q.$yN,TerminalOutputAnchor:q.TerminalOutputAnchor,ChatResultFeedbackKind:q.ChatResultFeedbackKind,ChatVariableLevel:q.ChatVariableLevel,ChatCompletionItem:q.$tO,CallHierarchyIncomingCall:q.$WM,CallHierarchyItem:q.$VM,CallHierarchyOutgoingCall:q.$XM,CancellationError:D.$5,CancellationTokenSource:b.$se,CandidatePortSource:t.CandidatePortSource,CodeAction:q.$SM,CodeActionKind:q.$TM,CodeActionTriggerKind:q.CodeActionTriggerKind,CodeLens:q.$YM,Color:q.$_M,ColorInformation:q.$aN,ColorPresentation:q.$bN,ColorThemeKind:q.ColorThemeKind,CommentMode:q.CommentMode,CommentState:q.CommentState,CommentThreadCollapsibleState:q.CommentThreadCollapsibleState,CommentThreadState:q.CommentThreadState,CommentThreadApplicability:q.CommentThreadApplicability,CompletionItem:q.$6M,CompletionItemKind:q.CompletionItemKind,CompletionItemTag:q.CompletionItemTag,CompletionList:q.$7M,CompletionTriggerKind:q.CompletionTriggerKind,ConfigurationTarget:q.ConfigurationTarget,CustomExecution:q.$jN,DebugAdapterExecutable:q.$CN,DebugAdapterInlineImplementation:q.$FN,DebugAdapterNamedPipeServer:q.$EN,DebugAdapterServer:q.$DN,DebugConfigurationProviderTriggerKind:hi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:q.DebugConsoleMode,DebugVisualization:q.$VN,DecorationRangeBehavior:q.DecorationRangeBehavior,Diagnostic:q.$LM,DiagnosticRelatedInformation:q.$KM,DiagnosticSeverity:q.DiagnosticSeverity,DiagnosticTag:q.DiagnosticTag,Disposable:q.$xM,DocumentHighlight:q.$OM,DocumentHighlightKind:q.DocumentHighlightKind,MultiDocumentHighlight:q.$PM,DocumentLink:q.$$M,DocumentSymbol:q.$RM,EndOfLine:q.EndOfLine,EnvironmentVariableMutatorType:q.EnvironmentVariableMutatorType,EvaluatableExpression:q.$IN,InlineValueText:q.$JN,InlineValueVariableLookup:q.$KN,InlineValueEvaluatableExpression:q.$LN,InlineCompletionTriggerKind:q.InlineCompletionTriggerKind,EventEmitter:I.$he,ExtensionKind:q.ExtensionKind,ExtensionMode:q.ExtensionMode,ExternalUriOpenerPriority:q.ExternalUriOpenerPriority,FileChangeType:q.FileChangeType,FileDecoration:q.$XN,FileDecoration2:q.$XN,FileSystemError:q.$ON,FileType:h.FileType,FilePermission:h.FilePermission,FoldingRange:q.$PN,FoldingRangeKind:q.FoldingRangeKind,FunctionBreakpoint:q.$AN,InlineCompletionItem:q.$8M,InlineCompletionList:q.$9M,Hover:q.$MM,VerboseHover:q.$NM,HoverVerbosityAction:q.HoverVerbosityAction,IndentAction:y.IndentAction,Location:q.$JM,MarkdownString:q.$ZM,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:q.$1M,PortAutoForwardAction:q.PortAutoForwardAction,Position:q.$yM,ProcessExecution:q.$hN,ProgressLocation:q.ProgressLocation,QuickInputButtons:q.$WN,Range:q.$zM,RelativePattern:q.$wN,Selection:q.$AM,SelectionRange:q.$UM,SemanticTokens:q.$SN,SemanticTokensBuilder:q.$RN,SemanticTokensEdit:q.$TN,SemanticTokensEdits:q.$UN,SemanticTokensLegend:q.$QN,ShellExecution:q.$iN,ShellQuoting:q.ShellQuoting,SignatureHelp:q.$3M,SignatureHelpTriggerKind:q.SignatureHelpTriggerKind,SignatureInformation:q.$2M,SnippetString:q.$IM,SourceBreakpoint:q.$zN,StandardTokenType:q.StandardTokenType,StatusBarAlignment:q.StatusBarAlignment,SymbolInformation:q.$QM,SymbolKind:q.SymbolKind,SymbolTag:q.SymbolTag,Task:q.$kN,TaskGroup:q.$gN,TaskPanelKind:q.TaskPanelKind,TaskRevealKind:q.TaskRevealKind,TaskScope:q.TaskScope,TerminalLink:q.$cN,TerminalQuickFixTerminalCommand:q.$eN,TerminalQuickFixOpener:q.$dN,TerminalLocation:q.TerminalLocation,TerminalProfile:q.$fN,TerminalExitReason:q.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:q.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:q.TextDocumentSaveReason,TextEdit:q.$EM,SnippetTextEdit:q.$GM,TextEditorCursorStyle:a.TextEditorCursorStyle,TextEditorLineNumbersStyle:q.TextEditorLineNumbersStyle,TextEditorRevealType:q.TextEditorRevealType,TextEditorSelectionChangeKind:q.TextEditorSelectionChangeKind,SyntaxTokenType:q.SyntaxTokenType,TextDocumentChangeReason:q.TextDocumentChangeReason,ThemeColor:q.$vN,ThemeIcon:q.$uN,TreeItem:q.$lN,TreeItemCheckboxState:q.TreeItemCheckboxState,TreeItemCollapsibleState:q.TreeItemCollapsibleState,TypeHierarchyItem:q.$hO,UIKind:ii.UIKind,Uri:$.URI,ViewColumn:q.ViewColumn,WorkspaceEdit:q.$HM,DocumentPasteTriggerKind:q.DocumentPasteTriggerKind,DocumentDropEdit:q.$rN,DocumentDropOrPasteEditKind:q.$sN,DocumentPasteEdit:q.$tN,InlayHint:q.$5M,InlayHintLabelPart:q.$4M,InlayHintKind:q.InlayHintKind,RemoteAuthorityResolverError:q.$DM,ResolvedAuthority:q.$BM,ManagedResolvedAuthority:q.$CM,SourceControlInputBoxValidationType:q.SourceControlInputBoxValidationType,ExtensionRuntime:q.ExtensionRuntime,TimelineItem:q.$8N,NotebookRange:q.$ZN,NotebookCellKind:q.NotebookCellKind,NotebookCellExecutionState:q.NotebookCellExecutionState,NotebookCellData:q.$1N,NotebookData:q.$2N,NotebookRendererScript:q.$6N,NotebookCellStatusBarAlignment:q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:q.NotebookEditorRevealType,NotebookCellOutput:q.$4N,NotebookCellOutputItem:q.$3N,NotebookCellStatusBarItem:q.$5N,NotebookControllerAffinity:q.NotebookControllerAffinity,NotebookControllerAffinity2:q.NotebookControllerAffinity2,NotebookEdit:q.$FM,NotebookKernelSourceAction:q.$7N,NotebookVariablesRequestKind:q.NotebookVariablesRequestKind,PortAttributes:q.$0N,LinkedEditingRanges:q.$9N,TestResultState:q.TestResultState,TestRunRequest:q.$$N,TestMessage:q.$_N,TestTag:q.$aO,TestRunProfileKind:q.TestRunProfileKind,TextSearchCompleteMessageType:_t.TextSearchCompleteMessageType,DataTransfer:q.$qN,DataTransferItem:q.$mN,TestCoverageCount:q.$bO,FileCoverage:q.$dO,FileCoverage2:q.$dO,StatementCoverage:q.$eO,BranchCoverage:q.$fO,DeclarationCoverage:q.$gO,WorkspaceTrustState:q.WorkspaceTrustState,LanguageStatusSeverity:q.LanguageStatusSeverity,QuickPickItemKind:q.QuickPickItemKind,InputBoxValidationSeverity:q.InputBoxValidationSeverity,TabInputText:q.$iO,TabInputTextDiff:q.$jO,TabInputTextMerge:q.$kO,TabInputCustom:q.$lO,TabInputNotebook:q.$nO,TabInputNotebookDiff:q.$oO,TabInputWebview:q.$mO,TabInputTerminal:q.$pO,TabInputInteractiveWindow:q.$qO,TabInputChat:q.$rO,TabInputTextMultiDiff:q.$sO,TelemetryTrustedValue:c.$op,LogLevel:r.LogLevel,EditSessionIdentityMatch:f.EditSessionIdentityMatch,InteractiveSessionVoteDirection:q.InteractiveSessionVoteDirection,ChatCopyKind:q.ChatCopyKind,InteractiveEditorResponseFeedbackKind:q.InteractiveEditorResponseFeedbackKind,DebugStackFrame:q.$GN,DebugThread:q.$HN,RelatedInformationType:q.RelatedInformationType,SpeechToTextStatus:q.SpeechToTextStatus,TextToSpeechStatus:q.TextToSpeechStatus,PartialAcceptTriggerKind:q.PartialAcceptTriggerKind,KeywordRecognitionStatus:q.KeywordRecognitionStatus,ChatResponseMarkdownPart:q.$uO,ChatResponseFileTreePart:q.$yO,ChatResponseAnchorPart:q.$zO,ChatResponseProgressPart:q.$AO,ChatResponseProgressPart2:q.$BO,ChatResponseReferencePart:q.$EO,ChatResponseWarningPart:q.$CO,ChatResponseTextEditPart:q.$FO,ChatResponseMarkdownWithVulnerabilitiesPart:q.$vO,ChatResponseCommandButtonPart:q.$DO,ChatResponseDetectedParticipantPart:q.$wO,ChatResponseConfirmationPart:q.$xO,ChatRequestTurn:q.$GO,ChatResponseTurn:q.$HO,ChatLocation:q.ChatLocation,LanguageModelChatMessageRole:q.LanguageModelChatMessageRole,LanguageModelChatMessage:q.$IO,LanguageModelChatMessage2:q.$IO,LanguageModelChatSystemMessage:q.$JO,LanguageModelChatUserMessage:q.$KO,LanguageModelChatAssistantMessage:q.$LO,LanguageModelError:q.$MO,NewSymbolName:q.$NN,NewSymbolNameTag:q.NewSymbolNameTag,NewSymbolNameTriggerKind:q.NewSymbolNameTriggerKind,InlineEdit:q.$NO,InlineEditTriggerKind:q.InlineEditTriggerKind}}}}),define(Ce[318],Ie([1,0,60,126,44,120,45,39,71,57,129,131,132,89,93,85,119,68,51,88,66,70,257,12,130,86,87,91,95,124]),function(_,e,b,D,I,T,A,M,$,a,P,y,u,k,h,r,o,c,f,t,s,n,i,g,d,l,p,C,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,b.$Gs)(l.$Nnc,l.$Mnc,b.InstantiationType.Delayed),(0,b.$Gs)(g.$8j,i.$1oc,b.InstantiationType.Delayed),(0,b.$Gs)(r.$Smc,r.$Tmc,b.InstantiationType.Delayed),(0,b.$Gs)(M.$jP,M.$iP,b.InstantiationType.Eager),(0,b.$Gs)(C.$3mc,C.$4mc,b.InstantiationType.Eager),(0,b.$Gs)(S.$Hnc,S.$Inc,b.InstantiationType.Eager),(0,b.$Gs)(A.$fnc,A.$dnc,b.InstantiationType.Eager),(0,b.$Gs)(c.$hnc,c.$gnc,b.InstantiationType.Eager),(0,b.$Gs)(y.$Xnc,y.$2nc,b.InstantiationType.Eager),(0,b.$Gs)(T.$4nc,T.$3nc,b.InstantiationType.Eager),(0,b.$Gs)($.$$O,$.$0O,b.InstantiationType.Eager),(0,b.$Gs)(p.$Onc,p.$Pnc,b.InstantiationType.Eager),(0,b.$Gs)(f.$Wmc,f.$Vmc,b.InstantiationType.Eager),(0,b.$Gs)(D.$woc,D.$voc,b.InstantiationType.Delayed),(0,b.$Gs)(u.$hoc,u.$ioc,b.InstantiationType.Eager),(0,b.$Gs)(k.$Anc,k.$znc,b.InstantiationType.Eager),(0,b.$Gs)(P.$Joc,P.$Ioc,b.InstantiationType.Eager),(0,b.$Gs)(a.$Dnc,a.$Gnc,b.InstantiationType.Eager),(0,b.$Gs)(v.$Koc,v.$Loc,b.InstantiationType.Eager),(0,b.$Gs)(h.$wEb,h.$xEb,b.InstantiationType.Eager),(0,b.$Gs)(o.$Yoc,o.$Xoc,b.InstantiationType.Eager),(0,b.$Gs)(I.$cnc,I.$bnc,b.InstantiationType.Eager),(0,b.$Gs)(t.$Knc,t.$Jnc,b.InstantiationType.Eager),(0,b.$Gs)(s.$hP,s.$eP,b.InstantiationType.Eager),(0,b.$Gs)(n.$rnc,n.$snc,b.InstantiationType.Eager),(0,b.$Gs)(d.$Vnc,d.$Wnc,b.InstantiationType.Eager)}),define(Ce[319],Ie([1,0,317,46,2,314,7,11,264]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=void 0;class a extends T.$4oc{k(){}getModule(k,h){for(const r of this.b){const o=r(k);if(o){k=o;break}}if(this.a.has(k))return this.a.get(k).load(k,h,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class P extends D.$Rnc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance($.$_qc);const k=this.h.invokeFunction(b.$Zoc);this.r=this.h.createInstance(a,k,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(k){return k.browser}async xb(k,h,r){h=h.with({path:y(h.path,".js")});const o=k?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const c=I.URI.revive(await this.C.$asBrowserUri(h)),f=await fetch(c.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),f.status!==200)throw new Error(f.statusText);const t=await f.text(),s=`${h.toString(!0)}#vscode-extension`,n=`${t}
//# sourceURL=${s}`;let i;try{i=new Function("module","exports","require",n)}catch(p){throw console.error(o?`Loading code for extension ${o} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${h.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}k&&await this.w.initializeLocalizedMessages(k);const g={},d={exports:g},l=p=>{const C=this.r.getModule(p,h);if(C===void 0)throw new Error(`Cannot load module '${p}'`);return C};try{return r.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(d,g,l),d.exports!==g?d.exports:g}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),r.codeLoadingStop()}}async $setRemoteEnvironment(k){}async Bb(k=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const h=Date.now()+k;for(;Date.now()<h&&!("__jsDebugIsReady"in globalThis);)await(0,M.$Bh)(10)}}e.$arc=P;function y(u,k){return u.endsWith(k)?u:u+k}}),define(Ce[320],Ie([1,0,74,60,12,46,227,92,319]),function(_,e,b,D,I,T,A,M,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Gs)(I.$7j,new b.$xi(A.$3oc,[!0],!0)),(0,D.$Gs)(T.$Snc,$.$arc,D.InstantiationType.Eager),(0,D.$Gs)(M.$inc,M.$jnc,D.InstantiationType.Eager)}),define(Ce[328],Ie([1,0,23,4,84,315,266,20,64,16,2,318,320]),function(_,e,b,D,I,T,A,M,$,a,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=n;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const u=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function k(i){return/^(file|vscode-remote):/i.test(i)}const h=fetch.bind(self);function r(i){self.fetch=async function(g,d){return g instanceof Request||k(String(g))&&(g=(await i(P.URI.parse(String(g)))).toString(!0)),h(g,d)},self.XMLHttpRequest=class extends XMLHttpRequest{open(g,d,l,p,C){(async()=>(k(d.toString())&&(d=(await i(P.URI.parse(d.toString()))).toString(!0)),super.open(g,d,l??!0,p,C)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(g,d){if(/^file:/i.test(g.toString()))g=a.$Ug.uriToBrowserUri(P.URI.parse(g.toString())).toString(!0);else if(/^vscode-remote:/i.test(g.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const p=`(${function(E){function R(N){return typeof N=="string"||N instanceof URL?String(N).replace(/^file:\/\//i,"vscode-file://vscode-app"):N}const w=fetch.bind(self);self.fetch=function(N,B){return N instanceof Request?w(N,B):w(R(N),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(N,B,X,V,O){return super.open(N,R(B),X??!0,V,O)}};const m=importScripts.bind(self);self.importScripts=(...N)=>{m(...N.map(R))},m(E)}.toString()}('${g}'))`;d=d||{},d.name=`${name} -> ${d.name||M.$nc(g.toString())}`;const C=new Blob([p],{type:"application/javascript"}),S=URL.createObjectURL(C);return new i(S,d)}}else self.Worker=class extends A.$brc{constructor(i,g){super(u,i,{name:M.$nc(i.toString()),...g})}};const o=new class{constructor(){this.pid=void 0}exit(i){y()}};class c{constructor(){const g=new MessageChannel,d=new D.$he;let l=!1;u(g.port2,[g.port2]),g.port1.onmessage=p=>{const{data:C}=p;if(!(C instanceof ArrayBuffer)){console.warn("UNKNOWN data received",C);return}const S=b.$Je.wrap(new Uint8Array(C,0,C.byteLength));if((0,I.$7m)(S,I.MessageType.Terminate)){l=!0,t("received terminate message from renderer");return}d.fire(S)},this.protocol={onMessage:d.event,send:p=>{if(!l){const C=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);g.port1.postMessage(C,[C])}}}}}function f(i){return new Promise(g=>{const d=i.onMessage(l=>{d.dispose();const p=JSON.parse(l.toString());i.send((0,I.$6m)(I.MessageType.Initialized)),g({protocol:i,initData:p})});i.send((0,I.$6m)(I.MessageType.Ready))})}let t=i=>y();function s(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function n(){$.mark("code/extHost/willConnectToRenderer");const i=new c;return{onmessage(g){s(g)&&f(i.protocol).then(d=>{$.mark("code/extHost/didWaitForInitData");const l=new T.$6oc(d.protocol,d.initData,o,null,g.data);r(p=>l.asBrowserUri(p)),t=p=>l.terminate(p)})}}}})}).call(this);

//# sourceMappingURL=extensionHostWorker.js.map
